/*
  Task: Casino
  Solution by: Semyon Dyatlov
*/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define for if (0) ; else for

#define MAXK 26
#define MAXL 250
#define MAXN 250
#define MAXL2 250

int k, l, n;
char c[MAXK];
int x[MAXK], s[MAXL], L[MAXN], S[MAXN][MAXL2], C[MAXL+1], sum[MAXL+1];
char A[MAXL][MAXL], *B[MAXL][MAXL][MAXN];

int c2i(char C)
{
  return strchr(c,C)-c;
}

int max(int a, int b)
{
  return (a>b) ? a : b;
}

int main()
{
  freopen("casino.in","rt",stdin);
  freopen("casino.out","wt",stdout);

  static char buffer[1024];
  scanf("%d",&k);
  for (int i=0;i<k;i++)
  {
    scanf("%s%d",buffer,&x[i]);
    c[i] = buffer[0];
  }
  c[k] = 0;

  scanf("%s",buffer);
  l = strlen(buffer);
  sum[0] = 0;
  for (int i=0;i<l;i++)
  {
    s[i] = c2i(buffer[i]);
    sum[i+1] = sum[i]+x[s[i]];
  }

  scanf("%d",&n);
  for (int i=0;i<n;i++)
  {
    scanf("%s",buffer);
    L[i] = strlen(buffer);
    for (int j=0;j<L[i];j++)
      S[i][j] = c2i(buffer[j]);
    for (int p=0;p<l;p++)
      for (int q=p;q<l;q++) {
        B[p][q][i]=(char*) malloc(sizeof(char)*L[i]);
        memset(B[p][q][i],0,sizeof(char)*L[i]);
      }
  }

  memset(A,0,sizeof(A));
  for (int q=0;q<l;q++)
    for (int i=0;i+q<l;i++)
    {
      int j = i+q;
      for (int x=0;x<n;x++)
        for (int y=0;y<L[x];y++)
          if (s[j]==S[x][y])
          {
            if (!y)
              B[i][j][x][y] = i==j;
            else
              for (int k=i;k<j;k++)
                B[i][j][x][y] |= ((k==j-1)||A[k+1][j-1])&&B[i][k][x][y-1];
          }
      for (int x=0;x<n;x++)
        A[i][j] |= B[i][j][x][L[x]-1];
      for (int x=i;x<j;x++)
        A[i][j] |= A[i][x]&&A[x+1][j];
    }


  memset(C,0,sizeof(C));
  for (int i=0;i<l;i++)
  {
    C[i+1] = C[i];
    for (int j=0;j<=i;j++)
      if (A[j][i])
        C[i+1] = max(C[i+1],sum[i+1]-sum[j]+C[j]);
  }
  printf("%d\n",C[l]);

  return 0;
}
