{$I-,Q-,R-,S-,O+,H-}
{$I+,Q+,R+,S+,O-,H+}
{$apptype console}
{$M 10000000, 10000000}

uses SysUtils;

const
  cInFile = 'casino.in';
  cOutFile = 'casino.out';

  inf = maxlongint shr 1;
  eps = 1e-8;

  nmax = 250;  // length of sequence;
  lmax = 250; // total length of all strings;
  kmax = 250; // number of strings;

  vmax = lmax + 1;

type
  int = longint;
  real = extended;

  alph = array ['a'..'z'] of int;
  tbor = record
           par : int;
           ch : char;
           p : alph;
           t : boolean;
         end;  

var
  n, m : int;
  ans : int;

  cost : array ['a'..'z'] of int;
  sm : array [0..nmax] of int;

  s : string;

  k : int;
  b : array [0..vmax] of tbor;

  res : array [0..nmax, 0..nmax] of int; 
  d : array [0..nmax, 0..vmax] of boolean;

procedure OutData;
var
  i, j : int;
begin
  writeln(ans);
end;

procedure Solve;
var
  i, j : int;
  l, r, nx : int;
begin
  for i:= 1 to n do assert((s[i] in ['a'..'z']) and (cost[s[i]] > 0));
  sm[0]:= 0;
  for i:= 1 to n do sm[i]:= sm[i - 1] + cost[s[i]];
  fillchar(res, sizeof(res), 0);
  for l:= n downto 1 do
  begin
    fillchar(d, sizeof(d), 0);
    j:= b[1].p[s[l]];
    d[l, j]:= true;
    if b[j].t then d[l][1]:= true;
    for r:= l + 1 to n do
      for i:= 1 to k do
        if d[r - 1, i] then
          for nx:= r to n do
            if res[r, nx - 1] = sm[nx - 1] - sm[r - 1] then
            begin
              j:= b[i].p[s[nx]];
              d[nx, j]:= true;
              if b[j].t then d[nx, 1]:= true;
            end;
    for r:= l to n do
    begin
      res[l, r]:= 0;
      if d[r, 1] then
      begin
        res[l, r]:= sm[r] - sm[l - 1];
        continue;
      end;
      for i:= l to r - 1 do
        if res[l, r] < res[l, i]  + res[i + 1, r] then
          res[l, r]:= res[l, i]  + res[i + 1, r];
    end;
  end;
  ans:= res[1, n];
end;

procedure init;
begin
  fillchar(b, sizeof(b), 0);
  k:= 1;
end;

procedure ReadData;
var
  i, j, t, kb : int;
  ch : char;
  OL : int;
begin
  init;
  fillchar(cost, sizeof(cost), 255);
  readln(kb);
  assert((kb > 0) and (kb <= 26));
  for i:= 1 to kb do
  begin
    read(ch);
    assert(ch in ['a'..'z']);
    readln(t);
    assert((t >= 1) and (t <= nmax));
    cost[ch]:= t;
  end;
  readln(s);
  assert((length(s) > 0) and (length(s) <= nmax));
  readln(n);
  assert((n >= 1) and (n <= kmax));
  OL:= 0;
  for i:= 1 to n do
  begin
    t:= 1;
    while not seekeoln do
    begin
      read(ch);
      inc(OL);
      assert(ch in ['a'..'z']);
      if b[t].p[ch] = 0 then
      begin
        inc(k);
        b[k].par:= t;
        b[k].ch:= ch;
        b[k].t:= false;
        b[t].p[ch]:= k;
      end;
      t:= b[t].p[ch];
    end;
    b[t].t:= true;
    readln;
  end;
  assert(OL <= lmax);
  n:= length(s);
end;

begin
  assign(input,cinfile);
  assign(output,coutfile);
  reset(input);
  rewrite(output);
  ReadData;
  Solve;
  OutData;
  close(input);
  close(output);
end.
