{$R+,Q+,O-}
{$APPTYPE CONSOLE}
uses
  Math;
type
  int = integer;
  bool = boolean;

procedure imp();
begin
  close(output);
  rewrite(output, 'clocks.out');
  writeln('Impossible');
  halt;
end;

var
  a, b, k, aa, bb, u1, u2, u3, v1, v2, v3, t, tmp, k0, k1, q : int;
  ac, bc : char;
  f : bool;

label
  inside;

begin
  reset(input, 'clocks.in');
  rewrite(output, 'clocks.out');

  read(a, b, k);
  if (a > b) then
  begin
    tmp := a;
    a := b;
    b := tmp;
    ac := 'B';
    bc := 'A';
  end
  else
  begin
    ac := 'A';
    bc := 'B';
  end;

  aa := a;
  bb := b;
  write('Initially: ');
  while true do
  begin
    u1 := 1;
    u2 := 0;
    u3 := a;
    v1 := 0;
    v2 := 1;
    v3 := b;
    while (v3 <> 0) do
    begin
      q := u3 div v3;
      t := u1 - q * v1;
      u1 := v1;
      v1 := t;
      t := u2 - q * v2;
      u2 := v2;
      v2 := t;
      t := u3 - q * v3;
      u3 := v3;
      v3 := t;
    end;

    if (k mod u3 <> 0) then
      imp();

    u1 := u1 * (k div u3);
    u2 := u2 * (k div u3);

    assert((v1 <> 0) and (v2 <> 0));
    if (v1 < 0) then
    begin
      v1 := -v1;
      v2 := -v2;
    end;

    k0 := ceil(-u1 / v1);
    k1 := floor(-u2 / v2);
    if (k0 <= k1) then
    begin
      u1 := u1 + k0 * v1;
      u2 := u2 + k0 * v2;

      if b = bb then
      begin
        while u1 > 0 do
        begin
          writeln('flip ', ac);
          write('When ', ac, ' stops: ');
          dec(u1);
        end;
        while u2 > 0 do
        begin
          writeln('flip ', bc);
          write('When ', bc, ' stops: ');
          dec(u2);
        end;
        writeln('ready');
        exit;
      end;

      while (u1 > 1) do
      begin
        writeln('flip A and B');
        writeln('When ', ac, ' stops: flip A and B');
        write('When ', bc, ' stops: ');
        dec(u1, 2);
      end;

      f := true;
      if (u2 > 1) then
      begin
        writeln('flip ', bc);
        f := false;
        goto inside;
      end;

      while (u2 > 1) do
      begin
        writeln('flip A and B');
      inside:
        writeln('When ', ac, ' stops: flip A and B');
        write('When ', bc, ' stops: ');
        dec(u2, 2);
      end;

      if (u1 = 1) and (u2 = 1) then
        writeln('At the beginning wait aa');
      if (u1 = 1) and (u2 = 0) then
      begin
        if f then
          writeln('flip ', ac)
        else
          writeln('do nothing');
        write('When ', ac, ' stops: ');
      end;
      if (u1 = 0) and (u2 = 1) then
      begin
        if f then
          writeln('do nothing')
        else
          writeln('flip ', ac);
        write('When ', ac, ' stops: ');
      end;

      writeln('ready');
      exit;
    end;

    if (a = b) or (k < bb) or (bb mod aa = 0) then
      imp();

    dec(k, bb);

    q := bb;
    if (b < bb) then
    begin
      dec(q, b);
      writeln('flip ', bc);
      write('When ', ac, ' stops: ');
    end
    else
    begin
      writeln('flip A and B');
      dec(q, aa);
      write('When ', ac, ' stops: ');
    end;
    while q >= aa do
    begin
      writeln('flip ', ac);
      dec(q, aa);
      write('When ', ac, ' stops: ');
    end;
    assert(q > 0);
    writeln('flip ', ac);
    a := q;
    b := aa - q;
    write('When ', bc, ' stops: ');
  end;
end.

