{$R+,Q+,O+}
{$APPTYPE CONSOLE}
{A, B <= 100}

type
  int = longint;

function gcd(n, m: int): int;
var
  t: int;
begin
  while (m > 0) do
  begin
    t := m;
    m := n mod m;
    n := t;
  end;
  gcd := n;
end;

var
  w: array[-100..100, 0..10000] of boolean;
  p1, p2, m: array[-100..100, 0..10000] of int;

procedure solve(a, b, t: int);

var
  g: int;
  done: boolean;

procedure solvelinear;
var
  i: int;
begin
  g := 0;
  while ((t - g * a) mod b > 0) do
    inc(g);
  write('Initially: ');
  for i := 1 to g do
  begin
    writeln('flip A');
    write('When A stops: ');
  end;
  for i := 1 to (t - g * a) div b do
  begin
    writeln('flip B');
    write('When B stops: ');
  end;
  writeln('ready');
end;

procedure answer(x: int);

procedure ans(x, t: int);
begin
  if (t = 0) then
    exit;
  ans(p1[x, t], p2[x, t]);
  case m[x, t] and 3 of
    1: writeln('flip A');
    2: writeln('flip B');
    3: writeln('flip A and B');
    0: writeln('do nothing');
  end;
  if (m[x, t] and 4 > 0) then
    write('When B stops: ')
  else
    write('When A stops: ');
end;

begin
  write('Initially: ');
  ans(x, t);
  writeln('ready');
  done := true;
end;

procedure dfs(x, z: int);

procedure go(a1, b1, mask: int);
var
  min: int;
begin
  min := 0;
  if (a1 > 0) then
    min := a1;
  if (b1 > 0) and ((min = 0) or (b1 < min)) then
  begin
    min := b1;
    mask := mask or 4;
  end;
  if (a1 > 0) then
    dec(a1, min);
  if (b1 > 0) then
    dec(b1, min);
  dec(b1, a1);
  inc(min, z);
  if (min <= t) and not w[b1, min] then
  begin
    p1[b1, min] := x;
    p2[b1, min] := z;
    m[b1, min] := mask;
    dfs(b1, min);
  end;
end;

var
  a0, b0: int;

begin
  if done then
    exit;
  if (z = t) then
    answer(x);
  w[x, z] := true;
  a0 := 0;
  b0 := 0;
  if (x < 0) then
    a0 := -x
  else
    b0 := x;
  go(a - a0, b0, 1);
  go(a0, b - b0, 2);
  go(a - a0, b - b0, 3);
  go(a0, b0, 0);
end;

begin
  if (a > 100) or (b > 100) then
  begin
    writeln('I''m not smart enough for big tests.');
    exit;
  end;
  g := gcd(a, b);
  if (t mod g > 0) then
  begin
    writeln('Impossible');
    exit;
  end;
  a := a div g;
  b := b div g;
  t := t div g;
  if (t > a * b) then
  begin
    solvelinear;
    exit;
  end;
  for g := -a to b do
    fillchar(w[g, 0], t + 1, false);
  done := false;
  dfs(0, 0);
  if not done then
    writeln('Impossible');
end;

var
  a, b, t: int;

begin
  assign(input, 'clocks.in');
  assign(output, 'clocks.out');
  reset(input);
  rewrite(output);
  read(a, b, t);
  solve(a, b, t);
end.

