{$R+,Q+,O-}
{$MINSTACKSIZE $1000000}
{$APPTYPE CONSOLE}

const
  filename = 'clocks';

type 
  int = longint;

var
  a, b, t, x: int;
  ti, w, how: array[-500..500, 1..3] of int;
  len: int;
  ans: array[1..200000] of int;
  good: array[0..100000] of boolean;
  aa, bb: array[0..100000] of int;

procedure dfslin(t, ka, kb: int);
begin
  good[t] := true;
  aa[t] := ka;
  bb[t] := kb;
  if (t >= a) and not good[t - a] then
    dfslin(t - a, ka + 1, kb);
  if (t >= b) and not good[t - b] then
    dfslin(t - b, ka, kb + 1);
end;

procedure addedge(a1, b1, typ: int);
var
  min, temp: int;

begin
  if (a1 = 0) or (b1 = 0) then
    exit;
  temp := 0;
  if (b1 < a1) then
  begin
    min := b1;
    temp := 4;
  end
  else
    min := a1;
  dec(a1, min);
  dec(b1, min);
  ti[x, typ] := min;
  w[x, typ] := b1 - a1;
  how[x, typ] := typ or temp;
end;

procedure trav(xx, tt, hh, dep: int);
begin
  if (dep > 17) or (tt > t) then
    exit;    
  inc(len);
  ans[len] := hh;
  if good[tt] then
  begin
    write('Initially: ');
    for hh := 1 to aa[tt] do
    begin
      writeln('flip A');
      write('When A stops: ');
    end;
    for hh := 1 to bb[tt] do
    begin
      writeln('flip B');
      write('When B stops: ');
    end;
    for hh := 2 to len do
    begin
      case ans[hh] and 3 of
        1: writeln('flip A');
        2: writeln('flip B');
        3: writeln('flip A and B');
      end;
      if (ans[hh] >= 4) then
        write('When B stops: ')
      else
        write('When A stops: ');
    end;
    writeln('ready');
    halt;
  end;
  if (ti[xx, 3] > 0) then trav(w[xx, 3], tt + ti[xx, 3], how[xx, 3], dep + 1);
  if (ti[xx, 1] > 0) then trav(w[xx, 1], tt + ti[xx, 1], how[xx, 1], dep + 1);
  if (ti[xx, 2] > 0) then trav(w[xx, 2], tt + ti[xx, 2], how[xx, 2], dep + 1);
  dec(len);
end;

function gcd(n, m: int): int;
var
  t: int;
begin
  while (m > 0) do
  begin
    t := m;
    m := n mod m;
    n := t;
  end;
  gcd := n;
end;


var
  a0, b0: int;

begin
  assign(input, filename + '.in');
  assign(output, filename + '.out');
  reset(input);
  rewrite(output);

  read(a, b, t);
  if (t mod gcd(a, b) <> 0) then
  begin
    writeln('Impossible');
    halt;
  end;
  for x := -a to b do
  begin
    a0 := 0;
    b0 := 0;
    if (x > 0) then
      b0 := x
    else
      a0 := -x;
    addedge(a - a0, b0, 1);
    addedge(a0, b - b0, 2);
    addedge(a - a0, b - b0, 3);
  end;
  dfslin(t, 0, 0);

  len := 0;
  trav(0, 0, 0, 0);
  writeln('Impossible');

end.
