{$MINSTACKSIZE $00400000}
{$o+,q-,r-}
const
    max_n = 100000;
    max_c = 100000;

var
    i, n, q: longint;
    v, c, next: array [1..2 * max_n] of longint;
    col: array [1..max_c] of boolean;
    r: array [1..max_n] of longint;
    u, z: array [1..max_n] of boolean;
    ea, eb, ec: longint;
    cg: longint;

function dfs(i: longint): boolean;
var
    j: longint;
begin
    u[i] := true;

    j := r[i];
    while j <> 0 do begin
        if not u[v[j]] then begin
            if col[c[j]] then begin
                dfs := false;
                exit;
            end else begin
                col[c[j]] := true;
            end;
        end;
        j := next[j];
    end;
    j := r[i];
    while j <> 0 do begin
        col[c[j]] := false;
        j := next[j];
    end;

    j := r[i];
    while j <> 0 do begin
        if not u[v[j]] then begin
            if not dfs(v[j]) then begin
                dfs := false;
                exit;
            end;
        end;
        j := next[j];
    end;
    dfs := true;
end;

procedure add(ea, eb, ec: longint);
begin
    inc(q);
    v[q] := eb;
    c[q] := ec;
    next[q] := r[ea];
    r[ea] := q;
end;

begin
    assign(input, 'robot.in'); reset(input);
    assign(output, 'robot.out'); rewrite(output);

    fillchar(r, sizeof(r), 0);

    read(n);
    for i := 1 to n - 1 do begin
        read(ea, eb, ec);
        add(ea, eb, ec);
        add(eb, ea, ec);
    end;

    cg := 0;
    for i := 1 to n do begin
        fillchar(u, sizeof(u), 0);
        fillchar(col, sizeof(col), 0);
        z[i] := dfs(i);
        if z[i] then begin
            inc(cg);
        end;
    end;
    writeln(cg);
    for i := 1 to n do begin
        if z[i] then write(i, ' ');
    end;

    close(input);
    close(output);
end.