{
          

    :        
    :       
    :     
}

{$o-,r+,q+}
uses
    math, sysutils;
const
    inf = 1e10;
    eps = 1e-5;

function dist(x1, y1, x2, y2, xc, yc, r: extended): extended;
var
    a: extended;
begin
    if 
        (abs(sqr(x1 - xc) + sqr(y1 - yc) - r * r) < eps) and 
        (abs(sqr(x2 - xc) + sqr(y2 - yc) - r * r) < eps) 
    then begin
        a := arctan2(x1 - xc, y1 - yc) - arctan2(x2 - xc, y2 - yc);
        if a < -eps then a := -a;
        while a > pi + eps do a := 2 * pi - a;
        dist := a * r;
    end else begin
        dist := inf;
    end;
end;

var
    x1, y1, r1, x2, y2, r2: longint;
    px, py: array [1..4] of extended;
    a, b, c, d: extended;
    z: array [1..4, 1..4] of extended;
    cp: longint;
    i, j, k: longint;
begin
    assign(input, 'bike.in'); reset(input);
    assign(output, 'bike.out'); rewrite(output);

    read(x1, y1, r1, x2, y2, r2);

    cp := 2;
    read(px[1], py[1], px[2], py[2]);

    x2 := x2 - x1; y2 := y2 - y1;
    px[1] := px[1] - x1; py[1] := py[1] - y1;
    px[2] := px[2] - x1; py[2] := py[2] - y1;

    d := x2 * x2 + y2 * y2;
    if (sqr(r1 + r2) >= d) and (sqr(r1 - r2) <= d) then begin
        d := sqrt(d);
        a := x2 / d;
        b := y2 / d;
        c := (sqr(x2) + sqr(y2) - sqr(r2) + sqr(r1)) / d / 2;

        d := r1 * r1 - c * c;
        if d > 0 then begin
            d := sqrt(r1 * r1 - c * c);
        end else begin
            d := 0;
        end;
        cp := 4;
        px[3] := a * c + b * d; py[3] := b * c - a * d;
        px[4] := a * c - b * d; py[4] := b * c + a * d;
    end;

    for i := 1 to cp do begin
        for j := 1 to cp do begin
            z[i][j] := min(
                dist(px[i], py[i], px[j], py[j], 0, 0, r1),
                dist(px[i], py[i], px[j], py[j], x2, y2, r2)
            );
        end;
    end;

    for i := 1 to cp do begin
        for j := 1 to cp do begin
            for k := 1 to cp do begin
                if z[j][k] > z[j][i] + z[i][k] then begin
                    z[j][k] := z[j][i] + z[i][k];
                end;
            end;
        end;
    end;

    if z[1][2] < inf then begin
        writeln(z[1][2]:0:10);
    end else begin
        writeln(-1);
    end;

    close(input);
    close(output);
end.