{
          

    :     
    :       
    :     
}


{$APPTYPE CONSOLE}
{$O-,Q+,R+}
Uses Math, SysUtils;

const
  problem_id = 'calendar';

var
  dw : integer;  // day of week of 1.01
  l : boolean;   // leap?
  col : integer; // month-columns in the calendar
  i, j, k : integer;

type
  mtable = record
    d : array [1..7, 1..7] of integer; // rows, cols
    w : integer; // width, height = 7
  end;

// nd - number of days in the month
// fd - first day
procedure build_mtable(var a : mtable; nd : integer; fd : integer);
var r, c, i : integer;
begin
  fillchar(a, sizeof(a), 0);
  c := 1;
  r := fd - 1;
  for i := 1 to nd do
  begin
    inc(r);
    if r > 7 then
    begin
      r := 1;
      inc(c);
      assert(c <= 7);
    end;
    a.d[r][c] := i;
  end;
  a.w := c;
end;

function numdays(m : integer) : integer;
begin
  if odd(m + (m div 8)) then numdays := 31 else
  if m <> 2 then numdays := 30 else
  if l then numdays := 29 else
  numdays := 28;
end;

procedure w(x : integer);
begin
  assert((x >= 0) and (x <= 31));
  if x = 0 then write('  ') else
  begin
    if x > 9 then write(x div 10) else write(' ');
    write(x mod 10);
  end;
end;

procedure writeline(a : mtable; line : integer);
var i : integer;
begin
  assert((line >= 0) and (line <= 7));
  for i := 1 to a.w do
  begin
    if i > 1 then write(' ');
    if line = 0 then write('  ') else
      w(a.d[line][i]);
  end;
end;

var
  z : array [1..12, 1..12] of mtable;
  ww : array [1..12] of integer;
  x : integer;
begin
  reset(input, problem_id + '.in');
  rewrite(output, problem_id + '.out');
  read(dw, i, col);
  l := (i = 1);
  assert((1 <= dw) and (dw <= 7));
  assert((i = 0) or (i = 1));
  assert((col >= 1) and (12 mod col = 0));
  x := 1;
  for i := 1 to 12 div col do
    for j := 1 to col do
    begin
      build_mtable(z[i][j], numdays(x), dw);
      dw := (dw + numdays(x) - 1) mod 7 + 1;
      inc(x);
    end;
  for j := 1 to col do
  begin
    ww[j] := 0;
    for i := 1 to 12 div col do
      ww[j] := max(ww[j], z[i][j].w);
  end;
  for i := 1 to 12 div col do
    for j := 1 to col do
      z[i][j].w := ww[j];
  for i := 1 to 12 div col do
  begin
    for k := 1 - ord(i > 1) to 7 do
    begin
      for j := 1 to col do
      begin
        writeline(z[i][j], k);
        if j < col then write('   ');
      end;
      writeln;
    end;
  end;
end.