uses sysutils, math;

const
  maxn = 2000;
  maxm = 50000;

  inf = 1000000000;

var
  qq, i, j, n, m, ii, jj, kk: integer;
  d, hd: array[1..maxn] of integer;
  z: array[1..maxn] of boolean;
  nx, ds, c, nm: array[1..2 * maxm] of integer;
  our: array[1..maxm] of boolean;
  pi, pj, r, h, ph: array[1..maxn] of integer;
  min, money: integer;
  l, nh: integer;

  sl, by: array[1..maxm] of boolean;


procedure add(i, j, k, x: integer);
begin
  inc(l);
  nx[l] := hd[i];
  ds[l] := j;
  c[l] := k;
  nm[l] := x;
  hd[i] := l;
end;

procedure swap(i, j: integer);
var
  t: integer;
begin
  t := h[i];
  h[i] := h[j];
  h[j] := t;
  ph[h[i]] := i;
  ph[h[j]] := j;
end;

procedure siftup(i: integer);
var
  ii: integer;
begin
  while i > 1 do begin
    ii := i shr 1;
    if d[h[ii]] <= d[h[i]] then exit;
    swap(ii, i);
    i := ii;
  end;
end;

procedure siftdown(i: integer);
var
  ii: integer;
begin
  while i shl 1 <= nh do begin
    ii := i;
    if d[h[i shl 1]] < d[h[ii]] then ii := i shl 1;
    if (i shl 1 + 1 <= nh) and (d[h[i shl 1 + 1]] < d[h[ii]]) then ii := i shl 1 + 1;
    if ii = i then exit;
    swap(i, ii);
    i := ii;
  end;
end;

procedure insert(i: integer);
begin
  inc(nh);
  h[nh] := i;
  ph[i] := nh;
  siftup(nh);
end;

procedure delmin;
begin
  swap(1, nh);
  dec(nh);
  siftdown(1);
end;


procedure print(i: integer);
begin
  if i <> 1 then print(pi[i]);
  write(i, ' ');
end;

var
  dd: integer;

begin
  assign(input, 'campaign.in');
  reset(input);
  assign(output, 'campaign.out');
  rewrite(output);

  read(n, m);
  for i := 1 to n do read(r[i]);
  for i := 1 to m do begin
    read(ii, jj, qq, kk);
    if qq = 1 then begin
      money := money + kk;
    end;
    our[i] := qq = 1;
    add(ii, jj, kk + r[jj], i);
    add(jj, ii, kk + r[ii], i);
  end;

  d[1] := 0;
  for i := 2 to n do d[i] := inf;
  nh := 0;
  for i := 1 to n do insert(i);

  while nh > 0 do begin
    i := h[1];
    if d[i] = inf then break;
    delmin;
    j := hd[i];
    while j <> 0 do begin
      dd := d[i] + c[j];
      if d[ds[j]] > dd then begin
        d[ds[j]] := dd;
        pi[ds[j]] := i;
        pj[ds[j]] := nm[j];
        siftup(ph[ds[j]]);
      end;
      j := nx[j];
    end;
  end;

  if d[n] > money then begin
    writeln(-1);
    exit;
  end;

  for i := 1 to m do if our[i] then sl[i] := true;

  i := n;
  while i <> 1 do begin
    j := pj[i];
    if our[j] then sl[j] := false else by[j] := true;
    i := pi[i];
  end;


  j := 0;
  for i := 1 to m do if sl[i] then inc(j);
  write(j);
  for i := 1 to m do if sl[i] then write(' ', i);
  writeln;

  j := 0;
  for i := 1 to m do if by[i] then inc(j);
  write(j);
  for i := 1 to m do if by[i] then write(' ', i);
  writeln;

  print(n);
end.