{
          

    :      
    :       
     :     
    ,  ....
     ,   ...
       pay - get...
    +    ...
}

{$APPTYPE CONSOLE}
{$O-,Q+,R+}
Uses Math, SysUtils;

const
  problem_id = 'campaign';
  inf = 1000000000;
var n, m, i : integer;
    r : array [1..2000] of integer;
    a : array [1..2000, 1..2000] of integer;
    roads : array [1..2000, 1..2000] of integer;
    cash, pay : integer;
    mark : array [1..2000] of boolean;
    dist, from : array [1..2000] of integer;
    way : array [1..2000] of integer;
    waylen : integer;
procedure addedge(src, dst, own, cost, ednum : integer);
begin
  if own = 1 then inc(cash, cost);
  a[src][dst] := cost;
  a[dst][src] := cost;
  assert(roads[src][dst] = 0);
  assert(roads[dst][src] = 0);
  roads[src][dst] := ednum * (ord(own <> 1) * 2 - 1);
  roads[dst][src] := roads[src][dst];
end;
var j, x, y, p, q : integer;

procedure NoSolution;
begin
  writeln(-1);
  halt;
end;

begin
  reset(input, problem_id + '.in');
  rewrite(output, problem_id + '.out');
  assert(not seekeoln);
  read(n);
  assert(not seekeoln);
  read(m);
  assert(seekeoln);
  readln;
  assert((2 <= n) and (n <= 2000));
  assert((1 <= m) and (m <= 50000));
  for i := 1 to n do
  begin
    assert(not seekeoln);
    read(r[i]);
    assert(seekeoln);
    readln;
  end;
  assert(r[1] = 0);
  assert(r[n] = 0);
  for i := 1 to n do assert((0 <= r[i]) and (r[i] <= 10000));

  cash := 0;

  for i := 1 to n do for j := 1 to n do a[i][j] := inf;

  for i := 1 to m do
  begin
    assert(not seekeoln);
    read(x);
    assert(not seekeoln);
    read(y);
    assert(not seekeoln);
    read(p);
    assert(not seekeoln);
    read(j);
    assert(seekeoln);
    readln;
    assert((1 <= x) and (x <= n));
    assert((1 <= y) and (y <= n));
    assert((1 <= p) and (p <= n));
    assert(x <> y);
    assert((1 <= j) and (j <= 10000));
    addedge(x, y, p, j, i);
  end;
  assert(seekeof);
  //////////////////////
  /// now solving... ///
  //////////////////////

  for i := 1 to n do mark[i] := false;
  dist[1] := 0;
  for i := 2 to n do dist[i] := inf;
  while true do
  begin
    j := -1;
    for i := 1 to n do if (not mark[i]) and ((j = -1) or (dist[i] < dist[j])) then
      j := i;
    if j = -1 then NoSolution; // not connected
    mark[j] := true;
    if j = n then break;

    for i := 1 to n do
        if roads[j][i] < 0 then
        begin
          if dist[i] > dist[j] + r[j] then
          begin
            dist[i] := dist[j] + r[j];
            from[i] := j;
          end
        end else
        if dist[i] > dist[j] + r[j] + a[j][i] then
        begin
          dist[i] := dist[j] + r[j] + a[j][i];
          from[i] := j;
        end;
  end;

  waylen := 1;
  way[waylen] := n;
  while way[waylen] <> 1 do
  begin
    inc(waylen);
    way[waylen] := from[way[waylen - 1]];
  end;

  pay := 0;
  for i := 1 to waylen - 1 do pay := pay + a[way[i]][way[i+1]];
  for i := 2 to waylen - 1 do pay := pay + r[way[i]];
  if pay > cash then NoSolution;

  for i := 1 to waylen - 1 do
  begin
    p := way[i];
    q := way[i+1];
    if roads[p][q] < 0 then roads[p][q] := 0;
    if roads[q][p] < 0 then roads[q][p] := 0;
  end;

  // what we sell
  j := 0;
  for i := 1 to n do for q := i to n do if roads[i][q] < 0 then inc(j);
  write(j);
  for i := 1 to n do for q:= i to n do if roads[i][q] < 0 then write(' ', -roads[i][q]);
  writeln;

  // what we buy
  j := 0;
  for i := 1 to waylen - 1 do if roads[way[i]][way[i+1]] > 0 then inc(j);
  write(j);
  for i := 1 to waylen - 1 do if roads[way[i]][way[i+1]] > 0 then write(' ', roads[way[i]][way[i+1]]);
  writeln;

  // how we travel
  write(1);
  for i := waylen - 1 downto 1 do write(' ', way[i]);
  writeln;
end.
