/*
          

    :        
    :       
    :     
*/
#include <algorithm>
#include <stdio.h>
#include <string.h>

#define for(what) if (0) ; else for(what)

using namespace std;

int m, n, k;
int board[300][300];

struct Point
{
  int x;
  int y;

  bool operator<(const Point &a) const
  {
    return (board[x][y]<board[a.x][a.y]);
  }
};

Point p[90000];
int psize;

int main()
{
  freopen("chess.in","rt",stdin);
  freopen("chess.out","wt",stdout);

  scanf("%d%d%d",&m,&n,&k);
  for (int i=0;i<m;i++)
    for (int j=0;j<n;j++)
    {
      scanf("%d",&(board[i][j]));
      if (board[i][j])
      {
        p[psize].x = i;
        p[psize++].y = j;
      }
    }

  bool flag = (k+1==psize);
  stable_sort(p,p+psize);
  for (int i=1;i<psize;i++)
    flag &= ((p[i].x==p[i-1].x)||(p[i].y==p[i-1].y)||
      (p[i].x+p[i].y==p[i-1].x+p[i-1].y)||
      (p[i].x-p[i].y==p[i-1].x-p[i-1].y))
      &&(board[p[i-1].x][p[i-1].y]<board[p[i].x][p[i].y]);
  if (!flag)
  {
    printf("Wrong Board\n");
    return 0;
  }

  for (int i=0;i<psize;i++)
    board[p[i].x][p[i].y] = i+1;
  for (int i=0;i<m;i++)
  {
    for (int j=0;j<n;j++)
      printf("%d ",board[i][j]);
    printf("\n");
  }

  return 0;
}