{
          

    :      
    :       
    :     
}

{$APPTYPE CONSOLE}
{$O-,Q+,R+}
Uses Math, SysUtils;

const
  problem_id = 'farm';
  msgver = 'Vertical';
  msghor = 'Horizontal';
  msgimp = 'Impossible';

type rect = record
  x1, y1, x2, y2 : integer;
end;

procedure cc(x : integer);
begin
  assert((x >= 0) and (x <= 1000 * 1000 * 1000));
end;

procedure rr(var r : rect);
begin
  with r do
  begin
    read(x1, y1, x2, y2);
    assert((x1 < x2) and (y1 < y2));
    cc(x1); cc(y1); cc(x2); cc(y2);
  end;
end;

var rs : array [1..4] of rect;

procedure tryV(x : integer);
var i, j : integer;
begin
  for i := 1 to 4 do if (rs[i].x1 < x) and (rs[i].x2 > x) then exit;
  j := 0;
  for i := 1 to 4 do if rs[i].x1 >= x then inc(j);
  if j <> 2 then exit;
  writeln(msgver);
  writeln(x);
  halt;
end;

procedure tryH(y : integer);
var i, j : integer;
begin
  for i := 1 to 4 do if (rs[i].y1 < y) and (rs[i].y2 > y) then exit;
  j := 0;
  for i := 1 to 4 do if rs[i].y1 >= y then inc(j);
  if j <> 2 then exit;
  writeln(msghor);
  writeln(y);
  halt;
end;

var
  i : integer;

begin
  reset(input, problem_id + '.in');
  rewrite(output, problem_id + '.out');
  for i := 1 to 4 do rr(rs[i]);
  for i := 1 to 4 do with rs[i] do
  begin
    tryV(x1);
    tryV(x2);
    tryH(y1);
    tryH(y2);
  end;
  writeln(msgimp);
end.
