{
          

    :        
    :       
    :     
}

{$APPTYPE CONSOLE}
{$O-,Q+,R+}
Uses Math, SysUtils;

const
  problem_id = 'lifts';
  maxl = 100;
  min_floor = -100;
  max_floor = 100;

var
  l, u, s, d : array [1..maxl] of integer;
  n : integer; // # of elevators
  i : integer;

function lpos(ln : integer; t : integer) : integer;
var i, x : integer;
begin
  assert((1 <= ln) and (ln <= n));
  t := t mod (2 * (u[ln] - l[ln]));
  x := s[ln] + d[ln] * t;
  for i := 1 to 2 do
  begin
    if x > u[ln] then x := u[ln] - (x - u[ln]);
    if x < l[ln] then x := l[ln] + (l[ln] - x);
  end;
  lpos := x;
end;

function gcd(x, y : integer) : integer;
begin
  if y = 0 then gcd := x else gcd := gcd(y, x mod y);
end;

function lcm(x, y : integer) : integer;
begin
  lcm := (x div gcd(x, y)) * y;
end;

procedure NoSolution;
begin
  writeln(-1);
  halt;
end;
var time, cur : integer;
label next;
begin
  if ParamCount = 0 then reset(input, problem_id + '.in') else 
	reset(input, ParamStr(1));
  if ParamCount <= 1 then rewrite(output, problem_id + '.out') else
	rewrite(output, ParamStr(2));
  read(n);
  assert((1 <= n) and (n <= 100));
  assert(seekeoln);
  readln;
  for i := 1 to n do
  begin
    read(l[i], u[i], s[i], d[i]);
    assert((min_floor <= l[i]) and (l[i] < u[i]) and (u[i] <= max_floor));
    assert((l[i] <= s[i]) and (s[i] <= u[i]));
    assert(((d[i] = 1) and (s[i] < u[i])) or ((d[i] = -1) and (s[i] > l[i])));
  end;
  assert(seekeof);
  if (l[1] > 0) or (u[1] < 0) then NoSolution;
  if (l[n] > 0) or (u[n] < 0) then NoSolution;
  for i := 1 to n do
  begin
    l[i] := l[i] * 2;
    u[i] := u[i] * 2;
    s[i] := s[i] * 2;
  end;

  time := 2;

  while lpos(1, time) <> 0 do inc(time);
  cur := 1;
  inc(time, 4);
  while cur < n do
  begin
    for i := 1 to 5 * lcm(u[cur] - l[cur], u[cur+1] - l[cur+1]) + 7 do
    begin
      if lpos(cur, time) = lpos(cur+1, time) then break;
      inc(time);
    end;
    if lpos(cur, time) = lpos(cur+1, time) then
    begin
      inc(cur);
      inc(time, 4);
    end else NoSolution;
  end;
  while lpos(n, time) <> 0 do inc(time);
  writeln((time + 2) div 2);
end.
