{
   .  
   襭: ᥩ ८ࠦ᪨

  : O(S),  S - ⢮ ﭨ, S = N^2 * N^2 -  N - ࠧ ᪨
}
{$apptype console}
{$q+,r+,o+}
uses
  math, sysutils;

const
  maxn = 8;
  maxq = maxn * maxn * maxn * maxn * 2;
  maxr = maxq;
  gox : array[1..8] of integer = ( 1, 1, 2, 2,-1,-1,-2,-2 );
  goy : array[1..8] of integer = ( 2,-2, 1,-1, 2,-2, 1,-1 );

type
  tposition = array[1..2] of integer;
  tturn = record
    c: char;
    p: tposition;
  end;
  tqueue = object
    di, dj: array[1..maxq] of tposition;
    head, tail, size: integer;

    procedure init;
    procedure add( i, j: tposition );
    procedure get( var i, j: tposition );
  end;

procedure tqueue.init;
begin
  head := 1;
  tail := 1;
  size := 0;
end;

procedure tqueue.add( i, j: tposition );
begin
  di[tail] := i;
  dj[tail] := j;

  inc( size );
  inc( tail );
  if ( tail > maxq ) then
    tail := 1;
end;

procedure tqueue.get( var i, j: tposition );
begin
  i := di[head];
  j := dj[head];

  dec( size );
  inc( head );
  if ( head > maxq ) then
    head := 1;
end;

var
  d: array[1..maxn, 1..maxn, 1..maxn, 1..maxn] of integer;
  prev: array[1..maxn, 1..maxn, 1..maxn, 1..maxn] of tturn;
  idx: array[char] of integer;
//  inf: integer;

  ch: char;
  ckb, ckw, nk,
  kb, kw, fkb, fkw: tposition;
  q: tqueue;
  i: integer;

  res: array[1..maxr] of tturn;
  rc: integer;

function readpos: tposition;
var
  ch1, ch2: char;
  res: tposition;
begin
  ch1 := #0;
  ch2 := #0;
  if ( not seekeof( input ) ) then read( ch1 );
  if ( not seekeof( input ) ) then read( ch2 );
  res[1] := idx[ch1];
  res[2] := idx[ch2];
  readpos := res;
end;

function valid( x, y: tposition ): boolean;
begin
  valid :=  ( x[1] >= 1 ) and ( x[1] <= maxn ) and
            ( x[2] >= 1 ) and ( x[2] <= maxn ) and
            ( y[1] >= 1 ) and ( y[1] <= maxn ) and
            ( y[2] >= 1 ) and ( y[2] <= maxn ) and
            ( not ( ( x[1] = y[1] ) and ( x[2] = y[2] ) ) );
end;

begin
  assign( input, 'knights.in' ); reset( input );
  assign( output, 'knights.out' ); rewrite( output );

  for ch := 'a' to 'h' do
    idx[ch] := ord( ch ) - ord( 'a' ) + 1;
  for ch := '1' to '8' do
    idx[ch] := ord( ch ) - ord( '1' ) + 1;

  fillchar( d, sizeof( d ), 63 );
//  inf := d[1, 1, 1, 1];

  kw := readpos;
  kb := readpos;
  fkw := readpos;
  fkb := readpos;

  d[kw[1], kw[2], kb[1], kb[2]] := 0;
  q.init;
  q.add( kw, kb );
  while q.size > 0 do begin
    q.get( ckw, ckb );
    for i := 1 to 8 do begin
      nk[1] := ckw[1] + gox[i];
      nk[2] := ckw[2] + goy[i];
      if ( not valid( nk, ckb ) ) then
        continue;
      if ( d[nk[1], nk[2], ckb[1], ckb[2]] > d[ckw[1], ckw[2], ckb[1], ckb[2]] + 1 ) then begin
        d[nk[1], nk[2], ckb[1], ckb[2]] := d[ckw[1], ckw[2], ckb[1], ckb[2]] + 1;
        prev[nk[1], nk[2], ckb[1], ckb[2]].c := 'W';
        prev[nk[1], nk[2], ckb[1], ckb[2]].p := ckw;
        q.add( nk, ckb );
      end;
    end;
    for i := 1 to 8 do begin
      nk[1] := ckb[1] + gox[i];
      nk[2] := ckb[2] + goy[i];
      if ( not valid( ckw, nk ) ) then
        continue;
      if ( d[ckw[1], ckw[2], nk[1], nk[2]] > d[ckw[1], ckw[2], ckb[1], ckb[2]] + 1 ) then begin
        d[ckw[1], ckw[2], nk[1], nk[2]] := d[ckw[1], ckw[2], ckb[1], ckb[2]] + 1;
        prev[ckw[1], ckw[2], nk[1], nk[2]].c := 'B';
        prev[ckw[1], ckw[2], nk[1], nk[2]].p := ckb;
        q.add( ckw, nk );
      end;
    end;
  end;

  writeln( d[fkw[1], fkw[2], fkb[1], fkb[2]] );
  rc := 0;
  ckw := fkw; ckb := fkb;
  while true do begin
    if ( ckw[1] = kw[1] ) and ( ckw[2] = kw[2] ) and ( ckb[1] = kb[1] ) and ( ckb[2] = kb[2] ) then
      break;

    inc( rc );
    res[rc].c := prev[ckw[1], ckw[2], ckb[1], ckb[2]].c;

    case prev[ckw[1], ckw[2], ckb[1], ckb[2]].c of
      'W': begin
             res[rc].p := ckw;
             ckw := prev[ckw[1], ckw[2], ckb[1], ckb[2]].p;
           end;
      'B': begin
             res[rc].p := ckb;
             ckb := prev[ckw[1], ckw[2], ckb[1], ckb[2]].p;
           end;
    end;
  end;

  for i := rc downto 1 do begin
    write( res[i].c, ' ' );
    write( chr( res[i].p[1] + ord( 'a' ) - 1 ) );
    write( chr( res[i].p[2] + ord( '1' ) - 1 ) );
    writeln;
  end;

  close( input ); close( output );
end.