#include <stdio.h>
#include <stdlib.h>

int next[1 << 6][1 << 3], size[1 << 6];

void try( int i, int x, int y )
{
  if (x >= 0 && x < 8 && y >= 0 && y < 8)
    next[i][size[i]++] = x << 3 | y;
}

int gc( void )
{
  char x;
  int y;
  if (scanf(" %c%d", &x, &y) == 2)
    return (x - 'a') << 3 | (y - 1);
  else
    exit(0);
}

int gp( void )
{
  int x = gc();
  return x << 6 | gc();
}

int mark[1 << 12], dist[1 << 12], q[1 << 12], prev[1 << 12];

int main( void )
{
  int k = 0, i;
  freopen("knights.in", "r", stdin);
  freopen("knights.out", "w", stdout);
  for (i = 0; i < 1 << 6; i++)
  {
    int x = i >> 3, y = i & 7;
    size[i] = 0;
    try(i, x + 1, y + 2);
    try(i, x + 1, y - 2);
    try(i, x - 1, y + 2);
    try(i, x - 1, y - 2);
    try(i, x + 2, y + 1);
    try(i, x + 2, y - 1);
    try(i, x - 2, y + 1);
    try(i, x - 2, y - 1);
  }
  while (1)
  {
    int u = gp(), v = gp(), f = 0, r = 1;
    ++k;
    mark[v] = k;
    dist[v] = 0;
    q[f] = v;
    while (f < r)
    {
      int x = q[f++];
      int a = x >> 6, b = x & 63;
      if (x == u)
        break;
      for (i = 0; i < size[a]; i++)
      {
        int c = next[a][i];
        if (c != b)
        {
          int z = c << 6 | b;
          if (mark[z] != k)
          {
            mark[z] = k;
            dist[z] = dist[x] + 1;
            prev[z] = x;
            q[r] = z;
            r++;
          }
        }
      }
      for (i = 0; i < size[b]; i++)
      {
        int c = next[b][i];
        if (c != a)
        {
          int z = a << 6 | c;
          if (mark[z] != k)
          {
            mark[z] = k;
            dist[z] = dist[x] + 1;
            prev[z] = x;
            q[r] = z;
            r++;
          }
        }
      }
    }
    printf("%d\n", dist[u]);
    while (u != v)
    {
      int w = prev[u];
      if ((w ^ u) >> 6)
      {
        putchar('W');
        w >>= 6;
      }
      else
      {
        putchar('B');
        w &= 63;
      }
      putchar(' ');
      putchar("abcdefgh"[w >> 3]);
      putchar("12345678"[w & 7]);
      putchar('\n');
      u = prev[u];
    }
  }
  return 0;
}
