{$O-,Q+,R+}
{ $O+,Q-,R-}
{$MINSTACKSIZE $00004000}
{$APPTYPE CONSOLE}
uses
    math, sysutils;
type
    int = longint;
const
    finname = 'knights';
    maxn = 16;
    dx: array[1 .. 8] of int = (1, 1, -1, -1, 2, 2, -2, -2);
    dy: array[1 .. 8] of int = (2, -2, 2, -2, 1, -1, 1, -1);
var
    d, p: array[1 .. maxn, 1 .. maxn, 1 .. maxn, 1 .. maxn] of int;
procedure printpath(x1, y1, x2, y2: int);
var
    u: int;
begin
    u := p[x1, y1, x2, y2];
    if (u = 0) then begin
        exit;
    end;
    if (u > 8) then begin
        dec(u, 8);
        printpath(x1, y1, x2 - dx[u], y2 - dy[u]);
        writeln('B ', chr(x2 + ord('a') - 1), y2);
    end
    else begin
        printpath(x1 - dx[u], y1 - dy[u], x2, y2);
        writeln('W ', chr(x1 + ord('a') - 1), y1);
    end;
end;
function getintlet: int;
var
    ch: char;
begin
    repeat
        read(ch);
    until (ch >= 'a') and (ch <= 'z');
    result := ord(ch) - ord('a') + 1;
end;
var
    b: array[-2 .. maxn + 2, -2 .. maxn + 2] of boolean;
    qx1, qy1, qx2, qy2: array[0 .. maxn * maxn * maxn * maxn] of int;
    x1, y1, x2, y2: int;
    x1n, y1n, x2n, y2n: int;
    x1e, y1e, x2e, y2e: int;
    n, m, i, l, h, j: int;
begin
    reset(input, finname + '.in');
    rewrite(output, finname + '.out');

//    read(n, m);
    n := 8;
    m := 8;
    fillchar(d, sizeof(d), $ff);
    fillchar(b, sizeof(b), false);
    for l := 1 to n do
        for h := 1 to m do
            b[l, h] := true;
    x1 := getintlet;
    read(y1);
    x2 := getintlet;
    read(y2);
    x1e := getintlet;
    read(y1e);
    x2e := getintlet;
    read(y2e);


    l := 0;
    h := 1;
    qx1[0] := x1;
    qy1[0] := y1;
    qx2[0] := x2;
    qy2[0] := y2;
    d[x1, y1, x2, y2] := 0;

    repeat
        x1 := qx1[l];
        x2 := qx2[l];
        y1 := qy1[l];
        y2 := qy2[l];
        inc(l);
        b[x2, y2] := false;
        for i := 1 to 8 do begin
            x1n := x1 + dx[i];
            x2n := x2{ + dx[j]};
            y1n := y1 + dy[i];
            y2n := y2{ + dy[j]};
            if (b[x1n, y1n] {and b[x2n, y2n]} and (d[x1n, y1n, x2n, y2n] = -1)) then begin
                qx1[h] := x1n;
                qx2[h] := x2n;
                qy1[h] := y1n;
                qy2[h] := y2n;
                inc(h);
                d[x1n, y1n, x2n, y2n] := d[x1, y1, x2, y2] + 1;
                p[x1n, y1n, x2n, y2n] := i;
            end;
        end;
        b[x2, y2] := true;

        b[x1, y1] := false;
        for j := 1 to 8 do begin
            x1n := x1{ + dx[i]};
            x2n := x2 + dx[j];
            y1n := y1{ + dy[i]};
            y2n := y2 + dy[j];
            if ({b[x1n, y1n] and }b[x2n, y2n] and (d[x1n, y1n, x2n, y2n] = -1)) then begin
                qx1[h] := x1n;
                qx2[h] := x2n;
                qy1[h] := y1n;
                qy2[h] := y2n;
                inc(h);
                d[x1n, y1n, x2n, y2n] := d[x1, y1, x2, y2] + 1;
                p[x1n, y1n, x2n, y2n] := j + 8;
            end;
        end;
        b[x1, y1] := true;
        if (d[x1e, y1e, x2e, y2e] > -1) then
            break;
    until l = h;

    if (d[x1e, y1e, x2e, y2e] > -1) then begin
        writeln(d[x1e, y1e, x2e, y2e]);
        printpath(x1e, y1e, x2e, y2e);
    end else
        write(-1);

    close(input);
    close(output);
end.