{$o-,q+,r+}
{$apptype console}
uses
	math, sysutils;

type
	int = longint;
const
	inf = $77777777;
	eps = 1e-10;
	finname = 'mines';
    maxn = 100;
    md = 8;
    dx: array[1 .. 8] of int = (1, -1,  1, -1,  1, -1,  0,  0);
    dy: array[1 .. 8] of int = (0,  0,  1,  1, -1, -1,  1, -1);
procedure quitf;
begin
    writeln('No solution');
    halt(0);
end;
var
	m, n, i, j, k: int;
    ch: char;
    a: array[0 .. maxn + 1, 0 .. maxn + 1] of int;
begin
	assign(input, finname + '.in');
	reset(input);
	assign(output, finname + '.out');
	rewrite(output);

    read(m, n);
    for i := 1 to m do
        for j := 1 to n do begin
            if seekeof then
                break;
            read(ch);
            if (ch = '1') then
                a[i, j] := -1
            else
                a[i, j] := 0;
        end;
    for i := 0 to m + 1 do begin
        a[i, 0] := 8;
        a[i, n + 1] := 8;
    end;
    for i := 0 to n + 1 do begin
        a[0, i] := 8;
        a[m + 1, i] := 8;
    end;

    for i := 1 to m do
        for j := 1 to n do begin
            if (a[i, j] <> -1) then
                continue;
            for k := 1 to md do
                if (a[i + dx[k], j + dy[k]] = 0) then begin
                    a[i, j] := 1;
                    break;
                end;
        end;
    for i := 1 to m do
        for j := 1 to n do begin
            if (a[i, j] <> 1) then
                continue;
            a[i, j] := 0;
            for k := 1 to md do
                if (a[i + dx[k], j + dy[k]] = -1) then
                    inc(a[i, j]);
            if (a[i, j] = 0) then
                quitf;
        end;

    for i := 1 to m do begin
        for j := 1 to n do begin
            if (a[i, j] = 0) then
                write('.')
            else
                if (a[i, j] = -1) then
                    write('*')
                else
                    write(a[i, j]);
        end;
        writeln;
    end;

	close(input);
	close(output);
end.