{VII Kirov Olympiad, XII Spb olympiad
Problem Mines
Solution by Victor Matyukhin}

const nmax=100;
      NoSolution='No solution';

var a,b:array[1..nmax,1..nmax] of byte;
    n,m:integer;
    i,j:integer;

procedure quit(s:string);
  begin
  writeln(s);
  close(input);
  close(output);
  halt(239);
  end;

function test(x,y:integer):boolean;
  begin
  test:=false;
  if (x<1) or (x>m) or (y<1) or (y>n) then exit;
  if a[x,y]=1 then exit;
  test:=true;
  exit;
  end;


function check(x,y:integer):boolean;
  begin
  check:=false;
  if a[x,y]=0 then exit;
  if test(x-1,y) then exit;
  if test(x-1,y-1) then exit;
  if test(x,y-1) then exit;
  if test(x+1,y-1) then exit;
  if test(x+1,y) then exit;
  if test(x+1,y+1) then exit;
  if test(x,y+1) then exit;
  if test(x-1,y+1) then exit;
  check:=true;
  end;

function tc(x,y:integer):integer;
  begin
  tc:=0;
  if (x<1) or (x>m) or (y<1) or (y>n) then exit;
  if b[x,y]=10 then tc:=1;
  end;



procedure scet(x,y:integer);
  begin
  b[x,y]:=0;
  b[x,y]:=b[x,y]+tc(x-1,y);
  b[x,y]:=b[x,y]+tc(x-1,y-1);
  b[x,y]:=b[x,y]+tc(x,y-1);
  b[x,y]:=b[x,y]+tc(x+1,y-1);
  b[x,y]:=b[x,y]+tc(x+1,y);
  b[x,y]:=b[x,y]+tc(x+1,y+1);
  b[x,y]:=b[x,y]+tc(x,y+1);
  b[x,y]:=b[x,y]+tc(x-1,y+1);
  end;


procedure solve;
  var i,j:integer;
  begin
  fillchar(b,sizeof(b),0);
  for i:=1 to m do
    for j:=1 to n do
      if check(i,j) then b[i,j]:=10;

  for i:=1 to m do
    for j:=1 to n do
      if b[i,j]<>10 then scet(i,j);

  end;

procedure done;
  var i,j:integer;
  begin
  for i:=1 to m do
    for j:=1 to n do begin
      if ((b[i,j]=0) and (a[i,j]=1)) then begin
        writeln(NoSolution);
        close(output);
        halt;
        end;
      if ((b[i,j]<>0) and (a[i,j]=0)) then begin
        writeln('Botva in jury solution');
        close(output);
        halt;
        end;
      end;

  for i:=1 to m do begin
    for j:=1 to n do
      case b[i,j] of
      1..9:write(chr(b[i,j]+ord('0')));
      0:write('.');
      10: write('*');
      end;
    writeln;
    end;
  close(output);
  end;






begin
assign(input,'mines.in');
reset(input);
assign(output,'mines.out');
rewrite(output);
read(m);
if seekeoln then quit('N not found in first line');
read(n);
if (n<1) or (m<1) or (n>nmax) or (m>nmax) then quit('Wrong N or M');
if not seekeoln then quit('End of first line expected');
for i:=1 to m do begin
  for j:=1 to n do begin
    read(a[i,j]);
    if (a[i,j]<>0) and (a[i,j]<>1) then quit('Botva in the map: 0 or 1 expected');
    if (j<n) and seekeoln then quit('Unexpected eoln');
    end;
  if not seekeoln then quit('Eoln expected');
  end;
if not seekeof then quit('EOF expected');

solve;
done;
end.


