{$o-,q+,r+}

uses
  math, sysutils;

var
  pi, pj: array[0..1000, 0..1000] of integer;
  z: array[0..1000, 0..1000] of boolean;
  qi, qj: array[1..1100000] of integer;
  q1, q2: integer;
  n, i, j, ii, jj, iii, jjj, k: integer;

const
  inf = 1000000000;

procedure print(i, j: integer);
begin
  if (i=0) and (j=0) then exit;
  print(pi[i, j], pj[i, j]);
  write(j - pj[i, j]);
end;

begin
  reset(input, 'number.in');
  rewrite(output, 'number.out');
  read(n);
  for i := 0 to n-1 do
    for j := 0 to n do begin
      z[i, j] := false;
    end;
  z[0, 0] := true;

  q1 := 0;
  q2 := 1;
  qi[1] := 0;
  qj[1] := 0;

  while q1 < q2 do begin
    inc(q1);
    i := qi[q1];
    j := qj[q1];
    ii := (i * 10) mod n;
    for k := 0 to 9 do begin
      iii := ii + k;
      if iii >= n then iii := iii - n;
      jjj := j + k;
      if jjj > n then break;
      if not z[iii, jjj] then begin
        z[iii, jjj] := true;
        inc(q2);
        qi[q2] := iii;
        qj[q2] := jjj;
        pi[iii, jjj] := i;
        pj[iii, jjj] := j;
      end;
    end;
  end;
  assert(z[0, n]);
  print(0, n);
end.