{$D-,L-,I-,Q-,R-,S-}
Program virtual_alx;
const
  inpfile='virtual.in';
  outfile='virtual.out';
  nm=105;
var
  a,s : array [0..nm,0..nm,0..nm] of Int64;
  x,y,z,x1,y1,z1 : LongInt;
  osn,ans : Int64;  
{}
Procedure Inp;
var
  i,j,k : LongInt;
begin
  assign(input,inpfile);
  reset(input);
  read(x,y,z,x1,y1,z1,osn);
  inc(osn);
  for k:=1 to z do
    for j:=1 to y do
      for i:=1 to x do read(a[i,j,k]);
end;
{}
Procedure Out(ok : Boolean);
begin
  assign(output,outfile);
  rewrite(output);
  if ok then writeln(ans)
        else writeln(-1);
  close(output);
  halt;
end;
{}
Procedure Init;
begin
  fillchar(a,sizeof(a),0);
  fillchar(s,sizeof(s),0);
end;
{}
Function Sv(i,j,k : LongInt) : Int64;
begin
  if i>x then i:=x;
  if j>y then j:=y;
  if k>z then k:=z;
  if (i<1) or (j<1) or (k<1) then Sv:=0
                             else Sv:=s[i,j,k];
end;
{}
Procedure Solve;
var
  i,j,k : LongInt;
  i1,j1,k1 : LongInt;
  bak : Int64;
begin
  ans:=0;
  for i:=1 to x-x1+1 do
    for j:=1 to y-y1+1 do
      for k:=1 to z-z1+1 do begin
        i1:=i+x1-1;
        j1:=j+y1-1;
        k1:=k+z1-1;

        bak:=Sv(i1-1,j1,k1)+Sv(i1,j1-1,k1)+Sv(i1,j1,k1-1)
            -Sv(i1-1,j1-1,k1)-Sv(i1,j1-1,k1-1)-Sv(i1-1,j1,k1-1)
            +Sv(i1-1,j1-1,k1-1)-
            (Sv(i-1,j1,k1)+Sv(i1,j-1,k1)+Sv(i1,j1,k-1)
            -Sv(i-1,j-1,k1)-Sv(i1,j-1,k-1)-Sv(i-1,j1,k-1)+Sv(i-1,j-1,k-1));
        bak:=(200*osn-bak-a[i,j,k]) mod osn;

        s[i1,j1,k1]:=
             (Sv(i1-1,j1,k1)+Sv(i1,j1-1,k1)+Sv(i1,j1,k1-1)
            -Sv(i1-1,j1-1,k1)-Sv(i1,j1-1,k1-1)-Sv(i1-1,j1,k1-1)
            +Sv(i1-1,j1-1,k1-1)+bak) mod osn;
        inc(ans,bak);
      end;

  for i:=1 to x do
    for j:=1 to y do
      for k:=1 to z do begin
        i1:=i+x1-1;
        j1:=j+y1-1;
        k1:=k+z1-1;

        bak:=(Sv(i1,j1,k1)
            -Sv(i-1,j1,k1)-Sv(i1,j-1,k1)-Sv(i1,j1,k-1)
            +Sv(i-1,j-1,k1)+Sv(i1,j-1,k-1)+Sv(i-1,j1,k-1)-
            Sv(i-1,j-1,k-1)+a[i,j,k]) mod osn;
        if bak <> 0 then begin
          Out(false);
        end;
      end;
end;
{}
Begin
  Init;
  Inp;
  Solve;
  Out(true);
End.
