{$APPTYPE CONSOLE}
{$A+,B-,D+,E+,F-,G-,I+,L+,N+,O+,P-,Q+,R+,S+,T-,V+,X+,Y+}

uses SysUtils;

const
  cInFile = 'virtual.in';
  cOutFile = 'virtual.out';

  nmax = 101;

type
  int = longint;
  real = extended;

var
  k : int;
  z,y,x,z1,y1,x1 : int;

  ans : int64;

  a, c : array [1..nmax,1..nmax,1..nmax] of int;

procedure OutData;
var
  i, j, g : int;
begin
  for i:= 1 to x do
    for j:= 1 to y do
      for g:= 1 to z do
        if c[i,j,g] <> 0 then
        begin
          writeln('-1');
          exit;
        end;
{  while true do;}
  writeln(ans);
  writeln;
end;

procedure Solve;
var
  i, j, g : int;
begin
  fillchar(a,sizeof(a),0);
  ans:= 0;
  for i:= 1 to x-x1+1 do
    for j:= 1 to y-y1+1 do
      for g:= 1 to z-z1+1 do
      begin
        a[i,j+1,g]:= (a[i,j+1,g] + a[i,j,g]) mod k;
        a[i,j,g+1]:= (a[i,j,g+1] + a[i,j,g]) mod k;
        a[i+1,j,g]:= (a[i+1,j,g] + a[i,j,g]) mod k;
        a[i,j+1,g+1]:= (a[i,j+1,g+1] + k - a[i,j,g]) mod k;
        a[i+1,j,g+1]:= (a[i+1,j,g+1] + k - a[i,j,g]) mod k;
        a[i+1,j+1,g]:= (a[i+1,j+1,g] + k - a[i,j,g]) mod k;
        a[i+1,j+1,g+1]:= (a[i+1,j+1,g+1] + a[i,j,g]) mod k;
        c[i,j,g]:= (c[i,j,g] + a[i,j,g]) mod k;
        a[i,j,g]:= 0;

        a[i,j,g]:= (k - c[i,j,g]) mod k;
        c[i,j,g]:= 0;
        inc(ans,a[i,j,g]);
        a[i,j+y1,g]:= (a[i,j+y1,g] + k - a[i,j,g]) mod k;
        a[i,j,g+z1]:= (a[i,j,g+z1] + k - a[i,j,g]) mod k;
        a[i,j+y1,g+z1]:= (a[i,j+y1,g+z1] + a[i,j,g]) mod k;
        a[i+x1,j,g]:= (a[i+x1,j,g] + k - a[i,j,g]) mod k;
        a[i+x1,j+y1,g]:= (a[i+x1,j+y1,g] + a[i,j,g]) mod k;
        a[i+x1,j,g+z1]:= (a[i+x1,j,g+z1] + a[i,j,g]) mod k;
        a[i+x1,j+y1,g+z1]:= (a[i+x1,j+y1,g+z1] + k - a[i,j,g]) mod k;

        a[i,j+1,g]:= (a[i,j+1,g] + a[i,j,g]) mod k;
        a[i,j,g+1]:= (a[i,j,g+1] + a[i,j,g]) mod k;
        a[i+1,j,g]:= (a[i+1,j,g] + a[i,j,g]) mod k;
        a[i,j+1,g+1]:= (a[i,j+1,g+1] + k - a[i,j,g]) mod k;
        a[i+1,j,g+1]:= (a[i+1,j,g+1] + k - a[i,j,g]) mod k;
        a[i+1,j+1,g]:= (a[i+1,j+1,g] + k - a[i,j,g]) mod k;
        a[i+1,j+1,g+1]:= (a[i+1,j+1,g+1] + a[i,j,g]) mod k;
        a[i,j,g]:= 0;
      end;
  for i:= 1 to x do
    for j:= 1 to y do
      for g:= 1 to z do
      begin
        a[i,j+1,g]:= (a[i,j+1,g] + a[i,j,g]) mod k;
        a[i,j,g+1]:= (a[i,j,g+1] + a[i,j,g]) mod k;
        a[i+1,j,g]:= (a[i+1,j,g] + a[i,j,g]) mod k;
        a[i,j+1,g+1]:= (a[i,j+1,g+1] + k - a[i,j,g]) mod k;
        a[i+1,j,g+1]:= (a[i+1,j,g+1] + k - a[i,j,g]) mod k;
        a[i+1,j+1,g]:= (a[i+1,j+1,g] + k - a[i,j,g]) mod k;
        a[i+1,j+1,g+1]:= (a[i+1,j+1,g+1] + a[i,j,g]) mod k;
        c[i,j,g]:= (c[i,j,g] + a[i,j,g]) mod k;
        a[i,j,g]:= 0;
      end;
end;

procedure ReadData;
var
  i, j, g : int;
begin
  read(z,y,x,z1,y1,x1,k);
  assert((z >= 1) and (z <= 100));
  assert((y >= 1) and (y <= 100));
  assert((x >= 1) and (x <= 100));
  assert((z1 >= 1) and (z1 <= 100));
  assert((y1 >= 1) and (y1 <= 100));
  assert((x1 >= 1) and (x1 <= 100));
  assert((k >= 1) and (k <= 1000000000));
  inc(k);
  for i:= 1 to x do
    for j:= 1 to y do
      for g:= 1 to z do
      begin
        read(c[i,j,g]);
        assert((c[i, j, g] >= 0) and (c[i, j, g] <= k)); 
      end;
end;

begin
  assign(input,cinfile);
  assign(output,coutfile);
  reset(input);
  rewrite(output);
  ReadData;
  Solve;
  OutData;
  close(input);
  close(output);
end.