{$O-,Q+,R+}
const MaxN=30;
      MaxB=19;

type order=record
       s, d, q, x, l:integer;
     end;

var o:array [1..MaxN] of order;
    tmp:order;
    c, b, n:integer;

{there are five types of condition variables available for sorting
 before running greed solution
  1. starting station
  2. destination
  3. quantity
  4. profit
  5. number
  each of them may be inverted (+5 added in this case)
}
const Conds=5;
type carr=array [1..Conds] of integer;


function superless (var cond:carr; const o1, o2:order):boolean;
var i:integer;
    l, e:boolean;
begin
  l:=false; e:=false;
  for i:=1 to Conds do begin
    case cond[i] of  
      1:begin l:=o1.s<o2.s; e:=o1.s=o2.s end;
      2:begin l:=o1.d<o2.d; e:=o1.d=o2.d end;
      3:begin l:=o1.q<o2.q; e:=o1.q=o2.q end;
      4:begin l:=o1.x<o2.x; e:=o1.x=o2.x end;
      5:begin l:=o1.l<o2.l; e:=o1.l=o2.l end;
      6:begin l:=o1.s>o2.s; e:=o1.s=o2.s end;
      7:begin l:=o1.d>o2.d; e:=o1.d=o2.d end;
      8:begin l:=o1.q>o2.q; e:=o1.q=o2.q end;
      9:begin l:=o1.x>o2.x; e:=o1.x=o2.x end;
      10:begin l:=o1.l>o2.l; e:=o1.l=o2.l end;
      11:begin l:=o1.s<o2.s; e:=o1.s=o2.s end;
      12:begin l:=o1.d<o2.d; e:=o1.d=o2.d end;
      13:begin l:=o1.q<o2.q; e:=o1.q=o2.q end;
      14:begin l:=o1.x<o2.x; e:=o1.x=o2.x end;
      15:begin l:=o1.l<o2.l; e:=o1.l=o2.l end;
      else runerror (239);
    end;
    if l then begin superless:=true; exit end else
    if not e then begin superless:=false; exit end;
  end;
  superless:=false;
end;

var max:integer;
    f, fm:array [1..MaxN] of boolean;

procedure greed;
var p:array [0..MaxB-1] of integer;
    i, j, cur:integer;
    found:boolean;
begin
  fillchar (p, sizeof (p), 0);
  fillchar (f, sizeof (f), 0);
  cur:=0;
  for i:=1 to n do with o[i] do begin
    found:=true;
    for j:=s to d-1 do
      if p[j]+q>c then begin found:=false; break end;
    if found then begin
      f[l]:=true;
      inc (cur, x);
      for j:=s to d-1 do inc (p[j], q)
    end;
  end;
  if cur>max then begin
    max:=cur; fm:=f
  end;
end;

var cond:carr;
    i, j, k:integer;

begin
  reset (input, 'trains.in');
  rewrite (output, 'trains.out');
  read (c, b, n);
  for i:=1 to n do with o[i] do begin
    read (s, d, q); x:=(d-s)*q; l:=i;
  end;
  max:=0;
  for i:=1 to Conds do cond[i]:=i;
  repeat
    for i:=n downto 1 do
      for j:=1 to i-1 do
        if superless (cond, o[j+1], o[j]) then 
          begin tmp:=o[j]; o[j]:=o[j+1]; o[j+1]:=tmp end;
    greed;
    k:=0;
    for i:=Conds downto 1 do if cond[i]<>2*Conds+i then begin k:=i; break end;
    if k=0 then break;
    inc (cond[k]);
    for i:=k+1 to Conds do cond[i]:=cond[i-1]+1
  until false;
  writeln (max);
  for i:=1 to n do if fm[i] then write (i, ' ');
end.