{$A8,B-,C+,D+,E-,F-,G+,J-,K-,L+,M-,N+,P+,T-,U-,V+,W-,X+,Y+,Z1}
{$Q+,R+,S+,O-,H+,I+}
{$MINSTACKSIZE $00004000}
{$MAXSTACKSIZE $01100000}
{$IMAGEBASE $00400000}
{$APPTYPE console}

uses SysUtils;

const
  cinfile = 'tree.in';
  coutfile = 'tree.out';

  inf = maxlongint shr 1;
  eps = 1e-8;

  nmax = 250;

type
  int = longint;
  real = extended;

var
  ans, vans : int;
  n, m, k : int;

  t, no : array [1..nmax, 0..nmax] of int;

  u : array [1..nmax] of boolean;
  p : array [1..nmax] of int;

  s : array [1..nmax, 0..nmax] of int;
  e : array [0..nmax, 0..nmax] of int;

procedure outit(v, k : int);
var
  i, j, y : int;
  dl : int;
  x, x1 : int;

  e : array [0..nmax, 0..nmax] of int;
  pr : array [0..nmax, 0..nmax] of record
    x, y : int
  end;
begin
  if k = 0 then
  begin
    write(no[v, p[v]], ' ');
    exit;
  end;
  if k = 1 then
  begin
    for i:= 1 to t[v, 0] do
      if t[v, i] <> p[v] then write(no[v, t[v, i]], ' ');
    exit;
  end;
  fillchar(e, sizeof(e), 1);
  fillchar(pr, sizeof(pr), 1);
  e[0, 0]:= 0;
  dl:= 1;
  for i:= 1 to t[v, 0] do
  begin
    if p[v] = t[v, i] then
    begin
      dl:= 2;
      continue;
    end;
    for j:= 0 to k do
    begin
      for y:= 0 to k - j do
        if e[i, y + j] > e[i - dl, j] + s[t[v, i], y] then
        begin
          e[i, y + j]:= e[i - dl, j] + s[t[v, i], y];
          pr[i, y + j].x:= i - dl;
          pr[i, y + j].y:= y;
        end;
    end;
    dl:= 1;
  end;
  dl:= t[v, 0];
  for i:= 1 to t[v, 0] do
    if t[v, i] = p[v] then dec(dl);
  x:= 0;
  y:= 0;
  for i:= 1 to t[v, 0] do
  begin
    if t[v, i] = p[v] then continue;
    dec(dl);
    j:= k - 1;
    if s[v, j + 1] = e[i, j] + dl then
    begin
      x:= i;
      y:= j;
    end;
  end;
  for i:= x + 1 to t[v, 0] do
    if t[v, i] <> p[v] then write(no[v, t[v, i]], ' ');
  while x <> 0 do
  begin
    outit(t[v, x], pr[x, y].y);
    x1:= pr[x, y].x;
    dec(y, pr[x, y].y);
    x:= x1;
  end;
  s[v, 0]:= 1;
  s[v, 1]:= 0;
  for i:= 1 to t[v, 0] do
    if t[v, i] <> p[v] then inc(s[v, 1]);
end;

procedure outdata;
var
  i, j : int;
begin
  writeln(ans);
  if p[vans] <> 0 then write(no[vans, p[vans]], ' ');
  outit(vans, k);
end;

procedure go(v : int);
var
  i, j, y : int;
  dl : int;
begin
  u[v]:= true;
  for i:= 1 to t[v, 0] do
    if p[v] <> t[v, i] then
    begin
      assert(not u[t[v, i]]);
      p[t[v, i]]:= v;
      go(t[v, i]);
    end;
  fillchar(e, sizeof(e), 1);
  e[0, 0]:= 0;
  dl:= 1;
  for i:= 1 to t[v, 0] do
  begin
    if p[v] = t[v, i] then
    begin
      dl:= 2;
      continue;
    end;
    for j:= 0 to k do
    begin
      for y:= 0 to k - j do
        if e[i, y + j] > e[i - dl, j] + s[t[v, i], y] then
          e[i, y + j]:= e[i - dl, j] + s[t[v, i], y];
//      if e[i, j] > e[i - dl, j] + 1 then
//        e[i, j]:= e[i - dl, j] + 1;
    end;
    dl:= 1;
  end;
  dl:= t[v, 0];
  for i:= 1 to t[v, 0] do
    if t[v, i] = p[v] then dec(dl);
  for i:= 1 to t[v, 0] do
  begin
    if t[v, i] = p[v] then continue;
    dec(dl);
    for j:= 1 to k - 1 do
      if s[v, j + 1] > e[i, j] + dl then
        s[v, j + 1]:= e[i, j] + dl;
  end;
  s[v, 0]:= 1;
  s[v, 1]:= 0;
  for i:= 1 to t[v, 0] do
    if t[v, i] <> p[v] then inc(s[v, 1]);
end;

procedure solve;
var
  i, j : int;
begin
  fillchar(p, sizeof(p), 0);
  fillchar(u, sizeof(u), 0);
  fillchar(s, sizeof(s), 1);
  go(1);
  for i:= 1 to n do assert(u[i]);
  ans:= inf;
  vans:= 0;
  for i:= 1 to n do
    if ans >= s[i, k] + ord(p[i] <> 0) then
    begin
      ans:= s[i, k] + ord(p[i] <> 0);
      vans:= i;
    end;
end;

procedure readdata;
var
  i : int;
  x, y : int;
begin
  read(n, k);
  assert((k >= 1) and (n >= k) and (n <= 250));
  fillchar(t, sizeof(t), 0);
  for i:= 1 to n - 1 do
  begin
    read(x, y);
    assert((x >= 1) and (y >= 1) and (x <= n) and (y <= n));
    inc(t[x, 0]);
    t[x, t[x, 0]]:= y;
    no[x, y]:= i;
    inc(t[y, 0]);
    t[y, t[y, 0]]:= x;
    no[y, x]:= i;
  end;
end;

begin
  reset(input, cinfile);
  rewrite(output, coutfile);
  readdata;
  solve;
  outdata;
  close(input);
  close(output);
end.
