{$O-,Q+,R+}
uses SysUtils;

const MaxN=100;
      MaxK=100;
      MaxM=100;
      MaxL=1000000;

var n, l, k, m, min:integer;
    a:array [0..MaxN] of integer;
    d, dm:array [0..MaxM, 0..MaxN] of integer;
    c, cm:array [0..MaxM] of integer;
    h, hm:array [0..MaxM] of integer;
    hb, hbm:integer;


function len (i, j:integer):integer;
begin
  Result:=abs (a[j]-a[i]); if Result>l shr 1 then Result:=l-Result;
  assert ((Result>=0) and (Result<=L shr 1));
end;


procedure recnode (x, t:integer);
var i, j, z:integer;
begin
  if t>=min then exit;
  if x>n then begin
//    writeln ('!');
    min:=t;
    hbm:=hb;
    for i:=1 to hb do begin
      cm[i]:=c[i];
      hm[i]:=h[i];
      for j:=0 to c[i] do
        dm[i, j]:=d[i, j];
    end;
    exit;
  end;
  for z:=1 to hb do begin
    if (z<>0) and (c[z]<k) then begin
      inc (c[z]);
      d[z, c[z]]:=x;
      recnode (x+1, t+len (h[z], x));
      dec (c[z]);
    end;
  end;
end;


procedure rechub (x, t:integer);
var i, j:integer;
begin
//  writeln ('H', x, ' ', t);
  if x*(k-1)+1>=n then begin
    hb:=x-1;
    recnode (1, t);
  end;
  if (x>m) or (t>=min) then exit;
  for j:=0 to n do begin
    h[x]:=j;
    for i:=x-1 downto 0 do
      if c[i]<k then begin
        inc (c[i]);
        d[i, c[i]]:=-x;
        d[x, 0]:=-i;
        c[x]:=0;
//        writeln (x, '<-', j);
        rechub (x+1, t+len (h[i], j));
//        writeln (x, '->', j);
        dec (c[i]);
      end;
  end;
end;


var i, j, last:integer;

begin
  reset (input, 'network.in');
  rewrite (output, 'network.out');
  assert (not seekeoln); read (n); assert ((n>=1) and (n<=MaxN));
  assert (not seekeoln); read (l); assert ((l>=1) and (l<=MaxL));
  assert (not seekeoln); read (k); assert ((k>=1) and (k<=MaxK));
  assert (not seekeoln); read (m); assert ((m>=1) and (m<=MaxM));
  assert (seekeoln); readln;
  last:=0;
  for i:=1 to n do begin
    assert (not seekeoln); read (a[i]); assert ((a[i]>last) and (a[i]<l));
  end;
  assert (seekeof);
  c[0]:=k-1;
  min:=maxlongint;
  rechub (1, 0);
  //writeln ('*', min);
  if min=maxlongint then begin writeln ('-1'); halt end;
  writeln (hbm);
  for i:=1 to hbm do begin
    write (a[hm[i]]);
    for j:=0 to cm[i] do write (' ', dm[i, j]);
    writeln;
  end;
end.