{$A+,B-,D+,E+,F-,G+,I+,L+,N-,O-,P-,Q-,R-,S+,T-,V-,X+,Y+}
{$M 65520,0,655360}

program Fil2;

type
  TField=array [0..46,0..42] of Integer;

var
  D:TField;
  Steps:array [1..3] of TField;
  Was:array [0..46,0..42] of Boolean;

  Turn:Integer;

  Enemy:Integer;
  Our:Integer;

const
  MaxLevel:Integer=3;

procedure LoadData;
var
  I,J:Integer;
  C:Char;
begin
  AsSign(Input,'FILYA.IN');
  ReSet(Input);
  for J:=1 to 41 do
    begin
      for I:=1 to 45 do
        begin
          Read(C);
          D[I,J]:=Ord(C)-48;
        end;
      ReadLn;
    end;
  Close(Input);
  AsSign(Input,'CON');
  ReSet(Input);
end;

procedure ClearWas;
var
  I,J:Integer;
begin
  for I:=1 to 45 do
    begin
      for J:=1 to 41 do
        begin
          Was[I,J]:=False;
          Was[0,J]:=True;
          Was[46,J]:=True;
        end;
      Was[I,0]:=True;
      Was[I,42]:=True;
    end;
end;

procedure InitColors;
begin
  Our:=D[1,1];
  Enemy:=D[45,41];
end;

function FNum(X,Y:Integer):Integer;
var
  I:Integer;
  Res:Integer;
begin
  Res:=1;
  Was[X,Y]:=True;
  if (not Was[X+1,Y]) and (D[X+1,Y]=Our) then
    Res:=Res+FNum(X+1,Y);
  if (not Was[X,Y+1]) and (D[X,Y+1]=Our) then
    Res:=Res+FNum(X,Y+1);
  if (not Was[X-1,Y]) and (D[X-1,Y]=Our) then
    Res:=Res+FNum(X-1,Y);
  if (not Was[X,Y-1]) and (D[X,Y-1]=Our) then
    Res:=Res+FNum(X,Y-1);
  FNum:=Res;
end;

function GetNum:Integer;
begin
  ClearWas;
  GetNum:=FNum(1,1);
end;

procedure Fill(X,Y:Integer; Color:Integer);
begin
  D[X,Y]:=Color;

  if D[X+1,Y]=Our then Fill(X+1,Y,Color);
  if D[X,Y+1]=Our then Fill(X,Y+1,Color);
  if D[X-1,Y]=Our then Fill(X-1,Y,Color);
  if D[X,Y-1]=Our then Fill(X,Y-1,Color);
end;

function GetBest(Lev:Integer):Integer;
var
  I:Integer;
  Max,M:Integer;
  Sav:Integer;
begin
  Max:=0;
  for I:=1 to 6 do
    if (I<>Our) and (I<>Enemy) then
      begin
        Steps[Lev]:=D;
        Sav:=Our;

        Fill(1,1,I);
        Our:=I;

        if Lev=MaxLevel then
          begin
            M:=GetNum;
            if M>Max then Max:=M
          end
        else
          begin
            M:=GetBest(Lev+1);
            if M>Max then
              begin
                Max:=M;
                if Lev=1 then Turn:=I;
              end;
          end;

        Our:=Sav;
        D:=Steps[Lev];
      end;
  GetBest:=Max;
end;

procedure MakeTurn;
var
  I:Integer;
  Max,M:Integer;
  Sav:Integer;
begin
  GetBest(1);
end;

procedure MakeTurn1;
var
  I:Integer;
  Max,M:Integer;
  Sav:Integer;
begin
  Max:=0;
  for I:=1 to 6 do
    if (I<>Our) and (I<>Enemy) then
      begin
        Steps[1]:=D;
        Sav:=Our;

        Fill(1,1,I);
        Our:=I;

        M:=GetNum;
        if M>Max then
          begin
            Turn:=I;
            Max:=M;
          end;

        Our:=Sav;
        D:=Steps[1];
      end;
end;

procedure WriteTurn;
begin
  AsSign(Output,'FILYA.OUT');
  ReWrite(Output);
  WriteLn(Turn);
  Close(Output);
end;

begin
  LoadData;
  InitColors;
  ClearWas;
  if GetNum<800 then MakeTurn
                else MakeTurn1;
  WriteTurn;
end.