{$A8,B-,C+,D+,E-,F-,G+,J-,K-,L+,M-,N+,P+,T-,U-,V+,W-,X+,Y+,Z1}
{$Q+,R+,S+,O-,H+,I+}
{$MINSTACKSIZE $00004000}
{$MAXSTACKSIZE $00100000}
{$IMAGEBASE $00400000}
{$APPTYPE console}

uses SysUtils;

const
  cinfile = 'triples.in';
  coutfile = 'triples.out';

  inf = maxlongint shr 1;
  eps = 1e-8;

  nmax = 200000;
  pmax = 2005;

type
  int = longint;
  real = extended;

var
  ans : int64;
  n, k, kn : int64;
  p : int;

  a, mp, mpm : array [1..nmax] of int;

  kp, kpm : array [0..pmax] of int64;

  st : array [0..pmax, 0..pmax] of int;

  c : array [0..pmax, 0..pmax] of int64;

procedure outdata;
var
  i, j : int;
begin
  writeln(ans);
end;

procedure ata;
var
  i, j : int;
  s : int64;
begin
  s:= 0;
  for i:= 0 to p - 1 do
    for j:= 0 to p - 2 do
      if st[i, j] = i then
        inc(s, kpm[j] * kp[i]);
  dec(ans, s);
end;

procedure aat;
var
  i, j : int;
  s : int64;
begin
  s:= 0;
  for i:= 1 to n do
     inc(s, kp[ st[mp[i], mpm[i]] ]);
  dec(ans, s);
end;

procedure taa;
var
  i, t : int;
  s : int64;
begin
  fillchar(c, sizeof(c), 0);
  for i:= 0 to p - 2 do
    for t:= 0 to p - 1 do
      inc(c[st[t, i], i], kp[t]);
  s:= 0;
  for i:= 1 to n do inc(s, c[mp[i], mpm[i]]);
  dec(ans, s);
end;

procedure aaa;
var
  i, t : int;
  s : int64;
begin
  s:= 0;
  for i:= 1 to n do
    if st[mp[i], mpm[i]] = mp[i] then inc(s);
  inc(ans, s * 2);
end;

procedure solve;
var
  i, j : int;
  s : int64;
begin
  for i:= 1 to n do mp[i]:= a[i] mod p;
  for i:= 1 to n do mpm[i]:= a[i] mod (p - 1);

  fillchar(kp, sizeof(kp), 0);
  fillchar(kpm, sizeof(kpm), 0);
  for i:= 1 to n do
  begin
    inc(kp[mp[i]]);
    inc(kpm[mpm[i]]);
  end;

  fillchar(st, sizeof(st), 0);
  for i:= 0 to p do st[i, 0]:= 1;
  st[0, 0]:= 0;
  for i:= 0 to p do
    for j:= 1 to p - 1 do st[i, j]:= (st[i, j - 1] * i) mod p;
  ans:= 0;
  for i:= 0 to p - 1 do
    for j:= 0 to p - 2 do
      ans:= ans + kp[i] * kpm[j] * kp[st[i, j]];

  ata;
  aat;
  taa;
  aaa;

  inc(ans, kp[0] * (n - 1) * kn);
  inc(ans, kp[1] * (n - 1) * kn);
  inc(ans, kp[1] * (kn - 1) * kn);
  inc(ans, kp[0] * (n - 1) * kn);
  inc(ans, n * (kn - 1) * kn);
end;

procedure readdata;
var

  i, j, h : int;
  x : int;
begin
  read(k, p);
  assert((3<=k) and (k<=100000));
  assert((2<=p) and (p<=1499));
  if p>2 then
    for h:=2 to trunc(sqrt(p))+1 do assert(p mod h<>0);
    
  n:= 0;
  for i:= 1 to k do
  begin
    read(x);
    assert((0<=x) and (x<=1000000000));
    if x = 0 then inc(kn) else
    begin
      inc(n);
      a[n]:= x;
    end;
  end;
end;

begin
  reset(input, cinfile);
  rewrite(output, coutfile);
  readdata;
  solve;
  outdata;
  close(input);
  close(output);
end.
