{$D+,L+,I+,Q+,R+,S+}
Program cycle_alx_slow;

uses SysUtils;

const
  inpfile='path.in';
  outfile='path.out';
  nm = 2000;
var
  a : array [1..nm,0..nm] of LongInt;
  u,v : array [1..nm] of LongInt;
  n,m,cnt : LongInt;
{}
Procedure Inp;
var
  i,x,y : LongInt;
begin
  assign(input,inpfile);
  reset(input);
  for i:=1 to n do a[i,0]:=0;

  read(n,m);
  for i:=1 to m do begin
    read(x,y);
    inc(a[x,0]); a[x,a[x,0]]:=y;
    inc(a[y,0]); a[y,a[y,0]]:=x;
  end;
end;
{}
Procedure Out;
var
  i : LongInt;
begin
  assign(output,outfile);
  rewrite(output);
  for i:=1 to n do v[u[i]]:=i;
  for i:=1 to n do write(v[i],' ');
  close(output);
  halt;
end;
{}
Procedure Init;
begin
  fillchar(u,sizeof(u),0);
end;
{}
var
  y : LongInt;
  
Procedure Dfs(x : LongInt);
var
  i : LongInt;
begin
  inc(cnt);
  u[x]:=cnt;
  if cnt=n then Out;


  for i:=1 to a[x,0] do begin
    y:=a[x,i];
    if u[y]=0 then Dfs(y);
  end;  

  dec(cnt);
  u[x]:=0;
end;
{}
Procedure Solve;
begin
  cnt:=0;
  Dfs(1);
end;
{}
Begin
  Init;
  Inp;
  Solve;
  Out;
End.
