{$APPTYPE CONSOLE}
{$R-,Q-,S-}
Const
  MaxN=10000;
Var
  Cost:Array[0..MaxN,0..MaxN]Of Byte;
  Cycle:Array[0..MaxN]Of Integer;
  N,M,A,B,I,J:Integer;
  Found:Boolean;
  MinC:Integer;
Procedure Search;
Var
  C,T,I,J,II,JJ,AI,AJ,AII,AJJ,NumIter,MaxIter:Integer;
Begin                         
  MaxIter:=N*N Div 10;
  For I:=0 To N Do Cycle[I]:=I;
  For I:=0 To N Do Begin
    J:=I+Random(N+1-I);
    If I<>J Then Begin
      T:=Cycle[I];
      Cycle[I]:=Cycle[J];
      Cycle[J]:=T;
    End;
  End;
  C:=0;
  For I:=0 To N Do Inc(C,Cost[Cycle[I],Cycle[(I+1) Mod (N+1)]]);
  NumIter:=0;
  While (C>0) And (NumIter<MaxIter) Do Begin
    Repeat
      I:=Random(N+1);
      J:=Random(N+1);
      JJ:=J+1;
      If JJ>N Then JJ:=0;
    Until (I<>J) And (I<>JJ);
    II:=I-1;
    If II<0 Then II:=N;
    AI:=Cycle[I];
    AII:=Cycle[II];
    AJ:=Cycle[J];
    AJJ:=Cycle[JJ];
    If Cost[AI,AII]+Cost[AJ,AJJ]>Cost[AI,AJJ]+Cost[AJ,AII] Then Begin
      Inc(C,Cost[AI,AJJ]+Cost[AJ,AII]-Cost[AI,AII]-Cost[AJ,AJJ]);
//      WriteLn(C);
      Repeat
        T:=Cycle[I];
        Cycle[I]:=Cycle[J];
        Cycle[J]:=T;
        Inc(I);
        If I>N Then I:=0;
        If I=J Then Break;
        Dec(J);
        If J<0 Then J:=N;
        If I=J Then Break;
      Until False;
      NumIter:=0;
    End Else Inc(NumIter);
  End;
  If C=0 Then Found:=True;
  If C<MinC Then Begin
    MinC:=C;
    WriteLn(C);
  End;
End;
Begin
  FillChar(Cost,SizeOf(Cost),0);
  ReSet(Input,'cycle.in');
  Read(N,M);
  MinC:=2*N;
  RandSeed:=N*5421+M;
  For I:=1 To N Do
    For J:=1 To N Do
      Cost[I,J]:=1;
  For I:=1 To M Do Begin
    Read(A,B);
    Cost[A,B]:=0;
    Cost[B,A]:=0;
    RandSeed:=RandSeed*543179+A*317+B;
  End;
  Close(Input);
  Found:=False;
  While Not Found Do Search;
  For I:=0 To N Do If Cycle[I]=0 Then Break;
  ReWrite(Output,'cycle.out');
  For J:=I+1 To N Do Write(Cycle[J],' ');
  For J:=0 To I-1 Do Write(Cycle[J],' ');
  WriteLn;
  Close(Output);
End.