#include <stdio.h>

#define FILE_IN "rhyme.in"
#define FILE_OUT "rhyme.out"

#define MAXN 50
#define MAXK 50
#define MAXM 1000
#define MAXW 100

struct EDGE{
  int v,c;
};

struct VERTEX{
  int num,prev,c;
};

int all,n,m,k,a,b;

EDGE mat[MAXN][MAXN];
int st[MAXN];

VERTEX que[2*MAXN*MAXK];
int be[MAXN];
int s,f;

void pop(VERTEX &d){
  d=que[s++];
}

void push(VERTEX &t){
  que[f++]=t;
}

int w[MAXW][MAXN*MAXK];
int wl=0;

int  find(){
  s=0;f=0;
  VERTEX d,de;
  d.num=a;
  d.c=k+1;
  d.prev=-1;
  int i,j;
  for (i=0;i<n;i++) be[i]=0;
  push(d);
  while(s<f) {
    pop(d);
    be[d.num]=1;
    if (d.num==b) {
      j=d.prev;
      w[wl][1]=d.c;
      w[wl][0]=0;
      while (j!=-1) {
        w[wl][++w[wl][0]*2+1]=que[j].c;
        w[wl][w[wl][0]*2]=que[j].num;
        j=que[j].prev;
      }
      wl++;
      return 1;
    }
    for (i=0;i<st[d.num];i++)
      if (!be[mat[d.num][i].v]) {
        de.prev=s-1;
        de.num=mat[d.num][i].v;
        de.c=mat[d.num][i].c;
        push(de);
      }
  }
  return 0;
}

int main(){
  freopen(FILE_IN,"r",stdin);
  freopen(FILE_OUT,"w",stdout);

  int i,u,v,c,j;
  scanf("%d %d %d %d",&n,&k,&a,&b);
  a--,b--;
  scanf("%d",&m);
  for (i=0;i<n;i++) st[i]=0;
  for (i=0;i<m;i++) {
    scanf("%d %d %d",&u,&v,&c);
    u--;v--;
    mat[u][st[u]].v=v;
    mat[u][st[u]++].c=c;
  }
  int shift;
  while(find()){
    for (i=1;i<=w[wl-1][0];i++){
      shift=0;
      v=w[wl-1][2*i];
      c=w[wl-1][2*i-1];
      for (j=0;j<st[v];j++){
        if (mat[v][j].c==c) shift++;
        else if (shift>0) {
          mat[v][j-shift]=mat[v][j];
        }
      }
      st[v]-=shift;
    }
  };

  printf("%d\n",wl);
  for(i=0;i<wl;i++){
    for (j=w[i][0];j>0;j--) printf("%d %d ",w[i][2*j]+1,w[i][2*j-1]);
    printf("%d\n",b+1);
  }

  fclose(stdin);
  fclose(stdout);
  return 0;
}