{$I+,Q+,R+,S+,O+}
{$Apptype console}

uses SysUtils;

const
  cInFile = 'form.in';
  cOutFile = 'form.out';

  list = 1 shl 17;
  nmax = 100010;

type
  int = longint;
  real = extended;

  ttree = array [1..list shl 1] of int64;
  mx = array [1..list shl 1] of int;

var
  n, k : int;
  ans : int64;

  p : array [1..nmax] of int;
  bl, c : array [1..nmax] of int64;
  u : array [1..nmax] of boolean;

  tree : ttree;
  mr : mx;

procedure OutData;
var
  i, j : int;
begin
  writeln(ans);
end;

function findsb(v : int) : int64;
var
  s : int64;
  i : int;
begin
  s:= 0;
  v:= v + list - 1;
  i:= 1;
  while i <= list do
    if mr[i shl 1] > v then i:= i shl 1 else
    begin
      inc(s,tree[i shl 1]);
      i:= i shl 1 + 1;
    end;
  findsb:= s;
end;

procedure change(v : int; b : int64);
var
  i : int;
begin
  i:= v + list - 1;
  tree[i]:= b;
  while i > 1 do
  begin
    i:= i shr 1;
    tree[i]:= tree[i shl 1] + tree[i shl 1 + 1];
  end;
end;

procedure init;
var
  i, j : int;
begin
  for i:= list to list shl 1 do mr[i]:= i;
  for i:= list-1 downto 1 do mr[i]:= mr[i shl 1+1];
end;

procedure Solve;
var
  i, j : int;
begin
  init;
  for i:= 1 to n do bl[i]:= 1;
  for i:= 1 to n do c[i]:= 1;
  for j:= 1 to k do 
  begin
    fillchar(tree,sizeof(tree),0);
    for i:= n downto 1 do
    begin
      c[i]:= findsb(n) - findsb(p[i]);
      change(p[i],bl[i]);
    end;
    bl:= c;
  end;
  ans:= 0;
  for i:= 1 to n do inc(ans,c[i]);
end;

procedure ReadData;
var
  i, j : int;
begin
  read(n, k);
  assert((n >= 1) and (n <= 100000));
  assert((k >= 0) and (k <= 10));
  for i:= 1 to n do read(p[i]);
  for i:= 1 to n do assert((p[i] >= 1) and (p[i] <= n));
  fillchar(u, sizeof(u), 0);
  for i:= 1 to n do 
  begin
    assert(not u[p[i]]);
    u[p[i]]:= true;
  end;
end;

begin
  assign(input,cinfile);
  assign(output,coutfile);
  reset(input);
  rewrite(output);
  ReadData;
  Solve;
  OutData;
  close(input);
  close(output);
end.