{$D+,L+,I+,Q+,R+,S+}
Program king_alx_slow;
const
  inpfile='king.in';
  outfile='king.out';
  inf = MaxLongInt;
  nm=505;
  xm=1000;
  dx : array [1..8] of LongInt = (1,1,0,-1,-1,-1,0,1);
  dy : array [1..8] of LongInt = (0,1,1,1,0,-1,-1,-1);
type
  Coord = record
    x,y : LongInt;
  end;
var
  a : array [1..nm] of Coord;
  u : array [0..xm,0..xm] of LongInt;
  b : array [1..xm*xm] of Coord;
  s,t : Coord;
  n : LongInt;
  p1,p2 : Coord;
{}
Function Min(q,w : LongInt) : LongInt;
begin
  if q<w then min:=q else min:=w;
end;
{}
Function Max(q,w : LongInt) : LongInt;
begin
  if q>w then max:=q else max:=w;
end;
{}
Procedure Inp;
var
  i,j : LongInt;
begin
  assign(input,inpfile);
  reset(input);
  read(s.x,s.y,t.x,t.y,n);

  p1:=s; p2:=s;
  p1.x:=min(p1.x,t.x);
  p1.y:=min(p1.y,t.y);
  p2.x:=max(p2.x,t.x);
  p2.y:=max(p2.y,t.y);

  for i:=1 to n do begin
    read(a[i].x,a[i].y);
    p1.x:=min(p1.x,a[i].x);
    p1.y:=min(p1.y,a[i].y);
    p2.x:=max(p2.x,a[i].x);
    p2.y:=max(p2.y,a[i].y);
  end;

  dec(p1.x);
  dec(p1.y);

  dec(s.x,p1.x-1);
  dec(s.y,p1.y-1);
  dec(t.x,p1.x-1);
  dec(t.y,p1.y-1);

  dec(p2.x,p1.x-2);
  dec(p2.y,p1.y-2);
  for i:=0 to p2.x+1 do
    for j:=0 to p2.y+1 do u[i,j]:=-1;

  for i:=1 to p2.x do
    for j:=1 to p2.y do u[i,j]:=-2;

  for i:=1 to n do begin
    dec(a[i].x,p1.x-1);
    dec(a[i].y,p1.y-1);
    u[a[i].x,a[i].y]:=-1;
  end;
end;
{}
Procedure Out(res : LongInt);
begin
  assign(output,outfile);
  rewrite(output);
  writeln(res);
  close(output);
  halt;
end;
{}
Procedure Init;
begin
end;
{}
Procedure Solve;
var
  i : LongInt;
  q,w : LongInt;
  p : Coord;
begin
  q:=0; w:=1;
  b[1]:=s; u[s.x,s.y]:=0;
  while q<w do begin
    inc(q);
    for i:=1 to 8 do begin
      p.x:=b[q].x+dx[i];
      p.y:=b[q].y+dy[i];
      if u[p.x,p.y]=-2 then begin
        u[p.x,p.y]:=u[b[q].x,b[q].y]+1;
        inc(w);
        b[w]:=p;
        if (p.x=t.x) and (p.y=t.y) then Out(u[p.x,p.y]);
      end;
    end;  
  end;
end;
{}
Begin
  Init;
  Inp;
  Solve;
  Out(-1);
End.
