{$A+,B-,D+,E+,F-,G-,I+,L+,N-,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}
const
  problem='x0';
  fin =problem+'.in';
  fout=problem+'.out';

var
  a,b:array[-10..60,-10..60]of longint;
  i,j,k,l,n,m,mdx,mdy,x1,x2,y1,y2:longint;

function solidcheck:boolean;
  procedure dfs(x,y:longint);
  var
    dx,dy,i:longint;
  begin
    b[x,y]:=1;
    for dx:=-mdx to mdx do
      for dy:=-mdy to mdy do
        if (dx<>0)or(dy<>0) then
          if (a[x+dx,y+dy]=1) then
          begin
            if (b[x+dx,y+dy]=0) then
              dfs(x+dx,y+dy);
            for i:=0 to dx do
              if a[x+i,y]=0 then
                a[x+i,y]:=2;
            for i:=0 to dy do
              if a[x+dx,y+i]=0 then
                a[x+dx,y+i]:=2;
            for i:=dx to 0 do
              if a[x+i,y]=0 then
                a[x+i,y]:=2;
            for i:=dy to 0 do
              if a[x+dx,y+i]=0 then
                a[x+dx,y+i]:=2;
          end;
  end;

  procedure dfs1(x,y:longint);
  var
    dx,dy:longint;
  begin
    b[x,y]:=1;
    for dx:=-1 to 1 do
      for dy:=-1 to 1 do
        if abs(dx)+abs(dy)=1 then
        if (dx<>0)or(dy<>0) then
          if (b[x+dx,y+dy]=0)and(a[x+dx,y+dy]=0) then
            dfs1(x+dx,y+dy);
  end;

var
  i,j,k:longint;

begin
  fillchar(b,sizeof(b),1);
  for i:=-1 to n+1 do
    for j:=-1 to m+1 do
      b[i,j]:=0;
  k:=0;
  for i:=1 to n do
    for j:=1 to m do
      if (a[i,j]=0)and(b[i,j]=0) then begin
        inc(k);
        dfs1(i,j);
      end;
  if k=2 then begin
    solidcheck:=true;
    exit;
  end;
  for i:=1 to n do
    for j:=1 to m do
      b[i,j]:=0;
  for i:=1 to n do
    for j:=1 to m do
      if (a[i,j]=1)and(b[i,j]=0) then
        dfs(i,j);
  for i:=-1 to n+2 do
    for j:=-1 to m+2 do
      b[i,j]:=0;
  k:=0;
  for i:=1 to n do
    for j:=1 to m do
      if (a[i,j]=0)and(b[i,j]=0) then begin
        inc(k);
        dfs1(i,j);
      end;
  if k>=2 then
    solidcheck:=false
  else
    solidcheck:=true;
end;

function diagcheck:boolean;
var
  k,l:longint;
begin
  fillchar(b,sizeof(b),0);
  for i:=x1 to x2 do begin
    k:=y1+trunc(((i-x1)/(x2-x1))*(y2-y1));
    for j:=k-mdy to k+mdy do begin
      b[i,j]:=2;
      if a[i,j]=1 then
        b[i,j]:=1;
    end;
  end;
  for i:=x1 to x2 do begin
    k:=y1+trunc(((x2-i)/(x2-x1))*(y2-y1));
    for j:=k-mdy to k+mdy do begin
      b[i,j]:=2;
      if a[i,j]=1 then
        b[i,j]:=1;
    end;
  end;
  k:=0;
  l:=0;
  for i:=1 to n do
    for j:=1 to m do begin
      if a[i,j]=1 then
        inc(k);
      if b[i,j]=1 then
        inc(l);
    end;
  if l/k>0.7 then
    diagcheck:=true
  else
    diagcheck:=false
end;

function process:char;
begin
  x1:=100;y1:=100;
  x2:=0;y2:=0;
  for i:=1 to n do
    for j:=1 to m do
      if a[i,j]=1 then begin
        if i<x1 then
          x1:=i;
        if i>x2 then
          x2:=i;
        if j<y1 then
          y1:=j;
        if j>y2 then
          y2:=j;
      end;
  mdx:=1+(x2-x1)div 5;
  mdy:=1+(y2-y1)div 5;
  if (solidcheck)and(diagcheck) then
    process:='X'
  else
    process:='0';
  fillchar(a,sizeof(a),0);
  fillchar(b,sizeof(b),0);
end;

procedure init;
var
  c:char;
begin
  assign(input,fin);
  reset(input);
  assign(output,fout);
  rewrite(output);

    n:=0;
    repeat
      read(c);
      if c='#' then begin
        writeln(process);
        n:=0;
        m:=0;
        break;
      end;
      if c='-' then begin
        writeln(process);
        readln;
        n:=0;
        m:=0;
        continue;
      end;
      inc(n);
      m:=0;
      repeat
        inc(m);
        read(c);
        if c='.' then
          a[n,m]:=0
        else
          a[n,m]:=1;
      until eoln;
      readln;
    until eof;

  close(output);
  close(input);
end;

procedure solve;
begin

end;

procedure done;
begin
end;

begin
  init;
  solve;
  done;
end.
