{$A+,B-,D+,E+,F-,G-,I+,L+,N-,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}
const
  problem='divide';
  fin =problem+'.in';
  fout=problem+'.out';
  base=10;
  maxn=5000;

type
  long=array[0..6000]of integer;

var
  z:array[0..maxn]of long;
  a1,a2,a3,b1,b2,b3,t1,t2,t3,x,y,x1,y1:long;
  i,j,k,l,n,m:longint;
  ch:char;

procedure readlong(var a:long);
var
  i:longint;
begin
  while not (ch in ['0'..'9']) do
    read(ch);
  fillchar(a,sizeof(a),0);
  repeat
    inc(a[0]);
    for i:=a[0] downto 2 do
      a[i]:=a[i-1];
    a[1]:=ord(ch)-ord('0');
    read(ch);
  until not (ch in ['0'..'9']);
end;

function cmp(const a,b:long):longint;
var
  i:longint;
begin
  if a[0]>b[0] then begin
    cmp:=1;
    exit;
  end;
  if a[0]<b[0] then begin
    cmp:=-1;
    exit;
  end;
  for i:=a[0] downto 1 do begin
    if a[i]>b[i] then begin
      cmp:=1;
      exit;
    end;
    if a[i]<b[i] then begin
      cmp:=-1;
      exit;
    end;
  end;
  cmp:=0;
end;

procedure add(var a:long;const b:long);
var
  i:longint;
begin
  if a[0]<b[0] then
    a[0]:=b[0];
  for i:=1 to b[0] do begin
    a[i]:=a[i]+b[i];
    if a[i]>=base then begin
      inc(a[i+1]);
      dec(a[i],base);
    end;
  end;
  if a[a[0]+1]>0 then
    inc(a[0]);
end;

procedure mult(const a,b:long; var c:long);
var
  i,j:longint;
begin
  fillchar(c,sizeof(c),0);
  for i:=1 to a[0] do
    for j:=1 to b[0] do begin
      c[i+j-1]:=c[i+j-1]+a[i]*b[j];
      if c[i+j-1]>=base then begin
        c[i+j]:=c[i+j]+ c[i+j-1]div base;
        c[i+j-1]:=c[i+j-1] mod base;
      end;
    end;
  c[0]:=a[0]+b[0];
  while (c[c[0]]=0)and(c[0]>1) do
    dec(c[0]);
end;

procedure mults(var a:long;b:longint);
var
  i:longint;
begin
  for i:=1 to a[0] do
    a[i]:=a[i]*b;
  for i:=1 to a[0] do
    if a[i]>=base then begin
      a[i+1]:=a[i+1]+ a[i] div base;
      a[i]:=a[i] mod base;
    end;
  while a[a[0]+1]>0 do begin
    inc(a[0]);
    a[a[0]+1]:=a[a[0]+1]+a[a[0]] div base;
    a[a[0]]:=a[a[0]] mod base;
  end;
end;

procedure sub(var a:long;const b:long);
var
  i:longint;
begin
  for i:=1 to b[0] do begin
    a[i]:=a[i]-b[i];
    if a[i]<0 then begin
      dec(a[i+1]);
      inc(a[i],base);
    end;
  end;
  for i:=b[0]+1 to a[0] do
    if a[i]<0 then begin
      dec(a[i+1]);
      inc(a[i],base);
    end;
  while (a[a[0]]=0)and(a[0]>1) do
    dec(a[0]);
end;

procedure divide(const x,y:long;var a,b,c:long);
var
  d,e:long;
  i,j,k,l:longint;
begin
  i:=x[0];
  fillchar(a,sizeof(a),0);
  fillchar(b,sizeof(b),0);
  fillchar(c,sizeof(c),0);
  fillchar(d,sizeof(d),0);
  fillchar(e,sizeof(e),0);
  e[0]:=1;
  l:=0;
  j:=0;
  n:=0;
  repeat
    inc(l);
    d:=y;
    k:=1;
    while cmp(d,e)<1 do begin
      inc(k);
      add(d,y);
    end;
    dec(k);
    d:=y;
    mults(d,k);
    sub(e,d);
    mults(e,base);
    if i<0 then begin
      e[1]:=0;
      b[n+1]:=k;
      inc(e[0]);
      e[e[0]]:=k;
      for j:=1 to n do
        if cmp(e,z[j])=0 then
          break;
      if cmp(e,z[j])=0 then
        break;
      if (e[0]=1) then begin
        b[0]:=n;
        c[0]:=0;
        exit;
      end;
      inc(n);
      z[n]:=e;
      e[e[0]]:=0;
      dec(e[0]);
    end
    else begin
      e[1]:=x[i];
      if i=0 then
        e[1]:=0;
      a[l]:=k;
      a[0]:=l;
      dec(i);
    end;
  until false;
  c[0]:=n-j+1;
  for i:=j to n do
    c[i-j+1]:=b[i];
  b[0]:=j-1;
end;

procedure init;
begin
  assign(input,fin);
  reset(input);

    readlong(a1);
    if ch='.' then begin
      readlong(a2);
      if ch=')' then begin
        a3:=a2;
        fillchar(a2,sizeof(a2),0);
      end;
      if ch='(' then
        readlong(a3);
    end;
    read(ch);
    readlong(b1);
    if ch='.' then begin
      readlong(b2);
      if ch=')' then begin
        b3:=b2;
        fillchar(b2,sizeof(b2),0);
      end;
      if ch='(' then
        readlong(b3);
    end;
    if a3[0]=0 then
      a3[0]:=1;
    if b3[0]=0 then
      b3[0]:=1;

  close(input);
end;

procedure solve;
begin
  fillchar(z,sizeof(z),0);
  fillchar(t3,sizeof(t3),0);
  t3[0]:=a2[0]+1;
  t3[t3[0]]:=1;
  fillchar(t2,sizeof(t2),0);
  t2[0]:=a3[0]+1;
  t2[t2[0]]:=1;
  t1[0]:=1;
  t1[1]:=1;
  sub(t2,t1);
   mult(t2,a2,x);
   add(x,a3);
  mult(t2,t3,t1);
  fillchar(t2,sizeof(t2),0);
  fillchar(t3,sizeof(t3),0);
  mult(t1,a1,t2);
   add(x,t2);
  y:=t1;

  fillchar(t3,sizeof(t3),0);
  t3[0]:=b2[0]+1;
  t3[t3[0]]:=1;
  fillchar(t2,sizeof(t2),0);
  t2[0]:=b3[0]+1;
  t2[t2[0]]:=1;
  t1[0]:=1;
  t1[1]:=1;
  sub(t2,t1);
   mult(t2,b2,x1);
   add(x1,b3);
  mult(t2,t3,t1);
  fillchar(t2,sizeof(t2),0);
  fillchar(t3,sizeof(t3),0);
  mult(t1,b1,t2);
   add(x1,t2);
  y1:=t1;

  fillchar(t1,sizeof(t1),0);
  fillchar(t2,sizeof(t2),0);
   mult(x,y1,t1);
   mult(y,x1,t2);
   x:=t1;
   y:=t2;
  fillchar(t1,sizeof(t1),0);
  fillchar(t2,sizeof(t2),0);
  fillchar(t3,sizeof(t3),0);
  fillchar(a1,sizeof(a1),0);
  fillchar(a2,sizeof(a2),0);
  fillchar(a3,sizeof(a3),0);
  fillchar(b1,sizeof(b1),0);
  fillchar(b2,sizeof(b2),0);
  fillchar(b3,sizeof(b3),0);
  fillchar(x1,sizeof(x1),0);
  fillchar(y1,sizeof(y1),0);

  divide(x,y,a1,a2,a3);
  if (a2[0]=1)and(a2[1]=0) then
    a2[0]:=0;
  if (a3[0]=1)and(a3[1]=0) then
    a3[0]:=0;
end;

procedure done;
begin
  assign(output,fout);
  rewrite(output);

    k:=0;
    for i:=1 to a1[0] do begin
      if (k=0)and(a1[i]=0) then
        continue;
      if a1[i]<>0 then
        k:=1;
      write(a1[i]);
    end;
    if k=0 then
      write(0);
    if (a3[0]<>0)or(a2[0]<>0) then
      write('.');
    if a2[0]<>0 then
      for i:=1 to a2[0] do
        write(a2[i]);
    if a3[0]<>0 then begin
      write('(');
      for i:=1 to a3[0] do
        write(a3[i]);
      write(')');
    end;

  close(output);
end;

begin
  init;
  solve;
  done;
end.
