{$A+,B-,D+,E+,F-,G-,I+,L+,N+,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}
const
  problem='virtual';
  fin =problem+'.in';
  fout=problem+'.out';

var
  a:array[0..110,0..110,0..110]of longint;
  b:array[0..110,0..110,0..110]of extended;
  i,j,k,m,n,l,x,y,z,x1,y1,z1:longint;

procedure init;
begin
  assign(input,fin);
  reset(input);

    read(x,y,z,x1,y1,z1,k);
    for i:=1 to z do
      for j:=1 to y do
        for l:=1 to x do
          read(a[l,j,i]);

  close(input);
end;

function sum(x,y,z:longint):extended;
var
  x2,y2,z2:longint;
begin
  x2:=x-x1;
  y2:=y-y1;
  z2:=z-z1;
  if x2<0 then
    x2:=0;
  if y2<0 then
    y2:=0;
  if z2<0 then
    z2:=0;
  sum:=b[x,y,z]-(b[x2,y,z]+b[x,y2,z]+b[x,y,z2])+
                (b[x2,y2,z]+b[x2,y,z2]+b[x,y2,z2]) - b[x2,y2,z2];
end;

procedure setb(x,y,z,k:longint);
begin
  b[x,y,z]:=k+(b[x-1,y,z]+b[x,y-1,z]+b[x,y,z-1])-
                (b[x-1,y-1,z]+b[x-1,y,z-1]+b[x,y-1,z-1]) + b[x-1,y-1,z-1];
end;

{function sum(x,y,z:longint):longint;
var
  x2,y2,z2,i,j,l,s:longint;
begin
  s:=0;
  x2:=x-x1;
  y2:=y-y1;
  z2:=z-z1;
  if x2<0 then
    x2:=0;
  if y2<0 then
    y2:=0;
  if z2<0 then
    z2:=0;
  for i:=x2 to x do
    for j:=y2 to y do
      for l:=z2 to z do
        s:=s+b[i,j,l];
  sum:=s;
end;}

procedure solve;
var
  g:longint;
begin
  fillchar(b,sizeof(b),0);
  for i:=1 to x do
    for j:=1 to y do
      for l:=1 to z do begin
        setb(i,j,l,0);
        g:=(trunc(sum(i,j,l)+1e-4)+a[i,j,l])mod k;
        g:=(k-g)mod k;
        if ((i>x-x1+1)or(j>y-y1+1)or(l>z-z1+1))and(g<>0) then begin
          b[x,y,z]:=-1;
          exit;
        end;
        setb(i,j,l,g);
      end;
end;

procedure done;
begin
  assign(output,fout);
  rewrite(output);

    writeln(b[x,y,z]:0:0);

  close(output);
end;

begin
  init;
  solve;
  done;
end.
