{$A+,B-,D+,E+,F-,G-,I+,L+,N-,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}
uses
  guess;

const
  maxn=600000;
  p   =262143;

var
  q,i,j,k,l,r,n,m:longint;
  f,s:array[0..maxn]of longint;
  a:array[1..maxn] of longint;

function check(i:longint):boolean;
begin
  check:=true;
  if i<1 then
    exit;
  if f[i]=1 then
    check:=false
  else
    check:=check(i div 2);
end;

function free(l,r:longint):longint;
var
  k:longint;
begin
  k:=-1;
  inc(l,p);inc(r,p);
  while l<=r do begin
    if f[l]=0 then
      if check(l) then begin
        k:=l;
        break;
      end;
    if f[r]=0 then
      if check(r) then begin
        k:=r;
        break;
      end;
    l:=(l+1) div 2;
    r:=(r-1) div 2;
  end;
  if k=-1 then begin
    free:=-1;
    exit;
  end;
  while k<=p do begin
    if f[2*k]=0 then
      k:=2*k
    else
      k:=2*k+1;
  end;
  free:=k-p;
end;

procedure update(i:longint);
begin
  if (f[2*i]=1)and(f[2*i+1]=1) then begin
    f[i]:=1;
    update(i div 2);
  end;
end;

procedure fill(l,r:longint);
begin
  inc(l,p);inc(r,p);
  while l<=r do begin
    f[l]:=1;
    f[r]:=1;
    if l mod 2=1 then
      update(l div 2);
    if r mod 2=0 then
      update(r div 2);
    l:=(l+1) div 2;
    r:=(r-1) div 2;
  end;
end;

function sum(l,r:longint):longint;
var
  a:longint;
begin
  inc(l,p);inc(r,p);
  a:=0;
  while l<r do begin
    if l mod 2 =1 then
      dec(a,s[l-1]);
    if r mod 2 =0 then
      dec(a,s[r+1]);
    l:=l div 2;
    r:=r div 2;
    if a<0 then
      a:=a+k;
    if l=r then
      inc(a,s[l]);
  end;
  a:=a mod k;
  sum:=a;
end;

procedure add(i,w:longint);
begin
  inc(i,p);
  while i>=1 do begin
    inc(s[i],w);
    s[i]:=s[i] mod k;
    i:=i div 2;
  end;
end;

begin
  fillchar(s,sizeof(s),0);
  fillchar(f,sizeof(f),0);
  fillchar(a,sizeof(a),0);
  initialize(n,k,q);
  for i:=p+n+1 to 2*p+1 do
    f[i]:=1;
  for i:=p downto 1 do
    if (f[2*i]=1)and(f[2*i+1]=1) then
      f[i]:=1;
  repeat
    nextquery(l,r,m);
    i:=free(l,r);
    j:=sum(l,r);
    if (i=-1)and(j<>m) then
      error(n,a);
    if i<>-1 then begin
      a[i]:=(m-j+k)mod k;
      add(i,(m-j+k)mod k);
      fill(l,r);
    end;
    dec(q);
  until q=0;
  consistent(n,a);
end.
