{$A+,B-,D+,E+,F-,G-,I+,L+,N-,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}
const
  problem='expr';
  fin =problem+'.in';
  fout=problem+'.out';

var
  s:string;
  a:array [0..100,0..100,-500..500] of longint;
  min,max,b:array[0..100,0..100]of longint;
  i,j,k,l,n,m:longint;

procedure init;
begin
  assign(input,fin);
  reset(input);

    readln(s);

  close(input);
end;

function correct(l,r:longint):boolean;
var
  i,k:longint;
begin
  k:=0;
  for i:=l to r do
    if s[i] in['-','+'] then
      dec(k)
    else
      inc(k);
  correct:=k=1
end;

procedure process(l,r:longint);
var
  i,j,k,c:longint;
begin
  if b[l,r]=1 then
    exit;
  b[l,r]:=1;
  min[l,r]:=500;
  max[l,r]:=-500;
  if not correct(l,r) then begin
    min[l,r]:=1;
    max[l,r]:=0;
    exit;
  end;
  if l=r then begin
    a[l,r,ord(s[l])-ord('0')]:=1;
    min[l,r]:=ord(s[l])-ord('0');
    max[l,r]:=ord(s[l])-ord('0');
  end;
  if s[l]='+' then
    for k:=l+1 to r-1 do begin
      process(l+1,k);
      process(k+1,r);
      for i:=min[l+1,k] to max[l+1,k] do
        for j:=min[k+1,r] to max[k+1,r] do
          if (a[l+1,k,i]=1)and(a[k+1,r,j]=1) then begin
            c:=i+j;
            a[l,r,c]:=1;
            if c<min[l,r] then
              min[l,r]:=c;
            if c>max[l,r] then
              max[l,r]:=c;
          end;
    end;

  if s[l]='-' then
    for k:=l+1 to r-1 do begin
      process(l+1,k);
      process(k+1,r);
      for i:=min[l+1,k] to max[l+1,k] do
        for j:=min[k+1,r] to max[k+1,r] do
          if (a[l+1,k,i]=1)and(a[k+1,r,j]=1) then begin
            c:=i-j;
            a[l,r,c]:=1;
            if c<min[l,r] then
              min[l,r]:=c;
            if c>max[l,r] then
              max[l,r]:=c;
          end;
    end;

  if s[r]='+' then
    for k:=l+1 to r-1 do begin
      process(l,k-1);
      process(k,r-1);
      for i:=min[l,k-1] to max[l,k-1] do
        for j:=min[k,r-1] to max[k,r-1] do
          if (a[l,k-1,i]=1)and(a[k,r-1,j]=1) then begin
            c:=i+j;
            a[l,r,c]:=1;
            if c<min[l,r] then
              min[l,r]:=c;
            if c>max[l,r] then
              max[l,r]:=c;
          end;
    end;

  if s[r]='-' then
    for k:=l+1 to r-1 do begin
      process(l,k-1);
      process(k,r-1);
      for i:=min[l,k-1] to max[l,k-1] do
        for j:=min[k,r-1] to max[k,r-1] do
          if (a[l,k-1,i]=1)and(a[k,r-1,j]=1) then begin
            c:=i-j;
            a[l,r,c]:=1;
            if c<min[l,r] then
              min[l,r]:=c;
            if c>max[l,r] then
              max[l,r]:=c;
          end;
    end;

  for k:=l+1 to r+1 do begin
    if s[k]='+' then begin
      process(l,k-1);
      process(k+1,r);
      for i:=min[l,k-1] to max[l,k-1] do
        for j:=min[k+1,r] to max[k+1,r] do
          if (a[l,k-1,i]=1)and(a[k+1,r,j]=1) then begin
            c:=i+j;
            a[l,r,c]:=1;
            if c<min[l,r] then
              min[l,r]:=c;
            if c>max[l,r] then
              max[l,r]:=c;
          end;
    end;
    if s[k]='-' then begin
      process(l,k-1);
      process(k+1,r);
      for i:=min[l,k-1] to max[l,k-1] do
        for j:=min[k+1,r] to max[k+1,r] do
          if (a[l,k-1,i]=1)and(a[k+1,r,j]=1) then begin
            c:=i-j;
            a[l,r,c]:=1;
            if c<min[l,r] then
              min[l,r]:=c;
            if c>max[l,r] then
              max[l,r]:=c;
          end;
    end;
  end;

end;

procedure solve;
begin
  n:=length(s);
  process(1,n);
  k:=0;
  for i:=min[1,n] to max[1,n] do
    inc(k,a[1,n,i]);
end;

procedure done;
begin
  assign(output,fout);
  rewrite(output);

    write(k);

  close(output);
end;

begin
  init;
  solve;
  done;
end.
