{$A+,B-,D-,E-,F-,G-,I-,L-,N-,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}
  Const File_In='key.in';
        File_Out='key.out';
        MaxN=10000;
        MaxM=1000;
        MaxNM=250000;
        MaxRC=100;
  Type Int=LongInt;
  Var C,R : Int;
      M,N : Int;
      Key : Array [1..MaxRC,1..MaxRC] Of Boolean;
      Z,Use : Array [-MaxRC..MaxN+MaxRC,1..MaxM] Of Boolean;
      Queue : Array [1..MaxNM,1..2] Of Int;
      Len,Now : Int;
      Answer : Int;

Procedure OpenFiles;
Begin
  Assign(Input,File_In);
  ReSet(Input);
  Assign(Output,File_Out);
  ReWrite(Output);
End;

Function ReadSymbol : Char;
  Var Symbol : Char;
Begin
  Read(Symbol);
  While Not (Symbol In ['.','#']) Do Read(Symbol);
  ReadSymbol :=Symbol;
End;

Procedure Init;
  Var I,J : Int;
Begin
  Read(R,C);
  For I :=1 To R Do
    For J :=1 To C Do
      If ReadSymbol='#' Then Key[I,J] :=True
      Else Key[I,J] :=False;
  Read(N,M);
  For I :=1 To N Do
    For J :=1 To M Do
      If ReadSymbol='#' Then Z[I,J] :=False
      Else Z[I,J] :=True;
  For I :=-R+1 To 0 Do
    For J :=1 To M Do
      Z[I,J] :=True;
  For I :=N+1 To N+R Do
    For J :=1 To M Do
      Z[I,J] :=True;
  For I :=1 To N+R Do
    For J :=1 To M Do
      Use[I,J] :=False;
End;

Procedure MakeAnswer;
  Var I,J : Int;
      X,Y : Int;
      Ok : Boolean;
Begin
  While Now<=Len Do
    Begin
      X :=Queue[Now,1];
      Y :=Queue[Now,2];
      If (Y>C) And Not Use[X,Y-1] Then
        Begin
          Ok :=True;
          For I :=X-R+1 To X Do
            Begin
              For J :=Y-C To Y-1 Do
                Begin
                  Ok :=Ok And (Z[I,J] Or Not Key[I-X+R,J-Y+C+1]);
                  If Not Ok Then Break;
                End;
              If Not Ok Then Break;
            End;
          Use[X,Y-1] :=True;
          If Ok Then
            Begin
              Inc(Len);
              Queue[Len,1] :=X;
              Queue[Len,2] :=Y-1;
            End
        End;
      If (Y<M) And Not Use[X,Y+1] Then
        Begin
          Ok :=True;
          For I :=X-R+1 To X Do
            Begin
              For J :=Y-C+2 To Y+1 Do
                Begin
                  Ok :=Ok And (Z[I,J] Or Not Key[I-X+R,J-Y+C-1]);
                  If Not Ok Then Break;
                End;
              If Not Ok Then Break;
            End;
          Use[X,Y+1] :=True;
          If Ok Then
            Begin
              Inc(Len);
              Queue[Len,1] :=X;
              Queue[Len,2] :=Y+1;
            End
        End;
      If (X<N+R) And Not Use[X+1,Y] Then
        Begin
          Ok :=True;
          For I :=X-R+2 To X+1 Do
            Begin
              For J :=Y-C+1 To Y Do
                Begin
                  Ok :=Ok And (Z[I,J] Or Not Key[I-X+R-1,J-Y+C]);
                  If Not Ok Then Break;
                End;
              If Not Ok Then Break;
            End;
          Use[X+1,Y] :=True;
          If Ok Then
            Begin
              Inc(Len);
              Queue[Len,1] :=X+1;
              Queue[Len,2] :=Y;
              If X+1>Answer Then Answer :=X+1;
            End
        End;
      Inc(Now);
      If Answer=N+R Then Exit;
    End;
End;

Procedure Solve;
  Var I,J : Int;
      Ok : Boolean;
Begin
  Len :=0;
  Now :=1;
  Answer :=0;
  For I :=C To M Do
    Begin
      Ok :=True;
      For J :=I-C+1 To I Do
        Ok :=Ok And (Z[1,J] Or Not Key[R,J-I+C]);
      If Ok Then
        Begin
          Inc(Len);
          Answer :=1;
          Queue[Len,1] :=1;
          Queue[Len,2] :=I;
          Use[1,I] :=True;
        End;
    End;
  MakeAnswer;
  If Answer=N+R Then Answer :=-1;
  WriteLn(Answer);
End;

Procedure CloseFiles;
Begin
  Close(Input);
  Close(Output);
End;

Begin
  OpenFiles;
  Init;
  Solve;
  CloseFiles;
End.
