{$A+,B-,D+,E+,F-,G-,I+,L+,N-,O-,P-,Q+,R+,S+,T-,V+,X+,Y+}
  Const File_In='tractor.in';
        File_Out='tractor.out';
  Type Int=LongInt;
       Real=Extended;
       TPoint=Record X,Y : Int; End;
  Var N : Int;
      V,U : Real;
      P : Array [1..50] Of TPoint;
      T : Array [1..50] Of Real;

Procedure OpenFiles;
Begin
  Assign(Input,File_In);
  ReSet(Input);
  Assign(Output,File_Out);
  ReWrite(Output);
End;

Procedure Init;
  Var I : Int;
Begin
  Read(N,U,V);
  Inc(N);
  For I :=1 To N Do
    Read(P[I].X,P[I].Y);
End;

Function Skal(Const X1,Y1,X2,Y2 : Real) : Real;
Begin
  Skal :=X1*X2+Y1*Y2;
End;

Function Vect(Const X1,Y1,X2,Y2 : Real) : Real;
Begin
  Vect :=X1*Y2-Y1*X2;
End;

Function DistToLine(Const A,B,P : TPoint) : real;
Begin
  DistToLine :=Vect(P.X-A.X,P.Y-A.Y,B.X-A.X,B.Y-A.Y)/Sqrt(Sqr(A.X-B.X)+Sqr(A.Y-B.Y))
End;

Procedure Solve;
  Var I,J : Int;
      L : Real;
Begin
  T[1] :=0;
  For I :=2 To N Do
    Begin
      T[I] :=T[I-1]+Sqrt(Sqr(P[I].X-P[I-1].X)+Sqr(P[I].Y-P[I-1].Y))/V;
      For J :=1 To I-2 Do
        Begin
          L :=Sqrt(Sqr(P[I].X-P[J].X)+Sqr(P[I].Y-P[J].Y));
          If T[I]>T[J]+L/U Then
            T[I] :=T[J]+L/U;
          If J>1 Then
            If (Skal(P[J].X-P[J-1].X,P[J].Y-P[J-1].Y,P[I].X-P[J-1].X,P[I].Y-P[J-1].Y)>0) And
               (Skal(P[J-1].X-P[J].X,P[J-1].Y-P[J].Y,P[I].X-P[J].X,P[I].Y-P[J].Y)>0) Then
                 If DistToLine(P[J],P[J-1],P[I])/U+Sqrt(Sqr(L)-Sqr(DistToLine(P[J],P[J-1],P[I])))/V<T[I] Then
                   T[I] :=DistToLine(P[J],P[J-1],P[I])/U+Sqrt(Sqr(L)-Sqr(DistToLine(P[J],P[J-1],P[I])))/V
        End;
    End;
  WriteLn(T[N]:0:4);
End;

Procedure CloseFiles;
Begin
  Close(Input);
  Close(Output);
End;

Begin
  OpenFiles;
  Init;
  Solve;
  CloseFiles;
End.
