{$A+,B-,D-,E+,F-,G-,I-,L-,N-,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}
  Const File_In='network.in';
        File_Out='network.out';
        MaxN=100;
        Infinity=MaxLongInt Div 2;
  Type Int=LongInt;
  Var K,L,M,N : Int;
      D : Array [1..MaxN] Of Int;
      D2 : Array [1..MaxN,0..MaxN] Of Int;
      D3 : Array [1..MaxN,1..MaxN,1..MaxN] Of Int;
      Ans,DAns : Array [1..MaxN,0..MaxN,0..MaxN] Of Int;
      Nums : Array [0..MaxN] Of Int;
      Answer,NumAns,AnsH : Int;

Procedure OpenFiles;
Begin
  Assign(Input,File_In);
  ReSet(Input);
  Assign(Output,File_Out);
  ReWrite(Output);
End;

Procedure Init;
  Var I : Int;
Begin
  Read(N,L,K,M);
  For I :=1 To N Do
    Read(D[I]);
End;

Function Min(Const A,B : Int) : Int;
Begin
  If A<B Then Min :=A
  Else Min :=B;
End;

Function GetSolve(Const Num : Int) : Int;
  Var MinL : Int;
      I,J,L,Help,HelpI : Int;
Begin
  FillChar(Ans,SizeOf(Ans),0);
  Nums[0] :=0;
  For I :=Num To N Do
    Begin
      Inc(Nums[0]);
      Nums[Nums[0]] :=I;
    End;
  For I :=1 To Num-1 Do
    Begin
      Inc(Nums[0]);
      Nums[Nums[0]] :=I;
    End;
  Ans[1,1,1] :=D2[Nums[1],0];
  For I :=2 To N Do
    Begin
      HelpI :=Min(I,K);
      For J :=1 To M Do
        Begin
          For L :=1 To HelpI Do
            If I=L Then
              Begin
                Help :=Nums[(2*I-L+1) Div 2];
                Ans[I,J,L] :=D3[Help,Nums[I-L+1],Nums[I]]+D2[Help,0];
                DAns[I,J,L] :=Nums[Help];
                If (L>1) And (Ans[I,J,L-1]>0) And (Ans[I,J,L-1]<Ans[I,J,L]) Then
                  Begin
                    Ans[I,J,L] :=Ans[I,J,L-1];
                    DAns[I,J,L] :=DAns[I,J,L-1];
                  End;
              End
            Else
              Begin
                Help :=Nums[(2*I-L+1) Div 2];
                Ans[I,J,L] :=Ans[I-L,J-1,M];
                If J>1 Then Inc(Ans[I,J,L],D2[Nums[Help],DAns[I-L,J-1,M]]);
                DAns[I,J,L] :=Help;
                If (L>1) And (Ans[I,J,L-1]<Ans[I,J,L]) Then
                  Begin
                    Ans[I,J,L] :=Ans[I,J,L-1];
                    DAns[I,J,L] :=DAns[I,J,L-1];
                  End;
              End;
          For L :=HelpI+1 To K Do
            Begin
              Ans[I,J,L] :=Ans[I,J,L-1];
              DAns[I,J,L] :=DAns[I,J,L-1];
            End;
        End;
    End;
  MinL :=Infinity;
  For I :=1 To M Do
    If (Ans[Nums[N],I,K]>0) And (MinL>Ans[Nums[N],I,K]) Then
      Begin
        MinL :=Ans[Nums[N],I,K];
        AnsH :=I;
      End;
  GetSolve :=MinL;
End;

Procedure WriteAnswer(J,L : Int);
  Var K2,K3 : Int;
Begin
  If L=0 Then Exit;
  For K2 :=1 To K Do
    If Ans[J,L,K2]=Answer Then
      Begin
        WriteAnswer(J-K2,L-1);
        Write(D[DAns[J,L,K2]],' ',L-1);
        For K3 :=J-K2+1 To J Do Write(' ',Nums[K3]);
        WriteLn;
        Break;
      End;
End;

Procedure Solve;
  Var I,J,K2 : Int;
      MinL : Int;
Begin
  If N>(K-1)*M+1 Then
    Begin
      WriteLn('-1');
      Exit;
  End;
  FillChar(D2,SizeOf(D2),0);
  FillChar(D3,SizeOf(D3),0);
  For I :=1 To N Do
    D2[I,0] :=Min(D[I],L-D[I]);
  For I :=1 To N Do
    For J :=I+1 To N Do
      Begin
        D2[I,J] :=Min(D[J]-D[I],D[I]+L-D[J]);
        D2[J,I] :=D2[I,J];
        D3[I,J,J] := D2[I,J];
      End;
  For I :=1 To N Do
    For J :=1 To N Do
      Begin
        For K2 :=J-1 DownTo 1 Do
          D3[I,J,K2] :=D3[I,J,K2+1]+D2[I,K2];
        For K2 :=J+1 To N Do
          D3[I,J,K2] :=D3[I,J,K2-1]+D2[I,K2];
      End;
  Answer :=Infinity;
  For I :=1 To N Do
    Begin
      MinL :=GetSolve(I);
      If MinL<Answer Then
        Begin
          Answer :=MinL;
          NumAns :=I;
        End;
    End;
  GetSolve(NumAns);
  WriteLn(AnsH);
  WriteAnswer(Nums[N],AnsH);
End;

Procedure CloseFiles;
Begin
  Close(Input);
  Close(Output);
End;

Begin
  OpenFiles;
  Init;
  Solve;
  CloseFiles;
End.
