{$A+,B-,D-,E+,F-,G-,I-,L-,N-,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}
  Const File_In='filya.in';
        File_Out='filya.out';
        N=41;
        M=45;
  Type Int=LongInt;
       DType=Array [1..N,1..M] Of Int;
  Var Map,MapToUse,Num : Array [0..N+1,0..M+1] Of Int;
      HelpUse : Array [1..N,1..M] Of Boolean;
      DMy,DEnemy : DType;
      Answer,AnswerColor,CntAns : Int;
      CntNums : Int;
      HelpD : Array [1..N*M] Of Int;
      Queue : Array [1..N*M,1..2] Of Int;
      R : Array [1..N*M,1..N*M] Of Boolean;
      Use : Array [1..N*M] Of Boolean;

Procedure OpenFiles;
Begin
  Assign(Input,File_In);
  ReSet(Input);
  Assign(Output,File_Out);
  ReWrite(Output);
End;

Function ReadSym : Char;
  Var Symbol : Char;
Begin
  Read(Symbol);
  While Not (Symbol In ['1'..'6']) Do Read(Symbol);
  ReadSym :=Symbol;
End;

Procedure Init;
  Var I,J : Int;
Begin
  FillChar(Map,SizeOf(Map),0);
  For I :=1 To N Do
    For J :=1 To M Do
      Map[I,J] :=Ord(ReadSym)-Ord('0');
End;

Procedure MakeD(Const FirstI,FirstJ : Int; Var D : DType);
  Var Now,Len : Int;
      I,J : Int;

Procedure Count(I,J,Color : Int);
Begin
  If (MapToUse[I,J]<>Color) Or (Num[I,J]>0) Then Exit;
  Num[I,J] :=CntNums;
  Count(I,J+1,Color);
  Count(I,J-1,Color);
  Count(I+1,J,Color);
  Count(I-1,J,Color);
End;

Procedure AddEdge(Const I,J,I2,J2 : Int);
Begin
  If MapToUse[I2,J2]=0 Then Exit;
  R[Num[I,J],Num[I2,J2]] :=True;
End;

Begin
  FillChar(D,SizeOf(D),255);
  FillChar(HelpD,SizeOf(HelpD),255);
  FilLChar(R,SizeOf(R),0);
  FillChar(Num,SizeOf(Num),0);
  FillChar(Use,SizeOf(Use),0);
  CntNums :=0;
  For I :=1 To N Do
    For J :=1 To M Do
      If Num[I,J]=0 Then
        Begin
          Inc(CntNums);
          Count(I,J,MapToUse[I,J]);
        End;
  For I :=1 To N Do
    For J :=1 To M Do
      Begin
        AddEdge(I,J,I+1,J);
        AddEdge(I,J,I,J+1);
        AddEdge(I,J,I-1,J);
        AddEdge(I,J,I,J-1);
      End;
  Len :=1;
  Now :=1;
  Queue[1,1] :=Num[FirstI,FirstJ];
  Queue[1,2] :=0;
  HelpD[Num[FirstI,FirstJ]] :=0;
  Use[Num[FirstI,FirstJ]] :=True;
  While Now<=Len Do
    Begin
      For I :=1 To CntNums Do
        If R[Queue[Now,1],I] And Not Use[I] Then
          Begin
            Use[I] :=True;
            Inc(Len);
            Queue[Len,1] :=I;
            Queue[Len,2] :=Queue[Now,2]+1;
            HelpD[I] :=Queue[Len,2];
          End;
      Inc(Now);
    End;
  For I :=1 To N Do
    For J :=1 To M Do
      D[I,J] :=HelpD[Num[I,J]];
//  WriteLn(D[FirstI,FirstJ]);
End;

Procedure Check(Const Color : Int);
  Var I,J : Int;
      Cnt,Count : Int;

Procedure Paint(I,J : Int);
Begin
  If MapToUse[I,J]<>Map[1,1] Then Exit;
  MapToUse[I,J] :=Color;
  Paint(I,J+1);
  Paint(I,J-1);
  Paint(I+1,J);
  Paint(I-1,J);
End;

Procedure GetCnt(I,J : Int);
Begin
  If (MapToUse[I,J]<>MapToUse[1,1]) Or (HelpUse[I,J]) Then Exit;
  HelpUse[I,J] :=True;
  Inc(Cnt);
  GetCnt(I,J+1);
  GetCnt(I,J-1);
  GetCnt(I+1,J);
  GetCnt(I-1,J);
End;

Begin
  FillChar(HelpUse,SizeOf(HelpUse),0);
  MapToUse :=Map;
  Cnt :=0;
  Count :=0;
  Paint(1,1);
  GetCnt(1,1);
  MakeD(1,1,DMy);
  MakeD(N,M,DEnemy);
  For I :=1 To N Do
    For J :=1 To M Do
      If DMy[I,J]<DEnemy[I,J] Then
        Inc(Count);
  If (Count>Answer) Or ((Count=Answer) And (CntAns<Cnt)) Then
    Begin
      Answer :=Count;
      CntAns :=Cnt;
      AnswerColor :=Color;
    End;
End;

Procedure Solve;
  Var I : Int;
Begin
  Answer :=0;
  For I :=1 To 6 Do
    If (I<>Map[1,1]) And (I<>Map[N,M]) Then
      Check(I);
  WriteLn(AnswerColor);
End;

Procedure CloseFiles;
Begin
  Close(Input);
  Close(Output);
End;

Begin
  OpenFiles;
  Init;
  Solve;
  CloseFiles;
End.
