{$A+,B-,D+,E+,F-,G-,I+,L+,N-,O-,P-,Q+,R+,S+,T-,V+,X+,Y+}
  Const File_In='x0.in';
        File_Out='x0.out';
  Type Int=LongInt;
       TSymbol=Record
                 S : Array [1..40,-1..40] Of Char;
                 N,M : Int;
               End;
  Var S : TSymbol;

Procedure OpenFiles;
Begin
  Assign(Input,File_In);
  ReSet(Input);
  Assign(Output,File_Out);
  ReWrite(Output);
End;

Function Max(Const A,B : Int) : Int;
Begin
  If A>B Then Max :=A
  Else Max :=B;
End;

Procedure Solve;
  Var Ok,Ok1,Ok2 : Boolean;
      Cnt : Array [1..40] Of Int;
      F,L : Array [0..31] Of Int;
      I,J : Int;
Begin
  FillChar(Cnt,SizeOf(Cnt),0);
  FillChar(L,SizeOf(L),0);
  FillChar(F,SizeOf(F),0);
  For I :=1 To S.N Do
    For J :=1 To S.M Do
      If (S.S[I,J]='*') And (S.S[I,J]<>S.S[I,J-1]) Then Inc(Cnt[I]);
  For I :=1 To S.N Do
    F[I] :=Max(F[I-1],Cnt[I]);
  For I :=S.N DownTo 1 Do
    L[I] :=Max(L[I+1],Cnt[I]);
  Ok :=True;
  For I :=1 To S.N Do
    If (Cnt[I]<F[I-1]) And (Cnt[I]<L[I+1]) Then Ok :=False;
  Ok1 :=False;
  Ok2 :=False;
  For I :=1 To S.N Do
    Begin
      If I>1 Then Ok1 :=Ok1 Or ((F[I-1]=0) And (F[I]=1));
      If I<S.N Then Ok2 :=Ok2 Or ((F[I+1]=0) And (F[I]=1));
    End;
  If Not Ok Then Begin WriteLn('X'); Exit; End;
  If Ok1 And Ok2 Then
    Begin
     WriteLn('0');
     Exit;
    End;
  For I :=1 To S.N Do
    For J :=1 To S.M Do
      If (S.S[I,J]='*') And (S.S[I,J]<>S.S[I,J-1]) And (S.S[I,J]<>S.S[I,J-2]) Then Inc(Cnt[I]);
  For I :=1 To S.N Do
    F[I] :=Max(F[I-1],Cnt[I]);
  For I :=S.N DownTo 1 Do
    L[I] :=Max(L[I+1],Cnt[I]);
  Ok :=True;
  For I :=1 To S.N Do
    If (Cnt[I]<F[I-1]) And (Cnt[I]<L[I+1]) Then Ok :=False;
  If Ok Then WriteLn('0')
  Else WriteLn('X');
End;

Function NextSym : Char;
  Var Symbol : Char;
Begin
  Read(Symbol);
  While Not (Symbol In ['.','*','#','-']) Do Read(Symbol);
  NextSym :=Symbol;
End;

Procedure Init;
  Var Sym : Char;
      I : Int;
Begin
  FIllChar(S,SizeOf(S),'.');
  Read(Sym);
  While Sym<>'#' Do
    Begin
      S.N :=1;
      S.M :=1;
      S.S[1,1] :=Sym;
      While Not EoLn Do
        Begin
          Inc(S.M);
          Read(S.S[1,S.M]);
        End;
      Sym :=NextSym;
      While Not (Sym In ['-','#']) Do
        Begin
          Inc(S.N);
          S.S[S.N,1] :=Sym;
          For I :=2 To S.M Do
            Read(S.S[S.N,I]);
          Sym :=NextSym;
        End;
      Solve;
      If Sym='#' Then Break;
      Sym :=NextSym;
    End;
End;

Procedure CloseFiles;
Begin
  Close(Input);
  Close(Output);
End;

Begin
  OpenFiles;
  Init;
  CloseFiles;
End.
