{$A+,B-,D-,E+,F-,G-,I-,L-,N-,O+,P-,Q-,R-,S-,T-,V+,X+,Y+}
  Const File_In='triples.in';
        File_Out='triples.out';
        MaxN=100000;
        MaxP=1500;
  Type Int=LongInt;
  Var N,P : Int;
      A,O : Array [1..MaxN] Of Int;
      Cnt : Array [-1..MaxP-1] Of Int;
      Cicles,Per,PredP : Array [0..MaxP-1,-1..MaxP] Of Int;
      Use : Array [0..MaxP-1] Of Boolean;
      C : Array [0..MaxN,0..3] Of Int64;
      Answer : Int64;

Procedure OpenFiles;
Begin
  Assign(Input,File_In);
  ReSet(Input);
  Assign(Output,File_Out);
  ReWrite(Output);
End;

Procedure Init;
  Var I : Int;
Begin
  Read(N,P);
  For I :=1 To N Do
    Read(A[I]);
End;

Procedure Solve;
  Var I,J : Int;
      A1,A2,A3 : Int;
Begin
  FIllChar(Cnt,SizeOf(Cnt),0);
  FillChar(C,SizeOf(C),0);
  For I :=1 To N Do
    C[I,0] :=1;
  C[1,1] :=1;
  C[2,1] :=2;
  C[2,2] :=1;
  For I :=3 To N Do
    For J :=1 To 3 Do
      C[I,J] :=C[I-1,J-1]+C[I,J-1];
  For I :=1 To N Do
    O[I] :=A[I] Mod P;
  For I :=1 To N Do
    Inc(Cnt[O[I]]);
  For I :=0 To P-1 Do
    Begin
      FillChar(Use,SizeOf(Use),0);
      Use[I] :=True;
      Cicles[I,-1] :=1;
      Cicles[I,0] :=1;
      Cicles[I,1] :=I;
      While Not Use[(Cicles[I,Cicles[I,-1]]*I) Mod P] Do
        Begin
          Inc(Cicles[I,-1]);
          Cicles[I,Cicles[I,-1]] :=(Cicles[I,Cicles[I,-1]-1]*I) Mod P;
          Use[Cicles[I,Cicles[I,-1]]] :=True;
        End;
      PredP[I,-1] :=0;
      PredP[I,0] :=1;
      While ((PredP[I,PredP[I,-1]]*I) Mod P)<>((Cicles[I,Cicles[I,-1]]*I) Mod P) Do
        Begin
          Inc(PredP[I,-1]);
          PredP[I,PredP[I,-1]] :=(PredP[I,PredP[I,-1]-1]*I) Mod P;
        End;
      Per[I,-1] :=0;
      Per[I,0] :=(Cicles[I,Cicles[I,-1]]*I) Mod P;
      While (Per[I,Per[I,-1]]*I) Mod P<>Per[I,0] Do
        Begin
          Inc(Per[I,-1]);
          Per[I,Per[I,-1]] :=(Per[I,Per[I,-1]-1]*I) Mod P;
        End;
      Inc(Per[I,-1]);
    End;
  Answer :=0;
  For I :=0 To P-1 Do
    Begin
      For J :=1 To N Do
        Begin
          If A[J]<=PredP[I,-1] Then A3 :=PredP[I,A[J]]
          Else A3 :=Per[I,(A[J]-PredP[I,-1]) Mod Per[I,-1]];
          If I<>O[J] Then
            If I<>A3 Then
              If O[J]<>A3 Then
                Inc(Answer,C[Cnt[I],1]*C[Cnt[A3],1])
              Else
                Inc(Answer,C[Cnt[I],1]*C[Cnt[A3]-1,1])
            Else
              Inc(Answer,C[Cnt[I],2]*2)
          Else If (O[J]=A3) Then
                 Inc(Answer,C[Cnt[I]-1,2]*2)
               Else
                 Inc(Answer,C[Cnt[I]-1,1]*C[Cnt[A3],1])
        End;
    End;
  WriteLn(Answer);
End;

Procedure CloseFiles;
Begin
  Close(Input);
  Close(Output);
End;

Begin
  OpenFiles;
  Init;
  Solve;
  CloseFiles;
End.
