{$A+,B-,D-,E+,F-,G-,I-,L-,N-,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}
  Const File_In='rhyme.in';
        File_Out='rhyme.out';
        MaxN=50;
        MaxK=50;
  Type Int=LongInt;
  Var N,M,K : Int;
      S,T : Int;
      R,F : Array [1..MaxN,1..MaxN,1..MaxK] Of Int;
      Can : Array [1..2,1..MaxN,1..MaxK] Of Boolean;
      Use : Array [1..MaxN] Of Boolean;
      From : Array [1..MaxN,1..2] Of Int;
      CntAns : Int;

Procedure OpenFiles;
Begin
  Assign(Input,File_In);
  ReSet(Input);
  Assign(Output,File_Out);
  ReWrite(Output);
End;

Procedure Init;
  Var I : Int;
      V1,V2,C : Int;
Begin
  FillChar(R,SizeOf(R),0);
  FillChar(F,SizeOf(F),0);
  Read(N,K,S,T,M);
  For I :=1 To M Do
    Begin
      Read(V1,V2,C);
      R[V1,V2,C] :=1;
    End;
End;

Function Find(I : Int) : Boolean;
  Var J,Help,Color : Int;
Begin
  Use[I] :=True;
  If I=T Then
    Begin
      Find :=True;
      Exit;
    End;
  For J :=1 To N Do
    If Not Use[J] Then
       For Color :=1 To K Do
        If R[I,J,Color]-F[I,J,Color]>0 Then
          Begin
            If Find(J) Then
              Begin
                For Help :=1 To N Do
                  If (R[I,Help,Color]>0) Or (F[I,Help,Color]<>0) Then
                    Begin
                      F[I,Help,Color] :=F[I,Help,Color]+1;
                      F[Help,I,Color] :=-F[I,Help,Color];
                   End;
                For Help :=1 To N Do
                  If (R[Help,J,Color]>0) Or (F[Help,J,Color]<>0) Then
                    Begin
                      F[Help,J,Color] :=F[Help,J,Color]+1;
                      F[J,Help,Color] :=-F[Help,J,Color];
                   End;
                Find :=True;
                Exit;
              End;
          End;
  Find :=False;
End;

Procedure WriteAns(I : Int);
Begin
  If From[I,1]<>0 Then
    WriteAns(From[I,1]);
  Write(I,' ',From[I,2],' ')
End;

Function FindAns(I : Int) : Boolean;
  Var J,Help,C : Int;
Begin
  If I=T Then
    Begin
      FindAns :=True;
      Exit;
    End;
  Use[I] :=True;
  For J :=1 To N Do
    For C :=1 To K Do
      If (R[I,J,C]>0) And (F[I,J,C]>0) Then
        Begin
          If FindAns(J) Then
            Begin
                For Help :=1 To N Do
                  If (R[I,Help,C]>0) Or (F[I,Help,C]<>0) Then
                    Begin
                      F[I,Help,C] :=0;
                      F[Help,I,C] :=0;
                   End;
                For Help :=1 To N Do
                  If (R[Help,J,C]>0) Or (F[Help,J,C]<>0) Then
                    Begin
                      F[Help,J,C] :=0;
                      F[J,Help,C] :=0;
                   End;
{              F[I,J,C] :=0;
              F[J,I,C] :=0;}
              From[J,1] :=I;
              From[I,2] :=C;
              FindAns :=True;
              Exit;
            End;
        End;
  FindAns :=False;
End;

Procedure Solve;
  Var I : Int;
Begin
  FillChar(Can,SizeOf(Can),True);
  CntAns :=0;
  While True Do
    Begin
      FillChar(Use,SizeOf(Use),0);
      If Not Find(S) Then Break
      Else Inc(CntAns);
    End;
  WriteLn(CntAns);
  For I :=1 To CntAns Do
    Begin
      FillChar(Use,SizeOf(Use),0);
      FillChar(From,SizeOf(From),0);
      FindAns(S);
      WriteAns(From[T,1]);
      WriteLn(T);
    End;
End;

Procedure CloseFiles;
Begin
  Close(Input);
  Close(Output);
End;

Begin
  OpenFiles;
  Init;
  Solve;
  CloseFiles;
End.
