{$A+,B-,D-,E+,F-,G-,I-,L-,N-,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}
  Const File_In='king.in';
        File_Out='king.out';
        MaxN=501;
  Type Int=LongInt;
       TMas=Array [-1..MaxN+3] Of Int;
       TNum=Array [0..MaxN+3] Of Int;
  Var X,Y,X2,Y2 : TMas;
      InNumX,InNumY,NumX,NumY,NumX2,NumY2 : TNum;
      Map : Array [0..MaxN+3,0..MaxN+3] Of Int64;
      Bad : Array [0..MaxN+3,0..MaxN+3] Of Boolean;
      Queue : Array [1..(MaxN+4)*(MaxN+4),1..2] Of Int;
      N : Int;
      Len,Now : Int;

Procedure OpenFiles;
Begin
  Assign(Input,File_In);
  ReSet(Input);
  Assign(Output,File_Out);
  ReWrite(Output);
End;

Procedure Init;
  Var I : Int;
Begin
  Read(X[1],Y[1],X[2],Y[2]);
  Read(N);
  For I :=3 To N+2 Do
    Read(X[I],Y[I]);
End;

Procedure Swap(Var A,B : Int);
  Var C : Int;
Begin
  C :=A;
  A :=B;
  B :=C;
End;

Function Min(Const A,B : Int) : Int;
Begin
  If A<B Then Min :=A
  Else Min :=B;
End;

Function Max(Const A,B : Int) : Int;
Begin
  If A<B Then Max :=A
  Else Max :=B;
End;

Procedure QSort(Var A : TMas; Var Num : TNum; Const L,R : Int);

Procedure Sort(L,R : Int);
  Var I,J,X : Int;
Begin
  I :=L;
  J :=R;
  X :=A[Num[(L+R) Div 2]];
  Repeat
    While A[Num[I]]<X Do Inc(I);
    While A[Num[J]]>X Do Dec(J);
    If I<=J Then
      Begin
        Swap(Num[I],Num[J]);
        Inc(I);
        Dec(J);
      End;
  Until I>J;
  If I<R Then Sort(I,R);
  If J>L Then Sort(L,J);
End;

Begin
  Sort(L,R);
End;

Procedure Add(Const I,J : Int; Const Sum : Int64);
Begin
  If Not Bad[I,J] And (Map[I,J]=-1) Then
    Begin
      Map[I,J] :=Sum;
      Inc(Len);
      Queue[Len,1] :=I;
      Queue[Len,2] :=J;
    End;
End;

Procedure TryAdd(Const I,J : Int; Const Sum : Int64);

Procedure Diag(Const DX,DY : Int);
  Var I2,J2 : Int;
Begin
  I2 :=I+DX;
  J2 :=J+DY;
  While (I2>=0) And (I2<=X2[-1]) And (J2>=0) And (J2<=Y2[-1]) Do
    Begin
      If (Map[I2,J2]<>-1) Or Bad[I2,J2] Then Exit;
      If Abs(X2[I2]-X2[I])=Abs(Y2[J2]-Y2[J]) Then
        Begin
          Add(I2,J2,Sum+Abs(X2[I2]-X2[I]));
          Exit;
        End;
      Add(I2,J2,Max(Abs(X2[I2]-X2[I]),Abs(Y2[J2]-Y2[J])));
      If Abs(X2[I2]-X2[I])<Abs(Y2[J2]-Y2[J]) Then Inc(I2,DX)
      Else Inc(J2,DY);
    End;
End;

Begin
  If I>0 Then Add(I-1,J,Sum+Int64(Abs(X2[I]-X2[I-1])));
  If I<X2[-1] Then Add(I+1,J,Sum+Int64(Abs(X2[I]-X2[I+1])));
  If J>0 Then Add(I,J-1,Sum+Int64(Abs(Y2[J]-Y2[J-1])));
  If J<Y2[-1] Then Add(I,J+1,Sum+Int64(Abs(Y2[J]-Y2[J+1])));
  Diag(1,1);
  Diag(1,-1);
  Diag(-1,1);
  Diag(-1,-1);
End;

Procedure Solve;
  Var I,J : Int;
Begin
  FillChar(Map,SizeOf(Map),255);
  FillChar(bad,SizeOf(Bad),0);
  For I :=1 To N+2 Do
    NumX[I] :=I;
  For I :=1 To N+2 Do
    NumY[I] :=I;
  QSort(X,NumX,1,N+2);
  QSort(Y,NumY,1,N+2);
  X[0] :=X[NumX[1]]-1;
  NumX[0] :=0;
  X[N+3] :=X[NumX[N+2]]+1;
  NumX[N+3] :=N+3;
  Y[0] :=Y[NumY[1]]-1;
  NumY[0] :=0;
  Y[N+3] :=Y[NumY[N+2]]+1;
  NumY[N+3] :=N+3;
  X2[-1] :=0;
  X2[0] :=X[NumX[0]];
  NumX2[0] :=0;
  For I :=1 To N+3 Do
    Begin
      If X[NumX[I]]<>X[NumX[I-1]] Then
        Begin
          Inc(X2[-1]);
          X2[X2[-1]] :=X[NumX[I]];
        End;
      NumX2[I] :=X2[-1];
    End;
  Y2[-1] :=0;
  Y2[0] :=Y[0];
  NumY2[0] :=0;
  For I :=1 To N+3 Do
    Begin
      If Y[NumY[I]]<>Y[NumY[I-1]] Then
        Begin
          Inc(Y2[-1]);
          Y2[Y2[-1]] :=Y[NumY[I]];
        End;
      NumY2[I] :=Y2[-1];
    End;
  For I :=0 To N+3 Do
    InNumX[NumX[I]] :=I;
  For I :=0 To N+3 Do
    InNumY[NumY[I]] :=I;
  For I :=3 To N+2 Do
    Bad[NumX2[InNumX[I]],NumY2[InNumY[I]]] :=True;
  Len :=1;
  Now :=1;
  For I :=0 To X2[-1] Do
    For J :=0 To Y2[-1] Do
      If (X2[I]=X[1]) And (Y2[J]=Y[1]) Then
        Begin
          Map[I,J] :=0;
          Queue[1,1] :=I;
          Queue[1,2] :=J;
        End;
  While Now<=Len Do
    Begin
      TryAdd(Queue[Now,1],Queue[Now,2],Map[Queue[Now,1],Queue[Now,2]]);
      Inc(Now);
    End;
  For I :=0 To X2[-1] Do
    For J :=0 To Y2[-1] Do
      If (X2[I]=X[2]) And (Y2[J]=Y[2]) Then
        WriteLn(Map[I,J]);
End;

Procedure CloseFiles;
Begin
  Close(Input);
  Close(Output);
End;

Begin
  OpenFiles;
  Init;
  Solve;
  CloseFiles;
End.
