{$A+,B-,D-,E+,F-,G-,I+,L-,N-,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}
  Const File_In='pursuit.in';
        File_Out='pursuit.out';
        MaxM=10001;
        MaxN=301;
  Type Int=LongInt;
       TDist=Array [1..MaxN] Of Int;
  Var N,M,K,S,T : Int;
      R,RHelp : Array [1..MaxM*2,1..3] Of Int;
      F : Array [1..MaxN+1] Of Int;
      DistP,Dist1,DistB : TDist;
      Use : Array [1..MaxN,1..MaxN] Of Boolean;

Procedure OpenFiles;
Begin
  Assign(Input,File_In);
  ReSet(Input);
  Assign(Output,File_Out);
  ReWrite(Output);
End;

Procedure MakeEdges;
  Var I : Int;
Begin
  FillChar(F,SizeOf(F),0);
  RHelp :=R;
  For I :=1 To M Do
    Inc(F[R[I,1]]);
  Inc(F[1]);
  For I :=2 To N+1 Do
    Inc(F[I],F[I-1]);
  For I :=1 To M Do
    Begin
      Dec(F[RHelp[I,1]]);
      R[F[RHelp[I,1]]] :=RHelp[I];
    End;
End;

Procedure Init;
  Var I : Int;
Begin
  Read(N,M,K);
  For I :=1 To M Do
    Begin
      Read(R[I,1],R[I,2],R[I,3]);
      R[I+M,1] :=R[I,2]; R[I+M,2] :=R[I,1]; R[I+M,3] :=R[I,3];
    End;
  Read(S,T);
  M :=M*2;
  MakeEdges;
End;

Function MakeMovePolice : Int;
  Var Queue : Array [1..MaxN+1,1..2] Of Int;
      Use : Array [1..MaxN] Of Boolean;
      I,Now,Len : Int;
Begin
  FillChar(Use,SizeOf(Use),0);
  FillChar(Queue,SizeOf(Queue),0);
  Queue[1,1] :=S;
  Use[S] :=True;
  Now :=1;
  Len :=1;
  While Now<=Len Do
    Begin
      If Queue[Now,1]=T Then Break;
      For I :=F[Queue[Now,1]] To F[Queue[Now,1]+1]-1 Do
        If Not Use[R[I,2]] Then
          Begin
            Use[R[I,2]] :=True;
            Inc(Len);
            Queue[Len,1] :=R[I,2];
            Queue[Len,2] :=Queue[Now,2];
            If Queue[Len,2]=0 Then Queue[Len,2] :=I;
          End;
      Inc(Now);
    End;
  If Queue[Now,1]=T Then
    MakeMovePolice :=Queue[Now,2]
  Else MakeMovePolice :=0;
End;

Function MakeMoveBandit : Int;
  Var Queue : Array [1..MaxN+1,1..2] Of Int;
      Use : Array [1..MaxN] Of Boolean;
      I,Now,Len : Int;
Begin
  FillChar(Use,SizeOf(Use),0);
  FillChar(Queue,SizeOf(Queue),0);
  Queue[1,1] :=T;
  Use[T] :=True;
  Use[S] :=True;
  Now :=1;
  Len :=1;
  While Now<=Len Do
    Begin
      If Queue[Now,1]=1 Then Break;
      For I :=F[Queue[Now,1]] To F[Queue[Now,1]+1]-1 Do
        If Not Use[R[I,2]] Then
          Begin
            Use[R[I,2]] :=True;
            Inc(Len);
            Queue[Len,1] :=R[I,2];
            Queue[Len,2] :=Queue[Now,2];
            If Queue[Len,2]=0 Then Queue[Len,2] :=I;
          End;
      Inc(Now);
    End;
  If Queue[Now,1]=1 Then
    MakeMoveBandit :=Queue[Now,2]
  Else MakeMoveBandit :=0;
End;

Procedure MakeDist(Const S : Int; Var Dist : TDist);
  Var Queue : Array [1..MaxN+1,1..2] Of Int;
      Use : Array [1..MaxN] Of Boolean;
      I,Now,Len : Int;
Begin
  FillChar(Use,SizeOf(Use),0);
  FillChar(Queue,SizeOf(Queue),0);
  Queue[1,1] :=S;
  Use[S] :=True;
  Dist[S] :=0;
  Now :=1;
  Len :=1;
  While Now<=Len Do
    Begin
      For I :=F[Queue[Now,1]] To F[Queue[Now,1]+1]-1 Do
        If Not Use[R[I,2]] Then
          Begin
            Use[R[I,2]] :=True;
            Inc(Len);
            Queue[Len,1] :=R[I,2];
            Queue[Len,2] :=Queue[Now,2];
            Dist[R[I,2]] :=Dist[R[I,1]]+1;
            If Queue[Len,2]=0 Then Queue[Len,2] :=I;
          End;
      Inc(Now);
    End;
End;

Function CheckColor(Const Color : Int) : Boolean;
  Var I : Int;
Begin
  CheckColor :=True;
  For I :=F[T] To F[T+1]-1 Do
    If (R[I,2]=1) And (R[I,3]=Color) Then CheckColor :=False;
End;

Procedure Solve;
  Var Ans,Move,MoveB : Int;
      I,SLast : Int;
Begin
  FillChar(Use,SizeOf(Use),0);
  Ans :=0;
  MakeDist(1,Dist1);
  If T<>1 Then
    While True Do
      Begin
        If Use[S,T] Then
          Begin
            WriteLn('Endless');
            Exit;
          End;
        Use[S,T] :=True;
        Inc(Ans);
        MakeDist(T,DistB);
        //Move :=MakeMovePolice;
        Move :=F[S];
        For I :=F[S]+1 To F[S+1]-1 Do
          If Not (R[Move,2]=T) And (CheckColor(R[I,3]) Or (R[I,2]=T)) And
          ((DistB[R[I,2]]<DistB[S]) Or Not CheckColor(R[Move,3])) Then Move :=I;
//        If Move=0 Then
//        Begin
//            WriteLn('Endless');
//            Exit;
//          End;
        SLast :=S;
        S :=R[Move,2];
        If S=T Then Break;
        MoveB :=MakeMoveBandit;
        If MoveB<>0 Then
          If R[Move,3]=R[MoveB,3] Then T :=R[MoveB,2]
          Else
        Else
          Begin
            MakeDist(S,DistP);
            For I :=F[T] To F[T+1] Do
              If (R[I,3]=R[Move,3]) And (DistP[R[I,2]]>DistP[T]) Then
                Begin
                  T :=R[I,2];
                  Break;
                End;
          End;
        If T=1 Then Break;
      End
  Else
    If S=1 Then
      Begin
        WriteLn('Caught');
        WriteLn('0');
        Exit;
      End;
  If T=1 Then
    WriteLn('Escaped')
  Else WriteLn('Caught');
  WriteLn(Ans);
End;

Procedure CloseFiles;
Begin
  Close(Input);
  Close(Output);
End;

Begin
  OpenFiles;
  Init;
  Solve;
  CloseFiles;
End.
