{$A+,B-,D-,E+,F-,G-,I-,L-,N-,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}
  Const File_In='rects.in';
        File_Out='rects.out';
        MaxN=100000;
  Type Int=LongInt;
       TRect=Record A,Num,X1,Y1,X2,Y2 : Int; End;
  Var N : Int;
      R : Array [1..MaxN] Of TRect;
      Ans,AnsW,Max : Array [0..MaxN] Of Int64;
      From : Array [1..MaxN] Of Int;
      Answer : Int;

Procedure OpenFiles;
Begin
  Assign(Input,File_In);
  ReSet(Input);
  Assign(Output,File_Out);
  ReWrite(Output);
End;

Procedure Init;
  Var I : Int;
Begin
  Read(N);
  For I :=1 To N Do
    Begin
      Read(R[I].X1,R[I].Y1,R[I].X2,R[I].Y2,R[I].A);
      R[I].Num :=I;
    End;
End;

Procedure Swap(Var A,B : TRect);
  Var C : TRect;
Begin
  C :=A;
  A :=B;
  B :=C;
End;

Procedure Sort(L,R2 : Int);
  Var I,J,X : Int;
Begin
  I :=L;
  J :=R2;
  X :=R[(I+J) Div 2].X1;
  Repeat
    While R[I].X1<X Do Inc(I);
    While R[J].X1>X Do Dec(J);
    If I<=J Then
      Begin
        Swap(R[I],R[J]);
        Inc(I);
        Dec(J);
      End;
  Until I>J;
  If I<R2 Then Sort(I,R2);
  If J>L Then Sort(L,J);
End;

Procedure Solve;
  Var I,J : Int;
Begin
  Sort(1,N);
  FillChar(From,Sizeof(From),0);
  FillChar(Max,Sizeof(Max),0);
  FillChar(Ans,Sizeof(Ans),0);
  Answer :=1;
  For I :=1 To N Do
    Begin
      For J :=I-1 DownTo 1 Do
        Begin
          If Max[J]<=Ans[I] Then Break;
          If (R[J].X2<R[I].X1) And (R[J].Y1>R[I].Y2) Then
            If Ans[I]<Ans[J] Then
              Begin
                Ans[I] :=Ans[J];
                From[I] :=J;
              End;
        End;
      Inc(Ans[I],Int64(R[I].A));
      Max[I] :=Max[I-1];
      If Ans[I]>Max[I] Then
        Begin
          Max[I] :=Ans[I];
          Answer :=I;
        End;
    End;
  WriteLn(Ans[Answer]);
  AnsW[0] :=0;
  While Answer<>0 Do
    Begin
      Inc(AnsW[0]);
      AnsW[AnsW[0]] :=R[Answer].Num;
      Answer :=From[Answer];
    End;
  For I :=AnsW[0] DownTo 1 Do
    Write(AnsW[I],' ');
End;

Procedure CloseFiles;
Begin
  Close(Input);
  Close(Output);
End;

Begin
  OpenFiles;
  Init;
  Solve;
  CloseFiles;
End.
