{$A+,B-,D-,E+,F-,G-,I-,L-,N-,O-,P-,Q-,R-,S-,T-,V+,X+,Y+,H+}
  Const File_In='eq.in';
        File_Out='eq.out';
        MaxN=350;
        Ok='equivalent';
  Type Int=LongInt;
  Var N,M,T : Int;
      V1,V2 : Array [1..MaxN] Of Int;
      Ans : Array [1..MaxN] Of Record Find : Boolean; S : String; End;
      V : Array [1..MaxN,0..1] Of Int;
      D : Array [1..MaxN] Of Boolean;
      Find,NewFind : Array [1..MaxN,1..MaxN] Of Record
                                                  S : String;
                                                  Len : Int;
                                                End;

Procedure OpenFiles;
Begin
  Assign(Input,File_In);
  ReSet(Input);
  Assign(Output,File_Out);
  ReWrite(Output);
End;

Procedure Solve(Const V1,V2,Num : Int);
  Var I,J : Int;
      Change : Boolean;
Begin
  If V1=V2 Then Begin WriteLn(Ok); Exit End;
  If D[V1] Xor D[V2] Then
    Begin
      Ans[Num].Find :=True;
      Ans[Num].S :='';
      WriteLn; Exit
    End;
  For I :=1 To N Do
    For J :=1 To N Do
      Begin
        NewFind[I,J].Len :=-1;
        NewFind[I,J].S :='';
      End;
  NewFind[V1,V2].Len :=0;
  NewFind[V2,V1].Len :=0;
  Change :=True;
  While Change Do
    Begin
      For I :=1 To N Do
        For J :=1 To N Do 
          Find[I,J] :=NewFind[I,J];
      For I :=1 To N Do
        For J :=1 To N Do
          If (Find[I,J].Len>=0) And (D[I] Xor D[J]) Then
            Begin
              WriteLn(Find[I,J].S);
              Ans[Num].Find :=True;
              Ans[Num].S :=Find[I,J].S;
              Exit;
            End;
      For I :=1 To N Do
        For J :=1 To N Do
          NewFind[I,J].Len :=-1;
      For I :=1 To N Do
        For J :=1 To N Do
          If Find[I,J].Len>=0 Then
            Begin
              NewFind[V[I,0],V[J,0]].Len :=Find[I,J].Len+1;
              NewFind[V[I,0],V[J,0]].S :=Find[I,J].S+'0';
              NewFind[V[I,1],V[J,1]].Len :=Find[I,J].Len+1;
              NewFind[V[I,1],V[J,1]].S :=Find[I,J].S+'1';
            End;
      Change :=False;
      For I :=1 To N Do
        For J :=1 To N Do
          Change :=Change Or ((NewFind[I,J].Len<>0) Xor (Find[I,J].Len<>0));
    End;
  WriteLn(Ok);
End;

Procedure Init;
  Var I,J,Help : Int;
      FindAns : Boolean;
Begin
  FillChar(D,SizeOf(D),0);
  Read(N);
  Read(T);
  For I :=1 To T Do
    Begin
      Read(Help);
      D[Help] :=True;
    End;
  For I :=1 To N Do
    Read(V[I,0],V[I,1]);
  Read(M);
  For I :=1 To M Do
    Begin
      Read(V1[I],V2[I]);
      FindAns :=False;
      For J :=1 To I-1 Do
        If (V1[I]=V1[J]) And (V2[I]=V2[J]) Then
          Begin
            If Ans[J].Find Then WriteLn(Ans[J].S)
            Else WriteLn(Ok);
            FindAns :=True;
            Break;  
          End;
      Ans[I].Find :=False;
      If Not FindAns Then Solve(V1[I],V2[I],I);
    End;
End;

Procedure CloseFiles;
Begin
  Close(Input);
  Close(Output);
End;

Begin
  OpenFiles;
  Init;
  CloseFiles;
End.
