{$A+,B-,D-,E-,F-,G-,I-,L-,N-,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}
  Const File_In='game.in';
        File_Out='game.out';
        MaxM=150;
        MaxL=100;
  Type Int=LongInt;
  Var S : String;
      M,Len : Int;
      Rule : Array [1..MaxM] Of Record S : String; Sym : Char; End;
      A : Array [1..MaxL,1..MaxL,1..MaxL,0..50] Of Boolean;
      B : Array [1..MaxL,1..MaxL,'A'..'Z'] Of Boolean;
      CanUse : Array ['A'..'Z'] Of Boolean;
      Len2 : Array [1..MaxM] Of Int;

Procedure OpenFiles;
Begin
  Assign(Input,File_In);
  ReSet(Input);
  Assign(Output,File_Out);
  ReWrite(Output);
End;

Function ReadS : String;
  Var Sym : Char;
      S : String;
Begin
  Read(Sym);
  S :='';
  While Not (Sym In ['A'..'Z']) Do Read(Sym);
  While Sym In ['A'..'Z'] Do
    Begin
      S :=S+Sym;
      Read(Sym);
    End;
  ReadS :=S;
End;

Procedure Init;
  Var I : Int;
      HelpS : String;
Begin
  FillChar(CanUse,SizeOf(CanUse),0);
  S :=ReadS;
  Len :=Length(S);
  Read(M);
  For I :=1 To M Do
    Begin
      Rule[I].S :=ReadS;
      HelpS :=ReadS;
      Rule[I].Sym :=HelpS[1];
      CanUse[Rule[I].Sym] :=True;
    End;
End;

Procedure Solve;
  Var I3,J3,I,J,J2,K,L : Int;
      Sym : Char;
Begin
  If Len>MaxL Then Exit;
  For I :=1 To Len Do
    For J :=1 To Len Do
      For Sym :='A' To 'Z' Do
        B[I,J,Sym] :=False;
  For I :=1 To Len Do
    If CanUse[S[I]] Then
      B[I,I,S[I]] :=True;
  For I :=1 To Len Do
    For J :=I+1 To Len Do
      For K :=1 To M Do
        A[I,J,K,0] :=False;
  For I :=1 To Len Do
    For J :=1 To M Do
      If Rule[J].S[1]=S[I] Then
        A[I,I,J,1] :=True
      Else A[I,I,J,1] :=False;
  For I :=1 To M Do
    Len2[I] :=Length(Rule[I].S);
  For J3 :=2 To Len Do
    For I3 :=1 To Len-J3+1 Do
      Begin
        I :=I3;
        J :=I3+J3-1;
        For L :=1 To M Do
          Begin
            A[I,J,L,1] :=A[I,J,L,1] Or B[I,J,Rule[L].S[1]];
            For K :=1 To Len2[L] Do
              For J2 :=I To J-1 Do
                Begin
                  A[I,J,L,K] :=A[I,J2,L,K-1] And B[J2+1,J,Rule[L].S[K]];
                  If A[I,J,L,K] Then Break;
                End;
            If A[I,J,L,Len2[L]] Then
              B[I,J,Rule[L].Sym] :=True;
          End;
        For L :=1 To M Do
          A[I,J,L,1] :=A[I,J,L,1] Or B[I,J,Rule[L].S[1]];
      End;
  For Sym :='A' To 'Z' Do
    If CanUse[Sym] And B[1,Len,Sym] Then Write(Sym);
End;

Procedure CloseFiles;
Begin
  Close(Input);
  Close(Output);
End;

Begin
  OpenFiles;
  Init;
  Solve;
  CloseFiles;
End.
