{$A+,B-,D-,E+,F-,G-,I-,L-,N-,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}
  Const File_In='roads.in';
        File_Out='roads.out';
        MaxN=100001;
        MaxM=MaxN;
  Type Int=LongInt;
  Var N,M,L : Int;
      Answer,CntAns : Int;
      D,Num,InNum : Array [1..MaxN] Of Int;
      R,R2 : Array [1..MaxM*2,1..2] Of Int;
      F : Array [1..MaxN+1] Of Int;
      Cnt : Array [0..MaxN] Of Int;
      Last,First,DMax,NumMax,NumMax2 : Array [1..MaxN] Of Int;
      ForAns : Array [1..MaxN*4,1..2] Of Int;

Procedure OpenFiles;
Begin
  Assign(Input,File_In);
  ReSet(Input);
  Assign(Output,File_Out);
  ReWrite(Output);
End;

Procedure MakeEdges;
  Var I : Int;
Begin
  FillChar(F,SizeOf(F),0);
  For I :=1 To M Do
    Begin
      R[I+M,1] :=R[I,2];
      R[I+M,2] :=R[I,1];
      Inc(F[R[I,1]]);
      Inc(F[R[I,2]]);
    End;
  M :=M*2;
  Inc(F[1]);
  For I :=2 To N+1 Do
    Inc(F[I],F[I-1]);
  R2 :=R;
  For I :=1 To M Do
    Begin
      Dec(F[R2[I,1]]);
      R[F[R2[I,1]]] :=R2[I];
    End;
End;

Procedure Init;
  Var I : Int;
Begin
  Read(N,M,L);
  For I :=1 To N Do
    Begin
      Read(D[I]);
      Num[I] :=I;
    End;
  For I :=1 To M Do
    Read(R[I,1],R[I,2]);
  MakeEdges;
End;

Function Max(Const A,B : Int) : Int;
Begin
  If A>B Then Max :=A
  Else Max :=B;
End;

Procedure Swap(Var A,B : Int);
  Var C : Int;
Begin
  C :=A;
  A :=B;
  B :=C;
End;

Procedure Sort(L,R : Int);
  Var I,J,X : Int;
Begin
  I :=L;
  J :=R;
  X :=D[L+Random(R-L+1)];
  Repeat
    While D[I]<X Do Inc(I);
    While D[J]>X Do Dec(J);
    If I<=J Then
      Begin
        Swap(D[I],D[J]);
        Swap(Num[I],Num[J]);
        Inc(I);
        Dec(J);
      End;
  Until I>J;
  If I<R Then Sort(I,R);
  If J>L Then Sort(L,J);
End;

Procedure Sort2(L,R : Int);
  Var I,J,X : Int;
Begin
  I :=L;
  J :=R;
  X :=ForAns[L+Random(R-L+1),1];
  Repeat
    While ForAns[I,1]<X Do Inc(I);
    While ForAns[J,1]>X Do Dec(J);
    If I<=J Then
      Begin
        Swap(ForAns[I,1],ForAns[J,1]);
        Swap(ForAns[I,2],ForAns[J,2]);
        Inc(I);
        Dec(J);
      End;
  Until I>J;
  If I<R Then Sort2(I,R);
  If J>L Then Sort2(L,J);
End;

Procedure Dfs(I : Int);
  Var J : Int;
Begin
  Cnt[I] :=Cnt[0];
  For J :=F[Num[I]] To F[Num[I]+1]-1 Do
    If Cnt[InNum[R[J,2]]]=0 Then
      Dfs(InNum[R[J,2]]);
End;

Procedure Solve;
  Var I,Help : Int;
Begin
  FillChar(Cnt,SizeOf(Cnt),0);
  Randomize;
  Sort(1,N);
  For I :=1 To N Do
    InNum[Num[I]] :=I;
  For I :=1 To N Do
    If Cnt[I]=0 Then
      Begin
        Inc(Cnt[0]);
        Dfs(I);
      End;
  FillChar(First,SizeOf(First),255);
  FillChar(DMax,SizeOf(Dmax),0);
  For I :=1 To N Do
    Begin
      If First[Cnt[I]]=-1 Then
        Begin
          First[Cnt[I]] :=I;
          Last[Cnt[I]] :=I;
        End
      Else
        Begin
          If D[I]-D[Last[Cnt[I]]]>DMax[Cnt[I]] Then
            Begin
              NumMax2[Cnt[I]] :=Last[Cnt[I]];
              NumMax[Cnt[I]] :=I;
              DMax[Cnt[I]] :=D[I]-D[Last[Cnt[I]]];
            End;
          Last[Cnt[I]] :=I;
        End;
    End;
  For I :=1 To Cnt[0] Do
    If D[First[I]]-D[Last[I]]+L>DMax[I] Then
      Begin
        DMax[I] :=D[First[I]]-D[Last[I]]+L;
        NumMax[I] :=First[I];
        NumMax2[I] :=Last[I];
      End;
  CntAns :=0;
  For I :=1 To Cnt[0] Do
    If DMax[I]<>L Then
      If NumMax[I]<>First[I] Then
        Begin
          Inc(CntAns);
          ForAns[CntAns,1] :=0;
          ForAns[CntAns,2] :=1;
          Inc(CntAns);
          ForAns[CntAns,1] :=D[NumMax2[I]];
          ForAns[CntAns,2] :=-1;
          Inc(CntAns);
          ForAns[CntAns,1] :=D[NumMax[I]];
          ForAns[CntAns,2] :=1;
          Inc(CntAns);
          ForAns[CntAns,1] :=L;
          ForAns[CntAns,2] :=-1;
        End
      Else
        Begin
          Inc(CntAns);
          ForAns[CntAns,1] :=D[First[I]];
          ForAns[CntAns,2] :=1;
          Inc(CntAns);
          ForAns[CntAns,1] :=D[Last[I]];
          ForAns[CntAns,2] :=-1;
        End;
  Sort2(1,CntAns);
  Help :=ForAns[1,2];
  For I :=2 To CntAns Do
    Begin
      If Help>0 Then Inc(Answer,ForAns[I,1]-ForAns[I-1,1]);
      Inc(Help,ForAns[I,2]);
    End;
  WriteLn(Answer);
End;

Procedure CloseFiles;
Begin
  Close(Input);
  Close(Output);
End;

Begin
  OpenFiles;
  Init;
  Solve;
  CloseFiles;
End.
