{$A+,B-,D-,E+,F-,G-,I-,L-,N-,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}
  Const File_In='tree.in';
        File_Out='tree.out';
        MaxN=250;
  Type Int=Integer;
  Var N,M,P : Int;
      R,R2 : Array [1..MaxN,1..3] Of Int;
      F : Array [1..MaxN+1] Of Int;
      Answer : Int;
      Use,UseAns : Array [1..MaxN] Of Boolean;
      Color : Array [1..MaxN] Of Int;
      Cnt,Par : Array [0..MaxN] Of Int;

Procedure OpenFiles;
Begin
  Assign(Input,File_In);
  ReSet(Input);
  Assign(Output,File_Out);
  ReWrite(Output);
End;

Procedure MakeEdges;
  Var I : Int;
Begin
  FillChar(F,SizeOf(F),0);
  For I :=1 To M Do
    Begin
      R[I+M,1] :=R[I,2];
      R[I+M,2] :=R[I,1];
      R[I,3] :=I;
      R[I+M,3] :=I;
      Inc(F[R[I,1]]);
      Inc(F[R[I,2]]);
    End;
  M :=M*2;
  Inc(F[1]);
  For I :=2 To N+1 Do
    Inc(F[I],F[I-1]);
  R2 :=R;
  For I :=1 To M Do
    Begin
      Dec(F[R2[I,1]]);
      R[F[R2[I,1]]] :=R2[I];
    End;
End;

Procedure Init;
  Var I : Int;
Begin
  Read(N,P);
  For I :=1 To N-1 Do
    Read(R[I,1],R[I,2]);
  M :=N-1;
  MakeEdges;
End;

Procedure Dfs(I : Int);
  Var J : Int;
Begin
  For J :=F[I] To F[I+1]-1 Do
    If R[J,2]<>Par[I] Then
      Begin
        Par[R[J,2]] :=I;
        Dfs(R[J,2]);
        Inc(Cnt[I],Cnt[R[J,2]]);
      End;
  Inc(Cnt[I]);
End;

Procedure FindAnswer(Count,CntV : Int);
  Var I : Int;
      Clr : Int;

Procedure Paint(I : Int);
  Var J : Int;
Begin
  Color[I] :=Clr;
  For J :=F[I] To F[I+1]-1 Do
    If Not Use[R[J,3]]  And (Color[R[J,2]]<>Clr) Then
      Paint(R[J,2]);
End;

Begin
  If Count>=Answer Then Exit;
  If CntV<P Then Exit;
  If CntV=P Then
    Begin
      Answer :=Count;
      UseAns :=Use;
      Exit;
    End;
  For I :=1 To N-1 Do
    If Not Use[I] And (Color[R2[I,1]]=Count) And (Color[R2[I,2]]=Count) Then
      Begin
        Use[I] :=True;
        Dec(Cnt[R2[I,1]],Cnt[R2[I,2]]);
        Clr :=Count+1;
        Paint(R2[I,1]);
        FindAnswer(Count+1,CntV-Cnt[R2[I,2]]);
        Clr :=Count;
        Paint(R2[I,1]);
        Clr :=Count+1;
        Paint(R2[I,2]);
        FindAnswer(Count+1,Cnt[R2[I,2]]);
        Clr :=Count;
        Paint(R2[I,2]);
        Inc(Cnt[R2[I,1]],Cnt[R2[I,2]]);
        Use[I] :=False;
      End;
End;

Procedure Swap(Var A,B : Int);
  Var C : Int;
Begin
  C :=A;
  A :=B;
  B :=C;
End;

Procedure Solve;
  Var I : Int;
Begin
  FillChar(Cnt,SizeOf(Cnt),0);
  FillChar(Par,SizeOf(Par),0);
  FillChar(Use,SizeOf(Use),0);
  FillChar(UseAns,SizeOf(UseAns),0);
  Answer :=N-P+1;
  Dfs(1);
  For I :=1 To N-1 Do
    If Par[R[I,1]]=R[I,2] Then
      Swap(R[I,1],R[I,2]);
  FindAnswer(0,N);
  WriteLn(Answer);
  For I :=1 To N-1 Do
    If UseAns[I] Then Write(I,' ');
End;

Procedure CloseFiles;
Begin
  Close(Input);
  Close(Output);
End;

Begin
  OpenFiles;
  Init;
  Solve;
  CloseFiles;
End.
