{$I-,O+,Q-,R-,S-}
const
fn='glass.';
eps=1E-8;


function angle(x,y:double):double;
var
a:double;
begin
if abs(x)<eps then begin
if y<0 then angle:=pi*3/2 else angle:=pi/2;
exit;
end;
a:=arctan(y/x);
if a<0 then a:=a+pi;
if y<0 then a:=a+pi;
angle:=a;
end;

procedure swapdouble(var a,b:double);
var
d:double;
begin
d:=a;
a:=b;
b:=d;
end;

procedure united(var a1,a2:double;b1,b2:double);
begin
if (a1>b2+eps) or (a2+eps<b1) then begin
a1:=-1;
a2:=-1;
exit;
end;
if (b1<=a1) and (a2<=b2) then exit;
if (a1<=b1) and (b2<=a2) then begin
a1:=b1;
a2:=b2;
exit;
end;
if (b1<=a1+eps) and (a1<=b2+eps) then begin
a2:=b2;
exit;
end;
if (b1<=a2+eps) and (a2<=b2+eps) then begin
a1:=b1;
exit;
end;
end;

procedure un(var a1,a2:double;b1,b2:double);
var
d1,d2:double;
begin
d1:=a1;
d2:=a2;
united(a1,a2,b1,b2);
if abs(a1+1)>eps then exit;
a1:=d1;
a2:=d2;
united(a1,a2,b1+2*pi,b2+2*pi);
if abs(a1+1)>eps then exit;
a1:=d1;
a2:=d2;
united(a1,a2,b1-2*pi,b2-2*pi);
if abs(a1+1)>eps then exit;
writeln(-1);
close(output);
halt;
end;

var
i:integer;
r:double;
n:integer;
x,y:array [1..200] of double;
sa,ss,fa,a,d1,d2,xd,yd:double;
begin
assign(input,fn+'in');reset(input);
assign(output,fn+'out');rewrite(output);
read(r,n);
for i:=1 to n do read(x[i],y[i]);
close(input);
a:=angle(x[2]-x[1],y[2]-y[1]);
sa:=a;
fa:=a+pi;
for i:=2 to n-1 do begin
a:=angle(x[i+1]-x[i],y[i+1]-y[i]);
un(sa,fa,a,a+pi);
end;
r:=r*0.99999;

xd:=x[2]-x[1];
yd:=y[2]-y[1];
xd:=xd/2;
yd:=yd/2;
a:=angle(xd,yd);
a:=a+0.0001;
ss:=sqrt(xd*xd+yd*yd);
write((cos(a)*ss+x[1]+eps):0:5,' ',(sin(a)*ss+y[1]+eps):0:5);
write(' ');
write((cos(sa)*r+eps):0:5,' ',(sin(sa)*r+eps):0:5);
close(output);
end.
