VAR
{ Debug:Text;}
 KRX,KRY,RX,RY,X,Y,CX,CY,MaxY:LongInt;
 Key:Array[0..99,0..99]Of Byte;
 Matrix:Array[0..999,0..9999]Of Byte;
 Vect:Byte;
 CH:Char;

Function GetMt(PX,PY:LongInt):Byte;
 Begin
   If (PX<0)Or(PX>=RX)Then GetMt:=1
   Else If (PY<0)Or(PY>=RY)Then GetMt:=0
   Else GetMt:=Matrix[PX,PY];
 End;

Function GoGoGo:Boolean;
 Var
  X,Y,TX,TY:LongInt;
 Begin
   TX:=CX;TY:=CY;
   Case Vect Of
     0:Inc(TX);
     1:Inc(TY);
     2:Dec(TX);
     3:Dec(TY);
   End;
   For X:=0 To KRX-1 Do
     For Y:=0 To KRY-1 Do
       If (Key[X,Y]And GetMt(X+TX,Y+TY))=1 Then Begin
         GoGoGo:=False;
         Exit;
       End;
   CX:=TX;
   CY:=TY;
   GoGoGo:=True;
 End;

Procedure IncVect;
 Begin
   Vect:=(Vect+1)Mod 4;
 End;

Procedure DecVect;
 Begin
   Vect:=(Vect+3)Mod 4;
 End;

BEGIN
  Assign(Input,'key.in');
  Assign(Output,'key.out');
{  Assign(Debug,'key.debug.out');}
  Reset(Input);
  ReWrite(Output);
{  ReWrite(Debug);}

  ReadLn(KRY,KRX);
  For Y:=0 To KRY-1 Do Begin
    For X:=0 To KRX-1 Do Begin
      Read(CH);
      If CH='#'Then Key[X,Y]:=1 Else Key[X,Y]:=0;
    End;
    ReadLn;
  End;
  ReadLn(RY,RX);
  For Y:=0 To RY-1 Do Begin
    For X:=0 To RX-1Do Begin
      Read(CH);
      If CH='#'Then Matrix[X,Y]:=1 Else Matrix[X,Y]:=0;
    End;
    ReadLn;
  End;
  CX:=0;
  CY:=-KRY;
  Vect:=1;
  MaxY:=-KRY-1;
  While True Do Begin
{    Writeln(Debug,'FF ',CX,' ',CY,' ',MaxY);}
    IncVect;
    While Not GoGoGo Do DecVect;
    If CY>MaxY Then MaxY:=CY;
    If CY<-KRY Then Break;
    If CY>RY Then Begin
      MaxY:=$7FFFFFFF;
      Break;
    End;
  End;
  If MaxY=$7FFFFFFF Then Writeln(-1)
  Else Writeln(MaxY+KRY);

  Close(Input);
  Close(Output);
{  Close(Debug);}
END.

