Uses Math;

Function TestIn(Max,Min,Test:Double):Boolean;
 Begin
   If Min>Max Then TestIn:=(Test>=Max)And(Test<=Min)
   Else TestIn:=(Test<=Min)Or(Test>=Max);
 End;

Procedure ACROSS(Var B:Boolean;Var Min1,Max1:Double;Min2,Max2:Double);
 Begin
   If Not B Then Exit;
   If TestIn(Min1,Max1,Min2)Then Begin
     If TestIn(Min1,Max1,Max2)Then Begin
       Min1:=Min2;
       Max1:=Max2;
     End Else Begin
       Min1:=Min2;
     End;
   End Else Begin
     If TestIn(Min1,Max1,Max2)Then Begin
       Max1:=Max2;
     End Else Begin
       If Not TestIn(Min2,Max2,Min1) Then
         B:=False;
     End;
   End;
 End;

VAR
{ Debug:Text;}
 R:Double;
 N,I:LongInt;
 V:Array[0..199]Of Record
   X,Y:Double;
 End;
 MinA,MaxA,TMA,TXA:Double;
 B1:Boolean;
 X,Y,Alph:Double;
 SS11:Boolean;

CONST
 Eps=0.000000000001;

Procedure FindXY(Var X,Y:Double);
 Begin
   For I:=0 To N-3 Do Begin
     If (V[I].X*V[I+1].Y-V[I].Y*V[I+1].X+V[I+1].X*V[I+2].Y-V[I+1].Y*V[I+2].X+V[I+2].X*V[I].Y-V[I+2].Y*V[I].X)<Eps Then Begin
        X:=(V[I].X+V[I+2].X)/2;
        Y:=(V[I].Y+V[I+2].Y)/2;
        SS11:=True;Exit;
     End;
   End;
   For I:=0 To N-3 Do Begin
     If (V[I].X*V[I+1].Y-V[I].Y*V[I+1].X+V[I+1].X*V[I+2].Y-V[I+1].Y*V[I+2].X+V[I+2].X*V[I].Y-V[I+2].Y*V[I].X)>Eps Then Begin
        X:=(V[I].X+V[I+2].X)/2;
        Y:=(V[I].Y+V[I+2].Y)/2;
        SS11:=False;Exit;
     End;
   End;
   SS11:=True;
   X:=Cos(Alph);
   Y:=Sin(Alph);
 End;


BEGIN
  Assign(Input,'glass.in');
  Assign(Output,'glass.out');
{  Assign(Debug,'glass.debug.out');}
  Reset(Input);
  ReWrite(Output);
{  ReWrite(Debug);}

  ReadLn(R,N);
  For I:=0 To N-1 Do ReadLn(V[I].X,V[I].Y);
  MinA:=-PI;
  MaxA:=+PI;
  B1:=True;
  For I:=1 To N-1 Do Begin
    TMA:=ArcTan2(V[I].Y-V[I-1].Y,V[I].X-V[I-1].X);
    If TMA>0 Then TXA:=TMA-PI
    Else TXA:=TMA+PI;
{    Writeln(Debug,MinA,' ',MaxA);}
    ACROSS(B1,MinA,MaxA,TMA,TXA);
  End;
{  Writeln(Debug,MinA,' ',MaxA);}
  If Not B1 Then Writeln(-1) Else Begin
    If MinA>MaxA Then
      Alph:=(MinA+MaxA)/2
    Else Begin
      Alph:=(MinA+MaxA)/2;
      If Alph<0 Then Alph:=Alph+PI
      Else Alph:=Alph-PI;
    End;
    FindXY(X,Y);
    If SS11 Then Begin
      Writeln(X:0:5,' ',Y:0:5,' ',Cos(Alph):0:5,' ',Sin(Alph):0:5);
    End Else Begin
      Writeln(X:0:5,' ',Y:0:5,' ',-Cos(Alph):0:5,' ',-Sin(Alph):0:5);
    End;
  End;

  Close(Input);
  Close(Output);
{  Close(Debug);}
END.