CONST
 Eps1=1e-12;
 Eps2=5e-5;

Procedure Cross(X1,Y1,X2,Y2,Y:Double;Var RX,RY:Double);
 Begin
   RY:=Y;
   RX:=((X2-X1)*(Y-Y1)/(Y2-Y1))+X1;
 End;

VAR
{ Debug:Text;}
 N,I,K:LongInt;
 S,SK:Double;
 X,Y:Array[0..49999]Of Double;
 MMY,MXY:Double;

Function GetS(Line:Double):Double;
 Var
  Ind,MI,NI:LongInt;
  Sum1,Sum2,NX,NY,TX,TY:Double;
 Begin
   Sum1:=0;
   Sum2:=0;
   Ind:=0;
   NX:=0;
   NY:=0;
   While Y[Ind]<Line Do Begin
     Inc(Ind);
     If Ind=N Then Begin
       GetS:=S;
       Exit;
     End;
   End;
   MI:=Ind;
   Repeat
     NI:=(Ind+1)Mod N;
     If Y[NI]-Line>Eps1 Then Begin
       If Y[Ind]-Line>Eps1 Then Begin
         {no action}
       End Else Begin
         Cross(X[Ind],Y[Ind],X[NI],Y[NI],Line,TX,TY);
         Sum1:=Sum1+(Sum2+X[Ind]*TY-TX*Y[Ind]+TX*NY-NX*TY)/2;
         Sum2:=0;
       End;
     End Else Begin
       If Y[Ind]-Line>Eps1 Then Begin
         Cross(X[Ind],Y[Ind],X[NI],Y[NI],Line,NX,NY);
         Sum2:=NX*Y[NI]-NY*X[NI];
       End Else Begin
         Sum2:=Sum2+X[Ind]*Y[NI]-X[NI]*Y[Ind];
       End;
     End;
     Ind:=NI;
   Until MI=Ind;
   GetS:=Abs(Sum1);
 End;

Function MakeLine(Sqr:Double):Double;
 Var MinY,MaxY,Sep,Res:Double;
 Begin
   MinY:=MMY;
   MaxY:=MXY;
   While (MaxY-MinY)>Eps2 Do Begin
{     Writeln(Debug,'Y(= [',MinY:0:4,';',MaxY:0:4,']');
     Flush(Debug);}
     Sep:=(MinY+MaxY)/2;
     Res:=GetS(Sep);
{     Writeln(Debug,'S:',Res:0:5,' of ',Sqr:0:5);}
     If Abs(Res-Sqr)<Eps1 Then Begin
       MakeLine:=Sep;
       Exit;
     End;
     If Res<Sqr Then MinY:=Sep;
     If Res>Sqr Then MaxY:=Sep;
   End;
   MakeLine:=(MinY+MaxY)/2;
 End;

BEGIN
  Assign(Input,'antiufo.in');
  Assign(Output,'antiufo.out');
{  Assign(Debug,'antiufo.debug.out');}
  Reset(Input);
  ReWrite(Output);
{  ReWrite(Debug);}

  ReadLn(N,K);
  For I:=0 To N-1 Do ReadLn(X[I],Y[I]);
  S:=0;
  For I:=0 To N-1 Do S:=S+X[I]*Y[(I+1)Mod N]-Y[I]*X[(I+1)Mod N];
  MMY:=20000;
  MXY:=-20000;
  For I:=0 To N-1 Do Begin
    If MMY>Y[I] Then MMY:=Y[I];
    If MXY<Y[I] Then MXY:=Y[I];
  End;
  S:=Abs(S/2);
  SK:=S/(K+1);
  For I:=1 To K Do Writeln(MakeLine(SK*I):0:4);

  Close(Input);
  Close(Output);
{  Close(Debug);}
END.

