TYPE
 pRebList=LongInt;
 tRebList=Record
   Target:LongInt;
   Next:LongInt;
 End;

VAR
 Mem1:Array[0..210000]Of tRebList;
 MFR:LongInt;

Procedure Mem1Init;
 Var
  I:LongInt;
 Begin
   For I:=209999 DownTo 0 Do Begin
     Mem1[I].Target:=I+1;
   End;
   MFR:=0;
 End;

Function GetMem1:LongInt;
 Var
  Temp:LongInt;
 Begin
   Temp:=MFR;
   MFR:=Mem1[MFR].Target;
   GetMem1:=Temp;
 End;

Procedure FreeMem1(F:LongInt);
 Begin
   Mem1[F].Target:=MFR;
   MFR:=F;
 End;

Procedure RebList_Init(Var List:pRebList);
 Begin
   List:=-1;
 End;

Procedure RebList_Put(Var List:pRebList;TRG:LongInt);
 Begin
   If List=-1 Then Begin
     List:=GetMem1;
     Mem1[List].Target:=TRG;
     Mem1[List].Next:=-1;
     Exit;
   End;
   RebList_Put(Mem1[List].Next,TRG);
 End;

Procedure RebList_Get(List:pRebList;Var A:Array Of LongInt;Var B:LongInt);
 Begin
   B:=0;
   While List<>-1 Do Begin
     A[B]:=Mem1[List].Target;
     Inc(B);
     List:=Mem1[List].Next;
   End;
 End;

TYPE
 tRec1=Record
   X:LongInt;
   C:LongInt;
   I:LongInt;
 End;

Procedure SWAP1(Var A,B:tRec1);
 Var
  T:tRec1;
 Begin
   T:=A;
   A:=B;
   B:=T;
 End;

Procedure Sort1(Var A,B:Array Of tRec1;St,Fn:LongInt);
 Var
  I,J,Spr,St1,Fn1:LongInt;
 Begin
   If (Fn-St)<15 Then Begin
     For I:=0 To Fn-St Do
     For J:=St To Fn-1 Do
       If A[J].C>A[J+1].C Then SWAP1(A[J],A[J+1]);
     Exit;
   End;
   Spr:=(St+Fn)Shr 1;
   Sort1(A,B,St,Spr);
   Sort1(A,B,Spr+1,Fn);
   St1:=St;
   Fn1:=Spr+1;
   I:=St;
   While I<=Fn Do Begin
     If(Fn1>Fn)Or((St1<=Spr)And(A[St1].C<A[Fn1].C))Then Begin
       B[I]:=A[St1];
       Inc(St1);
     End Else Begin
       B[I]:=A[Fn1];
       Inc(Fn1);
     End;
     Inc(I);
   End;
   For I:=St To Fn Do A[I]:=B[I];
 End;

Procedure Sort2(Var A,B:Array Of tRec1;St,Fn:LongInt);
 Var
  I,J,Spr,St1,Fn1:LongInt;
 Begin
   If (Fn-St)<15 Then Begin
     For I:=0 To Fn-St Do
     For J:=St To Fn-1 Do
       If A[J].X>A[J+1].X Then SWAP1(A[J],A[J+1]);
     Exit;
   End;
   Spr:=(St+Fn)Shr 1;
   Sort2(A,B,St,Spr);
   Sort2(A,B,Spr+1,Fn);
   St1:=St;
   Fn1:=Spr+1;
   I:=St;
   While I<=Fn Do Begin
     If(Fn1>Fn)Or((St1<=Spr)And(A[St1].X<A[Fn1].X))Then Begin
       B[I]:=A[St1];
       Inc(St1);
     End Else Begin
       B[I]:=A[Fn1];
       Inc(Fn1);
     End;
     Inc(I);
   End;
   For I:=St To Fn Do A[I]:=B[I];
 End;

VAR
{ Debug:Text;}
 N,M,I,L,A,B:LongInt;
 X,Tmp:Array[0..100000]Of tRec1;
 V:Array[0..100000]Of pRebList;
 TC,Max,Temp,Temp2:LongInt;

Procedure DFS(U:LongInt);
 Var
  List:pRebList;
 Begin
   If X[U].C<>0 Then Exit;
   X[U].C:=1;
   List:=V[U];
   While List<>-1 Do Begin
     DFS(Mem1[List].Target);
     List:=Mem1[List].Next;
   End;
   X[U].C:=TC;
 End;

BEGIN
  Assign(Input,'roads.in');
  Assign(Output,'roads.out');
{  Assign(Debug,'roads.debug.out');}
  Reset(Input);
  ReWrite(Output);
{  ReWrite(Debug);}

  Mem1Init;
  ReadLn(N,M,L);
  For I:=0 To N-1 Do Begin
    Read(X[I].X);
    RebList_Init(V[I]);
    X[I].C:=0;
    X[I].I:=I;
  End;
  For I:=0 To M-1 Do Begin
    ReadLn(A,B);
    RebList_Put(V[A-1],B-1);
    RebList_Put(V[B-1],A-1);
  End;
  TC:=2;
  For I:=0 To N-1 Do Begin
    DFS(I);
    Inc(TC);
  End;
  Sort2(X,Tmp,0,N-1);
  Max:=-1;
  Temp2:=0;
  For I:=0 To N-1 Do If X[I].C=X[(I+1)Mod N].C Then Begin
    Temp:=X[(I+1)Mod N].X-X[I].X;
    If Temp<0 Then Temp:=Temp+L;
    If Max<Temp Then Max:=Temp;
  End Else Begin
    Temp:=X[(I+1)Mod N].X-X[I].X;
    If Temp<0 Then Temp:=Temp+L;
    If Max<Temp Then Max:=Temp;
    Temp2:=Temp2+Temp;
  End;
  If Max<Temp2 Then Max:=Temp2;
  Writeln(L-Max);

  Close(Input);
  Close(Output);
{  Close(Debug);}
END.

