{$Q-,R-,S-}
const eps=1e-9;
const MAXVER=5100;
const dc=50;
var pnt:array[1..MAXVER,1..2]of double;
    so:array[1..MAXVER,1..MAXVER]of byte;
    n,gn:longint;
    v,u:double;

procedure Load;
var i,j:longint;
    cx,cy,dx,dy:double;
begin
    fillchar(so,sizeof(so),0);
    read(n,u,v);
    inc(n);
    gn:=n;
    for i:=1 to n do begin
        read(pnt[i,1],pnt[i,2]);
    end;
    for i:=2 to n do begin
        so[i-1,i]:=1;
        so[i,i-1]:=1;
    end;
    for i:=2 to n do begin
        dx:=pnt[i,1]-pnt[i-1,1];
        dy:=pnt[i,2]-pnt[i-1,2];
        for j:=1 to dc-1 do begin
            cx:=pnt[i,1]+(dx*j)/dc;
            cy:=pnt[i,2]+(dy*j)/dc;
            inc(n);
            pnt[n,1]:=cx;
            pnt[n,2]:=cy;
            so[i,n]:=1;
            so[n,i]:=1;
            so[n,i-1]:=1;
            so[i-1,n]:=1;
        end;
    end;
end;

var dst:array[1..MAXVER]of double;
    was:array[1..MAXVER]of longint;

procedure Count;
var i,cver,j:longint;
    cdst,min:double;
begin
    for i:=1 to n do begin
        dst[i]:=2000000000;
        was[i]:=0;
    end;
    cver:=1;
    dst[1]:=0;
    while true do begin
        for i:=1 to n do begin
            cdst:=sqrt(sqr(pnt[cver,1]-pnt[i,1])+sqr(pnt[cver,2]-pnt[i,2]));
            if so[cver,i]=1 then cdst:=cdst/v
            else cdst:=cdst/u;
            cdst:=cdst+dst[cver];
            if dst[i]-cdst>eps then begin
                dst[i]:=cdst;
            end;
        end;
        was[cver]:=1;
        min:=2000000000;
        for i:=1 to n do begin
            if was[i]=1 then continue;
            if dst[i]<min then begin
                min:=dst[i];
                j:=i;
            end;
        end;
        if abs(min-2000000000)<eps then break;
        cver:=j;
    end;
end;

procedure Solve;
begin
    Count;
    write(dst[gn]:0:5);
end;

begin
    assign(input,'tractor.in');
    assign(output,'tractor.out');
    reset(input);
    rewrite(output);
    Load;
    Solve;
    close(input);
    close(output);
end.
