{$Q-,R-,S-}
const eps=1e-9;
var n,l,k,m:longint;
    pos:array[1..210]of double;

procedure Load;
var i:longint;
begin
    read(n,l,k,m);
    pos[1]:=0;
    for i:=1 to n do begin
        read(pos[i+1]);
    end;
    inc(n);
    for i:=1 to n do begin
        pos[n+i]:=pos[i]+l;
    end;
end;

var en,nmr:longint;
    min:extended;
    mres:array[1..110]of longint;
    res:array[1..210,1..210,0..1]of double;
    was,pth:array[1..210,1..210,0..1]of longint;
    ps,rs:array[1..210,1..210]of double;

procedure FillPOS;
var i,j,k:longint;
    po,cp1:double;
begin
    for i:=1 to 2*n do begin
        for j:=i to 2*n do begin
            po:=0;
            for k:=i to j do po:=po+pos[k];
            po:=po/(j-i+1.0);
            cp1:=0;
            for k:=i to j do begin
                cp1:=cp1+abs(pos[k]-po);
            end;
            ps[i,j]:=po;
            rs[i,j]:=cp1;
        end;
    end;
end;

function Count(pos,lft,use:longint):double;
var i,nfwd:longint;
    npos,cres:double;
begin
    if pos=en+1 then begin
        Count:=0;
        exit;
    end;
    if lft=0 then begin
        Count:=2000000000;
        exit;
    end;
    if was[pos,lft,use]<>-1 then begin
        Count:=res[pos,lft,use];
        exit;
    end;
    was[pos,lft,use]:=0;
    res[pos,lft,use]:=2000000000;
    pth[pos,lft,use]:=en+1;
    nfwd:=1;
    for i:=pos to en do begin
        if i=en then nfwd:=0;
        if (i-pos+1)+use+nfwd>k+1 then break;
        cres:=Count(i+1,lft-1,1);
        if cres>=2000000000 then continue;
        cres:=cres+rs[pos,i];
        if nfwd=1 then begin
            npos:=ps[i+1,pth[i+1,lft-1,1]];
            cres:=cres+abs(npos-ps[pos,i]);
        end;
        if res[pos,lft,use]>cres then begin
            res[pos,lft,use]:=cres;
            pth[pos,lft,use]:=i;
        end;
    end;
    Count:=res[pos,lft,use];
end;

procedure Solve;
var i,cnum,clft,cuse:longint;
    cres:double;
begin
    FillPOS;
    min:=2000000000;
    nmr:=0;
    en:=n;
    for i:=1 to n do begin
	fillchar(was,sizeof(was),$FF);
        cres:=Count(i,m,0);
        if min>cres then begin
            min:=cres;
            nmr:=1;
            mres[nmr]:=i-1;
            cnum:=i;
            clft:=m;
            cuse:=0;
            while cnum<>en+1 do begin
                inc(nmr);
                mres[nmr]:=pth[cnum,clft,cuse];
                cnum:=pth[cnum,clft,cuse]+1;
                dec(clft);
                cuse:=1;
            end;
        end;
        inc(en);
    end;
end;

procedure Save;
var i,j:longint;
    ccc:double;
begin
    write(nmr-1);
    for i:=2 to nmr do begin
        writeln;
        ccc:=ps[mres[i-1]+1,mres[i]];
        if ccc-l>-eps then ccc:=ccc-l;
        write(ccc:0:6);
        if i<nmr then write(' ',-i);
        if i>2 then write(' ',-(i-2));
        for j:=mres[i-1]+1 to mres[i] do begin
            if j-1>=n then write(' ',j-n-1)
            else write(' ',j-1);
        end;
    end;
end;

begin
    assign(input,'network.in');
    assign(output,'network.out');
    reset(input);
    rewrite(output);
    Load;
    Solve;
    Save;
    close(input);
    close(output);
end.
