const di:array[1..8]of longint=(1,1,1,0,0,-1,-1,-1);
const dj:array[1..8]of longint=(1,0,-1,1,-1,1,0,-1);
const ddi:array[1..4]of longint=(0,0,1,-1);
const ddj:array[1..4]of longint=(1,-1,0,0);
var wf:longint;
    sym:array[0..50,0..50]of char;
    n,m:longint;
    ild:longint;

function Load:boolean;
var c:char;
    i:longint;
begin
    if ild=0 then begin
        Load:=false;
        exit;
    end;
    n:=0;
    read(c);
    if c='#' then begin
        Load:=false;
        exit;
    end;
    ild:=1;
    n:=1;
    sym[1,1]:=c;
    m:=1;
    read(c);
    while(c<>#13)and(c<>#10)do begin
        inc(m);
        sym[n,m]:=c;
        read(c);
    end;
    if c=#13 then read(c);
    while (sym[n,1]<>'-')and(sym[n,1]<>'#') do begin
        inc(n);
        for i:=1 to m do begin
            read(sym[n,i]);
            if (sym[n,i]='-')then break;
            if(sym[n,i]='#')then begin
                ild:=0;
                break;
            end;
        end;
        readln;
    end;
    c:=sym[n,1];
    while(c<>#10)and(c<>#26)do read(c);
    dec(n);
    Load:=true;
end;

var was:array[0..50,0..50]of longint;

procedure Dfs(i,j,can:longint);
var k,ni,nj:longint;
begin
    was[i,j]:=1;
    for k:=1 to 8 do begin
        ni:=i+di[k];
        nj:=j+dj[k];
        if(ni<1-can)or(ni>n+can)or(nj<1-can)or(nj>m+can)then continue;
        if (was[ni,nj]=1)or(sym[ni,nj]<>sym[i,j]) then continue;
        Dfs(ni,nj,can);
    end;
end;

function CheckConn:boolean;
var i,j,f:longint;
begin
    fillchar(was,sizeof(was),0);
    f:=0;
    for i:=1 to n do begin
        for j:=1 to m do begin
            if sym[i,j]='*' then begin
                Dfs(i,j,0);
                f:=1;
                break;
            end;
        end;
        if f=1 then break;
    end;
    for i:=1 to n do begin
        for j:=1 to n do begin
            if (was[i,j]=0)and(sym[i,j]='*') then begin
                CheckConn:=false;
                exit;
            end;
        end;
    end;
    CheckConn:=true;
end;

var q:array[1..5001,1..2]of longint;
    hd,tl:longint;
    prev:array[1..51,1..51,1..2]of longint;
    cmp:array[1..51,1..51]of longint;

procedure FindComps;
var was:array[1..51,1..51]of longint;
    i,j,ccmp:longint;
procedure Dfs(i,j,can:longint);
var k,ni,nj:longint;
begin
    was[i,j]:=1;
    cmp[i,j]:=ccmp;
    for k:=1 to 4 do begin
        ni:=i+di[k];
        nj:=j+dj[k];
        if(ni<1-can)or(ni>n+can)or(nj<1-can)or(nj>m+can)then continue;
        if (was[ni,nj]=1)or(sym[ni,nj]<>sym[i,j]) then continue;
        Dfs(ni,nj,can);
    end;
end;
begin
    fillchar(was,sizeof(was),0);
    ccmp:=0;
    for i:=1 to n do begin
        for j:=1 to m do begin
            if sym[i,j]='.' then continue;
            if was[i,j]=0 then begin
                inc(ccmp);
                dfs(i,j,0);
            end;
        end;
    end;
end;

function FindNear(bi,bj:longint;var ei,ej:longint):longint;
var dst:array[1..51,1..51]of longint;
    i,j,k,ni,nj,min:longint;
begin
    for i:=1 to n do begin
        for j:=1 to m do begin
            dst[i,j]:=2000000000;
        end;
    end;
    dst[bi,bj]:=0;
    q[1,1]:=bi;
    q[1,2]:=bj;
    hd:=1;
    tl:=1;
    while hd<=tl do begin
        i:=q[hd,1];
        j:=q[hd,2];
        for k:=1 to 4 do begin
            ni:=q[hd,1]+di[k];
            nj:=q[hd,2]+dj[k];
            if(ni<1)or(ni>n)or(nj<1)or(nj>m)then continue;
            if sym[ni,nj]='*' then begin
                if dst[ni,nj]>dst[i,j]+1 then begin
                    dst[ni,nj]:=dst[i,j]+1;
                    prev[ni,nj,1]:=i;
                    prev[ni,nj,2]:=j;
                end;
                continue;
            end;
            if dst[ni,nj]>dst[i,j]+1 then begin
                dst[ni,nj]:=dst[i,j]+1;
                prev[ni,nj,1]:=i;
                prev[ni,nj,2]:=j;
                inc(tl);
                q[tl,1]:=ni;
                q[tl,2]:=nj;
            end;
        end;
        inc(hd);
    end;
    min:=2000000000;
    for i:=1 to n do begin
        for j:=1 to m do begin
            if sym[i,j]='.' then continue;
            if dst[i,j]<=1 then continue;
            if cmp[i,j]=cmp[bi,bj] then continue;
            if dst[i,j]<min then begin
                min:=dst[i,j];
                ei:=i;
                ej:=j;
            end;
        end;
    end;
    FindNear:=min;
end;

procedure Connect(i1,j1,i2,j2:longint);
var ci,cj,ni,nj:longint;
begin
    FindNear(i1,j1,ci,cj);
    if(ci<>i2)or(cj<>j2) then exit;
    while(ci<>i1)or(cj<>j1)do begin
        sym[ci,cj]:='*';
        ni:=prev[ci,cj,1];
        nj:=prev[ci,cj,2];
        ci:=ni;
        cj:=nj;
    end;
end;

procedure ConnectNearest;
var mi1,i,j,mj1,mi2,mj2,min,rs,ri,rj:longint;
begin
    min:=2000000000;
    for i:=1 to n do begin
        for j:=1 to m do begin
            if sym[i,j]='.' then continue;
            rs:=FindNear(i,j,ri,rj);
            if rs<min then begin
                min:=rs;
                mi1:=i;
                mj1:=j;
                mi2:=ri;
                mj2:=rj;
            end;
        end;
    end;
    Connect(mi1,mj1,mi2,mj2);
end;

procedure Dfs2(i,j,can:longint);
var k,ni,nj:longint;
begin
    was[i,j]:=1;
    for k:=1 to 4 do begin
        ni:=i+ddi[k];
        nj:=j+ddj[k];
        if(ni<1-can)or(ni>n+can)or(nj<1-can)or(nj>m+can)then continue;
        if (was[ni,nj]=1)or(sym[ni,nj]<>sym[i,j]) then continue;
        Dfs2(ni,nj,can);
    end;
end;

procedure GoodExpand;
var nsym:array[1..50,1..50]of char;
    ni,nj,i,j:longint;
begin
    for i:=1 to n do begin
        for j:=1 to m do nsym[i,j]:=sym[i,j];
    end;
    for i:=1 to n do begin
        for j:=2 to m-1 do begin
            if (sym[i,j-1]='*')and(sym[i,j+1]='*') then nsym[i,j]:='*';
        end;
    end;
    for i:=2 to n-1 do begin
        for j:=1 to m do begin
            if (sym[i-1,j]='*')and(sym[i+1,j]='*') then nsym[i,j]:='*';
        end;
    end;
    for i:=1 to n do begin
        for j:=1 to m do sym[i,j]:=nsym[i,j];
    end;
end;

procedure Solve;
var i,j,f:longint;
    tx,t0:longint;
begin
    GoodExpand;
    tx:=0;
    t0:=0;
    while not CheckConn do begin
        FindComps;
        ConnectNearest;
    end;
    {shift symbol}
    for i:=1 to 50 do begin
        sym[0,i]:='.';
        sym[i,0]:='.';
        sym[50,i]:='.';
        sym[i,50]:='.';
    end;
    {}
    f:=0;
    for i:=1 to n do begin
        for j:=1 to m do begin
            if sym[i,j]='.' then begin
                Dfs2(i,j,1);
                f:=1;
                break;
            end;
        end;
        if f=1 then break;
    end;
    f:=0;
    for i:=1 to n do begin
        for j:=1 to m do begin
            if (was[i,j]=0)and(sym[i,j]='.') then begin
                inc(t0);
                f:=1;
                break;
            end;
        end;
        if f=1 then break;
    end;
    if f=0 then inc(tx);
    if wf=1 then writeln
    else wf:=1;
    if tx>t0 then write('X')
    else write('0');
end;


begin
    assign(input,'x0.in');
    assign(output,'x0.out');
    reset(input);
    rewrite(output);
    wf:=0;
    ild:=1;
    while Load do begin
        Solve;
    end;
    close(input);
    close(output);
end.
