const NEEDLEN=2000;
const MAXLEN=31000;
type reallong=record
    v:array[0..MAXLEN]of longint;
    pnt,len,bper:longint;
end;

var a,b:reallong;

procedure ReadRealLong(var a:reallong);
var c:char;
begin
    a.len:=0;
    read(c);
    while (c>='0')and(c<='9')do begin
        inc(a.len);
        a.v[a.len]:=ord(c)-ord('0');
        read(c);
    end;
    a.pnt:=a.len;
    a.bper:=a.len+1;
    if c='.' then begin
        read(c);
        while (c>='0')and(c<='9')do begin
            inc(a.len);
            a.v[a.len]:=ord(c)-ord('0');
            read(c);
        end;
        a.bper:=a.len+1;
        if c='(' then begin
            read(c);
            while c<>')' do begin
                inc(a.len);
                a.v[a.len]:=ord(c)-ord('0');
                read(c);
            end;
        end;
    end;
    while(c<>#10)and(c<>#26)do read(c);
end;

procedure Load;
begin
    fillchar(a,sizeof(a),0);
    fillchar(b,sizeof(b),0);
    REadRealLong(a);
    ReadRealLong(b);
end;

var r:reallong;

function Find(pos:longint):boolean;
begin
    if a.v[pos]>0 then begin
        Find:=true;
        exit;
    end;
    if pos=1 then Find:=false
    else Find:=Find(pos-1);
end;

function Bigger(pos:longint):boolean;
var i:longint;
begin
    if pos<1 then begin
        Bigger:=false;
        exit;
    end;
    if (pos>1)and(Find(pos-1)) then begin
        Bigger:=true;
        exit;
    end;
    for i:=pos to pos+b.len-1 do begin
        if a.v[i]>b.v[i-pos+1] then begin
            Bigger:=true;
            exit;
        end
        else if b.v[i-pos+1]>a.v[i] then begin
            Bigger:=false;
            exit;
        end;
    end;
    Bigger:=true;
end;

procedure Decrease(pos:longint);
var i,j:longint;
begin
    for i:=pos to pos+b.len-1 do begin
        a.v[i]:=a.v[i]-b.v[i-pos+1];
        j:=i;
        while a.v[j]<0 do begin
            dec(a.v[j-1]);
            inc(a.v[j],10);
            dec(j);
        end;
    end;
end;

procedure Divide(pos:longint);
var k:longint;
begin
    k:=0;
    while Bigger(pos-b.pnt+1) do begin
        Decrease(pos-b.pnt+1);
        inc(k);
    end;
    r.v[pos]:=k;
    r.len:=pos;
end;

procedure FindPeriod;
var i,plen,np,f,k,kk,pper,val,ff,per:longint;
    p:array[1..MAXLEN]of longint;
begin
    r.len:=NEEDLEN;
    f:=0;
    pper:=r.len-r.pnt;
    per:=0;
    for i:=0 to r.len-r.pnt do begin
        for plen:=1 to r.len-r.pnt do begin
            p[1]:=r.pnt+i+1;
            np:=1;
            while p[np]+plen-1<=r.len do begin
                inc(np);
                p[np]:=p[np-1]+plen;
            end;
            dec(np);
            if np=0 then continue;
            if(np=1)then continue;
            {check}
            ff:=1;
            for k:=1 to plen do begin
                val:=r.v[p[1]];
                for kk:=1 to np do begin
                    if r.v[p[kk]]<>val then begin
                        ff:=0;
                        break;
                    end;
                    inc(p[kk]);
                end;
                if ff=0 then break;
            end;
            if ff=1 then begin
                pper:=i;
                per:=plen;
                f:=1;
                break;
            end;
        end;
        if f=1 then break;
    end;
    r.bper:=pper+r.pnt+1;
    r.len:=r.bper+per-1;
    if per=1 then begin
        if r.v[r.bper]=0 then begin
            dec(r.len);
        end
        else if r.v[r.bper]=9 then begin
            dec(r.len);
            inc(r.v[r.len]);
            while r.v[r.len]>9 do begin
                inc(r.v[r.len-1]);
                dec(r.v[r.len],10);
                if (r.v[r.len]=0)and(r.len>r.pnt) then dec(r.len);
            end;
        end;
    end;
    if r.v[0]>0 then begin
        inc(r.len);
        inc(r.pnt);
        inc(r.bper);
        for i:=r.len downto 1 do r.v[i]:=r.v[i-1];
    end;
end;

procedure Solve;
var i,wl:longint;
begin
    fillchar(r,sizeof(r),0);
    while(a.len-a.pnt)<=2*NEEDLEN do begin
        if a.bper>a.len then break;
        wl:=a.len;
        for i:=a.bper to wl do begin
            inc(a.len);
            a.v[a.len]:=a.v[i];
        end;
        a.bper:=wl+1;
    end;
    while(b.len-b.pnt)<=NEEDLEN do begin
        if b.bper>b.len then break;
        wl:=b.len;
        for i:=b.bper to wl do begin
            inc(b.len);
            b.v[b.len]:=b.v[i];
        end;
        b.bper:=wl+1;
    end;
    i:=1;
    while (i<=NEEDLEN)and(r.len<MAXLEN) do begin
        Divide(i);
        if i=a.pnt then
            r.pnt:=r.len;
        if(i=a.len)and(a.v[i]>0)then begin
            inc(a.len);
        end;
        inc(i);
    end;
    FindPeriod;
end;

procedure Save;
var i:longint;
begin
    i:=1;
    while (i<r.pnt)and(r.v[i]=0) do inc(i);
    while i<=r.len do begin
        if r.pnt=i-1 then write('.');
        if r.bper=i then write('(');
        write(r.v[i]);
        inc(i);
    end;
    if r.bper<=r.len then write(')');
end;

begin
    assign(input,'divide.in');
    assign(output,'divide.out');
    reset(input);
    rewrite(output);
    Load;
    Solve;
    Save;
    close(input);
    close(output);
end.
