{$Q-,R-,S-}
const dx:array[1..8]of longint=(0,0,1,-1,1,1,-1,-1);
const dy:array[1..8]of longint=(1,-1,0,0,-1,1,1,-1);
const MAXN=510;
var n,xs,ys,xt,yt:longint;
    sp:array[1..MAXN,1..2]of longint;
    byx,byy,byp,bym:array[1..MAXN]of longint;

procedure QsortBYX(be,en:longint);
var l,r,t,x:longint;
begin
    l:=be;
    r:=en;
    t:=l+random(r-l+1);
    x:=sp[byx[t],1];
    while l<r do begin
        while x>sp[byx[l],1] do inc(l);
        while x<sp[byx[r],1] do dec(r);
        if l<=r then begin
            t:=byx[l];
            byx[l]:=byx[r];
            byx[r]:=t;
            inc(l);
            dec(r);
        end;
    end;
    if be<r then QsortBYX(be,r);
    if l<en then QsortBYX(l,en);
end;

procedure QsortBYY(be,en:longint);
var l,r,t,x:longint;
begin
    l:=be;
    r:=en;
    t:=l+random(r-l+1);
    x:=sp[byy[t],2];
    while l<r do begin
        while x>sp[byy[l],2] do inc(l);
        while x<sp[byy[r],2] do dec(r);
        if l<=r then begin
            t:=byy[l];
            byy[l]:=byy[r];
            byy[r]:=t;
            inc(l);
            dec(r);
        end;
    end;
    if be<r then QsortBYY(be,r);
    if l<en then QsortBYY(l,en);
end;

procedure QsortBYP(be,en:longint);
var l,r,t,x:longint;
begin
    l:=be;
    r:=en;
    t:=l+random(r-l+1);
    x:=sp[byp[t],1]+sp[byp[t],2];
    while l<r do begin
        while x>sp[byp[l],1]+sp[byp[l],2] do inc(l);
        while x<sp[byp[r],1]+sp[byp[r],2] do dec(r);
        if l<=r then begin
            t:=byp[l];
            byp[l]:=byp[r];
            byp[r]:=t;
            inc(l);
            dec(r);
        end;
    end;
    if be<r then QsortBYP(be,r);
    if l<en then QsortBYP(l,en);
end;

procedure QsortBYM(be,en:longint);
var l,r,t,x:longint;
begin
    l:=be;
    r:=en;
    t:=l+random(r-l+1);
    x:=sp[bym[t],1]-sp[bym[t],2];
    while l<r do begin
        while x>sp[bym[l],1]-sp[bym[l],2] do inc(l);
        while x<sp[bym[r],1]-sp[bym[r],2] do dec(r);
        if l<=r then begin
            t:=bym[l];
            bym[l]:=bym[r];
            bym[r]:=t;
            inc(l);
            dec(r);
        end;
    end;
    if be<r then QsortBYM(be,r);
    if l<en then QsortBYM(l,en);
end;

var np:array[1..MAXN*10,1..2]of longint;
    nn:longint;

procedure Load;
var i,j,f,nx,ny,k:longint;
begin
    read(xs,ys,xt,yt,n);
    for i:=1 to n do begin
        read(sp[i,1],sp[i,2]);
        byx[i]:=i;
        byy[i]:=i;
        byp[i]:=i;
        bym[i]:=i;
    end;
    QsortBYX(1,n);
    QsortBYY(1,n);
    QsortBYP(1,n);
    QsortBYM(1,n);
    nn:=2;
    np[1,1]:=xs;
    np[1,2]:=ys;
    np[2,1]:=xt;
    np[2,2]:=yt;
    for i:=1 to n do begin
        for j:=1 to 4 do begin
            nx:=sp[i,1]+dx[j];
            ny:=sp[i,2]+dy[j];
            f:=1;
            for k:=1 to n do begin
                if (sp[k,1]=nx)and(sp[k,2]=ny) then begin
                    f:=0;
                    break;
                end;
            end;
            for k:=1 to nn do begin
                if (np[k,1]=nx)and(np[k,2]=ny) then begin
                    f:=0;
                    break;
                end;
            end;
            if f=1 then begin
                inc(nn);
                np[nn,1]:=nx;
                np[nn,2]:=ny;
            end;
        end;
    end;
end;

function min(a,b:longint):longint;
begin
    if a<b then min:=a
    else min:=b;
end;

function max(a,b:longint):longint;
begin
    if a>b then max:=a
    else max:=b;
end;

function FindP(val,x:longint):longint;
var mi,l,r,vl,mid,min:longint;
begin
    min:=n+1;
    l:=1;
    r:=n;
    while l<=r do begin
        mid:=(l+r) div 2;
        vl:=sp[byp[mid],1]+sp[byp[mid],2];
        if vl=val then begin
            if min>mid then min:=mid;
        end;
        if vl<val then begin
            l:=mid+1;
        end
        else begin
            r:=mid-1;
        end;
    end;
    if min=n+1 then begin
        FindP:=0;
        exit;
    end;
    l:=min;
    min:=2000000000;
    mi:=0;
    while (l<=n)and(sp[byp[l],1]+sp[byp[l],2]=val) do begin
        if (sp[byp[l],1]>=x)and(sp[byp[l],1]<min)then begin
            min:=sp[byp[l],1];
            mi:=l;
        end;
        inc(l);
    end;
    FindP:=byp[mi];
end;

function FindM(val,x:longint):longint;
var mi,l,r,vl,mid,min:longint;
begin
    min:=n+1;
    l:=1;
    r:=n;
    while l<=r do begin
        mid:=(l+r) div 2;
        vl:=sp[bym[mid],1]-sp[bym[mid],2];
        if vl=val then begin
            if min>mid then min:=mid;
        end;
        if vl<val then begin
            l:=mid+1;
        end
        else begin
            r:=mid-1;
        end;
    end;
    if min=n+1 then begin
        FindM:=0;
        exit;
    end;
    l:=min;
    min:=2000000000;
    mi:=0;
    while (l<=n)and(sp[bym[l],1]-sp[bym[l],2]=val) do begin
        if (sp[bym[l],1]>=x)and(sp[bym[l],1]<min)then begin
            min:=sp[bym[l],1];
            mi:=l;
        end;
        inc(l);
    end;
    FindM:=bym[mi];
end;


function FindY(val,x:longint):longint;
var mi,l,r,vl,mid,min:longint;
begin
    min:=n+1;
    l:=1;
    r:=n;
    while l<=r do begin
        mid:=(l+r) div 2;
        vl:=sp[byy[mid],2];
        if vl=val then begin
            if min>mid then min:=mid;
        end;
        if vl<val then begin
            l:=mid+1;
        end
        else begin
            r:=mid-1;
        end;
    end;
    if min=n+1 then begin
        FindY:=0;
        exit;
    end;
    l:=min;
    min:=2000000000;
    mi:=0;
    while (l<=n)and(sp[byy[l],2]=val) do begin
        if (sp[byy[l],1]>=x)and(sp[byy[l],1]<min)then begin
            min:=sp[byy[l],1];
            mi:=l;
        end;
        inc(l);
    end;
    FindY:=byy[mi];
end;

function FindX(val,x:longint):longint;
var mi,l,r,vl,mid,min:longint;
begin
    min:=n+1;
    l:=1;
    r:=n;
    while l<=r do begin
        mid:=(l+r) div 2;
        vl:=sp[byx[mid],1];
        if vl=val then begin
            if min>mid then min:=mid;
        end;
        if vl<val then begin
            l:=mid+1;
        end
        else begin
            r:=mid-1;
        end;
    end;
    if min=n+1 then begin
        FindX:=0;
        exit;
    end;
    l:=min;
    min:=2000000000;
    mi:=0;
    while (l<=n)and(sp[byx[l],1]=val) do begin
        if (sp[byx[l],2]>=x)and(sp[byx[l],2]<min)then begin
            min:=sp[byx[l],1];
            mi:=l;
        end;
        inc(l);
    end;
    FindX:=byx[mi];
end;


function GetEdge(i11,i21:longint):longint;
var f,dx,dy,nx,ny,ind,i1,i2,i:longint;
    rs:int64;
begin
    for i:=1 to 2 do BEGIN
    if i=1 then begin
        i1:=i11;
        i2:=i21;
    end
    else begin
        i1:=i21;
        i2:=i11;
    end;
    {from i1 by diagonal}
    f:=1;
    dx:=np[i2,1]-np[i1,1];
    dy:=np[i2,2]-np[i1,2];
    if (dx=0)or(dy=0) then begin
        nx:=np[i1,1];
        ny:=np[i1,2];
    end
    else if((dx<0)and(dy>0))or((dx>0)and(dy<0)) then begin
        if abs(dx)<abs(dy) then begin
            nx:=np[i2,1];
            ny:=np[i1,1]+np[i1,2]-nx;
        end
        else begin
            ny:=np[i2,2];
            nx:=np[i1,1]+np[i1,2]-ny;
        end;
        ind:=FindP(np[i1,1]+np[i1,2],min(np[i1,1],nx));
        if (ind<>0)and(sp[ind,1]<=max(np[i1,1],nx)) then f:=0;
    end
    else begin
        if abs(dx)<abs(dy) then begin
            nx:=np[i2,1];
            ny:=-np[i1,1]+np[i1,2]+nx;
        end
        else begin
            ny:=np[i2,2];
            nx:=np[i1,1]-np[i1,2]+ny;
        end;
        ind:=FindM(np[i1,1]-np[i1,2],min(np[i1,1],nx));
        if (ind<>0)and(sp[ind,1]<=max(np[i1,1],nx)) then f:=0;
    end;
    if f=1 then begin
        if(nx=np[i1,1])and(ny=np[i1,2])then begin
            if dy=0 then begin
                ind:=FindY(ny,min(nx,np[i2,1]));
                if (ind<>0)and(sp[ind,1]<=max(nx,np[i2,1])) then f:=0;
            end
            else begin
                ind:=FindX(nx,min(ny,np[i2,2]));
                if (ind<>0)and(sp[ind,2]<=max(ny,np[i2,2])) then f:=0;
            end;
        end
        else if nx=np[i2,1] then begin
            ind:=FindX(nx,min(ny,np[i2,2]));
            if (ind<>0)and(sp[ind,2]<=max(ny,np[i2,2])) then f:=0;
        end
        else begin
            ind:=FindY(ny,min(nx,np[i2,1]));
            if (ind<>0)and(sp[ind,1]<=max(nx,np[i2,1])) then f:=0;
        end;
    end;
    if f=1 then begin
        GetEdge:=max(abs(dx),abs(dy));
        exit;
    end;
    END;
    rs:=maxlongint;
    getEdge:=rs;
end;

var was:array[1..MAXN*9]of longint;
    dst:array[1..MAXN*9]of longint;

procedure DeixtRA;
var min,cver,i:longint;
    val:int64;
begin
    fillchar(was,sizeof(was),0);
    for i:=1 to nn do begin
        dst[i]:=maxlongint;
    end;
    dst[1]:=0;
    cver:=1;
    while true do begin
        for i:=1 to nn do begin
            if i=cver then continue;
            val:=GetEdge(cver,i);
            val:=val+dst[cver];
            if val>=maxlongint then continue;
            if dst[i]>val then begin
                dst[i]:=val;
            end;
        end;
        was[cver]:=1;
        min:=maxlongint;
        for i:=1 TO NN DO BEGIN
            if was[i]=1 then continue;
            if dst[i]<min then begin
                min:=dst[i];
                cver:=i;
            end;
        END;
        if min=maxlongint then break;
    end;
end;


procedure Solve;
begin
    DeixtRA;
    if dst[2]=maxlongint then write('-1')
    else write(dst[2]);
end;


begin
    assign(input,'king.in');
    assign(output,'king.out');
    reset(input);
    rewrite(output);
    Load;
    Solve;
    close(input);
    close(output);
end.
