const eps=1e-9;
var xs,ls:array[1..5100]of extended;
    n:longint;

procedure Load;
var i:longint;
begin
    read(n);
    for i:=1 to n do begin
        read(xs[i],ls[i]);
    end;
end;

function Equal(i,j:longint):boolean;
begin
    if (abs(xs[i]-xs[j])<eps)and(abs(ls[i]-ls[j])<eps)then Equal:=true
    else Equal:=false;
end;

procedure GetIntersection(n1,n2:longint;var x,y:extended);
var aa,cc,c,xm:extended;
    t:longint;
begin
    if(xs[n2]<xs[n1])then begin
        t:=n1;
        n1:=n2;
        n2:=t;
    end;
    {count XM}
    aa:=2*xs[n2]-2*xs[n1];
    cc:=sqr(ls[n1])-sqr(ls[n2])+sqr(xs[n2])-sqr(xs[n1]);
    if(abs(aa)<eps)then begin
      y:=2000000000;
      x:=0;
      exit;
    end;
    xm:=cc/aa;
    {}
    c:=-(ls[n1]*ls[n1])+xm*xm-2*xm*xs[n1]+xs[n1]*xs[n1];
    c:=-c;
    if(c<-eps)then begin
        y:=2000000000;
        x:=0;
        exit;
    end
    else if(abs(c)<eps)then begin
        y:=0;
        x:=xm;
        exit;
    end
    else begin
        y:=-sqrt(c);
        x:=xm;
        exit;
    end;
end;

procedure Solve;
var mx,my,x,y,dx1,dx2:extended;
    i,j:longint;
begin
    i:=1;
    while (i<=n-1)and(Equal(i,i+1))do inc(i);
    if i=n then begin
        write(xs[1]:0:4,' ',-ls[1]:0:4);
        exit;
    end;
    my:=-2000000000;
    mx:=0;
    for i:=1 to n do begin
      x:=xs[i];
      y:=-ls[i];
      if y>my then begin
        mx:=x;
        my:=y;
      end;
    end;
    {check for canning}
    for i:=1 to n do begin
        for j:=i+1 to n do begin
            if abs(xs[i]-xs[j])-ls[i]-ls[j]>eps then begin
                write('-1 -1');
                exit;
            end;
        end;
    end;
    {}
    for i:=1 to n do begin
        for j:=i+1 to n do begin
            GetIntersection(i,j,x,y);
            if(y>eps)then continue;
            dx1:=x-xs[i];
            dx2:=x-xs[j];
            if dx1*dx2<eps then begin
                if y>my then begin
                    my:=y;
                    mx:=x;
                end;
            end;
        end;
    end;
    if(abs(my-2000000000)<eps) then write('-1 -1')
    else write(mx:0:4,' ',my:0:4);
end;

begin
    assign(input,'popular.in');
    assign(output,'popular.out');
    reset(input);
    rewrite(output);
    Load;
    Solve;
    close(input);
    close(output);
end.
