const MAXVAL=720;
var s:string;

procedure Load;
begin
    readln(s);
end;

var res:array[0..81,0..81]of smallint;
    can:array[1..81,1..81,1..2*MAXVAL]of smallint;
    ncan:array[1..81,1..81]of longint;
procedure Count(be,en:longint);
var ii,jj,i,j:longint;
    cn:array[-MAXVAL..MAXVAL]of byte;
begin
    if res[be,en]<>-1 then begin
        exit;
    end;
    fillchar(cn,sizeof(cn),0);
    {prefix}
    if (s[be]='+')or(s[be]='-') then begin
        for i:=be+1 to en-1 do begin
            if res[be+1,i]=-2 then continue;
            if res[i+1,en]=-2 then continue;
            Count(be+1,i);
            Count(i+1,en);
            for ii:=1 to ncan[be+1,i] do begin
                for jj:=1 to ncan[i+1,en] do begin
                    if s[be]='+' then cn[can[be+1,i,ii]+can[i+1,en,jj]]:=1
                    else cn[can[be+1,i,ii]-can[i+1,en,jj]]:=1;
                end;
            end;
        end;
    end;
    {postfix}
    if (s[en]='+')or(s[en]='-') then begin
        for i:=be to en-2 do begin
            if res[be,i]=-2 then continue;
            if res[i+1,en-1]=-2 then continue;
            Count(be,i);
            Count(i+1,en-1);
            for ii:=1 to ncan[be,i] do begin
                for jj:=1 to ncan[i+1,en-1] do begin
                    if s[en]='+' then cn[can[be,i,ii]+can[i+1,en-1,jj]]:=1
                    else cn[can[be,i,ii]-can[i+1,en-1,jj]]:=1;
                end;
            end;
        end;
    end;
    {normal}
    for i:=be to en do begin
        if (s[i]='+')or(s[i]='-')then begin
            if res[be,i-1]=-2 then continue;
            if res[i+1,en]=-2 then continue;
            Count(be,i-1);
            Count(i+1,en);
            for ii:=1 to ncan[be,i-1] do begin
                for jj:=1 to ncan[i+1,en] do begin
                    if s[i]='+' then cn[can[be,i-1,ii]+can[i+1,en,jj]]:=1
                    else cn[can[be,i-1,ii]-can[i+1,en,jj]]:=1;
                end;
            end;
        end;
    end;
    ncan[be,en]:=0;
    for i:=-MAXVAL to MAXVAL do if cn[i]=1 then begin
        inc(ncan[be,en]);
        can[be,en,ncan[be,en]]:=i;
    end;
    res[be,en]:=1;
    if ncan[be,en]=0 then res[be,en]:=-2;
end;

procedure Solve;
var i,rs:longint;
begin
    fillchar(res,sizeof(res),$FF);
    fillchar(can,sizeof(can),0);
    for i:=1 to length(s) do begin
        if (s[i]>='0')and(s[i]<='9') then begin
            res[i,i]:=1;
            can[i,i,1]:=ord(s[i])-ord('0');;
            ncan[i,i]:=1;
        end
        else begin
            res[i,i]:=-2;
        end;
    end;
    for i:=1 to 80 do begin
        res[0,i]:=-2;
        res[i,0]:=-2;
    end;
    Count(1,length(s));
    write(ncan[1,length(s)]);
end;

begin
    assign(input,'expr.in');
    assign(output,'expr.out');
    reset(input);
    rewrite(output);
    Load;
    Solve;
    close(input);
    close(output);
end.
