const MAXN=210000;
const eps=1e-12;
var n,k:longint;
    ang:array[1..MAXN]of double;
    val:array[1..MAXN]of longint;
    csum:array[0..MAXN]of int64;

procedure Qsort(be,en:longint);
var l,r,tl:longint;
    x,t:extended;
begin
    l:=be;
    r:=en;
    x:=ang[l+random(r-l+1)];
    while l<r do begin
        while x-ang[l]>eps do inc(l);
        while x-ang[r]<-eps do dec(r);
        if l<=r then begin
            t:=ang[l];
            ang[l]:=ang[r];
            ang[r]:=t;
            tl:=val[l];
            val[l]:=val[r];
            val[r]:=tl;
            inc(l);
            dec(r);
        end;
    end;
    if be<r then Qsort(be,r);
    if l<en then Qsort(l,en);
end;

procedure Load;
var i,lt:longint;
    t:double;
begin
    read(n,k);
    for i:=1 to n do begin
        readln(t,val[i]);
        ang[i]:=t;
        if ang[i]>2*PI then begin
            t:=ang[i]/(2*PI);
            lt:=trunc(t);
            ang[i]:=ang[i]-lt*2*PI;
        end;
    end;
    Qsort(1,n);
    for i:=1 to n do begin
        val[n+i]:=val[i];
        ang[n+i]:=2*PI+ang[i];
    end;
end;


function Search(beg:longint;an:double):longint;
var max,l,r,mid:longint;
    al:double;
begin
    l:=beg;
    r:=2*n;
    al:=ang[beg]+an;
    max:=-2000000000;
    while l<=r do begin
        mid:=(l+r)div 2;
        if ang[mid]-al<-eps then begin
            if mid>max then max:=mid;
            l:=mid+1;
        end
        else begin
            r:=mid-1;
        end;
    end;
    Search:=max;
end;

procedure Solve;
var i,j,min,cr,nxt,mi,cur,en:longint;
    max,min2,mn,crr:int64;
    cbang:double;
begin
    csum[0]:=0;
    for i:=1 to 2*n do begin
        csum[i]:=csum[i-1]+val[i];
    end;
    {find optimal otr}
    min:=2000000000;
    for i:=1 to n do begin
        nxt:=Search(i,2*PI/k);
        j:=nxt-i+1;
        if j<min then begin
            min:=j;
            mi:=i;
        end;
    end;
    mn:=2000000000;
    mn:=mn*mn;
    cur:=mi;
    en:=Search(mi,2*PI/k);
    while cur<=en do begin
        max:=2000000000;
        max:=-max*max;
        min2:=2000000000;
        min2:=min2*min2;
        cr:=cur;
        nxt:=Search(cr,2*PI/k-eps);
        cbang:=ang[cr];
        for i:=1 to k do begin
            if cr=0 then crr:=0
            else crr:=csum[nxt]-csum[cr-1];
            if crr>max then max:=crr;
            if crr<min2 then min2:=crr;
            {recount cr and nxt}
            cbang:=cbang+2*PI/k;
            if ang[nxt+1]>cbang+2*PI/k then begin
                cr:=0;
            end
            else begin
                cr:=nxt+1;
                nxt:=Search(cr,2*Pi/k-(ang[cr]-cbang));
            end;
        end;
        if max-min2<mn then mn:=max-min2;
        inc(cur);
    end;
    write(mn);
end;

begin
    assign(input,'necklace.in');
    assign(output,'necklace.out');
    reset(input);
    rewrite(output);
    Load;
    Solve;
    close(input);
    close(output);
end.
