const MAXN=1100;
var s:array[1..MAXN]of longint;
    n:longint;

procedure Load;
var c:char;
begin
    n:=0;
    read(c);
    while (c>='0')and(c<='9') do begin
        inc(n);
        s[n]:=ord(c)-ord('0');
        read(c);
    end;
end;

var nxt:array[1..MAXN,0..MAXN,1..2]of longint;
    rs:array[1..MAXN,0..MAXN]of longint;
    rlen:array[1..MAXN,1..MAXN]of longint;
    mseq:array[1..MAXN]of longint;
    nms:longint;

function GetRLen(be,en:longint):longint;
begin
    if rlen[be,en]<>-1 then begin
        GetRLen:=rlen[be,en];
        exit;
    end;
    if be=en then begin
        rlen[be,en]:=1;
        GetRlen:=rlen[be,en];
        exit;
    end;
    if s[be]=0 then rlen[be,en]:=GetRlen(be+1,en)
    else rlen[be,en]:=en-be+1;
    GetRLen:=rlen[be,en];
end;

function Bigger(b1,e1,e2:longint):boolean;
var l1,l2,b2,i1,i2:longint;
begin
    b2:=e1+1;
    l1:=rlen[b1,e1];
    l2:=rlen[b2,e2];
    if l2>l1 then Bigger:=true
    else if l1>l2 then Bigger:=false
    else begin
        i1:=b1;
        while(i1<e1)and(s[i1]=0)do inc(i1);
        i2:=b2;
        while(i2<e2)and(s[i2]=0)do inc(i2);
        while(i1<=e1)do begin
            if s[i2]>s[i1] then begin
                Bigger:=true;
                exit;
            end
            else if s[i1]>s[i2] then begin
                Bigger:=false;
                exit;
            end;
            inc(i1);
            inc(i2);
        end;
        Bigger:=false;
    end;
end;

function Search(beg,en:longint):longint;
var l,r,mid,min:longint;
begin
    l:=en+1;
    r:=n;
    min:=2000000000;
    while l<=r do begin
        mid:=(l+r)div 2;
        if Bigger(beg,en,mid) then begin
            if mid<min then min:=mid;
            r:=mid-1;
        end
        else begin
            l:=mid+1;
        end;
    end;
    Search:=min;
end;

function Count(pos,prev:longint):longint;
var npos,cres:longint;
begin
    if pos>=n then begin
        Count:=n-rlen[prev+1,n]+1;
        exit;
    end;
    if rs[pos,prev]<>-1 then begin
        Count:=rs[pos,prev];
        exit;
    end;
    rs[pos,prev]:=Count(pos+1,prev);
    nxt[pos,prev,1]:=pos+1;
    nxt[pos,prev,2]:=prev;
    {try to fill number}
    npos:=Search(prev+1,pos);
    if npos<=n then begin
        cres:=Count(npos,pos);
        if rs[pos,prev]<cres then begin
            rs[pos,prev]:=cres;
            nxt[pos,prev,1]:=npos;
            nxt[pos,prev,2]:=pos;
        end;
    end;
    Count:=rs[pos,prev];
end;

procedure Solve;
var i,cpos,cprev,np,npp:longint;
begin
    fillchar(rs,sizeof(rs),$FF);
    fillchar(rlen,sizeof(rlen),$FF);
    for np:=1 to n do begin
        for npp:=np to n do begin
            getRlen(np,npp);
        end;
    end;
    Count(1,0);
    cpos:=1;
    cprev:=0;
    nms:=0;
    while cpos<>n do begin
        if nxt[cpos,cprev,2]=cpos then begin
            inc(nms);
            mseq[nms]:=cpos;
        end;
        np:=nxt[cpos,cprev,1];
        npp:=nxt[cpos,cprev,2];
        cpos:=np;
        cprev:=npp;
    end;
    cpos:=1;
    for i:=1 to n do begin
        write(s[i]);
        if i=mseq[cpos] then begin
            write(',');
            inc(cpos);
        end;
    end;
end;

begin
    assign(input,'commas.in');
    assign(output,'commas.out');
    reset(input);
    rewrite(output);
    Load;
    Solve;
    close(input);
    close(output);
end.
