var a:array[1..31,1..4]of longint;
    fnum:array[1..31]of longint;
    n,b,c:longint;

procedure Qsort(be,en:longint);
var l,r,x,t:longint;
begin
    l:=be;
    r:=en;
    x:=a[l+random(r-l+1),4];
    while l<r do begin
        while x>a[l,4] do inc(l);
        while x<a[r,4] do dec(r);
        if l<=r then begin
            t:=a[l,1];
            a[l,1]:=a[r,1];
            a[r,1]:=t;
            t:=a[l,2];
            a[l,2]:=a[r,2];
            a[r,2]:=t;
            t:=a[l,3];
            a[l,3]:=a[r,3];
            a[r,3]:=t;
            t:=a[l,4];
            a[l,4]:=a[r,4];
            a[r,4]:=t;
            t:=fnum[l];
            fnum[l]:=fnum[r];
            fnum[r]:=t;
            inc(l);dec(r);
        end;
    end;
    if be<r then Qsort(be,r);
    if l<en then Qsort(l,en);
end;

procedure Load;
var i:longint;
begin
    read(c,b,n);
    for i:=1 to n do begin
        read(a[i,1],a[i,2],a[i,3]);
        a[i,4]:=(a[i,2]-a[i,1])*a[i,3];
        fnum[i]:=i;
    end;
    Qsort(1,n);
end;

var mset,cset:array[1..31]of byte;
    msum,csum:longint;

function TrySubSet(st:longint):longint;
var sum,i,j,f:longint;
    cval:array[0..20]of longint;
begin
    fillchar(cset,sizeof(cset),0);
    fillchar(cval,sizeof(cval),0);
    sum:=0;
    for i:=n downto 1 do begin
        if (st and (1 shl a[i,1])=0)or(st and (1 shl a[i,2])=0)then continue;
        f:=0;
        for j:=a[i,1] to a[i,2]-1 do begin
            if cval[j]+a[i,3]>c then begin
                f:=1;
                break;
            end;
        end;
        if f=1 then continue;
        for j:=a[i,1] to a[i,2]-1 do inc(cval[j],a[i,3]);
        cset[fnum[i]]:=1;
        inc(sum,a[i,4]);
    end;
    for i:=n downto 1 do begin
        if cset[fnum[i]]=1 then continue;
        f:=0;
        for j:=a[i,1] to a[i,2]-1 do begin
            if cval[j]+a[i,3]>c then begin
                f:=1;
                break;
            end;
        end;
        if f=1 then continue;
        for j:=a[i,1] to a[i,2]-1 do inc(cval[j],a[i,3]);
        cset[fnum[i]]:=1;
        inc(sum,a[i,4]);
    end;
    TrySubSet:=sum;
end;


function CanBeSubSet(st:longint):boolean;
var cinc:array[0..20]of longint;
    cc,i:longint;
begin
    fillchar(cinc,sizeof(cinc),0);
    for i:=1 to n do begin
        if (st and (1 shl (i-1)))=0 then continue;
        inc(cinc[a[i,1]],a[i,3]);
        dec(cinc[a[i,2]],a[i,3]);
    end;
    cc:=0;
    for i:=0 to b do begin
        inc(cc,cinc[i]);
        if cc>c then begin
            CanBeSubSet:=false;
            exit;
        end;
    end;
    CanBeSubSet:=true;
end;

procedure Solve;
var i,wf,mst,j,sst:longint;
begin
    if n>20 then begin
        fillchar(mset,sizeof(mset),0);
        msum:=0;
        j:=b+1;
        sst:=1 shl (j)-1;
        while sst>310000 do begin
            dec(j);
            sst:=1 shl (j)-1;
        end;
        for i:=0 to sst do begin
            csum:=TrySubSet(i);
            if csum>msum then begin
                msum:=csum;
                move(cset,mset,sizeof(mset));
            end;
        end;
        wf:=0;
        writeln(msum);
        for i:=1 to n do begin
            if mset[i]=1 then begin
                if wf=1 then write(' ')
                else wf:=1;
                write(i);
            end;
        end;
    end
    else begin
        msum:=0;
        mst:=0;
        for i:=0 to (1 shl n)-1 do begin
            if CanbeSubSet(i) then begin
                csum:=0;
                for j:=1 to n do begin
                    if (i and(1 shl (j-1)))=0 then continue;
                    inc(csum,a[j,4]);
                end;
                if csum>msum then begin
                    msum:=csum;
                    mst:=i;
                end;
            end;
        end;
        fillchar(mset,sizeof(mset),0);
        writeln(msum);
        wf:=0;
        for i:=1 to n do begin
            if mst and(1 shl (i-1))=0 then continue;
            mset[fnum[i]]:=1;
        end;
        for i:=1 to n do begin
            if mset[i]=0 then continue;
            if wf=1 then write(' ')
            else wf:=1;
            write(i);
        end;
    end;
end;

begin
    assign(input,'trains.in');
    assign(output,'trains.out');
    reset(input);
    rewrite(output);
    Load;
    Solve;
    close(input);
    close(output);
end.
