var edg:array[1..251,1..2]of longint;
    n,p:longint;
    prev,was:array[1..251]of longint;

procedure Dfs(ver:longint);
var i:longint;
begin
    was[ver]:=1;
    for i:=1 to n-1 do begin
        if edg[i,1]=ver then begin
            if was[edg[i,2]]=1 then continue;
            prev[edg[i,2]]:=ver;
            Dfs(edg[i,2]);
        end
        else if edg[i,2]=ver then begin
            if was[edg[i,1]]=1 then continue;
            prev[edg[i,1]]:=ver;
            Dfs(edg[i,1]);
        end;
    end;
end;

procedure Load;
var i,t:longint;
begin
    read(n,p);
    for i:=1 to n-1 do begin
        read(edg[i,1],edg[i,2]);
        if edg[i,2]<edg[i,1] then begin
            t:=edg[i,1];
            edg[i,1]:=edg[i,2];
            edg[i,2]:=t;
        end;
    end;
    fillchar(was,sizeof(was),0);
    Dfs(1);
    prev[1]:=0;
end;

var cld:array[0..251,1..251]of longint;
    ncld:array[0..251]of longint;
    res:array[0..251,0..251]of longint;
    numm:array[0..251,0..251]of longint;
    nm:array[0..251]of longint;

function Count(ver,num:longint):longint;
var i,cres:longint;
begin
    if (ver=0)and(num=0) then begin
        Count:=0;
        exit;
    end;
    if (ver=0)and(num>0) then begin
        Count:=2000000000;
        exit;
    end;
    if num<0 then begin
        Count:=2000000000;
        exit;
    end;
    if res[ver,num]<>-1 then begin
        Count:=res[ver,num];
        exit;
    end;
    {we are the last child of our parent}
    if nm[ver]=ncld[prev[ver]] then begin
        if num=0 then begin
            res[ver,num]:=1;
        end
        else begin
            {we don't have children}
            if ncld[ver]=0 then begin
                if num=1 then res[ver,num]:=0
                else res[ver,num]:=2000000000;
            end
            else begin
                res[ver,num]:=Count(cld[ver,1],num-1);
            end;
        end;
        Count:=res[ver,num];
        exit;
    end;
    if ncld[ver]=0 then begin
        {we cut off us}
        res[ver,num]:=Count(cld[prev[ver],nm[ver]+1],num)+1;
        numm[ver,num]:=0;
        {we don't do this}
        cres:=Count(cld[prev[ver],nm[ver]+1],num-1);
        if res[ver,num]>cres then begin
            res[ver,num]:=cres;
            numm[ver,num]:=1;
        end;
    end
    else begin
        {we cut off us}
        res[ver,num]:=Count(cld[prev[ver],nm[ver]+1],num)+1;
        numm[ver,num]:=0;
        {i is how many we get from us and our children}
        for i:=1 to num do begin
            cres:=Count(cld[ver,1],i-1);
            if cres>=2000000000 then continue;
            cres:=cres+Count(cld[prev[ver],nm[ver]+1],num-i);
            if res[ver,num]>cres then begin
                res[ver,num]:=cres;
                numm[ver,num]:=i;
            end;
        end;
    end;
    Count:=res[ver,num];
end;

var dedg:array[1..251,1..2]of longint;
    nde:longint;

procedure RestoreAnswer(ver,num:longint);
var i:longint;
begin
    if(ver=0)and(num=0)then exit;
    {we are the last child of our parent}
    if nm[ver]=ncld[prev[ver]] then begin
        if num=0 then begin
            inc(nde);
            dedg[nde,1]:=prev[ver];
            dedg[nde,2]:=ver;
        end
        else if num=1 then begin
        end
        else begin
            {we don't have children}
            if ncld[ver]=0 then begin
            end
            else begin
                RestoreAnswer(cld[ver,1],num-1);
            end;
        end;
        exit;
    end;
    if ncld[ver]=0 then begin
        {we cut off us}
        if numm[ver,num]=0 then begin
            inc(nde);
            dedg[nde,1]:=prev[ver];
            dedg[nde,2]:=ver;
            RestoreAnswer(cld[prev[ver],nm[ver]+1],num)
        end
        {we don't do this}
        else RestoreAnswer(cld[prev[ver],nm[ver]+1],num-1);
    end
    else begin
        {we cut off us}
        if numm[ver,num]=0 then begin
            inc(nde);
            dedg[nde,1]:=prev[ver];
            dedg[nde,2]:=ver;
            RestoreAnswer(cld[prev[ver],nm[ver]+1],num)
        end
        {i is how many we get from us and our children}
        else begin
            i:=numm[ver,num];
            RestoreAnswer(cld[ver,1],i-1);
            RestoreAnswer(cld[prev[ver],nm[ver]+1],num-i);
        end;
    end;
end;

procedure Solve;
var cr,mi,rs,i:longint;
begin
    fillchar(ncld,sizeof(ncld),0);
    for i:=2 to n do begin
        inc(ncld[prev[i]]);
        cld[prev[i],ncld[prev[i]]]:=i;
        nm[i]:=ncld[prev[i]];
    end;
    cld[0,1]:=1;
    ncld[0]:=1;
    nm[1]:=1;
    fillchar(res,sizeof(res),$FF);
    rs:=Count(cld[1,1],p-1);
    mi:=1;
    for i:=2 to n do begin
        cr:=Count(cld[i,1],p-1)+1;
        if rs>cr then begin
            mi:=i;
            rs:=cr;
        end;
    end;
    nde:=0;
    if mi<>1 then begin
        nde:=1;
        dedg[1,1]:=mi;
        dedg[1,2]:=prev[mi];
    end;
    writeln(rs);
    RestoreAnswer(cld[mi,1],p-1);
end;

procedure Save;
var i,j,wf:longint;
begin
    wf:=0;
    for i:=1 to nde do begin
        if dedg[i,2]<dedg[i,1] then begin
            j:=dedg[i,2];
            dedg[i,2]:=dedg[i,1];
            dedg[i,1]:=j;
        end;
        for j:=1 to n-1 do begin
            if (edg[j,1]=dedg[i,1])and(edg[j,2]=dedg[i,2]) then begin
                if wf=1 then write(' ')
                else wf:=1;
                write(j);
                break;
            end;
        end;
    end;
end;

begin
    assign(input,'tree.in');
    assign(output,'tree.out');
    reset(input);
    rewrite(output);
    Load;
    Solve;
    Save;
    close(input);
    close(output);
end.
