const delta=1e-9;
var i,j,n,k:longint;
    full:double;
    tx,ty,px,py:array[0..50000] of double;
    realMaxH:double;
    nx,ny:array[1..50000] of double; nnum:longint;
    ansH:array[1..50000] of double;

{procedure zam(aa,bb:longint);
var buf:double;
begin
    buf:=ansH[aa];
    ansH[aa]:=ansH[bb];
    ansH[bb]:=buf;
end;

procedure sift(aa,len:longint);
var mn:longint;
begin
    if 2*aa>len then exit;
    if 2*aa=len then
        mn:=2*aa
    else
    begin
        if ansH[2*aa+1]>ansH[2*aa] then
            mn:=2*aa+1
        else
            mn:=2*aa;
    end;
    if ansH[mn]>ansH[aa] then
    begin
        zam(aa,mn);
        sift(mn,len);
    end;
end;}

procedure Cross(hh,x1,y1,x2,y2:double;var cx,cy:double);
begin
    cy:=hh;
    cx:=(hh-y1)*(x2-x1)/(y2-y1)+x1;
end;

function VMult(x1,y1,x2,y2,x3,y3:double):double;
begin
    VMult:=(x3-x1)*(y2-y1)-(x2-x1)*(y3-y1);
end;

function getSquare(hh:double):double;
var u:longint;
    lastDown:boolean;
    res:double;
begin
    lastDown:=true;
    nnum:=0;
    for u:=2 to n+1 do
    begin
        if (lastDown and (py[u]<=hh)) then
        begin
            inc(nnum);
            nx[nnum]:=px[u];
            ny[nnum]:=py[u];
        end;
        if (lastDown xor (py[u]<=hh)) then
        begin
            inc(nnum);
            Cross(hh,px[u-1],py[u-1],px[u],py[u],nx[nnum],ny[nnum]);
            if py[u]<hh then
            begin
                inc(nnum);
                nx[nnum]:=px[u];
                ny[nnum]:=py[u];
            end;
        end;
        if py[u]<=hh then
            lastDown:=true
        else
            lastDown:=false;
    end;
    res:=0;
    nx[nnum+1]:=nx[1]; ny[nnum+1]:=ny[1];
    for u:=1 to nnum do
        res:=res+VMult(nx[1],ny[1],nx[u],ny[u],nx[u+1],ny[u+1])/2;
    getSquare:=res;
end;

procedure OneSearch(down,up:double;num:longint);
var middle:double;
begin
    while up-down>delta do
    begin
        middle:=(up+down)/2;
        if getSquare(middle)>num*full/(k+1) then
            up:=middle
        else
            down:=middle;
    end;
//    inc(anum);
//    ansH[anum]:=(down+up)/2;
    ansH[num]:=(down+up)/2;
end;

procedure FullSearch(down,up:double;left,right:longint);
var middle:double;
    divide:longint;
begin
    if right-left<0 then exit;
    if left-right=0 then
    begin
        OneSearch(down,up,left);
        exit;
    end;
    middle:=(down+up)/2;
    divide:=trunc(getSquare(middle)/full*(k+1));
    if divide>=left then
        FullSearch(down,middle,left,divide);
    if divide+1<=right then
        FullSearch(middle,up,divide+1,right);
end;

begin
    assign(input,'antiufo.in');
    assign(output,'antiufo.out');
    reset(input);
    rewrite(output);
    read(n,k);
    for i:=1 to n do
        read(tx[i],ty[i]);
    j:=1;
    for i:=2 to n do
        if ty[i]<ty[j] then
            j:=i;
    for i:=j to n do
    begin
        px[i-j+1]:=tx[i];
        py[i-j+1]:=ty[i];
    end;
    for i:=1 to j-1 do
    begin
        px[n-j+i+1]:=tx[i];
        py[n-j+i+1]:=ty[i];
    end;
    realmaxH:=-20000;
    for i:=1 to n do
        if py[i]>realmaxH then
            realmaxH:=py[i];
    full:=0;
//    anum:=0;
    px[0]:=px[n]; py[0]:=py[n]; px[n+1]:=px[1]; py[n+1]:=py[1];
    for i:=1 to n do
        full:=full+VMult(px[1],py[1],px[i],py[i],px[i+1],py[i+1])/2;
    FullSearch(py[1]+delta,realMaxH-delta,1,k);
{    for i:=k div 2 downto 1 do
        sift(i,k);
    for i:=k downto 2 do
    begin
        sift(1,i);
        zam(1,i);
    end;}
    for i:=1 to k do
        writeln(ansH[i]:0:5);
    close(input);
    close(output)
end.