const maxn=500;
      QSize=100000;
type TQueue=record
    arr:array[1..QSize] of longint;
    st,en:longint;
end;
var i,j,n:longint;
    tw:int64;
    stx,sty,enx,eny:int64;
    wx,wy:array[1..maxn] of int64;
    px,py:array[1..maxn*8+2] of int64; pnum:longint;
    vis:array[1..maxn*8+2] of boolean;
    dist:array[1..maxn*8+2] of int64;
    tmpx,tmpy:longint;
    Q:TQueue;

function Added(xx,yy:int64):boolean;
var u:longint;
begin
    for u:=1 to pnum-1 do
        if ((xx=px[u]) and (yy=py[u])) then
        begin
            Added:=true;
            exit;
        end;
    Added:=false;
end;

function min2(aa,bb:int64):int64;
begin
    if aa<bb then
        min2:=aa
    else
        min2:=bb;
end;

function Empty(var qq:TQueue):boolean;
begin
    if qq.st=1 then
        Empty:=(qq.en=QSize)
    else
        Empty:=((qq.en+1)=qq.st);
end;

procedure Add(var qq:TQueue;xx:longint);
begin
    inc(qq.en);
    if qq.en>QSize then
        qq.en:=1;
    qq.arr[qq.en]:=xx;
end;

function Pop(var qq:TQueue):longint;
begin
    Pop:=qq.arr[qq.st];
    inc(qq.st);
    if qq.st<1 then
        qq.st:=QSize;
end;

function StraightWay(x1,y1,x2,y2:int64;var way:int64):boolean;
var u:longint;
    w:int64;
begin
    StraightWay:=true;
    if ((x2=x1) and (y2=y1)) then
    begin
        way:=0;
        StraightWay:=true;
        exit;
    end;
    if x2=x1 then
    begin
        if y2>y1 then
        begin
            for u:=1 to n do
                if wx[u]=x1 then
                    if ((wy[u]>=y1) and (wy[u]<=y2)) then
                    begin
                        StraightWay:=false;
                        exit;
                    end;
            way:=y2-y1;
            StraightWay:=true;
        end
        else
            StraightWay:=StraightWay(x2,y2,x1,y1,way);
    end;
    if y2=y1 then
    begin
        if x2>x1 then
        begin
            for u:=1 to n do
                if wy[u]=y1 then
                    if ((wx[u]>=x1) and (wx[u]<=x2)) then
                    begin
                        StraightWay:=false;
                        exit;
                    end;
            way:=x2-x1;
            StraightWay:=true;
        end
        else
            StraightWay:=StraightWay(x2,y2,x1,y1,way);
    end;
    if ((x2>x1) and (y2>y1)) then
    begin
        w:=min2(x2-x1,y2-y1);
        for u:=1 to n do
            if wx[u]-wy[u]=x1-y1 then
                if ((wx[u]>=x1) and (wx[u]<=x1+w)) then
                begin
                    StraightWay:=false;
                    exit;
                end;
        way:=w;
        StraightWay:=StraightWay(x1+w,y1+w,x2,y2,w);
        way:=way+w;
    end;
    if ((x2>x1) and (y2<y1)) then
    begin
        w:=min2(x2-x1,y1-y2);
        for u:=1 to n do
            if wx[u]+wy[u]=x1+y1 then
                if ((wx[u]>=x1) and (wx[u]<=x1+w)) then
                begin
                    StraightWay:=false;
                    exit;
                end;
        way:=w;
        StraightWay:=StraightWay(x1+w,y1-w,x2,y2,w);
        way:=way+w;
    end;
    if x2<x1 then
        StraightWay:=StraightWay(x2,y2,x1,y1,way);
end;

begin
    assign(input,'king.in');
    assign(output,'king.out');
    reset(input);
    rewrite(output);
    read(stx,sty,enx,eny);
    read(n);
    for i:=1 to n do
    begin
        read(tmpx,tmpy);
        wx[i]:=tmpx;
        wy[i]:=tmpy;
    end;
    pnum:=1;
    for i:=1 to n do
    begin
        px[pnum]:=wx[i]-1;
        py[pnum]:=wy[i]-1;
        if not Added(px[pnum],py[pnum]) then inc(pnum);
        px[pnum]:=wx[i]-1;
        py[pnum]:=wy[i];
        if not Added(px[pnum],py[pnum]) then inc(pnum);
        px[pnum]:=wx[i]-1;
        py[pnum]:=wy[i]+1;
        if not Added(px[pnum],py[pnum]) then inc(pnum);
        px[pnum]:=wx[i];
        py[pnum]:=wy[i]-1;
        if not Added(px[pnum],py[pnum]) then inc(pnum);
        px[pnum]:=wx[i];
        py[pnum]:=wy[i]+1;
        if not Added(px[pnum],py[pnum]) then inc(pnum);
        px[pnum]:=wx[i]+1;
        py[pnum]:=wy[i]-1;
        if not Added(px[pnum],py[pnum]) then inc(pnum);
        px[pnum]:=wx[i]+1;
        py[pnum]:=wy[i];
        if not Added(px[pnum],py[pnum]) then inc(pnum);
        px[pnum]:=wx[i]+1;
        py[pnum]:=wy[i]+1;
        if not Added(px[pnum],py[pnum]) then inc(pnum);
    end;
    inc(pnum);
    px[pnum-1]:=stx;
    py[pnum-1]:=sty;
    px[pnum]:=enx;
    py[pnum]:=eny;
    Q.st:=1; Q.en:=1;
    Q.arr[1]:=pnum-1;
    vis[n*8+1]:=true;
    while not Empty(Q) do
    begin
        i:=Pop(Q);
        for j:=1 to pnum do
            if StraightWay(px[i],py[i],px[j],py[j],tw) then
                if not vis[j] then
                begin
                    vis[j]:=true;
                    dist[j]:=tw+dist[i];
                    Add(Q,j);
                end
                else
                begin
                    if dist[j]>dist[i]+tw then
                    begin
                        dist[j]:=dist[i]+tw;
                        Add(Q,j);
                    end;
                end;
    end;
    if not vis[pnum] then
        writeln(-1)
    else
        writeln(dist[pnum]);
    close(input);
    close(output);
end.
