const inf=100000000;
type elem=record
    diff:longint;
    fml,fmr,fr:longint;
end;
type DiffArr=array[1..51,1..51,1..51,1..51] of elem;
var i,j,m,n,k,st:longint;
    a,b:longint;
    arr:array[0..53] of longint;
    sum:array[0..53] of longint;
    incl:array[1..53] of longint;
    best:DiffArr;
    max,min:longint;
    minml,minmr:longint;
    currr,currml,currmr,nextr,nextml,nextmr:longint;
    res:longint;
    opers:longint;

procedure clear(var bst:DiffArr);
var ii,jj,aa,bb:longint;
begin
    for ii:=1 to k do
    	for jj:=1 to n do
    	    for aa:=1 to n do
    	        for bb:=1 to n do
    	        begin
    	            bst[ii,jj,aa,bb].diff:=inf;
    	            bst[ii,jj,aa,bb].fr:=0;
    	            bst[ii,jj,aa,bb].fml:=0;
    	            bst[ii,jj,aa,bb].fmr:=0;
                end;
end;


function rnd(aa:integer):integer;
begin
    rnd:=((aa+st)-1) mod n + 1;
end;

begin
    assign(input,'necklace.in');
    assign(output,'necklace.out');
    reset(input);
    rewrite(output);
    read(n,k);
    for i:=1 to n do
        read(arr[i]);

    res:=inf;
    opers:=0;
    for st:=1 to n do
    begin

    for i:=0 to n-1 do
        arr[i]:=arr[i+1];
    arr[n]:=arr[0];
    sum[0]:=0;
    for i:=1 to n do
    	sum[i]:=sum[i-1]+arr[i];
    clear(best);
    for i:=1 to n do
    begin
        best[1,i,1,i].diff:=0;
        best[1,i,1,i].fr:=0;
    end;
    for i:=2 to k do
    begin
        for j:=1 to n-(k-i) do
            for a:=1 to j do
                for b:=a to j do
                  if best[i-1,j,a,b].diff<res then
                    for m:=1 to n-j-(k-i) do
	            begin
	                max:=best[i-1,j,a,b].diff+sum[b]-sum[a-1];
	                min:=sum[b]-sum[a-1];
	                if min>sum[j+m]-sum[j] then
                        begin
                            if best[i,j+m,j+1,j+m].diff>max-(sum[j+m]-sum[j]) then
                            begin
                                best[i,j+m,j+1,j+m].diff:=max-(sum[j+m]-sum[j]);
                                best[i,j+m,j+1,j+m].fr:=j;
	                        best[i,j+m,j+1,j+m].fml:=a;
                                best[i,j+m,j+1,j+m].fmr:=b;
                            end;
	                end
	                else
                        begin
                            if sum[j+m]-sum[j]>max then
                                max:=sum[j+m]-sum[j];
                            if best[i,j+m,a,b].diff>max-min then
                            begin
                                best[i,j+m,a,b].diff:=max-min;
                                best[i,j+m,a,b].fr:=j;
	                        best[i,j+m,a,b].fml:=a;
                                best[i,j+m,a,b].fmr:=b;
                            end;
                        end;
                        inc(opers);
                    end;
    end;
    min:=inf; minml:=0; minmr:=0;
    for i:=1 to n do
        for j:=1 to n do
            if best[k,n,i,j].diff<min then
            begin
                min:=best[k,n,i,j].diff;
                minml:=i;
                minmr:=j;
            end;
    if min<res then
    begin
        res:=min;
        currr:=n; currml:=minml; currmr:=minmr;
        for i:=k downto 1 do
        begin
            nextr:=best[i,currr,currml,currmr].fr;
            nextml:=best[i,currr,currml,currmr].fml;
            nextmr:=best[i,currr,currml,currmr].fmr;
            for j:=nextr+1 to currr do
                incl[rnd(j)]:=i;
            currr:=nextr;
            currml:=nextml;
            currmr:=nextmr;
        end;
    end;

    end;

    writeln(res);
    for i:=1 to k do
    begin
        for j:=1 to n do
            if incl[j]=i then
                write(j,' ');
        writeln;
    end;
    close(input);
    close(output);
end.
