const maxCoord=10000;
      delta=0.00001;
      deltaSQ=1e-10;
var i,n,k:longint;
    px,py,fx,fy:array[1..210] of integer;
    centrx,centry:double;
    thisR,maxR,minR,cx,cy:double;

function Square(x1,y1,x2,y2,x3,y3:double):double;
begin
    Square:=abs(x1*(y2-y3)+x2*(y3-y1)+x3*(y1-y2))/2;
end;

function CoveredTr(x1,y1,x2,y2,x3,y3,rad:double):boolean;
var b1,b2,b3,allb:boolean;
    x12,y12,x23,y23,x13,y13:double;
    u:longint;
begin
    if Square(x1,y1,x2,y2,x3,y3)<deltaSQ then
    begin
        CoveredTr:=true;
        exit;
    end;
    b1:=false; b2:=false; b3:=false;
    for u:=1 to k do
    begin
        allb:=true;
        if sqr(fx[u]-x1)+sqr(fy[u]-y1)<sqr(rad) then
            b1:=true
        else
            allb:=false;
        if sqr(fx[u]-x2)+sqr(fy[u]-y2)<sqr(rad) then
            b2:=true
        else
            allb:=false;
        if sqr(fx[u]-x3)+sqr(fy[u]-y3)<sqr(rad) then
            b3:=true
        else
            allb:=false;
        if allb then
        begin
            CoveredTr:=true;
            exit;
        end;
    end;
    if not b1 then
    begin
        cx:=x1; cy:=y1;
        CoveredTr:=false;
        exit;
    end;
    if not b2 then
    begin
        cx:=x2; cy:=y2;
        CoveredTr:=false;
        exit;
    end;
    if not b3 then
    begin
        cx:=x3; cy:=y3;
        CoveredTr:=false;
        exit;
    end;

    x12:=(x1+x2)/2; y12:=(y1+y2)/2;
    x23:=(x2+x3)/2; y23:=(y2+y3)/2;
    x13:=(x1+x3)/2; y13:=(y1+y3)/2;
    if not CoveredTr(x1,y1,x12,y12,x13,y13,rad) then
    begin
        CoveredTr:=false;
        exit;
    end;
    if not CoveredTr(x2,y2,x23,y23,x12,y12,rad) then
    begin
        CoveredTr:=false;
        exit;
    end;
    if not CoveredTr(x3,y3,x13,y13,x23,y23,rad) then
    begin
        CoveredTr:=false;
        exit;
    end;
    if not CoveredTr(x12,y12,x13,y13,x23,y23,rad) then
    begin
        CoveredTr:=false;
        exit;
    end;
    CoveredTr:=true;
end;

function Covered(rad:double):boolean;
var u:longint;
begin
    for u:=1 to n do
    	if not CoveredTr(centrx,centry,px[u],py[u],px[u+1],py[u+1],rad) then
    	begin
    	    Covered:=false;
    	    exit;
    	end;
    Covered:=true;
end;

begin
    assign(input,'fire.in');
    assign(output,'fire.out');
    reset(input);
    rewrite(output);
    read(n);
    for i:=1 to n do
    	read(px[i],py[i]);
    read(k);
    for i:=1 to k do
    	read(fx[i],fy[i]);
    px[n+1]:=px[1]; py[n+1]:=py[1];
    centrx:=0; centry:=0;
    for i:=1 to n do
    begin
        centrx:=centrx+px[i];
        centry:=centry+py[i];
    end;
    centrx:=centrx/n; centry:=centry/n;
    minR:=0; maxR:=maxCoord;
    while maxR-minR>delta do
    begin
        thisR:=(maxR+minR)/2;
        if covered(thisR) then
            maxR:=thisR
        else
            minR:=thisR;
    end;
    writeln(cx:0:4,' ',cy:0:4);
    close(input);
    close(output);
end.
