type TQueue=record
     arr:array[1..360] of longint;
     st,en:longint;
end;
var cnt,i,j,n,k,t:longint; m:array[1..2] of longint;
    gt:array[1..360,0..1] of longint;
    pos:array[1..360] of boolean;
    father:array[1..2,1..360] of longint;
    st:array[1..2] of longint;
    q:array[1..2] of TQueue;
    vis:array[1..2,1..360] of boolean;
    mask:array[1..2,0..1] of integer;
    path:array[1..360] of integer; pn:longint;
    curr,ncurr:longint;
    solved:boolean; tbad:array[0..1] of boolean;


procedure clear(var qq:TQueue);
begin
    qq.st:=2; qq.en:=1;
end;

function empty(var qq:TQueue):boolean;
begin
    if ((qq.st-1=qq.en) or ((qq.st=1) and (qq.en=360)) ) then
        empty:=true
    else
        empty:=false;
end;

procedure push(var qq:TQueue;aa:longint);
begin
    inc(qq.en);
    if qq.en>360 then
        qq.en:=1;
    qq.arr[qq.en]:=aa;
end;

function pop(var qq:TQueue):longint;
begin
    if empty(qq) then
    begin
        pop:=qq.arr[qq.st];
        exit;
    end
    else
        pop:=qq.arr[qq.st];
    inc(qq.st);
    if qq.st>360 then
        qq.st:=1;
end;

begin
    assign(input,'eq.in');
    assign(output,'eq.out');
    reset(input);
    rewrite(output);
    read(n);
    read(t);
    for i:=1 to n do
        pos[i]:=false;
    for i:=1 to t do
    begin
        read(j);
        pos[j]:=true;
    end;
    for i:=1 to n do
        read(gt[i,0],gt[i,1]);
    read(k);
    for cnt:=1 to k do
    begin
        read(st[1],st[2]);
        if (pos[st[1]] xor pos[st[2]]) then
        begin
            writeln;
            continue;
        end;
        clear(q[1]);
        clear(q[2]);
        for j:=1 to 2 do
            for i:=1 to n do
            begin
                vis[j][i]:=false;
                father[j][i]:=0;
            end;
        push(q[1],st[1]); vis[1,st[1]]:=true;
        push(q[2],st[2]); vis[2,st[2]]:=true;
        solved:=false;
        while not (empty(q[1]) and empty(q[2])) do
        begin
            for j:=1 to 2 do
            begin
                m[j]:=pop(q[j]);
                for i:=0 to 1 do
                    if vis[j,gt[m[j],i]] then
                    begin
                        if pos[gt[m[j],i]] then
                            mask[j,i]:=2
                        else
                            mask[j,i]:=-2;
                    end
                    else
                    begin
                        if pos[gt[m[j],i]] then
                            mask[j,i]:=1
                        else
                            mask[j,i]:=-1;
                        push(q[j],gt[m[j],i]);
                        vis[j,gt[m[j],i]]:=true;
                        father[j,gt[m[j],i]]:=m[j];
                    end;
            end;
            tbad[0]:=false;
            tbad[1]:=false;
            for j:=0 to 1 do
                if mask[1,j]<>mask[2,j] then
                begin
                    if abs(mask[1,j]-mask[2,j])=1 then
                    begin
                        if abs(mask[1,j])=2 then
                            push(q[1],gt[m[1],j])
                        else
                            push(q[2],gt[m[2],j])
                    end
                    else
                        tbad[j]:=true;
            end;
            if (tbad[0] or tbad[1]) then
            begin
                curr:=m[1];
                if tbad[0] then
                    path[1]:=0
                else
                    path[1]:=1;
                for pn:=2 to 2*n do
                begin
                    if father[1,curr]=0 then break;
                    ncurr:=father[1,curr];
                    if gt[ncurr,0]=curr then
                        path[pn]:=0
                    else
                        path[pn]:=1;
                    curr:=ncurr;
                end;
                for i:=pn-1 downto 1 do
                    write(path[i]);
                writeln;
                solved:=true;
                break;
            end;
        end;
        if solved then continue;
        writeln('equivalent');
    end;
    close(input);
    close(output);
end.
