type
  integer = longint;
  TVector = record
    x, y: extended;
  end;

const eps=1E-10;

var
  i, j, n, s: integer;
  p, t: array [1..200] of TVector;
  r, d, g, res: TVector;
  rad: extended;
  f: boolean;

begin
  Assign(input, 'glass.in');
  Assign(output, 'glass.out');
  Reset(input);
  Rewrite(output);
  ReadLn(Rad);
  ReadLn(n);
  for i:=1 to n do
    ReadLn(p[i].x, p[i].y);
  for j:=1 to n-1 do
  begin
    d.x:=p[j+1].x-p[j].x;
    d.y:=p[j+1].y-p[j].y;
    if d.x+d.y<0 then
    begin
      d.x:=-d.x;
      d.y:=-d.y;
    end;
    r.x:=d.x/sqrt(d.x*d.x+d.y*d.y);
    r.y:=d.y/sqrt(d.x*d.x+d.y*d.y);
    for i:=1 to n do
    begin
      t[i].x:=p[i].x*r.y-p[i].y*r.x;
      t[i].y:=p[i].x*r.x+p[i].y*r.y;
    end;
    if t[n].x-t[1].x>0 then
      s:=1
    else
      s:=-1;
    f:=false;
    for i:=1 to n-1 do
      if (t[i+1].x-t[i].x)*s<0 then
        f:=true;
    if f then continue;
    if n>2 then
    begin
      if t[j].y>t[j+1].y then
        i:=j
      else
        i:=j+1;
      if j>1 then
      begin
        g.x:=t[i].x;
        g.y:=(t[i].y+sqrt(Rad*Rad-g.x*g.x))/2;
      end else
      begin
        g.y:=(t[1].y+t[2].y)/2;
        g.x:=(t[1].x+sqrt(rad*rad-g.y*g.y));
      end;
      r.x:=-r.x;
      res.x:=g.x*r.y-g.y*r.x;
      res.y:=g.x*r.x+g.y*r.y;
      WriteLn(res.x:5:5, ' ', res.y:5:5, ' ', d.x:5:5, ' ', d.y:5:5);
    end else
    begin
      g.x:=(t[1].x+rad)/2;
      g.y:=0;
      r.x:=-r.x;
      res.x:=g.x*r.y-g.y*r.x;
      res.y:=g.x*r.x+g.y*r.y;
      WriteLn(res.x:5:5, ' ', res.y:5:5, ' ', d.x:5:5, ' ', d.y:5:5);
    end;
    Close(input);
    Close(output);
    exit;
  end;
  WriteLn(-1);
  Close(input);
  Close(output);
end.