  {$I-,Q-,R-,S-}
const
    maxk=60;
    maxn=60;

type
    list=^tlist;
    tlist=record next,link:list; val,ind:longint; end;

var n,k,s,f,m,Z:longint;
    a:array[1..maxk,1..maxn] of list;
    ain,aout:array[1..maxn,1..maxk] of list;
    used:array[1..maxn] of boolean;

Procedure add(const u,v,c:longint);
var p1,p2:list;
begin
    new(p1);
    p1^.next:=a[c,u];
    p1^.val:=v;
    p1^.ind:=1;
    new(p2);
    p2^.next:=a[c,v];
    p2^.val:=u;
    p2^.ind:=-1;
    p1^.link:=p2;
    p2^.link:=p1;
    a[c,u]:=p1;
    a[c,v]:=p2;
end;

Procedure init;
var i,u,v,c:longint;
begin
    assign(input,'rhyme.in');
    reset(input);
    assign(output,'rhyme.out');
    rewrite(output);
    read(n,k,s,f);
    read(m);
    for i:=1 to m do
    begin
        read(u,v,c);
        if u<>v then
        add(u,v,c);
    end;
    fillchar(ain,sizeof(ain),0);
    fillchar(aout,sizeof(aout),0);
end;

Function dfs(const q:longint):boolean;
var i:longint;
    buf:list;
begin
    used[q]:=true;
    if q=f then
    begin
        dfs:=true;
        exit;
    end;
    for i:=1 to k do if aout[q,i]=nil then
    begin
        buf:=a[i,q];
        while buf<>nil do
        begin
            if (buf^.ind=1)and(not used[buf^.val])and(ain[buf^.val,i]=nil) then
            begin
                aout[q,i]:=buf;
                ain[buf^.val,i]:=buf^.link;
                if dfs(buf^.val) then
                begin
                    dfs:=true;
                    exit;
                end;
                aout[q,i]:=nil;
                ain[buf^.val,i]:=nil;
            end;
            buf:=buf^.next;
        end;
    end;
    for i:=1 to k do if ain[q,i]<>nil then
    begin
        buf:=ain[q,i];
        if not used[buf^.val] then
        begin
            ain[q,i]:=nil;
            aout[buf^.val,i]:=nil;
            if dfs(buf^.val) then
            begin
                dfs:=true;
                exit;
            end;
            ain[q,i]:=buf;
            aout[buf^.val,i]:=buf^.link;
        end;
    end;
    dfs:=false;
end;

Procedure solve;
begin
    z:=0;
    fillchar(used,sizeof(used),0);
    while dfs(s) do
    begin
        inc(Z);
        fillchar(used,sizeof(used),0);
    end;
end;

Procedure print;
var i,cur,j:longint;
    buf:list;
begin
    writeln(z);
    for i:=1 to z do
    begin
        cur:=s;
        write(cur,' ');
        while cur<>f do
        begin
            for j:=1 to k do if aout[cur,j]<>nil then
            begin
                buf:=aout[cur,j];
                write(j,' ',buf^.val,' ');
                aout[cur,j]:=nil;
                cur:=buf^.val;
                break;
            end;
        end;
        writeln;
    end;
end;

begin
    init;
    solve;
    print;
    close(input);
    close(output);
end.