  {$I-,Q-,R-,S-}
  {$M 40000000}
const
    maxn=510;
    maxk=15;

type
    list=^TList;
    TList=record next:list; val:longint; end;
    TSost=record num,sos:longint; end;

var n,m,k,x1,x2:longint;
    a:array[1..maxk,1..maxn] of list;
    calc:array[1..maxn,1..maxn] of record bo:boolean; sos,num:longint; end;
    used:array[1..maxn,1..maxn] of boolean;

Procedure add(const u,v,c:longint);
var p:list;
begin
    new(p);
    p^.next:=a[c,u];
    p^.val:=v;
    a[c,u]:=p;
end;

Procedure init;
var i,u,v,c:longint;
begin
    assign(input,'pursuit.in');
    reset(input);
    assign(output,'pursuit.out');
    rewrite(output);
    read(n,m,k);
    for i:=1 to m do
    begin
        read(u,v,c);
        add(u,v,c);
        add(v,u,c);
    end;
    read(x1,x2);
end;

Function get(const q,w:longint):TSost;
var buf1,buf2:list;
    i,tmax,tmin,TNum,trenum:longint;
    S:TSost;
begin
    if used[q,w] then
    begin
        if calc[q,w].bo then
        begin
            get.sos:=calc[q,w].sos;
            get.num:=calc[q,w].num;
            exit;
        end;
        get.sos:=0;
        get.num:=0;
        exit;
    end;
    if q=w then
    begin
        used[q,w]:=true;
        calc[q,w].bo:=true;
        calc[q,w].sos:=1;
        calc[q,w].num:=0;
        get.sos:=1;
        get.num:=0;
        exit;
    end;
    if w=1 then
    begin
        used[q,w]:=true;
        calc[q,w].bo:=true;
        calc[q,w].sos:=-1;
        calc[q,w].num:=0;
        get.sos:=-1;
        get.num:=0;
        exit;
    end;
    used[q,w]:=true;
    tmax:=-10;
    trenum:=-10;
    for i:=1 to k do
    begin
        buf1:=a[i,q];
        while buf1<>nil do
        begin
            if buf1^.val=w then
            begin
                tmax:=1;
                trenum:=1;
                break;
            end;
            tmin:=10;
            tnum:=0;
            buf2:=a[i,w];
            while buf2<>nil do
            begin
                S:=get(buf1^.val,buf2^.val);
                if ((S.sos=-1)and(tmin>-1))or((S.sos=-1)and(tmin=-1)and(tnum>s.num+1)) then
                begin
                    tmin:=-1;
                    tnum:=s.num+1;
                end else
                if (S.sos=0)and(tmin>0) then
                begin
                    tmin:=0;
                    tnum:=0;
                end else
                if ((S.sos=1)and(tmin>1))or((S.sos=1)and(S.num+1>tnum)and(tmin=1)) then
                begin
                    tmin:=1;
                    tnum:=s.num+1;
                end;
                buf2:=buf2^.next;
            end;
            S:=get(buf1^.val,w);
            if ((S.sos=-1)and(tmin>-1))or((S.sos=-1)and(tmin=-1)and(tnum>s.num+1)) then
            begin
                tmin:=-1;
                tnum:=s.num+1;
            end else
            if (S.sos=0)and(tmin>0) then
            begin
                tmin:=0;
                tnum:=0;
            end else
            if ((S.sos=1)and(tmin>1))or((S.sos=1)and(S.num+1>tnum)and(tmin=1)) then
            begin
                tmin:=1;
                tnum:=s.num+1;
            end;

            if tmin=-1 then
            begin
                if tmax<-1 then
                begin
                    tmax:=-1;
                    trenum:=tnum;
                end else
                if (tmax=-1)and(trenum<tnum) then
                begin
                    trenum:=tnum;
                end;
            end else
            if ((tmin=0)or(tmin=10))and(tmax<=0) then
            begin
                if tmax<0 then tmax:=0;
            end else if tmin=1 then
            begin
                if tmax<1 then
                begin
                    tmax:=1;
                    trenum:=tnum;
                end else
                if (tmax=1)and(trenum>tnum) then
                begin
                    trenum:=tnum;
                end;
            end;
            if (tmax=1)and(trenum=1) then break;
            buf1:=buf1^.next;
        end;
    end;
    calc[q,w].bo:=true;
    calc[q,w].num:=trenum;
    calc[q,w].sos:=tmax;
    if tmax=0 then
    begin
        calc[q,w].bo:=false;
        used[q,w]:=false;
    end;
    get.sos:=tmax;
    get.num:=trenum;
end;

Procedure solve;
begin
    fillchar(used,sizeof(used),0);
end;

Procedure print;
var T:TSost;
begin
    t:=get(x1,x2);
    if t.sos=0 then writeln('Endless') else
    if t.sos=1 then writeln('Caught') else writeln('Escaped');
    if t.sos<>0 then writeln(t.num);
end;

begin
    init;
    solve;
    print;
    close(input);
    close(output);
end.
