  {$I-,Q-,R-,S-}
  {$M 40000000}

const
    maxn=101;
    dex:array[1..6] of longint=(1,-1,0,0,0,0);
    dey:array[1..6] of longint=(0,0,1,-1,0,0);
    dez:array[1..6] of longint=(0,0,0,0,1,-1);

var x,y,z,dx,dy,dz,k:longint;
    ans:int64;
    a,b:array[0..maxn+5,0..maxn+5,0..maxn+5] of int64;
    used:array[0..maxn,0..maxn,0..maxn] of boolean;
    que:array[1..maxn*maxn*maxn] of record x,y,z:integer; end;

Function calc(const q,w,e:longint):int64;
var i,j,h:longint;
    res:int64;
begin
    if (q<1)or(w<1)or(e<1) then
    begin
        calc:=0;
        exit;
    end;
    i:=q;
    res:=0;
    while i<>0 do
    begin
        j:=w;
        while j<>0 do
        begin
            h:=e;
            while h<>0 do
            begin
                inc(res,a[i,j,h]);
                h:=h-((h xor (h-1)) shr 1 + 1);
            end;
            j:=j-((j xor (j-1)) shr 1 + 1);
        end;
        i:=i-((i xor (i-1)) shr 1 + 1);
    end;
    calc:=res;
end;

procedure add(const tx,ty,tz,val:longint);
var i,j,h:longint;
begin
    if (tx=0)or(ty=0)or(tz=0) then exit;
    if val=0 then exit;
    i:=tx;
    while i<=x do
    begin
        j:=ty;
        while j<=y do
        begin
            h:=tz;
            while h<=z do
            begin
                a[i,j,h]:=a[i,j,h]+val;
                h:=h+((h xor (h-1)) shr 1 + 1);
            end;
            j:=j+((j xor (j-1)) shr 1 + 1);
        end;
        i:=i+((i xor (i-1)) shr 1 + 1);
    end;
end;

Procedure init;
var i,j,h,c:longint;
begin
    assign(input,'virtual.in');
    reset(input);
    assign(output,'virtual.out');
    rewrite(output);
    read(x,y,z,dx,dy,dz,k);
    for i:=1 to z do
    for j:=1 to y do
    for h:=1 to x do
    begin
        read(c);
        b[h,j,i]:=c;
    end;
end;

Function get(const x,y,z:longint):int64;
begin
    get:=calc(x,y,z)-
         calc(x-dx,y,z)-calc(x,y-dy,z)-calc(x,y,z-dz)+
         calc(x-dx,y-dy,z)+calc(x-dx,y,z-dz)+calc(x,y-dy,z-dz)-
         calc(x-dx,y-dy,z-dz);
end;

Procedure no;
begin
    writeln(-1);
    close(input);
    close(output);
    halt;
end;

Procedure solve;
var cnt,i,j:longint;
    t:int64;
    cur:int64;
begin
    que[1].x:=1;
    que[1].y:=1;
    que[1].z:=1;
    used[1,1,1]:=true;
    i:=1;
    cnt:=1;
    ans:=0;
    while i<=cnt do
    begin
        t:=(int64(b[que[i].x,que[i].y,que[i].z])+get(que[i].x,que[i].y,que[i].z)) mod (k + 1);
        if t<>0 then
        begin
            if (que[i].x+dx-1>x)or
               (que[i].y+dy-1>y)or
               (que[i].z+dz-1>z) then no;
            cur:=k-t+1;
            ans:=ans+cur;
            add(que[i].x,que[i].y,que[i].z,cur);
        end;
        for j:=1 to 6 do if (not used[que[i].x+dex[j],que[i].y+dey[j],que[i].z+dez[j]])and
                            (que[i].x+dex[j]>0)and(que[i].x+dex[j]<=x)and
                            (que[i].y+dey[j]>0)and(que[i].y+dey[j]<=y)and
                            (que[i].z+dez[j]>0)and(que[i].z+dez[j]<=z)then
        begin
            used[que[i].x+dex[j],que[i].y+dey[j],que[i].z+dez[j]]:=true;
            inc(cnt);
            que[cnt].x:=que[i].x+dex[j];
            que[cnt].y:=que[i].y+dey[j];
            que[cnt].z:=que[i].z+dez[j];
        end;
        inc(i);
    end;
end;

Procedure print;
begin
    writeln(ans);
end;

begin
    init;
    solve;
    print;
    close(input);
    close(output);
end.