  {$I-,Q-,R-,S-}
const
    maxn=101000;
    inf=1000000000;

type
    tcity=record val,ind:longint; end;
    list=^tlist;
    tlist=record next:list; val:longint; end;

var n,m,l,cc:longint;
    a:array[1..maxn] of list;
    d:array[1..maxn] of tcity;
    used:array[1..maxn] of boolean;
    col,last,ll,first:array[1..maxn] of longint;

Procedure add(const u,v:longint);
var p:list;
begin
    new(p);
    p^.next:=a[u];
    p^.val:=v;
    a[u]:=p;
end;

Procedure init;
var i,u,v:longint;
begin
    assign(input,'roads.in');
    reset(input);
    assign(output,'roads.out');
    rewrite(output);
    read(n,m,l);
    for i:=1 to n do
    begin
        read(d[i].val);
        d[i].ind:=i;
    end;
    for i:=1 to m do
    begin
        read(u,v);
        add(u,v);
        add(v,u);
    end;
end;

Procedure qsort(const l,r:longint);
var i,j:longint;
    x,y:tcity;
begin
    i:=l;
    j:=r;
    x:=d[(l+r) div 2];
    repeat
        while d[i].val<x.val do inc(i);
        while d[j].val>x.val do dec(j);
        if i<=j then
        begin
            y:=d[i];
            d[i]:=d[j];
            d[j]:=y;
            inc(i);
            dec(j);
        end;
    until i>j;
    if i<r then qsort(i,r);
    if j>l then qsort(l,j);
end;

Procedure update;
var i,dd:longint;
begin
    dd:=d[1].val;
    for i:=1 to n do dec(d[i].val,dd);
end;

Procedure dfs(const q:longint);
var buf:list;
begin
    used[q]:=true;
    col[q]:=cc;
    buf:=a[q];
    while buf<>nil do
    begin
        if not used[buf^.val] then dfs(buf^.val);
        buf:=buf^.next;
    end;
end;

Procedure getcc;
var i:longint;
begin
    cc:=0;
    for i:=1 to n do if not used[i] then
    begin
        inc(cc);
        dfs(i);
    end;
end;

Procedure makelast;
var i:longint;
begin
    for i:=1 to n do
    begin
        if ll[col[d[i].ind]]=0 then
        begin
            ll[col[d[i].ind]]:=i;
            first[col[d[i].ind]]:=i;
        end else
        begin
            last[i]:=ll[col[d[i].ind]];
            ll[col[d[i].ind]]:=i;
        end;
    end;
    for i:=1 to cc do
    begin
        last[first[i]]:=ll[i];
    end;
end;

Function pre(const q:longint):longint;
begin
    if q=1 then pre:=n else pre:=q-1;
end;

{Procedure calc;
var i,j:longint;
begin
    for i:=1 to n do
    begin
        res[i]:=last[i];
        for j:=1 to i-1 do
        begin
            if (((i<res[j])and(i>j))and((res[i]>res[j])or(res[i]<j)))or
               ((res[j]<j)and((i>j)or(i<res[j]))and((res[i]>res[j])and(res[i]<j))) then
            begin
                res[j]:=res[i];
            end;
        end;
    end;
end;}

Procedure solve;
begin
    qsort(1,n);
    update;
    GetCC;
    makelast;
{    calc;}
end;

Function getsum(const ll,rr:longint):longint;
begin
    if rr>ll then getsum:=d[rr].val-d[ll].val else getsum:=(l-d[ll].val)+d[rr].val;
end;

Function between(const q,l,r:longint):boolean;
begin
    if l<r then between:=(q>=l)and(q<=r) else
    between:=(q<=r)or(q>=l);
end;

Function get(const q:longint):longint;
var i,sum,curl,curr:longint;
begin
    curl:=q;
    curr:=last[q];
    sum:=getsum(curl,curr);
    i:=q mod n + 1;
    while i<>q do
    begin
        if between(i,curl,curr) then
        begin
            if not between(last[i],curl,curr) then
            begin
                inc(sum,getsum(curr,last[i]));
                curr:=last[i];
            end;
        end else
        begin
            curl:=i;
            curr:=last[i];
            inc(sum,getsum(curl,curr));
        end;
        i:=i mod n + 1;
    end;
    get:=sum;
end;

Procedure print;
var i,ans,t:longint;
begin
    ans:=inf;
    for i:=1 to n do
    begin
        t:=get(i);
        if t<ans then ans:=t;
    end;
{    ans:=inf;
    for i:=1 to n do
    begin
        if res[i]<i then
    end;}
    writeln(ans);
end;

begin
    init;
    solve;
    print;
    close(input);
    close(output);
end.
