{$I-,Q-,R-,S-}
program ZadB;

type
  int=longint;
  real=extended;
  bool=boolean;
  TVect=record x,y:int; end;

const
  infile='tractor.in';
  outfile='tractor.out';
  maxN=55;
var
  N:int;
  x,y:array[1..maxN] of int;
  v,u:real;
  d:array[1..maxN,1..maxN] of real;


function dist(const v:Tvect):real;
 begin
  dist:=sqrt(sqr(v.x)+sqr(v.y));
 end;

function dist2(const v:Tvect):real;
 begin
  dist2:=sqr(v.x)+sqr(v.y);
 end;


function Vector(i,j:int):TVect;
 begin
   Vector.x:=x[j]-x[i];
   Vector.y:=y[j]-y[i];
 end;

function Vect(const a,b:TVect):real;
 begin
   Vect:=a.x*b.y-a.y*b.x;
 end;

function Scal(const a,b:TVect):real;
 begin
   Scal:=a.x*b.x+a.y*b.y;
 end;

procedure Run;
var
 i,j,k:int;
 Lmax,h,s2,d2,L,dor,newTime:real;
begin
 Read(N);
 Read(u,v);
 for i:= 1 to N+1 do
  Read(x[i],y[i]);

 for i := 1 to N+1 do
   for j := 1 to N+1 do
     d[i,j]:=dist(Vector(i,j))/u;

  for i :=  1 to N do
    begin
      Lmax:=dist(Vector(i,i+1));
      for j := 1 to N+1 do
        if Scal(Vector(i,i+1),vector(i,j))>0 then
          begin
            s2:=Abs(Vect(Vector(i,i+1),Vector(i,j)));
            h:=S2/Lmax;
            d2:=Dist2(Vector(i,j));
            L:=sqrt(d2-sqr(h));
            dor:=L-u*h/sqrt(4*sqr(v)-sqr(u));
            NewTime:=d[i,j];
            if dor>=0 then
              begin
                if dor<=Lmax then
                  NewTime:=dor/v+sqrt(sqr(L-dor)+sqr(h))/u
                else
                  NewTime:=Lmax/v+sqrt(sqr(L-Lmax)+sqr(h))/u
              end;

            if newTime<d[i,j] then
              begin
                d[i,j]:=newTime;
                d[j,i]:=newTime;
              end;
           end;
    end;

  for i :=  2 to N+1 do
    begin
      Lmax:=dist(Vector(i,i-1));
      for j := 1 to N+1 do
        if Scal(Vector(i,i-1),vector(i,j))>0 then
          begin
            s2:=Abs(Vect(Vector(i,i-1),Vector(i,j)));
            h:=S2/Lmax;
            d2:=Dist2(Vector(i,j));
            L:=sqrt(d2-sqr(h));
            dor:=L-u*h/sqrt(4*sqr(v)-sqr(u));
            NewTime:=d[i,j];
            if dor>=0 then
              begin
                if dor<=Lmax then
                  NewTime:=dor/v+sqrt(sqr(L-dor)+sqr(h))/u
                else
                  NewTime:=Lmax/v+sqrt(sqr(L-Lmax)+sqr(h))/u
              end;

            if newTime<d[i,j] then
              begin
                d[i,j]:=newTime;
                d[j,i]:=newTime;
              end;
           end;
    end;

  for k := 1 to N+1 do
    for i := 1 to N+1 do
      for j := 1 to  N+1 do
        if d[i,k]+d[k,j]<d[i,j] then
          d[i,j]:=d[i,k]+d[k,j];
  Write(d[1,n+1]:0:8);


end;

procedure OpenFiles;
 begin
   Assign(input,infile);
   Reset(input);
   Assign(output,outfile);
   Rewrite(output);
 end;

procedure CloseFiles;
 begin
   Close(input);
   Close(OUTPUT);
 end;

Begin
OpenFiles;
Run;
CloseFiles;
End.


