{$I-,Q-,R-,S-}
program ZadA;

uses
  Math;
const
  maxKol=200;
  osn=1000;
  maxL=20000;

type
  int=longint;
  real=extended;
  bool=boolean;
  long=array[0..maxKol]of int;
  rac=record p,q:long; end;

const
  infile='divide.in';
  outfile='divide.out';
var
  ostat:array[0..maxL]of long;
  chisl:array[0..maxL]of int;

procedure Write3(const a:int);
 begin
   if a<10 then Write('00',a) else
   if a<100 then Write('0',a) else
   Write(a);
 end;

procedure WriteLong(const a:long);
 var
   i:int;
 begin
   Write(a[a[0]]);
   for i := a[0]-1 downto 1 do
     Write3(a[i]);
 end;


procedure MulLongShort(var a :long;const b:int);
 var
  i:int;
 begin
  a[a[0]+1]:=0;
  for i := 1 to a[0] do
    a[i]:=a[i]*b;
  for i :=1 to a[0] do
    begin
      inc(a[i+1],a[i]div osn);
      a[i]:=a[i] mod osn;
    end;
  if a[a[0]+1]<>0 then
    inc(a[0]);
 end;

procedure SumLongShort(var a :long;const b:int);
 var
  i:int;
 begin
  a[a[0]+1]:=0;
  a[1]:=a[1]+b;
  for i :=1 to a[0] do
    begin
      if a[i]<0 then
        begin
          dec(a[i+1]);
          a[i]:=a[i]+osn;
        end;
      inc(a[i+1],a[i]div osn);
      a[i]:=a[i] mod osn;
    end;
  if a[a[0]+1]<>0 then
    inc(a[0])
  else
    if a[a[0]]=0 then
     dec(a[0]);
 end;

procedure ReadLong(var a:long;var L:int);
 var
   ch:char;
 begin
   L:=0;
   A[0]:=0;
   if not eoln then
     repeat
       Read(ch);
       if ch in ['0'..'9'] then
         begin
           inc(L);
           MulLongShort(a,10);
           SumLongShort(a,ord(ch)-ord('0'));
         end;
     until not(ch in ['0'..'9']) or eoln;
 end;


function MulLongLong(const a,b:long):long;
 var
   i,t,j:int;
 begin
   for i := 1 to a[0]+b[0]+2 do
     MulLongLong[i]:=0;
   for i :=1 to a[0] do
     for j :=1 to b[0] do
       inc(MulLongLong[i+j-1],a[i]*b[j]);

  for i :=1 to a[0]+b[0]+2 do
    begin
      inc(MulLongLong[i+1],MulLongLong[i]div osn);
      MulLongLong[i]:=MulLongLong[i] mod osn;
    end;
  t:=a[0]+b[0]+2;
  MulLongLong[0]:=0;
  for i := 1 to t do
    if MulLongLong[i]<>0 then
      MulLongLong[0]:=i;
 end;

procedure SumLongLong(var a:long;const b:long);
 var
   i,t:int;
 begin
   for i := a[0]+1 to Max(a[0],b[0])+1 do
     a[i]:=0;
   for i :=1 to b[0] do
     inc(a[i],b[i]);

  for i :=1 to max(a[0],b[0]) do
    begin
      inc(a[i+1],a[i]div osn);
      a[i]:=a[i] mod osn;
    end;
  t:=max(a[0],b[0])+1;
  a[0]:=0;
  for i := 1 to t do
    if a[i]<>0 then
      a[0]:=i;
 end;

procedure MinusLL(var a:long;const b:long);
 var
   i,t:int;
 begin
   for i := a[0]+1 to Max(a[0],b[0])+1 do
     a[i]:=0;
   for i :=1 to b[0] do
     dec(a[i],b[i]);

  for i :=1 to max(a[0],b[0]) do
    begin
      inc(a[i+1],a[i]div osn);
      a[i]:=a[i] mod osn;
      if a[i]<0 then
        begin
          a[i]:=a[i]+osn;
          dec(a[i+1]);
        end;
    end;
  t:=max(a[0],b[0])+1;
  a[0]:=0;
  for i := 1 to t do
    if a[i]<>0 then
      a[0]:=i;
 end;

procedure ReadRac(var A:rac);
 var
   cel,predper,per:long;
   L,Lpred,lper:int;
   DesPred,desPerm1:long;
   i:int;
   t1,t2:long;
 begin
   ReadLong(cel,L);
   ReadLong(predper,lpred);
   ReadLong(per,Lper);
   despred[0]:=1;
   despred[1]:=1;
   for i := 1 to lPred do
     MulLongShort(despred,10);

   desperm1[0]:=1;
   desperm1[1]:=1;
   for i := 1 to lPer do
     MulLongShort(desperm1,10);
   SumLongShort(desperm1,-1);

   if Lper<>0 then
     begin
       t1:=cel;
       t1:=MulLongLong(t1,despred);
       SumLongLong(t1,predper);
       t1:=MulLongLong(t1,desPerm1);
       SumLongLong(t1,per);

       A.p:=t1;

       t2:=despred;
       t2:=MulLongLong(t2,desperm1);

       A.q:=t2;
     end
   else
     begin
       t1:=cel;
       t1:=MulLongLong(t1,despred);
       SumLongLong(t1,predper);

       A.p:=t1;

       t2:=despred;

       A.q:=t2;
     end;

 end;

function More(const a,b:long):bool;
 var
   i:int;
 begin
  if a[0]=b[0] then
    begin
      for i := a[0] downto 1 do
        if a[i]<>b[i] then
          begin
            More:=a[i]>b[i];
            exit;
          end;
    end
  else
    begin
      More:=a[0]>b[0];
      exit;
    end;
  More:=false;
 end;

procedure LongDivLong(const A,B:long; var chasn,ost:long);
 var
   i:int;
   L,R,M:int;
   fl:bool;
 begin
   for i := 0 to a[0]+1 do
     chasn[i]:=0;
   fl:=true;
   for i := A[0] downto 1  do
     begin
       if fl then chasn[0]:=i;
       L:=0;
       R:=999;
       while L<R do
         begin
           M:=(L+R+1) div 2;
           chasn[i]:=M;
           if More(MulLongLong(chasn,B),A) then
             begin
               R:=M-1;
             end
           else
             begin
               L:=M;
             end;
         end;
       chasn[i]:=L;
       if L<>0 then  fl:=false;
     end;
   Ost:=A;
   MinusLL(Ost,MulLongLong(chasn,B));
 end;

function Eq(const a,b:long):bool;
 var
  i:int;
 begin
   eq:=true;
   if a[0]<>b[0] then
     begin
       eq:=false;
       exit;
     end;
   for i := 1 to a[0] do
     if a[i]<>b[i] then
       begin
         eq:=false;
         Break;
       end;
  end;


procedure WriteRac(const R:rac);
 var
  i,N:int;
  chasn,ost,P,Q:long;
  fl:bool;
  t:long;
  beg:int;
 begin
  p:=R.p;
  q:=R.q;
  if more(p,q) then
    begin
      LongDivLong(P,Q,chasn,ost);
      WriteLong(chasn);
      p:=ost;
    end
  else
    if more(q,p) then
      begin
        Write('0');
      end
   else
      begin
        Write('1');
        exit;
      end;

{P<Q}
  if (p[0]>0) and (p[p[0]]>0) then
    begin
      Write('.');

      n:=0;
      fl:=true;
      ostat[0]:=p;
      while fl do
        begin
          inc(N);
          MulLongShort(P,10);
          LongDivLong(P,Q,t,ostat[N]);
          p:=ostat[n];
          chisl[N]:=t[1];
          for i := 0 to N-1 do
            if eq(ostat[i],ostat[n]) then
              begin
                beg:=i;
                fl:=false;
              end;
        end;
      for i :=1 to beg do
        Write(chisl[i]);
      if (p[0]>0) and (p[p[0]]>0) then
        begin
          Write('(');
          for i := beg+1 to N do
            Write(chisl[i]);
          Write(')');
        end;

    end;

 end;

procedure Sokrat(var R:rac);
 var
   A,B,t,tt,ttt:long;
   st2,i:int;
 begin
   a:=R.p;
   b:=R.q;
   st2:=0;
   while (a[0]>0) and (a[a[0]]>0)
     and (b[0]>0) and (b[b[0]]>0)
       do
      begin
        If odd(a[1]) then
          if odd(b[1]) then
            begin
              if More(a,b) then
                begin
                  LongDivLong(A,B,ttt,t);
                  a:=t;
                end
              else
                begin
                  LongDivLong(B,A,ttt,t);
                  B:=t;
                end
            end
          else
            begin
              tt[0]:=1;
              tt[1]:=2;
              LongDivLong(B,tt,t,ttt);
              B:=t;
            end
        else
          if odd(b[1]) then
            begin
              tt[0]:=1;
              tt[1]:=2;
              LongDivLong(A,tt,t,ttt);
              A:=t;
            end
          else
            begin
              tt[0]:=1;
              tt[1]:=2;
              LongDivLong(A,tt,t,ttt);
              A:=t;
              LongDivLong(B,tt,t,ttt);
              B:=t;
              inc(st2);
            end;
      end;
   t[0]:=1;
   t[1]:=1;
   tt[0]:=1;
   tt[1]:=2;
   for i := 1 to st2 do
     t:=MulLongLong(t,tt);
   if (a[0]>0) and (a[a[0]]>0) then
     t:=MulLongLong(t,a);
   if (b[0]>0) and (b[b[0]]>0) then
     t:=MulLongLong(t,b);

   LongDivLong(R.P,t,tt,ttt);
   R.p:=tt;
   LongDivLong(R.Q,t,tt,ttt);
   R.q:=tt;
 end;

procedure Run;
var
 i,j:int;
 A,B:rac;
 Ans:rac;
begin
 ReadRac(A);
 Readln;
 ReadRac(B);

 ans.p:=MulLongLong(a.p,b.q);
 Ans.q:=MulLongLong(a.q,b.p);


 Sokrat(ans);

 WriteRac(ans);

end;

procedure OpenFiles;
 begin
   Assign(input,infile);
   Reset(input);
   Assign(output,outfile);
   Rewrite(output);
 end;

procedure CloseFiles;
 begin
   Close(input);
   Close(OUTPUT);
 end;

Begin
OpenFiles;
Run;
CloseFiles;
End.


