{$I-,Q-,R-,S-}
program ZadA;

type
  int=longint;
  real=extended;
  bool=boolean;

const
  infile='roads.in';
  outfile='roads.out';
  maxN=100000;
var
 N,M,L:int;
 a:array[1..maxN] of int;

  procedure QuickSort(iLo, iHi: Integer);
  var
    Lo, Hi, Mid, T: Integer;
  begin
    Lo := iLo;
    Hi := iHi;
    Mid := A[(Lo + Hi) div 2];
    repeat
      while A[Lo] < Mid do Inc(Lo);
      while A[Hi] > Mid do Dec(Hi);
      if Lo <= Hi then
      begin
        T := A[Lo];
        A[Lo] := A[Hi];
        A[Hi] := T;
        Inc(Lo);
        Dec(Hi);
      end;
    until Lo > Hi;
    if Hi > iLo then QuickSort(iLo, Hi);
    if Lo < iHi then QuickSort(Lo, iHi);
  end;

procedure Run;
var
 i,j:int;
 max:int;
begin
 Read(N,M,L);
 for i := 1 to N do
   Read(a[i]);
 QuickSort(1,N);
 a[N+1]:=a[1]+L;
 max:=0;
 for i := 1 to N do
   if a[i+1]-a[i]>max then
     max:=a[i+1]-a[i];
 Writeln(L-max);

end;

procedure OpenFiles;
 begin
   Assign(input,infile);
   Reset(input);
   Assign(output,outfile);
   Rewrite(output);
 end;

procedure CloseFiles;
 begin
   Close(input);
   Close(OUTPUT);
 end;

Begin
OpenFiles;
Run;
CloseFiles;
End.


