#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#define SQR(X) ((X) * (X))

#define MAX 53

int N, X[MAX], Y[MAX];
double V1, V2, D[MAX][MAX];
double MinD[MAX];
int U[MAX];

int main( void )
{
  int i, j, mini;

  freopen("tractor.in", "rt", stdin);
  freopen("tractor.out", "wt", stdout);
  scanf("%d%lf%lf", &N, &V2, &V1), N++;
  for (i = 0; i < N; i++)
  {
    scanf("%d%d", &X[i], &Y[i]);
    if (i > 0 && X[i] == X[i - 1] && Y[i] == Y[i - 1])
      N--, i--;
    else if (i > 1 && (X[i] - X[i - 1]) * (Y[i - 1] - Y[i - 2]) == 
                      (Y[i] - Y[i - 1]) * (X[i - 1] - X[i - 2]))
      N--, i--, X[i] = X[i + 1], Y[i] = Y[i + 1];
  }
  for (i = 0; i < N; i++)
    for (j = 0; j < N; j++)
      if (abs(i - j) == 1)
        D[i][j] = sqrt(SQR(X[i] - X[j]) + SQR(Y[i] - Y[j])) / V1;
      else
        D[i][j] = sqrt(SQR(X[i] - X[j]) + SQR(Y[i] - Y[j])) / V2;
  for (i = 0; i < N; i++)
    MinD[i] = 1e9;
  MinD[0] = 0;
  memset(U, 0, sizeof(U));
  mini = 0;
  while (mini != -1)
  {
    U[mini] = 1;
    for (i = 0; i < N; i++)
      if (MinD[i] > MinD[mini] + D[mini][i])
        MinD[i] = MinD[mini] + D[mini][i];
    mini = -1;
    for (i = 0; i < N; i++)
      if (!U[i] && (mini == -1 || MinD[i] < MinD[mini]))
        mini = i;
  }
  printf("%.6lf", MinD[N - 1]);
  return 0;
}
