#include <stdio.h>
#include <string.h>

#define SIZE 131072
#define MAXN 100013
#define MAXK 13

typedef unsigned long long t;

int N, K, A[MAXN];
t T[SIZE * 2][MAXK];
t S[MAXN][MAXK];
t Sum = 0, SK[MAXK];

void Get( int max, int St, int L, int R )
{
  int k, M = (L + R) >> 1;

  if (L >= max)
    return;
  if (R < max)
  {
    for (k = 1; k < K; k++)
      SK[k] += T[St][k];
    return;
  }
  Get(max, St << 1, L, M);
  Get(max, (St << 1) + 1, M + 1, R);
}

void Add( int max )
{
  int i, k;

  for (i = SIZE + max; i > 0; i >>= 1)
    for (k = 1; k < K; k++)
      T[i][k] += SK[k];
}

int main( void )
{
  int i, k;

  freopen("form.in", "rt", stdin);
  freopen("form.out", "wt", stdout);
  scanf("%d%d", &N, &K), K++;
  for (i = 0; i < N; i++)
    scanf("%d", &A[i]);
  memset(S, 0, sizeof(S));
  memset(T, 0, sizeof(T));
  for (i = 0; i < N; i++)
  {
    memset(SK, 0, sizeof(SK));
    Get(A[i], 1, 0, SIZE - 1);
    for (k = K; k > 0; k--)
      S[i][k] = SK[k] = SK[k - 1];
    S[i][1] = SK[1] = 1;
    Add(A[i]);
    Sum += S[i][K];
  }
  printf("%Lu", Sum);
  return 0;
}
