#include <stdio.h>
#include <stdlib.h>

#define SWAP(A, B, C) ((C) = (A), (A) = (B), (B) = (C))

#define MAX 100013

typedef int mas[MAX];
typedef long long mas64[MAX];

int N, RN = 0;
mas Pos, X1, Y1, X2, Y2, D, Last, R;
mas64 Sum;

void QSort( int L, int R )
{
  int i = L, j = R, y, tmp;

  if (L >= R) 
    return;
  y = Y1[L + (rand() % (R - L + 1))];
  while (i <= j)
  {
    while (Y1[i] < y)
      i++;
    while (Y1[j] > y)
      j--;
    if (i <= j)
    {
      SWAP(X1[i], X1[j], tmp);
      SWAP(X2[i], X2[j], tmp);
      SWAP(Y1[i], Y1[j], tmp);
      SWAP(Y2[i], Y2[j], tmp);
      SWAP(D[i], D[j], tmp);
      SWAP(Pos[i], Pos[j], tmp);
      i++, j--;
    }
  }
  QSort(L, j);
  QSort(i, R);
}

int main( void )
{
  int i, j, a, maxi;

  srand(23917);
  freopen("rects.in", "rt", stdin);
  freopen("rects.out", "wt", stdout);
  scanf("%d", &N);
  for (i = 0; i < N; i++)
    scanf("%d%d%d%d%d", &X1[i], &Y1[i], &X2[i], &Y2[i], &D[i]), Pos[i] = i;
  QSort(0, N - 1);
  for (i = 0; i < N; i++)
    Sum[i] = D[i], Last[i] = -1;
  for (i = 0; i < N; i++)
    for (j = i + 1; j < N; j++)
      if (Y1[j] > Y2[i] && X2[j] < X1[i] && Sum[j] < (a = Sum[i] + D[j]))
        Sum[j] = a, Last[j] = i;
  maxi = 0;
  for (i = 0; i < N; i++)
    if (Sum[i] > Sum[maxi])
      maxi = i;
  printf("%Ld\n", Sum[maxi]);
  while (maxi != -1)
    R[RN++] = maxi, maxi = Last[maxi];
  for (i = 0; i < RN; i++)
    printf("%d ", Pos[R[i]] + 1);
  return 0;
}
