#include <stdio.h>
#include <string.h>

#define MAX 83
#define VAL 803
#define ADD 400
#define SIZE 1000013

int _stklen = 10000000;

char S[MAX];
int Len, E = 0;
int Can[MAX][MAX], He[MAX][MAX], Is[MAX][MAX];
int A[SIZE], Ne[SIZE];

void Add( int L, int R, int x )
{
  A[E] = x, Ne[E] = He[L][R], He[L][R] = E++;
}

void Do( int L, int R )
{
  char T[VAL];
  int i, v1, v2, L1, R1, c, f = 0, L2, R2, L3, R3;

  if (L > R || Is[L][R])
    return;
  Is[L][R] = 1;
  if (L == R)
  {
    Add(L, R, S[L] - '0' + ADD);
    return;
  }
  memset(T, 0, sizeof(T));
  if (S[L] == '-' || S[L] == '+')
    L1 = L + 1, R1 = R, c = S[L]; 
  else if (S[R] == '-' || S[R] == '+')
    L1 = L, R1 = R - 1, c = S[R]; 
  else
    L1 = L, R1 = R, f = 1;
  for (i = L1; i < R1; i++)
    if ((!f && Can[L1][i] && Can[i + 1][R1]) || 
         (f && Can[L1][i] && Can[i + 2][R1]))
    {
      L2 = L1, R2 = i, R3 = R1;
      if (f)
        c = S[i + 1], L3 = i + 2;
      else
        L3 = i + 1;
      Do(L2, R2);
      Do(L3, R3);
      for (v1 = He[L2][R2]; v1 != -1; v1 = Ne[v1])
        for (v2 = He[L3][R3]; v2 != -1; v2 = Ne[v2])
          if (c == '+')
            T[A[v1] + A[v2] - ADD] = 1;
          else
            T[A[v1] - A[v2] + ADD] = 1;
    }
  for (i = 0; i < VAL; i++)
    if (T[i])
      Add(L, R, i);
}

int main( void )
{
  int i, j, s1, s2;

  freopen("expr.in", "rt", stdin);
  freopen("expr.out", "wt", stdout);
  scanf("%s", S);
  Len = strlen(S);
  memset(He, -1, sizeof(He));
  memset(Is, 0, sizeof(Is));
  memset(Can, 0, sizeof(Can));
  for (i = 0; i < Len; i++)
    for (s1 = s2 = 0, j = i; j < Len; j++)
    {
      if ('0' <= S[j] && S[j] <= '9')
        s1++;
      else
        s2++;
      if (s1 == s2 + 1)
        Can[i][j] = 1;
    }
  Do(0, Len - 1);
  for (s1 = 0, i = He[0][Len - 1]; i != -1; i = Ne[i])
    s1++;
  printf("%d", s1);
  return 0;
}
