{$M 1000000,1000000}
program pb;
 const maxn=10000;
       maxm=1000;
       const maxq=1000001;
 type pair=record
  x,y:integer;
 end;
 var r,c,n,m:longint;
     key:array[1..100,1..100] of char;
     pole:array[-100..maxn+101,0..maxm+1] of char;
     b:array[-100..maxn+101,0..maxm+1] of boolean;
     q:array[0..maxq] of pair;
     ans:longint;

 procedure load;
  var i,j:longint;
 begin
  assign(input,'key.in');
  reset(input);
   fillchar(key,sizeof(key),'.');
   fillchar(pole,sizeof(pole),'.');
   readln(r,c);
   for i:=1 to r do begin
    for j:=1 to c do
     read(key[i,j]);
    readln;
   end;
   readln(n,m);
   for i:=1 to n do begin
    for j:=1 to m do
     read(pole[i,j]);
    readln;
   end;
  close(input);
 end;

 procedure save;
 begin
  assign(output,'key.out');
  rewrite(output);
   writeln(ans);
  close(output);
 end;

 function canset(x,y:longint):boolean;
  var i,j:longint;
 begin
  b[x,y]:=true;
  if (y<c)or(y>m) then begin
   canset:=false;
   exit;
  end;
  for i:=x downto x-r+1 do
   for j:=y downto y-c+1 do
    if (pole[i,j]='#')and(key[r+i-x,c+j-y]='#') then begin
     canset:=false;
     exit;
    end;
  canset:=true;
 end;

 function max(x,y:longint):longint;
 begin
  if x>y then max:=x else max:=y;
 end;

 procedure bfs(x,y:longint);
  var h,l,i,j:longint;
      i1,j1:longint;
 begin
{   i:=x;
   j:=y;
   b[i,j]:=true;
   canset:=true;
   if (j<c)or(j>m) then begin
    canset:=false;
   end;
   if canset then 
   for i1:=i downto i-r+1 do
    for j1:=j downto j-c+1 do
     if (pole[i1,j1]='#')and(key[r+i1-i,c+j1-j]='#') then begin
      canset:=false;
      break;
     end;}
  if not canset(x,y) then exit;
  h:=1;
  l:=1;
  q[h].x:=x;
  q[h].y:=y;
  while not(l=h+1) do begin
   i:=q[l].x;
   j:=q[l].y;
   l:=l mod maxq+1;
   if i>ans then ans:=i;
   if ans>n+r then begin
    ans:=-1;
    save;
    halt(0);
   end;

{   b[i+1,j]:=true;
   canset:=true;
   if (j<c)or(j>m) then begin
    canset:=false;
   end;
   if canset then 
   for i1:=i+1 downto i+1-r+1 do
    for j1:=j downto j-c+1 do
     if (pole[i1,j1]='#')and(key[r+i1-i-1,c+j1-j]='#') then begin
      canset:=false;
      break;
     end;}

   if (not b[i+1,j])and(i<=n+r) then
   if canset(i+1,j) then begin
    h:=h mod maxq +1;
    q[h].x:=i+1;
    q[h].y:=j;
   end;

{   b[i-1,j]:=true;
   canset:=true;
   if (j<c)or(j>m) then begin
    canset:=false;
   end;
   if canset then 
   for i1:=i-1 downto i-1-r+1 do
    for j1:=j downto j-c+1 do
     if (pole[i1,j1]='#')and(key[r+i1-i+1,c+j1-j]='#') then begin
      canset:=false;
      break;
     end;}

   if (not b[i-1,j])and(i>1) then
   if canset(i-1,j) then begin
    h:=h mod maxq +1;
    q[h].x:=i-1;
    q[h].y:=j;
   end;

{   b[i,j+1]:=true;
   canset:=true;
   if (j+1<c)or(j+1>m) then begin
    canset:=false;
   end;
   if canset then 
   for i1:=i downto i-r+1 do
    for j1:=j+1 downto j+1-c+1 do
     if (pole[i1,j1]='#')and(key[r+i1-i,c+j1-j-1]='#') then begin
      canset:=false;
      break;
     end;}

   if (not b[i,j+1])and(j<m)and(i<=n) then
   if canset(i,j+1) then begin
    h:=h mod maxq +1;
    q[h].x:=i;
    q[h].y:=j+1;
   end;

{   b[i,j-1]:=true;
   canset:=true;
   if (j-1<c)or(j-1>m) then begin
    canset:=false;
   end;
   if canset then 
   for i1:=i downto i-r+1 do
    for j1:=j+1 downto j-1-c+1 do
     if (pole[i1,j1]='#')and(key[r+i1-i,c+j1-j+1]='#') then begin
      canset:=false;
      break;
     end;}

   if (not b[i,j-1])and(j>1)and(i<=n) then
   if canset(i,j-1) then begin
    h:=h mod maxq +1;
    q[h].x:=i;
    q[h].y:=j-1;
   end;
  end;
 end;

 procedure solve;
  var i,j:longint;
 begin
  ans:=0;
  fillchar(b,sizeof(b),0);
  for i:=1 to m do begin
   if (not b[1,i]) then begin
    bfs(1,i);
   end;
  end;
 end;

begin
 load;
 solve;
 save;
end.
