program pb;
 const maxn=1257;
 type point=record
  x,y:extended;
 end;
 var n:longint;
     u,v:extended;
     ver:array[1..maxn] of point;
     reb:array[1..maxn,1..maxn] of extended;
     b:array[0..maxn] of boolean;
     q:array[0..maxn] of extended;
     ans:extended;
     hr,nr:longint;

 procedure load;
  var i,j:longint;
      t1,t2,dx,dy:extended;
 begin
  assign(input,'tractor.in');
  reset(input);
   read(n,u,v);
   hr:=1250 div n;
   nr:=0;
   for i:=1 to n+1 do begin
    read(t1,t2);
    if i=1 then begin
     inc(nr);
     ver[i].x:=t1;
     ver[i].y:=t2;
    end else begin
     dx:=(t1-ver[nr].x)/hr;
     dy:=(t2-ver[nr].y)/hr;
     t1:=ver[nr].x;
     t2:=ver[nr].y;
     for j:=1 to hr do begin
      inc(nr);
      ver[nr].x:=t1+dx*j;
      ver[nr].y:=t2+dy*j;
     end;
    end;
   end;
  close(input);
 end;

 procedure save;
 begin
  assign(output,'tractor.out');
  rewrite(output);
   writeln(ans:0:5);
  close(output);
 end;

 function min(x,y:extended):extended;
 begin
  if x<y then min:=x else min:=y;
 end;

 function dist(p1,p2:point):extended;
 begin
  dist:=sqrt(sqr(p1.x-p2.x)+sqr(p1.y-p2.y));
 end;

 procedure solve;
  var i,j,k:longint;
 begin
  ans:=100000000;
  n:=nr;
  for i:=1 to n do
   for j:=1 to n do begin
    if i=j then reb[i,j]:=0 else
     if (i=j+1)or(j=i+1) then reb[i,j]:=dist(ver[i],ver[j])/v else
      reb[i,j]:=dist(ver[i],ver[j])/u;
   end;
   fillchar(b,sizeof(b),0);
   for i:=0 to n do q[i]:=ans;
   q[1]:=0;
   for i:=1 to n do begin
    k:=0;
    for j:=1 to n do
     if (not b[j])and(q[j]<q[k]) then k:=j;
     b[k]:=true;
     for j:=1 to n do
      q[j]:=min(q[j],q[k]+reb[k,j]);
   end;
{  for i:=1 to n do
   for j:=1 to n do
    d[i,j]:=reb[i,j];
  for i:=1 to n do
   for j:=1 to n do
    for k:=1 to n do
     d[j,k]:=min(d[j,k],d[j,i]+d[i,k]);}
  ans:=min(ans,q[n]);
 end;

begin
 load;
 solve;
 save;
end.
