program pb;
 const n=41;
       m=45;
 var   pole,pol:array[1..n,1..m] of longint;
       b:array[1..n,1..m] of boolean;
       cost:array[1..n,1..m] of longint;
       c1,c2:longint;
       ans:longint;

 procedure load;
  var i,j:longint;
      c:char;
 begin
  assign(input,'filya.in');
  reset(input);
   for i:=1 to 41 do begin
    for j:=1 to 45 do begin
     read(c);
     pole[i,j]:=ord(c)-ord('0');
    end;
    readln;
   end;
  close(input);
 end;

 procedure save;
 begin
  assign(output,'filya.out');
  rewrite(output);
   writeln(ans);
  close(output);
 end;

 procedure dfs(x,y:longint);
 begin
  b[x,y]:=true;
  if (x>1)and(pole[x-1,y]=pole[x,y])and(not b[x-1,y]) then dfs(x-1,y);
  if (x<n)and(pole[x+1,y]=pole[x,y])and(not b[x+1,y]) then dfs(x+1,y);
  if (y>1)and(pole[x,y-1]=pole[x,y])and(not b[x,y-1]) then dfs(x,y-1);
  if (y<m)and(pole[x,y+1]=pole[x,y])and(not b[x,y+1]) then dfs(x,y+1);
  pole[x,y]:=0;
 end;

 function dfs2(x,y:longint):longint;
  var a:longint;
 begin
  a:=0;
  b[x,y]:=true;
  if (x>1)and(pol[x-1,y]=pol[x,y])and(not b[x-1,y]) then inc(a,dfs2(x-1,y));
  if (x<n)and(pol[x+1,y]=pol[x,y])and(not b[x+1,y]) then inc(a,dfs2(x+1,y));
  if (y>1)and(pol[x,y-1]=pol[x,y])and(not b[x,y-1]) then inc(a,dfs2(x,y-1));
  if (y<m)and(pol[x,y+1]=pol[x,y])and(not b[x,y+1]) then inc(a,dfs2(x,y+1));
  pol[x,y]:=0;
  dfs2:=a+cost[x,y];
 end;

 procedure setcost;
  var i,j,k:longint;
 begin
  fillchar(cost,sizeof(cost),0);
  for i:=1 to n do
   for j:=1 to m do begin
    k:=1;
    if (i>1)and(pole[i-1,j]>0) then inc(k,20);
    if (i<n)and(pole[i+1,j]>0) then inc(k,20);
    if (j>1)and(pole[i,j-1]>0) then inc(k,20);
    if (j<m)and(pole[i,j+1]>0) then inc(k,20);
    cost[i,j]:=k;
   end;
 end;

 procedure solve;
  var i,j,k,fn,cn:longint;
 begin
  randomize;
  c1:=pole[1,1];
  c2:=pole[n,m];
  fillchar(b,sizeof(b),0);
  dfs(1,1);
  fn:=0;
  cn:=-1;
  for i:=1 to 6 do
   if (i<>c1)and(i<>c2) then begin
    for j:=1 to n do
     for k:=1 to m do
      if pole[j,k]=0 then pol[j,k]:=i
       else pol[j,k]:=pole[j,k];
    fillchar(b,sizeof(b),0);
    setcost;
    k:=dfs2(1,1);
    if k>cn then begin
     cn:=k;
     fn:=i;
    end else
    if (k=cn)and(random(2)=1) then begin
     cn:=k;
     fn:=i;
    end;
   end;
  ans:=fn;
 end;

begin
 load;
 solve;
 save;
end.
