program pb;
 const eps=1e-5;
 type point=record
  x,y:extended;
 end;
 var n,k:longint;
     mn,oc:array[1..200] of point;
     ax,ay,ans:extended;
     s:extended;

 procedure load;
  var i:longint;
 begin
  assign(input,'fire.in');
  reset(input);
   read(n);
   for i:=1 to n do read(mn[i].x,mn[i].y);
   read(k);
   for i:=1 to k do read(oc[i].x,oc[i].y);
  close(input);
 end;

 procedure save;
 begin
  assign(output,'fire.out');
  rewrite(output);
   writeln(ax:0:4,' ',ay:0:4);
  close(output);
 end;

 function min(x,y:extended):extended;
 begin
  if x<y then min:=x else min:=y;
 end;

 function max(x,y:extended):extended;
 begin
  if x>y then max:=x else max:=y;
 end;

 function dist(p1,p2:point):extended;
 begin
  dist:=sqrt(sqr(p1.x-p2.x)+sqr(p1.y-p2.y));
 end;

 procedure check(x,y:extended);
  var p:point;
      i:longint;
      t:extended;
 begin
  p.x:=x;
  p.y:=y;
  t:=1000000;
  for i:=1 to k do t:=min(dist(p,oc[i]),t);
  if t>ans then begin
   ans:=t;
   ax:=x;
   ay:=y;
  end;
 end;

 function vect(p1,p2:point):extended;
 begin
  vect:=p1.x*p2.y-p1.y*p2.x;
 end;

 function good(x,y:extended):boolean;
  var p,q,r:point;
      t:extended;
      i:longint;
 begin
  p.x:=x;
  p.y:=y;
  t:=0;
  for i:=1 to n-1 do begin
   q.x:=mn[i].x-p.x;
   q.y:=mn[i].y-p.y;
   r.x:=mn[i+1].x-p.x;
   r.y:=mn[i+1].y-p.y;
   t:=t+abs(vect(q,r));
  end;
   q.x:=mn[n].x-p.x;
   q.y:=mn[n].y-p.y;
   r.x:=mn[1].x-p.x;
   r.y:=mn[1].y-p.y;
   t:=t+abs(vect(q,r));
  good:=(abs(t-s)<eps);
 end;

 procedure solve;
  var i,j:longint;
      tm1,tm2,tm3:extended;
      mmx,mnx,mmy,mny:longint;
 begin
  for i:=1 to n-1 do s:=s+(mn[i].x*mn[i+1].y-mn[i].y*mn[i+1].x);
  s:=s+(mn[n].x*mn[1].y-mn[1].y*mn[n].x);
  s:=abs(s);
  randseed:=575757;
  ans:=0;
  mmx:=-100000;
  mnx:=100000;
  mmy:=-100000;
  mny:=100000;
  for i:=1 to n do begin
   mmx:=round(max(mmx,mn[i].x));
   mmy:=round(max(mmy,mn[i].y));
   mnx:=round(min(mnx,mn[i].x));
   mny:=round(min(mny,mn[i].y));
   tm1:=1000000;
   for j:=1 to k do
    tm1:=min(tm1,dist(mn[i],oc[j]));
   if ans<tm1 then begin
    ans:=tm1;
    ax:=mn[i].x;
    ay:=mn[i].y;
   end;
  end;
  tm1:=0;
  tm2:=0;
  for i:=1 to n do begin
   tm1:=tm1+oc[i].x;
   tm2:=tm2+oc[i].y;
  end;
  tm1:=tm1/k;
  tm2:=tm2/k;
  check(tm1,tm2);
  for i:=1 to 10000 do begin
   tm1:=mnx+random(mmx-mnx+1);
   tm2:=mny+random(mmy-mny+1);
   if good(tm1,tm2) then check(tm1,tm2);
  end;
 end;

begin
 load;
 solve;
 save;
end.
