{$M 5000000,3000000}
program pb;
 const maxn=100000;
 type reb=record
  x,y:longint;
 end;
 var n,m,l:longint;
     dist,od:array[1..maxn] of longint;
     r:array[1..2*maxn] of reb;
     hs:array[1..maxn] of longint;
     bl:array[1..maxn] of longint;
     gtmp:longint;
     ans,now:longint;
     fl1,fl2:boolean;

 procedure load;
  var i:longint;
 begin
  assign(input,'roads.in');
  reset(input);
   read(n,m,l);
   for i:=1 to n do read(dist[i]);
   for i:=1 to m do begin
    read(r[2*i-1].x,r[2*i-1].y);
    r[2*i].x:=r[2*i-1].y;
    r[2*i].y:=r[2*i-1].x;
   end;
  close(input);
 end;

 procedure save;
  var i:longint;
 begin
  assign(output,'roads.out');
  rewrite(output);
   writeln(ans);
  close(output);
 end;

 procedure qsort;

  procedure sort(l,rq: longint);
    var
       i,j: longint;
       x,y:reb;
    begin
       i:=l;
       j:=rq;
       x:=r[(l+rq) div 2];
       repeat
         while (r[i].x<x.x)or((r[i].x=x.x)and(r[i].y<x.y)) do
          inc(i);
         while (x.x<r[j].x)or((x.x=r[i].x)and(x.y<r[i].y)) do
          dec(j);
         if not(i>j) then
           begin
              y:=r[i];
              r[i]:=r[j];
              r[j]:=y;
              inc(i);
              j:=j-1;
           end;
       until i>j;
       if l<j then
         sort(l,j);
       if i<rq then
         sort(i,rq);
    end;

 begin
    sort(1,2*m);
 end;

 procedure qsort2;

  procedure sort(l,rq: longint);
    var
       i,j: longint;
       x,y:longint;
    begin
       i:=l;
       j:=rq;
       x:=dist[(l+rq) div 2];
       repeat
         while (dist[i]<x) do
          inc(i);
         while (x<dist[j]) do
          dec(j);
         if not(i>j) then
           begin
              y:=dist[i];
              dist[i]:=dist[j];
              dist[j]:=y;
              y:=od[i];
              od[i]:=od[j];
              od[j]:=y;
              inc(i);
              j:=j-1;
           end;
       until i>j;
       if l<j then
         sort(l,j);
       if i<rq then
         sort(i,rq);
    end;

 begin
    sort(1,n);
 end;

 procedure dfs(x:longint);
  var i:longint;
 begin
  od[x]:=gtmp;
  if hs[x]=0 then exit;
  i:=hs[x];
  while (i<=2*m)and(r[i].x=x) do begin
   if od[r[i].y]=0 then begin
    fl1:=false;
    dfs(r[i].y);
   end;
   inc(i);
  end;
 end;

 function min(x,y:longint):longint;
 begin
  if x<y then min:=x else min:=y;
 end;

 procedure solve;
  var i,j:longint;
      tmp:array[1..maxn] of longint;
 begin
  fl1:=true;
  fl2:=true;
  ans:=l;
  qsort;
  fillchar(hs,sizeof(hs),0);
  hs[r[1].x]:=1;
  for i:=2 to 2*m do
   if r[i].x<>r[i-1].x then hs[r[i].x]:=i;
  fillchar(od,sizeof(od),0);
  for i:=1 to n do
   if od[i]=0 then begin
    gtmp:=i;
    dfs(i);
    if i>1 then fl2:=false;
   end;
  qsort2;
  if fl1 then begin
   ans:=0;
   exit;
  end;
  if fl2 then begin
   ans:=l;
   exit;
  end;
  now:=0;
  fillchar(tmp,sizeof(tmp),0);
  fillchar(bl,sizeof(bl),0);
  for i:=1 to n do begin
   if tmp[od[i]]<>0 then bl[tmp[od[i]]]:=i;
   tmp[od[i]]:=i;
  end;
  i:=1;
  while i<=n do begin
   if bl[i]<>0 then begin
    inc(now,dist[bl[i]]-dist[i]);
    i:=bl[i];
   end;
   inc(i);
  end;
  ans:=min(ans,now);
 end;

begin
 load;
 solve;
 save;
end.
