const
        MaxN = 50;
type
        TPoint =
        record
          x, y : LongInt;
        end;
var
        u, v : Real;
        n : LongInt;
        mas : Array[1 .. MaxN] of TPoint;
        t : Array[1 .. MaxN] of Real;

Procedure Init;
var
        i : LongInt;
begin
  Assign(input, 'tractor.in');
  Reset(input);
  ReadLn(n, u, v);
  Inc(n);
  for i := 1 to n do
    Read(mas[i].x, mas[i].y);
  Close(input);
end;

Function Dist(const a, b : TPoint; const v : Real) : Real;
begin
  Dist := Sqrt(Sqr(a.x - b.x) + Sqr(a.y - b.y)) / v;
end;

Function Summ(const l, r : LongInt) : Real;
begin
  if l = r then
    Summ := 0
  else
    Summ := Dist(mas[l], mas[l + 1], v) + Summ(l + 1, r);
end;

Function Min(const a, b : Real) : Real;
begin
  if a < b then
    Min := a
  else
    Min := b;
end;

Procedure Solve;
var
        i, j : LongInt;
begin
  for i := n downto 1 do
  begin
    t[i] := Dist(mas[i], mas[n], u);
    for j := i + 1 to n do
      t[i] := Min(t[i], Summ(i, j) + t[j]);
  end;
  Assign(output, 'tractor.out');
  Rewrite(output);
  WriteLn(t[1] : 0 : 5);
  Close(output);
end;

Procedure Print;
begin
end;

begin
  Init;
  Solve;
  Print;
end.
