const
        MaxN = 1207;
var
        a, sm : Array[1 .. MaxN, 0 .. MaxN] of LongInt;
        s : Array[1 .. MaxN] of Array[1 .. MaxN] of Word;
        n : LongInt;
        rez : Array[1 .. MaxN] of LongInt;

Procedure Init;
var
        i, j : LongInt;
begin
  ReadLn(n);
  for i := 1 to n do
    for j := 1 to n do
      Read(a[i][j]);
end;

Procedure Swap(var a, b : Word);
var
        c : Word;
begin
  c := a;
  a := b;
  b := c;
end;

Procedure QSort(const l, r, e : Longint);
var
        i, j, x : LongInt;
begin
  i := l;
  j := r;
  x := a[s[(l + r) div 2][e]][e];
  repeat
    While a[s[i][e]][e] < x do
      Inc(i);
    While a[s[j][e]][e] > x do
      Dec(j);
    if i <= j then
    begin
      Swap(s[i][e], s[j][e]);
      Inc(i);
      Dec(j);
    end;
  until i > j;
  if j > l then
    QSort(j, l, e);
  if i < r then
    QSort(i, r, e);
end;

Procedure Solve;
var
        i, j, k, l : LongInt;
begin
  for i := 1 to n do
  begin
    a[i][i] := 0;
    for j := 1 to n do
      if a[i][i] < a[j][i] then
        a[i][i] := a[j][i];
  end;
  FillChar(sm, SizeOf(sm), 0);
  for i := 1 to n do
  begin
    for j := 1 to n do
      s[j][i] := j;
    QSort(1, n, i);
    k := n;
    for j := n - 1 downto 1 do
    begin
      if a[s[j][i]][i] < a[s[j + 1][i]][i] then
        k := j;
      for l := k + 1 to n do
        if sm[s[j][i]][s[l][i]] = 0 then
        begin
          sm[s[j][i]][s[l][i]] := 1;
          Inc(sm[s[l][i]][0]);
        end;
    end;
  end;
  for i := 1 to n do
  begin
    j := 1;
    While (sm[j][0] <> 0) do
    begin
      Inc(j);
      if j > n then
      begin
        WriteLn(-1);
        Exit;
      end;
    end;
    sm[j][0] := -1;
    for k := 1 to n do
      if sm[j][k] = 1 then
      begin
        sm[k][j] := 0;
        Dec(sm[k][0]);
      end;
    rez[i] := j;
  end;
  for i := 1 to n do
    Write(rez[i], ' ');
  WriteLn;
end;

begin
  Assign(input, 'chat.in');
  Reset(input);
  Assign(output, 'chat.out');
  Rewrite(output);
  While True do
  begin
    Init;
    if n = 0 then
      Break;
    Solve;
  end;
  Close(input);
  Close(output);
end.