  {$I-,Q-,R-,S-}
const
        MaxN = 100000;
type
        TP = ^TT;
        TT =
        record
          b : LongInt;
          next : TP;
        end;
var
        t : Byte;
        out : Text;
        s : String;
        sm : Array[1 .. MaxN] of TP;
        n, m, i : LongInt;
        bo : Array[1 .. MaxN] of Boolean;

Procedure Delete(var a : TP);
var
        t : TP;
begin
  t := a;
  a := a^.next;
  Dispose(t);
end;

Procedure Add(var a : TP; const b : LongInt);
var
        t : TP;
begin
  t := a;
  New(a);
  a^.b := b;
  a^.next := t;
end;

Procedure Init;
var
        i, a, b : LongInt;
begin
  ReadLn(n, m);
  for i := 1 to n do
  begin
    While sm[i] <> nil do
      Delete(sm[i]);
    bo[i] := False;
  end;
  for i := 1 to m do
  begin
    ReadLn(a, b);
    Add(sm[a], b);
    Add(sm[b], a);
  end;
end;

Function Solve(const v, g : LongInt) : Boolean;
var
        t : TP;
begin
  if g = 0 then
  begin
    Write(v, ' ');
    Solve := True;
    Exit;
  end;
  bo[v] := True;
  t := sm[v];
  While t <> nil do
  begin
    if not bo[t^.b] then
      if Solve(t^.b, g - 1) then
      begin
        Solve := True;
        Write(v, ' ');
        Exit;
      end;
    t := t^.next;
  end;
  bo[v] := False;
  Solve := False;
end;

begin
  for n := 1 to MaxN do
    sm[n] := nil;
  Assign(out, 'CON');
  Rewrite(out);
  for t := 7 to 20 do
  begin
    WriteLn(out, t);
    Str(t, s);
    if Length(s) < 2 then
      s := '0' + s;
    Assign(input, 'c:\sbor\path.' + s);
    Assign(output, 'c:\sbor\kum_04_c.' + s);
    Reset(input);
    Rewrite(output);
    Init;
    for i := 1 to n do
      if Solve(i, n - 1) then
        Break
      else
        Write(i, ' ');
    Close(input);
    Close(output);
  end;
  Close(out);
end.
