const
        MaxM = 10000;
        MaxN = 100;
        MaxK = 10;
type
        TDoor =
        record
          a, b : Word;
          k : Byte;
        end;
        PCan = ^TCan;
        TCan =
        record
          data : Word;
          next : PCan;
        end;

var
        door : Array[1 .. MaxM] of TDoor;
        n, m, k, p, t : Word;
        win : Array[1 .. MaxN, 1 .. MaxN] of LongInt;
        can : Array[1 .. MaxN, 1 .. MaxK] of PCan;

Procedure AddDoor(const a, b, k : LongInt);
var
        t : PCan;
begin
  t := can[a][k];
  New(can[a][k]);
  can[a][k]^.data := b;
  can[a][k]^.next := t;
end;

Procedure Init;
var
        i, j : Word;
begin
  Assign(input, 'pursuit.in');
  Reset(input);
  ReadLn(n, m, k);
  for i := 1 to m do
  begin
    ReadLn(door[i].a, door[i].b, door[i].k);
    AddDoor(door[i].a, door[i].b, door[i].k);
    AddDoor(door[i].b, door[i].a, door[i].k);
  end;
  ReadLn(p, t);
  Close(input);
  for i := 1 to n do
    for j := 1 to n do
      win[i][j] := -2;
end;

Function Min(const a, b : LongInt) : LongInt;
begin
  if a < b then
    Min := a
  else
    Min := b;
end;

Function Solve(const p, t, pred : Word) : LongInt;
var
        i : Byte;
        j : Word;
        a : PCan;
        pr : Boolean;

Function Catch(const p, t, k, pred : Word) : LongInt;
var
        rez : LongInt;
        a : PCan;
begin
  if p = t then
    Catch := 0
  else
  begin
    a := can[t][k];
    rez := Solve(p, t, pred);
    While (a <> nil) and (rez <> -1) do
    begin
      i := Solve(p, a^.data, pred);
      if i = -1 then
      begin
        rez := -1;
        Break;
      end;
      if rez < i then
        rez := i;
      a := a^.next;
    end;
  end;
  Catch := rez;
end;

begin
  if win[p][t] =  -2 then
  begin
    win[p][t] := MaxLongInt;
    for i := 1 to k do
    begin
      a := Can[p][i];
      Pr := False;
      While a <> nil do
      begin
        if a^.data <> pred then
        begin
          j := Catch(a^.data, t, i, pred);
          if j <> -1 then
            win[p][t] := Min(win[p][t], j);
        end
        else
          pr := True;
        a := a^.next;
      end;
      if win[p][t] = MaxLongInt then
      begin
        if pr then
        begin
          WriteLn('Endless');
          Halt;
        end
        else
          win[p][t] := -1;
      end;
    end;
  end
  else
  begin
    Solve := win[p][t];
  end;
end;

Procedure Print;
begin
end;

begin
  Init;
  Solve(p, t, 0);
  Print;
end.
