const
        MaxN = 53;
        MaxK = MaxN;
type
        TMM =
        record
          max, min : LongInt;
        end;
var
        a : Array[1 .. MaxN] of LongInt;
        din : Array[1 .. MaxN, 1 .. MaxN, 1 .. MaxK] of TMM;
        n, k : LongInt;

Procedure Init;
var
        i : LongInt;
begin
  Assign(input, 'necklace.in');
  Reset(input);
  ReadLn(n, k);
  for i := 1 to n do
    Read(a[i]);
  Close(input);
end;

Function Summ(const l, r : Byte) : LongInt;
var
        rez : LongInt;
        i : Byte;
begin
  rez := 0;
  for i := l to r do
    Inc(rez, a[i]);
  Summ := rez;
end;

Function Min(const a, b : LongInt) : LongInt;
begin
  if a < b then
    Min := a
  else
    Min := b;
end;

Function Max(const a, b : LongInt) : LongInt;
begin
  if a > b then
    Max := a
  else
    Max := b;
end;

Procedure Rec(const l, r, k : Byte);
var
        rez : TMM;
        s : LongInt;
        i : Byte;
begin
  if k = 1 then
  begin
    s := Summ(l, r);
    din[l][r][k].min := s;
    din[l][r][k].max := s;
    Exit;
  end;
  if (din[l][r][k].min = 0) and (din[l][r][k].max = 0) then
  begin
    s := 0;
    din[l][r][k].max := 60000000;
    din[l][r][k].min := 0;
    for i := l to r - 1 do
    begin
      Rec(i + 1, r, k - 1);
      Inc(s, a[i]);
      rez.min := Min(s, din[i + 1][r][k - 1].min);
      rez.max := Max(s, din[i + 1][r][k - 1].max);
      if rez.max - rez.min < din[l][r][k].max - din[l][r][k].min then
        din[l][r][k] := rez;
    end;
  end;
end;

Procedure Rec2(const l, r, k : Byte; const w : TMM);
var
        i, j : LongInt;
        rez : TMM;
begin
  if k = 1 then
  begin
    for i := l to r do
      Write(i, ' ');
    Exit;
  end;
  for i := l to r do
  begin
    rez := din[i + 1][r][k - 1];
    rez.min := Min(Summ(l, i), rez.min);
    rez.max := Max(Summ(l, i), rez.max);
    if (rez.min = w.min) and (rez.max = w.max) then
    begin
      for j := l to i do
        Write(j, ' ');
      WriteLn;
      Rec2(i + 1, r, k - 1, din[i + 1][r][k - 1]);
      Exit;
    end;
  end;
end;

Procedure Solve;
var
        i, j, ii, ji, y : LongInt;
        rez, ri : TMM;
begin
  Assign(output, 'necklace.out');
  Rewrite(output);
  if k = 1 then
  begin
    WriteLn(0);
    for i := 1 to n do
      Write(i, ' ');
    Close(output);
    Halt;
  end;
  FillChar(din, SizeOf(din), False);
  ri.max := 60000000;
  ri.min := 0;
  for i := 0 to n - 1 do
    for j := i + 1 to n do
    begin
      Rec(i + 1, j, k - 1);
      rez.min := Min(din[i + 1][j][k - 1].min, Summ(1, i) + Summ(j + 1, n));
      rez.max := Max(din[i + 1][j][k - 1].max, Summ(1, i) + Summ(j + 1, n));
      if rez.max - rez.min < ri.max - ri.min then
      begin
        ri := rez;
        ii := i;
        ji := j;
      end;
    end;
  WriteLn(ri.max - ri.min);
  for y := 1 to ii do
    Write(y, ' ');
  for y := ji + 1 to n do
    Write(y, ' ');
  WriteLn;
  Rec2(ii + 1, ji, k - 1, din[ii + 1][ji][k - 1]);
  Close(output);
end;

Procedure Print;
begin
end;

begin
  Init;
  Solve;
  Print;
end.
