{$I+,Q-,R-,S-}
const
        MaxN = 70000;
type
        TRect =
        record
          l, u, r, d : LongInt;
          a, n : LongInt;
        end;
        TMas = Array[1 .. MaxN] of Int64;

var
        r : Array[1 .. MaxN] of TRect;
        n : LongInt;
        rez : TMas;
        mmax : Int64;

Procedure Swap(var a, b : TRect);
var
        c : TRect;
begin
  c := a;
  a := b;
  b := c;
end;

Procedure QSort(const ll, rr : LongInt);
var
        i, j, x : LongInt;
begin
  i := ll;
  j := rr;
  x := r[(i + j) div 2].l;
  repeat
    While r[i].l < x do
      Inc(i);
    While r[j].l > x do
      Dec(j);
    if i <= j then
    begin
      Swap(r[i], r[j]);
      Inc(i);
      Dec(j);
    end;
  until i > j;
  if ll < j then
    QSort(ll, j);
  if i < rr then
    QSort(i, rr);
end;

Procedure Init;
var
        i : LongInt;
begin
  Assign(input, 'rects.in');
  Reset(input);
  ReadLn(n);
  for i := 1 to n do
  begin
    ReadLn(r[i].l, r[i].d, r[i].r, r[i].u, r[i].a);
    r[i].n := i;
  end;
  QSort(1, n);
  Close(input);
end;

Function Can(const a, b : TRect) : Boolean;
begin
  Can := (a.r < b.l) and (a.d > b.u);
end;

Procedure Rec(const i : LongInt);
var
        j : LongInt;
begin
  Write(r[i].n, ' ');
  for j := i + 1 to n do
    if (Can(r[i], r[j])) and (rez[i] = rez[j] + r[i].a) then
    begin
      Rec(j);
      Exit;
    end;
end;

Procedure Solve;
var
        i, j, ar : LongInt;
begin
  Assign(output, 'rects.out');
  Rewrite(output);
  FillChar(rez, SizeOf(rez), 0);
  for i := n downto 1 do
  begin
    if i = 1 then
      rez := rez;
    rez[i] := r[i].a;
    for j := i + 1 to n do
      if Can(r[i], r[j]) then
      begin
        if rez[i] < r[i].a + rez[j] then
          rez[i] := r[i].a + rez[j];
      end;
  end;
  ar := 1;
  for i := 1 to n do
    if rez[i] > rez[ar] then
      ar := i;
  WriteLn(rez[ar]);
  Rec(ar);
  Close(output);
end;

Procedure Print;
begin
end;

begin
  Init;
  Solve;
  Print;
end.
