const
        MaxN = 100;
var
        x, y, z, x1, y1, z1 : Byte;
        mas : Array[1 .. MaxN, 1 .. MaxN, 1 .. MaxN] of LongInt;
        k : LongInt;

Procedure Init;
var
        i, j, k1 : LongInt;
begin
  Assign(input, 'virtual.in');
  Reset(input);
  Assign(output, 'virtual.out');
  Rewrite(output);
  ReadLn(x, y, z, x1, y1, z1, k);
  for i := 1 to z do
    for j := 1 to y do
      for k1 := 1 to x do
        Read(mas[i][j][k1]);
  Close(input);
end;

Procedure Error;
begin
  WriteLn(-1);
  Close(output);
  Halt;
end;

Procedure Solve;
var
        z0, y0, x0, u, i, j, b : LongInt;
        d : Array[1 .. MaxN, 1 .. MaxN] of LongInt;
        rez : Int64;
begin
  rez := 0;
  FillChar(d, SizeOf(d), 0);
  for z0 := 1 to z - z1 + 1 do
  begin
    for y0 := 1 to y - y1 + 1 do
      for x0 := 1 to x - x1 + 1 do
      begin
        u := (k - mas[z0][y0][x0] + 1) mod (k + 1);
        Inc(rez, u);
        for i := y0 to y0 + y1 - 1 do
          for j := x0 to x0 + x1 - 1do
          begin
            d[i][j] := (d[i][j] + u) mod (k + 1);
            mas[z0][i][j] := (mas[z0][i][j] + u) mod (k + 1);
          end;
      end;
    for i := 1 to y do
      for j := 1 to x do
      begin
        if mas[z0][i][j] <> 0 then
          Error;
        for b := z0 + 1 to z0 + z1 - 1 do
          mas[b][i][j] := (mas[b][i][j] + d[i][j]) mod (k + 1);
        d[i][j] := 0;
      end;
  end;
  for z0 := z - z1 + 2 to z do
    for y0 := 1 to y do
      for x0 := 1 to x do
        if mas[z0][y0][z0] <> 0 then
          Error;
  WriteLn(rez);
end;

Procedure Print;
begin
  Close(output);
end;

begin
  Init;
  Solve;
  Print;
end.
