{$Q-,R-,S-,I-}

const maxn = 100000;

type TPoint = record x, y: longint; end;
     TRect = record lu, rd: TPoint; a: longint; end;
//     int64 = longint;

var n, i, j: longint;
    r: array [1..maxn] of TRect;
    s: array [1..maxn] of longint;
    d: array [1..maxn, 1..2] of int64;
    num: longint;
    max: int64;

procedure writeans (const a: longint);
begin
  if a = 0 then exit;
  writeans (d [a, 2]);
  write (' ', s [a]);
end;

procedure readrect (var r: TRect);
begin
  read (r.lu.x, r.rd.y, r.rd.x, r.lu.y, r.a);
end;

procedure swap (var a, b: longint);
var c: longint;
begin
  c := a;
  a := b;
  b := c;
end;

function compare (const a, b: TRect): longint;
begin
  if (a.lu.x = b.lu.x) and (a.lu.y = b.lu.y) then
     begin
       compare := 0;
       exit;
     end;
  if (a.lu.y > b.lu.y) or
     ((a.lu.y = b.lu.y) and (a.lu.x < b.lu.x)) then
     begin
       compare := -1;
       exit;
     end;
  compare := 1;
end;

procedure sort (left, right: longint);
var i, j, x: longint;
begin
  i := left;
  j := right;
  x := random (j - i + 1) + i;
  while i<=j do
  begin
    while compare (r [s [i]], r [s [x]]) = -1 do inc (i);
    while compare (r [s [j]], r [s [x]]) = 1 do dec (j);
    if i<=j then
    begin
      swap (s [i], s [j]);
      inc (i);
      dec (j);
    end;
  end;
  if i < right then sort (i, right);
  if left < j then sort (left, j);
end;

begin
  assign (input, 'rects.in');
  reset (input);
  assign (output, 'rects.out');
  rewrite (output);
  read (n);
  for i := 1 to n do
    readrect (r [i]);
  for i := 1 to n do
    s [i] := i;
  sort (1, n);
  d [1, 1] := r [s [1]].a;
  for i := 2 to n do
  begin
    d [i, 1] := r [s [i]].a;
    d [i, 2] := 0;
    for j := 1 to i-1 do
      if (r [s [j]].rd.x < r [s [i]].lu.x) and (r [s [j]].rd.y > r [s [i]].lu.y) and
      (d [j, 1] + r [s [i]].a > d [i, 1]) then
      begin
        d [i, 1] := d [j, 1] + r [s [i]].a;
        d [i, 2] := j;
      end;
  end;
  max := 0;
  num := 0;
  for i := 1 to n do
    if d [i, 1] > max then
    begin
      max := d [i, 1];
      num := i;
    end;
  writeln (max);
  writeans (num);
  close (input);
  close (output);
end.
