{$Q-,R-,S-,I-}
{$LONGSTRINGS ON}

const maxn = 350;

var n, m, t, i, h, j, q, w: longint;
    s: array [1..maxn, 0..1] of longint;
    e: array [1..maxn] of longint;
    eq: array [1..maxn, 1..maxn] of longint;
    c: array [1..maxn, 1..maxn] of string;

procedure solve (const a, b: longint);
var u1, u2, v1, v2: longint;
begin
  eq [a, b] := 2;
  eq [b, a] := 2;
  u1 := s [a, 0];
  u2 := s [b, 0];
  v1 := s [a, 1];
  v2 := s [b, 1];
  if eq [u1, u2] = 0 then solve (u1, u2);
  if eq [v1, v2] = 0 then solve (v1, v2);
  if (eq [u1, u2] = 1) and (eq [v1, v2] = 1) then
  begin
    eq [a, b] := 1;
    eq [b, a] := 1;
    exit;
  end;
  if (eq [u1, u2] = -1) and (eq [v1, v2] <> -1) then
  begin
    eq [a, b] := -1;
    eq [b, a] := -1;
    c [a, b] := '0' + c [u1, u2];
    c [b, a] := c [a, b];
    exit;
  end;
  if (eq [v1, v2] = -1) and (eq [u1, u2] <> -1) then
  begin
    eq [a, b] := -1;
    eq [b, a] := -1;
    c [a, b] := '1' + c [v1, v2];
    c [b, a] := c [a, b];
    exit;
  end;
  if (eq [v1, v2] = -1) and (eq [u1, u2] = -1) then
  begin
    eq [a, b] := -1;
    eq [b, a] := -1;
    if length (c [u1, u2]) < length (c [v1, v2]) then
    begin
      c [a, b] := '0' + c [u1, u2];
      c [b, a] := c [a, b];
    end else
    begin
      c [a, b] := '1' + c [v1, v2];
      c [b, a] := c [a, b];
    end;
    exit;
  end;
  eq [a, b] := 1;
  eq [b, a] := 1;
end;

begin
  assign (input, 'eq.in');
  reset (input);
  assign (output, 'eq.out');
  rewrite (output);
  read (n, t);
  for i := 1 to t do
  begin
    read (h);
    e [h] := 1;
  end;
  for i := 1 to n do
    for j := 1 to n do
    begin
      if i = j then eq [i, j] := 1;
      if e [i] <> e [j] then eq [i, j] := -1;
    end;
  for i := 1 to n do
    read (s [i, 0], s [i, 1]);
  for i := 1 to n do
    for j := 1 to n do
      if eq [i, j] = 0 then
        solve (i, j);
  read (m);
  for i := 1 to m do
  begin
    read (q, w);
    if eq [q, w] = 1 then writeln ('equivalent') else writeln (c [q, w]);
  end;
  close (input);
  close (output);
end.
