{$Q-,R-,S-,I-}

const eps = 1e-15;
      maxk = 10000;
      maxn = 100000;

type
//     int64 = longint;
     real = extended;
     TGem = record a, a0: real; p, f: longint; end;
     TStone = record w: int64; k: longint; end;

var n, k, i, h: longint;
    g: array [1..maxn] of TGem;
    _1_k, _2pi_k: real;
    it_min, it_max: array [1..2*maxk] of int64;
    ans: int64;
    n_k: longint;
    big: int64;

function getmin: int64;
begin
  getmin := it_min [1];
end;

function getmax: int64;
begin
  getmax := it_max [1];
end;

function min (const a, b: int64): int64;
begin
  if a < b then min := a else min := b;
end;

function max (const a, b: int64): int64;
begin
  if a > b then max := a else max := b;
end;

procedure change_sum (const d, num: longint);
var p: longint;
begin
  p := 1 shl h + num - 1;
  it_min [p] := it_min [p] + d;
  while p > 1 do
  begin
    p := p shr 1;
    it_min [p] := min (it_min [2*p], it_min [2*p+1]);
  end;
  p := 1 shl h + num - 1;
  it_max [p] := it_max [p] + d;
  while p > 1 do
  begin
    p := p shr 1;
    it_max [p] := max (it_max [2*p], it_max [2*p+1]);
  end;
end;

procedure swap (var a, b: TGem);
var c: TGem;
begin
  c := a;
  a := b;
  b := c;
end;

procedure sort (const l, r: longint);
var  i, j: longint;
     x: real;
begin
  i := l;
  j := r;
  x := g [random (j - i + 1) + i]. a0;
  while i <= j do
  begin
    while g [i].a0 - x < 0 do inc (i);
    while g [j].a0 - x > 0 do dec (j);
    if i <= j then
    begin
      swap (g [i], g [j]);
      inc (i);
      dec (j);
    end;
  end;
  if l < j then sort (l, j);
  if i < r then sort (i, r);
end;

begin
  big := 1000000000;
  big := big * big;
  assign (input, 'necklace.in');
  reset (input);
  assign (output, 'necklace.out');
  rewrite (output);
  read (n, k);
  h := 0;
  while k > 1 shl h do inc (h);
  _1_k := 1 / k;
  _2pi_k := 2*pi*_1_k;
  for i := 1 to n do
  begin
    read (g [i].a, g [i].p);
    g [i].a := eps + g [i].a;
    g [i].f := trunc (g [i].a / _2pi_k);
    g [i].a0 := g [i].a - g [i].f * _2pi_k;
    inc (g [i].f);
  end;
  sort (1, n);
  for i := 1 to 2*maxk do it_min [i] := big;
  for i := 1 to n do
  begin
    it_min [g [i].f + (1 shl h) - 1] := it_min [g [i].f + (1 shl h) - 1] + g [i].p;
    it_max [g [i].f + (1 shl h) - 1] := it_min [g [i].f + (1 shl h) - 1];
  end;
  for i := (1 shl h) - 1 downto 1 do
  begin
    it_max [i] := max (it_max [2*i], it_max [2*i+1]);
    it_min [i] := min (it_min [2*i], it_min [2*i+1]);
  end;
  ans := getmax - getmin;
  for i := 1 to n do
  begin
    n_k := g [i].f - 1;
    if n_k = 0 then n_k := k;
    change_sum (-g [i].p, g [i].f);
    change_sum (g [i].p, n_k);
    if  getmax - getmin < ans then ans := getmax - getmin;
  end;
  writeln (ans);
  close (input);
  close (output);
end.