{$Q-,R-,S-,I-}

const maxn = 250;

type TAns = record k: longint; r: array [1..maxn] of byte; end;

var n, p, i, k, pr, lev, j, w, e, t: longint;
    r: array [1..maxn, 1..2] of longint;
    c: array [1..maxn, -1..maxn, 1..2] of longint;
    v, l, q, s: array [1..maxn] of longint;
    a, d: array [0..maxn, 0..maxn] of TAns;
    ans: TAns;

procedure swap (var a, b: longint);
var c: longint;
begin
  c := a;
  a := b;
  b := c;
end;

procedure sort (const left, right: longint);
var i, j, x: longint;
begin
  i := left;
  j := right;
  x := l [q [random (j - i + 1) + i]];
  while i <= j do
  begin
    while l [q [i]] > x do inc (i);
    while l [q [j]] < x do dec (j);
    if i <= j then
    begin
      swap (q [i], q [j]);
      inc (i);
      dec (j);
    end;
  end;
  if left < j then sort (left, j);
  if i < right then sort (j, right);
end;

function min (const a, b: longint): longint;
begin
  if a < b then min := a else min := b;
end;

begin
  assign (input, 'tree.in');
  reset (input);
  assign (output, 'tree.out');
  rewrite (output);
  read (n, p);
  if p = n then
  begin
    writeln (0);
    close (output);
    halt;
  end;
  for i := 1 to n-1 do
    read (r [i, 1], r [i, 2]);
  l [1] := 1;
  k := 1;
  v [k] := 1;
  pr := 1;
  lev := 1;
  while pr < n do
  begin
    inc (lev);
    for i := 1 to k do
      for j := 1 to n-1 do
      begin
        if r [j, 2] = v [i] then swap (r [j, 1], r [j, 2]);
        if r [j, 1] <> v [i] then continue;
        if l [r [j, 2]] <> 0 then continue;
        inc (c [v [i], 0, 1]);
        c [v [i], c [v [i], 0, 1], 1] := r [j, 2];
        c [v [i], c [v [i], 0, 1], 2] := j;
        c [r [j, 2], -1, 1] := v [i];
        c [r [j, 2], -1, 2] := j;
        l [r [j, 2]] := lev;
        inc (pr);
      end;
    k := 0;
    fillchar (v, sizeof (v), 0);
    for i := 1 to n do
      if l [i] = lev then
      begin
        inc (k);
        v [k] := i;
      end;
  end;
  for i := 1 to n do
    q [i] := i;
  sort (1, n);
  for i := 1 to n do
  begin
    s [q [i]] := 1;
    for j := 1 to c [q [i], 0, 1] do
      s [q [i]] := s [q [i]] + s [c [q [i], j, 1]];
  end;
  for i := 1 to n do
  begin
    if c [q [i], 0, 1] = 0 then
    begin
      a [q [i], 0].k := -1;
      a [q [i], 1].k := 0;
      for j := 2 to n do
        a [q [i], j].k := -1;
      continue;
    end;
    fillchar (d, sizeof (d), 0);
    d [1, 0].k := 1;
    d [1, 0].r [1] := c [q [i], 1, 2];
    for j := 1 to n do
      d [1, j] := a [c [q [i], 1, 1], j];
    for w := 2 to c [q [i], 0, 1] do
    begin
      d [w, 0] := d [w-1, 0];
      inc (d [w, 0].k);
      d [w, 0].r [d [w, 0].k] := c [q [i], w, 2];
      for j := 1 to s [q [i]] - 1 do
      begin
        if d [w-1, j].k <> -1 then
        begin
          d [w, j] := d [w-1, j];
          inc (d [w, j].k);
          d [w, j].r [d [w, j].k] := c [q [i], w, 2];
        end;
        for e := 1 to min (j, s [c [q [i], w, 1]]) do
          if d [w-1, j-e].k + a [c [q [i], w, 1], e].k < d [w, j].k then
          begin
            d [w, j] := d [w-1, j-e];
            for t := 1 to a [c [q [i], w, 1], e]. k do
            begin
              inc (d [w, j].k);
              d [w, j].r [d [w, j].k] := a [c [q [i], w, 1], e]. r [t];
            end;
          end;
      end;
    end;
    for j := 1 to s [q [i]] do
      a [q [i], j] := d [c [q [i], 0, 1], j-1];
    for j := s [q [i]] + 1 to n do
      a [q [i], j].k := -1;
  end;
  for i := 2 to n do
    for j := 1 to s [i] do
    begin
      inc (a [i, j].k);
      a [i, j].r [a [i, j].k] := c [i, -1, 2];
    end;
  ans := a [1, p];
  for i := 2 to n do
  begin
    if a [i, p].k = -1 then continue;
    if a [i, p].k < ans.k then
    ans := a [i, p];
  end;
  writeln (ans.k);
  for i := 1 to ans.k-1 do
    write (ans. r [i], ' ');
  write (ans.r [ans.k]);
  close (input);
  close (output);
end.
