{$Q-,R-,I-,S-}
var
  img :array [1..41,1..41] of char;
  x,y :array [0..2000] of longint;
  n,m,k,i,j :longint;

procedure debug;
begin
  for i := 1 to k do
    img[x[i],y[i]] := chr(ord('0')+i mod 10);
  for i := 1 to n do
    begin
      for j := 1 to m do
        write (img[i,j]);
      writeln;
    end;
  writeln;
  for i := 1 to k do
    img[x[i],y[i]] := chr(ord('0')+i div 10);
  for i := 1 to n do
    begin
      for j := 1 to m do
        write (img[i,j]);
      writeln;
    end;
  writeln;
end;

function cmp (a,b :longint) :boolean; {a<=b}
begin
  case (x[a]-x[1])*(y[b]-y[1])-(x[b]-x[1])*(y[a]-y[1]) of
    -maxlongint..-1:cmp:=true;
                  0:cmp:=
                    (sqr(x[a]-x[1])+sqr(y[a]-y[1]))
                    <
                    (sqr(x[b]-x[1])+sqr(y[b]-y[1]));
    1..maxlongint  :cmp:=false;
  end;
end;

{procedure qsort (a,b :longint);
var i,j,t :longint;
begin
  if a>=b then exit;
  i:=a; j :=b;
  while (i<j) do
    begin
      while cmp(i,j)and(i<j) do inc(i);
      if i>=j then break;
      t:=x[i]; x[i]:=x[j]; x[j]:=t;
      t:=y[i]; y[i]:=y[j]; y[j]:=t;
      inc(i);
      while cmp(i,j)and(i<j) do dec(j);
      if i>=j then break;
      t:=x[i]; x[i]:=x[j]; x[j]:=t;
      t:=y[i]; y[i]:=y[j]; y[j]:=t;
      dec(j);
    end;
  qsort (a,i-1);
  qsort (j+1,b);
end;}

    procedure qsort(l,r: longint); var i,j,t: longint;
      begin
         i:=l; j:=r;
         x[0]:=x[(l+r) div 2]; y[0]:=y[(l+r) div 2];
         repeat
           while cmp(i,0) do inc(i);
           while cmp(0,j) do dec(j);
           if not(i>j) then begin
              t:=x[i]; x[i]:=x[j]; x[j]:=t;
              t:=y[i]; y[i]:=y[j]; y[j]:=t;
              inc(i); dec(j);
           end;
         until i>j;
         if l<j then qsort(l,j);
         if i<r then qsort(i,r);
      end;


procedure convert;
begin
  k:=0;
  for i := 1 to n do
    for j := 1 to m do
      if img[i,j]='*' then
        begin inc(k); x[k]:=i; y[k]:=j; end;
  qsort(2,k);
//  debug;
  x[k+1]:=x[1]; y[k+1]:=y[1];
  x[0]:=x[k];   y[0]:=y[k];
end;

function pssk (i :longint) :longint;
begin
  pssk:=(x[i-1]-x[i])*(y[i]-y[i+1])-(x[i]-x[i+1])*(y[i-1]-y[i]);
end;

function nos (a,b :longint) :boolean;
begin
  nos := ((a>0)xor(b>0))and(b<>0);
end;

function check :boolean;
var s :longint;
begin
  convert;
  check := false;
  for i := 1 to k do
    if pssk(i)<>0 then
      begin s:=pssk(i); break; end;
//  writeln(x[i-1]:3,y[i-1]:3,x[i]:3,y[i]:3,x[i+1]:3,y[i+1]:3);
  for i := 1 to k do
    if nos(s,pssk(i)) then
      begin
//  writeln(x[i-1]:3,y[i-1]:3,x[i]:3,y[i]:3,x[i+1]:3,y[i+1]:3);
      exit; end;
  check:=true;
end;


var
  f1,f2 :text;
  c :char;

begin
  assign(f1,'X0.in'); assign(f2,'X0.out');
  reset(f1); rewrite(f2);
    repeat
      n:=0; m:=0;
      repeat
        inc(n); j:=0;
        while not eoln(f1) do
          begin inc(j); read(f1,c); img[n,j]:=c; end;
        readln(f1);
        if m=0 then m:=j;
      until c in ['-','#'];
      dec(n);
      if check then writeln (f2,'0') else writeln (f2,'X');
    until c='#';
  close(f1); close(f2);
end.
