var f1,f2 :text; label enddd;

var
  pol :array [1..100,1..100] of longint;
  ban :array [1..100,1..100,1..10] of longint;
  room,r2:array [1..101] of integer;
  home,h2:array [1..10000] of integer;
  door,d2:array [1..10000] of integer;
  reg,rr2:array [1..10000] of byte;

function police (p,b :integer; max :longint) :longint; forward;
function bandit (p,b :integer; k :byte; min :longint) :longint; forward;

function police (p,b :integer; max :longint) :longint;          {finding min}
var min,t,i :longint;
begin
  if pol[p,b]<>maxlongint then begin police:=pol[p,b]; exit; end;
  pol[p,b]:=0;
  if p=b then begin pol[p,b]:=-1; police:=-1; exit; end;
  if b=1 then begin pol[p,b]:= 1; police:= 1; exit; end;
  min:=1;
  for i := room[p] to room[p+1]-1 do
    begin
      t:=bandit(door[i],b,reg[i],min);
      if (t<=0) and(min>0) then min:=t;
      if (t<0)  and(min<t) then min:=t;
      if (min>0)and(min<t) then min:=t;
    end;
  police:=min;
  pol[p,b]:=min;
end;

function bandit (p,b :integer; k :byte; min :longint) :longint; {finding max}
var max,t,i :longint;
begin
  if ban[p,b,k]<>maxlongint then begin bandit:=ban[p,b,k]; exit; end;
  ban[p,b,k]:=0;
  if p=b then begin ban[p,b,k]:=-1; bandit:=-1; exit; end;
  if b=1 then begin ban[p,b,k]:= 1; bandit:= 1; exit; end;
  t:=police(p,b,-maxlongint);
  if t>0 then inc(t) else if t<0 then dec(t) else {noop};
  max:=t;
  for i := room[b] to room[b+1]-1 do
    begin
      if reg[i]<>k then continue;
      if door[i]=p then continue;
      if door[i]=1 then
        begin
          max:=1;
          break;
        end;
      t:=police(p,door[i],max);
      if t>0 then inc(t) else if t<0 then dec(t) else {noop};
      if (max<0)and(t>=0)  then max:=t;
      if (max<0)and(max>t) then max:=t;
      if (t>0)  and(max>t) then max:=t;
    end;
  bandit:=max;
  ban[p,b,k]:=max;
end;

var n,m,k,i,j,kk :longint;

begin
  assign(f1,'pursuit.in');
  assign(f2,'pursuit.out');
  reset(f1); rewrite (f2);
  read (f1,n,m,k);
  for i := 1 to m do
    read (f1,home[i],door[i],reg[i]);
  for i := m+1 to 2*m do
    begin
      home[i]:=door[i-m];
      door[i]:=home[i-m];
      reg [i]:=reg [i-m];
    end;
  for i := 1 to n do
    for j := 1 to n do
      for kk:= 1 to k do
        begin
          pol[i,j]:=maxlongint;
          ban[i,j,kk]:=maxlongint;
        end;
  for i := 1 to 2*m do
    inc(room[home[i]]);
  for i := 2 to n do
    room[i]:=room[i]+room[i-1];
  for i := n+1 downto 2 do
    room[i]:=room[i-1]+1;
  room[1]:=1;
  r2:=room;
  h2:=home;
  d2:=door;
  rr2:=reg;
  for i := 1 to 2*m do
    begin
      home[r2[h2[i]]]:=h2[i];
      door[r2[h2[i]]]:=d2[i];
      reg [r2[h2[i]]]:=rr2[i];
      inc(r2[h2[i]]);
    end;
  read(f1,i,j);
  k:=police(i,j,-maxlongint);
  if k=0 then writeln (f2,'Endless') else
  if k>0 then writeln (f2,'Escaped') else
  if k<0 then writeln (f2,'Caught' ) else
                                runerror(random(255));
  if k<>0 then writeln (f2,abs(k)) else writeln(f2);
  close(f1); close(f2);
end.
