{$N+} const max = 100000 {100'000};
type
  rc = record x1,x2,y1,y2,a,n,next :longint; v :extended; end;
var
  mas :array [1..max] of rc;
  n :longint;

    procedure sort(l,r: longint);
      var
         i,j: longint; x,y :rc;
      begin
         i:=l;
         j:=r;
         x:=mas[(l+r) div 2];
         repeat
           while mas[i].x2<x.x2 do
            inc(i);
           while x.x2<mas[j].x2 do
            dec(j);
           if not(i>j) then
             begin
                y:=mas[i];
                mas[i]:=mas[j];
                mas[j]:=y;
                inc(i);
                j:=j-1;
             end;
         until i>j;
         if l<j then
           sort(l,j);
         if i<r then
           sort(i,r);
      end;

procedure process_rect (k :longint);
var e :extended; i,x,y :longint;
begin
  if mas[k].v<>0 then exit;
  e:=0;
  x:=1; y:=n;  {[x..y]}
  while (x<y) do
    begin
      i := (x+y) div 2;
      if mas[k].x1<mas[i].x2 then y:=i else x:=i+1;
    end;
  if y>2 then dec(y,2) else y:=1;
  for i := y to n do
    if (mas[i].x2>mas[k].x1)and(mas[i].y2<mas[k].y1) then
      begin
        process_rect(i);
        if e<mas[i].v then begin e:=mas[i].v; mas[k].next:=i; end;
      end;
  mas[k].v:=e+mas[k].a;
end;

var
  f1,f2 :text;
  i,j :longint;


begin
  assign(f1,'rects.in');
  assign(f2,'rects.out');
  reset (f1); rewrite (f2);
    read (f1,n);
    for i := 1 to n do
      begin
        read(f1,mas[i].x2,mas[i].y1,mas[i].x1,mas[i].y2,mas[i].a);
        mas[i].n:=i;
      end;
    sort(1,n);
    j:=1;
    for i := 1 to n do
      begin
        process_rect(i);
        if mas[i].v>mas[j].v then j:=i;
      end;
    writeln (f2,mas[j].v:0:0);
    while j>0 do
      begin
        write (f2,mas[j].n,' ');
        j:=mas[j].next;
      end;
  close(f1); close(f2);
end.
