const max = 100;

var
  desk :array [0..max,0..max,0..max] of int64;
  k :longint;

procedure updsum (x,y,z :longint; a:int64);
begin
  desk[x,y,z]:=a
    +desk[x-1,y  ,z]+desk[x,y-1,z  ]+desk[x,  y,z-1]
    -desk[x-1,y-1,z]-desk[x,y-1,z-1]-desk[x-1,y,z-1]
    +desk[x-1,y-1,z-1];
end;

function getsum (x1,x2,y1,y2,z1,z2 :longint) :int64;
begin
  if x1<1 then x1:=1;
  if y1<1 then y1:=1;
  if z1<1 then z1:=1;
  updsum (x2,y2,z2, 0);
  getsum := desk[x2,y2,z2]
    -desk[x1-1,y2,  z2]-desk[x2,y1-1,z2  ]-desk[x2  ,y2,z1-1]
    +desk[x1-1,y1-1,z2]+desk[x2,y1-1,z1-1]+desk[x1-1,y2,z1-1]
    -desk[x1-1,y1-1,z1-1];
end;

function oper_count(X,Y,Z :longint; x1,y1,z1 :longint) :int64;
var i,j,l :longint; t,r,tt :int64;
begin
  oper_count:=-1; r:=0;
  for i := 1 to X do
  for j := 1 to Y do
  for l := 1 to Z do
    begin
      tt := desk[i,j,l];
      t:=(tt+getsum(i-x1+1,i,j-y1+1,j,l-z1+1,l)) mod k;
      updsum(i,j,l, (k-t) mod k);
//{$} writeln ('The cell #',i,':',j,':',l,' contains number ',t:10,
//             '(old is ',tt:9,'). Sum is ',desk[i,j,l]:10);
      if ((i+x1-1>X)or(j+y1-1>Y)or(l+z1-1>Z))and(t<>0) then exit;
      inc(r, (k-t) mod k);
    end;
  oper_count := r;
end;

var
  X,Y,Z :longint;
  x1,y1,z1 :longint;
  i,j,l :longint;
  d :longint;
  f1,f2 :text;

begin
  assign(f1,'virtual.in'); assign(f2,'virtual.out');
  reset(f1); rewrite(f2);
    read(f1,X,Y,Z); read(f1,x1,y1,z1); read(f1,k); inc(k);
    for l := 1 to Z do
    for j := 1 to Y do
    for i := 1 to X do
      begin
        read (f1,d);
        desk[i,j,l]:=d;
      end;
    writeln (f2,oper_count(
                          X,Y,Z,
                          x1,y1,z1
                          ));
  close(f1); close(f2);
end.
