  {$I-,Q-,R-,S-,N+}
const
  maxn = 100000;
var
  n,k :longint;
  a :array [1..maxn*2] of longint;
  r :ARRAY [1..maxn*2] of extended;
  eps {2PI/1000k}:extended;

    procedure sort(l,rr: longint);
      var i,j,t: longint; x,y :extended;
      begin
         i:=l; j:=rr; x:=r[(l+rr) div 2];
         repeat
           while r[i]<x do inc(i);
           while x<r[j] do dec(j);
           if not(i>j) then
             begin
               y:=r[i]; r[i]:=r[j]; r[j]:=y;
               t:=a[i]; a[i]:=a[j]; a[j]:=t;
               inc(i); j:=j-1;
             end;
         until i>j;
         if l<j  then sort(l,j);
         if i<rr then sort(i,rr);
      end;

const
  maxlong  :int64 = 1000000000;
var
  maxint64 :int64;
  dt :int64;

  procedure nspr (st :longint);
  var this,min,max :int64; i,num :longint; rot :extended;
    procedure step;
    begin
      while rot+2*Pi/k<r[i]-eps/10 do
        begin
          if this<min then min:=this;
          if this>max then max:=this;
          this:=0;
          inc(num);
          rot := r[st]-eps+2*Pi/k*num;
        end;
      this:=this+a[i];
      if max-min>=dt then i:=n+st;
    end;
  begin
    rot := r[st]-eps; num:=0;
    this:=0; min:=maxint64; max:=-maxint64;
    for i := st to n+st do step;
    if dt>max-min then dt:=max-min;
  end;

var i :longint;
  f1,f2:text;

begin
  maxint64:=maxlong*maxn*2;
  assign(f1,'necklace.in');
  assign(f2,'necklace.out');
  reset(f1); rewrite(f2);

    read(f1,n,k); eps:=2/Pi*1000;
    for i := 1 to n do
      read (f1,r[i],a[i]);
    sort(1,n);
    for i := 1 to n do
      a[i+n]:=a[i];
    for i := 1 to n do
      r[i+n]:=r[i]+2*Pi;
    dt:=maxint64*2;
    for i := 1 to n do
      nspr(i);
    writeln(f2,dt);

  close(f1); close(f2);
end.
