#include <cstdio>
#include <bitset>
#include <string>
#include <vector>

using namespace std;

vector<char> string_buf(32767);


typedef bitset<127> t_line;

int n_key_x,n_key_y,n_loc_x,n_loc_y,n_both_x,n_both_y,n_cells,x_best;
vector<t_line> key;
vector<char> mtrx_cont; vector<char*> mtrx;
vector<char> marks;

int main(void) {
  #ifndef OFFLINE
  freopen("key.in","rt",stdin);
  freopen("key.out","wt",stdout);
  #endif
  int x,y;
  scanf("%d%d",&n_key_x,&n_key_y);
  key.resize(n_key_x);
  for (x=0; x<n_key_x; ++x) {
    key[x].reset();
    scanf("%s",&string_buf.front());
    for (y=0; y<n_key_y; ++y) key[x][y]=(string_buf[y]=='#'?1:0);
  }
  scanf("%d%d",&n_loc_x,&n_loc_y);
  n_both_x=n_loc_x+n_key_x; n_both_y=n_loc_y-n_key_y+1;
  n_cells=n_both_x*n_loc_y;
  mtrx_cont.resize(n_cells); mtrx.resize(n_both_x);
  for (x=0,y=0; x<n_both_x; ++x,y+=n_loc_y) mtrx[x]=&mtrx_cont[y];
  for (x=0; x<n_loc_x; ++x) {
    scanf("%s",&string_buf.front());
    for (y=0; y<n_loc_y; ++y) mtrx[x][y]=(string_buf[y]=='#'?1:0);
  }
  int i_line,height,width; t_line line;
  width=n_key_y-1;
  for (--(height=n_key_x),i_line=0; i_line<n_key_x; --height,++i_line)
   for (x=0; x<n_loc_x; ++x) {
    line.reset();
    for (y=0; y<width&&y<n_loc_y; ++y) line[y]=(mtrx[x][y]&1?1:0);
    for (; y<n_loc_y; ++y) {
      line[width]=(mtrx[x][y]&1?1:0);
      if (!(mtrx[x+height][y-width]&2)) if ((key[i_line]&line).any())
        mtrx[x+height][y-width]|=2;
      line>>=1;
    }
  }
  #ifdef DEBUG
  for (x=0; x<n_both_x; ++x) {
    for (y=0; y<n_both_y; ++y) printf("%c",mtrx[x][y]&2?'.':'*');
    printf("\n");
  } printf("\n");
  #endif
  marks.resize(n_both_y,1);
  for (x=0; x<n_both_x; ++x) {
    for (y=0; y<n_both_y; ++y) if (mtrx[x][y]&2) marks[y]=0;
    for (y=1; y<n_both_y; ++y) if (marks[y-1]&&!marks[y])
      if (!(mtrx[x][y]&2)) marks[y]=1;
    for (--y; y>0; --y) if (marks[y]&&!marks[y-1])
      if (!(mtrx[x][y-1]&2)) marks[y-1]=1;
    #ifdef DEBUG
    for (y=0; y<n_both_y; ++y) printf("%c",marks[y]?'+':'.');
    printf("\n");
    #endif
    for (y=0; y<n_both_y; ++y) if (marks[y]) break;
    if (y>=n_both_y) break;
  } x_best=x;
    #ifdef DEBUG
    printf("\n");
    #endif
  if (x_best<n_both_x) printf("%d\n",x_best);
  else printf("-1\n");
  #ifndef OFFLINE
  fclose(stdin);
  fclose(stdout);
  #endif
  return(0);
}


