#include <cstdio>
#include <vector>

using namespace std;


long mod_num,mod_deg;
vector<long> pwrs_cont; vector<long*> pwrs;
int n_nums;
vector<long> nums;
vector<int> cs_nums; vector<int> cs_degs;
vector<int> cs_numdegs_cont; vector<int*> cs_numdegs;
long long c_triples;

int main(void) {
  #ifndef OFFLINE
  freopen("triples.in","rt",stdin);
  freopen("triples.out","wt",stdout);
  #endif
  int i_num; long num,buf,acc,deg,pwr;
  scanf("%d%ld",&n_nums,&mod_num);
  mod_deg=1; buf=mod_num;
  for (num=2; num<=buf; ++num) if (!(buf%num)) {
    for (acc=1,buf/=num; !(buf%num); acc*=num,buf/=num);
    mod_deg*=acc*(num-1);
  }
  #ifdef DEBUG
  printf("%ld %ld\n",mod_num,mod_deg);
  #endif
  pwrs_cont.resize((mod_deg+1)*mod_num); pwrs.resize(mod_deg+1);
  for (deg=0,num=0; deg<=mod_deg; ++deg,num+=mod_num)
    pwrs[deg]=&pwrs_cont[num];
  for (num=0; num<mod_num; ++num) pwrs[0][num]=1%mod_num;
  for (deg=1; deg<=mod_deg; ++deg) for (num=0; num<mod_num; ++num)
    pwrs[deg][num]=(pwrs[deg-1][num]*num)%mod_num;
  #ifdef DEBUG
  for (deg=0; deg<=mod_deg; ++deg) {
    for (num=0; num<mod_num; ++num) {
      if (num) printf(" ");
      printf("%ld",pwrs[deg][num]);
    } printf("\n");
  }
  #endif
  nums.resize(n_nums);
  for (i_num=0; i_num<n_nums; ++i_num) scanf("%ld",&nums[i_num]);
  cs_nums.resize(mod_num); cs_degs.resize(mod_deg+1);  
  cs_numdegs_cont.resize((mod_deg+1)*mod_num); cs_numdegs.resize(mod_deg+1);
  for (deg=0,num=0; deg<=mod_deg; ++deg,num+=mod_num)
    cs_numdegs[deg]=&cs_numdegs_cont[num];
  for (i_num=0; i_num<n_nums; ++i_num) {
    num=nums[i_num]%mod_num;
    deg=nums[i_num]>0?(nums[i_num]-1)%mod_deg+1:0;
    ++cs_nums[num]; ++cs_degs[deg]; ++cs_numdegs[deg][num];
  }
  long long c_degs,c_nums_0,c_nums_1,c_numdegs_0,c_numdegs_1;
  c_triples=0;
  for (deg=0; deg<=mod_deg; ++deg) for (num=0; num<mod_num; ++num) {
    pwr=pwrs[deg][num];
    c_degs=static_cast<long long>(cs_degs[deg]);
    c_nums_0=static_cast<long long>(cs_nums[num]);
    c_nums_1=static_cast<long long>(cs_nums[pwr]);
    c_numdegs_0=static_cast<long long>(cs_numdegs[deg][num]);
    c_numdegs_1=static_cast<long long>(cs_numdegs[deg][pwr]);
    if (!c_degs||!c_nums_0||!c_nums_1) continue;
    if (pwr!=num) {
      c_triples+=c_degs*c_nums_0*c_nums_1
                -c_numdegs_0*c_nums_1-c_numdegs_1*c_nums_0;
    } else {
      c_triples+=c_degs*c_nums_0*c_nums_1-c_degs*c_nums_0
                -c_numdegs_0*c_nums_1-c_numdegs_1*c_nums_0
                +c_numdegs_0+c_numdegs_1;
    }
  }
  printf("%lld\n",c_triples);
  #ifndef OFFLINE
  fclose(stdin);
  fclose(stdout);
  #endif
  return(0);
}


