program afadsfasd;
type
    coord=array[-1..1010] of longint;
const
    dx:array[1..8] of longint = (1,1,1,0,-1,-1,-1,0);
    dy:array[1..8] of longint =(-1,0,1,1,1,0,-1,-1);
    Maxn=1010;
    maxq=5000000;
var xs,ys,xt,yt,n,h,w:longint;
    x1,y1,ind,x,y,yy,xx:coord;
    a:array[-1..maxn,-1..maxn] of longint;
    qx,qy,qdx,qdy:array[1..maxq] of integer;

procedure qsort(l,r:longint; var a,b,c:coord);
var i,j,x,t:longint;
begin
    i:=l;
    j:=r;
    x:=a[l+random(r-l+1)];
    while i<j do begin
        while a[i]<x do inc(i);
        while a[j]>x do dec(j);
        if i<=j then begin
            t:=a[i];a[i]:=a[j];a[j]:=t;
            t:=b[i];b[i]:=b[j];b[j]:=t;
            t:=c[i];c[i]:=c[j];c[j]:=t;
            inc(i);dec(j);
        end;
    end;
    if i<r then qsort(i,r,a,b,c);
    if l<j then qsort(l,j,a,b,c);
end;

procedure load;
var i,j:longint;
begin
    read(xs,ys,xt,yt,n);
    for i:= 1 to n do read(x[i],y[i]);
    x[n+1]:=xs;
    x[n+2]:=xt;
    y[n+1]:=ys;
    y[n+2]:=yt;
    for i:= 1 to n+2 do ind[i]:=i;
    qsort(1,n+2,x,y,ind);
    j:=1;
    for i:= 1 to n+2 do begin
        h:=j;
        x1[ind[i]]:=j;
        xx[j]:=x[i];
        if x[i]<x[i+1] then inc(j);
    end;
    qsort(1,n+2,y,x,ind);
    j:=1;
    for i:= 1 to n+2 do begin
        w:=j;
        y1[ind[i]]:=j;
        yy[j]:=y[i];
        if y[i]<y[i+1] then inc(j);
    end;
    fillchar(a,sizeof(a),127);
    for i:= 1 to n do
        a[x1[i],y1[i]]:=-1;
    inc(w);
    inc(h);
    xx[h]:=xx[h-1]+1;
    yy[w]:=yy[w-1]+1;
    xx[0]:=xx[1]-1;
    yy[0]:=yy[1]-1;
    xs:=x1[n+1];
    ys:=y1[n+1];
    xt:=x1[n+2];
    yt:=y1[n+2];
end;

function max(a,b:longint):longint;
begin
    if a>b then max:=a
    else max:=b;
end;

procedure solve;
var be,en,i,s,j,t,p,q:longint;
begin
    be:=1;
    en:=1;
    a[xs,ys]:=0;
    qx[1]:=xs;
    qy[1]:=ys;
    qdx[1]:=0;qdy[1]:=0;
    while be<=en do begin
        i:=qx[be];
        j:=qy[be];
        if(i<h)and( qdx[be]>=abs(xx[i+1]-xx[i]) )and (a[i,j]<a[i+1,j])then begin
                a[i+1,j]:=a[i,j];
                inc(en);
                qx[en]:=i+1;qy[en]:=j;
                qdx[en]:=qdx[be]-abs(xx[i+1]-xx[i]);
                qdy[en]:=qdy[be];
        end;
        if(i>0) and( qdx[be]>=abs(xx[i-1]-xx[i]) )and (a[i,j]<a[i-1,j])then begin
                a[i-1,j]:=a[i,j];
                inc(en);
                qx[en]:=i-1;qy[en]:=j;
                qdx[en]:=qdx[be]-abs(xx[i-1]-xx[i]);
                qdy[en]:=qdy[be];
        end;
        if (j<w)and( qdy[be]>=abs(yy[j+1]-yy[j]) )and (a[i,j]<a[i,j+1])then begin
                a[i,j+1]:=a[i,j];
                inc(en);
                qx[en]:=i;qy[en]:=j+1;
                qdx[en]:=qdx[be];
                qdy[en]:=qdy[be]-abs(yy[j+1]-yy[j]);
        end;
        if(j>0)and( qdy[be]>=abs(yy[j-1]-yy[j]) )and (a[i,j]<a[i,j-1])then begin
                a[i,j-1]:=a[i,j];
                inc(en);
                qx[en]:=i;qy[en]:=j-1;
                qdx[en]:=qdx[be];
                qdy[en]:=qdy[be]-abs(yy[j-1]-yy[j]);
        end;
        inc(be);
        for t:= 1 to 8 do begin
            p:=i+dx[t];
            q:=j+dy[t];
            if (p<0)or(q<0)or(p>h)or(q>w) then begin
                continue;
            end;
            s:=a[i,j]+max(abs(xx[p]-xx[i]),abs(yy[q]-yy[j]));
            if s<a[p,q] then begin
                a[p,q]:=s;
                inc(en);
                qx[en]:=p;qy[en]:=q;
//                if t mod 2 =1 then begin
                    qdx[en]:=s-abs(xx[p]-xx[i])-a[i,j];
                    qdy[en]:=s-abs(yy[q]-yy[j])-a[i,j];
//                end;
            end;
        end;
    end;
    write(a[xt,yt]);
end;

procedure save;
begin

end;

begin
    assign(input,'king.in');
    assign(output,'king.out');
    reset(input);
    rewrite(output);
    load;
    solve;
    save;
    close(output);
    close(input);
end.