{$Q+,R+,S+}

program fasfsa;
uses guess;
const maxot=10;
type yrav=record
        n,s,x:longint;
        r,c:array[0..maxot] of longint;
     end;

var n,k,q,cq:longint;
    a:array[1..200000] of yrav;
    x,wx:array[1..200000] of longint;

function inv(a:longint):longint;
var x,y,d:longint;

function extgcd(a,b:longint):longint;
var x1,y1:longint;
begin
    if a=0 then begin
        extgcd:=b;
        x:=0;y:=1;
    end else begin
    extgcd:=extgcd(b mod a,a);
        x1:=y-x*(b div a);
        y1:=x;
        x:=x1;
        y:=y1;
    end;
end;

begin
    d:=extgcd(a,k);
    if d>1 then begin
        inv:=-1;
    end else begin
      while x<0 do x:=x+k;
      inv:=x;
    end;
end;


procedure deceq(x,y,koef:longint);
var i,j,l:longint;
begin
  a[x].s:=(a[x].s-a[y].s*koef+k*k) mod k;
  for i:= 1 to a[y].n do begin
    if a[y].c[i]=0 then continue;
    j:=1;
    while j<=a[x].n do begin
      if (a[x].r[j-1]+1>=a[y].r[i-1]+1)and(a[x].r[j]<=a[y].r[i]) then begin
        a[x].c[j]:=(a[x].c[j]-a[y].c[i]*koef+k*k) mod k;
        inc(j);
      end else begin
        if (a[x].r[j-1]+1<a[y].r[i-1]+1)and(a[x].r[j]>=a[y].r[i-1]+1) then begin
          for l:= a[x].n+1 downto j+2 do begin
            a[x].r[l]:=a[x].r[l-1];
            a[x].c[l]:=a[x].c[l-1];
          end;
          inc(a[x].n);
          a[x].r[j+1]:=a[x].r[j];
          a[x].c[j+1]:=a[x].c[j];
          a[x].r[j]:=a[y].r[i-1];
          inc(j);
        end else if (a[y].r[i]<a[x].r[j])and(a[y].r[i]>=a[x].r[j-1]+1) then begin
          for l:= a[x].n+1 downto j+2 do begin
            a[x].r[l]:=a[x].r[l-1];
            a[x].c[l]:=a[x].c[l-1];
          end;
          inc(a[x].n);
          a[x].r[j+1]:=a[x].r[j];
          a[x].c[j+1]:=a[x].c[j];
          a[x].c[j]:=(a[x].c[j]-a[y].c[i]*koef+k*k)mod k;
          a[x].r[j]:=a[y].r[i];
          inc(j);
        end else inc(j);
      end;
    end;
  end;
end;


procedure gauss;
var i,j,h,g,cur:longint;
begin
  for i:= 1 to cq-1 do begin
      for j:= 1 to a[cq].n do
        if (a[cq].r[j-1]+1<=a[i].x)and(a[i].x<=a[cq].r[j])and(a[cq].c[j]>0) then begin
            deceq(cq,i,1);
            break;
        end;
      j:=1;
  while j< a[cq].n do begin
    if a[cq].c[j]=a[cq].c[j+1] then begin
        for h:= j to a[cq].n-1 do begin
            a[cq].r[h]:=a[cq].r[h+1];
            a[cq].c[h]:=a[cq].c[h+1];
        end;
        dec(a[cq].n);
    end;
    inc(j);
  end;
  end;
  for i:=1 to a[cq].n do begin
    if a[cq].c[i]>0 then begin
      h:=inv(a[cq].c[i]);
      if h<0 then continue;
      for j:= a[cq].r[i-1]+1 to a[cq].r[i] do begin
        if wx[j]=0 then begin
          a[cq].x:=j;
          wx[j]:=cq;
          for g:= 1 to a[cq].n do begin
            a[cq].c[g]:=(a[cq].c[g]*h)mod k;
          end;
          a[cq].s:=(a[cq].s*h)mod k;
          break;
        end;
      end;
      if a[cq].x>0 then begin
        break;
      end;
    end;
  end;
  if (a[cq].n=1)and(a[cq].c[1]=0)and(a[cq].s=0) then begin
    dec(cq);
    dec(q);
    exit;
  end;
  if (a[cq].x=0)and ((a[cq].n>1)or(a[cq].c[1]>0)) then error(n,x);
  for i:= 1 to cq-1 do begin
    for j:= 1 to a[i].n do begin
        if (a[i].r[j-1]+1<=a[cq].x)and(a[cq].x<=a[i].r[j])and(a[i].c[j]>0)then begin
            deceq(i,cq,a[i].c[j]);
        end;
    end;
  end;
end;



procedure solve;
var l,r,s,j:longint;
begin
    fillchar(x,sizeof(x),0);
    cq:=1;
    while cq<=q do begin
        NextQuery(l,r,s);
        a[cq].n:=1;
        if l>1 then begin
          a[cq].c[1]:=0;
          a[cq].r[1]:=l-1;
          inc(a[cq].n);
        end;
        a[cq].s:=s;
        a[cq].c[a[cq].n]:=1;
        a[cq].r[a[cq].n]:=r;
        if r<n then begin
          inc(a[cq].n);
          a[cq].c[a[cq].n]:=0;
          a[cq].r[a[cq].n]:=n;
        end;
        gauss;
        fillchar(x,sizeof(x),0);
        for j:= 1 to cq do
            x[a[j].x]:=a[j].s;
        inc(cq);
    end;
    Consistent(n,x);
end;

begin
    initialize(n,k,q);
    solve;
end.
