#include <stdio.h>
#include <string.h>

#define m 210

typedef struct
{
  int i[m], il, t[m], tl, p[m], pl;
} num;
typedef struct
{
  int n[m], d[m];
} rat;

char buf[m];
num a, b, c;
rat ar, br, cr;
int zero[m], t[m], dig[m];

void read( num *a )
{
  int i;

  memset(a, 0, sizeof(a));
  scanf("%s", buf);
  for (i = 0; buf[i] != 0 && buf[i] != '.'; i++)
    ;
  a->il = i;
  if (buf[i] != 0)
  {
    for (i++; buf[i] != 0 && buf[i] != '('; i++)
      ;
    a->tl = i - a->il - 1;
    if (buf[i] != 0)
    {
      for (i++; buf[i] != 0 && buf[i] != ')'; i++)
        ;
      a->pl = i - a->il - a->tl - 2;
    }
  }
  for (i = 0; i < a->il; i++)
    a->i[a->il - i - 1] = buf[i] - '0';
  for (i = 0; i < a->tl; i++)
    a->t[a->tl - i - 1] = buf[i + a->il + 1] - '0';
  for (i = 0; i < a->pl; i++)
    a->p[a->pl - i - 1] = buf[i + a->il + a->tl + 2] - '0';
}

void div( int *c, int *a, int *b )
{
  int i, j, la, lb;

  for (i = m - 1; i >= 0 && a[i] == 0; i--)
    ;
  la = i + 1;
  for (i = m - 1; i >= 0 && b[i] == 0; i--)
    ;
  lb = i + 1;
  memset(c, 0, sizeof(int) * m);
  for (i = la - lb; i >= 0; i--)
    while (1)
    {
      for (j = la - i; j >= 0; j--)
        if (a[i + j] != b[j])
          break;
      if (j >= 0 && a[i + j] < b[j])
        break;
      c[i]++;
      for (j = 0; j < lb; j++)
        a[i + j] -= b[j];
      for (j = 0; j < lb; j++)
        while (a[i + j] < 0)
          a[i + j + 1]--, a[i + j] += 10;
    }
}

void torat( rat *r, num *a )
{
  int k, l, i;

  memset(r, 0, sizeof(rat));
  k = a->tl, l = a->pl;
  if (l != 0)
  {
    for (i = 0; i < a->il; i++)
      r->n[i + a->tl + l] = a->i[i];
    for (i = 0; i < a->tl; i++)
      r->n[i + l] = a->t[i];
    for (i = 0; i < a->il; i++)
      r->n[i + a->tl] -= a->i[i];
    for (i = 0; i < a->tl; i++)
      r->n[i] -= a->t[i];
    for (i = 0; i < a->pl; i++)
      r->n[i] += a->p[i];
    for (i = 0; i < m; i++)
      r->n[i + 1] += r->n[i] / 10, r->n[i] %= 10;
    for (i = 0; i < l; i++)
      r->d[i + k] = 9;
  }
  else
  {
    for (i = 0; i < a->tl; i++)
      r->n[i] = a->t[i];
    for (i = 0; i < a->il; i++)
      r->n[i + a->tl] = a->i[i];
    r->d[k] = 1;
  }
}

void ratdiv( rat *c, rat *a, rat *b )
{
  int i, j;

  memset(c, 0, sizeof(rat));
  for (i = 0; i < m; i++)
    for (j = 0; i + j < m; j++)
      c->n[i + j] += a->n[i] * b->d[j];
  for (i = 0; i < m; i++)
    for (j = 0; i + j < m; j++)
      c->d[i + j] += a->d[i] * b->n[j];
  for (i = 0; i < m; i++)
    c->n[i + 1] += c->n[i] / 10, c->n[i] %= 10;
  for (i = 0; i < m; i++)
    c->d[i + 1] += c->d[i] / 10, c->d[i] %= 10;
}

void print( int *a )
{
  int i;

  for (i = m - 1; i >= 0 && a[i] == 0; i--)
    ;
  if (i < 0)
    i++;
  for (; i >= 0; i--)
    printf("%d", a[i]);
}

void print2( int *a )
{
  int i, j;

  for (i = m - 1; i >= 0 && a[i] == 0; i--)
    ;
  for (j = 0; j <= i; j++)
    printf("%d", a[j]);
}

int cmp( int *a, int *b )
{
  int i;

  for (i = m - 1; i >= 0; i--)
    if (a[i] != b[i])
      return a[i] - b[i];
  return 0;
}

int main( void )
{
  int i, j, k, l;

  freopen("divide.in", "rt", stdin);
  freopen("divide.out", "wt", stdout);
  read(&a), read(&b);
  torat(&ar, &a), torat(&br, &b);
  ratdiv(&cr, &ar, &br);
  div(c.i, cr.n, cr.d);
  print(c.i);
  memset(zero, 0, sizeof(zero));
  if (!cmp(cr.n, zero))
    return 0;
  memset(dig, 0, sizeof(dig));
  for (i = 0; i < 70; i++)
  {
    for (j = m - 1; j > 0; j--)
      cr.n[j] = cr.n[j - 1];
    cr.n[0] = 0;
    div(t, cr.n, cr.d);
    dig[i] = t[0];
    if (!cmp(cr.n, zero))
    {
      printf(".");
      print2(dig);
      return 0;
    }
  }
  for (i = 0; i < 70; i++)
  {
    for (j = 1; j < 70 - i; j++)
    {
      for (k = 1; i + k * j < 70; k++)
      {
        for (l = 0; l < j; l++)
          if (dig[i + l] != dig[i + k * j + l])
            break;
        if (l != j)
          break;
      }
      if (i + k * j >= 70)
        break;
    }
    if (j < 70 - i)
    {
      printf(".");
      for (k = 0; k < i; k++)
        printf("%d", dig[k]);
      printf("(");
      for (k = 0; k < j; k++)
        printf("%d", dig[i + k]);
      printf(")");
      return 0;
    }
  }
  return 0;
}
