#include <stdio.h>
#include <string.h>

#define m 1510
#define inf (int)1e9
#define min(a, b) ((a) < (b) ? (a) : (b))
#define max(a, b) ((a) > (b) ? (a) : (b))

int n, a[m][m], u[m], p[m], fi[m], la[m];

void sort( int *a, int l, int r )
{
  int i, j, x, t;

  if (l >= r)
    return;
  i = l, j = r;
  x = p[l + (rand() % (r - l + 1))];
  while (i <= j)
  {
    while (a[p[i]] < a[x])
      i++;
    while (a[p[j]] > a[x])
      j--;
    if (i <= j)
    {
      t = p[i], p[i] = p[j], p[j] = t;
      i++, j--;
    }
  }
  sort(a, l, j);
  sort(a, i, r);
}

int main( void )
{
  int i, j, k, t;

  freopen("chat.in", "rt", stdin);
  freopen("chat.out", "wt", stdout);
  while (scanf("%d", &n) == 1 && n != 0)
  {
    for (i = 0; i < n; i++)
      for (j = 0; j < n; j++)
        scanf("%d", &a[j][i]);
    for (i = 0; i < n; i++)
      fi[i] = 0, la[i] = n;
    for (i = 0; i < n; i++)
      for (j = 0; j < n; j++)
        if (a[i][j] > a[i][i])
          a[i][i] = a[i][j];
    for (i = 0; i < n; i++)
    {
      for (j = 0; j < n; j++)
        p[j] = j;
      sort(a[i], 0, n - 1);
      for (j = 0; j < n; j = t)
      {
        for (t = j; t < n && a[i][p[t]] == a[i][p[j]]; t++)
          ;
        for (k = j; k < t; k++)
          if (p[k] != i)
          {
            fi[p[k]] = max(fi[p[k]], j);
            la[p[k]] = min(la[p[k]], t - 1);
          }
      }
    }
    for (i = 0; i < n; i++)
      if (fi[i] > la[i])
        break;
    if (i == n)
    {
      memset(u, 0, sizeof(u));
      for (i = 0; i < n; i++)
      {
        for (j = fi[i]; j <= la[i]; j++)
          if (!u[j])
            break;
        if (j > la[i])
          break;
        u[j] = 1, p[i] = j;
      }
      if (i < n)
        printf("-1");
      else
      {
        for (i = 0; i < n; i++)
          printf("%d ", p[i] + 1);
      }
    }
    else
      printf("-1");
    printf("\n");
  }
  return 0;
}
