#include <stdio.h>
#include <stdlib.h>

#define m 50010
#define eps 1e-8
#define eps2 1e-6

int n, k, ni, is[m];
double x[m], y[m], s, mi, ma, ix[m];

void sort( int l, int r )
{
  int i, j, tt;
  double x, t;

  if (l >= r)
    return;
  i = l, j = r;
  x = ix[l + (rand() % (r - l + 1))];
  while (i <= j)
  {
    while (ix[i] < x - eps)
      i++;
    while (ix[j] > x + eps)
      j--;
    if (i <= j)
    {
      t = ix[i], ix[i] = ix[j], ix[j] = t;
      tt = is[i], is[i] = is[j], is[j] = tt;
      i++, j--;
    }
  }
  sort(l, j), sort(i, r);
}

double getsq( double yy )
{
  int i, j;
  double s;

  for (i = ni = 0; i < n; i++)
    if (y[i] < yy - eps && yy + eps < y[i + 1])
      is[ni] = i, ix[ni++] = x[i + 1] - (x[i + 1] - x[i]) * (y[i + 1] - yy) / (y[i + 1] - y[i]);
    else if (y[i + 1] < yy - eps && yy + eps < y[i])
      is[ni] = i, ix[ni++] = x[i + 1] - (x[i + 1] - x[i]) * (y[i + 1] - yy) / (y[i + 1] - y[i]);
  sort(0, ni - 1);
  for (i = 0, s = 0; i < ni; i += 2)
  {
    s += (yy + y[is[i] + 1]) * (x[is[i] + 1] - ix[i]);
    for (j = (is[i] + 1) % n; j != is[i + 1]; j = (j + 1) % n)
      s += (y[j] + y[j + 1]) * (x[j + 1] - x[j]);
    s += (y[is[i + 1] + 1] + yy) * (ix[i + 1] - x[is[i + 1] + 1]);
    s += 2 * yy * (ix[i] - ix[i + 1]);
  }
  return s;
}

int main( void )
{
  int i, j;
  double l, r, ss;

  srand(301703);
  freopen("antiufo.in", "rt", stdin);
  freopen("antiufo.out", "wt", stdout);
  scanf("%d%d", &n, &k);
  for (i = 0; i < n; i++)
    scanf("%lf%lf", &x[i], &y[i]);
  x[n] = x[0], y[n] = y[0];
  for (s = 0, i = 0; i < n; i++)
    s += y[i] * x[i + 1] - y[i + 1] * x[i];
  for (mi = ma = y[0], i = 1; i < n; i++)
    if (y[i] < mi)
      mi = y[i];
    else if (y[i] > ma)
      ma = y[i];
  for (i = 1; i <= k; i++)
  {
    l = mi, r = ma;
    while (fabs(l - r) > eps2)
    {
      ss = getsq((l + r) * .5);
      if (ss > s / (k + 1) * (k - i + 1))
        l = (l + r) * .5;
      else
        r = (l + r) * .5;
    }
    printf("%.4lf\n", l);
    mi = l;
  }
  return 0;
}
