#include <stdio.h>
#include <string.h>

#define m 82
#define mm (9 * m)

int is[m][m][mm], u[m][m][mm], n, di[m][m], nu[m][m], su[m][m];
char s[m];

int get( int l, int r, int a )
{
  int i, j;

  if (l > r)
    return 0;
  if (a > mm / 2 || a < -mm / 2 || di[l][r] != nu[l][r] - 1)
    return 0;
  if (l == r)
    return s[l] - '0' == a;
  if (u[l][r][a + mm / 2])
    return is[l][r][a + mm / 2];
  u[l][r][a] = 1;
  if (r - l == 2)
  {
    is[l][r][a] = 0;
    if (s[l] == '+')
      is[l][r][a] = a == s[l + 1] + s[l + 2] - '0' - '0';
    else if (s[r] == '+')
      is[l][r][a] = a == s[l] + s[l + 1] - '0' - '0';
    else if (s[l] == '-')
      is[l][r][a] = a == s[l + 1] - s[l + 2];
    else if (s[r] == '-')
      is[l][r][a] = a == s[l] - s[l + 1];
    else if (s[l + 1] == '+')
      is[l][r][a] = a == s[l] + s[r] - '0' - '0';
    else if (s[l + 1] == '-')
      is[l][r][a] = a == s[l] - s[r];
    return is[l][r][a];
  }
  if (s[l] == '+')
  {
    for (i = l + 1; i < r; i++)
      for (j = -su[l + 1][i]; j <= su[l + 1][i]; j++)
        if (get(l + 1, i, j) && get(i + 1, r, a - j))
        {
          is[l][r][a] = 1;
          return 1;
        }
  }
  else if (s[l] == '-')
  {
    for (i = l + 1; i < r; i++)
      for (j = -su[l + 1][i]; j <= su[l + 1][i]; j++)
        if (get(l + 1, i, j) && get(i + 1, r, j - a))
        {
          is[l][r][a] = 1;
          return 1;
        }
  }
  if (s[r] == '+')
  {
    for (i = l; i < r - 1; i++)
      for (j = -su[l][i]; j <= su[l][i]; j++)
        if (get(l, i, j) && get(i + 1, r - 1, a - j))
        {
          is[l][r][a] = 1;
          return 1;
        }
  }
  else if (s[r] == '-')
  {
    for (i = l; i < r - 1; i++)
      for (j = -su[l][i]; j <= su[l][i]; j++)
        if (get(l, i, j) && get(i + 1, r - 1, j - a))
        {
          is[l][r][a] = 1;
          return 1;
        }
  }
  for (i = l + 1; i < r; i++)
    if (s[i] == '+')
    {
      for (j = -su[l][i - 1]; j <= su[l][i - 1]; j++)
        if (get(l, i - 1, j) && get(i + 1, r, a - j))
        {
          is[l][r][a] = 1;
          return 1;
        }
    }
    else if (s[i] == '-')
      for (j = -su[l][i - 1]; j <= su[l][i - 1]; j++)
        if (get(l, i - 1, j) && get(i + 1, r, j - a))
        {
          is[l][r][a] = 1;
          return 1;
        }
  is[l][r][a] = 0;
  return 0;
}

void pr( void )
{
  int i, j;

  memset(di, 0, sizeof(di));
  for (i = 0; i < n; i++)
    di[i][i] = s[i] == '+' || s[i] == '-';
  for (i = 0; i < n; i++)
    for (j = i + 1; j < n; j++)
      di[i][j] = di[i][j - 1] + (s[j] == '+' || s[j] == '-');
  for (i = 0; i < n; i++)
    for (j = i; j < n; j++)
      nu[i][j] = j - i + 1 - di[i][j];
  for (i = 0; i < n; i++)
    su[i][i] = ('0' <= s[i] && s[i] <= '9') ? s[i] - '0' : 0;
  for (i = 0; i < n; i++)
    for (j = i + 1; j < n; j++)
      su[i][j] = su[i][j - 1] + (('0' <= s[j] && s[j] <= '9') ? s[j] - '0' : 0);
}

int main( void )
{
  int i, a;

  freopen("expr.in", "rt", stdin);
  freopen("expr.out", "wt", stdout);
  scanf("%s", s);
  n = strlen(s);
  memset(u, 0, sizeof(u));
  pr();
  for (i = -su[0][n - 1], a = 0; i <= su[0][n - 1]; i++)
    a += get(0, n - 1, i);
  printf("%d", a);
  return 0;
}
