#include <stdio.h>
#include <math.h>
#include <stdlib.h>

#define m 10010
#define mm 100010
#define eps 1e-10
#define pi 3.14159265358979323846
#define inf (long long)1e18

int n, k;
long long a[m], s[m];
long double aa[mm];

void sort( int l, int r )
{
  int i, j;
  long double x, t;
  long long tt;

  if (l >= r)
    return;
  i = l, j = r, x = aa[l + (rand() % (r - l + 1))];
  while (i <= j)
  {
    while (aa[i] < x - eps)
      i++;
    while (aa[j] > x + eps)
      j--;
    if (i <= j)
    {
      t = aa[i], aa[i] = aa[j], aa[j] = t;
      tt = a[i], a[i] = a[j], a[j] = tt;
      i++, j--;
    }
  }
  sort(l, j);
  sort(i, r);
}

int find( double a )
{
  int l, r, i;

  l = 0, r = n - 1;
  while (l < r)
  {
    i = (l + r) / 2;
    if (a > aa[i])
      l = i + 1;
    else
      r = i;
  }
  return l;
}

long long get( int l, int r )
{
  if (l <= r)
  {
    if (l == 0)
      return s[r];
    return s[r] - s[l - 1];
  }
  return s[n - 1] - s[l] + s[r];
}

int main( void )
{
  int i, j, l, t, pr;
  long long mi, ma, be;

  srand(301703);
  freopen("necklace.in", "rt", stdin);
  freopen("necklace.out", "wt", stdout);
  scanf("%d%d", &n, &k);
  for (i = 0; i < n; i++)
    scanf("%Lf%Ld", &aa[i], &a[i]);
  sort(0, n - 1);
  for (i = 1, s[0] = a[0]; i < n; i++)
    s[i] = s[i - 1] + a[i];
  be = inf;
  for (i = 0; i < n; i++)
  {
    mi = inf, ma = -inf;
    if (aa[i] + 2 * pi / k * (k - 1) > aa[(i - 1 + n) % n])
      t = 0;
    else
    {
      l = find(fmod(aa[i] + 2 * pi / k * (k - 1), 2 * pi));
      if ((i - 1 + n) % n < l)
        t = 0;
      else
        t = get(l % n, (i - 1 + n) % n);
    }
    if (t > ma)
      ma = t;
    if (t < mi)
      mi = t;
    pr = i;
    for (j = 1; j < k; j++)
    {
      l = find(fmod(aa[i] + 2 * pi / k * j, 2 * pi));
      if (aa[l] > fmod(aa[i] + 2 * pi / k * j, 2 * pi))
        t = 0, pr = l;
      else
        t = get(pr, l), pr = l;
      if (t > ma)
        ma = t;
      if (t < mi)
        mi = t;
    }
    if (ma - mi < be)
      be = ma - mi;
  }
  printf("%Ld", be);
  return 0;
}
