{$M 10000000,0}
{$I-,Q-,R-,S-}
const infinity=maxlongint shr 1;
type tseg=record
       x,y1,y2,r,t:longint;
     end;
var n,ns,ny,i,x1,y1,x2,y2,t,anc,nc:longint;
    w,last,ch:array [1..110000] of longint;
    ans:array [0..110000] of int64;
    seg:array [1..220000] of tseg;
    yy,best:array [0..220000] of longint;
procedure swap(var a,b:longint);
var t:longint;
begin
  t:=a;
  a:=b;
  b:=t;
end;
procedure addseg(x,y1,y2,r,t:longint);
begin
  inc(ns);
  seg[ns].x:=x;
  seg[ns].y1:=y1;
  seg[ns].y2:=y2;
  seg[ns].r:=r;
  seg[ns].t:=t;
end;
procedure addy(y:longint);
begin
  inc(ny);
  yy[ny]:=y;
end;
function lseg(a,b:tseg):boolean;
begin
  lseg:=(a.x<b.x) or (a.x=b.x) and (a.t<b.t);
end;
procedure qsort1(l,r:longint);
var i,j:longint;
    m,t:tseg;
begin
  i:=l;
  j:=r;
  m:=seg[l+random(r-l+1)];
  repeat
    while lseg(seg[i],m) do
      inc(i);
    while lseg(m,seg[j]) do
      dec(j);
    if i<=j then
    begin
      t:=seg[i];
      seg[i]:=seg[j];
      seg[j]:=t;
      inc(i);
      dec(j);
    end;
  until i>j;
  if l<j then
    qsort1(l,j);
  if i<r then
    qsort1(i,r);
end;
procedure qsort2(l,r:longint);
var i,j,m,t:longint;
begin
  i:=l;
  j:=r;
  m:=yy[l+random(r-l+1)];
  repeat
    while yy[i]>m do
      inc(i);
    while yy[j]<m do
      dec(j);
    if i<=j then
    begin
      t:=yy[i];
      yy[i]:=yy[j];
      yy[j]:=t;
      inc(i);
      dec(j);
    end;
  until i>j;
  if l<j then
    qsort2(l,j);
  if i<r then
    qsort2(i,r);
end;
function search(y:longint):longint;
var l,r,m:longint;
begin
  l:=1;
  r:=ny+1;
  while r-l>1 do
  begin
    m:=(l+r) shr 1;
    if yy[m]<y then
      r:=m
    else l:=m;
  end;
  search:=l;
end;
function query(x:longint):longint;
var res:longint;
begin
  res:=0;
  while x>=0 do
  begin
    if ans[best[x]]>ans[res] then
      res:=best[x];
    x:=x and (x+1)-1;
  end;
  query:=res;
end;
procedure update(x,k:longint);
begin
  while x<=ny do
  begin
    if ans[best[x]]<ans[k] then
      best[x]:=k;
    x:=x or (x+1);
  end;
end;
begin
  randomize;
  assign(input,'rects.in');
  reset(input);
  assign(output,'rects.out');
  rewrite(output);
  read(n);
  ns:=0;
  ny:=0;
  for i:=1 to n do
  begin
    read(x1,y1,x2,y2,w[i]);
    if x1>x2 then
      swap(x1,x2);
    if y1>y2 then
      swap(y1,y2);
    addseg(x1,y1,y2,i,1);
    addseg(x2,y1,y2,i,2);
    addy(y1);
    addy(y2);
  end;
  qsort1(1,ns);
  qsort2(1,ny);
  t:=1;
  for i:=2 to ny do
    if yy[i]<>yy[t] then
    begin
      inc(t);
      yy[t]:=yy[i];
    end;
  ny:=t;
  for i:=1 to ns do
  begin
    seg[i].y1:=search(seg[i].y1);
    seg[i].y2:=search(seg[i].y2);
  end;
  for i:=0 to ny do
    best[i]:=0;
  ans[0]:=-infinity;
  for i:=1 to ns do
    case seg[i].t of
      1:begin
        anc:=query(seg[i].y2-1);
        ans[seg[i].r]:=w[seg[i].r];
        if anc<>0 then
          inc(ans[seg[i].r],ans[anc]);
        last[seg[i].r]:=anc;
      end;
      2:update(seg[i].y1,seg[i].r);
    end;
  t:=1;
  for i:=2 to n do
    if ans[i]>ans[t] then
      t:=i;
  writeln(ans[t]);
  nc:=0;
  while t<>0 do
  begin
    inc(nc);
    ch[nc]:=t;
    t:=last[t];
  end;
  for i:=nc downto 1 do
    write(ch[i],' ');
  close(input);
  close(output);
end.
