const MaxN = 41;
      MaxM = 45;
      Small = -1;
      WhereX : array [1..4] of longint = (1,0,-1,0);
      WhereY : array [1..4] of longint = (0,1,0,-1);

var a : array [0..MaxN+1,0..MaxM+1] of longint;
    nn : array [0..MaxN+1,0..MaxM+1] of boolean;
    st1,st2 : longint;
    i,j : longint;
    c : char;
    ok : boolean;

function DFS(x,y,c : longint) : longint;
var i : longint;
    Result : longint;
begin
    if a[x,y] <> st1 then Result := 1;
    if a[x,y] = c then ok := true
    else Result := 0;
    nn[x,y] := false;
    for i := 1 to 4 do
     if ((a[x+WhereX[i],y+WhereY[i]] = a[1,1]) or (a[x+WhereX[i],y+WhereY[i]] = c))
     and nn[x+WhereX[i],y+WhereY[i]] then Result := Result+DFS(x+WhereX[i],y+WhereY[i],c);
    for i := 1 to 4 do
     if (a[x+WhereX[i],y+WhereY[i]] <> a[1,1]) and (a[x+WhereX[i],y+WhereY[i]] <> c)
     and (a[x+WhereX[i],y+WhereY[i]] <> 0) and (a[x+WhereX[i],y+WhereY[i]] <> st2)
     and nn[x+WhereX[i],y+WhereY[i]] then begin
      inc(Result);
      nn[x+WhereX[i],y+WhereY[i]] := false;
     end;
    DFS := Result;
end;

procedure Solve;
var s,max,i,j : longint;
begin
    Randomize;
    max := Small;
    j := Small;
    for i := 1 to 6 do
     if (i <> st1) and (i <> st2) then begin
      fillchar(nn,sizeof(nn),true);
      ok := false;
      s := DFS(1,1,i);
      if ok and (s > max) then begin
       max := s;
       j := i;
      end
      else if max = Small then j := i;
     end;
    writeln(j);
end;

begin
    assign(input,'filya.in');
    assign(output,'filya.out');
    reset(input);
    rewrite(output);
    for i := 1 to MaxN do begin
     for j := 1 to MaxM do begin
      read(c);
      a[i,j] := ord(c)-$30;
     end;
     readln;
    end;
    st1 := a[1,1];
    st2 := a[MaxN,MaxM];
    Solve;
    close(input);
    close(output);
end.
