const MaxN = 40;

type TAccount = record
      num : longint;
      where : longint;
     end;

var c : char;
    a : array [1..MaxN,1..MaxN] of longint;
    acc : array [1..MaxN,1..MaxN] of TAccount;
    n,m : longint;
    i,j : longint;

function Init : boolean;
var i,j : longint;
begin
    Init := false;
    i := 1;
    if eof then exit;
    read(c);
    while (c <> '-') and (c <> '#') do begin
     j := 1;
     while not eoln do begin
      if c = '*' then a[i,j] := 1;
      inc(j);
      read(c);
     end;
     if c = '*' then a[i,j] := 1;
     readln;
     inc(i);
     read(c);
    end;
    n := i-1;
    m := j;
    Init := true;
end;

procedure GetAcc(i,j : longint);
var x,y : longint;
begin
    with acc[i,j] do begin
     where := 1111;
     for x := i downto 1 do
      if a[x,j] = 1 then begin
       inc(num);
       where := where-1000;
       break;
      end;
     for x := i to n do
      if a[x,j] = 1 then begin
       inc(num);
       where := where-10;
       break;
      end;
     for x := j downto 1 do
      if a[i,x] = 1 then begin
       inc(num);
       where := where-1;
       break;
      end;
     for x := j to m do
      if a[i,x] = 1 then begin
       inc(num);
       where := where-100;
       break;
      end;
    end;
end;

function FindAcc(num : longint) : longint;
var i,j : longint;
    ot : longint;
begin
    ot := 0;
    for i := 1 to n do
     for j := 1 to m do
      if acc[i,j].num = num then inc(ot);
    FindAcc := ot;
end;

function FindDiff(num : longint) : longint;
var left,right,up,down : boolean;
    i,j : longint;
    all,allx,allxy : longint;
begin
    all := 0;
    for i := 1 to n do begin
     allx := 0;
     left := false;
     right := false;
     for  j := 1 to m do
      if acc[i,j].num = num then begin
       inc(allx);
       if acc[i,j].where = 100 then right := true
       else if acc[i,j].where = 1 then left := true
       else dec(allx);
      end;
     if right and left then all := all+allx;
    end;
    allxy := all;
    for j := 1 to m do begin
     allx := 0;
     up := false;
     down := false;
     for  i := 1 to n do
      if acc[i,j].num = num then begin
       inc(allx);
       if acc[i,j].where = 1000 then up := true
       else if acc[i,j].where = 10 then down := true
       else dec(allx);
      end;
     if up and down then all := allx+all;
    end;
    if (all = allxy) or (allxy = 0) then FindDiff := 0
    else FindDiff := 1;
end;

procedure Solve;
var i,j : longint;
    four,three : longint;
begin
    while Init do begin
     for i := 1 to n do
      for j := 1 to m do
       if a[i,j] = 0 then GetAcc(i,j);
     three := FindAcc(3);
     four := FindAcc(4);
     if four > three then writeln('0')
     else if FindDiff(3) = 1 then writeln('X')
     else writeln('0');
    end;
end;

begin
    assign(input,'x0.in');
    assign(output,'x0.out');
    reset(input);
    rewrite(output);
    Solve;
    close(input);
    close(output);
end.
