const MaxN = 1000;
      MaxP = 500;

var a : array [1..MaxN] of longint;
    ost : array [0..MaxP,0..MaxN] of longint;
    period : array [0..MaxP] of longint;
    p,n,i : longint;

function FindMod(x,y : longint) : longint;
var k : int64;
    i : longint;
begin
    fillchar(period,sizeof(period),0);
    k := a[x];
    if k <> p then begin
     inc(period[0]);
     period[period[0]] := 1;
     i := 1;
     while (period[i] <> 1) or (i = 1) do begin
      k := k*a[x];
      inc(period[0]);
      period[period[0]] := k mod p;
      inc(i);
     end;
     dec(period[0]);
    end
    else period[0] := 1;
    if y mod period[0] <> 0 then FindMod := period[y mod period[0]]
    else FindMod := period[period[0]];
end;

procedure Solve;
var i,j,k : longint;
    s : longint;
    sum : longint;
begin
    sum := 0;
    for i := 1 to n do
     for j := 1 to n do
      if i <> j then begin
       s := FindMod(i,j);
       for k := 1 to ost[s,0] do
        if (ost[s,k] <> i) and (ost[s,k] <> j) then inc(sum);
      end;
    writeln(sum);
end;

begin
    assign(input,'triples.in');
    assign(output,'triples.out');
    reset(input);
    rewrite(output);
    read(n,p);
    for i := 1 to n do begin
     read(a[i]);
     inc(ost[a[i] mod p,0]);
     ost[a[i] mod p,ost[a[i] mod p,0]] := i;
    end;
    Solve;
    close(input);
    close(output);
end.
