const MaxN = 4;

var a : array [1..MaxN,1..MaxN] of word;
    more : array [1..MaxN,1..MaxN] of word;
    stat : array [1..MaxN] of word;
    n,i : word;
    allright : boolean;

function Init : boolean;
var i,j : word;
begin
    for i := 1 to n do
     for j := 1 to n do
      a[i,j] := 0;
    read(n);
    Init := n <> 0;
    for i := 1 to n do
     for j := 1 to n do
      read(a[i,j]);
end;

function MBS(x,y : word) : boolean; //More By Stats
begin
    MBS := (more[x,y] = 2);
end;

function MBM(x,y : word) : boolean; //More By Messages
var i : word;
    morex : longint;
begin
    morex := 0;
    for i := 1 to n do
     if (i <> x) and (i <> y) then
      if (morex = 0) and (a[x,i] > a[y,i]) then morex := 1
      else if (morex = 0) and (a[x,i] < a[y,i]) then morex := -1
      else if ((morex = 1) and (a[x,i] < a[y,i]))
      or ((morex = -1) and (a[x,i] > a[y,i])) then begin
       allright := false;
       exit;
      end;
    if morex = 0 then MBM := (x > y)
    else MBM := (morex = 1);
end;

function GetStats : boolean;
var i,j,k : word;
    q : longint;
begin
    for i := 1 to n do
     for j := 1 to n do
      more[i,j] := 0;
    allright := true;
    for i := 1 to n do
     for j := i-1 downto 1 do
      if i <> j then begin
       if more[i,j] = 0 then
        if MBM(i,j) then begin
         more[i,j] := 2;
         more[j,i] := 1;
         for k := 1 to i-1 do
          if more[j,k] = 1 then begin
           more[i,k] := 2;
           more[k,i] := 1;
          end;
        end
        else begin
         more[i,j] := 1;
         more[j,i] := 2;
         for k := 1 to i-1 do
          if more[j,k] = 2 then begin
           more[i,k] := 1;
           more[k,i] := 1;
          end;
        end;
       if not allright then begin
        GetStats := false;
        exit;
       end;
      end;
end;

procedure Swap(var a,b : word);
var c : word;
begin
    c := a;
    a := b;
    b := c;
end;

procedure Sort(l,r : word);
var i,j,x : word;
begin
    i := l;
    j := r;
    x := stat[Random(j-i+1)+i];
    repeat
     while MBS(stat[j],x) do dec(j);
     while MBS(x,stat[i]) do inc(i);
     if i <= j then begin
      Swap(stat[i],stat[j]);
      inc(i);
      dec(j);
     end;
    until i > j;
    if i < r then Sort(i,r);
    if l < j then Sort(l,j);
end;

function Good : boolean;
var max : array [1..MaxN] of word;
    i,j : word;
begin
    Good := true;
    for i := 1 to n do max[i] := 0;
    for j := 1 to n do
     for i := 1 to n do
      if a[i,j] > max[j] then max[j] := a[i,j];
    for i := 1 to n do
     if (max[i] > a[stat[n],i]) and not (i = stat[n]) then begin
      Good := false;
      exit;
     end;
    if (n > 1) and (a[stat[n-1],stat[n]] < max[stat[n]]) then Good := false;
end;

procedure Solve;
begin
    While Init do
     if GetStats then begin
      for i := 1 to n do stat[i] := i;
      Sort(1,n);
      if not Good then writeln(-1)
      else begin
       for i := 1 to n-1 do write(stat[i],' ');
       writeln(stat[n]);
      end;
     end
     else writeln(-1);
end;

begin
    assign(input,'chat.in');
    assign(output,'chat.out');
    reset(input);
    rewrite(output);
    Solve;
    close(input);
    close(output);
end.
