const MaxN = 100000;

type TRect = record
      x1,y1,x2,y2 : longint;
      st : longint;
      number : longint;
     end;

var a : array [1..MaxN] of TRect;
    i,n,k : longint;
    x : TRect;
    ot,getot : array [1..MaxN] of int64;

function More(var a,b : TRect) : boolean;
begin
    More := (a.x1 <= b.x1) and (a.y1 >= b.y1);
    if (a.x1 = b.x1) and (a.x2 = b.x2)
    and (a.y1 = b.y1) and (a.y2 = b.y2) then More := false;
end;

procedure Swap(var a,b : TRect);
var c : TRect;
begin
    c := a;
    a := b;
    b := c;
end;

procedure Sort(l,r : longint);
var i,j : longint;
begin
    i := l;
    j := r;
    x := a[Random(j-i+1)+i];
    repeat
     while More(x,a[j]) do dec(j);
     while More(a[i],x) do inc(i);
     if i <= j then begin
      Swap(a[i],a[j]);
      inc(i);
      dec(j);
     end;
    until i > j;
    if i < r then Sort(i,r);
    if l < j then Sort(l,j);
end;

function MuchMore(var a,b : TRect) : boolean;
begin
    MuchMore := (a.x2 < b.x1) and (a.y2 > b.y1);
end;

procedure Solve;
var i,j : longint;
    max,kl : longint;
begin
    ot[1] := a[1].st;
    for i := 2 to n do
     for j := i-1 downto 1 do
      if (ot[j]+a[i].st > ot[i]) and MuchMore(a[j],a[i])
      then ot[i] := ot[j]+a[i].st;
    max := 1;
    for i := 2 to n do
     if ot[max] < ot[i] then max := i;
    writeln(ot[max]);
    i := max-1;
    j := max;
    kl := 1;
    getot[kl] := a[max].number;
    while ot[j] <> a[j].st do begin
     while ot[i]+a[i].st <> ot[j] do dec(i);
     inc(kl);
     getot[kl] := a[i].number;
     j := i;
    end;
    for i := kl downto 1 do write(getot[i],' ');
end;

begin
    assign(input,'rects.in');
    assign(output,'rects.out');
    reset(input);
    rewrite(output);
    read(n);
    for i := 1 to n do begin
     with a[i] do read(x1,y1,x2,y2,st);
     k := a[i].y1;
     a[i].y1 := a[i].y2;
     a[i].y2 := k;
     a[i].number := i;
    end;
    Sort(1,n);
    Solve;
    close(input);
    close(output);
end.
