{$H+}

const MaxLeng = 1000;

type TRask = array [0..MaxLeng] of longint;

var s,added : string;
    a : array [1..MaxLeng,1..MaxLeng] of longint;
    i,j,n : longint;
    eq : boolean;
    meq : array [1..MaxLeng] of longint;
    meqn : longint;
    fras,sras : TRask;

function More(i1,j1,i2,j2 : longint) : boolean;
var i : longint;
begin
    More := false;
    while (s[i1] = '0') and (i1 < j1) do inc(i1);
    while (s[i2] = '0') and (i2 < j2) do inc(i2);
    if j1-i1 > j2-i2 then More := true
    else if j1-i1 < j2-i2 then exit
    else begin
     for i := i1 to j1 do begin
      if s[i] > s[i2] then begin
       More := true;
       exit;
      end
      else if s[i] < s[i2] then exit;
      inc(i2);
     end;
     eq := true;
    end;
end;

procedure DoRask(i : longint; var ax : TRask);
var j : longint;
begin
    j := i;
    i := n;
    while j > 1 do begin
     inc(ax[0]);
     ax[ax[0]] := a[i,j];
     i := a[i,j]-1;
     j := j-1;
    end;
    inc(ax[0]);
    ax[ax[0]] := a[i,j];
end;

procedure Compare(var a,b : TRask);
var i : longint;
begin
    if a[0] > b[0] then begin
     a := b;
     exit;
    end;
    for i := a[0] downto 2 do begin
     eq := false;
     if More(a[i-1],a[i],b[i-1],b[i]) and not eq then begin
      a := b;
      exit;
     end
     else if not eq then exit;
    end;
end;

procedure Solve;
var i,j,k : longint;
    nx : longint;
    min : longint;
begin
    n := length(s);
    for i := 1 to n do
     for j := 1 to n do
      a[i,j] := -1;
    for i := 1 to n do
     for j := 1 to i do begin
      if i mod j = 0 then nx := i div j
      else nx := i div j+1;
      if j = 1 then a[i,j] := 1
      else
       for k := nx to i-j+1 do begin
        if (a[i-k,j-1] <> -1) and More(i-k+1,i,a[i-k,j-1],i-k) then begin
         a[i,j] := i-k+1;
         break;
        end;
       end;
      if a[i,j] = -1 then break;
     end;
    min := 1;
    for i := 2 to n do
     if (a[n,i] <> -1) and More(a[n,min],n,a[n,i],n) then min := i;
    for i := 1 to n do begin
     eq := false;
     if a[n,i] <> -1 then More(a[n,min],n,a[n,i],n);
     if eq then begin
      inc(meqn);
      meq[meqn] := i;
     end;
    end;
    DoRask(meq[1],fras);
    for i := 2 to meqn do begin
     DoRask(meq[i],sras);
     Compare(fras,sras);
    end;
    j := fras[0]-1;
    for i := 1 to length(s) do
     if (i = fras[j]) and (j > 0) then begin
      write(',',s[i]);
      dec(j);
     end
     else write(s[i]);
end;

begin
    assign(input,'commas.in');
    reset(input);
    assign(output,'commas.out');
    rewrite(output);
    readln(s);
    if s[1] = '0' then begin
     i := 1;
     j := 0;
     while s[i] = '0' do begin
      inc(j);
      inc(i);
     end;
     for i := 1 to j do added := added+'0';
     delete(s,1,j);
     write(added);
    end;
    Solve;
    close(input);
    close(output);
end.
