const max_depth=4;
type
  TField=array[0..42,0..46]of shortint;
var
  f:array[0..max_depth]of
      TField;
  mark:TField;
  color,depth:integer;

function paint(var f:TField; i,j, oc,nc:integer):integer;
var n:integer;
  procedure rec(i,j:integer);
  begin
    if f[i,j]=oc then begin
      f[i,j]:=nc;
      inc(n);
      rec(i-1,j);
      rec(i+1,j);
      rec(i,j-1);
      rec(i,j+1);
    end;
  end;
begin
  n:=0;
  rec(i,j);
  paint:=n;
end;

var
  w,a:TField;
  tx,ty:integer;

function way(i,j:integer):integer;
var r:integer;
begin
  if w[i,j]>=0 then way:=w[i,j] else begin
    if a[i,j]<=0 then r:=0 else
    if (i=tx)and(j=ty) then r:=1 else
    begin
      w[i,j]:=0;
      if (way(i-1,j)=1)or(way(i+1,j)=1)or
         (way(i,j-1)=1)or(way(i,j+1)=1) then
           r:=1 else r:=0;
    end;
    w[i,j]:=r;
    way:=r;
  end;
end;


function cost:longint;
var i,j:integer;
x:longint;
begin
  for i:=0 to 42 do
    for j:=0 to 46 do
      a[i,j]:=f[depth][i,j];

  x:=paint(a,1,1,a[1,1],-1)*100;
  tx:=41;
  ty:=45;
  for i:=1 to 41 do
    for j:=1 to 45 do
      w[i,j]:=-1;
  for i:=1 to 41 do
    for j:=1 to 45 do
      if way(i,j)=0 then begin
        a[i,j]:=-2;
        x:=x+99;
      end;

  x:=x-paint(a,41,45,a[41,45],-3)*100;
  tx:=1;
  ty:=1;
  for i:=1 to 41 do
    for j:=1 to 45 do
      w[i,j]:=-1;
  for i:=1 to 41 do
    for j:=1 to 45 do
      if way(i,j)=0 then begin
        a[i,j]:=-4;
        x:=x-99;
      end;

{  for i:=1 to 41 do
    for j:=1 to 46 do
      if a[i,j]=-1 then begin
        x:=x-paint(a,i-1,j,a[41,45],-5)*20;
        x:=x-paint(a,i+1,j,a[41,45],-5)*20;
        x:=x-paint(a,i,j-1,a[41,45],-5)*20;
        x:=x-paint(a,i,j+1,a[41,45],-5)*20;
      end;

  for i:=1 to 41 do
    for j:=1 to 46 do
      if a[i,j]=-3 then begin
        x:=x+paint(a,i-1,j,a[1,1],-6)*20;
        x:=x+paint(a,i+1,j,a[1,1],-6)*20;
        x:=x+paint(a,i,j-1,a[1,1],-6)*20;
        x:=x+paint(a,i,j+1,a[1,1],-6)*20;
      end;}
  cost:=x;
end;

function make2:longint; forward;

function make1:longint;
var
  ff:boolean;
  cl,ind,i,j:integer;
  z,max:longint;
begin
  if depth=max_depth then begin
    make1:=cost;
    exit;
  end;
  ff:=true;
  for cl:=1 to 6 do
    if (cl<>f[depth][1,1])and(cl<>f[depth][41,45]) then begin
      inc(depth);
      for i:=0 to 42 do
        for j:=0 to 46 do
          f[depth][i,j]:=f[depth-1][i,j];
      paint(f[depth],1,1,f[depth-1][1,1],cl);
      z:=make2;
      if ff or(z>max) then begin
        max:=z;
        ind:=cl;
        ff:=false;
      end;
      dec(depth);
    end;
  make1:=max;
  color:=ind;
end;

function make2:longint;
var
  ff:boolean;
  cl,j,i:integer;
  z,max:longint;
begin
  if depth=max_depth then begin
    make2:=cost;
    exit;
  end;
  ff:=true;
  for cl:=1 to 6 do
    if (cl<>f[depth][1,1])and(cl<>f[depth][41,45]) then begin
      inc(depth);
      for i:=0 to 42 do
        for j:=0 to 46 do
          f[depth][i,j]:=f[depth-1][i,j];
      paint(f[depth],41,45,f[depth-1][41,45],cl);
      z:=make1;
      if ff or(z<max) then begin
        max:=z;
        ff:=false;
      end;
      dec(depth);
    end;
  make2:=max;
end;

var
  i,j:integer;
  ch:char;
begin
  assign(input,'filya.in');
  reset(input);
  assign(output,'filya.out');
  rewrite(output);
  for i:=0 to 42 do
    for j:=0 to 46 do
      f[0][i,j]:=0;
  for i:=1 to 41 do begin
    for j:=1 to 45 do begin
      read(ch);
      f[0][i,j]:=ord(ch)-ord('0');
    end;
    readln;
  end;
  depth:=0;
  make1;
  writeln(color);
  close(input);
  close(output);
end.
