var
  h,w:integer;
  f:array[1..40,1..40]of boolean;

var
  left,top,right,bottom,dx,dy:integer;
  f2:array[-80..80,-80..80]of boolean;

procedure paint(i,j:integer);

begin
  if (i<left-dx-1)or(i>right+dx+1)or(j<top-1-dy)or(j>bottom+dy+1)or(f2[i,j]) then exit;
  f2[i,j]:=true;
  Paint(i-1,j);
  Paint(i+1,j);
  Paint(i,j-1);
  Paint(i,j+1);
end;

procedure scan;
var n,i,j,z,x:integer;
begin
  top:=w;
  left:=h;
  right:=1;
  bottom:=1;
  for i:=1 to w do
    for j:=1 to h do
      if f[i,j] then begin
        if j<top then top:=j;
        if j>bottom then bottom:=j;
        if i<left then left:=i;
        if i>right then right:=i;
      end;
  w:=right-left+1;
  h:=bottom-top+1;
  dx:=w div 6;
  dy:=h div 6;
{  for i:=left-dx-1 to right+dx+1 do begin
    for j:=top-dy-1 to bottom+dy+1 do
      write(ord(f[i,j]));
    writeln;
  end;
  writeln;}
  for i:=left-dx-1 to right+dx+1 do
    for j:=top-dy-1 to bottom+dy+1 do
      f2[i,j]:=false;
  for i:=left to right do
    for j:=top to bottom do
      if f[i,j] then
        for z:=i-dx to i+dx do
          for x:=j-dy to j+dy do
            f2[z,x]:=true;
{  for i:=left-dx-1 to right+dx+1 do begin
    for j:=top-dy-1 to bottom+dy+1 do
      write(ord(f2[i,j]));
    writeln;
  end;}
  n:=0;
  for i:=left-dx-1 to right+dx+1 do
    for j:=top-dy-1 to bottom+dy+1 do
      if not f2[i,j] then begin
        paint(i,j);
        inc(n);
      end;
  if n=1 then writeln('X') else writeln('0');
end;

var
  ch:char;
  i:integer;
begin
  assign(input,'x0.in');
  reset(input);
  assign(output,'x0.out');
  rewrite(output);
  repeat
    w:=0;
    while not eoln do begin
      inc(w);
      read(ch);
      f[w,1]:=ch='*';
    end;
    readln;
    read(ch);
    h:=1;
    while ch in ['.','*'] do begin
      inc(h);
      f[1,h]:=ch='*';
      for i:=2 to w do begin
        read(ch);
        f[i,h]:=ch='*';
      end;
      readln;
      read(ch);
    end;
    scan;
    readln;
  until ch='#';
  close(input);
  close(output);
end.
