{$S+,R+,Q+}
type
  ext=(no,yes,proc);
  pDoor=^tDoor;
  tDoor=record
    next:pDoor;
    v:integer;
  end;

  integer=longint;

var
  cok:array[1..300,1..300]of ext;
  cr:array[1..300,1..300]of integer;
  gok:array[1..300,1..300,1..10]of ext;
  gr:array[1..300,1..300,1..10]of integer;
  n,m,k:integer;
  doors:array[1..300,1..10]of pDoor;

function guy(x,y,s:integer):integer; forward;

function cop(x,y:integer):integer;
var
  f:boolean;
  m,z,s:integer;
  p:pDoor;
begin
  if cok[x,y]=yes then cop:=cr[x,y] else
  if cok[x,y]=proc then cop:=0 else
  begin
//    writeln('cop(',x,',',y,')');
    cok[x,y]:=proc;
    f:=true;
    m:=0;
    for s:=1 to k do begin
      p:=Doors[x,s];
      while p<>nil do begin
        z:=guy(p^.v,y,s);
        if f or (z>m) then begin
          f:=false;
          m:=z;
        end;
        p:=p^.next;
      end;
    end;
    if m>0 then inc(m) else
    if m<0 then dec(m);
    cr[x,y]:=m;
    cok[x,y]:=yes;
    cop:=m;
//    writeln('cop(',x,',',y,')=',m);
  end;
end;

function guy(x,y,s:integer):integer;
var
//  f:boolean;
  m,z:integer;
  p:pDoor;
begin
  if gok[x,y,s]=yes then guy:=gr[x,y,s] else
  if gok[x,y,s]=proc then guy:=0 else
  begin
//    writeln('guy(',x,',',y,',',s,')');
    gok[x,y,s]:=proc;
//    f:=true;
    m:=cop(x,y);
    p:=Doors[y,s];
    while p<>nil do begin
      z:=cop(x,p^.v);
      if {f or} (z<m) then begin
//        f:=false;
        m:=z;
      end;
      p:=p^.next;
    end;
    gr[x,y,s]:=m;
    guy:=m;
    gok[x,y,s]:=yes;
//    writeln('guy(',x,',',y,',',s,')=',m);
  end;
end;

procedure add(x,y,z:integer);
var p:pDoor;
begin
  new(p);
  p^.next:=doors[x,z];
  p^.v:=y;
  doors[x,z]:=p;
end;


var
  x,y,z,i,j,s:integer;

begin
  assign(input,'pursuit.in');
  reset(input);
  assign(output,'pursuit.out');
  rewrite(output);

  readln(n,m,k);
  //Load graph
  for i:=1 to n do
    for j:=1 to k do
      doors[i][j]:=nil;
  for i:=1 to m do begin
    readln(x,y,z);
    add(x,y,z);
    add(y,x,z);
  end;
  readln(x,y);
  if y=1 then begin
    close(input);
    close(output);
    halt;
  end;

  for i:=1 to n do begin
    for j:=1 to n do begin
      cok[i,j]:=no;
      for s:=1 to k do
        gok[i,j,s]:=no;
    end;
  end;
  for i:=1 to n do begin
    cok[i,1]:=yes;
    cr[i,1]:=-1;
    for s:=1 to k do
      gok[i,1,s]:=yes;
    for s:=1 to k do
      gr[i,1,s]:=-1;
  end;
  for i:=2 to n do begin
    cok[i,i]:=yes;
    cr[i,i]:=1;
    for s:=1 to k do
      gok[i,i,s]:=yes;
    for s:=1 to k do
      gr[i,i,s]:=1;
  end;
  z:=cop(x,y);
  if z=0 then
    writeln('Endless')
  else if z>0 then begin
    writeln('Caught');
    writeln(z-1);
  end else begin
    writeln('Escaped');
    writeln(-z-1);
  end;
  close(input);
  close(output);
end.
