{$M 40000000,0,0}
{$R+,S+}
type integer=longint;
var
  ll,max,k,t:integer;
  w,x,s,p,sr,dt,ed:array[1..100000]of integer;
  v:array[1..100000]of boolean;

type
  pE=^tE;
  tE=record
    next:pe;
    v:integer;
  end;
var
  list:array[1..100000]of pe;

procedure add(a,b:integer);
var p:pe;
begin
  new(p);
  p^.v:=b;
  p^.next:=list[a];
  list[a]:=p;
end;

procedure visit(x:integer);
var p:pe;
begin
  if v[x] then exit;
  v[x]:=true;
  inc(k);
  s[k]:=x;
  p:=list[x];
  while p<>nil do begin
    visit(p^.v);
    p:=p^.next;
  end;
end;

procedure Sort(var x,p:array of integer; l,r:integer);
var k,i,j,t:integer;
begin
  i:=l; j:=r;
  k:=x[p[(i+j)div 2]-1];
  repeat
    while x[p[i]-1]<k do inc(i);
    while x[p[j]-1]>k do dec(j);
    if i<=j then begin
      t:=p[i];
      p[i]:=p[j];
      p[j]:=t;
      inc(i);
      dec(j);
    end;
  until i>j;
  if l<j then Sort(x,p,l,j);
  if i<r then Sort(x,p,i,r);
end;

var a,b,n,m,l,i,j:integer;

begin
  assign(input,'roads.in');
  reset(input);
  assign(output,'roads.out');
  rewrite(output);
  readln(n,m,l);
  for i:=1 to n do ed[i]:=i;
  for i:=1 to m do ed[i]:=i;
  for i:=1 to n do list[i]:=nil;

  for i:=1 to n do begin
    read(x[i]);
    p[i]:=i;
  end;
  Sort(x,p,0,n-1);
  for i:=1 to n do w[p[i]]:=i;
  for i:=1 to m do begin
    readln(a,b);
    a:=w[a]; b:=w[b];
    add(a,b);
    add(b,a);
    v[i]:=false;
  end;
  m:=0;
  for i:=1 to n do
    if not v[p[i]] then begin
      k:=0;
      visit(i);
      Sort(ed,s,0,k-1);

{      for j:=1 to k do
        writeln(s[ed[j]]);
      writeln;}
      b:=x[p[s[1]]];
      a:=x[p[s[k]]];
      max:=l+b-a;
      for j:=2 to k do begin
        if x[p[s[j]]]-x[p[s[j-1]]]>max then
          begin
            b:=x[p[s[j]]];
            a:=x[p[s[j-1]]];
            max:=b-a;
          end;
      end;
      inc(m);
      sr[m]:=b;
      dt[m]:=a;
    end;

{  for i:=1 to m do
    writeln(sr[ed[i]],' ',dt[ed[i]]);
  writeln;}

  Sort(sr,ed,0,m-1);

{  for i:=1 to m do
    writeln(sr[ed[i]],' ',dt[ed[i]]);
  writeln;}

  i:=1;
  while (i<m)and(sr[ed[i]]<=dt[ed[m]]) do begin
    if dt[ed[i]]>dt[ed[m]] then ed[m]:=ed[i];
    inc(i);
  end;

  b:=dt[ed[i]];
  ll:=b-sr[ed[i]];
  for i:=i+1 to m do begin
    if sr[ed[i]]<b then begin
      ll:=ll+dt[ed[i]]-b;
      b:=dt[ed[i]];
    end else begin
      b:=dt[ed[i]];
      if sr[ed[i]]>b then ll:=ll+l;
      ll:=ll+b-sr[ed[i]];
    end;
  end;
  writeln(ll);



  close(input);
  close(output);
end.