{$I-,Q-,R-,S-}

program TheKey;
const infile = 'key.in';
      outfile = 'key.out';
const MAXR = 100;
      MAXN = 10000;
      MAXM = 1000;
type tRow = record
  start, len : integer;
end;
var key : array[1..MAXR] of tRow;
    b, q : array[-MAXR+1..MAXN, 0..MAXM+1] of boolean;
    right : array[-MAXR+1..MAXN+MAXR-1, 1..MAXM] of integer;
    field : array[-MAXR+1..MAXN+MAXR-1, 1..MAXM] of char;
    R, C, N, M : integer;

procedure ReadData;
var min, max, i, j : integer;
    ch : char;
begin
  fillchar(field, sizeof(field), '.');
  fillchar(right, sizeof(right), 0);
  fillchar(b, sizeof(b), false);
  fillchar(q, sizeof(q), false);

  assign(input, infile);
  assign(output, outfile);
  reset(input);
  rewrite(output);

  readln(R, C);
  for i:=1 to R do begin
    min:=1000; max:=0;
    for j:=1 to C do begin
      read(ch);
      if ch='#' then begin
        if j>max then max:=j;
        if j<min then min:=j;
      end;
    end;

    key[i].start:=min; key[i].len:=max-min+1; readln;
  end;

  readln(N, M);
  for i:=1 to N do begin
    for j:=1 to M do
      read(field[i, j]);

    readln;
  end;
end;

procedure Solve;
var i, j, k, max : integer;
begin
  for i:=-R+1 to N+R-1 do begin
    if field[i, M]='.' then right[i, M]:=1 else right[i, M]:=0;

    for j:=M-1 downto 1 do
      if field[i, j]='#' then right[i, j]:=0 else right[i, j]:=right[i, j+1]+1;
  end;

  for j:=1 to M-C+1 do begin
    b[-R+1, j]:=true;

    for k:=1 to R do
      if right[-R+k, j+key[k].start-1]<key[k].len then begin
        b[-R+1, j]:=false; break;
      end;
  end;
{}
  for i:=-R+2 to N do begin
    for j:=1 to M-C+1 do begin
      b[i, j]:=true;

      for k:=1 to R do
        if right[i+k-1, j+key[k].start-1]<key[k].len then begin
          b[i, j]:=false; break;
        end;
    end;
  end;
{}
  for j:=1 to M-C+1 do
    q[-R+1, j]:=b[-R+1, j];

  for i:=-R+2 to N do begin
    for j:=1 to M-C+1 do
      q[i, j]:=b[i, j] and (q[i, j-1] or q[i-1, j]);

    for j:=M-C+1 downto 1 do
      q[i, j]:=q[i, j] or (b[i, j] and q[i, j+1]);
  end;

  max:=-R+1;
  for i:=-R+1 to N do
    for j:=1 to M-C+1 do
      if (q[i, j]) then begin max:=i; break; end;

  if max=N then writeln(-1) else writeln(max+R-1);
end;

procedure WriteData;
begin
  close(input);
  close(output);
end;

begin
  ReadData;
  Solve;
  WriteData;
end.
