program JustFilya;
const infile = 'filya.in';
      outfile = 'filya.out';
      N = 41;
      M = 45;
      rs = 3;
var tf, tempfield, field : array[0..N+1, 0..M+1] of byte;
    cy, ce : byte;

procedure DFSPaint(i, j, c1, c2 : integer);
begin
  tempfield[i, j]:=c2;

  if tempfield[i, j-1]=c1 then DFSPaint(i, j-1, c1, c2);
  if tempfield[i, j+1]=c1 then DFSPaint(i, j+1, c1, c2);
  if tempfield[i-1, j]=c1 then DFSPaint(i-1, j, c1, c2);
  if tempfield[i+1, j]=c1 then DFSPaint(i+1, j, c1, c2);
end;

function DFSCount(i, j, c : integer) : longint;
var res : longint;
begin
  res:=1; tempfield[i, j]:=0;

  if tempfield[i, j-1]=c then res:=res+DFSCount(i, j-1, c);
  if tempfield[i, j+1]=c then res:=res+DFSCount(i, j+1, c);
  if tempfield[i-1, j]=c then res:=res+DFSCount(i-1, j, c);
  if tempfield[i+1, j]=c then res:=res+DFSCount(i+1, j, c);

  DFSCount:=res;
end;

procedure ReadData;
var i, j : integer;
    ch : char;
begin
  fillchar(field, sizeof(field), 0);
  assign(input, infile);
  assign(output, outfile);
  reset(input);
  rewrite(output);

  for i:=1 to N do begin
    for j:=1 to M do begin
      read(ch);
      field[i, j]:=ord(ch)-48;
    end;
    readln;
  end;
end;

procedure Solve2;
var maxi, i : byte;
    max, tmp : longint;
begin
  cy:=field[1, 1]; ce:=field[N, M];

  max:=-1;
  for i:=1 to 6 do begin
    if (i=cy) or (i=ce) then continue;

    tempfield:=field;
    DFSPaint(1, 1, cy, i);
    tmp:=DFSCount(1, 1, i);

    if tmp>max then begin max:=tmp; maxi:=i; end;
  end;

  writeln(maxi);
end;

procedure Solve1;
var maxi, maxj, i, j, i2 : byte;
    max, max2, tmp : longint;
begin
  cy:=field[1, 1]; ce:=field[N, M];

  max:=-1; maxi:=0;
  for i:=1 to 6 do begin
    if (i=cy) or (i=ce) then continue;

    if maxi=0 then maxi:=i;

    tempfield:=field;
    DFSPaint(1, 1, cy, i); tf:=tempfield;

    max2:=-1;
    for j:=1 to 6 do begin
      if (j=ce) or (j=i) then continue;

      tempfield:=tf;
      DFSPaint(N, M, ce, j);
      tmp:=DFSCount(N, M, j);

      if tmp>max2 then begin max2:=tmp; maxj:=j; end;
    end;

    tempfield:=tf; DFSPaint(N, M, ce, maxj); tf:=tempfield;

    for i2:=1 to 6 do begin
      if (i2=i) or (i2=j) then continue;

      tempfield:=tf;
      DFSPaint(1, 1, i, i2);
      tmp:=DFSCount(1, 1, i2);

      if tmp>max then begin max:=tmp; maxi:=i; end;
    end;
  end;

  writeln(maxi);
end;

procedure WriteData;
begin
  close(input);
  close(output);
end;

begin
  randomize;
  ReadData;
  if random(rs)<>0 then Solve1 else Solve2;
  WriteData;
end.
