{$I-,Q-,R-,S-}

program XorEncryption;
const infile = 'xor.in';
      outfile = 'xor.out';
      MAXL = 100000;
      allowed : array[0..255] of byte = (0,0,0,0,0,0,0,0,0,0,1,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,1,1,1,1,0,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0);
var LText : longint;
    LCypher : integer;
    seq, res : array[1..MAXL] of byte;
    cypher : array[1..20] of byte;
    fin, fout : file of byte;

procedure ReadData;
var i : longint;
begin
  assign(fin, infile);
  assign(fout, outfile);
  reset(fin);
  rewrite(fout);

  LText:=filesize(fin);
  for i:=1 to LText do
    read(fin, seq[i]);
end;

function CalcZeroes(shift : integer) : longint;
var i, res : longint;
begin
  res:=0;
  for i:=shift to LText do
    if (seq[i] xor seq[i-shift+1])=0 then inc(res);

  CalcZeroes:=res;
end;

procedure Solve;
var i : integer;
    temp, max, cur : longint;
    ch : byte;
    flag : boolean;
begin
  max:=-1;
  for i:=2 to 21 do begin
    temp:=CalcZeroes(i);
    if temp>max then begin max:=temp; LCypher:=i-1; end;
  end;

  for i:=1 to LCypher do
    for ch:=0 to 255 do begin
      cur:=i; flag:=true;

      while cur<=LText do begin
        if allowed[seq[cur] xor ch]=0 then begin flag:=false; break; end;

        cur:=cur+LCypher;
      end;

      if flag then begin
        cypher[i]:=ch; break;
//        write(chr(ch));
      end;
    end;

  for cur:=1 to LText do
    res[cur]:=seq[cur] xor cypher[(cur-1) mod LCypher+1];

  for cur:=1 to LText do
    write(fout, res[cur]);
end;

procedure WriteData;
begin
  close(fin);
  close(fout);
end;

begin
  ReadData;
  Solve;
  WriteData;
end.
