program Triples;
const infile = 'triples.in';
      outfile = 'triples.out';
      MAXN = 100000;
      MAXP = 1500;
var N : longint;
    p : integer;
    answer : int64;
    a : array[1..MAXN] of longint;
    matches : array[0..MAXP-1, 0..MAXP-2] of longint;
    pow : array[0..MAXP-1, 0..MAXP-2] of integer;
    modp : array[0..MAXP-1] of longint;
    modfip : array[0..MAXP-2] of longint;

procedure CalcPows;
var i : integer;
    j : integer;
begin
  for i:=0 to p-1 do begin
    if i<>0 then pow[i, 0]:=1 else pow[i, 0]:=1;

    for j:=1 to p-2 do
      pow[i, j]:=(longint(i)*longint(pow[i, j-1])) mod p;
  end;
end;

procedure Count;
var i, j, k : integer;
    m1, m2, n2, n3, o3 : int64;
begin
  for i:=1 to p-1 do
    for j:=0 to p-2 do begin
      if (modp[i]=0) or (modfip[j]=0) or (modp[pow[i, j]]=0) then continue;
      k:=pow[i, j];

      if (k=i) then begin
        m1:=matches[i, j]; m2:=modp[i]-m1; n2:=modfip[j]-m1;
        answer:=answer + m2*(m2-1)*(m1+n2) + 2*m1*m2*(m1+n2-1) + m1*(m1-1)*(m1+n2-2);
        continue;
      end;

      m1:=matches[i, j]; m2:=modp[i]-m1; n2:=matches[k, j]; n3:=modfip[j]-m1-n2; o3:=modp[k]-n2;
      answer:=answer + m1*(m1+n3-1)*(n2+o3) + m1*n2*(n2+o3-1) + m2*(m1+n3)*(n2+o3) + m2*n2*(n2+o3-1);
    end;
end;

procedure ReadData;
var i : longint;
begin
  fillchar(matches, sizeof(matches), 0);
  assign(input, infile);
  assign(output, outfile);
  reset(input);
  rewrite(output);

  read(N, p);
  for i:=1 to N do
    read(a[i]);
end;

procedure Solve;
var i : longint;
    nz1, nz2 : longint;
begin
  if p=1 then begin
    answer:=int64(n)*(n-1)*(n-2);
    writeln(answer); exit;
  end;

  CalcPows;
  for i:=1 to N do begin
    inc(modp[a[i] mod p]);
    inc(modfip[a[i] mod (p-1)]);
    inc(matches[a[i] mod p, a[i] mod (p-1)]);
  end;
  nz1:=0; nz2:=0;

  for i:=1 to N do
    if a[i] mod p=0 then begin
      if a[i]=0 then inc(nz1) else inc(nz2);
    end;

  answer:=answer + int64(nz1)*int64(nz1-1)*int64(modp[1]) + int64(nz2)*int64(nz1)*int64(modp[1]);

  answer:=answer + int64(nz1)*int64(N-nz1-nz2)*int64(nz2+nz1-1) + int64(nz1)*int64(nz2)*int64(nz2+nz1-2);

  answer:=answer + int64(nz2)*int64(N-nz1-nz2)*int64(nz1+nz2-1) + int64(nz2)*int64(nz2-1)*int64(nz1+nz2-2);

  Count;
  writeln(answer);
end;

procedure WriteData;
begin
  close(input);
  close(output);
end;

begin
  ReadData;
  Solve;
  WriteData;
end.
