program TheTravellingOfTheLonelyKing;
const infile = 'king.in';
      outfile = 'king.out';
      MAXN = 500;
      MAXP = 2+MAXN*4;
//type longint = longint;
var x, y : array[1..MAXP] of longint;
    d : array[1..MAXP] of longword;
    figx, figy : array[1..MAXN] of longint;
    G : array[1..MAXP, 1..MAXP] of longword;
    mark : array[1..MAXP] of boolean;
    inf : longint;
    N, NP : integer;

function min(a, b : longint) : longint;
begin
  if a<b then min:=a else min:=b;
end;

function max(a, b : longint) : longint;
begin
  if a>b then max:=a else max:=b;
end;

procedure Swap(var a, b : longint);
var t : longint;
begin
  t:=a; a:=b; b:=t;
end;

function FreePoint(x, y : longint) : boolean;
var i : integer;
begin
  for i:=1 to N do
    if (figx[i]=x) and (figy[i]=y) then begin FreePoint:=false; exit; end;

  FreePoint:=true;
end;

function FreeRect(x1, y1, x2, y2 : longint) : boolean;
var xr1, yr1, xr2, yr2 : longint;
    i : integer;
begin
  xr1:=min(x1, x2); yr1:=min(y1, y2);
  xr2:=max(x1, x2); yr2:=max(y1, y2);

  if (yr2-yr1)=(xr2-xr1) then begin FreeRect:=false; exit; end;

  if (yr2-yr1)>(xr2-xr1) then begin
    for i:=1 to N do
      if (figx[i]>=xr1) and (figx[i]<=xr2) and (figy[i]-figx[i]<=yr2-xr2) and
                                               (figy[i]-figx[i]>=yr1-xr1) then
        begin FreeRect:=false; exit; end;
  end else begin
    for i:=1 to N do
      if (figy[i]>=yr1) and (figy[i]<=yr2) and (figy[i]-figx[i]>=yr2-xr2) and
                                               (figy[i]-figx[i]<=yr1-xr1) then
        begin FreeRect:=false; exit; end;
  end;

  FreeRect:=true;
end;

function FreeDiag1(x1, y1, x2, y2 : longint) : boolean;
var xr1, yr1, xr2, yr2 : longint;
    i : integer;
begin
  if (y1-x1)<>(y2-x2) then begin FreeDiag1:=false; exit; end;

  xr1:=min(x1, x2); yr1:=min(y1, y2);
  xr2:=max(x1, x2); yr2:=max(y1, y2);

  for i:=1 to N do
    if ((figy[i]-figx[i])=(y1-x1)) and (figy[i]>=yr1) and (figy[i]<=yr2) and
                                       (figx[i]>=xr1) and (figx[i]<=xr2) then
      begin FreeDiag1:=false; exit; end;

  FreeDiag1:=true;
end;

function FreeDiag2(x1, y1, x2, y2 : longint) : boolean;
var xr1, yr1, xr2, yr2 : longint;
    i : integer;
begin
  if (y1+x1)<>(y2+x2) then begin FreeDiag2:=false; exit; end;

  xr1:=max(x1, x2); yr1:=min(y1, y2);
  xr2:=min(x1, x2); yr2:=max(y1, y2);

  for i:=1 to N do
    if ((figy[i]+figx[i])=(y1+x1)) and (figy[i]>=yr1) and (figy[i]<=yr2) and
                                       (figx[i]<=xr1) and (figx[i]>=xr2) then
      begin FreeDiag2:=false; exit; end;

  FreeDiag2:=true;
end;

procedure ReadData;
var xs, ys, xt, yt : longint;
    i : integer;
    mx, my : integer;
    b : boolean;
begin
  assign(input, infile);
  assign(output, outfile);
  reset(input);
  rewrite(output);

  read(xs, ys, xt, yt);

  NP:=2; x[1]:=0; y[1]:=0; x[2]:=xt-xs; y[2]:=yt-ys;
  if x[2]<0 then mx:=1 else mx:=1;
  if y[2]<0 then my:=1 else my:=1;

  x[2]:=x[2]*mx; y[2]:=y[2]*my;
{
  if y[2]>x[2] then b:=true else b:=false;

  if b then Swap(x[2], y[2]);}

  read(N);
  for i:=1 to N do begin
    read(figx[i], figy[i]);

    figx[i]:=(figx[i]-xs)*mx; figy[i]:=(figy[i]-ys)*my;
//    if b then Swap(figx[i], figy[i]);
  end;
end;

procedure Solve;
var i, j, minj : integer;
    min : longint;
begin
  inf:=2100000000;

  for i:=1 to N do begin
    if FreePoint(figx[i], figy[i]-1) then begin
      inc(NP); x[NP]:=figx[i]; y[NP]:=figy[i]-1;
    end;
{}
    if FreePoint(figx[i]-1, figy[i]) then begin
      inc(NP); x[NP]:=figx[i]-1; y[NP]:=figy[i];
    end;
{}
    if FreePoint(figx[i], figy[i]+1) then begin
      inc(NP); x[NP]:=figx[i]; y[NP]:=figy[i]+1;
    end;
{}
    if FreePoint(figx[i]+1, figy[i]) then begin
      inc(NP); x[NP]:=figx[i]+1; y[NP]:=figy[i];
    end;
  end;

  for i:=1 to NP do
    for j:=1 to NP do begin
      G[i, j]:=inf;
{}
      if (x[i]=x[j]) and (y[i]=y[j]) then begin G[i, j]:=0; continue; end;
{}
      if FreeDiag1(x[i], y[i], x[j], y[j]) then begin G[i, j]:=abs(x[i]-x[j]); continue; end;
{}
      if FreeDiag2(x[i], y[i], x[j], y[j]) then begin G[i, j]:=abs(x[i]-x[j]); continue; end;
{}
      if FreeRect(x[i], y[i], x[j], y[j]) then begin G[i, j]:=max(abs(x[i]-x[j]), abs(y[i]-y[j])); continue; end;
    end;

  for i:=1 to NP do
    d[i]:=inf;
  d[1]:=0;

  fillchar(mark, sizeof(mark), false);
  for i:=1 to NP do begin
    min:=inf;

    for j:=1 to NP do
      if (not mark[j]) and (min>d[j]) then begin min:=d[j]; minj:=j; end;
    if min=inf then break;
    if minj=2 then break;
    mark[minj]:=true;

    for j:=1 to NP do
      if (not mark[j]) and (d[minj]+G[minj, j]<d[j]) then
        d[j]:=d[minj]+G[minj, j];
  end;

  if d[2]=inf then writeln(-1) else writeln(d[2]);
end;

procedure WriteData;
begin
  close(input);
  close(output);
end;

begin
  ReadData;
  Solve;
  WriteData;
end.
