{$I-,Q-,R-,S-}
program Formation;
const infile = 'form.in';
      outfile = 'form.out';
      MAXN = 100000;
      MAXK = 11;
//type int64 = longint;
var sum : array[1..MAXN, 1..MAXK] of int64;
    a : array[1..MAXN] of longint;
    h : array[1..MAXN] of longint;
    N : longint;
    K : integer;

procedure CalcHeight;
var i : longint;
begin
  for i:=1 to MAXN do
    h[i]:=(i xor (i-1)+1) shr 1;
end;

function RSQGet(i0 : longint; j0 : integer) : int64;
var res : int64;
begin
  res:=0;
  while i0>0 do begin
    res:=res+sum[i0, j0];

    dec(i0, h[i0]);
  end;
  RSQGet:=res;
end;

procedure RSQUpdate(i0 : longint; j0 : integer; delta : int64);
begin
  while i0<=N do begin
    sum[i0, j0]:=sum[i0, j0]+delta;

    inc(i0, h[i0]);
  end;
end;

procedure ReadData;
var i : longint;
begin
  assign(input, infile);
  assign(output, outfile);
  reset(input);
  rewrite(output);

  read(N, K); inc(K);
  for i:=1 to N do
    read(a[i]);
end;

procedure Solve;
var i : longint;
    j : integer;
begin
  fillchar(sum, sizeof(sum), 0);
  CalcHeight;

  for i:=1 to N do
    for j:=1 to K do begin
      if j=1 then begin RSQUpdate(a[i], j, 1); continue; end;

      RSQUpdate(a[i], j, RSQGet(a[i]-1, j-1));
    end;

  writeln(RSQGet(N, K));
end;

procedure WriteData;
begin
  close(input);
  close(output);
end;

begin
  ReadData;
  Solve;
  WriteData;
end.
