{$M 10000000,10000000}

program Psyche;
const infile = 'psyche.in';
      outfile = 'psyche.out';
var n, k : int64;

procedure ReadData;
begin
  assign(input, infile);
  assign(output, outfile);
  reset(input);
  rewrite(output);
  read(n, k);
end;

function Run(nmb, start, step : int64) : int64;
var p, q, temp, last, r : int64;
begin
  if nmb=1 then begin Run:=1; exit; end;
  if start>nmb then start:=(start-1) mod nmb+1;
  if start+step>nmb then begin
    temp:=Run(nmb-1, step-nmb+start, step);
    if temp<start then Run:=temp else Run:=temp+1;
    exit;
  end;

  r:=(nmb-start) div step+1; last:=start+(r-1)*step;
  temp:=Run(nmb-r, step-nmb+last, step);
  if temp<start then begin Run:=temp; exit; end;
  p:=temp-start+1; q:=p div (step-1)+ord(p mod (step-1)<>0);
  Run:=temp+q;
end;

procedure Solve;
begin
  if k=1 then writeln(n) else writeln(Run(n, k, k));
end;

procedure WriteData;
begin
  close(input);
  close(output);
end;

begin
  ReadData;
  Solve;
  WriteData;
end.
