{$I-,Q-,R-,S-}

program ExcitingGame;
const infile = 'game.in';
      outfile = 'game.out';
      MAXN = 150;
      MAXL = 150;
var seq : array[1..MAXN] of char;
    A : array[1..MAXN, 1..MAXN, 'A'..'Z'] of boolean;
    rules : array[1..MAXN] of string[MAXL];
    trivial : array[1..MAXN] of char;
    resrules : array[1..MAXN] of char;
    restrivial : array[1..MAXN] of char;
    N, NT, SeqLen : integer;

procedure ReadData;
var i, Np : integer;
    temp : string;

function GetWord : string;
var ch : char;
    res : string;
begin
  res:='';
  while true do begin
    read(ch); if ch=' ' then break;
    res:=res+ch;
  end;
  GetWord:=res;
end;

begin
  assign(input, infile);
  assign(output, outfile);
  reset(input);
  rewrite(output);

  SeqLen:=0;
  while not eoln(input) do begin
    inc(SeqLen); read(seq[SeqLen]);
  end;

  readln;
  readln(Np); N:=0; NT:=0;

  for i:=1 to Np do begin
    temp:=GetWord;

    if length(temp)>1 then begin
      inc(N);
      rules[N]:=temp;
      readln(resrules[N]);
    end else begin
      inc(NT);
      trivial[NT]:=temp[1];
      readln(restrivial[NT]);
    end;
  end;
end;

function GetA(i, j, k : integer) : boolean;
var temp : array[1..MAXL, 1..MAXL] of integer;

function run(start, pos : integer) : integer;
var i : integer;
begin
  if (j-start<length(rules[k])-pos) then begin
    run:=0; exit;
  end;

  if (pos>length(rules[k])) then begin
    if (start>j) then run:=1 else run:=0;
    exit;
  end;

  if temp[start, pos]<>-1 then begin run:=temp[start, pos]; exit; end;

  temp[start, pos]:=0;

  for i:=start to j do
    if (A[start, i, rules[k][pos]]) and (run(i+1, pos+1)=1) then begin
      temp[start, pos]:=1; run:=1; exit;
    end;

  run:=0;
end;

begin
  fillchar(temp, sizeof(temp), 255);
  GetA:=(run(i, 1)=1);
end;

procedure Solve;
var i, l, k : integer;
    ch : char;
begin
  fillchar(A, sizeof(A), false);
  if SeqLen=1 then A[1, 1, seq[1]]:=true;

  for i:=1 to SeqLen do
    A[i, i, seq[i]]:=true;

  for l:=1 to SeqLen do
    for i:=1 to SeqLen-l+1 do begin
      for k:=1 to N do
        if (not A[i, i+l-1, resrules[k]]) and (GetA(i, i+l-1, k)) then
          A[i, i+l-1, resrules[k]]:=true;

      for k:=1 to NT do
        if (not A[i, i+l-1, restrivial[k]]) and (A[i, i+l-1, trivial[k]]) then
          A[i, i+l-1, restrivial[k]]:=true;
    end;

  for ch:='A' to 'Z' do
    if A[1, SeqLen, ch] then write(ch);
  writeln;
end;

procedure WriteData;
begin
  close(input);
  close(output);
end;

begin
  ReadData;
  Solve;
  WriteData;
end.
