program Commas;
const infile = 'commas.in';
      outfile = 'commas.out';
      MAXN = 1000;
var SeqLen, NZ : integer;
    seq : array[1..MAXN] of char;
    from, res : array[1..MAXN, 1..MAXN] of integer;
    temp : array[1..MAXN, 1..MAXN] of boolean;
    best : array[1..MAXN] of boolean;

function CompareDumb(l1, r1, l2, r2 : integer) : integer;
var i : integer;
begin
  while (l1<r1) and (seq[l1]='0') do inc(l1);
  while (l2<r2) and (seq[l2]='0') do inc(l2);

  if (r1-l1<r2-l2) then begin
    CompareDumb:=-1; exit;
  end;

  if (r1-l1>r2-l2) then begin
    CompareDumb:=1; exit;
  end;

  for i:=0 to r1-l1 do begin
    if (seq[l1+i]>seq[l2+i]) then begin CompareDumb:=1; exit; end;
    if (seq[l1+i]<seq[l2+i]) then begin CompareDumb:=-1; exit; end;
  end;

  CompareDumb:=0;
end;

function Compare(l, m, r : integer) : integer;
begin
  if m<=res[l, r] then Compare:=-1 else Compare:=1;
end;

procedure ReadData;
begin
  assign(input, infile);
  assign(output, outfile);
  reset(input);
  rewrite(output);

  SeqLen:=0; NZ:=0;
  while not eoln(input) do begin
    inc(SeqLen); read(seq[Seqlen]);
    if (SeqLen=1) and (seq[SeqLen]='0') then begin inc(NZ); dec(SeqLen); end;
  end;
end;

procedure Search(l1, r1 : integer);
var l, r, m : integer;
begin
  if CompareDumb(l1, l1, l1+1, r1)<>-1 then begin res[l1, r1]:=-1; exit; end;

  l:=l1; r:=r1;
  while l<r do begin
    m:=(l+r) shr 1+(l+r) and 1;

    if CompareDumb(l1, m, m+1, r1)=-1 then l:=m else r:=m-1;
  end;
  res[l1, r1]:=l;
end;

procedure Solve;
var i, j, k : integer;
begin
  fillchar(temp, sizeof(temp), false);
  fillchar(from, sizeof(from), 0);
  fillchar(best, sizeof(best), false);

  for i:=1 to SeqLen do
    for j:=i to SeqLen do
      Search(i, j);

  for i:=1 to SeqLen do
    temp[1, i]:=true;

  for i:=1 to SeqLen do
    for j:=2 to i do
      for k:=1 to j-1 do
        if (temp[k, j-1]) and (Compare(k, j-1, i)=-1) then begin
          temp[j, i]:=true; from[j, i]:=k;  break;
        end;

  for k:=SeqLen downto 1 do
    if temp[k, SeqLen] then break;

  i:=k; j:=SeqLen;
  while (i<>0) do begin
    best[j]:=true;
    k:=from[i, j]; j:=i-1; i:=k;
  end;
  best[SeqLen]:=false;

  for i:=1 to NZ do
    write('0');

  for i:=1 to SeqLen do begin
    write(seq[i]);
    if best[i] then write(',');
  end;

  writeln;
end;

procedure WriteData;
begin
  close(input);
  close(output);
end;

begin
  ReadData;
  Solve;
  WriteData;
end.
