#include <stdio.h>
#include <math.h>

#define m 100
#define inf 1e12

double x[m], y[m], d[m];
int mark[m];

double sq( double x )
{
  return x * x;
}

int main( void )
{
  int n, i, j, w;
  double u, v;

  freopen("tractor.in", "r", stdin);
  freopen("tractor.out", "w", stdout);
  scanf("%d%lf%lf", &n, &u, &v);
  for (i = 1; i <= n + 1; i++)
    scanf("%lf%lf", &x[i], &y[i]);
  for (i = 2; i <= n + 1; i++)
    d[i] = inf;
  for (i = 1; i <= n + 1; i++)
  {
    for (w = 0, j = 1; j <= n + 1; j++)
      if (!mark[j] && (w == 0 || d[w] > d[j]))
        w = j;
    mark[w] = 1;
    for (j = 1; j <= n + 1; j++)
    {
      double t = sqrt(sq(x[w] - x[j]) + sq(y[w] - y[j])) / u;

      if (mark[j])
        continue;
      if (d[j] > d[w] + t)
        d[j] = d[w] + t;
    }
    if (w != n + 1 && !mark[w + 1])
    {
      double t = sqrt(sq(x[w] - x[w + 1]) + sq(y[w] - y[w + 1])) / v;

      if (d[w + 1] > d[w] + t)
        d[w + 1] = d[w] + t;
    }
    if (w != 1 && !mark[w - 1])
    {
      double t = sqrt(sq(x[w] - x[w - 1]) + sq(y[w] - y[w - 1])) / v;

      if (d[w - 1] > d[w] + t)
        d[w - 1] = d[w] + t;
    }
  }
  printf("%lf\n", d[n + 1]);
  return 0;
}
