#include <stdio.h>

#define w 45
#define h 41
#define m 100

int a[m][m], p[m * m], c, hh[m * m], r[m * m * 4], next[m * m * 4], rr,
    col[m][m], mark[m * m], d[m * m], d1[m * m], sum[m * m], q[m * m],
    s[m * m], _stklen = 4 * 1024 * 1024, cur, cc[m * m],
    sum1[m * m];

void add( int x, int y )
{
  if (x == 0 || y == 0 || x == y)
    return;
  r[++rr] = y;
  next[rr] = hh[x];
  hh[x] = rr;
}

void dfs( int i, int j )
{
  if (col[i][j] || i < 1 || j < 1 || i > h || j > w || a[i][j] != cur)
    return;
  col[i][j] = c;
  s[c]++;
  dfs(i + 1, j);
  dfs(i - 1, j);
  dfs(i, j - 1);
  dfs(i, j + 1);
}

void bfs( int v )
{
  int i, l = 1, j, t;

  for (i = 1; i <= c; i++)
    mark[i] = 0;
  q[l] = v;
  mark[v] = 1;
  d[v] = p[v] = 0;
  for (i = 1; i <= l; i++)
    for (j = hh[q[i]]; j != 0; j = next[j])
    {
      if (r[j] != 2 && v == 1)
        t = 1;
      if (!mark[r[j]] && (v != 1 || cc[r[j]] != a[h][w])
          && (v == 1 || cc[r[j]] != a[1][1]))
      {
        mark[r[j]] = 1;
        q[++l] = r[j];
        d[r[j]] = d[q[i]] + 1;
        p[r[j]] = q[i];
      }
    }
}

int main( void )
{
  int i, j, bi;

  freopen("filya.in", "r", stdin);
  freopen("filya.out", "w", stdout);
  for (i = 1; i <= h; i++)
    for (j = 1; j <= w; j++)
    {
      char c;
    
      scanf(" %c", &c);
      a[i][j] = c - '0';
    }
  for (i = 1; i <= h; i++)
    for (j = 1; j <= w; j++)
      if (!col[i][j])
      {
        c++;
        cc[c] = cur = a[i][j];
        dfs(i, j);
      }
  for (i = 1; i <= h; i++)
    for (j = 1; j <= w; j++)
    {
      add(col[i - 1][j], col[i][j]);
      add(col[i + 1][j], col[i][j]);
      add(col[i][j - 1], col[i][j]);
      add(col[i][j + 1], col[i][j]);
    }
  bfs(col[h][w]);
  for (i = 1; i <= c; i++)
    d1[i] = d[i];
  bfs(1);
  for (i = 1; i <= c; i++)
    d1[i] -= d[i];
  for (bi = 0, i = 2; i <= c; i++)
  {
    sum[i] = s[i] + d1[i] * 3;
    /*if (j > i)
      sum[i] += (j - i) * 50;
    else
      sum[i] += (i - j) * 50;*/
  }
  for (i = 1; i <= c; i++)
    sum1[i] = -1000000;
  for (i = 1; i <= h; i++)
    for (j = 1; j <= w; j++)
    {
      int k = 0;
    
      if (j > i)
        k = -(j - i) * 5;
      else
        k = -(i - j) * 5;
      if (sum1[col[i][j]] < k + sum[col[i][j]])
        sum1[col[i][j]] = k + sum[col[i][j]];
    }
  for (i = 2; i <= c; i++)
    if ((d1[i] <= 0 && (bi == 0 || sum[bi] < sum[i]) && cc[i] != a[h][w])
        && mark[i])
      bi = i;
  if (bi == 0)
  {
    for (i = 1; i < 6; i++)
      if (i != a[1][1] && i != a[h][w])
        break;
    printf("%d\n", i);
    return 0;
  }
  for (; p[bi] != 1; bi = p[bi])
    ;
  for (i = 1; i <= h; i++)
    for (j = 1; j <= w; j++)
      if (col[i][j] == bi)
      {
        printf("%d\n", a[i][j]);
        return 0;
      }
  return 0;
}
