{$I trans.inc}
uses testjury;
type integer=longint;
const MaxN=600;
      MaxLL=600;
      MaxL=600;
      MaxSL=255;
      Base=1000000000;
      InvBase=1/Base;
      eps=1e-14;
      Digits=9;

type long=array [0..MaxLL] of integer;


procedure add (var a, b, c:long);
var i, cy, z:integer;
begin
  cy:=0;
  z:=max (b[0], c[0]);
  for i:=1 to z do begin
    inc (cy, b[i]+c[i]);
    if cy>=Base then begin a[i]:=cy-Base; cy:=1 end
    		else begin a[i]:=cy;	  cy:=0 end;
  end;
  if cy>0 then begin a[0]:=z+1; a[z+1]:=cy end
  	  else a[0]:=z;
end;


procedure muls (var a, b:long; s:comp);
var i, z:integer;
    cy, tmp:comp;
begin
  {if s=0 then a[0]:=0 else}
  if s=1 then a:=b else begin
    cy:=0;
    z:=b[0];
    for i:=1 to z do begin
      cy:=cy+b[i]*s;
      tmp:=int (cy*InvBase+eps);
      a[i]:=round (cy-tmp*Base); cy:=tmp;
    end;
    if cy>0 then begin
      a[0]:=z+1; a[z+1]:=round (cy) end
    	  else a[0]:=z;
  end;
end;


procedure writel (var a:long);
var s:string;
    i, j:integer;
begin
  write (a[a[0]]);
  for i:=a[0]-1 downto 1 do begin
    str (a[i], s); for j:=1 to Digits-length (s) do write ('0'); write (s);
  end;
  writeln;
end;

var i, j, l, n, cnt:integer;
    c:array [1..MaxSL] of integer;
    z:array [0..MaxL] of long;
    tmp:long;
    s:string;


begin
  ci ('jaina.in'); ao ('jaina.out');
  noeoln; n:=getintr (1, MaxN); reql (Reject);
  for i:=1 to n do begin
    s:=readstring;
    test ((length (s)>0) and (length (s)<=MaxSL));
    cnt:=0;
    for j:=1 to length (s) do begin
      test (s[j] in [#32..#126]);
      if s[j]<>#32 then inc (cnt);
    end;
    inc (c[cnt]);
  end;
  noeoln; l:=getintr (1, MaxL); reql (Reject);
  reqeof;
  z[0, 0]:=1; z[0, 1]:=1;
  for i:=0 to l-1 do
    for j:=1 to 255 do
      if (c[j]>0) and (i+j<=l) then begin
        fillchar (tmp, sizeof (tmp), 0);
        muls (tmp, z[i], c[j]);
        add (z[i+j], z[i+j], tmp);
      end;
  writel (z[l]);
end.