{$Q-,R-,S-,O+}
program macro;
const MaxN=50000; MaxM=50000; MaxX=999; Cst=2048; Pr=533543; Undef=$7f7f7f7f;
type
  PNode = ^Node;
  Node = array [1..4] of PNode;
  prec = record x, y, xt, yt : integer end;
  iarr = array [1..4] of integer;
const dx:iarr = (-1,1,-1,1);  dy:iarr=(-1,-1,1,1);
var
  Root : PNode;

procedure addit (P : PNode; x, y, s : integer);
var k : integer; Q : PNode;
begin
  repeat
    if s = 0 then exit;
    k := 1;
    if x < 0 then inc (x, s) else begin dec (x, s); inc (k) end;
    if y < 0 then inc (y, s) else begin dec (y, s); inc (k, 2) end;
    Q := P^[k];
    if Q = nil then begin new(Q); fillchar(Q^,sizeof(Node),0); P^[k]:=Q end;
    P := Q;  s := s shr 1
  until s = 0;
end;

var
  H : array [0..Pr-1] of prec;

function hash (x, y : integer; Add : boolean) : integer;
var h1, h2 : integer;
begin
  h1 := (239*x+17*y) mod Pr;  if h1 < 0 then inc (h1, Pr);
  h2 := 0;
  repeat
    if H[h1].x = Undef then begin
      if not Add then h1 := -1 else begin H[h1].x:=x; H[h1].y:=y end;
      hash := h1;  exit end;
    if (H[h1].x = x) and (H[h1].y = y) then begin hash := h1;  exit end;
    if h2 = 0 then begin
      h2 := (13*x+95*y) mod (Pr-1);  if h2 < 0 then inc (h2, Pr) else inc (h2);
    end;
    inc (h1, h2);  if h1 >= Pr then dec (h1, Pr)
  until false
end;

var x, y, bx, by, bd : integer;

procedure tryit (xt, yt : integer);
var d : integer;
begin
  d := sqr(x - xt) + sqr(y - yt);
  if d < bd then begin bd := d;  bx := xt;  by := yt end
end;

procedure search (P : PNode; xc, yc, s : integer);
var
  ux, uy, t, i, k : integer;
  V  : array [1..4] of integer;
begin
  if P = nil then exit;
  if s = 0 then begin tryit (xc, yc); exit end;
  ux := abs (x - xc);  uy := abs (y - yc);
  dec (ux, 2*s-1);  if ux < 0 then ux := 0;
  dec (uy, 2*s-1);  if uy < 0 then uy := 0;
  if sqr(ux) + sqr(uy) >= bd then exit;
  ux := x - xc;  uy := y - yc;
  if (ux > 0) and (uy > 0) then begin V[1]:=4; V[2]:=2; V[3]:=3; V[4]:=1 end;
  if (ux > 0) and (uy <=0) then begin V[1]:=2; V[2]:=4; V[3]:=1; V[4]:=3 end;
  if (ux <=0) and (uy > 0) then begin V[1]:=3; V[2]:=1; V[3]:=4; V[4]:=2 end;
  if (ux <=0) and (uy <=0) then begin V[1]:=1; V[2]:=3; V[3]:=2; V[4]:=4 end;
  if abs(ux) < abs(uy) then begin t:=V[2]; V[2]:=V[3]; V[3]:=t end;
  for i := 1 to 4 do begin
    k := V[i];
    search (P^[k], xc+s*dx[k], yc+s*dy[k], s shr 1)
  end
end;

procedure hashtry (x, y : integer);
var k : integer;
begin
  k := hash (x, y, false);
  if k >= 0 then tryit (H[k].xt, H[k].yt)
end;

function f (x : integer) : integer;
begin f := (x + $20000000) shr 1 - $10000000 end;

var N, M, i, j, k : integer;
begin
  assign (input, 'nearest.in');  reset (input);
  assign (output, 'nearest.out');  rewrite (output);
  read (N, M);
  if (N <= 0) or (N > MaxN) or (M <= 0) or (M > MaxM) then runerror (239);
  new (Root);  fillchar (Root^, sizeof(Node), 0);
  fillchar (H, sizeof(H), $7f);
  for i := 1 to N do begin
    read (x, y);
    if (abs(x) > MaxX) or (abs(y) > MaxX) then runerror (239);
    x := 2*x+1;  y := 2*y+1;
    addit (Root, x, y, Cst)
  end;
  for i := 1 to M do begin
    read (x, y);
    if (abs(x) > MaxX) or (abs(y) > MaxX) then runerror (239);
    x := 2*x+1;  y := 2*y+1;
    bx := Undef;  by := Undef;  bd := MaxLongInt;
    hashtry (x, y);
    if bx = Undef then begin
      for j := -2 to 2 do
        for k := -2 to 2 do hashtry (x+j, y+k);
      search (Root, 0, 0, Cst);
      k := hash (x, y, true);
      H[k].xt := bx;  H[k].yt := by
    end;
    writeln (f(bx), ' ', f(by));
  end
end.
