{$Q+,R+,S+,O-}
{$APPTYPE CONSOLE}
program macro;
const MaxN=50;
type Diagr = array [0..MaxN+1] of integer;
var
  A, B, C : Diagr;
  Ac, Bc, Cc : integer;
  Q, R       : array [0..MaxN,0..MaxN] of integer;
  X          : array [1..MaxN,1..MaxN] of integer;
  ci, cj, ck :integer;
  total : longint;
{
procedure printtab;
var i, j : integer;
begin
  for i := 1 to C[0] do begin
    for j := 1 to C[i]-1 do write (X[i,j], ' ');
    writeln (X[i,C[i]])
  end;
  writeln
end;
}
procedure fill_line; forward;

procedure fill_row;
var j, t, u : integer;
begin
{  if cj >= C[ci] then begin
    for j := ck to B[0] do begin Q[ci,j]:=Q[ci-1,j]; R[ci,j]:=R[ci-1,j] end;
    fill_line;
    exit
  end;}
  if ck > B[0] then begin
    if cj > C[ci] then runerror (239);
    if cj = C[ci] then fill_line;
    exit;
  end;
  t := Q[ci-1,ck] - 1;  if t > C[ci] then t := C[ci];
  dec (t, cj);
  u := R[ci-1,ck-1];  if u > B[ck] then u := B[ck];
  dec (u, R[ci-1,ck]);
  if u < 0 then exit;
  if t > u then t := u;
  Q[ci,ck]:=Q[ci-1,ck];  R[ci,ck]:=R[ci-1,ck];
  if cj < C[ci] then Q[ci, ck] := cj+1;
  inc (ck);
  fill_row;
  if t > 0 then begin
    for j := 1 to t do begin
      inc (cj);  X[ci,cj] := ck-1;  inc(R[ci,ck-1]);
      fill_row
    end;
    dec (cj, t)
  end;
  dec (ck)
end;

procedure fill_line;
var tk : integer;
begin
  if ci>=c[0] then begin
{    printtab;}
    inc (total); exit
  end;
  inc (ci);  tk := ck;
  cj := A[ci];  ck := 1;
  fill_row;
  dec (ci);  cj := C[ci];  ck := tk
end;

function calc : longint;
var i:integer;
begin
  calc := 0;
  if Ac + Bc <> Cc then exit;
  for i := 1 to C[0] do
    if (A[i] > C[i]) or (B[i] > C[i]) then exit;
  for i := 1 to B[0] do Q[0, i] := C[i]+1;
  for i := 1 to B[0] do R[0, i] := 0;
  for i := 0 to C[0] do R[i, 0] := MaxInt;
  ci := 0;  total := 0;
  fillchar (X, sizeof(X), 0);
  fill_line;
  calc := total
end;

function read_diagr (var A : Diagr; x : integer) : integer;
var i, Ac : integer;
begin
  fillchar(A, sizeof(A), 0);
  Ac := 0;  i := 0;
  repeat
    if x < 0 then read (x);
    if (x < 0) or (x > MaxN) then runerror (239);
    Ac := Ac + x;  if Ac > MaxN then runerror (239);
    inc (i);  A[i] := x;  x := -x;
  until x = 0;
  A[0] := i - 1;
{  if Ac = 0 then runerror (239);}
  read_diagr := Ac;
end;

var t, _ : integer;
begin
  assign (input, 'young.in');  reset (input);
  assign (output, 'young.out');  rewrite (output);
  _ := 0;
  repeat
    read (t);
    if t = -1 then halt;
    if t < 0 then runerror (239);
    Ac := read_diagr (A, t);
    Bc := read_diagr (B, -1);
    Cc := read_diagr (C, -1);
    if Cc > MaxN then runerror (239);
    inc (_);
    writeln (calc);
  until seekeof;
  runerror (239);
end.