{$O-,Q+,R+}
uses SysUtils;

const MaxN=20000;
      MaxC=10000;


function less2 (x1, y1, x2, y2:integer):boolean;
begin
  Result:=x1*y2-x2*y1<0;
end;

function less (x1, y1, x2, y2:integer):boolean;
var det:integer;
begin
  det:=x1*y2-x2*y1;
  Result:=(det<0) or (det=0) and (sqr (x1)+sqr (y1)<sqr (x2)+sqr (y2));
end;

var x, y:array [1..MaxN] of integer;


procedure qsort (l, r:integer);
var i, j, xx, xy, t:integer;
begin
  if l>=r then exit;
  i:=l; j:=r; xx:=x[(l+r) shr 1]; xy:=y[(l+r) shr 1];
  repeat
    while less (x[i], y[i], xx, xy) do inc (i);
    while less (xx, xy, x[j], y[j]) do dec (j);
    if i<=j then begin
      t:=x[i]; x[i]:=x[j]; x[j]:=t;
      t:=y[i]; y[i]:=y[j]; y[j]:=t;
      inc (i); dec (j)
    end;
  until i>j;
  qsort (l, j);
  qsort (i, r);
end;


var i, j, i1, t, n, x1, y1, c:integer;
    xn, yn:array [1..MaxN] of integer;
    f, orient:boolean;

begin
  assign (input, 'convex.in'); reset (input);
  assign (output, 'convex.out'); rewrite (output);
  assert (not seekeoln); read (n); assert ((n>=1) and (n<=MaxN));
  assert (seekeoln); readln;
  x1:=maxint; y1:=maxint; i1:=-1;
  for i:=1 to n do begin
    assert (not seekeoln); read (x[i]); assert (abs (x[i])<=MaxC);
    assert (not seekeoln); read (y[i]); assert (abs (y[i])<=MaxC);
    assert (seekeoln and not eof); readln;
    if (x[i]<x1) or (x[i]=x1) and (y[i]<y1) then begin
      x1:=x[i]; y1:=y[i]; i1:=i;
    end;
  end;
  assert (eof);
  f:=true;
  for i:=1 to n do
    if (x[i]<>x1) or (y[i]<>y1) then f:=false;
  if f then begin writeln (1); writeln (x1, ' ', y1); halt end;
  for i:=1 to n do begin dec (x[i], x1); dec (y[i], y1) end;
  t:=x[i1]; x[i1]:=x[1]; x[1]:=t;
  t:=y[i1]; y[i1]:=y[1]; y[1]:=t;
  qsort (2, n);
  xn[1]:=x[1]; yn[1]:=y[1]; 
  xn[2]:=x[2]; yn[2]:=y[2];
  c:=2;
  for i:=3 to n do begin
    inc (c); xn[c]:=x[i]; yn[c]:=y[i]; 
    while (c>2) and 
      not less2 (xn[c-1]-xn[c-2], yn[c-1]-yn[c-2], xn[c]-xn[c-1], yn[c]-yn[c-1]) do
      begin
        xn[c-1]:=xn[c]; yn[c-1]:=yn[c]; dec (c);
      end;
  end;
  while (c>2) and
    not less2 (xn[c]-xn[c-1], yn[c]-yn[c-1], xn[1]-xn[c], yn[1]-yn[c]) do
      dec (c);
  writeln (c);
  orient:=((xn[2]-xn[1])*(yn[3]-yn[2])-(xn[3]-xn[2])*(yn[2]-yn[1])>0) xor odd (n);
  if orient then
    for i:=1 to c do writeln (xn[i]+x1, ' ', yn[i]+y1)
  else
    for i:=c downto 1 do writeln (xn[i]+x1, ' ', yn[i]+y1);
end.