{$O-,Q+,R+}
uses SysUtils;

const MaxCols=100;
      MaxLines=100;
      MaxLen=250;

var s:array [1..MaxLines, 1..MaxCols] of string;
    m:array [1..MaxCols] of integer;
    f:string;

procedure displayheader;
var i, j:integer;
begin
  for i:=1 to length (f) do begin
    write ('+');
    for j:=1 to m[i]+2 do write ('-');
  end;
  writeln ('+');
end;

procedure displayline (x:integer);
var i, j:integer;
begin
  for i:=1 to length (f) do begin
    write ('| ');
    case f[i] of
      'l':begin write (s[x, i]); for j:=1 to m[i]-length (s[x, i]) do write (' ') end;
      'r':begin for j:=1 to m[i]-length (s[x, i]) do write (' '); write (s[x, i]) end;
      'c':begin
            for j:=1 to (m[i]-length (s[x, i])) shr 1 do write (' ');
            write (s[x, i]);
            for j:=1 to (m[i]-length (s[x, i])+1) shr 1 do write (' ');
          end;
    end;
    write (' ');
  end;
  writeln ('|');
end;

var i, cols, lines, p:integer;
    c:string;
    found:boolean;

begin
  assign (input, 'formatting.in'); reset (input);
  assign (output, 'formatting.out'); rewrite (output);
  readln (f);
  for i:=1 to length (f) do assert (f[i] in ['l', 'c', 'r']);
  assert ((length (f)>0) and (length (f)<=MaxCols));
  lines:=0; assert (not eof);
  repeat
    inc (lines);
    assert (lines<=MaxLines);
    readln (c); assert (length (c)<=MaxLen);
    cols:=0; found:=true;
    while found do begin
      inc (cols);
      assert (cols<=length (f));
      p:=pos ('&', c); found:=p>0; if p=0 then p:=length (c)+1;
      s[lines, cols]:=copy (c, 1, p-1);
      for i:=1 to length (s[lines, cols]) do assert (s[lines, cols, i] in [#32..#126]-['&']);
      if p-1>m[cols] then m[cols]:=p-1;
      c:=copy (c, p+1, length (c));
    end;
    //writeln (lines, ' ', cols);
    assert (cols=length (f));
  until eof;
  displayheader;
  displayline (1);
  displayheader;
  for i:=2 to lines do displayline (i);
  displayheader;
end.