{$Q-,R-,I-,S-,D-,L-,N+}
Program Programs;
Type
  Int=Longint;
  Real=Extended;
  TLong=Array[0..300] Of Int;
Const
  FileIn='programs.in';
  FileOut='programs.out';
  Base=1000000;
  LenBase=6;
  MaxN=601;
  MaxM=601;
Var
  N,M:Int;
  Len:Array[0..MaxM] Of Int;
  Am:Array[0..MaxM] Of Int;
  A:Array[0..MaxN] Of TLong;
  B:Array[0..MaxM] Of Int;

Procedure OpenFiles;
  Begin
    Assign(Input,FileIn);
    Assign(Output,FileOut);
    Reset(Input);
    Rewrite(Output);
  End;

Procedure Init;
  Var i:Int;
      s:String;
  Begin
    Read(M);
    For i:=1 To M Do
      Begin
        Readln;
        Read(s);B[i]:=Length(s);
      End;
    Read(N);
  End;

Procedure Swap(Var x,y:Int);
  Var t:Int;
  Begin
    t:=x;x:=y;y:=t;
  End;

Procedure QSort(l,r:Int);
  Var i,j,t:Int;
  Begin
    i:=l;j:=r;t:=B[l+Random(r-l+1)];
    Repeat
      While B[i]<t Do Inc(i);
      While B[j]>t Do Dec(j);
      If i<=j Then
        Begin
          Swap(B[i],B[j]);Inc(i);Dec(j);
        End;
      Until i>j;
    If i<r Then QSort(i,r);
    If l<j Then QSort(l,j);
  End;

Procedure Mult(Const x:TLong;Const y:Int;Var res:TLong);
  Var i,d:Int;
  Begin
    d:=0;
    For i:=1 To x[0] Do
      Begin
        res[i]:=x[i]*y+d;
        d:=res[i] Div Base;
        res[i]:=res[i] Mod Base;
      End;
    res[0]:=x[0];
    While d>0 Do
      Begin
        Inc(res[0]);res[res[0]]:=d Mod Base;d:=d Div Base;
      End;
  End;

Procedure Sum(Var x:TLong;Const y:TLong);
  Var i,d:Int;
  Begin
    If x[0]>=y[0] Then
      Begin
        d:=0;
        For i:=1 To y[0] Do
          Begin
            x[i]:=x[i]+y[i]+d;
            d:=x[i] Div Base;
            x[i]:=x[i] Mod Base;
          End;
        For i:=y[0]+1 To x[0] Do
          Begin
            x[i]:=x[i]+d;
            d:=x[i] Div Base;
            x[i]:=x[i] Mod Base;
          End;
        While d>0 Do
          Begin
            Inc(x[0]);x[x[0]]:=d Mod Base;d:=d Div Base;
          End;
      End Else
      Begin
        d:=0;
        For i:=1 To x[0] Do
          Begin
            x[i]:=x[i]+y[i]+d;
            d:=x[i] Div Base;
            x[i]:=x[i] Mod Base;
          End;
        For i:=x[0]+1 To y[0] Do
          Begin
            x[i]:=y[i]+d;
            d:=x[i] Div Base;
            x[i]:=x[i] Mod Base;
          End;
        x[0]:=y[0];
        While d>0 Do
          Begin
            Inc(x[0]);x[x[0]]:=d Mod Base;d:=d Div Base;
          End;
      End;
  End;

Procedure Get_Len_And_Am;
  Var i,curm:Int;
  Begin
    curm:=1;Len[1]:=B[1];Am[1]:=1;
    For i:=2 To M Do
      If B[i]=B[i-1] Then Inc(Am[curm]) Else
        Begin
          Inc(curm);Am[curm]:=1;Len[curm]:=B[i];
        End;
    M:=Curm;
  End;

Procedure Print(x:TLong);
  Var i:Int;
      s:String;
  Begin
    Write(x[x[0]]);
    For i:=x[0]-1 Downto 1 Do
      Begin
        Str(x[i],s);
        While Length(s)<LenBase Do s:='0'+s;
        Write(s);
      End;
  End;

Procedure Solve;
  Var i,j:Int;
      tmp:TLong;
  Begin
    Randomize;
    QSort(1,M);
    Get_Len_And_Am;
    A[0][0]:=1;A[0][1]:=1;
    For i:=1 To N Do
      Begin
        A[i][0]:=1;A[i][1]:=0;
        For j:=1 To M Do
          Begin
            If Len[j]>i Then Break;
            If Am[j]=1 Then Sum(A[i],A[i-Len[j]]) Else
              Begin
                Mult(A[i-Len[j]],Am[j],tmp);
                Sum(A[i],tmp);
              End;
          End;
      End;
    Print(A[N]);
  End;

Procedure CloseFiles;
  Begin
    Close(Input);
    Close(Output);
  End;

Begin
  OpenFiles;
  Init;
  Solve;
  CloseFiles;
End.
