{$Q-,R-,I-,S-,D-,L-,N+}
Program Indirect;
Type
  Int=Longint;
  Real=Extended;
Const
  FileIn='indirect.in';
  FileOut='indirect.out';
  N=32768;
Var
  A,P:Array[0..N] Of Int;
  Buffer,Start,CurOper:Int;
  Last:Array[0..N] Of Int;

Procedure OpenFiles;
  Begin
    Assign(Input,FileIn);
    Assign(Output,FileOut);
    Reset(Input);
    Rewrite(Output);
  End;

Procedure CloseFiles;
  Begin
    Close(Input);
    Close(Output);
  End;

Procedure Out(code:Int);{0 - ok, 1 - RE, 2 - DBY}
  Var i:Int;
  Begin
    Case code Of
      0:Writeln('SUCCESSFUL TERMINATION');
      1:Writeln('RUN-TIME ERROR');
      2:Writeln('DIVISION BY ZERO');
      End;
    Writeln(Buffer);
    For i:=1 To N Do Writeln(A[i]);
    CloseFiles;
    Halt(0);
  End;

Procedure Init;
  Var i:Int;
  Begin
    For i:=1 To N Do
      Begin
        A[i]:=0;P[i]:=i;
      End;
  End;

Procedure Norm(Var x:Int);
  Begin
{    If x>32767 Then x:=-32768+((x-32768) Mod (1 Shl 16));
    If x<-32768 Then x:=32767-((-x-32769) Mod (1 Shl 16));}
    x:=Integer(x);
  End;

Function Find(x:Int):Int;
  Begin
    If Last[x]=CurOper Then Out(1) Else Last[x]:=CurOper;
    If P[x]=x Then
      Begin
        If A[x]<0 Then Out(1) Else Find:=x;
      End Else
      Begin
        P[x]:=Find(P[x]);
        Find:=P[x];
      End;
  End;

Procedure Solve;
  Var ch1,ch2:Char;
      x,r:Int;
  Begin
    Fillchar(Last,Sizeof(Last),0);
    CurOper:=0;
    Buffer:=0;
    While Not Eof Do
      Begin
        If SeekEof Then Out(0);
        Readln(ch1,ch2,x);Inc(CurOper);
        If ch2='=' Then
          Begin
            If (x=0)And((ch1='D')Or(ch1='O')) Then Out(2);
            Case ch1 Of
              'A':Begin Inc(Buffer,x);Norm(Buffer);End;
              'S':Begin Dec(Buffer,x);Norm(Buffer);End;
              'M':Begin Buffer:=Buffer*x;Norm(Buffer);End;
              'D':Begin Buffer:=Buffer Div x;Norm(Buffer);End;
              'O':Begin Buffer:=Buffer Mod x;Norm(Buffer);End;
              'R':Begin Buffer:=x;Norm(Buffer);End;
              End;
          End Else
          Begin
            Start:=x;
            r:=Find(x);
            If (A[r]=0)And((ch1='O')Or(ch1='D')) Then Out(2);
            Case ch1 Of
              'A':Inc(Buffer,A[r]);
              'S':Dec(Buffer,A[r]);
              'M':Buffer:=Buffer*A[r];
              'D':Buffer:=Buffer Div A[r];
              'O':Buffer:=Buffer Mod A[r];
              'R':Buffer:=A[r];
              'W':A[r]:=Buffer;
              End;
            Norm(Buffer);Norm(A[r]);
            If A[r]<0 Then
              Begin
                P[r]:=Abs(A[r]);
              End;
          End;
      End;
    Out(0);
  End;

Begin
  OpenFiles;
  Init;
  Solve;
  CloseFiles;
End.