{$Q-,R-,I-,S-,D-,L-,N+}
Program Intsr;
Type
  Int=Longint;
  Real=Extended;
Const
  FileIn='2instr.in';
  FileOut='2instr.out';
  Inf=1000000000;
  MaxLen=65536;
Var
  Words:Array[0..MaxLen] Of Int;
  Used:Array[-1..MaxLen] Of Boolean;
  Dist,From,How:Array[-1..MaxLen] Of Int;
  Res:Array[0..MaxLen*3] Of String[2];
  Ans:Int;
  Start,Fin:Int;

Procedure OpenFiles;
  Begin
    Assign(Input,FileIn);
    Assign(Output,FileOut);
    Reset(Input);
    Rewrite(Output);
  End;

Function Id(x:Char):Int;
  Begin
    If x In ['0'..'9'] Then Id:=Ord(x)-Ord('0') Else
      Id:=Ord(x)-Ord('A')+10;
  End;

Function Hex2Int(s:String):Int;
  Begin
    Hex2Int:=Id(s[2])+16*Id(s[1]);
  End;

Procedure Init;
  Var s,s1,Startee:String;
      i:Int;
      ch:Char;
  Begin
    s:='    ';For i:=1 To 4 Do Read(S[i]);Read(ch);
    Start:=Hex2Int(s[1]+s[2])*16+Hex2Int(s[3]+s[4]);
    s:='    ';For i:=1 To 4 Do Read(S[i]);
    Fin:=Hex2Int(s[1]+s[2])*16+Hex2Int(s[3]+s[4]);
    Readln;
    s:='  ';Read(s[1],s[2]);Startee:=s;
    s1:='';i:=0;
    While i<MaxLen-1 Do
      Begin
        Read(ch);
        If Ch In ['0'..'9','A'..'Z'] Then s1:=s1+ch Else
          If s1<>'' Then
            Begin
              Words[i]:=Hex2Int(s)+16*Hex2Int(s1);
              Inc(i);
              s:=s1;s1:='';
            End;
      End;
    While Not SeekEof Do
      Begin
        Read(ch);s1:=s1+ch;
      End;
    Words[MaxLen-1]:=16*Hex2Int(Startee)+Hex2Int(s1);
  End;

Function Swp(x:Int):Int;
  Begin
    swp:=16*(x Mod 16)+x Div 16;
  End;

Procedure Rec(Const x:Int;Const pos:Int);
  Begin
    If x=Start Then Exit;
    If How[x]=1 Then
      Begin
        Res[pos]:='5C';
        Rec(From[x],pos-1);
      End Else
      Begin
        Res[pos]:='CC';Res[pos-1]:='0F';
        Rec(From[x],pos-2);
      End;
  End;

Procedure Solve;
  Var i,j,l:Int;
      min:Int;
  Begin
    For i:=-1 To MaxLen-1 Do
      Begin
        Used[i]:=False;Dist[i]:=Inf;
      End;
    Dist[Start]:=0;
    While True Do
      Begin
        min:=-1;
        For i:=0 To MaxLen-1 Do
          If (Dist[i]<Dist[min])And Not Used[i] Then min:=i;
        If (min=-1)Or(min=Fin) Then Break;
        Used[min]:=True;
        l:=Swp(min);
        If Dist[l]>=Dist[min]+2 Then
          Begin Dist[l]:=Dist[min]+2;From[l]:=min;How[l]:=2;End;
        l:=Words[min];
        If Dist[l]>Dist[min]+1 Then
          Begin Dist[l]:=Dist[min]+1;From[l]:=min;How[l]:=1;End;
      End;
    If Dist[Fin]>=Inf Then Begin Writeln('IMPOSSIBLE');Exit;End;
    Write(Dist[Fin]);
    Rec(Fin,Dist[Fin]);
    If Dist[Fin] Mod 16=0 Then
      Begin
        For i:=1 To Dist[Fin] Div 16 Do
          Begin
            Writeln;
            For j:=1 To 8 Do Write(Res[j],' ');
            Write(' ');
            For j:=9 To 16 Do Write(Res[j],' ');
          End;
        Writeln;
      End Else
      Begin
        For i:=1 To Dist[Fin] Div 16 Do
          Begin
            Writeln;
            For j:=1 To 8 Do Write(Res[j+16*(i-1)],' ');
            Write(' ');
            For j:=9 To 16 Do Write(Res[j+16*(i-1)],' ');
          End;
        i:=Dist[Fin] Div 16+1;
        Writeln;
        If Dist[Fin] Mod 16<=8 Then
           Begin
            For j:=1 To Dist[Fin] Mod 16-1 Do Write(Res[j+16*(i-1)],' ');
            j:=Dist[Fin] Mod 16;
            Write(Res[j+16*(i-1)]);Writeln;
          End Else
          Begin
            For j:=1 To 8 Do Write(Res[j+16*(i-1)],' ');
            Write(' ');
            For j:=9 To Dist[Fin] Mod 16-1 Do Write(Res[j+16*(i-1)],' ');
            j:=Dist[Fin] Mod 16;
            Write(Res[j+16*(i-1)]);Writeln;
          End;
      End;
  End;

Procedure CloseFiles;
  Begin
    Close(Input);
    Close(Output);
  End;

Begin
  OpenFiles;
  Init;
  Solve;
  CloseFiles;
End.
