{$Q-,R-,I-,S-,D-,L-,N+}
Program Ram;
Type
  Int=Longint;
  Real=Extended;
  TCommand=Record
    name:Int;
    way:Byte;
    param:Int;
    End;
Const
  FileIn='ram.in';
  FileOut='ram.out';
  MaxN=2000;
Var
  N,M:Int;
  C:Array[0..1000] Of Int;
  Commands:Array[0..MaxN] Of TCommand;
  Income:Array[0..MaxN] Of Int;

Procedure OpenFiles;
  Begin
    Assign(Input,FileIn);
    Assign(Output,FileOut);
    Reset(Input);
    Rewrite(Output);
  End;

Procedure Decrypt(s:String;Var param:Int;Var Way:Byte);
  Var code:Integer;
  Begin
    code:=10;
    Case s[1] Of
      '=':Begin way:=2;Delete(s,1,1);End;
      '*':Begin way:=3;Delete(s,1,1);End;
        Else way:=1;
      End;
    Val(s,param,code);
  End;

Procedure Add(s:String;x:Int);
  Var code:Integer;
  Begin
    If Copy(s,1,4)='LOAD' Then
      Begin
        Commands[x].name:=1;
        Decrypt(Copy(s,6,Length(s)-5),Commands[x].param,Commands[x].way);
        Exit;
      End;
    If Copy(s,1,5)='STORE' Then
      Begin
        Commands[x].name:=2;
        Decrypt(Copy(s,7,Length(s)-6),Commands[x].param,Commands[x].way);
        Exit;
      End;
    If Copy(s,1,3)='ADD' Then
      Begin
        Commands[x].name:=4;
        Decrypt(Copy(s,5,Length(s)-4),Commands[x].param,Commands[x].way);
        Exit;
      End;
    If Copy(s,1,3)='SUB' Then
      Begin
        Commands[x].name:=5;
        Decrypt(Copy(s,5,Length(s)-4),Commands[x].param,Commands[x].way);
        Exit;
      End;
    If Copy(s,1,4)='MULT' Then
      Begin
        Commands[x].name:=6;
        Decrypt(Copy(s,6,Length(s)-5),Commands[x].param,Commands[x].way);
        Exit;
      End;
    If Copy(s,1,3)='DIV' Then
      Begin
        Commands[x].name:=7;
        Decrypt(Copy(s,5,Length(s)-4),Commands[x].param,Commands[x].way);
        Exit;
      End;
    If Copy(s,1,4)='READ' Then
      Begin
        Commands[x].name:=8;
        Decrypt(Copy(s,6,Length(s)-5),Commands[x].param,Commands[x].way);
        Exit;
      End;
    If Copy(s,1,5)='WRITE' Then
      Begin
        Commands[x].name:=10;
        Decrypt(Copy(s,7,Length(s)-6),Commands[x].param,Commands[x].way);
        Exit;
      End;
    If Copy(s,1,4)='JUMP' Then
      Begin
        Commands[x].name:=11;
        Decrypt(Copy(s,6,Length(s)-5),Commands[x].param,Commands[x].way);
        Exit;
      End;
    If Copy(s,1,4)='JGTZ' Then
      Begin
        Commands[x].name:=12;
        Decrypt(Copy(s,6,Length(s)-5),Commands[x].param,Commands[x].way);
        Exit;
      End;
    If Copy(s,1,4)='JZERO' Then
      Begin
        Commands[x].name:=13;
        Decrypt(Copy(s,7,Length(s)-6),Commands[x].param,Commands[x].way);
        Exit;
      End;
    If Copy(s,1,4)='HALT' Then
      Begin
        Commands[x].name:=14;
{        Decrypt(Copy(s,6,Length(s)-6),Commands[x].param,Commands[x].way);}
        Commands[x].param:=1;Commands[x].way:=1;
        Exit;
      End;
  End;

Procedure Norm(Var s:String);
  Var i:Int;
  Begin
    i:=2;
    While i<=Length(s) Do
      Begin
        If (S[i]+S[i-1]='  ') Then Delete(s,i,1) Else Inc(i);
      End;
  End;

Function V(param:Int;way:Int):Int;
  Begin
    Case way Of
      1:V:=C[param];
      2:V:=param;
      3:V:=C[C[Param]];
      End;
  End;

Procedure Init;
  Var i:Int;
      s:String;
  Begin
    Read(N,M);
    For i:=1 To N Do
      Begin
        Readln;
        Read(s);Norm(s);
        Add(s,i);
      End;
    For i:=1 To M Do Read(Income[i]);
  End;

Procedure Solve;
  Var curcom,curinc:Int;
      rv:Int;
  Begin
    curcom:=1;curinc:=1;
    While curcom<=N Do
      Begin
        rv:=V(Commands[curcom].param,Commands[curcom].way);
        Case Commands[curcom].name Of
          1:C[0]:=rv;
          2:
            Begin
              If Commands[curcom].way=1 Then
                C[Commands[curcom].param]:=C[0] Else
                  C[C[Commands[curcom].param]]:=C[0];
            End;
          4:Inc(C[0],rv);
          5:Dec(C[0],rv);
          6:C[0]:=C[0]*rv;
          7:C[0]:=C[0] Div rv;
          8:
            Begin
              If Commands[curcom].way=1 Then
                C[Commands[curcom].param]:=Income[curinc] Else
                  C[C[Commands[curcom].param]]:=Income[curinc];
              Inc(curinc);
            End;
          10:Writeln(rv);
          11:curcom:=Commands[curcom].param;
          12:If C[0]>0 Then curcom:=Commands[curcom].param;
          13:If C[0]=0 Then curcom:=Commands[curcom].param;
          14:Exit;
          End;
        Inc(Curcom);
      End;
  End;

Procedure CloseFiles;
  Begin
    Close(Input);
    Close(Output);
  End;

Begin
  OpenFiles;
  Init;
  Solve;
  CloseFiles;
End.