{$Q-,R-,I-,S-,D-,L-,N+}
program rescue;

//Eva rulezzz!!!

Type
  Int=Longint;
  Real=Extended;
  TPoint=Record
    x,y:Int;
    End;
Const
  FileIn='rescue.in';
  FileOut='rescue.out';
  MaxN=50001;
  MaxCoord=1000;
  Inf=5000;
Var
  N,M,Ans:Int;
  A:Array[0..MaxN] Of TPoint;
  G:Array[-MaxCoord..MaxCoord,-MaxCoord..MaxCoord] Of Int;
  Beg,Fin:Array[-MaxCoord..MaxCoord] Of Int;
  Map:Array[-MaxCoord..MaxCoord,-MaxCoord..MaxCoord] Of Boolean;

Procedure OpenFiles;
  Begin
    Assign(Input,FileIn);
    Assign(Output,FileOut);
    Reset(Input);
    Rewrite(Output);
  End;

Procedure Init;
  Var i:Int;
  Begin
    Read(N,M);
    Fillchar(Map,Sizeof(Map),False);
    For i:=1 To N Do
      Begin
        Read(A[i].x,A[i].y);
        Map[A[i].x][A[i].y]:=True;
      End;
  End;

Procedure Swap(Var x,y:TPoint);
  Var t:TPoint;
  Begin
    t:=x;x:=y;y:=t;
  End;

Function Less(x,y:TPoint):Boolean;
  Begin
    Less:=(x.x<y.x)Or((x.x=y.x)And(x.y<y.y));
  End;

Procedure QSort(l,r:Int);
  Var i,j:Int;
      t:TPoint;
  Begin
    t:=A[l+Random(r-l+1)];i:=l;j:=r;
    Repeat
      While Less(A[i],t) Do Inc(i);
      While Less(t,A[j]) Do Dec(j);
      If i<=j Then
        Begin
          Swap(A[i],A[j]);Inc(i);Dec(j);
        End;
      Until i>j;
    If i<r Then QSort(i,r);
    If l<j Then QSort(l,j);
  End;

Function Search(x,l,r:Int):Int;
  Var t,res:Int;
  Begin
    res:=Inf;
    While l<=r Do
      Begin
        t:=(l+r) Shr 1;
        If Abs(A[t].y-x)<Abs(x-res) Then res:=A[t].y;
        If A[t].y>x Then r:=t-1 Else l:=t+1;
      End;
//    If Abs(A[t+1].y-x)<Abs(x-res) Then res:=A[t+1].y;
//    If Abs(A[t-1].y-x)<Abs(x-res) Then res:=A[t-1].y;
    Search:=Res;
  End;

Function Eq(p1,p2:TPoint):Boolean;
  Begin
    Eq:=((p1.x=p2.x)And(p1.y=p2.y));
  End;

Procedure Fill_beg_and_fin;
  Var i,cur,nn:Int;
  Begin
    For i:=-MaxCoord To MaxCoord Do
      Begin
        Beg[i]:=1;Fin[i]:=0;
      End;
    nn:=1;
    For i:=2 To N Do
      If Not Eq(A[i-1],A[i]) Then
        Begin
          Inc(nn);A[nn]:=A[i];
        End;
//    A[0].x:=-Inf;A[N+1].x:=Inf;
    N:=nn;cur:=1;
    For i:=2 To N+1 Do
      Begin
        If A[i].x=A[i-1].x Then Inc(cur) Else
          Begin
            Beg[A[i-1].x]:=i-cur;Fin[A[i-1].x]:=i-1;
            cur:=1;
          End;
      End;
  End;

Procedure Fill_G;
  Var i,j,cur,pr:Int;
  Begin
{    For i:=-MaxCoord+1 To MaxCoord-1 Do
      For j:=-MaxCoord+1 To MaxCoord-1 Do
        G[i][j]:=Search(j,Beg[i],Fin[i]);}
    For i:=-MaxCoord+1 To MaxCoord-1 Do
      For j:=-MaxCoord+1 To MaxCoord-1 Do
        G[i][j]:=Inf;
    For i:=-MaxCoord+1 To MaxCoord-1 Do
      Begin
        cur:=Inf;
        For j:=-MaxCoord+1 To MaxCoord-1 Do
          Begin
            If Map[i][j] Then Begin pr:=j;cur:=0;End Else Inc(cur);
            If G[i][j]>cur Then G[i][j]:=pr;
          End;
        cur:=Inf;
        For j:=MaxCoord-1 DownTo -MaxCoord+1 Do
          Begin
            If Map[i][j] Then Begin cur:=0;pr:=j;End Else Inc(cur);
            If G[i][j]>cur Then G[i][j]:=pr;
          End;
      End;
  End;

Procedure Solve;
  Var l,r,i,tmp:Int;
      cur,resx,resy:Int;
      x,y,am:Int;
      time:Real;
  Begin
//    Randomize;
//    QSort(1,N);
//    Fill_beg_and_fin;
    Fill_G;
    For i:=1 To M Do
      Begin
        Read(x,y);
        l:=x;r:=x+1;
        Ans:=Sqr(A[1].x-x)+Sqr(A[1].y-y)+1;
        While (l>-MaxCoord)Or(r<MaxCoord) Do
          Begin
            If l>-MaxCoord Then
              Begin
                tmp:=Sqr(x-l);
                If tmp>=Ans Then l:=-MaxCoord Else
                  Begin
//                    cur:=Search(y,Beg[l],Fin[l]);
                    cur:=G[l][y];Inc(tmp,Sqr(y-cur));
                    If tmp<Ans Then
                      Begin
                        Ans:=tmp;
                        resx:=l;resy:=cur;
                      End;
                    Dec(l);
                  End;
              End;
            //Now right
            If r<MaxCoord Then
              Begin
                tmp:=Sqr(x-r);
                If tmp>=Ans Then r:=MaxCoord Else
                  Begin
//                    cur:=Search(y,Beg[r],Fin[r]);
                    cur:=G[r][y];Inc(tmp,Sqr(y-cur));
                    If tmp<Ans Then
                      Begin
                        Ans:=tmp;
                        resx:=r;resy:=cur;
                      End;
                    Inc(r);
                  End;
              End;
          End;
        Writeln(resx,' ',resy);
      End;
  End;

Procedure CloseFiles;
  Begin
    Close(Input);
    Close(Output);
  End;

begin
  OpenFiles;
  Init;
  Solve;
  CloseFiles;
end.
