{$Q-,R-,I-,S-,D-,N+,L-,O-}
Program ProblemB;
{Eva rulezzz!!!}
Const
  FileIn='lcm.in';
  FileOut='lcm.out';
  MaxLen=20000;
  Base=100000000;
  LenBase=8;
  BigInt=10000000;
Type
  Int=Longint;
  Real=Extended;
  TLong=Array[0..MaxLen] Of Int64;
Var
  N:Int;
  cur:TLong;

Procedure Long2Int(Const x:TLong;Var res:Int);
  Var i:Int;
      deg:Int64;
  Begin
    deg:=1;res:=0;
    For i:=1 To x[0] Do
      Begin
        Inc(res,x[i]*deg);
        deg:=deg*Base;
      End;
  End;

Procedure Int2Long(x:Int64;Var res:TLong);
  Begin
    res[0]:=0;
    While x>0 Do
      Begin
        Inc(res[0]);res[res[0]]:=x Mod Base;
        x:=x Div Base;
      End;
  End;

Function More(Const x:Int;Const y:TLong):Boolean;
  Var t:TLong;
      i:Int;
  Begin
    Int2Long(x,t);
    If t[0]<>y[0] Then More:=(t[0]>y[0]) Else
      Begin
        For i:=t[0] Downto 1 Do
          If t[i]<>y[i] Then
            Begin
              More:=(t[i]>y[i]);Exit;
            End;
        More:=True;
      End;
  End;

Procedure OpenFiles;
  Begin
    Assign(Input,FileIn);
    Assign(Output,FileOut);
    Reset(Input);
    Rewrite(Output);
  End;

Procedure Init;
  Begin
    Read(N);
  End;

Function Gcd(x,y:Int):Int;
  Begin
    If y=0 Then Gcd:=x Else Gcd:=Gcd(y,x Mod y);
  End;

Function Modules(Const x:TLong;Const y:Int):Int;
  Var i:Int;
      cur:Int64;
  Begin
    cur:=0;
    For i:=x[0] Downto 1 Do cur:=(cur*base+x[i]) Mod y;
    Modules:=cur;
  End;

Procedure Norm(Var x:TLong);
  Begin
    While (x[0]>1)And(x[x[0]]=0) Do Dec(x[0]);
  End;

Procedure Division(Const x:TLong;Const y:Int; Var res:TLong);
  Var i:Int;
      cur:Int64;
  Begin
    cur:=0;
    res[0]:=x[0];
    For i:=x[0] Downto 1 Do
      Begin
        cur:=cur*Base+x[i];
        res[i]:=cur Div y;
        cur:=cur Mod y;
      End;
    Norm(res);
  End;

Procedure Mult(Var x:TLong;Const y:Int);
  Var i:Int;
      d:Int64;
  Begin
    d:=0;
    For i:=1 To x[0] Do
      Begin
        x[i]:=x[i]*y+d;
        d:=x[i] Div Base;
        x[i]:=x[i] Mod Base;
      End;
    While d>0 Do
      Begin
        Inc(x[0]);x[x[0]]:=d Mod Base;
        d:=d Div Base;
      End;
  End;

Procedure Print(Const x:TLong);
  Var i:Int;
      s:String;
  Begin
    Write(x[x[0]]);
    For i:=x[0]-1 Downto 1 Do
      Begin
        Str(x[i],s);
        While Length(s)<Lenbase Do s:='0'+s;
        Write(s);
      End;
  End;

Procedure Solve;
  Var i,l,curs:Int;
      d:Int64;
  Begin
    Int2Long(1,cur);
    For i:=1 To N Do
      Begin
        Read(l);
        If More(l,cur) And More(BigInt,cur) Then
          Begin
            Long2Int(cur,curs);
            Int2Long(Int64(curs*l) Div Gcd(l,curs),cur);
          End Else
          Begin
            d:=Gcd(l,Modules(cur,l));
            Mult(cur,l);Division(cur,d,cur);
          End;
      End;
    Print(cur);
  End;

Procedure CloseFiles;
  Begin
    Close(Input);
    Close(Output);
  End;

Begin
  OpenFiles;
  Init;
  Solve;
  CloseFiles;
End.
