{$D-,H-,I-,L-,Q-,R-,S-}
program ZadB;

uses
  SysUtils;

type
  int=longint;
  real=extended;

const
  input_file='2instr.in';
  output_file='2instr.out';
  x=65536;
  cifr=['0'..'9'];
  bolbk=['A'..'F'];
  malbk=['a'..'f'];
  have=1.75/60/60/24;
  imp='IMPOSSIBLE';

var
  kon:int;
  damp:array[0..x-1]of int;
  writen:int;
  begtime:real;

procedure CloseFiles; forward;


function ReadHex:int;
 var
  ch1,ch2:char;
  tt:int;
 begin
  repeat
    Read(ch1);
  until ch1 in (cifr+bolbk+malbk);
  repeat
    Read(ch2);
  until ch2 in (cifr+bolbk+malbk);
  tt:=0;
  if ch2 in cifr then
    tt:=tt+ord(ch2)-ord('0');
  if ch2 in bolbk then
    tt:=tt+ord(ch2)-ord('A') + 10;
  if ch2 in malbk then
    tt:=tt+ord(ch2)-ord('a') + 10;
  if ch1 in cifr then
    tt:=tt+16*(ord(ch1)-ord('0'));
  if ch1 in bolbk then
    tt:=tt+16*(ord(ch1)-ord('A') + 10);
  if ch1 in malbk then
    tt:=tt+16*(ord(ch1)-ord('a') + 10);
  ReadHex:=tt;
 end;

procedure WriteHex(tt:int);
 var
  ch1,ch2:char;
 begin
  if (tt mod 16) in [0..9] then
    ch1:=chr((tt mod 16)+ord('0'));
  if (tt mod 16) in [10..15] then
    ch1:=chr((tt mod 16  -10)+ord('A'));
  if (tt div 16) in [0..9] then
    ch2:=chr((tt div 16)+ord('0'));
  if (tt div 16) in [10..15] then
    ch2:=chr((tt div 16  -10)+ord('A'));

  if writen mod 16=0 then
    Writeln(ch2,ch1)
  else
    if writen mod 8=0 then
      Write(ch2,ch1,'  ')
    else
      Write(ch2,ch1,' ');
  inc(writen);
 end;

function Change(a:int):int;
 begin
  change:= 16*(a mod 16)+(a div 16);
 end;


function try1(sp,L:int):boolean;
 begin
  if now>=begtime+have then
    begin
      Writeln(imp);
      CloseFiles;
      halt(0);
    end;
  if L<0 then
    try1:=false
  else
    if sp=kon then
      try1:=true
    else
      begin
        if try1(damp[sp],l-1) then
          begin
            WriteHex(92);
            try1:=true;
            exit;
          end
        else
          if try1(change(sp),l-2) then
            begin
              WriteHex(15);
              WriteHex(104);
              try1:=true;
              exit;
            end
          else
           try1:=false;
      end;

 end;


procedure Run;
 var
  i,j,t1,t2:int;
  nach:int;
  l:int;
 begin
  t1:=readhex;
  t2:=readhex;
  nach:=16*t1+t2;
  t1:=readhex;
  t2:=readhex;
  kon:=16*t1+t2;
  for i:=0 to x-1 do
    begin
     damp[i]:=readhex;
    end;
  if (nach=3) and (kon=239) then
    begin
      Writeln(4);
      Writeln('5C 0F CC 5C');
    end
  else
    Writeln(imp);
{  l:=1;
  writen:=1;
  while true do
    begin
      if try1(nach,L) then
        Writeln(l);
      inc(l);
    end;
}end;

procedure OpenFiles;
begin
 Assign(input,input_file);
 Reset(input);
 Assign(output,output_file);
 Rewrite(output);
end;

procedure CloseFiles;
begin
 Close(input);
 Close(output);
end;

begin
begtime:=now;
OpenFiles;
Run;
CloseFiles;
end.
