{$A8,B-,C+,D-,E-,F-,G+,H+,I-,J-,K-,L-,M-,N+,O+,P+,Q-,R-,S-,T-,U-,V+,W-,X+,Y+,Z1}
program ZadB;

{$APPTYPE CONSOLE}

const
  osn=1000;
  maxLong=6003;
  maxN=2005;

type
  int=longint;
  long=array[0..maxLong]of int;

const
  input_file='lcm.in';
  output_file='lcm.out';

function ShortToLong(a:int):long;
 var
  t:long;
  tt:int;
  i:int;
 begin
  tt:=a;
  t[0]:=0;
  i:=0;
  while tt>0 do
    begin
      inc(i);
      if (tt mod osn)<>0 then t[0]:=i;
      t[i]:= tt mod osn;
      tt:= tt div osn;
    end;
  ShortToLong:=t;
 end;

function Bol(a,b:long):boolean;
 var
  i:int;
 begin
  if a[0]>b[0] then
    begin
      Bol:=true;
      exit;
    end;
  if a[0]<b[0] then
    begin
      Bol:=false;
      exit;
    end;
  for  i := a[0] downto 1 do
    begin
      if b[i]>a[i] then
        begin
          Bol:=false;
          exit;
        end;
      if b[i]<a[i] then
        begin
          Bol:=true;
          exit;
        end;
    end;
  Bol:=false;
 end;

function BolRvn(a,b:long):boolean;
 var
  i:int;
 begin
  if a[0]>b[0] then
    begin
      BolRvn:=true;
      exit;
    end;
  if a[0]<b[0] then
    begin
      BolRvn:=false;
      exit;
    end;
  for  i := a[0] downto 1 do
    begin
      if b[i]>a[i] then
        begin
          BolRvn:=false;
          exit;
        end;
      if b[i]<a[i] then
        begin
          BolRvn:=true;
          exit;
        end;
    end;
  BolRvn:=true;
 end;

function Minus(a,b:long):long;
 var
  aa:long;
  i:int;
 begin
  aa:=a;
  for i := 1 to aa[0] do
    begin
      if i>b[0]then
       aa[i]:=aa[i]
      else
      if b[i]<=aa[i] then
       aa[i]:=aa[i]-b[i]
      else
        begin
          aa[i]:=osn+aa[i]-b[i];
          dec(aa[i+1]);
        end;
    end;
  for i := 0 to aa[0] do
    if aa[i]<>0 then
      aa[0]:=i;
  Minus:=aa;
 end;

function Max(a,b:int):int;
 begin
  if a>b then max:=a else max:=b;
 end;

procedure incr(var a:long);
 var
  i:int;
 begin
  i:=1;
  repeat
    if a[i]=osn then
      begin
        a[i]:=0;
        inc(i);
      end;
    inc(a[i]);
    a[0]:=max(a[0],i);
  until a[i]<osn;
 end;

function Plus(a,b:long):long;
 var
  aa:long;
  i,ost:int;
 begin
  aa[0]:=max(a[0],b[0])+1;
  aa[aa[0]]:=0;
  for i := 1 to aa[0]-1 do
    begin
      if i>a[0]then
        aa[i]:=b[i]
      else
        if i>b[0]then
          aa[i]:=a[i]
        else
          aa[i]:=a[i]+b[i];
    end;
  ost:=0;
  for i := 1 to aa[0] do
    begin
      inc(aa[i],ost);
      ost:=0;
      if aa[i]>=osn then
        begin
          ost:=aa[i]div osn;
          aa[i]:= aa[i]mod osn;
        end;
      if aa[i]<>0 then aa[0]:=i;
    end;

  if aa[aa[0]]=0 then
    aa[0]:=aa[0]-1;
  Plus:=aa;
 end;

function Sdvig(a:long;nn:int):long;
 var
  i:int;
  t:long;
 begin
   t:=a;
   for i := t[0]+nn downto nn+1 do
     t[i]:= t[i-nn];
   for i := 1 to nn do
     t[i]:= 0;
   t[0]:=t[0]+nn;
   Sdvig:=t;
 end;

function ShortMulLong(nn:Int;a:long):long;
var
 t:long;
 i:int;
 ost:int;
begin
  t:=a;
  for i := 1 to a[0] do
    t[i]:=t[i]*nn;
  t[t[0]+1]:=0;
  ost:=0;
  for i := 1 to t[0]+1 do
    begin
      inc(t[i],ost);
      ost:=0;
      if t[i]>=osn then
        begin
          ost:=t[i]div osn;
          t[i]:= t[i]mod osn;
        end;
      if t[i]<>0 then t[0]:=i;
    end;
  ShortMulLong:=t;
end;

function Modd(a,b:long):long;
 var
  aa:long;
  t1:boolean;
 begin
  aa:=a;
  t1:=Bol(aa,b);
  while t1 do
    begin
      if aa[aa[0]] div (b[b[0]]+1) > 0 then
        aa:=Minus(aa,sdvig(ShortMulLong(aa[aa[0]] div (b[b[0]]+1),b),aa[0]-b[0]))
      else
        if a[0] > b[0] then
          aa:=Minus(aa,sdvig(ShortMulLong( (aa[aa[0]]*osn+aa[aa[0]-1]) div (b[b[0]]+1),b),aa[0]-b[0]-1))
        else
          if Bol(aa,b) then
            aa:=Minus(aa,b);
      t1:=Bol(aa,b)
    end;
  Modd:=aa;
 end;

function osnv(nn:int):long;
 var
  i:int;
 begin
  osnv[0]:=nn+1;
  for i:=1 to nn do
    osnv[i]:=0;
  osnv[nn+1]:=1;
 end;

function divv(a,b:long):long;
 var
  aa,tt:long;
 begin
  fillchar(tt,sizeof(tt),0);
  aa:=a;
  while BolRvn(aa,b) do
    begin

      if aa[aa[0]] div (b[b[0]]+1) > 0 then
        begin
          tt:=Plus(tt,ShortMulLong(aa[aa[0]] div (b[b[0]]+1),osnv(aa[0]-b[0])));
          aa:=Minus(aa,sdvig(ShortMulLong(aa[aa[0]] div (b[b[0]]+1),b),aa[0]-b[0]));
        end
      else
        if aa[0] > b[0] then
          begin
            tt:=Plus(tt,ShortMulLong((aa[aa[0]]*osn+aa[aa[0]-1]) div (b[b[0]]+1),osnv(aa[0]-b[0]-1)));
            aa:=Minus(aa,sdvig(ShortMulLong( (aa[aa[0]]*osn+aa[aa[0]-1]) div (b[b[0]]+1),b),aa[0]-b[0]-1))
          end
        else
          if BolRvn(aa,b) then
            begin
              aa:=Minus(aa,b);
              incr(tt);
            end;
    end;
  Divv:=tt;
 end;


function NOD(a,b:long):long;
var
 t1,t2:boolean;
 aa,bb:long;
begin
 aa:=a;
 bb:=b;
 t1:=Bol(aa,bb);
 t2:=Bol(bb,aa);
 while t1 or t2 do
   begin
     if t1 then
       aa:=Modd(aa,bb);
     if t2 then
       bb:=Modd(bb,aa);
     t1:=Bol(aa,bb);
     t2:=Bol(bb,aa);
   end;
  Nod:=aa;
end;

function Mul(a,b:long):long;
var
 t:long;
 i,j:int;
 ost:int;
begin
  fillchar(t,sizeof(t),0);
  for i := 1 to a[0] do
    for j := 1 to b[0] do
      t[i+j-1]:=t[i+j-1]+a[i]*b[j];
  ost:=0;
  for i := 1 to a[0]+b[0]+1 do
    begin
      inc(t[i],ost);
      ost:=0;
      if t[i]>=osn then
        begin
          ost:=t[i]div osn;
          t[i]:= t[i]mod osn;
        end;
      if t[i]<>0 then t[0]:=i;
    end;
  Mul:=t;
end;

procedure Writelong(a:long);
 var
  i:int;
 begin
   Write(a[a[0]]);
   for i := a[0]-1 downto 1 do
     begin
       if a[i]<100 then write('0');
       if a[i]<10 then write('0');
       Write(a[i]);
     end;
 end;

procedure Run;
 var
  i,j:int;
  N:int;
  res:long;
  tmp:long;
  temp:int;
  chisla:array[1..maxN]of int;
  c:int;
 begin
  Read(N);
  for i:= 1 to N do
    begin
      Read(temp);
      chisla[i]:=temp;
    end;

  for i:= 1 to N do
    for j:= 1 to N-1 do
      if chisla[j] > chisla[j+1]then
        begin
          c:= chisla[j];
          chisla[j]:=chisla[j+1];
          chisla[j+1]:=c;
        end;


  res:=ShortToLong(chisla[1]);
  for i:= 2 to N do
    begin
      tmp:=ShortToLong(chisla[i]);
      res:=mul(   Divv(res, Nod(res,tmp) ), tmp  );
//      res:=divv(   mul(res, tmp), Nod(res,tmp));
    end;
  WriteLong(Res);
 end;

procedure OpenFiles;
begin
 Assign(input,input_file);
 Reset(input);
 Assign(output,output_file);
 Rewrite(output);
end;

procedure CloseFiles;
begin
 Close(input);
 Close(output);
end;

begin
OpenFiles;
Run;
CloseFiles;
end.
