#include <fstream>
#include <vector>
#include <set>

using namespace std;

ifstream I("rle.in");
ofstream O("rle.out");

struct RLEarea{
	long C;//color
	long coord;
	long S;
};

typedef vector<RLEarea> RLEline;

long M,N,K;
int B;//black
long ost=0;
long curcol=1;

RLEarea in_area(long maxsize){
	RLEarea ret;
	if(ost){
		ret.C=B?curcol++:0;
		ret.S=ost;
		ost=0;
	}
	else{
		B=!B;
		ret.C=B?curcol++:0;
		if(K--) I>>ret.S;
		else ret.S=0;
	}
	if(ret.S>maxsize){
		ost=ret.S-maxsize;
		ret.S=maxsize;
	}
	return ret;
}

RLEline in_line(){
	RLEline ret;
	long size=0;
	while(size!=M){
		RLEarea a=in_area(M-size);
		a.coord=size;
		size+=a.S;
		ret.push_back(a);
	}
	return ret;
}

int main(){
	I>>M>>N;
	I>>B>>K;
	B=!B;

	RLEline first=in_line();
	long completedsymbols=0;
	RLEline::iterator i,j;
	set<long>::const_iterator ci;

	while(K||ost){
		RLEline second=in_line();

		for(i=second.begin();i!=second.end();i++) if(i->C){
			bool perekr=false;
			for(j=first.begin();j!=first.end();j++) if(j->C)
				if(i->coord<=(j->coord+j->S) && j->coord<=(i->coord+i->S)){
					if(perekr) j->C=i->C;
					else i->C=j->C,perekr=true;
				}
			
		}

		set<long> colors;

		for(i=first.begin();i!=first.end();i++) if(i->C)
			colors.insert(i->C);
		for(i=second.begin();i!=second.end();i++) if(i->C)
			colors.erase(i->C);

		for(ci=colors.begin();ci!=colors.end();ci++) completedsymbols++;
		first=second;
	}
	set<long> colors;
	for(i=first.begin();i!=first.end();i++) if(i->C) colors.insert(i->C);
	for(ci=colors.begin();ci!=colors.end();ci++) completedsymbols++;
	O<<completedsymbols;
	return 0;
}
