#include <fstream>
#include <stdio.h>
#include <string.h>

using namespace std;

FILE *I=fopen("elevator.in","r");
ofstream O("elevator.out");

long N,C,K;
long R[1000][1000];//requests [to][from]
double elapsed=0;

void in(){
	fscanf(I,"%li %li %li\n",&N,&C,&K);
	memset(R,0,sizeof(R));
	for(int i=0;i<K;i++){
		long src,dest;
		fscanf(I,"%li %li\n",&src,&dest);
		R[dest-1][src-1]++;
	}
}

void sol(){
	long im=0;
	for(int i=N-1;i>=1;i--,elapsed+=(im+C-1)/C,im=0)
		for(int j=0;j<i;j++){
			im+=R[i][j];
			R[i-1][j]+=R[i][j];
		}
}

void out(){
	O.precision(0);
	O<<fixed<<elapsed*10;
}

int main(){
	in(),
	sol(),
	out();
	return 0;
}