//#define PRIMARY_DEBUG

#include <fstream>
#include <deque>

using namespace std;

int N,M;
int matrix[12][12];

ifstream I("chrom.in");
ofstream O("chrom.out");

deque<int> queue;
int ped[12];
int d;
int P[100];

void in(){
	I>>N>>M;
	memset(matrix,0,sizeof(matrix));
	for(int i=0;i<M;i++){
		int a,b;
		I>>a>>b;
		a--,b--;
		matrix[a][b]=matrix[b][a]=1;
	}
}

//void process(int vert){
//	O<<vert<<endl;
//}

void sol(){
	int i,j;
	/*for(int c=1;c<=1;c++){
		//o6xog B LLIuPuHy
		int f=0;
		memset(ped,0,sizeof(ped));
		int i=0;
		queue.push_back(i);
		while(!queue.empty()){
			i=queue.front();
			queue.pop_front();
			ped[i]=1;
			for(int j=0;j<N;j++)
				if(!ped[j] && matrix[i][j])
					queue.push_back(j),ped[j]=1;
			process(i);
		}
	}*/
	d=0;
	*P=1;
	for(i=0;i<N;i++){
		int conn=0;
		for(j=0;j<i;j++) if(matrix[i][j]) conn++;
		int Pk[100],dk=d+1;
		*Pk=0;
		for(j=0;j<=d;j++){
			Pk[j+1]=P[j];
			P[j]*=(-conn);
			P[j]+=Pk[j];
		}
		d++;P[d]=Pk[d];
	}
}

void out(){
	int i;
	O<<d<<" ";
	for(i=0;i<=d;i++) O<<P[i]<<" ";
	O<<endl;
#ifdef PRIMARY_DEBUG
	int j;
	for(i=1;i<=N;i++){
		int res=0;
		int osn=1;
		for(j=0;j<=d;j++){
			res+=osn*P[j];
			osn*=i;
		}
		O<<res<<endl;
	}
#endif
}

int main(){
	in();
	sol();
	out();
	return 0;
}
