{$A+,B-,D+,E+,F-,G-,I+,L+,N-,O-,P-,Q-,R-,S+,T-,V+,X+}
Const InputFile='kitten.in';
      OutputFile='kitten.out';

Const MaxN=1001000;

Type Real=Double;

var a:Array[0..2*MaxN] of Longint;
    f:Array[0..2*MaxN] of Boolean;
    N:Longint;

    i,j:Longint;

Procedure FRead;
begin
Assign(Input,InputFile);
Reset(Input);
Assign(Output,OutputFile);
Rewrite(Output);
FillChar(a,Sizeof(a),0);
FillChar(f,SizeOf(f),False);
end;

Procedure FWrite(Answer:Longint);
begin
Close(Output);
Close(Input);
Halt;
end;

Procedure Add(i:Longint);
var k:Longint;
begin
k:=1;
Repeat
  Inc(a[i]);
  While i OR k=i Do k:=k shl 1;
  i:=i OR k;
  k:=k shl 1;
Until k>MaxN;
end;

Function Sum0(i:Longint):Longint;
begin
if i<0 then
  Sum0:=0
else
  Sum0:=Sum0(i AND (i+1)-1)+a[i];
end;

Function Sum(L,R:Longint):Longint;
begin
Sum:=Sum0(R)-Sum0(L-1);
end;

Procedure Solve;
var g,h:Longint;
begin
Repeat
  Read(g);
  if Abs(g)>MaxN then FWrite(43);
  if EoLn then
  begin
    Readln;
    g:=MaxN+g;
    if f[g]=False then Add(g);
    f[g]:=True;
  end
  else
  begin
    Readln(h);
    g:=MaxN+g;
    h:=MaxN+h;
    if g<h then
      Writeln(Sum(g,h))
    else
      Writeln(Sum(h,g));
  end;
Until EoF;
FWrite(1543);
end;

begin
FRead;
Solve;
end.