{$A+,B-,D+,E+,F-,G-,I+,L+,N+,O-,P-,Q-,R-,S-,T-,V+,X+}
Const InputFile='indirect.in';
      OutputFile='indirect.out';

Const N=32768;
Const Ans:Array[0..2] of String=('SUCCESSFUL TERMINATION','DIVISION BY ZERO','RUN-TIME ERROR');

Type Real=Double;

var a:Array[0..N] of Longint;
    Link:Array[1..N] of Longint;
    Cycled:Array[1..N] of Boolean;
    i,j:Longint;

Procedure FRead;
begin
FillChar(a,SizeOf(a),0);
Assign(Input,InputFile);
Reset(Input);

end;

Procedure FWrite(Answer:Longint);
begin
Close(Input);
Assign(Output,OutputFile);
Rewrite(Output);
Writeln(Ans[Answer]);
for i:=0 to N do
  Writeln(a[i]);
Close(Output);
Halt;
end;

Function GetLink(i:Longint):Longint;
begin
if a[i]<0 then
begin
  if Cycled[i] then FWrite(2);
  Link[i]:=GetLink(Link[i]);
  GetLink:=Link[i];
end
else
  GetLink:=i;
end;

Procedure Solve;
var g,h:Longint;
    what,where:Char;
    Num:Longint;
begin
FillChar(Link,SizeOf(Link),0);
FillChar(Cycled,SizeOf(Cycled),False);

While EoF=False Do
begin
  Read(what); Read(where); Readln(Num);
  if where='*' then
  begin
    j:=Num;
    j:=GetLink(j);
    Num:=a[j];
  end;
  h:=a[j];
  Case what of
  'A':Inc(a[0],Num);
  'S':Dec(a[0],Num);
  'M':a[0]:=a[0]*Num;
  'D':if Num=0 then
        FWrite(1)
      else
        a[0]:=a[0] div Num;
  'O':if Num=0 then
        FWrite(1)
      else
        a[0]:=a[0] mod Num;
  'R':a[0]:=Num;
  'W':a[j]:=a[0];
  end;
  if a[j]>=N then Dec(a[j],2*N);
  if a[j]<-N then Inc(a[j],2*N);
  if (j>0) AND (a[j]<0) then
  begin
    g:=a[j];
    a[j]:=0;
    if GetLink(-g)=j then
      Cycled[j]:=True
    else
      Link[j]:=GetLink(-g);
    a[j]:=g;
  end;
end;
FWrite(0);
end;

begin
FRead;
Solve;
end.