{$A+,B-,D+,E+,F-,G-,I+,L+,N-,O-,P-,Q-,R-,S+,T-,V+,X+}
Const InputFile='rle.in';
      OutputFile='rle.out';

Const MaxK=50100;

Type Real=Double;

var a:Array[1..MaxK] of Longint;
    b,ob:Array[1..MaxK,1..3] of Longint;
    c,oc:Array[1..MaxK,1..2] of Longint;
    tmp:Array[1..MaxK] of Longint;
    N,M,K,fc:Longint;

    i,j:Longint;

Procedure FRead;
begin
Assign(Input,InputFile);
Reset(Input);
Read(M,N,fc,K);
for i:=1 to K do
  Read(a[i]);
Close(Input);
end;

Procedure FWrite(Answer:Longint);
begin
Assign(Output,OutputFile);
Rewrite(Output);
Writeln(Answer);

Close(Output);
Halt;
end;

Procedure QSort(L,R:Longint);
var i,j:Longint;
    t,x:Longint;
begin
i:=L;
j:=R;
x:=tmp[(i+j) div 2];
Repeat
  While tmp[i]<x Do Inc(i);
  While tmp[j]>x Do Dec(j);
  if i<=j then
  begin
    t:=tmp[i];
    tmp[i]:=tmp[j];
    tmp[j]:=t;
    Inc(i);
    Dec(j);
  end;
Until i>j;
if i<R then QSort(i,R);
if L<j then QSort(L,j);
end;

Procedure Solve;
var g,h,p,q:Longint;
    x,r:Longint;
    Cur,Num:Longint;
    L,oL:Longint;
    c:Byte;
begin
c:=fc;
FillChar(ob,SizeOf(ob),0);
FillChar(b,SizeOf(b),0);
L:=0; oL:=0;
Cur:=0;
Num:=0;
x:=0;
for i:=1 to K do
begin
  if x+a[i]<M then
  begin
    if c=0 then
    begin
      x:=x+a[i];
    end
    else
    begin
      Inc(L);
      b[L,1]:=x+1;
      b[L,2]:=x+a[i];
      x:=x+a[i];
    end;
  end
  else
  begin
    r:=a[i];
    Dec(r,M-x);
    if c=1 then
    begin
      Inc(L);
      b[L,1]:=x+1;
      b[L,2]:=M;
      b[L,3]:=0;
      x:=M;
    end;

    q:=1;
    for p:=1 to oL do
    begin
      Dec(q);
      While (q<=L) AND (ob[p,1]>b[q,2]+1) Do Inc(q);
      While (q<=L) AND (ob[p,2]+1>=b[q,1]) Do
      begin
        if b[q,3]=0 then
          b[q,3]:=ob[p,3]
        else
        begin
          if b[q,3]<>ob[p,3] then
          begin
            Dec(Num);
            ob[p,3]:=b[q,3];
          end;
        end;
        Inc(q);
      end;
    end;
    for q:=1 to L do
      if b[q,3]=0 then
      begin
        Inc(Num);
        Inc(Cur);
        b[q,3]:=Cur;
      end;

    ob:=b;
    oL:=L;
    FillChar(b,SizeOf(b),0);
    L:=0;
    if r=0 then
    begin
      x:=0;
    end
    else if (r>0) AND (r<M) then
    begin
      if c=1 then
      begin
        L:=1;
        b[L,1]:=1;
        b[L,2]:=r;
        b[L,3]:=0;
      end;
      x:=r;
    end
    else
    begin
      if c=0 then
      begin
        oL:=0;
        FillChar(ob,Sizeof(ob),0);
        x:=r mod M;
      end
      else
      begin
        for p:=1 to oL do
          tmp[p]:=ob[p,3];
        QSort(1,oL);
        for p:=2 to oL do
          if tmp[p]<>tmp[p-1] then Dec(Num);
        h:=ob[1,3];

        oL:=1;
        FillChar(ob,Sizeof(ob),0);
        oB[1,1]:=1;
        oB[1,2]:=M;
        oB[1,3]:=h;
        if r mod M=0 then
          x:=M
        else
        begin
          x:=r mod M;
          L:=1;
          b[1,1]:=1;
          b[1,2]:=x;
          b[1,3]:=h;
        end;
      end;
    end;
  end;
  c:=1-c;
end;

FWrite(Num);
end;

begin
FRead;
Solve;
end.