{$A+,B-,D+,E+,F-,G-,I+,L+,N-,O-,P-,Q-,R-,S-,T-,V+,X+}
Const InputFile='kar.in';
      OutputFile='kar.out';

Const MaxN=1000000;
      MaxR=1000000;
      MaxR2=1000000;
Const HexDigits=['0'..'9','A'..'F'];
      Digits=['0'..'9'];
      ToHex:Array[0..15] of Char=('0','1','2','3','4','5','6','7','8','9','A','B','C','D','E','F');
Type Real=Double;
     BitVector=Array[0..2550] of Byte;

var a:Array[1..MaxN] of Longint;
    r:Array[1..MaxR] of Integer;
    r2:Array[1..MaxR2] of Byte;

    N,RN,R2N,Len:Longint;

    i,j:Longint;

Procedure FRead;
var ch:Char;
begin
N:=0;
Assign(Input,InputFile);
Reset(Input);
While EoF=False Do
begin
  Repeat Read(ch) Until (Eof) OR (ch in HexDigits);
  if EoF then Break;
  Inc(N);
  if ch in Digits then
    a[N]:=Ord(ch)-Ord('0')
  else
    a[N]:=Ord(ch)-Ord('A')+10;
  a[N]:=a[N]*16;
  Read(ch);
  if ch in Digits then
    a[N]:=a[N]+Ord(ch)-Ord('0')
  else
    a[N]:=a[N]+Ord(ch)-Ord('A')+10;
end;
Close(Input);
end;

Procedure FWrite(Answer:Longint);
begin
Assign(Output,OutputFile);
Rewrite(Output);
for i:=1 to Len do
  Write(ToHex[r2[i] div 16],ToHex[r2[i] mod 16]);
Close(Output);
Halt;
end;

var b,b2,c:Array[1..3200] of Longint;
    All,All2:Array[1..3200,1..3] of Longint;
    NA,NA2:Longint;

Function CmpAll(i,j:Longint):Shortint;
begin
if All[i,2]>All[j,2] then
  CmpAll:=1
else if All[i,2]<All[j,2] then
  CmpAll:=-1
else
begin
  if All[i,3]>All[j,3] then
    CmpAll:=1
  else if All[i,3]<All[j,3] then
    CmpAll:=-1
  else
    CmpAll:=0;
end;
end;

Procedure QSort(L,R:Longint);
var i,j:Longint;
begin
i:=L;
j:=R;
All[NA+1]:=All[(i+j) div 2];
Repeat
  While CmpAll(i,NA+1)=-1 Do Inc(i);
  While CmpAll(j,NA+1)= 1 Do Dec(j);
  if i<=j then
  begin
    All[NA+2]:=All[i];
    All[i]:=All[j];
    All[j]:=All[NA+2];
    Inc(i);
    Dec(j);
  end;
Until i>j;
if i<R then QSort(i,R);
if L<j then QSort(L,j);
end;

Function Find(i,j:Longint):Longint;
var L,R,m:Longint;
begin
L:=1; R:=NA;
While L<R Do
begin
  m:=(L+R) div 2;
  if (All[m,2]<i) then
    L:=m+1
  else if All[m,2]>i then
    R:=m-1
  else
  begin
    if (All[m,3]<j) then
      L:=m+1
    else if All[m,3]>j then
      R:=m-1
    else
    begin
      Find:=All[m,1];
      Exit;
    end;
  end;
end;
for m:=L-1 to R+1 do
  if (m>0) AND (m<=NA) then
  begin
    if (All[m,2]=i) AND (All[m,3]=j) then
    begin
      Find:=All[m,1];
      Exit;
    end;
  end;
Find:=-1;
end;

Procedure BuildTree(N:Longint);
var i,j,k,l,g,h:Longint;
begin
FillChar(All,SizeOf(All),0);
NA:=0;
g:=0;
for i:=1 to N do
  if b[i]>g then g:=b[i];
h:=0;
for l:=g downto 1 do
begin
  for i:=1 to N do
    if b[i]=l then
    begin
      Inc(NA);
      All[NA,1]:=i-1;
      All[NA,2]:=l;
      All[NA,3]:=h;
      Inc(h);
    end;
  h:=(h+1) shr 1;
end;
QSort(1,NA);
for j:=1 to 3 do
  All[NA+1,j]:=0;

end;

Function CmpAll2(i,j:Longint):Shortint;
begin
if All2[i,2]>All2[j,2] then
  CmpAll2:=1
else if All2[i,2]<All2[j,2] then
  CmpAll2:=-1
else
begin
  if All2[i,3]>All2[j,3] then
    CmpAll2:=1
  else if All2[i,3]<All2[j,3] then
    CmpAll2:=-1
  else
    CmpAll2:=0;
end;
end;

Procedure QSort2(L,R:Longint);
var i,j:Longint;
begin
i:=L;
j:=R;
All2[NA2+1]:=All2[(i+j) div 2];
Repeat
  While CmpAll2(i,NA2+1)=-1 Do Inc(i);
  While CmpAll2(j,NA2+1)= 1 Do Dec(j);
  if i<=j then
  begin
    All2[NA2+2]:=All2[i];
    All2[i]:=All2[j];
    All2[j]:=All2[NA2+2];
    Inc(i);
    Dec(j);
  end;
Until i>j;
if i<R then QSort2(i,R);
if L<j then QSort2(L,j);
end;

Function Find2(i,j:Longint):Longint;
var L,R,m:Longint;
begin
L:=1; R:=NA2;
While L<R Do
begin
  m:=(L+R) div 2;
  if (All2[m,2]<i) then
    L:=m+1
  else if All2[m,2]>i then
    R:=m-1
  else
  begin
    if (All2[m,3]<j) then
      L:=m+1
    else if All2[m,3]>j then
      R:=m-1
    else
    begin
      Find2:=All2[m,1];
      Exit;
    end;
  end;
end;
for m:=L-1 to R+1 do
  if (m>0) AND (m<=NA2) then
  begin
    if (All2[m,2]=i) AND (All2[m,3]=j) then
    begin
      Find2:=All2[m,1];
      Exit;
    end;
  end;
Find2:=-1;
end;

Procedure BuildTree2(N:Longint);
var i,j,k,l,g,h:Longint;
begin
FillChar(All2,SizeOf(All2),0);
NA2:=0;
g:=0;
for i:=1 to N do
  if b2[i]>g then g:=b2[i];
h:=0;
for l:=g downto 1 do
begin
  for i:=1 to N do
    if b2[i]=l then
    begin
      Inc(NA2);
      All2[NA2,1]:=i-1;
      All2[NA2,2]:=l;
      All2[NA2,3]:=h;
      Inc(h);
    end;
  h:=(h+1) shr 1;
end;
QSort2(1,NA2);
for j:=1 to 3 do
  All2[NA2+1,j]:=0;

end;


Procedure Solve;
var k,l,g,h,w,v,s:Longint;
    bv:BitVector;

begin
Len:=a[5]+a[6]*(1 shl 8)+a[7]*(1 shl 16)+a[8]*(1 shl 24);
for i:=1 to 12 do
begin
  g:=a[8+i];
  for j:=7 downto 0 do
  begin
    bv[8*(i-1)+j]:=g mod 2;
    g:=g shr 1;
  end;
end;

FillChar(b,SizeOf(b),0);
for i:=1 to 24 do
begin
  for j:=0 to 3 do
    b[i]:=b[i]*2+bv[(i-1)*4+j];
end;

BuildTree(24);

h:=0;
g:=0;
j:=0;
i:=20;
l:=8;
FillChar(c,SizeOf(c),0);
Repeat
  if l=8 then
  begin
    Inc(i);
    k:=a[i];
    for l:=7 downto 0 do
    begin
      bv[l]:=k mod 2;
      k:=k shr 1;
    end;
    l:=0;
  end;
  j:=j shl 1 + bv[l];
  Inc(h);
  k:=Find(h,j);
  if k>=0 then
  begin
    Inc(g);
    c[g]:=k;
    j:=0;
    h:=0;
  end;
  Inc(l);
Until (g=320);
for j:=1 to 288 do
  b[j]:=c[j];
for j:=289 to 320 do
  b2[j-288]:=c[j];
BuildTree(288);
BuildTree2(32);

h:=0;
g:=0;
j:=0;
w:=0;
FillChar(r,SizeOf(r),0);
Repeat
  if l=8 then
  begin
    Inc(i);
    if i>N then Break;
    k:=a[i];
    for l:=7 downto 0 do
    begin
      bv[l]:=k mod 2;
      k:=k shr 1;
    end;
    l:=0;
  end;
  j:=j shl 1 + bv[l];
  Inc(h);
  if w=0 then
    k:=Find(h,j)
  else if w=2 then
    k:=Find2(h,j)
  else if (w=1) OR (w=3) then
  begin
    Dec(s);
    k:=-1;
    if s=0 then
    begin
      Inc(g);
      if Odd(v) then
        r[g]:=1 shl (v shr 1 + 1)+j
      else
        r[g]:=3 shl (v shr 1 - 1)+j;
      if w=1 then
        w:=2
      else if w=3 then
      begin
        Inc(g);
        r[g]:=257;
        w:=0;
      end;
      j:=0;
      h:=0;
    end;
  end;

  if k>=0 then
  begin
    if (w=0) then
    begin
      Inc(g);
      r[g]:=k;
      if k>255 then
      begin
        r[g]:=256;
        v:=k-256;
        if Odd(v) then
          s:=(v shr 1)
        else
          s:=(v shr 1 - 1);
        if s>0 then
          w:=1
        else
        begin
          Inc(g);
          if v=0 then
            r[g]:=1
          else
          begin
            if Odd(v) then
              r[g]:=1 shl (v shr 1 + 1)
            else
              r[g]:=3 shl (v shr 1 - 1);
          end;
          w:=2;
        end;
      end;
    end
    else if w=2 then
    begin
      v:=k;
      if Odd(v) then
        s:=(v shr 1)
      else
        s:=(v shr 1 - 1);
      if s>0 then
        w:=3
      else
      begin
        Inc(g);
        if v=0 then
          r[g]:=1
        else
        begin
          if Odd(v) then
            r[g]:=1 shl (v shr 1 + 1)
          else
            r[g]:=3 shl (v shr 1 - 1);
        end;
        Inc(g);
        r[g]:=257;
        w:=0;
      end;

    end;
    h:=0;
    j:=0;
  end;
  Inc(l);
Until (False);
RN:=g;

R2N:=0;
i:=1;
While (R2N<=Len) AND (i<=RN) Do
begin
  if r[i]<=255 then
  begin
    Inc(R2N);
    r2[R2N]:=r[i];
  end
  else if r[i]=256 then
  begin
    if i<RN-2 then
    begin
      g:=R2N-r[i+1];
      if r[i+2]+R2N>Len then Break;
      for l:=1 to r[i+2] do
        r2[R2N+l]:=r2[g+l];
      Inc(R2N,l);
      Inc(i,3);
    end;
  end;
  Inc(i);
end;
FWrite(1543);
end;

begin
FRead;
Solve;
end.