const
  inf = 'customs.in'; ouf = 'customs.out';
  max = 120000;
  mm = 15000;
  verybig = 1000000003;
type
  longint = cardinal;
  liar = array[0..max] of longint;
  mliar = array[0..mm] of longint;

  procedure swap(var a, b: longint);
  var
    c: longint;
  begin
    c := a; a := b; b := c;
  end;
var
  n, m: longint;
  x, y, z: liar;
  v, cr: mliar;
  mx: longint;
  procedure qsort(l, r: longint);
  var
    i, j, md: longint;
  begin
    i := l; j := r; md := l + random(r - l + 1);
    mx := x[md];
    repeat
      while (x[i] < mx) do inc(i);
      while (x[j] > mx) do dec(j);
      if (i <= j) then
      begin
        swap(x[i], x[j]); swap(y[i], y[j]);
        swap(z[i], z[j]);
        inc(i); dec(j);
      end;
    until i > j;
    if (i < r) then qsort(i, r);
    if (j > l) then qsort(l, j);
  end;
var
  q: longint;
  h: mliar;
  d: mliar;
  a1, a2, a3: mliar;
  ww: array[1..mm] of byte;
  procedure down(k: longint);
  var
    l, j: longint;
  begin
    l := k; j := k shl 1;
    if (j <= q) and (cr[h[j]] < cr[h[l]]) then l := j;
    inc(j);
    if (j <= q) and (cr[h[j]] < cr[h[l]]) then l := j;
    if (l <> k) then
    begin
      d[h[l]] := k; d[h[k]] := l;
      swap(h[l], h[k]); down(l);
    end;
  end;
  procedure work(k: longint);
  var
    j: longint;
  begin
    j := k;
    while (j shr 1 > 0) and (cr[h[j shr 1]] > cr[h[j]]) do
    begin
      d[h[j shr 1]] := j;
      d[h[j]] := j shr 1;
      swap(h[j], h[j shr 1]);
      j := j shr 1;
    end;
    down(j);
  end;
  procedure go(c: longint);
  var
    i, j, b, w: longint;
    crc, b1, b2, b3: longint;
  begin
     for i := v[c] to v[c+1]-1 do
     begin
       b := y[i];
       if (d[b] > 0) then
       begin
          if (ww[b] = 0) then
          begin
            ww[b] := 1; a1[b] := 0;
            a2[b] := 0; a3[b] := 0;
          end;
          w := z[i];
          b1 := a1[c]; b2 := a2[c]; b3 := a3[c];
          if (w > b1) then
          begin
            b3 := b2; b2 := b1; b1 := w;
          end else
          if (w > b2) then
          begin
            b3 := b2; b2 := w;
          end else
          if (w > b3) then
            b3 := w;
          crc := b1 + b2 + b3;
          if (cr[b] > crc) then
          begin
            a1[b] := b1; a2[b] := b2; a3[b] := b3;
            cr[b] := crc;
          end;
          work(d[b]);
       end;
     end;
  end;
var
  a, b, c, i, j: longint;
begin
  assign(input, inf); reset(input);
  assign(output,ouf);rewrite(output);
  readln(input, n, m);
  randomize;
  fillchar(x, sizeof(x), 0); y := x; z := x;
  fillchar(ww, sizeof(ww), 0);
  for i := 1 to m do
    readln(input, x[i], y[i], z[i]);
  for i := m + 1 to m shl 1 do
  begin
    x[i] := y[i-m]; y[i] := x[i - m];
    z[i] := z[i-m];
  end;
  m := m shl 1;
  readln(input, a, b);
  for i := 1 to n do
  begin
    a1[i] := verybig;
    a2[i] := verybig;
    a3[i] := verybig;
    cr[i] := a1[i]+a2[i]+a3[i];
  end;
  qsort(1, m);
  fillchar(v, sizeof(v), 0);
  for i := 1 to m do
    if (x[i] <> x[i - 1]) then v[x[i]] := i;
  v[n+1] := m+1;
  for i := n downto 1 do
    if (v[i] = 0) then v[i] := v[i + 1];
  d[a] := 0;
  a1[a] := 0; a2[a] := 0; a3[a] := 0;
  cr[a] := 0;
  q := 0;
  for i := 1 to n do
    if (i <> a) then
    begin
      inc(q); h[q] := i; d[i] := q;
    end;
  ww[a] := 1;
  go(a); c := 0;
  while (c <> b) do
  begin
    c := h[1]; d[c] := 0;
    h[1] := h[q]; d[h[q]] := 1; h[q] := 0;
    dec(q); down(1);
    go(c);
  end;
  writeln(output, cr[b]);
  close(input); close(output);
end.
