{$I-,Q-,R-,S-}
const
  inf = 'indirect.in'; ouf = 'indirect.out';
  ok = 'SUCCESSFUL TERMINATION';
  dz = 'DIVISION BY ZERO';
  re = 'RUN-TIME ERROR';
  memo = 32768;
var
  mem: array[1..memo] of longint;
  w: array[1..memo] of longint;
  reg: longint;
  op, ch2: char;
  val, i: longint;
  cop: longint; er_cd: byte;
begin
  assign(input, inf); reset(input);
  assign(output,ouf);rewrite(output);
  reg := 0; cop := 0;
  fillchar(mem, sizeof(mem), 0);
  fillchar(w, sizeof(w), 0);
  er_cd := 0;
  while not eof(input) do
  begin
    inc(cop);
    read(input, op); read(input, ch2);
    readln(input, val);
    if (ch2 = '*') then
    begin
      while (mem[val] < 0) and (w[val] <> cop) do
      begin
         w[val] := cop;
         val := -mem[val];
      end;
      if (mem[val] < 0) then
      begin
        er_cd := 2; break;
      end;
      if (op <> 'W') then val := mem[val];
    end; {else val = val};
    case op of
      'A': reg := (reg + val) mod memo;
      'S': reg := (reg - val) mod memo;
      'M': reg := (reg * val) mod memo;
      'D': begin
             if (val = 0) then
             begin
                er_cd := 1; break;
             end else reg := reg div val;
           end;
      'O': begin
             if (val = 0) then
             begin
                er_cd := 1; break;
             end else reg := reg mod val;
           end;
      'R': reg := val;
      'W': mem[val] := reg;
    end;
  end;
  case er_cd of
     0: writeln(output, ok);
     1: writeln(output, dz);
     2: writeln(output, re);
  end;
  writeln(output, reg);
  for i := 1 to memo do
     writeln(output, mem[i]);
  close(input); close(output);
end.
