{$I-,Q-,R-,S-}
const
  inf = '2instr.in'; ouf = '2instr.out';
  hex: array[0..3] of longint = (1,16,256,4096);
  dgt: string[16] = '0123456789ABCDEF';
  max = 65535; qmax=150000;
var
  mem: array[0..max+1] of longint;
  q: array[1..qmax] of longint;
  w: array[0..qmax] of {byte} integer;
  ln, p: array[0..qmax] of longint;
  cv1, cv2: array[0..qmax] of longint;
  res: array[1..qmax] of longint;
  s: longint; f: longint;
  nx, cr, i, j, l, r, cm: longint;
  c: char;
begin
  assign(input, inf); reset(input);
  assign(output,ouf);rewrite(output);
  fillchar(w, sizeof(w), 0);
  fillchar(q, sizeof(q), 0);
  fillchar(mem,sizeof(mem), 0);
  s := 0; f := 0;
  read(input, c);
  while (c = ' ') do read(input, c);
  inc(s, (pos(c, dgt)-1)*hex[3]);
  read(input, c); inc(s, (pos(c, dgt)-1)*hex[2]);
  read(input, c); inc(s, (pos(c, dgt)-1)*hex[1]);
  read(input, c); inc(s, (pos(c, dgt)-1)*hex[0]);
  read(input, c);
  while (c = ' ') do read(input, c);
  inc(f, (pos(c, dgt)-1)*hex[3]);
  read(input, c); inc(f, (pos(c, dgt)-1)*hex[2]);
  read(input, c); inc(f, (pos(c, dgt)-1)*hex[1]);
  read(input, c); inc(f, (pos(c, dgt)-1)*hex[0]);
  readln(input);
  for i := 0 to 4095 do
  begin
    for j := 0 to 15 do
    begin
      cm := i*16+j;
      read(input, c);
      while (c = ' ') do read(input, c);
      inc(mem[cm], (pos(c,dgt)-1)*hex[1]);
      read(input, c);
      inc(mem[cm], (pos(c,dgt)-1)*hex[0]);
    end;
    readln(input);
  end;
  mem[max+1] := mem[0];
  fillchar(p, sizeof(p), 0);
  for i := 1 to qmax do ln[i] := -1;
  q[1] := s; w[1] := 1; l := 1; r := 1;
  ln[1] := 0; cv1[1] := s mod 256; cv2[1] := s div 256;
  while (l <= r) do
  begin
    cr := q[l];
    if (cr <= max) then
    begin
      {bswap sp}
      inc(r);
      cv1[r] := cv2[l]; cv2[r] := cv1[l];
      ln[r] := ln[l]+1; q[r] := max + 1 + cr;
      p[r] := l; w[q[r]] := 1;
      {pop sp}
      nx := mem[cr]+ mem[cr+1]*256;
      if (w[nx] = 0) then
      begin
        inc(r); p[r] := l;
        w[nx] := 1; q[r] := nx; ln[r] := ln[l]+1;
        cv1[r] := mem[cr]; cv2[r] := mem[cr + 1];
      end;
    end else
    begin
      nx := cv1[l] + cv2[l]*256;
      if (nx <= max) then
        if (w[nx] = 0) then
        begin
          inc(r); p[r] := l;
          w[nx] := 1; q[r] := nx;
          ln[r] := ln[l] + 1;
          cv1[r] := cv1[l]; cv2[r] := cv2[l];
        end;
    end;
    inc(l);
  end;
  if (w[f] = 0) then write(output, 'IMPOSSIBLE') else
  begin
    for i := 1 to qmax do
      if (q[i] = f) then break;
    writeln(output, ln[i]);
    j := 0;
    while (p[i] > 0) do
    begin
      inc(j);
      if (q[i] > max) and (q[p[i]] <= max) then
         res[j] := 15 else
      if (q[i] <= max) and (q[p[i]] > max) then
         res[j] := 204 else
         res[j] := 92;
      i := p[i];
    end;
    l := 0;
    for i := j downto 1 do
    begin
      inc(l);
      write(output, dgt[res[i] div 16+1], dgt[res[i] mod 16+1]);
      if (i = 1) then
        writeln(output)
      else
      begin
        if (l = 16) then
        begin
          l := 0; writeln(output);
        end else
        begin
          write(output,' ');
          if (l = 8) then
            write(output, ' ');
        end;
      end;
    end;
  end;
  close(input); close(output);
end.
