{$I-,Q-,R-,S-}
{$N+}
type
  real = double;
const
  max = 2500;
  inf = 'pipe.in'; ouf = 'pipe.out';
  dy = 0.001;
  eps = 1e-8;
  epans = 0.0005;
  big = 1e18;
var
  n, m: longint;
  dxm, x, y: array[1..max] of real;
  yc, yh, y1, d: real;
  i, j: longint;
  tcur, tdn, tup: real;
  function check: boolean;
  begin
    yc := y1; check := false;
    while (yc < yh+eps) do
    begin
      tdn := -big; tup := big;
      for i := 2 to m do
      begin
        tcur := (y[i] - yc)*dxm[i];
        if (tcur < tup) then tup := tcur;
        tcur := (y[i] - yc - 1)*dxm[i];
        if (tcur > tdn) then tdn := tcur;
      end;
      if (tdn < tup+eps) then
      begin
        check := true; exit;
      end;
      yc := yc + dy;
    end;
  end;
var
  l, r: longint;
  x1, k, y0, x0, ddy, ddx, mr, lr, rr: real;
begin
  assign(input, inf); reset(input);
  assign(output,ouf);rewrite(output);
  readln(input, n);
  for i := 1 to n do readln(input, x[i], y[i]);
  x1 := x[1];
  for i := 2 to n do dxm[i] := x[i] - x1;
  for i := 2 to n do dxm[i] := 1 / dxm[i];
  yh := y[1]; y1 := y[1]-1;
  m := n;
  if check then writeln(output, 'DELO TRUBA') else
  begin
    l := 1; r := n;
    while (r - l > 1) do
    begin
       m := (l + r) shr 1;
       if check then l := m else r := m;
    end;
    lr := 0; rr := x[r]-x[l]; m := r;
    ddy := y[r] - y[l]; y0 := y[l];
    ddx := x[r] - x[l]; x0 := x[l];
    k := ddy/ddx;
    while (rr - lr > epans) do
    begin
      mr := (lr + rr) / 2;
      x[r] := x0+mr;
      dxm[r] := 1 / (x[r] - x[1]);
      y[r] := k*mr + y0;
      if check then lr := mr else rr := mr;
    end;
    lr := x0 + lr;
    writeln(output, lr:2:2);
  end;
  close(input); close(output);
end.
