{$I-,Q-,R-,S-}
const
  inf = 'lcm.in'; ouf = 'lcm.out';
  md = 10000000;
type
  long = array[0..13000] of longint;
  procedure swap(var a, b: longint);
  var
    c: longint;
  begin
    c := a; a := b; b := c;
  end;
  procedure writelong(a: long);
  var
    l: longint;
    t: longint;
  begin
     l := a[0];
     while (l > 1) and (a[0] = 0) do dec(l);
     write(output, a[l]);
     dec(l);
     while (l > 0) do
     begin
       t := md div 10;
       while (t > 0) and (a[l] div t = 0) do
       begin
         write(output, 0); t := t div 10;
       end;
       if (a[l] > 0) then write(output, a[l]);
       dec(l);
     end;
  end;
  function gcd(a, b: longint): longint;
  var
    n, m: longint;
  begin
    n := a; m := b;
    if (m < n) then swap(n, m);
    while (n > 0) do
    begin
       m := m mod n; swap(n, m);
    end;
    gcd := m;
  end;
  function getmod(a: long; b: longint): longint;
  var
    i, l: longint;
    c: int64;
  begin
    l := a[0]; c := 0;
    for i := l downto 1 do
    begin
       c := c * md + a[i];
       c := c mod b;
    end;
    getmod := c;
  end;
  function mul(var a: long; b: int64): int64;
  var
    i, l: longint;
    c, d: int64;
  begin
    d := 0; l := a[0];
    for i := 1 to l do
    begin
       c := b * a[i] + d;
       a[i] := c mod md;
       d := c div md;
    end;
    while (d > 0) do
    begin
      inc(l);
      a[l] := d mod md; d := d div md;
    end;
    a[0] := l;
  end;
var
  n: longint;
  ma, b, c: longint;
  a: long;
  i: longint;
begin
  assign(input, inf); reset(input);
  assign(output,ouf); rewrite(output);
  fillchar(a, sizeof(a), 0);
  a[1] := 1; a[0] := 1;
  readln(input, n);
  for i := 1 to n do
  begin
    readln(input, b);
    ma := getmod(a, b);
    c := gcd(b, ma);
    b := b div c;
    mul(a, b);
  end;
  writelong(a);
  close(input); close(output);
end.
