{$ifdef DEBUG}
  {$I+,Q+,R+,S-}
{$else}
  {$I-,Q-,R-,S-}
{$endif}

program Programs;
const infile = 'programs.in';
      outfile = 'programs.out';
      MAXN = 600;
      MAXL = 600;
      MAXLENGTH = 290;
      BASE = 1000000;
type tLong = record
  l : integer;
  v : array[0..MAXLENGTH] of longint;
end;
var ln : array[1..MAXN] of integer;
    res : array[0..MAXL] of tLong;
    Temp : tLong;
    N, L : integer;

function max(a, b : integer) : integer;
begin
  if a>b then max:=a else max:=b;
end;

procedure ReadData;
var st : string;
    i : integer;
begin
  fillchar(res, sizeof(res), 0);
  assign(input, infile); reset(input);
  assign(output, outfile); rewrite(output);
  readln(N);
  for i:=1 to N do begin
    readln(st);
    inc(ln[length(st)]);
  end;
  read(L);
end;

procedure LongAddLong(var A, B, C : tLong);
var p, r : longint;
    i, m : integer;
begin
  m:=max(A.l, B.l); p:=0;
  for i:=1 to m do begin
    r:=p+A.v[i]+B.v[i];
    p:=r div BASE;
    r:=r mod BASE;
    C.v[i]:=r;
  end;
  C.l:=m;

  while p<>0 do begin
    inc(C.l);
    C.v[C.l]:=p mod BASE;
    p:=p div BASE;
  end;
end;

procedure LongMulLong(var A : tLong; B : integer; var C : tLong);
var p, r : longint;
    i, m : integer;
begin
  m:=A.l; p:=0;
  for i:=1 to m do begin
    r:=p+A.v[i]*B;
    p:=r div BASE;
    r:=r mod BASE;
    C.v[i]:=r;
  end;
  C.l:=m;

  while p<>0 do begin
    inc(C.l);
    C.v[C.l]:=p mod BASE;
    p:=p div BASE;
  end;
end;

procedure WriteLong(var A : tLong);
var i : integer;
    st : string[6];
begin
  write(A.v[A.l]);
  for i:=A.l-1 downto 1 do begin
    str(A.v[i], st);
    while length(st)<6 do st:='0'+st;
    write(st);
  end;
end;

procedure Solve;
var i, j : integer;
begin
  res[0].l:=1; res[0].v[1]:=1;

  for i:=1 to L do
    for j:=1 to 255 do begin
      if (i<j)or(ln[j]=0) then continue;

      if ln[j]=1 then begin
        LongAddLong(res[i], res[i-j], res[i]);
      end else begin
        fillchar(Temp, sizeof(Temp), 0);
        LongMulLong(res[i-j], ln[j], Temp);
        LongAddLong(res[i], Temp, res[i]);
      end;

    end;

  WriteLong(res[L]);
end;

procedure WriteData;
begin
  close(input);
  close(output);
end;

begin
  ReadData;
  Solve;
  WriteData;
end.
