{$ifdef DEBUG}
  {$I+,Q+,R+,S-}
{$else}
  {$I-,Q-,R-,S-}
{$endif}

program ItsASin;
const infile = 'sin.in';
      outfile = 'sin.out';
      MAXN = 100;
      inf = 1000000;
type real = extended;
var b : array[1..MAXN] of longint;
    res : array[1..MAXN, 0..MAXN, 0..MAXN] of real;
    from : array[1..MAXN, 0..MAXN, 0..MAXN] of integer;
    ans : array[1..MAXN] of integer;
    N : integer;

procedure ReadData;
var i, j, k : integer;
begin
  assign(input, infile); reset(input);
  assign(output, outfile); rewrite(output);
  read(N);
  for i:=1 to N do begin
    read(b[i]);
    b[i]:=b[i]*(i+1);
  end;

  for i:=1 to N do
    for j:=0 to N do
      for k:=0 to N do
        res[i, j, k]:=-inf;
end;

procedure Solve;
var k, s, p, l : integer;
    kmax, kmaxlast : integer;
    maxsum : real;
    temp : real;
begin
  for l:=1 to N do
    res[1, l, l]:=0;

  for k:=2 to N do
    for s:=k to N do
      for p:=1 to s-k+1 do
        for l:=1 to s-p do begin
          temp:=res[k-1, s-p, l] + sin(b[k-1]*l*p);
          if temp>res[k, s, p] then begin
            res[k, s, p]:=temp;
            from[k, s, p]:=l;
          end;
        end;

  maxsum:=-inf;
  for k:=2 to N do
    for l:=1 to N do
      if res[k, N, l]/k>maxsum then begin
        maxsum:=res[k, N, l]/k;
        kmax:=k; kmaxlast:=l;
      end;

  writeln(maxsum:0:6); s:=N; l:=kmaxlast;
  for k:=kmax downto 1 do begin
    ans[k]:=l; p:=s-l;
    l:=from[k, s, l];
    s:=p;
  end;

  for k:=1 to kmax do write(ans[k], ' ');
end;

procedure WriteData;
begin
  close(input);
  close(output);
end;

begin
  ReadData;
  Solve;
  WriteData;
end.
