{$ifdef DEBUG}
  {$I+,Q+,R+,S-}
{$else}
  {$I-,Q-,R-,S-}
{$endif}

program Temp;
const infile = 'small.in';
      outfile = 'small.out';
      inf = 20000;
var sums, sums2 : array[1..100, 1..100] of integer;
    res : array[1..100, 1..100] of integer;
    ans : array[1..100] of integer;
    from : array[1..100, 1..100] of integer;
    isloyal : array[1..99, 1..99] of boolean;
    streets : array[1..100] of integer;
    left, right, N, S, A : integer;

procedure ReadData;
var i, st, av : integer;
begin
  fillchar(sums, sizeof(sums), 0);
  fillchar(sums2, sizeof(sums2), 0);
  fillchar(from, sizeof(from), 0);
  assign(input, infile); reset(input);
  assign(output, outfile); rewrite(output);

  read(N);
  for i:=1 to N do begin
    read(st, av);
    isloyal[st, av]:=true;
  end;

  read(S); left:=101; right:=-1;
  for i:=1 to S do begin
    read(streets[i]);
    if streets[i]>right then right:=streets[i];
    if streets[i]<left then left:=streets[i];
  end;

  read(A);
end;

function GetSum(st1, av1, st2, av2 : integer) : integer;
var res : integer;
begin
  res:=sums[st2, av2]-sums[st1, av2]-sums[st2, av1]+sums[st1, av1];
  GetSum:=res;
end;

procedure CalcSums;
var st, av, av0, dt : integer;
begin
  for st:=2 to 100 do
    for av:=2 to 100 do begin
      if (isloyal[st-1, av-1])and(st-1>=left)and(st<=right) then dt:=1 else dt:=0;
      sums[st, av]:=sums[st-1, av]+sums[st, av-1]-sums[st-1, av-1]+dt;
    end;

  for av0:=1 to 99 do
    for av:=av0+1 to 100 do begin
      dt:=0;
      for st:=2 to S do
        if GetSum(streets[st-1], av0, streets[st], av)>0 then inc(dt);

      sums2[av0, av]:=dt;
    end;
end;

procedure Solve;
var st, av, av0, k : integer;
    max, maxav : integer;
begin
  CalcSums;

  for st:=1 to 100 do
    for av:=1 to 100 do
      res[st, av]:=-inf;

  for av:=1 to 100 do
    res[av, 1]:=0;

  for k:=2 to A do
    for av:=k to 100 do
      for av0:=1 to av-1 do begin

        if res[av0, k-1] + sums2[av0, av] > res[av, k] then begin
          res[av, k]:=res[av0, k-1] + sums2[av0, av];
          from[av, k]:=av0;
        end;

      end;

  max:=-1;
  for k:=100 downto 1 do
    if res[k, A]>max then begin
      max:=res[k, A];
      maxav:=k;
    end;

  for k:=A downto 1 do begin
    ans[k]:=maxav;
    maxav:=from[maxav, k];
  end;

  write(A);
  for k:=1 to A do
    write(' ', ans[k]);
end;

procedure WriteData;
begin
  close(input);
  close(output);
end;

begin
  ReadData;
  Solve;
  WriteData;
end.
