#include <stdio.h>

#define mm 50002

int h[mm], mark[mm], next[mm * 2], r[mm * 2], rr, l[mm], d[mm], t,
    _stklen = 2 * 1024 * 1024;

void dfs( int v )
{
  int i;

  if (mark[v])
    return;
  mark[v] = 1;
  for (i = h[v]; i != 0; i = next[i])
    dfs(r[i]);
}

int dfs2( int v )
{
  int i, c = 0;

  if (mark[v])
    return 0;
  mark[v] = 1;
  l[v] = d[v] = ++t;
  for (i = h[v]; i != 0; i = next[i])
    if (!mark[r[i]])
    {
      if (dfs2(r[i]))
        return 1;
      if (l[r[i]] < l[v])
        l[v] = l[r[i]];
      if (l[r[i]] < d[v])
        c++;
    }
    else if (mark[r[i]] == 2)
      return 1;
    else
    {
      if (d[r[i]] < l[v])
        l[v] = d[r[i]];
      c++;
    }
  mark[v] = 2;
  return (c > 1);
}

int main( void )
{
  int i, tt, x, y, n, m, f = 0;

  freopen("quirks.in", "r", stdin);
  freopen("quirks.out", "w", stdout);
  scanf("%d", &tt);
  while (tt--)
  {
    t = 0;
    scanf("%d%d", &n, &m);
    for (i = 1; i <= n; i++)
      d[i] = h[i] = l[i] = 0;
    rr = 0;
    for (i = 1; i <= m; i++)
    {
      scanf("%d%d", &x, &y);
      if (x == y)
        continue;
      r[++rr] = y;
      next[rr] = h[x];
      h[x] = rr;
    }
    for (i = 1; i <= n; i++)
      mark[i] = 0;
    for (i = 1; i <= n; i++)
      if (!mark[i])
      {
        f = i;
        dfs(i);
      }
    for (i = 1; i <= n; i++)
      mark[i] = 0;
    dfs(f);
    for (i = 1; i <= n; i++)
      if (!mark[i])
        break;
    if (i <= n)
    {
      printf("NO\n");
      continue;
    }
    for (i = 1; i <= n; i++)
      mark[i] = 0;
    if (dfs2(f))
      printf("NO\n");
    else
      printf("YES\n");
  }
  return 0;
}
