#include <stdio.h>
#include <math.h>

#define m 102
#define inf 1000

double a[m][m][m];
int d[m][m][m], b[m], _stklen = 1024 * 1024;

void write( int i, int j, int k )
{
  if (j == 1)
  {
    printf("%d ", k);
    return;
  }
  write(i - k, j - 1, d[i][j][k]);
  printf("%d ", k);
}

int main( void )
{
  int i, j, k, n, t, bj = 2, bk = 2;
  double s, bs;

  freopen("sin.in", "r", stdin);
  freopen("sin.out", "w", stdout);
  scanf("%d", &n);
  for (i = 1; i <= n; i++)
    scanf("%d", &b[i]);
  for (i = 0; i <= n; i++)
    for (j = 0; j <= n; j++)
      for (k = 0; k <= n; k++)
        a[i][j][k] = -inf;
  for (k = 1; k <= n; k++)
    a[k][1][k] = 0;
  for (i = 2; i <= n; i++)
    for (j = 2; j <= i; j++)
      for (k = 1; k + j - 1 <= i; k++)
        for (t = 1; t + k + j - 2 <= i; t++)
          if (a[i][j][k] <
             (s = a[i - k][j - 1][t] + sin(j * b[j - 1] * t * k)))
          {
            a[i][j][k] = s;
            d[i][j][k] = t;
          }
  bs = -inf;
  for (j = 2; j <= n; j++)
    for (k = 1; k <= n; k++)
      if (a[n][j][k] > bs * j)
      {
        bs = a[n][j][k] / j;
        bj = j, bk = k;
      }
  printf("%lf\n", bs);
  write(n, bj, bk);
  printf("\n");
  return 0;
}
