#include <stdio.h>

#define m 32770
#define mm 300000

short a[m];
char s1[mm], s2[mm];
int op[mm], p[m], f, st, fl, mark[m], i, _stklen = 2 * 1024 * 1024,
    up[m], rk[m];

int get( int x )
{
  if (p[x] == x)
    return x;
  return (p[x] = get(p[x]));
}

void join( int x, int y )
{
  x = get(x);
  y = get(y);
  if (x == y)
  {
    up[x] = -1;
    return;
  }
  if (rk[x] > rk[y])
    p[y] = x;
  else if (rk[x] < rk[y])
    p[x] = y;
  else
  {
    rk[x]++;
    p[y] = x;
  }
  up[x] = up[y];
}

int main( void )
{
  int c = 0, n;
  short r = 0, t;

  freopen("indirect.in", "r", stdin);
  freopen("indirect.out", "w", stdout);
  for (n = 1; scanf(" %c", &s1[n]) > 0; n++)
    scanf(" %c%d", &s2[n], &op[n]);
  n--;
  for (i = 1; i <= 32768; i++)
    p[i] = up[i] = i;
  for (i = 1; i <= n; i++)
  {
    if (s2[i] == '*')
    {
      c = up[get(op[i])];
      if (c < 0)
      {
        printf("RUN-TIME ERROR\n");
        break;
      }
      t = a[c];
    }
    else
      t = op[i];
    if (s1[i] == 'A')
      r += t;
    else if (s1[i] == 'S')
      r -= t;
    else if (s1[i] == 'M')
      r *= t;
    else if (s1[i] == 'D')
    {
      if (t == 0)
      {
        printf("DIVISION BY ZERO\n");
        break;
      }
      r /= t;
    }
    else if (s1[i] == 'O')
    {
      if (t == 0)
      {
        printf("DIVISION BY ZERO\n");
        break;
      }
      r %= t;
    }
    else if (s1[i] == 'R')
      r = t;
    else if (s1[i] == 'W')
    {
      a[c] = r;
      if (r < 0)
        join(c, -r);
    }
  }
  if (i > n)
    printf("SUCCESSFUL TERMINATION\n");
  printf("%d\n", (int)r);
  for (i = 1; i <= 32768; i++)
    printf("%d\n", (int)a[i]);
  return 0;
}
