#include <stdio.h>
#include <math.h>

#define mm 2000
#define vv 50002
#define inf 1000000000
#define sq(x) ((x) * (x))

typedef struct
{
  int x, y;
}
pnt;

int a[mm + 5][mm + 5], d[mm + 5][mm + 5];
pnt p[vv], q[vv];

int main( void )
{
  int i, j, n, m, s;

  freopen("rescue.in", "r", stdin);
  freopen("rescue.out", "w", stdout);
  scanf("%d%d", &n, &m);
  for (i = 1; i <= n; i++)
    scanf("%d%d", &p[i].x, &p[i].y);
  for (i = 1; i <= m; i++)
    scanf("%d%d", &q[i].x, &q[i].y);
  for (s = inf, i = 1; i <= n; i++)
  {
    if (p[i].x < s)
      s = p[i].x;
    if (p[i].y < s)
      s = p[i].y;
  }
  for (i = 1; i <= m; i++)
  {
    if (q[i].x < s)
      s = p[i].x;
    if (q[i].y < s)
      s = q[i].y;
  }
  for (i = 1; i <= n; i++)
  {
    p[i].x -= (s - 1);
    p[i].y -= (s - 1);
  }
  for (i = 1; i <= m; i++)
  {
    q[i].x -= (s - 1);
    q[i].y -= (s - 1);
  }
  for (i = 0; i <= mm; i++)
    for (j = 0; j <= mm; j++)
      d[i][j] = inf;
  for (i = 1; i <= n; i++)
  {
    a[p[i].x][p[i].y] = i;
    d[p[i].x][p[i].y] = 0;
  }
  p[0].x = p[0].y = 10000;
  for (i = 1; i <= mm; i++)
    for (j = 1; j <= mm; j++)
    {
      int dd = d[i][j], d1, d2, d3, d4, i1, i2, i3, i4, ii = a[i][j];

      i1 = a[i - 1][j - 1];
      i2 = a[i - 1][j];
      i3 = a[i - 1][j + 1];
      i4 = a[i][j - 1];
      d1 = sq(p[i1].x - i) + sq(p[i1].y - j);
      d2 = sq(p[i2].x - i) + sq(p[i2].y - j);
      d3 = sq(p[i3].x - i) + sq(p[i3].y - j);
      d4 = sq(p[i4].x - i) + sq(p[i4].y - j);
      if (d1 < dd)
        dd = d1, ii = i1;
      if (d2 < dd)
        dd = d2, ii = i2;
      if (d3 < dd)
        dd = d3, ii = i3;
      if (d4 < dd)
        dd = d4, ii = i4;
      d[i][j] = dd;
      a[i][j] = ii;
    }
  for (i = mm; i > 0; i--)
    for (j = mm; j > 0; j--)
    {
      int dd = d[i][j], d1, d2, d3, d4, i1, i2, i3, i4, ii = a[i][j];

      i1 = a[i + 1][j - 1];
      i2 = a[i + 1][j];
      i3 = a[i + 1][j + 1];
      i4 = a[i][j + 1];
      d1 = sq(p[i1].x - i) + sq(p[i1].y - j);
      d2 = sq(p[i2].x - i) + sq(p[i2].y - j);
      d3 = sq(p[i3].x - i) + sq(p[i3].y - j);
      d4 = sq(p[i4].x - i) + sq(p[i4].y - j);
      if (d1 < dd)
        dd = d1, ii = i1;
      if (d2 < dd)
        dd = d2, ii = i2;
      if (d3 < dd)
        dd = d3, ii = i3;
      if (d4 < dd)
        dd = d4, ii = i4;
      d[i][j] = dd;
      a[i][j] = ii;
    }
  for (i = 1; i <= m; i++)
  {
    pnt pp = p[a[q[i].x][q[i].y]];

    printf("%d %d\n", pp.x + s - 1, pp.y + s - 1);
  }
  return 0;
}
