#include <stdio.h>

#define m 1002
#define mm 200005

typedef struct
{
  int x, f;
}
pnt;

pnt a[mm], b[mm];
int x1[m], x2[m];

void swp( pnt *a, int i, int j )
{
  pnt t = a[i];

  a[i] = a[j];
  a[j] = t;
}

void down( pnt *a, int v, int n )
{
  while ((v * 2 <= n && a[v * 2].x > a[v].x)
         || (v * 2 + 1 <= n && a[v * 2 + 1].x > a[v].x))
    if (v * 2 + 1 <= n && a[v * 2 + 1].x > a[v * 2].x)
    {
      swp(a, v, v * 2 + 1);
      v = v * 2 + 1;
    }
    else
    {
      swp(a, v, v * 2);
      v *= 2;
    }
}

void sort( pnt *a, int n )
{
  int i;

  for (i = n; i > 0; i--)
    down(a, i, n);
  for (i = n; i > 1; i--)
  {
    swp(a, i, 1);
    down(a, 1, i - 1);
  }
}

int main( void )
{
  int i, j, s, x, y, k, n, c, n1 = 0, n2 = 0, ss;

  freopen("elevator.in", "r", stdin);
  freopen("elevator.out", "w", stdout);
  scanf("%d%d%d", &n, &c, &k);
  for (i = 1; i <= k; i++)
  {
    scanf("%d%d", &x, &y);
    if (x < y)
    {
      a[++n1].x = x;
      a[n1].f = 1;
      a[++n1].x = y;
      a[n1].f = 0;
    }
    else
    {
      b[++n2].x = y;
      b[n2].f = 1;
      b[++n2].x = x;
      b[n2].f = 0;
    }
  }
  sort(a, n1);
  sort(b, n2);
  for (s = 0, i = j = 1; i <= n; i++)
  {
    for (; j <= n1 && a[j].x < i; j++)
      ;
    for (; j <= n1 && a[j].x == i; j++)
      if (a[j].f)
        s++;
      else
        s--;
    x1[i] = s;
  }
  for (s = 0, i = j = 1; i <= n; i++)
  {
    for (; j <= n2 && b[j].x < i; j++)
      ;
    for (; j <= n2 && b[j].x == i; j++)
      if (b[j].f)
        s++;
      else
        s--;
    x2[i] = s;
  }
  for (i = 1, s = 0; i < n; i++)
  {
    int t1 = (x1[i] + c - 1) / c, t2 = (x2[i] + c - 1) / c;

    if (t1 > t2)
      s += t1 * 2;
    else
      s += t2 * 2;
  }
  for (ss = 0, i = n - 1; i > 0; i--)
  {
    if (x1[i] || x2[i])
      ss = 1;
    if (ss && x1[i] == 0 && x2[i] == 0)
      s += 2;
  }
  printf("%d\n", s * 5);
  return 0;
}
