{$q+,r+,n-}

const cinfile = 'customs.in';
      coutfile = 'customs.out';

const nmax = 10001;
      mmax = 100001;
      inf = maxlongint shr 1;

type int = longint;
     tway = array[0..3] of int;

var a       : array[1..nmax] of tway;
    q       : array[0..nmax] of int;
    head, p : array[1..nmax] of int;
    use     : array[1..nmax] of byte;
    e       : array[1..2*mmax, 0..2] of int;
    n, m, s, f : int;

procedure init;
var i, x, y, z : int;
begin
   read(n, m);
   fillchar(head, sizeof(head), 0);
   for i:=1 to m do begin
      read(x, y, z);
      e[2*i-1][0]:=z;
      e[2*i-1][1]:=y;
      e[2*i-1][2]:=head[x];
      head[x]:=2*i-1;

      e[2*i][0]:=z;
      e[2*i][1]:=x;
      e[2*i][2]:=head[y];
      head[y]:=2*i;
   end;
   read(s, f);
end;

function max(x, y : int) : int;
begin
   if x > y then max:=x else max:=y;
end;

procedure swap(x, y : int);
var t : int;
begin
   t:=q[x]; q[x]:=q[y]; q[y]:=t;
   t:=p[x]; p[x]:=p[y]; p[y]:=t;
end;

procedure sift_up(x : int);
begin
   while x > 1 do begin
      if a[q[x]][0] >= a[q[x div 2]][0] then exit;
      swap(x, x div 2);
      x:=x div 2;
   end;
end;

procedure sift_down(x : int);
var l : int;
begin
   l:=x;
   while true do begin
      if 2*x <= q[0] then
         if a[q[l]][0] > a[q[2*x]][0] then l:=2*x;
      if 2*x < q[0] then
         if a[q[l]][0] > a[q[2*x+1]][0] then l:=2*x+1;
      if x = l then exit;
      swap(x, l);
      x:=l;
   end;
end;

function res(x : tway; y : int) : tway;
var i, j : int;
begin
   i:=0;
   for j:=1 to 3 do
      if x[j] < y then i:=j;
   if i <> 0 then begin
      for j:=1 to i-1 do x[j]:=x[j+1];
      x[i]:=y;
      x[0]:=0;
      for j:=1 to 3 do
         if x[j] < inf then inc(x[0], x[j]);
   end;
   res:=x;
end;

procedure solve;
var i, j, k : int;
    t : tway;
begin
   fillchar(use, sizeof(use), 0);
   fillchar(p, sizeof(p), 0);
   for i:=1 to n do
      for j:=0 to 3 do a[i, j]:=inf;
   for j:=0 to 3 do a[s, j]:=0;
   q[0]:=1;
   q[1]:=s;
   p[s]:=1;
   while q[0] > 0 do begin
      i:=q[1];
      if i = f then exit;
      use[i]:=1;
      swap(1, q[0]);
      dec(q[0]);
      sift_down(1);

      j:=head[i];
      while j > 0 do begin
         k:=e[j][1];
         if use[k] = 0 then begin
            t:=res(a[i], e[j][0]);
            if t[0] < a[k][0] then begin
               a[k]:=t;
               if p[k] = 0 then begin
                  inc(q[0]);
                  q[q[0]]:=k;
                  p[k]:=q[0];
               end;
               sift_up(p[k]);
            end;
         end;
         j:=e[j][2];
      end;
   end;
end;

procedure writeanswer;
begin
   write(a[f][0]);
end;

begin
   assign(input, cinfile); reset(input);
   assign(output, coutfile); rewrite(output);
   init;
   solve;
   writeanswer;
   close(input); close(output);
end.
