{$q+,r+,n-}

const cinfile = 'quirks.in';
      coutfile = 'quirks.out';

const nmax = 52001;
      inf = maxlongint shr 1;

type int = longint;
     tgraph = record
                 head : array[1..nmax] of int;
                 e    : array[1..nmax, 1..2] of int;
                 m    : int;
              end;

var col, time, use : array[1..nmax] of int;
    w              : array[1..nmax, 0..2] of int;
    g, invg        : tgraph;
    n, t  : int;
    found : boolean;

procedure init;
var i, x, y : int;
begin
   fillchar(g.head, sizeof(g.head), 0);
   fillchar(invg.head, sizeof(invg.head), 0);
   read(n, g.m);
   for i:=1 to g.m do begin
      read(x, y);
      with g do begin
         e[i][1]:=y;
         e[i][2]:=head[x];
         head[x]:=i;
      end;
      with invg do begin
         e[i][1]:=x;
         e[i][2]:=head[y];
         head[y]:=i;
      end;
   end;
end;

procedure solve;
var i, cc, t, tt : int;
   procedure dfs_fst(x : int);
   var j, k : int;
      procedure relax_w;
      var tmp : int;
      begin
         if w[k, 2] < w[x, 1] then begin
            w[x, 1]:=w[k, 1];
            w[x, 2]:=w[k, 2];
            exit;
         end;
         if w[x, 2] <= w[k, 1] then exit;
         w[x, 2]:=w[k, 1];
         if w[x, 1] > w[x, 2] then begin
            tmp:=w[x, 1];
            w[x, 1]:=w[x, 2];
            w[x, 2]:=tmp;
         end;
      end;
   begin
      col[x]:=i;
      use[x]:=1;
      inc(tt);
      w[x, 0]:=tt;
      w[x, 1]:=tt;
      w[x, 2]:=inf;
      with g do begin
         j:=head[x];
         while j > 0 do begin
            k:=e[j][1];
            if use[k] = 0 then begin
               dfs_fst(k);
               if (w[k, 1] <= w[x, 0]) and (w[k, 2] <= w[x, 0]) then found:=true;
               if found then exit;
               relax_w;
            end else
               if use[k] = 2 then begin
                  if col[x] = col[k] then begin
                     found:=true;
                     exit;
                  end;
               end else relax_w;

            j:=e[j][2];
         end;
      end;
      use[x]:=1;
      inc(t);
      time[t]:=x;
   end;
   procedure dfs_snd(x : int);
   var j : int;
   begin
      col[x]:=cc;
      with invg do begin
         j:=head[x];
         while j > 0 do begin
            if col[e[j][1]] = 0 then
               dfs_snd(e[j][1]);
            j:=e[j][2];
         end;
      end;
   end;
   procedure dfs_thd(x : int);
   var j, k : int;
   begin
      with invg do begin
         j:=head[x];
         while j > 0 do begin
            k:=e[j][1];
            if time[k] = 0 then begin
               dfs_thd(k);
               if found then exit;
               time[k]:=x;
            end else begin
               if time[k] <> x then begin
                  found:=true;
                  exit;
               end;
            end;
            j:=e[j][2];
         end;
      end;
   end;
begin
   fillchar(use, sizeof(use), 0);
   fillchar(time, sizeof(time), 0);
   t:=0;
   tt:=0;
   found:=false;
   for i:=1 to n do
      if use[i] = 0 then dfs_fst(i);
   if found then exit;

   fillchar(col, sizeof(col), 0);
   cc:=0;
   for i:=n downto 1 do
      if col[time[i]] = 0 then begin
         inc(cc);
         dfs_snd(time[i]);
      end;

   fillchar(invg.head, sizeof(invg.head), 0);
   invg.m:=0;
   for i:=1 to g.m do begin
      t:=g.head[i];
      while t > 0 do begin
         if col[i] <> col[g.e[t][1]] then
            with invg do begin
               inc(m);
               e[m][1]:=col[g.e[t][1]];
               e[m][2]:=head[col[i]];
               head[col[i]]:=m;
            end;
         t:=g.e[t][2];
      end;
   end;

   fillchar(time, sizeof(time), 0);
   for i:=1 to cc do
      if time[i] = 0 then dfs_thd(i);
   if found then exit;
   t:=0;
   for i:=1 to cc do
      if time[i] = 0 then inc(t);
   found:=not (t = 1);
end;

procedure writeanswer;
begin
   if found then writeln('NO')
            else writeln('YES');
end;

begin
   assign(input, cinfile); reset(input);
   assign(output, coutfile); rewrite(output);
   read(t);
   while t > 0 do begin
      init;
      solve;
      writeanswer;
      dec(t);
   end;
   close(input); close(output);
end.