{$q+,r+,n+}

const cinfile = 'programs.in';
      coutfile = 'programs.out';
      alph = [#32..#126];

const nmax    = 601;
      lenmax  = 255;
      base    = 1000000;
      invbase = 0.000001;
      eps     = 0.00000001;
      logbase = 6;
      barr : array[1..logbase-1] of longint = (10, 100, 1000, 10000, 100000);

type int = longint;
     tlong = array[0..500] of int;

var a : array[0..nmax] of tlong;
    c : array[1..lenmax] of int;
    n, l : int;

procedure add_mul_int(var r : tlong; x : tlong; y : int);
var i, t, tt : int;
begin
   t:=0;
   for i:=1 to x[0] do begin
      x[i]:=x[i] * y + t;
//      t:=trunc(x[i] * invbase + eps);
      t:=x[i] div base;
      dec(x[i], base * t);
   end;
   while t > 0 do begin
//      tt:=trunc(t * invbase + eps);
      tt:=t div base;
      inc(x[0]);
      x[x[0]]:=t - base * tt;
      t:=tt;
   end;

   if r[0] < x[0] then r[0]:=x[0];
   for i:=1 to r[0] do begin
      inc(r[i], x[i]);
      if r[i] >= base then begin
         inc(r[i+1]);
         dec(r[i], base);
      end;
   end;
   if r[r[0]+1] <> 0 then inc(r[0]);
end;

procedure writelong(var x : tlong);
var i, j : int;
begin
   write(x[x[0]]);
   for i:=x[0]-1 downto 1 do begin
      for j:=logbase-1 downto 1 do
         if x[i] >= barr[j] then break else write('0');
      write(x[i]);
   end;
end;

procedure init;
var i, cc  : int;
    ch : char;
begin
   fillchar(c, sizeof(c), 0);
   readln(n);
   for i:=1 to n do begin
      cc:=0;
      read(ch);
      while ch in alph do begin
         if ch <> #32 then inc(cc);
         read(ch);
      end;
      inc(c[cc]);
      readln;
   end;
   read(l);
end;

procedure solve;
var i, j : int;
begin
   fillchar(a, sizeof(a), 0);
   a[0][0]:=1;
   a[0][1]:=1;
   for i:=1 to l do
      for j:=1 to lenmax do if c[j] > 0 then
         if i < j then break else
            add_mul_int(a[i], a[i - j], c[j]);
end;

begin
   assign(input, cinfile); reset(input);
   assign(output, coutfile); rewrite(output);
   init;
   solve;
   writelong(a[l]);
   close(input); close(output);
end.