{$q+,r+,n-}

//uses SysUtils;

const cinfile = 'rescue.in';
      coutfile = 'rescue.out';

const cmax = 1000;
      inf = maxlongint;

type int = longint;
     tpoint = array[1..2] of int;

var f     : array[-cmax..cmax, -cmax..cmax] of byte;
    d     : array[-cmax..cmax, -cmax..cmax] of int;
    a     : array[-cmax..cmax, -cmax..cmax] of tpoint;
    query : array[1..50001] of tpoint;
    last  : array[-cmax..cmax] of int;
    n, m : int;

//    told, tnew : tdatetime;

procedure init;
var i, x, y : int;
begin
   fillchar(f, sizeof(f), 0);
   read(n, m);
   for i:=1 to n do begin
      read(x, y);
      f[x, y]:=2;
   end;
   for i:=1 to m do begin
      read(x, y);
      query[i, 1]:=x;
      query[i, 2]:=y;
      if f[x, y] <> 2 then begin
         f[x, y]:=1;
         d[x, y]:=inf;
      end;
   end;
end;

procedure solve;
var i, j, t, k, pred, dcur : int;
    cpred, cur : tpoint;
begin
   for j:=-cmax to cmax do last[j]:=-cmax-1;
   for i:=-cmax to cmax do begin
      for j:=-cmax to cmax do
         if f[i, j] = 2 then last[j]:=i;
      pred:=-cmax;
      cpred[1]:=inf;
      for j:=-cmax to cmax do
         if f[i, j] = 1 then begin
            dcur:=inf;
            cur[1]:=-cmax;
            if cpred[1] <> inf then begin
               k:=sqr(a[i, j][1] - cpred[1]) + sqr(a[i, j][2] - cpred[2]);
               if d[i, j] > k then begin
                  d[i, j]:=k;
                  a[i, j]:=cpred;
                  dcur:=d[i, j];
                  cur:=cpred;
               end;
            end;

            for t:=pred to cmax do begin
               if (j < t) and (sqr(j - t) >= d[i, j]) then break;
               if last[t] >= cur[1] then begin
                  k:=sqr(i - last[t]) + sqr(j - t);
                  if dcur >= k then begin
                     dcur:=k;
                     cur[1]:=last[t];
                     cur[2]:=t;
                  end;
               end;
            end;
            pred:=cur[2];
            d[i, j]:=dcur;
            a[i, j]:=cur;
            cpred:=cur;
         end;
   end;

   for j:=-cmax to cmax do last[j]:=cmax+1;
   for i:=cmax downto -cmax do begin
      for j:=-cmax to cmax do
         if f[i, j] = 2 then last[j]:=i;
      pred:=-cmax;
      cpred[1]:=inf;
      for j:=-cmax to cmax do
         if f[i, j] = 1 then begin
            cur[1]:=cmax;
            dcur:=inf;
            if cpred[1] <> inf then begin
               k:=sqr(a[i, j][1] - cpred[1]) + sqr(a[i, j][2] - cpred[2]);
               if d[i, j] > k then begin
                  d[i, j]:=k;
                  a[i, j]:=cpred;
                  dcur:=d[i, j];
                  cur:=cpred;
               end;
            end;

            for t:=pred to cmax do begin
               if (j < t) and (sqr(j - t) >= d[i, j]) then break;
               if last[t] <= cur[1] then begin
                  k:=sqr(i - last[t]) + sqr(j - t);
                  if dcur >= k then begin
                     dcur:=k;
                     cur[1]:=last[t];
                     cur[2]:=t;
                  end;
               end;
            end;
            pred:=cur[2];
            if dcur < d[i, j] then begin
               a[i, j]:=cur;
               d[i, j]:=dcur;
            end;
            cpred:=cur;
         end;
   end;
end;

procedure writeanswer;
var i, x, y : int;
begin
   for i:=1 to m do begin
      x:=query[i, 1];
      y:=query[i, 2];
      if f[x, y] = 2 then writeln(x, ' ', y)
      else writeln(a[x, y][1], ' ', a[x, y][2]);
   end;

end;

begin
//   told:=now;

   assign(input, cinfile); reset(input);
   assign(output, coutfile); rewrite(output);
   init;
   solve;
   writeanswer;

//   tnew:=now;
//   writeln('time: ', (tnew-told)*24*60*60 :0 :4);

   close(input); close(output);
end.
