program Problem2;

{$D-,R-,Q-,L-}

{

  EVA RULEZZZ!!!!!!!

  Fight with the best? Die like the rest!

  Copyright by [ hr0nix@darkwired ]

}

const
  InFile = 'kitten.in';
  OutFile = 'kitten.out';
  MaxN = 1000001;
  Inf = 100000000;
  MaxQ = 20001;

type
  Int = longint;
  Real = extended;
  TQuery = record
    m1, m2 : Int;
  end;

var
  a1 : array [-MaxN..MaxN] of boolean;
  a2 : array [-MaxN..MaxN] of Int;
  queries : array [1..MaxQ] of TQuery;
  ct1, ct2, numqueries, maxqf : Int;

function min( n1, n2 : Int ) : Int;
begin
  if n1 < n2 then
    min := n1
  else
    min := n2;
end;

function max( n1, n2 : Int ) : Int;
begin
  if n1 > n2 then
    max := n1
  else
    max := n2;
end;

procedure OpenFiles;
begin
  assign( input, InFile );
  reset( input );
  assign( output, OutFile );
  rewrite( output );
end;

procedure CloseFiles;
begin
  close( input );
  close( output );
end;

procedure InitData;
var
  i : Int;
begin
  i := 0;
  ct1 := 0;
  ct2 := 0;
  maxqf := -1;
  while not( eof ) do begin
    inc( i );
    read( queries[ i ].m1 );
    if seekeoln then begin
      queries[ i ].m2 := Inf;
      inc( ct1 );
      readln;
    end
    else begin
      inc( ct2 );
      readln( queries[ i ].m2 );
      maxqf := max( maxqf, queries[ i ].m2 );
    end;
  end;
  numqueries := i;
end;

procedure Solve;
var
  i, j, sum : Int;
begin
  if ct1 > ct2 then begin
    fillchar( a1, sizeof( a2 ), false );
    for i := 1 to numqueries do
      if queries[ i ].m2 = Inf then
        a1[ queries[ i ].m1 ] := true
      else begin
        sum := 0;
        for j := min( queries[i].m1, queries[i].m2 ) to max( queries[i].m1, queries[i].m2 ) do
          if a1[ j ] then
            inc( sum );
        writeln( sum );
      end;
  end else begin
    fillchar( a1, sizeof( a1 ), false );
    fillchar( a2, sizeof( a2 ), 0 );
    for i := 1 to numqueries do
      if queries[ i ].m2 = Inf then begin
        if not( a1[ queries[ i ].m1 ] ) then begin
          for j := queries[ i ].m1 to maxqf do
            inc( a2[ j ] );
          a1[ queries[ i ].m1 ] := true;
        end;
      end
      else begin
        writeln( a2[ max( queries[i].m1, queries[i].m2 ) ] - a2[ min( queries[i].m1, queries[i].m2 ) - 1 ] );
      end;
  end;
end;

begin
  OpenFiles;
  InitData;
  Solve;
  CloseFiles;
end.
