{$A+,B-,D-,E-,F-,G+,I+,L-,N+,O+,P-,Q-,R-,S-,T-,V+,X+,Y+}
{$M 16384,0,655360}
program Quirks;


{

  EVA RULEZZZ!!!!!!!

  Fight with the best? Die like the rest!

  Copyright by [ hr0nix@darkwired ]

}

const
  InFile = 'quirks.in';
  OutFile = 'quirks.out';
  MaxN = 50000;
  MaxM = 50000;
  MaXXX = MaxLongInt div 100;

type
  Int = longint;
  Real = extended;

type
  TEdge = record
    v1, v2 : Int;
    deleted : boolean;
  end;

var
  edges : array [1..MaxM] of TEdge;
  marks : array [1..MaxN] of Int;
  been : array [1..MaxN] of boolean;
  up, tv, time : array [0..MaxN+1] of Int;
  n, m, ts, deleted, t : Int;

procedure OpenFiles;
begin
  assign( input, InFile );
  reset( input );
  assign( output, OutFile );
  rewrite( output );
end;

procedure CloseFiles;
begin
  close( input );
  close( output );
end;

procedure InitData;
var
  i : Int;
begin
  read( n, m );
  for i := 1 to m do begin
    read( edges[i].v1, edges[i].v2 );
    edges[i].deleted := false;
  end;
end;

procedure TopSort( v : Int );
var
  i : Int;
begin
  been[v] := true;
  for i := 1 to m do
    if ( edges[i].v1 = v ) and ( not( been[ edges[i].v2 ] ) ) then
      TopSort( edges[i].v2 );
  inc( ts );
  marks[v] := ts;
end;

function min( n1, n2 : Int ) : Int;
begin
  if n1 < n2 then
    min := n1
  else
    min := n2;
end;

function IsDaFuckingTree( root : Int ) : boolean;
var
  t : Int;

  function dfs(i:int):boolean;
  var p:Int;
      b:boolean;
      u:int;

  begin
    been[i]:=true;
    time[i]:=0;
    inc(t);
    tv[i]:=t;
    up[i]:=tv[i];
    u:=MaXXX;
    b:=true;
    p:=1;
    while ( p <= m ) do
      begin
       if edges[p].v1 <> i then begin
         inc( p );
         continue;
       end;
       if not been[edges[p].v2] then
        begin
         b:=b and dfs(edges[p].v2);
         u:=min(u,up[edges[p].v2]);
        end
       Else
        begin
         if not(time[edges[p].v2]=0) then
           b:=false
         else
           begin
             up[i]:=min(up[i],tv[edges[p].v2]);
           end;
        end;
       inc( p );
      end;
    if (u<tv[i]) and (up[i]<tv[i]) then
       b:=false;
    up[i]:=min(up[i],u);
    inc(t);
    time[i]:=t;
    dfs:=b;
  end;

begin
 fillchar(time,sizeof(time),0);
 fillchar(tv,sizeof(tv),0);
 fillchar(up,sizeof(up),0);
 t:=0;
 if not dfs(Root) then
   IsDaFuckingTree:=false
 else
   IsDaFuckingTree:=true;
end;

procedure dfs( v : Int );
var
  i : Int;
begin
  been[v] := true;
  for i := 1 to m do
    if ( edges[i].v1 = v ) and ( not( been[ edges[i].v2 ] ) ) then
      dfs( edges[i].v2 );
end;

procedure Solve;
var
  i, root : Int;
begin
  { Looking for root }
  fillchar( been, sizeof( been ), false );
  fillchar( marks, sizeof( marks ), 0 );
  root := -1;
  ts := 0;
  for i := 1 to n do
    if marks[i] = 0 then
      topsort( i );
  for i := 1 to n do
    if marks[i] = n then begin
      root := i;
      break;
    end;
  { Checking root }
  fillchar( been, sizeof( been ), false );
  dfs( root );
  for i := 1 to n do
    if not( been[i] ) then begin
      writeln( 'NO' );
      exit;
    end;
  { Checking is it a fuckin' tree? }
  fillchar( been, sizeof( been ), false );
  if IsDaFuckingTree( root ) then
    writeln( 'YES' )
  else
    writeln( 'NO' );
end;

var
  i : Int;
begin
  OpenFiles;
  read( t );
  for i := 1 to t do begin
    InitData;
    Solve;
  end;
  CloseFiles;
end.
 