program Programs;

{APPTYPE CONSOLE}
{O+,D-,R-,Q-,L-}

{

  EVA RULEZZZ!!!!!!!

  Fight with the best? Die like the rest!

  Copyright by [ hr0nix@darkwired ]

}

const
  InFile = 'programs.in';
  OutFile = 'programs.out';
  MaxN = 600;
  MaxLongNumLen = 250;
  Base = 1000000000;
  BaseLen = 9;

type
  Int = longint;
  LongNum = array[ 0..MaxLongNumLen ] of Int64;
  TLen = record
    len : Int;
    howmuch : Int;
  end;

var
  len : array [1..260] of Int;
  nlen : array [1..260] of TLen;
  ans : array [0..MaxN+260] of LongNum;
  n, l, nlc : Int;

{ LONG ARYTHMETIC REALIZATION }

function LongMulShort( const a : LongNum; b : Int ) : LongNum;
var
  res : LongNum;
  i, carry : Int;
begin
  fillchar( res, sizeof( res ), 0 );
  carry := 0;
  for i := 1 to a[ 0 ] do begin
    res[ i ] := ( a[ i ] * b + carry ) mod Base;
    carry := ( a[ i ] * b + carry ) div Base;
    inc( res[ 0 ] );
  end;
  while( carry <> 0 ) do begin
    inc( res[ 0 ] );
    res[ res[ 0 ] ] := carry mod Base;
    carry := carry div base;
  end;
  while ( res[ res[ 0 ] ] = 0 ) do
    dec( res[ 0 ] );
  LongMulShort := res;
end;

function Max( const n1, n2 : Int ) : Int;
begin
  if n1 > n2 then max := n1 else max := n2;
end;

function LongPlusLong( const a, b : LongNum ) : LongNum;
var
  res : LongNum;
  i, carry : Int;
begin
  fillchar( res, sizeof( res ), 0 );
  carry := 0;
  for i := 1 to Max( a[ 0 ], b[ 0 ] ) do begin
    res[ i ] := ( a[ i ] + b[ i ] + carry ) mod Base;
    carry := ( a[ i ] + b[ i ] + carry ) div Base;
    inc( res[ 0 ] );
  end;
  if carry <> 0 then begin
    inc( res[ 0 ] );
    res[ res[ 0 ] ] := carry;
  end;
  LongPlusLong := Res;
end;

procedure WriteLong( const a : LongNum );
var
  i : Int;
  s : string;
begin
  if a[ 0 ] = 0 then begin
    writeln( 0 );
    exit;
  end;
  for i := a[ 0 ] downto 1 do begin
    str( a[ i ], s );
    if i <> a[ 0 ] then
      while length( s ) < BaseLen do
        s := '0' + s;
    write( s );
  end;
  writeln;
end;

procedure OpenFiles;
begin
  assign( input, InFile );
  reset( input );
  assign( output, OutFile );
  rewrite( output );
end;

procedure CloseFiles;
begin
  close( input );
  close( output );
end;

procedure InitData;
var
  i : Int;
  s : string;
begin
  readln( n );
  fillchar( len, sizeof( len ), 0 );
  for i := 1 to n do begin
    readln( s );
    while( pos( ' ', s ) <> 0 ) do
      delete( s, pos( ' ', s ), 1 );
    inc( len[ length( s ) ] );
  end;
  read( l );
  for i := 1 to l do
    ans[ i ][ 0 ] := 0;
  nlc := 0;
  for i := 1 to 255 do
    if len[ i ] <> 0 then begin
      inc( nlc );
      nlen[ nlc ].len := i;
      nlen[ nlc ].howmuch := len[ i ];
    end;
end;

procedure Solve;
var
  i, j : Int;
begin
  ans[ 0, 0 ] := 1;
  ans[ 0, 1 ] := 1;
  for i := 0 to l - 1 do begin
    if ( ans[ i ][ 0 ] < 2 ) and ( ans[ i ][ 1 ] = 0 ) then
      continue;
    for j := 1 to nlc do begin
      if nlen[ j ].len > l - i then break;
      ans[ i + nlen[ j ].len ] := LongPlusLong( ans[ i + nlen[ j ].len ], LongMulShort( ans[ i ], nlen[ j ].howmuch ) );
    end;
  end;
  WriteLong( ans[ l ] );
end;

begin
  OpenFiles;
  InitData;
  Solve;
  CloseFiles;
end.
