program sinus;

{$O+,D-,Q-,R-,S-}

{

  EVA RULEZZZ!!!!!!!

  Fight with the best? Die like the rest!

  Copyright by [ hr0nix@darkwired ]

}

uses
  Math;

const
  InFile = 'sin.in';
  OutFile = 'sin.out';
  MaxN = 100;
  Inf = 1e+30;

type
  Int = integer;
  Real = extended;

var
  b : array [1..MaxN] of Int;
  n, k : Int;
  a, ab : array[ 1..MaxN] of Int;
  maxx : Real;

procedure OpenFiles;
begin
  assign( input, InFile );
  reset( input );
  assign( output, OutFile );
  rewrite( output );
end;

procedure CloseFiles;
begin
  close( input );
  close( output );
end;

procedure InitData;
var
  i : Int;
begin
  read( n );
  for i := 1 to n do
    read( b[ i ] );
  maxx := -Inf;
end;

function f( k : Int ) : Real;
var
  i : Int;
  sum : Real;
begin
  sum := 0;
  for i := 2 to k do
    sum := sum + sin( i * b[ i-1 ] * a[ i-1 ] * a[ i ] );
  f := sum / k;
end;

procedure dfs( deep, num : Int );
var
  i : Int;
  ans : extended;
begin
  if num = 0 then begin
    ans := f( deep - 1 );
    if ( ans > maxx ) and ( deep <> 2 ) then begin
      ab := a;
      k := deep - 1;
      maxx := ans;
    end;
    exit;
  end;
  for i := 1 to num do begin
    a[ deep ] := i;
    dfs( deep + 1, num - i );
  end;
end;

procedure Solve;
var
  i : Int;
begin
  dfs( 1, n );
  writeln( maxx : 0 : 6 );
  for i := 1 to k do
    write( ab[ i ], ' ' );
end;

begin
  OpenFiles;
  InitData;
  Solve;
  CloseFiles;
end.
