{$A+,B-,D-,E-,F-,G+,I+,L-,N+,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}
{$M 16384,0,655360}

program Rescue;

{

  EVA RULEZZZ!!!!!!!

  Fight with the best? Die like the rest!

  Copyright by [ hr0nix@darkwired ]

}

const
  InFile = 'rescue.in';
  OutFile = 'rescue.out';
  MaxN = 50000;

type
  Int = longint;
  Real = extended;
  TPoint = record
    x, y : Int;
  end;

var
  bases : array [1..MaxN] of TPoint;
  n, m : Int;

procedure OpenFiles;
begin
  assign( input, InFile );
  reset( input );
  assign( output, OutFile );
  rewrite( output );
end;

procedure CloseFiles;
begin
  close( input );
  close( output );
end;

procedure InitData;
var
  i : Int;
begin
  read( n, m );
  for i := 1 to n do
    read( bases[ i ].x, bases[ i ].y );
end;

function Dist( p1, p2 : TPoint ) : Real;
begin
  dist := sqr( p1.x - p2.x ) + sqr( p1.y - p2.y );
end;

procedure Solve;
var
  i, j, jmin : Int;
  r : TPoint;
  best : Real;
begin
  for i := 1 to m do begin
    read( r.x, r.y );
    jmin := 1;
    best := dist( bases[ 1 ], r );
    for j := 2 to n do
      if dist( bases[ j ], r ) < best then begin
        best := dist( bases[ jmin ], r );
        jmin := j;
      end;
    writeln( bases[ jmin ].x, ' ', bases[ jmin ].y );
  end;
end;

begin
  OpenFiles;
  InitData;
  Solve;
  CloseFiles;
end.
 