program Block;

{$APPTYPE CONSOLE}
{O+,D-,R-,Q-,S-}

Uses
  SysUtils;

{

  EVA RULEZZZ!!!!!!!

  Fight with the best? Die like the rest!

  Copyright by [ hr0nix@darkwired ]

}

const
  InFile = 'block.in';
  OutFile = 'block.out';
  endtime = 4.5 / ( 24 * 60 * 60 );

type
  Int = longint;
  Real = extended;
  TPoint = array [1..3] of Int;
  TBlock = array [1..4] of TPoint;
  PStand = ^TStand;
  TStand = record
    num, like : Int;
    next : PStand;
  end;
  TRecordPoint = record
    x, y, z : Int;
  end;

{ FUCKING BLOCKS }
const
  blocksize : array [1..12] of Int = ( 1, 2, 3, 3, 4, 4, 4, 4, 4, 4, 4, 4 );
  cblocks : array [1..12] of TBlock =
  (
  { 1 } ( ( 0,0,0 ), ( 0,0,0 ), ( 0,0,0 ), ( 0,0,0 ) ),
  { 2 } ( ( 0,0,0 ), ( 0,1,0 ), ( 0,0,0 ), ( 0,0,0 ) ),
  { 3 } ( ( 0,0,0 ), ( 0,1,0 ), ( 0,2,0 ), ( 0,0,0 ) ),
  { 4 } ( ( 0,0,0 ), ( 0,1,0 ), ( 0,0,1 ), ( 0,0,0 ) ),
  { 5 } ( ( 0,0,0 ), ( 0,1,0 ), ( 0,2,0 ), ( 0,3,0 ) ),
  { 6 } ( ( 0,0,0 ), ( 0,1,0 ), ( 0,0,1 ), ( 0,1,1 ) ),
  { 7 } ( ( 0,0,0 ), ( 0,1,0 ), ( 0,0,1 ), ( 0,0,2 ) ),
  { 8 } ( ( 0,0,0 ), ( 0,1,0 ), ( 0,2,0 ), ( 0,1,1 ) ),
  { 9 } ( ( 0,0,0 ), ( 0,1,0 ), ( 0,0,1 ), ( 0,-1,1 ) ),
 { 10 } ( ( 0,0,0 ), ( 0,0,1 ), ( 0,1,0 ), ( -1,1,0 ) ),
 { 11 } ( ( 0,0,0 ), ( 0,0,1 ), ( 0,1,0 ), ( 1,1,0 ) ),
 { 12 } ( ( 0,0,0 ), ( 0,1,0 ), ( -1,1,0 ), ( 0,1,-1 ) )
  );

var
  v, bestans, BlocksCount, tBlocksCount, optimal : Int;
  cans : Int;
  a : array [-4..12, -4..12, -4..12] of Int;
  curans, best : array [1..50] of Int;
  tblocks, blocks : array [1..1500] of TBlock;
  tblocksize, nblocksize, tblocktype, nblocktype : array [1..1500] of Int;
  coords : array [1..50] of TRecordPoint;
  standlist : array [1..50] of PStand;
  starttime : Real;

procedure OpenFiles;
begin
  assign( input, InFile );
  reset( input );
  assign( output, OutFile );
  rewrite( output );
end;

procedure CloseFiles;
begin
  close( input );
  close( output );
end;

procedure RotateLeft( var b : TBlock );
var
  i : Int;
  bn : TBlock;
begin
  bn := b;
  for i := 1 to 4 do begin
    bn[ i ][ 2 ] := -b[ i ][ 1 ];  { X -> -Y } { -X -> Y  }
    bn[ i ][ 1 ] := b[ i ][ 2 ];   { Y -> X  } { -Y -> -X }
  end;
  b := bn;
end;

procedure RotateTop( var b : TBlock );
var
  i : Int;
  bn : TBlock;
begin
  bn := b;
  for i := 1 to 4 do begin
    bn[ i ][ 3 ] := b[ i ][ 1 ];  { X -> Z  } { -X -> -Z }
    bn[ i ][ 1 ] := -b[ i ][ 3 ]; { Z -> -X } { -Z -> X  }
  end;
  b := bn;
end;

procedure RotateSpin( var b : TBlock );
var
  i : Int;
  bn : TBlock;
begin
  bn := b;
  for i := 1 to 4 do begin
    bn[ i ][ 3 ] := -b[ i ][ 2 ];  { Y -> -Z } { -Y -> Z  }
    bn[ i ][ 2 ] := b[ i ][ 3 ];   { Z -> Y  } { -Z -> -Y }
  end;
  b := bn;
end;

function Equal( b1, b2 : TBlock ) : boolean;
var
  i : Int;
begin
  Equal := false;
  for i := 1 to 4 do
    if ( b1[ i ][ 1 ] <> b2[ i ][ 1 ] ) or
       ( b1[ i ][ 2 ] <> b2[ i ][ 2 ] ) or
       ( b1[ i ][ 3 ] <> b2[ i ][ 3 ] ) then exit;
  Equal := true;
end;

procedure InitData;
var
  i, j, rl, rt, rs : Int;
  b, bl, bt, bs : TBlock;
  found : boolean;
begin
  starttime := time;
  fillchar( a, sizeof( a ), 0 );
  read( v );
  for i := 1 to v do begin
    read( coords[ i ].x, coords[ i ].y, coords[ i ].z );
    a[ coords[ i ].x, coords[ i ].y, coords[ i ].z ] := 2;
  end;
  bestans := MaxLongInt;

  { GENERATING ROTATIONS }
  tBlocksCount := 0;
  for i := 1 to 12 do begin
    b := cblocks[ i ];
    bl := b;
    for rl := 0 to 3 do begin
      if rl <> 0 then
        RotateLeft( bl );
      bt := bl;
      for rt := 0 to 3 do begin
        if rt <> 0 then
          RotateTop( bt );
        bs := bt;
        for rs := 0 to 3 do begin
          if rs <> 0 then
            RotateSpin( bs );
          inc( tblocksCount );
          tblocks[ tblockscount ] := bs;
          tblocksize[ tblockscount ] := blocksize[ i ];
          tblocktype[ tblockscount ] := i;
        end;
      end;
    end;
  end;
  BlocksCount := 0;
  for i := 1 to tBlocksCount-1 do begin
    found := false;
    for j := i + 1 to tBlocksCount do
      if Equal( tblocks[ i ], tblocks[ j ] ) then begin
        found := true;
        break;
      end;
    if not( found ) then begin
      inc( BlocksCount );
      blocks[ blockscount ] := tblocks[ i ];
      nblocksize[ blockscount ] := tblocksize[ i ];
      nblocktype[ blockscount ] := tblocktype[ i ];
    end;
  end;
end;

function CanStand( b : TBlock; size, x, y, z : Int ) : boolean;
var
  i, j  : Int;
  fuck : boolean;
begin
  for i := 1 to size do begin
    fuck := false;
    for j := 1 to size do
      if a[ x + b[ j ][ 1 ] - b[ i ][ 1 ],
            y + b[ j ][ 2 ] - b[ i ][ 2 ],
            z + b[ j ][ 3 ] - b[ i ][ 3 ]
          ] <> 2 then begin
                  fuck := true;
                  break;
                 end;
      if not( fuck ) then begin
        CanStand := true;
        exit;
      end;
  end;
  CanStand := false;
end;

procedure output;
var
  i : Int;
begin
  writeln( bestans );
  for i := 1 to bestans do
    write( best[ i ], ' ' );
  writeln;
  CloseFiles;
  Halt( 0 );
end;

procedure dfs( cur, howmuch : Int );
var
  i, j : Int;
  b : TBlock;
  p : PStand;
  fuck : boolean;
begin
  if time - starttime > endtime then
    Output;
  if cans >= bestans then
    exit;
  if howmuch = 0 then begin
    bestans := cans;
    for i := 1 to bestans do
      best[ i ] := curans[ i ];
    if bestans = optimal then
      Output;
    exit;
  end;
  if cur = v + 1 then
    exit;
  p := standlist[ cur ];
  with coords[ cur ] do
   if a[ x, y, z ] = 1 then begin
     dfs( cur + 1, howmuch );
     exit;
   end else
   if a[ x, y, z ] = 2 then        { FREE PLACE FOR OUR BLOCK }
     while p <> nil do begin
       b := blocks[ p^.num ];      { PUTTING BLOCK }
       for i := 1 to nblocksize[ p^.num ] do begin
         fuck := false;
         for j := 1 to nblocksize[ p^.num ] do
           if a[ x + b[ j ][ 1 ] - b[ i ][ 1 ],
                 y + b[ j ][ 2 ] - b[ i ][ 2 ],
                 z + b[ j ][ 3 ] - b[ i ][ 3 ]
               ] <> 2 then begin
                      fuck := true;
                      break;
                     end;
         if not( fuck ) then begin
          for j := 1 to nblocksize[ p^.num ] do
            a[ x + b[ j ][ 1 ] - b[ i ][ 1 ], y + b[ j ][ 2 ] - b[ i ][ 2 ], z + b[ j ][ 3 ] - b[ i ][ 3 ] ] := 1;
          inc( cans );
          curans[ cans ] := nblocktype[ p^.num ];
          dfs( cur + 1, howmuch - nblocksize[ p^.num ] );
          dec( cans );
          for j := 1 to nblocksize[ p^.num ] do
            a[ x + b[ j ][ 1 ] - b[ i ][ 1 ], y + b[ j ][ 2 ] - b[ i ][ 2 ], z + b[ j ][ 3 ] - b[ i ][ 3 ] ] := 2;
         end;
       end;
       p := p^.next;
     end;
end;

procedure Solve;
var
  i, j : Int;
  p : PStand;
begin
  optimal := v div 4;
  if v mod 4 <> 0 then
    inc( optimal );
  fillchar( standlist, sizeof( standlist ), 0 );
  for i := 1 to v do begin
    for j := 1 to BlocksCount do
      if CanStand( blocks[ j ], nblocksize[ j ], coords[ i ].x, coords[ i ].y, coords[ i ].z ) then begin
        new( p );
        p^.num := j;
        p^.next := standlist[ i ];
        standlist[ i ] := p;
      end;
  end;
  cans := 0;
  dfs( 1, v );
  Output;
end;

begin
  OpenFiles;
  InitData;
  Solve;
  CloseFiles;
end.
 