program Universal_Unit;

{

  EVA RULEZZZ!!!!!!!

  Fight with the best? Die like the rest!

  Copyright by [ hr0nix@darkwired ]

}

const
  InFile = 'unit.in';
  OutFile = 'unit.out';

type
  Int = longint;
  Real = extended;

var
   k, l, t : Int;
   a : array [1..16, 1..8] of Int;

procedure OpenFiles;
begin
  assign( input, InFile );
  reset( input );
  assign( output, OutFile );
  rewrite( output );
end;

procedure CloseFiles;
begin
  close( input );
  close( output );
end;

function power2( degree : Int ) : Int;
var
   i, res : Int;
begin
     res := 1;
     for i := 1 to degree do
         res := res shl 1;
     power2 := res;
end;

procedure InitData;
var
   i, j : Int;
begin
     read( k, l );
     for i := 1 to power2( k ) do
         for j := 1 to k + l do
             read( a[ i, j ] );
end;

procedure Solve;
label
     not_found, or_found;
var
   i, j, r, ccol, cnt1, cnt0 : Int;
   notf, orf : boolean;
begin
     { Checking for NOT }

     notf := false;
     for i := 0 to k do                     { col for fixing }
         for j := 1 to k do                 { col for parametres }
             for r := k + 1 to k + l do     { col for results }
                 if ( i <> j ) then begin
                    { fixing 0 }
                    notf := true;
                    for ccol := 1 to power2( k ) do
                        if ( ( i = 0 ) or ( a[ ccol, i ] = 0 ) ) and ( a[ ccol, j ] = a[ ccol, r ] ) then begin
                           notf := false;
                           break;
                        end;
                    if notf then
                       goto not_found;
                    { fixing 1 }
                    notf := true;
                    for ccol := 1 to power2( k ) do
                        if ( ( i = 0 ) or ( a[ ccol, i ] = 1 ) ) and ( a[ ccol, j ] = a[ ccol, r ] ) then begin
                           notf := false;
                           break;
                        end;
                    if notf then
                       goto not_found;
                 end;

     not_found:
     if not( notf ) then begin
        writeln( 'NO' );
        exit;
     end;

     { Checking for OR }

     orf := false;
     for i := k + 1 to k + l do begin
          cnt1 := 0;
          cnt0 := 0;
          for ccol := 1 to power2( k ) do
              if a[ ccol, i ] = 1 then
                 inc( cnt1 )
              else
                 inc( cnt0 );
          if ( cnt1 >= 3 ) and ( cnt0 >= 1 ) then begin
             orf := true;
             goto or_found;
          end;
     end;

     or_found:
     if not( orf ) then begin
        writeln( 'NO' );
        exit;
     end;

     writeln( 'YES' );
end;

var
   i : Int;
begin
  OpenFiles;
  read( t );
  for i := 1 to t do begin
      InitData;
      Solve;
  end;
  CloseFiles;
end.
