program Proff;

{

  EVA RULEZZZ!!!!!!!

  Fight with the best? Die like the rest!

  Copyright by [ hr0nix@darkwired ]

}

const
  InFile = 'prof.in';
  OutFile = 'prof.out';
  MaxN = 30;

type
  Int = longint;
  Real = extended;

var
   s : string;
   used : array [1..MaxN] of string;
   uc : Int;

procedure OpenFiles;
begin
  assign( input, InFile );
  reset( input );
  assign( output, OutFile );
  rewrite( output );
end;

procedure CloseFiles;
begin
  close( input );
  close( output );
end;

procedure InitData;
begin
     uc := 0;
     readln( s );
end;

procedure AddToUsed( s : string );
begin
     inc( uc );
     used[ uc ] := s;
end;

function AlreadyUsed( s : string ) : boolean;
var
   i : Int;
begin
     AlreadyUsed := true;
     for i := 1 to uc do
         if used[ i ] = s then
            exit;
     AlreadyUsed := false;
end;

procedure Solve;
var
   t, st : string;
   ans, i, j, k : Int;
begin
     ans := 0;
     for i := 1 to length( s ) do begin
         for j := i to length( s ) do begin
             t := copy( s, i, j-i+1 );
             if not( AlreadyUsed( t ) ) then begin
                st := s;
                for k := i to j do
                    st[ k ] := '*';
                if pos( t, st ) <> 0 then begin
                   inc( ans );
                   AddToUsed( t );
                end;
             end;
         end;
     end;
     writeln( ans );
end;

begin
  OpenFiles;
  InitData;
  Solve;
  CloseFiles;
end.
 