{$N+}
type int65536=array[0..150]of int64;
const eps=1e-18;
var base:int64;
    invbase:extended;
var n,l,mqlen:longint;
    qlen:array[0..255]of longint;

procedure Load;
var i,j:longint;
    c:char;
    clen:longint;
begin
    mqlen:=0;
    fillchar(qlen,sizeof(qlen),0);
    readln(n);
    for i:=1 to n do begin
        clen:=0;
        read(c);
        while (c<>#13)and(c<>#26) do begin
            if c<>' ' then inc(clen);
            read(c);
        end;
        if c=#13 then read(c);
        inc(qlen[clen]);
        if clen>mqlen then mqlen:=clen;
    end;
    read(l);
end;

var res:array[0..610]of int65536;

procedure LINC(i1,i2,cf:longint);
var i:longint;
    c1:int64;
begin
    if res[i1,0]<res[i2,0] then res[i1,0]:=res[i2,0];
    for i:=1 to res[i2,0] do begin
        inc(res[i1,i],res[i2,i]*cf);
        if res[i1,i]>=BASE then begin
            c1:=trunc((res[i1,i]+0.0)*INVBASE+eps);
            inc(res[i1,i+1],c1);
            res[i1,i]:=res[i1,i]-(c1*BASE);
        end;
    end;
    if res[i1,res[i1,0]+1]>0 then begin
        inc(res[i1,0]);
    end;
end;

procedure Solve;
var i,j:longint;
    cur:int64;
begin
    fillchar(res,sizeof(res),0);
    base:=10000000;
    base:=base*base;
    invbase:=1/base;
    res[0,0]:=1;
    res[0,1]:=1;
    for i:=0 to l-1 do begin
        if res[i,0]=0 then continue;
        for j:=1 to mqlen do begin
            if i+j>l then break;
            LINC(i+j,i,qlen[j]);
        end;
    end;
    if res[l,0]=0 then begin
        res[l,0]:=1;
        res[l,1]:=0;
    end;
    for i:=res[l,0] downto 1 do begin
        if i<>res[l,0] then begin
            cur:=10;
            while cur<BASE do begin
                if res[l,i]<cur then write('0');
                cur:=cur*10;
            end;
        end;
        write(res[l,i]);
    end;
end;

begin
    assign(input,'programs.in');
    assign(output,'programs.out');
    reset(input);
    rewrite(output);
    Load;
    Solve;
    close(input);
    close(output);
end.
