{$M 30000000,30000000}
{$N+,Q+,R+,S+}
var conn:array[0..70000]of longint;
    beg,en,curb,cc:longint;

function GetHexNum(c:char):longint;
begin
    if (c>='0')and(c<='9') then begin
        GetHexNum:=ord(c)-ord('0');
    end
    else begin
        GetHexNum:=ord(Upcase(c))-ord('A')+10;
    end;
end;

function ReadByte:longint;
var c:char;
    num:longint;
begin
    read(c);
    while (c=' ')or(c=#13)or(c=#10) do read(c);
    num:=GetHexNum(c);
    read(c);
    while (c=' ')or(c=#13)or(c=#10) do read(c);
    num:=(num shl 4)+GetHexNum(c);
    ReadByte:=num;
end;

procedure Load;
var ts:string;
    i,cur:longint;
    wb,num,b1,b2:longint;
begin
    readln(ts);
    cur:=1;
    while ts[cur]=' ' do inc(cur);
    beg:=0;
    while ts[cur]<>' ' do begin
        num:=GetHexNum(ts[cur]);
        beg:=beg shl 4+num;
        inc(cur);
    end;
    while ts[cur]=' ' do inc(cur);
    en:=0;
    while ts[cur]<>' ' do begin
        if cur>length(ts) then break;
        num:=GetHexNum(ts[cur]);
        en:=en shl 4+num;
        inc(cur);
    end;
    b1:=ReadByte;
    wb:=b1;
    for i:=0 to 65535 do begin
        if i<65535 then b2:=ReadByte
        else
            b2:=wb;
        conn[i]:=(b2 shl 8)+b1;
        b1:=b2;
    end;
end;

var prev,len,num,whr:array[0..65536]of longint;
    hp:array[1..700000]of longint;
    nhp:longint;

function Smaller(i1,i2:longint):boolean;
begin
    if len[i1]<len[i2] then Smaller:=true
    else if(len[i1]=len[i2])and(num[i1]<num[i2]) then Smaller:=true
    else Smaller:=false;
end;

procedure StepUp(ver:longint);
var cur,nxt,t:longint;
begin
    cur:=ver;
    nxt:=cur div 2;
    while (nxt>0)and(Smaller(hp[cur],hp[nxt])) do begin
        t:=whr[hp[cur]];
        whr[hp[cur]]:=whr[hp[nxt]];
        whr[hp[nxt]]:=t;
        t:=hp[cur];
        hp[cur]:=hp[nxt];
        hp[nxt]:=t;
        cur:=nxt;
        nxt:=cur div 2;
    end;
end;

function Bigger(i1,i2:longint):boolean;
begin
    if len[i1]>len[i2] then Bigger:=true
    else if (len[i1]=len[i2])and(num[i1]>num[i2])then Bigger:=true
    else Bigger:=false;
end;

procedure StepDown(ver:longint);
var cur,nxt,t:longint;
begin
    cur:=ver;
    nxt:=cur*2;
    if (nxt<nhp)and(Smaller(hp[nxt+1],hp[nxt])) then inc(nxt);
    while (nxt<=nhp)and(Bigger(hp[cur],hp[nxt])) do begin
        t:=whr[hp[cur]];
        whr[hp[cur]]:=whr[hp[nxt]];
        whr[hp[nxt]]:=t;
        t:=hp[cur];
        hp[cur]:=hp[nxt];
        hp[nxt]:=t;
        cur:=nxt;
        nxt:=cur*2;
        if (nxt<nhp)and(Smaller(hp[nxt+1],hp[nxt])) then inc(nxt);
    end;
end;


procedure AddHeap(ver:longint);
begin
    inc(nhp);
    hp[nhp]:=ver;
    whr[ver]:=nhp;
    StepUp(nhp);
end;

function GetMinHeap:longint;
var res:longint;
begin
    res:=hp[1];
    whr[hp[1]]:=0;
    hp[1]:=hp[nhp];
    whr[hp[nhp]]:=1;
    dec(nhp);
    StepDown(1);
    GetMinHeap:=res;
end;

function SwapByte(a:longint):longint;
var b1,b2:longint;
begin
    b1:=a shr 8;
    b2:=a-(b1 shl 8);
    SwapByte:=((b2 shl 8)+b1);
end;

procedure FindPath;
var i,cver,nver:longint;
begin
    fillchar(whr,sizeof(whr),0);
    for i:=0 to 65536 do begin
        len[i]:=2000000000;
        num[i]:=2000000000;
    end;
    nhp:=0;
    cver:=beg;
    len[beg]:=0;
    num[beg]:=0;
    nver:=conn[beg];
    if Smaller(cver,nver) then begin
        len[nver]:=1;
        num[nver]:=1;
        prev[nver]:=cver;
        AddHeap(nver);
    end;
    nver:=SwapByte(cver);
    if Smaller(cver,nver) then begin
        len[nver]:=2;
        num[nver]:=1;
        prev[nver]:=cver;
        AddHeap(nver);
    end;
    while nhp>0 do begin
        cver:=GetMinHeap;
        nver:=SwapByte(cver);
        if len[nver]>=len[cver]+2 then begin
            len[nver]:=len[cver]+2;
            num[nver]:=num[cver]+1;
            prev[nver]:=cver;
            if whr[nver]=0 then AddHeap(nver)
            else begin
                StepUp(whr[nver]);
                StepDown(whr[nver]);
            end;
        end
        else if (len[nver]=len[cver]+2)and(num[nver]>num[cver]) then begin
            len[nver]:=len[cver]+2;
            num[nver]:=num[cver]+1;
            prev[nver]:=cver;
            if whr[nver]=0 then AddHeap(nver)
            else begin
                StepUp(whr[nver]);
                StepDown(whr[nver]);
            end;
        end;
        nver:=conn[cver];
        if len[nver]>len[cver]+1 then begin
            len[nver]:=len[cver]+1;
            num[nver]:=num[cver]+1;
            prev[nver]:=cver;
            if whr[nver]=0 then AddHeap(nver)
            else begin
                StepUp(whr[nver]);
                StepDown(whr[nver]);
            end;
        end
        else if (len[nver]=len[cver]+1)and(num[nver]>num[cver]) then begin
            len[nver]:=len[cver]+1;
            num[nver]:=num[cver]+1;
            prev[nver]:=cver;
            if whr[nver]=0 then AddHeap(nver)
            else begin
                StepUp(whr[nver]);
                StepDown(whr[nver]);
            end;
        end;
    end;
end;

procedure OutByte(bt:string;lst:longint);
begin
    inc(curb);
    write(bt);
    if lst=0 then begin
        if curb=8 then begin
            if cc=0 then begin
                write('  ');
                inc(cc);
            end
            else begin
                writeln;
                cc:=0;
            end;
            curb:=0;
        end
        else write(' ');
    end;
end;


procedure Solve;
var cur,nxt,np,nb,i,lst:longint;
    path:array[1..70000,1..2]of longint;
begin
    FindPath;
    {rebuild path}
    if len[en]=2000000000 then begin
        write('IMPOSSIBLE');
        exit;
    end;
    np:=1;
    path[np,1]:=en;
    cur:=en;
    while cur<>beg do begin
        nxt:=prev[cur];
        if cur=conn[nxt] then path[np,2]:=1
        else path[np,2]:=2;
        inc(np);
        path[np,1]:=nxt;
        cur:=nxt;
    end;
    nb:=0;
    for i:=np-1 downto 1 do inc(nb,path[i,2]);
    writeln(nb);
    curb:=0;
    cc:=0;
    lst:=0;
    for i:=np-1 downto 1 do begin
        if i=1 then lst:=1;
        if path[i,2]=1 then OutByte('5C',lst)
        else begin
            OutByte('0F',0);
            OutByte('CC',lst);
        end;
    end;
    writeln;
end;

begin
    assign(input,'2instr.in');
    assign(output,'2instr.out');
    reset(input);
    rewrite(output);
    Load;
    Solve;
    close(input);
    close(output);
end.
