{$N+}
const FLOAD=0;
      FSTORE=1;
      FADD=2;
      FSUB=3;
      FMULT=4;
      FDIV=5;
      FREAD=6;
      FWRITE=7;
      FJUMP=8;
      FJGTZ=9;
      FJZERO=10;
      FHALT=11;
type command=record
    cmd:string;
    pnt:char;
    cmdn,val:longint;
end;
var num:array[0..1500]of longint;
    reg:array[0..1500]of longint;
    cmd:array[0..1500]of command;
    n,m,wf:longint;

procedure REadCommand(ind:longint);
var ts:string;
    i,fst,lst:longint;
begin
    readln(ts);
    for i:=1 to length(ts) do ts[i]:=Upcase(ts[i]);
    cmd[ind].cmd:='';
    cmd[ind].val:=0;
    cmd[ind].pnt:=#0;
    fst:=1;
    while ts[fst]=' ' do inc(fst);
    while ts[fst]<>' ' do begin
        if fst>length(ts) then break;
        cmd[ind].cmd:=cmd[ind].cmd+ts[fst];
        inc(fst);
        if fst>length(ts) then break;
    end;
    while ts[fst]=' ' do inc(fst);
    if (ts[fst]='=')or(ts[fst]='*') then begin
        cmd[ind].pnt:=ts[fst];
        inc(fst);
    end;
    while (ts[fst]>='0')and(ts[fst]<='9') do begin
        if fst>length(ts) then break;
        cmd[ind].val:=cmd[ind].val*10+ord(ts[fst])-ord('0');
        inc(fst);
        if fst>length(ts) then break;
    end;
    if cmd[ind].cmd='LOAD' then cmd[ind].cmdn:=0
    else if cmd[ind].cmd='STORE' then cmd[ind].cmdn:=1
    else if cmd[ind].cmd='ADD' then cmd[ind].cmdn:=2
    else if cmd[ind].cmd='SUB' then cmd[ind].cmdn:=3
    else if cmd[ind].cmd='MULT' then cmd[ind].cmdn:=4
    else if cmd[ind].cmd='DIV' then cmd[ind].cmdn:=5
    else if cmd[ind].cmd='READ' then cmd[ind].cmdn:=6
    else if cmd[ind].cmd='WRITE' then cmd[ind].cmdn:=7
    else if cmd[ind].cmd='JUMP' then cmd[ind].cmdn:=8
    else if cmd[ind].cmd='JGTZ' then cmd[ind].cmdn:=9
    else if cmd[ind].cmd='JZERO' then cmd[ind].cmdn:=10
    else if cmd[ind].cmd='HALT' then cmd[ind].cmdn:=11;
end;

procedure Load;
var i:longint;
begin
    readln(n,m);
    for i:=0 to n-1 do begin
        ReadCommand(i);
    end;
    for i:=1 to m do
        read(num[i]);
end;

var ccomm:longint;
    cval:longint;

function GetParam(p:longint):longint;
begin
    if cmd[p].pnt=#0 then GetParam:=reg[cmd[p].val]
    else if cmd[p].pnt='=' then GetParam:=cmd[p].val
    else GetParam:=reg[reg[cmd[p].val]];
end;

procedure ExecCmd;
begin
    if cmd[ccomm].cmdn=FLOAD then begin
        reg[0]:=GetParam(ccomm);
    end
    else if cmd[ccomm].cmdn=FSTORE then begin
        if cmd[ccomm].pnt=#0 then reg[cmd[ccomm].val]:=reg[0]
        else reg[reg[cmd[ccomm].val]]:=reg[0];
    end
    else if cmd[ccomm].cmdn=FADD then begin
        inc(reg[0],GetParam(ccomm));
    end
    else if cmd[ccomm].cmdn=FSUB then begin
        dec(reg[0],GetParam(ccomm));
    end
    else if cmd[ccomm].cmdn=FMULT then begin
        reg[0]:=reg[0]*GetParam(ccomm);
    end
    else if cmd[ccomm].cmdn=FDIV then begin
        reg[0]:=reg[0] div GetParam(ccomm);
    end
    else if cmd[ccomm].cmdn=FREAD then begin
        if cmd[ccomm].pnt=#0 then reg[cmd[ccomm].val]:=num[cval]
        else reg[reg[cmd[ccomm].val]]:=num[cval];
        inc(cval);
    end
    else if cmd[ccomm].cmdn=FWRITE then begin
        if wf=1 then writeln;
        wf:=1;
        write(GetParam(ccomm));
    end
    else if cmd[ccomm].cmdn=FJUMP then begin
        ccomm:=cmd[ccomm].val;
        exit;
    end
    else if cmd[ccomm].cmdn=FJGTZ then begin
        if reg[0]>0 then begin
            ccomm:=cmd[ccomm].val;
            exit;
        end;
    end
    else if cmd[ccomm].cmdn=FJZERO then begin
        if reg[0]=0 then begin
            ccomm:=cmd[ccomm].val;
            exit;
        end;
    end;
    inc(ccomm);
end;

procedure Solve;
begin
    fillchar(reg,sizeof(reg),0);
    wf:=0;
    ccomm:=0;
    cval:=1;
    while cmd[ccomm].cmdn<>FHALT do begin
        ExecCmd;
    end;
end;

begin
    assign(input,'ram.in');
    assign(output,'ram.out');
    reset(input);
    rewrite(output);
    Load;
    Solve;
    close(input);
    close(output);
end.
