{$D-,I-,L-,Q-,R-,S-,N+}
program _Zhenia;
const
 f_in='programs.in';
 f_out='programs.out';
 maxN=600;
 maxL=600;
 maxLen=255+10;
 lBase=1E+16;
 invBase=1E-16;
 lR=16;
 maxlLen=110;{105 - max}
 eps=1e-15;

type
 int=longint;
 Real = Extended;
 TLong = record
  l : int;
  C : array[1..maxlLen] of Real;
  end;

var
 N, L, Lmax : int;
 Len : array[1..maxN] of int;
 Count : array[0..maxLen] of int;
 A : array[0..maxL] of TLong;

procedure OpenFiles;
begin
 assign(input, f_in);
 reset(input);
 assign(output, f_out);
 rewrite(output);
end;

procedure CloseFIles;
begin
 close(input);
 close(output);
end;

procedure Init;
var
 i, j : int;
 S : String;

begin
 Readln(N);
 Lmax:=-1;
 for i:=1 to N do
  begin
  Readln(S);
  Len[i]:=0;
  for j:=1 to length(S) do
   if S[j] in [#33..#126] then
    Len[i]:=Len[i]+1;
  if Len[i]>Lmax then Lmax:=Len[i];
  end;
 Readln(L);
 fillchar(A, sizeof(A), 0);
 for i:=0 to L do
  begin
  A[i].l:=1;
{  A[i].C[1]:=0;}
  end;
 fillchar(COunt, sizeof(Count), 0);
 for i:=1 to N do
  inc( Count[ Len[i] ] );
end;

function RealEQ(const X, Y : Real) : boolean;
begin
 RealEQ:=abs(X-Y)<eps;
end;

function ZeroEQ(const X : TLong) : boolean;
begin
 ZeroEQ:=(X.l=1) and RealEQ(X.C[1],0.0);
end;

function max(const a, b : int) : int;
begin
 if a>b then max:=a else max:=b;
end;

procedure LongSum(var A : TLong; Const B : TLong);
var
 i : int;
begin
 for i:=1 to max(A.l, B.l)+1 do
  begin
  A.C[i]:=A.C[i]+B.C[i];
  A.C[i+1]:=A.C[i+1]+ Trunc( A.C[i] * invBase + eps );
  A.C[i]:= A.C[i] - Trunc( A.C[i] * invBase + eps )*lBase;
  end;
 A.l:=max(A.l, B.l);
 if not RealEQ(A.C[A.l+1],0) then
  inc(A.l);
end;

procedure LongMulShort(COnst A : TLong; const B : Real; var Rez : TLong);
var
 i : int;
begin
 Rez.C[1]:=0.0;
 for i:=1 to A.l do
  begin
  Rez.C[i]:=Rez.C[i]+A.C[i]*B;
  Rez.C[i+1]:=Trunc( Rez.C[i] * invBase + eps );
  Rez.C[i]:=Rez.C[i] - Trunc( Rez.C[i] * invBase + eps )*lBase;
  end;
 Rez.l:=A.l;
 if not RealEQ(Rez.C[Rez.l+1],0) then
  inc(Rez.l);
 Rez.C[Rez.l+1]:=0.0;
end;

procedure WriteLong(const A : TLong);
var
 i : int;
 S : String;
begin
{ Writeln(A.l);}
 Write(A.C[A.l]:0:0);
 for i:=A.l-1 downto 1 do
  begin
  Str(A.C[i]:0:0 , S);
  while length(S)<lR do
   S:='0'+S;
  Write(S);
  end;
end;

procedure Solve;

var
 i, j, s : int;
 C : TLong;

begin
 A[0].l   :=1;
 A[0].C[1]:=1;
 for i:=0 to L do
  if not ZeroEQ(A[i]) then
   begin

   for s:=0 to Lmax do
    if (i+s<=L) and (Count[s]>0) then
     begin
     LongMulShort( A[i], Count[s], C );
     LongSum(A[i+s], C );
     end;

   end;

 WriteLong(A[L]);
end;

begin
 OpenFiles;
 Init;
 Solve;
 CloseFiles;
end.
