{$D-,I-,L-,Q-,R-,S-,N+}
program _Instrunctions;
const
 f_in='2instr.in';
 f_out='2instr.out';
 memSize=65536;
 maxS=65536;
 lines=4096;
 group=8;
 fhl8=256;
 fhl16=65536;
 Inf=1094795585;

type
 int=longint;

var
 Start, Stop, l, r : int;
 State : array[1..maxS] of int;
 Mem : array[0..memSize-1] of int;
 Used : array[0..memSize-1] of boolean;
 D, Save, BackV : array[0..memSize-1] of int;
 lAns, hAns : int;
 Ans : array[0..memSize-1] of string[2];
 Help : array[0..memSize-1] of int;
 change : boolean;

procedure OpenFiles;
begin
 assign(input, f_in);
 reset(input);
 assign(output, f_out);
 rewrite(output);
end;

procedure CloseFIles;
begin
 close(input);
 close(output);
end;

function ChToHex(ch : char) : int;
begin
 ch:=UpCase(ch);
 if ch in ['0'..'9'] then
  ChToHex:=Ord(ch)-Ord('0')
 else
  ChToHex:=Ord(ch)-Ord('A')+10;
end;

function ReadHex(len : int) : int;
var
 ch : char;
 s, i : int;

begin
 s:=0;
 for i:=1 to len do
  begin
  Read(ch);
  s:=s*16+ChToHex(ch);
  end;
 ReadHex:=s;
end;

procedure Init;
var
 ch : char;
 i, line : int;

begin
 Start:=ReadHex(4);
 Read(ch);
 Stop:=ReadHEx(4);
 readln;
 for line:=1 to lines do
  begin
  for i:=1 to 8 do
   begin
   Mem[ (line-1)*16+(i-1) ]:=ReadHex(2);
   if i<>8 then Read(ch);
   end;
  Read(ch, ch);
  for i:=9 to 16 do
   begin
   Mem[ (line-1)*16+(i-1) ]:=ReadHex(2);
   if i<>8 then Read(ch);
   end;
  readln;
  end;
 fillchar(Save, sizeof(Save), 0);
end;

function bSwap(X : int) : int;
var
 a, b : int;
begin
 a:=X mod fhl8;
 b:=X div fhl8;
 bSwap:=a*fhl8+b;
end;

function Pop(X : Int) : int;
var
 a, b : int;
begin
 a:=Mem[X  ];
 if X<>fhl16-1 then
  b:=Mem[X+1]
 else
  b:=Mem[0];
 Pop:=a+b*fhl8;
end;

function min(const a, b : int; var change : boolean) : int;
begin
 if a<b then
  begin
  min:=a;
  change:=false;
  end
 else
  begin
  min:=b;
  change:=true;
  end;
end;

procedure AddPop;
begin
 lAns:=lAns+1;
 Ans[lAns]:='5C';
end;

procedure AddbSwap;
begin
 lAns:=lAns+1;
 Ans[lAns]:='0F';
 lAns:=lAns+1;
 Ans[lAns]:='CC';
end;

procedure WriteAnswer;
var
 col, i : int;
begin
 col:=1;
 for i:=1 to lAns do
  begin
  Write(Ans[i]);
  if i=lAns then
   begin
   Writeln;
   Exit;
   end;
  if col=8 then
   Write('  ')
  else if col=16 then
   Writeln
  else
   Write(' ');
  col:=col+1;
  if col=17 then col:=1;
  end;

end;

procedure Solve;
var
 i, imin, t : int;

begin
 {Dejkstra!}
 fillchar(Used, sizeof(Used), false);
 fillchar(D, sizeof(D), 65);
 D[Start]:=0;
 while true do
  begin
  imin:=-1;
  for i:=0 to memSize-1 do
   if not Used[i] then
    if D[i]<Inf then
     begin
     imin:=i;
     break;
     end;
  if imin=-1 then Break;
   if not Used[i] then
    if D[i]<D[imin]  then
     begin
     imin:=i;
     break;
     end;
  Used[imin]:=True;
  {pop}
  t:=Pop(imin);
  D[t]:=min(D[t], D[imin]+1, change );
  if Change then
   begin
   Save[t]:=1;
   BackV[t]:=imin;
   end
  else if (Save[t]=2) and (D[t]=D[imin]+1) then
   begin
   Save[t]:=1;
   BackV[t]:=imin;
   end;
  {bswap}
  t:=bSwap(imin);
  D[t]:=min(D[t], D[imin]+2, change );
  if Change then
   begin
   Save[t]:=2;
   BackV[t]:=imin;
   end;
  end;

 if not Used[Stop] then
  begin
  Writeln('IMPOSSIBLE');
  end
 else
  begin
  Writeln(D[Stop]);
  lAns:=0;
  hAns:=0;
  i:=Stop;
  while i<>Start do
   begin
   inc(hAns);
   Help[hAns]:=Save[i];
   i:=BackV[i];
   end;
  for i:=hAns downto 1 do
   if Help[i]=1 then
    AddPop
   else
    AddbSwap;
  WriteAnswer;
  end;
end;

begin
 OpenFiles;
 Init;
 Solve;
 CloseFiles;
end.
