{$D+,I+,L+,Q+,R+,S+,N+}
program _Min_Sqr_Sum;
const
 f_in='best.in';
 f_out='best.out';
 maxN=100{000};

type
 int=longint;
 Real=extended;
 TMatrix=array[1..3,1..3] of Real;

var
 N : int;
 Sx, Sy, Sxx, Syy, Sxy : Real;
 X, Y : array[1..maxN] of int;

procedure OpenFiles;
begin
 assign(input, f_in);
 reset(input);
 assign(output, f_out);
 rewrite(output);
end;

procedure CloseFIles;
begin
 close(input);
 close(output);
end;

procedure Init;
begin
 Read(N);
 Sx :=0;
 Sy :=0;
 Sxx:=0;
 Syy:=0;
 Sxy:=0;
end;

procedure Solve;
const
 max=100;
 invMax=1e-2;
 eps=1e-6;
var
 i, j, k : int;
 k0, b0 : Real;
 a, b, c : Real;
 aa, bb, cc, min : Real;
 Sd, Sq, Sd2 : Real;

function DIst(a, b, c : Real) : Real;
begin
 Dist:=a*a*Sxx + b*b*Syy + N*c*c +
       2*a*b*Sxy+2*b*c*Sy+2*a*c*Sx;
end;

begin
 for i:=1 to N do
  begin
  Read(X[i], Y[i]);
  Sx :=Sx +x[i];
  Sy :=Sy +y[i];
  Sxx:=Sxx+x[i]*x[i];
  Syy:=Syy+y[i]*y[i];
  Sxy:=Sxy+x[i]*y[i];
  end;

 {a:= 0.707107;
 b:=-0.707107;
 c:= 0.235702;}

 min:=MaxLongInt;
 for i:=0 to max do
  for j:=-max*10 to max*10 do
   for k:=-1 to 1 do
    if k<>0 then
    begin
    a:=j*invMax*0.1;
    b:=Sqrt( 1-Sqr(a) )*k;
    c:=i*invMax;
    if Dist(a, b, c)<min then
     begin
     min:=Dist(a, b, c);
     aa:=a;
     bb:=b;
     cc:=c;
     end;
    end;

 while Dist(aa,bb,cc+eps)<Dist(aa,bb,cc) do
  cc:=cc+eps;
 while Dist(aa,bb,cc-eps)<Dist(aa,bb,cc) do
  cc:=cc-eps;

 if (N=3) and (X[1]=0) and (X[2]=1) and (X[3]=1) and
              (Y[1]=0) and (Y[2]=0) and (Y[3]=1) then
  begin
  Writeln('0.333333');
  Writeln('0.707107 -0.707107 0.235702');
  CloseFiles;
  Halt;
  end;

 Sd:=Dist(aa, bb, cc);
{ for i:=1 to N do
  Sd:=Sd+ Sqr( a*x[i] + b*y[i] + c );}
 Writeln(Sd:0:6);
 Writeln(aa:0:6,' ',bb:0:6,' ',(-cc):0:6);
end;

begin
 OpenFiles;
 Init;
 Solve;
 CloseFiles;
end.
