  {$I-,Q-,R-,S-}
const maxk=91000;

type
    list=^tlist;
    tlist=record next:list; fl,sl,fr,sr,link:int64; end;

var c,k,line,last,ans:longint;
    n,m:int64;
    a:array[1..maxk] of list;
    dus,rank:array[0..maxk] of longint;

Procedure add(const line,fl,sl,fr,sr:int64);
var p:list;
begin
    new(p);
    p^.next:=a[line];
    p^.fr:=fr;
    p^.sr:=sr;
    p^.fl:=fl;
    p^.sl:=sl;
    p^.link:=dus[0]+1;
    a[line]:=p;
    inc(dus[0]);
    dus[dus[0]]:=dus[0];
end;

Procedure init;
var i,t:longint;
    sum,fl,sl,fr,sr:int64;
    q,w:extended;
begin
    assign(input,'rle.in');
    reset(input);
    assign(output,'rle.out');
    rewrite(output);
    read(m,n);
    read(c,k);
    sum:=1;
    line:=0;
    last:=0;
    for i:=1 to k do
    begin
        read(t);
        if c=1 then
        begin
            fl:=(sum-1) div m + 1;
            sl:=(sum+t-2) div m + 1;
            fr:=(sum-1) mod m + 1;
            sr:=(sum+t-2) mod m + 1;
            if t>=m then
            begin
                if fl<>last then inc(line);
                add(line,fl,fl,fr,m);
                if sl-fl>1 then
                begin
                    inc(line);
                    add(line,fl+1,sl-1,1,m);
                end;
                if fl<>sl then
                begin
                    inc(line);
                    add(line,sl,sl,1,sr);
                end;
                last:=sl;
            end else
            begin
                if fl=sl then
                begin
                    if fl=last then add(line,fl,sl,fr,sr) else
                    begin
                        inc(line);
                        last:=sl;
                        add(line,fl,sl,fr,sr);
                    end;
                end else
                begin
                    if fl=last then
                    begin
                        add(line,fl,fl,fr,m);
                        inc(line);
                        last:=sl;
                        add(line,sl,sl,1,sr);
                    end else
                    begin
                        inc(line);
                        add(line,fl,fl,fr,m);
                        inc(line);
                        add(line,sl,sl,1,sr);
                        last:=sl;
                    end;
                end;
            end;
        end;
        inc(sum,t);
        c:=1-c;
    end;
    ans:=dus[0];
end;

Function get(const q:longint):longint;
begin
    if dus[q]=q then get:=q else
    begin
        dus[q]:=get(dus[q]);
        get:=dus[q];
    end;
end;

Procedure union(const q,w:longint);
begin
    if rank[q]>rank[w] then dus[w]:=q else
    if rank[q]<rank[w] then dus[q]:=w else
    begin
        inc(rank[q]);
        dus[w]:=q;
    end;
end;

Function intersect(const a,b:list):boolean;
var t1,t2:longint;
begin
    t1:=(b^.fr-1)-a^.sr;
    t2:=a^.fr-(b^.sr+1);
    intersect:=(t1<=0)and(t2<=0);
end;

Procedure solve;
var i,t1,t2:longint;
    buf1,buf2:list;
begin
    for i:=1 to line-1 do
    begin
        buf1:=a[i];
        while buf1<>nil do
        begin
            buf2:=a[i+1];
            while buf2<>nil do
            begin
                if buf2^.fl-buf1^.sl>1 then break;
                if buf1^.fr-buf2^.sr>1 then break;
                t1:=get(buf1^.link);
                t2:=get(buf2^.link);
                if t1<>t2 then if intersect(buf1,buf2) then
                begin
                    union(t1,t2);
                    dec(ans);
                end;
                buf2:=buf2^.next;
            end;
            buf1:=buf1^.next;
        end;
    end;
end;

Procedure print;
var i:longint;
begin
{    for i:=1 to dus[0] do writeln(i,' ',get(i));}
    writeln(ans);
end;

begin
    init;
    solve;
    print;
    close(input);
    close(output);
end.