  {$I-,Q-,R-,S-}
const
    maxk=3000;
    maxn=55000;
    inf=1000000000;

type
    list=^TList;
    tlist=record next:list; val:longint; end;
var l:array[0..maxk] of list;
    links:array[1..maxk] of record link,x:longint; end;
    a:array[0..maxn] of longint;
    n,m,num,rx,ry,min:longint;

Procedure add(const q,w:longint);
var p:list;
begin
    new(p);
    p^.next:=l[q];
    p^.val:=w;
    l[q]:=p;
end;

Procedure init;
var i,x,y:longint;
begin
    assign(input,'rescue.in');
    reset(input);
    assign(output,'rescue.out');
    rewrite(output);
    read(n,m);
    for i:=1 to n do
    begin
        read(x,y);
        inc(x,1000);
        add(x,y);
    end;
end;

Procedure swap(var a,b:longint);
var t:longint;
begin
    t:=a;
    a:=b;
    b:=t;
end;

Procedure qsort(const l,r:longint);
var i,j,x:longint;
begin
    i:=l;
    j:=r;
    x:=a[(l+r) div 2];
    repeat
        while a[i]<x do inc(i);
        while a[j]>x do dec(j);
        if i<=j then
        begin
            swap(a[i],a[j]);
            inc(i);
            dec(j);
        end;
    until i>j;
    if i<r then qsort(i,r);
    if j>l then qsort(l,j);
end;

Procedure pre;
var i:longint;
    buf:list;
begin
    num:=0;
    for i:=1 to 2000 do if l[i]<>nil then
    begin
        buf:=l[i];
        inc(num);
        links[num].link:=a[0]+1;
        links[num].x:=i;
        while buf<>nil do
        begin
            inc(a[0]);
            a[a[0]]:=buf^.val;
            buf:=buf^.next;
        end;
    end;
    links[num+1].link:=a[0]+1;
    for i:=1 to num do qsort(links[i].link,links[i+1].link-1);
end;

Procedure update(const x1,y1,x2,y2:longint);
var t:longint;
begin
    t:=sqr(x1-x2)+sqr(y1-y2);
    if t<min then
    begin
        min:=t;
        rx:=x2;
        ry:=y2;
    end;
end;

Procedure binsearch(const ll,rr,x,y,xx:longint);
var l,r,med:longint;
begin
    l:=ll;
    r:=rr;
    while l<>r do
    begin
        med:=(l+r) shr 1;
        if a[med]<y then l:=med+1 else r:=med;
    end;
    update(x,y,xx,a[l]);
    if l<>ll then update(x,y,xx,a[l-1]);
{    if l<>rr then update(x,y,xx,a[l+1]);}
end;

Procedure look(const x,y:longint);
var i:longint;
begin
    for i:=1 to num do
    begin
        binsearch(links[i].link,links[i+1].link-1,x,y,links[i].x);
    end;
end;

Procedure solve;
var i,x,y:longint;
begin
    pre;
    for i:=1 to m do
    begin
        read(x,y);
        min:=inf;
        look(x+1000,y);
        writeln(rx-1000,' ',ry);
    end;
end;

begin
    init;
    solve;
    close(input);
    close(output);
end.