#include <stdio.h>
#include <stdlib.h>
#include <string.h>

struct TInfo {
  int cnt;
  int width;
};

const int n_x=99,n_y=99;

int n_cells,n_lns_x,n_lns_y;
char*mtrx_cont,**mtrx;
int*lns_x,*lns_y;
int*cnts_cont_0,**cnts_cont_1,***cnts;
TInfo*infos_cont,**infos;

int main(void) {
  #ifndef OFFLINE
  freopen("small.in","rt",stdin);
  freopen("small.out","wt",stdout);
  #endif
  int x,y,i_ln,n_blocks,i_block;
  n_cells=n_x*n_y;
  mtrx_cont=new char[n_cells]; mtrx=new char*[n_x];
  for (x=0,y=0; x<n_x; x++,y+=n_y) mtrx[x]=&mtrx_cont[y];
  scanf("%d",&n_blocks);
  memset(mtrx_cont,0,sizeof(char)*n_cells);
  for (i_block=0; i_block<n_blocks; i_block++) {
    scanf("%d%d",&y,&x); x--; y--;
    mtrx[x][y]=1;
  }
  scanf("%d",&n_lns_y);
  lns_y=new int[n_lns_y--];
  for (i_ln=0; i_ln<=n_lns_y; i_ln++) {
    scanf("%d",&lns_y[i_ln]);
    lns_y[i_ln]--;
  }
  scanf("%d",&n_lns_x);
  lns_x=new int[n_lns_x--];
  int x_0,x_1;
  cnts_cont_0=new int[(n_x+1)*(n_x+1)*(n_lns_y+1)];
  cnts_cont_1=new int*[(n_x+1)*(n_x+1)];
  cnts=new int**[n_x+1];
  for (x=0,i_ln=0; x<(n_x+1)*(n_x+1); x++,i_ln+=n_lns_y+1)
    cnts_cont_1[x]=&cnts_cont_0[i_ln];
  for (x_0=0,x_1=0; x_0<=n_x; x_0++,x_1+=n_x+1)
    cnts[x_0]=&cnts_cont_1[x_1];
  memset(cnts_cont_0,0,sizeof(int)*(n_x+1)*(n_x+1)*(n_lns_y+1));
  for (x=0; x<n_x; x++) for (i_ln=0; i_ln<n_lns_y; i_ln++) {
    for (y=lns_y[i_ln]; y<lns_y[i_ln+1]; y++) if (mtrx[x][y]) {
      cnts[x][x+1][i_ln]++; cnts[x][x+1][n_lns_y]++; break;
    }
  }
  for (x=2; x<=n_x; x++) for (x_0=0,x_1=x; x_1<=n_x; x_0++,x_1++)
   for (i_ln=0; i_ln<n_lns_y; i_ln++) {
      cnts[x_0][x_1][i_ln]=cnts[x_0][x_1-1][i_ln];
    if (cnts[x_0][x_1][i_ln]<cnts[x_1-1][x_1][i_ln])
      cnts[x_0][x_1][i_ln]=cnts[x_1-1][x_1][i_ln];
    cnts[x_0][x_1][n_lns_y]+=cnts[x_0][x_1][i_ln];
  }
  int cnt;
  infos_cont=new TInfo[(n_lns_x+1)*(n_x+1)]; infos=new TInfo*[n_lns_x+1];
  for (i_ln=0,x=0; i_ln<=n_lns_x; i_ln++,x+=n_x+1) infos[i_ln]=&infos_cont[x];
  memset(infos_cont,-1,sizeof(TInfo)*(n_lns_x+1)*(n_x+1));
  infos[0][0].cnt=0; infos[0][0].width=0;
  for (i_ln=1; i_ln<=n_lns_x; i_ln++) {
    for (x_0=0; x_0<n_x; x_0++) for (x_1=x_0+1; x_1<=n_x; x_1++) {
      cnt=infos[i_ln-1][x_0].cnt;
      if (cnt<0) continue;
      cnt+=cnts[x_0][x_1][n_lns_y];
      if (infos[i_ln][x_1].cnt<cnt) {
        infos[i_ln][x_1].cnt=cnt;
        infos[i_ln][x_1].width=x_1-x_0;
      }
    }
  }
  x=n_x;
  for (i_ln=n_lns_x; i_ln>0; i_ln--) {
    lns_x[i_ln]=x;
    x-=infos[i_ln][x].width;
  } lns_x[i_ln]=x;
  printf("%d",n_lns_x+1);
  for (i_ln=0; i_ln<=n_lns_x; i_ln++) printf(" %d",lns_x[i_ln]+1);
  printf("\n");
  delete[]infos_cont; delete[]infos;
  delete[]cnts_cont_0; delete[]cnts_cont_1; delete[]cnts;
  delete[]lns_x; delete[]lns_y;
  delete[]mtrx_cont; delete[]mtrx;
  #ifndef OFFLINE
  fclose(stdin);
  fclose(stdout);
  #endif
  return(0);
}


