{$I-,Q-,R-,S-}
{$M 10048576,0}
const taskid='2instr';
      inf=taskid+'.in';
      ouf=taskid+'.out';
      infinity=maxlongint div 3;
var src,dst,hlen,wrote,ans:longint;
    dump,best,hpos,first,was:array [0..65535] of longint;
    heap,aa:array [1..65536] of longint;
    v,next,w:array [1..200000] of longint;
function readword:string;
var ch:char;
    res:string;
begin
  read(ch);
  while ch in [' ',#10,#13] do
    read(ch);
  res:='';
  while ch in ['0'..'9','A'..'F'] do
  begin
    res:=res+ch;
    read(ch);
  end;
  readword:=res;
end;
function cnv(c:char):longint;
begin
  case c of
    '0'..'9':cnv:=byte(c)-byte('0');
    'A'..'F':cnv:=byte(c)-byte('A')+10;
  end;
end;
function convert(s:string):longint;
var res,i:longint;
begin
  res:=0;
  for i:=1 to length(s) do
    res:=res*16+cnv(s[i]);
  convert:=res;
end;
procedure init;
var i:longint;
begin
  assign(input,inf);
  reset(input);
  src:=convert(readword);
  dst:=convert(readword);
  for i:=0 to 65535 do
    dump[i]:=convert(readword);
  close(input);
end;
procedure swap(x,y:longint);
var t:longint;
begin
  t:=heap[x];
  heap[x]:=heap[y];
  heap[y]:=t;
  hpos[heap[x]]:=x;
  hpos[heap[y]]:=y;
end;
procedure heapify(x:longint);
var l,r,min:longint;
begin
  l:=2*x;
  r:=2*x+1;
  min:=x;
  if (l<=hlen) and (best[heap[l]]<best[heap[min]]) then
    min:=l;
  if (r<=hlen) and (best[heap[r]]<best[heap[min]]) then
    min:=r;
  if min<>x then
  begin
    swap(min,x);
    heapify(min);
  end;
end;
procedure extract(var x:longint);
begin
  x:=heap[1];
  swap(1,hlen);
  dec(hlen);
  heapify(1);
end;
procedure flow(x:longint);
begin
  while (x>1) and (best[heap[x shr 1]]>best[heap[x]]) do
  begin
    swap(x,x shr 1);
    x:=x shr 1;
  end;
end;
procedure relax(x,y,w:longint);
begin
  if best[x]+w<best[y] then
  begin
    best[y]:=best[x]+w;
    flow(hpos[y]);
  end;
end;
function bswap(x:longint):longint;
begin
  bswap:=((x and $FF) shl 8) or ((x and $FF00) shr 8);
end;
function popsp(x:longint):longint;
begin
  popsp:=dump[x]+dump[(x+1) mod 65536]*256;
end;
procedure addedge(q,x,y,ww:longint);
begin
  v[q]:=y;
  next[q]:=first[x];
  w[q]:=ww;
  first[x]:=q;
end;
procedure run;
var i,x,cur:longint;
begin
  hlen:=65536;
  fillchar(first,sizeof(first),0);
  for i:=0 to 65535 do
  begin
    best[i]:=infinity;
    heap[i+1]:=i;
    hpos[i]:=i+1;
    addedge(2*i+2,i,popsp(i),1);
    addedge(2*i+1,i,bswap(i),2);
  end;
  best[src]:=0;
  swap(hpos[src],1);
  for i:=0 to 65535 do
  begin
    extract(x);
    cur:=first[x];
    while cur<>0 do
    begin
      relax(x,v[cur],w[cur]);
      cur:=next[cur];
    end;
  end;
end;
procedure wri(x:longint);
begin
  if x div 16<10 then
    write(x div 16)
  else write(char(x div 16-10+byte('A')));
  if x mod 16<10 then
    write(x mod 16)
  else write(char(x mod 16-10+byte('A')));
end;
procedure writ(x:longint);
begin
  if wrote mod 16=0 then
    writeln
  else begin
    write(' ');
    if wrote mod 8=0 then
      write(' ');
  end;
  wri(x);
  inc(wrote);
end;
procedure oup(x:longint);
begin
  inc(ans);
  aa[ans]:=x;
end;
function outp(x:longint):boolean;
var cur:longint;
begin
  outp:=false;
  if was[x]=1 then
    exit;
  was[x]:=1;
  outp:=true;
  if x=dst then
    exit;
  outp:=true;
  cur:=first[x];
  while cur<>0 do
  begin
    if (best[x]+w[cur]=best[v[cur]]) and outp(v[cur]) then
    begin
      if w[cur]=1 then
        oup(92)
      else begin
        oup(204);
        oup(15);
      end;
      exit;
    end;
    cur:=next[cur];
  end;
  outp:=false;
end;
procedure done;
var i:longint;
begin
  assign(output,ouf);
  rewrite(output);
  if best[dst]=infinity then
  begin
    writeln('IMPOSSIBLE');
    close(output);
    halt;
  end;
  write(best[dst]);
  fillchar(was,sizeof(was),0);
  ans:=0;
  outp(src);
  wrote:=0;
  for i:=ans downto 1 do
    writ(aa[i]);
  writeln;
  close(output);
end;
begin
  init;
  run;
  done;
end.
