{$I-,Q-,R-,S-}
{$M 10048576,0}
uses sysutils;
const taskid='ram';
      inf=taskid+'.in';
      ouf=taskid+'.out';
var m,n,curop,curnm:longint;
    curch:char;
    curt,func,value:string;
    prog:array [0..1000] of record
      func,otype,num:longint;
    end;
    nums,reg:array [0..1000] of longint;
function curchar:char;
begin
  curchar:=curch;
end;
procedure nextchar;
begin
  read(curch);
end;
procedure skip;
begin
  while curchar in [#10,#13,#32] do
    nextchar;
end;
function curtoken:string;
begin
  curtoken:=curt;
end;
function nexttoken:string;
begin
  skip;
  curt:='';
  while curchar in ['A'..'Z','0'..'9','=','*'] do
  begin
    curt:=curt+curchar;
    nextchar;
  end;
end;
function v(x:longint):longint;
begin
  case prog[x].otype of
    1:v:=prog[x].num;
    2:v:=reg[prog[x].num];
    3:v:=reg[reg[prog[x].num]];
  end;
end;
function process(x:longint):longint;
begin
  case prog[x].func of
    1:begin {LOAD}
        reg[0]:=v(x);
        process:=x+1;
      end;
    2:begin {STORE}
        case prog[x].otype of
          2:reg[prog[x].num]:=reg[0];
          3:reg[reg[prog[x].num]]:=reg[0];
        end;
        process:=x+1;
      end;
    3:begin {ADD}
        inc(reg[0],v(x));
        process:=x+1;
      end;
    4:begin {SUB}
        dec(reg[0],v(x));
        process:=x+1;
      end;
    5:begin {MULT}
        reg[0]:=reg[0]*v(x);
        process:=x+1;
      end;
    6:begin {DIV}
        reg[0]:=reg[0] div v(x);
        process:=x+1;
      end;
    7:begin {READ}
        case prog[x].otype of
          2:reg[prog[x].num]:=nums[curnm];
          3:reg[reg[prog[x].num]]:=nums[curnm];
        end;
        inc(curnm);
        process:=x+1;
      end;
    8:begin {WRITE}
        writeln(v(x));
        process:=x+1;
      end;
    9:begin {JUMP}
        process:=prog[x].num;
      end;
    10:begin {JGTZ}
         if reg[0]>0 then
           process:=prog[x].num
         else process:=x+1;
       end;
    11:begin {JZERO}
         if reg[0]=0 then
           process:=prog[x].num
         else process:=x+1;
       end;
    12:begin {HALT}
         process:=-1;
       end;
  end;
end;
procedure init;
var i:longint;
begin
  assign(input,inf);
  reset(input);
  assign(output,ouf);
  rewrite(output);
  readln(m,n);
  nextchar;
  for i:=0 to m-1 do
  begin
    nexttoken;
    func:=curtoken;
    if func='LOAD' then
      prog[i].func:=1
    else if func='STORE' then
      prog[i].func:=2
    else if func='ADD' then
      prog[i].func:=3
    else if func='SUB' then
      prog[i].func:=4
    else if func='MULT' then
      prog[i].func:=5
    else if func='DIV' then
      prog[i].func:=6
    else if func='READ' then
      prog[i].func:=7
    else if func='WRITE' then
      prog[i].func:=8
    else if func='JUMP' then
      prog[i].func:=9
    else if func='JGTZ' then
      prog[i].func:=10
    else if func='JZERO' then
      prog[i].func:=11
    else if func='HALT' then
      prog[i].func:=12;
    prog[i].otype:=0;
    prog[i].num:=0;
    if func<>'HALT' then
    begin
      nexttoken;
      value:=curtoken;
      if value[1]='=' then
        prog[i].otype:=1
      else if value[1] in ['0'..'9'] then
        prog[i].otype:=2
      else if value[1]='*' then
        prog[i].otype:=3;
      if not (value[1] in ['0'..'9']) then
        delete(value,1,1);
      prog[i].num:=strtoint(value);
    end;
  end;
  for i:=1 to n do
    read(nums[i]);
  fillchar(reg,sizeof(reg),255);
  curnm:=1;
  curop:=0;
  while curop<>-1 do
    curop:=process(curop);
  close(input);
  close(output);
end;
procedure run;
begin
end;
procedure done;
begin
end;
begin
  init;
  run;
  done;
end.
