{$I-,Q-,R-,S-}
type tlong=array [0..5000] of int64;
const taskid='lcm';
      inf=taskid+'.in';
      ouf=taskid+'.out';
      base=1000000;
      lgbase=6;
var n:longint;
    a:array [1..2000] of longint;
    ans:tlong;
procedure init;
var i:longint;
begin
  assign(input,inf);
  reset(input);
  read(n);
  for i:=1 to n do
    read(a[i]);
  close(input);
end;
function _nod(a,b:longint):longint;
begin
  if a=0 then
    _nod:=b
  else _nod:=_nod(b mod a,a);
end;
function ost(a:tlong;b:longint):longint;
var res:int64;
    i:longint;
begin
  res:=0;
  for i:=a[0] downto 1 do
    res:=(res*base+a[i]) mod b;
  ost:=res;
end;
function nod(a:tlong;b:longint):longint;
begin
  nod:=_nod(ost(a,b),b);
end;
procedure mul(var a:tlong;b:longint);
var os,tmp:int64;
    i:longint;
begin
  os:=0;
  for i:=1 to a[0] do
  begin
    tmp:=a[i]*b+os;
    a[i]:=tmp mod base;
    os:=tmp div base;
  end;
  while os>0 do
  begin
    inc(a[0]);
    a[a[0]]:=os mod base;
    os:=os div base;
  end;
end;
procedure del(var a:tlong;b:longint);
var os,tmp:int64;
    i:longint;
begin
  os:=0;
  for i:=a[0] downto 1 do
  begin
    tmp:=os*base+a[i];
    a[i]:=tmp div b;
    os:=tmp mod b;
  end;
  while (a[0]>0) and (a[a[0]]=0) do
    dec(a[0]);
end;
procedure run;
var i,q:longint;
begin
  fillchar(ans,sizeof(ans),0);
  ans[0]:=1;
  ans[1]:=1;
  for i:=1 to n do
  begin
    q:=nod(ans,a[i]);
    mul(ans,a[i]);
    del(ans,q);
  end;
end;
procedure print(var a:tlong);
var i:longint;
    tmp:string;
begin
  write(a[a[0]]);
  for i:=a[0]-1 downto 1 do
  begin
    str(a[i],tmp);
    while length(tmp)<lgbase do
      tmp:='0'+tmp;
    write(tmp);
  end;
end;
procedure done;
begin
  assign(output,ouf);
  rewrite(output);
  print(ans);
  close(output);
end;
begin
  init;
  run;
  done;
end.
