program ooo;
const
  filename  = 'programs';
  InFile = FileName+'.in';
  OutFile = FileName+'.out';
  MaxL = 1000;
  Del = 1000000000;

type
  TNN = record
          l : integer;
          c : array[1..MaxL] of longint;
        end;

var
  i, l, j, k, n, m : longint;
  nn : array[0..600] of TNN;
  lngs : array[1..600] of integer;
  ch : char;
  w, x : integer;
  bb : array[0..600] of boolean;
  sl : TNN;

procedure OpenFile;
begin
  assign(input, InFile);
  reset(input);
  readln(n);
  j:= 0;
  while j< n do
    begin
    if not eoln then inc(j);
    while not eoln do
      begin
      read(ch);
      if ch<>#32 then inc(lngs[j]);
      end;
    readln;
    end;
  read(l);
  close(input);
end;

procedure QSort(const l, r : longint);
var
  i, j : longint;
begin
  i:= l;
  j:= r;
  x:= lngs[(j+i) div 2];
  repeat
    while lngs[i]< x do inc(i);
    while lngs[j]> x do dec(j);
    if i<=j then
      begin
      w:= lngs[i];
      lngs[i]:= lngs[j];
      lngs[j]:= w;
      inc(i);
      dec(j);
      end;
  until i>=j;
  if i<r then QSort(i, r);
  if l<j then QSort(l, j);
end;

function max(a, b : integer) : integer;
begin
  if a> b then max:= a
  else max:= b;
end;

procedure Slozh(a, b : integer);
var
  i, j, n : longint;
begin
  j:= 0;
  nn[a].l:= max(nn[a].l, nn[b].l);
  for i:=1 to nn[a].l do
    begin
    n:= nn[a].c[i];
    nn[a].c[i]:= (j+ nn[a].c[i]+ nn[b].c[i]) mod del;
    j:= (j+ n+ nn[b].c[i]) div del;
    end;
  if j <> 0 then
    begin
    inc(nn[a].l);
    nn[a].c[nn[a].l]:= j;
    end;
end;


procedure Solve;
begin
  QSort(1, n);
  for i:=1 to l do
    bb[i]:= false;
  bb[0]:= true;
  nn[0].c[1]:= 1;
  nn[0].l:= 1;
  for i:=1 to l do
    begin
    j:= 1;
    while (lngs[j]<= i) and (j<= n) do
      begin
      if i>= lngs[j] then
        begin
        if bb[i-lngs[j]] then
          begin
          bb[i]:= true;
          slozh(i, i-lngs[j]);
          end;
        end;
      inc(j);
      end;
    end;
end;

procedure SaveFile;
begin
  assign(output, OutFile);
  rewrite(Output);
  if nn[l].l <>0 then
    write(nn[l].c[nn[l].l])
  else write('0');
  for i:= nn[l].l-1 downto 1 do
    begin
    j:= nn[l].c[i];
    if j <> 0 then
      while j < (del div 10) do
        begin
        write(0);
        j:= j* 10;
        end
    else
      write('000000000');
    write(nn[l].c[i]);
    end;
  close(output);
end;

begin
  OpenFile;
  Solve;
  SaveFile;
end.
