{$IFDEF NORMAL}
  {$I-,Q-,R-,S-}
{$ENDIF NORMAL}
{$IFDEF DEBUG}
  {$I+,Q+,R+,S-}
{$ENDIF DEBUG}
{$IFDEF RELEASE}
  {$I-,Q-,R-,S-}
{$ENDIF RELEASE}
program ooo;
const
  filename  = 'indirect';
  InFile = FileName+'.in';
  OutFile = FileName+'.out';

type
  TIns = record
           op, a : integer;
         end;
var
  i, n, m, k, cikl, j, ac : longint;
  ins : array[1..262144] of TIns;
  c : array[1..32768] of integer;
  b : array[1..32768] of boolean;
  rez : (successful, divby0, runtime);

procedure OpenFile;
var
  ch : char;
  s : string;
  z : integer;
begin
  assign(input, InFile);
  reset(input);
  i:= 0;
  while not eof do
    begin
    inc(i);
    s:= '';
    z:= 0;
    while not eoln do
      begin
      read(ch);
      case ch of
        'A' : ins[i].op:= 1;
        'S' : ins[i].op:= 2;
        'M' : ins[i].op:= 3;
        'D' : ins[i].op:= 4;
        'O' : ins[i].op:= 5;
        'R' : ins[i].op:= 6;
        'W' : ins[i].op:= 7;
        '*' : z:= 0;
        '=' : z:= 1;
        '-', '0'..'9' : s:= s+ ch;
      end;
      end;
    ins[i].op:= ins[i].op+ 8* z;
    val(s, ins[i].a, j);
    readln;
    end;
  m:= i;
  close(input);
end;

procedure Solve;
var
  ac1 : longint;
begin
  i:= 0;
  ac:= 0;
  rez:= successful;
  cikl:= 0;
  repeat
    inc(i);
    ac1:= ac;
    case ins[i].op of
      1 : ac:= ac+ c[ins[i].a];
      2 : ac:= ac- c[ins[i].a];
      3 : ac:= ac* c[ins[i].a];
      4 : if c[ins[i].a]<>0 then
            ac:= ac div  c[ins[i].a]
          else rez:= divby0;
      5: if c[ins[i].a]<>0 then
            ac:= ac mod c[ins[i].a]
          else rez:= divby0;
      6, 7 : begin
          j:= ins[i].a;
          if (c[j] < 0) then fillchar(b, sizeof(b), false);
          while (c[j] < 0) and (rez = successful)  do
            begin
            b[j]:= true;
            j:= - c[j];
            if b[j] then
            rez:= runtime;
            end;
          if rez = successful then
            if j<>0 then
              if ins[i].op = 6 then
                ac:= c[j]
              else c[j]:= ac
            else
              rez:= runtime;
          end;
      9 : ac:= ac + ins[i].a;
      10 : ac:= ac - ins[i].a;
      11 : ac:= ac * ins[i].a;
      12 : if ins[i].a<>0 then
             ac:= ac div ins[i].a
           else rez:= divby0;
      13 : if ins[i].a<>0 then
             ac:= ac mod ins[i].a
           else rez:= divby0;
      14 : begin
           ac:= ins[i].a;
           end;
    end;
    if abs(ac) > 32767 then
      begin
      rez:= runtime;
      ac:= ac1;
      end;
  until (i>= m)or(rez<>successful);
end;

procedure SaveFile;
begin
  assign(output, OutFile);
  rewrite(Output);
  case rez of
    successful : writeln('SUCCESSFUL TERMINATION');
    divby0 : writeln('DIVISION BY ZERO');
    runtime : writeln('RUN-TIME ERROR');
  end;
  writeln(ac);
  for i:=1 to 32768 do
    writeln(c[i]);
  close(output);
end;

begin
  OpenFile;
  Solve;
  SaveFile;
end.
