const
  Max64=2000000000;
type
  TGraphEl = record
    X,Y: Word;
    Z: LongInt;
    end;
  TGraph = array[1..200000] of TGraphEl;
var
  f: Text;
  A: TGraph;
  B: array[1..10000] of LongInt;
  P: array[1..200000] of LongInt;
  N: Word;
  M,K,L,NP,c,NB: LongInt; { K - 砫 த }
                  { L -  த }
  Cost: Int64;
  NewCost: Int64;
procedure ReadData;
var
  i: LongInt;
begin
  Assign(f,'customs.in');
  Reset(f);
  Readln(f,N,M);
  for i:=1 to M do
    Readln(f, A[i].X, A[i].Y, A[i].Z);
  Readln(f,K,L);
  Close(f);
end;

function Min(const a,b: Int64): Int64;
begin
  if a<b then Min:=a
  else Min:=b;
end;
function NotPassed(const k: LongInt): Boolean;
var
  i: LongInt;
begin
  NotPassed:=True;
  for i:=1 to NP do
    if k=P[i] then
    begin
      NotPassed:=False;
      Break;
    end;
end;
procedure ChgL(var a,b: LongInt);
begin
  a:=a+b;
  b:=a-b;
  a:=a-b;
end;
procedure ChgW(var a,b: Word);
begin
  a:=a+b;
  b:=a-b;
  a:=a-b;
end;
procedure ChgElems(var a,b: TGraphEl);
begin
  ChgW(a.X,b.X);
  ChgW(a.Y,b.Y);
  ChgL(a.Z,b.Z);
end;
procedure Sort;
var
  i,j: LongInt;
begin
  for i:=M-1 downto 1 do
    for j:=1 to i do
      if A[j].X > A[j+1].X then
        ChgElems(A[j],A[j+1]);
end;
procedure FillB;
var
  i: LongInt;
begin
  NB:=0;
  if M>=1 then
  begin
    Inc(NB);
    B[1]:=1;
  end;
  for i:=2 to M do
    if A[i-1].X < A[i].X then
    begin
      NB := NB+A[i].X-A[i-1].X;
      B[NB]:=i;
    end;
  NB:=NB+1;
  B[NB]:=M+1;
end;
procedure MakeDouble;
var
  OldM,i: LongInt;
begin
  OldM:=M;
  for i:=1 to OldM do
  begin
    Inc(M);
    A[M].X:=A[i].Y;
    A[M].Y:=A[i].X;
    A[M].Z:=A[i].Z;
  end;
end;
procedure RegPass(const k: LongInt; var s: Word);
var
  i: LongInt;
begin
  NP:=NP+1;
  s:=1;
  P[NP]:=k;
  for i:=1 to M do
    if (A[k].X=A[i].Y) and (A[k].Y=A[i].X) and (k<>i) then
    begin
      NP:=NP+1;
      P[NP]:=i;
      s:=2;
    end;
end;
procedure Solve(const k: Word);
var
  i: LongInt;
  s: Word;
begin
  if k<>L then
  begin
    for i:=B[k] to B[k+1]-1 do
      if NotPassed(i) then
      begin
        RegPass(i,s);
        if c<=3 then
          NewCost:=NewCost+A[i].Z;
        c:=c+1;
        Solve(A[i].Y);
        c:=c-1;
        if c<=3 then
          NewCost:=NewCost-A[i].Z;
        NP:=NP-s;
      end;
  end else
  begin
    Cost:=Min(NewCost,Cost);
{    NewCost:=0;}
  end;
end;

procedure WriteData;
begin
  if Cost=Max64 then
    Cost:=0;
  Assign(f,'customs.out');
  Rewrite(f);
  Write(f,Cost);
  Close(f);
end;

begin
  ReadData;
  Cost:=Max64;
  NP:=0;
  c:=1;
  NewCost:=0;
  MakeDouble;
  Sort;
  FillB;
  Solve(K);
  WriteData;
end.
