type
  TGraphEl = record
    a,b: Word;
    end;
  TGraph = record
    Elm: array[1..50000] of TGraphEl;
    N,M: Word;
    end;
var
  f: Text;
  T,k: Byte;
  A: array[1..4] of TGraph;
  B,P: array[1..50000] of Word;
  R: array[1..50000] of Boolean;
  NB,NP,NR: Word;
  Res: Boolean;

procedure ReadData;
var
  i,j: LongInt;
begin
  Assign(f,'quirks.in');
  Reset(f);
  Readln(f,T);
  Readln(f);
  for i:=1 to T do
  begin
    Readln(f,A[i].N,A[i].M);
    for j:=1 to A[i].M do
      Readln(f, A[i].Elm[j].a, A[i].Elm[j].b);
    Readln(f);
  end;
  Close(f);
end;

{procedure ChgL(var a,b: LongInt);
begin
  a:=a+b;
  b:=a-b;
  a:=a-b;
end;}
procedure ChgW(var a,b: Word);
begin
  a:=a+b;
  b:=a-b;
  a:=a-b;
end;
procedure ChgElems(var a,b: TGraphEl);
begin
  ChgW(a.a,b.a);
  ChgW(a.b,b.b);
end;
procedure Sort;
var
  i,j: LongInt;
begin
  for i:=A[k].M-1 downto 1 do
    for j:=1 to i do
      if A[k].Elm[j].a > A[k].Elm[j+1].a then
        ChgElems(A[k].Elm[j],A[k].Elm[j+1]);
end;
procedure FillB;
var
  i,OldNB: LongInt;
begin
  NB:=0;
  if A[k].M>=1 then
  begin
    Inc(NB);
    B[1]:=1;
  end;
  for i:=2 to A[k].M do
    if A[k].Elm[i-1].a < A[k].Elm[i].a then
    begin
      NB := NB+A[k].Elm[i].a-A[k].Elm[i-1].a;
      B[NB]:=i;
    end;
  NB:=NB+1;
  B[NB]:=A[k].M+1;
  OldNB:=NB;
  for i:=OldNB to A[k].N do
  begin
    B[i+1]:=B[i];
    NB:=NB+1;
  end;
end;
function NotPassed(const k: LongInt): Boolean;
var
  i: LongInt;
begin
  NotPassed:=True;
  for i:=1 to NP do
    if k=P[i] then
    begin
      NotPassed:=False;
      Break;
    end;
end;
function FindNext: Word;
var
  i: Word;
begin
  FindNext:=0;
  for i:=1 to A[k].N do
    if not(R[i]) then
    begin
      FindNext:= i;
      Break;
    end;
end;
procedure Solve;
var
  i,j,c,x,y: Word;
begin
  for i:=1 to A[k].N do
    R[i]:=False;
  Res:=False;
  c:=1;
  while not(Res) and (c>0) do
  begin
    R[c]:=True;
    P[1]:=c; NP:=1;
    x:=1;
    y:=1;
    while (y<A[k].N) and (x<=y) do
    begin
      for i:=x to y do
        if B[P[i]]<B[P[i]+1] then
          for j:=B[P[i]] to B[P[i]+1]-1 do
            if NotPassed(A[k].Elm[j].b) then
            begin
              NP:=NP+1;
              P[NP]:=A[k].Elm[j].b;
            end;
      if (NP-y) < (y-x) then Break;
      x:=y+1;
      y:=NP;
    end;
    Res := Res or ((NP=A[k].N) and ((NP-y) < (y-x)));
    c:=FindNext;
  end;
end;

procedure WriteData;
begin
  if Res then Writeln(f,'YES')
  else Writeln(f,'NO');
end;

begin
  ReadData;
  Assign(f,'quirks.out');
  Rewrite(f);
  for k:=1 to T do
  begin
    Sort;
    FillB;
    Solve;
    WriteData;
  end;
  Close(f);
end.