const
  MemSize=32768;
var
  f: Text;
  A: Integer;
  CompMem: array[1..MemSize] of Integer;
  Passed: array[1..MemSize] of Boolean;
  ExtCode: string;

procedure ReadData;
var
  i: Word;
begin
  for i:=1 to MemSize do
    CompMem[i]:=0;
  A:=0;
  Assign(f,'indirect.in');
  Reset(f);
end;

function DoCmdC(const Cmd: Char; var X: Integer; const Y: Integer): Boolean;
begin
  DoCmdC:=True;
  case Cmd of
  'A':begin
        if abs(X+Y) <= MaxInt then X:=X+Y
        else X:=(X+Y) mod MaxInt;
      end;
  'S':begin
        if abs(X-Y) <= MaxInt then X:=X-Y
        else A:=(X-Y) mod MaxInt;
      end;
  'M':begin
        if abs(X*Y) <= MaxInt then X:=X*Y
        else X:=(X*Y) mod MaxInt;
      end;
  'D':if Y<>0 then X:=X div Y
      else
      begin
        DoCmdC:=False;
        ExtCode:='DIVISION BY ZERO';
      end;
  'O':if Y<>0 then X:=X mod Y
      else
      begin
        DoCmdC:=False;
        ExtCode:='DIVISION BY ZERO';
      end;
  'R':begin
        if abs(Y) <= MaxInt then X:=Y
        else X:=Y mod MaxInt;
      end;
  end;
end;
function DoCmdM(const Cmd: Char; var X: Integer; const N: Word): Boolean;
var
  i: LongInt;
begin
  if (Cmd<>'R') and (Cmd<>'W') then
    DoCmdM := DoCmdC(Cmd,X,CompMem[N])
  else
  begin
    for i:=1 to MemSize do
      Passed[i]:=False;
    i:=N;
    while (CompMem[i]<0) and not(Passed[i]) do
    begin
      Passed[i]:=True;
      i := abs(CompMem[i]);
    end;
    if Passed[i] then
    begin
      ExtCode:='RUN-TIME ERROR';
      DoCmdM:=False;
    end
    else
      if Cmd<>'W' then DoCmdM := DoCmdC(Cmd,X,CompMem[i])
      else
      begin
        CompMem[i]:=A;
        DoCmdM:=True;
      end;
  end;
end;
function DoCmd(Cmd: string): Boolean;
var
  i,n: Integer;
begin
  Val(Copy(Cmd,3,Length(Cmd)),n,i);
  case Cmd[2] of
    '*':DoCmd := DoCmdM(Cmd[1],A,n);
    '=':DoCmd := DoCmdC(Cmd[1],A,n);
  end;
end;
procedure Solve;
var
  B: Boolean;
  Cmd: string;
begin
  B:=True;
  while (not(eof(f))) and B do
  begin
    Readln(f,Cmd);
    B:=DoCmd(Cmd);
  end;
  if B then
    ExtCode:='SUCCESSFUL TERMINATION';
  Close(f);
end;

procedure WriteData;
var
  i: Word;
begin
  Assign(f,'indirect.out');
  Rewrite(f);
  Writeln(f,ExtCode);
  Writeln(f,A);
  for i:=1 to MemSize do
    Writeln(f,CompMem[i]);
  Close(f);
end;

begin
  ReadData;
  Solve;
  WriteData;
end.