type
  TMyArray = array[1..32,1..4] of Byte;
  TMyArray1 = array[1..4] of Byte;
  TUnit=record
    K,L: Byte;
    Input,Output: TMyArray;
    univ: Boolean;
    end;
var
  f: Text;
  T: Byte;
  U: array[1..4] of TUnit;

function pw(const a,b: Word): Word;
var
  i,c: Word;
begin
  c:=1;
  for i:=1 to b do
    c:=c*a;
  pw:=c;
end;

procedure ReadData;
var
  i,j,m: Byte;
begin
  Assign(f,'unit.in');
  Reset(f);
  Readln(f,T);
  for i:=1 to T do
  begin
    with U[i] do
    begin
      Readln(f,K,L);
      for j:=1 to pw(2,K) do
      begin
        for m:=1 to K do
          Read(f,Input[j,m]);
        for m:=K to L do
          Read(f,Output[j,m]);
      end;
    end;
  end;
  Close(f);
end;

function Compare1(const a,b: TMyArray1; const n: Byte): Boolean;
var
  i: Byte;
begin
  Compare1:=True;
  for i:=1 to n do
    if a[i] <> b[i] then
    begin
      Compare1:=False;
      Break;
    end;
end;

procedure GetOutput(const U: TUnit; const a: TMyArray1; var b: TMyArray1);
var
  i: Byte;
begin
  i:=1;
  while (i<=pw(1,U.K)) and Compare1(a,U.Input[i],U.K) do
    i:=i+1;
  b:=U.Output[i];
end;

procedure Solve;
var
  i,m: Byte;
  a,b: TMyArray1;
begin
  for i:=1 to T do
  begin
    a:=U[i].Input[1];
    m:=1;
    repeat
      GetOutput(U[i],a,b);
      a:=b;
      Inc(m);
    until (m>pw(2,U[i].K)) or not(Compare1(a,U[i].Input[1],U[i].K));
    if m < pw(2,U[i].K) then U[i].univ := True
    else U[i].univ := False;
  end;
end;

procedure WriteData;
var
  i: Byte;
begin
  Assign(f,'unit.out');
  Rewrite(f);
  for i:=1 to T do
    if U[i].univ then Writeln(f,'YES')
    else Writeln(f,'NO');
  Close(f);
end;

begin
  ReadData;
  Solve;
  WriteData;
end.