#include <stdio.h>
#include <string.h>
#include <time.h>

#define DBG 0

#define MAX(A, B) ((A) > (B) ? (A) : (B))

#define MAX_N 603
#define MAX_L 603
#define MAX_LEN 259

#define LEN 236
#define BASE 100000000000000000
#define BLEN 17

typedef long long type;

char S[MAX_N][MAX_LEN];
int N, Len, L[MAX_N];
type A[MAX_L][LEN];
int LA[MAX_L];

void Add( type *A, type *B, int L, int *Len )
{
  int i;

  *Len = L;
  for (i = 0; i < L; i++)
    A[i] += B[i];
  for (i = 0; i < L - 1; i++)
    if (A[i] >= BASE)
      A[i] -= BASE, A[i + 1]++;
  if (A[i] >= BASE)
    A[i] -= BASE, A[i + 1]++, (*Len)++;
}

void Print( type *A, FILE *F )
{
  int i;

  for (i = LEN - 1; i > 0 && !A[i]; i--)
    ;
  if (F != NULL)
  {
    fprintf(F, "%d", A[i--]);
    while (i >= 0)
      fprintf(F, "%0*Ld", BLEN, A[i--]);
  }
  else
  {
    printf("%d", A[i--]);
    while (i >= 0)
      printf("%0*Ld", BLEN, A[i--]);
  }
}

int main( void )
{
  FILE *InF, *OutF;
  int i, j;
# if DBG == 1
  int t = clock();
# endif

  memset(A, 0, sizeof(A));
  memset(LA, 0, sizeof(LA));
  memset(L, 0, sizeof(L));
  InF = fopen("programs.in", "rt");
  OutF = fopen("programs.out", "wt");
  fscanf(InF, "%d", &N);
  fgets(S[0], MAX_LEN, InF);
  for (i = 0; i < N; i++)
    fgets(S[i], MAX_LEN, InF);
  fscanf(InF, "%d", &Len);
  for (i = 0; i < N; i++)
    for (j = 0; S[i][j] != 0; j++)
      if (S[i][j] != ' ' && S[i][j] != 10 && S[i][j] != 13)
        L[i]++;
  A[0][0] = 1, LA[0] = 1;
  for (i = 0; i < Len; i++)
    for (j = 0; j < N; j++)
      if (i + L[j] <= Len)
        Add(A[i + L[j]], A[i], MAX(LA[i], LA[i + L[j]]), &LA[i + L[j]]);
  Print(A[Len], OutF);
# if DBG == 2
  for (i = 0; i <= Len; i++)
    Print(A[i], NULL), printf("\n");
# endif
# if DBG == 1
  printf("Time=%d\n", clock() - t);
# endif
  return 0;
}
