{$D-,G-,I-,J-,L-,H+,N+,Q-,R-,S-}
program prA;


uses
  SysUtils;

Const FileIn='kitten.in';
      FileOut='kitten.out';
Type Integer=LongInt;
     PTree=^TTree;
     TTree=Record
        Left,Right:PTree;
        Key:Integer;
        A,B:Integer;
     End;
Var T:PTree;
procedure Init;
  Begin
    T:=Nil;
  End;
Function Reload(Var T:PTree;Index:Integer;A,B:Integer):Boolean;
  Var Result:Boolean;
  Begin
    If T=Nil Then
      Begin
        New(T);
        T^.Left:=Nil;
        T^.Right:=Nil;
        T^.A:=A;
        T^.B:=B;
        T^.Key:=0;
      End;
    If (T^.A=T^.B) Then
      Begin
        Result:=T^.Key=0;
        If Result Then T^.Key:=1;
        Reload:=Result;
        Exit;
      End;
    If Index>(T^.A + T^.B) div 2 Then
      Begin
        If A + 1 = B Then Result:=Reload(T^.right,Index,B,B)
          Else
          Result:=Reload(T^.Right,Index,(A + B) div 2 + 1,B)
      End
      Else
      Begin
        If A + 1 = B Then Result:=Reload(T^.left,Index,A,A)
          Else
        Result:=Reload(T^.Left,Index,A,(A + B) div 2);
      End;
   If Result Then Inc(T^.Key);
   Reload:=Result;
  End;
Function GetNumber(T:PTree;A,B:Integer):Integer;
  Var Result:Integer;
  Begin
    If T=Nil Then
      Begin
        GetNumber:=0;
        Exit;
      End;
    If (T^.A=T^.B) Then
      Begin
        GetNumber:=T^.Key;
        Exit;
      End;
    Result:=0;
    If A<=(T^.A + T^.B) div 2 Then
      Begin
        If B>=(T^.A + T^.B) Then
          Result:=GetNumber(T^.Left,A,(T^.A + T^.B) div 2)
          Else
          Result:=GetNumber(T^.Left,A,B);
      End;
    If B>(T^.A + T^.B) div 2 Then
      Begin
        If A<=(T^.A + T^.B) div 2 Then
          Result:=Result + GetNumber(T^.Right,(T^.A + T^.B) div 2 + 1,B)
          Else
          Result:=Result + GetNumber(T^.Right,A,B);
      End;
    GetNumber:=Result;
  End;
procedure CloseFiles;
  Begin
    Close(Input);
    Close(Output);
  End;
procedure OpenFiles;
  Begin
    Assign(Input,FileIn);
    Reset(Input);
    Assign(Output,FileOut);
    Rewrite(Output);
  End;
Procedure Solve;
  Var S:String;
      A,B:Integer;
  Begin
    While Not SeekEof Do
      Begin
        Readln(S);
        If Pos(' ',S)=0 Then
          Begin
            A:=StrToInt(S);
            S:='';
          End
          Else
          Begin
            A:=StrToInt(Copy(S,1,Pos(' ',S) - 1));
            Delete(S,1,Pos(' ',S));
            While Pos(' ',S)<>0 Do
              Delete(S,Pos(' ',S),1);
          End;
        If S='' Then
          Begin
            Reload(T,A,-1000000,1000000);
            Continue;
          End;
        B:=StrToInt(S);
        Writeln(GetNumber(T,A,B));
      End;
  End;
begin
  OpenFiles;
  Init;
  Solve;
  CloseFiles
end.
