program prA;

{$D-,R-,I-,L-,Q-,S-,H+}
Const FileIn='programs.in';
      FileOut='programs.out';
      MaxN=600;
Type Integer=LongInt;
     TLong=Record
        Len:Integer;
        Key:Array[1..MaxN] Of Int64;
     End;
Var A:Array[0..MaxN+MaxN] Of TLong;
    B:Array[0..MaxN+MaxN] Of Boolean;
    Pr:Array[1..MaxN] Of Integer;
    Dr:Array[0..255] Of Integer;
    N,L:Integer;
    Osn:Int64;
procedure Init;
  Var S:String;
      I,J:Integer;
  Begin           
    Osn:=Int64(1000000000)*1000000;
    Fillchar(B,Sizeof(B),False);
    Fillchar(Dr,Sizeof(Dr),0);
    B[0]:=True; A[0].Len:=1; A[0].Key[1]:=1;
    Readln(N);
    For I:=1 To N Do
      Begin
        Readln(S);
        Pr[I]:=0;
        For J:=1 To Length(S) Do
          If (S[J] in [#32..#126])And(S[J]<>' ') Then
            Inc(Pr[I]);
        Inc(Dr[Pr[I]]);
      End;
    Read(L);
  End;
procedure CloseFiles;
  Begin
    Close(Input);
    Close(Output);
  End;
procedure OpenFiles;
  Begin
    Assign(Input,FileIn);
    Reset(Input);
    Assign(Output,FileOut);
    Rewrite(Output);
  End;
Procedure Mul(Var A:TLong;Var B:TLong;K:Integer);
  Var Temp:Int64;
      I:Integer;
  Begin
    A.Len:=B.Len; Temp:=0;
    For I:=1 To A.Len Do
      Begin
        Temp:=Temp + B.Key[I] * K;
        A.Key[I]:=Temp Mod Osn;
        Temp:=Temp Div Osn;
      End;
    While Temp<>0 Do
      Begin
        Inc(A.Len);
        A.Key[A.Len]:=Temp Mod Osn;
        Temp:=Temp Div Osn;
      End;
  End;
Procedure Sum(Var A:TLong;Var B:TLong;K:Integer);
  Var I:Integer;
      Temp:Int64;
  Begin
    Temp:=0;
    If A.Len>B.Len Then
      Begin
        For I:=1 To B.Len Do
          Begin
            Temp:=Temp + A.Key[I] + B.Key[I]*K;
            A.Key[I]:=Temp Mod Osn;
            Temp:=Temp Div Osn;
          End;
        For I:=B.Len + 1 To A.Len Do
          Begin
            Temp:=Temp + A.Key[I];
            A.Key[I]:=Temp Mod Osn;
            Temp:=Temp Div Osn;
          End;
      End
      Else
      Begin
        For I:=1 To A.Len Do
          Begin
            Temp:=Temp + A.Key[I] + B.Key[I]*K;
            A.Key[I]:=Temp Mod Osn;
            Temp:=Temp Div Osn;
          End;
        For I:=A.Len + 1 To B.Len Do
          Begin
            Temp:=Temp + B.Key[I]*K;
            Inc(A.Len);
            A.Key[I]:=Temp Mod Osn;
            Temp:=Temp Div Osn;
          End;
      End;
    While Temp<>0 Do
      Begin
        Inc(A.Len);
        A.Key[A.Len]:=Temp Mod Osn;
        Temp:=Temp Div Osn;
      End;
  End;
Procedure Print(Var A:TLong);
  Var I:Integer;
  Begin
    Write(A.Key[A.Len]);
    For I:=A.Len - 1 Downto 1 Do
      Begin              
        If A.Key[I]<100000000000000 Then Write(0);
        If A.Key[I]<10000000000000 Then Write(0);
        If A.Key[I]<1000000000000 Then Write(0);
        If A.Key[I]<100000000000 Then Write(0);
        If A.Key[I]<10000000000 Then Write(0);
        If A.Key[I]<1000000000 Then Write(0);
        If A.Key[I]<100000000 Then Write(0);
        If A.Key[I]<10000000 Then Write(0);
        If A.Key[I]<1000000 Then Write(0);
        If A.Key[I]<100000 Then Write(0);
        If A.Key[I]<10000 Then Write(0);
        If A.Key[I]<1000 Then Write(0);
        If A.Key[I]<100 Then Write(0);
        If A.Key[I]<10 Then Write(0);
        Write(A.Key[I]);
      End;
  End;
Procedure Solve;
  Var I,J:Integer;
  Begin
    For I:=0 To L Do
      If B[I] Then
      For J:=1 To 255 Do
        If Dr[J]<>0 Then
          Begin
            If B[I + J] Then
              Sum(A[I + J],A[I],Dr[J])
             Else
             Begin
               B[I + J]:=True;
               Mul(A[I + J],A[I],Dr[J]);
             End;
          End;
    If Not B[L] Then Write(0) Else
      Print(A[L]);
  End;
begin
  OpenFiles;
  Init;
  Solve;
  CloseFiles;
end.
