program PrB;

{$D-,R-,L-,Q-,S-,I-}
uses
  SysUtils;

Const FileIn='2instr.in';
      FileOut='2instr.out';
      MaxM=65535;//69903;
      Inf=100000;
Type Integer=LongInt;
     HREF=Record Bi,Sm:Integer; End;
     TList=Record Key:HREF; Len:Integer; End;
     Str=String;
Var Data:Array[0..65535] Of Integer;
    Tree:Array[1..MaxM + 1] Of TList;
    C:Array[0..MaxM] Of Integer;
    S:Array[0..MaxM] Of Str;
    St,Fi:HREF;
Function Get16:Integer;
  Var Ch1,Ch2:Char;
      Z1,Z2:Integer;
  Begin
    Read(Ch1);
    While Not (Ch1 in ['0'..'9','A'..'F']) Do
      Read(Ch1);
    Read(Ch2);
    If Ch1 in ['0'..'9'] Then Z1:=Ord(Ch1) - Ord('0')
                         Else Z1:=Ord(Ch1) - Ord('A') + 10;
    If Ch2 in ['0'..'9'] Then Z2:=Ord(Ch2) - Ord('0')
                         Else Z2:=Ord(Ch2) - Ord('A') + 10;
    Get16:=Z1*16 + Z2;
  End;
procedure Init;
  Var I:Integer;
  Begin
    Fillchar(Data,Sizeof(Data),0);
    St.Bi:=Get16;
    St.Sm:=Get16;
    Fi.Bi:=Get16;
    Fi.Sm:=Get16;
    For I:=0 To 65535 Do
      Data[I]:=Get16;
  End;
procedure CloseFiles;
  Begin
    Close(Input);
    Close(Output);
    Halt;
  End;
procedure OpenFiles;
  Begin
    Assign(Input,FileIn);
    Reset(Input);
    Assign(Output,FileOut);
    Rewrite(Output);
  End;
Procedure WriteAns;
  Var S1:Str;
      I:Integer;
  Begin
    Writeln(Tree[C[Fi.Bi*256 + Fi.Sm]].Len);
    S1:=S[Fi.Bi*256 + Fi.Sm];
    For I:=1 To Length(S1) - 1 Do
      Case S1[I] Of
        '0':Write('0F ');
        '1':Write('5C ');
        '2':Write('CC ');
      End;
    Case S1[Length(S1)] Of
      '0':Writeln('0F');
      '1':Writeln('5C');
      '2':Writeln('CC');
    End;
    CloseFiles;
  End;
Procedure RefreshUp(X:Integer);
  Var T:TList;
  Begin
    If X=1 Then Exit;
    If Tree[X].Len<Tree[X div 2].Len Then
      Begin
        T:=Tree[X]; Tree[X]:=Tree[X div 2]; Tree[X div 2]:=T;
        C[Tree[X].Key.Bi * 256 + Tree[X].Key.Sm]:=X;
        C[Tree[X div 2].Key.Bi * 256 + Tree[X div 2].Key.Sm]:=X div 2;
        RefreshUp(X Div 2);
      End;
  End;
Procedure RefreshDown(X:Integer);
  Var T:TList;
      Y:Integer;
  Begin
    If X>(MaxM + 1) div 2 Then Exit;
    If X=(MaxM + 1) div 2 Then
      Begin
        Y:=2*X;
        If Tree[X].Len>Tree[y].Len Then
          Begin
            T:=Tree[X]; Tree[X]:=Tree[Y]; Tree[Y]:=T;
            C[Tree[X].Key.Bi * 256 + Tree[X].Key.Sm ]:=X;
            C[Tree[Y].Key.Bi * 256 + Tree[Y].Key.Sm ]:=Y;
          End;
        Exit;
      End;
    If (Tree[X].Len>Tree[X * 2].Len)Or(Tree[X].Len>Tree[X * 2 + 1].Len) Then
      Begin
        Y:=2*X;
        If Tree[Y].Len>Tree[Y + 1].Len Then Inc(Y);
        T:=Tree[X]; Tree[X]:=Tree[Y]; Tree[Y]:=T;
        C[Tree[X].Key.Bi * 256 + Tree[X].Key.Sm]:=X;
        C[Tree[Y].Key.Bi * 256 + Tree[Y].Key.Sm]:=Y;
        RefreshDown(Y);
      End;
  End;
Procedure Solve;
  Var I:Integer;
      W,X:TList;
  Begin
    For I:=0 To MaxM Do
      Begin
        C[I]:=I + 1;
        Tree[C[I]].Key.Sm:=I Mod 256;
        Tree[C[I]].Key.Bi:=I Div 256;
        Tree[C[I]].Len:=Inf;
      End;
    Tree[C[St.Bi * 256 + St.Sm]].Len:=0;
    S[St.Bi * 256 + St.Sm]:='';
    RefreshUp(C[St.Bi * 256 + St.Sm]);
    While True Do
      Begin
        W:=Tree[1];
        If (W.Len=Inf)Or(W.Len=-1) Then
          Break;
        If (W.Key.Sm=Fi.Sm)And(W.Key.Bi=Fi.Bi) Then
          Begin
            WriteAns;
            Exit;
          End;
        {5C}
        X.Key.Sm:=Data[(W.Key.Bi * 256 + W.Key.Sm)Mod 65535];
        X.Key.Bi:=Data[(W.Key.Bi * 256 + W.Key.Sm + 1)Mod 65535];
        X.Len:=W.Len + 1;
        If Tree[C[X.Key.Bi * 256 + X.Key.Sm]].Len=X.Len Then
          If S[X.Key.Bi * 256 + X.Key.Sm]>(S[W.Key.Bi * 256 + W.Key.Sm] + '1') Then
            S[X.Key.Bi * 256 + X.Key.Sm]:=S[W.Key.Bi * 256 + W.Key.Sm] + '1';
        If Tree[C[X.Key.Bi * 256 + X.Key.Sm]].Len>X.Len Then
          Begin
            Tree[C[X.Key.Bi * 256 + X.Key.Sm]].Len:=X.Len;
            S[X.Key.Bi * 256 + X.Key.Sm]:=S[W.Key.Bi * 256 + W.Key.Sm] + '1';
            RefreshUp(C[X.Key.Bi * 256 + X.Key.Sm]);
          End;
        {0F CC}
        X.Key.Bi:=W.Key.Sm;
        X.Key.Sm:=W.Key.Bi;
        X.Len:=W.Len + 2;
        If Tree[C[X.Key.Bi * 256 + X.Key.Sm]].Len=X.Len Then
          If S[X.Key.Bi * 256 + X.Key.Sm]>(S[W.Key.Bi * 256 + W.Key.Sm] + '02') Then
            S[X.Key.Bi * 256 + X.Key.Sm]:=S[W.Key.Bi * 256 + W.Key.Sm] + '02';
        If Tree[C[X.Key.Bi * 256 + X.Key.Sm]].Len>X.Len Then
          Begin
            Tree[C[X.Key.Bi * 256 + X.Key.Sm]].Len:=X.Len;
            S[X.Key.Bi * 256 + X.Key.Sm]:=S[W.Key.Bi * 256 + W.Key.Sm] + '02';
            RefreshUp(C[X.Key.Bi * 256 + X.Key.Sm]);
          End;
        Tree[C[W.Key.Bi * 256 + W.Key.Sm]].Len:=Inf + 1;
        RefreshDown(C[W.Key.Bi * 256 + W.Key.Sm]);
        Tree[C[W.Key.Bi * 256 + W.Key.Sm]].Len:=-1;
      End;
    Writeln('IMPOSSIBLE');
  End;
begin
  OpenFiles;
  Init;
  Solve;
  CloseFiles
end.
