program prB;

uses
  SysUtils;
{$D-,R-,I-,L-,Q-,S-}
Const FileIn='rle.in';
      FileOut='rle.out';
      MaxK=60000;
Type Integer=LongInt;
     PList=^TList;
     TList=Record
       Next:PList;
       Key:Integer;
     End;
     TBlack=Record
       A,B:Integer;
       Lo,Hi:Integer;
     End;
Var A:Array[1..MaxK] Of PList;
    B:Array[1..MaxK] Of TBlack;
    Used:Array[1..MaxK] Of Boolean;
    N,M:Integer;
    Kol:Integer;
procedure Init;
  Var I,K:Integer;
      P:TBlack;
      Len:Integer;
      Color:Integer;
  Begin
    For I:=1 To MaxK Do
      A[i]:=Nil;
    Fillchar(Used,Sizeof(Used),False);
    Read(N,M);
    Read(Color,K);
    P.A:=0; P.Lo:=1;
    Kol:=0;
    For I:=1 To K Do
      Begin
        Read(Len);
        Color:=1 - Color;
        If Color=1 Then
          Begin
            P.A:=P.A + Len;
            P.Lo:=P.Lo + P.A div M;
            P.A:=P.A Mod M;
            Continue;
          End;
        Inc(Kol);
        B[Kol].Lo:=P.Lo;
        B[Kol].A:=P.A;
        P.A:=P.A + Len - 1;
        B[Kol].Hi:=P.Lo + P.A Div M;
        If (B[Kol].Lo + 1)=B[Kol].Hi  Then
          Begin
            B[Kol].Hi:=B[Kol].Lo;
            B[Kol].B:=M - 1;
            If B[kol].A<>0 Then Dec(B[kol].A);
            If B[Kol].B<>M Then Inc(B[kol].B);
            Inc(Kol);
            B[Kol].Lo:=B[Kol - 1].Lo + 1;
            B[Kol].A:=0;
            B[Kol].B:=P.A Mod M;
            If B[kol].A<>0 Then Dec(B[kol].A);
            If B[Kol].B<>M Then Inc(B[kol].B);
            P.A:=P.A + 1;
            P.Lo:=P.Lo + P.A div M;
            P.A:=P.A Mod M;
            Continue;
          End;
        P.Lo:=P.Lo + P.A div M;
        P.A:=P.A mod M;
        B[Kol].B:=P.A;
        If B[kol].A<>0 Then Dec(B[kol].A);
        If B[Kol].B<>M Then Inc(B[kol].B);
        P.A:=P.A + 1;
        P.Lo:=P.Lo + P.A div M;
        P.A:=P.A Mod M;
      End;
  End;
procedure CloseFiles;
  Begin
    Close(Input);
    Close(Output);
  End;
procedure OpenFiles;
  Begin
    Assign(Input,FileIn);
    Reset(Input);
    Assign(Output,FileOut);
    Rewrite(Output);
  End;
Procedure Add(X,Y:Integer);
  Var P:PList;
  Begin
    New(P);
    P^.Key:=Y;
    P^.Next:=A[X];
    A[X]:=P;
    New(P);
    P^.Key:=X;
    P^.Next:=A[Y];
    A[Y]:=P;
  End;
Procedure Dfs(X:Integer);
  Var P:PList;
  Begin
    If Used[X] Then Exit;
    Used[X]:=True;
    P:=A[X];
    While P<>Nil Do
      Begin
        Dfs(P^.Key);
        P:=P^.Next;
      End;
  End;
Procedure Solve;
  Var i,j:Integer;
      Ans:Integer;
  Begin
    For I:=1 To Kol Do
      Begin
        J:=I;
        While True Do
          Begin
            Inc(J);
            If J>Kol Then Break;
            If (B[I].Hi + 1)<B[J].Lo Then Break;
            If B[I].Hi=B[J].Lo Then
              Begin
                If (B[i].Hi>(B[i].Lo + 1))Or((B[j].Hi<>B[j].Lo)And(B[i].Hi<>B[i].Lo)) Then
                  Begin
                    Add(I,J);
                    Continue;
                  End;
                If B[i].Lo=B[i].Hi Then
                  Begin
                    If (((B[j].Lo + 1 ) = B[j].Hi)And(B[J].B>=B[i].A)) Or ((B[j].Lo + 1)>B[j].Hi) Then
                      Add(I,J);
                    Continue;
                  End;
                If (B[j].Lo=B[j].Hi) Then
                  Begin
                    If (B[i].A<=B[j].B)Or(B[i].B>=B[j].A) Then
                      Add(I,J);
                    Continue;
                  End;
                Add(I,J);
              End
              Else
              Begin
                If (B[i].Hi>=(B[i].Lo + 1))And(B[i].B>=B[j].A) Then
                  Begin
                    Add(I,J);
                    Continue;
                  End;
                If B[j].Lo=B[j].Hi Then
                  Begin
                    If ((B[i].A<=B[j].A)And(B[i].B>=B[j].A))Or
                       ((B[i].A<=B[j].B)And(B[i].B>=B[j].B)) Then
                       Add(I,J);
                    Continue;
                  End;
                If (B[i].B>=B[j].A) Then
                  Add(I,J);
              End;
          End;
      End;
    Ans:=0;
    For I:=1 To Kol Do
      If Not Used[I] Then
        Begin
          Inc(Ans);
          Dfs(I);
        End;
    Write(Ans);
  End;
begin
  OpenFiles;
  Init;
  Solve;
  CloseFiles
end.
