program temp;

{$D-,R-,I-,L-,S-,Q-}
uses
  SysUtils;

Const FileIn='chrom.in';
      FileOut='chrom.out';
      MaxN=12;
Type Integer=LongInt;
Var N:Integer;
    A:Array[1..MaxN,1..MaxN] Of Boolean;
    B:Array[1..MaxN] Of Integer;
    F:Array[1..MaxN] Of Integer;
    Koef:Array[1..MaxN,0..MaxN] Of Int64;
    Used:Array[1..MaxN] Of Boolean;
procedure Init;
  Var X,Y:Integer;
      I,M:Integer;
  Begin
    Fillchar(A,Sizeof(A),False);
    Read(N,M);
    For I:=1 To M Do
      Begin
        Read(X,Y);
        A[X,Y]:=True;
        A[Y,X]:=True;
      End;
  End;
procedure CloseFiles;
  Begin
    Close(Input);
    Close(Output);
  End;
procedure OpenFiles;
  Begin
    Assign(Input,FileIn);
    Reset(Input);
    Assign(Output,FileOut);
    Rewrite(Output);
  End;
Function Dfs(X,Y:Integer):Int64;
  Var J:Integer;
      Color:Integer;
      F:Boolean;
      Z,W:Int64;
  Begin
    Dfs:=1;
    Used[X]:=True;
    If B[X]<>0 Then Exit;
    Z:=0;
    For Color:=1 To Y Do
      Begin
        F:=True;
        For J:=1 To N Do
          If (Color=B[J])And(A[X,J]) Then
            Begin
              F:=False;
              Break;
            End;
        If F Then
          Begin
            B[X]:=Color;
            W:=1;
            For J:=1 To N Do
              If A[X,J] Then
                Begin
                  W:=W * Dfs(J,Y);
                  If W=0 Then Break;
                End;
            Z:=Z + W;
            B[X]:=0;
          End;
      End;
    Dfs:=Z;
  End;
Procedure Gaus;
  Var I,J,K:Integer;
      W: Int64;
  Begin
    For I:=1 To N Do
      Begin
        For J:=I + 1 To N Do
          If Koef[J,I] Mod Koef[I,I] <> 0 Then
            For K:=0 To N Do
              Koef[J,K]:=Koef[J,K] * Koef[I,I];
        For J:=I + 1 To N Do
          Begin
            W:=Koef[J,I] div Koef[I,I];
            For K:=0 To N Do
              Koef[J,K]:=Koef[J,K] - Koef[I,K] * W;
          End;
      End;
  End;
Function Step(A,X:Integer):Int64;
  Var I:Integer;
      Z:Int64;
  Begin
    Z:=1;
    For I:=1 To X Do
      Z:=Z * A;
    Step:=Z;
  End;
Procedure Solve;
  Var I,J,K:Integer;
      X:Int64;
  Begin
    For I:=1 To N Do
      If A[I,I] Then
        Begin
          Write('0 0');
          Exit;
        End;
    For I:=1 To N Do
      Begin
        Fillchar(B,Sizeof(B),0);
        Fillchar(Used,Sizeof(Used),False);
        X:=1;
        For J:=1 To N Do
          If Not Used[J] Then
            X:=X * Dfs(J,I);
        F[I]:=X;
      End;
    For I:=1 To N Do
      For J:=1 To N Do
        Koef[I,J]:=Step(I,J);
    For I:=1 To N  Do
      Koef[I,0]:=F[I];
    Gaus;
    For I:=N Downto 1 Do
      For J:=1 To I - 1 Do
        Begin
          For K:=0 To N Do
            Koef[J,K]:=Koef[J,K] * Koef[I,I];
          Koef[J,0]:=Koef[J,0] - Koef[I,0] * Koef[J,I] div Koef[I,I];
          Koef[J,I]:=0;
        End;
    Write(N,' 0 ');
    For I:=1 To N Do
      Write(Koef[I,0] div Koef[I,I],' ');
  End;
begin
  OpenFiles;
  Init;
  Solve;
  CloseFiles
end.
