{$I-,Q-,R-,S-}
const probname = 'polygon';
      maxn = 300;
      eps = 1e-6;

type TPoint = record x, y: double; end;

var n, i: longint;
    v: array [1..maxn] of TPoint;
    c, t: array [1..maxn] of longint;
    ang: array [1..maxn] of double;
    ans, nm: longint;
    min: double;

function vect (const x1, y1, x2, y2: double): double;
begin
  vect := x1 * y2 - x2 * y1;
end;

function scalar (const x1, y1, x2, y2: double): double;
begin
  scalar := x1 * x2 + y1 * y2;
end;

function svect (const x1, y1, x2, y2: double): longint;
var d: double;
begin
  d := x1 * y2 - x2 * y1;
  svect := 0;
  if d > eps then svect := 1;
  if d < -eps then svect := -1;
end;

procedure dfs (const w, cc: longint);
var i: longint;
    vct, scl, a: double;
    q: longint;
begin
  c [w] := cc;
  t [cc] := w;
  for i := 1 to n do
  begin
    if c [i] <> 0 then
    begin
      if (cc > 1) and (svect (v [i].x - v [w].x, v [i].y - v [w].y, v [w].x - v [t [cc-1]].x, v [w].y - v [t [cc-1]].y) = 1)
      and (ans < c [w] - c [i] + 1) then
      begin
        vct := vect (v [i].x - v [w].x, v [i].y - v [w].y, v [w].x - v [t [cc-1]].x, v [w].y - v [t [cc-1]].y);
        scl := scalar (v [i].x - v [w].x, v [i].y - v [w].y, v [w].x - v [t [cc-1]].x, v [w].y - v [t [cc-1]].y);
        if abs (scl) > eps then a := arctan (vct / scl) else a := pi/2;
        if a < 0 then a := a + pi;
        if (ang [w] + a - ang [i] - 2*pi < eps) then ans := c [w] - c [i] + 1;
      end;
      continue;
    end;
    if cc = 1 then dfs (i, cc+1) else
      if svect (v [i].x - v [w].x, v [i].y - v [w].y, v [w].x - v [t [cc-1]].x, v [w].y - v [t [cc-1]].y) = 1 then
      begin
        vct := vect (v [i].x - v [w].x, v [i].y - v [w].y, v [w].x - v [t [cc-1]].x, v [w].y - v [t [cc-1]].y);
        scl := scalar (v [i].x - v [w].x, v [i].y - v [w].y, v [w].x - v [t [cc-1]].x, v [w].y - v [t [cc-1]].y);
        if abs (scl) > eps then a := arctan (vct / scl) else a := pi/2;
        if a < 0 then a := a + pi;
        ang [i] := ang [w] + a;
        dfs (i, cc+1);
      end;
    ang [i] := 0;
  end;
  c [w] := 0;
  t [cc] := 0;
end;

begin
  assign (input, probname+'.in');
  reset (input);
  assign (output, probname+'.out');
  rewrite (output);
  read (n);
  min := 2000;
  for i := 1 to n do
  begin
    read (v [i].x, v [i].y);
    if v [i].x - min < -eps then
    begin
      min := v [i].x;
      nm := i;
    end;
  end;
  ans := 0;
  dfs (nm, 1);
  write (ans);
  close (input);
  close (output);
end.
