{$Q-,R-,S-,I-,L-}
{$LONGSTRINGS ON}
const probname = 'lcm';
      maxn = 2000;
type TLong = ansistring;
     int = integer;
     integer = int64;
var n, i: longint;
    v: array [1..maxn] of TLong;
    nok: TLong;

function strtoint (const s: TLong): longint;
var err: int;
    q, i: longint;
begin
  q := 0;
  for i := 1 to length (s) do
    q := q * 10 + ord (s [i]) - 48;
  strtoint := q;
end;

function mult (const a, b: TLong): TLong;
var i, j, u: longint;
    s: TLong;
begin
  s := '';
  for i := 1 to length (a) + length (b) do
    s := s + '0';
  for i := length (a) downto 1 do
    for j := length (b) downto 1 do
    begin
      u := (ord (a [i]) - 48) * (ord (b [j]) - 48);
      inc (s [i+j], u);
      inc (s [i+j-1], (ord (s [i+j]) - 48) div 10);
      s [i+j] := chr ((ord (s [i+j]) - 48) mod 10 + 48);
    end;
  if s [1] = '0' then delete (s, 1, 1);
  mult := s;
end;

function short_nod (a, b: longint): longint;
var r: longint;
begin
  if b = 0 then begin short_nod := a; exit; end;
  r := a mod b;
  while r > 0 do
  begin
    a := b;
    b := r;
    r := a mod b;
  end;
  short_nod := b;
end;

function long_nod (const a: TLong; b: longint): longint;
var i: longint;
    r: integer;
begin
  r := 0;
  for i := 1 to length (a) do
    r := (r * 10 + ord (a [i]) - 48) mod b;
  i := r;
  long_nod := short_nod (b, i);
end;

function divide (const a: TLong;const b: longint): TLong;
var i, k, j: longint;
    d, q: TLong;
    w, e: integer;
begin
  d := '';
  w := 0;
  i := 0;
  j := 0;
  while i < length (a) do
  begin
    while (w < b) and (i < length (a)) do
    begin
      inc (i);
      w := w * 10 + ord (a [i]) - 48;
      if (w < b) and (length (d) <> 0) then d := d + '0';
    end;
    if w >= b then
    begin
      e := w mod b;
      w := w div b;
      if i <= length (a) then
        d := d + chr (w + 48);
      w := e;
    end;
  end;
  divide := d;
end;

begin
  assign (input, probname+'.in');
  reset (input);
  assign (output, probname+'.out');
  rewrite (output);
  readln (n);
  for i := 1 to n do
    readln (v [i]);
  nok := v [1];
  for i := 2 to n do
    nok := divide (mult (nok, v [i]), long_nod (nok, strtoint (v [i])));
  writeln (nok);
  close (input);
  close (output);
end.