{$I-,Q-,R-,S-}

const
  MAXN = 650;
  MAXL = 650;

  osn = 1000000000;

  MAX_LONG = 200;

type
  Integer = Longint;

  TLong = array[0..MAX_LONG] of Integer;
  TString = String[255];

var
  n, h: Integer;
  l: array[1..MAXN] of Integer;
  d: array[0..MAXL] of TLong;

function SmartLength(const Str: TString): Integer;
var
  Count: Integer;
  i: Integer;
begin
  Count := 0;
  for i := 1 to Length(Str) do
    if (Str[i] <> ' ') then Inc(Count);

  SmartLength := Count;
end;

procedure Init();
var
  Str: TString;
  i: Integer;
begin
  Assign(Input, 'programs.in');
  Reset(Input);
  Assign(Output, 'programs.out');
  Rewrite(Output);

  Readln(n);
  for i := 1 to n do
  begin
    Readln(Str);
    l[i] := SmartLength(Str);
  end;
  Read(h);
end;

function Max(const a, b: Integer): Integer;
begin
  if (a > b) then Max := a else Max := b;
end;

procedure IncLong(var a: TLong; const b: TLong);
var
  i, pv: Integer;
begin
  if b[0] > a[0] then a[0] := b[0];

  pv := 0;
  for i := 1 to a[0] do
  begin
    pv := pv + a[i] + b[i];
    a[i] := pv mod Osn;
    pv := pv div Osn;
  end;

  if (pv > 0) then
  begin
    Inc(a[0]);
    a[a[0]] := pv;
  end;
end;

procedure Solve();
var
  i, j: Integer;
begin
  d[0][0] := 1;
  d[0][1] := 1;
  for i := 1 to h do
    for j := 1 to n do
      if (i - l[j] >= 0)  then
      begin
        IncLong(d[i], d[i - l[j]]);
      end;
end;

procedure Done();
var
  i: Integer;
begin
  if (d[h][0] = 0) then Writeln(0) else
    for i := d[h][0] downto 1 do
    begin
      Write(d[h][i]);
    end;

  Close(Input);
  Close(Output);
end;

begin
  Init();
  Solve();
  Done();
end.

