{$I-,Q-,R-,S-}
{$D-}

const
  MAXN = 105;
  LEN = 100;
  INFINITE = 100000000;

type
  Integer = Longint;

  TPoint = record
    x, y: Integer;
  end;

var
  n, s, a: Integer;
  Towns: array[1..MAXN * MAXN] of TPoint;
  v, p: array[1..MAXN] of Integer;
  m: array[1..MAXN, 1..MAXN] of Integer;
  NNew: array[1..MAXN] of Boolean;
  d, r: array[1..MAXN, 1..MAXN] of Integer;

procedure Init();
var
  i: Integer;
begin
  Assign(Input, 'small.in');
  Reset(Input);
  Assign(Output, 'small.out');
  Rewrite(Output);

  Read(n);
  for i := 1 to n do
    Read(Towns[i].x, Towns[i].y);

  Read(s);
  for i := 1 to s do
    Read(v[i]);

  Read(a);
  Dec(a, 2);
end;

procedure Solve();
var
  i, j, t, Max, h: Integer;
begin
  for i := 1 to n do
    for j := 1 to S - 1 do
      if (Towns[i].x >= v[j]) and (Towns[i].x < v[j + 1]) then
      begin
        p[i] := j;
        Break;
      end;

  for i := 1 to LEN do
    for j := i + 1 to LEN do
    begin
      m[i, j] := 0;
      Fillchar(NNew, Sizeof(NNew), False);

      for t := 1 to n do
        if (Towns[t].y >= i) and (Towns[t].y < j) then NNew[p[t]] := True;

      for t := 1 to n do
        if NNew[t] then Inc(m[i, j]);
    end;

  for i := 2 to LEN - 1 do
    d[1, i] := m[1, i];

  for t := 2 to a do
    for i := t + 1 to LEN - 1 do
    begin
      Max := -INFINITE;
      h := 0;
      for j := i - 1 downto t do
        if d[t - 1, j] + m[j, i] > Max then
        begin
          Max := d[t - 1, j] + m[j, i];
          h := j;
        end;
      d[t, i] := Max;
      r[t, i] := h;
    end;

  for i := a + 1 to LEN - 1 do
    Inc(d[a][i], m[i, LEN]);
end;

procedure Rec(const t, i: Integer);
begin
  if t = 0 then Exit;
  Rec(t - 1, r[t, i]);

  Write(i, ' ');
end;

procedure Done();
var
  Max, k, i: Integer;
begin
  Max := -INFINITE;
  k := 0;
  for i := a + 1 to LEN - 1 do
    if d[a][i] > Max then
    begin
      Max := d[a][i];
      k := i;
    end;

  Write(a + 2, ' ', 1, ' ');
  Rec(a, k);
  Writeln(LEN);

  Close(Input);
  Close(Output);
end;

begin
  Init();
  Solve();
  Done();
end.
