{$I-,Q-,R-,S-}
{$D-}

uses
  Windows;

const
  MAXN = 300;

type
  Integer = Longint;
  TPoint = record
    x, y: Extended;
  end;

  TArray = array[1..MAXN] of Boolean;

var
  n: Integer;
  Time: Integer;
  a: TArray;
  Points: array[1..MAXN] of TPoint;
  MPoints: array[1..MAXN] of TPoint;
  Used: array[1..MAXN] of Boolean;
  MaxAns: Integer;
  MegaAns: TArray;

function GetTickCount(): Longint; external 'kernel32.dll';

procedure Init();
var
  i: Integer;
begin
  Time := GetTickCount();
  Assign(Input, 'polygon.in');
  Reset(Input);
  Assign(Output, 'polygon.out');
  Rewrite(Output);

  Read(n);
  for i := 1 to n do
    Read(Points[i].x, Points[i].y);
end;

function Vp(const x1, y1, x2, y2: Extended): Extended;
begin
  Vp := x1*y2 - x2*y1;
end;

procedure Check();
var
  i, k, t, Ans: Integer;
  Count, Start: Integer;
begin
  Count := 0;
  for i := 1 to n do
    if not a[i] then
    begin
      Inc(Count);
      MPoints[Count] := Points[i];
    end;

  if Count < 3 then Exit;

  Fillchar(Used, Sizeof(Used), 0);

  k := 1;
  for i := 2 to Count do
    if MPoints[i].y < MPoints[k].y then
      k := i
    else
      if (MPoints[i].y = MPoints[k].y) and (MPoints[i].x < MPoints[k].x) then
        k := i;

  Start := k;
  Ans := 1;

  while True do
  begin
    for i := 1 to Count do
      if not Used[i] and (i <> k) then
      begin
        t := i;
        Break;
      end;

    for i := 1 to Count do
      if not Used[i] and (i <> k) and (Vp(MPoints[t].x - MPoints[k].x, MPoints[t].y - MPoints[k].y,
        MPoints[i].x - MPoints[k].x, MPoints[i].y - MPoints[k].y) < 0) then
          t := i;

    if t = Start then Break;

    k := t;
    Used[k] := True;
    Inc(Ans);
  end;

  if Ans > MaxAns then
  begin
    MaxAns := Ans;
{$IFDEF MEGA}
    MegaAns := a;
{$ENDIF}
  end;
end;

procedure Done();
var
  i: Integer;
begin
  Writeln(MaxAns);

{$IFDEF MEGA}
  for i := 1 to n do
    if MegaAns[i] then
      Writeln(Points[i].x:0:3, ' ', Points[i].y:0:3);
{$ENDIF}

  Close(Input);
  Close(Output);
  Halt;
end;


procedure Solve();
var
  i, j, s: Integer;
begin
  s := 1;
  while True do
  begin
    Check();
    i := n;
    while a[i] and (i > 0) do Dec(i);
    if (i <= 0) then
    while True do
    begin
      if GetTickCount() - Time > 3500 then Done();
    end;

    a[i] := True;
    for j := i + 1 to n do a[j] := False;
{$IFDEF MEGA}
    Write('Step: ', s:5, ' | ');
    for j := 1 to n do if a[j] then Write('1 ') else Write('0 ');
    Writeln;
{$ENDIF}
    Inc(s);
    if GetTickCount() - Time > 3500 then Done();
  end;
end;

begin
  Init();
  Solve();
  Done()
end.
