{$R-,Q-,S-,N+,E-}
Program programs;
type real=extended;
const eps:real=1e-10;

function DivE(a,b:real):real;
begin
  DivE:=int(a/b+eps);
end;

function ModE(a,b:real):real;
begin
  ModE:=a-DivE(a,b)*b;
end;

procedure Divide(a,b:real;var cc,dd:real);
var c,d:real;
begin
  c:=int(a/b+eps);
  d:=a-b*c;
  cc:=c;
  dd:=d;
end;
var
  ln:array[1..255]of longint;
  l:integer;

procedure Load;
var
  ch:char;
  i,k,n:integer;
begin
  assign(input,'programs.in');
  reset(input);
  readln(n);
  for i:=1 to 255 do ln[i]:=0;
  for i:=1 to n do begin
    k:=0;
    while true do begin
      read(ch);
      if (ch<#32) and (k>0) then break;
      if ch>#32 then inc(k);
    end;
    inc(ln[k]);
  end;
  readln(l);
  close(input);
end;
const
  Base:real=1e19;
  BN=19;
var
  k:array[0..600]of
      record
        n:integer;
        a:array[1..4000]of real;
      end;

procedure GoOn;
var
  i,ll,j,ii,jj:integer;
  r:real;
begin
  k[0].n:=1;
  k[0].a[1]:=1;
  for i:=1 to l do
    k[i].n:=0;
  for i:=0 to l-1 do
    begin
      ll:=l-i;
      if ll>255 then ll:=255;
//      writeln('I=',i);
      for j:=1 to ll do
        if j+i<=l then
          begin
            {Add k[i]*ln[j] to k[i+j]}
            jj:=i+j;
            r:=0;
            for ii:=1 to k[i].n do begin
              r:=r+k[i].a[ii]*ln[j];
              if k[jj].n<ii then
                k[jj].n:=ii
              else
                r:=r+k[jj].a[ii];
              Divide(r,Base,r,k[jj].a[ii]);
{              k[jj].a[ii]:=ModE(r,Base);
              r:=DivE(r,Base);}
            end;
            ii:=k[i].n;
            while r>0 do begin
              inc(ii);
              if k[jj].n<ii then
                k[jj].n:=ii
              else
                r:=r+k[jj].a[ii];
              Divide(r,Base,r,k[jj].a[ii]);
{              k[jj].a[ii]:=ModE(r,Base);
              r:=DivE(r,Base);}
            end;
          end;
    end;
end;

procedure Print;
var
  n,i,ii:integer;
  s,d:extended;
begin
  n:=k[l].n;
  write(k[l].a[n]:0:0);
  for ii:=n-1 downto 1 do begin
    s:=k[l].a[ii];
    d:=0;
    for i:=1 to BN do begin
      d:=d*10+ModE(s,10);
      s:=DivE(s,10);
    end;
    for i:=1 to BN do begin
      write(ModE(d,10):0:0);
      d:=DivE(d,10);
    end;
  end;
  close(output);
end;

begin
  Load;
  assign(output,'programs.out');
  rewrite(output);
  GoOn;
  Print;
end.
