Program indirect;
{$R+,Q+}
type smallint=-32768..32767;
integer=longint;
var
  i:longint;
  a:smallint;

  last:array[0..40000]of integer;
  mem:array[0..40000]of smallint;
  cm,tp:char;
  op:longint;

procedure Dump;

begin
  writeln(a);
  for i:=1 to 32768 do
    writeln(mem[i]);
  close(output);
  close(input);
  halt;
end;

procedure GoOn;
var i:longint;
begin
  for i:=1 to 32768 do begin
    mem[i]:=0;
    last[i]:=0;
  end;
  a:=0;
  i:=0;
  while not eof do begin
    inc(i);
    read(cm);
    read(tp);
    readln(op);
    if tp='*' then begin
      while mem[op]<0 do begin
        if last[op]=i then begin
          writeln('RUN-TIME ERROR');
          Dump;
        end;
        last[op]:=i;
        op:=-mem[op];
      end;
      case cm of
        'A':a:=(a+mem[op]);
        'S':a:=(a-mem[op]);
        'M':a:=smallint((a*mem[op]));
        'D':begin
          if mem[op]=0 then begin
            writeln('DIVISION BY ZERO');
            Dump;
          end;
          a:=(a div mem[op]);
        end;
        'O':begin
          if mem[op]=0 then begin
            writeln('DIVISION BY ZERO');
            Dump;
          end;
          a:=(a mod mem[op]);
        end;
        'R':a:=mem[op];
        'W':mem[op]:=a;
      end;

    end else
      case cm of
        'A':a:=(a+op);
        'S':a:=(a-op);
        'M':a:=(a*op);
        'D':begin
          if op=0 then begin
            writeln('DIVISION BY ZERO');
            Dump;
          end;
          a:=(a div op);
        end;
        'O':begin
          if op=0 then begin
            writeln('DIVISION BY ZERO');
            Dump;
          end;
          a:=(a mod op);
        end;
        'R':a:=op;
      end;
  end;
  writeln('SUCCESSFUL TERMINATION');
  Dump;
end;

begin
  assign(input,'indirect.in');
  reset(input);
  assign(output,'indirect.out');
  rewrite(output);
  GoOn;
  close(input);
  close(output);
end.
