{$A+,B-,D-,E-,F-,G+,I-,L-,N-,O+,P-,Q-,R-,S-,T-,V+,X+,Y+}
   Const File_In='kitten.in';
         File_Out='kitten.out';
         MaxLen=2000001;
   Type Int=LongInt;
        Trie=Array [0..MaxLen] Of Int;
   Var Ans : Trie;
       What : Array [0..MaxLen] Of Boolean;

Procedure OpenFiles;
Begin
  Assign(Input,File_In);
  ReSet(Input);
  Assign(Output,File_Out);
  ReWrite(Output);
End;

Function GetX(Const X : Int) : Int;
  Var XHelp,Two : Int;
Begin
  XHelp :=X;
  Two :=1;
  While XHelp And Two<>0 Do
    Begin
      XHelp :=XHelp Xor Two;
      Two :=Two*2;
    End;
  GetX :=XHelp;
End;

Procedure Add(Const A : Int);
  Var AHelp,ALast,Two : Int;
Begin
  Two :=1;
  AHelp :=A;
  ALast :=0;
  While AHelp<=MaxLen Do
    Begin
      If AHelp<>ALast Then
        Inc(Ans[AHelp]);
      ALast :=AHelp;
      AHelp :=ALast Or Two;
      Two :=Two*2;
    End;
End;

Function GetSum(Const  X : Int) : Int;
  Var Sum,XHelp : Int;
Begin
  Sum :=0;
  XHelp :=X;
  While XHelp>=0 Do
    Begin
      Inc(Sum,Ans[XHelp]);
      XHelp :=GetX(XHelp)-1;
    End;
  GetSum :=Sum;
End;

Function Sum(Const A,B : Int): Int;
Begin
  If A>B Then
    Sum :=GetSum(A)-GetSum(B-1)
  Else Sum :=GetSum(B)-GetSum(A-1)
End;

Procedure InitSolve;
  var A,B : Int;
Begin
  FillChar(Ans,SizeOf(Ans),0);
  FillChar(What,SizeOf(What),False);
  While Not EoF Do
    Begin
      Read(A);
      If Not EoLn Then
        Begin
          Read(B);
          WriteLn(Sum(A+MaxLen Div 2,B+MaxLen Div 2));
        End
      Else
        If Not What[A+MaxLen Div 2] Then
          Begin
            Add(A+MaxLen Div 2);
            What[A+MaxLen Div 2] :=True;
          End;
      ReadLn;
    End;
End;

Procedure CloseFiles;
Begin
  Close(Input);
  Close(Output);
End;

Begin
  OpenFiles;
  InitSolve;
  CloseFiles;
End.
