{$A+,B-,D-,E-,F-,G+,I-,L-,N+,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}
   Const File_In='quirks.in';
         File_Out='quirks.out';
         MaxN=50000;
         MaxM=50000;
   Type Int=LongInt;
   Var T,N,M : Int;
       R,R2 : Array [1..MaxM] Of Record
                                   A,B : Int;
                                 End;
       Count : Array [1..MaxN+1] Of Int;
       Answer : Boolean;
       Time,TimeV : Array [0..MaxN] Of Int;
       Use : Array [1..MaxN] Of Boolean;

Procedure OpenFiles;
Begin
  Assign(Input,File_In);
  ReSet(Input);
  Assign(Output,File_Out);
  ReWrite(Output);
End;

Procedure TopSort(I : Int);
  Var J : Int;
Begin
  Use[I] :=True;
  For J :=Count[I] To Count[I+1]-1 Do
    If Not Use[R[J].B] Then
      TopSort(R[J].B);
  Inc(Time[0]);
  Time[Time[0]] :=I;
End;

Procedure Check(I : Int);
  Var J : Int;
Begin
  Use[I] :=True;
  For J :=Count[I] To Count[I+1]-1 Do
    If Not Use[R[J].B] Then
      Check(R[J].B)
    Else If TimeV[R[J].B]<>0 Then Answer :=False;
  Inc(TimeV[0]);
  TimeV[I] :=TimeV[0];
End;

Procedure Solve;
  Var I : Int;
Begin
  Answer :=True;
  FillChar(Time,SizeOf(Time),0);
  FillChar(TimeV,SizeOf(TimeV),0);
  FillChar(Use,SizeOf(Use),0);
  For I :=1 to N Do
    If Not Use[I] Then
      TopSort(I);
  FillChar(Use,SizeOf(Use),0);
  Check(Time[Time[0]]);
  For I :=1 To N Do
    If Not Use[I] Then Answer :=False;
  If Answer Then WriteLn('YES')
  Else WriteLn('NO');
End;

Procedure Init;
  Var CountTests,I : Int;
Begin
  Read(T);
  For CountTests :=1 To T Do
    Begin
      Read(N,M);
      FillChar(Count,SizeOf(Count),0);
      For I :=1 To M Do
        Begin
          Read(R[I].A,R[I].B);
          Inc(Count[R[I].A]);
        End;
      Inc(Count[1]);
      For I :=2 To N+1 Do
        Inc(Count[I],Count[I-1]);
      R2 :=R;
      For I :=1 To M Do
        Begin
          Dec(Count[R2[I].A]);
          R[Count[R2[I].A]] :=R2[I];
        End;
      Solve;
    End;
End;

Procedure CloseFiles;
Begin
  Close(Input);
  Close(Output);
End;

Begin
  OpenFiles;
  Init;
  CloseFiles;
End.
