{$A+,B-,D-,E-,F-,G+,I-,L-,N-,O+,P-,Q-,R-,S-,T-,V+,X+,Y+}
{$H+}
   Const File_In='programs.in';
         File_Out='programs.out';
         MaxN=600;
         MaxL=600;
         MaxLen=279;
         Osn=1000000;
   Type Int=LongInt;
        TLong=Array [0..MaxLen] Of Int;
   Var L,LenW,N : Int;
       Lens,CountLen,Len : Array [0..MaxN] Of Int;
       Answer : Array [-MaxL..MaxL] Of TLong;

Procedure OpenFiles;
Begin
  Assign(Input,File_In);
  ReSet(Input);
  Assign(Output,File_Out);
  ReWrite(Output);
End;

Function GetLen(Const S : String) : Int;
  Var I,HelpLen : Int;
Begin
  HelpLen :=0;
  For I :=1 To Length(S) Do
    If (S[I] In [#32..#126]) And (S[I]<>' ') Then
      Inc(HelpLen);
  GetLen :=HelpLen;
End;

Procedure Init;
  Var I : Int;
      S : String;
Begin
  LenW :=Round(Ln(Osn)/Ln(10));
  FillChar(CountLen,SizeOf(CountLen),0);
  FillChar(Len,SizeOf(Len),0);
  ReadLn(N);
  For I :=1 To N Do
    Begin
      ReadLn(S);
      Lens[I] :=GetLen(S);
      If CountLen[Lens[I]]=0 Then
        Begin
          Inc(Len[0]);
          Len[Len[0]] :=Lens[I];
        End;
      Inc(CountLen[Lens[I]]);
    End;
  Read(L);
End;

Procedure WriteLong(Const A : TLong);
  Var I : Int;
      S : String;
Begin
  Write(A[A[0]]);
  For I :=A[0]-1 DownTo 1 Do
    Begin
      Str(A[I],S);
      While Length(S)<LenW Do
        S :='0'+S;
      Write(S);
    End;
End;

Function Max(Const A,B : Int) : Int;
Begin
  If A>B Then Max :=A
  Else Max :=B;
End;

Procedure Sum(Var A : TLong; Const B : TLong);
  var Len,I : Int;
      C : Tlong;
Begin
  FillChar(C,SizeOf(C),0);
  Len :=Max(A[0],B[0]);
  For I :=1 To Len Do
    Begin
      C[I] :=C[I]+A[I]+B[I];
      C[I+1] :=C[I] Div Osn;
      C[I] :=C[I] Mod Osn;
    End;
  C[0] :=Len;
  If C[C[0]+1]>0 Then Inc(C[0]);
  A :=C;
End;

Procedure Mul(Var A : TLong; Const B : Int);
  Var I : Int;
      C : Tlong;
Begin
  FillChar(C,SizeOf(C),0);
  For I :=1 To A[0] Do
    Begin
      C[I] :=C[I]+A[I]*B;
      C[I+1] :=C[I] Div Osn;
      C[I] :=C[I] Mod Osn;
    End;
  C[0] :=A[0];
  If C[C[0]+1]>0 Then Inc(C[0]);
  A :=C;
End;

Procedure Solve;
  Var I,J : Int;
      Help : TLong;
Begin
  FillChar(Answer,SizeOf(Answer),0);
  Answer[0][0] :=1;
  Answer[0][1] :=1;
  For J :=1 To L Do
    For I :=1 To Len[0] Do
      If (Len[I]<>0) And (J-Len[I]>=0) Then
        Begin
          Help :=Answer[J-Len[I]];
          If CountLen[Len[I]]<>1 Then
            Mul(Help,CountLen[Len[I]]);
          Sum(Answer[J],Help);
        End;
  WriteLong(Answer[L]);
End;

Procedure CloseFiles;
Begin
  Close(Input);
  Close(Output);
End;

Begin
  OpenFiles;
  Init;
  Solve;
  CloseFiles;
End.
