{$A+,B-,D-,E-,F-,G+,I-,L-,N+,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}
   Const File_In='small.in';
         File_Out='small.out';
         MaxN=100;
   Type Int=LongInt;
   Var N,S,A : Int;
       My : Array [1..MaxN*MaxN] Of Record X,Y : Int; End;
       V,H : Array [0..MaxN] Of Int;
       HelpCount : Array [1..MaxN] Of Int;
       Count,Ans,From : Array [0..MaxN,0..MaxN] Of Int;

Procedure OpenFiles;
Begin
  Assign(Input,File_In);
  ReSet(Input);
  Assign(Output,File_Out);
  ReWrite(Output);
End;

Procedure Init;
  Var I : Int;
Begin
  Read(N);
  For I :=1 To N Do
    Read(My[I].Y,My[I].X);
  Read(S);
  For I :=1 To S Do
    Read(V[I]);
  Read(A);
End;

Procedure Swap(Var A,B : Int);
  Var C : Int;
Begin
  C :=A;
  A :=B;
  B :=C;
End;

Procedure Sort(L,R : Int);
  Var B,E,X : Int;
Begin
  B :=L;
  E :=R;
  X :=My[(L+R) Div 2].X;
  Repeat
    While My[B].X<X Do Inc(B);
    While My[E].X>X Do Dec(E);
    If B<=E Then
      Begin
        Swap(My[B].X,My[E].X);
        Swap(My[B].Y,My[E].Y);
        Inc(B);
        Dec(E);
      End;
  Until B>E;
  If B<R Then Sort(B,R);
  If E>L Then Sort(L,E);
End;

Procedure Solve;
  Var I,J,K,X : Int;
      Num : Int;
Begin
  If N=0 Then
    Begin
      WriteLn(A);
      Write('1 ');
      For I :=2 To A-1 Do
        Write(I,' ');
      Write('100 ');
      Exit;
    End;
  FillChar(H,SizeOf(H),0);
  Sort(1,N);
  For I :=1 To MaxN Do
    Begin
      FillChar(HelpCount,SizeOf(HelpCount),0);
      Count[I,I] :=0;
      Num :=1;
      While (Num<=N) And (My[Num].X<I) Do Inc(Num);
      For J :=I+1 To MaxN Do
        Begin
          While (Num<=N) And (My[Num].X<J) Do
            Begin
              Inc(HelpCount[My[Num].Y]);
              Inc(Num);
            End;
          For K :=1 To S-1 Do
            For X :=V[K] To V[K+1] Do
              If HelpCount[X]>0 Then
                Begin
                  Inc(Count[I,J]);
                  Break;
                End;
          Count[J,I] :=Count[I,J];
        End;
    End;
  FillChar(Ans,SizeOf(Ans),0);
  FillChar(From,SizeOf(From),0);
  Ans[1,0] :=Count[1,MaxN];
  For I :=2 To MaxN Do
    Begin
      Ans[I,0] :=Ans[I-1,0];
      For J :=1 To A-2 Do
        For K :=1 To I-1 Do
          If Ans[I,J]<Ans[K,J-1]+Count[K,I]+Count[I,MaxN]-Count[K,MaxN] Then
            Begin
              Ans[I,J] :=Ans[K,J-1]+Count[K,I]+Count[I,MaxN]-Count[K,MaxN];
              From[I,J] :=K;
            End;
    End;
  X :=2;
  For I :=3 To MaxN-1 Do
    If Ans[X,A-2]<Ans[I,A-2] Then
      Begin
        J :=Ans[X,A-2];
        X :=I;
      End;
  For I :=A-2 DownTo 1 Do
    Begin
      H[I] :=X;
      X :=From[X,I];
    End;
  WriteLn(A);
  Write('1 ');
  For I :=1 To A-2 Do
    Write(H[I],' ');
  Write('100 ');
End;

Procedure CloseFiles;
Begin
  Close(Input);
  Close(Output);
End;

Begin
  OpenFiles;
  Init;
  Solve;
  CloseFiles;
End.
