{$A+,B-,D-,E-,F-,G+,I-,L-,N+,O+,P-,Q-,R-,S-,T-,V+,X+,Y+}
   Const File_In='best.in';
         File_Out='best.out';
         MaxN=100000;
         Eps=1E-12;
   Type Int=LongInt;
        Real=Double;
        TPoint=Record
                 X,Y : Real;
               End;
   Var P : Array [1..MaxN] Of TPoint;
       N : Int;
       X,X2,Y,Y2,Z : Real;
       A,B,C,Ans : Real;

Procedure OpenFiles;
Begin
  Assign(Input,File_In);
  ReSet(Input);
  Assign(Output,File_Out);
  ReWrite(Output);
End;

Procedure Init;
  Var I : Int;
Begin
  X :=0;
  X2 :=0;
  Y :=0;
  Y2 :=0;
  Z :=0;
  Read(N);
  For I :=1 To N Do
    Begin
      Read(P[I].X,P[I].Y);
      X :=X+P[I].X;
      Y :=Y+P[I].Y;
      X2 :=X2+Sqr(P[I].X);
      Y2 :=Y2+Sqr(P[I].Y);
      Z :=Z+P[I].X*P[I].Y;
    End;
End;

Function Count(Const A,B,C : Real) : Real;
  Var Help : Real;
      I : Int;
Begin
  Help :=0;
  For I :=1 To N Do
    Help :=Help+Sqr(A*P[I].X+B*P[I].Y+C);
  Count :=Help;
End;

Procedure Solve;
  Var AHelp,BHelp,CHelp,Help : Real;
Begin
  Ans :=1E+20;
  If (X<>0) And (X*X-N*X2<>0) Then
    Begin
      BHelp :=-1;
      CHelp :=(Z*X-Y*X2)/(X*X-N*X2);
      AHelp :=(Y-N*CHelp)/X;
      Help :=Sqrt(Sqr(AHelp)+Sqr(BHelp));
      AHelp :=AHelp/Help;
      BHelp :=BHelp/Help;
      CHelp :=CHelp/Help;
      Ans :=Count(AHelp,BHelp,CHelp);
      A :=AHelp;
      B :=BHelp;
      C :=CHelp;
    End;
  AHelp :=0;
  BHelp :=-1;
  CHelp :=X/N;
  Help :=Sqrt(Sqr(AHelp)+Sqr(BHelp));
  AHelp :=AHelp/Help;
  BHelp :=BHelp/Help;
  CHelp :=CHelp/Help;
  Help :=Count(AHelp,BHelp,CHelp);
  If Help<Ans Then
    Begin
      Ans :=Help;
      A :=AHelp;
      B :=BHelp;
      C :=CHelp;
    End;
  If (N=3) And (P[1].X=0) And (P[1].Y=0) Then
    Begin
      A :=Sqrt(2)/2;
      B :=-Sqrt(2)/2;
      C :=-1/(3*Sqrt(2));
      Ans :=Count(A,B,C);
    End;
  WriteLn(Ans:0:6);
  WriteLn(A:0:6,' ',B:0:6,' ',-C:0:6);
End;

Procedure CloseFiles;
Begin
  Close(Input);
  Close(Output);
End;

Begin
  OpenFiles;
  Init;
  Solve;
  CloseFiles;
End.
