{$A+,B-,D-,E-,F-,G+,I-,L-,N+,O+,P-,Q-,R-,S-,T-,V+,X+,Y+}
   Const File_In='young.in';
         File_Out='young.out';
         MaxLen=51;
   Type Int=LongInt;
        TDiagramma=Array [-1..MaxLen] Of Int;
   Var A,B,BC,C : TDiagramma;
       Answer : Int;
       CC,Count : Array [0..MaxLen,0..MaxLen] Of Int;

Procedure OpenFiles;
Begin
  Assign(Input,File_In);
  ReSet(Input);
  Assign(Output,File_Out);
  ReWrite(Output);
End;

Function Max(Const A,B : Int) : Int;
Begin
  If A>B Then Max :=A
  Else Max :=B;
End;

Procedure GetAnswer(I,J,MaxC : Integer);
  Var Color,From : Integer;
Begin
  If J>C[0] Then
    Begin
      Inc(Answer);
      Exit;
    End;
  If I>C[J] Then
    Begin
      GetAnswer(A[J+1]+1,J+1,MaxC);
      Exit;
    End;
  From :=Max(CC[J,I-1],CC[J-1,I]+1);
  For Color :=From To MaxC-1 Do
    If (B[Color]>0) And ((Color=1) Or (BC[Color]-B[Color]+1<=BC[Color-1]-B[Color-1]-Count[J,Color-1])) Then
      Begin
        Dec(B[Color]);
        CC[J,I] :=Color;
        Inc(Count[J,Color]);
        GetAnswer(I+1,J,MaxC);
        Dec(Count[J,Color]);
        Inc(B[Color]);
      End;
  If (MaxC<=B[0]) And (From<=MaxC) And ((MaxC=1) Or (BC[MaxC]-B[MaxC]+1<=BC[MaxC-1]-B[MaxC-1]-Count[J,MaxC-1])) Then
    Begin
      Dec(B[MaxC]);
      CC[J,I] :=MaxC;
      Inc(Count[J,MaxC]);
      GetAnswer(I+1,J,MaxC+1);
      Dec(Count[J,MaxC]);
      Inc(B[MaxC]);
    End;
End;

Procedure Solve;
  Var I : Int;
Begin
  If (A[-1]+B[-1]<>C[-1]) Then
    Begin
      WriteLn('0');
      Exit;
    End;
  For I :=1 To A[0] Do
    If A[I]>C[I] Then
      Begin
        WriteLn('0');
        Exit;
      End;
  FillChar(CC,SizeOf(CC),0);
  FillChar(Count,SizeOf(Count),0);
  BC :=B;
  Answer :=0;
  GetAnswer(A[1]+1,1,1);
  WriteLn(Answer);
End;

Procedure ReadD(Var A : TDiagramma);
Begin
  FillChar(A,SizeOf(A),0);
  Read(A[1]);
  If A[1]=-1 Then Exit;
  A[-1] :=0;
  A[0] :=0;
  While A[A[0]+1]<>0 Do
    Begin
      Inc(A[0]);
      Inc(A[-1],A[A[0]]);
      Read(A[A[0]+1])
    End;
End;

Procedure Init;
Begin
  ReadD(A);
  While A[1]<>-1 Do
    Begin
      ReadD(B);
      ReadD(C);
      Solve;
      ReadD(A);
    End;
End;

Procedure CloseFiles;
Begin
  Close(Input);
  Close(Output);
End;

Begin
  OpenFiles;
  Init;
  CloseFiles;
End.
