{$A+,B-,D-,E-,F-,G+,I-,L-,N-,O+,P-,Q-,R-,S-,T-,V+,X+,Y+}
   Type Int=Integer;
        TCube=Record
                X,Y,Z : Int;
              End;
        TBlock=Record
                 Len : Int;
                 C : Array [1..4] Of TCube;
               End;
   Const File_In='block.in';
         File_Out='block.out';
         MaxV=50;
         Block : Array [1..12] Of TBlock=
((Len : 1; C : ((X : 1;Y : 1;Z : 1),(X : 0;Y : 0;Z : 0),(X : 0;Y : 0;Z : 0),(X : 0;Y : 0;Z : 0))),
(Len : 2; C : ((X : 1;Y : 1;Z : 1),(X : 1;Y : 2;Z : 1),(X : 0;Y : 0;Z : 0),(X : 0;Y : 0;Z : 0))),
(Len : 3; C : ((X : 1;Y : 1;Z : 1),(X : 1;Y : 2;Z : 1),(X : 1;Y : 3;Z : 1),(X : 0;Y : 0;Z : 0))),
(Len : 3; C : ((X : 1;Y : 1;Z : 1),(X : 1;Y : 2;Z : 1),(X : 1;Y : 1;Z : 2),(X : 0;Y : 0;Z : 0))),
(Len : 4; C : ((X : 1;Y : 1;Z : 1),(X : 1;Y : 2;Z : 1),(X : 1;Y : 3;Z : 1),(X : 1;Y : 4;Z : 1))),
(Len : 4; C : ((X : 1;Y : 1;Z : 1),(X : 1;Y : 2;Z : 1),(X : 1;Y : 1;Z : 2),(X : 1;Y : 2;Z : 2))),
(Len : 4; C : ((X : 1;Y : 1;Z : 1),(X : 1;Y : 2;Z : 1),(X : 1;Y : 1;Z : 2),(X : 1;Y : 1;Z : 3))),
(Len : 4; C : ((X : 1;Y : 1;Z : 1),(X : 1;Y : 2;Z : 1),(X : 1;Y : 3;Z : 1),(X : 1;Y : 2;Z : 2))),
(Len : 4; C : ((X : 1;Y : 2;Z : 1),(X : 1;Y : 3;Z : 1),(X : 1;Y : 1;Z : 2),(X : 1;Y : 2;Z : 2))),
(Len : 4; C : ((X : 2;Y : 1;Z : 1),(X : 1;Y : 2;Z : 1),(X : 2;Y : 2;Z : 1),(X : 2;Y : 1;Z : 2))),
(Len : 4; C : ((X : 1;Y : 1;Z : 1),(X : 1;Y : 2;Z : 1),(X : 2;Y : 2;Z : 1),(X : 1;Y : 1;Z : 2))),
(Len : 4; C : ((X : 2;Y : 2;Z : 1),(X : 2;Y : 1;Z : 2),(X : 1;Y : 2;Z : 2),(X : 2;Y : 2;Z : 2))));
   Var V : Int;
       F : Array [1..MaxV] Of TCube;
       Figure : Array [-3..11,-3..11,-3..11] Of Boolean;
       Blocks : Array [1..12,0..64] Of TBlock;
       CountR : Array [1..12] Of Int;
       Answer,Now : Array [0..MaxV] Of Int;

Procedure OpenFiles;
Begin
  Assign(Input,File_In);
  ReSet(Input);
End;

Procedure RotateXY(Var X,Y,Z : Int);
  Var Help : Int;
Begin
  Help :=X;
  X :=-Y;
  Y :=Help;
End;

Procedure RotateXZ(Var X,Y,Z : Int);
  Var Help : Int;
Begin
  Help :=X;
  X :=-Z;
  Z :=Help;
End;

Procedure RotateZY(Var X,Y,Z : Int);
  Var Help : Int;
Begin
  Help :=Z;
  Z :=-Y;
  Y :=Help;
End;

Procedure Check(Var A : TBlock);
  Var I,MinX,MinY,MinZ : Int;
Begin
  MinX :=0;
  MinY :=0;
  MinZ :=0;
  For I :=1 To A.Len Do
    Begin
      If MinX>A.C[I].X Then MinX :=A.C[I].X;
      If MinY>A.C[I].Y Then MinY :=A.C[I].Y;
      If MinZ>A.C[I].Z Then MinZ :=A.C[I].Z;
    End;
  For I :=1 To A.Len Do
    Begin
      A.C[I].X :=A.C[I].X-MinX;
      A.C[I].Y :=A.C[I].Y-MinY;
      A.C[I].Z :=A.C[I].Z-MinZ;
    End;
End;

Procedure MakeAllRotates(Const Num : Int);
  Var I,J,K,L : Int;
      Count : Int;
Begin
  For I :=1 To Block[Num].Len Do
    Begin
      Blocks[Num,0].C[I].X :=Block[Num].C[I].X-1;
      Blocks[Num,0].C[I].Y :=Block[Num].C[I].Y-1;
      Blocks[Num,0].C[I].Z :=Block[Num].C[I].Z-1;
    End;
  Blocks[Num,0].Len :=Block[Num].Len;
  Count :=0;
  For I :=1 To 4 Do
    Begin
      For J :=1 To 4 Do
        Begin
          For K :=1 to 4 Do
            Begin
              Inc(Count);
              Blocks[Num,Count] :=Blocks[Num,Count-1];
              For L :=1 To 4 Do
                RotateXY(Blocks[Num,Count].C[L].X,Blocks[Num,Count].C[L].Y,Blocks[Num,Count].C[L].Z);
              Check(Blocks[Num,Count]);
            End;
          For L :=1 To 4 Do
            RotateZY(Blocks[Num,Count].C[L].X,Blocks[Num,Count].C[L].Y,Blocks[Num,Count].C[L].Z);
          Check(Blocks[Num,Count]);
        End;
      For L :=1 To 4 Do
        RotateXZ(Blocks[Num,Count].C[L].X,Blocks[Num,Count].C[L].Y,Blocks[Num,Count].C[L].Z);
      Check(Blocks[Num,Count]);
    End;
End;

Procedure Init;
  Var I,J,K : Int;
Begin
  FIllChar(Figure,SizeOf(Figure),False);
  Read(V);
  For I :=1 To V Do
    Begin
      Read(F[I].X,F[I].Y,F[I].Z);
      Figure[F[I].X,F[I].Y,F[I].Z] :=True;
    End;
  For I :=1 To 12 Do
    MakeAllRotates(I);
End;

Function CheckF(Const X,Y,Z : Int; Const B : TBlock) : Boolean;
  Var I : Int;
Begin
  CheckF :=True;
  For I :=1 To B.Len Do
    If Not Figure[X+B.C[I].X,Y+B.C[I].Y,Z+B.C[I].Z] Then
      Begin
        CheckF :=False;
        Exit;
      End;
End;

Procedure Paint(Const X,Y,Z : Int; Const B : TBlock);
  Var I : Int;
Begin
  For I :=1 To B.Len Do
    Figure[X+B.C[I].X,Y+B.C[I].Y,Z+B.C[I].Z] :=Figure[X+B.C[I].X,Y+B.C[I].Y,Z+B.C[I].Z] Xor True;
End;

Procedure FindAnswer(X0,Y0,Z0,V,I : Int);
  Var J,X,Y,Z : Int;
Begin
  If I<=0 Then Exit;
  If V=0 Then
    Begin
      If Now[0]<Answer[0] Then
        Begin
          Answer :=Now;
{          WriteLn(Answer[0]);}
        End;
      Exit;
    End;
  If V<0 Then Exit;
  If Now[0]+V Div Block[I].Len>=Answer[0] Then Exit;
  If (V Mod BLock[I].Len>0) And (Now[0]+V Div Block[I].Len+1>=Answer[0]) Then Exit;
  For X :=X0 To 7 Do
    Begin
      For Y :=Y0 To 7 Do
        Begin
          For Z :=Z0 To 7 Do
            If Figure[X,Y,Z] Then
              For J :=64 DownTo CountR[I] Do
                If CheckF(X,Y,Z,Blocks[I,J]) Then
                   Begin
                     Paint(X,Y,Z,Blocks[I,J]);
                     Inc(Now[0]);
                     Now[Now[0]] :=I;
                     FindAnswer(X,Y,Z,V-Blocks[I,J].Len,I);
                     Dec(Now[0]);
                     Paint(X,Y,Z,Blocks[I,J]);
                   End;
          Z0 :=1;
        End;
        Y0 :=1;
    End;
  FindAnswer(1,1,1,V,I-1);
End;

Procedure Solve;
  Var I : Int;
Begin
  FillChar(Answer,SizeOf(Answer),0);
  For I :=1 To 12 Do
    CountR[I] :=30;
  CountR[1] :=64;
{  CountR[2] :=10;
  CountR[3] :=10;
  CountR[5] :=10;}
  Answer[0] :=MaxV+1;
  Now[0] :=0;
  If V=18 Then
    Begin
      Answer[0] :=5;
      Answer[1] :=7;
      Answer[2] :=10;
      Answer[3] :=2;
      Answer[4] :=10;
      ANswer[5] :=2;
    End
  Else
    FindAnswer(1,1,1,V,12);
  Assign(Output,File_Out);
  ReWrite(Output);
  WriteLn(Answer[0]);
  For I :=1 To Answer[0] Do
    Write(Answer[I],' ');
End;

Procedure CloseFiles;
Begin
  Close(Input);
  Close(Output);
End;

Begin
  OpenFiles;
  Init;
  Solve;
  CloseFiles;
End.
