{$A+,B-,D+,E-,F-,G+,I+,L+,N+,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}
{$M 16384,0,655360}
const
  prob='ram';
  fin= prob+'.in';
  fout=prob+'.out';

type
  ttype=(_load,_store,_add,_sub,_mult,_div,_read,_write,_jump,_jgtz,_jzero,_halt);

type
  oper=record
    t:ttype;
    a,it:longint;
  end;

var
  omgstupidity:integer;
  i,j,k,l,n,m,cl,rp:longint;
  a:array[0..1100]of oper;
  c,b:array[0..1100]of longint;
  s:string;

procedure init;
begin
  assign(input,fin);
  reset(input);

    readln(n,m);
    for i:=0 to n-1 do begin
      readln(s);
      case s[1] of
        'H':a[i].t:=_halt;
        'L':a[i].t:=_load;
        'A':a[i].t:=_add;
        'M':a[i].t:=_mult;
        'D':a[i].t:=_div;
        'R':a[i].t:=_read;
        'W':a[i].t:=_write;
        'S':if s[2]='T' then
              a[i].t:=_store
            else
              a[i].t:=_sub;
        'J':case s[2] of
              'U':a[i].t:=_jump;
              'G':a[i].t:=_jgtz;
              'Z':a[i].t:=_jzero;
            end;
      end;
      if a[i].t=_halt then
        continue;
      while not(s[1] in ['*','=','0'..'9'])do
        delete(s,1,1);
      a[i].it:=1;
      if s[1]='*' then
        a[i].it:=2;
      if s[1]='=' then
        a[i].it:=0;
      if (a[i].t=_jump)or(a[i].t=_jgtz)or(a[i].t=_jzero) then
        a[i].it:=0;
      if (a[i].t=_read)or(a[i].t=_store) then
        dec(a[i].it);
      if not (s[1] in ['0'..'9']) then
        delete(s,1,1);
      val(s,a[i].a,omgstupidity);
    end;

    for i:=1 to m do
      read(b[i]);

  close(output);
end;

procedure solve;
begin

end;

procedure done;
begin
  assign(output,fout);
  rewrite(output);

    cl:=0;
    rp:=1;
    repeat
      k:=a[cl].a;
      for i:=1 to a[cl].it do
        k:=c[k] ;
      case a[cl].t of
        _jump :begin
                 cl:=k;
                 continue;
               end;
        _jgtz :if c[0]>0 then begin
                 cl:=k;
                 continue;
               end;
        _jzero:if c[0]=0 then begin
                 cl:=k;
                 continue;
               end;

        _halt :break;

        _read :begin;
                 c[k]:=b[rp];
                 inc(rp);
               end;
        _write:writeln(k);
        _load :c[0]:=k;
        _store:c[k]:=c[0];

        _add  :c[0]:=c[0]+k;
        _sub  :c[0]:=c[0]-k;
        _mult :c[0]:=c[0]*k;
        _div  :c[0]:=c[0] div k;
      end;
      inc(cl);
    until false;

  close(output);
end;

begin
  init;
  solve;
  done;
end.
