{$A+,B-,D-,E-,F-,G-,I-,L+,N+,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}
{$M 16384,0,655360}
const
  prob='best';
  fin =prob+'.in';
  fout=prob+'.out';
  maxn=100000;
  e=1e-12;

var
  a,b,c,min,cur,l,r,ans,sx,sy,sx2,sy2,sxy:extended;
  i,j,k,n,m:longint;
  p:array[1..maxn]of extended;
  z:array[1..maxn,1..2]of longint;

procedure init;
begin
  assign(input,fin);
  reset(input);

    read(n);
    for i:=1 to n do
      read(z[i,1],z[i,2]);

  close(input);
end;

function calculate(var a:extended;const b:extended;var c:extended):extended;
var
  a1,b1:extended;
  i:longint;
begin
  a:=sqrt(1-b*b);
  a1:=sx*a+sy*b;
  {for i:=1 to n do
    a1:=a1+z[i,1]*a+z[i,2]*b;}

  c:=-a1/n;
  b1:=sx2*a*a+sy2*b*b+n*c*c+2*(sxy*a*b+a*sx*c+b*sy*c);
  {for i:=1 to n do
    a1:=a1+sqr(a*z[i,1]+b*z[i,2]+c);}
  calculate:=b1;
end;

function eq(a,b:extended):boolean;
begin
  if abs(a-b)<e then
    eq:=true
  else
    eq:=false;
end;

function dihotomy(l,r:extended;var val:extended):extended;
var
  xl,xr,a,b,c,a1,a2,b1:extended;
begin
  xl:=calculate(a,l,c);
  xr:=calculate(a,r,c);
  repeat
    b:=(l+r)/2;
    b1:=b+e;
    if b1>r then
      b1:=r;
    a1:=calculate(a,b1,c);
    b1:=b-e;
    if b1<l then
      b1:=l;
    a2:=calculate(a,b1,c);
    if a1<a2 then
      l:=b
    else
      r:=b;
    xl:=calculate(a,l,c);
    xr:=calculate(a,r,c);
  until eq(l,r);
  dihotomy:=l;
  val:=xl;
end;

function cosang(x,y,x1,y1:extended):extended;
begin
  if eq(x1,x) and eq(y1,y) then begin
    cosang:=-1;
    exit;
  end;
  cosang:=(x1-x)/sqrt(sqr(x-x1)+sqr(y-y1));
end;

procedure sort(l,r:longint);
var
  i,j:longint;
  x,y:extended;
begin
  i:=l;
  j:=r;
  x:=p[(l+r) div 2];
  repeat
    while p[i]<x do
      inc(i);
    while p[j]>x do
      dec(j);
    if i<=j then begin
      y:=p[i];
      p[i]:=p[j];
      p[j]:=y;
      inc(i);
      dec(j);
    end;
  until i>j;
  if i<r then
    sort(i,r);
  if l<j then
    sort(l,j);
end;

procedure solve;
begin
  j:=1;
  for i:=2 to n do
    if (z[i,2]<z[j,2])or((z[i,2]=z[j,2])and(z[i,1]<z[j,1])) then
      j:=i;
  for i:=1 to n do
    p[i]:=cosang(z[j,1],z[j,2],z[i,1],z[i,2]);

  sort(1,n);
  sx:=0;
  sy:=0;
  sx2:=0;
  sy2:=0;
  sxy:=0;
  for i:=1 to n do begin
    sx:=sx+z[i,1];
    sy:=sy+z[i,2];
    sx2:=sx2+sqr(z[i,1]);
    sy2:=sy2+sqr(z[i,2]);
    sxy:=sxy+z[i,1]*z[i,2];
  end;

  min:=1e1543;
  for k:=1 to n-1 do begin
    l:=p[k];
    r:=p[k+1];
    cur:=dihotomy(l,r,a);
    if a<min then begin
      min:=a;
      ans:=cur;
    end;
  end;
  b:=ans;
  min:=calculate(a,b,c);
end;

procedure done;
begin
  assign(output,fout);
  rewrite(output);

    writeln(min:0:8);
    write(a:0:8,' ',b:0:8,' ',-c:0:8);

  close(output);
end;

begin
  init;
  solve;
  done;
end.
