{$A+,B-,D+,E-,F-,G-,I-,L+,N-,O-,P-,Q-,R-,S-,T-,V+,X+,Y+,H+}
{$M 16384,0,655360}
const
  fin= 'prof.in';
  fout='prof.out';

var
  i,j,k,l,n,m,r,x,ans:longint;
  a:array[0..4000]of string;
  ok:boolean;
  s,w,v,t:string;

procedure init;
begin
  assign(input,fin);
  reset(input);

    read(s);

  close(output);
end;

function kmp(s,p:string):boolean;
var
  q:array[0..4000]of longint;
  k,i,n,n1:longint;
begin
  kmp:=false;
  q[1]:=0;
  n:=length(p);
  k:=0;
  for i:=2 to n do begin
    while (not (p[i]=p[k+1]))and(k>0) do
      k:=q[k];
    if p[i]=p[k+1] then
      inc(k);
    q[i]:=k;
  end;
  n1:=length(s);
  k:=0;
  for i:=1 to n1 do begin
    while (not (s[i]=p[k+1]))and(k>0) do
      k:=q[k];
    if s[i]=p[k+1] then
      inc(k);
    if k=n then begin
      kmp:=true;
      exit;
    end;
  end;
end;

procedure sort(l,r:longint);
var
  i,j,x:longint;
begin
  i:=l;
  j:=r;
  a[n+2]:=a[(l+r)div 2];
  x:=n+2;
  repeat
    while a[i]<a[x] do
      inc(i);
    while a[j]>a[x] do
      dec(j);
    if i<=j then begin
      a[n+1]:=a[i];
      a[i]:=a[j];
      a[j]:=a[n+1];
      inc(i);
      dec(j);
    end;
  until i>j;
  if i<r then
    sort(i,r);
  if j>l then
    sort(l,j);
end;

procedure solve;
begin
  n:=length(s);
  for i:=1 to n do begin
    l:=1;
    r:=n-i+1;
    v:=copy(s,1,i-1);
    while l<>r do begin
      x:=(l+r+1)div 2;
      w:=copy(s,i,x);
      t:=copy(s,i+x,n-i-x+1);
      if ok then
        ok:=kmp(v,w);
      if ok or kmp(t,w) then
        l:=x
      else
        r:=x-1;
    end;
    w:=copy(s,i,l);
    t:=copy(s,i+l,n-i-l+1);
    if ok or kmp(t,w) then
      a[i]:=copy(s,i,l)
    else
      a[i]:=copy(s,i,l-1);
  end;

  sort(1,n);

  ans:=0;
  for i:=1 to n do begin
    k:=1;
    l:=length(a[i-1]);
    r:=length(a[i]);
    while (k<=l)and(k<=r)and(a[i][k]=a[i-1][k]) do
      inc(k);
    inc(ans,r-k+1);
  end;
end;

procedure done;
begin
  assign(output,fout);
  rewrite(output);

    write(ans);

  close(output);
end;

begin
  init;
  solve;
  done;
end.
