program ZA;

{$APPTYPE CONSOLE}

const
  base=1000000000;

type
  TLong = record
    len: longint;
    a: array [1..10000] of longint;
  end;

procedure LongInc(var a: TLong; const b: TLong);
var
  i: integer;
begin
  if a.len<b.len then
  begin
    for i:=a.len+1 to b.len do
      a.a[i]:=0;
    a.len:=b.len;
  end;
  for i:=1 to b.len do
  begin
    inc(a.a[i], b.a[i]);
    if (i<a.len) and (a.a[i]>=base) then
    begin
      a.a[i+1]:=a.a[i+1]+(a.a[i] div base);
      a.a[i]:=a.a[i] mod base;
    end;
  end;
  for i:=b.len+1 to a.len do
    if (i<a.len) and (a.a[i]>=base) then
    begin
      a.a[i+1]:=a.a[i+1]+(a.a[i] div base);
      a.a[i]:=a.a[i] mod base;
    end;
  while a.a[a.len]>=base do
  begin
    a.a[a.len+1]:=a.a[a.len] div base;
    a.a[a.len]:=a.a[a.len] mod base;
    inc(a.len);
  end;
  while (a.len>0) and (a.a[a.len]=0) do
    dec(a.len);
end;

var
  N, L, i, j, t: longint;
  len: array [1..600] of longint;
  d: array [0..600] of TLong;
  str: string;

begin
  Assign(input, 'programs.in');
  Assign(output, 'programs.out');
  Reset(input);
  Rewrite(output);
  ReadLn(N);
  for i:=1 to N do
  begin
    ReadLn(str);
    len[i]:=0;
    for j:=1 to Length(str) do
      if (Ord(str[j])>=32) and (Ord(str[j])<=126) and (str[j]<>' ') then
        inc(len[i]);
  end;
  Read(L);
  d[0].len:=1;
  d[0].a[1]:=1;
  for i:=1 to L do
  begin
    d[i].len:=0;
    for j:=1 to N do
      if i-len[j]>=0 then
        LongInc(d[i], d[i-len[j]]);
  end;
  {for j:=1 to L do
  begin}
  for i:=d[L].len downto 1 do
  begin
    t:=base div 10;
    if i<d[L].len then
      while (t>1) and (d[L].a[i]<t) do
      begin
        Write(0);
        t:=t div 10;
      end;
    Write(d[L].a[i]);
  end;
//  WriteLn;
//  end;
  Close(input);
  Close(output);
end.
 