program ZA;

{$APPTYPE CONSOLE}

type
  TVector=record
    x,y: extended;
  end;

var
  max, n, i: integer;
  points: array [1..300] of TVector;
  u: array [1..300] of boolean;
  t1, t2, f: TVector;

function VectorMul(v1, v2: TVector): extended;
begin
  VectorMul:=v1.x*v2.y-v2.x*v1.y;
end;

procedure recurse(p, v: TVector; c: integer);
var
  t, t1: TVector;
  i: integer;
begin
  for i:=1 to n do
  begin
    if c+n-i+1<max then
      exit;
    if u[i] then
      continue;
    t.x:=points[i].x-p.x;
    t.y:=points[i].y-p.y;
    t1.x:=f.x-points[i].x;
    t1.y:=f.y-points[i].y;
    {if ((t1.x<>0) or (t1.y<>0)) and (c>0) and (VectorMul(t, t1)>0) then
      continue;}
    if VectorMul(p, t)>0 then
    begin
      if c=0 then
        f:=points[i];
      u[i]:=true;
      recurse(points[i], t, c+1);
      u[i]:=false;
    end;
    if c+n-i<max then
      exit;
  end;
  max:=c;
end;

begin
  Assign(input, 'polygon.in');
  Assign(output, 'polygon.out');
  Reset(input);
  Rewrite(output);
  Read(N);
  for i:=1 to n do
  begin
    Read(points[i].x, points[i].y);
    u[i]:=false;
  end;
  max:=0;
  for i:=1 to n do
  begin
    points[i].x:=points[i].x+1001;
    points[i].y:=points[i].y+1001;
  end;
  t1.x:=0;
  t1.y:=0;
  t1.x:=1;
  t1.y:=0;
  recurse(t1, t2, 0);
  WriteLn(max);
  Close(input);
  Close(output);
end.
