#include <stdio.h>
#include <string.h>

#define maxl 666
#define maxn 666
#define maxd 100
#define maxw 300
#define base (long long)1e18

#define max(a, b) ((a) > (b) ? (a) : (b))

long long res[maxl][maxd];
int ll[maxl];
int n, l;
int len[maxn];
char buf[maxw];

int add( long long *a, long long *b, int la, int lb )
{
  int i;

  for (i = 0; i < lb; i++)
    a[i] += b[i];
  for (i = 0; i < max(la, lb); i++)
    if (a[i] >= base)
      a[i + 1]++, a[i] -= base;
  if (a[max(la, lb)])
    return max(la, lb) + 1;
  return max(la, lb);
}

void print( long long *a )
{
  int i;

  for (i = maxd - 1; i >= 0 && !a[i]; i--)
    ;
  if (i < 0)
    printf("0");
  else
  {
    printf("%Ld", a[i]);
    for (i--; i >= 0; i--)
      printf("%018Ld", a[i]);
  }
}

int main( void )
{
  int i, j, c;

  freopen("programs.in", "rt", stdin);
  freopen("programs.out", "wt", stdout);
  scanf("%d\n", &n);
  for (i = 0; i < n; i++)
  {
    gets(buf);
    for (j = len[i] = 0; buf[j]; j++)
      len[i] += (32 < buf[j] && buf[j] <= 126);
  }
  scanf("%d", &l);
  memset(res, 0, sizeof(res));
  res[0][0] = 1;
  ll[0] = 1;
  for (i = 1; i <= l; i++)
  {
    for (j = 0; j < n; j++)
      if (len[j] <= i)
        ll[i] = add(res[i], res[i - len[j]], ll[i], ll[i - len[j]]);
  }
  print(res[l]);
  return 0;
}
