#include <stdio.h>
#include <string.h>

//#define dbg

#define maxmem 32768
#define maxl 1023

short ac, mem[maxmem + 1];
int u[maxmem], s;
char buf[maxl];
int isre, isdbz;

void doop( char a, char b, int n )
{
  while (1)
  {
    if (b == '=')
    {
      if (a == 'A')
        ac += n;
      else if (a == 'S')
        ac -= n;
      else if (a == 'M')
        ac *= n;
      else if (a == 'D' || a == 'O')
      {
        if (n == 0)
        {
          isdbz = 1;
          return;
        }
        if (a == 'O')
          ac %= n;
        else
          ac /= n;
      }
      else if (a == 'R')
        ac = n;
      ac &= 0xFFFF;
      return;
    }
    else
    {
      u[n] = s;
      if (mem[n] < 0)
      {
        if (u[-mem[n]] == s)
        {
          isre = 1;
          return;
        }
        n = -mem[n];
        continue;
      }
      if (a == 'A')
        ac += mem[n];
      else if (a == 'S')
        ac -= mem[n];
      else if (a == 'M')
        ac *= mem[n];
      else if (a == 'D' || a == 'O')
      {
        if (mem[n] == 0)
        {
          isdbz = 1;
          return;
        }
        if (a == 'O')
          ac %= mem[n];
        else
          ac /= mem[n];
      }
      else if (a == 'R')
        ac = mem[n];
      else if (a == 'W')
        mem[n] = ac;
      ac &= 0xFFFF;
      return;
    }
  }
}

int main( void )
{
  int i, t;

  freopen("indirect.in", "rt", stdin);
  freopen("indirect.out", "wt", stdout);
  memset(u, 0, sizeof(u));
  memset(mem, 0, sizeof(mem));
  ac = 0;
  s = 1, isre = isdbz = 0;
  while (gets(buf))
  {
#ifdef dbg
    if (s % 500 == 0)
      fprintf(stderr, "step #%d\n", s);
#endif
    if (!*buf)
      break;
    sscanf(buf + 2, "%d", &t);
    doop(buf[0], buf[1], t);
    s++;
    if (isre || isdbz)
      break;
  }
#ifdef dbg
  printf("steps - %d\n", s);
#endif
  if (isre)
    printf("RUN-TIME ERROR\n");
  else if (isdbz)
    printf("DIVISION BY ZERO\n");
  else 
    printf("SUCCESSFUL TERMINATION\n");
  printf("%d\n", (int)ac);
  for (i = 1; i <= maxmem; i++)
    printf("%d\n", (int)mem[i]);
  return 0;
}          
