#include <stdio.h>
#include <string.h>

#define maxmem 0x10000
#define bswap 1
#define pop 2

typedef unsigned char byte;
typedef unsigned short word;

byte mem[maxmem];
word beg, end;
int res[maxmem], to[maxmem];
int is[maxmem];
byte ans[maxmem * 2 + 10];
int al;

int dfs( word sp )
{
  int np, rp, ns, rs;

  if (sp == end)
    return 0;
  if (is[sp] == 1)
    return -1;
  if (is[sp] == 2)
    return res[sp];
  is[sp] = 1;
  np = mem[sp] | (mem[(short)(sp + 1)] << 8);
  rp = dfs(np);
  ns = ((sp >> 8) & 0xFF) | (sp << 8);
  rs = dfs(ns);
  if (rp == -1)
  {
    if (rs == -1)
      res[sp] = -1;
    else
      res[sp] = rs + 2, to[sp] = bswap;
  }
  else
  {
    if (rs == -1)
      res[sp] = rp + 1, to[sp] = pop;
    else
    {
      if (rs + 2 < rp + 1)
        res[sp] = rs + 2, to[sp] = bswap;
      else if (rs + 2 > rp + 1)
        res[sp] = rp + 1, to[sp] = pop;
      else
        res[sp] = rs + 2, to[sp] = bswap;
    }
  }
  is[sp] = 2;
  return res[sp];
}

int main( void )
{
  int i, a, j;

  freopen("2instr.in", "rt", stdin);
  freopen("2instr.out", "wt", stdout);
  scanf("%X", &a), beg = a;
  scanf("%X", &a), end = a;
  for (i = 0; i < maxmem; i++)
    scanf("%X", &a), mem[i] = a;
  memset(is, 0, sizeof(is));
  if (dfs(beg) == -1)
    printf("IMPOSSIBLE");
  else
  {
    al = 0;
    printf("%d\n", res[beg]);
    while (beg != end)
      if (to[beg] == bswap)
      {
        ans[al++] = 0x0F, ans[al++] = 0xCC;
        beg = ((beg >> 8) & 0xFF) | (beg << 8);
      }
      else
      {
        ans[al++] = 0x5C;
        beg = mem[beg] | (mem[(short)(beg + 1)] << 8);
      }
    for (i = 0; i < al - (al % 16); i += 16)
    {
      for (j = 0; j < 8; j++)
        printf("%02X ", ans[i + j]);
      for (j = 0; j < 8; j++)
        printf(" %02X", ans[i + j + 8]);
      printf("\n");
    }
    if (al % 16 > 8)
    {
      for (j = 0; j < 8; j++)
        printf("%02X ", ans[al - (al % 16) + j]);
      for (j = al - (al % 16) + 8; j < al; j++)
        printf(" %02X", ans[j]);
      printf("\n");
    }
    else
      for (j = al - (al % 16); j < al; j++)
        printf(j == al - 1 ? "%02X\n" : "%02X ", ans[j]);
  }
  return 0;
}
