#include <stdio.h>
#include <stdlib.h>

#define maxn 52
#define max(a, b) ((a) > (b) ? (a) : (b))

typedef struct
{
  int num, len[maxn];
} diagram;

int t[maxn][maxn];
int len[maxn];
int k[maxn], l;
diagram la, my, ny;
int lro[maxn], lco[maxn], fro[maxn], fco[maxn];
int lnc[maxn], lnr[maxn];
int cur[maxn];
long long res;
int smy, sny, sla;
int b[maxn][maxn];
int st[maxn * maxn], sp = 0;

void get( int rown, int coln )
{
  int i, j, tt0, tt1;

  if (rown == ny.num)
  {
    for (i = 0; i < ny.num - 1; i++)
    {
      for (j = 0; j < l - 1; j++)
        if (b[i][j] < b[i + 1][j + 1])
          break;
      if (j != l - 1)
        break;
    }
    if (i == ny.num - 1)
    {
      for (i = 1; i < l; i++)
        if (b[0][i] > 0)
          break;
      if (i == l)
        res++;
    }
  }
  else
  {
    if (coln == lro[rown])
      get(rown + 1, fro[rown + 1]);
    else
    {
      tt0 = lnc[coln], tt1 = lnr[rown];
      for (i = max(tt0 + 1, tt1); i < l; i++)
        if (cur[i] > 0)
        {
          cur[i]--;
          tt0 = lnc[coln], tt1 = lnr[rown];
          t[rown][coln] = lnc[coln] = lnr[rown] = i;
          for (j = rown; j < ny.num; j++)
            b[j][i]++;
          st[sp++] = rown, st[sp++] = coln;
          get(rown, coln + 1);
          coln = st[--sp], rown = st[--sp];
          for (j = rown; j < ny.num; j++)
            b[j][i]--;
          lnc[coln] = tt0, lnr[rown] = tt1;
          cur[i]++;
        }
    }
  }
}

int main( void )
{
  int i, j, t;

  freopen("young.in", "rt", stdin);
  freopen("young.out", "wt", stdout);
  while (1)
  {
    la.num = my.num = ny.num = 0;
    while (scanf("%d", &t) == 1 && t > 0)
      la.len[la.num++] = t;
    if (t < 0)
      break;
    while (scanf("%d", &t) == 1 && t > 0)
      my.len[my.num++] = t;
    while (scanf("%d", &t) == 1 && t > 0)
      ny.len[ny.num++] = t;
    for (i = sla = 0; i < la.num; i++)
      sla += la.len[i];
    for (i = sny = 0; i < ny.num; i++)
      sny += ny.len[i];
    for (i = smy = 0; i < my.num; i++)
      smy += my.len[i];
    if (ny.num < la.num || smy != sny - sla)
    {
      printf("0\n");
      continue;
    }
    for (i = 0; i < la.num; i++)
      if (ny.len[i] < la.len[i])
        break;
    if (i != la.num)
    {
      printf("0\n");
      continue;
    }
    for (i = 0; i < la.num; i++)
      if (ny.len[i] != la.len[i])
        break;
    if (i == la.num)
    {
      if (my.num == 0)
        printf("1\n");
      else
        printf("0\n");
      continue;
    }
    memset(fro, 0, sizeof(fro));
    memset(fco, 0, sizeof(fco));
    memset(lro, 0, sizeof(lro));
    memset(lco, 0, sizeof(lco));
    for (i = 0; i < la.num; i++)
      fro[i] = la.len[i];
    for (i = la.num + 1; i < ny.num; i++)
      fro[i] = 0;
    for (i = 0; i < la.num; i++)
      for (j = 0; j < la.len[i]; j++)
        fco[j] = i + 1;
    for (i = 0; i < ny.num; i++)
      lro[i] = ny.len[i];
    for (i = 0; i < ny.num; i++)
      for (j = 0; j < ny.len[i]; j++)
        lco[j] = i;
    l = my.num;
    for (i = 0; i < my.num; i++)
      cur[i] = k[i] = my.len[i];
    for (i = 0; i < maxn; i++)
      lnc[i] = lnr[i] = -1;
    res = 0;
    get(0, fro[0]);
    printf("%Ld\n", res);
  }
  return 0;
}
