{$I-,Q-,R-,S-}

const
  IN_FILE = 'cicle.in';
  OUT_FILE = 'cicle.out';

  MAXN = 115;

  INFINITE = 100000;

type
  Integer = Longint;

var
  n: Integer;
  Start: Integer;
  a, b: array[1..MAXN, 1..MAXN] of Integer;
  NNew: array[1..MAXN] of Boolean;
  Ans: array[0..MAXN] of Integer;

procedure Init();
var
  i, j: Integer;
begin
  Assign(Input, IN_FILE);
  Reset(Input);
  Assign(Output, OUT_FILE);
  Rewrite(Output);
  Read(n);
  for i := 1 to n do
    for j := 1 to n do
      Read(a[i, j]);

  b := a;
end;

procedure Done();
begin
  Close(Input);
  Close(Output);
end;

procedure Print();
var
  i: Integer;
begin
  Writeln('YES');
  Writeln(Ans[0]);
  for i := 1 to Ans[0] do Write(Ans[i], ' ');
end;


procedure Dfs(const k, v: Integer);
var
  i: Integer;
begin
  Inc(Ans[0]);
  Ans[Ans[0]] := k;
  NNew[k] := True;

  for i := 1 to n do
    if b[k, i] < INFINITE then
    begin
      if (i = Start) and (v + b[k, i] < 0) then
      begin
        Inc(Ans[0]);
        Ans[Ans[0]] := Start;
        Print();
        Done();
        Halt;
      end;

      if not NNew[i] then Dfs(i, v + b[k, i]);
    end;

  Dec(Ans[0]);
end;

procedure Solve();
var
  k, i, j: Integer;
begin
  for k := 1 to n do
    for i := 1 to n do
      for j := 1 to n do
        if a[i, j] > a[i, k] + a[k, j] then
          a[i, j] := a[i, k] + a[k, j];

  for i := 1 to n do
  begin
    Start := i;
    if a[i, i] < 0 then Dfs(i, 0);
  end;

  Writeln('NO');
end;

begin
  Init();
  Solve();
  Done();
end.