{$ifdef DEBUG}
  {$I+,Q+,R+,S-}
{$else}
  {$I-,Q-,R-,S-}
{$endif}

program Temp;
const infile = 'cicle.in';
      outfile = 'cicle.out';
      inf = 1000000000;
      MAXN = 100;
var G, dist : array[1..MAXN, 1..MAXN] of longint;
    mark : array[1..MAXN] of boolean;
    q : array[1..MAXN] of integer;
    N, cur : integer;

procedure ReadData;
var i, j : integer;
begin
  assign(input, infile); reset(input);
  assign(output, outfile); rewrite(output);
  read(n);
  for i:=1 to n do
    for j:=1 to n do begin
      read(G[i, j]);
      if G[i, j]=100000 then G[i, j]:=inf;
    end;
end;

procedure Search(i0, i : integer; curs : longint);
var j, k, l : integer;
begin
  mark[i]:=true; inc(cur); q[cur]:=i;
  if (G[i, i0]<inf)and(curs+G[i, i0]<0) then begin
    for j:=1 to cur do
      write(q[j], ' ');
    write(i0);
    close(input);
    close(output);
    halt(0);
  end;

  for j:=1 to n do
    if (dist[j, j]<0)and(not mark[j])and(G[i, j]<inf) then
      Search(i0, j, curs+G[i, j]);
  dec(cur);
end;

procedure Solve;
var i ,j, k : integer;
begin
  fillchar(mark, sizeof(mark), false);
  dist:=G; cur:=0;
  for k:=1 to n do
    for i:=1 to n do
      for j:=1 to n do
        if dist[i, k]+dist[k, j]<dist[i, j] then
          dist[i, j]:=dist[i, k]+dist[k, j];
  for i:=1 to n do
    if dist[i, i]<0 then begin
      writeln('YES');
      Search(i, i, 0);
      exit;
    end;
  writeln('NO');
end;

procedure WriteData;
begin
  close(input);
  close(output);
end;

begin
  ReadData;
  Solve;
  WriteData;
end.
