{$ifdef DEBUG}
  {$I+,Q+,R+,S-}
{$else}
  {$I-,Q-,R-,S-}
{$endif}

program Temp;
const infile = 'floyd.in';
      outfile = 'floyd.out';
      inf = 1000000000;
      MAXN = 100;
var G, dist : array[1..MAXN, 1..MAXN] of longint;
    N : integer;

procedure ReadData;
var i, j : integer;
begin
  assign(input, infile); reset(input);
  assign(output, outfile); rewrite(output);
  read(n);
  for i:=1 to n do
    for j:=1 to n do begin
      read(G[i, j]);
      if G[i, j]=0 then G[i, j]:=inf;
    end;
end;

procedure Solve;
var i, j, k : integer;
    b : boolean;
begin
  dist:=G;
  for k:=1 to n do
    for i:=1 to n do
      for j:=1 to n do
        if dist[i, k]+dist[k, j]<dist[i, j] then
          dist[i, j]:=dist[i, k]+dist[k, j];
  for i:=1 to n do begin
    for j:=1 to n do begin
      if dist[i, j]>1000000 then begin write('0'); if j<n then write(' '); continue; end;
      b:=false;
      for k:=1 to n do
        if dist[i, k]+dist[k, j]<dist[i, j] then begin
          b:=true;
          break;
        end;
      if b then write('2') else write('1');
      if j<n then write(' ');
    end;
    if i<n then writeln;
  end;
end;

procedure WriteData;
begin
  close(input);
  close(output);
end;

begin
  ReadData;
  Solve;
  WriteData;
end.
