const probname = 'sort';
      maxn = 20000;

type pupil = record n: string [40]; num: longint; end;

var n, i: longint;
    a: array [1..maxn] of pupil;

procedure swap (var a, b: pupil);
var c: pupil;
begin
  c := a;
  a := b;
  b := c;
end;

procedure sort (const l, r: longint);
var i, j: longint;
    x: string [40];
    p1, p2: longint;
begin
  i := l;
  j := r;
  x := a [random (j-i+1) + i].n;
  while i<=j do
  begin
    while (i < r) and (a [i].n < x) do inc (i);
    while (j > l) and (a [j].n > x) do dec (j);
    if i<=j then
    begin
      p1 := pos (' ', a [i].n);
      p2 := pos (' ', a [j].n);
      if not ((p1 = p2) and (copy (a [i].n, 1, p1) = copy (a [j].n, 1, p1)) and (a[i].num < a [j].num)) then
        swap (a [i], a [j]);
      inc (i);
      dec (j);
    end;
  end;
  if l < j then sort (l, j);
  if i < r then sort (i, r);
end;

begin
  assign (input, probname + '.in');
  reset (input);
  assign (output, probname + '.out');
  rewrite (output);
  readln (n);
  for i := 1 to n do
  begin
    readln (a [i].n);
    a [i].num := i;
  end;
  sort (1, n);
  writeln (n);
  for i := 1 to n do
    writeln (a [i].n);
  close (input);
  close (output);
end.