#include <stdio.h>
#include <math.h>

#define m 102
#define inf 1000000000.
#define e 1e-8

int l, w[m * m], _stklen = 2 * 1024 * 1024;
double a[m][m], b[m][m];

int main( void )
{
  int i, k, j, n, t;

  freopen("floyd.in", "r", stdin);
  freopen("floyd.out", "w", stdout);
  scanf("%d", &n);
  for (i = 1; i <= n; i++)
    for (j = 1; j <= n; j++)
    {
      scanf("%lf", &a[i][j]);
      if (fabs(a[i][j]) < e)
        a[i][j] = inf;
    }
  for (k = 1; k <= n; k++)
    for (i = 1; i <= n; i++)
      for (j = 1; j <= n; j++)
        if ((a[i][k] < inf - e) && (a[k][j] < inf - e)
            && (a[i][j] > a[i][k] + a[k][j] + e))
          a[i][j] = a[i][k] + a[k][j];
  for (i = 1; i <= n; i++)
    for (j = 1; j <= n; j++)
      b[i][j] = a[i][j];
  for (t = 0; t < 3; t++)
    for (k = 1; k <= n; k++)
      for (i = 1; i <= n; i++)
        for (j = 1; j <= n; j++)
          if ((a[i][k] < inf - e) && (a[k][j] < inf - e)
              && (a[i][j] > a[i][k] + a[k][j] + e))
            a[i][j] = a[i][k] + a[k][j];
  for (k = 1; k <= n; k++)
    for (i = 1; i <= n; i++)
      for (j = 1; j <= n; j++)
        if ((a[i][k] < inf - e) && (a[k][j] < inf - e)
           && (a[k][k] < -e))
          b[i][j] = -inf;
  for (i = 1; i <= n; i++)
  {
    for (j = 1; j <= n; j++)
    {
      if (((a[i][j] >= 10002 - e) && (i != j)))
        printf("0");
      else if (fabs(a[i][j] - b[i][j]) < e)
        printf("1");
      else
        printf("2");
      if (j != n)
        printf(" ");
    }
    printf("\n");
  }
  return 0;
}
