program ooo;
const
  filename  = 'floyd';
  InFile = FileName+'.in';
  OutFile = FileName+'.out';

var
  i, j, k, l,n : longint;
  c, a : array[1..100, 1..100] of Longint;
  b : array[1..100, 1..100] of boolean;


procedure OpenFile;
begin
  assign(input, InFile);
  reset(input);
  readln(n);
  for i:=1 to n do
    begin
    for j:=1 to n do
      read(c[i, j]);
    readln;
    end;
  close(input);
end;

procedure floyd;
var
  i, k, j : integer;
begin
  for k:= 1 to n do
    for j:=1 to n do
      for i:=1 to n do
        if (a[i, k]+ a[k, j])< a[i, j] then
          begin
          a[i, j]:= a[i, k]+ a[k, j];
          end;
end;

procedure floyd2;
var
  i, k, j : integer;
begin
  for k:= 1 to n do
    for j:=1 to n do
      for i:=1 to n do
        if (a[i, k]+ a[k, j])< a[i, j] then
          begin
          a[i, j]:= a[i, k]+ a[k, j];
          b[i, j]:= true;
          end;
end;

procedure Solve;
begin
  for i:= 1 to n do
    for j:=1 to n do
      if c[i, j] = 0 then
        a[i,j]:= MaxLongInt div 4
      else a[i, j]:= c[i, j];
  floyd;
  floyd2;
end;

procedure SaveFile;
begin
  assign(output, OutFile);
  rewrite(Output);
  for i:=1 to n do
    begin
    for j:= 1 to n do
      if a[i, j] > 1000000 then write('0 ')
      else if b[i, j] then write('2 ')
      else write('1 ');
    writeln;
    end;

  close(output);
end;

begin
  OpenFile;
  Solve;
  SaveFile;
end.
