{$A+,B-,D-,E-,F-,G+,I-,L-,N-,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}
   Const File_In='floyd.in';
         File_Out='floyd.out';
         MaxN=100;
         Infinity=MaxLongInt Div 2;
   Type Int=LongInt;
   Var N : Int;
       Map,Answer,MapLast : Array [1..MaxN,1..MaxN] Of Int;
       Ok : Boolean;

Procedure OpenFiles;
Begin
  Assign(Input,File_In);
  ReSet(Input);
  Assign(Output,File_Out);
  ReWrite(Output);
End;

Procedure Init;
  Var I,J : Int;
Begin
  Read(N);
  For I :=1 To N Do
    For J :=1 To N Do
      Begin
        Read(Map[I,J]);
        If Map[I,J]=0 Then Map[I,J] :=Infinity;
      End;
End;

Procedure Solve;
  Var I,J,K : Int;
Begin
  FillChar(Answer,SizeOf(Answer),0);
  For K :=1 To N Do
    For I :=1 To N Do
      For J :=1 To N Do
        If (Map[I,J]>Map[I,K]+Map[K,J]) And (Map[I,K]+Map[K,J]<Infinity Div 2) Then
          Map[I,J] :=Map[I,K]+Map[K,J];
  MapLast :=Map;
  For I :=1 To N Do
    If Map[I,I]<0 Then
      Begin
        Map[I,I] :=-Infinity Div 100000;
        For J :=1 To N Do
          If Map[I,J]<>Infinity Then
            Map[I,J] :=Map[I,I];
      End;
  For Count :=1 To N Do
    For K :=1 To N Do
      For I :=1 To N Do
        For J :=1 To N Do
          If (Map[I,J]>Map[I,K]+Map[K,J]) And (Map[I,K]+Map[K,J]<Infinity Div 2) Then
            Map[I,J] :=Map[I,K]+Map[K,J];
  For I :=1 To N Do
    For J :=1 To N Do
      Begin
        If MapLast[I,J]>=Infinity Div 2 Then Answer[I,J] :=0
        Else If Map[I,J]<MapLast[I,J] Then Answer[I,J] :=2
        Else Answer[I,J] :=1;
      End;
  For I :=1 To N Do
    Begin
      For J :=1 To N Do
        Write(Answer[I,J],' ');
      WriteLn;
    End;
End;

Procedure CloseFiles;
Begin
  Close(Input);
  Close(Output);
End;

Begin
  OpenFiles;
  Init;
  Solve;
  CloseFiles;
End.
