#include <stdio.h>
#include <string.h>

int D[8][8], U[8][8], D1[8][8], D2[8][8];
int Q[128][2], Pos, Len;

void Add( int x, int y, int d )
{
  if (x < 0 || y < 0 || x >= 8 || y >= 8)
    return;
  if (U[y][x])
    return;
  U[y][x] = 1, D[y][x] = d;
  Q[Len][0] = x, Q[Len++][1] = y;
}

int main( void )
{
  char s1[9], s2[9];
  int x1, y1, x2, y2, x, y, d, i, j, min = 99;

  freopen("twohorse.in", "rt", stdin);
  freopen("twohorse.out", "wt", stdout);
  scanf("%s%s", s1, s2);
  x1 = s1[0] - 'a', y1 = s1[1] - '1';
  x2 = s2[0] - 'a', y2 = s2[1] - '1';

  memset(U, 0, sizeof(U));
  memset(D, 0, sizeof(D));
  U[y1][x1] = 1;
  Pos = 0, Len = 1;
  Q[0][0] = x1, Q[0][1] = y1;
  while (Pos < Len)
  {
    x = Q[Pos][0], y = Q[Pos++][1];
    d = D[y][x];
    Add(x + 2, y + 1, d + 1);
    Add(x + 2, y - 1, d + 1);
    Add(x - 2, y + 1, d + 1);
    Add(x - 2, y - 1, d + 1);
    Add(x + 1, y + 2, d + 1);
    Add(x + 1, y - 2, d + 1);
    Add(x - 1, y + 2, d + 1);
    Add(x - 1, y - 2, d + 1);
  }
  memcpy(D1, D, sizeof(D));

  memset(U, 0, sizeof(U));
  memset(D, 0, sizeof(D));
  U[y2][x2] = 1;
  Pos = 0, Len = 1;
  Q[0][0] = x2, Q[0][1] = y2;
  while (Pos < Len)
  {
    x = Q[Pos][0], y = Q[Pos++][1];
    d = D[y][x];
    Add(x + 2, y + 1, d + 1);
    Add(x + 2, y - 1, d + 1);
    Add(x - 2, y + 1, d + 1);
    Add(x - 2, y - 1, d + 1);
    Add(x + 1, y + 2, d + 1);
    Add(x + 1, y - 2, d + 1);
    Add(x - 1, y + 2, d + 1);
    Add(x - 1, y - 2, d + 1);
  }
  memcpy(D2, D, sizeof(D));

  for (i = 0; i < 8; i++)
    for (j = 0; j < 8; j++)
      if (D1[i][j] < min && D2[i][j] < min)
        if (D1[i][j] == D2[i][j])
          min = D1[i][j];
  if (min != 99)
    printf("%d", min);
  else
    printf("-1");
  return 0;
}
