{$q+,r+,n-}

const cinfile = 'maze.in';
      coutfile = 'maze.out';

const nmax = 2000;
      mmax = 10000;
      inf = maxlongint shr 1;

type int = longint;

var n, m : int;
    a : array[1..nmax] of int;
    e : array[1..nmax, 0..3] of int;

procedure init;
var i, j : int;
begin
   read(n, m);
   for i:=1 to m do begin
      for j:=1 to 2 do read(e[i, j]);
      read(e[i, 0]);
      e[i, 0]:=-e[i, 0];
   end;
end;

procedure solve;
var i, j, x, y : int;
begin
   for i:=2 to n do a[i]:=inf;
   a[1]:=0;
   for i:=1 to n-1 do begin
      for j:=1 to m do begin
         x:=e[j, 1];
         y:=e[j, 2];
         if a[x] + e[j, 0] < a[y] then
            a[y]:=a[x] + e[j, 0];
      end;
   end;
end;

procedure writeanswer;
var j : int;
begin
   if a[n] = inf then begin
      write(':(');
      exit;
   end;
   for j:=1 to m do
      if a[e[j, 1]] + e[j, 0] < a[e[j, 2]] then begin
         write(':)');
         exit;
      end;
   write(-a[n]);
end;

begin
   assign(input, cinfile); reset(input);
   assign(output, coutfile); rewrite(output);
   init;
   solve;
   writeanswer;
   close(input); close(output);
end.