#include <stdio.h>
#include <string.h>

#define MAX 253

int VA, VB;
int Is[MAX][MAX], CA[MAX][MAX], PA[MAX];
int UA[MAX], UB[MAX], Pair[MAX];

int dfs( int v )
{
  int i, *cv = CA[v], v1;

  for (i = 0; i < PA[v]; i++)
    if (!UB[v1 = cv[i]])
    {
      Pair[v1] = v;
      UB[v1] = 1;
      UA[v] = 1;
      return 1;
    }
    else
      if (dfs(Pair[v1]))
      {
        Pair[v1] = v;
        UA[v] = 1;
      }
  return 0;
}

int main( void )
{
  int i, j, k, sum = 0;

  memset(Is, 0, sizeof(Is));
  memset(UA, 0, sizeof(UA));
  memset(UB, 0, sizeof(UB));
  memset(PA, 0, sizeof(PA));
  freopen("pairs.in", "rt", stdin);
  freopen("pairs.out", "wt", stdout);
  scanf("%d%d", &VA, &VB);
  for (i = 0; i < VA; i++)
    while (1)
    {
      scanf("%d", &k);
      if (k == 0)
        break;
      k--;
      if (Is[i][k])
        continue;
      CA[i][PA[i]++] = k;
      Is[i][k] = 1;
    }
  for (i = 0; i < VA; i++)
    if (UA[i] == 0)
      dfs(i);
  for (i = 0; i < VA; i++)
    if (UA[i])
      sum++;
  printf("%d\n", sum);
  for (i = 0; i < VA; i++)
  {
    for (j = 0; j < VB; j++)
      if (Pair[j] == i)
        break;
    printf("%d %d\n", i + 1, j + 1);
  }
  return 0;
}
