#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define maxn 500

int n, m, da[maxn], ca[maxn][maxn];
int ma[maxn], mb[maxn], u[maxn];

int dfs( int v )
{
  int i;

  u[v] = 1;
  for (i = 0; i < da[v]; i++)
    if (ca[v][i] != ma[v])
      if (mb[ca[v][i]] == -1 || (mb[ca[v][i]] != -1 && !u[mb[ca[v][i]]] && dfs(mb[ca[v][i]])))
      {
        ma[v] = ca[v][i];
        mb[ca[v][i]] = v;
        return 1;
      }
  return 0;
}

int main( void )
{
  int i, j, t;

  freopen("pairs.in", "rt", stdin);
  freopen("pairs.out", "wt", stdout);
  scanf("%d%d", &n, &m);
  memset(da, 0, sizeof(da));
  for (i = 0; i < n; i++)
    while (scanf("%d", &t) == 1 && t != 0)
      ca[i][da[i]++] = t - 1;
  for (i = 0; i < n; i++)
    ma[i] = -1;
  for (i = 0; i < m; i++)
    mb[i] = -1;
  for (i = 0; i < n; i++)
  {
    memset(u, 0, sizeof(u));
    dfs(i);
  }
  for (i = 0; i < n; i++)
    if (ma[i] != -1)
      printf("%d %d\n", i + 1, ma[i] + 1);
  return 0;
}
