{$I-,Q-,R-,S-}
{$M 1048576,0}
const taskid='maze';
      inf=taskid+'.in';
      ouf=taskid+'.out';
var n,m:longint;
    first,best:array [1..2000] of longint;
    vert,next,weight:array [1..10000] of longint;
    cycle,can:boolean;
procedure addedge(i,j,k,l:longint);
begin
  vert[i]:=k;
  next[i]:=first[j];
  weight[i]:=l;
  first[j]:=i;
end;
procedure init;
var i,j,k,l:longint;
begin
  assign(input,inf);
  reset(input);
  read(n,m);
  fillchar(first,sizeof(first),0);
  for i:=1 to m do
  begin
    read(j,k,l);
    addedge(i,j,k,-l);
  end;
  close(input);
end;
procedure relax(i,j,k:longint);
begin
  if best[i]+k<best[j] then
    best[j]:=best[i]+k;
end;
procedure run;
var i,j,k:longint;
begin
  fillchar(best,sizeof(best),127);
  best[1]:=0;
  for i:=1 to n-1 do
  begin
    for j:=1 to n do
    begin
      k:=first[j];
      while k<>0 do
      begin
        relax(i,vert[k],weight[k]);
        k:=next[k];
      end;
    end;
  end;
  cycle:=false;
  for i:=1 to n do
  begin
    j:=first[i];
    while j<>0 do
    begin
      if best[i]+weight[j]<best[vert[j]] then
        cycle:=true;
      j:=next[j];
    end;
  end;
  can:=true;
  if best[n]>1000000 then
    can:=false;
end;
procedure done;
begin
  assign(output,ouf);
  rewrite(output);
  if not can then
    write(':(')
  else if cycle then
    write(':)')
  else write(-best[n]);
  close(output);
end;
begin
  init;
  run;
  done;
end.
