{$Q-,R-,I-,S-,D-,L-}
Program Template;
{Eva rulezzz!!!}
Type
  Int=Longint;
  Real=Extended;
Const
  FileIn='maze.in';
  FileOut='maze.out';
  MaxN=2001;
  MaxM=10001;
  Inf=100000000;
Var
  E:Array[0..MaxM,1..3] Of Int;
  Dist:Array[0..MaxN] Of Int;
  Used1,Used2:Array[0..MaxN] Of Boolean;
  G:Array[0..MaxN,0..MaxN] Of Boolean;
  N,M:Int;

Procedure OpenFiles;
  Begin
    Assign(Input,FileIn);
    Assign(Output,FileOut);
    Reset(Input);
    Rewrite(Output);
  End;

Procedure Init;
  Var i:Int;
  Begin
    Read(N,M);
    Fillchar(G,Sizeof(G),False);
    For i:=1 To M Do
      Begin
        Read(E[i][1],E[i][2],E[i][3]);
        G[E[i][1]][E[i][2]]:=True;
        E[i][3]:=-E[i][3];
      End;
  End;

Function Relax(i:Int):Boolean;
  Begin
    If Dist[E[i][2]]>Dist[E[i][1]]+E[i][3] Then
      Begin
        Dist[E[i][2]]:=Dist[E[i][1]]+E[i][3];
        Relax:=True;
      End Else Relax:=False;
  End;

Procedure DFS1(x:Int);
  Var i:Int;
  Begin
    Used1[x]:=True;
    For i:=1 To N Do
      If G[x][i] And Not Used1[i] Then DFS1(i);
  End;

Procedure DFS2(x:Int);
  Var i:Int;
  Begin
    Used2[x]:=True;
    For i:=1 To N Do
      If G[i][x] And Not Used2[i] Then DFS2(i);
  End;

Procedure Solve;
  Var i,j:Int;
  Begin
    Fillchar(Used1,Sizeof(Used1),False);
    Fillchar(Used2,Sizeof(Used2),False);
    DFS1(1);DFS2(N);
    For i:=2 To N Do Dist[i]:=Inf;Dist[1]:=0;
    For i:=1 To N Do
      For j:=1 To M Do Relax(j);
    For i:=1 To M Do
      If Relax(i) And Used1[E[i][1]] And Used2[E[i][2]] Then
        Begin
          Writeln(':)');Exit;
        End;
    Dist[N]:=-Dist[N];
    If Dist[N]<-20000000 Then Writeln(':(') Else Writeln(Dist[N]);
  End;

Procedure CloseFiles;
  Begin
    Close(Input);
    Close(Output);
  End;

Begin
  OpenFiles;
  Init;
  Solve;
  CloseFiles;
End.