#include <stdio.h>
#include <string.h>

#define INF2 1000000000
#define INF1 100000000

#define MAX_N 103

int N, D[MAX_N][MAX_N], Is[MAX_N][MAX_N];

int main( void )
{
  int i, j, k;

  memset(Is, 0, sizeof(Is));
  freopen("floyd.in", "rt", stdin);
  freopen("floyd.out", "wt", stdout);
  scanf("%d", &N);
  for (i = 0; i < N; i++)
    for (j = 0; j < N; j++)
      scanf("%d", &D[i][j]);
  for (i = 0; i < N; i++)
    for (j = 0; j < N; j++)
      if (!D[i][j])
        D[i][j] = INF2;
  for (k = 0; k < N; k++)
    for (i = 0; i < N; i++)
      for (j = 0; j < N; j++)
        if (D[i][j] > D[i][k] + D[k][j] && D[i][k] < INF1 && D[k][j] < INF1)
          D[i][j] = D[i][k] + D[k][j];
/*
  for (i = 0; i < N; i++)
  {
    for (j = 0; j < N; j++)
      printf("%d ", D[i][j]);
    printf("\n");
  }
*/
  for (k = 0; k < N; k++)
    for (i = 0; i < N; i++)
      for (j = 0; j < N; j++)
        if (D[i][j] > D[i][k] + D[k][j] && D[i][k] < INF1 && D[k][j] < INF1)
          Is[i][j] = Is[j][i] = 1;
  for (i = 0; i < N; i++)
  {
    for (j = 0; j < N; j++)
      if (Is[i][j])
        printf("2 ");
      else if (D[i][j] >= INF1)
        printf("0 ");
      else
        printf("1 ");
    printf("\n");
  }
  return 0;
}
