#include <stdio.h>
#include <string.h>

#define MAX_N 2003
#define MAX_E 10003

int N, EN, X[MAX_E], Y[MAX_E], W[MAX_E];
int D[MAX_N], U[MAX_N];

int main( void )
{
  int i, j, v1, v2, w;

  memset(D, 0, sizeof(D));
  memset(U, 0, sizeof(U));
  freopen("maze.in", "rt", stdin);
  freopen("maze.out", "wt", stdout);
  scanf("%d%d", &N, &EN);
  for (i = 0; i < EN; i++)
    scanf("%d%d%d", &X[i], &Y[i], &W[i]), X[i]--, Y[i]--, W[i] = -W[i];
  U[0] = 1;
  for (i = 0; i < N; i++)
    for (j = 0; j < EN; j++)
    {
      v1 = X[j], v2 = Y[j];
      w = D[v1] + W[j];
      if (U[v1] && (!U[v2] || D[v2] > w))
        D[v2] = w, U[v2] = 1;
    }
  if (!U[N - 1])
  {
    printf(":(");
    return 0;
  }
  for (j = 0; j < EN; j++)
  {
    v1 = X[j], v2 = Y[j];
    if (U[v1] && (!U[v2] || D[v2] > (w = D[v1] + W[j])))
    {
      printf(":)");
      return 0;
    }
  }
  printf("%d", -D[N - 1]);
  return 0;
}
