{$I-,Q-,R-,S-}

const
  IN_FILE = 'substr.in';
  OUT_FILE = 'substr.out';

  MAXN = 10005;

type
  Integer = Longint;

  TString = AnsiString;

var
  Sub: TString;
  n: Integer;
  p: array[1..MAXN] of Integer;

procedure Init();
var
  Ch: Char;
begin
  Assign(Input, IN_FILE);
  Reset(Input);
  Assign(Output, OUT_FILE);
  Rewrite(Output);

  Sub := '';
  Read(Ch);
  while Ch <> '*' do
  begin
    if not (Ch in [#10, #13, ' ']) then Sub := Sub + Ch;
    Read(Ch);
  end;
  n := Length(Sub);
end;

procedure Prefix();
var
  i: Integer;
  q: Integer;
begin
  p[1] := 0;
  for i := 2 to n do
  begin
    q := p[i - 1];
    while (q > 0) and (Sub[q + 1] <> Sub[i]) do q := p[q];
    if Sub[q + 1] = Sub[i] then p[i] := q + 1 else
      p[i] := q;
  end;
end;

function ReadChar(var Ch: Char): Boolean;
begin
  Read(Ch);
  while (Ch in [#10, #13, ' ']) do Read(Ch);
  if Ch = #26 then
  begin
    ReadChar := False;
    Exit;
  end;
  ReadChar := True;
end;

procedure Solve();
var
  Ch: Char;
  d, q: Integer;
begin
  Prefix();

  q := 0;
  d := 0;
  while ReadChar(Ch) do
  begin
    Inc(d);
    while (q > 0) and (Ch <> Sub[q + 1]) do q := p[q];
    if Ch = Sub[q + 1] then Inc(q);
    if q = n then
    begin
      Writeln(d - n + 1);
      q := p[q];
    end;
  end;
end;

procedure Done();
begin
  Close(Input);
  Close(Output);
end;

begin
  Init();
  Solve();
  Done();
end.
