{$A+,B-,D+,E-,F-,G+,I+,L+,N+,O-,P-,Q+,R+,S+,T-,V+,X+,Y+}
{$M 16384,0,655360}
const
  prob='floyd';
  fin =prob+'.in';
  fout=prob+'.out';
  maxn=200;

var
  i,j,k,l,n,m:longint;
  c:array[0..maxn]of longint;
  a,b,d:array[0..maxn,0..maxn]of longint;

procedure init;
begin
  assign(input,fin);
  reset(input);

    read(n);
    for i:=1 to n do
      for j:=1 to n do
        read(a[i,j]);

  close(input);
end;

procedure dfs(i:longint);
var
  j:longint;
begin
  c[i]:=1;
  for j:=1 to n do
    if (a[i,j]<>0)and(c[j]=0) then
      dfs(j);
end;

procedure solve;
begin
  b:=a;
  for i:=1 to n do
    for j:=1 to n do
      if b[i,j]=0 then
        b[i,j]:=maxlongint div 3;
  for i:=1 to n do
    if a[i,i]>0 then
      a[i,i]:=0;
  for k:=1 to n do
    for i:=1 to n do
      for j:=1 to n do
        if b[i,j]>b[i,k]+b[k,j] then
          b[i,j]:=b[i,k]+b[k,j];

  for i:=1 to n do
    if b[i,i]<0 then begin
      fillchar(c,sizeof(c),0);
      dfs(i);
      for j:=1 to n do
        if c[j]=1 then
          d[i,j]:=2;
    end;

  for i:=1 to n do
    for j:=1 to n do
      if d[i,j]<>2 then
        if b[i,j]>1000000 then
          d[i,j]:=0
        else
          d[i,j]:=1;
end;

procedure done;
begin
  assign(output,fout);
  rewrite(output);

    for i:=1 to n do begin
      for j:=1 to n do
        write(d[i,j],' ');
      writeln;
    end;

  close(output);
end;

begin
  init;
  solve;
  done;
end.