{$ifdef DEBUG}
  {$I+,Q+,R+,S-}
{$else}
  {$I-,Q-,R-,S-}
{$endif}

program Temp;
const infile = 'pairs.in';
      outfile = 'pairs.out';
      MAXN = 250;
      MAXM = 250;
var f : array[0..MAXN] of boolean;
    B : array[0..MAXM] of integer;
    G : array[1..MAXN, 1..MAXM] of boolean;
    M, N : integer;

procedure ReadData;
var i : integer;
    k : integer;
begin
  fillchar(G, sizeof(G), false);
  assign(input, infile); reset(input);
  assign(output, outfile); rewrite(output);
  read(N, M);
  for i:=1 to N do begin
    read(k);
    while k<>0 do begin
      G[i, k]:=true;
      read(k);
    end;
  end;
end;

function DFS(x : integer) : boolean;
var j : integer;
begin
  if x=0 then begin DFS:=true; exit; end;
  f[x]:=true;
  for j:=1 to M do
    if (not f[B[j]])and(G[x, j])and(DFS(B[j])) then begin
      B[j]:=x;
      DFS:=true;
      exit;
    end;
  DFS:=false;
end;

procedure Solve;
var i, cnt, cur : integer;
begin
  fillchar(B, sizeof(B), 0); cnt:=0;
  for i:=1 to N do begin
    fillchar(f, sizeof(f), false);
    if DFS(i) then inc(cnt);
  end;
  writeln(cnt); cur:=0;
  for i:=1 to M do
    if B[i]<>0 then begin
      inc(cur);
      write(B[i], ' ', i);
      if cur<cnt then writeln;
    end;
end;

procedure WriteData;
begin
  close(input);
  close(output);
end;

begin
  ReadData;
  Solve;
  WriteData;
end.
