{$I-,Q-,R-,S-}
{$M 1048576,0}
const taskid='maze';
      inf=taskid+'.in';
      ouf=taskid+'.out';
var n,m:longint;
    first,best,last,ww:array [1..2000] of longint;
    vert,next,weight:array [1..10000] of longint;
    cycle,can:boolean;
procedure addedge(i,j,k,l:longint);
begin
  vert[i]:=k;
  next[i]:=first[j];
  weight[i]:=l;
  first[j]:=i;
end;
procedure init;
var i,j,k,l:longint;
begin
  assign(input,inf);
  reset(input);
  read(n,m);
  fillchar(first,sizeof(first),0);
  for i:=1 to m do
  begin
    read(j,k,l);
    addedge(i,j,k,-l);
  end;
  close(input);
end;
procedure relax(i,j,k:longint);
begin
  if best[i]>1000000000 then
    exit;
  if best[i]+k<best[j] then
  begin
    best[j]:=best[i]+k;
    last[j]:=i;
    ww[j]:=k;
  end;
end;
procedure run;
var i,j,k,cur:longint;
begin
  fillchar(best,sizeof(best),127);
  best[1]:=0;
  for i:=1 to n do
  begin
    for j:=1 to n do
    begin
      k:=first[j];
      while k<>0 do
      begin
        relax(j,vert[k],weight[k]);
        k:=next[k];
      end;
    end;
  end;
  cycle:=false;
  cur:=n;
  while last[cur]<>0 do
  begin
    if best[last[cur]]+ww[cur]<best[cur] then
      cycle:=true;
    cur:=last[cur];
  end;
  can:=true;
  if best[n]>1000000000 then
    can:=false;
end;
procedure done;
begin
  assign(output,ouf);
  rewrite(output);
  if not can then
    write(':(')
  else if cycle then
    write(':)')
  else write(-best[n]);
  close(output);
end;
begin
  init;
  run;
  done;
end.
