{$I-,Q-,R-,S-}

const
  IN_FILE = 'cicle.in';
  OUT_FILE = 'cicle.out';

  MAXN = 115;

  INFINITE = 100000;

type
  Integer = Longint;

var
  n: Integer;
  Start: Integer;
  a, b, c: array[1..MAXN, 1..MAXN] of Integer;
  NNew: array[1..MAXN] of Integer;
  Ans: array[0..MAXN] of Integer;
  Queue: array[1..MAXN * MAXN] of Integer;
  ras: array[1..MAXN] of Integer;
  Vis: array[1..MAXN] of Boolean;

procedure Init();
var
  i, j: Integer;
begin
  Assign(Input, IN_FILE);
  Reset(Input);
  Assign(Output, OUT_FILE);
  Rewrite(Output);
  Read(n);
  for i := 1 to n do
    for j := 1 to n do
      Read(a[i, j]);

  b := a;
end;

procedure Done();
begin
  Close(Input);
  Close(Output);
end;

procedure Print();
var
  i: Integer;
begin
  Writeln('YES');
  Writeln(Ans[0]);
  for i := 1 to Ans[0] do Write(Ans[i], ' ');
end;


{procedure Dfs(const k, v: Integer);
var
  i: Integer;
begin
  Inc(Ans[0]);
  Ans[Ans[0]] := k;
  NNew[k] := True;

  for i := 1 to n do
    if b[k, i] < INFINITE then
    begin
      if (i = Start) and (v + b[k, i] < 0) then
      begin
        Inc(Ans[0]);
        Ans[Ans[0]] := Start;
        Print();
        Done();
        Halt;
      end;

      if not NNew[i] then Dfs(i, v + b[k, i]);
    end;

  Dec(Ans[0]);
end;}

procedure Rec(const k: Integer);
begin
  if Vis[k] then
  begin
    Inc(Ans[0]);
    Ans[Ans[0]] := k;
    Exit;
  end;

  Vis[k] := True;
  Rec(Ras[k]);
  Inc(Ans[0]);
  Ans[Ans[0]] := k;
end;

procedure Bfs(const k: Integer);
var
  l, r, Link: Integer;
  i, j: Integer;
begin
  Queue[1] := k;
  l := 1;
  r := 1;
  Link := 1;

  for i := 1 to n do NNew[i] := INFINITE;
  NNew[k] := 0;

  while (l <= r) do
  begin
    if NNew[k] < 0 then
    begin
      Rec(k);
      Print();
      Done();
      Halt;
    end;
    for i := l to r do
    begin
      for j := 1 to n do
        if b[Queue[i], j] < INFINITE then
          if NNew[Queue[i]] + b[Queue[i], j] < NNew[j] then
          begin
            Inc(Link);
            NNew[j] := NNew[Queue[i]] + b[Queue[i], j];
            Queue[Link] := j;
            ras[j] := Queue[i];
          end;
    end;

    l := r + 1;
    r := Link;
  end;


end;

procedure Solve();
var
  k, i, j: Integer;
begin
  for k := 1 to n do
    for i := 1 to n do
      for j := 1 to n do if (a[i, k] < INFINITE) and (a[k, j] < INFINITE) then
        if a[i, j] > a[i, k] + a[k, j] then
        begin
          a[i, j] := a[i, k] + a[k, j];
          c[i, j] := k;
        end;

  for i := 1 to n do
  begin
    Start := i;
    if a[i, i] < 0 then Bfs(i);
  end;

  Writeln('NO');
end;

begin
  Init();
  Solve();
  Done();
end.
