{$A+,B-,D+,E-,F-,G+,I+,L+,N+,O-,P-,Q+,R+,S+,T-,V+,X+,Y+}
{$M 16384,0,655360}
const
  prob='floyd';
  fin =prob+'.in';
  fout=prob+'.out';
  maxn=50;

var
  i,j,k,l,n,m,q:longint;
  a,b,c,d:array[0..maxn,0..maxn]of longint;

procedure init;
begin
  assign(input,fin);
  reset(input);

    read(n);
    for i:=1 to n do
      for j:=1 to n do
        read(a[i,j]);

  close(input);
end;

procedure solve;
begin
  b:=a;
  for i:=1 to n do
    for j:=1 to n do
      if b[i,j]=0 then
        b[i,j]:=maxlongint div 3;
  for i:=1 to n do
    if a[i,i]>0 then
      a[i,i]:=0;
  for k:=1 to n do
    for i:=1 to n do
      for j:=1 to n do
        if b[i,j]>b[i,k]+b[k,j] then
          b[i,j]:=b[i,k]+b[k,j];

  c:=b;

  for k:=1 to n do
    for i:=1 to n do
      for j:=1 to n do
        if (c[i,j]>c[i,k]+c[k,j])and(c[i,k]<1000000)and(c[k,j]<1000000) then
          c[i,j]:=c[i,k]+c[k,j];

  for i:=1 to n do
    for j:=1 to n do
      if (c[i,j]<b[i,j])and(c[i,j]<1000000) then
        d[i,j]:=2;

  for i:=1 to n do
    for j:=1 to n do
      if d[i,j]<>2 then
        if (b[i,j]<1000000)or(i=j) then
          d[i,j]:=1
        else
          d[i,j]:=0;
end;

procedure done;
begin
  assign(output,fout);
  rewrite(output);

    for i:=1 to n do begin
      for j:=1 to n do
        write(d[i,j],' ');
      writeln;
    end;

  close(output);
end;

begin
  init;
  solve;
  done;
end.