program ZB;

{$APPTYPE CONSOLE}

var
  minx, miny, i, j, N, ss: longint;
  x, y: array [1..20000] of longint;
  s: array [0..20000] of longint;

function VectorMul(x1, y1, x2, y2: longint): longint;
begin
  VectorMul:=x1*y2-x2*y1;
end;

procedure QSort(r, s: integer);
var
  i, j, x0, y0: integer;
procedure Swap(i, j: integer);
begin
  if i=j then exit;
  x[i]:=x[i] xor x[j];
  x[j]:=x[i] xor x[j];
  x[i]:=x[i] xor x[j];
  y[i]:=y[i] xor y[j];
  y[j]:=y[i] xor y[j];
  y[i]:=y[i] xor y[j];
end;
begin
  if r>=s then
    exit;
  i:=r;
  j:=s;
  x0:=x[(i+j) div 2];
  y0:=y[(i+j) div 2];
  while i<j do
  begin
    while (VectorMul(x0, y0, x[i], y[i])<0) or ((VectorMul(x0, y0, x[i], y[i])=0) and ((x0>x[i]) or (y0>y[i]))) do
      inc(i);
    while (VectorMul(x0, y0, x[j], y[j])>0) or ((VectorMul(x0, y0, x[j], y[j])=0) and ((x0<x[j]) or (y0<y[j]))) do
      dec(j);
    Swap(i, j);
  end;
  QSort(r, i);
  QSort(i+1, s);
end;

begin
  Assign(input, 'convex.in');
  Assign(output, 'convex.out');
  Reset(input);
  Rewrite(output);
  ReadLn(N);
  Read(minx, miny);
  x[1]:=minx;
  y[1]:=miny;
  for i:=2 to N do
  begin
    ReadLn(x[i], y[i]);
    if (x[i]<minx) or ((x[i]=minx) and (y[i]<miny)) then
    begin
      minx:=x[i];
      miny:=y[i];
    end;
  end;
  for i:=1 to N do
  begin
    dec(x[i], minx);
    dec(y[i], miny);
  end;
  QSort(1, N);
  ss:=1;
  s[0]:=1;
  s[1]:=1;
  for j:=2 to N do
  begin
    while (ss<>1) and (VectorMul(x[s[ss]]-x[s[ss-1]], y[s[ss]]-y[s[ss-1]], x[s[ss]]-x[j], y[s[ss]]-y[j])>=0) do
      dec(ss);
    inc(ss);
    s[ss]:=j;
  end;
  WriteLn(ss);
  if (ss mod 2)=0 then
    for i:=1 to ss do
      WriteLn(x[s[i]], ' ', y[s[i]])
  else
    for i:=ss downto 1 do
      WriteLn(x[s[i]], ' ', y[s[i]]);
  Close(input);
  Close(output);
end.
