{$q+,r+,n-}

const cinfile = 'floyd.in';
      coutfile = 'floyd.out';

const nmax = 101;
      inf = maxlongint shr 1;

type int = longint;

var d, a : array[1..nmax, 1..nmax] of int;
    n : int;

procedure init;
var i, j : int;
begin
   read(n);
   for i:=1 to n do
      for j:=1 to n do begin
         read(d[i, j]);
         if d[i, j] = 0 then d[i, j]:=inf;
         a[i, j]:=d[i, j];
      end;
end;

procedure solve;
var i, j, k : int;
begin
   for k:=1 to n do
      for i:=1 to n do
         for j:=1 to n do
            if d[i, j] > d[i, k] + d[k, j] then begin
               d[i, j]:=d[i, k] + d[k, j];
            end;
end;

procedure writeanswer;
var i, j, k, ans : int;
begin
   for i:=1 to n do begin
      for j:=1 to n do begin
         if d[i, j] > 100000 then ans:=0
         else begin
            ans:=1;
            for k:=1 to n do
               if d[i, k] + d[k, j] < d[i, j] then begin
                  ans:=2;
                  break;
               end;
         end;
         write(ans, ' ');
      end;
      writeln;
   end;
end;

begin
   assign(input, cinfile); reset(input);
   assign(output, coutfile); rewrite(output);
   init;
   solve;
   writeanswer;
   close(input); close(output);
end.