const
     FileIn='cicle.in';
     FileOut='cicle.out';
     MaxN=100;
     MaxAnswerLength=MaxN*MaxN;
var
   N: LongInt;
   A: array [1..MaxN, 1..MaxN] of LongInt;
   Connected: array [1..MaxN, 1..MaxN] of Boolean;
   AnswerLength: LongInt;
   Answer: array [1..MaxAnswerLength] of LongInt;
   Yes: Boolean;

procedure ReadData;
var
   F: Text;
   X, Y: LongInt;
begin
     Assign (F, FileIn);
     Reset (F);
     Readln (F, N);
     for X:=1 to N
         do for Y:=1 to N
                do Read (F, A [X, Y]);
     Close (F);
end;

procedure WriteData;
var
   F: Text;
   Index: LongInt;
begin
     Assign (F, FileOut);
     Rewrite (F);
     if Yes
        then begin
             Writeln (F, 'YES');
             Writeln (F, AnswerLength);
             for Index:=AnswerLength downto 1
                 do Write (F, Answer [Index], #32);
             Writeln (F);
        end
        else Writeln (F, 'NO');
     Close (F);
end;

var
   States: array [1..MaxN] of LongInt;
   Distances: array [1..MaxN] of LongInt;
   Top: LongInt;
   Stack: array [1..MaxN*MaxN] of LongInt;

procedure DFS (aNode: LongInt);
var
   Node: LongInt;
begin
     States [aNode]:=1;
     Inc (Top);
     Stack [Top]:=aNode;
     for Node:=1 to N
         do if Connected [aNode, Node]
               then case States [Node] of
                         0: begin
                                 Distances [Node]:=Distances [aNode]+A [Node, aNode];
                                 DFS (Node)
                            end;
                         1: if Distances [Node]>Distances [aNode]+A [Node, aNode]
                               then begin
                                    AnswerLength:=1;
                                    Answer [AnswerLength]:=Node;
                                    while Top>0
                                          do begin
                                             Inc (AnswerLength);
                                             Answer [AnswerLength]:=Stack [Top];
                                             if Stack [Top]=Node
                                                then Break;
                                             Dec (Top);
                                          end;
                                    Yes:=true;
                                    WriteData;
                                    Halt;
                               end;
                         2:;
               end;
     States [aNode]:=2;
     Dec (Top);
end;

procedure Solve;
var
   X, Y: LongInt;
   StartNode: LongInt;
begin
     for X:=1 to N
         do for Y:=1 to N
                do COnnected [X, Y]:=A [X, Y]<>100000;
     AnswerLength:=0;
     for StartNode:=1 to N
         do begin
            FillChar (States, SizeOf (States), 0);
            FillChar (Distances, SizeOf (Distances), 0);
            DFS (StartNode)
         end;
     Yes:=false;
end;

begin
     ReadData;
     Solve;
     WriteData;
end.
