#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

#define inpfile "cards.in"
#define outfile "cards.out"

const int NMAX = 1005;

int a[NMAX];
int res;

void Init()
{
	freopen(inpfile,"r",stdin);
	freopen(outfile,"w",stdout);
}

void Out()
{
	printf("%d\n",res);
	exit(0);
}

bool Check(int x)
{
	int i = a[0] + 1;
	int y;

	while (x) {
		y = x % 10;
		for (i--; (a[i] != y) && (i); i--);
		if (!i) return false;
		x /= 10;
	}
	return true;
}

void Solve()
{
	for (res = 0; Check(res); res++);
}

void Inp()
{
	char ch;
	
	memset(a,0,sizeof(a));	
	while ((scanf("%c",&ch) == 1) && ('0' <= ch) && (ch <= '9')) {
		a[0]++;
		a[a[0]] = ch - '0';
	}
}

int main()
{
	Init();
	Inp();
	Solve();
	Out();
	return 0;
}
