#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

#define inpfile "cards.in"
#define outfile "cards.out"

const int NMAX = 1005;

int a[NMAX];
int res;

void Init()
{
	freopen(inpfile,"r",stdin);
	freopen(outfile,"w",stdout);
}

void Out()
{
	exit(0);
}

bool Check(int x)
{
	int i = a[0] + 1;
	int y;

	while (x) {
		y = x % 10;
		for (i--; (a[i] != y) && (i); i--);
		if (!i) return false;
		x /= 10;
	}
	return true;
}

void Solve()
{
	bool u[10];
	int i,cnt,num;
	int an;
	an = a[0];

	memset(u,0,sizeof(u));

	cnt = 0; num = 0;
	for (i = a[0]; i; i--) {
		if (!u[a[i]]) {
			u[a[i]] = true;
			cnt++;

			if (cnt == 10) {
				cnt = 0;
				memset(u,0,sizeof(u));
				a[0] = i - 1;
				num++;
			}
		}
	}

	if (num <= 6) {
		a[0] = an;
		for (res = 0; Check(res); res++);
		printf("%d\n",res);
		return;
	}

	for (res = 1; Check(res); res++);
	printf("%d",res);
	for (i = 1; i <= num; i++) printf("0");
	printf("\n");
}

void Inp()
{
	char ch;
	
	memset(a,0,sizeof(a));	
	while ((scanf("%c",&ch) == 1) && ('0' <= ch) && (ch <= '9')) {
		a[0]++;
		a[a[0]] = ch - '0';
	}
}

int main()
{
	srand(8763);
	Init();
	Inp();
	Solve();
	Out();
	return 0;
}
