#include <stdio.h>
#include <memory.h>

#define MAXN 1024
#define FALSE 0
#define TRUE 1
#define MAX 1000000
#define MAXTAKED 5

int number[MAXN];
int len;
int used[MAX];

void read ()
{
  char token;
  len=0;
  token=getchar ();
  while (token<=32 || token>=127) token=getchar ();
  while (token>32 && token < 127)
    {
      number[len++]=token-'0';
      token=getchar ();
    }
}

void fill (long uk, int taked, long cur)
{
  long lcur=cur;
  if (uk==len)
    {
      used[cur]=TRUE;
      return;
    }
  if (taked>MAXTAKED) return;
  cur=cur*10+number[uk];
  fill (uk+1, taked+1, cur);
  cur=lcur;
  fill (uk+1, taked, cur);
}

int main ()
{
  long i;
  freopen ("cards.in", "r", stdin);
  freopen ("cards.out", "w", stdout);

  read ();
  memset (used, FALSE, sizeof (used));
  fill (0, 0, 0);

  for (i=0; i<MAX; i++)
    if (!used[i])
    {
      printf ("%ld", i);
      return 0;
    }

  printf ("%ld", i+1);
  return 0;
}
