#include <stdio.h>
#include <memory.h>

#define MAXN 1024
#define FALSE 0
#define TRUE 1
#define MAX 2000000

int number[MAXN];
int len;
int min[MAXN], mlen;

void read ()
{
  char token;
  len=0;
  token=getchar ();
  while (token<=32 || token>=127) token=getchar ();
  while (token>32 && token < 127)
    {
      number[len++]=token-'0';
      token=getchar ();
    }
}

int can (long uk, long depth, long mlen)
{
  int i;
  if (uk==len) return TRUE;
  if (mlen==depth) return TRUE;
  for (i=uk; i<len; i++)
    {
      if (number[i]==min[depth])
          return can (i+1, depth+1, mlen);
    }
  return FALSE;
}

int check (long a)
{
  int c;
  int i;
  mlen=0;
  while (a!=0)
    {
      c=a%10;
      min[mlen++]=c;
      a/=10;
    }
  for (i=0; i<mlen/2; i++)
    {
      c=min[i]; min[i]=min[mlen-i-1]; min[mlen-i-1]=c;
    }
  return can (0, 0, mlen);
}

int main ()
{
  long i;
  freopen ("cards.in", "r", stdin);
  freopen ("cards.out", "w", stdout);

  read ();

  for (i=1; i<MAX; i++)
    {
      if (!check (i))
      {
        printf ("%ld", i);
        return 0;
      }
    }
  printf ("%ld", i+1);
  return 0;
}

