#include <stdio.h>
#include <string.h>

#define m 1010

int n, is[10], f[m][m], al, ans[m], mi[m], ma[m], av[m], ne[m][10];
char s[m];

int issub( int *a )
{
  int i, j;

  for (i = m - 1; i && !a[i]; i--)
    ;
  for (j = 0; j < n && i >= 0; j++)
    if (a[i] == s[j] - '0')
      i--;
  return i < 0;
}

int pos( int *a )
{
  int i, j, k, st, z;

  if (!issub(a))
    return 0;
  for (i = m - 1; i && !a[i]; i--)
    ;
  st = i;
  for (j = -1; j < n && i >= 0; i--)
  {
    if (a[i] == 0)
      ;
    else if (a[i] == 1 && i == st)
    {
      if (!f[i][j + 1])
        return 0;
    }
    else
    {
      if (j >= n - 1)
        return 0;
      for (z = a[i] - 1; z >= 0; z--)
      {
        if (z == 0 && i == st)
          continue;
        k = ne[j + 1][z];
        if (i == 0)
        {
          if (k == -1)
            return 0;
        }
        else if (k == -1 || k == n - 1 || !f[i][k + 1])
          return 0;
      }
    }
    if (j >= n - 1)
      return 0;
    j = ne[j + 1][a[i]];
    if (j == -1)
      return 0;
  }
  return 1;
}

void add( int *c, int *a, int *b )
{
  int i;

  for (i = 0; i < m; i++)
    c[i] = a[i] + b[i];
  for (i = 0; i < m; i++)
    if (c[i] >= 10)
      c[i] -= 10, c[i + 1]++;
}

void shr( int *a )
{
  int i;

  for (i = m - 1; i > 0; i--)
    a[i - 1] += 10 * (a[i] & 1), a[i] >>= 1;
  a[0] >>= 1;
}

void inc( int *a )
{
  int i;

  for (a[0]++, i = 0; i < m; i++)
    if (a[i] >= 10)
      a[i] -= 10, a[i + 1]++;
}

void dec( int *a )
{
  int i;

  for (a[0]--, i = 0; i < m; i++)
    if (a[i] < 0)
      a[i] += 10, a[i + 1]--;
}

int cmp( int *a, int *b )
{
  int i;

  for (i = m - 1; i >= 0; i--)
    if (a[i] != b[i])
      return a[i] - b[i];
  return 0;
}

void print( int *a )
{
  int i;

  for (i = m - 1; i && !a[i]; i--)
    ;
  printf("%d", a[i--]);
  while (i >= 0)
    printf("%d", a[i--]);
}

int main( void )
{
  int i, j, t, k;

  freopen("cards.in", "rt", stdin);
  freopen("cards.out", "wt", stdout);
  scanf("%s", s), n = strlen(s);
  if (!strcmp(s, "1"))
  {
    printf("2");
    return 0;
  }
  memset(is, 0, sizeof(is)), t = 0;
  for (i = n - 1; i >= 0; i--)
  {
    if (!is[s[i] - '0'])
      t++, is[s[i] - '0'] = 1;
    f[1][i] = t == 10;
  }
  for (i = 2; i <= n; i++)
  {
    memset(is, -1, sizeof(is));
    for (j = n - 1; j > 0; j--)
    {
      is[s[j] - '0'] = t = j;
      for (k = 0; k < 10; k++)
        if (is[k] == -1)
          break;
        else if (is[k] > t)
          t = is[k];
      if (k == 10 && t < n - 1 && f[i - 1][t + 1])
        f[i][j] = 1;
    }
  }
  for (i = 0; i < n; i++)
    for (j = 0; j < 10; j++)
      for (ne[i][j] = -1, k = n - 1; k >= i; k--)
        if (s[k] == j + '0')
          ne[i][j] = k;
  memset(mi, 0, sizeof(mi)), mi[0] = 1;
  for (i = 0; i < n; i++)
    ma[n - i - 1] = s[i] - '0';
  inc(ma);
  while (cmp(mi, ma))
  {
    add(av, mi, ma);
    shr(av);
    if (pos(av))
      memcpy(mi, av, sizeof(av)), inc(mi);
    else
      memcpy(ma, av, sizeof(av));
  }
  while (pos(mi) || issub(mi))
    inc(mi);
  print(mi);
  return 0;
}
