{$O-}
program Cards;
uses
  sysutils;

const
     in_file='cards.in';
     out_file='cards.out';

function can(const a,b:int64):boolean;
var s1,s2:string;
    i,j:integer;
    res:boolean;
begin
    s1:=inttostr(a);
    s2:=inttostr(b);
    i:=1; j:=1;
    while (i<=length(s1)) and (j<=length(s2)) do
    begin
       if s1[i]=s2[j] then begin inc(j); inc(i); end else inc(i);
    end;
    if j>length(s2) then Result:=true else Result:=false;
end;

var cur:int64;
function rec(const l,r:int64):int64;
var i,j,mid,t:int64;
begin
    i:=l; j:=r;
    while i<j do
    begin
       mid:=(i+j)div 2;
       if can(cur,mid) then
       begin
          t:=rec(i,mid-1);
          if t=0 then i:=mid+1 else begin rec:=t; j:=t; end;
       end else j:=mid;
    end;
    if can(cur,j) then rec:=0 else rec:=j;
end;

var
    answer:int64;
begin
   assign(input,in_file); reset(input);
   readln(input,cur);
   close(input);
   answer:=rec(1,cur+1);
   assign(output,out_file); rewrite(output);
   write(answer);
   close(output);
end.
