#include <cstdio>
#include <cstring>
#include <queue>

using namespace std;

/*int
trim(char *b)
{
	int l = strlen(b);
	for (int i=l-1; i>=0; i--)
	{
		if ('\x0a' == b[i] || '\x0d' == b[i] || ' ' == b[i] || '\t' == b[i])
		{
			b[i]='\0';
			l--;
		}
		else
			break;
	}
	return l;
}*/

struct vertex
{
	short links[10];
	short from;
	bool grey;

	vertex()
	{
		for (int j=0; j<10; j++) links[j] = -1;
		from=-1;
		grey = false;
	}
};

int
main()
{
	int i,k,len;
	short li;
	char buf[1010];
	vertex v[1010];
	queue<int> Q;

	FILE *f = fopen ("cards.in", "r");
	//fgets(buf, 1005, f);
	//int len = trim(buf);
	int c0 = int('0');
	int c9 = int('9');
	int state = 0;
	for (len=0; len<1005;)
	{
		int fg = fgetc(f);

		if (!state)
		{
			if (fg>=c0 && fg<=c9)
			{
				buf[len]=char(fg);
				state = 1;
				len++;
			}
		}
		else
		{
			if (!(fg>=c0 && fg<=c9)) break;
			buf[len] = char(fg);
			len++;
		}
        
	}
	fclose (f);

    buf[len]='\0';	
	//printf ("'%s'\n", buf);
	
	for (i=len; i>=0; i--)
	{
		for (k=i+1; k<=len; k++)
		{
			li = buf[k-1] - '0';
			if (-1 == v[i].links[li])
				v[i].links[li] = k;
		}
	}

	/*for (i=0; i<=len; i++)
	{
		for (k=0; k<10; k++)
			printf ("%i ", int(v[i].links[k]));
		printf ("\n");
	}*/

	Q.push(0);

	bool found = false;
	int q;

	for(;;)
	{
		q = Q.front();
		Q.pop();
		//printf ("popped %i\n", q);

		for (i=(q?0:1); i<10; i++)
		{
			if (-1 == v[q].links[i])
			{
				//printf ("found %i\n", q);
				found = true;
				break;
			}
			else
			{
				if (!v[v[q].links[i]].grey)
				{
					//printf ("pushed %i\n", v[q].links[i]);
					v[v[q].links[i]].from = q;
					v[v[q].links[i]].grey = true;
					Q.push(v[q].links[i]);
				}
			}
		}

		if (found) break;
	}

	char final = i+'0';

	int ans[1010];
		
	for (i=0;;i++)
	{
		if (-1 == v[q].from) break;
        ans[i] = q;
		//printf ("%i ", q);
		q = v[q].from;
	}

	f = fopen ("cards.out", "w");
	for (i--;i>=0; i--)
	{
		fprintf (f, "%c", buf[ans[i]-1]);
	}
	fprintf (f, "%c", final);
	fclose(f);

	return 0;
}
