{$APPTYPE CONSOLE}
const
  MaxN = 1000;
  MaxM = 120;
type
  num = array[1..MaxN] of char;
  str = string[MaxM];
  MyArray = array[1..MaxN + 1, '0'..'9'] of str;
  MyArray2 = array[1..MaxN + 1] of char;
var
  S : num;
  N : longint;
  A : MyArray;
  min : MyArray2;
  minimum : char;

procedure Init;
begin
  N := 0;
  while not seekeoln(input) do
   begin
    inc(N);
    read(S[N]);
   end;
end;

function less(S1, S2 : str) : boolean;
var
  i : longint;

function ok : boolean;
begin
  if i = (length(S1) + 1) then
    ok := false
   else
    ok := (S1[i] = S2[i]);
end;

begin
  if length(S1) < length(S2) then
    less := true
  else
    if length(S1) > length(S2) then
      less := false
    else
     begin
      i := 1;
      while ok do
        inc(i);
      if (i = length(S1) + 1) then
        less := false
      else
        less := (S1[i] < S2[i]);
     end;
end;

procedure Solve;
var
  ch : char;
  i : longint;

function ok: boolean;
begin
  if minimum = '!' then
    ok := true
  else
    ok := less(A[i, ch], A[i, minimum]);
end;

begin
  for ch := '0' to '9' do
    A[N + 1, ch] := ch;
  min[N + 1] := '0';
  for i := N downto 1 do
   begin
    minimum := '!';
    for ch := '0' to '9' do
     begin
      if ch <> S[i] then
        A[i, ch] := A[i + 1, ch]
      else
        A[i, ch] := ch + A[i + 1, min[i + 1]];
      if ok then
        minimum := ch;
     end;
    min[i] := minimum;
   end;
  minimum := '!';
  i := 1;
  for ch := '1' to '9' do
    if ok then
      minimum := ch;
end;

procedure Print;
begin
  write(A[1, minimum]);
end;

begin
  assign(input, 'cards.in');
  reset(input);
  Init;
  close(input);
  Solve;
  assign(output, 'cards.out');
  rewrite(output);
  Print;
  close(output);
end.
