{$apptype console}
{$q+,r+,n-,o+}

{
    "binary search" in originaly unsorted list of names
}

const cinfile = 'fur.in';
      coutfile = 'fur.out';

const nmax = 1011;
      lmax = 2011;
      inf = maxlongint shr 1;

type int = longint;

var s : array[0..nmax, 1..lmax] of char;
    len : array[0..nmax] of int;

    ak : array[1..23] of int;
    d : array[1..nmax, 1..nmax] of int;
    r : array[1..nmax] of int;
    way : array[1..nmax] of int;
    use : array[1..nmax] of byte;
    n, k : int;

procedure init;
var i : int;
    c : char;
begin
   read(n);
   for i:=1 to n do begin
      repeat
         read(c);
      until c in ['a'..'z'];
      len[i]:=0;
      repeat
         inc(len[i]);
         s[i][len[i]]:=c;
         read(c);
      until not (c in ['a'..'z']);
      s[i][len[i] + 1]:=pred('a');
   end;
   read(k);
   inc(k);
   ak[1]:=1;
   for i:=2 to k do begin
      read(ak[i]);
   end;
end;

function diff(x, y : int) : int;
var i, stop : int;
begin
   if (len[x] < len[y]) then stop:=len[x] else stop:=len[y];
   inc(stop);
   for i:=1 to stop do
      if (s[x][i] <> s[y][i]) then begin
         diff:=ord(s[x][i]) - ord(s[y][i]);
         exit;
      end;
   diff:=0;
end;

function comm(x, y : int) : int;
var i : int;
begin
    i:=1;
    while (s[x][i] <> pred('a')) do begin
        if (s[x][i] <> s[y][i]) then break;
        inc(i);
    end;
    dec(i);
    comm:=i;
end;

procedure create_graph;
var i, j, l, r, t, tmp : int;
begin
    for i:=1 to n do
        for j:=1 to n do d[i][j]:=inf;

    for i:=1 to n do begin
        for j:=1 to n do if (i <> j) and (d[i][j] = inf) then begin
            l:=1;
            len[0]:=0;
            for t:=1 to len[j] do begin
                inc(len[0]);
                s[0][t]:=s[j][t];
                s[0][t + 1]:=pred('a');
                r:=n;
                while (l + 1 < r) do begin
                    tmp:=(l + r) shr 1;
                    if (diff(tmp, 0) <= 0) then l:=tmp else r:=tmp;
                end;
                while (l <= r) do
                    if (comm(l, 0) = len[0]) then break else inc(l);

                if (l <= r) and (comm(l, 0) = len[0]) then begin
                    if (d[i][l] > len[0] + 1) then begin
                        d[i][l]:=len[0] + 1;
                        if (l = j) then break;
                    end;
                end else
                    break;
            end;
        end;
    end;
    for i:=1 to n do begin
        d[i][i mod n + 1]:=1;
        d[i][(i - 2 + n) mod n + 1]:=1;
    end;
end;

procedure solve;
var i, j, t : int;
   procedure go(x : int);
   var y, tmp : int;
   begin
      y:=way[x];
      if (y = 0) then exit;
      go(y);
      if (y mod n + 1 = x) then writeln('down') else
         if (y - 2 + n) mod n + 1 = x then writeln('up')
         else begin
            writeln('Alt');
            for tmp:=1 to d[y][x] - 1 do
               writeln(s[x][tmp]);
         end;
   end;
begin
   for t:=1 to k - 1 do begin
      fillchar(use, sizeof(use), 0);
      for i:=1 to n do r[i]:=inf;
      r[ak[t]]:=0;
      way[ak[t]]:=0;
      while (true) do begin
         j:=1;
         for i:=2 to n do if (use[i] = 0) then
            if (use[j] = 1) or
               ((use[j] = 0) and (r[j] > r[i]))
            then j:=i;
         if (use[j] = 1) or (r[j] >= inf) then break;
         use[j]:=1;
         for i:=1 to n do if (use[i] = 0) then
            if r[i] > r[j] + d[j, i] then begin
               r[i]:=r[j] + d[j, i];
               way[i]:=j;
            end;
      end;
      writeln(r[ak[t + 1]]);
      go(ak[t + 1]);
   end;
end;

begin
   assign(input, cinfile); reset(input);
   assign(output, coutfile); rewrite(output);
   init;
   create_graph;
   solve;   
   close(input); close(output);
end.
