program _2;

{$APPTYPE CONSOLE}

const MaxN = 1000;
      Big = 10000000;

type TDeik = record
       count : longint;
       by : longint;
       from : longint;
     end;

var byAlt : array [1..MaxN, 1..MaxN] of longint;
    pref : array [1..MaxN, 1..MaxN] of longint;
    func : array [1..MaxN] of longint;
    nz : array [1..MaxN] of longint;
    up, down : array [1..MaxN, 1..MaxN] of longint;
    name : array [1..MaxN] of string;
    n, k : longint;
    wh, wn : longint;
    res : longint;

    nn : array [1..MaxN] of boolean;
    d : array [1..MaxN] of TDeik;

function MaxPref(const s, s1 : string) : longint;
var i : longint;
begin
    i := 1;
    while (s[i] = s1[i]) and (i <= Length(s)) and (i <= Length(s1)) do inc(i);
    Result := i;
end;

function Max(a, b : longint) : longint;
begin
    if a > b then Max := a
    else Max := b;
end;

function Alt(now : longint; i : longint) : longint;
begin
    if now > n then now := 1;
    if now = i then begin
      Result := 1;
      Exit;
    end;
    byAlt[now, i] := Alt(now + 1, i);
    Result := Max(pref[now, i], byAlt[now, i]);
    byAlt[now, i] := Max(Result, byAlt[now, i]) + 1;
end;

procedure Swap(var a, b : longint);
var c : longint;
begin
    c := a;
    a := b;
    b := c;
end;

procedure Sort(l, r : longint);
var i, j : longint;
    x : longint;
begin
    i := l;
    j := r;
    x := nz[Random(j - i + 1) + i];
    repeat
      while name[nz[i]] < name[x] do inc(i);
      while name[nz[j]] > name[x] do dec(j);
      if i <= j then begin
        Swap(nz[i], nz[j]);
        inc(i);
        dec(j);
      end;
    until i > j;
    if i < r then Sort(i, r);
    if l < j then Sort(l, j);
end;

function Min(a, b : longint) : longint;
begin
    if a < b then Min := a
    else Min := b;
end;

procedure Init();
var i, j : longint;
    maxx : longint;
begin
    Reset(input, 'fur.in');
    Rewrite(output, 'fur.out');
    Readln(n);
    for i := 1 to n do begin
      Readln(name[i]);
      nz[i] := i;
    end;
    Sort(1, n);
    for i := 2 to n do func[nz[i]] := MaxPref(name[nz[i - 1]], name[nz[i]]);
    for i := 1 to n do pref[i, i] := Big;
    for i := 2 to n do begin
      j := i - 1;
      maxx := func[nz[i]];
      while (j <> 0) and (maxx <> 0) do begin
        pref[nz[i], nz[j]] := maxx;
        pref[nz[j], nz[i]] := maxx;
        if Length(name[nz[j]]) < pref[nz[i], nz[j]] then pref[nz[i], nz[j]] := Big;
        if Length(name[nz[i]]) < pref[nz[j], nz[i]] then pref[nz[j], nz[i]] := Big;
        maxx := Min(maxx, func[nz[j]]);
        dec(j);
      end;
    end;
    for i := 1 to n do begin
      Alt(i + 1, i);
      byAlt[i, i] := 1;
    end;
    for i := 1 to n do
      for j := 1 to n do begin
        up[i, j] := i - j;
        if up[i, j] < 0 then inc(up[i, j], n);
        up[j, i] := j - i;
        if up[j, i] < 0 then inc(up[j, i], n);

        down[i, j] := j - i;
        if down[i, j] < 0 then inc(down[i, j], n);
        down[j, i] := i - j;
        if down[j, i] < 0 then inc(down[j, i], n);
      end;
end;

function GetNext() : longint;
var i : longint;
begin
    Result := -1;
    for i := 1 to n do
      if ((Result = -1) or (d[Result].count > d[i].count)) and (not nn[i]) then Result := i;
end;

procedure WriteAns(wn, wh : longint);
var i : longint;
begin
    if wh = wn then begin
      Writeln(res);
      Exit;
    end;
    case d[wh].by of
      1 : begin
            res := res + down[d[wh].from, wh];
            WriteAns(wn, d[wh].from);
            for i := 1 to down[d[wh].from, wh] do Writeln('down');
          end;

      2 : begin
            res := res + up[d[wh].from, wh];
            WriteAns(wn, d[wh].from);
            for i := 1 to up[d[wh].from, wh] do Writeln('up');
          end;

      3 : begin
            res := res + byAlt[d[wh].from, wh];
            WriteAns(wn, d[wh].from);
            Writeln('Alt');
            for i := 1 to byAlt[d[wh].from, wh] - 1 do Writeln(name[wh][i]);
          end;
    end;
end;

procedure Deikstra(wn, wh : longint);
var q, i : longint;
begin
    Fillchar(nn, sizeof(nn), false);
    for i := 1 to n do d[i].count := Big;
    d[wn].count := 0;
    nn[wn] := true;
    q := wn;
    while q <> -1 do begin
      nn[q] := true;
      for i := 1 to n do
        if not nn[i] then begin
          //up
          if down[q, i] + d[q].count < d[i].count then begin
            d[i].count := down[q, i] + d[q].count;
            d[i].by := 1;
            d[i].from := q;
          end;
          //down
          if up[q, i] + d[q].count < d[i].count then begin
            d[i].count := up[q, i] + d[q].count;
            d[i].by := 2;
            d[i].from := q;
          end;
          //Alt
          if byAlt[q, i] + d[q].count < d[i].count then begin
            d[i].count := byAlt[q, i] + d[q].count;
            d[i].by := 3;
            d[i].from := q;
          end;
        end;
      q := GetNext();
    end;
    res := 0;
    WriteAns(wn, wh);
end;

procedure Solve();
var i : longint;
begin
    Readln(k);
    wn := 1;
    for i := 1 to k do begin
      Read(wh);
      if wh = wn then Writeln(0)
      else Deikstra(wn, wh);
      wn := wh;
    end;
end;

procedure Print();
begin
    Close(input);
    Close(output);
end;

begin
    Init();
    Solve();
    Print();
end.
