#include <stdio.h>
#include <memory.h>
#include <string.h>

#define MAXN 1200
#define MAXLEN 2200

struct list
{
	int v, w;
	char path[MAXLEN];
	struct list* next;
};

struct list a[MAXN];
char str[MAXN][MAXLEN];
int path[MAXN];
int n;

void list_add(int x, int y, int w, char* path)
{
	struct list* pList = new list;
	strcpy(pList->path, path);
	pList->v = y;
	pList->w = w;
	pList->next = a[x].next;
	a[x].next = pList;
}

void init()
{
	freopen("fur.in", "r", stdin);
	freopen("fur.out", "w", stdout);
	memset(a, 0, sizeof(a));
}

void readdata()
{
	int i;
	scanf("%d\n", &n);
	for(i=0;i<n;i++)
	{
		gets(str[i]);
	}
}

void make_graph()
{
	int x, y, i;
	for(i=1;i<=n;i++)
	{
		x = i;
		y = x+1;
		if(y>n) y = 1;
		list_add(x, y, 1, "down\n");
		list_add(y, x, 1, "up\n");
	}
}

void find_path(int x, int y, char* str)
{
	struct list* pList = a[x].next;
	while(pList->v!=y)
	{
		pList = pList->next;
	}
	strcpy(str, pList->path);
}

void print_path(int s, int t)
{
	char str[MAXN];
	if(s!=t)
	{
		print_path(s, path[t]);
		find_path(path[t], t, str);
		printf("%s", str);
	}
}

void diikstra(int s, int t)
{
	char vert[MAXN];
	struct list* pList;
	int d[MAXN];
	int i, min, l;
	for(i=0;i<MAXN;i++)
	{
		d[i] = 10000;
		path[i] = 0;
	}
	memset(vert, 1, sizeof(vert));
	vert[s] = 0;
	d[s] = 0;
	l = s;
	while(l!=t)
	{
		pList = a[l].next;
		while(pList!=NULL)
		{
			if(vert[pList->v])
			{
				if(d[pList->v]>d[l]+pList->w)
				{
					d[pList->v]=d[l]+pList->w;
					path[pList->v] = l;
				}
			}
			pList = pList->next;
		}
		min = t;
		for(i=1;i<=n;i++)
			if(vert[i])
				if(d[i]<d[min])
					min = i;
		vert[min] = 0;
		l = min;
	}
	printf("%d\n", d[t]);
	print_path(s, t);
}

void solve()
{
	int i, x, t, k;
	make_graph();
	scanf("%d", &k);
	t = 1;
	for(i=0;i<k;i++)
	{
		scanf("%d", &x);
		diikstra(t,x);
		t = x;
	}
}

int main()
{
	init();
	readdata();
	solve();
	return 0;
}