{$apptype console}

const max_q = 1000000;
      max_n = 1000;
      max_k = 10;

var name: array [1..max_n] of string;
    id, len, w: array [1..max_n] of longint;
    dist: array [1..max_n] of longint;
    how: array [1..max_n] of string;
    fr: array [1..max_n] of longint;
    q: array [1..max_q] of longint;
    a: array [0..max_k] of longint;
    i, j, n, k: longint;

procedure swap(var a, b: longint);
var c: longint;
begin
  c := a; a := b; b := c;
end;

procedure QSort(l, r: longint);
var i, j, x: longint;
begin
  x := id[random(r-l)+l];
  i := l; j := r;
  repeat
    while name[id[i]] < name[x] do inc(i);
    while name[x] < name[id[j]] do dec(j);
    if i <= j then begin
      swap(id[i], id[j]);
      inc(i); dec(j);
    end;
  until i > j;
  if l < j then QSort(l, j);
  if i < r then QSort(i, r);
end;

procedure calc(ii, jj: longint);
var i, j, k, l, qb, qe: longint;
    s: string;

  procedure add(i, j, l: longint; f: string);
  begin
    if dist[j] > dist[i] + l then begin
      dist[j] := dist[i] + l;
      fr[j] := i;
      how[j] := f;
      q[qe] := j;
      inc(qe);
      if qe > max_q then qe := 1;
      assert(qb <> qe);
    end;
  end;

begin
  fillchar(dist, sizeof(dist), 127);
  qb := 1; qe := 2;
  q[1] := ii;
  dist[ii] := 0;
  fr[ii] := 0;
  how[ii] := '';

  while qb <> qe do begin
    i := q[qb];

    // up
    j := i-1; if j < 1 then j := n;
    add(i, j, 1, 'U');

    // down
    j := i+1; if j > n then j := 1;
    add(i, j, 1, 'D');

    // Alt
    for k := 1 to n do
      if k <> i then begin
        j := i; l := 1;
        s := '';
        repeat
          s := s + name[k,l];
          while pos(s, name[j]) <> 1 do begin
            inc(j); if j > n then j := 1;
          end;
          inc(l);
          if l > len[k] then break;
        until j = k;
        if j = k then add(i, k, l, s);
      end;

    inc(qb);
    if qb > max_q then qb := 1;
  end;
end;

procedure res(k: longint);
var i: longint;
begin
  if fr[k] <> 0 then res(fr[k]);
  if how[k] = 'U' then writeln('up')
  else if how[k] = 'D' then writeln('down')
  else if how[k] <> '' then begin
    writeln('Alt');
    for i := 1 to length(how[k]) do
      writeln(how[k,i]);
  end;
end;

begin
  reset(input, 'fur.in');
  rewrite(output, 'fur.out');

  readln(n);
  for i := 1 to n do begin
    readln(name[i]);
    len[i] := length(name[i]);
    id[i] := i;
  end;

  fillchar(w, sizeof(w), 0);
  QSort(1, n);
  w[id[1]] := 1;
  for i := 2 to n do begin
    j := 1;
    while (j <= len[id[i-1]])and(j <= len[id[i]]) do begin
      if name[id[i-1],j] <> name[id[i],j] then break;
      inc(j);
    end;
    w[id[i]] := j-1;
  end;

  read(k);
  for i := 1 to k do read(a[i]);
  a[0] := 1;

  for i := 1 to k do begin
    calc(a[i-1], a[i]);
    writeln(dist[a[i]]);
    res(a[i]);
  end;

  close(input); close(output);
end.