#include <stdio.h>
#include <string.h>

#define abs(a) ((a) > 0 ? (a) : -(a))
#define min(a, b) ((a) < (b) ? (a) : (b))

#define m 1010
#define ml 2010
#define mm (m * ml)

int n, k, l[m], o[m], d[m][m], w[m][m], r[m], u[m], he[mm], ne[mm], to[mm], nu, p[m], al, pa[m], e;
char a[m][ml], ch[mm];

void upd( int i, int j, int t, int k )
{
  if (d[i][j] == -1 || d[i][j] > t)
    d[i][j] = t, w[i][j] = k;
}

void add( int v, char *s )
{
  int i;

  if (!*s)
    return;
  for (i = he[v]; i != -1; i = ne[i])
    if (ch[i] == *s)
    {
      add(to[i], s + 1);
      return;
    }
  to[e] = nu++, ch[e] = *s, ne[e] = he[v], he[v] = e++;
  add(nu - 1, s + 1);
}

int find( int v, char *s )
{
  int i;

  if (!*s)
    return 0;
  for (i = he[v]; i != -1; i = ne[i])
    if (ch[i] == *s)
      return find(to[i], s + 1) + 1;
  return 0;
}

void print( int i, int j )
{
  int k;

  if (i == j)
    ;
  else if (w[i][j] == 1)
    while (i != j)
      printf("down\n"), i = (i + 1) % n;
  else if (w[i][j] == 2)
    while (i != j)
      printf("up\n"), i = (i + n - 1) % n;
  else
  {
    printf("Alt\n");
    for (k = 0; k < d[i][j] - 1; k++)
      printf("%c\n", a[j][k]);
  }
}

int main( void )
{
  int i, j, t, v;

  freopen("fur.in", "rt", stdin);
  freopen("fur.out", "wt", stdout);
  scanf("%d", &n);
  for (i = 0; i < n; i++)
    scanf("%s", a[i]), l[i] = strlen(a[i]);
  scanf("%d", &k), o[0] = 0;
  for (i = 1; i <= k; i++)
    scanf("%d", &o[i]), o[i]--;
  memset(d, -1, sizeof(d));
  for (i = 0; i < n; i++)
    d[i][i] = 0;
  for (i = 0; i < n; i++)
    for (j = 0; j < n; j++)
      if (i < j)
        upd(i, j, j - i, 1), upd(i, j, i + n - j, 2);
      else
        upd(i, j, j + n - i, 1), upd(i, j, i - j, 2);
  for (i = 0; i < n; i++)
  {
    if (!(i % 100))
      fprintf(stderr, "%d\n", i);
    memset(he, -1, sizeof(he)), nu = 1, e = 0;
    for (j = 0; j < n; j++)
    {
      v = (i + j) % n;
      if ((t = find(0, a[v])) < l[v])
        upd(i, v, t + 2, 3);
      add(0, a[v]);
    }
  }
  for (i = 0; i < k; i++)
  {
    memset(u, 0, sizeof(u));
    memset(r, -1, sizeof(r));
    v = o[i], r[v] = 0, p[v] = -1;
    while (1)
    {
      for (t = -1, j = 0; j < n; j++)
        if (!u[j] && (t == -1 || r[t] == -1 || (r[j] != -1 && r[t] > r[j])))
          t = j;
      if (t == -1)
        break;
      for (u[t] = 1, j = 0; j < n; j++)
        if (r[j] == -1 || r[j] > r[t] + d[t][j])
          r[j] = r[t] + d[t][j], p[j] = t;
    }
    for (al = 0, j = o[i + 1]; j != -1; j = p[j])
      pa[al++] = j;
    printf("%d\n", r[o[i + 1]]);
    for (j = al - 1; j > 0; j--)
      print(pa[j], pa[j - 1]);
  }
  return 0;
}
