#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define abs(a) ((a) > 0 ? (a) : -(a))
#undef min
#define min(a, b) ((a) < (b) ? (a) : (b))

#define m 1010
#define ml 2010

int n, k, l[m], o[m], d[m][m], w[m][m], r[m], u[m], p[m], al, pa[m], pe[m], lcp[m][m], lc[m];
char a[m][ml];

void upd( int i, int j, int t, int k )
{
  if (d[i][j] == -1 || d[i][j] > t)
    d[i][j] = t, w[i][j] = k;
}

void print( int i, int j )
{
  int k;

  if (i == j)
    ;
  else if (w[i][j] == 1)
    while (i != j)
      printf("down\n"), i = (i + 1) % n;
  else if (w[i][j] == 2)
    while (i != j)
      printf("up\n"), i = (i + n - 1) % n;
  else
  {
    printf("Alt\n");
    for (k = 0; k < d[i][j] - 1; k++)
      printf("%c\n", a[j][k]);
  }
}

void sort( int l, int r )
{
  int i, j, x, t;

  if (l >= r)
    return;
  i = l, j = r, x = pe[l + rand() % (r - l + 1)];
  while (i <= j)
  {
    while (strcmp(a[pe[i]], a[x]) < 0) i++;
    while (strcmp(a[pe[j]], a[x]) > 0) j--;
    if (i <= j)
      t = pe[i], pe[i] = pe[j], pe[j] = t, i++, j--;
  }
  sort(l, j), sort(i, r);
}

int main( void )
{
  int i, j, t, v;

  srand(301703);
  freopen("fur.in", "rt", stdin);
  freopen("fur.out", "wt", stdout);
  scanf("%d", &n);
  for (i = 0; i < n; i++)
    scanf("%s", a[i]), l[i] = strlen(a[i]), pe[i] = i;
  scanf("%d", &k), o[0] = 0;
  for (i = 1; i <= k; i++)
    scanf("%d", &o[i]), o[i]--;
  memset(d, -1, sizeof(d));
  for (i = 0; i < n; i++)
    d[i][i] = 0;
  for (i = 0; i < n; i++)
    for (j = 0; j < n; j++)
      if (i < j)
        upd(i, j, j - i, 1), upd(i, j, i + n - j, 2);
      else
        upd(i, j, j + n - i, 1), upd(i, j, i - j, 2);
  sort(0, n - 1);
  for (i = 1; i < n; i++)
  {
    for (j = 0; a[pe[i - 1]][j] && a[pe[i]][j]; j++)
      if (a[pe[i - 1]][j] != a[pe[i]][j])
        break;
    lc[pe[i]] = j;
  }
  /*
  for (i = 0; i < n; i++)
    fprintf(stderr, "%s %d\n", a[pe[i]], lc[pe[i]]);*/
  for (i = 0; i < n; i++)
    for (lcp[pe[i]][pe[i]] = l[pe[i]], j = i + 1; j < n; j++)
      lcp[pe[i]][pe[j]] = lcp[pe[j]][pe[i]] = min(lcp[pe[i]][pe[j - 1]], lc[pe[j]]);
  /*
  for (i = 0; i < n; i++)
    fprintf(stderr, "%s %d\n", a[i], lc[i]);
  for (i = 0; i < n; i++)
    for (j = 0; j < n; j++)
      fprintf(stderr, "%d%s", lcp[i][j], (j == n - 1) ? "\n" : " ");*/
  for (i = 0; i < n; i++)
    for (t = 0, j = 1; j < n; j++)
    {
      v = (i + n - j) % n;
      t = max(t, lcp[i][v]);
      if (t != l[i])
        /*fprintf(stderr, "%d->%d (%d)\n", v, i, t + 2), */upd(v, i, t + 2, 3);
    }
  for (i = 0; i < k; i++)
  {
    memset(u, 0, sizeof(u));
    memset(r, -1, sizeof(r));
    v = o[i], r[v] = 0, p[v] = -1;
    while (1)
    {
      for (t = -1, j = 0; j < n; j++)
        if (!u[j] && (t == -1 || r[t] == -1 || (r[j] != -1 && r[t] > r[j])))
          t = j;
      if (t == -1)
        break;
      for (u[t] = 1, j = 0; j < n; j++)
        if (r[j] == -1 || r[j] > r[t] + d[t][j])
          r[j] = r[t] + d[t][j], p[j] = t;
    }
    for (al = 0, j = o[i + 1]; j != -1; j = p[j])
      pa[al++] = j;
    printf("%d\n", r[o[i + 1]]);
    for (j = al - 1; j > 0; j--)
      print(pa[j], pa[j - 1]);
  }
  return 0;
}
