program tru2;

{$APPTYPE CONSOLE}

uses
  SysUtils;

const
  inf = 'fur.in';
  outf = 'fur.out';

var
  i, j, n, k: integer;
  files: array of string;
  s: string;
  ansdata: array [0..1000, 0..1000] of string;
  ansdone: array [0..1000, 0..1000] of integer;

function min(src, dst: integer): integer;
var
  a: integer;
begin
  result:=abs(src-dst);
  a:=n-result;
  if a < result then result:=-a;
end;

var
  sname: string;

function dosearch(src: integer): integer;
var
  nl: integer;
begin
  result:=src;
  nl:=length(sname);
  while copy(files[result], 1, nl) <> sname do
  begin
    inc(result);
    if result >= n then result:=0;
  end;
end;

function searchmin(src, dst: integer; done, all: integer): string;
var
  sr: integer;
begin
  if done = 0 then sname:='';
  result:='';
  if done = all then exit;
  inc(done);
  if done > length(files[dst]) then exit;
  sname:=sname+files[dst][done];
  sr:=dosearch(src);
  if dst = sr then result:=sname else result:=searchmin(sr, dst, done, all);
end;

var
  t: string;

procedure parse(x: string; l: integer);
var
  i: integer;
begin
  write(l);
  for i:=1 to l do
  begin
    writeln;
    case x[i] of
      'A': write('Alt');
      'U': write('up');
      'D': write('down');
      else write(x[i]);
    end;
  end;
end;

begin
  assign(input, inf);
  reset(input);
  assign(output, outf);
  rewrite(output);
  readln(n);
  setlength(files, n);
  for i:=0 to n-1 do
  begin
    readln(s);
    files[i]:=trim(s);
  end;
  for i:=0 to n-1 do
    for j:=0 to n-1 do
      if i = j then ansdone[i, j]:=0 else
      begin
        ansdone[i, j]:=min(i, j);
        setlength(ansdata[i, j], abs(ansdone[i, j]));
        if ((i > j) and (ansdone[i, j] > 0)) or ((i < j) and (ansdone[i, j] < 0)) then
          fillchar(ansdata[i, j, 1], abs(ansdone[i, j]), 'U')
        else
          fillchar(ansdata[i, j, 1], abs(ansdone[i, j]), 'D');
        ansdone[i, j]:=abs(ansdone[i, j]);
        t:='A'+searchmin(i, j, 0, ansdone[i, j]-1);
        if (length(t) < ansdone[i, j]) and (t <> 'A') then
        begin
          ansdone[i, j]:=length(t);
          ansdata[i, j]:=t;
        end;
      end;

  read(k);
  n:=0;
    read(j);
    dec(j);
    parse(ansdata[n, j], ansdone[n, j]);
    n:=j;
  for i:=2 to k do
  begin
    writeln;
    read(j);
    dec(j);
    parse(ansdata[n, j], ansdone[n, j]);
    n:=j;
  end;

  close(input);
  close(output);
end.
