{$A8,B-,C+,D+,E-,F-,G+,H+,I+,J-,K-,L+,M-,N+,O+,P+,Q-,R-,S-,T-,U-,V+,W-,X+,Y+,Z1}
{$APPTYPE CONSOLE}
{$i-,q-,r-}

uses Math;

const id = 'fur';
      infile = id + '.in';
      outfile = id + '.out';

const maxn = 1000;
      inf = MaxLongint shr 1;

type int = longint;
     Tpath = record
               f, col : int;
             end;

var w : array [1..maxn] of string;
    g : array [1..maxn, 1..maxn] of TPath;
    d, used, pi : array [1..maxn] of int;
    a : array [0..10] of int;
    n, k : int;

procedure Init;
var
  i : int;
begin
  readln(n);
  for i := 1 to n do
    readln(w[i]);
  readln(k);
  for i := 1 to k do
    read(a[i]);
end;

function calc(i, j : int) : int;
var
  k : int;
  ok : boolean;
begin
  ok := true;
  for k := 1 to length(w[i]) do
    if w[j][k] <> w[i][k] then begin
      ok := false;
      break;
    end;
  if ok then calc := inf
        else calc := k;
end;

procedure UpDown;
var
  i, j : int;
begin
  for i := 1 to n do begin
    g[i, (i mod n + 1)].f := 2;
    g[i, (i mod n + 1)].col := 1;
    j := i-1; if j = 0 then j := n;
    g[i, j].f := 1;
    g[i, j].col := 1;
  end;
end;

procedure incc(var x : int);
begin
  inc(x);
  if x > n then x := 1;
end;

function decc(x : int) : int;
begin
  dec(x);
  if x = 0 then decc := n else decc := x;
end;

procedure GoAlt(x, y : int);
var
  i, j, k, m, t : int;
  p : array [1..maxn] of int;
begin
  fillchar(p, sizeof(p), 0);
  i := x-1; m := 0;
  repeat
    incc(i);
    inc(m); p[m] := i;
  until i = y;

  for i := 2 to m do
    for j := 1 to i-1 do begin
      if (g[p[j], p[i]].f <> 0) then continue;
      t := 0;
      for k := j to i-1 do begin
        t := max(t, Calc(p[i], p[k]));
        if t = inf then break;
      end;
{      t := max(t, Calc(p[i], p[j]));}
//      if t = 1 then inc(t);
      if t <> inf then begin
        g[p[j], p[i]].f := 3;
        g[p[j], p[i]].col := t+1;
      end;
    end;
end;

procedure Path(x, y : int);
var
  u, i, min : int;
begin
  for i := 1 to n do d[i] := inf;
  fillchar(used, sizeof(used), 0);
  fillchar(pi, sizeof(pi), 0);
  u := x; d[x] := 0;
  while true do begin
    used[u] := 1;
    for i := 1 to n do
      if (g[u, i].f <> 0) and (used[i] = 0) and (d[i] > d[u] + g[u, i].col) then begin
        d[i] := d[u] + g[u, i].col;
        pi[i] := u;
      end;

     u := -1; min := inf;
     for i := 1 to n do
       if (used[i] = 0) and (min > d[i]) then begin
         min := d[i];
         u := i;
       end;
     if (u = -1) or (used[y] <> 0) then break;  
  end;
end;

procedure Save(x, y : int);
var
  i, j, k : int;
  b : array [1..maxn] of TPath;
  nw : array [1..maxn] of int;
begin
  fillchar(b, sizeof(b), 0);
  fillchar(nw, sizeof(nw), 0);
  writeln(d[y]);
  i := y; k := 0; pi[x] := x;
  while i <> x do begin
    inc(k);
    b[k] := g[pi[i], i];
    nw[k] := i;
    i := pi[i];
  end;
  for i := k downto 1 do
    case b[i].f of
      1 : writeln('up');
      2 : writeln('down');
      3 : begin
        writeln('Alt');
        for j := 1 to b[i].col-1 do writeln(w[nw[i]][j]);
      end;
    end;
end;

procedure Solve;
var
  i : int;
begin
  a[0] := 1;
  UpDown;
  for i := 1 to k do begin
    if a[i] = a[i-1] then begin
      writeln(0);
      continue;
    end;
    GoAlt(a[i-1], a[i]);
    Path(a[i-1], a[i]);
    Save(a[i-1], a[i]);
  end;
end;

BEGIN
  assign(input, infile); reset(input);
  assign(output, outfile); rewrite(output);
  Init;
  Solve;
  close(input); close(output);
END.