{    - }
program fur;
 type integer=longint;
 const maxn=2000;
       inf=maxlongint div 4;
 var n:longint;
     g:array[0..maxn,0..maxn] of longint;
     v:array[0..maxn] of string;
     a,ac:array[0..maxn] of longint;
     d,f:array[0..maxn] of longint;
     u:array[0..maxn] of boolean;
     t:array[0..2*maxn+1] of longint;
     h:longint;
     i,j,k:longint;

 function down(x:longint):longint;
 begin
  if x<n then down:=x+1 else down:=1;
 end;

 function up(x:longint):longint;
 begin
  if x>1 then up:=x-1 else up:=n;
 end;

 function max(x,y:longint):longint;
 begin
  if x>y then max:=x else max:=y;
 end;

 function min(x,y:longint):longint;
 begin
  if x<y then min:=x else min:=y;
 end;

 function dif(x,y:longint):longint;
  var ans,l1,l2:longint;
 begin
  ans:=1;
  l1:=length(v[x]);
  l2:=length(v[y]);
  while (ans<=min(l1,l2))and(v[x][ans]=v[y][ans]) do inc(ans);
  result:=ans  -1  ;
 end;

 procedure print(x:longint);
  var i:longint;
 begin
  if d[x]>0 then begin
   print(f[x]);
   if f[x]=up(x) then writeln('down') else
   if f[x]=down(x) then writeln('up') else begin
    writeln('Alt');
    for i:=1 to g[f[x],x]-1 do
     writeln(v[x][i]);
   end;
  end;
 end;

 procedure djkstra(x:longint);
  var i,j:longint;
 begin
  for i:=0 to n do d[i]:=inf;
  d[x]:=0;
  f[x]:=0;
  fillchar(u,sizeof(u),0);
  while true do begin
   j:=0;
   for i:=1 to n do
    if (not u[i])and(d[i]<d[j]) then j:=i;
   if j=0 then break;
   u[j]:=true;
   for i:=1 to n do
    if (not u[i])and(d[i]>d[j]+g[j,i]) then begin
     d[i]:=d[j]+g[j,i];
     f[i]:=j;
    end;
  end;
 end;

 procedure sort(l,r: integer);
 var
  i,j,x,y: integer;
 begin
  i:=l; j:=r; x:=a[(57*l+43*r) div 100];
  repeat
    while v[a[i]]<v[x] do i:=i+1;
    while v[x]<v[a[j]] do j:=j-1;
    if i<=j then
    begin
      y:=a[i]; a[i]:=a[j]; a[j]:=y;
      i:=i+1; j:=j-1;
    end;
  until i>j;
  if l<j then sort(l,j);
  if i<r then sort(i,r);
 end;


 procedure make_tree;
  var i:longint;
 begin
  for i:=1 to n do a[i]:=i;
  sort(1,n);
  for i:=1 to n do ac[a[i]]:=i;
  h:=1;
  while (h<n) do h:=h*2;
  fillchar(t,sizeof(t),0);
  for i:=1 to n-1 do
   t[h+i-1]:=dif(a[i],a[i+1]);
  for i:=h-1 downto 1 do
   t[i]:=min(t[2*i],t[2*i+1]);
 end;

 function rmq(x,y:longint):longint;
  var ax,ay:longint;
 begin
  x:=x+h-1;
  y:=y+h-1;
  ax:=t[x];
  ay:=t[y];
  while (y-x>1) do begin
   if x mod 2 =0 then ax:=min(ax,t[x+1]);
   if y mod 2 =1 then ay:=min(ay,t[y-1]);
   x:=x div 2;
   y:=y div 2;
  end;
  rmq:=min(ax,ay);
 end;

 function diff(x,y:longint):longint;
 begin
  if ac[x]<ac[y] then result:=rmq(ac[x],ac[y]-1)
   else result:=rmq(ac[y],ac[x]-1);
 end;

begin
 assign(input,'fur.in');
 reset(input);
 assign(output,'fur.out');
 rewrite(output);
  readln(n);
  for i:=0 to n+1 do
   for j:=0 to n+1 do
    if i<>j then g[i,j]:=inf else g[i,j]:=0;
  for i:=1 to n do begin
   g[i,up(i)]:=1;
   g[i,down(i)]:=1;
  end;
  for i:=1 to n do
   readln(v[i]);
  make_tree;
  for i:=1 to n do begin
   k:=0;
   j:=up(i);
   while (j<>i) do begin
    k:=max(k,diff(i,j)+1);
    if k>length(v[i]) then break;
    g[j,i]:=min(g[j,i],k+1);
    j:=up(j);
   end;
  end;
  read(k);
  j:=1;
  for i:=1 to k do begin
   djkstra(j);
   read(j);
   writeln(d[j]);
   print(j);
  end;
 close(output);
 close(input);
end.