program fur;

{$APPTYPE CONSOLE}

uses
  SysUtils;

type
  TPos = record
    Marked    : boolean;
    Prev, DFS : word;
  end;

var
  Fin, Fout : text;
  Names     : array [1..1000, 1..2000] of char;
  Poss      : array[1..1000] of TPos;
  Matr      : array [1..1000, 1..1000] of word;
  K         : byte;
  N, A, I, J, TP : word;

function Rav(CPos, Stn, Fnn : word) : boolean;
var
  I : word;
begin
  For I:=1 to CPos do
  if Names[Stn, I]<>Names[Fnn, I] then
  begin
    Rav:=false;
    exit;
  end;
  Rav:=true;
end;

function AltMovement(ST, Fn : word) : word;
var
  CPos, PosT : word;
begin
  PosT:=St;
  CPos:=0;
  While PosT<>Fn do
  begin
    CPos:=CPos+1;
    While not Rav(Cpos, Fn, PosT) do PosT:=(PosT mod N)+1;
  end;
  if Names[Fn , Cpos]=#0 then CPos:=65000;
  AltMovement:=CPos+1;
end;

procedure FindMin(St : word);
var
  I : word;
  Vm : word;
  NotMarked : word;
  MinDist : word;
begin
  For I:=1 To N do
  begin
    Poss[I].Marked:=false;
    Poss[I].Prev:=ST;
    Poss[I].DFS:=Matr[St, I];
  end;

  Poss[St].Marked:=True;
  Poss[St].Prev:=0;
  Poss[St].DFS:=0;
  NotMarked:=N-1;

  While NotMarked>0 do
  begin
    vm:=1;
    MinDist:=65500;
    For I:=1 To N do
      if Poss[I].Marked=false then
        if Poss[I].DFS<MinDist then
        begin
          Vm:=I;
          MinDist:=Poss[I].DFS;
        end;

    NotMarked:=NotMarked-1;
    Poss[vm].Marked:=true;

    For I:=1 to N do
      if Poss[I].Marked=false then
        if Poss[I].DFS>Poss[Vm].DFS+Matr[vm, i] then
        begin
          Poss[I].DFS:=Poss[Vm].DFS+Matr[vm, i];
          Poss[I].Prev:=vm;
        end;
  end;
end;

procedure PrintWay(PPos : word);
var
  C : word;
begin
  if Poss[PPos].Prev=0 then exit;
  PrintWay(Poss[PPos].Prev);
  if Matr[Poss[PPos].Prev, PPos]=1 then
  begin
    if Ppos=(Poss[PPos].Prev mod N)+1 then Writeln(Fout, 'down') else Writeln(Fout, 'up');
  end
  else
  begin
    Writeln(Fout, 'Alt');
    For C:=1 to Matr[Poss[PPos].Prev, PPos]-1 do Writeln(Fout, Names[PPos, C]);
  end;
end;

begin
  Assign(Fin, 'fur.in');
  Assign(Fout, 'fur.out');
  Reset(Fin);
  Rewrite(Fout);
  Readln(Fin, N);
  For I:=1 to N do
  begin
    j:=0;
    While not eoln(Fin) do
    begin
      J:=J+1;
      Read(Fin, Names[I, J]);
    end;
    Readln(Fin);
  end;

  For I:=1 To N do
  For J:=1 to N do
  begin
    if I=J then Matr[I, j]:=0
    else
      if ((I mod N)+1=J) or (((N+I-2) mod N)+1=J) then Matr[I, J]:=1
      else Matr[I, J]:=AltMovement(I, J);
  end;

  Readln(Fin, K);
  TP:=1;

  For I:=1 to K do
  begin
    Read(Fin, A);
    FindMin(Tp);
    Writeln(Fout, Poss[A].DFS);
    PrintWay(A);
    TP:=A;
  end;

  Close(Fin);
  Close(Fout);
end.
