#include <cstdio>
#include <cstring>
#include <string>
#include <vector>
#include <map>

using namespace std;

void
trim(char *b)
{
	int l = strlen(b);
	for (int i=l-1; i>=0; i--)
	{
		if ('\x0a' == b[i] || '\x0d' == b[i] || ' ' == b[i] || '\t' == b[i])
			b[i]='\0';
		else
			break;
	}
}



int
main()
{
	int N,i;
	char buf[4000];
	string s;
	vector<string> files(1000);

	FILE * f = fopen ("fur.in", "r");
	fscanf (f, "%i\n", &N);
	for (i=0; i<N; i++)
	{
		fgets (buf, 4000, f);
        trim(buf);
		s = buf;
		files.push_back(s);
	}

	int k, from=1, to;
	fscanf (f, "%i", &k);

	FILE * out = fopen ("fur.out", "w");
	
	for (i=0; i<k; i++)
	{
		fscanf (f, "%i", &to);

		if (from == to)
			fprintf (out, "0\n");
		else
		{
			int dway = to - from;
			if (dway < 0) { dway += N; }
			int uway = from-to;
			if (uway < 0) { uway += N; }
			int j;

			if (dway < uway)
			{
				fprintf (out, "%i\n", dway);
				for (j=0; j<dway; j++) fprintf (out, "down\n");
			}
			else
			{
				fprintf (out, "%i\n", uway);
				for (j=0; j<uway; j++) fprintf (out, "up\n");
			}
		}

		from = to;
	}

	fclose (out);
	fclose(f);


	return 0;
}
