program Zad2;

{$Apptype Console}

{$O+,Q-,R-,D-,I-}

uses
  SysUtils;

const
  MaxN=1000;
  MaxK=10;

type
  rec=record
        kol:Longint;
        nap:byte;
      end;

var
  f:array[1..MaxN] of String;
  N,K:Longint;
  a:array[1..MaxK] of LongInt;
  t:array[1..MaxN,1..MaxN] of Rec;
  way,dest,used:array[1..MaxN] of LongInt;

procedure Init;
begin
  Assign(input,'fur.in');
  Reset(input);
  Assign(output,'fur.out');
  Rewrite(output);
end;

procedure Final;
begin
  Close(input);
  Close(output);
end;

procedure InData;
var
  i:LongInt;
begin
  Readln(N);
  for i:=1 to N do
    Readln(f[i]);
  Read(K);
  for i:=1 to K do
    Read(a[i]);
end;


procedure PredP;
var
  i,j:Longint;
begin
  for i:=1 to N do
  for j:=1 to N do
  begin
    t[i,j].nap:=1;
    if i<j then
    begin
      t[i,j].kol:=j-i;
      if N-j+i<t[i,j].kol then
      begin
        t[i,j].kol:=N-j+i;
        t[i,j].nap:=2;
      end;
    end;
    if i=j then begin t[i,j].nap:=1; t[i,j].kol:=0;   end;
    if i>j then
    begin
      t[i,j].kol:=N-i+j;
      if i-j<t[i,j].kol then
      begin
        t[i,j].kol:=i-j;
        t[i,j].nap:=2;
      end;
    end;
  end;
end;

procedure OutAns(u,v:LongInt);
var
  v1,i:longint;
begin
  if u=v then Exit;
  v1:=dest[v];
  OutAns(u,v1);
  case t[v1,v].nap of
    1:for i:=1 to t[v1,v].kol do Writeln('down');
    2:for i:=1 to t[v1,v].kol do Writeln('up');
    3:begin Writeln('Alt'); for i:=1 to t[v1,v].kol-1 do Writeln(f[v][i]); end;
  end;
end;

procedure Dijkstr(u,v:LongInt);
var
  mini,i,j:LongInt;
begin
  fillchar(used,SizeOf(used),0);
  for i:=1 to N do
    way[i]:=MaxLongInt div 2;
  way[u]:=0;
  while used[v]<>1 do
  begin
    mini:=0;
    for i:=1 to N do
     if used[i]=0  then
     if (mini=0)or(way[mini]>way[i]) then mini:=i;
    used[mini]:=1;
    for j:=1 to N do
    if used[j]=0 then
    if way[mini]+t[mini,j].kol<way[j] then
    begin
      way[j]:=way[mini]+t[mini,j].kol;
      dest[j]:=mini;
    end;
   end;
   Writeln(way[v]);
   OutAns(u,v);
end;

procedure BuildG;
var
  i,j,cnt:Longint;
begin
  for i:=1 to N do
  begin
    j:=i-1;
    cnt:=1;
    if i=1 then j:=N;
    while j<>i do
    begin
      if (cnt<=Length(f[j]))and(Copy(f[i],1,cnt)=Copy(f[j],1,cnt))  then
      begin
        while (cnt<Length(f[i]))and(cnt<Length(f[j]))and(f[i][cnt+1]=f[j][cnt+1])
           do inc(cnt);
        if (cnt<=Length(f[j]))and(Copy(f[i],1,cnt)=Copy(f[j],1,cnt)) then  Break;
      end;
       if cnt+1<t[j,i].kol then
       begin
         t[j,i].kol:=cnt+1;
         t[j,i].nap:=3;
       end;
       dec(j);
       if j<1 then j:=N;
    end;
  end;
  
end;

procedure Solve;
var
  cur:LongInt;
  i:LongInt;
begin
  PredP;
  BuildG;
  cur:=1;
  for i:=1 to K do
  begin
    Dijkstr(cur,a[i]);
    cur:=a[i];
  end;
end;

begin
  Init;
  InData;
  Solve;
  Final;
end.