{$Q-,R-,S-}
{$APPTYPE CONSOLE}
type integer = longint;
const MNOGO = $7F7F7F7F;
var	snames, names : array[1..1100] of ansistring;
	ind : array[1..1100] of integer;
	n, k, ne : integer;
	a : array [0..11] of integer;
	match : array[1..1100, 1..1100] of integer;

var x, t : ansistring;

procedure Qsort(be, en : integer);
var l, r, tt : integer;
begin
	l := be;
	r := en;
	x := snames[l + random(r - l + 1)];
	while l < r do begin
		while x > snames[l] do inc(l);
		while x < snames[r] do dec(r);
	    if l <= r then begin
	    	t := snames[l];
	    	snames[l] := snames[r];
	    	snames[r] := t;
        tt := ind[l];
        ind[l] := ind[r];
        ind[r] := tt;
	    	inc(l);
			dec(r);
	    end;
	end;
	if be < r then Qsort(be, r);
	if l < en then Qsort(l, en);
end;

procedure Load;
var clen, i, j : integer;
begin
	ne := 0;
	readln(n);
	for i := 1 to n do begin 
		readln(names[i]);
		for j := length(names[i]) downto 1 do begin
			if (names[i, j] < 'a') or (names[i, j] > 'z') then begin
				Delete(names[i], j, 1);
			end;
		end;
		ind[i] := i;
	end;
	read(k);
	for i := 1 to k do begin
		read(a[i]);
	end;
	for i := 1 to n do snames[i] := names[i];
	Qsort(1, n);
	fillchar(match, sizeof(match), 0);
	for i := 1 to n do begin
		{go up}
		clen := 0;
		for j := 1 to n do begin
			while (clen < length(snames[i])) and (snames[j, clen + 1] = snames[i, clen + 1]) do inc(clen);
			match[ind[i], ind[j]] := clen;
		end;
		{go down}
		clen := 0;
		for j := n downto i do begin
			while (clen < length(snames[i])) and (snames[j, clen + 1] = snames[i, clen + 1]) do inc(clen);
			match[ind[i], ind[j]] := clen;
		end;
	end;
end;

var prs : array[1..1100, 1..1100] of integer;
	was, dst, prev, byw : array [1..1100] of integer;
	pth, pbw : array[1..1100] of integer;
	npth : integer;

function GetNext(a : integer) : integer;
begin
	if a = n then GetNext := 1
	else GetNext := a + 1;
end;

function GetPrev(a : integer) : integer;
begin
	if a = 1 then GetPrev := n
	else GetPrev := a - 1;
end;

procedure DijkstRA(bver : integer);
var nxt, cver, i, min, mi : integer;
begin
	fillchar(dst, sizeof(dst), $7F);
	fillchar(was, sizeof(was),  0);
	dst[bver] := 0;
	while true do begin
		min := MNOGO;
		mi := 0;
		for i := 1 to n do begin
			if was[i] = 1 then continue;
			if dst[i] < min then begin	
				min := dst[i];
				mi := i;
			end;
		end;
		if min = MNOGO then break;
		cver := mi;
		{go down}
		nxt := GetNext(cver);
		if dst[nxt] > dst[cver] + 1 then begin
			dst[nxt] := dst[cver] + 1;
			prev[nxt] := cver;
			byw[nxt] := 1;
		end;
		{go up}
		nxt := GetPrev(cver);
		if dst[nxt] > dst[cver] + 1 then begin
			dst[nxt] := dst[cver] + 1;
			prev[nxt] := cver;
			byw[nxt] := 2;
		end;
		{go by Alt + }
		for i := 1 to n do begin
			if i = cver then continue;
			if prs[cver, i] >= MNOGO then continue;
			if dst[i] > dst[cver] + prs[cver, i] then begin
				dst[i] := dst[cver] + prs[cver, i];
				prev[i] := cver;
				byw[i] := 3;
			end;
		end;
		was[cver] := 1;
	end;
end;

procedure Solve;
var i, j, cp, p : integer;
begin
	for i := 1 to n do begin
		j := GetPrev(i);
		cp := 1;
		while j <> i do begin
			if match[i, j] >= cp then cp := match[i, j] + 1;
			if cp > length(names[i]) then cp := MNOGO; 
			prs[j, i] := cp + 1;
			j := GetPrev(j);
		end;
	end;
	a[0] := 1;
	for i := 0 to k - 1 do begin
		DijkstRA(a[i]);
		writeln(dst[a[i + 1]]);
		npth := 0;
		j := a[i + 1];
		while j <> a[i] do begin
			inc(npth);
			pth[npth] := j;
			pbw[npth] := byw[j];
			j := prev[j];
		end;
		pth[npth + 1] := a[i];
		for j := npth downto 1 do begin
			if pbw[j] = 1 then begin
				writeln('down');
			end
			else if pbw[j] = 2 then begin
				writeln('up');
			end
			else begin
				writeln('Alt');
				for p := 1 to prs[pth[j + 1], pth[j]] - 1 do begin
					writeln(names[pth[j], p]);
				end;
			end;
		end;
	end;
end;

begin
	assign(input, 'fur.in');
	assign(output, 'fur.out');
	reset(input);
	rewrite(output);
	randseed := 1314;
	Load;
	Solve;
	close(input);
	close(output);
end.