Program prg;
                            {$O-}
{$APPTYPE CONSOLE}

uses
  SysUtils, Math;

const
  inf=1000000000;


type
  path=record
    len: integer;
    prev: integer;
  end;

var
  n: integer;
  i, j, l: integer;
  k: integer;
  d: array[0..1010, 0..1010] of path;
  arr: array[0..1010] of string;
  a: array[0..11] of integer;
  a1: integer;
  now, next: integer;


function countArrow(const a, b: integer): integer;
  begin
    result:=min(abs(a-b), (min(a, b))+(n-max(a, b)));
  end;


function getnum(const a, b: integer): integer;
  var
    i: integer;

  begin
    i:=0;
    while (i<length(arr[a]))and(i<length(arr[b]))and(arr[a][i+1]=arr[b][i+1]) do inc(i);
    result:=i;
  end;


function seeAlt(const a, b: integer): integer;
  var
    i, j: integer;
    len: integer;
    num: integer;

  begin
    num:=1;
    len:=countArrow(a, b);
    if len<3 then begin
      result:=inf;
      exit;
    end;

    if b>a then begin
      for i:=(a) to (b-1) do begin
        num:=max(num, getnum(i, b)+1);
      end;
    end else begin
      for i:=(a) to n do begin
        num:=max(num, getnum(i, b)+1);
      end;
      for i:=1 to (b-1) do begin
        num:=max(num, getnum(i, b)+1);
      end;
    end;

    result:=num+1;    // + Alt
  end;

procedure writeAlt(const a, b: integer);
  var
    i, j: integer;
    len: integer;
    num: integer;

  begin
    num:=1;
    len:=countArrow(a, b);

    if b>a then begin
      for i:=(a) to (b-1) do begin
        num:=max(num, getnum(i, b)+1);
      end;
    end else begin
      for i:=(a) to n do begin
        num:=max(num, getnum(i, b)+1);
      end;
      for i:=1 to (b-1) do begin
        num:=max(num, getnum(i, b)+1);
      end;
    end;
    writeln('Alt');
    for i:=1 to num do writeln(arr[b][i]);

  end;

procedure writeArrow(const a, b: integer);
  var
    i: integer;

  begin
    if abs(a-b)=min(abs(a-b), (min(a, b))+(n-max(a, b))) then begin
     if a<b then
      for i:=1 to (b-a) do writeln('down') else
      for i:=1 to (a-b) do writeln('up');
    end else begin
     if a<b then
      for i:=1 to (min(a, b))+(n-max(a, b)) do writeln('up') else
      for i:=1 to (min(a, b))+(n-max(a, b)) do writeln('down');
    end;
  end;


begin
  reset(input, 'fur.in');
  rewrite(output, 'fur.out');
  readln(n);
  for i:=1 to n do begin
    readln(arr[i]);
  end;
  readln(k);
  for i:=1 to k do begin
    read(a[i]);
  end;

  for i:=1 to n do begin
    for j:=1 to n do begin
      d[i][j].len:=countArrow(i, j);
      d[i][j].prev:=j;
    end;
  end;
  
  for l:=1 to n do begin
    for i:=1 to n do begin
      for j:=1 to n do begin
        if d[i][j].len=min(min(d[i][j].len, d[i][l].len+d[l][j].len), seeAlt(i, j)) then continue;
        if (d[i][l].len+d[l][j].len)=min(min(d[i][j].len, d[i][l].len+d[l][j].len), seeAlt(i, j)) then begin
          d[i][j].len:=d[i][l].len+d[l][j].len;
          d[i][j].prev:=d[i][l].prev;
        end else begin
          d[i][j].len:=seeAlt(i, j);
          d[i][j].prev:=j;
        end;

      end;
    end;
  end;

  a1:=1;
  for i:=1 to k do begin
    writeln(d[a1][a[i]].len);
    now:=a1;
    while now<>a[i] do begin
      next:=d[now][a[i]].prev;
      if SeeAlt(now, next)<countArrow(now, next) then
        writeAlt(now, next) else
        writeArrow(now, next);
      now:=next;
    end;
    a1:=a[i];
  end;


end.