{$R-,S-,Q-,I-,L-,B-,A+}
type
  int=longint;
const
  inf=maxlongint div 4;
  mx=1007;
  infile='fur.in';
 outfile='fur.out';
var
 was:array[1..mx]of boolean;
 p,d:array[1..mx]of int;
 wrd:array[1..mx]of string;
 key:array[1..2*mx*mx]of char;
 f,next,first,c:array[1..2*mx*mx]of int;
 a:array[1..mx,1..mx]of int;
 n,m:int;

procedure add(x:int;s:string);
var
 i,cur,u:int;
begin
  cur:=1;
  for i:=1 to length(s) do
   begin
     u:=first[cur];
     while u<>0 do
      begin
        if key[u]=s[i] then
          break;
        u:=next[u];
      end;
     if u=0 then
      begin
        inc(m);
        key[m]:=s[i];
        next[m]:=first[cur];
        first[cur]:=m;
        u:=m;
      end;
     cur:=u; 
   end;
  c[cur]:=x;
end;

function min(q,w:int):int;
begin
  if q<w then
   min:=q else
   min:=w;
end;

procedure dfs(u:int);
var
 i:int;
begin
  f[u]:=inf;
  i:=first[u];
  while i<>0 do
   begin
     dfs(i);
     f[u]:=min(f[u],f[i]);
     i:=next[i];
   end;
  if c[u]>0 then
   f[u]:=min(f[u],c[u]); 
end;

procedure init;
var
 i:int;
begin
  fillchar(c,sizeof(c),0);
  fillchar(key,sizeof(key),0);
  fillchar(first,sizeof(first),0);
  fillchar(next,sizeof(next),0);
  fillchar(f,sizeof(f),0);
  readln(n);
  m:=1;
  for i:=1 to n do
   begin
     readln(wrd[i]);
     add(i,wrd[i]);
   end;
  dfs(1);
end;

procedure rec(u,l:int;s:string);
var
 f1:boolean;
 i:int;
begin
  if not(was[f[u]])and(u<>1)then
   begin
     f1:=true;
     for i:=1 to n do
      if (length(s)>length(wrd[i]))or
         (length(s)<=length(wrd[i]))and(s<>copy(wrd[i],1,length(s)))then
        a[i,f[u]]:=min(a[i,f[u]],l+1) else
         begin
          if i<>f[u] then
            f1:=false;
         end;
     was[f[u]]:=f1;
   end;
  i:=first[u];
  while i<>0 do
   begin
     rec(i,l+1,s+key[i]);
     i:=next[i];
   end;
end;

procedure outp(x:int);
var
 i:int;
begin
  if p[x]>0 then
   begin
     outp(p[x]);
     if a[p[x],x]=1 then
      begin
        if x=1 then
         begin
            if p[x]=n then
             writeln('down') else
             writeln('up');
            exit;
         end;
        if x=n then
         begin
            if p[x]=1 then
             writeln('up') else
             writeln('down');
            exit; 
         end;
        if p[x]<x then
         writeln('down') else
         writeln('up'); 
      end else
      begin
        writeln('Alt');
        for i:=1 to a[p[x],x]-1 do
         writeln(wrd[x,i]);
      end;
   end;
end;

procedure dijkstra(s,t:int);
var
 i,u,m1:int;
begin
  fillchar(was,sizeof(was),0);
  fillchar(p,sizeof(p),0);
  for i:=1 to n do
   d[i]:=inf;
  d[s]:=0;
  while true do
   begin
     m1:=inf;
     u:=1;
     for i:=1 to n do
      if not(was[i])and(d[i]<m1)then
       begin
         m1:=d[i];
         u:=i;
       end;
      was[u]:=true;
      if u=t then
       break;
      for i:=1 to n do
       if not(was[i])and(d[i]>d[u]+a[u,i])then
        begin
          d[i]:=d[u]+a[u,i];
          p[i]:=u;
        end;
   end;
  writeln(d[t]);
  outp(t);
end;

procedure run;
var
 i,j,k,l,nx:int;
begin
  for i:=1 to n do
   for j:=1 to n do
    a[i,j]:=inf;
  for i:=1 to n-1 do
   begin
     a[i,i+1]:=1;
     a[i+1,i]:=1;
   end;
  a[1,n]:=1;
  a[n,1]:=1;
  fillchar(was,sizeof(was),0);
  rec(1,0,'');
  read(k);
  l:=1;
  for i:=1 to k do
   begin
     read(nx);
     dijkstra(l,nx);
     l:=nx;
   end;
end;

procedure opf;
begin
  assign(input,infile);
  reset(input);
  assign(output,outfile);
  rewrite(output);
end;

procedure clf;
begin
  close(input);
  close(output);
end;

begin
  opf;
  init;
  run;
  clf;
end.