program z2;
{$APPTYPE CONSOLE}
uses SysUtils, math;
const
 dirs :array[-1..1] of string = ('up','?','down');

var
 fL :integer;
 fNames :array of string;
 fjL :integer;
 fJumpTo :array of integer;
 f_o :textfile;

function  getDist(const n1,n2 :integer) :integer;
begin
 result := n2-n1;
 if abs(result) > fL div 2 then
   result := -fl*sign(result) + result;
end;

function  getDownDist(const n1,n2 :integer) :integer;
begin
 result := n2 - n1;
 if result < 0 then result := fl + result;
end;

function  traceFN (const fn :string; start :integer) :integer;
var
 i :integer;
begin
 i := start;
 while i <= fl-1 do
 if pos(fn,fNames[i]) = 1 then
  begin result := i; exit; end else
  inc(i);

 i := 0;
 while i <= start-1 do
 if pos(fn,fNames[i]) = 1 then
  begin result := i; exit; end else
  inc(i);
 result := -1; 
end;

procedure jump(cur,n :integer);
var
 i :integer;
 dst,alt_dst,l,cl :integer;
 traceID,sum_dst,sTraceDst,sTraceID :integer;
 curFn,sTrace :string;
begin
 dst := getDist(cur,n);
 l := length(fNames[n]);
 cl := 0; curFN := '';
 alt_dst := 1;
 sTraceDST := maxInt;

 while cl < l do
 begin
  inc(cl); inc(alt_dst);
  curFN := curFN + fNames[n][cl];
  traceID := traceFN(curFN,cur);
  sum_dst := alt_dst + abs(getDist(traceID,n));
  if sum_dst < sTraceDst then
  begin
   sTraceDst := sum_dst;
   sTraceID := traceID;
   sTrace := curFN;
  end;
  if traceID = n then break;
 end;

 if abs(dst) <= sTraceDst then
 begin
  writeln(f_o,abs(dst));
  for i := 1 to abs(dst) do
   writeln(f_o,dirs[sign(dst)]);
 end else
 begin
  writeln(f_o,sTraceDst);
  writeln(f_o,'Alt');
  for i := 1 to length(sTrace) do writeln(f_o,sTrace[i]);
  dst := getDist(sTraceID,n);

  for i := 1 to abs(dst) do
   writeln(f_o,dirs[sign(dst)]);
 end;
end;

var
 f :textfile;
 prevId,i :integer;

begin
 assignfile(f,'fur.in');
 reset(f);

 readln(f,fL);
 setLength(fNames,fL);
 for i := 0 to fL-1 do
  readln(f,fNames[i]);

 readln(f,fjL);
 setLength(fJumpTo,fjL);
 for i := 0 to fjL-1 do
  read(f,fJumpTo[i]);

 closefile(f);

 assignfile(f_o,'fur.out');
 rewrite(f_o);

 prevId := 0;
 for i := 0 to high(fJumpTo) do
 begin
  jump(prevId,fJumpTo[i]-1);
  prevId := fJumpTo[i]-1;
 end;

 closefile(f_o);

// writeln;
// readln;
end.
