program fur1;
type
   rec=record
      p,a:longint;
   end;
var
   a:array[1..1000,1..2000] of longint;
   amax:array[1..1000] of longint;
   heap:array[1..1000] of longint;
   hmax:longint;
   hpos:array[1..1000] of longint;
   prev:array[1..1000] of rec;
   d,done:array[1..1000] of longint;
   in1,out1:text;
   i,j,k,l,f,n,z:longint;
   c:char;
   ans:array[1..1000] of longint;
   anmax:longint;
   pos:longint;

procedure change(a,b:longint);
var
   c:longint;
begin
   c:=heap[a];
   heap[a]:=heap[b];
   heap[b]:=c;
   hpos[heap[a]]:=a;
   hpos[heap[b]]:=b;
end;

procedure siftup(a:longint);
var
  p:longint;
begin
   if a>1 then begin
      p:=a div 2;
      if d[heap[a]]<d[heap[p]] then begin
         change(a,p);
         siftup(p);
      end;
   end;
end;

procedure siftdown(a:longint);
var
   l,r,lage:longint;
begin
   l:=a*2;
   if (l<=hmax) and (d[heap[l]]<d[heap[a]]) then
      lage:=l
   else
      lage:=a;
   r:=a*2+1;
   if (r<=hmax) and (d[heap[r]]<d[heap[lage]]) then
       lage:=r;
   if lage<>a then begin
        change(a,lage);
        siftdown(lage);
   end;
end;

function extractMin:longint;
var
   i,j:longint;
begin
   extractmin:=heap[1];
   if hmax>1 then begin
      change(1,hmax);
      dec(hmax);
      siftdown(1);
   end;
end;

function cr1(a,b:longint):longint;
begin
   if a<=b then
      cr1:=b-a
   else
      cr1:=n-a+b;
end;

function cr2(a,b:longint):longint;
begin
   if a>=b then
      cr2:=a-b
   else
      cr2:=n-b+a;
end;

function cr3(a1,b:longint):longint;
var
   i,j,k:longint;
   bl:boolean;
begin
   i:=a1;
   k:=0;
   bl:=true;
   while (i<>b) and (bl) do begin
      j:=1;
      while (a[b][j]=a[i][j]) and (j<=amax[b]) do
        inc(j);
      if j<=amax[b] then begin
         if j>k then
            k:=j;
      end
      else begin
         bl:=false;
      end;
      if i=n then
         i:=1
      else
         inc(i);
   end;
   if bl then
      cr3:=k+1
   else
      cr3:=1000000;
end;

procedure dijkstra(t:longint);
var
   i,j,k,l:longint;
begin
   k:=extractmin;
   while (k<>t) do begin
      done[k]:=1;
      for i:=1 to N do begin
         if done[i]=0 then begin
            if cr1(k,i)+d[k]<d[i] then begin
               d[i]:=cr1(k,i)+d[k];
               prev[i].a:=1;
               prev[i].p:=k;
               siftup(hpos[i]);
            end;

            if cr2(k,i)+d[k]<d[i] then begin
               d[i]:=cr2(k,i)+d[k];
               prev[i].a:=2;
               prev[i].p:=k;
               siftup(hpos[i]);
            end;

            if cr3(k,i)+d[k]<d[i] then begin
               d[i]:=cr3(k,i)+d[k];
               prev[i].a:=3;
               prev[i].p:=k;
               siftup(hpos[i]);
            end;

         end;
      end;
      k:=extractmin;
   end;
end;

begin
   assign(out1,'fur.out');
   rewrite(out1);
   assign(in1,'fur.in');
   reset(in1);
   readln(in1,n);
   for i:=1 to n do begin
      while not eoln(in1) do begin
          read(in1,c);
          inc(amax[i]);
          a[i,amax[i]]:=ord(c);
      end;
      readln(in1);
   end;
   readln(in1,k);
   pos:=1;
   for i:=1 to k do begin
      fillchar(done,sizeof(done),0);
      for j:=1 to N do begin
         d[j]:=100000;
         heap[j]:=j;
         hpos[j]:=j;
      end;
      read(in1,l);
      hmax:=n;
      d[pos]:=0;
      siftup(pos);
      dijkstra(l);
      j:=l;
      anmax:=0;
      if d[l]=0 then
         writeln(out1,'0')
      else begin
         while j<>pos do begin
            inc(anmax);
            ans[anmax]:=j;
            j:=prev[j].p;
         end;
         inc(anmax);
         ans[anmax]:=pos;
         for j:=anmax-1 downto 1 do begin

            if prev[ans[j]].a=1 then begin
               f:=cr1(ans[j+1],ans[j]);
               writeln(out1,f);
               for z:=1 to f do
                   writeln(out1,'down');
            end;

            if prev[ans[j]].a=2 then begin
               f:=cr2(ans[j+1],ans[j]);
               writeln(out1,f);
               for z:=1 to f do
                   writeln(out1,'up');
            end;

            if prev[ans[j]].a=3 then begin
               f:=d[ans[j]]-d[ans[j+1]];
               writeln(out1,f);
               writeln(out1,'alt');
               for z:=1 to f-1 do
                   writeln(out1,chr(a[j+1][z]));
            end;
         end;
      end;
      pos:=l;
   end;
   close(in1);
   close(out1);
end.
