{$A+,B-,D-,E-,I-,L-,N-,Q-,R-,S-,X+,Y-}
{O-,R+,S+,Q+}
const
  infile='fur.in';
 outfile='fur.out';
 mx=1000+7;
 mx2=100+7;
 inf=maxlongint div 3;
 mxhesh=999997;
 mxprost=7;
 prost:array[0..mxprost-1] of longint=(117,13,127,3,97,997,521);
 heshmem=mx*mx;

var
 n,k,uk:longint;
 f:array[0..mx] of string;
 a:array[0..mx2] of longint;
 start:array[0..mx] of longint;
 w:array[0..mx,0..mx] of longint;
 first:array[0..mxhesh] of longint;
 next:array[0..heshmem] of longint;
 key:array[0..heshmem] of string;
 d,pr,path:array[0..mx] of longint;
 check:array[0..mx] of boolean;

procedure init;
var
 i:longint;
begin
 readln(n);
 for i:=1 to n do
  readln(f[i]);
 f[0]:=f[1];
 read(k);
 a[0]:=1;
 for i:=1 to k do
  read(a[i]);
end;

function succ(k:longint):longint;
begin
 if k<n then
  result:=k+1 else
   result:=1;
end;

procedure initialstart;
var
 i,j,l:longint;
 a,b:string;
begin
 for i:=1 to n do
  begin
   a:=f[i-1]+'#';
   b:=f[i]+'#';
   l:=length(b);
   j:=1;
   while (a[j]=b[j]) and (j<l) do
    inc(j);
   if j=l then
    start[i]:=inf else
     start[i]:=j;
  end;
end;

function min(a,b:longint):longint;
begin
 if a<b then
  min:=a else
   min:=b;
end;

function max(a,b:longint):longint;
begin
 if a>b then
  max:=a else
   max:=b;
end;

procedure clearhesh;
begin
 uk:=0;
 fillchar(first,sizeof(first),0);
end;

function heshcode(s:string):longint;
var
 i,n:longint;
begin
 n:=length(s);
 result:=n*n;
 for i:=1 to n do
  result:=(result+ord(s[i])*prost[i mod mxprost]) mod mxhesh;
end;

function ok(s:string):boolean;
var
 q:longint;
begin
 q:=first[heshcode(s)];
 result:=false;
 while q<>0 do
  begin
   if key[q]=s then
    begin
     result:=true;
     exit;
    end;
   q:=next[q];
  end;
end;

procedure add(s:string);
var
 q:longint;
begin
 if s='' then
  exit;
 q:=heshcode(s);
 if first[q]=0 then
  begin
   inc(uk);
   key[uk]:=s;
   next[uk]:=0;
   first[q]:=uk;
  end else
   begin
    q:=first[q];
    while next[q]<>0 do
     q:=next[q];
    inc(uk);
    key[uk]:=s;
    next[uk]:=0;
    next[q]:=uk; 
   end;
end;

procedure initial;
var
 i,j,k,lg:longint;
 ss:string;
begin
 initialstart;
 for i:=1 to n do
  for j:=i to n do
   begin
    w[i,j]:=min(abs(j-i),min(i,j)+n-max(i,j));
    w[j,i]:=w[i,j];
   end;
 for i:=1 to n do
  begin
   clearhesh;
   j:=i;
   while succ(j)<>i do
    begin
     j:=succ(j);
     k:=start[j];
     if k=inf then
      continue;
     lg:=length(f[j]);
     while ok(copy(f[j],1,k)) and (k<lg) do
      inc(k);
     if k=lg then
      if ok(f[j]) then
       continue; 
     w[i,j]:=min(w[i,j],1+k);
     ss:='';
     for k:=1 to lg do
      begin
       ss:=ss+f[j][k];
       add(ss);
      end;
    end;
  end;
end;

procedure writedubl(k:longint;q:string);
var
 i:longint;
begin
 for i:=1 to k do
  writeln(q);
end;

procedure writechars(q:string);
var
 i:longint;
begin
 for i:=1 to length(q) do
  writeln(q[i]);
end;

procedure done(s,t:longint);
var
 u,v,q,e,i:longint;
begin
 writeln(d[t]);
 u:=t;
 e:=1;
 path[1]:=t;
 while u<>s do
  begin
   inc(e);
   path[e]:=pr[u];
   u:=pr[u];
  end;
 dec(e); 
 for i:=e downto 1 do
  begin
   u:=path[i];
   v:=path[i+1];
   q:=0;
   if abs(u-v)=w[v,u] then
    inc(q);
   if u<v then
    inc(q);
   if (abs(u-v)=w[v,u]) or (min(u,v)+n-max(u,v)=w[v,u]) then
    begin
     if not odd(q) then
      writedubl(w[v,u],'up') else
       writedubl(w[v,u],'down');
    end else
     begin
      writeln('Alt');
      writechars(copy(f[u],1,w[v,u]-1));
     end;
  end;
end;

procedure solve(s,t:longint);
var
 i,u,v:longint;
begin
 for i:=0 to n do
  d[i]:=inf;
 d[s]:=0;
 fillchar(check,sizeof(check),0);
 while true do
  begin
   u:=0;
   for v:=1 to n do
    if (d[v]<d[u]) and (not check[v]) then
     u:=v;
   if (u=0) or (u=t) then
    break;
   check[u]:=true;
   for v:=1 to n do
    if not check[v] then
     if d[v]>d[u]+w[u,v] then
      begin
       d[v]:=d[u]+w[u,v];
       pr[v]:=u;
      end;
  end;
 done(s,t);
end;

procedure run;
var
 i:longint;
begin
 initial;
 for i:=1 to k do
  solve(a[i-1],a[i]);
end;

begin
 assign(input,infile);
 reset(input);
 assign(output,outfile);
 rewrite(output);
 init;
 run;
 close(input);
 close(output);
end.