{$apptype console}
{$h+}

program p2dpr;

const maxn = 1001;
      maxl = 2001;
      inf  = 1000000;

function min(x, y : integer) : integer;
begin
   if x < y then min := x else min := y;
end;

var m, lk : array [1..maxn, 1..maxl] of integer;
    ct    : array [1..maxn, 1..maxn] of char;
    s     : array [1..maxn] of string;
    len   : array [1..maxn] of integer;
    ind   : array [1..maxn] of integer;
    i, j, t, lm, ii, n, k : integer;

function find(l, r : integer) : integer;
var m, t : integer;
begin
   if l = r then begin
      t := lk[j][l];
      if t >= j then t := t-n;
      if t < ii then find := l else find := maxn+10;
      exit;
   end;
   m := (l+r) div 2;
   t := lk[j][m];
   if t >= j then t := t-n; 
   if t < ii then find := find(l, m) else find := find(m+1, r);
end;

var u    : array [1..maxn] of boolean;
    d, l : array [1..maxn] of integer;

procedure go(p1, p2 : integer);
var i, j, minv, cv : integer;
   procedure path(v : integer);
   var i : integer;
   begin
      if v = p1 then exit;
      path(l[v]);
      case ct[l[v]][v] of
         'u':begin
            for i := 1 to m[l[v]][v] do writeln('up');
         end;
         'd':begin
            for i := 1 to m[l[v]][v] do writeln('down');
         end;
         else begin
            writeln('ALT');
            for i := 1 to m[l[v]][v]-1 do writeln(s[v][i]);
         end;
      end;
   end;
begin
   for i := 1 to n do begin
      d[i] := inf; u[i] := false;
   end;
   d[p1] := 0;
   for i := 1 to n do begin
      minv := inf;
      for j := 1 to n do
         if not u[j] and (d[j] < minv) then begin
            minv := d[j]; cv := j;
         end;
      u[cv] := true;
      for j := 1 to n do
         if d[j] > minv+m[cv][j] then begin
            d[j] := minv+m[cv][j]; l[j] := cv;
         end;
   end;
   writeln(d[p2]);
   path(p2);
end;

begin
   reset(Input, 'fur.in');
   rewrite(Output, 'fur.out');

   readln(n);
   lm := 0;
   for i := 1 to n do begin
      readln(s[i]);
      len[i] := length(s[i]);
      ind[i] := i;
      if lm < len[i] then lm := len[i];
   end;

   for i := 1 to n do
      for j := 1 to n do begin
         ct[i][j] := 'd';
         m[i][j] := j-i;
         if j-i < 0 then m[i][j] := m[i][j]+n;
         t := i-j; if t < 0 then t := t+n;
         if t < m[i][j] then begin
            m[i][j] := t; ct[i][j] := 'u';
         end; 
      end;
  
   for i := 1 to n do begin 
      if i > 1 then lk[i][1] := i-1 else lk[i][1] := n;
      while s[lk[i][1]][1] <> s[i][1] do begin
         if lk[i][1] = 1 then lk[i][1] := n else dec(lk[i][1]);
      end;
   end;

   for j := 2 to lm do
      for i := 1 to n do
         if j <= len[i] then begin
            lk[i][j] := lk[i][j-1];
            while s[i][j] <> s[lk[i][j]][j] do lk[i][j] := lk[lk[i][j]][j-1];
         end;

   for i := 1 to n do
      for j := 1 to n do if i <> j then begin
         if i < j then ii := i else ii := i-n;
         t := find(1, len[j]);
         if t+1 < m[i][j] then begin
            m[i][j]  := t+1;
            ct[i][j] := '?';
         end;
      end;
   
   read(k);
   t := 1;
   for i := 1 to k do begin
      read(j); go(t, j); t := j;
   end;

   close(Input);
   close(Output);
end.