{$A8,B-,C+,D+,E-,F-,G+,H+,I+,J-,K-,L+,M-,N+,O+,P+,Q-,R-,S-,T-,U-,V+,W-,X+,Y+,Z1}
{$MINSTACKSIZE $00004000}
{$MAXSTACKSIZE $00100000}
{$IMAGEBASE $00400000}
{$APPTYPE GUI}
{$WARN SYMBOL_DEPRECATED ON}
{$WARN SYMBOL_LIBRARY ON}
{$WARN SYMBOL_PLATFORM ON}
{$WARN UNIT_LIBRARY ON}
{$WARN UNIT_PLATFORM ON}
{$WARN UNIT_DEPRECATED ON}
{$WARN HRESULT_COMPAT ON}
{$WARN HIDING_MEMBER ON}
{$WARN HIDDEN_VIRTUAL ON}
{$WARN GARBAGE ON}
{$WARN BOUNDS_ERROR ON}
{$WARN ZERO_NIL_COMPAT ON}
{$WARN STRING_CONST_TRUNCED ON}
{$WARN FOR_LOOP_VAR_VARPAR ON}
{$WARN TYPED_CONST_VARPAR ON}
{$WARN ASG_TO_TYPED_CONST ON}
{$WARN CASE_LABEL_RANGE ON}
{$WARN FOR_VARIABLE ON}
{$WARN CONSTRUCTING_ABSTRACT ON}
{$WARN COMPARISON_FALSE ON}
{$WARN COMPARISON_TRUE ON}
{$WARN COMPARING_SIGNED_UNSIGNED ON}
{$WARN COMBINING_SIGNED_UNSIGNED ON}
{$WARN UNSUPPORTED_CONSTRUCT ON}
{$WARN FILE_OPEN ON}
{$WARN FILE_OPEN_UNITSRC ON}
{$WARN BAD_GLOBAL_SYMBOL ON}
{$WARN DUPLICATE_CTOR_DTOR ON}
{$WARN INVALID_DIRECTIVE ON}
{$WARN PACKAGE_NO_LINK ON}
{$WARN PACKAGED_THREADVAR ON}
{$WARN IMPLICIT_IMPORT ON}
{$WARN HPPEMIT_IGNORED ON}
{$WARN NO_RETVAL ON}
{$WARN USE_BEFORE_DEF ON}
{$WARN FOR_LOOP_VAR_UNDEF ON}
{$WARN UNIT_NAME_MISMATCH ON}
{$WARN NO_CFG_FILE_FOUND ON}
{$WARN MESSAGE_DIRECTIVE ON}
{$WARN IMPLICIT_VARIANTS ON}
{$WARN UNICODE_TO_LOCALE ON}
{$WARN LOCALE_TO_UNICODE ON}
{$WARN IMAGEBASE_MULTIPLE ON}
{$WARN SUSPICIOUS_TYPECAST ON}
{$WARN PRIVATE_PROPACCESSOR ON}
{$WARN UNSAFE_TYPE OFF}
{$WARN UNSAFE_CODE OFF}
{$WARN UNSAFE_CAST OFF}
{$APPTYPE CONSOLE}
const
  MaxN = 1000;
  MaxM = 2000;
type
  str = array[1..MaxM] of char;
  MyArray = array[1..MaxN] of str;
  MyArray2 = array[1..MaxN, 1..MaxN] of longint;
  MyArray3 = array[0..MaxN] of longint;
  MyArray4 = array[1..MaxN] of boolean;
var
  A : MyArray;
  B : MyArray2;
  len, par, res : MyArray3;
  N, K, i, cur, d : longint;
  C : MyArray4;

function max(a, b : longint) : longint;
begin
  if a > b then
    max := a
  else
    max := b;
end;

procedure reading(i : longint);
begin
  len[i] := 0;
  while not seekeoln(input) do
   begin
    inc(len[i]);
    read(A[i][len[i]]);
   end;
  readln;
end;

procedure Init;
var
  i, j : longint;
  u, v, t : longint;

begin
  cur := 1;
  readln(N);
  fillchar(A, sizeof(A), 0);
  for i := 1 to N do
    reading(i);
  read(K);
  for i := 1 to N do
    B[i, i] := 0;
  for i := 1 to N do
    for j := 1 to N - 1 do
     begin
      u := (i + N - 1 - j) mod N + 1;
      v := (i + N + 1 - j) mod N;
      t := 0;
      while A[u][t] = A[i][t] do
        inc(t);
      B[u, i] := max(B[v, i], t);
    end;
  for i := 1 to N do
    for j := 1 to N - 1 do
     begin
      u := (i + N - 1 - j) mod N + 1;
      inc(B[u, i]);
      if ((i - u + N) mod N) < B[u, i] then
        B[u, i] := (i - u + N) mod N;
      if ((u - i + N) mod N) < B[u, i] then
        B[u, i] := (u - i + N) mod N;
     end;
end;

procedure dijkstra(beg : longint);
var
  i, j, min : longint;
begin
  res[0] := 398475;
  for i := 1 to N do
   begin
    res[i] := B[beg, i];
    C[i] := true;
    par[i] := beg;
   end;
  C[beg] := false;
  for i := 2 to N do
   begin
    min := 0;
    for j := 1 to N do
      if (C[j] = true) and (res[j] < res[min]) then
        min := j;
    C[min] := false;
    for j := 1 to N do
      if (C[j] = true) and ((res[min] + B[min, j]) < res[j]) then
       begin
        res[j] := res[min] + B[min, j];
        par[j] := min;
       end;
   end;
end;

procedure Solve;
var
  yk, t : longint;
  otv : MyArray3;
  i, j : longint;
begin
  dijkstra(cur);
  yk := d;
  otv[1] := d;
  t := 1;
  while yk <> cur do
   begin
    yk := par[yk];
    inc(t);
    otv[t] := yk;
   end;
  writeln(res[d]);   
  for i := t - 1 downto 1 do
   begin
    if B[otv[i + 1], otv[i]] = ((otv[i] - otv[i + 1] + N) mod N) then
      for j := 1 to B[otv[i + 1], otv[i]] do
        writeln('down')
    else
      if B[otv[i + 1], otv[i]] = ((otv[i + 1] - otv[i] + N) mod N) then
        for j := 1 to B[otv[i + 1], otv[i]] do
          writeln('up')
      else
       begin
        writeln('Alt');
        for j := 1 to (B[otv[i + 1], otv[i]] - 1) do
          writeln(A[otv[i]][j]);
       end;
   end;
end;

begin
  assign(input, 'fur.in');
  reset(input);
  assign(output, 'fur.out');
  rewrite(output);
  Init;
  for i := 1 to K do
   begin
    read(d);
    Solve;
    cur := d;
   end;
  close(input);
  close(output);
end.


