//{$A8,B-,C+,D+,E-,F-,G+,H+,I+,J-,K-,L+,M-,N+,O-,P+,Q+,R+,S+,T-,U-,V+,W-,X+,Y+,Z1}
{$A8,B-,C+,D-,E-,F-,G+,H+,I-,J-,K-,L-,M-,N+,O+,P+,Q-,R-,S-,T-,U-,V+,W-,X+,Y+,Z1}

program Problem2;

{$APPTYPE CONSOLE}

uses
  SysUtils, Math;

const inname='fur.in';
      outname='fur.out';
      maxn=1010;
      maxk=11;
      inf=maxlongint div 2;

type int=longint;
     real=extended;
     bool=boolean;

var n,k,last,new,best,bad,t,ll,len:int;
    s:array[0..maxn] of string;
    d:array[0..maxk] of int;
    p:array[0..maxn,0..maxn] of int;
    a:array[0..maxn] of int;
    l:array[0..maxn] of int;
    w:array[0..maxn] of string;

procedure done(x,y:int);
  var i,l1,l2:int;
begin
  l1:=length(s[x]);
  l2:=length(s[y]);

  p[x,y]:=0;

  i:=1;

  while (i<=l1) and (i<=l2) and (s[x,i]=s[y,i]) do begin
    inc(p[x,y]);
    inc(i);
  end;
end;

function next(x:int):int;
begin
  inc(x);

  if x>n then
    x:=1;

  result:=x;
end;

function prev(x:int):int;
begin
  dec(x);

  if x<1 then
    x:=n;

  result:=x;
end;

procedure mywrite(ch:char);
begin
  case ch of
    '1':writeln('down');
    '2':writeln('up');
    '3':writeln('Alt');
    else writeln(ch);
  end;
end;

procedure writeway(x:int);
  var i:int;
begin
  if x<1 then
    exit;

  writeway(l[x]);

  for i:=1 to length(w[x]) do
    mywrite(w[x,i]);
end;

procedure run;
  var i,j:int;
begin
  readln(n);
  for i:=1 to n do
    readln(s[i]);

  fillchar(p,sizeof(p),0);

  for i:=1 to n do
    for j:=1 to n do
      done(i,j);

  read(k);

  d[0]:=1;
  for i:=1 to k do
    read(d[i]);

  for i:=1 to k do begin
    fillchar(a,sizeof(a),0);

    last:=d[i-1];
    new:=d[i];

    a[last]:=0;
    l[last]:=0;
    w[last]:='';
    j:=next(last);

    while j<>last do begin
      a[j]:=a[prev(j)]+1;
      l[j]:=prev(j);
      w[j]:='1';

      best:=inf;
      bad:=2;

      t:=prev(j);
      ll:=0;
      while t<>prev(last) do begin
        if p[t,j]+2>bad then
          bad:=p[t,j]+2;
        if bad+a[t]<best then begin
          best:=a[t]+bad;
          ll:=t;
          len:=bad-1;
        end;

        t:=prev(t);
      end;

      if a[j]>best then begin
        a[j]:=best;
        l[j]:=ll;
        w[j]:='3'+copy(s[j],1,len);
      end;

      j:=next(j);
    end;

    best:=inf;
    bad:=1;
    j:=next(new);
    while j<>new do begin
      if bad+a[j]<best then begin
        best:=bad+a[j];
        ll:=j;
        len:=bad;
      end;

      inc(bad);
      j:=next(j);
    end;

    if best<a[new] then begin
      a[new]:=best;
      l[new]:=ll;
      w[new]:='';
      for j:=1 to len do
        w[new]:=w[new]+'2';
    end;

    writeln(a[new]);
    writeway(new);
  end;
end;

procedure openfiles;
begin
  assign(input,inname);
  assign(output,outname);
  reset(input);
  rewrite(output);
end;

procedure closefiles;
begin
  close(input);
  close(output);
end;

Begin
  openfiles;
  run;
  closefiles;
End.
 