#include <stdio.h>
#include <stdlib.h>

#define NN 2048

typedef struct {
	int h,l,n;
} PP;

PP a[NN];
int n;
int H;
int best = 0;
int b[NN];
int c[NN];

int cmp1(const void *a, const void *b) {
	return -((const PP *)a)->h+((const PP *)b)->h;
}

int cmp2(const void *a, const void *b) {
	return -((const PP *)b)->l+((const PP *)a)->l;
}

int cmp3(const void *a, const void *b) {
	return -(((const PP *)b)->l-((const PP *)a)->l+((const PP *)b)->h-((const PP *)a)->h);
}

int cmp4(const void *a, const void *b) {
	return +(((const PP *)b)->l-((const PP *)a)->l)-(((const PP *)b)->h-((const PP *)a)->h);
}

void change(void) {
	PP t;
	int x,y;
	x=rand()%n; y=rand()%n;
	t=a[x]; a[x]=a[y]; a[y]=t;
}

void solve(void) {
	int ch = 0;
	int i,j = 0;
	int cur = 0;
	for(i=0;i<n;i++) {
		if(ch+a[i].h+a[i].l>=H) {
			cur++;
			c[j++]=a[i].n;
		}
		ch+=a[i].h;
	}
	if(cur>best) {
		best = cur;
		for(i=0;i<best;i++)
			b[i]=c[i];
	}
/*	for(i=0;i<n;i++)
		c[i]=a[i].n;*/
}

void wr(void) {
	int i;
	printf("%d\n",best);
	for(i=0;i<best;i++)
		printf("%d ",b[i]);
	printf("\n");
/*	for(i=0;i<n;i++)
		printf("%d ",c[i]);
	printf("\n");*/
}

int main(void) {
	int i;
	srand(394856);
	freopen("advent.in","rt",stdin);
	freopen("advent.out","wt",stdout);
	scanf("%d",&n);
	for(i=0;i<n;i++) {
		a[i].n=i+1;
		scanf("%d%d",&a[i].h,&a[i].l);
	}
	scanf("%d",&H);
	qsort(a,n,sizeof(a[0]),cmp1);
	solve();
	for(i=0;i<2000000/n;i++) {
		change();
		solve();
	}
	qsort(a,n,sizeof(a[0]),cmp2);
	solve();
	for(i=0;i<2000000/n;i++) {
		change();
		solve();
	}
	qsort(a,n,sizeof(a[0]),cmp3);
	solve();
	for(i=0;i<2000000/n;i++) {
		change();
		solve();
	}
	qsort(a,n,sizeof(a[0]),cmp4);
	solve();
	for(i=0;i<2000000/n;i++) {
		change();
		solve();
	}
	wr();
	fclose(stdin);
	fclose(stdout);
	return 0;
}
