{$D+,I+,L+,Q+,R+,S+,H-,O-}
{$APPTYPE CONSOLE}
  Const ProblemID='advent';
        File_In=ProblemID+'.in';
        File_Out=ProblemID+'.out';
        MaxN=2000;
        MaxH=10000;
        Infinity=MaxLongInt Div 4;
  Type Int=LongInt;
  Var N,Pit : Int;
      H,L : Array [1..MaxN] Of Int;
      InAns,Use : Array [1..MaxN] Of Boolean;
      Num : Array [1..MaxN] Of Int;

Procedure OpenFiles;
Begin
  Assign(Input,File_In);
  ReSet(Input);
  Assign(Output,File_Out);
  ReWrite(Output);
End;

Procedure Init;
  Var I : Int;
Begin
  Read(N);
  For I :=1 To N Do Begin
    Read(H[I],L[I]);
    Num[I] :=I;
  End;
  Read(Pit);
End;

Procedure Swap(Var A,B : Int);
  Var C : Int;
Begin
  C :=A;
  A :=B;
  B :=C;
End;

Procedure Sort(Le,Ri : Int);
  Var I,J,X : Int;
Begin
  I :=Le;
  J :=Ri;
  X :=H[(I+J) Div 2];
  Repeat
    While H[I]<X Do Inc(I);
    While H[J]>X Do Dec(J);
    If I<=J Then Begin
      Swap(H[I],H[J]);
      Swap(L[I],L[J]);
      Swap(Num[I],Num[J]);
      Inc(I);
      Dec(J);
    End;
  Until I>J;
  If I<Ri Then Sort(I,Ri);
  If J>Le Then Sort(Le,J);
End;

Procedure Solve;
  Var Ans,I,InPit,J : Int;
      Ok : Boolean;
Begin
  FillChar(Use,SizeOf(Use),False);
  FillChar(InAns,SizeOf(InAns),False);
  Sort(1,N);
  Ans :=0;
  InPit :=0;
  For I :=1 To N Do Begin
    Ok :=True;
    While Ok Do Begin
      Ok :=False;
      For J :=N DownTo I Do 
        If Not(Use[J]) And (InPit+H[J]+L[J]>=Pit) Then Begin
          Inc(Ans);
          InAns[J] :=True;
          OK :=True;
          Inc(InPit,H[J]);
          Use[J] :=True;
        End;
    End;
    If Not Use[I] Then Begin
      Inc(InPit,H[I]);
      Use[I] :=True;
    End;
  End;
  WriteLn(Ans);
  For I :=1 To N Do
    if InAns[I] Then Write(Num[I],' ');
End;

Procedure CloseFiles;
Begin
  Close(Input);
  Close(Output);
End;

Begin
  OpenFiles;
  Init;
  Solve;
  CloseFiles;
End.