{$I-,Q-,R-,S-,O+,H-}
{$I+,Q+,R+,S+,O-,H+}
{$apptype console}
{$M 1000000, 10000000}

uses Math;

const
  cInFile = 'advent.in';
  cOutFile = 'advent.out';

  inf = maxlongint shr 1;
  eps = 1e-8;

  nmax = 106;
  hmax = 200;

type
  int = longint;
  real = extended;

  chel = record
    r, l, no : int;
  end;

var
  n : int;
  ans, ca : int;
  h : int;

  sh : int;
  p : array [1..nmax] of chel;
  cs : array [0..nmax] of int;
  a : array [0..nmax, 0..nmax, 0..nmax * hmax] of int;
  pr : array [0..nmax, 0..nmax, 0..nmax * hmax] of boolean;

  vv : array [1..nmax] of int;

  ck, cv, ps : int;
  u : array [1..nmax] of boolean;

procedure Solve;
var
  ii, i, j : int;
  x : chel;
begin
  for i:= 1 to n - 1 do
    for j:= i + 1 to n do
      if p[i].r + p[i].l < p[j].r + p[j].l then
      begin
        x:= p[i];
        p[i]:= p[j];
        p[j]:= x;
      end;

  cs[0]:= 0;
  for i:= 1 to n do cs[i]:= cs[i - 1] + p[i].r;
  sh:= cs[n];
  for ii:= 0 to n do
    for i:= 0 to n do
      for j:= 0 to cs[i] do a[ii, i, j]:= -inf;
  for ii:= 0 to n do
    for i:= 0 to n do
      for j:= 0 to cs[i] do pr[ii, i, j]:= false;
  a[0, 0, 0]:= inf;
  for ii:= 1 to n do
    for i:= 0 to ii do
      for j:= 0 to cs[i] do
      begin
        a[ii, i, j]:= a[ii - 1, i, j];
        if (j >= p[ii].r) and (i >= 1) then
          if a[ii, i, j] < min(a[ii - 1, i - 1, j - p[ii].r], j + p[ii].l) then
          begin
            a[ii, i, j]:= min(a[ii - 1, i - 1, j - p[ii].r], j + p[ii].l);
            pr[ii, i, j]:= true;
          end;
      end;
  ans:= 0;
  ca:= 0;
  for i:= 0 to n do
    for j:= 0 to sh do
      if a[n, i, j] + sh - j >= h then
      begin
        ans:= i;
        ca:= j;
      end;
  writeln(ans);
{  ck:= ans;
  cv:= ca;
  ps:= n;
  ans:= 0;
  fillchar(u, sizeof(u), 0);
  while ck <> 0 do
  begin
    if pr[ps, ck, cv] then
    begin
      inc(ans);
      vv[ans]:= ps;
      u[ps]:= true;
      dec(cv, p[ps].r);
      dec(ps);
      dec(ck);
    end else dec(ps);
  end;
  for i:= 1 to ans do write(p[vv[i]].no, ' ');
  writeln;
  for i:= 1 to n do
    if not u[i] then write(p[i].no, ' ');
  for i:= ans downto 1 do write(p[vv[i]].no, ' ');
  writeln;}
end;

procedure ReadData;
var
  i : int;
begin
  read(n);
  for i:= 1 to n do read(p[i].r, p[i].l);
  for i:= 1 to n do p[i].no:= i;
  read(h);
end;

var
  ii, tst : int;

begin
  assign(input,cinfile);
  assign(output,coutfile);
  reset(input);
  rewrite(output);
  ReadData;
  Solve;
{  read(tst);
  for ii:= 1 to tst do
  begin
    ReadData;
    Solve;
  end;}
  close(input);
  close(output);
end.
