{$I-,Q-,R-,S-,O+,H-}
{$I+,Q+,R+,S+,O-,H+}
{$apptype console}
{$M 1000000, 10000000}

uses Math;

const
  cInFile = 'advent.in';
  cOutFile = 'advent.out';

  inf = maxlongint shr 1;
  eps = 1e-8;

  nmax = 2001;

type
  int = longint;
  real = extended;

  chel = record
    r, l, rl, no : int;
  end;

var
  n : int;
  ans : int;
  
  sh, h : int;

  p : array [1..nmax] of chel;
  a : array [0..nmax, 0..nmax] of int;
  pb : array [0..nmax, 0..nmax] of boolean;

  vv : array [1..nmax] of int;

  ck, ps : int;
  u : array [1..nmax] of boolean;

procedure Solve;
var
  i, j : int;
  x : chel;
begin
  for i:= 1 to n do p[i].rl:= p[i].r + p[i].l;
  for i:= 1 to n - 1 do
    for j:= i + 1 to n do
      if p[i].rl > p[j].rl then
      begin
        x:= p[i];
        p[i]:= p[j];
        p[j]:= x;
      end;
  sh:= 0;
  for i:= 1 to n do inc(sh, p[i].r);
  a[0, 0]:= sh;
  for i:= 1 to n do a[0, i]:= -inf;
  for i:= 1 to n do
    for j:= 0 to i do
    begin
      pb[i, j]:= false;
      if j < i then a[i, j]:= a[i - 1, j] else a[i, j]:= - inf;
      if j = 0 then continue;
      if (a[i - 1, j - 1] + p[i].l >= h) and (a[i, j] < a[i - 1, j - 1] - p[i].r) then
      begin
        a[i, j]:= a[i - 1, j - 1] - p[i].r;
        pb[i, j]:= true;
      end;
    end;
  ans:= 0;
  for i:= 0 to n do
    if a[n, i] > -(inf div 2) then ans:= i;
  writeln(ans);
{  ck:= ans;
  ps:= n;
  ans:= 0;
  fillchar(u, sizeof(u[1]) * n, 0);
  while ck <> 0 do
  begin
    if pb[ps, ck] then
    begin
      inc(ans);
      vv[ans]:= ps;
      u[ps]:= true;
      dec(ck);
    end;
    dec(ps);
  end;
  for i:= 1 to ans do write(p[vv[i]].no, ' ');
  writeln;
  for i:= 1 to n do
    if not u[i] then write(p[i].no, ' ');
  for i:= 1 to ans do write(p[vv[i]].no, ' ');
  writeln;}
end;

procedure ReadData;
var
  i : int;
begin
  read(n);
  for i:= 1 to n do read(p[i].r, p[i].l);
  for i:= 1 to n do p[i].no:= i;
  read(h);
end;

var
  ii, tst : int;

begin
  assign(input,cinfile);
  assign(output,coutfile);
  reset(input);
  rewrite(output);
  ReadData;
  Solve;
{  read(tst);
  for ii:= 1 to tst do
  begin
    ReadData;
    Solve;
  end;}
  close(input);
  close(output);
end.
