program advent;

{$APPTYPE CONSOLE}

uses
  SysUtils;

var h,h2:Int64;
    ls:array[1..2000]of array[1..3]of integer;
    clr:array[1..2000]of boolean;
    i,n,k:integer;
    can:boolean;

procedure SortH(first,last:integer);
var l,r,x,i,j,k:integer;
begin
  x:=ls[(first+last)div 2,1];
  l:=first-1;
  r:=last+1;
  while true do begin
    repeat inc(l);until ls[l,1]>=x;
    repeat dec(r);until ls[r,1]<=x;
    if l<r then begin
      i:=ls[l,1];
      j:=ls[l,2];
      k:=ls[l,3];
      ls[l,1]:=ls[r,1];
      ls[l,2]:=ls[r,2];
      ls[l,3]:=ls[r,3];
      ls[r,1]:=i;
      ls[r,2]:=j;
      ls[r,3]:=k;
    end else break;
  end;
  if first<r then
    SortH(first,r);
  if (r+1)<last then
    SortH(r+1,last);
end;

function canit(id:integer):boolean;
var hm:Int64;
    i:integer;
begin
  hm:=h-(ls[id,1]+ls[id,2]);
  i:=n;
  while(i>id)and(hm>0) do begin
    if clr[ls[i,3]] then
      hm:=hm-ls[i,1];
    dec(i);
  end;
  if hm<=0 then canit:=true
  else begin
    i:=id-1;
    while(i>=1)and(hm>0)do begin
      if clr[ls[i,3]] then
        hm:=hm-ls[i,1];
      dec(i);
    end;
    if hm<=0 then canit:=true
    else canit:=false;
  end;
end;

begin
  assign(input,'advent.in');
  assign(output,'advent.out');
  reset(input);
  rewrite(output);

  readln(n);
  for i:=1 to n do begin
    readln(ls[i,1],ls[i,2]);
    ls[i,3]:=i;
    clr[i]:=true;
  end;
  readln(h);
  SortH(1,n);
  h2:=0;
  for i:=1 to n do
    h2:=h2+ls[i,1];
  can:=false;
  for i:=1 to n do
    if (h2+ls[i,2])>=h then can:=true;
  if not can then begin
    writeln(0);
  end else begin
    k:=0;
    for i:=1 to n do
      if canit(i) then begin
        clr[ls[i,3]]:=false;
        inc(k);
      end;
    writeln(k);
    for i:=1 to n do
      if not clr[i] then write(i,' ');
  end;

  close(input);
  close(output);
end.
