program _3;

{$APPTYPE CONSOLE}

const MaxN = 1000;

type TSchool = record
       w, l : longint;
     end;

var a : array [1..MaxN] of TSchool;
    ran : array [1..MaxN] of longint;
    n : longint;
    max : array [0..MaxN] of longint;
    h : longint;

procedure Init();
var i : longint;
begin
    Reset(input, 'advent.in');
    Rewrite(output, 'advent.out');
    Read(n);
    for i := 1 to n do Read(a[i].w, a[i].l);
    Read(h);
end;

procedure Swap(var a, b : longint);
var c : longint;
begin
    c := a;
    a := b;
    b := c;
end;

function Count() : longint;
var i : longint;
    s : longint;
begin
    s := 0;
    for i := 1 to n do s := s + a[ran[i]].w;
    i := 1;
    while s + a[ran[i]].l >= h do begin
      inc(i);
      s := s - a[ran[i]].w;
    end;
    Result := i - 1;
end;

procedure Solve();
var i, j : longint;
    x : longint;
begin
    Randomize;
    for i := 1 to 100000000 div n do begin
      for j := 1 to n do ran[j] := j;
      for j := 1 to n - 1 do Swap(ran[n - j + 1], ran[Random(n - j) + 1]);
      x := Count();
      if x > max[0] then begin
        max[0] := x;
        for j := 1 to x do max[j] := ran[j];
      end;
    end;
end;

procedure Print();
var i : longint;
begin
    Writeln(max[0]);
    for i := 1 to max[0] do Write(max[i], ' ');
    Close(input);
    Close(output);
end;

begin
    Init();
    Solve();
    Print();
end.
 