program advent;

uses SysUtils;

var peoples : array[0..2000,0..2] of Word;
    N,H     : Word;

     procedure swp(i,j : Word);
     var x : Word;
     begin
          x:=peoples[i,0];
          peoples[i,0]:=peoples[j,0];
          peoples[j,0]:=x;
          x:=peoples[i,1];
          peoples[i,1]:=peoples[j,1];
          peoples[j,1]:=x;
          x:=peoples[i,2];
          peoples[i,2]:=peoples[j,2];
          peoples[j,2]:=x;
     end;

     procedure Sort(b,e : Word);
     var x,i,j : Word;
     begin
          if b>=e then exit;
          x:=(b+e) div 2;
          x:=peoples[x,0]+peoples[x,1];
          i:=b; j:=e;
          while ((peoples[i,0]+peoples[i,1])>x) and (i<e) do inc(i);
          while ((peoples[j,0]+peoples[j,1])<x) and (j>b) do dec(j);
          repeat
                if (peoples[i,0]+peoples[i,1])<x then
                begin
                     swp(i,j);
                     inc(i);
                end else
                if (peoples[j,0]+peoples[j,1])>x then
                begin
                    swp(i,j);
                    dec(j);
                end else
                begin
                    inc(i); dec(j);
                end;
          until i>j;
          sort(b,j);
          sort(i,e);
     end;

     procedure Input;
     var f : Text;
         i : Word;
     begin
          Assign(f,'advent.in');
          Reset(f);

          ReadLn(f,N);

          for i:=1 to N do
          begin
              ReadLn(f,peoples[i,0],peoples[i,1]);
              peoples[i,2]:=i;
          end;
          ReadLn(f,H);
          Close(f);
          Sort(1,N);
          peoples[0,0]:=0; peoples[0,1]:=0;
     end;

     function Stay : Word;
     var height : Cardinal;
     begin
          result:=0;
          height:=0;
          while (height<H) and (result<N) do
          begin
               inc(result);
               height:=height+peoples[result,0]+peoples[result,1]-
                              peoples[result-1,1];
          end;
          if (result>0) and (height>H) then dec(result);
     end;

     procedure Output(cnt : Integer);
     var f : Text;
         i : Word;
     begin
          Assign(f,'advent.out');
          Rewrite(f);

          WriteLn(f,N-cnt);

          if cnt<N then
              for i:=cnt+1 to N do Write(f,peoples[i,2],' ');

          Close(f);
     end;

begin
     Input;
     Output(Stay);
end.
