{$APPTYPE CONSOLE}
program advent;

const
 taskid = 'advent';
 infile = taskid + '.in';
 outfile = taskid + '.out';
 maxn = 2000;

procedure init;
 begin
  assign(input, infile);
  assign(output, outfile);
  reset(input);
  rewrite(output);
 end;

var
 n, hh: integer;
 ll,h,ans,num: array [1..maxn] of integer;

procedure swap(var a,b: integer);
 var t: integer;
 begin
  t := a;
  a := b;
  b := t;
 end;

procedure sort(l,r: integer);
 var i,j,x: integer;
 begin
  i := l; j := r; x := h[(i+j) div 2];
  repeat
   while h[i] < x do inc(i);
   while x < h[j] do dec(j);
   if i<=j then begin
    swap(h[i], h[j]);
    swap(ll[i], ll[j]);
    swap(num[i], num[j]);
    inc(i);
    dec(j);
   end;
  until i>j;
  if l < j then sort(l, j);
  if i < r then sort(i, r);
 end;

procedure solve;
 var i: integer;
     s,k: integer;
 begin
  read(n);
  s := 0;
  for i := 1 to n do begin
   read(h[i], ll[i]);
   inc(s, h[i]);
  end;
  read(hh);
  for i := 1 to n do num[i] := i;
  sort(1,n);
  k := 0;
  for i := 1 to n do begin
   if s + ll[i] >= hh then begin
    inc(k);
    ans[k] := num[i];
    dec(s, h[i]);
   end;
  end;
  writeln(k);
  for i := 1 to k do write(ans[i], ' ');
 end;
  
begin
 init;
 solve;
end.