#include <stdio.h>
#include <memory.h>

#define MAXN 2000

struct chel
{
	int h, l;
};

struct chel a[MAXN];
int n, H, q;
int k[MAXN];
int a0[MAXN];
int res[MAXN];

void init()
{
	int i;
	freopen("advent.in", "r", stdin);
	freopen("advent.out", "w", stdout);
	memset(a, 0, sizeof(a));
	q = 0;
	for(i=0;i<MAXN;i++)
		a0[i] = i;
}

void readdata()
{
	int i;
	scanf("%d", &n);
	for(i=0;i<n;i++)
		scanf("%d%d", &a[i].h, &a[i].l);
	scanf("%d", &H);
}
void writedata()
{
	int i;
	printf("%d\n", q);
	for(i=0;i<q;i++)
		printf("%d ", res[i]);
}

void swap(int i, int j)
{
	struct chel t;
	int nt;
	nt = a0[i]; a0[i] = a0[j]; a0[j] = nt;
	t.h = a[i].h;
	t.l = a[i].l;
	a[i].h = a[j].h;
	a[i].l = a[j].l;
	a[j].h = t.h;
	a[j].l = t.l;
}

void qsort(int p, int q)
{
	int i = p-1;
	int j;
	if(p<q)
	{
		for(j=p;j<q;j++)
			if(a[j].h>a[q].h)
				swap(++i, j);
		swap(++i, q);
		qsort(p, i-1);
		qsort(i+1, q);
	}
}

void solve()
{
	int i;
	qsort(0, n-1);
	k[0] = a[0].h;
	for(i=1;i<n;i++)
		k[i] = a[i].h+k[i-1];
	i = n-1;
	while(i>=0)
	{
		if(k[i]+a[i].l>=H)
			res[q++] = a0[i]+1;
		i--;
	}
}

int main()
{
	init();
	readdata();
	solve();
	writedata();
	return 0;
}