#include <stdio.h>

#define MAXN 2048

long n;
long h[MAXN], len[MAXN], id[MAXN], t[MAXN];

void sort (long l, long r)
{
  long i=l, j=r, x=t[(l+r)/2], y;
  do
    {
      while (t[i]<x) i++;
      while (t[j]>x) j--;
      if (i<=j)
        {
          if (!(t[i]==t[j] && h[i]<h[j]))
            {
              y=t[i]; t[i]=t[j]; t[j]=y;
              y=h[i]; h[i]=h[j]; h[j]=y;
              y=id[i]; id[i]=id[j]; id[j]=y;
              y=len[i]; len[i]=len[j]; len[j]=y;
            }
          i++; j--;
        }
    } while (i<j);
  if (l<j) sort (l, j);
  if (i<r) sort (i, r);
}

int main ()
{
  long i, deep, cur;
  long ans[MAXN], count;
  long total_len, curlen;
  freopen ("advent.in", "r", stdin);
  freopen ("advent.out", "w", stdout);
  // Read data from disk
  scanf ("%ld", &n);
  total_len=0;
  for (i=0; i<n; i++)
    {
      scanf ("%ld %ld", &h[i], &len[i]);
      id[i]=i;
      t[i]=h[i]+len[i];
      total_len+=h[i];
    }
  scanf ("%ld", &deep);
  // Solve
  sort (0, n-1);
  cur=0;
  count=0; curlen=total_len+len[cur];
  while (cur<n)
    {
      if (curlen>=deep)
        ans[count++]=id[cur];
      total_len-=h[cur++];
      curlen=total_len+len[cur];
    }

  printf ("%ld\n", count);
  for (i=0; i<count; i++)
    printf ("%ld ", ans[i]+1);

  return 0;
}
