{ $define debug}
{ $define input}
{ $define output}
  {$ifndef debug} {$define input} {$define output} {$endif}
  procedure Done (ch :longint); forward;
  {$ifdef debug}

  {$else}

  {$endif}
const fname = 'advent';

var
  n,h :longint;
  hh,ll :array [1..2000] of longint;
  f     :array [1..2000] of boolean;
  st    :array [1..2000] of longint;
  stmax :longint;

procedure Run;
var
  i,j,k :longint;
begin
  read(n);
  for i := 1 to n do
    begin
      read(hh[i],ll[i]);
      f[i]:=false;
    end;
  read(h);

  for k := 1 to n do
    begin
      for i := 1 to n do
        if (hh[i]+ll[i]>=h) and (not f[i]) then
          break;
      if hh[i]+ll[i]>=h then
        begin
          inc(stmax);
          dec(h,hh[i]);
          st[stmax]:=i;
          f[i] := true;
          continue;
        end;
      for i := 1 to n do
        if not f[i] then break;
      j:=i;
      for i := i to n do
        if (not f[i]) and (hh[i]>hh[j]) then
          j:=i;
      dec(h,hh[j]);
      f[j]:=true;
    end;
end;

procedure WriteData (ch :longint);
var
  i :longint;
begin
  writeln(stmax);
  if stmax=0 then exit;
  for i := stmax downto 1 do
    write (st[i],' ');
  writeln;
end;

procedure Done (ch :longint); begin WriteData(ch); close(input); close(output); halt(0); end;
begin
  {$ifdef input} assign(input,fname+'.in'); reset(input); {$endif}
  {$ifdef output} assign(output,fname+'.out'); rewrite(output); {$endif}
  Run; Done(0);
end.
