#include <stdio.h>
#include <stdlib.h>

#define m 2010

int n, h[m], le[m], p[m], q[m], he, ans, al, a[m], k;

int less( int i, int j )
{
  return h[i] + le[i] < h[j] + le[j] || (h[i] + le[i] == h[j] + le[j] && h[i] > h[j]);
}

void sort1( int l, int r )
{
  int i, j, x, t;

  if (l >= r)
    return;
  i = l, j = r, x = p[l + rand() % (r - l + 1)];
  while (i <= j)
  {
    while (less(p[i], x)) i++;
    while (less(x, p[j])) j--;
    if (i <= j)
      t = p[i], p[i] = p[j], p[j] = t, i++, j--;
  }
  sort1(l, j), sort1(i, r);
}

void sort2( int l, int r )
{
  int i, j, x, t;

  if (l >= r)
    return;
  i = l, j = r, x = q[l + rand() % (r - l + 1)];
  while (i <= j)
  {
    while (h[q[i]] > h[x]) i++;
    while (h[q[j]] < h[x]) j--;
    if (i <= j)
      t = q[i], q[i] = q[j], q[j] = t, i++, j--;
  }
  sort2(l, j), sort2(i, r);
}

int main( void )
{
  int i, j, nu, s;

  srand(301703);
  freopen("advent.in", "rt", stdin);
  freopen("advent.out", "wt", stdout);
  scanf("%d", &n);
  for (i = 0; i < n; i++)
    scanf("%d%d", &h[i], &le[i]), p[i] = i;
  scanf("%d", &he);
  sort1(0, n - 1);
  ans = al = 0;
  for (i = 0; i < n; i++)
  {
    for (k = 0, j = i; j < n; j++)
      q[k++] = p[j];
    sort2(0, k - 1);
    for (s = 0, j = 0; j < i; j++)
      s += h[p[j]];
    for (nu = k, j = 0; j < k && s + h[p[i]] + le[p[i]] < he; j++)
      s += h[q[j]], nu--;
    if (s + h[p[i]] + le[p[i]] >= he)
    {
      fprintf(stderr, "can:%d %d\n", i, nu);
      if (nu > ans)
        for (ans = nu, al = 0; j < k; j++)
          a[al++] = q[j];
    }
  }
  printf("%d\n", ans);
  for (i = 0; i < al; i++)
    printf("%d ", a[i] + 1);
  return 0;
}
