program t;

{$APPTYPE CONSOLE}

uses
  SysUtils;

const
  inf = 'advent.in';
  outf = 'advent.out';

type
  TMyRec = record
    h, l, num: integer;
  end;

var
  a: array of TMyRec;
  done: array of integer;

procedure sort(l,r: integer);
var
  i,j,x: integer;
  y: TMyRec;
begin
  i:=l; j:=r; x:=a[(l+r) DIV 2].h;
  repeat
    while a[i].h<x do i:=i+1;
    while x<a[j].h do j:=j-1;
    if i<=j then
    begin
      y:=a[i]; a[i]:=a[j]; a[j]:=y;
      i:=i+1; j:=j-1;
    end;
  until i>j;
  if l<j then sort(l,j);
  if i<r then sort(i,r);
end;

var
  i, n, mh, h: integer;

procedure Add(x: integer);
begin
  setlength(done, length(done)+1);
  done[length(done)-1]:=x;
end;

begin
  assign(input, inf);
  reset(input);
  assign(output, outf);
  rewrite(output);

  setlength(done, 0);
  read(n);
  setlength(a, n);
  mh:=0;
  for i:=0 to n-1 do
  begin
    read(a[i].h, a[i].l);
    a[i].num:=i+1;
    mh:=mh+a[i].h;
  end;
  read(h);

  close(input);

  sort(0, n-1);

  for i:=0 to n-1 do
    if (mh+a[i].l) >= h then
    begin
      add(a[i].num);
      mh:=mh-a[i].h;
    end;

  write(length(done));

  if length(done) > 0 then
  begin
    writeln;
    write(done[0]);
    for i:=1 to length(done)-1 do
      write(' ', done[i]);
  end;

  close(output);
end.
