program Task3;

uses
  Windows,
  Messages,
  SysUtils,
  Variants,
  Classes,
  Math;

type
  TBoy = record
    Index, Height, Hand: Integer;
    Saved: Boolean;
  end;

var
  N, H, BoysSaved: Integer;
  Boy: array [1..2000] of TBoy;

procedure ReadInput;
var
  F: TextFile;
  I: Integer;
begin
  AssignFile(F, 'advent.in');
  Reset(F);
  ReadLn(F, N);
  for I := 1 to N do begin
    ReadLn(F, Boy[I].Height, Boy[I].Hand);
    Boy[I].Index := I;
    Boy[I].Saved := False;
  end;
  ReadLn(F, H);
  CloseFile(F);
end;

procedure WriteOutput;
var
  F: TextFile;
  S: AnsiString;
  I: Integer;
begin
  AssignFile(F, 'advent.out');
  Rewrite(F);
  WriteLn(F, BoysSaved);
  S := '';
  for I := 1 to N do
    if Boy[I].Saved then
      S := S + ' ' + IntToStr(Boy[I].Index);
  Write(F, TrimLeft(S));
  CloseFile(F);
end;

var
  I, J: Integer;
  TempBoy: TBoy;
  HeightWithoutHands: Int64;
begin
  ReadInput;
  BoysSaved := 0;

  HeightWithoutHands := 0;
  for I := 1 to N do
    Inc(HeightWithoutHands, Boy[I].Height);

  //    
  for I := 1 to N do
    for J := I + 1 to N do
      if Boy[J].Height < Boy[I].Height then begin
        TempBoy := Boy[I];
        Boy[I] := Boy[J];
        Boy[J] := TempBoy;
        Break;
      end;

  for I := 1 to N do begin
    if HeightWithoutHands + Boy[I].Hand >= H then begin
      //  
      Inc(BoysSaved);
      Boy[I].Saved := True;
      Dec(HeightWithoutHands, Boy[I].Height);
    end;
  end;

  WriteOutput;
end.
