{$O+,Q-,R-}
program Advent;

{$APPTYPE CONSOLE}

uses
  SysUtils;

const
  MaxN = 2000;

type
  TPupil= record
    n, h, l: integer;
  end;

var
  n, h0, i, s, c: integer;
  r: string;
  p: array [1..MaxN] of TPupil;

procedure QSort(l, r: integer);
var
  i, j, x: integer;
  y: TPupil;
begin
  i := l; j := r; x := p[(l+r) div 2].h;
  repeat
    while p[i].h < x do i := i+1;
    while x < p[j].h do j := j-1;
    if i <= j then
    begin
      y := p[i]; p[i] := p[j]; p[j] := y;
      i := i+1; j := j-1;
    end;
  until i > j;
  if l < j then QSort(l, j);
  if i < r then QSort(i, r);
end;

begin
  AssignFile(Input, 'advent.in');
  AssignFile(Output, 'advent.out');
  Reset(Input);
  Rewrite(Output);

  Readln(n);
  for i := 1 to n do
  begin
    Readln(p[i].h, p[i].l);
    p[i].n := i;
  end;
  Readln(h0);

  QSort(1, n);
  s := 0;
  c := 0;
  r := '';
  for i := 1 to n do Inc(s, p[i].h);
  for i := 1 to n do
  begin
    if s + p[i].l >= h0 then
    begin
      Inc(c);
      r := r + IntToStr(p[i].n) + ' ';
      Dec(s, p[i].h);
    end;
  end;
  Writeln(c);
  Writeln(TrimRight(r));

  CloseFile(Input);
  CloseFile(Output);
end.
