{$APPTYPE CONSOLE}
{$i-,q-,r-}

const id = 'advent';
      infile = id + '.in';
      outfile = id + '.out';

const maxn = 2000;
      maxs = 10000;

type int = longint;
     long = array [0..maxn+1] of int;

var a, b, c, cc : array [1..maxn] of int;
    p, pm, pmm : long;
    n, h, k : int;

procedure Init;
var
  i : int;
begin
  readln(n);
  for i := 1 to n do begin
    readln(a[i], b[i]);
    c[i] := i;
  end;
  readln(h);
end;

procedure swap(i, j : int);
var
  t : int;
begin
  t := a[i]; a[i] := a[j]; a[j] := t;
  t := b[i]; b[i] := b[j]; b[j] := t;
  t := c[i]; c[i] := c[j]; c[j] := t;  
end;

procedure qsort(l, r : int);
var
  i, j, x : int;
begin
  i := l; j := r; x := a[(l+r) div 2];
  while i <= j do begin
    while (a[i] > x) do inc(i);
    while (x > a[j]) do dec(j);
    if i <= j then begin
      swap(i, j);
      inc(i); dec(j);
    end;
  end;
  if l < j then qsort(l, j);
  if i < r then qsort(i, r);
end;

procedure Calc(p : long);
var
  i, t, kt : int;
begin
  t := 0;
  for i := 1 to n do
    inc(t, a[i] * p[i]);
  kt := 0; pm := p;
  for i := 1 to n do
    if (p[i] = 0) and (a[i] + b[i] + t >= h) then begin
      inc(kt);
      pm[i] := 2;
    end;
  if kt > k then begin
    k := kt;
    pmm := pm;
  end;
end;

procedure Add(var p : long);
var
  i, t : int;
begin
  t := 1;
  for i := 1 to p[0] do begin
    t := t + p[i];
    p[i] := t mod 2;
    t := t div 2;
  end;
  if t > 0 then begin
    inc(p[0]);
    p[p[0]] := 1;
  end;
end;

procedure Save(k : int; p : long);
var
  i : int;
begin
  writeln(k);
  for i := 1 to n do
    if p[i] = 2 then write(c[i],' ');
  writeln;   
end;

procedure Solve;
var
  t, i : int;
begin
  qsort(1, n);
{  fillchar(p, sizeof(p), 0);
  p[0] := 1; p[1] := 1;
  k := 0; i := 0;
  while true do begin
    Calc(p);
    Add(p);
    if p[0] > n then break;
    inc(i);
    if i > maxs then break;
  end;
  Save(k, pmm);}
  fillchar(cc, sizeof(cc), 0);
  t := 0;
  for i := 1 to n do
    cc[i] := cc[i-1] + a[i];
  i := n;
  while (cc[i-1] + a[i] + b[i] >= h) and (i > 1) do dec(i);
  writeln(n-i);
  for i := n downto i+1 do
    write(c[i],' ');
end;

BEGIN
  assign(input, infile); reset(input);
  assign(output, outfile); rewrite(output);
  Init;
  Solve;
  close(input); close(output);
END.