program advent;

uses
  SysUtils, Classes;

{$HINTS OFF}
{$WARNINGS OFF}

var
  InputFile, OutputFile : TextFile;
  N, H : Int64;
  AN : array[1..2, 1..2000] of Int64;
  I, J : Integer;
  State : Boolean;
  CurHeight : Integer;
  Tmp : Integer = 0;
  List : TStringList;
  sed : array[0..2000] of Boolean;

begin
  List := TStringList.Create;
  AssignFile(InputFile, 'advent.in');
  AssignFile(OutputFile, 'advent.out');
  Reset(InputFile);
  Rewrite(OutputFile);
  ReadLn(InputFile, N);
  for I := 1 to N do
    ReadLn(InputFile, An[1, I], An[2, I]);
  ReadLn(InputFile, H);
//-----------------------------------------
  State := True;
  while State do
  begin
    State := False;
    for I := 1 to N do
      begin
        if (An[1, I] > Tmp) and (sed[j] = false) then
          begin
            Tmp := An[1, I];
            sed[i] := True;
            CurHeight := CurHeight + Tmp;
            if CurHeight + An[2, I] >= H then
              List.Add(IntToStr(I));
          end;
      end;
    for J := 1 to N do
      if (An[1, J] + An[2, J] + CurHeight >= H) and (sed[j] = false) then
        begin
          List.Add(IntToStr(J));
          State := True;
        end else State := False;
   end;
  WriteLn(OutputFile, List.Count);
  for I := 0 to list.Count - 1 do
    Write(OutputFile, list[i], ' ');
//-----------------------------------------
  CloseFile(InputFile);
  CloseFile(OutputFile);
  List.Free;
end.

