program advent;

{$APPTYPE CONSOLE}

uses
  SysUtils;

type
  TSC = record
    H, L : LongWord;
    Nm   : Word;
  end;

var
  Fin, Fout  : Text;
  N, I, J, K : Word;
  Group      : array[1..2000] of TSc;
  Tmp        : TSC;
  H, Hs      : longword;
  Vybrs      : array[1..2000] of boolean;

begin
  Assign(Fin, 'advent.in');
  Assign(Fout, 'advent.out');
  Reset(Fin);
  Rewrite(Fout);
  Readln(Fin, N);
  HS:=0;
  For I:=1 to N do
  begin
    Group[I].Nm:=I;
    Readln(Fin, Group[I].H, Group[I].L);
    HS:=HS+Group[I].H;
    Vybrs[I]:=false;
  end;
  Readln(Fin, H);

  For I:=N-1 downto 2 do
  For J:=1 to I do
  begin
    if Group[J].H>Group[J+1].H then
    begin
      tmp:=Group[J];
      Group[J]:=Group[J+1];
      Group[J+1]:=Tmp;
    end;
  end;

  K:=0;

  For I:=1 to N do
  begin
    if Group[I].L+HS>=H then
    begin
      K:=K+1;
      HS:=HS-Group[I].H;
      Vybrs[Group[I].Nm]:=true;
    end;
  end;

  Writeln(Fout, K);
  For I:=1 to N do if Vybrs[I] then Write(Fout, I, ' ');

  Close(Fin);
  Close(Fout);
end.
