Program prg;

{$APPTYPE CONSOLE}

uses
  SysUtils;

type
  chel=record
    h, l: integer;
    index: integer;
    used: boolean;
  end;


var
  i, j, k: integer;
  L: integer;
  h, n: integer;
  arr: array[0..1010] of chel;
  maxl: integer;

procedure swap(a, b: integer);
  var
    t: chel;

  begin
    t:=arr[a];
    arr[a]:=arr[b];
    arr[b]:=t;
  end;


procedure qsort(l, r: integer);
  var
    lh, rh: integer;

  begin
    lh:=l;
    rh:=r;
    while (lh<rh) do begin
      while (lh<rh)and((arr[lh].h)<=(arr[rh].h)) do inc(lh);
      swap(lh, rh);
      while (lh<rh)and((arr[lh].h)<=(arr[rh].h)) do dec(rh);
      swap(lh, rh);
    end;
    if (lh-l)>1 then qsort(l, lh-1);
    if (r-rh)>1 then qsort(rh+1, r);
  end;

begin
  reset(input, 'advent.in');
  rewrite(output, 'advent.out');
  readln(n);
  for i:=1 to n do begin
    readln(arr[i].h, arr[i].l);
    arr[i].index:=i;
  end;
  readln(h);
  qsort(1, n);
  L:=0;
  for i:=1 to n do begin
    L:=L+arr[i].h;
  end;
  for i:=1 to n do begin
    if arr[i].l>maxl then maxl:=arr[i].l;
  end;

  if (L+maxl)<h then begin
    writeln(0);
    halt;
  end;

  for j:=1 to n do begin
    for i:=1 to n do begin
     if (not arr[i].used)and((L+arr[i].l)>h) then begin
      L:=L-arr[i].h;
      arr[i].used:=true;
      inc(k);
      break;
     end;
    end;
  end;

  writeln(k);
  for i:=1 to n do arr[i].used:=false; 
  L:=0;
  for i:=1 to n do begin
    L:=L+arr[i].h;
  end;

  for j:=1 to n do begin
    for i:=1 to n do begin
     if (not arr[i].used)and((L+arr[i].l)>h) then begin
      write(arr[i].index, ' ');
      L:=L-arr[i].h;
      arr[i].used:=true;
      break;
     end;
    end;
  end;

end.