type
  int=longint;
  pupil=record
        a,b,i:int64; end;
const
  mx=2001;
  infile='advent.in';
 outfile='advent.out';

var
  p:array[1..mx]of pupil;
  ans,ans1,ans2:array[1..mx]of int;
  h:int64;
  rs,res,res1,res2,n:int;

procedure swap(var x,y:pupil);
var
 z:pupil;
begin
 z:=x;
 x:=y;
 y:=z; 
end;

procedure sort(q,w:int);
var
 i,j:int;
begin
  for i:=q to w-1 do
   for j:=i+1 to w do
    if (p[i].a<p[j].a)or(p[i].a=p[j].a)and(p[i].b<p[j].b)then
     swap(p[i],p[j]);
end;

procedure init;
var
 i:int;
begin
  fillchar(p,sizeof(p),0);
  fillchar(ans,sizeof(ans),0);
  read(n);
  for i:=1 to n do
   begin
     read(p[i].a,p[i].b);
     p[i].i:=i;
   end;
  read(h);
  res1:=0;
  for i:=1 to n do
   if p[i].a+p[i].b>=h then
     begin
       inc(res1);
       ans1[res1]:=p[i].i;
       swap(p[res1],p[i]);
     end;
  sort(res1+1,n);
  rs:=res1;
end;

procedure solve1;
var
 i:int;
 all:int64;
begin
  res1:=rs;
  all:=0;
  for i:=1 to n do
   all:=all+p[i].a;
  i:=n;
  while true do
   if (i<=n)and(all+p[i].b>=h) then
    begin
      inc(res1);
      ans1[res1]:=p[i].i;
      all:=all-p[i].a;
      dec(i);
    end else
    break;
  if res1>n then
   res1:=n;
end;

procedure solve2;
var
 i:int;
 all,add:int64;
begin
  all:=0;
  for i:=1 to rs do
   all:=all+p[i].a;
  res2:=rs; 
  while true do
   begin
     add:=0;
     for i:=1 to n do
      if all+p[i].a+p[i].b>=h then
        begin
          inc(res2);
          ans[res2]:=p[i].i;
          swap(p[res2],p[i]);
          add:=p[i].a;
        end;
     if add=0 then
      exit;
   end;
end;

procedure run;
begin
  solve1;
  solve2;
  res:=res1;
  ans:=ans1;
  if res2>res1 then
   begin
     res:=res2;
     ans:=ans2;
   end;
end;

procedure done;
var
 i:int;
begin
  writeln(res);
  for i:=1 to res do
   write(ans[i],' ');
end;

procedure opf;
begin
  assign(input,infile);
  reset(input);
  assign(output,outfile);
  rewrite(output);
end;

procedure clf;
begin
  close(input);
  close(output);
end;

begin
  opf;
  init;
  run;
  done;
  clf;
end.