program z3;
{$APPTYPE CONSOLE}
uses SysUtils;
type
 TMan = record
  h,l,hl :integer;
 end;

var
 menL :integer;
 men :array of TMan;
 menU :array of boolean;
 sByH, sByHL :array of integer;
 holeH :integer;

 minHL_ID,minH_ID :integer;

var
 f,fo :textfile;
 i,j,k,sStart :integer;
 res :string;
 menSaved :integer;

begin
 assignfile(f,'advent.in');
 reset(f);
 readln(f,menL);
 setLength(men,menL);
 for i := 0 to menL-1 do
 begin
  readln(f,men[i].h,men[i].l);
  men[i].hl := men[i].h + men[i].l;
 end;

 readln(f,holeH);
 closefile(f);

 setLength(sByH,menL); setLength(sByHL,menL); setLength(menU,menL);
 fillChar(sByH[0],length(sByH)*sizeof(sByH[0]),0);
 fillChar(sByHL[0],length(sByHL)*sizeof(sByHL[0]),0);

 // By hl
 fillChar(menU[0],length(menU)*sizeof(menU[0]),0);
 sStart := 0;
 for i := 0 to menL-1 do
 begin
  k := 0;
  while menU[k] do inc(k);
  minHL_ID := k;

  for j := k+1 to menL-1 do if not menU[j] then
   if men[j].hl < men[minHL_ID].hl then minHL_ID := j;

  menU[minHL_ID] := true;
  sByHL[sStart] := minHL_ID;
  inc(sStart);
 end;

 // By h
 fillChar(menU[0],length(menU)*sizeof(menU[0]),0);
 sStart := 0;
 for i := 0 to menL-1 do
 begin
  k := 0;
  while menU[k] do inc(k);
  minH_ID := k;

  for j := k+1 to menL-1 do if not menU[j] then
   if men[j].h < men[minH_ID].h then minH_ID := j;

  menU[minH_ID] := true;
  sByH[sStart] := minH_ID;
  inc(sStart);
 end;

 minHL_ID := sByHL[0];
 minH_ID := sByH[0];

 // Selecting min
 fillChar(menU[0],length(menU)*sizeof(menU[0]),0);
 k := 0;
 for i := 0 to menL-1 do
 begin
  if k+men[minHL_ID].hl >= holeH then break;
  inc(k,men[ sByH[menL-i-1] ].h);
  menU[ sByH[menL-i-1] ] := true;
 end;

 res := '';
 menSaved := 0;

 for i := 0 to menL-1 do
 if not menU[i] then
 begin
  inc(menSaved);
  res := res + intToStr(i+1) + ' ';
 end;

 // k is still a pyramid height!
 for i := 0 to menL-1 do
 if menU[sByH[i]] then
  if k + men[sByH[i]].l >= holeH then
  begin
   inc(menSaved);
   menU[sByH[i]] := false;
   k := k - men[sByH[i]].h;
   res := res + intToStr(sByH[i]+1) + ' ';
  end;
{
 for i := 0 to menL-1 do write(sByHL[i]+1,' '); writeln;
 for i := 0 to menL-1 do write(sByH[i]+1,' '); writeln;
 writeln(minHL_ID);
 writeln(minH_ID);
}
 assignfile(fo,'advent.out');
 rewrite(fo);

 writeln(fo,menSaved);
 if menSaved > 0 then writeln(fo,res);

 closefile(fo);

// readln;
end.
