program adventure;

{$APPTYPE CONSOLE}

type stud=record
  h,l,n:integer;
 end;

var d:array[1..2000] of stud;
    k,i,ns,h:integer;
    s:array[1..2000] of boolean;
    ps:array[1..2000] of integer;

procedure swap(i,j:integer);
var t:stud;
begin
 t:=d[i]; d[i]:=d[j]; d[j]:=t;
end;

function part(a,b:integer):integer;
var i,j,x:integer;
begin
 i:=a-1; j:=b+1; x:=a;
 while true do begin
  repeat inc(i) until d[i].h>=d[x].h;
  repeat dec(j) until d[j].h<=d[x].h;
  if i<j then swap(i,j) else begin part:=j; exit; end;
 end;
end;

procedure sort(a,b:integer);
var d:integer;
begin
 if a<b then begin
  d:=part(a,b);
  sort(a,d);
  sort(d+1,b);
 end;
end;

begin
 assign(input,'advent.in'); reset(input);
 assign(output,'advent.out'); rewrite(output);
 read(k);
 for i:=1 to k do begin read(d[i].h, d[i].l); d[i].n:=i; end;
 read(h);
 sort(1,k);
 fillchar(ps,sizeof(ps),0); fillchar(s,sizeof(s),false); ns:=0;
 for i:=k downto 1 do ps[i]:=ps[i+1]+d[i].h;
 for i:=1 to k do
  if ps[i]+d[i].l>=h then begin s[i]:=true; inc(ns); end;
 writeln(ns);
 for i:=1 to k do if s[i] then write(d[i].n,' ');  
end.
