{$A8,B-,C+,D-,E-,F-,G+,H+,I-,J-,K-,L-,M-,N+,O+,P+,Q-,R-,S-,T-,U-,V+,W-,X+,Y+,Z1}
//{$A8,B-,C+,D+,E-,F-,G+,H+,I+,J-,K-,L+,M-,N+,O-,P+,Q+,R+,S+,T-,U-,V+,W-,X+,Y+,Z1}
program Problem3;

{$APPTYPE CONSOLE}

uses
  SysUtils;
type
  int=longint;
  real=extended;
  bool=boolean;
  TSch=record
    h,l,num:int;
    end;
const
  in_f='advent.in';
  out_f='advent.out';
  maxN=2000+5;
  tl=1.6/60/60/24;
  tl1=tl/2;
  tl2=5*tl/6;
  eps=1e-13;
var
  N:int;
  H:int;
  a:array[1..maxN] of TSch;
  k:real;
  cur,ans:array[1..maxN] of bool;
  t,answer:int;

  begtime:real;
  
function More(const a,b:TSch):bool;
begin
 More:=(a.h-a.l*K)-(b.h-b.l*K)>eps;
end;

procedure sort(l,r: integer);
var
  i,j: integer;
  x,y:TSch;
begin
  i:=l; j:=r; x:=a[L+Random(r-L+1)];
  repeat
    while More(x,a[i]) do i:=i+1;
    while More(a[j],x) do j:=j-1;
    if i<=j then
    begin
      y:=a[i]; a[i]:=a[j]; a[j]:=y;
      i:=i+1; j:=j-1;
    end;
  until i>j;
  if l<j then sort(l,j);
  if i<r then sort(i,r);
end;

procedure Swap(i,j:int);
var
y:Tsch;
begin
  y:=a[i]; a[i]:=a[j]; a[j]:=y;
end;

procedure Run;
var
 i,j:int;
 s,cs:int;
begin
  Read(n);
  for i := 1 to N do
    begin
      a[i].num:=i;
      Read(a[i].h,a[i].l);
    end;
  Read(h);  

  s:=0;
  for i := 1 to N do
    inc(s,a[i].h);
  RandSeed:=s;  

  fillchar(ans,sizeof(ans),0);
  answer:=0;
  
  while now<begtime+tl do
    begin

      k:=3*random-0.5;

      fillchar(cur,sizeof(cur),0);
      t:=0;
      cs:=s;
      Sort(1,N);
      if now>begtime+tl1 then
        for i := 1 to N Do
          Swap(random(n)+1,random(n)+1);
      if now>begtime+tl2 then
        for i := 1 to 4*N Do
          Swap(random(n)+1,random(n)+1);

      for i:= 1 to N Do
        if a[i].l+cs>=H then
          begin
            inc(t);
            dec(cs,a[i].h);
            cur[a[i].num]:=true;
          end;
     if t>answer then
       begin
         answer:=t;
         ans:=cur;
       end;     
   end;
  Writeln(answer);
  for i := 1 to N do
    if ans[i] then
      WRite(i,' ');
end;

procedure OpenFiles;
begin
REset(input,in_f);
REwrite(output,out_f);
end;

procedure CloseFiles;
begin
Close(input);
CLose(output);
end;

begin
  begtime:=now;
  OPenFiles;
  Run;
  CLoseFiles;
end.
