{$apptype console}

program p3dpr;

const maxn = 2001;

var d, lk     : array [0..maxn, 0..maxn] of integer;
    h, l, ind : array [0..maxn] of integer;
    i, j, n, h0, t : integer;

begin
   randseed := 571;
   reset(Input, 'advent.in');
   rewrite(Output, 'advent.out'); 
   
   read(n); h0 := 0;
   for i := 1 to n do begin
      read(h[i], l[i]); h0 := h0+h[i]; ind[i] := i;
   end;
   read(h[0]);

   for i := 1 to n-1 do
      for j := i+1 to n do
         if (h[j] < h[i]) or ((h[j] = h[i]) and (l[j] < l[i])) then begin
            t := h[i]; h[i] := h[j]; h[j] := t;
            t := l[i]; l[i] := l[j]; l[j] := t;
            t := ind[i]; ind[i] := ind[j]; ind[j] := t;
         end;

   for i := 0 to n do
      for j := 1 to n do d[i][j] := -1;
   for i := 0 to n do d[i][0] := h0;

   fillchar(lk, sizeof(lk), 0);
   for i := 1 to n do
      for j := 1 to n do begin
         d[j][i] := d[j-1][i];
         if d[j-1][i-1] >= 0 then
            if d[j-1][i-1]+l[j] >= h[0] then
               if d[j][i] < d[j-1][i-1]-h[i] then begin
                  d[j][i] := d[j-1][i-1]-h[i]; lk[j][i] := 1;
               end;
      end;
   i := n;
   while d[n][i] < 0 do dec(i);

   writeln(i);
   for j := n downto 1 do begin
      if lk[j][i] > 0 then begin
         write(ind[j], ' '); dec(i);
      end;
   end;
   writeln;
    
   close(Input);
   close(Output);
end.