#include <stdio.h>
#include <time.h>
#include <stdlib.h>

#define NUM 2010

int n;
int h[NUM], l[NUM];
int depth;
int adr[NUM];
int hsum[NUM];

int anum;
int ans[NUM];

int main(int argc, char **argv) {
	srand(666);
	freopen("advent.in", "r", stdin);
	freopen("advent.out", "w", stdout);
	int start = clock();
	bool timeover = false;
	scanf("%d", &n);
	int i, j;
	for (i = 0; i<n; i++)
		scanf("%d%d", h+i, l+i);
	scanf("%d", &depth);
	hsum[0] = 0;
	for (i = 0; i<n; i++) {
		adr[i] = i;
		hsum[i+1] = hsum[i] + h[i];
	}
	while (1) {
		if (timeover)
			if (clock() - start >= CLOCKS_PER_SEC*1.5)
				break;
		if (clock() - start >= CLOCKS_PER_SEC) {
			if (!timeover) {
				timeover = true;
				for (i = 0; i<10000; i++) {
					int ci = rand()%(n-1);
					hsum[ci+1] += h[adr[ci+1]] - h[adr[ci]];
					int buff = adr[ci];
					adr[ci] = adr[ci+1];
					adr[ci+1] = buff;
				}
			}
		}
		bool reset = false;
		for (i = 0; i<n-1; i++) {
			int c1 = 0;
			c1 += (hsum[i] + h[adr[i]] + l[adr[i]]) >= depth;
			c1 += (hsum[i] + h[adr[i]] + (h[adr[i+1]]+l[adr[i+1]])) >= depth;
			int c2 = 0;
			c2 += (hsum[i] + h[adr[i+1]] + l[adr[i+1]]) >= depth;
			c2 += (hsum[i] + h[adr[i+1]] + (h[adr[i]]+l[adr[i]])) >= depth;
			if (c2>c1) {
				reset = true;
				hsum[i+1] += h[adr[i+1]] - h[adr[i]];
				int buff = adr[i];
				adr[i] = adr[i+1];
				adr[i+1] = buff;
			}
		}
		if (!reset)
			break;
	}
	for (i = n-1; i>=0; i--) {
		if (hsum[i] + (h[adr[i]]+l[adr[i]]) >= depth) {
			ans[anum] = adr[i];
			anum++;
		}
	}

	printf("%d\n", anum);
	for (i = 0; i<anum; i++)
		printf("%d ", ans[i]+1);
	return 0;
}                        