program advent;

{$APPTYPE CONSOLE}

uses
  SysUtils;

type
  int = longint;

function min(a, b : int) : int;
begin
  if a < b then min := a else min := b;
end;

function max(a, b : int) : int;
begin
  if a > b then max := a else max := b;
end;

var
  n : int;
  l, h, wh : array [1..2000] of int;
  hh, ll : int;
  HM : int;


procedure swap(a, b : int );
var
  c : int;
begin
  c := h[a];
  h[a] := h[b];
  h[b] := c;
  c := l[a];
  l[a] := l[b];
  l[b] := c;
  c := wh[a];
  wh[a] := wh[b];
  wh[b] := c;
end;


procedure sort;
var
  i, j : int;
begin
  for i := 1 to n do
    for j := i + 1 to n do
      if (h[i] < h[j]) or ((h[i] = h[j]) and (l[i] > l[j])) then
        swap(i, j);
end;

var
  i, j, k : int;
  s : int;

begin
  reset(input, 'advent.in');
  rewrite(output, 'advent.out');
  read(n);
  for i := 1 to n do
  begin
    read(h[i], l[i]);
    wh[i] := i;
  end;
  read(HM);
  sort;
  hh := h[1];
  ll := l[1];
  i := 1;
  while (i < n) and (hh + ll < HM) do
  begin
    inc(i);
    hh := hh + h[i];
    if l[i] > ll then ll := l[i];
  end;
  if (i = n) and (hh + ll < HM) then
  begin
    writeln(0);
    halt(0);
  end;
  k := n - i + 1;
  for j := 1 to i - 1 do
    if h[j] + l[j] >= HM then
      inc(k);
  writeln(k);
  for j := 1 to i - 1 do
    if h[j] + l[j] >= HM then
      write(wh[j], ' ');
  for i := i to n do
    write(wh[i], ' ');
end.
