{$APPTYPE CONSOLE}
const
  MaxN = 2000;
type
  chel = record
    h, l : longint;
  end;
  MyArray = array[1..MaxN] of chel;
  MyArray2 = array[1..MaxN] of integer;
var
  A : MyArray;
  B, C : MyArray2;
  N, h, num : longint;

procedure Init;
var
  i : longint;
begin
  read(N);
  for i := 1 to N do
   begin
    read(A[i].h, A[i].l);
    B[i] := i;
   end;
  read(h);
end;

function less(x, y : chel) : boolean;
begin
  if (x.h + x.l) < (y.h + y.l) then
    less := true
  else
    less := ((x.h + x.l) = (y.h + y.l)) and (x.h < y.h);
end;

procedure swap(x, y: longint);
begin
  if B[x] <> B[y] then
   begin
    B[x] := B[x] xor B[y];
    B[y] := B[x] xor B[y];
    B[x] := B[x] xor B[y];
   end;
end;

procedure proc(l, r : longint; m : chel; var x, y : longint);
var
  i : longint;
begin
  x := l;
  y := l;
  for i := l to r do
    if less(A[B[i]], m) then
     begin
      swap(i, x);
      if x <> y then
        swap(i, y);
      inc(x);
      inc(y);
     end
    else
      if not less(m, A[B[i]]) then
       begin
        swap(i, y);
        inc(y);
       end;
end;

procedure qsort(l, r : longint);
var
  x, y : longint;
begin
  if l < r then
   begin
    proc(l, r, A[B[(l + r) div 2]], x, y);
    qsort(l, x - 1);
    qsort(y, r);
   end;
end;

procedure Solve;
var
  yk, S, i : longint;
begin
  S := 0;
  for i := 1 to N do
    inc(S, A[i].h);
  qsort(1, N);
  yk := 0;
  i := 0;
  repeat
    inc(yk);
    if S + A[B[yk]].l >= H then
     begin
      inc(i);
      C[i] := B[yk];
      dec(S, A[C[i]].h);
     end;
  until yk = N;
  num := i;
end;

procedure Print;
var
  i : longint;
begin
  writeln(num);
  for i := 1 to num do
    write(C[i], ' ');
end;

begin
  assign(input, 'advent.in');
  reset(input);
  Init;
  close(input);
  Solve;
  assign(output, 'advent.out');
  rewrite(output);
  Print;
  close(output);
end.
