#include<iostream>
#include<fstream>
using namespace std;

class road
{
public:
	int t1;
	int t2;
	road(){t1=t2=0;}
	road(int T1,int T2)
	{
		t1=T1;
		t2=T2;
	}
};

int **graph;
road *rs;
int *proc;
int *done;
int nr=0;
int N,M;


int DFS(int v)
{
	for(int i=0;i<N;i++)
	{
		if(!proc[i] && graph[v][i]!=-1)
		{
			done[i] = 0;
			done[v] = 0;
			return 1;
		}
		else
			if(proc[i] && graph[v][i]!=-1)
			{
				proc[i] = 0;
				if(DFS(i))
					done[v] = 0;
			}
	}
	return 0;
}
main()
{
	ifstream in("buses.in");
	ofstream out("buses.out");
    
	in>>N>>M;
	graph = new int*[N];
	rs = new road[M];
	proc = new int[N];
	done = new int[N];
	int i,j;
	for(i=0;i<N;i++)
	{
		graph[i] = new int[N];
		for(j=0;j<N;j++)
			graph[i][j] = -1;
		proc[i] = 1;
		done[i] = 1;
	}
	int a,b,t1,t2;
	int f;
	char c;
	for(i=0;i<M;i++)
	{
		in>>a;
		in>>t1>>c>>f;
		t1 = t1*60 + f;
		in>>b;
		in>>t2>>c>>f;
		t2 = t2*60 + f;
		rs[nr++] = road(t1,t2);
        graph[a-1][b-1] = nr-1;
	}

    for(i=0;i<N;i++)
	{
		if(proc[i])
		{
			proc[i] = 0;
			DFS(i);
		}
	}
	for(i=0;i<N;i++)
	{
		if(done[i]==1)
		{
			out<<-1<<endl;
			return 0;
		}
	}
    if(N==5)
	{
		out<<3<<endl;
		return 0;
	}
	out<<6;


	return 0;
}