{$APPTYPE CONSOLE}
{$I-,Q-,R-,S-,O+}
type tbus=record
       src,dst,t1,t2:longint;
     end;
var n,m,i,ans,cur:longint;
    bus:array [1..100000] of tbus;
    bal,nl,na:array [1..100000] of longint;
    arrive,leave,lnum:array [1..100000] of array of longint;
    was:array [1..100000] of boolean; 
function convert(c1,c2:char):longint;
begin
  convert:=(byte(c1)-byte('0'))*10+byte(c2)-byte('0');
end;
procedure readtime(var t:longint);
var c1,c2,ch,c3,c4:char;
begin
  read(c1);
  while not (c1 in ['0'..'9']) do
    read(c1);
  read(c2,ch,c3,c4);
  t:=convert(c1,c2)*60+convert(c3,c4);
end;
procedure readbus(var b:tbus);
begin
  with b do
  begin
    read(src);
    readtime(t1);
    read(dst);
    readtime(t2);
  end;  
end;
procedure qsort(var a:array of longint;l,r:longint);
var i,j,m,t:longint;
begin
  i:=l;
  j:=r;
  m:=a[l+random(r-l+1)];
  repeat
    while a[i]<m do
      inc(i);
    while a[j]>m do
      dec(j);
    if i<=j then
    begin
      t:=a[i];
      a[i]:=a[j];
      a[j]:=t;
      inc(i);
      dec(j);
    end;    
  until i>j;
  if l<j then
    qsort(a,l,j);
  if i<r then
    qsort(a,i,r);  
end;
procedure dfs(x:longint);
var i,p,q:longint;
begin
  was[x]:=true;
  for i:=1 to nl[x] do
    if not was[bus[lnum[x,i]].dst] then
      dfs(bus[lnum[x,i]].dst);
  p:=1; {arrive}
  q:=1; {leave}
  while (p<=nl[x]) or (q<=nl[x]) do
  begin
    if p>nl[x] then 
    else if q>nl[x] then
    begin
      inc(cur);
      inc(p);
    end  
    else if arrive[x,p]<=leave[x,q] then
    begin
      inc(p);
      inc(q);
    end
    else inc(q);
  end;    
end;
begin
  assign(input,'buses.in');
  reset(input);
  assign(output,'buses.out');
  rewrite(output);
  readln(n,m);
  for i:=1 to m do
    readbus(bus[i]);
  fillchar(bal,sizeof(bal),0);
  fillchar(nl,sizeof(nl),0);
  fillchar(na,sizeof(na),0);
  for i:=1 to m do
  begin
    inc(bal[bus[i].src]);
    dec(bal[bus[i].dst]);
    inc(nl[bus[i].src]);
    inc(na[bus[i].dst]);
  end;
  for i:=1 to n do
  begin
    if bal[i]<>0 then
    begin
      writeln(-1);
      close(input);
      close(output);
      halt;
    end;
    setlength(arrive[i],na[i]+1);
    setlength(leave[i],nl[i]+1);
    setlength(lnum[i],nl[i]+1);    
  end;
  fillchar(nl,sizeof(nl),0);
  fillchar(na,sizeof(na),0);
  for i:=1 to m do
  begin
    inc(nl[bus[i].src]);
    inc(na[bus[i].dst]);
    leave[bus[i].src,nl[bus[i].src]]:=bus[i].t1;
    lnum[bus[i].src,nl[bus[i].src]]:=i;    
    arrive[bus[i].dst,na[bus[i].dst]]:=bus[i].t2;    
  end;
  for i:=1 to n do
  begin
    qsort(leave[i],1,nl[i]);
    qsort(arrive[i],1,na[i]);
  end;
  fillchar(was,sizeof(was),false);
  ans:=0;
  cur:=0;
  for i:=1 to n do
    if not was[i] then
    begin
      inc(ans);
      dfs(i);
      if cur>0 then
        inc(ans,cur-1);
    end;
  writeln(ans);  
  close(input);
  close(output);
end.
