#include <fstream>
#include <windows.h>

#define tm 1440

struct rc
{
	rc *next;
    int f, g;
	int y;

};

struct sput
{
	sput *next;
	int g;
};

int n, m;
rc *ar[tm];
sput *put[tm];
int bus[100000];

void rcadd(rc * & h, int f, int g, int y)
{
	rc *r = new rc;
	r->f = f;
	r->g = g;
	r->y = y;
	r->next = h;
	h = r;
}

void sputadd(int y, int g)
{
	sput *s = new sput;
	s->g = g;
	s->next = put[y];
	put[y] = s;
}

void prib(int t)
{
	sput *p = put[t];
	while (p)
	{
		bus[p->g]++;
		sput *pp = p->next;
		delete p;
        p = pp;
	}
	put[t] = NULL;
}

using namespace std;

int main()
{
	ifstream fi;
	ofstream fo;
	int res = 0;
	DWORD time = GetTickCount();
	int vhvih[100000];

	for (int i = 0; i < tm; i++)
	{
		ar[i] = NULL;
		put[i] = NULL;
	}
	for (int i = 0; i < 100000; i++) {
		bus[i] = 0;
		vhvih[i] = 0;
	}

	fi.open("buses.in");
	fi >> n >> m;
	for (int i = 0; i < m; i++)
	{
		int f, g, x, xx, y, yy;
		char c;
		fi >> f >> x >> c >> xx;
		x = x * 60 + xx;
		fi >> g >> y >> c >> yy;
		y = y * 60 + yy;
		vhvih[f]++;
		vhvih[g]--;
		rcadd(ar[x], f, g, y);
	}
	fi.close();

	int uv = 0;
	for (int i = 0; i < 100000; i++)
		if (!uv && vhvih[i])
			uv = 1;

	if (!uv)
	{
		int u;
		int sct = 0;
		int uu = 0;
		do
		{
			u = 0;
			for (int i = 0; i < tm; i++)
			{
				prib(i);
				rc *r = ar[i];
				while (r)
				{
					if (bus[r->f] > 0)
						bus[r->f]--;
					else {
						res++;
						u = 1;
					}
					sputadd(r->y, r->g);
					r = r->next;
				}
			}
			if (u == 1)
				sct = 0;
			else
				sct++;
			DWORD tt = GetTickCount();
			if (tt - time >= 1900)
				uu = 1;
		} while (sct <= tm && !uu);
	}

	fo.open("buses.out");
	if (!uv)
		fo << res;
	else
		fo << -1;
	fo.close();

	return 0;
}
