{ $define debug}
{$define input}
{ $define output}
{$ifndef debug} {$define input} {$define output} {$endif}
procedure Done (ec :longint); forward;
const
  fname = 'buses'; finp = fname + '.in'; fout = fname + '.out';
{$ifdef debug}

{$else}

{$endif}

var
  n,m,k :longint;
  rs :array [1..200000] of longint;
  tw :array [1..200000] of longint;
  opt:array [1..200000] of longint;
  tk,dtk :array [1..100000] of longint;

procedure Swap (var a,b :longint);
begin
  if a=b then exit;
  a := a xor b;
  b := a xor b;
  a := a xor b;
end;

procedure QS (s,e :longint);
var
  i,j :longint;
begin
  if s>=e then exit;
  i:=s; j:=e;
  while i<j do
    begin
      while (i<j) and (rs[i]<=rs[j]) do inc(i);
      Swap (rs[i], rs[j]); Swap (tw[i], tw[j]); Swap (opt[i], opt[j]);
      while (i<j) and (rs[i]<=rs[j]) do dec(j);
      Swap (rs[i], rs[j]); Swap (tw[i], tw[j]); Swap (opt[i], opt[j]);
    end;
  QS(s,i-1); QS(j+1,e);
end;

procedure Run;
var
  i,mm :longint;
  procedure ReadTrsr;
  var
    c1,c2,c3,c4 :char;
  begin
    inc(m);
    read(tw[m]);
    repeat read(c1) until c1<>' ';
    read(c2,c3,c3,c4);
    rs[m] := rs[m] * 0 + (ord(c1)-ord('0'));
    rs[m] := rs[m] *10 + (ord(c2)-ord('0'));
    rs[m] := rs[m] *24 + (ord(c3)-ord('0'));
    rs[m] := rs[m] *10 + (ord(c4)-ord('0'));

    opt[m]:=m;
  end;
begin
  read(n,mm);
  for i := 1 to mm do
    begin
      ReadTrsr;
      ReadTrsr;
      readln;
    end;

  QS(1,m);

  for i := 1 to m do
    if odd(opt[i])
      then
        begin
          if tk[tw[i]]=0 then inc(k) else dec(tk[tw[i]]);
          dec(dtk[tw[i]]);
        end
      else
        begin
          inc(tk[tw[i]]);
          inc(dtk[tw[i]]);
        end;

  for i := 1 to n do
    if dtk[i]<>0 then Done(-1);
end;

procedure WriteData (ec :longint);
begin
  if ec=-1 then writeln(-1) else writeln(k);
end;

procedure Done (ec :longint); begin WriteData(ec); close(input); close(output); halt(0); end;
begin
  {$ifdef input}  assign (input,  finp); reset  (input);  {$endif}
  {$ifdef output} assign (output, fout); rewrite(output); {$endif}
  Run;
  Done(0);
end.
