{$apptype console}

const max_n = 100000;
      max_m = 100000;

var g: array [1..max_n] of longint;
    u, v, ut, vt, next: array [1..max_m] of longint;
    vis, bus: array [1..max_n] of boolean;
    i, j, n, m, ans: longint;
    ch: char;

procedure Botva;
begin
  write(-1);
  close(input); close(output);
  halt(0);
end;

procedure swap(var a, b: longint);
var c: longint;
begin
  c := a; a := b; b := c;
end;

function Less(x, y, a, b: longint): boolean;
begin
  if x = a then result := y < b
  else result := x < a;
end;

procedure QSort(l, r: longint);
var i, j, x, y: longint;
begin
  i := random(r-l)+l;
  x := ut[i]; y := vt[i];
  i := l; j := r;
  repeat
    while Less(ut[i], vt[i], x, y) do inc(i);
    while Less(x, y, ut[j], vt[j]) do dec(j);
    if i <= j then begin
      swap(u[i], u[j]);
      swap(v[i], v[j]);
      swap(ut[i], ut[j]);
      swap(vt[i], vt[j]);
      inc(i); dec(j);
    end;
  until i > j;
  if l < j then QSort(l, j);
  if i < r then QSort(i, r);
end;

procedure AddEdge(k: longint);
begin
  next[k] := g[u[k]];
  g[u[k]] := k;
end;

function Dfs(x, t: longint): longint;
var i, k, kk: longint;
begin
  result := 0;
  vis[x] := true;

  k := 0; kk := 0;
  i := g[x];
  while i <> 0 do begin
    if t <= ut[i] then begin
      if not vis[v[i]] then begin
        inc(result, Dfs(v[i], vt[i]));
        inc(k);
      end;
      bus[x] := true;
    end else inc(kk);
    i := next[i];
  end;
  if k = 0 then result := 1 + kk;
end;

begin
  reset(input, 'buses.in');
  rewrite(output, 'buses.out');

  fillchar(g, sizeof(g), 0);
  fillchar(next, sizeof(next), 0);

  read(n, m);
  for i := 1 to m do begin
    read(u[i], ch); // space
    read(ch); ut[i] := 10*(ord(ch) - ord('0'));
    read(ch); ut[i] := ut[i] + ord(ch) - ord('0');
    read(ch); // :
    read(ch); ut[i] := 60*ut[i] + 10*(ord(ch) - ord('0'));
    read(ch); ut[i] := ut[i] + ord(ch) - ord('0');

    read(v[i], ch); // space
    read(ch); vt[i] := 10*(ord(ch) - ord('0'));
    read(ch); vt[i] := vt[i] + ord(ch) - ord('0');
    read(ch); // :
    read(ch); vt[i] := 60*vt[i] + 10*(ord(ch) - ord('0'));
    read(ch); vt[i] := vt[i] + ord(ch) - ord('0');
  end;

  QSort(1, m);

  for i := 1 to m do AddEdge(i);

  for i := 1 to n do
    if g[i] = 0 then Botva;

  ans := 0;
  fillchar(vis, sizeof(vis), false);
  fillchar(bus, sizeof(bus), false);
  for i := 1 to m do
    if not vis[u[i]] then
      inc(ans, Dfs(u[i], 0));

  write(ans);

  close(input); close(output);
end.