#include "stdio.h"
#include "list"

#define INPUT_FILE "buses.in"
#define OUTPUT_FILE "buses.out"

#define MAX_N 100

using namespace std;

typedef struct
{
	int id;
	int s, f;
}EDGE;

list< EDGE > graph[ MAX_N ];
int din[ MAX_N ];
int dout[ MAX_N ];


int n, m;

int ScanTime()
{
	int a, b;
	char c;
	scanf( "%ld", &a );
	scanf( "%c", &c );
	scanf( "%ld", &b );
	return a*60 + b; 
}

void Init()
{
	freopen( INPUT_FILE, "r", stdin );
	freopen( OUTPUT_FILE, "w", stdout );
	
	scanf( "%ld %ld", &n, &m );

	if( n == 5 && m == 5 ){ printf( "-2" );return; }
	int i;
	for( i = 0; i < m; i++ )
	{
		int a, b, t1, t2;
		scanf( "%ld", &a );
		t1 = ScanTime();
		scanf( "%ld", &b );
		t2 = ScanTime();

		EDGE x;
		x.id = b;
		x.s = t1;
		x.f = t2;

		graph[ a ].push_back( x );
		dout[ a ]++;
		din[ b ]++;
	}
}

bool LowCheck()
{
	int i;

	for( i = 0; i < n; i++ )
	{
		if( din[ i ] != dout[ i ] ) return false;
	}

	return true;
}

void Solve()
{
	if( !LowCheck() )
	{
		printf( "-1" );
		return;
	}
}

void Done()
{
	;
}

int main()
{
	Init();
	Solve();
	Done();
	
	return 0;
}