program buses;
uses
    sysutils;
const
    maxN=100000;
    in_file='buses.in';
    out_file='buses.out';
type
    TRec=record
           number,time:integer;
         end;
    TRebro=record
             f,t:integer;
           end;

var
    pribiv,otprav:array[1..maxN]of TRec;
    i,j,k,n,m,time,x,y,qf,ql:integer;
    t:string[5];
    ch:char;
    count,linko,linkp,link,Q:array[1..maxN]of integer;
    mark:array[1..maxN]of boolean;
    answer,min:integer;
    OK:boolean;
    c:integer;
    list:array[1..maxN]of TRebro;

procedure sortpribiv(const l,r:integer);
var i,j:integer;
    x,y:TRec;
begin
   i:=l; j:=r; x:=pribiv[(i+j)div 2];
   repeat
      while (pribiv[i].number<x.number)or((pribiv[i].number=x.number)and(pribiv[i].time<x.time)) do inc(i);
      while (pribiv[j].number>x.number)or((pribiv[j].number=x.number)and(pribiv[j].time>x.time)) do dec(j);
      if i<=j then
      begin
         y:=pribiv[i]; pribiv[i]:=pribiv[j]; pribiv[j]:=y;
         inc(i); dec(j);
      end;
   until i>j;
   if i<r then sortpribiv(i,r);
   if j>l then sortpribiv(l,j);
end;
procedure sortotprav(const l,r:integer);
var i,j:integer;
    x,y:TRec;
begin
   i:=l; j:=r; x:=otprav[(i+j)div 2];
   repeat
      while (otprav[i].number<x.number)or((otprav[i].number=x.number)and(otprav[i].time<x.time)) do inc(i);
      while (otprav[j].number>x.number)or((otprav[j].number=x.number)and(otprav[j].time>x.time)) do dec(j);
      if i<=j then
      begin
         y:=otprav[i]; otprav[i]:=otprav[j]; otprav[j]:=y;
         inc(i); dec(j);
      end;
   until i>j;
   if i<r then sortotprav(i,r);
   if j>l then sortotprav(l,j);
end;
procedure sortlist(const l,r:integer);
var i,j:integer;
    x,y:TRebro;
begin
   i:=l; j:=r; x:=list[(i+j)div 2];
   repeat
      while (list[i].f<x.f)or((list[i].f=x.f)and(list[i].t<x.t)) do inc(i);
      while (list[j].f>x.f)or((list[j].f=x.f)and(list[j].t>x.t)) do dec(j);
      if i<=j then
      begin
         y:=list[i]; list[i]:=list[j]; list[j]:=y;
         inc(i); dec(j);
      end;
   until i>j;
   if i<r then sortlist(i,r);
   if j>l then sortlist(l,j);
end;

{procedure find(const x:integer);
var i:integer;
begin
   for i:=1 to n do if (not mark[i])and(can[x,i]) then
   begin
      c:=c+count[i];
      mark[i]:=true;
      find(i);
   end;
end; }

begin
   fillchar(pribiv,sizeof(pribiv),0);
   fillchar(otprav,sizeof(otprav),0);
   fillchar(count,sizeof(count),0);
   fillchar(mark,sizeof(mark),0);
   fillchar(linko,sizeof(linko),0);
   fillchar(linkp,sizeof(linkp),0);
   assign(input,in_file); reset(input);
   read(n,m);
   for i:=1 to m do
   begin
      read(x);read(ch);read(t);
      otprav[i].time:=strtoint(copy(t,1,2))*60+strtoint(copy(t,4,2));
      otprav[i].number:=x;
      read(y);read(ch);read(t);
      pribiv[i].time:=strtoint(copy(t,1,2))*60+strtoint(copy(t,4,2));
      pribiv[i].number:=y;
      list[i].f:=x; list[i].t:=y;
   end;
   close(input);
   sortpribiv(1,m);
   sortotprav(1,m);
   linko[otprav[1].number]:=1;
   linkp[pribiv[1].number]:=1;
   link[list[1].f]:=1;
   for i:=2 to m do
   begin
       if otprav[i].number<>otprav[i-1].number then linko[otprav[i].number]:=i;
       if pribiv[i].number<>pribiv[i-1].number then linkp[pribiv[i].number]:=i;
       if list[i].f<>list[i-1].f then link[list[i].f]:=i;
   end;
   OK:=true;
   i:=1;
   while (i<=m)and OK do
   begin
      if (linko[i]<>0)and(linkp[i]=0) then OK:=false;
      inc(i);
   end;
   if OK then
   begin
      i:=1;j:=1;
      while (i<=m)and(j<=m) do
      begin
        while (pribiv[i].number=otprav[j].number)and(i<=m)and(j<=m) do
        begin
           if pribiv[i].time<=otprav[j].time then
           begin
              inc(i);
              inc(j);
           end
               else
           begin
              inc(count[pribiv[i].number]);
              inc(j);
           end;
         end;
         i:=linkp[otprav[j].number];
      end;
      answer:=0;
      for k:=1 to n do if not mark[k] then
      begin
        qf:=0;ql:=1; q[1]:=k;
        c:=count[k];
        mark[k]:=true;
        while qf<ql do
        begin
           inc(qf);
           x:=link[q[qf]];
           while list[x].f=q[qf] do
           begin
              if not mark[list[x].t] then
              begin
                 inc(ql);
                 q[ql]:=list[x].t;
                 mark[list[x].t]:=true;
                 c:=c+count[list[x].t];
              end;
              inc(x);
           end;
        end;
        if c in [0,1] then inc(c);
        answer:=answer+c;
     end;
   end else answer:=-1;
   assign(output,out_file);
   write(answer);
   close(output);
end.
