program buses;

uses
  SysUtils, Classes;

type
  TQTime = record
    Hours   : Integer;
    Minutes : Integer;
  end;

  TQElement = record
    St1, St2     : Integer;
    Time1, Time2 : TQTime;
    B : Boolean;
  end;

var
  InputFile, OutputFile : TextFile;
  N, M, I, J : Integer;
  Ras : array of TQElement;
  Stadts : array of Boolean;
  Times : array of TQTime;
  Str, TimeMinutes1, TimeMinutes2, TimeHours1, TimeHours2, St1, St2 : string;
  State : Integer;
  buseslist : TStringList;
  Result : Boolean;

begin
  buseslist := TStringList.Create;
  AssignFile(InputFile, 'buses.in');  Reset(InputFile);
  AssignFile(OutputFile, 'buses.out');  Rewrite(OutputFile);
  ReadLn(InputFile, N, M);
  SetLength(Ras, M);
  SetLength(Stadts, N);
  SetLength(Times, N);
  for I := 1 to M do
    begin
      ReadLn(InputFile, Str);
      State := 1;
      for J := 1 to Length(Str) do
        case State of
          1 : if Str[j] <> ' ' then St1 := St1 + Str[j] else State := 2;
          2 : if Str[j] <> ':' then TimeHours1 := TimeHours1 + Str[j] else State := 3;
          3 : if Str[j] <> ' ' then TimeMinutes1 := TimeMinutes1 + Str[j] else State := 4;
          4 : if Str[j] <> ' ' then St2 := St2 + Str[j] else State := 5;
          5 : if Str[j] <> ':' then TimeHours2 := TimeHours2 + Str[j] else State := 6;
          6 : TimeMinutes2 := TimeMinutes2 + Str[j];
        end;
      Ras[i-1].St1 := StrToInt(St1);
      Ras[i-1].St2 := StrToInt(St2);
      Ras[i-1].Time1.Hours := StrToInt(TimeHours1);
      Ras[i-1].Time1.Minutes := StrToInt(TimeMinutes1);
      Ras[i-1].Time2.Hours := StrToInt(TimeHours2);
      Ras[i-1].Time2.Minutes := StrToInt(TimeMinutes2);
      St1          := '';
      St2          := '';
      TimeHours1   := '';
      TimeMinutes1 := '';
      TimeHours2   := '';
      TimeMinutes2 := '';
    end;
//------------------------------------------------------------------------------
  for I := 0 to Length(Ras) - 1 do
    begin
      if (Stadts[Ras[i].St1] = False) {or (Times[Ras[i].St1].Hours > Ras[i].Time1.Hours)} then
        buseslist.Add(IntToStr(Ras[i].St1));
      Stadts[Ras[i].St2] := True;
      Stadts[Ras[i].St1] := False;
      //Times[Ras[i].St2] := Ras[i].Time2;
    end;
  for I := 0 to buseslist.Count - 1 do
    if Stadts[StrToInt(buseslist[i])] = False then
      begin
        Result := False;
        WriteLn(OutputFile, -1);
        Break;
      end else Result := True;
   if Result then WriteLn(OutputFile, buseslist.count);
//------------------------------------------------------------------------------
  buseslist.free;
  CloseFile(InputFile);
  CloseFile(OutputFile);
end.
