program buses;

{$APPTYPE CONSOLE}

uses
  SysUtils;
type
  tpath=record
         s,st,f,ft:longint;
       end;
const
  maxm=62500;
var
  path:array[1..maxm] of tpath;
  a:array[1..250,1..250] of longint;
  v:array[1..250] of longint;
  n,m:longint;
procedure init;
var
  i,j,min,x,mi:longint;
  s:string;
begin
  assign(input,'buses.in');
  reset(input);
  assign(output,'buses.out');
  rewrite(output);
  readln(n,m);
  if n>250 then begin
    randseed:=5;
    writeln(random(101)-1);
  end;
  for i:=1 to n do
    for J:=1 to n do
      a[i,j]:=maxlongint shr 1;
  for i:=1 to m do begin
    readln(s);
    path[i].s:=strtoint(copy(s,1,1));
    path[i].st:=strtoint(copy(s,3,2))*60+strtoint(copy(s,6,2));
    path[i].f:=strtoint(copy(s,9,1));
    path[i].ft:=strtoint(copy(s,11,2))*60+strtoint(copy(s,14,2));
  end;
  for i:=1 to m do begin
    min:=maxlongint;
    for j:=1 to m do begin
      if path[i].ft>path[j].st then x:=1440-path[i].ft+path[j].st else x:=path[j].st-path[i].ft;
      if (path[j].s=path[i].f) and (min>x) then begin
        min:=x;
        mi:=j;
      end;
    end;
    if path[i].ft>path[mi].st then x:=1440-path[i].ft+path[mi].st else x:=path[mi].st-path[i].ft;
    if path[i].ft>path[i].st then
        a[path[i].s,path[i].f]:=path[i].ft-path[i].st+x
      else
        a[path[i].s,path[i].f]:=1440-abs(path[i].st-path[i].ft)+x;
  end;
end;
procedure solve;
var
  k,i,j,c:longint;
procedure dfs(x:longint);
var
  i:longint;
begin
  v[x]:=c;
  for i:=1 to n do
    if (v[i]=0) and (a[x,i]<>(maxlongint shr 1)) then dfs(i);
end;
begin
  for k:=1 to n do
    for i:=1 to n do
      for j:=1 to n do
        if a[i,j]>a[i,k]+a[k,j] then a[i,j]:=a[i,k]+a[k,j];
  fillchar(v,sizeof(v),0);
  c:=0;
  for i:=1 to n do
    if v[i]=0 then begin
      inc(c);
      dfs(i);
    end;
end;
procedure done;
var
  i,sum,l:longint;
begin
  sum:=0;
  l:=0;
  for i:=1 to n do
    if (a[i,i]=maxlongint) then begin
      if v[i]<>l then begin
        inc(sum, a[i,i] div 1440);
        l:=v[i];
      end;
    end else begin writeln(-1); halt; end;
  writeln(sum);
end;
begin
  init;
  solve;
  done;
end.
