#include <stdio.h>
#include <string.h>

#define MAX_T 1440
#define MAX_N 100002

int To[MAX_N], TST[MAX_N], TEN[MAX_N], Ne[MAX_N], Is[MAX_N], EH[MAX_N], EP = 0;
int FA[MAX_N], A = 0;

void AddE( int a, int b, int stt, int ent )
{
  To[EP] = b;
  TST[EP] = stt, TEN[EP] = ent;
  Is[EP] = 0;
  Ne[EP] = EH[a];
  EH[a] = EP++;
}

char * ReadNumber( char *s, int *n )
{
  *n = 0;
  while (*s != 0 && (*s < '0' || *s > '9'))
    s++;
  while (*s >= '0' && *s <= '9')
    *n = *n * 10 + (*s - '0'), s++;

  return s;
}

int main( void )
{
  int i, j, t, h1, m1, h2, m2, N, M, a, b;
  char buf[1002], *s;

  freopen("buses.in", "rt", stdin);
  freopen("buses.out", "wt", stdout);

  memset(EH, -1, sizeof(EH));
  memset(FA, 0, sizeof(FA));

  gets(buf);
  sscanf(buf, "%i%i", &N, &M);

  for (i = 0; i < M; i++)
  {
    gets(buf);
    s = buf;
    s = ReadNumber(s, &a);
    s = ReadNumber(s, &h1);
    s = ReadNumber(s, &m1);
    s = ReadNumber(s, &b);
    s = ReadNumber(s, &h2);
    s = ReadNumber(s, &m2);

    AddE(a - 1, b - 1, h1 * 60 + m1, h2 * 60 + m2);
  }

  for (t = 0; t < MAX_T; t++)
  {
    for (i = 0; i < N; i++)
      for (j = EH[i]; j != -1; j = Ne[j])
        if (TEN[j] == t && Is[j])
          Is[j] = 0, FA[To[j]]++;

    for (i = 0; i < N; i++)
      for (j = EH[i]; j != -1; j = Ne[j])
        if (TST[j] == t)
        {
          if (!FA[i])
            FA[i]++, A++;
          Is[j] = 1, FA[i]--;
        }
  }

  for (t = 0; t < MAX_T; t++)
  {
    for (i = 0; i < N; i++)
      for (j = EH[i]; j != -1; j = Ne[j])
        if (TEN[j] == t && Is[j])
          Is[j] = 0, FA[To[j]]++;

    for (i = 0; i < N; i++)
      for (j = EH[i]; j != -1; j = Ne[j])
        if (TST[j] == t)
        {
          if (!FA[i])
          {
            printf("-1");
            return 0;
          }
          Is[j] = 1, FA[i]--;
        }
  }

  printf("%i", A);
  
  return 0;
}