

program buses;

{$APPTYPE CONSOLE}

uses
  SysUtils;

type
  re=record
    st: integer;
    en: integer;
    vr_st: integer;
    vr_en: integer;
    check: boolean;
  end;


var
  N,M: integer;
  i,j: integer;
  reys: array [1..100000] of re;
  kolvo, min, klch: integer;
  f,g: text;
  pro,k,o: integer;
  lenta: array[1..1440] of integer;
  p,t: boolean;

procedure obnul;
begin
  for i:=1 to 100000 do begin
    reys[i].st:=0;
    reys[i].en:=0;
    reys[i].vr_st:=0;
    reys[i].vr_en:=0;
    reys[i].check:=false;
  end;
  N:=0;
  M:=0;
  Kolvo:=0;
  min:=0;
  klch:=0;
  k:=0;
  i:=0;
end;

procedure proread;
var
  q,v: string;
  w,u,o: integer;
begin
  assign(f,'buses.in');
  reset(f);
  ReadLn(f,N,M);
  for i:=1 to M do begin
    ReadLn(f,q);
    val(q[1],reys[i].st,w);
    v:=copy(q,3,2);
    if v[1]='0' then delete(v,1,1);
    val(v,u,w);
    v:=copy(q,6,2);
    if v[1]='0' then delete(v,1,1);
    val(v,o,w);
    reys[i].vr_st:=o+u*60;
    val(q[9],reys[i].en,w);
    v:=copy(q,11,2);
    if v[1]='0' then delete(v,1,1);
    val(v,u,w);
    v:=copy(q,14,2);
    if v[1]='0' then delete(v,1,1);
    val(v,o,w);
    reys[i].vr_en:=o+u*60;
  end;
  close(f);
end;


begin
  obnul;
  proread;
  assign(g,'buses.out');
  rewrite(g);
  for i:=1 to N do begin
    t:=false;
    p:=false;
    for o:=1 to M do begin
      if reys[o].st=i then t:=true;
      if reys[o].en=i then p:=true;
    end;
    if not (P AND T) then begin
      write(g,'-1');
      close(g);
      halt;
    end;
  end;
  for i:=1 to M do begin
    for j:=reys[i].vr_st+1 to reys[i].vr_en do begin
      k:=j;
      if k>1440 then k:=k-1440;
      inc(lenta[k]);
    end;
  end;
  min:=0;
  for i:=1 to 1440 do begin
    if lenta[i]>min then min:=lenta[i];
  end;
  write(g,min);
  close(g);

 end.
