{$A8,B-,C+,D+,E-,F-,G+,H+,I+,J-,K-,L+,M-,N+,O-,P+,Q-,R-,S-,T-,U-,V+,W-,X+,Y+,Z1}
{$MINSTACKSIZE $00004000}
{$MAXSTACKSIZE $00100000}

program buses_ea;

{$APPTYPE CONSOLE}

uses
  SysUtils;

const namein='buses.in';
      nameout='buses.out';
      NMax=110000;
      NA=-1;
type
 TArr=array [0..NMax] of integer;
 TStr=array [1..NMax] of array of integer;
var n,m,Sol:integer;
    p1,p2,t1,t2,s,a,b,v:TArr;
    h:TStr;

procedure Init;
var i,j:integer;
    s:string;

 function ReadInt:integer;
 var a:string;
 begin
  while s[i]=' ' do inc(i);
  a:='';
  while s[i]<>' ' do begin
    a:=a+s[i];
    inc(i)
   end;
  Result:=strtoint(a)
 end;

 function ReadTime:integer;
 var a:string;
 begin
  while s[i]=' ' do inc(i);
  a:='';
  while s[i]<>':' do begin
    a:=a+s[i];
    inc(i)
   end;
  inc(i);
  Result:=strtoint(a)*60;
  a:='';
  while s[i]<>' ' do begin
    a:=a+s[i];
    inc(i)
   end;
  inc(Result,strtoint(a)) 
 end;

begin
 assign(input,namein);
 reset(input);
 readln(n,m);
 for j:=1 to m do begin
   readln(s); s:=s+' ';
   i:=1;
   p1[j]:=ReadInt;
   t1[j]:=ReadTime;
   p2[j]:=ReadInt;
   t2[j]:=ReadTime
  end;
 close(input)
end;

procedure Sort(l,r:integer);
var q,a,i,j:integer;
begin
 i:=l; j:=r; q:=t1[s[l+random(r-l)]];
 repeat
  while t1[s[i]]<q do inc(i);
  while t1[s[j]]>q do dec(j);
  if i<=j then begin
    a:=s[i];
    s[i]:=s[j];
    s[j]:=a;
    inc(i); dec(j)
   end
 until i>j;
 if i<r then Sort(i,r);
 if l<j then Sort(l,j)
end;

procedure Heapfy(i:integer; var h:array of integer);
var l,r,larg:integer;
begin
 larg:=i; l:=i*2; r:=i*2+1;
 if (l<=h[0])and(h[l]<h[larg]) then larg:=l;
 if (r<=h[0])and(h[r]<h[larg]) then larg:=r;
 if larg<>i then begin
   r:=h[i]; h[i]:=h[larg]; h[larg]:=r;
   Heapfy(larg,h)
  end
end;

procedure InsHeap(a:integer; var h:array of integer);
var i:integer;
begin
 inc(h[0]);
 i:=h[0];
 while (i>1)and(h[i]<h[i div 2]) do begin
   h[i]:=h[i div 2];
   i:=i div 2
  end;
 h[i]:=a
end;

procedure Solve;
var i,q:integer;
begin
 Sol:=0;
 RandSeed:=n;
 fillchar(v,sizeof(v),0);
 for i:=1 to m do begin
   s[i]:=i;
   inc(v[p2[i]])
  end;
 Sort(1,m);
 fillchar(a,sizeof(a),0);
 fillchar(b,sizeof(b),0);
 for i:=1 to n do begin
   setlength(h[i],v[i]+1);
   h[i,0]:=0
  end;
 for i:=1 to m do begin
   q:=p1[s[i]];
   if (h[q,0]>0)and(h[q,1]<=t1[s[i]])
   then begin
     dec(b[q]);
     h[q,1]:=h[q,h[q,0]];
     dec(h[q,0]);
     Heapfy(1,h[q])
    end
   else begin
     inc(a[q]);
     inc(Sol)
    end; 
   InsHeap(t2[s[i]],h[p2[s[i]]]);
   inc(b[p2[s[i]]])  
  end;
 for i:=1 to n do
  if a[i]>b[i] then Sol:=NA
end;

procedure Done;
begin
 assign(output,nameout);
 rewrite(output);
 writeln(Sol);
 close(output)
end;

begin
 Init;
 Solve;
 Done
end.
