{$APPTYPE CONSOLE}
const DAY = 24 * 60;
const DAYEMU = 4;
const MAXEV = 110000 * DAYEMU * 2;
type integer = longint;
var n, m : integer;
	edg : array [1..110000, 1..4]of integer;

function ReadNumber : integer;
var c : char;
	res : integer;
begin
	read(c);
	while (c < '0') or (c > '9') do begin
		read(c);
	end;
	res := 0;
	while (c >= '0') and (c <= '9') do begin
		res := res * 10 + ord(c) - ord('0');
		read(c);
	end;
	ReadNumber := res;
end;

function ReadTime : integer;
var hr, min : integer;
begin
	hr := ReadNumber;
	min := ReadNumber;
	ReadTime := hr * 60 + min;
end;

procedure Load;
var i : integer;
begin
	read(n, m);
	for i := 1 to m do begin
		read(edg[i, 1]);
		edg[i, 3] := ReadTime;
		read(edg[i, 2]);
		edg[i, 4] := ReadTime;
		if edg[i, 4] < edg[i, 3] then inc(edg[i, 4], DAY);
	end;
end;

var nin, nout : array [1..110000] of integer;
	evt : array [0..MAXEV, 1..3] of integer;
	nev : integer;

procedure AddEvent(v, tm, tp : integer);
begin
	inc(nev);
	evt[nev, 1] := v;
	evt[nev, 2] := tm;
	evt[nev, 3] := tp;
end;

function Less(e1, e2 : integer) : boolean;
var i : integer;
begin
	for i := 1 to 3 do begin
		if evt[e1, i] > evt[e2, i] then begin
			Less := false;
			exit;
		end;
		if evt[e1, i] < evt[e2, i] then begin
			Less := true;
			exit;
		end;
	end;
	Less := false;
end;

procedure Qsort(be, en : integer);
var l, r, t : integer;
begin
	l := be;
	r := en;
	t := l + random(r - l + 1);
	evt[0, 1] := evt[t, 1];
	evt[0, 2] := evt[t, 2];
	evt[0, 3] := evt[t, 3];
	while l < r do begin
		while Less(l, 0) do inc(l);
		while Less(0, r) do dec(r);
		if l <= r then begin
			t :=evt[l, 1];
			evt[l, 1] := evt[r, 1];
			evt[r, 1] := t;
			t :=evt[l, 2];
			evt[l, 2] := evt[r, 2];
			evt[r, 2] := t;
			t :=evt[l, 3];
			evt[l, 3] := evt[r, 3];
			evt[r, 3] := t;
			inc(l);
			dec(r);
		end;
	end;
	if be < r then Qsort(be, r);
	if l < en then Qsort(l, en);
end;

procedure Solve;
var i, j, k, ans, co : integer;
begin
	fillchar(nin, sizeof(nin), 0);
	fillchar(nout, sizeof(nout), 0);
	for i := 1 to m do begin
		inc(nin[edg[i, 2]]);
		inc(nout[edg[i, 1]]);
	end;
	for i := 1 to n do begin
		if nin[i] <> nout[i] then begin
			write('-1');
			exit;
		end;
	end;
	{do events}
	nev := 0;
	for i := 1 to m do begin
		for j := 0 to DAYEMU - 1 do begin
			AddEvent(edg[i, 1], edg[i, 3] + j * DAY, 1);
			AddEvent(edg[i, 2], edg[i, 4] + j * DAY, 0);
		end;
	end;
	{count events}
	Qsort(1, nev);
	i := 1;
	ans := 0;
	while i <= nev do begin
		j := i;
		while (j <= nev) and (evt[j, 1] = evt[i, 1]) do inc(j);
        dec(j);
		co := 0;
		for k := i to j do begin
			if evt[k, 3] = 0 then inc(co)
			else begin
				if co = 0 then inc(ans)
				else dec(co);
			end;
		end;
		i := j + 1;
	end;
	write(ans);
end;

begin
	assign(input, 'buses.in');
	assign(output, 'buses.out');
	reset(input);
	rewrite(output);
	Load;
	Solve;
	close(input);
	close(output);
end.