Program P4;
Type TRoad = Record
 F, G : LongInt;
 T1, T2 : Word;
 RingNum : Word;
 CycNum : Word;
 FT : Boolean;
End;
Var Arr : Array[1..1000000] of TRoad; N, M, I, J, RngN, FT : LongInt; F : Text;
 Function GetNum(Ch : Char) : Byte;
 Begin
  GetNum := Ord(Ch) - Ord('0');
 End;
 Procedure ReadTime(Var Time : Word);
 Var Ch : Char;
 Begin
  Read(F, Ch);
  Read(F, Ch);
  Time := GetNum(Ch);
  Read(F, Ch);
  Time := Time * 10 + GetNum(Ch);
  Read(F, Ch);
  Read(F, Ch);
  Time := Time * 60 + GetNum(Ch) * 10;
  Read(F, Ch);
  Time := Time + GetNum(Ch);
 End;
 Procedure DoRing(OldRoad : LongInt; Deep : Byte);
 Var I : LongInt;
 Begin
  For I := 1 To M Do
  Begin
   If (Arr[OldRoad].G = Arr[I].F) And (Arr[OldRoad].T2 <= Arr[I].T1) And (Arr[I].RingNum = 0) Then
   Begin
    Arr[I].RingNum := RngN;
    DoRing(I, Deep + 1);
    If RngN = 255 Then Exit;
    Arr[I].RingNum := 0;
   End;
  End;
  If (Arr[OldRoad].G = Arr[FT].F) And (Arr[OldRoad].T2 <= Arr[FT].T1) And (Deep > 0) Then
  Begin
   Arr[FT].RingNum := RngN;
   Arr[FT].FT := True;
   RngN := 255;
  End;
 End;
 Procedure GetCyc(OldRoad : LongInt);
 Var I : LongInt;
 Begin
  If (Arr[FT].F = Arr[OldRoad].G) And (Arr[I].RingNum = 0) And (Arr[I].CycNum = 0) Then
  Begin
   Arr[FT].CycNum := RngN;
   Arr[FT].FT := True;
   RngN := 255;
   Exit;
  End;
  For I := 1 To M Do
   If (Arr[OldRoad].G = Arr[I].F) And (Arr[I].RingNum = 0) And (Arr[I].CycNum = 0) Then
   Begin
    Arr[I].CycNum := RngN;
    GetCyc(I);
    If RngN = 255 Then Exit;
    Arr[I].CycNum := 0;
   End;
 End;
Begin
 Assign(F, 'buses.in ');
 ReSet(F);
 Read(F, N, M);
 For I := 1 To M Do
 Begin
  Read(F, Arr[I].F);
  ReadTime(Arr[I].T1);
  Read(F, Arr[I].G);
  ReadTime(Arr[I].T2);
  ReadLn(F);
 End;
 Close(F);
 For I := 1 To N Do
  For J := 1 To M Do
  Begin
   If (Arr[J].RingNum <> 0) Or (Arr[J].CycNum <> 0) Then Continue;
   RngN := I;
   FT := J;
   DoRing(FT, 0);
   If RngN = 255 Then Break;
  End;
 For I := 1 To N Do
  For J := 1 To M Do
  Begin
   If (Arr[J].RingNum <> 0) Or (Arr[J].CycNum <> 0) Then Continue;
   RngN := I;
   FT := J;
   GetCyc(FT);
   If RngN = 255 Then Break;
  End;
 RngN := 0;
 For I := 1 To M Do
  If RngN < Arr[I].RingNum Then RngN := Arr[I].RingNum;
 For I := 1 To M Do
   If Arr[I].CycNum <> 0 Then Inc(RngN);
 Assign(F, 'buses.out');
 ReWrite(F);
 For I := 1 To M Do
  If (Arr[I].CycNum = 0) And (Arr[I].RingNum = 0) Then
  Begin
   Write(F, '-1');
   Close(F);
   Exit;
  End;
 Write(F, RngN);
 Close(F);
End.