type
  int=longint;
const
  alf:set of char=['0'..'9'];
  infile='buses.in';
 outfile='buses.out';
  mx=200007;
var
  key,next,first:array[1..mx]of int;
  was:array[1..mx]of boolean;
  q,ev,where:array[1..2*mx]of int;
  n,m,res,uk,cur:int;

procedure decode(var s:string;var x:int);
var
 k,i:int;
 code:integer;
begin
  i:=1;
  while not(s[i] in alf)do
   inc(i);
  val(copy(s,i,2),k,code);
  x:=60*(k-1);
  val(copy(s,i+3,2),k,code);
  x:=x+k;
end;

procedure readtime(var t:int);
var
 s:string;
 ch:char;
begin
  s:='';
  read(ch);
  while ch=' 'do
   read(ch);
  while not(ch=':')do
   begin
     s:=s+ch;
     read(ch);
   end;
  s:=s+ch;
  read(ch);
  s:=s+ch;
  read(ch);
  s:=s+ch;
  decode(s,t);
end;

procedure add(x,y,uk:int);
begin
  key[uk]:=y;
  next[uk]:=first[x];
  first[x]:=uk;
end;

procedure swap(var x,y:int);
var
 z:int;
begin
  z:=x;
  x:=y;
  y:=z;
end;

procedure sort(l,r:int);
var
  i,j,x:int;
begin
  i:=l; j:=r;
  x:=ev[(l+r) DIV 2];
  repeat
    while (ev[i]<x) do i:=i+1;
    while (x<ev[j]) do j:=j-1;
    if i<=j then
    begin
      swap(ev[i],ev[j]);
      swap(where[i],where[j]);
      i:=i+1; j:=j-1;
    end;
  until i>j;
  if l<j then sort(l,j);
  if i<r then sort(i,r);
end;

procedure init;
var
 i,t1,t2,x,y:int;
begin
  fillchar(key,sizeof(key),0);
  fillchar(next,sizeof(next),0);
  fillchar(first,sizeof(first),0);
  fillchar(ev,sizeof(ev),0);
  fillchar(where,sizeof(where),0);
  readln(n,m);
  for i:=1 to m do
   begin
     read(x);
     readtime(t1);
     read(y);
     readtime(t2);
     if t2<=t1 then
      t2:=t2+24*60;
     ev[i]:=t1*2+1;
     where[i]:=x;
     ev[i+m]:=t2*2;
     where[i+m]:=y;
     add(x,y,i);
   end;
  sort(1,2*m);
end;

procedure dfs(u:int);
var
 i:int;
begin
  if was[u] then
   exit else
   was[u]:=true;
  i:=first[u];
  while i<>0 do
   begin
     dfs(key[i]);
     i:=next[i];
   end;
  inc(uk);
  q[uk]:=u;
end;

function dfs2(u:int):int;
var
 i:int;
begin
  result:=1;
  if was[u] then
   exit else
   was[u]:=true; 
  i:=first[u];
  while i<>0 do
   begin
     if not(was[key[i]]) then
      inc(result,dfs2(key[i]));
     i:=next[i];
   end;
end;

function check:boolean;
var
 i:int;
begin
  fillchar(was,sizeof(was),0);
  fillchar(q,sizeof(q),0);
  uk:=0;
  for i:=1 to n do
   if not(was[i])then
    dfs(i);
  fillchar(was,sizeof(was),0);
  check:=true;
  for i:=1 to n do
   if not(was[q[i]])and(dfs2(q[i])=1)then
    exit;
  check:=false;
end;

procedure solve;
var
 i:int;
begin
  for i:=1 to 2*m do
   if (odd(ev[i]))then
    begin
      if q[where[i]]=0 then
       inc(cur) else
       dec(q[where[i]]);
    end else
    inc(q[where[i]]);
end;

procedure run;
var
 f:boolean;
 i:int;
begin
  res:=-1;
  uk:=0;
  if check then
   exit else
   begin
     res:=0;
     fillchar(q,sizeof(q),0);
     cur:=0;
     solve;
     res:=cur;
     f:=true;
     for i:=1 to 50 do
      begin
        solve;
        if cur=res then
         begin
           f:=false;
           break;
         end else
         res:=cur;
      end;
     if f then
      res:=-1;
   end;
end;

procedure done;
begin
  write(res);
end;

procedure opf;
begin
  assign(input,infile);
  reset(input);
  assign(output,outfile);
  rewrite(output);
end;

procedure clf;
begin
  close(input);
  close(output);
end;

begin
  opf;
  init;
  run;
  done;
  clf;
end.