type
  int = longint;
  PList = ^TList;
  TList = record
    d,f,g : int;
    n : PList;
  end;

const
  MaxN = 100010;

var
  N,M,time,K : int;
  R,Rn : array[1..MaxN]of PList;
  C : array[1..MaxN]of boolean;
  Range,H,L,D,F,St,uk : array[1..MaxN]of int;

procedure Init;
begin
  assign(input,'buses.in');
  assign(output,'buses.out');
  reset(input);
  rewrite(output);
end;

procedure Cloz;
begin
  close(input);
  close(output);
end;

function get_time : int;
var
  c : char;
  x : int;
begin
  read(c);
  read(c);
  x := ord(c) - $30;
  read(c);
  x := ord(c) - $30 +x*10;
  read(c);
  read(c);
  x := ord(c) - $30 +x*10;
  read(c);
  x := ord(c) - $30 +x*10;
  get_time := x;
end;

procedure Load;
var
  i,j,a,b,f,g : int;
  c : char;
  t : PList;
begin
  readln(N,M);
  for i := 1 to N do begin
    new(R[i]);
    R[i]^.n := nil;
  end;
  for i := 1 to M do begin
    read(a);
   f := get_time;
    read(b);
    g := get_time;
    new(t);
    t^.d := b;
    t^.f := f;
    t^.g := g;
    t^.n := R[a]^.n;
    R[a]^.n := t;
  end;
end;

procedure swap(i,j : int);
var
  t : int;
begin
  t := uk[i];
  uk[i] := uk[j];
  uk[j] := t;
end;

procedure QSort(Left, Right : int);
var
  i,j,x : int;
begin
  i := Left;
  j := Right;
  x := D[random(j-i+1)+i];
  while i <= j do begin
    while D[i] < x do inc(i);
    while D[j] > x do dec(j);
    if i <= j then begin
      swap(i,j);
      inc(i);
      dec(j);
    end;
  end;
  if i < right then QSort(i,right);
  if j > left then QSort(left,j);
end;


procedure DFS_Search(x : int);
var
  sc, v : int;
  w : PList;

begin
  St[1] := x;
  sc := 1;
  C[x] := false;
{  P[x] := 0;    }
  while sc > 0 do begin
    v := St[sc];
    dec(sc);
    inc(time);
    D[v] := time;
    w := R[v];
    while w^.n <> nil do begin
      w := w^.n;
      if C[w^.d] then begin
        inc(sc);
        St[sc] := w^.d;
        C[w^.d] := false;
        {P[w^.d] := v;       }
      end;
    end;
  end;
end;

procedure DFS;
var
  i : int;
begin
  FillChar(C,sizeof(C),true);
  time := 0;
  for i := 1 to N do
    if C[i] then DFS_Search(i);

end;

procedure Init_Set;
var
  i : int;
begin
  for i := 1 to N do begin
    Range[i] := i;
    H[i] := 0;
  end;
end;

procedure Connect(v,u : int);
begin
  Range[v] := Range[u];
end;

function Find_Set(x : int):int;
begin
  if x <> Range[x] then
    Range[x] := Find_Set(Range[x]);
  Find_Set := Range[x];
end;

procedure Union(v,u : int);
begin
  if H[Range[v]] = H[Range[u]] then begin
    inc(H[Range[u]]);
    Connect(v,u);
  end else
  if H[Range[v]] > H[Range[u]] then
    Connect(u,v) else
    Connect(v,u);
end;

procedure DFS_SV_Search(x : int);
var
  w : PList;
  sc,v : int;
begin
  St[1] := x;
  sc := 1;
  C[x] := false;
  while sc > 0 do begin
    v := St[sc];
    dec(sc);
    w := Rn[v];
    while w^.n <> nil do begin
      w := w^.n;
      if C[w^.d] then begin
        inc(sc);
        St[sc] := w^.d;
        C[w^.d] := false;
        Union(w^.d,v);
      end;
    end;
  end;
end;

procedure DFS_SV;
var
  i : int;
begin
  FillChar(C,sizeof(C),true);
  time := 0;
  for i := 1 to N do
    if C[uk[i]] then DFS_SV_Search(uk[i]);
end;

function Check_Way : boolean;
var
  i,v : int;
  w : PList;
  net : boolean;
begin
  net := false;
  for i := 1 to N do begin
    w := R[i];
    while w^.n <> nil do begin
      w := w^.n;
      if Find_Set(w^.d) <> Find_Set(i)
        then net := true;
    end;
  end;
  Check_way := net;
end;

procedure GoGoGo(x : int);
var
  w : PList;
  sc,v : int;
begin
  inc(D[x]);
  F[x] := 0;
  C[x] := false;
  St[1] := x;
  sc := 1;
  L[x] := 0;
  while sc > 0 do begin
    v := St[sc];
    L[v] := 1;
    dec(sc);
    w := R[v];
    while w^.n <> nil do begin
      w := w^.n;
      if C[w^.d] then begin
        inc(sc);
        St[sc] := w^.d;
        C[w^.d] := false;
        F[w^.d] := w^.g;
      end;
      H[v] := w^.f;
      if (H[v] > w^.g)or(L[v] = 0)
          then inc(D[v]);
    end;
      dec(L[v]);
  end;
end;

procedure Go;
var
  i : int;
begin
  K := 0;
  FillChar(H,sizeof(H),0);
  FillChar(D,sizeof(D),0);
  FillChar(F,sizeof(F),0);
  FillChar(C,sizeof(C),true);
  for i := 1 to N do begin
    if C[i] then GoGoGo(i);
  end;
  for i := 1 to N do
    K := K + D[i];
  writeln(k);
end;

procedure Slove;
var
  i,j : int;
  tmp,w : PList;
begin
  Init_Set;
  DFS;
  for i := 1 to N do
    uk[i] := i;
  QSort(1,N);
  for i := 1 to N do begin
    new(Rn[i]);
    Rn[i]^.n := nil;
  end;
  for i := 1 to N do begin
    w := R[i];
    while w^.n <> nil do begin
      w := w^.n;
      new(tmp);
      tmp^.d := i;
      tmp^.n := Rn[w^.d]^.n;
      Rn[w^.d]^.n := tmp;
    end;
  end;
  DFS_SV;
  if Check_Way
    then writeln(-1)
    else Go;
end;

BEGIN
  Init;
  Load;
  Slove;
  Cloz;
END.
