program buses;

{$APPTYPE CONSOLE}

type route=record
  s,d,t0,tf:integer;
 end;

type
 plist=^list;
 list=record
  tm:integer;
  nx:plist;
 end;

type bus=record
  tm:integer;
  u:boolean;
 end;

var t,stop,i,j,n,m,s:integer;
    cs,cd:integer;
    chk:plist;
    found:boolean;
    n0:array[1..100000] of integer;
    nf:array[1..100000] of integer;
    nc:array[1..100000] of integer;
  //  ct:array[1..100000] of list;
    ct:array[1..100000,1..1000] of bus;
    rt:array[1..100000] of route;

procedure swap(i,j:integer);
var t:route;
begin
 t:=rt[i]; rt[i]:=rt[j]; rt[j]:=t;
end;


function part(a,b:integer):integer;
var i,j:integer;
begin
 i:=a-1; j:=b+1;
 while true do begin
  repeat inc(i) until rt[i].t0>=rt[a].t0;
  repeat dec(j) until rt[j].t0<=rt[a].t0;
  if i<j then swap(i,j) else begin part:=j; exit; end;
 end;
end;

procedure sort(a,b:integer);
var d:integer;
begin
 if a<b then begin
  d:=part(a,b);
  sort(a,d);
  sort(d+1,b);
 end;
end;

procedure rd1(var q:integer);
var ch:char;
begin
 q:=0;
 read(ch); while not (ch in ['0'..'9']) do read(ch);
 while ch in ['0'..'9'] do begin
  q:=10*q+ord(ch)-ord('0'); read(ch);
 end;
end;

procedure rd(var t:integer);
var h,m:integer;
begin
 rd1(h); rd1(m); t:=60*h+m;
end;

begin
 assign(input,'buses.in'); reset(input);
 assign(output,'buses.out'); rewrite(output);
 read(n,m);
 fillchar(n0,sizeof(n0),0);
 fillchar(nf,sizeof(nf),0);
 fillchar(nc,sizeof(nc),0);
// for i:=1 to n do ct[i].tm:=-1;
 for i:=1 to m do begin
  read(rt[i].s); rd(rt[i].t0);
  read(rt[i].d); rd(rt[i].tf);
  if rt[i].t0>rt[i].tf then inc(rt[i].tf,1440);
 end;
 sort(1,m);
 t:=rt[1].t0; stop:=t+1440;

 for i:=1 to m do begin
   cs:=rt[i].s; cd:=rt[i].d;
   found:=false;
   for j:=1 to nc[cs] do
    if (not ct[cs,j].u) and (ct[cs,j].tm<=rt[i].t0) then begin
     ct[cs,j].u:=true; found:=true; dec(nf[cs]); break;
    end;

    if not found then inc(n0[cs]);

    if rt[i].tf<=stop then begin
     inc(nf[cd]); inc(nc[cd]); ct[cd,nc[cd]].tm:=rt[i].tf; ct[cd,nc[cd]].u:=false;
    end;

 end;

 s:=0;
 for i:=1 to n do
  if nf[i]<>n0[i] then begin write(-1); exit; end else inc(s,n0[i]);
 write(s);
end.


   {
    chk:=ct[cs].nx;
   //search for appropriate bus
   while chk<>nil do begin
    if chk^.tm<=rt[i].t0 then begin
     found:=true;
     //use this bus
     dec(nc[cs]);
     chk^.nx:=chk^.nx^.nx;
    end else chk:=chk^.nx;
   end;

   if not found then
    inc(n0[cs]);

   //add new bus to destination
   if rt[i].tf<=stop then begin
    inc(nc[cd]);
    chk:=ct[cd].nx;
    while chk<>nil do
    chk:=chk^.nx;
    new(chk); chk^.tm:=rt[i].tf;
  //  new(ct[cd].nx); ct[cd].nx^.tm:=rt[i].tf;
   end;}