{$A8,B-,C+,D-,E-,F-,G+,H+,I-,J-,K-,L-,M-,N+,O+,P+,Q-,R-,S-,T-,U-,V+,W-,X+,Y+,Z1}
//{$A8,B-,C+,D+,E-,F-,G+,H+,I+,J-,K-,L+,M-,N+,O-,P+,Q+,R+,S+,T-,U-,V+,W-,X+,Y+,Z1}
program Problem4;

{$APPTYPE CONSOLE}

uses
  SysUtils;
type
  int=longint;
  real=extended;
  bool=boolean;
  ttime=string[5];
  TSob=record
      num,time,d:int;
    end;
const
  in_f='buses.in';
  out_f='buses.out';
  maxN=100000+5;
var
  N,m:int;
  s:array[1..maxN*2] of TSob;
  st:array[1..maxN] of int;
  uk:int;

function Less(const a,b:TSob):bool;
 begin
   if a.time<>b.time then
     result:=a.time<b.time
   else
     Result:=a.d>b.d;  

 end;

procedure sort(l,r: integer);
var
  i,j: integer;
  x,y:TSob;
begin
  i:=l; j:=r; x:=s[l+Random(r-l+1)];
  repeat
    while Less(s[i],x) do i:=i+1;
    while Less(x,s[j]) do j:=j-1;
    if i<=j then
    begin
      y:=s[i]; s[i]:=s[j]; s[j]:=y;
      i:=i+1; j:=j-1;
    end;
  until i>j;
  if l<j then sort(l,j);
  if i<r then sort(i,r);
end;


function TimeToInt(const t:Ttime):int;
 begin
   Result:=StrToInt(copy(t,1,2))*60+StrToInt(copy(t,4,2));
 end;

procedure Run;
 var
  i,a,b,tt1,tt2:int;
  t1,t2:ttime;
  ch:char;
  ans:int;
 begin
   Read(n,m);
   RandSeed:=N+m;
   uk:=0;
   fillchar(st,sizeof(st),0);
   for i := 1 to M do
     begin
       Read(a,ch,t1,b,ch,t2);
       tt1:=TimeToInt(t1);
       tt2:=TimeToInt(t2);
       dec(st[a]);
       inc(st[b]);
       inc(uk);
       s[uk].num:=a;
       s[uk].d:=-1;
       s[uk].time:=tt1;
       if tt2>tt1 then
         begin
           inc(uk);
           s[uk].num:=b;
           s[uk].d:=1;
           s[uk].time:=tt2;
         end;  
     end;
   for i := 1 to N do
     if st[i]<>0 then
       begin
         Write(-1);
         exit;
       end;
   Sort(1,uk);
   ans:=0;
   for i:= 1 to uk do
     begin
       Inc(st[s[i].num],s[i].d);
       if st[s[i].num]<0 then
         begin
           inc(st[s[i].num]);
           inc(ans);
         end;
     end;
   Write(ans);  
 end;

procedure OpenFiles;
begin
  REset(input,in_f);
  REwrite(output,out_f);
end;
procedure CloseFiles;
begin
  Close(input);
  Close(output);
end;

begin
OpenFiles;
Run;
CloseFiles;
end.
