{$A8,B-,C+,D+,E-,F-,G+,H+,I+,J-,K-,L+,M-,N+,O+,P+,Q-,R-,S-,T-,U-,V+,W-,X+,Y+,Z1}
{$MINSTACKSIZE $00004000}
{$MAXSTACKSIZE $00100000}
{$APPTYPE CONSOLE}

uses
  SysUtils;
type
 pbus=^tbus;
 tbus=record
      st,m,n:longint;
      startch,startmin,finch,finmin:longint;
      next:pbus;
      end;
var
 tab:array[0..100010]of pbus;
 bus:array[1..100010]of pbus;
 start:array[0..100010]of longint;
 result,j,ans,lmar,n,m,i:longint;
 q:array[0..100010]of boolean;
 nm:array[0..100010]of pbus;
// ff:longint;

procedure read_(ii:longint);
var
 i,j,t:longint;
 s:string;
// p:pbus;
begin
 readln(s);
 i:=1;
 while s[i] in ['0'..'9'] do
  inc(i);
 t:=strtoint(copy(s,1,i-1));
 bus[ii]:=new(pbus);
 bus[ii].st:=t;
 bus[ii].m:=ii;
 bus[ii].next:=nil;
// tab[t]:=p;
 start[ii]:=t;
 t:=strtoint(copy(s,i+1,2));
 bus[ii].startch:=t;
 t:=strtoint(copy(s,i+4,2));
 bus[ii].startmin:=t;
 j:=i+7;
 while s[j] in ['0'..'9'] do
  inc(j);
 t:=strtoint(copy(s,i+7,j-i-7));
 bus[ii].n:=t;
 t:=strtoint(copy(s,j+1,2));
 bus[ii].finch:=t;
 t:=strtoint(copy(s,j+4,2));
 bus[ii].finmin:=t;
end;

function DFS(i,s:longint):boolean;
var
 op,p:pbus;
begin
 p:=tab[i];
 op:=nil;
 while p<>nil do
  begin
//  inc(ff);
  if (p.n=s) then
   begin
   if op<>nil then
    op.next:=p.next;
   q[p.m]:=true;
   inc(lmar);
   nm[lmar]:=p;
   DFS:=true;
   exit;
   end;
  if not(q[p.m]) then
   begin
   q[p.m]:=true;
   if DFS(p.n,s) then
    begin          
    if op<>nil then
     op.next:=p.next;
    inc(lmar);
    nm[lmar]:=p;
    DFS:=true;
    exit;
    end
   else
    q[p.m]:=false;
   end;
  op:=p;
  p:=p.next;
  end;
 DFS:=false;
end;

function count(ch1,min1,ch2,min2:longint):longint;
begin
 if (ch2<ch1) or ((ch2=ch1)and(min2<min1))then
  begin
  result:=(ch2+24-ch1)*60+min2-min1;
  end
 else
  begin                             
  result:=(ch2-ch1)*60+min2-min1;
  end;
end;

procedure add(i:longint);
begin
 bus[i].next:=tab[bus[i].st];
 tab[bus[i].st]:=bus[i];
end;

procedure Qsort(l,r: integer);
var
 i,j,x,yy:integer;
 y:pbus;
begin
  i:=l; j:=r; x:=bus[(l+r) DIV 2].startch*60+bus[(l+r) DIV 2].startmin;
  repeat
    while bus[i].startch*60+bus[i].startmin<x do i:=i+1;
    while x<bus[j].startch*60+bus[j].startmin do j:=j-1;
    if i<=j then
    begin
      y:=bus[i]; bus[i]:=bus[j]; bus[j]:=y;
      yy:=start[i]; start[i]:=start[j]; start[j]:=yy;
      i:=i+1; j:=j-1;
    end;
  until i>j;
  if l<j then Qsort(l,j);
  if i<r then Qsort(i,r);
end;


begin
 reset(input,'buses.in');
 rewrite(output,'buses.out');
 readln(n,m);
 for i:=1 to n do
  tab[i]:=nil;
 for i:=1 to m do
  begin
  read_(i);
  q[i]:=false;
  end;
 QSort(1,m);
 for i:=m downto 1 do
  add(i);
 ans:=0;
// ff:=0;
 for i:=1 to m do
  if not(q[i]) then
   begin
   lmar:=0;
   if (DFS(start[i],start[i])) then
    begin
    result:=0;
    for j:=lmar downto 1 do
     begin
     result:=result+count(nm[j].startch,nm[j].startmin,nm[j].finch,nm[j].finmin);
     result:=result+count(nm[j].finch,nm[j].finmin,nm[(j-2+lmar) mod lmar+1].startch,nm[(j-2+lmar) mod lmar+1].startmin);
     end;
    ans:=ans+result div (24*60);
    end
   else
    begin
    writeln(-1);
    close(input);
    close(output);
    halt;
    end;
   end;
 writeln(ans);
// writeln(ff);
 close(input);
 close(output);
end.
