/*************************************/
/*      57, Moscow                   */
/*************************************/

#include <fstream>
#include <stdio.h>
#include <algorithm>
#include <stdlib.h>
using namespace std;

int n;

struct race
{
   int time1, time2;
   int city1, city2;
};
race races [200057];
int m;
void read_race ( FILE* fin )
{
   race& r = races [m++];
   int h1, m1, h2, m2;
   fscanf ( fin, "%d %d:%d %d %d:%d", &r.city1, &h1, &m1, &r.city2, &h2, &m2 );
   r.city1--;
   r.city2--;
   r.time1 = h1 * 60 + m1;
   r.time2 = h2 * 60 + m2;
   if ( r.time2 < r.time1 )
      r.time2 += ( 60 * 24 );
   race& r2 = races [m++];
   r2 = r;
   r2.time1 += ( 60 * 24 );
   r2.time2 += ( 60 * 24 );
}

struct event
{
   int city;
   bool end;
   int time;
};
event events [400057];
int k;
bool operator < ( event const& a, event const& b )
{
   if ( a.time != b.time )
      return a.time < b.time;
   return a.end > b.end;
}
void make_events ()
{
   k = 0;
   for ( int i = 0; i < m; i++ )
   {
      events [k].city = races [i].city1;
      events [k].end = false;
      events [k++].time = races [i].time1;
      events [k].city = races [i].city2;
      events [k].end = true;
      events [k++].time = races [i].time2;
   }
   sort ( & ( events [0] ), & ( events [k] ) );
}

int r [100057];
int s [100057];

int main ()
{
   FILE* fin = fopen ( "buses.in", "r" );
   int gvm;
   fscanf ( fin, "%d %d", &n, &gvm );
   m = 0;
   for ( int i = 0; i < gvm; i++ )
      read_race ( fin );
   make_events ();
   fclose ( fin );

   ofstream fout ( "buses.out" );

   memset ( r, 0, sizeof r );
   memset ( s, 0, sizeof s );

   for ( int i = 0; i < k; i++ )
   {
      if ( events [i].end )
         s [events [i].city]++;
      else
      {
         if ( s [events [i].city] <= 0 )
            r [events [i].city]++;
         else
            s [events [i].city]--;
      }
   }

   int num = 0;
   for ( int i = 0; i < n; i++ )
   {
      if ( r [i] != s [i] )
      {
         fout << -1;
         return 0;
      }
      num += s [i];
   }
   fout << num;

   return 0;
}
