/*************************************/
/*      57, Moscow                   */
/*************************************/

#include <fstream>
#include <stdio.h>
#include <algorithm>
#include <stdlib.h>
#include <search.h>
using namespace std;

int n;

struct race
{
   int time1, time2;
   int city1, city2;
};
race races [200057];
int m;
void read_race ( FILE* fin )
{
   race& r = races [m++];
   int h1, m1, h2, m2;
   fscanf ( fin, "%d %d:%d %d %d:%d", &r.city1, &h1, &m1, &r.city2, &h2, &m2 );
   r.city1--;
   r.city2--;
   r.time1 = h1 * 60 + m1;
   r.time2 = h2 * 60 + m2;
   if ( r.time2 < r.time1 )
      r.time2 += ( 60 * 24 );
   //race& r2 = races [m++];
   //r2 = r;
   //r2.time1 += ( 60 * 24 );
   //r2.time2 += ( 60 * 24 );
}

struct event
{
   int city;
   bool end;
   int time;
};
event events [400057];
event events2 [400057];
event events3 [400057];
int ind [400057];
int k;
bool operator < ( event const& a, event const& b )
{
   if ( a.time != b.time )
      return a.time < b.time;
   return a.end > b.end;
}
inline int val ( event const& e )
{
   if ( e.end )
      return e.time << 1;
   return ( e.time << 1 ) + 1;
}/*
void myqsort ( int* i, int n )
{
   int m = n * 7 / 20;
   int k = val ( events [i [m]] );
   int l = 0;
   int r = n-1;
   do
   {
      while ( val ( events [i [l]] ) < k )
         l++;
      while ( val ( events [i [r]] ) > k )
         r--;
      if ( l <= r )
      {
         int t = i [l];
         i [l] = i [r];
         i [r] = t;
         l++;
         r--;
      }
   } while ( l <= r );
   if ( r > 0 ) myqsort ( i, r+1 );
   if ( l < n-1 ) myqsort ( i+l, n-l );
}*/
void make_events ()
{
   k = 0;
   for ( int i = 0; i < m; i++ )
   {
      ind [k] = k;
      events2 [k].city = races [i].city1;
      events2 [k].end = false;
      events2 [k++].time = races [i].time1;
      ind [k] = k;
      events2 [k].city = races [i].city2;
      events2 [k].end = true;
      events2 [k++].time = races [i].time2;
   }
   sort ( & ( events2 [0] ), & ( events2 [k] ) );
   memcpy ( events3, events2, sizeof events2 );
   for ( int i = 0; i < k; i++ )
      events3 [i].time += 24 * 60;
   merge ( & ( events2 [0] ), & ( events2 [k] ),
           & ( events3 [0] ), & ( events3 [k] ),
           & ( events [0] ) );
   k *= 2;
   //myqsort ( ind, k );
}

int r [100057];
int s [100057];

int main ()
{
   FILE* fin = fopen ( "buses.in", "r" );
   int gvm;
   fscanf ( fin, "%d %d", &n, &gvm );
   m = 0;
   for ( int i = 0; i < gvm; i++ )
      read_race ( fin );
   make_events ();
   fclose ( fin );

   ofstream fout ( "buses.out" );

   memset ( r, 0, sizeof r );
   memset ( s, 0, sizeof s );

   for ( int i = 0; i < k; i++ )
   {
      if ( events [i].end )
         s [events [i].city]++;
      else
      {
         if ( s [events [i].city] <= 0 )
            r [events [i].city]++;
         else
            s [events [i].city]--;
      }
   }

   int num = 0;
   for ( int i = 0; i < n; i++ )
   {
      if ( r [i] != s [i] )
      {
         fout << -1;
         return 0;
      }
      num += s [i];
   }
   fout << num << endl;

   return 0;
}
