{$A+,B-,D+,E+,F-,G-,I+,L+,N-,O-,P-,Q-,R-,S+,T-,V+,X+,Y+}
{$M 65520,0,655360}
program ol;
const
  maxe=10000;
  maxv=1000;
type
  edge=record
    start,finish,v:integer;
  end;
  gedge=array[1..maxe,1..maxv]of edge;
  gvert=array[1..maxv] of longint;
  pbool=array[1..maxe] of boolean;
var
  nedges,nver:longint;
  vert:^gvert;
  edges:^gedge;
  discov,process:^pbool;
  mg:boolean;
  k,p1,p2,i:longint;
  st,fin:integer;
  c:char;
procedure load;
begin
  readln(nedges,nver);
  for i:=1 to nver do begin
    p1:=0;
    p2:=0;
    st:=0;
    fin:=0;
    repeat
      read(c);
      if c in ['0'..'9'] then p1:=p1*10+(ord(c)-48);
    until c=' ';
    repeat
      read(c);
      if c in ['0'..'9'] then st:=st*10+(ord(c)-48);
    until c=':';
    st:=st*60;
    repeat
      read(c);
      if c in ['0'..'9'] then fin:=fin*10+(ord(c)-48);
    until c=' ';
    st:=st+fin;
    fin:=0;
    repeat
      read(c);
      if c in ['0'..'9'] then p2:=p2*10+(ord(c)-48);
    until c=' ';
    inc(vert^[p1]);
    edges^[p1,vert^[p1]].v:=p2;
    edges^[p1,vert^[p1]].start:=st;
    repeat
      read(c);
      if c in ['0'..'9'] then fin:=fin*10+(ord(c)-48);
    until c=':';
    fin:=fin*60;
    st:=0;
    while not eoln do begin
      read(c);
      if c in ['0'..'9'] then st:=st*10+(ord(c)-48);
    end;
    fin:=fin+st;
    edges^[p1,vert^[p1]].finish:=fin;
  end;
end;
procedure sort(x,p:longint);
var
  s1,s2:longint;
buf:edge;
begin
  for s1:=1 to vert^[x]-1 do
    for s2:=s1+1 to vert^[x] do
      if (((p<=edges^[x,s2].start)and(p<=edges^[x,s1].start))and(edges^[x,s1].start>edges^[x,s2].start))or(((p>edges^[x,s2].start)and(p>edges^[x,s1].start))and(edges^[x,s1].start<edges^[x,s2].start)) then begin
        buf:=edges^[x,s1];
        edges^[x,s1]:=edges^[x,s2];
        edges^[x,s2]:=buf;
      end;
end;
procedure dfs(x,p:longint);
var j:longint;
begin
  sort(x,p);
  if not discov^[x] then discov^[x]:=true
    else if not process^[x] then process^[x]:=true;
  for j:=1 to vert^[x] do if not process^[edges^[x,j].v] then begin
    if  process^[x] and (edges^[x,j].start<p) then inc(k);
    dfs(edges^[x,j].v,edges^[x,j].finish);
  end;
end;
procedure init;
begin
  new(vert);
  new(edges);
  new(discov);
  new(process);
  fillchar(process^,sizeof(process^),0);
  fillchar(vert^,sizeof(vert^),0);
  fillchar(edges^,sizeof(edges^),0);
  fillchar(discov^,sizeof(discov^),0);
end;
begin
  assign(input,'buses.in');
  reset(input);
  assign(output,'buses.out');
  rewrite(output);
  k:=0;
  init;
  load;
  for i:=1 to nedges do if not discov^[i] then begin
    inc(k);
    dfs(i,0);
  end;
  mg:=true;
  for i:=1 to nedges do if not process^[i] then begin
    mg:=false;
    break;
  end;
  if not mg then writeln('-1') else writeln(k);
  dispose(vert);
  dispose(edges);
  dispose(discov);
  dispose(process);
  close(input);
  close(output);
end.