Const
  MaxCell=300;
  Amount=50000000;
Type
  TCell=Record
    Row,Col:Integer;
  End;
  TPoly=Record
    Height,Width,NCell:Integer;
    Cell:Array[1..MaxCell]Of TCell;
  End;
Var
  K:Integer;
  S,B:TPoly;
  Res:Int64;
  Have:Array[0..MaxCell-1,0..MaxCell-1]Of Boolean;
Procedure ReadPoly(Var P:TPoly);
Var
  Row,Col:Integer;
  Ch:Char;
Begin
  Read(P.Height,P.Width);
  P.NCell:=0;
  For Row:=1 To P.Height Do
    For Col:=1 To P.Width Do Begin
      If Not SeekEOF Then Read(Ch);
      If Ch='X' Then Begin
        Inc(P.NCell);
        P.Cell[P.NCell].Row:=Row-1;
        P.Cell[P.NCell].Col:=Col-1;
      End;
    End;
End;
Procedure Solve;
Var
  X,Y,MinX,MaxX,MinY,MaxY:Integer;
  I,J,Cur,Total:Integer;
  Ok:Boolean;
Begin
  FillChar(Have,SizeOf(Have),False);
  For I:=1 To B.NCell Do With B.Cell[I] Do
    Have[Row,Col]:=True;
  MinX:=0;
  MinY:=0;
  MaxX:=B.Width*K-S.Width;
  MaxY:=B.Height*K-S.Height;
  Total:=0;
  Cur:=0;
  For I:=1 To Amount Div (S.NCell+2) Do Begin
    X:=MinX+Random(MaxX-MinX+1);
    Y:=MinY+Random(MaxY-MinY+1);
    Ok:=True;
    For J:=1 To S.NCell Do With S.Cell[J] Do
      If Not Have[(Y+Row) Div K,(X+Col) Div K] Then Begin
        Ok:=False;
        Break;
      End;
    Inc(Total);
    If Ok Then Inc(Cur);
  End;
  Res:=(Int64(MaxX-MinX+1)*(MaxY-MinY+1)*Int64(Cur)+Total Div 2) Div Total;
End;
Begin
  RandSeed:=548391571;
  ReSet(Input,'poly.in');
  Read(K);
  ReadPoly(S);
  ReadPoly(B);
  Close(Input);
  Solve;
  ReWrite(Output,'poly.out');
  WriteLn(Res);
  Close(OutpuT);
End.
