program _5;

{$APPTYPE CONSOLE}

const MaxN = 300;
      MaxQ = 1000;
      MaxXZ = 1000000;

var fn, f : array [1..MaxN, 1..MaxN] of char;
    m, d : array [1..MaxQ, 1..MaxQ] of longint;
    modeled : array [1..MaxXZ] of boolean;
    sum : int64;
    k : longint;
    h, w, h1, w1 : longint;

procedure Init();
var i, j : longint;
begin
    Reset(input, 'poly.in');
    Rewrite(output, 'poly.out');
    Readln(k);
    Readln(h, w);
    for i := 1 to h do begin
      for j := 1 to w do Read(fn[i, j]);
      Readln;
    end;
    Readln(h1, w1);
    for i := 1 to h1 do begin
      for j := 1 to w1 do Read(f[i, j]);
      Readln;
    end;
end;

procedure Check(x, y : longint; p : longint);
var i, j : longint;
begin
    for i := 1 to h do
      for j := 1 to w do
        if (m[i + x - 1, j + y - 1] <> p) and (fn[i, j] = 'X') then Exit;
    inc(sum);
end;

procedure Modeling(q, p : longint);
var bg, en : longint;
    i, j : longint;
    l, k_ : longint;
    sdi, sdj, sdv : longint;
    st : longint;
begin
    sdi := 0; sdj := 0;
    bg := q - w div k;
    if w mod k = 0 then inc(bg);
    if bg < 1 then bg := 1;
    en := q + (w - 1) div k + 1;
    if (w - 1) mod k = 0 then dec(en);
    for i := bg to en do begin
      for j := 1 to h1 do
        if f[j, i] = 'X' then begin
          for k_ := 1 to k do
            for l := 1 to k do
              m[k_ + sdi, l + sdj] := p;
          sdi := sdi + k;
        end;
      sdj := sdj + k;
      sdi := 0;
    end;
    sdv := (bg - 1)*k;
    st := (q - bg + 1)*k - w + 2;
    if st <= 0 then st := 1;
    for j := st to (q - bg + 1)*k do
      if not modeled[j + sdv] then
        for i := 1 to h1*k - h + 1 do
          Check(i, j, p);
    for i := 1 to (en - bg + 1)*k - w do
      modeled[i + sdv] := true;
end;

procedure CheckUp(p, x, y : longint);
var i, j, k_, l : longint;
    f : boolean;
begin
    for i := 1 to x do
      for j := 1 to y do begin
        f := true;
        for k_ := 1 to h do
          if f then
            for l := 1 to w do
              if (fn[k_, l] = 'X') and (d[k_ + i - 1, l + j - 1] <> p) then begin
                f := false;
                Break;
              end;
        if f then inc(sum);
      end;
end;

procedure CheckUpR(p, x, y, frx, fry : longint);
var i, j, k_, l : longint;
    f : boolean;
begin
    for i := frx to x do
      for j := fry to y do begin
        f := true;
        for k_ := 1 to h do
          if f then
            for l := 1 to w do
              if (fn[k_, l] = 'X') and (d[k_ + i - 1, l + j - 1] <> p) then begin
                f := false;
                Break;
              end;
        if f then inc(sum);
      end;
end;

procedure DEBUFF(q, p : longint);
var i : longint;
    sv : longint;
    k_, l : longint;
begin
    sv := 0;
    for i := 1 to h1 do begin
      if (f[i, q + 1] = 'X') and (f[i, q] = 'X') then inc(sv)
      else if f[i, q] = 'X' then begin
        if ((k - h + 1)*sv > 0) and (sv > 0) then sum := sum + sv*(k - h + 1);
        if (sv = 0) and ((i + 1 > h1) or (f[i + 1, q + 1] = '.')) then Continue;
        if sv = 0 then begin
          for k_ := 1 to 2*h - 2 do
            for l := 1 to w - 1 do
              d[k_, l] := p;
          for k_ := 1 to h - 1 do
            for l := 1 to w - 1 do
              d[k_ + h - 1, l + w - 1] := p;
          CheckUp(p, h - 1, w - 1);
        end
        else begin
          if (f[i - 1, q + 1] = 'X') and ((i + 1 <= h1) and (f[i + 1, q + 1] = 'X')) and (2*h + 1 > k) then begin
            for k_ := 1 to h - 1 do
              for l := 1 to 2*w - 2 do
                d[k_, l] := p;
            for k_ := 1 to k do
              for l := 1 to w - 1 do
                d[h - 1 + k_, l] := p;
            for k_ := 1 to h - 1 do
              for l := 1 to 2*w - 2 do
                d[h - 1 + k_ + k, l] := p;
            CheckUp(p, k + h - 1, w - 1);
          end
          else begin
            for k_ := 1 to h - 1 do
              for l := 1 to 2*w - 2 do
                d[k_, l] := p;
            for k_ := 1 to h - 1 do
              for l := 1 to w - 1 do
                d[k_ + h - 1, l] := p;
            CheckUp(p, h - 1, w - 1);
          end;
        end;
        sv := 0;
      end
      else begin
        if ((k - h + 1)*sv > 0) and (sv > 0) then sum := sum + (k - h + 1)*sv;
        if (sv = 0) and ((i + 1 > h1) or (f[i + 1, q] = '.')) then Continue;
        if sv = 0 then begin
          for k_ := 1 to 2*h - 2 do
            for l := 1 to w - 1 do
              d[k_, l + w - 1] := p;
          for k_ := 1 to h - 1 do
            for l := 1 to w - 1 do
              d[k_ + h - 1, l] := p;
          CheckUpR(p, h - 1, 2*w - 2, w - 1, 1);
        end
        else begin
          if (f[i - 1, q] = 'X') and ((i + 1 <= h1) and (f[i + 1, q] = 'X')) and (2*h + 1 > k) then begin
            for k_ := 1 to h - 1 do
              for l := 1 to 2*w - 2 do
                d[k_, l] := p;
            for k_ := 1 to k do
              for l := 1 to w - 1 do
                d[h - 1 + k_, l + w - 1] := p;
            for k_ := 1 to h - 1 do
              for l := 1 to 2*w - 2 do
                d[h - 1 + k_ + k, l] := p;
            CheckUpR(p, k + h - 1, 2*w - 1, 1, w - 1);
          end
          else begin
            for k_ := 1 to h - 1 do
              for l := 1 to 2*w - 2 do
                d[k_, l] := p;
            for k_ := 1 to h - 1 do
              for l := 1 to w - 1 do
                d[k_ + h - 1, l + w - 1] := p;
            CheckUpR(p, h - 1, 2*w - 2, 1, w - 1);
          end;
        end;
        sv := 0;
      end;
    end;
    if ((k - h + 1)*sv > 0) and (sv > 0) then sum := sum + (k - h + 1)*sv;
end;

procedure Solve();
var i, j : longint;
    sn, sv : longint;
    p : longint;
begin
    p := 0;
    for j := 1 to w1 do begin
      sv := 0;
      for i := 1 to h1 do
        if f[i, j] = '.' then begin
          sn := (k - w + 1)*(k*sv - h + 1);
          if (sn > 0) and ((k - w + 1) > 0) then sum := sum + sn;
          sv := 0;
        end
        else inc(sv);
      sn := (k - w + 1)*(k*sv - h + 1);
      if (sn > 0) and (k - w + 1 > 0) then sum := sum + sn;
      if (j <> w1) and (w <> 1) then begin
        inc(p);
        if (k < Round(h*1.5)) or (k < Round(w*1.5)) then Modeling(j, p)
        else DEBUFF(j, p);
      end;
    end;
end;

procedure Print();
begin
    Writeln(sum);
    Close(input);
    Close(output);
end;

begin
    Init();
    Solve();
    Print();
end.
