program poly;

uses  SysUtils;

var k               : Word;
    f0,f1,f2        : array of array of boolean;
    f1h,f1w,f2h,f2w : Word;
    vars            : Int64;

     procedure Input;
     var f : Text;
         i,j : Word;
         s   : char;
     begin
          Assign(f,'poly.in');
          Reset(f);

          ReadLn(f,K);
          ReadLn(f,f2h,f2w);
          SetLength(f2,f2h+1,f2w+1);
          for i:=1 to f2h do
          begin
               for j:=1 to f2w do
               begin
                    Read(f,s);
                    if s='X' then f2[i,j]:=true
                             else f2[i,j]:=false;
               end;
               ReadLn(f);
          end;

          ReadLn(f,f1h,f1w);
          SetLength(f0,f1h+1,f1w+1);
          for i:=1 to f1h do
          begin
               for j:=1 to f1w do
               begin
                    Read(f,s);
                    if s='X' then f0[i,j]:=true
                             else f0[i,j]:=false;
               end;
               ReadLn(f);
          end;
          Close(f);
     end;

     procedure zf0;
     var i,j,x,y : Cardinal;
         h,w : Cardinal;
     begin
          h:=f1h*k; w:=f1w*k;
          SetLength(f1,h+1,w+1);
          for i:=1 to f1h do
              for j:=1 to f1w do
                  for y:=1 to k do
                      for x:=1 to k do
                          f1[i*k+y-k,j*k+x-k]:=f0[i,j];
          f1h:=h; f1w:=w;
     end;

     function ifok(x1,y1 : Cardinal) : boolean;
     var i,j : Word;
     begin
          result:=false;
          for i:=1 to f2h do
              for j:=1 to f2w do
                  if (not f1[y1+i-1,x1+j-1]) and f2[i,j] then exit;
          result:=true;
     end;

     procedure Solve;
     var i,j,x,y : Cardinal;
     begin
          vars:=0;
          for i:=1 to f1h-f2h+1 do
              for j:=1 to f1w-f2w+1 do
                  if ifok(j,i) then inc(vars);
     end;

     procedure Output;
     var f : Text;
     begin
          Assign(f,'poly.out');
          Rewrite(f);
          WriteLn(f,vars);
          Close(f);
     end;

begin
     Input;
     zf0;
     Solve;
     Output;
end.
