#include<iostream>
#include<fstream>
using namespace std;

class poly
{
public:
	__int64 H;
	__int64 W;
	__int8 **f;
	poly(__int64 h,__int64 w)
	{
		H = h;
		W = w;
		f = new __int8*[h];
		for(int i=0;i<h;i++)
			f[i] = new __int8[w];
	}
	poly()
	{
		H=W=0;
	}
/*	void display()
	{
		for(int i=0;i<H;i++)
		{
			for(int j=0;j<W;j++)
				cout<<f[i][j]<<" ";
			cout<<endl;
		}
		cout<<endl;
	}*/
	
};

poly base,res,kbase,kres;
int K;
__int64 S=0;

main()
{
	ifstream in("poly.in");
	ofstream out("poly.out");
	int h,w;
	__int64 i,j;
	char c;
	in>>K;
	in>>h>>w;
	res = poly(h,w);
	for(i=0;i<h;i++)
	{
		for(j=0;j<w;j++)
		{
			in>>c;
			if(c=='X')
				res.f[i][j]=1;
			else
				res.f[i][j]=0;
		}
	}
	in>>h>>w;
		base = poly(h,w);
	for(i=0;i<h;i++)
	{
		for(j=0;j<w;j++)
		{
			in>>c;
			if(c=='X')
				base.f[i][j]=1;
			else
				base.f[i][j]=0;
		}
	}
	kbase = poly(base.H*K,base.W*K);
	for(i=0;i<kbase.H;i++)
	{
		for(j=0;j<kbase.W;j++)
			kbase.f[i][j] = base.f[i/K][j/K];
	}


	int x,y;
	int st;
//	kbase.display();
	
	for(int dk=1;dk<=K;dk++)
	{
		if(kbase.H < res.H*dk || kbase.W<res.W*dk)
			continue;

		kres = poly(res.H*dk,res.W*dk);
		for(i=0;i<kres.H;i++)
		{
			for(j=0;j<kres.W;j++)
				kres.f[i][j]=res.f[i/dk][j/dk];
		}
//		kres.display();

		for(i=0;i<=kbase.H-kres.H;i++)
		{
			for(j=0;j<=kbase.W-kres.W;j++)
			{
				st=1;
				for(y=0;y<kres.H && st;y++)
				{
					for(x=0;x<kres.W && st;x++)
					{
						if(kres.f[y][x] == 1 && kbase.f[i+y][j+x]!=1)
							st=0;
					}
				}
				if(st==1)
                    S++;
			}

		}
	}


    out<<S<<endl;
	return 0;
}