program poly2;

{$APPTYPE CONSOLE}
{$O-,Q+,R+}
{ $O+,Q-,R-}

uses
  SysUtils;

var
  a,b: array [1..300,1..300] of boolean;
  k,ha,wa,hb,wb: integer;

procedure init;
var
  i,j: integer;
  ch: char;
begin
  read(k);
  readln(ha,wa);
  for i:=1 to ha do begin
    for j:=1 to wa do begin
      read(ch);
      case ch of
        'X': a[i,j]:=true;
        '.': a[i,j]:=false;
      end;
    end;
    readln;
  end;
  readln(hb,wb);
  for i:=1 to hb do begin
    for j:=1 to wb do begin
      read(ch);
      case ch of
        'X': b[i,j]:=true;
        '.': b[i,j]:=false;
      end;
    end;
    readln;
  end;
end;

function get(const i,j: integer): boolean;
var
  i1,j1: integer;
begin
  i1:=i div k;
  if i mod k>0 then inc(i1);
  j1:=j div k;
  if j mod k>0 then inc(j1);
  result:=b[i1,j1]
end;

var
  all: integer;

procedure solve;
var
  i,j,i1,j1,hb1,wb1: integer;
  temp: boolean;
begin
  all:=0;
  hb1:=hb*k; wb1:=wb*k;
  for i:=0 to hb1-ha do
    for j:=0 to wb1-wa do begin
      temp:=true;
      for i1:=1 to ha do begin
        if not temp then break;
        for j1:=1 to wa do
          if a[i1,j1] and not get(i1+i,j1+j) then begin
            temp:=false;
            break;
          end;
      end;
      if temp then inc(all);
    end;
end;

begin
  reset(input,'poly.in'); rewrite(output,'poly.out');
  init;
  solve;
  writeln(all);
end.
