#include <stdio.h>
#include <string.h>

#define SWAP(A, B, C) ((C) = (A), (A) = (B), (B) = (C))

#define MAX 310

int KH, KW, H1, W1, H2, W2, Len;
__int64 Ans = 0;
char S1[MAX][MAX], S2[MAX][MAX];
char T1[MAX][MAX], T2[MAX][MAX];
char S[MAX * MAX];

int main( void )
{
  int i, x, y, j, k, f, tmp;

  freopen("poly.in", "rt", stdin);
  freopen("poly.out", "wt", stdout);
  scanf("%d", &i), KH = KW = i;
  scanf("%d%d", &H2, &W2);
  for (i = 0; i < H2; i++)
    scanf("%s", S2[i]);
  scanf("%d%d", &H1, &W1);
  for (i = 0; i < H1; i++)
    scanf("%s", S1[i]);
  if (KH > H2 && KW > W2)
  {
    for (i = 0; i < H1; i++)
      for (j = 0; j < W1; j++)
        if (S1[i][j] == 'X')
          Ans += (KH - H1) * (KW - W2) - 1;
    KH = H2, KW = W2;
  }
  for (i = 0; i < 2; i++)
  {
    if (KH > H2)
    {
      for (y = 0; y < H1; y++)
      {
        for (Len = x = 0; x < W1; x++)
          for (k = 0; k < KW; k++)
            S[Len++] = S1[y][x];
        for (x = 0; x + W2 <= Len; x++)
        {
          for (f = 1, k = 0; k < H2 && f; k++)
            for (j = 0; j < W2; j++)
              if (S2[k][j] == 'X' && 'X' != S[x + j])
                f = 0;
          if (f)
            Ans += KH - H2;
        }
      }
      KH = H2;
    }
    for (i = 0; i < H1; i++)
      for (j = 0; j < W1; j++)
        T1[j][i] = S1[i][j];
    for (i = 0; i < H2; i++)
      for (j = 0; j < W2; j++)
        T2[j][i] = S2[i][j];
    memcpy(S1, T1, sizeof(T1));
    memcpy(S2, T2, sizeof(T2));
    SWAP(KH, KW, tmp);
    SWAP(H1, W1, tmp);
    SWAP(H2, W2, tmp);
  }
  for (y = 0; y + H2 <= H1 * KH; y++)
    for (x = 0; x + W2 <= W1 * KW; x++)
    {
      for (f = 1, i = 0; i < H2 && f; i++)
        for (j = 0; j < W2; j++)
          if (S2[i][j] == 'X' && 'X' != S1[(y + i) / KH][(x + j) / KW])
            f = 0;
      if (f)
        Ans++;
    }
  printf("%I64d\n", Ans);
  return 0;
}
