#include <stdio.h>
#include <string.h>

#define m 303

char o[m][m], n[m][m];
int oh, ow, os, nw, nh, ns, oi[m], oj[m], ni[m], nj[m], k;
__int64 ans;

void read( char a[m][m], int *h, int *w, int *s, int *ci, int *cj )
{
  int i, j;

  scanf("%d%d", h, w);
  for (i = 0; i < *h; i++)
    scanf("%s", a[i]);
  *s = 0;
  for (i = 0; i < *h; i++)
    for (j = 0; j < *w; j++)
      if (a[i][j] == 'X')
        ci[*s] = i, cj[*s] = j, (*s)++;
}

int is( int i, int j )
{
  int i1, j1;

  i1 = i / k, j1 = j / k;
  return i >= 0 && j >= 0 && i1 < oh && j1 < ow && o[i1][j1] == 'X';
}

int main( void )
{
  int i, j, q, l, t1, t2, t3, t, d, u[9], f[9];

  freopen("poly.in", "rt", stdin);
  freopen("poly.out", "wt", stdout);
  scanf("%d", &k);
  read(n, &nh, &nw, &ns, ni, nj);
  read(o, &oh, &ow, &os, oi, oj);
  ans = 0;
  if (k < nh || k < nw)
    for (i = 0; i < os; i++)
      for (j = 0; j < k; j++)
        for (q = 0; q < k; q++)
        {
          for (l = 0; l < ns; l++)
            if (!is(oi[i] * k + j + ni[l], oj[i] * k + q + nj[l]))
              break;
          if (l == ns)
            ans++;
        }
  else
  {
    memset(u, 0, sizeof(u));
    for (i = 0; i < os; i++)
    {
      ans += (k - nw + 1) * (k - nh + 1);
      t1 = oi[i] < oh - 1 && o[oi[i] + 1][oj[i]] == 'X';
      t2 = oj[i] < ow - 1 && o[oi[i]][oj[i] + 1] == 'X';
      t3 = oi[i] < oh - 1 && oj[i] < ow - 1 && o[oi[i] + 1][oj[i] + 1] == 'X';
      if (t1)
        ans += (nh - 1) * (k - nw + 1);
      if (t2)
        ans += (nw - 1) * (k - nh + 1);
      t = t1 | (t2 << 1) | (t3 << 1);
      if (!u[t])
      {
        for (d = 0, j = k - nh + 1; j < k; j++)
          for (q = k - nw + 1; q < k; q++)
          {
            for (l = 0; l < ns; l++)
              if (!is(oi[i] * k + j + ni[l], oj[i] * k + q + nj[l]))
                break;
            if (l == ns)
              d++;
          }
        u[t] = 1, f[t] = d;
      }
      ans += f[t];
    }
  }
  printf("%I64d", ans);
  return 0;
}
