program poly;

uses Math;

{$APPTYPE CONSOLE}

type TPoint= record
x, y: Integer;
end;

var
  K: Integer;
  big, little: array[1..600, 1..600] of Boolean;
  figure: array[1..300] of TPoint;
  f: Integer;
  bx, by, lx, ly: Integer;

procedure LoadData;
var Data: TextFile;
i, j: Integer;
c: Char;
begin
  AssignFile(data, 'poly.in');
  Reset(data);
  ReadLn(Data, K);
  ReadLn(Data, ly, lx);
  f := 0;
  for j := 0 to ly - 1 do begin
    for i := 0 to lx - 1 do begin
      Read(Data, c);
      if c = 'X' then begin
        Inc(f);
        figure[f].X := i;
        figure[f].Y := j;
      end;
    end;
    ReadLn(Data);
  end;
{  for j := 1 to ly do begin
    for i := 1 to lx do begin
      Read(Data, c);
      if c = 'X' then little[i, j] := True;
    end;
    ReadLn(Data);
  end;    }
  ReadLn(Data, by, bx);
  for j := 1 to by do begin
    for i := 1 to bx do begin
      Read(Data, c);
      if c = 'X' then big[i, j] := True;
    end;
    ReadLn(Data);
  end;
  CloseFIle(Data);
end;

function Perebor: Integer;
var bigi, bigj: Integer;
i, j: Integer;
x: Integer;
a, b: Integer;
t: Boolean;
begin
  result := 0;
  for bigi := 1 to bx do
    for bigj := 1 to by do
      for i := 1 to K do
        for j := 1 to K do begin
          t := True;
          for x := 1 to f do begin
            a := (bigi - 1) * K + i + Figure[x].x;
            b := (bigj - 1) * K + j + Figure[x].y;
            a := Ceil(a / k);
            b := Ceil(b / k);
            if big[a, b] = False then begin
              t := False;
              Break;
            end;
          end;
          if t = True then Inc(result);
        end;
end;

function Giga: Int64;
var
bigmask: array[1..300, 1..300] of record
  used: array[0..7] of Boolean;
end;
mask: array[0..7] of integer;
newmask: Integer;
i, j, x: Integer;
right, bottom: Boolean;
begin
  for i := 0 to 7 do mask[i] := 0;
  for i := 1 to K do
    for j := 1 to K do begin
      newmask := 0;
      if (lx + i - 1 >= K) or (ly + j - 1 >= K) then begin
        for x := 1 to f do begin
          if Figure[x].x + i > K then right := True else right := False;
          if Figure[x].y + j > K then bottom := True else bottom := False;
          if right and bottom then newmask := newmask or 2 else begin
            if right then newmask := newmask or 1;
            if bottom then newmask := newmask or 4;
          end;
        end;
      end;
      Inc(mask[newmask]);
    end;
  Result := 0;
  for j := 1 to by do
    for i := 1 to bx do begin
      if Big[i, j] = False then Continue;;
      Result := Result + mask[0];
      newmask := 0;
      if Big[i+1, j] and Big[i, j+1] then newmask := newmask or 2;
      if Big[i+1, j] then newmask := newmask or 1;
      if Big[i, j+1] then newmask := newmask or 4;
      case newmask of
        1: Result := Result + mask[1];
        2: Result := Result + mask[2];
        3: Result := Result + mask[3] + mask[2] + mask[1];
        4: Result := Result + mask[4];
        5: Result := Result + mask[5] + mask[1] + mask[4];
        6: Result := Result + mask[6] + mask[4] + mask[2];
        7: for x := 1 to 7 do Result := Result + mask[x];
      end;
    end;
end;

var Data: TextFile;
begin
  AssignFile(data, 'poly.out');
  Rewrite(data);
  LoadData;
  if K < 150 then Write(Data, Perebor) else Write(Data, Giga);
  CloseFIle(Data);
end.

