program poly;

{$APPTYPE CONSOLE}

const
	MaxN = 310;

type
  TPoly = array [1..MaxN, 1..MaxN] of Boolean;

var
  k, h1, w1, h2, w2, i, j, ii, jj: Integer;
  ch: char;
  a, b: TPoly;
  m: array [1..MaxN, 1..MaxN] of Integer;
  ans: Int64;
  aa: array [1..MaxN*20, 1..MaxN*20] of Boolean;
  f: Boolean;

begin
	Reset(input, 'poly.in');
	Rewrite(output, 'poly.out');

  ReadLn(k, h1, w1);
  fillchar(a, sizeof(a), 0);
  fillchar(b, sizeof(b), 0);
  for i := 1 to h1 do
    begin
      for j := 1 to w1 do
        begin
          Read(ch);
          a[i,j] := ch = 'X';
        end;
      ReadLn;
    end;
  ReadLn(h2, w2);
  for i := 1 to h2 do
    begin
      for j := 1 to w2 do
        begin
          Read(ch);
          b[i,j] := ch = 'X';
        end;
      ReadLn;
    end;

  fillchar(m, sizeof(m), 0);
  for i := 1 to h1 do
    for j := 1 to w1 do
      for ii := 1 to h1 do
        for jj := 1 to w1 do
          if a[ii,jj] then
            if i+ii-1 > h1 then
              if j+jj-1 > w1 then m[i,j] := m[i,j] or 2
              else m[i,j] := m[i,j] or 1
            else
              if j+jj-1 > w1 then m[i,j] := m[i,j] or 4;

  if k <= 20 then
    begin
      fillchar(aa, sizeof(aa), 1);
      for i := 1 to k*h2 do
        for j := 1 to k*w2 do
          aa[i,j] := b[(i+k-1) div k, (j+k-1) div k];
      ans := 0;
      for i := 1 to k*h2-h1+1 do
        for j := 1 to k*w2-w1+1 do
          begin
            f := true;
            for ii := 1 to h1 do
              for jj := 1 to w1 do
                f := f and (aa[i+ii-1,j+jj-1] >= a[ii,jj]);
            ans := ans + ord(f);
          end;
      Write(ans);
      exit;
    end;

  ans := 0;
  for i := 1 to h2 do
    for j := 1 to w2 do
      if b[i,j] then
        begin
          ans := ans + int64(k-w1)*int64(k-h1);
          if b[i+1,j] then ans := ans + int64(k-w1)*int64(h1);
          if b[i,j+1] then ans := ans + int64(k-h1)*int64(w1);
          for ii := 1 to h1 do
            for jj := 1 to w1 do
              if ((m[ii,jj] and 1 > 0) <= b[i+1,j]) and
                 ((m[ii,jj] and 2 > 0) <= b[i+1,j+1]) and
                 ((m[ii,jj] and 4 > 0) <= b[i,j+1]) then ans := ans + 1;
        end;

  Write(ans);

	Close(input);
	Close(output);
end.