program poly;

uses
  SysUtils,dialogs;

const
  maxk=10000;
  maxx=300;

type
  bool=0..1;
  coord=0..maxx;
  int = 0..maxk;
  cord=0..maxx*maxk;

var
  fi,fo:text;
  k:int;
  x1,x2,y1,y2,i,pp1,pp2:coord;
  poly1:array[1..300,1..2] of coord;
  poly2:array[1..300,1..300] of bool;
  p1,p2,x_y:boolean;
  xi,yi:cord;
  kol:int64;

procedure init;
var
  xi,yi:coord;
  c:char;
begin
  p1:=true;
  p2:=true;
  i:=1;
  pp1:=0;pp2:=0;
  reset(fi,'poly.in');
  rewrite(fo,'poly.out');
  readln(fi,k);
  readln(fi,x1,y1);
  for xi:=1 to x1 do
    begin
    for yi:=1 to y1 do
      begin
        read(fi,c);
        if UpCase(c)='X' then
        begin
          inc(pp1);
          poly1[pp1,1]:=xi;
          poly1[pp1,2]:=yi;
          p1:=false;
        end;
      end;
    readln(fi);
    end;
  readln(fi,x2,y2);
  for xi:=1 to x2 do
    begin
    for yi:=1 to y2 do
      begin
        read(fi,c);
        if UpCase(c)='X' then
        begin
          poly2[xi,yi]:=1;
          inc(pp2);
        end
        else poly2[xi,yi]:=0;
        p2:=p2 and (poly2[xi,yi]=1);
      end;
    readln(fi);
    end;
  x_y:= (k >= x1) and (k >= y1);
  closefile(fi);
end;

function comp(x,y:cord):boolean;
begin
comp:=true;
for i:=1 to pp1 do
  if poly2[(x+poly1[i,1]-2) div k + 1,(y+poly1[i,2]-2) div k + 1] = 0 then
    begin
      comp:=false;
      break;
    end;
end;

procedure compare1(x,y:coord);
var
  xx,yy:cord;
begin
  if (poly2[x+1,y] = 0) and (poly2[x,y+1] = 0) then exit;

  if (poly2[x+1,y] = 0) and (poly2[x+1,y+1] = 0) then
  begin
  for xx:=1 to (k-x1+1) do
    for yy:=(k-y1+2) to k do
      if comp((x-1)*k+xx,(y-1)*k+yy)=true then kol:=kol+1;
  exit;
  end;

  if (poly2[x,y+1] = 0) and (poly2[x+1,y+1] = 0) then
  begin
  for xx:=(k-x1+2) to k do
    for yy:=1 to (k-y1+1) do
      if comp((x-1)*k+xx,(y-1)*k+yy)=true then kol:=kol+1;
  exit;
  end;

  for xx:=1 to (k-x1+1) do
    for yy:=(k-y1+2) to k do
      if comp((x-1)*k+xx,(y-1)*k+yy)=true then kol:=kol+1;
  for xx:=(k-x1+2) to k do
    for yy:=1 to k do
      if comp((x-1)*k+xx,(y-1)*k+yy)=true then kol:=kol+1;
end;

procedure compare2(x,y:coord);
var
  xx,yy:cord;
begin
  if (poly2[x+1,y]=0) and (poly2[x,y+1]=0) then exit;
  for xx:=1 to k do
    for yy:=1 to k do
      if comp((x-1)*k+xx,(y-1)*k+yy)=true then kol:=kol+1
end;

procedure solve;
begin
if p1 or p2 then kol:=(x2*k-x1+1)*(y2*k-y1+1)
else
begin
{for xi:=1 to (x2*k-x1+1) do
  for yi:=1 to (y2*k-y1+1) do
    if comp(xi,yi) then kol:=kol+1;}
if x_y then
begin
kol:=pp2*(k-x1+1)*(k-y1+1);
for xi:=1 to x2-1 do
  for yi:=1 to y2-1 do
    compare1(xi,yi);
end else
begin
for xi:=1 to x2-1 do
  for yi:=1 to y2-1 do
    compare2(xi,yi);
end;
end;
end;

begin
init;
kol:=0;
if (x1<x2*k) and (y1<y2*k) then solve;
writeln(fo,kol);
closefile(fo);
end.
