{$O+,Q-,R-}
program Poly;

{$APPTYPE CONSOLE}

uses
  SysUtils, Windows;

const
  maxK = 100;
  maxW1 = 30;
  maxH1 = 30;
  maxW2 = maxW1 * maxK;
  maxH2 = maxH1 * maxK;
  maxWorkTime = 1900;

var
  k, w1, h1, w2, h2, x, y, x0, y0, c: integer;
  workStart: cardinal;
  isIn: boolean;
  s: string;
  a1: array [1..maxW1, 1..maxH1] of integer;
  a2: array [1..maxW2, 1..maxH2] of integer;

procedure Return(x: integer);
begin
  Writeln(x);
  CloseFile(Input);
  CloseFile(Output);
  Halt(0);
end;

begin
  workStart := GetTickCount;

  AssignFile(Input, 'poly.in');
  AssignFile(Output, 'poly.out');
  Reset(Input);
  Rewrite(Output);

  Readln(k);
  if k > maxK then Return(0);

  Readln(h1, w1);
  if (h1 > maxH1) or (w1 > maxW1) then Return(0);
  FillChar(a1, SizeOf(a1), 0);
  for y := 1 to h1 do
  begin
    Readln(s);
    s := Trim(s);
    for x := 1 to w1 do
      if s[x] = 'X' then
        a1[x, y] := 1;
  end;

  Readln(h2, w2);
  if (h2 > maxH2) or (w2 > maxW2) then Return(0);
  FillChar(a2, SizeOf(a2), 0);
  for y := 1 to h2 do
  begin
    Readln(s);
    s := Trim(s);
    for x := 1 to w2 do
      if s[x] = 'X' then
        for x0 := (x-1) * k + 1 to x * k do
          for y0 := (y-1) * k + 1 to y * k do
            a2[x0, y0] := 1;
  end;

  c := 0;
  for x := 1 to w2*k - w1 + 1 do
    for y := 1 to h2*k - h1 + 1 do
    begin
      isIn := true;
      for x0 := 1 to w1 do
        for y0 := 1 to h1 do
          if (a1[x0, y0] = 1) and (a2[x+x0-1, y+y0-1] = 0) then
          begin
            isIn := false;
            Break;
          end;
      if isIn then Inc(c);
      if GetTickCount - workStart > maxWorkTime then Return(c);
    end;

  Return(c);
end.
