#include <fstream>

int a[400][400], A[400][400];
struct rec {
	int l,r;
} seg[100000], seg2[100000], seg3[100000];
int b, b2, b3;

void add(int l, int r) {
	seg2[b2].l = l;
	seg2[b2].r = r;
	b2++;
}

void intersect() {
	int j = 0;
	b3 = 0;
	for (int i = 0; i < b2; i++) {
		int left = (seg2[i].l > seg[j].l) ? seg2[i].l : seg[j].l;
		int right = (seg2[i].r < seg[j].r) ? seg2[i].r : seg[j].r;
		if (left <= right) {
			seg3[b3].l = left;
			seg3[b3].r = right;
			b3++;
		}
		while (seg2[i].r >= seg[j].r) {
			j++;
			if (j >= b)
				break;
			int left = (seg2[i].l > seg[j].l) ? seg2[i].l : seg[j].l;
			int right = (seg2[i].r < seg[j].r) ? seg2[i].r : seg[j].r;
			if (left <= right) {
				seg3[b3].l = left;
				seg3[b3].r = right;
				b3++;
			}
		}
	}
	b = b3;
	for (int i = 0; i < b; i++)
		seg[i] = seg3[i];
	b2 = 0;
}

int main() {
	std::ifstream fin("poly.in");
	std::ofstream fout("poly.out");
	int k;
	int h, w, H, W;
	fin >> k;
	fin >> h >> w;
	for (int i = 0; i < h; i++) {
		fin.ignore(1, '\n'); 
		for (int j = 0; j < w; j++) {
			char c;
			fin.get(c);
			a[i][j] = ((c == 'X') || (c == 'x')) ? 1 : 0;
		}
	}
	fin >> H >> W;
	for (int i = 0; i < H; i++) {
		fin.ignore(1, '\n'); 
		for (int j = 0; j < W; j++) {
			char c;
			fin.get(c);
			A[i][j] = ((c == 'X') || (c == 'x')) ? 1 : 0;
		}
	}
	_int64 ans = 0;
	for (int i = 0; i <= H*k - h; i++) {
		b = 1;
		seg[0].l = 0;
		seg[0].r = W*k-1;
		b2 = 0;
		for (int j = 0; j < h; j++) {
			int o = (i + j) / k;
			int fst = w-1, lst = w;
			for (int l = 0; l < w; l++)
				if (a[j][l]) {
					if (fst > l)
						fst = l;
					lst = l;
				}
			int s = lst - fst + 1;
			int len = 0;
			int start = -1;
			int count = 0;
			for (int l = 0; l < W; l++)
				if (A[o][l]) {
					len++;
					if (start == -1)
						start = l;
				}
				else {
					if (len*k >= s)
						add(start*k, start*k + len*k - s);
						//count += len*k - s + 1;
					len = 0;
					start = -1;
				}
			if (len*k >= s)
				add(start*k, start*k + len*k - s);
			if (b2 == 0) {
				b = 0;
				break;
			}
			intersect();
			//count += len*k - s + 1;
			//fout << count << std::endl;
		}
		for (int j = 0; j < b; j++)
			ans += seg[j].r - seg[j].l + 1;
	}
	fout << ans;
	return 0;
}