#include <stdio.h>
#include <string.h>

#define MAX_S 304

#define MAX(A, B) ((A) > (B) ? (A) : (B))

int F[MAX_S][MAX_S], FN[MAX_S][MAX_S], W, H, WN, HN;

int main( void )
{
  int K, i, j, k, l, m, n, f, sw, sh;
  __int64 sum;
  char buf[MAX_S];

  freopen("poly.in", "rt", stdin);
  freopen("poly.out", "wt", stdout);

  memset(F, 0, sizeof(F));
  memset(FN, 0, sizeof(FN));

  gets(buf), sscanf(buf, "%i", &K);
  gets(buf), sscanf(buf, "%i%i", &HN, &WN);
  for (i = 0; i < HN; i++)
    for (gets(buf), j = 0; j < WN; j++)
      if (buf[j] == 'X')
        FN[i][j] = 1;

  gets(buf), sscanf(buf, "%i%i", &H, &W);
  for (i = 0; i < H; i++)
    for (gets(buf), j = 0; j < W; j++)
      if (buf[j] == 'X')
        F[i][j] = 1;

  if (K * W < WN || K * H < HN)
  {
    printf("0");
    return 0;
  }

  sw = (WN - 1) / K + 1, sh = (HN - 1) / K + 1;
  if ((__int64)K * K * WN * HN * (H - sh) * (W - sw) >= 200000000)
  {
    for (sum = 0, i = 0; i < H; i++)
      for (j = 0; j < W; j++)
        if (F[i][j])
          sum++;

    printf("%I64i", sum * (K - WN + 1) * (K - HN + 1));
    return 0;
  }

  for (sum = 0, i = 0; i <= H - sh; i++)
    for (j = 0; j <= W - sw; j++)
      for (k = 0; k < K; k++)
        for (l = 0; l < K; l++)
        {
          for (f = 1, m = 0; m < HN && f; m++)
            for (n = 0; n < WN; n++)
              if (FN[m][n] && !F[i + (k + m) / K][j + (l + n) / K])
              {
                f = 0;
                break;
              }
          if (f)
            sum++;
        }

  printf("%I64i", sum);

  return 0;
}
