program poly;

{$APPTYPE CONSOLE}

uses
  SysUtils;

var
  Fin, Fout      : Text;
  I, J           : longword;
  N              : int64;
  StP, FnP       : array[0..301, 0..301] of shortint;
  ch             : char;
  SH, SW, K      : word;
  Fh, Fw, Lh, Lw : word;

function IsEqual(Dh, Dw : word) : boolean;
var
  I, J : word;
begin
  For I:=1 To Fh do
  For J:=1 to Fw do
  begin
    if Fnp[I, J]>Stp[((I+Dh-2) div K)+1, ((J+dw-2) div K)+1] then
    begin
      IsEqual:=false;
      exit;
    end;
  end;
  IsEqual:=true;
end;

begin
  Assign(Fin, 'poly.in');
  Assign(Fout, 'poly.out');
  Reset(Fin);
  Rewrite(Fout);
  Readln(Fin, K);
  N:=0;

  Readln(Fin, FH, FW);
  For I:=1 To FH do
  begin
    For J:=1 to Fw-1 do
    begin
      Read(Fin, ch);
      if ch='.' then FnP[I, J]:=0 else FnP[I, J]:=1;
    end;
    Readln(Fin, ch);
    if ch='.' then FnP[I, Fw]:=0 else FnP[I, Fw]:=1;
    FnP[I, Fw+1]:=0;
  end;

  Readln(Fin, SH, SW);
  For I:=1 To SH do
  begin
    For J:=1 to Sw-1 do
    begin
      Read(Fin, ch);
      if ch='.' then StP[I, J]:=0 else StP[I, J]:=1;
    end;
    Readln(Fin, ch);
    if ch='.' then StP[I, Sw]:=0 else StP[I,Sw]:=1;
    StP[I, Sw+1]:=0;
  end;

  I:=1;

  Lh:=Sh*K-Fh+1;
  Lw:=Sw*K-Fw+1;

  While I<=Lh do
  begin
    J:=1;
    While J<=Lw do
    begin
      if IsEqual(I, J) then
        N:=N+1;
      J:=J+1;
    end;
    I:=I+1;
  end;

  Writeln(Fout, N);
  Close(Fin);
  Close(Fout);
end.
