program task5;

{$APPTYPE CONSOLE}

uses
  SysUtils;
type
 TPoly= record
  h, w: Integer;
  sq: array [1..300, 1..300] of Boolean;
 end;

procedure razd(var poly: TPoly; k : Integer);
var
 i, j, x, y: Integer;
 res: TPoly;
begin
 res.h:=poly.h*k;
 res.w:=poly.w*k;
 for i:=1 to poly.h do
  for j:=1 to poly.w do
   for y:=1 to k do
    for x:=1 to k do
     res.sq[(j-1)*k+x, (i-1)*k+y]:=poly.sq[j, i];
 poly:=res;
end;

function canCut(newP, oldP: TPoly; x, y: Integer): Boolean;
var
 i, j: Integer;
begin
 canCut:=true;
 for i:=y to y+newP.h do
  for j:=x to x+newP.w do
   if (not oldP.sq[j, i]) and newP.sq[j-x+1, i-y+1] then
      begin
       canCut:=false;
       exit;
      end;
end;

var
 f: Textfile;
 i, j: Integer;
 k: Integer;
 buf: Char;
 oldP, newP: TPoly;
 count:Integer;
begin
  { TODO -oUser -cConsole Main : Insert code here }
  assignFile(f, 'poly.in');
  reset(f);
  readln(f, k);
  readln(f, newP.h, newP.w);
  for i:=1 to newP.h do
   begin
     for j:= 1 to newP.w do
       begin
         read(f, buf);
        if buf='X' then
            newP.sq[j,i]:=true
          else
           newP.sq[j,i]:=false;
        end;
     readln(f, buf);
    end;
  readln(f, oldP.h, oldP.w);
  for i:=1 to oldP.h do
   begin
     for j:= 1 to oldP.w do
      begin
       read(f, buf);
       if buf='X' then oldP.sq[j,i]:=true
                  else oldP.sq[j,i]:=false;
      end;
     readln(f, buf);
    end;
   closeFile(f);
  razd(oldP, k);
 count:=0;
 for i:=1 to oldP.h-newP.h+1 do
  for j:=1 to oldP.w-newP.w+1 do
   if oldP.sq[j, i] then
    if canCut(newP,oldP, j, i) then
     count:=count+1;
 assignFile(f, 'poly.out');
 rewrite(f);
 writeln(f, count);
 closeFile(f);
end.
