{$A8,B-,C+,D+,E-,F-,G+,H+,I+,J-,K-,L+,M-,N+,O-,P+,Q-,R-,S-,T-,U-,V+,W-,X+,Y+,Z1}
{$MINSTACKSIZE $00004000}
{$MAXSTACKSIZE $00100000}

program poly_ea;

{$APPTYPE CONSOLE}

uses
  SysUtils, Math;

const namein='poly.in';
      nameout='poly.out';
      NMax=350;
      KMax=11000;
      NA=-1;
      Last=-2;
      Term:set of char=['X','.'];
type
 TPoly=array [1..NMax,1..NMax] of integer;
 TEl=record
   n,m:integer
  end;
 TArr=array [1..NMax] of integer;
var x,y,v:TPoly;
    k,c:integer;
    Sol:int64;
    sx,sy:TEl;
    a,b:TArr;

procedure Init;

 procedure ReadPoly(var x:TPoly; var s:TEl);
 var i,j:integer;
     c:char;
 begin
  fillchar(x,sizeof(x),0);
  readln(s.n,s.m);
  i:=1;
  while i<=s.n do begin
    j:=1;
    while j<=s.m do begin
      read(c);
      if c in Term then begin
        if c='X' then x[i,j]:=1;
        inc(j)
       end
     end;
    inc(i) 
   end;
 end;

begin
 assign(input,namein);
 reset(input);
 readln(k);
 ReadPoly(y,sy);
 ReadPoly(x,sx);
 close(input)
end;

function Calc(i,j:integer):integer;
var q:integer;
begin
 if v[i,j]=NA then
  if (j=(sx.m+1)) then v[i,j]:=Last
  else
   if x[i,j]<>x[i,j+1] then v[i,j]:=0
   else begin
     q:=Calc(i,j+1);
     if q<>Last then v[i,j]:=q+1
     else v[i,j]:=q
    end;
 Result:=v[i,j]   
end;

function GetPlace(a:integer):integer;
begin
 Result:=(a-1) div k+1
end;

function GetSqr(a:integer):integer;
begin
 if a mod k=0 then Result:=1
 else Result:=k-a mod k+1
end;

procedure Solve;
var c,i,j,q,r1,r2,tx,ty:integer;
    ok,rev:boolean;
begin
 fillchar(v,sizeof(v),NA);
 for i:=1 to sx.n do
  for j:=1 to sx.m do
   v[i,j]:=Calc(i,j);
 c:=0;
 for i:=1 to sy.n do
  for j:=1 to sy.m do
   if y[i,j]=1 then begin
     inc(c);
     a[c]:=i;
     b[c]:=j
    end;
 Sol:=0;   
 i:=0; j:=0; ok:=true;
 while ok do begin
   r1:=0;
   r2:=maxint;
   rev:=true;
   for q:=1 to c do begin
     tx:=GetPlace(a[q]+i);
     ty:=GetPlace(b[q]+j);
     ok:=ok and (tx<=sx.n);
     if ty>sx.m then begin
       rev:=false;
       r1:=NA;
       break
      end; 
     if ok then
      if x[tx,ty]=0 then begin
        rev:=false;
        if v[tx,ty]=Last then r1:=NA;
        if r1<>NA then r1:=max(r1,v[tx,ty]*k+GetSqr(b[q]+j))
       end
      else r2:=min(r2,v[tx,ty]*k+GetSqr(b[q]+j))
    end;
   if ok then
    if rev then begin
       inc(j,r2+1);
       Sol:=Sol+int64(r2)
      end
    else
     if r1<>NA then inc(j,r1)
     else j:=maxint;
   if j>sx.m*k then begin
     inc(i);
     j:=0
    end
  end
end;

procedure Done;
begin
 assign(output,nameout);
 rewrite(output);
 writeln(Sol);
 close(output)
end;

begin
 Init;
 Solve;
 Done
end.
