{$A8,B-,C+,D-,E-,F-,G+,H+,I-,J-,K-,L-,M-,N+,O+,P+,Q-,R-,S-,T-,U-,V+,W-,X+,Y+,Z1}
//{$A8,B-,C+,D+,E-,F-,G+,H+,I+,J-,K-,L+,M-,N+,O-,P+,Q+,R+,S+,T-,U-,V+,W-,X+,Y+,Z1}
program Problem5;

{$APPTYPE CONSOLE}

uses
  SysUtils,Math;
const
  maxN=300+2;
type
  int=longint;
  real=extended;
  bool=boolean;
  TPol=record
      h,w:int;
      kl:array[0..maxN,0..maxN] of bool;
      min,max:array[0..maxN] of int;
    end;
const
  in_f='poly.in';
  out_f='poly.out';
var
  K:int;
  a,b:TPol;
  b2:array of array of bool;


procedure ReadPol(var a:Tpol);
var
 i,j:int;
 ch:char;
begin
   REadln(a.h,a.w);
   for i := 1 to a.h do
     begin
       for j := 1 to a.w do
         begin
           Read(ch);
           a.kl[i,j]:=ch='X';
         end;
       for j := 1 to a.w do
         if a.kl[i,j] then
           begin
             a.min[i]:=j;
             break;
           end;
       for j := a.w downto 1 do
         if a.kl[i,j] then
           begin
             a.max[i]:=j;
             break;
           end;
       Readln;
     end;
end;     

procedure Solve2;
 var
   i,j,t1,t2:int;
   ans:int;
 label
  l1;  
 begin
   ans:=0;
   SetLength(b2,b.h*k);
   for i := 0 to length(b2)-1 do
     SetLength(b2[i],b.w*k);
   for i:= 1 to b.h do
     for j := 1 to b.w do
       for t1 := 0to k-1 do
         for t2 := 0 to k-1 do
           b2[(i-1)*k+t1,(j-1)*k+t2]:=b.kl[i,j];
   for i := 0 to b.h*k-a.h do
     for j := 0 to b.w*k-a.w do
       begin
         for t1 := 1 to a.h do
           for t2:= 1 to a.w do
             if a.kl[t1,t2] and not b2[i+t1-1,j+t2-1] then
               goto l1;
         inc(ans);        
l1:
       end;
   Write(ans);
 end;

procedure Run;
 var
  i,j:int;
  have,use:array[0..15] of int{64};
  min1,max1,min2,max2:int;
  ans:int64;
 begin
   REad(k);
   REadPol(A);
   ReadPol(b);
   if k<max(a.h,a.w)-1 then
     begin
       Solve2;
       exit;
     end;
   fillchar(have,sizeof(have),0);
   for i := 1 to b.h do
     for  j:= 1 to b.w do
       inc(have[8*ord(b.kl[i,j])+ 4*ord(b.kl[i+1,j])+2*ord(b.kl[i+1,j+1])+ord(b.kl[i,j+1])]);
   fillchar(use,sizeof(use),0);
   for i := 1 to K do
     begin
       min1:=a.w;
       max1:=0;
       min2:=a.w;
       max2:=0;
       for j := 1 to a.h do
         if i+j-1>K then
            begin
              if a.min[j]<min2 then
                min2:=a.min[j];
              if a.max[j]>max2 then
                max2:=a.max[j];
            end
         else
            begin
              if a.min[j]<min1 then
                min1:=a.min[j];
              if a.max[j]>max1 then
                max1:=a.max[j];
            end;
       if max2=0 then
         begin
           if k-max1+min1>0 then
             inc(use[8],k-max1+min1);
           if max1-min1>0 then
             inc(use[8+1],max1-min1);
         end
       else
         begin
           if k-max(max1,max2)+1>0 then
             inc(use[8+4],k-max(max1,max2)+1);
           if min2-1>0 then
             inc(use[8+2+1],min2-min1);
           if max2-max1>0 then
             inc(use[8+4+2],max2-max1);
           if min(max1,max2)-min2>0 then
             inc(use[8+4+2+1],min(max1,max2)-min2);
           if min1-1>0 then
             inc(use[1+2+4],min1-1);
         end;
     end;
   ans:=0;  
   for i := 0 to 15 do
     for j := 0 to 15 do
       if  i or j =i then
         inc(ans,use[j]*have[i]);
   Write(ans);      
 end;

procedure OpenFiles;
begin
  REset(input,in_f);
  REwrite(output,out_f);
end;

procedure CloseFiles;
begin
  Close(input);
  Close(output);
end;

begin
OpenFiles;
Run;
CloseFiles;
end.
