{$r-,q-,s-,i-,o+}
program p5dpr;

type tpoly = record
        w, h, np : integer;
        m : array [1..300, 1..300] of char;
        l : array [1..300, 1..2] of integer;
     end;

var p1, p2, tmp : tpoly;
    k, i, j : integer;
    ans : int64;

function check(x, y : integer) : boolean;
var i : integer;
begin
   check := false;
   if (x+p1.h-1 > p2.h*k) or (y < p1.w) then exit;
   for i := 1 to p1.np do
      if p2.m[(x+p1.l[i][1]-2) div k + 1][(y-p1.w+p1.l[i][2]-1) div k + 1] = '.' then exit;
   check := true;
end;

procedure Stupid;
var i, t1, t2 : integer;
begin
   ans := 0;
   for i := 1 to p2.np do
    for t1 := 1 to k do
     for t2 := 1 to k do
      if check((p2.l[i][1]-1)*k+t1, (p2.l[i][2]-1)*k+t2) then
         inc(ans);
end;

function bin(x, y1, y2 : integer) : integer;
begin
   if y1 = y2 then begin
      if check(x, y1) then bin := (y1-1) mod k+1 else bin := k+1;
      exit;
   end;
   if check(x, (y1+y2) div 2) then
      bin := bin(x, y1, (y1+y2) div 2)
   else
      bin := bin(x, (y1+y2) div 2+1, y2);
end;

procedure Clever;
var i, t : integer;
begin
   ans := 0;
   for i := 1 to p2.np do
      for t := 1 to k do begin
         ans := ans+k+1-bin((p2.l[i][1]-1)*k+t, (p2.l[i][2]-1)*k+1, p2.l[i][2]*k);
      end;
end;

begin
   reset(Input, 'poly.in');
   rewrite(output, 'poly.out');

   readln(k);
   readln(p1.h, p1.w); p1.np := 0;
   for i := 1 to p1.h do begin
      for j := 1 to p1.w do begin
         read(p1.m[i][j]);
         if p1.m[i][j] = 'X' then begin
            inc(p1.np); p1.l[p1.np][1] := i; p1.l[p1.np][2] := j;
         end;
      end;
      readln;
   end;
   readln(p2.h, p2.w); p2.np := 0;
   for i := 1 to p2.h do begin
      for j := 1 to p2.w do begin
         read(p2.m[i][j]);
         if p2.m[i][j] = 'X' then begin
            inc(p2.np); p2.l[p2.np][1] := i; p2.l[p2.np][2] := j;
         end;
      end;
      readln;
   end;
   if p1.w > p1.h then begin
      tmp.h := p1.w; tmp.w := p1.h;
      for i := 1 to p1.h do
         for j := 1 to p1.w do tmp.m[j][i] := p1.m[i][j];
      tmp.np := p1.np;
      for i := 1 to tmp.np do begin
         tmp.l[i][1] := p1.l[i][2]; tmp.l[i][2] := p1.l[i][1];
      end;
      p1 := tmp;
      tmp.h := p2.w; tmp.w := p2.h;
      for i := 1 to p2.h do
         for j := 1 to p2.w do tmp.m[j][i] := p2.m[i][j];
      tmp.np := p2.np;
      for i := 1 to tmp.np do begin
         tmp.l[i][1] := p2.l[i][2]; tmp.l[i][2] := p2.l[i][1];
      end;
      p2 := tmp;
   end;
   if p1.w > k then Stupid else Clever;
   writeln(ans);
   close(Input);
   close(output);
end.