#include <stdio.h>

#define SIZE 200
#define SQ 30

bool matr[SQ*SIZE][SQ*SIZE];
bool image[SQ][SQ];
int cnt, k;
int mm, mn;
int imm, imn;
int ans;

void ReadAll() {
	int i, j, u, v;
	scanf("%d", &k);
	scanf("%d%d\n", &imm, &imn);
	for (i = 0; i<imm; i++) {
		for (j = 0; j<imn; j++) {
			char ch;
			scanf("%c", &ch);
			image[i][j] = (ch=='X');
		}
		scanf("\n");
	}
	scanf("%d%d\n", &mm, &mn);
	for (i = 0; i<mm; i++) {
		for (j = 0; j<mn; j++) {
			char ch;
			scanf("%c", &ch);
			if (ch=='X')
				for (u = 0; u<k; u++)
					for (v = 0; v<k; v++)
						matr[k*i+u][k*j+v] = true;
		}
		scanf("\n");
	}
}

int main(int argc, char **argv) {
	freopen("poly.in", "r", stdin);
	freopen("poly.out", "w", stdout);
	ReadAll();
	int i, j, u, v;
	for (i = 0; i<mm*k-imm; i++)
		for (j = 0; j<mn*k-imn; j++) {
			bool ok = true;
			for (u = 0; u<imm; u++)
				for (v = 0; v<imn; v++) {
					if (!matr[i+u][j+v] && image[u][v]) {
						ok = false;
						break;
					}
					if (ok)
						break;
				}
			ans += ok;
		}
	printf("%d", ans);
	return 0;
}