program b3;

{$APPTYPE CONSOLE}

uses
  SysUtils;
type
  int = longint;
  real = extended;

var
  k : int;
  n1, m1, n2, m2 : int;
  s1, s2 : array [1..300, 1..300] of boolean;
  s3 : array [1..10000, 1..10000] of boolean;
  c : char;


var
  i, j, x1, y1 : int;
  time : real;
  x, y : int;
  ans : int;
  q : boolean;

begin
  reset(input, 'poly.in');
  rewrite(output, 'poly.out');
  randomize;
  read(k);
  readln(n1, m1);
  time := now;
  for i := 1 to n1 do
  begin
    for j := 1 to m1 do
    begin
      read(c);
      s1[i, j] := c = 'X';
    end;
    readln;
  end;
  readln(n2, m2);
  for i := 1 to n2 do
  begin
    for j := 1 to m2 do
    begin
      read(c);
      s2[i, j] := c = 'X';
    end;
    readln;
  end;

  if (k * n2 > 10000) or (k * m2 > 10000) then
  begin
    write(0);
    halt(0);
  end;

  for i := 0 to n2 - 1 do
    for j := 0 to m2 - 1 do
      for x := 1 to k do
        for y := 1 to k do
        begin
          s3[i * k + x, j * k + y] := s2[i + 1, j + 1];
        end;
  n2 := n2 * k;
  m2 := m2 * k;
  ans := 0;

  for i := 1 to n2 do
    for j := 1 to m2 do
    begin
      if (n2 - i + 1 < n1) or (m2 - j + 1 < m1) then
        continue;
      q := true;
      for x := 1 to n1 do
      begin
        for y := 1 to m1 do
          if s1[x, y] and not s3[i + x - 1, j + y - 1] then
          begin
            q := false;
            break;
          end;
        if not q then break;
      end;
      if q then inc(ans);
      if random(100) <= 3 then
        if (now - time) * 24 * 60 * 60 > 1.5 then
        begin
          write(ans);
          halt(0);
        end;
    end;
  write(ans);
end.

