{$I+,Q+,R+,S+,O-}
var n,i,j,cnt:longint;
    x,y:array [1..21] of int64;
    good,ans:array [1..20,1..20] of boolean;
    best,last:array [1..20,1..20] of longint;
function vect(x1,y1,x2,y2:int64):int64;
begin
  vect:=x1*y2-x2*y1;
end;
function sign(x:int64):int64;
begin
  if x<0 then
    sign:=-1
  else if x=0 then
    sign:=0
  else sign:=1;    
end;
function diff(x1,y1,x2,y2,x3,y3:int64):boolean;
var s1,s2:longint;
begin
  s1:=sign(vect(x1,y1,x2,y2));
  s2:=sign(vect(x1,y1,x3,y3));
  diff:=s1*s2<0;
end;    
function cross(x1,y1,x2,y2,x3,y3,x4,y4:int64):boolean;
begin
  cross:=diff(x2-x1,y2-y1,x3-x1,y3-y1,x4-x1,y4-y1) and diff(x4-x3,y4-y3,x1-x3,y1-y3,x2-x3,y2-y3);
end;
function next(c,p,q:longint):longint;
begin
  next:=c+1;
  if c=q then
    next:=p
  else if c=n then
    next:=1;
end;
function prev(c,p,q:longint):longint;
begin
  prev:=c-1;
  if c=p then
    prev:=q
  else if c=1 then
    prev:=n;
end;
function gets(p,q:longint):int64;
var cur:longint;
    first:boolean;
begin
  result:=0;
  cur:=p;
  first:=true;
  while (cur<>p) or first do
  begin
    first:=false;
    result:=result+vect(x[cur],y[cur],x[next(cur,p,q)],y[next(cur,p,q)]);
    cur:=next(cur,p,q);
  end;
end;
function check(p,q:longint):boolean;
var i:longint;
begin
  check:=false;
  for i:=1 to n do
    if cross(x[p],y[p],x[q],y[q],x[i],y[i],x[i+1],y[i+1]) then
      exit;
  check:=abs(gets(p,q))+abs(gets(q,p))=abs(gets(1,n));
end;
function scal(x1,y1,x2,y2:int64):int64;
begin
  scal:=x1*x2+y1*y2;
end;
function isline(p,q,r:longint):boolean;
begin
  isline:=vect(x[q]-x[p],y[q]-y[p],x[r]-x[p],y[r]-y[p])=0;
end;
function coll(p,q,r:longint):boolean;
begin
  coll:=(vect(x[q]-x[p],y[q]-y[p],x[r]-x[p],y[r]-y[p])=0) and (scal(x[q]-x[p],y[q]-y[p],x[r]-x[p],y[r]-y[p])>0) and
        (scal(x[q]-x[r],y[q]-y[r],x[p]-x[r],y[p]-y[r])>0);
end;
procedure update(var a:longint;b:longint);
begin
  if b<a then
    a:=b;
end;
function rec(p,q:longint):longint;
var cur,tmp:longint;
begin
  assert(good[p,q]);
  if best[p,q]<>1000 then
  begin
    rec:=best[p,q];
    exit;
  end;
  if p=q then
    best[p,q]:=0
  else if p mod n+1=q then
    best[p,q]:=0
  else begin
    cur:=next(p,p,q);
    while cur<>q do
    begin
      if good[p,cur] and good[cur,q] then
      begin
        tmp:=rec(p,cur)+rec(cur,q)+byte(not isline(p,q,cur));
        if tmp<best[p,q] then
        begin
          best[p,q]:=tmp;
          last[p,q]:=cur;
        end;
      end;  
      cur:=next(cur,p,q);
    end;
  end;
  rec:=best[p,q];    
end;
function dist2(p,q:longint):int64;
begin
  dist2:=(x[p]-x[q])*(x[p]-x[q])+(y[p]-y[q])*(y[p]-y[q]);
end;
procedure process(a,b:longint);
var np,i,j,t:longint;
    p:array [1..30] of longint;
    ok:boolean;
begin
  np:=2;
  p[1]:=a;
  p[2]:=b;
  for i:=1 to n do
    if coll(a,i,b) then
    begin
      inc(np);
      p[np]:=i;
    end;
  for i:=1 to np-1 do
    for j:=i+1 to np do
      if dist2(a,p[i])>dist2(a,p[j]) then
      begin
        t:=p[i];
        p[i]:=p[j];
        p[j]:=t;
      end;
  for i:=1 to np-1 do
  begin
    if p[i]=p[i+1] then
      continue;
    ok:=true;  
    for j:=1 to n do
      if (p[i]=j) and (p[i+1]=j mod n+1) or (p[i]=j mod n+1) and (p[i+1]=j) then
      begin
        ok:=false;
        break;
      end;
    if ok then
      ans[p[i],p[i+1]]:=true;
  end;
end;
procedure restore(p,q:longint);
begin
  if (p=q) or (q=p mod n+1) then
    exit;
  restore(p,last[p,q]);
  restore(last[p,q],q);
  process(p,last[p,q]);
  process(last[p,q],q);  
end;
begin
  assign(input,'reform.in');
  reset(input);
  assign(output,'reform.out');
  rewrite(output);
  read(n);
  for i:=1 to n do
    read(x[i],y[i]);
  x[n+1]:=x[1];
  y[n+1]:=y[1];
  fillchar(good,sizeof(good),false);  
  for i:=1 to n-1 do
    for j:=1 to n do
      if i<>j then
        if check(i,j) then
          good[i,j]:=true;
  for i:=1 to n do
    for j:=1 to n do
      best[i,j]:=1000;
  writeln(rec(1,n));
  fillchar(ans,sizeof(ans),false);
  restore(1,n);
  cnt:=0;
  for i:=1 to n-1 do
    for j:=i+1 to n do
      if ans[i,j] then
        inc(cnt);
  writeln(cnt);
  for i:=1 to n-1 do
    for j:=i+1 to n do
      if ans[i,j] then
        writeln(x[i],' ',y[i],' ',x[j],' ',y[j]);
  close(input);
  close(output);
end.

