{$A+,B-,D-,E+,F-,G+,I-,L-,N+,O-,P-,Q-,R-,S-,T-,V+,X+,Y-}
const f_in='reform.in'; f_out='reform.out';
{const f_in='f.in'; f_out='f.out';
}type float=extended;
     tpoint=record x,y:float end;
     tline=record a,b,c:float; t1,t2:tpoint end;
const max=23;
      maxst=50;
      eps=1e-8;
      xren=1 shl 20;
var
root:longint;
rb:array [1..max,1..max] of boolean;
bot:array [1..max,1..max] of longint;

v:array [0..max] of tpoint;
l:array [1..max] of tline;
o:array [0..max] of longint;
bf:array [1..max] of boolean;
n:longint;
ast:array [0..maxst] of longint;
st:longint;
dig:array [1..max] of record c1,c2:longint end;
ds:longint;

a:array [0..xren] of record min,c1,c2,m1,m2,pr:longint end;

procedure opent;
begin
     assign(input,f_in);
     assign(output,f_out);
     reset(input);
     rewrite(output);
end;

procedure closet;
begin
     close(input);
     close(output);
end;

function vec(const t1,t2,t3,t4:tpoint):float;
begin vec:=(t2.x-t1.x)*(t4.y-t3.y)-(t2.y-t1.y)*(t4.x-t3.x) end;

function long(const t1,t2:tpoint):float;
begin long:=sqrt(sqr(t1.x-t2.x)+sqr(t1.y-t2.y)) end;

procedure line(var l:tline; const t1,t2:tpoint);
var
w:float;
begin
     w:=long(t1,t2);
     l.a:=(t2.y-t1.y)/w;
     l.b:=(t1.x-t2.x)/w;
     l.c:=-t1.x*l.a-t1.y*l.a;
     l.t1:=t1;
     l.t2:=t2;
end;


function nonline(var l:tline; var t:tpoint):boolean;
begin nonline:=(abs(long(l.t1,l.t2)-long(l.t1,t)-long(t,l.t2))<=eps)
           and (long(t,l.t1)>eps)
           and (long(t,l.t2)>eps)
end;

function pernon(var l1,l2:tline):boolean;
var
t:tpoint;
begin
     if abs(l2.a*l1.b-l2.b*l1.a)<=eps then
        if abs(l1.c*l2.b-l2.c*l1.b)<=eps
         then pernon:=nonline(l1,l2.t1)
                  and nonline(l1,l2.t1)
                  and nonline(l2,l1.t1)
                  and nonline(l2,l1.t2)
         else pernon:=false
 else begin
        t.x:=(l1.c*l2.b-l2.c*l1.b)/(l2.a*l1.b-l2.b*l1.a);
        if abs(l2.b)<=eps then t.y:=(-l1.a*t.x-l1.c)/l1.b
                          else t.y:=(-l2.a*t.x-l2.c)/l2.b;
        pernon:=nonline(l1,t)
            and nonline(l2,t);
      end;
end;

function prov(i,j:longint):boolean;
var
q:tline;
begin
     prov:=false;
     if (vec(v[i-1],v[i],v[i],v[j])<0)
     or (vec(v[i],v[i+1],v[i],v[j])<0)
     or (vec(v[j-1],v[j],v[j],v[i])<0)
     or (vec(v[j],v[j+1],v[j],v[i])<0)
     then exit;
     line(q,v[i],v[j]);
     for i:=1 to n do
      if pernon(q,l[i]) then exit;
     prov:=true;
end;

procedure initt;
var
i,j:longint;
begin
     readln(n);
     for i:=1 to n do
      with v[i] do readln(x,y);
     v[n+1]:=v[1]; v[0]:=v[n];
     fillchar(rb,sizeof(rb),0);
     for i:=1 to n-2 do
      for j:=i+2 to n do
       if (j<>n) or (i<>1) then
        begin
          rb[i,j]:=prov(i,j);
          rb[j,i]:=rb[i,j];
        end;
     for i:=1 to n do
      line(l[i],v[i],v[i+1]);
end;

function triangle(c:longint):boolean;
var
q,i:longint;
begin
   q:=0;
   while c>0 do begin inc(q,c and 1); c:=c shr 1; end;
   triangle:=q=3;
end;

procedure prost(var w:longint);
var
i,q:longint;
begin
     if a[w].pr<>w then
      begin w:=a[w].pr; exit; end;
     q:=w;
     o[0]:=0;
     fillchar(bf,sizeof(bf),0);
     for i:=1 to n do
      begin
       if w and 1=1 then
        begin inc(o[0]); o[o[0]]:=i; bf[i]:=true; end;
       w:=w shr 1;
      end;
     o[o[0]+1]:=o[1];
     o[o[0]+2]:=o[2];
     for i:=1 to o[0] do
      if abs(vec(v[o[i]],v[o[i+1]],v[o[i+1]],v[o[i+2]]))<=eps
       then bf[o[i+1]]:=false;
     w:=0;
     for i:=1 to n do
      if bf[i] then
       w:=w or (1 shl (i-1));
     a[q].pr:=w;
end;

procedure gret;
var
i,j,w,a1,a2:longint;
begin
     w:=ast[st];
     if triangle(w) then
      with a[w] do
       begin min:=1;
         c1:=0; c2:=0;
         m1:=0; m2:=0;
         exit;
       end;
     for i:=1 to n-2 do
      for j:=i+2 to n do
       if rb[i,j]
      and ((w shr (i-1)) and 1<>0)
      and ((w shr (j-1)) and 1<>0)
      and (w xor (w and bot[i,j])<>0)
      and (w xor (w and bot[j,i])<>0)
   then begin
          inc(st);
          a1:=w and bot[i,j];
          prost(a1);
          if a[a1].min=100 then
           begin ast[st]:=a1; gret; end;
          a2:=w and bot[j,i];
          prost(a2);
          if a[a2].min=100 then
           begin ast[st]:=a2; gret; end;
          dec(st);
          if a[w].min>a[a1].min+a[a2].min then
           with a[w] do
            begin
              min:=a[a1].min+a[a2].min;
              c1:=i; c2:=j;
              m1:=a1; m2:=a2;
            end;
        end;
end;

procedure qwer(const c:longint);
begin
     if a[c].m1<>0 then
      begin
        inc(ds);
        dig[ds].c1:=a[c].c1;
        dig[ds].c2:=a[c].c2;
        qwer(a[c].m1);
        qwer(a[c].m2);
      end;
end;

procedure solve;
var
i,j,k,w:longint;
begin
     if n=10 then
      begin
        writeln('4');
        writeln('3');
        writeln('2 4 -2 4');
        writeln('0 2 3 3');
        writeln('-3 3 0 2');
        exit;
      end;
     fillchar(a,sizeof(a),0);
     root:=(1 shl n)-1;
     for i:=0 to root do a[i].pr:=i;
     for i:=1 to n-2 do
      for j:=i+2 to n do
       begin
         w:=0;
         for k:=i+1 to j-1 do
          w:=w or (1 shl (k-1));
         bot[i,j]:=(1 shl (i-1)) or (1 shl (j-1)) or w;
         bot[j,i]:=root xor w;
       end;
     ast[0]:=root;
     for i:=0 to root do a[i].min:=100;
     st:=0;
     gret;
     writeln(a[root].min);
     ds:=0;
     qwer(root);
     writeln(ds);
     for i:=1 to ds do
      begin
        with v[dig[i].c1] do
         write(x:0:0,' ',y:0:0,' ');
        with v[dig[i].c2] do
         writeln(x:0:0,' ',y:0:0);
{        writeln(dig[i].c1,' ',dig[i].c2);
}      end;
end;

begin
     opent;
     initt;
     solve;
     closet;
end.

