#include <stdio.h>
#include <string.h>

#define m 22
#define mm (1 << m)
#define min(a, b) ((a) < (b) ? (a) : (b))
#define max(a, b) ((a) > (b) ? (a) : (b))

int n, x[m], y[m], is[m][m], p1[m], p2[m], r[mm], pi[mm], pj[mm], pp1[mm], pp2[mm], nu;

__int64 cp( __int64 i, __int64 j, __int64 k )
{
  int x1, y1, x2, y2;

  x1 = x[j] - x[i], y1 = y[j] - y[i];
  x2 = x[k] - x[i], y2 = y[k] - y[i];
  return x1 * y2 - x2 * y1;
}

void o( int p )
{
  if (pp1[p] == -1 && pp2[p] == -1)
    ;
  else if (pp1[p] == -1 && pp2[p] == -2)
    ;
  else if (pp1[p] == -1)
    o(pp2[p]);
  else
  {
    o(pp1[p]);
    o(pp2[p]);
    p1[nu] = pi[p], p2[nu++] = pj[p];
  }
}

int si( __int64 a )
{
  return a > 0 ? 1 : (a < 0 ? -1 : 0);
}

int inter( int p1, int p2, int p3, int p4 )
{
  __int64 a1, b1, c1, a2, b2, c2;

  a1 = y[p1] - y[p2], b1 = x[p2] - x[p1], c1 = -(a1 * x[p1] + b1 * y[p1]);
  a2 = y[p3] - y[p4], b2 = x[p4] - x[p3], c2 = -(a2 * x[p3] + b2 * y[p3]);
  if (a1 * b2 == a2 * b1)
    if (a1 * x[p3] + b1 * y[p3] + c1 == 0)
      return max(min(x[p1], x[p2]), min(x[p3], x[p4])) <= min(max(x[p1], x[p2]), max(x[p3], x[p4])) &&
             max(min(y[p1], y[p2]), min(y[p3], y[p4])) <= min(max(y[p1], y[p2]), max(y[p3], y[p4]));
    else
      return 0;
  else
    return si(cp(p1, p2, p3)) * si(cp(p1, p2, p4)) <= 0 &&
           si(cp(p3, p4, p1)) * si(cp(p3, p4, p2)) <= 0;
}

int inside( int i, int j )
{
  int k, s;
  __int64 a, b, c;

  for (s = 0, k = 0; k < n; k++)
    if ((y[k] * 2 < y[i] + y[j] && y[i] + y[j] <= y[k + 1] * 2))
    {
      a = y[k + 1] - y[k], b = x[k] - x[k + 1], c = -(a * x[k] + b * y[k]);
      s += (-b * (y[i] + y[j]) - 2 * c) < (x[i] + x[j]) * a;
    }
    else if ((y[k + 1] * 2 < y[i] + y[j] && y[i] + y[j] <= y[k] * 2))
    {
      a = y[k + 1] - y[k], b = x[k] - x[k + 1], c = -(a * x[k] + b * y[k]);
      s += (-b * (y[i] + y[j]) - 2 * c) > (x[i] + x[j]) * a;
    }
  return s & 1;
}

int main( void )
{
  int i, j, k, p;

  freopen("reform.in", "rt", stdin);
  freopen("reform.out", "wt", stdout);
  scanf("%d", &n);
  for (i = 0; i < n; i++)
    scanf("%d%d", &x[i], &y[i]);
  x[n] = x[0], y[n] = y[0];
  for (i = 0; i < n; i++)
    for (j = 0; j < n; j++)
      if (i == j || i == (j + 1) % n || j == (i + 1) % n)
        is[i][j] = 0;
      else if (inside(i, j))
      {
        for (k = 0; k < n; k++)
          if (k != i && (k + 1) % n != j && k != j && (k + 1) % n != i && inter(i, j, k, k + 1))
            break;
        if (k == n)
        {
          for (k = 0; k < n; k++)
            if (k != i && k != j && cp(i, j, k) == 0 &&
                min(x[i], x[j]) <= x[k] && x[k] <= max(x[i], x[j]) &&
                min(y[i], y[j]) <= y[k] && y[k] <= max(y[i], y[j]))
              break;
          is[i][j] = k == n;
        }
        else
          is[i][j] = 0;
      }
  for (p = 0; p < (1 << n); p++)
  {
    int i, j, a[m], k, p1, p2, t, t1, t2;

    for (k = 0, i = 0; i < n; i++)
      if ((p >> i) & 1)
        a[k++] = i;
    a[k] = a[0], a[k + 1] = a[1];
    if (k < 3)
    {
      pp1[p] = pp2[p] = -1, r[p] = 0;
      continue;
    }
    if (k == 3)
    {
      pp1[p] = -1, pp2[p] = -2, r[p] = 1;
      continue;
    }
    for (p1 = p, i = 0; i < k; i++)
      if (!cp(a[i], a[i + 1], a[i + 2]))
        p1 &= ~(1 << a[i + 1]);
    if (p != p1)
    {
      r[p] = r[p1];
      pp1[p] = -1, pp2[p] = p1;
      continue;
    }
    r[p] = -1;
    for (i = 0; i + 2 < k; i++)
      for (p1 = (1 << a[i]) | (1 << a[i + 1]) | (1 << a[i + 2]), p2 = p & ~(1 << a[i + 1]), j = i + 2; j < k; j++)
      {
        if (is[a[i]][a[j]])
        {
          t1 = r[p1], t2 = r[p2];
          if (t1 == -1 || t2 == -1)
            continue;
          t = t1 + t2;
          if (r[p] == -1 || r[p] > t)
            r[p] = t, pi[p] = a[i], pj[p] = a[j], pp1[p] = p1, pp2[p] = p2;
        }
        p1 |= 1 << a[j + 1], p2 &= ~(1 << a[j]);
      }
  }
  printf("%d\n", r[(1 << n) - 1]);
  nu = 0;
  o((1 << n) - 1);
  printf("%d\n", nu);
  for (i = 0; i < nu; i++)
    printf("%d %d %d %d\n", x[p1[i]], y[p1[i]], x[p2[i]], y[p2[i]]);
  return 0;
}
