//{$O-,Q+,R+,S+,I+}
{$O+,Q-,R-,S-,I-,D-,L-}
program reform;

{$APPTYPE CONSOLE}

uses
  Math;

const
	MaxN = 20;
  pNum = 1 shl MaxN;

var
  n, i, j, k, ans, v1, v2: Integer;
  x, y: array [0..MaxN+1] of Integer;
  a: array [1..MaxN, 1..MaxN] of Boolean;
  f, d1, d2: array [1..pNum] of Integer;

function VMul(ax, ay, bx, by: Integer): Integer;
begin
  Result := ax*by - ay*bx;
  Result := ord(Result>0) - ord(Result<0);
end;

function cross(x1, y1, x2, y2, u1, v1, u2, v2: Integer): Boolean;
var
  vm1, vm2, vm3, vm4: Integer;
begin
  vm1 := VMul(x2-x1, y2-y1, u1-x1, v1-y1);
  vm2 := VMul(x2-x1, y2-y1, u2-x1, v2-y1);
  vm3 := VMul(u2-u1, v2-v1, x1-u1, y1-v1);
  vm4 := VMul(u2-u1, v2-v1, x2-u1, y2-v1);
  if (x1 = x2) and (x1 = u1) and (u1 = u2) then
    Result := (min(y1, y2) < max(v1, v2)) and (min(v1, v2) < max(y1, y2))
  else
  if (vm1 = 0) and (vm2 = 0) then
    Result := (min(x1, x2) < max(u1, u2)) and (min(u1, u2) < max(x1, x2))
  else
    Result := (min(x1, x2) < max(u1, u2)) and (min(u1, u2) < max(x1, x2)) and
              (min(y1, y2) < max(v1, v2)) and (min(v1, v2) < max(y1, y2)) and
              (vm1*vm2 = -1) and (vm3*vm4 = -1);
end;

function g(k: Integer): Integer;
var
  i, j, i0, j0, m, t, m1, m2: Integer;
  s: array [1..MaxN] of Integer;
function next(i: Integer): Integer;
begin
  if i = m then Result := s[1]
  else Result := s[i+1]
end;
function prev(i: Integer): Integer;
begin
  if i = 1 then Result := s[m]
  else Result := s[i-1];
end;
begin
  if f[k] = -1 then
    begin
      //WriteLn('g(',k,')');
      m := 0;
      for i := 1 to n do
        if k and (1 shl (i-1)) > 0 then
          begin
            inc(m);
            s[m] := i;
            //Write(i, ' ');
          end;
      //WriteLn;
      if m = 3 then f[k] := 1 else
      for i0 := 1 to m-2 do
        for j0 := i0+2 to m-ord(i0=1) do
          if a[s[i0],s[j0]] then
            begin
              i := s[i0]; j := s[j0];
              m1 := k and (1 shl j - 1 shl i + 1 shl (i-1));
              m2 := k and not (1 shl (j-1) - 1 shl i);
              if VMul(x[i]-x[j], y[i]-y[j], x[i]-x[next(i0)], y[i]-y[next(i0)]) = 0
                then m1 := m1 and not (1 shl (i-1));
              if VMul(x[i]-x[j], y[i]-y[j], x[j]-x[prev(j0)], y[j]-y[prev(j0)]) = 0
                then m1 := m1 and not (1 shl (j-1));
              if VMul(x[i]-x[j], y[i]-y[j], x[i]-x[prev(i0)], y[i]-y[prev(i0)]) = 0
                then m2 := m2 and not (1 shl (i-1));
              if VMul(x[i]-x[j], y[i]-y[j], x[j]-x[next(j0)], y[j]-y[next(j0)]) = 0
                then m2 := m2 and not (1 shl (j-1));
              t := g(m1) + g(m2);
              if (f[k] = -1) or (f[k] > t) then
                begin
                  f[k] := t;
                  d1[k] := i0;
                  d2[k] := j0;
                end;
            end;
    end;
  Result := f[k];
end;

procedure print(k: Integer);
var
  m, i, j, i0, j0, m1, m2: Integer;
  s: array [1..MaxN] of Integer;
function next(i: Integer): Integer;
begin
  if i = m then Result := s[1]
  else Result := s[i+1]
end;
function prev(i: Integer): Integer;
begin
  if i = 1 then Result := s[m]
  else Result := s[i-1];
end;
begin
  m := 0;
  for i := 1 to n do
    if k and (1 shl (i-1)) > 0 then
      begin
        inc(m);
        s[m] := i;
      end;
  if m > 3 then
    begin
      i0 := d1[k];
      j0 := d2[k];
      i := s[i0]; j := s[j0];
      WriteLn(x[i], ' ', y[i], ' ', x[j], ' ', y[j]);
      m1 := k and (1 shl j - 1 shl i + 1 shl (i-1));
      m2 := k and not (1 shl (j-1) - 1 shl i);
      if VMul(x[i]-x[j], y[i]-y[j], x[i]-x[next(i0)], y[i]-y[next(i0)]) = 0
        then m1 := m1 and not (1 shl (i-1));
      if VMul(x[i]-x[j], y[i]-y[j], x[j]-x[prev(j0)], y[j]-y[prev(j0)]) = 0
        then m1 := m1 and not (1 shl (j-1));
      if VMul(x[i]-x[j], y[i]-y[j], x[i]-x[prev(i0)], y[i]-y[prev(i0)]) = 0
        then m2 := m2 and not (1 shl (i-1));
      if VMul(x[i]-x[j], y[i]-y[j], x[j]-x[next(j0)], y[j]-y[next(j0)]) = 0
        then m2 := m2 and not (1 shl (j-1));
      print(m1);
      print(m2);
    end;
end;

begin
	Reset(input, 'reform.in');
	Rewrite(output, 'reform.out');

  Read(n);
  for i := 1 to n do
    Read(x[i], y[i]);
  x[0] := x[n];
  y[0] := y[n];
  x[n+1] := x[1];
  y[n+1] := y[1];

  fillchar(a, sizeof(a), 0);
  for i := 1 to n-2 do
    for j := i+2 to n do
      begin
         a[i,j] := true;
         for k := 1 to n do
           a[i,j] := a[i,j] and not cross(x[i], y[i], x[j], y[j], x[k], y[k], x[k+1], y[k+1]);
         v1 := VMul(x[i+1]-x[i], y[i+1]-y[i], x[j]-x[i], y[j]-y[i]);
         v2 := VMul(x[j]-x[i], y[j]-y[i], x[i-1]-x[i], y[i-1]-y[i]);
         a[i,j] := a[i,j] and (((v1 = v2) and (v1 <> 0)) or ((v1 <> v2) and ((v1 = 0) or (v2 = 0))));
         a[j,i] := a[i,j];
      end;

  fillchar(f, sizeof(f), -1);
  ans := g(1 shl n - 1);
  WriteLn(ans);
  WriteLn(ans-1);
  print(1 shl n - 1);

	Close(input);
	Close(output);
end.