program reform;

{$APPTYPE CONSOLE}

uses
  SysUtils;

var
  Fin, Fout : text;
  N, I, NL  : byte;
  Poly      : array[1..21, 1..2] of integer;
  Lines     : array[1..100, 1..2, 1..2] of integer;

procedure AddLine(Xs, Ys, Xf, Yf : integer);
begin
  Nl:=Nl+1;
  Lines[Nl, 1, 1]:=Xs;
  Lines[Nl, 1, 2]:=Ys;
  Lines[Nl, 2, 1]:=Xf;
  Lines[Nl, 2, 2]:=Yf;
end;

procedure DelVert(S : byte);
var
  I : Byte;
begin
  For I:=S to N-1 do
  begin
    Poly[I, 1]:=Poly[I+1, 1];
    Poly[I, 2]:=Poly[I+1, 2];
  end;
  N:=N-1;
end;

function GetLine : boolean;
var
  I, J, K : byte;
  flag : boolean;
begin
  flag:=false;
  For I:=1 to N do
  For J:=1 To N do
  For K:=1 To N Do
  if (I<>J) and (J<>K) and (I<>K) then
    if (Poly[I, 1]-Poly[J, 1])*(Poly[J, 2]-Poly[K, 2])=(Poly[I, 2]-Poly[J, 2])*(Poly[J, 1]-Poly[K, 1]) then
    begin
      if ((Poly[I, 1]<Poly[J, 1]) and (Poly[J, 1]<Poly[K, 1])) or
         ((Poly[I, 1]>Poly[J, 1]) and (Poly[J, 1]>Poly[K, 1])) then
      begin
        if (abs(I-J)=1) and (abs(J-K)=1) then
        begin
          DelVert(J);
          continue;
        end;

        AddLine(Poly[I, 1], Poly[I, 2], Poly[K, 1], Poly[K, 2]);
        DelVert(J);
        continue;
        flag:=true;
      end;

      if ((Poly[J, 1]<Poly[I, 1]) and (Poly[I, 1]<Poly[K, 1])) or
         ((Poly[J, 1]>Poly[I, 1]) and (Poly[I, 1]>Poly[K, 1])) then
      begin
        if (abs(I-J)=1) and (abs(I-K)=1) then
        begin
          DelVert(I);
          continue;
        end;

        AddLine(Poly[J, 1], Poly[J, 2], Poly[K, 1], Poly[K, 2]);
        DelVert(I);
        continue;
        flag:=true;
      end;

      if ((Poly[I, 1]<Poly[K, 1]) and (Poly[K, 1]<Poly[J, 1])) or
         ((Poly[I, 1]>Poly[K, 1]) and (Poly[K, 1]>Poly[j, 1])) then
      begin
        if (abs(I-K)=1) and (abs(J-K)=1) then
        begin
          DelVert(K);
          continue;
        end;
        AddLine(Poly[I, 1], Poly[I, 2], Poly[J, 1], Poly[J, 2]);
        DelVert(K);
        continue;
        flag:=true;
      end;
    end;
  GetLine:=flag;
end;

begin
  Assign(Fin, 'reform.in');
  Assign(Fout, 'reform.out');
  Reset(Fin);
  Rewrite(Fout);
  Readln(Fin, N);
  For I:=1 to N do
    Readln(Fin, Poly[I, 1], Poly[I, 2]);

  Nl:=0;
  While GetLine do begin end;

  While N>3 do
  begin
    AddLine(Poly[1, 1], Poly[1, 2], Poly[3, 1], Poly[3, 2]);
    DelVert(2);
  end;

  Writeln(Fout, Nl+1);
  Writeln(Fout, Nl);
  For I:=1 to Nl do
    Writeln(Fout, Lines[I, 1, 1], ' ', Lines[I, 1, 2], ' ', Lines[I, 2, 1], ' ', Lines[I, 2, 2]);

  Close(Fin);
  Close(Fout);
end.
 