{$MINSTACKSIZE $00004000}
{$MAXSTACKSIZE $10100000}
{$APPTYPE CONSOLE}
{$O+,Q-,R-,S-}
type integer = longint;
const eps = 1e-9;
var n : integer;
	px, py : array[1..22] of extended;

procedure Load;
var i : integer;
begin
	read(n);
	for i := 1 to n do begin
		read(px[i], py[i]);
	end;
	px[n + 1] := px[1];
	py[n + 1] := py[1];
	px[n + 2] := px[2];
	py[n + 2] := py[2];
end;

var candia : array[1..20, 1..20] of integer;

procedure MakeLine(x1, y1, x2, y2 : extended; var a, b, c : extended);
begin
	a := y2 - y1;
	b := x1 - x2;
	c := - a * x1 - b * y1;
end;

function GetT(x1, y1, x2, y2, x3, y3 : extended) : extended;
var dx, dy, t : extended;
begin
	dx := x2 - x1;
	dy := y2 - y1;
	if abs(dx) < eps then begin
		if abs(dy) < eps then t := 2000000000
		else t := (y3 - y1) / dy;
	end
	else begin
		t := (x3 - x1) / dx;
	end;
	GetT := t;
end;

function InterLine(a1, b1, c1, a2, b2, c2 : extended; var xx, yy : extended) : boolean;
var d1, d2, d3 : extended;
begin
	d1 := a1 * b2 - b1 * a2;
	if abs(d1) < eps then begin
		InterLine := false;
		exit;
	end;
	d2 := (-c1) * b2 - b1 * (-c2);
	d3 := a1 * (-c2) - (-c1) * a2;
	xx := d2 / d1;
	yy := d3 / d1;
	InterLine := true;
end;

function InterOtr(x11, y11, x12, y12, x21, y21, x22, y22 : extended; var ix, iy : extended) : boolean;
var t, rx, ry, a1, b1, c1, a2, b2, c2 : extended;
begin
	MakeLine(x11, y11, x12, y12, a1, b1, c1);
	MakeLine(x21, y21, x22, y22, a2, b2, c2);
	if not InterLine(a1, b1, c1, a2, b2, c2, rx, ry) then begin
		if abs(a1 * x21 + b1 * y21 + c1 ) > eps then begin
			InterOtr := false;
			exit;
		end;
		if abs(a1 * x22 + b1 * y22 + c1 ) > eps then begin
			InterOtr := false;
			exit;
		end;
		t := GetT(x11, y11, x12, y12, x21, y21);
		if (t > -eps) and (t - 1 < eps) then begin
			ix := x21;
			iy := y21;
			InterOtr := true;
			exit;
		end;
		t := GetT(x11, y11, x12, y12, x22, y22);
		if (t > -eps) and (t - 1 < eps) then begin
			ix := x22;
			iy := y22;
			InterOtr := true;
			exit;
		end;
		InterOtr := false;
		exit;
	end;
	t := GetT(x11, y11, x12, y12, rx, ry);
	if (t < -eps) or (t - 1 > eps) then begin
		InterOtr := false;
		exit;
	end;
	t := GetT(x21, y21, x22, y22, rx, ry);
	if (t < -eps) or (t - 1 > eps) then begin
		InterOtr := false;
		exit;
	end;
	ix := rx;
	iy := ry;
	InterOtr := true;
end;

function Inside(x, y : extended) : boolean;
var i, cnt : integer;
	rx, ry : extended;
begin
	cnt := 0;
	for i := 1 to n do begin
		if abs(py[i + 1] - py[i]) < eps then continue;
		if InterOtr(x, y, x + 100000, y, px[i], py[i], px[i + 1], py[i + 1], rx, ry) then begin
			if (abs(rx - px[i]) < eps) and (abs(ry - py[i]) < eps) then begin
				if py[i] - py[i + 1] > eps then inc(cnt);
			end
			else if (abs(rx - px[i + 1]) < eps) and (abs(ry - py[i + 1]) < eps) then begin
				if py[i + 1] - py[i] > eps then inc(cnt);
			end
			else inc(cnt);
		end;
	end;
	if cnt mod 2 = 1 then Inside := true
	else Inside := false;
end;

var can : array [1..21, 1..21, 1..21] of integer;
	ans : array [1..30, 1..2] of integer;
	nans : integer;
	p3, p4, pth, p1, p2, res : array [1..1048576] of integer;
	
function ZeroB(a, i, j: integer) : integer;
begin
	ZeroB := a and not ((1 shl (j + 1) - 1 - (1 shl i - 1)));
end;

function Count(a : integer) : integer;
var i, j, k, nm, cr, b, c : integer;
	f : byte;
begin
	if res[a] <> -1 then begin
		Count := res[a];
		exit;
	end;
	nm := 0;
	for i := 1 to n do begin
		if a and (1 shl (i - 1)) <> 0 then inc(nm);
	end;
	if nm = 3 then begin
		res[a] := 1;
		Count := 1;
		exit;
	end;
	res[a] := 1000000;
	{if we can throw out smth}
	for i := 1 to n do begin
		if a and (1 shl (i - 1)) = 0 then continue;
		j := i + 1;
		if j = n + 1 then j := 1;
		while a and (1 shl (j - 1)) = 0 do begin
			inc(j);
			if j = n + 1 then j := 1;
		end;
		k := j + 1;
		if k = n + 1 then k := 1;
		while a and (1 shl (k - 1)) = 0 do begin
			inc(k);
			if k = n + 1 then k := 1;
		end;
		if can[i, j, k] = 1 then begin
			cr := Count(a - (1 shl (j - 1)));
            if res[a] > cr then begin
            	res[a] := cr;
				pth[a] := 1;
				p1[a] := j;
            end;
		end;
	end;
	{if we can make dia}
	for i := 1 to n do begin
		if a and (1 shl (i - 1)) = 0 then continue;
		f := 0;
		for j := i + 1 to n do begin
			if a and (1 shl (j - 1)) = 0 then continue;
			if f = 0 then begin
				f := 1;
				continue;
			end;
			if candia[i, j] = 0 then continue;
			b := ZeroB(a, i, j - 2);
			c := a - b + 1 shl (i - 1) + 1 shl (j - 1);
			cr := Count(b) +
            		Count(c);
			if res[a] > cr then begin
				res[a] := cr;
				pth[a] := 2;
				p1[a] := b;
				p2[a] := c;
				p3[a] := i;
				p4[a] := j;
			end;
		end;
	end;
	Count := res[a];
end;

procedure Rans(a : integer);
begin
	if res[a] = 1 then begin
		exit;
	end;
	if pth[a] = 1 then begin
		Rans(a - 1 shl (p1[a] - 1));
		exit;
	end;
	inc(nans);
	ans[nans, 1] := p3[a];
	ans[nans, 2] := p4[a];
	Rans(p1[a]);
	Rans(p2[a]);
end;

function Gint(a : extended) : integer;
begin
	Gint := round(a);
end;

procedure Solve;
var sgn, i, j, k, f, l : integer;
	vct, v1x, v1y, v2x, v2y, a1, b1, c1, ix, iy : extended;
begin
	{check if polygon is convex}
	v1x := px[2] - px[1];
	v1y := py[2] - py[1];
	v2x := px[3] - px[2];
	v2y := py[3] - py[2];
	vct := v1x * v2y - v1y * v2x;
	if vct < eps then sgn := -1
	else sgn := 1;
	f := 1;
	for i := 1 to n do begin
		v1x := px[i + 1] - px[i];
		v1y := py[i + 1] - py[i];
		v2x := px[i + 2] - px[i + 1];
		v2y := py[i + 2] - py[i + 1];
		vct := v1x * v2y - v1y * v2x;
		if vct < eps then begin
			if sgn = 1 then begin
				f := 0;
				break;
			end;
		end
		else begin
			if sgn = -1 then begin
				f := 0;
				break;
			end;
		end;
	end;
	if f = 1 then begin
		{polygon is convex}
		writeln(n - 2);
		writeln(n - 3);
		for i := 3 to n - 1 do begin
			writeln(Gint(px[1]), ' ', Gint(py[1]), ' ', Gint(px[i]), ' ', Gint(py[i]));
		end;
		exit;
	end;
	{end of this fucking check}
	fillchar(candia, sizeof(candia), 0);
	for i := 1 to n do begin
		for j := i + 2 to n do begin
        	if (i = 1) and (j = n) then continue;
			f := 1;
			for k := 1 to n do begin
				if not InterOtr(px[k], py[k], px[k + 1], py[k + 1], px[i], py[i], px[j], py[j], ix, iy) then continue;
				if ( abs(ix - px[i]) < eps) and (abs(iy - py[i]) < eps) then continue;
				if ( abs(ix - px[j]) < eps) and (abs(iy - py[j]) < eps) then continue;
				f := 0;
				break;
			end;
			if f = 1 then begin
				ix := (px[i] + px[j]) / 2;
				iy := (py[i] + py[j]) / 2;
				if Inside(ix, iy) then begin
					candia[i, j] := 1;
					candia[j, i] := 1;
				end;
			end;
		end;
	end;
	{we know if we can go diagonal}
	{count if from i j k we can go out j}
	fillchar(can, sizeof(can), 0);
	for i := 1 to n do begin
		j := i + 1;
		if j = n + 1 then  j := 1;
		for k := 1 to n do begin
			if (k = i) or (k = j) then continue;
			MakeLine(px[i], py[i], px[j], py[j], a1, b1, c1);
			if abs(a1 * px[k] + b1 * py[k] + c1) < eps then begin
				if candia[j, k] = 1 then begin
					can[i, j, k] := 1;
				end;
			end;
		end;
	end;
	for i := 1 to n do begin
		for k := 1 to n do begin
			j := k - 1;
			if j = 0 then j := n;
            if (i = j) or (k = i) or (k = j) then continue;
			MakeLine(px[i], py[i], px[j], py[j], a1, b1, c1);
			if abs(a1 * px[k] + b1 * py[k] + c1) < eps then begin
				if candia[i, j] = 1 then begin
					can[i, j, k] := 1;
				end;
			end;
		end;
	end;
    {fill if we can get out 2 vertices}
    for i := 1 to n do begin
    	j := i + 1;
        if j = n + 1 then j := 1;
		MakeLine(px[i], py[i], px[j], py[j], a1, b1, c1);
        for k := 1 to n do begin
        	l := k + 1;
            if l = n + 1 then l := 1;
            if (i = k) or (i = l) or (j = k) or (j = l) then continue;
            if abs(a1 * px[k] + b1 * py[k] + c1) < eps then begin
				if abs(a1 * px[l] + b1 * py[l] + c1) < eps then begin
					if candia[j, k] = 1 then begin
                    	can[i, j, l] := 1;
                        can[i, k, l] := 1;
                    end;
	            end;
            end;
        end;
    end;
	{YEAHHHHHH!}
	fillchar(res, sizeof(res), $FF);
	Count(1 shl n - 1);
	nans := 0;
	Rans(1 shl n - 1);
	writeln(res[1 shl n - 1]);
	writeln(nans);
	for i := 1 to nans do begin
		writeln(Gint(px[ans[i, 1]]), ' ', Gint(py[ans[i, 1]]), ' ',Gint(px[ans[i, 2]]), ' ', Gint(py[ans[i, 2]]));
	end;
end;

begin
	assign(input, 'reform.in');
	assign(output, 'reform.out');
	reset(input);
	rewrite(output);
	Load;
	Solve;
	close(input);
	close(output);
end.