{$A8,B-,C+,D-,E-,F-,G+,H+,I-,J-,K-,L-,M-,N+,O+,P+,Q-,R-,S-,T-,U-,V+,W-,X+,Y+,Z1}
//{$A8,B-,C+,D+,E-,F-,G+,H+,I+,J-,K-,L+,M-,N+,O-,P+,Q+,R+,S+,T-,U-,V+,W-,X+,Y+,Z1}
program Problem6;

{$APPTYPE CONSOLE}

uses
  SysUtils;
type
  int=longint;
  real=extended;
  bool=boolean;
  TPoint=record
    x,y:real;
    end;
const
  in_f='reform.in';
  out_f='reform.out';
  maxN=20+5;
  eps=1e-9;
var
  N:int;
  p:array[0..2*maxN] of TPoint;
  g,u,w:array[1..maxN,1..maxN] of bool;
  ans,link:array[1..2*maxN,1..2*maxN] of int;
  r:array[1..2*maxN] of int;
  find1,find2:array[1..maxN,1..maxN] of int;
  temp:array[1..maxN] of int;
  sz:int;

function More(const a,b:real):bool;
begin
 More:=a-B>eps;
end;

function MoreEq(const a,b:real):bool;
begin
 MoreEq:=a-B>-eps;
end;

function Eq(const a,b:real):bool;
begin
 Eq:=Abs(a-B)<=eps;
end;

function Vect(const a,b:TPoint):real;
begin
 Vect:=a.x*b.y-a.y*b.x;
end;

function Scal(const a,b:TPoint):real;
begin
 Scal:=a.x*b.x+a.y*b.y;
end;

Function Make(a,b:TPoint):TPoint;
begin
 REsult.x:=b.x-a.x;
 REsult.y:=b.y-a.y;
end;

function Peres(const a,b,c,d: Tpoint):bool;
begin
 Peres:=MoreEq(Vect(Make(a,c),Make(a,b))*Vect(Make(a,b),Make(a,d)),0)and
        More(Vect(Make(d,a),Make(d,c))*Vect(Make(d,c),Make(d,b)),0);
end;

function Peres2(const a,b,c,d: Tpoint):bool;
begin
 Peres2:=More(Vect(Make(a,c),Make(a,b))*Vect(Make(a,b),Make(a,d)),0)and
        More(Vect(Make(d,a),Make(d,c))*Vect(Make(d,c),Make(d,b)),0);
end;

function Good(nn:int;const v:TPoint):bool;
 begin
 If More(Vect(Make(p[nn-1],p[nn]),Make(p[nn],p[nn+1])),0) then
    good:=More(Vect(Make(p[nn],p[nn-1]),v)*Vect(Make(p[nn],p[nn-1]),Make(p[nn],p[nn+1])),0)
         and More(Vect(Make(p[nn],p[nn+1]),v)*Vect(Make(p[nn],p[nn+1]),Make(p[nn],p[nn-1])),0) 
 else
    good:= not (MoreEq(Vect(Make(p[nn],p[nn-1]),v)*Vect(Make(p[nn],p[nn-1]),Make(p[nn],p[nn+1])),0)
         and MoreEq(Vect(Make(p[nn],p[nn+1]),v)*Vect(Make(p[nn],p[nn+1]),Make(p[nn],p[nn-1])),0))
end;

function Good2(nn:int;const v:TPoint):bool;
 begin
 If More(Vect(Make(p[nn-1],p[nn]),Make(p[nn],p[nn+1])),0) then
    good2:=MoreEq(Vect(Make(p[nn],p[nn-1]),v)*Vect(Make(p[nn],p[nn-1]),Make(p[nn],p[nn+1])),0)
         and MoreEq(Vect(Make(p[nn],p[nn+1]),v)*Vect(Make(p[nn],p[nn+1]),Make(p[nn],p[nn-1])),0)
 else
    good2:= not (More(Vect(Make(p[nn],p[nn-1]),v)*Vect(Make(p[nn],p[nn-1]),Make(p[nn],p[nn+1])),0)
         and More(Vect(Make(p[nn],p[nn+1]),v)*Vect(Make(p[nn],p[nn+1]),Make(p[nn],p[nn-1])),0))
end;

procedure Write2(i,j:int);
begin
 if not w[i,j] and g[i,j] then
   begin
     Write(p[i].x:0:0,' ',p[i].y:0:0,' ');
     Write(p[j].x:0:0,' ',p[j].y:0:0);
     Writeln;
     w[i,j]:=true;
     w[j,i]:=true;
   end;
end;

procedure Write1(i,j:int);
begin
 WRite2(find1[i,j],find2[i,j]);
end;

procedure WriteAns(i,j:int);
begin
 Write1(r[i],r[j]);
 if link[i,j]<>0 then
   begin
     WriteAns(i,link[i,j]);
     WriteAns(link[i,j],j);
   end;  
end;

procedure Run;
 var
  i,j,k,l,mini,i1,i2:int;
  ok:bool;
 begin
   Read(n);
   for  i := 1 to N do
     Read(p[i].x,p[i].y);
   for  i:= N+1 to 2*N do
     p[i]:=p[i-n];
   p[0]:=p[n];
   fillchar(g,sizeof(g),0);  
   fillchar(u,sizeof(u),0);
   for I := 1 to N do
     u[i,i]:=true;
   for i := 1 to N Do
     for j := 1 to  N do
       if abs(i-j)>1 then
         begin
           ok:=true;
           for k := 1 to N do
             if Peres(p[i],p[j],p[k],p[k+1]) then
               ok:=false;
           u[i,j]:=true;    
           for k := 1 to N do
             if Peres2(p[i],p[j],p[k],p[k+1]) and not Eq(Vect(Make(p[i],p[j]),Make(p[k],p[k+1])),0) then
               u[i,j]:=false;
           if not (Good2(i,Make(p[i],p[j])) and
              Good2(j,Make(p[j],p[i]))) then
                u[i,j]:=false;
           if ok then
             if Good(i,Make(p[i],p[j])) and
                Good(j,Make(p[j],p[i])) then
               begin
                 g[i,j]:=true;
               end;
         end;
   for  i:= 1 to N do
     r[i]:=i;
   for  i:= N+1 to 2*N do
     r[i]:=r[i-n];
   fillchar(link,sizeof(link),0);
   fillchar(ans,sizeof(ans),-1);
   for  i:=  1 to 2*n-1 do
     ans[i,i+1]:=0;
   for L := 2 to N do
     begin
       for i := 1 to 2*n-L do
         begin
           j:=i+L;
           if u[r[i],r[j]] then
             begin
               for k:= i+1 to j-1 do
                 if (ans[i,k]<>-1) and (ans[k,j]<>-1)
                   and ((ans[i,k] + ans[k,j]+ord(not Eq(Vect(Make(p[r[i]],p[r[j]]),Make(p[r[i]],p[r[k]])),0))<ans[i,j]) or (ans[i,j]=-1))
                     then
                       begin
                         ans[i,j]:=ans[i,k] + ans[k,j]+ord(not Eq(Vect(Make(p[r[i]],p[r[j]]),Make(p[r[i]],p[r[k]])),0));
                         link[i,j]:=k;
                       end;
             end;
         end;
     end;
   mini:=1;
   for i := 1 to N Do
     if (ans[i,i+N]<>-1) and ((ans[mini,mini+N]=-1) or (ans[i,i+N]<ans[mini,mini+N])) then
       mini:=i;
   Writeln(ans[mini,mini+N]);
   Writeln(ans[mini,mini+N]-1);
   fillchar(w,sizeof(w),0);

   for i := 1 to N Do
     for j := 1 to N Do
//       if i<>j then
         begin
           find1[i,j]:=i;
           find2[i,j]:=j;
           sz:=0;
           for k := 1 to N Do
             if Eq(vect(Make(p[i],p[j]),Make(p[i],p[k])),0) and
               Not More(Scal(Make(p[k],p[i]),Make(p[k],p[j])),0) then
               begin
                 inc(sz);
                 temp[sz]:=k;
               end;
{           if sz<2 then
             write('111');
}           for i1:= 1 to sz do
             for i2 := 1 to sz do
               if g[temp[i1],temp[i2]] then
                begin
                  find1[i,j]:=temp[i1];
                  find2[i,j]:=temp[i2];
                end;

         end;

   WriteAns(mini,mini+N);
 end;

procedure OpenFiles;
begin
  REset(input,in_f);
  REwrite(output,out_f);
end;
procedure CloseFiles;
begin
  Close(input);
  Close(output);
end;

begin
OpenFiles;
Run;
CloseFiles;
end.
