#include <memory.h>
#include <stdio.h>
#include <stdlib.h>

int n;
int x[30],y[30];
bool poss[30][30];

inline int turn(int a1,int a2,int a3) {
	return (x[a2]-x[a1])*(y[a3]-y[a1])-(x[a3]-x[a1])*(y[a2]-y[a1]);
}

inline int diff(int a1,int a2) {
	return abs(x[a2]-x[a1])+abs(y[a2]-y[a1]);
}

int a[1100000];
int f[1100000];
int ff[1100000];
int diag[1100000][2];
bool bb[1100000];

int doit(int prf) {
	if (a[prf]>0)
		return a[prf];
	int pn=0,i,j;
	int ref[22];
	for(i=0;i<n;i++)
		if ((prf>>i)&1)
			ref[pn++]=i;
	ref[pn]=ref[0];
	ref[pn+1]=ref[1];
	for(i=0;i<pn;i++)
		if (turn(ref[i],ref[i+1],ref[i+2])==0) {
			bb[prf]=false;
			f[prf]=prf^(1<<ref[i+1]);
			a[prf]=doit(prf^(1<<ref[i+1]));
			return a[prf];
		}
	if (pn==3) {
		bb[prf]=false;
		a[prf]=0;
		return a[prf];
	}
	bb[prf]=true;
	a[prf]=1000000000;
	for(i=0;i<pn;i++)
		for(j=0;j<pn;j++)
			if (poss[ref[i]][ref[j]]) {
				int pr1=(1<<(ref[i]))-(1<<ref[j]);
				if (pr1<=0) pr1=-pr1;
				pr1&=prf;
				int pr2=prf&~pr1;
				pr1|=(1<<ref[i])|(1<<ref[j]);
				pr2|=(1<<ref[i])|(1<<ref[j]);
				int t1=doit(pr1);
				int t2=doit(pr2);
				if (t1+t2+1<a[prf]) {
					diag[prf][0]=ref[i];
					diag[prf][1]=ref[j];
					f[prf]=pr1;
					ff[prf]=pr2;
					a[prf]=t1+t2+1;
				}
			}
	return a[prf];
}

void outans(int prf) {
	if (a[prf]==0)
		return;
	outans(f[prf]);
	if (bb[prf]) {
		outans(ff[prf]);
		printf("%d %d %d %d\n",x[diag[prf][0]],y[diag[prf][0]],x[diag[prf][1]],y[diag[prf][1]]);
	}
}

int main() {
	freopen("reform.in","r",stdin);
	freopen("reform.out","w",stdout);
	int i,j,k;
	scanf("%d",&n);
	for(i=0;i<n;i++)
		scanf("%d%d",x+i,y+i);
	x[n]=x[0];
	y[n]=y[0];
	x[n+1]=x[1];
	y[n+1]=y[1];
	for(i=0;i<n;i++)
		for(j=0;j<n;j++) {
			if ((j==i-1)||(j==i)||(j==i+1)) {
				poss[i][j]=false;
				continue;
			}
			int l=0;
			int r=0;
			for(k=0;k<n;k++) {
				int t=turn(i,j,k);
				if (t>0) l++;
				if (t<0) r++;
			}
			if ((l==0)||(r==0)) {
				poss[i][j]=false;
				continue;
			}
			poss[i][j]=true;
			for(k=0;k<n;k++) {
				int k1=k+1;
				if (k1==n) k1=0;
				int t1,t2;
				t1=turn(i,j,k);
				t2=turn(i,j,k1);
				if ((t1==0)&&(t2==0)) {
					if ((k==i)||(k==j)||(k1==i)||(k1==j)) {
						if ((diff(k,j)+diff(k,i)==diff(i,j))
						&&(diff(k1,j)+diff(k1,i)==diff(i,j))) {
							poss[i][j]=false;
							break;
						}
					}
					continue;
				}
				if ((k==i)||(k==j)||(k1==i)||(k1==j))
					continue;
				if ((t1<0)&&(t2<0)||(t1>0)&&(t2>0)) continue;
				t1=turn(k,k1,i);
				t2=turn(k,k1,j);
				if ((t1<0)&&(t2<0)||(t1>0)&&(t2>0)) continue;
				poss[i][j]=false;
				break;
			}
		}
	memset(a,-1,sizeof(a));
	int ans=doit((1<<n)-1);
	printf("%d\n%d\n",ans+1,ans);
	outans((1<<n)-1);
	return 0;
}