{$apptype console}

const
 maxn = 25;
 maxp = 1100003;
 eps = 1e-9;

var
 n, i, k: integer;
 x, y, s, f: array [0..maxn] of integer;
 d, pa, pa2: array [0..maxp] of integer;
 td, a1, a2: array [0..maxp] of byte;

function sign(a: integer): integer;
 begin
   if a = 0 then
     sign := 0
   else
     sign := a div abs(a);
 end;

function test1(a, b, c, d: integer): boolean;
 var
  a1, b1, c1, a2, b2, c2: integer;
 begin
   a1 := y[a] - y[b];
   b1 := x[b] - x[a];
   c1 := -(a1 * x[a] + b1 * y[b]);
   a2 := y[c] - y[c];
   b2 := x[d] - x[d];
   c2 := -(a2 * x[d] + b2 * y[d]);
   test1 := (sign(a1 * x[c] + b1 * y[c] + c1) * sign(a1 * x[d] + b1 * y[d] + c1) <= 0) and
            (sign(a2 * x[a] + b2 * y[a] + c2) * sign(a2 * x[b] + b2 * y[b] + c2) <= 0);
 end;

function test2(k: integer; p: array of integer; a, b: integer): boolean;
 var
  ta, tb, tc, rx, ry, xa, xb, xc, d, l1, l2: extended;
  i, res, fa, fb: integer;
 begin
//   writeln(erroutput, 'TEST2');
   res := 0;
   ta := random(201) - 100.5 + random;
   tb := random(201) - 100.5 + random;
//   writeln(erroutput, '  ta = ', ta:7:3, '; tb = ', tb:7:3);
   tc := -(ta * (x[p[a]] + x[p[b]]) + tb * (y[p[a]] + y[p[b]]));
   l1 := tb * (x[p[a]] + x[p[b]]) - ta * (y[p[a]] + y[p[b]]);
//   writeln(erroutput, '!!L1 = ', L1:6:3);
   for i := 0 to k - 1 do begin
     fa := i;
     fb := (i + 1) mod k;
//     writeln(erroutput, '  fa = ', fa, '; fb = ', fb);
//     writeln(erroutput, '    x0 = ', x[p[fa]], '; y0 = ', y[p[fa]], '; x1 = ', x[p[fb]], '; y1 = ', y[p[fb]]);
     xa := y[p[fa]] - y[p[fb]];
     xb := x[p[fb]] - x[p[fa]];
     xc := -(xa * 2 * x[p[fa]] + xb * 2 * y[p[fa]]);
//     writeln(erroutput, '    xa = ', xa:6:3, '; xb = ', xb:6:3, '; xc = ', xc:6:3);
     d := ta * xb - tb * xa;
     if abs(d) < eps then
       continue;
     rx := -(tc * xb - tb * xc) / d;
     ry := -(ta * xc - tc * xa) / d;
//     writeln(erroutput, '    rx = ', rx:6:3, '; ry = ', ry:6:3);
     if ((rx < 2 * x[p[fa]] - eps) and (rx < 2 * x[p[fb]] - eps)) or
        ((rx > 2 * x[p[fa]] + eps) and (rx > 2 * x[p[fb]] + eps)) or
        ((ry < 2 * y[p[fa]] - eps) and (ry < 2 * y[p[fb]] - eps)) or
        ((ry > 2 * y[p[fa]] + eps) and (ry > 2 * y[p[fb]] + eps)) then
       continue;
     l2 := tb * rx - ta * ry;
//     writeln(erroutput, '    l2 = ', l2:6:3);
     if l2 > l1 + eps then
       inc(res);
   end;
//   writeln(erroutput, '!!RES = ', res);
   test2 := res and 1 = 0;
 end;

function func(pr: integer): integer;
 var
  i, k, a, b, c, j, f, pr1, pr2, res, r1, r2: integer;
  p: array [0..maxn] of integer;
 begin
   if d[pr] <> -1 then begin
     func := d[pr];
     exit;
   end;
   k := 0;
   for i := 0 to n - 1 do
     if pr and (1 shl i) <> 0 then begin
       p[k] := i;
       inc(k);
     end;
   if k <= 3 then begin
     d[pr] := 1;
     pa[pr] := -1;
     td[pr] := 0;
     func := 1;
     exit;
   end;
   for i := 0 to k - 1 do begin
     a := i;
     b := (i + 1) mod k;
     c := (i + 2) mod k;
     if (x[p[b]] - x[p[a]]) * (y[p[c]] - y[p[a]]) = (x[p[c]] - x[p[a]]) * (y[p[b]] - y[p[a]]) then begin
       d[pr] := func(pr - (1 shl b));
       pa[pr] := pr - (1 shl b);
       td[pr] := 0;
       func := d[pr];
       exit;
     end;
   end;
   for i := 0 to k - 2 do
     for j := i + 2 to k - 1 do begin
       if (j = k - 1) and (i = 0) then
         continue;
       a := i;
       b := j;
       f := 1;
       for c := 0 to k - 1 do
         if (c <> a) and (c <> b) and ((c + 1) mod k <> a) and ((c + 1) mod k <> b) then
           if test1(p[a], p[b], p[c], p[(c + 1) mod k]) then begin
             f := 0;
             break;
           end;
       if f = 0 then
         continue;
       if test2(k, p, a, b) then
         continue;
       pr1 := 0;
       for c := 0 to k - 1 do
         if (c >= a) and (c <= b) then
           pr1 := pr1 or (1 shl p[c]);
       pr2 := pr - pr1 + 1 shl p[a] + 1 shl p[b];
       r1 := func(pr1);
       r2 := func(pr2);
       if (r1 = -1) or (r2 = -1) then
         continue;
       res := r1 + r2;
       if (d[pr] = -1) or (d[pr] > res) then begin
         d[pr] := res;
         td[pr] := 2;
         a1[pr] := a;
         a2[pr] := b;
         pa[pr] := pr1;
         pa2[pr] := pr2;
       end;
     end;
   func := d[pr];
 end;

procedure makeout(pr: integer);
 begin
   if td[pr] = 0 then
     exit;
   if td[pr] = 1 then begin
     makeout(pa[pr]);
     exit;
   end;
   if td[pr] = 2 then begin
     s[k] := a1[pr];
     f[k] := a2[pr];
     inc(k);
     makeout(pa[pr]);
     makeout(pa2[pr]);
     exit;
   end;
 end;

begin
  reset(input, 'reform.in');
  rewrite(output, 'reform.out');

  read(n);
  for i := 0 to n - 1 do
    read(x[i], y[i]);
  fillchar(d, sizeof(d), -1);
  writeln(func((1 shl n) - 1));
  k := 0;
  makeout(1 shl n - 1);
  writeln(k);
  for i := 0 to k - 1 do
    writeln(x[s[i]], ' ', y[s[i]], '  ', x[f[i]], ' ', y[f[i]]);

  close(input);
  close(output);
end.
