{$apptype console}
{$o-,r+,q+}
{$maxstacksize 30000000}
uses
  SysUtils, Math;

const
  MAXN = 1000;

type
  int = longint;
  real = extended;

var
  h, w: int;
  a: array[1..MAXN, 1..MAXN] of int;
  col: array[1..MAXN, 1..MAXN] of int;
  r, c: int;
  colCnt: int;
  ch: char;

procedure dfs(r, c: int);
begin
  if col[r, c] > 0 then
    exit;
  col[r, c] := colCnt;
  if (r > 1)  and (a[r][c] <> a[r - 1][c]) then
    dfs(r - 1, c);
  if (r < h)  and (a[r][c] <> a[r + 1][c]) then
    dfs(r + 1, c);
  if (c > 1)  and (a[r][c] <> a[r][c - 1]) then
    dfs(r, c - 1);
  if (c < w)  and (a[r][c] <> a[r][c + 1]) then
    dfs(r, c + 1);
end;

begin
  reset(input, 'board.in');
  rewrite(output, 'board.out');
//  readln(h, w);
  h := 8;
  w := 8;
  assert((1 <= h) and (h <= MAXN));
  assert((1 <= w) and (w <= MAXN));
  for r := 1 to h do
  begin
    for c := 1 to w do
    begin
      read(ch);
      assert(ch in ['B', 'W']);
      if (ch = 'B') then
        a[r][c] := 0
      else if (ch = 'W') then
        a[r][c] := 1;
    end;
    readln;
  end;
  colCnt := 0;
  for r := 1 to h do
  begin
    for c := 1 to w do
    begin
      if col[r, c] = 0 then
      begin
        inc(colCnt);
        dfs(r, c);
      end;
    end;
  end;
  writeln(colCnt);
{
  for r := 1 to h do
  begin
    for c := 1 to w do
      write(col[r, c], ' ');
    writeln;
  end;
{}
end.

