{$APPTYPE CONSOLE}
uses
  SysUtils;
  
type
  int = longint;

function gcd(a, b: int): int;
begin
  result := a;
  while (b > 0) do
  begin
    result := b;
    b := a mod b;
    a := result;
  end;
end;

var
  head, next, val: array[1..300000] of int;
  len: int = 0;

procedure findAllDivisors(n: int);
var
  i, ii, m: int;
begin
  i := 1;
  ii := 1;
  while (ii <= n) do
  begin
    m := ii;
    while (m <= n) do
    begin
      inc(len);
      val[len] := ii;
      next[len] := head[m];
      head[m] := len;
      inc(m, ii);
    end;
    inc(i);
    ii := i * i;
  end;
end;

var
  n, m, z, nn, cur, p: int;
  ans, amo: array[1..100000] of int;
  toprint: int;

procedure output(m: int; s: string; dd: int);
var
  s1: string;
  z, nn, cur, p: int;
begin
  if (toprint = 0) then
    exit;
  if (m = 1) then
  begin
    writeln(s, ' ', dd);
    dec(toprint);
    exit;
  end;
  z := 1;
  while (z * z < m) do
  begin
    nn := m - z * z;
    cur := head[nn];
    while (cur > 0) do
    begin
      if (gcd(val[cur], z) = 1) then
      begin
        p := nn div val[cur];
        if (ans[p] + 1 = ans[m]) then
        begin
          s1 := s + ' ' + inttostr(z * dd);
          output(p, s1, dd * round(sqrt(val[cur])));
        end;
      end;
      cur := next[cur];
    end;
    inc(z);
  end;
end;

procedure answer(m: int);
begin
  writeln('------ Number: ', m:6, ';    ', amo[m]:10, ' points');
  toprint := 10;
  output(m, '', 1);
end;

begin
  n := 20000;
  findAllDivisors(n);
  ans[1] := 1;
  amo[1] := 1;
  for m := 2 to n do
  begin
    z := 1;
    ans[m] := m + 1;
    while (z * z < m) do
    begin
      nn := m - z * z;
      cur := head[nn];
      while (cur > 0) do
      begin
        if (gcd(val[cur], z) = 1) then
        begin
          p := nn div val[cur];
          if (ans[p] + 1 < ans[m]) then
          begin
            ans[m] := ans[p] + 1;
            amo[m] := amo[p];
          end
          else if (ans[p] + 1 = ans[m]) then
          begin
            inc(amo[m], amo[p]);
          end;
        end;
        cur := next[cur];
      end;
      inc(z);
    end;
  end;
  for m := 1 to n do
  begin
    answer(m);
    //writeln(m, ': ', ans[m], ' ', amo[m]);
  end;
end.