{$apptype console}
{$r+,q+,o-}
uses
  sysutils;

function readToken: string;
var
  ch: char;
begin
  if not seekeof then begin
    read(ch);
    result := '';
    while (ch > ' ') do begin
      result := result + upcase(ch);
      read(ch);
    end;
  end;
end;

var
  dd: array[0..1000100] of integer;
  name: array[1..200000] of string;
  hn: integer;

function readHero: integer;
var
  s: string;
  i, h: integer;
begin
  s := readToken;
  h := 0;
  for i := 1 to length(s) do begin
    h := (h * 213 + ord(s[i]) * 23) mod 1000003;
  end;
  while dd[h] > 0 do begin
    if (name[dd[h]] = s) then begin
      result := dd[h];
      exit;
    end;
    inc(h);
  end;
  inc(hn);
  dd[h] := hn;
  name[hn] := s;
  result := hn;
end;

var
  l: integer;
  nx, q: array[1..500000] of integer;

procedure add(var h, i: integer);
begin
  inc(l);
  nx[l] := h;
  q[l] := i;
  h := l;
end;

var
  z: array[1..100000] of boolean;
  el: array[1..200000] of integer;
  hl: array[1..100000] of integer;
  b, d: array[1..200000] of integer;
  pn: integer;
  p: array[1..100000] of integer;
  dz: array[1..200000] of boolean;

procedure push(i: integer);
var
  j, jj, h: integer;
begin
  if z[i] then exit;
  z[i] := true;
  j := hl[i];
  while (j <> 0) do begin
    h := q[j];
    if (d[h] = i) and (not dz[h]) then begin
      dz[h] := true;
      jj := el[h];
      while (jj <> 0) do begin
        push(q[jj]);
        jj := nx[jj];
      end
    end else begin
      if (b[h] <> 0) then push(b[h]);
    end;
    j := nx[j];
  end;
  inc(pn);
  p[pn] := i;
end;

var
  n, k, i, j, h1, h2: integer;
  s: string;

begin
  reset(input, 'mythes.in');
  rewrite(output, 'mythes.out');

  read(n);
  for i := 1 to n do begin
    read(k);
    for j := 1 to k do begin
      h1 := readHero;
      s := readToken;
      h2 := readHero;
      if (s = 'BORN') then begin
        b[h2] := i;
      end else begin
        d[h2] := i;
      end;
      add(el[h1], i);
      add(el[h2], i);
      add(hl[i], h1);
      add(hl[i], h2);
    end;
  end;

  for i := 1 to n do push(i);
  for i := 1 to n do write(p[i], ' ');
end.