import java.util.*;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintWriter;

public class mythes_pm {

    static Map<String, Hero> heroes = new HashMap<String, Hero>();

    static List<Integer> p = new ArrayList<Integer>();

    static Hero getHero(String name) {
        name = name.toLowerCase();
        Hero h = heroes.get(name);
        if (h == null) {
            h = new Hero();
            h.name = name;
            heroes.put(name, h);
        }
        return h;
    }

    public static void main(String[] args) throws FileNotFoundException {
        Scanner s = new Scanner(new File("mythes.in"));
        int n = s.nextInt();
        Card[] c = new Card[n];

        for (int i = 0; i < n; i++) {
            c[i] = new Card();
            c[i].n = i + 1;
            int m = s.nextInt();
            for (int j = 0; j < m; j++) {
                Hero h1 = getHero(s.next());
                String act = s.next();
                Hero h2 = getHero(s.next());
                c[i].h.add(h1);
                c[i].h.add(h2);
                h1.e.add(c[i]);
                h2.e.add(c[i]);
                if (act.equals("born")) {
                    h2.b = c[i];
                } else {
                    h2.d = c[i];
                }
            }
        }

        for (int i = 0; i < n; i++) {
            pushCard(c[i]);
        }

        PrintWriter w = new PrintWriter("mythes.out");
        for (int i: p) {
            w.print(i);
            w.print(' ');
        }
        w.close();
    }

    private static void pushCard(Card card) {
        if (card.z) return;
        card.z = true;
        for (Hero hero : card.h) {
            if (hero.b != null) pushCard(hero.b);
            if (hero.d == card) {
                for (Card c : hero.e) {
                    pushCard(c);
                }
            }
        }
        p.add(card.n);
    }

    static class Card {
        Set<Hero> h = new HashSet<Hero>();
        int n;
        boolean z = false;
    }

    static class Hero {
        String name;
        Card b;
        Card d;
        Set<Card> e = new HashSet<Card>();

        public boolean equals(Object obj) {
            return ((Hero)obj).name.equals(name);
        }
    }
}

