{$APPTYPE CONSOLE}
{$Q-,R-,O+}
uses
  sysutils;

type
  int = longint;

const
  maxn = 100000;
  maxd = 1000000000;

var
  i, n: int;
  anssize: int = 0;
  mx, w, ans: array[1..1000000] of int;
  free, toput, canfree: int;

begin
  reset(input, 'parcel.in');
  rewrite(output, 'parcel.out');
  read(n);
  assert((1 <= n) and (n <= maxn));
  for i := 1 to n do
  begin
    read(mx[i]);    
    assert((1 <= mx[i]) and (mx[i] <= maxd));
  end;
  for i := 1 to n  - 1 do
  begin
    read(w[i]);
    assert((1 <= w[i]) and (w[i] <= maxd));
    assert(mx[i] >= w[i]);
  end;
  free := n;
  read(toput);
  while (toput > mx[free]) do
  begin
    canfree := 0;
    for i := 1 to n do
    begin
      if (i <> free) and (w[i] <= mx[free]) and ((canfree = 0) or (mx[i] > mx[canfree])) then
      begin
        canfree := i;
      end;
    end;
    if (canfree = 0) or (mx[canfree] < mx[free]) or (anssize = 1000000) then
    begin
      writeln(-1);
      halt;
    end;
    w[free] := w[canfree];
    free := canfree;
    inc(anssize);
    ans[anssize] := free;
  end;
  writeln(anssize + 1);
  for i := 1 to anssize do
    write(ans[i], ' ');
end.