{$APPTYPE CONSOLE}

type
  int = longint;

var
  s: string;
  balance: int = 0;
  worstbalance: int = 0;
  open: int = 0;
  close: int = 0;
  bal: int = 0;
  openbr, closebr, i, j: int;

procedure impossible;
begin
  writeln('Impossible');
  halt;
end;

begin
  reset(input, 'brackets.in');
  rewrite(output, 'brackets.out');
  readln(s);

  for i := 1 to length(s) do
  begin
    if (s[i] = '(') then
      inc(balance)
    else if (s[i] = ')') then
      dec(balance)
    else if (s[i] = '[') and (open = 0) then
      open := i
    else if (s[i] = ']') then
      close := i;
    if (open <> 0) and (balance < worstbalance) then
      worstbalance := balance;    
  end;

  openbr := -worstbalance;
  closebr := openbr + balance;
  if (closebr < 0) then
    impossible;

  for i := 1 to length(s) do
  begin
    if (s[i] = '(') then
      inc(bal)
    else if (s[i] = ')') then
      dec(bal)
    else if (i = open) then
      inc(bal, openbr)
    else if (i = close) then
      dec(bal, closebr);
    if (bal < 0) then
      impossible;
  end;
  if (bal <> 0) then
    impossible;

  for i := 1 to length(s) do
  begin
    if (s[i] = '(') then
      write('(')
    else if (s[i] = ')') then
      write(')')
    else if (i = open) then
    begin
      for j := 1 to openbr do
        write('(');
    end
    else if (i = close) then
    begin
      for j := 1 to closebr do
        write(')');
    end;
  end;
  writeln;
end.