{$APPTYPE CONSOLE}

type
  int = longint;

const
  hsize = 566239;
  ha = 237;
  hb = 100;

var
  n, m, i, j, k, hash, cur: int;
  x, y: array[1..10000] of int;
  a, b, c: array[1..1000] of int;
  l: array[1..10000, 1..1000] of boolean;
  head: array[0..hsize - 1] of int;
  next, val: array[1..10000] of int;
  match: boolean;
  list: int = 0;

begin
  reset(input, 'candles.in');
  rewrite(output, 'candles.out');
  read(n, m, i);
  for i := 1 to n do
    read(x[i], y[i]);
  for i := 1 to m do
    read(a[i], b[i], c[i]);
  for j := 1 to n do
  begin
    hash := 0;
    for i := 1 to m do
    begin
      hash := ha * hash;
      if (a[i] * x[j] + b[i] * y[j] + c[i] > 0) then
      begin
        inc(hash, hb);
        l[j, i] := true;
      end
      else
        l[j, i] := false;
      hash := hash mod hsize;
    end;
    cur := head[hash];
    while (cur <> 0) do
    begin
      k := val[cur];
      match := true;
      for i := 1 to m do if (l[j, i] <> l[k, i]) then
      begin
        match := false;
        break;
      end;
      if match then
      begin
        writeln('YES');
        halt;
      end;
      cur := next[cur];
    end;
    inc(list);
    next[list] := head[hash];
    val[list] := j;
    head[hash] := list;
  end;
  writeln('NO');
end.