import java.util.Scanner;
import java.io.File;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Arrays;

public class perms_dp_bad {
    private static final int INF = 1000000000;
    private static final String INPUT_FILE = "perms.in";
    private static final String OUTPUT_FILE = "perms.out";

    private int n;
    private int[] a;

    private int ansQuality;
    private int[] ansPermutation;
    private int[] ansPosition;

    private int[] quality;
    private int[][] permutation;
    private int[][] position;
    private boolean[][] used;

    public static void main(String[] args) throws IOException {
        perms_dp_bad sol = new perms_dp_bad();
        sol.read();
        sol.solve();
        sol.write();
    }

    private void read() throws IOException {
        Scanner in = new Scanner(new File(INPUT_FILE));
        n = in.nextInt();
        a = new int[n];
        for (int i = n - 1; i >= 0; i--)
            a[i] = in.nextInt();
    }
    
    private void solve() {
        int MAX_LAST = n + 1;
        ansQuality = -1;
        ansPermutation = new int[n];
        ansPosition = new int[n];
        quality = new int[MAX_LAST];
        permutation = new int[MAX_LAST][n];
        position = new int[MAX_LAST][n];
        used = new boolean [MAX_LAST][n + 1];
        int[] dig = new int[MAX_LAST];
        int last = 0;
        System.arraycopy(a, 0, permutation[0], 0, n);
        for (int i = 0; i < n; i++) 
            position[0][i] = i;
        quality[0] = 0;
        while (permutation[0][0] > 1) {
            int l = 0;
            int r = permutation[0][0] - 1;
            quality[0]++;
            while (l < r) {
                int tmp = permutation[0][l];
                permutation[0][l] = permutation[0][r];
                permutation[0][r] = tmp;
                tmp = position[0][l];
                position[0][l] = position[0][r];
                position[0][r] = tmp;
                l++;
                r--;
            }
        }
        if (permutation[0][0] == 1) {
            if (ansQuality < quality[0]) {
                ansQuality = quality[0];
                System.arraycopy(permutation[0], 0, ansPermutation, 0, n);
                System.arraycopy(position[0], 0, ansPosition, 0, n);
            }
        } else {
            dig[0] = 0;
            for (int i = 0; i < n; i++) {
                used[0][permutation[0][i]] = true;
            }
            while (last >= 0) {
/*
                for (int p = 0; p <= last; p++) {
                    for (int i = 0; i < permutation[p].length; i++)
                        System.out.print(permutation[p][i] + "/" + position[p][i] + " ");
                    System.out.println();
                }
                System.out.println("-----");
/**/                
                for (int i = 0; i <= last; i++)
                    System.out.print(dig[i] + " ");
                System.out.println();

                if (ansQuality < quality[last]) {
                    ansQuality = quality[last];
                    System.arraycopy(permutation[last], 0, ansPermutation, 0, n);
                    System.arraycopy(position[last], 0, ansPosition, 0, n);
                }

                if (dig[last] < n && permutation[last][0] == 0) {
                    dig[last]++;
                    if (used[last][dig[last]])
                        continue;
                    dig[last + 1] = 0;
                    System.arraycopy(permutation[last], 0, permutation[last + 1], 0, n);
                    System.arraycopy(position[last], 0, position[last + 1], 0, n);
                    System.arraycopy(used[last], 0, used[last + 1], 0, n);

                    quality[last + 1] = quality[last];
                    permutation[last + 1][0] = dig[last];
                    used[last + 1][dig[last]] = true;

                    last++;
                    while (permutation[last][0] > 1) {
                        int l = 0;
                        int r = permutation[last][0] - 1;
                        while (l < r) {
                            int tmp = permutation[last][l];
                            permutation[last][l] = permutation[last][r];
                            permutation[last][r] = tmp;
                            tmp = position[last][l];
                            position[last][l] = position[last][r];
                            position[last][r] = tmp;
                            l++;
                            r--;
                        }
                        quality[last]++;
                    }
                } else {
                    last--;
                    continue;
                }
            }
        }
    }
    
    private void write() throws IOException {
        System.out.println("-----");
        for (int i = 0; i < n; i++)
            System.out.print(ansPermutation[i] + "/" + ansPosition[i] + " ");
        System.out.println();
        System.out.println("-----");

        for (int i = 0; i < n; i++) {
            for (int j = 1; j < n; j++) {
                if (ansPosition[j - 1] > ansPosition[j]) {
                    int tmp = ansPermutation[j - 1];
                    ansPermutation[j - 1] = ansPermutation[j];
                    ansPermutation[j] = tmp;
                    tmp = ansPosition[j - 1];
                    ansPosition[j - 1] = ansPosition[j];
                    ansPosition[j] = tmp;
                }
            }
        }

/*
        System.out.println("-----");
        for (int i = 0; i < n; i++)
            System.out.print(ansPermutation[i] + "/" + ansPosition[i] + " ");
        System.out.println();
        System.out.println("-----");
/**/
     
        boolean[] w = new boolean[n + 1];
        for (int i = 0; i < n; i++) {
            w[ansPermutation[i]] = true;
        }
        for (int i = 0; i < n; i++) {
            if (ansPermutation[i] == 0) {
                for (int d = 1 ; d <= n; d++) {
                    if (!w[d]) {
                        w[d] = true;
                        ansPermutation[i] = d;
                        break;
                    }
                }
            }
        }
        PrintWriter out = new PrintWriter(new File(OUTPUT_FILE));
        out.println(ansQuality);
        for (int i = n - 1; i >= 0; i--)
            out.print(ansPermutation[i] + " ");
        out.close();
    }
}
