{$R+,Q+,I+,O-}
{//$R-,Q-,I-,O+}
{$APPTYPE CONSOLE}

uses
  SysUtils;

type
  int = longint;

const
  NMAX = 500;
  MMAX = 500;

var
  n, m, i, j, x, z: int;
  a: array[1..NMAX, 1..MMAX] of int;
  vb: int;
  ib, jb, xb, yb: int;
  p, v: array[1..MMAX] of int;

procedure qsort(l, r: int);
var
  i, j, x: int;
begin
  i := l;
  j := r;
  x := v[p[(l + r) shr 1]];
  while i < j do begin
    while v[p[i]] > x do
      inc(i);
    while v[p[j]] < x do
      dec(j);
    if i < j then begin
      z := p[i];
      p[i] := p[j];
      p[j] := z;
      inc(i);
      dec(j);
    end;
  end;
  if l < j then qsort(l, j);
  if i < r then qsort(i, r);
end;

begin
  reset(input, 'problem.in');
  rewrite(output, 'problem.out');
  read(n, m);
  for i := 1 to n do begin
    for x := 1 to m do begin
      read(a[i, x]);
    end;
  end;

  for x := 1 to m do begin
    p[x] := x;
  end;
  vb := -1000000000;
  ib := 0;
  jb := 0;
  xb := 0;
  yb := 0;

  for i := 1 to n - 1 do begin
    for j := i + 1 to n do begin
      for x := 1 to m do begin
        v[x] := a[i, x] + a[j, x];
      end;
      qsort(1, m);
      if v[p[1]] + v[p[2]] > vb then begin
        vb := v[p[1]] + v[p[2]];
        ib := i;
        jb := j;
        if p[1] < p[2] then begin
          xb := p[1];
          yb := p[2];
        end else begin
          xb := p[2];
          yb := p[1];
        end;
      end;
    end;
  end;

  writeln(vb);
  writeln(ib, ' ', xb, ' ', jb, ' ', yb);
end.


