{$apptype console}
{$o-,r+,q+}
uses
  SysUtils, Math;

const
  inf = 1000000000;
  INPUT_FILE = 'tester.in';
  OUTPUT_FILE = 'tester.out';
  MAXH = 50;
  MAXK = 10;

type
  int = longint;

var
  ans: array[1..MAXH, 1..MAXH, 1..MAXH, 0..MAXK, 0..MAXK] of word;

function solve(l, r, h, k, c: int): int;
var
  i: int;
  res1, res2: int;
  res: int;
begin
  if (l > r) then
  begin
    result := 0;
    exit;
  end;
  if (k + c = 0) or (k < 0) then
  begin
    result := inf;
    exit;
  end;
  if (l = r) then
  begin
    if k > 0 then
    begin
      if h > l then
      begin
        result := 0;
      end else begin
        result := l - h;
      end;
    end else begin
      result := l - 1;
    end;
    exit;
  end;
  if ans[l, r, h, k, c] <> $FFFF then
  begin
    result := ans[l, r, h, k, c];
    exit;
  end;
  result := inf;
  if c > 0 then
  begin
    res := l - 1 + solve(l, r, l, k + c, 0);
    result := min(result, res);
  end;
  for i := l to h do
  begin
    res1 := solve(l, i - 1, i, k - 1, c);
    res2 := solve(i + 1, r, i, k - 1, c + 1);
    res := max(res1, res2);
    result := min(result, res);
  end;
  for i := h + 1 to r do
  begin
    res1 := solve(l, i - 1, i, k - 1, c);
    res2 := solve(i + 1, r, i, k - 1, c + 1);
    res := max(res1, res2);
    result := min(result, i - h + res);
  end;
  ans[l, r, h, k, c] := result;
end;

var
  h, k, p: int;

begin
  reset(input, INPUT_FILE);
  rewrite(output, OUTPUT_FILE);
  read(h, k);
  if k = 0 then
    halt(1);
  fillchar(ans, sizeof(ans), $FF);
  writeln(solve(2, h - 1, 1, k, 0));
end.