program time;

uses
	sysutils;

var
	i, j, k, p: longint;
	d: array [1..10] of longint;
	h, m: array [0..10000] of longint;

begin
	reset(input, 'time.in');
	rewrite(output, 'time.out');

	readln(p);
	assert(p >= 0);
	readln(d[1], d[2]);
	assert((d[1] = -1) or (d[1] = 0) or (d[1] = 1));
	assert((d[2] = -1) or (d[2] = 0) or (d[2] = 1));
	assert(p < 24 * 60 - 60 * d[1]);
	readln(k);
	assert((k >= 1) and (k <= 600));

	h[0] := 0;
	m[0] := 0;
	j := 1;
	for i := 1 to 3000 do begin
		h[i] := h[i - 1];
		m[i] := m[i - 1] + 1;
		if (m[i] = 60) then begin
			m[i] := 0;
			inc(h[i]);
		end;

		if (h[i] = 2) and (m[i] = 0) and (d[j] = 1) then begin
			h[i] := h[i] + d[j];
			d[j] := 0;
		end;
		if (h[i] = 3) and (m[i] = 0) and (d[j] = -1) then begin
			h[i] := h[i] + d[j];
			d[j] := 0;
		end;
		if (h[i] = 24) then begin
			h[i] := 0;
			inc(j);
		end;
	end;

	for i := 1 to k do begin
		writeln(format('%.2d:%.2d', [h[p + i - 1], m[p + i - 1]]));
	end;

	close(input);
	close(output);
end.