program wall;

uses
	math, sysutils;

const
	maxn = 1000;
    inf: int64 = 1000000000000000;

var
	n, i, j: longint;
	a, b: array [0..maxn] of int64;
	sum, h: int64;
	t1, t2: int64;
	d: array [1..maxn, 0..maxn] of int64;

begin
	reset(input, 'wall.in');
	rewrite(output, 'wall.out');

	readln(n);
	assert((1 <= n) and (n <= 1000));
	sum := 0;
	b[0] := 0;
	for i := 1 to n do begin
		read(a[i]);
		assert((1 <= a[i]) and (a[i] <= 1000000));
		sum := sum + a[i];
		b[i] := b[i - 1] + a[i];
   	end;

	h := sum div n;

	d[1][0] := 0;
	d[1][1] := 0;
	for i := 2 to n do begin
		for j := 0 to i do begin
			{ last height is h }
            if (j < i) then begin
    			t1 := abs(b[i - 1] - ((i - 1) * h + j)) + d[i - 1][j];
            end else begin
                t1 := inf;
            end;
			{ last height is h + 1 }
			if (j > 0) then begin
				t2 := abs(b[i - 1] - ((i - 1) * h + j - 1)) + d[i - 1][j - 1];
			end else begin
				t2 := inf;
			end;
			d[i][j] := min(t1, t2);
		end;
	end; 

	writeln(d[n][sum mod n]);

	close(input);
	close(output);
end. 