#include "orient_sn_bheap.h"
#include <iostream>
#include <queue>

using namespace std;

#define MMAX 100000

#define forn(i, n) for (int i = 0; i < int(n); ++i)

typedef bheap * pheap;

pheap h[MMAX];
pheap up[MMAX];
int nd;

key_t inf;
key_t ans;
int amount;

int n, m;

void readData()
{
	scanf("%d %d", &n, &m);
	nd = n;
	forn (i, nd) h[i] = new bheap();

	forn (i, m)			
	{
		int a, b, cab, cba;
		scanf("%d %d %d %d", &a, &b, &cab, &cba);
		inf = inf + cab + cba;
		--a; --b;
		h[b] -> insert(cab, i);	
		h[a] -> insert(cba, i);	
	}
	inf++;
	inf <<= 2;
	forn (i, nd) h[i] -> insert(inf, m);
}

void solve()
{
	queue <pheap> q;
	forn (i, nd) q.push(h[i]); 
	memset(up, 0, sizeof(up));
	amount = nd;
	while (!q.empty())
	{
		bheap * c = q.front();
		q.pop();
		key_t min = c -> getMinKey();										
		if (min >= inf / 2) 
			ans += min - inf, amount--;
		else
			ans += min;
		int upv = c -> getMinInfo();

		if (upv == m) continue;
		c -> extractMin();
		c -> incAll(-min);
		if (up[upv] == 0)
			up[upv] = c;
		else
		{
			bheap *t = new bheap;
			*t = merge(*c, *up[upv]);
			q.push(t);
		}
	}
	cout << amount << " " << ans << endl;
}

int main()
{
	freopen("orient.in", "rt", stdin);
	freopen("orient.out", "wt", stdout);
	inf = ans = amount = 0;
	readData();
	solve();
	return 0;
}
