#define _CRT_SECURE_NO_DEPRECATE
#pragma comment (linker, "/STACK:30000000")

#include <string>
#include <vector>
//#include <cmath>
//#include <queue>
#include <set>
//#include <map>
#include <algorithm>
//#include <iostream>
//#include <cstdio>
//#include <sstream>
#include <cassert>
//#include <utility>

using namespace std;

#define EPS 1E-8
const int INF = (int)1E+9;

#define C_IN_FILE "orient.in"
#define C_OUT_FILE "orient.out"

#define forn(i, n) for (int i = 0; i < (int)(n); ++i)
#define forv(i, v) for (int i = 0; i < (int)(v.size()); ++i)
#define fors(i, s) for (int i = 0; i < (int)(s.length()); ++i)
#define all(a) a.begin(), a.end()
#define pb push_back
#define PII pair<int, int>
#define mp make_pair
#define VI vector<int>
#define VS vector<string>

const int NMAX = 111111;

int n, m, kans, ans;
bool u[NMAX];

struct edge {
	int u, v, w;
	edge(int u, int v, int w) {
		this->u = u;
		this->v = v;
		this->w = w;
	}
};

vector<edge> a;

bool operator < (const edge &a, const edge &b) {
	return a.w < b.w;
}

void outdata() {
	printf("%d %d\n", kans, ans);
}

void solve() {
	ans = kans = 0;
	sort(all(a));
	forv(i, a) {
		if (!u[a[i].v]) {
			u[a[i].v] = true;
			++kans;
			ans += a[i].w;
		}
	}
}

void readdata() {
	set< PII > edges;
	scanf("%d%d", &n, &m);
	assert(1 <= n && n <=  10000);
	assert(1 <= m && m <= 100000);
	forn(i, m) {
		int x, y, c1, c2;
		scanf("%d%d%d%d", &x, &y, &c1, &c2);
		--x, --y;
		assert(0 <= x && x < n);
		assert(0 <= y && y < n);
		assert(x != y);
		assert(edges.count(mp(x, y)) == 0);
		assert(edges.count(mp(y, x)) == 0);
		edges.insert(mp(x, y));
		a.pb(edge(x, y, c1));
		a.pb(edge(y, x, c2));
	}
	edges.clear();
}

int main() {
    freopen(C_IN_FILE, "rt", stdin);
    freopen(C_OUT_FILE, "wt", stdout);
	readdata();
	solve();
	outdata();
	return 0;
}
