#include <cstdio>
#include <fstream.h>
#include <iostream.h>
#include <memory.h>

#define cin in
#define cout out
#define MM 83000
ifstream cin("typing.in");
ofstream cout("typing.out");


int n;

char kis[51][502];
char inp[100002];


int dp[100010][52];
int chd[51][MM];
int nxt[51][MM];
char chdc[51][MM];
char nxtc[51][MM];
int nn[51];





void Load()
{
	cin >> n;
	cin.getline(kis[0],501);
	for ( int i = 0; i < n; i++)
	{
		cin.getline(kis[i],501);
	}
	cin.getline(inp,100001);

}



void MakeSuff( int cur)
{
	nn[cur] = 0;
	int ver, t;
	for(int i = 0; kis[cur][i] != 0; i++) {
		ver = 0;
		for (int j = i ; kis[cur][j] != 0; j++) {
			t = chd[cur][ver];
			if (t != 0 && chdc[cur][ver] != kis[cur][j]) {
				while ( nxt[cur][t] != 0 && nxtc[cur][t] != kis[cur][j]) t = nxt[cur][t];
				t = nxt[cur][t];
			}
			if (t == 0){
				nn[cur]++;
				nxt[cur][nn[cur]] = chd[cur][ver];
				nxtc[cur][nn[cur]] = chdc[cur][ver];
				chd[cur][ver] = nn[cur];
				chdc[cur][ver] = kis[cur][j];
				t = nn[cur];
			}
			ver = t;
		}

	}
}


int GetLen(int st, int cur) 
{
	int ver = 0;
	int len = 0;
	int t;
	for (len = 0; ver != 0 || len == 0; len++) {
		t = chd[cur][ver];
		if (t != 0 && chdc[cur][ver] != inp[st + len]) {
			while ( nxt[cur][t] != 0 && nxtc[cur][t] != inp[st + len]) t = nxt[cur][t];
			t = nxt[cur][t];
		}
		ver = t;
		if (ver == 0) break;
	}
	if ( ver + len == 0 ) return 0;
	return len;
}

void Solve()
{
	int i, j, k, cst, len;
	for ( i = 0; i < n; i++) 
	{
		MakeSuff(i);
	}
	memset( dp, -1, sizeof(dp));
	dp[0][n] = 0;
	for ( i = 0; inp[i] != 0; i++) {
		for ( j = 0; j <= n; j++) {
			if (dp[i][j] < 0) continue;
			if (dp[i + 1][j] < 0 || dp[i + 1][j] > dp[i][j]  + 1) dp[i + 1][j] = dp[i][j] + 1;
			for ( k = 0; k < n; k++) {
				cst = 2; if (k == j) cst--;
				len = GetLen( i, k);
				if (dp[i + len][k] < 0 || dp[i + len][k] > dp[i][j]  + cst) dp[i + len][k] = dp[i][j] + cst;
			}
		}
	}
	int ans = -1;
	for (j = 0; j <= n; j++) {
		if (dp[i][j] >= 0 && (ans < 0 || ans > dp[i][j])) ans = dp[i][j];
	}
	cout << ans;
}
int main()
{
	Load();
	Solve();
	return 0;
}