import java.io.*;
import java.util.*;
import java.math.*;

public class TwoStrings_vv_slow{
  
  public static final String FileName = "holytape";

  int DEBUG = 0;

  public int count(String s1, String s2){
    int n = s1.length();
    int m = s2.length();
    int st = 0;
    int res = 0;
    for (int i=0;i<n && i<m;i++){
      if (s1.charAt(i) == '1' && s2.charAt(i) == '1'){
        if (st == 0){
          st = 1; res++;
        }
      } else {
        st = 0;
      }
    }
    return res;
  }



  public void run() throws Exception{    
    Scanner in = new Scanner(new File(FileName+".in"));
    PrintWriter out = new PrintWriter(new File(FileName+".out"));
    String s1 = in.next(); s1 = s1+' ';
    String s2 = in.next(); s2 = s2+' ';
    String t1 = new String(s1);
    String t2 = new String(s2);
    int n = t1.length();
    int m = t2.length();
    int best = 0;
    for(int i=0; i<m;i++){
      int h = count(s1,s2);
      if (h>best) 
        best = h;
      s1 = ' '+s1;
    }
    for(int i=0; i<n;i++){
      int h = count(t1,t2);
      if (h>best) 
        best = h;
      t2 = ' '+t2;
    }
    out.println(best);
    out.close();
  }

  public static void main(String[] args) throws Exception{
    TwoStrings_vv_slow t = new TwoStrings_vv_slow();
    t.run();
  }
}