{$Q-,R-,S-}
Uses SysUtils,Math;
Const
  MaxLen=5000;
  HashBase=3137;
Type
  THashArr=Array[0..MaxLen]Of Integer;
Var
  S1,S2:String;
  I,A1,A2,A3:Integer;
  H1,H2,H3:Integer;
  Hash1,Hash2:THashArr;
  Pow:Array[0..MaxLen]Of Integer;

Procedure BuildHash(S:String; Var Hash:THashArr);
Var
  I:Integer;
Begin
  Hash[0]:=0;
  For I:=1 To Length(S) Do Hash[I]:=HashBase*Hash[I-1]+Ord(S[I]);
End;

Function GetSubHash(Var Hash:THashArr; Start,Length:Integer):Integer;
Begin
  Result:=Hash[Start+Length-1]-Hash[Start-1]*Pow[Length];
End;

Function Check(A1,A2,A3:Integer; H1,H2,H3:Integer):Boolean;
Begin
  Check:=(GetSubHash(Hash2,1,A1)=H1) And
         (GetSubHash(Hash2,A1+1,A2)=H2) And
         (GetSubHash(Hash2,A1+A2+1,A3)=H3);
End;

Begin
  ReSet(Input,'stragain.in');
  ReadLn(S1);
  ReadLn(S2);
  Close(Input);

  BuildHash(S1,Hash1);
  BuildHash(S2,Hash2);
  Pow[0]:=1;
  For I:=1 To Max(Length(S1),Length(S2)) Do Pow[I]:=HashBase*Pow[I-1];

  For A1:=1 To Length(S1)-2 Do
    For A2:=1 To Length(S1)-1-A1 Do Begin
      A3:=Length(S1)-A1-A2;
      H1:=GetSubHash(Hash1,1,A1);
      H2:=GetSubHash(Hash1,A1+1,A2);
      H3:=GetSubHash(Hash1,A1+A2+1,A3);
      If Check(A1,A2,A3,H1,H2,H3) Or
         Check(A1,A3,A2,H1,H3,H2) Or
         Check(A2,A1,A3,H2,H1,H3) Or
         Check(A2,A3,A1,H2,H3,H1) Or
         Check(A3,A1,A2,H3,H1,H2) Or
         Check(A3,A2,A1,H3,H2,H1) Then Begin
        ReWrite(Output,'stragain.out');
        WriteLn('YES');
        WriteLn(Copy(S1,1,A1));
        WriteLn(Copy(S1,A1+1,A2));
        WriteLn(Copy(S1,A1+A2+1,A3));
        Close(Output);
        Halt;
      End;
    End;

  ReWrite(Output,'stragain.out');
  WriteLn('NO');
  Close(Output);
End.