import java.io.*;
import java.util.*;
import java.math.*;

public class coins{
  
  public static final String FileName = "coins";

  int DEBUG = 0;
  int INFINITY = 1000000000;


  int[][] c;
  int[][] e;
  int[][] f;
  int[][] h;
  int[]   d;
  int[]   q;

  boolean[] gone;

  int m;
  int n;


  PrintWriter out;

  public void add(int x,int y,int z) throws Exception{
    c[x][q[x]] = z;
    f[x][q[x]] = 0;
    e[x][q[x]] = y;
    h[x][q[x]] = q[y];
    c[y][q[y]] = 0;
    f[y][q[y]] = 0;
    e[y][q[y]] = x;
    h[y][q[y]] = q[x];
    q[x]++;
    q[y]++;
  }

  public boolean poisk(int v) throws Exception{
    if (v==m*n+1)
      return true;
    gone[v] = true;
    for (int i=0; i<d[v];i++){
      int ee = e[v][i];
      if (!gone[ee] && f[v][i]<c[v][i] && poisk(ee)){
        f[v][i]++; f[ee][h[v][i]]--;
        return true;
      }
    }
    return false;
  }

  int h1;
  int h2;

  public void swap(int x, int y, int z){
    if (x==0){
      h1 = y;
      h2 = z;
    } else {
      out.println((h1+1)+" "+(z+1)+" "+(h2+1));
    }
  }
/*  public void swap(int x, int y, int z){
    if (x==0){
      out.print((y+1)+" "+(z+1));
    } else {
      out.println(" "+(z+1));
    }
  }*/
  int[] ss;
  int qq;

  public boolean find(int v) throws Exception{
    if (v==m*n+1)                
      return true;
    gone[v] = true;
    for (int i=0; i<d[v];i++){
      int ee = e[v][i];
      if (f[v][i]>0 && !gone[ee] && find(ee)){
//        System.out.print(v+" ");
        ss[qq] = v;
        qq++;
        f[v][i]--; f[ee][h[v][i]]++;
        return true;
      }
    }
    return false;
  }


  public void run() throws Exception{    
    Scanner in = new Scanner(new File(FileName+".in"));
    out = new PrintWriter(new File(FileName+".out"));
    n = in.nextInt();
    m = in.nextInt();
    int[][] a = new int[n][m];
    for(int i=0; i<n;i++)
      for(int j=0; j<m; j++)
        a[i][j] = in.nextInt();
    c = new int[m*n+2][];
    f = new int[m*n+2][];
    e = new int[m*n+2][];
    h = new int[m*n+2][];
    q = new int[m*n+2];
    d = new int[m*n+2];
    ss= new int[m*n+2];
    gone = new boolean[m*n+2];
    for(int i=0;i<m;i++){
      d[i] = 2*(n-1)+2;
    }
    for(int i=1;i<n;i++){
      for(int j=0;j<m;j++){
        d[i*m+j] = 2*m;
      }
    }
    for(int z=0;z<2; z++){
      d[m*n+z] = m;
    }
    for(int i=0;i<m*n+2;i++){
      c[i] = new int[d[i]];
      f[i] = new int[d[i]];
      e[i] = new int[d[i]];
      h[i] = new int[d[i]];
    }
    for(int i=0;i<m;i++){
      add(m*n,i,a[0][i]);
      add(i,m*n+1,1);
    }
    for(int i=1;i<n;i++){
      for(int j=0;j<m;j++){
        for(int k=0;k<m;k++) if (k!=j){
          add(m*i+j,m*i+k,INFINITY);
        }
        if (a[i][j]>0){
          add(m*i+j,j,a[i][j]-1);
          add(j,m*i+j,0);
        } else {
          add(m*i+j,j,0);
          add(j,m*i+j,1);
        }   
      }
    }
    int cc = 0;
    while (poisk(m*n)){
      cc++;
      for(int i=0; i<m*n+2;i++)
        gone[i] = false;
    }
    out.println(cc);
//    System.out.println("YEAH");
    for(int u=0; u<cc; u++) {
      qq = 0;
      for(int i=0; i<m*n+2;i++)
        gone[i] = false;
      if (!find(m*n)) 
        System.out.println("BOTVA");
      for(int i=qq-1; i>0; i--){
        int v = ss[i]; int ee = ss[i-1];
        if (v<m*n && ee<m*n && v/m!=ee/m){
          swap(v/m,ee/m,ee%m);
        }        
      }
//      System.out.println();
    }
    out.close();
  }

  public static void main(String[] args) throws Exception{
    coins t = new coins();
    t.run();
  }
}