#define _CRT_SECURE_NO_DEPRECATE
#pragma comment (linker, "/STACK:30000000")

#include <string>
#include <vector>
//#include <cmath>
//#include <queue>
//#include <set>
//#include <map>
#include <algorithm>
#include <iostream>
//#include <cstdio>
//#include <sstream>
#include <cassert>
//#include <utility>

using namespace std;

#define EPS 1E-8
const int INF = (int)1E+9;

#define C_IN_FILE "input.txt"
#define C_OUT_FILE "output.txt"

#define forn(i, n) for (int i = 0; i < (int)(n); ++i)
#define forv(i, v) for (int i = 0; i < (int)(v.size()); ++i)
#define fors(i, s) for (int i = 0; i < (int)(s.length()); ++i)
#define all(a) a.begin(), a.end()
#define pb push_back
#define PII pair<int, int>
#define mp make_pair
#define VI vector<int>
#define VS vector<string>

typedef int tar[100000];

int n, m, ans;
VI a, b;
vector< PII > res;
bool u[100000];
int sm = 0;
tar o, p;

void outdata() {
	printf("%d\n", res.size());
	forv(i, res) {
		printf("%d %d\n", b[res[i].first], b[res[i].second]);
	}
}

int num() {
	int ans = 0;
	memset(u, 0, sizeof(u[0]) * n);
	forn(e, n) {
		if (!u[e]) {
			++ans;
			int t = e;
			while (!u[t]) {
				u[t] = true;
				t = p[t];
			}
		}
	}
	return n - ans;
}

void solve() {
	res.clear();
	b = a;
	sort(all(b));
	assert(unique(all(b)) == b.end());
	forn(i, n) assert(0 <= b[i] && b[i] <= (int)1E+9);
	forn(i, n) p[i] = (int)(lower_bound(all(b), a[i]) - b.begin());
	forn(i, n) o[p[i]] = i;
	while (true) {
		int cur = num();
		if (cur == 0) break;
		bool ok = false;
		forn(i, n) {
			if (ok) break;
			for(int j = i + 1; j < n; ++j) {
				swap(p[o[i]], p[o[j]]);
				if (num() < cur) {
					res.pb(mp(i, j));
					swap(o[i], o[j]);
					ok = true;
					break;
				}
				swap(p[o[i]], p[o[j]]);
			}
		}
	}
	sort(all(res));
}

void readdata() {
	scanf("%d", &n);
	assert(n > 0);
	sm += n;
	a = VI(n, 0);
	forn(i, n) scanf("%d", &a[i]);
}

int main() {
    freopen(C_IN_FILE, "rt", stdin);
    freopen(C_OUT_FILE, "wt", stdout);
	int tst;
	scanf("%d", &tst);
	forn(ii, tst) {
		readdata();
		solve();
		outdata();
	}
	assert(1 <= sm && sm <= 100000);
	return 0;
}
