#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <cassert>
#include <memory>
#include <vector>
#include <algorithm>
#include <string>

using namespace std;

#define cinfile "brackets1.in"
#define coutfile "brackets1.out"
#define forn(i, n) for (i = 0; i < (int)(n); ++i)
#define foro(i, n) for (i = 1; i <= (int)(n); ++i)

#define f0(a) memset(a, 0, sizeof(a))
#define VI vector<int>
#define pb push_back
#define all(a) a.begin(), a.end()

const int inf = (int)1e+9;
const double eps = (double)1e-9;

const int nmax = 20001;
                     
char a[nmax];
char st[nmax];
char ans[nmax];
int n, size;

char upcase(char x)
{
    return (x - 'a') + 'A';
}

int main()
{
    freopen(cinfile, "rt", stdin);
    freopen(coutfile, "wt", stdout);

    int i;
    fgets(a, nmax, stdin);
    n = strlen(a);
    if (a[n - 1] == '\n') --n;
    forn(i, n) {
        ans[i] = upcase(a[i]);
    }

    size = 0;
    forn(i, n) {
        if (size == 0) st[size++] = a[i];
        else {
            if (st[size - 1] == a[i]) {
                ans[i] = a[i];
                --size;
            } else st[size++] = a[i];
        }
    }
    if (size == 0) {
        forn(i, n) {
            printf("%c", ans[i]);
        }
    } else {
        printf("IMPOSSIBLE");
    }

    return 0;
}
