{$MAXSTACKSIZE $11111111}
{$APPTYPE CONSOLE}
{$D-,I-,L-,Q-,R-,S-,O+,H+}
  Uses SysUtils;
  Const Task_ID='brackets2';
        File_In=Task_ID+'.in';
        FIle_Out=Task_ID+'.out';
        MaxLen=100000;
  Type Int=LongInt;
  Var S:String;
      Cnt:Array['a'..'z']Of Int;
      Sum:Array[0..MaxLen]Of Boolean;
      Brackets:Array['a'..'z']Of Int;
      CntSym:Array[1..MaxLen]Of Int;
      BracketsSum:Int;
      Cnt1,Cnt2,LenS2:Int;
                                 
Procedure OpenFiles;
Begin
  Assign(Input,File_In);
  ReSet(Input);
  Assign(Output,File_Out);
  ReWrite(Output);
End;

Procedure Init;
Begin
  Read(S);
End;

Function FindAns(I:Int):Boolean;
Begin
  FindAns:=False;
  If I>Length(S) Then Begin
    If BracketsSum=0 Then FindAns:=True
    Else FindAns:=False;
    Exit;
  End;
  If BracketsSum<0 Then Exit;
  If Brackets[S[I]]=0 Then Begin
    Brackets[S[I]]:=1;
    Inc(BracketsSum,CntSym[I]);
    Inc(Cnt1,Cnt[S[I]]);
    If (Cnt1<=LenS2) And {(BracketsSum<Length(S)-I) And }FindAns(I+CntSym[I]) Then Begin
      FindAns:=True;
      Exit;
    End;
    Dec(Cnt1,Cnt[S[I]]);
    Brackets[S[I]]:=-1;
    Dec(BracketsSum,2*CntSym[I]);
    Inc(Cnt2,Cnt[S[I]]);
    If (Cnt2<=LenS2) And FindAns(I+CntSym[I]) Then Begin
      FindAns:=True;
      Exit;
    End;
    Inc(BracketsSum,CntSym[I]);
    Dec(Cnt2,Cnt[S[I]]);
    Brackets[S[I]]:=0;
  End
  Else Begin
    Inc(BracketsSum,Brackets[S[I]]*CntSym[I]);
    If FindAns(I+CntSym[I]) Then Begin
      FindAns:=True;
      Exit;
    End;
    Dec(BracketsSum,Brackets[S[I]]*CntSym[I]);
  End;
End;

Procedure Solve;
  Var I,J:Int;
      Sym:Char;
Begin
  FillChar(Brackets,SizeOf(Brackets),False);
  FillChar(Cnt,SizeOf(Cnt),0);
  FillChar(CntSym,SizeOf(CntSym),False);
  FillChar(Sum,SizeOf(Sum),False);
  For I:=1 To Length(S) Do
    Inc(Cnt[S[I]]);
  J:=0;
  Sum[0]:=True;
  For Sym:='a' To 'z' Do Begin
    For I:=J DownTo 0 Do
      Sum[I+Cnt[Sym]]:=Sum[I+Cnt[Sym]] Or Sum[I];  
    Inc(J,Cnt[Sym]);
  End;
  If Odd(Length(S)) Or Not Sum[Length(S) Div 2]  Or (S[1]=S[Length(S)]) Then Begin
    WriteLn('IMPOSSIBLE');
    Exit;
  End;
  CntSym[Length(S)]:=1;
  J:=Length(S);
  For I:=Length(S)-1 DownTo 1 Do
    If S[I]<>S[I+1] Then Begin
      CntSym[I]:=1;
      J:=I+1;
    End
    Else CntSym[I]:=J-I;
  Brackets[S[1]]:=1;
  Brackets[S[Length(S)]]:=-1;
  BracketsSum:=0;
  Cnt1:=Cnt[S[1]];
  Cnt2:=Cnt[S[Length(S)]];
  LenS2:=Length(S) Div 2;
  If Not FindAns(1)Then
    WriteLn('IMPOSSIBLE')
  Else Begin
    For I:=1 To Length(S) Do
      If Brackets[S[I]]=1 Then
        S[I]:='('
      Else S[I]:=')';
    WriteLn(S);
  End;
End;

Procedure CloseFiles;
Begin
  Close(Input);
  Close(Output);
End;

Begin
  OpenFiles;
  Init;
  Solve;
  CloseFiles;
End.