type
  int = longint;

var
  l: int;
  a: array[1..200] of int;
  am: array[1..3] of int;

procedure print;
var
  i: int;
begin
  for i := 1 to l do
  begin
    write(chr(ord('a') + a[i] - 1));
  end;
  writeln;
end;

procedure color(x: int);
var
  c: int;
begin
  if (a[x] = a[x + 1]) then
    exit;
  c := a[x] xor a[x + 1];
  dec(am[a[x]]);
  dec(am[a[x + 1]]);
  inc(am[c], 2);
  a[x] := c;
  a[x + 1] := c;
  print;
end;

procedure solve(s: string);
var
  rs, gs, bs, i, j, m: int;
  num: array['B'..'R'] of int;
  better: boolean;
begin
  l := length(s);
  rs := 0; gs := 0; bs := 0;
  for i := 1 to l do
  begin
    case s[i] of
      'R': inc(rs);
      'G': inc(gs);
      'B': inc(bs);
    end;
  end;
  rs := rs mod 3;
  gs := gs mod 3;
  bs := bs mod 3;
  if (rs xor gs xor bs = 3) then
  begin
    writeln('Impossible');
    exit;
  end;
  if (rs = gs) then
  begin
    num['R'] := 1;
    num['G'] := 2;
    num['B'] := 3;
  end
  else if (rs = bs) then
  begin
    num['B'] := 1;
    num['R'] := 2;
    num['G'] := 3;
  end
  else
  begin
    num['G'] := 1;
    num['B'] := 2;
    num['R'] := 3;
  end;
  fillchar(am, sizeof(am), 0);
  for i := 1 to l do
  begin
    a[i] := num[s[i]];
    inc(am[a[i]]);
  end;
  print;
  if (am[1] = l) or (am[2] = l) or (am[3] = l) then
    exit;
  if (am[1] * am[2] * am[3] = 1) then
  begin
    color(1);
    exit;
  end;
  while (am[1] + am[2] > 0) do
  begin
    for i := 1 to l - 1 do
    begin
      if (a[i] xor a[i + 1] = 3) then
        color(i);
    end;

    if (am[1] > am[2]) then
    begin
      i := 0;
      repeat
        inc(i);
      until (a[i] * a[i + 1] = 3);
      color(i);
      continue;
    end;

    if (am[1] < am[2]) then
    begin
      i := 0;
      repeat
        inc(i);
      until (a[i] * a[i + 1] = 6);
      color(i);
      continue;
    end;

    better := false;
    for j := l downto 1 do if (a[j] < 3) then
    begin
      i := j;
      while (i + 2 <= l) and (a[i + 1] * a[i + 2] = 9) do
      begin
        color(i);
        color(i + 1);
        color(i);
        inc(i, 2);
      end;
      if (i + 1 <= l) and (a[i] xor a[i + 1] = 3) then
      begin
        color(i);
        better := true;
        break;
      end;
    end;
    if better or (am[1] + am[2] = 0) then
      continue;

    m := l;
    repeat
      dec(m);
    until (a[m] = 3) and (a[m + 1] < 3);
    dec(m, 2);  

    if (m <= 0) then
    begin
      writeln('assertion 239 :)');
      exit;
    end;

    if (a[m] = 3) then
    begin
      color(m);
      color(m + 1);
      color(m);
      color(m + 2);
      continue;
    end;

    color(m + 1);
    color(m);
    color(m + 1);
    color(m + 2);
    continue;
  end;
end;

var
  s: string;

begin
  reset(input, 'threecolors.in');
  readln(s);
  solve(s);
end.