{$R+,Q+,S+,H+}
Const
  MaxLen=300;
  TaskID='cipher';
  InFile=TaskID+'.in';
  OutFile=TaskID+'.out';
  Infinity='!';
Var
  S,Res:String;
  MinChar,MaxChar:Array[1..MaxLen+1,0..MaxLen]Of Char;
  Best:Array[1..MaxLen+1,0..MaxLen,Boolean]Of String;

Function SBest(A,B:String):String;
Begin
  If A=Infinity Then SBest:=B Else If B=Infinity Then SBest:=A Else
    If Length(A)<Length(B) Then SBest:=A Else If Length(A)>Length(B) Then SBest:=B Else
      If A<B Then SBest:=A Else SBest:=B;
End;

Procedure GetBest(At:Integer; Len:Integer);
Var
  I:Integer;
  Cur:String;
Begin
  If Best[At,Len,False]<>'' Then Exit;

  If Len=1 Then Begin
    Best[At,Len,False]:=S[At];
    Best[At,Len,True]:=S[At];
    Exit;
  End;

  Best[At,Len,False]:=Infinity;
  Best[At,Len,True]:=Infinity;

  For I:=1 To Len-1 Do If (MaxChar[At,I]<=MinChar[At+I,Len-I]) Or (MinChar[At,I]>=MaxChar[At+I,Len-I]) Then Begin
    GetBest(At,I);
    GetBest(At+I,Len-I);
    If (Best[At,I,False]<>Infinity) And (Best[At+I,Len-I,False]<>Infinity) Then Begin
      If MaxChar[At,I]<=MinChar[At+I,Len-I] Then Begin
        Cur:=Best[At,I,False]+Best[At+I,Len-I,False];
        Best[At,Len,False]:=SBest(Best[At,Len,False],Cur);
      End;       
      If MinChar[At,I]>=MaxChar[At+I,Len-I] Then Begin
        Cur:=Best[At+I,Len-I,True]+Best[At,I,True];
        Best[At,Len,True]:=SBest(Best[At,Len,True],Cur);
      End;
    End;
  End;

  If Best[At,Len,False]<>Infinity Then
    Best[At,Len,True]:=SBest(Best[At,Len,True],'['+Best[At,Len,False]+']');
  If Best[At,Len,True]<>Infinity Then
    Best[At,Len,False]:=SBest(Best[At,Len,False],'['+Best[At,Len,True]+']');
End;

Procedure FillMinMaxChars;
Var
  I,J:Integer;
  Ch,CMin,CMax:Char;
Begin
  For I:=1 To Length(S)+1 Do Begin 
    CMin:=High(Char);
    CMax:=Low(Char);
    For J:=0 To Length(S)+1-I Do Begin
      If J>0 Then Begin
        Ch:=S[I+J-1];
        If Ch>CMax Then CMax:=Ch;
        If Ch<CMin Then CMin:=Ch;
      End;
      MinChar[I,J]:=CMin;
      MaxChar[I,J]:=CMax;
    End;
  End;
End;

Begin
  ReSet(Input,InFile);
  ReadLn(S);
  Close(Input);
  FillChar(Best,SizeOf(Best),0);
  FillMinMaxChars;
  GetBest(1,Length(S));
  Res:=Best[1,Length(S),False];
  If Res=Infinity Then Res:='NO SOLUTION';
  ReWrite(Output,OutFile);
  WriteLn(Res);
  Close(Output);
End.
