#define _CRT_SECURE_NO_DEPRECATE
#pragma comment (linker, "/STACK:30000000")

#include <string>
#include <vector>
//#include <cmath>
//#include <queue>
//#include <set>
//#include <map>
//#include <algorithm>
#include <iostream>
//#include <cstdio>
//#include <sstream>
#include <cassert>
//#include <utility>

using namespace std;

#define EPS 1E-8
const int INF = (int)1E+9;

#define C_IN_FILE "towns.in"
#define C_OUT_FILE "towns.out"

#define forn(i, n) for (int i = 0; i < (int)(n); ++i)
#define forv(i, v) for (int i = 0; i < (int)(v.size()); ++i)
#define fors(i, s) for (int i = 0; i < (int)(s.length()); ++i)
#define all(a) a.begin(), a.end()
#define pb push_back
#define PII pair<int, int>
#define mp make_pair
#define VI vector<int>
#define VS vector<string>

#define ALPH 26
#define MMAX 1100
#define LITTLE 20

struct edge {
	int u, v;
	edge() {}
	edge(int u, int v) {
		this->u = u;
		this->v = v;
	}
};

int n, m, ans;

int g[ALPH][ALPH];
int win[ALPH], s;
bool u[ALPH];
int kedge;
edge e[MMAX];
bool winE[1 << LITTLE][ALPH];
int degIn[ALPH], degOut[ALPH];


void outdata() {
}

void go(int v) {
	if (u[v]) return ;
	u[v] = true;
	forn(i, n) {
		forn(j, g[v][i]) {
			e[kedge++] = edge(v, i);
			go(i);	
		}
	}
}

bool littleEdges() {
	kedge = 0;
	memset(u, 0, sizeof u);
	go(s);
	if (kedge > LITTLE) return false;
	memset(winE, 0, sizeof winE);
	forn(msk, 1 << kedge) {
  		forn(r, kedge) {
  			if (msk & (1 << r)) {
  				if (!winE[msk ^ (1 << r)][e[r].v]) {
  					winE[msk][e[r].u] = true;
  				}
  			}
  		}
	}
	int msk = (1 << kedge) - 1;
   	forn(r, kedge) {
		if (e[r].u == s && !winE[msk ^ (1 << r)][e[r].v]) {
			printf("%c\n", e[r].v + 'a');
			return true;
		}
   	}
   	forn(r, kedge) {
		if (e[r].u == s) {
			printf("%c\n", e[r].v + 'a');
			return true;
		}
   	}
	return false;
}

void stupid() {
  	forn(i, n) forn(j, n) {
  		degIn[j] += g[i][j];
  		degOut[i] += g[i][j];
  	}
  	int t = -1, mn = INF;
  	forn(j, n) if (g[s][j] > 0 && win[j] == -1) {
  		if (mn > degOut[j]) {
  			t = j;
  			mn = degOut[j];
  		}
  	}
  	if (t == -1) {
     	forn(j, n) if (g[s][j] > 0) {
     		if (mn > degOut[j]) {
     			t = j;
     			mn = degOut[j];
     		}
     	}
  	}
	printf("%c\n", t + 'a');
}


void solve() {
	memset(win, 255, sizeof win);
	forn(ii, n) {
    	forn(i, n) if (win[i] == -1) {
    		int kw[3];
    		memset(kw, 0, sizeof kw);
    		forn(j, n) if (g[i][j] > 0) ++kw[win[j] + 1];
    		if (kw[1] > 0) win[i] = 1; else {
    			if (kw[0] == 0) win[i] = 0;
    		}
    	}
	}
	if (win[s] == -1) {
		if (littleEdges()) return ;
		stupid();
	} else {
		if (win[s] == 1) {
			forn(j, n) if (g[s][j] > 0 && win[j] == 0) {
				printf("%c\n", j + 'a');
				return ;
			}
		} else {
			forn(j, n) if (g[s][j] > 0) {
				printf("%c\n", j + 'a');
				return ;
			}
		}
	}
}

void readdata() {
	n = ALPH;
	forn(i, n) forn(j, n) scanf("%d", &g[i][j]);
	s = getchar();
	while (s <= ' ') s = getchar();
	s -= 'a';
}

int main() {
    freopen(C_IN_FILE, "rt", stdin);
    freopen(C_OUT_FILE, "wt", stdout);
	readdata();
	solve();
	outdata();
	return 0;
}

