#include <cstdio>

#define MAX(a, b) ((a)<(b)?(b):(a))
#define MIN(a, b) ((a)<(b)?(a):(b))

char c[300][300], tmp;
int m, n, i, j;

void op(int i, int j){
  if (c[i][j]==c[i+1][j]&&c[i][j]==c[i][j+1]&&c[i][j]==c[i+1][j+1]) return;
  printf("%d %d\n", i+1, j+1);
  char col[3]={0, 0, 0}, mc;
  col[c[i][j]]++;
  col[c[i][j+1]]++;
  col[c[i+1][j]]++;
  col[c[i+1][j+1]]++;
  if (col[0]>col[1]&&col[0]>col[2]) mc=0;
  if (col[1]>col[0]&&col[1]>col[2]) mc=1;
  if (col[2]>col[0]&&col[2]>col[1]) mc=2;
  if (col[1]==2&&col[2]==2) mc=0;
  if (col[0]==2&&col[2]==2) mc=1;
  if (col[0]==2&&col[1]==2) mc=2;
  c[i][j]=c[i][j+1]=c[i+1][j]=c[i+1][j+1]=mc;
}

void movedown(int i){
  if (c[i+1][0]!=c[i+1][1]||c[i+1][0]==c[i][0]){
    op(i, 0);
    op(i, 1);
  } else if (c[i+1][1]!=c[i+1][2]||c[i+1][1]==c[i][0]){
    op(i, 1);
    op(i, 0);
  } else {
    op(i, 0);
    op(i-1, 1);
    op(i-1, 0);
    op(i, 1);
    op(i, 0);
  }
}

void moveright(int i){
  if (c[0][i+1]!=c[1][i+1]||c[0][i+1]==c[0][i]){
    op(0, i);
    op(1, i);
  } else if (c[1][i+1]!=c[2][i+1]||c[1][i+1]==c[0][i]){
    op(1, i);
    op(0, i);
  } else {
    op(0, i);
    op(1, i-1);
    op(0, i-1);
    op(1, i);
    op(0, i);
  }
}

int main(){
  freopen("threecolors.in", "rt", stdin);
  freopen("threecolors.out", "wt", stdout);
  scanf("%d%d\n", &n, &m);
  for (i=0; i<n; i++){
    for (j=0; j<m; j++){
      scanf("%c", &tmp);
      if (tmp=='R') c[i][j]=0;
      if (tmp=='G') c[i][j]=1;
      if (tmp=='B') c[i][j]=2;
    }
    scanf("\n");
  }
  op(0, 0);
  if (c[0][2]!=c[1][2]||c[0][2]==c[0][0]){
    op(0, 1);
    movedown(1);
  } else if (c[2][0]!=c[2][1]||c[2][0]==c[0][0]){
    op(1, 0);
    moveright(1);
  } else {
    op(0, 1);
    op(1, 1);
    op(1, 0);
    op(0, 0);
    op(0, 1);
  }
  for (i=2; i<n-1; i++) movedown(i);
  for (j=2; j<m-1; j++){
    moveright(j);
    for (i=2; i<n-1; i++) op(i, j);
  }
  for (i=0; i<n; i++)
    for (j=0; j<m; j++)
      while (c[i][j]!=c[0][0]);
  /*for (i=0; i<n; i++){
    for( j=0; j<m; j++)
      printf("%d", c[i][j]);
    printf("\n");
  }*/
  return 0;
}

