{ $DEFINE DEBUG}
{$H+}
{$IFDEF DEBUG}
{$C+,I+,Q+,R+,S+}
{$ELSE}
{$C-,I-,Q-,R-,S-}
{$ENDIF}
const taskid='threecolors';
      infile=taskid+'.in';
      outfile=taskid+'.out';
type tfield=array [1..100,1..100] of char;
var n,m,i,j,k,todo,donex,doney,qq,qleft,qright,ccode:longint;
    map,help,temp:tfield;
    ok,dowrite:boolean;
    was:array [0..20000] of boolean;
    queue,last,lox,loy:array [0..20000] of longint;
procedure apply(var a:tfield;i,j:longint);
var cnt:array ['A'..'Z'] of longint;
begin
  if dowrite then
    writeln(i,' ',j);
  fillchar(cnt,sizeof(cnt),0);
  inc(cnt[a[i,j]]);
  inc(cnt[a[i,j+1]]);
  inc(cnt[a[i+1,j]]);
  inc(cnt[a[i+1,j+1]]);
  if (cnt['R']>cnt['G']) and (cnt['R']>cnt['B']) then
  begin
    a[i,j]:='R';
    a[i+1,j]:='R';
    a[i,j+1]:='R';
    a[i+1,j+1]:='R';
    exit;
  end;
  if (cnt['G']>cnt['R']) and (cnt['G']>cnt['B']) then
  begin
    a[i,j]:='G';
    a[i+1,j]:='G';
    a[i,j+1]:='G';
    a[i+1,j+1]:='G';
    exit;
  end;
  if (cnt['B']>cnt['R']) and (cnt['B']>cnt['G']) then
  begin
    a[i,j]:='B';
    a[i+1,j]:='B';
    a[i,j+1]:='B';
    a[i+1,j+1]:='B';
    exit;
  end;
  if (cnt['R']=2) and (cnt['G']=2) then
  begin
    a[i,j]:='B';
    a[i+1,j]:='B';
    a[i,j+1]:='B';
    a[i+1,j+1]:='B';
    exit;
  end;
  if (cnt['R']=2) and (cnt['B']=2) then
  begin
    a[i,j]:='G';
    a[i+1,j]:='G';
    a[i,j+1]:='G';
    a[i+1,j+1]:='G';
    exit;
  end;
  if (cnt['G']=2) and (cnt['B']=2) then
  begin
    a[i,j]:='R';
    a[i+1,j]:='R';
    a[i,j+1]:='R';
    a[i+1,j+1]:='R';
    exit;
  end;
  assert(false);
end;
procedure dorow;
var i,j:longint;
    ok:boolean;
begin
  {donex+1,1..doney}
  ok:=false;
  for i:=1 to doney-1 do
    if map[donex+1,i]<>map[donex+1,i+1] then
      ok:=true;
  if not ok then
  begin
    apply(map,donex,1);
    apply(map,donex-1,2);
    apply(map,donex-1,1);
  end;
  for i:=1 to doney-1 do
    if map[donex+1,i]<>map[donex+1,i+1] then
    begin
      apply(map,donex,i);
      for j:=i-1 downto 1 do
        apply(map,donex,j);
      for j:=i+1 to doney-1 do
        apply(map,donex,j);
      inc(donex);
      exit;
    end;
  inc(donex);
end;
procedure docol;
var ok:boolean;
    i,j:longint;
begin
  {1..donex,doney+1}
  ok:=false;
  for i:=1 to donex-1 do
    if map[i,doney+1]<>map[i+1,doney+1] then
      ok:=true;
  if not ok then
  begin
    apply(map,1,doney);
    apply(map,2,doney-1);
    apply(map,1,doney-1);
  end;
  for i:=1 to donex-1 do
    if map[i,doney+1]<>map[i+1,doney+1] then
    begin
      apply(map,i,doney);
      for j:=i-1 downto 1 do
        apply(map,j,doney);
      for j:=i+1 to donex-1 do
        apply(map,j,doney);
      inc(doney);
      exit;
    end;
  inc(doney);
end;
function letter2int(c:char):longint;
begin
  case c of
    'R':letter2int:=0;
    'G':letter2int:=1;
    'B':letter2int:=2;
  end;
end;
function field2int(var a:tfield):longint;
var res,i,j:longint;
begin
  res:=0;
  for i:=1 to 3 do
    for j:=1 to 3 do
      res:=res*3+letter2int(a[i,j]);
  field2int:=res;
end;
procedure fill(var a:tfield;ch:char);
var i,j:longint;
begin
  for i:=1 to 3 do
    for j:=1 to 3 do
      a[i,j]:=ch;
end;
procedure update(x,p,lx,ly:longint);
begin
  if not was[x] then
  begin
    was[x]:=true;
    last[x]:=p;
    lox[x]:=lx;
    loy[x]:=ly;
    inc(qright);
    queue[qright]:=x;
  end;
end;
function int2letter(x:longint):char;
begin
  case x of
    0:int2letter:='R';
    1:int2letter:='G';
    2:int2letter:='B';
  end;
end;
procedure int2field(code:longint;var a:tfield);
var i,j:longint;
begin
  for i:=3 downto 1 do
    for j:=3 downto 1 do
    begin
      a[i,j]:=int2letter(code mod 3);
      code:=code div 3;
    end;
end;
procedure copy(var src,dst:tfield);
var i,j:longint;
begin
  for i:=1 to 3 do
    for j:=1 to 3 do
      dst[i,j]:=src[i,j];
end;
procedure restore(code:longint);
begin
  if last[code]<>-1 then
  begin
    restore(last[code]);
    apply(map,lox[code],loy[code]);
  end;
end;
begin
  assign(input,infile);
  reset(input);
  assign(output,outfile);
  rewrite(output);
  readln(n,m);
  for i:=1 to n do
  begin
    for j:=1 to m do
      read(map[i,j]);
    readln;
  end;
  dowrite:=false;
  for qq:=0 to 3*3*3*3*3*3*3*3*3-1 do
    was[qq]:=false;
  qleft:=1;
  qright:=0;
  update(field2int(map),-1,0,0);
  while qleft<=qright do
  begin
    ccode:=queue[qleft];
    inc(qleft);
    int2field(ccode,help);
    for i:=1 to 2 do
      for j:=1 to 2 do
      begin
        copy(help,temp);
        apply(temp,i,j);
        update(field2int(temp),ccode,i,j);
      end;
  end;
  dowrite:=true;
  fill(help,'R');
  if was[field2int(help)] then
    restore(field2int(help))
  else begin
    fill(help,'G');
    if was[field2int(help)] then
      restore(field2int(help))
    else begin
      fill(help,'B');
      if was[field2int(help)] then
        restore(field2int(help))
      else assert(false);
    end;
  end;
  donex:=3;
  doney:=3;
  for i:=4 to n do
    dorow;
  for i:=4 to m do
    docol;
  for i:=1 to n do
    for j:=1 to m do
      assert(map[i,j]=map[1,1]);
  close(input);
  close(output);
end.
