{$IFDEF NORMAL}
  {$I-,Q-,R-,S-}
{$ENDIF NORMAL}
{$IFDEF DEBUG}
  {$I+,Q+,R-,S-}
{$ENDIF DEBUG}
{$IFDEF RELEASE}
  {$I-,Q-,R-,S-}
{$ENDIF RELEASE}
const namein='threecolors.in';
      nameout='threecolors.out';
      NMax=110;
      CMax=10;
      CA='R';
      CB='B';
      CC='G';
type
 TGrid=array [1..NMax,1..NMax] of integer;
 TMask=array [0..2] of integer;
 TRes=array [1..Sqr(NMax)*CMax,1..2] of integer;
var x,y:TGrid;
    v,Sol:TRes;
    n,m,q,TSol:integer;

procedure Init;
var i,j:integer;
    s:string;
begin
 assign(input,namein);
 reset(input);
 readln(n,m);
 for i:=1 to n do begin
   readln(s);
   for j:=1 to m do
    case s[j] of
      CA:x[i,j]:=0;
      CB:x[i,j]:=1;
      CC:x[i,j]:=2
     end
  end;
 close(input)
end;

procedure AddRes(const i,j:integer);
begin
 inc(q);
 v[q,1]:=i;
 v[q,2]:=j
end;

function Analize(const a,b,c:integer):boolean;
var w:TMask;
    Ok:boolean;
    i,j:integer;
begin
 fillchar(w,sizeof(w),0);
 for i:=a to a+1 do
  for j:=b to b+1 do
   inc(w[y[i,j]]);
 Ok:=true;
 for i:=0 to 2 do
  if i<>c then Ok:=Ok and (w[i]<w[c]);
 if not Ok then begin
   Ok:=true;
   for i:=0 to 2 do
    if i<>c then Ok:=Ok and (w[i]=2)
  end;
 Ok:=Ok and (w[c]<4);
 Analize:=Ok
end;

procedure Colored(const a,b,c:integer);
var i,j:integer;
begin
 for i:=a to a+1 do
  for j:=b to b+1 do
   y[i,j]:=c
end;

function Check(const c:integer):boolean;
var i,j:integer;
    Ok:boolean;
begin
 Ok:=true;
 for i:=1 to n do
  for j:=1 to m do
   Ok:=Ok and (y[i,j]=c);
 Check:=Ok
end;

procedure Solve;
var c,k,i,j:integer;
begin
 for c:=0 to 2 do begin
   y:=x; q:=0;
   for k:=1 to CMax do
    for i:=1 to n-1 do
     for j:=1 to m-1 do
      if Analize(i,j,c) then begin
        AddRes(i,j);
        Colored(i,j,c);
       end;
   if Check(c) then begin
     Sol:=v;
     TSol:=q;
     Exit
    end
  end
end;

procedure Done;
var i:integer;
begin
 assign(output,nameout);
 rewrite(output);
 for i:=1 to TSol do
  writeln(Sol[i,1],' ',Sol[i,2]);
 close(output)
end;

begin
 Init;
 Solve;
 Done
end.
