#include <stdio.h>
#include <memory.h>
#include <string.h>
#include <stack>

struct Col {
	int x, y;
};

#define SIZE 3010
inline int min2(int a, int b) { return (a<b ? a : b); }

int m, n;
bool matr[SIZE][SIZE];
int ys[2][SIZE];
long long res;
Col st[SIZE];
int stn;

long long getRes(int *arr) {
	long long locres = 0;
	int i;
	Col nc;
	stn = 0;
	nc.x = 0;  nc.y = 0;
	st[stn] = nc;
	stn++;
	for (i = 1; i<=n+1; i++) {
		nc.x = i;  nc.y = arr[i];
		st[stn] = nc;
		while (st[stn-1].y > st[stn].y) {
			long long tinc = (i - st[stn-1].x);
			tinc = tinc*(tinc+1) / 2;
			if (st[stn-2].y >= st[stn].y)
				locres += tinc * (st[stn-1].y - st[stn-2].y);
			else
				locres += tinc * (st[stn-1].y - st[stn].y);
			stn--;
			st[stn].y = st[stn+1].y;
			st[stn+1].x = 0;  st[stn+1].y = 0;
		}
		stn++;
	}
	return locres;
}

int main(int argc, char **argv) {
    freopen("rect.in", "r", stdin);
    freopen("rect.out", "w", stdout);
    scanf("%d%d\n", &m, &n);
	int i, j;
	for (i = 1; i<=m; i++) {
		for (j = 1; j<=n; j++) {
			char ch;
			scanf("%c", &ch);
			matr[i][j] = (ch=='B');
		}
		scanf("\n");
	}
	res = 0;
	for (i = 1; i<=m; i++) {
		memcpy(ys[0], ys[1], sizeof(ys[0]));
		memset(ys[1], 0, sizeof(ys[1]));
		for (j = 1; j<=n; j++) {
			if (matr[i][j])
				ys[1][j] = 0;
			else
				ys[1][j] = ys[0][j] + 1;
		}
		res += getRes(ys[1]);
	}
	printf("%Ld", res);
    return 0;
}
