#include <stdio.h>
#include <memory.h>
#include <string.h>

int n, p, h;
int best[1010];
double res;

bool used[1010];
int curr[1010];
double ct, csum;

void Solve(int u) {
	if (ct >= res) return;
	if (u>n) {
		res = ct;
		memcpy(best, curr, (n+1)*sizeof(int));
		return;
	}
	int i, j;
	for (j = 0; j<(n+1)/2; j++) {
		i = j+1;
		if (!used[i]) {
			used[i] = true;
			curr[u] = i;
			double inc = 1.0 / (curr[u-1]-1<i ? i : curr[u-1]-1);
			if ((u!=h) || (inc>=1.0/h)) {
			ct += inc;
			csum -= 1/i;
			Solve(u+1);
			csum += 1/i;
			ct -= inc;
			}
			curr[u] = 0;
			used[i] = false;
		}
		i = n-j;
		if (!used[i]) {
			used[i] = true;
			curr[u] = i;
			double inc = 1.0 / (curr[u-1]-1<i ? i : curr[u-1]-1);
			if ((u!=h) || (inc>=1.0/h)) {
			ct += inc;
			csum -= 1/i;
			Solve(u+1);
			csum += 1/i;
			ct -= inc;
			}
			curr[u] = 0;
			used[i] = false;
		}
	}
}

int main(int argc, char **argv) {
	freopen("skier.in", "r", stdin);
	freopen("skier.out", "w", stdout);
	int i;
	scanf("%d%d%d", &n, &p, &h);
	res = n*2;
	for (i = 1; i<=n; i++)
		csum += 1.0/i;
	Solve(1);
	for (i = 1; i<=n; i++)
		printf("%d ", best[i]);
	return 0;
}
