type integer = longint;
var m, n : integer;
	cma : array[1..3100, 1..3100] of char;
	ma : array[1..3100, 1..3100] of byte;

procedure Load;
var i, j : integer;
begin
	readln(m, n);
	for i := 1 to m do begin
		for j := 1 to n do begin
			read(cma[i, j]);
			if cma[i, j] = 'W' then ma[i, j] := 1
			else ma[i, j] := 0;
		end;
		readln;
	end;
end;

var rgt: array[1..3100, 1..3100] of integer;
	gm, d, was, rr : array[0..3100] of integer;
	nr : integer;

procedure Qsort(be, en : integer);
var l, r, x, t : integer;
begin
	l := be;
	r := en;
	x := rr[l + random(r - l + 1)];
	while l < r do begin
		while x > rr[l] do inc(l);
		while x < rr[r] do dec(r);
		if l <= r then begin
			t := rr[l];
			rr[l] := rr[r];
			rr[r] := t;
			inc(l);
			dec(r);
		end;
	end;
	if be < r then Qsort(be, r);
	if l < en then Qsort(l, en);
end;

function Find(val : integer) : integer;
var l, r, mid : integer;
begin
	l := 1;
	r := nr;
	while l <= r do begin
		mid := (l + r) div 2;
		if rr[mid] = val then begin
			Find := mid;
			exit;
		end;
		if rr[mid] < val then l := mid + 1
		else r := mid - 1;
	end;
	Find := 0;
end;

procedure Solve;
var cur, i, j, ii, cinc, k : integer;
	ares, cres : int64;
begin	
	fillchar(rgt, sizeof(rgt), 0);
	for i := m downto 1 do begin
		for j := n downto 1 do begin
			if ma[i, j] = 0 then rgt[i, j] := 0
			else rgt[i, j] := rgt[i, j + 1] + 1;
		end;
	end;
	ares := 0;
	for i := n downto 1 do begin
		{fill rr}
		for j := 1 to m do rr[j] := rgt[j, i];
		Qsort(1, m);
		nr := 1;
		for j := 2 to m do begin
			if rr[j] <> rr[nr] then begin
				inc(nr);
				rr[nr] := rr[j];
			end;
		end;
		fillchar(was, sizeof(was), 0);
		fillchar(d, sizeof(d), 0);
        fillchar(gm, sizeof(gm), 0);
        cur := 1;
        rr[nr + 1] := 3001;
        for j := 1 to n do begin
        	while rr[cur] < j do inc(cur);
            gm[j] := cur;
        end;
		for j := m downto 1 do begin
			for ii := 1 to nr do inc(d[ii]);
			{for O(N^3)}
			cres := 0;
			k := Find(rgt[j, i]);
			for ii := k + 1 to nr do d[ii] := 0;
			for ii := 1 to n do begin
				inc(cres, d[gm[ii]]);
			end;
			inc(ares, cres);
		end;
	end;
	write(ares);
end;

begin
	assign(input, 'rect.in');
	assign(output, 'rect.out');
	reset(input);
	rewrite(output);
	Load;
	Solve;
	close(input);
	close(output);
end.
