#include <cstdio>
#include <algorithm>
#include <vector>

using namespace std;

long n,ii,h,b=0;
vector<long> v,a;

inline long vel(long i)
{
	long t=v[i-1];
	if(i>1) t=max(t,v[i-2]-1);
	return t;
}

void work()
{
	long t=vel(ii);
	if(t>h) return;
	long q=0;
	for(long j=1;j<=n;j++)
		q+=vel(j);
	if(q>b){
		b=q;
		a.resize(0);
		for(long j=1;j<=n;j++)
			a.push_back(v[j-1]);
	}
}

int main()
{
	freopen("skier.in","r",stdin);
	scanf("%d%d%d",&n,&ii,&h);
	fclose(stdin);
	freopen("skier.out","w",stdout);
{
		b=-10;
		for(long i=1;i<=n;i++) v.push_back(i);
		work();
		long w=1;
		while(w<=3628800) next_permutation(v.begin(),v.end()), work(),w++;
		for(long i=0;i<a.size();i++) printf("%d ",a[i]);
		printf("\n");
	}	
	fclose(stdout);
	return 0;
}
