#include <stdio.h>
#include <string.h>

#define MAX 53
#define LEN 503
#define SLEN 100010

int N, D[SLEN][MAX],  Len[MAX];
char Dic[MAX][LEN], S[SLEN];

#define RELAX(i, j, d) { if (D[i][j] > d) D[i][j] = d; }

int main( void )
{
  int i, j, k, l, d, len;

  freopen("typing.in", "rt", stdin);
  freopen("typing.out", "wt", stdout);
  scanf("%d", &N);
  for (i = 0; i < N; i++)
    scanf("%s", Dic[i]), Len[i] = strlen(Dic[i]);
  scanf("%s", S), len = strlen(S);
  S[len] = '#';
  for (i = 0; i <= len; i++)
    for (j = 0; j < N; j++)
      D[i][j] = i + 1;
  for (i = 0; i < len; i++)
    for (j = 0; j < N; j++)
    {
      for (k = 0; k < N; k++)
        RELAX(i, j, D[i][k] + 1);
      d = D[i][j] + 1;
      RELAX(i + 1, j, d);
      for (l = 0; l < Len[j]; l++)
        for (k = 0; S[i + k] == Dic[j][l + k]; k++)
          RELAX(i + k + 1, j, d); 
    }
  for (j = len, i = 0; i < N; i++)
    if (j > D[len][i])
      j = D[len][i];
  printf("%d", j);
  return 0;
}
