#include <cstdio>
#include <string>
#include <algorithm>
#include <vector>
#include <set>

#define maxn 160
#define maxl 100010
#define inf 100000000

using namespace std;

char c[200100];
string w[maxn];
string c1,c2,c3;

long x_57,y_57,n_57;

bool comp_k(long n1,long x1,long y1,long n2,long x2,long y2)
{
	c1="";
	for(long i=x1;i<=y1;i++)
		c1+=w[n1][i];
	c2="";
	for(long i=x2;i<=y2;i++)
		c2+=w[n2][i];
	return c1<c2;
}

bool comp_s(long n,long x,long y,string& s)
{
	c1="";
	for(long i=x;i<=y;i++)
		c1+=w[n][i];
	return c1<s;
}

bool comp_s(string& s,long n,long x,long y)
{
	c1="";
	for(long i=x;i<=y;i++)
		c1+=w[n][i];
	return s<c1;
}


struct kus{
	long v;
	kus(){v=0;}
	friend bool operator<(kus k1,kus k2)
	{
		long n1,x1,y1,n2,x2,y2,t1=k1.v,t2=k2.v;
		y1=t1%1001,y2=t2%1001;
		t1/=1001,t2/=1001;
		x1=t1%1001,x2=t2%1001;
		t1/=1001,t2/=1001;
		n1=t1,n2=t2;
		if(k1.v==57575757) n1=57,x1=x_57,y1=y_57;
		if(k2.v==57575757) n2=57,x2=x_57,y2=y_57;
		return comp_k(n1,x1,y1,n2,x2,y2);
	}
	friend bool operator<(kus k,string s)
	{
		long y=k.v%1001,x=(k.v/1001)%1001,n=(k.v/1001)/1001;
		return comp_s(n,x,y,s);
	}
	friend bool operator<(string s,kus k)
	{
		long y=k.v%1001,x=(k.v/1001)%1001,n=(k.v/1001)/1001;
		return comp_s(s,n,x,y);
	}
	friend bool operator==(kus k1,kus k2)
	{
		return (!(k1<k2))&&(!(k2<k1));
	}
	friend bool operator==(kus k,string s)
	{
		return (!(k<s))&&(!(s<k));
	}
	void sett(long n,long x,long y)
	{
		if(n==57) v=57575757,n_57=n,x_57=x,y_57=y; else
		v=y+x*1001+n*1001*1001;
	}
	kus(long n,long x,long y){sett(n,x,y);}
	long nm()
	{
		if(v==57575757) return n_57;
		return (v/1001)/1001;
	}
	void operator++()
	{
		if(v==57575757) y_57++; else
		v++;
	}
};

vector<kus> s,v;
long n;
long d[maxl][maxn];

int main()
{
	freopen("typing.in","r",stdin);
	scanf("%d",&n);
	for(long i=1;i<=n;i++){
		scanf("%s",c);
		c3="";
		c3+=c;
		w[i]=c;
		long ln=0;
		while(c[ln]!=0) ln++;
		for(long j=0;j<ln;j++)
			for(long z=j+1;z<ln;z++)
				s.push_back(kus(i,j,z));
	}
	scanf("%s",c);
	long ln=0;
	while(c[ln]!=0) ln++;
	fclose(stdin);

	sort(s.begin(),s.end());
	v.push_back(s[0]);
	for(long i=1;i<s.size();i++)
		if(s[i].v!=s[i-1].v) v.push_back(s[i]);
	s.resize(0);
	s=v;
	for(long i=1;i<=ln;i++)
		for(long j=0;j<=n;j++)
			d[i][j]=inf;
	for(long i=0;i<=n;i++) d[0][i]=(i==0) ? 0:1;
	long up,down;
	w[57]="";
	w[57]+=c;
	for(long i=0;i<ln;i++){
		for(long j=0;j<=n;j++)
			d[i+1][j]=min(d[i+1][j],d[i][j]+1);
		kus kk(57,i,i+1);
		if(i+1>=ln) continue;
		long t=i+2;
		while(binary_search(s.begin(),s.end(),kk)){
			up=upper_bound(s.begin(),s.end(),kk)-s.begin();
			down=lower_bound(s.begin(),s.end(),kk)-s.begin();
			for(long o=down+((kk==s[down])?0:1);o<up;o++){
				for(long jj=0;jj<=n;jj++)
					d[t][s[o].nm()]=min(d[t][s[o].nm()],d[i][jj]+1+((jj==s[o].nm())?0:1));
			}
			++kk,t++;
			if(t>ln) break;
		}
	}

	freopen("typing.out","w",stdout);
	long mmn=inf;
	for(long i=0;i<=n;i++)
		mmn=min(mmn,d[ln][i]);
	printf("%d\n",mmn);
	fclose(stdout);
	return 0;
}
