#include <stdio.h>
#include <string.h>

#define MAXN  10010
#define MAXM 100010

int Ans1, Ans2, N, M, A[MAXM], B[MAXM], CA[MAXM], CB[MAXM], C[MAXN], P[MAXN];

void Reorient(int t)
{
  if (!(t + 1))
    return;
  Reorient(P[t]);
  if (P[t] + 1)
  P[P[t]] = t;
}

void CheckCycle(int t)
{
  int v = t;
  while (P[v] != t)
  {
    v = P[v];
    if (!(v + 1))
      return;
  }
  while (!C[t])
  {
    C[t] = 1;
    t = P[t];
  }
}

int main( void )
{
  int i, p, t;
  freopen("orient.in", "rt", stdin);
  freopen("orient.out", "wt", stdout);

  scanf("%d%d", &N, &M);
  for (i = 0; i < M; i++)
    scanf("%d%d%d%d", &A[i], &B[i], &CA[i], &CB[i]), A[i]--, B[i]--;
  memset(C, 0, sizeof(C));
  memset(P, -1, sizeof(P));
  Ans1 = Ans2 = 0;
  for (i = 0; i < M; i++)
    if (!C[A[i]])
    {
      Reorient(A[i]);
      P[A[i]] = B[i];
      CheckCycle(A[i]);
      Ans1++;
      Ans2 += CA[i];
    }
    else if (!C[B[i]])
    {
      Reorient(B[i]);
      P[B[i]] = A[i];
      CheckCycle(B[i]);
      Ans1++;
      Ans2 += CB[i];
    }
  printf("%d %d\n", Ans1, Ans2);

  return 0;
}
