type integer = longint;
var k, m : integer;
	wma, a : array[1..101, 1..101] of int64;
	p, b : array[1..101] of int64;

procedure Load;
var i, j : integer;
begin
	read(k, m);
	for i := 1 to m do read(p[i]);
	for i := 1 to m do read(b[i]);
	for i := 1 to k do begin
		for j := 1 to m do read(a[j, i]);
	end;
	for i := 1 to m do
    	a[i, k + 1] := 1 + p[i] - b[i];
    move(a, wma, sizeof(wma));
end;

var was : array[1..110] of byte;

function GCD(a, b : int64; var x, y : int64) : int64;
var xx, yy, d : int64;
begin
	if b > a then GCD := GCD(b, a, y, x)
	else if b = 0 then begin
		x := 1;
		y := 0;
		GCD := a;
	end
	else begin
		d := GCD(b, a mod b, xx, yy);
		x := yy;
		y := xx - yy * (a div b);
		GCD := d;
	end;
end;

function GetInv(a, p : int64) : int64;
var x, y : int64;
begin
	GCD(a, p, x, y);
    if x < 0 then inc(x, p);
	GetInv := x;
end;

var mn, x : array[1..110] of int64;

procedure Solve;
var ce, f, i, j, ii, pp : integer;
	kf: int64;
begin
	{solve}
	fillchar(was, sizeof(was), 0);
	for i := 1 to k do begin
		ce := 0;
		for j := 1 to m do begin
			if was[j] = 1 then continue;
			if a[j, i] <> 0 then begin
				ce := j;
				break;
			end;
		end;
		if ce = 0 then continue;
		mn[ce] := i;
		kf := GetInv(a[ce, i], p[ce]);
		for j := 1 to k + 1 do a[ce, j] := (a[ce, j] * kf) mod p[ce];
		for j := 1 to m do begin
			if j = ce then continue;
			kf := a[j, i];
			for ii := 1 to k + 1 do begin
				a[j, ii] := (a[j, ii] - a[ce, ii] * kf) mod p[j];
				if a[j, ii] < 0 then inc(a[j, ii], p[j]);
			end;
		end;
		was[ce] := 1;
	end;
	{restore answer}
	for i := 1 to m do begin
		for j := 1 to k do begin
			if a[i, j] <> 0 then begin
				x[j] := a[i, k + 1];
				for ii := j + 1 to k do if a[i, ii] <> 0 then x[ii] := 0;
                break;
			end;	
		end;
	end;
	for i := 1 to m do begin
		f := 1;
		for j := 1 to k do begin
			if a[i, j] <> 0 then begin
				f := 0;
				break;
			end;	
		end;
		if a[i, k + 1] = 0 then break;
		if f = 1 then begin
			for j := 1 to k do begin
				if wma[i, j] <> 0 then begin
					pp := a[i, k + 1] * GetInv(wma[i, j], p[i]);
					for ii := 1 to m do begin
						if pp mod p[ii] = 0 then begin
							inc(x[mn[ii]], pp);
							a[i, k + 1] := 0;
							break;
						end;
					end;
				end;
				if a[i, k + 1] = 0 then break;
			end;
			if a[i, k + 1] <> 0 then begin
				write('impossible');
				exit;
			end;
		end;
	end;
	{}
	for i := 1 to k do write(x[i], ' ');
end;

begin	
	assign(input, 'lock.in');
	assign(output, 'lock.out');
	reset(input);
	rewrite(output);
	Load;
	Solve;
	close(input);
	close(output);
end.
