const
        MaxM = 100;
        MaxK = 100;
        MaxL = 1000;
type
        TLong = Array[0 .. MaxL] of LongInt;
var
        k, m : LongInt;
        p, b : Array[1 .. MaxM] of LongInt;
        a : Array[1 .. MaxK, 1 .. MaxM] of LongInt;
        rez : TLong;

Procedure Init;
var
        i, j : LongInt;
begin
  ReadLn(k, m);
  for i := 1 to m do
    Read(p[i]);
  for i := 1 to m do
    Read(b[i]);
  for i := 1 to k do
    for j := 1 to m do
    begin
      Read(a[i][j]);
      a[i][j] := a[i][j] mod p[j];
    end;
end;

Procedure ALL(var a, b : TLong);
var
        i, ost : LongInt;
begin
  ost := 0;
  if a[0] < b[0] then
    a[0] := b[0];
  for i := 1 to a[0] do
  begin
    ost := ost + a[i] + b[i];
    a[i] := ost mod 10;
    ost := ost div 10;
  end;
  While ost <> 0 do
  begin
    Inc(a[0]);
    a[a[0]] := ost mod 10;
    ost := ost div 10;
  end;
end;

Procedure MLS(var a : TLong; const b : LongInt);
var
        ost, i : LongInt;
begin
  ost := 0;
  for i := 1 to a[0] do
  begin
    ost := ost + b * a[i];
    a[i] := ost mod 10;
    ost := ost div 10;
  end;
  While ost <> 0 do
  begin
    Inc(a[0]);
    a[a[0]] := ost mod 10;
    ost := ost div 10;
  end;
end;

Procedure WriteLong(const a : TLong);
var
        i : LongInt;
begin
  if a[0] = 0 then
    Write(0)
  else
  begin
    for i := a[0] downto 1 do
      Write(a[i]);
  end;
end;

Procedure Solve;
var
        q, i, j, d, y : LongInt;
        tek : TLong;
        cool : Boolean;
begin
  for q := 1 to k do
  begin
    cool := True;
    FillChar(rez, SizeOf(rez), 0);
    for i := 1 to m do
    begin
      FillChar(tek, SizeOf(tek), 0);
      tek[0] := 1;
      tek[1] := 1;
      d := 1;
      for j := 1 to m do
        if j <> i then
        begin
          d := (d * p[j]) mod p[i];
          MLS(tek, p[j]);
        end;
      d := (d * a[q][i]) mod p[i];
      y := 1;
      if (d = 0) and (b[i] <> 1) then
      begin
        cool := False;
        Break;
      end;
      While (d * y + b[i]) mod p[i] <> 1 do
        Inc(y);
      MLS(tek, y);
      ALL(rez, tek);
    end;
    if cool then
    begin
      for i := 1 to q - 1 do
        Write(0, ' ');
      WriteLong(rez);
      for i := q + 1 to k do
        Write(' ', 0);
      Close(input);
      Close(output);
      Halt;
    end;
  end;
end;

Procedure Print;
begin
  Write('impossible');
end;

begin
  Assign(input, 'lock.in');
  Reset(input);
  Assign(output, 'lock.out');
  Rewrite(output);
  Init;
  Solve;
  Print;
  Close(input);
  Close(output);
end.
