#include <stdio.h>
#include <string.h>
#include <memory.h>

struct Str {
	int len;
	char arr[510];
};

int n, l;
Str word[51];
char expr[100010];
int lf[51][100010];

int size;
int curr[510];
int pref[130000];

int dist[100010][51];

void readStr(Str &a) {
	fgets(a.arr, 505, stdin);
	a.len = strlen(a.arr);
	while ((a.arr[a.len-1] == '\n') || (a.arr[a.len-1] == ' '))
		a.len--;
	a.arr[a.len] = 0;
}

int readString(char *arr) {
	fgets(arr, 100005, stdin);
	int len = strlen(arr);
	while ((arr[len-1] == '\n') || (arr[len-1] == ' '))
		len--;
	arr[len] = 0;
	return len;
}

void CalcMaxIncr(int w) {
	int i, j, u;

	memset(lf[w], 63, sizeof(lf[w]));
	for (j = 0; j<word[w].len; j++) {
		int pos = j;
		int pl = 0;
                
        int pref[510];
        pref[0] = 0;
        pref[1] = 0;
        i = 1;
        u = 0;
        while (i<=word[w].len-j) {
              if (word[w].arr[i+j] == word[w].arr[u+j]) {
                 i++;
                 u++;
                 pref[i] = u;
                 continue;
              }
              if (u==0) {
                 i++;
                 pref[i] = u;
              }
              else
                  u = pref[u];
       }
       
		for (i = 0; i<l; i++) {
			while (expr[i] != word[w].arr[pos]) {
				pos = pref[pos-j]+j;
                                if (pos==j) break;
                        }
                        pl = pos-j;
                       if (expr[i] != word[w].arr[pos]) {
				pl = pos-j;
                                if (lf[w][i+1] > i+1-pl)
                                   lf[w][i+1] = i+1-pl;
				continue;
                        }
			pos++;
			pl++;
                        if (lf[w][i+1] > i+1-pl)
                           lf[w][i+1] = i+1-pl;
		}
	}
}

int main(int argc, char **argv) {
	freopen("typing.in", "r", stdin);
	freopen("typing.out", "w", stdout);
	int i, j;
	scanf("%d\n", &n);
	for (i = 0; i<n; i++)
		readStr(word[i]);
	l = readString(expr);
	for (i = 0; i<n; i++)
		CalcMaxIncr(i);

	memset(dist, 63, sizeof(dist));
	dist[0][0] = 0;
	for (i = 1; i<=n; i++)
		dist[0][i] = 1;
	for (i = 1; i<=l; i++) {
		for (j = 0; j<=n; j++)
			if (dist[i][j] > dist[i-1][j] + 1)
				dist[i][j] = dist[i-1][j] + 1;
		for (j = 1; j<=n; j++)
			if (lf[j-1][i] < i)
				if (dist[i][j] > dist[lf[j-1][i]][j] + 1)
					dist[i][j] = dist[lf[j-1][i]][j] + 1;
		int minp = 1000000000;
		for (j = 0; j<=n; j++)
			if (dist[i][j] < minp)
				minp = dist[i][j];
		if (minp < 1000000000)
			for (j = 0; j<=n; j++)
				if (dist[i][j] > minp + 1)
					dist[i][j] = minp + 1;
	}
	int ans = 1000000000;
	for (i = 0; i<=n; i++)
		if (ans > dist[l][i])
			ans = dist[l][i];
	printf("%d", ans);
	return 0;
}

