#include <cstdio>
#include <string>
#include <algorithm>
#include <iostream>

using namespace std;

string a, b, ans[3];
int n;

struct KMP{
  int pa[5000], pb[5000];
  void kmp(string a, string b){
    int i;
    pa[0]=0;
    for (i=1; i<a.size(); i++){
      for (pa[i]=pa[i-1]; pa[i]&&a[i]!=a[pa[i]]; pa[i]=pa[pa[i]-1]);
      if (a[i]==a[pa[i]]) pa[i]++;
    }
    pb[0]=0;
    for (i=1; i<b.size(); i++){
      for (pb[i]=pb[i-1]; pb[i]&&b[i]!=a[pb[i]]; pb[i]=pa[pb[i]-1]);
      if (b[i]==a[pb[i]]) pb[i]++;
    }
  }
};

bool check2(string a, string b, int u, int v){
  int i, p[5000], pc=0, n=a.size();
  KMP kmp;
  if (a.size()<2) return false;
  if (a==b){
    ans[u]=a.substr(0, 1);
    ans[v]=a.substr(1, a.size()-1);
    return true;
  }
  kmp.kmp(a, b);
  for (i=kmp.pb[n-1]; i; i=kmp.pa[i-1])  p[pc++]=i;
  kmp.kmp(b, a);
  for (i=kmp.pb[n-1]; i; i=kmp.pa[i-1]){
    while (pc&&p[pc-1]+i<n) pc--;
    if (pc&&p[pc-1]+i==n){
      ans[u]=a.substr(0, p[pc-1]);
      ans[v]=b.substr(0, i);
      return true;
    }
  }
  return false;
}

bool check(string a, string b){
  KMP kmp;
  int i;
  for (i=0; i<n&&a[i]==b[i]; i++){
    ans[0]=a.substr(0, i+1);
    if (check2(a.substr(i+1, n-i-1), b.substr(i+1, n-i-1), 1, 2)) return true;
  }
  kmp.kmp(b, a);
  for (i=kmp.pb[n-1]; i; i=kmp.pa[i-1]){
    ans[2]=b.substr(0, i);
    if (check2(a.substr(0, n-i), b.substr(i, n-i), 0, 1)) return true;
  }
  return false;
}

int main(){
  freopen("stragain.in", "rt", stdin);
  freopen("stragain.out", "wt", stdout);
  getline(cin, a, '\n');
  getline(cin, b, '\n');
  n=a.size();
  if (check(a, b))
    cout<<"YES\n"<<ans[0]<<'\n'<<ans[1]<<'\n'<<ans[2];
  else{
    reverse(a.begin(), a.end());
    reverse(b.begin(), b.end());

    if (check(a, b)){
      reverse(ans[0].begin(), ans[0].end());
      reverse(ans[1].begin(), ans[1].end());
      reverse(ans[2].begin(), ans[2].end());
      cout<<"YES\n"<<ans[2]<<'\n'<<ans[1]<<'\n'<<ans[0];
    } else
      cout<<"NO";
  };
  return 0;
}
