#include <iostream>
#include <string>
#include <cstdlib>

using namespace std;

#define P substr
typedef string str;

void Yes( str a, str b, str c )
{
  cout << "YES\n" << a << endl << b << endl << c;
  exit(0);
}

#define MAX 15010

int Do( str s, str t )
{
  static int P[MAX];
  str s2 = t + '$' + s + s;
  int k, i, len = s2.length(), tlen = t.length();

  P[0] = 0;
  for (k = 0, i = 1; i < len; i++)
  {
    while (k && s2[k] != s2[i])
      k = P[k - 1];
    if (s2[k] == s2[i])
      k++;
    P[i] = k;
    if (k == tlen)
      break;
  }
  if (i == len)
    return -1;
  k = i - tlen - s.length();
  return !k ? 1 : k;
}

int main( void )
{
  str S, T;
  int len, k, i;
 
  freopen("stragain.in", "rt", stdin);
  freopen("stragain.out", "wt", stdout);
  cin >> S >> T;
  len = S.length();
  for (i = 1; i < len - 1; i++)
  {
    if ((S.P(0, i) == T.P(0, i) && (k = Do(S.P(i, len - i), T.P(i, len - i))) != -1) ||
        (S.P(0, i) == T.P(len - i, i) && (k = Do(S.P(i, len - i), T.P(0, len - i))) != -1))
      Yes(S.P(0, i), S.P(i, k), S.P(i + k, len - i - k));
    if ((S.P(len - i, i) == T.P(0, i) && (k = Do(S.P(0, len - i), T.P(i, len - i))) != -1) ||
        (S.P(len - i, i) == T.P(len - i, i) && (k = Do(S.P(0, len - i), T.P(0, len - i))) != -1))
      Yes(S.P(0, k), S.P(k, len - i - k), S.P(len - i, i));
  }
  cout << "NO";
  return 0;
}
