{ $DEFINE DEBUG}
{$H+}
{$IFDEF DEBUG}
{$C+,I+,Q+,R+,S+}
{$ELSE}
{$C-,I-,Q-,R-,S-}
{$ENDIF}
{
1 shl 32-1 = 4294967295
1 shl 31   = 2147483648
}
uses math;
const taskid='holytape';
      infile=taskid+'.in';
      outfile=taskid+'.out';
type tlong=array [0..5000] of cardinal;
var s1,s2:string;
    i,j,cur,k,ans,last,tt:longint;
    lookup:array [0..65535] of cardinal;
    a,b,olda:tlong;
    qq:cardinal;
function getbits(a:cardinal):longint;
begin
  getbits:=lookup[a shr 16]+lookup[a and 65535]-((a shr 16) and 1) and ((a and 65535) shr 15);
end;
procedure setbit(var a:tlong;k:longint);
begin
  a[(k-1) shr 5+1]:=a[(k-1) shr 5+1] or (1 shl ((k-1) and 31));
end;
procedure encode(var s:string;var a:tlong);
var i:longint;
begin
  fillchar(a,sizeof(a),0);
  a[0]:=length(s) shr 5;
  if length(s) and 31<>0 then
    inc(a[0]);
  for i:=1 to length(s) do
    if s[i]='1' then
      setbit(a,i);
end;
procedure mul2(var a:tlong);
var os,tmp:int64;
    i:longint;
begin
  os:=0;
  for i:=1 to a[0] do
  begin
    tmp:=int64(a[i])*2+os;
    a[i]:=tmp and 4294967295;
    os:=tmp shr 32;
  end;
  if os>0 then
  begin
    inc(a[0]);
    a[a[0]]:=os;
  end;
end;
begin
  assign(input,infile);
  reset(input);
  assign(output,outfile);
  rewrite(output);
  readln(s1);
  readln(s2);
  for i:=0 to 65535 do
  begin
    lookup[i]:=0;
    last:=0;
    for j:=0 to 15 do
      if i and (1 shl j)<>0 then
      begin
        if last=0 then
          inc(lookup[i]);
        last:=1;
      end
      else last:=0;
  end;
  encode(s1,a);
  encode(s2,b);
  olda:=a;
  ans:=0;
  for i:=1 to 32 do
  begin
    for j:=1 to b[0] do
    begin
      cur:=0;
      last:=0;
      tt:=min(longint(a[0]),longint(b[0])-j+1);
      for k:=1 to tt do
      begin
        qq:=a[k] and b[j+k-1];
        inc(cur,getbits(qq)-last and (qq and 1));
        last:=qq shr 31;
      end;
      ans:=max(cur,ans);
    end;
    mul2(a);
  end;
  a:=olda;
  for i:=1 to 32 do
  begin
    for j:=1 to a[0] do
    begin
      cur:=0;
      last:=0;
      tt:=min(longint(b[0]),longint(a[0])-j+1);
      for k:=1 to tt do
      begin
        qq:=b[k] and a[j+k-1];
        inc(cur,getbits(qq)-last and (qq and 1));
        last:=qq shr 31;
      end;
      ans:=max(cur,ans);
    end;
    mul2(b);
  end;
  writeln(ans);
  close(input);
  close(output);
end.
