{$I-,Q-,R-,S-}
//{$I+,Q+,R+,S+}
program ProblemC;
uses
 SysUtils;

const
 in_f='stragain.in';
 out_f='stragain.out';
type
  int=longint;
  real=extended;
  bool=boolean;
const
  maxN=5000+5;
  tl1=0.6/24/60/60;
  tl2=1.2/24/60/60;
  tl3=1.9/24/60/60;
var
  N:int;
  s1,s2:array[1..maxN] of char;
  ss:array[1..2*maxN]of char;
  part2,part3:int;

  p1,p2,sr1,sr2:array[1..maxN] of int;

  temp:array[1..maxN] of int;
  tuk:int;
  swaped:bool;

  begtime:real;

procedure WriteAns;
 var
   i:int;
 begin
   WRiteln('YES');
   if not swaped then
     begin
       for i := 1 to part2-1 do
         WRite(s1[i]);
       Writeln;
       for i := part2 to part3-1 do
         WRite(s1[i]);
       Writeln;
       for i := part3 to N do
         WRite(s1[i]);
     end
   else
     begin
       for i := N downto part3 do
         WRite(s1[i]);
       Writeln;
       for i := part3-1 downto part2 do
         WRite(s1[i]);
       Writeln;
       for i := part2-1 downto 1 do
         WRite(s1[i]);
     end;
 end;

procedure Swap;
  var
    i:int;
    t:char;
  begin
    for i := 1 to N div 2 do
      begin
        t:=s1[i];s1[i]:=s1[n+1-i];s1[n+1-i]:=t;
        t:=s2[i];s2[i]:=s2[n+1-i];s2[n+1-i]:=t;
      end;
    swaped:=not swaped;
  end;

function Do213:bool;
  var
   i,j,k:int;
  begin
   do213:=false;
   p1[1]:=0;
   k:=0;
   for i := 2 to N do
     begin
       while (k<>0) and (s1[k+1]<>s1[i]) do
         k:=p1[k];
       if s1[k+1]=s1[i] then
         inc(k);
       p1[i]:=k;
     end;
   p2[1]:=0;
   k:=0;
   for i := 2 to N do
     begin
       while (k<>0) and (s2[k+1]<>s2[i]) do
         k:=p2[k];
       if s2[k+1]=s2[i] then
         inc(k);
       p2[i]:=k;
     end;
   k:=0;
   for i := 1 to N do
     begin
       while (k<>0) and (s1[k+1]<>s2[i]) do
         k:=p1[k];
       if s1[k+1]=s2[i] then
         inc(k);
       sr2[i]:=k;
     end;
   k:=0;
   for i := 1 to N do
     begin
       while (k<>0) and (s2[k+1]<>s1[i]) do
         k:=p2[k];
       if s2[k+1]=s1[i] then
         inc(k);
       sr1[i]:=k;
     end;
   i:=N;
   while (i>=1) and (s1[i]=s2[i]) do
     begin
       if swaped then
         if now>begtime+tl1 then exit else
       else
         if now>begtime+tl2 then exit else;

       tuk:=0;
       k:=sr1[i-1];
       while k<>0 do
         begin
           inc(tuk);
           temp[tuk]:=i-1-k;
           k:=p1[k];
         end;
       k:=sr2[i-1];
       for j :=tuk downto 1 do
         begin
           while k>temp[j] do k:=p1[k];
           if k=temp[j] then
             begin
               part2:=k+1;
               part3:=i;
               WriteAns;
               Do213:=true;
               exit;
             end;
         end;
       dec(i);
     end;
  end;

function Do2:bool;
 var
   i,k:int;
 begin
  for i := 1 to N do
    ss[i]:=s1[i];
  for i := 1 to N do
    ss[N+i]:=s1[i];

   p2[1]:=0;
   k:=0;
   for i := 2 to N do
     begin
       while (k<>0) and (s2[k+1]<>s2[i]) do
         k:=p2[k];
       if s2[k+1]=s2[i] then
         inc(k);
       p2[i]:=k;
     end;
   k:=0;
   for i := 1 to 2*N do
     begin
       while (k>0) and (s2[k+1]<>ss[i]) do
         k:=p2[k];
       if s2[k+1]=ss[i] then
         inc(k);
       if k=N then
         begin
           if i>=N+2 then
             begin
               part2:=2;
               part3:=i+1-N;
             end
           else
             begin
               part2:=i+1-N;
               part3:=N;
             end;
           WriteAns;
           Do2:=true;
           exit;
         end;
     end;
   Do2:=false;
 end;

function Do22(beg:int):bool;
 var
   i,k:int;
 begin
   if n-beg<2 then
     begin
       Do22:=false;
       exit;
     end;
   for i := beg+1 to N do
     ss[i-beg]:=s1[i];
   for i := beg+1 to N do
     ss[i+N-2*beg]:=s1[i];

   p2[1]:=0;
   k:=0;
   for i := 2 to N-beg do
     begin
       while (k<>0) and (s2[k+1]<>s2[i]) do
         k:=p2[k];
       if s2[k+1]=s2[i] then
         inc(k);
       p2[i]:=k;
     end;
   k:=0;
   for i := 1 to 2*(N-beg) do
     begin
       while (k>0) and (s2[k+1]<>ss[i]) do
         k:=p2[k];
       if s2[k+1]=ss[i] then
         inc(k);
       if k=N-beg then
         begin
           part2:=beg+1;
           part3:=beg+1+i-(n-beg);
           WriteAns;
           Do22:=true;
           exit;
         end;
     end;
   Do22:=false;
 end;

function Do321:bool;
 var
   k,i:int;
 begin
   Do321:=false;
   p1[1]:=0;
   k:=0;
   for i := 2 to N do
     begin
       while (k<>0) and (s1[k+1]<>s1[i]) do
         k:=p1[k];
       if s1[k+1]=s1[i] then
         inc(k);
       p1[i]:=k;
     end;
   k:=0;
   for i := 1 to N do
     begin
       while (k<>0) and (s1[k+1]<>s2[i]) do
         k:=p1[k];
       if s1[k+1]=s2[i] then
         inc(k);
       sr2[i]:=k;
     end;

   k:=sr2[N];
   while k<>0 do
     begin
       if now>begtime+tl3 then exit;
       if Do22(k) then
         begin
           Do321:=true;
           exit;
         end;
       k:=p1[k];
     end;
 end;

procedure Run;
 var
   i:int;
   ob:int;
 begin
   n:=0;
   while  not seekeoln do
     begin
       Inc(N);
       Read(s1[n]);
     end;
   REadln;
   n:=0;
   while  not seekeoln do
     begin
       Inc(N);
       Read(s2[n]);
     end;
   if n<3 Then
     begin
       WRiteln('NO');
       exit;
     end;

   swaped:=false;

   i:=1;
   while (i<=N) and (s1[i]=s2[i]) do inc(i);
   ob:=i-1;
// 1 2 3
   if ob=N then
     begin
       part2:=2;
       part3:=3;
       WRiteAns;
       exit;
     end;
// 2 3 1
// 3 1 2
   if Do2 then exit;
// 1 3 2
   Swap;
   if Do213 then exit;
   Swap;
// 2 1 3
   if Do213 then exit;
// 3 2 1
   if Do321 then exit;

   WRiteln('NO');
 end;

procedure OpenFiles;
 begin
  Assign(input,in_f);
  Reset(input);
  Assign(output,out_f);
  Rewrite(output);
 end;

procedure CloseFiles;
 begin
  Close(input);
  Close(output);
 end;

Begin
begtime:=now;
OpenFiles;
Run;
CloseFiles;
End.
