#include <stdio.h>
#include <string.h>

#define CONST 140000
#define SIZE 300000

int l1, l2;
char t1[130010], t2[130010];
int n1, n2;
int r1[66000][2], r2[66000][2];
int sum[SIZE];

int readTape(char *arr) {
	fgets(arr, 130005, stdin);
	int len = strlen(arr);
	while ((arr[len-1] == ' ') || (arr[len-1] == '\n'))
		len--;
	arr[len] = 0;
	return len;
}

void IncSum(int l, int r) {
	sum[l]++;
	sum[r]--;
}

int GetMax() {
	int res = 0;
	for (int i = 1; i<CONST*2; i++) {
		sum[i] += sum[i-1];
		if (res < sum[i])
			res = sum[i];
	}
    return res;
}

int main(int argc, char **argv) {
	freopen("holytape.in", "r", stdin);
	freopen("holytape.out", "w", stdout);
	int l1 = readTape(t1);
	int l2 = readTape(t2);
	int i, j;
	for (i = 0; i<l1; i++) {
		if (t1[i] == '1') {
			r1[n1][0] = i;
			for (; t1[i] == '1'; i++);
			r1[n1][1] = i;
			n1++;
		}
	}
	for (i = 0; i<l2; i++) {
		if (t2[i] == '1') {
			r2[n2][0] = i;
			for (; t2[i] == '1'; i++);
			r2[n2][1] = i;
			n2++;
		}
	}
	for (i = 0; i<n1; i++)
		for (j = 0; j<n2; j++) {
			int x1 = (r2[j][0] - r1[i][1]) + CONST;
			int x2 = (r2[j][1] - r1[i][0]) + CONST;
			IncSum(x1, x2);
		}
	int ans = GetMax();
	printf("%d", ans);
	return 0;
}
