#include <stdio.h>
#include <stdlib.h>

#define MAXL 5010

char s1[MAXL], s2[MAXL];
int d1[MAXL], d2[MAXL], n1, n2;

int main( void )
{
  int a, f, i, j, k;
  int timer = time();

  freopen("stragain.in", "rt", stdin);
  freopen("stragain.out", "wt", stdout);

  scanf("%s", s1);
  scanf("%s", s2);

  n1 = strlen(s1);
  n2 = strlen(s2);

  if (n1 < 3 || n2 < 3 || n1 != n2)
  {
    printf("NO");
    return 0;
  }
  for (f = 1, i = 0; (s1[i] || s2[i]) && f; i++)
    if (s1[i] != s2[i])
      f = 0;
  if (f)
  {
    printf("YES\n%c\n%c\n%s\n", s1[0], s1[1], &s1[2]);
    return 0;
  }
  for (a = i = 0; s1[i] && s1[i] == s2[i]; i++, a = i)
    ;
  if (a > n1 - 2)
    a = n1 - 2;
  if (a)
    for (i = a + 1; s1[i] && !f; i++)
    {
      f = 1;
      for (j = i; s1[j] && f; j++)
        if (s1[j] != s2[j - i + a])
          f = 0;
      for (j = a; j < i && f; j++)
        if (s1[j] != s2[j + n1 - i])
          f = 0;
    }
  if (f)
  {
    i--;
    printf("YES\n");
    for (j = 0; j < a; j++)
      fputc(s1[j], stdout);
    fputc('\n', stdout);
    for (j = a; j < i; j++)
      fputc(s1[j], stdout);
    fputc('\n', stdout);
    for (j = i; j < n1; j++)
      fputc(s1[j], stdout);
    fputc('\n', stdout);
    return 0;
  }
  for (a = i = n1 - 1; n1 >= 2 && s1[i] == s2[i]; a = i, i--)
    ;
  if (a < n1 - 1)
    for (i = 1; i < a && !f; i++)
    {
      f = 1;
      for (j = 0; j < i && f; j++)
        if (s1[j] != s2[j + a - i])
          f = 0;
      for (j = i; j < a && f; j++)
        if (s1[j] != s2[j - i])
          f = 0;
    }
  if (f)
  {
    i--;
    printf("YES\n");
    for (j = 0; j < i; j++)
      fputc(s1[j], stdout);
    fputc('\n', stdout);
    for (j = i; j < a; j++)
      fputc(s1[j], stdout);
    fputc('\n', stdout);
    for (j = a; j < n1; j++)
      fputc(s1[j], stdout);
    fputc('\n', stdout);
    return 0;
  }
  for (i = 1; i < n1 && !f; i++)
  {
    f = 1;
    for (j = 0; j < i && f; j++)
      if (s1[j] != s2[j + n1 - i])
        f = 0;
    for (j = i; j < n1 && f; j++)
      if (s1[j] != s2[j - i])
        f = 0;
  }
  if (f)
  {
    i--;
    printf("YES\n");
    if (i > 1)
    {
      printf("%c\n", s1[0]);
      for (j = 1; j < i; j++)
        fputc(s1[j], stdout);
    }
    else
      for (j = 0; j < i; j++)
        fputc(s1[j], stdout);
    fputc('\n', stdout);
    if (i <= 1)
    {
      printf("%c\n", s1[i]);
      for (j = i + 1; j < n1; j++)
        fputc(s1[j], stdout);
    }
    else
      for (j = i; j < n1; j++)
        fputc(s1[j], stdout);
    fputc('\n', stdout);
    return 0;
  }
  for (i = 0; i < n1; i++)
    for (d1[i] = 1, j = 0; j < i && d1[i]; j++)
      if (s1[j] != s2[j + n1 - i])
        d1[i] = 0;
  for (i = 0; i < n2; i++)
    for (d2[i] = 1, j = 0; j < i && d2[i]; j++)
      if (s2[j] != s1[j + n2 - i])
        d2[i] = 0;

  for (i = 0; s2[i] && !f && (time() - timer) < 1.9; i++)
    for (j = 1; j < i && !f; j++)
    {
      f = d1[j] && d2[n1 - i];
      for (k = j; k < i && f; k++)
        if (s1[k] != s2[k - j + n1 - i])
          f = 0;
    }
  if (f)
  {
    i--, j--;
    printf("YES\n");
    for (k = 0; k < j; k++)
      fputc(s1[k], stdout);
    fputc('\n', stdout);
    for (k = j; k < i; k++)
      fputc(s1[k], stdout);
    fputc('\n', stdout);
    for (k = i; k < n1; k++)
      fputc(s1[k], stdout);
    fputc('\n', stdout);
    return 0;
  }

  printf("NO\n");

  return 0;
}
