{$I-,Q-,R-,S-}
//{$I+,Q+,R+,S+}
program Temp;
uses
  SysUtils;
const
 in_f='peace.in';
 out_f='peace.out';
type
  int=longint;
  real=extended;
  bool=boolean;
const
  maxN=100;
  tl=1.7/24/60/60;
var
  N:int;
  v,loyal:array[1..maxN] of bool;
  g:array[1..maxN,0..maxN] of int;
  begtime:real;
  anstorch,ans:array[1..maxN] of int;
  list:array[1..maxN] of int;

procedure Swap(var a,b:int);
 var
   c:int;
 begin
   c:=a;a:=b;b:=c;
 end;

procedure Dfs(u:int);
 var
   i:int;
   sum:int;
   kol:int;
 begin
   v[u]:=true;
   sum:=0;
   if loyal[u] then kol:=1 else kol:=0;
   for i := 1 to g[u,0] do
     if not v[g[u,i]] then
       begin
         Dfs(g[u,i]);
         inc(sum,ans[g[u,i]]);
         if anstorch[g[u,i]]>=ans[g[u,i]] then
           inc(kol);
       end;
   case kol of
     0:
      begin
        ans[u]:=sum; 
        anstorch[u]:=-1;
      end;
     1:
      begin
        ans[u]:=sum;
        anstorch[u]:=sum;
      end;
     else
      begin
        ans[u]:=sum+1;
        anstorch[u]:=sum;
      end;
     end;
 end;

procedure Run;
 var
   i,j,a,b:int;
   m,k:int;
   answer,s:int;
 begin
   Read(n,m,k);
   fillchar(loyal,sizeof(loyal),0);
   for i := 1 to k do
     begin
       Read(a);
       loyal[a]:=true;
     end;
   fillchar(g,sizeof(g),0);
   for i := 1 to m do
     begin
       Read(a,b);
       inc(g[a,0]);
       g[a,g[a,0]]:=b;
       inc(g[b,0]);
       g[b,g[b,0]]:=a;
     end;

   RandSeed:=170239+18;
   answer:=0;
   while now<begtime+tl do
     begin
       for i := 1 to N do
         list[i]:=i;
       for i := N downto 2 do
         Swap(list[i],list[random(i)+1]);
       for i := 1 to N do
         for j := g[i,0] downto 2 do
           Swap(g[i,j],g[i,random(j)+1]);

       for i := 1 to N do
         v[i]:=false;
       s:=0;
       for i := 1 to N do
         if not v[list[i]] then
           begin
             dfs(list[i]);
             inc(s,ans[list[i]]);
           end;
       if s>answer then answer:=s;
     end;
   Write(answer);
 end;

procedure OpenFiles;
 begin
  Assign(input,in_f);
  Reset(input);
  Assign(output,out_f);
  Rewrite(output);
 end;

procedure CloseFiles;
 begin
  Close(input);
  Close(output);
 end;

Begin
begtime:=now;
OpenFiles;
Run;
CloseFiles;
End.
