{$I-,Q-,R-,S-}
//{$I+,Q+,R+,S+}
program Temp;
uses
  SysUtils;
const
 in_f='holytape.in';
 out_f='holytape.out';
type
  int=longint;
  real=extended;
  bool=boolean;
const
  maxN=150000;
  tl=9/24/60/60;
var
  N,M:int;
  s,g:array[-maxN..2*maxN] of bool;
  begtime:real;

procedure Init;
 var
   i,j:int;
   ch:char;
 begin
   N:=0;
   while not seekeoln do
     begin
       Inc(N);
       Read(ch);
       s[N]:=ch='1';
     end;
   readln;
   M:=0;
   while not seekeoln do
     begin
       Inc(M);
       Read(ch);
       g[M]:=ch='1';
     end;
   i:=1;
   while (i<N) and not s[i] do inc(i);dec(i);
   dec(n,i);
   for j := 1 to N do
     s[j]:=s[j+i];
   for j := N+1 to N+i do s[i]:=false;
   while (N>1) and not s[n] do dec(n);

   i:=1;
   while (i<M) and not g[i] do inc(i);dec(i);
   dec(M,i);
   for j := 1 to M do
     g[j]:=g[j+i];
   for j := M+1 to M+i do g[i]:=false;
   while (M>1) and not g[M] do dec(M);
 end;

procedure Run;
 var
  i,d:int;
  sum,ans:int;
  dyr:bool;
 begin
   Init;
   randSeed:=239017+18;
   ans:=0;
   while now<begtime+tl do
     begin
       d:=Random(n+m)-M+1;
       sum:=0;
       dyr:=false;
       for i := 1 to M do
         if g[i] and s[i+d] then
           begin
             if not dyr then
               inc(sum);
             dyr:=true;
           end
         else
           dyr:=false;
       if sum>ans then ans:=sum;
     end;
   WRite(ans);
 end;

procedure OpenFiles;
 begin
  Assign(input,in_f);
  Reset(input);
  Assign(output,out_f);
  Rewrite(output);
 end;

procedure CloseFiles;
 begin
  Close(input);
  Close(output);
 end;

Begin
begtime:=now;
OpenFiles;
Run;
CloseFiles;
End.
