type integer = longint;
var s1, s2 : string;

procedure Load;
begin
	readln(s1);
	readln(s2);
end;

var pf1 : array[1..5100]of integer;
	ns1, ns2 : string;

procedure CountPF;
var i, k : integer;
begin
	pf1[1] := 0;
	k := 0;
	for i := 2 to length(s1) do begin
		while (k > 0) and (s1[i] <> s1[k + 1]) do k := pf1[k];
		if (s1[i] = s1[k + 1]) then inc(k);
		pf1[i] := k;
	end;
end;

var lp : array[1..5100] of integer;
	ss : string;
	kk, pp, lps, lpn, pfs, pfn : array[1..5100] of integer;
	nk, np : integer;

function TrySplit2(pos : integer) : boolean;
var i, k, ck, cp : integer;
begin
	{count prefix-f}
	pfs[1] := 0;
	k := 0;
	for i := 2 to length(ss) do begin
		while (k > 0) and (ss[i] <> ss[k + 1]) do k := pfs[k];
		if (ss[i] = ss[k + 1]) then inc(k);
		pfs[i] := k;
	end;
	pfn[1] := 0;
	k := 0;
	for i := 2 to length(ns1) do begin
		while (k > 0) and (ns1[i] <> ns1[k + 1]) do k := pfn[k];
		if (ns1[i] = ns1[k + 1]) then inc(k);
		pfn[i] := k;
	end;
	{count prefix - match}
	k := 0;
	for i := 1  to length(ss) do begin
		while (k > 0) and (ss[i] <> ns1[k + 1]) do k := pfn[k];
		if (ss[i] = ns1[k + 1]) then inc(k);
		lps[i] := k;
	end;
	k := 0;
	for i := 1  to length(ns1) do begin
		while (k > 0) and (ns1[i] <> ss[k + 1]) do k := pfs[k];
		if (ns1[i] = ss[k + 1]) then inc(k);
		lpn[i] := k;
	end;
	nk := 0;
	np := 0;
	i := lps[length(ss)];
	while i <> 0 do begin
		inc(nk);
		kk[nk] := i;
		i := pfn[i];
	end;
	i := lpn[length(ns1)];
	while i <> 0 do begin
		inc(np);
		pp[np] := i;
		i := pfs[i];
	end;
	{search}
	cp := np;
	for ck := 1 to nk do begin
		while (kk[ck] + pp[cp] < length(ss)) do begin
			dec(cp);
			if cp = 0 then break;
		end;
		if cp = 0 then break;
		if kk[ck] + pp[cp] = length(ss) then begin
			writeln('YES');
			for i := 1 to pos do write(s1[i]);
			writeln;
			for i := 1 to pp[cp] do write(ss[i]);
			writeln;
			for i := 1 to kk[ck] do write(ns1[i]);
			TrySplit2 := true;
			exit;
		end;
	end;
	TrySplit2 := false;
end;

var curs : string;

procedure Solve;
var i, k, j : integer;
begin
	if (length(s1) < 3) or (length(s2) < 3) then begin
		write('NO');
		exit;
	end;
	CountPF;
	k := 0;
	for i := 1 to length(s2) do begin
		while (k > 0) and (s2[i] <> s1[k + 1]) do k := pf1[k];
		if (s2[i] = s1[k + 1]) then inc(k);
		lp[i] := k;
	end;
	if lp[length(s2)] = length(s1) then begin
		writeln('YES');
		writeln(s2[1]);
		writeln(s2[2]);
		for i := 3 to length(s2) do write(s2[i]);
		exit;
	end;
	for i := 1 to length(s2) do begin
        if lp[i] = 0 then continue;
		{make 2 strings}
		ns1 := '';
		for j := 1 to i - lp[i] do begin
			ns1 := ns1 + s2[j];
		end;
		ns2 := '';
		for j := i + 1 to length(s2) do begin
			ns2 := ns2 + s2[j];
		end;
		if length(ns1) = 0 then begin
			ns1 := ns2;
			ns2 := '';
		end;
		ss := '';
		for j := lp[i] + 1 to length(s1) do begin
			ss := ss + s1[j];
		end;
		if length(ns2) <> 0 then begin
			{check for compatibility}
			{direct}
			curs := ns1 + ns2;
			if curs = ss then begin
				writeln('YES');
				for j := 1 to lp[i] do write(s1[j]);
				writeln;
				writeln(ns1);
				writeln(ns2);
				exit;
			end;
			{reverse}
			curs := ns2 + ns1;
			if curs = ss then begin
				writeln('YES');
				for j := 1 to lp[i] do write(s1[j]);
				writeln;
				writeln(ns2);
				writeln(ns1);
				exit;
			end;
		end
		else begin
			if TrySplit2(lp[i]) then exit;
		end;
	end;
	write('NO');
end;

begin
	assign(input, 'stragain.in');
	assign(output, 'stragain.out');
	reset(input);
	rewrite(output);
	Load;
	Solve;
	close(input);
	close(output);
end.
