#include <stdio.h>
#include <windows.h>

char a [131072];
char b [131072];

DWORD start;

struct seg
{
  int beg, len, end;
};
seg as [131072];
seg bs [131072];
int n_as, n_bs;
int len;

void read_input ()
{
  FILE* f = fopen ( "holytape.in", "rt" );
  fscanf ( f, "%s %s", a, b );
  fclose ( f );

  char last = '0';
  n_as = 0;
  int i;
  for ( i = 0; a [i] != 0; i++ )
  {
    if ( a [i] == '0' && last == '1' )
    {
      as [n_as].end = i;
      as [n_as].len = i - as [n_as].beg;
      n_as++;
    }
    if ( a [i] == '1' && last == '0' )
      as [n_as].beg = i;
    last = a [i];
  }
  if ( last == '1' )
  {
    as [n_as].end = i;
    as [n_as].len = i - as [n_as].beg;
    n_as++;
  }
  len = i;

  last = '0';
  n_bs = 0;
  i;
  for ( i = 0; b [i] != 0; i++ )
  {
    if ( b [i] == '0' && last == '1' )
    {
      bs [n_bs].end = i;
      bs [n_bs].len = i - bs [n_bs].beg;
      n_bs++;
    }
    if ( b [i] == '1' && last == '0' )
      bs [n_bs].beg = i;
    last = b [i];
  }
  if ( last == '1' )
  {
    bs [n_bs].end = i;
    bs [n_bs].len = i - bs [n_bs].beg;
    n_bs++;
  }
  if ( len < i )
    len = i;
}

int result = 0;

void solve ()
{
  for ( int i = 0; i < len*2; i++ )
  {
    if ( GetTickCount () > start + 9500 )
    {
      result = -result;
      return;
    }

    int offset = ( ( i & 1 ) == 0 ? -(i>>1) : (i>>1) );

    int count = 0;
    int a_seg = 0;
    int b_seg = 0;

    while ( a_seg < n_as && b_seg < n_bs )
    {
      if ( as [a_seg].beg < bs [b_seg].beg+offset )
      {
        if ( as [a_seg].end > bs [b_seg].beg+offset )
          count++;
        if ( as [a_seg].end > bs [b_seg].end+offset )
          b_seg++;
        else
          a_seg++;
      }
      else
      {
        if ( bs [b_seg].end+offset > as [a_seg].beg )
          count++;
        if ( bs [b_seg].end+offset > as [a_seg].end )
          a_seg++;
        else
          b_seg++;
      }
    }

    if ( count > result )
      result = count;
    if ( result >= n_as && result >= n_bs )
      return;
  }
}

void write_output ()
{
  FILE* f = fopen ( "holytape.out", "wt" );
  fprintf ( f, "%d", result );
  fclose ( f );
}

int main ()
{
  start = GetTickCount ();

  read_input ();
  solve ();
  write_output ();

  return 0;
}
