#include <stdio.h>
#include <string.h>

#define INF (int)1e9
#define MAXV 410
#define MAXE 20010

int E = 0, N, M, K, St, En, He[MAXV], Ne[MAXE], Y[MAXE], F[MAXE];
int U[MAXV];

void AddE( int a, int b, int f )
{
  Ne[E] = He[a], Y[E] = b, F[E] = 0, He[a] = E++; 
  Ne[E] = He[b], Y[E] = a, F[E] = f, He[b] = E++; 
}

int dfs( int v, int dep )
{
  int e;

  if (v == En)
    return 0;
  U[v] = 1;
  for (e = He[v]; e != -1; e = Ne[e])
    if (F[e] < 1 && ((dep > 2 && Y[e] == En) || (!U[Y[e]] && dfs(Y[e], dep + 1))))
    {
//      printf("%d ", v);
      F[e]++, F[e ^ 1]--;
      return 1;
    }
  return 0;
}

int main( void )
{
  int i, j;

  freopen("peace.in", "rt", stdin);
  freopen("peace.out", "wt", stdout);
  scanf("%d%d%d", &N, &M, &K);
  memset(He, -1, sizeof(He));
  St = 0, En = 4 * N + 1;
  while (K--)
  {
    scanf("%d", &i);
    AddE(St, i, INF), AddE(i, i + N, INF), AddE(i + N, i + 2 * N, INF);
    AddE(i + N, En, INF);
  }
  for (i = 1; i <= N; i++)
  {
    AddE(i + 2 * N, i + 3 * N, 1);
    AddE(i + 3 * N, i, INF);
  }
  while (M--)
  {
    scanf("%d%d", &i, &j);
    AddE(i + 3 * N, j + 2 * N, 1);
    AddE(j + 3 * N, i + 2 * N, 1);
  }
  memset(U, 0, sizeof(U)), i = 0;
  while (dfs(St, 0))
  {
//    puts("");
    memset(U, 0, sizeof(U));
    i++;
  }
  printf("%d", i);
  return 0;
}
