const
        MaxN = 80;
var
        n, m, k : LongInt;
        sm : Array[1 .. MaxN, 1 .. MaxN{FROM}, 0 .. 1, 1 .. MaxN, 1 .. MaxN, 0 .. 1] of Byte;
        a : Array[1 .. MaxN] of Boolean;
        demo : Array[1 .. MaxN] of LongInt;
        usedinDFS : Array[1 .. MaxN, 1 .. MaxN, 0 .. 1] of Boolean;

Procedure Init;
var
        i, j, x, y : LongInt;
begin
  ReadLn(n, m, k);
  FillChar(sm, SizeOf(sm), False);
  for i := 1 to k do
  begin
    Read(x);
    a[x] := True;
  end;
  for i := 1 to n do
    for j := 1 to n do
      sm[i][j][0][i][j][1] := 1;
  for i := 1 to m do
  begin
    Read(x, y);
    for j := 1 to n do
    begin
      sm[x][j][1][y][j][0] := 1;
      sm[y][j][1][x][j][0] := 1;
    end;
  end;
end;

Function DFS(const x, y, z : Byte) : Boolean;
var
        d, e, f : Byte;
begin
  DFS := False;
  if usedinDFS[x][y][z] then
    Exit;
  for d := 1 to n do if d <> y then
    if (a[d]) and (sm[x][y][z][d][1][0] > 0) and (demo[d] = 0) then
    begin
      DFS := True;
      Dec(sm[x][y][z][d][1][0]);
      Inc(sm[d][1][0][x][y][z]);
      demo[d] := 1;
      Exit;
    end;
  usedinDFS[x][y][z] := True;
  for d := 1 to n do
    if (not a[d]) or (d = x) then
      for e := 1 to n do
        for f := 0 to 1 do
          if sm[x][y][z][d][e][f] > 0 then
            if DFS(d, e, f) then
            begin
              Inc(sm[d][e][f][x][y][z]);
              Dec(sm[x][y][z][d][e][f]);
              DFS := True;
              Exit;
            end;
end;

Procedure Solve;
var
        i, rez : LongInt;
begin
  rez := 0;
  for i := 1 to n do
  begin
    While DFS(i, i, 0) do
    begin
      FillChar(UsedInDFS, SizeOf(UsedInDFS), False);
      Inc(rez);
    end;
  end;
  Write(rez);
end;

Procedure Print;
begin
end;

begin
  Assign(input, 'peace.in');
  Reset(input);
  Assign(output, 'peace.out');
  Rewrite(output);
  Init;
  Solve;
  Print;
  Close(input);
  Close(output);
end.
