const
        MaxL = 5200;
type
        TStr =
        record
          len : Word;
          s : Array[1 .. MaxL] of Char;
        end;
var
        a, b : TStr;
        p : Array[1 .. MaxL] of LongInt;

Procedure CPF;
var
        i : LongInt;
begin
  p[1] := 0;
  for i := 2 to a.len do
  begin
    p[i] := p[i - 1];
    While (p[i] <> 0) and (a.s[i] <> a.s[p[i] + 1]) do
      p[i] := p[p[i]];
    if a.s[i] = a.s[p[i] + 1] then
      Inc(p[i]);
  end;
end;

Procedure ReadS(var s : TStr);
begin
  s.len := 0;
  While not SeekEoLn do
  begin
    Inc(s.len);
    Read(s.s[s.len]);
  end;
  ReadLn;
end;

Procedure Done;
begin
  Close(input);
  Close(output);
  Halt;
end;

Procedure No;
begin
  Write('NO');
  Done;
end;

Procedure Init;
begin
  ReadS(a);
  ReadS(b);
  if (a.len < 3) or (b.len < 3) or (a.len <> b.len) then
    No;
end;

Procedure Yes(const aa, bb, cc : LongInt);
var
        i : LongInt;
begin
  WriteLn('YES');
  for i := aa to bb - 1 do
    Write(a.s[i]);
  WriteLn;
  for i := bb to cc - 1 do
    Write(a.s[i]);
  WriteLn;
  for i := cc to a.len do
    Write(a.s[i]);
  Done;
end;

Procedure TestBegin;
var
        bo : Boolean;
        i, f, tek : LongInt;
        p : Array[1 .. MaxL] of LongInt;

Procedure CPF;
var
        i : LongInt;
begin
  FIllChar(p, SizeOf(p), 0);
  p[1] := 0;
  for i := 2 to a.len - f + 1 do
  begin
    p[i] := p[i - 1];
    While (p[i] <> 0) and (a.s[i + f - 1] <> a.s[p[i] + f]) do
      p[i] := p[p[i]];
    if a.s[i + f - 1] = a.s[p[i] + f] then
      Inc(p[i]);
  end;
end;

begin
  bo := True;
  f := 1;
  While (a.s[f] = b.s[f]) and (f < a.len) do
    Inc(f);
  if (f = a.len) and (a.s[f] = b.s[f]) then
    Yes(1, 2, 3);
  if (f = a.len) or (f = 1) then
    Exit;
  CPF;
  tek := 0;
  for i := 1 to b.len - f + 1 do
  begin
      While (b.s[i + f - 1] <> a.s[tek + f]) and (tek <> 0) do
        tek := p[tek];
      if b.s[i + f - 1] = a.s[tek + f] then
        Inc(tek);
  end;
  for i := f to b.len - tek do
    if b.s[i] <> a.s[i + tek] then
      Exit;
  Yes(1, f, f + tek);
end;

Procedure TestEnd(const l : LongInt);
var
        p : Array[1 .. MaxL] of LongInt;

Procedure TestAB;
var
        i : LongInt;
begin
  for i := 1 to l do
    if b.s[i] <> a.s[a.len - l + i] then
      Exit;
  Yes(1, a.len - l + 1, a.len - l + 2);
end;

Procedure TestBA;
var
        i, tek : LongInt;
begin
  p[1] := 0;
  for i := 2 to l do
  begin
    p[i] := p[i - 1];
    While (p[i] <> 0) and (b.s[i] <> b.s[p[i] + 1]) do
      p[i] := p[p[i]];
    if b.s[i] = b.s[p[i] + 1] then
      Inc(p[i]);
  end;
  tek := 0;
  for i := a.len - l + 1 to a.len do
  begin
      While (a.s[i] <> b.s[tek + 1]) and (tek <> 0) do
        tek := p[tek];
      if a.s[i] = b.s[tek + 1] then
        Inc(tek);
  end;
  for i := tek + 1 to l do
    if b.s[i] <> a.s[i - tek - 1 + a.len - l + 1] then
      Exit;
  Yes(1, a.len - l + 1, a.len - tek + 1);
end;

begin
  TestAB;
  TestBA;
end;

Procedure Test(const l, f : LongInt);

Procedure TestAB;
var
        i : longInt;
begin
  for i := 1 to l do
    if b.s[i] <> a.s[f - l - 1 + i] then
      Exit;
  for i := f to b.len do
    if b.s[i] <> a.s[i] then
      Exit;
  YES(1, f - l, f);
end;

Procedure TestBA;
var
        i : longInt;
begin
  for i := 1 to l do
    if b.s[i] <> a.s[a.len - l + i] then
      Exit;
  for i := f to b.len do
    if b.s[i] <> a.s[i - l] then
      Exit;
  YES(1, l + 1, f);
end;

begin
  TestAB;
  TestBA;
end;

Procedure Solve;
var
        i, tek, l : LongInt;
begin
  CPF;
  TestBegin;
  for l := a.len - 2 downto 1 do
  begin
    tek := 0;
    for i := 1 to b.len do
    begin
      While (b.s[i] <> a.s[tek + 1]) and (tek <> 0) do
        tek := p[tek];
      if b.s[i] = a.s[tek + 1] then
        Inc(tek);
      if tek = l then
      begin
        if i = l then
        else
          if i = b.len then
            TestEnd(i - l){last in checked}
          else
            Test(i - l, i + 1);{last&first in checked}
        tek := p[tek];
      end;
    end;
  end;
  No;
end;

Procedure Print;
begin
end;

begin
  Assign(input, 'stragain.in');
  Reset(input);
  Assign(output, 'stragain.out');
  Rewrite(output);
  Init;
  Solve;
  Print;
  Close(input);
  Close(output);
end.
