#include <stdio.h>
#include <string.h>

#define MAXL 10010
#define MAXV 810010

#define MAX(A, B) (((A) >= (B)) ? (A) : (B))

int V, N, L, R, C[MAXV], E[MAXV], qs, qz, Q[MAXV], D[MAXV];
char S[MAXL];

#define GETV(I, C1, C2) (((I) * 9 + (C1) - 'a') * 9 + (C2) - 'a')
#define GETI(U) ((U) / 81)
#define GETC1(U) (((U) / 9) % 9 + 'a')
#define GETC2(U) ((U) % 9 + 'a')

int main( void )
{
  int c, i, k, t;

  freopen("strgame.in", "rt", stdin);
  freopen("strgame.out", "wt", stdout);

  scanf("%s", S);
  scanf("%d%d", &L, &R);
  memset(C, 0, sizeof(C));
  memset(E, 0, sizeof(E));
  N = strlen(S);
  L %= N;
  if (!L) L = N;
  R %= N;
  if (!R) R = N;
  V = N * 81;
  qs = qz = 0;
  for (i = 0; i < V; i++)
  {
    for (k = 1; k <= R; k++)
      if (S[(GETI(i) + k) % N] != S[GETI(i)] &&
          S[(GETI(i) + k) % N] != GETC1(i) &&
          S[(GETI(i) + k) % N] != GETC2(i))
        E[i]++;
    for (k = 1; k <= L; k++)
      if (S[(GETI(i) + N - k) % N] != S[GETI(i)] &&
          S[(GETI(i) + N - k) % N] != GETC1(i) &&
          S[(GETI(i) + N - k) % N] != GETC2(i))
        E[i]++;
    if (!E[i])
      Q[qs + qz++] = i, C[i] = 1, D[i] = 0;
  }
  while (qz)
  {
    t = Q[qs++], qz--;
    for (k = 1; k <= L; k++)
      for (c = 'a'; c <= 'i'; c++)
      {
        int ti = (GETI(t) + k) % N;
        if (S[ti] == GETC1(t) &&
            S[GETI(t)] != GETC1(t) &&
            S[GETI(t)] != GETC2(t) &&
            S[GETI(t)] != c &&
            !C[GETV(ti, GETC2(t), c)])
          if (C[t] == 2)
          {
            D[GETV(ti, GETC2(t), c)] = MAX(D[GETV(ti, GETC2(t), c)], D[t] + 1);
            if (!(--E[GETV(ti, GETC2(t), c)]))
            {
              C[GETV(ti, GETC2(t), c)] = 1;
              Q[qs + qz++] = GETV(ti, GETC2(t), c);
            }
          }
          else
          {
            C[GETV(ti, GETC2(t), c)] = 2;
            D[GETV(ti, GETC2(t), c)] = D[t] + 1;
            Q[qs + qz++] = GETV(ti, GETC2(t), c);
          }
      }
    for (k = 1; k <= R; k++)
      for (c = 'a'; c <= 'i'; c++)
      {
        int ti = (GETI(t) + N - k) % N;
        if (S[ti] == GETC1(t) &&
            S[GETI(t)] != GETC1(t) &&
            S[GETI(t)] != GETC2(t) &&
            S[GETI(t)] != c &&
            !C[GETV(ti, GETC2(t), c)])
          if (C[t] == 2)
          {
            D[GETV(ti, GETC2(t), c)] = MAX(D[GETV(ti, GETC2(t), c)], D[t] + 1);
            if (!(--E[GETV(ti, GETC2(t), c)]))
            {
              C[GETV(ti, GETC2(t), c)] = 1;
              Q[qs + qz++] = GETV(ti, GETC2(t), c);
            }
          }
          else
          {
            C[GETV(ti, GETC2(t), c)] = 2;
            D[GETV(ti, GETC2(t), c)] = D[t] + 1;
            Q[qs + qz++] = GETV(ti, GETC2(t), c);
          }
      }
  }
/*
  printf("    ");
  for (t = 0; t < N; t++)
    printf("%c", S[t]);
  fputc('\n', stdout);
  for (i = 'a'; i <= 'i'; i++)
    for (k = 'a'; k <= 'i'; k++)
    {
      printf("%c%c: ", i, k);
      for (t = 0; t < N; t++)
        printf("%d", C[GETV(t, i, k)]);
      printf(" | ", i, k);
      for (t = 0; t < N; t++)
        printf("%d", D[GETV(t, i, k)]);
      fputc('\n', stdout);
    }
*/
  if (!C[GETV(0, 'i', 'i')])
    printf("DRAW\n");
  else if (C[GETV(0, 'i', 'i')] == 1)
    printf("LOSE\n%d\n", D[GETV(0, 'i', 'i')]);
  else
  {
    int A = GETV(0, 'i', 'i');
    printf("WIN\n%d\n", D[A]);
    i = 0;
    for (k = 1; k <= R && !i; k++)
      if (S[k % N] != S[0] &&
          C[GETV(k % N, S[0], GETC1(A))] == 1 &&
          D[GETV(k % N, S[0], GETC1(A))] == D[A] - 1)
            i = k;
    for (k = 1; k <= L && !i; k++)
      if (S[(N - k) % N] != S[0] &&
          C[GETV((N - k) % N, S[0], GETC1(A))] == 1 &&
          D[GETV((N - k) % N, S[0], GETC1(A))] == D[A] - 1)
            i = -k;
    printf("%d\n", i);
  }

  return 0;
}
