uses math;
const taskname='polyline';eps=1e-9;
type real=extended;
type tv=record x,y:real;end;
var
  t:text;
  n,maxi,max,i,j:longint;
  v1,v2,v3,tv1,tv2,maxv1,maxv2:tv;
  x,y:array[1..2000] of real;
  a,b,c,x1,y1,x2,y2,miny,maxy,ang1,r,ang:real;
  op:boolean;
function cl(v1,v2:tv):boolean;
begin
  cl:=(v1.x*v2.y-v2.x*v1.y)<eps;
end;

procedure turn(x1,y1,ang:real;var x2,y2:real);
var ang1:real;
begin
    ang1:=arctan2(x2-x1,y2-y1);
    r:=sqrt(sqr(x2-x1)+sqr(y2-y1));
    x2:=r*cos(ang1-ang)+x1;
    y2:=r*sin(ang1-ang)+y1;
end;
begin
  assign(t,taskname+'.in');
  reset(t);
  readln(t,n);
  for i:=1 to n do read(t,x[i],y[i]);
  close(t);
  for i:=1 to n-2 do
  begin
    v1.x:=x[i+1]-x[i];
    v1.y:=y[i+1]-y[i];
    v2.x:=x[i+2]-x[i];
    v2.y:=y[i+2]-y[i];
    if cl(v1,v2) then
    begin
      v2.x:=x[i+2]-x[i+1];
      v2.y:=y[i+2]-y[i+1];
      j:=i+2;
      op:=false;
      while (cl(v1,v2))and(j<n) do
      begin
        tv1:=v1;
        tv2:=v2;
        op:=not op;
        inc(j);
        if op then
        begin
          v3.x:=x[j]-x[i];
          v3.y:=y[j]-y[i];
          if cl(v1,v3) then v1:=v3;
        end else
        begin
          v3.x:=x[j]-x[i+1];
          v3.y:=y[j]-y[i+1];
          if cl(v3,v2) then v2:=v3;
        end;
      end;
      if cl(v1,v2) then
      begin
        tv1:=v1;
        tv2:=v2;
        inc(j);
      end;
      if (j-i)>max then
      begin
        maxv1:=tv1;
        maxv2:=tv2;
        maxi:=i;
        max:=j-i;
      end;
    end;
  end;

  v3.x:=maxv1.x+maxv2.x;
  v3.y:=maxv1.y+maxv2.y;
  ang:=arctan2(v3.x,v3.y);

  for i:=2 to n do
  begin
    turn(x[1],y[1],ang,x[i],y[i]);
{    ang1:=arctan2(x[i]-x[1],y[i]-y[1]);
    r:=sqrt(sqr(x[i]-x[1])+sqr(y[i]-y[1]));
    x[i]:=r*cos(ang1-ang)+x[1];
    y[i]:=r*sin(ang1-ang)+y[1];}
  end;

  maxy:=-maxlongint;
  miny:=maxlongint;
  op:=y[maxi]<y[maxi+1];
  for i:=maxi to max+maxi-1 do
  begin
    if op then
    begin
      if y[i]>maxy then maxy:=y[i];
    end else
    begin
      if y[i]<miny then miny:=y[i];
    end;
    op:=not op;
  end;

  x1:=0;
  x2:=1;
  y1:=(miny+maxy)/2;
  y2:=(miny+maxy)/2;

  turn(x[1],y[1],-ang,x1,y1);
  turn(x[1],y[1],-ang,x2,y2);

  assign(t,taskname+'.out');
  rewrite(t);
  a:=(y2-y1);
  b:=(x1-x2);
  c:=-(a*x1+b*y1);
  writeln(t,a);
  writeln(t,b);
  writeln(t,c);
{
  writeln(t,a*x1+b*y1+c);
  writeln(t,a*x2+b*y2+c);}
  close(t);
end.
