{$I-,Q-,R-,S-}
//{$I+,Q+,R+,S+}
program Temp;

const
 in_f='strgame.in';
 out_f='strgame.out';
type
  int=longint;
  real=extended;
  bool=boolean;
  Tpos=record
    i,L1,L2:int;
    end;
const
  maxN=10000;
  CC=8;
  dx=50;
  XXX=maxN*sqr(cc+1);
  Draw=-2;
  Win=-1;
  Lose=0;
  ss:array[-2..0] of string=('DRAW','WIN','LOSE');
var
  N:int;
  S:array[1..maxN] of int;
  L,R:int;
  pos,time:array[1..maxN,0..CC,0..CC] of int;

  och:array[1..XXX] of TPos;
  boch,eoch:int;

  sdvig:array[1..maxN,-dx..dx] of int;

procedure Init;
 var
   ch:char;
 begin
   N:=0;
   while not seekeoln do
     begin
       Read(ch);
       inc(N);
       s[n]:=ord(ch)-ord('a')+1;
     end;
   Read(L,R);
 end;


procedure Add(i,l1,l2,tt:int);
 begin
   time[i,l1,l2]:=tt;
   Inc(eoch);
   och[eoch].i:=i;
   och[eoch].L1:=L1;
   och[eoch].L2:=L2;
 end;


procedure Run;
 var
   i,inew,iold,j:int;
   L1,L2:int;
   tmp:int;
   cur:TPos;
   imin:int;
   min:int;
 begin
   Init;
   for i := 1 to N do
     for j := -dx to dx do
       sdvig[i,j]:=((i+j-1) mod N+N)mod N+1;
   fillchar(time,sizeof(time),255);
   boch:=1;
   eoch:=0;
   for i := 1 to N do
     for L1:= 0 to CC do
       if s[i]<>L1 then
         for L2:= 0 to CC do
           if (s[i]<>L2) and ((L1<>l2) or (L2=0)) then
             begin
               pos[i,L1,l2]:=0;
               for j := -L to R do
                 begin
                   inew:=sdvig[i,j];
                   tmp:=s[inew];
                   if (tmp<>L1) and (tmp<>L2) and (tmp<>s[i]) then
                     inc(pos[i,L1,L2]);
                 end;
               if pos[i,L1,L2]=Lose then
                 Add(i,L1,L2,0);
             end;

   while (boch<=eoch) and (pos[1,0,0]>0) do
     begin
       cur:=och[boch];
       for j := -R to L do
         begin
           iold:=sdvig[i,j];
           if s[iold]=cur.L1 then
           for tmp:= 0 to CC do
             if time[iold,cur.L2,tmp]=-1 then
               if ((tmp<>cur.L2) and (tmp<>cur.L1) and (tmp<>s[cur.i])) or (tmp=0) then
                 if pos[cur.i,cur.L1,cur.L2]=Lose then
                   begin
                     pos[iold,cur.L2,tmp]:=Win;
                     Add(iold,cur.L2,tmp,time[cur.i,cur.L1,cur.L2]+1);
                   end
                 else
                   begin
                     dec(pos[iold,cur.L2,tmp]);
                     if pos[iold,cur.L2,tmp]=Lose then
                       Add(iold,cur.L2,tmp,time[cur.i,cur.L1,cur.L2]+1);
                   end;
         end;
       inc(boch);
     end;
   for i := 1 to N do
     for L1:= 0 to CC do
       for L2:= 0 to CC do
         if pos[i,L1,L2]>0 then
           pos[i,L1,L2]:=Draw;
   Writeln(ss[pos[1,0,0]]);
   if (pos[1,0,0]=Lose) or (pos[1,0,0]=Win) then
     Writeln(time[1,0,0]);
   if pos[1,0,0]=Win then
     begin
       imin:=0;
       min:=time[1,0,0];
       for J := -L to R do
         begin
           inew:=sdvig[1,j];
           if (s[inew]<>s[1]) and (pos[inew,s[1],0]=Lose) then
             if time[inew,s[1],0]<min then
               begin
                 min:=time[inew,s[1],0];
                 imin:=j;
               end;
         end;
      Writeln(imin);
     end;
 end;

procedure OpenFiles;
 begin
  Assign(input,in_f);
  Reset(input);
  Assign(output,out_f);
  Rewrite(output);
 end;

procedure CloseFiles;
 begin
  Close(input);
  Close(output);
 end;

Begin
OpenFiles;
Run;
CloseFiles;
End.

