type integer = longint;
const eps = 1e-8;
	  eps2 = 1e-6;
var n : integer;
	px, py : array[1..2100] of extended;

procedure Load;
var i : integer;
begin
	read(n);
	for i := 1 to n do begin
		read(px[i], py[i]);
	end;
end;

var gcnt, max : integer;
	ma, mb, mc : extended;

procedure MakeLine(x1, y1, x2, y2 : extended; var a, b, c : extended);
begin
	a := y1 - y2;
	b := x2 - x1;
	c := - a * x1 - b * y1;
end;

var res, was : array[1..2001] of integer;

function InterLineOtr(a, b, c, x1, y1, x2, y2 : extended) : boolean;
var dd1, dd2 : extended;
begin
	dd1 := a * x1 + b * y1 + c;
	dd2 := a * x2 + b * y2 + c;
	if (dd1 * dd2 < -eps) then InterLineOtr := true
	else InterLineOtr := false;
end;

procedure CheckLine(a, b, c: extended);
var i : integer;
begin
	inc(gcnt);
	for i := 1 to n - 1 do begin	
		if InterLineOtr(a, b, c, px[i], py[i], px[i + 1], py[i + 1]) then was[i] := gcnt;
	end;
	res[n + 1] := 0;
	for i := n downto 1 do begin
		if was[i] <> gcnt then res[i] := 0
		else res[i] := res[i + 1] + 1;
	end;
	for i := 1 to n do begin
		if res[i] > max then begin
			max := res[i];
			ma := a;
			mb := b;
			mc := c;
		end;
	end;
end;

procedure Solve;
var i, j : integer;
	a, b, c : extended;
begin
	gcnt := 0;
	max := 0;
	for i := 1 to n do begin
		for j := i + 1 to n do begin
			MakeLine(px[i], py[i], px[j], py[j], a, b, c);
			CheckLine(a, b, c + eps2);
			CheckLine(a, b, c - eps2);
		end;
	end;
	writeln(ma : 0 : 15);
	writeln(mb : 0 : 15);
	writeln(mc : 0 : 15);
end;

begin
	assign(input, 'polyline.in');
	assign(output, 'polyline.out');
	reset(input);
	rewrite(output);
	Load;
	Solve;
	close(input);
	close(output);
end.
