#include <stdio.h>

#define LOSE 1
#define WIN 2
#define DRAW 0
#define  SWAP(a, b, c) ((c) = (a), (a) = (b), (b) = (c))

int Pos[10002][8][8][4], R, L; /* pos, p, pp, [3] : was, state, cnt, go cnt */
char S[10002], SN;

typedef struct
{
  int pos, p, pp;
} Position;

Position P1[2000000], P2[2000000];
int main( void )
{
  int i, j, k, AN, BN, pos, p, pp, f, p1, pp1, bst = LOSE, bp = 0, bpp = 0, bcnt = 2000000000, bk, OldL, OldR,
  bst1, bp1, bpp1, bcnt1;
  char c;
  Position *A = P1, *B = P2, *C;

  freopen("strgame.in", "rt", stdin);
  freopen("strgame.out", "wt", stdout);
  while ((c = getc(stdin)) >= 'a' && c <= 'h')
    S[SN++] = c - 'a';
  scanf("%i%i", &L, &R);

  /* !!! */
  if (L + R >= SN - 1)
    OldL = L, OldR = R,
    L = 1, R = SN - 2;
  else
    OldL = L, OldR = R;
  
  AN = 0;
  k = 0;
  //printf("----0----\n");
  for (pos = 0; pos < SN; pos++)
    for (p = 0; p < 8; p++)
      for (pp = 0; pp < 8; pp++)
      {
         f = 0;
         for (i = 1, j = (pos + 1) % SN; i <= R; i++, j = (j + 1) % SN)
           if (S[j] != S[pos] && S[j] != p && S[j] != pp)
             f++; 
         for (i = 1, j = (pos + SN - 1) % SN; i <= L; i++, j = (j + SN - 1) % SN)
           if (S[j] != S[pos] && S[j] != p && S[j] != pp)
             f++; 
         if (!f)
         {
           A[AN].pos = pos;
           A[AN].p = p;
           A[AN++].pp = pp;
           Pos[pos][p][pp][0] = 1;
           Pos[pos][p][pp][1] = LOSE;
           Pos[pos][p][pp][2] = 0;
           Pos[pos][p][pp][3] = f;
           //printf("LOSE position pos %i, p %i, pp %i\n", pos, p, pp);
         }
      }
  BN = 0;
  L = OldL;
  R = OldR;
//  printf("----1----\n");
  while (AN > 0)
  {
    for (k = 0; k < AN; k++)
    {
      pos = A[k].pos;
      p = A[k].p;
      pp = A[k].pp;
      /* Run right for L */
      for (i = 1, j = (pos + 1) % SN; i <= L; i++, j = (j + 1) % SN)
        if (S[j] == p)
        {
          p1 = pp;
          for (pp1 = 0; pp1 < 8; pp1++)
            if (!Pos[j][p1][pp1][0]) /* now was */
            {
              if (Pos[pos][p][pp][1] == LOSE)
              {
                Pos[j][p1][pp1][0] = 1;                                                      
                Pos[j][p1][pp1][1] = WIN;
                Pos[j][p1][pp1][2] = Pos[pos][p][pp][2] + 1;
                B[BN].pos = j;
                B[BN].p = p1;
                B[BN++].pp = pp1;
              }
              else
              {
                if (--Pos[j][p1][pp1][3] == 0)
                {
                  Pos[j][p1][pp1][0] = 1;
                  Pos[j][p1][pp1][1] = LOSE;
                  Pos[j][p1][pp1][2] = Pos[pos][p][pp][2] + 1;
                  B[BN].pos = j;
                  B[BN].p = p1;
                  B[BN++].pp = pp1;
                }
              }
            }
        }
      /* Run left for R */
      for (i = 1, j = (pos + SN - 1) % SN; i <= R; i++, j = (j + SN - 1) % SN)
        if (S[j] == p)
        {
          p1 = pp;
          for (pp1 = 0; pp1 < 8; pp1++)
            if (!Pos[j][p1][pp1][0]) /* no was */
            {
                
              if (Pos[pos][p][pp][1] == LOSE)
              {
                Pos[j][p1][pp1][0] = 1;
                Pos[j][p1][pp1][1] = WIN;
                Pos[j][p1][pp1][2] = Pos[pos][p][pp][2] + 1;
                B[BN].pos = j;
                B[BN].p = p1;
                B[BN++].pp = pp1;
              }
              else
              {
                if (--Pos[j][p1][pp1][3] == 0)
                {
                  Pos[j][p1][pp1][0] = 1;
                  Pos[j][p1][pp1][1] = LOSE;
                  Pos[j][p1][pp1][2] = Pos[pos][p][pp][2] + 1;
                  B[BN].pos = j;
                  B[BN].p = p1;
                  B[BN++].pp = pp1;
                }
              }
            }
        }
    }
    AN = BN;
    BN = 0;
    SWAP(A, B, C);
	
  }

  for (k = -L; k <= R; k++)
    if (k != 0)
    {
      pos = (k + 100 * SN) % SN;
      if (S[pos] == S[0])
      {
        if (bst == LOSE && bcnt == 2000000000)
          bcnt = 0;
        continue;
      }
        
      bst1 = LOSE;
      bcnt1 = 2000000000;
      p = S[0];
      for (pp = 0; pp < 8; pp++)
        if ((Pos[pos][p][pp][1] == bst1 && Pos[pos][p][pp][2] < bcnt1)
        || (Pos[pos][p][pp][1] == DRAW && bst1 == LOSE) ||
        (Pos[pos][p][pp][1] == WIN && (bst1 == LOSE || bst1 == DRAW)))		      
        {
          bp1 = p;
          bpp1 = pp;
          bst1 = Pos[pos][p][pp][1];
          bcnt1 = Pos[pos][p][pp][2];
        }
      if (bst1 == WIN)
        bst1 = LOSE;
      else
        if (bst1 == LOSE)
          bst1 = WIN;

      bcnt1++;
      if ((bst1 == bst && bcnt1 < bcnt)
      || (bst1 == DRAW && bst == LOSE) ||
      (bst1 == WIN && (bst == LOSE || bst == DRAW)))		      
      {
        bst = bst1;
        bcnt = bcnt1;
        bk = k;
      }

        
    }

     
    
  if (bst == DRAW)
  {
    printf("DRAW");
    return 0;
  }
  if (bst == LOSE)
  {
    printf("LOSE\n%i", bcnt);
    return 0;
  }
  printf("WIN\n%i\n%i", bcnt, bk);
  return 0;
}
