{$I-,Q-,R-,S-,H+}
{$M 60000000,60000000}
type pqueue=^tqueue;
     tqueue=record
       p:longint;
       c1,c2:char;
       next,prev:pqueue;
     end;
var s:string;
    n,l,r,p,i:longint;
    was:array [1..10000,'a'..'i','a'..'i'] of boolean;
    state,degree:array [1..10000,'a'..'i','a'..'i'] of longint;
    queue:pqueue;
    c1,c2,c3:char;
function min(c1,c2:char):char;
begin
  if c1<c2 then
    min:=c1
  else min:=c2;
end;
function max(c1,c2:char):char;
begin
  if c1>c2 then
    max:=c1
  else max:=c2;
end;
function move(p,q:longint):longint;
begin
  move:=((p+q-1) mod n+n) mod n+1;
end;
procedure enqueue(p:longint;c1,c2:char);
var tmp:pqueue;
begin
  new(tmp);
  tmp^.p:=p;
  tmp^.c1:=c1;
  tmp^.c2:=c2;
  tmp^.next:=queue;
  tmp^.prev:=queue^.prev;
  tmp^.next^.prev:=tmp;
  tmp^.prev^.next:=tmp;
end;
procedure dfs(p:longint;c1,c2:char);
var i:longint;
begin
  was[p,c1,c2]:=true;
  degree[p,c1,c2]:=0;
  for i:=-l to r do
    if (s[move(p,i)]<>s[p]) and
       (s[move(p,i)]<>c1) and
       (s[move(p,i)]<>c2) then
    begin
      if not was[move(p,i),s[p],c1] then
        dfs(move(p,i),s[p],c1);
      inc(degree[p,c1,c2]);
    end;
  if degree[p,c1,c2]=0 then
  begin
    state[p,c1,c2]:=-1;
    enqueue(p,c1,c2);
  end;
end;
procedure dequeue(var p:longint;var c1,c2:char);
var tmp:pqueue;
begin
  tmp:=queue^.next;
  p:=tmp^.p;
  c1:=tmp^.c1;
  c2:=tmp^.c2;
  tmp^.next^.prev:=tmp^.prev;
  tmp^.prev^.next:=tmp^.next;
  dispose(tmp);
end;
begin
  assign(input,'strgame.in');
  reset(input);
  readln(s);
  readln(l,r);
  n:=length(s);
  fillchar(was,sizeof(was),false);
  fillchar(state,sizeof(state),0);
  new(queue);
  queue^.next:=queue;
  queue^.prev:=queue;
  dfs(1,'i','i');
  while queue^.next<>queue do
  begin
    dequeue(p,c1,c2);
    for i:=-r to l do
      if (i<>0) and (s[move(p,i)]=c1) then
        for c3:='a' to 'i' do
          if was[move(p,i),c2,c3] and
             (s[p]<>s[move(p,i)]) and
             (s[p]<>c2) and
             (s[p]<>c3) then
          begin
            if state[move(p,i),c2,c3]<>0 then
              continue;
            if state[p,c1,c2]<0 then
            begin
              state[move(p,i),c2,c3]:=-state[p,c1,c2]+1;
              enqueue(move(p,i),c2,c3);
            end;
            if state[p,c1,c2]>0 then
            begin
              dec(degree[move(p,i),c2,c3]);
              if degree[move(p,i),c2,c3]=0 then
              begin
                state[move(p,i),c2,c3]:=-state[p,c1,c2]-1;
                enqueue(move(p,i),c2,c3);
              end;
            end;
          end;
  end;
  assign(output,'strgame.out');
  rewrite(output);
  if state[1,'i','i']=0 then
    writeln('DRAW')
  else if state[1,'i','i']<0 then
  begin
    writeln('LOSE');
    writeln(-state[1,'i','i']-1);
  end
  else begin
    writeln('WIN');
    writeln(state[1,'i','i']-1);
    for i:=-l to r do
      if (s[move(1,i)]<>s[1]) and (state[move(1,i),s[1],'i']<0) and (-state[move(1,i),s[1],'i']<state[1,'i','i']) then
      begin
        writeln(i);
        break;
      end;
  end;
  close(output);
  close(input);
end.
