#include <stdio.h>
#include <string.h>

#define LEN 10010
#define MAXV (LEN << 6)

#define V(P, A, B) (((P) << 6) + ((A) << 3) + (B))

char S[LEN], Sh[MAXV], F[MAXV], OutDeg[MAXV];
int Len, L, R;
int Po = 0, Si = 0, Q[MAXV], Mov[MAXV];

int main( void )
{
  int x, x1, i, j, c1, c2, c3, e, f, m;

  freopen("strgame.in", "rt", stdin);
  freopen("strgame.out", "wt", stdout);
  scanf("%s%d%d", S, &L, &R), Len = strlen(S);
  for (i = 0; i < Len; i++)
    S[i] -= 'a';
  memset(OutDeg, 0, sizeof(OutDeg));
  for (x = 0; x < Len; x++)
    for (x1 = x - L, i = -L; i <= R; i++, x1++)
      if ((x1 = (x1 % Len + Len) % Len) != x && S[x1] != S[x])
        for (c1 = 0; c1 < 8; c1++)
          for (c2 = 0; c2 < 8; c2++)
            if (S[x1] != c1 && S[x1] != c2)
              OutDeg[V(x, c1, c2)]++;
  memset(F, -1, sizeof(F));
  for (i = 0; i < (Len << 6); i++)
    if (!OutDeg[i])
      F[i] = 0, Mov[i] = 0, Q[Si++] = i;
  memset(Mov, 0, sizeof(Mov));
  while (Po < Si)
  {
    i = Q[Po++], f = F[i], m = Mov[i] + 1;
    x1 = i >> 6, c1 = (i >> 3) & 7, c2 = i & 7;
    for (x = (x1 + L) % Len, i = -L; i <= R; i++, (x = !x ? Len - 1 : x - 1))
      if (S[x] == c1)
        for (c3 = 0; c3 < 8; c3++)
          if (F[j = V(x, c2, c3)] == -1)
          {
            if (!f)
              F[j] = 1, Mov[j] = m, Sh[j] = i, Q[Si++] = j;
            else if (--OutDeg[j] == 0)
              F[j] = 0, Mov[j] = m, Q[Si++] = j;
          }
          else if (!f && F[j] == 1 && Mov[j] == m && Sh[j] > i)
            Sh[j] = i;
  }
  i = V(0, S[0], S[0]);
  if (F[i] == 1)
    printf("WIN\n%d\n%d\n", Mov[i], Sh[i]);
  else if (F[i] == 0)
    printf("LOSE\n%d\n", Mov[i]);
  else
    puts("DRAW");
  return 0;
}
