program cpas;

uses Math;

const eps = 1e-10;

type integer = longint;

var x, y : array [1..2000] of integer;
    x1, y1 : array [1..2000] of extended;
    l, r, l1, r1, a, b, c, an : extended;
    t, n, i, j, cur, best, maxa : integer;
    p1, p3 : array [1..2] of extended;

begin 
   assign(Input, 'polyline.in');
   assign(Output, 'polyline.out');
   reset(Input);
   rewrite(Output);
   read(n);
   for i := 1 to n do
      read(x[i], y[i]); 
   maxa := trunc(500000/n);
   best := 0;
   for t := 0 to maxa-1 do begin
      an := pi*t/maxa;
      for i := 1 to n do begin
         x1[i] := x[i]*cos(an)-y[i]*sin(an);
         y1[i] := y[i]*cos(an)+x[i]*sin(an);
      end;
      for j := 1 to n-1 do begin
         cur := 0;
         l := -1000000; r := 1000000;
         i := j; 
         while (i < n) do begin
            inc(i);
            if x1[i]-x1[i-1] > eps then begin
               l1 := x1[i-1]; r1 := x1[i];
            end else begin
               r1 := x1[i-1]; l1 := x1[i];
            end;
            if (r1-l < eps) or (r-l1 < eps) then break;
            if r-r1 > eps then r := r1;
            if l1-l > eps then l := l1;
            if r-l < eps then break;
            inc(cur);
            if cur > best then begin
               best := cur;
               p1[1] := (r+l)/2; p1[2] := 0;
               p3[1] := p1[1]*cos(an)+p1[2]*sin(an);
               p3[2] := p1[2]*cos(an)-p1[1]*sin(an);
               a := sin(an)*1000;
               b := cos(an)*1000;
               c := -a*p3[1]-b*p3[2];
            end;
         end;
      end;
   end;
   writeln(a);
   writeln(b);
   writeln(c);
   close(Input);
   close(Output);
end.