#include <cstdio>

#define EPS 1e-15

struct table{
  int a[6561], next[65536], b[65536], fre, prcount;
} t;

int m, n, i, j, k, K, L, tmp;
int par[101][6561], u[101][6561], ans[101], best;
long double d[101][6561], sum, a[100][6561];
char pos[101][6561], p;

bool imp(int x){
  int j;
  for (j=1; j<K; j++)
    if (x&(x<<j)) return true;
  return false;
}

bool imp(int x, int y){
  int j;
  for (j=0; j<K; j++){
    if (x&(y<<j)) return true;
    if (y&(x<<j)) return true;
  }
  return false;
}

int pow3(int x){
  int ans=1;
  for ( ; x>0; x--) ans*=3;
  return ans;
}

int f(int x){
  int i, ans=0;
  for (i=0; i<m; i++){
    ans|=(((x%3)/2)<<i);
    x/=3;
  }
  return ans;
}

int l(int x){
  int i, ans=0;
  for (i=0; i<m; i++){
    ans|=(((x%3)&1)<<i);
    x/=3;
  }
  return ans;
}

int join(int x, int y){
  int ans=0, i;
  for (i=m-1; i>=0; i--){
    ans*=3;
    ans+=((x&(1<<i))>>i)*2+((y&(1<<i))>>i);
  }
  return ans;
}

int main(){
  freopen("sprats.in", "rt", stdin);
  freopen("sprats.out", "wt", stdout);
  scanf("%d%d%d%d", &m, &n, &K, &L);
  for (i=0; i<n; i++)
    for (j=0; j<m; j++)
      scanf("%llf", &a[i][j]);
  for (i=0; i<6561; i++) t.a[i]=-1;
  if (L==1){
    t.prcount=(1<<m);
    for (i=0; i<(1<<m); i++){
      if (imp(i)) continue;
      for (j=0; j<(1<<m); j++){
        if (imp(j)) continue;
        t.b[t.fre]=j;
        t.next[t.fre]=t.a[i];
        t.a[i]=t.fre++;
      }
    }
  } else if (L==2){
    t.prcount=(1<<m);
    for (i=0; i<(1<<m); i++){
      if (imp(i)) continue;
      for (j=0; j<(1<<m); j++){
        if (imp(j)) continue;
        if (imp(i, j)) continue;
        t.b[t.fre]=j;
        t.next[t.fre]=t.a[i];
        t.a[i]=t.fre++;
      }
    }
  } else {
    t.prcount=pow3(m);
    for (i=0; i<t.prcount; i++){
      if (imp(f(i))||imp(l(i))) continue;
      for (j=0; j<(1<<m); j++){
        if (imp(j)) continue;
        if (imp(f(i), j)||imp(l(i), j)) continue;
        t.b[t.fre]=join(l(i), j);
        t.next[t.fre]=t.a[i];
        t.a[i]=t.fre++;
      }
    }
  }
  pos[0][0]=1;
  d[0][0]=1;
  for (i=0; i<n; i++){
    for (j=0; j<t.prcount; j++){
      if (pos[i][j]==0) continue;
      for (k=t.a[j]; k!=-1; k=t.next[k]){
        sum=0;
        for (tmp=0; tmp<m; tmp++) if ((1<<tmp)&(L==3?l(t.b[k]):t.b[k])) sum+=a[i][tmp];
        if (sum<EPS) continue;
        if (pos[i+1][t.b[k]]==0||(pos[i+1][t.b[k]]&&d[i+1][t.b[k]]<d[i][j]*sum)){
          d[i+1][t.b[k]]=d[i][j]*sum;
          par[i+1][t.b[k]]=j;
          pos[i+1][t.b[k]]=1;
        }
      }
    }
  }
  sum=0;
  best=-1;
  p=0;
  for (i=0; i<t.prcount; i++)
    if (pos[n][i]){
      p=1;
      if (d[n][i]>sum){
        sum=d[n][i];
        best=i;
      }
    }
  if (p==0)
    printf("IMPOSSIBLE");
  else {
    for (i=n; i>0; best=par[i][best], i--) ans[i-1]=L==3?l(best):best;
    for (i=0; i<n; i++){
      for (j=0; j<m; j++)
        printf("%d ", (1<<j)&ans[i]?1:0);
      printf("\n");
    }
  }
  return 0;
}
