{$R-}
const namein='strgame.in';
      nameout='strgame.out';
      NMax=11000;
      SMax=9;
      QMax=NMax*SMax*SMax;
      Empty='i';
      NA=-1;
      Lose=0;
      Win=1;
      Draw=2;
type
 integer=longint;
 TDp=array [0..NMax,'a'..Empty,'a'..Empty] of integer;
 TVs1=array [0..NMax,'a'..Empty,'a'..Empty] of boolean;
 TVS2=array [0..NMax,'a'..Empty] of boolean;
 TQue1=array [1..QMax] of integer;
 TQue2=array [1..QMax] of char;
 TVect=array [0..NMax] of char;
var d,w,f:TDp;
    s:string;
    q1:TQue1;
    q2,q3:TQue2;
    x:TVect;
    z:TVs1;
    y:TVS2;
    n,l,r,ql,qr:integer;

procedure Init;
var i:integer;
begin
 assign(input,namein);
 reset(input);
 readln(s);
 readln(l,r);
 n:=length(s);
 for i:=0 to n-1 do x[i]:=s[i+1];
 l:=l mod n;
 r:=r mod n;
 close(input)
end;

procedure StartQ;
begin
 ql:=1;
 qr:=1
end;

function EmptyQ:boolean;
begin
 EmptyQ:=(ql>=qr)
end;

procedure AddQ(const a:integer; const c1,c2:char);
begin
 q1[qr]:=a;
 q2[qr]:=c1;
 q3[qr]:=c2;
 inc(qr)
end;

procedure TakeQ(var a:integer; var c1,c2:char);
begin
 a:=q1[ql];
 c1:=q2[ql];
 c2:=q3[ql];
 inc(ql)
end;

procedure Solve;
var i,k:integer;
    c1,c2,c3:char;
begin
 fillchar(y,sizeof(y),false);
 for i:=0 to n-1 do
  for k:=-l to r do
   if k<>0 then y[i,x[(i+n-k) mod n]]:=true;
 for i:=0 to n do
  for c1:='a' to Empty do
   for c2:='a' to Empty do begin
     z[i,c1,c2]:=true;
     if (c1<>Empty) and ((c1=c2) or (c1=x[i]) or (c2=x[i]))
     then z[i,c1,c2]:=false
     else
      if (c1=Empty) and (c2<>Empty) then z[i,c1,c2]:=false
      else
       if (c1=Empty) and (c2=Empty) and (i<>0) then z[i,c1,c2]:=false
       else
        if (c2=Empty) and (c1<>Empty) then begin
          z[i,c1,c2]:=false;
          for k:=-l to r do
           if k<>0 then
            if ((i+n-k) mod n=0) and (x[0]=c1) then begin
              z[i,c1,c2]:=true;
              Break
             end
         end
        else
         if not((c1=Empty)and(c2=Empty)) then begin
           z[i,c1,c2]:=false;
           for k:=-l to r do
            if x[(i+n-k) mod n]=c1 then
             if y[(i+n-k) mod n,c2] then begin
               z[i,c1,c2]:=true;
               Break
              end
          end
    end;
 StartQ;
 for i:=0 to n-1 do
  for c1:='a' to Empty do
   for c2:='a' to Empty do
    if z[i,c1,c2] then begin
      f[i,c1,c2]:=0;
      for k:=-r to l do
       if (x[(i+n-k) mod n]<>x[i]) and
          (x[(i+n-k) mod n]<>c1) and
          (x[(i+n-k) mod n]<>c2)
       then inc(f[i,c1,c2]);
      if f[i,c1,c2]=0 then begin
        AddQ(i,c1,c2);
        d[i,c1,c2]:=0;
        w[i,c1,c2]:=Lose
       end
      else begin
        d[i,c1,c2]:=NA;
        w[i,c1,c2]:=Draw
       end
     end;
 while not EmptyQ do begin
   TakeQ(i,c1,c2);
   for k:=-l to r do
    if x[(i+n-k) mod n]=c1 then
     for c3:='a' to Empty do
      if z[(i+n-k) mod n,c2,c3] and (d[(i+n-k) mod n,c2,c3]=NA) then begin
        if w[i,c1,c2]=Win then dec(f[(i+n-k) mod n,c2,c3]);
        if (w[i,c1,c2]=Lose) or (f[(i+n-k) mod n,c2,c3]=0) then begin
           d[(i+n-k) mod n,c2,c3]:=d[i,c1,c2]+1;
           w[(i+n-k) mod n,c2,c3]:=1-w[i,c1,c2];
           AddQ((i+n-k) mod n,c2,c3)
         end
       end
  end
end;

procedure Done;
var k:integer;
begin
 assign(output,nameout);
 rewrite(output);
 if w[0,Empty,Empty]=Draw then writeln('DRAW')
 else
  if w[0,Empty,Empty]=Lose then begin
    writeln('LOSE');
    writeln(d[0,Empty,Empty])
   end
  else begin
    writeln('WIN');
    writeln(d[0,Empty,Empty]);
    for k:=l downto -r do
     if x[(n-k) mod n]<>x[0]
     then
      if (w[(n-k) mod n,x[0],Empty]=Lose) and
         (d[(n-k) mod n,x[0],Empty]=(d[0,Empty,Empty]-1))
      then begin
        writeln(-k);
        Break
       end
   end;
 close(output)
end;

begin
 Init;
 Solve;
 Done
end.
