{$apptype console}

const
 MAXN = 2010;
 eps = 1e-9;

var
 Ans, N, i, j: longint;
 X, Y: array [0..MAXN] of extended;
 RA, RB, RC: extended;

procedure Test(X1, Y1, X2, Y2: extended);
 var
  A, B, C: extended;
  Temp, i: longint;
 begin
   A := Y2 - Y1;
   B := X1 - X2;
   if sqr(A) + sqr(B) < eps then
     A := 1;
   C := -(A * X1 + B * Y1);
   Temp := 0;
   if Temp > Ans then begin
     Ans := Temp;
     RA := A;
     RB := B;
     RC := C;
   end;
   for i := 0 to N - 2 do
     if (A * X[i] + B * Y[i] + C) * (A * X[i + 1] + B * Y[i + 1] + C) < -eps then begin
       inc(Temp);
       if Temp > Ans then begin
         Ans := Temp;
         RA := A;
         RB := B;
         RC := C;
       end;
     end else
       Temp := 0;
 end;

begin
  assign(input, 'polyline.in');
  assign(output, 'polyline.out');
  reset(input);
  rewrite(output);

  read(N);
  for i := 0 to N - 1 do
    read(X[i], Y[i]);
  Ans := -1;
  RA := 0;
  RB := 1;
  RC := 0;
  for i := 0 to N - 2 do
    for j := i to N - 1 do begin
      Test((1e5 * X[i] + X[i + 1]) / (1e5 + 1), (1e5 * Y[i] + Y[i + 1]) / (1e5 + 1),
           (1e5 * X[j] + X[j + 1]) / (1e5 + 1), (1e5 * Y[j] + Y[j + 1]) / (1e5 + 1));
      Test((X[i] + 1e5 * X[i + 1]) / (1e5 + 1), (Y[i] + 1e5 * Y[i + 1]) / (1e5 + 1),
           (1e5 * X[j] + X[j + 1]) / (1e5 + 1), (1e5 * Y[j] + Y[j + 1]) / (1e5 + 1));
      Test((1e5 * X[i] + X[i + 1]) / (1e5 + 1), (1e5 * Y[i] + Y[i + 1]) / (1e5 + 1),
           (X[j] + 1e5 * X[j + 1]) / (1e5 + 1), (Y[j] + 1e5 * Y[j + 1]) / (1e5 + 1));
      Test((X[i] + 1e5 * X[i + 1]) / (1e5 + 1), (Y[i] + 1e5 * Y[i + 1]) / (1e5 + 1),
           (X[j] + 1e5 * X[j + 1]) / (1e5 + 1), (Y[j] + 1e5 * Y[j + 1]) / (1e5 + 1));
    end;
  if (RA > 1e9) then begin
    RB := RB / RA;
    RC := RC / RA;
    RA := RA / RA;
  end;
  if (RB > 1e9) then begin
    RC := RC / RB;
    RA := RA / RB;
    RB := RB / RB;
  end;
  if (RC > 1e9) then begin
    RA := RA / RC;
    RB := RB / RC;
    RC := RC / RC;
  end;
  writeln(RA:0:9);
  writeln(RB:0:9);
  writeln(RC:0:9);

  close(input);
  close(output);
end.
