const eps=1e-6;
      eps2=0.001;
type tedge=record
             x,y:extended;
           end;
var ans,cnt,n,i,j:longint;
    dx,dy,xc,yc,yyA,yyB,yyC,axc,ayc,x1,y1,x2,y2:extended;
    ap,a,b,c,d:tedge;
    p:array[1..2000]of record
                         x1,y1,x2,y2:extended;
                       end;

function dist(x1,y1,x2,y2:extended):extended;
begin
  dist:=sqrt(sqr(x2-x1)+sqr(y2-y1));
end;

function vect(a,b:tedge):longint;
var v:extended;
begin
  v:=a.x*b.y-a.y*b.x;
  vect:=0;
  if v<-eps then
    vect:=-1;
  if v>eps then
    vect:=1;
end;


function cross(a,b,c,d:tedge;var e,f:tedge):boolean;
var aa:array[1..5]of tedge;
    d1,d2,d3,d4,i,j:longint;
    t:tedge;

begin
  cross:=false;
  aa[1]:=a;
  aa[2]:=b;
  aa[3]:=c;
  aa[4]:=d;
  for i:=1 to 3 do
    for j:=i+1 to 4 do
      if vect(aa[i],aa[j])>0 then
      begin
        t:=aa[i];
        aa[i]:=aa[j];
        aa[j]:=t;
      end;
  aa[5]:=aa[1];
  for i:=1 to 4 do
  begin
    t.x:=aa[i].x+aa[i+1].x;
    t.y:=aa[i].y+aa[i+1].y;
    d1:=vect(a,t);
    d2:=vect(b,t);
    d3:=vect(c,t);
    d4:=vect(d,t);
    if (abs(d2-d1)>=1) and (abs(d4-d3)>=1) then
    begin
      e:=aa[i];
      f:=aa[i+1];
      cross:=true;
      exit;
    end;
  end;
end;

begin
  assign(input,'polyline.in');
  reset(input);
  read(n);
  read(x1,y1);
  for i:=1 to n-1 do
  begin
    read(x2,y2);
    dx:=(x2-x1)/dist(x1,y1,x2,y2);
    dy:=(y2-y1)/dist(x1,y1,x2,y2);
    p[i].x1:=x1+dx*eps2;
    p[i].y1:=y1+dy*eps2;
    p[i].x2:=x2-dx*eps2;
    p[i].y2:=y2-dy*eps2;
    x1:=x2;
    y1:=y2;
  end;
  close(input);
  ans:=0;
  for i:=1 to n-2 do
  begin
    cnt:=2;
    xc:=p[i].x1;
    yc:=p[i].y1;
    a.x:=p[i+1].x1-xc;
    a.y:=p[i+1].y1-yc;
    b.x:=p[i+1].x2-xc;
    b.y:=p[i+1].y2-yc;
    for j:=i+2 to n-1 do
    begin
      with p[j] do
      begin
        c.x:=x2-x1;
        c.y:=y2-y1;
        d.x:=x1-xc;
        d.y:=y1-yc;
        if vect(c,d)=0 then
          break;
        c.x:=x1-xc;
        c.y:=y1-yc;
        d.x:=x2-xc;
        d.y:=y2-yc;
      end;
      if cross(a,b,c,d,a,b) then
        inc(cnt)
      else
        break;
    end;
    if cnt>ans then
    begin
      ap.x:=a.x+b.x;
      ap.y:=a.y+b.y;
      axc:=xc;
      ayc:=yc;
      ans:=cnt;
    end;
    cnt:=2;
    xc:=p[i].x2;
    yc:=p[i].y2;
    a.x:=p[i+1].x1-xc;
    a.y:=p[i+1].y1-yc;
    b.x:=p[i+1].x2-xc;
    b.y:=p[i+1].y2-yc;
    for j:=i+2 to n do
    begin
      with p[j] do
      begin
        c.x:=x2-x1;
        c.y:=y2-y1;
        d.x:=x1-xc;
        d.y:=y1-yc;
        if vect(c,d)=0 then
          break;
        c.x:=x1-xc;
        c.y:=y1-yc;
        d.x:=x2-xc;
        d.y:=y2-yc;
      end;
      if cross(a,b,c,d,a,b) then
        inc(cnt)
      else
        break;
    end;
    if cnt>ans then
    begin
      ap.x:=a.x+b.x;
      ap.y:=a.y+b.y;
      axc:=xc;
      ayc:=yc;
      ans:=cnt;
    end;
  end;
  assign(output,'polyline.out');
  rewrite(output);
  yyA:=ap.y;
  yyB:=-ap.x;
  yyC:=-(yyA*axc+yyB*ayc);
  writeln(yyA:0:15,' ',yyB:0:15,' ',yyC:0:15);
  close(output);
end.
