const
        MaxN = 10000;
        MaxC = 8;
        MaxL = 50;
type
        TChar = 'a' .. 'h';
        TKl =
        record
          n : Word;
          c1, c2 : Char;
        end;
        TP = ^TT;
        TT =
        record
          k : TKl;
          next : TP;
        end;
var
        s : Array[1 .. MaxN] of Char;
        n, l, r, left, right : LongInt;
        reb, rez : Array[1 .. MaxN, TChar, TChar] of Byte;
        bfs : Array[1 .. MaxN * MaxC * MaxC] of
        record
          n, xod : Word;
          c1, c2 : Char;
        end;
        sm : Array[1 .. MaxN, TChar, TChar] of TP;
        qq : LongInt;

Procedure Init;
begin
  qq := 10 * MaxL;
  While not SeekEoLn do
  begin
    Inc(n);
    Read(s[n]);
  end;
  ReadLn;
  ReadLn(l, r);
end;

Procedure Add(const n1 : Word; c1, c2 : Char; nk : Word; c1k, c2k : Char);
var
        t : TP;
        u : ^LongInt;
begin
  t := sm[nk][c1k][c2k];
  New(sm[nk][c1k][c2k]);
  sm[nk][c1k][c2k]^.k.n := n1;
  sm[nk][c1k][c2k]^.k.c1 := c1;
  sm[nk][c1k][c2k]^.k.c2 := c2;
  sm[nk][c1k][c2k]^.next := t;
end;

Procedure Pred;
var
        k, t, i : LongInt;
        c1, c2 : Char;
        bo : Boolean;
begin
  right := 0;
  left := 1;
  for k := 1 to n do
    for c1 := 'a' to 'h' do
      for c2 := 'a' to 'h' do
      begin
        bo := True;
        for i := -l to r do
        begin
          t := (k + i - 1 + n * MaxL) mod n + 1;
          if (s[t] <> s[k]) and (s[t] <> c1) and (s[t] <> c2) then
          begin
            Inc(reb[t][s[k]][c1]);
{            Add(k, c1, c2, t, s[k], c1);}
            bo := False;
          end;
        end;
        if (bo){ and (s[k] <> c2) and (c1 <> c2) and (s[k] <> c1)} then
        begin
          Inc(right);
          bfs[right].n := k;
          bfs[right].c1 := c1;
          bfs[right].c2 := c2;
          rez[k][c1][c2] := 2;
        end;
     end;
  rez[1][s[1]][s[1]] := 0;
  bo := True;
  for i := -l to r do
  begin
    t := (i + n * MaxL) mod n + 1;
    if s[t] <> s[1] then
    begin
      Inc(reb[1][s[k]][s[1]]);
      Add(1, s[1], s[1], t, s[1], s[1]);
      bo := False;
    end;
  end;
  if bo then
  begin
    WriteLn('LOSE');
    WriteLn('0');
    Close(input);
    CLose(output);
    Halt;
  end;
end;


Procedure Check(const k, pred : LongInt);
var
        rr : LongInt;
begin
  if rez[1][s[1]][s[1]] = 1 then
  begin
    rr := bfs[pred].n - bfs[k].n;
    While rr >= -l do
      Dec(rr, n);
    Inc(rr, n);
    if rr < qq then
      qq := rr;
  end;
end;

Procedure Obr(const k : LongInt);
var
        t : TP;
begin
  if (bfs[k].n = 1) and (bfs[k].c1 = s[1]) and (bfs[k].c2 = s[1]) then
  begin
    Case rez[1][s[1]][s[1]] of
      1 :
      begin
        WriteLn('WIN');
        WriteLn(bfs[k].xod);
        WriteLn(qq);
      end;
      2 :
      begin
        WriteLn('LOSE');
        WriteLn(bfs[k].xod);
      end;
    end;
    Close(input);
    Close(output);
    Halt;
  end;
  Case rez[bfs[k].n][bfs[k].c1][bfs[k].c2] of
    1 :
    begin
      t := sm[bfs[k].n][bfs[k].c1][bfs[k].c2];
      While t <> nil do
      begin
        if rez[t^.k.n][t^.k.c1][t^.k.c2] = 0 then
        begin
          Dec(reb[t^.k.n][t^.k.c1][t^.k.c2]);
          if reb[t^.k.n][t^.k.c1][t^.k.c2] = 0 then
          begin
            Inc(right);
            bfs[right].n := t^.k.n;
            bfs[right].c1 := t^.k.c1;
            bfs[right].c2 := t^.k.c2;
            bfs[right].xod := bfs[k].xod + 1;
            rez[t^.k.n][t^.k.c1][t^.k.c2] := 2;
          end;
        end;
        t := t^.next;
      end;
    end;
    2 :
    begin
      t := sm[bfs[k].n][bfs[k].c1][bfs[k].c2];
      While t <> nil do
      begin
        if rez[t^.k.n][t^.k.c1][t^.k.c2] = 0 then
        begin
          Inc(right);
          bfs[right].n := t^.k.n;
          bfs[right].c1 := t^.k.c1;
          bfs[right].c2 := t^.k.c2;
          bfs[right].xod := bfs[k].xod + 1;
          rez[t^.k.n][t^.k.c1][t^.k.c2] := 1;
        end;
        if (t^.k.n = 1) and (t^.k.c1 = s[1]) and (t^.k.c2 = s[1]) then
          Check(right, k);
        t := t^.next;
      end;
    end;
  end;
end;

Procedure Solve;
begin
  Pred;
  While left <= right do
  begin
    Obr(left);
    Inc(left);
  end;
end;

Procedure Print;
begin
end;

Procedure GenTest;
var
        i : LongInt;
begin
  Assign(output, 'strgame.in');
  Rewrite(output);
  for i := 1 to MaxN do
    Write(Chr(Ord('a') + Random(8)));
  WriteLn;
{  WriteLn(Random(50) + 1, ' ', Random(50) + 1);}
  Write('50 50');
  Close(output);
end;

begin
  Assign(input, 'strgame.in');
  Reset(input);
  Assign(output, 'strgame.out');
  Rewrite(output);
  Init;
  Solve;
  Print;
  if rez[1][s[1]][s[1]] = 0 then
    Write('DRAW');
  Close(output);
  Close(input);
end.
