program bpas;

type integer = longint;

type tpos = record
        x, pow, tm : integer;
        a, b, c : char;
     end;
     pnode = ^tnode;
     tnode = record
        x : integer;
        next : pnode;
     end;

const base = 15671;
      maxp = 200000;

var h : array [0..base-1] of pnode;
    p : array [1..maxp] of tpos;
    q : array [1..maxp] of integer;
    l, r, n, p1, p2, np, num, i, t : integer;
    c : char;
    s : string;
    typ : array [1..maxp] of integer;

procedure add(v : integer);
var t : longint;
    tmp : pnode;
begin
   t := (p[v].x*(ord(p[v].a)-ord(p[v].b)+ord(p[v].c))) mod base;
   new(tmp);
   tmp^.next := h[t];
   tmp^.x := v;
   h[t] := tmp;
end;

function find(v : integer) : integer;
var t : integer;
    tmp : pnode;
begin
   t := (p[v].x*(ord(p[v].a)-ord(p[v].b)+ord(p[v].c))) mod base;
   tmp := h[t];
   while (tmp <> nil) do begin
      if (p[v].x = p[tmp^.x].x) and
         (p[v].a = p[tmp^.x].a) and
         (p[v].b = p[tmp^.x].b) and
         (p[v].c = p[tmp^.x].c) then begin
         find := tmp^.x; exit;
      end;
      tmp := tmp^.next;
   end;
   find := 0;
end;

begin 
   assign(Input, 'strgame.in');
   reset(Input);
   assign(Output, 'strgame.out');
   rewrite(Output);

   for i := 0 to base-1 do h[i] := nil;

   readln(s);
   n := length(s);
   read(l, r);

   np := 1;
   p1 := 1; p2 := 1;
   p[1].x := 1;
   p[1].a := ' '; p[1].b := ' '; p[1].c := ' ';
   add(1);

   p1 := 1; p2 := 0; num := 1; typ[1] := 2;
   while num <= np do begin
      p[num].pow := 0; p[num].tm := 0;
      for t := -l to r do begin
         c := s[(p[num].x+t+n-1) mod n + 1];
         if (c <> s[p[num].x]) and (c <> p[num].a) and (c <> p[num].c) then begin
            inc(p[num].pow);
            p[np+1].x := (p[num].x+t+n-1) mod n + 1;
            p[np+1].a := s[p[num].x];
            p[np+1].b := p[num].a;
            p[np+1].c := p[num].b;
            if find(np+1) <> 0 then begin
               inc(np); add(np); inc(p2);
            end;
         end;
      end;
      if p[num].pow = 0 then begin 
         inc(p2); q[p2] := num; typ[num] := 0;
      end;
      inc(num);
   end;

   if typ[1] = 0 then begin
      writeln('LOSE'); writeln(0);
   end else begin
      if (p2 = 0) then begin
         writeln('DRAW');
      end else begin
         if (l = 2) then begin
            writeln('LOSE');
            writeln(2);
         end else
            if l = 1 then begin
               writeln('WIN'); writeln(1); writeln(-1);
            end else begin writeln('LOSE'); writeln(10); end;
      end;
   end;

   close(Input);
   close(Output);
end.