#include <queue>
#include <vector>
#include <algorithm>
#include <cstdio>

#define F first
#define S second
#define P push_back
#define MP make_pair

using namespace std;

#define SWAP(A, B, C) ((C) = (A), (A) = (B), (B) = (C))
#define MIN(A, B) min(A[B], A[((B) + 1) % A.size()])
#define MAX(A, B) max(A[B], A[((B) + 1) % A.size()])
#define PAIR(A, B) MP(MIN(A, B), MAX(A, B))
#define LAST(i) { if (--cur[i] < 0) cur[i] = c[i].size() - 1; }
#define NEXT(i) { if (++cur[i] > c[i].size() - 1) cur[i] = 0; }

int main( void )
{
  int test_num;
  freopen("sort.in", "rt", stdin);
  freopen("sort.out", "wt", stdout);
  scanf("%d", &test_num);
  while (test_num--)
  {
    int i, j, k, pos, n, sum = 0, tmp;

    scanf("%d", &n);
    vector <int> a(n);
    vector < pair<int, int> > b(n);
    for (i = 0; i < n; i++)
      scanf("%d", &a[i]), b[i].F = a[i], b[i].S = i;
    stable_sort(b.begin(), b.end());

    vector< vector<int> > c;
    vector< int > st;
    for (i = 0; i < n; i++)
      if (b[i].F != -1)
      {
        vector <int> t;
        while (b[i].F != -1)
          t.P(b[i].F), b[i].F = -1, i = b[i].S;
        if ((k = t.size()) <= 1)
          continue;
        for (pos = j = 0; j < k; j++)
          if (PAIR(t, j) < PAIR(t, pos))
            pos = j;
        c.P(t), st.P(pos), sum += k - 1;
      }

    printf("%d\n", sum);
    vector<int> cur(st);
    priority_queue < pair<int,int> > q;
    for (i = 0; i < c.size(); i++)
    {
      q.push(MP(-MIN(c[i], cur[i]), i));
      NEXT(i)
    }
    while (!q.empty())
    {
      int i = q.top().S; q.pop();
      LAST(i)
      printf("%d %d\n", MIN(c[i], cur[i]), MAX(c[i], cur[i]));
      SWAP(c[i][cur[i]], c[i][(cur[i] + 1) % c[i].size()], tmp);
      NEXT(i)
      pair<int, int> p = MP(-MIN(c[i], cur[i]), i);
      NEXT(i)
      if (cur[i] != st[i])
        q.push(p);
    }
  }
  return 0;
}
