#include <stdio.h>
#include <string.h>

#define MIN(A, B) (((A) <= (B)) ? (A) : (B))
#define MAX(A, B) (((A) >= (B)) ? (A) : (B))
#define SWAP(A, B, C) ((C) = (A), (A) = (B), (B) = (C))
#define ABS(X) (((X) >= 0) ? (X) : -(X))

#define eps 1e-9

#define MAXN 110
#define MAXM 110
#define MAXV 20010
#define MAXE 1100000

int Ans = 0, N, M, A[MAXN][MAXM], V, E, S, T, He[MAXV], Re[MAXE], Ce[MAXE], Ta[MAXE], Ne[MAXE], Fl[MAXE];
int qs, qz, Q[MAXV], C[MAXV], P[MAXV], R[MAXV];
int TN, TA[MAXN * MAXM], TB[MAXN * MAXM], TW[MAXN * MAXM];
int MN[MAXM], MA[MAXM][MAXN], MM[MAXM][MAXN];

void AddEdge(int A, int B, int C)
{
  if (C <= 0)
    return; // 䨣 ⠪ ॡ 㦭? :)
  Ne[E] = He[A], Ta[E] = B, Ce[E] = C, Re[E] = E + 1, He[A] = E++;
  Ne[E] = He[B], Ta[E] = A, Ce[E] = 0, Re[E] = E - 1, He[B] = E++;
}

int main( void )
{
  int i, j, k;

  freopen("coins.in", "rt", stdin);
  freopen("coins.out", "wt", stdout);

  scanf("%d%d", &N, &M);
  for (i = 0; i < N; i++)
    for (j = 0; j < M; j++)
      scanf("%d", &A[i][j]);

  V = 2 * M * (N - 1) + M + 2, S = 0, T = 2 * M * (N - 1) + M + 1, E = 0;
  memset(He, -1, sizeof(He));
  for (i = 0; i < M; i++)
    AddEdge(S, i + 1, A[0][i]),
    AddEdge(i + 1, T, 1);
  for (j = 1; j < N; j++)
    for (i = 0; i < M; i++)
    {
      if (A[j][i] == 0)
      {
        AddEdge(i + 1, 2 * j * M - M + 1 + i, 1);
        for (k = 0; k < M; k++)
          if (A[j][k] > 1)
            AddEdge(2 * j * M - M + 1 + i, 2 * j * M + 1 + k, 1);
      }
      AddEdge(2 * j * M + 1 + i, i + 1, MAX(0, A[j][i] - 1));
    }
  memset(Fl, 0, sizeof(Fl));
  while (1)
  {
    memset(C, 0, sizeof(C));
    memset(P, -1, sizeof(P));
    qs = 0, qz = 1, Q[0] = S, C[S] = 1;
    while (qz && !C[T])
    {
      int t = Q[qs++];
      qz--;
      for (i = He[t]; i + 1; i = Ne[i])
        if (Ce[i] > Fl[i] && !C[Ta[i]])
        {
          C[Ta[i]] = 1;
          Q[qs + qz++] = Ta[i];
          P[Ta[i]] = t;
          R[Ta[i]] = i;
        }
    }
    if (!C[T])
      break;
    for (i = T; P[i] + 1; i = P[i])
      Fl[R[i]]++, Fl[Re[R[i]]]--;
    Ans++;
  }

  TN = 0;
  for (j = 1; j < N; j++)
    for (i = 0; i < M; i++)
      for (k = He[2 * j * M - M + 1 + i]; k + 1; k = Ne[k])
        if (Fl[k] > 0)
          TA[TN] = i, TB[TN] = Ta[k] - 2 * j * M - 1, TW[TN++] = j;
  memset(MN, 0, sizeof(MN));
  for (i = 0; i < TN; i++)
    MM[TA[i]][MN[TA[i]]] = TB[i], MA[TA[i]][MN[TA[i]]++] = TW[i];

  TN = 0;
  while (1)
  {
    for (i = 0; i < M; i++)
      if (A[0][i] && MN[i])
        break;
    if (i == M)
      break;
    while (A[0][i] && MN[i])
    {
      A[0][i]--;
      MN[i]--;
      TA[TN] = i;
      TB[TN] = MM[i][MN[i]];
      TW[TN++] = MA[i][MN[i]];
      A[0][MM[i][MN[i]]]++;
    }
  }

  printf("%d\n", Ans);
  for (i = 0; i < TN; i++)
    printf("%d %d %d\n", TW[i] + 1, TB[i] + 1, TA[i] + 1);

  return 0;
}
