#include <stdio.h>
#include <string.h>

#define MIN(A, B) (((A) <= (B)) ? (A) : (B))
#define MAX(A, B) (((A) >= (B)) ? (A) : (B))
#define SWAP(A, B, C) ((C) = (A), (A) = (B), (B) = (C))
#define ABS(X) (((X) >= 0) ? (X) : -(X))

#define eps 1e-9

#define MAXN 100010

int T, N, TN, A[MAXN], B[MAXN], I[MAXN], TA[MAXN], TB[MAXN];

void QSort(int l, int r)
{
  int i = l, j = r, x, t;
  if (l >= r)
    return;
  x = A[l + rand() % (r - l + 1)];
  while (i <= j)
  {
    while (A[i] < x) i++;
    while (A[j] > x) j--;
    if (i <= j)
    {
      SWAP(A[i], A[j], t);
      SWAP(I[i], I[j], t);
      i++, j--;
    }
  }
  QSort(l, j);
  QSort(i, r);
}

int main( void )
{
  int i, j, t, i1, i2;
  srand(20060829);

  freopen("sort.in", "rt", stdin);
  freopen("sort.out", "wt", stdout);

  scanf("%d", &T);
  while (T--)
  {
    scanf("%d", &N);
    for (i = 0; i < N; i++)
      scanf("%d", &A[i]), I[i] = i;
    QSort(0, N - 1);
    for (i = 0; i < N; i++)
      B[I[i]] = i;
    TN = 0;
    for (i = 0; i < N; i++)
    {
/*
      for (j = 0; j < N; j++)
        printf("%d%c", B[j], (j == N - 1) ? '\n' : ' ');
      for (j = 0; j < N; j++)
        printf("%d%c", I[j], (j == N - 1) ? '\n' : ' ');
      printf("\n");
*/
      if (I[i] == i)
        continue;
      while (I[i] < B[i])
      {
//        printf("SSWAPP 1\n");
        TA[TN] = A[B[I[i]]], TB[TN++] = A[B[I[I[i]]]];
        SWAP(B[I[i]], B[I[I[i]]], t);
        i1 = i;
        i2 = I[i];
        SWAP(I[i1], I[i2], t);
        if (I[i] == i)
          break;
      }
      if (I[i] == i)
        continue;
//      printf("SSWAPP 2\n");
      TA[TN] = A[B[I[i]]], TB[TN++] = A[B[i]];
      i1 = B[i];
      i2 = i;
      SWAP(B[i], B[I[i]], t);
      SWAP(I[i1], I[i2], t);
    }
/*
    for (i = 0; i < N; i++)
      printf("%d%c", B[i], (i == N - 1) ? '\n' : ' ');
    for (i = 0; i < N; i++)
      printf("%d%c", I[i], (i == N - 1) ? '\n' : ' ');
*/
    printf("%d\n", TN);
    for (i = 0; i < TN; i++)
      printf("%d %d\n", TA[i], TB[i]);
  }

  return 0;
}
