const
        MaxN = 100;
type
        TP = ^TT;
        TT =
        record
          n : Byte;
          next : TP;
        end;
var
        c, f : Array[0 .. MaxN, 0 .. MaxN] of LongInt;
        sm : Array[1 .. MaxN] of TP;
        vas, t : Array[1 .. MaxN] of Word;
        used : Array[0 .. MaxN] of Boolean;
        n, m, flow : LongInt;

Procedure Init;
var
        i, j, k : LongInt;
        q : TP;
begin
  ReadLn(n, m);
  for i := 1 to m do
    Read(vas[i]);
  for i := 1 to n - 1 do
  begin
    for j := 1 to m do
      Read(t[j]);
    for j := 1 to m do
      if t[j] = 0 then
      begin
        q := sm[j];
        New(sm[j]);
        sm[j]^.next := q;
        sm[j]^.n := i;
        for k := 1 to m do
          if t[k] > 1 then
            Inc(c[j][k]);
      end;
  end;
  for i := 1 to m do
    c[i][0] := 1;
end;

Function DFS(const u : Byte) : Boolean;
var
        v : Byte;
begin
  DFS := False;
  if used[u] then
    Exit;
  used[u] := True;
  if u = 0 then
  begin
    DFS := True;
    Inc(flow);
    Exit;
  end;
  for v := 0 to n do
    if c[u][v] - f[u][v] > 0 then
      if DFS(v) then
      begin
        Inc(f[u][v]);
        Dec(f[v][u]);
        DFS := True;
        Exit;
      end;
  DFS := False;
end;

Procedure DFS2(const a : Byte);
var
        b : Byte;
begin
  if a = 0 then
    Exit;
  if used[a] then
    Exit;
  used[a] := True;
  for b := 0 to n do
    if f[a][b] > 0 then
    begin
      Dec(f[a][b]);
      Inc(f[b][a]);
      if b <> 0 then
      begin
        WriteLn(sm[a]^.n, ' ', b, ' ', a);
        sm[a] := sm[a]^.next;
      end;
      DFS2(b);
      Exit;
    end;
end;

Procedure Solve;
var
        i, j : LongInt;
begin
  for i := 1 to m do
    for j := 1 to vas[i] do
    begin
      FillChar(used, SizeOf(used), False);
      DFS(i);
    end;
  WriteLn(flow);
  for i := 1 to m do
    for j := 1 to vas[i] do
    begin
      FillChar(used, SizeOf(used), False);
      DFS2(i);
    end;
end;

Procedure Print;
begin
end;

Procedure GenTest;
begin
  Assign(output, 'coins.in');
  Rewrite(output);
  Close(output);
end;

begin
  Assign(input, 'coins.in');
  Reset(input);
  Assign(output, 'coins.out');
  Rewrite(output);
  Init;
  Solve;
  Print;
  Close(input);
  Close(output);
end.
