Program prg;

type
  int=longint;
  chel=record
    k: int;
    x: double;
  end;
  merge=record
    n1, n2: int;
    k1, k2: int;
    x1, x2: double;
    t: double;
    nexttime, prevtime, nextpos, prevpos: int;
  end;



var
  n: int;
  arr: array[0..100010] of chel;
  t, mint: double;
  i, j, k, mini: int;
  mer: array[0..200010] of merge;
  mass: array[0..100010] of char;
  free: array[0..200010] of int;
  lfree: int;
  start: int;
  res: int;
  ans: array[0..100010] of int;
  ct: int;

procedure deletefrom(a: int);
  begin
    mer[mer[a].prevtime].nexttime:=mer[a].nexttime;
    mer[mer[a].nexttime].prevtime:=mer[a].prevtime;
  end;

//procedure addnew(x1, x2: double; k1, k2: int; n1, n2: int);

procedure swapmer(i: int);
  begin
    mer[mer[i].prevtime].nexttime:=mer[i].nexttime;
    mer[mer[i].nexttime].prevtime:=mer[i].prevtime;
    mer[i].prevtime:=mer[i].nexttime;
    mer[i].nexttime:=mer[mer[i].prevtime].nexttime;
    mer[mer[i].nexttime].prevtime:=i;
    mer[mer[i].prevtime].nexttime:=i;
  end;

procedure swap(a, b: int);
  var
    t: merge;

  begin
    mer[mer[a].prevpos].nextpos:=b;
    mer[mer[a].nextpos].prevpos:=b;
    mer[mer[b].prevpos].nextpos:=a;
    mer[mer[b].nextpos].prevpos:=a;
    t:=mer[a];
    mer[a]:=mer[b];
    mer[b]:=t;
  end;

procedure qsort(l, r: int);
  var
    lh, rh: int;

  begin
    lh:=l;
    rh:=r;
    while (lh<rh) do begin
      while (lh<rh) and(mer[lh].t<=mer[rh].t) do inc(lh);
      swap(lh, rh);
      while (lh<rh) and(mer[lh].t<=mer[rh].t) do dec(rh);
      swap(lh, rh);
    end;
    if (lh-l)>1 then qsort(l, lh-1);
    if (r-rh)>1 then qsort(rh+1, r);
  end;

procedure swap1(var a, b: chel);
  var
    t: chel;

  begin
    t:=a;
    a:=b;
    b:=t;
  end;

procedure qsort1(l, r: int);
  var
    lh, rh: int;

  begin
    lh:=l;
    rh:=r;
    while (lh<rh) do begin
      while (lh<rh) and (arr[lh].x<=arr[rh].x) do inc(lh);
      swap1(arr[lh], arr[rh]);
      while (lh<rh) and (arr[lh].x<=arr[rh].x) do dec(rh);
      swap1(arr[lh], arr[rh]);
    end;
    if (lh-l)>1 then qsort1(l, lh-1);
    if (r-rh)>1 then qsort1(rh+1, r);
  end;


begin
  assign(input, 'longpath.in');
  assign(output, 'longpath.out');
  reset(input);
  rewrite(output);

  readln(n);

  for i:=1 to 200005 do begin
    free[200005-i+1]:=i;
  end;
  lfree:=200005;

  for i:=1 to n do begin
    read(arr[i].k, arr[i].x);
  end;

  qsort1(1, n);

  for i:=1 to n-1 do begin
    t:=(arr[i+1].x-arr[i].x)*(arr[i].k*arr[i+1].k)/(100*(arr[i+1].k-arr[i].k));
    if t<0 then continue;
    mer[free[lfree]].n1:=i;
    mer[free[lfree]].n2:=i+1;
    mer[free[lfree]].k1:=arr[i].k;
    mer[free[lfree]].k2:=arr[i+1].k;
    mer[free[lfree]].x1:=arr[i].x;
    mer[free[lfree]].x2:=arr[i+1].x;
    mer[free[lfree]].t:=t;
    mer[free[lfree]].prevpos:=free[lfree]-1;
    mer[free[lfree]].nextpos:=free[lfree]+1;
    dec(lfree);
  end;

  qsort(1, free[lfree]-1);

  for i:=0 to free[lfree]-1 do begin
    mer[i].prevtime:=i-1;
    mer[i].nexttime:=i+1;
  end;

  fillchar(mass, sizeof(mass), 'a');

  while (mer[mer[0].nexttime].k1<>0) do begin
    i:=mer[0].nexttime;
    while mer[i].n1<>0 do begin
      mer[i].t:=mer[i].t-mer[mer[0].nexttime].t;
      mer[i].x1:=mer[i].x1+(100/mer[i].k1)*mer[mer[0].nexttime].t;
      mer[i].x2:=mer[i].x2+(100/mer[i].k2)*mer[mer[0].nexttime].t;
      i:=mer[i].nexttime;
    end;
    for i:=mer[mer[0].nexttime].n1+1 to mer[mer[0].nexttime].n2-1 do mass[i]:='a';
    if mass[mer[mer[0].nexttime].n1]='>' then mass[mer[mer[0].nexttime].n1]:='a' else
    if mass[mer[mer[0].nexttime].n1]='a' then mass[mer[mer[0].nexttime].n1]:='<';
    if mass[mer[mer[0].nexttime].n2]='<' then mass[mer[mer[0].nexttime].n2]:='a' else
    if mass[mer[mer[0].nexttime].n2]='a' then mass[mer[mer[0].nexttime].n2]:='>';
    if mer[mer[mer[0].nexttime].prevpos].n2=mer[mer[0].nexttime].n1 then begin
      mer[mer[mer[0].nexttime].prevpos].n2:=mer[mer[0].nexttime].n2;
      mer[mer[mer[0].nexttime].prevpos].k2:=mer[mer[0].nexttime].k1+mer[mer[0].nexttime].k2;
      mer[mer[mer[0].nexttime].prevpos].t:=(mer[mer[mer[0].nexttime].prevpos].x2-mer[mer[mer[0].nexttime].prevpos].x1)*(mer[mer[mer[0].nexttime].prevpos].k1*mer[mer[mer[0].nexttime].prevpos].k2);
      mer[mer[mer[0].nexttime].prevpos].t:=mer[mer[mer[0].nexttime].prevpos].t/(100*(mer[mer[mer[0].nexttime].prevpos].k2-mer[mer[mer[0].nexttime].prevpos].k1));
    end;
    if mer[mer[mer[0].nexttime].nextpos].n1=mer[mer[0].nexttime].n2 then begin
      mer[mer[mer[0].nexttime].nextpos].n1:=mer[mer[0].nexttime].n1;
      mer[mer[mer[0].nexttime].nextpos].k1:=mer[mer[0].nexttime].k1+mer[mer[0].nexttime].k2;
      mer[mer[mer[0].nexttime].nextpos].t:=(mer[mer[mer[0].nexttime].nextpos].x2-mer[mer[mer[0].nexttime].nextpos].x1)*(mer[mer[mer[0].nexttime].nextpos].k1*mer[mer[mer[0].nexttime].nextpos].k2);
      mer[mer[mer[0].nexttime].nextpos].t:=mer[mer[mer[0].nexttime].nextpos].t/(100*(mer[mer[mer[0].nexttime].nextpos].k2-mer[mer[mer[0].nexttime].nextpos].k1));
    end;


    if mer[mer[mer[0].nexttime].nextpos].t<0 then
      deletefrom(mer[mer[0].nexttime].nextpos) else
      begin
        while mer[mer[mer[0].nexttime].nextpos].t>mer[mer[mer[mer[0].nexttime].nextpos].nexttime].t do swapmer(mer[mer[0].nexttime].nextpos);
        while mer[mer[mer[0].nexttime].nextpos].t<mer[mer[mer[mer[0].nexttime].nextpos].prevtime].t do swapmer(mer[mer[mer[0].nexttime].nextpos].prevtime);
      end;
    if mer[mer[mer[0].nexttime].prevpos].t<0 then
      deletefrom(mer[mer[0].nexttime].prevpos) else
      begin
        while mer[mer[mer[0].nexttime].prevpos].t>mer[mer[mer[mer[0].nexttime].prevpos].nexttime].t do swapmer(mer[mer[0].nexttime].prevpos);
        while mer[mer[mer[0].nexttime].prevpos].t<mer[mer[mer[mer[0].nexttime].prevpos].prevtime].t do swapmer(mer[mer[mer[0].nexttime].prevpos].prevtime);
      end;
    deletefrom(mer[0].nexttime);

  end;

  start:=-1;

  for i:=1 to n do begin
    if (mass[i]='a')and(start=-1) then begin
      inc(res);
      ans[res]:=1;
    end else
    if (mass[i]='a')and(start<>-1) then ct:=ct+arr[i].k else
    if (mass[i]='<')and(start=-1) then begin
      start:=i;
      ct:=arr[i].k;
    end else
    if (mass[i]='>') then begin
      inc(res);
      ans[res]:=ct+arr[i].k;
      start:=-1;
      ct:=0;
    end;
  end;

  writeln(res);
  for i:=1 to res do
    write(ans[i], ' ');

  close(input);
  close(output);
end.
