#include <stdio.h>
#include <string.h>

#define MIN(A, B) (((A) <= (B)) ? (A) : (B))
#define MAX(A, B) (((A) >= (B)) ? (A) : (B))
#define SWAP(A, B, C) ((C) = (A), (A) = (B), (B) = (C))
#define ABS(X) (((X) >= 0) ? (X) : -(X))

#define eps 1e-9
#define inf (int)1e9

#define MAXN 10010

int N, S, T[MAXN], F[MAXN], ST[MAXN], SF[MAXN], D[MAXN];

int main( void )
{
  int i, j;

  freopen("batch.in", "rt", stdin);
  freopen("batch.out", "wt", stdout);

  scanf("%d%d", &N, &S);
  for (i = 0; i < N; i++)
    scanf("%d%d", &T[i], &F[i]);

  ST[0] = SF[0] = 0;
  for (i = 0; i < N; i++)
    ST[i + 1] = ST[i] + T[i], SF[i + 1] = SF[i] + F[i];

  D[N] = 0;
  for (i = N - 1; i >= 0; i--)
  {
    D[i] = inf;
    for (j = i + 1; j <= N; j++)
      D[i] = MIN(D[i], D[j] + (SF[N] - SF[j] + SF[j] - SF[i]) * (S + ST[j] - ST[i]));
  }
  printf("%d\n", D[0]);

  return 0;
}
