#include <stdio.h>
#include <stdlib.h>

#define SWAP(a, b, c) ((c) = (a), (a) = (b), (b) = (c))

int B[1500001][2], BN, Res[1500000][2], RN;


void QSort( int l, int r )
{
  int c, i, j, t;

  if (l >= r)
    return;
  c = B[l + (rand() % (r - l + 1))][0];
  i = l, j = r;
  while (i <= j)
  {
    while (B[i][0] < c)
      i++;
    while (B[j][0] > c)
      j--;
    if (i <= j)
      SWAP(B[i][0], B[j][0], t),
      SWAP(B[i][1], B[j][1], t),
      i++, j--;
  }
  QSort(l, j);
  QSort(i, r);
}

int main( void )
{
  int i, j, k, minl, min, max;

  freopen("empodio.in", "rt", stdin);
  freopen("empodio.out", "wt", stdout);

  scanf("%i", &BN);
  for (i = 0; i < BN; i++)
    scanf("%i", B[i]), B[i][1] = i;
  QSort(0, BN - 1);
  minl = BN - 1;
  RN = 0;
  for (i = BN - 1; i >= 0; i--)
  {
    min = max = B[i][1];
    for (j = i + 1; j <= minl; j++)
    {
      if (B[j][1] < min)
        break;
      if (B[j][1] > max)   
      {
        max = B[j][1];
        if (max - min == j - i)
        {
          Res[RN][0] = B[i][1] + 1;
          Res[RN++][1] = B[j][1] + 1;
          if (minl > j)
            minl = j;
          break;
        }
      }
    }
  }
  printf("%i\n", RN);
  for (i = RN - 1; i >= 0; i--)
    printf("%i %i\n", Res[i][0], Res[i][1]);
 
  return 0;
}
