#include <stdio.h>
#include <string.h>
#include <memory.h>

#define SIZE 2*1024*1024
#define NUM 1500010

int killme[1010];

int n;
int minarr[SIZE+NUM];
int maxarr[SIZE+NUM];
int minanti[SIZE+NUM];
int maxanti[SIZE+NUM];
int an;
int ans[NUM/2][2];

void BuildTree(int *arr, bool xr) {
	int i;
	for (i = SIZE-2; i>=0; i--) {
		if ((i<<1)+2 >= SIZE+NUM)
			continue;
		if ((arr[(i<<1)+1] < arr[(i<<1)+2]) ^ (xr))
			arr[i] = arr[(i<<1)+1];
		else
			arr[i] = arr[(i<<1)+2];
	}
}

inline int findMin(int *arr, bool xr, int l, int r) {
	r--;
	int res = (xr ? -1000000000 : 1000000000);
	int left = SIZE-1 + l;
	int right = SIZE-1 + r;
	if ((res > arr[left]) ^ (xr))
		res = arr[left];
	if ((res > arr[right]) ^ (xr))
		res = arr[right];
	while ((left!=right) && (left+1!=right)) {
		if (left&1)
			if ((res > arr[left+1]) ^ (xr))
				res = arr[left+1];
		left--;
		left >>= 1;
			
		if (!(right&1))
			if ((res > arr[right-1]) ^ (xr))
				res = arr[right-1];
		right--;
		right >>= 1;
	}
	return res;
}

int main(int argc, char **argv) {
	freopen("empodio.in", "r", stdin);
	freopen("empodio.out", "w", stdout);
	int i, curr;
	scanf("%d", &n);
	memset(minarr, 63, sizeof(minarr));
	memset(minanti, 63, sizeof(minanti));
	memset(maxarr, -63, sizeof(maxarr));
	memset(maxanti, -63, sizeof(maxanti));
	for (i = 0; i<n; i++) {
		scanf("%d", &curr);
		killme[i] = curr;
		minarr[SIZE-1+i] = curr;
		minanti[SIZE-1+curr] = i;
	}
	memcpy(maxarr+SIZE-1, minarr+SIZE-1, n*sizeof(int));
	memcpy(maxanti+SIZE-1, minanti+SIZE-1, n*sizeof(int));
	BuildTree(minarr, 0);
	BuildTree(maxarr, 1);
	BuildTree(minanti, 0);
	BuildTree(maxanti, 1);
	for (i = 0; i<n-1; i++) {
		int j = i+3;
		int delta;
		int cmax, cam;
		int arri, arrj;
		arri = minarr[SIZE-1+i];
		while (j < n) {
			arrj = minarr[SIZE-1+j];
			delta = 1;
			if (findMin(minarr, 0, i, j+1) < arri)
				break;
			cmax = findMin(maxarr, 1, i, j+1);
			if (findMin(minanti, 0, arri, cmax+1) < i)
				break;
			if ((cmax == arrj) && (j-i == arrj-arri)) {
				if (an != 0)
					if (ans[an-1][1] > i)
						an--;
				ans[an][0] = i;
				ans[an][1] = j;
				an++;
				break;
			}
			if (cmax - arri + 1 > j-i)
				delta = cmax-arri+1 - (j-i);
			cam = findMin(maxanti, 1, arri, cmax+1);
			if (cam-j > delta)
				delta = cam-j;
			j += delta;
		}
	}
	printf("%d\n", an);
	for (i = 0; i<an; i++)
		printf("%d %d\n", ans[i][0]+1, ans[i][1]+1);
	return 0;
}
