#include <stdio.h>
#include <string.h>

#define MIN(A, B) (((A) <= (B)) ? (A) : (B))
#define MAX(A, B) (((A) >= (B)) ? (A) : (B))
#define SWAP(A, B, C) ((C) = (A), (A) = (B), (B) = (C))
#define ABS(X) (((X) >= 0) ? (X) : -(X))

#define eps 1e-9
#define inf (int)1e9

#define MAXM 35

int N, M1, M2, T1[MAXM], T2[MAXM], F1[MAXM], F2[MAXM], R1[MAXM];

int main( void )
{
  int i, j, min, max, ave, Time, K1, K2, Ans1, Ans2;

  freopen("details.in", "rt", stdin);
  freopen("details.out", "wt", stdout);

  scanf("%d", &N);
  scanf("%d", &M1);
  for (i = 0; i < M1; i++)
    scanf("%d", &T1[i]);
  scanf("%d", &M2);
  for (i = 0; i < M2; i++)
    scanf("%d", &T2[i]);

  min = 0;
  max = 50000;
  while (min < max)
  {
    ave = (min + max) >> 1;
    K1 = N;
    memset(F1, -1, sizeof(F1));
    Time = 0;
    while(1)
    {
      for (i = 0; i < M1 && K1; i++)
        if (F1[i] == -1 && Time + T1[i] <= ave)
          K1--, F1[i] = Time + T1[i];
      Time++;
      if (Time > ave)
        break;
      for (i = 0; i < M1; i++)
        if (F1[i] + 1 && F1[i] <= Time)
          F1[i] = -1;
    }
    if (K1)
      min = ave + 1;
    else
      max = ave;
  }
  Ans1 = min;

  min = 0;
  max = 50000;
  while (min < max)
  {
    ave = (min + max) >> 1;
    K1 = N, K2 = 0;
    memset(F1, 0, sizeof(F1));
    memset(R1, 0, sizeof(F1));
    memset(F2, -1, sizeof(F2));
    Time = 0;
    while (K1--)
    {
      j = 0;
      for (i = 1; i < M1; i++)
        if (F1[i] + T1[i] < F1[j] + T1[j])
          j = i;
      R1[j]++, F1[j] += T1[j];
    }
    memset(F1, 0, sizeof(F1));
    while(1)
    {
      for (i = 0; i < M2 && K2; i++)
        if (F2[i] == -1 && Time + T2[i] <= ave)
          K2--, F2[i] = Time + T2[i];
      Time++;
      if (Time > ave)
        break;
      for (i = 0; i < M1; i++)
        if (R1[i] && T1[i] + F1[i] <= Time)
          R1[i] -= 1, K2++, F1[i] += T1[i];
      for (i = 0; i < M2; i++)
        if (F2[i] + 1 && F2[i] <= Time)
          F2[i] = -1;
    }
    for (i = K1 = 0; i < M1; i++)
      K1 += R1[i];
    if (K1 || K2)
      min = ave + 1;
    else
      max = ave;
  }
  Ans2 = min;

  printf("%d\n%d\n", Ans1, Ans2);

  return 0;
}
