#include <stdio.h>

#define MAXI(A, B) ((A) > (B) ? (A) : (B))

#define MAX 1500010
#define MAXT (1 << 21)
#define INF (1 << 30)

#define NUM 15
#define TRY(A) { if (nej < A) nej = A; else if (A < i) break; }

int RN = 0, N, A[MAX], P[MAX];
int T[MAXT * 2], NeLess[MAX], NeMore[MAX];
int SP = 0, SS[MAX];

int Read( void )
{
  int r = 0, c = getc(stdin);
  while (!('0' <= c && c <= '9'))
    c = getc(stdin);
  while ('0' <= c && c <= '9')
    r = r * 10 + c - '0', c = getc(stdin);
  return r;
}

int Get( int l, int r )
{
  int ma = 0;

  l += MAXT, r += MAXT;
  while (l <= r)
  {
    if (l & 1)
    {
      if (ma < T[l])
        ma = T[l];
      l++;
    }  
    if (!(r & 1))
    {
      if (ma < T[r])
        ma = T[r];
      r--;
    }  
    if (l > r)
      break;
    l >>= 1, r >>= 1;
  }
  return ma;
}

int main( void )
{
  int i, r;

  freopen("empodio.in", "rt", stdin);
  freopen("empodio.out", "wt", stdout);
  N = Read();
  for (i = 0; i < N; i++)
    A[i] = Read(), P[A[i]] = i;
  for (i = 0; i < N; i++)
    T[MAXT + i] = A[i];
  for (i = MAXT - 1; i > 0; i--)
    T[i] = MAXI(T[i + i], T[i + i + 1]);
  for (SP = i = 0; i < N; i++)
  {
    while (SP && A[SS[SP]] > A[i])
      NeLess[SS[SP--]] = i;
    SS[++SP] = i;
  }
  while (SP)
    NeLess[SS[SP--]] = INF;
  for (SP = i = 0; i < N; i++)
  {
    while (SP && A[SS[SP]] < A[i])
      NeMore[SS[SP--]] = i;
    SS[++SP] = i;
  }
  while (SP)
    NeMore[SS[SP--]] = INF;

  for (r = N, i = N - 3; i >= 0; i--)
  {
    int mi = A[i], ma = A[i], j = i + 1, nej, num = NUM;
    int curr = NeLess[i];

    if (r < curr)
      curr = r;
    j = i;
    while (1)
    {
      nej = j + 1;
      TRY(NeMore[j]);
      TRY(P[A[j] + 1]);
      if (nej >= curr)
        break;
      j = nej;
      if (!--num || A[j] == A[i] + j - i)
      {
        num = NUM;
        ma = Get(i, j);
        if (ma == A[j] && A[j] == A[i] + j - i)
        {
          r = j, RN += 2, T[MAXT * 2 - RN] = i, T[MAXT * 2 - RN + 1] = j;
          break;
        }
        if (j < i + ma - A[i] - 1)
          j = i + ma - A[i] - 1;
      }
    }
  }
  printf("%d\n", RN >> 1);
  for (i = RN; i > 0; i -= 2)
    printf("%d %d\n", T[MAXT * 2 - i] + 1, T[MAXT * 2 - i + 1] + 1);
  return 0;
}
