#include <stdio.h>
#include <string.h>

#define m (1 << 21)

#define min(a, b) ((a) < (b) ? (a) : (b))
#define max(a, b) ((a) > (b) ? (a) : (b))

int mi[m + m], ma[m + m], n, a[m], b[m + m], ne[m], a1[m], a2[m], h;

int getmin( int i, int j )
{
  int r;

  i += m, j += m;
  r = min(mi[i], mi[j]);
  while ((i >> 1) != (j >> 1))
  {
    if (!(i & 1)) r = min(r, mi[i + 1]);
    if (j & 1) r = min(r, mi[j - 1]);
    i >>= 1, j >>= 1;
  }
  return r;
}

int getmax( int i, int j )
{
  int r;

  i += m, j += m;
  r = max(ma[i], ma[j]);
  while ((i >> 1) != (j >> 1))
  {
    if (!(i & 1)) r = max(r, ma[i + 1]);
    if (j & 1) r = max(r, ma[j - 1]);
    i >>= 1, j >>= 1;
  }
  return r;
}

int main( void )
{
  int i, j;

  freopen("empodio.in", "rt", stdin);
  freopen("empodio.out", "wt", stdout);
  scanf("%d", &n);
  for (i = 0; i < n; i++)
    scanf("%d", &a[i]);
  for (i = 0; i < n; i++)
    mi[i + m] = ma[i + m] = a[i];
  for (i = m - 1; i >= 1; i--)
    mi[i] = min(mi[i + i], mi[i + i + 1]), ma[i] = max(ma[i + i], ma[i + i + 1]);
  memset(b, -1, sizeof(b));
  memset(ne, -1, sizeof(ne));
  for (i = 0; i < n; i++)
  {
    if (b[a[i] - i + m] != -1)
      ne[b[a[i] - i + m]] = i;
    b[a[i] - i + m] = i;
  }
  h = 0;
  for (i = 0; i < n; i++)
  {
    for (j = ne[i]; j != -1; j = ne[j])
      if (a[i] == getmin(i, j) && a[j] == getmax(i, j))
        break;
    if (j != -1)
      if (h > 0 && (a1[h - 1] <= i && j <= a2[h - 1]))
        a1[h - 1] = i, a2[h - 1] = j;
      else
        a1[h] = i, a2[h++] = j;
  }
  printf("%d\n", h);
  for (i = 0; i < h; i++)
    printf("%d %d\n", a1[i] + 1, a2[i] + 1);
  return 0;
}
