#include <cstdio>
#include <vector>
#include <algorithm>

#define maxn (long)1600000

using namespace std;

long qq[maxn+1000],qh=maxn+1000;
pair<long,long> mem[maxn+1000];

inline long my_alloc()
{
	return qq[--qh];
}

inline void my_free(long x)
{
	qq[qh++]=x;
}

struct stack{
	long beg;
	stack(){beg=-1;}
	inline void push(long x)
	{
		long t=beg;
		beg=my_alloc();
		mem[beg].first=x,mem[beg].second=t;
	}
	inline long top()
	{
		return mem[beg].first;
	}
	inline void pop()
	{
		long t=beg;
		beg=mem[beg].second;
		my_free(t);
	}
	inline bool empty()
	{
		return beg==-1;
	}
};

long m;
long b[maxn],h=0;
pair<long,long> a[maxn];
vector<pair<long,long> > v;
stack st[2*maxn];

inline bool good(long x,long y)
{
	return b[x]-x==b[y]-y;
}

int main()
{
	for(long i=0;i<maxn+1000;i++) qq[i]=i;
	freopen("empodio.in","r",stdin);
	scanf("%d",&m),h=0;
	long x;
	for(long i=0;i<m;i++){
		scanf("%d",&x);
		b[i]=x;
		while((h>0)&&(a[h].first>x)) st[maxn+a[h].first-a[h].second].pop(),h--;
		if(h>0){
			if(!st[maxn+x-i].empty()){
				v.push_back(make_pair(st[maxn+x-i].top(),i));
				while(h>0) st[maxn+a[h].first-a[h].second].pop(),h--;
			}
		}
		a[++h]=make_pair(x,i);
		st[maxn+x-i].push(i);
	}
	fclose(stdin);
	sort(v.begin(),v.end());
	freopen("empodio.out","w",stdout);
	printf("%d\n",v.size());
	for(long i=0;i<v.size();i++)
		printf("%d %d\n",v[i].first+1,v[i].second+1);
	fclose(stdout);
	return 0;
}
