Program prg;

function max(a, b: longint): longint;
  begin
    if a>b then max:=a else max:=b;
  end;

function min(a, b: longint): longint;
  begin
    if a>b then min:=b else min:=a;
  end;

type
  e=record
    a1, a2: longint;
  end;


var
  n: longint;
  i, j, k: longint;
  arr: array[0..1500010] of longint;
  emp: array[0..1500000] of e;

  nn: int64;
  t, t2: array[0..3000000] of longint;

  ii: int64;
  a, b: longint;


function getmin_(l, r: integer): longint;
  var
    res: longint;

  begin
    if l=r then getmin_:=t[l] else
    if l>r then getmin_:=high(longint) else begin
      res:=t[l];
      res:=min(res, t[r]);
      res:=min(res, getmin_((l+1) div 2, (r-1) div 2));
      getmin_:=res;
    end;
  end;

function getmin(l, r: longint): longint;
  begin
    getmin:=getmin_(nn+l-1, nn+r-1);
  end;

function getmax_(l, r: longint): longint;
  var
    res: longint;

  begin
    if l=r then getmax_:=t2[l] else
    if l>r then getmax_:=(-high(longint)) else begin
      res:=t2[l];
      res:=max(res, t2[r]);
      res:=max(res, getmax_((l+1) div 2, (r-1) div 2));
    end;
  end;


function getmax(l, r: longint): longint;
  var
    res: longint;
  begin
    res:=getmax_(nn+l-1, nn+r-1);
    getmax:=res;
  end;

procedure set1(a, pos: longint);
  var
    i: longint;
  begin
    i:=pos;
    t[i]:=a;
    while i>1 do begin
      i:=i div 2;
      t[i]:=min(t[2*i], t[2*i+1]);
    end;

  end;

procedure set2(a, pos: longint);
  var
    i: longint;
  begin
    i:=pos;
    t2[i]:=a;
    while i>1 do begin
      i:=i div 2;
      t2[i]:=max(t2[2*i], t2[2*i+1]);
    end;

  end;

procedure swap(var a, b: e);
  var
    t: e;

  begin
    t:=a;
    a:=b;
    b:=t;
  end;

procedure qsort(l, r: longint);
  var
    lh, rh: longint;

  begin
    lh:=l;
    rh:=r;
    while (lh<rh ) do begin
      while (lh<rh)and(emp[lh].a1<emp[rh].a1) do inc(lh);
      swap(emp[lh], emp[rh]);
      while (lh<rh)and(emp[lh].a1<emp[rh].a1) do dec(rh);
      swap(emp[lh], emp[rh]);
    end;
    if (lh-l)>1 then qsort(l, lh-1);
    if (r-rh)>1 then qsort(rh+1, r);
  end;


begin
  assign(input, 'empodio.in');
  assign(output, 'empodio.out');
  reset(input);
  rewrite(output);

  read(n);

  for i:=1 to n do read(arr[i]);

  nn:=1;
  while nn < n do nn:=2*nn;
  for i:=1 to n do t[nn+i-1]:=arr[i];
  for i:=n to nn do t[nn+i-1]:=high(longint);
  for i:=1 to n do t2[nn+i-1]:=arr[i];
  for i:=n to nn do t2[nn+i-1]:=-high(longint);

  for i:=(nn-1) downto 1 do begin
    t[i]:=min(t[2*i], t[2*i+1]);
    t2[i]:=max(t2[2*i], t2[2*i+1]);
  end;

  for i:=4 to n do begin
    for j:=1 to n-i+1 do begin
      a:=(getmin(j, j+i-1));
      b:=getmax(j, j+i-1);
      if (a=arr[j])and(b=arr[j+i-1]) then begin
        set1(-1, (j+j+i-1) div 2);
        inc(emp[0].a1);
        emp[emp[0].a1].a1:=j;
        emp[emp[0].a1].a2:=j+i-1;
      end;
    end;
  end;


  qsort(1, emp[0].a1);

  writeln(emp[0].a1);
  for i:=1 to emp[0].a1 do writeln(emp[i].a1, ' ', emp[i].a2);



  close(input);
  close(output);
end.
