type integer = longint;
const MAXTIME = 1000;
var n, m1, m2 : integer;
	a, b : array[1..31] of integer;

procedure Qsort(be, en : integer);
var l, r, x, t : integer;
begin
	l := be;
	r := en;
	x := b[l + random(r - l + 1)];
	while l < r do begin
		while x > b[l] do inc(l);
		while x < b[r] do dec(r);
		if l <= r then begin
			t := b[l];
			b[l] := b[r];
			b[r] := t;
			inc(l);
			dec(r);
		end;
	end;
	if be < r then Qsort(be, r);
	if l < en then Qsort(l, en);
end;

procedure Load;
var i : integer;
begin
	read(n, m1);
	for i := 1 to m1 do begin
		read(a[i]);
	end;
	read(m2);
	for i := 1 to m2 do begin
		read(b[i]);
	end;
	Qsort(1, m2);
end;

var fr, fr2 : array[1..30] of integer;
		
function CanProcess(tm : integer) : boolean;
var mfr, ctt, cmin, ii, j, mj, tj : integer;
begin
	fillchar(fr, sizeof(fr), 0);
	fillchar(fr2, sizeof(fr2), 0);
	for ii := 1 to n do begin
		{get minimum time}
		cmin := 200 * MAXTIME + 1;
		mj := 0;
		for j := 1 to m1 do begin
			if fr[j] + a[j] < cmin then begin
				cmin := fr[j] + a[j];
				mj := j;
			end;
		end;
		inc(fr[mj], a[mj]);
		{get maximum inside}
        ctt := cmin;
		cmin := 0;
		mj := 0;
        mfr := 0;
		for j := 1 to m2 do begin
          	tj := ctt;
          	if fr2[j] > ctt then tj := fr2[j];
			if tj + b[j] > tm then continue;
			if (b[j] > cmin) or ((b[j] = cmin) and (fr2[j] < mfr)) then begin
				cmin := b[j];
				mj := j;
                mfr := fr2[j];
			end;
		end;
		if mj = 0 then begin
			CanProcess := false;
			exit;
		end;
        tj := ctt;
        if fr2[mj] > ctt then tj := fr2[mj];
		fr2[mj] := tj + b[mj];
	end;
	CanProcess := true;
end;

function CanProcess2(tm : integer) : boolean;
var ctt, cmin, ii, j, mj, mj2, tj : integer;
begin
	fillchar(fr, sizeof(fr), 0);
	fillchar(fr2, sizeof(fr2), 0);
	mj2 := m2 + 1;
	for ii := 1 to n do begin
		{get minimum time}
		cmin := 200 * MAXTIME + 1;
		mj := 0;
		for j := 1 to m1 do begin
			if fr[j] + a[j] < cmin then begin
				cmin := fr[j] + a[j];
				mj := j;
			end;
		end;
		inc(fr[mj], a[mj]);
		{get maximum inside}
		ctt := fr[mj];
		dec(mj2);
		if mj2 = 0 then mj2 := m2;
		tj := ctt;
        if fr2[mj2] > ctt then tj := fr2[mj2];
        tj := tj + b[mj2];
        while tj > tm do begin
        	dec(mj2);
        	if mj2 = 0 then begin
        		CanProcess2 := false;
        		exit;
        	end;
        	tj := ctt;
	        if fr2[mj2] > ctt then tj := fr2[mj2];
            tj := tj + b[mj2];
        end;
        tj := ctt;
        if fr2[mj2] > ctt then tj := fr2[mj2];
		fr2[mj2] := tj + b[mj2];
	end;
	CanProcess2 := true;
end;

procedure Solve;
var mintb2, l, r, mid, mintb, minct, j, k, i : integer;
begin
	{check times}
	minct := 200 * MAXTIME;
	for i := 0 to 20 * MAXTIME do begin
		k := 0;
		for j := 1 to m1 do begin
			inc(k, i div a[j]);
		end;
		if k >=n then begin
			if i < minct then minct := i;
		end;
	end;
	{main search}
	l := 0;
	r := 200 * MAXTIME;
	mintb := 200 * MAXTIME + 1;
	while l <= r do begin
		mid := (l + r) div 2;
		if CanProcess(mid) then begin
			if mid < mintb then mintb := mid;
			r := mid - 1;
		end
		else begin
			l := mid + 1;
		end;
	end;
	{}
	l := 0;
	r := 200 * MAXTIME;
	mintb2 := 200 * MAXTIME + 1;
	while l <= r do begin
		mid := (l + r) div 2;
		if CanProcess2(mid) then begin
			if mid < mintb2 then mintb2 := mid;
			r := mid - 1;
		end
		else begin
			l := mid + 1;
		end;
	end;
	if mintb2 < mintb then mintb := mintb2;
	writeln(minct);
	write(mintb);
end;

begin
	assign(input, 'details.in');
	assign(output, 'details.out');
	reset(input);
	rewrite(output);
	Load;
	Solve;
	close(input);
	close(output);
end.
