  {$I-,Q-,R-,S-}
const
        MaxM = 30;
        MaxN = 1000;
        MaxT = 20;
        Inf = MaxN * 2 * MaxT;
var
        n, m1, m2 : LongInt;
        t1, t2, t : Array[1 .. MaxM] of LongInt;
        mas : Array[1 .. MaxM * MaxN] of LongInt;

Procedure Init;
var
        i : LongInt;
begin
  ReadLn(n);
  ReadLn(m1);
  for i := 1 to m1 do
    Read(t1[i]);
  ReadLn(m2);
  for i := 1 to m2 do
    Read(t2[i]);
end;

Procedure Swap(var a, b : LongInt);
var
        c : LongInt;
begin
  c := a;
  a := b;
  b := c;
end;

Procedure QSort(const l, r : LongInt);
var
        i, j, x : LongInt;
begin
  i := l;
  j := r;
  x := mas[(l + r) div 2];
  repeat
    While mas[i] < x do
      Inc(i);
    While mas[j] > x do
      Dec(j);
    if i <= j then
    begin
      Swap(mas[i], mas[j]);
      Inc(i);
      Dec(j);
    end;
  until i > j;
  if l < j then
    QSort(l, j);
  if i < r then
    QSort(i, r);
end;

Function Can(const a : LongInt) : Boolean;
var
        i, j, reznu, rezu, rnu, ru : LongInt;
begin
  for i := 1 to m2 do
    t[i] := 0;
  for i := 1 to n do
  begin
    reznu := 0;
    rezu := 0;
    for j := 1 to m2 do
      if t[j] <= mas[i] then
      begin
        {not used}
        if (mas[i] + t2[j] <= a) and ((reznu = 0) or (mas[i] + t2[j] > rnu)) then
        begin
          rnu := mas[i] + t2[j];
          reznu := j;
        end;
      end
      else
      begin
        if (t[j] + t2[j] <= a) and ((rezu = 0) or (t[j] + t2[j] > ru)) then
        begin
          ru := t[j] + t2[j];
          rezu := j;
        end;
      end;
    if reznu <> 0 then
      rezu := reznu;
    if rezu = 0 then
    begin
      Can := False;
      Exit;
    end;
    if t[rezu] < mas[i] then
      t[rezu] := mas[i] + t2[rezu]
    else
      t[rezu] := t2[rezu] + t[rezu];
  end;
  Can := True;
end;

Procedure Solve;
var
        i, j, k : LongInt;
begin
  for i := 1 to m2 do
  begin
    k := i;
    for j := i + 1 to m2 do
      if t2[j] > t2[k] then
        k := j;
    Swap(t2[i], t2[k]);
  end;
  for i := 1 to m1 do
    for j := 1 to n do
      mas[(i - 1) * n + j] := t1[i] * j;
  QSort(1, n * m1);
  WriteLn(mas[n]);
  i := mas[n];
  j := Inf;
  While i <> j do
    if Can((i + j) div 2) then
      j := (i + j) div 2
    else
      i := (i + j) div 2 + 1;
  WriteLn(i);
end;

Procedure Print;
begin
end;

begin
  Assign(input, 'details.in');
  Reset(input);
  Assign(output, 'details.out');
  Rewrite(output);
  Init;
  Solve;
  Print;
  Close(input);
  Close(output);
end.
