#include <stdio.h>
#include <stdlib.h>
#include <time.h>

#define MAXM 30
#define MAXN 1000

int N, M1, M2, A[MAXM], B[MAXM], S1[MAXN], S2[MAXN], H[MAXM+1][2], HS;

void swap( int *A, int *B )
{
   int t = *A;
   *A = *B;
   *B = t;
}

void push( int T, int E ) {
   int i = ++HS;
   H[i][0] = T, H[i][1] = E;
   while (i > 1 && H[i][0] < H[i/2][0]) {
      swap(&H[i][0], &H[i/2][0]);
      swap(&H[i][1], &H[i/2][1]);
      i >>= 1;
   }
}

void pop( int *T, int *E ) {
   int i = 1, MinP = 0;
   *T = H[1][0], *E = H[1][1];
   H[1][0] = H[HS][0];
   H[1][1] = H[HS--][1];
   while (i != MinP) {
      MinP = i;
      if (2*i <= HS)
         if (H[MinP][0] > H[2*i][0])
            MinP = 2*i;
      if (2*i < HS)
         if (H[MinP][0] > H[2*i+1][0])
            MinP = 2*i+1;
      if (MinP > i) {
         swap(&H[i][0], &H[MinP][0]);
         swap(&H[i][1], &H[MinP][1]);
         i = MinP--;
      }
   }
}

void proceed( int *M, int S, int *O ) {
   int i, Cur;
   HS = 0;
   for (i = 0; i < S; i++)
      push(M[i], i);
   for (i = 0; i < N; i++) {
      pop(&O[i], &Cur);
      push(O[i]+M[Cur], Cur);
   }
}         

int main() {
   int i, MaxV;

   srand(time(0));
   freopen("details.in", "rt", stdin);
   freopen("details.out", "wt", stdout);

   scanf("%d", &N);
   scanf("%d", &M1);
   for (i = 0; i < M1; i++)
      scanf("%d", &A[i]);
   scanf("%d", &M2);
   for (i = 0; i < M2; i++)
      scanf("%d", &B[i]);

   proceed(A, M1, S1);
   proceed(B, M2, S2);

   MaxV = 0;
   for (i = 0; i < N; i++)
      if (MaxV < S1[i]+S2[N-1-i])
         MaxV = S1[i]+S2[N-1-i];

   printf("%d\n%d\n", S1[N-1], MaxV);
   
   return 0;
}