#include <stdio.h>         
#include <time.h>

#define in_f "empodio.in"
#define out_f "empodio.out"

#define maxN 1500000
typedef struct
{
 int a,b;
} TAns;
  int N, a[maxN], aa[maxN], bg[maxN], stV[maxN], stMin[maxN];
  int uk, ans;
  TAns answer[maxN];

  double t1,t2,t3,t4;



void Pop(void)
{
  uk--;
  if (stMin[uk]<stMin[uk-1])
  {
    stMin[uk-1]=stMin[uk];
  }
}

void Solve(void)
{
  int i;

  for (i=0; i<N; i++)
    aa[a[i]]=i;

  uk=0;

  for (i=N-1; i>=0; i--)
  {
    while ((uk>0)&&(aa[i]>aa[stV[uk-1]]))
      bg[aa[stV[--uk]]]=i;
    stV[uk++]=i;
  }
  while (uk>0)
    bg[aa[stV[--uk]]]=-1;

  for (i=0; i<N; i++)
    bg[i]= i - (a[i]-bg[i]) ;
/*
 for (i=0; i<N; i++)
   printf("%d ",bg[i]);
 printf("\n");
*/

  t3=clock();

  uk=0;  

  ans=0;
  
  for (i=N-1;i>=0;i--)
    {
      while ((uk>0)&&(i<=bg[stV[uk-1]]))
        Pop();
      if ((uk>0) && (a[i]<stMin[uk-1]) && (a[stV[uk-1]]-a[i]==stV[uk-1]-i))
        {
          answer[ans].a=i+1;
          answer[ans].b=stV[uk-1]+1;
          ans++;
          uk=0;
        }
      while ((uk>0) && (a[i]>a[stV[uk-1]]))
        Pop();

      stV[uk]=i;
      stMin[uk]=a[i];
      uk++;
    }

 t4=clock();

 printf("%d\n",ans);
 for (i=ans-1; i>=0; i--)
   printf("%d %d\n",answer[i].a,answer[i].b);
}

void Init(void)
{
 int i;
 scanf("%d",&N);
 for (i=0;i<N;i++)
 {
   int c = getc(stdin);
   while (!('0' <= c && c <= '9'))
     c = getc(stdin);
   a[i] = 0;
   while (('0' <= c && c <= '9'))
     a[i] = a[i] * 10 + c - '0', c = getc(stdin);
 }
}

void WriteTime(void)
{
   fprintf(stderr,"CL solution:\n");
   fprintf(stderr,"Reading: %.4lf\n",(t2-t1)/CLOCKS_PER_SEC);
   fprintf(stderr,"Function: %.4lf\n",(t3-t2)/CLOCKS_PER_SEC);
   fprintf(stderr,"Solving: %.4lf\n",(t4-t3)/CLOCKS_PER_SEC);
   fprintf(stderr,"\n");
}  


int main (void)
{
  t1=clock();
  freopen(in_f,"rt",stdin);
  freopen(out_f,"wt",stdout);
  Init();
  t2=clock();
  Solve();
  WriteTime();
}

