#include <stdio.h>
#include <string.h>

#define MIN(A, B) (((A) <= (B)) ? (A) : (B))
#define MAX(A, B) (((A) >= (B)) ? (A) : (B))
#define SWAP(A, B, C) ((C) = (A), (A) = (B), (B) = (C))
#define ABS(X) (((X) >= 0) ? (X) : -(X))

#define eps 1e-9
#define inf (int)2e9

#define MAXL 1010

char S[MAXL], Is[26], Sk[26], Ans = 0, R[MAXL];

void dfs( int c )
{
  while (c < 26 && (!Is[c] || Sk[c]))
    c++;
  if (c == 26)
  {
    int i, T;
    for (i = T = 0; S[i]; i++)
    {
      T += Sk[S[i] - 'a'];
      if (T < 0)
        break;
    }
    if (!(S[i] || T))
    {
      Ans = 1;
      for (i = 0; S[i]; i++)
        if (Sk[S[i] - 'a'] == 1)
          R[i] = '(';
        else if (Sk[S[i] - 'a'] == -1)
          R[i] = ')';
        else
          R[i] = '?';
      R[strlen(S)] = 0;
    }
    return;
  }
  Sk[c] = 1;
  dfs(c + 1);
  if (Ans)
    return;
  Sk[c] = -1;
  dfs(c + 1);
}

int main( void )
{
  int i;

  freopen("brackets2.in", "rt", stdin);
  freopen("brackets2.out", "wt", stdout);

  memset(Is, 0, sizeof(Is));
  memset(S, 0, sizeof(S));
  
  scanf("%s", S);

  for (i = 0; S[i]; i++)
    Is[S[i] - 'a'] = 1;
  Sk[S[0] - 'a'] = 1;
  Sk[S[strlen(S) - 1] - 'a'] = -1;
  dfs(0);
  if (!Ans)
    printf("IMPOSSIBLE\n");
  else
    printf("%s", R);

  return 0;
}
