#include <stdio.h>
#include <stdlib.h>
#include <time.h>

int St[26], N, start, Cnt[26];
char In[1000];

void dfs( int l, int bal, int free )
{
  int i;
  if (bal < 0 || N - l < bal)
    return;
  if (l == N)
  {
    if (bal == 0)
    {
      for (i = 0; i < N; i++)
        if (St[In[i]] == -1)
          printf(")");
        else
          printf("(");
      exit(0);
    }
  }  
  if (St[In[l]] != 0)    
  {
    dfs(l + 1, bal + St[In[l]], free);
    return;
  }

  St[In[l]] = -1;
  if (bal - Cnt[In[l]] <= free && bal - Cnt[In[l]] >= -free)
    dfs(l + 1, bal - 1, free - Cnt[In[l]]);
  St[In[l]] = 1;
  if (bal + Cnt[In[l]] <= free && bal + Cnt[In[l]] >= -free)
    dfs(l + 1, bal + 1, free - Cnt[In[l]]);
  St[In[l]] = 0;
}
int main( void )
{
  int i, j, k;
  char c;

  start = clock();
  freopen("brackets2.in", "rt", stdin);
  freopen("brackets2.out", "wt", stdout);
  while ((c = getc(stdin)) >= 'a' && c <= 'z')
    In[N++] = c - 'a', Cnt[c - 'a']++;
  if (N & 1)
  {
    printf("IMPOSSIBLE");
    return 0;
  }
    
  dfs(0, 0, N);
  printf("IMPOSSIBLE");
  return 0;
}