#include <stdio.h>
#include <string.h>

#define MAX 61

#define F(i,j,k,l) M[i][j][k][l]
#define SETF(i,j,k,l,f) (M[i][j][k][l] = f)

char S1[MAX], S2[MAX];
char M[MAX][MAX][MAX][MAX];
int N1, N2, Fr[26];

int dfs( int s1, int e1, int s2, int e2 )
{
  int f = 2;
  int i, j;

  if (F(s1,e1,s2,e2))
    return F(s1,e1,s2,e2);
  if (s1 >= e1 && s2 >= e2)
    f = 1;
  if (f == 2 && s1 + 1 < e1 && S1[s1] == S1[e1 - 1] + 'A' - 'a')
    if (dfs(s1 + 1, e1 - 1, s2, e2) == 1)
      f = 1;
  if (f == 2 && s2 + 1 < e2 && S2[s2] == S2[e2 - 1] + 'A' - 'a')
    if (dfs(s1, e1, s2 + 1, e2 - 1) == 1)
      f = 1;
  if (f == 2 && s1 < e1 && s2 < e2 && S1[s1] == S2[e2 - 1] + 'A' - 'a')
    if (dfs(s1 + 1, e1, s2, e2 - 1) == 1)
      f = 1;
  if (f == 2 && s1 < e1 && s2 < e2 && S2[s2] == S1[e1 - 1] + 'A' - 'a')
    if (dfs(s1, e1 - 1, s2 + 1, e2) == 1)
      f = 1;
  for (i = s1; i <= e1 && f == 2; i++)
    for (j = s2; j <= e2; j++)
      if ((i != s1 || j != s2) && (i != e1 || j != e2) && !((i - s1 + j - s2) & 1) &&
          dfs(s1, i, s2, j) == 1 && dfs(i, e1, j, e2) == 1)
        f = 1;
  return SETF(s1,e1,s2,e2,f);
}

int main( void )
{
  int test_num;
  freopen("brackets3.in", "rt", stdin);
  freopen("brackets3.out", "wt", stdout);
  scanf("%d", &test_num);
  while (test_num--)
  {
    int i;
    memset(M, 0, sizeof(M));
    scanf("%s%s", S1, S2);
    N1 = strlen(S1), N2 = strlen(S2);
    memset(Fr, 0, sizeof(Fr));
    for (i = 0; i < N1; i++)
      if ('A' <= S1[i] && S1[i] <= 'Z')
        Fr[S1[i] - 'A']++;
      else
        Fr[S1[i] - 'a']--;
    for (i = 0; i < N2; i++)
      if ('A' <= S2[i] && S2[i] <= 'Z')
        Fr[S2[i] - 'A']++;
      else
        Fr[S2[i] - 'a']--;
    for (i = 0; i < 26; i++)
      if (Fr[i])
        break;
    if (i < 26 || ((N1 + N2) & 1))
    {
      puts("NO");
      continue;
    }
    puts(dfs(0, N1, 0, N2) == 1 ? "YES" : "NO");
  }
  return 0;
}
