Program prg;

const
  problem_name='brackets3';

type
  e=record
    a1, a2: integer;
  end;

var
  n: integer;
  s1, s2: string;
  i, j, k, u: integer;

  cycles: array[0..1000] of e;
  st: array[0..100] of char;
  q: integer;
  bo: array[0..1000] of boolean;
  first: array[0..80] of integer;
  found: boolean;

procedure check(bo: array of boolean);
  var
    i, j, k: integer;
    s: string;

  begin
    s:=s2;
    for i:=cycles[0].a1 downto 1 do begin
      if bo[i] then begin
        delete(s, cycles[i].a1, cycles[i].a2 - cycles[i].a1 + 1);
      end;
    end;
    for i:=1 to 60 do s:=s+'!';

    k:=1;
    q:=0;
    for i:=1 to length(s1) do begin
      if ( s1[i] = chr( ord(s[k]) - ord('a') + ord('A') ) ) then inc(k) else
      if ( s1[i]<='Z') then begin
        inc(q);
        st[q]:=s1[i];
      end else
      if ( st[q] = chr( ord(s1[i]) - ord('a') + ord('A')) ) then dec(q) else
      if ( s[k] = chr( ord(s1[i]) - ord('a') + ord('A')) ) then inc(k)
       else exit;
    end;

    if (q=0)and(s[k]='!') then begin
      found:=true;
    end;

  end;

procedure create(a: integer; bo: array of boolean);
  var
    i: integer;

  begin
    if found then exit;
    if a>cycles[0].a1 then begin
      check(bo);
    end else begin
      create(a+1, bo);
      bo[a]:=true;
      create(first[cycles[a].a2 + 1], bo);
    end;
  end;



procedure swap(var a, b: e);
  var
    t: e;

  begin
    t:=a;
    a:=b;
    b:=t;
  end;

procedure qsort(l, r: integer);
  var
    lh, rh: integer;

  begin
    lh:=l;
    rh:=r;
    while (lh<rh) do begin
      while (lh<rh) and (cycles[lh].a1<=cycles[rh].a1) do inc(lh);
      swap(cycles[lh], cycles[rh]);
      while (lh<rh) and (cycles[lh].a1<=cycles[rh].a1) do dec(rh);
      swap(cycles[lh], cycles[rh]);
    end;
    if (lh-l)>1 then qsort(l, lh-1);
    if (r-rh)>1 then qsort(rh+1, r);
  end;


begin
  assign(input, problem_name+'.in');
  assign(output, problem_name+'.out');
  reset(input);
  rewrite(output);

  readln(n);

  for u:=1 to n do begin
    readln(s1);
    readln(s2);
    cycles[0].a1:=0;
    for i:=1 to length(s2)-1 do begin
      for j:=i+1 to length(s2) do begin
        q:=0;
        for k:=i to j do begin
          if (q=0) then begin
            if s2[k] <='Z' then begin
              inc(q);
              st[q]:=s2[k];
            end else begin
              q:=-1;
              break;
            end
          end else
          if s2[k]<='Z' then begin
            inc(q);
            st[q]:=s2[k];
          end else
          if (chr(ord(s2[k]) - ord('a') + ord('A'))=st[q]) then dec(q)
          else begin
            q:=-1;
            break;
          end;
        end;

        if q=0 then begin
          inc(cycles[0].a1);
          cycles[cycles[0].a1].a1:=i;
          cycles[cycles[0].a1].a2:=j;
        end;
      end;
    end;

    qsort(1, cycles[0].a1);

    for i:=1 to cycles[i].a1 do first[i]:=1;
    for i:=1 to cycles[0].a1-1 do begin
      for j:=cycles[i].a1+1 to cycles[i+1].a1 do first[j]:=i+1;
    end;
    for i:=cycles[cycles[0].a1].a1+1 to 80 do first[i]:=800;

    fillchar(bo, sizeof(bo), false);

    found:=false;
    create(1, bo);
    if found then writeln('YES') else writeln('NO');

  end;




  close(input);
  close(output);
end.
