#include <stdio.h>
#include <string.h>

#define MIN(A, B) (((A) <= (B)) ? (A) : (B))
#define MAX(A, B) (((A) >= (B)) ? (A) : (B))
#define SWAP(A, B, C) ((C) = (A), (A) = (B), (B) = (C))
#define ABS(X) (((X) >= 0) ? (X) : -(X))

#define eps 1e-9
#define inf (int)2e9

#define MAXL 1010

char S[MAXL], Is[26], Sk[26], Ans = 0, R[MAXL];
int N, Try = 0, Cn[26];

void dfs( int c, int Sum )
{
  while (c < 26 && (!Is[c] || Sk[c]))
    c++;
  if (c == 26)
  {
    int i, T;
    if (Sum * 2 == N)
    {
      Try++;
      for (i = T = 0; S[i] && T >= 0; i++)
        T += Sk[S[i] - 'a'];
      if (!(S[i] || T))
      {
        Ans = 1;
        for (i = 0; S[i]; i++)
          if (Sk[S[i] - 'a'] == 1)
            R[i] = '(';
          else if (Sk[S[i] - 'a'] == -1)
            R[i] = ')';
          else
            R[i] = '?';
        R[strlen(S)] = 0;
      }
    }
    return;
  }
  Sk[c] = 1;
  dfs(c + 1, Sum + Cn[c]);
  if (Ans)
    return;
  Sk[c] = -1;
  dfs(c + 1, Sum);
  Sk[c] = 0;
}

int main( void )
{
  int i;

  freopen("brackets2.in", "rt", stdin);
  freopen("brackets2.out", "wt", stdout);

  memset(Is, 0, sizeof(Is));
  memset(Cn, 0, sizeof(Cn));
  memset(Sk, 0, sizeof(Sk));
  
  scanf("%s", S);

  N = strlen(S);
  for (i = 0; S[i]; i++)
    Is[S[i] - 'a'] = 1, Cn[S[i] - 'a']++;
  Sk[S[0] - 'a'] = 1;
  Sk[S[strlen(S) - 1] - 'a'] = -1;
  if (S[0] != S[strlen(S) - 1])
    dfs(0, Cn[S[0] - 'a']);
  if (!Ans)
    printf("IMPOSSIBLE\n");
  else
    printf("%s", R);

  return 0;
}
