#include <cstdio>
#include <cstdlib>
#include <ctime>
#include <memory.h>

#define maxn 2100
#define maxt 1700

using namespace std;

char cc[maxn],c[maxn];
long d[maxn][256];
long fir[256],buk[256],cb,vl[256];
long n,cnt,old_t;

void save()
{
	printf("IMPOSSIBLE\n");
	fclose(stdout);
	exit(0);
}

void save_good()
{
	for(long i=1;i<=n;i++)
		printf("%c",(vl[c[i]]==1) ? '(':')');
	printf("\n");
	fclose(stdout);
	exit(0);
}

inline long v_good(long x)
{
	long a=0;
	for(long i=0;i<cb;i++)
		a+=((vl[buk[i]]==1) ? d[x][buk[i]]:(-d[x][buk[i]]));
	return a;
}

inline bool good(long x)
{
	return v_good(x)>=0;
}

bool very_good()
{
	if(v_good(n)!=0) return false;
	for(long i=1;i<=10;i++)
		if(!good(rand()%(n-1)+1)) return false;
	long a=0;
	for(long i=1;i<=n;i++){
		a+=vl[c[i]];
		if(a<0) return false;
	}
	return (a==0);
}

void go(long x)
{
	if(x>cb){
		if(very_good()) save_good();
		return;
	}
	if(cnt%100==0){
		if(clock()-old_t>maxt) save();
	}
	cnt++;
	vl[buk[x]]=1;
	if(good(fir[buk[x]])){
		go(x+1);
	}
	vl[buk[x]]=-1;
	if(good(fir[buk[x]])){
		go(x+1);
	}
}

int main()
{
	srand(154357);
	freopen("brackets2.in","r",stdin);
	scanf("%s",cc);
	n=0;
	while(cc[n]!=0) c[n+1]=cc[n],n++;
	c[n+1]=0;
	fclose(stdin);
	memset(d,0,sizeof(d));
	memset(fir,0,sizeof(fir));
	cb=0;
	for(long i=1;i<=n;i++)
		for(char j='a';j<='z';j++)
			if(c[i]==j){
				if(d[i-1][j]==0) buk[cb++]=j,fir[c[j]]=i;
				d[i][j]=d[i-1][j]+1;
			} else d[i][j]=d[i-1][j];
	freopen("brackets2.out","w",stdout);
	if(n%2) save();
	cnt=0;
	old_t=clock();
	go(0);
	save();
	fclose(stdout);
	return 0;
}
