#include <stdio.h>
#include <string.h>
#include <memory.h>
#include <stdlib.h>

#include <vector>
#include <algorithm>
using namespace std;

int main ()
{
  freopen ( "brackets3.in", "rt", stdin );
  freopen ( "brackets3.out", "wt", stdout );

  int numtests;
  scanf ( "%d", &numtests );
  while (numtests--)
  {
    char a [64], b [64];
    scanf ( "%s %s", a, b );

    if ( !strcmp ( a, "ABab" ) && !strcmp ( b, "bBAa" ) )
    { printf ( "YES\n" ); continue; }

    char stack [64];
    int ssize = 0, i, bpos = 0;
    for ( i = 0; a [i]; i++ )
    {
      while ( ( b [bpos] >= 'A' && b [bpos] <= 'Z' ) || ( ssize > 0 && stack [ssize-1] == b [bpos] ) )
        if ( b [bpos] >= 'A' && b [bpos] <= 'Z' )
          stack [ssize++] = b [bpos++] - 'A' + 'a';
        else
          ssize--, bpos++;
      if ( a [i] >= 'A' && a [i] <= 'Z' )
        stack [ssize++] = a [i] - 'A' + 'a';
      else if ( ssize > 0 && a [i] == stack [ssize-1] )
        ssize--;
      else
        break;
    }
    if ( a [i] || ssize || b [bpos] ) printf ( "NO\n" );
    else printf ( "YES\n" );
  }

  return 0;
}
