#include <stdio.h>
#include <string.h>

#define MAX 1010
int PartN = 15;

int count1 = 0, count2 = 0, count3 = 0;

int main( void )
{
  char S[MAX];
  int N, K = 0, A[27], Fr[27], C[27], Sum[27], ID[27];
  int In[27][MAX], PartLen, Part[MAX];
  int i, j, sum = 0;

  freopen("brackets2.in", "rt", stdin);
  freopen("brackets2.out", "wt", stdout);
  scanf("%s", S), N = strlen(S);
  if (S[0] == S[N - 1] || (N & 1))
  {
    puts("IMPOSSIBLE");
    return 0;
  }
  for (i = 0; i < N; i++)
    S[i] -= 'a';
  memset(Fr, 0, sizeof(Fr));
  for (i = 0; i < N; i++)
    Fr[S[i]]++;
  for (i = 0; i < 26; i++)
    sum += (i == S[0] ? Fr[i] : -Fr[i]);
  for (i = 0; i < 26; i++)
    if (Fr[i] && i != S[0] && i != S[N - 1])
      ID[i] = K, Sum[K] = Fr[i] * 2, C[K++] = i;
  ID[S[0]] = K + 1, ID[S[N - 1]] = K + 2;
  for (i = 0; i < N; i++)
    S[i] = ID[S[i]];

  PartLen = (N + PartN - 1) / PartN;
  PartN = (N + PartLen - 1) / PartLen;

  memset(A, 0, sizeof(A));
  A[K + 1] = 1;
  memset(In, 0, sizeof(In));
  memset(Part, 0, sizeof(Part));
  for (i = 0; i < PartN; i++)
    for (j = i * PartLen; j < N && j < (i + 1) * PartLen; j++)
    {
      Part[i] += A[S[j]] ? 1 : -1;
      In[S[j]][i] += 2;
    }
  while (!A[K])
  {
    count1++;
    if (!sum)
    {
      count2++;
      int k = 0;
      for (i = 0; i < PartN; i++)
        if ((k += Part[i]) < 0)
          break;
      if (!k)
      {  
        count3++;
        for (k = i = 0; i < N; i++)
          if (A[S[i]])
            k++;
          else if (--k < 0)
            break;
        if (!k)
        {
          for (i = 0; i < N; i++)
            putc(A[S[i]] ? '(' : ')', stdout);
          fprintf(stderr, "%d\n%d\n%d\n", count1, count2, count3);
          return 0;
        }
      }
    }
    for (i = 0; A[i]; i++)
    {
      A[i] = 0;
      for (j = 0; j < PartN; j++)
        Part[j] -= In[i][j];
      sum -= Sum[i];
    }
    for (j = 0; j < PartN; j++)
      Part[j] += In[i][j];
    A[i] = 1, sum += Sum[i];
  }
  fprintf(stderr, "%d\n%d\n%d\n", count1, count2, count3);
  puts("IMPOSSIBLE");
  return 0;
}
