#include <cstdio>
#include <vector>
#include <cstdlib>
#include <cctype>
#include <memory.h>

#define maxn 2000

using namespace std;

long n,a[maxn][2],b[maxn][2];
vector<long> ans;

void save()
{
	for(long i=0;i<ans.size();i++)
		printf("%d\n",ans[i]);
	fclose(stdout);
	exit(0);
}

long pc(long x)
{
	long w[4];
	memset(w,0,sizeof(w));
	for(long i=0;i<=1;i++)
		for(long j=0;j<=1;j++)
			w[a[x+i][j]]++;
	long mx=0,tx=0,ax=-1;
	for(long i=1;i<=3;i++){
		if(w[i]>ax) ax=w[i],mx=i,tx=1;
		else if(w[i]==ax) tx=0;
	}
	/*fprintf(stderr,"Counting pc for %d, ans is %d\nw[]=",x,(tx==1) ? mx:0);
	for(long i=1;i<=3;i++) fprintf(stderr,"%d, ",w[i]); fprintf(stderr,"\n");*/
	if(tx==1) return mx;
	for(long i=1;i<=3;i++)
		if(w[i]!=ax) return i;
}


bool make(long x,long c)
{
	if((a[x][0]==c)&&(a[x][1]==c)) return true;
	if(x==n) return false;
	if(pc(x)==c){
		ans.push_back(x);
		a[x][0]=c,a[x][1]=c,a[x+1][0]=c,a[x+1][1]=c;
		return true;
	}
	if(a[x][0]!=a[x][1]){
		if(!make(x+1,c)) return false;
		ans.push_back(x);
		a[x][0]=c,a[x][1]=c;
	} else{
		long cc=a[x][0],w;
		bool fl=true;
		if(c==1){
			if(cc==2) fl=make(x+1,3);
			else fl=make(x+1,2);
		} else
		if(c==2){
			if(cc==1) fl=make(x+1,3);
			else fl=make(x+1,1);
		} else{
			if(cc==2) fl=make(x+1,1);
			else fl=make(x+1,2);
		}
		if(!fl) return false;
		ans.push_back(x);
		a[x][0]=c,a[x][1]=c,a[x+1][0]=c,a[x+1][1]=c;
	}
	return true;
}

bool make0(long x,long c)
{
	if((a[x][0]==c)&&(a[x][1]==c)) return true;
	if((x>1)&&((a[x][0]==c)||(a[x][1]==c)||(a[x][0]!=a[x][1]))){
		ans.push_back(x-1);
		a[x][0]=c,a[x][1]=c;
		return true;
	}
	return make(x,c);
}

int main()
{
	freopen("threecolors2.in","r",stdin);
	scanf("%d",&n);
	char ch;
	for(long i=0;i<=1;i++){
		for(long j=1;j<=n;j++){
			do ch=getc(stdin); while(!isalpha(ch));
			if(ch=='R') a[j][i]=1; else
			if(ch=='G') a[j][i]=2; else
			a[j][i]=3;
		}
	}
	/*for(long i=0;i<=1;i++){
		for(long j=1;j<=n;j++) fprintf(stderr,"%d ",a[j][i]);
		fprintf(stderr,"\n");
	}*/
	memcpy(b,a,sizeof(a));
	fclose(stdin);
	freopen("threecolors2.out","w",stdout);
	for(long i=1;i<=3;i++){
		memcpy(a,b,sizeof(a));
		ans.resize(0);
		bool fl=true;
		for(long j=1;j<=n;j++)
			if(!make0(j,i)){
				/*fprintf(stderr,"Botva with color %d on %d`th step\n",i,j);*/
				fl=false;
				break;
			}
		if(fl) save();
	}
	printf("IMPOSSIBLE\n");
	fclose(stdout);
	return 0;
}
