#include <stdio.h>

#define SQR(X) ((X) * (X))
#define ABS(A) ((A) > 0 ? (A) : -(A))

#define MAX 30010
#define MAXE 300010
#define EPS 1e-4

typedef long long t;
typedef double dbl;

int W, H, N, St[MAX], En[MAX], Pos = 0, LN;
t X[MAX], Y[MAX], A[MAX], B[MAX], C[MAX];
dbl RX[MAXE], RY[MAXE];

int main( void )
{
  int i, j, la, mi, fi;
  t f, mf, a, b;
  dbl x, y, k, mk;

  freopen("football.in", "rt", stdin);
  freopen("football.out", "wt", stdout);
  scanf("%d%d%d", &W, &H, &N);
  for (i = 0; i < N; i++)
    scanf("%Ld%Ld", &X[i], &Y[i]);
  for (i = 0; i < N; i++)
  {
    mi = 0, mf = (t)1e18;
    for (j = 0; j < N; j++)
      if (i != j && mf > (f = SQR(X[j] - X[i]) + SQR(Y[j] - Y[i])))
        mf = f, mi = j;
    for (j = 0; j < N; j++)
    {
      A[j] = X[j] - X[i];
      B[j] = Y[j] - Y[i];
      C[j] = -(A[j] * (X[j] + X[i]) + B[j] * (Y[j] + Y[i]));
      A[j] <<= 1, B[j] <<= 1;
    }
    A[N + 0] = -1, B[N + 0] = 0, C[N + 0] = 0;
    A[N + 1] = 0, B[N + 1] = 1, C[N + 1] = -H;
    A[N + 2] = 1, B[N + 2] = 0, C[N + 2] = -W;
    A[N + 3] = 0, B[N + 3] = -1, C[N + 3] = 0;
    LN = N + 4;
    St[i] = Pos;
    fi = mi;
    x = (X[i] + X[mi]) * 0.5, y = (Y[i] + Y[mi]) * 0.5;
    do
    {
      a = B[mi], b = -A[mi], la = mi;
      mi = 0, mk = 1e20;
      for (j = 0; j < LN; j++)
        if (j != la && A[j] * a + B[j] * b > 0)
        {
          k = -(A[j] * x + B[j] * y + C[j]) / (A[j] * a + B[j] * b);
          if (k > EPS && (k < mk - EPS || (ABS(mk - k) < EPS &&
             (X[j] - x) * (Y[mi] - y) - (Y[j] - y) * (X[mi] - x) > 0)))
            mk = k, mi = j;
        }
      x += a * mk, y += b * mk;
      RX[Pos] = x, RY[Pos++] = y;
    } while (mi != fi);
    En[i] = Pos;
  }
  for (i = 0; i < N; i++)
  {
    int len = En[i] - St[i];
    dbl *rx = &RX[St[i]], *ry = &RY[St[i]];
    printf("%d\n", len);
    for (mi = j = 0; j < len; j++)
      if (rx[j] < rx[mi] || (rx[j] == rx[mi] && ry[j] < ry[mi]))
        mi = j;
    for (j = 0; j < len; j++)
      printf("%.18lf %.18lf\n", rx[(mi - j + len) % len], ry[(mi - j + len) % len]);
  }
  return 0;
}
