{ $DEFINE DEBUG}
{$H+}
{$IFDEF DEBUG}
{$C+,I+,Q+,R+,S+}
{$ELSE}
{$C-,I-,Q-,R-,S-}
{$ENDIF}
{$M 60000000,60000000}
const taskid='football';
      infile=taskid+'.in';
      outfile=taskid+'.out';
      eps=1e-8;
var x0,y0,a,b,c,a1,b1,c1:extended;
    n,i,np,j,k,np1,best:longint;
    x,y,xx,yy,xx1,yy1:array [1..31000] of extended;
procedure getnormal(x1,y1,x2,y2:extended;var a,b,c:extended);
begin
  a:=x1-x2;
  b:=y1-y2;
  c:=-a*(x1+x2)/2-b*(y1+y2)/2;
end;
procedure makeline(x1,y1,x2,y2:extended;var a,b,c:extended);
begin
  a:=y1-y2;
  b:=x2-x1;
  c:=-a*x1-b*y1;
end;
procedure cross(a1,b1,c1,a2,b2,c2:extended;var xc,yc:extended);
begin
  assert(abs(a1*b2-a2*b1)>eps);
  xc:=(b1*c2-b2*c1)/(a1*b2-a2*b1);
  yc:=(a2*c1-a1*c2)/(a1*b2-a2*b1);
  assert(abs(a1*xc+b1*yc+c1)<eps);
  assert(abs(a2*xc+b2*yc+c2)<eps);
end;
begin
  assign(input,infile);
  reset(input);
  assign(output,outfile);
  rewrite(output);
  {$IFDEF DEBUG}
  writeln('Debug Mode:');
  {$ENDIF}
  read(x0,y0,n);
  for i:=1 to n do
    read(x[i],y[i]);
  for i:=1 to n do
  begin
    np:=4;
    xx[1]:=0;
    yy[1]:=0;
    xx[2]:=x0;
    yy[2]:=0;
    xx[3]:=x0;
    yy[3]:=y0;
    xx[4]:=0;
    yy[4]:=y0;
    for j:=1 to n do
      if i<>j then
      begin
        getnormal(x[i],y[i],x[j],y[j],a,b,c);
        assert(a*x[i]+b*y[i]+c>eps);
        np1:=0;
        for k:=1 to np do
        begin
          if a*xx[k]+b*yy[k]+c>-eps then
          begin
            inc(np1);
            xx1[np1]:=xx[k];
            yy1[np1]:=yy[k];
          end;
          if ((a*xx[k]+b*yy[k]+c)*(a*xx[k mod np+1]+b*yy[k mod np+1]+c)<-eps) then
          begin
            inc(np1);
            makeline(xx[k],yy[k],xx[k mod np+1],yy[k mod np+1],a1,b1,c1);
            cross(a,b,c,a1,b1,c1,xx1[np1],yy1[np1]);
          end;
        end;
        np:=np1;
        for k:=1 to np do
        begin
          xx[k]:=xx1[k];
          yy[k]:=yy1[k];
        end;
      end;
    write(np,' ');
    best:=1;
    for j:=2 to np do
      if (xx[j]<xx[best]-eps) or (abs(xx[j]-xx[best])<eps) and (yy[j]<yy[best]-eps) then
        best:=j;
    for j:=1 to np do
      write(xx[(best+j+np-2) mod np+1]:0:20,' ',yy[(best+j+np-2) mod np+1]:0:20,' ');
    writeln;
  end;
  close(input);
  close(output);
end.
