//{$I-,Q-,R-,S-}
{$I+,Q+,R+,S+}
program Temp;
uses
 SysUtils;
const
 in_f='threecolors2.in';
 out_f='threecolors2.out';
type
  int=longint;
  real=extended;
  bool=boolean;
const
  maxN=1000;
  cR=1;
  cG=2;
  cB=3;
  imp='IMPOSSIBLE';
  tl=1/24/60/60;
var
  N:int;
  x:array[1..maxN] of int;
  a,b:array[1..maxN,1..2] of int;

  perm:array[1..maxN] of int;

  begtime:real;


procedure Solve1;forward;

function GetColor(i:int):int;
var
  t:array[1..3] of int;
begin
  fillchar(t,sizeof(t),0);
  inc(t[b[i,1]]);
  inc(t[b[i,2]]);
  inc(t[b[i+1,1]]);
  inc(t[b[i+1,2]]);
  GetColor:=0;
  for i := 1 to 3 do
    if t[i]>2 then
      begin
        GetColor:=i;
        exit;
      end;
  for i := 1 to 3 do
    if t[i]=0 then
      begin
        GetColor:=i;
        exit;
      end;
  for i := 1 to 3 do
    if t[i]=2 then
      begin
        GetColor:=i;
        exit;
      end;
end;

procedure Do2(i:int);
var
  c:int;
begin
  c:=GetColor(i);
  b[i,1]:=c;
  b[i,2]:=c;
  b[i+1,1]:=c;
  b[i+1,2]:=c;
end;

procedure Swap(var a,b:int);
var c:int;
begin
 c:=a;a:=b;b:=c;
end;

procedure Solve2;
 var
   i,j,L:int;
   t:array[1..3] of int;
 begin
   RandSeed:=842932;
   for i := 1 to N-1 do
     perm[i]:=i;
  while now<begtime+tl do 
    begin
      for i := 1 to N do
        b[i]:=a[i];
      for i := N-1 downto 1 do 
        Swap(perm[i],perm[random(i)+1]);
      for i := 1 to N-1 do
        Do2(perm[i]);

  
      fillchar(t,sizeof(t),0);
      for i:= 1 to N do
        inc(t[b[i,1]]);
      for j := 1 to 3 do
        t[j]:=t[j] mod 3;
      for i := 1 to 2 do
        for j := i+1 to 3 do
          if t[i]=t[j] then
            begin
              for L := 1 to N-1 do
                WRiteln(perm[L]);
              for L := 1 to N do
                x[L]:=b[L,1];
              Solve1;
              exit;
            end;
    end;
  Writeln(imp);
 end;

procedure Do1(xx:int);
 var
   nc:int;
 begin
  Writeln(xx);
   nc:=6-x[xx]-x[xx+1];
   x[xx]:=nc;
   x[xx+1]:=nc;
 end;

procedure Solve1;
 var
   i,j,L:int;
   t:array[1..3] of int;
   col:int;
 begin
   fillchar(t,sizeof(t),0);
   for i:= 1 to N do
     inc(t[x[i]]);
   for j := 1 to 3 do
     t[j]:=t[j] mod 3;
   col:=0;
   for i := 1 to 2 do
     for j := i+1 to 3 do
       if t[i]=t[j] then
         if col=0 then
           col:=6-(i+j)
         else
           col:=x[1];

   for i:= 1 to N do
     begin
       while x[i]<> col do
         begin
           j:=i;
           while (j<=n) and (x[i]=x[j]) do
             inc(j);
           if j=N+1 then
             begin
               Do1(i-1);
               Do1(i);
               Do1(i+1);
               Do1(i);
               Do1(i-1);
             end
           else
             if x[j]=col then
               Do1(j-1)
             else
               begin
                 Do1(j-1);
                 for L := j-2 downto i do
                   Do1(L);
                 if x[i]<>col then
                   begin
                     Do1(i+1);
                     Do1(i);
                   end;
               end;
         end;
     end;
 end;

procedure  Init;
 var
   i,j:int;
   ch:char;
 begin
   Readln(N);
   for j := 1 to 2 do
     begin
       for i := 1 to N do
         begin
           Read(ch);
           case ch of
             'R':a[i,j]:=cR;
             'G':a[i,j]:=cG;
             'B':a[i,j]:=cB;
             end;
         end;
       readln;
     end;
 end;

procedure Run;
 begin
   Init;
   Solve2;
 end;

procedure OpenFiles;
 begin
  Assign(input,in_f);
  Reset(input);
  Assign(output,out_f);
  Rewrite(output);
 end;

procedure CloseFiles;
 begin
  Close(input);
  Close(output);
 end;

Begin
BegTime:=now;
OpenFiles;
Run;
CloseFiles;
End.
