{$R-,H+}
const namein='threecolors2.in';
      nameout='threecolors2.out';
      NMax=1100;
      CMax=2;
      NA=-1;
type
 TVect=array [0..NMax] of integer;
 TDp=array [1..NMax,0..NMax,0..CMax] of boolean;
 TPr=array [1..NMax,0..NMax,0..CMax] of integer;
var a,b:string;
    x,y,v,z:TVect;
    d:TDp;
    p,q:TPr;
    n,u:integer;
    Ok:boolean;

procedure Init;
var i:integer;
begin
 assign(input,namein);
 reset(input);
 readln(n);
 readln(a);
 readln(b);
 for i:=1 to n do begin
   case a[i] of
     'R':x[i]:=0;
     'B':x[i]:=1;
     'G':x[i]:=2
    end;
   case b[i] of
     'R':y[i]:=0;
     'B':y[i]:=1;
     'G':y[i]:=2
    end
  end;
 Ok:=false;
 close(input)
end;

function Color(a:integer):integer;
var i:integer;
begin
 for i:=0 to CMax do v[i]:=0;
 inc(v[x[a]]);
 inc(v[y[a]]);
 inc(v[x[a+1]]);
 inc(v[y[a+1]]);
 if (v[0]>(v[1]+v[2])) or (v[1]=v[2]) then Color:=0
 else
  if (v[1]>(v[0]+v[2])) or (v[0]=v[2]) then Color:=1
  else
   if (v[2]>(v[0]+v[1])) or (v[0]=v[1]) then Color:=2
end;

procedure Fly(i,l:integer);
begin
 if i>l then begin
   writeln(i-1);
   writeln(i-2);
   writeln(i-1);
   Fly(i-2,l)
  end
end;

procedure Print(i,j,c:integer);
begin
 if i=1 then Exit;
 case p[i,j,c] of
   1:begin
      Print(i-1,j,c);
      writeln(i-1)
     end;
   2:begin
      Print(i-1,j-1,c);
      Fly(i,j+1)
     end;
   3:begin
      Print(i-1,j,q[i,j,c]);
      Fly(i,j+2);
      writeln(j+1);
      writeln(1);
      Fly(j+2,1)
     end;
   4:begin
      Print(i-1,j+2,c);
      Fly(i,j+4);
      writeln(j+3);
      writeln(j+2);
      Fly(j+4,j+2);
      writeln(j+1)
     end;
   5:begin
      Print(i,j+1,q[i,j,c]);
      Fly(i,j+1);
      writeln(2);
      writeln(1);
      Fly(3,1)
     end;
   6:begin
      Print(i-1,j+1,c);
      Fly(i,j+2);
      writeln(j+1)
     end;
   7:begin
      Print(i-1,j-2,c);
      Fly(i,j);
      writeln(j-1)
     end;
   8:begin
      Print(i-1,j-1,q[i,j,c]);
      Fly(i,1)
     end;
   9:begin
      Print(i-1,j-2,q[i,j,c]);
      Fly(i,2);
      writeln(1)
     end
  end
end;

function Mex(const a,b:integer):integer;
var i:integer;
begin
 for i:=0 to CMax do
  if (i<>a) and (i<>b)
  then begin
    Mex:=i;
    Exit
   end
end;

procedure Done(c:integer);
var i:integer;
begin
 assign(output,nameout);
 rewrite(output);
 if not Ok then writeln('IMPOSSIBLE')
 else begin
   for i:=1 to u do writeln(z[u]);
   Print(n,0,c);
  end;
 close(output);
 halt(0)
end;

procedure Solve;
var k,i,j,c,v:integer;
    f:boolean;
begin
 for k:=0 to 2 do begin
   i:=1;
   u:=0;
   while (i<n) and (x[i]<>y[i]) and (not (Color(i)=k))
   do inc(i);
   if (i<n) and (Color(i)=k) then begin
     j:=i;
     while j>0 do begin
       inc(u);
       z[u]:=j;
       dec(j)
      end;
     fillchar(d,sizeof(d),false);
     inc(i);
     for c:=0 to CMax do begin
       d[i,0,c]:=true;
       p[i,0,c]:=NA
      end;
     while i<n do begin
       for j:=0 to n do
        for c:=0 to CMax do
         if d[i,j,c] then
          if (x[i+1]<>y[i+1]) or (x[i+1]=k)
          then begin
            d[i+1,j,c]:=true;
            p[i+1,j,c]:=1
           end
          else begin
            if x[i+1]=c then begin
              if ((i+1) mod 2)=((j+1) mod 2)
              then begin
                d[i+1,j+1,c]:=true;
                p[i+1,j+1,c]:=2;
                if (j+1)=2 then begin
                  d[i+1,j,Mex(x[i+1],k)]:=true;
                  p[i+1,j,Mex(x[i+1],k)]:=5;
                  q[i+1,j,Mex(x[i+1],k)]:=c
                 end
               end
              else
               if (i-j)>2 then
                if j=1 then begin
                  d[i+1,j,Mex(x[i+1],k)]:=true;
                  p[i+1,j,Mex(x[i+1],k)]:=3;
                  q[i+1,j,Mex(x[i+1],k)]:=c
                 end
                else
                 if j>1 then begin
                   d[i+1,j-2,c]:=true;
                   p[i+1,j-2,c]:=4;
                  end
             end
            else begin
              if (((i+1) mod 2)=((j+1) mod 2)) and (j>0)
              then begin
                d[i+1,j-1,c]:=true;
                p[i+1,j-1,c]:=6
               end;
              if (((i+1) mod 2)<>((j+1) mod 2)) and ((i-j)>2)
              then begin
                d[i+1,j+2,c]:=true;
                p[i+1,j+2,c]:=7
               end;
              if j=0 then
               if (i+1) mod 2=1 then begin
                 d[i+1,1,x[i+1]]:=true;
                 p[i+1,1,x[i+1]]:=8;
                 q[i+1,1,x[i+1]]:=c
                end
               else begin
                 d[i+1,2,Mex(x[i+1],k)]:=true;
                 p[i+1,2,Mex(x[i+1],k)]:=9;
                 q[i+1,2,Mex(x[i+1],k)]:=c
                end
             end
           end;
       inc(i)
      end;
     for i:=0 to CMax do
      if d[n,0,i] then begin
        Ok:=true;
        Done(i)
       end
   end
  end
end;

begin
 Init;
 Solve;
 Done(1)
end.
