const taskname='football';eps=1e-10;
type pqwe=^tqwe;tqwe=record x,y:extended;nxt,prev:pqwe;end;
var
  t:text;
  xx,yy:array[1..30000] of longint;
  cur:pqwe;
  j,x,y,n,i,tmp:longint;
  l:array[1..30000] of pqwe;
procedure qs(l,r:longint);
var m,i,j:longint;
begin
  m:=yy[(l+r)div 2];
  i:=l;
  j:=r;
  while i<j do
  begin
    while yy[i]<m do inc(i);
    while yy[j]>m do dec(j);
    if (i<=j) then
    begin
      tmp:=yy[i];
      yy[i]:=yy[j];
      yy[j]:=tmp;
      tmp:=xx[i];
      xx[i]:=xx[j];
      xx[j]:=tmp;
      inc(i);
      dec(j);
    end;
  end;
  if (i<r) then qs(i,r);
  if (l<j) then qs(l,j);
end;
function qwe(x1,y1,x2,y2,x3,y3,x4,y4:extended;var xx,yy:extended):boolean;
var ua,zn:extended;
begin
  ua:=(x4-x3)*(y1-y3)-(y4-y3)*(x1-x3);
  zn:=(y4-y3)*(x2-x1)-(x4-x3)*(y2-y1);
  if zn>0 then
  begin
    ua:=ua/zn;
    if (ua>-eps)and(ua<(1+eps)) then
    begin
    xx:=x1+ua*(x2-x1);
    yy:=y1+ua*(y2-y1);
    qwe:=true;
    end else qwe:=false;
  end else qwe:=false;
end;
procedure update(i:longint;x1,y1,x2,y2:extended);
var j:longint;cur:pqwe;xxxx,yyyy,xxx,yyy:extended;st,curr,currr:pqwe;
begin
  cur:=l[i];
  st:=cur;
  repeat
    if cur^.y<st^.y then st:=cur;
    cur:=cur^.nxt;
  until cur=l[i];
  cur:=st^.nxt;
  xxx:=0;
  yyy:=0;
  while (cur<>l[i])and(not qwe(cur^.prev^.x,cur^.prev^.y,cur^.x,cur^.y,x1,y2,x2,y2,xxx,yyy)) do cur:=cur^.nxt;
  curr:=cur;
  xxxx:=xxx;
  yyyy:=yyy;
  cur:=cur^.nxt;
  while (cur<>l[i]^.nxt)and(not qwe(cur^.prev^.x,cur^.prev^.y,cur^.x,cur^.y,x1,y2,x2,y2,xxx,yyy)) do cur:=cur^.nxt;
  currr:=cur;
  while cur^.prev<>curr do
  begin
    cur:=cur^.prev;
    dispose(cur);
  end;
  curr^.x:=xxxx;
  curr^.y:=yyyy;
  getmem(cur,sizeof(tqwe));
  curr^.nxt:=cur;
  cur^.x:=xxx;
  cur^.y:=yyy;
  cur^.prev:=curr;
  currr^.prev:=cur;
end;
function updat(i:longint):pqwe;
var j:longint;cur:pqwe;xxxx,yyyy,xxx,yyy:extended;st,curr,currr:pqwe;
begin
  cur:=l[i];
  st:=cur;
  repeat
    if cur^.y<st^.y then st:=cur;
    cur:=cur^.nxt;
  until cur=l[i];
  updat:=st;
end;
begin
  assign(t,taskname+'.in');
  reset(t);
  readln(t,x,y,n);
  for i:=1 to n do
  begin
    readln(t,xx[i],yy[i]);
  end;
  close(t);
  qs(1,n);
  for i:=1 to n do
  begin
    getmem(l[i],sizeof(tqwe));
    l[i]^.x:=0;
    l[i]^.y:=0;
    getmem(l[i]^.nxt,sizeof(tqwe));
    cur:=l[i]^.nxt;
    cur^.x:=0;
    cur^.y:=y;
    cur^.prev:=l[i];
    getmem(cur^.nxt,sizeof(tqwe));
    cur^.nxt^.prev:=cur;
    cur:=cur^.nxt;
    cur^.x:=x;
    cur^.y:=y;
    getmem(cur^.nxt,sizeof(tqwe));
    cur^.nxt^.prev:=cur;
    cur:=cur^.nxt;
    cur^.x:=x;
    cur^.y:=0;
    cur^.nxt:=l[i];
  end;
  for i:=1 to n do
  begin
    for j:=1 to i-1 do
    begin
      update(i,(xx[i]+xx[j])/2-(yy[i]+yy[j])/2,-(xx[i]+xx[j])/2+(yy[i]+yy[j])/2,(xx[i]+xx[j])/2+(yy[i]+yy[j])/2,-(xx[i]+xx[j])/2-(yy[i]+yy[j])/2);
    end;
  end;
  assign(t,taskname+'.out');
  rewrite(t);
  for i:=1 to n do
  begin
    cur:=updat(i);
    l[i]:=cur;
    while cur<>l[i]^.prev do
    begin
      write(t,cur^.x,'  ',cur^.y,'  ');
      cur:=cur^.nxt;
    end;
  end;
  close(t);
end.