#include <stdio.h>
#include <string.h>

#define m 1010
#define mm (81 * 81 * 81 * 81)

char a[2][m], u[mm];
int n, al, ans[m];
int stklen = 10 << 20;
int sev[] = {1, 2, 1, 2, 1, 3, 4, 3, 2, 1, 2, 1, 2, 4, 1, 2, 1, 2, 1, 5, 2, 1, 2, 1, 2, 4, 1, 2, 1, 2, 1, 3, 2, 1, 2, 1, 2, 4, 1, 2, 1, 2, 1, 6, 2, 1, 2, 1, 2, 3, 1, 2, 1, 2, 1, 2, 4, 1, 2, 1, 2, 1, 3, 2, 1, 2, 1, 2, 5, 1, 2, 1, 2, 1, 3, 6, 5, 4, 3, 2, 1, 2, 1, 2, 4, 1, 2, 1, 2, 1, 5, 2, 1, 2, 3, 4, 5, 1, 3, 2, 1, 2, 1, 2, 6, 1, 2, 1, 2, 1, 3, 4, 3, 2, 1, 2, 1, 2, 4, 1, 2, 1, 3, 4, 3, 2, 1, 2, 1, 2, 4, 1, 2, 1, 2, 1, 5, 2, 1, 2, 1, 2, 4, 1, 2, 1, 2, 1, 3, 2, 1, 2, 1, 2, 4, 1, 2, 1, 2, 3, 4, 3, 1, 4, 3, 2, 1, 2, 1, 2, 6, 1, 2, 1, 2, 1, 3, };
int four[] = {0, 2, 1, 0, 1, 0, 2};

int ok( void )
{
  int i;

  for (i = 0; i < n; i++)
    if (a[0][i] != a[1][i])
      return 0;
  for (i = 1; i < n; i++)
    if (a[0][i - 1] != a[0][i])
      return 0;
  return 1;
}

int get( void )
{
  int i, t;

  for (i = 0, t = 0; i < n; i++)
    t = t * 3 + a[0][1], t = t * 3 + a[1][i];
  return t;
}

int dfs( void )
{
  int i, nu[3];
  char c, t00, t01, t10, t11;

  if (ok())
  {
    for (i = 0; i < al; i++)
      printf("%d\n", ans[i]);
    return 1;
  }
  i = get();
  if (u[i])
    return 0;
  u[i] = 1;
  for (i = 1; i < n; i++)
  {
    nu[0] = nu[1] = nu[2] = 0;
    nu[a[0][i - 1]]++;
    nu[a[1][i - 1]]++;
    nu[a[0][i]]++;
    nu[a[1][i]]++;
    if (nu[0] > nu[1] && nu[0] > nu[2])
      c = 0;
    else if (nu[1] > nu[0] && nu[1] > nu[2])
      c = 1;
    else if (nu[2] > nu[0] && nu[2] > nu[1])
      c = 2;
    else if (nu[0] == nu[1])
      c = 2;
    else if (nu[0] == nu[2])
      c = 1;
    else
      c = 0;
    t00 = a[0][i - 1], t01 = a[1][i - 1];
    t10 = a[0][i], t11 = a[1][i];
    a[0][i - 1] = a[1][i - 1] = a[0][i] = a[1][i] = c;
    ans[al++] = i;
    if (dfs())
      return 1;
    al--;
    a[0][i - 1] = t00, a[1][i - 1] = t01;
    a[0][i] = t10, a[1][i] = t11;
  }
  return 0;
}

void color( int i )
{
  int nu[3], c;

  nu[0] = nu[1] = nu[2] = 0;
  nu[a[0][i - 1]]++;
  nu[a[1][i - 1]]++;
  nu[a[0][i]]++;
  nu[a[1][i]]++;
  if (nu[0] > nu[1] && nu[0] > nu[2])
    c = 0;
  else if (nu[1] > nu[0] && nu[1] > nu[2])
    c = 1;
  else if (nu[2] > nu[0] && nu[2] > nu[1])
    c = 2;
  else if (nu[0] == nu[1])
    c = 2;
  else if (nu[0] == nu[2])
    c = 1;
  else
    c = 0;
  a[0][i - 1] = a[1][i - 1] = a[0][i] = a[1][i] = c;
  printf("%d\n", i);
}

void color4( int j )
{
  int i;

  for (i = 0; i < sizeof(four) / sizeof(four[0]); i++)
    printf("%d\n", j + four[i]);
}

void color7( int j )
{
  int i;

  for (i = 0; i < sizeof(sev) / sizeof(sev[0]); i++)
    printf("%d\n", j + sev[i]);
}

int main( void )
{
  int i;

  freopen("threecolors2.in", "rt", stdin);
  freopen("threecolors2.out", "wt", stdout);
  scanf("%d", &n);
  scanf("%s%s", a[0], a[1]);
  for (i = 0; i < n; i++)
  {
    a[0][i] = (a[0][i] == 'R') ? 0 : ((a[0][i] == 'B') + 1);
    a[1][i] = (a[1][i] == 'R') ? 0 : ((a[1][i] == 'B') + 1);
  }
  if (n >= 7)
  {
    for (i = 1; i < n; i++)
      color(i);
    color4(n - 3);
    for (i = n - 4; i >= 1; i--)
    {
      color4(i);
      color(i + 3);
      color(i + 2);
      color(i + 3);
      color(i + 2);
      color(i + 1);
      color(i + 3);
    }
    for (i = 0; i < (n - 1) % 6; i += 2)
      color(i + 1), color(i + 2), color(i + 1);
    for (; i + 7 <= n; i += 6)
      color7(i);
    if (!ok())
    {
      freopen("threecolors2.out", "wt", stdout);
      printf("IMPOSSIBLE");
      return 0;
    }
  }
  else
  {
    memset(u, 0, sizeof(u));
    al = 0;
    if (!dfs())
      printf("IMPOSSIBLE");
  }
  return 0;
}
