#include <stdio.h>
#include <string.h>

#define MIN(A, B) (((A) <= (B)) ? (A) : (B))
#define MAX(A, B) (((A) >= (B)) ? (A) : (B))
#define SWAP(A, B, C) ((C) = (A), (A) = (B), (B) = (C))
#define ABS(X) (((X) >= 0) ? (X) : -(X))
#define SQR(X) ((X) * (X))

#define eps 1e-9
#define inf (int)2e9

#define MAXL 310

char S1[MAXL], S2[MAXL], S3[MAXL], S4[MAXL];
int N1, N2, N3, N4, Ans = 0;

int main( void )
{
  int i1, j1, i2, j2, i3, j3, i4, j4, k;
  int s1, l1, s2, l2, s3, l3, s4, l4, f;
  char *k1, *k2;

  freopen("nostrings.in", "rt", stdin);
  freopen("nostrings.out", "wt", stdout);

  scanf("%s%s%s%s", S1, S2, S3, S4);

  s1 = s2 = s3 = s4 = l1 = l2 = l3 = l4 = 0;
  N1 = strlen(S1), N2 = strlen(S2), N3 = strlen(S3), N4 = strlen(S4);
  for (i1 = 0; i1 < N1; i1++)
    for (j1 = 0; j1 <= N1 - i1; j1++)
      for (i2 = 0; i2 < N2; i2++)
        for (j2 = 0; j2 <= N2 - i2; j2++)
          for (i3 = 0; i3 < N3; i3++)
            for (j3 = 0; j3 <= N3 - i3; j3++)
              for (i4 = 0; i4 < N4; i4++)
                for (j4 = 0; j4 <= N4 - i4; j4++)
                {
                  if (j4 + j3 != j2 + j1)
                    continue;
                  if (j4 + j3 <= Ans)
                    continue;
                  for (f = 1, k = 0, k1 = &S1[i1], k2 = &S3[i3]; k < j1 + j2 && f; k++)
                  {
                    if ((*k1) != (*k2))
                    {
                      f = 0;
                      break;
                    }
                    k1++, k2++;
                    if (k + 1 == j1)
                      k1 = &S2[i2];
                    if (k + 1 == j3)
                      k2 = &S4[i4];
                  }
                  if (f)
                  {
                    Ans = j1 + j2;
                    s1 = i1, s2 = i2, s3 = i3, s4 = i4;
                    l1 = j1, l2 = j2, l3 = j3, l4 = j4;
                  }
                }
  for (i1 = 0; i1 < l1; i1++)
    putc(S1[i1 + s1], stdout);
  putc('\n', stdout);
  for (i2 = 0; i2 < l2; i2++)
    putc(S2[i2 + s2], stdout);
  putc('\n', stdout);
  for (i3 = 0; i3 < l3; i3++)
    putc(S3[i3 + s3], stdout);
  putc('\n', stdout);
  for (i4 = 0; i4 < l4; i4++)
    putc(S4[i4 + s4], stdout);
  putc('\n', stdout);

  return 0;
}
