#include <stdio.h>
#include <string.h>

#define inf (int)1e9
#define m 310

#define max(a, b) ((a) > (b) ? (a) : (b))
#define min(a, b) ((a) < (b) ? (a) : (b))

char a[m];
int n, r0[m][m], r1[m][m], p0[m][m], p1[m][m], mi[m][m], ma[m][m];

void o( int l, int r, int f, int re )
{
  if (l == r)
    putc(a[l], stdout);
  else if (f)
  {
    if (p1[l][r] == -2)
      putc('[', stdout), o(l, r, 0, re ^ 1), putc(']', stdout);
    else if (re)
      o(p1[l][r] + 1, r, 1, 1), o(l, p1[l][r], 1, 1);
    else
      o(l, p1[l][r], 1, 0), o(p1[l][r] + 1, r, 1, 0);
  }
  else
    if (p0[l][r] == -2)
      putc('[', stdout), o(l, r, 1, re ^ 1), putc(']', stdout);
    else if (re)
      o(p0[l][r] + 1, r, 0, 1), o(l, p0[l][r], 0, 1);
    else
      o(l, p0[l][r], 0, 0), o(p0[l][r] + 1, r, 0, 0);
}

int main( void )
{
  int i, j, k, ij;

  freopen("cipher.in", "rt", stdin);
  freopen("cipher.out", "wt", stdout);
  scanf("%s", a);
  n = strlen(a);
  for (i = 0; i < n; i++)
    for (j = i + 1, ma[i][i] = mi[i][i] = a[i]; j < n; j++)
      ma[i][j] = max(ma[i][j - 1], a[j]), mi[i][j] = min(mi[i][j - 1], a[j]);
  for (ij = 1; ij <= n; ij++)
    for (i = 0; i + ij <= n; i++)
    {
      j = i + ij - 1;
      r0[i][j] = r1[i][j] = inf, p0[i][j] = p1[i][j] = -1;
      if (ij == 1)
        r0[i][j] = r1[i][j] = 1;
      else
      {
        for (k = i; k < j; k++)
          if (ma[i][k] <= mi[k + 1][j] && r0[i][j] > r0[i][k] + r0[k + 1][j])
            r0[i][j] = r0[i][k] + r0[k + 1][j], p0[i][j] = k;
        for (k = i; k < j; k++)
          if (mi[i][k] >= ma[k + 1][j] && r1[i][j] > r1[i][k] + r1[k + 1][j])
            r1[i][j] = r1[i][k] + r1[k + 1][j], p1[i][j] = k;
        if (r0[i][j] >= r1[i][j] + 2)
          r0[i][j] = r1[i][j] + 2, p0[i][j] = -2;
        if (r1[i][j] >= r0[i][j] + 2)
          r1[i][j] = r0[i][j] + 2, p1[i][j] = -2;
      }
    }
  if (r0[0][n - 1] >= inf)
    printf("NO SOLUTION");
  else
    o(0, n - 1, 0, 0);
  return 0;
}
