{$h+,b-}
program bpas;

var num : array [0..300, 'a'..'z'] of integer;
    d   : array [1..300, 1..300] of integer;
    str : array [1..300, 1..300] of string;
    mal, mil : array [1..300, 1..300] of char;
    n, i, j  : integer;
    s : string;
    c : char;

function get(l, r : integer) : integer;
var c : char;
    i, t, j : integer;
begin
   if d[l][r] < 0 then begin
      d[l][r] := 1000;
      if l <= r then begin
         i := l; c := 'a'; t := 0;
         while num[r][c]-num[l-1][c] = 0 do inc(c);
         while (i <= r) and (c = s[i]) do begin
            inc(i); inc(t);
            if (i <= r) and (t = num[r][c]-num[l-1][c]) then begin
               t := 0; inc(c);
               while num[r][c]-num[l-1][c] = 0 do inc(c);
            end;
         end;
         if i > r then begin
            d[l][r] := 0;
            str[l][r] := copy(s, l, r-l+1);
         end else begin
            for j := i to r-1 do
               if mal[i][j] <= mil[j+1][r] then
                  if get(i, j)+get(j+1, r) < d[l][r] then begin
                     d[l][r] := get(i, j)+get(j+1, r);
                     str[l][r] := str[i][j]+str[j+1][r];
                  end else
                     if get(i, j)+get(j+1, r) = d[l][r] then
                        if str[i][j]+str[j+1][r] < str[l][r] then
                           str[l][r] := str[i][j]+str[j+1][r];
            if get(r, i)+1 < d[l][r] then begin
               d[l][r] := get(r, i)+1;
               str[l][r] := '['+str[r][i]+']';
            end else
               if get(r, i)+1 = d[l][r] then
                  if str[l][r] < '['+str[r][i]+']' then
                     str[l][r] := '['+str[r][i]+']';
            str[l][r] := copy(s, l, i-l)+str[l][r];
         end;
      end else begin
         i := l; c := 'a'; t := 0;
         while num[l][c]-num[r-1][c] = 0 do inc(c);
         while (i >= r) and (c = s[i]) do begin
            dec(i); inc(t);
            if (i >= r) and (t = num[l][c]-num[r-1][c]) then begin
               t := 0; inc(c);
               while num[l][c]-num[r-1][c] = 0 do inc(c);
            end;
         end;
         if i < r then begin
            d[l][r] := 0;
            str[l][r] := '';
            for j := l downto r do str[l][r] := str[l][r]+s[j];
         end else begin
            for j := i downto r+1 do
               if mal[j][i] <= mil[r][j-1] then
                  if get(i, j)+get(j-1, r) < d[l][r] then begin
                     d[l][r] := get(i, j)+get(j-1, r);
                     str[l][r] := str[i][j]+str[j-1][r];
                  end else
                     if get(i, j)+get(j-1, r) = d[l][r] then
                        if str[i][j]+str[j-1][r] < str[l][r] then
                           str[l][r] := str[i][j]+str[j-1][r];   
            if get(r, i)+1 < d[l][r] then begin
               d[l][r] := get(r, i)+1;
               str[l][r] := '['+str[r][i]+']';
            end else
               if get(r, i)+1 = d[l][r] then
                  if str[l][r] < '['+str[r][i]+']' then
                     str[l][r] := '['+str[r][i]+']';
            for j := i+1 to l do str[l][r] := s[j]+str[l][r];
         end;
      end;
   end;
   get := d[l][r];
end;

begin
   assign(Input, 'cipher.in');
   reset(Input);
   assign(Output, 'cipher.out');
   rewrite(Output);

   readln(s);
   n := length(s);
   fillchar(num[0], sizeof(num[0]), 0);
   for i := 1 to n do
      for j := 1 to n do begin
         d[i][j] := -1;
         str[i][j] := '';
      end;
   for i := 1 to n do   
      for c := 'a' to 'z' do
         num[i][c] := num[i-1][c] + ord(s[i] = c);
   for i := 1 to n do begin
      mal[i][i] := s[i];
      mil[i][i] := s[i];
   end;
   for i := 1 to n-1 do
      for j := i+1 to n do begin
         if s[j] > mal[i][j-1] then
            mal[i][j] := s[j]
         else
            mal[i][j] := mal[i][j-1];
         if s[j] < mil[i][j-1] then
            mil[i][j] := s[j]
         else
            mil[i][j] := mil[i][j-1];
      end;   

   if get(1, n) > 300 then
      writeln('NO SOLUTION')
   else
      writeln(str[1][n]);

   close(Input);
   close(Output);
end.