{$R-,H+}
uses math;
const namein='nostrings.in';
      nameout='nostrings.out';
      NMax=310;
type
 integer=longint;
 TVect=array [0..NMax] of integer;
 TDp=array [0..NMax] of TVect;
var w,d,f,h:TVect;
    y:TDp;
    v,s1,s2,s3,s4,r1,r2,r3,r4:string;
    Sol:integer;

procedure Init;
begin
 assign(input,namein);
 reset(input);
 readln(s1);
 readln(s2);
 readln(s3);
 readln(s4);
 close(input)
end;

procedure KMP(const a,b:string; var d:TVect);
var p:TVect;
    i,k:integer;
begin
 p[1]:=0;
 k:=0;
 for i:=2 to length(b) do begin
   while (k>0) and (b[i]<>b[k+1]) do k:=p[k];
   if b[i]=b[k+1] then inc(k);
   p[i]:=k
  end;
 k:=0;
 fillchar(d,sizeof(d),0);
 for i:=1 to length(a) do begin
   while (k>0) and (a[i]<>b[k+1]) do k:=p[k];
   if a[i]=b[k+1] then inc(k);
   if k>d[i-k+1] then d[i-k+1]:=k;
   if k=length(b) then k:=p[k]
  end;
 while k>0 do begin
   if k>d[length(a)-k+1] then d[length(a)-k+1]:=k;
   k:=p[k]
  end
end;

procedure Solve;
var i,j,l,r,t:integer;
begin
 Sol:=0;
 r1:=''; r2:='';
 r3:=''; r4:='';
 v:=s2;
 fillchar(y,sizeof(y),0);
 fillchar(w,sizeof(w),0);
 for i:=1 to length(s2) do begin
   KMP(s4,v,d);
   KMP(s3,v,y[i]);
   w[i]:=0; h[i]:=1;
   for j:=1 to length(s4) do
    if w[i]<d[j] then begin
      w[i]:=d[j];
      h[i]:=j
     end;
   delete(v,1,1)
  end;
 v:=s1;
 for l:=1 to length(s1) do begin
   KMP(s3,v,d);
   fillchar(f,sizeof(f),0);
   for i:=1 to length(s3) do
    f[i+d[i]-1]:=max(f[i+d[i]-1],d[i]);
   delete(v,1,1);
   for i:=1 to length(s3) do
    for j:=1 to length(s2) do begin
      t:=f[i];
      r:=j+y[j,i+1];
      inc(t,y[j,i+1]);
      inc(t,w[r]);
      if t>Sol then begin
        Sol:=t;
        r1:=Copy(s1,l,f[i]);
        r2:=Copy(s2,j,r+w[r]-j);
        r3:=Copy(s3,i-f[i]+1,f[i]+y[j,i+1]);
        r4:=Copy(s4,h[r],w[r])
       end
     end
  end
end;

procedure Done;
begin
 assign(output,nameout);
 rewrite(output);
 writeln(r1);
 writeln(r2);
 writeln(r3);
 writeln(r4);
 close(output)
end;

begin
 Init;
 Solve;
 Done
end.
