#include <stdio.h>

int DP[301][301][2][2],
  Min[301][301], Max[301][301], SN;
char S[301], Out[3001];

void Go(int i, int d, int f, char *Res)
{
  char T[3000];
  int j;


  fprintf(stderr, "In go(%i, %i, %i)\n", i, d, f);
  if (DP[i][d][f][0] == d && DP[i][d][f][1] == d)
  {
    for (j = 0; j < d; j++)
      Res[j] = S[i + j];
    return;
  }
  if (DP[i][d][f][1] == -1)
  {
    Res[0] = '[';
    Res[DP[i][d][f][0] - 1] = ']';
    Go(i, d, 1 - f, T);
    for (j = DP[i][d][1 - f][0]; j >= 1; j--)
    {
      if (T[DP[i][d][1 - f][0] - j] == ']')
        Res[j] = '[';
      else
      if (T[DP[i][d][1 - f][0] - j] == '[')
        Res[j] = ']';
      else
        Res[j] = T[DP[i][d][1 - f][0] - j];
    }
    return;
  }
  Go(i, DP[i][d][f][1], f, Res);
  Go(i + DP[i][d][f][1], d - DP[i][d][f][1], f, Res + DP[i][DP[i][d][f][1]][f][0]);
}

int main( void )
{
  int i, j, k, min, max, d, d1;
  char c;

  freopen("cipher.in", "rt", stdin);
  freopen("cipher.out", "wt", stdout);

  while ((c = getc(stdin)) >= 'a'&& c <= 'z')
    S[SN++] = c;
  for (i = 0; i < SN; i++)
  {
    min = 255;
    max = 0;
    for (d = 1; d <= SN; d++)
    {
      if (S[i + d - 1] < min)
        min = S[i + d - 1];
      if (S[i + d - 1] > max)
        max = S[i + d  - 1];
      Min[i][d] = min;
      Max[i][d] = max;
    }
    DP[i][1][0][0] = 1;
    DP[i][1][1][0] = 1;
    DP[i][1][0][1] = 1;
    DP[i][1][1][1] = 1;
     
  }
  for (d = 2; d <= SN; d++)
    for (i = 0; i + d <= SN; i++)
    {
      for (d1 = d - 1; d1 > 0; d1--)
      {
        /* UP */
        if (Max[i][d1] <= Min[i + d1][d - d1] && DP[i][d1][0][0] && DP[i + d1][d - d1][0][0] &&
           (DP[i][d][0][0] == 0 || DP[i][d][0][0] > DP[i][d1][0][0] + DP[i + d1][d - d1][0][0]))
           DP[i][d][0][0] = DP[i][d1][0][0] + DP[i + d1][d - d1][0][0],
           DP[i][d][0][1] = d1;
 
        /* DOWN */
        if (Min[i][d1] >= Max[i + d1][d - d1] && DP[i][d1][1][0] && DP[i + d1][d - d1][1][0] &&
           (DP[i][d][1][0] == 0 || DP[i][d][1][0] > DP[i][d1][1][0] + DP[i + d1][d - d1][1][0]))
           DP[i][d][1][0] = DP[i][d1][1][0] + DP[i + d1][d - d1][1][0],
           DP[i][d][1][1] = d1;

      }
      if (DP[i][d][0][0] && (DP[i][d][1][0] == 0 || DP[i][d][1][0] > DP[i][d][0][0] + 2))
        DP[i][d][1][0] = DP[i][d][0][0] + 2, 
        DP[i][d][1][1] = -1;

      if (DP[i][d][1][0] && (DP[i][d][0][0] == 0 || DP[i][d][0][0] > DP[i][d][1][0] + 2))
        DP[i][d][0][0] = DP[i][d][1][0] + 2, 
        DP[i][d][0][1] = -1;
      /*
      if (DP[i][d][1][0])
      {
        printf("%i %i 1\n", i, d);
        Go(i, d, 1, Out);
        for (j = 0; j < DP[i][d][1][0]; j++)
          putc(Out[j], stdout);
        printf("\n");
      }
      if (DP[i][d][0][0])
      {
        printf("%i %i 0\n", i, d);
        Go(i, d, 0, Out);
        for (j = 0; j < DP[i][d][0][0]; j++)
          putc(Out[j], stdout);
        printf("\n");
      }             */
    }
  
  if (!DP[0][SN][0][0])
    printf("NO SOLUTION");
  else
  {
    Go(0, SN, 0, Out);
    for (i = 0; i < DP[0][SN][0][0]; i++)
      putc(Out[i], stdout);
  }
  return 0;
}
