{$H-}
type integer = longint;
var s1, s2, s3, s4 : string;

procedure Load;
begin
	readln(s1);
	readln(s2);
	readln(s3);
	readln(s4);
end;

var s24l, s24p : array[1..301] of integer;
	cs : string;
	pf : array[1..301] of integer;
	suf : array[1..301] of string;
	ppf : array[1..301, 1..301] of integer;

var max, ms11, ms12, ms21, ms22, ms31, ms32, ms41, ms42 : integer;
	pff : array[1..301] of integer;

procedure GenAns(s11, s12, s31, s32 : integer);
var cs : string;
	i, k, l1, l2, l3, l4 : integer;
begin
	l1 := s12 - s11 + 1;
	l3 := s32 - s31 + 1;
	cs := suf[s32 + 1];
	move(ppf[s32 + 1], pff, sizeof(pff));
	k := 0;
	for i := 0 to length(s2) do begin
    	if i <> 0 then begin
			while (k > 0) and (s2[i] <> cs[k + 1]) do k := pff[k];
			if (s2[i] = cs[k + 1]) then inc(k);
    	end;
		l2 := k + s24l[i + 1];
        l3 := s32 - s31 + k + 1;
		l4 := s24l[i + 1];
		if l1 + l2 + l3 + l4 > max then begin
			max := l1 + l2 + l3 + l4;
			ms11 := s11;
			ms12 := s12;
			ms21 := i - k + 1;
			ms22 := i + s24l[i + 1];
			ms31 := s31;
			ms32 := s32 + k;
			ms41 := s24p[i + 1];
			ms42 := s24p[i + 1] + s24l[i + 1] - 1;
		end;
	end;
end;

procedure Solve;
var i, j, k : integer;
begin
	{count all suffixes of s3 and prefix-function for them}
	fillchar(ppf, sizeof(ppf), 0);
	cs := s3;
	for i := 1 to length(s3) do begin
		suf[i] := cs + '$';
		k := 0;
		ppf[i, 1] := 0;	
		for j := 2 to length(cs) do begin
			while (k > 0) and(cs[j] <> cs[k + 1]) do k := ppf[i, k];
			if (cs[j] = cs[k + 1]) then inc(k);
			ppf[i, j] := k;
		end;
		Delete(cs, 1, 1);
	end;
	suf[length(s3) + 1] := '$';
	{}
	max := 0;
	{first case}
	{count for s2 occur in s4}
	fillchar(s24l, sizeof(s24l), 0);
	fillchar(s24p, sizeof(s24p), 0);
	cs := s2;
	for i := 1 to length(s2) do begin
		pf[1] := 0;
		k := 0;
		for j := 2 to length(cs) do begin
			while (k > 0) and (cs[j] <> cs[k + 1]) do k := pf[k];
			if (cs[j] = cs[k + 1]) then inc(k);
			pf[j] := k;
		end;
		s24l[i] := 0;
		s24p[i] := 0;
		k := 0;
		for j := 1 to length(s4) do begin
        	if k = length(cs) then k := pf[k];
			while (k > 0) and (s4[j] <> cs[k + 1]) do k := pf[k];
			if (s4[j] = cs[k + 1]) then inc(k);
			if s24l[i] < k then begin
				s24l[i] := k;
				s24p[i] := j - k + 1;
			end;
		end;
		{}
		Delete(cs, 1, 1);
	end;
	{OK}
	cs := s1 + '$';
	for i := 1 to length(s1) do begin
		pf[1]:= 0;
		k := 0;
		for j := 2 to length(cs) do begin
			while (k > 0) and (cs[j] <> cs[k + 1]) do k := pf[k];
			if (cs[j] = cs[k + 1]) then inc(k);
			pf[j] := k;
		end;
		k := 0;
		for j := 1 to length(s3) do begin
			while (k > 0) and (cs[k + 1] <> s3[j]) do k := pf[k];
			if (cs[k + 1] = s3[j]) then inc(k);
			if k = 0 then GenAns(i, i + k - 1, j, j - 1)
			else GenAns(i, i + k - 1, j - k + 1, j);
		end;
		Delete(cs, 1, 1);
	end;
end;

var ts : string;
    wm, ws11, ws12, ws21, ws22, ws31, ws32, ws41, ws42 : integer;

procedure RestoreAns;
var i : integer;
begin
	if ws11 = 0 then ws12 := -1;
	if ws21 = 0 then ws22 := -1;
	if ws31 = 0 then ws32 := -1;
	if ws41 = 0 then ws42 := -1;
	for i := ws11 to ws12 do write(s1[i]);
	writeln;
	for i := ws21 to ws22 do write(s2[i]);
	writeln;
	for i := ws31 to ws32 do write(s3[i]);
	writeln;
	for i := ws41 to ws42 do write(s4[i]);
end;

begin
	assign(input, 'nostrings.in');
	reset(input);
	assign(output, 'nostrings.out');
	rewrite(output);
	Load;
    Solve;
    wm := max;
    ws11 := ms11;
    ws12 := ms12;
    ws21 := ms21;
    ws22 := ms22;
    ws31 := ms31;
    ws32 := ms32;
    ws41 := ms41;
    ws42 := ms42;
	ts := s1;
	s1 := s3;
	s3 := ts;
	ts := s2;
	s2 := s4;
	s4 := ts;
	Solve;
	ts := s1;
	s1 := s3;
	s3 := ts;
	ts := s2;
	s2 := s4;
	s4 := ts;
	if max > wm then begin
		ws11 := ms31;
	    ws12 := ms32;
    	ws21 := ms41;
	    ws22 := ms42;
    	ws31 := ms11;
	    ws32 := ms12;
    	ws41 := ms21;
	    ws42 := ms22;
	end;
	RestoreAns;
	close(input);
	close(output);
end.
