#include <cstdio>
#include <cstring>
#include <iostream>

#define MIN(a, b) ((a)<(b)?(a):(b))
#define MAX(a, b) ((a)>(b)?(a):(b))

using namespace std;

int i, j, n, anss;

char Min[300][300], Max[300][300];
char s[300][300][2];
char a[301], ans[1001];
int best[300][300][2], bestt[300][300][2];
int d[300][300][2];

string inv(string a){
  int minsum=1, i, cur=0;
  for (i=0; a[i]&&a[i+1]; i++){
    cur+=a[i]=='['?1:a[i]==']'?-1:0;
    if (cur<minsum) minsum=cur;
  }
  if (minsum>0)
    return a.substr(1, a.size()-2);
  else
    return '['+a+']';
}

int rec(int i, int j, char inv){
  int k;
  if (i==j){
    d[i][i][inv]=1;
    return d[i][i][inv];
  }
  if (s[i][j][inv]) return d[i][j][inv];
  s[i][j][inv]=1;
  d[i][j][inv]=1000000;
  for (k=i; k<j; k++){
    if (Max[i][k]<=Min[k+1][j]&&rec(i, k, 0)!=0&&rec(k+1, j, 0)!=0&&
      d[i][k][0]+d[k+1][j][0]+2*inv<d[i][j][inv])
      d[i][j][inv]=d[i][k][0]+d[k+1][j][0]+2*inv;
    if (Min[i][k]>=Max[k+1][j]&&rec(i, k, 1)!=0&&rec(k+1, j, 1)!=0&&
      d[i][k][1]+d[k+1][j][1]+2-2*inv<d[i][j][inv])
      d[i][j][inv]=d[i][k][1]+d[k+1][j][1]+2-2*inv;
  }
  if (d[i][j][inv]==1000000) d[i][j][inv]=0;
  return d[i][j][inv];
}

void buildans(int i, int j, char inv){
  char bestans[1001];
  int k, os=anss, t;
  if (i==j){
    ans[anss++]=a[i];
    return;
  }
  if (bestt[i][j][inv]!=0){
    k=best[i][j][inv];
    if (bestt[i][j][inv]==1){
      if (inv) ans[anss++]='[';
      buildans(i, k, 0);
      buildans(k+1, j, 0);
      if (inv) ans[anss++]=']';
    } else {
      if (!inv) ans[anss++]='[';
      buildans(k+1, j, 1);
      buildans(i, k, 1);
      if (!inv) ans[anss++]=']';
    }
    return;
  }
  for (k=i; k<j; k++){
    if (Max[i][k]<=Min[k+1][j]&&d[i][k][0]!=0&&d[k+1][j][0]!=0&&
      d[i][k][0]+d[k+1][j][0]+2*inv==d[i][j][inv]){
      if (inv) ans[anss++]='[';
      buildans(i, k, 0);
      buildans(k+1, j, 0);
      if (inv) ans[anss++]=']';
      return;
      for (t=os; t<anss; t++) if (ans[t]!=bestans[t]) break;
      if (bestt[i][j][inv]==0||ans[t]<bestans[t]){
        for (; t<anss; t++) bestans[t]=ans[t];
        bestt[i][j][inv]=1;
        best[i][j][inv]=k;
      }
      anss=os;
    }
    if (Min[i][k]>=Max[k+1][j]&&d[i][k][1]!=0&&d[k+1][j][1]!=0&&
      d[i][k][1]+d[k+1][j][1]+2-2*inv==d[i][j][inv]){
      if (!inv) ans[anss++]='[';
      buildans(k+1, j, 1);
      buildans(i, k, 1);
      if (!inv) ans[anss++]=']';
      return;
      for (t=os; t<anss; t++) if (ans[t]!=bestans[t]) break;
      if (bestt[i][j][inv]==0||ans[t]<bestans[t]){
        for (; t<anss; t++) bestans[t]=ans[t];
        bestt[i][j][inv]=2;
        best[i][j][inv]=k;
      }
      anss=os;
    }
  }
  for (t=os; t<os+d[i][j][inv]; t++) ans[t]=bestans[t];
  anss=os+d[i][j][inv];
}

int main(){
  freopen("cipher.in", "rt", stdin);
  freopen("cipher.out", "wt", stdout);
  scanf("%[a-z]", a);
  n=strlen(a);
  for (i=0; i<n; i++){
    Min[i][i]=Max[i][i]=a[i];
    for (j=i+1; j<n; j++){
      Min[i][j]=MIN(Min[i][j-1], a[j]);
      Max[i][j]=MAX(Max[i][j-1], a[j]);
    }
  }
  if (rec(0, n-1, false)==0)
    printf("NO SOLUTION");
  else {
    buildans(0, n-1, false);
    ans[anss]=0;
    printf("%s", ans);
  }
  return 0;
}
