#include <cstdio>
#include <memory.h>
#include <algorithm>

#define maxn (long)700
#define maxl (long)1000
#define l1 ll1
#define l2 ll2
#define l3 ll3
#define l4 ll4

using namespace std;

char s1[maxn],s2[maxn],s3[maxn],s4[maxn],ts[maxn];
long ll1=0,ll2=0,ll3=0,ll4=0;


struct suf_automat{
	long next[maxl][256],suf[maxl],l[maxl]/*,w[maxl]*/,nodes;
	
	suf_automat()
	{
		nodes=0;
		memset(next,0,sizeof(next));
		memset(suf,0,sizeof(suf));
		memset(l,0,sizeof(l));
/*		memset(w,0,sizeof(w));*/
	}

	void build(char s[maxn])
	{
		long len=0,x=0;
		while(s[len]!=0) len++;
		for(long i=0;i<len;i++){
			char c=s[i];
			nodes++;
			long m=nodes;
			l[m]=i;
			long p=x;
			while((p!=0)&&(next[p][c]==0))
				next[p][c]=m,p=suf[p];
			/**/if(next[p][c]==0) next[p][c]=m;
			if(p==0) suf[m]=0;
			else{
				long q=next[p][c];
				if(l[q]==l[p]+1) suf[m]=q;
				else{
					nodes++/*,w[nodes]=nw*/;
					long r=nodes;
					memcpy(next[q],next[r],sizeof(next[q]));
					suf[r]=suf[q];
					suf[q]=r,suf[m]=r;
					l[r]=l[p]+1;
					while((p!=0)&&(next[p][c]==q))
						next[p][c]=r,p=suf[p];
					/**/if(next[p][c]==0) next[p][c]=m;
				}
			}
			x=m;
		}
	}
};

suf_automat a1,a2,a3,a4;
long wh,now,ans,nc=0;
long e1=0,e2=0,e3=0,e4=0,e5=0,e6=0,e7=0,e8=0;

inline bool move(char c)
{
	if(wh==3){
		if(a3.next[now][c]>0){
			now=a3.next[now][c];
			return true;
		}
		else{
			wh=4;
			now=a4.next[0][c];
			return (now>0);
		}
	} else{
		now=a4.next[now][c];
		return (now>0);
	}
}

long d[5][maxl][maxn];

long get(long x,long y,long z)
{
	if(d[x][y][z]!=-1) return d[x][y][z];
	if(z>=ll2) return 0;
	if((x==3)&&(y==4)&&(z==1)) printf("Working in it\n");
	long ow=wh,on=now;
	wh=x,now=y;
	if(!move(s2[z])){
		now=on,wh=ow;
		d[x][y][z]=0;
		return 0;
	}
	if((x==3)&&(y==4)&&(z==1)) printf("Starting recursively %d %d %d\n",wh,now,z+1);
	d[x][y][z]=1+get(wh,now,z+1);
	if((x==3)&&(y==4)&&(z==1)) printf("Counted %d because reccall=%d\n",d[x][y][z],get(wh,now,z+1));
	wh=ow,now=on;
	return d[x][y][z];
}


int main()
{
	freopen("nostrings.in","r",stdin);
	gets(s1); gets(s2); gets(s3); gets(s4);
	while(s1[l1]!=0) l1++;
	while(s2[l2]!=0) l2++;
	while(s3[l3]!=0) l3++;
	while(s4[l4]!=0) l4++;
	fclose(stdin);
	a1.build(s1);
	a2.build(s2);
	a3.build(s3),printf("s3=%s\n",s3);
	a4.build(s4);
	ans=-1;
	for(long i=3;i<=4;i++)
		for(long j=0;j<maxl;j++)
			for(long k=0;k<maxn;k++)
				d[i][j][k]=-1;
	for(char j='a';j<='z';j++)
		printf("%c ",j);
	printf("\n");
	for(long i=0;i<=a3.nodes;i++){
		for(char j='a';j<='z';j++)
			printf("%d ",a4.next[i][j]);
		printf("\n");
	}
	for(long i=0;i<ll1;i++){
		long ts,mx;
		for(long j=0;j<ll2;j++){
			ts=i-1,now=0,wh=3,nc=0;                        
			do{
				mx=get(wh,now,j);
				printf("Working on %d-%d, %d-%d, ans is %d, wh=%d,now=%d\n",i,ts,j,j+mx-1,mx+nc,wh,now);
				if(mx+nc>ans) ans=mx+nc,e1=i,e2=ts,e3=j,e4=j+mx-1;
				ts++,nc++;
			} while(move(s1[ts]));
			printf("Ended %d,%d on %d because there`re no paths from %d,%d by %c\n",i,j,ts,wh,now,s1[ts]);
		}
	}
	long tl=0;
	freopen("nostrings.out","w",stdout);
	for(long i=e1;i<=e2;i++)
		printf("%c",s1[i]),ts[tl++]=s1[i];
	printf("\n");
	for(long i=e3;i<=e4;i++)
		printf("%c",s2[i]),ts[tl++]=s2[i];
	printf("\n");
	wh=3,now=0;
	long q=0;
	move(ts[q]);
	while((q<tl)&&(wh==3)){
		printf("%c",ts[q]);
		q++;
		if(q<tl) move(ts[q]);
	}
	printf("\n");
	while(q<tl){
		printf("%c",ts[q]);
		q++;
		if(q<tl) move(ts[q]);
	}
	printf("\n");
	fclose(stdout);
	return 0;
}
