{$DEFINE DEBUG}
{$UNDEF DEBUG}
type integer = longint;
const NUMP = 1594323;
var s, p : string;
	n : integer;
	pfp : array[1..13] of integer;	
	pow3 : array[0..13] of integer;

procedure Load;
var i, k : integer;
begin
	readln(s);
	n := length(s);
	readln(p);
	pfp[1] := 0;
	k := 0;
	for i := 2 to length(p) do begin
		while (k > 0) and (p[i] <> p[k + 1]) do k := pfp[k];
		if (p[i] = p[k + 1]) then inc(k);
		pfp[i] := k;
	end;
	pow3[0] := 1;
	for i := 1 to 13 do pow3[i] := 3 * pow3[i - 1];
end;

var res : array[0..NUMP] of extended;
	was : array[0..NUMP] of byte;

function Count(pr : integer) : extended;
var s : string;
	np1, np2, aw, sw, k, ppr, i : integer;
	cres : extended;
begin
	if was[pr] = 1 then begin
		Count := res[pr];
		exit;
	end;
	was[pr] := 1;
	{unpack profile}
	s := '';
	ppr := pr;
	for i := 1 to n do begin
		if ppr mod 3 = 0 then s := s+ '0'
		else if ppr mod 3 = 1 then s := s + '1'
		else s := s + '?';
		ppr := ppr div 3;
	end;
	{check if always win}
	aw := 0;
	k := 0;
	for i := 1 to n do begin
		while (k > 0) and (s[i] <> p[k + 1]) do k := pfp[k];
		if (s[i] = p[k + 1]) then inc(k);
		if k = length(p) then begin
			aw := 1;
			break;
		end;
	end;
	{check if can win some case}
	sw := 0;
	k := 0;
	for i := 1 to n do begin
		while (k > 0) and ((s[i] <> '?') and (s[i] <> p[k + 1])) do k := pfp[k];
		if (s[i] = p[k + 1]) or (s[i] = '?') then inc(k);
		if k = length(p) then begin
			sw := 1;
			break;
		end;
	end;
	{check if only one path}
	if (aw = 1) or (sw = 0) then begin
		{$IFDEF DEBUG}
		writeln('Count profile = ', pr);
		writeln(' string  = ', s);
		writeln(' result = ', res[pr] :0 :10);
		{$ENDIF}
		res[pr] := 0; 
		Count := 0;
		exit;
	end;
	{try to open smth}
	res[pr] := 1e+4000;
	for i := 1 to n do begin
		if s[i] <> '?' then continue;
		{if it will be zero}
		np1 := pr - pow3[i - 1] * (2 - 0);
		{if it will be one}
		np2 := pr - pow3[i - 1] * (2 - 1);
		cres := 0.5 * (1 + Count(np1)) + 0.5 * (1 + Count(np2));
		if res[pr] > cres then res[pr] := cres;
	end;
	{$IFDEF DEBUG}
	writeln('Count profile = ', pr);
	writeln(' string  = ', s);
	writeln(' result = ', res[pr] :0 :10);
	{$ENDIF}
	Count := res[pr];
end;

procedure Solve;
var begp, i : integer;
begin
	fillchar(was, sizeof(was), 0);
	begp := 0;
	for i := n downto 1 do begin
		begp := begp * 3;
		if s[i] = '0' then begp := begp + 0
		else if s[i] = '1' then begp := begp + 1
		else begp := begp + 2;
	end;
	write(Count(begp) :0 : 15);
end;

begin
	assign(input, 'substring.in');
	assign(output, 'substring.out');
	reset(input);
	rewrite(output);
	Load;
	Solve;
	close(input);
	close(output);
end.