#include <cstdio>
#include <string>
#include <iostream>
#include <algorithm>

#define Max1(a) ((a)==0?0:max1[a])
#define Max1i(a) ((a)==0?0:max1i[a])
#define Max4(b) ((b)==a[3].size()?0:max4[b])
#define Max4i(b) ((b)==a[3].size()?0:max4i[b])

using namespace std;

int ans, l[4], r[4], oa, i;
string a[4], x, y;
int px[300], py[300], max1[300], max4[300], max1i[300], max4i[300];

void kmp(){
  int i;
  px[0]=0;
  for (i=1; i<x.size(); i++){
    for (px[i]=px[i-1]; px[i]&&x[i]!=x[px[i]]; px[i]=px[px[i]-1]);
    if (x[i]==x[px[i]]) px[i]++;
  }
  //py[0]=0;
  for (i=0; i<y.size(); i++){
    for (py[i]=i==0?0:py[i-1]; py[i]&&y[i]!=x[py[i]]; py[i]=px[py[i]-1]);
    if (y[i]==x[py[i]]) py[i]++;
  }
}

void solve(){
  int i, j;
  for (i=0; i<a[0].size(); i++) max1[i]=max1i[i]=0;
  y=a[0];
  for (i=0; i<a[2].size(); i++){
    x=a[2].substr(i, a[2].size()-i);
    kmp();
    for (j=0; j<a[0].size(); j++)
      if (py[j]>max1[j]){
        max1[j]=py[j];
        max1i[j]=i+py[j]-1;
      }
  }
  reverse(a[1].begin(), a[1].end());
  reverse(a[3].begin(), a[3].end());
  for (i=0; i<a[3].size(); i++) max4[i]=max4i[i]=0;
  y=a[3];
  for (i=0; i<a[1].size(); i++){
    x=a[1].substr(i, a[1].size()-i);
    kmp();
    for (j=0; j<a[3].size(); j++)
      if (py[j]>max4[a[3].size()-j-1]){
        max4[a[3].size()-j-1]=py[j];
        max4i[a[3].size()-j-1]=a[1].size()-i-1-py[j]+1;
      }
  }
  reverse(a[1].begin(), a[1].end());
  reverse(a[3].begin(), a[3].end());
  y=a[3];
  for (i=0; i<=a[0].size(); i++){
    x=a[0].substr(i, a[0].size()-i);
    kmp();
    for (j=0; j<a[3].size()-1; j++){
      if (py[j]!=0&&Max1(i-1)+py[j]+Max4(j+1)>ans){
        ans=Max1(i-1)+py[j]+Max4(j+1);
        l[0]=i-Max1(i-1);
        r[0]=i+py[j]-1;
        l[1]=Max4i(j+1);
        r[1]=Max4i(j+1)+Max4(j+1)-1;
        l[2]=Max1i(i-1)-Max1(i-1)+1;
        r[2]=Max1i(i-1);
        l[3]=j;
        r[3]=j+py[j]-1+Max4(j+1);
      }
    }
  }
}

int main(){
  freopen("nostrings.in", "rt", stdin);
  freopen("nostrings.out", "wt", stdout);
  for (i=0; i<4; i++) getline(cin, a[i], '\n');
  ans=0;
  solve();
  oa=ans;
  swap(a[0], a[2]);
  swap(a[1], a[3]);
  ans--;
  solve();
  if (oa<=ans){
    swap(l[0], l[2]);
    swap(l[1], l[3]);
    swap(r[0], r[2]);
    swap(r[1], r[3]);
  }
  swap(a[0], a[2]);
  swap(a[1], a[3]);
  cout<<a[0].substr(l[0], r[0]-l[0]+1)<<endl;
  cout<<a[1].substr(l[1], r[1]-l[1]+1)<<endl;
  cout<<a[2].substr(l[2], r[2]-l[2]+1)<<endl;
  cout<<a[3].substr(l[3], r[3]-l[3]+1)<<endl;
  return 0;
}
