#include <stdio.h>
#include <memory.h>
#include <string.h>

int n[4];
char s[4][310];
int lcp[4][4][310][310];
int res[2][2][310][310];
int father[2][2][310][310];

char ans[4][310];
int anum[4];
int answer;
int besti, bestj, bc;

int readString(char *arr) {
	fgets(arr, 305, stdin);
	int len = strlen(arr);
	while ((arr[len-1] == ' ') || (arr[len-1] == '\n'))
		len--;
	arr[len] = 0;
	return len;
}

void GenLCP(int a, int b) {
	int i, j;
	lcp[a][b][n[a]][n[b]] = 0;
	for (i = 0; i<n[a]; i++)
		lcp[a][b][i][n[b]] = 0;
	for (j = 0; j<n[b]; j++)
		lcp[a][b][n[a]][j] = 0;
	for (i = n[a]-1; i>=0; i--)
		for (j = n[b]-1; j>=0; j--) {
			if (s[a][i] == s[b][j])
				lcp[a][b][i][j] = lcp[a][b][i+1][j+1] + 1;
			else
				lcp[a][b][i][j] = 0;
		}
}

void Print(int r, int a, int i, int len) {
	memcpy(ans[r]+anum[r], s[a]+i, len);
	anum[r] += len;
}

int main(int argc, char **argv) {
	freopen("nostrings.in", "r", stdin);
	freopen("nostrings.out", "w", stdout);
	int i, j, k;
	for (i = 0; i<4; i++)
		n[i] = readString(s[i]);
	for (i = 0; i<4; i++)
		for (j = 0; j<4; j++)
			GenLCP(i, j);
	for (i = 0; i<=n[1]; i++)
		for (j = 0; j<=n[3]; j++) {
			int com = lcp[1][3][i][j];
			res[1][1][i][j] = com;
		}
	for (i = 0; i<=n[0]; i++)
		for (j = 0; j<=n[3]; j++) {
			int com = lcp[0][3][i][j];
			for (k = 0; k<=n[1]; k++)
				if (res[0][1][i][j] < res[1][1][k][j+com] + com) {
					res[0][1][i][j] = res[1][1][k][j+com] + com;
					father[0][1][i][j] = k;
				}
		}
	for (i = 0; i<=n[1]; i++)
		for (j = 0; j<=n[2]; j++) {
			int com = lcp[1][2][i][j];
			for (k = 0; k<=n[3]; k++)
				if (res[1][0][i][j] < res[1][1][i+com][k] + com) {
					res[1][0][i][j] = res[1][1][i+com][k] + com;
					father[1][0][i][j] = k;
				}
		}
	answer = 0;
	for (i = 0; i<n[0]; i++)
		for (j = 0; j<n[2]; j++) {
			int com = lcp[0][2][i][j];
			for (k = 0; k<=n[3]; k++)
				if (res[0][0][i][j] < res[0][1][i+com][k] + com) {
					res[0][0][i][j] = res[0][1][i+com][k] + com;
					father[0][0][i][j] = k;
					if (answer < res[0][0][i][j]) {
						answer = res[0][0][i][j];
						besti = i;
						bestj = j;
						bc = 1;
					}
				}
			for (k = 0; k<=n[1]; k++)
				if (res[0][0][i][j] < res[1][0][k][j+com] + com) {
					res[0][0][i][j] = res[1][0][k][j+com] + com;
					father[0][0][i][j] = k;
					if (answer < res[0][0][i][j]) {
						answer = res[0][0][i][j];
						besti = i;
						bestj = j;
						bc = 0;
					}
				}
		}
	int com = lcp[0][2][besti][bestj];
	Print(0, 0, besti, com);
	Print(2, 2, bestj, com);
	if (bc) {
		bestj = father[0][0][besti][bestj];
		besti += com;
		com = lcp[0][3][besti][bestj];
		Print(0, 0, besti, com);
		Print(3, 3, bestj, com);
		besti = father[0][1][besti][bestj];
		bestj += com;
	}
	else {
		besti = father[0][0][besti][bestj];
		bestj += com;
		com = lcp[1][2][besti][bestj];
		Print(1, 1, besti, com);
		Print(2, 2, bestj, com);
		bestj = father[1][0][besti][bestj];
		besti += com;
	}
	com = lcp[1][3][besti][bestj];
	Print(1, 1, besti, com);
	Print(3, 3, bestj, com);
	for (i = 0; i<4; i++) {
		ans[i][anum[i]] = 0;
		printf("%s\n", ans[i]);
	}
	return 0;
}
