{ $DEFINE DEBUG}
{$H+}
{$IFDEF DEBUG}
{$C+,I+,Q+,R+,S+}
{$ELSE}
{$C-,I-,Q-,R-,S-}
{$ENDIF}
{$M 60000000,60000000}
uses math;
const taskid='nostrings';
      infile=taskid+'.in';
      outfile=taskid+'.out';
type ptrie=^ttrie;
     ttrie=array ['a'..'z'] of ptrie;
var s1,s2,s3,s4:string;
    a1,a2,a3,a4,a5,a6,a7,a8:string;
procedure createnode(var t:ptrie);
begin
  new(t);
  fillchar(t^,sizeof(t^),0);
end;
function buildtrie(s:string):ptrie;
var root,cur:ptrie;
    i,j:longint;
begin
  createnode(root);
  buildtrie:=root;
  for i:=1 to length(s) do
  begin
    cur:=root;
    for j:=i to length(s) do
    begin
      if cur^[s[j]]=nil then
        createnode(cur^[s[j]]);
      cur:=cur^[s[j]];
    end;
  end;
end;
procedure solve(s1,s2,s3,s4:string;var a1,a2,a3,a4:string);
var bor2,bor3,cur:ptrie;
    i,j,best1,best4,k,ii,jj,kk,best:longint;
    table1,table4:array [0..400] of longint;
begin
  bor2:=buildtrie(s2);
  bor3:=buildtrie(s3);
  fillchar(table4,sizeof(table4),0);
  for i:=1 to length(s4)+1 do
  begin
    cur:=bor2;
    for j:=i to length(s4) do
    begin
      cur:=cur^[s4[j]];
      if cur=nil then
        break;
      table4[i]:=j-i+1;
    end;
  end;
  fillchar(table1,sizeof(table1),0);
  for i:=1 to length(s1) do
  begin
    cur:=bor3;
    for j:=i to length(s1) do
    begin
      cur:=cur^[s1[j]];
      if cur=nil then
        break;
      if table1[j]<j-i+1 then
        table1[j]:=j-i+1;
    end;
  end;
  best1:=-1;
  for i:=0 to length(s1)+1 do
    if table1[i]>best1 then
    begin
      best1:=table1[i];
      ii:=i;
    end;
  best4:=-1;
  for i:=0 to length(s4)+1 do
    if table4[i]>best4 then
    begin
      best4:=table4[i];
      jj:=i;
    end;
  a1:=copy(s1,ii-table1[ii]+1,table1[ii]);
  a2:=copy(s4,jj,table4[jj]);
  a3:=a1;
  a4:=a2;
  best:=best1+best4;
  for i:=1 to length(s1) do
    for j:=1 to length(s4) do
      for k:=1 to min(length(s1)-i+1,length(s4)-j+1) do
      begin
        if s1[i+k-1]<>s4[j+k-1] then
          break;
        if table1[i-1]+k+table4[j+k]>best then
        begin
          best:=table1[i-1]+k+table4[j+k];
          ii:=i;
          jj:=j;
          kk:=k;
        end;
      end;
  if best<>best1+best4 then
  begin
    a1:=copy(s1,ii-table1[ii-1],table1[ii-1]+kk);
    a2:=copy(s4,jj+kk,table4[jj+kk]);
    a3:=copy(s1,ii-table1[ii-1],table1[ii-1]);
    a4:=copy(s4,jj,table4[jj+kk]+kk);
  end;
end;
begin
  assign(input,infile);
  reset(input);
  assign(output,outfile);
  rewrite(output);
  {$IFDEF DEBUG}
  writeln('Debug Mode:');
  {$ENDIF}
  readln(s1);
  readln(s2);
  readln(s3);
  readln(s4);
  solve(s1,s2,s3,s4,a1,a2,a3,a4);
  solve(s3,s4,s1,s2,a7,a8,a5,a6);
  {$IFDEF DEBUG}
  assert((pos(a1,s1)<>0) or (a1=''));
  assert((pos(a2,s2)<>0) or (a2=''));
  assert((pos(a3,s3)<>0) or (a3=''));
  assert((pos(a4,s4)<>0) or (a4=''));
  assert((pos(a5,s1)<>0) or (a5=''));
  assert((pos(a6,s2)<>0) or (a6=''));
  assert((pos(a7,s3)<>0) or (a7=''));
  assert((pos(a8,s4)<>0) or (a8=''));
  {$ENDIF}
  if length(a1)+length(a2)+length(a3)+length(a4)>length(a5)+length(a6)+length(a7)+length(a8) then
  begin
    writeln(a1);
    writeln(a2);
    writeln(a3);
    writeln(a4);
  end
  else begin
    writeln(a5);
    writeln(a6);
    writeln(a7);
    writeln(a8);
  end;
  close(input);
  close(output);
end.
