{ $DEFINE DEBUG}
{$H+}
{$IFDEF DEBUG}
{$C+,I+,Q+,R+,S+}
{$ELSE}
{$C-,I-,Q-,R-,S-}
{$ENDIF}
{$M 60000000,60000000}
uses math;
const taskid='cipher';
      infile=taskid+'.in';
      outfile=taskid+'.out';
      infinity=1000000000;
var s,ans:string;
    n,i,j,l,k,best:longint;
    least,most:array [1..300,1..300] of char;
    front,back:array [1..300,1..300] of longint;
    afront,aback:array [1..300,1..300] of string;
procedure update(var a:longint;b:longint);
begin
  if b<a then
    a:=b;
end;
procedure update2(var a:string;b:string);
begin
  if b<a then
    a:=b;
end;
begin
  assign(input,infile);
  reset(input);
  assign(output,outfile);
  rewrite(output);
  {$IFDEF DEBUG}
  writeln('Debug Mode:');
  {$ENDIF}
  readln(s);
  n:=length(s);
  for i:=1 to n do
  begin
    least[i,i]:=s[i];
    most[i,i]:=s[i];
  end;
  for l:=2 to n do
    for i:=1 to n-l+1 do
    begin
      j:=i+l-1;
      least[i,j]:=least[i,j-1];
      if s[j]<least[i,j] then
        least[i,j]:=s[j];
      most[i,j]:=most[i,j-1];
      if s[j]>most[i,j] then
        most[i,j]:=s[j];
    end;
  fillchar(front,sizeof(front),0);
  fillchar(back,sizeof(back),0);
  for i:=1 to n do
  begin
    front[i,i]:=1;
    back[i,i]:=1;
    afront[i,i]:=s[i];
    aback[i,i]:=s[i];
  end;
  for l:=2 to n do
    for i:=1 to n-l+1 do
    begin
      j:=i+l-1;
      front[i,j]:=infinity;
      for k:=i to j-1 do
        if most[i,k]<=least[k+1,j] then
        begin
          update(front[i,j],front[i,k]+front[k+1,j]);
          update(front[i,j],back[i,k]+front[k+1,j]+2);
          update(front[i,j],front[i,k]+back[k+1,j]+2);
          update(front[i,j],back[i,k]+back[k+1,j]+4);
        end;
      afront[i,j]:=#255;
      for k:=i to j-1 do
        if most[i,k]<=least[k+1,j] then
        begin
          if front[i,j]=front[i,k]+front[k+1,j] then
            update2(afront[i,j],afront[i,k]+afront[k+1,j]);
          if front[i,j]=back[i,k]+front[k+1,j]+2 then
            update2(afront[i,j],'['+aback[i,k]+']'+afront[k+1,j]);
          if front[i,j]=front[i,k]+back[k+1,j]+2 then
            update2(afront[i,j],afront[i,k]+'['+aback[k+1,j]+']');
          if front[i,j]=back[i,k]+back[k+1,j]+4 then
            update2(afront[i,j],'['+aback[i,k]+']['+aback[k+1,j]+']');
        end;
      back[i,j]:=infinity;
      for k:=i to j-1 do
        if least[i,k]>=most[k+1,j] then
        begin
          update(back[i,j],back[i,k]+back[k+1,j]);
          update(back[i,j],front[i,k]+back[k+1,j]+2);
          update(back[i,j],back[i,k]+front[k+1,j]+2);
          update(back[i,j],front[i,k]+front[k+1,j]+4);
        end;
      aback[i,j]:=#255;
      for k:=i to j-1 do
        if least[i,k]>=most[k+1,j] then
        begin
          if back[i,j]=back[i,k]+back[k+1,j] then
            update2(aback[i,j],aback[k+1,j]+aback[i,k]);
          if back[i,j]=front[i,k]+back[k+1,j]+2 then
            update2(aback[i,j],aback[k+1,j]+'['+afront[i,k]+']');
          if back[i,j]=back[i,k]+front[k+1,j]+2 then
            update2(aback[i,j],'['+afront[k+1,j]+']'+aback[i,k]);
          if back[i,j]=front[i,k]+front[k+1,j]+4 then
            update2(aback[i,j],'['+afront[k+1,j]+']['+afront[i,k]+']');
        end;
    end;
  best:=min(front[1,n],back[1,n]+2);
  ans:=#255;
  if best=infinity then
    writeln('NO SOLUTION')
  else begin
    if best=front[1,n] then
      update2(ans,afront[1,n]);
    if best=back[1,n]+2 then
      update2(ans,'['+aback[1,n]+']');
    writeln(ans);
  end;
  close(input);
  close(output);
end.
