#include <stdio.h>
#include <string.h>

#define MAX 305
#define INF (int)1e9

char S1[MAX], S2[MAX], S3[MAX], S4[MAX];
int L1, L2, L3, L4, St[MAX][MAX];
int End[MAX][MAX], End2[MAX], End4[MAX];
int P1[MAX][MAX], F1[MAX][MAX], P3[MAX][MAX], F3[MAX][MAX];

char T[MAX * 2];
int TL, Pr[MAX * 2];

void PrF( void )
{
  int i, k = 0;
  Pr[0] = 0;
  for (i = 1; i <= TL; i++)
  {
    while (k && T[k] != T[i])
      k = Pr[k - 1];
    if (T[k] == T[i])
      k++;
    Pr[i] = k;
  }
}

void Out( char *S, int l, int r )
{
  while (l < r)
    putc(S[l++], stdout);
  puts("");
}

int main( void )
{
  int i, j, k, f, p, len, res = -1, ri, rj, rk, rwho;

  freopen("nostrings.in", "rt", stdin);
  freopen("nostrings.out", "wt", stdout);
  gets(S1), L1 = strlen(S1);
  gets(S2), L2 = strlen(S2);
  gets(S3), L3 = strlen(S3);
  gets(S4), L4 = strlen(S4);
  memset(End, 0, sizeof(End));
  memset(End2, 0, sizeof(End2));
  memset(End4, 0, sizeof(End4));
  for (i = L2 - 1; i >= 0; i--)
    for (j = L4 - 1; j >= 0; j--)
      if (S2[i] == S4[j])
      {
        End[i][j] = End[i + 1][j + 1] + 1;
        if (End[i][j] > End2[i])
          End2[i] = End[i][j];
        if (End[i][j] > End4[j])
          End4[j] = End[i][j];
      }
  for (i = 0; i <= L1; i++)
    for (j = i; j <= L1; j++)
    {
      TL = 0;
      for (k = i; k < j; k++)
        T[TL++] = S1[k];
      T[TL++] = '#';
      for (k = 0; k < L4; k++)
        T[TL++] = S4[k];
      T[TL] = 0;
      PrF();
      for (f = -INF, k = 0; k <= L4; k++)
        if (Pr[TL - L4 - 1 + k] == j - i && End4[k] > f)
          f = End4[k], p = k;
      P1[i][j] = p, F1[i][j] = f * 2 + (j - i) * 2;
    }
  for (i = 0; i <= L3; i++)
    for (j = i; j <= L3; j++)
    {
      TL = 0;
      for (k = i; k < j; k++)
        T[TL++] = S3[k];
      T[TL++] = '#';
      for (k = 0; k < L2; k++)
        T[TL++] = S2[k];
      T[TL] = 0;
      PrF();
      for (f = -INF, k = 0; k <= L2; k++)
        if (Pr[TL - L2 - 1 + k] == j - i && End2[k] > f)
          f = End2[k], p = k;
      P3[i][j] = p, F3[i][j] = f * 2 + (j - i) * 2;
    }
  memset(St, 0, sizeof(St));
  for (i = 0; i < L1; i++)
    for (j = 0; j < L3; j++)
      if (S1[i] == S3[j])
        St[i + 1][j + 1] = St[i][j] + 1;
  for (i = 0; i <= L1; i++)
    for (j = 0; j <= L3; j++)
    {
      f = St[i][j] * 2;
      for (k = i; k <= L1; k++)
        if (F1[i][k] + f > res)
          res = F1[i][k] + f, ri = i, rj = j, rk = k, rwho = 0;
      for (k = j; k <= L3; k++)
        if (F3[j][k] + f > res)
          res = F3[j][k] + f, ri = i, rj = j, rk = k, rwho = 1;
    }
  fprintf(stderr, "%d\n", res);
  if (rwho == 0)
  {
    Out(S1, ri - St[ri][rj], rk);
    f = F1[ri][rk], p = P1[ri][rk];
    len = f / 2 - (rk - ri);
    Out(S4, p, p + len);
    Out(S3, rj - St[ri][rj], rj);
    Out(S4, p - (rk - ri), p + len);
  }
  else
  {
    Out(S1, ri - St[ri][rj], ri);
    f = F3[rj][rk], p = P3[rj][rk];
    len = f / 2 - (rk - rj);
    Out(S2, p - (rk - rj), p + len);
    Out(S3, rj - St[ri][rj], rk);
    Out(S2, p, p + len);
  }
  return 0;
}
