{$R-,H+}
uses
  SysUtils;

const namein='cipher.in';
      nameout='cipher.out';
      NMax=310;
      NA=-1;
      None=10*NMax;
var n:integer;
    s,x,Sol,v,y:string;

procedure Init;
begin
 assign(input,namein);
 reset(input);
 readln(s);
 n:=length(s);
 close(input)
end;

procedure Done;
begin
 assign(output,nameout);
 rewrite(output);
 writeln(Sol);
 close(output);
 halt(0)
end;

function MinS(const a,b:string):string;
var i:integer;
begin
 if length(a)<length(b) then MinS:=a
 else
  if length(b)<length(a) then MinS:=b
  else begin
    i:=1;
    while (i<=length(a)) and (a[i]=b[i]) do inc(i);
    if i>length(a) then MinS:=a
    else
     if a[i]>b[i] then MinS:=b
     else MinS:=a
   end
end;

procedure Calc(s:string);
var q:string;
    Ok:boolean;
    t,i,l,r:integer;
begin
 Ok:=true;
 t:=1;
 for i:=1 to length(s) do
  if s[i] in ['a'..'z'] then begin
    Ok:=Ok and (s[i]=x[t]);
    inc(t);
    if not Ok then Break
   end;
 if Ok then
  if Sol='' then Sol:=s
  else Sol:=MinS(Sol,s)
 else
  for l:=1 to length(s) do
   if s[l] in ['a'..'z'] then begin
     r:=l+1;
     while (r<=length(s)) and (s[r] in ['a'..'z']) do begin
       if ((l=1) or (s[l-1]<>'[')) or ((r=n) or (s[r+1]<>']'))
       then begin
         q:=copy(s,1,l-1);
         q:=q+'[';
         for i:=r downto l do q:=q+s[i];
         q:=q+']';
         if r<length(s) then q:=q+copy(s,r+1,length(s)-r);
         Calc(q)
        end;
       inc(r)
      end
    end
end;

procedure Solve;
var q:char;
    i,j:integer;
    f:boolean;
begin
 x:=s;
 for i:=1 to n-1 do
  for j:=i+1 to n do
   if x[i]>x[j] then begin
     q:=x[i];
     x[i]:=x[j];
     x[j]:=q
    end;
 Sol:='';
 Calc(s);
 if Sol='' then Sol:='NO SOLUTION'
end;

begin
 Init;
 Solve;
 Done
end.
