#include <stdio.h>
#include <algorithm>

#define PROFS 1594323

int pow3[16];
int n, k;
char expr[16];
char im[16];
int res[PROFS];
bool done[PROFS];
char mask[PROFS][16];
int stprf;
char curr[16];
bool equal[2][3];

int readString(char *arr) {
	fgets(arr, 15, stdin);
	int len = strlen(arr);
	while ((arr[len-1] == ' ') || (arr[len-1] == '\n'))
		len--;
	arr[len] = 0;
	return len;
}

bool ok, can;
char *cm;
int Solve(int prof) {
	if (done[prof]) return res[prof];
	done[prof] = true;
	cm = mask[prof];
	if (std::search(cm, cm+n, im, im+k) != cm+n)
		return (res[prof] = 0);
	can = false;
	int i, j;
	for (i = 0; i<=n-k; i++) {
		ok = true;
		for (j = 0; j<k; j++)
			if (!equal[im[j]][cm[i+j]]) {
				ok = false;
				break;
			}
		if (ok) {
			can = true;
			break;
		}
	}
	if (!can) return (res[prof] = 0);
	for (i = 0; i<n; i++)
		if (mask[prof][i] == 2) {
			int tr = 0;
			tr += Solve(prof - pow3[i]);
			if ((tr>>1) > res[prof])
				continue;
			tr += Solve(prof - 2*pow3[i]);
			tr >>= 1;
			if (res[prof] > tr)
				res[prof] = tr;
		}
	res[prof] += (1<<15);
	return res[prof];
}

int main(int argc, char **argv) {
	freopen("substring.in", "r", stdin);
	freopen("substring.out", "w", stdout);
	n = readString(expr);
	k = readString(im);
	stprf = 0;
	int i, j;
	for (i = n-1; i>=0; i--) {
		stprf *= 3;
		if (expr[i] != '?')
			stprf += (expr[i]-'0');
		else
			stprf += 2;
	}
	memset(curr, 0, sizeof(curr));
	for (i = 0; i<PROFS; i++) {
		res[i] = 1000000000;
		memcpy(mask[i], curr, n);
		for (j = 0; j<n; j++) {
			curr[j]++;
			if (curr[j] < 3) break;
			curr[j] = 0;
		}
	}
	equal[0][0] = true;
	equal[0][1] = false;
	equal[0][2] = true;
	equal[1][0] = false;
	equal[1][1] = true;
	equal[1][2] = true;
	pow3[0] = 1;
	for (i = 1; i<16; i++)
		pow3[i] = pow3[i-1]*3;
	for (i = 0; i<k; i++)
		im[i] -= '0';
	Solve(stprf);
	printf("%0.20llf", res[stprf] / (long double)(1<<15));
	return 0;
}
