#include <cstdio>

#define maxn 100
#define eps 1e-12

using namespace std;

char a[maxn],b[maxn];
double d[2000000];
long l=0,bl=0;

inline bool final()
{
	bool a1=true,a2=true,fl;
	for(long i=0;i<l;i++){
		fl=true;
		for(long j=0;j<bl;j++)
			if(b[j]!=a[i+j]){
				fl=false;
				break;
			}
		if(fl) a1=false;
		fl=true;
		for(long j=0;j<bl;j++)
			if((b[j]!=a[i+j])&&(a[i+j]!='?')){
				fl=false;
				break;
			}
		if(fl) a2=false;
	}
	return (!a1)||a2;
}

inline long cf(char c)
{
	if(c=='0') return 0;
	if(c=='1') return 1;
	return 2;
}

inline long count()
{
	long ans=0;
	for(long i=0;i<l;i++)
		ans=(ans*3)+cf(a[i]);
	return ans;
}

inline double f()
{
	long nm=count();
	if(d[nm]>-eps) return d[nm];
	if(final()){
		d[nm]=0;
		return 0;
	}
	double mn=100000.0,nw;
/*	printf("Counting for %s...\n",a);*/
	for(long i=0;i<l;i++){
		if(a[i]!='?') continue;
		a[i]='1';
		nw=f();
		a[i]='0';
		nw=(f()+nw)/2.0;
		a[i]='?';
		mn<?=nw;
	}
	if(mn>100){
		d[nm]=0.0;
		return 0.0;
	}
	d[nm]=1.0+mn;
/*	printf("Counted for %s, %0.5lf\n",a,d[nm]);*/
	return (1.0+mn);
}

int main()
{
	for(long i=0;i<2000000;i++)
		d[i]=-1;
	freopen("substring.in","r",stdin);
	gets(a);
	gets(b);
	while(a[l]!=0) l++;
	while(b[bl]!=0) bl++;
	fclose(stdin);
	freopen("substring.out","w",stdout);
	printf("%0.17lf\n",f());
	fclose(stdout);
	return 0;
}
