#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <algorithm>

using namespace std;

#include "stack.h"

#define MAX 5000010
#define NUM 20
#define LEN 200
#define START 50
int START_VAL, MIN_VAL;

char S[LEN];
int Pr = 0, F[1 << NUM][2];
int count1 = 0;
         
int main( void )
{
  int C1, C2, N, K = 0;
  int pr, i, k, nop, fc, sc, ave, sum, ma, mi;

  memset(F, 0, sizeof(F));
  memset(S, 0, sizeof(S));
  fprintf(stderr, "Init...\n");
  init(&C1, &C2, &N);
  /* Constants */
  START_VAL = N;
  MIN_VAL = N >> 2;

  fprintf(stderr, "Ok\n");
  nop = nextOp();
  fprintf(stderr, "Start\n");
  while (1)
  {
    fc = fastCount(), sc = slowCount();
    F[Pr][nop]++;
    for (i = 0; i < LEN - 1; i++)
      S[i] = S[i + 1];
    Pr = (Pr >> 1) + (nop << (NUM - 1));
    if (S[NUM - 1] != nop)
    {
      count1++;
      S[NUM - 1] = nop;
      for (i = NUM, pr = Pr; i < LEN - 1; i++)
      {
        k = F[pr][0] + F[pr][1] + 1;
        S[i] = (rand() % k <= F[pr][1]);
        pr = (pr >> 1) + (S[i] << (NUM - 1));
      }
    }
    for (pr = i = 0; i < NUM; i++)
      pr = (pr << 1) + S[LEN - 1 - NUM + i];
    k = F[pr][0] + F[pr][1] + 1;
    S[LEN - 1] = (rand() % k <= F[pr][1]);

    sum = 0, mi = 0, ma = 0;
    for (i = NUM - 1; i < LEN; i++)
    {
      sum += S[i] ? 1 : -1;
      if (sum < mi) mi = sum;
      if (sum > ma) ma = sum;
      if (ma - mi >= N)
        break;
    }
    K++;
    if (!fc && nop == POP)
    {
      ave = -mi;
      if (ave < MIN_VAL) ave = MIN_VAL;
      if (K < START) ave = START_VAL;
      load(min(ave, sc));
    }
    if (fc == N && nop == PUSH)
    {
      ave = ma;
      if (ave < MIN_VAL) ave = MIN_VAL;
      if (K < START) ave = START_VAL;
      save(ave);
    }
    nop = nextOp();
//    fprintf(stderr, "%d\n", count1);
  }
  return 0;
}
