#include <cmath>
#include <cstdlib>
#include "stack.h"

#define Pi 3.1415926535897932384626433832795

#define MAX(a, b) ((a)>(b)?(a):(b))
#define MIN(a, b) ((a)<(b)?(a):(b))

int c1, c2, T, ver[101], i, x, sum;
char t;

int main(){
  srand(77);
  init(&c1, &c2, &T);
  for (i=0; i<T+1; i++)
    sum+=ver[i]=i*(T+1-i)*(100/T);
  while (1){
    t=nextOp();
    if (t==PUSH&&fastCount()==T){
      x=rand()%sum;
      for (i=0; ver[i]<x; i++) x-=ver[i];
      //i=rand()%T+1;
      save(i);
    }
    if (t==POP&&fastCount()==0){
      x=rand()%sum;
      for (i=0; ver[i]<x; i++) x-=ver[i];
      //i=rand()%T+1;
      load(MIN(i, slowCount()));
    }
  }
  return 0;
}
