#include <cstdio>
#include <memory.h>
#include <cctype>

#define maxn 50
#define inf 10000000

using namespace std;

long a[maxn][maxn];
long deg[maxn];
long n=26,now;
long h=0;

long cost(long now)
{
	if(h>=14) return -deg[now];
	h++;
	if(h%2==1){
		long ac=-inf,tc;
		for(long i=0;i<n;i++){
			if(a[now][i]<=0) continue;
			a[now][i]--;
			tc=cost(i);
			a[now][i]++;
			if(tc>ac) ac=tc;
		}
		return ac;
	} else{
		long ac=inf,tc;
		for(long i=0;i<n;i++){
			if(a[now][i]<=0) continue;
			a[now][i]--;
			tc=cost(i);
			a[now][i]++;
			if(tc<ac) ac=tc;
		}
		return ac;
	}
	h--;
}

int main()
{
	memset(deg,0,sizeof(deg));
	freopen("towns.in","r",stdin);
	for(long i=0;i<n;i++)
		for(long j=0;j<n;j++)
			scanf("%d",&a[i][j]),deg[i]+=a[i][j];
	char ch;
	do scanf("%c",&ch); while(!isalpha(ch));
	now=ch-'a';
	long aa=-1,ac=-inf,tc;
	for(long i=0;i<n;i++){
		if(a[now][i]<=0) continue;
		if(aa==-1) aa=i;
		a[now][i]--;
		tc=cost(i);
		a[now][i]++;
		if(tc>ac) ac=tc,aa=i;
	}
	fclose(stdin);
	freopen("towns.out","w",stdout);
	printf("%c\n",'a'+aa);
	fclose(stdout);
	return 0;
}
