#include <stdio.h>
#include <stdlib.h>

#include "stack.h"

#define max(a, b) ((a) > (b) ? (a) : (b))
#define min(a, b) ((a) < (b) ? (a) : (b))

int main( void )
{
  int c1, c2, t, fa, sl, bl;

  srand(301703);
  init(&c1, &c2, &t);
  fa = fastCount();
  sl = slowCount();
  bl = max(1, min(t, t - 6 + rand() % 4);
  fprintf(stderr, "bl=%d\n", bl);
  while (1)
  {
    if (nextOp() == PUSH)
    {
      if (fa == t)
        save(bl), fa -= bl, sl += bl;
      fa++;
    }
    else
    {
      if (fa == 0)
        load(bl), fa += bl, sl -= bl;
      fa--;
    }
  }
  return 0;
}
