#include <cmath>
#include <cstdlib>
#include "stack.h"

#define Pi 3.1415926535897932384626433832795
#define INF -1

#define MAX(a, b) ((a)>(b)?(a):(b))
#define MIN(a, b) ((a)<(b)?(a):(b))

int c1, c2, T, verpush[101], verpop[101], i, x, sumpush, sumpop;
int d[101], min, mind;
char t;

int main(){
  //srand(77);
  init(&c1, &c2, &T);
  for (i=0; i<=T; i++) d[i]=INF;
  for (i=0; i<=T; i++){
    sumpush+=verpush[i]=1;
    sumpop+=verpop[i]=1;
  }
  while (1){
    t=nextOp();
    if (t==PUSH&&fastCount()==T){
      x=rand()%sumpush;
      for (i=0; verpush[i]<x; i++) x-=verpush[i];
      save(i);
    }
    if (t==POP&&fastCount()==0){
      x=rand()%sumpop;
      for (i=0; verpop[i]<x; i++) x-=verpop[i];
      load(MIN(i, slowCount()));
    }
    if (t==PUSH){
      mind=d[T];
      d[0]=INF;
      for (i=T; i>0; i--){
        d[i]=d[i-1];
        if (mind!=INF&&d[i]>mind+1){
          d[i]=mind+1;
          verpush[T-i+1]++;
          sumpush++;
        }
      }
    }
    if (t==POP){
      mind=d[0];
      d[T]=INF;
      for (i=0; i<T; i++){
        d[i]=d[i+1];
        if (mind!=INF&&d[i]>mind+1){
          d[i]=mind+1;
          verpop[i+1]++;
          sumpop++;
        }
      }
    }
  }
  return 0;
}
