#include <cstdio>
#include <cstdlib>
#include <ctime>

#include "stack.h"

int main ()
{
  srand (clock ());

  int c1, c2, T;
  init (&c1, &c2, &T);

  int HALF = (T + 1) / 2;
  int RH = HALF;

  while (true)
  {
    int op = nextOp ();
    if (HALF >= RH && HALF > 1)
      HALF -= (rand () & 1);
    else if (HALF < RH && HALF < T-1)
      HALF += (rand () & 1);
    int fsize = fastCount ();
    int ssize = slowCount ();
    if (op == PUSH)
      if (fsize >= T)
        save (HALF);
    if (op == POP)
      if (fsize <= 0)
        load (HALF>ssize?ssize:HALF);
  }

  return 0;
}
