#include <string>
#include <vector>
#include <cmath>
#include <queue>
#include <set>
#include <map>
#include <algorithm>
#include <iostream>
#include <cstdio>
#include <cassert>
#include <utility>

using namespace std;

#define IN_FILE "palin.in"
#define OUT_FILE "palin.out"

#define EPS 1E-8
const int INF = (int)1E+9;

#define forn(i, n) for (int i = 0; i < (int)(n); ++i)
#define forv(i, v) for (int i = 0; i < (int)(v.size()); ++i)
#define fors(i, s) for (int i = 0; i < (int)(s.length()); ++i)
#define all(a) a.begin(), a.end()
#define pb push_back
#define PII pair<int, int>
#define mp make_pair
#define VI vector<int>
#define VS vector<string>

int n, m;

string gen, text;

long long ans = 0;

void outdata() 
{
	cout << ans << endl;
}

void solve() 
{
	fors (i, text)
	{
		int pl = i;
		int pr = i + 1;
		int cur = 0;
		string left = "";
		while (pl >= 0 && pr < text.length() && (text[pl] == text[pr]))
		{
			left = text[pl] + left;
			cur += 2;
			if (left == gen.substr(0, left.size())) ++ans;
			--pl; ++pr;
		}
	}

	fors (i, text)
	{
		int pl = i;
		int pr = i;
		int cur = -1;
		string left = "";
		while (pl >= 0 && pr < text.length() && (text[pl] == text[pr]))
		{
			left = text[pl] + left;
			cur += 2;
			if (left == gen.substr(0, left.size())) ++ans;
			--pl; ++pr;
		}
	}
}

string readString()
{
	int c = getchar();
	while (c <= ' ') c = getchar();
	string res = "";
	while (isalpha(c)) 
	{
		res += c;
		c = getchar();
	}
	return res;
}

void readdata() 
{
	gen = readString();
	text = readString();
}

int main() 
{
	freopen(IN_FILE, "rt", stdin);
	freopen(OUT_FILE, "wt", stdout);
	readdata();
	solve();
	outdata();
	return 0;
}

