#include <stdio.h>
#include <stdlib.h>

#define NN 100000

typedef struct REB {
	int a;
	struct REB *p;
	struct REB *inv;
	int used;
} REB;

int n,m;
int Sn = 0,Sm = 0;
int tstcount,tst;
REB swap[3*NN];
REB *g[NN];
int h[NN], p[NN], used[NN];
int iswap;
int nparts;
int bcount;
int xx1,yy1,xx2,yy2;
int flag;

REB *getnew(void) {
	return &swap[iswap++];
}

void Add(int x, int y) {
	REB *t1, *t2;
	t1=getnew();
	t1->a=y; t1->p=g[x]; g[x]=t1;
	t2=getnew();
	t2->a=x; t2->p=g[y]; g[y]=t2;
	t1->inv=t2; t2->inv=t1;
	t1->used=0; t2->used=0;
}

void dfs(int v, int H, int P) {
	REB *t;
	h[v]=H; p[v]=P; used[v]=1;
	for(t=g[v];t!=NULL;t=t->p) {
		if(!used[t->a]) {
			t->used=1;
			t->inv->used=1;
			dfs(t->a,H+1,v);
		} else {
			if(!(t->used))
				bcount++;
		}
	}
}

int main(void) {
	int i;
	int x,y;
	REB *t;
	freopen("torus.in","rt",stdin);
	freopen("torus.out","wt",stdout);
	
	scanf("%d",&tstcount);
	for(tst=0;tst<tstcount;tst++) {
		iswap=0;
		scanf("%d%d",&n,&m);
		Sn+=n; Sm+=m;
		if(m>n+1) {
			for(i=0;i<m;i++)
				scanf("%d%d",&x,&y);
			printf("NO\n");
			continue;
		}
		for(i=0;i<n;i++) {
			g[i]=NULL;
			used[i]=0;
			h[i]=0;
			p[i]=-1;
		}
		for(i=0;i<m;i++) {
			scanf("%d%d",&x,&y);
			if((x>n)||(x<0)) {
				fprintf(stderr,"Error!\n");
				return 1;
			}
			if((y>n)||(y<0)) {
				fprintf(stderr,"Error!\n");
				return 1;
			}
			x--; y--;
			Add(x,y);
		}
		nparts=0; bcount=0;
		for(i=0;i<n;i++) {
			if(!used[i]) {
				nparts++;
				dfs(i,0,-1);
			}
		}
		bcount/=2;
		if(bcount>2) {
			printf("NO\n");
			continue;
		}
		if(bcount<=1) {
			printf("YES\n");
			continue;
		}
/*		if(nparts>1) {
			printf("YES\n");
			continue;
		}*/
		for(i=0;i<n;i++) {
			for(t=g[i];t!=NULL;t=t->p) {
				if(!(t->used)) {
					xx1=xx2; yy1=yy2;
					xx2=i; yy2=t->a;
					t->used=1;
					t->inv->used=1;
				}
			}
		}
		if(h[yy1]<h[xx1]) {
			i=yy1; yy1=xx1; xx1=i;
		}
		if(h[yy2]<h[xx2]) {
			i=yy2; yy2=xx2; xx2=i;
		}
		flag=0;
		while(1) {
			if((yy1<0)||(yy2<0)) break;
			if(h[xx1]>h[yy1]) break;
			if(h[xx2]>h[yy2]) break;
			if(yy1==yy2) flag=1;
			if(h[yy1]>h[yy2]) {
				yy1=p[yy1];
			} else {
				yy2=p[yy2];
			}
		}
		if(flag) {
			printf("YES\n");
		} else {
			printf("NO\n");
		}
	}
	
	if((Sn>100000)||(Sm>150000)) {
		fprintf(stderr,"Error!!\n");
		return 1;
	}
	return 0;
}
