import java.util.*;
import java.io.*;

public class rectangle_as_bt {
    int[][] a;
    int m;
    int n;
    int answer;
    boolean[][] u;

    void dfs(int x, int y, int c) {
        u[x][y] = true;
        if (x - 1 >= 0 && a[x - 1][y] == c && !u[x - 1][y]) {
            dfs(x - 1, y, c);
        }
        if (x + 1 < m && a[x + 1][y] == c && !u[x + 1][y]) {
            dfs(x + 1, y, c);
        }
        if (y - 1 >= 0 && a[x][y - 1] == c && !u[x][y - 1]) {
            dfs(x, y - 1, c);
        }
        if (y + 1 < n && a[x][y + 1] == c && !u[x][y + 1]) {
            dfs(x, y + 1, c);
        }
    }

    boolean correct() {
        u = new boolean[m][n];
        int k = 0;
        for (int i = 0; i < m; i++) {
            for (int j = 0; j < n; j++) {
                if (!u[i][j]) {
                    k++;
                    dfs(i, j, a[i][j]);
                }
            }
        }
        return k == 2;
    }

    void bt(int x, int y) {
        if (y >= n) {
            if (correct()) {
                answer++;
            }
            return;
        }
        if (x >= m) {
            bt(0, y + 1);
            return;
        }

        a[x][y] = 1;
        bt(x + 1, y);
        a[x][y] = 2;
        bt(x + 1, y);
    }

    public void run() throws IOException {
        Scanner in = new Scanner(new File("rectangle.in"));
        m = in.nextInt();
        n = in.nextInt();
        in.close();

        a = new int[m][n];
        answer = 0;
        bt(0, 0);

        PrintWriter out = new PrintWriter(new File("rectangle.out"));
        out.println(answer / 2);
        out.close();
    }

    public static void main(String[] arg) throws IOException {
        new rectangle_as_bt().run();
    }
}
