#include <stdio.h>
#include <string.h>
#include <assert.h>

int g[30][100], gc[30], gs[30], D[1048576][12], ga[30][12], P[1048576][12], o[20], oc;

const int allpos [12]={1, 0, 1, 0, 1, 1, 0, 1, 0, 1, 0, 1};
const char notes []="C?D?EF?G?A?B";



int main () {
  int n;

  freopen ("melody.in", "rt", stdin);
  freopen ("melody.out", "wt", stdout);

  scanf("%d", &n);

  for (int i=0; i<n; i++) {
    scanf ("%d", &gc[i]);
    for (int j=0; j<gc[i]; j++) {
      scanf ("%d", &g[i][j]);
      gs[i]+=g[i][j];
    };
  };

  for (int i=0; i<n; i++) gs[i]=(gs[i]+120000000)%12;

  for (int i=0; i<n; i++) {
    for (int j=0; j<12; j++)
      if (allpos[j]) {
        int cur=j, k;
        for (k=0; k<gc[i]; k++) {
          cur=(cur+g[i][k]+120000)%12;
          if (!allpos[cur]) break;
        };
        ga[i][j]=(k==gc[i]);
      };
  };

  for (int j=0; j<12; j++)
    if (allpos[j])
      D[0][j]=1;
  
  for (int i=0; i<(1<<n); i++)
    for (int l=0; l<12; l++) {
      if (D[i][l])
        for (int k=0; k<n; k++)
          if (!(i&(1<<k))&&ga[k][l]) {
            int c=l+gs[k];
            if (c>=12) c-=12;
            D[i|(1<<k)][c]=1;
            P[i|(1<<k)][c]=k;
          };
    };


  int mx=-1, mxi=-1, mxj=-1;
  for (int i=0; i<(1<<n); i++) {
    int j;
    for (j=0; j<12; j++)
      if (D[i][j]) break;
    if (j<12) {
      int c=i, e=0;
      while (c) {
        if (c&1) ++e;
        c>>=1;
      };
      if (e>mx) {
        mx=e;
        mxi=i;
        mxj=j;
      };
    };
  };

  fprintf (stderr, "%d %d %d\n", mx, mxi, mxj);

  while (mxi) {
    o[oc]=P[mxi][mxj]; 
    mxi&=~(1<<o[oc]);
    mxj-=gs[o[oc]];
    if (mxj<0) mxj+=12;
    ++oc;
  }; 

  assert (oc==mx);

  printf ("%d %c\n", mx, notes[mxj]);
  while (oc--) printf ("%d ", o[oc]+1);
};
