#define _CRT_SECURE_NO_DEPRECATE
#pragma comment (linker, "/STACK:30000000")
#include <string>
#include <vector>
#include <cmath>
#include <queue>
#include <map>
#include <set>
#include <algorithm>
#include <iostream>
#include <cstdio>
#include <cassert>
#include <utility>

using namespace std;

#define IN_FILE "bridge.in"
#define OUT_FILE "bridge.out"

#define EPS 1E-8
const int INF = (int)1E+9;

#define forn(i, n) for (int i = 0; i < (int)(n); ++i)
#define forv(i, v) for (int i = 0; i < (int)(v.size()); ++i)
#define fors(i, s) for (int i = 0; i < (int)(s.length()); ++i)
#define all(a) a.begin(), a.end()
#define pb push_back
#define PII pair<long long, long long>
#define mp make_pair
#define VI vector<long long>
#define VS vector<string>

int n, dx;
VI a;
map < pair<VI, int>, int > res;
map < pair<VI, int>, pair<VI, int> > par;
map < pair<VI, int>,int > hod;
pair<VI, int> bst;
set< pair<VI, int> > used;
queue< pair<VI, int> > q;
int ans;

void outdata() {
	if (ans < 1000000000) {
		cout << ans << endl;
	} else {
		cout << "No solution\n";
		return ;
	}
	VI resultat;
	while (bst != mp(a, 0)) {
//		cout << bst.second << endl;
//		forv(i, bst.first) cout << bst.first[i] << " ";
//		cout << endl;
		resultat.pb(hod[bst]);
		bst = par[bst];		
	}
	reverse(all(resultat));
	forv(i, resultat) cout << resultat[i] << " ";
	cout << endl;
}

void go(VI a, int cp) {
	int cd = res[mp(a, cp)];
	if (cp == n - 1) {
		if (ans > cd) {
			ans = cd;
			bst = mp(a, cp);
		}
		return ;
	}
   	for(int i = min(n - 1, cp + dx); i >= max(0, cp - dx); --i) {
   		if (a[i] == 1 && i != cp) {
   			VI b = a;
        	forn(j, n) {
        		if (j != i) {
        			b[j] = 1 - b[j];
        		}
        	}
   			if (used.count(mp(b, i)) == 0) {
   				used.insert(mp(b, i));
   				par[mp(b, i)] = mp(a, cp);
   				hod[mp(b, i)] = i - cp;
   				q.push(mp(b, i));
   				res[mp(b, i)] = cd + 1;
   			}
   		}
   	}
}

void readdata() {
	cin >> n >> dx;
	a.resize(n);
	forn(i, n) {
		cin >> a[i];
	}
}

int main() {
        freopen(IN_FILE, "rt", stdin);
        freopen(OUT_FILE, "wt", stdout);
        readdata();
		ans = INF;
		q.push(mp(a, 0));
		used.insert(mp(a, 0));
		res[mp(a, 0)] = 0;
        while(!q.empty()) {
        	go(q.front().first, q.front().second);
        	q.pop();
        }
        outdata();
        return 0;
}
