{$O-,Q+,R+}
uses SysUtils;

const MaxS=10000;
      MaxMN=200;

procedure readr (var x:integer; a, b:integer);
begin
  assert (not seekeoln); read (x); assert ((a<=x) and (x<=b));
end;

procedure readre (var x:extended; a, b:integer);
var t:integer;
begin
  readr (t, a, b); x:=t;
end;

procedure readl;
var c:char;
begin
  read (c); assert (c=#13); read (c); assert (c=#10);
end;

const eps=1e-12;
      inf=1e1000;

var w, h, z, i, j, n, m, gc:integer;
    x, y, u, v:array [1..MaxMN+1] of extended;
    g, gf, gd:array [1..2*MaxMN] of extended;
    maxy, maxv, md, mx, mxd, T, DEV, GMN, MNT:extended;


begin
  reset (input, 'guillotine.in');
  rewrite (output, 'guillotine.out');
  readr (w, 1, MaxS); readr (h, 1, MaxS); readr (z, 1, MaxS); readl;
  assert (z<w);
  readr (n, 2, MaxMN); readl;
  maxy:=0;
  for i:=1 to n do begin
    readre (x[i], 0, w); readre (y[i], 0, h); readl;
    if y[i]>maxy then maxy:=y[i];
  end;
  assert (x[1]=0); assert (x[n]=w); for i:=2 to n do assert (x[i]>x[i-1]);
  readr (m, 2, MaxMN); readl;
  maxv:=0;
  for i:=1 to m do begin
    readre (u[i], 0, z); readre (v[i], 0, h); readl; v[i]:=h-v[i];
    if v[i]>maxv then maxv:=v[i];
  end;
  assert (u[1]=0); assert (u[m]=z); for i:=2 to m do assert (u[i]>u[i-1]);
  assert (maxy+maxv<h);
  assert (eof);
  x[n+1]:=inf; u[m+1]:=inf;
  
  T:=0; GMN:=inf; MNT:=0;
  //create data info at <T>



  repeat
    i:=1; j:=1; gc:=0; md:=inf;
    while (j<=m) do begin
      if x[i]<u[j]+T-eps then begin
        if j>1 then begin
          inc (gc); g[gc]:=x[i]; 
          gd[gc]:=(v[j-1]-v[j])/(u[j]-u[j-1]);
          gf[gc]:=y[i]+v[j]+(u[j]+T-x[i])*gd[gc];
        end;
        inc (i);
      end else
      if x[i]>u[j]+T+eps then begin
        assert (i<=n);
        inc (gc); g[gc]:=u[j]+T;
        gd[gc]:=(y[i]-y[i-1])/(x[i]-x[i-1]);
        gf[gc]:=v[j]+y[i-1]+(u[j]+T-x[i-1])*gd[gc];
        DEV:=(x[i]-u[j]-T);
        if DEV<md then md:=DEV; //next event
        inc (j);
      end else {x[i]~=u[j]+T} begin
        if j>1 then begin
          inc (gc); g[gc]:=x[i];
          gd[gc]:=(v[j-1]-v[j])/(u[j]-u[j-1]); //left  <--
          gf[gc]:=v[j]+y[i];
        end;

        if i<n then begin
          inc (gc); g[gc]:=x[i];
          gd[gc]:=(y[i+1]-y[i])/(x[i+1]-x[i]); //right -->
          gf[gc]:=v[j]+y[i];
        end;
        inc (i); inc (j);
      end;
    end;
    // the list of points is created; now we are searching for the next event T
    // of type 2 (maximum change).

    mx:=-1; mxd:=-inf;
    for i:=1 to gc do 
      if (gf[i]>mx+eps) or (not (gf[i]<mx-eps) and (gd[i]>mxd)) then begin
        mx:=gf[i]; mxd:=gd[i];
      end;

    if mx<GMN then begin GMN:=mx; MNT:=T; end;

    if T-eps>w-z then break; //finish.
    
    for i:=1 to gc do 
      if gd[i]>mxd+eps then begin
        DEV:=(mx-gf[i])/(gd[i]-mxd);
        if DEV<md-eps then 
          md:=DEV;
      end;

    T:=T+md;
  until T>w-z+eps;
  writeln (MNT:0:20);
end.