#define _CRT_SECURE_NO_DEPRECATE

#include <set>
#include <vector>
#include <cstdio>
#include <utility>
#include <cassert>

#define VI vector<int>
#define mp make_pair
#define forn(i, n) for (int i = 0; i < (int)(n); ++i)

using namespace std;

VI weight;
VI num;
VI sumka;

set <pair<int, int> > a;
int n;

int main()
{
	freopen("hotel.in", "rt", stdin);
	freopen("hotel.out", "wt", stdout);
	scanf("%d", &n);
	weight.resize(n);
	forn (i, n) 
	{
		scanf("%d", &weight[i]);
		a.insert(mp(weight[i], i));
	}
	int k;
	scanf("%d", &k);
	num.resize(k);
	sumka.resize(k);
	forn (i, k)
	{
		int b;
		scanf("%d", &b);
		if (b > 0)
		{
			set <pair<int, int> > :: iterator ptr = a.lower_bound(mp(b, -2));
			if (ptr == a.end())
			{
				num[i] = -2;
				printf("%d\n", num[i] + 1);
				continue;
			}
			pair<int, int> toDel = *ptr;
			pair<int, int> toInsert = mp(ptr -> first - b, ptr -> second);
			num[i] = ptr -> second; 
			weight[ptr -> second] -= b;
			a.erase(toDel);
			a.insert(toInsert);
			printf("%d\n", num[i] + 1);
			sumka[i] = b;
		} else
		{
			b = -b - 4;
			printf("%d\n", num[b] + 1);
			if (num[b] == -2) continue;
			pair<int, int> toDel = mp(weight[num[b]], num[b]);
			pair<int, int> toInsert = mp(weight[num[b]] + sumka[b], num[b]);
			weight[num[b]] += sumka[b];
			a.erase(toDel);
			a.insert(toInsert);
			num[b] = -2;
		}
	}
	return 0;
}
