#define _CRT_SECURE_NO_DEPRECATE
#pragma comment (linker, "/STACK:30000000")
#include <string>
#include <vector>
#include <cmath>
#include <queue>
#include <set>
#include <map>
#include <algorithm>
#include <iostream>
#include <cstdio>
#include <cassert>
#include <utility>

using namespace std;

#define IN_FILE "rectangles.in"
#define OUT_FILE "rectangles.out"

#define x first
#define y second


#define EPS 1E-8
const int INF = (int)1E+9;

#define forn(i, n) for (int i = 0; i < (int)(n); ++i)
#define forv(i, v) for (int i = 0; i < (int)(v.size()); ++i)
#define fors(i, s) for (int i = 0; i < (int)(s.length()); ++i)
#define all(a) a.begin(), a.end()
#define pb push_back
#define PII pair<int, int>
#define mp make_pair
#define VI vector<int>
#define VS vector<string>

int n, m;
PII p[100000];

void outdata() {
}

void solve() {
	scanf("%d", &m);
	forn(ii, m) {
		int lx, ly, rx, ry;
		scanf("%d%d%d%d", &lx, &ly, &rx, &ry);
		int res = 0;
		forn(i, n) 
			if (lx <= p[i].x && ly <= p[i].y && p[i].x <= rx && p[i].y <= ry) ++res;
		printf("%d\n", res);
	}
}

void readdata() {
	scanf("%d", &n);
	assert(1 <= n && n <= 50000);
	forn(i, n) {
		int x, y;
		scanf("%d%d", &x, &y);
		assert(0 <= abs(x) && abs(x) <= (int)1E+9);
		assert(0 <= abs(y) && abs(y) <= (int)1E+9);
		p[i] = mp(x, y);
	}
}

int main() {
        freopen(IN_FILE, "rt", stdin);
        freopen(OUT_FILE, "wt", stdout);
        readdata();
        solve();
        outdata();
        return 0;
}

