#include <stdio.h>
#include <assert.h>
#include <string.h>
 



#define LLEN 100
#define BASE 10

typedef int lnum[LLEN];

void add (lnum a, lnum b, lnum c) {
  int cy=0;
  for (int i=0; i<LLEN; i++) {
    cy+=b[i]+c[i];
    if (cy>=BASE) {a[i]=cy-BASE; cy=1;}
              else{a[i]=cy; cy=0;};
  };
  assert (!cy);
};

void muls (lnum a, lnum b, int s) {
  int cy=0;
  for (int i=0; i<LLEN; i++) {
    cy+=b[i]*s;
    a[i]=cy%BASE;
    cy/=BASE;
  };
  assert (!cy);
};


void writel (lnum a) {
  int i;
  for (i=LLEN-1; i>0; i--)
    if (a[i]) break;
  for (int j=i; j>=0; j--)
    printf ("%d", a[j]);
  puts ("");
};

lnum c[51][51][51][2];


int main () {
  int ca, cb, ch, md;
  freopen ("roundtable.in", "rt", stdin);
  freopen ("roundtable.out", "wt", stdout);
  scanf ("%d %d %d %d", &ca, &cb, &ch, &md);
  c[0][ca-1][cb][0][0]=1;
  for (int cn=1; cn<ch; cn++) 
    for (int la=0; la<=ca; la++) 
      for (int lb=0; lb<=cb; lb++)
        for (int m=0; m<2; m++) {
          memcpy (c[cn][la][lb][m], c[cn-1][la][lb][m], sizeof (lnum));
          if (!m||cn<=ch-md) {
            add (c[cn][la][lb][m], c[cn][la][lb][m], c[cn-1][la+1-m][lb+m][m]);
            if (cn>=md) 
              add (c[cn][la][lb][m], c[cn][la][lb][m], c[cn-md][la+1-m][lb+m][1-m]);
          };
        };
  lnum res;
  add (res, c[ch-1][0][0][0], c[ch-1][0][0][1]);
  muls (res, res, ch);
  for (int a=1; a<=ca-1; a++) muls (res, res, a);
  for (int b=1; b<=cb; b++) muls (res, res, b);
  writel (res);
};