#include <iostream>
#include <vector>
#include <cassert>
#include <algorithm>

#define VI vector<int>

#define pb push_back
#define forn(i, n) for (int i = 0; i < (int)(n); ++i)
#define forv(i, v) for (int i = 0; i < (int)(v.size()); ++i)
#define all(x) x.begin(), x.end()

using namespace std;

struct segment
{
	int l;
	int r;
	int num;
    
    segment(int l, int r, int num)
    {
    	this -> l = l;
    	this -> r = r;
    	this -> num = num;
    }

    segment()
    {

    }

    bool operator < (const segment &a)
    {
    	return (this -> l < a.l);
    }
};

vector <segment> a;
VI nums;
vector<VI > stack;

int main()
{
	freopen("cloakroom.in", "rt", stdin);
	freopen("cloakroom.out", "wt", stdout);

	int n;
	scanf("%d", &n);

	a.resize(n);

	forn (i, n)
	{
		int l, r;
		scanf("%d %d", &l, &r);
		a[i] = segment(l, r, i + 1);
	}

	sort(all(a));

	int right = a[0].r;
	nums.pb(a[0].num);

	stack.pb(VI());

	for (int i = 1; i < a.size(); ++i)				
	{
		if (a[i].r < right)
			stack[nums.size() - 1].pb(a[i].num);
		else
		{
			right = a[i].r;
			nums.pb(a[i].num);
			stack.pb(VI());
		}
	}

	forv (i, nums) printf("%d ", nums[i]);
	reverse(all(stack));
	forv (i, stack)
	{
		reverse(all(stack[i]));
		forv (j, stack[i]) printf("%d ", stack[i][j]);
	}

	return 0;
}