#define _CRT_SECURE_NO_DEPRECATE
#pragma comment (linker, "/STACK:30000000")
#include <string>
#include <vector>
#include <cmath>
#include <queue>
#include <set>
#include <map>
#include <algorithm>
#include <iostream>
#include <cstdio>
#include <cassert>
#include <utility>

using namespace std;

#define IN_FILE "cloakroom.in"
#define OUT_FILE "cloakroom.out"

#define forn(i, n) for (int i = 0; i < (int)(n); ++i)
#define forv(i, v) for (int i = 0; i < (int)(v.size()); ++i)
#define fors(i, s) for (int i = 0; i < (int)(s.length()); ++i)
#define all(a) a.begin(), a.end()
#define pb push_back
#define PII pair<int, int>
#define mp make_pair
#define VI vector<int>
#define VS vector<string>

struct segm {
    int l, r, no;
    bool operator < (const segm & a) {
        return this->l < a.l;
    }
};

int n;
vector< segm > a;

vector< VI > res;
int r;

void out(int n) {
    if (n >= (int)res.size()) {
        return ;
    }
    printf("%d ", res[n][0] + 1);
    out(n + 1);
    reverse(res[n].begin() + 1, res[n].end());
    for(int i = 1; i < (int)res[n].size(); ++i) {
        printf("%d ", res[n][i] + 1);
    }
}

void outdata() {
    out(0);
}

void solve() {
    sort(all(a));
    r = -1;
    forn(i, n) {
        if (a[i].r > r) {
            r = a[i].r;
            VI c(1);
            c[0] = a[i].no;
            res.pb(c);
        } else {
            res.back().pb(a[i].no);
        }
    }
}

void readdata() {
    scanf("%d", &n);
    assert(1 <= n && n <= 200000);
    a.resize(n);
    forn(i, n) {
        scanf("%d%d", &a[i].l, &a[i].r);
        assert(1 <= a[i].l && a[i].l < a[i].r && a[i].r <= (int)1E+9);
    }
    forn(i, n) a[i].no = i;
}

int main() {
        freopen(IN_FILE, "rt", stdin);
        freopen(OUT_FILE, "wt", stdout);
        readdata();
        solve();
        outdata();
        return 0;
}
