{$I-,Q-,R-,S-,O+,H-}
{$I+,Q+,R+,S+,O-,H+}
{$apptype console}
{$M 1000000, 10000000}

uses Math, SysUtils;

const
  cInFile = 'office.in';
  cOutFile = 'office.out';

  inf = maxlongint shr 1;
  eps = 1e-8;

  nmax = 1000;
  mmax = 11000;
  lgmax = 17;

type
  int = longint;
  real = extended;

  rebro = record
    v, w : int;
    nx : int;
  end;

  line = array [0..nmax] of int;

var
  n, m, k : int;

  kans : int;
  ans : line;

  g : array [0..nmax] of int;
  kl : int;
  s : array [0..mmax * 2] of rebro;

  d : array [0..nmax] of line;
  gl : int;
  dp : line;
  v : line;

procedure OutData;
var
  i, j, x : int;
begin
  write(kans);
  for i:= 1 to kans - 1 do
    for j:= i + 1 to kans do
      if ans[i] > ans[j] then
      begin
        x:= ans[i];
        ans[i]:= ans[j];
        ans[j]:= x;
      end;
  for i:= 1 to kans do write(' ', ans[i]);
  writeln;
end;

procedure go(v, pr, wc : int);
var
  i, x : int;
begin
  inc(gl, wc);
  dp[v]:= gl;
  x:= g[v];
  while x <> 0 do
  begin
    if s[x].v <> pr then go(s[x].v, v, s[x].w);
    x:= s[x].nx;
  end;
  dec(gl, wc);
end;

function dist(vr : int) : int;
var
  i : int;
begin
  Result:= d[vr, v[1]];
  for i:= 2 to k do
    if Result < d[vr, v[i]] then
      Result:= d[vr, v[i]];
end;

procedure Solve;
var
  i, j, ii, tst : int;
  cdst, tmpdst : int;
begin
  for i:= 1 to n do
  begin
    go(i, 0, 0);
    d[i]:= dp;
  end;
  read(tst);
  for ii:= 1 to tst do
  begin
    read(k);
    for i:= 1 to k do read(v[i]);
    kans:= 1;
    ans[1]:= 1;
    cdst:= dist(1);
    for i:= 2 to n do
    begin
      tmpdst:= dist(i);
      if tmpdst < cdst then
      begin
        kans:= 1;
        ans[1]:= i;
        cdst:= tmpdst;
      end else
        if tmpdst = cdst then
        begin
          inc(kans);
          ans[kans]:= i;
        end;
    end;
    outdata;
  end;
end;

procedure push(x, y, z : int);
begin
  inc(kl);
  s[kl].v:= y;
  s[kl].w:= z;
  s[kl].nx:= g[x];
  g[x]:= kl;
end;

procedure ReadData;
var
  i, j : int;
  x, y, z : int;
begin
  kl:= 0;
  fillchar(g, sizeof(g), 0);
  read(n);
  assert((n <= 100000) and (n >= 1));
  for i:= 1 to n - 1 do
  begin
    read(x, y, z);
    assert((x > 0) and (x <= n));
    assert((y > 0) and (y <= n));
    assert((z > 0) and (z <= 100));
    push(x, y, z);
    push(y, x, z);
  end;
end;

begin
  assign(input,cinfile);
  assign(output,coutfile);
  reset(input);
  rewrite(output);
  ReadData;
  Solve;
  close(input);
  close(output);
end.
