{ Mugurel Ionut Andreica - Bucuresti, ROMANIA }

{ Complexitate: O(N) }

{
OBS: Considera in interiorul poligonului si punctele de
     pe laturi (deci si varfurile)
}

{$A+,B-,D+,E+,F-,G-,I-,L+,N+,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}
{$M 16384,0,655360}

Program Discrete_Volume;

type covect=array[1..10000] of longint;

var fin,fout:text;
    i,j,k,m,n,p,pmx,maxx,pmax,maxxy,pred,next,next2,mm:integer;
    xp,yp:^covect;
    minx,minxy,miny,sens,smn:longint;
    npp,npo,ndr,nst,ntot:longint;
    a1,b1,c1,a2,b2,c2:longint;
    start,first:boolean;

function semn(aa,bb,cc,xx,yy:longint):integer;
var rr:longint;
begin
rr:=aa*xx+bb*yy+cc;
if (rr>0) then semn:=1
else if rr<0 then semn:=-1
     else semn:=0;
end;

function cmmdc(a,b:longint):longint;
begin
if (a mod b=0) then cmmdc:=b
else cmmdc:=cmmdc(b,a mod b);
end;

function NPPL(xx1,yy1,xx2,yy2:longint):longint;
begin
if (xx1=xx2) then
  NPPL:=abs(yy2-yy1)+1
else
  if (yy1=yy2) then
    NPPL:=abs(xx2-xx1)+1
  else
    NPPL:=cmmdc(abs(xx2-xx1),abs(yy2-yy1))+1;
end;

function NPU(x1,y1,x2,y2:longint):longint;
var yy,ymin,ymax,dd,npel:longint;
begin
if (x2<x1) then
  begin
    yy:=x2; x2:=x1; x1:=yy;
    yy:=y2; y2:=y1; y1:=yy;
  end
else
  if (x1=x2) and (y1>y2) then
    begin
      yy:=y2; y2:=y1; y1:=yy;
    end;

if (x1=x2) then NPU:=y2+1
else
  if (y1=y2) then
    begin
      yy:=(x2-x1+1)*(y1+1);

      NPU:=yy;
    end
  else
    begin
      if (y1<y2) then
        begin
          ymin:=y1; ymax:=y2;
        end
      else
        begin
         ymin:=y2; ymax:=y1;
        end;


      yy:=ymin*(x2-x1+1)+((ymax-ymin+1)*(x2-x1+1)) div 2;

      yy:=yy-(NPPL(x1,y1,x2,y2) div 2);

      NPU:=yy+NPPL(x1,y1,x2,y2);
    end;
end;

begin
assign(fin,'POLY.IN');
reset(fin);
readln(fin,n);

new(xp); fillchar(xp^,sizeof(xp^),0);
new(yp); fillchar(yp^,sizeof(yp^),0);

minx:=maxlongint; pmx:=0; miny:=maxlongint;
maxx:=-minx; pmax:=0; maxxy:=-miny;

for i:=1 to n do
  begin
    readln(fin,xp^[i],yp^[i]);
    if (xp^[i]<minx) or
      ((xp^[i]=minx) and (yp^[i]<minxy)) then
      begin
        minx:=xp^[i]; minxy:=yp^[i];
        pmx:=i;
      end;

    if (xp^[i]>maxx) or
       ((xp^[i]=maxx) and (yp^[i]>maxxy)) then
       begin
         maxx:=xp^[i]; maxxy:=yp^[i];
         pmax:=i;
       end;

    if (yp^[i]<miny) then miny:=yp^[i];
  end;
close(fin);

for i:=1 to n do
  yp^[i]:=yp^[i]-miny;

pred:=pmx-1; if pred<1 then pred:=n;
next:=pmx+1; if pred>n then pred:=1;

a1:=yp^[pmx]-yp^[next];
b1:=xp^[next]-xp^[pmx];
c1:=xp^[pmx]*yp^[next]-xp^[next]*yp^[pmx];

p:=semn(a1,b1,c1,xp^[pred],yp^[pred]);
if p>0 then sens:=1
else sens:=-1;

npp:=0;

{ Lantul de jos }
i:=pmx; smn:=-1;

while (i<>pmax) do
  begin
    next:=i+sens;
    if (next>n) then next:=1;
    if (next<1) then next:=n;

    next2:=next+sens;
    if (next2>n) then next2:=1;
    if (next2<1) then next2:=n;

    while (xp^[next]=xp^[i]) and (xp^[next2]=xp^[next]) do
      begin
        next:=next+sens;
        if (next>n) then next:=1;
        if (next<1) then next:=n;

        next2:=next+sens;
        if (next2>n) then next2:=1;
        if (next2<1) then next2:=n;
      end;

    a1:=yp^[i]-yp^[next];
    b1:=xp^[next]-xp^[i];
    c1:=xp^[i]*yp^[next]-xp^[next]*yp^[i];

    if ((xp^[next2]>xp^[next]) and (smn=-1)) or
       ((xp^[next2]<xp^[next]) and (smn=1)) then
      begin
        npo:=NPU(xp^[i],yp^[i],xp^[next],yp^[next]);
        if (smn=-1) then
          begin
            npo:=npo-NPPL(xp^[i],yp^[i],xp^[next],yp^[next]);
            npo:=npo-yp^[next];
          end
        else
          begin
            npo:=npo-(yp^[next]+1);
          end;

        npp:=npp+smn*npo;

      end
    else
      begin
        npo:=NPU(xp^[i],yp^[i],xp^[next],yp^[next]);
        if (smn=-1) then
          npo:=npo-NPPL(xp^[i],yp^[i],xp^[next],yp^[next]);

        p:=semn(a1,b1,c1,xp^[next2],yp^[next2]);

        if (smn=-1) then
          begin
            if (p=-1) then
              begin
                npo:=npo+1;
              end
            else
              begin

              end;
          end
        else
          begin
            if (p=1) then
              begin

              end
            else
              begin
                npo:=npo-1;
              end;
          end;

        npp:=npp+smn*npo;
        smn:=-smn;
      end;

    i:=next;
  end;

{ END Lantul de jos }

{ Lantul de sus }
i:=pmx; smn:=+1;
sens:=-sens;

while (i<>pmax) do
  begin
    next:=i+sens;
    if (next>n) then next:=1;
    if (next<1) then next:=n;

    next2:=next+sens;
    if (next2>n) then next2:=1;
    if (next2<1) then next2:=n;

    while (xp^[next]=xp^[i]) and (xp^[next2]=xp^[next]) do
      begin
        next:=next+sens;
        if (next>n) then next:=1;
        if (next<1) then next:=n;

        next2:=next+sens;
        if (next2>n) then next2:=1;
        if (next2<1) then next2:=n;
      end;

    a1:=yp^[i]-yp^[next];
    b1:=xp^[next]-xp^[i];
    c1:=xp^[i]*yp^[next]-xp^[next]*yp^[i];

    if ((xp^[next2]>xp^[next]) and (smn=1)) or
       ((xp^[next2]<xp^[next]) and (smn=-1)) then
      begin
        npo:=NPU(xp^[i],yp^[i],xp^[next],yp^[next]);
        if (smn=-1) then
          begin
            npo:=npo-NPPL(xp^[i],yp^[i],xp^[next],yp^[next]);
            npo:=npo-yp^[next];
          end
        else
          begin
            npo:=npo-(yp^[next]+1);
          end;

        npp:=npp+smn*npo;

      end
    else
      begin
        npo:=NPU(xp^[i],yp^[i],xp^[next],yp^[next]);
        if (smn=-1) then
          npo:=npo-NPPL(xp^[i],yp^[i],xp^[next],yp^[next]);

        p:=semn(a1,b1,c1,xp^[next2],yp^[next2]);

        if (smn=-1) then
          begin
            if (p=1) then
              begin
                npo:=npo+1;
              end
            else
              begin

              end;
          end
        else
          begin
            if (p=-1) then
              begin

              end
            else
              begin
                npo:=npo-1;
              end;
          end;

        npp:=npp+smn*npo;
        smn:=-smn;
      end;

    i:=next;
  end;

{ END Lantul de sus }


assign(fout,'POLY.OUT');
rewrite(fout);
writeln(fout,npp);
close(fout);

end.