{ Mugurel Ionut Andreica - Bucuresti, ROMANIA }

{$A+,B-,D+,E+,F-,G-,I-,L+,N+,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}
{$M 16384,0,655360}

Program Discrete_Volume;

type covect=array[1..10000] of longint;

const eps:double=1e-5;

var fin,fout:text;
    i,j,k,m,n,p,pmx,pred,next,next2,mm:integer;
    xp,yp,a,b,c,np,seg:^covect;
    minx,minxy,miny,maxx,maxy,sens,smn:longint;
    npp,npo,ndr,nst,ntot,xx,yy,aa,bb,cc,xn,yn:longint;
    inside,okdr:boolean;
    xi,yi,d1,d2,d:double;

function semn(aa,bb,cc,xx,yy:longint):integer;
var rr:longint;
begin
rr:=aa*xx+bb*yy+cc;
if (rr>0) then semn:=1
else if rr<0 then semn:=-1
     else semn:=0;
end;

begin
randomize;

assign(fin,'POLY.IN');
reset(fin);
readln(fin,n);

new(xp); fillchar(xp^,sizeof(xp^),0);
new(yp); fillchar(yp^,sizeof(yp^),0);

minx:=maxlongint; pmx:=0; miny:=maxlongint;
maxx:=-maxlongint; maxy:=-maxlongint;

for i:=1 to n do
  begin
    readln(fin,xp^[i],yp^[i]);
    if (xp^[i]<minx) or
      ((xp^[i]=minx) and (yp^[i]<minxy)) then
      begin
        minx:=xp^[i]; minxy:=yp^[i];
        pmx:=i;
      end;

    if (yp^[i]<miny) then miny:=yp^[i];
    if (xp^[i]>maxx) then maxx:=xp^[i];
    if (yp^[i]>maxy) then maxy:=yp^[i];
  end;
close(fin);

for i:=1 to n do
  yp^[i]:=yp^[i]-miny;

maxy:=maxy-miny;
miny:=0;


new(a); fillchar(a^,sizeof(a^),0);
new(b); fillchar(b^,sizeof(b^),0);
new(c); fillchar(c^,sizeof(c^),0);

for i:=1 to n do
  begin
    next:=i+1; if next>n then next:=1;

    a^[i]:=yp^[i]-yp^[next];
    b^[i]:=xp^[next]-xp^[i];
    c^[i]:=xp^[i]*yp^[next]-xp^[next]*yp^[i];
  end;

npp:=0;
for xx:=minx to maxx do
  for yy:=miny to maxy do
    begin
      inside:=false;

      for i:=1 to n do
        begin
          next:=i+1; if next>n then next:=1;

          if (semn(a^[i],b^[i],c^[i],xx,yy)=0) and
             (
             (
             ((xx>=xp^[i]) and (xx<=xp^[next])) or
             ((xx<=xp^[i]) and (xx>=xp^[next]))
             ) and
             (
             ((yy>=yp^[i]) and (yy<=yp^[next])) or
             ((yy<=yp^[i]) and (yy>=yp^[next]))
             )
             )
          then
            begin
              inside:=true;
              break;
            end;
        end;

      if inside then
        begin
          inc(npp);
          continue;
        end;

      repeat
        okdr:=true;
        xn:=random(100)+10;
        yn:=random(100)+10;
        d:=sqrt((xn-xx)*(xn-xx) + (yn-yy)*(yn-yy));

        aa:=yy-yn;
        bb:=xn-xx;
        cc:=xx*yn-xn*yy;

        for i:=1 to n do
          if (semn(aa,bb,cc,xp^[i],yp^[i])=0) then
            begin
              okdr:=false;
              break;
            end;

        if (not okdr) then continue;

        npo:=0;
        for i:=1 to n do
          begin
            if (aa*b^[i]-a^[i]*bb<>0) then
              begin
                next:=i+1; if next>n then next:=1;

                xi:=(bb*c^[i]-b^[i]*cc)/(aa*b^[i]-a^[i]*bb);
                yi:=(cc*a^[i]-c^[i]*aa)/(aa*b^[i]-a^[i]*bb);

                d1:=sqrt((xi-xx)*(xi-xx) + (yi-yy)*(yi-yy));
                d2:=sqrt((xi-xn)*(xi-xn) + (yi-yn)*(yi-yn));

                if (abs(d1+d2-d)<=eps) or (d2<d1) then
                  begin
                    if (
                       (
                       (((xi>=xp^[i]) or (abs(xi-xp^[i])<=eps)) and
                        ((xi<=xp^[next]) or (abs(xi-xp^[next])<=eps))) or
                       (((xi<=xp^[i]) or (abs(xi-xp^[i])<=eps)) and
                        ((xi>=xp^[next]) or (abs(xi-xp^[next])<=eps)))
                       ) and
                       (
                       (((yi>=yp^[i]) or (abs(yi-yp^[i])<=eps)) and
                        ((yi<=yp^[next]) or (abs(yi-yp^[next])<=eps))) or
                       (((yi<=yp^[i]) or (abs(yi-yp^[i])<=eps)) and
                        ((yi>=yp^[next]) or (abs(yi-yp^[next])<=eps)))
                       )
                       ) then inc(npo);
                  end;
              end;
          end;
      until okdr;

      if (npo and 1=1) then inside:=true;

      if (inside) then
        inc(npp);

    end;

assign(fout,'POLY.OUT');
rewrite(fout);
writeln(fout,npp);
close(fout);

end.