program STROMY;
const
  MAXV = 10000;
var
  Vrcholu : Array[0..MAXV, 1..2] of Word; {Poty listov a nelistov
                                           jednotlivch hbok}
  V : Word;                    {Poet listov}
  Existuje : Boolean;          {Me zadan strom existova?}

procedure Vstup;
{Nata vstup zo sboru}
var
  Inp : Text;
  i, H : Word;
begin
  Assign(Inp, 'stromy.in');
  Reset(Inp);
  ReadLn(Inp, V);
  for i := 1 to V do begin
    Vrcholu[i,1] := 0;
    Vrcholu[i,2] := 0;
  end;
  for i := 1 to V do begin
    Read(Inp, H);
    if H >= V then begin
      Existuje := False;
      break;
    end;
    Inc(Vrcholu[H,1]);
  end;
  Close(Inp);
end;

procedure Vypis(Existuje : Boolean);
{Vype njden strom alebo sprvu, e neexistuje}
var
  Out : Text;
  i,j : Word;
begin
  Assign(Out, 'stromy.out');
  Rewrite(Out);
  if Existuje then
    for i := 0 to V-1 do begin
      for j := 1 to Vrcholu[i,2] do
        Write(Out, 'U');
      for j := 1 to Vrcholu[i,1] do
        Write(Out, 'L');
      WriteLn(Out);
    end
  else
    WriteLn(Out, 'Zodpovedajuci strom neexistuje.');
  Close(Out);
end;

function NajdiStrom : Boolean;
{Poksi se njs strom s danmi hbkami listov}
var
  i : Word;
begin
  {Prejdeme vetky mon hbky listov}
  for i := V-1 downto 0 do begin
    {Je poet vrcholov na nejakej rovni neprny?}
    if (Vrcholu[i+1,1] + Vrcholu[i+1,2]) mod 2 = 1 then begin
      Existuje := False;       {rove nad nami neme by korektn ...}
      break;
    end;
    {Pod kadm vrcholom visia vdy prve dva vrcholy}
    Vrcholu[i,2] := (Vrcholu[i+1,1] + Vrcholu[i+1,2]) div 2;
  end;
  {Je na prvej rovni viac ne jeden vrchol?}
  if Existuje and (Vrcholu[0,1] + Vrcholu[0,2] > 1) then
    Existuje := False;
end;

begin
  Existuje := True;
  Vstup;
  if Existuje then
    NajdiStrom;
  Vypis(Existuje);
end.
