program POSOL;
const
  MAXV = 100;                  {Maximlny poet miest}
type
  MestT = record
            Byl : Boolean;     {Navtvili sme u pri poslednom
                                prehedvan toto mesto}
            HC : Byte;         {Poet ciest z danho mesta}
            H : Array[1..MAXV] of  Byte;     {Susedia danho mesta}
            NepritelD : Byte;  {Vzdialenos od mesta obsadenho nepriateom}
          end;
  MestP = Array[1..MAXV] of Byte;   {Typ pre pole s slami miest}
var
  VC : Byte;                   {Poet miest}
  V : Array[1..MAXV] of MestT; {Jednotliv mest}
  NVC : Byte;                  {Poet miest obsadench nepriateom}
  NV : MestP;                  {sla miest obsadench nepriateom}
  Start, Cil : Byte;           {Poiaton a cieov mesto}

procedure Nacti;
var
  Inp : Text;
  i : Word;
  M : Word;                    {Poet vetkch existujcich ciest}
  A, B : Byte;                 {Poiaton a koncov mesto cesty}
begin
  Assign(Inp, 'posel.in');
  Reset(Inp);
  Read(Inp, VC);
  for i := 1 to VC do
    V[i].HC := 0;
  ReadLn(Inp, M);
  for i := 1 to M do begin
    ReadLn(Inp, A, B);
    {Pridme cestu k obom mestm}
    Inc(V[A].HC);
    V[A].H[V[A].HC] := B;
    Inc(V[B].HC);
    V[B].H[V[B].HC] := A;
  end;
  {Natame obsaden mest}
  ReadLn(Inp, NVC);
  for i := 1 to NVC do
    Read(Inp, NV[i]);
  {Nata poiaton a cieov mesto}
  Read(Inp, Start);
  ReadLn(Inp, Cil);
  Close(Inp);
end;

procedure NeprVzdal;
{Spota vzdialenos jednotlivch miest od nepriateskch}
var
  S, N : Byte;                 {Prv a posledn mesto v rade}
  F : Array[1..MAXV] of Byte;  {Rad miest}
  A : Byte;                    {Aktulne mesto}
  I : Byte;
begin
  {Inicializujeme hodnoty Byl}
  for i := 1 to VC do begin
    V[i].Byl := False;
    V[i].NepritelD := VC;
  end;
  N := 0;
  S := 1;
  {Naplnme rad nepriateskmi mestami}
  for i := 1 to NVC do begin
    Inc(N);
    F[N] := NV[i];
    V[NV[i]].Byl := True;
    V[NV[i]].NepritelD := 0;
  end;
  {Km je nieo v rade}
  while N >= S do begin
    A := F[S];
    Inc(S);
    for i := 1 to V[A].HC do begin
      if not V[V[A].H[i]].Byl then begin
        {Nastavme vzdialenos od nepriatea}
        V[V[A].H[i]].Byl := True;
        V[V[A].H[i]].NepritelD := V[A].NepritelD + 1;
        {Pridme mesto do radu}
        Inc(N);
        F[N] := V[A].H[i];
      end;
    end;
  end;
end;

function ZjistiMinVzdal : Byte;
{Zist, ako vzdialenos si dokeme udra od nepriatea}
var
  S : Array[1..MAXV] of Byte;  {Zaiatky jednotlivch radov}
  N : Array[1..MAXV] of Byte;  {Posledn mest v jednotlivch radoch}
  F : Array[1..MAXV, 1..MAXV] of Byte;  {Rady}
  A : Byte;                    {Aktulne mesto}
  ActD : Byte;                 {Aktulna vzdialenos od nepriatea}
  I : Byte;
begin
  for i := 1 to VC do begin
    S[i] := 1;
    N[i] := 0;
    V[i].Byl := False;
  end;
  {Ulome do radu poiaton mesto}
  Inc(N[V[Start].NepritelD]);
  F[V[Start].NepritelD,N[V[Start].NepritelD]] := Start;
  V[Start].Byl := True;
  {Prejdeme vetky mon vzdiaenosti}
  for ActD := V[Start].NepritelD downto 0 do begin
    {Km je vo fronte nieo na spracovanie}
    while S[ActD] <= N[ActD] do begin
      A := F[ActD,S[ActD]];
      if A = Cil then begin    {Nali sme cestu a do cieovho mesta?}
        ZjistiMinVzdal := ActD;
        break;
      end;
      Inc(S[ActD]);
      for i := 1 to V[A].HC do begin
        if not V[V[A].H[i]].Byl then begin  {Ete sme v tomto meste neboli?}
          V[V[A].H[i]].Byl := True;
          if V[V[A].H[i]].NepritelD >= ActD then begin 
                                            {Meme do neho vojs teraz?}
            {Pridme mesto do radu}
            Inc(N[ActD]);
            F[ActD,N[ActD]] := V[A].H[i];
          end
          else begin           {Do mesta teraz vstpi nememe}
            {Pridme ho do prslunho radu do budcna}
            Inc(N[V[V[A].H[i]].NepritelD]);
            F[V[V[A].H[i]].NepritelD,N[V[V[A].H[i]].NepritelD]] := V[A].H[i];
          end;
        end;
      end;
    end;
    if A = Cil then
      break;
  end;
end;

procedure VypisCestu(Prev : MestP);
{Vype njden trasu}
var
  A : Byte;                    {Aktulne mesto}
  Out : Text;
begin
  Assign(Out, 'posel.out');
  Rewrite(Out);
  {Prejdeme cel njden trasu}
  A := Start;
  while A <> Cil do begin
    Write(Out, A, ' ');
    A := Prev[A];
  end;
  WriteLn(Out, A);
  Close(Out);
end;

procedure NajdiCestu(D : Byte);
{Njde najkratiu trasu cez mest vzdialenosti aspo D}
var
  S, N : Byte;                 {Zaiatok a koniec radu}
  F : Array[1..MAXV] of Byte;  {Rad na mest}
  Prev : MestP;                {Mest, odkia sme prili}
  A : Byte;                    {Aktulne mesto}
  i : Byte;
begin
  for i := 1 to VC do
    V[i].Byl := False;
  {Zaradme poiaton mesto do radu}
  S := 1;
  N := 1;
  F[N] := Cil;
  V[Cil].Byl := True;
  Prev[Cil] := Cil;
  while S <= N do begin
    {Vyberieme mesto z radu}
    A := F[S];
    if A = Start then
      break;
    Inc(S);
    for i := 1 to V[A].HC do   {Prejdeme vtky cesty z mesta}
      {Ete sme v danom meste neboli a je dos aleko od nepriateov?}
      if (not V[V[A].H[i]].Byl) and (V[V[A].H[i]].NepritelD >= D) then begin
        {Zaradme mesto do radu}
        V[V[A].H[i]].Byl := True;
        Inc(N);
        F[N] := V[A].H[i];
        Prev[V[A].H[i]] := A;  {Poznamenme, odkia sme prili}
      end;
  end;
  VypisCestu(Prev);            {Vypeme njden cestu}
end;

begin
  Nacti;       {Nata vstup}
  NeprVzdal;   {Spota vzdialenosti od nepriatea}
  {Zist, ak vzdialenos dokeme ma od nepratea a njdeme najkratiu cestu}
  NajdiCestu(ZjistiMinVzdal);
end.
