program robot;          { P-II-2 }
const MAX=20;           { maximln rozmry tvercov st }
type policko = record
                x,y : word;
               end;
var sirka, vyska: word; { rozmry mstnosti }
    prekazky: array[1..MAX,1..MAX] of boolean;
                        { rozloen pekek v mstnosti }
    navstiveno, svisle, vodorovne: array[1..MAX,1..MAX] of boolean;
                        { indiktory navtven polek mstnosti }
    predchozi: array[1..MAX,1..MAX] of policko;
                        { pedchoz polko na optimln cest }
    start, cil: policko;
                        { poten a clov polko }
    fronta: array[1..MAX*MAX] of policko;
    zpracovano, vefronte: word;
                        { fronta prohledvn do ky }
    x, y: word; { pomocn promnn }
    i: integer;
procedure vypis( x, y: word);
 var x0, y0: word;
     k: integer;
 begin
  x0:=predchozi[x,y].x; { pedchoz polko na optimln cest }
  y0:=predchozi[x,y].y;
  if ( x0 = predchozi[x0,y0].x ) and ( y0 = predchozi[x0,y0].y )
    then begin
      { Jsme na potenm polku ... }
      if x0 < x then write('Program pro robota '
                          +'(poten natoen DOL):');
      if x0 > x then write('Program pro robota '
                          +'(poten natoen NAHORU):');
      if y0 < y then write('Program pro robota '
                          +'(poten natoen DOPRAVA):');
      if y0 > y then write('Program pro robota '
                          +'(poten natoen DOLEVA):');
    end
  else
    begin
      { Nejprve vypeme pedchoz polko
        a potom smr naeho otoen }
      vypis(x0,y0);
      k:=(x-x0)*(y0-predchozi[x0,y0].y)-
         (x0-predchozi[x0,y0].x)*(y-y0);
      if k > 0 then write(' <DOPRAVA>');
      if k < 0 then write(' <DOLEVA>');
    end;
  k:=x+y-x0-y0; { Spotme poet krok, kter je teba udlat }
  if k < 0 then k:=-k;
  while k > 0 do
    begin
      write(' <KROK>');
      dec(k)
    end
 end;
begin
  { Nateme rozmry st, pekky, poten a clov polko }
  readln(vyska,sirka);
  readln(start.x,start.y);
  readln(cil.x,cil.y);
  for x:= 1 to vyska do
    for y:= 1 to sirka do
      begin
        read(i);
        prekazky[x,y]:=(i=1);
        navstiveno[x,y]:=false;
        svisle[x,y]:=false;
        vodorovne[x,y]:=false;
      end;
  { Test na shodu potenho a clovho polka }
  if ( start.x = cil.x ) and ( start.y = cil.y ) then
    begin
      writeln('Poten a clov polko jsou stejn.');
      halt;
    end;
  { Inicializace prohledvn do ky }
  zpracovano:=0;
  vefronte:=1;
  fronta[1]:=start;
  navstiveno[start.x,start.y]:=true;
  predchozi[start.x,start.y]:=start;
  { Cyklus prohledvn do ky }
  while ( zpracovano < vefronte ) do
    begin
      inc(zpracovano);
      x:=fronta[zpracovano].x;
      y:=fronta[zpracovano].y;
      if not vodorovne[x,y] then
        begin
          { Projedeme s vodorovn ( dek ) }
          vodorovne[x,y]:=true;
          i:=1;
          while ( y+i <= sirka ) and not ( prekazky[x,y+i] ) do
            begin
              vodorovne[x,y+i]:=true;
              if not navstiveno[x,y+i] then
                begin
                  navstiveno[x,y+i]:=true;
                  predchozi[x,y+i]:=fronta[zpracovano];
                  inc(vefronte);
                  fronta[vefronte].x:=x;
                  fronta[vefronte].y:=y+i;
                end;
              inc(i);
            end;
          i:=-1;
          while ( y+i >= 1 ) and not ( prekazky[x,y+i] ) do
            begin
              vodorovne[x,y+i]:=true;
              if not navstiveno[x,y+i] then
                begin
                  navstiveno[x,y+i]:=true;
                  predchozi[x,y+i]:=fronta[zpracovano];
                  inc(vefronte);
                  fronta[vefronte].x:=x;
                  fronta[vefronte].y:=y+i;
                end;
              dec(i);
            end;
        end;
      if not svisle[x,y] then
        begin
          { Projedeme s svisle ( sloupeek ) }
          svisle[x,y]:=true;
          i:=1;
          while ( x+i <= vyska ) and not ( prekazky[x+i,y] ) do
            begin
              svisle[x+i,y]:=true;
              if not navstiveno[x+i,y] then
                begin
                  navstiveno[x+i,y]:=true;
                  predchozi[x+i,y]:=fronta[zpracovano];
                  inc(vefronte);
                  fronta[vefronte].x:=x+i;
                  fronta[vefronte].y:=y;
                end;
              inc(i);
            end;
          i:=-1;
          while ( x+i >= 1 ) and not ( prekazky[x+i,y] ) do
            begin
              svisle[x+i,y]:=true;
              if not navstiveno[x+i,y] then
                begin
                  navstiveno[x+i,y]:=true;
                  predchozi[x+i,y]:=fronta[zpracovano];
                  inc(vefronte);
                  fronta[vefronte].x:=x+i;
                  fronta[vefronte].y:=y;
                end;
              dec(i);
            end;
        end;
    end;
  if not navstiveno[cil.x,cil.y] then
    begin
      { Na clov polko se nelze dostat ... }
      writeln('Cesta z potenho na clov polko neexistuje.');
      halt
    end;
  { A vypeme nalezenou cestu ... }
  vypis(cil.x,cil.y);
  writeln;
end.

