program p_I_3;
const napriamke	= 0; napravo = 1; nalavo = 2; {smery}
      biela = 0; cierna = 1;                  {farby}
type bod = record x,y : longint; farba: integer; end;
var n : integer;          {poet bielych/iernych bodov}
    m : integer;                   {celkov poet bodov}
    a : array[1..1000] of bod;              {pole bodov}
     {pocet bielych a iernych bodov napravo do priamky}
    pocet :  array[biela..cierna] of integer;
    start : bod;              {tartovac bod triedenia}

function poloha(a, b : bod):integer;
{Zisti, kde je bod b vzhadom na priamku cez body (0,0),a}
var vektsucin : longint;
begin
   vektsucin := a.x * b.y - b.x * a.y;
   if vektsucin > 0 then poloha := nalavo
   else if vektsucin < 0 then poloha := napravo
   else poloha := napriamke
end; {poloha}

function mensi(var a, b : bod):boolean;
{Vrti, i bod a je men ako bod b v naom usporiadan}
var pol1, pol2, pol3 : integer;
begin
   pol1 := poloha(start, a); 
   pol2 := poloha(start, b);
   pol3 := poloha(a, b);
   mensi := (pol1 < pol2) or ((pol1 = pol2) and (pol3=napravo));
end; {mensi}

procedure tried;
{Utriedi body pomocou porovnania "mensi"}
var i, j, min : integer;
   pom : bod;
begin
   for i := 1 to m-1 do begin
      min := i;                    {njdi minimum v a[i..m]}
      for j := i+1 to m do begin
	 if mensi(a[j], a[min]) then min := j;
      end;
      {ulo minimum do a[i]}
      pom := a[i]; a[i] := a[min]; a[min] := pom;
   end;
end; {tried}

procedure nacitaj;
{Nata dta zo sboru}
var t : text;
   i  : integer;
begin
   assign(t,'priamka.in');   {otvor sbor}
   reset(t);
   read(t,n);         {poet bielych/iernych bodov}
   m := 2*n;          {celkov poet bodov}
   for i := 1 to m do begin {taj body}
      read(t, a[i].x, a[i].y);
      if i <= n then a[i].farba := biela
      else a[i].farba := cierna;
   end;
   close(t);          {zavri sbor} 
end; {nacitaj}

function prva_priamka:integer;
{Njdi priamku idcu tesne pred bod a[1],
 vr posledn bod napravo, inicializuj pole pocet}
var i : integer;
begin
   pocet[biela] := 0;   {vynuluj poty}
   pocet[cierna] := 0;
   i := 1;              {km sme napravo, zvyuj pole pocet}
   while (i <= m) and (poloha(a[1], a[i]) in [napravo, napriamke]) do begin
      pocet[a[i].farba] := pocet[a[i].farba] + 1;
      i := i+1;
   end;
   prva_priamka := i-1;
end; {prva_priamka}

function dalsia_priamka(i, j :integer) :integer;
{Posunie priamku spred bodu a[i-1] pred bod a[i]}
var koniec : boolean;
    stare_j :  integer;
begin
   {a[i-1] sa posunie doava - odtaj ho} 
   pocet[a[i-1].farba] := pocet[a[i-1].farba] - 1;
   koniec := false;
   repeat     {pritaj body, ktor sa posun doprava}
      stare_j := j;
      j := j+1;   
      if j > m then j := 1;
      if (poloha(a[i], a[j]) in [napravo, napriamke]) then begin
	 pocet[a[j].farba] := pocet[a[j].farba] + 1;
      end
      else koniec := true;
   until koniec or (j = i);
   dalsia_priamka := stare_j;   
end; {dalsia_priamka}

procedure vypis(i, j :integer);
{Vype vsledok do sboru}
var t : text;
    b1, b2 : bod;
begin
   {b1 je a[i] premietnut poda (0,0)}
   b1.x := -a[j].x; b1.y := -a[j].y;
   {b2 je posledn bod pred a[i]}
   if i > 1 then b2 := a[i-1]
   else b2 := a[m];
   {njdi ten z b1, b2, ktor je viac vpravo}
   if (poloha(a[i],b2) = nalavo) and (poloha(b1,b2) = napravo) then
      b1:=b2;
   
   assign(t,'priamka.out');    {otvor sbor}
   rewrite(t);
   {vsledn bod je stred seky medzi a[i] a b1}
   writeln(t, (a[i].x+b1.x)/2.0:0:1, ' ', (a[i].y+b1.y)/2.0:0:1);
   close(t);            {zatvor sbor} 
end; {vypis}

var i,j:integer;
begin {hlavn program}
   nacitaj;      {nataj vstup}
   start:=a[1];  {od tohoto bodu zaneme triedi}
   tried;        {utrie proti smeru hodinovch ruiiek}
   i:=1; j:=prva_priamka;  {njdi prv priamku}
   {km nenjde o potrebuje, skaj aliu priamku}
   while pocet[biela]<>n-pocet[cierna] do begin
      i:=i+1;
      j:=dalsia_priamka(i,j);
   end;
   vypis(i,j);   {vyp do vstupnho sboru}
end.
