program P_III_1;
var a : array [1..100,1..100] of integer;
       { Matica A. Predpokladme, e olky s reprezentovan ako -1 }
    n, m : integer; { Rozmery matice A }
    sig : array [1..100] of integer; { Signatra poslednho stpca }
    stlpec : array [1..100] of integer; { Pomocn pole na jeden stpec }
procedure nacitaj;
var i, j : integer;
begin
   readln(m, n);   { nataj rozmery }
   for i := 1 to m do   { nataj maticu }
      for j := 1 to n do
	 read(a[i,j]);
end; { nacitaj }

procedure tried(k : integer);
{ Utriedi k-ty stpec matice. Pre sporu miesta pouijeme
  kvadratick triedenie, mono nahradi n log n triedenm.
  olky (reprezentovan -1) bud navrchu. }
var i, j, min, pom : integer;
begin
   for i := 1 to m-1 do begin
      min := i;    { njdi minimum v neutriedenej asti stpca }
      for j := i+1 to m do begin
         if a[j,k] < a[min,k] then min := j;
      end;
      { vyme a[i,k] a a[min,k] }
      pom := a[i,k]; a[i,k] := a[min,k]; a[min,k] := pom;
   end; 
end; { tried }

procedure vypis;
var i, j : integer;
begin
   for i := 1 to m do begin
      for j := 1 to n do
	 write(' ',a[i][j]);
      writeln;   { ukoni riadok i }  
   end;
end;

var i, k, pouzi : integer;
begin  { hlavn program }
   nacitaj;    { vstup }
   for i := 1 to m do sig[i] := 0; { inicializuj signatru }
   for k := 1 to n do begin { pre vetky stpce }
      tried(k);   { utrie stpec }
      pouzi := m;   { posledn nepouit slo }
      { ukladaj sla odspodu do pomocnho poa "stlpec" } 
      for i := m downto 1 do begin  
	 if a[pouzi][k] >= sig[i] then begin
	    stlpec[i] := a[pouzi][k];
	    pouzi := pouzi-1;
	 end
	 else stlpec[i] := -1; { ak sa ned poui slo, poui olk }
      end;
      { ak zostali nepouit sla, nemono usporiada }
      if (pouzi >= 1) and (a[pouzi][k] <> -1) then begin
	 writeln('Maticu nemozno usporiadat');
	 exit;
      end;
      { skopruj pomocn pole sp do matice a prepotaj signatru }
      for i := 1 to m do begin
	 a[i][k] := stlpec[i];
	 if stlpec[i] <> -1 then sig[i] := stlpec[i]
      end;
   end;
   vypis; { vpis matice }
end.