/* Mircea Digulescu - Bucuresti, ROMANIA */

/* Score: 90% */

#include <fstream.h>

ifstream in("centru.in");
ofstream out("centru.out");

#define MAX 16005

int n;

struct node
 {
  int i;
  node *next;
 } *fii[MAX];

inline void QADD(int i, int j)
 {
  node *t=new node;
  t->i=j;t->next=fii[i];
  fii[i]=t;
  t=new node;
  t->i=i;t->next=fii[j];
  fii[j]=t;
 }

int max1[MAX];
int fiu1[MAX];
int max2[MAX];

void Post(int i, int p=-1)
 {
  node *t=fii[i];
  if(!t) {max1[i]=1;return;}
  while(t)
   {
    if(t->i!=p)
     {
      Post(t->i,i);
      if(max1[t->i]+1 > max1[i])
       {
	max2[i] = max1[i];
	max1[i] = max1[t->i]+1;
	fiu1[i]=t->i;
       }
      else if(max1[t->i]+1 > max2[i])
       {
	max2[i]=max1[t->i]+1;
       }
     }
    t=t->next;
   }
 }

void Pre(int i, int p=-1)
 {
  node *t=fii[i];
  if(p!=-1)
   {
    if(fiu1[p]!=i)
      if(max1[p]+1>max1[i])
     {
      max2[i] = max1[i];
      max1[i] = max1[p]+1; fiu1[i]=p;
     }
      else if(max1[p]+1>max2[i])
     {
      max2[i] = max1[p]+1;
     }     else;
   else
    if(max2[p]+1>max1[i])
     {
      max2[i] = max1[i];
      max1[i] = max2[p]+1; fiu1[i]=p;
     }
      else if(max2[p]+1>max2[i])
     {
      max2[i] = max2[p]+1;
     }
   }
  while(t)
   {
    if(t->i!=p) Pre(t->i,i);
    t=t->next;
   }
 }

int main()
 {
  in>>n;
  int a,b,i;
  for(i=1;i<n;i++)
   {
    in>>a>>b;a--;b--;
    QADD(a,b);
   }
  Post(0);
  Pre(0);
  int mx=n+2,c=0;
  for(i=0;i<n;i++) if(max1[i]==mx) c++;
		   else if(max1[i]<mx) {c=1;mx=max1[i];}
  out<<c<<'\n';
  for(i=0;i<n;i++) if(max1[i]==mx) out<<i+1<<' ';
  return 0;
 }