// O(N^2)

#include <stdio.h>

#define NMAX 5010
#define INF 666666666

int A[NMAX], lmax[NMAX], lmin[NMAX];
int i, j, k, N, vmax;

int main()
{
	freopen("scmm.in", "r", stdin);

	scanf("%d", &N);

	for (i = 1; i <= N; i++)
	{
		scanf("%d", &A[i]);
		lmin[i] = INF;
		lmax[i] = 0;
	}

	N++;
	A[N] = INF;
	lmin[N] = INF;
	lmax[N] = 0;

	lmin[1] = lmax[1] = 1;

	for (i = 2; i <= N; i++)
	{
		vmax = -INF;

		for (j = i - 1; j >= 1; j--)
		{
			if (A[j] <= A[i] && lmax[j] > lmax[i])
				lmax[i] = lmax[j];

			if (A[j] > vmax && A[j] <= A[i])
			{
				if (lmin[j] < lmin[i])
					lmin[i] = lmin[j];

				vmax = A[j];
			}
		}

		if (lmin[i] == INF)
			lmin[i] = 0;

		lmin[i]++;
		lmax[i]++;
	}

	for (i = N; i <= N; i++)
	{
		fprintf(stderr, "%d -> val=%d, lmin=%d, lmax=%d\n", i, A[i], lmin[i], lmax[i]);
	}

	freopen("scmm.out", "w", stdout);
	printf("%d\n", lmin[N] - 1);

	return 0;
}
