// O(N^3)

#include <stdio.h>

#define NMAX 5010
#define INF 666666666

int A[NMAX], lmin[NMAX];
int i, j, k, N, ok;

int main()
{
	freopen("scmm.in", "r", stdin);

	scanf("%d", &N);

	for (i = 1; i <= N; i++)
	{
		scanf("%d", &A[i]);
		lmin[i] = INF;
	}

	N++;
	A[N] = INF;
	lmin[N] = INF;

	lmin[1] = 1;

	for (i = 2; i <= N; i++)
	{
		for (j = i - 1; j >= 1; j--)
			if (A[j] <= A[i] && lmin[j] < lmin[i])
			{
				ok = 1;

				for (k = j + 1; k < i && ok; k++)
					if (A[j] <= A[k] && A[k] <= A[i])
						ok = 0;

				if (ok)
					lmin[i] = lmin[j];
			}

		if (lmin[i] == INF)
			lmin[i] = 0;

		lmin[i]++;
	}

	fprintf(stderr, "%d\n", lmin[N] - 1);

	freopen("scmm.out", "w", stdout);
	printf("%d\n", lmin[N] - 1);

	return 0;
}
