// Mugurel Ionut Andreica - Bucuresti, ROMANIA

#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#define MAXN 111
#define INF 666

char edge[MAXN][MAXN];
long ntracks[MAXN][MAXN],nsol;
int i,j,ii,jj,k,m,n,nq,po,dmin,nok,queue[MAXN+1],dist[MAXN+1],stack[2*MAXN+1];

int main()
{
freopen("traseu.in","rt",stdin);
freopen("traseu.out","wt",stdout);
scanf("%d %d %d %d",&n,&m,&i,&j);

memset(edge,0,sizeof(edge));
for (k=1;k<=m;k++)
  {
  scanf("%d %d",&ii,&jj);
  edge[ii][jj]=edge[jj][ii]=1;
  }

for (ii = 1; ii <= n; ii++)
  dist[ii] = INF;
  
dist[i]=0;
queue[po=nq=1]=i;

while (po<=nq)
  {
  ii=queue[po];

  for (jj=1;jj<=n;jj++)
    if ((edge[ii][jj]) && (dist[jj]==INF))
      dist[queue[++nq]=jj]=dist[ii]+1;
  po++;
  }

printf("%d\n",dmin=dist[1]+dist[j]);

m=dist[1]>dist[j]?dist[1]:dist[j];

memset(ntracks,0,sizeof(ntracks));
ntracks[i][0]=1;

for (k=1;k<=m;k++)
  {
  for (ii=1;ii<=n;ii++)
    for (jj=1;jj<=n;jj++)
      if (edge[ii][jj])
       ntracks[ii][k]+=ntracks[jj][k-1];
  }

nsol=ntracks[1][dist[1]]*ntracks[j][dist[j]];
printf("%ld\n",nsol);

return 0;
}