#include <stdio.h>
#include <math.h>

#define eps 1e-7

int main()
{
	int Q;
	double a, b, c, delta;

	//freopen("e.in", "r", stdin);

	scanf("%d", &Q);

	while (Q--)
	{
		scanf("%lf %lf %lf", &a, &b, &c);

		if (fabs(a) < eps) // a == 0
		{
			if (fabs(b) < eps) // b == 0
			{
				if (fabs(c) < eps) // c == 0
					printf("INF\n");
				else
					printf("0\n");
			}
			else
				printf("1\n");
		}
		else
		{
			delta = b*b-4.0*a*c;

			if (fabs(delta) < eps) // delta == 0
				printf("1\n");
			else // delta != 0
			if (delta < 0)
				printf("0\n");
			else
				printf("2\n");
		}
	}

	return 0;
}