#include <stdio.h>
#include <string.h>

#define LMAX 1048576

char s[2][LMAX];
int i, j, l[2], dif, l1, lmin, unu, doi;

int main()
{
	int T;
	char t[100];

	freopen("f.in", "r", stdin);

	fgets(t, 100, stdin);
	sscanf(t, "%d", &T);

	while (T--)
	{
		fgets(s[0], LMAX - 1, stdin);
		fgets(s[1], LMAX - 1, stdin);

		l[0] = strlen(s[0]);
		s[0][l[0] - 1] = 0;
		l[0]--;

		l[1] = strlen(s[1]);
		s[1][l[1] - 1] = 0;
		l[1]--;

		if (l[0] <= l[1])
			unu = 0, doi = 1;
		else
			unu = 1, doi = 0;

		dif = l[doi] - l[unu];

		for (i = 0; i <= dif; i++)
			if (!strncmp(s[unu], s[doi] + i, l[unu]))
			{
				// s1[unu] is located inside s[doi]
				printf("%d\n", l[doi]);
				fprintf(stderr, "s%d is located inside s%d\n", unu + 1, doi + 1);

				break;
			}

		if (i > dif) // s[unu] is not located inside s[doi]
		{
			lmin = l[unu] + l[doi];

			// try to place s[doi] after s[1]

			for (i = 1; i < l[unu]; i++)
				if (!strncmp(s[unu] + i, s[doi], l[unu] - i))
				{
					// a prefix of s[doi] matches a suffix of s[unu]

					if (l[doi] + i < lmin)
						lmin = l[doi] + i;

					fprintf(stderr, "a prefix of s%d matches a suffix of s%d -> l=%d\n", doi + 1, unu + 1, l[doi] + i);

					break;
				}

			// try to place s[unu] after s[doi]

			for (i = dif + 1; i < l[doi] && l[unu] + i < lmin; i++)
				if (!strncmp(s[unu], s[doi] + i, l[doi] - i))
				{
					// a prefix of s[unu] matches a suffix of s[doi]

					if (l[unu] + i < lmin)
						lmin = l[unu] + i;

					fprintf(stderr, "a prefix of s%d matches a suffix of s%d -> l=%d\n", unu + 1, doi + 1, l[unu] + i);

					break;
				}

			printf("%d\n", lmin);
		}
	}

	return 0;
}
