Const
  MAX = 50;
Var
  n: Integer;
  rings: Array[0..MAX-1] Of Integer;

Procedure ReadInput;
Var
  i: Integer;
Begin
  Assign(input, 'Necklace.in');
  Reset(input);
  Read(n);
  For i := 0 To n-1 do
    Read(rings[i]);

  Close(input);
End;

Function Swap(x, y: Integer): Boolean;
Var
  rx, ry: Integer;
Begin
  x := x Mod n;
  y := y Mod n;
  rx := rings[x];
  ry := rings[y];

  If (ry-rx > 1) Then
    Begin
      rings[x] := ry;
      rings[y] := rx;
      WriteLn(rx, ' ', ry);
      Swap := True;
    End
  Else
    Swap := False;
End;

Procedure Solve;
Var
  terminate: Boolean;
  i: Integer;
Begin
  Assign(output, 'Necklace.out');
  Rewrite(output);
  terminate := false;
  While (Not(terminate)) Do
    Begin
      terminate := True;
      For i := 1 To n do
        If (Swap(i, i+1)) Then
          terminate := False;
    End;
  WriteLn(0);
  Close(output);
End;

Begin
  ReadInput;
  Solve;
End.