uses
  SysUtils;

const
  base = 10;

type
  int = longint;

var
  n, k, i: int;
  s, t: string;
  intpart, rest: int;
  period, per: int;
  were: array[0..9] of int;
  first, zero, minim: boolean;

begin
  reset(input, 'numbers.in');
  rewrite(output, 'numbers.out');
{}while not seekeof do begin
  read(n, k);

  s := '.';
  intpart := n div k;
  while (intpart > 0) do
  begin
    s := inttostr(intpart mod base) + s;
    intpart := intpart div base;
  end;
  if (s = '.') then
    s := '0.';
  rest := n mod k;
  i := 0;
  period := 0;
  fillchar(were, sizeof(were), 0);
  while (rest > 0) do
  begin
    inc(i);
    if (were[rest] > 0) then
    begin
      period := i - were[rest];
      break;
    end;
    were[rest] := i;
    rest := rest * base;
    s := s + inttostr(rest div k);
    rest := rest mod k;
  end;
  first := true;
  write(n, ' = ');
  repeat
    zero := true;
    t := '';
    for i := 1 to length(s) do
    begin
      if (s[i] in ['1'..'9']) then
      begin
        t := t + inttostr(k);
        dec(s[i]);
        zero := false;
      end
      else
        t := t + s[i];
    end;
    if zero then
      break;
    if first then
      first := false
    else
      write(' + ');
    while (s[1] = '0') and (s[2] <> '.') do
      s := copy(s, 2, length(s));
    while (t[1] = '0') and (t[2] <> '.') do
      t := copy(t, 2, length(t));
    if (period > 0) then
    begin
      minim := false;
      for per := 1 to period div 2 do if (period mod per = 0) then
      begin
        minim := true;
        for i := length(t) downto length(t) - period + per + 1 do
        begin
          if (t[i] <> t[i - per]) then
          begin
            minim := false;
            break;
          end;
        end;
        if minim then
        begin
          setlength(t, length(t) - period + per);
          break;
        end;
      end;
      if not minim then
        per := period;
      while (t[length(t) - per] = t[length(t)]) do
        setlength(t, length(t) - 1);
      if (per > 1) or (t[length(t)] <> '0') then
      begin
        write(copy(t, 1, length(t) - per), '(', copy(t, length(t) - per + 1, length(t)), ')');
        continue;
      end;
      setlength(t, length(t) - per);
    end;
    while (t[length(t)] = '0') do
      setlength(t, length(t) - 1);
    if (t[length(t)] = '.') then
      setlength(t, length(t) - 1);
    write(t);
  until false;
  writeln;
{}end;
end.
