const
    max_c = 50;
    max_k = 20;
    max_n = 50;

var
    c: array [-1..max_c - 1, -1..max_c - 1] of longint;
    a: array [1..max_k, 1..max_k] of boolean;
    m: array [1..max_n, 1..max_k] of boolean;
    u, v: array [0..1 shl max_k - 1] of boolean;
    w: array [1..max_k] of longint;
    x, y: array [1..max_k] of longint;
    i, j, n, t: longint;
    x1, y1, x2, y2: array [1..max_n] of longint;
    q: longint;
    ai, aj: longint;

function calc(p: longint): boolean;
var
    i, j, c: longint;
begin
    if not u[p] then begin
        u[p] := true;
        v[p] := false;
        for i := 1 to q do if (p and w[i] <> 0) then begin
            c := 0;
            for j := 1 to q do if a[i][j] and (p and w[j] <> 0) then begin
                if not calc(p xor w[j] xor w[i]) then begin
                    v[p] := true;
                    ai := i;
                    aj := j;
                    break;
                end;
                inc(c);
            end;
            if not v[p] and (c <> 4) then begin
                if not calc(p xor w[i]) then begin
                    v[p] := true;
                    ai := i;
                    aj := 0;
                end;
            end;
            if v[p] then break;
        end;
    end;
    calc := v[p];
end;

var
    ans: longint;
    f: boolean;
begin
    assign(input, 'net.in'); reset(input);
    assign(output, 'net.out'); rewrite(output);

    read(n);
    for i := 1 to n do begin
        read(x1[i], y1[i], x2[i], y2[i]);
        if x1[i] > x2[i] then begin
            t := x1[i]; x1[i] := x2[i]; x2[i] := t;
        end;
        if y1[i] > y2[i] then begin
            t := y1[i]; y1[i] := y2[i]; y2[i] := t;
        end;
        inc(c[x1[i]][y1[i]]);
        if (x1[i] <> x2[i]) then begin
            inc(c[x1[i]][y1[i] - 1]);
        end else begin
            inc(c[x1[i] - 1][y1[i]]);
        end;
    end;

    q := 0;
    for i := low(c) to high(c) do begin
        for j := low(c[i]) to high(c[j]) do begin
            if c[i][j] = 4 then begin
                inc(q);
                x[q] := i;
                y[q] := j;
            end;
        end;
    end;

    for i := 1 to q do begin
        w[i] := 1 shl (i - 1);
    end;

    for i := 1 to q do begin
        for j := 1 to q do begin
            a[i][j] := abs(x[i] - x[j]) + abs(y[i] - y[j]) = 1;
        end;
    end;

    for i := 1 to n do begin
        for j := 1 to q do begin
            m[i][j] := (x1[i] = x[j]) and (y1[i] = y[j]) or (x2[i] = x[j] + 1) and (y2[i] = y[j] + 1);
        end;
    end;

    if (calc(1 shl q - 1)) then begin
        writeln(1);
        ans := 0;
        if aj = 0 then begin
            for i := 1 to n do if m[i][ai] then begin
                f := true;
                for j := 1 to q do begin
                    f := f and ((ai = j) or not m[i][j]);
                end;
                if f then begin
                    ans := i;
                end;
            end;
        end else begin
            for i := 1 to n do begin
                if m[i][ai] and m[i][aj] then begin
                    ans := i;
                end;
            end;
        end;
        writeln(ans);
    end else begin
        writeln(2);
    end;

    close(input);
    close(output);
end.