#include <stdio.h>
#include <memory.h>
#include <math.h>
#include <malloc.h>

#define FILE_IN "stalker.in"
#define FILE_OUT "stalker.out"
#define MAXN 2005
#define MAXK 2005


struct node{
    node * next;
    node * prev;
    int b;
};

struct elem{
    int n,k;
};


int a[MAXN];
int na=0;
int n,k;
int g[MAXN];
node * r[MAXN][MAXK];
node * rk[MAXN];
node * p,*q;
bool b[MAXN][MAXK]; 
elem query[MAXK*MAXN];
int qs=0;
node * dr[MAXN][MAXK];
bool ia[MAXN];
int ba[MAXN];
bool iaa[MAXN];
    
void bfs(int n,int k,int t){
    node * p;
    p=r[n][k];
    while (p!=NULL) {
        if (ba[p->b]!=t && !iaa[p->b]) {
            g[p->b]=g[n];
            ba[p->b]=t;
            bfs(p->b,k,t);
            if (!ia[p->b]) {
                a[na++]=p->b;           
                ia[p->b]=true;
            }
        }
        if (dr[n][k]->prev!=NULL) {
            dr[n][k]->prev->next=dr[n][k]->next;
        } else {
            rk[n]=dr[n][k]->next;
        }        
        p=p->next;
    }
	r[n][k]=NULL;
    if (!ia[n]) {
        a[na++]=n;      
        ia[n]=true;
        
    }
}


void memet(void * a,int x,int b){
	int i;
	for (i=0;i<b;i++) {
		memset();
	}
}

int main(){
    printf("%lf\n",(double)sizeof(node*)*2*2005*2005/1024/1024);
	printf("%lf\n",(double)sizeof(elem)*2005*2005/1024/1024);
	printf("%lf\n",(double)sizeof(bool)*2*2005*2005/1024/1024);
	printf("%d\n",sizeof(node));

	freopen(FILE_IN,"r",stdin);
    freopen(FILE_OUT,"w",stdout);

    //data
    
	memet(b,0,sizeof(bool)*MAXN*MAXK);
    memet(g,0,sizeof(int)*MAXN);
    memet(ia,0,sizeof(bool)*MAXN);
    memet(ba,0,sizeof(int)*MAXN);
	memet(iaa,0,sizeof(bool)*MAXN);

	return 0;


    
    //input
    scanf("%d %d",&n,&k);   

    int i,j;

    for (i=0;i<n;i++)
        for (j=0;j<k;j++){
            r[i][j]=NULL;
        }

    int ri,ra,rb;


    for (i=0;i<k;i++) {
        scanf("%d",&ri);
        for (j=0;j<ri;j++) {
            scanf("%d %d",&ra,&rb);
            ra--;
            rb--;

            p=new node;			
            p->b=rb;
            p->next=r[ra][i];
            r[ra][i]=p;

            p=new node;			
            p->b=ra;
            p->next=r[rb][i];
            r[rb][i]=p;
        }
    }

    for (i=0;i<n;i++) {             
        rk[i]=NULL;
        for (j=k-1;j>=0;j--) {
            if (r[i][j]!=NULL) {
                p=new node;
                p->b=j;
                p->next=rk[i];
                if (rk[i]!=NULL) {
                    rk[i]->prev=p;
                }
                p->prev=NULL;
                rk[i]=p;
                dr[i][j]=p;
            }           
        }
    }

    
	//solve
    
    a[na++]=0;
    g[0]=1;
    int t=0;
	ia[0]=true;
	

    for (;na>0;) {      
        
        qs=0;
        for (i=0;i<na;i++){
            iaa[a[i]]=true;
			p=rk[a[i]];
            while (p!=NULL) {
                q=r[a[i]][p->b];
                while (q!=NULL) {
                    if (!b[q->b][p->b] && !ia[q->b]) {
                        query[qs].n=q->b;   
                        query[qs].k=p->b;
                        qs++;
                        g[q->b]=g[a[i]]+1;
                        b[q->b][p->b]=true;
                    }                   
                    q=q->next;
                }
                p=p->next;
            }           
        }

        na=0;
        for (i=0;i<qs;i++) {            
            t++;
			ba[query[i].n]=t;
            bfs(query[i].n,query[i].k,t);   
        }

        
    }
    
    if (g[n-1]>0) {
        printf("%d",(g[n-1]-1));
    } else {
        printf("%s","-1");
    }

    fclose(stdout);
    return 0;
}