{ "".
 ;   O(N^2).
:  .}

{$D-,L-,I-,Q-,R-,S-}
{$APPTYPE CONSOLE}

const
  MAXN = 2000;
  MAXED = MAXN * (MAXN - 1) div 2;

type
  int = longint;

var
  n, maps: int;
  nedges, i, ncomp: int;
  m, a, b: int;
  len: int;
  next, val: array[1..MAXED] of int;
  head: array[1..MAXN] of int;
  vlen: int;
  vlist: array[1..2 * MAXED] of int;
  were: array[1..MAXN] of int;
  len0: int;
  next0, val0: array[1..2 * MAXED] of int;
  head0: array[-MAXED..MAXN] of int;
  cur: int;
  que: array[1..MAXN + MAXED] of int;
  way: array[-MAXED..MAXN] of int;

procedure AddEdge(v1, v2: int);
begin
  inc(len);
  next[len] := head[v1];
  val[len] := v2;
  head[v1] := len;
  inc(vlen);
  vlist[vlen] := v1;
end;

procedure AddEdge0(v1, v2: int);
begin
  inc(len0);
  next0[len0] := head0[v1];
  val0[len0] := v2;
  head0[v1] := len0;
end;

procedure dfs(v: int);
begin
  were[v] := m;
  AddEdge0(v, -ncomp);
  AddEdge0(-ncomp, v);
  while (head[v] > 0) do
  begin
    if (were[val[head[v]]] < m) then
      dfs(val[head[v]]);
    head[v] := next[head[v]];
  end;
end;

procedure FindComponents;
var
  i: int;
begin
  for i := 1 to vlen do if (were[vlist[i]] < m) then
  begin
    inc(ncomp);
    dfs(vlist[i]);
  end;
end;

procedure CleanHead;
var
  i: int;
begin
  for i := 1 to vlen do
    head[vlist[i]] := 0;
end;

procedure bfs0;
var
  v: int;
begin
  len := 1;
  que[1] := 1;
  way[1] := 1;
  cur := 1;
  while (cur <= len) do
  begin
    v := que[cur];
    while (head0[v] > 0) do
    begin
      if (way[val0[head0[v]]] = 0) then
      begin
        inc(len);
        que[len] := val0[head0[v]];
        way[val0[head0[v]]] := way[v] + 1;
      end;
      head0[v] := next0[head0[v]];
    end;
    inc(cur);
  end;
end;

begin
  reset(input, 'stalker.in');
  rewrite(output, 'stalker.out');
  read(n, maps);
  for m := 1 to maps do
  begin
    vlen := 0;
    read(nedges);
    for i := 1 to nedges do
    begin
      read(a, b);
      AddEdge(a, b);
      AddEdge(b, a);
    end;
    FindComponents;
    CleanHead;
  end;
  bfs0;
  if (way[n] = 0) then
    writeln(-1)
  else
    writeln((way[n] div 2));
end.
