{$q+,r+,o-}

uses
  sysutils;
  
const
  maxv = 8004000;
  size = maxv + 10;
  maxe = 8600000;

var
  m, dd, h, x, y, n, k, i, j, ii, jj, q1, q2: integer;
  qi, qj: array[0..size] of smallint;
  d: array[1..2000, 0..2000] of integer;
  z1, z2, z3: array[1..2000, 0..2000] of boolean;
  hd: array[1..2000, 0..2000] of integer;
  nx: array[1..maxe + 10] of integer;
  di, dj: array[1..maxe + 10] of smallint;
  ln: array[1..maxe + 10] of byte;
  last: integer;

procedure addedge(i1, j1, i2, j2, d: integer);
begin
  inc(last);
  di[last] := i2;
  dj[last] := j2;
  ln[last] := d;
  nx[last] := hd[i1, j1];
  hd[i1, j1] := last;
end;

begin

{
  rewrite(output, 'stalker.in');
  writeln(2000);
  writeln(2000);
  for i := 1 to 2000 do begin
    writeln(150);
    for j := 1 to 150 do begin
      writeln(random(2000) + 1, ' ', random(2000) + 1);
    end;
  end;
  halt;
}

  reset(input, 'stalker.in');
  rewrite(output, 'stalker.out');

  last := 0;
  read(n, k);
  fillchar(hd, sizeof(hd), 0);
  
  for i := 1 to k do begin
    read(m);
    for j := 1 to m do begin
      read(x, y);
      addedge(x, i, y, i, 0);
      addedge(y, i, x, i, 0);
    end;
  end;

  for i := 1 to n do begin
    for j := 1 to k do begin
      addedge(i, j, i, 0, 0);
      addedge(i, 0, i, j, 1);
    end;
  end;

  fillchar(z1, sizeof(z1), 0);
  fillchar(z2, sizeof(z2), 0);
  fillchar(z3, sizeof(z3), 0);
  fillchar(d, sizeof(d), 0);

  qi[1] := 1;
  qj[1] := 0;
  z1[1, 0] := true;
  z2[1, 0] := true;
  d[1, 0] := 0;
  q1 := 0;
  q2 := 1;

  while q1 <> q2 do begin

    inc(q1);
    if q1 > size then q1 := 0;
    i := qi[q1];
    j := qj[q1];

    if z3[i, j] then continue;
    z3[i, j] := true;

    h := hd[i, j];
    while h <> 0 do begin
      ii := di[h];
      jj := dj[h];
      dd := ln[h];
      if (dd = 0) then begin
        if (not z1[ii, jj]) and (not z2[ii, jj] or (d[ii, jj] > d[i, j])) then begin
          qi[q1] := ii;
          qj[q1] := jj;
          dec(q1);
          if q1 < 0 then q1 := size;

          d[ii, jj] := d[i, j];
          z1[ii, jj] := true;
        end;
      end else begin
        if not z2[ii, jj] and (not z1[ii, jj] or (d[ii, jj] > d[i, j] + 1)) then begin
          inc(q2);
          if q2 > size then q2 := 0;
          qi[q2] := ii;
          qj[q2] := jj;

          d[ii, jj] := d[i, j] + 1;
          z2[ii, jj] := true;
        end;
      end;
      h := nx[h];
    end;
  end;

  if (z3[n, 0]) then begin
    writeln(d[n, 0]);
  end else begin
    writeln(-1);
  end;

end.