const
  filename = 'clocks';

type 
  int = integer;

var
  a, b, t: int;
  aa, bb: array[0..100000] of int;
  w: array[0..100000] of boolean;

procedure dfs(tt: int);

procedure go(a0, b0: int);
begin
  if (a0 > b0) then
    a0 := b0;
  if (tt + a0 <= 100000) and not w[tt + a0] then
    dfs(tt + a0);
end;

begin
  w[tt] := true;
  go(aa[tt], bb[tt]);
  go(a - aa[tt], bb[tt]);
  go(aa[tt], b - bb[tt]);
  go(a - aa[tt], b - bb[tt]);
end;


begin
  assign(input, filename + '.in');
  assign(output, filename + '.out');
  reset(input);
  rewrite(output);

  read(a, b, t);

  dfs(0);

  if not w[t] then
  begin
    writeln('Impossible');
    halt;
  end;

  writeln('Poss');
  
end.