{$Q+,R+,O-}
{$MINSTACKSIZE $1000000}
{$APPTYPE CONSOLE}

type
  int = longint;

var
  n, i, x, y, z: int;
  head, dang: array[1..100000] of int;
  edge, next, color: array[1..200000] of int;
  dead, cc: array[1..100000] of boolean;
  len, cur: int;

procedure addedge(x, y, z: int);
begin
  inc(len);
  next[len] := head[x];
  edge[len] := y;
  color[len] := z;
  head[x] := len;
end;

procedure nosolution;
begin
{  writeln(0);}
  halt;
end;

procedure dfs_killer(v, u, col: int);
var
  cur: int;
begin
  dead[v] := true;
  if (dang[v] > 0) and (col <> dang[v]) then
    nosolution;
  cur := head[v];
  while (cur > 0) do
  begin
    if (edge[cur] <> u) then
      dfs_killer(edge[cur], v, color[cur]);
    cur := next[cur];
  end;
end;

begin
  assign(input, 'robot.in');
  assign(output, 'robot.out');
  reset(input);
  rewrite(output);
  readln(n);
  len := 0;
  for i := 2 to n do
  begin
    read(x, y, z);
    addedge(x, y, z);
    addedge(y, x, z);
  end;
  for i := 1 to n do
  begin
    cur := head[i];
    while (cur > 0) do
    begin
      if cc[color[cur]] then
      begin
        if (dang[i] = 0) then
          dang[i] := color[cur]
        else
          nosolution;
      end
      else
        cc[color[cur]] := true;
      cur := next[cur];
    end;
    cur := head[i];
    while (cur > 0) do
    begin
      cc[color[cur]] := false;
      cur := next[cur];
    end;
  end;
  for i := 1 to n do if (not dead[i]) and (dang[i] > 0) then
  begin
    cur := head[i];
    while (cur > 0) do
    begin
      if (color[cur] <> dang[i]) then
        dfs_killer(edge[cur], i, color[cur]);
      cur := next[cur];
    end;
  end;
  x := 0;
  for i := 1 to n do if (not dead[i]) and (dang[i] = 0) then
    inc(x);
{  writeln(x);}
  for i := 1 to n do if (not dead[i]) and (dang[i] = 0) then
    write(i, ' ');
  writeln;
end.

