{
          

    :      
    :       
    :     
}
{$q+,r+,o-}
uses
    sysutils;

const
    max_n = 2000;
    max_m = 50000;
    max_c = 10000;

var
    i, j, l, n, m: longint;
    z, q, t: array [1..max_n, 1..max_n] of longint;
    a, b, c, p, s: array [1..max_m] of longint;
    r: array [1..max_n] of longint;
    d, prev: array [0..max_n] of longint;
    cash: longint;
    cb, cs: longint;
    u: array [1..max_n] of boolean;
    path: array[1..max_n] of longint;
    mi: longint;
begin
    assign(input, 'campaign.in'); reset(input);
    assign(output, 'campaign.out'); rewrite(output);

    read(n, m);
    assert((2 <= n) and (n <= max_n), 'N out of bounds');
    assert((0 < m) and (m <= max_m), 'M out of bounds');

    for i := 1 to n do begin
        read(r[i]);
        assert((0 <= r[i]) and (r[i] <= max_c), format('R[%d] out of bounds', [i]));
    end;

    for i := 1 to n do begin
        for j := 1 to n do begin
            z[i][j] := maxlongint div 2;
        end;
    end;

    cash := r[n];
    for i := 1 to m do begin
        read(a[i], b[i], p[i], c[i]);
        assert((0 < a[i]) and (a[i] <= n), format('A[%d] out of bounds', [i]));
        assert((0 < b[i]) and (b[i] <= n), format('B[%d] out of bounds', [i]));
        assert((0 < p[i]) and (p[i] <= n), format('P[%d] out of bounds', [i]));
        assert((0 <= c[i]) and (c[i] <= max_c), format('C[%d] out of bounds', [i]));
        assert(a[i] <> b[i], format('A[%d] = B[%d]', [i, i]));
        assert(q[a[i], b[i]] = 0, format('Duplicate road %d', [i]));

        if p[i] = 1 then begin
            s[i] := -1;
            cash := cash + c[i];
        end;
        q[a[i], b[i]] := i;
        q[b[i], a[i]] := i;
        z[a[i], b[i]] := c[i] + r[b[i]];
        z[b[i], a[i]] := c[i] + r[a[i]];
        t[a[i], b[i]] := a[i];
        t[b[i], a[i]] := a[i];
    end;

    for i := 0 to n do begin
        d[i] := maxlongint div 2;
    end;

    d[0] := maxlongint;
    d[1] := 0;
    for i := 1 to n do begin
        mi := 0;
        for j := 1 to n do begin
            if not u[j] and (d[j] < d[mi]) then begin
                mi := j;
            end;
        end;
        u[mi] := true;
        for j := 1 to n do begin
            if d[j] > d[mi] + z[mi][j] then begin
                d[j] := d[mi] + z[mi][j];
                prev[j] := mi;
            end;
        end;
    end;

    if cash >= d[n] then begin
        l := 0;
        i := n;
        j := prev[n];
        while j <> 0 do begin
            inc(l);
            path[l] := i;
            inc(s[q[i][j]]);
            i := prev[i];
            j := prev[j];
        end;

        cs := 0;
        for i := 1 to m do begin
            if s[i] < 0 then inc(cs);
        end;
        write(cs);
        for i := 1 to m do begin
            if s[i] < 0 then write(' ', i);
        end;
        writeln;

        cb := 0;
        for i := 1 to m do begin
            if s[i] > 0 then inc(cb);
        end;
        write(cb);
        for i := 1 to m do begin
            if s[i] > 0 then write(' ', i);
        end;
        writeln;

        write(1);
        for i := l downto 1 do begin
            write(' ', path[i]);
        end;
    end else begin
        writeln(-1);
    end;

    close(input);
    close(output);
end.