{
          

    :        
    :       
    :     
}
{$o-,q+,r+}
{$apptype console}
uses
	math, sysutils;

const
	inf = $77777777;
	eps = 1e-10;
	finname = 'chess';
    maxn = 300;
procedure quitf;
begin
    write('Wrong Board');
    halt(0);
end;
type
	int = longint;
procedure swap(var a, b: int);
var
    t: int;
begin
    t := a;
    a := b;
    b := t;
end;
var
    b, cx, cy: array[1 .. maxn * maxn] of int;
procedure qs(l, r: int);
var
    i, j, x: int;
begin
    if (l >= r) then
        exit;
    i := l;
    j := r;
    x := b[random(r - l + 1) + l];
    repeat
        while (b[i] < x) do
            inc(i);
        while (b[j] > x) do
            dec(j);
        if (i <= j) then begin
            swap(b[i], b[j]);
            swap(cx[i], cx[j]);
            swap(cy[i], cy[j]);
            inc(i);
            dec(j);
        end;
    until i > j;
    qs(i, r);
    qs(l, j);
end;
var
	n, m, k, i, j: int;
    a: array[1 .. maxn, 1 .. maxn] of int;
    nb: int;
begin
	reset(input, finname + '.in');
	rewrite(output, finname + '.out');

    read(n, m, k);
    inc(k);
    nb := 0;
    for i := 1 to n do begin
        for j := 1 to m do begin
            read(a[i, j]);
            if (a[i, j] > 0) then begin
                inc(nb);
                b[nb] := a[i, j];
                cx[nb] := i;
                cy[nb] := j;
            end;
        end;
    end;
    if (nb <> k) then
        quitf;
    qs(1, nb);

    for i := 1 to nb - 1 do
        if (b[i] = b[i + 1]) then
            quitf;

    for i := 1 to nb - 1 do
        if not (
                       (cx[i] = cx[i + 1])
                    or (cy[i] = cy[i + 1])
                    or (cx[i] + cy[i + 1] = cx[i + 1] + cy[i])
                    or (cx[i] + cy[i] = cx[i + 1] + cy[i + 1])
               )
        then
            quitf;

    for i := 1 to nb do
        a[cx[i], cy[i]] := i;

    for i := 1 to n do begin
        for j := 1 to m do
            write(a[i, j], ' ');
        writeln;
    end;

	close(input);
	close(output);
end.