{
          

    :        
    :       
    :     
}

{$R+,Q+,O-}
{$APPTYPE CONSOLE}
type
  int = longint;

var
  a, ans: array [1..300, 1..300] of int;
  v, x, y: array [1..300 * 300] of int;
  n, m, k, tmp, t: int; 

procedure qs(l, h: int);
var
  i, j: int;

begin
  i:=l;
  j:=h;
  t:=v[l + random(h - l + 1)];

  while (i <= j) do
  begin
    while (v[i] < t) do inc(i);
    while (v[j] > t) do dec(j);
    if (i <= j) then
    begin
      tmp:=v[i];
      v[i]:=v[j];
      v[j]:=tmp;  

      tmp:=x[i];
      x[i]:=x[j];
      x[j]:=tmp;  

      tmp:=y[i];
      y[i]:=y[j];
      y[j]:=tmp;  

      inc(i);
      dec(j);
    end;
  end;
  if (l < j) then qs(l, j);
  if (i < h) then qs(i, h);
end;

procedure solve;
var
  i, j, p: int;

begin
  p:=0;
  for i:=1 to m do
    for j:=1 to n do
      if (a[i][j] > 0) then
      begin
        inc(p);
        x[p]:=i;
        y[p]:=j;
        v[p]:=a[i][j];
      end;

  if (p <> k + 1) then
  begin
    writeln('Wrong Board');
    exit;
  end;

  randseed:=239361;
  qs(1, p);

  fillchar(ans, sizeof(ans), 0);
  for i:=1 to p - 1 do
  begin
    if (v[i] < v[i + 1]) and ((x[i] = x[i + 1]) or (y[i] = y[i + 1]) or (x[i] + y[i] = x[i + 1] + y[i + 1]) or (x[i] - y[i] = x[i + 1] - y[i + 1])) then
    begin
      ans[x[i]][y[i]]:=i;
      continue;
    end;
    writeln('Wrong Board');
    exit;
  end;
  ans[x[p]][y[p]]:=p;
  for i:=1 to m do
  begin
    for j:=1 to n do
      write(ans[i][j], ' ');
    writeln;
  end;
end;

var
  i, j: int;

begin
  assign(input, 'chess.in');
  assign(output, 'chess.out');
  reset(input);
  rewrite(output);

  read(m, n, k);
  assert((1 <= m) and (m <= 300));
  assert((1 <= n) and (n <= 300));
  assert((0 <= k) and (k <= m * n));

  fillchar(a, sizeof(a), 0);
  for i:=1 to m  do
    for j:=1 to n do
    begin
      read(a[i][j]);
      assert((0 <= a[i][j]) and (a[i][j] <= 1000000000));
    end;
  solve;
end.
