{$o-,q+,r+}
{ $o+,q-,r-}
{$apptype console}
uses
	math, sysutils;
const
	inf = $7777;
	eps = 1e-10;
    maxv = 300;
	finname = 'sawmill';
type
	int = longint;
function gcd(a, b: int): int;
var
    t: int;
begin
    if (a < b) then begin
        t := a;
        a := b;
        b := t;
    end;
    while (b > 0) do begin
        t := a mod b;
        a := b;
        b := t;
    end;
    result := a;
end;
procedure quit(x: int);
begin
    write(x);
    close(output);
    halt(0);
end;
var
    a, x, b, y, z: int;
	cx, cy, cxt, cyt, cxl, cyl: int;
    t, dx, r, m: int;
begin
	reset(input, finname + '.in');
	rewrite(output, finname + '.out');

    read(a, x, b, y, z);
    assert(seekeof);
    assert(
                (0 < a) and (a <= maxv)
            and (0 < x) and (x <= maxv)
            and (0 < b) and (b <= maxv)
            and (0 < y) and (y <= maxv)
            and (0 < z) and (z <= maxv)
            and (x <= z) and (y <= z)
          );

    if (x = y) then begin
        if (z mod x = 0) then
            quit(a + b - (a + b) div (z div x))
        else
            quit(a + b);
    end;

    cy := x div gcd(x, y);
    cx := y div gcd(x, y);
    assert(x * cx = y * cy);

    cxt := z div x;
    t := x * cxt;
    cyt := 0;

    while true do begin
        if (t = z) then
            break;
        while (t + y <= z) do begin
            inc(cyt);
            inc(t, y);
        end;
        if (t = z) then
            break;
        if (cxt = 0) then
            break;
        dec(cxt);
        dec(t, x);
    end;

    if (t <> z) then
        quit(a + b);
    if (cxt = 0) then
        quit(a + b - b div cyt);

    dx := cxt div cx;
    r := a div cxt;
    if (cyt > 0) and (r > b div cyt) then
        r := b div cyt;
    m := r * dx;
    cxl := cxt * r;
    cyl := cyt * r;

    while true do begin
        while (cxl + cxt > a) and (m > 0) and (cyl + cy <= b) do begin
            dec(m);
            dec(cxl, cx);
            inc(cyl, cy);
        end;
        if (cxl + cxt <= a) and (cyl + cyt <= b) then begin
            inc(r);
            inc(cxl, cxt);
            inc(cyl, cyt);
            inc(m, dx);
        end
        else begin
            if (cxt < cx) then
                break;
            dec(cxt, cx);
            inc(cyt, cy);
            dec(dx);
        end;
    end;

    quit(a + b - r);
end.
