{ $o-,q+,r+}
{$o+,q-,r-}
{$apptype console}
uses
	math, sysutils;

const
	inf = $7777;
	eps = 1e-10;
    maxv = 300;
	finname = 'sawmill';
type
	int = longint;
var
    a, x, b, y, z: int;
	i, j, k: int;
    v: array[0 .. maxv + 1, 0 .. maxv + 1, 0 .. maxv] of smallint;
begin
	reset(input, finname + '.in');
	rewrite(output, finname + '.out');

    read(a, x, b, y, z);
    assert(seekeof);
    assert(
                (0 < a) and (a <= maxv)
            and (0 < x) and (x <= maxv)
            and (0 < b) and (b <= maxv)
            and (0 < y) and (y <= maxv)
            and (0 < z) and (z <= maxv)
            and (x <= z) and (y <= z)
          );

    fillchar(v, sizeof(v), $77);

    for i := 0 to z do
        v[0, 0, z] := 0;
    for i := 0 to a do
        for j := 0 to b do begin
            for k := z downto 0 do begin
                if (k >= x) and (v[i + 1, j, k - x] > v[i, j, k] + ord(k > x)) then begin
                	v[i + 1, j, k - x] := v[i, j, k] + ord(k > x);
                	if (v[i + 1, j, z] > v[i + 1, j, k - x]) then
						v[i + 1, j, z] := v[i + 1, j, k - x];                		
                end;
                if (k >= y) and (v[i, j + 1, k - y] > v[i, j, k] + ord(k > y)) then begin
                	v[i, j + 1, k - y] := v[i, j, k] + ord(k > y);
                	if (v[i, j + 1, z] > v[i, j + 1, k - y]) then
						v[i, j + 1, z] := v[i, j + 1, k - y];                		
                end;
            end;
        end;

    k := inf;
    for i := 0 to z do
        if (k > v[a, b, i]) then
            k := v[a, b, i];
    write(k);

	close(input);
	close(output);
end.