{ $o-,q+,r+}
{$o+,q-,r-}
{$apptype console}
uses
	math, sysutils;
const
	inf = $7777;
	eps = 1e-10;
    maxv = 300;
	finname = 'sawmill';
type
	int = longint;
var
    a, x, b, y, z: int;
	i, j, k: int;
    kn, t, ii, jj, zm, d: int;
    v: array[0 .. maxv + 1, 0 .. maxv + 1, 0 .. maxv] of smallint;
begin
	reset(input, finname + '.in');
	rewrite(output, finname + '.out');

    read(a, x, b, y, z);
    assert(seekeof);
    assert(
                (0 < a) and (a <= maxv)
            and (0 < x) and (x <= maxv)
            and (0 < b) and (b <= maxv)
            and (0 < y) and (y <= maxv)
            and (0 < z) and (z <= maxv)
            and (x <= z) and (y <= z)
          );

    fillchar(v, sizeof(v), $77);

    for i := 0 to z do
        v[0, 0, z] := 0;
    for i := 0 to a do
        for j := 0 to b do begin
            zm := inf;
            for k := 0 to z - 1 do begin
                t := v[i, j, k];
                if (t = inf) then
                    continue;
                if (zm > t) then
                    zm := t;

                kn := k - x;
                if (kn >= 0) then begin
                    d := ord(kn > 0);
                    inc(t, d);
                    ii := i + 1;
                    if (v[ii, j, kn] > t) then
                        v[ii, j, kn] := t;
                    dec(t, d);
                end;

                kn := k - y;
                if (kn >= 0) then begin
                    inc(t, ord(kn > 0));
                    jj := j + 1;
                    if (v[i, jj, kn] > t) then
                        v[i, jj, kn] := t;
                end;
            end;

            if (v[i, j, z] > zm) then
                v[i, j, z] := zm
            else
                zm := v[i, j, z];
                
            t := zm;
            
            kn := z - x;
            d := ord(kn > 0);
            inc(t, d);
            ii := i + 1;
            if (v[ii, j, kn] > t) then
                v[ii, j, kn] := t;
            dec(t, d);

            kn := z - y;
            inc(t, ord(kn > 0));
            jj := j + 1;
            if (v[i, jj, kn] > t) then
                v[i, jj, kn] := t;

        end;

    k := inf;
    for i := 0 to z do
        if (k > v[a, b, i]) then
            k := v[a, b, i];
    write(k);

	close(input);
	close(output);
end.