(*
  "Old Castle". Jury's solution.
  Antony Popovich, 21.10.2004.
*)

{$APPTYPE CONSOLE}
{$Q+,R+,O+}

uses
  math, sysutils;

const
  fn = 'castle';
  rad = 180 / pi;

type
  tpoint = record
    a, b : longint;
  end;

var
  ans : extended;
  i, len, n, r : longint;
  z : array[0..185] of tpoint;

procedure sortangles;
var
  i, j, best : longint;
  temp : tpoint;
begin
  for i := 1 to n do begin
    best := i;
    for j := i + 1 to n do begin
      if z[j].a < z[best].a then
        best := j;
    end;
    temp := z[i];
    z[i] := z[best];
    z[best] := temp;
  end;
end;

begin
  assign(input, fn + '.in'); reset(input);
  assign(output, fn + '.out'); rewrite(output);

  read(n, r); len := 0;
  for i := 1 to n do begin
    read(z[i].a, z[i].b);

    while z[i].b < z[i].a do inc(z[i].b, 360);
    inc(len, z[i].b - z[i].a);
  end;

  ans := (pi * r * len) / 180;

  sortangles; z[0] := z[n];
  for i := 1 to n do begin
    ans := ans + sqrt(sqr(r) * (sqr((cos(z[i].b / rad) - cos(z[(i + 1) mod n].a / rad))) + sqr(sin(z[i].b / rad) - sin(z[(i + 1) mod n].a / rad))));
  end;

  writeln(ans : 0 : 10);
end.
