/* Copyright 2004 Dmitri Pavlov */
#include <math.h>
#include <stdio.h>

#define M 360
#define pi 3.141592653589793238462643383279502884197169399375105820974944592307

int main( void )
{
  freopen("castle.in", "r", stdin);
  freopen("castle.out", "w", stdout);
  int n;
  while (scanf("%d", &n) == 1)
  {
    int u = 0, r, k;
    double v = 0;
    int c[M];
    scanf("%d", &r);
    for (k = 0; k < M; k++)
      c[k] = 0;
    while (n-- > 0)
    {
      int a, b;
      scanf("%d%d", &a, &b);
      if (a < b)
      {
        int k;
        for (k = a; k < b; k++)
          c[k] = 1;
        u += b - a;
      }
      else
      {
        int k;
        for (k = a; k < M; k++)
          c[k] = 1;
        for (k = 0; k < b; k++)
          c[k] = 1;
        u += M + b - a;
      }
    }
    k = 0;
    while (k < M)
      if (c[k] == 0)
      {
        int l = k, L;
        while (l < M && c[l] == 0)
          l++;
        if (l == M && c[0] == 0)
          break;
        L = l - k;
        if (k == 0)
        {
          int m = M;
          while (m > 0 && c[m - 1] == 0)
            m--;
          L += M - m;
        }
        k = l;
      
        if (L > M / 2)
          L = M - L;
        if (L == M / 2)
          v += 1;
        else
          v += sin(L / (double)M * pi);
      }
      else
        k++;
    printf("%.3f\n", (u * pi / M + v) * 2 * r);
  }
  return 0;
}
