{$O-,Q+,R+}
{ $O+,Q-,R-}
{$MINSTACKSIZE $00004000}
{$APPTYPE CONSOLE}
uses
    math, sysutils;
type
    int = longint;
const
    finname = 'castle';
    maxm = 2 * 10000 + 1;
type
    point = record
        a: extended;
        u: boolean;
    end;
var
    a: array[1 .. maxm] of point;
procedure qs(l, r: int);
var
    x, t: point;
    i, j: int;
begin
    if (l >= r) then
        exit;
    i := l;
    j := r;
    x := a[random(r - l + 1) + l];
    repeat
        while (a[i].a < x.a) or ((a[i].a = x.a) and (a[i].u < x.u)) do
            inc(i);
        while (a[j].a > x.a) or ((a[j].a = x.a) and (a[j].u > x.u)) do
            dec(j);
        if (i <= j) then begin
            t := a[i];
            a[i] := a[j];
            a[j] := t;
            inc(i);
            dec(j);
        end;
    until i > j;
    qs(i, r);
    qs(l, j);
end;
var
    s, p, r, t, x1, x2, y1, y2: extended;
    i, n, m: int;
begin
    reset(input, finname + '.in');
    rewrite(output, finname + '.out');

    read(n, r);
    m := 0;
    for i := 1 to n do begin
        inc(m);
        read(a[m].a);
        a[m].a := a[m].a * pi / 180;
        a[m].u := true;
        inc(m);
        if (a[m].a < a[m - 1].a) then
            a[m].a := a[m].a + 2 * pi;
        read(a[m].a);
        a[m].a := a[m].a * pi / 180;
        a[m].u := false;
    end;

    qs(1, m);
    a[m + 1].a := a[1].a + 2 * pi;
    s := 0;
    p := 0;

    for i := 1 to m do begin
        x1 := r * cos(a[i].a);
        x2 := r * cos(a[i + 1].a);
        y1 := r * sin(a[i].a);
        y2 := r * sin(a[i + 1].a);
        s := s + 0.5 * (x2 - x1) * (y2 + y1);
        if (not a[i].u) then
            p := p + hypot(y2 - y1, x2 - x1);
    end;

    s := abs(s);
    for i := 1 to m do
        if (a[i].u) then begin
            t := a[i + 1].a - a[i].a;
            s := s + 0.5 * sqr(r) * (t - sin(t));
            p := p + r * t;
        end;

    //writeln(s:0:10);
    writeln(p:0:10);

    close(input);
    close(output);
end.