// SPb-JPC-Kirov-2004
// Problem: "Chart"
// Solution by Orshanskiy Sergey

{$APPTYPE CONSOLE}
Uses Math, SysUtils;
{$O-,Q+,R+}

const problem_id = 'chart';
      good : set of char = ['a'..'z', 'A'..'Z', '0'..'9',
        '.', ',', '?', '!', ';', ':', '-', '(', ')'];
var
      ch : char;
      z : array [#0..#255] of integer;
      m : integer;
begin
  if ParamCount < 1 then
	  AssignFile(input, problem_id + '.in') else
    AssignFile(input, ParamStr(1));
	reset(input);
  if ParamCount < 2 then
    AssignFile(output, problem_id + '.out') else
    AssignFile(output, ParamStr(2));
	rewrite(output);

  m := 0;
  while not eof do
  begin
    read(ch);
    inc(m);
    assert(ch <> #9);
  end;
  assert(m <= 10000);

  reset(input);
  assert(not seekeof);

  fillchar(z, sizeof(z), 0);

  while not seekeof do
  begin
    read(ch);
    assert(ch in good);
    inc(z[ch]);
  end;
  m := 0;
  for ch := #0 to #255 do m := max(m, z[ch]);
  assert(m > 0);
  while m > 0 do
  begin
    for ch := #0 to #255 do if z[ch] > 0 then
      if z[ch] >= m then write('#') else write(' ');
    writeln;
    dec(m);
  end;
  for ch := #0 to #255 do if z[ch] > 0 then
    write(ch);
  writeln;
end.
