{$O-,R+,Q+}
{$apptype CONSOLE}

const
	MAX_N = 100;
	INFINITY = 10000;
	IN_FILE = 'mines.in';
	OUT_FILE = 'mines.out';
	
var
	m, n : integer;
	a, b : array[0..MAX_N+1,0..MAX_N+1] of integer;

procedure WriteYES;
var
	i, j : integer;
	
begin
	rewrite(output, OUT_FILE);
	for i := 1 to m do begin
		for j := 1 to n do
			if b[i,j] = -1 then
				write('*')
			else if b[i,j] = 0 then
				write('.')
			else
				write(b[i,j]);
		writeln;
	end;			
	close(output);
end;
			
procedure WriteNO;
begin
	rewrite(output, OUT_FILE);
	writeln('No solution');
	close(output);
end;

procedure ReadInput;
var
	i, j : integer;
	
begin
	reset(input, IN_FILE);
	read(m);
	if (m < 1) or (m > MAX_N) then runerror(239);
	if eoln then runerror(239);
	read(n);
	if (n < 1) or (n > MAX_N) then runerror(239);
	if not eoln then runerror(239);	
	readln;
	for i := 1 to m do begin
		for j := 1 to n do begin
			if eoln then runerror(239);
			read(a[i,j]);
			if (a[i,j] < 0) or (a[i,j] > 1) then runerror(239);
		end;
		if not eoln then runerror(239);
		readln;	
	end;
	if not eof then runerror(239);
	close(input);
end;

var
	i, j : integer;
	dx, dy : integer;
				
begin
	ReadInput;
	
	fillchar(b, sizeof(b), 0);
	for i := 1 to m do
		for j := 1 to n do
			b[i,j] := -1;
			
	for i := 1 to m do
		for j := 1 to n do
			if a[i,j] = 0 then begin
				for dx := -1 to 1 do for dy := -1 to 1 do
					b[i + dx, j + dy] := 0;
			end;
			
	for i := 1 to m do
		for j := 1 to n do
			if b[i,j] = 0 then begin
				for dx := -1 to 1 do for dy := -1 to 1 do
					if b[i + dx, j + dy] = -1 then
						inc(b[i,j]);
				if (a[i,j] = 1) and (b[i,j] = 0) then begin
					WriteNO;
					halt;
				end;	
			end;
			
	WriteYES;		
end.
