#include <assert.h>
#include <stdio.h>

#define max (1 << 12)
#define B 10

typedef int arr0[max][max + 1];
arr0 mark, u, v, mark;
int red[max][B];
typedef int arr1[max * (max + 1)];
arr1 x, y, num;

int main( void )
{
  freopen("number.in", "r", stdin);
  freopen("number.out", "w", stdout);
  int n;
  while (scanf("%d", &n) == 1)
  {
    int f = 0, r = 1, i, j;
    x[f] = 0;
    y[f] = 0;
    for (i = 0; i < n; i++)
      for (j = 0; j <= n; j++)
        mark[i][j] = 0;
    mark[0][0] = 1;
    for (i = 0; i < n; i++)
      for (j = 0; j < B; j++)
        red[i][j] = (i * B + j) % n;
    while (f < r)
    {
      int a = x[f], b = y[f], k;
      if (a == 0 && b == n)
      {
        int a = 0, b = n, k = 0;
        while (b != 0)
        {
          int aa = u[a][b], bb = v[a][b];
          num[k++] = b - bb;
          a = aa;
          b = bb;
        }
        while (k-- > 0)
          printf("%d", num[k]);
        printf("\n");
        break;
      }
      f++;
      for (k = 0; k < B; k++)
      {
        int aa = red[a][k], bb = b + k;
        if (bb > n)
          break;
        if (!mark[aa][bb])
        {
          mark[aa][bb] = 1;
          x[r] = aa;
          y[r] = bb;
          r++;
          u[aa][bb] = a;
          v[aa][bb] = b;
        }
      }
    }
    if (f == r)
      assert(0);
  }
  return 0;
}
