// SPb-JPC-Kirov-2004
// Problem: "Pascal"
// Solution by Orshanskiy Sergey

{$APPTYPE CONSOLE}
Uses Math, SysUtils;
{$O-,Q+,R+}

const problem_id = 'pascal';
      max_n = 2*1000*1000*1000;

var
  n : integer;

// calculates "1"s in binary representation
function CalcOnes(x : integer) : integer;
begin
  assert(x >= 0);
  result := 0;
  while x > 0 do
  begin
    result := result + (x and 1);
    x := x shr 1;
  end;
end;

begin
  if ParamCount < 1 then
	  AssignFile(input, problem_id + '.in') else
    AssignFile(input, ParamStr(1));
	reset(input);
  if ParamCount < 2 then
    AssignFile(output, problem_id + '.out') else
    AssignFile(output, ParamStr(2));
	rewrite(output);

  assert(not seekeoln);
  read(n);
  assert(seekeof);
  assert((0 <= n) and (n <= max_n));

  writeln(1 shl CalcOnes(n));
end.