#include <assert.h>
#include <stdio.h>

#define SIZE (1 << 10)

int a[SIZE][SIZE], m, n, f, mini, maxi, minj, maxj;

void count( void )
{
  int i, j;
  f = 0;
  for (i = 0; i < m; i++)
    for (j = 0; j < n; j++)
      if (a[i][j] == 1)
      {
        if (f == 0)
        {
          mini = maxi = i;
          minj = maxj = j;
        }
        else
        {
          if (mini > i)
            mini = i;
          if (maxi < i)
            maxi = i;
          if (minj > j)
            minj = j;
          if (maxj < j)
            maxj = j;
        }
        f++;
      }
}

void mark( int k, int l, int di, int dj )
{
  int i, j;
  for (i = k; i >= 0 && i < m; i += di)
    for (j = l; j >= 0 && j < n && a[k][j]; j += dj)
      if (a[i][j] == 1)
        a[i][j] = 2;
      else
      {
        for (j = l; j >= 0 && j < n && a[k][j] && a[i][j]; j += dj)
          a[i][j] = 1;
        return;
      }
}

int main( void )
{
  int i, j;
  freopen("rect.in", "r", stdin);
  freopen("rect.out", "w", stdout);
  scanf("%d%d", &m, &n);
  for (i = 0; i < m; i++)
    for (j = 0; j < n; j++)
    {
      char c;
      scanf(" %c", &c);
      a[i][j] = c == '#';
    }
  count();
  if (f < 2)
  {
    printf("NO\n");
    return 0;
  }

  if (a[mini][minj])
    mark(mini, minj, 1, 1);
  else if (a[maxi][minj])
    mark(maxi, minj, -1, 1);
  else if (a[mini][maxj])
    mark(mini, maxj, 1, -1);
  else if (a[maxi][maxj])
    mark(maxi, maxj, -1, -1);
  else
  {
    printf("NO\n");
    return 0;
  }
  count();
  if (f == 0)
    if (mini < maxi)
      for (j = minj; j <= maxj; j++)
        a[maxi][j] = 1;
    else
      for (i = mini; i <= maxi; i++)
        a[i][maxj] = 1;
  else if (f != (maxi - mini + 1) * (maxj - minj + 1))
  {
    printf("NO\n");
    return 0;
  }
  printf("YES\n");
  for (i = 0; i < m; i++)
  {
    for (j = 0; j < n; j++)
      putchar(".ba"[a[i][j]]);
    putchar('\n');
  }
  return 0;
}
