// SPb-JPC-Kirov-2004
// Problem: "Zeroes"
// Solution by Orshanskiy Sergey

{$APPTYPE CONSOLE}
Uses Math, SysUtils;
{$O-,Q+,R+}

const problem_id = 'zeroes';

type arr31 = array [0..30] of integer;

// zeroes in a number
function zeroes(x : integer) : integer;
begin
  result := 0;
  while x > 0 do
  begin
    result := result + ((x and 1) xor 1);
    x := x shr 1;
  end;
end;
// takes all numbers from 1 to r and returns a[i] - how many numbers with i zeroes...
function calculate(r : integer) : arr31;
var q : arr31;
    i : integer;
begin
  fillchar(result, sizeof(result), 0);
  inc(result[0]); //result[zeroes(1)]
  if not odd(r) then
  begin
    inc(result[zeroes(r)]);
    dec(r);
  end;
  // now l is supposed to be 2
  if r = 1 then exit; // l > r
  q := calculate(r shr 1);
  assert(q[30] = 0);
  for i := 0 to 30 do if q[i] > 0 then
  begin
    result[i] := result[i] + q[i];
    result[i+1] := result[i+1] + q[i];
  end;
end;

var a : arr31;
    n, k, i : integer;
    s : int64;

begin
  if ParamCount < 1 then
	  AssignFile(input, problem_id + '.in') else
    AssignFile(input, ParamStr(1));
	reset(input);
  if ParamCount < 2 then
    AssignFile(output, problem_id + '.out') else
    AssignFile(output, ParamStr(2));
	rewrite(output);

  assert(not seekeoln);
  read(n);
  assert((1 <= n) and (n <= maxlongint));
  assert(not seekeoln);
  read(k);
  assert((1 <= k) and (k <= 30));
  assert(seekeof);
  a := calculate(n);
  s := 0;
  for i := 1 to 30 do
    s := s + int64(a[i]) * ((i - 1) div k + 1);
  writeln(s);
end.