{$A8,B-,C+,D+,E-,F-,G+,J-,K-,L+,M-,N+,P+,T-,U-,V+,W-,X+,Y+,Z1}
{$Q-,R-,S-,O+,H+,I+}
{$MINSTACKSIZE $00004000}
{$MAXSTACKSIZE $00100000}
{$IMAGEBASE $00400000}
{$APPTYPE console}

const
  cinfile = 'eq.in';
  coutfile = 'eq.out';

  inf = maxlongint shr 1;
  eps = 1e-8;

  nmax = 351;

type
  int = longint;
  real = extended;

var
  ans : int;
  n, m, k : int;

  t : int;
  f : array [1..nmax] of boolean;
  g : array [1..nmax, 0..1] of int;

  a : array [1..nmax, 1..nmax] of boolean;
  res, c : array [1..nmax, 1..nmax] of int;

procedure outdata;
var
  i, j : int;
  x, y, x1, y1 : int;
begin
  read(m);
  for i:= 1 to m do
  begin
    read(x, y);
    if a[x, y] then writeln('equivalent') else
    begin
      while c[x, y] <> -1 do
      begin
        write(c[x, y]);
        x1:= g[x, c[x, y]];
        y1:= g[y, c[x, y]];
        x:= x1;
        y:= y1;
      end;
      writeln;
    end;
  end;        
end;

procedure solve;
var
  i, j, y : int;
begin
  fillchar(a, sizeof(a), 1);
  fillchar(c, sizeof(c), 255);
  fillchar(res, sizeof(res), 0);
  for i:= 1 to n do
    for j:= 1 to n do
      if f[i] xor f[j] then 
        a[i, j]:= false;
  for y:= 1 to n do
    for i:= 1 to n do
      for j:= 1 to n do
        if a[i, j] then
        begin
          if not a[g[i, 0], g[j, 0]] and (res[g[i, 0], g[j, 0]] < y) then
          begin
            a[i, j]:= false;
            c[i, j]:= 0;
            res[i, j]:= y;
            continue;
          end;
          if not a[g[i, 1], g[j, 1]] and (res[g[i, 1], g[j, 1]] < y) then
          begin
            a[i, j]:= false;
            c[i, j]:= 1;
            res[i, j]:= y;
          end;
        end;
end;

procedure readdata;
var
  i, j : int;
begin
  read(n, t);
  assert((n >= 1) and (n <= 350));
  assert((t >= 0) and (t <= n));
  fillchar(f, sizeof(f), 0);
  for i:= 1 to t do
  begin
    read(j);
    assert((j >= 1) and (j <= n)); 
    f[j]:= true;
  end;
  for i:= 1 to n do
  begin
    read(j);
    assert((j >= 1) and (j <= n)); 
    g[i, 0]:= j;
    read(j);
    assert((j >= 1) and (j <= n)); 
    g[i, 1]:= j;
  end;
end;

begin
  reset(input, cinfile);
  rewrite(output, coutfile);
  readdata;
  solve;
  outdata;
  close(input);
  close(output);
end.
