{$O-,Q+,R+}
{$APPTYPE CONSOLE}
uses SysUtils;
const MaxL=1000; MaxLen=MaxL;
type
  TChange=Record
    AtLen:Integer;
    By:Integer;
  End;

var s:string;
    K:integer;
  NextNonzero:Array[1..MaxLen]Of Integer;
  Change:Array[1..MaxLen,1..MaxLen]Of TChange;

Procedure Initialize;
Var
  Diff,I,J:Integer;
  N:Integer;
Begin
  N:=K;
  J:=N+1;
  For I:=N Downto 1 Do Begin
    If S[I]>'0' Then J:=I;
    NextNonzero[I]:=J;
  End;
  For Diff:=1 To N-1 Do
    For J:=N DownTo Diff+1 Do Begin
      I:=J-Diff;
      With Change[I,J] Do Begin
        If S[I]>S[J] Then Begin
          AtLen:=1;
          By:=1;
        End Else If S[I]<S[J] Then Begin
          AtLen:=1;
          By:=-1;
        End Else If J=N Then Begin
          AtLen:=2;
          By:=1;
        End Else Begin
          AtLen:=Change[I+1,J+1].AtLen+1;
          By:=Change[I+1,J+1].By;
        End;
        Change[J,I].AtLen:=AtLen;
        Change[J,I].By:=-By;
      End;
    End;
End;

function less (p1, p2, l:integer):boolean;
begin
  if p2>K then less:=false else
  if p1>K then less:=true else
    begin
      If P1=P2 Then Less:=False Else With Change[P1,P2] Do Begin
        If AtLen>L Then Less:=False Else Less:=(By<0);        
      End;
    end;
end;

var f:array [1..MaxL, 1..MaxL] of boolean;
    p, po:array [0..MaxL] of integer;
    pc, poc:integer;
    n:array [0..MaxL+1] of integer;
    max:integer;

procedure rec (b, l:integer);
var bb, bl, nn, nd, i:integer;
begin
  f[b, l]:=true;
  if b+l=K+1 then begin
    if n[b]>max then begin
      max:=n[b]; po:=p; poc:=pc;
    end;
  end else begin
    inc (pc);
    p[pc]:=b+l-1;
    bb:=n[b]; if bb<=K then begin
      bl:=b+l-bb; if bl<0 then bl:=0;
      nn:=n[b+l]; nd:=nn-b-l;
      if (nn<=K) and (b+l+bl+nd<=K+1) then begin
        for i:=K-b-l+1 downto bl+nd+1 do
          if not f[b+l, i] then
            rec (b+l, i);
        if less (bb, nn, bl) and not f[b+l, bl+nd] then
          rec (b+l, bl+nd);
      end;
    end;
    dec (pc);
  end;
end;

var i, j, q:integer;

begin
  reset (input, 'commas.in');
  rewrite (output, 'commas.out');
  readln (s);
  K:=length (s);
  Initialize;
  for i:=1 to K do assert (s[i] in ['0'..'9']); assert (seekeof);
  q:=K+1; s:=s+#0;
  for i:=K downto 1 do begin
    if s[i]<>'0' then q:=i;
    n[i]:=q;
  end;
  max:=0;
  fillchar (f, sizeof (f), 0);
 for i:=K downto 1 do rec (1, i);
  for i:=1 to poc do begin
    for j:=po[i-1]+1 to po[i] do write (s[j]);
    write (',');
  end;
  for j:=po[poc]+1 to K do write (s[j]);
  writeln;
end.