{$I-,Q-,R-,S-,O+,H-}
{$I+,Q+,R+,S+,O-,H+}
{$apptype console}
{$M 10000000, 10000000}

program InterestingGame;

uses SysUtils;

const
  cInFile = 'game.in';
  cOutFile = 'game_vg.out';

  inf = maxlongint shr 1;
  eps = 1e-8;

  nmax = 150;  // length of sequence;
  lmax = 150; // total length of all strings;
  kmax = 150; // number of strings;

  vmax = lmax + 1;

type
  int = longint;
  real = extended;

  alph = array ['A'..'Z'] of int;
  balph = int;
  tbor = record
           par : int;
           ch : char;
           p : alph;
           t : boolean;
           e : balph;
         end;  

var
  n : int;
  ans : balph;

  s : string;

  k : int;
  b : array [0..vmax] of tbor;

  res : array [0..nmax, 0..nmax] of balph;
  d : array [0..nmax, 0..vmax] of boolean;
  st : array [0..nmax] of balph;

procedure OutData;
var
  ch : char;
begin
  for ch:= 'A' to 'Z' do
    if (ans shr (ord(ch) - ord('A'))) and 1 = 1 then write(ch);
end;

procedure Solve;
var
  i, j : int;
  l, r, nx : int;
  ch : char;
begin
  for i:= 1 to n do assert(s[i] in ['A'..'Z']);
  fillchar(res, sizeof(res), 0);
  for i:= 1 to n do res[i, i]:= res[i, i] or (1 shl (ord(s[i]) - ord('A')));
  for l:= n downto 1 do
  begin
    fillchar(d, sizeof(d), 0);
    d[l - 1, 1]:= true;
    fillchar(st, sizeof(st), 0);
    for r:= l to n do
    begin
      for ch:= 'A' to 'Z' do
        if st[r - 1] and (1 shl (ord(ch) - ord('A'))) <> 0 then
          d[r - 1, b[1].p[ch]]:= true;
      for i:= 1 to k do
        if d[r - 1, i] then
          for nx:= r to n do
            if res[r, nx] <> 0 then
              for ch:= 'A' to 'Z' do
                if res[r, nx] and (1 shl (ord(ch) - ord('A'))) <> 0 then
                begin
                  j:= b[i].p[ch];
                  d[nx, j]:= true;
                  if b[j].t then
                  begin
                    st[nx]:= st[nx] or b[j].e;
                    res[l, nx]:=  res[l, nx] or b[j].e;
                  end;
                end;
    end;
  end;
  ans:= res[1, n];
end;

procedure init;
begin
  fillchar(b, sizeof(b), 0);
  k:= 1;
end;

procedure ReadData;
var
  i, t : int;
  ch : char;
  OL : int;
begin
  init;
  readln(s);
  assert((length(s) > 0) and (length(s) <= nmax));
  readln(n);
  assert((n >= 1) and (n <= kmax));
  OL:= 0;
  for i:= 1 to n do
  begin
    t:= 1;
    read(ch);
    while ch <> ' ' do
    begin
      inc(OL);
      assert(ch in ['A'..'Z']);
      if b[t].p[ch] = 0 then
      begin
        inc(k);
        b[k].par:= t;
        b[k].ch:= ch;
        b[k].t:= false;
        b[t].p[ch]:= k;
      end;
      t:= b[t].p[ch];
      read(ch);
    end;
    b[t].t:= true;
    if not seekeoln then read(ch);
    b[t].e:= b[t].e or (1 shl (ord(ch) - ord('A')));
    readln;
  end;
  assert(OL <= lmax);
  n:= length(s);
end;

begin
  assign(input,cinfile);
  assign(output,coutfile);
  reset(input);
  rewrite(output);
  ReadData;
  Solve;
  OutData;
  close(input);
  close(output);
end.
