{$D+,L+,I+,Q+,R+,S+}
{$APPTYPE CONSOLE}
Program necklace2_alx_slow;
const
  inpfile='necklace2.in';
  outfile='necklace2.out';
  nm=100005;
  km=10005;
  inf : Int64 = nm*Int64(MaxLongInt);
  eps=1e-10;
type
  Stone = record
    ang : Extended;
    w : Int64;
  end;  
var
  a : array [1..nm] of Stone;
  b : array [1..km] of Int64;
  n,k : LongInt;
  dang : Extended;
  ans : Int64;
{}
Procedure Inp;
var
  i : LongInt;
begin
  assign(input,inpfile);
  reset(input);
  read(n,k);
  for i:=1 to n do
    read(a[i].ang,a[i].w);
end;
{}
Procedure Out;
begin
  assign(output,outfile);
  rewrite(output);
  writeln(ans);
  close(output);
  halt;
end;
{}
Procedure Init;
begin
  fillchar(a,sizeof(a),0);
end;
{}
Procedure Solve;
var
  wmin,wmax : Int64;
  i,j,h : LongInt;
  ang : Extended;
begin
  dang:=2*pi/k;

  ans:=inf;
  for i:=1 to n do begin
    fillchar(b,sizeof(b),0);
    wmin:=inf; wmax:=-inf;
    for j:=1 to n do begin
      ang:=a[j].ang+a[i].ang+eps;
      while ang>2*pi do ang:=ang-2*pi;
      h:=trunc(ang/dang)+1;
      inc(b[h],a[j].w);
    end;

    for j:=1 to k do begin
      if b[j]>wmax then wmax:=b[j];
      if b[j]<wmin then wmin:=b[j];
    end;

    if wmax-wmin<ans then ans:=wmax-wmin;  
  end;
end;
{}
Begin
  Init;
  Inp;
  Solve;
  Out;
End.
