{$A8,B-,C+,D+,E-,F-,G+,J-,K-,L+,M-,N+,P+,T-,U-,V+,W-,X+,Y+,Z1}
{$Q+,R+,S+,O-,H+,I+}
{$MINSTACKSIZE $00004000}
{$MAXSTACKSIZE $00100000}
{$IMAGEBASE $00400000}
{$APPTYPE console}

uses SysUtils;

const
  cinfile = 'necklace2.in';
  coutfile = 'necklace2.out';

  inf = maxlongint shr 1;
  eps = 1e-8;

  nmax = 10000;

type
  int = longint;
  real = extended;

var
  ans : int;
  n, m, k : int;

  u : array [1..2*nmax + 10] of real;
  c : array [1..2*nmax + 10] of int64;

procedure outdata;
var
  i, j : int;
begin
  writeln(ans);
end;

procedure solve;
var
  i, j : int;
  x : real;
  x2 : int64;

  cu : real;
  s, min, max : int64;
  cp : int;
begin
  for i:= 1 to n - 1 do
    for j:= i + 1 to n do
      if u[i] > u[j] then
      begin
        x:= u[i];
        u[i]:= u[j];
        u[j]:= x;
        x2:= c[i];
        c[i]:= c[j];
        c[j]:= x2;
      end;
  for i:= 1 to n + 4 do c[n + i]:= c[i];
  for i:= 1 to n + 4 do u[n + i]:= u[i] + 2*pi;
  ans:= inf;
  for i:= 1 to n do
  begin
    cu:= u[i];
    cp:= i + 1;
    min:= inf;
    max:= -inf;
    for j:= 1 to k do
    begin
      s:= 0;
      while u[cp] - cu < 2*pi / k + 1e-8 do
      begin
        inc(s, c[cp]);
        inc(cp);
      end;
      if min > s then min:= s;
      if max < s then max:= s;
      cu:= cu + 2*pi / k;
    end;
    if ans > max - min then ans:= max - min;
  end;
end;

procedure readdata;
var
  i, j : int;
begin
  read(n, k);
  for i:= 1 to n do read(u[i], c[i]);
end;

begin
  reset(input, cinfile);
  rewrite(output, coutfile);
  readdata;
  solve;
  outdata;
  close(input);
  close(output);
end.
