{$A8,B-,C+,D+,E-,F-,G+,J-,K-,L+,M-,N+,P+,T-,U-,V+,W-,X+,Y+,Z1}
{$Q+,R+,S+,O-,H+,I+}
{$MINSTACKSIZE $00004000}
{$MAXSTACKSIZE $00100000}
{$IMAGEBASE $00400000}
{$APPTYPE console}

uses SysUtils;

const
  cinfile = 'chat.in';
  coutfile = 'chat.out';

  inf = maxlongint shr 1;
  eps = 1e-8;

  nmax = 1201;

type
  int = longint;
  real = extended;

  vector = array [1..nmax] of int;
  TarVector = array [1..nmax] of vector;

var
  ans : int;
  n, m, k : int;

  a : TarVector;
  p : array [1..nmax] of int;
  
procedure outdata;
var
  i, j : int;
begin

end;

function less(const a, b : vector) : boolean;
var
  i : int;
begin
  for i:= 1 to n + 1 do
    if a[i] <> b[i] then
    begin
      less:= a[i] < b[i];
      exit;
    end;
  less:= false;
end;

function lessG(const a, b : vector) : boolean;
var
  i : int;
begin
  for i:= 1 to n do
    if a[i] > b[i] then
    begin
      lessG:= false;
      exit;
    end;
  lessG:= true;
end;

procedure sort(var a : TarVector; n : int);
var
  l, r : int;
  x : int;

  procedure sift;
  var
    i, j : int;
  begin
    x:= p[l];
    i:= l;
    j:= i shl 1;
    if (j < r) and less(a[p[j]], a[p[j + 1]]) then inc(j);
    while (j <= r) and less(a[x], a[p[j]]) do
    begin
      p[i]:= p[j];
      i:= j;
      j:= i shl 1;
      if (j < r) and less(a[p[j]], a[p[j + 1]]) then inc(j);
    end;
    p[i]:= x;
  end;

begin
  r:= n;
  for l:= n shr 1 downto 1 do sift;
  l:= 1;
  for r:= n - 1 downto 1 do
  begin
    x:= p[1];
    p[1]:= p[r + 1];
    p[r + 1]:= x;
    sift;
  end;
end;

procedure solve;
var
  i, j : int;
begin
  for i:= 1 to n do a[i, n + 1]:= i;
  for i:= 1 to n do p[i]:= i;
  sort(a, n);
  for i:= 1 to n - 1 do
    if not lessG(a[p[i]], a[p[i + 1]]) then
    begin
      writeln(-1);
      exit;
    end;
  for i:= 1 to n do write(p[i], ' ');
  writeln;
end;

procedure readdata;
var
  i, j : int;
  max : int;
begin
  assert(not seekeof);
  read(n);
  assert(IoResult = 0);
  if n = 0 then exit;
  assert((n >= 1) and (n <= 1200));
  for i:= 1 to n do
    for j:= 1 to n do
    begin
      read(a[i, j]);
      assert(IoResult = 0);
      assert((a[i, j] >= 0) and (a[i, j] <= 10000));
    end;
  for i:= 1 to n do assert(a[i, i] = 0);
  for j:= 1 to n do
  begin
    max:= a[1, j];
    for i:= 2 to n do
      if max < a[i, j] then max:= a[i, j];
    a[j, j]:= max;
  end;
end;

begin
  reset(input, cinfile);
  rewrite(output, coutfile);
  while true do
  begin
    readdata;
    if n = 0 then
    begin
      assert(seekeof);
      break;
    end;
    solve;
    outdata;
  end;
  assert(seekeof);
  close(input);
  close(output);
end.
