{$D+,L+,I+,Q+,R+,S+,O+}
{$apptype console}
Program path_alx;
const
  inpfile='path.in';
  outfile='path.out';
  nm = 1000;
type
  Vector = array [0..nm] of LongInt;
var
  a : array [1..nm] of Vector;
  b : array [1..nm] of LongInt;
  u,v : array [1..nm] of LongInt;
  s,n,m,cnt : LongInt;
{}
Procedure Inp;
var
  i,x,y : LongInt;
begin
  assign(input,inpfile);
  reset(input);
  for i:=1 to n do a[i,0]:=0;

  read(n,m);
  for i:=1 to m do begin
    read(x,y);
    inc(a[x,0]); a[x,a[x,0]]:=y;
    inc(a[y,0]); a[y,a[y,0]]:=x;
    inc(b[x]); inc(b[y]);
  end;
end;
{}
Procedure Out;
var
  i : LongInt;
begin
  assign(output,outfile);
  rewrite(output);
  if u[1]=0 then writeln('Impossible')
  else begin
    for i:=1 to n do v[u[i]]:=i;
    for i:=1 to n do write(v[i],' ');
  end;  
  close(output);
  halt;
end;
{}
Procedure Init;
begin
  fillchar(b,sizeof(b),0);
  fillchar(u,sizeof(u),0);
end;
{}
Procedure Swap(var q,w : LongInt);
var
  bak : LongInt;
begin
  bak:=q;
  q:=w;
  w:=bak;
end;
{}
Procedure Sort(x,l,r : LongInt);
var
  i,j,d : LongInt;
begin
  i:=l; j:=r; d:=b[a[x,(l+r) div 2]];
  repeat
    while b[a[x,i]]<d do inc(i);
    while d<b[a[x,j]] do dec(j);
    if i<=j then begin
      Swap(a[x,i],a[x,j]);
      inc(i); dec(j);
    end;
  until i>j;
  if l<j then Sort(x,l,j);
  if i<r then Sort(x,i,r);
end;
{}
var
  ok : Boolean;
{}
Procedure Dfs(x : LongInt);
var
  i,j,y : LongInt;
begin
  inc(cnt);
  u[x]:=cnt;

  if cnt=n then begin
    Out;
  end;

  if a[x,0] > 1 then
    Sort(x, 1, a[x,0]);

  for j:=1 to a[x,0] do
    if u[a[x,j]]=0 then begin
      dec(b[a[x,j]]);
      if (b[a[x,j]]=0) and (cnt<n-1)  then ok:=false;
    end;

  if ok then
      for i:= 1 to a[x,0] do begin
        y:=a[x,i];
        if u[y]=0 then begin
          Dfs(y);
          if b[y]=0 then break
        end;
      end;

  for j:=1 to a[x,0] do
    if u[a[x,j]]=0 then inc(b[a[x,j]]);
 
  ok:=true;
  dec(cnt);
  u[x]:=0;
end;
{}
Procedure Solve;
var
  i : LongInt;
begin
  ok:=true;
  cnt:=0;
  s:=1;
  for i:=2 to n do
    if b[i]<b[s] then s:=i;
    
  Dfs(s);
end;
{}
Begin
  Init;
  Inp;
  Solve;
  Out;
End.
