{$D+,L+,I+,Q+,R+,S+,O-}
Program rhyme_alx_bad2;
Uses SysUtils;
const
  inpfile='rhyme.in';
  outfile='rhyme.out';
  nm=50;
  km=50;
  nm2=nm*(2*km+1);
  mm=2*(nm*2*km+1005);
var
  a : array [1..nm2] of LongInt;
  ee : array [1..mm] of record
    x,next : LongInt;
  end;
  c,f : array [1..nm2,1..nm2] of ShortInt;
  n,k,m,ne : LongInt;
  s,t,res : LongInt;

  v : array [1..nm,1..nm,1..km] of Boolean;

  d : array [1..nm2] of LongInt;
  p : array [1..nm2] of LongInt;
  u : array [1..nm2] of Boolean;
  way : array [1..nm2] of LongInt;
  wlen : LongInt;
{}
Procedure Inp;
var
  i,j,x,y,col : LongInt;
begin
  assign(input,inpfile);
  reset(input);
  ne:=0;
  read(n,k,s,t,m);
  assert((1<=n) and (n<=50) and (1<=k) and (k<=50) and (1<=m) and (m<=1000));
  assert((1<=s) and (s<=n) and (1<=t) and (t<=n) and (s<>t));

  for i:=1 to n do begin
    for j:=1 to k do begin
      inc(ne);
      ee[ne].x:=i;
      ee[ne].next:=a[n+2*k*(i-1)+j];
      a[n+2*k*(i-1)+j]:=ne;
      c[n+2*k*(i-1)+j,i]:=1;

      inc(ne);
      ee[ne].x:=n+2*k*(i-1)+j;
      ee[ne].next:=a[i];
      a[i]:=ne;

      inc(ne);
      ee[ne].x:=n+2*k*(i-1)+k+j;
      ee[ne].next:=a[i];
      a[i]:=ne;
      c[i,n+2*k*(i-1)+k+j]:=1;

      inc(ne);
      ee[ne].x:=i;
      ee[ne].next:=a[n+2*k*(i-1)+k+j];
      a[n+2*k*(i-1)+k+j]:=ne;
    end;
  end;

  for i:=1 to m do begin
    read(x,y,col);
    assert((1<=x) and (x<=n) and (1<=y) and (y<=n) and (1<=col) and (col<=k));
    assert(not v[x,y,col]);
    v[x,y,col]:=true;

    inc(ne);
    ee[ne].x:=n+2*k*(y-1)+col;
    ee[ne].next:=a[n+2*k*(x-1)+k+col];
    a[n+2*k*(x-1)+k+col]:=ne;
    c[n+2*k*(x-1)+k+col,n+2*k*(y-1)+col]:=1;

    inc(ne);
    ee[ne].x:=n+2*k*(x-1)+k+col;
    ee[ne].next:=a[n+2*k*(y-1)+col];
    a[n+2*k*(y-1)+col]:=ne;
  end;
end;
{}
Procedure Dfs(x : LongInt);
var
  j : LongInt;
begin
  inc(wlen);
  way[wlen]:=x;

  if x=t then exit;
  u[x]:=true;

  j:=a[x];
  while j<>0 do begin
    if (f[x,ee[j].x]=1) and not u[ee[j].x] then begin
      dec(f[x,ee[j].x]);
      inc(f[ee[j].x,x]);
      Dfs(ee[j].x);
      break;
    end; 
    j:=ee[j].next;
  end;
end;
{}
Procedure Out;
var
  i,j,col : LongInt;
begin
  assign(output,outfile);
  rewrite(output);
  writeln(res);
  for i:=1 to res do begin
    fillchar(u,sizeof(u),0);
    wlen:=0;
    Dfs(s);

    write(way[1],' ');
    j:=4;
    while j<=wlen do begin
      col:=way[j-2];
      dec(col,n);
      col:=col-2*k*(way[j-3]-1)-k;
      write(col,' ',way[j],' ');
      inc(j,3);
    end;
    writeln;
  end;
  close(output);
  halt;
end;
{}
Procedure Init;
begin
  fillchar(a,sizeof(a),0);
  fillchar(c,sizeof(c),0);
  fillchar(f,sizeof(f),0);
  fillchar(v,sizeof(v),0);
end;
{}
Function Bfs(s,t : LongInt) : Boolean;
var
  q,w : LongInt;
  i,j : LongInt;
begin
  fillchar(u,sizeof(u),0);
  
  Bfs:=false;
  q:=0; w:=1;
  d[1]:=s; u[s]:=true;
  while q<w do begin
    inc(q);

    j:=a[d[q]];
    while (j<>0) do begin
      if not u[ee[j].x] and (c[d[q],ee[j].x]>0) then begin
        inc(w);
        d[w]:=ee[j].x;
        u[ee[j].x]:=true;
        p[d[w]]:=d[q];
        if d[w]=t then break;
      end;
      j:=ee[j].next;
    end;

    if d[w]=t then break;
  end;

  if d[w]<>t then exit;

  wlen:=0;
  j:=d[w];
  while j<>0 do begin
    inc(wlen);
    way[wlen]:=j;
    j:=p[j];
  end;
  Bfs:=true; 
end;
{}
Procedure Solve;
var
  i,j : LongInt;
  ok : Boolean;
begin
  res:=0;
  repeat
    ok:=true;
    if Bfs(s,t) then begin
      inc(res);
      for i:=wlen downto 2 do begin
        inc(f[way[i],way[i-1]]);
        dec(c[way[i],way[i-1]]);

        if random(2)=1 then begin
          dec(f[way[i-1],way[i]]);
          inc(c[way[i-1],way[i]]);
        end;
      end;
    end else ok:=false;
  until not ok;
end;
{}
Begin
  randseed:=76125;
  Init;
  Inp;
  Solve;
  Out;
End.
