{$O-,Q+,R+}
uses SysUtils;

const MaxN=50000;
      MaxK=50000;
      MaxC=10000;
      eps=1e-12;

var x, y, z:array [0..MaxN+1] of integer;


function lessp (x1, y1, x2, y2:integer):boolean;
begin                              
  Result:=(y1<y2) or ((y1=y2) and (x1<x2));
end;

function less (i, j:integer):boolean;
begin
  Result:=lessp (x[i], y[i], x[j], y[j]);
end;

procedure qsort (l, r:integer);
var i, j, a, b:integer;
begin
  if l>=r then exit;
  i:=l; j:=r; a:=z[(l+r) shr 1];
  repeat
    while less (z[i], a) do inc (i);
    while less (a, z[j]) do dec (j);
    if i<=j then begin
      b:=z[i]; z[i]:=z[j]; z[j]:=b;
      inc (i); dec (j)
    end
  until i>j;
  qsort (l, j);
  qsort (i, r);
end;

var i, n, k, ly, cy, cj:integer;
    a, b, c, d, y1, y2, s, c1, c2, ls, cs:extended;

begin
  reset (input, 'antiufo.in');
  rewrite (output, 'antiufo.out');
  assert (not seekeoln); read (n); assert ((n>=3) and (n<=MaxN));
  assert (not seekeoln); read (k); assert ((k>=1) and (k<=MaxK));
  assert (seekeoln); readln;
  for i:=1 to n do begin
    assert (not seekeoln); read (x[i]); assert (abs (x[i])<=MaxC);
    assert (not seekeoln); read (y[i]); assert (abs (y[i])<=MaxC);
    assert (seekeoln); readln;
    z[i]:=i;
  end;
  x[n+1]:=x[1]; y[n+1]:=y[1]; x[0]:=x[n]; y[0]:=y[n];
  s:=0;
  for i:=1 to n do s:=s-x[i]*y[i+1]+x[i+1]*y[i];
  for i:=1 to n do assert ((x[i]-x[i-1])*(y[i+1]-y[i])-(x[i+1]-x[i])*(y[i]-y[i-1])<>0);
  assert ((s>=0));
  assert (seekeof);
  qsort (1, n);
  c1:=0; c2:=0; ly:=-10001; cy:=ly; ls:=0; cs:=0; cj:=1;
  for i:=1 to n do begin
    {event happens}
    cy:=y[z[i]];
    if cy<>ly then begin
      ls:=cs;
      cs:=cs+c2*sqr (cy-ly)+2*c1*(cy-ly);
      while cs*(K+1)+eps>s*cj do begin
        a:=c2*(k+1);
        b:=2*(k+1)*(c1 - c2*ly);
        c:=(k+1)*(ls+c2*sqr (ly)-2*c1*ly)-s*cj;
        //writeln (a, ' ', b, ' ', c);
        if abs (a)<eps then begin
          assert (abs (b)>eps); writeln (-c/b:0:20);
        end else begin
          d:=sqr (b)-4*a*c; assert ((d>-eps));
          if abs (d)<eps then d:=0 else d:=sqrt (d);
          y1:=(-b-d)/(2*a);
          y2:=(-b+d)/(2*a);
          if (y1<ly-eps) or (y1>cy+eps) then writeln (y2:0:20) 
                                        else writeln (y1:0:20);
        end;
        inc (cj); if cj=K+1 then inc (cj);
      end;
      c1:=c1+c2*(cy-ly);
      ly:=cy;
    end;
    //writeln (i, ' ', z[i], ' ', x[z[i]], ' ', y[z[i]], ' ', cs:0:10);
    if y[z[i]-1]<>y[z[i]] then c2:=c2-(x[z[i]-1]-x[z[i]])/(y[z[i]]-y[z[i]-1])
    else c1:=c1-(x[z[i]]-x[z[i]-1])/2;
    if y[z[i]+1]<>y[z[i]] then c2:=c2+(x[z[i]+1]-x[z[i]])/(y[z[i]]-y[z[i]+1])
    else c1:=c1-(x[z[i]+1]-x[z[i]])/2;
    //writeln ('* ', c1, ' ', c2:0:10, ' ', cs:0:10);
  end;
  //writeln (cs, ' ', s);
end.