#include <stdio.h>

#define FILE_IN "form.in"
#define FILE_OUT "form.out"
#define MAXN 100000

long long a[MAXN*4],b[MAXN];
int n,k;
int h[MAXN];
int shift;

void Init(){
  shift=1;
  while (shift<n) shift<<=1;
  shift--;
}

void Change(int k,long long newkey){
  a[shift+k]=newkey;
  k+=shift;
  while (k>0) {
    k=(k-1)/2;
    a[k]=a[2*k+1]+a[2*k+2];
  }
}

long long GetSum(int k){
  if (k<0) return 0;
  k+=shift;
  long long s=a[k];
  while (k>0) {
    if ((k+1)%2) s+=a[k-1];
    k=(k-1)/2;
  }
  return s;
}

void FillZero(){
  int i;
  for (i=0;i<shift+n;i++) a[i]=0;
}

int main(){
  freopen(FILE_IN,"r",stdin);
  freopen(FILE_OUT,"w",stdout);

  scanf("%d %d",&n,&k);
  int i;
  for (i=0;i<n;i++) {
    scanf("%d",&h[i]);
  }

  int j;
  for (i=0;i<n;i++) b[i]=1;
  Init();
  
  int t;
  long long c;
  for (j=1;j<=k;j++){
    FillZero();
    for (i=0;i<n;i++){
      c=GetSum(h[i]-2);
      Change(h[i]-1,b[i]);
      b[i]=c;
    }
  }
  c=0;
  for (i=0;i<n;i++) c+=b[i];

  printf("%Ld",c);

  fclose(stdin);
  fclose(stdout);
  return 0;
}