{$D+,L+,I+,Q+,R+,S+}
Program king_alx;
const
  inpfile='king.in';
  outfile='king.out';
  inf : Int64 = Int64(MaxLongInt)*Int64(MaxLongInt);
  big=1000000000;
  nm=505;
  nm2=10*nm;
  dx : array [1..8] of LongInt = (1,1,0,-1,-1,-1,0,1);
  dy : array [1..8] of LongInt = (0,1,1,1,0,-1,-1,-1);
type
  Coord = record
    x,y : LongInt;
  end;
var
  a : array [1..nm] of Coord;
  b,c,d,e : array [1..nm] of LongInt;
  v : array [0..nm2] of Int64;
  f : array [1..nm2] of Coord;
  u : array [1..nm2] of Boolean;
  s,t : Coord;
  n : LongInt;
{}
Procedure Inp;
var
  i,j : LongInt;
begin
  assign(input,inpfile);
  reset(input);
  read(s.x,s.y,t.x,t.y,n);
  assert((abs(s.x)<=big) and (abs(s.y)<=big));
  assert((abs(t.x)<=big) and (abs(t.y)<=big));
  assert((0<=n) and (n<=500));
  for i:=1 to n do
    read(a[i].x,a[i].y);

  for i:=1 to n-1 do
    for j:=i+1 to n do
      assert((a[i].x<>a[j].x) or (a[i].y<>a[j].y));

  for i:=1 to n do
    assert((s.x<>a[i].x) or (s.y<>a[i].y));
end;
{}
Procedure Out(ok : Boolean);
begin
  assign(output,outfile);
  rewrite(output);
  if ok then writeln(v[2])
        else writeln(-1);
  close(output);
  halt;
end;
{}
Procedure Init;
begin
  fillchar(u,sizeof(u),0);
end;
{}
Procedure Swap(var q,w : LongInt);
var
  bak : LongInt;
begin
  bak:=q;
  q:=w;
  w:=bak;
end;
{}
Procedure SortB(l,r : LongInt);
var
  i,j : LongInt;
  x : Coord;
begin
  i:=l; j:=r; x:=a[b[(l+r) div 2]];
  repeat
    while (a[b[i]].y<x.y) or ((a[b[i]].y=x.y) and (a[b[i]].x<x.x)) do inc(i);
    while (x.y<a[b[j]].y) or ((x.y=a[b[j]].y) and (x.x<a[b[j]].x)) do dec(j);
    if i<=j then begin
      Swap(b[i],b[j]);
      inc(i); dec(j);
    end;
  until i>j;
  if l<j then SortB(l,j);
  if i<r then SortB(i,r);
end;
{}
Procedure SortC(l,r : LongInt);
var
  i,j : LongInt;
  x : Coord;
begin
  i:=l; j:=r; x:=a[c[(l+r) div 2]];
  repeat
    while (a[c[i]].x<x.x) or ((a[c[i]].x=x.x) and (a[c[i]].y<x.y)) do inc(i);
    while (x.x<a[c[j]].x) or ((x.x=a[c[j]].x) and (x.y<a[c[j]].y)) do dec(j);
    if i<=j then begin
      Swap(c[i],c[j]);
      inc(i); dec(j);
    end;
  until i>j;
  if l<j then SortC(l,j);
  if i<r then SortC(i,r);
end;
{}
Procedure SortD(l,r : LongInt);
var
  i,j : LongInt;
  x : Coord;
begin
  i:=l; j:=r; x:=a[d[(l+r) div 2]];
  repeat
    while (a[d[i]].x-a[d[i]].y<x.x-x.y) or ((a[d[i]].x-a[d[i]].y=x.x-x.y) and (a[d[i]].x<x.x)) do inc(i);
    while (x.x-x.y<a[d[j]].x-a[d[j]].y) or ((x.x-x.y=a[d[j]].x-a[d[j]].y) and (x.x<a[d[j]].x)) do dec(j);
    if i<=j then begin
      Swap(d[i],d[j]);
      inc(i); dec(j);
    end;
  until i>j;
  if l<j then SortD(l,j);
  if i<r then SortD(i,r);
end;
{}
Procedure SortE(l,r : LongInt);
var
  i,j : LongInt;
  x : Coord;
begin
  i:=l; j:=r; x:=a[e[(l+r) div 2]];
  repeat
    while (a[e[i]].x+a[e[i]].y<x.x+x.y) or ((a[e[i]].x+a[e[i]].y=x.x+x.y) and (a[e[i]].x<x.x)) do inc(i);
    while (x.x+x.y<a[e[j]].x+a[e[j]].y) or ((x.x+x.y=a[e[j]].x+a[e[j]].y) and (x.x<a[e[j]].x)) do dec(j);
    if i<=j then begin
      Swap(e[i],e[j]);
      inc(i); dec(j);
    end;
  until i>j;
  if l<j then SortE(l,j);
  if i<r then SortE(i,r);
end;
{}
Function Max(q,w : Int64) : Int64;
begin
  if q>w then max:=q else max:=w;
end;
{}
Function Len(var q,w : Coord) : Int64;
begin
  Len:=max(abs(q.x-w.x),abs(q.y-w.y));
end;
{}
Procedure SwapP(var q,w : Coord);
var
  bak : Coord;
begin
  bak:=q;
  q:=w;
  w:=bak;
end;
{}
Function FreeSegmentB(q,w : Coord) : Boolean;
var
  l,r,m : LongInt;
begin
  FreeSegmentB:=false;

  l:=1; r:=n;
  while l<r do begin
    m:=(l+r) div 2;
    if (a[b[m]].y<q.y) or ((a[b[m]].y=q.y) and (a[b[m]].x<q.x)) then l:=m+1
                                                                else r:=m;
  end;

  if (a[b[l]].y=q.y) and (a[b[l]].x>=q.x) and (a[b[l]].x<=w.x) then exit;
  FreeSegmentB:=true;
end;
{}
Function FreeSegmentC(q,w : Coord) : Boolean;
var
  l,r,m : LongInt;
begin
  FreeSegmentC:=false;

  l:=1; r:=n;
  while l<r do begin
    m:=(l+r) div 2;
    if (a[c[m]].x<q.x) or ((a[c[m]].x=q.x) and (a[c[m]].y<q.y)) then l:=m+1
                                                                else r:=m;
  end;
  
  if (a[c[l]].x=q.x) and (a[c[l]].y>=q.y) and (a[c[l]].y<=w.y) then exit;
  FreeSegmentC:=true;
end;
{}
Function FreeSegmentD(q,w : Coord) : Boolean;
var
  l,r,m : LongInt;
begin
  FreeSegmentD:=false;

  l:=1; r:=n;
  while l<r do begin
    m:=(l+r) div 2;
    if (a[d[m]].x-a[d[m]].y<q.x-q.y) or ((a[d[m]].x-a[d[m]].y=q.x-q.y) and (a[d[m]].x<q.x)) then l:=m+1
                                                                                           else r:=m;
  end;

  if (a[d[l]].x-a[d[l]].y=q.x-q.y) and (a[d[l]].x>=q.x) and (a[d[l]].x<=w.x) then exit;
  FreeSegmentD:=true;
end;
{}
Function FreeSegmentE(q,w : Coord) : Boolean;
var
  l,r,m : LongInt;
begin
  FreeSegmentE:=false;

  l:=1; r:=n;
  while l<r do begin
    m:=(l+r) div 2;
    if (a[e[m]].x+a[e[m]].y<q.x+q.y) or ((a[e[m]].x+a[e[m]].y=q.x+q.y) and (a[e[m]].x<q.x))then l:=m+1
                                                                                           else r:=m;
  end;

  if (a[e[l]].x+a[e[l]].y=q.x+q.y) and (a[e[l]].x>=q.x) and (a[e[l]].x<=w.x) then exit;
  FreeSegmentE:=true;
end;
{}
Function FreeWay(q,w : Coord) : Boolean;
var
  p : Coord;
begin
  FreeWay:=false;

  if q.x>w.x then SwapP(q,w);
  if abs(q.x-w.x)>abs(q.y-w.y) then begin
    if q.y<w.y then begin
      p.x:=q.x+abs(q.x-w.x)-abs(q.y-w.y);
      p.y:=q.y;

      if not FreeSegmentB(q,p) then exit;
      if not FreeSegmentD(p,w) then exit;
    end else begin
      p.x:=q.x+abs(q.x-w.x)-abs(q.y-w.y);
      p.y:=q.y;

      if not FreeSegmentB(q,p) then exit;
      if not FreeSegmentE(p,w) then exit;
    end;
  end else begin
    if q.y<w.y then begin
//      p.x:=q.x;
//      p.y:=q.y+abs(q.y-w.y)-abs(q.x-w.x);

//      if not FreeSegmentC(q,p) then exit;
//      if not FreeSegmentD(p,w) then exit;
    end else begin
      p.x:=q.x;
      p.y:=q.y-(abs(q.y-w.y)-abs(q.x-w.x));

      if not FreeSegmentC(p,q) then exit;
      if not FreeSegmentE(p,w) then exit;
    end;
  end;

  FreeWay:=true;
end;
{}
Procedure Solve;
var
  i,j,mini : LongInt;
  dist : Int64;
begin
  if n=0 then begin
    v[2]:=max(abs(s.x-t.x),abs(s.y-t.y));
    Out(true);
  end;

  for i:=1 to n do begin
    b[i]:=i; c[i]:=i;
    d[i]:=i; e[i]:=i;
  end;

  SortB(1,n);
  SortC(1,n);
  SortD(1,n);
  SortE(1,n);

  for i:=0 to 2+8*n do v[i]:=inf;
  v[1]:=0;

  f[1]:=s; f[2]:=t;
  for i:=1 to n do
    for j:=1 to 8 do begin
      f[2+8*(i-1)+j].x:=a[i].x+dx[j];
      f[2+8*(i-1)+j].y:=a[i].y+dy[j];
    end;

  while not u[2] do begin
    mini:=0;
    for i:=1 to 2+8*n do
      if not u[i] and (v[i]<v[mini]) then mini:=i;

    if mini=0 then Out(false);
    u[mini]:=true;

    for i:=1 to 2+8*n do
      if not u[i] then
        if FreeWay(f[mini],f[i]) then begin
          dist:=Len(f[mini],f[i]);
          if v[mini]+dist<v[i] then v[i]:=v[mini]+dist; 
        end;
  end;  
end;
{}
Begin
  Init;
  Inp;
  Solve;
  Out(true);
End.
