{$A+,B-,D+,E+,F-,G-,I+,L+,N-,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}
const
  problem='key';
  fin =problem+'.in';
  fout=problem+'.out';
  maxn=11000;
  maxm=1100;
  dx:array[0..2]of longint=(1,0,0);
  dy:array[0..2]of longint=(0,-1,1);

var
  ans:longint;
  key:array[0..110,0..110]of longint;
  a,b:array[-200..maxn,0..maxm]of byte;
  lp,rp,lp1,rp1:array[0..110]of longint;
  dp:array[0..110,0..110]of longint;
  i,j,n,m,nk,mk,l,r,k:longint;

procedure init;
var
  c:char;
begin
  assign(input,fin);
  reset(input);

    readln(nk,mk);
    fillchar(key,sizeof(key),0);
    fillchar(a,sizeof(a),0);
    fillchar(b,sizeof(b),0);
    for i:=1 to nk do begin
      for j:=1 to mk do begin
        read(c);
        if c='#' then
          key[i,j]:=1
        else
          key[i,j]:=0;
      end;
      readln;
    end;
    readln(n,m);
    for i:=1 to n do begin
      for j:=1 to m do begin
        read(c);
        if c='#' then
          a[i,j]:=1
        else
          a[i,j]:=0;
      end;
      readln;
    end;

  close(input);
end;

function canmove(x,y:longint;dir:longint):boolean;
var
  i,j:longint;
begin
  canmove:=true;
  case dir of
    {down}
    0:begin
      for i:=1 to mk do
        for j:=1 to dp[i,0] do
          if a[x+dp[i,j]-1,y+i-1]=1 then begin
            canmove:=false;
            exit;
          end;
    end;
    {left}
    1:begin
      for i:=1 to nk do
        if (a[x+i-1,y+lp[i]-1]=1)or(a[x+i-1,y+lp1[i]-1]=1) then begin
          canmove:=false;
          exit;
        end;
    end;
    {right}
    2:begin
      for i:=1 to nk do
        if (a[x+i-1,y+rp[i]-1]=1)or(a[x+i-1,y+rp1[i]-1]=1) then begin
          canmove:=false;
          exit;
        end;
    end;
  end;
end;

procedure done;forward;

procedure dfs(x,y:longint);
var
  i:longint;
begin
  b[x,y]:=1;
  a[x,y]:=3;
  if x>n then begin
    ans:=-1;
    done;
  end;
  if x+nk-1>ans then
    ans:=x+nk-1;
  for i:=0 to 2 do
    if b[x+dx[i],y+dy[i]]=0 then
      if canmove(x,y,i) then
        dfs(x+dx[i],y+dy[i]);
  a[x,y]:=0;
end;

procedure solve;
begin
  {generate profiles...}
  {dowm}
    for i:=1 to mk do
      for j:=nk downto 1 do
        if (key[j,i]=1)and(key[j+1,i]=0) then begin
          inc(dp[i,0]);
          dp[i,dp[i,0]]:=j+1;
        end;
  {left}
    for i:=1 to mk do
      if key[1,i]=1 then begin
        lp[1]:=i-1;
        lp[1]:=i-1;
        break;
      end;
    for i:=2 to nk do
      for j:=1 to mk do
        if (key[i,j]=1)or(key[i-1,j]=1) then begin
          lp[i]:=j-1;
          break;
        end;
    for i:=2 to nk do
      for j:=1 to mk do
        if (key[i,j]=1) then begin
          lp1[i]:=j-1;
          break;
        end;
  {right}
    for i:=mk downto 1 do
      if key[1,i]=1 then begin
        rp[1]:=i+1;
        rp1[1]:=i+1;
        break;
      end;
    for i:=2 to nk do
      for j:=mk downto 1 do
        if (key[i,j]=1)or(key[i-1,j]=1) then begin
          rp[i]:=j+1;
          break;
        end;
    for i:=2 to nk do
      for j:=mk downto 1 do
        if key[i,j]=1 then begin
          rp1[i]:=j+1;
          break;
        end;
  {profiles generated}
{
  show profiles...
  for i:=1 to nk do
    key[i,rp[i]]:=2;
  for i:=1 to nk do
    key[i,lp[i]]:=3;
  for i:=1 to mk do
    key[dp[i],i]:=4;
}
  for i:=-nk to n do begin
    a[i,0]:=1;
    b[i,0]:=1;
    b[i,m+2-mk]:=1;
    a[i,m+1]:=1;
  end;
  dfs(-nk,1);
end;

procedure done;
begin
  assign(output,fout);
  rewrite(output);

    write(ans);

  close(output);
  halt(0);
end;

begin
  init;
  solve;
  done;
end.
