{$A+,B-,D+,E+,F-,G-,I+,L+,N-,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}
const
  problem='chat';
  fin =problem+'.in';
  fout=problem+'.out';

type
  aaa=record
    l,r:longint;
  end;

var
  a:array[0..2000,0..2000]of longint;
  l:array[0..2000]of aaa;
  b,z,x:array[0..2000]of longint;
  i,j,k,n,m,ln,q,ans:longint;

procedure init;
begin

  fillchar(a,sizeof(a),0);
  fillchar(z,sizeof(z),0);
  fillchar(b,sizeof(b),0);
  fillchar(l,sizeof(l),0);
  ln:=0;
  ans:=0;
  read(n);
  if n=0 then
    exit;
  for i:=1 to n do begin
    for j:=1 to n do
      read(a[i,j]);
    a[i,n+1]:=i;
  end;

end;

procedure sort(l,r,k:longint);
var
  i,j,x,y:longint;
begin
  i:=l;
  j:=r;
  x:=a[b[(i+j)div 2],k];
  repeat
    while x>a[b[i],k] do
      inc(i);
    while x<a[b[j],k] do
      dec(j);
    if i<=j then begin
      y:=b[i];
      b[i]:=b[j];
      b[j]:=y;
      inc(i);
      dec(j);
    end;
  until i>j;
  if i<r then
    sort(i,r,k);
  if l<j then
    sort(l,j,k);
end;

procedure solve;
begin
  for j:=1 to n do begin
    k:=0;
    for i:=1 to n do
      if a[i,j]>k then
        k:=a[i,j];
    a[j,j]:=k;
  end;
  ln:=1;
  l[1].l:=1;
  l[1].r:=n;
  for i:=1 to n do begin
    z[i]:=i;
    x[i]:=i;
  end;
  for k:=1 to n+1 do begin
    for i:=1 to n do
      b[i]:=x[i];
    for i:=1 to ln do
      sort(l[i].l,l[i].r,k);
    for i:=1 to n do begin
      z[b[i]]:=i;
      x[i]:=b[i];
    end;
    for i:=1 to ln do
      for j:=l[i].l to l[i].r-1 do
        if a[x[j],k]<>a[x[j+1],k] then begin
          inc(ln);
          l[ln].l:=l[i].l;
          l[ln].r:=j;
          l[i].l:=j+1;
        end;
    if k=n+1 then
      exit;
    for i:=1 to n-1 do
      if a[x[i],k]>a[x[i+1],k] then begin
        ans:=-1;
        exit;
      end;
  end;
end;

procedure done;
begin
  if ans=-1 then
    writeln(-1)
  else begin
    for i:=1 to n do
      write(x[i],' ');
    writeln;
  end;
end;

begin
  assign(output,fout);
  rewrite(output);
  assign(input,fin);
  reset(input);
  repeat
    init;
    if n=0 then
      break;
    solve;
    done;
  until false;
  close(output);
  close(input);
end.
