{$A+,B-,D+,E+,F-,G-,I+,L+,N-,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}
const
  problem='rhyme';
  fin =problem+'.in';
  fout=problem+'.out';

var
  a,f:array[0..3000,1..5]of longint;
  z:array[0..3000]of longint;
  b,e:array[0..60]of longint;
  c,d:array[0..60,0..60]of longint;
  i,j,k,l,n,m,s,t,ans:longint;

procedure init;
begin
  assign(input,fin);
  reset(input);

    read(n,k,s,t,m);
    for i:=1 to m do begin
      read(a[i,1],a[i,2],a[i,3]);
      a[i,4]:=1;
      a[i,5]:=i;
    end;
    for i:=1 to m do begin
      a[i+m,1]:=a[i,2];
      a[i+m,2]:=a[i,1];
      a[i+m,3]:=-a[i,3];
      a[i+m,4]:=0;
      a[i+m,5]:=a[i,5];
    end;
    m:=2*m;
    fillchar(b,sizeof(b),0);
    for i:=1 to m do
      inc(b[a[i,1]]);
    inc(b[1]);
    for i:=1 to n do
      inc(b[i+1],b[i]);
    f:=a;
    fillchar(a,sizeof(a),0);
    for i:=1 to m do begin
      dec(b[f[i,1]]);
      a[b[f[i,1]]]:=f[i];
    end;
    f:=a;
    for i:=1 to m do
      f[i,4]:=0;
    for i:=1 to m do
      for j:=i+1 to m do
        if a[i,5]=a[j,5] then begin
          z[i]:=j;
          z[j]:=i;
        end;
  close(input);
end;

procedure push(k,q:longint);
begin
  inc(f[k,4],q);
  dec(f[z[k],4],q);
  if q<>1 then
    exit;
  if f[k,3]>0 then begin
    c[a[k,1],a[k,3]]:=1;
    d[a[k,2],a[k,3]]:=1;
  end
  else begin
    c[a[k,1],-a[k,3]]:=0;
    d[a[k,2],-a[k,3]]:=0;
  end;
end;

function dfs(v:longint):boolean;
var
  i:longint;
begin
  dfs:=false;
  if v=t then begin
    dfs:=true;
    exit;
  end;
  e[v]:=1;
  for i:=b[v] to b[v+1]-1 do begin
    if a[i,3]>0 then
      if (a[i,4]-f[i,4]>0)and(e[a[i,2]]=0)and(c[v,a[i,3]]=0)and(c[a[i,2],a[i,3]]=0) then
        if dfs(a[i,2]) then begin
          push(i,1);
          dfs:=true;
          exit;
        end;
    if a[i,3]<0 then
      if (a[i,4]-f[i,4]>0)and(e[a[i,2]]=2) then
        if dfs(a[i,2]) then begin
          push(i,1);
          dfs:=true;
          exit;
        end;
  end;
end;

function dfs1(v:longint):boolean;
var
  i:longint;
begin
  dfs1:=false;
  if v=t then begin
    writeln(v);
    dfs1:=true;
    exit;
  end;
  for i:=b[v] to b[v+1]-1 do
    if f[i,4]=1 then begin
      write(v,' ',f[i,3],' ');
      push(i,-1);
      dfs1:=dfs1(f[i,2]);
      exit;
    end;
end;

procedure solve;
begin
  fillchar(e,sizeof(e),0);
  while dfs(s) do
    fillchar(e,sizeof(e),0);
  ans:=0;
  for i:=b[s] to b[s+1]-1 do
    inc(ans,f[i,4]);
end;

procedure done;
begin
  assign(output,fout);
  rewrite(output);

    writeln(ans);
    while dfs1(s) do
     i:=i;

  close(output);
end;

begin
  init;
  solve;
  done;
end.
