{$A+,B-,D+,E+,F-,G-,I+,L+,N-,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}
{$M 16384,0,655360}
const
  problem='necklace';
  fin =problem+'.in';
  fout=problem+'.out';

var
  i,j,k,l,n,m:longint;
  cmin,cmax,gmin,gmax,sum:longint;
  a,b,c:array[0..100]of longint;

procedure init;
begin
  assign(input,fin);
  reset(input);

    read(n,k);
    sum:=0;
    for i:=1 to n do begin
      read(a[i]);
      inc(sum,a[i]);
    end;

  close(input);
end;

function dist(i,j:longint):longint;
begin
  if i<j then
    dist:=j-i-1
  else
    dist:=j+n-i-1;
end;

function next(i:longint):longint;
begin
  inc(i);
  if i>n then
    i:=1;
  next:=i;
end;

procedure dfs(ck,cn:longint);
var
  i,j,s,min,max:longint;
begin
  if ck=k then begin
    i:=cn;
    s:=0;
    repeat
      inc(s,a[i]);
      i:=next(i);
    until i=l;
    if s<cmin then
      cmin:=s;
    if s>cmax then
      cmax:=s;
    if cmax-cmin<gmax-gmin then begin
      gmin:=cmin;
      gmax:=cmax;
      c:=b;
    end;
    exit;
  end;
  if ck=0 then begin
    for i:=1 to n do begin
      l:=i;
      b[1]:=i;
      cmax:=-1000000000;
      cmin:=1000000000;
      dfs(1,i);
    end;
    exit;
  end;

  i:=next(cn);
  s:=a[cn];
  repeat
    if dist(i,l)<k-ck then
      break;
    if s-cmin>=gmax-gmin then
      break;
    if cmax-s<gmax-gmin then begin
      max:=cmax;
      min:=cmin;
      if s>cmax then
        cmax:=s;
      if s<cmin then
        cmin:=s;
      b[ck+1]:=i;
      dfs(ck+1,i);
      b[ck+1]:=0;
      cmax:=max;
      cmin:=min;
    end;
    inc(s,a[i]);
    i:=next(i);
  until false;
end;

procedure solve;
begin
  gmax:=1000000000;
  gmin:=-1000000000;
  dfs(0,0);
end;

procedure done;
begin
  assign(output,fout);
  rewrite(output);

    c[k+1]:=c[1];
    writeln(gmax-gmin);
    for i:=1 to k do begin
      j:=c[i];
      repeat
        write(j,' ');
        j:=next(j);
      until j=c[i+1];
      writeln;
    end;

  close(output);
end;

begin
  init;
  solve;
  done;
end.
