{$A+,B-,D+,E+,F-,G-,I+,L+,N-,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}
const
  problem='tree';
  fin =problem+'.in';
  fout=problem+'.out';

var
  i,j,l,k,n,m,p,k1:longint;
  cur,min,ans:longint;
  z,y:array[0..300,1..2]of longint;
  a,b,e:array[0..300,0..300]of longint;
  d,c,q:array[0..300]of longint;

procedure update(v,k,q:longint);
var
  i:longint;
begin
  if cur>=min then
    exit;
  if q>b[v,0] then begin
    if (cur<min)and(k=0) then begin
      min:=cur;
      e[n+1]:=e[0];
      a[v,k1]:=min;
    end;
    exit;
  end;
  if k<0 then
    exit;
  for i:=k downto 0 do
    if d[b[v,q]]>=i then begin
      cur:=cur+a[b[v,q],i];
      e[0,b[v,q]]:=i;
      update(v,k-i,q+1);
      e[0,b[v,q]]:=0;
      cur:=cur-a[b[v,q],i];
    end;
end;

procedure dfs(v:longint);
var
  i,u,j:longint;
begin
  c[v]:=1;
  d[v]:=1;
  for i:=1 to n-1 do begin
    if z[i,1]=v then begin
      u:=z[i,2];
      if c[u]=1 then
        continue;
      inc(b[v,0]);
      q[u]:=v;
      b[v,b[v,0]]:=u;
      dfs(u);
      d[v]:=d[v]+d[u];
    end;
    if z[i,2]=v then begin
      u:=z[i,1];
      if c[u]=1 then
        continue;
      inc(b[v,0]);
      q[u]:=v;
      b[v,b[v,0]]:=u;
      dfs(u);
      d[v]:=d[v]+d[u];
    end;
  end;
  a[v,0]:=0;
  a[v,d[v]]:=1;
  for i:=1 to d[v]-1 do begin
    cur:=0;
    min:=maxlongint;
    fillchar(e[0],sizeof(e[0]),0);
    k1:=i;
    update(v,i,1);
    e[0]:=e[n+1];
    for j:=1 to n do
      if e[0,j]<>0 then
        e[k1,j]:=e[0,j];
  end;
end;

procedure init;
begin
  assign(input,fin);
  reset(input);

    read(n,p);
    for i:=1 to n-1 do
      read(z[i,1],z[i,2]);

  close(input);
end;

procedure genans(v,k:longint);
var
  i:longint;
begin
  if k=0 then
    exit;
  if d[v]=k then begin
    inc(m);
    y[m,1]:=q[v];
    y[m,2]:=v;
    exit;
  end;
  for i:=1 to b[v,0] do
    genans(b[v,i],e[k,b[v,i]]);
end;

procedure solve;
begin
  fillchar(a,sizeof(a),1);
  dfs(1);
  ans:=a[1,n-p];
  k:=1;
  for i:=2 to n do
    if d[i]>=p then
      if ans>a[i,d[i]-p]+1 then begin
        ans:=a[i,d[i]-p]+1;
        k:=i;
      end;
  m:=0;
  if k<>1 then begin
    inc(m);
    y[m,2]:=k;
    y[m,1]:=q[k];
  end;
  l:=d[k]-p;
  genans(k,l);
end;

procedure done;
begin
  assign(output,fout);
  rewrite(output);

    writeln(ans);
    for i:=1 to n-1 do
      for j:=1 to m do
        if ((z[i,2]=y[j,1])and(z[i,1]=y[j,2]))or((z[i,1]=y[j,1])and(z[i,2]=y[j,2])) then
          write(i,' ');

  close(output);
end;

begin
  init;
  solve;
  done;
end.
