{$Q-,R-,S-,I-}

const maxr = 100;
      maxn = 10000;
      maxm = 1000;

var r, c, i, j , n, m, x: longint;
    line: array [1..maxm] of char;
    key: array [1..maxr, 1..2] of longint;
    lock: array [1..maxn, 1..maxm, 1..2] of integer;
    a, b: array [0..maxn+maxr, 0..maxm] of byte;
    ans: longint;

procedure process_key (const a: longint);
var i, f, l: longint;
begin
  f := 0;
  l := 0;
  for i := 1 to c do
    if line [i] = '#' then
    begin
      if f = 0 then f := i;
      l := i;
    end;
  key [a, 1] := f;
  key [a, 2] := l;
end;

procedure process_lock (const a: longint);
var i: longint;
begin
  if line [1] = '#' then lock [a, 1, 1] := -1 else
    lock [a, 1, 1] := 1;
  for i := 2 to m do
    if line [i] = '#' then lock [a, i, 1] := -1 else
      if line [i-1] = '#' then lock [a, i, 1] := i else
      lock [a, i, 1] := lock [a, i-1, 1];

  if line [m] = '#' then lock [a, m, 2] := -1 else
    lock [a, m, 2] := m;
  for i := m-1 downto 1 do
    if line [i] = '#' then lock [a, i, 2] := -1 else
      if line [i+1] = '#' then lock [a, i, 2] := i else
      lock [a, i, 2] := lock [a, i+1, 2];
end;

function min (const a, b: byte): byte;
begin
  if a < b then min := a else min := b;
end;

function check (const s, i, j: longint):byte;
var f, l, p: longint;
begin
  p := key [s, 1] + j - 1;
  f := lock [i, p, 1];
  l := lock [i, p, 2];
  if (f <= key [s, 1] + j - 1) and (l >= key [s, 2] + j - 1) then
    check := 1 else check := 0;
end;

function max (const a, b: longint): longint;
begin
  if a > b then max := a else max := b;
end;

function dfs (const x, y: longint): longint;
var q: longint;
begin
  q := x;
  b [x, y] := 1;
  if (b [x, y-1] = 0) and (a [x, y-1] = 1) then q := max (q, dfs (x, y-1));
  if (b [x, y+1] = 0) and (a [x, y+1] = 1) then q := max (q, dfs (x, y+1));
  if (b [x+1, y] = 0) and (a [x+1, y] = 1) then q := max (q, dfs (x+1, y));
  dfs := q;
end;

begin
  assign (input, 'key.in');
  reset (input);
  assign (output, 'key.out');
  rewrite (output);
  readln (r, c);
  for i := 1 to r do
  begin
    for j := 1 to c-1 do
      read (line [j]);
    readln (line [c]);
    process_key (i);
  end;
  readln (n, m);
  for i := 1 to n do
  begin
    for j := 1 to m-1 do
      read (line [j]);
    readln (line [m]);
    process_lock (i);
  end;
  for i := 1 to n+r-1 do
    for j := 1 to m-c+1 do
      a [i, j] := 1;
  for x := 1 to m-c+1 do
    for i := r downto 1 do
      for j := 1+r-i to n+r-i do
        a [j, x] := min (a [j, x], check (i, j-r+i, x));
  for i := 1 to m do
    a [0, i] := 1;
  ans := dfs (0, 1);
  if ans < n+r-1 then writeln (ans) else writeln (-1);
  close (input);
  close (output);
end.
