{$A+,B-,D-,E+,F-,G-,I-,L-,N-,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}
  Const File_In='divide.in';
        File_Out='divide.out';
        MaxLen=30001;
        MaxLen2=3000;
        Osn=10000;
  Type Int=LongInt;
       TNumber=Array [1..3,0..MaxLen] Of Int;
       TLong=Array [0..MaxLen2] Of Int;
       TNumber2=Array [1..2] Of TLong;
  Var A,B : TNumber;
      Answer : TNumber;
      A2,B2,Ans,Ans2 : TNumber2;
      Minus : Int;

Procedure OpenFiles;
Begin
  Assign(Input,File_In);
  ReSet(Input);
  Assign(Output,File_Out);
  ReWrite(Output);
End;

Function NextSymbol : Char;
  Var Symbol : Char;
Begin
  Read(Symbol);
  While Not (Symbol In ['0'..'9','.','(',')','-']) Do Read(Symbol);
  Minus :=Minus Xor Ord(Symbol='-');
  NextSymbol :=Symbol;
End;

Procedure ReadNumber(Var A : TNumber);
  Var I : Int;
      Symbol : Char;
Begin
  FillChar(A,SizeOf(A),0);
  I :=1;
  Repeat
    Symbol :=NextSymbol;
    Case Symbol Of
      '.' : Inc(I);
      '(' : Inc(I);
      '0'..'9' : Begin
                   Inc(A[I,0]);
                   A[I,A[I,0]] :=Ord(Symbol)-Ord('0');
                 End;
    End;
  Until EoLn;
End;

Procedure Init;
Begin
  Minus :=0;
  ReadNumber(A);
  ReadNumber(B);
End;

Procedure WriteAnswer;
  Var I : Int;
Begin
  If Minus=1 Then Write('-');
  For I :=Answer[1,0] DownTo 1 Do
    Write(Answer[1,I]);
  If Answer[2,0]+Answer[3,0]<>0 Then
    Begin
      Write('.');
      For I :=1 To Answer[2,0] Do
        Write(Answer[2,I]);
      If Answer[3,0]<>0 Then
        Begin
          Write('(');
          For I :=1 To Answer[3,0] Do
            Write(Answer[3,I]);
          Write(')');
        End;
    End;
End;

Function Max(Const A,B : Int) : Int;
Begin
  If A>B Then Max :=A
  Else Max :=B;
End;

Function Min(Const A,B : Int) : Int;
Begin
  If A<B Then Min :=A
  Else Min :=B;
End;

Function MoreEq(Const A,B : TLong; Const S : Int) : Boolean;
  Var I : Int;
Begin
  MoreEq :=True;
  If A[0]>B[0]+S Then MoreEq :=True
  Else If A[0]<B[0]+S Then MoreEq :=False
  Else For I :=A[0] DownTo 1 Do
         If ((I<=S) And (A[I]>0)) Or ((I>S) And (A[I]>B[I-S])) Then
           Begin
             MoreEq :=True;
             Exit
           End
         Else If (I>S) And (A[I]<B[I-S]) Then
                Begin
                  MoreEq :=False;
                  Exit;
                End
End;

Function Eq(Const A,B : TLong) : Boolean;
  Var I : Int;
Begin
 Eq :=True;
 If A[0]<>B[0] Then Eq :=False
 Else For I :=1 To A[0] Do
   If A[I]<>B[I] then
     Begin
       Eq :=False;
       Exit;
     End;
End;

Procedure Mul(Const A,B : TLong;Var C : TLong);
  Var I,J : Int;
Begin
  FillChar(C,SizeOf(C),0);
  C[0] :=A[0]+B[0];
  For I :=1 To A[0] Do
    For J :=1 To B[0] Do
      Begin
        Inc(C[I+J-1],A[I]*B[J]);
        Inc(C[I+J],C[I+J-1] Div Osn);
        C[I+J-1] :=C[I+J-1] Mod Osn;
      End;
  While (C[0]>1) And (C[C[0]]=0) Do Dec(C[0]);
End;

Procedure Sum(Var A : TLong; Const B : TLong);
  Var I : Int;
Begin
  A[0] :=Max(A[0],B[0]);
  For I :=1 To A[0] Do
    Begin
      Inc(A[I],B[I]);
      Inc(A[I+1],A[I] Div Osn);
      A[I] :=A[I] Mod Osn;
    End;
  If A[A[0]+1]>0 Then Inc(A[0]);
End;

Procedure Add(Var A : TLong; Const B : Int);
  Var I : Int;
Begin
  For I :=A[0] DownTo 1 Do
    Begin
      A[I] :=A[I]*10;
      Inc(A[I+1],A[I] Div Osn);
      A[I] :=A[I] Mod Osn;
    End;
  Inc(A[1],B);
  If A[A[0]+1]>0 Then Inc(A[0]);
End;

Procedure Div10(Var A : TLong);
  Var I : Int;
Begin
  A[1] :=A[1] Div 10;
  For I :=2 To A[0] Do
    Begin
      Inc(A[I-1],A[I] Mod 10*(Osn Div 10));
      A[I] :=A[I] Div 10;
    End;
  If (A[0]>1) And (A[A[0]]=0) Then Dec(A[0]);
End;

Procedure Sub(Var A : TLong; Const B : TLong; Const S : Int);
  Var I,J : Int;
Begin
  For I :=1 To Min(A[0],B[0]) Do
    Begin
      Dec(A[I+S],B[I]);
      J :=I+S;
      While A[J]<0 Do
        Begin
          Inc(A[J],Osn);
          Dec(A[J+1]);
          Inc(J);
        End;
    End;
  While (A[0]>1) And (A[A[0]]=0) Do Dec(A[0]);
End;

Procedure GetNumber(Const A : TNumber; Var B : TNumber2);
  Var I : Int;
      C,D,Help : TLong;
Begin
  FillChar(B,SizeOf(B),0);
  FillChar(C,SizeOf(C),0);
  FillChar(D,SizeOf(D),0);
  If A[3,0]=0 Then
    Begin
      B[2][0] :=1;
      B[2][1] :=1;
      For I :=1 To A[2,0] Do
        Add(B[2],0);
      D[0] :=1;
      D[1] :=1;
    End
  Else
    Begin
      For I :=1 To A[3,0] Do
        Add(B[2],9);
      For I :=1 To A[2,0] Do
        Add(B[2],0);
      For I :=1 To A[3,0] Do
        Add(D,9);
      For I :=1 To A[3,0] Do
        Add(B[1],A[3,I]);
    End;
  For I :=1 To A[2,0] Do
    Add(C,A[2,I]);
  Mul(C,D,Help);
  Sum(B[1],Help);
  FillChar(C,SizeOf(C),0);
  For I :=1 To A[1,0] Do
    Add(C,A[1,I]);
  Mul(C,B[2],Help);
  Sum(B[1],Help);
End;

Procedure MakeAnswer;
  Var I,J,J2,S : Int;
      Help,Help2,Num : TLong;
Begin
  FillChar(Answer,SizeOf(Answer),0);
  FillChar(Num,SizeOf(Num),0);
  Num[0] :=1;
  S :=0;
  Help2 :=Ans[2];
  While MoreEq(Ans[1],Help2,0) Do
    Begin
      Add(Help2,0);
      Inc(S);
    End;
  If S>0 Then
    Begin
      Div10(Help2);
      Dec(S);
    End;
  Answer[1,0] :=S+1;
  If MoreEq(Ans[1],Ans[2],0) Then
    While S>=0 Do
      Begin
        Answer[1,S+1] :=9;
        For I :=1 To 9 Do
          Begin
            Num[1] :=I;
            Mul(Help2,Num,Help);
            If Not MoreEq(Ans[1],Help,0) Then
              Begin
                Answer[1,S+1] :=I-1;
                Break;
              End;
          End;
        Num[1] :=Answer[1,S+1];
        Mul(Help2,Num,Help);
        Sub(Ans[1],Help,0);
        Div10(Help2);
        Dec(S);
      End;
  Num[1] :=0;
  If MoreEq(Num,Ans[1],0) Then Exit;
  Ans2 :=Ans;
  For S :=1 To MaxLen-Answer[1,0]-1 Do
    Begin
      Add(Ans2[1],0);
      J :=9;
      For I :=1 To 9 Do
        Begin
          Num[1] :=I;
          Mul(Ans2[2],Num,Help);
          If Not MoreEq(Ans2[1],Help,0) Then
            Begin
              J :=I-1;
              Break;
            End;
        End;
      Num[1] :=J;
      Mul(Ans2[2],Num,Help);
      Sub(Ans2[1],Help,0);
    End;
  Help2 :=Ans2[1];
  J2 :=J;
  J :=-1;
  While (J2<>J) Or Not Eq(Ans2[1],Help2) Do
    Begin
      Inc(Answer[3,0]);
      Add(Ans2[1],0);
      J :=9;
      For I :=1 To 9 Do
        Begin
          Num[1] :=I;
          Mul(Ans2[2],Num,Help);
          If Not MoreEq(Ans2[1],Help,0) Then
            Begin
              J :=I-1;
              Break;
            End;
        End;
      Num[1] :=J;
      Mul(Ans2[2],Num,Help);
      Sub(Ans2[1],Help,0);
    End;
  Ans2 :=Ans;
  For S :=1 To Answer[3,0] Do
    Begin
      Add(Ans2[1],0);
      J :=9;
      For I :=1 To 9 Do
        Begin
          Num[1] :=I;
          Mul(Ans2[2],Num,Help);
          If Not MoreEq(Ans2[1],Help,0) Then
            Begin
              J :=I-1;
              Break;
            End;
        End;
      Num[1] :=J;
      Mul(Ans2[2],Num,Help);
      Sub(Ans2[1],Help,0);
    End;
  Help2 :=Ans[1];
  Answer[2,0] :=-1;
  Repeat
    Inc(Answer[2,0]);
    Add(Ans2[1],0);
    J :=9;
    For I :=1 To 9 Do
      Begin
        Num[1] :=I;
        Mul(Ans2[2],Num,Help);
        If Not MoreEq(Ans2[1],Help,0) Then
          Begin
            J :=I-1;
            Break;
          End;
      End;
    Num[1] :=J;
    Mul(Ans2[2],Num,Help);
    Sub(Ans2[1],Help,0);
    Add(Help2,0);
    J2 :=9;
    For I :=1 To 9 Do
      Begin
        Num[1] :=I;
        Mul(Ans2[2],Num,Help);
        If Not MoreEq(Help2,Help,0) Then
          Begin
            J2 :=I-1;
            Break;
          End;
      End;
    Num[1] :=J2;
    Mul(Ans2[2],Num,Help);
    Sub(Help2,Help,0);
  Until (J2=J) And (Eq(Help2,Ans2[1]));
  For S :=1 To Answer[2,0] Do
    Begin
      Add(Ans[1],0);
      Answer[2,S] :=9;
      For I :=1 To 9 Do
        Begin
          Num[1] :=I;
          Mul(Ans[2],Num,Help);
          If Not MoreEq(Ans[1],Help,0) Then
            Begin
              Answer[2,S] :=I-1;
              Break;
            End;
        End;
      Num[1] :=Answer[2,S];
      Mul(Ans[2],Num,Help);
      Sub(Ans[1],Help,0);
    End;
  For S :=1 To Answer[3,0] Do
    Begin
      Add(Ans[1],0);
      Answer[3,S] :=9;
      For I :=1 To 9 Do
        Begin
          Num[1] :=I;
          Mul(Ans[2],Num,Help);
          If Not MoreEq(Ans[1],Help,0) Then
            Begin
              Answer[3,S] :=I-1;
              Break;
            End;
        End;
      Num[1] :=Answer[3,S];
      Mul(Ans[2],Num,Help);
      Sub(Ans[1],Help,0);
    End;
  If (Answer[3,0]=1) And (Answer[3,1]=0) Then Answer[3,0] :=0;
End;

Procedure Solve;
Begin
  GetNumber(A,A2);
  GetNumber(B,B2);
  Mul(A2[1],B2[2],Ans[1]);
  Mul(A2[2],B2[1],Ans[2]);
  MakeAnswer;
  WriteAnswer;
End;

Procedure CloseFiles;
Begin
  Close(Input);
  Close(Output);
End;

Begin
  OpenFiles;
  Init;
  Solve;
  CloseFiles;
End.
