{$A+,B-,D+,E-,F-,G-,I-,L+,N-,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}
  Const File_In='necklace.in';
        File_Out='necklace.out';
        MaxN=50;
  Type Int=LongInt;
  Var K,N : Int;
      A,A2,Num : Array [0..MaxN+1] Of Int;
      Answer : Array [0..MaxN,0..MaxN,0..(MaxN*MaxN+MaxN+1) Div 2] Of Int;
      Sum : Array [1..MaxN,1..MaxN] Of Int;
      Sums,Sums2 : Array [0..MaxN*MaxN] Of Int;
      NumAns,SizeAns : Int;

Procedure OpenFiles;
Begin
  Assign(Input,File_In);
  ReSet(Input);
  Assign(Output,File_Out);
  ReWrite(Output);
End;

Procedure Move;
  Var I : Int;
Begin
  For I :=N DownTo 1 Do
    A[I+1] :=A[I];
  A[1] :=A[N+1];
  For I :=N DownTo 1 Do
    Num[I+1] :=Num[I];
  Num[1] :=Num[N+1];
End;

Procedure Swap(Var A,B : Int);
  Var C : Int;
Begin
  C :=A;
  A :=B;
  B :=C;
End;

Procedure Sort(L,R : Int);
  Var I,J,X : Int;
Begin
  I :=L;
  J :=R;
  X :=Sums[(I+J) Div 2];
  Repeat
    While Sums[I]<X Do Inc(I);
    While Sums[J]>X Do Dec(J);
    If I<=J Then
      Begin
        Swap(Sums[I],Sums[J]);
        Inc(I);
        Dec(J);
      End;
  Until I>J;
  If I<R Then Sort(I,R);
  If J>L Then Sort(L,J);
End;

Function Max(Const A,B : Int) : Int;
Begin
  If A>B Then Max :=A
  Else Max :=B;
End;

Function Min(Const A,B : Int) : Int;
Begin
  If A<B Then Min :=A
  Else Min :=B;
End;

Function Solve : Int;
  Var I,J,L,I2 : Int;
      HelpSolve : Int;
Begin
  FillChar(Sums,SizeOf(Sums),0);
  For I :=1 To N Do
    Sum[I,I] :=A[I];
  For I :=1 To N Do
    For J :=I+1 To N Do
      Sum[I,J] :=Sum[I,J-1]+A[J];
  For I :=1 To N Do
    For J :=I To N Do
      Begin
        Inc(Sums[0]);
        Sums[Sums[0]] :=Sum[I,J];
      End;
  Sort(1,Sums[0]);
  Sums2 :=Sums;
  Sums[0] :=1;
  For I :=2 To Sums2[0] Do
    If Sums2[I]<>Sums2[I-1] Then
      Begin
        Inc(Sums[0]);
        Sums[Sums[0]] :=Sums2[I];
      End;
//  FillChar(Answer,SizeOf(Answer),0);
  For I :=1 To N Do
    Begin
      For L :=1 To Sums[0] Do
        If Sums[L]>=Answer[I-1,0,L]+A[I] Then
          Answer[I,0,L] :=Answer[I-1,0,L]+A[I]
        Else Answer[I,0,L] :=0;
      For L :=1 To Sums[0] Do
        If Sum[1,I]<=Sums[L] Then
          Answer[I,1,L] :=Sum[1,I]
        Else Answer[I,1,L] :=0;
      For J :=2 To Min(I,K) Do
        For L :=1 To Sums[0] Do
          Begin
            Answer[I,J,L] :=Answer[I,J,L-1];
            For I2 :=J-1 To I-1 Do
              If (Sum[I2+1,I]<=Sums[L]) Then
                Answer[I,J,L] :=Max(Answer[I,J,l],Min(Answer[I2,J-1,L],Sum[I2+1,I]));
          End;
    End;
  HelpSolve :=MaxLongInt Div 2;
  For I :=1 To Sums[0] Do
    If Answer[N,K,I]<>0 Then
      HelpSolve :=Min(HelpSolve,Sums[I]-Answer[N,K,I]);
  Solve :=HelpSolve;
End;

Procedure WriteAnswer;
  Var I,I2,J,L : Int;
      Help : Int;
Begin
  WriteLn(SizeAns);
  Solve;
  For I :=1 To Sums[0] Do
    If (Answer[N,K,I]<>0) And (SizeAns=Sums[I]-Answer[N,K,I]) Then
      Begin
        L :=I;
        Break;
      End;
  I :=N;
  J :=K;
  While J>1 Do
    Begin
      For I2 :=I-1 DownTo J-1 Do
        If (Answer[I,J,L]=Min(Answer[I2,J-1,L],Sum[I2+1,I])) Then
          Begin
            For Help :=I2+1 To I Do Write(Num[Help],' ');
            WriteLn;
            I :=I2;
            Dec(J);
            Break;
          End;
    End;
  For Help :=1 To I Do Write(Num[Help],' ');
End;

Procedure Init;
  Var Ans,I : Int;
Begin
  Read(N,K);
  SizeAns :=0;
  For I :=1 To N Do
    Begin
      Read(A[I]);
      Inc(SizeAns,A[I]);
      Num[I] :=I;
    End;
  A2 :=A;
  For I :=1 To N+1-K Do
    Begin
      Move;
      Ans :=Solve;
      If Ans<SizeAns Then
        Begin
          SizeAns :=Ans;
          NumAns :=I;
          If SizeAns=0 Then Break;
        End;
    End;
  A :=A2;
  For I :=1 To N Do Num[I] :=I;
  For I :=1 To NumAns Do Move;
  Solve;
  WriteAnswer;
End;

Procedure CloseFiles;
Begin
  Close(Input);
  Close(Output);
End;

Begin
  OpenFiles;
  Init;
  Solve;
  CloseFiles;
End.
