{$A+,B-,D-,E+,F-,G-,I-,L-,N-,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}
  Const File_In='virtual.in';
        File_Out='virtual.out';
        MaxXYZ=101;
  Type Int=LongInt;
  Var Map : Array [0..MaxXYZ,0..MaxXYZ,0..MaxXYZ] Of Int;
      Sum : Array [0..MaxXYZ,0..MaxXYZ,0..MaxXYZ] Of Int64;
      K,X,Y,Z,X1,Y1,Z1 : Int;
      Answer : Int64;

Procedure OpenFiles;
Begin
  Assign(Input,File_In);
  ReSet(Input);
  Assign(Output,File_Out);
  ReWrite(Output);
End;

Procedure Init;
  Var I,J,L : Int;
Begin
  Read(X,Y,Z,X1,Y1,Z1,K);
  Inc(K);
  For I :=1 To Z Do
    For J :=1 To Y Do
      For L :=1 To X Do
        Read(Map[L,J,I]);
End;

Function Max(Const A,B : Int) : Int;
Begin
  If A>B Then Max :=A
  Else Max :=B;
End;

Function GetSum(Const X,Y,Z : Int) : Int64;
  Var X2,Y2,Z2 : Int;
      HelpSum : Int64;
Begin
  X2 :=Max(1,X-X1+1);
  Y2 :=Max(1,Y-Y1+1);
  Z2 :=Max(1,Z-Z1+1);
  HelpSum :=(Int64(Map[X,Y,Z])+Sum[X,Y,Z]-Sum[X2-1,Y2-1,Z2-1]-Sum[X,Y,Z2-1]-Sum[X,Y2-1,Z]-Sum[X2-1,Y,Z]
            +Sum[X2-1,Y2-1,Z]+Sum[X2-1,Y,Z2-1]+Sum[X,Y2-1,Z2-1]);
  While HelpSum<0 Do Inc(HelpSum,K);
  GetSum :=HelpSum;
End;

Procedure Add(Const X,Y,Z : Int; Const WhatAdd : Int64);
Begin
  Sum[X,Y,Z] :=(WhatAdd+Sum[X-1,Y,Z]+Sum[X,Y-1,Z]+Sum[X,Y,Z-1]+Sum[X-1,Y-1,Z-1]
                -Sum[X-1,Y-1,Z]-Sum[X-1,Y,Z-1]-Sum[X,Y-1,Z-1]) Mod Int64(K);
  While Sum[X,Y,Z]<0 Do Inc(Sum[X,Y,Z],K);
End;

Procedure Solve;
  Var Ok : Boolean;
      I,J,L : Int;
      HelpSum : Int64;
Begin
  FillChar(Sum,SizeOf(Sum),0);
  Answer :=0;
  Ok :=True;
  For I :=1 To X Do
    For J :=1 To Y Do
      For L :=1 To Z Do
        Begin
          Add(I,J,L,0);
          If (I<=X-X1+1) And (J<=Y-Y1+1) And (L<=Z-Z1+1) Then
            Begin
              HelpSum :=(GetSum(I,J,L)) Mod Int64(K);
              If HelpSum<>0 Then
                Begin
                  Add(I,J,L,K-HelpSum);
                  Inc(Answer,Int64(K-HelpSum));
                End;
            End
        End;
  For L :=1 To Z Do
    For J :=1 To Y Do
      For I :=1 To X Do
        If GetSum(I,J,L) Mod Int64(K)<>0 Then
          Ok :=False;
  If Ok Then WriteLn(Answer)
  Else WriteLn('-1')
End;

Procedure CloseFiles;
Begin
  Close(Input);
  Close(Output);
End;

Begin
  OpenFiles;
  Init;
  Solve;
  CloseFiles;
End.
