{$A+,B-,D-,E+,F-,G-,I-,L-,N-,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}
  Const File_In='commas.in';
        File_Out='commas.out';
        MaxLen=1001;
  Type Int=LongInt;
  Var S : Array [1..MaxLen] Of Char;
      Ans : Array [1..MaxLen,1..MaxLen,1..2] Of Int;
      More0 : Array [1..MaxLen,1..MaxLen] Of Boolean;
      Len : Int;

Procedure OpenFiles;
Begin
  Assign(Input,File_In);
  ReSet(Input);
  Assign(Output,File_Out);
  ReWrite(Output);
End;

Procedure Init;
  Var Sym : Char;
Begin
  Len :=0;
  Read(Sym);
  While Not(Sym In ['0'..'9']) Do Read(Sym);
  While Sym In ['0'..'9'] Do
    Begin
      Inc(Len);
      S[Len] :=Sym;
      Read(Sym);
    End;
End;

Procedure WriteAns(I,J : Int);
  Var K : Int;
Begin
  If I=0 Then Exit;
  WriteAns(I-J,Ans[I,J,2]);
  For K :=I-J+1 To I Do Write(S[K]);
  If I<>Len Then Write(',');
End;

Function Check(Const I,J,K2 : Int) : Boolean;
  Var More : Boolean;
      K : Int;
Begin
  More :=False;
  For K :=K2 DownTo 1 Do
    If S[I-K+1]>S[I-J-K+1] Then
      Begin
        More :=True;
        Break;
      End
    Else If S[I-K+1]<S[I-J-K+1] Then Break;
  Check :=More;
End;

Procedure Solve;
  Var I,J,K : Int;
      More : Boolean;
      AnsJ : Int;
Begin
  FillChar(More0,SizeOf(More0),0);
  FillChar(Ans,SizeOf(Ans),0);
  For I :=1 To Len Do
    If S[I]<>'0' Then More0[I,I] :=True;
  For I :=1 To Len Do
    For J :=I+1 To Len Do
      More0[I,J] :=More0[I,J-1] Or (S[J]<>'0');
  Ans[1,1,1] :=1;
  For I :=2 To Len Do
    Begin
      For J :=1 To I-1 Do
        Begin
          More :=(S[I]>S[I-J]) Or More0[I-J+1,I-1];
          For K :=1 To I-J Do
            Begin
              More :=More And
                     (((J>K) And ((Ord(S[I-K+1])>Ord(S[I-J-K+1])) Or More0[I-J+1,I-K]
                     Or ((Ord(S[I-K+1])=Ord(S[I-J-K+1])) And Check(I,J,K))))
                     Or ((J<K) And (S[I-J-K+1]='0')) Or ((J=K) And Check(I,J,J)));
              If Not More Then Break;
              If Ans[I-J,K,1]>0 Then
                If (Ans[I,J,1]=0) Or (I-J-K+1=1) Or More0[I-J-K+1,I-J-Ans[I,J,2]] Then
                  Begin
                    Ans[I,J,1] :=Ans[I-J,K,1]+1;
                    Ans[I,J,2] :=K;
                  End;
            End;
        End;
      Ans[I,I,1] :=1;
    End;
  AnsJ :=0;
  For J :=1 To Len Do
    If Ans[Len,J,1]>0 Then
      Begin
        AnsJ :=J;
        Break;
      End;
  WriteAns(Len,AnsJ);
End;

Procedure CloseFiles;
Begin
  Close(Input);
  Close(Output);
End;

Begin
  OpenFiles;
  Init;
  Solve;
  CloseFiles;
End.
