{$A+,B-,D-,E+,F-,G-,I-,L-,N-,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}
  Const File_In='trains.in';
        File_Out='trains.out';
        MaxN=30;
        MaxB=19;
  Type Int=LongInt;
  Var C,B,N : Int;
      X,Y,Y2,Q : Array [1..MaxN] Of Int;
      Num,InNum,Sum : Array [1..MaxN] Of Int;
      Now : Array [-1..MaxB] Of Int;
      Answer : Int;
      Use,UseAns : Array [1..MaxN] Of Boolean;

Procedure OpenFiles;
Begin
  Assign(Input,File_In);
  ReSet(Input);
  Assign(Output,File_Out);
  ReWrite(Output);
End;

Procedure Init;
  Var I : Int;
Begin
  Read(C,B,N);
  For I :=1 To N Do
    Read(X[I],Y[I],Q[I]);
End;

Procedure Swap(Var A,B : Int);
  Var C : Int;
Begin
  C :=A;
  A :=B;
  B :=C;
End;

Function GetMax(Const Num : Integer) : Int;
  Var Max : Int;
      I : Integer;
Begin
  Max :=0;
  For I :=X[Num] To Y2[Num] Do
    If Max<Now[I] Then Max :=Now[I];
  GetMax :=Max;
End;

Procedure Add(Const Num,WhatAdd : Int);
  Var I : Integer;
Begin
  For I :=X[Num] To Y2[Num] Do
    Inc(Now[I],WhatAdd);
  Inc(Now[-1],(Y[Num]-X[Num])*WhatAdd);
End;

Procedure FindAnswer(I : Integer);
Begin
  If I=N+1 Then
    Begin
      If Now[-1]>Answer Then
        Begin
          Answer :=Now[-1];
          UseAns :=Use;
        End;
      Exit;
    End;
  If Sum[I]+Now[-1]<=Answer Then Exit;
  If GetMax(I)+Q[I]<=C Then
    Begin
      Add(I,Q[I]);
      Use[I] :=True;
      FindAnswer(I+1);
      Add(I,-Q[I]);
    End;
  Use[I] :=False;
  FindAnswer(I+1);
End;

Procedure Solve;
  Var I,J : Int;
Begin
  For I :=1 To N Do
    Num[I] :=I;
  For I :=2 To N Do
    Begin
      J :=I;
      While (J>1) And ((Y[J]-X[J])*Q[J]>(Y[J-1]-X[J-1])*Q[J-1]) Do
        Begin
          Swap(X[J],X[J-1]);
          Swap(Y[J],Y[J-1]);
          Swap(Q[J],Q[J-1]);
          Swap(Num[J],Num[J-1]);
          Dec(J);
        End;
    End;
  Sum[N] :=(Y[N]-X[N])*Q[N];
  For I :=N-1 DownTo 1 Do
    Sum[I] :=Sum[I+1]+(Y[I]-X[I])*Q[I];
  For I :=1 To N Do
    Y2[I] :=Y[I]-1;
  Answer :=0;
  FillChar(UseAns,SizeOf(UseAns),0);
  FillChar(Use,SizeOf(Use),0);
  FillChar(Now,SizeOf(Now),0);
  FindAnswer(1);
  WriteLn(Answer);
  For I :=1 To N Do
    InNum[Num[I]] :=I;
  For I :=1 To N Do
    If UseAns[InNum[I]] Then Write(I,' ');
End;

Procedure CloseFiles;
Begin
  Close(Input);
  Close(Output);
End;

Begin
  OpenFiles;
  Init;
  Solve;
  CloseFiles;
End.