{$A+,B-,D+,E+,F-,G-,I+,L+,N-,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}
uses
  sysutils;

const
  problem='filya';
  fin =problem+'.in';
  fout=problem+'.out';
  dx:array[0..3]of longint=(0,1,0,-1);
  dy:array[0..3]of longint=(1,0,-1,0);
  sec= 1.157407407e-5;

type
  field=array[0..50,0..50]of byte;

var
  i,j,k,l,n,m,max:longint;
  a,b,c:field;
  stop:boolean;
  st:extended;
  counter:longint;

procedure init;
var
  c:char;
begin
  n:=41;
  m:=45;
  assign(input,fin);
  reset(input);

    for i:=1 to n do begin
      for j:=1 to m do begin
        read(c);
        a[i,j]:=ord(c)-ord('0');
      end;
      readln;
    end;

  close(input);
end;

function dfs(x,y,c,nc:longint):longint;
var
  i,k:longint;
begin
  k:=1;
  a[x,y]:=nc;
  b[x,y]:=1;
  for i:=0 to 3 do
    if (b[x+dx[i],y+dy[i]]=0)and(a[x+dx[i],y+dy[i]]=c) then
      k:=k+dfs(x+dx[i],y+dy[i],c,nc);
  dfs:=k;
end;

function think(p,d:longint;var move:longint):longint;
var
  i,j,k,max:longint;
  q:field;
begin
  inc(counter);
  if counter>1000 then begin
    counter:=0;
    if now-st>0.95*sec then begin
      stop:=true;
      exit;
    end;
  end;
  if d>5 then begin
    think:=0;
    exit;
  end;
  max:=-maxlongint;
  case p of
1:begin
    for i:=1 to 6 do begin
      if i=a[1,1] then
        continue;
      if i=a[n,m] then
        continue;
      q:=a;
      k:=dfs(1,1,a[1,1],i);
      fillchar(b,sizeof(b),0);
      k:=dfs(1,1,a[1,1],i);
      fillchar(b,sizeof(b),0);
      k:=k-think(2,d+1,j);
      if k>max then begin
        move:=i;
        max:=k;
      end;
      if stop then exit;  
      a:=q;
    end;
  end;
2:begin
    for i:=1 to 6 do begin
      if i=a[1,1] then
        continue;
      if i=a[n,m] then
        continue;
      q:=a;
      fillchar(b,sizeof(b),0);
      k:=dfs(n,m,a[n,m],i);
      fillchar(b,sizeof(b),0);
      k:=dfs(n,m,a[n,m],i);
      k:=k-think(1,d+1,j);
      if k>max then begin
        move:=i;
        max:=k;
      end;
      if stop then exit;  
      a:=q;
    end;
  end;
  end;
  think:=max;
end;

procedure solve;
begin
  max:=0;
  st:=now;
  i:=think(1,0,l);
  counter:=0;
{  for i:=1 to 6 do begin
    a:=c;
    if i=a[1,1] then
      continue;
    if i=a[n,m] then
      continue;
    c:=a;
    fillchar(b,sizeof(b),0);
    k:=dfs(1,1,a[1,1],i);
    if max<k then begin
      max:=k;
      l:=i;
    end;
  end;}
end;

procedure done;
begin
  assign(output,fout);
  rewrite(output);

    writeln(l);

  close(output);
end;

begin
  init;
  solve;
  done;
end.
