{$I+,Q-,R-,S-,N+}
const
  problem='popular';
  fin =problem+'.in';
  fout=problem+'.out';
  e=1e-8;

var
  i,j,k,n,m:longint;
  h,x1,x2,x0,ax,ay:extended;
  x,l:array[0..10000]of extended;

procedure init;
begin
  assign(input,fin);
  reset(input);

    readln(n);
    for i:=1 to n do
      read(x[i],l[i]);

  close(input);
end;

function dist(x1,y1,x2,y2:extended):extended;
begin
  dist:=sqrt(sqr(x1-x2)+sqr(y1-y2));
end;

procedure solve;
begin
  h:=1e1000;
  for i:=1 to n do
    if l[i]<h then begin
      k:=i;
      h:=l[i];
    end;

  for i:=1 to n do
    for j:=i+1 to n do
      if l[i]+l[j]<abs(x[i]-x[j]) then begin
        ax:=-1;
        ay:=1;
        exit;
      end;

  m:=0;
  for i:=1 to n do
    if dist(x[i],0,x[k],h) > l[i]+e then begin
      m:=1;
      break;
    end;
  if m=0 then begin
    ax:=x[k];
    ay:=h;
    exit;
  end;

  ay:=1e1000;
  for i:=1 to n do
    for j:=i+1 to n do begin
      x0:=((sqr(l[i])-sqr(l[j]))/(x[j]-x[i])+x[i]+x[j])/2;
      if l[i]<abs(x0-x[i]) then
        continue;
      h:=sqrt(sqr(l[i])-sqr(x0-x[i]));
      if ((x0>x[j])and(x0>x[i]))or((x0<x[j])and(x0<x[i])) then
        continue;
      if h<ay then begin
        ay:=h;
        ax:=x0;
      end;
    end;
end;

procedure done;
begin
  assign(output,fout);
  rewrite(output);

    writeln(ax:0:5,' ',-ay:0:5);

  close(output);
end;

begin
  init;
  solve;
  done;
end.
