{$A+,B-,D+,E+,F-,G-,I+,L+,N-,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}
uses
  sysutils;

const
  problem='trains';
  fin =problem+'.in';
  fout=problem+'.out';
  sec= 1.157407407e-5;

var
  st:extended;
  i,j,k,l,n,m,max,cur:longint;
  a:array[0..50,1..3]of longint;
  b,c,d,e,z,t:array[0..50]of longint;

procedure init;
begin
  assign(input,fin);
  reset(input);

    read(l,m,n);
    for i:=1 to n do
      read(a[i,1],a[i,2],a[i,3]);

  close(input);
end;

procedure done;forward;

procedure dfs(k:longint);
var
  i,j:longint;
begin
  j:=0;
  if k>n then begin
    if now-st>1.8*sec then begin
      done;
      exit;
    end;
    if max<cur then begin
      d:=e;
      max:=cur;
    end;
    exit;
  end;
  if cur+b[k]<max then
    exit;
  for i:=a[k,1]+1 to a[k,2] do
    if a[k,3]+c[i]>l then begin
      j:=1;
      break;
    end;
  if j=0 then begin
    for i:=a[k,1]+1 to a[k,2] do
      c[i]:=c[i]+a[k,3];
    cur:=cur+z[k];
    e[k]:=1;
    dfs(k+1);
    for i:=a[k,1]+1 to a[k,2] do
      c[i]:=c[i]-a[k,3];
    cur:=cur-z[k];
    e[k]:=0;
  end;
  dfs(k+1);
end;

procedure solve;
begin
  st:=now;
  for i:=1 to n do
    z[i]:=(a[i,2]-a[i,1])*a[i,3];
  for i:=1 to n do
    t[i]:=i;
  for i:=1 to n-1 do
    for j:=i+1 to n do
      if z[i]<z[j] then begin
        z[i]:=z[i] xor z[j];
        z[j]:=z[i] xor z[j];
        z[i]:=z[i] xor z[j];
        a[i,1]:=a[i,1] xor a[j,1];
        a[j,1]:=a[i,1] xor a[j,1];
        a[i,1]:=a[i,1] xor a[j,1];
        a[i,2]:=a[i,2] xor a[j,2];
        a[j,2]:=a[i,2] xor a[j,2];
        a[i,2]:=a[i,2] xor a[j,2];
        a[i,3]:=a[i,3] xor a[j,3];
        a[j,3]:=a[i,3] xor a[j,3];
        a[i,3]:=a[i,3] xor a[j,3];
        t[i]:=t[i] xor t[j];
        t[j]:=t[i] xor t[j];
        t[i]:=t[i] xor t[j];
      end;
  b[n+1]:=0;
  for i:=n downto 1 do
    b[i]:=b[i+1]+z[i];
  max:=-10;
  cur:=0;
  fillchar(c,sizeof(c),0);
  dfs(1);
end;

procedure done;
begin
  assign(output,fout);
  rewrite(output);

    writeln(max);
    for j:=1 to n do
    for i:=1 to n do
      if (d[i]=1)and(t[i]=j) then
        write(t[i],' ');

  close(output);
end;

begin
  init;
  solve;
  done;
end.
