CONST
 RES1=1000;
 RES2=1000000;

TYPE
 tQuelle=Record
   Data:Array[0..RES2-1]Of Record
     X,Y,N:LongInt;
   End;
   Head,Size:LongInt;
 End;

Procedure Quelle_Init(Var Quelle:tQuelle);
 Begin
   Quelle.HEAD:=0;
   Quelle.SIZE:=0;
 End;

Procedure Quelle_Put(Var Quelle:tQuelle;X,Y,N:LongInt);
 Begin
   If Quelle.SIZE=RES2 Then Begin
     Writeln('QUELLE_LIMIT_EXCEEDED');
     Halt;
   End;
   Quelle.Data[(Quelle.Head+Quelle.Size)Mod RES2].X:=X;
   Quelle.Data[(Quelle.Head+Quelle.Size)Mod RES2].Y:=Y;
   Quelle.Data[(Quelle.Head+Quelle.Size)Mod RES2].N:=N;
   Inc(Quelle.Size);
 End;

Function Quelle_Empty(Var Quelle:tQuelle):Boolean;
 Begin
   Quelle_Empty:=Quelle.Size=0;
 End;

Procedure Quelle_Get(Var Quelle:tQuelle;Var X,Y,N:LongInt);
 Begin
   X:=Quelle.Data[Quelle.Head].X;
   Y:=Quelle.Data[Quelle.Head].Y;
   N:=Quelle.Data[Quelle.Head].N;
   Dec(Quelle.Size);
   Quelle.Head:=(Quelle.Head+1)Mod RES2;
 End;

VAR
{ Debug:Text;}
 XS,YS,XT,YT:LongInt;
 N,I:LongInt;
 P:Array[-RES1..RES1,-RES1..RES1]Of Byte;
 Quelle:tQuelle;

Function  WFS:LongInt;
 Var
  TX,TY,N:LongInt;
 Begin
   Quelle_Init(Quelle);
   Quelle_Put(Quelle,XS,YS,0);
   While Not Quelle_Empty(Quelle) Do Begin
     Quelle_Get(Quelle,TX,TY,N);
{     Writeln(Debug,TX,' ',TY);}
     If (TX>=-RES1)And(TY>=-RES1)And(TX<=RES1)And(TY<=RES1)Then
       If P[TX,TY]=3 Then Begin
         WFS:=N;Exit;
       End Else If P[TX,TY]=0 Then Begin
         P[TX,TY]:=1;
         Quelle_Put(Quelle,TX-1,TY-1,N+1);
         Quelle_Put(Quelle,TX-1,TY,N+1);
         Quelle_Put(Quelle,TX-1,TY+1,N+1);
         Quelle_Put(Quelle,TX,TY+1,N+1);
         Quelle_Put(Quelle,TX+1,TY+1,N+1);
         Quelle_Put(Quelle,TX+1,TY,N+1);
         Quelle_Put(Quelle,TX+1,TY-1,N+1);
         Quelle_Put(Quelle,TX,TY-1,N+1);
       End;
   End;
   WFS:=-1;
 End;

VAR
 A,B:LongInt;

BEGIN
  Assign(Input,'king.in');
  Assign(Output,'king.out');
{  Assign(Debug,'king.debug.out');}
  Reset(Input);
  ReWrite(Output);
{  ReWrite(Debug);}

  FillChar(P,SizeOf(P),0);
  ReadLn(XS,YS);
  ReadLn(XT,YT);
  If (XS>RES1)Or(YS>RES1)Or(XS<-RES1)Or(YS<-RES1)Or(XT>RES1)Or(YT>RES1)Or(XT<-RES1)Or(YT<-RES1)Then Begin
    If ABS(XT-XS)>ABS(YT-YS)Then Writeln(aBS(xt-xs))
    Else Writeln(Abs(YT-YS));
  End Else Begin
    ReadLn(N);
    P[XT,YT]:=3;
    For I:=0 To N-1 Do Begin
      ReadLn(A,B);
      If (A>=-RES1)And(B>=-RES1)And(A<=RES1)And(B<=RES1)Then
        P[A,B]:=2;
    End;
    Writeln(WFS);
  End;

  Close(Input);
  Close(Output);
{  Close(Debug);}
END.

