CONST
 Eps=1e-12;

TYPE
 tNck=Record
   D:Double;
   A,K:LongInt;
 End;

Procedure SWAP(Var A,B:tNck);
 Var
  T:tNck;
 Begin
   T:=A;
   A:=B;
   B:=T;
 End;

Procedure Sort(Var A,B:Array Of tNck;L,R:LongInt);
 Var
  S,F,T,X:LongInt;
 Begin
   If R-L<15 Then Begin
     For S:=0 To R-L Do Begin
       For F:=L To R-1 Do If A[F].D>A[F+1].D Then SWAP(A[F],A[f+1]);
     End;
     Exit;
   End;
   F:=(L+R)Shr 1;
   Sort(A,B,L,F);
   Sort(A,B,F+1,R);
   T:=L;
   S:=L;
   X:=F;
   While T<=R Do Begin
     If (X>R)Or((S<=F)And(A[S].D<=A[X].D)) Then Begin
       B[T]:=A[S];
       Inc(S);
     End Else Begin
       B[T]:=A[X];
       Inc(X);
     End;
     Inc(T);
   End;
   For T:=L To R Do A[T]:=B[T];
 End;

VAR
 N,K,I,TK,TempMinI,TempMaxI:LongInt;
 A,B:Array[0..100000]Of tNck;
 KDEL:Array[0..10000]Of LongInt;
 KFFF:Array[0..10000]Of QWord;
 RESULT_MIN:QWord;
 TTT:Double;

BEGIN
  Assign(Input,'necklace.in');
  Assign(Output,'necklace.out');
  Reset(Input);
  ReWrite(Output);
  
  ReadLn(N,K);
  For I:=0 To N-1 Do Begin
    ReadLn(A[I].D,A[I].A);
    A[I].D:=A[I].D/(2*PI);
  End;
  Sort(A,B,0,N-1);
  FillChar(KDEL,SizeOf(KDel),255);
  FillChar(KFFF,SizeOf(KFFF),0);
  For I:=0 To N-1 Do Begin
    TK:=Trunc(A[I].D*K);
    If KDEL[TK]=-1 Then Begin
      KDEL[TK]:=I;
    End;
    A[I].D:=A[I].D*K-Trunc(A[I].D*K);
    A[I].K:=TK;
    KFFF[TK]:=KFFF[TK]+A[I].A;
  End;
  TempMinI:=0;
  TempMaxI:=0;
  For I:=1 To K-1 Do Begin
    If KFFF[TempMinI]>KFFF[I]Then TempMinI:=I;
    If KFFF[TempMaxI]<KFFF[I]Then TempMaxI:=I;
  End;
  RESULT_MIN:=KFFF[TempMaxI]-KFFF[TempMinI];
  Sort(A,B,0,N-1);
  For I:=0 To N-2 Do Begin
    TTT:=A[I].D;
    KFFF[A[I].K]:=KFFF[A[I].K]-A[I].A;
    If A[I].K=TempMaxI Then Begin
      TempMaxI:=0;
      For I:=1 To K-1 Do Begin
        If KFFF[TempMaxI]<KFFF[I]Then TempMaxI:=I;
      End;
    End;
    If KFFF[A[I].K]<KFFF[TempMini] Then TempMini:=A[I].K;
    If A[I].K=0 Then A[I].K:=K-1 Else Dec(A[I].K);
    KFFF[A[I].K]:=KFFF[A[I].K]+A[I].A;
    A[I].D:=A[I].D+1;
    If Abs(A[I+1].D-TTT)>=Eps Then
      If RESULT_MIN>KFFF[TempMaxI]-KFFF[TempMinI] Then Begin
        RESULT_MIN:=KFFF[TempMaxI]-KFFF[TempMinI];
      End;
  End;
  Writeln(RESULT_MIN);

  Close(Input);
  Close(Output);
END.
