TYPE
 tQuelle=Record
   Data:Array[0..1000000]Of Record
     X,Y:Word;
   End;
   Head,Size:LongInt;
 End;

Procedure QUELLE_Init(Var Quelle:tQuelle);
 Begin
   Quelle.Head:=0;
   Quelle.Size:=0;
 End;

Procedure QUELLE_Put(Var Quelle:tQuelle;X,Y:LongInt);
 Begin
   Quelle.Data[(Quelle.Head+Quelle.Size)Mod 1000000].X:=X;
   Quelle.Data[(Quelle.Head+Quelle.Size)Mod 1000000].Y:=Y;
   Inc(Quelle.Size);
 End;

Procedure QUELLE_Get(Var Quelle:tQuelle;Var X,Y:LongInt);
 Begin
   X:=Quelle.Data[Quelle.Head].X;
   Y:=Quelle.Data[Quelle.Head].Y;
   Inc(Quelle.Head);
   Dec(Quelle.Size);
 End;

Function  QUELLE_Empty(Var Quelle:tQuelle):Boolean;
 Begin
   QUELLE_Empty:=Quelle.Size=0;
 End;

VAR
 Debug:Text;
 Length,I,J,E:LongInt;
 A:Array[0..1000]Of Byte;
 Prev:Array[0..1000,0..1000]Of Record
   P1,P2:LongInt;
 End;
 D:Array[0..1000,0..1000]Of LongInt;
 CH:Char;
 Quelle:tQuelle;
 FF:LongInt;
 FFF:Array[0..1000]Of LongInt;
 X,Y:LongInt;

Function  TestEma1(ST1,FN1,ST2,FN2:LongInt):Boolean;
 Var
  I1,I2:LongInt;
 Begin
   I1:=ST1;
   I2:=ST2;
   While (I2<=FN2)And(A[I2]=0)Do Inc(I2);
   If I2>FN2 Then Begin
     TestEma1:=False;
     Exit;
   End;
   While (I1<=FN1)And(A[I1]=0)Do Inc(I1);
   If I1>FN2 Then Begin
     TestEma1:=True;
     Exit;
   End;
   If (FN2-I2)>(FN1-I1)Then Begin
     TestEma1:=True;
     Exit;
   End Else If (FN2-I2)<(FN1-I1)Then Begin
     TestEma1:=False;
     Exit;
   End;
   While I1<=FN1 Do Begin
     If A[I1]>A[I2]Then Begin
       TestEma1:=False;
       Exit;
     End Else If A[I1]<A[I2]Then Begin
       TestEma1:=True;
       Exit;
     End;
     Inc(I1);
     Inc(I2);
   End;
   TestEma1:=False;
 End;

Procedure Target(TXA,TXB,FYF,EMA,NNN:LongInt);
 Begin
   If (D[TXA,TXB]=-1)Or(D[TXA,TXB]>NNN)Then Begin
     D[TXA,TXB]:=NNN;
     Prev[TXA,TXB].P1:=FYF;
     Prev[TXA,TXB].P2:=EMA;
     Quelle_Put(Quelle,TXA,TXB);
   End;
 End;

BEGIN
  Assign(Input,'commas.in');
  Assign(Output,'commas.out');
  Assign(Debug,'commas.debug.out');
  Reset(Input);
  ReWrite(Output);
  ReWrite(Debug);

  Length:=0;
  While Not EOLN Do Begin
    Read(CH);
    A[Length]:=Byte(CH)-Byte('0');
    Inc(Length);
  End;
  FillChar(D,SizeOf(D),255);
  Quelle_Init(Quelle);
  For I:=1 To Length Do Begin
    D[I-1,I]:=1;
    Quelle_Put(Quelle,I-1,I);
  End;
  While Not Quelle_Empty(Quelle) Do Begin
    Quelle_Get(Quelle,I,J);
    Writeln(Debug,I,' ',J);
{    For E:=1 To Length-I-1 Do
      If TestEma1(I-E+1,I,I+1,I+E)then Begin
        Target(I+E,E,I,J,D[I,J]+1);
        Writeln(Debug,'FF',E);
      End;}
    If (Length-I)>J Then Begin
      If (Length-I-1)>J Then Begin
        For E:=J+1 To Length-I-1 Do Begin
{          If TestEma1()}
          Target(I+E,E,I,J,D[I,J]+1);
          Writeln(Debug,'FF');
        End;
      End;
      If TestEma1(I-J+1,I,I+1,I+J) Then Begin
        Target(I+J,J,I,J,D[I,J]+1);
        Writeln(Debug,'FFF');
      End;
    End;
  End;
  FillChar(FFF,SizeOf(FFF),0);
  X:=Length-1;
  Y:=Length+1;
  For I:=Length-1 DownTo 1 Do Begin
    If D[Length-1,I]>0 Then Begin
      Y:=I;
    End;
  End;
  FFF[X]:=1;
  While (X+1)<>Y Do Begin
    I:=Prev[X,Y].P1;
    Y:=Prev[X,Y].P2;X:=I;
    FFF[X]:=1;
  End;
  For I:=0 To Length-1 Do Begin
    Write(A[I]);
    If (I<>(Length-1))And(FFF[I]=1) Then Write(',');
  End;
  Writeln;

  Close(Input);
  Close(Output);
  Close(Debug);
END.
