const MAXN=110000;
const MAXP=1510;
var num,nmp:array[1..MAXN]of longint;
    n,p:longint;
    nm:array[0..MAXP]of longint;
    pow2:array[0..30]of longint;
    pwr:array[0..MAXP,0..30]of longint;

procedure Load;
var i,j:longint;
begin
    fillchar(nm,sizeof(nm),0);
    read(n,p);
    for i:=1 to n do begin
        read(num[i]);
        nmp[i]:=num[i] mod p;
        inc(nm[num[i]mod p]);
    end;
    for i:=0 to 30 do pow2[i]:=1 shl i;
    for i:=0 to p-1 do begin
        pwr[i,0]:=i;
        for j:=1 to 30 do pwr[i,j]:=(pwr[i,j-1]*pwr[i,j-1])mod p;
    end;
end;

function Power(a,b:longint):longint;
var i,res:longint;
begin
    res:=1;
    for i:=0 to 30 do begin
        if b and pow2[i]>0 then res:=(res*pwr[a,i])mod p;
    end;
    Power:=res;
end;

procedure Solve;
var i,j,rs:longint;
    sum,n1,n2:int64;
begin
    sum:=0;
    for i:=0 to p-1 do begin
        for j:=1 to n do begin
            rs:=Power(i,num[j]);
            n1:=nm[i];
            n2:=nm[rs];
            if (rs=i)and(nmp[j]=i)then begin
                dec(n1);
                n2:=n1-1;
            end
            else if nmp[j]=i then dec(n1)
            else if nmp[j]=rs then dec(n2)
            else if rs=i then dec(n2);
            sum:=sum+n1*n2;
        end;
    end;
    write(sum);
end;

begin
    assign(input,'triples.in');
    assign(output,'triples.out');
    reset(input);
    rewrite(output);
    Load;
    Solve;
    close(input);
    close(output);
end.
