const MAXN=1200;
var a:array[1..MAXN,1..MAXN]of longint;
    n:longint;
    sum,fnum:array[1..MAXN]of longint;

function LOad:boolean;
var i,j:longint;
begin
    read(n);
    if n=0 then begin
        Load:=false;
        exit;
    end;
    fillchar(sum,sizeof(sum),0);
    for i:=1 to n do begin
        fnum[i]:=i;
        for j:=1 to n do begin
            read(a[i,j]);
            sum[i]:=sum[i]+a[i,j];
        end;
    end;
    Load:=true;
end;

function Error(i1,i2:longint):boolean;
var big,i:longint;
begin
    big:=0;
    if sum[i1]>sum[i2] then big:=i1
    else if sum[i2]>sum[i1] then big:=i2;
    for i:=1 to n do begin
        if(i=i1)or(i=i2)then continue;
        if a[i1,i]>a[i2,i] then begin
            if big=0 then big:=i1;
            if big=i2 then begin
                Error:=true;
                exit;
            end;
        end;
        if a[i2,i]>a[i1,i] then begin
            if big=0 then big:=i2;
            if big=i1 then begin
                Error:=true;
                exit;
            end;
        end;
    end;
    Error:=false;
end;

function Bigger(i1,i2:longint):boolean;
var i:longint;
begin
    if sum[i1]>sum[i2] then begin
        Bigger:=true;
        exit;
    end
    else if sum[i2]>sum[i1] then begin
        Bigger:=false;
        exit;
    end;
    for i:=1 to n do begin
        if (i=i1)or(i=i2)then continue;
        if a[i1,i]>a[i2,i] then begin
            Bigger:=true;
            exit;
        end;
        if a[i2,i]>a[i1,i] then begin
            Bigger:=false;
            exit;
        end;
    end;
    if i1>i2 then Bigger:=true
    else Bigger:=false;
end;

function Smaller(i1,i2:longint):boolean;
var i:longint;
begin
    if sum[i1]<sum[i2] then begin
        Smaller:=true;
        exit;
    end
    else if sum[i2]<sum[i1] then begin
        Smaller:=false;
        exit;
    end;
    for i:=1 to n do begin
        if (i=i1)or(i=i2)then continue;
        if a[i1,i]<a[i2,i] then begin
            Smaller:=true;
            exit;
        end;
        if a[i2,i]<a[i1,i] then begin
            Smaller:=false;
            exit;
        end;
    end;
    if i1<i2 then Smaller:=true
    else Smaller:=false;
end;

function MegaSort(be,en:longint):boolean;
var l,r,x,t:longint;
begin
    l:=be;
    r:=en;
    x:=fnum[l+random(r-l+1)];
    if (Error(x,fnum[l]))or(Error(x,fnum[r])) then begin
        MegaSort:=false;
        exit;
    end;
    while l<r do begin
        while Bigger(x,fnum[l]) do begin
            inc(l);
            if Error(x,fnum[l]) then begin
                MegaSort:=false;
                exit;
            end;
        end;
        while Smaller(x,fnum[r]) do begin
            dec(r);
            if Error(x,fnum[r]) then begin
                MegaSort:=false;
                exit;
            end;
        end;
        if l<=r then begin
            t:=fnum[l];
            fnum[l]:=fnum[r];
            fnum[r]:=t;
            inc(l);
            dec(r);
        end;
    end;
    if be<r then begin
        if not MegaSort(be,r) then begin
            MegaSort:=false;
            exit;
        end;
    end;
    if l<en then begin
        if not MEgaSort(l,en) then begin
            MegaSort:=false;
            exit;
        end;
    end;
    MegaSort:=true;
end;

procedure Solve;
var i,i1,i2:longint;
begin
    randseed:=3364;
    if MegaSort(1,n) then begin
        {check random pairs}
        for i:=1 to n do begin
            i1:=random(n)+1;
            i2:=random(n)+1;
            while(i1=i2)do i2:=random(n)+1;
            if Error(fnum[i1],fnum[i2]) then begin
                write('-1');
                exit;
            end;
            if i2>i1 then if Bigger(fnum[i1],fnum[i2]) then begin
                write('-1');
                exit;
            end;
            if i1>i1 then if Bigger(fnum[i2],fnum[i1]) then begin
                write('-1');
                exit;
            end;
        end;
        for i:=1 to n do begin
            write(fnum[i]);
            if i<n then write(' ');
        end;
    end
    else write('-1');
end;

var wf:longint;

begin
    assign(input,'chat.in');
    assign(output,'chat.out');
    reset(input);
    rewrite(output);
    wf:=0;
    while Load do begin
        if wf=1 then writeln
        else wf:=1;
        Solve;
    end;
    close(input);
    close(output);
end.
