const MAXM=1100;
const MAXN=110;
var m,n,k,a,b:longint;
    edg:array[1..MAXM,1..4]of longint;
    bedg:array[1..MAXN]of longint;
    ie,oe:array[1..MAXN,1..MAXN]of longint;

procedure Qsort(be,en:longint);
var l,r,x,t:longint;
begin
    l:=be;
    r:=en;
    x:=edg[l+random(r-l+1),1];
    while l<r do begin
        while x>edg[l,1] do inc(l);
        while x<edg[r,1] do dec(r);
        if l<=r then begin
            t:=edg[l,1];
            edg[l,1]:=edg[r,1];
            edg[r,1]:=t;
            t:=edg[l,2];
            edg[l,2]:=edg[r,2];
            edg[r,2]:=t;
            t:=edg[l,3];
            edg[l,3]:=edg[r,3];
            edg[r,3]:=t;
            t:=edg[l,4];
            edg[l,4]:=edg[r,4];
            edg[r,4]:=t;
            inc(l);
            dec(r);
        end;
    end;
    if be<r then Qsort(be,r);
    if l<en then Qsort(l,en);
end;

procedure Load;
var i:longint;
begin
    fillchar(ie,sizeof(ie),0);
    fillchar(oe,sizeof(oe),0);
    read(n,k,a,b);
    read(m);
    for i:=1 to m do begin
        read(edg[i,1],edg[i,2],edg[i,3]);
        edg[i,4]:=1;
        inc(ie[edg[i,2],edg[i,3]]);
        inc(oe[edg[i,1],edg[i,3]]);
    end;
    Qsort(1,m);
    fillchar(bedg,sizeof(bedg),0);
    bedg[edg[1,1]]:=1;
    for i:=2 to m do begin
        if edg[i,1]<>edg[i-1,1] then bedg[edg[i,1]]:=i;
    end;
    bedg[n+1]:=m+1;
    for i:=n downto 1 do begin
        if bedg[i]=0 then bedg[i]:=bedg[i+1];
    end;
end;

var pth:array[1..MAXM,1..MAXN,1..2]of longint;
    was,dst:array[1..MAXN]of longint;
    prev:array[1..MAXN,1..2]of longint;
    z:longint;


procedure DeleteEdges;
var cur:longint;
    nxt,i,j:longint;
begin
    j:=1;
    while pth[z,j,2]<>0 do begin
        cur:=pth[z,j,1];
        nxt:=pth[z,j+1,1];
        for i:=bedg[cur] to bedg[cur+1]-1 do begin
            if edg[i,4]=0 then continue;
            if edg[i,3]=pth[z,cur,2] then begin
                edg[i,4]:=0;
                dec(oe[edg[i,1],edg[i,3]]);
                dec(ie[edg[i,2],edg[i,3]]);
            end;
        end;
        for i:=1 to m do begin
            if edg[i,4]=0 then continue;
            if edg[i,2]=nxt then begin
                if edg[i,3]=pth[z,cur,2] then begin
                    edg[i,4]:=0;
                    dec(ie[edg[i,2],edg[i,3]]);
                    dec(oe[edg[i,1],edg[i,3]]);
                end;
            end;
        end;
        inc(j);
    end;
end;

procedure DeixtRA;
var i,min,cver,val,nxt:longint;
begin
    fillchar(was,sizeof(was),0);
    for i:=1 to n do dst[i]:=2000000000;
    dst[a]:=0;
    cver:=a;
    while true do begin
        for i:=bedg[cver] to bedg[cver+1]-1 do begin
            if edg[i,4]=0 then continue;
            nxt:=edg[i,2];
            val:=oe[cver,edg[i,3]]+ie[nxt,edg[i,3]]-1;
            if dst[nxt]>dst[cver]+val then begin
                dst[nxt]:=dst[cver]+val;
                prev[nxt,1]:=cver;
                prev[nxt,2]:=edg[i,3];
            end;
        end;
        was[cver]:=1;
        min:=2000000000;
        for i:=1 to n do begin
            if was[i]=1 then continue;
            if dst[i]<min then begin
                min:=dst[i];
                cver:=i;
            end;
        end;
        if min=2000000000 then break;
    end;
end;

procedure Solve;
var cur,cp,i,j:longint;
    cpp:array[1..110,1..2]of longint;
begin
    z:=0;
    DeixtRA;
    while dst[b]<2000000000 do begin
        inc(z);
        cur:=b;
        cp:=1;
        cpp[cp,1]:=b;
        cpp[cp,2]:=0;
        while cur<>a do begin
            inc(cp);
            cpp[cp,1]:=prev[cur,1];
            cpp[cp,2]:=prev[cur,2];
            cur:=prev[cur,1];
        end;
        j:=1;
        for i:=cp downto 1 do begin
            pth[z,j,1]:=cpp[i,1];
            pth[z,j,2]:=cpp[i,2];
            inc(j);
        end;
        DeleteEdges;
        DeixtRA;
    end;
end;

procedure Save;
var i,j:longint;
begin
    write(z);
    for i:=1 to z do begin
        writeln;
        j:=1;
        while pth[i,j,2]<>0 do begin
            write(pth[i,j,1],' ',pth[i,j,2],' ');
            inc(j);
        end;
        write(pth[i,j,1]);
    end;
end;

begin
    randseed:=26527;
    assign(input,'rhyme.in');
    assign(output,'rhyme.out');
    reset(input);
    rewrite(output);
    Load;
    Solve;
    Save;
    close(input);
    close(output);
end.
