const eps=1e-9;
const bineps=1e-11;
const MAXN=51000;
var pnt:array[1..MAXN,1..2]of double;
    n,k:longint;
    by,ey,sqr:double;

function Vector(v1x,v1y,v2x,v2y:double):double;
begin
    Vector:=v1x*v2y-v2x*v1y;
end;

procedure Load;
var i:longint;
begin
    by:=11000;
    ey:=-11000;
    sqr:=0;
    read(n,k);
    for i:=1 to n do begin
        read(pnt[i,1],pnt[i,2]);
        if pnt[i,2]<by then by:=pnt[i,2];
        if pnt[i,2]>ey then ey:=pnt[i,2];
    end;
    pnt[n+1,1]:=pnt[1,1];
    pnt[n+1,2]:=pnt[1,2];
    for i:=1 to n do begin
        sqr:=sqr+Vector(pnt[i,1],pnt[i,2],pnt[i+1,1],pnt[i+1,2]);
    end;
    sqr:=abs(sqr)/2;
end;

var ys:array[1..MAXN]of double;

function GetX(i1,i2:longint;y:double):double;
var a,b,c:double;
begin
    a:=pnt[i2,2]-pnt[i1,2];
    b:=pnt[i1,1]-pnt[i2,1];
    c:=-a*pnt[i1,1]-b*pnt[i1,2];
    if abs(a)<eps then GetX:=pnt[i1,1]
    else GetX:=(-b*y-c)/a;
end;

function GetSquare(y1,y2:double):double;
var pp:array[1..MAXN,1..2]of double;
    ff,h,i,bi,npp,isi,f:longint;
    sqr:double;
begin
    for i:=1 to n do begin
        if (pnt[i,2]-y1<eps)and(pnt[i+1,2]-y1>eps) then begin
            bi:=i;
            break;
        end;
    end;
    i:=bi;
    h:=0;
    sqr:=0;
    while h<=n do begin
        if (pnt[i,2]-y1<eps)and(pnt[i+1,2]-y1>eps) then begin
            npp:=1;
            pp[1,2]:=y1;
            pp[1,1]:=GetX(i,i+1,y1);
            f:=1;
            isi:=1;
            ff:=0;
            while not(((pnt[i,2]-y1>-eps)and(pnt[i+1,2]-y1<-eps))and(isi=1))do begin
                if isi=1 then begin
                    if (pnt[i,2]-y2<eps)and(pnt[i+1,2]-y2>eps) then begin
                        if f=1 then begin
                            inc(npp);
                            pp[npp,1]:=pnt[i,1];
                            pp[npp,2]:=pnt[i,2];
                        end
                        else f:=1;
                        inc(npp);
                        pp[npp,2]:=y2;
                        pp[npp,1]:=GetX(i,i+1,y2);
                        isi:=0;
                    end
                    else begin
                        inc(npp);
                        pp[npp,1]:=pnt[i,1];
                        pp[npp,2]:=pnt[i,2];
                    end;
                end
                else if isi=0 then begin
                    if (pnt[i,2]-y2>eps)and(pnt[i+1,2]-y2<eps) then begin
                        inc(npp);
                        pp[npp,2]:=y2;
                        pp[npp,1]:=GetX(i,i+1,y2);
                        isi:=1;
                        if ((pnt[i,2]-y1>-eps)and(pnt[i+1,2]-y1<-eps)) then break;
                    end;
                end;
                inc(i);
                if i>n then i:=1;
                inc(h);
                if h>=n then begin
                    ff:=1;
                    break;
                end;
            end;
            if ff=0 then begin
                inc(npp);
                pp[npp,2]:=y1;
                pp[npp,1]:=GetX(i,i+1,y1);
            end;
            for i:=1 to npp-1 do sqr:=sqr+Vector(pp[i,1],pp[i,2],pp[i+1,1],pp[i+1,2]);
            sqr:=sqr+Vector(pp[npp,1],pp[npp,2],pp[1,1],pp[1,2]);
            if h>n then break;
        end
        else begin
            inc(i);
            inc(h);
        end;
    end;
    sqr:=sqr/2;
    GetSquare:=abs(sqr);
end;

procedure Solve;
var py,l,r,mid,sq:double;
    i:longint;
begin
    py:=by;
    for i:=1 to k do begin
        l:=py;
        r:=ey;
        while abs(r-l)>bineps do begin
            mid:=(l+r)/2;
            sq:=GetSquare(py,mid);
            if sq>sqr/(k+1) then r:=mid
            else l:=mid;
        end;
        ys[i]:=l;
        py:=l;
    end;
    for i:=1 to k do begin
        write(ys[i]:0:4);
        if i<k then writeln;
    end;
end;

begin
    assign(input,'antiufo.in');
    assign(output,'antiufo.out');
    reset(input);
    rewrite(output);
    Load;
    Solve;
    close(input);
    close(output);
end.
