var be1,be2,n,m,k:longint;
    edg:array[1..10,1..21000,1..2]of longint;
    ne:array[1..10]of longint;
    ws:array[1..10,1..310,1..310]of byte;
    bedg:array[1..10,1..310]of longint;

procedure Qsort(co,be,en:longint);
var l,r,x,t:longint;
begin
    l:=be;
    r:=en;
    x:=edg[co,l+random(r-l+1),1];
    while l<r do begin
        while edg[co,l,1]<x do inc(l);
        while edg[co,r,1]>x do dec(r);
        if l<=r then begin
            t:=edg[co,l,1];
            edg[co,l,1]:=edg[co,r,1];
            edg[co,r,1]:=t;
            t:=edg[co,l,2];
            edg[co,l,2]:=edg[co,r,2];
            edg[co,r,2]:=t;
            inc(l);
            dec(r);
        end;
    end;
    if be<r then Qsort(co,be,r);
    if l<en then Qsort(co,l,en);
end;


procedure Load;
var i,p,q,c,j:longint;
begin
    read(n,m,k);
    fillchar(ws,sizeof(ws),0);
    fillchar(ne,sizeof(ne),0);
    for i:=1 to m do begin
        read(p,q,c);
        if ws[c,p,q]=1 then continue;
        inc(ne[c]);
        edg[c,ne[c],1]:=p;
        edg[c,ne[c],2]:=q;
        inc(ne[c]);
        edg[c,ne[c],1]:=q;
        edg[c,ne[c],2]:=p;
        ws[c,p,q]:=1;
        ws[c,q,p]:=1;
    end;
    fillchar(bedg,sizeof(bedg),0);
    for i:=1 to k do begin
        Qsort(i,1,ne[i]);
        bedg[i,edg[i,1,1]]:=1;
        for j:=2 to ne[i] do begin
            if edg[i,j,1]<>edg[i,j-1,1] then begin
                bedg[i,edg[i,j,1]]:=j;
            end;
        end;
        bedg[i,n+1]:=ne[i]+1;
        for j:=n downto 1 do begin
            if bedg[i,j]=0 then bedg[i,j]:=bedg[i,j+1];
        end;
    end;
    read(be1,be2);
end;

var was,res:array[1..310,1..310]of longint;

function Count(be1,be2:longint):longint;
var i,co,n1,n2,j,mr,mmr,r:longint;
begin
    if be1=be2 then begin
        Count:=1;
        exit;
    end;
    if was[be1,be2]=2 then begin
        Count:=res[be1,be2];
        exit;
    end;
    was[be1,be2]:=1;
    mmr:=-1;
    for co:=1 to k do begin
        for i:=bedg[co,be1] to bedg[co,be1+1]-1 do begin
            n1:=edg[co,i,2];
            if n1=be2 then begin
                mmr:=1;
                break;
            end;
            if was[n1,be2]=1 then mr:=0
            else begin
                mr:=Count(n1,be2);
                if mr<0 then dec(mr);
                if mr>0 then inc(mr);
            end;
            for j:=bedg[co,be2] to bedg[co,be2+1]-1 do begin
                n2:=edg[co,j,2];
                if n2=n1 then continue;
                if n2=1 then begin
                    mr:=-1;
                    break;
                end;
                if was[n1,n2]=1 then begin
                    mr:=0;
                    continue;
                end;
                r:=Count(n1,n2);
                if r<0 then dec(r);
                if r>0 then inc(r);
                if r<0 then begin
                    if mr>=0 then mr:=r
                    else if mr<r then mr:=r;
                end;
                if r>0 then if (mr>0)and(r>mr) then mr:=r;
                if (r=0)and(mr>0)then mr:=0;
            end;
            if mmr=2000000000 then mmr:=mr;
            if mmr<0 then begin
                if mr=0 then mmr:=0;
                if mr<0 then if mmr>mr then mmr:=mr;
                if mr>0 then mmr:=mr;
            end
            else if mmr=0 then begin
                if mr>0 then mmr:=mr;
            end
            else begin
                if (mr>0)and(mr<mmr) then mmr:=mr;
            end;
        end;
    end;
    was[be1,be2]:=2;
    res[be1,be2]:=mmr;
    Count:=mmr;
end;


procedure Solve;
var r:longint;
begin
    fillchar(was,sizeof(was),0);
    if be2=1 then begin
        writeln('Escaped');
        write('0');
        exit;
    end
    else if be1=be2 then begin
        writeln('Caught');
        write('0');
        exit;
    end;
    r:=Count(be1,be2);
    if r<0 then begin
        writeln('Escaped');
        write(-r);
    end
    else if r>0 then begin
        writeln('Caught');
        write(r);
    end
    else write('Endless');
end;


begin
  assign(input,'pursuit.in');
  assign(output,'pursuit.out');
  reset(input);
  rewrite(output);
  Load;
  Solve;
  close(input);
  close(output);
end.
