var rct:array[1..110000,1..4]of longint;
    c:array[1..110000]of int64;
    fc,rnum:array[1..110000]of longint;
    n:longint;

procedure Load;
var t,i:longint;
begin
    read(n);
    for i:=1 to n do begin
        read(rct[i,1],rct[i,2],rct[i,3],rct[i,4]);
        read(fc[i]);
	c[i]:=fc[i];
        if rct[i,3]<rct[i,1] then begin
            t:=rct[i,3];
            rct[i,3]:=rct[i,1];
            rct[i,1]:=t;
        end;
        if rct[i,2]<rct[i,4] then begin
            t:=rct[i,2];
            rct[i,2]:=rct[i,4];
            rct[i,4]:=t;
        end;
        rnum[i]:=i;
    end;
end;

function Longer(i,j:longint):boolean;
begin
    if (rct[j,1]>rct[i,3])and(rct[j,2]<rct[i,4]) then Longer:=true
    else Longer:=false;
end;

procedure Qsort(be,en:longint);
var x,l,r,t:longint;
begin
    l:=be;
    r:=en;
    t:=l+random(r-l+1);
    x:=rct[t,3];
    while l<r do begin
        while x>rct[l,3] do inc(l);
        while x<rct[r,3] do dec(r);
        if l<=r then begin
            t:=rct[l,1];
            rct[l,1]:=rct[r,1];
            rct[r,1]:=t;
            t:=rct[l,2];
            rct[l,2]:=rct[r,2];
            rct[r,2]:=t;
            t:=rct[l,3];
            rct[l,3]:=rct[r,3];
            rct[r,3]:=t;
            t:=rct[l,4];
            rct[l,4]:=rct[r,4];
            rct[r,4]:=t;
            t:=rnum[l];
            rnum[l]:=rnum[r];
            rnum[r]:=t;
            t:=c[l];
            c[l]:=c[r];
            c[r]:=t;
            inc(l);
            dec(r);
        end;
    end;
    if be<r then Qsort(be,r);
    if l<en then Qsort(l,en);
end;

var val:array[1..110000]of int64;
    prev:array[1..110000]of longint;
    seq:array[1..110000]of longint;

procedure Solve;
var i,j,mj,ns:longint;
    max:int64;
begin
    Qsort(1,n);
    fillchar(prev,sizeof(prev),0);
    fillchar(val,sizeof(val),0);
    for i:=1 to n do begin
        val[i]:=c[i];
        max:=-2000000000;
        max:=max*1000000;
        mj:=0;
        for j:=1 to i-1 do begin
            if Longer(j,i) then if val[j]>max then begin
                max:=val[j];
                mj:=j;
            end;
        end;
        if mj<>0 then begin
            val[i]:=val[i]+max;
            prev[i]:=mj;
        end;
    end;
    max:=-2000000000;
    max:=max*1000000;
    mj:=0;
    for i:=1 to n do begin
        if val[i]>max then begin
            max:=val[i];
            mj:=i;
        end;
    end;
    ns:=0;
    writeln(max);
    while mj<>0 do begin
        inc(ns);
        seq[ns]:=rnum[mj];
        mj:=prev[mj];
    end;
    while ns<>0 do begin
        write(seq[ns]);
        dec(ns);
        if ns>=1 then write(' ');
    end;
end;

begin
  assign(input,'rects.in');
  assign(output,'rects.out');
  reset(input);
  rewrite(output);
  Load;
  Solve;
  close(input);
  close(output);
end.
