const MAXN=110000;
var pos:array[1..MAXN]of longint;
    rnum,fnum:array[1..MAXN]of longint;
    n,m,l:longint;
    edg:array[1..MAXN,1..2]of longint;

procedure Qsort(be,en:longint);
var l,r,x,t:longint;
begin
    l:=be;
    r:=en;
    x:=pos[l+random(r-l+1)];
    while l<r do begin
        while x>pos[l] do inc(l);
        while x<pos[r] do dec(r);
        if l<=r then begin
            t:=pos[l];
            pos[l]:=pos[r];
            pos[r]:=t;
            t:=fnum[l];
            fnum[l]:=fnum[r];
            fnum[r]:=t;
            inc(l);
            dec(r);
        end;
    end;
    if be<r then Qsort(be,r);
    if l<en then Qsort(l,en);
end;

procedure Load;
var i,t:longint;
begin
    read(n,m,l);
    for i:=1 to n do begin
        read(pos[i]);
        fnum[i]:=i;
    end;
    for i:=1 to m do begin
        read(edg[i,1],edg[i,2]);
    end;
    Qsort(1,n);
    for i:=1 to n do rnum[fnum[i]]:=i;
    for i:=1 to m do begin
        edg[i,1]:=rnum[edg[i,1]];
        edg[i,2]:=rnum[edg[i,2]];
        if edg[i,2]<edg[i,1] then begin
            t:=edg[i,2];
            edg[i,2]:=edg[i,1];
            edg[i,1]:=t;
        end;
    end;
end;

var fill:array[1..MAXN]of longint;

function getNext(i:longint):longint;
begin
    if i=n then getNExt:=1
    else GetNext:=i+1;
end;

procedure Solve;
var msum,i,cc,csum,j:longint;
begin
    msum:=-2000000000;
    for i:=1 to n do begin
        for j:=1 to m do begin
            if (edg[j,1]<=i)and(edg[j,2]>=i)then begin
                inc(fill[edg[j,2]]);
                dec(fill[edg[j,1]]);
            end
            else begin
                inc(fill[edg[j,1]]);
                dec(fill[edg[j,2]]);
            end;
        end;
        csum:=0;
        cc:=0;
        j:=i+1;
        if j>n then j:=1;
        while j<>i do begin
            inc(cc,fill[j]);
            if cc=0 then begin
                if j=n then inc(csum,l-pos[j]+pos[1])
                else inc(csum,pos[j+1]-pos[j]);
            end;
            j:=getNext(j);
        end;
        if csum>msum then msum:=csum;
    end;
    write(l-msum);
end;

begin
    assign(input,'roads.in');
    assign(output,'roads.out');
    reset(input);
    rewrite(output);
    Load;
    Solve;
    close(input);
    close(output);
end.
