type Queue=record
    px,py:array[1..41*45] of integer;
    st,en:integer;
end;
type MapType=array[1..45,1..41] of shortint;
type DoProc=procedure(xx,yy:integer;var tm:MapType);
var i,j,k:longint;
    bormap,map,temp:MapType;
    ch:char;
    cnt,sq,sqst:integer;
    best,max:integer;

procedure Clear(var qq:Queue);
begin
    qq.st:=2; qq.en:=1;
end;

function Empty(var qq:Queue):boolean;
begin
    if qq.st=1 then
        Empty:=(qq.en=41*45)
    else
        Empty:=(qq.en=qq.st-1);
end;

procedure Add(var qq:Queue;xx,yy:integer);
begin
    inc(qq.en);
    if qq.en>41*45 then
        qq.en:=1;
    qq.px[qq.en]:=xx;
    qq.py[qq.en]:=yy;
end;

procedure Pop(var qq:Queue;var xx,yy:integer);
begin
    xx:=qq.px[qq.st];
    yy:=qq.py[qq.st];
    inc(qq.st);
    if qq.st>41*45 then
        qq.st:=1;
end;

procedure reColor(xx,yy:integer;var tm:MapType);
begin
    tm[xx,yy]:=k;
end;

procedure Square(xx,yy:integer;var tm:MapType);
begin
    inc(sq);
end;

procedure Borders(xx,yy:integer;var tm:MapType);
var res:boolean;
begin
    res:=false;
    if xx>1 then
        res:=res or ((tm[xx-1,yy]<>tm[xx,yy]) and (tm[xx-1,yy]<>tm[45,41]));
    if yy>1 then
        res:=res or ((tm[xx,yy-1]<>tm[xx,yy]) and (tm[xx,yy-1]<>tm[45,41]));
    if xx<45 then
        res:=res or ((tm[xx+1,yy]<>tm[xx,yy]) and (tm[xx+1,yy]<>tm[45,41]));
    if yy<41 then
        res:=res or ((tm[xx,yy+1]<>tm[xx,yy]) and (tm[xx,yy+1]<>tm[45,41]));
    if res then
        inc(cnt);
end;

procedure Borders2(xx,yy:integer;var tm:MapType);
begin
    if xx>1 then
        if tm[xx-1,yy]=tm[1,1] then
            inc(BorMap[xx-1,yy]);
    if yy>1 then
        if tm[xx,yy-1]=tm[1,1] then
            inc(BorMap[xx,yy-1]);
    if xx<45 then
        if tm[xx+1,yy]=tm[1,1] then
            inc(BorMap[xx+1,yy]);
    if yy<41 then
        if tm[xx,yy+1]=tm[1,1] then
            inc(BorMap[xx,yy+1]);
end;

procedure BFS(var currMap:MapType;x1,y1:integer;tpr:DoProc);
var q:Queue;
    cx,cy:integer;
    tcolor:integer;
    vis:array[1..45,1..41] of boolean;

begin
    Clear(q);
    for cx:=1 to 45 do
        for cy:=1 to 41 do
            vis[cx,cy]:=false;
    vis[x1,y1]:=true;
    tcolor:=currMap[x1,y1];
    Add(q,x1,y1);
    while not Empty(q) do
    begin
        Pop(q,cx,cy);
        tpr(cx,cy,currMap);
        if cx>1 then
            if not vis[cx-1,cy] then
                if currMap[cx-1,cy]=tcolor then
                begin
                    Add(q,cx-1,cy);
                    vis[cx-1,cy]:=true;
                end;
        if cy>1 then
            if not vis[cx,cy-1] then
                if currMap[cx,cy-1]=tcolor then
                begin
                    Add(q,cx,cy-1);
                    vis[cx,cy-1]:=true;
                end;
        if cx<45 then
            if not vis[cx+1,cy] then
                if currMap[cx+1,cy]=tcolor then
                begin
                    Add(q,cx+1,cy);
                    vis[cx+1,cy]:=true;
                end;
        if cy<41 then
            if not vis[cx,cy+1] then
                if currMap[cx,cy+1]=tcolor then
                begin
                    Add(q,cx,cy+1);
                    vis[cx,cy+1]:=true;
                end;
    end;
end;

procedure antiBFS(var currMap:MapType;x1,y1:integer;tpr:DoProc);
var q:Queue;
    cx,cy:integer;
    tcolor:integer;
    vis:array[1..45,1..41] of boolean;
begin
    Clear(q);
    for cx:=1 to 45 do
        for cy:=1 to 41 do
            vis[cx,cy]:=false;
    vis[x1,y1]:=true;
    tcolor:=currMap[1,1];
    Add(q,x1,y1);
    while not Empty(q) do
    begin
        Pop(q,cx,cy);
        tpr(cx,cy,currMap);
        if cx>1 then
            if not vis[cx-1,cy] then
                if currMap[cx-1,cy]<>tcolor then
                begin
                    Add(q,cx-1,cy);
                    vis[cx-1,cy]:=true;
                end;
        if cy>1 then
            if not vis[cx,cy-1] then
                if currMap[cx,cy-1]<>tcolor then
                begin
                    Add(q,cx,cy-1);
                    vis[cx,cy-1]:=true;
                end;
        if cx<45 then
            if not vis[cx+1,cy] then
                if currMap[cx+1,cy]<>tcolor then
                begin
                    Add(q,cx+1,cy);
                    vis[cx+1,cy]:=true;
                end;
        if cy<41 then
            if not vis[cx,cy+1] then
                if currMap[cx,cy+1]<>tcolor then
                begin
                    Add(q,cx,cy+1);
                    vis[cx,cy+1]:=true;
                end;
    end;
end;

begin
    assign(input,'filya.in');
    assign(output,'filya.out');
    reset(input);
    rewrite(output);
    for j:=1 to 41 do
    begin
        for i:=1 to 45 do
        begin
            read(ch);
            map[i,j]:=ord(ch)-ord('0');
        end;
        readln;
    end;
    max:=-1;
    sq:=0;
    BFS(map,1,1,@Square);
    sqst:=sq;
    for k:=1 to 6 do
    begin
        if k=map[1,1] then continue;
        temp:=map;
        BFS(temp,1,1,@reColor);
        if temp[1,1]=temp[45,41] then continue;
        cnt:=0;
        BFS(temp,1,1,@Borders);
        sq:=0;
        BFS(temp,1,1,@Square);
        cnt:=sq;
        if ((cnt>max) and (sq<>sqst)) then
        begin
            best:=k;
            max:=cnt;
        end;
    end;
    if max<0 then
    begin
        for k:=1 to 6 do
        begin
            if k=map[1,1] then continue;
            temp:=map;
            BFS(temp,1,1,@reColor);
            if temp[1,1]=temp[45,41] then continue;
            sq:=0;
            BFS(temp,1,1,@Square);
            if sq>max then
            begin
                best:=k;
                max:=sq;
            end;
        end;
    end;
    write(best);
    close(input);
    close(output);
end.
