const longsize=32000;
      maxSize=30000;
      operSize=200;
      hashSize=50000;
type long=record
     arr:array[0..longsize] of shortint;
     len:longint;
end;
type smallLong=record
     arr:array[0..operSize] of shortint;
     len:longint;
end;
var i,j,m,n,k:longint;
    s:string;
    c1,c2,z1,z2,tc,tz:long;
    mlt1,mlt2:longint;
    openbr,closebr,period:longint;
    hashT:array[0..hashSize-1] of SmallLong;
    hashInf:array[0..hashSize-1] of longint;
    writeperiod:boolean;
    start,writedr:boolean;
    tb:boolean;

function hashFunction(var aa:SmallLong):longint;
var cnt:longint;
    u:longint;
begin
    cnt:=0;
    for u:=0 to aa.len-1 do
    begin
        cnt:=cnt*10+aa.arr[u]*aa.arr[u]*u+u*u*u;
        cnt:=cnt mod hashSize;
    end;
    hashFunction:=cnt;
end;

function Equal(var aa,bb:SmallLong):boolean;
var tb:boolean;
    u:longint;
begin
    if aa.len>0 then
        while aa.arr[aa.len-1]=0 do
        begin
            dec(aa.len);
            if aa.len=0 then break;
        end;
    if bb.len>0 then
        while bb.arr[bb.len-1]=0 do
        begin
            dec(bb.len);
            if bb.len=0 then break;
        end;
    if aa.len<>bb.len then
    begin
        Equal:=false;
        exit;
    end;
    tb:=true;
    for u:=0 to aa.len-1 do
        if aa.arr[u]<>bb.arr[u] then
        begin
            tb:=false;
            break;
        end;
    Equal:=tb;
end;

function HashAdd(var aa:SmallLong;ii:longint):boolean;
var u:longint; hf:longint;
begin
    hf:=hashFunction(aa);
    while hashInf[hf]<>-13 do
    begin
        if Equal(hashT[hf],aa) then
        begin
            HashAdd:=true;
            openbr:=hashInf[hf];
            exit;
        end;
        inc(hf);
        if hf>=hashSize then hf:=hf-hashSize;
    end;
    hashInf[hf]:=ii;
    hashT[hf]:=aa;
    hashAdd:=false;
end;

function max2(aa,bb:longint):longint;
begin
    if aa>bb then
        max2:=aa
    else
        max2:=bb;
end;

procedure Clear(var aa:long);
begin
    aa.len:=0;
end;

function Plus(var aa,bb:long):long;
var res:long;
    u:longint;
    t:shortint;
begin
    Clear(res); t:=0;
    res.len:=max2(aa.len,bb.len);
    for u:=0 to max2(aa.len,bb.len)-1 do
    begin
        if u>=aa.len then
            aa.arr[u]:=0;
        if u>=bb.len then
            bb.arr[u]:=0;
        res.arr[u]:=aa.arr[u]+bb.arr[u]+t;
        t:=res.arr[u] div 10;
        res.arr[u]:=res.arr[u]-(res.arr[u] div 10)*10;
    end;
    Plus:=res;
end;

procedure Minus(var aa:Long;var bb:SmallLong);
var u:longint;
    t:shortint;
begin
    t:=0;
    for u:=0 to max2(aa.len,bb.len)-1 do
    begin
        if u>=aa.len then
            aa.arr[u]:=0;
        if u>=bb.len then
            bb.arr[u]:=0;
        aa.arr[u]:=aa.arr[u]-bb.arr[u]-t;
        if aa.arr[u]<0 then
        begin
            aa.arr[u]:=aa.arr[u]+10;
            t:=1;
        end
        else
            t:=0;
    end;
    aa.len:=max2(aa.len,bb.len);
    if aa.len=0 then exit;
    while aa.arr[aa.len-1]=0 do
    begin
        dec(aa.len);
        if aa.len=0 then break;
    end;
end;

function Greater(var aa:Long;var bb:SmallLong):boolean;
var u,tr:longint;
    t:shortint;
begin
    t:=0;
    for u:=0 to max2(aa.len,bb.len)-1 do
    begin
        if u>=aa.len then
            aa.arr[u]:=0;
        if u>=bb.len then
            bb.arr[u]:=0;
        tr:=aa.arr[u]-bb.arr[u]-t;
        if tr<0 then t:=1
        else t:=0;
    end;
    Greater:=(t=0);
end;

procedure MultS(var aa:long;bb:longint);
var u:longint;
    t,c:longint;
begin
    t:=0;
    for u:=0 to aa.len-1 do
    begin
        c:=aa.arr[u]*bb+t;
        aa.arr[u]:=c-(c div 10)*10;
        t:=c div 10;
    end;
    while t>0 do
    begin
        inc(aa.len);
        aa.arr[aa.len-1]:=t-(t div 10)*10;
        t:=t div 10;
    end;
end;

function Mult(var aa,bb:long):long;
var res:long;
    u,v:longint;
    t,c:longint;
begin
    Clear(res); t:=0;
    res.len:=aa.len+bb.len;
    for u:=0 to res.len do
    begin
        c:=t;
        for v:=0 to u do
        begin
            if v>=aa.len then
                aa.arr[v]:=0;
            if u-v>=bb.len then
                bb.arr[u-v]:=0;
            c:=c+aa.arr[v]*bb.arr[u-v];
        end;
        res.arr[u]:=c-(c div 10)*10;
        t:=c div 10;
    end;
    while t>0 do
    begin
        inc(res.len);
        res.arr[res.len-1]:=t-(t div 10)*10;
        t:=t div 10;
    end;
    Mult:=res;
end;

procedure Mult10p(var aa:long;tadd:shortint);
var u:longint;
begin
    for u:=aa.len downto 1 do
        aa.arr[u]:=aa.arr[u-1];
    aa.arr[0]:=tadd;
    inc(aa.len);
end;

function Divide(var aa,bb:long):long;
var u,v,w:longint;
    res:long; ost:Long; osts:SmallLong;
    tos:array[0..9] of SmallLong;
begin
    for u:=0 to 9 do
    begin
        ost:=bb;
        MultS(ost,u);
        tos[u].len:=ost.len;
        for w:=0 to ost.len-1 do
            tos[u].arr[w]:=ost.arr[w];
    end;
    clear(ost);
    res.len:=aa.len;
    for u:=aa.len-1 downto 0 do
    begin
        Mult10p(ost,aa.arr[u]);
        osts.len:=ost.len;
        for w:=0 to ost.len-1 do
            osts.arr[w]:=ost.arr[w];
        if hashAdd(osts,u) then
        begin
            closebr:=u+1;
            for w:=0 to u do
                res.arr[w]:=0;
            Divide:=res;
            exit;
        end;
        for v:=9 downto 0 do
        begin
            if Greater(ost,tos[v]) then
                 break;
        end;
        res.arr[u]:=v;
        Minus(ost,tos[v]);
    end;
    Divide:=res;
end;

procedure readLong(var cc,zz:long);
var tc,tz,t1,t2:long;
    s:string;
begin
    readln(s);
    clear(cc);
    clear(zz);
    clear(tc);
    clear(tz);
    j:=0;
    zz.arr[0]:=1;
    zz.len:=1;
    for i:=1 to length(s) do
    begin
        if s[i]='.' then
        begin
            j:=i;
            break;
        end;
        Mult10p(cc,ord(s[i])-ord('0'));
    end;
    if j>0 then
    begin
        mlt1:=0; m:=0;
        for i:=j+1 to length(s) do
        begin
            if s[i]='(' then
            begin
                m:=i;
                break;
            end;
            Mult10p(zz,0);
            inc(mlt1);
            Mult10p(cc,ord(s[i])-ord('0'));
        end;
        if m>0 then
        begin
            k:=0;
            for i:=m+1 to length(s)-1 do
            begin
                Mult10p(tz,9);
                Mult10p(tc,ord(s[i])-ord('0'));
                inc(k);
            end;
            tz:=Mult(tz,zz);
            t1:=Mult(cc,tz); t2:=Mult(tc,zz);
            cc:=Plus(t1,t2);
            zz:=Mult(tz,zz);
        end;
    end;
end;

begin
    for i:=0 to hashSize-1 do hashInf[i]:=-13;
    assign(input,'divide.in');
    assign(output,'divide.out');
    reset(input);
    rewrite(output);
    readLong(c1,z1);
    readLong(c2,z2);
    c1:=Mult(c1,z2);
    for i:=maxSize+c1.len-1 downto maxSize do
        c1.arr[i]:=c1.arr[i-maxSize];
    for i:=0 to maxSize-1 do
        c1.arr[i]:=0;
    c1.len:=c1.len+maxSize;
    z1:=Mult(c2,z1);
    if c1.len>0 then
        while c1.arr[c1.len-1]=0 do
        begin
            dec(c1.len);
            if c1.len=0 then break;
        end;
    if z1.len>0 then
        while z1.arr[z1.len-1]=0 do
        begin
            dec(z1.len);
            if z1.len=0 then break;
        end;
    c2:=Divide(c1,z1);
    period:=openbr-closebr+1;
    while maxSize>openbr do
    begin
        tb:=true;
        if openbr+period>c2.len then break;
        for i:=openbr downto closebr do
            if c2.arr[i+period]<>c2.arr[i] then
            begin
                tb:=false;
                break;
            end;
        if tb then
        begin
            openbr:=openbr-period;
            closebr:=closebr-period;
        end;
        if not tb then break;
    end;
    while ((maxSize<=openbr) and (maxSize>closebr)) do
    begin
        for i:=openbr downto closebr do
            c2.arr[i-period]:=c2.arr[i];
        openbr:=openbr-period;
        closebr:=closebr-period;
    end;
    writeperiod:=false;
    for i:=closebr to openbr do
        if c2.arr[i]>0 then
        begin
            writeperiod:=true;
            break;
        end;
    writedr:=false;
    for i:=0 to maxSize-1 do
        if c2.arr[i]>0 then
        begin
            writedr:=true;
            break;
        end;
    start:=false;
    for i:=c2.len-1 downto maxSize do
    begin
        if c2.arr[i]>0 then
            start:=true;
        if i<=maxSize then
            start:=true;
        if start then write(c2.arr[i]);
    end;
    if writedr then
    begin
        write('.');
        for i:=maxSize-1 downto openbr+1 do
            write(c2.arr[i]);
        if writeperiod then
        begin
            write('(');
            for i:=openbr downto closebr do
                write(c2.arr[i]);
            write(')');
        end;
    end;
    close(input);
    close(output);
end.
