type
  TField = array [1..45, 1..41] of byte;

var
  f, col: TField;
  i, j, c, k, max, maxc, t: integer;
  ch: char;

function Recurse(depth: integer): integer;
var
  col: TField;
  c1, c2, minmax, i, j, c, k, t: integer;

procedure dfs(i, j: integer);
begin
  col[i, j]:=c;
  if (i-1>=1) and (f[i-1, j]=f[i, j]) and (col[i-1, j]=0) then
    dfs(i-1, j);
  if (i+1<=45) and (f[i+1, j]=f[i, j]) and (col[i+1, j]=0) then
    dfs(i+1, j);
  if (j-1>=1) and (f[i, j-1]=f[i, j]) and (col[i, j-1]=0) then
    dfs(i, j-1);
  if (j+1<=41) and (f[i, j+1]=f[i, j]) and (col[i, j+1]=0) then
    dfs(i, j+1);
end;

begin
  for i:=1 to 45 do
    for j:=1 to 41 do
      col[i, j]:=0;
  c:=1;
  dfs(1, 1);
  c:=2;
  dfs(45, 41);
  {for j:=1 to 41 do
  begin
    for i:=1 to 45 do
      Write(col[i, j]);
    WriteLn;
  end;}
  if depth=4 then
  begin
    c1:=0;
    c2:=0;
    for i:=1 to 45 do
      for j:=1 to 41 do
      begin
        if col[i, j]=1 then
          inc(c1);
        if col[i, j]=2 then
          inc(c2);
      end;
    recurse:=5*c1-c2;
    exit;
  end;
  if depth mod 2=0 then
  begin
    minmax:=-20000;
    k:=f[1, 1];
    for c:=1 to 6 do
    begin
      if (c=k) or (c=f[45, 41]) then
        continue;
      for i:=1 to 45 do
        for j:=1 to 41 do
          if col[i, j]=1 then f[i, j]:=c;
      t:=recurse(depth+1);
      if t>minmax then
        minmax:=t;
    end;
    for i:=1 to 45 do
      for j:=1 to 41 do
        if col[i, j]=1 then f[i, j]:=k;
    Recurse:=minmax;
  end else
  begin
    minmax:=20000;
    k:=f[45, 41];
    for c:=1 to 6 do
    begin
      if (c=k) or (c=f[1, 1]) then
        continue;
      for i:=1 to 45 do
        for j:=1 to 41 do
          if col[i, j]=2 then f[i, j]:=c;
      t:=recurse(depth+1);
      if t<minmax then
        minmax:=t;
    end;
    for i:=1 to 45 do
      for j:=1 to 41 do
        if col[i, j]=2 then f[i, j]:=k;
    recurse:=minmax;
  end;
end;

procedure dfs(i, j, c: integer);
begin
  col[i, j]:=c;
  if (i-1>=1) and (f[i-1, j]=f[i, j]) and (col[i-1, j]=0) then
    dfs(i-1, j, c);
  if (i+1<=45) and (f[i+1, j]=f[i, j]) and (col[i+1, j]=0) then
    dfs(i+1, j, c);
  if (j-1>=1) and (f[i, j-1]=f[i, j]) and (col[i, j-1]=0) then
    dfs(i, j-1, c);
  if (j+1<=41) and (f[i, j+1]=f[i, j]) and (col[i, j+1]=0) then
    dfs(i, j+1, c);
end;

begin
  Assign(input, 'filya.in');
  Assign(output, 'filya.out');
  Reset(input);
  Rewrite(output);
  for j:=1 to 41 do
  begin
    for i:=1 to 45 do
    begin
      Read(ch);
      f[i, j]:=ord(ch)-ord('0');
    end;
    ReadLn;
  end;
  dfs(1, 1, 1);
  k:=f[1, 1];
  max:=-20000;
  maxc:=0;
  for c:=1 to 6 do
  begin
    if (c=k) or (c=f[45, 41]) then
      continue;
    for i:=1 to 45 do
      for j:=1 to 41 do
        if col[i, j]=1 then
          f[i, j]:=c;
    t:=recurse(1);
    if t>max then
    begin
      max:=t;
      maxc:=c;
    end;
  end;
  WriteLn(maxc);
  Close(input);
  Close(output);
end.