type
  integer = longint;

var
  i, j, k, n, d: integer;
  p: array [0..1500] of integer;
  pow: array [0..1500, 0..1500] of integer;
  c: int64;

begin
  Assign(input, 'triples.in');
  Assign(output, 'triples.out');
  Reset(input);
  Rewrite(output);
  ReadLn(n, d);
  for i:=0 to d-1 do
  begin
    pow[0, i]:=0;
    pow[i, 0]:=1;
  end;
  for i:=1 to d-1 do
    for j:=1 to d-1 do
      pow[i, j]:=(pow[i, j-1]*i) mod d;
  for i:=0 to d-1 do
    p[i]:=0;
  for i:=1 to n do
  begin
    Read(j);
    inc(p[j mod d]);
  end;
  c:=0;
  for i:=0 to d-1 do
    for j:=0 to d-1 do
    begin
      k:=pow[i, j];
      if (i<>j) and (j<>k) and (k<>i) then
      begin
        c:=c+p[i]*p[j]*p[k];
        continue;
      end;
      if (i=j) and (j=k) then
      begin
        c:=c+p[i]*(p[i]-1)*(p[i]-2);
        continue;
      end;
      if (i=j) then
      begin
        c:=c+p[i]*(p[i]-1)*p[k];
        continue;
      end;
      if (j=k) then
      begin
        c:=c+p[j]*(p[j]-1)*p[i];
        continue;
      end;
      if (i=k) then
      begin
        c:=c+p[i]*(p[i]-1)*p[j];
        continue;
      end;
    end;
  WriteLn(c);
  Close(input);
  Close(output);
end.