type
  integer = longint;

var
  b, c, n, max, i, j: integer;
  maxo, curo: array [1..30] of boolean;
  col: array [0..20] of boolean;
  y, q, num: array [0..20, 0..30] of integer;
  f: array [0..20] of integer;


procedure recurse(s, o: integer);
var
  i, j, sum: integer;
  collision: boolean;
begin
  if f[s]>c then
  begin
    col[s]:=true;
    exit;
  end;
  if s=b then begin
    sum:=0;
    for i:=0 to b-1 do
      sum:=sum+f[i];
    if sum>max then
    begin
      max:=sum;
      for i:=1 to n do
        maxo[i]:=curo[i];
    end;
    exit;
  end;
  if o>q[s, 0] then
  begin
    recurse(s+1, 1);
    exit;
  end;
  for i:=s to y[s, o]-1 do
    f[i]:=f[i]+q[s, o];
  curo[num[s, o]]:=true;
  recurse(s, o+1);
  collision:=false;
  for i:=s to y[s, o]-1 do
  begin
    f[i]:=f[i]-q[s, o];
    if col[i] then
      collision:=true;
  end;
  curo[num[s, o]]:=false;
  if collision then
    recurse(s, o+1);
end;

begin
  Assign(input, 'trains.in');
  Assign(output, 'trains.out');
  Reset(input);
  Rewrite(output);
  ReadLn(c, b, n);
  for i:=0 to b do
    q[i, 0]:=0;
  for i:=1 to n do
  begin
    Read(j);
    inc(q[j, 0]);
    ReadLn(y[j, q[j, 0]], q[j, q[j, 0]]);
    num[j, q[j, 0]]:=i;
  end;
  max:=0;
  recurse(0, 1);
  WriteLn(max);
  for i:=1 to n do
    if maxo[i] then
      Write(i, ' ');
  Close(input);
  Close(output);
end.
