  {$I-,Q-,R-,S-}
const
    inf=1000000000;
    maxR=110;
    maxM=1100;

type
    TKey=record l,r:longint; end;
    TList=array[0..maxR] of longint;

var r,c,n,m,ans:longint;
    key:array[1..maxR] of TKey;
    cur0:array[0..maxm] of longint;
    now:array[0..1,0..maxm] of TList;
    used:array[0..maxm] of boolean;
    curR:array[0..1,0..maxm] of boolean;
    was:boolean;

Procedure readchar(var ch:char);
begin
    read(ch);
    while (ch<>'#')and(ch<>'.') do read(ch);
end;

Procedure readkey;
var i,j,min,max:longint;
    ch:char;
begin
    for i:=1 to r do
    begin
        min:=inf;
        max:=0;
        for j:=1 to c do
        begin
            readchar(ch);
            if ch='#' then
            begin
                if j<min then min:=j;
                if j>max then max:=j;
            end;
        end;
        key[i].l:=min;
        key[i].r:=max;
    end;
end;

Procedure init;
begin
    assign(input,'key.in');
    reset(input);
    assign(output,'key.out');
    rewrite(output);
    read(r,c);
    readkey;
end;

Function can(const q,w:longint):boolean;
begin
    can:=false;
    if w<c then exit;
    if cur0[w-(c-key[q].r)]>=key[q].r-key[q].l+1 then can:=true;
end;

Procedure dfs(const q,w:longint);
begin
    ans:=w;
    was:=true;
    if used[q] then exit;
    used[q]:=true;
    if now[w and 1][q,now[w and 1][q,0]]=r then
    begin
        curr[w and 1][q]:=true;
        dfs(q-1,w);
    end;
end;

Procedure doit;
var i,j,h:longint;
    ch:char;
begin
    was:=true;
    for i:=1 to n do
    begin
        if not was then exit;
        cur0[0]:=0;
        fillchar(curr[i and 1],sizeof(curr[i and 1]),0);
        fillchar(used,sizeof(used),0);
        used[0]:=true;
        was:=false;
        for j:=1 to m do
        begin
            now[i and 1][j,0]:=0;
            if now[(i+1) and 1][j,now[(i+1) and 1][j,0]]=r then dec(now[(i+1) and 1][j,0]);
            readchar(ch);
            if ch='.' then cur0[j]:=cur0[j-1]+1 else cur0[j]:=0;
            if can(1,j) then
            begin
                inc(now[i and 1][j,0]);
                now[i and 1][j,now[i and 1][j,0]]:=1;
            end;
            for h:=1 to now[(i+1) and 1][j,0] do
            begin
                if can(now[(i+1) and 1][j,h]+1,j) then
                begin
                    inc(now[i and 1][j,0]);
                    now[i and 1][j,now[i and 1][j,0]]:=now[(i+1) and 1][j,h]+1;
                end;
            end;
            if now[i and 1][j,now[i and 1][j,0]]=r then
            begin
                if curr[(i+1) and 1][j] or curr[i and 1][j-1] then
                begin
                    was:=true;
                    ans:=i;
                    curr[i and 1][j]:=true;
                    used[j]:=true;
                    dfs(j-1,i);
                end;
            end;
        end;
    end;
end;

Procedure doit2;
var i,j,h:longint;
begin
    for i:=n+1 to n+r do
    begin
        if not was then exit;
        cur0[0]:=0;
        fillchar(curr[i and 1],sizeof(curr[i and 1]),0);
        fillchar(used,sizeof(used),0);
        used[0]:=true;
        was:=false;
        for j:=1 to m do
        begin
            now[i and 1][j,0]:=0;
            if now[(i+1) and 1][j,now[(i+1) and 1][j,0]]=r then dec(now[(i+1) and 1][j,0]);
            cur0[j]:=cur0[j-1]+1;
            if can(1,j) then
            begin
                inc(now[i and 1][j,0]);
                now[i and 1][j,now[i and 1][j,0]]:=1;
            end;
            for h:=1 to now[(i+1) and 1][j,0] do
            begin
                if can(now[(i+1) and 1][j,h]+1,j) then
                begin
                    inc(now[i and 1][j,0]);
                    now[i and 1][j,now[i and 1][j,0]]:=now[(i+1) and 1][j,h]+1;
                end;
            end;
            if now[i and 1][j,now[i and 1][j,0]]=r then
            begin
                if curr[(i+1) and 1][j] or curr[i and 1][j-1] then
                begin
                    was:=true;
                    ans:=i;
                    curr[i and 1][j]:=true;
                    used[j]:=true;
                    dfs(j-1,i);
                end;
            end;
        end;
    end;
end;

Procedure solve;
var i,j:longint;
begin
    read(n,m);
    for i:=1 to m do
    for j:=1 to r do
    begin
        inc(now[0][i,0]);
        now[0][i,now[0][i,0]]:=j;
    end;
    for i:=1 to m do curr[0][i]:=true;
    doit;
    doit2;
end;

Procedure print;
begin
    if ans=n+r then writeln(-1) else
    writeln(ans);
end;

begin
    init;
    solve;
    print;
    close(input);
    close(output);
end.