  {$I-,Q-,R-,S-}
const
    maxn=60;

type
    extended=double;
    tpoint=record x,y:extended; end;

var n:longint;
    u,v:extended;
    a:array[1..maxn] of tpoint;
    d:array[1..maxn,1..maxn] of extended;

Procedure init;
var i:longint;
begin
    assign(input,'tractor.in');
    reset(input);
    assign(output,'tractor.out');
    rewrite(output);
    read(n);
    inc(n);
    read(u,v);
    for i:=1 to n do read(a[i].x,a[i].y);
end;

Function dist(const a,b:tpoint):extended;
begin
    dist:=sqrt(sqr(a.x-b.x)+sqr(a.y-b.y));
end;

Function min(const a,b:extended):extended;
begin
    if a<b then min:=a else min:=b;
end;

Procedure solve;
var i,j,k:longint;
begin
    for i:=1 to n do
    for j:=1 to n do
    begin
       d[i,j]:=dist(a[i],a[j])/u;
    end;
    for i:=1 to n-1 do
    begin
        d[i,i+1]:=dist(a[i],a[j])/v;
        d[i+1,i]:=d[i,i+1];
    end;
    for k:=1 to n do
    for i:=1 to n do
    for j:=1 to n do d[i,j]:=min(d[i,j],d[i,k]+d[k,j]);
end;

Procedure print;
begin
    writeln(d[1,n]:0:5);
end;

begin
    init;
    solve;
    print;
    close(input);
    close(output);
end.