  {$I-,Q-,R-,S-}
const
    n=41;
    m=45;
    maxn=50;
    di:array[1..4] of longint=(0,0,1,-1);
    dj:array[1..4] of longint=(1,-1,0,0);
    inf=1000000000;

type
    ttype=record t,n1:longint; end;
    TBoard=array[0..maxn,0..maxn] of longint;

var a:TBoard;
    c1,c2,col:longint;
    used:array[0..maxn,0..maxn] of longint;

Procedure readchar(var ch:char);
begin
    read(ch);
    while not (ch in ['1'..'6']) do read(ch);
end;

Procedure init;
var i,j:longint;
    ch:char;
begin
    assign(input,'filya.in');
    reset(input);
    assign(output,'filya.out');
    rewrite(output);
    for i:=1 to n do
    for j:=1 to m do
    begin
        readchar(ch);
        a[i,j]:=ord(ch)-48;
    end;
    c1:=a[1,1];
    c2:=a[n,m];
end;

Function dfs(const q,w,c,p:longint; const a:tboard):longint;
var i,res:longint;
begin
    used[q,w]:=p;
    res:=1;
    for i:=1 to 4 do
    begin
        if used[q+di[i],w+dj[i]]=0 then
        if a[q+di[i],w+dj[i]]=c then inc(res,dfs(q+di[i],w+dj[i],c,p,a));
    end;
    dfs:=res;
end;

Function recmin(const a:TBoard; const dep,alpha,betta:longint):longint; forward;
Function recmax(const a:TBoard; const dep,alpha,betta:longint):longint; forward;

Function recmin(const a:TBoard; const dep,alpha,betta:longint):longint;
var i,j,h,cur,min:longint;
    t:tboard;
begin
    if dep>5 then
    begin
        fillchar(used,sizeof(used),0);
        recmin:=dfs(1,1,a[1,1],1,a)-dfs(n,m,a[n,m],2,a);
        exit;
    end;
    min:=inf;
    for h:=1 to 6 do if (h<>a[1,1])and(h<>a[n,m]) then
    begin
        t:=a;
        fillchar(used,sizeof(used),0);
        dfs(n,m,a[n,m],2,a);
        for i:=1 to n do
        for j:=1 to m do if used[i,j]=2 then t[i,j]:=h;
        fillchar(used,sizeof(used),0);
        dfs(n,m,h,2,t);
        cur:=recmax(t,dep+1,alpha,min);
        if cur<min then
        begin
            min:=cur;
        end;
        if min<alpha then
        begin
            recmin:=min;
            exit;
        end;
    end;
    recmin:=min;
end;

Function recmax(const a:TBoard; const dep,alpha,betta:longint):longint;
var i,j,h,cur,max:longint;
    t:tboard;
begin
    if dep>5 then
    begin
        fillchar(used,sizeof(used),0);
        recmax:=dfs(1,1,a[1,1],1,a)-dfs(n,m,a[n,m],2,a);
        exit;
    end;
    max:=-inf;
    for h:=1 to 6 do if (h<>a[1,1])and(h<>a[n,m]) then
    begin
        t:=a;
        fillchar(used,sizeof(used),0);
        dfs(1,1,a[1,1],1,a);
        for i:=1 to n do
        for j:=1 to m do if used[i,j]=1 then t[i,j]:=h;
        fillchar(used,sizeof(used),0);
        dfs(1,1,h,1,t);
        cur:=recmin(t,dep+1,max,betta);
        if cur>max then
        begin
            max:=cur;
            if dep=1 then col:=h;
        end;
        if (max>Betta) then
        begin
            recmax:=max;
            exit;
        end;
    end;
    recmax:=max;
end;

Procedure solve;
begin
    recmax(a,1,0,1000000000);
end;

Procedure print;
begin
    writeln(col);
end;

begin
    init;
    solve;
    print;
    close(input);
    close(output);
end.