  {$I-,Q-,R-,S-}
  {$M 60000000}
const
    maxn=400;
    maxlong=31000;
    P=23917;

type
    TLong=array[0..maxn] of longint;
    TlongLong=array[0..maxlong] of longint;
    TD=record ch,zn:TLong; end;
    TTD=record c,d,p:TLong; end;
    TTlongD=record c,d,p:TlongLong; end;
    TSost=(_period,_int,_real);
    list=^tlist;
    tlist=record next:list; a:tlong; p:longint; end;

var a,b,c:TD;
    aa,bb:boolean;
    H:array[0..P] of list;
    ans:TTlongD;

Procedure init;
begin
    assign(input,'divide.in');
    reset(input);
    assign(output,'divide.out');
    rewrite(output);
end;

Procedure swap(var a,b:longint);
var t:longint;
begin
    t:=a;
    a:=b;
    b:=t;
end;

Procedure reverse(var a:TLong);
var i:longint;
begin
    for i:=1 to a[0] div 2 do swap(a[i],a[a[0]-i+1]);
end;

Procedure readreal(var t:TTD; var cc:boolean);
var s:string;
    i:longint;
    cur:TSost;
begin
    fillchar(t,sizeof(t),0);
    readln(s);
    cur:=_int;
    for i:=1 to length(s) do
    begin
        case cur of
          _int:
            begin
                if s[i]='-' then cc:=true else
                if s[i]='.' then cur:=_real else
                if s[i] in ['0'..'9'] then
                begin
                    inc(t.c[0]);
                    t.c[t.c[0]]:=ord(s[i])-48;
                end;
            end;
          _real:
            begin
                if s[i]='(' then cur:=_period else
                if s[i] in ['0'..'9'] then
                begin
                    inc(t.d[0]);
                    t.d[t.d[0]]:=ord(s[i])-48;
                end;
            end;
          _period:
            begin
                if s[i] in ['0'..'9'] then
                begin
                    inc(t.p[0]);
                    t.p[t.p[0]]:=ord(s[i])-48;
                end;
            end;
        end;
    end;
    if t.c[0]=0 then t.c[0]:=1;
    reverse(t.c);
    reverse(t.d);
    reverse(t.p);
end;

Function mullong(const a,b:TLong):TLong;
var c:TLong;
    i,j:longint;
begin
    fillchar(c,sizeof(c),0);
    for i:=1 to a[0] do
    for j:=1 to b[0] do
    begin
        c[i+j-1]:=c[i+j-1]+a[i]*b[j];
        c[i+j]:=c[i+j]+(c[i+j-1] div 10);
        c[i+j-1]:=c[i+j-1] mod 10;
    end;
    c[0]:=a[0]+b[0];
    while (c[c[0]]=0)and(c[0]>1) do dec(c[0]);
    mullong:=c;
end;

Function max(const a,b:longint):longint;
begin
    if a>b then max:=a else max:=b;
end;

Function sumlong(const a,b:Tlong):TLong;
var c:TLong;
    i,ost:longint;
begin
    ost:=0;
    fillchar(c,sizeof(c),0);
    c[0]:=max(a[0],b[0]);
    for i:=1 to c[0] do
    begin
        c[i]:=ost+a[i]+b[i];
        ost:=c[i] div 10;
        c[i]:=c[i] mod 10;
    end;
    if ost<>0 then
    begin
        inc(c[0]);
        c[c[0]]:=ost;
    end;
    sumlong:=c;
end;

Procedure convert(const t:TTD; var a:TD);
var t1,t2,t3,t4:td;
    i:longint;
begin
    fillchar(t1,sizeof(t1),0);
    fillchar(t2,sizeof(t2),0);
    fillchar(t3,sizeof(t3),0);
    {get C}
    t1.ch:=t.c;
    t1.zn[0]:=1;
    t1.zn[1]:=1;

    {get D}
    t2.ch:=t.d;
    t2.zn[0]:=t2.ch[0]+1;
    t2.zn[t2.zn[0]]:=1;

    {get P}
    t3.ch:=t.p;
    t3.zn[0]:=t3.ch[0]+t2.ch[0];
    for i:=t2.ch[0]+1 to t3.zn[0] do t3.zn[i]:=9;
    while (t3.zn[t3.zn[0]]=0)and(t3.zn[0]>1) do dec(t3.zn[0]);

    if (t3.zn[0]=0)or((t3.zn[0]=1)and(t3.zn[1]=0)) then t3.zn[1]:=1;
    if (t2.zn[0]=0)or((t2.zn[0]=1)and(t2.zn[1]=0)) then t2.zn[1]:=1;
    if (t1.zn[0]=0)or((t1.zn[0]=1)and(t1.zn[1]=0)) then t1.zn[1]:=1;
    if t3.zn[0]=0 then t3.zn[0]:=1;
    if t2.zn[0]=0 then t2.zn[0]:=1;
    if t1.zn[0]=0 then t1.zn[0]:=1;

    {sum C D P}
    t4.zn:=mullong(t1.zn,t2.zn);
    t4.ch:=mullong(t1.ch,t2.zn);
    t1.ch:=mullong(t2.ch,t1.zn);
    t2.ch:=sumlong(t1.ch,t4.ch);
    t2.zn:=t4.zn;
    t1.zn:=mullong(t2.zn,t3.zn);
    t1.ch:=mullong(t2.ch,t3.zn);
    t4.ch:=mullong(t3.ch,t2.zn);
    a.ch:=sumlong(t4.ch,t1.ch);
    a.zn:=t1.zn;
end;

Function more2(const a:tlong; const b:Tlong; const l,r:longint):boolean;
var ia,ib:longint;
begin
    if a[0]>(r-l+1) then more2:=true else
    if a[0]<(r-l+1) then more2:=false else
    begin
        ia:=1;
        ib:=l;
        while a[ia]=b[ib] do
        begin
            inc(ia);
            inc(ib);
            if ib>r then break;
        end;
        if ib>r then more2:=false else
        if a[ia]>b[ib] then more2:=true else more2:=false;
    end;
end;

Function more(const a:tlong; const b:TlongLong; const l,r:longint):boolean;
var ia,ib:longint;
begin
    if a[0]>(r-l+1) then more:=true else
    if a[0]<(r-l+1) then more:=false else
    begin
        ia:=1;
        ib:=l;
        while a[ia]=b[ib] do
        begin
            inc(ia);
            inc(ib);
            if ib>r then break;
        end;
        if ib>r then more:=false else
        if a[ia]>b[ib] then more:=true else more:=false;
    end;
end;

Procedure sublong2(var a:TLong; const l,r:longint; const b:TLong);
var ia,ib:longint;
begin
    ia:=r;
    ib:=b[0];
    while ib>=1 do
    begin
        a[ia]:=a[ia]-b[ib];
        if a[ia]<0 then
        begin
            dec(a[ia-1]);
            inc(a[ia],10);
        end;
        dec(ia);
        dec(ib);
    end;
end;

Procedure sublong(var a:TlongLong; const l,r:longint; const b:TLong);
var ia,ib:longint;
begin
    ia:=r;
    ib:=b[0];
    while ib>=1 do
    begin
        a[ia]:=a[ia]-b[ib];
        if a[ia]<0 then
        begin
            dec(a[ia-1]);
            inc(a[ia],10);
        end;
        dec(ia);
        dec(ib);
    end;
end;

Function lesseq2(const a:tlong; const b:TLong; const l,r:longint):boolean;
var ia,ib:longint;
begin
    if a[0]<(r-l+1) then lesseq2:=true else
    if a[0]>(r-l+1) then lesseq2:=false else
    begin
        ia:=1;
        ib:=l;
        while a[ia]=b[ib] do
        begin
            inc(ia);
            inc(ib);
            if ib>r then break;
        end;
        if ib>r then lesseq2:=true else
        if a[ia]<=b[ib] then lesseq2:=true else lesseq2:=false;
    end;
end;

Function lesseq(const a:tlong; const b:TlongLong; const l,r:longint):boolean;
var ia,ib:longint;
begin
    if a[0]<(r-l+1) then lesseq:=true else
    if a[0]>(r-l+1) then lesseq:=false else
    begin
        ia:=1;
        ib:=l;
        while a[ia]=b[ib] do
        begin
            inc(ia);
            inc(ib);
            if ib>r then break;
        end;
        if ib>r then lesseq:=true else
        if a[ia]<=b[ib] then lesseq:=true else lesseq:=false;
    end;
end;

Function gethash(const a:TlongLong; const l,r:longint):longint;
var i,j,hash,cur:longint;
begin
    hash:=0;
    for i:=l to r do
    begin
        cur:=1;
        for j:=1 to (i-l) mod 5 + 1 do cur:=cur*a[i];
        hash:=(hash+cur) mod P;
    end;
    gethash:=hash;
end;

Function eq(const a:tlong; b:TlongLong; const l,r:longint):boolean;
var ia,ib:longint;
begin
    if a[0]<>(r-l+1) then
    begin
        eq:=false;
        exit;
    end;
    ia:=1;
    ib:=l;
    while a[ia]=b[ib] do
    begin
        inc(ia);
        inc(ib);
        if ib>r then
        begin
            eq:=true;
            exit;
        end;
    end;
    if a[ia]<>b[ib] then
    begin
        eq:=false;
        exit;
    end;
end;

Function look(const hash:longint; const a:tlonglong; const l,r:longint):list;
var buf:list;
begin
    buf:=H[hash];
    while buf<>nil do
    begin
        if eq(buf^.a,a,l,r) then
        begin
            look:=buf;
            exit;
        end;
        buf:=buf^.next;
    end;
    look:=nil
end;

Procedure add(const hash:longint; const a:tlonglong; const l,r,p:longint);
var buf:list;
    i:longint;
begin
    new(buf);
    buf^.next:=H[hash];
    fillchar(buf^.a,sizeof(buf^.a),0);
    buf^.a[0]:=r-l+1;
    buf^.p:=p;
    for i:=1 to buf^.a[0] do buf^.a[i]:=a[l+i-1];
    h[hash]:=buf;
end;

Procedure divide(a:TlongLong; const b:TLong);
var l,r,t,i:longint;
    tt:list;
begin
    l:=1;
    r:=1;
    while more(b,a,l,r) do
    begin
        inc(r);
        if r>a[0] then break;
    end;
    while r<=a[0] do
    begin
        inc(ans.c[0]);
        ans.c[ans.c[0]]:=0;
        while lesseq(b,a,l,r) do
        begin
            inc(ans.c[ans.c[0]]);
            sublong(a,l,r,b);
            while (a[l]=0)and(l<r) do inc(l);
        end;
        inc(r);
        while (a[l]=0)and(l<=r) do inc(l);
    end;
    while l<=r do
    begin
        t:=gethash(a,l,r);
        tt:=look(t,a,l,r);
        if tt=nil then add(t,a,l,r,ans.d[0]) else
        begin
            ans.p[0]:=ans.d[0]-tt^.p;
            for i:=1 to ans.p[0] do ans.p[i]:=ans.d[tt^.p+i];
            ans.d[0]:=tt^.p;
            exit;
        end;
        inc(ans.d[0]);
        ans.d[ans.d[0]]:=0;
        while lesseq(b,a,l,r) do
        begin
            inc(ans.d[ans.d[0]]);
            sublong(a,l,r,b);
            while (a[l]=0)and(l<r) do inc(l);
        end;
        inc(r);
        while (a[l]=0)and(l<=r) do inc(l);
    end;
end;

Function conv(const a:tlong):tlonglong;
var res:tlonglong;
    i:longint;
begin
    fillchar(res,sizeof(res),0);
    for i:=0 to a[0] do res[i]:=a[i];
    conv:=res;
end;

Function divlong(a:tlong; const b:TLong; var rr:tlong):TLong;
var l,r,i:longint;
    ans,res:TLong;
begin
    l:=1;
    r:=1;
    while more2(b,a,l,r) do
    begin
        inc(r);
        if r>a[0] then break;
    end;
    fillchar(ans,sizeof(ans),0);
    while r<=a[0] do
    begin
        inc(ans[0]);
        while lesseq2(b,a,l,r) do
        begin
            inc(ans[ans[0]]);
            sublong2(a,l,r,b);
            while (a[l]=0)and(l<r) do inc(l);
        end;
        inc(r);
        while (a[l]=0)and(l<=r) do inc(l);
    end;
    divlong:=ans;
    fillchar(res,sizeof(res),0);
    for i:=l to r-1 do
    begin
        inc(res[0]);
        res[res[0]]:=a[i];
    end;
    rr:=res;
end;

Procedure swaplong(var a,b:TLong);
var t:TLong;
begin
    t:=a;
    a:=b;
    b:=t;
end;

Function eq02(a:Tlong):boolean;
begin
    while (a[a[0]]=0)and(a[0]>1) do dec(a[0]);
    if (a[0]=0)or((a[0]=1)and(a[a[0]]=0)) then eq02:=true else eq02:=false;
end;

Function gcd(a,b:TLong):TLong;
var t:tlong;
begin
    if more2(b,a,1,a[0]) then swaplong(a,b);
    while not eq02(b) do
    begin
        divlong(a,b,t);
        a:=b;
        b:=t;
    end;
    gcd:=a;
end;

Procedure solve;
var t:TTD;
    tt:tlong;
    p,qq:Tlong;
begin
    readreal(t,aa);
    convert(t,a);
    if eq02(a.ch) then
    begin
        writeln(0);
        close(input);
        close(output);
        halt;
    end;
    readreal(t,bb);
    convert(t,b);
    c.ch:=mullong(a.ch,b.zn);
    c.zn:=mullong(a.zn,b.ch);
    reverse(c.ch);
    reverse(c.zn);
    p:=gcd(c.ch,c.zn);
    tt:=divlong(c.ch,p,qq);
    c.ch:=tt;
    tt:=divlong(c.zn,p,qq);
    c.zn:=tt;
    if (c.ch[0]=1)and(c.ch[1]=0) then
    begin
        writeln(0);
        close(input);
        close(output);
        halt;
    end;
    divide(conv(c.ch),c.zn);
end;

Function eq0(a:Tlonglong):boolean;
begin
    while (a[a[0]]=0)and(a[0]>1) do dec(a[0]);
    if (a[0]=0)or((a[0]=1)and(a[a[0]]=0)) then eq0:=true else eq0:=false;
end;

Procedure print;
var i:longint;
begin
    if (ans.c[0]=0)or((ans.c[0]=1)and(ans.c[1]=0)) then write('0') else
    begin
        if aa xor bb then write('-');
        for i:=1 to ans.c[0] do write(ans.c[i]);
    end;
    if eq0(ans.d) and eq0(ans.p) then exit;
    write('.');
    for i:=1 to ans.d[0] do write(ans.d[i]);
    if eq0(ans.p) then exit;
    write('(');
    for i:=1 to ans.p[0] do write(ans.p[i]);
    write(')');
end;

begin
    init;
    solve;
    print;
    close(input);
    close(output);
end.