  {$I-,Q-,R-,S-}
const
    maxn=1250;

var n:longint;
    a:array[0..maxn,0..maxn] of longint;
    ind,cur,old:array[0..maxn] of longint;

Procedure init;
begin
    assign(input,'chat.in');
    reset(input);
    assign(output,'chat.out');
    rewrite(output);
end;

Function readdata:boolean;
var i,j:longint;
begin
    readdata:=false;
    read(n);
    if n=0 then exit;
    fillchar(a,sizeof(a),0);
    fillchar(ind,sizeof(ind),0);
    fillchar(cur,sizeof(cur),0);
    for i:=1 to n do
    begin
        ind[i]:=i;
        cur[i]:=1;
        for j:=1 to n do read(a[i,j]);
    end;
    readdata:=true;
end;

Function more(const q1,w1,q2,w2:longint):longint;
begin
    if q1>q2 then
    begin
        if w1>=w2 then
        begin
            more:=1;
            exit;
        end;
        more:=0;
        exit;
    end else
    if q1<q2 then
    begin
        if w1<=w2 then
        begin
            more:=-1;
            exit;
        end;
        more:=0;
        exit;
    end else
    begin
        if w1>w2 then more:=1 else more:=-1;
        exit;
    end;
end;

Function qsort(const q,l,r:longint):boolean;
var i,j,x,xx,t,y:longint;
begin
    qsort:=false;
    i:=l;
    j:=r;
    x:=a[ind[(l+r) div 2],q];
    xx:=cur[ind[(l+r) div 2]];
    repeat
        while true do
        begin
            t:=more(x,xx,a[ind[i],q],cur[ind[i]]);
            if t=0 then exit;
            if t=-1 then break;
            inc(i);
        end;
        while true do
        begin
            t:=more(a[ind[j],q],cur[ind[j]],x,xx);
            if t=0 then exit;
            if t=-1 then break;
            dec(j);
        end;
        if i<=j then
        begin
            y:=ind[i];
            ind[i]:=ind[j];
            ind[j]:=y;
            y:=cur[ind[i]];
            cur[ind[i]]:=cur[ind[j]];
            cur[ind[j]]:=y;
            inc(i);
            dec(j);
        end;
    until i>j;
    if i<r then if not qsort(q,i,r) then exit;
    if j>l then if not qsort(q,l,j) then exit;
    qsort:=true;
end;

Function fmax(const a,b:longint):longint;
begin
    if a>b then fmax:=a else fmax:=b;
end;

Procedure qsort2(const l,r:longint);
var i,j,x,y:longint;
begin
    i:=l;
    j:=r;
    x:=ind[(l+r) div 2];
    repeat
        while ind[i]<x do inc(i);
        while ind[j]>x do dec(j);
        if i<=j then
        begin
            y:=ind[i];
            ind[i]:=ind[j];
            ind[j]:=y;
            inc(i);
            dec(j);
        end;
    until i>j;
    if i<r then qsort2(i,r);
    if j>l then qsort2(l,j);
end;

Procedure solve;
var i,j,max,tt,l,r:longint;
    bo:boolean;
begin
    while readdata do
    begin
        for i:=1 to n do
        begin
            max:=0;
            for j:=1 to n do max:=fmax(max,a[j,i]);
            a[i,i]:=max;
        end;
        bo:=true;
        for i:=1 to n do
        begin
            if not qsort(i,1,n) then
            begin
                bo:=false;
                break;
            end;
            tt:=0;
            old:=cur;
            fillchar(cur,sizeof(cur),0);
            for j:=1 to n do
            begin
                if old[ind[j]]<>old[ind[j-1]] then
                begin
                    inc(tt);
                    cur[ind[j]]:=tt;
                end else
                if a[ind[j],i]>a[ind[j-1],i] then
                begin
                    inc(tt);
                    cur[ind[j]]:=tt;
                end else cur[ind[j]]:=tt;
            end;
        end;
        if not bo then writeln(-1) else
        begin
            l:=1;
            r:=1;
            while r<=n do
            begin
                while cur[ind[l]]=cur[ind[r]] do inc(r);
                qsort2(l,r-1);
                l:=r;
            end;
            for i:=1 to n do write(ind[i],' ');
            writeln;
        end;
    end;
end;

Procedure print;
begin

end;

begin
    init;
    solve;
    print;
    close(input);
    close(output);
end.