  {$I-,Q-,R-,S-}
const
    maxn=510;
    temp=1000000000;
    dx:array[1..8] of longint=(-1,0,1,1,1,0,-1,-1);
    dy:array[1..8] of longint=(1,1,1,0,-1,-1,-1,0);

type
    tpoint=record x,y:longint; end;

var res:array[0..maxn*8] of int64;
    p:array[0..maxn*8] of tpoint;
    po:array[0..maxn] of tpoint;
    used:array[0..maxn*8] of boolean;
    a:array[0..maxn*8,0..maxn*8] of longint;
    can:array[0..maxn*8,0..maxn*8] of boolean;
    inf:int64;
    s,f:tpoint;
    n,num:longint;

Procedure init;
var i:longint;
begin
{    fillchar(res,sizeof(res),0);
    fillchar(p,sizeof(p),0);
    fillchar(po,sizeof(po),0);
    fillchar(used,sizeof(used),0);
    fillchar(a,sizeof(a),0);
    fillchar(can,sizeof(can),0);}
    assign(input,'king.in');
    reset(input);
    assign(output,'king.out');
    rewrite(output);
    read(s.x,s.y);
    read(f.x,f.y);
    read(n);
    inf:=temp;
    inf:=inf*temp;
    for i:=1 to n do read(po[i].x,po[i].y);
end;

Function ok(const p:tpoint):boolean;
var i:longint;
begin
    ok:=false;
    for i:=1 to n do if (p.x=po[i].x)and(p.y=po[i].y) then exit;
    ok:=true;
end;

Procedure BuildPoints;
var i,j:longint;
    cur:tpoint;
begin
    p[1]:=s;
    num:=1;
    for i:=1 to n do
    begin
        for j:=1 to 8 do
        begin
            cur.x:=po[i].x+dx[j];
            cur.y:=po[i].y+dy[j];
            if ok(cur) then
            begin
                inc(num);
                p[num]:=cur;
            end;
        end;
    end;
    inc(num);
    p[num]:=f;
end;

Function max(const a,b:longint):longint;
begin
    if a>b then max:=a else max:=b;
end;

Function dist(const a,b:tpoint):longint;
begin
    dist:=max(abs(a.x-b.x),abs(a.y-b.y));
end;

Function eq(const a,b:tpoint):boolean;
begin
    eq:=(a.x=b.x)and(a.y=b.y);
end;

Procedure MakeMS;
var i,j,h:longint;
    bo:boolean;
begin
    for i:=1 to num do
    for j:=1 to num do
    begin
        bo:=true;
        for h:=1 to n do if dist(p[i],p[j])=dist(p[i],po[h])+dist(po[h],p[j]) then
        begin
            bo:=false;
            break;
        end;
        if bo then
        begin
            can[i,j]:=true;
            a[i,j]:=dist(p[i],p[j]);
        end;
    end;
end;

Function getmin:longint;
var i:longint;
    min:int64;
begin
    getmin:=0;
    min:=inf;
    for i:=1 to num do if not used[i] then
    begin
        if res[i]<min then
        begin
            min:=res[i];
            getmin:=i;
        end;
    end;
end;

Procedure Dijkstra;
var i,t:longint;
begin
    for i:=1 to num do res[i]:=inf;
    res[1]:=0;
    while true do
    begin
        t:=getmin;
        if t=0 then break;
        for i:=1 to num do if can[t,i] then
        if res[i]> res[t]+a[t,i] then
           res[i]:=res[t]+a[t,i];
        used[t]:=true;
    end;
end;

Procedure solve;
begin
    BuildPoints;
    MakeMS;
    Dijkstra;
end;

Procedure print;
begin
    writeln(res[num]);
end;

begin
    init;
    solve;
    print;
    close(input);
    close(output);
end.