  {$I-,Q-,R-,S-}
const
    maxn=5100;
    _eps=1E-5;
    inf=1000000000;

type
    extended=real;
    TPoint=record x,y:extended; end;

var n:longint;
    x,l:array[1..maxn] of extended;
    res:tpoint;

Procedure init;
var i:longint;
begin
    assign(input,'popular.in');
    reset(input);
    assign(output,'popular.out');
    rewrite(output);
    read(n);
    for i:=1 to n do
    begin
        read(x[i],l[i]);
    end;
end;

Procedure no;
begin
    writeln(-1,' ',-1);
    close(input);
    close(output);
    halt;
end;

Function eq(const a,b:extended):boolean;
begin
    eq:=abs(a-b)<_eps;
end;

Function less(const a,b:extended):boolean;
begin
    less:=(b-a)>_eps;
end;

Procedure intersect(const q,w:longint);
var p:TPoint;
    tmp:extended;
begin
    if (l[q]+l[w]<abs(x[q]-x[w]))and(not eq(l[q]+l[w],abs(x[q]-x[w]))) then no;
    if q=w then
    begin
        p.x:=x[q];
        p.y:=-l[q];
        if p.y>res.y then res:=p;
    end else
    begin
        if eq(x[q],x[w]) then p.x:=x[q] else
        p.x:=(sqr(l[q])-sqr(l[w])-sqr(x[q])+sqr(x[w]))/(2*x[w]-2*x[q]);
        tmp:=sqr(l[q])-sqr(p.x-x[q]);
        if less(tmp,0) then
        begin
            if l[q]<l[w] then
            begin
                p.x:=x[q];
                p.y:=-l[q];
            end else
            begin
                p.x:=x[w];
                p.y:=-l[w];
            end;
            if p.y>res.y then res:=p;
            exit;
        end;
        if eq(tmp,0) then tmp:=0;
        p.y:=-sqrt(tmp);
        if ((p.x>=x[q])and(p.x<=x[w]))or
           ((p.x<=x[q])and(p.x>=x[w])) then
        begin
            if p.y>res.y then res:=p;
        end else
        begin
            if l[q]<l[w] then
            begin
                p.x:=x[q];
                p.y:=-l[q];
            end else
            begin
                p.x:=x[w];
                p.y:=-l[w];
            end;
            if p.y>res.y then res:=p;
        end;
    end;
end;

Procedure solve;
var i,j:longint;
begin
    res.y:=-inf;
    for i:=1 to n do
    for j:=i to n do intersect(i,j);
end;

Procedure print;
begin
    if eq(res.y,-inf) then writeln(-1,' ',-1) else
    writeln(res.x:0:4,' ',res.y:0:4);
end;

begin
    init;
    solve;
    print;
    close(input);
    close(output);
end.