  {$I-,Q-,R-,S-}
const
    maxn=60;
    inf=1000000000;

var n,k,res:longint;
    c:array[1..maxn] of longint;
    a:array[1..maxn,1..maxn] of longint;
    cur,ans:array[0..maxn] of longint;

Procedure init;
var i,j,sum:longint;
begin
    assign(input,'necklace.in');
    reset(input);
    assign(output,'necklace.out');
    rewrite(output);
    read(n,k);
    for i:=1 to n do read(c[i]);
    for i:=1 to n do
    begin
        j:=i mod n + 1;
        a[i,i]:=c[i];
        sum:=a[i,i];
        while j<>i do
        begin
            inc(sum,c[j]);
            a[i,j]:=sum;
            j:=j mod n + 1;
        end;
    end;
    res:=inf;
end;

Procedure print;
var i,j:longint;
begin
    writeln(res);
    for i:=1 to k do
    begin
        j:=ans[i];
        while j<>ans[i mod k + 1] do
        begin
            write(j,' ');
            j:=j mod n + 1;
        end;
        writeln;
    end;
    close(input);
    close(output);
    halt;
end;

Procedure gennext;
var i:longint;
begin
    i:=k;
    while cur[i]=n-k+i do dec(i);
    if i=0 then print;
    inc(cur[i]);
    while i<>k do
    begin
        inc(i);
        cur[i]:=cur[i-1]+1;
    end;
end;

Function fmin(const a,b:longint):longint;
begin
    if a<b then fmin:=a else fmin:=b;
end;

Function fmax(const a,b:longint):longint;
begin
    if a>b then fmax:=a else fmax:=b;
end;

Function q(const w:longint):longint;
begin
    if w=0 then q:=n else q:=w;
end;

Procedure calc;
var min,max,i:longint;
begin
    min:=inf;
    max:=-inf;
    for i:=1 to k-1 do
    begin
        min:=fmin(min,a[cur[i],q(cur[i+1]-1)]);
        max:=fmax(max,a[cur[i],q(cur[i+1]-1)]);
    end;
    min:=fmin(min,a[cur[k],q(cur[1]-1)]);
    max:=fmax(max,a[cur[k],q(cur[1]-1)]);
    if max-min<res then
    begin
        res:=max-min;
        ans:=cur;
    end;
end;

Procedure solve;
var i:longint;
begin
    cur[0]:=100;
    for i:=1 to k do cur[i]:=i;
    while true do
    begin
        calc;
        gennext;
    end;
end;

begin
    init;
    solve;
end.