  {$I-,Q-,R-,S-}
  {$M 40000000}
uses guess;

const
    maxn=200001;

type ttype=record R,RS,L,LS,opened:longint; ll,rr:boolean; end;

var n,k,q:longint;
    a:array[1..maxn] of ttype;
    b,c:array[1..maxn] of longint;

Function getup(const a,b:longint):longint;
begin
    if b>=a then getup:=b-a else getup:=b-a+k;
end;

Function look(const l,r,s:longint):boolean;
var res1,res2:boolean;
    tmp1,tmp2,tmp3:TTYpe;
begin
    look:=false;
    if a[l].rr then
    begin
        if a[l].r=r then
        begin
            if a[l].rs<>s then exit;
            look:=true;
            exit;
        end;
        if a[l].r<r then
        begin
            look:=look(a[l].r+1,r,getup(a[l].rs,s));
            exit;
        end;
        if a[l].r>r then
        begin
            tmp1:=a[l];
            tmp2:=a[a[l].r];
            tmp3:=a[r];
            a[l].rr:=false;
            a[a[l].r].ll:=false;
            res2:=look(r+1,a[l].r,getup(s,a[l].rs));
            res1:=look(l,r,s);
            look:=res1 and res2;
            if not (res1 and res2) then
            begin
                a[l]:=tmp1;
                a[a[l].r]:=tmp2;
                a[r]:=tmp3;
            end;
            exit;
        end;
    end else
    if a[r].ll then
    begin
        if a[r].l>l then
        begin
            look:=look(l,a[r].l-1,getup(a[r].ls,s));
            exit;
        end;
        if a[r].l<l then
        begin
            tmp1:=a[r];
            tmp2:=a[a[r].l];
            tmp3:=a[l];
            a[r].ll:=false;
            a[a[r].l].rr:=false;
            res2:=look(a[r].l,l-1,getup(s,a[r].ls));
            res1:=look(l,r,s);
            look:=res1 and res2;
            if not (res1 and res2) then
            begin
                a[r]:=tmp1;
                a[a[r].l]:=tmp2;
                a[l]:=tmp3;
            end;
            exit;
        end;
    end else
    begin
        a[l].rr:=true;
        a[l].r:=r;
        a[l].rs:=s;
        a[r].ll:=true;
        a[r].l:=l;
        a[r].ls:=s;
        look:=true;
        exit;
    end;
end;

Function getsum(const q:longint):longint;
var res,i:longint;
begin
    res:=0;
    i:=q;
    while i<>0 do
    begin
        res:=res+b[i];
        i:=i-((i xor (i-1)) div 2 + 1);
    end;
    getsum:=res;
end;

Procedure add(const q,w:longint);
var i:longint;
begin
    i:=q;
    while i<=n do
    begin
        inc(b[i],w);
        i:=i+((i xor (i-1)) div 2 + 1);
    end;
end;

Procedure get;
var i,cur:longint;
begin
    for i:=1 to n do
    begin
        if a[i].ll then
        begin
            cur:=(getsum(i)-getsum(a[i].l-1)) mod k;
            add(i,(a[i].ls-cur+2*k) mod k);
            c[i]:=(a[i].ls-cur+2*k) mod k;
        end;
    end;
end;

Procedure solve;
var i,l,r,s:longint;
begin
    for i:=1 to q do
    begin
        nextquery(l,r,s);
        if not look(l,r,s) then
        begin
            get;
            error(n,c);
        end;
    end;
    get;
    consistent(n,c);
end;

begin
    initialize(n,k,q);
    solve;
end.