  {$I-,Q-,R-,S-}
const
    maxn=400;

var n,tnum:longint;
    t:array[1..maxn] of boolean;
    a:array[1..maxn,0..1] of longint;
    res:array[1..maxn,1..maxn] of record eq,bo:boolean; link,len:longint; end;
    used:array[1..maxn,1..maxn] of boolean;

Procedure init;
var i,tmp,v1,v2:longint;
begin
    assign(input,'eq.in');
    reset(input);
    assign(output,'eq.out');
    rewrite(output);
    read(n);
    read(tnum);
    for i:=1 to tnum do
    begin
        read(tmp);
        T[tmp]:=true;
    end;
    for i:=1 to n do
    begin
        read(v1,v2);
        a[i,0]:=v1;
        a[i,1]:=v2;
    end;
end;

Function dfs(const q,w:longint):longint;
var t0,t1:longint;
begin
    if used[q,w] then
    begin
        if res[q,w].bo then
        begin
            if res[q,w].eq then dfs:=-1 else dfs:=res[q,w].len;
        end else dfs:=-1;
        exit;
    end;
    used[q,w]:=true;
    if (t[q] and not t[w]) then
    begin
        dfs:=1;
        res[q,w].bo:=true;
        res[q,w].eq:=false;
        res[q,w].link:=-1;
        res[q,w].len:=0;
        res[w,q]:=res[q,w];
        exit;
    end else
    if (t[w] and not t[q]) then
    begin
        dfs:=1;
        res[q,w].bo:=true;
        res[q,w].eq:=false;
        res[q,w].link:=-1;
        res[q,w].len:=1;
        res[w,q]:=res[q,w];
        exit;
    end;
    t0:=dfs(a[q,0],a[w,0]);
    t1:=dfs(a[q,1],a[w,1]);
    if (t0=-1)and(t1=-1) then
    begin
        res[q,w].bo:=true;
        res[q,w].eq:=true;
        res[q,w].link:=0;
        res[w,q]:=res[q,w];
        dfs:=-1;
        exit;
    end;
    if (t0>=1)and(t1=-1) then
    begin
        res[q,w].bo:=true;
        res[q,w].eq:=false;
        res[q,w].link:=0;
        res[q,w].len:=t0+1;
        res[w,q]:=res[q,w];
        dfs:=T0+1;
        exit;
    end;
    if (t0=-1)and(t1>=1) then
    begin
        res[q,w].bo:=true;
        res[q,w].eq:=false;
        res[q,w].link:=1;
        res[q,w].len:=t1+1;
        res[w,q]:=res[q,w];
        dfs:=t1+1;
        exit;
    end;
    if (t0>=1)and(t1>=1) then
    begin
        res[q,w].bo:=true;
        res[q,w].eq:=false;
        if t0<t1 then
        begin
            res[q,w].link:=0;
            res[q,w].len:=t0+1;
        end else
        begin
            res[q,w].link:=1;
            res[q,w].len:=t1+1;
        end;
        dfs:=res[q,w].len;
        res[w,q]:=res[q,w];
        exit;
    end;
end;

Procedure solve;
var i,j:longint;
begin
    for i:=1 to n do
    begin
        res[i,i].bo:=true;
        res[i,i].eq:=true;
        res[i,i].link:=0;
        for j:=i+1 to n do if not used[i,j] then dfs(i,j);
    end;
end;

Procedure recprint(const q,w:longint);
var u,v,tu,tv:longint;
begin
    u:=q;
    v:=w;
    while res[u,v].link<>-1 do
    begin
        write(res[u,v].link);
        tu:=a[u,res[u,v].link];
        tv:=a[v,res[u,v].link];
        u:=tu;
        v:=tv;
    end;
    writeln;
end;

Procedure print;
var i,m,u,v:longint;
begin
    read(m);
    for i:=1 to m do
    begin
        read(u,v);
        if res[u,v].eq then writeln('equivalent') else recprint(u,v);
    end;
end;

begin
    init;
    solve;
    print;
    close(input);
    close(output);
end.