  {$I-,Q-,R-,S-}
const
    sym=['0'..'9','+','-'];
    maxn=100;
    last=90;
    max=500;

type
    TExpr=array[0..maxn] of record T:(_plus,_minus,_num); val:longint; next:longint; end;

var a:TExpr;
    can:array[-max..max] of boolean;
    first:longint;

Procedure readexpr(var expr:TExpr);
var ch:char;
    cur:longint;
begin
    cur:=0;
    read(ch);
    while not (ch in sym) do read(ch);
    while ch in sym do
    begin
        inc(cur);
        case ch of
          '+':expr[cur].t:=_plus;
          '-':expr[cur].t:=_minus;
          else
          begin
            expr[cur].t:=_num;
            expr[cur].val:=ord(ch)-48;
          end;
        end;
        expr[cur-1].next:=cur;
        expr[cur].next:=last;
        read(ch);
    end;
end;

Procedure init;
begin
    assign(input,'expr.in');
    reset(input);
    assign(output,'expr.out');
    rewrite(output);
    readexpr(a);
end;

Procedure rec(const a:TExpr; const first:longint);
var t1,t2,t3:longint;
    temp:TExpr;
begin
    t1:=first;
    t2:=a[t1].next;
    t3:=a[t2].next;
    if t1=last then exit;
    if t2=last then
    begin
        if a[t1].t=_num then can[a[t1].val]:=true;
        exit;
    end;
    if t3=last then exit;
    while t3<>last do
    begin
        case a[t1].t of
          _plus:
            begin
                if (a[t2].t=_num)and(a[t3].t=_num) then
                begin
                    temp:=a;
                    temp[t1].next:=temp[t3].next;
                    temp[t1].t:=_num;
                    temp[t1].val:=temp[t2].val+temp[t3].val;
                    rec(temp,first);
                end;
            end;
          _minus:
            begin
                if (a[t2].t=_num)and(a[t3].t=_num) then
                begin
                    temp:=a;
                    temp[t1].next:=temp[t3].next;
                    temp[t1].t:=_num;
                    temp[t1].val:=temp[t2].val-temp[t3].val;
                    rec(temp,first);
                end;
            end;
          _num:
            begin
                case a[t2].t of
                  _num:
                    begin
                        if a[t3].t=_plus then
                        begin
                            temp:=a;
                            temp[t1].next:=temp[t3].next;
                            temp[t1].t:=_num;
                            temp[t1].val:=temp[t1].val+temp[t2].val;
                            rec(temp,first);
                        end else
                        if a[t3].t=_minus then
                        begin
                            temp:=a;
                            temp[t1].next:=temp[t3].next;
                            temp[t1].t:=_num;
                            temp[t1].val:=temp[t1].val-temp[t2].val;
                            rec(temp,first);
                        end;
                    end;
                  _minus:
                    begin
                        if a[t3].t=_num then
                        begin
                            temp:=a;
                            temp[t1].next:=temp[t3].next;
                            temp[t1].t:=_num;
                            temp[t1].val:=temp[t1].val-temp[t3].val;
                            rec(temp,first);
                        end;
                    end;
                  _plus:
                    begin
                        if a[t3].t=_num then
                        begin
                            temp:=a;
                            temp[t1].next:=temp[t3].next;
                            temp[t1].t:=_num;
                            temp[t1].val:=temp[t1].val+temp[t3].val;
                            rec(temp,first);
                        end;
                    end;
                end;
            end;
        end;
        t1:=t2;
        t2:=t3;
        t3:=a[t3].next;
    end;
end;

Procedure solve;
begin
    first:=1;
    rec(a,first);
end;

Procedure print;
var i,ans:longint;
begin
    ans:=0;
    for i:=-max to max do if can[i] then inc(ans);
    writeln(ans);
end;

begin
    init;
    solve;
    print;
    close(input);
    close(output);
end.