  {$I-,Q-,R-,S-}
const
    sym=['A'..'Z'];
    maxn=160;

type
    List=^TList;
    TList=record next:list; ch:char; end;
    TTree=record LS,PS:longint; ch:char; ok:boolean; l:list; end;

var s:string;
    n,cnt:longint;
    A:array[1..maxn] of TTree;
    cha:array['A'..'Z'] of longint;
    b:array[1..maxn,1..maxn] of longint;
    res:array[1..maxn,1..maxn] of array[1..maxn] of boolean;

Procedure readword(var s:string);
var ch:char;
begin
    s:='';
    read(ch);
    while not (ch in sym) do read(ch);
    while ch in sym do
    begin
        s:=s+ch;
        read(ch);
    end;
end;

Function get(const q:longint; const ch:char):longint;
var cur:longint;
begin
    cur:=a[q].ls;
    get:=0;
    while cur<>0 do
    begin
        get:=cur;
        if a[cur].ch=ch then exit;
        cur:=a[cur].ps;
    end;
end;

Procedure addppl(const q:longint; const ch:char);
var p:list;
begin
    new(p);
    p^.next:=a[q].l;
    p^.ch:=ch;
    a[q].l:=p;
end;

Procedure add(const s1,s2:string);
var i,cur,t:longint;
begin
    cur:=1;
    for i:=1 to length(s1) do
    begin
        t:=get(cur,s1[i]);
        if t=0 then
        begin
            inc(cnt);
            a[cur].ls:=cnt;
            a[cnt].ch:=s1[i];
            a[cnt].ls:=0;
            a[cnt].ps:=0;
            a[cnt].l:=nil;
            a[cnt].ok:=false;
            cur:=cnt;
        end else
        if a[t].ch=s1[i] then cur:=t else
        begin
            inc(cnt);
            a[t].ps:=cnt;
            a[cnt].ch:=s1[i];
            a[cnt].ls:=0;
            a[cnt].ps:=0;
            a[cnt].l:=nil;
            a[cnt].ok:=false;
            cur:=cnt;
        end;
    end;
    a[cur].ok:=true;
    addppl(cur,s2[1]);
end;

Procedure init;
var i:longint;
    ss,sss:string;
    ch:char;
begin
    assign(input,'game.in');
    reset(input);
    assign(output,'game.out');
    rewrite(output);
    readword(s);
    read(n);
    fillchar(a,sizeof(a),0);
    cnt:=2;
    a[1].LS:=2;
    a[2].ch:='A';
    for ch:='B' to 'Z' do
    begin
        inc(cnt);
        a[cnt-1].PS:=cnt;
        a[cnt].ch:=ch;
    end;
    for i:=1 to n do
    begin
        readword(ss);
        readword(sss);
        add(ss,sss);
    end;
end;

Procedure GetCharLink;
var cur:longint;
begin
    cur:=a[1].ls;
    while cur<>0 do
    begin
        cha[a[cur].ch]:=cur;
        cur:=a[cur].ps;
    end;
end;

Procedure conc(const s1,s2:string; const q1,q2:longint);
var cur,i:longint;
begin
    cur:=1;
    for i:=1 to length(s1) do
    begin
        cur:=get(cur,s1[i]);
        if (cur=0)or(a[cur].ch<>s1[i]) then exit;
    end;
    for i:=1 to length(s2) do
    begin
        cur:=get(cur,s2[i]);
        if (cur=0)or(a[cur].ch<>s2[i]) then exit;
    end;
    B[q1,q2]:=cur;
end;

Procedure rec2(const s:string; const q:longint; const s2:string; const q2:longint);
var cur:longint;
begin
    cur:=a[q].ls;
    while cur<>0 do
    begin
        rec2(s+a[cur].ch,cur,s2,q2);
        cur:=a[cur].ps;
    end;
    if s<>'' then conc(s,s2,q,q2);
end;

Procedure rec1(const s:string; const q:longint);
var cur:longint;
begin
    cur:=a[q].ls;
    while cur<>0 do
    begin
        rec1(s+a[cur].ch,cur);
        cur:=a[cur].ps;
    end;
    if s<>'' then rec2('',1,s,q);
end;

Procedure GetConcatStrs;
begin
    rec1('',1);
end;

Procedure addd(const q,w,num:longint);
var buf:list;
begin
    res[q,w][num]:=true;
    buf:=a[num].l;
    while buf<>nil do
    begin
        res[q,w][cha[buf^.ch]]:=true;
        buf:=buf^.next;
    end;
end;

Procedure update(const l,r,l1,r1,l2,r2:longint);
var i,j:longint;
begin
    for i:=1 to cnt do
    begin
        if not res[l1,r1,i] then continue;
        for j:=1 to cnt do
        begin
            if not res[l2,r2,j] then continue;
            if b[i,j]=0 then continue;
            addd(l,r,b[i,j]);
        end;
    end;
end;

procedure solve;
var i,j,len:longint;
begin
    GetCharLink;
    GetConcatStrs;
    for i:=1 to length(s) do res[i,i][cha[s[i]]]:=true;
    for len:=2 to length(s) do
    begin
        for i:=1 to length(s)-len+1 do
        begin
            for j:=i+1 to i+len-1 do
            begin
                update(i,i+len-1,i,j-1,j,i+len-1);
            end;
        end;
    end;
end;

procedure print;
var ch:char;
begin
    for ch:='A' to 'Z' do if cha[ch]<>0 then if res[1,length(s)][cha[ch]] then write(ch);
end;

begin
    init;
    solve;
    print;
    close(input);
    close(output);
end.