  {$I-,Q-,R-,S-}
const
    maxn=1100;

var n,ans:longint;
    s:array[0..maxn] of longint;
    res:array[0..maxn,0..maxn] of record di,dj:longint; end;
    can,used:array[0..maxn,0..maxn] of boolean;

Procedure init;
var ch:char;
begin
    assign(input,'commas.in');
    reset(input);
    assign(output,'commas.out');
    rewrite(output);
    read(ch);
    while not (ch in ['0'..'9']) do read(ch);
    while ch in ['0'..'9'] do
    begin
        inc(n);
        s[n]:=ord(ch)-48;
        read(ch);
    end;
    s[0]:=-1;
end;

Function more(const l1,r1,l2,r2:longint):boolean;
var i1,i2:longint;
begin
    i1:=l1;
    i2:=l2;
    while (s[i1]=0)and(i1<r1) do inc(i1);
    while (s[i2]=0)and(i2<r2) do inc(i2);
    if abs(r1-i1)>abs(i2-r2) then more:=true else
    if abs(r1-i1)<abs(i2-r2) then more:=false else
    begin
        while (s[i1]=s[i2])and(i1<=r1) do
        begin
            inc(i1);
            inc(i2);
        end;
        if i1>r1 then
        begin
            more:=false;
            exit;
        end;
        if s[i1]>s[i2] then more:=true else more:=false;
    end;
end;

Function rec(const l,r:longint):boolean;
var i:longint;
    ll,rr,med:longint;
begin
    if used[l,r] then
    begin
        rec:=can[l,r];
        exit;
    end;
    used[l,r]:=true;
    ll:=1;
    rr:=l-1;
    while ll<rr do
    begin
        med:=(ll+rr) div 2;
        if more(l,r,med,l-1) then rr:=med else ll:=med+1;
    end;
    i:=rr;
    if not more(l,r,i,l-1) then inc(i);
    while i<=l-1 do
    begin
        if rec(i,l-1) then
        begin
            rec:=true;
            can[l,r]:=true;
            res[l,r].di:=i;
            res[l,r].dj:=l-1;
            exit;
        end;
        inc(I);
    end;
    rec:=false;
end;

Procedure solve;
var i:longint;
begin
    for i:=1 to n do
    begin
        can[1,i]:=true;
        used[1,i]:=true;
        res[1,i].di:=0;
        res[1,i].dj:=0;
    end;
    for i:=1 to n do if rec(n-i+1,n) then
    begin
        ans:=n-i+1;
        exit;
    end;
end;

Procedure recprint(const i,j:longint; const b:boolean);
var h:longint;
begin
    if (i=0)and(j=0) then exit;
    recprint(res[i,j].di,res[i,j].dj,false);
    for h:=i to j do write(s[h]);
    if not b then write(',');
end;

begin
    init;
    solve;
    recprint(ans,n,true);
    close(input);
    close(output);
end.