  {$I-,Q-,R-,S-}
const
    maxn=260;

type
    list=^tlist;
    tlist=record next:list; val,num:longint; end;

var a:array[1..maxn] of list;
    used,vis:array[1..maxn] of boolean;
    res:array[1..maxn,1..maxn] of record can:boolean; num,saved,link,sav:longint; end;
    n,k:longint;

Procedure add(const u,v,num:longint);
var p:list;
begin
    new(p);
    p^.next:=a[u];
    p^.val:=v;
    p^.num:=num;
    a[u]:=p;
end;

Procedure init;
var i,u,v:longint;
begin
    assign(input,'tree.in');
    reset(input);
    assign(output,'tree.out');
    rewrite(output);
    read(n,k);
    for i:=1 to n-1 do
    begin
        read(u,v);
        add(u,v,i);
        add(v,u,i);
    end;
end;

Procedure dfs(const q:longint);
var num,i,j:longint;
    buf:list;
begin
    used[q]:=true;
    fillchar(res[q],sizeof(res[q]),0);
    buf:=a[q];
    num:=0;
    while buf<>nil do
    begin
        if not used[buf^.val] then
        begin
            inc(num);
        end;
        buf:=buf^.next;
    end;
    buf:=a[q];
    res[q,1].can:=true;
    res[q,1].num:=num;
    while buf<>nil do
    begin
        if not used[buf^.val] then
        begin
            dfs(buf^.val);
            for i:=n downto 1 do
            begin
                if not res[q,i].can then continue;
                for j:=1 to n do
                begin
                    if not res[buf^.val,j].can then continue;
                    if not res[q,i+j].can then
                    begin
                        res[q,i+j].can:=true;
                        res[q,i+j].num:=res[q,i].num+res[buf^.val,j].num-1;
                        res[q,i+j].saved:=buf^.val;
                        res[q,i+j].sav:=buf^.num;
                        res[q,i+j].link:=i;
                    end else
                    if res[q,i+j].num>res[q,i].num+res[buf^.val,j].num-1 then
                    begin
                        res[q,i+j].num:=res[q,i].num+res[buf^.val,j].num-1;
                        res[q,i+j].saved:=buf^.val;
                        res[q,i+j].sav:=buf^.num;
                        res[q,i+j].link:=i;
                    end;
                end;
            end;
        end;
        buf:=buf^.next;
    end;
end;

Procedure solve;
begin
    dfs(1);
end;

Procedure recprint(const q,w:longint);
var cur:longint;
    saved:array[0..maxn] of boolean;
    buf:list;
begin
    if q=0 then exit;
    vis[q]:=true;
    cur:=w;
    fillchar(saved,sizeof(saved),0);
    while cur<>0 do
    begin
        saved[res[q,cur].sav]:=true;
        recprint(res[q,cur].saved,cur-res[q,cur].link);
        cur:=res[q,cur].link;
    end;
    buf:=a[q];
    while buf<>nil do
    begin
        if (not saved[buf^.num])and(not vis[buf^.val]) then write(buf^.num,' ');
        buf:=buf^.next;
    end;
end;

Procedure print;
var i,li,min,cur:longint;
begin
    li:=0;
    min:=1000000000;
    for i:=1 to n do
    begin
        if res[i,k].can then
        begin
            if i=1 then cur:=res[i,k].num else cur:=res[i,k].num+1;
            if cur<min then
            begin
                min:=cur;
                li:=i;
            end;
        end;
    end;
    writeln(min);
    recprint(li,k);
end;

begin
    init;
    solve;
    print;
    close(input);
    close(output);
end.