{$I-,Q-,R-,S-}
{$M 30000000,5000000}
program ZadA;

uses
  Math,SysUtils;
type
  int=longint;
  real=double;
  bool=boolean;
  ur=record L,R:int; end;

const
  infile='key.in';
  outfile='key.out';
  maxKey=120;
  maxN=10100;
  maxM=1020;
  tl=1.9/24/60/60;
var
 V,H:int;
 N,M:int;
 key:array[1..maxKey]of ur;
 Down:array[1..maxKey] of int;
 zam,was:array[-maxKey..maxN+maxKey+1,-maxKey..maxM+1+maxkey]of bool;
 maxim:int;
 begTime:real;

procedure CloseFiles; forward;

procedure dfs(gl,ot:int);
 var
   i:int;
   fl:bool;
 begin
  if gl>maxim then maxim:=gl;
  if time>begtime+tl then
    begin
      if maxim>N then Write(-1)
      else Write(maxim+V-1);
      CloseFiles;
      Halt(0);
    end;
  was[gl,ot]:=true;
  fl:=true;
  if not was[gl+1,ot] then
    begin
      for i := 1 to H do
        if zam[gl+down[i],ot+i-1] then
          begin
            fl:=false;
            Break;
          end;
      if fl then dfs(gl+1,ot);
   end;
  fl:=true;
  if not was[gl,ot-1] then
    begin
      for i := 1 to V do
        if zam[gl+i-1,ot+key[i].L-2] then
          begin
            fl:=false;
            Break;
          end;
      if fl then dfs(gl,ot-1);
   end;
  fl:=true;
  if not was[gl,ot+1] then
    begin
      for i := 1 to V do
        if zam[gl+i-1,ot+key[i].R] then
          begin
            fl:=false;
            Break;
          end;
      if fl then dfs(gl,ot+1);
   end;
 end;

procedure Run;
var
 i,j:int;
 ch:char;
begin
 Readln(V,H);
 for i := 1 to V do
   begin
     key[i].L:=H;
     key[i].R:=1;
     for j := 1 to H do
       begin
         Read(ch);
         if ch='#' then
           begin
             Down[j]:=i;
             key[i].L:=min(key[i].L,j);
             key[i].R:=max(key[i].R,j);
           end;
       end;
     Readln;
   end;
 ReadLn(N,M);
 fillchar(zam,sizeof(zam),0);
 for i := -V to 0 do
   begin
     zam[i,-H]:=true;
     zam[i,m+1+H]:=true;
   end;
 for i := -H to 0 do
   zam[1,i]:=true;
 for i := M+1 to M+1+H do
   zam[1,i]:=true;
 for i := 1 to N do
   begin
     zam[i,0]:=true;
     zam[i,m+1]:=true;
   end;
 for i := N+1 to N+V+1 do
   begin
     zam[i,-H]:=true;
     zam[i,m+1+H]:=true;
   end;
 for i := -H to M+1+H do
   zam[N+V+1,i]:=true;
 for i := 1 to N do
   begin
     for j := 1 to M do
       begin
         Read(ch);
         zam[i,j]:=ch='#';
       end;
     Readln;
   end;

 maxim:=-V;
 fillchar(was,sizeof(was),0);
{
 DEBUG

 for i := -V-5 to N+V+1+5 do
   begin
    for j := -V-5 to M+1+V+5 do
      if zam[i,j] then write(1) else Write(0);
    Writeln;
   end;

 DEBUG
}

 dfs(-V+1,1);

 if maxim>N then Write(-1)
 else Write(maxim+V-1);
end;

procedure OpenFiles;
 begin
   Assign(input,infile);
   Reset(input);
   Assign(output,outfile);
   Rewrite(output);
 end;

procedure CloseFiles;
 begin
   Close(input);
   Close(OUTPUT);
 end;

Begin
begTime:=time;
OpenFiles;
Run;
CloseFiles;
End.


