{$I+,Q+,R+,S+}
program ZadC;

uses
  Math,SysUtils;

type
  int=longint;
  real=extended;
  bool=boolean;

const
  infile='network.in';
  outfile='network.out';
  maxN=105;
  maxM=105;
  maxK=105;
  tl=1.8/24/60/60;
var
  N,L,k,m:int;
  d,num:array[0..maxN] of int;
  a:array[0..maxN,0..maxN] of int;
  ans:int;
  ar,ansar:array[0..maxM,0..maxK] of int;
  b,ansb:array[0..maxM] of int;
  begtime:real;

procedure CloseFiles; forward;

procedure Stop;
 var
   i,j:int;
 begin
   Writeln(ansar[0,0]);
   for i := 1 to ansar[0,0] do
     begin
       write(d[ansb[i]],' ');
       for j:= 1 to ansar[i,0] do
         Write(ansar[i,j],' ');
       writeln;
     end;
   CloseFiles;
   halt(0);
 end;


procedure check;
 var
   i,cur:int;
   otv:int;
 begin
   cur:=1;
   fillchar(ar,sizeof(ar),0);
   ar[0,0]:=b[0];
   otv:=0;
   for i := 0 to N do
     if ar[cur,0]<k then
       begin
         inc(ar[cur,0]);
         ar[cur,ar[cur,0]]:=i;
         inc(otv,a[i,b[cur]]);
       end
     else
       begin
         inc(cur);
         inc(ar[cur,0]);
         ar[cur,ar[cur,0]]:=cur-1;
       end;


   if otv<ans then
     begin
       ans:=otv;
       ansar:=ar;
       ansb:=b;
     end;
   if time>begtime+tl then
     Stop;
 end;

procedure Gen(tek,lst:int);
 var
  i:int;
 begin
   if tek>M then
     begin
       b[0]:=lst;
       if lst<>0 then
         check;
       exit;
     end;
   for i := 0 to lst do
     begin
       b[tek]:=i;
       Gen(tek+1,lst)
     end;
   if lst<> n then
     begin
       b[tek]:=lst+1;
       Gen(tek+1,lst+1)
     end;

 end;

procedure Run;
var
 i,j,s:int;
 komp,Lhub:int;
 Lt:int;
begin
  Read(N,L,K,M);
  if (K-1)*m+1<N then
    begin
      Write(-1);
      CloseFiles;
      halt(0);
    end;
  d[0]:=0;
  num[0]:=0;
  for i := 1 to N do
    begin
      read(d[i]);
      num[i]:=i;
    end;

  for i:= 0 to N do
    for j := 0 to N do
      a[i,j]:=min((L+d[i]-d[j])mod L,(L+d[j]-d[i])mod L);
  ans:=maxlongint;
  Gen(1,0);

  Stop;

end;

procedure OpenFiles;
 begin
   Assign(input,infile);
   Reset(input);
   Assign(output,outfile);
   Rewrite(output);
 end;

procedure CloseFiles;
 begin
   Close(input);
   Close(OUTPUT);
 end;

Begin
begtime:=time;
OpenFiles;
Run;
CloseFiles;
End.
