{$I-,Q-,R-,S-}
program ZadA_my_sol;

type
  int=longint;
  real=extended;
  bool=boolean;
  rbr=record kon,next:int; end;

const
  infile='filya.in';
  outfile='filya.out';
  N=41;
  M=45;
  dx:array[0..3] of int=(0,1,0,-1);
  dy:array[0..3] of int=(1,0,-1,0);
  maxVer=N*M;
  imp=1000000000;
var
  v,pole,polenew:array[0..N+1,0..M+1] of int;
  cc:int;
  dost:array[1..6]of bool;
  beg:array[1..maxVer] of int;
  uk:int;
  gr:array[1..maxVer*8] of rbr;
  ms:array[0..maxVer,0..maxVer] of bool;
  dmena,dovr,ves:array[1..maxVer] of int;

  Och:array[1..2*maxVer] of int;
  uk1,uk2:int;

procedure InitOch(a:int);
 begin
   Och[1]:=a;
   uk1:=2;
   uk2:=1;
 end;

function GetNext:int;
 begin
   GetNext:=Och[uk2];
   inc(uk2);
 end;

function Empty:bool;
  begin
    empty:=uk1=uk2;
  end;

procedure AddOch(a:int);
 begin
   och[uk1]:=a;
   inc(uk1);
 end;

procedure mark(a,b,col:int);
var
 i:int;
begin
 v[a,b]:=1;
 for i :=0 to 3 do
   if (polenew[a,b]=polenew[a+dx[i],b+dy[i]]) and
     (v[a+dx[i],b+dy[i]]=0) then
     mark(a+dx[i],b+dy[i],col);
 polenew[a,b]:=col;
end;

procedure dfs(a,b:int);
var
 i:int;
begin
 v[a,b]:=cc;
 for i :=0 to 3 do
   if (polenew[a,b]=polenew[a+dx[i],b+dy[i]]) and
     (v[a+dx[i],b+dy[i]]=0) then
     dfs(a+dx[i],b+dy[i]);
end;

procedure Add(i,j:int);
 begin
   inc(uk);
   gr[uk].kon:=j;
   gr[uk].next:=beg[i];
   beg[i]:=uk;
 end;

procedure Run;
var
 i,j,hod,k:int;
 ch:char;
 vrag,ia:int;
 vv,cur:int;
 har,har2,besthar,besthar2,besthod:int;
begin
  fillchar(pole,sizeof(pole),0);
  for i := 1 to N do
    begin
      for j := 1 to M do
        begin
          Read(ch);
          pole[i,j]:=ord(ch)-ord('0');
        end;
      readln;
    end;

  fillchar(dost,sizeof(dost),true);
  dost[pole[1,1]]:=false;
  dost[pole[N,M]]:=false;

  besthar:=imp;
  besthar2:=imp;
  for hod:= 1 to 6 do
    if dost[hod] then
      begin
        polenew:=pole;
        fillchar(v,sizeof(v),0);
        Mark(1,1,hod);


        fillchar(v,sizeof(v),0);
        cc:=0;
        for i := 1 to N do
          for j := 1 to M do
            if v[i,j]=0 then
              begin
                inc(cc);
                dfs(i,j);
              end;

        fillchar(ms,sizeof(ms),0);
        for i := 1 to N do
          for j := 1 to M do
            for k := 0 to 3 do
              begin
                ms[v[i,j],v[i+dx[k],j+dy[k]]]:=true;
                ms[v[i+dx[k],j+dy[k]],v[i,j]]:=true;
              end;

        fillchar(beg,sizeof(beg),0);
        uk:=0;
        for i :=1 to cc do
          for j :=i+1 to cc do
            if ms[i,j] then
              begin
                Add(i,j);
                Add(j,i);
              end;
        ia:=v[1,1];
        vrag:=v[n,m];

        fillchar(dmena,sizeof(dmena),255);
        InitOch(ia);
        dmena[ia]:=0;
        while not empty do
          begin
            vv:=GetNext;
            if vv<> vrag then
              begin
                cur:=beg[vv];
                while cur<>0 do
                  begin
                    if dmena[gr[cur].kon]=-1 then
                      begin
                        dmena[gr[cur].kon]:=dmena[vv]+1;
                        AddOch(gr[cur].kon);
                      end;
                    cur:=gr[cur].next;
                  end;
              end;
          end;

        fillchar(dovr,sizeof(dovr),255);
        InitOch(vrag);
        dovr[vrag]:=0;
        while not empty do
          begin
            vv:=GetNext;
            if vv<> ia then
              begin
                 cur:=beg[vv];
                 while cur<>0 do
                   begin
                     if dovr[gr[cur].kon]=-1 then
                       begin
                         dovr[gr[cur].kon]:=dovr[vv]+1;
                         AddOch(gr[cur].kon);
                       end;
                     cur:=gr[cur].next;
                   end;
              end;
          end;

        fillchar(ves,sizeof(ves),0);
        for i := 1 to N do
          for j:= 1 to M do
            inc(ves[v[i,j]]);

        har:=0;
        har2:=0;
        for i:=  1 to cc do
          if dovr[i]<>-1 then
            inc(har,ves[i]*dmena[i])
          else
            inc(har2,ves[i]*dmena[i]);

        if (har<besthar) or (har=besthar) and (har2<besthar2) then
          begin
            besthar2:=har2;
            besthar:=har;
            besthod:=hod;
          end;
      end;
  Write(besthod);
end;

procedure OpenFiles;
 begin
   Assign(input,infile);
   Reset(input);
   Assign(output,outfile);
   Rewrite(output);
 end;

procedure CloseFiles;
 begin
   Close(input);
   Close(OUTPUT);
 end;

Begin
OpenFiles;
Run;
CloseFiles;
End.