{$I-,Q-,R-,S-}
program ZadA;

type
  int=longint;
  real=extended;
  bool=boolean;
  otr=record
        num:int;
        y,nakl,x0:real;
      end;

const
  infile='antiufo.in';
  outfile='antiufo.out';
  maxN=52000;
  eps=1e-8;
  inf=1e8;
var
  N,K:int;
  x,y:array[1..maxN+2] of real;
  S:Real;
  a:array[0..maxN*2] of otr;
  uk:int;
  shir:array[0..4*maxN] of real;
  yshir:array[0..4*maxN] of real;
  tek:int;


function More(const a,b:otr):bool;
begin
  if Abs(a.y-b.y)<eps then
     More:=a.num<b.num
  else
     More:=a.y>b.y;
end;

  procedure QuickSort(iLo, iHi: Int);
  var
    Lo, Hi: Int;
    Mid,t:otr;
  begin
    Lo := iLo;
    Hi := iHi;
    Mid := A[(Lo + Hi) div 2];
    repeat
      while More(Mid,A[Lo]) do Inc(Lo);
      while More(A[Hi], Mid) do Dec(Hi);
      if Lo <= Hi then
      begin
        T := A[Lo];
        A[Lo] := A[Hi];
        A[Hi] := T;
        Inc(Lo);
        Dec(Hi);
      end;
    until Lo > Hi;
    if Hi > iLo then QuickSort(iLo, Hi);
    if Lo < iHi then QuickSort(Lo, iHi);
  end;


procedure Add(const x1,y1,x2,y2:real;const nn:int);
begin
inc(uk);
if y2-y1>eps then
  begin
    a[uk].y:=y1;
    a[uk].num:=nn;
    a[uk].nakl:=-(x2-x1)/(y2-y1);
    a[uk].x0:=-x1;
    inc(uk);
    a[uk].y:=y2;
    a[uk].num:=-nn;
    a[uk].nakl:=-(x2-x1)/(y2-y1);
    a[uk].x0:=-x2;
  end
else
if y1-y2>eps then
  begin
    a[uk].y:=y2;
    a[uk].num:=nn;
    a[uk].nakl:=(x1-x2)/(y1-y2);
    a[uk].x0:=x2;
    inc(uk);
    a[uk].y:=y1;
    a[uk].num:=-nn;
    a[uk].nakl:=(x1-x2)/(y1-y2);
    a[uk].x0:=x1;
  end
else
  begin
    a[uk].y:=y1;
    a[uk].num:=nn;
    a[uk].nakl:=0;
    a[uk].x0:=0;
    inc(uk);
    a[uk].y:=y2;
    a[uk].num:=-nn;
    a[uk].nakl:=0;
    a[uk].x0:=0;
  end

end;

function Vect(const x1,y1,x2,y2:real):real;
begin
Vect:=x1*y2-y1*x2;
end;

function Otrez(S,a,b,L:real):real;
 var
  SObsh,L0,ab2:real;
  k1,k2,k3:real;
 begin
  Sobsh:=(a+b)/2*L;
  if Abs(a-b)<eps then
    L0:=L*s/sobsh
  else
    begin
      ab2:=(a-b)/2;
      k1:=ab2;
      k2:=-(sobsh+ab2*L);
      k3:=L*S;
      L0:=(-k2-sqrt(sqr(k2)-4*k1*k3))/2/k1;
    end;
  Otrez:=L0;
 end;

procedure Run;
var
 i,cur:int;
 S0,SL,xx:real;
 Naklon:real;
begin
 Read(N,K);
 for  i := 1 to N do
   Read(x[i],y[i]);
 x[n+1]:=x[1];
 y[n+1]:=y[1];
 s:=0;
 for  i :=  1 to N Do
   s := S+ Vect(x[i],y[i],x[i+1],y[i+1]);
 s:=Abs(S)/2/(K+1);

 uk:=0;
 for i := 1 to N do
   Add(x[i],y[i],x[i+1],y[i+1],i);

 QuickSort(1,2*N);
{debug
 for i := 1 to 2*n do
   WriteLn(a[i].y:0:4,' ',a[i].nakl:0:4,' ',a[i].x0:0:4,' ',a[i].num);
 Writeln;
 Writeln;
debug}


 tek:=0;
 a[0].y:=inf;
 shir[0]:=0;
 yshir[0]:=0;
 Naklon:=0;
 for i := 1 to 2*n do
   begin
     inc(tek);
     yshir[tek]:=a[i].y;
     shir[tek]:=shir[tek-1];
     shir[tek]:=shir[tek]+naklon*(yshir[tek]-yshir[tek-1]);
     inc(tek);
     yshir[tek]:=a[i].y;
     shir[tek]:=shir[tek-1];
     if a[i].num>0 then
       begin
         naklon:=naklon+a[i].nakl;
         shir[tek]:=shir[tek]+a[i].x0;
       end
     else
       begin
         naklon:=naklon-a[i].nakl;
         shir[tek]:=shir[tek]-a[i].x0;
       end;
     shir[tek]:=shir[tek]+naklon*(yshir[tek]-yshir[tek-1]);
   end;
{debug
 for i := 1 to tek do
   WriteLn(yshir[i]:0:4,' ',shir[i]:0:4);
debug}

  cur:=0;
  S0:=0;
  for i := 1 to K do
    begin
      while s0<=s do
        begin
          inc(cur);
          SL:=(yshir[cur+1]-yshir[cur])*(shir[cur]+shir[cur+1])/2;
          s0:=s0+SL;
        end;
      xx:=Otrez(Sl-(S0-S),shir[cur],shir[cur+1],yshir[cur+1]-yshir[cur]);
      Writeln((xx +yshir[cur]):0:5);
      s0:=s0-S;
    end;


end;

procedure OpenFiles;
 begin
   Assign(input,infile);
   Reset(input);
   Assign(output,outfile);
   Rewrite(output);
 end;

procedure CloseFiles;
 begin
   Close(input);
   Close(output);
 end;

Begin
OpenFiles;
Run;
CloseFiles;
End.


