{$I-,Q-,R-,S-}
program ZadA;
uses
  SysUtils;
type
  int=longint;
  real=extended;
  bool=boolean;
const
  infile='popular.in';
  outfile='popular.out';
  maxN=5000;
  eps=1e-8;
  tl=1.7;
var
  x,l:array[1..maxN] of Real;
  begtime:real;
  ymin,xisk:real;
  found:bool;

function Eq(const a,b:real):bool;
begin
Eq:=Abs(a-b)<eps;
end;

procedure CloseFiles; forward;

procedure Stop;
begin
  if found then
    Writeln(xisk:0:4,' ',ymin:0:4)
  else
    Writeln('-1 -1');
 CloseFiles;
 Halt(0);
end;



procedure Run;
var
 i,j:int;
 N:int;
 x1,x2,l1,l2,Lmin:real;
 xx,yy:real;

procedure Try;
var
 i:int;
 t:real;
 fl:boolean;
begin
  t:=sqr(yy);
  fl:=true;
  for i :=1 to N do
    if sqr(x[i]-xx)+t-sqr(l[i])>eps then
      begin
        fl:=false;
        break;
      end;
  if fl then
    begin
      found:=true;
      if yy<ymin then
        begin
          ymin:=yy;
          xisk:=xx;
        end;
    end;
end;

begin
 Read(n);
 for i := 1 to n do
   Read(x[i],L[i]);

 Lmin:=l[1];
 for i := 1 to N do
   if l[i]<lmin then
     lmin:=L[i];
 Lmin:=-Lmin;
 ymin:=0;
 xisk:=0;
 found:=false;

 for i := 1 to N do
   begin
   if time*24*60*60>begtime+tl then
     Stop;
   for j := i to n do
     begin
       x1:=x[i];
       x2:=x[j];
       l1:=l[i];
       l2:=L[j];
       if Eq(x1,x2) then
         begin
           if Eq (l1,l2) then
             begin
               xx:=(x1+x2)/2;
               yy:=-(l1+l2)/2;
               if (yy<ymin) and (yy-Lmin>=-eps) then
                 Try;
             end;
         end
       else
         begin
           xx:= ((sqr(L1)-sqr(L2))/(x2-x1)+x1+x2)/2;
           if Abs(L1)>Abs(xx-x1) then
             begin
               yy:=-sqrt(sqr(L1)-sqr(xx-x1));
               if (yy<ymin) and (yy-Lmin>=-eps) then
                 Try;
             end;
         end;
     end;
   end;
  Stop;

end;

procedure OpenFiles;
 begin
   Assign(input,infile);
   Reset(input);
   Assign(output,outfile);
   Rewrite(output);
 end;

procedure CloseFiles;
 begin
   Close(input);
   Close(output);
 end;

Begin
BegTime:=time*24*60*60;
OpenFiles;
Run;
CloseFiles;
End.


