{$M 30000000,2000000}
{$I-,Q-,R-,S-}
program ZadB;

type
  int=longint;
  real=extended;
  bool=boolean;
  TPoint=record x,y:Real; end;

const
  infile='fire.in';
  outfile='fire.out';
  maxN=200;
  maxK=200;
  max=2500;
  epsD=1e-10;
  epsS=1e-13;
  epsP=1e-10;
var
  N,k:int;
  ver:array[1..maxN]of TPoint;
  Och:array[1..maxK]of TPoint;
  found:bool;
  FP:TPoint;
  M:real;

function Vect(const a,b,c,d:TPoint):real;
begin
Vect:=(b.x-a.x)*(d.y-c.y)-(b.y-a.y)*(d.x-c.x);
end;

procedure Search (const a,b,c:TPoint);
 var
   G:TPoint;
   AB,BC,AC:TPoint;
   S:Real;
   i:int;
 begin
   if Found then exit;
   S:=Abs(Vect(a,b,a,c));
   G.x:=(a.x+b.x+c.x)/3;
   G.y:=(a.y+b.y+c.y)/3;
   AB.x:=(A.x+B.x)/2;
   AB.y:=(A.y+B.y)/2;
   BC.x:=(B.x+C.x)/2;
   BC.y:=(B.y+C.y)/2;
   AC.x:=(A.x+C.x)/2;
   AC.y:=(A.y+C.y)/2;
   if s<epsS then
     begin
       Found:=true;
       FP:=G;
       exit;
     end;
   for i := 1 to K do
     if (Sqr(a.x-och[i].x)+Sqr(a.y-och[i].y)-sqr(M)<=epsP)
     and (Sqr(b.x-och[i].x)+Sqr(b.y-och[i].y)-sqr(M)<=epsP)
     and (Sqr(c.x-och[i].x)+Sqr(c.y-och[i].y)-sqr(M)<=epsP)
       then
         exit;
   Search(A,AB,AC);
   Search(B,AB,BC);
   Search(C,BC,AC);
   Search(AB,BC,AC);
 end;

procedure Run;
var
 i,j:int;
 L,R:real;
begin
 Read(N);
 for i:= 1 to N do
   Read(ver[i].x,ver[i].y);
 Read(k);
 for i:= 1 to K do
   Read(och[i].x,och[i].y);
 L:=0;
 R:=max;
 while R-L>epsD do
   begin
     M:=(R+L)/2;
     Found:=false;
     for j := 2 to N-1 do
       Search(ver[1],ver[j],ver[j+1]);
     if Found
         then L:=M
         else R:=M;
   end;
 Write(FP.x:0:5,' ',FP.y:0:5);

end;



procedure OpenFiles;
 begin
   Assign(input,infile);
   Reset(input);
   Assign(output,outfile);
   Rewrite(output);
 end;

procedure CloseFiles;
 begin
   Close(input);
   Close(output);
 end;

Begin
OpenFiles;
Run;
CloseFiles;
End.


