{$I-,Q-,R-,S-}
program Zad1;

const
  maxS=405;
  maxK=maxS*2+1;

type
  int=longint;
  bool=boolean;
  arr=record
    list: array[0..maxK] of int;
    b:array[-maxS..maxS] of bool;
    end;

const
  infile='expr.in';
  outfile='expr.out';
  maxN=80;
  pl=16;
  mn=32;
  cfr=[0..9];
var
  s:array[1..maxN] of int;
  a:array[1..maxN,1..maxN] of arr;

procedure Add(i,j,znach:int);
 begin
   if not a[i,j].b[znach] then
     begin
       a[i,j].b[znach]:=true;
       inc(a[i,j].list[0]);
       a[i,j].list[a[i,j].list[0]]:=znach;
     end;

 end;

procedure CloseFiles; forward;

procedure Run;
var
 i,j,k,n1,n2:int;
 N:int;
 ch:char;
begin
  N:=0;
  ch:=' ';
  while not (eof or (ch='*')) do
    begin
      Read(ch);
      if ch in ['0'..'9'] then
        begin
          inc(N);
          s[n]:= ord(ch)-ord('0');
        end;
      if ch ='+' then
        begin
          inc(N);
          s[n]:= pl;
        end;
      if ch ='-' then
        begin
          inc(N);
          s[n]:= mn;
        end;
    end;

  if  N=0 then
   begin
     Write(0);
     CloseFiles;
     Halt(0);
   end;

  fillchar(a,sizeof(a),0);
  for i := 1 to  N do
    if s[i] in cfr then
      Add(i,i,s[i]);

  for j:=1 to N-1 do
    for i :=1 to N-j do
      begin
        {infix}
        for k := i+1 to i+j-1 do
          begin
            if s[k]=pl then
              for n1:=1 to a[i,k-1].list[0] do
                for n2 := 1 to a[k+1,i+j].list[0] do
                  Add(i,i+j,a[i,k-1].list[n1]+a[k+1,i+j].list[n2]);
            if s[k]=mn then
              for n1:=1 to a[i,k-1].list[0] do
                for n2 := 1 to a[k+1,i+j].list[0] do
                  Add(i,i+j,a[i,k-1].list[n1]-a[k+1,i+j].list[n2]);
          end;
        {prefix}
        if s[i]=pl then
          for k := i+1 to i+j-1 do
            for n1:=1 to a[i+1,k].list[0] do
              for n2 := 1 to a[k+1,i+j].list[0] do
                Add(i,i+j,a[i+1,k].list[n1]+a[k+1,i+j].list[n2]);
        if s[i]=mn then
          for k := i+1 to i+j-1 do
            for n1:=1 to a[i+1,k].list[0] do
              for n2 := 1 to a[k+1,i+j].list[0] do
                Add(i,i+j,a[i+1,k].list[n1]-a[k+1,i+j].list[n2]);
        {postfix}
        if s[i+j]=pl then
          for k := i to i+j-2 do
            for n1:=1 to a[i,k].list[0] do
              for n2 := 1 to a[k+1,i+j-1].list[0] do
                Add(i,i+j,a[i,k].list[n1]+a[k+1,i+j-1].list[n2]);
        if s[i+j]=mn then
          for k := i to i+j-2 do
            for n1:=1 to a[i,k].list[0] do
              for n2 := 1 to a[k+1,i+j-1].list[0] do
                Add(i,i+j,a[i,k].list[n1]-a[k+1,i+j-1].list[n2]);
      end;
{  for i := 1 to a[1,n].list[0] do
    Writeln(a[1,n].list[i]);
}  Write(a[1,n].list[0]);




end;

procedure OpenFiles;
 begin
   Assign(input,infile);
   Reset(input);
   Assign(output,outfile);
   Rewrite(output);
 end;

procedure CloseFiles;
 begin
   Close(input);
   Close(OUTPUT);
 end;

Begin
OpenFiles;
Run;
CloseFiles;
End.


