#include <stdio.h>
#include <conio.h>
#include <string.h>

#define INF 1000000000

#define H 41
#define W 45
#define DEP 2

typedef char mas[H + 9][W + 9];

mas Map, M2, U;
int SP = 0, SS[99];
int Qx[H * W], Qy[H * W], Pos, Size;
int Dx[4] = {1, -1, 0, 0}, Dy[4] = {0, 0, 1, -1};
int G = 0;

void Add( int x, int y, int d )
{
  U[y][x] = d, Qx[Size] = x, Qy[Size++] = y;
}

int Bfs( int Sx, int Sy, int C1 )
{
  int x, y, x1, y1, u, i, C0 = M2[Sy][Sx], Sum = 0;

  memset(U, 0, sizeof(U));
  Pos = 0, Size = 0;
  M2[Sy][Sx] = C1, Add(Sx, Sy, 1), Sum++;
  while (Pos < Size)
  {
    x = Qx[Pos], y = Qy[Pos++];
    for (i = 0; i < 4; i++)
    {
      x1 = x + Dx[i], y1 = y + Dy[i], u = U[y][x];
      if (!U[y1][x1])
        if (M2[y1][x1] == C0 && u == 1)
          M2[y1][x1] = C1, Add(x1, y1, 1), Sum++;
        else if (M2[y1][x1] == C1)
          Add(x1, y1, 2), Sum++;
    }
  }
  return Sum;
}

int dfs( int c0, int c1, int dep )
{
  int c2, c3, max = -INF, dif, d, good = -3, i, s1, s2;

  if (dep == 0)
  {
    for (c2 = 0; c2 < 6; c2++)
      if (c0 != c2 && c1 != c2)
      {
        memcpy(M2, Map, sizeof(Map));
        SS[SP++] = c2;
        for (i = 0; i < DEP * 2 + 1; i++)
          if (i & 1)
            s2 = Bfs(W, H, SS[i]);
          else
            s1 = Bfs(1, 1, SS[i]);
        if (DEP == 0)
          s2 = Bfs(W, H, Map[H][W]);
        if ((d = s1 - s2) > max)
          max = d, good = c2;
        SP--;
      }
  }
  else
  {
    for (c2 = 0; c2 < 6; c2++)
    {
      dif = INF;
      for (c3 = 0; c3 < 6; c3++)
        if (c0 != c2 && c1 != c2 && c1 != c3 && c2 != c3)
        {
          SS[SP++] = c2, SS[SP++] = c3;
          if ((d = dfs(c2, c3, dep - 1)) < dif)
            dif = d;
          SP -= 2;
        }
      if (dif != INF && dif > max)
        max = dif, good = c2;
    }
  }
  G = good;
  return max;
}

int main( void )
{
  int i, j;

  freopen("filya.in", "rt", stdin);
  freopen("filya.out", "wt", stdout);
  for (i = 1; i <= H; i++)
    scanf("%s", Map[i] + 1);
  for (i = 1; i <= H; i++)
    for (j = 1; j <= W; j++)
      Map[i][j] -= '1';
  for (i = 0; i <= H + 1; i++)
    Map[i][0] = Map[i][W + 1] = '*';
  for (i = 0; i <= W + 1; i++)
    Map[0][i] = Map[H + 1][i] = '*';
  dfs(Map[1][1], Map[H][W], DEP);
  printf("%d", G + 1);
  return 0;
}
