#include <stdio.h>
#include <string.h>

#define DEBUG_MODE 0

#define LEN 101113
#define MAX 21

typedef unsigned char byte;

byte S[LEN], Pas[MAX];
byte Is[LEN][256];
int Len = 0;
byte Ch[MAX][256];

int main( void )
{
  FILE *F;
  int i, j, k, im, f;

#if DEBUG_MODE == 1
  printf("Read...\n");
#endif
  F = fopen("xor.in", "rb");
  while (fread(S + Len, 1, 1, F) == 1)
    Len++;
  fclose(F);
#if DEBUG_MODE == 1
  printf("Precalc...\n");
#endif
  memset(Is, 0, sizeof(Is));
  for (i = 0; i < Len; i++)
  {
    for (j = 32; j < 128; j++)
      if (j != 35 && j != 64 && j != 94 && j != 124)
        Is[i][j ^ S[i]] = 1;
    Is[i][ 9 ^ S[i]] = 1;
    Is[i][10 ^ S[i]] = 1;
    Is[i][13 ^ S[i]] = 1;
  }
#if DEBUG_MODE == 1
  printf("Solve...\n");
#endif
  for (k = 1; k < MAX; k++)
  {
    memset(Ch, 1, sizeof(Ch));
    for (im = 0, i = 0; i < Len; i++)
    {
      for (f = 0, j = 0; j < 256; j++)
        f += (Ch[im][j] &= Is[i][j]);
      if (!f)
        break;
      if (++im == k)
        im = 0;
    }
    if (i < Len)
      continue;
    for (i = 0; i < k; i++)
    {
      for (j = 0; !Ch[i][j]; j++)
        ;
      Pas[i] = j;
    }
    break;
  }
#if DEBUG_MODE == 1
  printf("Decode...\n");
#endif
  for (im = 0, i = 0; i < Len; i++)
  {
    S[i] ^= Pas[im];
    if (++im == k)
      im = 0;
  }
#if DEBUG_MODE == 1
  printf("Output...\n");
  puts(Pas);
#endif
  F = fopen("xor.out", "wb");
  fwrite(S, Len, 1, F);
  fclose(F);
  return 0;
}
