#include <stdio.h>
#include <string.h>

#define MAXT 2500
#define LEN1 303
#define LEN2 5013
#define SHIFT 99

typedef int num[LEN1 + LEN2 * 3];

num A, B, C;

void Read( int *A )
{
  static int P[LEN1];
  int c, i, len, plen = 0;

  memset(A, 0, sizeof(num));
  c = getc(stdin);
  while (c == 10 || c == 13 || c == 32)
    c = getc(stdin);
  len = 0;
  while ('0' <= c && c <= '9')
    A[len++] = c - '0', c = getc(stdin);
  for (i = len - 1; i >= 0; i--)
    A[LEN1 - len + i] = A[i];
  for (i = LEN1 - len - 1; i >= 0; i--)
    A[i] = 0;
  if (c == '.')
  {
    c = getc(stdin);
    len = 0;
    while ('0' <= c && c <= '9')
      A[LEN1 + len++] = c - '0', c = getc(stdin);
    if (c == '(')
    {
      c = getc(stdin);
      while (c != ')')
        P[plen++] = c - '0', c = getc(stdin);
    }
    else
      P[plen++] = 0;
    for (i = 0; len < LEN2; i++)
      A[LEN1 + len++] = P[i % plen];
  }
}

int main( void )
{
  int i, j, st, dx, T, f9 = 0, fr = 0;
  
  freopen("divide.in", "rt", stdin);
  freopen("divide.out", "wt", stdout);
  Read(A);
  Read(B);
  memset(C, 0, sizeof(C));
  for (st = 0; !B[st]; st++)
    ;
  dx = LEN1 - st - 1;
  for (i = 0; i <= LEN1 + LEN2; i++)
  {
    while (A[i] > B[st])
    {
      C[i + dx]++;
      for (j = i; j <= LEN1 + LEN2; j++)
        A[j] -= B[j - i + st];
      for (j = LEN1 + LEN2; j >= i; j--)
        while (A[j] < 0)
          A[j] += 10, A[j - 1]--;
    }
    A[i + 1] += A[i] * 10, A[i] = 0;
  }
  for (i = LEN1 + LEN2; i > 0; i--)
    C[i - 1] += C[i] / 10, C[i] %= 10;

  T = 1;
  while (T < MAXT)
  {
    for (i = 0; i < (LEN2 >> 1); i++)
      if (C[LEN1 + (LEN2 >> 1) + i - SHIFT] != C[LEN1 + (LEN2 >> 1) + (i % T) - SHIFT])
        break;
    if (i == (LEN2 >> 1))
      break;
    T++;
  }
  if (T == MAXT)
    T = 0;
  for (i = LEN1 + LEN2 - SHIFT; i - T >= LEN1 && C[i - T] == C[i]; i--)
    ;
  st = i - T;
  
  if (T == 1 && C[st + 1] == 9)
    f9 = 1;
  if (f9)
    for (C[i = st]++; C[i] > 9; i--)
      C[i] -= 10, C[i - 1]++;
  for (i = LEN1; i < LEN1 + LEN2 - SHIFT && !C[i]; i++)
    ;
  if (i != LEN1 + LEN2 - SHIFT)
    fr = 1;

  for (i = 0; i < LEN1 && !C[i]; i++)
    ;
  if (i == LEN1)
    putc('0', stdout);
  while (i < LEN1)
    putc('0' + C[i++], stdout);
  if (!fr)
    return 0;
  printf(".");
  if (T == 0)
    st = LEN1 + LEN2 - SHIFT;
  for (i = LEN1; i <= st; i++)
    putc('0' + C[i], stdout);
  if (T == 0 || (T == 1 && (C[i] == 0 || C[i] == 9)))
    return 0;
  putc('(', stdout);
  for (j = 1; j <= T; j++)
    putc('0' + C[st + j], stdout);
  putc(')', stdout);
  return 0;
}
