#include <stdio.h>
#include <string.h>

#define MAXN 100013
#define MAXP 1513

int N, P, A[MAXN];
long long Ze = 0, MP[MAXP], MP1[MAXP];
long long Sum = 0;
int F[MAXP][MAXP];

int Pow( int a, int p )
{
  int x, r = 1;

  a %= P;
  for (x = a; p; x = (x * x) % P, p >>= 1)
    if (p & 1)
      r = (r * x) % P;
  return r;
}

int main( void )
{
  int i, j, x, p;

  freopen("triples.in", "rt", stdin);
  freopen("triples.out", "wt", stdout);
  scanf("%d%d", &N, &P);
  for (i = 0; i < N; i++)
    scanf("%d", &A[i]);
  for (i = 0; i <= P; i++)
    MP[i] = MP1[i] = 0;
  for (i = 0; i < N; i++)
    MP[A[i] % P]++, MP1[A[i] % (P - 1)]++, Ze += !A[i];
  if (P == 2)
  {
    printf("%Ld", 
      Ze * MP[1] * (N - 2) + 
     (MP[0] - Ze) * (MP[0] - 1) * (MP[0] - 2) + 
      MP[1] * (MP[1] - 1) * (N - Ze - 2) + 
      MP[0] * MP[1] * (MP[0] - 1));
    return 0;                                     
  }
  /* For any i, j, k */
  for (i = 0; i < P; i++)
    for (x = 1, j = 0; j < P - 1; j++, x = (x * i) % P)
      Sum += MP[i] * MP1[j] * MP[x];
  Sum += MP[0] * (MP1[0] - Ze) * (MP[0] - MP[1]);
  /* i != k */
  memset(F, 0, sizeof(F));
  for (i = 0; i < P; i++)
    for (x = 1, j = 0; j < P - 1; j++, x = (x * i) % P)
      F[i][x] += MP1[j];
  for (i = 0; i < N; i++)
  {
    Sum -= F[A[i] % P][A[i] % P];
    if ((A[i] % P) == 0)
      Sum -= MP1[0] - Ze;
  }
//  Sum -= N * MP1[1];
//  Sum -= MP[1] * (N - MP1[1]);
//  Sum -= MP[0] * (N - MP1[1] - Ze);
  /* i != j */
  for (i = 0; i < N; i++)
  {
    Sum -= MP[p = Pow(A[i], A[i])];
    if (p == (A[i] % P))
      Sum += 2;
  }
  /* j != k */
  memset(F, 0, sizeof(F));
  for (i = 0; i < P; i++)
    for (x = 1, j = 0; j < P - 1; j++, x = (x * i) % P)
      F[j][x] += MP[i];
  for (i = 0; i < N; i++)
  {
    Sum -= F[A[i] % (P - 1)][A[i] % P];
    if ((A[i] % (P - 1)) == 0 && A[i] != 0)
      if ((A[i] % P) == 1)
        Sum += MP[0];
      else if ((A[i] % P) == 0)
        Sum -= MP[0];
  }
  printf("%Ld", Sum);
  return 0;
}
