#include <stdio.h>
#include <string.h>

#define SWAP(A, B, C) ((C) = (A), (A) = (B), (B) = (C))

#define MAX 157

int _stklen = 10000000;

char S[MAX];
char W[MAX][MAX], *Wo[MAX], Le[MAX];
int N, Len[MAX], Is[26], Sum = 0, f = 0;
int Eq[26][26];
int T0, Count = 0;

void dfs( char *S )
{
  int i, j, k, L = strlen(S), L2;
  char S2[MAX];

  if (Sum == 26 || f)
    return;
  if (L == 1)
  {
    Sum += !Is[S[0] - 'A'];
    Is[S[0] - 'A'] = 1;
    return;
  }
  for (i = 0; i < N; i++)
    if (Len[i] <= L)
      for (j = 0; j + Len[i] <= L && Len[i] > 1; j++)
      {
        for (k = 0; k < Len[i]; k++)
          if (!Eq[S[j + k] - 'A'][Wo[i][k] - 'A'])
            break;
        if (k != Len[i])
          continue;
        L2 = 0;
        for (k = 0; k < j; k++)
          S2[L2++] = S[k];
        S2[L2++] = Le[i];
        for (k = j + Len[i]; k < L; k++)
          S2[L2++] = S[k];
        S2[L2] = 0;
        dfs(S2);
      }
}

int main( void )
{
  char tmp[9], *t1;
  int i, j, t2;
  
  freopen("game.in", "rt", stdin);
  freopen("game.out", "wt", stdout);
  scanf("%s%d", S, &N);
  for (i = 0; i < N; i++)
    scanf("%s%s", W[i], tmp), Le[i] = tmp[0];
  for (i = 0; i < N; i++)
    Len[i] = strlen(W[i]), Wo[i] = W[i];
  memset(Eq, 0, sizeof(Eq));
  for (i = 0; i < 26; i++)
    Eq[i][i] = 1;
  for (i = 0; i < N; i++)
    if (Len[i] == 1)
      Eq[W[i][0] - 'A'][Le[i] - 'A'] = 1;
  for (i = 0; i < N; i++)
    for (j = 1; j < N; j++)
      if (Len[j - 1] > Len[j])
      {
        SWAP(Len[j - 1], Len[j], t2);
        SWAP(Wo[j - 1], Wo[j], t1);
      }
  memset(Is, 0, sizeof(Is));
  dfs(S);
  for (i = 0; i < 26; i++)
    if (Is[i])
      putc(i + 'A', stdout);
  return 0;
}
