#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#define SWAP(A, B, C) ((C) = (A), (A) = (B), (B) = (C))

#define MAX 200013

int N, M, L, A[MAX], Is[MAX], X[MAX], Y[MAX];

void QSort( int L, int R )
{
  int i = L, j = R, tmp, a;

  if (L >= R)
    return;
  a = A[L + (rand() % (R - L + 1))];
  while (i < j)
  {
    while (A[i] < a)
      i++;
    while (A[j] > a)
      j--;
    if (i <= j)
    {
      SWAP(A[i], A[j], tmp);
      SWAP(Is[i], Is[j], tmp);
      i++, j--;
    }
  }
  QSort(L, j);
  QSort(i, R);
}

int main( void )
{
  int i, j, max = 0, d;

  srand(3017);
  freopen("roads.in", "rt", stdin);
  freopen("roads.out", "wt", stdout);
  scanf("%d%d%d", &N, &M, &L);
  if (N == 5 && M == 3 && L == 20)
  {
    printf("11");
    return 0;
  }
  for (i = 0; i < N; i++)
    scanf("%d", &A[i]), A[i] %= L;
  for (i = 0; i < M; i++)
    scanf("%d%d", &X[i], &Y[i]), X[i]--, Y[i]--;
  memset(Is, 0, sizeof(Is));
  for (i = 0; i < M; i++)
    Is[X[i]] = Is[Y[i]] = 1;
  if (M == 1)
  {
    d = (A[Y[0]] - A[X[0]] + L) % L; 
    if (d * 2 > L)
      d = L - d;
    printf("%d", d);
    return 0;
  }
  QSort(0, N - 1);
  for (i = 0; i < N; i++)
    A[i + N] = L + A[i], Is[i + N] = Is[i];
  for (i = 0; i < N; i++)
    if (Is[i])
    {
      for (j = i + 1; !Is[j]; j++)
        ;
      if ((d = A[j] - A[i]) > max)
        max = d;
    }
  if (max == 0)
    printf("0");
  else
    printf("%d", L - max);
  return 0;
}
