#include <stdio.h>
#include <string.h>
#include <time.h>

#define SWAP(A, B, C) ((C) = (A), (A) = (B), (B) = (C))

#define MAX 31
#define SIZE (1 << 15) + 13

int C, B, N, N1, N2, X[MAX], Y[MAX], Q[MAX], P[MAX], Pos[MAX];
int IsN1 = 0, IsN2 = 0, Is1[SIZE], Is2[SIZE];
int NB1[SIZE], NB2[SIZE], Max = 0;
int Res = 0, RN = 0, R[MAX];

void Do( int St, int N, int *IsN, int *Is, int *NB )
{
  int i, j, k, nb, c;

  for (i = (1 << N) - 1; i >= 0; i--)
  {
    for (nb = 0, k = 0; k < N; k++)
      if ((i >> k) & 1)
        nb += (Y[St + k] - X[St + k]) * Q[St + k];
    for (c = 0, j = 0; j <= B; j++)
    {
      for (k = 0; k < N; k++)
        if ((i >> k) & 1)
          if (X[St + k] == j)
            c += Q[St + k];
          else if (Y[St + k] == j)
            c -= Q[St + k];
      if (c > C)
        break;
    }
    if (j > B)
      Is[*IsN] = i, NB[*IsN] = nb, (*IsN)++;
  }
}

int main( void )
{                
  int i, j, b, c, x, tmp, T0, px, py;
  long long sum = 0;
    
  T0 = clock();
  freopen("trains.in", "rt", stdin);
  freopen("trains.out", "wt", stdout);
  scanf("%d%d%d", &C, &B, &N);
  for (i = 0; i < N; i++)
    scanf("%d%d%d", &X[i], &Y[i], &Q[i]), P[i] = Pos[i] = i;
  for (i = 0; i < N; i++)
    if (X[i] > Y[i])
      SWAP(X[i], Y[i], tmp);
  for (i = 0; i < N; i++)
    if (Q[i] <= C)
      sum += Q[i] * (Y[i] - X[i]);
  for (i = 0; i < N; i++)
    for (j = 1; j < N; j++)
      if (X[j - 1] > X[j])
      {
        SWAP(X[j - 1], X[j], tmp);
        SWAP(Y[j - 1], Y[j], tmp);
        SWAP(Q[j - 1], Q[j], tmp);
        SWAP(Pos[j - 1], Pos[j], tmp);
      }
  for (i = 0; i < N; i++)
    for (j = 1; j < N; j++)
      if (Y[P[j - 1]] > Y[P[j]])
        SWAP(P[j - 1], P[j], tmp);
  N1 = N >> 1, N2 = N - N1;
  memset(Is1, 0, sizeof(Is1));
  memset(Is2, 0, sizeof(Is2));
  Do(0, N1, &IsN1, Is1, NB1);
  Do(N1, N2, &IsN2, Is2, NB2);
  for (i = 0; i < IsN1; i++)
  {
    if (clock() - T0 >= 160)
      break;
    for (j = 0; j < IsN2 && Max < sum; j++)
    {
      if (NB1[i] + NB2[j] <= Max)
        continue;
      x = Is1[i] + (Is2[j] << N1);
      c = 0, px = 0, py = 0;
      for (b = 0; b <= B; b++)
      {
        while (px < N && X[px] <= b)
        {
          if ((x >> px) & 1)
            c += Q[px];
          px++;
        }
        while (py < N && Y[P[py]] <= b)
        {
          if ((x >> P[py]) & 1)
            c -= Q[P[py]];
          py++;
        }
        if (c > C)
          break;
      }
      if (b <= B)
        continue;
      Max = NB1[i] + NB2[j], Res = x;
    }
  }
  for (i = 0; i < N; i++)
    if ((Res >> i) & 1)
      R[RN++] = Pos[i] + 1;
  for (i = 0; i < RN; i++)
    for (j = 1; j < RN; j++)
      if (R[j - 1] > R[j])
        SWAP(R[j - 1], R[j], tmp);
  printf("%d\n", Max);
  for (i = 0; i < RN; i++)
    printf("%d ", R[i]);
//  printf("\n%d\n", clock() - T0);
  return 0;
}
