#include <stdio.h>                                
#include <string.h>

#define MAXV 259
#define MAXE 539
#define SIZE 1000013

int N, P, Pr[MAXV], Min[MAXV][MAXV], Tmp[MAXV], Tmp2[MAXV];
int E = 0, He[MAXV], Ne[MAXE], Y[MAXE];
int EM = 0, HeM[MAXV][MAXV], NeM[SIZE], YM[SIZE], Ch[SIZE];
int ENo[MAXV][MAXV];
int RN = 0, R[MAXE];

void AddE( int a, int b, int n )
{
  Ne[E] = He[a], Y[E] = b, He[a] = E++;
}

void dfs1( int v, int pr )
{
  int e;

  Pr[v] = pr;
  for (e = He[v]; e != -1; e = Ne[e])
    if (Y[e] != pr)
      dfs1(Y[e], v);
}

void dfs2( int v )
{
  int i, j, e, u, *M = Min[v], *Mu;

  M[1] = 0;
  for (e = He[v]; e != -1; e = Ne[e])
    if ((u = Y[e]) != Pr[v])
    {
      dfs2(u);
      Mu = Min[u];
      memset(Tmp, -1, sizeof(Tmp));
      for (j = 0; j <= N; j++)
        if (Mu[j] != -1)
          for (i = 0; i <= N; i++)
            if (M[i] != -1 && (Tmp[i + j] == -1 || Tmp[i + j] > M[i] + Mu[j]))
              Tmp[i + j] = M[i] + Mu[j], Tmp2[i + j] = j;
      memcpy(M, Tmp, sizeof(Tmp));
      for (j = N; j >= 0; j--)
        if (Tmp[j] != -1)
        {
          NeM[EM] = HeM[v][j - Tmp2[j]];
          YM[EM] = u;
          Ch[EM] = Tmp2[j];
          HeM[v][j] = EM++;
        }
        else
          HeM[v][j] = -1;
    }
  NeM[EM] = -1;
  YM[EM] = v;
  Ch[EM] = 1;
  HeM[v][0] = EM++;
  M[0] = 1;
}

void Del( int v, int p )
{
  int e;

  for (e = HeM[v][p]; e != -1; e = NeM[e])
    if (YM[e] == v)
      R[RN++] = ENo[v][Pr[v]];
    else
      Del(YM[e], Ch[e]);
}

int main( void )
{
  int i, a, b, min = (int)1e9, mini;

  freopen("tree.in", "rt", stdin);
  freopen("tree.out", "wt", stdout);
  scanf("%d%d", &N, &P);
  memset(He, -1, sizeof(He));
  for (i = 1; i < N; i++)
  {
    scanf("%d%d", &a, &b), a--, b--;
    AddE(a, b, i);
    AddE(b, a, i);
    ENo[a][b] = ENo[b][a] = i;
  }
  dfs1(0, -1);
  memset(Min, -1, sizeof(Min));
  memset(HeM, -1, sizeof(HeM));
  dfs2(0);
  for (i = 0; i < N; i++)
    if (Min[i][P] != -1 && Min[i][P] < min)
      mini = i, min = Min[i][P];
  if (mini)
    min++, R[RN++] = ENo[mini][Pr[mini]];
  printf("%d\n", min);
  Del(mini, P);
  for (i = 0; i < RN; i++)
    printf("%d ", R[i]);
  return 0;
}
