{$P+}
{$M 30000000,2000000}
program pb;
 const osn=10;
 type byte=shortint;
 type long=array[0..60000] of integer; {zadom napered}
 type ch=record
  z:long;
  drob:long;
  per:long;
 end;
 type drb=record
  p,q:long;
 end;
 var s1,s2,s3:string;
     c1,c2,c3:ch;
     d1,d2,d3:drb;
     zero:long;
     t1:long;

 procedure load;
 begin
  assign(input,'divide.in');
  reset(input);
   readln(s1);
   readln(s2);
  close(input);
 end;

 procedure save;
 begin
  assign(output,'divide.out');
  rewrite(output);
   writeln(s3);
  close(output);
 end;

 procedure swap(var x,y:integer);
  var t:longint;
 begin
  t:=x;
  x:=y;
  y:=t;
 end;

 function min(x,y:longint):longint;
 begin
  if x<y then min:=x else min:=y;
 end;

 function max(x,y:longint):longint;
 begin
  if x>y then max:=x else max:=y;
 end;

 procedure rotate(var l:long; x,y:longint);
  var i:longint;
 begin
  for i:=x to (x+y) div 2 do begin
   swap(l[i],l[y-i+x]);
  end;
 end;

 procedure longsum(const l1,l2:long; var l:long);
  var i,j,t:longint;
 begin
  fillchar(l,sizeof(l),0);
  t:=0;
  for i:=1 to max(l1[0],l2[0]) do begin
   j:=t+l1[i]+l2[i];
   l[i]:=j mod osn;
   t:=j div osn;
  end;
  if t=0 then l[0]:=max(l1[0],l2[0]) else begin
   l[0]:=max(l1[0],l2[0])+1;
   l[l[0]]:=t;
  end;
 end;

 procedure longms(const l1,l2:long; var l:long; sdvig:longint);
  var i,j,t:longint;
 begin
  fillchar(l,sizeof(l),0);
  t:=0;
  if l1[0]>=l2[0]+sdvig then begin
   for i:=1 to max(l1[0],l2[0]+sdvig) do begin
    if i>sdvig then begin
     if i-sdvig>0 then j:=l1[i]-l2[i-sdvig]-t
      else j:=l1[i]-t;
     t:=0;
     if j<0 then begin t:=1; inc(j,10); end;
     l[i]:=j;
    end else begin
     j:=l1[i]-t;
     t:=0;
     if j<0 then begin t:=1; inc(j,10); end;
     l[i]:=j;
    end;
   end;
   l[0]:=max(l1[0],l2[0]+sdvig);
   while (l[0]>0)and(l[l[0]]=0) do dec(l[0]);
  end else begin
   l[0]:=0;
  end;
 end;

 procedure longdiv2(var l:long);
  var i,j,t:longint;
 begin
  t:=0;
  for i:=l[0] downto 1 do begin
   j:=(t*10+l[i]);
   l[i]:=j div 2;
   t:=j mod 2;
  end;
  if l[l[0]]=0 then dec(l[0]);
 end;

 function compare(const l1,l2:long; sdvig:longint):shortint;
  var i:longint;
 begin
  if l1[0]>l2[0]+sdvig then compare:=1 else
   if l1[0]<l2[0]+sdvig then compare:=-1 else
   begin
    for i:=l1[0] downto 1 do begin
     if ((i>sdvig)and(l1[i]>l2[i-sdvig]))or((i<=sdvig)and(l1[i]>0)) then begin
      compare:=1;
      exit;
     end else
     if ((i>sdvig)and(l1[i]<l2[i-sdvig]))or((i<=sdvig)and(l1[i]<0)) then begin
      compare:=-1;
      exit;
     end;
    end;
    compare:=0;
   end;
 end;

 function compare2(const l1,l2:long; sdvig:longint):shortint;
  var i:longint;
 begin
  if l1[0]>l2[0]+sdvig then compare2:=1 else
   if l1[0]<l2[0]+sdvig then compare2:=-1 else
   begin
    for i:=l1[0] downto 1+sdvig do begin
     if ((i>0)and(l1[i]>l2[i-sdvig]))or((i<=0)and(0>l2[i-sdvig])) then begin
      compare2:=1;
      exit;
     end else
     if ((i>0)and(l1[i]<l2[i-sdvig]))or((i<=0)and(0<l2[i-sdvig])) then begin
      compare2:=-1;
      exit;
     end;
    end;
    compare2:=0;
   end;
 end;

 procedure longnod(x,y:long; var l:long);
  var i,j:longint;
      t:long;
 begin
  fillchar(l,sizeof(l),0);
  j:=0;
  if compare(x,y,0)=-1 then begin
   t:=x;
   x:=y;
   y:=t;
  end;
  while (x[0]>0)and(y[0]>0) do begin
   if (x[x[0]] mod 2 =0)and(y[y[0]] mod 2 =0) then begin
    inc(j);
    longdiv2(x);
    longdiv2(y);
   end else
   if x[1] mod 2 =0 then begin
    longdiv2(x);
   end else
   if y[1] mod 2 =0 then begin
    longdiv2(y);
   end else begin
    longms(x,y,t,0);
    if compare(y,t,0)=1 then begin
     x:=y;
     y:=t;
    end else begin
     x:=t;
    end;
   end;
  end;
  if x[0]=0 then l:=y else l:=x;
 end;

 procedure shortmul(const x:long; y:shortint; var l:long; sdvig:longint);
  var i,j,t:longint;
 begin
  fillchar(l,sizeof(l),0);
  t:=0;
  for i:=1 to x[0] do begin
   j:=x[i]*y+t;
   l[i+sdvig]:=j mod osn;
   t:=j div osn;
  end;
  if t=0 then l[0]:=x[0]+sdvig else begin
   l[0]:=x[0]+1+sdvig;
   l[l[0]]:=t;
  end;
  while (l[0]>0)and(l[l[0]]=0) do dec(l[0]); 
 end;

 procedure longmul(const x,y:long; var l:long);
  var i:longint;
      t,tt:long;
 begin
  fillchar(l,sizeof(l),0);
  for i:=1 to x[0] do begin
   shortmul(y,x[i],t,i-1);
   longsum(l,t,tt);
   l:=tt;
  end;
 end;

 function fnd(const l1,l2:long; sdvig:longint):longint;
  var up,down,now:longint;
 begin
  up:=9;
  down:=0;
  while up-down>1 do begin
   now:=(up+down) div 2;
   shortmul(l2,now,t1,0);
   if compare(l1,t1,sdvig)=-1 then up:=now else down:=now;
  end;
  now:=up;
  shortmul(l2,now,t1,0);
  if compare(l1,t1,sdvig)<>-1 then fnd:=up else
   fnd:=down;
 end;

 procedure longdiv(l1,l2:long; var l:long);
  var i,j,k:longint;
      t1,t2:long;

 begin
  fillchar(l,sizeof(l),0);
  k:=l1[0]-l2[0];
  for i:=k downto 0 do begin
   j:=fnd(l1,l2,i);
   inc(l[0]);
   l[l[0]]:=j;
   shortmul(l2,j,t1,0);
   longms(l1,t1,t2,i);
   l1:=t2;
  end;
  rotate(l,1,l[0]);
  while (l[0]>0)and(l[l[0]]=0) do dec(l[0]);
 end;

 procedure s2ch(const s:string; var c:ch);
  var i:longint;

  procedure rot;
  begin
   rotate(c.z,1,c.z[0]);
   rotate(c.drob,1,c.drob[0]);
   rotate(c.per,1,c.per[0]);
  end;

 begin
  fillchar(c,sizeof(c),0);
  i:=1;
  while (i<=length(s))and(s[i]<>'.') do begin
   inc(c.z[0]);
   c.z[c.z[0]]:=ord(s[i])-ord('0');
   inc(i);
  end;
  if (c.z[0]=1)and(c.z[1]=0) then dec(c.z[0]);
  if i>length(s) then begin rot; exit; end;
  inc(i);
  while (i<=length(s))and(s[i]<>'(') do begin
   inc(c.drob[0]);
   c.drob[c.drob[0]]:=ord(s[i])-ord('0');
   inc(i);
  end;
  if i>length(s) then begin rot; exit; end;
  inc(i);
  while (i<=length(s))and(s[i]<>')') do begin
   inc(c.per[0]);
   c.per[c.per[0]]:=ord(s[i])-ord('0');
   inc(i);
  end;
  rot;
 end;

 procedure ch2d(const c:ch; var d:drb);
  var t1,t2,t3,t4,t5:long;
      i:longint;
 begin
  fillchar(t1,sizeof(t1),0);
  t1[0]:=c.drob[0]+1;
  if t1[0]>0 then t1[t1[0]]:=1 else begin
   t1[0]:=1;
   t1[1]:=1;
  end;
  longmul(t1,c.z,t2);
  longsum(t2,c.drob,t3);
  for i:=1 to c.per[0] do t2[i]:=9;
  t2[0]:=c.per[0];
  if t2[0]=0 then begin
   t2[0]:=1;
   t2[1]:=1;
  end;
  longmul(t3,t2,t4);
  longsum(t4,c.per,t5);
  longmul(t2,t1,t3);
  longnod(t5,t3,t1);
  longdiv(t5,t1,t2);
  longdiv(t3,t1,t4);
  d.p:=t2;
  d.q:=t4;
 end;

 function isper(const l:long; x:longint; var y:longint):boolean;
  var i,j:longint;
      fl:boolean;
 begin
  for i:=1 to 100 do begin
   fl:=true;
   for j:=x downto i+1 do
    if l[j]<>l[j-i] then begin
     fl:=false;
     break;
    end;
   if fl then begin
    y:=i;
    isper:=true;
    exit;
   end;
  end;
  isper:=false;
 end;

 procedure d2ch(const d:drb; var c:ch);
  var t1,t2:long;
      i,j,k:longint;
 begin
  fillchar(c,sizeof(c),0);
  longdiv(d.p,d.q,c.z);
  longmul(c.z,d.q,t2);
  longms(d.p,t2,t1,0);
  if c.z[0]=0 then c.z[0]:=1;
  if t1[0]=0 then exit;
  {Prodolzenie sleduet}
  for i:=500 downto 201 do
   t1[i]:=t1[i-200];
  for i:=1 to 200 do t1[i]:=0;
  t1[0]:=t1[0]+200;
  longdiv(t1,d.q,t2);
  j:=0;
  for i:=500 downto 1 do if isper(t2,i,k) then begin
   j:=i;
   break;
  end;
  if (j<>0) then begin
   isper(t2,j,k);
   for i:=j+1 to t2[0] do c.drob[i-j]:=t2[i];
   c.drob[0]:=t2[0]-j;
   for i:=j downto j-k+1 do c.per[i-j+k]:=t2[i];
   c.per[0]:=k;
   if (k=1)and(c.per[1]=0) then c.per[0]:=0;
  end else begin
   i:=1;
   while t2[i]=0 do inc(i);
   for j:=t2[0] downto i do c.per[j-i+1]:=t2[i];
   c.per[0]:=t2[0]-i+1;
  end;
 end;

 procedure ch2s(var c:ch; var s:string);
  var i:longint;
 begin
  rotate(c.z,1,c.z[0]);
  rotate(c.drob,1,c.drob[0]);
  rotate(c.per,1,c.per[0]);
  s:='';
  for i:=1 to c.z[0] do begin
   s:=s+chr(c.z[i]+ord('0'));
  end;
  if (c.drob[0]>0)or(c.per[0]>0) then s:=s+'.' else exit;
  for i:=1 to c.drob[0] do begin
   s:=s+chr(c.drob[i]+ord('0'));
  end;
  if c.per[0]>0 then s:=s+'(' else exit;
  for i:=1 to c.per[0] do begin
   s:=s+chr(c.per[i]+ord('0'));
  end;
  s:=s+')';
 end;

 procedure solve;
  var t1,t2:long;
 begin
  s3:='';
  fillchar(zero,sizeof(zero),0);
  fillchar(c1,sizeof(c1),0);
  fillchar(c2,sizeof(c2),0);
  fillchar(c3,sizeof(c3),0);
  fillchar(d1,sizeof(d1),0);
  fillchar(d2,sizeof(d2),0);
  fillchar(d3,sizeof(d3),0);
  s2ch(s1,c1);
  s2ch(s2,c2);
  ch2d(c1,d1);
  ch2d(c2,d2);
  longmul(d1.p,d2.q,t1);
  longmul(d1.q,d2.p,t2);
  d3.p:=t1;
  d3.q:=t2;
  d2ch(d3,c3);
  ch2s(c3,s3);
 end;

begin
 load;
 solve;
 save;
end.
