program p1;
 type tros=record
  x,l:extended;
 end;
 type kon=record
  x,t:extended;
  w:longint;
 end;
 const eps=1e-5;
 var n:longint;
     r:array[1..5000] of tros;
     a:array[1..10000] of kon;
     ax,ay:extended;

 procedure qsort;

  procedure sort(l,r: longint);
    var
       i,j: longint;
       x,y:kon;
    begin
       i:=l;
       j:=r;
       x:=a[(l+r) div 2];
       repeat
         while (a[i].x<x.x) do
          inc(i);
         while (x.x<a[j].x) do
          dec(j);
         if not(i>j) then
           begin
              y:=a[i];
              a[i]:=a[j];
              a[j]:=y;
              inc(i);
              j:=j-1;
           end;
       until i>j;
       if l<j then
         sort(l,j);
       if i<r then
         sort(i,r);
    end;

 begin
    sort(1,2*n);
 end;

 procedure load;
  var i:longint;
 begin
  assign(input,'popular.in');
  reset(input);
   read(n);
   for i:=1 to n do read(r[i].x,r[i].l);
  close(input);
 end;

 procedure save;
 begin
  assign(output,'popular.out');
  rewrite(output);
   writeln(ax:0:4,' ',ay:0:4);
  close(output);
 end;

 function sf(a,b,c:extended):extended;
  var p:extended;
 begin
  p:=(a+b+c)/2;
  sf:=sqrt(p*(p-a)*(p-b)*(p-c));
 end;

 procedure solve;
  var i,j,l1,l2:longint;
      fl:boolean;
      t1,t2:tros;
 begin
  fillchar(a,sizeof(a),0);
  for i:=1 to n do begin
   a[2*i-1].x:=r[i].x-r[i].l;
   a[2*i-1].t:=1;
   a[2*i-1].w:=i;
   a[2*i].x:=r[i].x+r[i].l;
   a[2*i].t:=2;
   a[2*i].w:=i;
  end;
  qsort;
  i:=1;
  j:=0;
  fl:=false;
  while (i<=2*n) do begin
   if a[i].t=1 then inc(j) else dec(j);
   if j=n then begin
    fl:=true;
    l1:=a[i].w;
    while (a[i].t<>2) do inc(i);
    l2:=a[i].w;
    break;
   end;
   inc(i);
  end;
  if not(fl) then begin
   assign(output,'popular.out');
   rewrite(output);
    writeln(-1,' ',-1);
   close(output);
   halt(0);
  end;
  t1:=r[l1];
  t2:=r[l2];
  if abs(t1.x-t2.x)>eps then begin
   ay:=-2*sf(abs(t1.x-t2.x),t1.l,t2.l)/abs(t1.x-t2.x);
   ax:=t2.x+sqrt(-sqr(ay)+sqr(t2.l));
  end else begin
   ay:=-t1.l;
   ax:=t1.x;
  end;
 end;

begin
 load;
 solve;
 save;
end.
