program p3;
 const maxn=300;
 type reb=record
  x,t:longint;
 end;
 type pr=^tr;
      tr=record
       e:reb;
       next:pr;
      end;

 var n,m,k:longint;
     r:array[1..maxn] of pr;
     gam:array[1..maxn,1..maxn] of longint;
     bu:array[1..maxn,1..maxn] of boolean;
     sm,sp:longint;

 procedure add(var t:pr;r:reb);
  var tp,pp:pr;
 begin
  tp:=t;
  new(pp);
  pp^.e:=r;
  pp^.next:=tp;
  t:=pp;
 end;

 procedure load;
  var i,j,t1,t2:longint;
      r1:reb;
 begin
  assign(input,'pursuit.in');
  reset(input);
   fillchar(r,sizeof(r),0);
   read(n,m,k);
   for i:=1 to m do begin
    read(j,t1,t2);
    r1.x:=j;
    r1.t:=t2;
    add(r[t1],r1);
    r1.x:=t1;
    r1.t:=t2;
    add(r[j],r1);
   end;
   read(sm,sp);
  close(input);
 end;

 procedure save;
 begin
  assign(output,'pursuit.out');
  rewrite(output);
   if gam[sm,sp]=0 then writeln('Endless') else
    if gam[sm,sp]>0 then begin
     writeln('Caught');
     writeln(gam[sm,sp]-1);
    end else
    if gam[sm,sp]<0 then begin
     writeln('Escaped');
     writeln(-gam[sm,sp]-1);
    end;
  close(output);
 end;

 function min(x,y:longint):longint;
 begin
  if x<y then min:=x else min:=y;
 end;

 function max(x,y:longint):longint;
 begin
  if x>y then max:=x else max:=y;
 end;

 function find(x,y:longint):longint;
  var tp1,tp2:pr;
      mn,mx,tmp:longint;
      rn,rm:reb;
 begin
  if bu[x,y] then begin
   find:=gam[x,y];
   exit;
  end;
  bu[x,y]:=true;
  tp1:=r[x];
  mx:=-100000;
  while tp1<>nil do begin
   rm:=tp1^.e;
   tp1:=tp1^.next;
   mn:=find(rm.x,y);
   if mn=1 then begin
    gam[x,y]:=2;
    find:=2;
    exit;
   end;
   tp2:=r[y];
   while tp2<>nil do begin
    rn:=tp2^.e;
    tp2:=tp2^.next;
    if rn.t=rm.t then begin
     tmp:=find(rm.x,rn.x);
     if tmp=-1 then begin
      gam[x,y]:=-2;
      find:=-2;
      exit;
     end;
     if ((tmp<0)and(tmp>mn))or((tmp>=0)and(tmp<mn)) then mn:=tmp;
    end;
   end;
   if ((mn>0)and(mn<mx))or((mn<=0)and(mn>mx)) then mx:=mn;
  end;
  if mx>0 then gam[x,y]:=mx+1 else
   if mx<0 then gam[x,y]:=mx-1 else
    gam[x,y]:=0;
  find:=gam[x,y];
 end;

 procedure solve;
  var i:longint;
 begin
  fillchar(bu,sizeof(bu),0);
  fillchar(gam,sizeof(gam),0);
  for i:=1 to n do begin
   gam[i,i]:=1;
   bu[i,i]:=true;
  end;
  for i:=1 to n do begin
   gam[i,1]:=-1;
   bu[i,1]:=true;
  end;
  find(sm,sp);
 end;

begin
 load;
 solve;
 save;
end.
