program pb;
 const maxn=350;
 type ver=record
  x1,y1,x2,y2:integer;
  d:-1..1;
  fr:integer;
  l:longint;
 end;
 var us:array[1..maxn,1..2] of longint;
     dop:array[1..maxn] of boolean;
     psi:array[1..maxn,1..maxn] of ver;
     worked:array[1..maxn,1..maxn] of boolean;
     n,m,t:longint;

 procedure solve; forward;

 procedure print(x,y:longint);
 begin
  if psi[x,y].fr=0 then exit;
  if psi[x,y].fr=1 then write(0) else write(1);
  if psi[x,y].fr=1 then print(psi[x,y].x1,psi[x,y].y1)
   else print(psi[x,y].x2,psi[x,y].y2);
 end;

 procedure load;
  var i,j,t:longint;
 begin
  assign(input,'eq.in');
  reset(input);
  assign(output,'eq.out');
  rewrite(output);
   fillchar(dop,sizeof(dop),0);
   read(n,t);
   for i:=1 to t do begin
    read(j);
    dop[j]:=true;
   end;
   for i:=1 to n do begin
    read(us[i,1],us[i,2]);
   end;
   solve;
   read(m);
   for i:=1 to m do begin
    read(j,t);
    if psi[j,t].d=1 then writeln('equivalent')
     else begin
      print(j,t);
      writeln;
     end;
    end;
  close(output);
  close(input);
 end;

 procedure rep(i,j:longint);
 begin
  psi[i,j].d:=-1;
  if psi[psi[i,j].x1,psi[i,j].y1].d=0 then begin
   psi[psi[i,j].x1,psi[i,j].y1].fr:=1;
   rep(psi[i,j].x1,psi[i,j].y1);
  end;
  if psi[psi[i,j].x2,psi[i,j].y2].d=0 then begin
   psi[psi[i,j].x2,psi[i,j].y2].fr:=2;
   rep(psi[i,j].x2,psi[i,j].y2);
  end;
 end;

 function find(x,y:longint):integer;
  var i,j,w:longint;
 begin
  if psi[x,y].d=-1 then begin
   find:=-1;
   exit;
  end else if psi[x,y].d=1 then begin
   find:=1;
   exit;
  end;
  if worked[x,y] then begin
   find:=0;
   exit;
  end;
  worked[x,y]:=true;
  i:=find(us[x,1],us[y,1]);
  if i=-1 then begin
   psi[x,y].fr:=1;
   psi[x,y].d:=-1;
   psi[x,y].l:=psi[us[x,1],us[y,1]].l+1;
   find:=-1;
  end;
  j:=find(us[x,2],us[y,2]);
  if j=-1 then begin
   psi[x,y].fr:=2;
   psi[x,y].d:=-1;
   psi[x,y].l:=psi[us[x,2],us[y,2]].l+1;
   find:=-1;
  end;
  if psi[x,y].d=-1 then begin
   if (i=-1)and(j=-1) then begin
    if psi[us[x,2],us[y,2]].l<psi[us[x,1],us[y,1]].l then w:=2 else w:=1;
    psi[x,y].l:=psi[us[x,w],us[y,w]].l+1;
    psi[x,y].fr:=w;
   end;
   exit;
  end;
  find:=1;
 end;

 procedure solve;
  var i,j:longint;
 begin
  fillchar(worked,sizeof(worked),0);
  fillchar(psi,sizeof(psi),0);
  for i:=1 to n do begin
   for j:=1 to n do begin
    psi[i,j].d:=0;
    if i=j then begin
     psi[i,j].d:=1;
     worked[i,j]:=true;
    end;
    psi[i,j].x1:=us[i,1];
    psi[i,j].y1:=us[j,1];
    psi[i,j].x2:=us[i,2];
    psi[i,j].y2:=us[j,2];
   end;
  end;
  for i:=1 to n do
   for j:=1 to n do
    if psi[i,j].d=0 then begin
     if dop[i]<>dop[j] then begin
      psi[i,j].d:=-1;
      worked[i,j]:=true;
     end;
    end;
  for i:=1 to n do
   for j:=1 to n do
    if psi[i,j].d=0 then psi[i,j].d:=find(i,j);
  for i:=1 to n do
   for j:=1 to n do
    if psi[i,j].d=0 then psi[i,j].d:=1;
 end;

begin
 load;
end.
