  {$I-,Q-,R-,S-}
const
        MaxR = 102;
        MaxC = 102;
        MaxN = 10010;
        MaxM = 1010;
type
        TMM =
        record
          min, max : Byte;
        end;
        TP = ^TT;
        TT =
        record
          n, m : Word;
          next : TP;
        end;
        TQWERTY = Array[-1 .. MaxN + MaxR + 1, -1 .. MaxM + MaxC + 1] of Char;
var
        n, m : LongInt;
        r, c : Byte;
        key : Array[1 .. MaxR] of TMM;
        door : Array[-1 .. MaxN + 2 * MaxR + 1, -1 .. MaxM + 2 * MaxC + 1] of Word;
        d : TQWERTY;
        can : Array[1 .. MaxN + 2 * MaxR + 2, 1 .. 2 * MaxM] of Array[1 .. 3] of Boolean;
        used : Array[1 .. MaxN + 2 * MaxR + 10, 1 .. MaxM + 2 * MaxC + 10] of Boolean;
        bfs, bfs2 : TP;

Procedure Add(var a : TP; const n, m : Word);
var
        t : TP;
begin
  if used[n][m] then
    Exit;
  t := a;
  New(a);
  a^.n := n;
  a^.m := m;
  a^.next := t;
end;

Procedure Init;
var
        i, j : LongInt;
begin
  Assign(input, 'key.in');
  Reset(input);
  ReadLn(r, c);
  for i := 1 to r do
  begin
    key[i].min := 0;
    for j := 1 to c do
    begin
      Read(d[1][1]);
      if d[1][1] = '#' then
      begin
        if key[i].min = 0 then
          key[i].min := j;
        key[i].max := j;
      end;
    end;
    ReadLn;
  end;
  ReadLn(n, m);
  FillChar(d, SizeOf(d), #0);
  FillChar(door, SizeOf(door), 0);
  for i := 1 to n do
  begin
    for j := 1 to m do
      Read(d[i + r + 1][j]);
    ReadLn;
  end;
  n := n + r + 1;
  for i := 1 to n + r + 1 do
    for j := m downto 1 do
      if (d[i][j] = '#') and (i >= c) and (d[i][j] <> #0) then
        door[i][j] := 0
      else
        door[i][j] := door[i][j + 1] + 1;
  Close(input);
end;

Function CanGoLeft(const n, m : Word) : Boolean;
var
        i : Byte;
begin
  for i := 1 to r do
    if door[n + i - 1][m - 1 + key[i].min - 1] < key[i].max - key[i].min + 1 then
    begin
      CanGoLeft := False;
      Exit;
    end;
  CanGoLeft := True;
end;

Function CanGoRight(const n, m : Word) : Boolean;
var
        i : Byte;
begin
  for i := 1 to r do
    if door[n + i - 1][m + key[i].min] < key[i].max - key[i].min + 1 then
    begin
      CanGoRight := False;
      Exit;
    end;
  CanGoRight := True;
end;

Function CanGoDown(const n, m : Word) : Boolean;
var
        i : Byte;
begin
  for i := 1 to r do
    if door[n + i][m - 1 + key[i].min] < key[i].max - key[i].min + 1 then
    begin
      CanGoDown := False;
      Exit;
    end;
  CanGoDown := True;
end;

Procedure Solve;
var
        i, j, rez : Word;
        bo : Boolean;
        t : TP;
begin
  for i := 1 to n + r + 1 do
    for j := 1 to m - c + 1 do
    begin
      can[i][j][1] := CanGoLeft(i, j);
      can[i][j][2] := CanGoRight(i, j);
      can[i][j][3] := CanGoDown(i, j);
    end;
  FillChar(bo, SizeOf(bo), False);
  Add(bfs, 1, 1);
  rez := 0;
  While bfs <> nil do
  begin
    While bfs <> nil do
    begin
      t := bfs;
      bfs := bfs^.next;
      used[t^.n, t^.m] := True;
      if can[t^.n][t^.m][1] then
        Add(bfs, t^.n, t^.m - 1);
      if can[t^.n][t^.m][2] then
        Add(bfs, t^.n, t^.m + 1);
      if can[t^.n][t^.m][3] then
        Add(bfs2, t^.n + 1, t^.m);
      Dispose(t);
    end;
    bfs := bfs2;
    bfs2 := nil;
    Inc(rez);
  end;
  Assign(output, 'key.out');
  Rewrite(output);
  if rez - 2 > n - r then
    WriteLn(-1)
  else
    WriteLn(rez - 2);
  Close(output);
end;

Procedure Print;
begin
end;

begin
  Init;
  Solve;
  Print;
end.
