const
        MaxN = 500;
        MaxF = 30000;
type
        TLong = Array[0 .. MaxN] of LongInt;
        TLongS =
        record
          l : LongInt;
          a : Array[1 .. MaxN] of Char;
        end;
        TDrob =
        record
          n, m : TLong;
        end;
var
        a, b, rez : TDrob;
        y, t, i : LongInt;
        d, w : Array[1 .. MaxF] of TLong;
        c : TLong;

Function Max(const a, b : LongInt) : LongInt;
begin
  if a > b then
    Max := a
  else
    Max := b;
end;

Procedure ReadLong(var s : TLongS);
var
        bo, bo1 : Boolean;
begin
  FillChar(s, SizeOf(s), 0);
  bo := False;
  bo1 := False;
  While not SeekEoLn do
  begin
    Inc(s.l);
    Read(s.a[s.l]);
    if s.a[s.l] = '(' then
      bo := True;
    if s.a[s.l] = '.' then
      bo1 := True;
  end;
  if not bo1 then
  begin
    Inc(s.l);
    s.a[s.l] := '.';
    if bo then
    begin
      s.a[s.l] := '0';
    end;
  end;
  if not bo then
  begin
    Inc(s.l, 3);
    s.a[s.l - 2] := '(';
    s.a[s.l - 1] := '0';
    s.a[s.l] := ')';
  end;
  ReadLn;
end;

Function Mul10(var a, b : TLongS) : Boolean;
var
        pa, pb, i : LongInt;
begin
  pa := 1;
  While a.a[pa] <> '.' do
    Inc(pa);
  pb := 1;
  While b.a[pb] <> '.' do
    Inc(pb);
  if (a.a[pa + 1] = '(') and (b.a[pb + 1] = '(') then
  begin
    Mul10 := False;
    Exit;
  end
  else
  begin
    Mul10 := True;
    if (a.a[pa + 1] <> '(') and (b.a[pb + 1] <> '(') then
    begin
      a.a[pa] := a.a[pa + 1];
      a.a[pa + 1] := '.';
      b.a[pb] := b.a[pb + 1];
      b.a[pb + 1] := '.';
    end;
    if (a.a[pa + 1] <> '(') and (b.a[pb + 1] = '(') then
    begin
      a.a[pa] := a.a[pa + 1];
      a.a[pa + 1] := '.';
      b.a[pb] := b.a[pb + 2];
      b.a[pb + 1] := '.';
      b.a[pb + 2] := '(';
      b.a[b.l] := b.a[pb];
      Inc(b.l);
      b.a[b.l] := ')';
    end;
    if (a.a[pa + 1] = '(') and (b.a[pb + 1] <> '(') then
      Mul10(b, a);
  end;
end;

Procedure mMul10(var a : TLong);
var
        i : LongInt;
begin
  for i := a[0] downto 1 do
    a[i + 1] := a[i];
  a[1] := 0;
  Inc(a[0]);
  While (a[a[0]] = 0) and (a[0] <> 1) do
    Dec(a[0]);
end;

Procedure Div10(var a : TLong);
var
        i : LongInt;
begin
  for i := 1 to a[0] do
    a[i] := a[i + 1];
  a[a[0]] := 0;
  Dec(a[0]);
end;

Function MoreEq(const a, b : TLong) : Boolean;
var
        i : LongInt;
begin
  if a[0] > b[0] then
    MoreEq := True
  else
  begin
    if a[0] < b[0] then
      MoreEq := False
    else
    begin
      MoreEq := True;
      for i := a[0] downto 1 do
      begin
        if a[i] > b[i] then
          Exit;
        if a[i] < b[i] then
        begin
          MoreEq := False;
          Exit;
        end;
      end;
    end;
  end;
end;

Procedure SubLong(var a : TLong; const b : TLong);
var
        i : LongInt;
begin
  for i := 1 to b[0] do
    a[i] := a[i] - b[i];
  for i := 1 to a[0] do
    if a[i] < 0 then
    begin
      Inc(a[i], 10);
      Dec(a[i + 1]);
    end;
  While (a[a[0]] = 0) and (a[0] <> 1) do
    Dec(a[0]);
end;

Procedure SummLong(const a, b : TLong; var rez : TLong);
var
        i : LongInt;
begin
  for i := 1 to Max(a[0], b[0]) do
    rez[i] := a[i] + b[i];
  for i := 1 to b[0] do
    if rez[i] > 9 then
    begin
      Dec(rez[i], 10);
      Inc(rez[i + 1]);
    end;
  rez[0] := Max(a[0], b[0]);
  While rez[rez[0] + 1] <> 0 do
    Inc(rez[0]);
end;

Procedure LongMod(a, b : TLong; var rez : TLong);
var
        e : LongInt;
begin
  e := 0;
  While b[0] < a[0] do
  begin
    mMul10(b);
    Inc(e);
  end;
  While e <> -1 do
  begin
    Dec(e);
    While MoreEq(a, b) do
      SubLong(a, b);
    Div10(b);
  end;
  rez := a;
end;

Procedure LongDiv(a, b : TLong; var rez : TLong);
var
        e, i : LongInt;
        r : TLong;
begin
  e := 0;
  FillChar(r, SizeOf(r), 0);
  While b[0] < a[0] do
  begin
    mMul10(b);
    Inc(e);
  end;
  for i := 0 to e do
  begin
    While MoreEq(a, b) do
    begin
      SubLong(a, b);
      Inc(r[e - i + 1]);
    end;
    Div10(b);
  end;
  r[0] := e + 2;
  While (r[r[0]] = 0) and (r[0] <> 1) do
    Dec(r[0]);
  rez := r;
end;

Procedure LongDivMod(a, b : TLong; var rez, rez2 : TLong);
var
        e, i : LongInt;
        r : TLong;
begin
  e := 0;
  FillChar(r, SizeOf(r), 0);
  While b[0] < a[0] do
  begin
    mMul10(b);
    Inc(e);
  end;
  for i := 0 to e do
  begin
    While MoreEq(a, b) do
    begin
      SubLong(a, b);
      Inc(r[e - i + 1]);
    end;
    Div10(b);
  end;
  r[0] := e + 2;
  While (r[r[0]] = 0) and (r[0] <> 1) do
    Dec(r[0]);
  rez := r;
  rez2 := a;
end;

Procedure MulLong(const a, b : TLong; var rez : TLong);
var
        r : TLong;
        i, j : LongInt;
begin
  FillChar(r, SizeOf(r), 0);
  for i := 1 to a[0] do
    for j := 1 to b[0] do
    begin
      Inc(r[i + j - 1], a[i] * b[j]);
      While r[i + j - 1] > 9 do
      begin
        Dec(r[i + j - 1], 10);
        Inc(r[i + j]);
      end;
    end;
  r[0] := i + j + 2;
  While (r[r[0]] = 0) and (r[0] <> 1) do
    Dec(r[0]);
  rez := r;
end;

Procedure SummDrob(const a, b : TDrob; var rez : TDrob);
var
        r : TLong;
begin
  MulLong(a.n, b.m, r);
  SummLong(r, b.n, rez.n);
  rez.m := b.m;
end;

Procedure MakeDrob(const a : TLongS; var rez : TDrob);
var
        ac, ad : TDrob;
        p, i : LongInt;
begin
  FillChar(ac, SizeOf(ac), 0);
  p := 1;
  While a.a[p + 1] <> '.' do
    Inc(p);
  ac.n[0] := p;
  for i := 1 to p do
    ac.n[p - i + 1] := Ord(a.a[i]) - Ord('0');
  While (ac.n[ac.n[0]] = 0) and (ac.n[0] <> 1) do
    Dec(ac.n[0]);
  ac.m[0] := 1;
  ac.m[1] := 1;
  Inc(p, 3);
  ad.n[0] := a.l - p;
  for i := p to a.l - 1 do
    ad.n[a.l - i] := Ord(a.a[i]) - Ord('0');
  While (ad.n[ad.n[0]] = 0) and (ad.n[0] <> 1) do
    Dec(ad.n[0]);
  ad.m[0] := a.l - p;
  for i := 1 to ad.m[0] do
    ad.m[i] := 9;
  SummDrob(ac, ad, rez);
end;

Procedure ReadDrob(var a, b : TDrob);
var
        sa, sb : TLongS;
begin
  ReadLong(sa);
  ReadLong(sb);
  While Mul10(sa, sb) do;
  MakeDrob(sa, a);
  MakeDrob(sb, b);
end;

Procedure Div2(var a : TLong);
var
        i : LongInt;
begin
  for i := a[0] downto 1 do
  begin
    if a[i] mod 2 = 1 then
      Inc(a[i - 1], 10);
    a[i] := a[i] div 2;
  end;
  While a[a[0]] = 0 do
    Dec(a[0]);
end;

Function Eq0(const a : TLong) : Boolean;
begin
  Eq0 := ((a[0] = 1) and (a[1] = 0)) or (a[0] = 0);
end;

Procedure Mul2(var a : TLong);
var
        i : LongInt;
begin
  for i := a[0] downto 1 do
  begin
    a[i] := a[i] * 2;
    if a[i] > 9 then
    begin
      Dec(a[i], 10);
      Inc(a[i + 1]);
    end;
  end;
  While a[a[0] + 1] <> 0 do
    Inc(a[0]);
end;

Procedure NOD(a, b : TLong; var rez : TLong);
var
        r, i : LongInt;
begin
  FillChar(rez, SizeOf(rez), 0);
  r := 0;
  While (not Eq0(a)) and (not Eq0(b)) do
  begin
    if (a[1] mod 2 = 0) and (b[1] mod 2 = 0) then
    begin
      Div2(a);
      Div2(b);
      Inc(r)
    end
    else
    begin
      if (a[1] mod 2 = 0) and (b[1] mod 2 = 1) then
        Div2(a)
      else
      begin
      if (a[1] mod 2 = 1) and (b[1] mod 2 = 0) then
        Div2(b)
      else
      begin
        if MoreEq(a, b) then
          SubLong(a, b)
        else
          SubLong(b, a);
      end;
      end;
    end;
  end;
  if Eq0(a) then
    rez := b
  else
    rez := a;
  for i := 1 to r do
    Mul2(rez);
end;

Procedure Sokr(var a, b : TLong);
var
        r, c : TLong;
begin
  NOD(a, b, r);
  LongDiv(a, r, c);
  a := c;
  LongDiv(b, r, c);
  b := c;
end;

Procedure WriteLong(const a : TLong);
var
        i : LongInt;
begin
  for i := a[0] downto 1 do
    Write(a[i]);
end;

Function EqLong(const a, b : TLong) : Boolean;
var
        i : LongInt;
begin
  for i := 0 to a[0] do
    if a[i] <> b[i] then
    begin
      EqLong := False;
      Exit;
    end;
  EqLong := True;
end;

Function GenNext : Boolean;
begin
  Inc(y);
  w[y] := rez.n;
  mMul10(rez.n);
  LongDivMod(rez.n, rez.m, d[y], c);
  for i := y - 1 downto 1 do
    if EqLong(w[i], w[y]) then
    begin
      GenNext := False;
      for t := 1 to i - 1 do
        WriteLong(d[t]);
      Write('(');
      for t := i to y - 1 do
        WriteLong(d[t]);
      Write(')');
      Exit;
    end;
  if Eq0(rez.n) then
  begin
    GenNext := False;
    for t := 1 to y - 1 do
      WriteLong(d[t]);
      Exit;
  end;
  rez.n := c;
  GenNext := True;
end;

begin
  Assign(input, 'divide.in');
  Reset(input);
  Assign(output, 'divide.out');
  Rewrite(output);
  ReadDrob(a, b);
  MulLong(a.n, b.m, rez.n);
  MulLong(a.m, b.n, rez.m);
  Sokr(rez.n, rez.m);
  LongDiv(rez.n, rez.m, c);
  WriteLong(c);
  LongMod(rez.n, rez.m, rez.n);
  if not Eq0(rez.n) then
  begin
    Write('.');
    While GenNext do;
  end;
  Close(input);
  Close(output);
end.
