  {$I-,Q-,R-,S-}
const
        MaxP = 1500;
        MaxN = 20;
type
        TLong = Array[0 .. MaxN] of LongInt;
var
        mas : Array[0 .. MaxP] of LongInt;
        per : Array[0 .. MaxP, 0 .. MaxP] of LongInt;
        n, p : LongInt;

Procedure Init;
var
        i, j, k : LongInt;
begin
  ReadLn(n, p);
  for i := 1 to n do
  begin
    Read(j);
    Inc(mas[j mod p]);
  end;
  for i := 0 to p - 1 do
  begin
    k := 1;
    per[i][0] := 1;
    for j := 1 to p - 1 do
    begin
      k := (k * i) mod p;
      per[i][j] := k;
    end;
  end;
end;

Function Max(const a, b : LongInt) : LongInt;
begin
  if a > b then
    Max := a
  else
    Max := b;
end;

Procedure MulLong(const a, b : TLong; var rez : TLong);
var
        r : TLong;
        i, j : LongInt;
begin
  FillChar(r, SizeOf(r), 0);
  for i := 1 to a[0] do
    for j := 1 to b[0] do
    begin
      Inc(r[i + j - 1], a[i] * b[j]);
      While r[i + j - 1] > 9 do
      begin
        Dec(r[i + j - 1], 10);
        Inc(r[i + j]);
      end;
    end;
  r[0] := i + j + 2;
  While (r[r[0]] = 0) and (r[0] <> 1) do
    Dec(r[0]);
  rez := r;
end;

Procedure SumLong(const a, b : TLong; var rez : TLong);
var
        i : LongInt;
begin
  for i := 1 to Max(a[0], b[0]) do
    rez[i] := a[i] + b[i];
  for i := 1 to b[0] do
    if rez[i] > 9 then
    begin
      Dec(rez[i], 10);
      Inc(rez[i + 1]);
    end;
  rez[0] := Max(a[0], b[0]);
  While rez[rez[0] + 1] <> 0 do
    Inc(rez[0]);
end;


Procedure MulShort(var a : TLong; const b : LongInt);
var
        i : LongInt;
begin
  for i := 1 to a[0] do
    a[i] := a[i] * b;
  for i := 1 to a[0] do
  begin
    a[i + 1] := a[i + 1] + a[i] div 10;
    a[i] := a[i] mod 10;
  end;
  While a[a[0] + 1] <> 0 do
  begin
    Inc(a[0]);
    a[a[0] + 1] := a[a[0]] div 10;
    a[a[0]] := a[a[0]] mod 10;
  end;
end;

Function Mul(const a, b, c : LongInt) : TLong;
var
        d : TLong;
begin
  FillChar(d, SizeOf(d), 0);
  d[0] := 1;
  d[1] := 1;
  MulShort(d, a);
  MulShort(d, b);
  MulShort(d, c);
  While (d[d[0]] = 0) and (d[0] <> 1) do
    Dec(d[0]);
  Mul := d;
end;

Procedure Solve;
var
        i, j : LongInt;
        rez, c : TLong;
begin
  FillChar(rez, SizeOf(rez), 0);
  rez[0] := 1;
  rez[1] := 0;
  for i := 0 to p - 1 do
    for j := 0 to p - 1 do
    begin
      if i = j then
      begin
        if i = per[i][i] then
          SumLong(rez, Mul(mas[i], (mas[i] - 1), (mas[i] - 2)), rez)
        else
          SumLong(rez, Mul(mas[i], (mas[i] - 1), (mas[per[i][j]])), rez);
      end
      else
      begin
        if (i = per[i][j]) or (j = per[i][j]) then
          SumLong(rez, Mul(mas[i], mas[j], (mas[per[i][j]] - 1)), rez)
        else
          SumLong(rez, Mul(mas[i], mas[j], mas[per[i][j]]), rez);
      end;
    end;
  While (rez[rez[0]] = 0) and (rez[0] <> 1) do
    Dec(rez[0]);
  for i := rez[0] downto 1 do
    Write(rez[i]);
end;

Procedure Print;
begin
end;

begin
  Assign(input, 'triples.in');
  Reset(input);
  Assign(output, 'triples.out');
  Rewrite(output);
  Init;
  Solve;
  Print;
  Close(input);
  Close(output);
end.