const
        MaxN = 50000;
type
        TPoint =
        record
          x, y : LongInt;
        end;
        TVector =
        record
          x, y : LongInt;
        end;

var
        p : Array[1 .. MaxN] of TPoint;
        n, k, min, max : LongInt;
        s : Real;

Procedure MakeVector(const a, b : TPoint; var v : TVector);
begin
  v.x := b.x - a.x;
  v.y := b.y - a.y;
end;

Function VectorProduct(const v1, v2 : TVector) : LongInt;
begin
  VectorProduct := v1.x * v2.y - v1.y * v2.x;
end;

Procedure Init;
var
        i : LongInt;
        v1, v2 : TVector;
        p0 : TPoint;
begin
  ReadLn(n, k);
  p0.x := 0;
  p0.y := 0;
  for i := 1 to n do
  begin
    ReadLn(p[i].x, p[i].y);
  end;
  min := p[i].x;
  max := min;
  for i := 1 to n do
  begin
    if min > p[i].x then
      min := p[i].x;
    if max < p[i].x then
      max := p[i].x;
  end;
  s := 0;
  for i := 1 to n do
  begin
    MakeVector(p0, p[i], v1);
    MakeVector(p0, p[i mod n + 1], v2);
    s := s + VectorProduct(v1, v2);
  end;
  s := Abs(s) / 2;
end;


Procedure Solve;
var
        r : Extended;
        i : LongInt;
begin
  for i := 1 to k do
  begin
    r := min + (max - min) / k;
    WriteLn(r : 0 : 5)
  end;
end;

Procedure Print;
begin
end;

begin
  Assign(input, 'antiufo.in');
  Reset(input);
  Init;
  Close(input);
  Assign(output, 'antiufo.out');
  Rewrite(output);
  Solve;
  Print;
  Close(output);
end.
