  {$I-,Q-,R-,S-}
const
        MaxN = 250;
        dij : Array[1 .. 8, 1 .. 2] of Integer = ((-1, -1), (-1, 0), (-1, 1), (0, -1), (0, 1), (1, -1), (1, 0), (1, 1));
type
        TPoint =
        record
          x, y : LongInt;
        end;
        TP = ^TT;
        TT =
        record
          c : Word;
          d : Byte;
          e : LongInt;
          next : TP;
        end;
var
        s, t : TPoint;
        w : Array[0 .. MaxN + 1] of TPoint;
        n : LongInt;
        sm : Array[0 .. MaxN + 1, 1 .. 8] of TP;
        bo : Array[0 .. MaxN + 1, 1 .. 8] of Boolean;
        distance : Array[0 .. MaxN + 1, 1 .. 8] of LongInt;

Procedure Init;
var
        i : LongInt;
begin
  ReadLn(s.x, s.y);
  ReadLn(t.x, t.y);
  ReadLn(n);
  w[0] := s;
  w[n + 1] := t;
  for i := 1 to n do
    ReadLn(w[i].x, w[i].y);
end;

Function Max(const a, b : LongInt) : LongInt;
begin
  if a > b then
    Max := a
  else
    Max := b;
end;

Function Dis(const a, b : TPoint) : LongInt;
begin
  Dis := Max(Abs(a.x - b.x), Abs(a.y - b.y));
end;

Function Dist(const a, b : TPoint) : LongInt;
var
        c : TPoint;
        i : Word;
begin
  if Abs(a.x - b.x) > Abs(a.y - b.y) then
  begin
    c.x := a.x + (Ord(a.x < b.x) * 2 - 1) * Abs(a.y - b.y);
    c.y := b.y;
  end
  else
  begin
    c.x := b.x;
    c.y := a.y + (Ord(a.y < b.y) * 2 - 1) * Abs(a.x - b.x);
  end;
  for i := 1 to n do
    if (Dis(a, w[i]) + Dis(w[i], c) = Dis(a, c)) or (Dis(c, w[i]) + Dis(w[i], b) = Dis(b, c)) then
    begin
      Dist := -1;
      Exit;
    end;
  Dist := Dis(a, b);
end;

Procedure Add(const a : Word; const b : Byte; const c : Word; const  d : Byte; const e : LongInt);
var
        t : TP;
begin
  t := sm[a][b];
  New(sm[a][b]);
  sm[a][b]^.c := c;
  sm[a][b]^.d := d;
  sm[a][b]^.e := e;
  sm[a][b]^.next := t;
end;

Procedure Solve;
var
        a, b, c, d : Word;
        e : LongInt;
        p1, p2 : TPoint;
        t : TP;
begin
  for a := 0 to n + 1 do
    for b := 1 to 8 do
      for c := 0 to n + 1 do
        for d := 1 to 8 do
        begin
          if (a > c) or ((a = c) and (b > d)) then
            Break;
          p1.x := w[a].x + dij[b][1];
          p1.y := w[a].y + dij[b][2];
          p2.x := w[c].x + dij[d][1];
          p2.y := w[c].y + dij[d][2];
          e := Dist(p1, p2);
          if e <> -1 then
          begin
            Add(a, b, c, d, e);
            Add(c, d, a, b, e);
          end;
        end;
  FillChar(bo, SizeOf(bo), False);
  for a := 0 to n + 1 do
    for b := 1 to 8 do
      distance[a][b] := MaxLongInt;
  for b := 1 to 8 do
    distance[0][b] := 1;
  While True do
  begin
    c := 0;
    d := 1;
    for a := 0 to n + 1 do
      for b := 1 to 8 do
        if not bo[a][b] then
        begin
          if (bo[c][d]) or (distance[c][d] > distance[a][b]) then
          begin
            c := a;
            d := b;
          end;
        end;
    if bo[c][d] then
      Break;
    bo[c][d] := True;
    t := sm[c][d];
    While t <> nil do
    begin
      if not bo[t^.c, t^.d] then
      begin
        if distance[t^.c, t^.d] > distance[c][d] + t^.e then
        distance[t^.c, t^.d] := distance[c][d] + t^.e;
      end;
      t := t^.next;
    end;
  end;
  b := 1;
  for a := 2 to 8 do
    if distance[n + 1][a] < distance[n + 1][b] then
      b := a;
  if distance[n + 1][b] <> MaxLongInt then
    WriteLn(distance[n + 1][b] + 1)
  else
    WriteLn(-1);
end;

Procedure Print;
begin
end;

begin
  Assign(input, 'king.in');
  Reset(input);
  Init;
  Close(input);
  Assign(output, 'king.out');
  Rewrite(output);
  Solve;
  Print;
  Close(output);
end.
