  {$I-,Q-,R-,S-}
const
        MaxN = 100100;
        MaxK = 11;
type
        TFen = Array[0 .. MaxN] of Int64;
var
        mas, where : Array[1 .. MaxN] of LongInt;
        f : Array[0 .. MaxK + 1] of TFen;
        n, k : LongInt;
        rez : Int64;

Procedure Init;
var
        i : LongInt;
begin
  ReadLn(n, k);
  for i := 1 to n do
  begin
    Read(mas[i]);
    where[mas[i]] := i;
  end;
  FillChar(f, SizeOf(f), 0);
  Inc(k);
end;


Procedure Add(const fen : LongInt; i : LongInt; const d : Int64);
begin
  While i <= n do
  begin
    f[fen][i] := f[fen][i] + d;
    i := i or (i + 1);
  end;
end;

Function Summ(const fen : LongInt; i : LongInt) : Int64;
var
        rez : Int64;
begin
  rez := 0;
  While i > 0 do
  begin
    rez := rez + f[fen][i];
    i := i and (i + 1) - 1;
  end;
  Summ := rez;
end;

Procedure Solve;
var
        i, j : LongInt;
begin
  Add(1, where[1], 1);
  for i := 2 to n do
  begin
    Add(1, where[i], 1);
    for j := 2 to k do
      Add(j, where[i], Summ(j - 1, where[i] - 1));
  end;
  rez := Summ(k, n);
end;

Procedure Print;
begin
  WriteLn(rez);
end;

begin
  Assign(input, 'form.in');
  Reset(input);
  Init;
  Close(input);
  Assign(output, 'form.out');
  Rewrite(output);
  Solve;
  Print;
  Close(output);
end.
