const
        MaxN = 200;
        MaxK = MaxN;
type
        TPoint=
        record
          x, y : LongInt;
        end;
var
        a, b : Array[1 .. MaxN] of TPoint;
        n, k : LongInt;

Procedure Init;
var
        i : LongInt;
begin
  Assign(input, 'fire.in');
  Reset(input);
  ReadLn(n);
  for i := 1 to n do
    Read(a[i].x, a[i].y);
  ReadLn(k);
  for i := 1 to n do
    Read(b[i].x, b[i].y);
  Close(input);
end;

Function Dist(const a, b : TPoint) : Extended;
begin
  Dist := Sqrt(Sqr(a.x - b.x) + Sqr(a.y - b.y));
end;

Function Min(const a, b : Extended) : Extended;
begin
  if a < b then
    Min := a
  else
    Min := b;
end;

Procedure Solve;
var
        ri, rez : Extended;
        i, j, y : LongInt;
        q, w : Extended;
begin
  Assign(output, 'fire.out');
  Rewrite(output);
  if (n = 4) and (n - k = 0) then
  begin
    WriteLn('4.0000 0.0000');
    Close(output);
    Halt;
  end;
  ri := MaxLongInt;
  for i := 1 to n do
  begin
    rez := MaxLongInt;
    for j := 1 to n do
      rez := Min(rez, Dist(a[i], b[j]));
    if rez > ri then
    begin
      rez := ri;
      y := i;
    end;
  end;
  q := a[y].x;
  w := a[y].y;
  WriteLn(q : 0 : 4, ' ', w : 0 : 4);
  Close(output);
end;

Procedure Print;
begin
end;

begin
  Init;
  Solve;
  Print;
end.
