const
        MaxN = 100010;
        MaxC = 1000001000;
        MaxK = 10010;
type
        TR =
        record
          a : Real;
          c : LongInt;
          d : Integer;
        end;
        Real = Extended;
var
        n, k : LongInt;
        mas : Array[1 .. MaxN] of TR;
        mmax : Real;
        y : Array[0 .. MaxK] of Int64;

Procedure Swap(var a, b : TR);
var
        c : TR;
begin
  c := a;
  a := b;
  b := c;
end;

Procedure QSort(const l, r : LongInt);
var
        i, j : LongInt;
        x : Real;
begin
  i := l;
  j := r;
  x := mas[(l + r) div 2].a;
  repeat
    While mas[i].a < x do
      Inc(i);
    While mas[j].a > x do
      Dec(j);
    if i <= j then
    begin
      Swap(mas[i], mas[j]);
      Inc(i);
      Dec(j);
    end;
  until i > j;
  if l < j then
    QSort(l, j);
  if i < r then
    QSort(i, r);
end;

Procedure Init;
var
        i : LongInt;
begin
  Assign(input, 'necklace.in');
  Reset(input);
  ReadLn(n, k);
  mmax := Pi * 2 / k;
  for i := 1 to n do
  begin
    Read(mas[i].a, mas[i].c);
    mas[i].d := Trunc(mas[i].a / mmax);
    mas[i].a := mas[i].a - mmax * mas[i].d;
    While mas[i].a < 0 do
    begin
      mas[i].a := mas[i].a + mmax;
      Dec(mas[i].d);
    end;
    While mas[i].a > mmax do
    begin
      mas[i].a := mas[i].a - mmax;
      Inc(mas[i].d);
    end;
  end;
  QSort(1, n);
  for i := 1 to n do
    Inc(y[mas[i].d], mas[i].c);
end;


{Function Binary_Search(const zn : Real) : LongInt;
var
        min, max : LongInt;
begin
  min := 1;
  max := n;
  While max - min > 1 do
    if a[(min + max) div 2] < zn then
      min := (min + max) div 2
    else
      max := (min + max) div 2;
  if max <> n then
  While a[max + 1] < zn do
  begin
    Inc(max);
    if max = n then
      Break;
  end;
  if max <> 1 then
  begin
    While a[max] > zn do
    begin
      Dec(max);
      if max = 1 then
        Break;
    end;
  end;
  Binary_Search := max;
end;

Function Summm(l : LongInt) : Int64;
var
        rez : Int64;
begin
  rez := 0;
  While l > 0 do
  begin
    Inc(rez, c[l]);
    l := l and (l + 1) - 1;
  end;
  Summm := rez;
end;

Function Summ(const l, r : LongInt) : Int64;
begin
  Summ := Summm(r) - Summm(l - 1);
end;}

Procedure Pereschet(var mmax, mmin : Int64);
var
        i : LongInt;
begin
  mmax := y[0];
  mmin := y[0];
  for i := 1 to k - 1 do
  begin
    if mmax < y[i] then
      mmax := y[i];
    if mmin > y[i] then
      mmin := y[i];
  end;
end;

Procedure Solve;
var
        i : LongInt;
        mmax, mmin : Int64;
        b : Boolean;
        rez : Int64;
begin
  Pereschet(mmax, mmin);
  rez := mmax - mmin;
  for i := 1 to n do
  begin
    b := False;
    if (y[mas[i].d] = mmax) or (y[mas[i].d] = mmin) then
      b := True;
    Dec(y[mas[i].d], mas[i].c);
    mas[i].d := (mas[i].d + 1) mod k;
    Inc(y[mas[i].d], mas[i].c);
    if (y[mas[i].d] = mmax) or (y[mas[i].d] = mmin) then
      b := True;
    if b then
    begin
      Pereschet(mmax, mmin);
    end;
    if rez > mmax - mmin then
      rez := mmax - mmin;
  end;
  Assign(output, 'necklace.out');
  Rewrite(output);
  WriteLn(rez);
  Close(output);
  Close(input);
end;

Procedure Print;
begin
end;

begin
  Init;
  Solve;
  Print;
end.
