const
        MaxN = 1000;
type
        TLong = Array[0 .. MaxN] of Word;
var
        c :
        record
          l : LongInt;
          w : Array[1 .. MaxN] of Word;
        end;
        rez : Array[0 .. MaxN] of Integer;

Procedure Add(const x : Integer);
begin
  Inc(rez[0]);
  rez[rez[0]] := x;
end;

Procedure Init;
var
        i : Char;
begin
  Assign(input, 'commas.in');
  Reset(input);
  Assign(output, 'commas.out');
  Rewrite(output);
  While not SeekEoLn do
  begin
    Inc(c.l);
    Read(i);
    c.w[c.l] := Ord(i) - Ord('0');
  end;
  Close(input);
end;

Function More(l1, r1, l2, r2 : Integer) : Boolean;
begin
  While r1 - l1 > r2 - l2 do
  begin
    if c.w[l1] <> 0 then
    begin
      More := True;
      Exit;
    end;
    Inc(l1);
  end;
  While r1 - l1 < r2 - l2 do
  begin
    if c.w[l2] <> 0 then
    begin
      More := False;
      Exit;
    end;
    Inc(l2);
  end;
  While l1 <= r1 do
  begin
    if c.w[l1] < c.w[l2] then
    begin
      More := False;
      Exit;
    end;
    if c.w[l1] > c.w[l2] then
    begin
      More := True;
      Exit;
    end;
    Inc(l1);
    Inc(l2);
  end;
  More := False;
end;

Function Can(const l, r : Integer) : Boolean;
var
        i : LongInt;
begin
  if l = 1 then
  begin
    Can := True;
    Add(r);
    Exit;
  end;
  if l > r then
  begin
    Can := False;
    Exit;
  end;
  i := l - 1;
  While More(l, r, i, l - 1) do
  begin
    Dec(i);
    if i = 0 then
      Break;
  end;
  Can := Can(i + 1, l - 1);
  if Can then Add(r);
end;

Function Prev(const r : Integer) : Integer;
var
        i : Integer;
begin
  for i := r downto 1 do
    if Can(i, r) then
    begin
      Prev := i - 1;
      Exit;
    end;
end;

Procedure Solve;
var
        i, j, l, o : LongInt;
begin
  if c.l = 0 then
  begin
    WriteLn;
    Close(output);
    Halt;
  end;
  FillChar(rez, SizeOf(rez), False);
  l := Prev(c.l);
  o := rez[0];
  rez[0] := 1;
  for j := 1 to o do
  for i := 1 to o - 2 do
    While More(rez[i] + 2, rez[i + 1], rez[i - 1], rez[i] + 1) do
      Inc(rez[i]);
  j := 1;
  for i := 1 to c.l do
  begin
    Write(c.w[i]);
    if (i <> c.l) and (rez[j] = i) then
    begin
      Write(',');
      Inc(j);
    end;
  end;
  Close(output);
end;

Procedure Print;
begin
end;

begin
  Init;
  Solve;
  Print;
end.
