{$Q-,R-,S-,I-}

const maxn = 5000;
      big = 200000;

label 1;

type real = double;

var n, i, j: longint;
    l, l2, x: array [1..maxn] of real;
    prot: boolean;
    xans, yans, x1, x2, xb, xe: real;

function dist (const x1, y1, x2, y2: real): real;
begin
  dist := sqrt (sqr (x2 - x1) + sqr (y2 - y1));
end;

procedure swap (var a, b: longint);
var c: longint;
begin
  c := a;
  a := b;
  b := c;
end;

function cross (a, b: longint; var x1, x2: real): boolean;
var x0: real;
    sw: boolean;
begin
  sw := false;
  if x [a] - x [b] > 0 then
  begin
    swap (a, b);
    sw := true;
  end;
  if x [b] - l [b] - x [a] - l [a] >= 0 then
  begin
    cross := false;
    prot := true;
    exit;
  end;
  if x [a] + l [a] - x [b] - l [b] >= 0 then
    if sw then
    begin
      cross := true;
      x1 := x [b] - l [b];
      x2 := x [b] + l [b];
      exit;
    end else
    begin
      cross := false;
      exit;
    end;
  if x [a] - l [a] - (x [b] - l [b]) >= 0 then
    if not sw then
    begin
      cross := true;
      x1 := x [a] - l [a];
      x2 := x [a] + l [a];
      exit;
    end else
    begin
      cross := false;
      exit;
    end;
  x0 := ((l2 [b] - l2 [a]) / (x [a] - x [b]) + x [a] + x [b]) / 2;
  cross := true;
  if sw then
  begin
    x1 := x [b] - l [b];
    x2 := x0;
  end else
  begin
    x1 := x0;
    x2 := x [b] + l [b];
  end;
end;

begin
  assign (input, 'popular.in');
  reset (input);
  assign (output, 'popular.out');
  rewrite (output);
  read (n);
  for i := 1 to n do
  begin
    read (x [i], l [i]);
    l2 [i] := sqr (l [i]);
  end;
  prot :=false;
  for i := 1 to n do
  begin
    xb := -big;
    xe := big;
    for j := 1 to n do
    begin
      if i = j then continue;
      if cross (i, j, x1, x2) then
      begin
        if x1 - xb > 0 then xb := x1;
        if x2 - xe < 0 then xe := x2;
      end else
      if prot then goto 1;
    end;
    if xe - xb < 0 then continue;
    if x [i] - xe > 0 then
    begin
      xans := xe;
      yans := - sqrt (l2 [i] - sqr (xans - x [i]));
      goto 1;
    end;
    if x [i] - xb < 0 then
    begin
      xans := xb;
      yans := - sqrt (l2 [i] - sqr (xans - x [i]));
      goto 1;
    end;
    if (x [i] - xb) * (x [i] - xe) <= 0 then
    begin
      xans := x [i];
      yans := - l [i];
      goto 1;
    end;
  end;
1:
  if prot then writeln ('-1 -1') else
  writeln (xans:0:4, ' ', yans:0:4);
  close (input);
  close (output);
end.
