//{$Q-,R-,I-,S-}
const n=41; m=45;
var
  mat :array [1..n,1..m] of char;
  c   :array [1..n,1..m] of boolean;
  qx,qy :array [0..n*m] of longint;
  k :array [char] of longint;
  t :longint;

function  EMPTY      :boolean; begin EMPTY := (0=t); end;
procedure incr (var l:longint);begin l:=(l+1)  mod(n*m+1); end;
procedure decr (var l:longint);begin l:=(l+n*m)mod(n*m+1); end;
procedure PUSH (x,y :longint);
begin if c[x,y] then exit; inc(t); qx[t]:=x; qy[t]:=y; c[x,y]:=true; end;
procedure POP (var x,y :longint);
begin if EMPTY then exit; x:=qx[t]; y:=qy[t]; dec(t); end;

procedure dfs (x,y :longint; f :boolean; ch :char);
  procedure check (x,y :longint);
  begin
    if x<1 then exit;
    if y<1 then exit;
    if x>n then exit;
    if y>m then exit;
    if mat[x,y]=ch then PUSH(x,y) else
      if f then dfs(x,y,false,mat[x,y]);
  end;
begin
  PUSH(x,y);
  while not EMPTY do
    begin
      POP(x,y);
      if mat[x,y]<>ch then
        begin
          PUSH(x,y);
          exit;
        end;
      inc(k[ch]);
      check (x+1,y);
      check (x,y+1);
      check (x-1,y);
      check (x,y-1);
    end;
end;


var
  f1,f2 :text;
  i,j :longint;
  ch,chh :char;

begin
  assign(f1,'filya.in'); assign(f2,'filya.out');
  reset(f1); rewrite(f2);
    for i := 1 to n do
      begin
        for j := 1 to m do
          read(f1,mat[i,j]);
        readln(f1);
      end;
    dfs(1,1,true,mat[1,1]);
    for ch := #0 to #255 do
      if not (ch in ['1'..'6']) then
       k[ch]:=-1;
    chh:=#0;
    for ch := #0 to #255 do
      if ch<>mat[1,1] then
        if ch<>mat[n,m] then
          if k[ch]>k[chh] then
            chh:=ch;
    writeln(f2,chh);
  close(f1); close(f2);
end.
