{$M 55000000,1024}{$S-,R-,I-,Q-}
type rule = array [0..2] of char;
var
  chn :char;
  rul :array [1..150] of rule; m :longint;
  eq  :array [char,char] of boolean;
  chs :array [char] of byte;
  pr  :array [char,0..150] of char;

procedure addrule (s :string; c :char);
var i :longint;
begin
//{$} write ('Next rule: ',s,'->',c,' (');
  for i := 1 to length(s)-1 do
    begin
      chn:=succ(chn);
      inc(m);
      rul[m,0]:=chn;
      rul[m,1]:=s[i];
      rul[m,2]:=s[i+1];
      s[i+1]:=chn;
      chs[chn]:=m;
//{$} write (rul[m,1],rul[m,2],'->',rul[m,0],', ');
    end;

  eq[s[length(s)],c]:=true;
  pr[c,0]:=succ(pr[c,0]);
  pr[c,ord(pr[c,0])]:=s[length(s)];
//{$} writeln (s[length(s)],'->',c,')');
end;

var
  mat :array [1..150,1..150,char] of byte;
  s   :string;

function letter (a,b :byte; ch :char; f :boolean) :byte;
var r :byte;
  function let :byte;
  var i,j :integer; c :char;
  begin
    if a=b then
      begin
        let:=ord(eq[s[a],ch]);
        exit;
      end;
    if f then
      begin
        let:=1;
        for i := 1 to ord(pr[ch,0]) do
          if letter(a,b,pr[ch,i],false)>0 then
            exit;
        let:=0;
        exit;
      end;
    let:=1;
    if chs[ch]<>0 then
      for j := chs[ch] to chs[ch] do
        for i := a to b-1 do
          if   letter(a,i,  rul[j,1],true)>0 then
            if letter(i+1,b,rul[j,2],true)>0 then
              exit;
    let:=0;
  end;
begin
  if mat[a,b,ch]<>255 then begin letter := mat[a,b,ch]; exit; end;
  r:=let;
  mat[a,b,ch]:=r;
  letter:=r;

//{$} if (ch<='C')or(ch>'Z') then
//{$} if mat[a,b,ch]=1 then
//{$} writeln ('Prod ',copy(s,a,b-a+1),'->',ch,' is ',r);
end;

procedure Init;
begin
  for chn := 'A' to #255 do
    begin
      eq[chn,chn]:=true;
      pr[chn,0]:=#1;
      pr[chn,1]:=chn;
    end;
  chn:=succ('Z');

  fillchar(mat,sizeof(mat),255);
end;

var
  f1,f2 :text;
  mm :longint;
  ss :string; ch :char;

begin
  Init;
  assign(f1,'game.in');
  assign(f2,'game.out');
  reset(f1); rewrite(f2);

    readln(f1,s);
    readln(f1,mm);
    while mm>0 do
      begin
        ss:='';
        repeat
          read(f1,ch);
          ss:=ss+ch;
        until ch=' ';
        delete (ss,length(ss),1);
        readln(f1,ch);
        addrule (ss,ch);
        dec(mm);
      end;
    for ch := 'A' to 'Z' do
//{$}   begin
      if letter (1,length(s),ch,true)>0 then
        begin
          write(f2,ch);
//{$}       readln;
        end;
//{$}   readln; end;
    writeln(f2);

  close(f1); close(f2);
end.
