#include <cstdio>
#include <algorithm>
#include <vector>

using namespace std;


int n_guys,n_cells,c_guys_left;
vector<long> mtrx_cont; vector<long*> mtrx;
vector<long> sorted_cont; vector<long*> sorted;
vector<char> locks_cont; vector<char*> locks;
vector<int> is_sorted; vector<int> cs_locks;
vector<char> marks;
vector<int> seq;
int f_ok;

int main(void) {
  #ifndef OFFLINE
  freopen("chat.in","rt",stdin);
  freopen("chat.out","wt",stdout);
  #endif
  for (scanf("%d",&n_guys); n_guys>0; scanf("%d",&n_guys)) {
    int i_guy,i_guy_to,i_guy_on;
    n_cells=n_guys*n_guys;
    mtrx_cont.resize(n_cells); mtrx.resize(n_guys);
    sorted_cont.resize(n_cells); sorted.resize(n_guys);
    locks_cont.clear(); cs_locks.clear();
    locks_cont.resize(n_cells); locks.resize(n_guys);
    is_sorted.resize(n_guys); cs_locks.resize(n_guys);
    marks.clear(); seq.clear();
    marks.resize(n_guys); seq.reserve(n_guys);
    for (i_guy=0,i_guy_to=0; i_guy<n_guys; ++i_guy,i_guy_to+=n_guys) {
      mtrx[i_guy]=&mtrx_cont[i_guy_to];
      sorted[i_guy]=&sorted_cont[i_guy_to];
      locks[i_guy]=&locks_cont[i_guy_to];
    }
    for (i_guy=0; i_guy<n_guys; ++i_guy)
     for (i_guy_to=0; i_guy_to<n_guys; ++i_guy_to) {
      scanf("%ld",&mtrx[i_guy][i_guy_to]);
      sorted[i_guy_to][i_guy]=mtrx[i_guy][i_guy_to];
    }
    for (i_guy_to=0; i_guy_to<n_guys; ++i_guy_to) {
      sort(sorted[i_guy_to],sorted[i_guy_to]+n_guys);
      is_sorted[i_guy_to]=1;
    }
    for (i_guy=0; i_guy<n_guys; ++i_guy)
     for (i_guy_to=0; i_guy_to<n_guys; ++i_guy_to) if (i_guy_to!=i_guy)
     if (mtrx[i_guy][i_guy_to]>sorted[i_guy_to][is_sorted[i_guy_to]]) {
      locks[i_guy][i_guy_to]=1;
      ++cs_locks[i_guy];
    }
    f_ok=1;
    for (c_guys_left=n_guys; c_guys_left>0; --c_guys_left) {
      for (i_guy=0; i_guy<n_guys; ++i_guy) if (!marks[i_guy]) {
        if (cs_locks[i_guy]>0) continue;
        if (sorted[i_guy][is_sorted[i_guy]]==sorted[i_guy][n_guys-1])
          break;
      }
      if (i_guy>=n_guys) { f_ok=0; break; }
      marks[i_guy]=1; seq.push_back(i_guy);
      for (i_guy_to=0; i_guy_to<n_guys; ++i_guy_to) if (i_guy_to!=i_guy) {
        ++is_sorted[i_guy_to];
        for (i_guy_on=0; i_guy_on<n_guys; ++i_guy_on) if (!marks[i_guy_on])
         if (locks[i_guy_on][i_guy_to])
         if (mtrx[i_guy_on][i_guy_to]<=sorted[i_guy_to][is_sorted[i_guy_to]]) {
          locks[i_guy_on][i_guy_to]=0;
          --cs_locks[i_guy_on];
        }
      }
    }
    if (f_ok) {
      vector<int>::iterator p_seq;
      for (p_seq=seq.begin(); p_seq!=seq.end(); ++p_seq) {
        if (p_seq!=seq.begin()) printf(" ");
        printf("%d",(*p_seq)+1);
      } printf("\n");
    } else printf("-1\n");
  }
  #ifndef OFFLINE
  fclose(stdin);
  fclose(stdout);
  #endif
  return(0);
}


