#include <cstdio>
#include <functional>
#include <string>
#include <vector>

using namespace std;

vector<char> string_buf(255);


struct t_token {
  char type;
  int val;
};

int n_toks,n_pairs,n_vals,n_cells,c_vals_out; int val_bnd,val_size;
string str;
vector<t_token> toks;
vector<int> ns_vals_cont; vector<int*> ns_vals;
vector<char> marks_cont_0; vector<char*> marks_cont_1; vector<char**> marks;

inline void proc(int v,int w,int v_0,int w_0,int v_1,int w_1,char type) {
  int n_vals_0,n_vals_1,i_val,i_val_0,i_val_1,val,val_0,val_1;
  n_vals_0=ns_vals[v_0][w_0]; n_vals_1=ns_vals[v_1][w_1];
  for (i_val_0=0; i_val_0<n_vals_0; ++i_val_0)
  if (marks[v_0][w_0][i_val_0]) {
    for (i_val_1=0; i_val_1<n_vals_1; ++i_val_1)
    if (marks[v_1][w_1][i_val_1]) {
      val_0=(i_val_0&1?~i_val_0:i_val_0)>>1;
      val_1=(i_val_1&1?~i_val_1:i_val_1)>>1;
      if (type<0) val=val_0-val_1; else val=val_0+val_1;
      i_val=(val<0)?(~(val<<1)):(val<<1);
      marks[v][w][i_val]=1;
    }
  }
}

int main(void) {
  #ifndef OFFLINE
  freopen("expr.in","rt",stdin);
  freopen("expr.out","wt",stdout);
  #endif
  int i_tok,i_tok_to,i_tok_by,c_toks_width,i_val; char type;
  scanf("%s",&string_buf.front());
  toks.resize(n_toks=(str=&string_buf.front()).length());
  val_bnd=0;
  for (i_tok=0; i_tok<n_toks; ++i_tok) switch (str[i_tok]) {
    case '+': toks[i_tok].type=+1; toks[i_tok].val=-1; break;
    case '-': toks[i_tok].type=-1; toks[i_tok].val=-1; break;
    default: toks[i_tok].type=0;
      toks[i_tok].val=static_cast<int>(str[i_tok]-'0');
      if (toks[i_tok].val<0) toks[i_tok].val=0;
      if (val_bnd<toks[i_tok].val) val_bnd=toks[i_tok].val;
  }
  val_size=(val_bnd<<1)+1;
  n_cells=(n_pairs=(n_toks+1)*(n_toks+1))*(n_vals=n_toks*val_size);
  ns_vals_cont.resize(n_pairs); ns_vals.resize(n_toks+1);
  marks_cont_0.resize(n_cells); marks_cont_1.resize(n_pairs);
  marks.resize(n_toks+1);
  for (i_tok_to=0,i_val=0; i_tok_to<n_pairs; ++i_tok_to,i_val+=n_vals)
    marks_cont_1[i_tok_to]=&marks_cont_0[i_val];
  for (i_tok=0,i_tok_to=0; i_tok<=n_toks; ++i_tok,i_tok_to+=n_toks+1) {
    ns_vals[i_tok]=&ns_vals_cont[i_tok_to];
    marks[i_tok]=&marks_cont_1[i_tok_to];
  }
  for (i_tok=0; i_tok<n_toks; ++i_tok)
   for (++(i_tok_to=i_tok); i_tok_to<=n_toks; ++i_tok_to) {
    for (i_tok_by=i_tok; i_tok_by<i_tok_to; ++i_tok_by)
     if (!toks[i_tok_by].type)
      ns_vals[i_tok][i_tok_to]+=toks[i_tok_by].val;
    ns_vals[i_tok][i_tok_to]=(ns_vals[i_tok][i_tok_to]<<1)+1;
  }
  for (i_tok=0; i_tok<n_toks; ++i_tok) if (!toks[i_tok].type)
    marks[i_tok][i_tok+1][toks[i_tok].val<<1]=1;
  for (c_toks_width=3; c_toks_width<=n_toks; ++c_toks_width)
   for (i_tok=0,i_tok_to=c_toks_width; i_tok_to<=n_toks; ++i_tok,++i_tok_to) {
    if ((type=toks[i_tok].type))
     for (++(i_tok_by=i_tok+1); i_tok_by<i_tok_to; ++i_tok_by)
      proc(i_tok,i_tok_to,i_tok+1,i_tok_by,i_tok_by,i_tok_to,type);
    if ((type=toks[i_tok_to-1].type))
     for (++(i_tok_by=i_tok); i_tok_by<i_tok_to-1; ++i_tok_by)
      proc(i_tok,i_tok_to,i_tok,i_tok_by,i_tok_by,i_tok_to-1,type);
    for (++(i_tok_by=i_tok); i_tok_by<i_tok_to-1; ++i_tok_by)
     if ((type=toks[i_tok_by].type))
      proc(i_tok,i_tok_to,i_tok,i_tok_by,i_tok_by+1,i_tok_to,type);
    #ifdef DEBUG
    printf("%d %d %s ",i_tok,i_tok_to,
      str.substr(i_tok,i_tok_to-i_tok).c_str());
    for (i_val=0; i_val<n_vals; ++i_val) if (marks[i_tok][i_tok_to][i_val])
      printf(" %d",(i_val&1?~i_val:i_val)>>1);
    printf("\n");
    #endif
  }
  c_vals_out=0;
  for (i_val=0; i_val<n_vals; ++i_val) if (marks[0][n_toks][i_val])
    ++c_vals_out;
  printf("%d\n",c_vals_out);
  #ifndef OFFLINE
  fclose(stdin);
  fclose(stdout);
  #endif
  return(0);
}


