
{$IFDEF NORMAL}
  {$I-,Q-,R-,S-}
{$ENDIF NORMAL}
{$IFDEF DEBUG}
  {$I+,Q+,R+,S-}
{$ENDIF DEBUG}
{$IFDEF RELEASE}
  {$I-,Q-,R-,S-}
{$ENDIF RELEASE}
program gdsfgds;
const eps = 1e-9;
var n:longint;
    l,x:array[1..5010] of extended;


procedure load;
var i:longint;
begin
    read(n);
    for i:=  1to n do read(x[i],l[i]);
end;

function wrongtest(xx,yy:extended):boolean;
const q=30;
var i,j:longint;
begin
    for i:= 1 to q do begin
        j:=random(54333) mod n +1;
        if sqr(x[j]-xx)+yy*yy-l[j]*l[j]>eps then begin
            wrongtest:=true;
            exit;
        end;
    end;
    wrongtest:=false;
end;

procedure solve;
var xx,yy,p,s,a,b,c:extended;
    i,j,mi:longint;
begin
    mi:=n;
    xx:=-1;yy:=-1;
    for i:= 1 to n-1 do begin
        if l[i]<l[mi] then mi:=i;
    end;
    for i:= 1 to n-1 do begin
        for j:= i+1 to n do begin
            if abs(x[i]-x[j])>l[i]+l[j] then begin
                write('-1 -1');
                exit;
            end;
            a:=l[i];b:=l[j];c:=abs(x[i]-x[j]);
            if (a>b+c)or(b>c+a)or(c>a+b)or(c<eps) then continue;
            p:=(a+b+c)/2;
            s:=sqrt((p)*(p-a)*(p-b)*(p-c));
            s:=2*s/c;
            if a>b  then begin
                p:=x[i]+(x[j]-x[i])/c*sqrt(a*a-s*s);
                if abs(x[j]-x[i])/c*sqrt(a*a-s*s)>abs(x[i]-x[j]) then continue;
            end
            else begin
                p:=x[j]+(x[i]-x[j])/c*sqrt(b*b-s*s);
                if abs(x[j]-x[i])/c*sqrt(b*b-s*s)>abs(x[i]-x[j]) then continue;
            end;
            //if wrongtest(p,-s) then continue;
            if ((xx=-1)and(yy=-1))or(yy<-s) then begin
            xx:=p;yy:=-s;
            end;
        end;
    end;
    s:=0;
            for i:= 1 to n do
                if sqr(x[i]-xx)+yy*yy-sqr(l[i])>eps then s:=1;
        if (xx=-1)and(yy=-1)or(s>0.5) then begin
            xx:=x[mi];yy:=-l[mi]
        end;
        if (xx<>-1)or(yy<>-1) then begin
            s:=0;
            for i:= 1 to n do
                if sqr(x[i]-xx)+yy*yy-sqr(l[i])>eps then s:=1;
            if s<0.5 then write(xx:0:4,' ',yy:0:4)
            else write('-1 -1');
        end;
end;
procedure save;
begin

end;


begin
    assign(input,'popular.in');
    assign(output,'popular.out');
    reset(input);
    rewrite(output);
    load;
    solve;
    save;
    close(input);
    close(output);
end.
