program task2dfwdsf;
{$Q+,R+,S+}

const eps=1e-10;

var
    f,pk:extended;
    c,id:array[0..101000] of longint;
    sum:array[0..10010] of inT64;
    a,d:array[0..101000] of extended;
    n,k:longint;
    cur,best:int64;
    min,max:longint;


function mod2pdk(x:extended):extended;
begin
    mod2pdk:=x-trunc(x/pk)*pk;
end;

procedure load;
var i:longint;
begin
    min:=1;
    max:=1;
    read(n,k);
    pk:=2*pi/k;
    f:=random*pk;
    for i:= 1 to n do begin
        read(a[i],c[i]);
        if f<a[i] then
            d[i]:=mod2pdk(f-a[i]+2*pi)
        else
            d[i]:=mod2pdk(f-a[i]);
        id[i]:=(trunc((f-a[i])/pk)+k)mod k;
         sum[id[i]]:=sum[id[i]]+c[i];
        if sum[id[i]]<sum[min] then min:=id[i];
        if sum[id[i]]>sum[max] then max:=id[i];
    end;
end;


procedure qsort(l,r:longint);
var x,t:extended;
    i,j,tt:longint;
begin
     x:=d[random(r-l+1)+l];
     i:=l;j:=r;
     while i<j do begin
           while d[i]<x do inc(i);
           while d[j]>x do dec(j);
           if i<=j then begin
              t:=d[i];d[i]:=d[j];d[j]:=t;
              t:=a[i];a[i]:=a[j];a[j]:=t;
              tt:=id[i];id[i]:=id[j];id[j]:=tt;
              tt:=c[i];c[i]:=c[j];c[j]:=tt;
              inc(i);dec(j);
           end;
     end;
     if l<j then qsort(l,j);
     if i<r then qsort(i,r);
end;

procedure solve;
var i,j,h,flag:longint;
begin
     qsort(1,n);
     d[n+1]:=-100000;
     best:=-1;
     j:=1;
     for i:= 1 to n do if abs(d[i]-d[i+1])>eps then begin
         flag:=0;
         for h:= j to i do begin
             if id[h]=max then flag:=1;
             dec(sum[id[h]],c[i]);
             if flag=0 then begin
                if sum[id[h]]<sum[min] then min:=id[h];
             end;
             id[h]:=(id[h]+1)mod k;
             if id[h]=min then flag:=1;
             if flag=0 then begin
                if sum[id[h]]>sum[max] then max:=id[h];
             end;
             inc(sum[id[h]],c[i]);
         end;
         if flag=1 then begin
            for h:= 0 to k-1 do begin
                if sum[h]>sum[max] then max:=h;
                if sum[h]<sum[min] then min:=h;
            end;
         end;
         cur:=sum[max]-sum[min];
         if (best=-1)or(cur<best)then best:=cur;
         j:=i+1;
     end;
     write(best);
end;



begin
    assign(input,'necklace.in');
    assign(output,'necklace.out');
    reset(input);
    rewrite(output);
    load;
    solve;
    close(input);
    close(output);
end.
