#include <stdio.h>
#include <string.h>
#include <math.h>

#define m 52
#define inf 1e100
#define eps 1e-8
#define sqr(x) ((x) * (x))

int x[m], y[m], n, is[m];
double r[m], u, v;

int main( void )
{
  int i, j, mi;

  freopen("tractor.in", "rt", stdin);
  freopen("tractor.out", "wt", stdout);
  scanf("%d%lf%lf", &n, &u, &v);
  for (i = 0; i <= n; i++)
    scanf("%d%d", &x[i], &y[i]);
  r[0] = 0;
  for (i = 1; i <= n; i++)
    r[i] = inf;
  memset(is, 0, sizeof(is));
  while (1)
  {
    for (j = 0, mi = -1; j <= n; j++)
      if (!is[j] && (mi == -1 || r[mi] > r[j]))
        mi = j;
    if (mi == -1)
      break;
    is[mi] = 1;
    if (mi < n && r[mi + 1] - eps > r[mi] + sqrt(sqr(x[mi] - x[mi + 1]) + sqr(y[mi] - y[mi + 1])) / v)
      r[mi + 1] = r[mi] + sqrt(sqr(x[mi] - x[mi + 1]) + sqr(y[mi] - y[mi + 1])) / v;
    if (mi > 0 && r[mi - 1] - eps > r[mi] + sqrt(sqr(x[mi] - x[mi - 1]) + sqr(y[mi] - y[mi - 1])) / v)
      r[mi - 1] = r[mi] + sqrt(sqr(x[mi] - x[mi - 1]) + sqr(y[mi] - y[mi - 1])) / v;
    for (i = 0; i <= n; i++)
      if (r[i] - eps > r[mi] + sqrt(sqr(x[mi] - x[i]) + sqr(y[mi] - y[i])) / u)
        r[i] = r[mi] + sqrt(sqr(x[mi] - x[i]) + sqr(y[mi] - y[i])) / u;
  }
  printf("%.8lf", r[n]);
  return 0;
}
