#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define m 41
#define mm 45

char a[m][mm + 1];
int u[m][mm];

int calc( int i, int j, char c )
{
  int r;

  if (i < 0 || i >= m || j < 0 || j >= mm || u[i][j] || a[i][j] != c)
    return 0;
  u[i][j] = 1;
  r = 1 + calc(i - 1, j, c) + calc(i + 1, j, c) +
          calc(i, j - 1, c) + calc(i, j + 1, c);
}

void color( int i, int j, char c, char cc )
{
  if (i < 0 || i >= m || j < 0 || j >= mm || u[i][j] || a[i][j] != c)
    return;
  u[i][j] = 1, a[i][j] = cc;
  color(i - 1, j, c, cc), color(i + 1, j, c, cc);
  color(i, j - 1, c, cc), color(i, j + 1, c, cc);
}

int num( int i, int j, char c, char cc )
{
  int r;
  
  if (i < 0 || i >= m || j < 0 || j >= mm || u[i][j] || (a[i][j] != c && a[i][j] != cc))
    return;
  u[i][j] = 1, r = a[i][j] == cc;
  return r + num(i - 1, j, c, cc) + num(i + 1, j, c, cc) +
             num(i, j - 1, c, cc) + num(i, j + 1, c, cc);
}

int dfs( int dep, int pl, int *mo )
{
  int i, j, be, bv, t[m][mm], tt, c;

  if (dep > 2)
  {
    memset(u, 0, sizeof(u));
    i = calc(0, 0, a[0][0]);
    memset(u, 0, sizeof(u));
    j = calc(m - 1, mm - 1, a[m - 1][mm - 1]);
    if (pl == 0)
      return i - j;
    return j - i;
  }
  if (pl == 0)
  {
    memcpy(t, a, sizeof(a));
    for (i = 1, be = -1, bv = -1000; i <= 2; i++)
    {
      c = (rand() % 6) + 1;
      if (c == a[0][0] || c == a[m - 1][mm - 1])
      {
        i--;
        continue;
      }
      memcpy(a, t, sizeof(a));
      memset(u, 0, sizeof(u));
      /*
      if (num(0, 0, a[0][0], i) == 0)
      {
        i -= rand() & 1;
        continue;
      }
      */
      memset(u, 0, sizeof(u));
      color(0, 0, a[0][0], c);
      j = -dfs(dep + 1, 1, &tt);
      if (j > bv)
        bv = j, be = c;
    }
    *mo = be;
    return bv;
  }
  else
  {
    memcpy(t, a, sizeof(a));
    for (i = 1, be = -1, bv = -1000; i <= 2; i++)
    {
      c = (rand() % 6) + 1;
      if (c == a[0][0] || c == a[m - 1][mm - 1])
      {
        i--;
        continue;
      }
      memcpy(a, t, sizeof(a));
      memset(u, 0, sizeof(u));
      /*
      if (num(m - 1, mm - 1, a[m - 1][mm - 1], i) == 0)
      {
        i -= rand() & 1;
        continue;
      }
      */
      memset(u, 0, sizeof(u));
      color(m - 1, mm - 1, a[m - 1][mm - 1], i);
      j = -dfs(dep + 1, 0, &tt);
      if (j > bv)
        bv = j, be = c;
    }
    *mo = be;
    return bv;
  }
}

int main( void )
{
  int i, j;

  freopen("filya.in", "rt", stdin);
  freopen("filya.out", "wt", stdout);
  for (i = 0; i < m; i++)
    scanf("%s", a[i]);
  srand(a[0][0] * a[m - 1][mm - 1] + a[m / 2][mm / 2]);
  for (i = 0; i < m; i++)
    for (j = 0; j < mm; j++)
      a[i][j] -= '0';
  dfs(0, 0, &i);
  printf("%d", i);
  return 0;
}
