#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define m 510
#define mm 1010
#define min(a, b) ((a) < (b) ? (a) : (b))
#define max(a, b) ((a) > (b) ? (a) : (b))

int *r[mm], *u[mm], *f[mm], x0, y0, x1, y1, minx, miny, maxx, maxy, x[m], y[m], n;
int mem[mm * mm * 3], mla = 0, q[mm * mm][2], fi, la;

int *all( int s )
{
  mla += s;
  return &mem[mla - s];
}

void add( int x, int y, int rr )
{
  if (x < 0 || y < 0 || x > maxx || y > maxy || u[x][y] || f[x][y])
    return;
  u[x][y] = 1, r[x][y] = rr, q[la][0] = x, q[la++][1] = y;
}

int main( void )
{
  int i, j, rr;

  freopen("king.in", "rt", stdin);
  freopen("king.out", "wt", stdout);
  scanf("%d%d%d%d%d", &x0, &y0, &x1, &y1, &n);
  for (i = 0; i < n; i++)
    scanf("%d%d", &x[i], &y[i]);
  memset(u, 0, sizeof(u));
  minx = min(x0, x1), maxx = max(x0, x1);
  miny = min(y0, y1), maxy = max(y0, y1);
  for (i = 0; i < n; i++)
  {
    minx = min(minx, x[i]), maxx = max(maxx, x[i]);
    miny = min(miny, y[i]), maxy = max(maxy, y[i]);
  }
  if (n == 0)
    printf("%d", max(abs(x0 - x1), abs(y0 - y1))), exit(0);
  if ((maxx - minx + 2) * (maxy - miny + 2) > mm * mm)
    printf("-1"), exit(0);
  maxx -= minx - 2, maxy -= miny - 2;
  for (i = 0; i < n; i++)
    x[i] -= minx - 2, y[i] -= miny - 2;
  x0 -= minx - 2, y0 -= miny - 2;
  x1 -= minx - 2, y1 -= miny - 2;
  memset(mem, 0, sizeof(mem));
  for (i = 0; i <= maxx + 1; i++)
  {
    r[i] = all(maxy + 2);
    u[i] = all(maxy + 2);
    f[i] = all(maxy + 2);
  }
  for (i = 0; i < n; i++)
    f[x[i]][y[i]] = 1;
  u[x0][y0] = 1, r[x0][y0] = 0;
  q[0][0] = x0, q[0][1] = y0;
  fi = 0, la = 1;
  while (fi < la)
  {
    x0 = q[fi][0], y0 = q[fi++][1], rr = r[x0][y0];
    for (i = -1; i <= 1; i++)
      for (j = -1; j <= 1; j++)
        if (i || j)
          add(x0 + i, y0 + j, rr + 1);
  }
  if (!u[x1][y1])
    printf("-1");
  else
    printf("%d", r[x1][y1]);
  return 0;
}
