#include <stdio.h>
#include <string.h>

#define m 100010

typedef unsigned long long llong;

int n, k, b[m];
llong a[12][m];

void set( llong *a, int i, llong d )
{
  for (; i < m; i |= i + 1)
    a[i] += d;
}

llong get( llong *a, int i )
{
  llong r;

  for (r = 0; i >= 0; i &= i + 1, i--)
    r += a[i];
  return r;
}

int main( void )
{
  int i, j;

  freopen("form.in", "rt", stdin);
  freopen("form.out", "wt", stdout);
  scanf("%d%d", &n, &k);
  k++;
  for (i = 1; i <= n; i++)
    scanf("%d", &b[i]);
  memset(a, 0, sizeof(a));
  set(a[0], 0, 1);
  for (i = 1; i <= n; i++)
    for (j = 1; j <= k; j++)
      set(a[j], b[i], get(a[j - 1], b[i] - 1));
  printf("%Lu", get(a[k], n));
  return 0;
}
