#include <stdio.h>

#define m 5010
#define max(a, b) ((a) > (b) ? (a) : (b))
#define min(a, b) ((a) < (b) ? (a) : (b))
#define sqr(x) ((x) * (x))
#define eps 1e-12
#define inf 1e100

long double x[m], l[m];
int n;

int main( void )
{
  int i, j;
  long double mi, ma, hi, y1, y2, bx, x1, x2, l1, l2, xx, yy, cx, cy;

  freopen("popular.in", "rt", stdin);
  freopen("popular.out", "wt", stdout);
  scanf("%d", &n);
  for (i = 0; i < n; i++)
    scanf("%Lf%Lf", &x[i], &l[i]);
  mi = x[0] - l[0], ma = x[0] + l[0];
  for (i = 1; i < n; i++)
  {
    mi = max(mi, x[i] - l[i]);
    ma = min(ma, x[i] + l[i]);
  }
  if (mi > ma + eps)
    printf("-1 -1");
  else
  {
    hi = -inf;
    for (i = 0; i < n; i++)
    {
      cy = inf;
      if (mi - eps < x[i] && x[i] < ma + eps)
        if (-l[i] < cy)
          cy = -l[i], cx = x[i];
      for (j = 0; j < n; j++)
      {
        x1 = x[i], x2 = x[j], l1 = l[i] * l[i], l2 = l[j] * l[j];
        if (fabs(x1 - x2) < eps)
          continue;
        xx = ((l1 - l2) / (x2 - x1) + x1 + x2) * .5;
        yy = -sqrt(l1 - sqr(xx - x1) + eps);
        if (mi - eps < xx && xx < ma + eps && yy < cy)
          cy = yy, cx = xx;
      }
      if (cy > hi)
        hi = cy, bx = cx;
    }
    if (hi <= -inf)
      printf("-1 -1");
    else
      printf("%.4Lf %.4Lf", bx, hi);
  }
  return 0;
}
