#include <stdio.h>
#include <string.h>

#define m 310
#define mm 20010
#define mc 11

int n, k, l, e, he[m], to[mm], ne[mm], co[mm], u[m][m][mc], r[m][m][mc][2], _stklen = 12 << 20;

void relaxb( int *r0, int *r1, int r2, int r3 )
{
  if ((*r0 == 0 && r2 == 1) ||
      (*r0 == 1 && r2 == 1 && r3 < *r1) ||
      (*r0 == 2 && (r2 != 2 || r3 > *r1)))
    *r0 = r2, *r1 = r3;
}

void relaxa( int *r0, int *r1, int r2, int r3 )
{
  if ((*r0 == 0 && r2 == 2) ||
      (*r0 == 1 && (r2 != 1 || r3 > *r1)) ||
      (*r0 == 2 && r3 < *r1))
    *r0 = r2, *r1 = r3;
}

void dfs( int a, int b, int c )
{
  int i, j, b0, b1, r0, r1;

  if (u[a][b][c])
    return;
  if (a == b)
  {
    r[a][b][c][0] = 2, r[a][b][c][1] = 0;
    return;
  }
  if (b == 0)
  {
    r[a][b][c][0] = 1, r[a][b][c][1] = 0;
    return;
  }
  u[a][b][c] = 1;
  r[a][b][c][0] = r[a][b][c][1] = 0;
  if (c == 0)
  {
    r0 = 1, r1 = 0;
    for (i = he[a]; i != -1; i = ne[i])
    {
      dfs(to[i], b, co[i]);
      relaxa(&r0, &r1, r[to[i]][b][co[i]][0], r[to[i]][b][co[i]][1] + 1);
    }
    r[a][b][c][0] = r0, r[a][b][c][1] = r1;
  }
  else
  {
    b0 = 2, b1 = 0;
    dfs(a, b, 0);
    relaxb(&b0, &b1, r[a][b][0][0], r[a][b][0][1]);
    if (a != b)
      for (j = he[b]; j != -1; j = ne[j])
        if (co[j] == c)
        {
          dfs(a, to[j], 0);
          relaxb(&b0, &b1, r[a][to[j]][0][0], r[a][to[j]][0][1]);
        }
    r[a][b][c][0] = b0, r[a][b][c][1] = b1;
  }
}

int main( void )
{
  int a, b, c;

  freopen("pursuit.in", "rt", stdin);
  freopen("pursuit.out", "wt", stdout);
  scanf("%d%d%d", &n, &k, &l);
  e = 0;
  memset(he, -1, sizeof(he));
  while (k--)
  {
    scanf("%d%d%d", &a, &b, &c);
    a--, b--;
    ne[e] = he[a], to[e] = b, co[e] = c, he[a] = e++;
    ne[e] = he[b], to[e] = a, co[e] = c, he[b] = e++;
  }
  scanf("%d%d", &a, &b), a--, b--;
  memset(u, 0, sizeof(u));
  dfs(a, b, 0);
  if (r[a][b][0][0] == 0)
    printf("Endless");
  else if (r[a][b][0][0] == 1)
    printf("Escaped\n%d", r[a][b][0][1]);
  else
    printf("Caught\n%d", r[a][b][0][1]);
  return 0;
}
