#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#define m 100010

int n, k, l, aa[m], he[m], to[m + m], ne[m + m], u[m], pa[m], si[m];

int get( int i )
{
  if (pa[i] == i)
    return i;
  return pa[i] = get(pa[i]);
}

void join( int i, int j )
{
  i = get(i), j = get(j);
  if (i == j)
    return;
  if (si[i] < si[j])
    pa[i] = j, si[j] += si[i];
  else
    pa[j] = i, si[i] += si[j];
}

int main( void )
{
  int i, j, a, b, mi, ma;

  freopen("roads.in", "rt", stdin);
  freopen("roads.out", "wt", stdout);
  scanf("%d%d%d", &n, &k, &l);
  for (i = 0; i < n; i++)
    scanf("%d", &aa[i]), aa[i] %= l;
  memset(he, -1, sizeof(he));
  for (i = 0; i < k; i++)
  {
    scanf("%d%d", &a, &b);
    a--, b--;
    to[i * 2] = b, ne[i * 2] = he[a], he[a] = i * 2;
    to[i * 2 + 1] = a, ne[i * 2 + 1] = he[b], he[b] = i * 2 + 1;
  }
  memset(u, 0, sizeof(u));
  for (i = b = 0; i < m; i++)
    if (!u[i])
  {
    u[i] = 1;
    mi = ma = aa[i];
    for (j = he[i]; j != -1; u[to[j]] = 1, j = ne[j])
      if (aa[to[j]] < mi)
        mi = aa[to[j]];
      else if (aa[to[j]] > ma)
        ma = aa[to[j]];
    if (ma - mi > l - ma + mi)
      b += l - ma + mi;
    else
      b += ma - mi;
  }
  printf("%d", l > b ? b : l);
  return 0;
}
