{$I-,Q-,R-,S-}
const eps=1e-8;
      infinity=1e20;
var n,i,j,min:longint;
    u,v,t:extended;
    x,y,best:array [0..50] of extended;
    w:array [0..50,0..50] of extended;
    marked:array [0..50] of boolean;
function get(l,d,u,v:extended):extended;
var a,b,m1,m2:extended;
function ctime(x:extended):extended;
begin
  ctime:=sqrt(sqr(l-x)+sqr(d))/u+x/v;
end;
begin
  a:=0;
  b:=l;
  while abs(a-b)>eps do
  begin
    m1:=a+(b-a)/3;
    m2:=b-(b-a)/3;
    if ctime(m1)<ctime(m2) then
      b:=m2
    else a:=m1;
  end;
  get:=ctime(a);
end;
function scal(x1,y1,x2,y2:extended):extended;
begin
  scal:=x1*x2+y1*y2;
end;
function vect(x1,y1,x2,y2:extended):extended;
begin
  vect:=x1*y2-x2*y1;
end;
function dist2(x1,y1,x2,y2:extended):extended;
begin
  dist2:=sqr(x2-x1)+sqr(y2-y1);
end;
function dist(x1,y1,x2,y2:extended):extended;
begin
  dist:=sqrt(dist2(x1,y1,x2,y2));
end;
procedure gett(i,j,k:longint);
var x0,y0,x1,y1,x2,y2,s1,s2,v,d0,d1,d,l:extended;
begin
  x0:=x[i];
  y0:=y[i];
  x1:=x[j];
  y1:=y[j];
  x2:=x[k];
  y2:=y[k];
  s1:=scal(x0-x1,y0-y1,x2-x1,y2-y1);
  s2:=scal(x0-x2,y0-y2,x1-x2,y1-y2);
  if (s1<eps) or (s2<eps) then
    exit;
  v:=abs(vect(x0-x1,y0-y1,x2-x1,y2-y1));
  d0:=dist(x1,y1,x2,y2);
  d1:=dist(x0,y0,x1,y1);
  d:=v/d0;
  l:=sqrt(sqr(d1)-sqr(d));
  if get(d,l,u,v)<w[i,j] then
    w[i,j]:=get(d,l,u,v);
  v:=abs(vect(x0-x2,y0-y2,x2-x1,y2-y1));
  d0:=dist(x1,y1,x2,y2);
  d1:=dist(x0,y0,x2,y2);
  d:=v/d0;
  l:=sqrt(sqr(d1)-sqr(d));
  if get(d,l,u,v)<w[i,k] then
    w[i,k]:=get(d,l,u,v);
end;
begin
  assign(input,'tractor.in');
  reset(input);
  assign(output,'tractor.out');
  rewrite(output);
  read(n,u,v);
  for i:=0 to n do
    read(x[i],y[i]);
  for i:=0 to n do
    for j:=0 to n do
      w[i,j]:=dist(x[i],y[i],x[j],y[j])/u;
  for i:=0 to n do
    w[i,i]:=0;
  for i:=0 to n-1 do
  begin
    w[i,i+1]:=dist(x[i],y[i],x[i+1],y[i+1])/v;
    w[i+1,i]:=w[i,i+1];
  end;
  for i:=0 to n do
    for j:=0 to n-1 do
      gett(i,j,j+1);
  for i:=0 to n do
  begin
    best[i]:=infinity;
    marked[i]:=false;
  end;
  best[0]:=0;
  for i:=0 to n do
  begin
    min:=0;
    for j:=0 to n do
      if not marked[j] and ((min=0) or (best[j]<best[min])) then
        min:=j;
    marked[min]:=true;
    for j:=0 to n do
    begin
      t:=best[min]+w[min,j];
      if t<best[j] then
        best[j]:=t;
    end;
  end;
  writeln(best[n]:0:10);
  close(input);
  close(output);
end.
