{$M 10000000,0}
{$I-,Q-,R-,S-}
const eps=1e-8;
var n,i,m,j:longint;
    xp,yp,xf,yf:array [1..201] of double;
    l,r,cr,a,b,c,d,x0,y0,dx,dy,t1,t2,ax,ay:double;
    ok:boolean;
label 1;
function dist2(x1,y1,x2,y2:double):double;
begin
  dist2:=sqr(x1-x2)+sqr(y1-y2);
end;
function vect(x1,y1,x2,y2:double):double;
begin
  vect:=x1*y2-x2*y1;
end;
procedure doit(x0,y0:double);
var i,c1,c2:longint;
begin
  for i:=1 to m do if dist2(x0,y0,xf[i],yf[i])<sqr(cr-eps) then exit;
  c1:=0;
  c2:=0;
  for i:=1 to n do
  begin
    if vect(x0-xp[i],y0-yp[i],xp[i+1]-xp[i],yp[i+1]-yp[i])>eps then inc(c1);
    if vect(x0-xp[i],y0-yp[i],xp[i+1]-xp[i],yp[i+1]-yp[i])<-eps then inc(c2);
  end;
  if (c1<>0) and (c2<>0) then exit;
  ax:=x0;
  ay:=y0;
  ok:=true;
end;
begin
  assign(input,'fire.in');
  reset(input);
  assign(output,'fire.out');
  rewrite(output);
  read(n);
  for i:=1 to n do
    read(xp[i],yp[i]);
  xp[n+1]:=xp[1];
  yp[n+1]:=yp[1];
  read(m);
  for i:=1 to m do
    read(xf[i],yf[i]);
  l:=0;
  r:=2829;
  while l+eps<r do
  begin
    cr:=(l+r)/2;
    ok:=false;
    for i:=1 to m-1 do
      for j:=i+1 to m do
      begin
        a:=2*(xf[j]-xf[i]);
        b:=2*(yf[j]-yf[i]);
        c:=(sqr(xf[i])+sqr(yf[i]))-(sqr(xf[j])+sqr(yf[j]));
        if (abs(a)<eps) and (abs(b)<eps) then
          continue;
        d:=sqrt(sqr(a)+sqr(b));
        a:=a/d;
        b:=b/d;
        c:=c/d;
        x0:=-a*c;
        y0:=-b*c;
        dx:=-b;
        dy:=a;
        a:=sqr(dx)+sqr(dy);
        b:=2*(dx*(x0-xf[i])+dy*(y0-yf[i]));
        c:=sqr(x0-xf[i])+sqr(y0-yf[i])-sqr(cr);
        d:=sqr(b)-4*a*c;
        if d<-eps then
          continue;
        if d<eps then
        begin
          t1:=-b/(2*a);
          doit(x0+dx*t1,y0+dy*t1);
          if ok then
            goto 1;
        end
        else begin
          t1:=(-b+sqrt(d))/(2*a);
          t2:=(-b-sqrt(d))/(2*a);
          doit(x0+dx*t1,y0+dy*t1);
          if ok then
            goto 1;
          doit(x0+dx*t2,y0+dy*t2);
          if ok then
            goto 1;
        end;
      end;
    for i:=1 to m do
      for j:=1 to n do
      begin
        a:=yp[j+1]-yp[j];
        b:=xp[j]-xp[j+1];
        c:=-a*xp[j]-b*yp[j];
        if (abs(a)<eps) and (abs(b)<eps) then
          continue;
        d:=sqrt(sqr(a)+sqr(b));
        a:=a/d;
        b:=b/d;
        c:=c/d;
        x0:=-a*c;
        y0:=-b*c;
        dx:=-b;
        dy:=a;
        a:=sqr(dx)+sqr(dy);
        b:=2*(dx*(x0-xf[i])+dy*(y0-yf[i]));
        c:=sqr(x0-xf[i])+sqr(y0-yf[i])-sqr(cr);
        d:=sqr(b)-4*a*c;
        if d<-eps then
          continue;
        if d<eps then
        begin
          t1:=-b/(2*a);
          doit(x0+dx*t1,y0+dy*t1);
          if ok then
            goto 1;
        end
        else begin
          t1:=(-b+sqrt(d))/(2*a);
          t2:=(-b-sqrt(d))/(2*a);
          doit(x0+dx*t1,y0+dy*t1);
          if ok then
            goto 1;
          doit(x0+dx*t2,y0+dy*t2);
          if ok then
            goto 1;
        end;
      end;
    for i:=1 to n do
    begin
      doit(xp[i],yp[i]);
      if ok then
        goto 1;
    end;
    for i:=1 to m do
    begin
      doit(xf[i]+cr,yf[i]);
      if ok then
        goto 1;
    end;
    1:
    if ok then
      l:=cr
    else r:=cr;
  end;
  writeln(ax:0:10,' ',ay:0:10);
  close(input);
  close(output);
end.
