const MaxN = 500;
      Big = 100000000;

type extended = real;

     TIzlom = record
      x,y : longint;
     end;

     TLine = record
      x1,y1,x2,y2 : longint;
     end;

var n,i : longint;
    u,v : extended;
    a : array [1..MaxN] of TIzlom;
    time : array [1..MaxN] of extended;

function Dist(a : TLine) : extended;
var q : extended;
begin
    q := Sqrt(Sqr(a.x1-a.x2)+Sqr(a.y1-a.y2));
    Dist := q;
end;

function GetTime(a : TLine; speed : extended) : extended;
var q : extended;
begin
    q := Dist(a)/speed;
    GetTime := q;
end;

function Include(a : TLine; p,q : TIzlom) : boolean;
begin
    Include := false;
    if not ((a.x1 = a.x2) or (a.y1 = a.y2)) then exit
    else if (a.x1 = a.x2) and (p.x = q.x) then
     if (((a.x1 <= p.x) and (a.x2 >= p.x))
     or ((a.x1 >= p.x) and (a.x2 <= p.x)))
     and (((a.x1 <= q.x) and (a.x2 >= q.x))
     or ((a.x1 >= q.x) and (a.x2 <= q.x))) then Include := true
     else exit
    else
     if (((a.y1 <= p.y) and (a.y2 >= p.y))
     or ((a.y1 >= p.y) and (a.y2 <= p.y)))
     and (((a.y1 <= q.y) and (a.y2 >= q.y))
     or ((a.y1 >= q.y) and (a.y2 <= q.y))) then Include := true;
end;

function GetPp(a,b,c : TIzlom) : TIzlom;
begin
    GetPp.x := Big;
    if not (((a.y < b.y) and (a.y > c.y))
    or ((a.y > b.y) and (a.y < c.y))) then exit;
    if not (((a.x < b.x) and (a.x > c.x))
    or ((a.x > b.x) and (a.x < c.x))) then exit;
    if ((a.y < b.y) and (a.y > c.y))
    or ((a.y > b.y) and (a.y < c.y)) then begin
     GetPp.x := b.x;
     GetPp.y := a.y;
    end
    else begin
     GetPp.x := a.x;
     GetPp.y := b.y;
    end;
end;

procedure Solve;
var ax,bx : TLine;
    i,j,k : longint;
    s : extended;
    sh : TIzlom;
    q : extended;
begin
    time[1] := 0;
    for i := 2 to n do begin
     ax.x1 := a[i].x; ax.x2 := a[i-1].x;
     ax.y1 := a[i].y; ax.y2 := a[i-1].y;
     q := GetTime(ax,v);
     time[i] := time[i-1]+q;
    end;
    for i := 2 to n do begin
     {1}
     for j := i-2 downto 1 do begin
      ax.x1 := a[j].x; ax.x2 := a[i].x;
      ax.y1 := a[j].y; ax.y2 := a[i].y;
      s := GetTime(ax,u);
      for k := 1 to n-1 do
       if Include(ax,a[k],a[k+1]) then begin
        bx.x1 := a[k].x; bx.x2 := a[k+1].x;
        bx.y1 := a[k].y; bx.y2 := a[k+1].y;
        s := s-GetTime(bx,u)+GetTime(bx,v);
       end;
      if time[i] > s then time[i] := s;
     end;
     {2}
     for j := i-2 downto 1 do begin
      sh := GetPp(a[j],a[i],a[i-1]);
      if sh.x <> Big then begin
       ax.x1 := a[j].x; ax.x2 := sh.x;
       ax.y1 := a[j].y; ax.y2 := sh.y;
       s := GetTime(ax,u);
       for k := 1 to n-1 do
        if Include(ax,a[k],a[k+1]) then begin
         bx.x1 := a[k].x; bx.x2 := a[k+1].x;
         bx.y1 := a[k].y; bx.y2 := a[k+1].y;
         s := s-GetTime(bx,u)+GetTime(bx,v);
        end;
       if time[i] > s then time[i] := s;
      end;
     end;
     {3}
     for j := i-2 downto 1 do begin
      sh := GetPp(a[i],a[j],a[j+1]);
      if sh.x <> Big then begin
       ax.x1 := a[j].x; ax.x2 := sh.x;
       ax.y1 := a[j].y; ax.y2 := sh.y;
       s := GetTime(ax,u);
       for k := 1 to n-1 do
        if Include(ax,a[k],a[k+1]) then begin
         bx.x1 := a[k].x; bx.x2 := a[k+1].x;
         bx.y1 := a[k].y; bx.y2 := a[k+1].y;
         s := s-GetTime(bx,u)+GetTime(bx,v);
        end;
       if time[i] > s then time[i] := s;
      end;
     end;
    end;
end;

begin
    assign(input,'tractor.in');
    assign(output,'tractor.out');
    reset(input);
    rewrite(output);
    read(n,u,v);
    n := n+1;
    for i := 1 to n do
     read(a[i].x,a[i].y);
    Solve;
    writeln(abs(time[n]) : 0 : 6);
    close(input);
    close(output);
end.
