const MaxN = 100000;
      MaxK = 11;

type int64 = extended;
     TFenriz = array [0..MaxN] of int64;

var a : array [1..MaxK,1..MaxN] of int64;
    fen : array [1..MaxK] of TFenriz;
    f : array [1..MaxN] of longint;
    i,n,k : longint;

procedure AddFenriz(var f : TFenriz; where : longint; cost : int64);
begin
    while where <= n do begin
     f[where] := f[where]+cost;
     where := where or (where+1);
    end;
end;

function GetFenriz(const f : TFenriz; where : longint) : int64;
var s : int64;
begin
    s := 0;
    while where >= 0 do begin
     s := s+f[where];
     where := (where and (where+1))-1;
    end;
    GetFenriz := s;
end;

procedure Solve;
var i,j,kx : longint;
    sum : int64;
begin
    for i := 1 to n do a[1,i] := 1;
    for kx := 2 to k do
     for i := 1 to n do
      if i < kx then AddFenriz(fen[kx],f[i],a[kx-1,i])
      else begin
       a[kx,i] := GetFenriz(fen[kx],f[i]);
       AddFenriz(fen[kx],f[i],a[kx-1,i]);
      end;
    sum := 0;
    for i := 1 to n do sum := sum+a[k,i];
    writeln(sum : 0 : 0);
end;

begin
    assign(input,'form.in');
    assign(output,'form.out');
    reset(input);
    rewrite(output);
    read(n,k);
    inc(k);
    for i := 1 to n do read(f[i]);
    Solve;
    close(input);
    close(output);
end.
