const MaxN = 200000;
      Big = 100000000;

type TNecklace = record
      ang : extended;
      st : longint;
     end;

     TInterval = record
      x,y : longint;
     end;

var a : array [1..MaxN] of TNecklace;
    sum : array [1..MaxN] of int64;
    good : int64;
    i,n,nx,k : longint;

procedure Swap(var a,b : TNecklace);
var c : TNecklace;
begin
    c := a;
    a := b;
    b := c;
end;

procedure Sort(l,r : longint);
var i,j : longint;
    x : extended;
begin
    i := l;
    j := r;
    x := a[Random(j-i+1)+i].ang;
    repeat
     while a[i].ang < x do inc(i);
     while x < a[j].ang do dec(j);
     if i <= j then begin
      Swap(a[i],a[j]);
      inc(i);
      dec(j);
     end;
    until i > j;
    if i < r then Sort(i,r);
    if l < j then Sort(l,j);
end;

function GetBin(x,y : extended) : TInterval;
var l,r,m : longint;
begin
    l := 1;
    r := nx;
    while abs(r-l) > 1 do begin
     m := (l+r) div 2;
     if x >= a[m].ang then l := m;
     if x <= a[m].ang then r := m;
    end;
    if l = r then
     if a[l].ang < x then GetBin.x := l+1
     else GetBin.x := l-1
    else
     if a[l].ang = x then GetBin.x := l
     else GetBin.x := r;
    l := 1;
    r := nx;
    while abs(r-l) > 1 do begin
     m := (l+r) div 2;
     if y >= a[m].ang then l := m;
     if y <= a[m].ang then r := m;
    end;
    if l = r then
     if a[l].ang < y then GetBin.y := l+1
     else GetBin.y := l-1
    else
     if a[l].ang = y then GetBin.y := l
     else GetBin.y := r;
end;

function GetSum(t : TInterval) : int64;
begin
    GetSum := sum[t.y]-sum[t.x];
end;

procedure Solve;
var leng,p,px : extended;
    int : TInterval;
    difnow,maxnow,minnow : int64;
    sms : int64;
    i,j : longint;
begin
    good := Big;
    Sort(1,n);
    nx := n*2;
    for i := n+1 to nx do begin
     a[i].ang := a[i-n].ang+2*pi;
     a[i].st := a[i-n].st;
    end;
    leng := 2*pi/k;
    sum[1] := a[1].st;
    for i := 2 to nx do
     sum[i] := sum[i-1]+a[i].st;
    for i := 1 to n do begin
     p := a[i].ang;
     maxnow := Big;
     minnow := -Big;
     for j := 1 to k do begin
      px := p+leng;
      sms := GetSum(GetBin(p,px));
      if (good = Big) or ((abs(sms-maxnow) < good) and (abs(sms-minnow) < good)) then begin
       if (maxnow = Big) or (maxnow < sms) then maxnow := sms;
       if (minnow = -Big) or (minnow > sms) then minnow := sms;
      end
      else break;
      p := px;
     end;
     if good > maxnow-minnow then good := maxnow-minnow;
    end;
    writeln(good);
end;

begin
    assign(input,'necklace.in');
    assign(output,'necklace.out');
    reset(input);
    rewrite(output);
    read(n,k);
    for i := 1 to n do
     with a[i] do read(ang,st);
    Solve;
    close(input);
    close(output);
end.
