{$I-,Q-,S-,R-}

const MaxN = 250;
      Big = 10000000;

type TRebro = record
      x,y : longint;
     end;

var a,reb,cost : array [1..MaxN,1..MaxN] of longint;
    n,p,i : longint;
    nn : array [1..MaxN] of boolean;
    x,y : longint;
    r : longint;
    rx : TRebro;
    todel : array [0..MaxN*MaxN] of TRebro;

function Relax(v : longint) : longint;
var i : longint;
    sm : longint;
begin
    nn[v] := false;
    sm := 0;
    for i := 1 to n do
     if nn[i] and (a[v,i] <> 0) then begin
      inc(cost[v,i],Relax(i));
      inc(sm,cost[v,i]);
      a[i,v] := 0;
     end;
    Relax := sm+1;
end;

function Min(a,b : longint) : longint;
begin
    if abs(a-p) > abs(b-p) then Min := b
    else Min := a;
end;

function DFS(v : longint) : longint;
var minx : longint;
    i : longint;
begin
    minx := Big;
    for i := 1 to n do
     if (a[v,i] = 1) and (cost[v,i] > p) then minx := Min(minx,DFS(i))
     else if (a[v,i] = 1) and (cost[v,i] <= p) then minx := Min(minx,cost[v,i]);
    DFS := minx;
end;

procedure Solve;
var i,j : longint;
    f : boolean;
begin
    fillchar(nn,sizeof(nn),true);
    Relax(1);
    while p <> 0 do begin
     r := DFS(1);
     f := true;
     for i := 1 to n do begin
      for j := 1 to n do
       if cost[i,j] = r then begin
        f := false;
        rx.x := i; rx.y := j;
        break;
       end;
      if not f then break;
     end;
     inc(todel[0].x);
     todel[todel[0].x] := rx;
     p := p-cost[rx.x,rx.y];
     a[rx.x,rx.y] := 0;
     a[rx.y,rx.x] := 0;
     fillchar(cost,sizeof(cost),0);
     fillchar(nn,sizeof(nn),true);
     Relax(1);
    end;
    writeln(todel[0].x);
    for i := 1 to todel[0].x do
     write(reb[todel[i].x,todel[i].y],' ');
end;

begin
    assign(input,'tree.in');
    assign(output,'tree.out');
    reset(input);
    rewrite(output);
    read(n,p);
    p := n-p;
    for i := 1 to n-1 do begin
     read(x,y);
     a[x,y] := 1; a[y,x] := 1;
     reb[x,y] := i; reb[y,x] := i;
    end;
    Solve;
    close(input);
    close(output);
end.
