{$R+}
var
  first:boolean;
  mass,sr,dt,par,ch,rc:array[1..250]of integer;
  res,tr,trw:array[0..250,0..250]of integer;
  i,j,n,p,min,ind:integer;

procedure out(x,y:integer);
var i:integer;
begin
  if first then
    first:=false
  else
    write(' ');
  for i:=1 to n-1 do begin
    if (sr[i]=x)and(dt[i]=y)or(sr[i]=y)and(dt[i]=x) then
      begin
        write(i);
        exit;
      end;
  end;
end;

function cnt_mass(v:integer):integer;
var i,s:integer;
begin
  s:=1;
  i:=ch[v];
  while i<>0 do begin
    s:=s+cnt_mass(i);
    i:=rc[i];
  end;
  mass[v]:=s;
  cnt_mass:=s;
end;

procedure down(v:integer);
var
i:integer;
lst:integer;
begin
  lst:=0;
  rc[v]:=0;
  ch[v]:=0;
  for i:=1 to n-1 do begin
    if sr[i]=v then begin
      if par[v]=dt[i] then
        continue;
      par[dt[i]]:=v;
      if lst=0 then
        ch[v]:=dt[i]
      else
        rc[lst]:=dt[i];
      lst:=dt[i];
      down(dt[i]);
    end else
    if dt[i]=v then begin
      if par[v]=sr[i] then
        continue;
      par[sr[i]]:=v;
      if lst=0 then
        ch[v]:=sr[i]
      else
        rc[lst]:=sr[i];
      lst:=sr[i];
      down(sr[i]);
    end;
  end;
end;

function count(v,p:integer):integer; forward;

function try(i,p:integer):integer;
var
  my,w,min,x:integer;
begin
  if i=0 then begin
    if p=0 then try:=0 else try:=-1;
    exit;
  end;
  if tr[i,p]>=-1 then
    try:=tr[i,p]
  else begin
    my:=p;
    if my>mass[i] then my:=mass[i];
    min:=-1;
    for w:=0 to my do begin
      if count(i,w)>=0 then begin
        x:=try(rc[i],p-w);
        if ((min<0)or(min>x))and(x>=0) then begin
          x:=x+res[i,w];
          min:=x;
          trw[i,p]:=w;
        end;
      end;
    end;
    tr[i,p]:=min;
    try:=min;
  end;
end;

function count(v,p:integer):integer;
var r:integer;
begin
  if res[v,p]>=-1 then
    count:=res[v,p]
  else begin
    if p>mass[v] then
      r:=-1
    else begin
      r:=try(ch[v],p-1);
    end;
    count:=r;
    res[v,p]:=r;
  end;
end;


procedure walk(v,p:integer);
var i:integer;
begin
  if p=0 then begin
    out(v,par[v]);
    exit;
  end;
  i:=ch[v];
  dec(p);
  while i<>0 do begin
    walk(i,trw[i,p]);
    dec(p,trw[i,p]);
    i:=rc[i];
  end;
end;

begin
  assign(input,'tree.in');
  reset(input);
  assign(output,'tree.out');
  rewrite(output);
  readln(n,p);
  for i:=1 to n-1 do
    readln(sr[i],dt[i]);
  par[1]:=0;
  down(1);
  cnt_mass(1);

  for i:=1 to n do
    for j:=0 to p do
      res[i,j]:=-2;
  for i:=2 to n do
//    if ch[i]=0 then
      res[i,0]:=1
{    else
      res[i,0]:=-1};
  res[1,0]:=-1;

  for i:=1 to n do
    for j:=0 to p do
      tr[i,j]:=-2;

  for i:=1 to n do
    count(i,p);

  min:=res[1,p]-1;
  ind:=1;
  for i:=2 to n do
    if (res[i,p]<min)and(res[i,p]>=0) then begin
      ind:=i;
      min:=res[i,p];
    end;
  inc(min);
  writeln(min);
  first:=true;
  if ind>1 then
    out(ind,par[ind]);
  walk(ind,p);
  writeln;

{  write('  ');
  for j:=1 to n do write(j:6);
  writeln;
  for i:=0 to p do begin
    write(i:2);
    for j:=1 to n do write(res[j,i]:6);
    writeln;
  end;
  writeln;
  for i:=0 to p do begin
    write(i:2);
    for j:=1 to n do write(tr[j,i]:3,'(',trw[j,i],')');
    writeln;
  end;}

  close(input);
  close(output);
end.