program Divide;
const infile = 'divide.in';
      outfile = 'divide.out';
      asd = 2000;
type tFraction = record
  a, b : int64;
end;
var f0 : tFraction;

function ToVal(s : string) : int64;
var res : int64;
    i : integer;
begin
  res:=0;
  for i:=1 to length(s) do
    res:=res*10+ord(s[i])-48;
  ToVal:=res;
end;

function GCD(a, b : int64) : int64;
begin
  while (a<>0) and (b<>0) do
    if a>b then
      a:=a mod b
    else
      b:=b mod a;
  GCD:=a+b;
end;

function pow10(a : integer) : int64;
var i : integer;
    res : int64;
begin
  res:=1;
  for i:=1 to a do
    res:=res*10;
  pow10:=res;
end;

function Normalize(f : tFraction) : tFraction;
var g : int64;
begin
  g:=GCD(f.a, f.b);
  f.a:=f.a div g; f.b:=f.b div g;
  Normalize:=f;
end;

function MakeFraction(s : string) : tFraction;
var intpart, predp, per : int64;
    res : tFraction;
    k, lpredp, lper : integer;
    s1, s2 : string;
begin
  k:=pos('.', s);
  if k=0 then begin
    res.a:=ToVal(s); res.b:=1; MakeFraction:=res; exit;
  end;

  s1:=copy(s, 1, k-1); s2:=copy(s, k+1, length(s)-k);
  intpart:=ToVal(s1);

  k:=pos('(', s2);
  if k=0 then begin
    lpredp:=length(s2); predp:=ToVal(s2);
    res.b:=pow10(lpredp);
    res.a:=predp+intpart*res.b;
    MakeFraction:=res; exit;
  end;

  lpredp:=k-1; predp:=ToVal(copy(s2, 1, lpredp));
  s2:=copy(s2, k+1, length(s2)-k-1);
  lper:=length(s2); per:=ToVal(s2);

  res.b:=pow10(lpredp+lper)-pow10(lpredp); res.a:=predp*pow10(lper)+per-predp+intpart*res.b;
  MakeFraction:=res;
end;

procedure ReadData;
var s1, s2 : string;
    f1, f2 : tFraction;
    g : int64;
begin
  assign(input, infile);
  assign(output, outfile);
  reset(input);
  rewrite(output);

  readln(s1);
  readln(s2);

  f1:=Normalize(MakeFraction(s1)); f2:=Normalize(MakeFraction(s2));
  g:=GCD(f1.a, f2.a); f1.a:=f1.a div g; f2.a:=f2.a div g;
  g:=GCD(f1.b, f2.b); f1.b:=f1.b div g; f2.b:=f2.b div g;

  f0.a:=f1.a*f2.b; f0.b:=f1.b*f2.a;
  f0:=Normalize(f0);
end;

procedure Solve;
var res : array[1..asd] of integer;
    res1 : array[1..asd] of int64;
    i, j, k : integer;
begin
  write(f0.a div f0.b);
  f0.a:=f0.a mod f0.b;
  if f0.a=0 then exit;

  write('.');

  f0.a:=f0.a*10;
  for i:=1 to asd do begin
    res1[i]:=f0.a; res[i]:=f0.a div f0.b; f0.a:=f0.a mod f0.b;
    f0.a:=f0.a*10;
  end;

  for i:=1 to asd do
    if res1[i]=0 then begin
      for j:=1 to i-1 do
        write(res[j]);
      writeln; exit;
    end;

  for i:=1 to asd do
    for j:=i-1 downto 1 do
      if res1[j]=res1[i] then begin
        for k:=1 to j-1 do
          write(res[k]);
        write('(');
        for k:=j to i-1 do
          write(res[k]);
        writeln(')'); exit;
      end;
end;

procedure WriteData;
begin
  close(input);
  close(output);
end;

begin
  ReadData;
  Solve;
  WriteData;
end.
