program TheChat;
const infile = 'chat.in';
      outfile = 'chat.out';
      MAXN = 1200;
var max : array[1..MAXN] of integer;
    a : array[1..MAXN, 1..MAXN] of integer;
    id : array[1..MAXN] of integer;
    N : integer;

function Compare(i, j : integer) : integer;
var k, res : integer;
begin
  res:=0;
  for k:=1 to N do begin
    if (a[id[i], k]>a[id[j], k]) and (res=2) then begin Compare:=100; exit; end;
    if (a[id[j], k]>a[id[i], k]) and (res=1) then begin Compare:=100; exit; end;

    if a[id[i], k]>a[id[j], k] then res:=1;
    if a[id[j], k]>a[id[i], k] then res:=2;
  end;

  if (res=0) and (id[i]>id[j]) then res:=1;
  if (res=0) and (id[j]>id[i]) then res:=2;

  Compare:=res;
end;

function HeapSort : boolean;
var i : integer;

procedure Swap(i, j : integer);
var t : integer;
begin
  t:=id[i]; id[i]:=id[j]; id[j]:=t;
end;

function Heapify(i, hs : integer) : boolean;
var l, r, largest : integer;
begin
  while true do begin
    l:=i shl 1; r:=l+1; largest:=i;

    if (l<=hs) and (Compare(l, largest)=100) then begin Heapify:=false; exit; end;
    if (r<=hs) and (Compare(r, largest)=100) then begin Heapify:=false; exit; end;

    if (l<=hs) and (Compare(l, largest)=1) then largest:=l;
    if (r<=hs) and (Compare(r, largest)=1) then largest:=r;

    if largest=i then break;
    Swap(i, largest); i:=largest;
  end;

  Heapify:=true;
end;

begin
  for i:=(N div 2) downto 1 do
    if not Heapify(i, N) then begin HeapSort:=false; exit; end;

  for i:=N downto 2 do begin
    Swap(i, 1);
    if not Heapify(1, i-1) then begin HeapSort:=false; exit; end;
  end;

  HeapSort:=true;
end;

procedure ReadData;
begin
  assign(input, infile);
  assign(output, outfile);
  reset(input);
  rewrite(output);
end;

function Init : boolean;
var i, j : integer;
begin
  read(N); if N=0 then begin Init:=false; exit; end;

  for i:=1 to N do
    max[i]:=-1;

  for i:=1 to N do
    for j:=1 to N do
      read(a[i, j]);

  for j:=1 to N do
    for i:=1 to N do
      if a[i, j]>max[j] then max[j]:=a[i, j];

  for i:=1 to N do
    a[i, i]:=max[i];

  for i:=1 to N do
    id[i]:=i;

  Init:=true;
end;

procedure Solve;
var i : integer;
begin
  while true do begin
    if not Init then break;

    if not HeapSort then begin writeln(-1); continue; end;

    for i:=1 to N do
      write(id[i], ' ');
    writeln;
  end;
end;

procedure WriteData;
begin
  close(input);
  close(output);
end;

begin
  ReadData;
  Solve;
  WriteData;
end.
