program Rects;
const infile = 'rects.in';
      outfile = 'rects.out';
      MAXN = 7000;
var x1, y1, x2, y2, a : array[1..MAXN] of longint;
    way : array[1..MAXN] of integer;
    G : array[1..MAXN, 1..MAXN] of boolean;
    res : array[1..MAXN] of int64;
    N : longint;

procedure ReadData;
var i : integer;
begin
  assign(input, infile);
  assign(output, outfile);
  reset(input);
  rewrite(output);
  read(N);
  for i:=1 to N do begin
    read(x1[i], y2[i], x2[i], y1[i], a[i]);
  end;
end;

function DFS(u : integer) : int64;
var v, maxv : integer;
    max : int64;
begin
  if res[u]<>-1 then begin DFS:=res[u]; exit; end;

  max:=0; maxv:=0;
  for v:=1 to N do
    if (G[u, v]) and (DFS(v)>max) then begin
      max:=DFS(v); maxv:=v;
    end;

  res[u]:=a[u]+max; way[u]:=maxv; DFS:=res[u];
end;

procedure Solve;
var i, j : integer;
    max : int64;
    maxu : integer;
begin
  fillchar(res, sizeof(res), 255);
  for i:=1 to N do
    for j:=1 to N do
      if (x1[j]>x2[i]) and (y1[j]<y2[i]) then G[i, j]:=true;

  for i:=1 to N do
    DFS(i);

  max:=0; maxu:=0;
  for i:=1 to N do
    if res[i]>max then begin max:=res[i]; maxu:=i; end;

  writeln(max); i:=maxu;

  while i<>0 do begin
    write(i, ' '); i:=way[i];
  end;
end;

procedure WriteData;
begin
  close(input);
  close(output);
end;

begin
  ReadData;
  Solve;
  WriteData;
end.
