program Roads;
const infile = 'roads.in';
      outfile = 'roads.out';
      MAXN = 100001;
var d : array[1..MAXN] of longint;
    N, M, l : longint;

procedure HeapSort;
var i : longint;

procedure Swap(i, j : longint);
var t : longint;
begin
  t:=d[i]; d[i]:=d[j]; d[j]:=t;
end;

procedure Heapify(i, hs : longint);
var l, r, largest : longint;
begin
  while true do begin
    l:=i shl 1; r:=l+1; largest:=i;

    if (l<=hs) and (d[l]>d[largest]) then largest:=l;
    if (r<=hs) and (d[r]>d[largest]) then largest:=r;

    if largest=i then break;
    Swap(i, largest); i:=largest;
  end;
end;

begin
  for i:=(N div 2) downto 1 do
    Heapify(i, N);

  for i:=N downto 2 do begin
    Swap(i, 1);
    Heapify(1, i-1);
  end;
end;

procedure ReadData;
var i, a, b : longint;
begin
  assign(input, infile);
  assign(output, outfile);
  reset(input);
  rewrite(output);

  read(N, M, l);
  for i:=1 to N do
    read(d[i]);
  for i:=1 to M do begin
    read(a, b);
  end;
end;

procedure Solve;
var i, max : longint;
begin
  HeapSort;
  d[N+1]:=l+d[1]; max:=-1;
  for i:=1 to N do
    if d[i+1]-d[i]>max then max:=d[i+1]-d[i];

  writeln(l-max);
end;

procedure WriteData;
begin
  close(input);
  close(output);
end;

begin
  ReadData;
  Solve;
  WriteData;
end.
