program MegaTrains;
const infile = 'trains.in';
      outfile = 'trains.out';
      MAXN = 30;
      MAXB = 20;
type
t1 = array[1..MAXN] of boolean;
t2 = array[0..MAXB] of longint;
tTask = record
  x, y : integer;
  c, q : longint;
end;
var best, res : t1;
    p : array[1..MAXN] of integer;
    sums : array[0..MAXN] of int64;
    t : array[1..MAXN] of tTask;
    C, max : longint;
    B, N : integer;

procedure Sort;
var i, j : integer;

procedure Swap(i, j : integer);
var t0 : tTask;
    t1 : integer;
begin
  t0:=t[i]; t[i]:=t[j]; t[j]:=t0;
  t1:=p[i]; p[i]:=p[j]; p[j]:=t1;
end;

begin
  for i:=1 to N do
    for j:=i+1 to N do
      if t[i].c<t[j].c then Swap(i, j);
end;

function GetSum(i, j : integer) : int64;
begin
  GetSum:=sums[j]-sums[i-1];
end;

procedure run(st, cur : longint; zv : t1; pl : t2);
var tzv : t1;
    tpl : t2;
    i, j : integer;
    flag : boolean;
begin
  if cur>max then begin
    max:=cur; best:=zv;
  end;

  for i:=st to N do begin
    if cur+GetSum(i, N)<max then break;

    flag:=true;
    for j:=t[i].x to t[i].y-1 do
      if pl[j]+t[i].q>C then begin flag:=false; break; end;
    if not flag then continue;

    tzv:=zv; tzv[i]:=true; tpl:=pl;
    for j:=t[i].x to t[i].y-1 do
      tpl[j]:=pl[j]+t[i].q;

    run(i+1, cur+t[i].c, tzv, tpl);
  end;
end;

procedure ReadData;
var i : integer;
begin
  assign(input, infile);
  assign(output, outfile);
  reset(input);
  rewrite(output);

  read(C, B, N);
  for i:=1 to N do begin
    read(t[i].x, t[i].y, t[i].q);
    t[i].c:=(t[i].y-t[i].x)*t[i].q;
  end;
end;

procedure Solve;
var i : integer;
    zv : t1;
    pl : t2;
begin
  fillchar(zv, sizeof(zv), false);
  fillchar(res, sizeof(res), false);
  fillchar(pl, sizeof(pl), 0);
  for i:=1 to N do
    p[i]:=i;
  Sort; sums[0]:=0; max:=-1;
  for i:=1 to N do
    sums[i]:=sums[i-1]+t[i].c;

  run(1, 0, zv, pl);

  writeln(max);
  for i:=1 to N do
    if best[i] then res[p[i]]:=true;

  for i:=1 to N do
    if res[i] then write(i, ' ');
end;

procedure WriteData;
begin
  close(input);
  close(output);
end;

begin
  ReadData;
  Solve;
  WriteData;
end.
