#include <stdio.h>

#define m 251
#define inf 1000000

int pp, h[m], next[m * 2], r[m * 2], rr, f[m][m], n, ss = 0,
    edge[m], ss, st[m], ch[m][m], num[m][m], pr[m], _stklen = 4 * 1024 * 1024;
short a[m][m][m], b[m][m][m];

void add( int x, int y )
{
  r[++rr] = y;
  next[rr] = h[x];
  h[x] = rr;
}

void calc( int v, int p )
{
  int i, s = 0, j, t, tt, k, bb;

  pr[v] = p;
  for (i = h[v]; i != 0; i = next[i])
    if (r[i] != p)
    {
      calc(r[i], v);
      ch[v][++s] = r[i];
    }
  for (j = 1; j <= pp; j++)
    a[v][0][j] = inf;
  for (i = 1; i <= s; i++)
  {
    a[v][i][0] = i;
    for (j = 1; j <= pp; j++)
    {
      t = a[v][i - 1][j] + 1;
      bb = -1;
      for (k = 0; k < j; k++)
        if (t > (tt = a[v][i - 1][k] + f[ch[v][i]][j - k]))
        {
          t = tt;
          bb = k;
        }
      a[v][i][j] = t;
      b[v][i][j] = bb;
    }
  }
  f[v][0] = inf;
  for (j = 0; j < pp; j++)
    f[v][j + 1] = a[v][s][j];
  st[v] = s;
}

void write( int v, int i, int j )
{
  if (i == 0)
    return;
  if (j == 0)
  {
    for (; i > 0; i--)
      edge[++ss] = num[v][ch[v][i]];
    return;
  }
  if (b[v][i][j] == -1)
  {
    edge[++ss] = num[v][ch[v][i]];
    write(v, i - 1, j);
  }
  else
  {
    write(v, i - 1, b[v][i][j]);
    write(ch[v][i], st[ch[v][i]], j - b[v][i][j] - 1);
  }
}

int main( void )
{
  int t, i, x, y;

  freopen("tree.in", "r", stdin);
  freopen("tree.out", "w", stdout);
  scanf("%d%d", &n, &pp);
  for (i = 1; i < n; i++)
  {
    scanf("%d%d", &x, &y);
    add(x, y);
    num[x][y] = num[y][x] = i;
    add(y, x);
  }
  calc(1, 0);
  for (i = 2; i <= n; i++)
    f[i][pp]++;
  t = 1;
  for (i = 1; i <= n; i++)
    if (f[t][pp] > f[i][pp])
      t = i;
  write(t, st[t], pp - 1);
  if (t != 1)
    edge[++ss] = num[t][pr[t]];
  printf("%d\n", ss);
  for (i = 1; i <= ss; i++)
    printf("%d ", edge[i]);
  printf("\n");
  return 0;
}
