{$I trans.inc}
uses testjury;
type integer=longint;

const MaxM=1000000000;
      MaxN=1000000000;
      MaxS=1000000000;
      MaxK=30000;

var u, h:array [1..MaxK] of integer;
    comps:integer;

function up (a:integer):integer;
begin
  if u[a]=a then begin Result:=a; exit end;
  Result:=up (u[a]); u[a]:=Result;
end;


procedure merge (i, j:integer);
begin
  {writeln (i, ' ', j);}
  i:=up (i); j:=up (j);
  if i=j then exit;
  dec (comps);
  if h[i]<h[j] then u[i]:=j else
  if h[i]>h[j] then u[j]:=i else
  begin inc (h[j]); u[i]:=j end;
end;


var ca, cb, cr, la, lb, lr:array [1..MaxK] of integer;
    cc, lc, lp:integer;
    cur, next, ccn, colors, k, lines, symbols, _, i, m, n:integer;


begin
  ci ('rle.in'); ao ('rle.out'); _:=0;
    m:=getintr (0, MaxM); n:=getintr (0, MaxN);
    {writeln (m, ' ', n);}
    if (m=0) and (n=0) then runerror (239);
    test ((m>0) and (n>0));
    lc:=0; lines:=0; colors:=0; comps:=0;
    cur:=1-getintr (0, 1); next:=0;
    k:=getintr (1, MaxK);
    repeat
      if next=0 then begin cur:=1-cur; next:=getintr (1, MaxS); dec (k); test (k>=0) end;
      if next>=m then begin inc (lines, next div m - 1); next:=next mod m+m; end;
      symbols:=0; cc:=0; lp:=1;
      repeat
        if next=0 then begin cur:=1-cur; next:=getintr (1, MaxS); dec (k); test (k>=0) end;
        if symbols+next>m then ccn:=m-symbols else ccn:=next;
        if cur=1 then begin
          {writeln ('found region');}
          inc (cc); ca[cc]:=symbols; cb[cc]:=symbols+ccn-1;
          {writeln ('1: ', lp, ' ', lc, ' ', la[1], ' ', lb[1]);}
          while (lp<=lc) and (lb[lp]<symbols-1) do inc (lp);
          {writeln ('2: ', lp, ' ', lc, ' ', la[1], ' ', lb[1]);}
          if (lp>lc) or (la[lp]>symbols+ccn) then begin
            inc (comps); inc (colors); cr[cc]:=colors; u[colors]:=colors; h[colors]:=1;
            {writeln ('added new color = ', colors);}
          end else begin
            cr[cc]:=lr[lp];
            while (lp<=lc) and (la[lp]<=symbols+ccn-1) and (lb[lp]<symbols+ccn-1) do begin merge (cr[cc], lr[lp]); inc (lp) end;
            if (lp<=lc) and (la[lp]<=symbols+ccn) then merge (cr[cc], lr[lp]);
          end;
        end;
        inc (symbols, ccn); dec (next, ccn);
      until symbols>=m; test (symbols=m);
      for i:=1 to cc do begin la[i]:=ca[i]; lb[i]:=cb[i]; lr[i]:=cr[i] end;
      lc:=cc;
      inc (lines);
    until lines>=n; test (lines=n);
    test (k=0); test (next=0);
    inc (_);
    writeln (comps);
end.