#include <assert.h>
#include <stdio.h>

#define ALLOW_CONST 0
#define MAXK 4
#define MAXL 4
#define POW  (1 << MAXK)
#define POWM (POW - 1)

int K, L;
int U[POW][MAXL], O[MAXL];
int Q[16] = {3, 5, 0, 15}, qw = 2*(ALLOW_CONST+1);
int F[16], D;
char str[16];

void wk (int a, int b, int c, int d) {
  int i, j, v, w;
  a = Q[a];  b = Q[b];  c = Q[c];  d = Q[d];
  for (j = 0; j < L; j++) O[j] = 0;
  for (i = 0; i < 4; i++) {
    v = ((a & 1) << 3) + ((b & 1) << 2) + ((c & 1) << 1) + (d & 1);
    a >>= 1;  b >>= 1;  c >>= 1;  d >>= 1;
    for (j = 0; j < L; j++)
      O[j] = (O[j] >> 1) + (U[v][j] << 3);
  }
  for (j = 0; j < L; j++) {
    w = O[j];
    if (!F[w]) { F[w] = 1;  Q[qw++] = w; }
  }
}

int main (void) {
  int i, j, a, b, c, qr = 0;
  assert (scanf ("%d%d\n", &K, &L) == 2);
  assert (K > 0 && L > 0 && K <= MAXK && L <= MAXL);
  for (i = 0; i < (1 << K); i++) {
    str[0] = 0;  fgets (str, 15, stdin);
    for (j = 0; j < L; j++) {
      assert (str[j] == '0' || str[j] == '1');
      U[i][j] = str[j] & 1;
    }
    assert (str[L] == '\n');
  }
  for (i = (1 << K); i < POW; i++)
    for (j = 0; j < L; j++) U[i][j] = U[i-(1 << K)][j];
  for (i = 0; i < qw; i++) F[Q[i]] = 1;
  while (qr < qw && !F[8] && !F[14]) {
    for (a = 0; a <= qr; a++)
      for (b = 0; b <= qr; b++)
	for (c = 0; c <= qr; c++) {
	  wk (qr,a,b,c);
	  if (a < qr) { wk(a,qr,b,c);
	  if (b < qr) { wk(a,b,qr,c);
	  if (c < qr) { wk(a,b,c,qr); }}}
	}
    qr++;
  }
  puts (F[8] || F[14] ? "YES" : "NO");
  return 0;
}
