{$Q-,R-,S-,O+}
{$APPTYPE CONSOLE}
program macro;
const MaxN=13{12}; MaxM=1000; MaxTests=100;  MaxP=6;
type Graph = array [1..MaxN, 1..MaxN] of boolean;
     Poly = array [1..16] of integer;
     Arr = array of Poly;
var
  N, M  : integer;
  A     : Graph;
  CM    : array [1..MaxP, 1..MaxN, 1..MaxN] of integer;
  SP    : array [1..MaxN] of Poly;
  C     : array [1..MaxP] of Arr;
  R     : array [1..MaxN] of integer;

procedure prepare;
var p, i, j, u, v, q, x, y, z : integer;
label _1;
begin
  fillchar (SP, sizeof(SP), 0);
  SP[1,1] := 1;
  for p := 2 to MaxN do begin
    SP[p,1] := -SP[p-1,1]*(p-1);
    for i := 2 to p do SP[p,i] := SP[p-1,i-1]-SP[p-1,i]*(p-1);
  end;
  for p := 1 to MaxP do begin
    x := 1;  v := 0;
    for i := 1 to p do
      for j := i + 1 to p do begin
        CM[p,i,j]:=x;  CM[p,j,i]:=x;  x := x shl 1
      end;
    q := p*(p-1) shr 1;
    setlength (C[p], 1 shl q);
    fillchar (C[p,0,1], sizeof(Poly), 0);
    C[p,0,p] := 1;
    for x := 1 to pred (1 shl q) do begin
      u := 0;  z := x;
      for i := 1 to p do
        for j := i + 1 to p do
          if odd(z) then begin u:=i; v:=j; goto _1 end
          else z := z shr 1;
_1:   if u = 0 then runerror (239);
      C[p,x] := C[p,x-CM[p,u,v]];
      for i := 1 to v - 1 do R[i] := i;
      for i := v + 1 to p do R[i] := i-1;
      R[v] := u;  y := 0;  z := x;
      for i := 1 to p do
        for j := i + 1 to p do begin
          if odd(z) then y := y or CM[p-1,R[i],R[j]];
          z := z shr 1
        end;
      for i := 1 to p - 1 do
        C[p,x,i] := C[p,x,i] - C[p-1,y,i]
    end
  end
end;

procedure solve (var R : Poly; var A : Graph;  N : integer);
var x, i, j, u, v  : integer;
    Q  : array [1..MaxN] of integer;
    B  : Graph;
    R1 : Poly;
begin
  if N <= MaxP then begin
    x := 0;
    for i := 1 to N do
      for j := i + 1 to N do
        if A[i,j] then inc (x, CM[N,i,j]);
    R := C[N, x];
    exit
  end;
  M := 0;
  for u := 1 to N do
    for v := u + 1 to N do
      if A[u,v] then inc (M);
  if M*4 > N*(N-1) then begin
    R := SP[N];
    for u := 1 to N do
      for v := u + 1 to N do if not A[u,v] then begin
        for i := 1 to v - 1 do Q[i] := i;
        for i := v + 1 to N do Q[i] := i - 1;
        Q[v] := u;
        fillchar (B, sizeof(B), 0);
        for i := u to N do
          for j := i + 1 to N do
            if A[i,j] then begin B[Q[i],Q[j]] := true;  B[Q[j],Q[i]] := true end;
        solve (R1, B, N - 1);
        for i := 1 to N-1 do {inc (R[i], R1[i])}R[i]:=R[i]+R1[i];
        A[u,v] := true
    end
  end else begin
    fillchar (R, sizeof(R), 0);
    R[N] := 1;
    for u := 1 to N do
      for v := u + 1 to N do if A[u,v] then begin
        A[u,v] := false;
        for i := 1 to v - 1 do Q[i] := i;
        for i := v + 1 to N do Q[i] := i - 1;
        Q[v] := u;
        fillchar (B, sizeof(B), 0);
        for i := u to N do
          for j := i + 1 to N do
            if A[i,j] then begin B[Q[i],Q[j]] := true;  B[Q[j],Q[i]] := true end;
        solve (R1, B, N - 1);
        for i := 1 to N-1 do {dec (R[i], R1[i])}R[i]:=R[i]-R1[i];
      end
  end
end;
      
  
var i, _, u, v : integer;
    Res        : Poly;
begin
  prepare;
  assign (input, 'chrom.in');  reset (input);
  assign (output, 'chrom.out');  rewrite (output);
  _ := 0;
    read (N, M);  
    if _ > MaxTests then runerror (239);
    if (N <= 0) or (N > MaxN) or (M < 0) or (M > MaxM) then runerror (239);
    fillchar (A, sizeof (A), 0);
    for i := 1 to M do begin
      read (u, v);
      if (u<=0) or (v<=0) or (u>N) or (v>N) or (u=v) then runerror(239);
      A[u,v]:=true;  A[v,u]:=true
    end;
    solve (Res, A, N);
    write (N, ' 0');
    for i := 1 to N do write (' ', Res[i]);
    writeln
end.

