{$A+,B-,D+,E-,F-,G+,I-,L+,N+,O-,P-,Q-,R-,S-,T-,V-,X+,Y+}
program macro;

type integer=smallint;

type tarr=array [0..255] of integer;
     parr=^tarr;
     harr=array [0..128] of parr;

var m, p:harr;
    a, v:integer;
    x:longint;


procedure memdump;
var i:word;
begin
  writeln (a);
  for i:=1 to 32768 do writeln (m[hi (i)]^[lo (i)]);
  halt;
end;


procedure checkzero;
begin
  if v<>0 then exit;
  writeln ('DIVISION BY ZERO');
  memdump;
end;


procedure takeaddress;
var c, t:longint;
    steps:word;
begin
  steps:=0;
  c:=x;
  while p[hi (c)]^[lo (c)]<0 do begin
    inc (steps);
    c:=-longint (p[hi (c)]^[lo (c)]);
    if steps>40000 then begin
      writeln ('RUN-TIME ERROR');
      memdump;
    end;
  end;
  t:=x; x:=c; c:=t;
  while p[hi (c)]^[lo (c)]<0 do begin
    t:=-longint (p[hi (c)]^[lo (c)]);
    p[hi (c)]^[lo (c)]:=-x;
    c:=t;
  end;
end;


procedure loadvalue;
var c:char;
begin
  read (c);
  if c='=' then begin
    read (v);
  end else begin
    read (x);
    takeaddress;
    v:=m[hi (x)]^[lo (x)];
  end;
end;


procedure storevalue;
var c:char;
begin
  read (c);
  read (x);
  takeaddress;
  m[hi (x)]^[lo (x)]:=a;
  p[hi (x)]^[lo (x)]:=a;
end;


var i:integer;
    c:char;

begin
  assign (input, 'indirect.in'); reset (input);
  assign (output, 'indirect.out'); rewrite (output);
  for i:=0 to 128 do begin
    new (m[i]); new (p[i]);
    fillchar (m[i]^, sizeof (m[i]^), 0);
    fillchar (p[i]^, sizeof (p[i]^), 0);
  end;
  repeat
    read (c);
    case c of
      'A':begin loadvalue; a:=a+v; end;
      'S':begin loadvalue; a:=a-v; end;
      'M':begin loadvalue; a:=a*v; end;
      'D':begin loadvalue; checkzero; a:=a div v; end;
      'O':begin loadvalue; checkzero; a:=a mod v; end;
      'R':begin loadvalue; a:=v; end;
      'W':storevalue;
    end;
    readln;
  until eof;
  writeln ('SUCCESSFUL TERMINATION');
  memdump;
end.