{$A+,B-,D+,E+,F-,G-,I+,L+,N-,O-,P-,Q+,R+,S+,T-,V+,X+}
program macro;
const maxm=1000; maxn=1000; maxr=1000; maxi=1000000;


function getop (var o:string;var v:integer):integer;
var tmp:integer;
begin
  if o='' then begin getop:=3;v:=0;exit;end;
  if o[1]='*' then begin getop:=2;o:=copy (o, 2, 255) end else
  if o[1]='=' then begin getop:=0;o:=copy (o, 2, 255) end else
  getop:=1;
  val (o, v, tmp);
  if tmp<>0 then runerror (239);
end;

type oc=(_loadi, _loadr, _loadc,
         _storer, _storec,
         _addi, _addr, _addc,
         _subi, _subr, _subc,
         _multi, _multr, _multc,
         _divi, _divr, _divc,
         _readr, _readc,
         _writei, _writer, _writec,
         _jump, _jgtz, _jzero,
         _halt);

type instr=record
     c:oc;
     p:integer;
     end;

var pr:array [0..maxm-1] of instr;
    f:array [0..maxr-1] of boolean;
    val:array [0..maxr-1] of integer;
    n:integer;

procedure store (r, value:integer);
begin
  f[r]:=true;
  val[r]:=value;
end;


function load (r:integer):integer;
begin
  if not f[r] then runerror (239);
  load:=val[r];
end;


function infile:integer;
var tmp:integer;
begin
  dec (n); if n<0 then runerror (239);
  read (tmp);infile:=tmp;
end;


procedure outfile (value:integer);
begin
  writeln (value);
end;

var p:integer;
    c, o, s:string;
    i, m, t, ov, v, ip:integer;
    newip:integer;

begin
  assign (input, 'in.txt'); reset (input);
  assign (output, 'out.txt'); rewrite (output);
  ip:=0;
  readln (m, n);
  if (m<1) or (m>maxm) or (n<1) or (n>maxn) then runerror (239);
  for i:=0 to m-1 do
    begin
      readln (s);
      s:=s;
      c:=''; o:='';
      p:=1;
      while (s[p]<>' ') and (p<=length (s)) do begin c:=c+s[p]; inc (p);end;
      while (s[p]=' ') and (p<=length (s)) do inc (p);
      if c<>'HALT' then
        begin
          if p>length (s)then runerror (239);
          while p<=length (s) do begin o:=o+s[p]; inc (p);end;
        end;
      if p<=length (s) then runerror (239);
      t:=getop (o, v);
      pr[i].p:=v;
      if ((v<0) or (v>=maxr)) and (t<>0) then runerror (239);
      if c='LOAD' then
        case t of
          0:pr[i].c:=_loadi;
          1:pr[i].c:=_loadr;
          2:pr[i].c:=_loadc;
        else runerror (239);
        end
      else
      if c='STORE' then
        case t of
          1:pr[i].c:=_storer;
          2:pr[i].c:=_storec;
        else runerror (239);
        end
      else
      if c='ADD' then
        case t of
          0:pr[i].c:=_addi;
          1:pr[i].c:=_addr;
          2:pr[i].c:=_addc;
        else runerror (239);
        end
      else
      if c='SUB' then
        case t of
          0:pr[i].c:=_subi;
          1:pr[i].c:=_subr;
          2:pr[i].c:=_subc;
        else runerror (239);
        end
      else
      if c='MULT' then
        case t of
          0:pr[i].c:=_multi;
          1:pr[i].c:=_multr;
          2:pr[i].c:=_multc;
        else runerror (239);
        end
      else
      if c='DIV' then
        case t of
          0:pr[i].c:=_divi;
          1:pr[i].c:=_divr;
          2:pr[i].c:=_divc;
        else runerror (239);
        end
      else
      if c='READ' then
        case t of
          1:pr[i].c:=_readr;
          2:pr[i].c:=_readc;
        else runerror (239);
        end
      else
      if c='WRITE' then
        case t of
          0:pr[i].c:=_writei;
          1:pr[i].c:=_writer;
          2:pr[i].c:=_writec;
        else runerror (239);
        end
      else
      if c='JUMP' then
        if t=1 then begin pr[i].c:=_jump; if pr[i].p>=m then runerror (239);end
        else runerror (239)
      else
      if c='JGTZ' then
        if t=1 then begin pr[i].c:=_jgtz; if pr[i].p>=m then runerror (239);end
        else runerror (239)
      else
      if c='JZERO' then
        if t=1 then begin pr[i].c:=_jzero; if pr[i].p>=m then runerror (239);end
        else runerror (239)
      else
      if c='HALT' then
        if t=3 then pr[i].c:=_halt
        else runerror (239)
      else runerror (239);
    end;
  repeat
    newip:=-1;
    case pr[ip].c of
      _loadi:store (0, pr[ip].p);
      _loadr:store (0, load (pr[ip].p));
      _loadc:store (0, load (load (pr[ip].p)));
      _storer:store (pr[ip].p, load (0));
      _storec:store (load (pr[ip].p), load (0));
      _addi:store (0, load (0)+pr[ip].p);
      _addr:store (0, load (0)+load (pr[ip].p));
      _addc:store (0, load (0)+load (load (pr[ip].p)));
      _subi:store (0, load (0)-pr[ip].p);
      _subr:store (0, load (0)-load (pr[ip].p));
      _subc:store (0, load (0)-load (load (pr[ip].p)));
      _multi:store (0, load (0)*pr[ip].p);
      _multr:store (0, load (0)*load (pr[ip].p));
      _multc:store (0, load (0)*load (load (pr[ip].p)));
      _divi:store (0, load (0) div pr[ip].p);
      _divr:store (0, load (0) div load (pr[ip].p));
      _divc:store (0, load (0) div load (load (pr[ip].p)));
      _readr:store (pr[ip].p, infile);
      _readc:store (load (pr[ip].p), infile);
      _writei:outfile (pr[ip].p);
      _writer:outfile (load (pr[ip].p));
      _writec:outfile (load (load (pr[ip].p)));
      _jump:newip:=pr[ip].p;
      _jgtz:if load (0)>0 then newip:=pr[ip].p;
      _jzero:if load (0)=0 then newip:=pr[ip].p;
      _halt:begin for i:=1 to n do
                  begin if seekeof then runerror (239);read (m);end;
                  if not seekeof then runerror (239);
                  halt;end;
    end;
    if newip>=0 then ip:=newip else inc (ip);
    if (ip<0) or (ip>=m) then runerror (239);
  until false;

end.