{$A+,B-,D+,E-,F-,G+,I+,L+,N+,O-,P-,Q+,R+,S+,T-,V+,X+,Y+}
{$M 16384,0,655360}
program macro;
const MaxN = 100000;
      eps = 1e-14;
type float = extended;

var
  N, i          : longint;
  x, y, z       : float;
  A, B, C, D, E : float;
  G0, G1, Disc, L, U, V, W, t : float;
begin
  assign (input, 'bestline.in');  reset (input);
  assign (output, 'bestline.out');  rewrite (output);
  read (N);
  if (N <= 0) or (N > MaxN) then runerror (239);
  A := 0;  B := 0;  C := 0;  D := 0;  E := 0;
  for i := 1 to N do begin
    read (x, y);
    A := A + x*x;  B := B + x*y;  C := C + y*y;
    D := D + x;    E := E + y
  end;
  G1 := (A*N - sqr(D)) + (C*N - sqr(E));
  G0 := (A*C*N + 2*B*D*E - C*D*D - A*E*E - N*B*B);
  Disc := sqr (G1) - 4*N*G0;
  if Disc < 0 then runerror (239);
  if Disc <= 0 then L := G1 / (2*N)
               else L := (G0 * 2) / (G1 + sqrt (Disc));
  U := (A-L)*N - D*D;
  V := B*N - D*E;
  W := (C-L)*N - E*E;
  if abs (U) < eps then begin x := W;   y := -V end
                   else begin x := -V;  y := U end;
  if (abs(x) < eps) and (abs(y) < eps) then begin x:=1; y:=0 end;
  z := (-D*x-E*y) / N;
  t := 1 / sqrt (sqr(x) + sqr(y));
  if z < 0 then t := -t;
  x := x * t;  y := y*t;  z := z*t;
  writeln (L:10:10);
  writeln (-x:10:10, ' ', -y:10:10, ' ', z:10:10);
end.
