program sort;

{$APPTYPE CONSOLE}

const
  FILE_IN='sort.in';
  FILE_OUT='sort.out';
  NMAX=20005;
type
  string20=string[20];
  pupil=record
    fname:string20;
    sname:string20;
    number:longint;
  end;
  tpupil=^pupil;
  atpupils=array[1..NMAX] of tpupil;
var
  pupils:array[1..NMAX] of pupil;
  list:atpupils;
  n:longint;

Procedure QSort(var a:atpupils;n:longint);
Procedure swap(var a,b:tpupil);
var
  c:tpupil;
begin
  c:=a;
  a:=b;
  b:=c;
end;

function comp(a,b:tpupil):boolean;
begin
  if (a^.fname<b^.fname) then
  begin
    comp:=true;
    exit;
  end else
  if (a^.fname>b^.fname) then
  begin
    comp:=false;
    exit;
  end else comp:=(a^.number<b^.number);
end;

Procedure sort(s,f:longint);
var
  mid:tpupil;
  i,j:longint;
begin
  i:=s;
  j:=f;
  mid:=a[(s+f) div 2];
  repeat
    while (comp(a[i],mid)) do inc(i);
    while (comp(mid,a[j])) do dec(j);
    if (i<=j) then
    begin
      swap(a[i],a[j]);
      inc(i);
      dec(j);
    end;
  until i>j;
  if (s<j) then sort(s,j);
  if (i<f) then sort(i,f);
end;
begin
  sort(1,n);
end;


Procedure ReadName(var name:string20);
var
  ch:char;
begin
  name:='';
  repeat
    read(ch);
    if (ch<>' ') and (ord(ch)<>13) and (ord(ch)<>26) then name:=name+ch;
  until (ch=' ') or (ord(ch)=13) or (ord(ch)=26);
  if (ord(ch)=13) then read(ch);
end;

Procedure OutData();
var
  i:longint;
begin
  assign(output,FILE_OUT);
  rewrite(output);

  writeln(n);

  for i:=1 to n do
  begin
    writeln(list[i]^.fname,' ',list[i]^.sname);
  end;

  close(output);
end;

Procedure Solve();
var
  i:longint;
begin
  for i:=1 to n do
  begin
    list[i]:=@pupils[i];
  end;
  QSort(list,n);
end;

Procedure InitData();
begin
  fillchar(pupils,sizeof(pupils),0);
end;

Procedure ReadData();
var
  i:longint;
begin
  assign(input,FILE_IN);
  reset(input);
  readln(n);
  for i:=1 to n do
  begin
    ReadName(pupils[i].fname);
    ReadName(pupils[i].sname);
    pupils[i].number:=i;
  end;

end;

begin
  InitData();
  ReadData();
  Solve();
  OutData();
end.
