{$Q-,R-,I-,S-,D-,L-,N+}
Program Sinus;
Type
  Int=Longint;
  Real=Extended;
Const
  FileIn='sin.in';
  FileOut='sin.out';
  Inf=1000000000;
  MaxN=101;
Var
  F:Array[0..MaxN,0..MaxN,0..MaxN] Of Real;
  From:Array[0..MaxN,0..MaxN,0..MaxN,1..3] Of Int;
  A,B:Array[0..MaxN] Of Int;
  N,K:Int;
  Path:Array[0..MaxN] Of Int;
  Ans:Real;

Procedure OpenFiles;
  Begin
    Assign(Input,FileIn);
    Assign(Output,FileOut);
    Reset(Input);
    Rewrite(Output);
  End;

Procedure Init;
  Var i:Int;
  Begin
    Read(N);
    For i:=1 To N Do Read(B[i]);
  End;

Function Min(x,y:Int):Int;
  Begin
    If x<y Then Min:=x Else Min:=y;
  End;

Procedure Rec(x,y,z:Int);
  Begin
    Path[y]:=z;
    If y<>2 Then
      Begin
        Rec(x-z,y-1,From[x][y][z][3]);
      End Else
        Path[1]:=x-z;
  End;

Procedure Solve;
  Var i,j,l,r,resk:Int;
      resi,resj,resl:Int;
      cur:Real;
  Begin
    Ans:=-Inf;
    For i:=1 To N Do
      For j:=1 To N Do
        For l:=1 To N Do F[i][j][l]:=-Inf;
    For i:=1 To N-1 Do
      For j:=1 To N-i Do F[i+j][2][j]:=Sin(2*B[1]*i*j);
    For i:=3 To N Do
      For j:=3 To i Do
        For l:=1 To i-(j-1) Do
          For r:=1 To (i-l)-(j-2) Do
            Begin
              cur:=F[i-l][j-1][r]+Sin(j*B[j-1]*l*r);
              If cur>F[i][j][l] Then
                Begin
                  F[i][j][l]:=cur;
                  From[i][j][l][3]:=r;
                End;
            End;
    For j:=1 To N Do
      For l:=1 To N Do
        If F[N][j][l]/j>Ans Then
            Begin
              Ans:=F[N][j][l]/j;resk:=j;
              resl:=l;
            End;
    Writeln(Ans:0:6);
    Rec(N,resk,resl);
    For i:=1 To resk Do Write(Path[i],' ');
  End;

Procedure CloseFiles;
  Begin
    Close(Input);
    Close(Output);
  End;

Begin
  OpenFiles;
  Init;
  Solve;
  CloseFiles;
End.
