{$Q-,R-,I-,S-,D-,L-,N+}
Program Small;
Type
  Int=Longint;
  Real=Extended;
Const
  FileIn='small.in';
  FileOut='small.out';
  Inf=1000000000;
  N=100;
Var
  A:Array[0..N+10,0..N+10] Of Int;
  G:Array[0..N+10,0..N+10,0..N+10] Of Int;
  Sum:Array[0..N+10,0..N+10] Of Int;
  G1:Array[0..N+10,0..N+10] Of Int;
  Map:Array[0..N+10,0..N+10] Of Byte;
  From:Array[0..N+10,0..N+10] Of Int;
  Divisions:Array[0..N+10] Of Int;
  Ans,AmDivisions,Abled:Int;
  AmGoodHomes,Parts:Int;

Procedure OpenFiles;
  Begin
    Assign(Input,FileIn);
    Assign(Output,FileOut);
    Reset(Input);
    Rewrite(Output);
  End;

Procedure Init;
  Var i,l,k:Int;
  Begin
    Fillchar(Map,Sizeof(Map),0);
    Read(AmGoodHomes);
    For i:=1 To AmGoodHomes Do
      Begin
        Read(l,k);Map[k][l]:=1;
      End;
    Read(AmDivisions);
    For i:=1 To AmDivisions Do Read(Divisions[i]);
    Read(Abled);
  End;

Procedure Fill_Sum;
  Var i,j,k:Int;
      cur:Int;
  Begin
    For k:=1 To AmDivisions-1 Do
      Begin
        cur:=0;
        Sum[1][k]:=0;
        For i:=1 To N-1 Do
          Begin
            For j:=Divisions[k] To Divisions[k+1]-1 Do
              Inc(cur,Map[i][j]);
            Sum[i+1][k]:=cur;
          End;
      End;
    Parts:=AmDivisions-1;
  End;

Procedure Fill_G1;
  Var i,j,k:Int;
  Begin
    Fillchar(G1,Sizeof(G1),0);
    For i:=1 To N Do
      For j:=i To N Do
        For k:=1 To Parts Do
          If Sum[j][k]-Sum[i][k]>0 Then Inc(G1[i][j]);
  End;

Procedure Rec(x,y:Int);
  Begin
    If x<>1 Then Rec(From[x][y],y-1);
    Write(x,' ');
  End;

Procedure Solve;
Var i,j,k:Int;
  Begin
    Fill_Sum;
    Fill_G1;
    Fillchar(A,Sizeof(A),0);
    Dec(Abled);
    A[1][0]:=0;
    For i:=1 To N Do
      For j:=i To N Do A[i][j]:=-Inf;
    For i:=2 To N Do
      For j:=1 To Abled Do
        Begin
          A[i][j]:=-Inf;
          For k:=1 To i-1 Do
            If A[k][j-1]+G1[k][i]>A[i][j] Then
              Begin
                A[i][j]:=A[k][j-1]+G1[k][i];
                From[i][j]:=k;
              End;
        End;
    Ans:=A[N][Abled];
{    Writeln(Ans);}
    Write(Abled+1,' ');
    Rec(N,Abled);
  End;

Procedure CloseFiles;
  Begin
    Close(Input);
    Close(Output);
  End;

Begin
  OpenFiles;
  Init;
  Solve;
  CloseFiles;
End.
