{$Q-,R-,I-,S-,D-,L-,N+}
Program Polygon;
{Eva rulezzz!!!}
Uses SysUtils;
Type
  Int=Longint;
  Real=Extended;
  TPoint=Record
    x,y:Int;
    angle:Real;
    rname:Int;
    End;
//  Int64=Longint;
  PList=^TList;
  TList=Record
    x:Int;
    next:PList;
    End;
Const
  FileIn='polygon.in';
  FileOut='polygon.out';
  MaxN=301;
  Limit=3.9;
Var
  N,Ans:Int;
  A:Array[0..MaxN] Of TPoint;
  B:Array[0..MaxN] Of TPoint;
  G:Array[0..MaxN,0..MaxN] Of PList;
  Pos_in_B:Array[0..MaxN] Of Int;
  F:Array[0..MaxN,0..MaxN] Of Int;

Procedure OpenFiles;
  Begin
    Assign(Input,FileIn);
    Assign(Output,FileOut);
    Reset(Input);
    Rewrite(Output);
  End;

Procedure Init;
  Var i:Int;
      k,l:Real;
  Begin
    Read(N);
    For i:=1 To N Do
      Begin
        Read(k,l);
        A[i].x:=Trunc(k*1000);A[i].y:=Trunc(l*1000);
      End;
  End;

Function Good_of_me(p:TPoint;p1:TPoint):Boolean;
  Begin
    Good_of_me:=(p.y>p1.y)Or((p.y=p1.y)And(p.x>p1.x));
  End;

Procedure Swap_TPoint(Var p1,p2:TPoint);
  Var t:TPoint;
  Begin
    t:=p1;p1:=p2;p2:=t;
  End;

Procedure QSort(l,r:Int);
  Var i,j:Int;
      t:Real;
  Begin
    i:=l;j:=r;t:=B[l+Random(r-l+1)].angle;
    Repeat
      While B[i].angle<t Do Inc(i);
      While B[j].angle>t Do Dec(j);
      If i<=j Then
        Begin
          Swap_TPoint(B[i],B[j]);
          Inc(i);Dec(j);
        End;
      Until i>j;
    If i<r Then QSort(i,r);
    If l<j Then QSort(l,j);
  End;

Function Vect(p1,p2,p3,p4:TPoint):Int64;
  Var x1,y1,x2,y2:Int64;
  Begin
    x1:=p2.x-p1.x;y1:=p2.y-p1.y;
    x2:=p4.x-p3.x;y2:=p4.y-p3.y;
    Vect:=x1*y2-x2*y1;
  End;

Procedure HIM(Starter:Int);
  Var i,j,k:Int;
      M:Int;
      r:Real;
      rk:Int;
      p:PList;
  Begin
    M:=1;B[1]:=A[Starter];B[1].angle:=0;
    For i:=1 To N Do
      If Good_Of_Me(A[i],A[Starter]) Then
        Begin
          Inc(M);
          If A[i].x=A[Starter].x Then r:=Pi/2 Else
            If A[i].x>A[Starter].x Then
              r:=ArcTan((A[i].y-A[Starter].y)/(A[i].x-A[Starter].x)) Else
                r:=Pi/2+ArcTan((A[Starter].x-A[i].x)/(A[i].y-A[Starter].y));
          B[M]:=A[i];B[M].angle:=r;
        End;
    Fillchar(Pos_In_B,Sizeof(Pos_in_b),0);
    For i:=1 To M Do
      Pos_in_B[B[i].rname]:=i;
    If (M<=Ans)Or(M<3) Then Exit;
    QSort(2,M);
    For i:=2 To M Do
      F[i][1]:=2;
    For i:=3 To M Do
      For j:=2 To i-1 Do
        Begin
          F[i][j]:=0;
          p:=G[B[i].rname][B[j].rname];
          While p<>Nil Do
            Begin
              rk:=Pos_in_B[p^.x];
              If (rk=0)Or(rk>=j) Then Begin p:=p^.next;Continue;End;
              If F[j][rk]+1>F[i][j] Then F[i][j]:=F[j][rk]+1;
              p:=p^.next;
            End;
          If F[i][j]+M-i<=Ans Then F[i][j]:=0 Else
            Begin
              If (F[i][j]>Ans)And(Vect(B[j],B[i],B[i],B[1])>0) Then
                Ans:=F[i][j];
            End;
        End;
  End;

Procedure QSort_A(l,r:Int);
  Var i,j,t:Int;
  Begin
    i:=l;j:=r;t:=A[l+Random(r-l+1)].y;
    Repeat
      While A[i].y<t Do Inc(i);
      While A[j].y>t Do Dec(j);
      If i<=j Then
        Begin
          Swap_TPoint(A[i],A[j]);
          Inc(i);Dec(j);
        End;
      Until i>j;
    If i<r Then QSort_A(i,r);
    If l<j Then QSort_A(l,j);
  End;

Procedure Get_G;
  Var i,j,k:Int;
      p:PList;
  Begin
    For i:=1 To N Do
      For j:=1 To N Do G[i][j]:=Nil;
    For i:=1 To N Do
      For j:=1 To N Do
        For k:=1 To N Do
          Begin
            If (i=j)Or(i=k)Or(j=k) Then Continue;
            If Vect(A[k],A[j],A[j],A[i])>0 Then
              Begin
                New(p);p^.x:=k;
                p^.next:=G[i][j];G[i][j]:=p;
              End;
          End;
  End;

Procedure Solve;
  Var i:Int;
      cur,st:Real;
  Begin
    st:=Now;
    QSort_A(1,N);
    Get_G;
    For i:=1 To N Do A[i].rname:=i;
    Ans:=0;
    For i:=1 To N Do
      Begin
        HIM(i);
        cur:=now;
//        If ((cur-st))>=Limit Then Break;
      End;
    Writeln(Ans);
  End;

Procedure CloseFiles;
  Begin
    Close(Input);
    Close(Output);
  End;

Begin
  OpenFiles;
  Init;
  Solve;
  CloseFiles;
End.
