{$Q-,R-,I-,S-,D-,L-,N+}
Program Young;
{Eva rulezzz!!!}
Type
  Int=Longint;
  Real=Extended;
Const
  FileIn='young.in';
  FileOut='young.out';
  MaxN=51;
Var
  A:Array[0..MaxN,0..MaxN] Of Int;
  F1,F2,F3:Array[0..MaxN,0..MaxN] Of Boolean;
  Avaliable:Array[0..MaxN] Of Int;
  AmOnFLines:Array[0..MaxN,0..MaxN] Of Int;
  Used:Array[0..MaxN] Of Int;
  Ans,Size1,Size2,Size3:Int;
  AmExist,AmAvaliable,Left:Int;
  Exist:Array[0..MaxN,1..2] Of Int;
  MaxColor:Int;

Procedure OpenFiles;
  Begin
    Assign(Input,FileIn);
    Assign(Output,FileOut);
    Reset(Input);
    Rewrite(Output);
  End;

Procedure CloseFiles;
  Begin
    Close(Input);
    Close(Output);
  End;

Procedure Init;
  Var i,j,cnt:Int;
  Begin
    Fillchar(F1,Sizeof(F1),False);
    Read(i);Size1:=0;cnt:=0;
    If i=-1 Then
      Begin
        CloseFiles;Halt(0);
      End;
    While i<>0 Do
      Begin
        Inc(Size1,i);Inc(cnt);
        For j:=1 To i Do F1[cnt][j]:=True;
        Read(i);
      End;
    Fillchar(F2,Sizeof(F2),False);
    Read(i);Size2:=0;cnt:=0;
    Fillchar(Avaliable,Sizeof(Avaliable),0);
    While i<>0 Do
      Begin
        Inc(Size2,i);Inc(cnt);
        Avaliable[cnt]:=i;
        For j:=1 To i Do F2[cnt][j]:=True;
        Read(i);
      End;
    Fillchar(F3,Sizeof(F3),False);
    Read(i);Size3:=0;cnt:=0;
    While i<>0 Do
      Begin
        Inc(Size3,i);Inc(cnt);
        For j:=1 To i Do F3[cnt][j]:=True;
        Read(i);
      End;
  End;

Procedure Fill_avaliable_and_Exist;
  Var i,j:Int;
  Begin
    Left:=0;AmExist:=0;
    For i:=1 To MaxN Do
      For j:=1 To MaxN Do
        Begin
          If Not F3[i][j] Or F1[i][j] Then A[i][j]:=-1;
          If F3[i][j] And Not F1[i][j] Then
            Begin
              Inc(AmExist);
              Exist[AmExist][1]:=i;Exist[AmExist][2]:=j;
              MaxColor:=i;
            End;
          If Not F3[i][j] And F1[i][j] Then Ans:=-1;
        End;
    If AmExist<>Size2 Then Ans:=-1;
  End;

Function Max(x,y:Int):Int;
  Begin
    If x>y Then Max:=x Else Max:=y;
  End;

Function Rec(pos:Int;num:Int):Int;
  Var i,rs:Int;
      x,y,dx:Int;
      p1,p2:Boolean;
      Label 1;
  Begin
    x:=Exist[pos][1];y:=Exist[pos][2];
    Inc(Used[num]);
    A[x][y]:=num;
    If A[x+1][y]=-1 Then Begin p1:=True;A[x+1][y]:=num;End Else p1:=False;
    If A[x][y+1]=-1 Then Begin p2:=True;A[x][y+1]:=num;End Else p2:=False;
    AmOnFLines[x][num]:=Used[num];
    Dec(Avaliable[num]);
    rs:=0;
    dx:=0;For i:=1 To y-1 Do If A[x][i]=num-1 Then Inc(dx);
    If AmOnFLines[x][num]>Used[num-1]-dx Then Goto 1;
    If pos=AmExist Then Begin rs:=1;Goto 1;End;
    For i:=Max(A[Exist[pos+1][1]][Exist[pos+1][2]-1],
               A[Exist[pos+1][1]-1][Exist[pos+1][2]]+1) To MaxColor Do
                 If Avaliable[i]>0 Then
                   Inc(rs,Rec(pos+1,i));
    1:
    Rec:=rs;
    If p1 Then A[x+1][y]:=-1;
    If p2 Then A[x][y+1]:=-1;
    Dec(AmOnFLines[x][num]);
    Inc(Avaliable[num]);
    Dec(Used[num]);
  End;

Procedure Solve;
  Var i:Int;
  Begin
    Fillchar(A,Sizeof(A),0);
    Fillchar(Used,Sizeof(Used),0);
    Used[0]:=1000;
    For i:=1 To MaxN Do A[0][i]:=0;
    For i:=1 To MaxN Do A[i][0]:=1;
    Fillchar(AmOnFLines,Sizeof(AmOnFLines),0);
    For i:=0 To MaxN Do AmOnFLines[i][0]:=100;
    For i:=1 To MaxN Do AmOnFLines[0][i]:=0;
    Ans:=0;
    Fill_Avaliable_And_Exist;
    If Ans=-1 Then Begin Writeln(0);Exit;End;
    For i:=1 To MaxN Do
      If Avaliable[i]>0 Then Inc(Ans,Rec(1,i));
    Writeln(Ans);
  End;

Begin
  OpenFiles;
  While True Do
    Begin
      Init;
      Solve;
    End;
  CloseFiles;
End.