{$Q+,R+,I+,S+,D+,L+,N+}
Program Chrom;
Type
  Int=Longint;
  Real=Extended;
Const
  FileIn='chrom.in';
  FileOut='chrom.out';
Var N,M:Int;

Procedure OpenFiles;
  Begin
    Assign(Input,FileIn);
    Assign(Output,FileOut);
    Reset(Input);
    Rewrite(Output);
  End;

Procedure Init;
  Begin
    Read(N,M);
  End;

Procedure Solve;
  Var i:Int;
  Begin
    If N=1 Then
      Begin
        Write('1 0 1');
        Exit;
      End;
    If N=2 Then
      Begin
        If M=0 Then Write('2 0 0 1');
        If M=1 Then Write('2 0 -1 1');
        Exit;
      End;
    If N=3 Then
      Begin
        If M=0 Then Write('3 0 0 0 1');
        If M=1 Then Write('3 0 0 -1 1');
        If M=2 Then Write('3 0 1 -2 1');
        If M=3 Then Write('3 0 2 -3 1');
        Exit;
      End;
    If M=1 Then
      Begin
        Write(N,' ');
        For i:=1 To N-1 Do Write('0 ');
        Write('-1 1');
        Exit;
      End;
    If M=2 Then
      Begin
        Write(N,' ');
        For i:=1 To N-2 Do Write('0 ');
        Write('1 -2 1');
        Exit;
      End;
  End;

Procedure CloseFiles;
  Begin
    Close(Input);
    Close(Output);
  End;

Begin
  OpenFiles;
  Init;
  Solve;
  CloseFiles;
End.