{$A+,B-,C+,D-,E-,F-,G+,H+,I-,J-,K-,L-,M-,N+,O+,P+,Q-,R-,S-,T-,U-,V+,W-,X+,Y+,Z1}
program ZadA;

type
  int=longint;

const
  input_file='kitten.in';
  output_file='kitten.out';
  c = 1000002;
  maxN=2000005;
  logN=21;
var
  cherti:array [1..1 shl 22]of int;
  est:array [1..maxN]of boolean;

function GetElCherti(LogRazm,Num:int):int;
 begin
  GetElCherti:=cherti[ ( 1 shl (Logn-LogRazm) ) + Num];
 end;

function GetCherti(Num:int):int;
 var
  temp,i:int;
 begin
  temp:=0;
  for i:= 0 to logN do
    if ((Num shr i) and 1) = 1 then
      temp:=temp+GetElCherti(i,(Num shr i) -1);
  GetCherti:=temp;
 end;

procedure WriteElCherti(LogRazm,Num:int);
 begin
  inc(cherti[ ( 1 shl (Logn-LogRazm) ) + Num]);
 end;

procedure WriteCherti(Num:int);
 var
  i:int;
 begin
  if not est[Num] then
    for i:=0 to logN do
      WriteElCherti(i,(Num-1) div (1 shl i));
  est[Num]:=true;
 end;

function min(a,b:int):int;
begin
 if a>b then min:=b else min:=a;
end;

function max(a,b:int):int;
begin
 if a>b then max:=a else max:=b;
end;

procedure Run;
 var
  i,n1,n2,io:int;
  s,s1,s2:string;
 begin
  fillchar(cherti,sizeof(cherti),0);
  fillchar(est,sizeof(est),false);

  while not seekeof do
    begin
      Readln(s);
      while s[1]= ' ' do delete(s,1,1);
      while s[length(s)]= ' ' do delete(s,length(s),1);
      if Pos(' ',s)=0 then
        begin
          Val(s,n1,io);
          WriteCherti(n1+c);
        end
      else
        begin
          s1:=copy(s, 1, pos(' ',s)-1 );
          s2:=copy(s, pos(' ',s)+1,length(s)-pos(' ',s) );
          Val( s1 , n1,io);
          Val( s2 , n2,io);
          Writeln(GetCherti(max(n1,n2)+c)-GetCherti(min(n1,n2)+c-1));
        end;
    end;




 end;

procedure OpenFiles;
begin
 Assign(input,input_file);
 Reset(input);
 Assign(output,output_file);
 Rewrite(output);
end;

procedure CloseFiles;
begin
 Close(input);
 Close(output);
end;

begin
OpenFiles;
Run;
CloseFiles;
end.
