{$D-,H-,I-,L-,Q-,R-,S-}
program ZadA;

type
  int=longint;

const
  input_file='indirect.in';
  output_file='indirect.out';
  succ='SUCCESSFUL TERMINATION';
  divzer='DIVISION BY ZERO';
  runtime='RUN-TIME ERROR';
  XXX=32768;
  YYY=65536;
var
  mem: array [1..XXX]of int;
  akkum:int;


procedure CloseFiles; forward;

function IntTo16bit(a:int):int;
 var
   t:int;
 begin
  t:=a mod YYY;
  if t>xxx-1 then
    t:=t-yyy;
  if t<-xxx then
    t:=t+yyy;
  IntTo16bit:=t;
 end;


procedure DumpMem;
 var
  i:int;
 begin
  Writeln(akkum);
  for i := 1to XXX do
    Writeln(mem[i]);
 end;


function GetMem(t:int):int;
 var
  k:int;
  tt:int;
 begin
  k:=0;
  tt:=t;
  while not (mem[tt]>=0)do
    begin
      inc(k);
      tt:=abs(mem[tt]);
      if k>XXX+10 then
        begin
          Writeln(runtime);
          DumpMem;
          CloseFiles;
          halt(0);
        end;
    end;
  GetMem:=Mem[tt];
 end;


procedure WriteMem(t:int);
 var
  k:int;
  tt:int;
 begin
  k:=0;
  tt:=t;
  while not (mem[tt]>=0)do
    begin
      inc(k);
      tt:=abs(mem[tt]);
      if k>XXX+10 then
        begin
          Writeln(runtime);
          DumpMem;
          CloseFiles;
          halt(0);
        end;
    end;
  Mem[tt]:=akkum;
 end;




procedure Run;
 var
  i,j: int;
  ch1,ch2:char;
  t,tt:int;
 begin
  fillchar(mem,sizeof(mem),0);
  akkum:=0;
  while not seekeof do
    begin
      Read(ch1,ch2);
      Readln(t);


      case ch1 of
       'A':
         case ch2 of
           '*':
             akkum:=IntTo16bit(akkum+GetMem(t));
           '=':
             akkum:=IntTo16bit(akkum+t);
           end;
       'S':
         case ch2 of
           '*':
             akkum:=IntTo16bit(akkum-GetMem(t));
           '=':
             akkum:=IntTo16bit(akkum-t);
           end;
       'M':
         case ch2 of
           '*':
             akkum:=IntTo16bit(akkum*GetMem(t));
           '=':
             akkum:=IntTo16bit(akkum*t);
           end;
       'D':
         case ch2 of
           '*':
             begin
               tt:=GetMem(t);
               if tt=0 then
                 begin
                   writeln(divzer);
                   DumpMem;
                   exit;
                 end
               else
                 akkum:=IntTo16bit(akkum div tt);
             end;
           '=':
             begin
               if t=0 then
                 begin
                   writeln(divzer);
                   DumpMem;
                   exit;
                 end
               else
                 akkum:=IntTo16bit(akkum div t);
             end;
           end;
       'O':
         case ch2 of
           '*':
             begin
               tt:=GetMem(t);
               if tt=0 then
                 begin
                   writeln(divzer);
                   DumpMem;
                   exit;
                 end
               else
                 akkum:=IntTo16bit(akkum mod tt);
             end;
           '=':
             begin
               if t=0 then
                 begin
                   writeln(divzer);
                   DumpMem;
                   exit;
                 end
               else
                 akkum:=IntTo16bit(akkum mod t);
             end;
           end;
       'R':
         case ch2 of
           '*':
             akkum:=GetMem(t);
           '=':
             akkum:=t;
           end;
       'W':
         WriteMem(t);
       end;
    end;

  Writeln(succ);
  DumpMem;

 end;

procedure OpenFiles;
begin
 Assign(input,input_file);
 Reset(input);
 Assign(output,output_file);
 Rewrite(output);
end;

procedure CloseFiles;
begin
 Close(input);
 Close(output);
end;

begin
OpenFiles;
Run;
CloseFiles;
end.
