{$D-,H-,I-,L-,Q-,R-,S-}
program ZadC;

type
  int=longint;
  TOperator = record
    tip:int;
{
1  Load
2  Store
3  Add
4  Sub
5  Mult
6  Div
7  Read
8  Write
9  Jump
10  Jgtz
11 Jzero
12 Halt
}
    operand:int;
{
1  -  =i
2  -  i
3  -  *i
}
    num:int;
    end;

const
  input_file='ram.in';
  output_file='ram.out';
  maxN=1000;
  maxM=1000;

var
  code:array[0..maxM]of TOperator;
  ForRead:array[1..maxN]of int;
  UkazRead:int;
  m,n:int;


function GetRead:int;
begin
inc(UkazRead);
GetRead:=ForRead[ukazRead];
end;

procedure Run;
 var
  i,j,io,t:int;
  s,s1:string;
  cur:int;
  Reg:array[0..maxN]of int;
 begin
  ReadLn(M,N);
  for i := 0 to m-1 do
    begin
      ReadLn(S);
      S1:=copy(s,1,2);
      if s1='LO' then
        code[i].tip:=1;
      if s1='ST' then
        code[i].tip:=2;
      if s1='AD' then
        code[i].tip:=3;
      if s1='SU' then
        code[i].tip:=4;
      if s1='MU' then
        code[i].tip:=5;
      if s1='DI' then
        code[i].tip:=6;
      if s1='RE' then
        code[i].tip:=7;
      if s1='WR' then
        code[i].tip:=8;
      if s1='JU' then
        code[i].tip:=9;
      if s1='JG' then
        code[i].tip:=10;
      if s1='JZ' then
        code[i].tip:=11;
      if s1='HA' then
        code[i].tip:=12;
      code[i].operand:=2;
      if pos('=',s)<>0 then
        code[i].operand:=1;
      if pos('*',s)<>0 then
        code[i].operand:=3;
      s1:='';
      for j:=1 to length(s)do
        if s[j]in ['0'..'9']then
          s1:=s1+s[j];
      if s1<>'' then
        Val(s1,code[i].num,io)
      else
        code[i].num:=0;
    end;
  for i := 1 to N do
    begin
      Read(t);
      ForRead[i]:=t;
    end;
  UkazRead:=0;

  cur:=0;
  while not (code[cur].tip=12) do
    begin
      case code[cur].tip of
        1:
          begin
            case code[cur].operand of
              1:
                Reg[0]:=code[cur].num;
              2:
                Reg[0]:=reg[code[cur].num];
              3:
                Reg[0]:=reg[reg[code[cur].num]];
              end;
            inc(cur);
          end;
        2:
          begin
            case code[cur].operand of
              2:
                Reg[code[cur].num]:=reg[0];
              3:
                Reg[reg[code[cur].num]]:=reg[0];
              end;
            inc(cur);
         end;
        3:
          begin
            case code[cur].operand of
              1:
                Reg[0]:=reg[0]+code[cur].num;
              2:
                Reg[0]:=reg[0]+reg[code[cur].num];
              3:
                Reg[0]:=reg[0]+reg[reg[code[cur].num]];
              end;
            inc(cur);
          end;
        4:
          begin
            case code[cur].operand of
              1:
                Reg[0]:=reg[0]-code[cur].num;
              2:
                Reg[0]:=reg[0]-reg[code[cur].num];
              3:
                Reg[0]:=reg[0]-reg[reg[code[cur].num]];
              end;
            inc(cur);
          end;
        5:
          begin
            case code[cur].operand of
              1:
                Reg[0]:=reg[0]*code[cur].num;
              2:
                Reg[0]:=reg[0]*reg[code[cur].num];
              3:
                Reg[0]:=reg[0]*reg[reg[code[cur].num]];
              end;
            inc(cur);
          end;
        6:
          begin
            case code[cur].operand of
              1:
                Reg[0]:=reg[0] div code[cur].num;
              2:
                Reg[0]:=reg[0] div reg[code[cur].num];
              3:
                Reg[0]:=reg[0] div reg[reg[code[cur].num]];
              end;
            inc(cur);
          end;
        7:
          begin
            case code[cur].operand of
              2:
                reg[code[cur].num]:=GetRead;
              3:
                reg[reg[code[cur].num]]:=GetRead;
              end;
            inc(cur);
          end;
        8:
          begin
            case code[cur].operand of
              1:
                Writeln(code[cur].num);
              2:
                Writeln(reg[code[cur].num]);
              3:
                Writeln(reg[reg[code[cur].num]]);
              end;
            inc(cur);
          end;
        9:
          begin
            cur:=code[cur].num;
          end;
        10:
          begin
            if reg[0]>0 then
              cur:=code[cur].num
            else
              inc(cur);
          end;
        11:
          begin
            if reg[0]=0 then
              cur:=code[cur].num
            else
              inc(cur);
          end;
        end;
    end;
 end;

procedure OpenFiles;
begin
 Assign(input,input_file);
 Reset(input);
 Assign(output,output_file);
 Rewrite(output);
end;

procedure CloseFiles;
begin
 Close(input);
 Close(output);
end;

begin
OpenFiles;
Run;
CloseFiles;
end.
