{$D-,H-,I-,L-,Q-,R-,S-}
program ZadA;

type
  int=longint;
  real=extended;

const
  input_file='pipe.in';
  output_file='pipe.out';
  maxN=2000;
  eps=1e-10;
  truba='DELO TRUBA';
  cikl=100000;
var

  x,y:array[1..maxN]of real;
  n:int;


function Max(a,b:real):real;
 begin
   if a>b then Max:=a else max:=b;
 end;

function Min(a,b:real):real;
 begin
   if a<b then Min:=a else min:=b;
 end;

function More(a,b:real):boolean;
 begin
   More:=a-b>eps;
 end;

function Vect(v1x,v1y,v2x,v2y:real):real;
 begin
   Vect:=v1x*v2y-v1y*v2x;
 end;

function PeresechX(x1,y1,x2,y2,x3,y3,x4,y4:real):real;
 begin
   PeresechX:=x1+(x2-x1)*vect(x4-x3,y4-y3,x1-x3,y1-y3)/vect(x2-x1,y2-y1,x4-x3,y4-y3);
 end;


function Good(uvel:real):Real;
 var
  l:int;
  verhn,nijn:real;
  oldverhn,oldnijn:real;
  ans:real;
 begin

  verhn:=1;
  nijn:=0;
  oldverhn:=1;
  oldnijn:=0;

  for l:=2 to N do
    begin
      Verhn:= min(verhn, (y[l]-y[1]) - (x[l]-x[1])*uvel + 1);
      Nijn:= max(nijn, (y[l]-y[1]) - (x[l]-x[1])*uvel);
      if More(nijn,verhn) then
        begin
          Good:=max(
                   max(peresechX(x[1],y[1]-1+oldverhn,x[1]+1,y[1]-1+oldverhn+uvel,x[l-1],y[l-1],x[l],y[l]),
                   peresechX(x[1],y[1]-1+oldverhn,x[1]+1,y[1]-1+oldverhn+uvel,x[l-1],y[l-1]-1,x[l],y[l]-1)
                      ),
                   max(peresechX(x[1],y[1]-1+oldnijn,x[1]+1,y[1]-1+oldnijn+uvel,x[l-1],y[l-1],x[l],y[l]),
                   peresechX(x[1],y[1]-1+oldnijn,x[1]+1,y[1]-1+oldnijn+uvel,x[l-1],y[l-1]-1,x[l],y[l]-1)
                      )
                   );

          exit;
        end;
      oldverhn:=verhn;
      oldnijn:=nijn;
    end;
  Good:=x[n]+1;
 end;


procedure Run;
 var
  i,j: int;
  t1,t2:real;
  minim,maxim,r,hlp,ans:real;
 begin
  Read(N);
  for i := 1 to N do
    begin
      Read(t1,t2);
      x[i]:=t1;
      y[i]:=t2;
    end;
  minim:=(y[2]-y[1]-1) / (x[2]-x[1]);
  maxim:=(y[2]-y[1]+1) / (x[2]-x[1]);
  ans:=x[1];
  for i :=  0 to cikl do
    begin
      r:=minim+(maxim-minim)*i/cikl;
      hlp:=good(r);
      ans:=max(hlp,ans);
    end;
  if ans>=x[n] then Write(truba) else
    Write(ans:0:2);


 end;

procedure OpenFiles;
begin
 Assign(input,input_file);
 Reset(input);
 Assign(output,output_file);
 Rewrite(output);
end;

procedure CloseFiles;
begin
 Close(input);
 Close(output);
end;

begin
OpenFiles;
Run;
CloseFiles;
end.
