{$A8,B-,C+,D-,E-,F-,G+,H+,I-,J-,K-,L-,M-,N+,O+,P+,Q-,R-,S-,T-,U-,V+,W-,X+,Y+,Z1}
program ZadA;

{$APPTYPE CONSOLE}

const
  maxN=12;
  maxM=100;

type
  int=longint;
  cveta=array[1..maxN] of int;
  rebro=record
    where,next:int;
    end;
  Real=extended;
  mnogochlen=array[1..maxN+1]of int;

const
  input_file='chrom.in';
  output_file='chrom.out';

var
  nach:array[1..maxN]of int;
  graf:array[1..maxM]of rebro;
  N,M:int;
  free:int;
  znach:array[1..maxN]of int64;


procedure AddRebro(v1,v2:int);
 begin
   graf[free].next:=nach[v1];
   graf[free].where:=v2;
   nach[v1]:=free;
   inc(free);
 end;


procedure Podobrat(used,ukaz:int;raskr:cveta);
  var
    i,u:int;
    zapr:array[1..maxN+1]of boolean;
  begin
    if ukaz=N+1 then
      begin
        inc(znach[used]);
        exit;
      end;
    fillchar(zapr,sizeof(zapr),false);
    u:=nach[ukaz];
    while u<>0 do
      begin
        if graf[u].where<ukaz then
          zapr[raskr[graf[u].where]]:=true;
        u:=graf[u].next;
      end;
    for i:= 1 to used do
      if not zapr[i] then
        begin
          raskr[ukaz]:=i;
          podobrat(used,ukaz+1,raskr);
        end;
    if not zapr[used+1] then
      begin
        raskr[ukaz]:=used+1;
        podobrat(used+1,ukaz+1,raskr);
      end;
  end;

function sum(mn1,mn2:mnogochlen):mnogochlen;
 var
  i:int;
  mn:mnogochlen;
 begin
  fillchar(mn,sizeof(mn),0);
  for i := 1 to N+1 do
    mn[i]:=mn1[i]+mn2[i];
  sum:=mn;
 end;

function sdvig(mn1:mnogochlen):mnogochlen;
 var
  i:int;
  mn:mnogochlen;
 begin
  fillchar(mn,sizeof(mn),0);
  for i := N+1 downto 2 do
    mn[i]:=mn1[i-1];
  mn[1]:=0;
  sdvig:=mn;
 end;

function umnn(mn1:mnogochlen;nn:int64):mnogochlen;
 var
  i:int;
  mn:mnogochlen;
 begin
  fillchar(mn,sizeof(mn),0);
  for i := 1 to N+1 do
    mn[i]:=nn*mn1[i];
  umnn:=mn;
 end;



function umnoj(mn:mnogochlen;nn:int):mnogochlen;
 begin
  umnoj:=sum(sdvig(mn),umnn(mn,-nn));
 end;

function AAA(K:int):mnogochlen;
 var
  i:int;
  mn:mnogochlen;
 begin
  fillchar(mn,sizeof(mn),0);
  mn[1]:=1;
  for i := 0 to k-1 do
    mn:=Umnoj(mn,i);
  AAA:=mn;
 end;

procedure Run;
 var
  i,c,t1,t2:int;
  raskr:cveta;
  otv:mnogochlen;
  ans:int;
 begin
  Read(N,M);
  fillchar(nach,sizeof(nach),0);
  free:=1;
  for i := 1 to M do
    begin
      Read(t1,t2);
      AddRebro(t1,t2);
      AddRebro(t2,t1);
    end;
  fillchar(znach,sizeof(znach),0);

  raskr[1]:=1;
  Podobrat(1,2,raskr);

  fillchar(otv,sizeof(otv),0);
  for c := 1 to N do
    if znach[c]<>0 then
      otv:=sum( otv, Umnn(AAA(c),znach[c]) );
  for i:= 1 to n+1 do
    if otv[i]<>0 then
      ans:=i;
  Write(ans-1,' ');
  for i:= 1 to ans do
    write(otv[i],' ');
 end;

procedure OpenFiles;
begin
 Assign(input,input_file);
 Reset(input);
 Assign(output,output_file);
 Rewrite(output);
end;

procedure CloseFiles;
begin
 Close(input);
 Close(output);
end;

begin
OpenFiles;
Run;
CloseFiles;
end.
