#define PRIMARY_DEBUG
#define SECONDARY_DEBUG

#ifdef PRIMARY_DEBUG
#pragma warning(disable:4786)
#endif

#include <fstream>
#include <string>
#include <map>
#include <set>
#include <iostream>
#ifdef PRIMARY_DEBUG
#include <windows.h>
#endif

using namespace std;

ifstream I("prof.in");
ofstream O("prof.out");

char text[4000];
int textlen;
unsigned long words=0;

#ifdef PRIMARY_DEBUG
DWORD tmrr=0;
DWORD timr;
#endif
void StartTimer(){
#ifdef PRIMARY_DEBUG
	timr=GetTickCount();
#endif
}
void EndTimer(){
#ifdef PRIMARY_DEBUG
	tmrr+=GetTickCount()-timr;
#endif
}

typedef char *pchar;

	struct strless : binary_function<pchar, pchar, bool> {
	bool operator()(const pchar& _X, const pchar& _Y) const
	{return (strcmp(_X,_Y)<0 ? true:false); }
	};

typedef set<char *,strless> entriesvector,*pentriesvector;
typedef map<string,entriesvector> wordmap;

pentriesvector wordmap1[3000][3000];

void in(){
	I.getline(text,4000);
	textlen=strlen(text);
}

inline string sub(char *s,int l){
	if(s+l>text+textlen) return (string)"";
	char c=s[l];
	s[l]=0;
	string ret(s);
	s[l]=c;
	return ret;
}

int maxeq(char *a,char *b){
	int c=0;
	while(*a==*b) a++,b++,c++;
	return c;
}

void sol(){
	wordmap A,B;
	{
		char *t=text;
		while(*t){
			string sss="";//sub(t,1);
			/*if(sss[0])*/ A[sss].insert(t);
			t++;
		}
	}
	for(int i=0;i<=textlen/2;i++){
		//process:  A      i
		wordmap::iterator j;
		for(j=A.begin();j!=A.end();j++){
			string IND=j->first;
			entriesvector V=j->second;
			if(V.size()<2){
#ifdef SECONDARY_DEBUG
				cout<<"Too few "<<IND<<endl;
#endif
			}
			else{
				if(i){
#ifdef SECONDARY_DEBUG
					cout<<IND<<" is a word"<<endl;
#endif
					words++;
				}
				entriesvector::iterator h;
				{
					//cleaning b
					long mineq=1000000;//infinite
					entriesvector::iterator i1,i2;
					i1=V.begin();
					i2=V.end();
					i2--;
					char *p1=*i1;
					char *p2=*i2;
					if(p1!=p2){
						long asdf=maxeq(p1,p2);
						if(mineq>asdf) mineq=asdf;
					}
					mineq-=IND.length();
#ifdef PRIMARY_DEBUG
					if(mineq<0){printf("!!!!!!!!!!!!!!");return;}
#endif
					words+=mineq;
					if(mineq){
						IND=sub(p1,j->first.length()+mineq);
#ifdef SECONDARY_DEBUG
						cout<<mineq<<"*"<<V.size()<<" words are counted"<<endl;
#endif
					}
				}

				for(h=V.begin();h!=V.end();h++){
					string sss=sub(*h,IND.length()+1);
					if(sss[0]){
						entriesvector *vvv=&B[sss];
						StartTimer();
						vvv->insert(*h);
						EndTimer();
					}
				}
			}
		}
		A=B;
		B.clear();
	}
}

void out(){
	O<<words;
}

int main(){
	in();
	sol();
	out();
#ifdef PRIMARY_DEBUG
	cout<<tmrr/1000.0f<<endl;
#endif
	return 0;
}