{$A+,B-,D-,E-,F-,G+,I-,L-,N+,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}
program prB;
{Eva Rulezzz!!!}
{AESC MSU #2 team forever}
const inp_file='2instr.in';
      out_file='2instr.out';
      nmax=65536;
      maxx=maxlongint div 2;
      Digits:set of char=['0'..'9','A'..'F'];
      kolvostr=4096;

type Ptr=^rr;
     rr=record
         v,w:longint;
         next:ptr;
        end;
     list=array [0..nmax+1] of longint;
     integer=longint;
     TAd=word;
     TMemory=array [0..nmax] of longint;

var col,r,back:list;
    n,m,size:longint;
    Heap:list;
    c:TMemory;
    start,finish:longint;
    onway:array [0..nmax+1] of boolean;
    GetBack:array [0..nmax+1] of ptr;
    numberinline:longint;



procedure openfiles;
begin
 assign(input,inp_file);
 assign(output,out_file);
 reset(input);
 rewrite(output);
end;
procedure closefiles;
begin
 close(input);
 close(output);
end;

procedure swap(i,j:longint);
var c:longint;
begin
 c:=Heap[i];
 Heap[i]:=Heap[j];
 Heap[j]:=c;
 back[Heap[i]]:=i;
 back[Heap[j]]:=j;
end;

procedure push(i:longint);
begin
 While (i>1) and (r[Heap[i div 2]]>r[Heap[i]]) do
  begin
   swap(i div 2,i);
   i:=i div 2;
  end;
end;

procedure fillheap(x:longint);
begin
 inc(size);
 Heap[size]:=x;
 back[Heap[size]]:=size;
 push(size);
end;


procedure pull(i:longint);
var m:longint;
begin
 m:=i;
 if (2*i<=size)and(r[heap[2*i]]<r[heap[m]]) then
   m:=2*i;
 if (2*i+1<=size)and(r[heap[2*i+1]]<r[heap[m]]) then
   m:=2*i+1;
 if i<>m then
  begin
   swap(i,m);
   pull(m);
  end;
end;

function Extract_min:longint;
var x:longint;
begin
 extract_min:=Heap[1];
 swap(size,1);
 Heap[size]:=0;
 dec(size);
 x:=1;
 pull(x);
end;

procedure reset_key(i,x:longint);
begin
 r[Heap[i]]:=x;
 push(i);
 pull(i);
end;

function GetNum(p:char):longint;
begin
 case p of
  '0': getNum:=0;
  '1': getNum:=1;
  '2': getNum:=2;
  '3': getNum:=3;
  '4': getNum:=4;
  '5': getNum:=5;
  '6': getNum:=6;
  '7': getNum:=7;
  '8': getNum:=8;
  '9': getNum:=9;
  'A': getNum:=10;
  'B': getNum:=11;
  'C': getNum:=12;
  'D': getNum:=13;
  'E': getNum:=14;
  'F': getNum:=15;
 end;
end;

function SixteenToTen(s:string):longint;
var i:longint;
    step:longint;
    tek:longint;
begin
 step:=1;
 tek:=0;
 for i:=length(s) downto 1 do
  begin
   tek:=tek+GetNum(s[i])*step;
   step:=step*16;
  end;
 Sixteentoten:=tek;
end;

procedure init;
var p1,p2,p3,p4:char;
    s:string;
    ad:Tad;
    i,j:longint;
begin
 read(p1);
 while not(p1 in digits) do
  read(p1);

 read(p2,p3,p4);
 s:=p1+p2+p3+p4;

 Start:=sixteenToTen(S);

 read(p1);
 while not(p1 in digits) do
  read(p1);

 read(p2,p3,p4);
 s:=p1+p2+p3+p4;

 Finish:=sixteenToTen(S);
 readln;

 fillchar(c,sizeof(c),0);
 ad:=0;
 for i:=1 to kolvostr do
  begin
   for j:=1 to 8 do
     begin
      read(p1,p2,p3);
      s:=p1+p2;
      c[ad]:=SixteenToTen(s);
      ad:=ad+1;
     end;

   for j:=1 to 8 do
     begin
      read(p3,p1,p2);
      s:=p1+p2;
      c[ad]:=SixteenToTen(s);
      ad:=ad+1;
     end;

   readln;
  end;


end;

function Invert(i:longint):Tad;
var a,b:longint;
begin
 a:=i div (16*16);
 b:=i mod (16*16);
 Invert:=b*16*16+a;
end;

function Get(i:longint):Tad;
var a,b:longint;
begin
 a:=c[i];
 b:=c[word(i+1)];
 Get:=b*16*16+a;
end;

procedure Add(v1,v2,w:longint);
var p:ptr;
begin
 New(p);
 p^.v:=v2;
 p^.w:=w;
 p^.next:=GetBack[v1];
 GetBack[v1]:=p;
end;

procedure Rec(i:longint);
var p:ptr;
begin
 onway[i]:=true;
 p:=GetBack[i];
 while p<>nil do
  begin
   if not onway[p^.v] and (r[p^.v]+p^.w=r[i]) then
     Rec(p^.v);

   p:=p^.next;
  end;

end;

procedure PrintByte(s:string);
begin
 case numberinline of
  0: begin
        writeln;
        write(s);
       end;
  8:write('  '+s)
 else
     write(' '+s);
 end;
 numberinline:=(numberinline+1) mod 16;
end;

procedure print(i:longint);
var a,b:longint;
begin
 if i=finish then exit;
 a:=get(i);
 b:=invert(i);
 if onway[b] and (r[b]=r[i]+2) then
  begin
   printByte('0F');
   printByte('CC');
   Print(b);
   exit;
  end;
 if onway[a] and (r[a]=r[i]+1) then
  begin
   printByte('5C');
   print(a);
   exit;
  end;

end;

procedure solve;
var i,x:longint;
    x1,x2:longint;

begin
 for i:=0 to nmax-1 do
  r[i]:=maxx;

 r[start]:=0;

 size:=0;
 fillchar(Heap,sizeof(Heap),0);


 for i:=0 to nmax-1 do
  fillheap(i);

 while (size>0) do
  begin
   x:=extract_min;
   col[x]:=1;

   x1:=get(x);
   x2:=invert(x);

   if (r[x1]>r[x]+1)and(r[x]<=maxx) then
     reset_key(back[x1],r[x]+1);
   if (r[x2]>r[x]+2)and(r[x]<=maxx) then
     reset_key(back[x2],r[x]+2);

  end;

  if (r[finish]=maxx) then
   begin
    writeln('IMPOSSIBLE');
    closefiles;
    halt;
   end;


  write(r[finish]);


  for i:=0 to nmax-1 do
    getBack[i]:=nil;

  for i:=0 to nmax-1 do
    Add(invert(i),i,2);

  for i:=0 to nmax-1 do
    add(get(i),i,1);

  fillchar(onway,sizeof(onway),false);
  Rec(finish);

  numberinline:=0;
  Print(start);
  writeln;
end;

begin
  openfiles;
  init;
  solve;
  closefiles;
end.
