program prB;
{$N+,D-,R-,S-,Q-,L+,I-,B-,O+}
const inp_file='lcm.in';
      out_file='lcm.out';
      nmax=2000;
      dmax=300;
      maxlen=2000;
const osn=1000000000;
      maxvalue=1000000000;
      maxsimple=36000;

type  int=longint;
      TDel=array [0..dmax] of int;
      TMas=array [0..nmax] of TDel;
      TLong=array [0..maxlen+1] of extended;

var a:TMas;
    N:int;
    Num:array [0..nmax+1] of int;
    Simple,kolvo:array [0..maxsimple] of int;
    kolvoSimple:int;
    ans,c,c1,c2:Tlong;




procedure openfiles;
begin
 assign(input,inp_file);
 assign(output,out_file);
 reset(input);
 rewrite(output);
end;
procedure closefiles;
begin
 close(input);
 close(output);
end;

procedure init;
var i:int;
begin
 read(N);
 for i:=1 to N do
  read(Num[i]);
end;

function min(a,b:int):int;
begin
 if a<b then min:=a else min:=b;
end;

function ISSimple(var i:int):boolean;
var j:int;
begin
  issimple:=false;
  for j:=2 to min(round(sqrt(i))+1,i-1) do
    if (i mod j=0) then
       exit;
  issimple:=true;
end;

procedure GetSimple;
var i:int;
begin
 kolvoSimple:=0;
 fillchar(simple,sizeof(simple),0);
 for i:=2 to round(sqrt(maxvalue))+1 do
   if IsSimple(i) then
     begin
       inc(kolvoSimple);
       Simple[KolvoSimple]:=i;
     end;
end;

procedure Make(a:int;var d:TDel);
var i:int;
    f:boolean;
begin
 d[0]:=0;
 while not (a=1) do
  begin
   f:=true;
   for i:=1 to kolvosimple do
     if (a mod simple[i]=0) then
       begin
         inc(d[0]);
         d[d[0]]:=simple[i];
         a:=a div simple[i];
         f:=false;
         break;
       end;
   if f then
    begin
     inc(d[0]);
     d[d[0]]:=a;
     inc(kolvosimple);
     simple[kolvosimple]:=a;
     a:=1;
    end;



  end;
end;

function max(a,b:int):int;
begin
 if a>b then max:=a else max:=b;
end;

procedure Printlong(A:Tlong);
var i:int;
    s,st:string;
begin
 write(round(a[round(a[0])]));
 for i:=round(a[0])-1 downto 1 do
  begin
   str(osn-1,st);
   str(round(a[i]),s);
   while length(s)<length(st) do
    s:='0'+s;
   write(s);
  end;
 writeln;
end;

procedure multiply(A:Tlong;p:int64;var C:Tlong);
var i:int;

  function ExtDiv(a,b:extended):extended;
  begin
   ExtDiv:=trunc(a/b);
  end;

  function ExtMod(a,b:extended):extended;
  begin
   Extmod:=round((a/b-extdiv(a,b))*b);
  end;

begin
 fillchar(c,sizeof(c),0);
 for i:=1 to round(a[0]) do
   begin
    c[i]:=c[i]+ExtMod(a[i]*p,osn);
    c[i+1]:=ExtDiv(a[i]*p,osn);
   end;
 c[0]:=a[0];
 if c[round(c[0])+1]<>0 then
   c[0]:=c[0]+1;
 if c[round(c[0])]>=osn then
   begin
    c[round(c[0])+1]:=extdiv(c[round(c[0])],osn);
    c[round(c[0])]:=ExtMod(c[round(c[0])],osn);
    c[0]:=c[0]+1;
   end;
end;

procedure solve;
var i,j,k,tek,last:int;
begin
  GetSimple;

  for i:=1 to n do
   Make(num[i],a[i]);

  fillchar(kolvo,sizeof(kolvo),0);

  for i:=1 to N do
    a[i][a[i][0]+1]:=-1;
  for i:=1 to N do
    begin
      tek:=1;
      while tek<=a[i][0] do
       begin
         last:=tek;
         while a[i][tek]=a[i][tek+1] do
          inc(tek);

         for k:=1 to kolvoSimple do
           if simple[k]=a[i][tek] then
             kolvo[k]:=max(kolvo[k],tek-last+1);

         inc(tek);
       end;

    end;

  fillchar(ans,sizeof(ans),0);
  ans[0]:=1;
  ans[1]:=1;

  for i:=1 to kolvosimple do
   for j:=1 to kolvo[i] do
     begin
      multiply(ans,simple[i],c);
      ans:=c;
     end;

  printLong(ans);

end;

begin
  openfiles;
  init;
  solve;
  closefiles;
end.
