{$A+,B-,D+,E+,F-,G-,I+,L+,N+,O-,P+,Q-,R-,S-,T-,V+,X+}
Const InputFile='small.in';
      OutputFile='small.out';

Const M=100;
      MaxN=M*M;

Type Real=Double;
     Point=record
     x,y:Shortint;
     end;

var a:Array[1..MaxN] of Point;
    b:Array[1..M] of Byte;
    c,d:Array[1..M] of Byte;
    R,t:Array[0..M,0..M] of Longint;
    N,S,K:Longint;

    i,j:Longint;

Procedure FRead;
begin
Assign(Input,InputFile);
Reset(Input);
Read(N);
for i:=1 to N do
  Read(a[i].x,a[i].y);
Read(S);
for i:=1 to S do
  Read(b[i]);
Read(K);
Close(Input);
end;

Procedure FWrite(Answer:Longint);
begin
Assign(Output,OutputFile);
Rewrite(Output);
Write(K,' ');
for i:=1 to K do
  Write(c[i],' ');
Close(Output);
Halt;
end;

Function RC(x1,y1,x2,y2:Byte):Longint;
begin
RC:=R[x2,y2]-R[x1-1,y2]-R[x2,y1-1]+R[x1-1,y1-1];
end;

Procedure Solve;
var l,g,h,mx,mj:Longint;
    t1,t2:Longint;
    w:Array[1..M] of Boolean;
begin
FillChar(R,SizeOf(R),0);
FillChar(t,SizeOf(t),0);
for i:=1 to N do
  t[a[i].x,a[i].y]:=1;

for i:=1 to M do
for j:=1 to M do
  R[i,j]:=R[i-1,j]+R[i,j-1]-R[i-1,j-1]+T[i,j];

FillChar(w,SizeOf(w),False);
c[1]:=1;
c[2]:=M;
w[1]:=True;
w[M]:=True;
for i:=3 to K do
begin
  mx:=0;
  mj:=0;
  for j:=2 to M-1 do
  begin
    g:=1;
    While c[g]<j Do Inc(g);
    if c[g]=j then Continue;
    h:=0;
    for l:=2 to S do
      if RC(b[l-1],c[g-1],b[l],c[g])>0 then
      begin
        t1:=RC(b[l-1],c[g-1],b[l],j-1);
        t2:=RC(b[l-1],j,b[l],c[g]);
        if (t1>0) AND (t2>0) then
          Inc(h);
      end;
    if h>mx then
    begin
      mx:=h;
      mj:=j;
    end;
  end;
  if mj=0 then
  begin
    for j:=1 to M do
      if w[j]=False then
      begin
        c[i]:=j;
        Break;
      end;
  end
  else
    c[i]:=mj;
  w[c[i]]:=True;
  for j:=i downto 2 do
    if c[j-1]>c[j] then
    begin
      g:=c[j-1]; c[j-1]:=c[j]; c[j]:=g;
    end;
end;

FWrite(1543);
end;

begin
FRead;
Solve;
end.