{$A+,B-,D+,E+,F-,G-,I+,L+,N+,O-,P-,Q-,R-,S-,T-,V+,X+}
Const InputFile='2instr.in';
      OutputFile='2instr.out';
Const HexDigits=['0'..'9','A'..'F'];
      Digits=['0'..'9'];

Const N=1 shl 16;
Const INF=724249387;
      SA:Array[1..2,1..2] of String[2]=(('5C',''),('0F','CC'));

Type Real=Double;
var a:Array[0..N] of Byte;
    Ans:Array[1..N] of Byte;
    Len:Longint;
    Start,Stop:Word;
    i,j:Longint;

Procedure FRead;
var ch:Char;
begin
FillChar(a,SizeOf(a),0);
Start:=0;
Stop:=0;
Assign(Input,InputFile);
Reset(Input);

While Not (ch in HexDigits) Do Read(ch);
While ch in HexDigits Do
begin
  if ch in Digits then
    j:=Ord(ch)-Ord('0')
  else
    j:=Ord(ch)-Ord('A')+10;
  Start:=Start*16+j;
  Read(ch);
end;
While Not (ch in HexDigits) Do Read(ch);
While ch in HexDigits Do
begin
  if ch in Digits then
    j:=Ord(ch)-Ord('0')
  else
    j:=Ord(ch)-Ord('A')+10;
  Stop:=Stop*16+j;
  Read(ch);
end;

i:=0;
Repeat
  While Not (ch in HexDigits) Do Read(ch);
  While ch in HexDigits Do
  begin
    if ch in Digits then
      j:=Ord(ch)-Ord('0')
    else
      j:=Ord(ch)-Ord('A')+10;
    a[i]:=a[i] shl 4+j;
    Read(ch);
  end;
  if EoF=False then Read(ch);
  Inc(i);
  if i>N then Break;
Until EoF;
a[N]:=a[0];
Close(Input);
end;

Procedure FWrite(Answer:Longint);
begin
Assign(Output,OutputFile);
Rewrite(Output);
if Answer=-1 then
  Write('IMPOSSIBLE')
else
begin
  Writeln(Answer);
  j:=0;
  for i:=1 to Len do
  begin
    Inc(j);
    Write(sa[Ans[i],1]);
    if (j mod 16=0) then
      Writeln
    else if j mod 8=0 then
      Write('  ')
    else
      Write(' ');
    if Ans[i]=2 then
    begin
      Inc(j);
      Write(sa[Ans[i],2]);
      if (j mod 16=0) OR (i=Len) then
        Writeln
      else if j mod 8=0 then
        Write('  ')
      else
        Write(' ');
    end;
  end;
end;
Close(Output);
Halt;
end;

var d:Array[1..N] of Longint;
    Prev:Array[1..N] of Longint;
    Que:Array[1..N] of Word;
    Were:Array[0..N] of Boolean;
    Num,Cur,First:Longint;

Procedure Solve;
var g,h:Longint;
    p,t:Word;
begin
FillChar(d,SizeOf(d),43);
FillChar(Prev,SizeOf(Prev),0);
FillChar(Que,SizeOf(Que),0);
Num:=1;
Cur:=1;
First:=1;
Que[1]:=Start;
d[1]:=0;
Were[Start]:=True;
Repeat
  p:=Que[Cur];
  t:=a[p]+a[p+1] shl 8;
  if Were[t]=False then
  begin
    Inc(Num);
    Que[Num]:=t;
    d[Num]:=d[Cur]+1;
    Prev[Num]:=Cur;
    Were[t]:=True;
    if t=Stop then Break;
  end;

  Inc(Cur);
  if (Cur<=Num+1) AND (d[Cur]>d[First]) then
  begin
    for i:=First to Cur-1 do
    begin
      p:=Que[i];
      t:=Swap(p);
      if Were[t]=False then
      begin
        Inc(Num);
        Que[Num]:=t;
        d[Num]:=d[First]+2;
        Prev[Num]:=i;
        Were[t]:=True;
        if t=Stop then Break;
      end;
    end;
    if t=Stop then Break;
    First:=Cur;
  end;
Until Cur>Num;
if Que[Num]=Stop then
begin
  Len:=0;
  h:=d[Num];
  g:=Num;
  Repeat
    Inc(Len);
    Ans[Len]:=d[g]-d[Prev[g]];
    g:=Prev[g];
  Until Que[g]=Start;
  for i:=1 to Len div 2 do
  begin
    g:=Ans[i]; Ans[i]:=Ans[Len+1-i]; Ans[Len+1-i]:=g;
  end;
end
else
  h:=-1;
FWrite(h);
end;

begin
FRead;
Solve;
end.