{$A+,B-,D+,E+,F-,G-,I+,L+,N+,O-,P-,Q-,R-,S-,T-,V+,X+}
Const InputFile='ram.in';
      OutputFile='ram.out';

Const MaxN=1010;
Const Chars=['A'..'Z'];
      Digits=['0'..'9'];
      Sp=['=','*'];

Type Real=Double;

var a:Array[0..MaxN] of Longint;
    s:Array[1..MaxN] of String[5];
    op:Array[1..MaxN] of Char;
    Num:Array[1..MaxN] of Longint;
    Inp:Array[1..MaxN] of Longint;
    N,M:Longint;

    i,j:Longint;

Procedure FRead;
var ch:Char;
    st:String;
    Code:Integer;
begin
Assign(Input,InputFile);
Reset(Input);
Readln(M,N);
for i:=1 to M do
begin
  s[i]:='';
  Repeat Read(ch) Until ch in Chars;
  While ch in Chars Do
  begin
    s[i]:=s[i]+ch;
    Read(ch);
  end;
  if s[i]<>'HALT' then
  begin
    Repeat Read(ch) Until (ch in Sp) OR (ch in Digits);
    if ch in Sp then
      op[i]:=ch
    else
      op[i]:=' ';
    st:='';
    While (ch in Digits)=False Do Read(ch);
    While ch in Digits Do
    begin
      st:=st+ch;
      Read(ch);
    end;
    Val(st,Num[i],Code);
    if ch=#13 then
      Read(ch)
    else
      Readln;

  end;
end;
for i:=1 to N do
  Read(Inp[i]);
Close(Input);

Assign(Output,OutputFile);
Rewrite(Output);

end;

Procedure Solve;
var g,h,K:Longint;
begin
FillChar(a,SizeOf(a),0);
K:=0;
i:=1;
Repeat
  if s[i]='HALT' then
    Break
  else if s[i]='JUMP' then
  begin
    i:=Num[i]+1;
    Continue;
  end
  else if s[i]='JGTZ' then
  begin
    if a[0]>0 then
      i:=Num[i]+1
    else
      Inc(i);
    Continue;
  end
  else if s[i]='JZERO' then
  begin
    if a[0]=0 then
      i:=Num[i]+1
    else
      Inc(i);
    Continue;
  end
  else
  begin
    j:=Num[i];
    g:=Num[i];
    Case op[i] of
    ' ':j:=a[j];
    '*':
    begin
      j:=a[a[j]];
      g:=a[g];
    end;
    end;

    Case s[i][1] of
    'L':a[0]:=j;
    'A':Inc(a[0],j);
    'S':
    begin
      if s[i]='STORE' then
        a[g]:=a[0]
      else if s[i]='SUB' then
        Dec(a[0],j);
    end;
    'M':a[0]:=a[0]*j;
    'D':a[0]:=a[0] div j;
    'R':
    begin
      Inc(K);
      a[g]:=Inp[K];
    end;
    'W':Writeln(j);
    end;
  end;
  Inc(i);
Until False;

Close(Output);
end;

begin
FRead;
Solve;
end.