{$A-,B-,D-,E-,F-,G-,I-,L-,N-,O-,P-,Q-,R-,S-,T-,V-,X-}
Const InputFile='chrom.in';
      OutputFile='chrom.out';

Const MaxN=13;
      MaxM=2*120;

Type Real=Double;
     int=longint;

var a:Array[1..MaxM,1..2] of Longint;
    b:Array[1..MaxN+1] of Longint;
    Ans:Array[1..MaxN] of int;
    N,M:Longint;

    i,j:Longint;
var f,r:Array[1..MaxN] of int;
    c:Array[1..MaxN] of Byte;
    Num:Byte;
    k:Byte;


Procedure FRead;
begin
Assign(Input,InputFile);
Reset(Input);
Read(N,M);
for j:=1 to M do
  Read(a[j,1],a[j,2]);
Close(Input);
end;

Procedure FWrite(Answer:Longint);
begin
Assign(Output,OutputFile);
Rewrite(Output);
Write(N,' 0');
for i:=1 to N do
  Write(' ',Ans[i]);
Close(Output);
Halt;
end;

Function CmpA(i,j:Longint):Shortint;
var k:Byte;
begin
CmpA:=0;
for k:=1 to 2 do
  if a[i,k]>a[j,k] then
  begin
    CmpA:=1;
    Break;
  end
  else if a[i,k]<a[j,k] then
  begin
    CmpA:=-1;
    Break;
  end;
end;

Procedure QSort(L,R:Longint);
var i,j:Longint;
begin
i:=L;
j:=R;
a[M+1]:=a[(i+j) div 2];
Repeat
  While CmpA(i,M+1)=-1 Do Inc(i);
  While CmpA(j,M+1)= 1 Do Dec(j);
  if i<=j then
  begin
    a[M+2]:=a[i];
    a[i]:=a[j];
    a[j]:=a[M+2];
    Inc(i);
    Dec(j);
  end;
Until i>j;
if i<R then QSort(i,R);
if L<j then QSort(L,j);
end;

Procedure PrepareGraph;
begin
for j:=1 to M do
begin
  a[M+j,1]:=a[j,2];
  a[M+j,2]:=a[j,1];
end;
M:=M*2;
QSort(1,M);
a[M+1,1]:=0;
b[1]:=1;
j:=1;
for i:=1 to N do
begin
  b[i+1]:=b[i];
  While a[j,1]=i Do
  begin
    Inc(j);
    Inc(b[i+1]);
  end;
end;
end;

Procedure Rec(i:Byte);
var j,g,cn:Byte;
begin
if i>N then
  f[k]:=f[k]+1
else
begin
  for cn:=1 to k do
  begin
    g:=1;
    for j:=b[i] to b[i+1]-1 do
      if c[a[j,2]]=cn then
      begin
        g:=0;
        Break;
      end;
    if g=1 then
    begin
      c[i]:=cn;
      Rec(i+1);
    end;
  end;
  c[i]:=0;
end;
end;

var T,T0:Array[1..MaxN,1..MaxN] of int;
Procedure Solve;
var g,h:Longint;
begin
PrepareGraph;
FillChar(f,SizeOf(f),0);
for k:=1 to N do
begin
  FillChar(c,SizeOf(c),0);
  c[1]:=1;
  Rec(2);
  f[k]:=f[k]*k;
end;

for i:=1 to N do
  T[i,1]:=i;
for j:=2 to N do
for i:=1 to N do
  T[i,j]:=T[i,j-1]*i;
r:=f;
T0:=T;

for j:=1 to N do
begin
  for i:=j+1 to N do
  begin
    k:=T[i,j] div T[j,j];
    for g:=1 to N do
      Dec(T[i,g],T[j,g]*k);
    Dec(r[i],r[j]*k);
  end;
end;

FillChar(Ans,SizeOf(Ans),0);
for i:=N downto 1 do
begin
  for j:=i+1 to N do
    Dec(r[i],Ans[j]*T[i,j]);
  Ans[i]:=r[i] div T[i,i];
end;

FWrite(1543);
end;

begin
FRead;
Solve;
end.