{$A+,B-,D+,E-,F-,G+,I+,L+,N+,O-,P-,Q-,R+,S+,T-,V+,X+,Y+}
const
  inf = 'quirks.in'; ouf = 'quirks.out';
  max = 60000;
type
  liar = array[0..max] of longint;
  procedure swap(var a, b: longint);
  var
    c: longint;
  begin
    c := a; a := b; b := c;
  end;
var
  a, b, q: liar;
  v: liar;
  w: array[1..max] of byte;
  ma, mb: longint;
  procedure qsort(l, r: longint);
  var
    md, i, j: longint;
  begin
    i := l; j := r; md := l + random(r - l + 1);
    mb := b[md]; ma := a[md];
    repeat
       while (b[i] < mb) or
             ((b[i] = mb) and (a[i] < ma)) do inc(i);
       while (b[j] > mb) or
             ((b[j] = mb) and (a[j] > ma)) do dec(j);
       if (i <= j) then
       begin
         swap(a[i], a[j]); swap(b[i], b[j]);
         inc(i); dec(j);
       end;
    until i > j;
    if (i < r) then qsort(i, r);
    if (l < j) then qsort(l, j);
  end;
var
  n, m: longint; ok: boolean;
  root: longint;
  d: liar;
  dp: longint;
  procedure find(k: longint);
  var
    i, j, s: longint;
    procedure work;
    begin
      j := a[i];
      if (w[j] = 0) then
      begin
        find(j);
        if (d[j] < dp) then
          inc(s);
        if (d[j] < d[k]) then d[k] := d[j];
      end else
      begin
        if (w[j] = 1) and (q[j] = 0) then ok := false;
        if (q[j] < dp) then d[k] := q[j];
        if (d[k] < dp) then inc(s);
      end;
    end;
  begin
    inc(dp); s := 0;
    w[k] := 1; d[k] := dp; q[k] := dp;
    for i := v[k] to v[k + 1] - 1 do
       if (i = v[k]) then work else
         if (a[i] <> a[i - 1]) then work;
    if (s > 1) then ok := false;
    dec(dp); q[k] := 0;
  end;
var
  iv, ov: liar;
  i, j, c, l, r, t: longint;
  k: longint;
begin
  assign(input, inf);  reset(input);
  assign(output,ouf);rewrite(output);
  randomize;
  readln(input, t);
  while (t > 0) do
  begin
    fillchar(a, sizeof(a), 0); b := a;
    fillchar(w, sizeof(w), 0);
    iv := a; ov  := a; q := a;
    readln(input, n, m);
    for i := 1 to m do
    begin
      readln(input, a[i], b[i]);
      inc(iv[b[i]]); inc(ov[a[i]]);
    end;
    r := 0;
    for i := 1 to n do
       if (ov[i] = 0) and (iv[i] > 0) then
       begin
         inc(r); q[r] := i;
       end;
    l := 1;
    qsort(1, m);
    fillchar(v, sizeof(v), 0);
    for i := 1 to m do
      if (b[i] <> b[i - 1]) then v[b[i]] := i;

    v[n+1] := m+1;

    for i := n downto 1 do
      if (v[i] = 0) then v[i] := v[i + 1];

    while (l <= r) do
    begin
      c := q[l]; w[c] := 1; iv[c] := 0;
      for i := v[c] to v[c + 1] - 1 do
      begin
        j := a[i];
        dec(ov[j]);
        if (ov[j] = 0) and (iv[j] > 0) then
        begin
          inc(r); q[r] := j;
        end;
      end;
      inc(l);
    end;
    k := 0;
    for i := 1 to n do
      if (w[i] = 0) and (iv[i] = 0) and (ov[i] >= 0) then
        inc(k);
    if k > 1 then writeln(output, 'NO') else
    begin
      q := a; a := b; b := q;
      qsort(1, m);
      fillchar(v, sizeof(v), 0);
        for i := 1 to m do
          if (b[i] <> b[i - 1]) then v[b[i]] := i;

        v[n+1] := m+1;

        for i := n downto 1 do
          if (v[i] = 0) then v[i] := v[i + 1];
      if (k = 0) then i := 1 else
      begin
        for j := 1 to n do
          if (w[j] = 0) and (iv[j] = 0) and (ov[j] >= 0) then
          begin
            i := j; break;
          end;
      end;
      fillchar(w, sizeof(w), 0);
      fillchar(q, sizeof(q), 0);
      ok := true;
      dp := 0;
      find(i);
      for i := 1 to n do if (w[i] = 0) then ok := false;
      if ok then writeln(output, 'YES') else writeln(output, 'NO');
    end;
    dec(t);
  end;
  close(input); close(output);
end.
