  {$I-,Q-,R-,S-}
const
  inf = 'polygon.in'; ouf = 'polygon.out';
  max = 300;
  big = 1e18;
type
  real = double;
  procedure swap(var a, b: real);
  var
     c: real;
  begin
    c := a; a := b; b := c;
  end;
  procedure iswap(var a, b: integer);
  var
    c: integer;
  begin
    c := a; a := b; b := c;
  end;
var
  x, y: array[1..max] of real;
  mx, my: real;
  procedure qsort(l, r: integer);
  var
    i, j, md: integer;
  begin
    i := l; j := r; md := l + random(r - l + 1);
    mx := x[md]; my := y[md];
    repeat
      while (x[i] < mx) or
           ((x[i] = mx) and (y[i] < my)) do inc(i);
      while (x[j] > mx) or
           ((x[j] = mx) and (y[j] > my)) do dec(j);
      if (i <= j) then
      begin
        swap(x[i], x[j]); swap(y[i], y[j]);
        inc(i); dec(j);
      end;
    until i > j;
    if (i < r) then qsort(i, r);
    if (j > l) then qsort(l, j);
  end;
var
  n, m: integer;
  ps: array[1..max] of real;
  c: array[1..max] of integer;
  md: real;
  procedure sort1(l, r: integer);
  var
    i, j: integer;
  begin
    i := l; j := r; md := ps[l + random(r - l + 1)];
    repeat
       while (ps[i] < md) do inc(i);
       while (ps[j] > md) do dec(j);
       if (i <= j) then
       begin
          swap(ps[i], ps[j]); iswap(c[i], c[j]);
          inc(i); dec(j);
       end;
    until i > j;
    if (i < r) then sort1(i, r);
    if (j > l) then sort1(l, j);
  end;
var
  s, i, j, k, k1, q: integer;
  d: array[1..max,1..max] of real;
{  vc, sc: array[1..max,1..max,1..max]of real;
  w, ws: array[1..max,1..max,1..max] of byte;}
  var
    xc, yc: real;
  function vec(a, b, c: integer): real;
  begin
{    if w[a, b, c] = 1 then
     vec := vc[a, b, c] else
     begin}
       yc := y[c]; xc := x[c];
{       vc[a, b, c] := (x[b] - xc)*(y[a] - yc)
          - (x[a] - xc)*(y[b] - yc);
       vec := vc[a, b, c];
       end;}
       vec := (x[b] - xc)*(y[a] - yc)
          - (x[a] - xc)*(y[b] - yc);
  end;
var
  t, x1, y1, x2, y2: real;
  function sca(a, b, c: integer): real;
  begin
{    if (ws[a,b,c]=1) then
      sca := sc[a, b, c] else
      begin}
         x1 := x[a] - x[b]; y1 := y[a] - y[b];
         x2 := x[b] - x[c]; y2 := y[b] - y[c];
         t := x1*x1+y1*y1+x2*x2+y2*y2;
         t := sqrt(t);
         {sc[a, b, c] := (x1*x2+y1*y2)/t;
         sca := sc[a, b, c];             }
         sca := (x1*x2+y1*y2)/t;
{      end;}
  end;
var
  p1, p2: array[1..max] of integer;
  dx, dy: real;
  ok: boolean;
begin
  assign(input, inf); reset(input);
  assign(output,ouf);rewrite(output);
  readln(input, n); randomize;
{  fillchar(w,  sizeof(w), 0);
  fillchar(ws, sizeof(ws),0);}
  for i := 1 to n do readln(input, x[i], y[i]);
  qsort(1, n); m := 0;
  for i := 1 to n-1 do
    for j := i+1 to n do
      if (i <> j) then
      begin
        dx := x[j] - x[i];
        dy := y[j] - y[i];
        if (dx = 0) then
        begin
           if (dy > 0) then d[i, j] := big else d[i, j] := -big;
        end else d[i, j] := dy/dx;
      end;
  for k := 1 to n - 2 do
  begin
     k1 := k + 1; c[k] := k;
     for i := k1 to n do c[i] := i;
     for i := k1 to n do ps[i] := d[k, i];
     sort1(k1, n);
     for i := k1 to n do p1[i] := k;
     for q := 3 to n do
     begin
       ok := false; s := k1 + q - 3;

       for i := s to n do p2[i] := -1;

       for i := s+1 to n do
          for j := s to i - 1 do
            if (p1[j] <> -1) then
              if (vec(c[i], c[j], c[p1[j]]) > 0) then
              begin
                if (p2[i] = -1) then p2[i] := j else
                begin
                  if sca(c[i], c[j], c[p1[j]]) >
                      sca(c[i], c[p2[i]], c[p1[p2[i]]]) then
                         p2[i] := j;
                end;
              end;
       for i := s to n do
       begin
         p1[i] := p2[i];
         if (p1[i] <> -1) then ok := true;
       end;
       if not ok then break;
       ok := false;
       if (q > m) then
       begin
         for i := s to n do
           if (p1[i] <> -1) then
            if (vec(k, c[i], c[p1[i]]) > 0) then
             begin
               m := q; ok := true; break;
             end;
       end;
       if not ok then break;
    end;
  end;
  writeln(output, m);
  close(input); close(output);
end.
