#include <stdio.h>

#define m 65537

typedef struct
{
  int n, f;
}
pnt;

int mark[m][2], p[m * 2], mem[m], w[m * 2];
char e[m * 2][5];
pnt q[m * 2];

int get( char *s )
{
  int c = 0, i;

  for (i = 0; i < 4; i++)
  {
    char cc = s[4 - i - 1];

    if (cc >= '0' && cc <= '9')
      c |= ((cc - '0') << (i * 4));
    else if (cc >= 'A' && cc <= 'F')
      c |= ((cc - 'A' + 10) << (i * 4));
    else
      c |= ((cc - 'a' + 10) << (i * 4));
  }
  return c;
}

int main( void )
{
  int i, j, k, tt, ss, l;
  char s[10], t[10];

  freopen("2instr.in", "r", stdin);
  freopen("2instr.out", "w", stdout);
  scanf(" %c %c %c %c", &s[0], &s[1], &s[2], &s[3]);
  scanf(" %c %c %c %c", &t[0], &t[1], &t[2], &t[3]);
  s[4] = t[4] = 0;
  ss = get(s);
  tt = get(t);
  for (i = 0; i < 65536; i++)
  {
    s[0] = s[1] = '0';
    scanf(" %c %c", &s[2], &s[3]);
    mem[i] = get(s);
  }
  q[l = 1].n = ss;
  q[1].f = 0;
  mark[ss][0] = 1;
  for (i = 1; i <= l; i++)
  {
    int s1 = ((q[i].n & 0xFF) << 8) | (q[i].n >> 8);
    
    if (q[i].f && !mark[s1][0])
    {
      mark[s1][0] = 1;
      q[++l].n = s1;
      q[l].f = 0;
      p[l] = i;
      e[l][0] = e[l][1] = 'C';
      if (s1 == tt)
        break;
    }
    else if (!q[i].f)
    {
      int s = mem[q[i].n] | (mem[(q[i].n + 1) & 0xFFFF] << 8);

      if (!mark[q[i].n][1])
      {
        mark[q[i].n][1] = 1;
        q[++l].n = q[i].n;
        q[l].f = 1;
        p[l] = i;
        e[l][0] = '0', e[l][1] = 'F';
      }
      if (!mark[s][0])
      {
        mark[s][0] = 1;
        q[++l].n = s;
        q[l].f = 0;
        p[l] = i;
        e[l][0] = '5', e[l][1] = 'C';
        if (s == tt)
          break;
      }
    }
  }
  if (!mark[tt][0])
    printf("IMPOSSIBLE\n");
  else
  {
    for (i = l, k = 0; i != 1; i = p[i])
      w[++k] = i;
    printf("%d\n", k);
    for (i = k, j = 0; i >= 0; i--, j++)
    {
      printf("%s", e[w[i]]);
      if (i == 0)
      {
        printf("\n");
        break;
      }
      if ((j & 15) == 15)
        printf("\n");
      else if ((j & 7) == 7)
        printf("  ");
      else
        printf(" ");
    }
  }
  return 0;
}


