#include <stdio.h>
#include <math.h>

#define m 100002
#define e 1e-8

typedef struct
{
  double x, y;
}
pnt;

pnt p[m];

int main( void )
{
  int i, n;
  double a, b, c, d1, x, y, xy, x2, y2, a1, b1, c1, aa, bb, t,
         a2, b2, c2, d2;

  freopen("best.in", "r", stdin);
  freopen("best.out", "w", stdout);
  scanf("%d", &n);
  x = y = xy = x2 = y2 = 0;
  for (i = 1; i <= n; i++)
  {
    scanf("%lf%lf", &p[i].x, &p[i].y);
    x2 += p[i].x * p[i].x;
    y2 += p[i].y * p[i].y;
    xy += p[i].x * p[i].y;
    x += p[i].x;
    y += p[i].y;
  }
  for (i = 1; i < n; i++)
    if (fabs(p[i + 1].x - p[i].x) > e || fabs(p[i + 1].y - p[i].y) > e)
      break;
  if (i == n)
  {
    a1 = 1;
    b1 = 0;
    printf("%lf\n%lf %lf %lf\n", b1, a1, b1, p[1].x);
    return 0;
  }
  a1 = n * x2 - x * x;
  b1 = n * y2 - y * y;
  c1 = 2 * n * xy - 2 * x * y;
  aa = a1 - b1;
  bb = c1;
  a = 2 * bb;
  b = 2 * aa;
  c = -bb;
  if (fabs(a) > e)
  {
    b1 = (-b + sqrt(b * b - 4 * a * c)) / a / 2;
    if (fabs(b1) > 1 + e)
    {
      b1 = 1;
      a1 = 0;
    }
    else if (fabs(b - 1) < e)
      a1 = 0;
    else
      a1 = sqrt(1 - b1 * b1);
    c1 = (a1 * x + b1 * y) / n;
    d1 = 0;
    for (i = 1; i <= n; i++)
      d1 += (p[i].x * a1 + p[i].y * b1 - c1)
           * (p[i].x * a1 + p[i].y * b1 - c1);
    b2 = (-b - sqrt(b * b - 4 * a * c)) / a / 2;
    if (fabs(b2) > 1 + e)
      b2 = 1, a2 = 0;
    else if (fabs(b2 - 1) < e)
      b2 = 1, a2 = 0;
    else
      a2 = sqrt(1 - b2 * b2);
    c2 = (a2 * x + b2 * y) / n;
    d2 = 0;
    for (i = 1; i <= n; i++)
      d2 += (p[i].x * a2 + p[i].y * b2 - c2)
            * (p[i].x * a2 + p[i].y * b2 - c2);
    if (d1 > d2)
    {
      d1 = d2;
      a1 = a2, b1 = b2, c1 = c2;
    }
  }
  else if (fabs(b) > e)
  {
    b1 = -c / b;
    if (fabs(b1) > 1 + e)
      b1 = 1, a1 = 0;
    else if (fabs(b1 - 1) < e)
      b1 = 1, a1 = 0;
    else
      a1 = sqrt(1 - b1 * b1);
    c1 = (a1 * x + b1 * y) / n;
    d1 = 0;
    for (i = 1; i <= n; i++)
      d1 += (p[i].x * a1 + p[i].y * b1 - c1)
            * (p[i].x * a1 + p[i].y * b1 - c1);
  }
  else
  {
    b1 = 0;
    a1 = 1;
    c1 = a1 * x / n;
    d1 = 0;
    for (i = 1; i <= n; i++)
      d1 += (p[i].x * a1 + p[i].y * b1 - c1)
            * (p[i].x * a1 + p[i].y * b1 - c1);
  }
  printf("%lf\n", d1);
  if (c1 < -e)
    printf("%lf %lf %lf\n", -a1, -b1, -c1);
  else
    printf("%lf %lf %lf\n", a1, b1, c1);
  return 0;
}

