#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>

#define m 5
#define mm 11
#define m2 200
#define tm 4.7

typedef struct
{
  int i, j, k;
}
pnt;

int a[12][4][3] =
{{{1, 1, 1}, {0, 0, 0}, {0, 0, 0}, {0, 0, 0}},
 {{1, 1, 1}, {1, 2, 1}, {0, 0, 0}, {0, 0, 0}},
 {{1, 1, 1}, {1, 2, 1}, {1, 3, 1}, {0, 0, 0}},
 {{1, 1, 1}, {1, 2, 1}, {1, 1, 2}, {0, 0, 0}},
 {{1, 1, 1}, {1, 2, 1}, {1, 3, 1}, {1, 4, 1}},
 {{1, 1, 1}, {1, 2, 1}, {1, 1, 2}, {1, 2, 2}},
 {{1, 1, 1}, {1, 2, 1}, {1, 1, 2}, {1, 1, 3}},
 {{1, 1, 1}, {1, 2, 1}, {1, 3, 1}, {1, 2, 2}},
 {{1, 2, 1}, {1, 3, 1}, {1, 1, 2}, {1, 2, 2}},
 {{2, 1, 1}, {1, 2, 1}, {2, 2, 1}, {2, 1, 2}},
 {{1, 1, 1}, {1, 2, 1}, {2, 2, 1}, {1, 1, 2}},
 {{2, 2, 1}, {2, 1, 2}, {1, 2, 2}, {2, 2, 2}}};
int len[12] = {1, 2, 3, 3, 4, 4, 4, 4, 4, 4, 4, 4}, li, lj, lk,
    f[mm][mm][mm], ff[mm][mm][mm], c[m][m][m], b[m][m][m], bs,
    ln[m2], pp, n, tp[m2][m][m][m], type[m2], cc, way[100], bw[55], be, bc;
pnt p[53], w[m2][4];

void copy( int ii, int jj, int kk )
{
  int i, j, k;

  for (i = 0; i < 4; i++)
    for (j = 0; j < 4; j++)
      for (k = 0; k < 4; k++)
        b[i][j][k] = 0;
  for (i = 0; i < 4; i++)
    for (j = 0; j < 4; j++)
      for (k = 0; k < 4; k++)
        if (c[i][j][k])
          b[i - ii][j - jj][k - kk] = c[i][j][k];
}

void rotxy( void )
{
  int i, j, k, ii = 10, jj = 10, kk = 10;

  for (i = 0; i < 4; i++)
    for (j = 0; j < 4; j++)
      for (k = 0; k < 4; k++)
        if ((c[i][j][k] = b[j][3 - i][k]) == 1)
        {
          if (ii > i)
            ii = i;
          if (jj > j)
            jj = j;
          if (kk > k)
            kk = k;
        }
  copy(ii, jj, kk);
}

void rotxz( void )
{
  int i, j, k, ii = 10, jj = 10, kk = 10;

  for (i = 0; i < 4; i++)
    for (j = 0; j < 4; j++)
      for (k = 0; k < 4; k++)
        if ((c[i][j][k] = b[3 - k][j][i]) == 1)
        {
          if (ii > i)
            ii = i;
          if (jj > j)
            jj = j;
          if (kk > k)
            kk = k;
        }
  copy(ii, jj, kk);
}

void rotyz( void )
{
  int i, j, k, ii = 10, jj = 10, kk = 10;

  for (i = 0; i < 4; i++)
    for (j = 0; j < 4; j++)
      for (k = 0; k < 4; k++)
        if ((c[i][j][k] = b[i][k][3 - j]) == 1)
        {
          if (ii > i)
            ii = i;
          if (jj > j)
            jj = j;
          if (kk > k)
            kk = k;
        }
  copy(ii, jj, kk);
}

void calc( int ii, int jj, int kk, int c, int e )
{
  int i, j, t;

  if (bs == 1)
    return;
  if (bs <= (c + (e >> 2)))
    return;
  if (bs > c + e)
  {
    bs = c + e;
    be = e;
    bc = c;
    memcpy(bw, way, sizeof(int) * (bc + 1));
  }
  if (e == 0)
    return;
  if ((clock() - cc) >= tm * CLOCKS_PER_SEC)
  {
    printf("%d\n", bs);
    for (i = 0; i < bc; i++)
      printf("%d ", bw[i] + 1);
    for (i = 1; i <= be; i++)
      printf("1 ");
    exit(0);
  }
  if (kk == 7)
    kk = 0, jj++;
  if (jj == 7)
    jj = 0, ii++;
  if (ii > li || (ii == li && jj > lj) || (ii == li && jj == lj && kk >= lk))
    return;
  for (i = n - 1; i > 1; i--)
  {
    if (bs <= (c + (e >> 2)))
      break;
    if (bs > c + e)
    {
      bs = c + e;
      be = e;
      bc = c;
      memcpy(bw, way, sizeof(int) * (c + 1));
    }
    if (e >= ln[i])
    {
      for (j = 0; j < ln[i]; j++)
        if (!f[ii + w[i][j].i][jj + w[i][j].j][kk + w[i][j].k]
           || ff[ii + w[i][j].i][jj + w[i][j].j][kk + w[i][j].k])
          break;
      if (j == ln[i])
      {
        for (j = 0; j < ln[i]; j++)
          ff[ii + w[i][j].i][jj + w[i][j].j][kk + w[i][j].k] = 1;
        way[c] = type[i];
        calc(ii, jj, kk + 1, c + 1, e - ln[i]);
        for (j = 0; j < ln[i]; j++)
          ff[ii + w[i][j].i][jj + w[i][j].j][kk + w[i][j].k] = 0;
      }
    }
  }
  if (!f[ii][jj][kk] || !f[ii][jj][kk + 1] || !f[ii][jj + 1][kk]
      || !f[ii + 1][jj][kk])
    calc(ii, jj, kk + 1, c, e);
}

int main( void )
{
  int i, t, j, k, ii, jj, kk, tt;

  freopen("block.in", "r", stdin);
  freopen("block.out", "w", stdout);
  for (t = 0; t < 12; t++)
  {
    for (i = 0; i < 4; i++)
      for (j = 0; j < 4; j++)
        for (k = 0; k < 4; k++)
          b[i][j][k] = 0;
    for (i = 0; i < 4; i++)
      for (j = 0; j < 4; j++)
        for (k = 0; k < 4; k++)
        {
          for (ii = 0; ii < 4; ii++)
            for (jj = 0; jj < 4; jj++)
              for (kk = 0; kk < 4; kk++)
                b[ii][jj][kk] = 0;
          for (ii = 0; ii < len[t]; ii++)
            b[a[t][ii][0] - 1][a[t][ii][1] - 1][a[t][ii][2] - 1] = 1;
          for (ii = 0; ii < i; ii++)
            rotxy();
          for (ii = 0; ii < j; ii++)
            rotxz();
          for (ii = 0; ii < k; ii++)
            rotyz();
          for (tt = 1; tt <= n; tt++)
          {
            for (ii = 0; ii < 4; ii++)
              for (jj = 0; jj < 4; jj++)
                for (kk = 0; kk < 4; kk++)
                  if (b[ii][jj][kk] != tp[tt][ii][jj][kk])
                  {
                    ii = jj = kk = 10;
                    break;
                  }
            if (ii == 4)
              break;
          }
          if (tt <= n)
            continue;
          n++;
          type[n] = t;
          for (ii = 0; ii < 4; ii++)
            for (jj = 0; jj < 4; jj++)
              for (kk = 0; kk < 4; kk++)
                if (b[ii][jj][kk])
                {
                  tp[n][ii][jj][kk] = 1;
                  w[n][ln[n]].i = ii;
                  w[n][ln[n]].j = jj;
                  w[n][ln[n]].k = kk;
                  ln[n]++;
                }
        }
  }
  scanf("%d", &pp);
  for (i = 1; i <= pp; i++)
  {
    scanf("%d%d%d", &p[i].i, &p[i].j, &p[i].k);
    f[p[i].i - 1][p[i].j - 1][p[i].k - 1] = 1;
  }
  for (i = 1; i <= pp; i++)
    for (j = 1; j < pp; j++)
      if (p[j].i > p[j + 1].i
         || ((p[j].i == p[j + 1].i) && (p[j].j > p[j + 1].j))
         || (((p[j].i == p[j + 1].i) && (p[j].j == p[j + 1].j))
            && (p[j].k > p[j + 1].k)))
      {
        pnt t = p[j];

        p[j] = p[j + 1];
        p[j + 1] = t;
      }
  li = p[pp].i, lj = p[pp].j, lk = p[pp].k;
  bs = pp;
  cc = clock();
  calc(0, 0, 0, 0, pp);
  printf("%d\n", bs);
  for (i = 0; i < bc; i++)
    printf("%d ", bw[i]);
  for (i = 1; i <= be; i++)
    printf("1 ");
  printf("\n");
  return 0;
}
