#include <stdio.h>
#include <math.h>

#define mm 15

int aa[mm][mm], num[mm], mark[mm], nc, bad[mm][mm], col[mm], b[mm][mm],
    k, n, c, next[202], r[202], rr, h[20], ll, len[mm], deg[mm];
double a[mm][mm], f[mm], ss[mm];

void calc( int l, double p )
{
  int i, v = b[nc][l], ii;

  if (l > num[nc])
  {
    ss[nc] += p;
    return;
  }
  if (deg[v] == 1)
  {
    calc(l + 1, p * (k - 1));
    return;
  }
  for (i = 1; i <= k; i++)
  {
    if (bad[v][i])
      continue;
    col[v] = i;
    for (ii = h[v]; ii != 0; ii = next[ii])
      bad[r[ii]][i]++;
    if (ii != 0)
      continue;
    calc(l + 1, p);
    for (ii = h[v]; ii != 0; ii = next[ii])
      bad[r[ii]][i]--;
  }
}

void dfs( int v )
{
  int i, t = 0;

  if (mark[v])
    return;
  mark[v] = c;
  b[c][++num[c]] = v;
  for (i = 1; i <= n; i++)
  {
    if (aa[v][i])
      dfs(i);
    deg[v] += aa[v][i];
  }
}

int main( void )
{
  int i, m, j, ii;
  long long t;

  freopen("chrom.in", "r", stdin);
  freopen("chrom.out", "w", stdout);
  scanf("%d%d", &n, &m);
  for (i = 1; i <= m; i++)
  {
    int x, y;

    scanf("%d%d", &x, &y);
    aa[x][y] = aa[y][x] = 1;
  }
  for (i = 1; i <= n; i++)
    aa[i][i] = 0;
  for (i = 1; i <= n; i++)
    if (!mark[i])
    {
      c++;
      dfs(i);
    }
  for (i = 1; i <= n; i++)
    for (j = 1; j <= n; j++)
      if (aa[i][j])
      {
        r[++rr] = j;
        next[rr] = h[i];
        h[i] = rr;
      }
  /*for (i = 1; i <= n; i++)
    b[mark[i]][++num[mark[i]]] = i;*/
  for (i = 1; i <= c; i++)
    if (num[i] > 1)
    {
      int t;
    
      for (j = 2; j <= num[i]; j++)
        if (aa[b[i][1]][b[i][j]])
          break;
      t = b[i][j];
      b[i][j] = b[i][2];
      b[i][2] = t;
    }
  for (k = 1; k <= n; k++)
  {
    for (i = 1; i <= n; i++)
      col[i] = ss[i] = len[i] = 0;
    for (nc = 1; nc <= c; nc++)
      if (num[nc] == 1)
        ss[nc] = k;
      else if (num[nc] == 2)
        ss[nc] = k * (k - 1);
      else
      {
        if (k == 1)
          ss[k] = 0;
        else
        {
          col[b[nc][1]] = 1;
          col[b[nc][2]] = 2;
          for (i = 1; i <= n; i++)
            for (j = 1; j <= k; j++)
              bad[i][j] = 0;
          for (i = 1; i <= num[nc]; i++)
          {
            if (aa[b[nc][1]][b[nc][i]])
              bad[b[nc][i]][1]++;
            if (aa[b[nc][2]][b[nc][i]])
              bad[b[nc][i]][2]++;
          }
          for (i = 1; i <= num[nc]; i++)
          {
            len[b[nc][i]] = k;
            for (j = 1; j <= k; j++)
              if (bad[b[nc][i]][j])
                len[b[nc][i]]--;
          }
          calc(3, 1);
          ss[nc] *= k * (k - 1);
        }
      }
    for (f[k] = i = 1; i <= c; i++)
      f[k] *= ss[i];
  }
  for (i = 1; i <= n; i++)
  {
    a[i][1] = i;
    for (j = 2; j <= n; j++)
      a[i][j] = a[i][j - 1] * i;
    a[i][n + 1] = f[i];
  }
  for (i = 1; i < n; i++)
  {
    int bi;
    double t;
  
    for (ii = bi = i; ii <= n; ii++)
      if (a[ii][i] > a[bi][i])
        bi = ii;
    ii = bi;
    for (j = 1; j <= n + 1; j++)
    {
      t = a[i][j];
      a[i][j] = a[ii][j];
      a[ii][j] = t;
    }
    for (ii = i + 1; ii <= n; ii++)
    {
      t = a[ii][i];
      for (j = 1; j <= n + 1; j++)
        a[ii][j] = a[ii][j] * a[i][i] / t - a[i][j];
    }
  }
  for (i = n; i > 0; i--)
  {
    f[i] = a[i][n + 1] / a[i][i];
    for (ii = i - 1; ii > 0; ii--)
      a[ii][n + 1] -= f[i] * a[ii][i];
  }
  for (i = n; i > 0; i--)
    if (fabs(f[i]) > 1e-5)
      break;
  printf("%d 0 ", i);
  for (ii = 1; ii <= i; ii++)
    printf("%.0lf ", f[ii]);
  printf("\n");
  return 0;
}
