{$q+,r+,n-}

const cinfile = 'kitten.in';
      coutfile = 'kitten.out';

const nmax  = 1 shl 21;
      shift = 1000001;

type int = longint;

var a : array[1..2*nmax - 1, 1..3] of int;

procedure init;
var i : int;
begin
   for i:=2*nmax-1 downto nmax do begin
      a[i, 1]:=0;
      a[i, 2]:=i - nmax + 1;
      a[i, 3]:=a[i, 2];
   end;
   for i:=nmax-1 downto 1 do begin
      a[i, 1]:=0;
      a[i, 2]:=a[2*i, 2];
      a[i, 3]:=a[2*i+1, 3];
  end;
end;

function query(x, l, r : int) : int;
begin
	query:=0;
	if (r < a[x, 2]) or (a[x, 3] < l) then exit;
   if (l <= a[x, 2]) and (a[x, 3] <= r) then begin
      query:=a[x, 1];
      exit;
   end;
   if x < nmax then
      query:=query(2*x, l, r) + query(2*x+1, l, r);
end;

procedure solve;
var x, y : int;
begin
   while not eof do begin
      read(x);
      if not eoln then begin
         read(y);
         inc(x, shift);
         inc(y, shift);
         writeln(query(1, x, y));
      end else begin
         inc(x, shift);
         if a[nmax - 1 + x, 1] = 0 then begin
            x:=nmax - 1 + x;
            while x > 0 do begin
               inc(a[x, 1]);
               x:=x div 2;
            end;
         end;
      end;
      readln;
   end;
end;

begin
   assign(input, cinfile); reset(input);
   assign(output, coutfile); rewrite(output);
   init;
   solve;
   close(input); close(output);
end.
