{$q+,r+,n+}

const cinfile = 'sin.in';
      coutfile = 'sin.out';

const nmax = 101;
      inf = 1000;

type int = longint;
     real = extended;

var b       : array[1..nmax] of int;
    d       : array[1..nmax, 1..nmax] of real;
    pj, way : array[1..nmax, 1..nmax] of int;
    n : int;

procedure init;
var i : int;
begin
   read(n);
   for i:=1 to n do begin
		read(b[i]);
      b[i]:=b[i] * (i+1);
   end;
end;

procedure solve;
var i, lasta, x, j : int;
    r, dt          : real;
begin
   for i:=1 to n do begin
      for x:=1 to n do d[i, x]:=-inf;
      d[i, i]:=0;
      pj[i, i]:=1;
      way[i, i]:=0;
   end;

   for i:=1 to n-1 do
      for lasta:=i downto 1 do begin
         j:=pj[i, lasta] + 1;
         dt:=d[i, lasta] * (j-1);
         for x:=1 to n-i do begin
            r:=(dt + sin(b[j-1] * lasta * x)) / j;
            if d[i+x, x] < r then begin
               d[i+x, x]:=r;
               pj[i+x, x]:=j;
               way[i+x, x]:=lasta;
            end;
         end;
      end;
end;

procedure writeanswer;
var max, j : int;
   procedure go(x, y : int);
   begin
      if x = 0 then exit;
      go(x - y, way[x, y]);
      write(y, ' ');
   end;
begin
   max:=1;
   for j:=2 to n-1 do
      if d[n, max] < d[n, j] then max:=j;
   writeln(d[n, max] :0 :6);
   go(n, max);
end;

begin
   assign(input, cinfile); reset(input);
   assign(output, coutfile); rewrite(output);
   init;
   solve;
   writeanswer;
   close(input); close(output);
end.