{$A+,B-,D-,E-,F-,G+,I+,L+,N+,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}
{$M 16384,0,655360}
program Ram;

{

  EVA RULEZZZ!!!!!!!

  Fight with the best? Die like the rest!

  Copyright by [ hr0nix@darkwired ]

}

const
  InFile = 'ram.in';
  OutFile = 'ram.out';
  MaxN = 1000;

type
  Int = longint;
  Real = extended;
  TCmd = record
    name : string[ 10 ];
    op : Int;
    optype : char;
  end;

var
  commands : array [0..MaxN-1] of TCmd;
  reg : array [0..MaxN-1] of Int;
  inp : array [1..MaxN] of Int;
  n, m, inpp : Int;

procedure OpenFiles;
begin
  assign( input, InFile );
  reset( input );
  assign( output, OutFile );
  rewrite( output );
end;

procedure CloseFiles;
begin
  close( input );
  close( output );
end;

function StrToInt( s : string ) : Int;
var
  res, k : Integer;
begin
  val( s, res, k );
  StrToInt := res;
end;

procedure InitData;
var
  i : Int;
  s : string;
begin
  readln( m, n );
  for i := 0 to m-1 do begin
    readln( s );
    s := s + ' ';
    commands[ i ].name := copy( s, 1, pos( ' ', s ) - 1 );
    delete( s, 1, pos( ' ', s ) );
    while ( pos( ' ', s ) <> 0 ) do
      delete( s, pos( ' ', s ), 1 );
    if s = '' then
      continue;
    if pos( '=', s ) <> 0 then begin
      commands[ i ].optype := '=';
      commands[ i ].op := StrToInt( copy( s, pos( '=', s ) + 1, length( s ) - 1 ) );
    end else
    if pos( '*', s ) <> 0 then begin
      commands[ i ].optype := '*';
      commands[ i ].op := StrToInt( copy( s, pos( '*', s ) + 1, length( s ) - 1 ) );
    end else begin
      commands[ i ].op := StrToInt( s );
      commands[ i ].optype := '#';
    end;
  end;
  for i := 1 to n do
    read( inp[ i ] );
  inpp := 0;
end;

function value( cmdnum : Int ) : Int;
begin
  if commands[ cmdnum ].optype = '=' then
    value := commands[ cmdnum ].op
  else
  if commands[ cmdnum ].optype = '*' then
    value := reg[ reg[ commands[ cmdnum ].op ] ]
  else
    value := reg[ commands[ cmdnum ].op ];
end;

procedure Load( regnum, value : Int );
begin
  reg[ regnum ] := value;
end;

procedure Solve;
var
  ccmd : Int;
begin
  ccmd := 0;
  while ( ccmd <= m ) do begin
    if commands[ ccmd ].name = 'LOAD' then
      Load( 0, Value( ccmd ) )
    else

    if commands[ ccmd ].name = 'STORE' then begin
      if commands[ ccmd ].optype = '*' then
        reg[ reg[ commands[ ccmd ].op ] ] := reg[ 0 ]
      else
        reg[ commands[ ccmd ].op ] := reg[ 0 ];
    end else

    if commands[ ccmd ].name = 'ADD' then
      Load( 0, reg[ 0 ] + value( ccmd ) )
    else

    if commands[ ccmd ].name = 'SUB' then
       Load( 0, reg[ 0 ] - value( ccmd ) )
    else

    if commands[ ccmd ].name = 'MULT' then
       Load( 0, reg[ 0 ] * value( ccmd ) )
    else

    if commands[ ccmd ].name = 'DIV' then
       Load( 0, reg[ 0 ] div value( ccmd ) )
    else

    if commands[ ccmd ].name = 'READ' then begin
      inc( inpp );
      if commands[ ccmd ].optype = '*' then
        reg[ reg[ commands[ ccmd ].op ] ] := inp[ inpp ]
      else
        reg[ commands[ ccmd ].op ] := inp[ inpp ];
    end else

    if commands[ ccmd ].name = 'WRITE' then
      Writeln( value( ccmd ) )
    else

    if commands[ ccmd ].name = 'JUMP' then
      ccmd := commands[ ccmd ].op - 1
    else

    if commands[ ccmd ].name = 'JGTZ' then
      if reg[ 0 ] > 0 then begin
        ccmd := commands[ ccmd ].op - 1;
      end
    else

    if commands[ ccmd ].name = 'JZERO' then
      if reg[ 0 ] = 0 then begin
        ccmd := commands[ ccmd ].op - 1;
      end
    else

    if commands[ ccmd ].name = 'HALT' then
      ccmd := m;

    inc( ccmd );
 end;
end;

begin
  OpenFiles;
  InitData;
  Solve;
  CloseFiles;
end.
 