{$A+,B-,D+,E-,F-,G+,I+,L+,N+,O-,P-,Q-,R+,S+,T-,V+,X+,Y+}
{$M 16384,0,655360}

program Best;

{

  EVA RULEZZZ!!!!!!!

  Fight with the best? Die like the rest!

  Copyright by [ hr0nix@darkwired ]

}

const
  InFile = 'best.in';
  OutFile = 'best.out';
  eps = 1e-7;
  Inf = 1e+15;

type
  Int = longint;

var
  sumx, sumy, summul, sumsqrx, sumsqry, a, b, c, Dist : Real;
  n : Int;

procedure OpenFiles;
begin
  assign( input, InFile );
  reset( input );
  assign( output, OutFile );
  rewrite( output );
end;

procedure CloseFiles;
begin
  close( input );
  close( output );
end;

procedure TryFi ( fi : Real );
var a0, b0, c0 : Real;
    newDist : Real;
begin
  a0 := cos( fi );
  b0 := sin( fi );
  c0 := ( a0 * sumx + b0 * sumy ) / N;

  NewDist := a0*a0*sumsqrx+b0*b0*sumsqry
             +N*c0*c0+2*a0*b0*summul
             -2*a0*c0*sumx-2*b0*c0*sumy;

  if newdist < dist then
    begin
      dist := newdist;
      a := a0;
      b := b0;
      c := c0;
    end;
end;


procedure InitData;
var
  i : Int;
  x, y : Real;
begin
  read( n );
  sumx := 0;
  sumy := 0;
  sumsqrx := 0;
  sumsqry := 0;
  summul := 0;
  for i := 1 to n do begin
    read( x, y );
    sumx := sumx + x;
    sumy := sumy + y;
    sumsqrx := sumsqrx + x * x;
    sumsqry := sumsqry + y * y;
    summul := summul + x * y;
  end;
end;

function DeleteMinus( num : Real ) : Real;
begin
  if abs( num ) < eps then
    DeleteMinus := abs( num )
  else
    DeleteMinus := num;
end;

procedure Solve;
var
  c1, c2, c3, c4 : Real;
  fi, arc : Real;
begin
 dist := Inf;
 c1 := sumsqrx - sumsqrx / N;
 c2 := sumsqry - sumsqry / N;
 c3 := summul - 2 * summul / N;

 if abs( c1 - c2 ) < eps then
   begin
    tryFI( pi / 4 );
    tryFI( 3 * pi / 4 );
    tryFI( 5 * pi / 4 );
    tryFI( 7 * pi / 4 );
   end
 Else
   begin
    c4 := 2 * c3 / ( c1 - c2 );
    arc := arctan( c4 );
    tryFi( arc );
    tryFi( arc + pi / 2 );
    tryFi( arc + pi );
    tryFi( arc + 3 * pi / 2 );
   end;
 writeln( abs( dist ) : 0 : 6 );
 if c < -eps then
   begin
    a := -a;
    b := -b;
    c := -c;
   end;
 a := DeleteMinus( a );
 b := DeleteMinus( b );
 c := DeleteMinus( c );
 writeln( a : 0 : 6,' ',b : 0 : 6,' ',c : 0 : 6);
end;


begin
  OpenFiles;
  InitData;
  Solve;
  CloseFiles;
end.
 