program Problem1;

{$D-,Q-,R-,L-}

{

  EVA RULEZZZ!!!!!!!

  Fight with the best? Die like the rest!

  Copyright by [ hr0nix@darkwired ]

}

const
  InFile = 'rle.in';
  OutFile = 'rle.out';
  MaxN = 30001;

type
  Int = longint;
  Real = extended;
  TSegment = record
    s, e, num : Int;
  end;

var
  nums : array [1..MaxN] of Int;
  laststring, curstring : array [1..MaxN] of TSegment;
  colors : array [1..MaxN] of Int;
  m, n, b, k, cs, cls, cc : Int;

procedure OpenFiles;
begin
  assign( input, InFile );
  reset( input );
  assign( output, OutFile );
  rewrite( output );
end;

procedure CloseFiles;
begin
  close( input );
  close( output );
end;

function Intersect( nnew, nold : Int ) : boolean;
begin
  if ( ( laststring[ nold ].s >= curstring[ nnew ].s ) and
       ( laststring[ nold ].s <= curstring[ nnew ].e ) )
      or
     ( ( laststring[ nold ].e >= curstring[ nnew ].s ) and
       ( laststring[ nold ].e <= curstring[ nnew ].e ) )
       then
        Intersect := true
       else
        Intersect := false;
end;

function InColors( color : Int ) : boolean;
var
  i : Int;
begin
  InColors := true;
  for i := 1 to cc do
    if colors[ i ] = color then
      exit;
  InColors := false;
end;

procedure InitData;
var
  i : Int;
begin
  read( m, n, b, k );
  for i := 1 to k do
    read( nums[ i ] );
  if ( k mod 2 <> b ) then
    inc( nums[ k ], m )
  else begin
    inc( k );
    nums[ k ] := m;
  end;
end;

procedure Solve;
var
  ans, i, i1, i2, iold, numc : Int;
  sum : Int64;
  color : boolean;

begin
  // reading first string
  i := 1;
  sum := 0;
  color := ( b = 1 );
  cls := 0;
  numc := 0;
  iold := 1;
  while true do begin
    if color then begin
      inc( cls );
      inc( numc );
      laststring[ cls ].s := sum + 1;
      laststring[ cls ].e := sum + 1 + nums[ i ];
      if laststring[ cls ].e > m + 1 then
        laststring[ cls ].e := m + 1;
      laststring[ cls ].num := numc;
    end;
    inc( sum, nums[ i ] );
    if sum > m then begin
      nums[ i ] := sum - m;
      iold := i;
      break;
    end else
    if sum = m then begin
      color := not( color );
      iold := i + 1;
      break;
    end else begin
      inc( i );
      color := not( color );
    end;
  end;

  // primary calculations
  ans := 0;
  sum := 0;
  cs := 0;
  i := iold;
  while i <= k do begin
    if color then begin
      inc( cs );
      curstring[ cs ].s := sum + 1;
      curstring[ cs ].e := sum + 1 + nums[ i ];
      if curstring[ cs ].e > m + 1 then
        curstring[ cs ].e := m + 1;
      curstring[ cs ].num := -1;
    end;
    inc( sum, nums[ i ] );
    if sum >= m then begin
      if sum > m then begin
        nums[ i ] := sum - m;
      end else
      if sum = m then begin
        color := not( color );
        inc( i );
      end;
      cc := 0;
      for i1 := 1 to cs do begin
        for i2 := 1 to cls do
        if Intersect( i1, i2 ) then begin
          inc( cc );
          colors[ cc ] := laststring[ i2 ].num;
          curstring[ i1 ].num := laststring[ i2 ].num;
        end;
      end;
      for i1 := 1 to cls do begin
        if not( InColors( laststring[ i1 ].num ) ) then
          inc( ans );
        inc( cc );
        colors[ cc ] := laststring[ i1 ].num;
      end;
      laststring := curstring;
      cls := cs;
      for i1 := 1 to cls do
        if laststring[ i1 ].num = -1 then begin
          laststring[ i1 ].num := numc;
          inc( numc );
        end;
      sum := 0;
      cs := 0;
    end else begin
      inc( i );
      color := not( color );
    end;
  end;

  writeln( ans );
end;

begin
  OpenFiles;
  InitData;
  Solve;
  CloseFiles;
end.

