{$N+}
{$M 30000000,2097152}
var n,m,nedg:longint;
    edg:array[1..210000,1..3]of longint;
    bedg:array[1..11000]of longint;
    s,t:longint;

procedure Qsort(be,en:longint);
var l,r,x,t:longint;
begin
    l:=be;
    r:=en;
    x:=edg[l+random(r-l+1),1];
    while l<r do begin
        while x>edg[l,1] do inc(l);
        while x<edg[r,1] do dec(r);
        if l<=r then begin
            t:=edg[l,1];
            edg[l,1]:=edg[r,1];
            edg[r,1]:=t;
            t:=edg[l,2];
            edg[l,2]:=edg[r,2];
            edg[r,2]:=t;
            t:=edg[l,3];
            edg[l,3]:=edg[r,3];
            edg[r,3]:=t;
            inc(l);
            dec(r);
        end;
    end;
    if be<r then Qsort(be,r);
    if l<en then Qsort(l,en);
end;

procedure Load;
var i:longint;
begin
    fillchar(bedg,sizeof(bedg),0);
    randseed:=11111;
    readln(n,m);
    nedg:=0;
    for i:=1 to m do begin
        inc(nedg);
        readln(edg[nedg,1],edg[nedg,2],edg[nedg,3]);
        inc(nedg);
        edg[nedg,1]:=edg[nedg-1,2];
        edg[nedg,2]:=edg[nedg-1,1];
        edg[nedg,3]:=edg[nedg-1,3];
    end;
    Qsort(1,nedg);
    bedg[edg[1,1]]:=1;
    for i:=2 to nedg do begin
        if edg[i,1]<>edg[i-1,1] then bedg[edg[i,1]]:=i;
    end;
    bedg[n+1]:=nedg+1;
    for i:=n downto 1 do begin
        if bedg[i]=0 then bedg[i]:=bedg[i+1];
    end;
    read(s,t);
end;

var wcnt,prev,hp,whr:array[1..11000]of longint;
    dst:array[1..11000]of int64;
    max:array[1..3,1..11000]of int64;
    nhp:longint;

procedure StepUp(ind:longint);
var nxt,cur,t:longint;
begin
    cur:=ind;
    nxt:=cur shr 1;
    while(cur>1)and(dst[hp[nxt]]>dst[hp[cur]])do begin
        t:=whr[hp[cur]];
        whr[hp[cur]]:=whr[hp[nxt]];
        whr[hp[nxt]]:=t;
        t:=hp[cur];
        hp[cur]:=hp[nxt];
        hp[nxt]:=t;
        cur:=nxt;
        nxt:=cur shr 1;
    end;
end;

procedure StepDown(ind:longint);
var nxt,cur,t:longint;
begin
    cur:=ind;
    nxt:=cur*2;
    if  (nxt<nhp)and( dst[hp[nxt+1]]<dst[hp[nxt]])then inc(nxt);
    while(nxt<=nhp)and(dst[hp[nxt]]<dst[hp[cur]])do begin
        t:=whr[hp[cur]];
        whr[hp[cur]]:=whr[hp[nxt]];
        whr[hp[nxt]]:=t;
        t:=hp[cur];
        hp[cur]:=hp[nxt];
        hp[nxt]:=t;
        cur:=nxt;
        nxt:=cur shl 1;
        if  (nxt<nhp)and( dst[hp[nxt+1]]<dst[hp[nxt]])then inc(nxt);
    end;
end;

procedure AddHeap(i:longint);
begin
    inc(nhp);
    hp[nhp]:=i;
    whr[i]:=nhp;
    StepUp(nhp);
    StepDown(nhp);
end;

procedure DeleteHeap(ind:longint);
begin
    whr[hp[nhp]]:=ind;
    hp[ind]:=hp[nhp];
    dec(nhp);
    StepDown(ind);
end;

function GetMinMAx(ver:longint):longint;
var i,mm:longint;
begin
    mm:=1;
    for  i:=2 to 3 do if max[i,ver]<max[mm,ver] then mm:=i;
    GetMinMAx:=mm;
end;

procedure DeixtRA;
var cver,mver,nver,i,cmm:longint;
    cres,nres:int64;
begin
    fillchar(max,sizeof(max),0);
    fillchar(wcnt,sizeof(wcnt),0);
    fillchar(whr,sizeof(whr),0);
    for i:=1 to n do begin
        dst[i]:=2000000000;
        dst[i]:=dst[i] shl 4;
    end;
    dst[s]:=0;
    for i:=1 to n do begin
        if i<>s then AddHeap(i);
    end;
    cver:=s;
    wcnt[s]:=1;
    while true do begin
        cres:=max[1,cver]+max[2,cver]+max[3,cver];
        cmm:=GetMinMax(cver);
        wcnt[cver]:=1;
        for i:=bedg[cver] to bedg[cver+1]-1 do begin
            nver:=edg[i,2];
            if max[cmm,cver]>edg[i,3] then nres:=cres
            else nres:=cres-max[cmm,cver]+edg[i,3];
            if (dst[nver]>nres) then begin
                wcnt[nver]:=0;
                max[1,nver]:=max[1,cver];
                max[2,nver]:=max[2,cver];
                max[3,nver]:=max[3,cver];
                if max[cmm,cver]<edg[i,3] then max[cmm,nver]:=edg[i,3];
                dst[nver]:=max[1,nver]+max[2,nver]+max[3,nver];
                StepUp(whr[nver]);
                StepDown(whr[nver]);
            end;
        end;
        mver:=hp[1];
        if nhp=0 then break;
        DeleteHeap(1);
        cver:=mver;
    end;
end;

procedure Solve;
begin
    DeixtRA;
    write(max[1,t]+max[2,t]+max[3,t]);
end;

begin
    assign(input,'customs.in');
    assign(output,'customs.out');
    reset(input);
    rewrite(output);
    Load;
    Solve;
    close(input);
    close(output);
end.
