{$M 30000000,30000000}
{$N+}
var acc:longint;
    was,mem,mem2:array[1..33000]of longint;
    cc,cmd:char;
    val:longint;

procedure REadCommand;
begin
    read(cmd,cc);
    cmd:=upcase(cmd);
    readln(val);
end;

procedure CheckOverFlow;
begin
    acc:=acc mod 65536;
    while acc>32767 do dec(acc,65536);
    while acc<-32768 do inc(acc,65536);
end;

function Root(cur:longint):longint;
var rt:longint;
begin
    if was[cur]=1 then begin
        Root:=0;
        exit;
    end;
    was[cur]:=1;
    if mem2[cur]>=0 then begin
        Root:=cur;
        was[cur]:=0;
        exit;
    end;
    rt:=Root(-mem2[cur]);
    if rt=0 then begin
        Root:=0;
        exit;
    end;
    mem2[cur]:=-rt;
    was[cur]:=0;
    Root:=rt;
end;

function ExecuteCommand:longint;
var nval:longint;
begin
    if cc='=' then nval:=val
    else begin
        nval:=Root(val);
        if nval=0 then begin
            ExecuteCommand:=1;
            exit;
        end;
        if cmd<>'W' then nval:=mem[nval];
    end;
    case cmd of
        'A': begin
            inc(acc,nval);
            CheckOverFlow;
        end;
        'S': begin
            dec(acc,nval);
            CHeckOverFlow;
        end;
        'M': begin
            acc:=acc*nval;
            CHeckOverFlow;
        end;
        'D': begin
            if nval=0 then begin
                ExecuteCommand:=2;
                exit;
            end;
            acc:=acc div nval;
            CheckOverFlow;
        end;
        'O': begin
            if nval=0 then begin
                ExecuteCommand:=2;
                exit;
            end;
            acc:=acc mod nval;
            CheckOverFlow;
        end;
        'R': begin
            acc:=nval;
            CheckOverFlow;
        end;
        'W': begin
            mem[nval]:=acc;
            mem2[nval]:=acc;
        end;
    end;
    ExecuteCommand:=0;
end;

procedure OutMem;
var i:longint;
begin
    writeln;
    write(acc);
    for i:=1 to 32768 do begin
        writeln;
        write(mem[i]);
    end;
end;

procedure Solve;
var tr,f:longint;
begin
    acc:=0;
    f:=0;
    fillchar(mem,sizeof(mem),0);
    fillchar(mem2,sizeof(mem2),0);
    while not eof(input) do begin
        ReadCommand;
        tr:=ExecuteCommand;
        if tr=1 then begin
            write('RUN-TIME ERROR');
            f:=1;
            break;
        end
        else if tr=2 then begin
            write('DIVISION BY ZERO');
            f:=1;
            break;
        end;
    end;
    if f=0 then write('SUCCESSFUL TERMINATION');
    OutMem;
end;

begin
    assign(input,'indirect.in');
    assign(output,'indirect.out');
    reset(input);
    rewrite(output);
    Solve;
    close(input);
    close(output);
end.
