{$N+}
const dx:array[1..4]of longint=(-1,1,0,0);
const dy:array[1..4]of longint=(0,0,1,-1);
var near:array[-1000..1000,-1000..1000]of longint;
    q:array[1..5000000,1..2]of longint;
    hd,tl:longint;
    n,m:int64;
    pnt:array[1..51000,1..2]of longint;

function Inside(x,y:longint):boolean;
begin
    if(x>=-1000)and(y>=-1000)and(x<=1000)and(y<=1000) then Inside:=true
    else Inside:=false;
end;

procedure StartBFS;
var i,nx,ny:longint;
begin
    while hd<=tl do begin
        for i:=1 to 4 do begin
            nx:=q[hd,1]+dx[i];
            ny:=q[hd,2]+dy[i];
            if not Inside(nx,ny) then continue;
            if near[nx,ny]=0 then begin
                near[nx,ny]:=near[q[hd,1],q[hd,2]];
                inc(tl);
                q[tl,1]:=nx;
                q[tl,2]:=ny;
            end;
        end;
        inc(hd);
    end;
end;

procedure Load;
var i:longint;
begin
    fillchar(near,sizeof(near),0);
    hd:=1;
    tl:=0;
    read(n,m);
    for i:=1 to n do begin
        read(pnt[i,1],pnt[i,2]);
        inc(tl);
        q[tl,1]:=pnt[i,1];
        q[tl,2]:=pnt[i,2];
        near[q[tl,1],q[tl,2]]:=i;
    end;
end;

procedure SolveBFS;
var i,p,q,ci:longint;
begin
    StartBFS;
    for i:=1 to m do begin
        read(p,q);
        ci:=near[p,q];
        write(pnt[ci,1],' ',pnt[ci,2]);
        if i<m then writeln;
    end;
end;

procedure SolveBAD;
var i,j,mi:longint;
    min,csqr,cx64,cy64:int64;
    cx,cy:longint;
begin
    for i:=1 to m do begin
        min:=2000000000;
        min:=min*min;
        read(cx,cy);
        cx64:=cx;
        cy64:=cy;
        for j:=1 to n do begin
            csqr:=(cx64-pnt[j,1])*(cx64-pnt[j,1])+(cy64-pnt[j,2])*(cy64-pnt[j,2]);
            if csqr<min then begin
                min:=csqr;
                mi:=j;
            end;
        end;
        write(pnt[mi,1],' ',pnt[mi,2]);
        if i<m then writeln;
    end;
end;

begin
    assign(input,'rescue.in');
    assign(output,'rescue.out');
    reset(input);
    rewrite(output);
    Load;
    if n*m<=9000000 then SolveBAD
    else SolveBFS;
    close(input);
    close(output);
end.
