{$M 30000000,30000000}
{$N+}
const eps=1e-9;
var pnt:array[1..301,1..2]of double;
    n:longint;

procedure QsortX(be,en:longint);
var l,r,tl:longint;
    t,x,y:double;
begin
    l:=be;
    r:=en;
    tl:=l+random(r-l+1);
    x:=pnt[tl,1];
    y:=pnt[tl,2];
    while l<r do begin
        while (x-pnt[l,1]>eps)or((abs(x-pnt[l,1])<eps)and(y-pnt[l,2]>eps))do inc(l);
        while (x-pnt[r,1]<-eps)or((abs(x-pnt[r,1])<eps)and(y-pnt[r,2]<-eps)) do dec(r);
        if l<=r then begin
            t:=pnt[l,1];
            pnt[l,1]:=pnt[r,1];
            pnt[r,1]:=t;
            t:=pnt[l,2];
            pnt[l,2]:=pnt[r,2];
            pnt[r,2]:=t;
            inc(l);
            dec(r);
        end;
    end;
    if be<r then QsortX(be,r);
    if l<en then QsortX(l,en);
end;

procedure Load;
var i:longint;
begin
    read(n);
    for i:=1 to n do begin
        read(pnt[i,1],pnt[i,2]);
    end;
    QsortX(1,n);
end;

function VEctorSign(p1,p2,p3,p4:longint):longint;
var v1x,v1y,v2x,v2y,v:extended;
begin
    v1x:=pnt[p2,1]-pnt[p1,1];
    v1y:=pnt[p2,2]-pnt[p1,2];
    v2x:=pnt[p4,1]-pnt[p3,1];
    v2y:=pnt[p4,2]-pnt[p3,2];
    v:=v1x*v2y-v1y*v2x;
    if abs(v)<eps then VectorSign:=0
    else if v<0 then VectorSign:=-1
    else VEctorSign:=1;
end;

var eup,edwn:array[1..310,0..310]of longint;
    vs:array[1..310,1..310,1..310]of shortint;
    beg:longint;

function CountUp(pnt,prev:longint):longint;
var i,cr:longint;
begin
    if pnt=beg then begin
        CountUp:=1;
        exit;
    end;
    if eup[pnt,prev]>=0 then  begin
        CountUp:=eup[pnt,prev];
        exit;
    end;
    eup[pnt,prev]:=0;
    for i:=1 to pnt-1 do begin
        if (prev=0)or(VS[i,pnt,prev]<0)then begin
            cr:=CountUp(i,pnt)+1;
            if cr>eup[pnt,prev] then eup[pnt,prev]:=cr;
        end;
    end;
    CountUp:=eup[pnt,prev];
end;

function CountDown(pnt,prev:longint):longint;
var i,cr:longint;
begin
    if pnt=beg then begin
        CountDown:=1;
        exit;
    end;
    if edwn[pnt,prev]>=0 then  begin
        CountDown:=edwn[pnt,prev];
        exit;
    end;
    edwn[pnt,prev]:=0;
    for i:=1 to pnt-1 do begin
        if (prev=0)or(VS[i,pnt,prev]>0)then begin
            cr:=CountDown(i,pnt)+1;
            if cr>edwn[pnt,prev] then edwn[pnt,prev]:=cr;
        end;
    end;
    CountDown:=edwn[pnt,prev];
end;

procedure Solve;
var i,j,k,max,cr:longint;
begin
    for i:=1 to n do begin
        for j:=i+1 to n do begin
            for k:=j+1 to n do begin
                vs[i,j,k]:=VectorSign(i,j,j,k);
            end;
        end;
    end;
    max:=-2000000000;
    for i:=1 to n do begin
        fillchar(eup,sizeof(eup),$FF);
        fillchar(edwn,sizeof(edwn),$FF);
        beg:=i;
        for j:=1 to n do begin
            cr:=CountUp(j,0)+CountDown(j,0);
            dec(cr,2);
            if cr>max then max:=cr;
        end;
    end;
    write(max);
end;

begin
    assign(input,'polygon.in');
    assign(output,'polygon.out');
    reset(input);
    rewrite(output);
    Load;
    Solve;
    close(input);
    close(output);
end.
