{$N+}
var aseq:array[0..32]of int64;

procedure Load;
var k:longint;
    res:int64;
begin
    aseq[0]:=1;
    aseq[1]:=2;
    for k:=2 to 32 do begin
        res:=1;
        if k mod 2=0 then begin
            res:=(1 shl (k div 2))+(1 shl (k div 2 -1));
            aseq[k]:=res;
        end
        else begin
            res:=(1 shl (k div 2 +1));
            aseq[k]:=res;
        end;
    end;
end;
var bytebuf:array[1..10]of longint;
    cbuf,len:longint;

function toupper(c:char):char;
begin
    if (c<='z')and(c>='a') then begin
        toupper:=chr(ord(c)-(ord('a')-ord('A')));
    end
    else toupper:=c;
end;

function ReadByte:longint;
var c:char;
    n1,n2:longint;
function ReadNum:longint;
begin
    ReadNum:=0;
    read(c);
    while (c=' ')or(c=#13)or(c=#10) do begin
        read(c);
        if eof(input) then break;
    end;
    if c in['0'..'9']then REadNum:=ord(c)-ord('0')
    else REadNum:=ord(toupper(c))-ord('A')+10;
end;
begin
    n1:=ReadNUm;
    n2:=ReadNum;
    ReadByte:=(n1 shl 4)+n2;
end;

procedure FillBuf;
var i:longint;
begin
    cbuf:=1;
    for i:=1 to 10 do begin
        bytebuf[i]:=ReadByte;
    end;
end;

procedure ReadLen;
var i:longint;
begin
    len:=0;
    i:=0;
    while i<4 do begin
        len:=len+(bytebuf[cbuf])shl(i*8);
        inc(cbuf);
        if cbuf=11 then FillBuf;
        inc(i);
    end;
end;

var wtab,tablen:array[0..24]of longint;
    tabseq:array[0..24]of string;
    tabtree:array[1..1000]of longint;
    wba,balen:array[0..300]of longint;
    baseq:array[1..300]of string;
    batree:array[1..17000000]of integer;
    wsec,seclen:array[0..32]of longint;
    sectree:array[1..1000]of longint;
    secseq:array[0..32]of string;

procedure QsortBase(be,en:longint);
var y,l,r,x,t:longint;
begin
    l:=be;
    r:=en;
    t:=l+random(r-l+1);
    x:=balen[t];
    y:=wba[t];
    while l<r do begin
        while (x<balen[l])or((x=balen[l])and(y>wba[l])) do inc(l);
        while (x>balen[r])or((x=balen[r])and(y<wba[r])) do dec(r);
        if l<=r then begin
            t:=balen[l];
            balen[l]:=balen[r];
            balen[r]:=t;
            t:=wba[l];
            wba[l]:=wba[r];
            wba[r]:=t;
            inc(l);
            dec(r);
        end;
    end;
    if be<r then QsortBase(be,r);
    if l<en then QsortBase(l,en);
end;

procedure QsortSecond(be,en:longint);
var y,l,r,x,t:longint;
begin
    l:=be;
    r:=en;
    t:=l+random(r-l+1);
    x:=seclen[t];
    y:=wsec[t];
    while l<r do begin
        while (x<seclen[l])or((x=seclen[l])and(y>wsec[l])) do inc(l);
        while (x>seclen[r])or((x=seclen[r])and(y<wsec[r])) do dec(r);
        if l<=r then begin
            t:=seclen[l];
            seclen[l]:=seclen[r];
            seclen[r]:=t;
            t:=wsec[l];
            wsec[l]:=wsec[r];
            wsec[r]:=t;
            inc(l);
            dec(r);
        end;
    end;
    if be<r then QsortSecond(be,r);
    if l<en then QsortSecond(l,en);
end;


procedure BuildBaseTree;
var cseq,nseq:string;
    cur,i,j:longint;
procedure INCNSEQ;
var cur:longint;
begin
    cur:=length(nseq);
    nseq[cur]:=chr(ord(nseq[cur])+1);
    while nseq[cur]='2' do begin
        nseq[cur-1]:=chr(ord(nseq[cur-1])+1);
        nseq[cur]:='0';
        dec(cur);
    end;
end;
function GetLastZR:longint;
var cur,fnd:longint;
begin
    cur:=length(nseq);
    fnd:=0;
    while (cur>0)and(nseq[cur]='0') do begin
        inc(fnd);
        dec(cur);
    end;
    GetLastZR:=fnd;
end;

begin
    for i:=1 to 17000000 do batree[i]:=-1;
    QsortBase(0,255+32);
    cur:=0;
    cseq:='';
    for i:=1 to balen[0] do cseq:=cseq+'0';
    while balen[cur]<>0 do begin
        baseq[wba[cur]]:=cseq;
        inc(cur);
        if balen[cur]=0 then break;
        nseq:=cseq;
        INCNSEQ;
        while GetLastZR<balen[cur-1]-balen[cur] do INCNSEQ;
        cseq:='';
        for i:=1 to balen[cur] do cseq:=cseq+nseq[i];
    end;
    {generating tree}
    for i:=0 to 255+32 do begin
        cur:=1;
        if balen[i]=0 then continue;
        for j:=1 to balen[i] do begin
            cur:=2*cur+ord(baseq[wba[i]][j])-ord('0');
        end;
        batree[cur]:=wba[i];
    end;
end;

procedure BuildSecondTree;
var cseq,nseq:string;
    cur,i,j:longint;
procedure INCNSEQ;
var cur:longint;
begin
    cur:=length(nseq);
    nseq[cur]:=chr(ord(nseq[cur])+1);
    while nseq[cur]='2' do begin
        nseq[cur-1]:=chr(ord(nseq[cur-1])+1);
        nseq[cur]:='0';
        dec(cur);
    end;
end;
function GetLastZR:longint;
var cur,fnd:longint;
begin
    cur:=length(nseq);
    fnd:=0;
    while (cur>0)and(nseq[cur]='0') do begin
        inc(fnd);
        dec(cur);
    end;
    GetLastZR:=fnd;
end;

begin
    for i:=1 to 1000 do sectree[i]:=-1;
    QsortSecond(0,31);
    cur:=0;
    cseq:='';
    for i:=1 to seclen[0] do cseq:=cseq+'0';
    while seclen[cur]<>0 do begin
        secseq[wsec[cur]]:=cseq;
        inc(cur);
        if seclen[cur]=0 then break;
        nseq:=cseq;
        INCNSEQ;
        while GetLastZR<seclen[cur-1]-seclen[cur] do INCNSEQ;
        cseq:='';
        for i:=1 to seclen[cur] do cseq:=cseq+nseq[i];
    end;
    {generating tree}
    for i:=0 to 31 do begin
        cur:=1;
        if seclen[i]=0 then continue;
        for j:=1 to seclen[i] do begin
            cur:=2*cur+ord(secseq[wsec[i]][j])-ord('0');
        end;
        sectree[cur]:=wsec[i];
    end;
end;


procedure BuildTabTree;
var i,cur,j:longint;
begin
    for i:=1 to 1000 do tabtree[i]:=-1;
    for i:=0 to 24 do begin
        cur:=1;
        if tablen[i]=0 then continue;
        for j:=1 to tablen[i] do begin
            cur:=2*cur+ord(tabseq[wtab[i]][j])-ord('0');
        end;
        tabtree[cur]:=wtab[i];
    end;
end;

procedure INCCBUF;
begin
    inc(cbuf);
    if cbuf=11 then FillBuf;
end;

procedure QsortTab(be,en:longint);
var y,l,r,x,t:longint;
begin
    l:=be;
    r:=en;
    t:=l+random(r-l+1);
    x:=tablen[t];
    y:=wtab[t];
    while l<r do begin
        while (x<tablen[l])or((x=tablen[l])and(y>wtab[l])) do inc(l);
        while (x>tablen[r])or((x=tablen[r])and(y<wtab[r])) do dec(r);
        if l<=r then begin
            t:=tablen[l];
            tablen[l]:=tablen[r];
            tablen[r]:=t;
            t:=wtab[l];
            wtab[l]:=wtab[r];
            wtab[r]:=t;
            inc(l);
            dec(r);
        end;
    end;
    if be<r then QsortTab(be,r);
    if l<en then QsortTab(l,en);
end;

var bitbuf:array[1..80]of longint;
    cbbuf:longint;

procedure FillBBuf;
var i,cnum,j:longint;
begin
    cbbuf:=1;
    i:=1;
    while i<>81 do begin
        cnum:=bytebuf[cbuf];
        INCCBUF;
        for j:=7 downto 0 do begin
            bitbuf[i]:=(cnum and(1 shl j))shr j;
            inc(i);
        end;
    end;
end;

procedure INCCBBUF;
begin
    inc(cbbuf);
    if cbbuf=81 then FillBBuf;
end;

var outseq:array[1..240000]of longint;

function LOG2(a:longint):longint;
var k,val:int64;
begin
    k:=0;
    val:=1;
    while val<a do begin
        vaL:=val*2;
        inc(k);
    end;
    LOG2:=k;
end;

procedure Solve;
var wcl,t,i,cur,clen,c1,c2,xi,lj,x,l,of1,of2:longint;
    cseq,nseq:string;
procedure INCNSEQ;
var cur:longint;
begin
    cur:=length(nseq);
    nseq[cur]:=chr(ord(nseq[cur])+1);
    while nseq[cur]='2' do begin
        nseq[cur-1]:=chr(ord(nseq[cur-1])+1);
        nseq[cur]:='0';
        dec(cur);
    end;
end;
function GetLastZR:longint;
var cur,fnd:longint;
begin
    cur:=length(nseq);
    fnd:=0;
    while (cur>0)and(nseq[cur]='0') do begin
        inc(fnd);
        dec(cur);
    end;
    GetLastZR:=fnd;
end;
function GetNExtSymbol:longint;
var cur:longint;
begin
    cur:=1;
    while batree[cur]=-1 do begin
        cur:=2*cur+bitbuf[cbbuf];
        INCCBBUF;
    end;
    GetNextSymbol:=batree[cur];
end;
function GetSecSymbol:longint;
var cur:longint;
begin
    cur:=1;
    while sectree[cur]=-1 do begin
        cur:=2*cur+bitbuf[cbbuf];
        INCCBBUF;
    end;
    GetSecSymbol:=sectree[cur];
end;
begin
    FillBuf;
    inc(cbuf,4);
    ReadLen;
    {reading lens of lens}
    i:=0;
    while i<23 do begin
        tablen[i]:=bytebuf[cbuf] shr 4;
        wtab[i]:=i;
        inc(i);
        tablen[i]:=bytebuf[cbuf]-(tablen[i-1] shl 4);
        wtab[i]:=i;
        inc(i);
        INCCBUF;
    end;
    QsortTab(0,23);
    cur:=0;
    cseq:='';
    for i:=1 to tablen[0] do cseq:=cseq+'0';
    while tablen[cur]<>0 do begin
        tabseq[wtab[cur]]:=cseq;
        inc(cur);
        if tablen[cur]=0 then break;
        nseq:=cseq;
        INCNSEQ;
        while GetLastZR<tablen[cur-1]-tablen[cur] do INCNSEQ;
        cseq:='';
        for i:=1 to tablen[cur] do cseq:=cseq+nseq[i];
    end;
    cbbuf:=80;
    INCCBBUF;
    BuildTabTree;
    {retrieving packed table lens}
    for i:=0 to 255+32 do begin
        {reading symbol}
        cur:=1;
        while tabtree[cur]=-1 do begin
            cur:=2*cur+bitbuf[cbbuf];
            INCCBBUF;
        end;
        balen[i]:=tabtree[cur];
        wba[i]:=i;
    end;
    {retrieving packed second lens}
    for i:=0 to 31 do begin
        {reading symbol}
        cur:=1;
        while tabtree[cur]=-1 do begin
            cur:=2*cur+bitbuf[cbbuf];
            INCCBBUF;
        end;
        seclen[i]:=tabtree[cur];
        wsec[i]:=i;
    end;
    {}
    BuildBaseTree;
    BuildSecondTree;
    {reading symbols}
    clen:=0;
    while clen<>len do begin
        c1:=GetNextSymbol;
        if c1>255 then begin
            xi:=c1-256;
            of1:=LOG2(aseq[xi+1]-aseq[xi]);
            t:=0;
            for i:=1 to of1 do begin
                t:=t shl 1+bitbuf[cbbuf];
                INCCBBUF;
            end;
            x:=aseq[xi]+t;
            c2:=GetSecSymbol;
            lj:=c2;
            of2:=LOG2(aseq[lj+1]-aseq[lj]);
            for i:=1 to of2 do begin
                t:=t shl 1+bitbuf[cbbuf];
                INCCBBUF;
            end;
            l:=aseq[lj]+t;
            wcl:=clen;
            for i:=1 to l do begin
                inc(clen);
                outseq[clen]:=outseq[wcl-x+i];
            end;
        end
        else begin
            inc(clen);
            outseq[clen]:=c1;
        end;
    end;
end;

procedure QWrite(a:longint);
var c:char;
    cnum:longint;
begin
    cnum:=a shr 4;
    if cnum<10 then c:=chr(cnum+ord('0'))
    else c:=chr(cnum+ord('A')-10);
    write(c);
    cnum:=a-((a shr 4)shl 4);
    if cnum<10 then c:=chr(cnum+ord('0'))
    else c:=chr(cnum+ord('A')-10);
    write(c);
end;

procedure Save;
var i:longint;
begin
    for i:=1 to len do begin
        QWrite(outseq[i]);
    end;
end;

begin
    assign(input,'kar.in');
    assign(output,'kar.out');
    reset(input);
    rewrite(output);
    Load;
    Solve;
    Save;
    close(input);
    close(output);
end.
