const
     FileIn='sin.in';
     FileOut='sin.out';
     MaxN=100;
var
   N: LongInt;
   B: array [1..MaxN] of LongInt;
   AnswerValue: Extended;
   AnswerLength: LongInt;
   Answer: array [1..MaxN] of LongInt;

procedure ReadData;
var
   F: Text;
   Index: LongInt;
begin
     Assign (F, FileIn);
     Reset (F);
     Readln (F, N);
     for Index:=1 to N
         do Read (F, B [Index]);
     Close (F);
end;

procedure WriteData;
var
   F: Text;
   Index: LongInt;
begin
     Assign (F, FileOut);
     Rewrite (F);
     Writeln (F, AnswerValue:0:6);
     for Index:=1 to AnswerLength
         do Write (F, Answer [Index], #32);
     Close (F);
end;

type
    TCell=record
                FilledIn: Boolean;
                Value: Extended;
                OldK: LongInt;
          end;
var
   Dynamic: array [1..MaxN, 1..MaxN, 1..MaxN] of TCell;
// Dynamic [i, j, k] -  㬬 鸞  j ᫠,   㬬 i  ᫥   k

procedure Solve;
var
   i, j, k, ni, nj, nk: LongInt;
   NewValue: Extended;
begin
     for i:=1 to N
         do for j:=1 to N
                do for k:=1 to N
                       do Dynamic [i, j, k].FilledIn:=false;

     for i:=1 to N
         do with Dynamic [i, 1, i]
                 do begin
                    FilledIn:=true;
                    Value:=0;
                    OldK:=1;
                 end;

     for i:=1 to N
         do for j:=1 to N-1
                do for k:=1 to N
                       do if Dynamic [i, j, k].FilledIn
                             then for nk:=1 to N-i
                                      do begin
                                         ni:=i+nk;
                                         nj:=j+1;
                                         NewValue:=Dynamic [i, j, k].Value+Sin ((j+1)*B [j]*k*nk);
                                         if (not Dynamic [ni, nj, nk].FilledIn) or
                                            (Dynamic [ni, nj, nk].Value<NewValue)
                                            then begin
                                                 Dynamic [ni, nj, nk].FilledIn:=true;
                                                 Dynamic [ni, nj, nk].Value:=NewValue;
                                                 Dynamic [ni, nj, nk].OldK:=k;
                                            end;
                                      end;
     for nj:=1 to N
         do begin
            for nk:=1 to N
                do if Dynamic [N, nj, nk].FilledIn
                      then Break;
            if Dynamic [N, nj, nk].FilledIn
               then Break;
         end;
     AnswerValue:=Dynamic [N, nj, nk].Value/nj;
     for j:=1 to N
         do for k:=1 to N
                do if Dynamic [N, j, k].FilledIn
                      then if Dynamic [N, j, k].Value/j>AnswerValue
                              then begin
                                   nj:=j;
                                   nk:=k;
                                   AnswerValue:=Dynamic [N, nj, nk].Value/nj;
                              end;
     AnswerLength:=nj;
     i:=N;
     k:=nk;
     j:=nj;
     while j>=1
           do begin
              Answer [j]:=k;
              nk:=k;
              k:=Dynamic [i, j, k].OldK;
              Dec (j);
              Dec (i, nk);
           end;
end;

begin
     ReadData;
     Solve;
     WriteData;
end.
