{ $DEFINE DBG}
{$IFDEF DBG}
  {$I+,Q+,R+,S-}
{$ElSE}
  {$I-,Q-,R-,S-}
{$ENDIF}

program sh;
const tsk='2instr';
var t,i,j:longint;
    ws,dum:array[0..65550]of byte;
    oc:array[1..65550*2]of word;
    op:array[1..65550*2]of byte;
    from:array[1..65550*2]of longint;
    ur,uw:longint;
    sp,sn:word;
function GetHer(const a:Char):byte;
begin
 if (a>='0')and(a<='9') then GetHer:=Ord(a)-Ord('0') else
  GetHer:=10+ord(a)-ord('A');
end;
function GetHr(const a:byte):char;
begin
 if a<10 then GetHr:=Chr(ord('0')+a) else
  GetHr:=Chr(Ord('A')+a mod 10);
end;
function ByteToHex(const a:byte):string[2];
var rs:string[2];
begin
 rs:='  ';
 rs[2]:=GetHr(a mod 16);
 rs[1]:=GetHr(a div 16);
 ByteToHex:=rs;
end;
function WriteProg(const ur:longint):byte;
var rs:byte;
    s:string[2];
begin
 if ur=1 then
 begin
  WriteProg:=1;
  exit;
 end;
 rs:=WriteProg(from[ur]);
 if rs<>1 then write(' ');
 s:=ByteToHex(op[ur]);
 WRite(s);
 if rs=8 then write(' ');
 if rs=16 then
 begin
  rs:=1;
  writeln;
 end else
 begin
  rs:=rs+1;
 end;
 WriteProg:=rs;
end;
function CalcLen(const ur:longint):longint;
begin
 if ur=1 then calcLen:=0 else calclen:=calclen(from[ur])+1;
end;
procedure ReadHexw(var a:word);
var c:char;
begin
 read(c);
 while not (c in ['0'..'9','A'..'F']) do
 begin
  read(c);
 end;
 a:=GetHer(c);
 read(c);
 a:=a*16+Gether(c);
 read(c);
 a:=a*16+Gether(c);
 read(c);
 a:=a*16+Gether(c);
end;
procedure ReadDump;
var i:longint;
    s:string;
begin
 for i:=0 to 4095 do
 begin
  readln(s);
  if s='' then Break;
  for j:=0 to 7 do
  begin
   dum[i*16+j]:=GetHer(s[3*j+1])*16+GetHer(s[3*j+2]);
  end;
  s:=Copy(s,8*3+2,8*3-1);
  for j:=0 to 7 do
  begin
   dum[i*16+j+8]:=GetHer(s[3*j+1])*16+GetHer(s[3*j+2]);
  end;
 end;
end;
procedure Init;
begin
 Assign(input,tsk+'.in');
 Assign(output,tsk+'.out');
 reset(input);rewrite(output);
 readhexw(sn);
 readhexw(sp);
 readln;
 fillchar(ws,sizeof(ws)*2,0);
 readDump;
end;
procedure print;
begin

 Close(input);close(output);
end;
procedure Solve;
begin
 ur:=1;
 uw:=2;
 oc[1]:=sn;
 ws[sn]:=1;
 while (ur<uw) do
 begin
  if oc[ur]=sp then break;
  if op[ur]=$0f then
  begin
   t:=Lo(oc[ur])*256+hi(oc[ur]);
   if ws[t]=0 then
   begin
    op[uw]:=$CC;
    from[uw]:=ur;
    oc[uw]:=t;
    ws[t]:=1;
    inc(uw);
   end;
  end else
  begin
   t:=Lo(oc[ur])*256+hi(oc[ur]);
   if ws[t]=0 then
   begin
    op[uw]:=$0f;
    from[uw]:=ur;
    oc[uw]:=oc[ur];
    inc(uw);
   end;
   if oc[ur]=65535 then t:=dum[65535]+dum[0]*256 else t:=dum[oc[ur]]+dum[oc[ur]+1]*256;
   if ws[t]=0 then
   begin
    op[uw]:=$5C;
    from[uw]:=ur;
    oc[uw]:=t;
    ws[t]:=1;
    inc(uw);
   end;
  end;
  inc(ur);
 end;
 if ur<uw then
 begin
  Writeln(CalcLen(ur));
  Writeprog(ur);
  Writeln;
 end else writeln('IMPOSSIBLE');
end;
begin
 Init;
 Solve;
 Print;
end.