{$D-,I-,L-,Q-,R-,S-,N+}
program _Kitten_RSQ;
const
 f_in='kitten.in';
 f_out='kitten.out';
 maxN=1048576;

type
 int=longint;

var
 A : array[1..4*maxN-1] of int;

procedure OpenFiles;
begin
 assign(input, f_in);
 reset(input);
 assign(output, f_out);
 rewrite(output);
end;

procedure CloseFIles;
begin
 close(input);
 close(output);
end;

procedure Init;
begin
 Fillchar(A, sizeof(A), 0);
end;

procedure Solve;
var
 x, y : int;

function min(a, b : int) : int;
begin
 if a<b then min:=a else min:=b;
end;

function max(a, b : int) : int;
begin
 if a>b then max:=a else max:=b;
end;

procedure Change(X, Value : int);
var
 i, num : int;
begin
 X:=X+maxN; {protiv otricatelnih chisel}
 num:=maxN*2+X-1;
 A[ num ]:=Value;
 i:=num div 2;
 while i>=1 do
  begin
  A[i]:=A[2*i]+A[2*i+1];
  i:=i div 2;
  end;
end;

function Count(L, R : int) : int;
var
 S : int;
begin
 if L=R then
  begin Count:=A[L]; exit; end;
 S:=Count(L div 2, R div 2);
 if L mod 2=1 then dec(S, A[L-1]);
 if R mod 2=0 then dec(S, A[R+1]);
 Count:=S;
end;

function CountS(L, R : int) : int;
begin
 L:=L+maxN; {protiv otricatelnih chisel}
 R:=R+maxN;
 CountS:=Count( min(L,R)+maxN*2-1, max(L,R)+maxN*2-1 );
end;

begin
 while not SeekEOF do
  begin
  Read(x);
  if SeekEOLN then
   begin
   Readln;{}
   Change(x, 1);
   end
  else
   begin
   Readln(y);
   Writeln(CountS(x,y));
   end;
  end;

end;

begin
 OpenFiles;
 Init;
 Solve;
 CloseFiles;
end.
