  {$I-,Q-,R-,S-}
const
    maxn=51000;

type
    list=^TList;
    TList=record next:list; val:longint; end;

var test,n,m,nums,cc,nn,time:longint;
    a,at,b:array[1..maxn] of list;
    vis,instep,soc:array[1..maxn] of boolean;
    c,col,st,tt,used:array[0..maxn] of longint;
    megabo:boolean;

Procedure init;
begin
    assign(input,'quirks.in');
    reset(input);
    assign(output,'quirks.out');
    rewrite(output);
    read(test);
end;

Procedure add(const u,v:longint);
var p:list;
begin
    new(p);
    p^.next:=a[u];
    p^.val:=v;
    a[u]:=p;
    new(p);
    p^.next:=at[v];
    p^.val:=u;
    at[v]:=p;
end;

Procedure readdata;
var i,u,v:longint;
begin
    fillchar(a,sizeof(a),0);
    fillchar(at,sizeof(at),0);
    read(n,m);
    for i:=1 to m do
    begin
        read(u,v);
        add(u,v);
    end;
end;

procedure dfs(const q:longint);
var buf:list;
begin
    vis[q]:=true;
    buf:=a[q];
    while buf<>nil do
    begin
        if not vis[buf^.val] then dfs(buf^.val);
        buf:=buf^.next;
    end;
    inc(c[0]);
    c[c[0]]:=q;
end;

Procedure sfd(const q:longint);
var buf:list;
begin
    col[q]:=cc;
    buf:=at[q];
    vis[q]:=true;
    while buf<>nil do
    begin
        if not vis[buf^.val] then sfd(buf^.val);
        buf:=buf^.next;
    end;
end;

Procedure add2(const u,v:longint);
var p:list;
begin
    new(p);
    p^.next:=b[u];
    p^.val:=v;
    b[u]:=p;
end;

Procedure Condensate;
var i:longint;
    buf:list;
begin
    fillchar(b,sizeof(b),0);
    fillchar(instep,sizeof(instep),0);
    for i:=1 to n do
    begin
        buf:=a[i];
        while buf<>nil do
        begin
            if col[i]<>col[buf^.val] then
            begin
                add2(col[i],col[buf^.val]);
                instep[col[buf^.val]]:=true;
            end;
            buf:=buf^.next;
        end;
    end;
end;

Procedure dfs2(const q:longint);
var buf:list;
begin
    used[q]:=1;
    buf:=b[q];
    while buf<>nil do
    begin
        if used[buf^.val]<>0 then megabo:=true;
        if used[buf^.val]=0 then dfs2(buf^.val);
        buf:=buf^.next;
    end;
    used[q]:=2;
end;

Function min(const a,b:longint):longint;
begin
    if a<b then min:=a else min:=b;
end;

Function dfs3(const q,dep:longint):longint;
var buf:list;
    t,oldtime:longint;
begin
    vis[q]:=true;
    buf:=a[q];
    inc(time);
    oldtime:=time;
    inc(st[0]);
    st[st[0]]:=q;
    tt[q]:=time;
    while buf<>nil do
    begin
        if col[buf^.val]=col[q] then
        begin
            if not vis[buf^.val] then
            begin
                if dep=1 then inc(nn);
                t:=dfs3(buf^.val,dep+1);
                if (t>=oldtime)and(dep>1) then soc[q]:=true;
                tt[q]:=min(tt[q],t);
            end else if st[st[0]-1]<>buf^.val then
            begin
                tt[q]:=min(tt[q],tt[buf^.val]);
            end;
        end;
        buf:=buf^.next;
    end;
    buf:=at[q];
    while buf<>nil do
    begin
        if col[buf^.val]=col[q] then
        begin
            if not vis[buf^.val] then
            begin
                if dep=1 then inc(nn);
                t:=dfs3(buf^.val,dep+1);
                if (t>=oldtime)and(dep>1) then soc[q]:=true;
                tt[q]:=min(tt[q],t);
            end else if st[st[0]-1]<>buf^.val then
            begin
                tt[q]:=min(tt[q],tt[buf^.val]);
            end;
        end;
        buf:=buf^.next;
    end;
    dec(st[0]);
    dfs3:=tt[q];
end;

Procedure dfs4(const q:longint);
var buf:list;
begin
    vis[q]:=true;
    buf:=a[q];
    while buf<>nil do
    begin
        if col[q]=col[buf^.val] then
        begin
            if soc[buf^.val] then
            begin
                if instep[buf^.val] then megabo:=true else instep[buf^.val]:=true;
            end else if not vis[buf^.val] then
            begin
                instep[buf^.val]:=true;
                dfs4(buf^.val);
            end else
            begin
                if instep[buf^.val] then megabo:=true else instep[buf^.val]:=true;
            end;
        end;
        buf:=buf^.next;
    end;
end;

Function doit:boolean;
var i,bv:longint;
    buf:list;
begin
    doit:=false;

    fillchar(vis,sizeof(vis),0);
    c[0]:=0;
    for i:=1 to n do if not vis[i] then dfs(i);

    fillchar(vis,sizeof(vis),0);
    cc:=0;
    for i:=n downto 1 do if not vis[c[i]] then
    begin
        inc(cc);
        sfd(c[i]);
    end;

    {$IFDEF OKE}
    writeln('Strongly Connected Components:');
    for i:=1 to n do writeln(i,' ',col[i]);
    writeln('-------------------------');
    {$ENDIF}

    Condensate;

    bv:=0;
    for i:=1 to cc do if not instep[i] then
    begin
        if bv<>0 then exit;
        bv:=i;
    end;

    fillchar(used,sizeof(used),0);
    megabo:=false;
    dfs2(bv);
    if megabo then exit;
    for i:=1 to cc do if used[i]=0 then exit;

    fillchar(vis,sizeof(vis),0);
    fillchar(soc,sizeof(soc),0);
    fillchar(tt,sizeof(tt),0);
    for i:=1 to n do if not vis[i] then
    begin
        nn:=0;
        time:=0;
        st[0]:=0;
        dfs3(i,1);
        if nn>1 then soc[i]:=true;
    end;

    {$IFDEF OKE}
    writeln('Connecting Points:');
    for i:=1 to n do if soc[i] then writeln(i);
    writeln('-------------------------');
    {$ENDIF}

    fillchar(vis,sizeof(vis),0);
    for i:=1 to n do if (not vis[i])and(not soc[i]) then
    begin
        fillchar(instep,sizeof(instep),0);
        megabo:=false;
        dfs4(i);
        if megabo then exit;
    end;

    doit:=true;
end;

Procedure solve;
var i:longint;
begin
    for i:=1 to test do
    begin
        readdata;
        if doit then writeln('YES') else writeln('NO');
    end;
end;

begin
    init;
    solve;
    close(input);
    close(output);
end.
