  {$I-,Q-,R-,S-}
const
    maxn=610;
    maxl=1800;
    base=10000;

type TLong=array[0..maxl] of longint;

var n,l,maxnums:longint;
    nums:array[1..maxn] of longint;
    res:array[0..maxn] of TLong;

Procedure delspace(var s:string);
var i:longint;
begin
    i:=1;
    while i<=length(s) do
    begin
        if s[i]=' ' then delete(s,i,1) else inc(I);
    end;
end;

Function max(const a,b:longint):longint;
begin
    if a>b then max:=a else max:=b;
end;

Procedure init;
var i:longint;
    s:string;
begin
    assign(input,'programs.in');
    reset(input);
    assign(output,'programs.out');
    rewrite(output);
    readln(n);
    for i:=1 to n do
    begin
        readln(s);
        delspace(s);
        inc(nums[length(s)]);
        maxnums:=max(maxnums,length(s));
    end;
    read(l);
end;

Function min(const a,b:longint):longint;
begin
    if a<b then min:=a else min:=b;
end;

Procedure summul(var a:TLong; const c:TLong; const q:longint);
var i,ost:longint;
begin
    ost:=0;
    for i:=1 to max(a[0],c[0]) do
    begin
        a[i]:=a[i]+c[i]*q+ost;
        ost:=a[i] div base;
        a[i]:=a[i] mod base;
    end;
    a[0]:=max(a[0],c[0]);
    while ost<>0 do
    begin
        inc(a[0]);
        a[a[0]]:=ost mod base;
        ost:=ost div base;
    end;
end;

Procedure solve;
var i,j:longint;
begin
    res[0,0]:=1;
    res[0,1]:=1;
    for i:=1 to l do
    begin
        for j:=1 to min(i,maxnums) do if nums[j]>0 then
        begin
            summul(res[i],res[i-j],nums[j]);
        end;
    end;
end;

Procedure print;
var i,t:longint;
begin
    if res[l,0]=0 then res[l,0]:=1;
    write(res[l,res[l,0]]);
    for i:=res[l,0]-1 downto 1 do
    begin
        t:=base div 10;
        while t<>0 do
        begin
            write(res[l,i] div t);
            res[l,i]:=res[l,i] mod t;
            t:=t div 10;
        end;
    end;
end;

begin
    init;
    solve;
    print;
    close(input);
    close(output);
end.