  {$I-,Q-,R-,S-}
const
    maxn=110;
    inf=1000000000;

var n:longint;
    b:array[1..maxn] of longint;
    a:array[0..maxn,0..maxn,0..maxn] of extended;
    link:array[0..maxn,0..maxn,0..maxn] of record l1,l2:longint; end;
    vis:array[0..maxn,0..maxn,0..maxn] of boolean;
    ans:array[0..maxn] of longint;

Procedure init;
var i:longint;
begin
    assign(input,'sin.in');
    reset(input);
    assign(output,'sin.out');
    rewrite(output);
    read(n);
    for i:=1 to n do read(b[i]);
end;

Function max(const a,b:extended):extended;
begin
    if a>b then max:=a else max:=b;
end;

Procedure solve;
var i,k,j,h,l1,l2:longint;
    t,tt:extended;
begin
    for i:=1 to n do vis[1,n-i,i]:=true;
    for k:=2 to n do
    for i:=n-k+1 downto 0 do
    for j:=1 to n-i do
    begin
        t:=-inf;
        l1:=0;
        for h:=1 to n do if vis[k-1,i+j,h] then
        begin
            tt:=a[k-1,i+j,h]+sin(k*b[k-1]*j*h);
            if tt>t then
            begin
                t:=tt;
                l1:=i+j;
                l2:=h;
            end;
        end;
        if l1<>0 then
        begin
            vis[k,i,j]:=true;
            a[k,i,j]:=t;
            link[k,i,j].l1:=l1;
            link[k,i,j].l2:=l2;
        end;
    end;
end;

Procedure print;
var i,j,k,l,tj,tl:longint;
    res,tt:extended;
begin
    res:=-inf;
    for i:=2 to n do
    for j:=1 to n do if vis[i,0,j] then
    begin
        tt:=a[i,0,j]/i;
        if tt>res then
        begin
            res:=tt;
            k:=i;
            l:=j;
        end;
    end;
    writeln(res:0:7);
    j:=0;
    for i:=k downto 1 do
    begin
        inc(ans[0]);
        ans[ans[0]]:=l;
        tj:=link[i,j,l].l1;
        tl:=link[i,j,l].l2;
        j:=tj;
        l:=tl;
    end;
    for i:=ans[0] downto 1 do write(ans[i],' ');
end;

begin
    init;
    solve;
    print;
    close(input);
    close(output);
end.
