  {$I-,Q-,R-,S-}
const
    maxn=110;

type tstreet=record h,v:longint; end;

var a:array[0..maxn*maxn] of tstreet;
    h:array[0..maxn] of longint;
    c:array[0..maxn,0..maxn] of longint;
    used:array[0..maxn,0..maxn,0..maxn] of boolean;
    res:array[0..maxn,0..maxn] of longint;
    link:array[0..maxn,0..maxn] of record i,j:longint; end;
    v:array[0..maxn] of longint;
    ans:array[0..maxn] of boolean;
    n,s,k,cc:longint;

Procedure init;
var i:longint;
begin
    assign(input,'small.in');
    reset(input);
    assign(output,'small.out');
    rewrite(output);
    read(n);
    for i:=1 to n do
    begin
        read(a[i].v,a[i].h);
        inc(a[i].h);
        inc(a[i].v);
    end;
    read(s);
    for i:=1 to s do read(v[i]);
    read(k);
    if (s=0)or(s=1)or(n=0) then
    begin
        write(k,' ');
        for i:=1 to k do write(i,' ');
        close(input);
        close(output);
        halt;
    end;
end;

Procedure swap(var a,b:Tstreet);
var t:TStreet;
begin
    t:=a;
    a:=b;
    b:=t;
end;

Function more(const a,b:tstreet):boolean;
begin
    if a.h>b.h then more:=true else
    if a.h<b.h then more:=false else
    if a.v>b.v then more:=true else more:=false;
end;

Procedure qsort(const l,r:longint);
var i,j:longint;
    x:tstreet;
begin
    i:=l;
    j:=r;
    x:=a[(l+r) div 2];
    repeat
        while more(x,a[i]) do inc(i);
        while more(a[j],x) do dec(j);
        if i<=j then
        begin
            swap(a[i],a[j]);
            inc(i);
            dec(j);
        end;
    until i>j;
    if i<r then qsort(i,r);
    if j>l then qsort(l,j);
end;

Function intersect(const q1,w1,q2,w2:longint):longint;
var i,num:longint;
begin
    num:=0;
    for i:=1 to s do
    begin
        used[q1+1,w1,i]:=used[q1,w1,i] or used[q2,w2,i];
        if used[q1+1,w1,i] then inc(num);
    end;
    intersect:=num;
end;

Procedure pre;
var i,j,vv,hh:longint;
begin
    for i:=1 to n do
    begin
        vv:=a[i].v;
        hh:=a[i].h;
        if (vv<=v[1])or(vv>v[s]) then continue;
        if hh<>a[i-1].h then
        begin
            inc(cc);
            h[cc]:=hh;
        end;
        for j:=s downto 1 do
        begin
            if vv>v[j] then
            begin
                if used[1,cc,j] then break;
                inc(c[1,cc]);
                used[1,cc,j]:=true;
                break;
            end;
        end;
    end;
    h[cc]:=100;
    for i:=2 to cc do
    begin
        for j:=1 to cc-i+1 do c[i,j]:=intersect(i-1,j,i-1,j+1);
    end;
end;

Procedure dinamka;
var i,j,h,t1,t2,ii,jj:longint;
begin
    for i:=1 to k-1 do
    begin
        for j:=i to cc do
        begin
            t1:=0;
            for h:=1 to j do if res[i-1,h-1]+c[j-h+1,h]>t1 then
            begin
                t1:=res[i-1,h-1]+c[j-h+1,h];
                ii:=i-1;
                jj:=h-1;
            end;
            res[i,j]:=t1;
            link[i,j].i:=ii;
            link[i,j].j:=jj;
        end;
    end;
end;

Procedure raskrutka;
var i,j,tj,ti,num:longint;
begin
    ans[1]:=true;
    i:=k-1;
    j:=cc;
    while i<>0 do
    begin
        ans[h[j]]:=true;
        ti:=link[i,j].i;
        tj:=link[i,j].j;
        i:=ti;
        j:=tj;
    end;
    num:=0;
    for i:=1 to 101 do if ans[i] then inc(num);
    num:=k-num;
    for i:=1 to 101 do if (not ans[i])and(num>0) then
    begin
        ans[i]:=true;
        dec(num);
    end;
end;

Procedure solve;
begin
    qsort(1,n);
    pre;
    dinamka;
    raskrutka;
end;

Procedure print;
var i:longint;
begin
    write(k,' ');
    for i:=1 to 101 do if ans[i] then write(i,' ');
end;

begin
    init;
    solve;
    print;
    close(input);
    close(output);
end.