  {$I-,Q-,R-,S-}
const
    _eps=7E-7;
    inf=1000000000;

var t1,t2,t3,t4,t5:extended;
    n:longint;
    min,ra,rb,rc:extended;

Procedure init;
var i,x,y:longint;
begin
    assign(input,'best.in');
    reset(input);
    assign(output,'best.out');
    rewrite(output);
    read(n);
    for i:=1 to n do
    begin
        read(x,y);
        t1:=t1+sqr(x);
        t2:=t2+sqr(y);
        t3:=t3+x*y;
        t4:=t4+x;
        t5:=t5+y;
    end;
end;

Function eq(const a,b:extended):boolean;
begin
    eq:=abs(a-b)<_eps;
end;

Function calc(const a,b:extended; var c:extended):extended;
begin
    c:=(-2*t4*a-2*t5*b)/(2*n);
    if c>0 then
    begin
        calc:=inf;
        exit;
    end;
    calc:=t1*a*a+t2*b*b+2*t3*a*b+c*(n*c+2*t4*a+2*t5*b);
end;

Procedure doit(const l,r:extended);
var a,b,c,t:extended;
begin
    a:=(l+r)/2;
    if eq(a,l) then exit;
    b:=sqrt(1-sqr(a));
    t:=calc(a,b,c);
    if t<min then
    begin
        min:=t;
        ra:=a;
        rb:=b;
        rc:=-c;
    end;
    b:=-b;
    t:=calc(a,b,c);
    if t<min then
    begin
        min:=t;
        ra:=a;
        rb:=b;
        rc:=-c;
    end;
    doit(l,a);
    doit(a,r);
end;

Procedure solve;
var t,c:extended;
begin
    min:=inf;
    doit(-1,1);
    t:=calc(-1,0,c);
    if t<min then
    begin
        min:=t;
        ra:=-1;
        rb:=0;
        rc:=-c;
    end;
    t:=calc(1,0,c);
    if t<min then
    begin
        min:=t;
        ra:=1;
        rb:=0;
        rc:=-c;
    end;
end;

Procedure print;
begin
    writeln(min:0:7);
    writeln(ra:0:7,' ',rb:0:7,' ',rc:0:7);
end;

begin
    init;
    solve;
    print;
    close(input);
    close(output);
end.