  {$I-,Q-,R-,S-}

const
    maxn=303;

type
    TPoint=record x,y:longint; end;

var a,aa:array[0..maxn] of TPoint;
    cur:array[0..maxn,0..maxn] of longint;
    vis:array[0..maxn,0..maxn] of boolean;
    n,DN,ans:longint;

Procedure init;
var i:longint;
begin
    assign(input,'polygon.in');
    reset(input);
    assign(output,'polygon.out');
    rewrite(output);
    read(n);
    for i:=1 to n do read(a[i].x,a[i].y);
end;

Function GetVec(const a,b:TPoint):TPoint;
begin
    GetVec.x:=a.x-b.x;
    GetVec.y:=a.y-b.y;
end;

Function vp(const a,b:Tpoint):longint;
begin
    vp:=a.x*b.y-b.x*a.y;
end;

Procedure swap(var a,b:longint);
var t:longint;
begin
    t:=a;
    a:=b;
    b:=t;
end;

Procedure swapP(var a,b:TPoint);
var t:TPoint;
begin
    t:=a;
    a:=b;
    b:=t;
end;

Function more(const a,b:TPoint):boolean;
var t:longint;
begin
    t:=vp(a,b);
    if (a.y<0)and(b.y<0) then more:=false else
    if a.y<0 then more:=true else
    if b.y<0 then more:=false else
    if t<0 then more:=true else more:=false;
end;

Procedure qsort(const l,r:longint);
var i,j:longint;
    x:TPoint;
begin
    i:=l;
    j:=r;
    x:=a[(l+r) div 2];
    repeat
        while more(x,a[i]) do inc(i);
        while more(a[j],x) do dec(j);
        if i<=j then
        begin
            swapP(a[i],a[j]);
            inc(i);
            dec(j);
        end;
    until i>j;
    if i<r then qsort(i,r);
    if j>l then qsort(L,j);
end;

Procedure pre(const q:longint);
var dx,dy,i:longint;
begin
    dx:=a[q].x;
    dy:=a[q].y;
    for i:=1 to n do
    begin
        dec(a[i].x,dx);
        dec(a[i].y,dy);
    end;
    swapP(a[q],a[1]);
    qsort(2,n);
    dn:=n;
    while (a[dn].y<0)and(dn>0) do dec(dn);
end;

Procedure relax(const q,w:longint);
var v1,v2,v3:TPoint;
    i:longint;
begin
    v1:=GetVec(a[q],a[cur[q,w]]);
    for i:=q+1 to dn do
    begin
        v2:=GetVec(a[i],a[q]);
        if vp(v1,v2)>=0 then
        begin
            if not vis[i,w+1] then
            begin
                vis[i,w+1]:=true;
                cur[i,w+1]:=q;
                if w+2>ans then ans:=w+2;
            end else
            if vp(GetVec(a[i],a[cur[i,w+1]]),v2)<0 then
            begin
                cur[i,w+1]:=q;
            end;
        end;
    end;
end;

Procedure calc(const q:longint);
var i,j:longint;
begin
    pre(q);
    if dn<3 then exit;
    fillchar(cur,sizeof(cur),0);
    fillchar(vis,sizeof(vis),0);
    vis[1,0]:=true;
    cur[1,0]:=1;
    for i:=1 to dn do
    for j:=0 to i do if vis[i,j] then relax(i,j);
end;

Procedure solve;
var i:longint;
begin
    aa:=a;
    for i:=1 to n do
    begin
        a:=aa;
        calc(i);
    end;
end;

Procedure print;
begin
    writeln(ans);
end;

begin
    init;
    solve;
    print;
    close(input);
    close(output);
end.