  {$I-,Q-,R-,S-}
const maxn=15;

type TPoly=array[0..maxn] of longint;

var n,m:longint;
    a:array[1..maxn,1..maxn] of longint;
    l:array[1..maxn] of Tpoly;
    res,temp,cur:TPoly;
    used,vis:array[1..maxn] of boolean;

Procedure init;
var i,u,v:longint;
begin
    assign(input,'chrom.in');
    reset(input);
    assign(output,'chrom.out');
    rewrite(output);
    read(n,m);
    for i:=1 to m do
    begin
        read(u,v);
        if u=v then
        begin
            writeln(0,' ',0);
            close(input);
            close(output);
            halt;
        end;
        a[u,v]:=1;
        a[v,u]:=1;
    end;
    if n=1 then
    begin
        writeln(1,' ',0,' ',1);
        close(input);
        close(output);
        halt;
    end;
end;

Procedure mul(const a,b:TPoly; var c:TPoly);
var i,j:longint;
begin
    fillchar(c,sizeof(c),0);
    for i:=1 to a[0] do
    for j:=1 to b[0] do
    begin
        c[i+j-1]:=c[i+j-1]+a[i]*b[j];
    end;
    c[0]:=a[0]+b[0];
    while (c[c[0]]=0)and(c[0]>1) do dec(c[0]);
end;

Function max(const a,b:longint):longint;
begin
    if a>b then max:=a else max:=b;
end;

Procedure sum(const a,b:TPoly; var c:TPoly);
var i,j:longint;
begin
    fillchar(c,sizeof(c),0);
    for i:=1 to max(a[0],b[0]) do c[i]:=a[i]+b[i];
    c[0]:=max(a[0],b[0]);
end;

Function gennext:boolean;
var i,t:longint;
begin
    i:=n;
    gennext:=false;
    while cur[i]>cur[i-1] do
    begin
        cur[i]:=1;
        dec(i);
        if i=0 then exit;
    end;
    inc(cur[i]);
    gennext:=true;
end;

Function ok:boolean;
var i,j:longint;
begin
    ok:=false;
    for i:=1 to n do
    for j:=i+1 to n do if (cur[i]=cur[j])and(a[i,j]=1) then exit;
    ok:=true;
end;

Procedure update;
var i,tt:longint;
    qq:TPoly;
begin
    fillchar(l,sizeof(l),0);
    tt:=0;
    fillchar(qq,sizeof(qq),0);
    qq[0]:=1;
    qq[1]:=1;
    for i:=1 to n do if cur[i]>tt then tt:=cur[i];
    for i:=1 to tt do
    begin
        l[i,0]:=2;
        l[i,1]:=-i+1;
        l[i,2]:=1;
        mul(qq,l[i],temp);
        qq:=temp;
    end;
    sum(res,qq,temp);
    res:=temp;
end;

procedure solve;
var i,j:longint;
begin
    cur[0]:=0;
    for i:=1 to n do cur[i]:=1;
    cur[n]:=0;
    while gennext do
    begin
        if ok then update;
    end;
end;

Procedure print;
var i:longint;
begin
    write(res[0]-1,' ');
    for i:=1 to res[0] do write(res[i],' ');
end;

begin
    init;
    solve;
    print;
    close(input);
    close(output);
end.