#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define INF 1e15L

typedef long double TDist[3];

const TDist TDist_zero={0,0,0},TDist_inf={INF,INF,INF};

int n_verts,n_cells,n_edges,source,target;
TDist*mtrx_cont,**mtrx;

int main(void) {
  #ifndef OFFLINE
  freopen("customs.in","rt",stdin);
  freopen("customs.out","wt",stdout);
  #endif
  int a,b,v,w,u,i_edge; long double dist;
  scanf("%d%d",&n_verts,&n_edges);
  n_cells=n_verts*n_verts;
  mtrx_cont=new TDist[n_cells]; mtrx=new TDist*[n_verts];
  for (v=0,w=0; v<n_verts; v++,w+=n_verts) mtrx[v]=&mtrx_cont[w];
  for (v=0; v<n_verts; v++) for (w=0; w<n_verts; w++)
    memcpy(mtrx[v][w],TDist_inf,sizeof(TDist_inf));
  for (u=0; u<n_verts; u++)
    memcpy(mtrx[u][u],TDist_zero,sizeof(TDist_zero));
  for (i_edge=0; i_edge<n_edges; i_edge++) {
    scanf("%d%d%Lf",&a,&b,&dist); a--; b--;
    for (v=0; v<n_verts; v++) for (w=0; w<n_verts; w++) {
      TDist res;
      memcpy(res,TDist_zero,sizeof(TDist_zero));
      res[2]=dist;
      if (mtrx[v][a][0]>res[2]) {
        res[0]=res[1]; res[1]=res[2]; res[2]=mtrx[v][a][0];
      } else if (mtrx[v][a][0]>res[1]) {
        res[0]=res[1]; res[1]=mtrx[v][a][0];
      } else if (mtrx[v][a][0]>res[0]) res[0]=mtrx[v][a][0];
      if (mtrx[v][a][1]>res[2]) {
        res[0]=res[1]; res[1]=res[2]; res[2]=mtrx[v][a][1];
      } else if (mtrx[v][a][1]>res[1]) {
        res[0]=res[1]; res[1]=mtrx[v][a][1];
      } else if (mtrx[v][a][1]>res[0]) res[0]=mtrx[v][a][1];
      if (mtrx[v][a][2]>res[2]) {
        res[0]=res[1]; res[1]=res[2]; res[2]=mtrx[v][a][2];
      } else if (mtrx[v][a][2]>res[1]) {
        res[0]=res[1]; res[1]=mtrx[v][a][2];
      } else if (mtrx[v][a][2]>res[0]) res[0]=mtrx[v][a][2];
      if (mtrx[b][w][0]>res[2]) {
        res[0]=res[1]; res[1]=res[2]; res[2]=mtrx[b][w][0];
      } else if (mtrx[b][w][0]>res[1]) {
        res[0]=res[1]; res[1]=mtrx[b][w][0];
      } else if (mtrx[b][w][0]>res[0]) res[0]=mtrx[b][w][0];
      if (mtrx[b][w][1]>res[2]) {
        res[0]=res[1]; res[1]=res[2]; res[2]=mtrx[b][w][1];
      } else if (mtrx[b][w][1]>res[1]) {
        res[0]=res[1]; res[1]=mtrx[b][w][1];
      } else if (mtrx[b][w][1]>res[0]) res[0]=mtrx[b][w][1];
      if (mtrx[b][w][2]>res[2]) {
        res[0]=res[1]; res[1]=res[2]; res[2]=mtrx[b][w][2];
      } else if (mtrx[b][w][2]>res[1]) {
        res[0]=res[1]; res[1]=mtrx[b][w][2];
      } else if (mtrx[b][w][2]>res[0]) res[0]=mtrx[b][w][2];
      if (mtrx[v][w][0]+mtrx[v][w][1]+mtrx[v][w][2]>res[0]+res[1]+res[2])
      memcpy(mtrx[v][w],res,sizeof(TDist));
    }
  } scanf("%d%d",&source,&target); source--; target--;
  printf("%.0Lf\n",
  mtrx[source][target][0]+mtrx[source][target][1]+mtrx[source][target][2]);
  delete[]mtrx_cont; delete[]mtrx;
  #ifndef OFFLINE
  fclose(stdin);
  fclose(stdout);
  #endif
  return(0);
}


