#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

struct TInfo {
  long double val;
  int prev;
};
struct TPrecalc {
  long double val;
  char calced;
};

int num,*parts;
long double*coeffs,val_inf;
TInfo func_inf,*funcs_cont_0,**funcs_cont_1,***funcs,best,*bests;
TPrecalc*sins_cont,**sins;

int main(void) {
  #ifndef OFFLINE
  freopen("sin.in","rt",stdin);
  freopen("sin.out","wt",stdout);
  #endif
  int cnt,cur,last,diff,mult;
  TInfo func; long double&val=func.val; int&prev=func.prev;
  scanf("%d",&num);
  coeffs=new long double[num+1];
  *coeffs=0;
  for (cnt=1; cnt<=num; cnt++) {
    scanf("%Lf",&coeffs[cnt]);
    coeffs[cnt]*=(long double)(cnt+1);
  }
  sins_cont=new TPrecalc[(num+1)*(num+1)*(num+1)];
  sins=new TPrecalc*[num+1];
  funcs_cont_0=new TInfo[(num+1)*(num+1)*(num+1)];
  funcs_cont_1=new TInfo*[(num+1)*(num+1)];
  funcs=new TInfo**[num+1];
  for (cnt=0,last=0; cnt<=num; cnt++,last+=(num+1)*(num+1))
    sins[cnt]=&sins_cont[last];
  for (cur=0,last=0; cur<(num+1)*(num+1); cur++,last+=num+1)
    funcs_cont_1[cur]=&funcs_cont_0[last];
  for (cnt=0,cur=0; cnt<=num; cnt++,cur+=num+1)
    funcs[cnt]=&funcs_cont_1[cur];
  bests=new TInfo[num+1];
  memset(sins_cont,0,sizeof(TPrecalc)*(num+1)*(num+1)*(num+1));
  func_inf.val=-(long double)(num+2); func_inf.prev=0;
  val_inf=-(long double)(num+1);
  for (cur=0; cur<=num; cur++) for (last=0; last<=cur; last++)
    funcs[0][cur][last]=func_inf;
  funcs[0][0][0].val=0; funcs[0][0][0].prev=0; *bests=func_inf;
  for (cnt=1; cnt<=num; cnt++) {
    for (cur=0; cur<=num; cur++) funcs[cnt][cur][0]=func_inf;
    for (cur=1; cur<=num; cur++) for (last=1; last<=cur; last++) {
      diff=cur-last;
          funcs[cnt][cur][last].val=funcs[cnt-1][diff][0].val;
          funcs[cnt][cur][last].prev=0;
      for (prev=1; prev<=diff; prev++) {
        val=funcs[cnt-1][diff][prev].val;
        if (val<val_inf) continue;
        TPrecalc&precalc=sins[cnt][mult=last*prev];
        if (!precalc.calced) {
          precalc.calced=1;
          precalc.val=sin(coeffs[cnt-1]*(long double)mult);
        } val+=precalc.val;
        if (funcs[cnt][cur][last].val<val) funcs[cnt][cur][last]=func;
      }
    }
    bests[cnt]=func_inf;
    for (prev=1; prev<=num; prev++) {
      val=funcs[cnt][num][prev].val/(long double)cnt;
      if (bests[cnt].val<val) bests[cnt]=func;
    }
  }
  best=*bests;
  for (cnt=1; cnt<=num; cnt++) if (best.val<bests[cnt].val) {
    best.val=bests[cnt].val;
    best.prev=cnt;
  }
  parts=new int[best.prev];
  cnt=best.prev; cur=num; last=bests[cnt].prev;
  while (cnt>0) {
    parts[cnt-1]=last;
    last=funcs[cnt][cur][last].prev;
    cur-=parts[--cnt];
  }
  printf("%.12Lf\n",best.val);
  for (cnt=0; cnt<best.prev; cnt++) {
    if (cnt) printf(" ");
    printf("%d",parts[cnt]);
  } printf("\n");
  delete[]parts;
  delete[]funcs_cont_0; delete[]funcs_cont_1; delete[]funcs;
  delete[]sins_cont; delete[]sins;
  delete[]coeffs;
  #ifndef OFFLINE
  fclose(stdin);
  fclose(stdout);
  #endif
  return(0);
}


