#include <stdio.h>
#include <stdlib.h>
#include <string.h>

int n_floors,n_floors_act;
long cap,n_inters,*cnts_fwd,*cnts_bwd,*cnts,cnt_total;

int main(void) {
  #ifndef OFFLINE
  freopen("elevator.in","rt",stdin);
  freopen("elevator.out","wt",stdout);
  #endif
  long i_inter;
  scanf("%d%ld%ld",&n_floors,&cap,&n_inters);
  cnts_fwd=new long[n_floors]; cnts_bwd=new long[n_floors];
  memset(cnts_fwd,0,sizeof(long)*n_floors);
  memset(cnts_bwd,0,sizeof(long)*n_floors);
  n_floors_act=0;
  for (i_inter=0; i_inter<n_inters; i_inter++) {
    int i_floor_a,i_floor_b;
    scanf("%d%d",&i_floor_a,&i_floor_b); i_floor_a--; i_floor_b--;
    if (i_floor_a<i_floor_b) {
      if (n_floors_act<i_floor_b) n_floors_act=i_floor_b;
      cnts_fwd[i_floor_a]++; cnts_fwd[i_floor_b]--;
    }
    if (i_floor_a>i_floor_b) {
      if (n_floors_act<i_floor_a) n_floors_act=i_floor_a;
      cnts_bwd[i_floor_a-1]++; if (i_floor_b>0) cnts_bwd[i_floor_b-1]--;
    }
  }
  int i_floor;
  cnt_total=0;
  for (i_floor=0; i_floor<n_floors_act; i_floor++)
    cnts_fwd[i_floor]=cnt_total+=cnts_fwd[i_floor];
  cnt_total=0;
  for (i_floor=n_floors_act-1; i_floor>=0; i_floor--)
    cnts_bwd[i_floor]=cnt_total+=cnts_bwd[i_floor];
  cnts=new long[n_floors_act];
  for (i_floor=0; i_floor<n_floors_act; i_floor++) {
    cnts[i_floor]=1;
    if (cnts[i_floor]<cnts_fwd[i_floor]) cnts[i_floor]=cnts_fwd[i_floor];
    if (cnts[i_floor]<cnts_bwd[i_floor]) cnts[i_floor]=cnts_bwd[i_floor];
  }
  cnt_total=0;
  for (i_floor=0; i_floor<n_floors_act; i_floor++)
    cnt_total+=(cnts[i_floor]+cap-1)/cap;
  printf("%ld\n",cnt_total*10L);
  delete[]cnts;
  delete[]cnts_fwd; delete[]cnts_bwd;
  #ifndef OFFLINE
  fclose(stdin);
  fclose(stdout);
  #endif
  return(0);
}


