{$I-,Q-,R-,S-}
{$M 10048576,0}
const taskid='indirect';
      inf=taskid+'.in';
      ouf=taskid+'.out';
var acc:longint;
    mem,p,ptr,rank:array [1..32768] of longint;
    bad:array [1..32768] of boolean;
function getp(x:longint):longint;
begin
  if p[x]<>x then
    getp:=getp(p[x]);
  getp:=p[x];
end;
procedure link(x,y,pp:longint);
var t:longint;
begin
  if rank[x]=rank[y] then
    inc(rank[x]);
  if rank[x]<rank[y] then
  begin
    t:=x;
    x:=y;
    y:=t;
  end;
  ptr[x]:=pp;
  p[y]:=x;
end;
procedure union(x,y,p:longint);
begin
  link(getp(x),getp(y),p);
end;
function getptr(x:longint):longint;
begin
  getptr:=ptr[getp(x)];
end;
function _mem(x:longint):longint;
var i:longint;
begin
  if bad[getp(x)] then
  begin
    assign(output,ouf);
    rewrite(output);
    writeln('RUN-TIME ERROR');
    writeln(acc);
    for i:=1 to 32768 do
      writeln(mem[i]);
    close(output);
    halt;
  end;
  _mem:=mem[getptr(x)];
end;
procedure update(x,y:longint);
begin
  _mem(getptr(x));
  mem[getptr(x)]:=y;
  if y<0 then
    if getptr(x)=getptr(-y) then
      bad[getp(x)]:=true
    else
      union(x,-y,getptr(-y));
end;
procedure norm(var x:longint);
begin
  x:=x mod 65536;
  while x<-32768 do
    inc(x,65536);
  while x>32767 do
    dec(x,65536);
end;
procedure init;
var i,num:longint;
    ch1,ch2:char;
    cmd:string;
begin
  acc:=0;
  fillchar(mem,sizeof(mem),0);
  fillchar(rank,sizeof(rank),0);
  fillchar(bad,sizeof(bad),false);
  for i:=1 to 32768 do
  begin
    p[i]:=i;
    ptr[i]:=i;
  end;
  assign(input,inf);
  reset(input);
  while not eof do
  begin
    readln(ch1,ch2,num);
    cmd:=ch1+ch2;
    if cmd='A*' then
    begin
      inc(acc,_mem(num));
      norm(acc);
    end
    else if cmd='S*' then
    begin
      dec(acc,_mem(num));
      norm(acc);
    end
    else if cmd='M*' then
    begin
      acc:=acc*_mem(num);
      norm(acc);
    end
    else if cmd='D*' then
    begin
      if _mem(num)=0 then
      begin
        assign(output,ouf);
        rewrite(output);
        writeln('DIVISION BY ZERO');
        writeln(acc);
        for i:=1 to 32768 do
          writeln(mem[i]);
        close(output);
        halt;
      end;
      acc:=acc div _mem(num);
      norm(acc);
    end
    else if cmd='O*' then
    begin
      if _mem(num)=0 then
      begin
        assign(output,ouf);
        rewrite(output);
        writeln('DIVISION BY ZERO');
        writeln(acc);
        for i:=1 to 32768 do
          writeln(mem[i]);
        close(output);
        halt;
      end;
      acc:=acc mod _mem(num);
      norm(acc);
    end
    else if cmd='R*' then
    begin
      acc:=_mem(num);
    end
    else if cmd='W*' then
    begin
      update(num,acc);
    end
    else if cmd='A=' then
    begin
      inc(acc,num);
      norm(acc);
    end
    else if cmd='S=' then
    begin
      dec(acc,num);
      norm(acc);
    end
    else if cmd='M=' then
    begin
      acc:=acc*num;
      norm(acc);
    end
    else if cmd='D=' then
    begin
      if num=0 then
      begin
        assign(output,ouf);
        rewrite(output);
        writeln('DIVISION BY ZERO');
        writeln(acc);
        for i:=1 to 32768 do
          writeln(mem[i]);
        close(output);
        halt;
      end;
      acc:=acc div num;
      norm(acc);
    end
    else if cmd='O=' then
    begin
      if num=0 then
      begin
        assign(output,ouf);
        rewrite(output);
        writeln('DIVISION BY ZERO');
        writeln(acc);
        for i:=1 to 32768 do
          writeln(mem[i]);
        close(output);
        halt;
      end;
      acc:=acc mod num;
      norm(acc);
    end
    else if cmd='R=' then
    begin
      acc:=num;
      norm(acc);
    end
  end;
  close(input);
end;
procedure run;
begin
end;
procedure done;
var i:longint;
begin
  assign(output,ouf);
  rewrite(output);
  writeln('SUCCESSFUL TERMINATION');
  writeln(acc);
  for i:=1 to 32768 do
    writeln(mem[i]);
  close(output);
end;
begin
  init;
  run;
  done;
end.
