{$I-,Q-,R-,S-}
{$M 1048576,0}
const taskid='pipe';
      inf=taskid+'.in';
      ouf=taskid+'.out';
      infinity=1e100;
      eps=1e-8;
var n:longint;
    x,y:array [0..2000] of double;
    max:double;
procedure init;
var i:longint;
begin
  assign(input,inf);
  reset(input);
  read(n);
  for i:=1 to n do
    read(x[i],y[i]);
  close(input);
end;
function cross(x1,y1,x2,y2,x3,y3,x4,y4:double;var xc,yc:double):boolean;
var a,b,c,d,e,f,dx,dy,dd,t,s:double;
begin
  a:=x2-x1;
  b:=x3-x4;
  c:=x3-x1;
  d:=y2-y1;
  e:=y3-y4;
  f:=y3-y1;
  dx:=c*e-b*f;
  dy:=a*f-c*d;
  dd:=a*e-b*d;
  cross:=false;
  if abs(dd)<eps then
    exit;
  t:=dx/dd;
  s:=dy/dd;
  if (s<eps) or (s>1-eps) then
    exit;
  cross:=true;
  xc:=x1+(x2-x1)*t;
  yc:=y1+(y2-y1)*t;
end;
function crver(x1,y1,x2,y2,x0:double):double;
begin
  crver:=y1+(x0-x1)/(x2-x1)*(y2-y1);
end;
function vec(x1,y1,x2,y2:double):double;
begin
  vec:=x1*y2-x2*y1;
end;
function belong(x1,y1,x2,y2,x,y:double):boolean;
begin
  belong:=abs(vec(x-x1,y-y1,x2-x1,y2-y1))<eps;
end;
function sign(x1,y1,x2,y2,x0,y0:double):longint;
var v:double;
begin
  v:=vec(x0-x1,y0-y1,x2-x1,y2-y1);
  if abs(v)<eps then
    v:=0
  else if v<0 then
    sign:=-1
  else sign:=1;
end;
procedure tryray(x1,y1,x2,y2:double);
var ok:boolean;
    i:longint;
    xc,xp,yp,yc:double;
label 1,2;
begin
  if (crver(x1,y1,x2,y2,x[1])<y[1]-1-eps) or (crver(x1,y1,x2,y2,x[1])>y[1]+eps) then
    exit;
  xp:=1e100;
  ok:=true;
    for i:=1 to n-1 do
      if cross(x1,y1,x2,y2,x[i],y[i],x[i+1],y[i+1],xc,yc) then
      begin
        if xc<xp then
        begin
          xp:=xc;
          yp:=yc;
        end;
        ok:=false;
      end;
  if belong(x1,y1,x2,y2,x[1],y[1]) then
  begin
    if belong(x1,y1,x2,y2,x[2],y[2]) then
      goto 2;
    if sign(x1,y1,x2,y2,x[2],y[2])=1 then
    begin
      if x[i]<xp then
      begin
        xp:=x[i];
        yp:=y[i];
      end;
      ok:=false;
    end;
  end;
  2:
    for i:=2 to n-1 do
      if belong(x1,y1,x2,y2,x[i],y[i]) then
      begin
        if belong(x1,y1,x2,y2,x[i-1],y[i-1]) and belong(x1,y1,x2,y2,x[i+1],y[i+1]) then
          continue;
        if (sign(x1,y1,x2,y2,x[i-1],y[i-1])=1) or (sign(x1,y1,x2,y2,x[i+1],y[i+1])=1) then
        begin
          if x[i]<xp then
          begin
            xp:=x[i];
            yp:=y[i];
          end;
          ok:=false;
        end;
      end;
    for i:=1 to n-1 do
      if cross(x1,y1,x2,y2,x[i],y[i]-1,x[i+1],y[i+1]-1,xc,yc) then
      begin
        if xc<xp then
        begin
          xp:=xc;
          yp:=yc;
        end;
        ok:=false;
      end;
  if belong(x1,y1,x2,y2,x[1],y[1]-1) then
  begin
    if belong(x1,y1,x2,y2,x[2],y[2]-1) then
      goto 1;
    if sign(x1,y1,x2,y2,x[2],y[2]-1)=-1 then
    begin
      if x[i]<xp then
      begin
        xp:=x[i];
        yp:=y[i];
      end;
      ok:=false;
    end;
  end;
  1:
    for i:=2 to n-1 do
      if belong(x1,y1,x2,y2,x[i],y[i]-1) then
      begin
        if belong(x1,y1,x2,y2,x[i-1],y[i-1]-1) and belong(x1,y1,x2,y2,x[i+1],y[i+1]-1) then
          continue;
        if (sign(x1,y1,x2,y2,x[i-1],y[i-1]-1)=-1) or (sign(x1,y1,x2,y2,x[i+1],y[i+1]-1)=-1) then
        begin
          if x[i]<xp then
          begin
            xp:=x[i];
            yp:=y[i];
          end;
          ok:=false;
        end;
      end;
  if ok then
  begin
    assign(output,ouf);
    rewrite(output);
    writeln('DELO TRUBA');
    close(output);
    halt;
  end;
  for i:=1 to n-1 do
    if ((x1+xp)/2>=x[i]) and ((xp+x1)/2<=x[i+1]) then
      ok:=((y1+yp)/2<=crver(x[i],y[i],x[i+1],y[i+1],(x1+xp)/2)) and ((y1+yp)/2>=crver(x[i],y[i]-1,x[i+1],y[i+1]-1,(x1+xp)/2));
  if not ok then
    exit;
  if xp>max then
    max:=xp;
end;
procedure run;
var i:longint;
begin
  max:=-1e100;
  for i:=2 to n do
  begin
    tryray(x[1],y[1],x[i],y[i]);
    tryray(x[1],y[1],x[i],y[i]-1);
    tryray(x[1],y[1]-1,x[i],y[i]);
    tryray(x[1],y[1]-1,x[i],y[i]-1);
  end;
  for i:=1 to n-1 do
  begin
    tryray(x[i],y[i],x[i+1],y[i+1]);
    tryray(x[i],y[i]-1,x[i+1],y[i+1]-1);
  end;
end;
procedure done;
begin
  assign(output,ouf);
  rewrite(output);
  writeln(max:0:2);
  close(output);
end;
begin
  init;
  run;
  done;
end.
