{$I-,Q-,R-,S-}
uses math;
const taskid='prof';
      inf=taskid+'.in';
      ouf=taskid+'.out';
type ptree=^ttree;
     ttree=record
       ch:array ['a'..'{'] of ptree;
       l,r,p,q,w:word;
     end;
var n,ans:longint;
    a:array [1..3001] of char;
    root:ptree;
procedure init;
var ch:char;
begin
  assign(input,inf);
  reset(input);
  read(ch);
  n:=0;
  while ch in ['a'..'z'] do
  begin
    inc(n);
    a[n]:=ch;
    read(ch);
  end;
  close(input);
end;
procedure create(var x:ptree);
var ch:char;
begin
  new(x);
  for ch:='a' to '{' do
    x^.ch[ch]:=nil;
  x^.l:=1;
  x^.r:=0;
  x^.p:=0;
  x^.q:=0;
  x^.w:=0;
end;
function split(x,c:ptree;cc:char;p:longint):ptree;
var tmp:ptree;
begin
  create(tmp);
  x^.ch[cc]:=tmp;
  tmp^.ch[a[p]]:=c;
  tmp^.l:=c^.l;
  tmp^.r:=p-1;
  c^.l:=p;
  split:=tmp;
end;
procedure add(x:ptree;f,l,r:longint);
var tmp:ptree;
    cur,curx:longint;
begin
  if x^.ch[a[l]]=nil then
  begin
    create(tmp);
    x^.ch[a[l]]:=tmp;
    tmp^.l:=l;
    tmp^.r:=r;
    tmp^.p:=f;
    exit;
  end;
  cur:=l;
  curx:=x^.ch[a[l]]^.l;
  while (cur<=r) and (curx<=x^.ch[a[l]]^.r) do
  begin
    if a[cur]=a[curx] then
    begin
      inc(cur);
      inc(curx);
    end
    else break;
  end;
  if cur>r then
    exit;
  if curx>x^.ch[a[l]]^.r then
  begin
    add(x^.ch[a[l]],f,cur,r);
    exit;
  end;
  tmp:=split(x,x^.ch[a[l]],a[l],curx);
  add(tmp,f,cur,r);
end;
procedure process(x:ptree);
var ch:char;
begin
  if x^.p<>0 then
  begin
    x^.q:=x^.p;
    x^.w:=x^.p;
    exit;
  end;
  x^.q:=65535;
  x^.w:=0;
  for ch:='a' to '{' do
    if x^.ch[ch]<>nil then
    begin
      process(x^.ch[ch]);
      if x^.ch[ch]^.q<x^.q then
        x^.q:=x^.ch[ch]^.q;
      if x^.ch[ch]^.w>x^.w then
        x^.w:=x^.ch[ch]^.w;
    end;
end;
procedure debug(x:ptree;s:string);
var ch:char;
begin
  if x=nil then
    exit;
  writeln(s,x^.l,'-',x^.r);
  for ch:='a' to '{' do
    debug(x^.ch[ch],s+' ');
end;
function calc(x:ptree;l:word):longint;
var res:longint;
    ch:char;
begin
  calc:=0;
  if x=nil then
    exit;
  if x^.p<>0 then
    exit;
  if l>=x^.w-x^.q then
    exit;
  res:=min(x^.w-x^.q-l,x^.r-x^.l+1);
  for ch:='a' to '{' do
    inc(res,calc(x^.ch[ch],l+x^.r-x^.l+1));
  calc:=res;
end;
procedure run;
var i:longint;
begin
  inc(n);
  a[n]:='{';
  create(root);
  for i:=1 to n do
    add(root,i,i,n);
  process(root);
{  debug(root,'');}
  ans:=calc(root,0);
end;
procedure done;
begin
  assign(output,ouf);
  rewrite(output);
  writeln(ans);
  close(output);
end;
begin
  init;
  run;
  done;
end.
