program ooo;
const
  filename  = 'rescue';
  InFile = FileName+'.in';
  OutFile = FileName+'.out';

type
  TXY = record
             x, y : integer;
             r : real;
           end;

var
  i, m, n, j, k, l  : longint;
  x : real;
  rib, baz : array[1..50000] of TXY;
  nn : array[1..50000] of longint;
  w : TXY;

procedure OpenFile;
begin
  assign(input, InFile);
  reset(input);
  readln(n, m);
  for i:=1 to n do
    begin
    readln(baz[i].x, baz[i].y);
    baz[i].r:=sqrt(sqr(baz[i].x)+ sqr(baz[i].y));
    end;
  for i:=1 to m do
    begin
    readln(rib[i].x, rib[i].y);
    rib[i].r:=sqrt(sqr(rib[i].x)+ sqr(rib[i].y));
    end;
  close(input);
end;

procedure QSort(const l, r : longint);
var
  i, j : longint;
begin
  i:= l;
  j:= r;
  x:= baz[(l+r) div 2].r;
  repeat
    while baz[i].r< x do inc(i);
    while baz[j].r> x do dec(j);
    if i<=j then
      begin
      w:= baz[i];
      baz[i]:= baz[j];
      baz[j]:= w;
      inc(i);
      dec(j);
      end;
  until i>=j;
  if i<r then QSort(i, r);
  if l<j then QSort(l, j);
end;


procedure Solve;
var
  min : longint;
  rmin, r : real;
begin
  QSort(1, n);
  for i:=1 to m do
    begin
    rmin:= sqrt(sqr(rib[i].x- baz[1].x)+ sqr(rib[i].y- baz[1].y));
    min:= 1;
    j:= 2;
    while (j <= n) and (rmin > abs(rib[i].r-baz[j].r)) do
      begin
      r:= sqrt(sqr(rib[i].x- baz[j].x)+ sqr(rib[i].y- baz[j].y));
      if r< rmin then
        begin
        rmin:= r;
        min:= j;
        end;
      inc(j);
      end;
    nn[i]:= min;
    if i = 10000 then
      break;
    end;
end;

procedure SaveFile;
begin
  assign(output, OutFile);
  rewrite(Output);
  for i:=1 to m do
    writeln(baz[nn[i]].x, ' ', baz[nn[i]].y);
  close(output);
end;

begin
  OpenFile;
  Solve;
  SaveFile;
end.
