type
  TPoint=record
    X,Y: Word;
    end;
var
  f: Text;
  B,R: array[1..50000] of TPoint;
  M,N: Word;
  P: array[1..50000] of Word;
  MinDest: Extended;

procedure ReadData;
var
  i: Word;
begin
  Assign(f,'rescue.in');
  Reset(f);
  Readln(f,N,M);
  for i:=1 to N do
    Readln(f,B[i].X,B[i].Y);
  Readln(f);
  for i:=1 to M do
    Readln(f,R[i].X,R[i].Y);
  Close(f);
end;

function Dest(const P1,P2: TPoint): Extended;
begin
  Dest := Sqrt(Sqr(P1.X-P2.X) + Sqr(P1.Y-P2.Y));
end;
procedure Solve;
var
  i,j: Word;
begin
  for i:=1 to M do
  begin
    P[i]:=1;
    MinDest:=Dest(R[i],B[1]);
    for j:=2 to N do
      if Dest(R[i],B[j])<MinDest then
      begin
        P[i]:=j;
        MinDest:=Dest(R[i],B[j]);
      end;
  end;
end;

procedure WriteData;
var
  i: Word;
begin
  Assign(f,'rescue.out');
  Rewrite(f);
  for i:=1 to M do
    Writeln(f,B[P[i]].X,' ',B[P[i]].Y);
  Close(f);
end;

begin
  ReadData;
  Solve;
  WriteData;
end.