var
  f: Text;
  N: Word;
  C,K,T: LongInt;
  A: array[1..100000,1..2] of Word;
  Up, Down: array[1..99999] of Word;

procedure ReadData;
var
  i: LongInt;
begin
  Assign(f,'elevator.in');
  Reset(f);
  Readln(f,N,C,K);
  for i:=1 to K do
    Readln(f,A[i,1],A[i,2]);
  Close(f);
end;

procedure Change(Var a,b: Word);
begin
  a:=a+b;
  b:=a-b;
  a:=a-b;
end;

{procedure Sort;
var
  i,j: LongInt;
begin
  for i:=K downto 2 do
    for j:=1 to i do
      if ((A[j,1]*1001)+A[j,2]) > ((A[j+1,1]*1001)+A[j+1,2]) then
      begin
        Change(A[j,1],A[j+1,1]);
        Change(A[j,2],A[j+1,2]);
      end;
end;}

function max(a,b: Word): Word;
begin
  if a>b then max := a
  else max := b;
end;

procedure Solve;
var
  i,j: LongInt;
  x,y: Word;
begin
{  Sort;}
  for i:=1 to 99999 do
  begin
    Up[i]:=0;
    Down[i]:=0;
  end;

  for i:=1 to K do
  begin
    x:=A[i,1];
    y:=A[i,2];
    if x<y then
      for j:=x to y-1 do
        Up[j] := Up[j]+1
    else
      for j:=y to x-1 do
        Down[j] := Down[j]+1;
  end;

  for i:=1 to 99999 do
  begin
    j := Up[i] div C;
    if (Up[i] mod C) <> 0 then Inc(j);
    Up[i] := j;
    j := Down[i] div C;
    if (Down[i] mod C) <> 0 then Inc(j);
    Down[i] := j;
    T := T+max(Up[i],Down[i]);
  end;
  T:=T*10;
end;

procedure WriteData;
begin
  Assign(f,'elevator.out');
  Rewrite(f);
  Write(f,T);
  Close(f);
end;

begin
  ReadData;
  Solve;
  WriteData;
end.