type
  T2=array [0..1] of byte;
  PSim=^TSim;
  TSim=record
     a:byte;
     next:PSim;
  end;
var
  Dump:array [0..65535] of byte;
  were:array [0..65535] of boolean;
  A0,A1:T2;
  Que:array [0..2,0..80000] of record
                                 data:T2;
                                 str:PSim;
                               end;
  Head,TaiL:array [0..2] of longint;
  Tek:integer;
  LLong,Long:longint;
procedure Extract(i:byte;var data:T2;var str:PSim);
begin
  data:=Que[i,Head[i]].data;
  str:=Que[i,Head[i]].str;
  Head[i]:=(Head[I]+1) mod 80000;
end;
function PEmpty:boolean;forward;
function PPEmpty:boolean;forward;
function Sr(pp,p:byte):boolean;
var
  UPP,UP:PSim;
  b:boolean;
begin
  if PPEmpty  then
    begin
      Sr:=false;
      exit;
    end;
  if PEmpty then
    begin
      Sr:=true;
      exit;
    end;
  Upp:=Que[pp,Head[pp]].str;
  Up:=Que[p,Head[p]].str^.next;
  b:=true;
  while Up<>nil do
    begin
      b:=Upp^.a<=Up^.a;
      Upp:=Upp^.next;
      Up:=Up^.next;
    end;
end;
function PEmpty:boolean;
var
  i:integer;
begin
  i:=(tek-1+3)mod 3;
  PEmpty:=head[i]=tail[i];
end;
function PPEmpty:boolean;
var
  i:integer;
begin
  i:=(tek-2+3)mod 3;
  PPEmpty:=head[i]=tail[i];
end;
procedure Out_16(i,j:byte);
begin
  if i=1 then write('5C')
  else
    if (i<>j) or (Long=LLOng) then write('0F')
    else write('CC');
end;
procedure Print(Str:PSim);
var
  Ans:array [1..150000] of byte;
  j:Longint;
begin
  Long:=0;
  while str<>nil do
    begin
      inc(Long);
      Ans[Long]:=str^.a;
      str:=str^.next;
    end;
  LLong:=Long;
  j:=0;
  assign(output,'2instr.out');
  rewrite(output);
  writeln(Long);
  while Long<>0 do
  begin
    if j mod 16<>0 then write(' ');
    if j mod 16=8 then write(' ');
    Out_16(Ans[Long],Ans[Long+1]);
    inc(j);
    if j mod 16=0 then writeln;
    dec(Long);
  end;
  close(output);
  halt;
end;
function Compare (a1,a2:T2):boolean;
begin
  if (a1[1]=a2[1]) and (a1[0]=a2[0]) then Compare:=true
  else Compare:=False;
end;
procedure Push(X:T2;Str:PSIm);
var
  l:longint;
begin
  if Compare(X,A1) then Print(str);
  l:=X[1];
  l:=l*256+X[0];
  were[L]:=true;
  Que[Tek,Tail[Tek]].data:=X;
  Que[Tek,Tail[Tek]].str:=str;
  Tail[Tek]:=(Tail[Tek]+1) mod 80000;
end;
procedure Val2(s:string;var i:byte);
var
  j:byte;
begin
  if (s[1]<='9') and (s[1]>='0') then
    i:=ord(s[1])-ord('0')
  else i:=ord(s[1])-ord('A')+10;
  if (s[2]<='9') and (s[2]>='0') then
    j:=ord(s[2])-ord('0')
  else j:=ord(s[2])-ord('A')+10;
  i:=i*16+j;
end;
var
  s:string;
  i,j,q,e,w,pr,pp,l:longint;
  P,P2:PSim;
  b1:byte;
  bln1:boolean;
begin
  assign(input,'2instr.in');
  reset(input);
  readln(s);
  Val2(s[1]+s[2],A0[1]);
  Val2(s[3]+s[4],A0[0]);
  Val2(s[6]+s[7],A1[1]);
  Val2(s[8]+s[9],A1[0]);
  j:=-1;
  For i:=1 to 4096 do
    begin
      readln(s);
      For q:=1 to 8 do
        begin
          inc(j);
          Val2(s[q*3-2]+s[q*3-1],Dump[j]);
        end;
      For q:=1 to 8 do
        begin
           inc(j);
           Val2(s[q*3-2+25]+s[q*3-1+25],Dump[j])
        end;
    end;
  close(input);
  teK:=0;
  Push(A0,nil);
  inc(Tek);
  New(P);
  p^.a:=1;
  i:=A0[1];
  i:=i*256+A0[0];
  A0[0]:=Dump[i];
  i:=(i+1) mod 65536;
  A0[1]:=Dump[i];
  Push(A0,p);
  inc(Tek);
  repeat
  pr:=(tek-1+3) mod 3;
  pp:=(tek-2+3) mod 3;
  e:=head[pr];
  while (Not PEmpty) or (Not PPEmpty ) do
    begin
      if Sr(pp,pr) then
        begin
          Extract(pp,A0,p);
          New(P2);
          P2^.a:=0;
          P2^.next:=P;
          P:=p2;
          New(P2);
          P2^.a:=0;
          P2^.next:=P;
          b1:=A0[0];
          A0[0]:=A0[1];
          A0[1]:=b1;
          l:=A0[1];
          l:=l*256+A0[0];
          if not were[l] then
            begin
              Push(A0,p2);
              were[l]:=true;
            end;
        end
      else
        begin
          Extract(pr,A0,p);
          New(P2);
          P2^.a:=1;
          p2^.next:=P;
          i:=A0[1];
          i:=i*256+A0[0];
          A0[0]:=Dump[i];
          i:=(i+1) mod 65536;
          A0[1]:=Dump[i];
          l:=A0[1];
          l:=l*256+A0[0];
          if not were[l] then
            begin
              Push(A0,p2);
              were[l]:=true;
            end;
        end;

    end;
    head[pr]:=e;
    tek:=(tek+1) mod 3;
  until (PEmpty) and ( PPEmpty);
  assign(output,'2instr.out');
  rewrite(output);
  writeln('IMPOSSIBLE');
  close(output);
end.