#include <stdio.h>
#include <string.h>

#define DBG 0

#define MAX (1 << 21)

int A[MAX << 1];

void Add( int st, int a )
{
  if (st == 0)
    return;
  A[st + a]++;
  Add(st >> 1, a >> 1);
}

int Num( int st, int a, int b )
{
  int sum = 0;

  if (a > b || st == 0)
    return 0;
  if (a & 1)
    sum += A[st + a], a++;
  if ((b & 1) == 0)
    sum += A[st + b], b--;
  sum += Num(st >> 1, a >> 1, b >> 1);
  return sum;
}

int main( void )
{
  char s[99];
  int a, b;

  memset(A, 0, sizeof(A));
  freopen("kitten.in", "rt", stdin);
  freopen("kitten.out", "wt", stdout);
  while (gets(s) != NULL)
  {
#   if DBG
    printf("--> %s\n", s);
#   endif
    b = 0;
    while (s[b] == 32 || s[b] == 8 || s[b] == 9)
      b++;
    sscanf(s + b, "%d", &a);
    a += MAX >> 1;
    while (s[b] == '-' || s[b] == '+' || ('0' <= s[b] && s[b] <= '9'))
      b++;
    if (s[b] == 0)
    {
      if (A[MAX + a] == 0)
        Add(MAX, a);
    }
    else
    {
      sscanf(s + b, "%d", &b);
      b += MAX >> 1;
      printf("%d\n", Num(MAX, a, b));
    }
  }
  return 0;
}
