#include <stdio.h>
#include <string.h>
#include <math.h>
#include <time.h>

#define DBG 0

#define MAX_N 103

int N, B[MAX_N];

/***
 * The first - number of numbers
 * The second - total sum
 * Last - last number
 */
double A[MAX_N][MAX_N][MAX_N], *AIJ1;
int Is[MAX_N][MAX_N][MAX_N], *IsIJ1;
int La[MAX_N][MAX_N][MAX_N], (*LaI1)[MAX_N];
int P[MAX_N], PN = 0;

int main( void )
{
  FILE *InF, *OutF;
  int i, sum, last, num, maxi = 0, maxl = 0, B0;
  double d, d0, maxf = -9;
# if DBG 
  int t = clock();
# endif

  memset(A, 0, sizeof(A));
  memset(Is, 0, sizeof(Is));
  InF = fopen("sin.in", "rt");
  OutF = fopen("sin.out", "wt");
  fscanf(InF, "%d", &N);
  for (i = 0; i < N; i++)
    fscanf(InF, "%d", &B[i]), B[i] *= i + 2;
  for (i = 1; i < N; i++)
    Is[1][i][i] = 1, La[1][i][i] = i;
  for (i = 1; i < N; i++)
    for (sum = 1; sum < N; sum++)
      for (last = 1; last < N; last++)
        if (Is[i][sum][last])
        {
          d0 = A[i][sum][last];
          B0 = B[i - 1] * last;
          IsIJ1 = Is[i + 1][sum];
          AIJ1 = A[i + 1][sum];
          LaI1 = La[i + 1];
          for (num = 1; num + sum <= N; num++)
          {
            IsIJ1 += MAX_N + 1; 
            AIJ1 += MAX_N + 1; 
            d = d0 + sin(B0 * num);
            if (!*IsIJ1 || *AIJ1 < d)
              *IsIJ1 = 1, *AIJ1 = d, LaI1[sum + num][num] = last;
          }
        }
  for (i = 2; i < N; i++)
    for (last = 1; last < N; last++)
      if (A[i][N][last] / i > maxf)
        maxf = A[i][N][last] / i, maxi = i, maxl = last;
  fprintf(OutF, "%.8lf\n", maxf);
  while (maxi > 0)
  {
    P[PN++] = maxl;
    i = La[maxi][N][maxl];
    N -= maxl, maxl = i;
    maxi--;
  }
  for (i = PN - 1; i >= 0; i--)
    fprintf(OutF, "%d ", P[i]);
# if DBG 
  printf("Time=%d\n", clock() - t);
# endif
  return 0;
}
