#include <stdio.h>

#define SWAP(A, B, C) ((C) = (A), (A) = (B), (B) = (C))

#define MAX_N 10000
#define SIZE 100
#define SIZE1 (SIZE + 1)

int N, S, A, X[MAX_N], Y[MAX_N], Num[SIZE1];
int Reg[SIZE1], F[SIZE1][SIZE1], Is[SIZE1];
int Res[SIZE1][SIZE1][SIZE1], U[SIZE1][SIZE1][SIZE1], L[SIZE1][SIZE1][SIZE1];
int P[SIZE1], PN = 0;
char s[99];

int main( void )
{
  FILE *InF, *OutF;
  int i, j, k, i1, j1, k1, num, maxres = -1, maxk = 0;

  InF = fopen("small.in", "rt");
  OutF = fopen("small.out", "wt");

  fscanf(InF, "%d", &N);
  for (i = 0; i < N; i++)
    fscanf(InF, "%d%d", &Y[i], &X[i]);
  fscanf(InF, "%d", &S);
  for (i = 0; i < S; i++)
    fscanf(InF, "%d", &Num[i]);
  fscanf(InF, "%d", &A);

  for (i = 1, k = 0; i <= SIZE; i++) 
  { 
    while (k < S && i >= Num[k])
      k++;
    Reg[i] = k;
  }  

  for (i = 0; i < N; i++)
    for (j = 1; j < N; j++) 
      if (Y[j - 1] > Y[j])
        SWAP(X[j - 1], X[j], k), SWAP(Y[j - 1], Y[j], k);

  memset(F, 0, sizeof(F));
  for (i = 1; i <= SIZE; i++)
  {
    num = 0;
    memset(Is, 0, sizeof(Is));
    for (k = 0; k < N && Y[k] < i; k++)
      ;
    for (j = i; j <= SIZE; j++)
    {
      while (k < N && Y[k] <= j)
        if (Is[Reg[X[k++]]] == 0)
          Is[Reg[X[k - 1]]] = 1, num++;  
      F[i][j] = num;
    }  
  }

  memset(Res, 0, sizeof(Res));
  memset(U, 0, sizeof(U));
  U[1][1][1] = 1, L[1][1][1] = 0;
  for (i = 1; i < SIZE; i++)
    for (j = 0; j <= A; j++)
      for (k = 1; k <= i; k++) 
        if (U[i][j][k]) 
        {
          if (!U[i + 1][j][k] || Res[i + 1][j][k] < Res[i][j][k])
          {
            U[i + 1][j][k] = 1;
            Res[i + 1][j][k] = Res[i][j][k];
            L[i + 1][j][k] = k;
          }
          if (j < A && (!U[i + 1][j + 1][i + 1] || Res[i + 1][j + 1][i + 1] < Res[i][j][k] + F[k][i]))
          {
            U[i + 1][j + 1][i + 1] = 1;
            Res[i + 1][j + 1][i + 1] = Res[i][j][k] + F[k][i];
            L[i + 1][j + 1][i + 1] = k;
          }
        }

  maxk = SIZE, maxres = Res[SIZE][A][SIZE];
  k = maxk, i = SIZE, j = A;
  while (k > 0)
  {
    if (PN == 0 || P[PN - 1] != k)
      P[PN++] = k;
    i1 = i - 1;
    if (L[i][j][k] == k)
      j1 = j;
    else
      j1 = j - 1;
    k1 = L[i][j][k];
    i = i1, j = j1, k = k1;
  }
  
  fprintf(OutF, "%d", A);
  for (i = PN - 1; i >= 0; i--)
    fprintf(OutF, " %d", P[i]);
  return 0;
}
