#include <stdio.h>
#include <string.h>

#define DBG 0

#define MAX 40013

int Mem[MAX], Next[MAX], A = 0;

void Correct( int *X )
{
  *X &= 65535;
  if (*X >> 15)
    *X = -32768 + (*X & 32767);
}

int main( void )
{
  FILE *InF, *OutF;
  char com[99];
  int i, k = 0, x, y, flag = 1, x0, ne, tmp;
  int t = clock();

  memset(Mem, 0, sizeof(Mem));
  memset(Next, 0, sizeof(Next));
  InF = fopen("indirect.in", "rt");
  OutF = fopen("indirect.out", "wt");
  while (fgets(com, 99, InF) != NULL)
  {
    sscanf(com + 2, "%d", &x), y = x;
    if (com[1] == '*')
    {
      x0 = x;
      for (x = x0, i = 0; Mem[x] < 0 && i < 32768; i++, k++)
        if (Next[x] && x != Next[x])
          x = Next[x];
        else
          x = -Mem[x];
      if (i == 32768)
      {
        flag = 0;
        fprintf(OutF, "RUN-TIME ERROR\n");
        break;
      }
      ne = x;
      for (x = x0, i = 0; Mem[x] < 0 && i < 32768; i++, k++)
        if (Next[x] && x != Next[x])
          tmp = Next[x], Next[x] = ne, x = tmp;
        else
          Next[x] = ne, x = -Mem[x];
      y = Mem[x];
    }
    if (com[0] == 'W')
      Mem[x] = A;
    else if (com[0] == 'A')
      A += y;
    else if (com[0] == 'S')
      A -= y;
    else if (com[0] == 'M')
      A *= y;
    else if (com[0] == 'R')
      A = y;
    else
    {
      if (y == 0)
      {
        flag = 0;
        fprintf(OutF, "DIVISION BY ZERO\n");
        break;
      }
      if (com[0] == 'D')
        A /= y;
      else 
        A %= y;
    }
    Correct(&A);
  }         
  if (flag)
    fprintf(OutF, "SUCCESSFUL TERMINATION\n");
  fprintf(OutF, "%d\n", A);
  for (i = 1; i <= 32768; i++)
    fprintf(OutF, "%d\n", Mem[i]);
# if DBG == 1
  printf("Time=%d\n%d\n", clock() - t, k);
# endif
  return 0;
}
