#include <stdio.h>

#define MAX 65536

int Start, End;
int Mem[MAX + 1];
int D[MAX], L[MAX], Op[MAX];
int Q[MAX], Pos = 0, Len = 1;
int P[MAX], PN = 0;
FILE *InF, *OutF;

void Add( int sp, int d, int l, int op )
{
  if (D[sp] != -1)
    return;
  D[sp] = d, L[sp] = l, Op[sp] = op;
  Q[Len++] = sp;
}

void Sep( int i, int k, int f )
{
  if ((!i && !f) || ((k & 15) == 15))
    fprintf(OutF, "\n");
  else if ((k & 15) == 7)
    fprintf(OutF, "  ");
  else 
    fprintf(OutF, " ");
}

int main( void )
{
  int i, k, sp, num = 0;

  InF = fopen("2instr.in", "rt");
  OutF = fopen("2instr.out", "wt");
  fscanf(InF, "%X%X", &Start, &End);
  for (i = 0; i < MAX; i++)
    fscanf(InF, "%X", &Mem[i]);
  Mem[MAX] = Mem[0];
  for (i = 0; i < MAX; i++)
    D[i] = -1;
  Q[0] = Start, D[Start] = 0;
  while (Pos < Len)
  {
    sp = Q[Pos++];
    Add((sp >> 8) + ((sp & 255) << 8), D[sp] + 2, sp, 1);
    Add(Mem[sp] + (Mem[sp + 1] << 8), D[sp] + 1, sp, 0);
  }
  if (D[End] == -1)
    fprintf(OutF, "IMPOSSIBLE");
  else
  { 
    sp = End;
    while (sp != Start)
      P[PN++] = Op[sp], sp = L[sp];
    for (i = 0; i < PN; i++)
      num += P[i] + 1;
    fprintf(OutF, "%d\n", num);
    for (i = PN - 1, k = 0; i >= 0; i--, k++)
      if (P[i] == 0)
        fprintf(OutF, "5C"), Sep(i, k, 0);
      else
        fprintf(OutF, "0F"), Sep(i, k, 1), fprintf(OutF, "CC"), Sep(i, ++k, 0);
  }  
  return 0;
}
