#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define MAX_K 30003

int W, H, C, K, Res = 0;
int A[MAX_K], Pos = 0;
int Str1[MAX_K], Str2[MAX_K], Num1, Num2, Len;
int Pa1[MAX_K], N1, Pa2[MAX_K], N2, Pa3[MAX_K];
int U1[MAX_K], U2[MAX_K];

void GetStr( void )
{
  Num2 = Len = 0;
  if (C == 1)
    Str2[Num2++] = 0;
  while (Len < W)
  {
    Str2[Num2++] = Len;
    Len += A[Pos];
    Pos++;
    C = 1 - C;
  }
  if (Len > W)
    Pos--, C = 1 - C, A[Pos] = Len - W;
  Str2[Num2] = W;
}

void CopyStr( void )
{
  memcpy(Str1, Str2, sizeof(int) * (Num2 + 1));
  Num1 = Num2;
}

int Get( int v )
{
  if (Pa1[v] == v)
    return v;
  return Pa1[v] = Get(Pa1[v]);
}

void Join( int v1, int v2 )
{
  v1 = Get(v1), v2 = Get(v2);
  if (U1[v1] || U1[v2])
    U1[v1] = U1[v2] = 1;
  if (rand() & 1)
    Pa1[v2] = v1;
  else
    Pa1[v1] = v2;
}

void Do( int i, int j )
{
  if (i >= Num1 || j >= Num2)
    return;
  i >>= 1, j >>= 1;
  if (!U2[j])
    Pa2[j] = i;
  else
    Join(Pa2[j], i);
  U1[Get(i)] = 1;
  U2[j] = 1;
}

int main( void )
{
  int i, j;

  freopen("rle.in", "rt", stdin);
  freopen("rle.out", "wt", stdout);
  scanf("%d%d%d%d", &W, &H, &C, &K);
  if (H <= 0 || W <= 0)
  {
    printf("0");
    return 0;
  }
  for (i = 0; i < K; i++)
  {
    scanf("%d", &A[i]);
    if (A[i] > W)
      A[i] = (A[i] % W) + W;
  }
  GetStr();
  CopyStr();
  N1 = Num1 >> 1;
  for (i = 0; i < N1; i++)
    Pa1[i] = i;
  while (Pos < K)
  {
    GetStr();
    for (i = 0; i < Num1; i++)
      U1[i] = 0;
    for (i = 0; i < Num2; i++)
      U2[i] = 0;
    i = j = 1;
    while (j < Num2 && i < Num1)
    {
      if (Str1[i] <= Str2[j + 1] && Str1[i + 1] >= Str2[j])
        Do(i, j);
      if (Str1[i + 1] < Str2[j + 1])
        i += 2;
      else
        j += 2;
    }
    for (i = 0; i < N1; i++)
      if (U1[Get(i)] == 0)
        Res++;
    for (j = 0; j < (Num2 >> 1); j++)
      if (U2[j])
        Pa2[j] = Get(Pa2[j]);
    N2 = (Num2 >> 1);
    Pa3[0] = 0;
    for (i = 1; i < (Num2 >> 1); i++)
      if (U2[i] && U2[i - 1] && Pa2[i - 1] == Pa2[i])
        Pa3[i] = Pa3[i - 1];
      else
        Pa3[i] = i;
    N1 = N2;
    for (i = 0; i < N1; i++)
      Pa1[i] = Pa3[i];
    CopyStr();
  }
  Res++;
  for (i = 1; i < N1; i++)
    if (Get(i - 1) != Get(i))
      Res++;
  printf("%d\n", Res);
  return 0;
}
