#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <conio.h>
#include <time.h>

#define SWAP(A, B, C) ((C) = (A), (A) = (B), (B) = (C))

#define EPS 1e-8

#define MAX_N 303

int N, St;
double MinY, t;
double X[MAX_N], Y[MAX_N];
int Max[MAX_N][MAX_N], U[MAX_N][MAX_N];
short C[MAX_N][MAX_N][MAX_N], *C1;
int P[MAX_N][MAX_N]; 

void Dfs( int i, int j, int f )
{
  int k, l, res = 0, f1, p;
  short *C1;
  double xme, xpe;

  if (U[i][j])
    return;
  U[i][j] = 1;
  if (f == 2 && X[i] < X[St] - EPS)
    return;
  if (i == St)
    Max[i][j] = 1;
  else
  {
    xme = X[i] - EPS, xpe = X[i] + EPS;
    p = P[i][j], C1 = &C[i][j][0];
    for (l = 0; l < p; l++)
      if ((k = C1[l]) >= St && Y[k] >= MinY - EPS)
      {
        f1 = f;
        if (X[k] < xme)
        {
          if (f == 1)
            f1 = 2;
        }
        else if (X[k] > xpe)
        {
          if (f == 0)
            f1 = 1;
          else if (f == 2)
            continue;
        }
        Dfs(k, i, f1);
        if (Max[k][i] && Max[k][i] + 1 > res)
          res = Max[k][i] + 1;
      }
    Max[i][j] = res;
  }  
}

int main( void )
{
  FILE *InF, *OutF;
  int i, j, k, res = 0;
  int tall = clock(), ti = clock();
  double Xij, Yij, Xj, Yj;

  InF = fopen("polygon.in", "rt");
  OutF = fopen("polygon.out", "wt");
  fscanf(InF, "%d", &N);
  for (i = 0; i < N; i++)
    fscanf(InF, "%lf%lf", &X[i], &Y[i]);
  for (i = 0; i < N; i++)
    for (j = 1; j < N; j++)
      if (Y[j - 1] > Y[j] + EPS || (Y[j - 1] >= Y[j] - EPS && X[j - 1] < X[j]))
      {
        SWAP(X[j], X[j - 1], t);
        SWAP(Y[j], Y[j - 1], t);
      }
  printf("Time1=%d\n", clock() - ti), ti = clock();
  memset(P, 0, sizeof(P));
  for (i = 0; i < N; i++)
    for (j = 0; j < N; j++)
    {
      C1 = C[i][j];
      Xij = X[j] - X[i], Yij = Y[j] - Y[i];
      Xj = X[j], Yj = Y[j];
      for (k = 0; k < N; k++)
        if (i != j && i != k && j != k)
          if (Xij * (Y[k] - Yj) - (X[k] - Xj) * Yij > EPS)
            C1[P[i][j]++] = k;
    }
  printf("Time2=%d\n", clock() - ti), ti = clock();
  for (j = 0; j < N; j++)
  {
    memset(Max, 0, sizeof(Max));
    memset(U, 0, sizeof(U));
    St = j, MinY = Y[j];
    for (i = St + 1; i < N; i++)
    {
      if (X[i] >= X[j] - EPS)
        Dfs(i, j, 1);
      else
        Dfs(i, j, 0);
      if (Max[i][j] > res)
        res = Max[i][j];
    }
    if (clock() - tall > 370)
      break;
  }
  fprintf(OutF, "%d", res);
  printf("Time3=%d\n", clock() - ti), ti = clock();
  printf("Res=%d\n", res);
  printf("AllTime=%d\n", clock() - tall);
  return 0;
}
