#include <stdio.h>
#include <string.h>
#include <conio.h>
#include <time.h>

#define DBG 2

#define INF 999

#define MAX_H 51

FILE *InF, *OutF;
int Len1[MAX_H], Len2[MAX_H], Len3[MAX_H], Num[MAX_H];
int B[MAX_H][MAX_H], A[MAX_H][MAX_H];
int H1, H2, H3, S1, S2, S3, Sum = 0;

void Read( int *S, int *N, int *A )
{
  *N = 0, *S = 0;
  while (fscanf(InF, "%d", &A[*N + 1]) == 1)
  {
    if (A[++(*N)] <= 0)
      break;
    *S += A[*N];
  }
}

void Dfs1( int y, int x, int l )
{
  int i, j;

  if (x >= Len3[y])
  {
    y++, x = Len1[y], l = 1;
    if (y == H3)
    {
      for (i = 1; i < H3; i++)
        for (j = 1; j < H2; j++)
          if (B[i][j] > B[i - 1][j - 1])
            return;
      Sum++;
#     if DBG == 0
      for (i = 0; i < H3; i++)
      {
        for (j = 0; j < Len3[i]; j++)
          printf("%d ", A[i][j]);
        printf("\n");
      }
#     endif
      return;
    }
    if (x == Len3[y])
      Dfs1(x, y, l);
  }
  for (i = l; i < H2; i++)
    if (Num[i] < Len2[i] && i > A[y - 1][x] && B[y][i] + 1 <= B[y - 1][i - 1])
    {
      A[y][x] = i;
      Num[i]++;
      for (j = y; j < H3; j++)
        B[j][i]++;
      Dfs1(y, x + 1, i);
      for (j = y; j < H3; j++)
        B[j][i]--;
      Num[i]--;
    }
}

int main( void )
{
  int i, j, t = clock();

  InF = fopen("young.in", "rt");
  OutF = fopen("young.out", "wt");
  while (1)
  {
    Sum = 0;
    memset(Len1, 0, sizeof(Len1));
    memset(Len2, 0, sizeof(Len2));
    memset(Len3, 0, sizeof(Len3));
    memset(Num, 0, sizeof(Num));
    memset(B, 0, sizeof(B));
    memset(A, 0, sizeof(A));
    Read(&S1, &H1, Len1);
    Read(&S2, &H2, Len2);
    Read(&S3, &H3, Len3);
    if (Len1[H1] < 0 || Len2[H2] < 0 || Len3[H3] < 0)
      break;
#   if DBG == 1
    printf("H1=%d:", H1 - 1);
    for (i = 1; i < H1; i++)
      printf(" %d", Len1[i]);
    printf("\n");
    printf("H2=%d:", H2 - 1);
    for (i = 1; i < H2; i++)
      printf(" %d", Len2[i]);
    printf("\n");
    printf("H3=%d:", H3 - 1);
    for (i = 1; i < H3; i++)
      printf(" %d", Len3[i]);
    printf("\n");
    printf("S1=%d S2=%d S3=%d\n", S1, S2, S3);
#   endif
    for (i = 1; i < H1; i++)
      if (Len3[i] < Len1[i])
        break;
    if (i < H1 || S2 != S3 - S1)
    {
      fprintf(OutF, "0\n");
#     if DBG == 1
      printf("----> 0 <----\n");
#     endif
      continue;
    }
    for (i = 0; i < MAX_H; i++)
      B[i][0] = INF;
    Len3[0] = Len3[1];
    Dfs1(1, Len1[1], 1);
    fprintf(OutF, "%d\n", Sum);
#   if DBG == 1
    printf("----> %d <----\n", Sum);
    getch();
#   endif
  }
# if DBG <= 2
  printf("Time=%d\n", clock() - t);
# endif
  return 0;
}
