program temp;

{$D-,R-,I-,L-,Q-,S-}
uses
  SysUtils;

Const FileIn='customs.in';
      FileOut='customs.out';
      MaxN=10000;
      Inf=1000000001;
Type TCost = Extended;
     Integer=LongInt;
     PList=^TList;
     TList=Record
       Next: PList;
       Go: Integer;
       Cost: TCost;
     End;
Var Path:Array[1..MaxN,0..3] Of TCost;
    Fifty:Array[1..MaxN] Of Integer;
    Data, P:Array[1..MaxN] Of PList;
    Up:Array[1..MaxN] Of Integer;
    Time:Array[1..MaxN] Of Integer;
    Used:Array[1..MaxN] Of Boolean;
    Strange:Array[1..MaxN] Of Boolean;
    Co:Array[1..MaxN] Of TCost;
    Bo:Array[1..MaxN] Of Boolean;
    N,M:Integer;
    St,Fi:Integer;
Function Min(A,B: TCost): TCost;
  Begin
    If A>B Then Min:=B Else Min:=A;
  End;
Function Max(A,B: TCost): TCost;
  Begin
    If A<B Then Max:=B Else Max:=A;
  End;
procedure Init;
  Var X,Y: Integer;
      Z: TCost;
      I: Integer;
  Begin
    For I:=1 To MaxN Do
      Data[i]:= Nil;
    Read(N, M);
    For I:=1 To M Do
      Begin
        Read(X, Y, Z);
        If Data[X] = Nil Then
          Begin
            New(Data[X]);
            P[X]:=Data[X];
          End
          Else
          Begin
            New(P[X]^.Next);
            P[X]:=P[X]^.Next;
          End;
        P[X]^.Next:=Nil;
        P[X]^.Go:=Y;
        P[X]^.Cost:=Z;
        If Data[Y] = Nil Then
          Begin
            New(Data[Y]);
            P[Y]:=Data[Y];
          End
          Else
          Begin
            New(P[Y]^.Next);
            P[Y]:=P[Y]^.Next;
          End;
        P[Y]^.Next:=Nil;
        P[Y]^.Go:=X;
        P[Y]^.Cost:=Z;
      End;
    Read(St,Fi);
  End;
procedure CloseFiles;
  Begin
    Close(Input);
    Close(Output);
  End;
procedure OpenFiles;
  Begin
    Assign(Input,FileIn);
    Reset(Input);
    Assign(Output,FileOut);
    Rewrite(Output);
  End;
Procedure Refresh(By,Wh:Integer;Ma:TCost);
  Var Min:TCost;
      I:Integer;
  Begin
    Min:=Inf;
    For I:=0 To Fifty[Wh] Do
      If Path[Wh,I]<Min Then Min:=Path[Wh,I];
    If Min>Ma Then Min:=Ma;
    If Fifty[Wh]<2 Then Min:=0;
    If (Path[Wh,3] + Ma - Min)<Path[By,3] Then
      Begin
        Path[By]:=Path[Wh];
        Fifty[By]:=Fifty[Wh] + 1;
        If Fifty[By]=3 Then Fifty[By]:=2;
        Path[By,3]:=Path[Wh,3] + Ma - Min;
        If Fifty[Wh]<2 Then
          Path[By, Fifty[By]]:=Ma
          Else
          For I:=0 To 2 Do
            If Abs(Path[By, I] - Min)<0.5 Then
              Begin
                Path[By,I]:=Min;
                Exit;
              End;
      End;
  End;
Procedure GetPoints;
Var T:Integer;
  Function Min(A,B:Integer):Integer;
    Begin
      If A>B Then Min:=B Else Min:=A;
    End;
  Function Max(A,B:Integer):Integer;
    Begin
      If A>B Then Max:=A Else Max:=B;
    End;
  Function Dfs(X:Integer;Last:Integer):Boolean;
    Var P:PList;
        F:Boolean;
    Begin
      Dfs:=False;
      If Used[X] Then Exit;
      Used[X]:=True;
      F:=False;
      If (X = Fi) then
        F:=True;
      Inc(T); Up[X]:=T; Time[X]:=T;
      P:=Data[X];
      While P<>Nil Do
        Begin
          If Used[P^.Go] Then
            Begin
              If P^.Go<>Last Then
                Up[X]:=Min(Up[X],Time[P^.Go]);
              P:=P^.Next;
            End
            Else
            Begin
              If Not F Then
                Begin
                  F:=Dfs(P^.Go,X);
                  If F Then
                    Begin
                      Up[X]:=Min(Up[X],Up[P^.Go]);
                      If Time[X]<=Up[P^.Go] Then
                        Strange[X]:=True;
                      Break;
                    End
                    Else
                    Up[X]:=Min(Up[X],Up[P^.Go]);
                End
                Else
                Strange[X]:=True;
              P:=P^.Next;
            End;
        End;
      If F And (Time[X]<=Up[X]) Then
        Strange[X]:=True;
      Dfs:=F;
    End;
  Begin
    T:=0;
    Fillchar(Used,Sizeof(Used),False);
    Fillchar(Strange,Sizeof(Strange),False);
    Fillchar(Time,Sizeof(Time),0);
    Fillchar(Up,Sizeof(Up),0);
    Dfs(St,0);
    Strange[St]:=False;
  End;
Procedure AddCost(X:TCost);
  Var I:Integer;
      Min:TCost;
  Begin
    Inc(Fifty[St]);
    Min:=Inf;
    If Fifty[St]<3 Then
      Begin
        Path[St,Fifty[St]]:=X;
        Path[St,3]:=Path[St,3] + X;
        Exit;
      End;
    For I:=0 To 2 Do
      If Path[St,Fifty[St]]<Min Then Min:=Path[St,Fifty[St]];
    If Min>X Then Min:=X;
    If Fifty[St]<>3 Then Min:=0;
    For I:=0 To Fifty[St] Do
      If Abs(Path[St,I] - Min)<0.5 Then
        Begin
          Path[St,I]:=X;
          Path[St,3]:=Path[St,3] + X - Min;
          Exit;
        End;
  End;
Procedure Solve;
  Var I,J: Integer;
      P: PList;
      Ans: TCost;
  Begin
    For J:=0 To 3 Do
      For I:=1 To MaxN Do
        Path[I,J]:=MaxInt;
    Fillchar(Fifty,Sizeof(Fifty),0);
    Fifty[St]:=-1;
    Path[St,0]:=0; Path[St,1]:=0; Path[St,2]:=0;
    Path[St,3]:=0;
    GetPoints;
    For I:=1 To N Do
      If Strange[I] Then
        Begin
          Fillchar(Bo,Sizeof(Bo),False);
          P:=Data[I];
          While P<>Nil Do
            Begin
              If Strange[P^.Go] Then
                Begin
                  If Bo[P^.Go] Then
                    Co[P^.Go]:=Min(Co[P^.Go],P^.Cost)
                    Else
                    Begin
                      Co[P^.Go]:=P^.Cost;
                      Bo[P^.Go]:=True;
                    End;
                End;
              P:=P^.Next;
            End;
          Bo[I]:=False;
          For J:=1 To N Do
            If Bo[J] Then
              AddCost(Co[J]);
        End;
    While True Do
      Begin
        M:=0;
        For I:=1 To N Do
          If Fifty[i]<>3 Then
            M:=I;
        If M=0 Then Break;
        For I:=1 To N Do
          If (Path[I,3]<Path[M,3])And(Fifty[i]<>3) Then M:=I;
        If (M=Fi) Then Break;
        P:= Data[M];
        While P<> Nil Do
          Begin
            Refresh(P^.Go,M,P^.Cost);
            P:=P^.Next;
          End;
        Fifty[M]:=3;
      End;
    Ans:=Path[Fi,3];
    Writeln(Ans:0:0);
  End;
begin
  OpenFiles;
  Init;
  Solve;
  CloseFiles
end.
