program PrC;

{$D-,R-,L-,Q-,S-,I-}
uses
  SysUtils;

Const FileIn='quirks.in';
      FileOut='quirks.out';
      MaxN=50000;
Type Integer=LongInt;
     PList=^TList;
     TList=Record
       Key:Integer;
       Next:PList;
     End;
Var T:Integer;
    N,M,L:Integer;
    A:Array[1..MaxN] Of Integer;
    B:Array[1..MaxN] Of Integer;
    Used:Array[1..MaxN] Of Boolean;
    Graf,P:Array[1..MaxN] Of PList;
procedure Init;
  Var I,X,Y:Integer;
  Begin
    Fillchar(A,Sizeof(A),0);
    Fillchar(Used,Sizeof(Used),False);
    For I:=1 To MaxN Do
      Graf[I]:=Nil;
    Read(N,M);
    For I:=1 To M Do
      Begin
        Read(X,Y);
        If Graf[X]= Nil Then
          Begin
            New(Graf[X]);
            P[X]:=Graf[X];
          End
          Else
          Begin
            New(P[X]^.Next);
            P[X]:=P[X]^.Next;
          End;
        P[X]^.Key:=Y;
        P[X]^.Next:=Nil;
      End;
  End;
procedure CloseFiles;
  Begin
    Close(Input);
    Close(Output);
  End;
procedure OpenFiles;
  Begin
    Assign(Input,FileIn);
    Reset(Input);
    Assign(Output,FileOut);
    Rewrite(Output);
  End;
Procedure Dfs(X:Integer);
  Var P:PList;
  Begin
    If Used[X] Then Exit;
    Used[X]:=True;
    P:=Graf[X];
    While P<>Nil Do
      Begin
        Dfs(P^.Key);
        P:=P^.Next;
      End;
    Inc(L);
    A[L]:=X;
    B[X]:=L;
  End;
Procedure Solve;
  Var I:Integer;
      P:PList;
  Begin
    L:=0;
    For I:=1 To N Do
      If Not Used[I] Then
        Dfs(I);
    Fillchar(Used,Sizeof(Used),False);
    Used[A[N]]:=True;
    For I:=N DownTo 1 Do
      If Not Used[A[I]] Then
        Begin
          Writeln('NO');
          Exit;
        End Else
        Begin
          P:=Graf[A[I]];
          While P<>Nil Do
            If Used[P^.Key] Then
              Begin
                If I>B[P^.Key] Then
                  Begin
                    Writeln('NO');
                    Exit;
                  End;
                P:=P^.Next;
              End
              Else
              Begin
                Used[P^.Key]:=True;
                P:=P^.Next;
              End;
        End;
    Writeln('YES');
  End;
begin
  OpenFiles;
  Read(T);
  While T<>0 Do
    Begin
      Init;
      Solve;
      Dec(T);
    End;
  CloseFiles
end.
