program prB;

{$D-,R-,I-,L-,Q-,S-}

Const FileIn='sin.in';
      FileOut='sin.out';
      MaxN=100;
Type Integer=LongInt;
Var N:Integer;
    B:Array[0..MaxN] Of Integer;
    A:Array[0..MaxN,0..MaxN,0..MaxN] Of Extended;
    C:Array[0..MaxN,0..MaxN,0..MaxN] Of Boolean;
    D:Array[0..MaxN,0..MaxN,0..MaxN] Of Integer;
    E:Array[0..MaxN,0..MaxN,0..MaxN] Of Integer;
    SinM:Array[0..MaxN,0..MaxN*MaxN] Of Extended;
procedure Init;
  Var I:Integer;
  Begin
    Read(N);
    For I:=1 To N Do
      Read(B[I]);
    B[0]:=0;
    For I:=1 To N Do
      B[I]:=B[I] * (I + 1);
  End;
procedure CloseFiles;
  Begin
    Close(Input);
    Close(Output);
  End;
procedure OpenFiles;
  Begin
    Assign(Input,FileIn);
    Reset(Input);
    Assign(Output,FileOut);
    Rewrite(Output);
  End;
Procedure GetSin;
  Var I,J:Integer;
  Begin
    For I:=0 To N Do
      For J:=0 To N*N Do
        SinM[I,J]:=Sin(B[I]*J);
  End;
Procedure Print(X,Y,Z:Integer);
  Begin
    If D[X,Y,Z]=0 Then
      Exit;
    Print(X - 1,Y - D[X,Y,Z],E[X,Y,Z]);
    Write(D[X,Y,Z],' ');
  End;
Procedure Solve;
  Var I,J,K,L:Integer;
      Ans:Extended;
  Begin
    GetSin;
    Fillchar(C,Sizeof(C),False);
    C[0,0,0]:=True;
    A[0,0,0]:=0;
    D[0,0,0]:=0;
    e[0,0,0]:=0;
    For J:=0 To N - 1 Do
      For I:=0 To J Do
        For K:=0 To J - I + 1 Do
          If C[I,J,K] Then
            Begin
              For L:=1 To N - J Do
                If Not C[I + 1,J + L,L] Then
                  Begin
                    C[I + 1,J + L,L]:=True;
                    A[I + 1,J + L,L]:=A[I,J,K] + SinM[I, K*L];
                    D[I + 1,J + L,L]:=L;
                    E[I + 1,J + L,L]:=K;
                  End
                  Else
                  If A[I + 1,J + L,L]<A[I,J,K] + SinM[I, K*L] Then
                    Begin
                      A[I + 1,J + L,L]:=A[I,J,K] + SinM[I, K*L];
                      D[I + 1,J + L,L]:=L;
                      E[I + 1,J + L,L]:=K;
                    End;
            End;
    Ans:=-MaxInt;
    For I:=1 To N Do
      For K:=1 To N Do
        If C[I,N,K] And (A[I,N,K]/I>Ans) Then
          Ans:=A[I,N,K]/I;
    Writeln(Ans:0:10);
    For I:=1 To N Do
      For K:=1 To N Do
        If (C[I,N,K])And(Abs(Ans - A[I,N,K]/I)<1e-9) Then
          Begin
            Print(I,N,K);
            Exit;
          End;
  End;
begin
  OpenFiles;
  Init;
  Solve;
  CloseFiles;
end.
