program prA;

{$D-,R-,I-,L-,Q-,S-}
uses
  SysUtils;

Const FileIn='indirect.in';
      FileOut='indirect.out';
Type Integer=LongInt;
Var Data:Array[1..32768] Of ShortInt;
    Circle:Array[1..32768] Of Integer;
    Akum:ShortInt;
    Step:Integer;
procedure Init;
  Begin
    Fillchar(Data,Sizeof(Data),0);
    Fillchar(Circle,Sizeof(Circle),0);
    Akum:=0;
  End;
procedure CloseFiles;
  Begin
    Close(Input);
    Close(Output);
    HALT;
  End;
procedure OpenFiles;
  Begin
    Assign(Input,FileIn);
    Reset(Input);
    Assign(Output,FileOut);
    Rewrite(Output);
  End;
Procedure Print;
  Var I:Integer;
  Begin
    Writeln(Akum);
    For I:=1 To 32768 Do
      Writeln(Data[I]);
  End;
Function GetMem(X:Integer):Integer;
  Begin
    While Data[X]<0 Do
      Begin
        Circle[X]:=Step;
        X:=-Data[X];
        If Circle[X]=Step Then
          Begin
            Writeln('RUN-TIME ERROR');
            Print;
            CloseFiles;
          End;
      End;
    GetMem:=X;
  End;
Procedure Solve;
  Var S:String;
      A:Integer;
  Begin
    Step:=0;
    While Not SeekEof Do
      Begin
        Readln(S);
        A:=StrToInt(Copy(S,3,Length(S) - 2));
        Delete(S,3,Length(S) - 2);
        If S[2]='=' Then
          Case S[1] Of
            'A':Akum:=Akum + A ;
            'S':Akum:=Akum - A;
            'M':Akum:=Akum * A;
            'D','O':Begin
                    If A=0 Then
                      Begin
                        Writeln('DIVISION BY ZERO');
                        Print;
                        Exit;
                      End;
                    If S[1]='D' Then
                       Akum:=Akum Div A
                    Else
                       Akum:=Akum Mod A;
              End;
            'R':Akum:=A;
           End;
        If S[2]='=' Then Continue;
        Inc(Step);
        A:=GetMem(A);
        Case S[1] Of
          'A':Akum:=Akum + Data[A];
          'S':Akum:=Akum - Data[A];
          'M':Akum:=Akum * Data[A];
          'D','O':Begin
              If Data[A]=0 Then
                Begin
                  Writeln('DIVISION BY ZERO');
                  Print;
                  Exit;
                End;
              If S[1]='D' Then Akum:=Akum Div Data[A]
                          Else Akum:=Akum Mod Data[A];
            End;
          'R':Akum:=Data[A];
          'W':Data[A]:=Akum;
        End;
      End;
    Writeln('SUCCESSFUL TERMINATION');
    Print;
  End;
begin
  OpenFiles;
  Init;
  Solve;
  CloseFiles
end.
