program PrC;

{$D-,R-,I-,L-,Q-,S-}
Uses SysUtils;
Const FileIn='ram.in';
      FileOut='ram.out';
Type Integer=LongInt;
     TComm=(cLoad,cStore,cAdd,cSub,cMult,cDiv,cRead,cWrite,cJump,cJgtz,cJzero,cHalt);
     TNum=Record Ty:(cNum,cReg,cRegReg);
                 X:Integer;
     End;
Var N,M:Integer;
    Data:Array[0..1000] Of Integer;
    Comm:Array[0..1000] Of TComm;
    Num:Array[0..1000] Of TNum;
    Inp:Array[1..1000] Of Integer;
    W:Integer;
    St:Extended;
procedure Init;
  Var S,S1:String;
      I,J:Integer;
  Begin
    Readln(M,N);
    For I:=0 To M -1 Do
      Begin
        Readln(S);
        J:=1;S1:='';
        While (J<=Length(S))And(S[J]<>' ') Do
          Begin
            S1:=S1 + S[J];
            Inc(J);
          End;
        Delete(S,1,J);
        While (Length(S)<>0)And(S[1]=' ') Do
          Delete(S,1,1);
        If S<>'' Then  Begin
          Num[I].Ty:=cReg;
          If S[1]='=' Then Num[I].Ty:=cNum;
          If S[1]='*' Then Num[I].Ty:=cRegReg;
          If Not (S[1] in ['0'..'9']) Then Delete(S,1,1);
          Num[I].X:=StrToInt(S);
        End;
        If S1='LOAD' Then
          Comm[I]:=cLoad Else
        If S1='STORE' Then
          Comm[I]:=cStore Else
        If S1='ADD' Then
          Comm[I]:=cAdd Else
        If S1='SUB' Then
          Comm[I]:=cSub Else
        If S1='MULT' Then
          Comm[I]:=cMult Else
        If S1='DIV' Then
          Comm[I]:=cDiv Else
        If S1='READ' Then
          Comm[I]:=cRead Else
        If S1='WRITE' Then
          Comm[I]:=cWrite Else
        If S1='JUMP' Then
          Comm[I]:=cJump Else
        If S1='JGTZ' Then
          Comm[I]:=cJgtz Else
        If S1='JZERO' Then
          Comm[I]:=cJzero Else
        If S1='HALT' Then
          Comm[I]:=cHalt;
      End;
    For I:=1 To N Do
      Read(Inp[I]);
    N:=0;
  End;
procedure CloseFiles;
  Begin
    Close(Input);
    Close(Output);
  End;
procedure OpenFiles;
  Begin
    Assign(Input,FileIn);
    Reset(Input);
    Assign(Output,FileOut);
    Rewrite(Output);
  End;
Procedure CommLoad(Var X:Integer);
  Begin
    Case Num[X].Ty Of
      cNum:Data[0]:=Num[X].X;
      cReg:Data[0]:=Data[Num[X].X];
      cRegReg:Data[0]:=Data[Data[Num[X].X]];
    End;
  End;
Procedure CommStore(Var X:Integer);
  Begin
    Case Num[X].Ty Of
      cReg:Data[Num[X].X]:=Data[0];
      cRegReg:Data[Data[Num[X].X]]:=Data[0];
    End;
  End;
Procedure CommAdd(Var X:Integer);
  Begin
    Case Num[X].Ty Of
      cNum:Data[0]:=Data[0] + Num[X].X;
      cReg:Data[0]:=Data[0] + Data[Num[X].X];
      cRegReg:Data[0]:=Data[0] + Data[Data[Num[X].X]];
    End;
  End;
Procedure CommSub(Var X:Integer);
  Begin
    Case Num[X].Ty Of
      cNum:Data[0]:=Data[0] - Num[X].X;
      cReg:Data[0]:=Data[0] - Data[Num[X].X];
      cRegReg:Data[0]:=Data[0] - Data[Data[Num[X].X]];
    End;
  End;
Procedure CommMult(Var X:Integer);
  Begin
    Case Num[X].Ty Of
      cNum:Data[0]:=Data[0] * Num[X].X;
      cReg:Data[0]:=Data[0] * Data[Num[X].X];
      cRegReg:Data[0]:=Data[0] * Data[Data[Num[X].X]];
    End;
  End;
Procedure CommDiv(Var X:Integer);
  Begin
    Case Num[X].Ty Of
      cNum:Data[0]:=Data[0] div Num[X].X;
      cReg:Data[0]:=Data[0] div Data[Num[X].X];
      cRegReg:Data[0]:=Data[0] div Data[Data[Num[X].X]];
    End;
  End;
Procedure CommRead(Var X:Integer);
  Begin
    Inc(N);
    Case Num[X].Ty Of
      cReg:Data[Num[X].X]:=Inp[N];
      cRegReg:Data[Data[Num[X].X]]:=Inp[N];
    End;
  End;
Procedure CommWrite(Var X:Integer);
  Begin
    Case Num[X].Ty Of
      cNum:Writeln(Num[X].X);
      cReg:Writeln(Data[Num[X].X]);
      cRegReg:Writeln(Data[Data[Num[X].X]]);
    End;
  End;
Procedure Solve;
  Var P:Integer;
  Begin
    P:=-1;W:=0;
    While True Do
      Begin
        Inc(P);Inc(W);
        Case Comm[P] Of
          cLoad:CommLoad(P);
          cStore:CommStore(P);
          cAdd:CommAdd(P);
          cSub:CommSub(P);
          cMult:CommMult(P);
          cDiv:CommDiv(P);
          cRead:CommRead(P);
          cWrite:CommWrite(P);
          cJump:P:=Num[P].X - 1;
          cJgtz:If Data[0]>0 Then P:=Num[P].X - 1;
          cJzero:If Data[0]=0 Then P:=Num[P].X - 1;
          cHalt:Exit;
        End;
      End;
  End;
begin
  OpenFiles;
  Init;
  St:=Now;
  Solve;
  CloseFiles;
  Assign(Output,'');
  Rewrite(Output);
  Write(Abs(Now - St)*24*60*60*10000000/w:0:5,' ',w);
  Close(Output);
end.
