program temp;

{$D-,R-,I-,L-,Q-,S-}
uses
  SysUtils;

Const FileIn='best.in';
      FileOut='best.out';
      Kol=2500000;
      Eps=1e-7;
      Inf=500000000000000000;
Type Integer=LongInt;
Var X2,Y2:Extended;
    X,Y:Extended;
    XY:Extended;
    N:Integer;
    Step:Extended;
procedure Init;
  Var A,B,I:Integer;
  Begin
    Read(N);
    X2:=0; Y2:=0;
    XY:=0; X:=0; Y:=0;
    For I:=1 To N Do
      Begin
        Read(A,B);
        X2:=X2 + Extended(A)*A;
        Y2:=Y2 + Extended(B)*B;
        X:=X + Extended(A);
        Y:=Y + Extended(B);
        XY:=XY + Extended(A)*B;
      End;
  End;
procedure CloseFiles;
  Begin
    Close(Input);
    Close(Output);
  End;
procedure OpenFiles;
  Begin
    Assign(Input,FileIn);
    Reset(Input);
    Assign(Output,FileOut);
    Rewrite(Output);
  End;
Procedure Solve;
  Var F,C:Extended;
      Z:Extended;
      A,B:Extended;
      co,si:Extended;
      W:Extended;
      Ans:Extended;
      AnsA,AnsB,AnsC:Extended;
      D:Extended;
  Begin
    Z:=2*pi; Ans:=inf; F:=0;
    Step:=(z - f)/kol;
    While F<Z Do
      Begin
        co:=cos(f);
        si:=sin(f);
        A:=X2 * co * co + Y2 * si * si + 2 * XY * co * si;
        B:=X*co + Y * si;
        C:=-B/N;
        If C<0 Then C:=0;
        W:=N*C*C + 2*C*B + A;
        If W<Ans Then
          Begin
            If W<Eps Then
              Begin
                D:=B*B - 4*A*N;
                If D<Eps Then D:=0;
                C:=B + Sqrt(D);
                C:=C / N;
                Writeln(0.0:0:6);
                Writeln(Co:0:6,' ',Si:0:6,' ',C:0:6);
                Exit;
              End;
            Ans:=W;
            AnsA:=co;
            AnsB:=si;
            AnsC:=C;
          End;
        F:=F + Step;
      End;
    Writeln(Ans:0:6);
    Writeln(-AnsA:0:6,' ',-AnsB:0:6,' ',AnsC:0:6);
  End;
begin
  OpenFiles;
  Init;
  Solve;
  CloseFiles;
end.
