program prC;
{$D-,R-,I-,L-,Q-,S-,T-}
uses
  SysUtils;

Const FileIn='unit.in';
      FileOut='unit.out';
      MaxL=65535;
Type Integer=LongInt;
Var A:Array[0..65535] Of Boolean;
    B:Array[0..3,0..15] Of Boolean;
    G:Array[0..15,1..10000] Of Integer;
    Line:Array[1..MaxL] Of Integer;
    Z:Array[1..10] Of Integer;
    H:Array[0..15] Of Integer;
    K,L,T,M:Integer;
    Setka:Integer;
    StrangeNumber:Integer;
Procedure Generate(Fr,X,Y:Integer);
  Var I:Integer;
  Begin
    If X=K Then
      Begin
        Inc(M);
        G[Fr,M]:=Y;
        Exit;
      End;
    For I:=1 To StrangeNumber Do
      Generate(Fr,X + 1,Y Or (Z[I] shl X));
  End;
procedure Init;
  Var I,J:Integer;
      St,Fi:Integer;
  Begin
    Fillchar(A,Sizeof(A),False);
    Fillchar(G,Sizeof(G),0);
    Read(K,L);
    StrangeNumber:=K + L + 2;
    Z[K + L + 1]:=0;
    Z[K + L + 1]:=1;
    For I:=0 To (1 shl K) - 1 Do
      Begin
        M:=0; St:=0;
        For J:=1 To K Do
          Begin
            Read(Z[J]);
            St:=St + Z[J] shl (J - 1);
          End;
        Fi:=0;
        For J:=1 To L Do
          Begin
            Read(Z[K + J]);
            Fi:=Fi + Z[K + J] shl (J - 1);
          End;
        H[St]:=Fi;
        Generate(St,0,0);
      End;
  End;
procedure CloseFiles;
  Begin
    Close(Input);
    Close(Output);
  End;
procedure OpenFiles;
  Begin
    Assign(Input,FileIn);
    Reset(Input);
    Assign(Output,FileOut);
    Rewrite(Output);
  End;
Procedure Solve;
  Var Fi:Integer;
      I,J:Integer;
      Lo,Hi:Integer;
      X,Y,Q:Integer;
      F:Boolean;
  Begin
    If K=1 Then
      Begin
        Writeln('NO');
        Exit;
      End;
    StrangeNumber:=K + K;
    X:=M;
    For Y:=1 To X Do
      Begin
        For  I:=0 To 1 shl k - 1 Do
          Begin
            For J:=1 To K Do
              Z[J]:=(H[I] shr (J - 1)) And 1;
            For J:=1 To L Do
              Z[J + K]:=(G[I,Y] shr (J - 1))And 1;
            M:=X;
            Generate(H[I],0,0);
          End;
        End;
    Setka:=1 shl K - 1;
    Fi:=0;
    For I:=0 To (1 shl K) - 1 Do
      Fi:=Fi Or (I shl (I*K));
    A[Fi]:=True;
    Line[1]:=Fi;
    Lo:=0; Hi:=1;
    While Lo<Hi Do
      Begin
        Inc(Lo);X:=Line[Lo];
        For I:=1 To M Do
          Begin
           Y:=0;
            For J:=0 To 1 shl K - 1 Do
              Y:=Y Or (G[(X shr (J * K)) And Setka,I] shl (J*K));
            If Not A[Y] Then
              Begin
                Inc(Hi);
                A[Y]:=True;
                Line[Hi]:=Y;
              End;
          End;
      End;
    Fillchar(B,Sizeof(B),False);
    For I:=0 To 1 shl (K*(1 shl K)) - 1 Do
      If A[I] Then
        Begin
          For J:=0 To K - 1 Do
            Begin
              X:=0;
              For Y:=0 To 1 shl K - 1 Do
                X:=X + (I shr (Y * K) shr J And 1) shl Y;
              B[J,X]:=True;
            End;
        End;
    For J:=0 To K - 1 Do
      Begin
        F:=True;
        For I:=0 To 1 shl K - 1 Do
          F:=F And B[J,I];
        If F Then
          Begin
            Writeln('YES');
            Exit;
          End;
      End;
    Writeln('NO');
  End;
begin
  OpenFiles;
  Read(T);
  While T<>0 Do
    Begin
      Init;
      Solve;
      Dec(T);
    End;
  CloseFiles
end.
