program temp;

{$D-,R-,I-,L-,Q-,S-}
Const FileIn='lcm.in';
      FileOut='lcm.out';
      Osn=1000;
      MaxLen=10000;
Type Integer=LongInt;
     TLong=Record
             Len:Integer;
             A:Array[1..MaxLen] Of Integer;
           End;
     PList=^TList;
     TList=Record
       Next:PList;
       Number:Integer;
       K:Integer;
     End;
Var Ans:TLong;
    List:PList;
    A:Array[1..100000] Of Integer;
Procedure Mul(X:Integer);
  Var I:Integer;
      Temp:Int64;
  Begin
    Temp:=0;
    For I:=1 To Ans.Len Do
      Begin
        Temp:=Temp + Int64(Ans.A[I]) * X;
        Ans.A[I]:=Temp Mod Osn;
        Temp:=Temp Div Osn;
      End;
    While Temp<>0 Do
      Begin
        Inc(Ans.Len);
        Ans.A[Ans.Len]:=Temp Mod Osn;
        Temp:=Temp Div Osn;
      End;
  End;
Function Max(A,B:Integer):Integer;
  Begin
    If A>B Then Max:=A Else Max:=B;
  End;
Procedure Divis(Var X:Integer;Y:Integer);
  Var K:Integer;
      P:PList;
  Begin
    K:=0;
    While X Mod Y=0 Do
      Begin
        Inc(K);
        X:=X Div Y;
      End;
    If K=0 Then Exit;
    If Y<=100000 Then
      Begin
        A[Y]:=Max(A[Y],K);
        Exit;
      End;
    If List=Nil Then
      Begin
        New(List);
        List^.Number:=Y;
        List^.K:=K;
        List^.Next:=Nil;
        Exit;
      End;
    P:=List;
    While P<>Nil Do
      Begin
        If P^.Number=Y Then
          Begin
            P^.K:=Max(P^.K,K);
            Exit;
          End;
        If P^.Next=Nil Then Break;
        P:=P^.Next;
      End;
    New(P^.Next);P:=P^.Next;
    P^.Number:=Y;P^.K:=K;
    P^.Next:=Nil;
  End;
procedure Init;
  Var I,N,X,Y:Integer;
  Begin
    Fillchar(A,Sizeof(A),0);
    Read(N);
    List:=Nil;
    For I:=1 To N Do
      Begin
        Read(X);
        Divis(X,2);
        Y:=1;
        While X<>1 Do
          Begin
            Y:=Y + 2;
            If Y>35000 Then Y:=X;
            Divis(X,Y);
          End;
      End;
  End;
procedure CloseFiles;
  Begin
    Close(Input);
    Close(Output);
  End;
procedure OpenFiles;
  Begin
    Assign(Input,FileIn);
    Reset(Input);
    Assign(Output,FileOut);
    Rewrite(Output);
  End;
Procedure Solve;
  Var P:PList;
      I:Integer;
      Z:Integer;
  Begin
    P:=List; Ans.Len:=1; Ans.A[1]:=1;
    While P<>Nil Do
      Begin
        Z:=1;
        While P^.K<>0 Do
          Begin
            Z:=Z * P^.Number;
            Dec(P^.K);
          End;
        Mul(Z);
        P:=P^.Next;
      End;
    For I:=2 To 100000 Do
      If A[I]<>0 Then
      Begin
        Z:=1;
        While A[I]<>0 Do
          Begin
            Dec(A[I]);
            Z:=Z * I;
           End;
        Mul(Z);
      End;
    Write(Ans.A[Ans.Len]);
    For I:=Ans.Len - 1 Downto 1 Do
      Begin
        If Ans.A[I]<100 Then Write('0');
        If Ans.A[I]<10 Then Write('0');
        Write(Ans.A[I]);
      End;
  End;
begin
  OpenFiles;
  Init;
  Solve;
  CloseFiles
end.
