{$Q-,R-,S-,I-,L-}
const probname = 'customs';
      maxm = 100000;
      maxn = 10000;

type TRebro = record x, y: longint; z: int64; end;
     TStone = record n: longint; ww: array [1..3] of int64; w: int64; end;

var n, m, i, a, b, j, k: longint;
    r: array [1..2*maxm] of TRebro;
    h: array [1..maxn] of TStone;
    hs, cur: longint;
    index, p: array [1..maxn+1] of longint;
    d: array [1..maxn] of int64;
    min, newd: int64;
    nm: longint;
    big: int64;


procedure swapR (var a, b: TRebro);
var c: TRebro;

begin
  c := a;
  a := b;
  b := c;
end;

procedure swapS (var a, b: TStone);
var c: TStone;

begin
  c := a;
  a := b;
  b := c;
end;

procedure swapL (var a, b: longint);
var c: longint;

begin
  c := a;
  a := b;
  b := c;
end;

procedure sort (left, right: longint);
var i, j, x: longint;
begin
  i := left;
  j := right;
  x := r [random (j-i+1)+i].x;
  while i <= j do
  begin
    while r [i].x < x do inc (i);
    while r [j].x > x do dec (j);
    if i<=j then
    begin
      swapR (r [i], r [j]);
      inc (i);
      dec (j);
    end;
  end;
  if left < j then sort (left, j);
  if i < right then sort (i, right);
end;

procedure siftup (const v: longint);
begin
  if v = 1 then exit;
  if h [v].w < h [v shr 1].w then
  begin
    swapS (h [v], h [v shr 1]);
    swapL (p [h [v].n], p [h [v shr 1].n]);
    siftup (v shr 1);
  end;
end;

procedure siftdown (const v: longint);
var min: longint;

begin
  min := v;
  if (2*v <= hs) and (h [2*v].w < h [min].w) then  min := 2*v;
  if (2*v+1 <= hs) and (h [2*v+1].w < h [min].w) then  min := 2*v+1;
  if min <> v then
  begin
    swapS (h [v], h [min]);
    swapL (p [h [v].n], p [h [min].n]);
    siftdown (min);
  end;
end;

procedure extractroot;
begin
  swapS (h [1], h [hs]);
  swapL (p [h [1].n], p [h [hs].n]);
  dec (hs);
  siftdown (1);
end;

begin
  big := 4000;
  big := big * 1000000;
  assign (input, probname+'.in');
  reset (input);
  assign (output, probname+'.out');
  rewrite (output);
  read (n, m);
  for i := 1 to m do
  begin
    read (r [2*i-1].x, r [2*i-1].y, cur);
    r [2*i-1].z := cur;
    r [2*i].x := r [2*i-1].y;
    r [2*i].y := r [2*i-1].x;
    r [2*i].z := r [2*i-1].z;
  end;
  read (a, b);
  sort (1, 2*m);
  fillchar (index, sizeof (index), 0);
  index [1] := 1;
  for i := 2 to 2*m do
    if index [r [i].x] = 0 then index [r [i].x] := i;
  index [n+1] := 2*m+1;
  hs := n;
  for i := 1 to n do
  begin
    h [i].n := i;
    h [i].w := big;
    h [i].ww [1] := 0;
    h [i].ww [2] := 0;
    h [i].ww [3] := 0;
    p [i] := i;
  end;
  h [a]. w := 0;
  swapS (h [1], h [a]);
  swapL (p [1], p [a]);
  for i := 1 to n do
    d [i] := big;
  d [a] := 0;
  for i := 1 to n do
  begin
    cur := h [1].n;
    for j := index [cur] to index [cur+1]-1 do
    begin
      min := big;
      nm := 0;
      for k := 1 to 3 do
        if h [1].ww [k] < min then
        begin min := h [1].ww [k]; nm := k; end;
      if r [j].z > min then
        newd := h [1].ww [1] + h [1].ww [2] + h [1].ww [3] - min + r [j].z
      else newd := h [1].ww [1] + h [1].ww [2] + h [1].ww [3];
      if newd < h [p [r [j].y]].w then
      begin
        h [p [r [j].y]].w := newd;
        h [p [r [j].y]].ww := h [1].ww;
        h [p [r [j].y]].ww [nm] := r [j].z;
        d [r [j].y] := newd;
        siftup (p [r [j].y]);
      end;
    end;
    extractroot;
  end;
  write (d [b]);
  close (input);
  close (output);
end.
