{$Q-,R-,S-,I-,L-}
const probname = 'quirks';
      maxm = 50000;
      maxn = 50000;

type TRebro = record x, y: longint; end;
     TFlag = (Black, Gray, White);

var t, tt, n, m, i, j: longint;
    r: array [1..maxm] of TRebro;
    c, pr, time, o, ins: array [0..maxn] of longint;
    tottime, ftime: longint;
    f, f2: array [1..maxn] of TFlag;
    ind: array [1..maxn+1] of longint;
    cc, q: longint;
    kos: boolean;

procedure swap (var a, b: TRebro);
var c: TRebro;

begin
  c := a;
  a := b;
  b := c;
end;

procedure sort (left, right: longint);
var i, j, x: longint;

begin
  i := left;
  j := right;
  x := r [random (j-i+1)+i].x;
  while i<=j do
  begin
    while r [i].x < x do inc (i);
    while r [j].x > x do dec (j);
    if i<=j then
    begin
      swap (r [i], r [j]);
      inc (i);
      dec (j);
    end;
  end;
  if left < j then sort (left, j);
  if i < right then sort (i, right);
end;

procedure dfs1 (const v: longint);
var i: longint;

begin
  f [v] := Gray;
  for i := ind [v] to ind [v+1]-1 do
    if f [r [i].y] = Black then dfs1 (r [i].y);
  f [v] := White;
  inc (tottime);
  time [v] := tottime;
  o [tottime] := v;
end;

procedure dfs2 (const v: longint);
var i: longint;

begin
  f2 [v] := Gray;
  c [v] := cc;
  for i := ind [v] to ind [v+1]-1 do
    if f2 [r [i].y] = Black then dfs2 (r [i].y);
  f2 [v] := White;
end;

procedure dfs3 (const v: longint);
var i: longint;

begin
  f [v] := Gray;
  for i := ind [v] to ind [v+1]-1 do
  begin
    if f [r [i].y] = White then kos := true;
    if f [r [i].y] = Black then dfs3 (r [i].y);
    if kos then exit;
  end;
  f [v] := White;
end;

begin
  assign (input, probname+'.in');
  reset (input);
  assign (output, probname+'.out');
  rewrite (output);
  read (t);
  for tt := 1 to t do
  begin
    fillchar (r, sizeof (r), 0);
    fillchar (ind, sizeof (ind), 0);
    kos := false;
    read (n, m);
    for i := 1 to m do
      read (r [i].x, r [i].y);
    sort (1, m);
    for i := 1 to m do
      if ind [r [i].x] = 0 then ind [r [i].x] := i;
    ind [n+1] := m+1;
    for i := n downto 1 do
      if ind [i] = 0 then
        ind [i] := ind [i+1];
    fillchar (time, sizeof (time), 0);
    fillchar (f, sizeof (f), 0);
    fillchar (f2, sizeof (f2), 0);
    fillchar (c, sizeof (c), 0);
    tottime := 0;
    cc := 0;
    time [0] := 1000000;
    for i := 1 to n do
    begin
      ftime := tottime;
      if time [i] = 0 then dfs1 (i);
      for j := ftime + 1 to tottime do
        if c [o [j]] = 0 then begin inc (cc); pr [cc] := o [j]; dfs2 (o [j]); end;
    end;
    fillchar (ins, sizeof (ins), 0);
    q := cc;
    for i := 1 to m do
      if (c [r [i].x] <> c [r [i].y]) and (ins [c [r [i].y]] = 0) then
      begin
        ins [c [r [i].y]] := 1;
        dec (q);
      end;
    if q <> 1 then
    begin
      writeln ('NO');
      continue;
    end;
    for i := 1 to cc do
      if ins [i] = 0 then q := i;
    fillchar (f, sizeof (f), 0);
    dfs3 (pr [q]);
    if kos then writeln ('NO') else writeln ('YES');
  end;
  close (input);
  close (output);
end.
