{$Q-,R-,S-,I-,L-}
const probname = 'programs';
      maxn = 600;
      maxl = maxn;
      base = 10000;

type TLong = array [0..500] of longint;

var n, l, i, j: longint;
    s: array [1..maxn] of string;
    d: array [0..maxl] of TLong;
    len: array [1..255] of longint;

function max (const a, b: longint): longint;
begin
  if a > b then max := a else max := b;
end;

procedure increase (var a: TLong; const b: TLong);
var i, q: longint;
begin
  a [0] := max (a [0], b [0]);
  for i := 1 to a [0] do
  begin
    a [i] := a [i] + b [i];
    inc (a [i+1], a [i] div base);
    a [i] := a [i] mod base;
  end;
  if a [a [0] + 1] <> 0 then inc (a [0]);
end;

procedure mult_add (const x, k, y: longint);
var i, um: longint;
    c: TLong;
begin
  if k <= 0 then exit;
  if k > 1 then
  begin
    fillchar (c, sizeof (c), 0);
    um := 0;
    c [0] := d [x, 0];
    for i := 1 to c [0] do
    begin
      c [i] := d [x, i] * k + um;
      um := c [i] div base;
      c [i] := c [i] mod base;
    end;
    if um <> 0 then
    begin
      inc (c [0]);
      c [c [0]] := um;
    end;
    increase (d [y], c);
  end else increase (d [y], d [x]);
end;

procedure writelong (const a: TLong);
var i: longint;
begin
  write (a [a [0]]);
  for i := a [0]-1 downto 1 do
  begin
    if a [i] < 10 then write ('0');
    if a [i] < 100 then write ('0');
    if a [i] < 1000 then write ('0');
    write (a [i]);
  end;
end;

begin
  assign (input, probname+'.in');
  reset (input);
  assign (output, probname+'.out');
  rewrite (output);
  readln (n);
  for i := 1 to n do
  begin
    readln (s [i]);
    j := 1;
    while j <= ord (s [i, 0]) do
    begin
      while s [i, j] = ' ' do delete (s [i], j, 1);
      inc (j);
    end;
    inc (len [length (s [i])])
  end;
  read (l);
  fillchar (d, sizeof (d), 0);
  d [0, 0] := 1;
  d [0, 1] := 1;
  for i := 1 to l do
    for j := 1 to 255 do
    begin
      if j > i then break;
      mult_add (i - j, len [j], i);
    end;
  writelong (d [l]);
  close (input);
  close (output);
end.
