{$I-,Q-,R-,S-}
const probname = 'ram';
      cmd = ['A'..'Z'];
      oper = ['*', '=', '0'..'9'];
      maxn = 1000;

type TCommand = (_load, _store, _add, _sub, _mult, _div, _read, _write, _jump, _jgtz, _jzero, _halt);
     TFullCommand = record cmd: TCommand; o: char; v: longint; end;

var n, m, i: longint;
    com: array [0..maxn] of TFullCommand;
    c: array [0..999] of longint;

procedure getcommand (var com: TFullCommand);
var s, cm, op: string;
    i: longint;
    serv: char;
    v: longint;
    err: integer;
begin
  readln (s);
  i := 1;
  cm := '';
  op := '';
  while (s [i] in cmd) and (i <= ord (s [0])) do
  begin
    cm := cm + s [i];
    inc (i);
  end;
  i := ord (s [0]);
  while s [i] in oper do
  begin
    op := s [i] + op;
    dec (i);
  end;
  serv := #0;
  if op[1] in ['=', '*'] then
  begin
    serv := op [1];
    delete (op, 1, 1);
  end;
  if op = '' then v := 0 else val (op, v, err);
  if cm = 'LOAD'    then com.cmd := _LOAD;
  if cm = 'STORE'   then com.cmd := _STORE;
  if cm = 'ADD'     then com.cmd := _ADD;
  if cm = 'SUB'     then com.cmd := _SUB;
  if cm = 'MULT'    then com.cmd := _MULT;
  if cm = 'DIV'     then com.cmd := _DIV;
  if cm = 'READ'    then com.cmd := _READ;
  if cm = 'WRITE'   then com.cmd := _WRITE;
  if cm = 'JUMP'    then com.cmd := _JUMP;
  if cm = 'JGTZ'    then com.cmd := _JGTZ;
  if cm = 'JZERO'   then com.cmd := _JZERO;
  if cm = 'HALT'    then com.cmd := _HALT;
  com.o := serv;
  com.v := v;
end;

procedure docommand (var cur: longint);
begin
  with com[cur] do
  case cmd of
  _LOAD :begin
           if o = '=' then c [0] := v;
           if o = #0 then c [0] := c [v];
           if o = '*' then c [0] := c [c [v]];
           inc (cur);
         end;
  _STORE:begin
           if o = #0 then c [v] := c [0];
           if o = '*' then c [c [v]] := c [0];
           inc (cur);
         end;
  _ADD  :begin
           if o = '=' then c [0] := c [0] + v;
           if o = #0 then c [0] := c [0] + c [v];
           if o = '*' then c [0] := c [0] + c [c [v]];
           inc (cur);
         end;
  _SUB  :begin
           if o = '=' then c [0] := c [0] - v;
           if o = #0 then c [0] := c [0] - c [v];
           if o = '*' then c [0] := c [0] - c [c [v]];
           inc (cur);
         end;
  _MULT :begin
           if o = '=' then c [0] := c [0] * v;
           if o = #0 then c [0] := c [0] * c [v];
           if o = '*' then c [0] := c [0] * c [c [v]];
           inc (cur);
         end;
  _DIV  :begin
           if o = '=' then c [0] := c [0] div v;
           if o = #0 then c [0] := c [0] div c [v];
           if o = '*' then c [0] := c [0] div c [c [v]];
           inc (cur);
         end;
  _READ :begin
           if o = #0 then read (c [v]);
           if o = '*' then read (c [c [v]]);
           inc (cur);
         end;
  _WRITE:begin
           if o = '=' then writeln (v);
           if o = #0 then writeln (c [v]);
           if o = '*' then writeln (c [c [v]]);
           inc (cur);
         end;
  _JUMP :cur := v;
  _JGTZ :if c [0] > 0 then cur := v else inc (cur);
  _JZERO:if c [0] = 0 then cur := v else inc (cur);
  _HALT :begin close (output); halt(0); end;
  end;
end;

begin
  assign (input, probname+'.in');
  reset (input);
  assign (output, probname+'.out');
  rewrite (output);
  readln (n, m);
  for i := 0 to n-1 do
    getcommand (com [i]);
  i := 0;
  while true do
    docommand (i);
  close (input);
  close (output);
end.
