{$I-,Q-,R-,S-}
{$D-}

const
  MAXN = 100;

type
  Integer = Longint;

  TArray = array[0..MAXN] of Integer;

var
  n: Integer;
  b: array[1..MAXN] of Integer;
  s, MaxS: TArray;
  MaxSum: Extended;

procedure Init();
var
  i: Integer;
begin
  Assign(Input, 'sin.in');
  Reset(Input);
  Assign(Output, 'sin.out');
  Rewrite(Output);

  Read(n);
  for i := 1 to n do Read(b[i]);
end;

procedure Calc();
var
  i: Integer;
  Sum: Extended;
begin
  if s[0] < 2 then Exit;

  Sum := 0;
  for i := 2 to s[0] do
    Sum := Sum + Sin(i * b[i - 1] * s[i - 1] * s[i]);
  Sum := Sum / s[0];

  if Sum > MaxSum then
  begin
    MaxSum := Sum;
    MaxS := s;
  end;
end;

procedure Rec(const k: Integer);
var
  i: Integer;
begin
  if (k = 0) then
  begin
    Calc();
    Exit;
  end;

  for i := 1 to k do
  begin
    Inc(s[0]);
    s[s[0]] := i;
    Rec(k - i);
    Dec(s[0]);
  end;
end;

procedure Solve();
begin
  Rec(n);
end;

procedure Done();
var
  i: Integer;
begin
  Writeln(MaxSum:0:10);
  for i := 1 to MaxS[0] do Write(MaxS[i], ' ');

  Close(Input);
  Close(Output);
end;

begin
  Init();
  Solve();
  Done();
end.

