{$I-,Q-,R-,S-}
const
  MAXK = 30005;
  MAXN = 1000000;

type
  Integer = Longint;
  TArray = array[0..MAXK] of record
    l, r: Integer;
  end;
  PArray = ^TArray;

var
  White: Boolean;
  Seg: array[1..MAXK] of Integer;
  a: array[0..MAXN] of PArray;
  m, n: Integer;
  k: Integer;
  Cur, Len: Integer;
  Count: Integer;

procedure Init();
var
  Tmp, i: Integer;
begin
  Assign(Input, 'rle.in');
  Reset(Input);
  Assign(Output, 'rle.out');
  Rewrite(Output);

  Read(m, n);
  Read(Tmp);
  White := Tmp = 0;

  Read(k);
  for i := 1 to k do Read(Seg[i]);
  Cur := 1;
end;

procedure MakeStr(const i: Integer);
var
  Link: Integer;
begin
  Len := 0;
  Link := 0;
  while (Len < m) do
  begin
    if Cur > k then Exit;
    if not White then
    begin
      if Len + Seg[Cur] > m then
      begin
        Inc(Link);
        a[i]^[Link].l := Len + 1;
        a[i]^[Link].r := m;
        Dec(Seg[Cur], m - Len);
        Len := m;
        a[i]^[0].l := Link;
        Exit;
      end else
      begin
        Inc(Link);
        a[i]^[Link].l := Len + 1;
        a[i]^[Link].r := Len + Seg[Cur];
        Len := a[i]^[Link].r;
      end;
    end else
    begin
      Inc(Len, Seg[Cur]);
    end;
    White := not White;
    Inc(Cur);
  end;
  a[i]^[0].l := Link;
end;

procedure Intersect(const a1, a2: PArray);
var
  l1, l2: Integer;
  Per: Boolean;
begin
  l1 := 1;
  l2 := 1;
  Per := False;

  while (l1 <= a1^[0].l) and (l2 <= a2^[0].l) do
  begin
    if a1^[l1].r + 1 < a2^[l2].l then Inc(l1) else
      if a2^[l2].r + 1 < a1^[l1].l then
      begin
        Inc(l2);
        if not Per then Inc(Count);
        Per := False;
      end else
      begin
        Per := True;
        Inc(l2);

      end;
  end;

  if l2 <= a2^[0].l then Inc(Count, a2^[0].l - l2 + 1);
end;

procedure Solve();
var
  i: Integer;
begin
  New(a[0]);
  New(a[1]);

  for i := 2 to n do
    a[i] := a[i mod 2];

  MakeStr(0);
  Count := a[0]^[0].l;
  for i := 2 to n do
  begin
    MakeStr(i - 1);
    Intersect(a[i - 2], a[i - 1]);
  end;
end;

procedure Done();
begin
  Writeln(Count);

  Close(Input);
  Close(Output);
end;

begin
  Init();
  Solve();
  Done();
end.