{$I-,Q-,R-,S-}
{$D-}

const
  MAXN = 50005;
  MAXM = 50005;

type
  Integer = Longint;

  TPoint = record
    x, y: Integer;
  end;

var
  n, m: Integer;
  Base: array[1..MAXN] of TPoint;
  Cry: array[1..MAXM] of TPoint;

procedure Init();
var
  i: Integer;
begin
  Assign(Input, 'rescue.in');
  Reset(Input);
  Assign(Output, 'rescue.out');
  Rewrite(Output);

  Read(n, m);

  for i := 1 to n do
    Read(Base[i].x, Base[i].y);

  for i := 1 to m do
    Read(Cry[i].x, Cry[i].y);

end;

function Len(const p1, p2: TPoint): Integer;
begin
  Len := Sqr(p1.x - p2.x) + Sqr(p1.y - p2.y);
end;

procedure Solve();
var
  i, j, Tmp, Min, k: Integer;
begin
  for i := 1 to m do
  begin
    Min := Len(Cry[i], Base[1]);
    k := 1;
    for j := 2 to n do
    begin
      Tmp := Len(Cry[i], Base[j]);
      if Tmp < Min then
      begin
        Min := Tmp;
        k := j;
      end;
    end;
    Writeln(Base[k].x, ' ', Base[k].y);
  end;
end;

procedure Done();
begin
  Close(Input);
  Close(Output);
end;

begin
  Init();
  Solve();
  Done();
end.

