{$I-,Q-,R-,S-}

const
  MAXN = 1005;

type
  Integer = Longint;

var
  a: array[1..MAXN, 1..MAXN] of Integer;
  n, c, k: Integer;
  Count: array[1..MAXN] of Integer;
  Vit: array[1..MAXN] of Integer;
  Ans: Integer;

procedure Init();
var
  i, t1, t2: Integer;
begin
  Assign(Input, 'elevator.in');
  Reset(Input);
  Assign(Output, 'elevator.out');
  Rewrite(Output);

  Read(n, c, k);

  for i := 1 to k do
  begin
    Read(t1, t2);
    Inc(a[t1, t2]);
    Inc(Count[t1]);
  end;
end;

function Min(const a, b: Integer): Integer;
begin
  if a < b then Min := a else Min := b;
end;

procedure Solve();
var
  i, j, Sum, t, v, cg, q: Integer;
  Must: Boolean;
begin
  cg := 0;
  t := 1;
  v := 1;

  while True do
  begin
    if cg = 0 then
    begin
      Must := False;
      for i := 1 to n do if Count[i] > 0 then Must := True;
      if not Must then
      begin
        Inc(Ans, 5 * (t - 1));
        Break;
      end;
    end;

    if Vit[t] > 0 then
    begin
      Dec(cg, Vit[t]);
      Vit[t] := 0;
    end;

    if v = 1 then
    begin
      for i := n downto t + 1 do if a[t, i] > 0 then
      begin
        q := Min(c - cg, a[t, i]);
        Dec(a[t, i], q);
        Inc(cg, q);
        Dec(Count[t], q);
        Inc(Vit[i], q);
        if c = cg then Break;
      end;

      if (cg = 0) then
      begin
        Must := False;
        for i := t + 1 to n do if Count[i] > 0 then Must := True;
        if not Must then
        begin
          v := -1;
          Continue;
        end;
      end;

      Inc(t);
      Inc(Ans, 5);
    end else
    begin
      for i := 1 to t - 1 do if a[t, i] > 0 then
      begin
        q := Min(c - cg, a[t, i]);
        Dec(a[t, i], q);
        Inc(cg, q);
        Dec(Count[t], q);
        Inc(Vit[i], q);
        if c = cg then Break;
      end;

      if (cg = 0) then
      begin
        Must := False;
        for i := t - 1 downto 1 do if Count[i] > 0 then Must := True;
        if not Must then
        begin
          v := 1;
          Continue;
        end;
      end;

      Dec(t);
      Inc(Ans, 5);
    end;
  end;

end;

procedure Done();
begin
  Writeln(Ans);

  Close(Input);
  Close(Output);
end;

begin
  Init();
  Solve();
  Done();
end.
