{$I-,Q-,R-,S-}
{$D-}

const
  MAXV = 3000000;

type
  Integer = Longint;

  TVertex = record
    NNew: Boolean;
    Order: Word;
  end;

  PList = ^TList;
  TList = record
    k: Integer;
    c: Char;
    Next: PList;
  end;

var
  Links: array[0..MAXV] of PList;
  a: array[1..MAXV] of TVertex;
  Count: Integer;
  Answer: Integer;
  s: AnsiString;

procedure Init();
begin
  Assign(Input, 'prof.in');
  Reset(Input);
  Assign(Output, 'prof.out');
  Rewrite(Output);
  Readln(s);
end;

function Find(const v: Integer; const c: Char): Integer;
var
  Cur: PList;
begin
  Cur := Links[v];
  while (Cur <> nil) do
  begin
    if Cur^.c = c then
    begin
      Find := Cur^.k;
      Exit;
    end;

    Cur := Cur^.Next;
  end;

  Find := 0;
end;

procedure AddLink(const v1: Integer; const c: Char; const v2: Integer);
var
  Tmp: PList;
begin
  New(Tmp);
  Tmp^.k := v2;
  Tmp^.c := c;
  Tmp^.Next := Links[v1];
  Links[v1] := Tmp;
end;

procedure Add(l, r, o: Integer);
var
  v, vn: Integer;
  Len: Integer;
begin
  v := 0;
  Len := 1;

  while l <= r do
  begin
    vn := Find(v, s[l]);
    if vn > 0 then
    begin
      v := vn;
      if not a[v].NNew and (o - a[v].Order >= Len) then
      begin
        Inc(Answer);
        a[v].NNew := True;
      end;
    end else
    begin
      Inc(Count);
      AddLink(v, s[l], Count);
      v := Count;
      a[v].Order := o;
    end;

    Inc(l);
    Inc(Len);
  end;
end;

procedure Solve();
var
  i: Integer;
begin
  for i := 1 to Length(s) do Add(i, Length(s), i);
end;

procedure Done();
begin
  Writeln(Answer);

  Close(Input);
  Close(Output);
end;

begin
  Init();
  Solve();
  Done();
end.
