{$R-,Q-,S-}
Program customs;
type
  smallint=integer;
  integer=longint;
  TRoad=record
    a,b:integer;
    c:int64;
  end;
  TCost=object
    cs:array[1..3,//i,i-th < any of x,i
             1..3
            ]of int64;
    procedure Add(c:int64);
    procedure Unite(var c:TCost);
    procedure Init(c:integer);
    function More(var c:TCost):boolean;
  end;
  PNode=^TNode;
  TNode=record
    key:integer;
    left,right:PNode;
  end;
  procedure TCost.Add(c:int64);
  var i,j,min:integer;
    s:TCost;
  begin
    for i:=1 to 3 do begin
      if (cs[i,2]>=0)and((cs[i,3]=-1)or(cs[i,3]<cs[i,2]+c))then
        cs[i,3]:=cs[i,2]+c;
      if (cs[i,1]>=0)and((cs[i,2]=-1)or(cs[i,2]<cs[i,1]+c))then
        cs[i,2]:=cs[i,1]+c;
      if ((cs[i,1]=-1)or(cs[i,1]<c))then
        cs[i,1]:=c;
    end;
    for i:=1 to 3 do begin
      for j:=1 to 3 do
        if (j=1)or(s.cs[min,i]>s.cs[j,i]) then
          min:=j;
      for j:=1 to 3 do s.cs[i,j]:=s.cs[min,j];
    end;
  end;

  procedure TCost.Unite(var c:TCost);
  var i,j:integer;
  begin
    for i:=1 to 3 do
      if (cs[i,i]=-1)or(cs[i,i]>c.cs[i,i]) then
        for j:=1 to 3 do cs[i,j]:=c.cs[i,j];
  end;

  procedure TCost.Init(c:integer);
  var i,j:integer;
  begin
    for i:=1 to 3 do
      for j:=1 to 3 do
        cs[i,j]:=c;
  end;

  function TCost.More(var c:TCost):boolean;
  var i:integer;
  f:boolean;
  begin
    f:=false;
    for i:=1 to 3 do
      f:=f or ((cs[i,i]>=c.cs[i,i])and(c.cs[i,i]>0));
    More:=f;
  end;

var
  n,m,i,j:integer;
  c:int64;
  r:array[1..200000]of TRoad;
  t:TRoad;
  my:TCost;
  min:int64;
  start,finish,last,d,k1,k2,k3:integer;
  st,fn:array[1..10000]of integer;
  fr:array[1..10000]of boolean;
  s:array[1..10000]of TCost;

var
  root:PNode;
  value:integer;

  procedure Insert(var root:PNode);
  begin
    if root=nil then
      begin
        new(root);
        root^.left:=nil;
        root^.right:=nil;
        root^.key:=value;
      end
    else
      if s[root^.key].More(s[value]) then
        Insert(root^.left)
      else
      if s[value].More(s[root^.key]) then
        Insert(root^.right);
  end;

  function DeleteLeft(var root:PNode):integer;
  var p:PNode;
  begin
    if root^.left=nil then
      begin
        p:=root^.right;
        DeleteLeft:=root^.key;
        dispose(root);
        root:=p;
      end
    else
      DeleteLeft:=DeleteLeft(root^.left);
  end;


  procedure Delete(var root:PNode);
  var p:PNode;
  begin
    if root=nil then exit;
    if root^.key=value then begin
      if root^.left=nil then begin
        p:=root^.right;
        dispose(root);
        root:=p;
      end else
      if root^.right=nil then begin
        p:=root^.left;
        dispose(root);
        root:=p;
      end else
        root^.key:=DeleteLeft(root);
    end else
    if s[root^.key].More(s[value]) then Delete(root^.left)
    else {if s[value].More(s[root^.key]) then} Delete(root^.right);
  end;



procedure SortR(l,rr:integer);
var i:integer;
begin
  i:=l;
  j:=rr;
  k1:=r[(i+j)div 2].a;
  k2:=r[(i+j)div 2].b;
  k3:=r[(i+j)div 2].c;
  repeat
    while (r[i].a<k1)or(r[i].a=k1)and
      ((r[i].b<k2)or(r[i].b=k2)and(r[i].c<k3)) do inc(i);
    while (r[j].a>k1)or(r[j].a=k1)and
      ((r[j].b>k2)or(r[j].b=k2)and(r[j].c>k3)) do dec(j);
    if i<=j then begin
      t:=r[i];
      r[i]:=r[j];
      r[j]:=t;
      inc(i);
      dec(j);
    end;
  until i>j;
  if l<j then SortR(l,j);
  if i<rr then SortR(i,rr);
end;


var p:PNode;
procedure GoOn;
begin
  readln(n,m);
  for i:=1 to m do begin
    readln(r[i*2].a,r[i*2].b,c);
    r[i*2-1].a:=r[i*2].b;
    r[i*2-1].b:=r[i*2].a;
    r[i*2].c:=c;
    r[i*2-1].c:=r[i*2].c;
  end;
  m:=2*m;
  SortR(1,m);
  for i:=1 to m do
    begin
      value:=r[i].b;
      Insert(root);
    end;
//  for value:=1 to n do Insert(root);
  d:=0;
  for i:=2 to m do
    if (r[i].a=r[i-1].a)and(r[i].b=r[i-1].b) then
      inc(d)
    else
      r[i-d]:=r[i];
  m:=m-d;
  last:=r[1].a;
  for i:=1 to r[1].a-1 do st[i]:=0;
  st[r[1].a]:=1;
  for i:=2 to m do begin
    if r[i].a>last then begin
      for j:=last+1 to r[i].a-1 do st[j]:=0;
      fn[last]:=i-1;
      last:=r[i].a;
      st[last]:=i;
    end;
  end;
  fn[last]:=m;
  for i:=1 to n do begin
    fr[i]:=true;
    s[i].init(-1);
  end;
  readln(start,finish);
  for j:=1 to n do begin
    if j=1 then
      min:=start
    else begin
      min:=-1;
{      for i:=1 to n do
        if (fr[i])and((min<0)or(s[min].more(s[i]))) then
          min:=i;}
      p:=root;
      if p=nil then break;
      while (p^.left<>nil) do
        p:=p^.left;
      min:=p^.key;
    end;
    fr[min]:=false;
    value:=min;
    Delete(root);
    if st[min]<>0 then
      for i:=st[min] to fn[min] do
       if fr[r[i].b] then
        begin
          my:=s[min];
          my.Add(r[i].c);
          value:=r[i].b;
          Delete(root);
          s[r[i].b].Unite(my);
          value:=r[i].b;
          Insert(root);
        end;
  end;
  min:=-1;
  for i:=1 to 3 do begin
    j:=3;
    while (j>0)and(s[finish].cs[i,j]=-1) do dec(j);
    if (j>0)and((min=-1)or(min>s[finish].cs[i,j])) then
      min:=s[finish].cs[i,j];
  end;
  writeln(min);
end;

begin
  assign(input,'customs.in');
  reset(input);
  assign(output,'customs.out');
  rewrite(output);
  root:=nil;
  GoOn;
  close(input);
  close(output);
end.
