Program ram;


var
  reg,com,arg,ct:array[0..70000]of -32768..32767;

procedure Load;
var
  m,n,i:integer;
  ch:char;
  s:string[10];
  sign:boolean;
begin
  readln(m,n);
  for i:=0 to m-1 do begin
    ch:=#0;
    s:='';
    while not eoln and (ch<>' ') do begin
      read(ch);
      if ch=' ' then break;
      s:=s+UpCase(ch);
    end;
    if s='LOAD' then com[i]:=1 else
    if s='STORE' then com[i]:=2 else
    if s='ADD' then com[i]:=3 else
    if s='SUB' then com[i]:=4 else
    if s='MULT' then com[i]:=5 else
    if s='DIV' then com[i]:=6 else
    if s='READ' then com[i]:=7 else
    if s='WRITE' then com[i]:=8 else
    if s='JUMP' then com[i]:=9 else
    if s='JGTZ' then com[i]:=10 else
    if s='JZERO' then com[i]:=11 else
    if s='HALT' then com[i]:=12 else
      begin
        writeln('Unknown command at ',i);
        halt;
      end;
    if com[i]<>12 then begin
      while ch=' ' do read(ch);
      case ch of
        '=':begin
          ct[i]:=0;
          read(ch);
        end;
        '*':begin
          ct[i]:=2;
          read(ch);
        end;
        else ct[i]:=1;
      end;
      sign:=ch='-';
      if sign then read(ch);
      arg[i]:=ord(ch)-ord('0');
      while not eoln do begin
        read(ch);
        arg[i]:=arg[i]*10+ord(ch)-ord('0');
      end;
      if sign then arg[i]:=-arg[i];
    end;
    readln;
  end;
end;

var
  ip:integer;

function trg(ct,arg:integer):integer;
begin
  case ct of
    0:begin
      writeln('Using constant as destination object at ',ip);
      halt;
    end;
    1:trg:=arg;
    2:trg:=reg[arg];
    else
      begin
        writeln('Unknown EA type at ',ip);
        halt;
      end;
  end;
end;

function val(ct,arg:integer):integer;
begin
  if ct=0 then
    val:=arg
  else
    val:=reg[trg(ct,arg)];
end;
{$Q-,R-,S-,B-}
procedure GoOn;
begin
  ip:=0;
  while com[ip]<>12 do begin
    case com[ip] of
      1:reg[0]:=val(ct[ip],arg[ip]);
      2:reg[trg(ct[ip],arg[ip])]:=reg[0];
      3:reg[0]:=reg[0]+val(ct[ip],arg[ip]);
      4:reg[0]:=reg[0]-val(ct[ip],arg[ip]);
      5:reg[0]:=reg[0]*val(ct[ip],arg[ip]);
      6:reg[0]:=reg[0] div val(ct[ip],arg[ip]);
      7:read(reg[trg(ct[ip],arg[ip])]);
      8:writeln(val(ct[ip],arg[ip]));
      9:begin
        ip:=arg[ip];
        continue;
      end;
      10:if reg[0]>0 then
        begin
          ip:=arg[ip];
          continue;
        end;
      11:if reg[0]=0 then
        begin
          ip:=arg[ip];
          continue;
        end;
    end;
    inc(ip);
  end;//while
end;

begin
  assign(input,'ram.in');
  reset(input);
  assign(output,'ram.out');
  rewrite(output);
  Load;
  GoOn;
  close(input);
  close(output);
end.