{$A+,B-,D-,E-,F-,G+,I-,L-,N-,O+,P-,Q-,R-,S-,T-,V+,X+,Y+}
   Const File_In='customs.in';
         File_Out='customs.out';
         MaxN=10000;
         MaxM=100000;
         Infinity=MaxLongInt Div 2;
   Type Int=LongInt;
   Var A,B,N,M,SizeHeap : Int;
       R,R2 : Array [1..2*MaxM] Of Record
                                     A,B : Int;
                                     Price : Int64;
                                   End;
       Count : Array [1..MaxN+1] Of Int;
       D : Array [0..MaxN*2+1] Of Record
                                  D : Int64;
                                  Num : Int;
                                  R : Array [0..4] Of Int64;
                                End;
       Num : Array [1..MaxN*2+1] Of Int;

Procedure OpenFiles;
Begin
  Assign(Input,File_In);
  ReSet(Input);
  Assign(Output,File_Out);
  ReWrite(Output);
End;

Procedure Init;
  Var I,Price : Int;
Begin
  FillChar(Count,SizeOf(Count),0);
  Read(N,M);
  For I :=1 To M Do
    Begin
      Read(R[I].A,R[I].B,Price);
      R[I].Price :=Price;
      R[I+M].A :=R[I].B;
      R[I+M].B :=R[I].A;
      R[I+M].Price :=R[I].Price;
      Inc(Count[R[I].A]);
      Inc(Count[R[I].B]);
    End;
  M :=M*2;
  Read(A,B);
  Inc(Count[1]);
  For I :=2 To N+1 Do
    Inc(Count[I],Count[I-1]);
  R2 :=R;
  For I :=1 To M Do
    Begin
      Dec(Count[R2[I].A]);
      R[Count[R2[I].A]] :=R2[I];
    End;
End;

Procedure Swap(Var A,B : Int64);
  Var C : Int64;
Begin
  C :=A;
  A :=B;
  B :=C;
End;

Procedure ChangeKey(Const I,R : Int);
  Var Now : Int;
Begin
  Inc(D[Num[I]].D,R);
  Now :=0;
  D[Num[I]].R[0] :=R;
  While D[Num[I]].R[Now]>D[Num[I]].R[Now+1] Do
    Begin
      Swap(D[Num[I]].R[Now],D[Num[I]].R[Now+1]);
      Inc(Now);
    End;
  Dec(D[Num[I]].D,D[Num[I]].R[0]);
  Now :=Num[I];
  While Now>1 Do
    Begin
      If D[Now].D<D[Now Div 2].D Then
        Begin
          D[0] :=D[Now];
          D[Now] :=D[Now Div 2];
          D[Now Div 2] :=D[0];
          Num[D[Now].Num] :=Now;
          Num[D[Now Div 2].Num] :=Now Div 2;
          Now :=Now Div 2;
        End
      Else Break;
    End;
End;

Function ExtractMin : Int;
  Var Now : Int;
Begin
  ExtractMin :=D[1].Num;
  D[0] :=D[1];
  D[1] :=D[SizeHeap];
  D[SizeHeap] :=D[0];
  Num[D[1].Num] :=1;
  Num[D[SizeHeap].Num] :=SizeHeap;
  Dec(SizeHeap);
  Now :=1;
  While Now<SizeHeap Do
    Begin
      If D[Now*2].D>D[Now*2+1].D Then
        If (D[Now].D>D[Now*2+1].D) And (Now*2+1<=SizeHeap) Then
          Begin
            D[0] :=D[Now];
            D[Now] :=D[Now*2+1];
            D[Now*2+1] :=D[0];
            Num[D[Now].Num] :=Now;
            Num[D[Now*2+1].Num] :=Now*2+1;
            Now :=Now*2+1;
          End
        Else Break
      Else
        If (D[Now].D>D[Now*2].D) And (Now*2<=SizeHeap) Then
          Begin
            D[0] :=D[Now];
            D[Now] :=D[Now*2];
            D[Now*2] :=D[0];
            Num[D[Now].Num] :=Now;
            Num[D[Now*2].Num] :=Now*2;
            Now :=Now*2;
          End
        Else Break
    End;
End;

Function GetR(Const I,R : Int) : Int;
  Var Now,P : Int;
Begin
  P :=D[Num[I]].D+R;
  D[Num[I]].R[0] :=R;
  Now :=0;
  While R>D[Num[I]].R[Now+1] Do
    Inc(Now);
  Dec(P,D[Num[I]].R[Now]);
  GetR :=P;
End;

Procedure Solve;
  Var I,J,Min : Int;
Begin
  FillChar(D,SizeOf(D),0);
  SizeHeap :=N;
  For I :=1 To 2*N+1 Do
    Begin
      D[I].D :=Infinity;
      D[I].R[4] :=Infinity;
      Num[I] :=I;
      D[I].Num :=I;
    End;
  D[1].D :=0;
  D[1].Num :=A;
  Num[A] :=1;
  Num[1] :=A;
  D[A].Num :=1;
  For I :=1 To N Do
    Begin
      Min :=ExtractMin;
      For J :=Count[Min] To Count[Min+1]-1 Do
        If GetR(Min,R[J].Price)<D[Num[R[J].B]].D Then
          Begin
            D[Num[R[J].B]].R :=D[Num[Min]].R;
            D[Num[R[J].B]].D :=D[Num[Min]].D;
            ChangeKey(R[J].B,R[J].Price);
          End;
      If Min=B Then Break;
    End;
  WriteLn(D[Num[B]].D);
End;

Procedure CloseFiles;
Begin
  Close(Input);
  Close(Output);
End;

Begin
  OpenFiles;
  Init;
  Solve;
  CloseFiles;
End.
