{$A+,B-,D-,E-,F-,G+,I-,L-,N+,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}
   Const File_In='sin.in';
         File_Out='sin.out';
         MaxN=101;
         Infinity=MaxLongInt Div 2;
   Type Int=LongInt;
        Real=Extended;
   Var Answer : Array [0..MaxN,0..MaxN,0..MaxN] Of Record
                                                     Num : Real;
                                                     From : Int;
                                                   End;
       AnswerWrite,B : Array [1..MaxN] Of Int;
       N : Int;

Procedure OpenFiles;
Begin
  Assign(Input,File_In);
  ReSet(Input);
  Assign(Output,File_Out);
  ReWrite(Output);
End;

Procedure Init;
  Var I : Int;
Begin
  Read(N);
  For I :=1 To N Do
    Read(B[I]);
End;

Function Max(Const A,B : Real) : Real;
Begin
  If A>B Then Max :=A
  Else Max :=B;
End;

Procedure Solve;
   Var I,J,K,L : Int;
       Ans : Real;
       AnsK,AnsLast,AnsSum : Int;
Begin
  For I :=0 To N Do
    For J :=0 To N Do
      If I<>J Then
        Answer[0,I,J].Num :=-Infinity
      Else Answer[0,I,J].Num :=0;
  For I :=1 To N Do
    For J :=0 To N Do
      For K :=0 To N Do
        Answer[I,J,K].Num :=-Infinity;
  For I :=0 To N-2 Do
    For J :=I+1 To N-1 Do
      For K :=1 To J-I Do
        If Answer[I,J,K].Num<>-Infinity Then
          For L :=1 To N-J Do
            If Answer[I+1,J+L,L].Num<Answer[I,J,K].Num+Sin((I+2)*B[I+1]*L*K) Then
              Begin
                Answer[I+1,J+L,L].Num :=Answer[I,J,K].Num+Sin((I+2)*B[I+1]*L*K);
                Answer[I+1,J+L,L].From :=K;
              End;
  Ans :=-Infinity;
  AnsSum :=N;
  For I :=1 To N-1 Do
    For J :=1 To N Do
      If Ans<Answer[I,N,J].Num/(I+1) Then
        Begin
          Ans :=Answer[I,N,J].Num/(I+1);
          AnsLast :=J;
          AnsK :=I;
        End;
  WriteLn(Ans:0:7);
  For I :=AnsK DownTo 1 Do
    Begin
      AnswerWrite[I+1] :=AnsLast;
      AnsLast :=Answer[I,AnsSum,AnsLast].From;
      Dec(AnsSum,AnswerWrite[I+1]);
    End;
  AnswerWrite[1] :=AnsSum;
  For I :=1 To AnsK+1 Do
    Write(AnswerWrite[I],' '); 
end;

Procedure CloseFiles;
Begin
  Close(Input);
  Close(Output);
End;

Begin
  OpenFiles;
  Init;
  Solve;
  CloseFiles;
End.
