 {$A+,B-,D-,E-,F-,G+,I-,L-,N-,O+,P-,Q-,R-,S-,T-,V+,X+,Y+}
   Const File_In='ram.in';
         File_Out='ram.out';
         MaxR=1000;
         MaxN=1000;
         MaxM=1000;
   Type Int=Integer;
   Var C : Array [0..MaxR-1] Of Int;
       Commands : Array [0..MaxM] Of Record
                                       S : String[5];
                                       Param : String[6];
                                       P : Int;
                                     End;
       Nums : Array [0..MaxN] Of Int;
       M,N : Int;

Procedure OpenFiles;
Begin
  Assign(Input,File_In);
  ReSet(Input);
  Assign(Output,File_Out);
  ReWrite(Output);
End;

Procedure Init;
  Var Error,I : Int;
      Sym : Char;
      HelpS : String[6];
Begin
  Read(M,N);
  For I :=0 To M-1 Do
    Begin
      Read(Sym);
      While Not (Sym In ['A'..'Z']) Do Read(Sym);
      Commands[I].S :='';
      Commands[I].Param :='';
      While Sym In ['A'..'Z'] Do
        Begin
          Commands[I].S :=Commands[I].S+Sym;
          Read(Sym)
        End;
      If Commands[I].S<>'HALT' Then
        Begin
          While Not (Sym In ['0'..'9','*','=']) Do Read(Sym);
          While Sym In ['0'..'9','*','='] Do
            Begin
              Commands[I].Param :=Commands[I].Param+Sym;
              Read(Sym);
            End;
          HelpS :=Commands[I].Param;
          If (HelpS[1]='=') Or (HelpS[1]='*') Then
            Begin
              Delete(HelpS,1,1);
              Val(HelpS,Commands[I].P,Error);
            End
          Else Val(HelpS,Commands[I].P,Error);
        End;
    End;
  Nums[0] :=0;
  For I :=1 To N Do
    Read(Nums[I]);
End;

Function Get(Const I : Int) : Int;
  Var Error : Int;
Begin
  If Commands[I].Param[1]='=' Then
    Get :=Commands[I].P
  Else
    If Commands[I].Param[1]='*' Then
      Get :=C[C[Commands[I].P]]
    Else
      Get :=C[Commands[I].P];
End;

Procedure Solve;
  Var Count : Int;
Begin
  Count :=0;
  While True Do
    Begin
      If Commands[Count].S[1]='J' Then
        If Commands[Count].S[2]='U' Then
          Begin
            Count :=Commands[Count].P;
            Continue;
          End
        Else
          If Commands[Count].S[2]='G' Then
            If C[0]>0 Then
               Begin
                 Count :=Commands[Count].P;
                 Continue;
               End
            Else
          Else
            If C[0]=0 Then
               Begin
                 Count :=Commands[Count].P;
                 Continue;
               End
            Else
      Else
        If Commands[Count].S[1]='L' Then
          C[0] :=Get(Count)
        Else If Commands[Count].S[1]='A' Then
               C[0] :=C[0]+Get(Count)
        Else If (Commands[Count].S[1]='S') Then
               If (Commands[Count].S[2]='U') Then
                  C[0] :=C[0]-Get(Count)
               Else
                 If Commands[Count].Param[1]='*' Then
                   C[C[Commands[Count].P]] :=C[0]
                 Else C[Commands[Count].P] :=C[0]
        Else If Commands[Count].S[1]='M' Then
               C[0] :=C[0]*Get(Count)
        Else If Commands[Count].S[1]='D' Then
               C[0] :=C[0] Div Get(Count)
        Else If Commands[Count].S[1]='R' Then
               Begin
                 Inc(Nums[0]);
                 If Commands[Count].Param[1]='*' Then
                   C[C[Commands[Count].P]] :=Nums[Nums[0]]
                 Else
                   C[Commands[Count].P] :=Nums[Nums[0]];
               End
        Else If Commands[Count].S[1]='W' Then
               WriteLn(Get(Count))
        Else Break;
      Inc(Count);
    End;
End;

Procedure CloseFiles;
Begin
  Close(Input);
  Close(Output);
End;

Begin
  OpenFiles;
  Init;
  Solve;
  CloseFiles;
End.
