{$A+,B-,D-,E-,F-,G+,I-,L-,N-,O+,P-,Q-,R-,S-,T-,V+,X+,Y+}
   Const File_In='lcm.in';
         File_Out='lcm.out';
         MaxLen=5000;
         Osn=10000;
   Type Int=LongInt;
        TLong=Array [0..MaxLen] Of Int;
   Var LenW : Int;
       N : Int;
       Answer,B,NOK : TLong;

Procedure OpenFiles;
Begin
  Assign(Input,File_In);
  ReSet(Input);
  Assign(Output,File_Out);
  ReWrite(Output);
End;

Procedure WriteLong(Const A : TLong);
  Var I : Int;
      S : String;
Begin
  Write(A[A[0]]);
  For I :=A[0]-1 DownTo 1 Do
    Begin
      Str(A[I],S);
      While Length(S)<LenW Do
        S :='0'+S;
      Write(S);
    End;
End;

Function Less(Const A,B : TLong; Const S : int) : Boolean;
  Var I : Int;
Begin
  If A[0]<B[0]+S Then Less :=True
  Else If A[0]>B[0]+S Then Less :=False
  Else
    Begin
      Less :=False;
      For I := A[0] DownTo 1 Do
        If A[I]<B[I-S] Then
          Begin
            Less :=True;
            Exit
          End
        Else
        If B[I-S]<A[I] Then
          Begin
            Less :=False;
            Exit
          End
    End;
End;

Function More(Const A,B : TLong; Const S : Int) : Boolean;
  Var I : Int;
Begin
  If A[0]<B[0]+S Then More :=False
  Else If A[0]>B[0]+S Then More :=True
  Else
    Begin
      More :=False;
      For I := A[0] DownTo 1 Do
        If A[I]<B[I-S] Then
          Begin
            More :=False;
            Exit
          End
        Else
        If B[I-S]<A[I] Then
          Begin
            More :=True;
            Exit
          End
    End;
End;

Function Eq(Const A,B : TLong; Const S : Int) : Boolean;
  Var I : Int;
Begin
  If A[0]<>B[0]+S Then Eq :=False
  Else
    Begin
      For I :=1 To A[0] Do
        If A[I]<>B[I-S] Then
          Begin
            Eq :=False;
            Exit;
          End;
      Eq :=True;
    End
End;

Procedure ReadLong(Var A : TLong);
  Var I : Int;
      Sym : Char;
Begin
  FillChar(A,SizeOf(A),0);
  A[0] :=1;
  While Not SeekEoLn Do
    Begin
      Read(Sym);
      For I :=A[0] DownTo 1 Do
        Begin
          Inc(A[I+1],A[I]*10 Div Osn);
          A[I] :=A[I]*10 Mod Osn;
        End;
      If A[A[0]+1]>0 Then Inc(A[0]);
      Inc(A[1],Ord(Sym)-Ord('0'));
    End;
  ReadLn;
End;

Procedure MulLong(Var A : TLong; Const B : TLong);
  Var I,J,Help : Int;
      C : TLong;
Begin
  FillChar(C,SIzeOf(C),0);
  C[0] :=A[0]+B[0];
  For I :=1 To A[0] Do
    For J :=1 To B[0] Do
      Begin
        Help :=A[I]*B[J]+C[I+J-1];
        Inc(C[I+J],Help Div Osn);
        C[I+J-1] :=Help Mod Osn;
      End;
  While (C[0]>0) And (C[C[0]]=0) Do Dec(C[0]);
  A :=C;
End;

Procedure Div2(Var A : TLong);
  Var I,Ost : Int;
      B : TLong;
Begin
  FillChar(B,SizeOf(B),0);
  I :=A[0];
  Ost :=A[A[0]];
  While (Ost<2) And (I>0) Do
    Begin
      Dec(I);
      Ost :=Ost*Osn+A[I];
    End;
  B[0] :=I;
  While I>0 Do
    Begin
      B[I] :=Ost Div 2;
      Dec(I);
      Ost :=(Ost Mod 2)*Osn;
      If I>0 Then Inc(Ost,A[I]);
    End;
  A :=B;
End;

Procedure DivLong(Var A : TLong; Const B : TLong);
  Var I,J,L,Len,R : Int;
      C,CHelp : TLong;
Begin
  If Less(A,B,0) Then
    Begin
      FillChar(A,SizeOf(A),0);
      A[0] :=1;
      Exit;
    End
  Else
    If Eq(A,B,0) Then
      Begin
        FillChar(A,SizeOf(A),0);
        A[0] :=1;
        A[1] :=1;
        Exit;
      End;
  FillChar(C,SizeOf(C),0);
  I :=0;
  While More(A,B,I+1) Do Inc(I);
  Len :=I;
  C[0] :=1;
  C[0] :=Len+1;
  For I :=Len+1 DownTo 1 Do
    Begin
      L :=0;
      R :=Osn-1;
      While L+4<R Do
        Begin
          CHelp :=C;
          CHelp[I] :=(L+R) Div 2;
          MulLong(CHelp,B);
          If Less(A,CHelp,0) Then
            R :=(L+R) Div 2-1
          Else If More(A,CHelp,0) Then
            L :=(L+R) Div 2+1
          Else
            Begin
              L :=(L+R) Div 2;
              R :=L;
            End;
        End;
      For J :=L To R+1 Do
        Begin
          Fillchar(CHelp,SizeOf(CHelp),0);
          CHelp :=C;
          CHelp[I] :=J Mod Osn;
          MulLong(CHelp,B);
          If (R=Osn) Or Less(A,CHelp,0) Then
            Begin
              C[I] :=J-1;
              Break;
            End;
        End;
    End;
  A :=C;
End;

Procedure Swap(Var A,B : TLong);
  Var C : TLong;
Begin
  C :=A;
  A :=B;
  B :=C;
End;

Procedure Difference(Var A : TLong; Const B : TLong; Const S : Int);
  Var C : TLong;
      I,J : Int;
Begin
  C :=A;
  For I :=1 To B[0] Do
    Begin
      Dec(C[I+S],B[I]);
      J :=I+S;
      While C[J]<0 Do
        Begin
          Inc(C[J],Osn);
          Dec(C[J+1]);
          Inc(J);
        End;
    End;
  While (C[0]>0) And (C[C[0]]=0) Do Dec(C[0]);
  A :=C;
End;

Procedure NODLong(Const A,B : TLong; Var NOD : TLong);
  Var AH,BH : TLong;
      Help2 : TLong;
Begin
  FillChar(Nod,SizeOf(Nod),0);
  Help2[0] :=1;
  Help2[1] :=2;
  Nod[0] :=1;
  Nod[1] :=1;
  AH :=A;
  BH :=B;
  While Not Odd(AH[1]) And Not Odd(BH[1]) Do
    Begin
      MulLong(Nod,Help2);
      Div2(AH);
      Div2(BH);
    End;
  While Not Eq(AH,BH,0) Do
    Begin
      While Not Odd(AH[1]) Do Div2(AH);
      While Not Odd(BH[1]) Do Div2(BH);
      If Less(BH,AH,0) Then Swap(BH,AH);
      If Eq(AH,BH,0) Then Break;
      Difference(BH,AH,0);
    End;
  MulLong(Nod,AH);
End;

Procedure NOKLong(Var A : TLong; Const B : TLong);
  Var C,Nod : TLong;
Begin
  C :=A;
  NodLong(C,B,NOD);
  MulLong(C,B);
  DivLong(C,NOD);
  A :=C;
End;

Procedure Init;
  Var I : Int;
Begin
  LenW :=Round(Ln(Osn)/Ln(10));
  ReadLn(N);
  ReadLong(Answer);
  For I :=1 To N-1 Do
    Begin
      ReadLong(B);
      NokLong(Answer,B);
    End;
End;

Procedure Solve;
Begin
  WriteLong(Answer);
End;

Procedure CloseFiles;
Begin
  Close(Input);
  Close(Output);
End;

Begin
  OpenFiles;
  Init;
  Solve;
  CloseFiles;
End.
