{$A+,B-,D+,E-,F-,G+,I+,L+,N+,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}
{$M 16384,0,655360}
const
  fin= 'customs.in';
  fout='customs.out';
  inf=7e10;
  maxn=12000;
  maxm=120000;

var
  ans:extended;
  i,j,k,n,m,l,hs,s,t:longint;
  a,t1:array[0..maxm,1..2]of longint;
  ex,ext1:array[0..maxm]of extended;
  b:array[0..maxn]of longint;
  p,h:array[0..16*maxn]of longint;
  d:array[0..16*maxn]of extended;
  q:array[0..16*maxn,1..3]of extended;

procedure init;
begin
  assign(input,fin);
  reset(input);

    read(n,m);
    fillchar(b,sizeof(b),0);
    fillchar(a,sizeof(a),0);
    for i:=1 to m do
      read(a[i,1],a[i,2],ex[i]);
    read(s,t);
    for i:=1 to m do begin
      a[i+m,1]:=a[i,2];
      a[i+m,2]:=a[i,1];
      ex[i+m]:=ex[i];
    end;
    m:=2*m;
    for i:=1 to m do
      inc(b[a[i,1]]);
    for i:=1 to n do
      b[i]:=b[i]+b[i-1];
    t1:=a;
    ext1:=ex;
    fillchar(a,sizeof(a),0);
    for i:=1 to m do begin
      a[b[t1[i,1]]]:=t1[i];
      ex[b[t1[i,1]]]:=ext1[i];
      dec(b[t1[i,1]]);
    end;
    for i:=1 to n do
      inc(b[i]);
    b[n+1]:=m+1;

  close(output);
end;

procedure swap(i,j:longint);
var
  x:longint;
begin
  x:=h[i];
  h[i]:=h[j];
  h[j]:=x;
  p[h[i]]:=i;
  p[h[j]]:=j;
end;

procedure deckey(i:longint;nk:extended);
begin
  i:=p[i];
  d[h[i]]:=nk;
  while (i<>1)and(d[h[i]]<d[h[i div 2]]) do begin
    swap(i,i div 2);
    i:=i div 2;
  end;
end;

procedure push(i:longint);
begin
  if 2*i>hs then
    exit;
  if 2*i+1>hs then begin
    if d[h[2*i]]<d[h[i]] then
      swap(i,2*i);
    exit;
  end;

  if (d[h[2*i]]<d[h[i]])and(d[h[2*i]]<=d[h[2*i+1]]) then begin
    swap(i,2*i);
    push(2*i);
    exit;
  end;

  if (d[h[2*i+1]]<d[h[i]])and(d[h[2*i+1]]<=d[h[2*i]]) then begin
    swap(i,2*i+1);
    push(2*i+1);
    exit;
  end;
end;

function extractmin:longint;
begin
  extractmin:=h[1];
  swap(1,hs);
  dec(hs);
  push(1);
end;

function max(i,j:extended):extended;
begin
  if i>j then
    max:=i
  else
    max:=j;
end;

procedure solve;
var
  g,w,o,f:longint;
begin
  for i:=1 to 16*n+50 do
    d[i]:=inf;
  fillchar(q,sizeof(q),0);
  hs:=16*n;
  for i:=1 to 16*n do
    h[i]:=i+15;
  for i:=16 to 16*n+15 do
    p[i]:=i-15;
  deckey(16*s,0);
  repeat
    if hs=0 then
      break;
    k:=extractmin;

    l:=k mod 16;
    k:=k div 16;
    g:=l mod 4;
    if g<>3 then
      g:=1
    else
      g:=0;
    for i:=b[k] to b[k+1]-1 do begin
      if (l=0)and(d[16*a[i,2]+l+g]>d[16*k+l]) then begin
        deckey(16*a[i,2]+l+g,d[16*k+l]);
        w:=16*a[i,2]+l+g;
        q[w]:=q[16*k+l];
        for o:=3 downto 1 do
          if q[w,o]<ex[i] then begin
            for f:=1 to o-1 do
              q[w,f-1]:=q[w,f];
            q[w,o]:=ex[i];
            break;
          end;
      end;
      if d[16*a[i,2]+l+g]>d[16*k+l]-q[16*k,1]+max(q[16*k+l,1],ex[i]) then begin
        deckey(16*a[i,2]+l+g,d[16*k+l]-q[16*k+l,1]+max(q[16*k+l,1],ex[i]));
        w:=16*a[i,2]+l+g;
        q[w]:=q[16*k+l];
        for o:=3 downto 1 do
          if q[w,o]<ex[i] then begin
            for f:=1 to o-1 do
              q[w,f-1]:=q[w,f];
            q[w,o]:=ex[i];
            break;
          end;
      end;
      if l<12 then
        if d[16*a[i,2]+l+4+g]>d[16*k+l]+ex[i] then begin
          deckey(16*a[i,2]+l+4+g,d[16*k+l]+ex[i]);
          w:=16*a[i,2]+l+g+4;
          q[w]:=q[16*k+l];
          for o:=3 downto 1 do
            if q[w,o]<ex[i] then begin
              for f:=1 to o-1 do
                q[w,f-1]:=q[w,f];
              q[w,o]:=ex[i];
              break;
            end;
        end;
    end;
  until false;

  ans:=d[16*t+15];
  if ans>d[16*t+10] then
    ans:=d[16*t+10];
  if ans>d[16*t+5] then
    ans:=d[16*t+5];
end;

procedure done;
begin
  assign(output,fout);
  rewrite(output);

    write(ans:0:0);

  close(output);
end;

begin
  init;
  solve;
  done;
end.