{$A+,B-,D+,E-,F-,G-,I-,L+,N+,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}
{$M 16384,0,655360}
const
  fin= 'lcm.in';
  fout='lcm.out';
  maxp=4500;

type
  long=array[0..20000]of longint;

var
  p,b,c:array[0..maxp]of longint;
  a:array[0..3000]of longint;
  np,n,m,i,j,k,l:longint;
  ans,t1,t2,t3:long;

procedure init;
begin
  assign(input,fin);
  reset(input);

    read(n);
    for i:=1 to n do
      read(a[i]);

  close(output);
end;

procedure setshort(a:longint;var b:long);
begin
  fillchar(b,sizeof(b),0);
  b[0]:=1;
  b[1]:=a;
  while b[b[0]]>=10 do begin
    inc(b[0]);
    b[b[0]]:=b[b[0]-1]div 10;
    b[b[0]-1]:=b[b[0]-1]mod 10;
  end;
end;

procedure mult(var a,b,c:long);
var
  i,j:longint;
begin
  fillchar(c,sizeof(c),0);
  c[0]:=a[0]+b[0];
  for i:=1 to a[0] do
    for j:=1 to b[0] do begin
      inc(c[i+j-1],a[i]*b[j]);
      if c[i+j-1]>=10 then begin
        inc(c[i+j],c[i+j-1]div 10);
        c[i+j-1]:=c[i+j-1]mod 10;
      end;
    end;
  if c[c[0]]=0 then
    dec(c[0]);
end;

procedure solve;
begin
  np:=3;
  p[1]:=2;
  p[2]:=3;
  p[3]:=5;
  for i:=3 to 20000 do begin
    k:=i*2+1;
    l:=trunc(sqrt(k));
    for j:=1 to np do
      if (k mod p[j]=0)or(p[j]>l) then
        break;
    if k mod p[j]<>0 then begin
      inc(np);
      p[np]:=k;
    end;
  end;

  fillchar(c,sizeof(c),0);
  for k:=1 to n do begin
    fillchar(b,sizeof(b),0);
    for i:=1 to np do
      while a[k] mod p[i]=0 do begin
        a[k]:=a[k] div p[i];
        inc(b[i]);
      end;
    for i:=1 to np do
      if c[i]<b[i] then
        c[i]:=b[i];
  end;

  for i:=1 to n do
    for j:=i+1 to n do
      if a[i]>a[j] then begin
        a[i]:=a[i] xor a[j];
        a[j]:=a[i] xor a[j];
        a[i]:=a[i] xor a[j];
      end;


  ans[0]:=1;
  ans[1]:=1;
  for i:=1 to np do begin
    setshort(p[i],t1);
    for j:=1 to c[i] do begin
      t2:=ans;
      mult(t1,t2,ans);
    end;
  end;
  for i:=1 to n do
    if a[i]<>a[i-1] then begin
      setshort(a[i],t1);
      t2:=ans;
      mult(t1,t2,ans);
    end;
end;

procedure done;
begin
  assign(output,fout);
  rewrite(output);

    for i:=ans[0] downto 1 do
      write(ans[i]);

  close(output);
end;

begin
  init;
  solve;
  done;
end.
