program ZB;

{$APPTYPE CONSOLE}

type
  TEdge = record
    s, e, next: longint;
    c: longint;
  end;

  TMax=array [1..3] of longint;

var
  s, ind, nom: array [1..10000] of longint;
  h: array [1..10000] of longint;
  max: array [1..10000] of TMax;
  w: array [1..200002] of TEdge;
  i, j, x, y, N, M, hsize: longint;
  z: longint;
  t: TMax;

procedure Swap(i, j: integer);
var
  t64: longint;
  t: longint;
begin
  ind[nom[i]]:=j;
  ind[nom[j]]:=i;
  t:=nom[i];
  nom[i]:=nom[j];
  nom[j]:=t;
  t64:=h[i];
  h[i]:=h[j];
  h[j]:=t64;
end;

procedure Heapify(i: integer);
var
  min: longint;
begin
  min:=i;
  if (i*2<=hsize) and (h[min]>h[i*2]) then
    min:=i*2;
  if (i*2+1<=hsize) and (h[min]>h[i*2+1]) then
    min:=i*2+1;
  if min=i then
    exit;
  Swap(min, i);
  Heapify(min);
end;

procedure ExtractMin;
begin
  Swap(1, hsize);
  dec(hsize);
  Heapify(1);
end;

procedure DecKey(i: integer; Key: Int64);
var
  x: longint;
begin
  x:=ind[i];
  h[x]:=Key;
  while (x>1) and (h[x]<h[x div 2]) do
  begin
    Swap(x, x div 2);
    x:=x div 2;
  end;
end;

begin
  Assign(input, 'customs.in');
  Assign(output, 'customs.out');
  Reset(input);
  Rewrite(output);
  Read(N, M);
  hsize:=N;
  for i:=1 to N do
  begin
    s[i]:=0;
    h[i]:=400000000;
    max[i, 1]:=0;
    max[i, 2]:=0;
    max[i, 3]:=0;
    ind[i]:=i;
    nom[i]:=i;
  end;
  for i:=1 to M do
  begin
    ReadLn(x, y, z);
    w[i*2-1].s:=x;
    w[i*2-1].e:=y;
    w[i*2-1].c:=z;
    w[i*2-1].next:=s[x];
    s[x]:=i*2-1;
    w[i*2].s:=y;
    w[i*2].e:=x;
    w[i*2].c:=z;
    w[i*2].next:=s[y];
    s[y]:=i*2;
  end;
  Read(x, y);
  DecKey(x, 0);
  while hsize>0 do
  begin
    if nom[1]=y then
      break;
    j:=s[nom[1]];
    ExtractMin;
    while (j<>0) do
    begin
      if (max[w[j].s, 3]=0) or (w[j].c>max[w[j].s, 3]) then
      begin
        i:=1;
        while (max[w[j].s, i]<=w[j].c) and (max[w[j].s, i]<>0) do
        begin
          t[i]:=max[w[j].s, i];
          inc(i);
        end;
        t[i]:=w[j].c;
        inc(i);
        while i<=3 do
        begin
          t[i]:=max[w[j].s, i-1];
          inc(i);
        end;
        z:=0;
        for i:=1 to 3 do
          inc(z, t[i]);
        if z<h[ind[w[j].e]] then
        begin
          max[w[j].e]:=t;
          DecKey(w[j].e, z);
        end;
      end;
        j:=w[j].next;
    end;
  end;
  WriteLn(h[ind[y]]);
  Close(input);
  Close(output);
end.
