program ZC;

{$APPTYPE CONSOLE}

type
  TEdge = record
    s, e, next: longint;
  end;

var
  s, c: array [1..50000] of longint;
  w: array [1..50001] of TEdge;
  i, j, x, y, N, M, T, k: longint;
  f, f1, f2: boolean;

function DFS(i: longint): boolean;
var
  j: longint;
begin
  DFS:=true;
  if c[i]<>0 then
  begin
    DFS:=false;
    exit;
  end;
  c[i]:=1;
  j:=s[i];
  while j<>0 do
  begin
    if not(DFS(w[j].e)) then
    begin
      DFS:=false;
      exit;
    end;
    j:=w[j].next;
  end;
  c[i]:=2;
end;

begin
  Assign(input, 'quirks.in');
  Assign(output, 'quirks.out');
  Reset(input);
  Rewrite(output);
  Read(T);
  for k:=1 to T do
  begin
    Read(N, M);
    for i:=1 to N do
      s[i]:=0;
    for i:=1 to M do
    begin
      Read(x, y);
      w[i].s:=x;
      w[i].e:=y;
      w[i].next:=s[x];
      s[x]:=i;
    end;
    f:=true;
    f1:=false;
    for i:=1 to N do
    begin
      for j:=1 to N do
        c[j]:=0;
      f:=f and DFS(i);
      if not(f) then
        break;
      f2:=true;
      for j:=1 to N do
        if c[j]=0 then
        begin
          f2:=false;
          break;
        end;
      f1:=f1 or f2;
    end;
    if f and f1 then
      WriteLn('YES')
    else
      WriteLn('NO');
  end;
  Close(input);
  Close(output);
end.
