program ZB;

{$APPTYPE CONSOLE}

type
  TVector = record
    x, y: extended;
  end;

var
  N, i: integer;
  y1, y2: extended;
  mx1, mx2, my1, my2: extended;
  p1, p2: TVector;

function VectorMul(a, b: TVector): extended;
begin
  VectorMul:=a.x*b.y-b.x*a.y;
end;

procedure Process;
var
  ty1, ty2, max, a1, b1, c1, a2, b2, c2, cx: Extended;
  t1, t2: TVector;
begin
  ty1:=y1+p1.y*(mx2-mx1)/p1.x;
  ty2:=y2+p2.y*(mx2-mx1)/p2.x;
  if ty1>my2 then
    ty1:=my2;
  if ty2<my2-1 then
    ty2:=my2-1;
  if ty1<ty2 then
  begin
    max:=mx1;
    A1:=p1.y;
    B1:=-p1.x;
    C1:=p1.x*y1-mx1*p1.y;
    A2:=my1-my2;
    B2:=mx2-mx1;
    C2:=mx1*my2-mx2*my1;
    if abs(A1*B2-A2*B1)>0.0001 then
    begin
      cx:=(B1*C2-B2*C1)/(A1*B2-A2*B1);
      if (cx>=mx1) and (cx<=mx2) and (cx>max) then
        max:=cx;
    end;
    A1:=p2.y;
    B1:=-p2.x;
    C1:=p2.x*y2-mx1*p2.y;
    A2:=my1-my2;
    B2:=mx2-mx1;
    C2:=mx1*(my2-1)-mx2*(my1-1);
    if abs(A1*B2-A2*B1)>0.0001 then
    begin
      cx:=(B1*C2-B2*C1)/(A1*B2-A2*B1);
      if (cx>=mx1) and (cx<=mx2) and (cx>max) then
        max:=cx;
    end;
    WriteLn(max:2:2);
    Close(input);
    Close(output);
    halt;
  end;
  t2.x:=mx2-mx1;
  t2.y:=(my2-1)-y1;
  t1.x:=mx2-mx1;
  t1.y:=my2-y2;
  if VectorMul(t1, p1)>=0 then
    p1:=t1;
  if VectorMul(t2, p2)<=0 then
    p2:=t2;
  y1:=ty1;
  y2:=ty2;
end;

begin
  Assign(input, 'pipe.in');
  Assign(output, 'pipe.out');
  Reset(input);
  Rewrite(output);
  Read(N);
  Read(mx1, my1);
  Read(mx2, my2);
  p1.x:=mx2-mx1;
  p1.y:=my2-my1+1;
  p2.x:=mx2-mx1;
  p2.y:=my2-my1-1;
  y1:=my1;
  y2:=my1-1;
  Process;
  mx1:=mx2;
  my1:=my2;
  for i:=2 to N-1 do
  begin
    Read(mx2, my2);
    Process;
    mx1:=mx2;
    my1:=my2;
  end;
  WriteLn('DELO TRUBA');
  Close(input);
  Close(output);
end.
