#include <stdio.h>
#include <string.h>

#define maxn 1001000

int n = maxn << 1, a[maxn << 1], f[maxn << 1];
char buf[1024];

void add( int i, int d )
{
  for (; i < n; i |= i + 1)
    f[i] += d;
}

int get( int i )
{
  int r;

  if (i < 0)
    return 0;
  for (r = 0; i >= 0; i &= i + 1, i--)
    r += f[i];
  return r;
}

int main( void )
{
  int i, j;
  
  freopen("kitten.in", "rt", stdin);
  freopen("kitten.out", "wt", stdout);
  memset(a, 0, sizeof(a));
  memset(f, 0, sizeof(f));
  while (gets(buf))
  {
    if (sscanf(buf, "%d%d", &i, &j) == 1)
    {
      i += maxn;
      if (!a[i])
        a[i] = 1, add(i, 1);
    }
    else if (sscanf(buf, "%d%d", &i, &j) == 2)
    {
      if (i > j)
        i ^= j, j ^= i, i ^= j;
      i += maxn, j += maxn;
      printf("%d\n", get(j) - get(i - 1));
    }
  }
  return 0;
}
