#include <stdio.h>

#define maxn 50100
#define maxm 50100

int ev0[maxm], en0[maxm], ev1[maxm], en1[maxm], n, m;
int hd0[maxn], hd1[maxn], u[maxn], f[maxn], t;
int csize[maxn], cpos[maxn], comps[maxn], nc, isbad;
int col[maxn];

void dfs0( int v )
{
  int i;

  u[v] = 1;
  for (i = hd0[v]; i != -1; i = en0[i])
    if (!u[ev0[i]])
      dfs0(ev0[i]);
  f[t++] = v;
}

void dfs1( int v )
{
  int i;

  u[v] = t + 1;
  for (i = hd1[v]; i != -1; i = en1[i])
    if (!u[ev1[i]])
      dfs1(ev1[i]);
}

void dfs2( int v )
{
  int i, j;

  u[v] = 1;
  for (j = 0; j < csize[v]; j++)
    for (i = hd0[comps[cpos[v] + j]]; i != -1; i = en0[i])
      if (!u[col[ev0[i]]])
        dfs2(col[ev0[i]]);
      else if (col[ev0[i]] != v)
        isbad = 1;
}

void dfs3( int v )
{
  int i;

  u[v] = 1;
  for (i = hd0[v]; i != -1; i = en0[i])
    if (col[ev0[i]] == col[v])
    {
      if (!u[ev0[i]])
        dfs3(ev0[i]);
      else if (u[ev0[i]] == 2)
        isbad = 1;
    }
  u[v] = 2;
}

int main( void )
{
  int i, te, a, b;

  freopen("quirks.in", "rt", stdin);
  freopen("quirks.out", "wt", stdout);
  scanf("%d", &te);
  while (te--)
  {
    scanf("%d%d", &n, &m);
    for (i = 0; i < n; i++)
      hd0[i] = hd1[i] = -1;
    for (i = 0; i < m; i++)
    {
      scanf("%d%d", &a, &b);
      a--, b--;
      ev0[i] = b, en0[i] = hd0[a], hd0[a] = i;
      ev1[i] = a, en1[i] = hd1[b], hd1[b] = i;
    }
    memset(u, 0, sizeof(u));
    for (i = t = 0; i < n; i++)
      if (!u[i])
        dfs0(i);
    memset(u, 0, sizeof(u));
    for (i = t = 0; i < n; i++)
      if (!u[f[n - i - 1]])
        dfs1(f[n - i - 1]), t++;
    for (i = 0; i < n; i++)
      col[i] = u[i] - 1;
    nc = t;
    memset(csize, 0, sizeof(csize));
    for (i = 0; i < n; i++)
      csize[col[i]]++;
    cpos[0] = 0;
    for (i = 1; i < nc; i++)
      cpos[i] = cpos[i - 1] + csize[i - 1];
    memset(csize, 0, sizeof(csize));
    for (i = 0; i < n; i++)
      comps[cpos[col[i]] + csize[col[i]]++] = i;
    memset(u, 0, sizeof(u));
    isbad = 0;
    dfs2(0);
    for (i = 0; i < nc; i++)
      if (!u[i])
        isbad = 1;
    if (isbad)
    {
      printf("NO\n");
      continue;
    }
    memset(u, 0, sizeof(u));
    for (i = 0; i < nc; i++)
      dfs3(comps[cpos[i]]);
    if (isbad)
    {
      printf("NO\n");
      continue;
    }
    printf("YES\n");
  }
  return 0;
}

