#include <stdio.h>

//#define dbg

#define maxr 1000100
#define maxk 300100

int pr[maxr], si[maxr], cc[maxr];
int wid, hei, k;
int segm[maxk][4], ns;
int line0[maxk][4], nl0, line1[maxk][4], nl1, num;

int get( int i )
{
  if (pr[i] == i)
    return i;
  return pr[i] = get(pr[i]);
}

void join( int i, int j )
{
  i = get(i), j = get(j);
  if (i == j)
    return;
  if (si[i] < si[j])
    pr[i] = j, si[j] += si[i];
  else
    pr[j] = i, si[i] += si[j];
}

int main( void )
{
  int i, col, curx, cury, len, res, j, k;

  freopen("rle.in", "rt", stdin);
  freopen("rle.out", "wt", stdout);
  scanf("%d%d", &wid, &hei);
  scanf("%d%d", &col, &k);
  curx = cury = ns = 0;
  for (i = 0; i < k; i++)
  {
    scanf("%d", &len);
    while (len)
    {
      if (curx + len - 1 < wid)
      {
        segm[ns][0] = curx, segm[ns][1] = curx + len - 1, segm[ns][2] = cury, segm[ns][3] = col, ns++;
        curx += len;
        if (curx >= wid)
          cury++, curx = 0;
        len = 0;
      }
      else
      {
        segm[ns][0] = curx, segm[ns][1] = wid - 1, segm[ns][2] = cury, segm[ns][3] = col, ns++;
        len -= wid - curx;
        curx = 0, cury++;
      }
    }
    col = (col + 1) & 1;
  }
  for (i = 0; i < ns; i++)
    pr[i] = i, si[i] = 1, cc[i] = segm[i][3];
  cury = num = 0;
  nl0 = nl1 = 0;
  for (i = 0; i < ns && segm[i][2] == 0; i++)
    line0[nl0][0] = segm[i][0], line0[nl0][1] = segm[i][1], line0[nl0][3] = segm[i][3], line0[nl0][2] = num++, nl0++;
  for (; i < ns && segm[i][2] == 1; i++)
    line1[nl1][0] = segm[i][0], line1[nl1][1] = segm[i][1], line1[nl1][3] = segm[i][3], line1[nl1][2] = num++, nl1++;
  cury = 1;
#ifdef dbg
  printf("%d\n", ns);
  for (j = 0; j < ns; j++)
    printf("(%d, %d, %d, %d), ", segm[j][0], segm[j][1], segm[j][2], segm[j][3]);
  printf("\n");
#endif
  for (; i <= ns;)
  {
#ifdef dbg
    for (j = 0; j < nl0; j++)
      printf("(%d, %d, %d), ", line0[j][0], line0[j][1], line0[j][3]);
    printf("\n");
    for (j = 0; j < nl1; j++)
      printf("(%d, %d, %d), ", line1[j][0], line1[j][1], line1[j][3]);
    printf("\n\n");
#endif
    for (j = k = 0; j < nl0 && k < nl1;)
    {
      if (!line0[j][3])
        j++;
      else if (!line1[k][3])
        k++;
      else
      {
        if (line0[j][0] < line1[k][0])
        {
          if (line0[j][1] >= line1[k][0] - 1)
            join(line0[j][2], line1[k][2]);
        }
        else if (line0[j][0] >= line1[k][0])
        {
          if (line1[k][1] >= line0[j][0] - 1)
            join(line0[j][2], line1[k][2]);
        }
        if (line0[j][1] < line1[k][1])
          j++;
        else if (line0[j][1] > line1[k][1])
          k++;
        else
          j++, k++;
      }
    }
    if (i == ns)
      break;
    cury++;
    for (j = 0; j < nl1; j++)
      line0[j][0] = line1[j][0], line0[j][1] = line1[j][1], line0[j][2] = line1[j][2], line0[j][3] = line1[j][3];
    nl0 = nl1, nl1 = 0;
    for (; i < ns && segm[i][2] == cury; i++)
      line1[nl1][0] = segm[i][0], line1[nl1][1] = segm[i][1], line1[nl1][3] = segm[i][3], line1[nl1][2] = num++, nl1++;
  }
  res = 0;
  for (i = 0; i < num; i++)
    if (cc[i] && pr[i] == i)
      res++;
  printf("%d", res);
  return 0;
}
