#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define maxn 1010

int to[maxn][maxn], n, c, k, max, min;
int u[maxn], cur[maxn], nc, fl;

void out( int fl )
{
  if (fl < 0 || fl >= n)
    return;
  u[fl] -= cur[fl];
  nc -= cur[fl];
  cur[fl] = 0;
}

void add( int fl, int dir )
{
  int i;

  if (fl < 0 || fl >= n)
    return;
  if (dir == 1)
  {
    for (i = n - 1; i >= fl + 1 && nc < c; i--)
      if (to[fl][i] + nc > c)
        cur[i] += c - nc, to[fl][i] -= c - nc, u[fl] -= c - nc, k -= c - nc, nc = c;
      else
        cur[i] += to[fl][i], nc += to[fl][i], u[fl] -= to[fl][i], k -= to[fl][i], to[fl][i] = 0;
  }
  else
  {
    for (i = 0; i <= fl - 1 && nc < c; i++)
      if (to[fl][i] + nc > c)
        cur[i] += c - nc, to[fl][i] -= c - nc, u[fl] -= c - nc, k -= c - nc, nc = c;
      else
        cur[i] += to[fl][i], nc += to[fl][i], u[fl] -= to[fl][i], k -= to[fl][i], to[fl][i] = 0;
  }
}

void chmm( void )
{
  if (!k)
    return;
  while (max >= 0 && max < n && !u[max])
    max--;
  while (min >= 0 && min < n && !u[min])
    min++;
}

int main( void )
{
  int i, a, b, res = 0;

  freopen("elevator.in", "rt", stdin);
  freopen("elevator.out", "wt", stdout);
  memset(to, 0, sizeof(to));
  memset(u, 0, sizeof(u));
  memset(cur, 0, sizeof(cur));
  scanf("%d%d%d", &n, &c, &k);
  for (i = 0; i < k; i++)
    scanf("%d%d", &a, &b), to[--a][--b]++, u[a]++, u[b]++;
  for (max = n - 1; max >= 0 && !u[max]; max--)
    ;
  for (min = 0; min < n && !u[min]; min++)
    ;
  nc = fl = 0;
  while (k)
  {
    for (i = fl; i < max; i++)
    {
      out(i);
      add(i, 1);
    }
    res += max - fl;
    fl = max;
    chmm();
    for (i = fl; i > min; i--)
    {
      out(i);
      add(i, -1);
    }
    res += fl - min;
    fl = min;
    chmm();
  }
  res += fl;
  printf("%d\n", res * 5);
  fclose(stdin);
  fclose(stdout);
  return 0;
}
