#include <stdio.h>
#include <string.h>

#define INF 100000

#define MAX_N 101

int N, A[MAX_N][MAX_N];

int Col[MAX_N], P[MAX_N], PN = 0, Pos;

int dfs( int v )
{
  int i;

  Col[v] = 1;
  for (i = 0; i < N; i++)
    if (A[v][i] != INF && i != v)
      if (Col[i] == 1)
      {
        P[PN++] = i;
        return 1;
      }
      else if (Col[i] == 0)
      {
        P[PN++] = i;
        if (dfs(i))
          return 1;
        PN--;
      }
  Col[v] = 2;
  return 0;
}

int main( void )
{
  int i, j;

  freopen("cicle.in", "rt", stdin);
  freopen("cicle.out", "wt", stdout);
  scanf("%d", &N);
  for (i = 0; i < N; i++)
    for (j = 0; j < N; j++)
      scanf("%d", &A[i][j]);
  for (i = 0; i < N; i++)
  {
    memset(Col, 0, sizeof(Col));
    PN = 1, P[0] = i;
    if (dfs(i))
    {
      printf("YES\n");
      for (Pos = PN - 2; P[Pos] != P[PN - 1]; Pos--)
        ;
      printf("%d\n", PN - Pos);
      for (j = Pos; j < PN; j++)
        printf("%d ", P[j] + 1);
      return 0;
    }
  }
  printf("NO\n");
  return 0;
}
