#include <stdio.h>
#include <math.h>

#define m 102
#define inf 1000000000
#define e 1e-8

int b[m][m], l, w[m * m], _stklen = 2 * 1024 * 1024;
double a[m][m];

void write( int i, int j )
{
  if (b[i][j] == 0 || b[i][j] == i || b[i][j] == j)
    w[++l] = i;
  else
  {
    write(i, b[i][j]);
    write(b[i][j], j);
  }
}

int main( void )
{
  int i, k, j, n;

  freopen("cicle.in", "r", stdin);
  freopen("cicle.out", "w", stdout);
  scanf("%d", &n);
  for (i = 1; i <= n; i++)
    for (j = 1; j <= n; j++)
    {
      scanf("%lf", &a[i][j]);
      if (fabs(a[i][j] - 100000) < e)
        a[i][j] = inf;
    }
  for (k = 1; k <= n; k++)
    for (i = 1; i <= n; i++)
      for (j = 1; j <= n; j++)
        if (a[i][k] != inf && a[k][j] != inf
            && (a[i][j] > a[i][k] + a[k][j] + e))
        {
          a[i][j] = a[i][k] + a[k][j];
          b[i][j] = k;
          if (i == j && a[i][j] < -e)
          {
            i = j = k = 100;
            break;
          }
        }
  for (i = 1; i <= n; i++)
    if (a[i][i] < -e)
      break;
  if (i <= n)
  {
    j = i;
    printf("YES\n");
    write(i, i);
    printf("%d\n", l + 1);
    for (i = 1; i <= l; i++)
      printf("%d ", w[i]);
    printf("%d\n", j);
    /*
    for (i = 1; i <= n; i++)
      c[i][0] = inf;
    c[k][0] = 0;
    for (i = 1; i <= n; i++)
      for (j = 1; j <= n; j++)
        c[i][j] = inf;
    for (i = 1; i <= n; i++)
      for (j = 0; j <= n; j++)
      {
        if (c[i][j] >= inf)
          continue;
        for (ii = 1; ii <= n; ii++)
          if (a[i][ii] != inf && c[ii][i + 1] > c[i][j])

      }*/
  }
  else
    printf("NO\n");
  return 0;
}
