{$A+,B-,D-,E-,F-,G+,I-,L-,N+,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}
   Const File_In='substr.in';
         File_Out='substr.out';
         MaxLen=200000;
   Type Int=LongInt;
   Var S1,S2 : Array [1..MaxLen] Of Char;
       LenS1,LenS2 : Int;
       P1,P2 : Array [0..MaxLen] Of Int;

Procedure OpenFiles;
Begin
  Assign(Input,File_In);
  ReSet(Input);
  Assign(Output,File_Out);
  ReWrite(Output);
End;

Function ReadNext : Char;
  Var Sym : Char;
Begin
  Read(Sym);
  While Not (Sym In [#33..#126]) Or (Sym=' ') Do Read(Sym);
  ReadNext :=Sym;
End;

Procedure Init;
  var Sym : Char;
Begin
  Sym :=ReadNext;
  LenS1 :=0;
  LenS2 :=0;
  While Sym<>'*' Do
    Begin
      Inc(LenS1);
      S1[LenS1] :=Sym;
      Sym :=ReadNext;
    End;
  While Not SeekEoF Do
    Begin
      Sym :=ReadNext;
      Inc(LenS2);
      S2[LenS2] :=Sym;
    End;
End;

Procedure Solve;
  Var I : Int;
Begin
  FIllChar(P1,SizeOf(P1),0);
  FIllChar(P2,SizeOf(P2),0);
  For I :=2 To LenS1 Do
    Begin
      P1[I] :=P1[I-1];
      While (S1[P1[I]+1]<>S1[I]) And (P1[I]<>0) Do
        P1[I] :=P1[P1[I]];
      If S1[P1[I]+1]=S1[I] Then Inc(P1[I]);
    End;
  For I :=1 To LenS2 Do
    Begin
      P2[I] :=P2[I-1];
      While (S1[P2[I]+1]<>S2[I]) And (P2[I]<>0) Do
        P2[I] :=P1[P2[I]];
      If S1[P2[I]+1]=S2[I] Then Inc(P2[I]);
      If P2[I]=LenS1 Then
        WriteLn(I-LenS1+1);
    End;
End;

Procedure CloseFiles;
Begin
  Close(Input);
  Close(Output);
End;

Begin
  OpenFiles;
  Init;
  Solve;
  CloseFiles;
End.
