#include <stdio.h>
#include <string.h>

#define MAX_N 20001
#define MAX_LEN 31

int N;
char SName[MAX_N][MAX_LEN];
char Name[MAX_N][MAX_LEN];
int A[MAX_N], C[MAX_N];

void Merge( int L, int M, int R )
{
  int i = L, j = M, k;

  for (k = L; k < R; k++)
    if (j >= R || (i < M && strcmp(SName[A[i]], SName[A[j]]) <= 0))
      C[k] = A[i++];
    else
      C[k] = A[j++];
  for (k = L; k < R; k++)
    A[k] = C[k];
}

void MSort( int L, int R )
{
  int M = (L + R + 1) >> 1;

  if (L + 1 >= R)
    return;
  MSort(L, M);
  MSort(M, R);
  Merge(L, M, R);
}

int main( void )
{
  int i;

  freopen("sort.in", "rt", stdin);
  freopen("sort.out", "wt", stdout);
  scanf("%d", &N);
  for (i = 0; i < N; i++)
    scanf("%s%s", SName[i], Name[i]), A[i] = i;
  MSort(0, N);
  printf("%d\n", N);
  for (i = 0; i < N; i++)
  {
    if (i > 0)
      printf("\n");
    printf("%s %s", SName[A[i]], Name[A[i]]);
  }
  return 0;
}
