{$I-,Q-,R-,S-}

const
  MAXN = 300;

type
  Integer = Longint;

const
  IN_FILE = 'pairs.in';
  OUT_FILE = 'pairs.out';

var
  n, m: Integer;
  a: array[1..MAXN, 1..MAXN] of Boolean;
  NNew: array[0..MAXN] of Boolean;
  b: array[0..MAXN] of Integer;
  Count: Integer;

procedure Init();
var
  i, k: Integer;
begin
  Assign(Input, IN_FILE);
  Reset(Input);
  Assign(Output, OUT_FILE);
  Rewrite(Output);

  Read(n, m);
  for i := 1 to n do
  begin
    Read(k);
    while (k > 0) do
    begin
      a[i, k] := True;
      Read(k);
    end;
  end;
end;

function Dfs(const x: Integer): Boolean;
var
  j: Integer;
begin
  if (x = 0) then
  begin
    Dfs := True;
    Exit;
  end;
  NNew[x] := True;
  for j := 1 to m do
    if a[x, j] and not NNew[b[j]] and Dfs(b[j]) then
    begin
      b[j] := x;
      Dfs := True;
      Exit;
    end;

  Dfs := False;
end;

procedure Solve();
var
  i: Integer;
begin
  for i := 1 to n do
  begin
    Fillchar(NNew, Sizeof(NNew), 0);
    if Dfs(i) then
      Inc(Count);
  end;

  Writeln(Count);
  for i := 1 to m do
    if b[i] > 0 then
      Writeln(b[i], ' ', i);
end;

procedure Done();
begin
  Close(Input);
  Close(Output);
end;

begin
  Init();
  Solve();
  Done();
end.
