program ooo;
const
  filename  = 'convex';
  InFile = FileName+'.in';
  OutFile = FileName+'.out';

type
  TXY = record
          x, y : longint;
        end;

var
  i, j, k, l, n, m, npoints : longint;
  ps : array[1..20000] of TXY;
  points : array[1..20000] of integer;

procedure OpenFile;
begin
  assign(input, InFile);
  reset(input);
  readln(n);
  for i:=1 to n do
    readln(ps[i].x, ps[i].y);
  close(input);
end;

procedure Solve;
var
  nn : longint;
  x1, y1, x2, y2, xe, ye : real;
  cosa, cosm, r, rm : real;
begin
  nn:= 1;
  for i:= 2 to n do
    if (ps[nn].y> ps[i].y) or ((ps[nn].y= ps[i].y) and (ps[nn].x > ps[i].x)) then
      nn:= i;
  x1:= ps[nn].x- 10;
  y1:= ps[nn].y;
  x2:= ps[nn].x; xe:= x2;
  y2:= ps[nn].y; ye:= y2;
  npoints:= 1;
  points[1]:= nn;
  i:= 0;
  repeat
    inc(i);
    cosm:= -1;
    rm:= 0;
    l:=0;
    for j:=1 to n do
      begin
      r:= sqrt((sqr(x2-x1)+sqr(y2-y1))*(sqr(ps[j].x-x2)+sqr(ps[j].y-y2)));
      if r<>0 then
        begin
        cosa:= ((x2-x1)*(ps[j].x-x2)+ (y2-y1)*(ps[j].y-y2))/r;
        if (cosa> cosm) or((cosa=cosm)and(rm<r)) then
          begin
          cosm:= cosa;
          rm:= r;
          l:= j;
          end;
        end;
      end;
    x1:= x2;
    y1:= y2;
    x2:= ps[l].x;
    y2:= ps[l].y;
    inc(npoints);
    points[npoints]:= l;
  until (x2 = xe) and (y2 = ye);
  dec(npoints);
end;

procedure SaveFile;
begin
  assign(output, OutFile);
  rewrite(Output);
  writeln(npoints);
  if n mod 2 = 1 then
    begin
    for i:=1 to npoints div 2 do
      begin
      j:= points[i];
      points[i]:= points[npoints-i+1];
      points[npoints-i+1]:= j;
      end;
    end;
  for i:=1 to npoints do
    writeln(ps[points[i]].x,' ', ps[points[i]].y);
  close(output);
end;

begin
  OpenFile;
  Solve;
  SaveFile;
end.
