{$A+,B-,D-,E-,F-,G+,I-,L-,N+,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}
   Const File_In='sort.in';
         File_Out='sort.out';
         MaxN=20001;
   Type Int=LongInt;
        TString=String[20];
   Var N : Int;
       F,Name : Array [1..MaxN] Of TString;
       Num : Array [1..MaxN] Of Int;

Procedure OpenFiles;
Begin
  Assign(Input,File_In);
  ReSet(Input);
  Assign(Output,File_Out);
  ReWrite(Output);
End;

Procedure ReadFN(Const I : Int);
  Var Sym : Char;
Begin
  Num[I] :=I;
  F[I] :='';
  Name[I] :='';
  Read(Sym);
  While Not (Sym In ['a'..'z','A'..'Z']) Do Read(Sym);
  While (Sym In ['a'..'z','A'..'Z']) Do
     Begin
       F[I] :=F[I]+Sym;
       Read(Sym);
     End;
  While Not (Sym In ['a'..'z','A'..'Z']) Do Read(Sym);
  While (Sym In ['a'..'z','A'..'Z']) Do
     Begin
       Name[I] :=Name[I]+Sym;
       Read(Sym);
     End;
End;

Procedure Init;
  Var I : Int;
Begin
  Read(N);
  For I :=1 To N Do
    ReadFN(I);
End;

Procedure Swap(Var A,B : Int);
  Var C : Int;
Begin
  C :=A;
  A :=B;
  B :=C;
End;

Procedure SwapS(Var A,B : TString);
  Var C : TString;
Begin
  C :=A;
  A :=B;
  B :=C;
End;

Procedure Sort(L,R : Int);
  Var B,E : Int;
      X : TString;
Begin
  B :=L;
  E :=R;
  X :=F[(L+R) Div 2];
  Repeat
    While F[B]<X Do Inc(B);
    While F[E]>X Do Dec(E);
    If B<=E Then
      Begin
        Swap(Num[B],Num[E]);
        SwapS(Name[B],Name[E]);
        SwapS(F[B],F[E]);
        Inc(B);
        Dec(E);
      End;
  Until B>E;
  If B<R Then Sort(B,R);
  If E>L Then Sort(L,E);
End;

Procedure SortNum(L,R : Int);
  Var B,E : Int;
      X : Int;
Begin
  B :=L;
  E :=R;
  X :=Num[(L+R) Div 2];
  Repeat
    While Num[B]<X Do Inc(B);
    While Num[E]>X Do Dec(E);
    If B<=E Then
      Begin
        Swap(Num[B],Num[E]);
        SwapS(Name[B],Name[E]);
        SwapS(F[B],F[E]);
        Inc(B);
        Dec(E);
      End;
  Until B>E;
  If B<R Then SortNum(B,R);
  If E>L Then SortNum(L,E);
End;

Procedure Solve;
  Var I,J : Int;
Begin
  Sort(1,N);
  WriteLn(N);
  J :=1;
  For I :=2 To N Do
    If F[I]<>F[I-1] Then
      Begin
        SortNum(J,I-1);
        J :=I;
      End;
  SortNum(J,N);
  For I :=1 To N Do
    WRiteLn(F[I],' ',Name[I]);
End;

Procedure CloseFiles;
Begin
  Close(Input);
  Close(Output);
End;

Begin
  OpenFiles;
  Init;
  Solve;
  CloseFiles;
End.
