uses Math;
const
     FileIn='substr.in';
     FileOut='substr.out';
var
   Image: array [1..10000] of Char;
   N, M: LongInt;
   T: array [1..200000] of Char;
   P: array [1..10000] of Char;
//   P - ࠧ
   AnswerLength: LongInt;
   Answer: array [1..200000] of LongInt;

procedure ReadData;
var
   F: file of Char;
   BufSize: LongInt;
   NChar: LongInt;
   TextGoes: Boolean;
begin
     Assign (F, FileIn);
     Reset (F);

     TextGoes:=false;
     M:=0;
     N:=0;
     while FilePos (F)<FileSize (F)
           do begin
              BufSize:=Min (FileSize (F)-FilePos (F), SizeOf (Image));
              BlockRead (F, Image, BufSize);
              for NChar:=1 to BufSize
                  do if Image [NChar]='*'
                        then TextGoes:=true
                        else if Ord (Image [NChar])>=33
                                then if TextGoes
                                        then begin
                                             Inc (N);
                                             T [N]:=Image [NChar];
                                        end
                                        else begin
                                             Inc (M);
                                             P [M]:=Image [NChar];
                                        end;
           end;
     Close (F);
end;

procedure WriteData;
var
   F: Text;
   Index: LongInt;
begin
     Assign (F, FileOut);
     Rewrite (F);
     for Index:=1 to AnswerLength
         do Writeln (F, Answer [Index]);
     Close (F);
end;

var
   z: array [1..200000] of LongInt;

procedure ComputePrefixFunction;
var
   k, q: LongInt;
begin
     m:=Length (P);
     Z [1]:=0;
     k:=0;
     for q:=2 to m
         do begin
            while (k>0) and (P [k+1]<>P [q])
                  do k:=Z [k];
            if P [k+1]=P [Q]
               then Inc (K);
            Z [q]:=k;
         end;
end;

procedure KMPMatcher;
var
   q, i: LongInt;
begin
     ComputePrefixFunction;
     q:=0;
     for i:=1 to n
         do begin
            while (q>0) and (P [q+1]<>T [i])
                  do q:=Z [q];
            if P [q+1]=T [i]
               then Inc (q);
            if q=m
               then begin
                    Inc (AnswerLength);
                    Answer [AnswerLength]:=i-m+1;
                    q:=Z [q];
               end;
         end;
end;

procedure Solve;
begin
     AnswerLength:=0;
     KMPMatcher;
end;

begin
     ReadData;
     Solve;
     WriteData;
end.
