#include <stdio.h>

#define MAX_LEN 300003

char S[MAX_LEN], SubS[MAX_LEN];
int LS = 0, LSubS = 0;
int P[MAX_LEN], Pr[MAX_LEN];

void Kmp( void )
{
  int i, k;

  P[0] = 0;
  for (i = 1; i < LSubS; i++)
  {
    k = P[i - 1];
    while (k > 0 && S[k] != S[i])
      k = P[k - 1];
    if (SubS[k] == SubS[i])
      k++;
    P[i] = k;
  }
  for (i = 0; i < LS; i++)
  {
    if (i == 0)
      k = 0;
    else
      k = Pr[i - 1];
    while (k > 0 && SubS[k] != S[i])
      k = P[k - 1];
    if (SubS[k] == S[i])
      k++;
    if (k == LSubS)
    {
      printf("%d\n", i - LSubS + 2);
      k = P[k - 1];
      if (SubS[k] == S[i] && LSubS > 1)
        k++;
    }
    Pr[i] = k;
  }
}

int main( void )
{
  int c;

  freopen("substr.in", "rt", stdin);
  freopen("substr.out", "wt", stdout);
  while ((c = getc(stdin)) != '*')
    if (33 <= c && c <= 126)
      SubS[LSubS++] = c;
  while ((c = getc(stdin)) != -1)
    if (33 <= c && c <= 126)
      S[LS++] = c;
  Kmp();
  return 0;
}
