const
     FileIn='sort.in';
     FileOut='sort.out';
     MaxN=20000;
var
   N: Word;
   Fams: array [1..MaxN] of string [22];
   Full: array [1..MaxN] of string;
   Indexes: array [1..MaxN] of Word;

procedure ReadData;
var
   F: Text;
   Index: Word;
begin
     Assign (F, FileIn);
     Reset (F);
     Readln (F, N);
     for Index:=1 to N
         do Readln (F, Full [Index]);
     Close (F);
end;

procedure WriteData;
var
   F: Text;
   Index: Word;
begin
     Assign (F, FileOut);
     Rewrite (F);
     Writeln (F, N);
     for Index:=1 to N
         do Writeln (F, Full [Indexes [Index]]);
     Close (F);
end;

procedure QSort (aLeft, aRight: Word);
var
   i, j: Word;
   T: Word;
   MiddleKey: Word;
begin
     i:=aLeft;
     j:=aRight;
     MiddleKey:=Indexes [(i+j) shr 1];
     repeat
           while Fams [Indexes [i]]<Fams [MiddleKey]
                 do Inc (i);
           while Fams [MiddleKey]<Fams [Indexes [j]]
                 do Dec (j);
           if i<=j
              then begin
                   T:=Indexes [i];
                   Indexes [i]:=Indexes [j];
                   Indexes [j]:=T;
                   Inc (i);
                   Dec (j);
              end;
     until i>=j;
     if aLeft<j
        then QSort (aLeft, j);
     if i<aRight
        then QSort (i, aRight);
end;

procedure Solve;
var
   Index: Word;
   NChar: Word;
begin
     for Index:=1 to N
         do begin
            for NChar:=1 to Length (Full [Index])
                do if Full [Index] [NCHar]=#32
                      then Break;
            Fams [Index]:=Copy (Full [Index], 1, NChar-1);
            SetLength (Fams [Index], NChar+1);
            Fams [Index] [NChar]:=Chr (Hi (Index));
            Fams [Index] [NChar+1]:=Chr (Lo (Index));
            Indexes [Index]:=Index;
         end;
     QSort (1, N);
end;

begin
     ReadData;
     Solve;
     WriteData;
end.
