program problemM;

{APPTYPE CONSOLE}
{$O+,D-,S-,R-,Q-}

{

  EVA RULEZZZ!!!!!!!

  Fight with the best? Die like the rest!

  Copyright by [ hr0nix@darkwired ]

}


const
  InFile = 'sort.in';
  OutFile = 'sort.out';
  MaxN = 20000;

type
  Int = longint;
  Real = extended;
  TString = string[ 45 ];

var
  n : Int;
  full, sorted, merge : array [1..MaxN] of Tstring;

procedure OpenFiles;
begin
  assign( input, InFile );
  reset( input );
  assign( output, OutFile );
  rewrite( output );
end;

procedure CloseFiles;
begin
  close( input );
  close( output );
end;

procedure InitData;
var
  i : Int;
  s : Tstring;
begin
  readln( n );
  for i := 1 to n do begin
    readln( s );
    full[ i ] := s;
  end;
  sorted := full;
end;

function less( const s1, s2 : string ) : boolean;
var
  i : Int;
  sf1, sf2 : string;
begin
  if s1 = s2 then begin
    less := false;
    exit;
  end;
  sf1 := '';
  i := 1;
  while s1[ i ] <> ' ' do begin
    sf1 := sf1 + s1[ i ];
    inc( i );
  end;
  sf2 := '';
  i := 1;
  while s2[ i ] <> ' ' do begin
    sf2 := sf2 + s2[ i ];
    inc( i );
  end;

  if sf1 < sf2 then begin
    less := true;
    exit;
  end else
  if sf1 > sf2 then begin
    less := false;
    exit;
  end;

  for i := 1 to n do
    if full[ i ] = s1 then begin
      less := true;
      exit;
    end else
    if full[ i ] = s2 then begin
      less := false;
      exit;
    end;
  less := false;
end;

procedure QSort(l, r: Integer);
var
  i, j : integer;
  x, y : TString;
begin
  i := l; j := r; x := sorted[(l+r) DIV 2];
  repeat
    while less( sorted[i], x ) do i := i + 1;
    while less( x, sorted[j] ) do j := j - 1;
    if i <= j then
    begin
      y := sorted[i]; sorted[i] := sorted[j]; sorted[j] := y;
      i := i + 1; j := j - 1;
    end;
  until i > j;
  if l < j then QSort(l, j);
  if i < r then QSort(i, r);
end;

procedure MergeSort( l, r : Int );
var
  c1, c2, c, i : Int;
begin
  if l = r then
    exit;
  MergeSort( l, ( l + r ) div 2 );
  MergeSort( ( l + r ) div 2 + 1, r );
  c := l - 1;
  c1 := l;
  c2 := ( l + r ) div 2 + 1;
  while ( c1 <= ( l + r ) div 2 ) and ( c2 <= r ) do begin
    inc( c );
    if less( sorted[ c1 ], sorted[ c2 ] ) then begin
      merge[ c ] := sorted[ c1 ];
      inc( c1 );
    end else begin
      merge[ c ] := sorted[ c2 ];
      inc( c2 );
    end;
  end;
  while ( c1 <= ( l + r ) div 2 ) do begin
    inc( c );
    merge[ c ] := sorted[ c1 ];
    inc( c1 );
  end;
  while ( c2 <= r ) do begin
    inc( c );
    merge[ c ] := sorted[ c2 ];
    inc( c2 );
  end;
  for i := l to r do
    sorted[ i ] := merge[ i ];
end;

procedure Solve;
var
  i : Int;
begin
  QSort( 1, n );
  writeln( n );
  for i := 1 to n do
    writeln( sorted[ i ] );
end;

begin
  OpenFiles;
  InitData;
  Solve;
  CloseFiles;
end.
