{$ifdef DEBUG}
  {$I+,Q+,R+,S-}
{$else}
  {$I-,Q-,R-,S-}
{$endif}

program Temp;
const infile = 'maze.in';
      outfile = 'maze.out';
      MAXN = 2000;
      MAXM = 10000;
      inf = 1000000000;
type tEdge = record
  u, v, c : longint;
end;
var N, M : longint;
    dist : array[1..MAXN] of longint;
    e : array[1..MAXM] of tEdge;

procedure ReadData;
var i : integer;
begin
  assign(input, infile); reset(input);
  assign(output, outfile); rewrite(output);
  read(N, M);
  for i:=1 to N do
    dist[i]:=inf;
  dist[1]:=0;
  for i:=1 to M do begin
    read(e[i].u, e[i].v, e[i].c);
    e[i].c:=-e[i].c
  end;
end;

procedure Solve;
var i, j : longint;
begin
  for i:=1 to N-1 do begin
    for j:=1 to M do
      if dist[e[j].u]+e[j].c<dist[e[j].v] then
        dist[e[j].v]:=dist[e[j].u]+e[j].c;
  end;
  if dist[N]=inf then begin
    writeln(':(');
    exit;
  end;

  for j:=1 to M do
    if dist[e[j].u]+e[j].c<dist[e[j].v] then begin
      writeln(':)');
      exit;
    end;  
  writeln(-dist[N]);
end;

procedure WriteData;
begin
  close(input);
  close(output);
end;

begin
  ReadData;
  Solve;
  WriteData;
end.
