  {$I-,Q-,R-,S-}
const
    maxn=200;
    inf=1000000000;

var n,m:longint;
    a:array[1..maxn,1..maxn] of boolean;
    c:array[1..maxn] of longint;
    d,col:array[1..2,1..maxn] of longint;

procedure init;
var i,u,v:longint;
begin
    assign(input,'filling.in');
    reset(input);
    assign(output,'filling.out');
    rewrite(output);
    read(n);
    for i:=1 to n do read(c[i]);
    read(m);
    for i:=1 to m do
    begin
        read(u,v);
        a[u,v]:=true;
        a[v,u]:=true;
    end;
end;

procedure GetMin(var t1,t2:longint);
var mm,i:longint;
begin
    mm:=inf;
    t1:=0;
    t2:=0;
    for i:=1 to n do
    begin
        if (col[1,i]=1)and(d[1,i]<mm) then
        begin
            mm:=d[1,i];
            t1:=1;
            t2:=i;
        end;
        if (col[2,i]=1)and(d[2,i]<mm) then
        begin
            mm:=d[2,i];
            t1:=2;
            t2:=i;
        end;
    end;
end;

Procedure relax(const t,u,v:longint);
begin
    if t=1 then
    begin
        if col[1,v]=0 then
        begin
            col[1,v]:=1;
            d[1,v]:=d[t,u]+c[u];
        end else if d[1,v]>d[t,u]+c[u] then d[1,v]:=d[t,u]+c[u];
        if col[2,v]=0 then
        begin
            col[2,v]:=1;
            d[2,v]:=d[t,u]+c[u]*2;
        end else if d[2,v]>d[t,u]+c[u]*2 then d[2,v]:=d[t,u]+c[u]*2;
    end else
    begin
        if col[1,v]=0 then
        begin
            col[1,v]:=1;
            d[1,v]:=d[t,u];
        end else if d[1,v]>d[t,u] then d[1,v]:=d[t,u];
        if col[2,v]=0 then
        begin
            col[2,v]:=1;
            d[2,v]:=d[t,u]+c[u];
        end else if d[2,v]>d[t,u]+c[u] then d[2,v]:=d[t,u]+c[u];
    end;
end;

Procedure solve;
var t1,t2,i:longint;
begin
    col[1,1]:=1;
    while true do
    begin
        getmin(t1,t2);
        if t1=0 then exit;
        for i:=1 to n do if a[t2,i] then relax(t1,t2,i);
        col[t1,t2]:=2;
    end;
end;

Function min(const a,b:longint):longint;
begin
    if a<b then min:=a else min:=b;
end;

Procedure print;
var ans:longint;
begin
    ans:=inf;
    if (col[1,n]=0)and(col[2,n]=0) then writeln(-1) else
    begin
        if col[1,n]=2 then ans:=min(ans,d[1,n]);
        if col[2,n]=2 then ans:=min(ans,d[2,n]);
        writeln(ans);
    end;
end;

begin
    init;
    solve;
    print;
    close(input);
    close(output);
end.