#include <stdio.h>
#include <string.h>

#define MAX 253

int VA, VB;
int CA[MAX][MAX], PA[MAX];
int CB[MAX][MAX], PB[MAX];
int UA[MAX], UB[MAX], Pair[MAX];

int dfs( int v )
{
  int i;

  for (i = 0; i < PA[v]; i++)
    if (!UB[CA[v][i]])
    {
      Pair[CA[v][i]] = v;
      UB[CA[v][i]] = 1;
      UA[v] = 1;
      return 1;
    }
    else
      if (dfs(Pair[CA[v][i]]))
      {
        Pair[CA[v][i]] = v;
        UB[CA[v][i]] = 1;
        UA[v] = 1;
      }
  return 0;
}

int main( void )
{
  int i, j, k, sum = 0;

  memset(UA, 0, sizeof(UA));
  memset(UB, 0, sizeof(UB));
  memset(PA, 0, sizeof(PA));
  memset(PB, 0, sizeof(PB));
  freopen("pairs.in", "rt", stdin);
  freopen("pairs.out", "wt", stdout);
  scanf("%d%d", &VA, &VB);
  for (i = 0; i < VA; i++)
    while (1)
    {
      scanf("%d", &k);
      if (k == 0)
        break;
      k--;
      CA[i][PA[i]++] = k;
      CB[k][PB[k]++] = i;
    }
  for (i = 0; i < VA; i++)
    if (UA[i] == 0)
      dfs(i);
  for (i = 0; i < VA; i++)
    if (UA[i])
      sum++;
  printf("%d\n", sum);
  for (i = 0; i < VA; i++)
  {
    for (j = 0; j < VB; j++)
      if (Pair[j] == i)
        break;
    printf("%d %d\n", i + 1, j + 1);
  }
  return 0;
}
