#include <fstream>

using namespace std;

ifstream I("twohorse.in");
ofstream O("twohorse.out");

int were[8][8];
int x1,x2,y1,y2;
int turn;

void in(){
	char p1[10],p2[10];
	I>>p1>>p2;
	x1=p1[0]-'a';
	y1=p1[1]-'1';
	x2=p2[0]-'a';
	y2=p2[1]-'1';
	memset(were,0,sizeof(were));
}

struct pos{
	int x,y;
	int turn;
};

pos queue[64];
pos *qs,*qe;

void addpos(pos p){
	if(p.x<0 || p.x>7 || p.y<0 || p.y>7)
		return;
	if(!were[p.x][p.y]){
		*qe=p;
		were[p.x][p.y]=1;
		qe++;
	}
}

void sol(){
	were[x1][y1]=1;
	qs=queue;
	qe=queue+1;
	qs->x=x1;
	qs->y=y1;
	qs->turn=0;
	turn=9999;

	while(qs!=qe){
		if(qs->x<0 || qs->x>7 || qs->y<0 || qs->y>7){
			qs++;
			continue;
		}
		if(qs->x==x2 && qs->y==y2){
			turn=qs->turn;
			return;
		}
		pos p;
		p.turn=qs->turn+1;

		p.x=qs->x+1;
		p.y=qs->y+2;
		addpos(p);

		p.x=qs->x-1;
		p.y=qs->y+2;
		addpos(p);

		p.x=qs->x+1;
		p.y=qs->y-2;
		addpos(p);

		p.x=qs->x-1;
		p.y=qs->y-2;
		addpos(p);

		p.x=qs->x+2;
		p.y=qs->y+1;
		addpos(p);

		p.x=qs->x-2;
		p.y=qs->y+1;
		addpos(p);

		p.x=qs->x+2;
		p.y=qs->y-1;
		addpos(p);

		p.x=qs->x-2;
		p.y=qs->y-1;
		addpos(p);

		qs++;
	}
}

void out(){
	if(turn%2) O<<-1;
	else O<<turn/2;
}    

int main(){
    in();
    sol();
    out();
	return 0;
}                
