#include <stdio.h>

#define mm 200
#define inf 1000000000

int d[mm][4], mark[mm][4], c[mm], a[mm][mm];

int main( void )
{
  int i, j, bi, bj, n, m;

  freopen("filling.in", "r", stdin);
  freopen("filling.out", "w", stdout);
  scanf("%d", &n);
  for (i = 1; i <= n; i++)
    scanf("%d", &c[i]);
  scanf("%d", &m);
  for (i = 1; i <= m; i++)
  {
    int x, y;

    scanf("%d%d", &x, &y);
    a[x][y] = a[y][x] = 1;
  }
  for (i = 1; i <= n; i++)
    d[i][0] = d[i][1] = d[i][2] = d[i][3] = inf;
  d[1][0] = 0;
  while (1)
  {
    bi = bj = -1;
    for (i = 1; i <= n; i++)
      for (j = 0; j < 4; j++)
        if (!mark[i][j] && (bi == -1 || d[bi][bj] > d[i][j]))
          bi = i, bj = j;
    if (bi == -1 || d[bi][bj] == inf)
      break;
    mark[bi][bj] = 1;
    j = bj;
    //printf("%d %d\n", bi, bj);
    if (j == 0)
    {
      if (d[bi][1] > d[bi][0] + c[bi])
        d[bi][1] = d[bi][0] + c[bi];
      if (d[bi][2] > d[bi][0] + c[bi])
        d[bi][2] = d[bi][0] + c[bi];
      if (d[bi][3] > d[bi][0] + c[bi] * 2)
        d[bi][3] = d[bi][0] + c[bi] * 2;
    }
    else if (j == 1)
    {
      if (d[bi][3] > d[bi][1] + c[bi])
        d[bi][3] = d[bi][1] + c[bi];
    }
    else if (j == 2)
    {
      if (d[bi][1] > d[bi][2])
        d[bi][1] = d[bi][2];
      if (d[bi][3] > d[bi][2] + c[bi])
        d[bi][3] = d[bi][2] + c[bi];
    }
    if (j & 1)
    {
      for (i = 1; i <= n; i++)
        if (a[bi][i] && (d[i][j - 1] > d[bi][j]))
          d[i][j - 1] = d[bi][j];
    }
  }
  for (i = j = 0; i < 4; i++)
    if (d[n][i] < d[n][j])
      j = i;
  if (d[n][j] >= inf)
    printf("-1\n");
  else
    printf("%d\n", d[n][j]);
  return 0;
}
