{$A+,B-,D-,E-,F-,G+,I-,L-,N-,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}
   Const File_In='pairs.in';
         File_Out='pairs.out';
         MaxN=250;
   Type Int=Integer;
   Var N,M : Int;
       R : Array [1..MaxN,1..MaxN] Of Boolean;
       P : Array [1..MaxN] Of Int;
       Use : Array [0..MaxN] Of Boolean;

Procedure OpenFiles;
Begin
  Assign(Input,File_In);
  ReSet(Input);
  Assign(Output,File_Out);
  ReWrite(Output);
End;

Procedure Init;
  Var I,J : Int;
Begin
  FIllChar(R,SizeOf(R),False);
  Read(N,M);
  For I :=1 To N Do
    Begin
      Read(J);
      While J<>0 Do
        Begin
          R[I,J] :=True;
          Read(J);
        End;
    End;
End;

Function Dfs(I : Int) : BOolean;
  Var J : Int;
Begin
  If I=0 Then
    Begin
      Dfs :=True;
      Exit;
    End;
  Use[I] :=True;
  For J :=1 To M Do
    If R[I,J] And Not Use[P[J]] And Dfs(P[J]) Then
      Begin
        Dfs :=True;
        P[J] :=I;
        Exit;
      End;
  Dfs :=False;
End;

Procedure Solve;
  Var I,Ans : Int;
Begin
  FilLChar(P,SizeOf(P),0);
  For I :=1 To N Do
    Begin
      FillChar(Use,SizeOf(Use),0);
      Dfs(I);
    End;
  Ans :=0;
  For I :=1 To M Do
    If P[I]<>0 Then Inc(Ans);
  WriteLn(Ans);
  For I :=1 To M Do
    If P[I]<>0 Then
      WriteLn(P[I],' ',I);
End;

Procedure CloseFiles;
Begin
  Close(Input);
  Close(Output);
End;

Begin
  OpenFiles;
  Init;
  Solve;
  CloseFiles;
End.
