program ooo;
const
  filename  = 'sort';
  InFile = FileName+'.in';
  OutFile = FileName+'.out';

type
  TIma = record
           s1, s2 : string[21];
           n : integer;
         end;

var
  i, j, k, l, m, n : longint;
  Ima : array[1..20000] of TIma;
  w : TIma;
  x : string;
  y :  integer;

procedure OpenFile;
var
  s : string;
begin
  assign(input, InFile);
  reset(input);
  readln(n);
  for i:=1 to n do
    begin
    readln(s);
    j:= pos(' ', s);
    ima[i].s1:=copy(s, 1, j);
    ima[i].s2:=copy(s, j+1, length(s)-j);
    ima[i].n:= i;
    end;
  close(input);
end;

procedure QSort(const l, r : longint);
var
  i, j : longint;
begin
  i:= l;
  j:= r;
  x:= ima[(j+i) div 2].s1;
  repeat
    while ima[i].s1< x do inc(i);
    while ima[j].s1> x do dec(j);
    if i<=j then
      begin
      w:= ima[i];
      ima[i]:= ima[j];
      ima[j]:= w;
      inc(i);
      dec(j);
      end;
  until i>=j;
  if i<r then QSort(i, r);
  if l<j then QSort(l, j);
end;


procedure QSortN(l, r: integer);
var
  i, j : longint;
begin
  i:= l;
  j:= r;
  y:= ima[(j+i) div 2].n;
  repeat
    while (ima[i].n< y) and (i<= r) do inc(i);
    while (ima[j].n> y) and (i>= l) do dec(j);
    if i<=j then
      begin
      w:= ima[i];
      ima[i]:= ima[j];
      ima[j]:= w;
      inc(i);
      dec(j);
      end;
  until i>=j;
  if i<r then QSortN(i, r);
  if l<j then QSortN(l, j);
end;

procedure Solve;
begin
  QSort(1, n);
  x:= ima[1].s1;
  for i:=2 to n do
    if ima[i].s1 <> x then
      begin
      if (i-1-j) <> 0 then
         QSortN(j, i-1);
      j:= i;
      x:= ima[i].s1;
      end;
end;

procedure SaveFile;
begin
  assign(output, OutFile);
  rewrite(Output);
  writeln(n);
  for i:=1 to n do
    begin
    Writeln(ima[i].s1+ima[i].s2);
    end;
  close(output);
end;

begin
  OpenFile;
  Solve;
  SaveFile;
end.
