program ProblemP;

{APPTYPE CONSOLE}
{O-}

{

  EVA RULEZZZ!!!!!!!

  Fight with the best? Die like the rest!

  Copyright by [ hr0nix@darkwired ]

}


const
  InFile = 'twohorse.in';
  OutFile = 'twohorse.out';
  dx : array [1..8] of Integer = ( -2, -1,  1,  2, 2, 1, -1, -2 );
  dy : array [1..8] of Integer = ( -1, -2, -2, -1, 1, 2,  2,  1 );

type
  Int = longint;
  Real = extended;
  TState = record
    x1, y1, x2, y2 : Int;
  end;

var
  s1x, s1y, s2x, s2y : Int;
  states : array [1..8, 1..8, 1..8, 1..8] of Int;
  qr, ql : Int;
  q : array [0..8*8*8*8] of TState;

procedure OpenFiles;
begin
  assign( input, InFile );
  reset( input );
  assign( output, OutFile );
  rewrite( output );
end;

procedure CloseFiles;
begin
  close( input );
  close( output );
end;

procedure InitData;
var
  c : char;
begin
  fillchar( states, sizeof( states ), 0 );
  read( c );
  s1x := ord( c ) - ord( 'a' ) + 1;
  read( s1y );
  read( c ); // space
  read( c );
  s2x := ord( c ) - ord( 'a' ) + 1;
  read( s2y );
end;

procedure EnQueue( s : TState );
begin
  inc( qr );
  Q[ qr ] := s;
end;

function DeQueue : TState;
begin
  DeQueue := q[ ql ];
  inc( ql );
end;

procedure Solve;
var
  ns, s : TState;
  i, j : Int;
begin
  ql := 0;
  qr := -1;
  s.x1 := s1x;
  s.x2 := s2x;
  s.y1 := s1y;
  s.y2 := s2y;
  EnQueue( s );
  while Ql <= Qr do begin
    s := DeQueue;
    if ( s.x1 = s.x2 ) and ( s.y1 = s.y2 ) then begin
      writeln( states[ s.x1, s.y1, s.x2, s.y2 ] );
      CloseFiles;
      Halt( 0 );
    end;
    for i := 1 to 8 do
      for j := 1 to 8 do begin
        ns.x1 := s.x1 + dx[ i ];
        ns.y1 := s.y1 + dy[ i ];
        ns.x2 := s.x2 + dx[ j ];
        ns.y2 := s.y2 + dy[ j ];
        if ( ns.x1 <= 0 ) or ( ns.x1 > 8 ) or ( ns.y1 <= 0 ) or ( ns.y1 > 8 ) or
           ( ns.x2 <= 0 ) or ( ns.x2 > 8 ) or ( ns.y2 <= 0 ) or ( ns.y2 > 8 ) then
            continue;
        if states[ ns.x1, ns.y1, ns.x2, ns.y2 ] <> 0 then
          continue;
        states[ ns.x1, ns.y1, ns.x2, ns.y2 ] := states[ s.x1, s.y1, s.x2, s.y2 ] + 1;
        EnQueue( ns );
      end;
  end;
  writeln( -1 );
end;

begin
  OpenFiles;
  InitData;
  Solve;
  CloseFiles;
end.
