{$N+}
{$M 30000000,30000000}
var edg:array[1..11000,1..3]of longint;
    n,m:longint;

procedure Load;
var i:longint;
begin
    read(n,m);
    for i:=1 to m do begin
        read(edg[i,1],edg[i,2],edg[i,3]);
    end;
end;

var dst:array[1..3000]of int64;
    was1,was2:array[1..3000]of longint;

procedure Dfs1(ver:longint);
var i:longint;
begin
    was1[ver]:=1;
    for i:=1 to m do begin
        if ver=edg[i,1] then begin
            if was1[edg[i,2]]=0 then Dfs1(edg[i,2]);
        end;
    end;
end;

procedure Dfs2(ver:longint);
var i:longint;
begin
    was2[ver]:=1;
    for i:=1 to m do begin
        if ver=edg[i,2] then begin
            if was2[edg[i,1]]=0 then Dfs2(edg[i,1]);
        end;
    end;
end;


procedure Solve;
var i,j:longint;
begin
    for i:=1 to n do begin
        dst[i]:=-2000000000;
        dst[i]:=dst[i]*1000;
    end;
    dst[1]:=0;
    for i:=1 to n do begin
        for j:=1 to m do begin
            if dst[edg[j,2]]<dst[edg[j,1]]+edg[j,3] then begin
                dst[edg[j,2]]:=dst[edg[j,1]]+edg[j,3];
            end;
        end;
    end;
    if dst[n]=-2000000000000 then begin
        write(':(');
        exit;
    end;
    fillchar(was1,sizeof(was1),0);
    Dfs1(1);
    fillchar(was2,sizeof(was2),0);
    Dfs2(n);
    for i:=1 to n do begin
        if (was1[i]=1)and(was2[i]=1) then was1[i]:=1
        else was1[i]:=0;
    end;
    for i:=1 to m do begin
        if was1[edg[i,1]]=0 then continue;
        if dst[edg[i,2]]<dst[edg[i,1]]+edg[i,3] then begin
            write(':)');
            exit;
        end;
    end;
    write(dst[n]);
end;

begin
    assign(input,'maze.in');
    assign(output,'maze.out');
    reset(input);
    rewrite(output);
    Load;
    Solve;
    close(input);
    close(output);
end.
