{$A+,B-,D-,E-,F-,G+,I-,L-,N-,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}
   Const File_In='maze.in';
         File_Out='maze.out';
         MaxN=2000;
         MaxM=10000;
         Infinity=MaxLongInt Div 2;
   Type Int=LongInt;
   Var N,M : Int;
       R : Array [1..MaxM,1..3] Of Int;
       D,DLast : Array [1..MaxN] Of Int;

Procedure OpenFiles;
Begin
  Assign(Input,File_In);
  ReSet(Input);
  Assign(Output,File_Out);
  ReWrite(Output);
End;

Procedure Init;
  Var I : Int;
Begin
  Read(N,M);
  For I :=1 To M Do
    Begin
      Read(R[I,1],R[I,2],R[I,3]);
      R[I,3] :=-R[I,3];
    End;
End;

Procedure Solve;
  Var I,J : Int;
Begin
  D[1] :=0;
  For I :=2 To N Do
    D[I] :=Infinity;
  For I :=1 To N-1 Do
    For J :=1 To M Do
      If (D[R[J,1]]<>Infinity) And (D[R[J,2]]>D[R[J,1]]+R[J,3]) Then
        D[R[J,2]] :=D[R[J,1]]+R[J,3];
  DLast :=D;
  For I :=1 To N Do
    For J :=1 To M Do
      If (D[R[J,1]]<>Infinity) And (D[R[J,2]]>D[R[J,1]]+R[J,3]) Then
        D[R[J,2]] :=D[R[J,1]]+R[J,3];
  If D[N]=Infinity Then
    WriteLn(':(')
  Else If D[N]<DLast[N] Then WriteLn(':)')
  Else WriteLn(-D[N]);
End;

Procedure CloseFiles;
Begin
  Close(Input);
  Close(Output);
End;

Begin
  OpenFiles;
  Init;
  Solve;
  CloseFiles;
End.
