#include <fstream>

using namespace std;

ifstream I("floyd.in");
ofstream O("floyd.out");

int N;
double M[100][100];

void in(){
	I>>N;
	for(int i=0;i<N;i++) for(int j=0;j<N;j++){
		double xxx;
		I>>xxx;
		if(xxx==0) M[i][j]=1000000.0f;
		else M[i][j]=xxx;
	}
}

double min(double a,double b){
	if(a>b) return b;
	else return a;
}

void sol(){
	for(int k=0;k<N;k++)
		for(int i=0;i<N;i++)
			for(int j=0;j<N;j++)
				M[i][j]=min(M[i][j],M[i][k]+M[k][j]);
}

void out(){
	int i,j;
	int X[100];
	memset(X,0,sizeof(X));
	for(i=0;i<N;i++)
		for(j=0;j<N;j++)
			if(M[i][j]+M[j][i]<0)
				X[i]=X[j]=1;
	for(i=0;i<N;i++){
		for(j=0;j<N;j++){
			if(M[i][j]>20000.0f) O<<"0 ";
			else if(X[i] || X[j]) O<<"2 ";
			else O<<"1 ";
		}
		O<<endl;
	}
}    

int main(){
    in();
    sol();
    out();
	return 0;
}                
