{$ifdef DEBUG}
  {$I+,Q+,R+,S-}
{$else}
  {$I-,Q-,R-,S-}
{$endif}

program Temp;
const infile = 'floyd.in';
      outfile = 'floyd.out';
      inf = 10000000;
      MAXN = 100;
var dist : array[0..MAXN, 0..MAXN] of longint;
    N : integer;

procedure ReadData;
var i, j : integer;
begin
  assign(input, infile); reset(input);
  assign(output, outfile); rewrite(output);
  read(n);
  for i:=1 to n do
    for j:=1 to n do begin
      read(dist[i, j]);
      if dist[i, j]=0 then dist[i, j]:=inf;
    end;
end;

procedure Solve;
var i, j, k : integer;
    b : boolean;
begin
  for j:=1 to n do
    for i:=1 to n do begin
      if dist[i, j]=inf then continue;

      for k:=1 to n do
        if (dist[j, k]<inf)and(dist[i, k]>dist[i, j]+dist[j, k]) then
          dist[i, k]:=dist[i, j]+dist[j, k];
    end;
  for i:=1 to n do begin
    for j:=1 to n do begin
      if dist[i, j]>=1000000 then begin write('0'); if j<n then write(' '); continue; end;
      b:=false;
      for k:=1 to n do
        if dist[i, k]+dist[k, j]<dist[i, j] then b:=true;

      if b then write('2') else write('1');
      if j<n then write(' ');
    end;
    if i<n then writeln;
  end;
end;

procedure WriteData;
begin
  close(input);
  close(output);
end;

begin
  ReadData;
  Solve;
  WriteData;
end.
