type
  TOrient=(oLeft,oCenter,oRight);
  TTable=array[1..100,1..100] of string;
var
  SrcFile,ResFile: Text;
  M,N: Word;
  A: array[1..100] of TOrient;
  LC: array[1..100] of Word;
  T: TTable;

procedure Convert(St: string; const k: Word);
var
  i: Word;
begin
  St:=St+'&';
  for i:=1 to N do
  begin
    T[k,i]:=Copy(St,1,pos('&',St)-1);
    Delete(St,1,pos('&',St));
  end;
end;

procedure ReadData;
var
  Ch: Char;
  St: string;
begin
  Assign(SrcFile,'formatting.in');
  Reset(SrcFile);
  M:=0;
  N:=0;
  while not(Eoln(SrcFile)) do
  begin
    Inc(N);
    Read(SrcFile,Ch);
    case Ch of
    'l':A[N]:=oLeft;
    'c':A[N]:=oCenter;
    'r':A[N]:=oRight;
    end;
  end;
  Readln(SrcFile);

  while not(Eof(SrcFile)) do
  begin
    Inc(M);
    Readln(SrcFile,St);
    Convert(St,M);
  end;
  Close(SrcFile);
end;

procedure GetMaxLen;
var
  i,j: Word;
begin
  for i:=1 to N do
  begin
    LC[i]:=Length(T[1,i]);
    for j:=1 to M do
      if Length(T[j,i])>LC[i] then
        LC[i]:=Length(T[j,i]);
  end;
end;
procedure WriteLine;
var
  i,j: Word;
begin
  for i:=1 to N do
  begin
     Write(ResFile,'+');
     for j:=1 to LC[i]+2 do
       Write(ResFile,'-');
  end;
  Writeln(ResFile,'+');
end;
procedure WriteStr(const k: Word);
var
  i: Word;
  St: string;
begin
  for i:=1 to N do
  begin
    Write(ResFile,'| ');
    St:=T[k,i];
    case A[i] of
      oLeft: while Length(St)<LC[i] do
               Insert(' ',St,Length(St)+1);
      oCenter: while Length(St)<LC[i] do
               begin
                 Insert(' ',St,1);
                 Insert(' ',St,Length(St)+1);
               end;
      oRight: while Length(St)<LC[i] do
               Insert(' ',St,1);
    end;
    if Length(St)>LC[i] then
      Delete(St,1,1);
    Write(ResFile,St,' ');
  end;
  Writeln(ResFile,'|');
end;
procedure Solve;
var
  i: Word;
begin
  Assign(ResFile,'formatting.out');
  Rewrite(ResFile);

  GetMaxLen;
  WriteLine;
  WriteStr(1);
  WriteLine;
  for i:=2 to M do
    WriteStr(i);
  WriteLine;
  Close(ResFile);
end;

begin
  ReadData;
  Solve;
end.