{$I+,Q+,R+,S+}
{$M 1048576,0}
const taskid='convex';
      inf=taskid+'.in';
      ouf=taskid+'.out';
var n,c,sl:longint;
    x,y,st:array [1..20000] of longint;
procedure init;
var i:longint;
begin
  assign(input,inf);
  reset(input);
  read(n);
  for i:=1 to n do
    read(x[i],y[i]);
  close(input);
end;
function vec(X1,y1,x2,y2:longint):longint;
begin
  vec:=x1*y2-x2*Y1;
end;
function dist(x1,y1,x2,y2:longint):longint;
begin
  dist:=sqr(x1-x2)+sqr(y1-y2);
end;
function less(x1,y1,x2,y2:longint):boolean;
var v,d1,d2:longint;
begin
  v:=vec(x1-x[1],y1-y[1],x2-x[1],y2-y[1])*c;
  d1:=dist(x[1],y[1],x1,y1);
  d2:=dist(x[1],y[1],x2,y2);
  less:=(v>0) or (v=0) and (d1<d2);
end;
procedure qsort(l,r:longint);
var i,j,mx,my,t:longint;
begin
  i:=l;
  j:=r;
  mx:=x[(l+r) shr 1];
  my:=y[(l+r) shr 1];
  repeat
    while less(x[i],y[i],mx,my) do
      inc(i);
    while less(mx,my,x[j],y[j]) do
      dec(j);
    if i<=j then
    begin
      t:=x[i];
      x[i]:=x[j];
      x[j]:=t;
      t:=y[i];
      y[i]:=y[j];
      y[j]:=t;
      inc(i);
      dec(j);
    end;
  until i>j;
  if l<j then
    qsort(l,j);
  if i<r then
    qsort(i,r);
end;
procedure run;
var min,i,t:longint;
begin
  c:=1-2*(n and 1);
  min:=1;
  for i:=2 to n do
    if (x[i]<x[min]) or (x[i]=x[min]) and (y[i]<y[min]) then
      min:=i;
  t:=x[1];
  x[1]:=x[min];
  x[min]:=t;
  t:=y[1];
  y[1]:=y[min];
  y[min]:=t;
  if n>2 then
    qsort(2,n);
  min:=1;
  for i:=2 to n do
    if (x[i]<>x[i-1]) or (y[i]<>y[i-1]) then
    begin
      inc(min);
      x[min]:=x[i];
      y[min]:=y[i];
    end;
  n:=min;
  if n=1 then
  begin
    assign(output,'convex.out');
    rewrite(output);
    writeln(1);
    writeln(x[1],' ',y[1]);
    close(output);
    halt;
  end;
  st[1]:=1;
  st[2]:=2;
  sl:=2;
  for i:=3 to n do
  begin
    while (sl>1) and (vec(x[st[sl]]-x[st[sl-1]],y[st[sl]]-y[st[sl-1]],x[i]-x[st[sl-1]],y[i]-y[st[sl-1]])*c<=0) do
      dec(sl);
    inc(sl);
    st[sl]:=i;
  end;
end;
procedure done;
var i:longint;
begin
  assign(output,ouf);
  rewrite(output);
  writeln(sl);
  for i:=1 to sl do
    writeln(x[st[i]],' ',y[st[i]]);
  close(output);
end;
begin
  init;
  run;
  done;
end.
