{$A+,B-,D-,E-,F-,G+,I-,L-,N-,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}
   Const File_In='twohorse.in';
         File_Out='twohorse.out';
         Turn : Array [1..8,1..2] Of Integer=((1,2),(-1,-2),(-1,2),(1,-2),(2,1),(-2,-1),(2,-1),(-2,1));
   Type Int=Integer;
   Var Map : Array [-1..10,-1..10,-1..10,-1..10] Of Boolean;
       Queue : Array [1..8*8*8*8+1,1..5] Of Int;
       First : Array [1..4] Of Int;

Procedure OpenFiles;
Begin
  Assign(Input,File_In);
  ReSet(Input);
  Assign(Output,File_Out);
  ReWrite(Output);
End;

Procedure Init;
  Var Sym : Char;
Begin
  Read(Sym);
  While Not (Sym In ['a'..'h']) Do read(Sym);
  First[1] :=Ord(Sym)-Ord('a')+1;
  Read(First[2]);
  Read(Sym);
  While Not (Sym In ['a'..'h']) Do read(Sym);
  First[3] :=Ord(Sym)-Ord('a')+1;
  Read(First[4]);
End;

Procedure Solve;
  Var Now,Len,I,J,K,L : Int;
Begin
  FillChar(Map,SizeOf(Map),False);
  FillChar(Queue,SizeOf(Queue),0);
  For I :=-1 To 10 Do
    For J :=-1 To 10 Do
      For K :=-1 To 10 Do
        For L :=-1 To 10 Do
          If (K=-1) Or (K=0) Or (K=9) Or (K=10)
          Or (L=-1) Or (L=0) Or (L=9) Or (L=10)
          Or (I=-1) Or (I=0) Or (I=9) Or (I=10)
          Or (J=-1) Or (J=0) Or (J=9) Or (J=10) Then
            Map[I,J,K,L] :=True;
  Now :=1;
  Len :=1;
  Map[First[1],First[2],First[3],First[4]] :=True;
  Queue[1,1] :=First[1];
  Queue[1,2] :=First[2];
  Queue[1,3] :=First[3];
  Queue[1,4] :=First[4];
  Queue[1,5] :=0;
  While Now<=Len Do
    Begin
      If (Queue[Now,1]=Queue[Now,3]) And (Queue[Now,2]=Queue[Now,4]) Then
        Break;
      For I :=1 To 8 Do
        For J :=1 To 8 Do
          If Not Map[Queue[Now,1]+Turn[I,1],Queue[Now,2]+Turn[I,2],Queue[Now,3]+Turn[J,1],Queue[Now,4]+Turn[J,2]] Then
            Begin
              Map[Queue[Now,1]+Turn[I,1],Queue[Now,2]+Turn[I,2],Queue[Now,3]+Turn[J,1],Queue[Now,4]+Turn[J,2]] :=True;
              Inc(Len);
              Queue[Len,5] :=Queue[Now,5]+1;
              Queue[Len,1] :=Queue[Now,1]+Turn[I,1];
              Queue[Len,2] :=Queue[Now,2]+Turn[I,2];
              Queue[Len,3] :=Queue[Now,3]+Turn[J,1];
              Queue[Len,4] :=Queue[Now,4]+Turn[J,2];
            End;
      Inc(Now);
    End;
  If (Now<=Len) And (Queue[Now,1]=Queue[Now,3]) And (Queue[Now,2]=Queue[Now,4]) Then
    WriteLn(Queue[Now,5])
  Else WriteLn('-1');
End;

Procedure CloseFiles;
Begin
  Close(Input);
  Close(Output);
End;

Begin
  OpenFiles;
  Init;
  Solve;
  CloseFiles;
End.
