#include <stdio.h>

#define maxn 100

int w[maxn][maxn];
int is[maxn][maxn];
int u[maxn], n;

void dfs( int v )
{
  int i;

  u[v] = 1;
  for (i = 0; i < n; i++)
    if (!u[i] && w[v][i] != 0)
      dfs(i);
}

int main( void )
{
  int i, j, k;

  freopen("floyd.in", "rt", stdin);
  freopen("floyd.out", "wt", stdout);
  scanf("%d", &n);
  for (i = 0; i < n; i++)
    for (j = 0; j < n; j++)
      scanf("%d", &w[i][j]);
  for (k = 0; k < n; k++)
    for (i = 0; i < n; i++)
      for (j = 0; j < n; j++)
        if (w[i][k] != 0 && w[k][j] != 0 && w[i][j] > w[i][k] + w[k][j])
          w[i][j] = w[i][k] + w[k][j];
  memset(is, 0, sizeof(is));
  for (i = 0; i < n; i++)
    for (j = 0; j < n; j++)
      if (w[i][j] != 0 || i == j)
        is[i][j] = 1;
  for (i = 0; i < n; i++)
    if (w[i][i] < 0)
    {
      memset(u, 0, sizeof(u));
      dfs(i);
      for (j = 0; j < n; j++)
        if (u[j])
          is[i][j] = 2;
    }
  for (i = 0; i < n; i++)
    for (j = 0; j < n; j++)
      printf(j == n - 1 ? "%d\n" : "%d ", is[i][j]);
  return 0;
}
