{$ifdef DEBUG}
  {$I+,Q+,R+,S-}
{$else}
  {$I-,Q-,R-,S-}
{$endif}

program Temp;
const infile = 'sort.in';
      outfile = 'sort.out';
type integer=longint;
tRecord = record
  f : string[20];
  all : string[40];
  id : integer;
end;
var g : array[1..20000] of tRecord;
    n : integer;

procedure ReadData;
var i : integer;

function ReadF(st : string) : string;
var tmp : string[20];
    i : integer;
begin
  tmp:='';
  for i:=1 to length(st) do begin
    if st[i]=' ' then break;
    tmp:=tmp+st[i];
  end;
  ReadF:=tmp;
end;

begin
  assign(input, infile); reset(input);
  assign(output, outfile); rewrite(output);
  readln(N);
  for i:=1 to N do begin
    readln(g[i].all);
    g[i].f:=ReadF(g[i].all);
    g[i].id:=i;
  end;
end;

procedure swap(var a, b : tRecord);
var t : tRecord;
begin
  t:=a; a:=b; b:=t;
end;

procedure Sort;
var i : integer;

procedure Heapify(i, hs : integer);
var l, r, lrg : longint;
begin
  while true do begin
    l:=2*i; r:=2*i+1; lrg:=i;
    if (l<=hs)and((g[l].f>g[lrg].f)or((g[l].f=g[lrg].f)and(g[l].id>g[lrg].id))) then lrg:=l;
    if (r<=hs)and((g[r].f>g[lrg].f)or((g[r].f=g[lrg].f)and(g[r].id>g[lrg].id))) then lrg:=r;
    if lrg=i then break;
    swap(g[i], g[lrg]);
    i:=lrg;
  end;
end;

begin
  for i:=(n div 2) downto 1 do
    Heapify(i, n);
  for i:=n downto 2 do begin
    swap(g[1], g[i]);
    Heapify(1, i-1);
  end;
end;

procedure Solve;
var i : integer;
begin
  Sort;
  writeln(n);
  for i:=1 to n do
    writeln(g[i].all);
end;

procedure WriteData;
begin
  close(input);
  close(output);
end;

begin
  ReadData;
  Solve;
  WriteData;
end.
