  {$I-,Q-,R-,S-}
const
    sym=['a'..'z','0'..'9'];
    maxn=8*8*8*8*2;
    dx:array[1..8] of longint=(1,2,2,1,-1,-2,-2,-1);
    dy:array[1..8] of longint=(2,1,-1,-2,-2,-1,1,2);
type tpoint=record x,y:longint; end;
var u,v:tpoint;
    que:array[1..maxn] of record len:longint; p1,p2:tpoint; end;
    used:array[1..8,1..8,1..8,1..8] of boolean;

Procedure readsost(var a:TPoint);
var ch:char;
begin
    read(ch);
    while not (ch in sym) do read(ch);
    a.x:=ord(ch)-96;
    read(ch);
    a.y:=ord(ch)-48;
end;

Procedure print(const q:longint);
begin
    writeln(q);
    close(input);
    close(output);
    halt;
end;

Function eq(const a,b:TPoint):boolean;
begin
    eq:=(a.x=b.x)and(a.y=b.y);
end;

Procedure BFS;
var i,cnt,h1,h2,x1,y1,x2,y2:longint;
begin
    if eq(u,v) then print(0);
    used[u.x,u.y,v.x,v.y]:=true;
    que[1].len:=0;
    que[1].p1:=u;
    que[1].p2:=v;
    i:=1;
    cnt:=1;
    while i<=cnt do
    begin
        for h1:=1 to 8 do
        for h2:=1 to 8 do
        begin
            x1:=que[i].p1.x+dx[h1];
            y1:=que[i].p1.y+dy[h1];
            x2:=que[i].p2.x+dx[h2];
            y2:=que[i].p2.y+dy[h2];
            if (x1>8)or(x1<1)or(y1>8)or(y1<1)or
               (x2>8)or(x2<1)or(y2>8)or(y2<1) then continue;
            if not used[x1,y1,x2,y2] then
            begin
                used[x1,y1,x2,y2]:=true;
                inc(cnt);
                que[cnt].len:=que[i].len+1;
                que[cnt].p1.x:=x1;
                que[cnt].p1.y:=y1;
                que[cnt].p2.x:=x2;
                que[cnt].p2.y:=y2;
                if eq(que[cnt].p1,que[cnt].p2) then print(que[cnt].len);
            end;
        end;
        inc(i);
    end;
    print(-1);
end;

begin
    assign(input,'twohorse.in');
    reset(input);
    assign(output,'twohorse.out');
    rewrite(output);
    readsost(u);
    readsost(v);
    BFS;
    close(input);
    close(output);
end.