{$N+}
const di:array[1..8]of longint=(-1,1,-1,1,-2,2,-2,2);
const dj:array[1..8]of longint=(-2,2,2,-2,1,-1,-1,1);
var b11,b12,b21,b22:longint;

procedure Load;
var c:char;
begin
    read(c);
    while(c=' ')or(c=#13)or(c=#10) do read(c);
    b11:=ord(c)-ord('a')+1;
    read(c);
    while(c=' ')or(c=#13)or(c=#10) do read(c);
    b12:=ord(c)-ord('1')+1;
    read(c);
    while(c=' ')or(c=#13)or(c=#10) do read(c);
    b21:=ord(c)-ord('a')+1;
    read(c);
    while(c=' ')or(c=#13)or(c=#10) do read(c);
    b22:=ord(c)-ord('1')+1;
end;

var dist:array[1..8,1..8,1..8,1..8]of longint;
    q:array[1..70000,1..4]of longint;
    hd,tl:longint;

function Inside(i,j:longint):boolean;
begin
    if(i>=1)and(i<=8)and(j>=1)and(j<=8) then Inside:=true
    else Inside:=false;
end;

procedure Solve;
var i,j,k,ii:longint;
    n11,n12,n21,n22:longint;
begin
    for i:=1 to 8 do for j:=1 to 8  do for k:=1 to 8 do for ii:=1 to 8 do dist[i,j,k,ii]:=2000000000;
    dist[b11,b12,b21,b22]:=0;
    hd:=1;
    tl:=1;
    q[1,1]:=b11;
    q[1,2]:=b12;
    q[1,3]:=b21;
    q[1,4]:=b22;
    while hd<=tl do begin
        b11:=q[hd,1];
        b12:=q[hd,2];
        b21:=q[hd,3];
        b22:=q[hd,4];
        if(b11=b21)and(b12=b22)then begin
            write(dist[b11,b12,b21,b22]);
            exit;
        end;
        for i:=1 to 8 do begin
            n11:=b11+di[i];
            n12:=b12+dj[i];
            if not Inside(n11,n12) then continue;
            for j:=1 to 8 do begin
                n21:=b21+di[j];
                n22:=b22+dj[j];
                if not Inside(n21,n22) then continue;
                if dist[n11,n12,n21,n22]>dist[b11,b12,b21,b22]+1 then begin
                    dist[n11,n12,n21,n22]:=dist[b11,b12,b21,b22]+1;
                    inc(tl);
                    q[tl,1]:=n11;
                    q[tl,2]:=n12;
                    q[tl,3]:=n21;
                    q[tl,4]:=n22;
                end;
            end;
        end;
        inc(hd);
    end;
    write('-1');
end;

begin
    assign(input,'twohorse.in');
    assign(output,'twohorse.out');
    reset(input);
    rewrite(output);
    Load;
    Solve;
    close(input);
    close(output);
end.
