{$q+,r+,n-}

const cinfile = 'twohorse.in';
      coutfile = 'twohorse.out';

const nmax = 9;
      inf = maxlongint shr 1;

type int = longint;
     tpoint = array[1..2] of int;

var a, b : array[1..nmax, 1..nmax] of int;
    s1, s2 : tpoint;

procedure init;
var c1 : char;
begin
   repeat
      read(c1);
   until c1 in ['a'..'h'];
   s1[1]:=ord(c1) - ord('a') + 1;
   read(c1);
   s1[2]:=ord(c1) - ord('1') + 1;
   repeat
      read(c1);
   until c1 in ['a'..'h'];
   s2[1]:=ord(c1) - ord('a') + 1;
   read(c1);
   s2[2]:=ord(c1) - ord('1') + 1;
end;

procedure solve;
var l, r : int;
    t : tpoint;
    q : array[1..nmax*nmax*nmax] of tpoint;
   procedure add(x, y : int);
   begin
      if (x >= 1) and (x <= 8) and (y >= 1) and (y <= 8) then begin
         if a[x, y] <> 10000 then exit;
         a[x, y]:=a[t[1], t[2]] + 1;
         inc(r);
         q[r, 1]:=x;
         q[r, 2]:=y;
      end;
   end;
   procedure bdd(x, y : int);
   begin
      if (x >= 1) and (x <= 8) and (y >= 1) and (y <= 8) then begin
         if b[x, y] <> 10000 then exit;
         b[x, y]:=b[t[1], t[2]] + 1;
         inc(r);
         q[r, 1]:=x;
         q[r, 2]:=y;
      end;
   end;
begin
   for l:=1 to 8 do
      for r:=1 to 8 do begin
         a[l, r]:=10000;
         b[l, r]:=10000;
      end;

   l:=0;
   r:=1;
   q[1]:=s1;
   a[s1[1]][s1[2]]:=0;
   while l < r do begin
      inc(l);
      t:=q[l];
      add(t[1]-2, t[2]-1);
      add(t[1]-2, t[2]+1);
      add(t[1]-1, t[2]-2);
      add(t[1]-1, t[2]+2);
      add(t[1]+1, t[2]-2);
      add(t[1]+1, t[2]+2);
      add(t[1]+2, t[2]-1);
      add(t[1]+2, t[2]+1);
   end;

   l:=0;
   r:=1;
   q[1]:=s2;
   b[s2[1]][s2[2]]:=0;
   while l < r do begin
      inc(l);
      t:=q[l];
      bdd(t[1]-2, t[2]-1);
      bdd(t[1]-2, t[2]+1);
      bdd(t[1]-1, t[2]-2);
      bdd(t[1]-1, t[2]+2);
      bdd(t[1]+1, t[2]-2);
      bdd(t[1]+1, t[2]+2);
      bdd(t[1]+2, t[2]-1);
      bdd(t[1]+2, t[2]+1);
   end;
end;

procedure writeanswer;
var i, j : int;
    min : tpoint;
begin
   min[1]:=1;
   min[2]:=1;
   for i:=1 to 8 do
      for j:=1 to 8 do
         if (a[i, j] = b[i, j]) then
            if (a[min[1], min[2]] <> b[min[1], min[2]]) or
               ((a[min[1], min[2]] = b[min[1], min[2]]) and
                (a[min[1], min[2]] > a[i, j]))
            then begin
               min[1]:=i;
               min[2]:=j;
            end;

   if a[min[1], min[2]] = 10000 then write('-1') else
      if a[min[1], min[2]] = b[min[1], min[2]]
      then write(a[min[1], min[2]])
      else write('-1');
end;

begin
   assign(input, cinfile); reset(input);
   assign(output, coutfile); rewrite(output);
   init;
   solve;
   writeanswer;
   close(input); close(output);
end.