{$ifdef DEBUG}
  {$I+,Q+,R+,S-}
{$else}
  {$I-,Q-,R-,S-}
{$endif}

program Temp;
const infile = 'substr.in';
      outfile = 'substr.out';
var a : array[1..10000] of char;
    pf : array[1..10000] of integer;
    la : integer;

procedure WriteData;
begin
  close(input);
  close(output);
end;

function GetChar : char;
var ch : char;
begin
  read(ch); if (ch in [#33..#126]) then begin GetChar:=ch; exit; end;
  while (not (ch in [#33..#126]))and(not eof(input)) do
    read(ch);
  if seekeof(input) then begin
    WriteData;
    halt(0);
  end;
  GetChar:=ch;
end;

procedure ReadData;
var ch : char;
begin
  assign(input, infile); reset(input);
  assign(output, outfile); rewrite(output);
  la:=0;
  ch:=GetChar;
  while ch<>'*' do begin
    inc(la); a[la]:=ch;
    ch:=GetChar;
  end;
end;

procedure CPF;
var k, q : integer;
begin
  pf[1]:=0; k:=0;
  for q:=2 to la do begin
    while (k>0)and(a[k+1]<>a[q]) do k:=pf[k];
    if a[k+1]=a[q] then inc(k);
    pf[q]:=k;
  end;
end;

procedure Solve;
var i, q : longint;
    ch : char;
begin
  CPF; q:=0;
  for i:=1 to 300000 do begin
    ch:=GetChar;
    while (q>0)and(a[q+1]<>ch) do q:=pf[q];
    if a[q+1]=ch then inc(q);
    if q=la then begin
      writeln(i-la+1);
      q:=pf[q];
    end;
  end;
end;

begin
  ReadData;
  Solve;
  WriteData;
end.
