  {$I-,Q-,R-,S-}
const
    maxn=60000;

type TPoint=record x,y:longint; end;

var n,i,k,dx,dy:longint;
    a:array[1..maxn] of TPoint;
    st:array[0..maxn] of longint;

Function vp(const a,b:TPoint):longint;
begin
    vp:=a.x*b.y-a.y*b.x;
end;

Function getvec(const a,b:TPoint):Tpoint;
begin
    getvec.x:=a.x-b.x;
    getvec.y:=a.y-b.y;
end;

Procedure update;
var v1,v2:TPoint;
    t:longint;
begin
    while st[0]>2 do
    begin
        v1:=getvec(a[st[st[0]]],a[st[st[0]-2]]);
        v2:=getvec(a[st[st[0]-1]],a[st[st[0]-2]]);
        t:=vp(v1,v2);
        if t>=0 then
        begin
            st[st[0]-1]:=st[st[0]];
            dec(st[0]);
        end else exit;
    end;
end;

Procedure SwapP(var a,b:TPoint);
var t:TPoint;
begin
    t:=a;
    a:=b;
    b:=t;
end;

Function len(const a:TPoint):longint;
begin
    len:=sqr(a.x)+sqr(a.y);
end;

Function more(const a,b:TPoint):boolean;
var t:longint;
begin
    t:=vp(a,b);
    if t<0 then more:=true else
    if t>0 then more:=false else
    if len(a)>len(b) then more:=true else more:=false;
end;

Procedure qsort(const l,r:longint);
var i,j:longint;
    x:TPoint;
begin
    i:=l;
    j:=r;
    x:=a[(l+r) div 2];
    repeat
        while more(x,a[i]) do inc(i);
        while more(a[j],x) do dec(j);
        if i<=j then
        begin
            swapP(a[i],a[j]);
            inc(i);
            dec(j);
        end;
    until i>j;
    if i<r then qsort(i,r);
    if j>l then qsort(L,j);
end;

begin
    assign(input,'convex.in');
    reset(input);
    assign(output,'ccnvex.out');
    rewrite(output);

    read(n);
    for i:=1 to n do read(a[i].x,a[i].y);

    k:=1; dx:=a[1].x; dy:=a[1].y;

    for i:=1 to n do
    begin
        if a[i].y<dy then
        begin
            dx:=a[i].x;
            dy:=a[i].y;
            k:=i;
        end else
        if (a[i].y=dy)and(a[i].x<dx) then
        begin
            dx:=a[i].x;
            dy:=a[i].y;
            k:=i;
        end;
    end;

    swapP(a[1],a[k]);

    for i:=1 to n do
    begin
        a[i].x:=a[i].x-dx;
        a[i].y:=a[i].y-dy;
    end;

    qsort(1,n);

    if n<=2 then
    begin
        writeln(n);
        for i:=1 to n do writeln(a[i].x+dx,' ',a[i].y+dy);
        close(input);
        close(output);
        halt;
    end;

    st[0]:=1;
    st[st[0]]:=1;

    for i:=2 to n do
    begin
        inc(st[0]);
        st[st[0]]:=i;
        update;
    end;

    writeln(st[0]);
    if n mod 2=1 then for i:=st[0] downto 1 do writeln(a[st[i]].x+dx,' ',a[st[i]].y+dy,' ') else
                   for i:=1 to st[0] do writeln(a[st[i]].x+dx,' ',a[st[i]].y+dy,' ');

    close(input);
    close(output);
end.
