{$q+,r+,n-}

const cinfile = 'pairs.in';
      coutfile = 'pairs.out';

const nmax = 300;
      inf = maxlongint shr 1;

type int = longint;

var d : array[0..nmax, 0..nmax] of int;
    wx, wy : array[0..nmax] of int;
    use : array[0..nmax] of byte;
    n, m, cnt : int;

procedure init;
var i, j : int;
begin
   fillchar(d, sizeof(d), 0);
   read(n, m);
   for i:=1 to n do begin
      read(j);
      while j <> 0 do begin
         d[i, j]:=1;
         read(j);
      end;
   end;
end;

procedure solve;
var i : int;
   function dfs(x : int) : boolean;
   var j : int;
   begin
      if x = 0 then begin
         dfs:=true;
         exit;
      end;
      use[x]:=1;
      for j:=1 to m do
         if (d[x, j] = 1) and (use[wy[j]] = 0) then
            if dfs(wy[j]) then begin
               wy[j]:=x;
               wx[x]:=j;
               dfs:=true;
               exit;
            end;
      dfs:=false;
   end;
begin
   fillchar(wx, sizeof(wx), 0);
   fillchar(wy, sizeof(wy), 0);
   cnt:=0;
   for i:=1 to n do
      if wx[i] = 0 then begin
         fillchar(use, sizeof(use), 0);
         if dfs(i) then inc(cnt);
      end;
end;

procedure writeanswer;
var i : int;
begin
   writeln(cnt);
   for i:=1 to m do
      if wy[i] <> 0 then writeln(wy[i], ' ', i);
end;

begin
   assign(input, cinfile); reset(input);
   assign(output, coutfile); rewrite(output);
   init;
   solve;
   writeanswer;
   close(input); close(output);
end.
