#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define maxc 200
#define maxr 200
#define maxl 300

char align[maxc];
char buf[maxl];
int rows, cols;
char cell[maxr][maxc][maxl];
int len[maxr][maxc];
int wid[maxc];

void prn( char *d, char *s, char al, int wid )
{
  int i, l;

  l = strlen(s);
  memset(d, ' ', sizeof(char) * wid);
  d[wid] = 0;
  if (al == 'l')
    for (i = 0; i < l; i++)
      d[i] = s[i];
  else if (al == 'r')
    for (i = 0; i < l; i++)
      d[wid - i - 1] = s[l - i - 1];
  else
    for (i = 0; i < l; i++)
      d[i + (wid - l) / 2] = s[i];
}

int main( void )
{
  int i, j, k;

  freopen("formatting.in", "rt", stdin);
  freopen("formatting.out", "wt", stdout);
  scanf("%s\n", align);
  cols = strlen(align);
  rows = 0;
  memset(len, 0, sizeof(len));
  while (gets(buf))
  {
    for (i = j = 0; buf[i]; i++)
      if (buf[i] == '&')
        j++;
      else
        cell[rows][j][len[rows][j]++] = buf[i];
    rows++;
  }
  for (i = 0; i < cols; i++)
    for (j = wid[i] = 0; j < rows; j++)
      if (len[j][i] > wid[i])
        wid[i] = len[j][i];
  for (i = 0; i < cols; i++)
  {
    printf("+");
    for (j = 0; j < wid[i] + 2; j++)
      printf("-");
  }
  printf("+\n");
  for (i = 0; i < cols; i++)
  {
    prn(buf, cell[0][i], align[i], wid[i]);
    printf("| %s ", buf);
  }
  printf("|\n");
  for (i = 0; i < cols; i++)
  {
    printf("+");
    for (j = 0; j < wid[i] + 2; j++)
      printf("-");
  }
  printf("+\n");
  for (k = 1; k < rows; k++)
  {
    for (i = 0; i < cols; i++)
    {
      prn(buf, cell[k][i], align[i], wid[i]);
      printf("| %s ", buf);
    }
    printf("|\n");
  }
  for (i = 0; i < cols; i++)
  {
    printf("+");
    for (j = 0; j < wid[i] + 2; j++)
      printf("-");
  }
  printf("+");
  return 0;
}
