#include <stdio.h>

#define m 10000

typedef struct
{
  int i1, j1, i2, j2;
}
pnt;

int dd[m], mark[10][10][10][10],
   d[8][2] = {{2, 1}, {2, -1}, {-2, 1}, {-2, -1},
              {1, 2}, {1, -2}, {-1, 2}, {-1, -2}};
pnt q[m];

int good( int i, int j, int t )
{
  int ii = i + d[t][0], jj = j + d[t][1];

  if (ii < 0 || jj < 0 || ii > 7 || j > 7)
    return 0;
  return 1;
}

int main( void )
{
  int i, p1, p2, l, i2, j2, i1, j1, t1, t2;
  char c1, c2;

  freopen("twohorse.in", "r", stdin);
  freopen("twohorse.out", "w", stdout);
  scanf(" %c%d %c%d", &c1, &p1, &c2, &p2);
  i1 = c1 - 'a';
  j1 = p1 - 1;
  i2 = c2 - 'a';
  j2 = p2 - 1;
  q[l = 1].i1 = i1;
  q[1].j1 = j1;
  q[1].i2 = i2;
  q[1].j2 = j2;
  mark[i1][j1][i2][j2] = 1;
  if (i1 == i2 && j1 == j2)
  {
    printf("0\n");
    return 0;
  }
  for (i = 1; i <= l; i++)
  {
    int i1 = q[i].i1, j1 = q[i].j1, i2 = q[i].i2, j2 = q[i].j2;

    for (t1 = 0; t1 < 8; t1++)
      for (t2 = 0; t2 < 8; t2++)
      {
        if (good(i1, j1, t1) && good(i2, j2, t2)
        && !mark[i1 + d[t1][0]][j1 + d[t1][1]][i2 + d[t2][0]][j2 + d[t2][1]])
        {
          mark[i1 + d[t1][0]][j1 + d[t1][1]][i2 + d[t2][0]][j2 + d[t2][1]] = 1;
          q[++l].i1 = i1 + d[t1][0];
          q[l].j1 = j1 + d[t1][1];
          q[l].i2 = i2 + d[t2][0];
          q[l].j2 = j2 + d[t2][1];
          dd[l] = dd[i] + 1;
          if (q[l].i1 == q[l].i2 && q[l].j1 == q[l].j2)
          {
            printf("%d\n", dd[l]);
            return 0;
          }
        }
      }
  }
  printf("-1\n");
  return 0;
}
