{$A+,B-,D-,E-,F-,G+,I-,L-,N+,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}
   Const File_In='cicle.in';
         File_Out='cicle.out';
         MaxN=100;
         Infinity=100000;
   Type Int=LongInt;
   Var N : Int;
       R,Map,From : Array [1..MaxN,1..MaxN] Of Int;
       D,DLast : Array [0..MaxN] Of Int;
       Ok : Boolean;

Procedure OpenFiles;
Begin
  Assign(Input,File_In);
  ReSet(Input);
  Assign(Output,File_Out);
  ReWrite(Output);
End;

Procedure Init;
  Var I,J : Int;
Begin
  Read(N);
  For I :=1 To N Do
    For J :=1 To N Do
      Read(Map[I,J]);
  R :=Map;
End;

Procedure WriteAnswer(I,J : Int);
Begin
  If I>0 Then WriteAnswer(I-1,From[I,J]);
  Write(J,' ');
End;

Procedure Solve;
  Var C,I,J,K : Int;
Begin
  FillChar(From,SizeOf(From),0);
  For K :=1 To N Do
    For I :=1 To N Do
      For J :=1 To N Do
        If (Map[I,J]>Map[I,K]+Map[K,J]) And (Map[I,K]<>Infinity) And (Map[K,J]<>Infinity) Then
          Map[I,J] :=Map[I,K]+Map[K,J];
  For C :=1 To N Do
    If Map[C,C]<0 Then
      Begin
        WriteLn('YES');
        For J :=1 To N Do
          D[J] :=Infinity;
        D[C] :=0;
        For I :=1 To N Do
          Begin
            DLast :=D;
            For J :=1 To N Do
              If D[J]<>Infinity Then
                For K :=1 To N Do
                  If D[K]>DLast[J]+R[J,K] Then
                    Begin
                      D[K] :=DLast[J]+R[J,K];
                      From[I,K] :=J;
                    End;
            If D[C]<0 Then
              Begin
                WriteLn(I+1);
                WriteAnswer(I,C);
                Break;
              End;
          End;
        Exit;
      End;
  WriteLn('NO');
End;

Procedure CloseFiles;
Begin
  Close(Input);
  Close(Output);
End;

Begin
  OpenFiles;
  Init;
  Solve;
  CloseFiles;
End.
