#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define STR_SIZE 511

#define HEIGHT_BND 255

struct TCell {
  char*text;
  int width;
};

int n_x,n_y;
char*align,*lines_cont,**lines;
TCell*cells_cont,**cells;
int*widths;

int main(void) {
  #ifndef OFFLINE
  freopen("formatting.in","rt",stdin);
  freopen("formatting.out","wt",stdout);
  #endif
  int x,y,pos,spacing; char*p_str;
  align=new char[STR_SIZE];
  lines_cont=new char[HEIGHT_BND*STR_SIZE];
  lines=new char*[HEIGHT_BND];
  for (x=0,y=0; x<HEIGHT_BND; x++,y+=STR_SIZE) lines[x]=&lines_cont[y];
  //scanf("%s",align);
  fgets(align,sizeof(char)*STR_SIZE,stdin);
  for (n_y=0,p_str=align; *p_str; n_y++,p_str++) switch (*p_str) {
    case 'L': case 'l': align[n_y]=0; break;
    case 'R': case 'r': align[n_y]=2; break;
    case 'C': case 'c': align[n_y]=1; break;
    default: n_y--;
  }
  cells_cont=new TCell[HEIGHT_BND*n_y]; cells=new TCell*[HEIGHT_BND];
  for (x=0,y=0; x<HEIGHT_BND; x++,y+=n_y) cells[x]=&cells_cont[y];
  widths=new int[n_y];
  memset(widths,0,sizeof(int)*n_y);
  //for (n_x=0; scanf("%s",lines[n_x])>=1; n_x++) {
  for (n_x=0; fgets(lines[n_x],sizeof(char)*STR_SIZE,stdin); n_x++) {
    //p_str=strchr(lines[n_x],'\n'); if (p_str) *p_str=0;
    //if (!*lines[n_x]) { n_x--; continue; }
    p_str=lines[n_x];
    for (y=0; y<n_y; y++) {
      cells[n_x][y].text=p_str;
      p_str=strchr(p_str,'&');
      if (p_str) *(p_str++)=0;
      else if (y+1<n_y) break;
      for (; (*cells[n_x][y].text>0)&&(*cells[n_x][y].text<=32);
           cells[n_x][y].text++);
      for (pos=strlen(cells[n_x][y].text)-1; pos>=0; pos--) {
        if (!( (cells[n_x][y].text[pos]>0)&&(cells[n_x][y].text[pos]<=32) ))
          break;
        cells[n_x][y].text[pos]=0;
      }
      cells[n_x][y].width=++pos;
      if (widths[y]<cells[n_x][y].width) widths[y]=cells[n_x][y].width;
    } if (y<n_y) n_x--;
  }
  printf("+");
  for (y=0; y<n_y; y++) {
    for (pos=-1; pos<=widths[y]; pos++) printf("-");
    printf("+");
  }
  printf("\n|");
  for (y=0; y<n_y; y++) {
    spacing=widths[y]-cells[0][y].width;
    printf(" ");
    switch (align[y]) {
      case 1: for (pos=0; pos<(spacing)>>1; pos++) printf(" "); break;
      case 2: for (pos=0; pos<spacing; pos++) printf(" "); break;
    }
    printf("%s",cells[0][y].text);
    switch (align[y]) {
      case 1: for (pos=0; pos<(spacing+1)>>1; pos++) printf(" "); break;
      case 0: for (pos=0; pos<spacing; pos++) printf(" "); break;
    }
    printf(" |");
  }
  printf("\n+");
  for (y=0; y<n_y; y++) {
    for (pos=-1; pos<=widths[y]; pos++) printf("-");
    printf("+");
  }
 for (x=1; x<n_x; x++) {
  printf("\n|");
  for (y=0; y<n_y; y++) {
    spacing=widths[y]-cells[x][y].width;
    printf(" ");
    switch (align[y]) {
      case 1: for (pos=0; pos<(spacing)>>1; pos++) printf(" "); break;
      case 2: for (pos=0; pos<spacing; pos++) printf(" "); break;
    }
    printf("%s",cells[x][y].text);
    switch (align[y]) {
      case 1: for (pos=0; pos<(spacing+1)>>1; pos++) printf(" "); break;
      case 0: for (pos=0; pos<spacing; pos++) printf(" "); break;
    }
    printf(" |");
  }
 }
  printf("\n+");
  for (y=0; y<n_y; y++) {
    for (pos=-1; pos<=widths[y]; pos++) printf("-");
    printf("+");
  }
  printf("\n");
  delete[]widths;
  delete[]cells_cont; delete[]cells;
  delete[]align; delete[]lines_cont; delete[]lines;
  #ifndef OFFLINE
  fclose(stdin);
  fclose(stdout);
  #endif
  return(0);
}


