const
     FileIn='cicle.in';
     FileOut='cicle.out';
     MaxN=100;
     MaxAnswerLength=MaxN*MaxN;
var
   N: LongInt;
   A: array [1..MaxN, 1..MaxN] of LongInt;
   Connected: array [1..MaxN, 1..MaxN] of Boolean;
   AnswerLength: LongInt;
   Answer: array [1..MaxAnswerLength] of LongInt;
   Yes: Boolean;

procedure ReadData;
var
   F: Text;
   X, Y: LongInt;
begin
     Assign (F, FileIn);
     Reset (F);
     Readln (F, N);
     for X:=1 to N
         do for Y:=1 to N
                do Read (F, A [X, Y]);
     Close (F);
end;

procedure WriteData;
var
   F: Text;
   Index: LongInt;
begin
     Assign (F, FileOut);
     Rewrite (F);
     if Yes
        then begin
             Writeln (F, 'YES');
             Writeln (F, AnswerLength+1);
             for Index:=AnswerLength downto 1
                 do Write (F, Answer [Index], #32);
             Writeln (F, Answer [AnswerLength]);
        end
        else Writeln (F, 'NO');
     Close (F);
end;

var
   States: array [1..MaxN] of LongInt;
   Distances: array [1..MaxN] of LongInt;

function DFS (aNode: LongInt): Boolean;
var
   Node: LongInt;
begin
     States [aNode]:=1;
     for Node:=1 to N
         do if Connected [aNode, Node]
               then case States [Node] of
                         0: begin
                                 Distances [Node]:=Distances [aNode]+A [Node, aNode];
                                 if DFS (Node)
                                    then begin
                                         Inc (AnswerLength);
                                         Answer [ANswerLength]:=aNode;
                                         DFS:=true;
                                         Exit;
                                    end;
                            end;
                         1: if Distances [Node]>Distances [aNode]+A [Node, aNode]
                               then begin
                                    Inc (AnswerLength);
                                    Answer [AnswerLength]:=aNode;
                                    DFS:=true;
                                    Exit;
                               end;
                         2:;
               end;
     States [aNode]:=2;
     DFS:=false;
end;

procedure Solve;
var
   X, Y: LongInt;
   StartNode: LongInt;
begin
     for X:=1 to N
         do for Y:=1 to N
                do COnnected [X, Y]:=A [X, Y]<>100000;
     AnswerLength:=0;
     for StartNode:=1 to N
         do begin
            FillChar (States, SizeOf (States), 0);
            FillChar (Distances, SizeOf (Distances), 0);
            if DFS (StartNode)
               then begin
                    Yes:=true;
                    Exit;
               end;
         end;
     Yes:=false;
end;

begin
     ReadData;
     Solve;
     WriteData;
end.
