#include <stdio.h>

#define mm 300

int a[mm][mm], lm[mm], rm[mm], mark[mm], p, n, m,
    _stklen = 2 * 1024 * 1024;

int dfs( int v )
{
  int i;

  if (mark[v])
    return 0;
  mark[v] = 1;
  for (i = 1; i <= m; i++)
    if (a[v][i] && rm[i] == 0)
    {
      rm[i] = v;
      lm[v] = i;
      return 1;
    }
    else if (a[v][i] && dfs(rm[i]))
    {
      rm[i] = v;
      lm[v] = i;
      return 1;
    }
  return 0;
}

int main( void )
{
  int i;

  freopen("pairs.in", "r", stdin);
  freopen("pairs.out", "w", stdout);
  scanf("%d%d", &n, &m);
  for (i = 1; i <= n; i++)
  {
    while (1)
    {
      int x;

      scanf("%d", &x);
      if (x == 0)
        break;
      a[i][x] = 1;
    }
  }
  p = 0;
  while (1)
  {
    for (i = 1; i <= n; i++)
      mark[i] = 0;
    for (i = 1; i <= n; i++)
      if (lm[i] == 0 && !mark[i] && dfs(i))
        break;
    if (i > n)
      break;
    p++;
  }
  printf("%d\n", p);
  for (i = 1; i <= n; i++)
    if (lm[i] != 0)
      printf("%d %d\n", i, lm[i]);
  return 0;
}
