program problemM;

{APPTYPE CONSOLE}
{O-}

{

  EVA RULEZZZ!!!!!!!

  Fight with the best? Die like the rest!

  Copyright by [ hr0nix@darkwired ]

}


const
  InFile = 'sort.in';
  OutFile = 'sort.out';
  MaxN = 30000;

type
  Int = longint;
  Real = extended;
  TString = string[ 45 ];
  TGuy = record
    pos : Int;
    name, fam : string;
  end;

var
  n : Int;
  guys : array [1..MaxN] of TGuy;

procedure OpenFiles;
begin
  assign( input, InFile );
  reset( input );
  assign( output, OutFile );
  rewrite( output );
end;

procedure CloseFiles;
begin
  close( input );
  close( output );
end;

procedure InitData;
var
  i, j : Int;
begin
  readln( n );
  for i := 1 to n do begin
    readln( guys[ i ].name );
    guys[ i ].pos := i;
    guys[ i ].fam := '';
    j := 1;
    while guys[ i ].name[ j ] <> ' ' do begin
      guys[ i ].fam := guys[ i ].fam + guys[ i ].name[ j ];
      inc( j );
    end;
  end;
end;

procedure Swap( var g1, g2 : TGuy );
var
  g3 : TGuy;
begin
  g3 := g1; g1 := g2; g2 := g3;
end;

function less( g1, g2 : TGuy ) : boolean;
begin
  Less := ( g1.fam < g2.fam ) or ( ( g1.fam = g2.fam ) and ( g1.pos < g2.pos ) );
end;

procedure QSort(l, r: Integer);
var
  i, j : int;
  t : TGuy;
begin
  i := l; j := r;
  t := guys[ l + random( r - l + 1 ) ];
  repeat
    while less( guys[i], t ) do i := i + 1;
    while less( t, guys[j] ) do j := j - 1;
    if i <= j then
    begin
      swap( guys[i], guys[j]);
      i := i + 1; j := j - 1;
    end;
  until i > j;
  if l < j then QSort(l, j);
  if i < r then QSort(i, r);
end;

procedure Solve;
var
  i : Int;
begin
  QSort( 1, n );
  writeln( n );
  for i := 1 to n do
    writeln( guys[ i ].name );
end;

begin
  OpenFiles;
  InitData;
  Solve;
  CloseFiles;
end.
