#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

#define inpfile "cards.in"
#define outfile "cards.out"

const int NMAX = 1005;

int a[NMAX];
long long res;

void Init()
{
	freopen(inpfile,"r",stdin);
	freopen(outfile,"w",stdout);
}

void Out()
{
	printf("%lld\n",res);
	exit(0);
}

bool Check(long long x)
{
	int i = a[0] + 1;
	int y;

	while (x) {
		y = x % 10;
		for (i--; (a[i] != y) && (i); i--);
		if (!i) return false;
		x /= 10;
	}
	return true;
}

void Solve()
{
	long long i,mini,t;
	for (res = 0; Check(res); res+= rand()%1000 + 1);

	mini = res;
	t = res - 500000;
	if (t<0) t = 0;
	for (i = res - 1; i > t; i--)
		if (!Check(i)) mini = i;
	res = mini;
}

void Inp()
{
	char ch;
	
	memset(a,0,sizeof(a));	
	while ((scanf("%c",&ch) == 1) && ('0' <= ch) && (ch <= '9')) {
		a[0]++;
		a[a[0]] = ch - '0';
	}
}

int main()
{
	srand(8763);
	Init();
	Inp();
	Solve();
	Out();
	return 0;
}
