#include <stdio.h>
#include <assert.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <vector>

using namespace std;

#define FILE_IN "cards.in"
#define FILE_OUT "cards.out"

const int MAXN = 1005;

int n;
int a[MAXN+1];
int tmp[11];
int beast[MAXN+1];
vector<int> ans[MAXN+1];

void OpenFiles() {
	freopen(FILE_IN,"r",stdin);
	freopen(FILE_OUT,"w",stdout);
}

void CloseFiles() {
	fclose(stdout);
}

void Initialize(){
	memset(beast, 0 ,sizeof(beast));	
}

void ReadData() {
	n = 0;
	unsigned char ch;
	while (scanf("%c",&ch)==1) {
		if (isdigit(ch)) {
			a[++n] = ch-'0';
		} else break;
	}
	int i,t;
	for (i=1;i<=n/2;i++) {
		t = a[i];
		a[i] = a[n-i+1];
		a[n-i+1] = t;
	}
}

void Solve() {
	int k,i,t,j,q,kn;
	int blocks;
	int tt;

	if (a[1]==1)
		ans[1].push_back(1);

	for (k=2;k<=n;k++) {
		memset(tmp,0,sizeof(tmp));
		t = 0;
		blocks = 0;
		for (i=1;i<=k;i++) {
			if (tmp[a[i]]==0) {
				t++;
				tmp[a[i]] = 1;
			}
			if (t==10) {
				blocks++;
				memset(tmp, 0 ,sizeof(tmp));
				t = 0;
			}
		}

		t = 1;
		while (tmp[t]!=0) t++;			

		if (t==10) {
 			blocks++;
			t = 1;
		}
			
        // we can obtain (t-1)99...9 

        i = k;
        a[0] = t;
        beast[0] = 1;
        while (a[i]!=t) i--;
        if (i==0) {
			for (i=0;i<blocks;i++) ans[k].push_back(9);
			if (t>1) ans[k].push_back(t-1);			
			if (t==10) beast[k] = 1; 
        } else {
        	i--;
			kn = i+1;
        	j = 0;
			a[0] = 0;
        	while (i>=0 && j<blocks) 
        		if (a[i--]==0) j++;

        	if (i<0) {
        		for (i=0;i<blocks;i++) ans[k].push_back(9);
        		if (t>1) ans[k].push_back(t-1);
				//if (t<=1) beast[k] = 1;
        	} else {
				i++;i++;
				j = 1;
				while (i<kn && a[i]!=0) i++;        			
				if (i<kn)
        		while (ans[i-1].size()>j || (ans[i-1].size()==j && beast[i-1])) {
        			i++;
        			while (i<kn && a[i]!=0) i++;        			
                    if (i==kn) break;
					j++;
        		}
        		ans[k] = ans[i-1];
				tt = ans[i-1].size();
				for (q=0;q<blocks-tt;q++) {
					ans[k].push_back(0);
				}
        		ans[k].push_back(t);
        		if (t==9 && beast[i-1] && tt==0) beast[t]=1;
        	}
        }

	}
}
int num[MAXN];

void OutData() {
	vector<int>::iterator p;

	int k=0;

	p = ans[n].begin();
	while (p!=ans[n].end()) {
		num[k++] = *p;
		p++;
	}

    
	int i,t;
	
    t=1;
    i=0;
    while (t>0) {
    	num[i] = num[i]+t;
    	t = num[i] / 10;
    	num[i] = num[i] % 10;
    	i++;
    }
    
    if (num[k]>0) k++;

    	for (i=0;i<=(k-1)/2;i++) {
		t = num[i];
		num[i] = num[k-1-i];
		num[k-i-1] = t;
	}

    

	for (i=0;i<k;i++) 
		printf("%d",num[i]);
    


}

int main(int argc, char * arg[]) {
	OpenFiles();
    Initialize();
    ReadData();
    Solve();
    OutData();
    CloseFiles();
    return 0;	
}