#include <stdio.h>
#include <assert.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <iostream>

using namespace std;

#define FILE_IN "cards.in"
#define FILE_OUT "cards.out"

#define MAXLONGLONG 10000000000000000

long long magic = 5000;
long long mleft,mright,ans;
long long x,y;

const int MAXN = 1005;

int n;
int a[MAXN];

void OpenFiles() {
	freopen(FILE_IN,"r",stdin);
	freopen(FILE_OUT,"w",stdout);
}

void CloseFiles() {
	fclose(stdout);
}

void Initialize(){
	ans = 0;
}

void ReadData() {	
	n = 0;
	unsigned char ch;
	while (scanf("%c",&ch)==1) {
		if (isdigit(ch)) {
			a[++n] = ch-'0';
		} else break;
	}
	int i,t;
	for (i=1;i<=n/2;i++) {
		t = a[i];
		a[i] = a[n-i+1];
		a[n-i+1] = t;
	}	
}

int di[20];
int possible(long long num){
	if (num<=0) return 1;
	int i = n-1;
	int len=0;
	while (num>0) {
		di[len++] = num%10;
		num = num/10;
	}	
	int j = n;
	for (i=len-1;i>=0;i--) {
		a[0] = di[i];
		while (a[j]!=di[i]) j--;
		if (j==0) return 0;
		j--;
	}	
	return 1;
}

void Solve() {	

int z;
mright = MAXLONGLONG + magic;
for (z=0;z<2;z++){
	mleft = 1;
	
	int re = 1;
	int i;
	while (mright-mleft>1){
		re = 1;
		x = (mright+mleft)/2;
		y = (mright+mleft)/4;
		if (x>0)
			for (i=0;i<magic;i++) {			
				re = re && possible(((long long)rand()*rand()+rand()) %x+1);
			}

		for (i=0;i<magic;i++)
			re = re && possible(x-i);

		if (re)
			mleft = (mright+mleft)/2;
		else
			mright = (mright+mleft)/2;
	}	
}
if (ans<mleft) ans = mleft;
}

void OutData() {
	cout << (ans+1);
}

int main(int argc, char * arg[]) {
	OpenFiles();
    Initialize();
    ReadData();
    Solve();
    OutData();
    CloseFiles();
    return 0;	
}