program _1;

{$APPTYPE CONSOLE}

const MaxN = 1000;

type TLong = array [0..MaxN] of longint;

var x, m : TLong;
    pohod : array [0..9, 1..MaxN + 1] of longint;

procedure Reader(i : longint);
var q : char;
    l : longint;
begin
    while not SeekEof do begin
      Read(q);
      inc(x[0]);
      l := Ord(q) - $30;
      x[x[0]] := l;
    end;  
end;    

function Less(const a, b : TLong) : boolean;
var i : longint;
begin
    Less := a[0] < b[0];
    if a[0] = b[0] then
      for i := 1 to a[0] do
        if a[i] <> b[i] then begin
          Less := a[i] < b[i];
          Exit;
        end;
end;

function Add(i : longint; const a : TLong) : TLong;
var j : longint;
begin
    Result[0] := a[0] + 1;
    Result[1] := i;
    for j := 1 to a[0] do Result[j + 1] := a[j]; 
end;

function Schet(wh : longint) : TLong;
var max : longint;
    i : longint;
    st : longint;
begin
    Result[0] := 1000000;
    if wh = 1 then st := 1
    else st := 0;
    for i := st to 9 do
      if pohod[i, wh] = 0 then begin
        Result[0] := 1;
        Result[1] := i;
        Exit;
      end;
    max := 0;
    for i := st to 9 do begin
      if max < pohod[i, wh] then 
        m := Add(i, Schet(pohod[i, wh] + 1));
      if Less(m, Result) then begin
        Result := m;
        max := pohod[i, wh];
      end;
    end;
end;

procedure Init();
begin
    Reset(input, 'cards.in');
    Rewrite(output, 'cards.out');
    Reader(0);
end;

procedure WriteLong(const a : TLong);
var i : longint;
begin
    for i := 1 to a[0] do Write(a[i]);
end;

procedure Solve();
var i, j : longint;
begin
    for i := 0 to 9 do
      for j := x[0] downto 1 do
        if x[j] = i then pohod[i, j] := j
        else pohod[i, j] := pohod[i, j + 1];
    WriteLong(Schet(1));
end;

procedure Print();
begin
    Close(input);
    Close(output);
end;

begin
    Init();
    Solve();
    Print();
end.
 