#include "stdio.h"
#include "algorithm"
#include "string.h"

#define INPUT_FILE "cards.in"
#define OUTPUT_FILE "cards.out"

#define MAX_N 1005
#define GD( x ) (x - '0')

typedef struct
{
	int pos[ 10 ];
	bool flag[ 1000 ];
} DIGIT, *LPDIGIT;

bool p[ 10 ];

int n;
char str[ MAX_N ];
DIGIT arr[ MAX_N ];

void Init()
{
	freopen( INPUT_FILE, "r", stdin );
	freopen( OUTPUT_FILE, "w", stdout );

	scanf( "%s", str );
	n = strlen( str );

	int i;
	for( i = n - 2; i >= 0; i-- )
	{
		arr[ i ] = arr[ i + 1 ];
		arr[ i ].pos[ GD(str[ i + 1 ]) ] = i + 1;
		arr[ i ].flag[ 0 ] = true;
	}
	arr[ n - 1 ].flag[ 0 ] = true;
}

void FreeP()
{
	int i;
	for( i = 0; i < n; i++ )
	{
		p[ i ] = false;;
	}
}

bool F(  )
{
	int i;
	bool flag = true;
	for( i = 0; i < 10 && flag ; i++ )
	{
		flag &= p[ i ];
	}
	return flag;
}

int rr[ MAX_N ];

bool Check()
{
	int i;

	for( i = 0; i < n; i++ )
	{
		rr[ GD(str[ i ]) ] = 1;
	}
	for( i = 1; i < 10; i++ )
	{
		if( !rr[ i ] )
		{
			printf( "%ld", i );
			return false;
		}
	}
}

void Solve()
{
	if( !Check() )return;

	bool f = true;
	int k = 1;
	while( f )
	{
		FreeP();
		if( k == 1 ) p[ 0 ] = true;
		int i;
		for( i = n - 1; i >= 0; i-- )
		{
			if( arr[ i ].flag[ k - 1 ] )
			{
				p[ GD(str[ i ]) ] |= true;
			}
			if( F() ){ break; }
		}
		if( i < 1 )
		{
			break;//Exit
		}
		i--;
		for( ; i >= 0; i-- )
		{
			arr[ i ].flag[ k ] = true;
		}
		k++;
	}

//Get Number
	p[ 0 ] = true;
	int c = 0;
	int i = 0;
	while( p[ i ] ){ i++; }//1
	c = i;
	i--;
	
	int t = i;
	i = 0;
	while( k > 1 )
	{
		for( ; i < n; i++  )
		{
			if( GD(str[ i ]) == t )
			{
				int j = 0;
				while( arr[ i ].flag[ j ] ){ j++; }
				c *= 10;
				c += j;
				break;
			}
		}
		k--;
	}
	printf( "%ld", c );
}

void Done()
{
	;
}

int main()
{
	Init();
	Solve();
	Done();

	return 0;
}