program tru1;

{$APPTYPE CONSOLE}

uses
  SysUtils;

const
  inf = 'cards.in';
  outf = 'cards.out';

var
  lnums: array [0..1021, 0..10] of smallint;
  res: string;
  n, x, k: integer;
  c: char;
  pts: array [1..9] of smallint;
  data: string;

procedure QUIT;
begin
  write(res);
  close(output);
  halt(0);
end;

function RAll(x, nn: integer): boolean;
begin
  result:=
    (lnums[nn, 0] - lnums[x, 0] > 0) and
    (lnums[nn, 1] - lnums[x, 1] > 0) and
    (lnums[nn, 2] - lnums[x, 2] > 0) and
    (lnums[nn, 3] - lnums[x, 3] > 0) and
    (lnums[nn, 4] - lnums[x, 4] > 0) and
    (lnums[nn, 5] - lnums[x, 5] > 0) and
    (lnums[nn, 6] - lnums[x, 6] > 0) and
    (lnums[nn, 7] - lnums[x, 7] > 0) and
    (lnums[nn, 8] - lnums[x, 8] > 0) and
    (lnums[nn, 9] - lnums[x, 9] > 0);
end;

function RAllN(x, nn: integer): boolean;
begin
  result:=
    (lnums[n, 0] - lnums[x, 0] >= nn) and
    (lnums[n, 1] - lnums[x, 1] >= nn) and
    (lnums[n, 2] - lnums[x, 2] >= nn) and
    (lnums[n, 3] - lnums[x, 3] >= nn) and
    (lnums[n, 4] - lnums[x, 4] >= nn) and
    (lnums[n, 5] - lnums[x, 5] >= nn) and
    (lnums[n, 6] - lnums[x, 6] >= nn) and
    (lnums[n, 7] - lnums[x, 7] >= nn) and
    (lnums[n, 8] - lnums[x, 8] >= nn) and
    (lnums[n, 9] - lnums[x, 9] >= nn);
end;

var
  btype: byte;
  t, frst, i: integer;

function find(c: char; frst: integer): integer;
var
  i: integer;
begin
  for i:=frst to length(data) do
    if data[i] = c then
    begin
      result:=i; exit;
    end;
  result:=0;
end;

begin
  assign(input, inf);
  reset(input);
  assign(output, outf);
  rewrite(output);
  fillchar(lnums, sizeof(lnums), 0);
  fillchar(pts, sizeof(pts), 0);
  read(c); n:=0;
  while not (c in ['0'..'9']) do read(c);
  while (c in ['0'..'9']) do
  begin
    inc(n);
    x:=ord(c)-ord('0');
    lnums[n]:=lnums[n-1];
    inc(lnums[n, x]);
    if (lnums[n, 1] > 0) and
      (lnums[n, 2] > 0) and
      (lnums[n, 3] > 0) and
      (lnums[n, 4] > 0) and
      (lnums[n, 5] > 0) and
      (lnums[n, 6] > 0) and
      (lnums[n, 7] > 0) and
      (lnums[n, 8] > 0) and
      (lnums[n, 9] > 0) then
        lnums[n, 10]:=1;
    if pts[x] = 0 then pts[x]:=n;
    data:=data+c;
    read(c);
  end;
  close(input);

  if lnums[n, 10] < 1 then
  for x:=1 to 9 do
    if lnums[n, x] = 0 then
    begin
      res:=inttostr(x);
      quit;
    end;

  k:=1;
  btype:=0;
  frst:=9;
  while btype = 0 do
  begin
    inc(k);
    for x:=frst to n-10 do
      if (lnums[x, 10] = k-1) and (RAll(x, n)) then
      begin
        btype:=1;
        t:=x;
        break;
      end;
    if btype = 0 then
    begin
      btype:=1;
      break;
    end;
    btype:=0;
    lnums[n, 10]:=k;
    frst:=n;
    for x:=n-1 downto t+9 do
      if (lnums[t, 10] = k-1) and (RAll(t, x)) then
        lnums[x, 10]:=k else
        begin
          frst:=x+1;
          break;
        end;
  end;
  res:='';

  dec(k);
  for x:=1 to 9 do
    if RAllN(pts[x], k-1) and not RAllN(pts[x], k) then
      begin res:=inttostr(x); frst:=pts[x]+1; break; end;

  for t:=k downto 2 do
  begin
    for x:=0 to 9 do
    begin
      i:=find(chr(x+ord('0')), frst);
      if RAllN(i, t-2) and not RAllN(i, t-1) then
        break;
    end;
    frst:=i+1;
    res:=res+data[i];
  end;
  dec(frst);
  if frst > n then res:=res+'0' else
  for x:=0 to 9 do
    if lnums[n, x]-lnums[frst, x] = 0 then
    begin
      c:=chr(x+ord('0'));
      break;
    end;
  res:=res+c;
  quit;
end.
