{$O-}
program Cards;
uses sysutils;
const
     in_file='cards.in';
     out_file='cards.out';
     maxN=1100;
     p=10;
     lgp=1;
type
     TLong=array[0..maxN]of integer;
var
     Zero,One:TLong;

procedure ReadLong(var A:TLong);
var i,ind:integer;
    ch:char;
begin
   fillchar(A,sizeof(A),0);
   read(ch);
   while not (ch in ['0'..'9']) do read(ch);
   while ch in ['0'..'9'] do
   begin
      for i:=A[0] downto 1 do
      begin
         A[i+1]:=A[i+1]+(A[i]*10)div p;
         A[i]:=(A[i]*10) mod p;
      end;
      A[1]:=A[1]+ord(ch)-ord('0');
      if A[A[0]+1]>0 then inc(A[0]);
      read(ch);
   end;
end;

procedure WriteLong(const A:TLong);
var i:integer;
    s:string;
begin
   write(A[A[0]]);
   for i:=A[0]-1 downto 1 do
   begin
      s:=inttostr(A[i]);
      while length(s)<lgp do s:='0'+s;
      write(s);
   end;
end;

procedure Sub1(var A:TLong);
var i:integer;
begin
   dec(A[1]);
   i:=1;
   while A[i]<0 do
   begin
      inc(A[i],p);
      dec(A[i+1]);
      inc(i);
   end;
   if A[A[0]]=0 then dec(A[0]);
end;

procedure div2(var A:TLong);
var i,t:integer;
    B:TLong;
begin
   t:=0;
   fillchar(B,sizeof(B),0);
   B[0]:=A[0];
   for i:=A[0] downto 1 do
   begin
      B[i]:=(t*p+A[i]) div 2;
      t:=(t*p+A[i]) mod 2;
   end;
   if B[B[0]]=0 then dec(B[0]);
   A:=B;
end;
procedure Add(const A,B:TLong; var C:TLong);
var i:integer;
begin
   fillchar(c,sizeof(c),0);
   if A[0]>B[0] then C[0]:=A[0] else C[0]:=B[0];
   for i:=1 to C[0] do
   begin
      C[i+1]:=(A[i]+B[i]+C[i])div p;
      C[i]:=(A[i]+B[i]+C[i])mod p;
   end;
   if C[C[0]+1]>0 then inc(C[0]);
end;

function can(const a,b:TLong):boolean;
var i,j:integer;
    res:boolean;
begin
    i:=1; j:=1;
    while (i<=A[0]) and (j<=B[0]) do
    begin
       if A[i]=B[j] then begin inc(j); inc(i); end else inc(i);
    end;
    if j>B[0] then Result:=true else Result:=false;
end;

function Less(const A,B:TLong):boolean;
var i:integer;
begin
   if A[0]<B[0] then Result:=true else
   if A[0]>B[0] then Result:=false else
   begin
      i:=A[0];
      while (i>0)and(A[i]=B[i]) do dec(i);
      if ((i>0)and(A[i]>B[i]))or(i=0) then Result:=False
      else  Result:=true;
   end;
end;

function EQ(const A,B:TLong):boolean;
var i:integer;
begin
   if A[0]<>B[0] then Result:=false else
   begin
      i:=A[0];
      while (A[i]=B[i])and(i>0) do dec(i);
      if i=0 then Result:=true else Result:=false;
   end;
end;

var cur:TLong;

function rec(const l,r:TLong):TLong;
var i,j,mid,t,c:TLong;
begin
    i:=l; j:=r;
    if EQ(i,j) then
    begin
       if can(cur,j) then rec:=zero else rec:=j;
    end
        else
    begin
      while less(i,j) do
      begin
         Add(i,j,mid);
         div2(mid);
         if can(cur,mid) then
         begin
            c:=mid;
            sub1(c);
            t:=rec(i,c);
            if EQ(t,zero) then Add(mid,one,i) else begin rec:=t; j:=t; end;
         end  else j:=mid;
      end;
      if can(cur,j) then rec:=zero else rec:=j;
    end;
end;

var
    answer,T:TLong;

begin
   assign(input,in_file); reset(input);
   ReadLong(cur);
   fillchar(zero,sizeof(zero),0); zero[0]:=1;
   fillchar(one,sizeof(one),0); one[0]:=1; one[1]:=1;
   Add(cur,one,T);
   close(input);
   answer:=rec(one,T);
   assign(output,out_file); rewrite(output);
   writeLong(answer);
   close(output);
end.
