program P_1;

{$APPTYPE CONSOLE}

const
  MaxN = 2000;
  Cif : Set of Char = ['0' .. '9'];
  Inf = MaxLongInt div 2 - 5;
type
  TLong = Array[0 .. MaxN] of LongInt;
var
  x : TLong;
  mas : Array[0 .. MaxN, 0 .. 9] of LongInt;
  rez : Array[0 .. MaxN] of LongInt;

Procedure ReadLong(var a : TLong);
var
  c : Char;
begin
  FillChar(a, SizeOf(a), 0);
  Read(c);
  While not (c in Cif) do
    Read(c);
  While c in Cif do
  begin
    Inc(a[0]);
    a[a[0]] := Ord(c) - Ord('0');
    Read(c);
  end;
end;

Procedure Init;
begin
  Reset(input, 'cards.in');
  Rewrite(output, 'cards.out');
  ReadLong(x);
end;

Function Min(const a, b : LongInt) : LongInt;
begin
  if a < b then
    Min := a
  else
    Min := b;
end;

Procedure Solve;
var
  i, j : LongInt;
begin
  for i := 0 to 9 do
    mas[x[0]][i] := Inf;
  rez[x[0]] := 1;
  for i := x[0] - 1 downto 0 do
  begin
    mas[i] := mas[i + 1];
    mas[i][x[i + 1]] := i + 1;
    rez[i] := Inf;
    for j := Ord(i = 0) to 9 do
      if mas[i][j] = Inf then
        rez[i] := 0
      else
        rez[i] := Min(rez[i], rez[mas[i][j]]);
    Inc(rez[i]);
  end;
end;

Procedure Print;
var
  i, tek : LongInt;
begin
  tek := 0;
  While rez[tek] <> 1 do
  begin
    for i := Ord(tek = 0) to 9 do
      if rez[tek] = rez[mas[tek][i]] + 1 then
      begin
        tek := mas[tek][i];   
        Write(x[tek]);
        Break;
      end;
  end;
  for i := Ord(tek = 0) to 9 do
    if mas[tek][i] = Inf then
    begin
      Write(i);
      Break;
    end;
end;

begin
  Init;
  Solve;
  Print;
end.
 