{$O+,Q-,R-}
program Cards;

{$APPTYPE CONSOLE}

uses
  SysUtils;

const
  MaxK = 1000;
  Ord0 = Ord('0');

var
  k, i, j, zp, zn, l: integer;
  s: string;
  x: array [1..MaxK] of integer;
  a: array [1..MaxK+1, 0..9] of integer;
  w: array [0..9] of boolean;

procedure Return(s: string);
begin
  Writeln(s);
  CloseFile(Input);
  CloseFile(Output);
  Halt(0);
end;

procedure FindNumber(s: string; k, p: integer);
var
  i, z, r: integer;
  q: string;
begin
  Inc(k);
  if k = 1 then z := 1 else z := 0;
  for i := z to 9 do
  begin
    q := s + Chr(i + Ord0);
    r := a[p, i] + 1;
    if k = l then
    begin
      if r >= zp then Return(q + Chr(zn + Ord0));
    end
    else
      FindNumber(q, k, r);
  end;
end;

begin
  AssignFile(Input, 'cards.in');
  AssignFile(Output, 'cards.out');
  Reset(Input);
  Rewrite(Output);

  Readln(s);
  s := Trim(s);
  k := Length(s);
  for i := 1 to k do
    x[i] := Ord(s[i]) - Ord0;
  FillChar(a, SizeOf(a), 0);

  for i := 0 to 9 do w[i] := false;
  for i := 1 to k do
    w[x[i]] := true;
  for i := 1 to 9 do
    if not w[i] then Return(Chr(i + Ord0));
  if not w[0] then Return('10'); 

  zp := High(integer);
  zn := 0;
  for i := k downto 1 do
    for j := 0 to 9 do
      if x[i] = j then
        a[i, j] := i
      else
      begin
        a[i, j] := a[i+1, j];
        if (a[i, j] = 0) and (zp > i) then
        begin
          zp := i;
          zn := j;
        end;
      end;

  l := 1;
  while true do
  begin
    for i := 1 to 9 do FindNumber('', 0, 1);
    Inc(l);
  end;
end.
 