{$APPTYPE CONSOLE}
{$i-,q-,r-}

const id = 'cards';
      infile = id + '.in';
      outfile = id + '.out';

const maxn = 1000;

type int = longint;
     long = array [0..maxn] of int;

var a, ans : long;
    b : array [1..maxn, 0..9] of int;
    c : array [0..9] of int;
    n : int;

procedure Init;
var
  ch : char;
  i, j : int;
begin
  read(ch);
  while not (ch in ['0'..'9']) do read(ch);
  while ch in ['0'..'9'] do begin
    inc(n);
    a[n] := ord(ch) - ord('0');
    inc(c[a[n]]);
    read(ch);
  end;
  for i := 1 to n-1 do
    for j := i+1 to n do
      inc(b[i][a[j]]);
  a[0] := n;    
end;

function more(a, b : long) : boolean;
var
  i : int;
begin
  if (a[0] <> b[0]) then begin
    more := (a[0] > b[0]);
    exit;
  end;
  for i := 1 to a[0] do
    if a[i] <> b[i] then begin
      more := (a[i] > b[i]);
      exit;
    end;
  more := false;  
end;

procedure Save(x : long);
var
  i : int;
begin
  for i := 1 to x[0] do write(x[i]);
  close(output);
  halt(0);
end;

procedure Solve;
var
  i, j : int;
  ok : boolean;
  x : array [1..9] of long;
begin
  for i := 1 to 9 do if c[i] = 0 then begin
    writeln(i);
    close(output);
    halt(0);
  end;

  fillchar(x, sizeof(x), 0);
  ans[0] := maxn;
  for i := 1 to n do begin   if (a[i] <> 0) and (x[a[i]][0] = 0) then begin
    ok := false;
    for j := 0 to 9 do if b[i][j] = 0 then begin
      x[a[i]][0] := 1; x[a[i]][1] := a[i];
      x[a[i]][0] := 2; x[a[i]][2] := j;
      ok := true;
    end;
    if not ok then x[a[i]][0] := -1;
  end; end;
  for i := 1 to 9 do
    if x[i][0] > 0 then Save(x[i]);
end;

BEGIN
  assign(input, infile); reset(input);
  assign(output, outfile); rewrite(output);
  Init;
  Solve;
  close(input); close(output);
END.