{$APPTYPE CONSOLE}
{$i-,q-,r-}

const id = 'cards';
      infile = id + '.in';
      outfile = id + '.out';

const maxn = 1000;

type int = longint;
     long = array [0..maxn] of int;

var a, ans : long;
    b : array [1..maxn, 0..9] of int;
    c : array [0..9] of int;
    n : int;

procedure Init;
var
  ch : char;
  i, j : int;
begin
  read(ch);
  while not (ch in ['0'..'9']) do read(ch);
  while ch in ['0'..'9'] do begin
    inc(n);
    a[n] := ord(ch) - ord('0');
    inc(c[a[n]]);
    read(ch);
  end;
  for i := 1 to n-1 do
    for j := i+1 to n do
      inc(b[i][a[j]]);
  a[0] := n;    
end;

function more(a, b : long) : boolean;
var
  i : int;
begin
  if (a[0] <> b[0]) then begin
    more := (a[0] > b[0]);
    exit;
  end;
  for i := 1 to a[0] do
    if a[i] <> b[i] then begin
      more := (a[i] > b[i]);
      exit;
    end;
  more := false;  
end;

procedure Save(x : long);
var
  i : int;
begin
  for i := x[0] downto 1 do write(x[i]);
  close(output);
  halt(0);
end;

procedure Solve;
var
  i, j, k, t : int;
  x : long;
begin
  for i := 1 to 9 do if c[i] = 0 then begin
    writeln(i);
    close(output);
    halt(0);
  end;

  ans[0] := maxn;
  for i := 10 to 10000 do begin
    fillchar(x, sizeof(x), 0);
    t := i;
    while t <> 0 do begin
      inc(x[0]);
      x[x[0]] := t mod 10;
      t := t div 10;
    end;
    k := 1; j := x[0];
    while true do begin
      if (a[k] = x[j]) then dec(j);
      inc(k);
      if (j < 1) or (k > n) then break;
    end;
    if j >= 1 then Save(x);
  end;
end;

BEGIN
  assign(input, infile); reset(input);
  assign(output, outfile); rewrite(output);
  Init;
  Solve;
  close(input); close(output);
END.