program cards;

{$APPTYPE CONSOLE}

uses
  SysUtils;

var
  Fin, Fout : Text;
  X, N      : array[0..1005] of byte;
  Numbs     : array[0..9] of Word;
  Lx, Ln, I : word;
  FnX       : word;
  Ch        : char;

function IsIn : boolean;
var
  Xi, Ni : word;
begin
  Xi:=0;
  Ni:=1;
  While (Xi<=FnX) and (Ni<=Ln) do
  begin
    Xi:=Xi+1;
    if X[Xi]=N[Ni] then Ni:=Ni+1;
  end;

  if Ni>Ln then IsIn:=True else IsIn:=false;
end;

procedure Increment;
var
  I, J : Byte;
begin
  N[Ln]:=N[Ln]+1;
  For I:=Ln downto 1 do
  begin
    N[I-1]:=N[I-1]+(N[I] div 10);
    N[I]:=N[I] mod 10;
  end;
  if N[0]<>0 then
  begin
    Ln:=Ln+1;
    For J:=Ln downto 1 do N[J]:=N[J-1];
    N[0]:=0;
  end;
end;

begin
  Assign(Fin, 'cards.in');
  Assign(Fout, 'cards.out');
  Reset(Fin);
  Rewrite(Fout);
  Lx:=0;
  Ln:=0;
  N[0]:=0;
  For I:=0 to 9 do Numbs[I]:=0;
  While not eof(Fin) do
  begin
    Lx:=Lx+1;
    Read(Fin, ch);
    X[Lx]:=ord(Ch)-48;
    Numbs[X[Lx]]:=Numbs[X[Lx]]+1;
  end;

  For I:=0 to Lx do N[I]:=0;
  LN:=1;
  N[1]:=1;
  FnX:=1;

  While (Fnx<=Lx) do
  begin
    While (FnX<=Lx) and (X[Fnx]<>N[Ln]) do
      FnX:=FnX+1;
    While IsIn do
      increment;
  end;

  For I:=1 to Ln do write(Fout, N[I]);

  Close(Fin);
  Close(Fout);
end.

