program task_1;

type
  long = array [ 0.. 255] of integer;

var
  fin, fout : text;
  i, j, k, n : integer;
  A : ARRAY[1..1000] of char;
  otv : long;
  fl : boolean;

procedure up(var x : long);
var
  i : byte;
begin
  inc(x[1]);
  for i := 1 to x[0] do
  if x[i] > 9 then
  begin
    dec(x[i], 10);
    inc(x[i + 1]);
  end;
  if x[x[0] + 1] <> 0 then inc(x[0]);
end;

procedure down(var x : long);
var
  i : byte;
begin
  dec(x[1]);
  for i := 1 to x[0]  do
  if x[i] < 0 then
  begin
    inc(x[i], 10);
    dec(x[i + 1]);
  end;
  if x[x[0]] = 0 then dec(x[0]);
end;

function yes(x : long) : boolean;
var
  i, j, k : integer;
begin
  k := 1;
  i := 1;
  while (i <= n) and (k <= x[0]) do
  begin
    if ord(a[i]) - ord('0') = x[k] then inc(k);
    inc(i);
  end;
  if k <= x[0] then yes := false
  else yes := true;
end;

function chek(x : integer) : long;
var
  i, j, k : integer;
  y : long;
begin
  for i := 2 to 255 do
    y[i] := 0;
  y[1] := 1;
  y[0] := 1;
  while yes(y) do up(y);
  chek := y;
end;

procedure load;
var
  c: char;
begin
  n := 0;
  assign(fin, 'cards.in');
  reset(fin);
  read(fin, c);
  while (c <= '9') and (c >= '0') and not(eof(fin)) do
  begin
    inc(n);
    a[n] := c;
    read(fin, c);
  end;
end;

procedure execute;
var
  i, j, k, min: integer;
  c : char;
  numb : array['0'.. '9'] of integer;

begin
  fl := false;
  for c := '0' to '9'do
    numb[c] := 0;
  i := 1;
  while not(fl) and (i <= n) do
  begin
    if a[i] = '1' then
      fl := true;
    inc(i);
  end;
  if fl then
  begin
    for j := i  to n do
      inc(numb[a[j]]);
    min := 1000;
    for c := '0' to '9' do
      if numb[c] < min then min := numb[c];
    otv := chek(min + 1);
  end
  else
  begin
    assign(fout, 'cards.out');
    rewrite(fout);
    write(fout, 1);
    closefile(fout);
    exit;
  end;
end;

procedure save;
var
  i : integer;
begin
  assign(fout, 'cards.out');
  rewrite(fout);
  for i := otv[0] downto 1 do
    write(fout, otv[i]);
  close(fout);
end;

begin
  load;
  execute;
  if fl then
  save;
end.
