program Solution;

{$APPTYPE CONSOLE}

{%File 'cards.in'}
{%File 'cards.out'}

uses
  SysUtils;

type
 PCell             =^TCell;
 TCell             =record
  Next             :PCell;
  Bool             :Array [0..9] of Boolean;
 end;

var
 Ptrs              :Array [0..9] of PCell;
 Amount            :Array [0..9] of Word;
 Root,
 P                 :PCell;
 N                 :Array [0..1000] of Byte;
 CNum              :Byte;
 i, j,
 NLen              :Word;

procedure FInPut;
var
 S                 :Array [0..1000] of Char;
 Num               :Array [0..1000] of Byte;
 i, j,
 Len               :Word;
begin
 Assign(InPut, 'cards.in');
 Reset(InPut);
 ReadLn(S);
 Close(InPut);
 for Len:=0 to 1000 do
  if S[Len]=#0 then
   break;
 dec(Len);
 for i:=0 to Len do
  Num[i]:=Byte(S[i])-48;
 for j:=0 to Len do
  begin
   P:=Ptrs[Num[j]];
   if P=nil then
    begin
     New(P);
     Root^.Bool[Num[j]]:=TRUE;
     Ptrs[Num[j]]:=P;
    end
   else
    begin
     while (P^.Next<>nil) do
      P:=P^.Next;
     New(P^.Next);
     P:=P^.Next;
    end;
   for i:=j+1 to Len do
    P^.Bool[Num[i]]:=TRUE;
  end;
end;

procedure FOutPut;
var
 i                 :Word;
 RP                :PCell;
begin
 Assign(OutPut, 'cards.out');
 ReWrite(OutPut);
 for i:=NLen downto 0 do
  Write(N[i]);
 Close(OutPut);
 Dispose(Root);
 for i:=0 to 9 do
  begin
   P:=Ptrs[i];
   while P<>nil do
    begin
     RP:=P;
     Dispose(RP);
     P:=P^.Next;
    end;
  end;
 halt(0);
end;

procedure LongInc;
var
 O                 :Byte;
 i                 :Word;
begin
 O:=1;
 i:=0;
 repeat
  if N[i]=9 then
   N[i]:=0
  else
   begin
    inc(N[i]);
    break;
   end;
  inc(i);
 until FALSE;
 if i>NLen then inc(NLen);
end;

begin
 New(Root);
 N[0]:=1;
 NLen:=0;
 FInPut;
 repeat
  for j:=0 to 9 do
   Amount[j]:=0;
  P:=Root; 
  for j:=NLen downto 0 do
   begin
    CNum:=N[j];
    if not P^.Bool[CNum] then
     FOutPut;
    inc(Amount[CNum]);
    P:=Ptrs[CNum];
    for i:=2 to Amount[CNum] do
     begin
      P:=P^.Next;
      if P=nil then
       FOutPut;
     end;
   end;
  LongInc;
 until FALSE;
end.
