#include <fstream>
#include <deque>
using namespace std;

ifstream I("cards.in");
ofstream O("cards.out");

char X[10000];
int Adj[10000][10];
deque<int> Q;
int L[10000],P[10000];
int V[10000]={};

int main(){
	I>>X;
	int i,j;
	for(j=0;j<10;j++) Adj[strlen(X)][j]=-1;
	for(i=strlen(X)-1;i>=0;i--){
		for(j=0;j<10;j++) Adj[i][j]=Adj[i+1][j];
		Adj[i][X[i]-'0']=i;
	}
	for(i=1;i<10;i++){
		if(Adj[0][i]==-1){
			O<<i;
			return 0;
		}
		else{
			P[Adj[0][i]]=-1;
			L[Adj[0][i]]=1;
			V[Adj[0][i]]=1;
			Q.push_back(Adj[0][i]);
		}
	}
	while(!Q.empty()){
		int cur=Q.front();
		Q.pop_front();
		for(i=0;i<10;i++){
			if(Adj[cur+1][i]==-1){
				deque<int> out;
				out.push_back(i);
				while(cur!=-1){
					out.push_back(X[cur]-'0');
					cur=P[cur];
				}
				for(deque<int>::reverse_iterator k=out.rbegin();k!=out.rend();k++)
					O<<*k;
				return 0;
			}
			else if(!V[Adj[cur+1][i]]){
				V[Adj[cur+1][i]]=1;
				P[Adj[cur+1][i]]=cur;
				L[Adj[cur+1][i]]=L[cur]+1;
				Q.push_back(Adj[cur+1][i]);
			}
		}
	}
	return 0;
}