Program Cards;
Const
{  InpPath='C:\Work\cards_in.txt';
  OutPath='C:\Work\cards_out.txt';}
  InpPath='cards.in';
  OutPath='cards.out';
{$APPTYPE CONSOLE}
Var
  Map               :Array[0..9, 0..9] Of Boolean;
  Used              :Array[0..9] Of Boolean;
  Nums              :Array[0..9] Of LongInt;
  Min               :Extended;

Procedure ReadData;
Var
  InpFile       :Text;
  Code          :Integer;
  i, l          :Byte;
  Ch            :Char;
  First         :Boolean;
Begin
  FillChar(Map, SizeOf(Map), False);
  FillChar(Nums, SizeOf(Nums), 0);
  FillChar(Used, SizeOf(Used), False);
  Min:=0;
  First:=True;
  Assign(InpFile, InpPath);
  Reset(InpFile);
  While Not Eof(InpFile) Do
  Begin
    Read(InpFile, Ch);
    Val(Ch, i, Code);
    If First Then First:=False Else
      Map[l, i]:=True;
    l:=i;
    Nums[i]:=Nums[i]+1;
  End;
  Close(InpFile);
End;

Procedure Fill(i, pos:Byte);
Var
  j           :Byte;
Begin
  Used[pos]:=True;
  For j:=0 To 9 Do
    If Map[pos, j] And (pos<>j) And (Not Used[j])Then
    Begin
      Map[i, j]:=True;
      Fill(i, j);
    End;
  Used[pos]:=False;
End;

Procedure Solve(i:Byte; Count:Extended);
Var
  j             :Byte;
Begin
  For j:=0 To 9 Do
    If Not Map[i, j] Or ((Map[i, j] And (Nums[j]=0))) Then
    Begin
      If(Min=0) Or (Min>(Count*10+j)) Then Min:=Count*10+j;
      Exit;
    End;
  For j:=0 To 9 Do
    If Map[i, j] And (Nums[j]>0) And ((Min=0) Or ((Count*10+j)<Min)) Then
    Begin
      Nums[j]:=Nums[j]-1;
      Solve(j, Count*10+j);
      Nums[j]:=Nums[j]+1;
    End;
End;

Procedure WriteData;
Var
  OutFile                 :Text;
Begin
  Assign(OutFile, OutPath);
  ReWrite(OutFile);
  Write(OutFile, Min:0:0);
  Close(OutFile);
End;

Var
  i, j           :Word;
Begin
  ReadData;
  For i:=0 To 9 Do
    If(Nums[i]=0) And (i<>0) Then
    Begin
      Min:=i;
      WriteData;
      Halt;
    End;
    For i:=0 To 9 Do
    Begin
      Fill(i, i);
      If Nums[i]>1 Then Map[i,i]:=True;
    End;
    For i:=1 To 9 Do
    Begin
      Nums[i]:=Nums[i]-1;
      Solve(i, i);
      If Min<100 Then Break;
      Nums[i]:=Nums[i]+1;
    End;
    WriteData;
End.
