{$A+,B-,D-,E-,I-,L-,N-,Q-,R-,S-,X+,Y-}
{O-,R+,S+,Q+}
uses
 SysUtils;

const
  infile='cards.in';
 outfile='cards.out';
 mxleng=1000+7;
 mxvolna=mxleng;
 go:array['0'..'9'] of longint=(0,1,2,3,4,5,6,7,8,9);
 antigo:array[0..9] of char=('0','1','2','3','4','5','6','7','8','9');
 inf=60000;

type
 tvolna=array[0..9,0..mxleng] of word;

var
 x,n:string;
 m:longint;
 v:array[1..mxvolna] of tvolna;
 dubak:array[1..mxvolna,0..9] of boolean;
 dgdm,gde:array[1..mxvolna,0..9] of word;
 a:array[0..9,1..2*mxleng] of word;
 ok:array[0..mxleng] of boolean;

procedure init;
begin
 {initial}
{ fillchar(v,sizeof(v),0);
 fillchar(dubak,sizeof(dubak),false);
 fillchar(dgdm,sizeof(dgdm),0);
 fillchar(a,sizeof(a),0);}
 {init}
 readln(x);
 m:=length(x);
end;

function min(a,b:word):word;
begin
 if a<b then
  min:=a else
   min:=b;
end;

procedure update(q,i,k:longint);
begin
 i:=i+m-1;
 a[q,i]:=k;
 i:=i div 2;
 while i<>0 do
  begin
   a[q,i]:=min(a[q,2*i],a[q,2*i+1]);
   i:=i div 2;
  end;
end;

procedure initialrmq;
var
 i,j:longint;
begin
 for i:=0 to 9 do
  for j:=1 to 2*m do
   a[i,j]:=inf;
 for i:=1 to m do
  update(go[x[i]],i,i);
end;

function rmq(q,x,y:longint):word;
begin
 x:=x+m-1;
 y:=y+m-1;
 result:=min(a[q,x],a[q,y]);
 while x<=y do
  begin
   result:=min(result,a[q,x]);
   result:=min(result,a[q,y]);
   x:=(x+1) div 2;
   y:=(y-1) div 2;
  end;
end;

procedure run;
var
 i,j,k,t,q,count:longint;
 check:boolean;
begin
 initialrmq;
 {mini test}
 for i:=1 to 9 do
  begin
   v[1][i,0]:=1;
   v[1][i,1]:=rmq(i,1,m);
   if v[1][i,1]=inf then
    begin
     n:=inttostr(i);
     exit;
    end;
  end;
 {right}
 count:=1;
 while true do
  begin
   fillchar(ok,sizeof(ok),0);
   check:=true;
   for i:=0 to 9 do
    for j:=1 to v[count][i,0] do
     for k:=0 to 9 do
      begin
       t:=rmq(k,v[count][i,j]+1,m);
       if t=inf then
        begin
         check:=false;
         if dubak[count,i]=false then
          begin
           dubak[count,i]:=true;
           gde[count,i]:=v[count][i,j];
           dgdm[count,i]:=inf+k;
          end else
           begin
            if x[dgdm[count,i]]>x[t] then
             dgdm[count,i]:=inf+k;
           end;
         break;
        end else
         begin
          ok[t]:=true;
         end;
      end;
   if not check then
    break;
   inc(count);
    for i:=1 to m do
     if ok[i] then
      begin
       inc(v[count][go[x[i]],0]);
       v[count][go[x[i]],v[count][go[x[i]],0]]:=i;
      end;
  end;
 {left}
 while count>1 do
  begin
   dec(count);
   for i:=0 to 9 do
    for j:=1 to v[count][i,0] do
     begin
      for k:=0 to 9 do
       begin
        t:=rmq(k,v[count][i,j]+1,m);
        if (dubak[count+1,k]) and (t=gde[count+1,k]) then
         begin
          dgdm[count,i]:=t;
          dubak[count,i]:=true;
          gde[count,i]:=v[count][i,j];
          break;
         end;
       end;
      if dubak[count,i] then
       break;
     end;
  end;
 {set n}
 n:='';
 for i:=1 to 9 do
  if dubak[1,i] then
   begin
    n:=antigo[i];
    count:=1;
    q:=i;
    while dgdm[count,q]<>0 do
     begin
      if dgdm[count,q]>=inf then
       begin
        dgdm[count,q]:=dgdm[count,q]-inf;
        n:=n+antigo[dgdm[count,q]];
        break;
       end;
      n:=n+x[dgdm[count,q]];
      q:=go[x[dgdm[count,q]]];
      inc(count);
     end;
    exit;
   end;
end;

procedure done;
begin
 writeln(n);
end;

begin
 assign(input,infile);
 reset(input);
 assign(output,outfile);
 rewrite(output);
 init;
 run;
 done;
 close(input);
 close(output);
end.