program cards;

{$APPTYPE CONSOLE}
{$O+}

uses  SysUtils;

const MaxN= 1000;

Type TMatrix= Array [0..MaxN] of SmallInt;
     TDigit=  Array [0..9] of boolean;

var X, N: TMatrix;
    Digit: TDigit;

procedure Assigning;
  begin
  Assign(input, 'cards.in');
  Assign(output, 'cards.out');
  Reset(input);
  Rewrite(output);
  end;

procedure ReadData;
  var c: char;
      i: integer;
  begin
  X[0]:= 0;
  While not eof(input)
    do begin
       Read(c);
       If (c<>#13)and(c<>#10)
          Then begin
               inc(X[0]);
               X[X[0]]:= StrToInt(c);
               end;
       end;
  For i:= 1 to (X[0] div 2)
    do begin
       X[i]:= X[i] xor X[X[0]+ 1- i];
       X[X[0]+ 1- i]:= X[i] xor X[X[0]+ 1- i];
       X[i]:= X[i] xor X[X[0]+ 1- i]
       end;
  end;

procedure prepare;
  var i, j: integer;
  begin
  For i:= 0 to 9
    do begin
       j:= 1;
       While (X[j]<>i)and (j<= X[0])
         do inc(j);
       If j<= X[0]
          Then Digit[i]:= true
          Else begin
               Digit[i]:= false;
               If i>0
                  Then break;
               end;
       end;
  For i:= 1 to 9
    do If not Digit[i]
          Then begin
               Write(i);
               Close(output);
               Halt(0);
               end;
  If not Digit[0]
     Then begin
          Write(10);
          Close(output);
          Halt(0);
          end;
  end;

function max(a, b: integer): Integer;
  begin
  If a> b
     Then result:= a
     Else result:= b;
  end;

procedure Plus(const A, B: TMatrix; var C: TMatrix);
  var i: integer;
  begin
  C[0]:= Max(A[0], B[0]);
  C[1]:= A[1]+ B[1];
  For i:= 2 to C[0]
    do begin
       C[i]:= A[i]+ B[i];
       C[i]:= C[i]+ C[i-1] div 10;
       C[i-1]:= C[i-1] mod 10;
       end;
  If C[C[0]]>=10
     Then begin
          inc(C[0]);
          C[C[0]]:= C[C[0]- 1] div 10;
          C[C[0]-1]:=C[C[0]-1] mod 10;
          end;
  end;

procedure divtwo(A: TMatrix; var C: TMatrix);
  var i: integer;
  begin
{  C:= A;
  For i:= C[0] downto 2
    do begin
       C[i-1]:= C[i-1]+ (C[i]div 10)*10;
       C[i]:= C[i] div 2;
       end;
  C[1]:= C[1] div 2;}
  FillChar(C, SizeOf(C), 0);
  C[0]:= A[0];
  For i:= A[0] downto 2
    do begin
       C[i]:=(C[i]*10+ A[i]) div 2;
       C[i- 1]:= A[i] mod 2;
       end;
  C[1]:= (C[1]*10+A[1]) div 2;
  While C[C[0]]= 0
    do dec(C[0]);
  end;

function eq(const A, B: TMatrix): boolean;
  var i: integer;
  begin
  If A[0]<>B[0]
     Then result:= false
     Else begin
          i:= A[0];
          While (A[i]= B[i])and (i>=1)
            do dec(i);
          If i= 0
             Then result:= true
             Else result:= false;
          end;
  end;

function possible(A: TMatrix):boolean;
  var i, j: integer;
  begin
  i:= A[0];
  j:= X[0];
  While (i>= 1)and (j>= 1)
    do begin
       While (X[j]<>A[i])and (j>=1)
         do dec(j);
       dec(j);
       dec(i);
       end;
  If j>= 0
     Then result:= true
     Else result:= false;
  end;

procedure Solve;
  var Left: TMatrix;
      minus: boolean;
  procedure Check(const Left, Right: TMatrix);
    var middle: Tmatrix;
    begin
    FillChar(Middle, sizeof(middle), 0);
    Middle[0]:= 1; Middle[1]:= 1;
    Plus(Left, Middle, Middle);
    If eq(middle, Right)
       Then begin
            If not Possible(Left)
               Then begin
                    N:= Left;
                    //minus:= true;
                    exit;
                    end
               Else
            If not Possible(Right)
               Then begin
                    N:= Right;
                    //minus:= false;
                    exit;
                    end;
            end
       Else begin
            FillChar(Middle, Sizeof(Middle), 0);
            Plus(Left, Right, Middle);
            Divtwo(Middle, Middle);
            If Possible(Middle)
               Then begin
                    Check(Left, Middle);
                    If minus
                       Then exit;
                    Check(Middle, Right);
                    end
               Else begin
                    N:= Middle;
                    minus:= true;
                    end;
            end;
    end;
  begin
  Prepare;
  FillChar(Left, sizeof(left), 0);
  Left[0]:= 1; Left[1]:= 1;
  N:= X;
  Repeat
  minus:= false;
  Check(Left, N);
  Until not minus;
  end;

procedure OutData;
  var i: integer;
  begin
  For i:= N[0] downto 1
    do Write(N[i]);
  end;

procedure Closing;
  begin
  Close(input);
  Close(output);
  end;

begin
Assigning;
ReadData;
Solve;
OutData;
Closing;
end.
