program cards;

{$APPTYPE CONSOLE}
{$O+}

uses
  SysUtils;

const MaxN= 1000;

Type TMatrix= Array [0..MaxN] of SmallInt;
     TDigit=  Array [0..9] of boolean;

var X: TMatrix;
    Digit: TDigit;
    N: integer;

procedure Assigning;
  begin
  Assign(input, 'cards.in');
  Assign(output, 'cards.out');
  Reset(input);
  Rewrite(output);
  end;

procedure ReadData;
  var c: char;
      i: integer;
  begin
  X[0]:= 0;
  While not eof(input)
    do begin
       Read(c);
       If (c<>#13)and(c<>#10)
          Then begin
               inc(X[0]);
               X[X[0]]:= StrToInt(c);
               end;
       end;
  For i:= 1 to (X[0] div 2)
    do begin
       X[i]:= X[i] xor X[X[0]+ 1- i];
       X[X[0]+ 1- i]:= X[i] xor X[X[0]+ 1- i];
       X[i]:= X[i] xor X[X[0]+ 1- i]
       end;
  end;

procedure prepare;
  var i, j: integer;
  begin
  For i:= 0 to 9
    do begin
       j:= 1;
       While (X[j]<>i)and (j<= X[0])
         do inc(j);
       If j<= X[0]
          Then Digit[i]:= true
          Else begin
               Digit[i]:= false;
               If i>0
                  Then break;
               end;
       end;
  For i:= 1 to 9
    do If not Digit[i]
          Then begin
               Write(i);
               Close(output);
               Halt(0);
               end;
  If not Digit[0]
     Then begin
          Write(10);
          Close(output);
          Halt(0);
          end;
  end;

function max(a, b: integer): Integer;
  begin
  If a> b
     Then result:= a
     Else result:= b;
  end;


function possible(A: integer):boolean;
  var i, j: integer;
      temp: TMatrix;
  begin
  temp[0]:= 0;
  While a>0
    do begin
       inc(temp[0]);
       temp[temp[0]]:= a mod 10;
       a:= a div 10;
       end;
  i:= temp[0];
  j:= X[0];
  While (i>= 1)and (j>= 1)
    do begin
       While (X[j]<>temp[i])and (j>=1)
         do dec(j);
       dec(j);
       dec(i);
       end;
  If j>= 0
     Then result:= true
     Else result:= false;
  end;

procedure Solve;
  var i:integer;
  begin
  Prepare;
  i:= 1;
  While Possible(i)
    do inc(i);
  N:= i;
  end;

procedure OutData;
  var i: integer;
  begin
  Write(N);
  end;

procedure Closing;
  begin
  Close(input);
  Close(output);
  end;

begin
Assigning;
ReadData;
Solve;
OutData;
Closing;
end.
