#include <iostream>

#define L 1010
#define MIN -2000000000

using namespace std;


char sr[L + 2];
long el[L + 2];
long l;
long d;
long sol[L + 2];
long last[L + 2];
long tvis[11];
long tcar[11];
long col[L + 1];
//-------------------------------------------------------------------------------------------------------------
void find_from(long be)
{
	long y;
	long left = 10;
	memset(tvis, 0, sizeof(tvis));
	memset(tcar, 0, sizeof(tcar));
	for(y = be; y <= l; y++)
	{
		if (tcar[el[y]] == 0)
		{
			tcar[el[y]] = 1;
			tvis[el[y]] = y;
			left--;
		}
		if (left == 0) {break;}
	}
}
//-------------------------------------------------------------------------------------------------------------
void initialization()
{
	long y;
	cin >> sr;
	for(y = 0; y <= (strlen(sr) - 1); y++) 
	{
		el[y+1] = (sr[y] - '0');
	}
	l = strlen(sr);
}
//-------------------------------------------------------------------------------------------------------------
bool zero()
{
	long y, f = 0;
	for(y = 1; y <= l; y++)
	{
		if (el[y] == 0) {f = 1;}
	}
	if (f == 0)
	{
		cout << "10\n";
		return false;
	}
	return true;
}
//-------------------------------------------------------------------------------------------------------------
bool nine()
{
	long c = 1, be, en, left, y;
	long car[11];
	memset(car, 0, sizeof(car));
	be = 1;
	en = 9;
	left = 9;
	for(y = l; y >= 1; y--)
	{
		if ((el[y] >= be) && (el[y] <= en) && (car[el[y]] == 0))
		{
			left--;
			car[el[y]] = 1;
		}
		if (left == 0) {return true;}
	}
	for(y = be; y <= en; y++)
	{
		if (car[y] == 0) 
		{
			cout << y << "\n";
			return false;
		}
	}
	return false;
}
//-------------------------------------------------------------------------------------------------------------
long imp_dig()
{
	last[0] = 0;
	long d = 1, flag, be, en;
	long car[11], left;
	long c;
	long f;
	c = l;
	flag = 0;
	be = 0;
	en = 9;
	memset(car, 0, sizeof(car));
	left = 10;
	for( c = l; ; c--)
	{
		col[c] = 1;
		if (car[el[c]] == 0) 
		{
			car[el[c]] = 1;
			left--;
		}
		if (left == 0)
		{
			last[1] = c;
			flag = 1;
			break;
		}
	}
	if (flag == 0) {return -1;}
	// first digit rules
	for(d = 2; ; d++)
	{
		memset(car, 0, sizeof(car));
		flag = 0;
		left = 10;
		for(c-- ; c >= 1; c--)
		{
			col[c] = d;
			if (car[el[c]] == 0)
			{
				car[el[c]] = 1;
				left--;
			}
			if (left == 0)
			{
				last[d] = c;
				flag = 1;
				break;
			}
		}
		if (flag == 0) {return d;}
	}
}
//-------------------------------------------------------------------------------------------------------------
long next_max(long be, long d, long beg)
{
	long y, left = 10, m, j;
	long car[11], vis[11];
	memset(car, 0, sizeof(car));
	memset(vis, 0, sizeof(vis));
	for(y = be; col[y] == d; y++)
	{
		if (car[el[y]] == 0) 
		{
			car[el[y]] = 1;
		}
	}
	for(j = beg; ; j++)
	{
		if (car[j] == 0) {m = j; break;}
	}
	for( ;col[y] >= (d-1);y++)
	{
		if (col[y] == d) {continue;}
		if (el[y] == m) {return y;}
	}
}
//-------------------------------------------------------------------------------------------------------------
void inc_sol()
{
	long y;
	for(y = 1; y <= (d+1); y++)
	{
		if (sol[y] == 9) {sol[y] = 0; continue;}
		if (sol[y] < 9) 
		{
			sol[y]++;
			break;
		}
	}
}
//-------------------------------------------------------------------------------------------------------------
void print_solution()
{
	long y, j, maxp;
	long car[11];
	long vis[11];
	long pos = 1;
	pos = 1;
	for(y = 1; y <= L; y++) {sol[y] = 0;}
	for(y = d; y >= 2; y--)
	{
		if (y == d)
		{
			pos = next_max(pos, y, 1);
		}
		else
		{
			pos = next_max(pos, y, 0);
		}
		sol[y] = el[pos];
	}
	memset(car, 0, sizeof(car));
	for(y = (pos+1); y <= l; y++)
	{
		if (car[el[y]] == 0)
		{
			car[el[y]] = 1;
		}
	}
	for(y = 0; y <= 9; y++)
	{
		if (car[y+1] == 0)
		{
			sol[1] = y;
			break;
		}
	}
	inc_sol();
	for(y = 1; y <= d; y++)
	{
		cout << sol[y];
	}
}
//-------------------------------------------------------------------------------------------------------------
void print_colors()
{
	long y;
	for(y = 1; y <= l; y++) {cout << col[y];}
	cout << "\n";
}
//-------------------------------------------------------------------------------------------------------------
void logic()
{
	long y, n;
	initialization();
	if (!nine()) {return;}
	if (!zero()) {return;}
	d = imp_dig();
	//print_colors();
	if (d == -1) {cout << "10\n"; return;}
	print_solution();
}
//-------------------------------------------------------------------------------------------------------------
int main()
{
	freopen("cards.in", "r", stdin);
	freopen("cards.out", "w", stdout);
	logic();
	return 0;
}