program fur;

{$APPTYPE CONSOLE}

uses
  SysUtils;

const
 INF  = 1000000000;

{type
 ptree = ^ttree;
 ttree = record
  e:array['a'..'z'] of ptree;
  num : longint;
 end;

function tcreate(num:longint):ptree;
 var
  i:char;
 begin
  new(result);
  for i:='a' to 'z' do
   result.e[i]:=nil;
  result.num:=num;
 end;
 }

var
 als,nils:string;
 n,k:longint;
 i,j,q:longint;
 w:array[0..1000] of string;
 l:array[1..1000] of longint;
{ pw : array[1..1000] of ptree;}
 a:array[0..10] of longint;
 g:array[1..10,1..10] of longint;
 gp:array[1..10,1..10] of string;

{ root,cur:ptree;}
 alts : array[1..1000] of  string;
 altc:array[1..1000] of longint;

 ans:array[1..1000] of longint;
 ac:longint;

function alt(u,v:longint):string;
 var
  i,c:longint;
 begin
  result := w[v][1];
  i:=u; c:=1;
  while i<>v do
   begin
    while w[i][c]=w[v][c] do
     begin
      inc(c);
      result:=result + w[v][c];
     end;
    if w[v][c]=' ' then
     begin
      alt := '#';
      exit;
     end;
    inc(i);
    if i= n+1 then i:=1; 
   end;
 end;

var
 r,b,min,minb:array[-1..1000] of longint;

procedure refresh(u:longint);
 var
  i:longint;
 begin
  for i:=1 to n do
   if g[i,j]<INF then
    if r[i] = INF then
     if min[i] = INF then begin min[i]:=r[u]+g[u,i]; minb[i]:=u; end
     else
     if min[i]>r[u]+g[u,i] then begin min[i]:=r[u]+g[u,i]; minb[i]:=u; end;
 end;

procedure find(u,v:longint);
 var
  i,j:longint;
 begin
  for i:=1 to n do
   begin
    r[i]:=INF;
    min[i]:=INF;
   end;
  r[u]:=0; min[u]:=0;
  refresh(u);
  while r[v]=inf do
   begin
    j:=-1;
    for i:=1 to n do
     if (r[i]=INF) and (min[i]<INF) then
      if (min[i]<min[j]) or (j=-1) then j:=i;
//    if j = -1 then runerror(239);
    r[j]:=min[j];
    b[j]:=minb[j];
    refresh(j);
   end;
 end;

var
 u,v:longint;
begin
 assign(input,'fur.in'); reset(input);
 assign(output,'fur.out'); rewrite(output);
 for i:=1 to 2000 do nils:=nils+' ';
 readln(n);
 for i:=1 to n do readln(w[i]);
 for i:=1 to n do l[i]:=length(w[i]);
 for j:=0 to n do
  for i:=length(w[j]) to 2001 do w[j]:=w[j]+' ';


 //suffix-tree 
{ root := tcreate(0);
 for i:=1 to n do
  begin
   cur := root;
   for j:=1 to length(w[i]) do
    begin
     if cur.e[w[i][j]] = nil then cur.e[w[i][j]]:=tcreate(0);
     cur := cur.e[w[i][j]];
     if cur.num=0 then cur.num:=i;
    end;
  end;
 }
 //graph
 for i:=1 to n do
  for j:=1 to n do
   g[i,j]:= INF;
 for i:=1 to n do g[i,i]:=0;
 for i:=1 to n-1 do
  begin
   g[i,i+1]:=1;
   gp[i,i+1]:='down';
  end;
 for i:=2 to n do
  begin
   g[i,i-1]:=1;
   gp[i,i-1]:='up';
  end;
 g[1,n]:=1;
 gp[1,n]:='up';
 g[n,1]:=1;
 gp[n,1]:='down';

 //alting
 for i:=1 to n do
  for j:=1 to n do
   if i<>j then
    begin
     als := alt(i,j);
     if als<>'#' then
      if g[i,j]>length(als)+1 then
       begin
        g[i,j]:=length(als)+1;
        gp[i,j]:=als;
       end;
    end;

 // i'v done it! In God We Trust.
 u:=1;
 read(k);
 for i:=1 to k do
  begin
   read(v);
   find(u,v);//dijkstra
   writeln(r[v]);
   fillchar(ans,sizeof(ans),0);
   ac:=0; j:=v;
   while j<>u do
    begin
     inc(ac);
     ans[ac]:=j;
     j:=b[j];
    end;
   inc(ac); ans[ac]:=j;
   for j:=ac downto 2 do
    begin
     if gp[ans[j],ans[j-1]] = 'up' then writeln('up') else
     if gp[ans[j],ans[j-1]] = 'down' then writeln('down') else
     begin
      writeln('Alt');
      for q:=1 to length(gp[ans[j],ans[j-1]]) do writeln(GP[ans[j],ans[j-1]][q]);
     end;
    end; 

   u:=v;
  end;
 close(input);
 close(output);
end.
