program P2;

uses
    SysUtils,StrUtils;
var
    F:Text;
    Files:array[0..1000] of string;
    N,K,I:Integer;
    ToEdit:array[0..10] of Integer;
    CurrPos:Integer;

function GetDir(FromI,ToI:Integer):Boolean;
var
    MDist:Integer;
    Dist:Integer;
begin
    MDist:=((N+1) div 2)-1;
    Dist:=Abs(FromI-ToI);
    Result:=ToI<FromI;
    if Dist>MDist then Result:=not Result;
end;

function GetMinUpDown(FromI,ToI:Integer):Integer;
var
    MDist:Integer;
    Dist:Integer;
begin
    MDist:=((N+1) div 2)-1;
    Dist:=Abs(FromI-ToI);
    if Dist>MDist then
        Dist:=N-Dist;
    Result:=Dist;
end;

function GetVarLen(V:string):Integer;
var
    Idx:Integer;
    Line:string;
begin
    Idx:=AnsiPos(#13#10,V);
    Line:=Copy(V,1,Idx-1);
    Result:=StrToInt(Line);
end;

function GetMinAlts(Name:string;MaxP:Integer):string;
var
    I,P:Integer;
    SubStr:string;
    MinM,MinL,NP,MaxI,LastP,ToI:Integer;
    IsUp:Boolean;
begin
    ToI:=AnsiIndexStr(Name,Files);
    P:=CurrPos;
    if MaxP>0 then
        MinM:=MaxP
    else
        MinM:=-1;
    MinL:=-1;
    if MaxP<Length(Name) then MaxI:=MaxP
    else MaxI:=Length(Name);
    for I:=1 to MaxI do
    begin
        if (MinM>=0) and (I>=MinM) then Break;
        SubStr:=Copy(Name,1,I);
        while Copy(Files[P],1,I)<>SubStr do
        begin
            Inc(P);
            if P>N then P:=1;
        end;
        if (Files[P]=Name) then
        begin
            LastP:=P;
            MinM:=I;
            MinL:=I;
            Break;
        end
        else begin
            NP:=I+GetMinUpDown(P,ToI);
            if (NP<MinM) or (MinM=-1) then
            begin
                LastP:=P;
                MinM:=NP;
                MinL:=I;
            end;
        end;
    end;
    if MinL=-1 then Result:=''
    else begin
        Result:=IntToStr(MinM+1)+#13#10'Alt';
        for I:=1 to MinL do
            Result:=Result+#13#10+Name[I];
        IsUp:=GetDir(LastP,ToI);
        for I:=1 to MinM-MinL do
            if IsUp then
                Result:=Result+#13#10'up'
            else
                Result:=Result+#13#10'down';
    end;
end;

procedure FindWay(Index:Integer);
var
    I:Integer;
    FN:string;
    WayAlt,WayStr:string;
    End_Str:string;
    BestDir:Boolean;
    BestM,WayLen:Integer;
    IAltLen,AltLen,Dist:Integer;
    RealPos:Integer;
begin
    if Index=CurrPos then
        End_Str:='0'
    else begin
        FN:=Files[Index];
        Dist:=GetMinUpDown(CurrPos,Index);
        WayAlt:=GetMinAlts(FN,Dist);
        if WayAlt='' then
        begin
            BestDir:=GetDir(CurrPos,Index);
            BestM:=Dist;
        end
        else begin
            AltLen:=GetVarLen(WayAlt);
            IAltLen:=AltLen;
            End_Str:=WayAlt;
            BestM:=0;
        end;
        RealPos:=CurrPos;
        WayStr:=WayAlt;
        if WayAlt<>'' then
        begin
            WayLen:=AltLen;
            for I:=1 to WayLen-1 do
            begin
                if I>=WayLen then Break;
                Inc(CurrPos);
                if CurrPos>N then CurrPos:=1;
                WayAlt:=GetMinAlts(FN,IAltLen-I);
                if (WayAlt<>'') and (GetVarLen(WayAlt)+I<WayLen) then
                begin
                    WayLen:=GetVarLen(WayAlt)+I;
                    WayStr:=WayAlt;
                    BestM:=I;
                    BestDir:=False;
                end;
            end;
            CurrPos:=RealPos;
            for I:=1 to WayLen-1 do
            begin
                if I>=WayLen then Break;
                Dec(CurrPos);
                if CurrPos<1 then CurrPos:=N;
                WayAlt:=GetMinAlts(FN,IAltLen-I);
                if (WayAlt<>'') and (GetVarLen(WayAlt)+I<WayLen) then
                begin
                    WayLen:=GetVarLen(WayAlt)+I;
                    WayStr:=WayAlt;
                    BestM:=I;
                    BestDir:=True;
                end;
            end;
        end;
        if WayStr='' then
            End_Str:=IntToStr(BestM)
        else
            End_Str:=IntToStr(BestM+GetVarLen(WayStr));
        for I:=1 to BestM do
            if BestDir then
                End_Str:=End_Str+#13#10'up'
            else
                End_Str:=End_Str+#13#10'down';
        End_Str:=End_Str+Copy(WayStr,AnsiPos(#13#10,WayStr),Length(WayStr));
    end;
    AssignFile(F,'Fur.out');
    Append(F);
    WriteLn(F,End_Str);
    CloseFile(F);
    CurrPos:=Index;
end;

begin
    AssignFile(F,'Fur.in');
    Reset(F);
    ReadLn(F,N);
    for I:=1 to N do
        ReadLn(F,Files[I]);
    Files[0]:='';
    ReadLn(F,K);
    for I:=0 to K-1 do
        Read(F,ToEdit[I]);
    CloseFile(F);
    CurrPos:=1;
    AssignFile(F,'Fur.out');
    Rewrite(F);
    CloseFile(F);
    for I:=0 to K-1 do
        FindWay(ToEdit[I]);
end.
