program fur;

uses SysUtils;

var files   : array[1..1000,1..2001] of Char;
    N,cur   : Word;
    edits   : array[1..10] of Word;
    K       : Byte;
    way     : array[0..2] of Word;
    f       : Text;

     procedure Input;
     var s : Char;
         l : Word;
     begin
          Assign(f,'fur.in');
          Reset(f);
                ReadLn(f,N);
          for cur:=1 to N do
          begin
               Read(f,s);
               l := 1;
               while s in ['a'..'z'] do
               begin
                    files[cur,l]:=s;
                    Read(f,s);
                    inc(l);
               end;
               files[cur,l]:=#0;
               ReadLn(f);
          end;
                ReadLn(f,K);
          for cur:=1 to K do Read(f,edits[cur]);
          Close(f);
     end;

     procedure OutWay(fil : Word);
     var i : Word;
     begin
          case way[1] of
          0: WriteLn(f,'0'); 
          1: begin
                  WriteLn(f,way[2]);
                  for i:=1 to way[2] do
                      WriteLn(f,'up');
             end;
          2: begin
                  WriteLn(f,way[2]);
                  for i:=1 to way[2] do
                      WriteLn(f,'down');
             end;
          3: begin
                  WriteLn(f,way[2]);
                  WriteLn(f,'Alt');
                  dec(way[2]);
                  for i:=1 to way[2] do
                      WriteLn(f,files[fil,i]);
             end;
          end;
     end;

     function AWay(b,e : Word) : Word;
     var cur : Word;
     begin
          result:=0;
          if b=e then exit;
          cur:=b;
          result:=1;
          while (cur<>e) and (files[cur,result]<>#0) do
          begin
               while files[cur,result]<>files[e,result] do
                    if cur<N then inc(cur) else cur:=1;
               inc(result);
          end;
          if files[cur,result]=#0 then result:=65535;
     end;

     function UWay(b,e : Word) : Word;
     begin
          if e=b then result:=0 else
          if e<b then result:=b-e else
          result:=b+N-e;
     end;

     function DWay(b,e : Word) : Word;
     begin
          if b=e then result:=0 else
          if b<e then result:=e-b else
          result:=e+N-b;
     end;

     procedure GetWay(b,e : Word);
     var ways : array[1..3] of Word;
     begin
          if b=e then
          begin
               way[1]:=0;
               way[2]:=0;
               exit;
          end;
          ways[1]:=UWay(b,e);
          ways[2]:=DWay(b,e);
          ways[3]:=AWay(b,e);
          if (ways[1]<=ways[2]) and (ways[1]<=ways[3]) then
          begin
               way[1]:=1;
               way[2]:=ways[1];
          end else
          if (ways[2]<=ways[1]) and (ways[2]<=ways[3]) then
          begin
               way[1]:=2;
               way[2]:=ways[2];
          end else
          if (ways[3]<=ways[1]) and (ways[3]<=ways[2]) then
          begin
               way[1]:=3;
               way[2]:=ways[3];
          end;
     end;

     procedure Solve;
     var i : Word;
     begin
          Assign(f,'fur.out');
          Rewrite(f);
          cur:=1;
          for i:=1 to K do
          begin
               GetWay(cur,edits[i]);
               OutWay(i);
               cur:=edits[i];
          end;
          Close(f);
     end;

begin
     Input;
     Solve;
end.
