{$APPTYPE CONSOLE}
{$I-,Q-,R-,S-,O+}
uses math,sysutils;
const infinity=100000;
type pnode=^tnode;
     tnode=record
       symb:char;
       br,son:pnode;
       best:word;
     end;
var n,i,m,cur,j,q,k:longint;
    fname:array [1..1000] of string;
    a:array [1..10] of longint;
    weight:array [1..1000,1..1000] of longint;
    best,last:array [1..1000] of longint;
    root:pnode;
    mark:array [1..1000] of boolean;
function getup(i,j:longint):longint;
begin
  result:=i-j;
  if result<0 then
    inc(result,n);
end;
function getdown(i,j:longint):longint;
begin
  result:=getup(j,i);
end;
procedure create(var t:pnode);
begin
  new(t);
  fillchar(t^,sizeof(t^),0);
end;
function getson(t:pnode;c:char):pnode;
var cur:pnode;
begin
  cur:=t^.son;
  while cur<>nil do
  begin
    if cur^.symb=c then
      break;
    cur:=cur^.br;
  end;
  getson:=cur;
end;
function addson(t:pnode;c:char):pnode;
begin
  create(result);
  result^.symb:=c;
  result^.br:=t^.son;
  t^.son:=result;
end;
procedure add(t:pnode;s:string;k:longint);
var cur,tmp:pnode;
    i:longint;
begin
  cur:=t;
  for i:=1 to length(s) do
  begin
    tmp:=getson(cur,s[i]);
    if tmp=nil then
      tmp:=addson(cur,s[i]);
    cur:=tmp;
  end;
  cur^.best:=k;  
end;
procedure debug(t:pnode;s:string);
var cur:pnode;
begin
  writeln(s+t^.symb+' '+inttostr(t^.best));
  cur:=t^.son;
  while cur<>nil do
  begin
    debug(cur,s+' ');
    cur:=cur^.br;
  end;
end;
procedure dfs(t:pnode;d,k:longint);
var cur:pnode;
begin
  if t^.best=0 then
  begin
    cur:=t^.son;
    while cur<>nil do
    begin
      dfs(cur,d+1,k);
      if (t^.best=0) or (getdown(k,cur^.best)<getdown(k,t^.best)) then
        t^.best:=cur^.best; 
      cur:=cur^.br;
    end;
  end;
  if (d<>0) and (d+1<weight[k,t^.best]) then
    weight[k,t^.best]:=d+1;
end;
procedure free(t:pnode);
begin
  if t=nil then
    exit;
  free(t^.br);
  free(t^.son);
  dispose(t);  
end;
procedure restore(x,y:longint);
var i:longint;
begin
  if x=y then
    exit;
  restore(x,last[y]);  
  if weight[last[y],y]=getup(last[y],y) then
  begin
    for i:=1 to weight[last[y],y] do
      writeln('up');
  end
  else if weight[last[y],y]=getdown(last[y],y) then
  begin
    for i:=1 to weight[last[y],y] do
      writeln('down');
  end
  else begin
    writeln('Alt');
    for i:=1 to weight[last[y],y]-1 do
      writeln(fname[y,i]);
  end;
end;
begin
  assign(input,'fur.in');
  reset(input);
  assign(output,'fur.out');
  rewrite(output);
  readln(n);
  for i:=1 to n do
    readln(fname[i]);
  read(m);
  for i:=1 to m do
    read(a[i]);
  for i:=1 to n do
  begin
    for j:=1 to n do
      weight[i,j]:=min(getup(i,j),getdown(i,j));
    create(root);
    for j:=1 to n do
      add(root,fname[j],j);
    dfs(root,0,i);
    free(root);
  end;
  cur:=1;  
  for i:=1 to m do
  begin
    for j:=1 to n do
      best[j]:=infinity;
    best[cur]:=0;
    fillchar(mark,sizeof(mark),false);
    for j:=1 to n do
    begin
      q:=0;
      for k:=1 to n do
        if not mark[k] and ((q=0) or (best[k]<best[q])) then
          q:=k;
      mark[q]:=true;
      for k:=1 to n do
        if best[q]+weight[q,k]<best[k] then
        begin
          best[k]:=best[q]+weight[q,k];
          last[k]:=q;
        end;
    end;
    writeln(best[a[i]]);
    restore(cur,a[i]);
    cur:=a[i];
  end;
  close(input);
  close(output);
end.
