#include <fstream>

const int INF = 2000000000;

int n, k;
char files[1000][2002];
int ar[1000][1000];

using namespace std;


int get(int x)
{
	if (x < 0)
		x = n - 1;
	else if (x >= n)
		x = 0;
	return x;
}


int nalt(int p, int d)
{
	char s[2002];
	sprintf(s, files[d]);
	int i = 0;
	int pos = p;
	while (pos != d)
	{
		int ls = strlen(s);
		int lf = strlen(files[pos]);
		while (i < ls && i < lf && s[i] == files[pos][i])
			i++;
		if (i == ls)
			return INF;
		pos = get(pos + 1);
	}
	return i + 2;
}


int func(int p, int d)
{
	p = get(p);
	d = get(d);
	if (ar[p][d] != -1)
		return ar[p][d];
	int a[5];
	a[0] = nalt(p, d);
	ar[p][d] = a[0];
	A:	a[1] = 1 + func(p - 1, d);
	if (a[1] < ar[p][d])
		ar[p][d] = a[1];
	a[2] = 1 + func(p + 1, d);
	if (a[2] < ar[p][d]) {
		ar[p][d] = a[2];
		goto A;
	}
	a[3] = 1 + func(p, d - 1);
	if (a[3] < ar[p][d]) {
		ar[p][d] = a[3];
		goto A;
	}
	a[4] = 1 + func(p, d + 1);
	if (a[4] < ar[p][d]) {
		ar[p][d] = a[4];
		goto A;
	}
	/*int m = 0;
	int min = a[0];
	for (int i = 1; i < 5; i++)
	{
		if (a[i] < min) {
			m = i;
			min = a[i];
		}
	}
	ar[p][d] = min;*/
	return ar[p][d];
}

void print(ofstream &fo, int p, int d)
{
	if (get(p + 1) == d)
		fo << "down\n";
	else if (get(p - 1) == d)
		fo << "up\n";
	else {
		fo << "Alt\n";
		for (int i = 0; i < ar[p][d] - 1; i++)
			fo << files[d][i] << "\n";
	}
}

void findpath(ofstream &fo, int p, int d)
{
	if (p == d)
		return;
    int i = 0;
	while ((i < n) && (ar[p][i] <= 0 || ar[i][d] <= 0 || ar[p][i] + ar[i][d] != ar[p][d]))
		i++;
	if (i == n) {
		print(fo, p, d);
		return;
	}
	print(fo, p, i);
	findpath(fo, i, d);
}

int main()
{
	ifstream fi;
	ofstream fo;
	int a[10];
	int res[10];

	fi.open("fur.in");
	fi >> n;
	for (int i = 0; i < n; i++)
		fi >> files[i];
	fi >> k;
	for (int i = 0; i < k; i++) {
		fi >> a[i];
		a[i]--;
	}
	fi.close();
	for (int i = 0; i < n; i++)
	{
		for (int j = i; j < n; j++)
			ar[i][j] = ar[j][i] = -1;
		ar[i][i] = 0;
		ar[i][get(i+1)] = ar[get(i+1)][i] = 1;
		ar[i][get(i-1)] = ar[get(i-1)][i] = 1;
	}
	int pos = 0;
	for (int i = 0; i < k; i++)
	{
		res[i] = func(pos, a[i]);
		pos = a[i];
	}
	fo.open("fur.out");
	for (int i = 0; i < k; i++) {
		fo << res[i] << "\n";
		if (!i)
			findpath(fo, 0, a[i]);
		else
			findpath(fo, a[i - 1], a[i]);
	}
	fo.close();

	return 0;
}
