{$APPTYPE CONSOLE}
{$O-,H+,Q-,R-,S-,B-}
type
 int=longint;
const
 inf=1000000001;
 maxN=1000;
var
 fl    :  array[0..maxN+1]of string;
 sym,w :  array[0..maxN+1,0..maxN+1]of int;
 d,p   :  array[0..maxN+1]of int;
 path  :  array[0..maxN+1]of int;
 ok    :  array[0..maxN+1]of boolean;
 n,i,j,l,x,y,max:int;
 k,st,fn,u,v,np:int;

function min(a,b:int):int;
begin
 if (a<b) then min:=a else min:=b;
end;

procedure dijkstra(st,fn:int);
var x,i:int;
begin
 fillchar(ok,sizeof(ok),false);
 fillchar(p,sizeof(p),0);
 for i:=1 to n do d[i]:=inf;
 d[st]:=0; ok[st]:=true;
 x:=st;
 while (not(ok[fn])) do begin
  for i:=1 to n do
   if (d[i]>d[x]+w[x,i]) then begin
    d[i]:=d[x]+w[x,i];
    p[i]:=x;
   end;
  x:=1;
  for i:=1 to n do
   if ((ok[x])or(d[x]>d[i]))and(not(ok[i])) then x:=i;
  ok[x]:=true;
 end;
end;

Begin
 assign(input,'fur.in');
 reset(input);
 assign(output,'fur.out');
 rewrite(output);
 readln(n);
 for i:=1 to n do readln(fl[i]);
 {greatest common prefix}
 fillchar(sym,sizeof(sym),0);
 {equal strings}
 fillchar(ok,sizeof(ok),false);
 for i:=1 to n do
  if (not(ok[i])) then begin
   ok[i]:=true;
   np:=1;
   p[np]:=i;
   for j:=1 to n do
    if (fl[i]=fl[j])and(i<>j) then begin
     ok[j]:=true;
     inc(np);
     p[np]:=j;
    end;
   sym[i,i]:=length(fl[i]);
   for x:=1 to np do
    for y:=1 to np do
     sym[p[x],p[y]]:=sym[i,i];
  end;
 {normal alg.}
 for i:=1 to n do
  for j:=i to n do begin
   st:=sym[i,j]+1;
   fn:=min(length(fl[i]),length(fl[j]));
   for l:=st to fn do
    if (fl[i][l]=fl[j][l]) then inc(sym[i,j]) else break;
   sym[j,i]:=sym[i,j];
  end;
 {ALT jumps}
 for i:=1 to n do
  for j:=1 to n do
   w[i,j]:=inf;
 for j:=1 to n do begin
  max:=0;
  w[j,j]:=0;
  for i:=j-1 downto 1 do begin
   if (max<sym[i,j]) then max:=sym[i,j];
   if (max>=length(fl[j])) then begin
    max:=inf;
    break;
   end;
   w[i,j]:=max+2;
  end;
  for i:=n downto j+1 do begin
   if (max<sym[i,j]) then max:=sym[i,j];
   if (max>=length(fl[j])) then begin
    max:=inf;
    break;
   end;
   w[i,j]:=max+2;
  end;
 end;
 {UP/DOWN jumps}
 for i:=1 to n do begin
  w[i,(i mod N)+1]:=1;
  w[(i mod N)+1,i]:=1;
  w[i,i]:=0;
 end;
{
 writeln('W array');
 for i:=1 to n do begin
  for j:=1 to n do write(w[i,j]:2);
  writeln;
 end;
}
 {Dijkstra}
 read(k);
 st:=1;
 for i:=1 to k do begin
  read(fn);
  dijkstra(st,fn);
  writeln(d[fn]);
  st:=fn;
  {path}
  np:=0;
  v:=fn;
  while (d[v]>0) do begin
   inc(np);
   path[np]:=v;
   v:=p[v];
  end;
  inc(np); path[np]:=v;
  for j:=np downto 2 do begin
   u:=path[j]; v:=path[j-1];
   if ((u mod N)+1=v) then writeln('down') else
   if ((v mod N)+1=u) then writeln('up') else begin
    writeln('Alt');
    for L:=1 to w[u,v]-1 do
     writeln(fl[v][L]);
   end;
  end;
  {/path}
 end;
 close(output);
End.
