#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define MAXN 1010
#define MAXK 13
#define LEN 2010

int St, En, N, K, A[MAXK];
char S[MAXN][LEN];
int L[MAXN][MAXN], Max[MAXN][MAXN];
int D[MAXN], La[MAXN];
int Po[MAXN], Si[MAXN], Q[MAXN][MAXN];
int PN, P[MAXN];

int Cor( int v )
{
  while (v < 0) v += N;
  while (v >= N) v -= N;
  return v;
}

void Add( int v, int d, int la )
{
  v = Cor(v);
  if (D[v] > d)
    D[v] = d, La[v] = la, Q[d][Si[d]++] = v; 
}

int main( void )
{
  int i, j, k, a, b;

  freopen("fur.in", "rt", stdin);
  freopen("fur.out", "wt", stdout);
  scanf("%d", &N);
  for (i = 0; i < N; i++)
    scanf("%s", S[i]);
  scanf("%d", &K);
  for (A[0] = 0, i = 1; i <= K; i++)
    scanf("%d", &A[i]), A[i]--;
  for (i = 0; i < N; i++)
    for (j = i + 1; j < N; j++)
    {
      for (k = 0; S[i][k] == S[j][k]; k++)
        ;
      L[i][j] = L[j][i] = k;
    }
  for (i = 0; i < N; i++)
  {
    Max[i][i] = k = 0;
    for (j = Cor(i - 1); j != i; j = Cor(j - 1))
    {
      if (L[j][i] > k)
        k = L[j][i];
      Max[j][i] = k;
    }
  }
  for (k = 0; k < K; k++)
  {
    St = A[k], En = A[k + 1];
    for (i = 0; i < N; i++)
      D[i] = MAXN, Po[i] = Si[i] = 0;
    Add(St, 0, -1);
    for (i = 0; i < N; i++)
      while (Po[i] < Si[i])
      {
        j = Q[i][Po[i]++];
        Add(j + 1, i + 1, j);
        Add(j - 1, i + 1, j);
        for (a = 0; a < N; a++)
          Add(a, i + Max[j][a] + 2, j);
      }
    printf("%d\n", D[En]);
    PN = 0;
    for (i = En; i != -1; i = La[i])
      P[PN++] = i;
    for (i = PN - 1; i > 0; i--)
    {
      a = P[i], b = P[i - 1];
      if (Cor(a + 1) == b)
        puts("down");
      else if (Cor(a - 1) == b)
        puts("up");
      else
      {
        puts("Alt");
        for (j = 0; j <= Max[a][b]; j++)
          printf("%c\n", S[b][j]);
      }
    }
  }
  return 0;
}
