{$apptype console}
{$maxstacksize 30000000}

const max_q = 1000000;
      max_n = 1000;
      max_k = 10;

var name: array [1..max_n] of string;
    len: array [1..max_n] of longint;
    dist: array [1..max_n] of longint;
    how: array [1..max_n] of char;
    fr: array [1..max_n] of longint;
    q: array [1..max_q] of longint;
    a: array [0..max_k] of longint;
    i, n, k: longint;
    last: char;

procedure calc(ii, jj: longint);
var i, j, k, l, qb, qe: longint;
    s: string;
    ch: char;

  procedure add(i, j, l: longint; f: char);
  begin
    if dist[j] > dist[i] + l then begin
      dist[j] := dist[i] + l;
      fr[j] := i;
      how[j] := f;
      q[qe] := j;
      inc(qe);
      if qe > max_q then qe := 1;
      assert(qb <> qe);
    end;
  end;

begin
  fillchar(dist, sizeof(dist), 127);
  qb := 1; qe := 2;
  q[1] := ii;
  dist[ii] := 0;
  fr[ii] := 0;
  how[ii] := #0;

  while qb <> qe do begin
    i := q[qb];

    // up
    j := i-1; if j < 1 then j := n;
    add(i, j, 1, 'U');

    // down
    j := i+1; if j > n then j := 1;
    add(i, j, 1, 'D');

    // Alt
    k := i;
    s := ''; l := 0;
    while (fr[k] <> 0)and(how[k] <> 'U')and(how[k] <> 'D') do begin
      s := s + how[k];
      k := fr[k];
      inc(l);
    end;
    for ch := 'a' to 'z' do begin
      j := i;
      while (l+1 > len[j])or(pos(s + ch, name[j]) <> 1) do begin
        inc(j); if j > n then j := 1;
        if i = j then break;
      end;
      add(i, j, 1 + ord(l = 0), ch);
    end;

    inc(qb);
    if qb > max_q then qb := 1;
  end;
end;

procedure res(k: longint);
begin
  if fr[k] <> 0 then res(fr[k]);
  if how[k] = 'U' then begin
    writeln('up');
    last := 'U';
  end else if how[k] = 'D' then begin
    writeln('down');
    last := 'D';
  end else if how[k] in ['a'..'z'] then begin
    if not(last in ['U','D']) then writeln('Alt');
    writeln(how[k]);
    last := how[k];
  end;
end;

begin
  reset(input, 'fur.in');
  rewrite(output, 'fur.out');

  readln(n);
  for i := 1 to n do begin
    readln(name[i]);
    len[i] := length(name[i]);
  end;

  read(k);
  for i := 1 to k do read(a[i]);
  a[0] := 1;

  for i := 1 to k do begin
    calc(a[i-1], a[i]);
    writeln(dist[a[i]]);
    last := 'U';
    res(a[i]);
  end;

  close(input); close(output);
end.