program P2;

{$A8,B-,C+,D-,E-,F-,G+,H+,I-,J-,K-,L-,M-,N+,O+,P+,Q-,R-,S-,T-,U-,V+,W-,X+,Y+,Z1}
//{$A8,B-,C+,D+,E-,F-,G+,H+,I+,J-,K-,L+,M-,N+,O+,P+,Q+,R+,S-,T-,U-,V+,W-,X+,Y+,Z1}
{$MINSTACKSIZE $00004000}
{$MAXSTACKSIZE $00100000}
{$IMAGEBASE $00400000}
{$APPTYPE CONSOLE}

uses
  SysUtils;

type
  int = integer;
  str = string;

const inf = 999999999; 

var n: int;

function Min(a, b: int): int;
begin
  if a<b then Result:=a
  else Result:=b;
end;

function Max(a, b: int): int;
begin
  if a>b then Result:=a
  else Result:=b;
end;

function Common(const a, b: str): int;
var i: int;
begin
  Result:=Min(Length(a), Length(b))+1;
  for i:=1 to Result-1 do
    if a[i]<>b[i] then
    begin
      Result:=i;
      exit;
    end;
  if Length(a)>Length(b) then Result:=inf;
end;

function Dist(a, b: int; out c: char): int;
var x: int;
    f: boolean;
begin
  x:=b-a;
  if x<0 then
  begin
    x:=-x;
    f:=true;
  end
  else
    f:=false;
  if x<n-x then
  begin
    Result:=x;
    if f then c:='U' else c:='D';
  end
  else
  begin
    Result:=n-x;
    if f then c:='D' else c:='U';
  end
end;

var a: array[1..1000] of str;
    req: array[0..10] of int;
    nreq: int;
    dc, d: array[1..1000, 1..1000] of int;
    w: array[1..100, 1..100] of str;

var i, j, k, l, i0, x, y: int;
    c: char;

begin
  Assign(input, 'fur.in');
  Reset(input);
  ReadLn(n);
  for i:=1 to n do ReadLn(a[i]);
  Read(nreq);
  for i:=1 to nreq do Read(req[i]);
  Close(input);
  req[0]:=1;

  for j:=1 to n do
  begin
    i:=j;
    while true do
    begin
      i0:=i;
      Dec(i);
      if i<=0 then i:=n;
      if i=j then break;
      dc[i, j]:=Max(Common(a[i], a[j]), dc[i0, j]);
    end;
  end;

  for i:=1 to n-1 do
  begin
    d[i, i+1]:=1;
    w[i, i+1]:='D';
    d[i+1, i]:=1;
    w[i+1, i]:='U';
  end;
  if n>1 then
  begin
    d[1, n]:=1;
    w[1, n]:='U';
    d[n, 1]:=1;
    w[n, 1]:='D';
  end;
  for k:=2 to n do
    for i:=1 to n do
    begin
      j:=i+k;
      if j>n then j:=j-n;
      if i=j then break;
      x:=Dist(i, j, c);
      y:=dc[i, j]+1;
      if x<=y then
      begin
        d[i, j]:=x;
        SetLength(w[i, j], x);
        for l:=1 to x do
          w[i, j][l]:=c;
      end
      else
      begin
        d[i, j]:=y;
        w[i, j]:='A'+Copy(a[j], 1, y-1);
      end;
      l:=i+1;
      if l>n then l:=1;
      while l<>j do
      begin
        x:=d[i, l]+d[l, j];
        if x<d[i, j] then
        begin
          d[i, j]:=x;
          w[i, j]:=w[i, l]+w[l, j];
        end;
        l:=l+1;
        if l>n then l:=1;
      end;

      j:=i-k;
      if j<=0 then j:=j+n;
      x:=Dist(i, j, c);
      y:=dc[i, j]+1;
      if x<=y then
      begin
        d[i, j]:=x;
        SetLength(w[i, j], x);
        for l:=1 to x do
          w[i, j][l]:=c;
      end
      else
      begin
        d[i, j]:=y;
        w[i, j]:='A'+Copy(a[j], 1, y-1);
      end;
      l:=i-1;
      if l<=0 then l:=n;
      while l<>j do
      begin
        x:=d[i, l]+d[l, j];
        if x<d[i, j] then
        begin
          d[i, j]:=x;
          w[i, j]:=w[i, l]+w[l, j];
        end;
        l:=l-1;
        if l<=0 then l:=n;
      end;

    end;

  Assign(output, 'fur.out');
  Rewrite(output);
  for i:=1 to nreq do
  begin
    x:=d[req[i-1], req[i]];
    WriteLn(x);
    for j:=1 to x do
    begin
      c:=w[req[i-1], req[i]][j];
      case c of
        'U': WriteLn('up');
        'D': WriteLn('down');
        'A': WriteLn('Alt');
        else WriteLn(c);
      end;
    end;
  end;
  Close(output);

end.
 