program man;

{$D-,L-}
{$R-,Q-}
{$S-,I-,C-}

uses
  SysUtils;

var
  n, k: Integer;
  f: array [1..1000] of String;
  zap: array [1..10] of Integer;
  output: Text;

procedure ReadFromFile;
var
  fin: Text;
  i: Integer;
begin
  Assign(fin, 'fur.in');
  Reset(fin);
  Readln(fin, n);
  for i := 1 to n do
    Readln(fin, f[i]);
  Readln(fin, k);
  for i := 1 to k do
    Read(fin, zap[i]);
end;

function MakeUpWay(now, dob: Integer): Integer;
var
  i: Integer;
begin
  i := now;
  Result := 0;
  while i <> dob do
  begin
    Inc(result);
    Dec(i);
    if i < 1 then
      i := n;
  end
end;

var
  s: String;

function CanFind(now, dob, count: Integer): Boolean;
var
  i: Integer;
begin
  s := Copy(f[dob], 1, count);
  i := now;
  while i <> dob do
  begin
    Inc(i);
    if i > n then
      i := 1;
    if i = dob then
      break;
    if (Pos(s, f[i]) = 1) then
    begin
      Result := true;
      Exit
    end
  end;
  Result := false;
end;

function GetAltWay(now, dob: Integer; var st: String): Integer;
var
  i: Integer;
begin
  Result := 2;
  i := 1;
  s := f[now][1];
  while (i <= length(s)) and CanFind(now, dob, i) do
  begin
    Inc(i);
    Inc(result);
  end;
  st := s;
end;

function GetDownWay(now, dob: Integer): Integer;
var
  i: Integer;
begin
  i := now;
  Result := 0;
  while i <> dob do
  begin
    Inc(result);
    Inc(i);
    if i > n then
      i := 1;
  end
end;

function MakeDownWay(now, dob: Integer; var str: String): Integer;
var
  best, bestres, canres, i: Integer;
  st: String;
begin
  best := now;
  bestres := GetDownWay(now, dob);
  i := now;
  st := '';
  while i <> dob do
  begin
    Inc(i);
    if i > n then
      i := 1;
    canres := GetDownWay(i, dob) + GetAltWay(now, i, st);
    if canres < bestres then
    begin
      bestres := canres;
      best := i;
      str := st;
    end
  end;
  Result := bestres;
end;

procedure MakeWay(now, dob: Integer);
var
  u, d, count, i, next: Integer;
  str: String;
begin
  u := MakeUpWay(now, dob);
  d := MakeDownWay(now, dob, str);
  if u <= d then
  begin
    Writeln(output, u);
    for i := 1 to u do
      Writeln(output, 'up');
  end
  else
  begin
    Writeln(output, d);
    next := 0;
    if Length(str) <> 0 then
    begin
      Writeln(output, 'Alt');
      for i := 1 to Length(str) do
        Writeln(output, str[i]);
      next := 1;
    end;
      for i := 1 to d - Length(str) - next do
        Writeln(output, 'down')
  end
end;

procedure MakeFile;
var
  i, now: Integer;
begin
  now := 1;
  for i := 1 to k do
  begin
    MakeWay(now, zap[i]);
    now := zap[i];
  end
end;

begin
  ReadFromFile;

  Assign(output, 'fur.out');
  Rewrite(output);
  MakeFile;
  Close(output);
end.
 