
#include <iostream>
#include <fstream>
#include <string>
#include <vector>
using namespace std;

vector <string> commands;
string Names[1000];
int N, K, Edit[11], Type;
bool exists1[30];

bool DoesBeg( string &s, string &from )
{
	for( int i = 0; i < from.length(); ++i )
		if( s[i] != from[i] )
			return false;
	return true;
}

int GetFromTo( int from, int to, int &type, string buf = "" )
{
	int up = 999, down, alt = 1000;
	up   = to <= from ? from - to : N - to + from;
	down = to >= from ? to - from : N - from + to;
	if( up <= 2 ) 
	{
		type = 0;
		if( buf.length() )
			for( int i = 0; i < up; ++i )
				commands.insert( commands.begin(), "up" );
		return up;
	}
	if( down <= 2 )
	{
		type = 1;
		if( buf.length() )
			for( int i = 0; i < up; ++i )
				commands.insert( commands.begin(), "down" );
		return down;
	}
	int press, cur_alt;
	char next_best;
	/*
	if( !buf.length() )
	{
		for( char next = 'a'; next <= 'z' && alt; ++next )
		{
			if( !exists1[next-'a'] ) continue;
			string buf2 = buf + next;
			for( press = from; ; press < N-1 ? ++press : press = 0 )
				if( DoesBeg( Names[press], buf2 ) ) break;
			if( press == to-1 ) cur_alt = 0;
			else cur_alt = GetFromTo( press, to, type, buf2 ) + 1;
			if( cur_alt < alt ) { alt = cur_alt; next_best = next; }
		}
	}
	else*/
	{
		next_best = Names[to-1][buf.length()];
		string buf2 = buf + next_best;
		for( press = from; ; press < N-1 ? ++press : press = 0 )
			if( DoesBeg( Names[press], buf2 ) ) break;
		if( press == to-1 ) alt = 1;
		else alt = GetFromTo( press, to, type, buf2 );
	}
	if( alt < up && alt < down )
	{
		type = 2;
		commands.insert( commands.begin(), string( 1, next_best ) );
		return alt + 1;
	}
	return up < down ? type = 0, up : type = 1, down;
}

int main()
{
	ifstream fi( "fur.in" );
	//ofstream fo( "fur.out" );
	fi >> N;
	for( int i = 0; i < N; ++i ) 
	{ 
		fi >> Names[i];
		//for( int j = 0; j < Names[i].length(); ++j )
			exists1[Names[i][0]-'a'] = true;
	}
	fi >> K;
	for( int i = 1; i <= K; ++i ) fi >> Edit[i];
	Edit[0] = 1;
	for( int i = 1; i <= K; ++i )
	{
		int num = GetFromTo( Edit[i-1], Edit[i], Type );
		cout << num << endl;
		switch( Type )
		{
		case 0:
			for( int i = 0; i < num; ++i ) cout << "up\n";
			break;
		case 1:
			for( int i = 0; i < num; ++i ) cout << "down\n";
			break;
		case 2:
			cout << "Alt\n";
			for( int i = 0; i < num-1; ++i )
				cout << commands[i] << endl;
		}
		commands.clear();
	}
	return 0;
}