
#include <fstream>
#include <string>
#include <vector>
using namespace std;

vector <string> commands;
string Names[1000];
int N, K, Edit[11], Type;
bool exists1[30];

bool DoesBeg( string &s, string &from )
{
	for( int i = 0; i < from.length(); ++i )
		if( s[i] != from[i] )
			return false;
	return true;
}

int GetFromTo( int from, int to, int &type, string buf = "" )
{
	int up, down, alt;
	up   = to <= from ? from - to : N - to + from;
	down = to >= from ? to - from : N - from + to;
	if( up <= 2 ) 
	{
		type = 0;
		for( int i = 0; i < up; ++i )
			commands.insert( commands.begin(), "up" );
		return up;
	}
	if( down <= 2 )
	{
		type = 1;
		for( int i = 0; i < down; ++i )
			commands.insert( commands.begin(), "down" );
		return down;
	}
	int press;
	string buf2 = buf + Names[to-1][buf.length()];
	for( press = from-1; ; press < N-1 ? ++press : press = 0 )
		if( DoesBeg( Names[press], buf2 ) ) break;
	press++;
	if( press == to ) alt = 0;
	else { GetFromTo( press, to, type, buf2 ); alt = commands.size(); }
	if( alt < up && alt < down )
	{
		type = 2;
		commands.insert( commands.begin(), string( 1, Names[to-1][buf.length()] ) );
		return commands.size();
	}
	return up < down ? type = 0, up : type = 1, down;
}

int main()
{
	ifstream fi( "fur.in" );
	ofstream fo( "fur.out" );
	fi >> N;
	for( int i = 0; i < N; ++i ) 
	{ 
		fi >> Names[i];
		exists1[Names[i][0]-'a'] = true;
	}
	fi >> K;
	for( int i = 1; i <= K; ++i ) fi >> Edit[i];
	Edit[0] = 1;
	for( int i = 1; i <= K; ++i )
	{
		int num = GetFromTo( Edit[i-1], Edit[i], Type );
		switch( Type )
		{
		case 0:
			fo << num << endl;
			for( int i = 0; i < num; ++i ) fo << "up\n";
			break;
		case 1:
			fo << num << endl;
			for( int i = 0; i < num; ++i ) fo << "down\n";
			break;
		case 2:
			fo << num+1 << endl;
			fo << "Alt\n";
			for( int i = 0; i < commands.size(); ++i )
				fo << commands[i] << endl;
		}
		commands.clear();
	}
	return 0;
}