#include <stdio.h>
#include <string.h>
#include <algorithm>
#include <memory.h>
#include <map>
#include <vector>

using namespace std;

#define NMAX 1100
#define LMAX 2100
#define INF 1000000000

typedef multimap<int,int> MAP;


vector<char> VEC;
int n;
int k;
char st[NMAX][LMAX];
int pointer[NMAX];
int seq[13];
int a[NMAX][NMAX];
int number[NMAX];
int len[NMAX];
int dist[NMAX];
bool flag[NMAX];
int curr;

MAP heap;
//M_ITER curr;
pair< int,int > qwe;

bool cmp(int a, int b)
{
	int i;
    for (i=0;st[a][i] && st[b][i] && st[a][i]==st[b][i];i++);
	if (!st[a][i] || !st[b][i])  return (a<b);
	return (st[a][i]<st[b][i]);
}

int main()
{
	freopen("fur.in", "r", stdin);
	freopen("fur.out", "w", stdout);
	scanf("%d", &n);
	int i;
	for (i=0;i<n;i++)
	{
		scanf("%s", st[i]);
		len[i]=strlen(st[i]);
		pointer[i]=i;
	}
	std::sort(pointer,pointer+n,cmp);

	for (i=0;i<n;i++) number[pointer[i]]=i;
//	for (i=0;i<n;i++) printf("%s\n", st[pointer[i]]);
	
	scanf("%d", &k);
	seq[0]=0;
	for (i=1;i<=k;i++)
	{
		scanf("%d", seq+i);
		seq[i]--;
	}
	
	memset(a,100,sizeof(a));
	
	for (i=0;i<n;i++) a[i][i]=0;
	for (i=0;i<n;i++)
	{
		a[i][(i-1+n)%n]=1;
		a[i][(i+1)%n]=1;
	}
	int j,t;
	int hod;
	bool ok;
	for (i=0;i<n;i++) 
		for (j=0;j<n;j++)
			if (a[pointer[i]][pointer[j]]>1)
			{
				if (pointer[i]<pointer[j])
				{
					ok=0;
					for (hod=0;(!ok) && (hod<len[pointer[j]]);hod++)
					{
						ok=1;
						t=j-1;
						while (ok && t>=0 && st[pointer[t]][hod]==st[pointer[j]][hod]) 
						{
							if (pointer[t]>=pointer[i] && pointer[t]<pointer[j]) ok=0;
							t--;
						}
											
						t=j+1;
						while (ok && t<n && st[pointer[t]][hod]==st[pointer[j]][hod]) 
						{
							if (pointer[t]>=pointer[i] && pointer[t]<pointer[j]) ok=0;
							t++;
						}

						if (ok) a[pointer[i]][pointer[j]]=hod+2;
					}
					
				} else
				{
					ok=0;
					for (hod=0;(!ok) && (hod<len[pointer[j]]);hod++)
					{
						ok=1;
						t=j;
						while (ok && t>=0 && st[pointer[t]][hod]==st[pointer[j]][hod]) 
						{
							if (pointer[t]>=pointer[i] || pointer[t]<pointer[j]) ok=0;
							t--;
						}
											
						t=j+1;
						while (ok && t<n && st[pointer[t]][hod]==st[pointer[j]][hod]) 
						{
							if (pointer[t]>=pointer[i] || pointer[t]<pointer[j]) ok=0;
							t++;
						}

						if (ok) a[pointer[i]][pointer[j]]=hod+2;
					}
				}
			}
	int u,l;

	for (i=0;i<k;i++)
	{
		memset(dist,100,sizeof(dist));
		memset(flag,0,sizeof(flag));
		flag[seq[i]]=1;
		dist[seq[i]]=0;
		heap.clear();
		for (j=0;j<n;j++) if ((a[seq[i]][j]<INF) && (!flag[j]))
		{
			qwe.first=a[seq[i]][j];
			qwe.second=j;
			heap.insert(qwe);
		}
		while (!flag[seq[i+1]])
		{
			l=heap.begin()->first;
			u=heap.begin()->second;
			heap.erase(heap.begin());
			while (flag[u])
			{
				l=heap.begin()->first;
				u=heap.begin()->second;
				heap.erase(heap.begin());
			}	
			flag[u]=1;
			dist[u]=l;
			for (j=0;j<n;j++) if ((a[u][j]<INF) && (!flag[j]))
			{
				qwe.first=a[u][j]+l;
				qwe.second=j;
				heap.insert(qwe);
			}
		}
		printf("%d\n", dist[seq[i+1]]);
		
		if (dist[seq[i+1]]>0)
		{
			VEC.clear();
			curr=seq[i+1];
			while (curr!=seq[i])
			{
				for (u=0;u<n;u++) if ((dist[u]<INF) && (a[u][curr]<INF) && (u!=curr) && (dist[u]+a[u][curr]==dist[curr])) break; 
				if (a[u][curr]==1)
				{
					if ((u+1)%n==curr) VEC.push_back('#'); else VEC.push_back('@');
				} else
				{
					for (j=a[u][curr]-2;j>=0;j--) VEC.push_back(st[curr][j]);
					VEC.push_back('!');
				}
				curr=u;
			}
			for (j=VEC.size()-1;j>=0;j--)
				if (VEC[j]=='!') printf("Alt\n"); else
				if (VEC[j]=='@') printf("up\n"); else
				if (VEC[j]=='#') printf("down\n"); else
				printf("%c\n", VEC[j]);
		}
	}
	return 0;
}

