{$A8,B-,C+,D+,E-,F-,G+,H+,I+,J-,K-,L+,M-,N+,O+,P+,Q-,R-,S-,T-,U-,V+,W-,X+,Y+,Z1}
{$Apptype console}
uses
  SysUtils;
type int = longint;
  restype =  record
    down,up:int;
    alt:string;  
  end;
  p2 = ^rec2;
  rec2 = record
    next,pred:p2;
    num:int;
  end;
  p = ^rec;
  rec=  record
    child,next,par:p;
    ch:char;
    nums:p2;
  end;
const
  inf = 'fur.in';
  out = 'fur.out';
  maxk = 10;
  maxn = 1000;
var n,k:int;
    root:p;
    tofind:array[0..maxk] of int;
    str:array[1..maxn] of string;
procedure create(var hp:p;child,next,par:p;ch:char;num:p2);
begin
  new(hp);
  hp^.child:=child;
  hp^.next:=next;
  hp^.par:=par;
  hp^.ch:=ch;
  hp^.nums:=num;
end;
procedure give_child(var res:p;ch:char;hp:p);
var hp2:p;
    found:boolean;
begin
  hp2:=hp^.child;
  found:=false;
  while (hp2<>nil) and not  found do begin
    if hp2^.ch= ch then found:=true else 
    hp2:=hp2^.next;
  end;
  res:=hp2;
end;
procedure add_num(hp:p;num:int);
var hp2,hp3,teklast:p2;
    f:boolean;
begin
  hp2:=hp^.nums;
  f:=true;
  teklast:=nil;
  new(hp3);
  hp3^.num:=num;
  while (hp2<>nil) and f do begin
    if hp2^.num>=num then begin
      f:=false;
      if hp2^.pred<>nil then hp2^.pred^.next:=hp3 else hp^.nums:=hp3;
      hp3^.pred:=hp2^.pred;
      hp3^.next:=hp2;
      hp2^.pred:=hp3;
    end else begin
      teklast:=hp2;
      hp2:=hp2^.next;
    end;
  end;
  if hp2 = nil then begin
    hp3^.next:=nil;
    if teklast = nil then begin
      hp3^.pred:=nil;
      hp^.nums:=hp3;
    end else begin
      hp3^.pred:=teklast;
      teklast^.next:=hp3;
    end;
  end;
end;
procedure build_tree(s:string;num:int);
var i:int;
    hp,hp2:p;
begin
  hp:=root;
  for i:=1 to length(s) do begin
    give_child(hp2,s[i],hp);
    if hp2= nil then begin
      create(hp2,nil,hp^.child,hp,s[i],nil);
      hp^.child:=hp2;
    end;
    hp:=hp2;
    add_num(hp,num);
  end;
end;
procedure init;
var
    i:int;
begin
  assign(input,inf);
  reset(input);
  assign(output,out);
  rewrite(output);
  create(root,nil,nil,nil,#255,nil);
  readln(n);
  for i:=1 to n do begin
    readln(str[i]);
    build_tree(Str[i],i);
  end;
  readln(k);
  for i:=1 to k do read(tofind[i]);
end;
function res_value(res:restype):int;
var h:int;
begin
  h:=0;
  h:=h+res.down+res.up;
  if res.alt<>'' then h:=h+length(res.alt)+1;
  res_value:=h;
end;
procedure push_alt(var pos:int;ch:char;var hp:p);
var hp2:p;
    hp3:p2;
    respos,reslen:int;
begin
  give_child(hp2,ch,hp);
  hp:=hp2;
  hp3:=hp2^.nums;
  reslen:=2*maxn;
  while hp3<>nil do begin
    if ((-pos+hp3^.num+n)mod n)<reslen then begin
      reslen:=(-pos+hp3^.num+n)mod n;
      respos:=hp3^.num;
    end;
    hp3:=hp3^.next;
  end;
  pos:=respos;
end;
procedure wr(res:restype);
var i:int;
begin
  writeln(res_value(res));
    for i:=1 to res.up do writeln('up');
    for i:=1 to res.down do writeln('down');
    if res.alt<>'' then begin
      writeln('Alt');
      for i:=1 to length(res.alt) do writeln(res.alt[i]);
    end;
end;
procedure go_to(pos1,pos2:int;var res:restype);
var i:int;
    tekres:restype;
    hp:p;
begin
  tekres.down:=0;
  tekres.alt:='';
  tekres.up:=100000;
  res.down:=0;
  res.up:=0;
  res.alt:='';
  hp:=root;
  for i:=1 to length(str[pos2]) do begin
    res.up:=(-pos2+ pos1 + n )mod n;
    if res_value(tekres)>res_value(res) then tekres:=res;
    res.up:=0;
    res.down:=(-pos1+ pos2 + n )mod n;
    if res_value(tekres)>res_value(res) then tekres:=res;
    res.down:=0;
    res.alt:=res.alt+str[pos2][i];
    push_alt(pos1,str[pos2][i],hp);
    if pos1 = pos2 then begin
      if res_value(tekres)>res_value(res) then tekres:=res;
      res:=tekres;
      exit;
    end;
  end;
  res:=tekres;
end;
procedure run;
var i,tekpos:int;
    res:restype;
begin
  tekpos:=1;
  for i:=1 to k do begin
    go_to(tekpos,tofind[i],res);
    wr(res);
    tekpos:=tofind[i];
  end;
end;
begin
  init;
  run;
end.
