{$O-,Q+,R+}
uses
  SysUtils;

Const
  MaxN = 1000;
  MaxLen = 2000;
  inf = MaxN + 1;

Var
  from, D: Array [0 .. MaxN] of Integer;
  r, w, ss: Array [1 .. MaxN, 1 .. MaxN] of Integer;
  way: Array [1 .. MaxN, 1 .. MaxN] of byte;
  tek, p, max, j, min, s, i, n, k: Integer;
  poz: Array [1 .. MaxN] of Integer;
  len: Array [1 .. MaxN] of Integer;
  f, a: Array [1 .. MaxN, 1 .. MaxLen] of char;
  mUp, mDown: Array [1 .. MaxN, 1 .. MaxN] of Integer;

{Function Max(a, b: Integer): integer;
Begin
  If a > b Then Max := a Else Max := b;
End;
   }
Function More(aa, bb: integer): Boolean;
Var
  i, a, b: Integer;
Begin
  a := poz[aa];
  b := poz[bb];
  If a = b Then Begin
    More := true;
    Exit;
  End;
  For i := 1 to len[a] do Begin
    If i > len[b] Then Begin
      More := true;
      Exit;
    End;
    If f[a, i] > f[b, i] Then Begin
      More := true;
      Exit;
    End;
    If f[a, i] < f[b, i] Then Begin
      More := false;
      Exit;
    End;
  End;
  More := false;
End;

Procedure Swap(a, b: Integer);
Var
  c: Integer;
Begin
  c := poz[a];
  poz[a] := poz[b];
  poz[b] := c;
End;

Function Partition(l, r: Integer): Integer;
Var
  x, i, j: Integer;
Begin
   i := l - 1;
   j := r + 1;
   x := l + random(r - l + 1);
   While true do Begin
     Repeat Inc(i);
       Until More(x, i);
     Repeat Dec(j);
       Until More(j, x);
     If i < j Then Begin
       Swap(i, j);
     End
     Else Begin
       Partition := j;
       Exit;
     End;
   End;
End;

Procedure QSort(l, r: Integer);
Var
  q: Integer;
Begin
  If l < r Then Begin
    q := Partition(l, r);
    Qsort(l, q);
    Qsort(q + 1, r);
  End;
End;

Procedure CountMoves;
Var
  cup, cdown, i, j: Integer;
Begin
  For i := 1 to n do Begin
    For j := 1 to n do Begin
      If j > i Then Begin
        cUp := i + n - j;
        cDown := j - i;
      End
      Else Begin
        cUp := i - j;
        cDown := n - i + j;
      End;
      mUp[i, j] := cUp;
      mDown[i, j] := cDown;
    End;
  End;
End;

Procedure Dejkstra(v: Integer);
Var
  min, i, j: Integer;
  use: Array [0 .. maxN] of Boolean;
Begin
  FillChar(use, sizeof(use), 0);
  For i := 1 to n do Begin
    d[i] := inf;
  End;
  d[0] := inf;
  d[v] := 0;
  For i := 1 to n do Begin
    min := 0;
    For j := 1 to n do Begin
      If (d[j] < d[min]) and (not use[j]) Then min := j;
    End;
    use[min] := true;
    For j := 1 to n do Begin
      If d[min] + w[min, j] < d[j] Then Begin
        d[j] := d[min] + w[min, j];
        from[j] := min;
      End;
    End;
  End;
End;

Procedure WriteWay(tek, p: Integer);
Var
  i, v, j, size: Integer;
  ans, op: Array [1 .. MaxN] of Integer;
Begin
  WriteLn(d[p]);
  v := p;
  size := 0;
  While v <> tek do Begin
    Inc(size);
    ans[size] := w[from[v], v];
    op[size] := way[from[v], v];
    v := from[v];
  End;
  v := p;
  For i := size downto 1 do Begin
    If op[i] = 1 Then
      For j := 1 to ans[size] do
        WriteLn('down');
    If op[i] = 2 Then
      For j := 1 to  ans[size] do
        WriteLn('up');
    If op[i] = 3 Then Begin
      WriteLn('Alt');
      For j := 1 to ans[i] - 1 do
        WriteLn(a[v, j]);
    End;
    v := from[v];
  End;
End;

Begin
Assign(input, 'fur.in');
Assign(output, 'fur.out');
Reset(input);
Rewrite(output);

  Randomize;

  ReadLn(n);
  For i := 1 to n do Begin
    poz[i] := i;
    len[i] := 0;
    While not eoln do Begin
      Inc(len[i]);
      Read(a[i, len[i]]);
      f[i, len[i]] := a[i, len[i]];
    End;
    ReadLn;
  End;

{  Read(k);}
  QSort(1, n);

  For i := 1 to n - 1 do Begin
    s := 0;
    For k := 1 to len[poz[i]] do
      If a[poz[i], k] = a[poz[i + 1], k] Then Inc(s)
      Else Break;
    ss[i, i + 1] := s;
    ss[i + 1, i] := s;
  End;

  For i := 1 to n do Begin
    min := ss[i, i + 1];
    For j := i + 1 to n - 1 do Begin
      If ss[j, j + 1] < min Then min := ss[j, j + 1];
      ss[i, j + 1] := min;
      ss[j + 1, i] := min;
      If min = 0 Then Break;
     End;
  End;

  For i := 1 to n do Begin
    For j := 1 to n do Begin
       mUp[poz[i], poz[j]] := ss[i, j];
    End;
  End;

  For i := 1 to n do Begin
    For j := 1 to n do Begin
      ss[i, j] := mUp[i, j];
    End;
  End;


  For i := n downto 1 do Begin
    max := 0;
    For j := i - 1 downto 1 do Begin
      If ss[j, i] > max Then Max := ss[j, i];
      r[j, i] := max + 1;
      If r[j, i] = len[i] + 1 Then r[j, i] := inf;
    End;
    For j := n downto i + 1 do Begin
      If ss[j, i] > max Then Max := ss[j, i];
      r[j, i] := max + 1;
      If r[j, i] = len[i] + 1 Then r[j, i] := inf;
    End;
  End;

  CountMoves;

  For i := 1 to n do Begin
    For j := 1 to n do Begin
      w[i, j] := mUp[i, j];
      way[i, j] := 2;
      If mUp[i, j] > mDown[i, j] Then Begin
        w[i, j] := mDown[i, j];
        way[i, j] := 1;
      End;
      If  r[i, j] < w[i, j] Then begin
        w[i, j] := r[i, j] + 1;
        way[i, j] := 3;
      End;
    End;
  End;

  Read(k);
  tek := 1;
  For i := 1 to k do Begin
    Read(p);
    Dejkstra(tek);
    WriteWay(tek, p);
    tek := p;
  End;

Close(input);
Close(output);
End.