Program yahoo;
                            {$O-}
{$APPTYPE CONSOLE}

uses
  SysUtils, Math;

const
  inf=1000000000;


type
  path=record
    len: integer;
    prev: integer;
  end;

var
  n: integer;
  i, j, l: integer;
  k: integer;
  d: array[0..1010, 0..1010] of path;
  arr: array[0..1010] of string;
  a: array[0..11] of integer;
  a1: integer;
  now, next: integer;
  nm: array[0..1010, 0..1010] of integer;
  t: array[0..4000010] of integer;
  nn: integer;

procedure maketree;
  begin
    nn:=1;
    while nn<2*n*n do nn:=2*nn;
    for i:=(nn div 2) to ((nn div 2)+n*n) do begin
      t[i]:=nm[((i-(nn div 2)) mod n) + 1][((i-(nn div 2)) div n) + 1];
    end;
    for i:=((nn div 2)+n*n+1) to nn-1 do t[i]:=-inf;
    for i:=(nn div 2)-1 downto 1 do t[i]:=max(t[2*i], t[2*i+1]);
  end;

function getmax_(l, r: integer): integer;
  begin
    if l>r then result:=-inf else
    if l=r then result:=t[l] else
    begin
      result:=t[l];
      result:=max(result, t[r]);
      result:=max(result, getmax_((l+1)div 2, (r-1)div 2));
    end;
  end;


function getmax(l, r: integer): integer;
  begin
    result:=getmax_((nn div 2)+l-1, (nn div 2)+r-1);
  end;





function countArrow(const a, b: integer): integer;
  begin
    result:=min(abs(a-b), (min(a, b))+(n-max(a, b)));
  end;


function getnum(const a, b: integer): integer;
  var
    i: integer;

  begin
    i:=0;
    while (i<length(arr[a]))and(i<length(arr[b]))and(arr[a][i+1]=arr[b][i+1]) do inc(i);
    result:=i;
  end;


function seeAlt(const a, b: integer): integer;
  var
    i, j: integer;
    len: integer;
    num: integer;

  begin
    num:=1;
    len:=countArrow(a, b);
    if len<3 then begin
      result:=inf;
      exit;
    end;

    if b>a then begin
      num:=getmax((b-1)*n+a, (b-1)*n+b-1);
    end else begin
      num:=max(getmax((b-1)*n+a, (b-1)*n+n), getmax((b-1)*n+1, (b-1)*n+b-1));
    end;

    result:=num+1+1;    // + Alt + first letter
  end;

procedure writeAlt(const a, b: integer);
  var
    i, j: integer;
    len: integer;
    num: integer;

  begin
    num:=1;
    len:=countArrow(a, b);

    if b>a then begin
      for i:=(a) to (b-1) do begin
        num:=max(num, getnum(i, b)+1);
      end;
    end else begin
      for i:=(a) to n do begin
        num:=max(num, getnum(i, b)+1);
      end;
      for i:=1 to (b-1) do begin
        num:=max(num, getnum(i, b)+1);
      end;
    end;
    writeln('Alt');
    for i:=1 to num do writeln(arr[b][i]);

  end;

procedure writeArrow(const a, b: integer);
  var
    i: integer;

  begin
    if abs(a-b)=min(abs(a-b), (min(a, b))+(n-max(a, b))) then begin
     if a<b then
      for i:=1 to (b-a) do writeln('down') else
      for i:=1 to (a-b) do writeln('up');
    end else begin
     if a<b then
      for i:=1 to (min(a, b))+(n-max(a, b)) do writeln('up') else
      for i:=1 to (min(a, b))+(n-max(a, b)) do writeln('down');
    end;
  end;



begin
  a[0]:=1;
  reset(input, 'fur.in');
  rewrite(output, 'fur.out');
  readln(n);
  for i:=1 to n do begin
    readln(arr[i]);
  end;
  readln(k);
  for i:=1 to k do begin
    read(a[i]);
  end;

  for i:=1 to n do begin
    for j:=1 to n do begin
      if i<>j then
      nm[i][j]:=getnum(i, j);
    end;
  end;

  maketree;


  for i:=1 to n do begin
    for j:=1 to n do begin
      d[i][j].len:=min(countArrow(i, j), seeAlt(i, j));
      d[i][j].prev:=j;
    end;
  end;



{  for i:=1 to n do begin
    for j:=1 to n do begin
      for l:=min(i, j) to max(i, j) do
        maxnm[i][j]:=max(maxnm[i][j], nm[l]);
    end;
  end;  }


  for l:=1 to n do begin
    for i:=0 to k do begin
      for j:=0 to k do begin
       if j<>i then begin

        if d[a[i]][a[j]].len=min(d[a[i]][a[j]].len, d[a[i]][l].len+d[l][a[j]].len) then continue;
        if (d[a[i]][l].len+d[l][a[j]].len)=min(d[a[i]][a[j]].len, d[a[i]][l].len+d[l][a[j]].len) then begin
          d[a[i]][a[j]].len:=d[a[i]][l].len+d[l][a[j]].len;
          d[a[i]][a[j]].prev:=d[a[i]][l].prev;
        end else begin
          d[a[i]][a[j]].len:=seeAlt(a[i], a[j]);
          d[a[i]][a[j]].prev:=a[j];
        end;
        
       end;
      end;
    end;
  end;

  a1:=1;
  for i:=1 to k do begin
    writeln(d[a1][a[i]].len);
    now:=a1;
    while now<>a[i] do begin
      next:=d[now][a[i]].prev;
      if SeeAlt(now, next)<countArrow(now, next) then
        writeAlt(now, next) else
        writeArrow(now, next);
      now:=next;
    end;
    a1:=a[i];
  end;


end.