{$APPTYPE CONSOLE}

uses
  SysUtils,StrUtils;

type
 ptree=^ttree;
 ttree=record
       next:array['a'..'z']of ptree;
       end;
       
const
 Inf=2000000000; 

var
 s:array[1..1000] of string;
 pos,k,i,n:longint;
 a,mas:array[1..1000]of longint;
 tab:array['a'..'z']of ptree;
 ch:char;

procedure count(i:longint);
var
 j:longint;
 p:ptree;
begin
 j:=1;
 p:=tab[s[i,j]];
 while (j<=length(s[i]))and(p<>nil) do
  begin
  inc(j);
  p:=p.next[s[i,j]];
  end;
 if j>length(s[i]) then
  mas[i]:=-1
 else
  mas[i]:=j+1;
end;

procedure add(i:longint);
var
 p:ptree;
 j:longint;
begin
 if tab[s[i,1]]=nil then
  begin
  tab[s[i,1]]:=new(ptree);
  end;
 p:=tab[s[i,1]];
 for j:=2 to length(s[i]) do
  begin
  if p.next[s[i,j]]=nil then
   begin
   p.next[s[i,j]]:=new(ptree);
   end;
  p:=p.next[s[i,j]]; 
  end;
end;

procedure Dijkstra(start,f:longint);
var
 ans,i,j,imin:longint;
 ff:string;
 q:array[1..1000]of boolean;
 st,pr,d:array[1..1000]of longint;
 
begin
 for i:=1 to n do
  begin
  if mas[i]=-1 then
   d[i]:=Inf
  else
   d[i]:=mas[i];
  q[i]:=false;
  pr[i]:=-1;
  end;
 d[start]:=0;
 for i:=1 to n do
  begin
  imin:=1;
  while q[imin] do
   inc(imin);
  for j:=imin to n do
   if (d[j]<d[imin]) and (not(q[j])) then
    imin:=j;
  q[imin]:=true;
  if d[(imin)mod n+1]>d[imin]+1 then
   begin
    d[(imin)mod n+1]:=d[imin]+1;
    pr[(imin)mod n+1]:=imin;
   end;
  if d[(imin+n-2) mod n+1]>d[imin]+1 then
   begin
    d[(imin+n-2)mod n+1]:=d[imin]+1;
    pr[(imin+n-2)mod n+1]:=imin;
   end;
  end;
 i:=f;
 j:=0;
 while i<>start do
  begin
  inc(j);
  st[j]:=i;
  if pr[i]=-1 then
   i:=start
  else
   i:=pr[i];
  end;
 ans:=0; 
 for i:=j downto 1 do
  begin
  if pr[st[i]]=-1 then
   begin    
   inc(ans,mas[st[i]]);
   end;
  if pr[st[i]]=(st[i]+n-2)mod n+1   then
   begin
   inc(ans);
   end;
  if pr[st[i]]=(st[i])mod n+1   then
   begin
   inc(ans);
   end;
  end;
 writeln(ans); 
 for i:=j downto 1 do
  begin
  if pr[st[i]]=-1 then
   begin
   writeln('Alt');
   for imin:=1 to mas[st[i]]-1 do
    begin
    ff:=s[st[i]];
    writeln(ff[imin]);
    end;
   end;
  if pr[st[i]]=(st[i]+n-2)mod n+1   then
   begin
   writeln('down');
   end;
  if pr[st[i]]=(st[i])mod n+1   then
   begin
   writeln('up');
   end;
  end;
end;

begin
 reset(input,'fur.in');
 rewrite(output,'fur.out');
 for ch:='a' to 'z' do
  tab[ch]:=nil;
 readln(n);
 for i:=1 to n do
  begin
  readln(s[i]);
  count(i);
  add(i);
  end;
 read(k);
 pos:=1;
 for i:=1 to k do
  begin
  read(a[i]);
  Dijkstra(pos,a[i]);
  pos:=a[i];
  end;
 close(input);
 close(output);
end.
 