{$APPTYPE CONSOLE}
uses math;

Const
  NMax = 1000;
  Inf = 10001;

Var
  a  : array [1..NMax,1..NMax] of Smallint;
  d  : array [1..NMax,1..NMax] of Smallint;
  h  : array [1..NMax,1..NMax] of Smallint;
  nw : array [1..NMax] of boolean;
  p  : array [1..NMax] of Word;
  dd : array [1..Nmax] of Smallint;
  st : array [0..Nmax] of Smallint;
  mas : array [1..NMax] of string;
  {
   -1 - up
   -2 - down
   else Alt..
  }

  n, i, j, x, k, s, f, v : Integer;

procedure Dijkstra(s, f : integer);
var
  dmin, u, v : Integer;

begin
  FillChar(nw, SizeOf(nw),True);
  FillChar(p, Sizeof(p),0);
  For i := 1 to N do
    dd[i] := a[s][i];
  nw[s] := False;
  dd[s] := 0;
  while TRue do
    begin
      dmin := Inf;
      For u := 1 to N do
        If nw[u] and (dd[u] < dmin) then
          begin
            dmin := dd[u];
            v := u;
          end;
      If v = f then
        break;
      nw[V] := False;
      For u := 1 to n do
        If dmin + a[v][u] < dd[u] then
          begin
            dd[u] := dmin + a[v][u];
            p[u] := v;
          end;
    end;
end;

begin
  Reset(Input,'fur.in');
  Rewrite(Output,'fur.out');
  FillChar(a, SizeOf(a),$7F);
  ReadLn(N);
  For i := 1 to N do
    Readln(mas[i]);
  For i := 1 to N-1 do
    For j := i+1 to N do
      begin
        x := 1;
        while (length(mas[i]) >= x) and (length(mas[j]) >= x) and (x < n div 2) and (mas[i][x] = mas[j][x]) do inc(x);
        d[i][j] := x;
        d[j][i] := x;
      end;
  a[1][2] := 1; h[1][2] := -2; a[1][n] := 1; h[1][n] := -1;
   For i := 1 to N-1 do
     begin
       a[i][i-1] := 1;
       h[i][i-1] := -1;
       a[i][i+1] := 1;
       h[i][i+1] := -2;
     end;
{  For i := 1 to n-1 do
    For j := i+1 to N do
      begin
        If j-i < (n div 2 + n mod 2) then
          begin
            a[i][j] := j-i;
            h[i][j] := -2;
            a[j][i] := j-i;
            h[j][i] := -1;
          end
         else
          begin
            a[i][j] := n-(j-i);
            h[i][j] := -1;
            a[j][i] := n-(j-i);
            h[j][i] := -2;
          end;
      end;  }
  For i := 1 to N-1 do
    For j := i+1 to N do
      begin
        For x := i+1 to j do
          begin
            d[i][j] := max(d[i][j],d[x][j]);
            If d[i][j] >= a[i][j] then
              break;
          end;
        If d[i][j]+1 < a[i][j] then
          begin
            a[i][j] := d[i][j]+1;
            h[i][j] := d[i][j]+1;
          end;
      end;
  For i := 2 to N do
    For j := 1 to i-1 do
      begin
        For x := i+1 to n do
          begin
            d[i][j] := max(d[i][j],d[x][j]);
            If d[i][j] >= a[i][j] then
              break;
          end;
        For x := 1 to j do
          begin
            d[i][j] := max(d[i][j],d[x][j]);
            If d[i][j] >= a[i][j] then
              break;
          end;
        If d[i][j]+1 < a[i][j] then
          begin
            a[i][j] := d[i][j]+1;
            h[i][j] := d[i][j]+1;
          end;
      end;
  Read(k);
  s := 1;
  For i := 1 to k do
    begin
      Read(f);
      If s = f then
        begin
          WriteLn(0);
          continue;
        end;
      Dijkstra(s, f);
      v := f;
      st[0] := 0;
      while v > 0 do
        begin
          inc(st[0]);
          st[st[0]] := v;
          v := p[v];
        end;
      WriteLn(dd[f]);
      v := s;
      For j := st[0] downto 1 do
        begin
          If h[v][st[j]] = -1 then
            WriteLn('up')
           else
            If h[v][st[j]] = -2 then
              WriteLn('down')
             else
              begin
                WriteLn('Alt');
                For x := 1 to h[v][st[j]]-1 do
                  writeln(mas[st[j]][x]);
              end;
          v := st[i];
        end;
      s := f;
    end;
end.
