{$D+,I+,L+,Q+,R+,S+,H-,O-}
{$APPTYPE CONSOLE}
  Const ProblemID='advent';
        File_In=ProblemID+'.in';
        File_Out=ProblemID+'.out';
        MaxN=2000;
        MaxH=10000;
        Infinity=MaxLongInt Div 4;
  Type Int=LongInt;
  Var N,Pit,SH : Int;
      H,L : Array [1..MaxN] Of Int;
      Ans : Array [0..MaxN,1..2] Of Int;

Procedure OpenFiles;
Begin
  Assign(Input,File_In);
  ReSet(Input);
  Assign(Output,File_Out);
  ReWrite(Output);
End;

Procedure Init;
  Var I : Int;
Begin
  Read(N);
  SH :=0;
  For I :=1 To N Do Begin
    Read(H[I],L[I]);
    Inc(SH,H[I]);
  End;
  Read(Pit);
End;

Procedure Swap(Var A,B : Int);
  Var C : Int;
Begin
  C :=A;
  A :=B;
  B :=C;
End;

Procedure Sort(Le,Ri : Int);
  Var I,J,X : Int;
Begin
  I :=Le;
  J :=Ri;
  X :=H[(I+J) Div 2]+L[(I+J) Div 2];
  Repeat
    While H[I]+L[I]<X Do Inc(I);
    While H[J]+L[J]>X Do Dec(J);
    If I<=J Then Begin
      Swap(H[I],H[J]);
      Swap(L[I],L[J]);
      Inc(I);
      Dec(J);
    End;
  Until I>J;
  If I<Ri Then Sort(I,Ri);
  If J>Le Then Sort(Le,J);
End;

Procedure Solve;
  Var I : Int;
Begin
  Sort(1,N);
  FillChar(Ans,SizeOf(Ans),0);
  For I :=1 To N Do
    If SH-Ans[I-1,2]+L[I]>=Pit Then Begin
      Ans[I,1] :=Ans[I-1,1]+1;
      Ans[I,2] :=Ans[I-1,2]+H[I];
    End
    Else Ans[I] :=Ans[I-1];
  WriteLn(Ans[N,1]);
End;

Procedure CloseFiles;
Begin
  Close(Input);
  Close(Output);
End;

Begin
  OpenFiles;
  Init;
  Solve;
  CloseFiles;
End.