{$D-,I-,L-,Q-,R-,S-,H-,O+}
{$APPTYPE CONSOLE}
  Const ProblemID='advent';
        File_In=ProblemID+'.in';
        File_Out=ProblemID+'.out';
//        MaxN=2000;
//        MaxH=10000;
	MaxN=200;
	MaxH=2000;
        Infinity=MaxLongInt Div 4;
  Type Int=LongInt;
  Var N,Pit,SH : Int;
      H,L : Array [1..MaxN] Of Int;
      Ans1,Ans2 : Array [0..MaxN,0..MaxH*2] Of Int;

Procedure OpenFiles;
Begin
  Assign(Input,File_In);
  ReSet(Input);
  Assign(Output,File_Out);
  ReWrite(Output);
End;

Procedure Init;
  Var I : Int;
Begin
  Read(N);
  SH :=0;
  For I :=1 To N Do Begin
    Read(H[I],L[I]);
    Inc(SH,H[I]);
  End;
  Read(Pit);
End;

Procedure Swap(Var A,B : Int);
  Var C : Int;
Begin
  C :=A;
  A :=B;
  B :=C;
End;

Function Max(Const A,B : Int) : Int;
Begin
  If A>B Then Max :=A
  Else Max :=B;
End;

Function Min(Const A,B : Int) : Int;
Begin
  If A<B Then Min :=A
  Else Min :=B;
End;

Procedure Sort(Le,Ri : Int);
  Var I,J,X : Int;
Begin
  I :=Le;
  J :=Ri;
  X :=H[(I+J) Div 2]+L[(I+J) Div 2];
  Repeat
    While H[I]+L[I]<X Do Inc(I);
    While H[J]+L[J]>X Do Dec(J);
    If I<=J Then Begin
      Swap(H[I],H[J]);
      Swap(L[I],L[J]);
      Inc(I);
      Dec(J);
    End;
  Until I>J;
  If I<Ri Then Sort(I,Ri);
  If J>Le Then Sort(Le,J);
End;

Procedure Solve;
  Var Ans,I,J,K : Int;
Begin
  Sort(1,N);
  For I :=0 To N Do
    For J :=0 To MaxH*2 Do
      Ans2[I,J] :=Infinity;
  Ans2[0,MaxH*2] :=0;
  For I :=1 To N Do Begin
    Ans1 :=Ans2;
    For J :=0 To I Do
      For K :=0 To MaxH*2 Do
        Ans2[J,K] :=Infinity;
    Ans2[0,MaxH*2] :=0;
    For J :=0 To I Do
      For K :=0 To MaxH*2 Do
        If Ans1[J,K]<>Infinity Then Begin
          Ans2[J,K] :=Min(Ans2[J,K],Ans1[J,K]);
          If SH-Ans1[J,K]+L[I]>=Pit Then
            Ans2[J+1,Min(K,L[I]+H[I])] :=Min(Ans2[J+1,Min(K,L[I]+H[I])],Ans1[J,K]+H[I]);
        End;
  End;
  Ans :=0;
  For I :=0 To N Do
    For J :=0 To MaxH*2 Do
      If (Ans2[I,J]<>Infinity){ And (Pit<=SH-Ans2[I,J]+J) }And (I>Ans) Then
        Ans :=I;
  WriteLn(Ans);
End;

Procedure CloseFiles;
Begin
  Close(Input);
  Close(Output);
End;

Begin
  OpenFiles;
  Init;
  Solve;
  CloseFiles;
End.