{$D+,I+,L+,Q+,R+,S+,H-,O+}
{$APPTYPE CONSOLE}
  Const ProblemID='advent';
        File_In=ProblemID+'.in';
        File_Out=ProblemID+'.out';
//        MaxN=2000;
//        MaxH=10000;
	MaxN=100;
	MaxH=1000;
        Infinity=30000;
  Type Int=LongInt;
  Var N,Pit,SH : Int;
      H,L,Num : Array [1..MaxN] Of Int;
      Ans : Array [0..MaxN,0..MaxN,0..MaxH] Of Word;

Procedure OpenFiles;
Begin
  Assign(Input,File_In);
  ReSet(Input);
  Assign(Output,File_Out);
  ReWrite(Output);
End;

Procedure Init;
  Var I : Int;
Begin
  Read(N);
  SH :=0;
  For I :=1 To N Do Begin
    Read(H[I],L[I]);
    Inc(SH,H[I]);
    Num[I] :=I;
  End;
  Read(Pit);
End;

Procedure Swap(Var A,B : Int);
  Var C : Int;
Begin
  C :=A;
  A :=B;
  B :=C;
End;

Function Max(Const A,B : Int) : Int;
Begin
  If A>B Then Max :=A
  Else Max :=B;
End;

Function Min(Const A,B : Int) : Int;
Begin
  If A<B Then Min :=A
  Else Min :=B;
End;

Procedure Sort(Le,Ri : Int);
  Var I,J,X : Int;
Begin
  I :=Le;
  J :=Ri;
  X :=H[(I+J) Div 2]+L[(I+J) Div 2];
  Repeat
    While H[I]+L[I]>X Do Inc(I);
    While H[J]+L[J]<X Do Dec(J);
    If I<=J Then Begin
      Swap(H[I],H[J]);
      Swap(L[I],L[J]);
      Swap(Num[I],Num[J]);
      Inc(I);
      Dec(J);
    End;
  Until I>J;
  If I<Ri Then Sort(I,Ri);
  If J>Le Then Sort(Le,J);
End;

Procedure Solve;
  Var I,J,K : Int;
      AnsCnt,IAns,JAns,Null,HelpH : Int;
      Ok : Boolean;
Begin
  Sort(1,N);
  FillChar(Ans,SizeOf(Ans),0);
  Null :=0;
  HelpH :=0;
  While (Null<N) And (L[Null+1]+H[Null+1]>=Pit) Do Begin
    Inc(HelpH,H[Null+1]);
    Dec(SH,H[Null+1]);
    Inc(Null);    
  End;
  Dec(Pit,HelpH);
  For I :=0 To N Do
    For J :=0 To MaxH Do
      Ans[Null,I,J] :=Infinity;
  Ans[Null,0,MaxH] :=0;
  For I :=Null+1 To N Do Begin
    For J :=0 To Min(I+1,N) Do
      For K :=0 To MaxH Do
        Ans[I,J,K] :=Infinity;
    Ans[I,0,MaxH] :=0;
    For J :=0 To I Do
      For K :=0 To MaxH Do
        If Ans[I-1,J,K]<>Infinity Then Begin
          Ans[I,J,K] :=Min(Ans[I,J,K],Ans[I-1,J,K]);
          Ans[I,J+1,Min(K,Ans[I,J,K]+H[I]+L[I])] :=Min(Ans[I,J+1,Min(K,Ans[I,J,K]+L[I]+H[I])],Ans[I-1,J,K]+H[I]);
        End;
  End;
  AnsCnt :=0;
  IAns :=0;
  For I :=0 To N Do
    For J :=0 To MaxH Do
      If (Ans[N,I,J]<>Infinity) And (Pit<=SH-Ans[N,I,J]+J) And (I>AnsCnt) Then Begin
        AnsCnt :=I;
        IAns :=I;
        JAns :=J;
      End;
  WriteLn(AnsCnt+Null);
  HelpH :=0;
  For I :=1 To Null Do Begin
    Write(Num[I],' ');//,HelpH+H[I]+L[I]);
    Inc(HelpH,H[I]);
  End;
  For I :=N DownTo Null+1 Do Begin
    If IAns=0 Then Break;
    Ok :=False;
    For J :=IAns-1 To IAns Do Begin
      For K :=0 To MaxH Do
        If Ans[I-1,J,K]<>Infinity Then Begin
          If (J=IAns) And (K=JAns) And (Ans[I,J,K]=Ans[I-1,J,K]) Then Begin
            IAns :=J;
            JAns :=K;
            Ok :=True;
            Break;
          End;
          If (IAns=J+1) And (JAns=Min(K,Ans[I,J,K]+H[I]+L[I])) And
             (Ans[I,IAns,JAns]=Ans[I-1,J,K]+H[I]) Then Begin
                Write(Num[I],' ');//,HelpH+H[I]+L[I]);
//                Inc(HelpH,H[I]);
//               Write(Num[I],' ');
               IAns :=J;
               JAns :=K;
               Ok :=True;
               Break
            End;
        End;
      If Ok Then Break;
    End;
  End;
End;

Procedure CloseFiles;
Begin
  Close(Input);
  Close(Output);
End;

Begin
  OpenFiles;
  Init;
  Solve;
  CloseFiles;
End.