{$I-,Q-,R-,S-,O+,H-}
{$I+,Q+,R+,S+,O-,H+}
{$apptype console}
{$M 1000000, 10000000}

uses Math;

const
  cInFile = 'advent.in';
  cOutFile = 'advent.out';

  inf = maxlongint shr 1;
  eps = 1e-8;

  nmax = 201;
  hmax = 501;

type
  int = longint;
  real = extended;

  chel = record
    r, l, rl, no : int;
  end;

var
  n : int;
  ans, ca : int;
  h : int;

  sh : int;
  mr : int;
  p : array [1..nmax] of chel;
  cs : array [0..nmax] of int;
  a : array [0..nmax, 0..nmax, 0..2 * hmax] of int;
  pb : array [0..nmax, 0..nmax, 0..2 * hmax] of boolean;
  pr : array [0..nmax, 0..nmax, 0..2 * hmax] of int;

  vv : array [1..nmax] of int;

  ck, cv, ps : int;
  u : array [1..nmax] of boolean;

procedure Solve;
var
  ii, i, j : int;
  x : chel;
  mxv : int;
begin
  for i:= 1 to n do p[i].rl:= p[i].r + p[i].l;
  for i:= 1 to n - 1 do
    for j:= i + 1 to n do
      if p[i].rl < p[j].rl then
      begin
        x:= p[i];
        p[i]:= p[j];
        p[j]:= x;
      end;
  mr:= p[1].r + p[1].l + 1;
  cs[0]:= 0;
  for i:= 1 to n do cs[i]:= cs[i - 1] + p[i].r;
  sh:= cs[n];
  for ii:= 0 to n do
    for i:= 0 to n do
      for j:= 0 to mr do a[ii, i, j]:= inf;
  a[0, 0, mr]:= 0;
  for ii:= 0 to n - 1 do
    for i:= 0 to ii do
      for j:= 0 to mr do
      begin
        if a[ii + 1, i, j] > a[ii, i, j] then
        begin
          a[ii + 1, i, j]:= a[ii, i, j];
          pb[ii + 1, i, j]:= false;
          pr[ii + 1, i, j]:= j;
        end;
        mxv:= min(j, a[ii, i, j] + p[ii + 1].rl);
        if a[ii + 1, i + 1, mxv] > a[ii, i, j] + p[ii + 1].r then
        begin
          a[ii + 1, i + 1, mxv]:= a[ii, i, j] + p[ii + 1].r;
          pb[ii + 1, i + 1, mxv]:= true;
          pr[ii + 1, i + 1, mxv]:= j;
        end;
      end;
  ans:= 0;
  ca:= 0;
  for i:= 0 to n do
    for j:= 0 to sh do
      if sh - a[n, i, j] + j >= h then
      begin
        ans:= i;
        ca:= j;
      end;
  writeln(ans);
{  ck:= ans;
  cv:= ca;
  ps:= n;
  ans:= 0;
  fillchar(u, sizeof(u), 0);
  while ck <> 0 do
  begin
    if pb[ps, ck, cv] then
    begin
      inc(ans);
      vv[ans]:= ps;
      u[ps]:= true;
      cv:= pr[ps, ck, cv];
      dec(ck);
    end;
    dec(ps);
  end;
  for i:= 1 to ans do write(p[vv[i]].no, ' ');
  writeln;
  for i:= 1 to n do
    if not u[i] then write(p[i].no, ' ');
  for i:= ans downto 1 do write(p[vv[i]].no, ' ');
  writeln;}
end;

procedure ReadData;
var
  i : int;
begin
  read(n);
  for i:= 1 to n do read(p[i].r, p[i].l);
  for i:= 1 to n do p[i].no:= i;
  read(h);
end;

var
  ii, tst : int;

begin
  assign(input,cinfile);
  assign(output,coutfile);
  reset(input);
  rewrite(output);
  ReadData;
  Solve;
{  read(tst);
  for ii:= 1 to tst do
  begin
    ReadData;
    Solve;
  end;}
  close(input);
  close(output);
end.
