{$apptype console}
{$q+,r+,n-,o+}

const cinfile = 'advent.in';
      coutfile = 'advent.out';
      
const nmax = 2011;
      inf = maxlongint shr 1;

type int = longint;

var h, l, a, b, way : array[0..nmax] of int;
    n, sum, c, height : int;

procedure init;
var i : int;
begin
    read(n);
    for i:=1 to n do read(h[i], l[i]);
    read(height);
end;

procedure qsort(p, q : int);
var pp, qq, x, t : int;
begin
    pp:=p - 1;
    qq:=q + 1;
    x:=h[b[(p + q) shr 1]] + l[b[(p + q) shr 1]];
    while true do begin
        repeat dec(qq); until (h[b[qq]] + l[b[qq]] <= x);
        repeat inc(pp); until (h[b[pp]] + l[b[pp]] >= x);
        if (pp >= qq) then break
        else begin
            t:=b[qq];
            b[qq]:=b[pp];
            b[pp]:=t;
        end;
    end;
    if (p < qq) then qsort(p, qq);
    if (qq + 1 < q) then qsort(qq + 1, q);
end;

procedure sort;
var i : int;
begin
    for i:=1 to n do b[i]:=i;
    if (n > 1) then qsort(1, n);
end;

procedure solve;
var i, j : int;
begin   
    for i:=1 to n do a[i]:=inf;
    sum:=0;
    for i:=1 to n do inc(sum, h[i]);
    a[0]:=0;
    way[0]:=0;
    c:=0;
    for j:=1 to n do begin  
        for i:=c downto 0 do
            if (sum - a[i] + l[b[j]] >= height) then begin
                if (a[i + 1] > a[i] + h[b[j]]) then begin
                    a[i + 1]:=a[i] + h[b[j]];
                    way[i + 1]:=b[j];
                end;
            end;
        if (a[c + 1] <> inf) then inc(c);
    end;
end;

procedure writeanswer;
    procedure go(x : int);
    begin
        if (x = 0) then exit;
        go(x - 1);
        write(way[x]);
        if (x < c) then write(' ');
    end;
begin
    writeln(c);
    go(c);
end;

begin
    assign(input, cinfile); reset(input);
    assign(output, coutfile); rewrite(output);
    init;
    sort;
    solve;
    writeanswer;
    close(input); close(output);
end.
