#include <stdio.h>
#include <stdlib.h>

#define SWAP(A, B, C) ((C) = (A), (A) = (B), (B) = (C))
#define MINI(A, B) ((A) < (B) ? (A) : (B))

#define MAX 2010

int N, MaxH, H[MAX], L[MAX], No[MAX];
int AN = 0, A[MAX], P[MAX];
int AN2 = 0, A2[MAX], P2[MAX];

void QSort( int l, int r )
{
  int i = l, j = r, x, tmp;

  if (l >= r)
    return;
  x = H[l + (rand() % (r - l + 1))];
  while (i <= j)
  {
    while (H[i] < x) i++;
    while (H[j] > x) j--;
    if (i <= j)
    {
      SWAP(H[i], H[j], tmp);
      SWAP(L[i], L[j], tmp);
      SWAP(No[i], No[j], tmp);
      i++, j--;
    }
  }
  QSort(l, j), QSort(i, r);
}

void Sort( void )
{
  int f = 1, i, tmp;

  while (f)
    for (f = 0, i = AN2 - 2; i >= 0; i--)
      if (MINI(P2[i] + L[A2[i]], P2[i + 1] + L[A2[i + 1]]) < 
          MINI(P2[i] + L[A2[i]] - H[A2[i + 1]], P2[i + 1] + L[A2[i + 1]] + H[A2[i]]))
      {
        f = 1;
        P2[i] -= H[A2[i + 1]], P2[i + 1] += H[A2[i]];
        SWAP(P2[i], P2[i + 1], tmp);
        SWAP(A2[i], A2[i + 1], tmp);
      }
}

int Check( void )
{
  int i;

  for (i = 0; i < AN2; i++)
    if (P2[i] + L[A2[i]] < MaxH)
      return 0;
  return 1;
}

int main( void )
{
  int i, j, sum = 0;

  srand(301703);
  freopen("advent.in", "rt", stdin);
  freopen("advent.out", "wt", stdout);
  scanf("%d", &N);
  for (i = 0; i < N; i++)
    scanf("%d%d", &H[i], &L[i]), No[i] = i + 1;
  scanf("%d", &MaxH);
  QSort(0, N - 1);
  for (i = 0; i < N; i++)
    sum += H[i];
  for (i = 0; i < N; i++)
  {
    for (AN2 = AN, j = 0; j < AN; j++)
      A2[j] = A[j], P2[j] = P[j];
    A2[AN2] = i, P2[AN2++] = sum;
    Sort();
    if (Check())
    {
      sum -= H[i];
      for (AN = AN2, j = 0; j < AN; j++)
        A[j] = A2[j], P[j] = P2[j];
    }
  }
  printf("%d\n", AN);
  for (i = 0; i < AN; i++)
    printf("%d ", No[A[i]]);
  return 0;
}
