program C;
{$apptype console}

const max_n = 2000;

var h, l, id, ans: array [1..max_n] of longint;
    num: array [1..max_n] of double;
    i, k, n, height, cnt: longint;

procedure swap(var a, b: double); overload;
var c: double;
begin
  c := a; a := b; b := c;
end;

procedure swap(var a, b: longint); overload;
var c: longint;
begin
  c := a; a := b; b := c;
end;

procedure QSort(l, r: longint);
var i, j: longint;
    x: double;
begin
  i := l; j := r;
  x := num[random(r-l)+l];
  repeat
    while num[i] < x do inc(i);
    while x < num[j] do dec(j);
    if i <= j then begin
      swap(num[i], num[j]);
      swap(h[i], h[j]);
      swap(C.l[i], C.l[j]);
      inc(i); dec(j);
    end;
  until i > j;
  if l < j then QSort(l, j);
  if i < r then QSort(i, r);
end;

begin
  reset(input, 'advent.in');
  rewrite(output, 'advent.out');

  read(n);
  k := 0;
  for i := 1 to n do begin
    read(h[i], l[i]);
    num[i] := h[i]/l[i];
    id[i] := i;
    inc(k, h[i]);
  end;
  inc(k, l[n]);
  read(height);

  if k < height then begin
    write('0');
    close(input); close(output);
    halt(0);
  end;

  QSort(1, n);

  cnt := 0;
  for i := n downto 1 do
    if k >= height then begin
      inc(cnt);
      ans[cnt] := id[i];
      dec(k, h[i] + l[i]);
      if i > 1 then inc(k, l[i-1]);
    end else break;

  writeln(cnt);
  for i := 1 to cnt do write(ans[i], ' ');

  close(input); close(output);
end.