program adv;

{$D-,L-}
{$R-,Q-}
{$S-,I-,C-}

uses
  SysUtils;

type
  TSchool = record
    h, l: LongInt;
  end;

var
  school: array [1..2000] of TSchool;
  vipr: array [1..2000] of Integer;
  res, n, s, h: Integer;

procedure ReadFromFile;
var
  f: Text;
  i: Integer;
begin
  Assign(f, 'advent.in');
  Reset(f);
  Readln(f, n);
  for i := 1 to n do
    Readln(f, school[i].h, school[i].l);
  Readln(f, h);
  Close(f);
end;

procedure WriteToFile;
var
  f: Text;
  i: Integer;
begin
  Assign(f, 'advent.out');
  Rewrite(f);
  Writeln(f, res);
  for i := 1 to res do
    Write(f, vipr[i], ' ');
  Close(f);
end;

function GetMin: Integer;
var
  i, min: Integer;
begin
  min := -1;
  i := 1;
  while (school[i].h = -1) or (school[i].l + s < h) do
  begin
    Inc(i);
    if i > n then
    begin
      WriteToFile;
      Halt(0)
    end
  end;
  Result := i;
  min := school[i].h;
  for i := i + 1 to n do
    if (school[i].h <> -1) and (school[i].l + s >= h)
    and (school[i].h < min) then
    begin
      Result := i;
      min := school[i].h;
    end
end;

procedure MakeVipr;
var
  i, m: Integer;
begin
  s := 0;
  for i := 1 to n do
    Inc(s, school[i].h);
  res := 0;
  while true do
  begin
    m := GetMin;
    Inc(res);
    vipr[res] := m;
    Dec(s, school[m].h);
    school[m].h := -1;
  end
end;

begin
  ReadFromFile;
  MakeVipr;
  WriteToFile;
end.
 