{$A8,B-,C+,D+,E-,F-,G+,H+,I+,J-,K-,L+,M-,N+,O+,P+,Q-,R-,S-,T-,U-,V+,W-,X+,Y+,Z1}
program z3_version_1;
{$APPTYPE CONSOLE}
uses
  SysUtils;
const MaxN = 3000;
var can: array[1..MaxN] of Boolean;
    rost, arms, num, a: array[1..MaxN] of LongInt;
    i, j, k, m, n, H, cur: Longint;

procedure init;
begin
    Assign(input, 'advent.in'); Reset(input);
    Assign(output, 'advent.out'); ReWrite(output);

        Read(N);
        for i := 1 to n do begin
           Read(rost[i], arms[i]);
           num[i] := i;
        end;

        Read(H);

    Close(input);
end;

procedure save;
begin
    Close(output);
end;

procedure QSort(L, R: LongInt);
var e, p: LongInt;
begin
    e := rost[(L+R) div 2];
    i := L; j := R;

    repeat
         while rost[i] > e do inc(i);
         while e > rost[j] do dec(j);
         if i <= j then begin
                            p := rost[i]; rost[i] := rost[j]; rost[j] := p;
                            p := arms[i]; arms[i] := arms[j]; arms[j] := p;
                            p := num[i]; num[i] := num[j]; num[j] := p;
                            inc(i); dec(j);
                        end;
    until i > j;

    if i < R then QSort(i, R);
    if L < j then QSort(L, j);
end;

procedure work;
begin
     FillChar(can, sizeof(can), false);
     
     QSort(1, N);

     a[1] := arms[1];
     for i := 2 to N do begin
         if arms[i] > arms[i-1] then a[i] := arms[i]
                                else a[i] := arms[i-1];
     end;

     j := 1;
     cur := rost[1];

     while cur < H do begin
         inc(j);
         cur := cur + rost[j];
     end;

     for i := j to N do
        can[ num[i] ] := true;

     M := j-1;
     cur := cur - rost[j];

     for i := M downto 1 do begin
         if (cur + arms[i] >= H)and(can[num[i]]=false) then
         begin
             can[num[i]] := true;
             cur := cur - rost[i];
         end;
     end;

    M := 0;
    for i := 1 to N do
      if can[i] then inc(M);

   writeln(M);
   for i := 1 to N do
     if can[i] then write(i,' ');
end;

begin
    init;
    work;
    save;
end.
