program advent;

{$APPTYPE CONSOLE}

uses
  SysUtils;

type
  pupil=record
          h,l,ost,i:longint;
        end;
const
  maxn=2006;
var
  a:array[1..maxn] of pupil;
  n,h:longint;
procedure init;
var
  i,sum:longint;
  f:boolean;
begin
  assign(input,'advent.in');
  reset(input);
  assign(output,'advent.out');
  rewrite(output);
  readln(n);
  sum:=0;
  for i:=1 to n do begin
    readln(a[i].h,a[i].l);
    a[i].i:=i;
    inc(sum,a[i].h);
  end;
  readln(h);
  for i:=1 to n do begin
    a[i].ost:=h-a[i].h-a[i].l;
    if a[i].ost<0 then a[i].ost:=0;
  end;
  f:=false;
  for i:=1 to n do
    f:=f or ((sum+a[i].l)>=h);
  if not f then writeln(0);
end;
procedure qsort(l,r:longint);
var
  i,j,x,lx,index:longint;
  k:pupil;
begin
  i:=l;
  j:=r;
  index:=random(r-l+1)+l;
  x:=a[index].ost;
  lx:=a[index].l;
  repeat
    while (a[i].ost<x) or (a[i].ost=x) and (a[i].l>lx) do inc(i);
    while (a[j].ost>x) or (a[j].ost=x) and (a[j].l<lx) do dec(j);
    if i<=j then begin
      k:=a[i];
      a[i]:=a[j];
      a[j]:=k;
      inc(i); dec(j);
    end;
  until i>j;
  if i<r then qsort(i,r);
  if l<j then qsort(l,j);
end;
procedure sdvig(l,r:longint);
var
  i:longint;
begin
  for i:=r downto l do
    a[i+1]:=a[i]; 
end;
procedure solve;
var
  x:pupil;
  i,kol,j:longint;
  sum:array[1..maxn] of longint;
begin
  qsort(1,n);
  sum[1]:=a[1].h;
  for i:=2 to n do
    sum[i]:=sum[i-1]+a[i].h;
  for i:=n downto 2 do begin
    if sum[i]+a[i].l<h then begin
      if a[i].l>a[i+1].l then begin
        x:=a[i+1];
        sdvig(1,i);
        a[1]:=x;
      end else begin
        x:=a[i];
        sdvig(1,i-1);
        a[1]:=x;
      end;
      sum[1]:=a[1].h;
      for j:=2 to n do
        sum[j]:=sum[j-1]+a[j].h;
    end;
  end;
  kol:=0;
  for i:=n downto 1 do
    if sum[i]+a[i].l>=h then inc(kol);
  writeln(kol);
  for i:=n downto n-kol+1 do
    write(a[i].i,' ');
end;
procedure done;
var
  i:longint;
begin
  writeln;
  writeln;
  for i:=1 to n do begin
    writeln(a[i].i,' ',a[i].h,' ',a[i].l,' ',a[i].ost);
  end;
end;
begin
  init;
  solve;
 // done;
end.
 