{    - }
program advent;
 const maxn=3000;
 type integer=longint;
 type chel=record
  h,w,n:longint;
 end;
 var a:array[1..maxn] of chel;
     n,h,m:longint;
     i,j,k:longint;
     ans:longint;
     u:array[1..maxn] of boolean;

 procedure sort(l,r: integer);
 var
  i,j: integer;
  x,y:chel;
 begin
  i:=l; j:=r; x:=a[(57*l+43*r) div 100];
  repeat
    while a[i].w<x.w do i:=i+1;
    while x.w<a[j].w do j:=j-1;
    if i<=j then
    begin
      y:=a[i]; a[i]:=a[j]; a[j]:=y;
      i:=i+1; j:=j-1;
    end;
  until i>j;
  if l<j then sort(l,j);
  if i<r then sort(i,r);
 end;

 function find(x:longint):longint;
  var up,down,t:longint;
 begin
  up:=n;
  down:=1;
  while (up-down>1) do begin
   t:=(up+down) div 2;
   if a[t].w<=x then down:=t else up:=t;
  end;
  if a[up].w<=x then result:=up
   else result:=down;
 end;

 function count(x:longint):longint;
  var t:longint;
 begin
  t:=find(h-a[x].h);
  if i<=t then dec(t);
  result:=t;
 end;

 procedure rm(x:longint);
  var i:longint;
 begin
  for i:=x to n-1 do
   a[i]:=a[i+1];
  dec(n);
 end;

begin
 assign(input,'advent.in');
 reset(input);
  read(n);
  m:=n;
  for i:=1 to n do
   read(a[i].h,a[i].w);
  read(h);
  for i:=1 to n do begin
   a[i].w:=h-a[i].w;
   a[i].n:=i;
  end;
 close(input);

 ans:=0;
 fillchar(u,sizeof(u),0);
 sort(1,n);
 h:=0;
 for i:=1 to n do
  h:=h+a[i].h;
 while true do begin
  j:=0;
  k:=-1;
  for i:=1 to n do
   if (a[i].w<=h)and(count(i)>k) then begin
    j:=i;
    k:=count(i);
   end;
  if j=0 then break;
  inc(ans);
  u[a[j].n]:=true;
  h:=h-a[j].h;
  rm(j);
 end;

 assign(output,'advent.out');
 rewrite(output);
  writeln(ans);
  for i:=1 to m do
   if u[i] then
    write(i,' ');
 close(output);
end.