#include <cstdio>
#include <cstdlib>
#include <vector>

using namespace std;

struct Student
{
	int L, H;
	int ind;
};

int cnt;
int H;
const int MAX = 2000;
Student ss[MAX];
vector<int> nums;

int cmp(const void *a, const void *b)
{
	Student* l = (Student *)a;
	Student* r = (Student *)b;
	if ( l->H < r->H )
		return -1;
	if ( l->H > r->H )
		return 1;
	if ( l->L < r->L )
		return -1;
	if ( l->L > r->L )
		return 1;
	return 0;
}

int can()
{
	for ( int i = 0; i < cnt; ++i )
	{
		int sum = 0;
		for ( int j = 0; j < cnt; ++j )
			if ( i != j )
				sum += ss[j].H;
		if ( sum >= H - (ss[i].H + ss[i].L) )
			return i;
	}
	return -1;
}

int main()
{
	freopen("advent.in", "r", stdin);
	freopen("advent.out", "w", stdout);
	scanf("%d", &cnt);
	for ( int i = 0; i < cnt; ++i )
	{
		scanf("%d %d", &ss[i].H, &ss[i].L);
		ss[i].ind = i + 1;
	}
	scanf("%d", &H);
	qsort(ss, cnt, sizeof(Student), cmp);
	int sNum;
	while ( (sNum = can()) != -1 )
	{
		nums.push_back(ss[sNum].ind);
		for ( int i = sNum; i < cnt - 1; ++i )
			ss[i] = ss[i+1];
		--cnt;
		qsort(ss, cnt, sizeof(Student), cmp);
	}
	printf("%d\n", nums.size());
	for ( int i = 0; i < nums.size(); ++i )
	{
		if ( i > 0 )
			putchar(' ');
		printf("%d", nums[i]);
	}
	return 0;
}