#include <cstdio>
#include <cstdlib>
#include <cstring>

struct pupil
{
	int h,l,hl;
	int n;
};

int
compare_hl (const void *v1, const void *v2)
{
	pupil *p1 = (pupil*)v1, *p2 = (pupil*)v2;
	if (p1->hl > p2->hl) return 1;
	if (p1->hl < p2->hl) return -1;
	return 0;
}

int
compare_h (const void *v1, const void *v2)
{
	pupil *p1 = (pupil*)v1, *p2 = (pupil*)v2;
	if (p1->h > p2->h) return 1;
	if (p1->h < p2->h) return -1;
	return 0;
}


int
main()
{
	pupil p[2010], p2[2010];
	int N,H,i,j;

	FILE *f = fopen ("advent.in", "r");
	fscanf (f, "%i", &N);
	for (i=0; i<N; i++)
	{
		fscanf (f, "%i%i", &(p[i].h), &(p[i].l));
		p[i].hl = p[i].h + p[i].l;
		p[i].n = i+1;
	}
	fscanf (f, "%i", &H);

	fclose (f);

	qsort (p, N, sizeof(pupil), compare_hl);
	
	//for (i=0; i<N; i++)
	//	printf ("%i %i %i %i\n", p[i].n, p[i].hl, p[i].h, p[i].l);

	int sum,k,r;
	int min=N,mini=0;

	for (i=p[0].hl; i<=p[N-1].hl; i++)
	{
		sum = 0;
		for (k=0; k<N; k++)
		{
			if (p[k].hl >= i) break;
			sum+=p[k].h;
		}
		//printf ("sum=%i k=%i i=%i\n", sum, k, i);

		r = H - sum - i;

	
		if (r<=0)
		{
			//printf ("%i %i\n", r, k);
			memcpy (p2, p, k*sizeof(pupil));
			qsort (p2, k, sizeof(pupil), compare_h);


			for (j=0;j<k;j++)
			{
				//printf ("sum is %i, l is %i, h is %i\n", sum, p2[j].l, p2[j].h);

				if (r + p2[j].h <= 0)
				{
					r += p2[j].h;
					k--;
				}
				else break;

			}
			//printf ("%i %i\n", i, k);
			if (k < min) {min = k; mini = i;}

		}
		

	}


	f = fopen ("advent.out", "w");
	fprintf (f, "%i\n", N-min);


	
	if (N-min>0)
	{
	sum = 0;
	for (k=0; k<N; k++)
	{
		if (p[k].hl >= mini) break;
		sum+=p[k].h;
	}

	for (j=k; j<N; j++)
		fprintf (f, "%i ", p[j].n);
	r = H - sum - i;

	for (j=0;j<k;j++)
	{
		if (r + p2[j].h <= 0)
		{
			r += p2[j].h;
			k--;
			fprintf (f, "%i ", p2[j].n);
		}
		else break;
	}
	
	}

	fclose (f);

	return 0;
}