program Zad3;

{$Apptype Console}

{$O+,R-.Q-,D-,I-}

uses
  SysUtils;

type
  Pupil=record
          h,l:LongInt;
          num:LongInt;
        end;

const
  MaxN=2000;

var
  N:LongInt;
  a,b:array[1..MaxN] of Pupil;
  h:LongInt;
  H1:Longint;
  ans:array[1..MaxN] of longint;

procedure Init;
begin
  Assign(input,'advent.in');
  Reset(input);
  Assign(output,'advent.out');
  Rewrite(output);
end;

procedure Final;
begin
  Close(input);
  Close(output);
end;

procedure InData;
var
  i:LongInt;
begin
  Read(N);
  for i:=1 to N do
  begin
    Read(a[i].h,a[i].l);
    a[i].num:=i;
  end;
  Read(h1);
end;

procedure Sort(l,r:Longint);
var
  i,j,m,p:Longint;
begin
  if l>=r then Exit;
  m:=(l+r) div 2;
  Sort(l,m);
  Sort(m+1,r);
  i:=l;
  j:=m+1;
  p:=0;
  while (i<=M)and(j<=r) do
  begin
    inc(p);
    if a[i].h>a[j].h then
    begin
      b[p]:=a[i];
      inc(i);
    end
    else
    begin
      b[p]:=a[j];
      inc(j);
    end;
  end;
  while (i<=M) do
  begin
    inc(p);
    b[p]:=a[i];
    inc(i);
  end;

  while (j<=r) do
  begin
    inc(p);
    b[p]:=a[j];
    inc(j);
  end;
  for i:=0 to p-1 do
    a[l+i]:=b[i+1];
end;



procedure OutAns(kol:Longint);
var
  i:Longint;
begin
  Writeln(kol);
 for i:=1 to kol do Write(ans[i],' ');
end;

procedure DownHeap(k,N:Longint);
var
  child:Longint;
  NewEl:Pupil;
begin
  NewEl:=a[k];
  while k<=N div 2 do
  begin
    child:=k*2;
    if (child<N)and(a[child+1].h<a[child].h) then inc(child);
    if NewEl.h<=a[child].h then Break;
    a[k]:=a[child];
    k:=child;
  end;
  a[k]:=NewEl;
end;


procedure Solve;
var
  i,N2,cnt:Longint;
  t:Pupil;
begin
  h:=0;
  for i:=1 to N do
    h:=h+a[i].h;
  fillchar(ans,SizeOf(ans),0);
  cnt:=0;
  N2:=0;
  for i:=N div 2 downto 1  do
     DownHeap(i,N);
  while N>=1 do
  begin
    t:=a[1];
    a[1]:=a[N];
    dec(N);
    DownHeap(1,N);
    if t.l+h>=h1 then
    begin
      inc(cnt);
      ans[cnt]:=t.num;
      h:=h-t.h;
    end
    else
    begin
      inc(N2);
      b[N2]:=t;
    end;
  end;
  
  OutAns(cnt);
end;

begin
  Init;
  InData;
  Solve;
  Final;
end.