program Zad3ver2;

{$Apptype Console}

{$O+,R-,Q-,D-,I-}

uses
  SysUtils;

type
  Pupil=record
          h,l:LongInt;
          num:LongInt;
        end;

const
  MaxN=2000+1;

var
  N:LongInt;
  a:array[1..MaxN] of Pupil;
  h:LongInt;
  H1:Longint;
  ans,ans2:array[1..MaxN] of longint;

procedure Init;
begin
  Assign(input,'advent.in');
  Reset(input);
  Assign(output,'advent.out');
  Rewrite(output);
end;

procedure Final;
begin
  Close(input);
  Close(output);
end;

procedure InData;
var
  i:LongInt;
begin
  Read(N);
  for i:=1 to N do
  begin
    Read(a[i].h,a[i].l);
    a[i].num:=i;
  end;
  Read(h1);
end;     


procedure OutAns(kol:Longint);
var
  i:Longint;
begin
  Writeln(kol);
 for i:=1 to kol do Write(ans[i],' ');
end;


procedure Swap(var a,b:pupil);
var
  t:Pupil;
begin
  t:=a; a:=b; b:=t;

end;

function CanSwap(u,v:LongInt; var num:Longint):boolean;
var
  i,num1,del1,del2,num2:LOngInt;
begin
  Result:=true;
  if v>N then v:=1;
  h:=0;
  num1:=N+1;
  del1:=0;
  for i:=1 to N do
  begin
    h:=h+a[i].h;
    if (num1=N+1 )and (h+a[i].l>=h1) then begin num1:=i; Break; end;
  end;
  if num1<>N+1 then del1:=h+a[num1].l-h1;
  swap(a[u],a[v]);
  h:=0;
  num2:=N+1;
  del2:=0;
  for i:=1 to Num do
  begin
    h:=h+a[i].h;
    if (num2=N+1) and( h+a[i].l>=h1) then begin num2:=i; end;
  end;
  if num2<>N+1 then del2:=h+a[num2].l-h1;
  num:=num2;
  if  not( (num2<num1)or((num2=num1)and(del2>del1))) then
  begin
    Result:=false;
    num:=num1;
    Swap(a[u],a[v]);
  end;
end;

procedure DownHeap(k,N:Longint);
var
  child:Longint;
  NewEl:Pupil;
begin
  NewEl:=a[k];
  while k<=N div 2 do
  begin
    child:=k*2;
    if (child<N)and(a[child+1].h<a[child].h) then inc(child);
    if NewEl.h<=a[child].h then Break;
    a[k]:=a[child];
    k:=child;
  end;
  a[k]:=NewEl;
end;

procedure Solve;
var
  i,cnt,num,fl,j,cnt2:Longint;
  t:pupil;
begin
  h:=0;
  num:=N+1;

  fillchar(ans,SizeOf(ans),0);
  fl:=1;
  while fl=1 do
  begin
    fl:=0;
    for i:=1 to N do
    for j:=i+1 to N do
    begin
      if CanSwap(i,j,num) then fl:=1;
    end;
  end;

  cnt:=0;
  for i:=num to N do
  begin
    inc(cnt);
    ans[cnt]:=a[i].num;
  end;

  h:=0;
  cnt2:=0;
  for i:=1 to N do
    h:=h+a[i].h;
  fillchar(ans,SizeOf(ans),0);
  cnt:=0;
  for i:=N div 2 downto 1  do
     DownHeap(i,N);
  while N>=1 do
  begin
    t:=a[1];
    a[1]:=a[N];
    dec(N);
    DownHeap(1,N);
    if t.l+h>=h1 then
    begin
      inc(cnt2);
      ans2[cnt2]:=t.num;
      h:=h-t.h;
    end;
  end;
  if cnt2>cnt then
  begin
   cnt:=cnt2;
   ans:=ans2;
  end;
  OutAns(cnt);
end;

begin
  Init;
  InData;
  Solve;
  Final;
end.