{$APPTYPE CONSOLE}
type integer = longint;
var n : integer;
	ind, h, l, hl : array[1..2000] of integer;	
	hh : integer;

procedure Qsort(be, en : integer);
var ll, r, x, t : integer;
begin
	ll := be;
	r := en;
	x := hl[ll + random(r - ll + 1)];
	while ll < r do begin
		while x > hl[ll] do inc(ll);
		while x < hl[r] do dec(r);
		if ll <= r then begin
			t := hl[ll];
			hl[ll] := hl[r];
			hl[r] := t;
      t := h[ll];
			h[ll] := h[r];
			h[r] := t;
      t := l[ll];
			l[ll] := l[r];
			l[r] := t;
			t := ind[ll];
			ind[ll] := ind[r];
			ind[r] := t;
			inc(ll);
			dec(r);
		end;
	end;
	if be < r then Qsort(be, r);
	if ll < en then Qsort(ll, en);
end;

procedure Load;
var i : integer;
begin
	read(n);
	for i := 1 to n do begin
		read(h[i], l[i]);
		hl[i] := h[i] + l[i];
		ind[i] := i;
	end;
	read(hh);
	Qsort(1, n);
end;

var pth, res : array[0..2000, 0..2000]of integer;
	cse : array[1..2001] of integer;

function Count(pos, num : integer) : integer;
var cr : integer;
begin
	if res[pos, num] <> -1 then begin
		Count := res[pos, num];
		exit;
	end;
	if pos = 0 then begin
		if num > 0 then res[pos, num] := -2
		else res[pos, num] := 0;
		Count := res[pos, num];
		exit;
	end;
	res[pos, num] := -2;
	{take last}
	cr := Count(pos - 1, num - 1);
	if cr <> -2 then begin
		if cr + l[pos] + cse[pos] >= hh then begin
			if res[pos, num] < cr then begin
				res[pos, num] := cr;
				pth[pos, num] := 1;
			end;
		end;
	end;
	{do not take last}
	cr := Count(pos - 1, num);
	if cr <> -2 then begin 
		if res[pos, num] < cr + h[pos] then begin
			res[pos, num] := cr + h[pos];
			pth[pos, num] := 2;
		end;	
	end;
	Count := res[pos, num];
end;

procedure RAns(pos, num : integer);
begin
	if pos = 0 then exit;
	if pth[pos, num] = 0 then exit;
	if pth[pos, num] = 1 then begin
		write(ind[pos], ' ');
		RAns(pos - 1, num - 1);
	end
	else begin
		Rans(pos - 1, num);
	end;
end;

procedure Solve;
var i : integer;
begin
	fillchar(res, sizeof(res), $FF);
	fillchar(cse, sizeof(cse), 0);
	fillchar(pth, sizeof(pth), 0);
	for i := n downto 1 do cse[i] := cse[i + 1] + h[i];
	for i := n downto 0 do begin
		if Count(n, i) <> - 2 then begin
			writeln(i);
			RAns(n, i);
      exit;
		end;
	end;
end;

begin
	assign(input, 'advent.in');
	assign(output, 'advent.out');
	reset(input);
	rewrite(output);
	Load;
	Solve;
	close(input);
	close(output);
end.