program Solution;

{$APPTYPE CONSOLE}

uses
  SysUtils;

const
 MAXN              =2000;  

var
 i, SavedAmount,
 N                 :Word;
 Saved,
 Num               :Array [1..MAXN] of Word;
 H, L              :Array [1..MAXN] of LongInt;
 Sum,
 Height            :Int64;

procedure QSort(Left, Right: SmallInt);
var
 T1, T2, X         :LongInt;
 T3                :Word;
 i, j              :SmallInt;
begin
  i:=Left; j:=Right; X:=H[(Left+Right) div 2];
  repeat
    while H[i]>X do i:=i+1;
    while X>H[j] do j:=j-1;
    if i<=j then
    begin
      T1:=H[i]; H[i]:=H[j]; H[j]:=T1;
      T2:=L[i]; L[i]:=L[j]; L[j]:=T2;
      T3:=Num[i]; Num[i]:=Num[j]; Num[j]:=T3;
      i:=i+1; j:=j-1;
    end;
  until i>j;
  if Left<j then QSort(Left,j);
  if i<Right then QSort(i,Right);
end;

begin
 Assign(InPut, 'advent.in');
 Reset(InPut);
 ReadLn(N);
 for i:=1 to N do
  begin
   ReadLn(H[i], L[i]);
   Num[i]:=i;
  end;
 ReadLn(Height);
 Close(InPut);
 QSort(1, N);
 for i:=1 to N do
  inc(Sum, H[i]);
 for i:=N downto 1 do
  if Sum+L[i]>=Height then
   begin
    dec(Sum, H[i]);
    dec(N);
    inc(SavedAmount);
    Saved[SavedAmount]:=Num[i];
   end
  else
   continue;
 Assign(OutPut, 'advent.out');
 ReWrite(OutPut);
 WriteLn(SavedAmount);
 if SavedAmount<>0 then
  for i:=1 to SavedAmount do
   Write(Saved[i],' ');
 Close(OutPut);
end.
