type
  int=longint;
  pupil=record
        a,b,i:int64; end;
const
  mx=1001;
  infile='advent.in';
 outfile='advent.out';

var
  p:array[1..mx]of pupil;
  ans:array[1..mx]of int;
  h:int64;
  res,n:int;

procedure swap(var x,y:pupil);
var
 z:pupil;
begin
 z:=x;
 x:=y;
 y:=z; 
end;

procedure sort(q,w:int);
var
 i,j:int;
begin
  for i:=q to w-1 do
   for j:=i+1 to w do
    if (p[i].a<p[j].a)or(p[i].a=p[j].a)and(p[i].b<p[j].b)then
     swap(p[i],p[j]);
end;

procedure init;
var
 i:int;
begin
  fillchar(p,sizeof(p),0);
  fillchar(ans,sizeof(ans),0);
  res:=0;
  read(n);
  for i:=1 to n do
   begin
     read(p[i].a,p[i].b);
     p[i].i:=i;
   end;
  read(h);
  res:=0;
  for i:=1 to n do
   if p[i].a+p[i].b>=h then
     begin
       inc(res);
       ans[res]:=i;
       swap(p[res],p[i]);
     end;
  sort(res+1,n);
end;

procedure run;
var
 i:int;
 all:int64;
begin
  all:=0;
  for i:=1 to n do
   all:=all+p[i].a;
  i:=n;
  while true do
   if (i<=n)and(all+p[i].b>=h) then
    begin
      inc(res);
      ans[res]:=p[i].i;
      all:=all-p[i].a;
      dec(i);
    end else
    break;
  if res>n then
   res:=n;
end;

procedure done;
var
 i:int;
begin
  writeln(res);
  for i:=1 to res do
   write(ans[i],' ');
end;

procedure opf;
begin
  assign(input,infile);
  reset(input);
  assign(output,outfile);
  rewrite(output);
end;

procedure clf;
begin
  close(input);
  close(output);
end;

begin
  opf;
  init;
  run;
  done;
  clf;
end.