{$A+,B+,D+,E+,F+,G+,I+,L+,N+,O+,P+,Q+,R+,S+,T+,V+,X+,Y+}
{$M 16384,0,655360}
type
  int = longint;
  real = extended;
const
  MaxN = 2001;
var
  h,l,kpd,pos,S : array[1..MaxN]of int;
  N,HH,HT,K : int;

procedure Init;
begin
  assign(input,'advent.in');
  assign(output,'advent.out');
  reset(input);
  rewrite(output);
end;

procedure Cloz;
begin
  close(input);
  close(output);
end;

procedure Load;
var
  i,j : int;
begin
  read(N);
  for i := 1 to N do begin
    read(h[i],l[i]);
    kpd[i] := h[i] + l[i];
    pos[i] := i;
  end;
  read(HH);
end;

procedure swap(i,j : int);
var
  t : int;
begin
  t := pos[i];
  pos[i] := pos[j];
  pos[j] := t;
end;

procedure QSort(Left,Right : int);
var
  i,j,x : int;
begin
  i := Left;
  j := Right;
  x := kpd[pos[random(j-i+1)+i]];
  while i <= j do begin
    while kpd[pos[i]] > x do inc(i);
    while kpd[pos[j]] < x do dec(j);
    if i <= j then begin
      swap(i,j);
      inc(i);
      dec(j);
    end;
  end;
  if i < Right then QSort(i,Right);
  if j > Left  then QSort(Left,j);
end;

procedure Slove;
var
  i,j : int;
begin
  QSort(1,N);
  HT := 0;
  k := 0;
  for i := 1 to N do begin
    if H[pos[i]] + L[pos[i]] + HT >= HH
      then begin
         inc(k);
        S[k] := pos[i];
      end;
    HT := HT + H[pos[i]];
  end;
end;

procedure Display;
var
  i : int;
begin
  writeln(k);
  for i := 1 to K do
    write(S[i],' ');
end;


BEGIN
  Init;
  Load;
  Slove;
  Display;
  Cloz;
END.