#include <fstream>
#include <deque>
using namespace std;

ifstream I("advent.in");
ofstream O("advent.out");

int N;
int h[2000],L[2000];
int H;
int alive[2000];

typedef int (*pfunc)(int);

int f1(int i){
	return -h[i];
}
int f2(int i){
	return L[i]-h[i];
}
int f3(int i){
	return L[i];
}
int f4(int i){
	return h[i];
}
int f5(int i){
	return L[i]+h[i];
}
int f6(int i){
	return L[i]-2*h[i];
}
int f7(int i){
	return 2*L[i]-h[i];
}
int f8(int i){
	return 3*L[i]-h[i];
}
int f9(int i){
	return 2*L[i]-5*h[i];
}
int f10(int i){
	return L[i]-h[i]+i;
}


void greedy(deque<int> &ans,pfunc f){
	while(1){
		int s=0;
		for(int i=0;i<N;i++) if(alive[i]) s+=h[i];
		deque<int> canout;
		for(int i=0;i<N;i++) if(alive[i] && s+L[i]>=H) canout.push_back(i);
		if(canout.empty()) break;
		int maxval=-10000000;
		int lucky=0;
		for(int i=0;i<canout.size();i++){
			int newval=f(canout[i]);
			if(newval>maxval) maxval=newval,lucky=canout[i];
		}
		alive[lucky]=0;
		ans.push_back(lucky);
	}
}

int main(){
	I>>N;
	for(int i=0;i<N;i++) I>>h[i]>>L[i],alive[i]=1;
	I>>H;
	deque<int> ans[10];
	greedy(ans[0],f1);
	greedy(ans[1],f2);
	greedy(ans[2],f3);
	greedy(ans[3],f4);
	greedy(ans[4],f5);
	greedy(ans[5],f6);
	greedy(ans[6],f7);
	greedy(ans[7],f8);
	greedy(ans[8],f9);
	greedy(ans[9],f10);
	int maxescaped=0;
	int coolans=0;
	for(int i=0;i<10;i++) if(ans[i].size()>maxescaped) maxescaped=ans[coolans=i].size();
	O<<ans[coolans].size()<<endl;
	for(int i=0;i<ans[coolans].size();i++) O<<ans[coolans][i]+1<<" ";
	return 0;
}