Program Adventure;
{$APPTYPE CONSOLE}
Const
 { InpPath='c:\work\advent_in.txt';
  OutPath='c:\work\advent_out.txt';}
  InpPath='advent.in';
  OutPath='advent.out';
Type
  Boy=Record
    h, l          :LongInt;
    num           :Word;
  End;
Var
  N, H, StSize    :Word;
  J               :Array[1..2000] Of Boy;
  St, MinSt       :Array[1..2000] Of Word;
  Used            :Array[1..2000] Of Boolean;
  MinStSize, MaxC :Word;
  Count           :Word;


Function Partition(Min, Max:Word):Word;
Var
  X, l, r, reg         :Word;
Begin
  l:=Min-1;
  r:=Max+1;
  X:=J[Min].h;
  While True Do
  Begin
    Repeat
      l:=l+1;
    Until J[l].h<=X;
    Repeat
      r:=r-1;
    Until J[r].h>=X;
    If l<r Then
    Begin
      reg:=J[l].h;J[l].h:=J[r].h;J[r].h:=reg;
      reg:=J[l].l;J[l].l:=J[r].l;J[r].l:=reg;
      reg:=J[l].num;J[l].num:=J[r].num;J[r].num:=reg;
    End Else
    Begin
      Partition:=r;
      Exit;
    End;
  End;
End;

Procedure QuickSort(Min, Max:Word);
Var
  q                   :Word;
Begin
  If Min<Max Then
  Begin
    q:=Partition(Min, Max);
    QuickSort(Min, q);
    QuickSort(q+1, Max);
  End;
End;

Procedure ReadData;
Var
  InpFile         :Text;
  i               :Word;
Begin
  FillChar(Used, SizeOf(Used), False);
  Assign(InpFile, InpPath);
  Reset(InpFile);
  ReadLn(InpFile, N);
  For i:=1 To N Do
  Begin
    ReadLn(InpFile, J[i].h, J[i].l);
    J[i].num:=i;
  End;
  ReadLn(InpFile, H);
  Close(InpFile);
End;

Procedure Rec(SumH, C:Word);
Var
  i                 :Word;
Begin
  If MaxC<C Then
  Begin
    MaxC:=C;
    For i:=1 To MaxC Do
      MinSt[i]:=St[i];
  End;

  For i:=1 To StSize Do
    If Not Used[i] Then
    Begin
      If(SumH+J[i].l)>=H Then
      Begin
        Used[i]:=True;
        St[C+1]:=i;
        Rec(SumH-J[i].h, C+1);
        Used[i]:=False;
     End;
    End;
End;

Procedure WriteData;
Var
  OutFile                  :Text;
  i                        :Word;
Begin
  Assign(OutFile, OutPath);
  ReWrite(OutFile);
  WriteLn(OutFile, Count);
  For i:=StSize+1 To N Do
    Write(OutFile, J[i].num, ' ');
  For i:=1 To MaxC Do
    Write(OutFile, J[MinSt[i]].num, ' ');
  Close(OutFile);
End;

Var
  i, SumH           :Word;
Begin
  ReadData;
  QuickSort(1, N);
  SumH:=0;
  StSize:=0;
  MaxC:=0;
  For i:=1 To N Do
    If(SumH+J[i].h)>=H Then
    Begin
      SumH:=SumH+J[i].h;
      StSize:=i;
      Break;
    End Else SumH:=SumH+J[i].h;
  If StSize=0 Then StSize:=N;
  Count:=N-StSize;
  Rec(SumH, 0);
  Count:=Count+MaxC;
  WriteData;
End.
