/**************************************/
/*   57, Moscow                       */
/**************************************/

#include <fstream>
using namespace std;

struct unit
{
   int ht;
   int al;
   int ex;
   unit* prev;
   unit* next; // extra info

   int index;
};
unit units [2006];
int num;
int hht;
int sum_ht = 0;
unit* saved = NULL;
int num_saved = 0;
unit* pot = NULL;

int main ()
{
   ifstream fin ( "advent.in" );
   ofstream fout ( "advent.out" );

   // input //////
   fin >> num;
   for ( int i = 0; i < num; i++ )
   {
      fin >> units [i].ht >> units [i].al;
      units [i].index = i + 1;
      sum_ht += units [i].ht;
   }
   fin >> hht; 
   for ( int i = 0; i < num; i++ )
   {
      units [i].ex = units [i].al - hht;
      if ( units [i].ex + sum_ht >= 0 )
      {
         if ( pot )
            pot->prev = & ( units [i] );
         units [i].next = pot;
         pot = & ( units [i] );
         pot->prev = NULL;
      }
   }
   ///////////////

   while ( pot )
   {
      unit* best_op = NULL;
      int best_val = -1000000;
      unit* cur = pot;
      while ( cur )
      {
         int cur_val = -cur->al - cur->ht;
         if ( cur_val > best_val )
         {
            best_op = cur;
            best_val = cur_val;
         }
         cur = cur->next;
      }

      if ( best_op->prev )
         best_op->prev->next = best_op->next;
      else
         pot = best_op->next;
      if ( best_op->next )
         best_op->next->prev = best_op->prev;

      best_op->next = saved;
      best_op->prev = NULL;
      saved = best_op;
      num_saved++;

      sum_ht -= best_op->ht;

      cur = pot;
      while ( cur )
      {
         if ( cur->ex + sum_ht < 0 )
         {
            if ( cur->prev )
               cur->prev->next = cur->next;
            else
               pot = cur->next;
            if ( cur->next )
               cur->next->prev = cur->prev;
         }
         cur = cur->next;
      }
   }

   fout << num_saved << endl;
   unit* cur = saved;
   while ( cur )
   {
      fout << cur->index << " ";
      cur = cur->next;
   }

   return 0;
}
