{$apptype console}

const
 maxn = 2010;

var
 N, i, ans, A: integer;
 B, P, H, L: array [0..maxn] of integer;

procedure qsort(l_, r: integer);
 var
  i, j, x, t: integer;
 begin
   if l_ >= r then
     exit;
   i := l_; j := r; x := H[l_ + random(r - l_ + 1)];
   while i <= j do begin
     while H[i] > x do inc(i);
     while H[j] < x do dec(j);
     if i <= j then begin
       t := H[i]; H[i] := H[j]; H[j] := t;
       t := L[i]; L[i] := L[j]; L[j] := t;
       t := P[i]; P[i] := P[j]; P[j] := t;
       inc(i); dec(j);
     end;
   end;
   qsort(l_, j);
   qsort(i, r);
 end;

begin
  reset(input, 'advent.in');
  rewrite(output, 'advent.out');

  read(N);
  for i := 0 to N - 1 do begin
    read(H[i], L[i]);
    P[i] := i + 1;
  end;
  read(A);

  qsort(0, n - 1);

  ans := 0;
  for i := 0 to n - 1 do begin
    if i > 0 then
      H[i] := H[i] + H[i - 1];
    if H[i] + L[i] >= A then begin
      B[ans] := P[i];
      inc(ans);
    end;
  end;
  
  writeln(ans);
  if ans > 0 then begin
    for i := 0 to ans - 1 do begin
      if i <> 0 then
        write(' ');
      write(B[i]);
    end;
    writeln;
  end;

  close(input);
  close(output);
end.
