#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#define MaxN 2010

int N, H, TH, h[MaxN], l[MaxN], p[MaxN], Is[MaxN], ans, AIs[MaxN], MaxH = 0;

void QSort(int L, int R)
{
  int i = L, j = R, x, t;
  if (L >= R)
    return;
  x = h[L + rand() % (R - L + 1)];
  while (i <= j)
  {
    while (h[i] < x) i++;
    while (h[j] > x) j--;
    if (i <= j)
    {
      t = h[i], h[i] = h[j], h[j] = t;
      t = l[i], l[i] = l[j], l[j] = t;
      t = p[i], p[i] = p[j], p[j] = t;
      i++, j--;
    }
  }
  QSort(L, j);
  QSort(i, R);
}

int main( void )
{
  int i, k;
  srand(31415927);
  freopen("advent.in", "rt", stdin);
  freopen("advent.out", "wt", stdout);

  scanf("%d", &N);
  for (i = 0; i < N; i++)
    scanf("%d%d", &h[i], &l[i]), p[i] = i + 1, MaxH = MaxH > h[i] ? MaxH : h[i];
  scanf("%d", &H);
  MaxH = MaxH + 1 > H ? MaxH + 1 : H;

  QSort(0, N - 1);

  ans = 0;
  for (TH = 0; TH < MaxH && ans < N; TH++)
  {
    int S = 0, mi, B = 0;
    memset(Is, 0, sizeof(Is));
    for (i = N - 1; i >= 0 && S < TH; i--)
      S += h[i];
    mi = i;
    if (S < TH)
      continue;
    TH = S;
    while (1)
    {
      int f = 0;
      for (i = 0; i <= mi; i++)
        if (!Is[i])
          if (h[i] + l[i] + S >= H)
            f = 1, B++, Is[i] = 1, S += h[i];
      if (!f)
        break;
    }
    if (B > ans)
    {
      ans = B;
      memcpy(AIs, Is, sizeof(Is));
    }
  }
  for (k = 0; k < N; k++)
  {
    int S = 0, mi, B = 0;
    S = TH = h[k];
    Is[k] = 1;
    mi = N - 1;
    while (1)
    {
      int f = 0;
      for (i = 0; i <= mi; i++)
        if (!Is[i])
          if (h[i] + l[i] + S >= H)
            f = 1, B++, Is[i] = 1, S += h[i];
      if (!f)
        break;
    }
    Is[mi] = 0;
    if (B > ans)
    {
      ans = B;
      memcpy(AIs, Is, sizeof(Is));
    }
  }
  printf("%d\n", ans);
  if (ans)
  {
    for (i = 0; i < N; i++)
      if (AIs[i])
        printf("%d ", p[i]);
    puts("");
  }

  return 0;
}
