{$APPTYPE CONSOLE}
Const
  NMax = 2000;
  c = 10;
  kmax = 2000;

Type
  TNode = record
    id : Word;
    l, h, s : Integer;
  end;

Var
  mas : array [1..NMax] of TNode;
  i, all, n, hh, k : integer;
  cur, best : array [0..NMax] of Integer;

procedure swap(var a, b: TNode);
Var
  t : TNode;

begin
  t := a;
  a := b;
  b := t;
end;

procedure QSort1(l, r : Smallint);
Var
  m : Integer;
  i, j : Integer;

begin
  i := l;
  j := r;
  m := mas[l+Random(r-l+1)].h;
  while i < j do
    begin
      while mas[i].h < m do inc(i);
      while mas[j].h > m do dec(j);
      If i <= j then
        begin
          swap(mas[i],mas[j]);
          inc(i);
          dec(j);
        end;
    end;
  If i < r then QSort1(i,r);
  If j > l then QSort1(l,j);
end;

procedure QSort2(l, r : Smallint);
Var
  m : Integer;
  i, j : Integer;

begin
  i := l;
  j := r;
  m := mas[l+Random(r-l+1)].l;
  while i < j do
    begin
      while mas[i].l < m do inc(i);
      while mas[j].l > m do dec(j);
      If i <= j then
        begin
          swap(mas[i],mas[j]);
          inc(i);
          dec(j);
        end;
    end;
  If i < r then QSort2(i,r);
  If j > l then QSort2(l,j);
end;

procedure QSort3(l, r : Smallint);
Var
  m : Integer;
  i, j : Integer;

begin
  i := l;
  j := r;
  m := mas[l+Random(r-l+1)].s;
  while i < j do
    begin
      while mas[i].s < m do inc(i);
      while mas[j].s > m do dec(j);
      If i <= j then
        begin
          swap(mas[i],mas[j]);
          inc(i);
          dec(j);
        end;
    end;
  If i < r then QSort3(i,r);
  If j > l then QSort3(l,j);
end;

procedure change;
var
  k, x, y : integer;

begin
  k := n*c;
  while k > 0 do
    begin
      dec(k);
      x := random(n)+1;
      y := random(n)+1;
      swap(mas[x],mas[y]);
    end;
end;

begin
  Reset(Input,'advent.in');
  Rewrite(Output,'advent.out');
  randomize;
  Read(N);
  hh := 0;
  For i := 1 to n do
    begin
      read(mas[i].h,mas[i].l);
      mas[i].s := mas[i].h + mas[i].l;
      mas[i].id := i;
      Inc(hh, mas[i].h);
    end;
  Read(all);
  cur[0] := 0;
  QSort1(1,n);
  For i := 1 to n do
    If hh + mas[i].l >= all then
      begin
        Inc(cur[0]);
        cur[cur[0]] := mas[i].id;
        Dec(hh, mas[i].h);
      end;
  best := cur;
  cur[0] := 0;
  QSort2(1,n);
  For i := 1 to n do
    If hh + mas[i].l >= all then
      begin
        Inc(cur[0]);
        cur[cur[0]] := mas[i].id;
        Dec(hh, mas[i].h);
      end;
  If cur[0] > best[0] then
    best := cur;
  cur[0] := 0;
  QSort3(1,n);
  For i := 1 to n do
    If hh + mas[i].l >= all then
      begin
        Inc(cur[0]);
        cur[cur[0]] := mas[i].id;
        Dec(hh, mas[i].h);
      end;
  If cur[0] > best[0] then
    best := cur;
  k := KMax;
  while k > 0 do
    begin
      cur[0] := 0;
      change;
      For i := 1 to n do
        If hh + mas[i].l >= all then
          begin
            Inc(cur[0]);
            cur[cur[0]] := mas[i].id;
            Dec(hh, mas[i].h);
          end;
      If cur[0] > best[0] then
        best := cur;
      dec(k);
    end;
  WriteLn(best[0]);
  For i := 1 to best[0] do
    Write(best[i],' ');
end.
