{$A+,B-,D-,E-,I-,L-,N-,Q-,R-,S-,X+,Y-}
{O-,R+,S+,Q+}
const
  infile='advent.in';
 outfile='advent.out';
 mx=2000+7;

var
 n,k,size:longint;
 all,height:longint;
 h,l,id,res:array[0..mx] of longint;

procedure init;
var
 i:longint;
begin
 read(n);
 all:=0;
 for i:=1 to n do
  begin
   read(h[i],l[i]);
   all:=all+h[i];
   id[i]:=i;
  end;
 read(height);
end;

procedure swap(var a,b:longint);
var
 c:longint;
begin
 c:=a;
 a:=b;
 b:=c;
end;

function more(i,j:longint):boolean;
begin
 result:=(h[i]>h[j]) or ((h[i]=h[j]) and (l[i]<l[j]));
end;

procedure heapify(k:longint);
var
 q:longint;
begin
 while true do
  begin
   q:=k;
   if 2*k<=size then
    if more(id[2*k],id[q]) then
     q:=2*k;
   if 2*k+1<=size then
    if more(id[2*k+1],id[q]) then
     q:=2*k+1;
   if k<>q then
    begin
     swap(id[q],id[k]);
     k:=q;
    end else
     break;
  end;
end;

procedure heapsort;
var
 i:longint;
begin
 for i:=n div 2 downto 1 do
  heapify(i);
 size:=n;
 while size>0 do
  begin
   swap(id[1],id[size]);
   dec(size);
   heapify(1);
  end;
end;

function sum(x,y:longint):longint;
var
 i:longint;
begin
 result:=0;
 for i:=x to y do
  result:=result+h[id[i]];
end;

procedure run;
var
 i,now:longint;
begin
 i:=n;
 while i>0 do
  begin
   if all+l[id[i]]<height then
    begin
     height:=height-h[id[i]];
     all:=all-h[id[i]];
     swap(id[i],id[n]);
     dec(n);
    end;
   dec(i);
  end;
 heapsort;
 k:=0;
 if n=0 then
  exit;
 if h[id[1]]>=height then
  begin
   k:=n;
   for i:=n downto 1 do
    res[n-i+1]:=id[i];
  end;
 now:=sum(1,n);
 for i:=1 to n  do
  begin
   if now+l[id[i]]>=height then
    begin
     inc(k);
     res[k]:=id[i];
     now:=now-h[id[i]];
    end;
  end;
end;

procedure done;
var
 i:longint;
begin
 writeln(k);
 for i:=1 to k do
  write(res[i],' ');
end;

begin
 assign(input,infile);
 reset(input);
 assign(output,outfile);
 rewrite(output);
 init;
 run;
 done;
 close(input);
 close(output);
end.