program Prokl;

{$APPTYPE CONSOLE}

uses
  SysUtils;

const
 InFile  = 'advent.in';
 OutFile = 'advent.out';
 MaxN = 2000;

type
 Zap = record
         h,l    : integer;
 end;

var
 a               : array [1..MaxN] of Zap;
 nom             : array [1..MaxN] of integer;
 n,Hei,kol       : integer;

procedure AA;
begin
 assign(input,InFile);
 reset(input);
 assign(output,OutFile);
 rewrite(output);
end;

procedure CA;
begin
 close(input);
 close(output);
end;

procedure Swap(var a,b: integer);
var
 t          : integer;
begin
 t := a;
 a := b;
 b := t;
end;

procedure QSort1(lo,hi: integer);
var
 x,i,j      : integer;
begin
 x := (a[lo].h+a[hi].h+a[(lo+hi)div 2].h) div 3;
 i := lo; j := hi;
 repeat
  while a[i].h>x do Inc(i);
  while x>a[j].h do Dec(j);
  if i<=j then begin
   Swap(a[i].h,a[j].h);
   Swap(a[i].l,a[j].l);
   Swap(nom[i],nom[j]);
   Inc(i); Dec(j);
  end;
 until i>j;
 if lo<j then QSort1(lo,j);
 if j+1<hi then QSort1(j+1,hi);
end;

procedure QSort2(lo,hi: integer);
var
 x,i,j      : integer;
begin
 x := (a[lo].l+a[hi].l+a[(lo+hi)div 2].l) div 3;
 i := lo; j := hi;
 repeat
  while a[i].l>x do Inc(i);
  while x>a[j].l do Dec(j);
  if i<=j then begin
   Swap(a[i].h,a[j].h);
   Swap(a[i].l,a[j].l);
   Swap(nom[i],nom[j]);
   Inc(i); Dec(j);
  end;
 until i>j;
 if lo<j then QSort2(lo,j);
 if j+1<hi then QSort2(j+1,hi);
end;

procedure ReadData;
var
 i    : integer;
begin
 read(n);
 for i:= 1 to n do
  read(a[i].h,a[i].l);
 read(Hei);
end;

procedure Init;
var
 i          : integer;
begin
 for i:= 1 to n do
  nom[i] := i;
end;

procedure Solve;
var
 i,bn,th    : integer;
begin
 QSort1(1,n);
 bn := 1;
 for i:= 2 to n do
  if a[i].h<>a[bn].h then begin
   if i-1<>bn then
    QSort2(bn,i-1);
   bn := i;
  end;
 if bn<>n then
  Qsort2(bn,n);
 th := 0;
 for i:= 1 to n do
  th := th+a[i].h;
 kol := n;
 while kol>0 do
  if th+a[nom[kol]].l>=Hei then begin
   th := th-a[kol].h;
   Dec(kol);
  end
  else begin
   Inc(kol);
   break;
  end;
 if kol=0 then kol:=1;
 writeln(n-kol+1);
 for i := kol to n do
  write(nom[i],' ');
end;

procedure WriteData;
begin
end;

begin
 AA;
 ReadData;
 Init;
 Solve;
 WriteData;
 CA;
end.
 