//  ,  
// , .
//  ,  
// , ...

//#include "stdafx.h"
#include <map>
#include <vector>
#include <cstdio>

using namespace std;

typedef struct {
	int out;
	int maxh, sum;
	bool from;
} tS;

vector< map<int, tS> > a;

int N;
vector<int> h, l;

void Out(int p, int ph)
{
	if (p==-1) return;
	if (a[p][ph].from)
	{
		Out(p-1, ph);
		printf("%d ", p+1);
	} else
	{
		Out(p-1, ph-h[p]);
	}
}

int main()
{
	freopen("advent.in", "r", stdin);
	freopen("advent.out", "w", stdout);
	scanf("%d", &N);
	h.resize(N);
	l.resize(N);
	a.resize(N);
	int i;
	map<int, tS>::iterator j;
	a[0][0].out = 1;
	a[0][0].maxh = 0;
	a[0][0].from = true;
	for (i = 0; i < N; i++)
	{
		scanf("%d%d", &h[i], &l[i]);
		a[0][h[i]].out = 0;
		a[0][h[i]].maxh = 0;
		a[0][h[i]].from = false;
		a[0][0].maxh = max(a[0][0].maxh, h[i]+l[i]);
		if (i==0) continue;
		for (j = a[i-1].begin(); j != a[i-1].end(); j++)
		{
			tS *it;
			it = &a[i][h[i]+j->first];
			if (it->out<j->second.out)
			{
				it->out=j->second.out;
				it->maxh=j->second.maxh;
				it->from = false;
			}
			else if (it->out==j->second.out)
			{
				if (it->maxh<j->second.maxh)
				{
					it->maxh=j->second.maxh;
					it->from = false;
				}
			}
			it = &a[i][j->first];
			if (it->out<j->second.out+1)
			{
				it->out=j->second.out+1;
				it->maxh=max(j->second.maxh, h[i]+l[i]);
				it->from = true;
			} else if (it->out==j->second.out+1)
			{
				if (it->maxh<max(j->second.maxh, h[i]+l[i]))
				{
					it->maxh=max(j->second.maxh, h[i]+l[i]);
					it->from = true;
				}
			}
		}
	}
	int H;
	scanf("%d", &H);
	int res = 0, curh=0;
	for (j = a[N-1].begin(); j!=a[N-1].end(); j++)
	{
		if (j->first+j->second.maxh>=H)
		{
			if (res < j->second.out)
			{
				res = j->second.out;
                curh = j->first;
			}
		}
	}
	printf("%d\n", res);
	if (res!=0) Out(N-1, curh);
	fclose(stdin);
	fclose(stdout);
    return 0;
}