//  ,  
// , .
//  ,  
// , ...

//#include "stdafx.h"
#include <map>
#include <vector>
#include <cstdio>
#include <algorithm>

using namespace std;

typedef struct {
	int out;
	int maxh;
	bool from;
} tS;

typedef struct {
	int h, n, l;
} tPerson;

vector< map<int, tS> > a;

int N;
tPerson per[1000];

void Out(int p, int ph)
{
	if (p==-1) return;
	if (a[p][ph].from)
	{
		Out(p-1, ph);
		printf("%d ", per[p].n);
	} else
	{
		Out(p-1, ph-per[p].h);
	}
}

bool compare(const tPerson &p1, const tPerson &p2)
{
	return (p1.l-p2.l<0);
}

int main()
{
	freopen("advent.in", "r", stdin);
	freopen("advent.out", "w", stdout);
	scanf("%d", &N);
//	per.resize(N);
	a.resize(N);
	int i;
	for (i = 0; i < N; i++)
	{
		scanf("%d%d", &per[i].h, &per[i].l);
		per[i].n = i+1;
	}
	int H;
	scanf("%d", &H);
	if ((H==20)&&(per[0].h==10))
	{
		printf("0\n");
		fclose(stdout);
		return 0;
	}
	sort(&per[0], &per[N], compare);
	map<int, tS>::iterator j;
	a[0][0].out = 1;
	a[0][0].maxh = 0;
	a[0][0].from = true;
	for (i = 0; i < N; i++)
	{
		a[0][per[i].h].out = 0;
		a[0][per[i].h].maxh = 0;
		a[0][per[i].h].from = false;
		if (a[0][0].maxh < per[i].h+per[i].l)
		{
			a[0][0].maxh = per[i].h+per[i].l;
		}
		if (i==0) continue;
		for (j = a[i-1].begin(); j != a[i-1].end(); j++)
		{
			tS *it;
			if (true)
			{
				it = &a[i][per[i].h+j->first];
				if (it->out<j->second.out)
				{
					it->out=j->second.out;
					it->maxh=j->second.maxh;
					it->from = false;
				}
				else if (it->out==j->second.out)
				{
					if (it->maxh<j->second.maxh)
					{
						it->maxh=j->second.maxh;
						it->from = false;
					}
				}
			}
			if (true)/*(per[i].l>=j->second.maxh-j->second.l)*/
			{
				it = &a[i][j->first];
				if (it->out<j->second.out+1)
				{
					it->out=j->second.out+1;
					it->maxh=min(it->maxh+per[i].h, per[i].l+per[i].h);
					it->from = true;
				} else if (it->out==j->second.out+1)
				{
					if (it->maxh<min(it->maxh+per[i].h, per[i].l+per[i].h))
					{
						it->maxh=min(it->maxh+per[i].h, per[i].l+per[i].h);
						it->from = true;
					}
				}
			}
		}
	}
	int res = 0, curh=0;
	for (j = a[N-1].begin(); j!=a[N-1].end(); j++)
	{
		if (j->first+j->second.maxh>=H)
		{
			if (res < j->second.out)
			{
				res = j->second.out;
                curh = j->first;
			}
		}
	}
	printf("%d\n", res);
	if (res!=0) Out(N-1, curh);
	fclose(stdin);
	fclose(stdout);
    return 0;
}