uses
    sysutils;

const
    max_n = 100000;
    max_m = 100000;
    max_t = 24 * 60 - 1;

type
    tarr = array [1..max_n] of longint;

var
    n, m: longint;
    c, b: array [1..max_n] of longint;
    acity, atime, dcity, dtime: tarr;
    ans: longint;

function d(c: char): longint;
begin
    d := ord(c) - ord('0');
end;

function readTime(): longint;
var
    d1, d2, d3, d4: char;
begin
    if seekeof then;

    read(d1, d2);
    read(d3);
    read(d3, d4);
    readTime := (d(d1) * 10 + d(d2)) * 60 + d(d3) * 10 + d(d4);
end;

var
    t: array [0..max_t] of longint;
    tcity, ttime: tarr;

procedure sort(var city, time: tarr);
var
    i: longint;
begin
    fillchar(t, sizeof(t), 0);
    for i := 1 to m do begin
        inc(t[time[i]]);
    end;
    for i := 1 to max_t do begin
        t[i] := t[i] + t[i - 1];
    end;
    tcity := city;
    ttime := time;
    for i := 1 to m do begin
        time[t[ttime[i]]] := ttime[i];
        city[t[ttime[i]]] := tcity[i];
        dec(t[ttime[i]]);
    end;
end;

var
    i: longint;
    pa, pd: longint;
    f: boolean;
begin
    assign(input, 'buses.in'); reset(input);
    assign(output, 'buses.out'); rewrite(output);

    read(n, m);

    ans := 0;
    for i := 1 to m do begin
        read(dcity[i]);
        dtime[i] := readTime();
        dec(b[dcity[i]]);

        read(acity[i]);
        atime[i] := readTime();
        inc(b[acity[i]]);

        if (dtime[i] > atime[i]) then begin
            inc(ans);
        end;
    end;

    sort(dcity, dtime);
    sort(acity, atime);

    for i := 1 to m do begin
        
    end;

    pa := 1;
    pd := 1;
    for i := 0 to max_t do begin
        while (pa <= m) and (atime[pa] = i) do begin
            inc(c[acity[pa]]);
            inc(pa);
        end;
        while (pd <= m) and (dtime[pd] = i) do begin
             if (c[dcity[pd]] > 0) then begin
                dec(c[dcity[pd]]);
            end else begin
                inc(ans);
            end;
            inc(pd);
        end;
    end;

    f := true;
    for i := 1 to n do begin
        f := f and (b[i] = 0);
    end;

    if f then begin
        writeln(ans);
    end else begin
        writeln(-1);
    end;

    close(input);
    close(output);
end.