#include <stdio.h>
#include <stdlib.h>

#define PROBLEM_NAME "buses"

#define MM 100000
#define NN 100000

typedef struct {
	int tp,tm,st;
} Event;

int cmp(const void *x, const void *y) {
	const Event *a, *b; 
	a=(const Event *)x;
	b=(const Event *)y;
	if(a->tm==b->tm) return (a->tp-b->tp);
	return a->tm-b->tm;
}

Event a[2*MM];
int g[NN];
int b[NN];
int n,m;
int ans = 0;

void ReadEvent(Event *p) {
	int x,hh,mm;
	scanf("%d%d:%d",&x,&hh,&mm);
	p->st=x-1; p->tm=hh*60+mm;
}

int main(void) {
	int i;
	freopen(PROBLEM_NAME ".in","rt",stdin);
	freopen(PROBLEM_NAME ".out","wt",stdout);

	scanf("%d%d",&n,&m);
	for(i=0;i<n;i++) {
		g[i]=0;
		b[i]=0;
	}
	for(i=0;i<m;i++) {
		ReadEvent(&a[2*i]);
		a[2*i].tp=0;
		ReadEvent(&a[2*i+1]);
		a[2*i].tp=1;
		if(a[2*i].tm>a[2*i+1].tm)
			ans++;
	}
	qsort(a,2*m,sizeof(a[0]),cmp);
	for(i=0;i<2*m;i++) {
		if(!a[i].tp) {
			g[a[i].st]++;
		} else {
			if(g[a[i].st]<=0) {
				ans++;
				b[a[i].st]++;
			} else {
				g[a[i].st]--;
			}
		}
	}
	for(i=0;i<n;i++) {
		if(g[i]!=b[i]) {
			printf("-1\n");
			return 0;
		}
	}
	printf("%d\n",ans);

	return 0;
}
