program P4;

uses
  SysUtils,Classes;

type
    TBusNCh=record
        DoInc:Boolean;
        Time:Integer;
    end;
    PBusNCh=^TBusNCh;

var
    F:Text;
    N,M,I:Integer;
    Towns:array[0..100000] of TList;
    BusN:Integer;
    Cross:Integer;

procedure AddRace(P1,T1,P2,T2:Integer);
var
    NewP:PBusNCh;
begin
    New(NewP);
    NewP^.DoInc:=False;
    NewP^.Time:=T1;
    Towns[P1].Add(NewP);
    New(NewP);
    NewP^.DoInc:=True;
    NewP^.Time:=T2;
    Towns[P2].Add(NewP);
    if T2<T1 then Inc(Cross);
end;

function ReadTime:Integer;
var
    Data:array[0..4] of Char;
    I:Integer;
    H,M:Integer;
begin
    Data[0]:=' ';
    while (Data[0]=' ') do
        Read(F,Data[0]);
    for I:=1 to 4 do
        Read(F,Data[I]);
    H:=StrToInt(Copy(Data,1,2));
    M:=StrToInt(Copy(Data,4,2));
    Result:=60*H+M;
end;

procedure ReadRace;
var
    P1,P2:Integer;
    Time1,Time2:Integer;
begin
    Read(F,P1);
    Time1:=ReadTime;
    Read(F,P2);
    Time2:=ReadTime;
    ReadLn(F);
    AddRace(P1,Time1,P2,Time2);
end;

function CompF(Item1,Item2:Pointer):Integer;
var
    PI1,PI2:PBusNCh;
    dT:Integer;
begin
    PI1:=Item1;
    PI2:=Item2;
    dT:=PI1^.Time-PI2^.Time;
    if dT<>0 then Result:=dT
    else if PI1^.DoInc xor PI2^.DoInc then
    begin
        if PI1.DoInc then Result:=1
        else Result:=-1;
    end
    else
        Result:=0;
end;

function TownCheck(TownN:Integer):Boolean;
var
    I,N:Integer;
begin
    N:=0;
    for I:=0 to Towns[TownN].Count-1 do
        if PBusNCh(Towns[TownN][I])^.DoInc then
            Inc(N)
        else
            Dec(N);
    Result:=N=0;
end;

function GetBusN(TownN:Integer):Integer;
var
    I,N,BN:Integer;
begin
    N:=0;
    BN:=0;
    for I:=0 to Towns[TownN].Count-1 do
        if PBusNCh(Towns[TownN][I])^.DoInc then
            Inc(N)
        else begin
            if N>0 then Dec(N)
            else Inc(BN);
        end;
    Result:=BN;
end;

label 1;
begin
    AssignFile(F,'Buses.in');
    Reset(F);
    ReadLn(F,N,M);
    for I:=1 to N do
    begin
        Towns[I]:=TList.Create;
        Towns[I].Capacity:=M*2 div N;
    end;
    Cross:=0;
    for I:=0 to M-1 do
        ReadRace;
    CloseFile(F);
    BusN:=-1;
    for I:=1 to N do
    begin
        Towns[I].Sort(CompF);
        if TownCheck(I)=False then goto 1;
    end;
    BusN:=Cross;
    for I:=1 to N do
        Inc(BusN,GetBusN(I));
1:  AssignFile(F,'Buses.out');
    Rewrite(F);
    WriteLn(F,BusN);
    CloseFile(F);
end.
