#include <stdio.h>

#define MAX 100001

struct W {
	int x;
	int h1;
	int m1;
	int y;
	int h2;
	int m2;
	int c;
};

struct V {
	int mq;
	int oq;
	int c;
};

struct Edge {
	int value;
	int w;
	int c;
	Edge *next;
};

W w[MAX];
V v[MAX];
Edge *e[MAX];
Edge *e2[MAX];
int n,m;

void Insert(int x, int v, int w) {
	if (e[x]==NULL) {e[x]=new Edge;e[x]->value=v;e[x]->next=NULL;e[x]->w=w;return;}
	Edge *temp;
	temp=new Edge;
	temp->next=e[x];
	temp->value=v;
	temp->w=w;
	e[x]->next=temp;
}

void Insert2(int x, int v, int w) {
	if (e2[x]==NULL) {e2[x]=new Edge;e2[x]->value=v;e2[x]->next=NULL;e2[x]->w=w;return;}
	Edge *temp;
	temp=new Edge;
	temp->next=e[x];
	temp->value=v;
	temp->w=w;
	e2[x]->next=temp;
}

int color;
int exit;

/*void dfs(int a, int h, int m) {
	if (v[a].mq>1) return;
	Edge *x;
	x=e[a];
	while (x!=NULL) {
		if (w[x->w].)
		w[x->w].c=color;
		dfs(x->value);
		x=x->next;
	}
}*/

int fun(int h1, int m1, int h2, int m2) {
	int t1,t2;
	t1=h1*60+m1;
	t2=h2*60+m2;
	if (t1>=t2) return 1;
	return 0;
}

void dfs(int a, int h, int m) {
	Edge *x;
	x=e[a];
	while (x!=NULL) {
		if (x->c>=1) {
			if (x->c==color) {
				if (fun(w[x->w].h1,w[x->w].m1,h-24,m)==0) {
					color++;
				}
			}
			x=x->next;
			continue;
		}
		if (fun(w[x->w].h1,w[x->w].m1,h,m)==1) {
			x->c=color;
			w[x->w].c=color;
			dfs(x->value,w[x->w].h2,w[x->w].m2);
		}
		x=x->next;
	}
}

int main() {
	int i;
	freopen("buses.in","r",stdin);
	freopen("buses.out","w",stdout);
	scanf("%d %d",&n,&m);
	for (i=1;i<=n;i++) e[i]=NULL;
	for (i=1;i<=m;i++) {
		scanf("%d %d:%d",&w[i].x,&w[i].h1,&w[i].m1);
		scanf("%d %d:%d",&w[i].y,&w[i].h2,&w[i].m2);
		if (w[i].h2<w[i].h1) w[i].h2+=24;
		w[i].c=0;
		v[w[i].y].mq++;
		v[w[i].x].oq++;
		Insert(w[i].x,w[i].y,i);
	}
	color=0;
	for (i=1;i<=n;i++) {
		if (v[i].mq==0) {printf("-1");return 0;}
		//if (v[i].mq==1) {color++;dfs(i);}
	}
	color=0;
	for (i=1;i<=m;i++) {
		if (w[i].c==0) {color++;dfs(w[i].x,0,0);}
	}
	printf("%d",color);
	return 0;
}