program P4_;

{$A8,B-,C+,D-,E-,F-,G+,H+,I-,J-,K-,L-,M-,N+,O+,P+,Q-,R-,S-,T-,U-,V+,W-,X+,Y+,Z1}
//{$A8,B-,C+,D+,E-,F-,G+,H+,I+,J-,K-,L+,M-,N+,O+,P+,Q+,R+,S-,T-,U-,V+,W-,X+,Y+,Z1}
{$MINSTACKSIZE $00004000}
{$MAXSTACKSIZE $00100000}
{$IMAGEBASE $00400000}
{$APPTYPE CONSOLE}

uses
  SysUtils;

type
  int = integer;

const
  DayM = 1440;

var n, m, bus: int;
    s, e, st, et, cnt: array[1..100000] of int;

procedure Outp(x: int);
begin
  Assign(output, 'buses.out');
  Rewrite(output);
  WriteLn(x);
  Close(output);
  halt;
end;

procedure sort_s(l,r: integer);
var
  i,j,x,y: integer;
begin
  i:=l; j:=r; x:=st[(l+r) DIV 2];
  repeat
    while st[i]<x do i:=i+1;
    while x<st[j] do j:=j-1;
    if i<=j then
    begin
      y:=st[i]; st[i]:=st[j]; st[j]:=y;
      y:=s[i]; s[i]:=s[j]; s[j]:=y;

      i:=i+1; j:=j-1;
    end;
  until i>j;
  if l<j then sort_s(l,j);
  if i<r then sort_s(i,r);
end;

procedure sort_e(l,r: integer);
var
  i,j,x,y: integer;
begin
  i:=l; j:=r; x:=et[(l+r) DIV 2];
  repeat
    while et[i]<x do i:=i+1;
    while x<et[j] do j:=j-1;
    if i<=j then
    begin
      y:=et[i]; et[i]:=et[j]; et[j]:=y;
      y:=e[i]; e[i]:=e[j]; e[j]:=y;

      i:=i+1; j:=j-1;
    end;
  until i>j;
  if l<j then sort_e(l,j);
  if i<r then sort_e(i,r);
end;

var i, sp, ep, add: int;
    c: char;

begin
  Assign(input, 'buses.in');
  Reset(input);
  ReadLn(n, m);
  for i:=1 to m do
  begin
    Read(s[i]);
    Inc(cnt[s[i]]);
    
    Read(c, c);
    st[i]:=(ord(c)-ord('0'))*10;
    Read(c);
    st[i]:=(st[i]+(ord(c)-ord('0')))*60;
    Read(c, c);
    st[i]:=st[i]+(ord(c)-ord('0'))*10;
    Read(c);
    st[i]:=st[i]+(ord(c)-ord('0'));
    
    Read(e[i]);
    Dec(cnt[e[i]]);

    Read(c, c);
    et[i]:=(ord(c)-ord('0'))*10;
    Read(c);
    et[i]:=(et[i]+(ord(c)-ord('0')))*60;
    Read(c, c);
    et[i]:=et[i]+(ord(c)-ord('0'))*10;
    Read(c);
    et[i]:=et[i]+(ord(c)-ord('0'));

    if et[i]<st[i] then Inc(et[i], DayM);
  end;
  Close(input);
  st[m+1]:=999999999;
  et[m+1]:=999999999;

  for i:=1 to n do
    if cnt[i]<>0 then Outp(-1);

  sort_s(1, m);
  sort_e(1, m);

  sp:=1;
  ep:=1;
  bus:=0;
  add:=0;
  while (sp<=m) or (ep<=m) do
    if et[ep]<=st[sp] then
    begin
      if et[ep]>DayM then break;
      Inc(cnt[e[ep]]);
      Inc(ep);
    end
    else
    begin
      if cnt[s[sp]]=0 then
        Inc(bus)
      else
        Dec(cnt[s[sp]]);
      Inc(sp);
    end;
  sp:=1;
  if ep>m then
  begin
    ep:=1;
    add:=DayM;
  end;
  while sp<=m do
    if (et[ep]+add)<=(st[sp]+DayM) then
    begin
      Inc(cnt[e[ep]]);
      Inc(ep);
    if ep>m then
    begin
      ep:=1;
      add:=DayM;
    end;
    end
    else
    begin
      if cnt[s[sp]]=0 then
        Inc(bus)
      else
        Dec(cnt[s[sp]]);
      Inc(sp);
    end;

  Outp(bus);
end.
 