program buses;

const MaxN=100000;

var inp,out:text;
    ar:array[1..MaxN] of record p1,h1,p2,h2:longint; end;
    n,m:longint;
    ardb,are:array[1..Maxn] of longint;
    arb:array[1..maxn] of boolean;

 procedure input;
 var i,j,k,l,d:integer;
     s:string[2];
     c:string[1];
 begin
  assign(inp,'buses.in');
  reset(inp);
  readln(inp,n,m);
  for i:=1 to m do
   begin
    read(inp,ar[i].p1);
    read(inp,c,s);
    val(s,j,l);
    read(inp,c,s);
    val(s,k,l);
    ar[i].h1:=j*60+k;
    read(inp,ar[i].p2);
    read(inp,c,s);
    val(s,j,l);
    readln(inp,c,s);
    val(s,k,l);
    ar[i].h2:=j*60+k;
   end;
 end;

 procedure output;
 begin
  assign(out,'buses.out');
  rewrite(out);
 end;

 procedure sort;
 var i,j,k:integer;
 begin
  for i:=1 to m-1 do
   for j:=i+1 to m do
    if ar[i].h1>ar[j].h1 then
     begin
      k:=ar[i].h1;ar[i].h1:=ar[j].h1;ar[j].h1:=k;
      k:=ar[i].h2;ar[i].h2:=ar[j].h2;ar[j].h2:=k;
      k:=ar[i].p1;ar[i].p1:=ar[j].p1;ar[j].p1:=k;
      k:=ar[i].p2;ar[i].p2:=ar[j].p2;ar[j].p2:=k;
     end;
 end;

 procedure Solve;
 var z,i,j,k,l,p:longint;
 begin
  sort;
  fillchar(ardb,sizeof(ardb),0);
  fillchar(are,sizeof(are),0);
  fillchar(arb,sizeof(arb),true);
  z:=0;
  for i:=1 to m do
   begin
    k:=ar[i].h1;
    p:=ar[i].p1;
    for j:=1 to i-1 do
     if arb[j] then
      if ar[j].h2<=k then
       begin
        inc(are[ar[j].p2]);
        arb[j]:=false;
       end;
    for j:=i+1 to m do
     if arb[j] then
      if ar[j].h2<=k then
       begin
        inc(z);
        inc(are[ar[j].p2]);
        arb[j]:=false;
       end;

    if are[p]>0 then
     begin
      dec(are[p]);
     end
    else
     begin
      inc(z);
      inc(ardb[ar[i].p1]);
     end;
   end;
  for i:=1 to m do
   if arb[i] then
    begin
     inc(are[ar[i].p2]);
    end;

  i:=1;
  while (i<=n) and (are[i]=ardb[i]) do inc(i);
  if i=n+1 then writeln(out,z) else writeln(out,'-1');
 end;

begin
 input;
 output;
 solve;
 close(inp);
 close(out);
end.
