#include <stdio.h>
#include <vector>
#include <memory.h>
#include <algorithm>

using namespace std;

#define NMAX 110000

typedef struct {int from, time1, to, time2;} rebro;
typedef struct {int p; bool flag; } botva;

typedef vector<botva> VEC;
typedef VEC::iterator V_ITER;

int n,m;
int u,v,h1,m1,h2,m2;

rebro reb[NMAX];

int degree[NMAX];
VEC sp[NMAX];
botva curr;
int kol[NMAX];
int late[NMAX];
int time[NMAX];
int bad;
int sutki;

bool cmp(botva a, botva b)
{
	return (a.p<b.p);
}

void DFS(int start)
{
	if (kol[start]==0) return;
	int i;
	while (kol[start]>0)
	{
		for (i=0;i<sp[i].size();i++)
		if (sp[start][i].flag && time[start]<=reb[sp[start][i].p].time1)
			{
				sp[start][i].flag=0;
				kol[start]--;
				if (reb[sp[start][i].p].time1>reb[sp[start][i].p].time2) sutki++;
//				if (bad<sutki) bad=sutki;
				time[reb[sp[start][i].p].to]=reb[sp[start][i].p].time2;
				DFS(reb[sp[start][i].p].to);
				i=-1;
			}
			if (kol[start]>0)
			{
				time[start]=-1;
				late[start]++;
				if (bad<late[start]) bad=late[start];
				sutki++;
			}
	}
	
	return;
}


int main()
{
	freopen("buses.in","r",stdin);
	freopen("buses.out","w", stdout);
	scanf("%d%d\n", &n, &m);
	memset(degree,0,sizeof(degree));
	memset(kol,0,sizeof(kol));
	int i;
/*	for (i=0;i<NMAX;i++) 
	{
		sp[i].clear();
		flag[i].clear();
	}*/
	for (i=0;i<m;i++)
	{
		scanf("%d %d:%d %d %d:%d\n", &u, &h1, &m1, &v, &h2, &m2);
		u--;
		reb[i].from=u;
		reb[i].time1=h1*60+m1;
		degree[u]++;
		kol[u]++;
		curr.flag=1;
		curr.p=i;
		sp[u].push_back(curr);
		
		v--;
		reb[i].to=v;
		reb[i].time2=h2*60+m2;
		degree[v]--;
	}

	for (i=0;i<n;i++) if (degree[i]!=0) 
	{
		printf("-1");
		return 0;
		sort(&sp[i][0],(&sp[i][0])+sp[i].size(),cmp);
	}
	int ans=0;
	for (i=0;i<n;i++)
	if (kol[i]>0)
		{
			memset(late,0,NMAX*sizeof(int));
			memset(time,255,NMAX*sizeof(int));
			bad=0;
			sutki=0;
			DFS(i);
			if (time[i]>reb[sp[i][0].p].time1) late[i]++;
			if (bad<late[i]) bad=late[i];
			ans+=bad+sutki;
		}
	printf("%d", ans);

	return 0;
}