program buses;
uses
    sysutils;
const
    maxN=2500;
    in_file='buses.in';
    out_file='buses.out';
type
    TRasp=array[0..maxN]of integer;

var
    can:array[1..maxN,1..maxN]of boolean;
    fc,tc:array[1..maxN]of TRasp;
    i,j,k,n,m,time,x,y:integer;
    t:string[5];
    ch:char;
    count:array[1..maxN]of integer;
    mark:array[1..maxN]of boolean;
    answer,min:integer;
    OK:boolean;
    c:integer;
procedure sort(var A:TRasp;const l,r:integer);
var x,y,i,j:integer;
begin
   i:=l; j:=r; x:=A[(i+j)div 2];
   repeat
      while A[i]>x do inc(i);
      while A[j]<x do dec(j);
      if i<=j then
      begin
         y:=A[i]; A[i]:=A[j]; A[j]:=y;
         inc(i); dec(j);
      end;
   until i>j;
   if i<r then sort(A,i,r);
   if j>l then sort(A,l,j);
end;
var b:boolean;
procedure find(const x:integer);
var i:integer;
begin
   for i:=1 to n do if (not mark[i])and(can[x,i]) then
   begin
      answer:=answer+count[i];
      if count[i]>0 then inc(c);
      mark[i]:=true;
      find(i);
   end;
end;

begin
   fillchar(can,sizeof(can),false);
  // fillchar(fc[0],sizeof(fc[0]),0);
  // fillchar(tc[0],sizeof(tc[0]),0);
   for i:=1 to maxN do begin fc[i,0]:=0; tc[i,0]:=0;end;
   fillchar(count,sizeof(count),0);
   fillchar(mark,sizeof(mark),0);
   assign(input,in_file); reset(input);
   read(n,m);
   for i:=1 to m do
   begin
      read(x);read(ch);read(t);
      inc(fc[x,0]);
      fc[x,fc[x,0]]:=strtoint(copy(t,1,2))*60+strtoint(copy(t,4,2));
      read(y);read(ch);read(t);
      inc(tc[y,0]);
      tc[y,tc[y,0]]:=strtoint(copy(t,1,2))*60+strtoint(copy(t,4,2));
      can[x,y]:=true;
   end;
   close(input);
   for i:=1 to n do
   begin
      sort(fc[i],1,fc[i][0]);
      sort(tc[i],1,tc[i][0]);
   end;
   OK:=true;
   for k:=1 to n do
   begin
      if (tc[k,0]=0)and(fc[k,0]>0) then begin OK:=false; break; end;
      i:=1;j:=1;
      while (i<=fc[k,0])and(j<=tc[k,0])and OK do
      begin
         if tc[k,j]<=fc[k,i] then
         begin
            inc(i); inc(j);
         end
             else
         begin
            inc(j);
            inc(count[k]);
         end;
      end;
   end;
   if OK then
   begin
     answer:=0;
     for i:=1 to n do if not mark[i] then
     begin
        c:=0;
        answer:=answer+1+count[i];
        if count[i]>0 then inc(c);
        mark[i]:=true;
        find(i);
        if c>1 then dec(answer);
     end;
    // for i:=1 to n do answer:=answer+count[i];
   end else answer:=-1;
   assign(output,out_file);
   write(answer);
   close(output);
end.
