program Project1;


uses
  SysUtils;

procedure readint(var x:integer);
var ch:char;
begin
  x:=0;
  repeat
    read(ch);
  until ch in ['0'..'9'];
  repeat
    x:=x*10+ord(ch)-ord('0');
    read(ch);
  until not (ch in ['0'..'9']);
end;

procedure readtime(var x:integer);
var
  ch:char;
  y:integer;
begin
  x:=0;
  repeat
    read(ch);
  until ch in ['0'..'9'];
  x:=ord(ch)-ord('0');
  read(ch);
  x:=x*10+ord(ch)-ord('0');
  read(ch); // ':'
  read(ch);
  y:=ord(ch)-ord('0');
  read(ch);
  y:=y*10+ord(ch)-ord('0');
  x:=x*60+y;
end;

var
  m:integer;
  ofs,free:array[0..100001]of integer;

function getnext(city,x:integer):integer;
begin
  if free[x]<>x then
    free[x]:=getnext(city,free[x]);
  Result:=free[x];
end;

var
  key,n,race,city,sc:integer;
  din,dout,f,g,x,y:array[1..100000]of integer;

procedure swap(var x,y:integer);
var t:integer;
begin
  t:=x; x:=y; y:=t;
end;

procedure sort(l,r:integer);
var i,j:integer;
begin
  i:=l; j:=r;
  key:=f[(i+j)div 2];
  repeat
    while f[i]<key do inc(i);
    while key<f[j] do dec(j);
    if i<=j then begin
      swap(f[i],f[j]);
      swap(g[i],g[j]);
      swap(x[i],x[j]);
      swap(y[i],y[j]);
      inc(i); dec(j);
    end;

  until i>j;
  if l<j then Sort(l,j);
  if i<r then Sort(i,r);
end;

var
  i,k,days,l,r,d:integer;
  st,en,next:array[0..100001]of integer;
  rc:array[0..2000000]of integer;
  can:array[1..100000]of boolean;

begin
  reset(input,'buses.in');
  rewrite(output,'buses.out');
  readln(n,m);
  for i:=1 to n do begin
    din[i]:=0; dout[i]:=0;
  end;

  for i:=1 to m do begin
    readint(f[i]); inc(dout[f[i]]);
    readtime(x[i]);
    readint(g[i]); inc(din[g[i]]);
    readtime(y[i]);
  end;

  for i:=1 to n do
    if din[i]<>dout[i] then begin
      writeln(-1);
      exit;
    end;
  sort(1,m);
  for i:=1 to n do begin
    st[i]:=0;
  end;
  for i:=1 to m do begin
    free[i]:=i;
    city:=f[i];
    if st[city]=0 then
      st[city]:=i
    else
      next[en[city]]:=i;
    en[city]:=i;
    next[i]:=0;
  end;
  k:=0;
  for i:=1 to n do begin
    ofs[i]:=k;
    while st[i]<>0 do begin
      inc(k);
      rc[k]:=i;
      st[i]:=next[st[i]];
    end;
  end;
  ofs[n+1]:=k;

  days:=0;

  for i:=1 to m do
    if x[i]>y[i] then inc(days);

  for i:=1 to m do can[i]:=true;

  for i:=1 to m do
    if can[i] then begin
      sc:=f[i];
      race:=i;
      city:=sc;
      repeat
        city:=g[race];
        free[race]:=free[race]+1;
        can[race]:=false;
        if free[race]>ofs[f[race]+1] then
          free[race]:=ofs[f[race]]+1;
        l:=ofs[city]+1; r:=ofs[city+1];
        while(l<r) do begin
          d:=(l+r)div 2;
          if(x[rc[d]]<y[race]) then
            l:=d+1
          else
            r:=d;
        end;
        if x[l]<y[race] then l:=ofs[city]+1;
        // l - index of the best next race (maybe not free)
        // now let's find next free:
        l:=getnext(city,l);
        if x[l]<y[race] then
          inc(days);
        race:=l;
      until city=sc;
    end;
  writeln(days);




end.
