#include <stdio.h>
#include <stdlib.h>
#define SWAP(a, b, c) (c) = (a), (a) = (b), (b) = (c)

int cnt;
int Cnt[100001];

typedef struct
{
	int time, city, st, iss;
} SOB;
SOB S[200000];
int SN;

void Read()
{
	int t1, t11, t2, t22, c1, c2;
	scanf("%d %d:%d %d %d:%d", &c1, &t1, &t11, &c2, &t2, &t22);
	t1 = t1 * 24 + t11;
	t2 = t2 * 24 + t22;
	if (t1 > t2)
		t2 += 24 * 60;
	S[SN].city = c1;
	S[SN].time = t1;
	S[SN++].st = 0;
	S[SN].city = c2;
	S[SN].time = t2;
	S[SN++].st = 1;
	
	S[SN].city = c1;
	S[SN].time = t1 + 24 * 60;
	S[SN].iss = 1;
	S[SN++].st = 0;
	S[SN].city = c2;
	S[SN].time = t2 + 24 * 60;
	S[SN].iss = 1;
	S[SN++].st = 1;
}

int IsAmB( SOB a, SOB b )
{
	if (a.time == b.time)
		return a.st > b.st;
	return a.time < b.time;
}
void QSort( int l, int r )
{
	int i, j;
	SOB t, c;
	if (l >= r)
		return;
    c = S[l + (rand() % (r - l + 1))];
	i = l, j = r;
	while (i <= j)
	{
		while (IsAmB(S[i], c))
			i++;
		while (IsAmB(c, S[j]))
			j--;
		if (i <= j)
			SWAP(S[i], S[j], t),
			i++, j--;
	}
	QSort(l, j);
	QSort(i, r);
}


int main( void )
{
	int i, j, k, N, M;

	freopen("buses.in", "rt", stdin);
	freopen("buses.out", "wt", stdout);
	srand(307103);
	scanf("%i%i", &N, &M);
	for (i = 0; i < M; i++)
		Read();
	QSort(0, SN - 1);
	for (i = 0; i < SN; i++)
	{
		if (S[i].st == 0)
		{
			if (Cnt[S[i].city] == 0)
			{
				if (S[i].iss)
				{
					printf("-1");
					return 0;
				}
				cnt++;
			}
			else
				Cnt[S[i].city]--;
		}
		else
		{
			Cnt[S[i].city]++;
		}
	}
	printf("%i", cnt);
	return 0;
}