program buses;

{$APPTYPE CONSOLE}

uses
  SysUtils;

type
  TTime = record
    Hour, Min : byte;
  end;

  TReys = record
    St, Fn   : LongWord;
    StT, FnT : TTime;
  end;

var
  Fin, Fout : text;
  Reys      : array[1..100000] of TReys;
  Send      : array[1..100000] of boolean;
  Towns     : array[1..100000] of Integer;
  N, M, I   : LongWord;
  STHour, STMin : byte;
  THour, TMin : byte;
  Ch        : char;
  K         : longint;

begin
  Assign(Fin, 'buses.in');
  Assign(Fout, 'buses.out');
  Reset(Fin);
  Rewrite(Fout);
  Readln(Fin, N, M);
  THour:=23;
  TMin:=59;
  For I:=1 to N do Towns[I]:=0;
  For I:=1 to M do
  begin
    Send[I]:=false;
    Read(Fin, Reys[I].St);
    Read(Fin, Ch);
    Read(Fin, Ch);
    Reys[I].StT.Hour:=(ord(Ch)-48)*10;
    Read(Fin, Ch);
    Reys[I].StT.Hour:=Reys[I].StT.Hour+(ord(Ch)-48);
    Read(Fin, Ch);
    Read(Fin, Ch);
    Reys[I].StT.Min:=(ord(Ch)-48)*10;
    Read(Fin, Ch);
    Reys[I].StT.Min:=Reys[I].StT.Min+(ord(Ch)-48);
    Read(Fin, Reys[I].Fn);
    Read(Fin, Ch);
    Read(Fin, Ch);
    Reys[I].FnT.Hour:=(ord(Ch)-48)*10;
    Read(Fin, Ch);
    Reys[I].FnT.Hour:=Reys[I].FnT.Hour+(ord(Ch)-48);
    Read(Fin, Ch);
    Read(Fin, Ch);
    Reys[I].FnT.Min:=(ord(Ch)-48)*10;
    Readln(Fin, Ch);
    Reys[I].FnT.Min:=Reys[I].FnT.Min+(ord(Ch)-48);

    if (Reys[I].StT.Hour<THour) or ((Reys[I].StT.Hour=THour) and (Reys[I].StT.Min<Tmin)) then
    begin
      THour:=Reys[I].StT.Hour;
      TMin:=Reys[I].StT.Min;
    end;
  end;

  K:=0;
  STHour:=THour;
  STMin:=TMin;

  repeat
    For I:=1 to M do
    begin
      if (Reys[I].StT.Hour=THour) and (Reys[I].StT.Min=TMin) then
      begin
        Send[I]:=true;
        if Towns[Reys[I].St]<=0 then K:=K+1;
        Towns[Reys[I].St]:=Towns[Reys[I].St]-1;
{        if (Reys[I].StT.Hour>Reys[I].FnT.Hour) or
           ((Reys[I].StT.Hour=Reys[I].FnT.Hour) and
           (Reys[I].StT.Min>Reys[I].FnT.Min)) then Towns[Reys[I].Fn]:=Towns[Reys[I].Fn]+1;}
      end;
      if (Reys[I].FnT.Hour=THour) and (Reys[I].FnT.Min=TMin) then
      begin
        if Send[I] then
        begin
          Send[I]:=false;
          Towns[Reys[I].Fn]:=Towns[Reys[I].Fn]+1;
        end
        else
        begin
          Towns[Reys[I].Fn]:=Towns[Reys[I].Fn]+1;
          K:=K+1;
        end;
      end;
    end;
    THour:=(THour+((TMin+1) div 60)) mod 24;
    TMin:=(TMin+1) mod 60;
  until (THour=STHour) and (TMin=STMin);

  For I:=1 to N do
  if Towns[I]<>0 then
  begin
    K:=-1;
    Break;
  end;

  Writeln(Fout, K);
  Close(Fin);
  Close(Fout);
end.
