{$O-,Q+,R+}
Uses
  SysUtils;

Const
  MaxN = 10 * 100000;

Var
  l, r, j, i, n, m, ans: LongInt;
  InSide, event, real, pr,  b, e, t1, t2: Array [1 .. MaxN] of LongInt;
  prAns: Boolean;

Procedure ReadTime(Var t: LongInt);
Var
  h, m: Integer;
  ch: Char;
Begin
  ch := 'a';
  h := 0;
  m := 0;
  While not (ch in ['0' .. '9']) do
    Read(ch);
  While ch in ['0' .. '9'] do Begin
    h := h  * 10 + Ord(ch) - Ord('0');
    Read(ch);
  End;
  While not (ch in ['0' .. '9']) do
    Read(ch);
  While ch in ['0' .. '9'] do Begin
    m := m  * 10 + Ord(ch) - Ord('0');
    Read(ch);
  End;
  t := h * 60 + m;
End;

Procedure Swap(Var a, b: LongInt);
Var
  c: LongInt;
Begin
  c := a;
  a := b;
  b := c;
End;

Function Partition(l, r: LongInt): LongInt;
Var
  i, j, x: LongInt;
Begin
  i := l - 1;
  j := r + 1;
  x := event[(l + r) div 2];
  While true do Begin
    Repeat Inc(i);
      Until event[i] >= x;
    Repeat Dec(j);
      Until event[j] <= x;
    If i < j Then Begin
      Swap(event[i], event[j]);
      Swap(real[i], real[j]);
      Swap(pr[i], pr[j]);
    End
    Else Begin
      partition := j;
      Exit;
    End;
  End;
End;
     {
Function Partition(l, r: LongInt): LongInt;
Var
  i, j, x: LongInt;
Begin
  i := l - 1;
  j := r + 1;
  x := l + random(r - l + 1);
  While true do Begin
    Repeat Inc(i);
      Until (event[i] >= event[x]);
    Repeat Dec(j);
      Until (event[j] <= event[x]);
    If i < j Then Begin
      Swap(event[i], event[j]);
      Swap(pr[i], pr[j]);
      Swap(real[i], real[j]);
    End
    Else Begin
      Partition := j;
      Exit;
    End;
  End;
End;
      }
Procedure Qsort(l, r: LongInt);
Var
  q: LongInt;
Begin
  If l < r Then Begin
    q := Partition(l, r);
    Qsort(l, q);
    Qsort(q + 1, r);
  End;
End;

Function Partition2(l, r: LongInt): LongInt;
Var
  i, j, x: LongInt;
Begin
  i := l - 1;
  j := r + 1;
  x := l + random(r - l + 1);
  While true do Begin
    Repeat Inc(i);
      Until pr[i] <= pr[x];
    Repeat Dec(j);
      Until pr[j] >= pr[x];
    If i < j Then Begin
      Swap(event[i], event[j]);
      Swap(pr[i], pr[j]);
      Swap(real[i], real[j]);
    End
    Else Begin
      Partition2 := j;
      Exit;
    End;
  End;
End;

Procedure Qsort2(l, r: LongInt);
Var
  q: LongInt;
Begin
  If l < r Then Begin
    q := Partition2(l, r);
    Qsort2(l, q);
    Qsort2(q + 1, r);
  End;
End;

Begin
Assign(input, 'buses.in');
Assign(output, 'buses.out');
Reset(input);
Rewrite(output);

  Randomize;

  Read(n, m);
  For i := 1 to m do Begin
    Read(b[i]);
    ReadTime(t1[i]);
    Read(e[i]);
    ReadTime(t2[i]);
    If t1[i] > t2[i] Then Inc(t2[i], 60 * 24);
    event[i] := t1[i];
    pr[i] := 1;
    real[i] := i;
    event[i + m] := t2[i];
    pr[i + m] := 2;
    real[i + m] := i;
    b[i + m] := b[i];
    e[i + m] := e[i];
    t1[i + m] := t1[i] + 24 * 60;
    t2[i + m] := t2[i] + 24 * 60;
  End;

  For i := 2 * m + 1 to  4 * m do Begin
    event[i] := event[i  - 2 * m] + 60 * 24;
    pr[i] := pr[i - 2 * m];
    If i <= 3 * m Then real[i] := i - m
    Else real[i] := i - 2 * m;
  End;

  For i := 4 * m + 1 to 6 * m do Begin
    event[i] := event[i - 2 * m] + 60 * 24 * 2;
    pr[i] := pr[i - 4 * m];
    If i <= 5 * m Then real[i] := i - 3 * m
    Else
      real[i] := i - 4 * m;
  End;

  Qsort(1, 6 * m);

  l := 1;
  r := 1;
  For i := 1 to 6 * m - 1 do Begin
    If event[i] = event[i + 1] Then Begin
      r := i + 1;
    End
    Else Begin
      Qsort2(l, r);
      l := i + 1;
      r := i + 1;
    End;
  End;
  Qsort2(l, r);

  For i := 1 to m - 1 do
    If (event[i]  = event[i + 1]) and (pr[i] < pr[i + 1])
      Then j := i;

  prAns := true;

   For i := 1 to 6 * m do Begin
    If pr[i] = 1 Then Begin
      If event[i] <= 2 * 24 * 60 Then
        If InSide[b[real[i]]] = 0 Then Begin
          Inc(ans);
        End
        Else
          Dec(InSide[b[real[i]]])
      Else Begin
        Dec(InSide[b[real[i]]]);
        If InSide[b[real[i]]] < 0 Then prAns := false;
      End;
    End;
    If pr[i] = 2 Then Begin
      Inc(InSide[e[real[i]]]);
    End;
  End;

  If prAns Then Write(ans)
  Else Write('-1');

Close(input);
Close(output);
End.
