program Zad4;

{$Apptype Console}

{$O+,R-,Q-,D-,I-}

uses
  SysUtils;

type
  rec=record
        u,v:Longint;
        b,e:Longint;
      end;
  rec2=record
         f,l:LongInt;
       end; 

const
  MaxM=100000;


const
  MaxN=100000;

var
  N,M:LongInt;
  reb,r2:array[1..MaxM] of rec;
  ans:LongInt;
  a:array[1..MaxM] of rec2;
  used,used2:array[1..MaxN] of longint;
  way:array[1..MaxN] of LongInt;
  cnt:Longint;


procedure Init;
begin
  Assign(input,'buses.in');
  Reset(input);
  Assign(output,'buses.out');
  Rewrite(output);
end;

procedure Final;
begin
  Close(input);
  Close(output);
end;

function Find(const s:string):LongInt;
begin
  Result:=StrToInt(Copy(s,1,2))*60+StrToInt(Copy(s,4,2));
end;

procedure InData;
var
  i,k:LongInt;
  st,time:string;
begin
  Readln(N,M);
  for i:=1 to M do
  begin
    Readln(st);
    k:=Pos(' ',st);
    reb[i].u:=StrToInt(Copy(st,1,k-1));
    st:=Copy(st,k+1,Length(st)-k);
    time:=Copy(st,1,5);
    reb[i].b:=Find(time);
    st:=Copy(st,7,Length(st)-6);

    k:=Pos(' ',st);
    reb[i].v:=StrToInt(Copy(st,1,k-1));
    st:=Copy(st,k+1,Length(st)-k);
    time:=Copy(st,1,5);
    reb[i].e:=Find(time);
  end;
end;

procedure BuildG;
var
  i:Longint;
begin
  fillchar(a,SizeOf(a),0);
  for i:=1 to M do
  begin
    if a[reb[i].u].f=0 then
    begin
      a[reb[i].u].f:=i;
      a[reb[i].u].l:=i;
    end
    else
      a[reb[i].u].l:=i;
  end;
end;


procedure OutAns;
begin
  Writeln(ans);
end;

procedure Sort(l,r:LongInt);
var
  i,j,m:Longint;
  t:LongInt;
begin
  if l>=r then Exit;
  m:=(l+r) div 2;
  Sort(l,m);
  Sort(m+1,r);
  i:=l;
  j:=m+1;
  t:=0;
  while (i<=m)and(j<=r) do
  begin
    inc(t);
    if (reb[i].u<reb[j].u)or((reb[i].u=reb[j].u)and(reb[i].b<reb[j].b)) then
    begin
      r2[t]:=reb[i];
      inc(i);
    end
    else
    begin
      r2[t]:=reb[j];
      inc(j);
    end;
  end;

  while (i<=m) do
  begin
    inc(t);
    r2[t]:=reb[i];
    inc(i);
  end;

  while (j<=r) do
  begin
    inc(t);
      r2[t]:=reb[j];
      inc(j);
  end;

  for t:=0 to t-1 do
    reb[l+t]:=r2[t+1];
end;

function Dfs(v,k:Longint):Boolean;
var
  i:LOngInt;
begin
  Result:=false;
  if v=k then Result:=true
  else
  begin
    if used2[v]=1 then Exit;
    used2[v]:=1;
    for i:=a[v].f to a[v].l do
    if used[i]=0 then
      if Dfs(reb[i].v,k) then
      begin
        Result:=true;
        used[i]:=1;
        inc(cnt);
        way[cnt]:=i;
        Exit;
      end;
  end;
end;

procedure FindWay(i,j:Longint);
var
  p:LongInt;
begin
  fillchar(used2,SizeOF(used2),0);
  for p:=a[i].f to a[i].l do
  if used[p]=0 then
  begin
    if Dfs(reb[p].v,j) then
    begin
      used[p]:=1;
      inc(cnt);
      way[cnt]:=p;
      Exit;
    end;
  end;
end;

function Rasst(i,j:Longint):Longint;
begin
  if i<=j then
  Result:=j-i else Result:=24*60-abs(j-i);
end;


procedure Solve;
var
  i,cnt2,j:Longint;
  beg:Longint;
begin
  Sort(1,M);
  BuildG;
  ans:=0;
  fillchar(used,SizeOf(used),0);

  for i:=1 to M do
  if (used[i]=0) then
  begin
     cnt:=0;

    FindWay(reb[i].v,reb[i].u);
    inc(cnt);
    way[cnt]:=i;
    if cnt=1 then
    begin
      ans:=-1;
      Exit;
    end;
    used[i]:=1;
    beg:=Rasst(reb[way[cnt]].b,reb[way[cnt]].e);

    for j:=cnt-1 downto 1 do
    begin
     beg:=beg+Rasst(reb[way[j]].b,reb[way[j]].e);
     beg:=beg+Rasst(reb[way[j+1]].e,reb[way[j]].b);  
    end;
    cnt2:=beg div (60*24); if beg mod (60*24)>0 then inc(cnt2);
    ans:=ans+cnt2;
  end;
end;

begin
  Init;
  InData;
  Solve;
  OutAns;
  Final;
end.