Program qq;

{$APPTYPE CONSOLE}

uses
  SysUtils;

const
  day=60*24;

type
  trip=record
    e: integer;
    time1, time2: integer;
    used: boolean;
    index: integer;
  end;
  city=array of trip;

function conv(s: string): integer;
  begin
    result:=strtoint(copy(s, 1, 2))*60+strtoint(copy(s, 4, 2));
  end;


var
  n, m: integer;
  i, j, k, a, b: integer;
  arr: array[0..100010] of city;
  len: array[0..100010] of integer;
  s: string[5];
  stok: array[0..100010] of boolean;
  ind: array[0..100010]of integer;
  alr: integer;
  mint: integer;
  res: int64;
  disc: int64;

procedure swap(var a, b: trip);
  var
    t: trip;

  begin
    t:=a;
    a:=b;
    b:=t;
  end;

procedure qsort(x, l, r: integer);
  var
    lh, rh: integer;

  begin
    lh:=l;
    rh:=r;
    while (lh<rh) do begin
      while (lh<rh)and(arr[x][lh].time2<=arr[x][rh].time2) do inc(lh);
      swap(arr[x][lh], arr[x][rh]);
      while (lh<rh)and(arr[x][lh].time2<=arr[x][rh].time2) do dec(rh);
      swap(arr[x][lh], arr[x][rh]);
    end;
    if (lh-l)>1 then qsort(x, l, lh-1);
    if (r-rh)>1 then qsort(x, rh+1, r);
  end;

procedure swap2(var a, b: city);
  var
    t: city;
    te: integer;

  begin
    t:=a;
    a:=b;
    b:=t;
    te:=ind[a[0].index];
    ind[a[0].index]:=ind[b[0].index];
    ind[b[0].index]:=te;
//    te:=a[0].index;
//    a[0].index:=b[0].index;
//    b[0].index:=te;
  end;

procedure qsort2(l, r: integer);
  var
    lh, rh: integer;

  begin
    lh:=l;
    rh:=r;
    while (lh<rh) do begin
      while (lh<rh)and(arr[lh][1].time2<=arr[rh][1].time2) do inc(lh);
      swap2(arr[lh], arr[rh]);
      while (lh<rh)and(arr[lh][1].time2<=arr[rh][1].time2) do dec(rh);
      swap2(arr[lh], arr[rh]);
    end;
    if (lh-l)>1 then qsort2(l, lh-1);
    if (r-rh)>1 then qsort2(rh+1, r);
  end;

function dfs(v: integer; time: integer): boolean;
  var
    i: integer;

  begin
    i:=1;
    while (i<len[v]) and ((arr[v][i].used=true)or(arr[v][i].time1<time)) do inc(i);
    if i>=len[v] then begin
      result:=false;
      exit;
    end;
    arr[v][i].used:=true;
    inc(disc);
    result:=dfs(arr[v][i].e, arr[v][i].time2);
    result:=true;
  end;

begin
  reset(input, 'buses.in');
  rewrite(output, 'buses.out');
  readln(n, m);
  for i:=1 to 100010 do len[i]:=1;
  for i:=1 to m do begin
    read(j);
    inc(len[j]);
    setlength(arr[j], len[j]);
    read(s[1]);
    read(s);
    k:=conv(s);
    read(s[1]);
    read(a);
    stok[a]:=true;
    arr[j][len[j]-1].e:=a;
    arr[j][len[j]-1].time1:=k;
    read(s[1]);
    read(s);
    k:=conv(s);
    arr[j][len[j]-1].time2:=k;
  end;

  mint:=maxint;
  for i:=1 to n do begin
    if ((len[i]<>1)and(not stok[i]))or((len[i]=1)and(stok[i])) then begin
      writeln('-1');
      exit;
    end;
    qsort(i, 1, len[i]-1);
    for j:=1 to len[i]-1 do begin
      if arr[i][j].time1<mint then mint:=arr[i][j].time1;
    end;
  end;
  for i:=1 to n do begin
    for j:=1 to len[i]-1 do begin
      arr[i][j].time1:=arr[i][j].time1-mint;
      if arr[i][j].time1<0 then arr[i][j].time1:=arr[i][j].time1+day;
      arr[i][j].time2:=arr[i][j].time2-mint;
      if arr[i][j].time2<0 then arr[i][j].time2:=arr[i][j].time2+day;
    end;
  end;

  for i:=1 to n do begin
    if len[i]<>1 then
    arr[i][0].index:=i;
  end;
  for i:=1 to n do begin
    ind[i]:=i;
  end;

  qsort2(1, n);

  for i:=1 to n do begin
    for j:=1 to len[i]-1 do begin
      arr[i][j].e:=ind[arr[i][j].e];
    end;
  end;

  res:=0;
  disc:=0;
  while disc<m do
  for i:=1 to n do begin
    if dfs(i, 0) then inc(res);
  end;
  writeln(res);

  for i:=1 to m do setlength(arr[j], 0);

end.