program buses;

uses
  SysUtils;
type
  stime=string[5];
  road=record
    f,g,x,y:integer;
  end;
var
  s1,S2:stime;
  es,en,enter,esc:array[1..100000] of integer;
  a:array[1..100000]of road;
FUNCTION timetoint(s:stime):integer;
{var
  a1,b1:string;}
begin
{  a1:=copy(s,1,2);
  b1:=copy(s,4,2);  }
  result:=strtoint(copy(s,1,2))*60+strtoint(copy(s,4,2));
end;

procedure qsortesc(l,r: integer);
var
  i,j,x,y: integer;
begin
  i:=l; j:=r; x:=esc[(l+r) DIV 2];
  repeat
    while esc[i]<x do i:=i+1;
    while x<esc[j] do j:=j-1;
    if i<=j then
    begin
      y:=esc[i]; esc[i]:=esc[j];esc[j]:=y;
      i:=i+1; j:=j-1;
    end;
  until i>j;
  if l<j then qsortesc(l,j);
  if i<r then qsortesc(i,r);
end;
procedure qsortenter(l,r: integer);
var
  i,j,x,y: integer;
begin
  i:=l; j:=r; x:=enter[(l+r) DIV 2];
  repeat
    while enter[i]<x do i:=i+1;
    while x<enter[j] do j:=j-1;
    if i<=j then
    begin
      y:=enter[i]; enter[i]:=enter[j];enter[j]:=y;
      i:=i+1; j:=j-1;
    end;
  until i>j;
  if l<j then qsortenter(l,j);
  if i<r then qsortenter(i,r);
end;
var
  m,n,i,j,lastesc,lasten,count,esi,eni:integer;
  c:char;
begin
  assign(input,'buses.in');
  reset(input);
  assign(output,'buses.out');
  rewrite(output);
  readln(n,m);
  for i:=1 to n do begin
    es[i]:=0;
    en[i]:=0;
  end;
  for i:=1 to m do begin
    read(a[i].f);
    read(c);
    read(s1);
    a[i].x:=timetoint(s1);
    read(a[i].g);
    read(c);    
    read(s2);
    a[i].y:=timetoint(s2);
    if a[i].y<a[i].x then begin
      a[i].y:=a[i].y+1440;
    end;
    inc(en[a[i].g]);
//    enter[a[i].g][en[a[i].g]]:=a[i].y;
//    enter[][]:=a[i].y;
    inc(es[a[i].f]);
//    esc[a[i].f][es[a[i].f]]:=a[i].x;
  end;
  count:=0;
  for i:=1 to n do begin
    if en[i]<>es[i] then begin
      writeln('-1');
      halt;
    end;
  end;
  for i:=1 to n do begin
    esi:=0;
    eni:=0;
    for j:=1 to m do begin
      if a[j].f=i then begin
        inc(esi);
        esc[esi]:=a[j].x;
      end;
      if a[j].g=i then begin
        inc(eni);
        enter[eni]:=a[j].y;
      end;
    end;
    qsortesc(1,esi);
    qsortenter(1,eni);
    lasten:=1;
    lastesc:=1;

    for j:=1 to esi do begin
      if esc[lastesc]<enter[lasten] then begin
        inc(lastesc);
        inc(count);
      end
      else begin
        inc(lastesc);
        inc(lasten);
      end;
    end;
  end;
  writeln(count);
end.

