{$APPTYPE CONSOLE}
Const
  NMax = 100000;

Var
  n, m : Integer;
  i,  k, l, kk : Integer;
  mas : array [1..NMax] of Integer;
  id : array [1..2*NMax] of Integer;
  x, y : array [1..2*NMax] of Word;

procedure ReadTime(var a : Word);
Var
  ch : char;
  h, m : Integer;

begin
  Read(ch);
  Read(ch); h := 10*(ord(ch)-48);
  Read(ch); h := h + (ord(ch)-48);
  Read(ch);
  Read(ch); m := 10*(ord(ch)-48);
  Read(ch); m := m + (ord(ch)-48);
  a := h*60 + m;
end;

procedure swap(var a, b : Integer); overload;
var
  t : Integer;

begin
  t := a;
  a := b;
  b := t;
end;

procedure swap(var a, b : Word); overload;
var
  t : Word;

begin
  t := a;
  a := b;
  b := t;
end;

procedure dh(k, n : integer);
var
  new_elem, ny, nid, child, o : integer;

begin
  new_elem := x[k];
  ny := y[k];
  nid := id[k];
  while 2*k <= n do
    begin
      child := 2*k;
      If (child < n) and ((x[child] < x[child+1]) or ((x[child] = x[child+1]) and (y[child] < y[child+1]))) then
        Inc(child);
      If (new_elem > x[child]) or ((new_elem = x[child]) and (ny >= y[child])) then
        break;
      x[k] := x[child];
      y[k] := y[child];
      id[k] := id[child];
      k := child;
    end;
  x[k] := new_elem;
  y[k] := ny;
  id[k] := nid;
end;

procedure Sort;
var
  i : integer;
begin
  For i := m downto 1 do
    dh(i, 2*m);
  For i := m*2 downto  2 do
    begin
      swap(x[1],x[i]);
      swap(y[1],y[i]);
      swap(id[1],id[i]);
      dh(1,i-1);
    end;
end;

procedure QSort(l, r : Integer);
Var
  m : Integer;
  i, j : Integer;

begin
  i := l;
  j := r;
  m := x[l+Random(r-l+1)];
  while i <= j do
    begin
      while x[i] < m do inc(i);
      while x[j] > m do dec(j);
      If i <= j then
        begin
          If (x[i] = x[j]) and (y[i] > y[j]) then
            begin
              inc(i);
              dec(j);
              continue;
            end;

          swap(x[i],x[j]);
          swap(y[i],y[j]);
          swap(id[i],id[j]);
          inc(i);
          dec(j);
        end;
    end;
  If i < r then QSort(i, r);
  If j > l then QSort(l, j);
end;

begin
  Reset(Input,'buses.in');
  Rewrite(Output,'buses.out');
  Randomize;
  FillChar(mas, SizeOf(mas), 0);
  Read(N, M);
  For i := 1 to M do
    begin
      Read(id[i*2-1]);
      ReadTime(x[i*2-1]);
      y[i*2-1] := 1;
      Read(id[i*2]);
      ReadTime(x[i*2]);
      If x[i*2] < x[i*2-1] then
        x[i*2] :=  x[i*2] + 24*60;
      y[i*2] := 0;
      ReadLn;
    end;
  Sort;
//  QSort(1,2*m);
  k := 0;
  for l := 1 to 10 do begin
  For i := 1 to 2*M do
    begin
      case y[i] of
        1 :
          begin
            If mas[id[i]] = 0 then
              begin
                Inc(k);
              end
             else
              dec(mas[id[i]]);
          end;
        0 :
          begin
            inc(mas[id[i]]);
          end;
      end;
    end;
  If l > 1 then
    begin
      If kk < k then
        begin
          writeln(-1);
          halt;
        end;
    end;
  kk := k;
  end;
  WriteLn(k);
end.
 