{$A+,B-,D-,E-,I-,L-,N-,Q-,R-,S-,X+,Y-}
{O-,R+,S+,Q+}
uses
 SysUtils;
const
  infile='buses.in';
 outfile='buses.out';
 mx=100000+7;

var
 n,m,size,res:longint;
 t,c,id,go:array[1..2*mx] of longint;
 bus,score:array[1..mx] of longint;
 travel:array[1..mx] of boolean;

procedure readtime(var t:longint);
var
 ch1,ch2,ch3,ch4,ch5:char;
 s:string;
begin
 read(ch1);
 while not (ch1 in ['0'..'9']) do
  read(ch1);
 read(ch2);
 read(ch3);
 read(ch4);
 read(ch5);
 s:=ch1+ch2+ch3+ch4+ch5;
 t:=strtoint(s[1]+s[2])*60+strtoint(s[4]+s[5]);
end;

procedure init;
var
 i,ct,tm:longint;
begin
 readln(n,m);
 for i:=1 to m do
  begin
   read(ct);
   readtime(tm);
   t[2*i-1]:=2*tm+1;
   c[2*i-1]:=ct;
   id[2*i-1]:=2*i-1;
   go[2*i-1]:=i;
   read(ct);
   readtime(tm);
   t[2*i]:=2*tm;
   c[2*i]:=ct;
   id[2*i]:=2*i;
   go[2*i]:=i;
  end;
 m:=m*2;  
end;

procedure swap(var a,b:longint);
var
 c:longint;
begin
 c:=a;
 a:=b;
 b:=c;
end;

procedure heapify(k:longint);
var
 q:longint;
begin
 while true do
  begin
   q:=k;
   if 2*k<=size then
    if t[id[q]]<t[id[2*k]] then
     q:=2*k;
   if 2*k+1<=size then
    if t[id[q]]<t[id[2*k+1]] then
     q:=2*k+1;
   if k<>q then
    begin
     swap(id[k],id[q]);
     k:=q;
    end else
     break;
  end;
end;

procedure heapsort;
var
 i:longint;
begin
 size:=m;
 for i:=m div 2 downto 1 do
  heapify(i);
 while size>0 do
  begin
   swap(id[1],id[size]);
   dec(size);
   heapify(1);
  end;
end;

procedure kmd;
var
 i:longint;
begin
 for i:=1 to m do
  begin
   if odd(t[id[i]]) then
    begin
     {start}
     dec(score[c[id[i]]]);
     if bus[c[id[i]]]>0 then
      dec(bus[c[id[i]]]) else
       inc(res);
     travel[go[id[i]]]:=true;
    end else
     begin
      {finish}
      if not travel[go[id[i]]] then
       inc(res) else
        travel[go[id[i]]]:=false;
      inc(bus[c[id[i]]]);
      inc(score[c[id[i]]]);
     end;
  end;
end;

procedure checking;
var
 i:longint;
begin
 for i:=1 to n do
  if score[i]<0 then
   begin
    res:=-1;
    exit;
   end;
end;

procedure run;
var
 q,i:longint;
begin
 res:=0;
 fillchar(bus,sizeof(bus),0);
 fillchar(travel,sizeof(travel),false);
 heapsort;
 kmd;
 for i:=1 to 10 do
  kmd;
 fillchar(score,sizeof(score),0);
 q:=res;
 kmd;
 checking;
 if res>q then
  res:=-1;
end;

procedure done;
begin
 write(res);
end;

begin
 assign(input,infile);
 reset(input);
 assign(output,outfile);
 rewrite(output);
 init;
 run;
 done;
 close(input);
 close(output);
end.