program ol;
const
  maxe=100000;
  maxv=100000;
type
  edge=record
    start,finish,v:integer;
  end;
  gedge=array[1..maxe,1..maxv]of edge;
  gvert=array[1..maxv] of longint;
  pbool=array[1..maxe] of boolean;
var
  nedges,nver:longint;
  vert:^gvert;
  edges:^gedge;
  process,discov:^pbool;
  mg:boolean;
  k,p1,p2,i:longint;
  st,fin:integer;
  c:char;
procedure load;
begin
  readln(nedges,nver);
  for i:=1 to nver do begin
    p1:=0;
    p2:=0;
    st:=0;
    fin:=0;
    repeat
      read(c);
      if c in ['0'..'9'] then p1:=p1*10+(ord(c)-48);
    until c=' ';
    repeat
      read(c);
      if c in ['0'..'9'] then st:=st*10+(ord(c)-48);
    until c=':';
    st:=st*60;
    repeat
      read(c);
      if c in ['0'..'9'] then fin:=fin*10+(ord(c)-48);
    until c=' ';
    st:=st+fin;
    fin:=0;
    repeat
      read(c);
      if c in ['0'..'9'] then p2:=p2*10+(ord(c)-48);
    until c=' ';
    inc(vert^[p1]);
    edges^[p1,vert^[p1]].v:=p2;
    edges^[p1,vert^[p1]].start:=st;
    repeat
      read(c);
      if c in ['0'..'9'] then fin:=fin*10+(ord(c)-48);
    until c=':';
    fin:=fin*60;
    st:=0;
    while not eoln do begin
      read(c);
      if c in ['0'..'9'] then st:=st*10+(ord(c)-48);
    end;
    fin:=fin+st;
    edges^[p1,vert^[p1]].finish:=fin;
  end;
end;
procedure dfs(x,p:longint);
var j:longint;
begin
  if not discov^[x] then discov^[x]:=true
    else if not process^[x] then process^[x]:=true;
  for j:=1 to vert^[x] do if not process^[edges^[x,j].v] then begin
    if (not process^[x]) and (edges^[x,j].start<p) then inc(k);
    dfs(edges^[x,j].v,edges^[x,j].finish);
  end;
end;
procedure init;
begin
  new(vert);
  new(edges);
  new(process);
  new(discov);
  fillchar(vert^,sizeof(vert^),0);
  fillchar(edges^,sizeof(edges^),0);
  fillchar(process^,sizeof(process^),0);
  fillchar(discov^,sizeof(discov^),0);
end;
begin
  k:=0;
  init;
  load;
  for i:=1 to nedges do if not discov^[i] then begin
    inc(k);
    dfs(i,0);
  end;
  mg:=true;
  for i:=1 to nedges do if not process^[i] then begin
    mg:=false;
    break;
  end;
  if not mg then writeln('-1') else writeln(k);
  dispose(vert);
  dispose(edges);
  dispose(process);
  dispose(discov);
end.