program a3;

{$APPTYPE CONSOLE}

uses
  SysUtils;
type
  int = longint;
  TElem = record
    t, next, k : int;
  end;
  EL = record
    k, t, l : int;
  end;
  ar = array [1..100000] of EL;

var
  a : ar;
  n, m : int;
  h1, h2 : array [1..100000] of TElem;
  g1, g2 : array [1..100000] of int;
  c1, c2 : int;
  ans : int;

procedure sort(var a : ar; n : int);
  procedure swap(var x, y : EL);
    var
      z : EL;
  begin
    z := x;
    x := y;
    y := z;
  end;

  procedure sift(v : int);
    var
      l : int;
  begin
    if 2 * v > n then exit;
    l := 2 * v;
    if (l + 1 <= n) and (a[l + 1].t > a[l].t) then inc(l);
    if a[v].t < a[l].t then
    begin
      swap(a[v], a[l]);
      sift(l);
    end;
  end;

var
  i : int;

begin
  for i := n div 2 + 1 downto 1 do
    sift(i);
  while n > 1 do
  begin
    swap(a[1], a[n]);
    dec(n);
    sift(1);
  end;
end;

procedure add1(v, t : int);
begin
  inc(c1);
  h1[c1].t := t;
  h1[c1].next := g1[v];
  g1[v] := c1;
end;

procedure add2(v, t, k : int);
begin
  inc(c2);
  h2[c2].k := k;
  h2[c2].t := t;
  h2[c2].next := g2[v];
  g2[v] := c2;
end;

procedure readdata(var t : int);
var
  s : string;
  c : char;
  code, i, k : integer;
begin
  s := '';
  read(c);
  for i := 1 to 2 do
  begin
    read(c);
    s := s + c;
  end;
  val(s, k, code);
  t := k * 60;
  read(c);
  s := '';
  for i := 1 to 2 do
  begin
    read(c);
    s := s + c;
  end;
  val(s, k, code);
  t := t + k;
end;

var
  kol : array [1..100000] of int;
  i, j, k, l, t : int;
  k1, k2, x : int;
  x1, y1, x2, y2 : int;

begin
  reset(input, 'buses.in');
  rewrite(output, 'buses.out');
  read(n, m);
  for i := 1 to m do
  begin
    read(x1);
    readdata(y1);
    read(x2);
    readdata(y2);
    add1(x1, y1);
    if y1 > y2 then
      k := 2 else k := 1;
    add2(x2, y2, k);
  end;
  for i := 1 to n do
  begin
    k1 := 0;
    k2 := 0;
    x := g1[i];
    while x <> 0 do
    begin
      inc(k1);
      x := h1[x].next;
    end;
    x := g2[i];
    while x <> 0 do
    begin
      inc(k2);
      x := h2[x].next;
    end;
    if k1 <> k2 then
    begin
      write(-1);
      halt(0);
    end;
  end;
  ans := 0;
  for i := 1 to n do
  begin
    x := g1[i];
    k := 0;
    while x <> 0 do
    begin
      inc(k);
      a[k].t := h1[x].t;
      a[k].k := 1;
      x := h1[x].next;
    end;
    x := g2[i];
    while x <> 0 do
    begin
      inc(k);
      if h2[x].k = 2 then
      begin
        a[k].l := 2;
      end else a[k].l := 1;
      a[k].t := h2[x].t;
      a[k].k := 2;
      x := h2[x].next;
    end;
    sort(a, k);
    x := 0;
    l := 0;
    t := 0;

    for j := 1 to k do
      if (a[j].k = 2) and (a[j].l = 2) then
        inc(t) else
      if a[j].k = 2 then
        inc(x) else
        begin
          if (t > 0) then
          begin
            dec(t);
          end;
          if x > 0 then dec(x) else
            inc(l);
        end;
    ans := ans + l + t;
  end;
  writeln(ans);
end.
 