// This is the main project file for VC++ application project 
// generated using an Application Wizard.

#include <vector>
#include <set>
#include <cstdio>
#include <cstdlib>

using namespace std;

struct tRace{
	int sh, sm, fh, fm, dest, from;
	bool friend operator<(const tRace p1, const tRace p2);
};

bool operator<(const tRace p1, const tRace p2) {
	if (p1.sh<p2.sh) return true;
	if ((p1.sh==p2.sh)&&(p1.sm<p2.sm)) return true;
	return false;
}

vector< set<tRace> > r;
set<int> has;
int M, N;

void ExitInf(void)
{
	printf("-1\n");
	fclose(stdout);
	fclose(stdin);
	exit(0);
}

int res = 0;

void AddRoute(int start)
{
	tRace cur, st;
	cur.sh = cur.sm = 0;
	st = *(r[start].lower_bound(cur));
	int i = start;
	set<tRace>::iterator it;
	while (true)
	{
		if (r[i].empty()){
			if (i==start) break;
			ExitInf();
		}
		if ((it = r[i].lower_bound(cur))==r[i].end())
		{
			cur.sh = cur.sm = 0;
			it = r[i].lower_bound(cur);
			res++;
		}
		if (it->fh<cur.sh) ++res; else
			if ((it->fh==cur.sh)&&(it->fm<cur.sm)) ++res;
		cur = *it;
		r[i].erase(it);
		if (r[i].size()==0)
			has.erase(i);
		cur.sh = cur.fh;
		cur.sm = cur.fm;
		i = cur.dest;
	}
	if (st.sh<cur.sh) ++res; else
		if ((st.sh==cur.sh)&&(st.sm<cur.sm)) ++res;
}

int main()
{
	freopen("buses.in", "r", stdin);
	freopen("buses.out", "w", stdout);
	scanf("%d%d", &N, &M);
	r.resize(N);
	int i;
	for (i = 0; i < M; i++)
	{
		tRace rc;
		scanf("%d %d:%d %d %d:%d", &rc.from, &rc.sh, &rc.sm, &rc.dest, &rc.fh, &rc.fm);
		--rc.from;
		--rc.dest;
		r[rc.from].insert(rc);
		has.insert(rc.from);
	}
	set<int>::iterator it;
	while ((it=has.lower_bound(0))!=has.end())
	{
		AddRoute(*it);
	}
	printf("%d", res);
	fclose(stdin);
	fclose(stdout);
    return 0;
}