//{$A8,B-,C+,D+,E-,F-,G+,H+,I+,J-,K-,L+,M-,N+,O-,P+,Q+,R+,S+,T-,U-,V+,W-,X+,Y+,Z1}
{$A8,B-,C+,D-,E-,F-,G+,H+,I-,J-,K-,L-,M-,N+,O+,P+,Q-,R-,S-,T-,U-,V+,W-,X+,Y+,Z1}

program Problem4;

{$APPTYPE CONSOLE}

uses
  SysUtils;

const inname='buses.in';
      outname='buses.out';
      maxn=200000;

type int=longint;
     real=extended;
     bool=boolean;
     tt=record
          key:int;
          t1,t2:int;
          u:bool;
        end;

var n,m,t1,t2,x,y,ans,day,time,kol:int;
    d:array[0..maxn] of int;
    a:array[0..maxn] of array of tt;
    u:array[0..maxn] of bool;
    timet,dayt,d1,d2:array[0..maxn] of int;
    ch:char;
    fl:bool;
    beg:real;

procedure closefiles; forward;    

procedure readtime(var t:int);
begin
  t:=0;
  read(ch);
  t:=ord(ch)-ord('0');
  read(ch);
  t:=10*t+ord(ch)-ord('0');
  read(ch);
  read(ch);
  t:=10*t+ord(ch)-ord('0');
  read(ch);
  t:=10*t+ord(ch)-ord('0');
end;

procedure go(t:int);
  var i,timel,dayl:int;
begin
  if (now-beg)*60*60*24>1.7 then begin
    write(-1);
    closefiles;
    halt;
  end;

  if u[t] then begin
    if time<=timet[t] then
      dec(ans);
    inc(ans,day-dayt[t]+1);
    fl:=true;

    dec(m,kol);
  end;

  u[t]:=true;
  timet[t]:=time;
  dayt[t]:=day;

  for i:=1 to d[t] do
    if (a[t,i].t1>=time) and a[t,i].u then begin
      timet[t]:=a[t,i].t1;

      inc(kol);
      d1[kol]:=t;
      d2[kol]:=i;

      timel:=time;
      dayl:=day;

      if a[t,i].t1>a[t,i].t2 then
        inc(day);
      time:=a[t,i].t2;

      a[t,i].u:=false;

      go(a[t,i].key);

      if fl then
        exit;

      dec(kol);
      time:=timel;
      day:=dayl;
      a[t,i].u:=true;
    end;

  for i:=1 to d[t] do
    if a[t,i].u then begin
      inc(kol);
      d1[kol]:=t;
      d2[kol]:=i;

      timel:=time;
      dayl:=day;

      inc(day);
      if a[t,i].t1>a[t,i].t2 then
        inc(day);
      time:=a[t,i].t2;

      a[t,i].u:=false;

      go(a[t,i].key);

      if fl then
        exit;

      dec(kol);
      time:=timel;
      day:=dayl;
      a[t,i].u:=true;
    end;

  u[t]:=false;
end;

procedure run;
  var i,j:int;
begin
  fillchar(d,sizeof(d),0);

  read(n,m);

  for i:=1 to n do
    setlength(a[i],1);

  for i:=1 to m do begin
    read(x,ch);
    readtime(t1);
    read(y,ch);
    readtime(t2);

    inc(d[x]);
    if d[x]>=length(a[x]) then
      setlength(a[x],length(a[x])*2);

    a[x,d[x]].key:=y;
    a[x,d[x]].t1:=t1;
    a[x,d[x]].t2:=t2;

    a[x,d[x]].u:=true;
    readln;
  end;

  ans:=0;

  fl:=true;
  while fl do begin
    for i:=1 to n do begin
      for j:=1 to n do
        u[j]:=false;
      kol:=0;
      day:=0;
      time:=0;

      fl:=false;
      go(i);

      if fl then
        break;
    end;
  end;
  if m=0 then
    write(ans)
  else
    write(-1);  
end;

procedure openfiles;
begin
  assign(input,inname);
  assign(output,outname);
  reset(input);
  rewrite(output);
end;

procedure closefiles;
begin
  close(input);
  close(output);
end;

Begin
  beg:=now;
  openfiles;
  run;
  closefiles;
End.
 