#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define inpfile "poly.in"
#define outfile "poly.out"

const int NMAX = 305;

//Global variables
bool a[NMAX][NMAX];
bool b[NMAX][NMAX];
int h1,w1,h2,w2;
int k;
int res;
//----------------

void Init()
{
	freopen(inpfile,"r",stdin);
	freopen(outfile,"w",stdout);
}

void Out()
{
	printf("%d\n",res);
	exit(0);
}

void Inp()
{
	int i,j;
	char ch;
	
	scanf("%d",&k);
	
	scanf("%d %d\n",&h1,&w1);
	for (i=1; i<=h1; i++) {
		for (j=1; j<=w1; j++) {
			scanf("%c",&ch);
			a[i][j] = (ch=='X');
		}
		scanf("\n");
	}

	scanf("%d %d\n",&h2,&w2);
	for (i=1; i<=h2; i++) {
		for (j=1; j<=w2; j++) {
			scanf("%c",&ch);
			b[i][j] = (ch=='X');
		}
		scanf("\n");
	}
}

void Solve()
{
	int i,j,x,y;
	bool ok;

	res=0;
	for (i=0; i<=h2*k - h1; i++)
		for (j=0; j<=w2*k - w1; j++) {
			ok=true;
			for (x=1; (x<=h1) && ok; x++)
				for (y=1; (y<=w1) && ok; y++)
					if (a[x][y] && !b[(x+i+k-1)/k][(y+j+k-1)/k]) {
						ok=false;
						break;
					}
			
			if (ok) res++;
		}
}

int main()
{
	Init();
	Inp();
	Solve();
	Out();
	return 0;
}
