{$apptype console}
{$q+,r+,n-,o+}

const cinfile = 'poly.in';
      coutfile = 'poly.out';

const nmax = 311;

type int = longint;
     tpoint = array[1..2] of int;
     tpoly = record
                 len, x, y : int;
                 a : array[1..nmax] of tpoint;
             end;

var a, b : array[1..nmax, 1..nmax] of byte;
    f, pat : tpoly;
    use : array[-nmax..nmax, -nmax..nmax] of int;
    n1, m1, n2, m2 : int;
    k, m, n : int;
    ans : int64;

procedure init;
var i, j : int;
    c : char;
begin
    fillchar(a, sizeof(a), 0);
    fillchar(b, sizeof(b), 0);
    read(k);
    readln(n1, m1);
    f.len:=0;
    pat.len:=0;
    m:=0;
    for i:=1 to n1 do begin
        for j:=1 to m1 do begin
            read(c);
            if (c = 'X') then begin
                inc(m);
                a[i, j]:=1;
                inc(f.len);
                f.a[f.len][1]:=i;
                f.a[f.len][2]:=j;
                if (f.len = 1) then begin
                    f.x:=i;
                    f.y:=j;
                end;              
            end;
        end;
        readln;
    end;
    readln(n2, m2);
    n:=0;
    for i:=1 to n2 do begin
        for j:=1 to m2 do begin
            read(c);
            if (c = 'X') then begin
                inc(n);
                b[i, j]:=1;
                inc(pat.len);
                pat.a[pat.len][1]:=i;
                pat.a[pat.len][2]:=j;
            end;
        end;
        readln;
    end;

    ans:=0;
end;

procedure solve1;
const dir : array[1..4, 1..2] of int = ((-1, -1), (-1, 1), (1, 1), (1, -1));
var i, j, up, oldup : int;
    c, cc : array[0..4] of int64;
    tmp : int64;
    siz : array[1..4, 1..2] of int;
begin
    tmp:=(k - n1 + 1)*(k - m1 + 1);
    inc(ans, tmp*n);

    cc[1]:=0;
    cc[2]:=0;
    for i:=1 to n2 do
        for j:=1 to m2 do begin
            if (b[i, j] + b[i, j + 1] = 2) then inc(cc[1]);
            if (b[i, j] + b[i + 1, j] = 2) then inc(cc[2]);
        end;
    tmp:=(m1 - 1)*(k - n1 + 1);
    inc(ans, tmp*cc[1]);
    tmp:=(n1 - 1)*(k - m1 + 1);
    inc(ans, tmp*cc[2]);

    fillchar(c, sizeof(c), 0);
    siz[1][1]:=n1;
    siz[1][2]:=m1;
    siz[2][1]:=n1;
    siz[2][2]:=1;
    siz[3][1]:=1;
    siz[3][2]:=1;
    siz[4][1]:=1;
    siz[4][2]:=m1;

    for j:=1 to 4 do begin
        i:=0;
        oldup:=nmax;
        repeat
            up:=0;
            while (a[siz[j][1] + dir[j][1]*i, siz[j][2] + dir[j][2]*up] = 0) and (up <= oldup) do
                inc(up);
            inc(c[j], up);
            inc(i);
            oldup:=up;
        until (up = 0);
    end;

    fillchar(cc, sizeof(cc), 0);
    for i:=1 to n2 do
        for j:=1 to m2 do
            if (b[i, j] + b[i + 1, j] + b[i, j + 1] + b[i + 1, j + 1] = 4) then begin
                for up:=0 to 4 do inc(cc[up]);
            end else if (b[i, j] + b[i + 1, j] + b[i, j + 1] + b[i + 1, j + 1] = 3) then begin
                if (b[i + 1, j + 1] = 0) then inc(cc[1]);
                if (b[i + 1, j] = 0) then inc(cc[2]);
                if (b[i, j + 1] = 0) then inc(cc[3]);
                if (b[i, j] = 0) then inc(cc[4]);
            end;
    for i:=1 to 4 do inc(ans, c[i]*cc[i]);
    tmp:=(n1*m1 - cc[1] - cc[2] - cc[3] - cc[4]);
    inc(ans, tmp*cc[0]);
end;

procedure convert(var x : int);
begin
    if (x < 0) then begin
        x:=-x - 1;
        x:=-(x div k);        
    end else begin
        x:=x div k;
    end;
end;

procedure solve2;
var i, j, t, tt : int;
    map : tpoly;
    p : tpoint;
    found : boolean;
begin
    fillchar(use, sizeof(use), 0);
    for i:=0 to k - 1 do
        for j:=0 to k - 1 do begin
            map.len:=1;
            map.a[1][1]:=0;
            map.a[1][2]:=0;
            use[0, 0]:=i + j*k + 1;
            for t:=1 to f.len do begin
                p[1]:=f.a[t][1] - f.x + i;
                p[2]:=f.a[t][2] - f.y + j;
                convert(p[1]);
                convert(p[2]);
                if (use[p[1], p[2]] <> i + j*k + 1) then begin
                    use[p[1], p[2]]:=i + j*k + 1;
                    inc(map.len);
                    map.a[map.len]:=p;
                end;
            end;

            for t:=1 to pat.len do begin
                found:=true;
                for tt:=1 to map.len do begin
                    p[1]:=pat.a[t][1] + map.a[tt][1];
                    p[2]:=pat.a[t][2] + map.a[tt][2];
                    if (p[1] >= 1) and (p[1] <= n1) and
                       (p[2] >= 1) and (p[2] <= m1)
                    then begin
                        if (b[p[1], p[2]] = 0) then begin
                            found:=false;
                            break;
                        end;
                    end else begin
                        found:=false;
                        break;
                    end;
                end;
                if (found) then inc(ans);
            end;
        end;
end;

procedure writeanswer;
begin
    write(ans);
end;

begin
    assign(input, cinfile); reset(input);
    assign(output, coutfile); rewrite(output);
    init;
    if (m <= k) then solve1 else solve2;
    writeanswer;
    close(input); close(output);
end.
