{$apptype console}
{$q+,r+,n-,o+}

const cinfile = 'poly.in';
      coutfile = 'poly.out';

const nmax = 311;

type int = longint;

var a, b : array[1..nmax, 1..nmax] of byte;
    sum  : array[0..nmax, 0..nmax] of int;
    n1, m1, n2, m2 : int;
    k, m, n : int;
    ans : int64;

procedure init;
var i, j : int;
    c : char;
begin
    fillchar(a, sizeof(a), 0);
    fillchar(b, sizeof(b), 0);
    read(k);
    readln(n1, m1);
    m:=0;
    for i:=1 to n1 do begin
        for j:=1 to m1 do begin
            read(c);
            if (c = 'X') then begin
                inc(m);
                a[i, j]:=1;
            end;
        end;
        readln;
    end;
    readln(n2, m2);
    n:=0;
    for i:=1 to n2 do begin
        for j:=1 to m2 do begin
            read(c);
            if (c = 'X') then begin
                inc(n);
                b[i, j]:=1;
            end;
        end;
        readln;
    end;

    ans:=0;
end;

procedure count_corners;
const dir : array[1..4, 1..2] of int = ((-1, -1), (-1, 1), (1, 1), (1, -1));
var i, j, up, oldup : int;
    c, cc : array[0..4] of int64;
    siz : array[1..4, 1..2] of int;
begin
    fillchar(c, sizeof(c), 0);
    siz[1][1]:=n1;
    siz[1][2]:=m1;
    siz[2][1]:=n1;
    siz[2][2]:=1;
    siz[3][1]:=1;
    siz[3][2]:=1;
    siz[4][1]:=1;
    siz[4][2]:=m1;

    for j:=1 to 4 do begin
        i:=0;
        oldup:=nmax;
        repeat
            up:=0;
            while (a[siz[j][1] + dir[j][1]*i, siz[j][2] + dir[j][2]*up] = 0) and (up <= oldup) do
                inc(up);
            inc(c[j], up);
            inc(i);
            oldup:=up;
        until (up = 0);
    end;

    fillchar(cc, sizeof(cc), 0);
    for i:=1 to n2 do
        for j:=1 to m2 do
            if (b[i, j] + b[i + 1, j] + b[i, j + 1] + b[i + 1, j + 1] = 4) then begin
                for up:=0 to 4 do inc(cc[up]);
            end else if (b[i, j] + b[i + 1, j] + b[i, j + 1] + b[i + 1, j + 1] = 3) then begin
                if (b[i + 1, j + 1] = 0) then inc(cc[1]);
                if (b[i + 1, j] = 0) then inc(cc[2]);
                if (b[i, j + 1] = 0) then inc(cc[3]);
                if (b[i, j] = 0) then inc(cc[4]);
            end;
    for i:=1 to 4 do inc(ans, c[i]*cc[i]);
end;

procedure count_rect;
var w, c : array[0..1, 0..1] of int;    
    i, j, ii, jj : int;
begin
    if (n1 mod k = 0) then begin
        w[0][0]:=n1 div k;
        c[0][0]:=1;
        if (k > 1) then w[0][1]:=n1 div k + 1 else w[0][1]:=0;
        c[0][1]:=k - 1;
    end else begin
        w[0][0]:=n1 div k + 1;
        c[0][0]:=w[0][0]*k - n1 + 1;
        if (n1 mod k > 1) then begin
            w[0][1]:=n1 div k + 2;
            c[0][1]:=n1 mod k - 1;
        end else begin
            w[0][1]:=0;
            c[0][1]:=0;
        end;
    end;
    if (m1 mod k = 0) then begin
        w[1][0]:=m1 div k;
        c[1][0]:=1;
        if (k > 1) then w[1][1]:=m1 div k + 1 else w[1][1]:=0;
        c[1][1]:=k - 1;
    end else begin
        w[1][0]:=m1 div k + 1;
        c[1][0]:=w[1][0]*k - m1 + 1;
        if (m1 mod k > 1) then begin
            w[1][1]:=m1 div k + 2;
            c[1][1]:=m1 mod k - 1;
        end else begin
            w[1][1]:=0;
            c[1][1]:=0;
        end;
    end;

    fillchar(sum, sizeof(sum), 0);
    for i:=1 to n do
        for j:=1 to n do
            sum[i, j]:=sum[i - 1, j] + sum[i, j - 1] - sum[i - 1, j - 1] + b[i, j];

    for i:=0 to 1 do
        for j:=0 to 1 do
            if (w[0][i] > 0) and (w[1][j] > 0) then begin
                for ii:=0 to n2 - 1 do
                    for jj:=0 to m2 - 1 do begin
                        if (sum[ii + w[0][i], jj + w[1][j]]
                            - sum[ii, jj + w[1][j]]
                            - sum[ii + w[0][i], jj]
                            + sum[ii, jj] = w[0][i]*w[1][j])
                        then begin
                            inc(ans, c[0][i]*c[1][j]);
                        end;                                                                       
                    end;                                  
            end;
end;

procedure writeanswer;
begin
    write(ans);
end;

begin
    assign(input, cinfile); reset(input);
    assign(output, coutfile); rewrite(output);
    init;
    count_corners;
    count_rect;
    writeanswer;
    close(input); close(output);
end.
