#include <iostream>

#define SMAX 300
#define KMAX 10000

#define ARMAX 10000

using namespace std;

bool small[SMAX][SMAX];
bool large[ARMAX][ARMAX];

int main()
{
	freopen("poly.in", "rt", stdin);
	freopen("poly.out", "wt", stdout);

	int k;
	scanf("%d", &k);
	int h1, w1;
	scanf("%d%d", &h1, &w1);
	for (int i = 0; i < h1; ++i)
		for (int j = 0; j < w1; ++j)
		{
			int c = getchar();
			while (c <= ' ') c = getchar();
			small[i][j] = (c == 'X');
		}
	
	int h2, w2;
	scanf("%d%d", &h2, &w2);

	for (int i = 0; i < h2; ++i)	
		for (int j = 0; j < w2; ++j)
		{
			int c = getchar();
			while (c <= ' ') c = getchar();
			for (int x = 0; x < k; ++x)				
				for (int y = 0; y < k; ++y)				
					large[i * k + x][j * k + y] = (c == 'X');
		}

	int ans = 0;
	for (int i = 0; i < k * h2 - h1 + 1; ++i)
		for (int j = 0; j < k * w2 - w1 + 1; ++j)
		{
			bool ok = true;
			for (int x = 0; x < h1; ++x)
			{
				if (!ok) break;
				for (int y = 0; y < w1; ++y)
					if (small[x][y] && !large[i + x][j + y])
					{
						ok = false;
						break;
					}
			}
			if (ok) ++ans;
		}
	printf("%d\n", ans);
	return 0;
}