{$APPTYPE CONSOLE}
program poly;

const
 taskid = 'poly';
 infile = taskid + '.in';
 outfile = taskid + '.out';
 maxn = 305;

type
 tpoly = array [0..maxn, 0..maxn] of boolean;

var
 k,ha,hb,wa,wb: integer;
 ans: int64;
 a,b: tpoly;

procedure init;
 begin
  assign(input, infile);
  assign(output, outfile);
  reset(input);
  rewrite(output);
 end;

procedure loadpoly(var a: tpoly; var h,w: integer);
 var i,j: integer;
     c: char;
 begin
  readln(h,w);
  dec(h); dec(w);
  for i := 0 to h do begin
   for j := 0 to w do begin
    read(c);
    a[i,j] := (c = 'X');
   end;
   readln;
  end;
 end;
 
procedure load;
 begin
  readln(k);
  loadpoly(a, ha, wa);
  loadpoly(b, hb, wb);
 end;

function tryit(u,v,uu,vv: integer): boolean;
 var i,j: integer;
 begin
  tryit := false;
  for i := 0 to ha do
   for j := 0 to hb do
    if a[i,j] and (not b[(i+uu) div k + u, (j+vv) div k + v]) then exit;
  tryit := true;
 end;

procedure solve;
 var i,j{,kh,kw},ii,jj,ci,cj: integer;
     //ok: boolean;
 begin
  load;
  {
  kh := k*(hb+1)-1;
  kw := k*(wb+1)-1;
  }
  ans := 0;

  {
  i := 0;
  while i <= kh-ha do begin
   j := 0;
   while j <= kw-wa do begin

    ok := true;

    for ii := 0 to ha do begin
     for jj := 0 to wa do
      if a[ii,jj] and (not b[(ii+i) div k, (jj+j) div k]) then begin
       ok := false;
       break;
      end;
     if not ok then break;
    end;


    if ok then inc(ans);

    inc(j);
   end;
   inc(i);
  end;
  }

  ci := k-ha;  if ci < 0 then ci := 0;
  cj := k-wa;  if cj < 0 then cj := 0;

  for i := 0 to hb do
   for j := 0 to wb do begin

    if b[i,j] then inc(ans, ci*cj);
    if (ci > 0) and (cj > 0) and (not b[i+1,j]) and (not b[i,j+1]) and (not b[i+1,j+1]) then continue;

    for ii := 0 to ci-1 do
     for jj := cj to k-1 do begin
      if tryit(i,j,ii,jj) then inc(ans);
     end;

    for ii := ci to k-1 do
     for jj := 0 to k-1 do begin
      if tryit(i,j,ii,jj) then inc(ans);
     end;

   end;

  write(ans);
 end;

begin
 init;
 solve;
end.