{$M 30000000,0,30000000}

type TField=record
               h,w,c:int64;
               f:array[0..600,0..600]of boolean;
            end;
     PField=^TField;

var k:int64;
    old,new:TField;
    fields:array[1..1000]of TField;
    fc:int64;
    ans:int64;

function EqF(a,b:PField):boolean;
var i,j,h,w:integer;
begin
   if a^.h>b^.h then h:=a^.h else h:=b^.h;
   if a^.w>b^.w then w:=a^.w else w:=b^.w;
   for i:=0 to h-1 do for j:=0 to w-1 do if a^.f[i,j]<>b^.f[i,j] then Exit(false);
   EqF:=true;
end;

procedure init;
var f:text;i,j:integer;c:char;
begin
   assign(f,'poly.in');
   reset(f);
   readln(f,k);
   readln(f,new.h,new.w);
   for i:=1 to new.h do
   begin
      for j:=1 to new.w do begin read(f,c);new.f[i-1,j-1]:=(c='X');end;
      readln(f);
   end;
   readln(f,old.h,old.w);
   for i:=1 to old.h do
   begin
      for j:=1 to old.w do begin read(f,c);old.f[i-1,j-1]:=(c='X');end;
      readln(f);
   end;
   close(f);
end;

procedure makefield(dx,dy:int64;m:int64);
var f:TField;i,j:integer;
begin
   fillchar(f,sizeof(f),0);
   for i:=0 to new.h-1 do for j:=0 to new.w-1 do
      f.f[(i+dx)div k,(j+dy)div k]:=f.f[(i+dx)div k,(j+dy)div k]or new.f[i,j];
   f.h:=new.h div k+2;
   f.w:=new.w div k+2;
   for i:=1 to fc do if EqF(@f,@Fields[i])then begin inc(Fields[i].c,m);exit;end;
   inc(fc);
   Fields[fc]:=f;
   Fields[fc].c:=m;
end;

procedure makefields;
var i,j:int64;
begin
   fc:=0;
//   for i:=0 to k-1 do for j:=0 to k-1 do makefield(i,j,1);
   i:=new.h mod k;
   j:=new.w mod k;
   if i=0 then i:=k;
   if j=0 then j:=k;
   makefield(0,0,(k-i+1)*(k-j+1));
   makefield(k-i+1,0,(i-1)*(k-j+1));
   makefield(0,k-j+1,(k-i+1)*(j-1));
   makefield(k-i+1,k-j+1,(i-1)*(j-1));
end;

function incl(f:PField):int64;
label 1;
var i,j,x,y:integer;good:boolean;r:int64;
begin
   r:=0;
   for x:=0 to old.h-1 do for y:=0 to old.w-1 do
   begin
      good:=true;
      for i:=0 to f^.h-1 do for j:=0 to f^.w-1 do
         if f^.f[i,j] and not old.f[x+i,y+j] then begin good:=false;goto 1;end;
      1:if good then r:=r+1;
   end;
   incl:=r;
end;

procedure solve;
var i:integer;
begin
   makefields;
   ans:=0;
   for i:=1 to fc do ans:=ans+Fields[i].c*Incl(@Fields[i]);
end;

procedure out;
var f:text;
begin
   assign(f,'poly.out');
   rewrite(f);
   write(f,ans);
   close(f);
end;

begin
   init;
   solve;
   out;
end.
