#include <fstream>

using namespace std;

int res;
int k;
int h1, w1, h2, w2;
int f1[300][300];
int f2[300][300];
int maxwru[300];
int maxwrd[300];
int maxwlu[300];
int maxwld[300];
int maxhur[300];
int maxhul[300];
int maxhdr[300];
int maxhdl[300];

int counth(int up, int x)
{
	if (up)
	{
		int i = 0;
		while (f1[i][x] == 0)
			i++;
		return h1 - i;
	}
	else
	{
		int i = h1 - 1;
		while (f1[i][x] == 0)
			i--;
		return i + 1;
	}
}

int countw(int right, int y)
{
	if (right)
	{
        int i = w1 - 1;
		while (f1[y][i] == 0)
			i--;
		return i + 1;
	}
	else
	{
		int i = 0;
		while (f1[y][i] == 0)
			i++;
		return w1 - i;
	}
}

void countall()
{
	int wrmax = -1;
	int wlmax = -1;
	for (int i = 0; i < h1; i++)
	{
		int wl = countw(0, i);
		int wr = countw(1, i);
		if (wl > wlmax)	wlmax = wl;
		if (wr > wrmax) wrmax = wr;
		maxwlu[i] = wlmax;
		maxwru[i] = wrmax;
	}
	wrmax = -1;
	wlmax = -1;
	for (int i = h1 - 1; i >= 0; i--)
	{
		int wl = countw(0, i);
		int wr = countw(1, i);
		if (wl > wlmax)	wlmax = wl;
		if (wr > wrmax) wrmax = wr;
		maxwld[i] = wlmax;
		maxwrd[i] = wrmax;
	}
	int humax = -1;
	int hdmax = -1;
	for (int i = 0; i < w1; i++)
	{
		int hu = counth(1, i);
		int hd = counth(0, i);
		if (hu > humax)	humax = hu;
		if (hd > hdmax) hdmax = hd;
		maxhul[i] = humax;
		maxhdl[i] = hdmax;
	}
	humax = -1;
	hdmax = -1;
	for (int i = w1 - 1; i >= 0; i--)
	{
		int hu = counth(1, i);
		int hd = counth(0, i);
		if (hu > humax)	humax = hu;
		if (hd > hdmax) hdmax = hd;
		maxhur[i] = humax;
		maxhdr[i] = hdmax;
	}
}


int main()
{
    ifstream fi;
	ofstream fo;

	res = 0;

	fi.open("poly.in");
	fi >> k >> h1 >> w1;
	for (int i = 0; i < h1; i++)
		for (int j = 0; j < w1; j++)
			f1[i][j] = 0;
	
	for (int i = 0; i < h1; i++)
		for (int j = 0; j < w1; j++)
		{
			char c;
			fi >> c;
			if (c == 'X')
				f1[i][j] = 1;
		}

	fi >> h2 >> w2;
	for (int i = 0; i < h2; i++)
		for (int j = 0; j < w2; j++)
			f2[i][j]= 0;
	for (int i = 0; i < h2; i++)
		for (int j = 0; j < w2; j++)
		{
			char c;
			fi >> c;
			if (c == 'X')
				f2[i][j] = 1;
		}

	fi.close();

//	countall();

	int kx, j, ky;
	int u;
	int lastx  = -1;
	int lastxk = -1;
	int lasty  = -1;
	int lastyk = -1;
	int lastu = -1;
	
	for (int i = 0; i < h2; i++)
		for (j = 0; j < w2; j++)
			for (kx = 0; kx < k; kx++)
				for (ky = 0; ky < k; ky++)
				{
					if (!kx || !ky || kx / k != lastx || (h1 - 1 + kx) / k != lastxk
						|| ky / k != lasty || (w1 - 1 + ky) / k != lastyk)
					{
						u = 0;
						for (int x = 0; x < h1; x++)
							for (int y = 0; y < w1; y++)
								if (!u && f1[x][y] && !f2[i + (x + kx) / k][j + (y + ky) / k])
									u = 1;
						lastx  = kx / k;
						lastxk = (h1 - 1 + kx) / k;
						lasty  = ky / k;
						lastyk = (w1 - 1 + ky) / k;
						lastu = u;
					}
					else
						u = lastu;
                    
					if (!u)
						res++;
				}


	fo.open("poly.out");
	fo << res;
	fo.close();       
        
	return 0;
}
