{$apptype console}
uses
 Math,Sysutils;
type
 pol=array[1..300,1..300] of boolean;
 poly=array[1..300] of record
                        x,y:smallint;
                       end;
var
 p1,p2:pol;
 pp1,pp2:poly;
 tab:array[1..300,1..300]of longint;
 tb:array[0..300,0..300] of longint;
 n1,n2,k,w1,w2,h1,h2:longint;
 ans:int64;
procedure GetPol(h,w:longint;var p:pol);
 var
  i,j:longint;
  ch:char;
 begin
  for i:=1 to h do begin
   for j:=1 to w do begin
    read(ch);
    if ch='X' then
     p[j,i]:=true;
   end;
   readln;
  end;
 end;
procedure Convert(var n:longint; p:pol; var pp:poly);
 var
  i,j:longint;
 begin
  n:=0;
  for i:=1 to 300 do
   for j:=1 to 300 do
    if p[i,j] then begin
     inc(n);
     pp[n].x:=i;
     pp[n].y:=j;
    end;
 end;

function count(p1:pol; n1,n2:longint; pp1,pp2:poly):int64;
 function Check(i,j:longint):boolean;
  var
   f:longint;
  begin
   for f:=1 to n2 do begin
    if (i+pp2[f].x-1>300)or(j+pp2[f].y-1>300)or(not(p1[i+pp2[f].x-1,j+pp2[f].y-1])) then begin
     result:=false;
     exit;
    end;
   end;
   result:=true;
  end;
 var
  ff:longint;
 begin
  result:=0;
  for ff:=1 to n1 do
   if Check(pp1[ff].x,pp1[ff].y) then
    inc(result);
 end;
procedure BuildTab;
 var
  i,j,kw,kh:longint;
 begin
  fillchar(tb,sizeof(tb),0);
  for j:=1 to h1 do
   for i:=1 to w1 do
    if p1[i,j] then
     tb[i,j]:=tb[i-1,j]+tb[i,j-1]-tb[i-1,j-1]+1
    else
     tb[i,j]:=tb[i-1,j]+tb[i,j-1]-tb[i-1,j-1];
  for j:=1 to h1 do
   for i:=1 to w1 do begin
    kw:=min(i+k-1,w1);
    kh:=min(j+k-1,h1);
    tab[i,j]:=tb[kw,kh]+tb[i-1,j-1]-tb[i-1,kh]-tb[kw,j-1];
   end;
 end;
procedure Solve;
 var
  i,j,ii,jj,n3:longint;
  mult,tmp,mx,my:int64;
  pp3:poly;
 begin
  ans:=0;
  tmp:=1;
  if (w1<k) then
   mx:=(k-w1+1)
  else
   mx:=1;
  if (h1<k) then
   my:=(k-h1+1)
  else
   my:=1;
  for i:=1 to min(k,w1) do
   for j:=1 to min(k,h1) do begin
     n3:=0;
    if tb[i-1,j-1]>0 then begin
     inc(n3);
     pp3[n3].x:=1;
     pp3[n3].y:=1;
    end;
    ii:=i;
    while ii<=w1 do begin
     if tb[min(w1,ii+k-1),j-1]-tb[ii-1,j-1]>0 then begin
      inc(n3);
      if i>1 then
       pp3[n3].x:=((ii-i) div k)+2
      else
       pp3[n3].x:=((ii-i) div k)+1;
      pp3[n3].y:=1;
     end;
     ii:=ii+k;
    end;
    jj:=i;
    while jj<=h1 do begin
     if tb[i-1,min(h1,jj+k-1)]-tb[i-1,jj-1]>0 then begin
      inc(n3);
      pp3[n3].x:=1;
      if j>1 then
       pp3[n3].y:=((jj-j) div k)+2
      else
       pp3[n3].y:=((jj-j) div k)+1;
     end;
     jj:=jj+k;
    end;
    ii:=i;
    while ii<=w1 do begin
     jj:=j;
     while jj<=h1 do begin
      if tab[ii,jj]>0 then begin
       inc(n3);
       if ((ii-1) mod k)=0 then
        pp3[n3].x:=((ii-1)div k)+1
       else
        pp3[n3].x:=((ii-1) div k)+2;
       if ((jj-1) mod k)=0 then
        pp3[n3].y:=((jj-1)div k)+1
       else
        pp3[n3].y:=((jj-1) div k)+2
      end;
      jj:=jj+k;
     end;
     ii:=ii+k;
    end;
    tmp:=count(p2,n2,n3,pp2,pp3);
    if i=1 then
     tmp:=tmp*mx;
    if j=1 then
     tmp:=tmp*my;
    ans:=ans+tmp;
   end;
 end;
begin
 fillchar(p1,sizeof(p1),0);
 fillchar(p2,sizeof(p2),0);
 fillchar(tab,sizeof(tab),0);
 reset(input,'poly.in');
 rewrite(output,'poly.out');
 read(k);
 readln(h1,w1);
 Getpol(h1,w1,p1);
 readln(h2,w2);
 if (h2=0)or(w2=0) then begin
  writeln(0);
  close(input);
  close(output);
  exit;
 end;
 Getpol(h2,w2,p2);
 if n2=0 then begin
  writeln(0);
  close(input);
  close(output);
  exit;
 end;
 convert(n1,p1,pp1);
 convert(n2,p2,pp2);
 buildTab;
 solve;
 writeln(ans);
 close(input);
 close(output);
end.
