program P5;

{$A8,B-,C+,D-,E-,F-,G+,H+,I-,J-,K-,L-,M-,N+,O+,P+,Q-,R-,S-,T-,U-,V+,W-,X+,Y+,Z1}
//{$A8,B-,C+,D+,E-,F-,G+,H+,I+,J-,K-,L+,M-,N+,O+,P+,Q+,R+,S-,T-,U-,V+,W-,X+,Y+,Z1}
{$MINSTACKSIZE $00004000}
{$MAXSTACKSIZE $00100000}
{$IMAGEBASE $00400000}
{$APPTYPE CONSOLE}

uses
  SysUtils;

type
  int = integer;
  bool = boolean;

var k, h, w, h0, w0: int;
    a, a0: array[0..301, 0..301] of bool;

function C_rb: int;
var prev, i, j: int;
begin
  Result:=0;
  prev:=w;
  for i:=1 to h do
  begin
    j:=1;
    while (j<=prev) and not a[i, j] do Inc(j);
    prev:=j-1;
    Inc(Result, prev);
  end;
end;

function C_rt: int;
var prev, i, j: int;
begin
  Result:=0;
  prev:=w;
  for i:=h downto 1 do
  begin
    j:=1;
    while (j<=prev) and not a[i, j] do Inc(j);
    prev:=j-1;
    Inc(Result, prev);
  end;
end;

function C_lb: int;
var prev, i, j: int;
begin
  Result:=0;
  prev:=1;
  for i:=1 to h do
  begin
    j:=w;
    while (j>=prev) and not a[i, j] do Dec(j);
    prev:=j+1;
    Inc(Result, w-j);
  end;
end;

function C_lt: int;
var prev, i, j: int;
begin
  Result:=0;
  prev:=1;
  for i:=h downto 1 do
  begin
    j:=w;
    while (j>=prev) and not a[i, j] do Dec(j);
    prev:=j+1;
    Inc(Result, w-j);
  end;
end;

procedure Outp(x: int);
begin
  Assign(output, 'poly.out');
  Rewrite(output);
  WriteLn(x);
  Close(output);
  halt;
end;

procedure GoodSol;
var c1, c2h, c2w, c4, lt, lb, rt, rb, i, j, cnt: int;
begin
  c1:=(k-h+1)*(k-w+1);
  c2h:=(h-1)*(k-w+1);
  c2w:=(w-1)*(k-h+1);
  c4:=(w-2)*(h-2);
  lt:=C_lt;
  lb:=C_lb;
  rt:=C_rt;
  rb:=C_rb;
  cnt:=0;
  for i:=1 to h0 do
    for j:=1 to w0 do
      if a0[i, j] then 
      begin
        Inc(cnt, c1);
        if a0[i, j+1] then
        begin
          Inc(cnt, c2w);
          if a0[i+1, j] then
          begin
            Inc(cnt, lt);
            if a0[i+1, j+1] then
              Inc(cnt, c4);
          end;
          if a0[i+1, j+1] then
            Inc(cnt, rt);
        end;
        if a0[i+1, j] then
        begin
          Inc(cnt, c2h);
          if a0[i+1, j+1] then
            Inc(cnt, lb);
          if a0[i+1, j-1] then
            Inc(cnt, rb);
        end;
      end;
  Outp(cnt);
end;

procedure BadSol;
var i, j, i0, bm, cnt: int;
    bi, bj: array[1..300] of int;
begin
  bm:=0;
  for i:=1 to h do
    for j:=1 to w do
      if a[i, j] then
      begin
        Inc(bm);
        bi[bm]:=i;
        bj[bm]:=j;
      end;
  cnt:=0;
  for i:=0 to h0*k-h do
    for j:=0 to w0*k-w do
    begin
      Inc(cnt);
      for i0:=1 to bm do
        if not a0[( (i+bi[i0]+1) div k), ( (j+bj[i0]+1) div k)] then
        begin
          Dec(cnt);
          break;
        end;
    end;
  Outp(cnt);
end;

var i, j: int;
    c: char;

begin
  Assign(input, 'poly.in');
  Reset(input);
  ReadLn(k);
  ReadLn(h, w);
  for i:=1 to h do
  begin
    for j:=1 to w do
    begin
      Read(c);
      a[i, j]:=(c='X');
    end;
    ReadLn;
  end;
  ReadLn(h0, w0);
  for i:=1 to h0 do
  begin
    for j:=1 to w0 do
    begin
      Read(c);
      a0[i, j]:=(c='X');
    end;
    ReadLn;
  end;
  Close(input);
  if (w<=k) and (h<=k) then
    GoodSol
  else
    BadSol;
end.
