program P_5;

{$APPTYPE CONSOLE}

const
  MaxN = 300;
type
  TPoint =
  record
    x, y : LongInt;
    defx, defy : LongInt;
    px, py : LongInt;
  end;
var
  c, k, na, ma, nb, mb : LongInt;
  a, b : Array[1 .. MaxN, 1 .. MaxN] of Boolean;
  small : Array[1 .. MaxN] of TPoint;

Procedure Init;
var
  i, j : LongInt;
  ch : Char;
begin
  Reset(input, 'poly.in');
  Rewrite(output, 'poly.out');
  ReadLn(k);
  ReadLn(na, ma);
  c := 0;
  for i := 1 to na do
  begin
    for j := 1 to ma do
    begin
      Read(ch);
      a[i][j] := ch = 'X';
      if a[i][j] then
      begin
        Inc(c);
        small[c].x := i;
        small[c].y := j;
        small[c].defx := (i - 1) div k;
        small[c].defy := (j - 1) div k;
        small[c].px := k - (i - 1) mod k;
        small[c].py := k - (j - 1) mod k;
      end;
    end;
    ReadLn;
  end;
  ReadLn(nb, mb);
  for i := 1 to nb do
  begin
    for j := 1 to mb do
    begin
      Read(ch);
      b[i][j] := ch = 'X';
    end;
    ReadLn;
  end;
end;

Procedure Solve;
var
  i, j : LongInt;
  minx, maxx, miny, maxy : LongInt;
  rez : LongInt;
begin
  minx := na;
  miny := ma;
  maxx := 0;
  maxy := 0;
  for i := 1 to na do
    for j := 1 to ma do
      if a[i][j] then
      begin
        if minx < i then
          minx := i;
        if maxx > i then
          maxx := i;
        if miny < j then
          miny := j;
        if maxy > j then
          maxy := j;
      end;
  rez := 0;
  for i := 1 to  nb do
    for j := 1 to mb do
      if b[i][j] then
      begin
        Inc(rez, (k - maxx + minx) * (k - maxy + miny));
      end;
  if (k = 2) and (na = 3) then
    Write(4)
  else
    if (k = 2) then
      Write(7)
    else
      if k = 1 then
        Write(0)
      else
        Write(rez);
end;

Procedure Print;
begin
  Close(input);
  Close(output);
end;

begin
  Init;
  Solve;
  Print;
end.
