{$apptype console}
{$i-,q-,r-}

const id = 'poly';
      infile = id + '.in';
      outfile = id + '.out';

const maxn = 300;
      maxk = 10000;
      maxlen = 1000;

type int = longint;
     TPoint = record
                x, y : int;
              end;
     long = array [0..maxlen] of int;
     Tpoly = array [0..maxn+1, 0..maxn+1] of byte;

var p1, p2 : Tpoly;
    pp1, pp2 : array [1..maxn] of TPoint;
    n1, m1, n2, m2, k, w1, w2 : int;
    a : long;

procedure Init;
var
  ch : char;
  i, j : int;
begin
  readln(k);
  readln(n1, m1);
  fillchar(p1, sizeof(p1), 0); w1 := 0;
  for i := 1 to n1 do begin
    for j := 1 to m1 do begin
      read(ch);
      if ch = 'X' then begin
        p1[i, j] := 1;
        inc(w1);
        pp1[w1].x := i; pp1[w1].y := j;
      end;
    end;
    readln;
  end;
  readln(n2, m2);
  fillchar(p2, sizeof(p2), 0); w2 := 0;
  for i := 1 to n2 do begin
    for j := 1 to m2 do begin
      read(ch);
      if ch = 'X' then begin
        p2[i, j] := 1;
        inc(w2);
        pp2[w2].x := i; pp2[w2].y := j;        
      end;
    end;
    readln;
  end;

  if (n2 * k < n1) or (m2 * k < m1) then begin
    writeln(0);
    close(output);
    halt(0);
  end;
end;

procedure Add(var a : long; x : int64);
var
  i : int;
  t : int64;
begin
  t := x;
  for i := 1 to a[0] do begin
    t := t + a[i];
    a[i] := t mod 10;
    t := t div 10;
  end;
  while t<> 0 do begin
    inc(a[0]);
    a[a[0]] := t mod 10;
    t := t div 10;
  end;
end;

procedure Pram(x, y : int);
var
  ii, jj, i, j, l : int;
  ok : boolean;
  t : int64;
begin
{  if p2[x, y+1] = 1 then begin
    t := (n1 - 1) * (k - m1 + 1);
    Add(a, t);
  end;
  if p2[x+1, y] = 1 then begin
    t := (m1 - 1) * (k - n1 + 1);
    Add(a, t);
  end;}
  for ii := 1 to k do
    for jj := 1 to k do begin
      ok := true;
      for l := 1 to w1 do begin
        i := (pp1[l].x+ii-1) div k;
        if (pp1[l].x+ii-1) mod k <> 0 then inc(i);
        j := (pp1[l].y+jj-1) div k;
        if (pp1[l].y+jj-1) mod k <> 0 then inc(j);
        if (p2[x+i-1, y+j-1] <> 1) or (x+i-1 > n2) or (y+j-1 > m2) then begin
          ok := false;
          break;
        end;
      end;
      if ok then Add(a, 1);
    end;
end;

procedure Find(x, y : int);
var
  i, j, ii, jj, l : int;
  ok : boolean;
begin
  for ii := 1 to k do
    for jj := 1 to k do begin
      ok := true;
      for l := 1 to w1 do begin
        i := (pp1[l].x+ii-1) div k;
        if (pp1[l].x+ii-1) mod k <> 0 then inc(i);
        j := (pp1[l].y+jj-1) div k;
        if (pp1[l].y+jj-1) mod k <> 0 then inc(j);
        if (p2[x+i-1, y+j-1] <> 1) or (x+i-1 > n2) or (y+j-1 > m2) then begin
          ok := false;
          break;
        end;
      end;
      if ok then Add(a, 1);
    end;
end;

procedure WriteAns(a : long);
var
  i : int;
begin
  for i := a[0] downto 1 do
    write(a[i]);
  close(output);
  halt(0);
end;

procedure Solve;
var
  i, j : int;
  t : int64;
begin
  fillchar(a, sizeof(a), 0);
  a[0] := 1;
  if (k >= n1) and (k >= m1) then begin
{    t := w2 * (k - n1 + 1) * (k - m1 + 1);
    Add(a, t);}
    for i := 1 to w2 do
      Pram(pp2[i].x, pp2[i].y);
    WriteAns(a);
  end;
  for i := 1 to n2 do
    for j := 1 to m2 do
      Find(i, j);
  WriteAns(a);
end;

BEGIN
  assign(input, infile); reset(input);
  assign(output, outfile); rewrite(output);
  Init;
  Solve;
  close(input); close(output);
END.