{$APPTYPE CONSOLE}
type integer = longint;
type rect = record	
	x1, y1, x2, y2 : integer;
end;
var h1, w1, h2, w2, k : integer;
	ma1, ma2 : array[1..301, 1..301] of char;

function GetGC : char;
var c : char;
begin
	read(c);
	while (c <> 'X') and (c <> '.') do read(c);
	GetGC := c;
end;

procedure Load;
var i, j : integer;
begin
	read(k, h1, w1);
	for i := 1 to h1 do begin
		for j := 1 to w1 do begin
			ma1[i, j] := GetGC;
		end;
	end;
	read(h2, w2);
	for i := 1 to h2 do begin
		for j := 1 to w2 do begin
			ma2[i, j] := GetGC;
		end;
	end;
end;

var cell1, cell2 : array [1..301, 1..2] of integer;
	nr, nc1, nc2 : integer;
	rct : array [1..100000] of rect;
	rc : array [1..100000] of integer;

procedure AddRect(x1, y1, x2, y2, cl : integer);
begin
	inc(nr);
	rct[nr].x1 := x1;
	rct[nr].y1 := y1;
	rct[nr].x2 := x2;
	rct[nr].y2 := y2;
	rc[nr] := cl;
end;

var cre, cre2 : array [1..100000]of rect;
	ncre, nncre : integer;

function max(a, b : integer) : integer;
begin
	if a > b then max := a
	else max := b;
end;

function min(a, b : integer) : integer;
begin
	if a < b then min := a
	else min := b;
end;

function IntRect(a, b : rect) : rect;
var c : rect;
begin
	c.x1 := max(a.x1, b.x1);
	c.x2 := min(a.x2, b.x2);
	c.y1 := max(a.y1, b.y1);
	c.y2 := min(a.y2, b.y2);
    IntRect := c;
end;

var kr : array[1..100000] of byte;

procedure UpdateRects;
var i, j : integer;
begin
	fillchar(kr, sizeof(kr), 0);
	if nncre < 2000 then begin
		for i := 1 to nncre do begin
			if kr[i] = 1 then continue;
			for j := 1 to nncre do begin
				if kr[j] = 1 then continue;
				if i = j then continue;
				if (cre2[i].x1 = cre2[j].x1) and (cre2[i].x2 = cre2[j].x2) and (cre2[i].y2 + 1 = cre2[j].y1) then begin
					cre2[i].y2 := cre2[j].y2;
					kr[j] := 1;
					continue;
				end;
				if (cre2[i].y1 = cre2[j].y1) and (cre2[i].y2 = cre2[j].y2) and (cre2[i].x2 + 1 = cre2[j].x1) then begin
					cre2[i].x2 := cre2[j].x2;
					kr[j] := 1;
					continue;
				end;
			end;
		end;
	end;
	ncre := 0;
	for i := 1 to nncre do begin
		if kr[i] = 0 then begin
			inc(ncre);
			cre[ncre] := cre2[i];
		end;
	end;
end;

procedure Solve;
var l, r, i, j, x1, y1, x2, y2 : integer;
	a : rect;
    ans, lx, ly : int64;
begin
	nc1 := 0;
	for i := 1 to h1 do begin
		for j := 1 to w1 do begin
			if ma1[i, j] = 'X' then begin
				inc(nc1);
				cell1[nc1, 1] := i;
				cell1[nc1, 2] := j;
			end;
		end;
	end;
	nc2 := 0;
	for i := 1 to h2 do begin
		for j := 1 to w2 do begin
			if ma2[i, j] = 'X' then begin
				inc(nc2);
				cell2[nc2, 1] := i;
				cell2[nc2, 2] := j;
			end;
		end;
	end;
	if (nc1 = 0) or (nc2 = 0) then begin
		write('0');
		exit;
	end;
	nr := 0;
	for i := 1 to nc1 do begin
		for j := 1 to nc2 do begin
			y1 := ((cell2[j, 1] - 1) * k) + 1;
			x1 := ((cell2[j, 2] - 1) * k) + 1;
			dec(y1, cell1[i, 1]);
			dec(x1, cell1[i, 2]);
			y2 := y1 + k - 1;
			x2 := x1 + k - 1;
			AddRect(x1, y1, x2, y2, i);
		end;
	end;
	ncre := 1;
	cre[1].x1 := -1000000000;
	cre[1].y1 := -1000000000;
	cre[1].x2 := 1000000000;
	cre[1].y2 := 1000000000;
	l := 1;
	while l <= nr do begin
		r := l;
		while (r <= nr) and (rc[r] = rc[l]) do inc(r);
		dec(r);
		nncre := 0;
		for i := l to r do begin
			for j := 1 to ncre do begin
				a := IntRect(rct[i], cre[j]);
				if (a.x1 > a.x2) then continue;
				if (a.y1 > a.y2) then continue;
				inc(nncre);
				cre2[nncre] := a;
			end;
		end;
        UpdateRects;
		l := r + 1;
	end;
    ans := 0;
    for i := 1 to ncre do begin
    	lx := cre[i].x2 - cre[i].x1 + 1;
		ly := cre[i].y2 - cre[i].y1 + 1;
        ans := ans + lx * ly;
    end;
    write(ans);
end;

begin
	assign(input, 'poly.in');
	assign(output, 'poly.out');
	reset(input);
	rewrite(output);
	Load;
	Solve;
	close(input);
	close(output);
end.            