Program PolyX;
{$APPTYPE CONSOLE}
Const
  InpPath='poly.in';
  OutPath='poly.out';
Var
  K                   :Integer;
  Ho, Wo, Hn, Wn      :Integer;
  Count               :Integer;
  PolyN, PolyO, Poly  :Array[1..1000, 1..1000] Of Boolean;

Procedure ReadData;
Var
  InpFile             :Text;
  i, j                :Integer;
  Ch                  :Char;
Begin
  FillChar(PolyN, SizeOf(PolyN), False);
  FillChar(PolyO, SizeOf(PolyO), False);
  Count:=0;
  Assign(InpFile, InpPath);
  Reset(InpFile);
  ReadLn(InpFile, K);
  ReadLn(InpFile, Hn, Wn);
  For i:=1 To Hn Do
  Begin
    For j:=1 To Wn Do
    Begin
      Read(InpFile, Ch);
      If Ch='X' Then PolyN[K+i-1, K+j-1]:=True;
    End;
    ReadLn(InpFile);
  End;
  ReadLn(InpFile, Ho, Wo);
  For i:=1 To Ho Do
  Begin
    For j:=1 To Wo Do
    Begin
      Read(InpFile, Ch);
      If Ch='X' Then PolyO[i, j]:=True;
    End;
    ReadLn(InpFile);
  End;
{  For i:=1 To K+Hn-1 Do
  Begin
    For j:=1 To K+Wn-1 Do
      If PolyN[i, j] Then Write(1)
      Else Write(0);
    WriteLn;
  End;
  ReadLn;}
  Close(InpFile);
End;

Procedure Solve;
Var
  i, j, x, y, z, rx, ry, maxRx, f   :Integer;
  Ok                                :Boolean;
Begin
  Count:=0;
  For i:=1 To K Do
    For j:=1 To K Do
    Begin
      FillChar(Poly ,SizeOf(Poly), False);
      rx:=0;
      ry:=0;
      maxRx:=0;
      For y:=K To K+Hn-1 Do
      Begin
        ry:=((y-i) Div K)+1;
        For x:=K To K+Wn-1 Do
        Begin
          rx:=((x-j) Div K)+1;
          If PolyN[y, x] Then Poly[ry, rx]:=True;
        End;
        If(maxRx=0) Or (maxRx<rx) Then maxRx:=rx;
        rx:=0;
      End;

{      For y:=1 To ry Do
      Begin
        For x:=1 To maxRx Do
          If Poly[y, x] Then Write(1)
            Else Write(0);
        WriteLn;
      End;
      ReadLn;}
      rx:=maxRx;
      For y:=0 To (Ho-ry) Do
        For x:=0 To (Wo-rx) Do
        Begin
          Ok:=False;
          For f:=1 To ry Do
          Begin
            For z:=1 To rx Do
              If Poly[f, z] And Not PolyO[f+y, z+x] Then
              Begin
                Ok:=True;
                Break;
              End;
              If Ok Then Break;
          End;
          If Not Ok Then Inc(Count);
        End;
    End;
End;

Procedure WriteData;
Var
  OutFile                     :Text;
Begin
  Assign(OutFile, OutPath);
  ReWrite(OutFile);
  WriteLn(OutFile, Count);
  Close(OutFile);
End;

Begin
  ReadData;
  Solve;
  WriteData;
End.
