#include <fstream>
using namespace std;

bool map1 [301][301];
bool map2 [301][301];
int w1, h1, w2, h2;
int k;

int main ()
{
   ifstream fin ( "poly.in" );
   ofstream fout ( "poly.out" );

   fin >> k;
   fin >> h1 >> w1;
   for ( int y = 0; y < h1; y++ )
   {
      char ln [357];
      fin >> ln;
      for ( int x = 0; x < w1; x++ )
         map1 [x][y] = ( ln [x] == 'X' );
   }
   fin >> h2 >> w2;
   for ( int y = 0; y < h2; y++ )
   {
      char ln [357];
      fin >> ln;
      for ( int x = 0; x < w2; x++ )
         map2 [x][y] = ( ln [x] == 'X' );
   }

   int num = 0;
   h2 *= k;
   w2 *= k;
   for ( int y = 0; y < h2; y++ )
   {
      for ( int x = 0; x < w2; x++ )
      {
         bool ok = true;
         for ( int y1 = 0; y1 < h1 && ok; y1++ )
         {
            for ( int x1 = 0; x1 < w1 && ok; x1++ )
            {
               if ( map1 [x1][y1] && ! ( map2 [(x1+x)/k][(y1+y)/k] ) )
                  ok = false;
            }
         }
         if ( ok )
            num++;
      }
   }

   fout << num;

   return 0;
}
