{$APPTYPE CONSOLE}
const
  MaxN = 3000;
  MaxM = 300;
type
  MyArray = array[1..MaxN, 1..MaxN] of boolean;
  MyArray2 = array[1..MaxM, 1..MaxM] of boolean;
var
  A : MyArray;
  B : MyArray2;
  H1, W1, H2, W2 : longint;
  K : longint;
  res : longint;

procedure Init;
var
  i, j, p, q : longint;
  ch : char;
begin
  fillchar(A, sizeof(A), false);
  fillchar(B, sizeof(B), false);
  read(K);
  readln(H1, W1);
  for i := 1 to H1 do
   begin
    for j := 1 to W1 do
     begin
      read(ch);
      if ch = 'X' then
        for p := ((i - 1) * K + 1) to (i * K) do
          for q := ((j - 1) * K + 1) to (j * K) do
            A[p, q] := true;
     end;
    readln;
   end;
  readln(H2, W2);
  for i := 1 to H2 do
   begin
    for j := 1 to W2 do
     begin
      read(ch);
      if ch = 'X' then
        B[i, j] := true;
     end;
    readln;
   end;
end;

procedure Solve;
var
  i, j, p, q : longint;
  yes : boolean;
begin
  res := 0;
  for i := 1 to H1 * K do
    for j := 1 to W1 * K do
     begin
      yes := true;
      for p := 1 to H2 do
        for q := 1 to W2 do
          if B[p, q] = true then
            if A[i + p - 1, j + q - 1] = false then
              yes := false;
      if yes = true then
        inc(res);
     end;
end;

procedure Print;
begin
  write(res);
end;

begin
  assign(input, 'poly.in');
  reset(input);
  Init;
  close(input);
  Solve;
  assign(output, 'poly.out');
  rewrite(output);
  Print;
  close(output);
end.
 