//{$A8,B-,C+,D+,E-,F-,G+,H+,I+,J-,K-,L+,M-,N+,O-,P+,Q+,R+,S+,T-,U-,V+,W-,X+,Y+,Z1}
{$A8,B-,C+,D-,E-,F-,G+,H+,I-,J-,K-,L-,M-,N+,O+,P+,Q-,R-,S-,T-,U-,V+,W-,X+,Y+,Z1}

program Problem5;

{$APPTYPE CONSOLE}

uses
  SysUtils, Math;

const inname='poly.in';
      outname='poly.out';
      maxn=650;
      maxk=10100;

type int=longint;
     real=extended;
     bool=boolean;
     tpole=array[-10..maxn,-10..maxn] of int;

var k,n1,m1,n2,m2:int;
    dk:array[-10..100*maxk] of int;
    a,b,pr:tpole;
    ch:char;
    ans:int64;

function find(x,y:int):int64;
  var i,j,i1,j1,x2,y2,g1,g2:int;
      fl:bool;
begin
  for i:=1 to dk[n2] + 2 do
    for j:=1 to dk[m2] + 2 do
      pr[i,j]:=0;

  g1:=1;
  g2:=1;

  for i:=1 to n2 do
    for j:=1 to m2 do
      if b[i,j]=1 then begin
        x2:=x+i-1;
        y2:=y+j-1;
        pr[dk[x2+k-1],dk[y2+k-1]]:=1;

        if dk[x2+k-1]>g1 then
          g1:=dk[x2+k-1];
        if dk[y2+k-1]>g2 then
          g2:=dk[y2+k-1];
      end;

  result:=0;
  for i:=1 to n1 do
    for j:=1 to m1 do begin
      fl:=true;
      for i1:=1 to g1 do begin
        for j1:=1 to g2 do
          if pr[i1,j1]>a[i+i1-1,j+j1-1] then begin
            fl:=false;
            break;
          end;
        if not fl then
          break;
      end;

      if fl then
        inc(result);
    end;
end;

procedure run;
  var i,j:int;
begin
  fillchar(a,sizeof(a),0);
  fillchar(b,sizeof(b),0);

  readln(k,n2,m2);
  for i:=1 to n2 do begin
    for j:=1 to m2 do begin
      read(ch);
      if ch='X' then
        b[i,j]:=1;
    end;
    readln;
  end;

  for i:=1 to 100*maxk do
    dk[i]:=i div k;

  readln(n1,m1);
  for i:=1 to n1 do begin
    for j:=1 to m1 do begin
      read(ch);
      if ch='X' then
        a[i,j]:=1;
    end;
    readln;
  end;

  fillchar(pr,sizeof(pr),0);

  ans:=0;

  if (n2<=k) and (m2<=k) then begin
    inc(ans,find(1,1)*int64(k-n2+1)*int64(k-m2+1));
  end;

  for i:=1 to k do
    for j:=max(1,k-m2+2) to k do
      inc(ans,find(i,j));

  for i:=max(1,k-n2+2) to k do
    for j:=1 to k-m2+1 do
      inc(ans,find(i,j));

  writeln(ans);
  {
  ans:=0;

  for i:=1 to k do
    for j:=1 to k do
      inc(ans,find(i,j));

  write(ans);
  }
end;

procedure openfiles;
begin
  assign(input,inname);
  assign(output,outname);
  reset(input);
  rewrite(output);
end;

procedure closefiles;
begin
  close(input);
  close(output);
end;

Begin
  openfiles;
  run;
  closefiles;
End.
 