program reform;

{$APPTYPE CONSOLE}

uses
  SysUtils;

type tpoin = record
      x,y:integer;
    end;

var n,nn,nnn,ntr,i,j,k:integer;
    ver,vern,ver2:array[1..20]of tpoin;
    diags:array[1..50,1..2]of tpoin;

function leng(p1,p2:tpoin):real;
begin
  leng:=sqrt(sqr(p2.x-p1.x)+sqr(p2.y-p1.y));
end;

function cos(p1,p2,p3:tpoin):integer;
begin
  cos:=(p2.x-p1.x)*(p3.y-p1.y)-(p3.x-p1.x)*(p2.y-p1.y);
end;

function scal(p1,p2,p3:tpoin):integer;
begin
  scal:=(p2.x-p1.x)*(p2.y-p1.y)+(p3.x-p1.x)*(p3.y-p1.y);
end;

function findfir:integer;
var i:integer;
    f:boolean;
begin
  f:=false;
  if cos(vern[nn],vern[1],vern[2])<0 then begin
      f:=true;
      findfir:=1;
      exit;
    end;
  if not f then
    for i:=1 to nn-2 do
      if(cos(vern[i],vern[i+1],vern[i+2])<0)and(not f)then begin
        f:=true;
        findfir:=i+1;
        exit;
      end;
  if not f then
    if cos(vern[nn-1],vern[nn],vern[1])<0 then begin
      f:=true;
      findfir:=nn;
      exit;
    end;
end;

function isvyp(main:boolean):boolean;
var i,j:integer;
    b:boolean;
begin
if main then begin
  b:=true;
  for i:=1 to n do begin
    for j:=i+2 to n do
      if cos(ver[i],ver[j-1],ver[j])<0 then b:=false;
    if i<>1 then
      if cos(ver[i],ver[n],ver[1])<0 then b:=false;
    for j:=2 to i-1 do
      if cos(ver[i],ver[j-1],ver[j])<0 then b:=false;
  end;
  isvyp:=b;
end else begin
  b:=true;
  if cos(vern[nn],vern[1],vern[2])<0 then b:=false;
  for i:=1 to nn-2 do
    if cos(vern[i],vern[i+1],vern[i+2])<0 then b:=false;
  if cos(vern[nn-1],vern[nn],vern[1])<0 then b:=false;
  isvyp:=b;
end;
end;

function havelin:boolean;
var b:boolean;
    i:integer;
begin
  b:=false;
  if cos(vern[nn],vern[1],vern[2])=0 then b:=true;
  for i:=2 to nn-1 do
    if cos(vern[i-1],vern[i],vern[i+1])=0 then b:=true;
  if cos(vern[nn-1],vern[nn],vern[1])=0 then b:=true;
  havelin:=b;
end;

procedure findn;
var i:integer;
begin
  nnn:=0;
  if cos(vern[nn],vern[1],vern[2])<>0 then begin
    inc(nnn);
    ver2[nnn]:=vern[1];
  end;
  for i:=2 to nn-1 do
    if cos(vern[i-1],vern[i],vern[i+1])<>0 then begin
      inc(nnn);
      ver2[nnn]:=vern[i];
    end;
  if cos(vern[nn-1],vern[nn],vern[1])<>0 then begin
    inc(nnn);
    ver2[nnn]:=vern[nn];
  end;
end;

procedure simplifying;
var i,j:integer;
begin
  while cos(vern[nn],vern[1],vern[2])=0 do begin
    for i:=1 to nn-1 do
      vern[i]:=vern[i+1];
    dec(nn);
  end;
  i:=2;
  while i<nn do
    if cos(vern[i-1],vern[i],vern[i+1])=0 then begin
      for j:=i to nn-1 do
        vern[j]:=vern[j+1];
      dec(nn);
    end else inc(i);
  if cos(vern[nn-1],vern[nn],vern[1])=0 then
    dec(nn);
end;

begin
  assign(input,'reform.in');
  assign(output,'reform.out');
  reset(input);
  rewrite(output);

  readln(n);
  if n=3 then begin
    writeln(1);
    writeln(0);
  end else begin
    for i:=1 to n do
      readln(ver[i].x,ver[i].y);
    if n=4 then begin
      writeln(2);
      writeln(1);
      if(cos(ver[2],ver[3],ver[4])<0)or(cos(ver[2],ver[4],ver[1])<0) then writeln(ver[1].x,' ',ver[1].y,' ',ver[3].x,' ',ver[3].y)
      else writeln(ver[2].x,' ',ver[2].y,' ',ver[4].x,' ',ver[4].y)
    end else begin
      if isvyp(true) then begin
        writeln(n-2);
        writeln(n-3);
        for i:=3 to n-1 do
          writeln(ver[1].x,' ',ver[1].y,' ',ver[i].x,' ',ver[i].y);
      end else begin
        nn:=n;
        ntr:=0;
        k:=0;
        for i:=1 to nn do
          vern[i]:=ver[i];
        repeat
          i:=findfir;
          inc(ntr);
          inc(k);
          diags[k,1]:=vern[i];
          if i=nn then diags[k,2]:=vern[2]
          else if i=nn-1 then diags[k,2]:=vern[1]
          else diags[k,2]:=vern[i+2];
          for j:=i+1 to nn-1 do
            vern[j]:=vern[j+1];
          dec(nn);
          {while havelin do
            simplifying; }
        until isvyp(false);
        findn;
        inc(ntr,nnn-2);
        inc(k,nnn-3);
        for i:=3 to nnn-1 do begin
          diags[k+i+1-nnn,1]:=ver2[1];
          diags[k+i+1-nnn,2]:=ver2[i];
        end;
        writeln(ntr);
        writeln(k);
        for i:=1 to k do
          writeln(diags[i,1].x,' ',diags[i,1].y,' ',diags[i,2].x,' ',diags[i,2].y);
      end;
    end;
  end;

  close(input);
  close(output);
end.
