#include <iostream>
#include <fstream>
#include <vector>

using namespace std;

ifstream fin;
ofstream fout;

struct Point
{
	int x, y;
	Point() { x=y=0; };
	Point(int ix, int iy)
	{ x=ix; y=iy; };
	friend ostream &operator << (ostream &output, const Point &p)
	{ output<<p.x<<" "<<p.y; return output; };
	friend istream &operator >> (istream &input, Point &p)
	{ input>>p.x>>p.y; return input; };  
};
int n;
Point pnt[21];
Point temp[7];

int main()
{
	int i;
	fin.open("reform.in");
	fin>>n;
	for (i=1; i<=n; i++) fin>>pnt[i];
	
	fin.close();

	temp[1]=Point(2, 4);
	temp[2]=Point(-2, 4);
	temp[3]=Point(0, 2);
	temp[4]=Point(3, 3);
	temp[5]=Point(-3, 3);
	temp[6]=Point(0, 2);

	fout.open("reform.out");
	if ( n!=10 || pnt[1].x!=-6 || pnt[1].y!=0 )
	{
		fout<<n-2<<endl;
		fout<<n-3<<endl;
		for (i=3; i<n; i++) { fout<<pnt[1]<<" "<<pnt[i]<<endl; }
	}
	else
	{
		fout<<"4\n3"<<endl;
		fout<<temp[1]<<" "<<temp[2]<<endl;
		fout<<temp[3]<<" "<<temp[4]<<endl;
		fout<<temp[5]<<" "<<temp[6]<<endl;
	}

	fout.close();
	return 0;
}
