const max=21;
      eps=1e-5;
type tans=record
 a1,a2,x,w,k:longint;
end;
var ans:array[0..1 shl max] of tans;
    was:array[0..1 shl max] of boolean;
    i,n,t:longint;
    x,y:array[0..max] of longint;
function vec2(x1,y1,x2,y2:extended):extended;
begin
 vec2:=x1*y2-x2*y1;
end;
function scal2(x1,y1,x2,y2:extended):extended;
begin
 scal2:=x1*x2+y1*y2;
end; 
function vec(x1,y1,x2,y2:longint):longint;
begin
 vec:=x1*y2-x2*y1;
end;
function prev(x,z:longint):longint;
begin
 repeat
  x:=(x+n) mod (n+1);
 until z and (1 shl x)>0;
 prev:=x;
end;
function next(x,z:longint):longint;
begin
 repeat
  x:=(x+1) mod (n+1);
 until z and (1 shl x)>0;
 next:=x;
end;
function _in(x1,y1:extended; z:longint):boolean;
var x3,y3,x4,y4,f,c,c1,k:longint;
    b1,b2:boolean;
begin
 k:=0;
 f:=next(n,z);
 c:=f;
 repeat
  c1:=next(c,z);
  x3:=x[c];
  y3:=y[c];
  x4:=x[c1];
  y4:=y[c1];
  b1:=(vec2(x3-x1,y3-y1,1e-5,1)*vec2(x4-x1,y4-y1,1e-5,1))<0;
  b2:=(scal2(x3-x1,y3-y1,1e-5,1)>-eps)or(scal2(x4-x1,y4-y1,1e-5,1)>-eps);
  if b1 and b2  then
   inc(k);
  c:=c1;
 until c=f;
 _in:=(k mod 2=1);
end;
procedure correct(var z:longint);
var c2,c1,c,f:longint;
begin
 f:=next(n,z);
 c:=f;
 repeat
  c1:=next(c,z);
  if c1=f then
   exit;
  c2:=next(c1,z);
  if vec(x[c1]-x[c],y[c1]-y[c],x[c2]-x[c1],y[c2]-y[c1])=0 then
   z:=z-(1 shl c1)
  else
   c:=c1;
 until false;
end;
function poss(x1,y1,x2,y2,z:longint):boolean;
var b1,b2:boolean;
    c1,c,x3,y3,x4,y4,f:longint;
begin
 f:=next(n,z);
 c:=f;
 repeat
  c1:=next(c,z);
  x3:=x[c];
  y3:=y[c];
  x4:=x[c1];
  y4:=y[c1];
  b1:=vec(x1-x3,y1-y3,x4-x3,y4-y3)*vec(x2-x3,y2-y3,x4-x3,y4-y3)<0;
  b2:=vec(x3-x1,y3-y1,x2-x1,y2-y1)*vec(x4-x1,y4-y1,x2-x1,y2-y1)<0;
  if b1 and b2 then begin
   poss:=false;
   exit;
  end;
  c:=c1;
 until c=f;
 if not _in((x1+x2)/2,(y1+y2)/2,z) then
  poss:=false
 else
  poss:=true;
end;
procedure find(z:longint);
var z1,a1,a2,i:longint;
    bk,bw,best,b1,b2:longint;
begin
 best:=maxlongint div 2;
 if was[z] then
  exit;
 was[z]:=true;
 for i:=0 to n do
  if z and (1 shl i)>0 then begin
   a1:=prev(i,z);
   a2:=next(i,z);
   if next(a2,z)=a1 then begin
    ans[z].x:=1;
    ans[z].k:=0;
    exit;
   end;
   if not poss(x[a1],y[a1],x[a2],y[a2],z) then
    continue;
   if a1=a2 then begin
    ans[z].x:=0;
    exit;
   end;
   z1:=z-(1 shl i);
   correct(z1);
   find(z1);
   if ans[z1].x+1<best then begin
    best:=ans[z1].x+1;
    b1:=a1;
    b2:=a2;
    bw:=z1;
    bk:=ans[z1].k+1;
   end;
  end;
 ans[z].x:=best;
 ans[z].a1:=b1;
 ans[z].a2:=b2;
 ans[z].w:=bw;
 ans[z].k:=bk;
end;
procedure GetAns(t:longint);
var a1,a2:longint;
begin
 if ans[t].x=1 then
  exit;
 a1:=ans[t].a1;
 a2:=ans[t].a2;
 writeln(x[a1],' ',y[a1],' ',x[a2],' ',y[a2]);
 GetAns(ans[t].w);
end;
begin
 assign(input,'reform.in');
 assign(output,'reform.out');
 reset(input);
 rewrite(output);
 read(n);
 dec(n);
 fillchar(was,sizeof(was),false);
 for i:=0 to n do
  read(x[i],y[i]);
 t:=1 shl(n+1)-1;
 find(t);
 writeln(ans[t].x);
 writeln(ans[t].k);
 GetAns(t);
 close(input);
 close(output);
end.
