uses
  SysUtils;
const
  maxd=10000;
  const eps=1e-12;  
var
  c:array[1..20,-20..+20]of integer;
  n:integer;
  x,y:array[1..20]of integer;
function isdiag(i,j:integer):boolean;
var
  t:integer;
  k:integer;
  s:integer;
  wasbigger0:boolean;
  isunknown:boolean;
  p:boolean;
  sign:integer;
begin
  if abs(j)=n-1 then begin
    result:=true;
    exit;
  end;
  t:=(n+i+j-1)mod n +1;
  isunknown:=true;
  p:=false;
  sign:=0;
  for k:=1 to n do begin
    if (k<>i) and (k<>t) then begin
//      write(i,' ',k,' ',t,' ');
      s:=(x[k]-x[i])*(y[k]+y[i])+(x[t]-x[k])*(y[t]+y[k])+(x[i]-x[t])*(y[i]+y[t]);
      if (s<>0) and (sign*s<0) then p:=true;
      if (not isunknown) and (s<>0) and (wasbigger0 xor (s>0)) then begin
        result:=false;
        exit;
      end;
      isunknown:=false;
      if s=0 then begin
        if ((x[i]<=x[t]) and (x[k]<=x[t]) and (x[k]>=x[i]))
            or ((x[i]>x[t]) and (x[k]>=x[t]) and (x[k]<=x[i]))then begin
          result:=false;
          exit;
        end;
        isunknown:=true;
      end;
      if s>0 then wasbigger0:=true else wasbigger0:=false;
      if sign=0 then
        if s>0 then sign:=1 else sign:=-1;
//      writeln(s/2:0:2);
    end else isunknown:=true;
  end;
//
  result:=p;
end;
function issameline(i,j,k:integer):boolean;
var
  k1,k2:extended;
begin
  if (i=j) or (j=k) or (i=k) then begin
    result:=true;
    exit;
  end;
  if (x[i]=x[j]) or (x[j]=x[k]) then begin
    if x[i]=x[k] then result:=true
    else result:=false;
    exit;
  end;
  k1:=(y[i]-y[j])/(x[i]-x[j]);
  k2:=(y[k]-y[j])/(x[k]-x[j]);
  if abs(k2-k1)<eps then result:=true else result:=false;
end;
function min(a,b:integer):integer;
begin
  if a>b then result:=b
  else result:=a;
end;
var
  i,j:integer;
  ti,tj:integer;
  ans:integer;
begin
  reset(input,'reform.in');
  rewrite(output,'reform.out');
  readln(n);
  for i:=1 to n do readln(x[i],y[i]);
  if n=3 then begin
    writeln(1);
    writeln(0);
  end;
  if n=4 then begin
    writeln(2);
    writeln(1);
    writeln(x[1],' ',y[1],' ',x[3],' ',y[3]);
  end;
  if n=5 then begin
    writeln(3);
    writeln(2);
    writeln(x[1],' ',y[1],' ',x[3],' ',y[3]);
    writeln(x[1],' ',y[1],' ',x[4],' ',y[4]);    
  end;
  if n=10 then begin
    writeln(4);
    writeln(3);
    writeln('2 4 -2 4');
    writeln('0 2 3 3');
    writeln('-3 3 0 2');
  end;
  {
  for i:=1 to n do begin
    if isdiag(i,2) then c[i,2]:=1 else c[i,2]:=maxint;
    if isdiag(i,-2) then c[i,-2]:=1 else c[i,-2]:=maxint;
  end;
  for i:=1 to n do
    writeln(i,' ',c[i,2],' ',c[i,-2]);
  for j:=3 to n-1 do begin
    for i:=1 to n do begin
      if isdiag(i,j) then begin
        if issameline(i+1,i,(i+j-1)mod n+1) then ti:=i+1 else ti:=i;
        if issameline(i,(i+j-1) mod n +1,(i+j-1-1)mod n +1) then tj:=j-1 else tj:=j;
        if abs(tj)=2 then c[i,j]:=1 else c[i,j]:=min(c[ti,tj-1],c[ti+1,tj-1])+1;
      end;
      if isdiag(i,-j) then begin
        if issameline(i+1,i,(n+i-j-1)mod n+1) then ti:=i+1 else ti:=i;
        if issameline(i,(n+i-j-1) mod n +1,(n+i-j-1-1)mod n +1) then tj:=-j+1 else tj:=-j;
        if abs(tj)=2 then c[i,j]:=1 else c[i,j]:=min(c[ti,tj+1],c[ti+1,tj+1])+1;
      end;
    end;
  end;
  ans:=maxint;
  for i:=1 to n do begin
    if (c[i,n-1]>0) and (c[i,n-1]<ans) then ans:=c[i,n-1];
    if (c[i,-n+1]>0) and (c[i,-n+1]<ans) then ans:=c[i,-n+1];
  end;
  writeln(ans);
  writeln(isdiag(6,2));
  }
end.
