{$R-,Q-,S-,B-}

const id='reform';
      eps=1e-8;

type tpoint=record
      x,y:extended;
      end;
     tline=record
      a,b,c:extended;
      end;

function p2l(p1,p2:tpoint):tline;
 begin
 result.a:=p1.y-p2.y;
 result.b:=p2.x-p1.x;
 result.c:=-result.a*p1.x-result.b*p1.y;
 end;

function l2p(l1,l2:tline):tpoint;
 var d:extended;
 begin
 d:=l1.a*l2.b-l2.a*l1.b;
 result.x:=(l1.b*l2.c-l2.b*l1.c)/d;
 result.y:=(l1.c*l2.a-l2.c*l1.a)/d;
 end;

function eq(l1,l2:tline):boolean;
 begin
 eq:=(abs(l1.a*l2.b-l2.a*l1.b)<eps) and
     (abs(l1.b*l2.c-l2.b*l1.c)<eps) and
     (abs(l1.c*l2.a-l2.c*l1.a)<eps);
 end;

function linecalc(l:tline; p:tpoint):extended;
 begin
 result:=l.a*p.x+l.b*p.y+l.c;
 end;

function lineside(l:tline; p:tpoint):longint;
 var t:extended;
 begin
 t:=linecalc(l,p);
 if t<-eps then result:=-1
 else if t>eps then result:=1
 else result:=0;
 end;

function cross(a,b,c,d:tpoint):boolean;
 var l1,l2:tline;
 begin
 l1:=p2l(a,b);
 l2:=p2l(c,d);
 cross:=(lineside(l2,a)*lineside(l2,b)<0) and
        (lineside(l1,c)*lineside(l1,d)<0);
 end;

var g,n,i,j,k:longint;
    p:array [1..43] of tpoint;
    b:array [1..43,1..43] of boolean;
    e:array [1..43,1..43,1..2] of tpoint;
    rn:array [1..43,1..43,1..2] of longint;
    sp:array [1..43,1..43,1..2] of boolean;
    q,w:tpoint;

function ins(p1:tpoint):boolean;
 var l:tline; q:tpoint; c,i:longint;
 begin
 l.a:=1;
 l.b:=2*random-1;
 l.c:=-l.a*p1.x-l.b*p1.y;
 q.x:=p1.x+1e6*l.a;
 q.y:=p1.y+1e6*l.b;
 c:=0;
 for i:=1 to n do
  if cross(p1,q,p[i],p[(i mod n)+1]) then inc(c);
 ins:=c mod 2=1;
 end;

function prev(i:longint):longint;
 begin
 result:=i-1;
 if i=1 then result:=n;
 end;

var ans,n1:longint;
    p1:array [1..43] of tpoint;
    r:array [1..43] of longint;
    a,a1:array [1..100,1..2] of tpoint;
    t:array [0..2000000] of boolean;

function prev1(i:longint):longint;
 begin
 result:=i-1;
 if i=1 then result:=n1;
 end;

function eqp(p1,p2:tpoint):boolean;
 begin
 eqp:=(abs(p1.x-p2.x)<eps) and (abs(p1.y-p2.y)<eps);
 end;

procedure calc(d:longint);
 var i,j,h:longint; rc,rc1,rc2:longint; pc,pc1,pc2:tpoint;
     po:array [1..43] of tpoint;
     no,nn:longint;
     ro:array [1..43] of longint;
     take:array [1..43] of boolean;
 begin

 if n1<=3 then
  begin
  if d-1<ans then
   begin
   ans:=d-1;
   a:=a1;
   end;
  exit;
  end;

 //HASH!!!!!!!!!

 h:=0;
 for i:=1 to n1 do h:=h or (1 shl (r[i]-1));
 if t[h] then exit;

 t[h]:=true;

 for i:=1 to n1 do po[i]:=p1[i];
 for i:=1 to n1 do ro[i]:=r[i];
 no:=n1;

 for i:=1 to n1 do
  begin
  if b[r[prev1(i)],r[(i mod n1)+1]] then
   begin
   fillchar(take,sizeof(take),true);
   rc:=r[i];
   rc1:=r[(i mod n1)+1];
   rc2:=r[prev1(i)];
   a1[d,1]:=p1[prev1(i)];
   a1[d,2]:=p1[(i mod n1)+1];
   if rc1<rc2 then
    begin
    p1[(i mod n1)+1]:=e[rc1,rc2,1];
    p1[prev1(i)]:=e[rc1,rc2,2];
    r[(i mod n1)+1]:=rn[rc1,rc2,1];
    r[prev1(i)]:=rn[rc1,rc2,2];
    end
   else
    begin
    p1[(i mod n1)+1]:=e[rc2,rc1,2];
    p1[prev1(i)]:=e[rc2,rc1,1];
    r[(i mod n1)+1]:=rn[rc2,rc1,2];
    r[prev1(i)]:=rn[rc2,rc1,1];
    end;
   for j:=i to n1 do
    begin
    p1[j]:=p1[j+1];
    r[j]:=r[j+1];
    end;
   dec(n1);
   for j:=2 to n1 do
    if eqp(p1[j],p1[j-1]) then take[j]:=false;
   nn:=0;
   for j:=1 to n1 do
    if take[j] then
     begin
     inc(nn);
     p1[nn]:=p1[j];
     r[nn]:=r[j];
     end;
   n1:=nn;  
   calc(d+1);
   n1:=no;
   for j:=1 to n1 do p1[j]:=po[j];
   for j:=1 to n1 do r[j]:=ro[j];

   end;
  end;
 end;

begin
randseed:=1543543543;
assign(input,id+'.in');
assign(output,id+'.out');
reset(input);
rewrite(output);
readln(n);
for i:=1 to n do readln(p[i].x,p[i].y);
fillchar(b,sizeof(b),0);
for i:=1 to n-1 do
 for j:=i+1 to n do
  if abs(i-j)>1 then
  begin
  b[i,j]:=true;
  for g:=1 to n do b[i,j]:=b[i,j] and
                           not(cross(p[i],p[j],p[g],p[(g mod n)+1]));
  q.x:=(p[i].x+p[j].x)/2;
  q.y:=(p[i].y+p[j].y)/2;
  b[i,j]:=b[i,j] and ins(q);
  if b[i,j] then
   begin
   e[i,j,1]:=p[i];
   e[i,j,2]:=p[j];
   sp[i,j,1]:=false;
   sp[i,j,2]:=false;

   rn[i,j,1]:=i;
   rn[i,j,2]:=j;
   if eq(p2l(p[i],p[j]),p2l(p[i],p[(i mod n)+1])) then
    begin
    e[i,j,1]:=p[(i mod n)+1];
    rn[i,j,1]:=(i mod n)+1;
    sp[i,j,1]:=true;
    end;
   if eq(p2l(p[i],p[j]),p2l(p[i],p[prev(i)])) then
    begin
    e[i,j,1]:=p[prev(i)];
    rn[i,j,1]:=prev(i);
    sp[i,j,1]:=true;
    end;
   if eq(p2l(p[i],p[j]),p2l(p[j],p[(j mod n)+1])) then
    begin
    e[i,j,2]:=p[(j mod n)+1];
    rn[i,j,2]:=(j mod n)+1;
    sp[i,j,2]:=true;
    end;
   if eq(p2l(p[i],p[j]),p2l(p[j],p[prev(j)])) then
    begin
    e[i,j,2]:=p[prev(j)];
    rn[i,j,2]:=prev(j);
    sp[i,j,2]:=true;
    end;
   end;
  end;
n1:=n;
for i:=1 to n do p1[i]:=p[i];
for i:=1 to n do r[i]:=i;
fillchar(t,sizeof(t),0);
ans:=maxlongint div 4;
calc(1);
writeln(ans+1);
writeln(ans);
for i:=1 to ans do writeln(a[i,1].x:0:0,' ',a[i,1].y:0:0,' ',
                           a[i,2].x:0:0,' ',a[i,2].y:0:0);
close(input);
close(output);
end.