#include <stdio.h>

#define NMAX 22

typedef struct {int x,y;} point;
typedef	struct {int x1, y1, x2, y2;} diag;

point points[NMAX];
diag ans[NMAX];

int n;

inline int vec(int x1, int y1, int x2, int y2)
{
	return (x1*y2-x2*y1);
}

void VYREZ()
{
	int i,j;
	for (i=0;i<n;i++) 
		if (vec(points[(i+1)%n].x-points[i].x, points[(i+1)%n].y-points[i].y,
			points[(i+2)%n].x-points[(i+1)%n].x, points[(i+2)%n].y-points[(i+1)%n].y)==0)
		{
			j=(i+1)%n;
			for (;j<n;j++) points[j]=points[j+1];
			n--;
			i=-1;
		}
}

int main()
{
	int count_k=0, count_t=0;
	freopen("reform.in","r",stdin);
	freopen("reform.out","w", stdout);
	scanf("%d", &n);
	int i,j;
	for (i=0;i<n;i++)  scanf("%d%d", &points[i].x, &points[i].y);
	
	while (n>3)
	{
		for (i=0;i<n;i++) 
		if (vec(points[(i+1)%n].x-points[i].x, points[(i+1)%n].y-points[i].y,
								points[(i+2)%n].x-points[(i+1)%n].x, points[(i+2)%n].y-points[(i+1)%n].y)>0)
		{
			count_t++;
			ans[count_k].x1=points[i].x;
			ans[count_k].y1=points[i].y;
			ans[count_k].x2=points[(i+2)%n].x;
			ans[count_k].y2=points[(i+2)%n].y;
			count_k++;
			j=(i+1)%n;
			for (;j<n-1;j++) points[j]=points[j+1];
			n--;
			VYREZ();
			break;
		}
	}
	printf("%d\n%d\n", count_t, count_k);
	for (i=0;i<count_k;i++) printf("%d %d %d %d\n",ans[i].x1, ans[i].y1, ans[i].x2, ans[i].y2);
	return 0;
}