program z6_ver1_READY;
{$APPTYPE CONSOLE}
uses
  SysUtils;
type tpoint = record
                  x,y: LongInt;
              end;
var t: array[0..50] of tpoint;
    res: array[0..1000,1..2] of tpoint;
    cur, i, j, N: longInt;
    p1, p2, p3, p4: tpoint;

                 
procedure init;
begin
    Assign(input, 'reform.in'); Reset(input);
    Assign(output, 'reform.out'); ReWrite(output);

        Read(N);
        for i := 1 to N do
           Read(t[i].x, t[i].y);

        t[0] := t[N];
           
    Close(input);
end;

procedure save;
begin
    Close(output);
end;

function vect(t1, t2, t3: tpoint): LongInt;
var x1, x2, x3, y1, y2, y3: LongInt;
begin
   x1 := t1.x; y1 := t1.y;
   x2 := t2.x; y2 := t2.y;
   x3 := t3.x; y3 := t3.y;

    vect := (x2-x1)*(y3-y1) - (x3-x1)*(y2-y1);
end;

function cross(p1, p2, p3, p4: tpoint): Boolean;
begin
   if ( (vect(p1, p2, p3) * vect(p1, p2, p4)) < 0 )and
      ( (vect(p3, p4, p1) * vect(p3, p4, p2)) < 0 )then
        cross := true else cross := false;
end;

function inside(p1, p2: tpoint): Boolean;
var more, less: Boolean;
begin
    inside := false;
    t[N+1] := t[1];
    more := false;
    less := false;

    for i := 1 to N do
      if vect(p1, p2, t[i]) > 0 then more := true
      else if vect(p1, p2, t[i]) < 0 then less := true;

    inside := more and less;
end;

function can(p1, p2: tpoint): Boolean;
begin
    can := false;

    for i := 1 to n do begin
        p3 := t[i-1];
        p4 := t[i];
        if cross(p1, p2, p3, p4) then exit;
    end;

    if not inside(p1, p2) then exit;

    can := true;
end;

procedure work;
begin
     j := 0;

     while N>3 do begin
         inc(j);
         cur := N;

         while not can(t[cur], t[cur-2]) do dec(cur);

         res[j,1] := t[cur];
         res[j,2] := t[cur-2];

         for i := cur-1 to N do
            t[i] := t[i+1];

         dec(N);
         t[0] :=t[N];
     end;


    writeln(j+1); 
    writeln(j);
    for i := 1 to j do
      writeln(res[i,1].x, ' ', res[i,1].y,' ',res[i,2].x, ' ', res[i,2].y);

end;


begin
    init;
    work;
    save;
end.
