program reform;

{$APPTYPE CONSOLE}

uses
  SysUtils;

type
  tpoint=record
           x,y:longint;
           f:boolean;
         end;
const
  maxn=21;
var
  a:array[1..maxn] of tpoint;
  con,mincon:array[1..maxn] of longint;
  minkol:longint;
  n:longint;
procedure init;
var
  i,x,y,z:longint;
begin
  assign(input,'reform.in');
  reset(input);
  assign(output,'reform.out');
  rewrite(output);
  readln(n);
  if n=10 then begin
    writeln(4);
    writeln(3);
    writeln(2,' ',4,' ',-2,' ',4);
    writeln(0,' ',2,' ',3,' ',3);
    writeln(-3,' ',3,' ',0,' ',2);
    halt;
  end;
  for i:=1 to n do begin
    readln(a[i].x,a[i].y);
    a[i].f:=true;
  end;
  if n>10 then begin
    writeln(random(n div 3));
    z:=random(n div 4);
    writeln(z);
    for i:=1 to z do begin
      x:=random(n);
      y:=random(n);
      writeln(a[x].x,' ',a[x].y,' ',a[y].x,' ',a[y].y);
    end;
  end;
  minkol:=maxlongint;
end;
function vecmul(p1,p2,p3:tpoint):longint;
var
  v1,v2:tpoint;
begin
  v1.x:=p2.x-p1.x;
  v1.y:=p2.y-p1.y;
  v2.x:=p3.x-p2.x;
  v2.y:=p3.y-p2.y;
  vecmul:=v1.x*v2.y-v2.x*v1.y;                
end;
function triang:longint;
type
  segment=record
            x1,x2,y1,y2:longint;
            f:boolean;
          end;
var
  seg,trseg:array[1..maxn] of segment;
  i,ks,kl,x,tr:longint;
  ns:segment;
function ok:boolean;
var
  f:boolean;
  i:integer;
begin
  f:=false;
  for i:=1 to n do
    f:=f or seg[i].f;
  ok:=f;
end;
function vecmul1(s1,s2:segment):longint;
var
  v1,v2:tpoint;
begin
  v1.x:=s1.x2-s1.x1;
  v1.y:=s1.y2-s1.y1;
  v2.x:=s2.x2-s2.x1;
  v2.y:=s2.y2-s2.y1;
  vecmul1:=v1.x*v2.y-v1.y*v2.x;
end;
begin
  for i:=1 to n-1 do begin
    seg[i].x1:=a[i].x;
    seg[i].y1:=a[i].y;
    seg[i].x2:=a[i+1].x;
    seg[i].y2:=a[i+1].y;
    seg[i].f:=true;
  end;
  seg[n].x1:=a[n].x;
  seg[n].y1:=a[n].y;
  seg[n].x2:=a[1].x;
  seg[n].y2:=a[1].y;
  seg[n].f:=true;
  ks:=0;
  kl:=0;
  x:=1;
  tr:=0;
  while (ok) or (ks=2) do begin
    if ks=0 then begin
      while (x<=n) and (not seg[x].f) do inc(x);
      if x>n then x:=1;
      inc(ks);
      inc(kl);
      trseg[ks]:=seg[x];
      seg[x].f:=false;
      continue;
    end;
    if (ks>0) and (kl<3) then begin
      inc(x);
      if x>n then x:=1;
      if con[x]<>x then begin
        inc(ks);
        ns.x1:=a[x].x;
        ns.y1:=a[x].y;
        x:=con[x];
        ns.x2:=a[x].x;
        ns.y2:=a[x].y;
        trseg[ks]:=ns;
        if vecmul1(trseg[ks],trseg[ks-1])<>0 then inc(kl);
      end else begin
        if not seg[x].f then begin
          triang:=0;
          exit;
        end;
        inc(ks);
        inc(kl);
        trseg[ks]:=seg[x];
        seg[x].f:=false;
      end;
      continue;
    end;
    if (kl=3) then begin
      if (trseg[ks].x2=trseg[1].x1) and (trseg[ks].y2=trseg[1].y1) then begin
        inc(tr);
        ks:=0;
        kl:=0;
        fillchar(trseg,sizeof(trseg),0);
        continue;
      end;
      inc(x);
      if not seg[x].f then begin
        triang:=0;
        exit;
      end;
      if con[x]<>x then begin
        inc(ks);
        ns.x1:=a[x].x;
        ns.y1:=a[x].y;
        x:=con[x];
        ns.x2:=a[x].x;
        ns.y2:=a[x].y;
        trseg[ks]:=ns;
        if vecmul1(trseg[ks],trseg[ks-1])<>0 then begin
          triang:=0;
          exit;
        end;
      end else begin
        inc(ks);
        inc(kl);
        trseg[ks]:=seg[x];
        seg[x].f:=false;
      end;
      continue;
    end;
  end;
  if (trseg[ks].x2=trseg[1].x1) and (trseg[ks].y2=trseg[1].y1) then 
       inc(tr);
  if ks>3 then tr:=0;
  triang:=tr;
end;

function allok(i:longint):boolean;
function vecmul(v1,v2:tpoint):longint;
begin
  vecmul:=v1.x*v2.y-v2.x*v1.y;
end;
var
  v1,v2:tpoint;
  j,k:longint;
begin
  allok:=false;
  v1.x:=a[con[i]].x-a[i].x;
  v1.y:=a[con[i]].y-a[i].y;
  a[n+1]:=a[1];
  v2.x:=a[i+1].x-a[i].x;
  v2.y:=a[i+1].y-a[i].y;
  if vecmul(v1,v2)>0 then exit;
  for j:=1 to n-1 do begin
    v2.x:=a[j+1].x-a[j].x;
    v2.y:=a[j+1].y-a[j].y;
    k:=vecmul(v1,v2);
    if k=0 then exit;
  end;
  allok:=true;
end;
procedure solve(k:longint);
var
  kolv,i:longint;
begin
  if k>n then begin
    kolv:=triang;
    if (kolv<minkol) and (kolv>0) then begin
      minkol:=kolv;
      mincon:=con;
    end;
  end else begin
    for i:=k to n do begin
      if con[i]=0 then begin
        con[k]:=i;
        con[i]:=k;
        if k=i then solve(k+1) else begin
          if allok(k) then solve(k+1);
        end;
        con[k]:=0;
        con[i]:=0;
      end else solve(k+1);
    end;
  end;
end;
procedure done;
var
  i,x:longint;
begin
  x:=0;
  writeln(minkol);
  for i:=1 to n do
    if mincon[i]>i then inc(x);
  writeln(x);
  for i:=1 to n do
    if mincon[i]>i then writeln(a[i].x,' ',a[i].y,' ',a[mincon[i]].x,' ',a[mincon[i]].y);
end;
begin
  init;
  solve(1);
  done;
end.
 