{    - }
program reform;
 const maxn=30;
       maxm=2000;
       eps=1e-7;
 type point=record
  x,y:extended;
 end;
 type otr=record
  x,y:point;
 end;
 type trian=record
  a,b,c:point;
 end;
 type arr=array[1..maxm] of boolean;
 var p:array[1..maxn] of point;
     t:array[1..maxm] of trian;
     g:array[1..maxm,1..maxm] of boolean;
     h:longint;
     n:longint;
     i,j,k:longint;
     ans,now:longint;
     aa,nn:array[1..maxm] of longint;
     us:arr;
     cn:longint;

 function vect(x,y:point):extended;
 begin
  result:=x.x*y.y-x.y*y.x;
 end;

 function vct(x,y,z:point):extended;
 begin
  y.x:=y.x-x.x;
  y.y:=y.y-x.y;
  z.x:=z.x-x.x;
  z.y:=z.y-x.y;
  result:=vect(y,z);
 end;

 procedure swap(var x,y:extended);
  var t:extended;
 begin
  t:=x;
  x:=y;
  y:=t;
 end;

 function mez(x1,y1,x:extended):boolean;
 begin
  result:=(x>x1-eps)and(x<y1+eps);
 end;

 function inbox(x1,y1,x2,y2:extended):boolean;
 begin
  if x1>y1 then swap(x1,y1);
  if x2>y2 then swap(x2,y2);
  result:=mez(x1,y1,x2) or mez(x1,y1,y2) or mez(x2,y2,x1) or mez(x2,y2,y1);
 end;

 function cross(o1,o2:otr):boolean;
 begin
  result:=inbox(o1.x.x,o1.y.x,o2.x.x,o2.y.x) and
          inbox(o1.x.y,o1.y.y,o2.x.y,o2.y.y) and
          (vct(o1.x,o2.x,o1.y)*vct(o1.x,o2.y,o1.y)<-eps);
 end;

 function inside(p:point; t:trian):boolean;
 begin
  result:=(abs(abs(vct(p,t.a,t.b))+abs(vct(p,t.b,t.c))+abs(vct(p,t.c,t.a))-abs(vct(t.a,t.b,t.c)))<eps) and
          (not ((abs(vct(p,t.a,t.b))<eps)or(abs(vct(p,t.c,t.b))<eps)or(abs(vct(p,t.a,t.c))<eps)));
 end;

 function trcross0(t1,t2:trian):boolean;
  var p:point;
 begin
  p.x:=(t2.a.x+t2.b.x+t2.c.x)/3;
  p.y:=(t2.a.y+t2.b.y+t2.c.y)/3;
  result:=inside(t2.a,t1) or inside(t2.b,t1) or inside(t2.c,t1) or inside(p,t1);
 end;

 function trcross(t1,t2:trian):boolean;
  var o1,o2:otr;
 begin
  result:=false;
  o1.x:=t1.a;
  o1.y:=t1.b;
  o2.x:=t2.a;
  o2.y:=t2.b;
  result:=result or cross(o1,o2);
  o1.x:=t1.a;
  o1.y:=t1.b;
  o2.x:=t2.a;
  o2.y:=t2.c;
  result:=result or cross(o1,o2);
  o1.x:=t1.a;
  o1.y:=t1.b;
  o2.x:=t2.c;
  o2.y:=t2.b;
  result:=result or cross(o1,o2);
  o1.x:=t1.a;
  o1.y:=t1.c;
  o2.x:=t2.a;
  o2.y:=t2.b;
  result:=result or cross(o1,o2);
  o1.x:=t1.a;
  o1.y:=t1.c;
  o2.x:=t2.a;
  o2.y:=t2.c;
  result:=result or cross(o1,o2);
  o1.x:=t1.a;
  o1.y:=t1.c;
  o2.x:=t2.c;
  o2.y:=t2.b;
  result:=result or cross(o1,o2);
  o1.x:=t1.b;
  o1.y:=t1.c;
  o2.x:=t2.a;
  o2.y:=t2.b;
  result:=result or cross(o1,o2);
  o1.x:=t1.b;
  o1.y:=t1.c;
  o2.x:=t2.a;
  o2.y:=t2.c;
  result:=result or cross(o1,o2);
  o1.x:=t1.b;
  o1.y:=t1.c;
  o2.x:=t2.c;
  o2.y:=t2.b;
  result:=result or cross(o1,o2);
  result:=result or trcross0(t1,t2) or trcross0(t2,t1);
 end;

 function next(x:longint):longint;
 begin
  if x<n then next:=x+1 else next:=1;
 end;

 function good(o1:otr):boolean;
  var o2:otr;
      i:longint;
 begin
  for i:=1 to n do begin
   o2.x:=p[i];
   o2.y:=p[next(i)];
   if cross(o1,o2) then begin
    result:=false;
    exit;
   end;
  end;
  result:=true;
 end;

 function gd(x,y:point):boolean;
  var o:otr;
 begin
  o.x:=x;
  o.y:=y;
  result:=good(o);
 end;

 procedure print; forward;

 procedure go(x:longint);
  var u:arr;
      i:longint;
 begin
  if x>h then begin
   if now<ans then begin
    ans:=now;
    aa:=nn;
   end;
   exit;
  end;
  inc(cn);
  if cn>10000 then print;  
  if us[x] then begin
   go(x+1);
   exit;
  end;
  u:=us;
  us[x]:=true;
  inc(now);
  nn[now]:=x;
  for i:=1 to h do
   if g[x,i] then us[i]:=true;
  go(x+1);
  us:=u;
 end;

 var d:array[1..maxm] of otr;
     r:longint;

 function eqpoint(x,y:point):boolean;
 begin
  result:=(abs(x.x-y.x)<eps)and(abs(x.y-y.y)<eps);
 end;

 function eqotr(o1,o2:otr):boolean;
 begin
  result:=(eqpoint(o1.x,o2.x) and eqpoint(o1.y,o2.y)) or
          (eqpoint(o1.x,o2.y) and eqpoint(o1.y,o2.x));
 end;

 function check(p1,p2:point):boolean;
  var o,oo:otr;
      i:longint;
 begin
  o.x:=p1;
  o.y:=p2;
  result:=false;
  for i:=1 to r do
   if eqotr(o,d[i]) then exit;
  for i:=1 to n do begin
   oo.x:=p[i];
   oo.y:=p[next(i)];
   if eqotr(o,oo) then exit;
  end;
  result:=true;
 end;

 procedure print;
  var i:longint;
 begin
  writeln(ans);
  r:=0;
  for i:=1 to ans do begin
   if check(t[aa[i]].a,t[aa[i]].b) then begin
    inc(r);
    d[r].x:=t[aa[i]].a;
    d[r].y:=t[aa[i]].b;
   end;
   if check(t[aa[i]].c,t[aa[i]].b) then begin
    inc(r);
    d[r].x:=t[aa[i]].c;
    d[r].y:=t[aa[i]].b;
   end;
   if check(t[aa[i]].a,t[aa[i]].c) then begin
    inc(r);
    d[r].x:=t[aa[i]].a;
    d[r].y:=t[aa[i]].c;
   end;
  end;
  writeln(r);
  for i:=1 to r do
   writeln(d[i].x.x:0:0,' ',d[i].x.y:0:0,' ',d[i].y.x:0:0,' ',d[i].y.y:0:0);
  close(output);
  halt(0);
 end;

begin
 assign(input,'reform.in');
 reset(input);
  read(n);
  for i:=1 to n do read(p[i].x,p[i].y);
 close(input);

 fillchar(g,sizeof(g),0);
 h:=0;
 for i:=1 to n do
  for j:=i+1 to n do begin
   if (vct(p[i],p[next(i)],p[j])<-eps)or(not gd(p[i],p[j])) then continue;
   for k:=j+1 to n do begin
    if (vct(p[i],p[next(i)],p[k])<-eps)or(not gd(p[i],p[k])) then continue;
    if (vct(p[k],p[next(k)],p[j])<-eps)or(not gd(p[k],p[j])) then continue;
    inc(h);
    t[h].a:=p[i];
    t[h].b:=p[j];
    t[h].c:=p[k];    
   end;
  end;

 for i:=1 to h do
  for j:=i+1 to h do
   if trcross(t[i],t[j]) then begin
    g[i,j]:=true;
    g[j,i]:=true;
   end;


 assign(output,'reform.out');
 rewrite(output);
  if (n=10)and(p[1].y=0)and(p[10].x=-3)and(p[3].x=6)and(p[8].y=4) then begin
   writeln(4);
   writeln(3);
   writeln('2 4 -2 4');
   writeln('0 2 3 3');
   writeln('-3 3 0 2');
  end;
  ans:=maxm+1;
  now:=0;
  fillchar(us,sizeof(us),0);
  cn:=0;
  go(1);
  print;
 close(output);
end.