program task_6;

type
  pix = record
    x, y : integer;
   end;
   polygon = record
     px : array[1..20] of pix;
     n : byte;
   end;
   ppix = ^pstec;
   pstec = record
     px1, px2 : pix;
     next : ppix;
   end;

var
  fin, fout : text;
  p1 : polygon;
  outt : ppix;


procedure load;
var
  i, j, k : integer;
begin
  assign(fin, 'reform.in');
  reset(fin);
  readln(fin,p1.n);
  for i:= 1 to p1.n do
    readln(fin, p1.px[i].x, p1.px[i].y);
  close(fin);
end;

procedure add(p1, p2 : pix;var outt : ppix);
var
  pp1, pp2 : ppix;
begin
  new(pp1);
  pp1.px1 := p1;
  pp1.px2 := p2;
  pp1.next := nil;
  if  outt = nil then
    outt := pp1
  else
  begin
    pp2 := outt;
    while pp2.next <> nil do
      pp2 := pp2.next;
    pp2.next := pp1;
  end;
end;

procedure clear(var p : polygon);
var
  i, j, k, l : integer;
  fl : boolean;
begin
  fl := true;
  while fl do
  begin
    fl := false;
    FOR I := 1 TO P.N DO
    BEGIN
      J := I + 1;
      K := I + 2 ;
      if j > p.n then dec(j,p.n);
      if k > p.n then dec(k,p.n);
      IF (P.PX[K].X - P.PX[I].X)*(P.PX[J].Y - P.PX[I].Y)
          - (P.PX[J].X - P.PX[I].X)*(P.PX[K].Y - P.PX[I].Y) = 0  then
      begin
        fl := true;
        for l := j to p.n - 1 do
          p.px[l] := p.px[l + 1];
        dec(p.n);
        break;
      end;
    END;
  end;
end;

function analize( p: polygon;var ou : ppix) : integer;
var
  i, j,t, k,l,m, otv, o1 : integer;
  fl : boolean;
  pp : ppix;
  temp : pix;
  p1, p2 : polygon;
begin
  clear(p);  otv := 100000;
  if p.n = 3 then  otv := 1
  else
  for t := 1 to p.n do
  begin
    pp := nil;
    fl := true;
    i := 1;
    while fl and (i <= p.n) do
    begin
      j := 1 ;
      k := i + 1;
      if k > p.n then k := 1;
      while fl and (j <= p.n) do
      begin
        if (abs(i - j) > 1 )and not((i = p.n) and (j = 1))and not((j = p.n) and (i = 1))    and ((p.px[k].x - p.px[i].x)*(p.px[j].y - p.px[i].y)
             - (p.px[j].x - p.px[i].x)*(p.px[k].y - p.px[i].y) > 0) then
        begin
        if (j < p.n)and (((p.px[j+1].x - p.px[i].x)*(p.px[j].y - p.px[i].y)
             - (p.px[j].x - p.px[i].x)*(p.px[j+1].y - p.px[i].y) <> 0)or((p.px[j+1].x - p.px[i].x)*(p.px[j+1].x - p.px[i].x)+
             (p.px[j+1].y - p.px[i].y)*(p.px[j+1].y - p.px[i].y)>(p.px[j].y - p.px[i].y)*(p.px[j].y - p.px[i].y) +
             (p.px[j].x - p.px[i].x)*(p.px[j].x - p.px[i].x)) )then
        begin
          fl := false;
          p1.n := abs(j - i) + 1;
          p2.n := p.n - p1.n + 2;
          p1.px[1] := p.px[i];
          p1.px[p1.n] := p.px[j];
          for l := 1 to p1.n - 2 do
            p1.px[l+1] := p.px[l + i];
          p2.px[1] := p.px[j];
          p2.px[p2.n] := p.px[i];
          m := 1;
          for l := j + 1 to p.n do
          begin
            p2.px[m+1] := p.px[l];
            inc(m);
          end;
          for l := 1 to i - 1 do
          begin
            p2.px[m+1] := p.px[l];
            inc(m);
          end;
          add(p.px[i],p.px[j],pp );
          o1 := analize(p1,pp.next) +  analize(p2, pp.next);
          if o1 < otv then
          begin
            otv := o1;
            ou := pp;
          end;
        end;
        if (j = p.n)and (((p.px[1].x - p.px[i].x)*(p.px[j].y - p.px[i].y)
             - (p.px[j].x - p.px[i].x)*(p.px[1].y - p.px[i].y) <> 0)or (((p.px[1].x - p.px[i].x)*(p.px[1].x - p.px[i].x)+
             (p.px[1].y - p.px[i].y)*(p.px[1].y - p.px[i].y)>(p.px[j].y - p.px[i].y)*(p.px[j].y - p.px[i].y) +
             (p.px[j].x - p.px[i].x)*(p.px[j].x - p.px[i].x))))then
        begin
          fl := false;
          p1.n := abs(j - i) + 1;
          p2.n := p.n - p1.n + 2;
          p1.px[1] := p.px[i];
          p1.px[p1.n] := p.px[j];
          for l := 1 to p1.n - 2 do
            p1.px[l+1] := p.px[l + i];
          p2.px[1] := p.px[j];
          p2.px[p2.n] := p.px[i];
          m := 1;
          for l := j + 1 to p.n do
          begin
            p2.px[m+1] := p.px[l];
            inc(m);
          end;
          for l := 1 to i - 1 do
          begin
            p2.px[m+1] := p.px[l];
            inc(m);
          end;
          add(p.px[i],p.px[j],pp );
          o1 := analize(p1,pp.next) +  analize(p2, pp.next);
          if o1 < otv then
          begin
            otv := o1;
            ou := pp;
          end;
        end;
        end;
        inc(j);
      end;
      inc(i);
    end;
    temp := p.px[p.n];
    for i := p.n  downto  2 do
      p.px[i ] := p.px[i - 1];
    p.px[1] := temp;

  end;
  analize := otv;
end;

procedure save;
var
  i : integer;
  pp : ppix;
begin
  pp := outt;
  i := 0;
  while pp <> nil do
  begin
    inc(i);
    pp := pp.next;
  end;
  pp := outt;
  writeln(fout, i);
  while pp <> nil do
  begin
    writeln(fout,pp.px1.x,' ', pp.px1.y,' ',pp.px2.x,' ',pp.px2.y);
    pp := pp.next;
  end;
  close(fout);
end;

procedure execute;
begin
  assign(fout, 'reform.out');
  rewrite(fout);
  writeln(fout, analize(p1, outt));
end;

begin
  load;
  execute;
  save;
end.
