program Zad6;

{$Apptype Console}

{$O+,D-,Q-,R-,I-}

uses
  SysUtils,Windows;

type
  Int64=Extended;
  Point=record
          x,y:Int64;
          num:LongInt;
        end;

  diag=record
          u,v:Longint;
        end;
const
  MaxN=20;

type
  Poly=array[1..MaxN] of Point;

var
  N:LongInt;
  a:poly;
  cnt:Longint;
  k:LongInt;
  ans,ans2:array[1..MaxN] of diag;
  first:Cardinal;


procedure Init;
begin
  Assign(input,'reform.in');
  Reset(input);
  Assign(output,'reform.out');
  Rewrite(output);
end;

procedure Final;
begin
  Close(input);
  Close(output);
end;

procedure InData;
var
  i:Longint;
begin
  first:=GetTickCount;
  Read(N);
  for i:=1 to N do
  with a[i] do
  begin
    Read(x,y);
    num:=i;
  end;
end;

procedure OutAns;
var
  i:LongInt;
begin
  Writeln(cnt);
  Writeln(k);
  for i:=1 to K do
    with ans[i] do
      Writeln(a[u].x:0:0,' ',a[u].y:0:0,' ',a[v].x:0:0,' ',a[v].y:0:0);
  Final;
  halt(0);
end;


function VectP(p1,p2,p3,p4:Point):Int64;
begin
  Result:=(p2.x-p1.x)*(p4.y-p3.y)-(p2.y-p1.y)*(p4.x-p3.x);
end;

function ScalP(p1,p2,p3,p4:Point):Int64;
begin
  Result:=(p2.x-p1.x)*(p4.x-p3.x)+(p2.y-p1.y)*(p4.y-p3.y);
end;


function Peres(p1,p2,p3,p4:Point):Boolean;
begin
  Result:=(VectP(p1,p2,p1,p4)*VectP(p1,p2,p1,p3)<0)and
          (VectP(p3,p4,p4,p1)*VectP(p3,p4,p3,p2)<0);
end;

function PointIn(p:Point; const a:Poly; const N:Longint):Boolean;
var
  p2:Point;
  cnt,i:LongInt;
begin
  p2.x:=1e10;
  p2.y:=1e11+1e10;
  cnt:=0;
  for i:=1 to N-1 do
  if Peres(p,p2,a[i],a[i+1]) then inc(cnt);
  if Peres(p,p2,a[1],a[N]) then inc(cnt);
  Result:=(cnt mod 2)=1;
end;


function NotGr(p1,p2:Point):Boolean;
var
  i,j:Longint;
begin
  Result:=true;
  i:=p1.num;
  j:=i+1; if i+1>N then j:=1;

  if (VectP(p1,a[j],p1,a[j])=0)and(ScalP(p1,a[j],p1,a[j])<0) then Result:=false;

                                               j:=i-1; if j=0 then j:=N;
  if (VectP(p1,a[j],p1,a[j])=0)and(ScalP(p1,a[j],p1,a[j])<0) then Result:=false;
  i:=p2.num;
  j:=i+1; if i+1>N then j:=1;

  if (VectP(p2,a[j],p2,a[j])=0)and(ScalP(p2,a[j],p2,a[j])<0) then Result:=false;
  j:=i-1; if j=0 then j:=N;
  if (VectP(p2,a[j],p2,a[j])=0)and(ScalP(p2,a[j],p2,a[j])<0) then Result:=false;
end;

function Obr(var b:Poly;var N:Longint; const j:Longint):Boolean;
var
  i,j1,N2,j2:LongInt;
  b2:Poly;
  p:Point;
begin
  j1:=j+1; if j1>N then j1:=j1-N;
   j2:=j+2; if j2>N then j2:=j2-N;
  p.x:=(b[j].x+b[j2].x)/2;
  p.y:=(b[j].y+b[j2].y)/2;
  Result:=NotGr(b[j],b[j2])and PointIn(p,b,N);
  if not Result then Exit;
  for i:=j1 to N-1 do
    b[i]:=b[i+1];
  dec(N);
  N2:=2;
  b2[1]:=b[1];
  b2[2]:=b[2];
  for i:=3 to N do
  begin
    if VectP(b2[N2-1],b[N2],b[N2-1],b[i])<>0 then inc(N2);
    b2[N2]:=b[i];
  end;
  if (n2>3)and(VectP(b2[N2-1],b2[N2],b2[N2-1],b[1])=0) then Dec(n2);
  if VectP(b2[N2],b2[1],b2[N2],b[2])=0   then
  begin
    for i:=2 to N2 do
      b2[i-1]:=b2[i];
    dec(N2);
  end;

  b:=b2;
  N:=N2;

end;


procedure TryFind(var a:Poly; N:LongInt; cnt2,k2:Longint);
var
  i,j:Longint;
  b:Poly;
  n2:LongInt;
begin
  if cnt2+1>=cnt then Exit;
  if n<=3 then
  begin
    ans:=ans2;
    cnt:=cnt2+1;
    k:=k2-1;
    Exit;
  end;
if GetTickCount-first>1700 then OutAns;
  for i:=1 to N do
  begin
    b:=a;
    N2:=N;
    if Obr(b,N2,i) then
    begin
      ans2[k2].u:=a[i].num;
      j:=i+2; if j>N then j:=j-N;
      ans2[k2].v:=a[j].num;
      TryFind(b,N2,cnt2+1,k2+1);
    end;
  end;
end;

procedure  Solve;
begin
  k:=0;
  cnt:=MaxLongInt;
  if n=3 then
  begin
    cnt:=1;
    k:=0;
    OutAns;
  end;
  fillchar(ans2,SizeOf(ans2),0);
  TryFind(a,N,0,1);
end;

begin
  Init;
  InData;
  Solve;
  OutAns;
end.