Program P6;
Type TPoint = Record
 X, Y : Integer;
 En : Boolean;
End;
Var F : Text; N, I, DelCount, BCount : Byte; Arr : Array[1..21] of TPoint; Ans, BestAns : Array[1..25] of String; S : String;
 Procedure DelPoint(Pn : Byte);
 Begin
  Arr[Pn].En := False;
  Dec(N);
  Inc(DelCount);
 End;
 Procedure UnDel(Pn : Byte);
 Begin
  Arr[Pn].En := True;
  Inc(N);
  Dec(DelCount);
 End;
 Function GetNext(Pn : Byte) : Byte;
 Var I : Byte;
 Begin
  I := Pn + 1;
  While Not Arr[I].En Do
  Begin
   Inc(I);
   If I > N Then I := 1;
  End;
  GetNext := I;
 End;
 Function GetPrev(Pn : Byte) : Byte;
 Var I : Byte;
 Begin
  If Pn > 1 Then I := Pn - 1 else I := N;
  While Not Arr[I].En Do
  Begin
   Dec(I);
   If I = 0 Then I := N;
  End;
  GetPrev := I;
 End;
 Function InPoly(Pn : Byte) : Boolean;
 Var Prev, Next : Byte;
 Begin
  Prev := GetPrev(Pn);
  Next := GetNext(Pn);
  If (Arr[Pn].X - Arr[Prev].X) * (Arr[Next].Y - Arr[Prev].Y) > (Arr[Pn].Y - Arr[Prev].Y) * (Arr[Next].X - Arr[Prev].X) Then
   InPoly := True else InPoly := False;
 End;
 Procedure CheckRes;
 Begin
  If DelCount < BCount Then
  Begin
   BestAns := Ans;
   BCount := DelCount;
  End;
 End;
 Procedure Rec;
 Var I : Byte;
 Begin
  If N = 3 Then
  Begin
   CheckRes;
   Exit;
  End;
  For I := 1 To N Do
  Begin
   If InPoly(I) Then
   Begin
    Inc(DelCount);
    Str(Arr[GetPrev(I)].X, S);
    Ans[DelCount] := S;
    Str(Arr[GetPrev(I)].Y, S);
    Ans[DelCount] := Ans[DelCount] + ' ' + S;
    Str(Arr[GetNext(I)].X, S);
    Ans[DelCount] := Ans[DelCount] + ' ' + S;
    Str(Arr[GetNext(I)].Y, S);
    Ans[DelCount] := Ans[DelCount] + ' ' + S;
    Dec(DelCount);
    DelPoint(I);
    Rec;
    UnDel(I);
   End;
  End;
 End;
Begin
 Assign(F, 'reform.in');
 ReSet(F);
 Read(F, N);
 For I := 1 To N Do
 Begin
  Read(F, Arr[I].X);
  Read(F, Arr[I].Y);
  Arr[I].En := True;
 End;
 Close(F);
 I := 1;
 BCount:= 255;
 DelCount := 0;
 Rec;
 Assign(F, 'reform.out');
 ReWrite(F);
 WriteLn(F, BCount + 1);
 WriteLn(F, BCount);
 For I := 1 To BCount Do
  WriteLn(F, BestAns[I]);
 Close(F);
End.