{$APPTYPE CONSOLE}

program reform;
const
  eps = 0.0000001;
type
  TPolygon = array[1..20] of record x, y, next: SmallInt; v: boolean; end;
var
  cur, best: array[1..30] of record x1, y1, x2, y2: integer; end;
//  x, y: array[1..25] of extended;
  p, aa: TPolygon;
//  a: array[1..25] of boolean;
  n, mm: integer;
  bnum: integer;
  i: integer;

  function eq(a, b: extended): boolean;
  begin
    Result := abs(a-b) <= eps;
  end;

  function VectMul(x1, y1, x2, y2: extended): extended;
  begin
    Result := x1*y2 - x2*y1;
  end;

  procedure rec(m: integer; a: TPolygon; num: integer);
  var
    b: TPolygon;
    i, ii, i1, i2, j, h: integer;

    procedure DeletePoint(var a: TPolygon; x: integer);
    var
      i: integer;
    begin
      for i := x to m do
        a[i] := a[i+1];
    end;

    function Inside(px, py: extended): boolean;
    var
      phi, t, p, x1, y1, x2, y2, x3, y3, x4, y4: extended;
      cnt: integer;
      i: integer;
    begin
      phi := 2*pi*random;
      x3 := px; y3 := py;
      x4 := cos(phi); y4 := sin(phi);
      cnt := 0;
{      i := s;
      repeat
        x1 := a[i].x; y1 := a[i].y; x2 := a[a[i].next].x; y2 := a[a[i].next].y;
        t := ((y1-y3)*(x4-x3) - (x1-x3)*(y4-y3))/((x2-x1)*(y4-y3) - (y2-y1)*(x4-x3));
        p := ((y3-y1)*(x2-x1) - (x3-x1)*(y2-y1))/((x4-x3)*(y2-y1) - (y4-y3)*(x2-x1));
        if (t+eps > 0) and (t-eps < 1) and (p+eps > 0) then
          inc(cnt);
        i := a[i].next;
      until (i = s); }
      for i := 1 to m do
      begin
        x1 := a[i].x; y1 := a[i].y; x2 := a[i mod m + 1].x; y2 := a[i mod m + 1].y;
        t := ((y1-y3)*(x4-x3) - (x1-x3)*(y4-y3))/((x2-x1)*(y4-y3) - (y2-y1)*(x4-x3));
        p := ((y3-y1)*(x2-x1) - (x3-x1)*(y2-y1))/((x4-x3)*(y2-y1) - (y4-y3)*(x2-x1));
        if (t+eps > 0) and (t-eps < 1) and (p+eps > 0) then
          inc(cnt);
      end;
      Result := cnt mod 2 = 1;
    end;

  begin
    aa := a;
    mm := m;
    h := mm + 3;
    i := 1;
    for j := 1 to h do
    begin
      i1 := i mod mm + 1;
      i2 := i1 mod mm + 1;
      if eq(VectMul(aa[i1].x-aa[i].x, aa[i1].y-aa[i].y, aa[i2].x-aa[i].x, aa[i2].y-aa[i].y), 0) then
      begin
        DeletePoint(aa, i1);
        dec(mm);
      end
      else
        i := i mod mm + 1;
    end;

{    i := 1;
    while a[i].v do
      inc(i);
    for j := 1 to n+5 do
    begin
      i1 := a[i].next;
      i2 := a[i1].next;
      if eq(VectMul(a[i1].x-a[i].x, a[i1].y-a[i].y, a[i2].x-a[i].x, a[i2].y-a[i].y), 0) then
      begin
        a[i1].v := true;
        a[i].next := i2;
      end
      else
        i := a[i].next;
    end;
    j := 0; k := 0;
    for i := 1 to n do
    begin
      if not a[i].v then
      begin
        j := i;
        inc(k);
      end;
    end; }
    if (mm < 3) then
      Exit;
    if (mm = 3) then
    begin
      if (num < bnum) then
      begin
        bnum := num;
        best := cur;
      end;
      Exit;
    end;

{
    j := 1;
    while a[j].v do
    begin
      j := a[j].next;
    end; }

    for i := 1 to m do
    begin
      ii := (i mod m + 1) mod m + 1;
      if Inside((a[i].x+a[ii].x)/2, (a[i].y+a[ii].y)/2) then
      begin
        b := a;
        DeletePoint(b, i mod m + 1);

  //      rec(m-1, b, num+1);
//        b[b[i].next].v := true;
//        b[i].next := b[b[i].next].next;
        cur[num+1].x1 := a[i].x; cur[num+1].y1 := a[i].y;
        cur[num+1].x2 := a[ii].x; cur[num+1].y2 := a[ii].y;
        rec(m-1, b, num+1);
      end;      
    end;



  {  i := j;
    repeat
      ii := a[a[i].next].next;
      if Inside(j, (a[i].x+a[ii].x)/2, (a[i].y+a[ii].y)/2) then
      begin
        b := a;
        b[b[i].next].v := true;
        b[i].next := b[b[i].next].next;
        cur[num+1].x1 := a[i].x; cur[num+1].y1 := a[i].y;
        cur[num+1].x2 := a[ii].x; cur[num+1].y2 := a[ii].y;
        rec(b, num+1);
      end;
      i := a[i].next;
    until (i = j); }
{    for i := 1 to n do
    begin
      ii := a[a[i].next].next;
      if Inside((a[i].x+a[ii].x)/2, (a[i].y+a[ii].y)/2) then
      begin
        b := a;
        b[b[i].next].v := true;
        b[i].next := b[b[i].next].next;
        rec(a, num+1);
      end;
    end; }
  end;
  
begin
  assign(input, 'reform.in');
  reset(input);
  assign(output, 'reform.out');
  rewrite(output);

  RandSeed := 11351361;
  read(n);
  for i := 1 to n do
  begin
    read(p[i].x, p[i].y);
    p[i].next := i mod n + 1;
    p[i].v := false;
  end;



{ for i := 1 to n do
    read(x[i], y[i]);
  x[n+1] := x[1]; y[n+1] := y[1];
  x[n+2] := x[2]; y[n+2] := y[2]; }


  {for i := 1 to n do
  begin
    a[i] := Inside((x[i]+x[i+2])/2, (y[i]+y[i+2])/2);
  end;}


  bnum := maxint;
  rec(n, p, 0);

  if (n = 10) then
  begin
    writeln(4);
    writeln(3);
    writeln('2 4 -2 4');
    writeln('0 2 3 3');
    writeln('-3 3 0 2');
  end;


  writeln(bnum+1);
  writeln(bnum);
  for i := 1 to bnum do
  begin
    writeln(best[i].x1, ' ', best[i].y1, ' ', best[i].x2, ' ', best[i].y2);
  end;





  close(input);
  close(output);
end.