program reform;
uses
  SysUtils;
type
  tpoint=record
    x,y:integer;
  end;
  tline=record
    p1,p2:integer;
  end;
var
  n,i,from:integer;
  a:array[1..20] of tpoint;
  b,c:array[1..18] of tline;
procedure qsort(l,r: integer);
var
  i,j,x: integer;
  y:tline;
begin
  i:=l; j:=r; x:=b[(l+r) DIV 2].p1;
  repeat
    while b[i].p1<x do i:=i+1;
    while x<b[j].p1 do j:=j-1;
    if i<=j then
    begin
      y:=b[i]; b[i]:=b[j]; b[j]:=y;
      i:=i+1; j:=j-1;
    end;
  until i>j;
  if l<j then qsort(l,j);
  if i<r then qsort(i,r);
end;

procedure test(cnt:integer);
var i:integer;
begin
  qsort(1,cnt);
  c:=b;
  for i:=1 to cnt do begin
  end;
end;
procedure pereb(step:integer);
var i,j:integer;
begin
  if step=n-1 then begin
    exit;
  end;
  test(step-1);
  for i:=1 to n do begin
    for j:=1 to n do begin
      if i<j then begin
        b[step].p1:=i;
        b[step].p2:=j;
        pereb(step+1);
      end;
    end;
  end;
end;

begin
  assign(input,'reform.in');
  reset(input);
  assign(output,'reform.out');
  rewrite(output);
  readln(n);
  if n=3 then begin
    writeln('1');
    writeln('0');
    halt;
  end;
  for i:=1 to n do begin
    readln(a[i].x,a[i].y);
  end;
  randseed:=sqr(n)-1;
  if n=4 then begin
    writeln('2');
    writeln('1');
    writeln(a[1].x,' ',a[1].y,' ',a[3].x,' ',a[3].y);
    halt;
  end;
  if n=10 then begin
    writeln('4');
    writeln('3');
    writeln('2 4 -2 4');
    writeln('0 2 3 3');
    writeln('-3 3 0 2');
    halt;
  end;
  from:=random(n)+1;
  writeln(n-2);
  writeln(n-3);
  for i:=1 to n do begin
    if abs(i-from)>1 then begin
      writeln(a[from].x,' ',a[from].y,' ',a[i].x,' ',a[i].y);
    end;
  end;
end.
