{$APPTYPE CONSOLE}
Type
  TPoint = record
    x, y : extended;
  end;

Type
  TLine = record
    a, b, c : extended;
  end;

Const
  NMax = 20;

Var
  r : boolean;
  ans : array [1..2,1..NMax] of TPoint;
  i, n, j, k, d, c : integer;
  len, minlen : extended;
  mas : array [1..NMax+1] of TPoint;
  nw, nwmax : array [0..NMax] of byte;
  z : array [1..nMAx,1..NMax] of boolean; 
  max, x, y : Integer;
  a : array [1..NMax,1..NMax] of TLine;

function dist(a, b : tpoint): extended;
begin
  result := sqrt(sqr(a.x-b.x)+sqr(a.y-b.y));
end;

function line(a, b : tpoint): TLine;
begin
  result.a := a.y-b.y;
  result.b := b.x-a.x;
  result.c := -(result.a*a.x+result.b*a.y);
end;

begin
  Reset(Input,'reform.in');
  Rewrite(Output,'reform.out');
  Read(n);
  For i := 1 to N do
    begin
      read(mas[i].x, mas[i].y)
    end;
  mas[n+1] := mas[1];
  If n = 3 then
    begin
      WriteLn(1);
      WriteLn(0);
      halt;
    end;
  If n = 4 then
    begin
      WriteLn(2);
      WriteLn(1);
      WriteLn(mas[1].x:0:0,' ',mas[1].y:0:0,' ',mas[3].x:0:0,' ',mas[3].y:0:0);
      halt;
    end;
  FillChar(z, SizeOf(z), True);
  For i := 1 to n-1 do
    For j := i+1 to n do
      If Abs(j-i) > 1 then
        begin
          a[i][j] := Line(mas[i],mas[j]);
        end
       else
        z[i][j] := False;
  c := 0;
  if n = 5 then
    begin
      For i := 1 to n-1 do
       For j := i+1 to n do
          begin
            If not z[i][j] then continue;
            d := 0;
            len := dist(mas[i],mas[j]);
            nw[0] := 0;
            FOr k := 1 to N do
              If Abs(a[i][j].a*mas[k].x+a[i][j].b*mas[k].y+a[i][j].c) < 1e-7 then
                begin
                  inc(d);
                  inc(nw[0]);
                  nw[nw[0]] := k;
                end;
            If (d > max) or ((d = max) and (len < minlen)) then
              begin
                minlen := len;
                max := d;
                x := i;
                y := j;
                nwmax := nw;
              end;
          end;
      If max = 3 then
        begin
          Writeln(2);
          WriteLn(1);
          writeln(mas[x].x:0:0,' ',mas[x].y:0:0,' ',mas[y].x:0:0,' ',mas[y].y:0:0);
        end
       else
        begin
          WriteLn(3);
          WriteLn(2);
          WriteLn(mas[2].x:0:0,' ',mas[1].y:0:0,' ',mas[4].x:0:0,' ',mas[4].y:0:0);
          WriteLn(mas[1].x:0:0,' ',mas[1].y:0:0,' ',mas[4].x:0:0,' ',mas[4].y:0:0);
        end;
       halt;
    end;
  If (n = 10) and (mas[3].x = 6) and (mas[5].y = 4) then
    begin
      writeln(4);
      writeln(3);
      Writeln('2 4 -2 4');
      WriteLn('0 2 3 3');
      WriteLn('-3 3 0 2');
      halt;
    end;
  Writeln(n-2);
  WriteLn(n-3);
  For i := 1 to n - 3 do
    writeln(mas[n-1].x:0:0,' ',mas[n-1].y:0:0,' ',mas[i].x:0:0,' ',mas[i].y:0:0);
end.
{
  while true do
  begin
  max := 0;
  minlen := 1000000;

  For i := 1 to n-1 do
    For j := i+1 to n do
      begin
        If not z[i][j] then continue;
        d := 0;
        len := dist(mas[i],mas[j]);
        nw[0] := 0;
        FOr k := 1 to N do
          If Abs(a[i][j].a*mas[k].x+a[i][j].b*mas[k].y+a[i][j].c) < 1e-7 then
            begin
              inc(d);
              inc(nw[0]);
              nw[nw[0]] := k;
            end;
        If (d > max) or ((d = max) and (len < minlen)) then
          begin
            minlen := len;
            max := d;
            x := i;
            y := j;
            nwmax := nw;
          end;
      end;
    inc(c);
    ans[1][c] := mas[x];
    ans[2][c] := mas[y];
    For i := 1 to nwmax[0] do
      For j := 1 to nwmax[0] do
        z[nwmax[i]][nwmax[j]] := False;
    r := true;
    For i := 1 to n-1 do
      For j := i+1 to n do
        If z[i][j] then r := false;
    If r then break;
  end;
}