#include <stdio.h>
#include <memory.h>

struct Poly {
	int n;
	int id[22];
};

int n;
int px[22], py[22];

Poly init;
int ans;
int lnum;
int best[30][2];

int cn;
int clnum;
int curr[30][2];

inline int vect(int x1, int y1, int x2, int y2) {
	return x1*y2-x2*y1;
}

void Solve(Poly p) {
	int i, j, u, v;
	p.id[p.n+1] = p.id[1];
	for (i = 1; i<=p.n; i++) {
		int cv = vect(px[p.id[i]]-px[p.id[i-1]], py[p.id[i]]-py[p.id[i-1]]
					, px[p.id[i+1]]-px[p.id[i-1]], py[p.id[i+1]]-py[p.id[i-1]]);
		if (cv==0) {
			p.n--;
			for (j = i; j<=p.n+1; j++)
				p.id[j] = p.id[j+1];
			p.id[p.n] = p.id[0];
			i--;
		}
	}
	if (p.n==3) {
		cn++;
		if (cn < ans) {
			ans = cn;
			lnum = clnum;
			memcpy(best, curr, sizeof(best));
		}
		cn--;
		return;
	}
	if (cn + p.n-2 >= ans)
		return;
	for (i = 1; i<=p.n; i++) {
		int cv = vect(px[p.id[i]]-px[p.id[i-1]], py[p.id[i]]-py[p.id[i-1]]
					, px[p.id[i+1]]-px[p.id[i-1]], py[p.id[i+1]]-py[p.id[i-1]]);
		if (cv>0) {
			Poly np;
			np.n = p.n-1;
			v = 0;
			for (u = 0; u<=p.n+1; u++) {
				np.id[v] = p.id[u];
				if (u!=i)
					v++;
			}
			curr[clnum][0] = p.id[i-1];
			curr[clnum][1] = p.id[i+1];
			cn++;
			clnum++;
			Solve(np);
			clnum--;
			cn--;
		}
	}
}

int main(int argc, char **argv) {
	freopen("reform.in", "r", stdin);
	freopen("reform.out", "w", stdout);
	scanf("%d", &n);
	int i;
	for (i = 0; i<n; i++)
		scanf("%d%d", &px[i], &py[i]);
	init.n = n;
	for (i = 0; i<n; i++)
		init.id[i] = i;
	init.id[n] = 0;
	init.id[n+1] = 1;
	ans = 1000000000;
	Solve(init);
	printf("%d\n", ans);
	printf("%d\n", lnum);
	for (i = 0; i<lnum; i++)
		printf("%d %d %d %d\n", px[best[i][0]], py[best[i][0]], px[best[i][1]], py[best[i][1]]);
	return 0;
}