#include <stdio.h>
#include <memory.h>

inline int uabs(int a) { return (a<0 ? -a : a); }
struct Poly {
	int n;
	int id[22];
};

int n;
int px[22], py[22];

Poly init;
int ans;
int lnum;
int best[30][2];

int cn;
int clnum;
int curr[30][2];

int parr[30];
int an;

inline int vect(int x1, int y1, int x2, int y2) {
	return x1*y2-x2*y1;
}

bool inTr(int v, int a, int b, int c) {
	int vc, v0;
	vc = vect(px[v]-px[a], py[v]-py[a], px[b]-px[a], py[b]-px[a]);
	v0 = vect(px[c]-px[a], py[c]-py[a], px[b]-px[a], py[b]-py[a]);
	if (vc==0) return false;
	if ((vc<0)^(v0<0)) return false;

	vc = vect(px[v]-px[b], py[v]-py[b], px[c]-px[b], py[c]-px[b]);
	v0 = vect(px[a]-px[b], py[a]-py[b], px[c]-px[b], py[c]-py[b]);
	if (vc==0) return false;
	if ((vc<0)^(v0<0)) return false;

	vc = vect(px[v]-px[c], py[v]-py[c], px[a]-px[c], py[a]-px[c]);
	v0 = vect(px[b]-px[c], py[b]-py[c], px[a]-px[c], py[a]-py[c]);
	if (vc==0) return false;
	if ((vc<0)^(v0<0)) return false;
}

bool onLine(int v, int a, int b) {
	int pv = vect(px[v]-px[a], py[v]-py[a], px[v]-px[b], py[v]-py[b]);
	if (pv!=0)
		return false;
	pv = ((px[v]-px[a])*(px[v]-px[b])) + ((py[v]-py[a])*(py[v]-py[b]));
	return (pv<=0);
}

void Solve(Poly p) {
	int i, j, u, v;
	p.id[p.n+1] = p.id[1];
	for (i = 1; i<=p.n; i++) {
		int cv = vect(px[p.id[i]]-px[p.id[i-1]], py[p.id[i]]-py[p.id[i-1]]
					, px[p.id[i+1]]-px[p.id[i-1]], py[p.id[i+1]]-py[p.id[i-1]]);
		if (cv==0) {
			p.n--;
			for (j = i; j<=p.n+1; j++)
				p.id[j] = p.id[j+1];
			p.id[p.n] = p.id[0];
			i--;
		}
	}
	if (p.n==3) {
		cn++;
		if (cn < ans) {
			ans = cn;
			lnum = clnum;
			memcpy(best, curr, sizeof(best));
		}
		cn--;
		return;
	}
	if (cn + p.n-2 >= ans)
		return;
	for (i = 1; i<=p.n; i++) {
		int cv = vect(px[p.id[i]]-px[p.id[i-1]], py[p.id[i]]-py[p.id[i-1]]
					, px[p.id[i+1]]-px[p.id[i-1]], py[p.id[i+1]]-py[p.id[i-1]]);
		bool ok = true;
		for (j = 0; j<p.n; j++)
			if (inTr(p.id[j], p.id[i-1], p.id[i], p.id[i+1])) {
				ok = false;
				break;
			}
		if (ok && (cv>0)) {
			Poly np;
			np.n = p.n-1;
			v = 0;
			for (u = 0; u<=p.n+1; u++) {
				np.id[v] = p.id[u];
				if (u!=i)
					v++;
			}
			int vcln = clnum;
			int ap = p.id[i-1];
			int bp = p.id[i+1];
			an = 0;
			for (j = 1; j<=p.n; j++) {
				if (onLine(p.id[j], ap, bp)) {
					parr[an] = j;
					an++;
				}
			}
			if (an==2) {
				curr[clnum][0] = p.id[i-1];
				curr[clnum][1] = p.id[i+1];
				clnum++;
			}
			else {
				curr[clnum][0] = parr[2];
				curr[clnum][1] = parr[1];
				clnum++;
			}
			cn++;
			Solve(np);
			clnum = vcln;
			cn--;
		}
	}
}

int main(int argc, char **argv) {
	freopen("reform.in", "r", stdin);
	freopen("reform.out", "w", stdout);
	scanf("%d", &n);
	int i;
	for (i = 0; i<n; i++)
		scanf("%d%d", &px[i], &py[i]);
	init.n = n;
	for (i = 0; i<n; i++)
		init.id[i] = i;
	init.id[n] = 0;
	init.id[n+1] = 1;
	ans = 1000000000;
	Solve(init);
	printf("%d\n", ans);
	printf("%d\n", lnum);
	for (i = 0; i<lnum; i++)
		printf("%d %d %d %d\n", px[best[i][0]], py[best[i][0]], px[best[i][1]], py[best[i][1]]);
	return 0;
}