{$apptype console}
{$o-,r+,q+}
{$maxstacksize 30000000}
uses
  sysutils, math;

type
  int = longint;
  real = extended;

const
  maxn = 1000;
  maxm = 1000;

var
  n, m : int;  
  a : array[1..maxn, 1..maxm] of int;
  i, j : int;
  w : array[1..maxm, 1..maxn] of boolean;
  ans : int;
  di : array[1..4] of int = (0, 0, -1, 1);
  dj : array[1..4] of int = (1, -1, 0, 0);
  ch : char;

procedure dfs(i, j : int);
var
  k : int;
  ni, nj : int;
begin
  w[i][j] := true;
  for k := 1 to 4 do
  begin
    ni := i + di[k];
    nj := j + dj[k];
    if (1 <= ni) and (ni <= n) and (1 <= nj) and (nj <= m) then
    begin
      if a[ni][nj] = 1 - a[i][j] then
      begin
        if not w[ni][nj] then
          dfs(ni, nj);
      end;
    end;
  end;
end;

begin 
  reset(input, 'board.in');
  rewrite(output, 'board.out');
  n := 8;
  m := 8;
  for i := 1 to n do
  begin
    for j := 1 to m do
    begin
      read(ch);
      assert(ch in ['B', 'W']);
      a[i][j] := 1;
      if ch = 'B' then
        a[i][j] := 0;
    end;
    readln;
  end;

  ans := 0;

  for i := 1 to n do
    for j := 1 to m do
      if not w[i][j] then
      begin
        inc(ans);
        dfs(i, j);
      end;

  writeln(ans);
end. 