{$APPTYPE CONSOLE}
uses
  Math;
  
type
  int = longint;

function gcd(a, b: int): int;
begin
  while (b > 0) do
  begin
    result := b;
    b := a mod b;
    a := result;
  end;
  result := a;
end;

var
  i, j, n, x: int;
  ans, how: array[1..1000000] of int;
  isSquare: array[1..1000000] of boolean;

begin
  reset(input, 'hyper.in');
  rewrite(output, 'hyper.out');
  read(n);
  for i := 1 to floor(sqrt(n)) do
    isSquare[i * i] := true;
  ans[1] := 1;
  how[1] := 1;
  for i := 2 to n do
  begin
    ans[i] := i;
    how[i] := 1;
    for j := 1 to floor(sqrt(i - 1)) do
    begin
      x := i - j * j;
      if (isSquare[x]) and (gcd(j, x) = 1) then
      begin
        ans[i] := 2;
        how[i] := -j;
        break;
      end;
      if (ans[x] + 1 < ans[i]) then
      begin
        ans[i] := ans[x] + 1;
        how[i] := j;
      end;
    end;
  end;
  writeln(ans[n]);
  while (n > 0) do
  begin
    if (how[n] < 0) then
    begin
      writeln(-how[n], ' ', round(sqrt(n - sqr(how[n]))));
      halt;
    end;
    write(how[n]);
    dec(n, sqr(how[n]));
    if (n > 0) then
      write(' ');
  end;
  writeln;
end.
