{$R+,Q+,O-}
program brackets;

uses
    sysutils;

const
	maxn = 2000;

var
	s, r: string;
	lb, rb, i, j: longint;
	bal: array [0..maxn] of longint;
	repl, repr: longint;
	min: longint;
	can: boolean;

begin
	reset(input, 'brackets.in');
	rewrite(output, 'brackets.out');

	readln(s);

	assert(eof);
	assert(length(s) <= 2000);
	for i := 1 to length(s) do
		assert(s[i] in ['(', ')', '[', ']']);

	lb := -1;
	rb := -1;
   	r := '';
   	for i := 1 to length(s) do begin
   		if s[i] in ['(', ')'] then begin
   			r := r + s[i]
   		end else begin
   			if (s[i] = '[') and (lb = -1) then
   				lb := length(r);
   			if (s[i] = ']') then
   				rb := length(r);
   		end;
   	end;

	bal[0] := 0;
	for i := 1 to length(r) do
		if r[i] = '(' then
			bal[i] := bal[i - 1] + 1
		else
			bal[i] := bal[i - 1] - 1;

	min := 0;
	if lb <> -1 then begin
		for i := lb + 1 to length(r) do begin
			if bal[i] < min then
				min := bal[i];
		end;
	end;
	repl := -min;
	if min < 0 then begin
		for i := lb + 1 to length(r) do
			bal[i] := bal[i] - min;
	end;

	if min = 0 then
		lb := -1;

	repr := 0;
	if (rb > lb) and (bal[length(r)] > 0) then begin
		repr := bal[length(r)];
		for i := rb to length(r) do
			bal[i] := bal[i] - repr;
	end else begin
		rb := lb;
	end;

	can := true;
	for i := 1 to length(r) do begin
		if bal[i] < 0 then
			can := false;
	end;
	if bal[length(r)] <> 0 then
		can := false;

    if lb = -1 then
        lb := 0;
    if rb = -1 then
        rb := lb;
	if can then begin
        for i := 1 to lb do
            write(r[i]);
        for i := 1 to repl do
            write('(');
        for i := lb + 1 to rb do
            write(r[i]);
		for i := 1 to repr do
			write(')');
		for i := rb + 1 to length(r) do
			write(r[i]);
		writeln;
	end else begin
		writeln('Impossible');
	end;	

	close(input);
	close(output);
end.