{$APPTYPE CONSOLE}

type
  int = longint;

procedure impossible;
begin
  writeln('Impossible');
  halt;
end;

var
  s: string;
  i, j, open, close, openbr, closebr: int;
  depth: int = 0;
  balance: int = 0;

begin
  reset(input, 'brackets.in');
  rewrite(output, 'brackets.out');
  readln(s);

  for i := 1 to length(s) do
  begin
    if (s[i] = '(') then
      inc(balance)
    else if (s[i] = ')') then
      dec(balance);
  end;

  close := length(s);
  while (close > 0) and (s[close] <> ']') do
    dec(close);
  open := 1;
  while (open <= length(s)) and (s[open] <> '[') do
    inc(open);

  openbr := 0;
  closebr := 0;
  if (open > length(s)) then
  begin
    closebr := balance;
    if (closebr < 0) then
      impossible;
  end
  else if (close = 0) then
  begin
    openbr := -balance;
    if (openbr < 0) then
      impossible;
  end
  else if (open > close) then
  begin
    if (balance > 0) then
      closebr := balance
    else
      openbr := -balance;
  end
  else
  begin
    openbr := length(s);
    closebr := openbr + balance;
  end;
    
  for i := 1 to length(s) do
  begin
    if (depth < 0) then
      impossible;
    if (s[i] = '(') then
    begin
      inc(depth);
      continue;
    end;
    if (s[i] = ')') then
    begin
      dec(depth);
      continue;
    end;
    if (i = open) then
    begin
      inc(depth, openbr);
      continue;
    end;
    if (i = close) then
    begin
      dec(depth, closebr);
    end;
  end;
  if (depth <> 0) then
    impossible;

  for i := 1 to length(s) do
  begin
    if (s[i] in ['(', ')']) then
    begin
      write(s[i]);
      continue;
    end;
    if (i = open) then
    begin
      for j := 1 to openbr do
        write('(');
      continue;
    end;
    if (i = close) then
    begin
      for j := 1 to closebr do
        write(')');
      continue;
    end;
  end;
  writeln;
end.