{$R+,Q+,I+,O-}
{//$R-,Q-,I-,O+}
{$APPTYPE CONSOLE}

uses
  SysUtils;

type
  int = longint;

const
  NMAX = 10000;
  MMAX = 1000;

var
  k, l, r, i, j, n, m: int;
  x, y: array[1..NMAX] of int;
  a, b, c: int;
  d: array[1..MMAX, 1..NMAX] of boolean;
  v: array[boolean, 1..NMAX] of int;
  cur, equal: boolean;

begin
  reset(input, 'candles.in');
  rewrite(output, 'candles.out');
  read(n, m, r);
  cur := false;
  for i := 1 to n do begin
    read(x[i], y[i]);
    v[cur, i] := i;
  end;
  for j := 1 to m do begin
    read(a, b, c);
    for i := 1 to n do begin
      d[j, i] := (a * x[i] + b * y[i] + c > 0);
    end;
  end;
  for j := 1 to m do begin
    cur := not cur;
    l := 1;
    r := n;
    for i := 1 to n do begin
      k := v[not cur, i];
      if d[j, k] then begin
        v[cur, l] := k;
        inc(l);
      end else begin
        v[cur, r] := k;
        dec(r);
      end;
    end;
  end;

  for i := 1 to n - 1 do begin
    equal := true;
    k := v[cur, i];
    l := v[cur, i + 1];
    for j := 1 to m do begin
      if d[j, k] <> d[j, l] then begin
        equal := false;
        break;
      end;
    end;
    if equal then begin
      write('YES');
      halt(0);
    end;
  end;
  write('NO');
end.
