import java.util.Scanner;
import java.io.File;
import java.io.IOException;
import java.io.PrintWriter;

public class ngon_dp {
    private static final int INF = 1000000000;
    private static final String INPUT_FILE = "ngon.in";
    private static final String OUTPUT_FILE = "ngon.out";

    private int n;
    private int l;
    
    private int cnt;
    private int[] a;

    public static void main(String[] args) throws IOException {
        ngon_dp sol = new ngon_dp();
        sol.read();
        sol.solve();
        sol.write();
    }

    private void read() throws IOException {
        Scanner in = new Scanner(new File(INPUT_FILE));
        n = in.nextInt();
        l = in.nextInt();
    }
    
    private void solve() {
        cnt = 0;
        a = new int[n + 200];
        n--;
        for (int i = 0; i < n; i++) {
            a[cnt] = 1;
            cnt++;
        }
        int sum = n;
        int i1 = 0;
        while (true) {
            if (sum > l)
                break;
            a[cnt] = sum;
            cnt++;
            sum = sum * 2 - a[i1];
            i1++;
        }
    }
    
    private void write() throws IOException {
        PrintWriter out = new PrintWriter(new File(OUTPUT_FILE));
        out.println(cnt);
        for (int i = 0; i < cnt; i++)
            out.print(a[i] + " ");
        out.close();
    }
}
