import java.util.Scanner;
import java.util.Locale;
import java.io.File;
import java.io.IOException;
import java.io.PrintWriter;

public class oil_dp_bad {
    private static final int INF = 1000000000;
    private static final String INPUT_FILE = "oil.in";
    private static final String OUTPUT_FILE = "oil.out";

    private int n;
    private int[] a;
    private int[] b;
    private int aa;
    private int bb;
    private double answer;

    public static void main(String[] args) throws IOException {
        oil_dp_bad sol = new oil_dp_bad();
        sol.read();
        sol.solve();
        sol.write();
    }

    private void read() throws IOException {
        Scanner in = new Scanner(new File(INPUT_FILE));
        n = in.nextInt();
        aa = in.nextInt();
        bb = in.nextInt();
        a = new int[n];
        b = new int[n];
        for (int i = 0; i < n; i++) {
            a[i] = in.nextInt();
            b[i] = in.nextInt();
        }
    }
    
    private void solve() {
        int minA = 0;
        int minB = 0;
        for (int i = 0; i < n; i++) {
            if (a[minA] > a[i])
                minA = i;
            if (b[minB] > b[i])
                minB = i;
        }
        answer = 0;
        if (minA == minB) {
            if (1.0 * aa / a[minA] < 1.0 * bb / b[minB]) {
                answer = 1.0 * bb / b[minB];
                double tans = 0;
                for (int i = 0; i< n; i++) {
                    if (i == minB)
                        return;
                    tans = Math.max(tans, 1.0 * aa / a[i]);
                }
                answer += tans;
            } else {
                answer = 1.0 * aa / a[minA];
                double tans = 0;
                for (int i = 0; i< n; i++) {
                    if (i == minA)
                        return;
                    tans = Math.max(tans, 1.0 * bb / b[i]);
                }
                answer += tans;
            }
        } else {
            answer = (1.0 * aa / a[minA]) + (1.0 * bb / b[minB]);
        }
    }
    
    private void write() throws IOException {
        PrintWriter out = new PrintWriter(new File(OUTPUT_FILE));
        out.printf(Locale.US, "%1$f", new Object[] {Double.valueOf(answer)});
        out.close();
    }
}
