import java.util.Scanner;
import java.io.File;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Arrays;

public class perms_dp {
    private static final int INF = 1000000000;
    private static final String INPUT_FILE = "perms.in";
    private static final String OUTPUT_FILE = "perms.out";

    private int n;

    private boolean[] w;
    private byte[] dig;

    private int answer;
    private byte[] ans;
    private byte[] ansd;

    private int d;
    private byte[][] pv;

    public static void main(String[] args) throws IOException {
//        long time1 = System.currentTimeMillis();
        perms_dp sol = new perms_dp();
        sol.read();
        sol.solve();
        sol.write();
//        long time2 = System.currentTimeMillis();
//        long dt = time2 - time1;
//        long ss = dt / 1000;
//        long ms = dt % 1000;
//        System.out.println(ss + ":" + (ms / 100) % 10 +  (ms / 10) % 10  +  (ms / 1) % 10 );
    }

    private void read() throws IOException {
        Scanner in = new Scanner(new File(INPUT_FILE));
        n = in.nextInt();
        pv = new byte[n + 1][n];
        w = new boolean[n + 1];
        for (int i = n - 1; i >= 0; i--) {
            pv[0][i] = in.nextByte();
            w[pv[0][i]] = true;
        }
    }
    
    private void solve() {
        byte[] iv = new byte[n];
        System.arraycopy(pv[0], 0, iv, 0, n);
        byte[] ip = new byte[n];
        for (byte i = 0; i < n; i++)
            ip[i] = i;
        answer = -1;
        ansd = new byte[n];
        d = 0;
        dig = new byte[n];
        sol(0);    
       
        d = 0;
        while (true) {
            if (iv[0] == 0) {
                iv[0] = ansd[d];
                d++;
            }
            if (iv[0] == 1)
                break;
            int l = 0;
            int r = iv[0] - 1;
            while (l < r) {
                byte tmp = iv[l];
                iv[l] = iv[r];
                iv[r] = tmp;
                tmp = ip[l];
                ip[l] = ip[r];
                ip[r] = tmp;
                l++;
                r--;
            }
        }

        for (int i = 0; i < n; i++) {
            for (int j = 1; j < n; j++) {
                if (ip[j - 1] > ip[j]) {
                    byte tmp = iv[j - 1];
                    iv[j - 1] = iv[j];
                    iv[j] = tmp;
                    tmp = ip[j - 1];
                    ip[j - 1] = ip[j];
                    ip[j] = tmp;
                }
            }
        }
        Arrays.fill(w, false);
        for (int i = 0; i < n; i++) {
            w[iv[i]] = true;
        }
        for (int i = 0; i < n; i++) {
            if (iv[i] == 0) {
                for (byte d = 1 ; d <= n; d++) {
                    if (!w[d]) {
                        w[d] = true;
                        iv[i] = d;
                        break;
                    }
                }
            }
        }
        ans = iv;
    }

    private void sol(int cnt) {
        byte[] lpv = pv[d];
        while (lpv[0] > 1) {
            cnt++;
            int l = 0;
            int r = lpv[0] - 1;
            while (l < r) {
                byte tmp = lpv[l];
                lpv[l] = lpv[r];
                lpv[r] = tmp;
                l++;
                r--;
            }
        }
        if (lpv[0] == 0) {
            for (byte i = 1; i <= n; i++) {
                if (w[i]) 
                    continue;
                dig[d] = i;
                w[i] = true;
                System.arraycopy(lpv, 0, pv[d + 1], 0, n);
                d++;
                pv[d][0] = i;
                sol(cnt);
                d--;
                w[i] = false;
            }
        } else if (lpv[0] == 1) {
            if (answer < cnt) {
                answer = cnt;
                System.arraycopy(dig, 0, ansd, 0, n);
            }
        }
    }
    
    private void write() throws IOException {
        PrintWriter out = new PrintWriter(new File(OUTPUT_FILE));
        out.println(answer);
        for (int i = n - 1; i >= 0; i--)
            out.print(ans[i] + " ");
        out.close();
    }
}
