program problem;

uses
	math, sysutils;

const
	maxn = 500;

var
	i, j, m, n: longint;
	a: array [1..maxn, 1..maxn] of longint;
	k, l1, l2, max1, max2, best: longint;
	x1, y1, x2, y2: longint;

begin
	reset(input, 'problem.in');
	rewrite(output, 'problem.out');

	readln(m, n);
	assert((2 <= m) and (m <= 500) and (2 <= n) and (n <= 500));
	for i := 1 to m do begin
		for j := 1 to n do begin
			read(a[i][j]);
			assert(abs(a[i][j]) <= 10000000);
		end;
		readln;
	end;

	best := -maxlongint;
	for i := 1 to m do begin
		for j := i + 1 to m do begin
			max1 := -maxlongint;
			max2 := -maxlongint;
			for k := 1 to n do begin
				if a[i][k] + a[j][k] > max1 then begin
					l2 := l1;
					max2 := max1;
					l1 := k;
					max1 := a[i][k] + a[j][k];
				end else if	a[i][k] + a[j][k] > max2 then begin
					l2 := k;
					max2 := a[i][k] + a[j][k];
				end;
			end;
			if max1 + max2 > best then begin
				best := max1 + max2;
				x1 := i;
				y1 := min(l1, l2);
				x2 := j;
				y2 := max(l1, l2);
			end;
		end;
	end;

	writeln(best);
	writeln(x1, ' ', y1, ' ', x2, ' ', y2);

	close(input);
	close(output);
end.
