{$apptype console}
{$o+,r-,q-}
uses
  SysUtils, Math;

const
  inf = 1000000000;
  INPUT_FILE = 'problem.in';
  OUTPUT_FILE = 'problem.out';
  MAXN = 500;

type
  int = longint;

var
  n, m: int;
  a: array[1..MAXN, 1..MAXN] of int;
  r1, r2, c: int;
  i, j: int;
  max1, max2: int;
  answer: int;
  sum: int;
  c1, c2: int;
  ar1, ar2, ac1, ac2: int;

begin
  reset(input, INPUT_FILE);
  rewrite(output, OUTPUT_FILE);
  read(n, m);
  for i := 1 to n do
    for j := 1 to m do
      read(a[i][j]);
  if (n < 2) or (m < 2) then
    halt(1);

  ar1 := -1;
  ar2 := -1;
  ac1 := -1;
  ac2 := -1;
  answer := -inf;
  for r1 := 1 to n do
    for r2 := r1 + 1 to n do
    begin
      c1 := -1;
      c2 := -1;
      max1 := -inf;
      max2 := -inf;
      for c := 1 to m do
      begin
        sum := a[r1][c] + a[r2][c];
        if max1 < sum then
        begin
          max2 := max1;
          max1 := sum;
          c2 := c1;
          c1 := c;
        end else if max2 < sum then
        begin
          max2 := sum;
          c2 := c;
        end;
      end;
      if answer < max1 + max2 then
      begin
        answer := max1 + max2;
        ar1 := r1;
        ar2 := r2;
        ac1 := c1;
        ac2 := c2;
      end;
    end;
  writeln(answer);
  writeln(min(ar1, ar2), ' ', min(ac1, ac2), ' ', max(ar1, ar2), ' ', max(ac1, ac2));
end.