{$apptype console}
{$o+,r-,q-}
uses
  SysUtils, Math;

const
  inf = 1000000000;
  INPUT_FILE = 'problem.in';
  OUTPUT_FILE = 'problem.out';
  MAXN = 500;

type
  int = longint;

var
  n, m: int;
  a: array[1..MAXN, 1..MAXN] of int;
  r1, r2: int;
  i, j: int;
  answer: int;
  c1, c2: int;
  ar1, ar2, ac1, ac2: int;
  sum: int;

begin
  reset(input, INPUT_FILE);
  rewrite(output, OUTPUT_FILE);
  read(n, m);
  for i := 1 to n do
    for j := 1 to m do
      read(a[i][j]);
  if (n < 2) or (m < 2) then
    halt(1);

  ar1 := -1;
  ar2 := -1;
  ac1 := -1;
  ac2 := -1;
  answer := -inf;
  for r1 := 1 to n do
    for r2 := r1 + 1 to n do
    begin
      for c1 := 1 to m do
        for c2 := c1 + 1 to m do
        begin
          sum := a[r1][c1] + a[r1][c2] + a[r2][c1] + a[r2][c2];
          if answer < sum then
          begin
            answer := sum;
            ar1 := r1;
            ar2 := r2;
            ac1 := c1;
            ac2 := c2;
          end;
        end;
    end;
  writeln(answer);
  writeln(ar1, ' ', min(ac1, ac2), ' ', ar2, ' ', max(ac1, ac2));
end.