{$o+,q-,r-}
{$APPTYPE console}

uses
    Math, SysUtils;

const
    maxn = 500;
    filename = 'problem';
    inf = $77777777;

type
    int = longint;

var
    n, m, i, j, r, k, k1, k2: int;
    a: array[1 .. maxn, 1 .. maxn] of int;

begin
    reset(input, filename + '.in');
    rewrite(output, filename + '.out');

    read(n, m);
    for i := 1 to n do
        for j := 1 to m do begin
            read(a[i][j]);
            assert(abs(a[i][j]) <= 10000000);
        end;

    r := -inf;
    for i := 1 to n do
        for j := i + 1 to n do begin
            if (a[i][1] + a[j][1] > a[i][2] + a[j][2]) then begin
                k1 := a[i][1] + a[j][1];
                k2 := a[i][2] + a[j][2];
            end
            else begin
                k2 := a[i][1] + a[j][1];
                k1 := a[i][2] + a[j][2];
            end;
            for k := 3 to m do begin
                if (a[i][k] + a[j][k] > k1) then
                    k1 := a[i][k] + a[j][k]
                else if (a[i][k] + a[j][k] > k2) then
                    k2 := a[i][k] + a[j][k];
            end;
            r := max(r, k1 + k2);
        end;

    write(r);
end.