{$r-,q-,o+}
{$apptype console}
type
  int = longint;

const
  program_name = 'problem';
  inf = 1000000000;

var
  a: array [1..500, 1..500] of int;
  m1, m2: array [1..500] of int;
  n, m: int;
  u1, u2, i, j, d: int;
  max1, max2, max1i, max2i: int;
  maxi1, maxi2, maxj1, maxj2: int;
  max: int;

begin
  reset(input, program_name + '.in');
  rewrite(output, program_name + '.out');

  read(n, m);
  for i:=1 to n do
    for j:=1 to m do begin
            read(a[i][j]);
            assert(abs(a[i][j]) <= 10000000);
        end;


  for i:=1 to n do
  begin
    m1[i]:=-inf;
    m2[i]:=-inf;
    for j:=1 to m do
    begin
      if (a[i][j] > m1[i]) then
      begin
        m2[i]:=m1[i];
        m1[i]:=a[i][j];
        continue;
      end;

      if (a[i][j] > m2[i]) then
      begin
        m2[i]:=a[i][j];
        continue;
      end;
    end;
  end;

  max:=-inf;
  maxi1:=-1;
  maxi2:=-1;
  maxj1:=-1;
  maxj2:=-1;
  for u1:=1 to n do
    for u2:=u1 + 1 to n do
    begin
      max1:=-inf;
      max2:=-inf;
      max1i:=-1;
      max2i:=-1;
      if (m1[u1] + m2[u1] + m1[u2] + m2[u2] <= max) then
        continue;

      for i:=1 to m do
      begin
        d:=a[u1][i] + a[u2][i];
        if (d > max1) then
        begin
          max2:=max1;
          max2i:=max1i;

          max1:=d;
          max1i:=i;
          continue;
        end;

        if (d > max2) then
        begin
          max2:=d;
          max2i:=i;
          continue;
        end;
      end;

      if (max1 + max2 > max) then
      begin
        max:=max1 + max2;
        maxi1:=u1;
        maxi2:=u2;
        maxj1:=max1i;
        maxj2:=max2i;
      end;
    end;

  writeln(max);
  if (maxj1 < maxj2) then
    writeln(maxi1, ' ', maxj1, ' ', maxi2, ' ', maxj2)
  else
    writeln(maxi1, ' ', maxj2, ' ', maxi2, ' ', maxj1);
end.

