{$r+,q+,o-}
{$apptype console}
type
  int = longint;

const
  program_name = 'puzzle';
  inf = 1000000000;

var
  x: array [1..50, 1..50] of boolean;
  d: array [1..50, 0..1] of int;
  mark: array [1..50, 0..1] of boolean;
  q, qd: array [1..100] of int;
  ans1, ans2: array [1..50] of int;
  k, n, m, l, h: int;
  max1, max2: int;

var
  g, u, v, i: int;

begin
  reset(input, program_name + '.in');
  rewrite(output, program_name + '.out');

  read(k);
  for g:=1 to k do
  begin
    read(n, m);
    fillchar(x, sizeof(x), false);
    for i:=1 to m do
    begin
      read(u, v);
      x[u][v]:=true;
      x[v][u]:=true;
    end;

    l:=1;
    h:=2;
    q[1]:=1;
    qd[1]:=0;
    fillchar(mark, sizeof(mark), false);
    for u:=1 to n do
      for v:=0 to 1 do
        d[u][v]:=inf;

    mark[1][0]:=true;
    d[1][0]:=0;
    while (l < h) do
    begin
      u:=q[l];
      v:=qd[l];
      inc(l);
      for i:=1 to n do
        if (x[u][i]) and (not mark[i][1 - v]) then
        begin
          q[h]:=i;
          qd[h]:=1 - v;
          inc(h);
          mark[i][1 - v]:=true;
          d[i][1 - v]:=d[u][v] + 1;
        end;
    end;

    ans1[g]:=d[n][0];
    ans2[g]:=d[n][1];
  end;

  max1:=-1;
  max2:=-1;
  for i:=1 to k do
    if (ans1[i] > max1) then
      max1:=ans1[i];
    
  for i:=1 to k do
    if (ans2[i] > max2) then
      max2:=ans2[i];

  if (max1 > max2) then
    max1:=max2;

  if (max1 = inf) then
    writeln('Impossible')
  else
    writeln(max1);

end.
