{$apptype console}
{$o+,r-,q-}
{$maxstacksize 10000000}
uses
  sysutils, math;

type
  int = longint;

const
  maxfloor = 51;
  maxmarbles = 11;
  problem_name = 'tester';
  inf = 20000;
  THROW = 1;
  UP = 2;
  DOWN = 3;
  TOZERO = 4;

var
  a : array[0..maxfloor, 0..maxfloor, 1..maxfloor, 0..maxmarbles, 0..maxmarbles] of word;
  n, m : int;

function solve(l, r : int; pos : int; have, zero : int) : int;
var
  t4 : int;
  i : int;
begin
  if a[l][r][pos][have][zero] < inf then
  begin
    result := a[l][r][pos][have][zero];
    exit;
  end;
  if (l > r) then
  begin
    result := 0;
    exit;
  end;

  result := inf;

  // Take all
  if (zero <> 0) then
  begin
    for i := l to r do
    begin
      result := min(result, i - 1 + solve(l, r, i, have + zero, 0));
    end;{}
//    result := min(result, l - 1  + solve(l, r, l, have + zero, 0));
  end;

  if have > 0 then
  begin
    for i := l to r do
    begin
      t4 := 0;
      t4 := max(t4, max(0, i - pos) + solve(l, i - 1, i, have - 1, zero));  
      t4 := max(t4, max(0, i - pos) + solve(i + 1, r, i, have - 1, zero + 1));  
      result := min(result, t4);
    end;
  end;

  a[l][r][pos][have][zero] := result;
end;

begin
  reset(input, problem_name + '.in');
  rewrite(output, problem_name + '.out');
  fillchar(a, sizeof(a), $77);
  readln(n, m);
  assert((1 <= n) and (n <= 50));
  assert((1 <= m) and (m <= 10));
  writeln(solve(2, n - 1, 1, m, 0));
end.