import java.io.File;
import java.util.Scanner;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Arrays;

public class time_dp {
    private static final int INF = 10000;
    private static final String INPUT_FILE = "time.in";
    private static final String OUTPUT_FILE = "time.out";

    private int h;
    private int k;

    private int[] ans;
    
    public static void main(String[] args) throws IOException {
        time_dp sol = new time_dp();
        sol.solve();
    }

    private void solve() throws IOException {
        Scanner in = new Scanner(new File(INPUT_FILE));
        PrintWriter out = new PrintWriter(new File(OUTPUT_FILE));
        int time = in.nextInt();
        int[] op = new int[2];
        op[0] = in.nextInt();
        op[1] = in.nextInt();
        int cnt = in.nextInt();
        int dd = 0;
        int hh = 0;
        int mm = 0;
        while (time > 0) {
            time--;
            mm++;
            if (mm == 60) {
                mm = 0;
                hh++;
                if (hh == 24) {
                    hh = 0;
                    dd++;
                }
                if (op[dd] == 1 && hh == 2 && mm == 0) {
                    hh = 3;
                    op[dd] = 0;
                }
                if (op[dd] == -1 && hh == 3 && mm == 0) {
                    hh = 2;
                    op[dd] = 0;
                }
            }
        }
        while (cnt > 0) {
            cnt--;
            out.println("" + (hh / 10) + (hh % 10) + ":" + (mm / 10) + (mm % 10));
            mm++;
            if (mm == 60) {
                mm = 0;
                hh++;
                if (hh == 24) {
                    hh = 0;
                    dd++;
                }
                if (op[dd] == 1 && hh == 2 && mm == 0) {
                    hh = 3;
                    op[dd] = 0;
                }
                if (op[dd] == -1 && hh == 3 && mm == 0) {
                    hh = 2;
                    op[dd] = 0;
                }
            }
        }
        out.close();
    }
}
