{$O-,Q+,R+}
uses SysUtils, Math;

const MaxMN=130000;
      MaxD=MaxMN*2+239;

type tpoly=array [0..MaxD] of integer;
     ppoly=^tpoly;


procedure add (var a:tpoly; const b:tpoly; bd:integer; const c:tpoly; cd:integer);
var i:integer;
begin
  for i:=0 to min (bd, cd) do 
    a[i]:=b[i]+c[i];
  if bd<cd then
    move (c[bd+1], a[bd+1], (cd-bd)*sizeof (integer))
  else
    move (b[cd+1], a[cd+1], (bd-cd)*sizeof (integer));
end;


procedure sub (var a:tpoly; const b:tpoly; bd:integer; const c:tpoly; cd:integer);
var i:integer;
begin
  for i:=0 to min (bd, cd) do 
    a[i]:=b[i]-c[i];
  if bd<cd then
    move (c[bd+1], a[bd+1], (cd-bd)*sizeof (integer))
  else
    move (b[cd+1], a[cd+1], (bd-cd)*sizeof (integer));
end;

procedure mul (var a:tpoly; const b, c:tpoly; d:integer);
var i, j, k:integer;
    x, y, z:array of integer;
begin
  if d<50 then begin
    for i:=0 to d do
      for j:=0 to d do
        inc (a[i+j], b[i]*c[j]);
    exit;
  end;
  k:=d shr 1 + 1;
  mul (a, b, c, k-1);
  mul (ppoly (@a[k shl 1])^, ppoly (@b[k])^, ppoly (@c[k])^, d-k);
  setlength (x, k);
  add (ppoly (@x[0])^, b, k-1, ppoly (@b[k])^, d-k);
  setlength (y, k);
  add (ppoly (@y[0])^, c, k-1, ppoly (@c[k])^, d-k);
  setlength (z, (k-1) shl 1 + 1);
  mul (ppoly (@z[0])^, ppoly (@x[0])^, ppoly (@y[0])^, k-1);
  sub (ppoly (@z[0])^, ppoly (@z[0])^, (k-1) shl 1, ppoly (@a[0])^, (k-1) shl 1);
  sub (ppoly (@z[0])^, ppoly (@z[0])^, (k-1) shl 1, ppoly (@a[k shl 1])^, (d-k) shl 1);
  add (ppoly (@a[k])^, ppoly (@a[k])^, (k-1) shl 1, ppoly (@z[0])^, (k-1) shl 1);
end;


procedure mult (var a:tpoly; const b, c:tpoly; d:integer);
var i, j:integer;
begin
  for i:=0 to d do
    for j:=0 to d do
      inc (a[i+j], b[i]*c[j]);
end;


var c:char;
    i, t, n, m, d, s, mx:integer;
    p1, p2, p3, p4:array [0..MaxMN+1] of integer;
    v1, v2:tpoly;

begin
  reset (input, 'holytape.in');
  rewrite (output, 'holytape.out');
  n:=0; m:=0;
  read (c);
  while c<>#13 do begin
    assert (c in ['0'..'1']);
    inc (n);
    p1[n]:=ord (c)-48;
    read (c);
  end;
  assert ((n>0) and (n<=MaxMN));
  read (c);
  assert (c=#10);
  read (c);
  while c<>#13 do begin
    assert (c in ['0'..'1']);
    inc (m);
    p2[m]:=ord (c)-48;
    read (c);
  end;
  read (c);
  assert (c=#10);
  assert (eof);
  assert ((n>0) and (n<=MaxMN));
  for i:=1 to n shr 1 do begin t:=p1[i]; p1[i]:=p1[n-i+1]; p1[n-i+1]:=t end;
  p3:=p1; p4:=p2;
  d:=max (m, n);                                
  inc (d);
  for i:=1 to n-1 do
    if (p1[i]=1) and (p1[i+1]=1) then p1[i]:=0;
  for i:=1 to m-1 do
    if (p2[i]=1) and (p2[i+1]=1) then p2[i]:=0;
  mul (v1, ppoly (@p1[0])^, ppoly (@p2[0])^, d);
  for i:=n downto 2 do
    if (p3[i]=1) and (p3[i-1]=1) then p3[i]:=0;
  for i:=m downto 2 do
    if (p4[i]=1) and (p4[i-1]=1) then p4[i]:=0;
  mul (v2, ppoly (@p3[0])^, ppoly (@p4[0])^, d);
//  for i:=0 to d do writeln (p1[i], ' ', p2[i], ' ', p3[i], ' ', p4[i]);
  mx:=0; s:=0;
  for i:=0 to 2*d+1 do begin
    inc (s, v2[i]);
//    writeln (v1[i], ' ', v2[i], ' ', s);
    if s>mx then mx:=s;
    dec (s, v1[i]);
  end;
  writeln (mx);
end.