import java.io.*;
import java.util.*;
import java.math.*;



public class TwoStrings_vv_poly_fur{

  
  public static final String FileName = "holytape";

  int DEBUG = 0;

  public class complex{
    public double x;
    public double y;

    public complex(double xx,double yy){
      x = xx;
      y = yy;
    }

    public complex(double xx){
      x = xx; y=0;
    }

    public complex(){
      x = 0; y = 0;
    }

    public complex mull(complex a){
      return new complex(x*a.x-y*a.y,x*a.y+y*a.x);
    }

    public complex add(complex a){
      return new complex(x+a.x,y+a.y);
    }

    public complex subt(complex a){
      return new complex(x-a.x,y-a.y);
    }
      
  }

  int[] rev;
  complex[] ksi;
  int d2d = 1;
  int d = 0;

  public void QFT (complex[] zz){
    complex z = new complex();
    for(int s =0;s<d;s++){
      int m1 = 1<<s;
      int m2 = m1 - 1;
      int sh = d - s - 1;
      for(int i=0;i<d2d;i++){
        if ((i & m1) == 0) {
          int j = i + m1;
          int k = (i & m2)<<sh;
//          complex z = zz[j].mull(ksi[k]);
          z.x = zz[j].x*ksi[k].x-zz[j].y*ksi[k].y;
          z.y = zz[j].x*ksi[k].y+zz[j].y*ksi[k].x;
          zz[j].x = zz[i].x-z.x;
          zz[j].y = zz[i].y-z.y;
//          zz[j] = zz[i].subt(z);
          zz[i].x+=z.x;
          zz[i].y+=z.y;
//          zz[i] = zz[i].add(z);
        }
      }
    }     
  }



  public void revarr(complex[] a){
    for(int i=0; i<d2d;i++){
      int j = rev[i];
      if(j>i){
        complex t = a[i]; a[i] = a[j]; a[j] = t;
      }
    }
  }


  public int[] mult(int[] x,int[] y) throws Exception{
//    System.out.println("URA[0]");
    int n = x.length;
    int m = y.length;
    int nn = n+m;
    while (d2d<=nn){
      d2d*=2;
      d++;
    }
//    d++; d2d*=2;
    ksi = new complex[d2d];
    for(int i=0;i<d2d;i++){
      ksi[i] = new complex(Math.cos(2*Math.PI*i/d2d),Math.sin(2*Math.PI*i/d2d));
    }
    int j = 0;
    rev = new int[d2d];
    for(int i=0;i<d2d;i++){
      rev[i] = j;
      int k = d2d;  
      do{ 
        k = k>>1; 
      } while ((j & k) != 0);
      j = (j + 3*k) & (d2d - 1);
    }
//    System.out.println("URA[1]");
    complex[] a = new  complex[d2d];
    for(int i=0;i<d2d;i++){
      if (i<n) {a[i] = new complex(x[i]);}
      else {a[i] = new complex();}
    }
    complex[] b = new  complex[d2d];
    for(int i=0;i<d2d;i++){
      if (i<m) {b[i] = new complex(y[i]);}
      else {b[i] = new complex();}
    }
    revarr (a);
    revarr (b);
    if (DEBUG>0){
      System.out.println("REV----------------------------------------------------");
      for(int i=0;i<a.length;i++){
        System.out.println(a[i].x+" "+a[i].y+"I");
      }
      for(int i=0;i<b.length;i++){
        System.out.println(b[i].x+" "+b[i].y+"I");
      }
    }
//    System.out.println("URA[2]");
    QFT (a);
    QFT (b);
//    System.out.println("URA[3]");
    if (DEBUG>0){
      System.out.println("QFT----------------------------------------------------");
      for(int i=0;i<a.length;i++){
        System.out.println(a[i].x+" "+a[i].y+"I");
      }
      for(int i=0;i<b.length;i++){
        System.out.println(b[i].x+" "+b[i].y+"I");
      }
    }
    for(int i=0;i<d2d;i++){
      a[i] = a[i].mull(b[i]);
    }
    if (DEBUG>0){
      System.out.println("MULT----------------------------------------------------");
      for(int i=0;i<a.length;i++){
        System.out.println(a[i].x+" "+a[i].y+"I");
      }
    }
    revarr (a);
    if (DEBUG>0){
      System.out.println("REV----------------------------------------------------");
      for(int i=0;i<a.length;i++){
        System.out.println(a[i].x+" "+a[i].y+"I");
      }
    }
    QFT (a);
    if (DEBUG>0){
      System.out.println("QFT-----------------------------------------------------");
      for(int i=0;i<a.length;i++){
        System.out.println(a[i].x+" "+a[i].y+"I");
      }
    }
    int[] res = new int[n+m-1];
    double f = 1;
    for(int i=0;i<d;i++){
      f*=0.5;
    }
    int[]q = new int[n+m-1];
    q[0] = 0;
    for (int i=1;i<n+m-1;i++){
      q[i]=d2d-i;
    }
    for(int i=0;i<n+m-1;i++){
      res[i]=(int)Math.round(a[q[i]].x*f);
      if (DEBUG>0) System.out.println(a[i].x*f);
    }
    return res;
  }

  public void draw(int[] x){
    for(int i=x.length-1;i>=0;i--){
      System.out.print(x[i]+" ");
    }
    System.out.println();
  }
  BufferedReader in;

  public void run() throws Exception{    
    in = new BufferedReader(new FileReader(FileName+".in"));
    PrintWriter out = new PrintWriter(new File(FileName+".out"));
    String s1 = in.readLine(); s1 = '0'+s1+'0';
    String s2 = in.readLine(); s2 = '0'+s2+'0';
    int n = s1.length();
    int m = s2.length();
    int[] p1 = new int[n];
    for(int i=0;i<n-1;i++){
      if(s1.charAt(i)=='0' && s1.charAt(i+1)=='1'){
        p1[i]=1;
      }
    }
    int[] p2 = new int[m];
    for(int i=0;i<m-1;i++){
      if(s2.charAt(i)=='1' && s2.charAt(i+1)=='0'){
        p2[m-1-i]=1;
      }
    }
    int[] p = mult(p1,p2);
    int[] q1 = new int[n];
    for(int i=0;i<n-1;i++){
      if(s1.charAt(i)=='1' && s1.charAt(i+1)=='0'){
        q1[i]=1;
      }
    }
    int[] q2 = new int[m];
    for(int i=0;i<m-1;i++){
      if(s2.charAt(i)=='0' && s2.charAt(i+1)=='1'){
        q2[m-1-i]=1;
      }
    }
    int[] q = mult(q1,q2);
    if (DEBUG>0){
      draw(p1);
      draw(p2);
      draw(p);
      draw(q1);
      draw(q2);
      draw(q);
    }
    int best = 0;
    int cc = 0;
    for(int i=-(m-1);i<(n-1);i++){
      if (cc>best)
        best = cc;
      cc+=p[i+(m-1)];
      cc-=q[i+(m-1)+1];
      if (DEBUG>0)
        System.out.println(cc);
    }     
    out.println(best);
    out.close();
  }

  public static void main(String[] args) throws Exception{
    TwoStrings_vv_poly_fur t = new TwoStrings_vv_poly_fur();
    t.run();
  }
}