import java.io.*;
import java.util.*;
import java.math.*;



public class TwoStrings_vv_poly_slow{

  
  public static final String FileName = "holytape";

  int DEBUG = 0;

  public int count(String s1, String s2){
    int n = s1.length();
    int m = s2.length();
    int st = 0;
    int res = 0;
    for (int i=0;i<n && i<m;i++){
      if (s1.charAt(i) == '1' && s2.charAt(i) == '1'){
        if (st == 0){
          st = 1; res++;
        }
      } else {
        st = 0;
      }
    }
    return res;
  }

  public int[] mult(int[] x,int[] y){
    int n = x.length-1;
    int m = y.length-1;
    int[] res = new int[n+m+1];
    for(int i=0; i<=n;i++)
      for(int j=0; j<=m; j++){
        res[i+j]+=x[i]*y[j];
      }
    return res;
  }

  public void draw(int[] x){
    for(int i=x.length-1;i>=0;i--){
      System.out.print(x[i]+" ");
    }
    System.out.println();
  }



  public void run() throws Exception{    
    Scanner in = new Scanner(new File(FileName+".in"));
    PrintWriter out = new PrintWriter(new File(FileName+".out"));
    String s1 = in.next(); s1 = '0'+s1+'0';
    String s2 = in.next(); s2 = '0'+s2+'0';
    int n = s1.length();
    int m = s2.length();
    int[] p1 = new int[n];
    for(int i=0;i<n-1;i++){
      if(s1.charAt(i)=='0' && s1.charAt(i+1)=='1'){
        p1[i]=1;
      }
    }
    int[] p2 = new int[m];
    for(int i=0;i<m-1;i++){
      if(s2.charAt(i)=='1' && s2.charAt(i+1)=='0'){
        p2[m-1-i]=1;
      }
    }
    int[] p = mult(p1,p2);
    int[] q1 = new int[n];
    for(int i=0;i<n-1;i++){
      if(s1.charAt(i)=='1' && s1.charAt(i+1)=='0'){
        q1[i]=1;
      }
    }
    int[] q2 = new int[m];
    for(int i=0;i<m-1;i++){
      if(s2.charAt(i)=='0' && s2.charAt(i+1)=='1'){
        q2[m-1-i]=1;
      }
    }
    int[] q = mult(q1,q2);
    if (DEBUG>0){
      draw(p1);
      draw(p2);
      draw(p);
      draw(q1);
      draw(q2);
      draw(q);
    }
    int best = 0;
    int cc = 0;
    for(int i=-(m-1);i<(n-1);i++){
      if (cc>best)
        best = cc;
      cc+=p[i+(m-1)];
      cc-=q[i+(m-1)+1];
      if (DEBUG>0)
        System.out.println(cc);
    }     
    out.println(best);
    out.close();
  }

  public static void main(String[] args) throws Exception{
    TwoStrings_vv_poly_slow t = new TwoStrings_vv_poly_slow();
    t.run();
  }
}