#define _CRT_SECURE_NO_DEPRECATE
#pragma comment (linker, "/STACK:30000000")

#include <string>
#include <vector>
//#include <cmath>
//#include <queue>
//#include <set>
//#include <map>
#include <algorithm>
#include <iostream>
//#include <cstdio>
//#include <sstream>
#include <cassert>
//#include <utility>

using namespace std;

#define EPS 1E-8
const int INF = (int)1E+9;

#define C_IN_FILE "stragain.in"
#define C_OUT_FILE "stragain.out"

#define forn(i, n) for (int i = 0; i < (int)(n); ++i)
#define forv(i, v) for (int i = 0; i < (int)(v.size()); ++i)
#define fors(i, s) for (int i = 0; i < (int)(s.length()); ++i)
#define all(a) a.begin(), a.end()
#define pb push_back
#define PII pair<int, int>
#define mp make_pair
#define VI vector<int>
#define VS vector<string>

const int base = (1 << 20) - 1;
const int mul = 17;

int n, m, ans;
string s1, s2;
int h1, hc;

VI h2, mn;

void outdata() {
}

inline int hash2(int l, int r) {
	int res = h2[r];
	if (l > 0) res = (res + base + 1 - ((mn[r - l + 1] * h2[l - 1]) & base)) & base;
	return res;
}

void solve() {
	if (s1.length() < 3) {
		cout << "NO\n";
		return ;

	}
	if (s1 == s2) {
		cout << "YES\n";
		cout << s1[0] << endl;
		cout << s1[1] << endl;
		cout << s1.substr(2) << endl;
		return ;
	}
	int n = (int)s1.length();
	mn = VI(n + 1, 1);
	forn(i, n) mn[i + 1] = (mn[i] * mul) & base;
	hc = h1 = 0;
	forn(i, n) h1 = (h1 * mul + s1[i]) & base;
	h2 = VI(n, 0);
	forn(i, n) hc = h2[i] = (hc * mul + s2[i]) & base;
	for(int l = 0; l < n - 2; ++l) {
		for(int r = l + 1; r < n - 1; ++r) {
			int t[3], p[3], ln[3];
			t[0] = hash2(0, l), t[1] = hash2(l + 1, r), t[2] = hash2(r + 1, n - 1);
			ln[0] = l + 1, ln[1] = r - l, ln[2] = n - 1 - r;
			forn(z, 3) p[z] = z;
			forn(q, 5) {
				next_permutation(p, p + 3);
				int hh = (t[p[0]] * mn[n - ln[p[0]]]) & base;
				hh += (t[p[1]] * mn[ln[p[2]]]) & base;
				hh += t[p[2]];
				hh &= base;
				if (hh == h1) {
					string s[3];
					s[0] = s2.substr(0, l + 1);
					s[1] = s2.substr(l + 1, r - l);
					s[2] = s2.substr(r + 1);
					if (s[0] + s[1] + s[2] == s1) {
						cout << "YES\n";
						forn(z, 3) cout << s[p[z]] << endl;
						return ;
					}
				}
			}
		}
	}
	cout << "NO\n";
}

void readdata() {
	cin >> s1 >> s2;
	assert(s1.length() == s2.length());
}

int main() {
    freopen(C_IN_FILE, "rt", stdin);
    freopen(C_OUT_FILE, "wt", stdout);
	readdata();
	solve();
	outdata();
	return 0;
}

