#define _CRT_SECURE_NO_DEPRECATE
#pragma comment (linker, "/STACK:30000000")

#include <string>
#include <vector>
//#include <cmath>
//#include <queue>
//#include <set>
//#include <map>
#include <algorithm>
#include <iostream>
//#include <cstdio>
//#include <sstream>
#include <cassert>
//#include <utility>

using namespace std;

#define EPS 1E-8
const int INF = (int)1E+9;

#define C_IN_FILE "input.txt"
#define C_OUT_FILE "output.txt"

#define forn(i, n) for (int i = 0; i < (int)(n); ++i)
#define forv(i, v) for (int i = 0; i < (int)(v.size()); ++i)
#define fors(i, s) for (int i = 0; i < (int)(s.length()); ++i)
#define all(a) a.begin(), a.end()
#define pb push_back
#define PII pair<int, int>
#define mp make_pair
#define VI vector<int>
#define VS vector<string>

const int LISTMAX = 1 << 17;

typedef int ttree[(LISTMAX << 1) + 6];

int n, m, ans;
VI a, b;
vector< PII > res;
vector< vector< PII > > res2;
vector<bool> u;
ttree tree, treev, treel, treer;
int sm = 0;

void outdata() {
	printf("%d\n", res.size());
	forv(i, res) {
		printf("%d %d\n", b[res[i].first], b[res[i].second]);
	}
}

int fmin(const VI & a, int v, int l, int r) {
	if (treel[v] > r || treer[v] < l) return -1;
	if (treer[v] <= r && treel[v] >= l) return treev[v];
	int lf = fmin(a, v << 1, l, r);
	int rf = fmin(a, (v << 1) + 1, l, r);
	if (lf == -1) return rf;
	if (rf == -1) return lf;
	if (a[lf] > a[rf]) return rf; else return lf;
}

void calc(const VI & a, int l, int r) {
	if (l == r) return ;
	int m = fmin(a, 1, l + 1, r);
//	assert(a[l] < a[m]);
	res.pb(mp(a[l], a[m]));
	calc(a, l, m - 1);
	calc(a, m, r);
}

void calc(const VI & a) {
	int list = 1;
	while (list < (int)a.size()) list <<= 1;
	forn(i, list) {
		int t = i;
		if (i >= (int)a.size()) {
			t = -1;
			tree[i + list] = INF;
		} else tree[i + list] = a[i];
		treev[i + list] = t;
		treel[i + list] = treer[i + list] = i;
	}
	for(int i = list - 1; i > 0; --i) {
		tree[i] = tree[(i << 1) + 1];
		treev[i] = treev[(i << 1) + 1];
		if (tree[i] > tree[i << 1]) {
			tree[i] = tree[i << 1];
			treev[i] = treev[i << 1];
		}
		treel[i] = treel[i << 1];
		treer[i] = treer[(i << 1) + 1];
	}
	calc(a, 0, (int)a.size() - 1);
}

void solve() {
	res2.clear();
	b = a;
	sort(all(b));
	assert(unique(all(b)) == b.end());
	forn(i, n) assert(0 <= b[i] && b[i] <= (int)1E+9);
	forn(i, n) a[i] = (int)(lower_bound(all(b), a[i]) - b.begin());
	u = vector<bool>(n, false);
	forn(e, n) {
		if (!u[e]) {
			res.clear();
			VI c;
			int t = e;
			while (!u[t]) {
				u[t] = true;
				c.pb(t);
				t = a[t];
			}
			int tmin = 0;
			forv(i, c) {
				if (c[i] < c[tmin]) tmin = i;
			}
			VI tmp;
			forv(i, c) tmp.pb(c[(tmin + i) % c.size()]);
			calc(tmp);
			res2.pb(res);
		}
	}
	res.clear();
	sort(all(res2));
	forv(i, res2) forv(j, res2[i]) res.pb(res2[i][j]);
}

void readdata() {
	scanf("%d", &n);
	assert(n > 0);
	sm += n;
	a = VI(n, 0);
	forn(i, n) scanf("%d", &a[i]);
}

int main() {
    freopen(C_IN_FILE, "rt", stdin);
    freopen(C_OUT_FILE, "wt", stdout);
	int tst;
	scanf("%d", &tst);
	forn(ii, tst) {
		readdata();
		solve();
		outdata();
	}
	assert(1 <= sm && sm <= 100000);
	return 0;
}
