#include <cstdio>
#include <cstdlib>
#include <memory.h>

#define NNN 100011
//#define NNN 6
#define DEB false
int n;
int val[NNN], ind[NNN], nxt[NNN], nxtsrt[NNN], prvsrt[NNN], whm[NNN], ans[NNN][2], prv[NNN]; 
int kk,cc;
int tmp[NNN];


void Qsort(int be, int en)
{
	int l = be, r = en;
	int x = val[be + rand() % ( en - be + 1)];
	int t;
	while ( l < r ) {
		while ( val[l] < x ) l++;
		while ( val[r] > x ) r--;
		if ( l <= r ) {
			t = val[l]; val[l] = val[r]; val[r] = t;
			t = ind[l]; ind[l] = ind[r]; ind[r] = t;
			l++;r--;
		}	
	}
	if ( l < en ) Qsort( l, en );
	if ( r > be ) Qsort( be, r );
}

void SaveAll(int st, int st2)
{
	printf("\nst: %d , st2 : %d", st, st2);
	printf("\nwhm: ");
	for(int i = 1; i <= n; i++) printf("%d ", whm[i]);
	printf("\nval: ");
	for(i = 1; i <= n; i++) printf("%d ", val[i]);
	printf("\nind: ");
	for(i = 1; i <= n; i++) printf("%d ", ind[i]);
	printf("\nnxt: ");
	for(i = 1; i <= n; i++) printf("%d ", nxt[i]);
	printf("\nprv: ");
	for(i = 1; i <= n; i++) printf("%d ", prv[i]);
	printf("\nnxtsrt: ");
	for(i = 1; i <= n; i++) printf("%d ", nxtsrt[i]);
	printf("\nprvsrt: ");
	for(i = 1; i <= n; i++) printf("%d ", prvsrt[i]);
	printf("\n\n");
	fflush(stdout);
	
}

void Qsort2(int be, int en)
{
	int l = be, r = en;
	int x = tmp[be + rand() % ( en - be + 1)];
	int t;
	while ( l < r ) {
		while ( tmp[l] < x ) l++;
		while ( tmp[r] > x ) r--;
		if ( l <= r ) {
			t = tmp[l]; tmp[l] = tmp[r]; tmp[r] = t;
			l++;r--;
		}	
	}
	if ( l < en ) Qsort2( l, en );
	if ( r > be ) Qsort2( be, r );
}

int tmp1[NNN][2], tmp2[NNN][2];
void Merge( int st, int t, int en)
{
	if (en <= t) return;
	if (st > t) return;
	memcpy(tmp1,ans[st],(t - st + 1) * 2 * sizeof (int));
	memcpy(tmp2,ans[t + 1],(en - t) * 2 * sizeof (int));
	int i = 0,j = 0, k = 0;
	int nn = t - st + 1;
	int mm = en - t;
	int tt;
	for (i = 0; i < nn; i++) {
		if ( tmp1[i][0] > tmp1[i][1]) {
			tt = tmp1[i][0]; tmp1[i][0] = tmp1[i][1]; tmp1[i][1] = tt;
		}
	}
	for (i = 0; i < mm; i++) {
		if ( tmp2[i][0] > tmp2[i][1]) {
			tt = tmp2[i][0]; tmp2[i][0] = tmp2[i][1]; tmp2[i][1] = tt;
		}
	}
	i = 0;
	while ( i < nn && j < mm )
	{
		if (tmp1[i][0] < tmp2[j][0] || (tmp1[i][0] == tmp2[j][0] && tmp1[i][1] < tmp2[j][1])) {
			ans[st + k][0] = tmp1[i][0];
			ans[st + k][1] = tmp1[i][1];
			k++;
			i++;
		} else {
			ans[st + k][0] = tmp2[j][0];
			ans[st + k][1] = tmp2[j][1];
			k++;
			j++;
		}
	}
	for (;i < nn; i++) {
			ans[st + k][0] = tmp1[i][0];
			ans[st + k][1] = tmp1[i][1];
			k++;
	}
	for (;j < mm; j++) {
			ans[st + k][0] = tmp2[j][0];
			ans[st + k][1] = tmp2[j][1];
			k++;
	}
}


void Rec( int st)
{
	if (DEB)SaveAll(0,0);
	
	if (ind[st] == st) return;
	int i,j,k,t;
	int st2 = nxtsrt[st];
	t = prv[st2];
	nxt[t] = st;
	k = prv[st];
	prv[st] = t;
	nxt[k] = st2;
	prv[st2] = k;
	i = st;
	j = st2;
	do {
		i = nxt[i];
		j = nxt[j];
	} while (i != st && j != st2);
	if (j == st2) {
		i = st2; j = st;
	}
	k = i;
	t = 0;
	do {
		tmp[++t] = k;
		k = nxt[k];
	} while (k != i);
	Qsort2(1,t);
	k = ind[st];ind[st] = ind[st2];ind[st2] = k;
	whm[ind[st]] = st;
	whm[ind[st2]] = st2;
	//k = val[whm[st]]; val[whm[st]] = val[whm[st2]]; val[whm[st2]] = k;
	if (DEB) printf("**********************************\n");
	if (DEB) SaveAll(st,st2); 
	tmp[t + 1] = 0;
	for (k = 1; k <= t; k++) {
		nxtsrt[prvsrt[tmp[k]]] = nxtsrt[tmp[k]];
		prvsrt[nxtsrt[tmp[k]]] = prvsrt[tmp[k]];
	}
	for (k = 1; k <= t; k++) {
		nxtsrt[tmp[k]] = tmp[k + 1];
		prvsrt[tmp[k + 1]] = tmp[k];
	}
	prvsrt[st] = 0;
	prvsrt[st2] = 0;
	nxtsrt[tmp[t]] = 0;
	prvsrt[tmp[1]] = 0;
	if (DEB) SaveAll(st,st2); 
	if (DEB) printf("**********************************\n");
	ans[kk][0] =  val[st];
	ans[kk][1] =  val[st2];
	if (ans[kk][0] > ans[kk][1]) {
		t = ans[kk][0]; ans[kk][0] = ans[kk][1]; ans[kk][1] = t;
	}
	t = kk;
	kk++;
	Rec(st);
	k = kk;
	Rec(st2);
	Merge(t ,k - 1,kk - 1);
}

void Load()
{
	kk = 0;	
	scanf( "%d", &n);
	/*memset(nxt,0, sizeof(nxt));
	memset(prv,0, sizeof(prv));
	memset(nxtsrt,0, sizeof(nxtsrt));
	memset(prvsrt,0, sizeof(prvsrt));

	memset(ind,0, sizeof(ind));
	
	memset(val,0, sizeof(val));
	memset(whm,0, sizeof(whm));
	memset(ans,0, sizeof(ans));
	memset(tmp1,0, sizeof(tmp1));
	memset(tmp2,0, sizeof(tmp2));
*/
	for (int i = 1; i <= n; i++) {
		scanf("%d", &val[i]);
		ind[i] = i;
	}
	Qsort( 1, n);
	int j = 0;
	for (i = 1; i <= n; i++) whm[ind[i]] = i;
	for (i = 1; i <= n; i++) {
		nxt[i] = whm[i];
		prv[nxt[i]] = i;
	}
	int k;
	for (i = 1; i <= n; i++) {
		if (nxtsrt[i] != 0 || prvsrt[i] != 0) continue;
		j = i;
		k = 0;
		do {
			k++;
			tmp[k] = j;
			j = nxt[j];
		} while ( j != i);
		Qsort2(1,k);
		tmp[k + 1] = 0;
		for(j = 1; j <= k; j++) {
			nxtsrt[tmp[j]] = tmp[j + 1];
			prvsrt[tmp[j + 1]] = tmp[j];
		}
		nxtsrt[tmp[k]] = 0;
		prvsrt[tmp[1]] = 0;
	}
}


void Solve()
{
	kk = 0;
	int i;
	int t = 0;
	for ( i = 1; i <= n; i++) {
		if ( ind[i] == i) continue;
		t = kk;
		Rec(i);
		Merge(0,t - 1,kk - 1);
	}
	
	printf("%d\n",kk);
	for (i = 0; i < kk; i++) {
		printf( "%d %d\n", ans[i][0], ans[i][1]);
	}

}

int main()
{
	cc = 0;
	freopen( "sort.in", "rt", stdin);
	freopen( "sort.out", "wt", stdout);
	int tests;
	scanf("%d", &tests);
	for (int test = 0; test < tests; test++) {
		Load();
		Solve();
	}
	return 0;
}