#include <stdio.h>

#define SQR(X) ((X) * (X))
#define ABS(A) ((A) > 0 ? (A) : -(A))

#define MAX 3010
#define MAXE 20010
#define EPS 1e-6

typedef double dbl;
typedef __int64 t;

int W, H, N, St[MAX], En[MAX], Pos = 0, LN;
t X[MAX], Y[MAX], A[MAX], B[MAX], C[MAX];
dbl RX[MAXE], RY[MAXE];

int main( void )
{
  int Mi[MAX];
  t Mf[MAX];
  int i, j, la, mi, fi;
  t f, mf, a, b, tmp;
  dbl x, y, k, mk;

  freopen("football.in", "rt", stdin);
  freopen("football.out", "wt", stdout);
  scanf("%d%d%d", &W, &H, &N);
  if (N > 3000)
    while (1);
  for (i = 0; i < N; i++)
    scanf("%Ld%Ld", &X[i], &Y[i]), Mf[i] = (t)1e18;
  for (i = 0; i < N; i++)
  {
    for (j = i + 1; j < N; j++)
    {
      f = SQR(X[j] - X[i]) + SQR(Y[j] - Y[i]);
      if (Mf[i] > f) Mf[i] = f, Mi[i] = j;
      if (Mf[j] > f) Mf[j] = f, Mi[j] = i;
    }
    mi = Mi[i];
    for (j = 0; j < N; j++)
    {
      A[j] = X[j] - X[i];
      B[j] = Y[j] - Y[i];
      C[j] = -(A[j] * (X[j] + X[i]) + B[j] * (Y[j] + Y[i]));
      A[j] <<= 1, B[j] <<= 1;
    }
    A[N + 0] = -1, B[N + 0] = 0, C[N + 0] = 0;
    A[N + 1] = 0, B[N + 1] = 1, C[N + 1] = -H;
    A[N + 2] = 1, B[N + 2] = 0, C[N + 2] = -W;
    A[N + 3] = 0, B[N + 3] = -1, C[N + 3] = 0;
    LN = N + 4;
    St[i] = Pos;
    fi = mi;
    x = (X[i] + X[mi]) * 0.5, y = (Y[i] + Y[mi]) * 0.5;
    do
    {
      a = B[mi], b = -A[mi], la = mi;
      mi = 0, mk = 1e20;
      for (j = 0; j < LN; j++)
        if (j != la && (tmp = A[j] * a + B[j] * b) > 0)
        {
          k = -(A[j] * x + B[j] * y + C[j]);
          if (k > EPS)
            if (k < mk * tmp - EPS || (ABS(mk * tmp - k) < EPS && A[j] * B[mi] - B[j] * A[mi] > 0))
              mk = k / tmp, mi = j;
        }
      x += a * mk, y += b * mk;
      RX[Pos] = x, RY[Pos++] = y;
    } while (mi != fi);
    En[i] = Pos;
  }
  for (i = 0; i < N; i++)
  {
    int len = En[i] - St[i];
    dbl *rx = &RX[St[i]], *ry = &RY[St[i]];
    printf("%d\n", len);
    for (mi = j = 0; j < len; j++)
      if (rx[j] < rx[mi] - EPS || (ABS (rx[j] - rx[mi])<EPS && ry[j] < ry[mi]-EPS))
        mi = j;
    for (j = 0; j < len; j++)
      printf("%.18lf %.18lf\n", rx[(mi - j + len) % len], ry[(mi - j + len) % len]);
  }
  return 0;
}
