{$APPTYPE CONSOLE}

{$Q+,R+,I+,O-}

uses SysUtils;
type int = integer;

const 
  maxl = 1000000;
  FileName = 'threecolors2';

var cc:integer;
    y:array[0..maxl] of integer;
var
  l: int;
  a: array[1..1005] of int;
  am: array[1..3] of int;



procedure print;
begin
end;

procedure color(x: int);
var
  c: int;
begin
  if (a[x] = a[x + 1]) then
    exit;
  inc(cc);
  y[cc]:=x;   
  c := a[x] xor a[x + 1];
  dec(am[a[x]]);
  dec(am[a[x + 1]]);
  inc(am[c], 2);
  a[x] := c;
  a[x + 1] := c;
  print;
end;

procedure solve(s: string);
var
  rs, gs, bs, i, j, m: int;
  num: array['B'..'R'] of int;
  better: boolean;
begin
  l := length(s);
  rs := 0; gs := 0; bs := 0;
  for i := 1 to l do
  begin
    case s[i] of
      'R': inc(rs);
      'G': inc(gs);
      'B': inc(bs);
    end;
  end;
  rs := rs mod 3;
  gs := gs mod 3;
  bs := bs mod 3;
  if (rs xor gs xor bs = 3) then
  begin
    writeln('Impossible');
    exit;
  end;
  if (rs = gs) then
  begin
    num['R'] := 1;
    num['G'] := 2;
    num['B'] := 3;
  end
  else if (rs = bs) then
  begin
    num['B'] := 1;
    num['R'] := 2;
    num['G'] := 3;
  end
  else
  begin
    num['G'] := 1;
    num['B'] := 2;
    num['R'] := 3;
  end;
  fillchar(am, sizeof(am), 0);
  for i := 1 to l do
  begin
    a[i] := num[s[i]];
    inc(am[a[i]]);
  end;
  print;
  if (am[1] = l) or (am[2] = l) or (am[3] = l) then
    exit;
  if (am[1] * am[2] * am[3] = 1) then
  begin
    color(1);
    exit;
  end;
  while (am[1] + am[2] > 0) do
  begin
    for i := 1 to l - 1 do
    begin
      if (a[i] xor a[i + 1] = 3) then
        color(i);
    end;

    if (am[1] > am[2]) then
    begin
      i := 0;
      repeat
        inc(i);
      until (a[i] * a[i + 1] = 3);
      color(i);
      continue;
    end;

    if (am[1] < am[2]) then
    begin
      i := 0;
      repeat
        inc(i);
      until (a[i] * a[i + 1] = 6);
      color(i);
      continue;
    end;

    better := false;
    for j := l downto 1 do if (a[j] < 3) then
    begin
      i := j;
      while (i + 2 <= l) and (a[i + 1] * a[i + 2] = 9) do
      begin
        color(i);
        color(i + 1);
        color(i);
        inc(i, 2);
      end;
      if (i + 1 <= l) and (a[i] xor a[i + 1] = 3) then
      begin
        color(i);
        better := true;
        break;
      end;
    end;
    if better or (am[1] + am[2] = 0) then
      continue;

    m := l;
    repeat
      dec(m);
    until (a[m] = 3) and (a[m + 1] < 3);
    dec(m, 2);  

    if (m <= 0) then
    begin
      writeln('assertion 239 :)');
      exit;
    end;

    if (a[m] = 3) then
    begin
      color(m);
      color(m + 1);
      color(m);
      color(m + 2);
      continue;
    end;

    color(m + 1);
    color(m);
    color(m + 1);
    color(m + 2);
    continue;
  end;
end;



var n:integer;
    s,t:array[1..2] of string;
    x:array[char] of integer;


procedure store;
begin
  t[1]:=s[1];
  t[2]:=s[2];
end;

procedure restore;
begin
  s[1]:=t[1];
  s[2]:=t[2];
end;
var    u:array[char] of integer;

procedure put(i:integer);
var c:char;
    k,j:integer;
begin
  u['R']:=0; u['G']:=0; u['B']:=0;
  for j:=0 to 1 do
    for k:=1 to 2 do
      inc(u[s[k][i+j]]);
  if (u['G']>=3) or (u['R']>=3) or (u['B']>=3) then begin
    if u['G']>=3 then
      c:='G';
    if u['R']>=3 then
      c:='R';
    if u['B']>=3 then
      c:='B';
  end else begin
    if (u['G']*u['R']*u['B']=0) then begin
      if u['G']=0 then
        c:='G';
      if u['R']=0 then
        c:='R';
      if u['B']=0 then
        c:='B';
    end else begin
      if u['G']=2 then
        c:='G';
      if u['R']=2 then
        c:='R';
      if u['B']=2 then
        c:='B';
    end;
    
  end;
  for j:=0 to 1 do
    for k:=1 to 2 do
      s[k][i+j]:=c;
end;


var _,i:integer;
begin
  reset(input,FileName+'.in');
  rewrite(output,FileName+'.out');
  readln(n);
  readln(s[1]);
  readln(s[2]);
{  for j:=1 to 2 do begin
    for i:=1 to n do begin    
      case s[j][i] of
        'R': s[j][i]:='a';
        'G': s[j][i]:='b';
        'B': s[j][i]:='c';
        else runerror(53);
      end;
    end;
  end;}
  store;
  for _:=1 to 1000 do begin
    restore;
    cc:=0;
    for i:=1 to n do begin
      inc(cc); y[cc]:=random(n-1)+1;
      put(y[cc]);
    end;
    for i:=1 to n-1 do
      if (s[1][i]<>s[2][i]) or (s[1][i+1]<>s[2][i+1]) then begin
        inc(cc); y[cc]:=i;
        put(i);
      end; 
    x['R']:=0;
    x['G']:=0;
    x['B']:=0;
    for i:=1 to n do begin
      inc(x[s[1][i]]);
    end;
    x['R']:=x['R'] mod 3;
    x['G']:=x['G'] mod 3;
    x['B']:=x['B'] mod 3;
    if (x['R'] = x['G']) or (x['R'] = x['B']) or (x['G'] = x['B']) then begin
      solve(s[1]);
      for i:=1 to cc do begin
        writeln(y[i]);
      end;
      exit;
    end;      
  end;
  writeln('IMPOSSIBLE');
end.