const
        MaxN = 100;
var
        n, m : LongInt;
        mas : Array[1 .. MaxN, 1 .. MaxN] of Byte;

Procedure Init;
var
        i, j : LongInt;
        ch : Char;
begin
  ReadLn(n, m);
  for i := 1 to m do
  begin
    for j := 1 to n do
    begin
      Read(ch);
      Case ch of
        'R' : mas[i][j] := 1;
        'G' : mas[i][j] := 2;
        'B' : mas[i][j] := 3;
      end;
    end;
    ReadLn;
  end;
end;

Procedure Color(const i, j : LongInt);
var
        c : Array[1 .. 3] of LongInt;
        t : Byte;
begin
  WriteLn(i, ' ', j);
  FillChar(c, SizeOf(c), 0);
  Inc(c[mas[i][j]]);
  Inc(c[mas[i][j + 1]]);
  Inc(c[mas[i + 1][j]]);
  Inc(c[mas[i + 1][j + 1]]);
  t := 0;
  if (c[1] > 2) or (c[2] = c[3]) then
    t := 1;
  if (c[2] > 2) or (c[1] = c[3]) then
    t := 2;
  if (c[3] > 2) or (c[1] = c[2]) then
    t := 3;
  mas[i][j] := t;
  mas[i][j + 1] := t;
  mas[i + 1][j] := t;
  mas[i + 1][j + 1] := t;
end;

Procedure MakeHor(const n : LongInt);
begin
  if (mas[1][n] = mas[1][n - 1]) and (mas[2][n] = mas[2][n - 1]) then
    Exit;
  if (mas[1][n] = mas[2][n]) and (mas[1][n] <> mas[1][n - 1]) then
  begin
    Color(2, n - 1);
    if mas[2][n] = mas[1][n] then
    begin
      Color(1, n - 2);
      Color(1, n - 1);
      Color(2, n - 1);
      Color(1, n - 2);
      Color(1, n - 1);
    end
    else
    begin
      if mas[2][n] = mas[1][n - 1] then
        Color(1, n - 1)
      else
      begin
        Color(1, n - 2);
        Color(1, n - 1);
      end;
    end;
  end
  else
    Color(1, n - 1);
end;

Procedure MakeVer(const m : LongInt);
begin
  if (mas[m][1] = mas[m - 1][1]) and (mas[m][2] = mas[m - 1][2]) then
    Exit;
  if (mas[m][1] = mas[m][2]) and (mas[m][1] <> mas[m - 1][1]) then
  begin
    Color(m - 1, 2);
    if mas[m][2] = mas[m][1] then
    begin
      Color(m - 2, 1);
      Color(m - 1, 1);
      Color(m - 1, 2);
      Color(m - 2, 1);
      Color(m - 1, 1);
    end
    else
    begin
      if mas[m][2] = mas[m - 1][1] then
        Color(m - 1, 1)
      else
      begin
        Color(m - 2, 1);
        Color(m - 1, 1);
      end;
    end;
  end
  else
    Color(m - 1, 1);
end;

Procedure Solve;
var
        i, j : LongInt;
begin
  Color(1, 1);
  for i := 3 to m do
    MakeVer(i);
  for j := 3 to n do
    MakeHor(j);
  for i := 2 to m - 1 do
    for j := 1 to n - 1 do
      Color(i, j);
end;

Procedure Print;
var
        i, j : LongInt;
begin
  for i := 1 to m do
  begin
    for j := 1 to n do
      Case mas[i][j] of
        1 : Write('R');
        2 : Write('G');
        3 : Write('B');
      end;
    WriteLn;
  end;
end;

begin
  Assign(input, 'threecolors.in');
  Reset(input);
  Assign(output, 'threecolors.out');
  Rewrite(output);
  Init;
  Solve;
  Print;
  Close(input);
  Close(output);
end.
