program a;

{$APPTYPE CONSOLE}

var n, m, i, j, sx, sy : integer;
    t   : array [1..101, 1..101] of integer;
    c   : char;

procedure Paint(x, y : integer);
var maxn, nmax, i : integer;
    num : array [1..3] of integer;
begin
   writeln(x, ' ', y);
   fillchar(num, sizeof(num), 0);
   inc(num[t[x][y]]); inc(num[t[x+1][y+1]]);
   inc(num[t[x+1][y]]); inc(num[t[x][y+1]]);
   maxn := 1; nmax := 1;
   for i := 2 to 3 do begin
      if num[maxn] < num[i] then begin
         maxn := i; nmax := 1;
      end else if num[maxn] = num[i] then inc(nmax);
   end;
   if nmax > 1 then
      if num[1] = 0 then
         maxn := 1
      else if num[2] = 0 then
              maxn := 2
           else
              maxn := 3;
   t[x][y] := maxn; t[x+1][y+1] := maxn;
   t[x+1][y] := maxn; t[x][y+1] := maxn;
end;

procedure NewC;
var i, j : integer;
begin
   i := 1;
   while (i < sx) and (t[i][sy+1] = t[i+1][sy+1]) and
         (t[i][sy+1] <> t[1][1]) do inc(i);
   if i < sx then begin
      for j := i downto 1 do Paint(j, sy);
      for j := i+1 to sx-1 do Paint(j, sy);
   end else begin
      Paint(1, sy);
      Paint(2, sy-1);
      Paint(1, sy-1);
      Paint(2, sy);
      Paint(1, sy);
      for j := 3 to sx-1 do Paint(j, sy);
   end;
   inc(sy);
end;

procedure NewL;
var i, j : integer;
begin
   i := 1;
   while (i < sy) and (t[sx+1][i] = t[sx+1][i+1]) and
         (t[sx+1][i] <> t[1][1]) do inc(i);
   if i < sy then begin
      for j := i downto 1 do Paint(sx, j);
      for j := i+1 to sy-1 do Paint(sx, j);
   end else begin
      Paint(sx, 1);
      Paint(sx-1, 2);
      Paint(sx-1, 1);
      Paint(sx, 2);
      Paint(sx, 1);
      for j := 3 to sy-1 do Paint(sx, j);
   end;
   inc(sx);
end;

procedure Init;
begin
   Paint(1, 1);
   sx := 2; sy := 2;
   if (t[1][3] <> t[2][3]) or (t[1][3] = t[1][1]) then begin
      Paint(1, 2); inc(sy);
      NewL;
   end else begin
      if (t[3][1] <> t[3][2]) or (t[3][1] = t[1][1]) then begin
         Paint(2, 1); inc(sx);
         NewC;
      end else begin
         Paint(2, 2);
         Paint(2, 1);
         Paint(1, 2);
         Paint(1, 1);
         sx := 3; sy := 3;
      end;
   end;
end;

begin
   assign(Input, 'threecolors.in');
   assign(Output, 'threecolors.out');
   reset(Input);
   rewrite(Output);
   readln(m, n);
   for i := 1 to m do begin
      for j := 1 to n do begin
         read(c);
         case c of
            'R': t[i][j] := 1;
            'G': t[i][j] := 2;
            'B': t[i][j] := 3;
         end;
      end;
      readln;
   end;
   Init;
   while sy <> n do NewC;
   while sx <> m do NewL;
   close(Input);
   close(Output);
end.
