#include <cstdio>
#include <ctype.h>
#include <vector>
#include <algorithm>
#include <memory.h>

#define maxn 200

using namespace std;

long n,m;
long a[maxn][maxn];
long c[4];

void col(long x,long y,long c)
{
	for(long i=0;i<2;i++)
		for(long j=0;j<2;j++)
			a[x+i][y+j]=c;
}

void make(long x,long y)
{
	memset(c,0,sizeof(c));
	printf("%d %d\n",x,y);
	for(long i=0;i<=1;i++)
		for(long j=0;j<=1;j++)
			c[a[x+i][y+j]]++;
	long mx,q[4];
	q[0]=0;
	mx=max(c[1],max(c[2],c[3]));
	for(long i=1;i<=3;i++)
		if(c[i]==mx) q[q[0]++]=i;
	if(q[0]==1){
		col(x,y,q[0]);
		return;
	}
	long t=0;
	for(long i=1;i<=3;i++)
		if((q[1]!=i)&&(q[2]!=i)) t=i;
	col(x,y,t);
}

void make_right(long x,long y)
{
	make(x+1,y);
	make(x,y);
	make(x+1,y);
	make(x,y);
	make(x+2,y);
}

void swap_right(long x,long y)
{
	make(x+1,y);
	make(x,y);
	make(x+2,y);
}

void make_down(long x,long y)
{
	make(x,y+1);
	make(x,y);
	make(x,y+1);
	make(x,y);
	make(x,y+2);
}

void swap_down(long x,long y)
{
	make(x,y+1);
	make(x,y);
	make(x,y+2);
}


void add_right(long x)
{
	if(a[3][x]!=a[2][x]){
		make(2,x-1);
		make(1,x-1);
		return;
	}
	make(1,x-1);
	make(2,x-2);
	make(2,x-1);
	make(1,x-1);
}

void add_down(long x,long y)
{
	if(a[x][y+1]!=a[x][y+2]){
		make(x-1,y+1);
		make(x-1,y);
		return;
	}
	make(x-1,y);
	make(x-2,y+1);
	make(x-1,y+1);
	make(x-1,y);
}

void doo()
{
	if((a[1][3]==a[1][1])&&(a[2][3]==a[1][1])) add_down(3,1);
	else add_right(3);
}

int main()
{
	char c;
	freopen("threecolors.in","r",stdin);
	scanf("%d%d",&m,&n);
	for(long i=1;i<=m;i++)
		for(long j=1;j<=n;j++){
			do scanf("%c",&c); while(!isalpha(c));
			if(c=='R') a[i][j]=1;
			else if(c=='B') a[i][j]=2;
			else a[i][j]=3;
		}
	fclose(stdin);
	freopen("threecolors.out","w",stdout);
	make(1,1);
	long o=a[1][1];
	if((a[1][3]==o)||(a[2][3]==o)||(a[1][3]!=a[2][3])) make(1,2),doo();else
	if((a[3][1]==o)||(a[3][2]==o)||(a[3][1]!=a[3][2])) make(2,1),doo();else
	if(a[2][3]!=a[3][2]) make(2,2),make(1,2),make(2,1); else
	if(a[3][3]!=a[1][1]){
		make(2,2),make(1,2),make(2,1),make(1,1);
	} else{
		make(2,2),make(1,2),make(2,1),make(1,1);
	}
	for(long i=4;i<=n;i++)
		add_right(i);
	for(long i=1;i<=n-2;i+=3)
		for(long j=4;j<=m;j++)
			add_down(j,i);
	for(long j=4;j<=m;j++)
		add_down(j,n-2);
	fclose(stdout);
	return 0;
}
