#include <stdio.h>

#define MAX 3010
#define MAXT 4096

int H, W;
char S[MAX][MAX];
short F[MAX][MAX];
short T[MAXT * 2], FT[MAXT * 2];
long long Sum = 0;

int Get( int L, int R )
{
  int res, mi = (int)1e9;
  L += MAXT, R += MAXT;
  while (L < R)
  {
    if (L & 1)
    {
      if (T[L] < mi)
        mi = T[res = L];
      L++;
    }
    if (!(R & 1))
    {
      if (T[R] < mi)
        mi = T[res = R];
      R--;
    }
    if (L > R)
      break;
    L >>= 1, R >>= 1;
  }
  if (T[L] < mi)
    mi = T[res = L];
  return FT[res];
}

void Do( int L, int R )
{
  int M;

  if (L > R)
    return;
  if (L == R)
  {
    Sum += T[L + MAXT];
    return;
  }
  M = Get(L, R);
  Sum += (long long)T[M + MAXT] * (M - L + 1) * (R - M + 1);
  Do(L, M - 1);
  Do(M + 1, R);
}

int main( void )
{
  int i, j;

  freopen("rect.in", "rt", stdin);
  freopen("rect.out", "wt", stdout);
  scanf("%d%d", &H, &W);
  for (i = 0; i < H; i++)
    scanf("%s", S[i]);
  for (j = 0; j < W; j++)
    for (F[H][j] = 0, i = H - 1; i >= 0; i--)
      if (S[i][j] == 'W')
        F[i][j] = F[i + 1][j] + 1;
      else
        F[i][j] = 0;
  for (i = 0; i < H; i++)
  {
    for (j = 0; j < W; j++)
      T[MAXT + j] = F[i][j], FT[MAXT + j] = j;
    for (j = MAXT - 1; j > 0; j--)
      if (T[j + j] < T[j + j + 1])
        T[j] = T[j + j], FT[j] = FT[j + j];
      else
        T[j] = T[j + j + 1], FT[j] = FT[j + j + 1];
    Do(0, W - 1);
  }
  printf("%Ld", Sum);
  return 0;
}
