{$C-,I-,Q-,R-,S-}
var n,m,i,j,st2:longint;
    map:array [1..3000,1..3000] of char;
    best:array [1..3001,1..3000] of longint;
    sum1,sum2:array [1..8192] of longint;
    ans:int64;
    same:array [1..8192] of boolean;
procedure add(x,l0,r0,weight,cnt:longint);
var middle:longint;
begin
  if (weight<l0) or (weight>r0) then
    exit;
  if l0=r0 then
  begin
    inc(sum1[x],cnt);
    inc(sum2[x],cnt*weight);
    same[x]:=true;
    exit;
  end;
  if same[x] then
  begin
    assert(sum1[x]=0);
    assert(sum2[x]=0);
    same[x]:=false;
    same[2*x]:=true;
    same[2*x+1]:=true;
    sum1[2*x]:=0;
    sum2[2*x]:=0;
    sum1[2*x+1]:=0;
    sum2[2*x+1]:=0;
  end;
  middle:=(l0+r0) shr 1;
  add(2*x,l0,middle,weight,cnt);
  add(2*x+1,middle+1,r0,weight,cnt);
  sum1[x]:=sum1[2*x]+sum1[2*x+1];
  sum2[x]:=sum2[2*x]+sum2[2*x+1];
  if (sum1[x]=0) and (sum2[x]=0) then
    same[x]:=true;
end;
function query(x,l0,r0,l,r:longint):longint;
var middle:longint;
begin
  if (l>r0) or (r<l0) then
  begin
    query:=0;
    exit;
  end;
  if (l<=l0) and (r>=r0) then
  begin
    query:=sum1[x];
    exit;
  end;
  if same[x] then
  begin
    assert(sum1[x]=0);
    assert(sum2[x]=0);
    same[x]:=false;
    same[2*x]:=true;
    same[2*x+1]:=true;
    sum1[2*x]:=0;
    sum2[2*x]:=0;
    sum1[2*x+1]:=0;
    sum2[2*x+1]:=0;
  end;
  middle:=(l0+r0) shr 1;
  query:=query(2*x,l0,middle,l,r)+query(2*x+1,middle+1,r0,l,r);
  if (sum1[x]=0) and (sum2[x]=0) then
    same[x]:=true;
end;
procedure clean(x,l0,r0,l,r:longint);
var middle:longint;
begin
  if (l>r0) or (r<l0) then
    exit;
  if (l<=l0) and (r>=r0) then
  begin
    sum1[x]:=0;
    sum2[x]:=0;
    same[x]:=true;
    exit;
  end;
  if same[x] then
  begin
    assert(sum1[x]=0);
    assert(sum2[x]=0);
    exit;
  end;
  middle:=(l0+r0) shr 1;
  clean(2*x,l0,middle,l,r);
  clean(2*x+1,middle+1,r0,l,r);
  sum1[x]:=sum1[2*x]+sum1[2*x+1];
  sum2[x]:=sum2[2*x]+sum2[2*x+1];
  if (sum1[x]=0) and (sum2[x]=0) then
    same[x]:=true;
end;
begin
  assign(input,'rect.in');
  reset(input);
  assign(output,'rect.out');
  rewrite(output);
  readln(n,m);
  for i:=1 to n do
  begin
    for j:=1 to m do
      read(map[i,j]);
    readln;
  end;
  for i:=1 to m do
    best[n+1,i]:=0;
  for i:=n downto 1 do
    for j:=1 to m do
      if map[i,j]='W' then
        best[i,j]:=best[i+1,j]+1
      else best[i,j]:=0;
  ans:=0;
  st2:=1;
  while st2<=n do
    st2:=st2*2;
  for i:=1 to n do
  begin
    fillchar(sum1,sizeof(sum1),0); {Amount}
    fillchar(sum2,sizeof(sum2),0); {Part sum}
    fillchar(same,sizeof(same),true); {Zero node?}
    for j:=1 to m do
    begin
      add(1,0,st2-1,best[i,j],1);
      add(1,0,st2-1,best[i,j],query(1,0,st2-1,best[i,j]+1,n));
      clean(1,0,st2-1,best[i,j]+1,n);
      inc(ans,sum2[1]);
    end;
  end;
  writeln(ans);
  close(input);
  close(output);
end.
