#include <stdio.h>
#include <string.h>

#define MAXI(A, B) ((A) > (B) ? (A) : (B))

#define MAX 53
#define LEN 503
#define SLEN 100010

void Z( int *Pr, char *Str, char *Text )
{
  static char S[SLEN + LEN];
  static int P[SLEN + LEN];
  int TLen = strlen(Text), k, i, j, len;

  for (i = 0; i < TLen; i++)
    Pr[i] = 1;
  for (j = 0; j < strlen(Str); j++)
  {
    sprintf(S, "%s$", Str + j);
    len = strlen(S);
    for (i = 0; i < TLen; i++)
      S[len++] = Text[TLen - i - 1];
    P[0] = 0;
    for (k = 0, i = 1; i < len; i++)
    {
      while (k > 0 && S[k] != S[i])
        k = P[k - 1];
      if (S[k] == S[i])
        k++;
      P[i] = k;
    }
    for (i = 0; i < TLen; i++)
      Pr[i] = MAXI(Pr[i], P[len - i - 1]);
  }
}

#define RELAX(i, j, d) { if (D[i][j] > d) D[i][j] = d; }

int N, Len[MAX], Pr[MAX][SLEN], D[SLEN][MAX];
char Dic[MAX][LEN], S[SLEN];

int main( void )
{
  int i, j, k, l, d, len;

  freopen("typing.in", "rt", stdin);
  freopen("typing.out", "wt", stdout);
  scanf("%d", &N);
  for (i = 0; i < N; i++)
    scanf("%s", Dic[i]), Len[i] = strlen(Dic[i]);
  scanf("%s", S), len = strlen(S);
  for (j = 0; j < N; j++)
    Z(Pr[j], Dic[j], S);
  for (i = 0; i <= len; i++)
    for (j = 0; j < N; j++)
      D[i][j] = i + 1;
  for (i = 0; i < len; i++)
    for (j = 0; j < N; j++)
    {
      for (k = 0; k < N; k++)
        RELAX(i, j, D[i][k] + 1);
      d = D[i][j] + 1;
      RELAX(i + 1, j, d);
      for (k = 1; k <= Pr[j][i]; k++)
        RELAX(i + k, j, d);
    }
  for (j = len, i = 0; i < N; i++)
    if (j > D[len][i])
      j = D[len][i];
  printf("%d", j);
  return 0;
}
