  {$I-,Q-,R-,S-}
const
        MaxN = 50;
        MaxL = 500;
        MaxS = 100000;
        Inf = MaxS * 2;
var
        n : LongInt;
        s : Array[1 .. MaxN] of
        record
          len : Word;
          s : Array[1 .. MaxL] of Char;
        end;
        p : Array[1 .. MaxN, 1 .. MaxL, 1 .. MaxL] of Word;
        rez, a : Array[0 .. MaxN, 0 .. MaxS] of LongInt;

Procedure CPF;
var
        i, j, k : LongInt;
begin
  for i := 1 to n do
    for j := 1 to s[i].len do
    begin
      p[i][j][1] := 0;
      for k := 2 to s[i].len - j + 1 do
      begin
        p[i][j][k] := p[i][j][k - 1];
        While (s[i].s[p[i][j][k] + j] <> s[i].s[k + j - 1]) and (p[i][j][k] <> 0) do
          p[i][j][k] := p[i][j][p[i][j][k]];
        if s[i].s[p[i][j][k] + j] = s[i].s[k + j - 1] then
          Inc(p[i][j][k]);
      end;
    end;
end;

Procedure Init;
var
        i, j : LongInt;
begin
  ReadLn(n);
  for i := 1 to n do
  begin
    s[i].len := 0;
    While not SeekEoLn do
    begin
      Inc(s[i].len);
      Read(s[i].s[s[i].len]);
    end;
    ReadLn;
  end;
  CPF;
end;

Procedure Solve;
var
        tek : Array[1 .. MaxN, 1 .. MaxL] of LongInt;
        i, j, l, r : LongInt;
        ch : Char;
begin
  FillChar(tek, SizeOf(tek), 0);
  l := 0;
  for i := 1 to n do
    rez[i][0] := 1;
  rez[0][0] := 0;
  While not SeekEoLn do
  begin
    Inc(l);
    Read(ch);
    for i := 0 to n do
      rez[i][l] := Inf;
    for i := 0 to n do
    begin
      if rez[i][l] > rez[i][l - 1] + 1 then
        rez[i][l] := rez[i][l - 1] + 1;
      for j := 1 to s[i].len do
      begin
        While (s[i].s[tek[i][j] + j] <> ch) and (tek[i][j] <> 0) do
          tek[i][j] := p[i][j][tek[i][j]];
        if s[i].s[tek[i][j] + j] = ch then
          Inc(tek[i][j]);
        if a[i][l - tek[i][j]] < tek[i][j] then
        begin
          a[i][l - tek[i][j]] := tek[i][j];
          if rez[i][l] > rez[i][l - tek[i][j]] + 1 then
            rez[i][l] := rez[i][l - tek[i][j]] + 1;
        end;
        if tek[i][j] = s[i].len - j + 1 then
          tek[i][j] := p[i][j][tek[i][j]];
      end;
      for j := 1 to n do
        if rez[j][l] > rez[i][l] + 1 then
          rez[j][l] := rez[i][l] + 1;
    end;
  end;
  r := Inf;
  for i := 0 to n do
    if r > rez[i][l] then
      r := rez[i][l];
  Write(r);
end;

Procedure Print;
begin
end;

procedure Test;
var
        i, j : LongInt;
begin
  Assign(output, 'typing.in');
  Rewrite(output);
  WriteLn(MaxN);
  for i := 1 to MaxN do
  begin
    for j := 1 to MaxL do
      Write(Chr(Random(26) + Ord('a')));
    WriteLn;
  end;
  for i := 1 to 2000 do
    Write(Chr(Random(26) + Ord('a')));
  Close(output);
end;

begin
  Test;
  Assign(input, 'typing.in');
  Reset(input);
  Assign(output, 'typing.out');
  Rewrite(output);
  Init;
  Solve;
  Print;
  Close(input);
  Close(output);
end.
