{$R-,H+}
uses Math;
const namein='typing.in';
      nameout='typing.out';
      NMax=55;
      QMax=510;
      LMax=100001;
      Inf=LMax+NMax;
type
 integer=longint;
 TStr=array [1..NMax] of string;
 TPre=array [0..QMax] of integer;
 TDp=array [0..LMax,0..NMax] of integer;
var s,q,f:string;
    n,m,SMax:integer;
    x:TStr;
    d:TDp;

procedure Init;
var i:integer;
begin
 assign(input,namein);
 reset(input);
 readln(n);
 SMax:=0;
 for i:=1 to n do begin
   readln(x[i]);
   SMax:=max(SMax,length(x[i]))
  end;
 inc(SMax);
 readln(s);
 m:=length(s);
 close(input)
end;

function KMP(const a,b:string):integer;
var p:TPre;
    i,k,r:integer;
begin
 p[1]:=0;
 k:=0;
 for i:=2 to length(b) do begin
   while (k>0) and (b[i]<>b[k+1]) do k:=p[k];
   if b[i]=b[k+1] then inc(k);
   p[i]:=k
  end;
 k:=0; r:=0;
 for i:=1 to length(a) do begin
   while (k>0) and (a[i]<>b[k+1]) do k:=p[k];
   if a[i]=b[k+1] then inc(k);
   r:=max(r,k);
   if k=length(b) then k:=p[k]
  end;
 KMP:=r
end;

procedure Solve;
var i,j,k:integer;
    q,v:string;
begin
 for i:=0 to m do
  for j:=0 to n do d[i,j]:=Inf;
 d[0,0]:=0;
 v:='';
 for i:=1 to min(m,SMax) do v:=v+s[i];
 for i:=0 to m-1 do begin
   if i>0 then begin
     delete(v,1,1);
     if (i+SMax)<=m then v:=v+s[i+SMax]
    end;
   for j:=0 to n do
    if d[i,j]<>Inf then begin
      d[i+1,j]:=min(d[i+1,j],d[i,j]+1);
      d[i+1,0]:=min(d[i+1,0],d[i,j]+1);
      if j<>0 then begin
        k:=KMP(x[j],v);
        d[i+k,j]:=min(d[i+k,j],d[i,j]+1);
        d[i+k,0]:=min(d[i+k,0],d[i,j]+1)
       end
      else
       for k:=1 to n do d[i,k]:=min(d[i,k],d[i,j]+1)
     end
  end
end;

procedure Done;
var i,Sol:integer;
begin
 assign(output,nameout);
 rewrite(output);
 Sol:=Inf;
 for i:=0 to n do Sol:=min(Sol,d[m,i]);
 writeln(Sol);
 close(output)
end;

begin
 Init;
 Solve;
 Done
end.
