#include <stdio.h>
#include <string.h>

#define MAXN 55
#define MAXL 505
#define MAXD 100010
#define MAXA 30
#define MAXT 7000000
#define MAXR 30000

#define MAX(A, B) (((A) >= (B)) ? (A) : (B))

int N, D[MAXD][MAXN]/*, TCnt, TRoot, TNext[MAXT], TChar[MAXT], THair[MAXR][MAXA], TMax[]*/;
char S[MAXN][MAXL], Str[MAXD];

void relax(int i, int j, int d)
{
  if (D[i][j] == -1 || D[i][j] > d)
    D[i][j] = d;
}

int main( void )
{
  int i, j, k, t;
  freopen("typing.in", "rt", stdin);
  freopen("typing.out", "wt", stdout);

  scanf("%d", &N);
  for (i = 0; i < N; i++)
    scanf("%s", S[i]);
  scanf("%s", Str);
/*
  TCnt = 0;
  TRoot = -1;
  memset(TNext, 0, sizeof(TNext));
  memset(TMax, 0, sizeof(TMax));
  for (i = 0; i < N; i++)
    for (k = 0; S[i][k]; k++)
      TRoot = TPut(TRoot, i, k, 0);
*/
  memset(D, -1, sizeof(D));
  D[0][N] = 0;
  for (i = 0; Str[i]; i++)
  {
    for (j = 0; j <= N; j++)
      if (D[i][j] + 1)
        for (k = 0; k < N; k++)
          if (j != k)
            relax(i, k, D[i][j] + 1);
    for (j = 0; j <= N; j++)
      relax(i + 1, j, D[i][j] + 1);
    for (j = 0; j < N; j++)
      for (k = 0; S[j][k]; k++)
      {
        for (t = 0; Str[i + t] && S[j][k + t]; t++)
          ;
        if (t--)
          relax(i + t, j, D[i][j] + 1);
      }
/*
    for (t = TNext[TRoot][Str[i] - 'a'], j = 1; t + 1 && Str[i + j - 1]; t = TNext[t][MAX(Str[i + j] - 'a', 0)], j++)
      for (k = 0; k < N; k++)
        if (D[i][k] + 1 && TCan[t][k])
          relax(i + j, k, D[i][k] + 1);
*/
  }
  for (j = 0; j <= N; j++)
    relax(0, N + 1, D[i][j]);
  printf("%d\n", D[0][N + 1]);

  return 0;
}
