#include <stdio.h>
#include <string.h>

#define MAXN 55
#define MAXL 505
#define MAXD 100010

int N, D[MAXD][MAXN];
char S[MAXN][MAXL], Str[MAXD];

void relax(int i, int j, int d)
{
  if (D[i][j] == -1 || D[i][j] > d)
    D[i][j] = d;
}

int main( void )
{
  int i, j, k, t;
  freopen("typing.in", "rt", stdin);
  freopen("typing.out", "wt", stdout);

  scanf("%d", &N);
  for (i = 0; i < N; i++)
    scanf("%s", S[i]);
  scanf("%s", Str);
  memset(D, -1, sizeof(D));
  D[0][N] = 0;
  for (i = 0; Str[i]; i++)
  {
    for (j = 0; j <= N; j++)
      if (D[i][j] + 1)
        for (k = 0; k < N; k++)
          if (j != k)
            relax(i, k, D[i][j] + 1);
    for (j = 0; j <= N; j++)
      relax(i + 1, j, D[i][j] + 1);
    for (j = 0; j < N; j++)
      for (k = 0; S[j][k]; k++)
      {
        for (t = 0; Str[i + t] && S[j][k + t] && Str[i + t] == S[j][k + t]; t++)
          ;
        relax(i + t, j, D[i][j] + 1);
      }
  }
  for (j = 0; j <= N; j++)
    relax(0, N + 1, D[i][j]);
  printf("%d\n", D[0][N + 1]);

  return 0;
}
