type integer = longint;
const MNOGO = $7F7F7F7F;
const BSIZE = 1500000;
var n : integer;
	p : array[1..50, 1..500] of char;
	s : array[1..100000] of char;
	len : array[1..50] of integer;
	lens : integer;

procedure Load;
var i : integer;
	c : char;
begin
	readln(n);
	for i := 1 to n do begin
		len[i] := 0;
		read(c);
		if c = #13 then read(c);
		while c <> #10 do begin
			inc(len[i]);
			p[i, len[i]] := c;
			read(c);
			if c = #13 then read(c);
		end;
	end;
	lens := 0;
	read(c);
	if c = #13 then read(c);
	while (c <> #10) and (c <> #26) do begin
		inc(lens);
		s[lens] := c;
		read(c);
		if c = #13 then read(c);
	end;
end;

var en, next, first, suf, rt : array[1..BSIZE] of integer;
	fl1, fl2 : array[1..BSIZE] of integer;
	ch : array[1..BSIZE] of char;
	cslen, nver, ne : integer;
	cs : array[1..500] of char;

function AddTree : integer;
var cur, i, j, cgo : integer;
begin
	cur := 1;
	for i := 1 to cslen do begin
		cgo := 0;
		j := first[cur];
		while j <> 0 do begin
			if ch[j] = cs[i] then begin
				cgo := en[j];
				break;
			end;
			j := next[j];
		end;
		if cgo = 0 then begin
			inc(nver);
			inc(ne);
			next[ne] := first[cur];
			first[cur] := ne;
			en[ne] := nver;
			ch[ne] := cs[i];
			cgo := nver;
			rt[nver] := cur;
		end;
		cur := cgo;
	end;
	AddTree := cur;
end;

function GetGo(ver : integer; c : char) : integer;
var i : integer;
begin
	i := first[ver];
	while i <> 0 do begin
		if ch[i] = c then begin
			GetGo := en[i];
			exit;
		end;
		i := next[i];
	end;
	GetGo := 0;
end;

function CountSuf(ver : integer) : integer;
var j, i : integer;
	c : char;
begin
	if suf[ver] <> 0 then begin
		CountSuf := suf[ver];
		exit;
	end;
	if ver = 1 then begin
		suf[ver] := 1;
		CountSuf := 1;
		exit;
	end;
	if rt[ver] = 1 then begin
		suf[ver] := 1;
		CountSuf := 1;
		exit;
	end;
	i := first[rt[ver]];
	while i <> 0 do begin
		if en[i] = ver then c := ch[i];
		i := next[i];
	end;
	i := CountSuf(rt[ver]);
	while true do begin
		j := GetGo(i, c);
		if j <> 0 then begin
			i := j;
			break;
		end;
		i := CountSuf(i);
        if i = 1 then break;
	end;
	suf[ver] := i;
	CountSuf := suf[ver];
end;

procedure SetFl(pos : integer; f : integer);
begin
	if f <= 32 then begin
		fl1[pos] := fl1[pos] or (1 shl (f - 1));
	end
	else begin
		fl2[pos] := fl2[pos] or (1 shl (f - 33));
	end;
end;

function GetFl(pos : integer; f : integer) : integer;
begin
	if f <= 32 then begin
		if fl1[pos] and (1 shl (f - 1)) <> 0 then GetFl := 1
		else GetFl := 0;
	end
	else begin
		if fl2[pos] and (1 shl (f - 33)) <> 0 then GetFl := 1
		else GetFl := 0;
	end;
end;

var res : array[0..100000, 0..50] of integer;

procedure Solve;
var i, k, cver, j, min, mi, lpos : integer;
begin
	nver := 1;
	fillchar(fl1, sizeof(fl1), 0);
	fillchar(fl2, sizeof(fl2), 0);
	fillchar(first, sizeof(first), 0);
	fillchar(next, sizeof(next), 0);
	ne := 0;
	for i := 1 to n do begin
		move(p[i], cs, sizeof(cs));
		cslen := len[i];
		while cslen <> 0 do begin
			k := AddTree;
			SetFl(k, i);
			for j := 1 to cslen - 1 do cs[j] := cs[j + 1];
			dec(cslen);
		end;
	end;
	for i := 1 to nver do begin
		CountSuf(i);
	end;
	{make rt such as length}
	rt[1] := 0;
	for i := 2 to nver do rt[i] := rt[rt[i]] + 1;

	fillchar(res, sizeof(res), $7F);
	res[0, 0] := 0;
	cver := 1;
	for i := 1 to lens do begin
		while GetGo(cver, s[i]) = 0 do begin
			cver := suf[cver];
			if cver = 1 then break;
		end;
		if GetGo(cver, s[i]) <> 0 then cver := GetGo(cver, s[i]);
		{dull goes - simply type}
		for j := 0 to n do begin
			if res[i, j] > res[i - 1, j] + 1 then res[i, j] := res[i - 1, j] + 1;
		end;
		{clever goes - substring}
		if cver <> 1 then begin
			lpos := i - rt[cver];
			mi := 0;
			min := MNOGO;
			for j := 0 to n do begin
				if res[lpos, j] < min then begin
					min := res[lpos, j];
					mi := j;
				end;
			end;
			for j := 1 to n do begin
				if GetFl(cver, j) = 0 then continue;
				{same}
				if res[i, j] > res[lpos, j] + 1 then begin
					res[i, j] := res[lpos, j] + 1;
				end;
				{minimum}
				if res[i, j] > res[lpos, mi] + 2 then begin
					res[i, j] := res[lpos, mi] + 2;
				end;
			end;
		end;
	end;
	min := MNOGO;
	for i := 0 to n do begin
		if res[lens, i] < min then begin
			min := res[lens, i];
		end;
	end;
	write(min);
end;

begin
	assign(input, 'typing.in');
	assign(output, 'typing.out');
	reset(input);
	rewrite(output);
	Load;
	Solve;
	close(input);
	close(output);
end.
