{$I-,Q-,R-,S-}
const
        MaxN = 50;
        MaxL = 500;
        MaxS = 100000;
        Inf = MaxS * 2;
type
        TString = Array[1 .. MaxL] of Char;
        TT =
        record
          len : Word;
          s : TString;
        end;
var
        n : LongInt;
        s : Array[1 .. MaxN, 1 .. MaxL] of TT;
        rez : Array[0 .. MaxN, 0 .. MaxS] of LongInt;
        ss : Array[1 .. MaxS] of Char;
        le : Array[1 .. MaxN] of LongInt;

Procedure Init;
var
        i, j, y : LongInt;
begin
  ReadLn(n);
  for i := 1 to n do
  begin
    s[i][1].len := 0;
    While not SeekEoLn do
    begin
      Inc(s[i][1].len);
      Read(s[i][1].s[s[i][1].len]);
    end;
    le[i] := s[i][1].len;
    for y := 2 to s[i][1].len do
    begin
      s[i][y].len := s[i][y - 1].len - 1;
      for j := 1 to s[i][y].len do
        s[i][y].s[j] := s[i][y - 1].s[j + 1];
      for j := s[i][y].len + 1 to s[i][1].len do
        s[i][y].s[j] := #0;
    end;
    ReadLn;
  end;
end;

Function More(const a, b : TString) : Boolean;
var
        i : LongInt;
begin
  for i := 1 to MaxL do
    if a[i] <> b[i] then
    begin
      More := a[i] > b[i];
      Exit;
    end;
  More := False;
end;

Procedure Swap(var a, b : TT);
var
        c : TT;
begin
  c := a;
  a := b;
  b := c;
end;

Procedure QSort(const n, l, r : LongInt);
var
        i, j : LongInt;
        x : TString;
begin
  i := l;
  j := r;
  x := s[n][(l + r) div 2].s;
  repeat
    While More(x, s[n][i].s) do
      Inc(i);
    While More(s[n][j].s, x) do
      Dec(j);
    if i <= j then
    begin
      Swap(s[n][i], s[n][j]);
      Inc(i);
      Dec(j);
    end;
  until i > j;
  if l < j then
    QSort(n, l, j);
  if i < r then
    QSort(n, i, r);
end;

Procedure Solve;
var
        i, j, l, now, r, tek, q, w : LongInt;
        ch : Char;
        heap : Array[1 .. MaxN + 1] of Word;
        ssilk : Array[0 .. MaxN] of Word;{뫪    娯}

Procedure SwapInt(var a, b : Word);
var
        c : Byte;
begin
  c := a;
  a := b;
  b := c;
end;

Procedure Swap(const a, b : LongInt);
begin
  SwapInt(heap[a], heap[b]);
  SwapInt(ssilk[heap[a]], ssilk[heap[b]]);
end;

Procedure MoveUp(a : LongInt);
begin
  While (a <> 1) and (rez[heap[a]][now] < rez[heap[a div 2]][now]) do
  begin
    Swap(a, a div 2);
    a := a div 2;
  end;
end;

Procedure MoveDown(a : LongInt);
var
        b : LongInt;
begin
  While True do
  begin
    b := 0;
    if (a * 2 <= n + 1) and (rez[heap[a]][now] > rez[heap[a * 2]][now]) then
      b := a * 2;
    if (a * 2 + 1 <= n + 1) and (rez[heap[a]][now] > rez[heap[a * 2 + 1]][now]) then
    begin
      if b <> 0 then
      begin
        if rez[heap[b]][now] > rez[heap[a * 2 + 1]][now] then
          b := a * 2 + 1;
      end
      else
        b := a * 2 + 1;
    end;
    if b = 0 then
      Exit;
    Swap(a, b);
    a := b;
  end;
end;

Function BinSearch(const from, tek : LongInt) : LongInt;
var
        e : TString;
        i, min, max : LongInt;
begin
  if tek = 0 then
  begin
    BinSearch := 0;
    Exit;
  end;
  for i := 1 to MaxL do
    if i + from <= l then
      e[i] := ss[i + from]
    else
      e[i] := #255;
  min := 1;
  max := le[tek];
  While min <> max do
    if More(s[tek][(min + max + 1) div 2].s, e) then
      max := (min + max + 1) div 2 - 1
    else
      min := (min + max + 1) div 2;
  for i := 1 to s[tek][min].len do
    if e[i] <> s[tek][min].s[i] then
    begin
      BinSearch := i - 1;
      Exit;
    end;
  BinSearch := s[tek][min].len;
end;

begin
  for i := 1 to n do
    QSort(i, 1, s[i][1].len);
  l := 0;
  r := Inf;
  While not SeekEoLn do
  begin
    Inc(l);
    Read(ss[l]);
  end;
  for i := 0 to n do
    for j := 0 to l do
      rez[i][j] := Inf;
  rez[0][0] := 0;
  for now := 0 to l do
  begin
    for i := 0 to n do
    begin
      heap[i + 1] := i;
      ssilk[i] := i + 1;
      MoveUp(i + 1);
    end;
    for i := 0 to n do
    begin
      tek := heap[1];
      for j := 0 to n do
        if (rez[j][now] <> Inf * 2) and (rez[j][now] > rez[tek][now] + 1) then
        begin
          rez[j][now] := rez[tek][now] + 1;
          MoveUp(ssilk[j]);
        end;
      if rez[tek][now + 1] > rez[tek][now] + 1 then
        rez[tek][now + 1] := rez[tek][now] + 1;
      w := BinSearch(now, tek);
      for q := 1 to w do
        if now + q <= MaxS then
          if rez[tek][now + q] > rez[tek][now] + 1 then
            rez[tek][now + q] := rez[tek][now] + 1;
      if (now = l) and (r > rez[tek][now]) then
        r := rez[tek][now];
      rez[tek][now] := Inf * 2;
      MoveDown(ssilk[tek]);
    end;
  end;
  Write(r);
end;

Procedure Print;
begin
end;

procedure Test;
var
        i, j : LongInt;
begin
  Assign(output, 'typing.in');
  Rewrite(output);
  WriteLn(MaxN);
  for i := 1 to MaxN do
  begin
    for j := 1 to MaxL do
      Write(Chr(Random(26) + Ord('a')));
    WriteLn;
  end;
  for i := 1 to 5000 do
    Write(Chr(Random(26) + Ord('a')));
  Close(output);
end;

begin
  Test;
  Assign(input, 'typing.in');
  Reset(input);
  Assign(output, 'typing.out');
  Rewrite(output);
  Init;
  Solve;
  Print;
  Close(input);
  Close(output);
end.
