{$D+,I-,Q-,R-,S-}
type tnode=record
             n,ds:longint;
           end;
const inf=maxlongint shr 2;
var pk,r,n,m,o,oe,i,a,b,cab,cba,j,ans,ansc:longint;
    first,prev,preve,inheap,ds,dp,mark:array[1..150000]of longint;
    next,ew,ee:array[-350000..350000]of longint;
    ec:array[1..350000]of shortint;
    heap:array[1..150000]of tnode;

procedure swap(a,b:longint);
var t:tnode;
begin
  inheap[heap[a].n]:=b;
  inheap[heap[b].n]:=a;
  t:=heap[a];
  heap[a]:=heap[b];
  heap[b]:=t;
end;

procedure up(x:longint);
begin
  if x=1 then
    exit;
  if heap[x].ds<heap[x div 2].ds then
    swap(x,x div 2);
end;

procedure add(x,ds:longint);
begin
  inc(r);
  heap[r].n:=x;
  heap[r].ds:=ds;
  inheap[x]:=r;
  up(r);
end;

procedure down(x:longint);
var lc,rc,next:longint;
begin
  lc:=x*2;
  rc:=x*2+1;
  next:=x;
  if lc<=r then
    if heap[next].ds>heap[lc].ds then
      next:=lc;
  if rc<=r then
    if heap[next].ds>heap[rc].ds then
      next:=rc;
  if next<>x then
  begin
    swap(next,x);
    down(next);
  end;
end;

procedure delete(x:longint);
begin
  inheap[heap[r].n]:=x;
  inheap[heap[x].n]:=0;
  heap[x]:=heap[r];
  dec(r);
  if r=0 then
    exit;
  up(x);
  down(x);
end;

function findpath(s:longint):boolean;
var i,j,cur:longint;
begin
  findpath:=false;
  mark[s]:=1;
  ds[s]:=0;
  prev[s]:=0;
  r:=0;
  add(s,0);
  for i:=1 to o do
  begin
    cur:=heap[1].n;
    delete(1);
    j:=first[cur];
    while j<>0 do
    begin
      if ec[j]>0 then
        if mark[ee[j]]<>2 then
          if ds[ee[j]]>ds[cur]+(ew[j]+dp[ee[j]]-dp[cur]) then
          begin
            ds[ee[j]]:=ds[cur]+(ew[j]+dp[ee[j]]-dp[cur]);
            prev[ee[j]]:=cur;
            preve[ee[j]]:=j;
            if mark[ee[j]]=0 then
              add(ee[j],ds[ee[j]])
            else
            begin
              heap[inheap[ee[j]]].ds:=ds[ee[j]];
              up(inheap[ee[j]]);
            end;
            mark[ee[j]]:=1;
          end;
      j:=next[j];
    end;
    mark[cur]:=2;
  end;
  if mark[o-1]=2 then
    findpath:=true;
end;

procedure addedge(a,b,w:longint);
begin
  inc(oe);
  ee[oe]:=b;
  ew[oe]:=w;
  ec[oe]:=1;
  if first[a]=0 then
    first[a]:=oe
  else
  begin
    next[oe]:=first[a];
    first[a]:=oe;
  end;
  ee[-oe]:=a;
  ew[-oe]:=-w;
  ec[-oe]:=0;
  if first[b]=0 then
    first[b]:=-oe
  else
  begin
    next[-oe]:=first[b];
    first[b]:=-oe;
  end;
end;

begin
  assign(input,'orient.in');
  reset(input);
  read(n,m);
  o:=n;
  for i:=1 to m do
  begin
    read(a,b,cab,cba);
    inc(o);
    addedge(o,a,cba);
    addedge(o,b,cab);
  end;
  close(input);
  inc(o);
  for i:=1 to n do
    addedge(i,o,0);
  inc(o);
  for i:=n+1 to o-2 do
    addedge(o,i,0);
  for i:=1 to o do
  begin
    dp[i]:=0;
    ds[i]:=inf;
    mark[i]:=0;
  end;
  while true do
  begin
    if not findpath(o) then
      break;
    for i:=1 to o do
    begin
      dp[i]:=ds[i];
      ds[i]:=inf;
      mark[i]:=0;
    end;
    i:=o-1;
    while i<>o do
    begin
      j:=preve[i];
      i:=prev[i];
      ec[j]:=ec[j]-1;
      ec[-j]:=ec[j]+1;
    end;
  end;
  ans:=0;
  j:=first[o];
  while j<>0 do
  begin
    if ec[j]=0 then
      inc(ans);
    j:=next[j];
  end;
  ansc:=0;
  for i:=1 to oe do
    ansc:=ansc+ew[i]*(1-ec[i]);
  assign(output,'orient.out');
  rewrite(output);
  writeln(ans,' ',ansc);
  close(output);
end.
