#include <stdio.h>
#include <time.h>

#define MAX 103

int K, M, P[MAX], B[MAX], A[MAX][MAX];
int X[MAX], Sum[MAX];

int main( void )
{
  int i, j, start = clock();

  freopen("lock.in", "rt", stdin);
  freopen("lock.out", "wt", stdout);
  scanf("%d%d", &K, &M);
  for (i = 0; i < M; i++)
    scanf("%d", &P[i]);
  for (i = 0; i < M; i++)
    scanf("%d", &B[i]);
  for (i = 0; i < M; i++)
    if (B[i])
      break;
  if (i == M)
  {
    for (i = 0; i < K; i++)
      printf("0 ");
    return 0;
  }
  for (j = 0; j < K; j++)
    for (i = 0; i < M; i++)
      scanf("%d", &A[i][j]), A[i][j] %= P[i];
  srand(301703);
  while (clock() - start < 1900)
  {
    for (i = 0; i < K; i++)
      X[i] = rand() % 10000;
    for (i = 0; i < M; i++)
      for (Sum[i] = B[i], j = 0; j < K; j++)
      {
        Sum[i] += A[i][j] * X[j];
        if (Sum[i] >= (int)1e9)
          Sum[i] %= P[i];
      }
    for (i = 0; i < M; i++)
      if (Sum[i] % P[i])
        break;
    if (i == M)
    {
      for (i = 0; i < K; i++)
        printf("%d ", X[i]);
      return 0;
    }
  }
  puts("impossible");
  return 0;
}
