{ $DEFINE DEBUG}
{$H+}
{$IFDEF DEBUG}
{$C+,I+,Q+,R+,S+}
{$ELSE}
{$C-,I-,Q-,R-,S-}
{$ENDIF}
const taskid='typing';
      infile=taskid+'.in';
      outfile=taskid+'.out';
type ptrie=^ttrie;
     ttrie=record
       mask:int64;
       br,ch:ptrie;
       symb:char;
     end;
var n,i,j,k,num,l,r,m:longint;
    dict:array [1..50] of string;
    s:string;
    root,cur,tmp:ptrie;
    dp:array [0..100000,0..50] of longint;
    cmask:array [0..100001] of int64;
    value:array [1..50] of longint;
    cp:int64;
procedure createnode(var t:ptrie);
begin
  new(t);
  fillchar(t^,sizeof(t^),0);
end;
procedure add(t:ptrie;x:longint);
begin
  t^.mask:=t^.mask or (int64(1) shl x);
end;
function gc(t:ptrie;c:char):ptrie;
begin
  t:=t^.ch;
  while t<>nil do
  begin
    if t^.symb=c then
    begin
      gc:=t;
      exit;
    end;
    t:=t^.br;
  end;
  gc:=nil;
end;
function ac(t:ptrie;c:char):ptrie;
var tmp:ptrie;
begin
  new(tmp);
  tmp^.symb:=c;
  tmp^.mask:=0;
  tmp^.br:=t^.ch;
  tmp^.ch:=nil;
  t^.ch:=tmp;
  ac:=tmp;
end;
procedure update(var a:longint;b:longint);
begin
  if b<a then
    a:=b;
end;
begin
  assign(input,infile);
  reset(input);
  readln(n);
  for i:=1 to n do
    readln(dict[i]);
  readln(s);
  createnode(root);
  for i:=1 to n do
    for j:=1 to length(dict[i]) do
    begin
      cur:=root;
      add(root,i);
      for k:=j to length(dict[i]) do
      begin
        tmp:=gc(cur,dict[i,k]);
        if tmp=nil then
          cur:=ac(cur,dict[i,k])
        else cur:=tmp;
        add(cur,i);
      end;
    end;
  writeln(1);
  fillchar(dp,sizeof(dp),127);
  dp[0,0]:=0;
  for i:=1 to n do
    dp[0,i]:=1;
  for i:=0 to length(s) do
  begin
    for j:=1 to n do
      update(dp[i,0],dp[i,j]);
    for j:=1 to n do
      update(dp[i,j],dp[i,0]+1);
    if i=length(s) then
      break;
    cur:=gc(root,s[i+1]);
    k:=i+1;
    while cur<>nil do
    begin
      cmask[k]:=cur^.mask;
      if k=length(s) then
        break;
      inc(k);
      cur:=gc(cur,s[k]);
    end;
    if cur=nil then
      num:=k-1
    else num:=k;
    cmask[num+1]:=0;
    for j:=1 to n do
    begin
      cp:=int64(1) shl j;
      l:=i;
      r:=num+1;
      while r-l>1 do
      begin
        m:=(l+r) shr 1;
        if cmask[m] and cp<>0 then
          l:=m
        else r:=m;
      end;
      value[j]:=l;
    end;
    for j:=1 to n do
    begin
      update(dp[value[j],j],dp[i,j]+1);
      update(dp[i+1,j],dp[i,j]+1);
    end;
    update(dp[i+1,0],dp[i,0]+1);
  end;
  assign(output,outfile);
  rewrite(output);
  writeln(dp[length(s),0]);
  close(input);
  close(output);
end.
