#include <cstdio>
#include <cstdlib>
#include <memory.h>

#define maxn 201

using namespace std;

long k,m,p[maxn],q[maxn],a[maxn][maxn],b[maxn][maxn],ans[maxn];

template<class T>
T extended_gcd(T a,T b,T& x,T& y)
{
	if(a==0){
		x=0,y=1;
		return b;
	}
	if(b==0){
		x=1,y=0;
		return a;
	}
	T r=a%b,k=a/b,xx,yy;
	T tmp=extended_gcd(b,r,xx,yy);
	x=yy;
	y=xx-k*yy;
	return tmp;
}

template<class T>
T find(T a,T b,T c)
{
	T x,y;
	extended_gcd(a,c,x,y);
	/*(a,c)=1*/
	return b*x;
}

void save()
{
	freopen("lock.out","w",stdout);
	printf("impossible\n");
	fclose(stdout);
	exit(0);
}

int main()
{
	srand(5757);
	freopen("lock.in","r",stdin);
	scanf("%d%d",&k,&m);
	for(long i=1;i<=m;i++)
		scanf("%d",&p[i]);
	for(long i=1;i<=m;i++)
		scanf("%d",&q[i]),q[i]=(p[i]-q[i]+1)%p[i];
	for(long i=1;i<=k;i++)
		for(long j=1;j<=m;j++)
			scanf("%d",&a[i][j]),a[i][j]%=p[j];
	fclose(stdin);
	memset(b,0,sizeof(b));
	for(long i=1;i<=m;i++){
		long j,tt=0;
/*		printf("--\n");
		for(long x=1;x<=k;x++){
			for(long y=1;y<=m;y++) printf("%d ",a[x][y]);
			printf("\n");
		}*/
		do j=rand()%k+1,tt++; while((a[j][i]==0)&&(tt<=1000000));
		if(tt>1000000) save();
		b[j][i]=find(a[j][i],q[i],p[i]);
	}
	freopen("lock.out","w",stdout);
	for(long i=1;i<=k;i++){
		long ans=1,md,x,tmp;
		for(long j=1;j<=m;j++)
			if(b[i][j]==0) ans*=p[j];
		md=ans;
		for(long j=1;j<=m;j++){
			if(b[i][j]!=0){
				x=find(md,b[i][j]-ans,p[j]);
				ans=md*x+ans;
				md*=p[j];
				ans%=md;
				while(ans<0) ans+=md;
			}
		}
		printf("%d ",ans%md);
	}
	printf("\n");
	fclose(stdout);
	return 0;
}
