#include <stdio.h>
#include <string.h>
#include <memory.h>
#include <vector>
#include <algorithm>

struct Edge {
	int a, b;
	int cost;
};

int n, m;
Edge edge[200010];
int inv[10010];
int anse, ansc;

bool cmpEdge(Edge a, Edge b) {
	return (a.cost < b.cost);
}

int main(int argc, char **argv) {
	freopen("orient.in", "r", stdin);
	freopen("orient.out", "w", stdout);
	int i;
	scanf("%d%d", &n, &m);
	for (i = 0; i<m; i++) {
		int a, b, c, d;
		scanf("%d%d%d%d", &a, &b, &c, &d);
		a--;  b--;
		edge[2*i].a = a;
		edge[2*i].b = b;
		edge[2*i].cost = c;
		edge[2*i+1].a = b;
		edge[2*i+1].b = a;
		edge[2*i+1].cost = d;
	}
	std::sort(edge, edge+2*m, cmpEdge);
	memset(inv, -1, sizeof(inv));
	for (i = 0; i<2*m; i++) {
		if (inv[edge[i].a] == edge[i].b)
			continue;
		if (inv[edge[i].b] < 0) {
			anse++;
			ansc += edge[i].cost;
			inv[edge[i].b] = edge[i].a;
		}
	}
	printf("%d %d", anse, ansc);
	return 0;
}

