Program prg;


const
  epsilon=1E-3;

procedure swap(var a, b: integer);
  var
    t: integer;

  begin
    t:=a;
    a:=b;
    b:=t;
  end;


var
  k, m: integer;
  p: array[0..105] of integer;
  b: array[0..105] of integer;
  a: array[0..105, 0..105] of integer;

  i, j: integer;
  x, y, z: integer;
  alpha: longint;

  ans: array[0..105] of integer;

  temp: double;




begin
  assign(input, 'lock.in');
  assign(output, 'lock.out');
  reset(input);
  rewrite(output);

  readln(k, m);
  for i:=1 to m do begin
    read(p[i]);
  end;
  for i:=1 to m do begin
    read(b[i]);
  end;
  for i:=1 to k do
    for j:=1 to m do begin
      read(a[i][j]);
    end;

  for i:=1 to k do
    b[i]:=(1-b[i]+p[i])mod p[i];

//  inc(m);
//  for i:=1 to k do begin
//    a[i][m]:=p[i];
//  end;

  for i:=2 to k do begin
    for j:=1 to (i-1) do begin
      if a[j][j]=0 then begin
        x:=j+1;
        while (a[x][j]=0)and(x<=k) do inc(x);
        if x>k then begin
          dec(m);
          for y:=j to m do
            for z:=1 to k do
              a[z][y]:=a[z][y+1];
        end else begin
          for y:=1 to m do
            swap(a[x][y], a[j][y]);
        end;
      end;

      alpha:=a[i][j];
      for x:=1 to m do
        a[i][x]:=a[i][x]*a[j][j];
      b[i]:=b[i]*a[j][j];

      for x:=1 to m do begin
        a[i][x]:=a[i][x]-a[j][x]*alpha;
      end;
      b[i]:=b[i]-b[j]*alpha;

    end;
  end;

  for i:=k downto 1 do begin
    if a[i][i]=0 then begin
      ans[i]:=0;
      continue;
    end;
    temp:=(b[i])/(a[i][i] mod p[i]);
    if abs(round(temp) - temp)<epsilon then ans[i]:=round(temp) else
    begin
      writeln('impossible');
      close(output);
      halt;
    end;
    if i<>1 then b[i-1]:=(b[i-1]-ans[i]*a[i-1][i]+10000*p[i-1]) mod p[i-1];

  end;




  for i:=1 to k do write(ans[i], ' ');

  close(output);
  close(input);

end.
