#include <stdio.h>

struct edge
{
   int a, b;
   int c;
   bool e1;
   edge* next;
   bool ok;
};
edge* vStart [10057];

edge edges [100057*2];
int edgeAN = 0;
edge* allocEdge ()
{
   return & ( edges [edgeAN++] );
}

int numV, numE;

void read_input ()
{
   FILE* f = fopen ( "orient.in", "rt" );
   fscanf ( f, "%d %d", &numV, &numE );
   for ( int i = 0; i < numV; i++ )
      vStart [i] = NULL;
   for ( int i = 0; i < numE; i++ )
   {
      edge* e = allocEdge ();
      int a, b, cab, cba;
      fscanf ( f, "%d %d %d %d", &a, &b, &cab, &cba );
      a--;
      b--;
      e->a = a;
      e->b = b;
      e->c = cab;
      e->e1 = true;
      e->next = vStart [b];
      e->ok = true;
      vStart [b] = e;

      e = allocEdge ();
      e->a = b;
      e->b = a;
      e->c = cba;
      e->e1 = false;
      e->next = vStart [a];
      e->ok = true;
      vStart [a] = e;
   }
   numE *= 2;
   fclose ( f );
}

int num, cost;

void solve ()
{
   num = 0;
   cost = 0;
   
   int left = numE;
   while ( left > 0 )
   {
      int best = -1;
      int bestf;
      for ( int i = 0; i < numE; i++ )
      {
         if ( !edges [i].ok )
            continue;
         int forb = 0;
         int o;
         if ( edges [i].e1 )
            o = i + 1;
         else
            o = i - 1;
         if ( edges [o].ok )
            forb++;
         edge* e = vStart [edges [i].b];
         while ( e )
         {
            if ( e->ok && e != & ( edges [i] ) )
               forb++;
            e = e->next;
         }
         if ( best < 0 || forb < bestf ||
              ( forb == bestf && edges [i].c < edges [best].c ) )
         {
            best = i;
            bestf = forb;
         }
      }
      num++;
      cost += edges [best].c;
      int o;
      if ( edges [best].e1 )
         o = best + 1;
      else
         o = best - 1;
      edges [o].ok = false;
      edge* e = vStart [edges [best].b];
      while ( e )
      {
         e->ok = false;
         e = e->next;
      }
      left -= bestf + 1;
   }
}

void write_output ()
{
   FILE* f = fopen ( "orient.out", "wt" );
   fprintf ( f, "%d %d", num, cost );
   fclose ( f );
}

int main ()
{
   read_input ();
   solve ();
   write_output ();
   
   return 0;
}
