{$UNDEF DEBUG}
type integer = longint;
var n, m, k, ne : integer;
	isgood : array[1..110] of integer;
	edg : array[1..10000, 1..3] of integer;
	inv : array[1..10000] of integer;
	first : array[1..202] of integer;
	next : array[1..10000] of integer;

procedure AddEdge(v1, v2, cfl : integer);
begin
	inc(ne);
	edg[ne, 1] := v1;
	edg[ne, 2] := v2;
	edg[ne, 3] := cfl;
	next[ne] := first[v1];
	first[v1] := ne;
end;

procedure Load;
var i, v1, v2, p : integer;
begin
	read(n, m, k);
	for i := 1 to k do begin
		read(p);
		isgood[p] := 1;
	end;
	{i - vertex begin i + n - vertex end}
	{2 * n + 1 - source 2 * n + 2 - destination}
	ne := 0;
	for i := 1 to n do begin
		if isgood[i] = 0 then begin
			AddEdge(i + n, i, 2);
			AddEdge(i, i + n, 0);
			inv[ne] := ne - 1;
			inv[ne - 1] := ne;
		end
		else begin
			AddEdge(2 * n + 1, i, 1);
			AddEdge(i, 2 * n + 1, 0);
			inv[ne] := ne - 1;
			inv[ne - 1] := ne;
			AddEdge(2 * n + 2, i + n, 0);
			AddEdge(i + n, 2 * n + 2, 1);
			inv[ne] := ne - 1;
			inv[ne - 1] := ne;
		end;
	end;
	for i := 1 to m do begin
		read(v1, v2);
		AddEdge(v1, v2 + n, 1);
		AddEdge(v2 + n, v1, 0);
		inv[ne] := ne - 1;
		inv[ne - 1] := ne;
		AddEdge(v2, v1 + n, 1);
		AddEdge(v1 + n, v2, 0);
		inv[ne] := ne - 1;
		inv[ne - 1] := ne;
	end;
end;

var was : array[1..410] of integer;

function Dfs(ver : integer; var min : integer) : boolean;
var cmin, i : integer;
begin
	if ver = 2 * n + 2 then begin
    	{$IFDEF DEBUG}
        writeln;
		writeln('Found path : ');
        write(2 * n + 2, ' ');
        {$ENDIF}
		Dfs := true;
		exit;
	end;
	was[ver] := 1;
	i := first[ver];
	while i <> 0 do begin
		if (edg[i, 3] > 0) and (was[edg[i, 2]] = 0) then begin
			cmin := min;
			if edg[i, 3] < cmin then cmin := edg[i, 3];
			if Dfs(edg[i ,2], cmin) then begin
            	{$IFDEF DEBUG}
				write(ver, ' ');
                {$ENDIF}
				dec(edg[i, 3], cmin);
				inc(edg[inv[i], 3], cmin);
				min := cmin;
				Dfs := true;
				exit;
			end;
		end;
		i := next[i];
	end;
	Dfs := false;
end;

procedure Solve;
var res, min : integer;
begin
	{generate flow from 2 * n + 1 to 2 * n + 2}
	fillchar(was, sizeof(was), 0);
	res := 0;
	while Dfs(2 * n + 1, min) do begin
		inc(res, min);
		fillchar(was, sizeof(was), 0);
	end;
	write(res shr 1);
end;

begin
	assign(input, 'peace.in');
	assign(output, 'peace.out');
	reset(input);
	rewrite(output);
	Load;
	Solve;
	close(input);
	close(output);
end.
