const
        MaxN = 100;
var
        n, m, k : LongInt;
        sm : Array[1 .. MaxN, 0 .. 1, 1 .. MaxN, 0 .. 1] of LongInt;
        a, demo : Array[1 .. MaxN] of Boolean;
        usedinDFS : Array[1 .. MaxN, 0 .. 1] of Boolean;

Procedure Init;
var
        i, x, y : LongInt;
begin
  ReadLn(n, m, k);
  FillChar(sm, SizeOf(sm), False);
  for i := 1 to k do
  begin
    Read(x);
    a[x] := True;
  end;
  for i := 1 to n do
    sm[i][0][i][1] := 1;
  for i := 1 to m do
  begin
    Read(x, y);
    sm[x][1][y][0] := 1;
    sm[y][1][x][0] := 1;
  end;
end;

Function DFS(const u1, u2, zapr : LongInt) : Boolean;
var
        v1, v2 : LongInt;
begin
  DFS := False;
  if usedinDFS[u1][u2] then
    Exit;
  usedinDFS[u1][u2] := True;
  if (u1 <> zapr) and (a[u1]) and (u2 = 1) and (not demo[u1]) then
  begin
    DFS := True;
    demo[u1] := True;
    Exit;
  end;
  for v1 := 1 to n do
    for v2 := 0 to 1 do
      if sm[u1][u2][v1][v2] > 0 then
        if DFS(v1, v2, zapr) then
        begin
          Inc(sm[v1][v2][u1][u2]);
          Dec(sm[u1][u2][v1][v2]);
          DFS := True;
          Exit;
        end;
end;

Procedure Solve;
var
        i, rez : LongInt;
begin
  rez := 0;
  for i := 1 to n do
    if a[i] then
    begin
      FillChar(usedinDFS, SizeOf(usedinDFS), False);
      While DFS(i, 0, i) do
        Inc(rez);
    end;
  Write(rez);
end;

Procedure Print;
begin
end;

begin
  Assign(input, 'peace.in');
  Reset(input);
  Assign(output, 'peace.out');
  Rewrite(output);
  Init;
  Solve;
  Print;
  Close(input);
  Close(output);
end.
