#include <stdio.h>
#include <string.h>

#define MAXN 110
#define MAXM 2010
#define MINN 25
#define MAXP 2200000

#define MIN(A, B) (((A) <= (B)) ? (A) : (B))

int Ans, E, N, M, K, A[MAXN], B[MAXN], He[MAXN], U[MAXM], V[MAXM], Ne[MAXM], Ta[MAXM];
char D[MAXP][MINN];

void dfs(int p, int n, int a)
{
  int t, i;
  if (D[p][n])
    return;
  D[p][n] = 1;
  for (t = He[n]; t + 1; t = Ne[t])
    if (!(p & (1 << Ta[t])))
     if (B[Ta[t]])
     {
       if (a + 1 > Ans)
         Ans = a + 1;
       for (i = 0; i < K; i++)
         if (!(p & (1 << A[i])) && A[i] != Ta[t])
           dfs(p | (1 << Ta[t]) | (1 << A[i]), A[i], a + 1);
     }
     else
       dfs(p | (1 << Ta[t]), Ta[t], a);
}

int main( void )
{
  int i;

  freopen("peace.in", "rt", stdin);
  freopen("peace.out", "wt", stdout);

  memset(B, 0, sizeof(B));
  memset(He, -1, sizeof(He));
  scanf("%d%d%d", &N, &M, &K);
  for (i = 0; i < K; i++)
    scanf("%d", &A[i]), A[i]--, B[A[i]] = 1;
  E = 0;
  for (i = 0; i < M; i++)
    scanf("%d%d", &U[i], &V[i]), U[i]--, V[i]--,
        Ne[E] = He[U[i]], Ta[E] = V[i], He[U[i]] = E++,
        Ne[E] = He[V[i]], Ta[E] = U[i], He[V[i]] = E++;
  Ans = 0;
  memset(D, 0, sizeof(D));
  if (N <= 21)
    for (i = 0; i < K; i++)
      dfs(1 << A[i], A[i], 0);
  else
    Ans = MIN(M, K / 2);
  printf("%d\n", Ans);

  return 0;
}
