#include <stdio.h>
#include <string.h>
#include <algorithm>
#include <time.h>

#define WORK_TIME 1500

int n;
char s[5010], im[5010];
int tn;
char buff[5010];
struct Part {
	int l, r;
};
Part parr[3];
int stime;

typedef short *pshort;
pshort eqs[10010];

inline int min2(int a, int b) { return (a<b ? a : b); }
bool operator< (Part a, Part b) {
	return (a.l < b.l);
}

int readString(char *arr) {
	fgets(arr, 5005, stdin);
	int len = strlen(arr);
	while ((arr[len-1] == ' ') || (arr[len-1] == '\n'))
		len--;
	arr[len] = 0;
	return len;
}

int dind;
int ai;
inline bool equal(int di, int dj, int len) {
	dind = di-dj;
	if (dind < 0)
		ai = di;
	else
		ai = dj;
	return (eqs[dind+n][ai] == eqs[dind+n][ai+len]);
}

int main(int argc, char **argv) {
	freopen("stragain.in", "r", stdin);
	freopen("stragain.out", "w", stdout);
	stime = clock();
	n = readString(s);
	n = readString(im);
	int i, j, k;
	for (i = -n+1; i<n; i++) {
		int cs = min2(n-i, n+i);
		eqs[n+i] = new short[cs+1];
		int ds, dim;
		ds = (i<0 ? 0 : i);
		dim = (i>0 ? 0 : -i);
		for (j = 0; j<cs; j++)
			eqs[n+i][j+1] = (s[j+ds] != im[j+dim]);
		eqs[n+i][0] = 0;
		for (j = 1; j<=cs; j++)
			eqs[n+i][j] += eqs[n+i][j-1];
	}

	for (i = n-1; i>0; i--) {
		if ((clock()-stime)*1000 > WORK_TIME*CLOCKS_PER_SEC)
			break;
		for (j = i+1; j<n; j++) {
			parr[0].l = 0;
			parr[0].r = i;
			parr[1].l = i;
			parr[1].r = j;
			parr[2].l = j;
			parr[2].r = n;
			do {
				tn = 0;
				bool ok = true;
				for (k = 0; k<3; k++) {
					if (!equal(tn, parr[k].l, parr[k].r-parr[k].l)) {
						ok = false;
						break;
					}
					tn += parr[k].r-parr[k].l;
				}
				if (ok) {
					printf("YES\n");
					for (k = 0; k<3; k++) {
						memcpy(buff, im + parr[k].l, (parr[k].r-parr[k].l)*sizeof(char));
						buff[parr[k].r-parr[k].l] = 0;
						printf(buff);
						printf("\n");
					}
					return 0;
				}
			} while (std::next_permutation(parr, parr+3));
		}
	}
	printf("NO");
	for (i = -n+1; i<n; i++)
		delete eqs[n+i];
	return 0;
}
