program bpas;

var f, c      : array [1..250, 1..250] of integer;
    n, m, ans : integer;

procedure Load;
var i, x, u, v, k : integer;
begin
   assign(Input, 'peace.in');
   reset(Input);
   read(n, m, k);
   fillchar(c, sizeof(c), 0);
   for i := 1 to k do begin
      read(x);
      c[1][x+n+1] := 1;
      c[x+1][2*n+2] := 1;
   end;
   for i := 1 to m do begin
      read(u, v);
      c[u+1][n+1+v] := 1;
      c[v+1][n+1+u] := 1;
   end;
   for i := 1 to n do
      c[n+1+i][i+1] := 1;
   close(Input);
end;

var u : array [1..250] of boolean;

function find(v, d : integer) : boolean;
var i : integer;
begin
   if v = 2*n+2 then begin
      find := (d > 2);
      exit;
   end;
   u[v] := true;
   for i := 1 to 2*n+2 do begin
      if ((c[v][i] - f[v][i]) > 0) and (not u[i]) then
         if find(i, d+1) then begin
            find := true;
            f[v][i] := f[v][i]+1;
            f[i][v] := -f[v][i];
            exit;
         end;
   end;
   find := false;
end;

procedure Solve;
var stop : boolean;
    i    : integer;
begin
   ans := 0;
   fillchar(f, sizeof(f), 0);
   stop := false;
   while not stop do begin
      stop := true;
      for i := 1 to n do
         if (c[1][n+1+i] > 0) and (f[1][n+1+i] = 0) then begin
            fillchar(u, sizeof(u), 0);
            u[1] := true;
            if find(n+1+i, 0) then begin
               f[1][n+1+i] := 1;
               inc(ans); stop := false;
            end;
         end;
   end;
end;

procedure Save;
begin
   assign(Output, 'peace.out');
   rewrite(Output);
   writeln(ans);
   close(Output);
end;

begin
   Load;
   Solve;
   Save;
end.