{$R+}
const namein='strgame.in';
      nameout='strgame.out';
      NMax=11000;
      SMax=9;
      QMax=NMax*SMax*SMax;
      Empty='i';
      NA=-1;
      Lose=0;
      Win=1;
      Draw=2;
type
 TDp=array [0..NMax,'a'..'i','a'..'i'] of integer;
 TQue1=array [1..QMax] of integer;
 TQue2=array [1..QMax] of char;
 TVect=array [0..NMax] of char;
var d,w,f:TDp;
    s:string;
    q1:TQue1;
    q2,q3:TQue2;
    x:TVect;
    n,l,r,ql,qr:integer;

procedure Init;
var i:integer;
begin
 assign(input,namein);
 reset(input);
 readln(s);
 readln(l,r);
 n:=length(s);
 for i:=0 to n-1 do x[i]:=s[i+1];
 l:=l mod n;
 r:=r mod n;
 close(input)
end;

procedure StartQ;
begin
 ql:=1;
 qr:=1
end;

function EmptyQ:boolean;
begin
 EmptyQ:=(ql>=qr)
end;

procedure AddQ(const a:integer; const c1,c2:char);
begin
 q1[qr]:=a;
 q2[qr]:=c1;
 q3[qr]:=c2;
 inc(qr)
end;

procedure TakeQ(var a:integer; var c1,c2:char);
begin
 a:=q1[ql];
 c1:=q2[ql];
 c2:=q3[ql];
 inc(ql)
end;

procedure Solve;
var i,k,t:integer;
    c1,c2,c3:char;
begin
 StartQ;
 for i:=0 to n-1 do
  for c1:='a' to 'i' do
   for c2:='a' to 'i' do begin
     f[i,c1,c2]:=0;
     for k:=-r to l do begin
       t:=(i+n-k) mod n;
       if (x[t]<>x[i]) and
          (x[t]<>c1) and
          (x[t]<>c2)
       then inc(f[i,c1,c2]);
      end;
     if f[i,c1,c2]=0 then begin
       AddQ(i,c1,c2);
       d[i,c1,c2]:=0;
       w[i,c1,c2]:=Lose
      end
     else begin
       d[i,c1,c2]:=NA;
       w[i,c1,c2]:=Draw
      end
    end;
 while not EmptyQ do begin
   TakeQ(i,c1,c2);
   for k:=-l to r do
    if x[(i+n-k) mod n]=c1 then begin
      t:=(i+n-k) mod n;
      for c3:='a' to Empty do
       if d[t,c2,c3]=NA then begin
         if w[i,c1,c2]=Win then dec(f[t,c2,c3]);
         if (w[i,c1,c2]=Lose) or (f[t,c2,c3]=0) then begin
            d[t,c2,c3]:=d[i,c1,c2]+1;
            w[t,c2,c3]:=1-w[i,c1,c2];
            AddQ(t,c2,c3)
          end
        end
     end
  end
end;

procedure Done;
var k:integer;
begin
 assign(output,nameout);
 rewrite(output);
 if w[0,Empty,Empty]=Draw then writeln('DRAW')
 else
  if w[0,Empty,Empty]=Lose then begin
    writeln('LOSE');
    writeln(d[0,Empty,Empty])
   end
  else begin
    writeln('WIN');
    writeln(d[0,Empty,Empty]);
    for k:=l downto -r do
     if x[(n-k) mod n]<>x[0]
     then
      if (w[(n-k) mod n,x[0],Empty]=Lose) and
         (d[(n-k) mod n,x[0],Empty]=(d[0,Empty,Empty]-1))
      then begin
        writeln(-k);
        Break
       end
   end;
 close(output)
end;

begin
 Init;
 Solve;
 Done
end.
