type integer = longint;
const MNOGO = 1000000000;
const eps = 1e-6;
const NUMP = 6561;
var m, n, k, l : integer;
	ma : array[1..110, 1..8] of extended;

procedure Load;
var i, j : integer;
begin
	read(m, n, k, l);
	for i := 1 to n do begin
		for j := 1 to m do begin
			read(ma[i, j]);
		end;
	end;
end;

var res : array[1..101, 0..NUMP] of extended;
	lp : array[1..101, 0..NUMP] of integer;
	plc : array[1..101, 0..NUMP, 1..8] of byte;
	rma : array[1..101, 1..8] of integer;
	nma: array[1..3, 1..8] of byte;
	sum, sm : extended; 
	cpp : array[1..8] of byte;
	
procedure GenGO(cs, cp : integer);
var np, i, j, cur : integer;
	
procedure TryPlace(pos : integer);
var ourma : array[1..3, 1..8] of byte;
	j, ii, jj : shortint;
begin                 	
	if pos = m + 1 then begin
		if abs(sum) < eps then exit;
		{pack profile}
		np := 0;
		for j := m downto 1 do begin
			if nma[3, j] = 1 then np := np * 3 + 2
			else if nma[2, j] = 1 then np := np * 3 + 1
			else np := np * 3;
		end;
		{relax}
		sm := ln(sum);
		if res[cs + 1, np] < res[cs, cp] + sm then begin
			res[cs + 1, np] := res[cs, cp] + sm;
			move(cpp, plc[cs + 1, np], sizeof(plc[cs + 1, np]));
			lp[cs + 1, np] := cp;
		end;
		exit;
	end;
	cpp[pos] := 0;
	TryPlace(pos + 1);             
    if nma[1, pos] = 0 then begin	
    	move(nma, ourma, sizeof(ourma));
		for ii := 1 to l do begin
			for jj := pos - k + 1 to pos + k - 1 do begin
				if (jj < 1) then continue;
				if (jj > m)then break;
				nma[ii, jj] := 1;
			end;
		end;
		cpp[pos] := 1;
		sum := sum + ma[cs, pos];
		TryPlace(pos + 1);
		sum := sum - ma[cs, pos];
	    move(ourma, nma, sizeof(nma));
	end;                          
end;

begin
	{unpack profile}
	fillchar(nma, sizeof(nma), 0);
	cur := cp;
	for i := 1 to m do begin
		for j := 1 to cur mod 3 do nma[j, i] := 1;
		cur := cur div 3;
	end;
	sum := 0;
	TryPlace(1);
end;

procedure Solve;
var ii, i, j, mi : integer;
	max : extended;
begin
	for i := 1 to 101 do begin
		for j := 0 to NUMP do begin
			res[i, j] := -MNOGO;
		end;
	end;
	res[1, 0] := 0;
	for i := 1 to n do begin
		for j := 0 to NUMP do begin
			if abs(res[i, j] + MNOGO) < eps then continue;
			GenGo(i, j);
		end;
	end;
	max := -MNOGO;
	mi := 0;
	for i := 0 to NUMP do begin
		if res[n + 1, i] > max then begin
			max := res[n + 1, i];
			mi := i;
		end;
	end;
	if (abs(max + MNOGO) < eps) then begin
		write('IMPOSSIBLE');
	end
	else begin
		fillchar(rma, sizeof(rma), 0);
		j := mi;
		for i := n + 1 downto 2 do begin
			for ii := 1 to 8 do rma[i - 1, ii] := plc[i, j, ii];
			j := lp[i, j];	
		end;
		for i := 1 to n do begin
			for j := 1 to m do begin
				write(rma[i, j], ' ');
			end;
			writeln;
    	end;
   	end;
end;

begin
	assign(input, 'sprats.in');
	assign(output, 'sprats.out');
	reset(input);
	rewrite(output);
	Load;
	Solve;
	close(input);
	close(output);
end.
