#include <cstdio>
#include <cstring>

#define FIX(i) ((i)<0?(i)+n:(i)>=n?(i)-n:(i))
#define LOSE 1
#define WIN 2
#define st 9

char p1[st*st], p2[st*st];

int ptoi(char a, char b){
  return a+b*st;
}

void initp(){
  int i, j;
  for (i=0; i<st; i++)
    for (j=0; j<st; j++){
      p1[ptoi(i, j)]=i;
      p2[ptoi(i, j)]=j;
    }
}

int d[10000][st*st], n, i, i1, k, j, x, y, z, curd;
char t[10000][st*st], L[10000][st*st], str[10001];
int q[st*st*10000], q1[st*st*10000], s, e, l, r;

int main(){
  freopen("strgame.in", "rt", stdin);
  freopen("strgame.out", "wt", stdout);
  initp();
  scanf("%[a-h]%d%d", str, &l, &r);
  n=strlen(str);
  if (l>=n) l=n-1;
  if (r>=n) r=n-1;
  for (i=0; i<n; i++) str[i]-='a';
  for (i=0; i<n; i++)
    for (i1=0; i1<st*st; i1++){
      x=p1[i1];
      y=p2[i1];
      z=str[i];
      for (j=(n+i-l)%n; j!=i; j++){
        if (j==n){
          j=0;
          if (i==j) break;
        }
        if (str[j]!=x&&str[j]!=y&&str[j]!=z)
          L[i][i1]++;
      }
      for (j=(i+l)%n; j!=i; j--){
        if (j==-1){
          j=n-1;
          if (i==j) break;
        }
        if (str[j]!=x&&str[j]!=y&&str[j]!=z)
          L[i][i1]++;
      }
      if (L[i][i1]==0){
        t[i][i1]=LOSE;
        d[i][i1]=0;
        q[e]=i;
        q1[e++]=i1;
      }
    }
  while (s<e){
    x=p1[q1[s]];
    y=p2[q1[s]];
    z=str[q[s]];
    if (x==y||x==z||y==z){
      s++;
      continue;
    }
    i=q[s];
    curd=d[q[s]][q1[s]];
    if (t[q[s]][q1[s]]==LOSE){
      for (j=(i+l)%n; j!=i; j--){
        if (j==-1){
          j=n-1;
          if (i==j) break;
        }
        if (str[j]==y){
          for (k=0; k<st; k++){
            i1=ptoi(k, x);
            if (k==8) k=9;
            if (k==x||k==y||k==z||t[j][i1]!=0) continue;
            t[j][i1]=WIN;
            d[j][i1]=curd+1;
            q[e]=j;
            q1[e++]=i1;
          }
        }
      }
      for (j=(n+i-r)%n; j!=i; j++){
        if (j==n){
          j=0;
          if (i==j) break;
        }
        if (str[j]==y){
          for (k=0; k<st; k++){
            i1=ptoi(k, x);
            if (k==8) k=9;
            if (k==x||k==y||k==z||t[j][i1]!=0) continue;
            t[j][i1]=WIN;
            d[j][i1]=curd+1;
            q[e]=j;
            q1[e++]=i1;
          }
        }
      }
    } else {
      for (j=(i+l)%n; j!=i; j--){
        if (j==-1){
          j=n-1;
          if (i==j) break;
        }
        if (str[j]==y){
          for (k=0; k<st; k++){
            i1=ptoi(k, x);
            if (k==8) k=9;
            if (k!=x&&k!=y&&k!=z&&curd+1>d[j][i1]) d[j][i1]=curd+1;
            if (k==x||k==y||k==z||--L[j][i1]!=0) continue;
            t[j][i1]=LOSE;
            q[e]=j;
            q1[e++]=i1;
          }
        }
      }
      for (j=(n+i-r)%n; j!=i; j++){
        if (j==n){
          j=0;
          if (i==j) break;
        }
        if (str[j]==y){
          for (k=0; k<st; k++){
            i1=ptoi(k, x);
            if (k==8) k=9;
            if (k!=x&&k!=y&&k!=z&&curd+1>d[j][i1]) d[j][i1]=curd+1;
            if (k==x||k==y||k==z||--L[j][i1]!=0) continue;
            t[j][i1]=LOSE;
            q[e]=j;
            q1[e++]=i1;
          }
        }
      }
    }
    s++;
  }
  if (t[0][80]==0)
    printf("DRAW");
  else if (t[0][80]==LOSE)
   printf("LOSE\n%d", d[0][80]);
  else {
    printf("WIN\n%d\n", d[0][80]);
    for (i=-l; i<=r; i++){
      if (i==0) continue;
      if (t[FIX(i)][ptoi(str[0], 8)]==LOSE&&d[FIX(i)][ptoi(str[0], 8)]==d[0][80]-1){
        printf("%d", i);
        return 0;
      }
    }
  }
  /*printf("\n");
  for (i=0; i<n; i++)
    for (i1=0; i1<64; i1++){
      if ((p1[i1]!=8&&p1[i1]==p2[i1])||p1[i1]==str[i]||p2[i1]==str[i]) continue;
      printf("%d %c %c %s %d\n", i, p1[i1]+'a', p2[i1]+'a', t[i][i1]==0?"DRAW":t[i][i1]==1?"LOSE":"WIN ", t[i][i1]==0?L[i][i1]:d[i][i1]);
    }*/
  return 0;
}
