#include <stdio.h>
#include <string.h>

#define LEN 10010
#define MAX 103
#define MAXV (LEN << 6)
#define MAXE 1000010

#define V(P, A, B) (((P) << 6) + ((A) << 3) + (B))

char S[LEN];
int Len, L, R, He[MAXV], InDeg[MAXV], OutDeg[MAXV];
int E = 0, Ne[MAXE], Y[MAXE], ELen[MAXE];
int F[MAXV], C[MAXV], Mov[MAXV], Sh[MAXV];
int Po = 0, Si = 0, Q[MAXV];

int main( void )
{
  int x, x1, i, j, c1, c2, v1, v2, e, f, m;

  freopen("strgame.in", "rt", stdin);
  freopen("strgame.out", "wt", stdout);
  scanf("%s%d%d", S, &L, &R), Len = strlen(S);
  for (i = 0; i < Len; i++)
    S[i] -= 'a';
  memset(He, -1, sizeof(He));
  memset(InDeg, 0, sizeof(InDeg));
  memset(OutDeg, 0, sizeof(OutDeg));
  for (x = 0; x < Len; x++)
    for (x1 = x - L, i = -L; i <= R; i++, x1++)
      if ((x1 = (x1 % Len + Len) % Len) != x && S[x1] != S[x])
        for (c1 = 0; c1 < 8; c1++)
          for (c2 = 0; c2 < 8; c2++)
            if (S[x1] != c1 && S[x1] != c2)
            {
              v1 = V(x, c1, c2), v2 = V(x1, S[x], c1);
              Ne[E] = He[v2], Y[E] = v1, ELen[E] = i, He[v2] = E++;
              OutDeg[v1]++, InDeg[v2]++;
            }
  memset(F, -1, sizeof(F));
  memset(C, 0, sizeof(C));
  for (i = 0; i < (Len << 6); i++)
    if (!OutDeg[i])
      F[i] = 0, Mov[i] = 0, Q[Si++] = i;
  while (Po < Si)
  {
    i = Q[Po++], f = F[i], m = Mov[i] + 1;
    for (e = He[i]; e != -1; e = Ne[e])
      if (F[j = Y[e]] == -1)
      {
        if (!f)
          F[j] = 1, Mov[j] = m, Sh[j] = ELen[e], Q[Si++] = j;
        else if (++C[j] == OutDeg[j])
          F[j] = 0, Mov[j] = m, Q[Si++] = j;
      }
      else if (!f && F[j] == 1 && Mov[j] == m && Sh[j] > ELen[e])
        Sh[j] = ELen[e];
  }
  i = V(0, S[0], S[0]);
  if (F[i] == 1)
    printf("WIN\n%d\n%d\n", Mov[i], Sh[i]);
  else if (F[i] == 0)
    printf("LOSE\n%d\n", Mov[i]);
  else
    puts("DRAW");
  return 0;
}
