#include <stdio.h>
#include <string.h>

#define MAXN 110
#define MAXM 8
#define MAXP 70000

#define eps 1e-9

#define MAX(A, B) (((A) >= (B)) ? (A) : (B))

char D1[MAXP][300];                              // Bytes: 21000000
int M, N, K, L, Pa[MAXN][MAXP];                  // Bytes: 30800016
double P[MAXN][MAXM], D[2][MAXP], D2[MAXN][300]; // Bytes:  1391040
                                                 // Total: 53275056 Bytes (~51 Mb)

int R[MAXN], RN;

int main( void )
{
  int i, j, k, p, np, t;

  freopen("sprats.in", "rt", stdin);
  freopen("sprats.out", "wt", stdout);

  scanf("%d%d%d%d", &M, &N, &K, &L);
  for (i = 0; i < N; i++)
    for (j = 0; j < M; j++)
      scanf("%lf", &P[i][j]);
  memset(D, 0, sizeof(D));
  memset(Pa, -1, sizeof(Pa));
  memset(D2, 0, sizeof(D2));
/*
  for (i = 0; i < N; i++)
    for (j = 0; j < M; j++)
      printf("P[i = %d][j = %d] = %lf\n", i, j, P[i][j]);
*/
  for (i = 0; i < N; i++)
    for (j = 0; j < (1 << M); j++)
      for (k = 0; k < M; k++)
        if (j & (1 << k))
          D2[i][j] += P[i][k];
/*
  for (i = 0; i < N; i++)
    for (j = 0; j < (1 << M); j++)
      printf("D2[i = %d][j = %d] = %lf\n", i, j, D2[i][j]);
*/
  for (i = 0; i < (1 << (M << 1)); i++)
    for (j = 0; j < (1 << M); j++)
      for (D1[i][j] = 1, k = 0; D1[i][j] && k < M; k++)
        if (j & (1 << k))
          for (t = MAX(0, k - K + 1); t < k + K && t < M && D1[i][j]; t++)
          {                                            
            if (L >= 1 && (j & (1 << t)) && t != k)
              D1[i][j] = 0;
            if (L >= 2 && (i & (1 << t)))
              D1[i][j] = 0;
            if (L >= 3 && (i & (1 << (t + M))))
              D1[i][j] = 0;
          }
/*
  for (i = 0; i < (1 << (M << 1)); i++)
    for (j = 0; j < (1 << M); j++)
      printf("D1[i = %03d][j = %02d] = %s\n", i, j, D1[i][j] ? "YES" : "NO");
*/
  D[0][0] = 1;
  k = 0;
  for (i = 0; i < N; i++)
  {
    for (p = 0; p < (1 << (M << 1)); p++)
      if (D[k][p] > eps)
        for (np = 0; np < (1 << M); np++)
          if (D1[p][np])
            if (D[1 - k][(p << M | np) & ((1 << (M << 1)) - 1)] < D2[i][np] * D[k][p])
            {
              D[1 - k][(p << M | np) & ((1 << (M << 1)) - 1)] = D2[i][np] * D[k][p];
              Pa[i + 1][(p << M | np) & ((1 << (M << 1)) - 1)] = p;
            }
    memset(D[k], 0, sizeof(D[k]));
    k = 1 - k;
  }
  for (p = np = 0; np < (1 << (M << 1)); np++)
    if (D[k][np] > D[k][p])
      p = np;
  if (D[k][p] < eps)
    printf("IMPOSSIBLE\n");
  else
  {
    RN = 0;
    i = N;
//    printf("p = %d\n", p);
    while (p + 1)
    {
      R[RN++] = p;
      p = Pa[i--][p];
    }
    for (i = N - 1; i >= 0; i--)
      for (j = 0; j < M; j++)
        printf("%d%c", !!(R[i] & (1 << j)), (j == M - 1) ? '\n' : ' ');
  }

  return 0;
}
