const
	eps=1e-9;
  BigEps=1e-5;
type
	line=record
  	a,b,c:extended;
  end;
  point=record
  	x,y:integer;
  end;
  otr=record
		a,b:point;
  end;
var
	a:array[1..2000] of point;
  o:array[1..2000] of otr;
  n:integer;
	maxcount:integer;
	bestline:line;
function znak(l:line;p:point):integer;
begin
	if abs(l.a*p.x+l.b*p.y+l.c)<eps then
  	znak:=0
  else if l.a*p.x+l.b*p.y+l.c<0 then
  	znak:=-1
  else
  	znak:=1;
end;

function cross(l:line;o:otr):boolean;
begin
	cross:=(znak(l,o.a)*znak(l,o.b)=-1);
end;
procedure testline(l:line);
var
	i,aa,bb,cc,count:integer;
  tl:line;
begin
	for aa:=-1 to 1 do
  	for bb:=-1 to 1 do
  		for cc:=-1 to 1 do
        tl.a:=l.a+bigeps*aa;
        tl.b:=l.b+bigeps*bb;
        tl.c:=l.c+bigeps*cc;
        count:=0; 	
      	for i:=1 to n-1 do begin
        	if cross(tl,o[i]) then inc(count);
        end;
        if count>maxcount then begin
        	maxcount:=count;
          bestline:=tl;
       	end;
end;
function makeline(p1,p2:point):line;
begin
	makeline.a:=p2.y-p1.y;
  makeline.b:=p1.x-p2.x;
  makeline.c:=1.0*p1.y*(p2.x-p1.x)-1.0*p1.x*(p2.y-p1.y);
end;
procedure genline(o1,o2:otr);
begin
	testline(makeline(o1.a,o2.a));
  testline(makeline(o1.a,o2.b));
	testline(makeline(o1.b,o2.a));
	testline(makeline(o1.b,o2.b));
end;
procedure out;
begin
	writeln(bestline.a);
  writeln(bestline.b);
  writeln(bestline.c);
//  writeln('y=',-bestline.a/bestline.b:0:8,'*x+',-bestline.c/bestline.b:0:8);
//  writeln(maxcount);
end;

var
	i,x,y,j:integer;
  o1,o2:line;	
begin
	assign(input,'polyline.in');
  reset(input);
  assign(output,'polyline.out');
  rewrite(output);

  readln(n);
  for i:=1 to n do begin
  	readln(x,y);
    a[i].x:=x;
    a[i].y:=y;
    if i>1 then begin
    	o[i-1].a.x:=a[i-1].x;
      o[i-1].a.y:=a[i-1].y;
    	o[i-1].b.x:=a[i].x;
    	o[i-1].a.y:=a[i].y;
    end;
  end;
  maxcount:=0;
  for i:=1 to n-1 do
    for j:=i+1 to n do begin
			testline(makeline(a[i],a[j]));

//    	genline(o1,o2);
    end;

  out;	

  close(input);
  close(output);
end.
