{ $DEFINE DEBUG}
{$H+}
{$IFDEF DEBUG}
{$C+,I+,Q+,R+,S+}
{$ELSE}
{$C-,I-,Q-,R-,S-}
{$ENDIF}
uses math;
const taskid='sprats';
      infile=taskid+'.in';
      outfile=taskid+'.out';
      eps=1e-25;
var m,n,k,l,i,j,nump,ne,temp,cur,ansi:longint;
    p:array [1..100,1..8] of extended;
    cprof,cmask,nprof:array [1..8] of longint;
    first:array [0..10000] of longint;
    edge:array [1..100000] of record
      v,w,n:longint;
    end;
    data:array [1..100,0..255] of extended;
    best:array [0..100,0..7000] of extended;
    ans:extended;
    lastp,lastm:array [0..100,0..7000] of longint;
procedure addedge(a,b,c:longint);
begin
  inc(ne);
  edge[ne].v:=b;
  edge[ne].w:=c;
  edge[ne].n:=first[a];
  first[a]:=ne;
end;
procedure rec(cpnum,x,last:longint);
var i,nnum,cmnum:longint;
begin
  if x=m+1 then
  begin
    nprof:=cprof;
    for i:=1 to m do
    begin
      dec(nprof[i]);
      if nprof[i]<0 then
        nprof[i]:=0;
      if cmask[i]=1 then
        nprof[i]:=l-1;
    end;
    nnum:=0;
    for i:=m downto 1 do
      nnum:=nnum*l+nprof[i];
    cmnum:=0;
    for i:=m downto 1 do
      cmnum:=cmnum*2+cmask[i];
    addedge(cpnum,nnum,cmnum);
    exit;
  end;
  cmask[x]:=0;
  rec(cpnum,x+1,last);
  if x<last+k then
    exit;
  for i:=max(1,x-k+1) to min(m,x+k-1) do
    if cprof[i]<>0 then
      exit;
  cmask[x]:=1;
  rec(cpnum,x+1,x);
end;
procedure restore(i,j:longint);
var temp,k:longint;
begin
  if i=0 then
    exit;
  restore(i-1,lastp[i,j]);
  temp:=lastm[i,j];
  for k:=1 to m do
  begin
    write(temp mod 2,' ');
    temp:=temp div 2;
  end;
  writeln;
end;
begin
  assign(input,infile);
  reset(input);
  assign(output,outfile);
  rewrite(output);
  read(m,n,k,l);
  for i:=1 to n do
    for j:=1 to m do
      read(p[i,j]);
  nump:=1;
  for i:=1 to m do
    nump:=nump*l;
  fillchar(first,sizeof(first),0);
  ne:=0;
  for i:=0 to nump-1 do
  begin
    temp:=i;
    for j:=1 to m do
    begin
      cprof[j]:=temp mod l;
      temp:=temp div l;
    end;
    rec(i,1,-100);
  end;
  for i:=1 to n do
    for j:=0 to 1 shl m-1 do
    begin
      temp:=j;
      for k:=1 to m do
      begin
        cmask[k]:=temp mod 2;
        temp:=temp div 2;
      end;
      data[i,j]:=0;
      for k:=1 to m do
        if cmask[k]=1 then
          data[i,j]:=data[i,j]+p[i,k];
    end;
  fillchar(best,sizeof(best),0);
  fillchar(lastp,sizeof(lastp),255);
  fillchar(lastm,sizeof(lastm),255);
  best[0,0]:=1;
  lastp[0,0]:=0;
  for i:=0 to n-1 do
    for j:=0 to nump-1 do
      if lastp[i,j]<>-1 then
      begin
        cur:=first[j];
        while cur<>0 do
        begin
          if abs(data[i+1,edge[cur].w])>eps then
            if best[i,j]*data[i+1,edge[cur].w]>best[i+1,edge[cur].v] then
            begin
              best[i+1,edge[cur].v]:=best[i,j]*data[i+1,edge[cur].w];
              lastp[i+1,edge[cur].v]:=j;
              lastm[i+1,edge[cur].v]:=edge[cur].w;
            end;
          cur:=edge[cur].n;
        end;
      end;
  ans:=-1;
  ansi:=-1;
  for i:=0 to nump-1 do
    if (lastp[n,i]<>-1) and (best[n,i]>ans) then
    begin
      ans:=best[n,i];
      ansi:=i;
    end;
  if ansi=-1 then
    writeln('IMPOSSIBLE')
  else restore(n,ansi);
  close(input);
  close(output);
end.
