{$R-,Q-,S-,B-}

uses sysutils;

const taskid='polyline';
      eps=1e-9;
      sh=1e-2;

type tpoint=record x,y:extended; end;
     tline=record a,b,c:extended; end;

var nli,next,ans,n,i,j,k:longint;
    p:array [1..2003] of tpoint;
    l:array [1..2003] of tline;
    d:array [1..2003,1..2003] of longint;
    li:array [1..1000000] of tline;
    al:tline;
    t:extended;

function p2l(p1,p2:tpoint):tline;
 begin
 p2l.a:=p1.y-p2.y;
 p2l.b:=p2.x-p1.x;
 p2l.c:=-p2l.a*p1.x-p2l.b*p1.y;
 end;

function l2p(l1,l2:tline):tpoint;
 var d:extended;
 begin
 d:=l1.a*l2.b-l2.a*l1.b;
 l2p.x:=(l1.b*l2.c-l2.b*l1.c)/d;
 l2p.y:=(l1.c*l2.a-l2.c*l1.a)/d;
 end;

function lcalc(p:tpoint; l:tline):extended;
 begin
 lcalc:=l.a*p.x+l.b*p.y+l.c;
 end;

function lside(p:tpoint; l:tline):longint;
 var t:extended;
 begin
 t:=lcalc(p,l);
 if t<-eps then lside:=-1
 else if t>eps then lside:=1
 else lside:=0;
 end;

function crall(l:tline; s,f:longint):boolean;
 var res,i:longint;
 begin
 crall:=true;
 for i:=s to f-1 do
  if lside(p[i],l)*lside(p[i+1],l)<>-1 then
   begin
   crall:=false;
   exit;
   end;
 end;

//procedure swap

procedure calcfrom(s:longint);
 var l,r,i,j,k:longint;
     ok:boolean;
     p1,p2:tpoint; cl:tline;
 begin
 l:=s+1;
 r:=n+1;
 ok:=true;
 nli:=0;
 while r>l+1 do
  begin
  ok:=false;
  i:=(l+r) div 2;
  for j:=s to i-1 do
   begin
   for k:=j+1 to i do
    begin
    p1.x:=p[j].x+sh*(p[j+1].x-p[j].x);
    p1.y:=p[j].y+sh*(p[j+1].y-p[j].y);
    p2.x:=p[k].x-sh*(p[k].x-p[k-1].x);
    p2.y:=p[k].y-sh*(p[k].y-p[k-1].y);
    if crall(p2l(p1,p2),s,i) then
     begin
     ok:=true;
     cl:=p2l(p1,p2);
     break;
     end;
    if k<>i then
     begin
     p2.x:=p[k].x+sh*(p[k+1].x-p[k].x);
     p2.y:=p[k].y+sh*(p[k+1].y-p[k].y);
     if crall(p2l(p1,p2),s,i) then
      begin
      ok:=true;
      cl:=p2l(p1,p2);
      break;
      end;
     if j<>s then
      begin
      p1.x:=p[j].x-sh*(p[j].x-p[j-1].x);
      p1.y:=p[j].y-sh*(p[j].y-p[j-1].y);
      if crall(p2l(p1,p2),s,i) then
       begin
       ok:=true;
       cl:=p2l(p1,p2);
       break;
       end;
      end;
     end;
    if j<>s then
     begin
     p1.x:=p[j].x-sh*(p[j].x-p[j-1].x);
     p1.y:=p[j].y-sh*(p[j].y-p[j-1].y);
     p2.x:=p[k].x-sh*(p[k].x-p[k-1].x);
     p2.y:=p[k].y-sh*(p[k].y-p[k-1].y);
     if crall(p2l(p1,p2),s,i) then
      begin
      ok:=true;
      cl:=p2l(p1,p2);
      break;
      end;
     end;
    end;
   if ok then break;
   end;
  if ok then l:=i
  else r:=i;
  end;
 if l-s>ans then
  begin
  ans:=l-s;
  al:=cl;
  end;
 if l=n then
  begin
  next:=n;
  exit;
  end;
 i:=l;
 p2.x:=p[l+1].x-sh*(p[l+1].x-p[l].x);
 p2.y:=p[l+1].y-sh*(p[l+1].y-p[l].y);
 for j:=s to l-1 do
  begin
  p1.x:=p[j].x+sh*(p[j+1].x-p[j].x);
  p1.y:=p[j].y+sh*(p[j+1].y-p[j].y);
  k:=l-1;
  cl:=p2l(p1,p2);
  while lside(p[k],cl)*lside(p[k+1],cl)=-1 do dec(k);
  inc(k);
  if k<i then i:=k;
  if j<>s then
   begin
   p1.x:=p[j].x-sh*(p[j].x-p[j-1].x);
   p1.y:=p[j].y-sh*(p[j].y-p[j-1].y);
   k:=l-1;
   cl:=p2l(p1,p2);
   while lside(p[k],cl)*lside(p[k+1],cl)=-1 do dec(k);
   inc(k);
   if k<i then i:=k;
   end;
  end;
 next:=i;
 end;

begin
t:=timestamptomsecs(datetimetotimestamp(now));
assign(input,taskid+'.in');
assign(output,taskid+'.out');
reset(input);
rewrite(output);
readln(n);
for i:=1 to n do readln(p[i].x,p[i].y);
for i:=1 to n-1 do l[i]:=p2l(p[i],p[i+1]);
if n=2 then
 begin
 al.a:=l[1].b;
 al.b:=l[1].a;
 al.c:=-al.a*((p[1].x+p[2].x)/2)-al.b*((p[1].y+p[2].y)/2);
 end
else
 begin
 i:=1;
 ans:=1;
 next:=1;
 while (next<n) and (n-next>ans) do
  begin
  calcfrom(next);
  if timestamptomsecs(datetimetotimestamp(now))-t>1900 then break;
  end;
 end;
writeln(al.a:0:10);
writeln(al.b:0:10);
writeln(al.c:0:10);
//writeln(ans);
close(input);
close(output);
end.
