#include <stdio.h>
#include <string.h>

#define m 10100
#define mm 8

char s[m];
int n, l, r, d[m][mm][mm], z[m][mm][mm], y[m][mm][mm], w[m][mm][mm], u[m][mm][mm];
int qi[m * mm * mm], qa[m * mm * mm], qb[m * mm * mm], fi, la;

void addq( int i, int a, int b, int rr, int ww )
{
  y[i][a][b] = rr, w[i][a][b] = ww, u[i][a][b] = 1;
  qi[la] = i, qa[la] = a, qb[la++] = b;
}

int main( void )
{
  int i, a, b, c, j, t, ma, is[mm];

  freopen("strgame.in", "rt", stdin);
  freopen("strgame.out", "wt", stdout);
  scanf("%s%d%d", s, &l, &r);
  n = strlen(s);
  ma = 0;
  memset(is, 0, sizeof(is));
  for (i = 0; i < n; i++)
    is[s[i] - 'a'] = 1;
  for (i = 0; i < mm; i++)
    if (is[i])
      is[i] = ma++;
  for (i = 0; i < n; i++)
    s[i] = is[s[i] - 'a'] + 'a';
  memset(d, 0, sizeof(d));
  memset(z, 0, sizeof(z));
  for (i = 0; i < n; i++)
    for (a = 0; a < ma; a++)
      for (b = 0; b < ma; b++)
        for (j = i - l; j <= i + r; j++)
        {
          t = j;
          while (t < 0)
            t += n;
          while (t >= n)
            t -= n;
          if (s[t] != s[i] && s[t] != a + 'a' && s[t] != b + 'a')
            d[i][a][b]++, z[i][a][b] = 1;
        }
  memset(u, 0, sizeof(u));
  fi = la = 0;
  for (i = 0; i < n; i++)
    for (a = 0; a < ma; a++)
      for (b = 0; b < ma; b++)
        if (!z[i][a][b])
          addq(i, a, b, 0, 0);
  while (fi < la)
  {
    i = qi[fi], a = qa[fi], b = qb[fi++];
    if (i == 0 && a == s[0] - 'a' && b == s[0] - 'a')
      break;
    for (j = i - r; j <= i + l; j++)
    {
      t = (n + (j % n)) % n;
      if (a == s[t] - 'a' && s[i] != s[t] && s[i] != b)
        for (c = 0; c < ma; c++)
          if (s[i] != c + 'a')
          {
            d[t][b][c]--;
            if (y[i][a][b] == 0 && !u[t][b][c])
              addq(t, b, c, 1, w[i][a][b] + 1);
            else if (y[i][a][b] == 1 && d[t][b][c] == 0 && !u[t][b][c])
              addq(t, b, c, 0, w[i][a][b] + 1);
          }
    }
  }
  a = s[0] - 'a';
  if (!u[0][a][a])
    printf("DRAW");
  else if (y[0][a][a] == 0)
    printf("LOSE\n%d", w[0][a][a]);
  else
  {
    printf("WIN\n%d\n", w[0][a][a]);
    for (j = -l; j <= r; j++)
    {
      t = (n + (j % n)) % n;
      if (s[t] != s[0] && y[t][a][a] == 0 && w[t][a][a] == w[0][a][a] - 1)
        break;
    }
    printf("%d", j);
  }
  return 0;
}
