#include <stdio.h>
#include <stdlib.h>

#define SWAP(a, b, c) ((c) = (a), (a) = (b), (b) = (c))



int A[100000], AN, B[100000][2], BN;
int Out[100010][2], ON;

void QSort( int l, int r )
{
  int i, j, t, c;

  if (l >= r)
    return;
  c = B[l + (rand() % (r - l + 1))][0];
  i = l, j = r;
  while (i < j)
  {
    while (B[i][0] < c) i++;
    while (B[j][0] > c) j--;
    if (i <= j)
      SWAP(B[i][0], B[j][0], t),
      SWAP(B[i][1], B[j][1], t),
      i++, j--;
      
  }
  QSort(l,  j);
  QSort(i, r);

}
void SWP( int i, int j, int lasti, int lastj ) 
{
  int t;
  if (A[i] > A[j])
    Out[ON][0] = A[j], Out[ON++][1] = A[i];
  else
    Out[ON][0] = A[i], Out[ON++][1] = A[j];
  SWAP(A[i], A[j], t);
  SWAP(B[lasti][1], B[lastj][1], t);
  /*for (i = 0; i < AN; i++)
    for (j = 0; j < AN; j++)
      if (A[j] == B[i][0] && j != B[i][1])
      {
        printf("SWP BOTVA\n");
        exit(0);
        return 0;
      }*/

}

int Find( int f )
{
  int l, r, c;

  l = 0;
  r = AN - 1;
  while (l <= r)
  {
    c = (l + r) / 2;
    if (B[c][0] == f)
      return c;
    if (B[c][0] < f)
      l = c + 1;
    else
      r = c - 1;
  }

} 

int main( void )
{
  int i, j, k, T;

  freopen("sort.in", "rt", stdin);
  freopen("sort.out", "wt", stdout);

  scanf("%i%", &T);
  while (T-- > 0)
  {
    /*printf("Start %i\n", T);*/
    scanf("%i", &AN);	    
    for (i = 0; i < AN; i++)
      scanf("%i", A + i), B[i][0] = A[i], B[i][1] = i;
    BN = AN;
    QSort(0, BN - 1);
    ON = 0;
    for (i = 0; i < AN; i++)
      if (A[i] != B[i][0])
      {
        j = B[i][1];
        while (A[i] > B[j][0])
        {
          k = B[j][1];
          SWP(j, k, i, j), j = k;

        }
        
        SWP(j, i, i, Find(A[i]));
      }
   printf("%i\n", ON);
   for (i = 0; i < ON; i++)
     printf("%i %i\n", Out[i][0], Out[i][1]);
   /*for (i = 1; i < AN; i++)
     if (A[i - 1] > A[i])
     {
       printf("SORT BOTVA\n");
       return 0;
     }*/
  }
  return 0;
}

