Program prg;

type
  integer=longint;

var
  t: integer;
  n: integer;
  i, k: integer;
  arr, arr2: array[0..100010] of integer;
  a: integer;
  ans: array[0..200010] of integer;
  res: integer;
  ind: array[0..100010] of integer;

procedure swap(var a, b: integer);
  var
    t: integer;

  begin
    t:=a;
    a:=b;
    b:=t;
//    t:=ind[a];
//    ind[a]:=ind[b];
//    ind[b]:=t;
  end;

procedure qsort(l, r: integer);
  var
    lh, rh: integer;

  begin
    lh:=l;
    rh:=r;
    while (lh<rh) do begin
      while (lh<rh) and (arr2[lh]<=arr2[rh]) do inc(lh);
      swap(arr2[lh], arr2[rh]);
      while (lh<rh) and (arr2[lh]<=arr2[rh]) do dec(rh);
      swap(arr2[lh], arr2[rh]);
    end;
    if (lh-l)>1 then qsort(l, lh-1);
    if (r-rh)>1 then qsort(rh+1, r);
  end;


begin
  assign(input, 'sort.in');
  assign(output, 'sort.out');
  reset(input);
  rewrite(output);

  readln(t);

  for k:=1 to t do begin
    readln(n);
    for i:=1 to n do begin
      read(arr[i]);
    end;
    arr2:=arr;
    for i:=1 to n do begin
      ind[arr[i]]:=i;
    end;

    qsort(1, n);
    res:=0;

    for i:=1 to n-2 do begin
      if i=ind[arr2[i]] then continue;

      while (arr2[ind[arr2[i]]]<arr[i]) do begin
        inc(res);
        ans[2*res-1]:=arr2[i];
        ans[2*res]:=arr2[ind[arr2[i]]];
        swap(arr[ind[arr2[i]]], arr[ind[arr2[ind[arr2[i]]]]]);
        swap(ind[arr2[i]], ind[arr2[ind[arr2[i]]]]);
        inc(res);
        ans[2*res-1]:=arr2[i];
        ans[2*res]:=arr[i];
        a:=ind[arr2[i]];
        swap(ind[arr[i]], ind[arr2[i]]);
        swap(arr[i], arr[a]);
      end; 
      if i<>ind[arr2[i]] then begin
        inc(res);
        ans[res*2-1]:=arr2[i];
        ans[2*res]:=arr[i];
        a:=ind[arr2[i]];
        swap(ind[arr[i]], ind[arr2[i]]);
        swap(arr[i], arr[a]);
      end;
    end;

    writeln(res);
    for i:=1 to res do 
      writeln(ans[2*i-1], ' ', ans[2*i]);

  end;


  close(input);
  close(output);
end.