type integer=longint;
const maxn=100000;
      inf=10000000;

var q,qq:array[1..maxn] of record
                             x:integer;
                             id:integer;
                          end;
    w:array[1..maxn] of record
                            i:integer;
                            x:integer;
                          end;
    mark:Array[1..maxn] of boolean;
    sw:array[1..maxn] of record
                             a,b:integer;
                           end;
    sp:array[1..maxn] of integer;
    c:integer;
    pos:array[0..maxn] of integer;
    rmq:array[1..maxn*2-1] of record
                              x,i:integer;
                            end;
    u,n:integer;
procedure update(i,x,z:integer);
begin
  i:=i+n-1;
  rmq[i].x:=x;
  rmq[i].i:=z;
  i:=i shr 1;
  while i>0 do begin
    if rmq[i*2].x>rmq[i*2+1].x then
    rmq[i]:=rmq[i*2+1]
    else rmq[i]:=rmq[i*2];
    i:=i shr 1;
  end;
end;
procedure swap(var a,b:integer);
var c:integer;
begin
  c:=a;
  a:=b;
  b:=c;
end;
procedure qsort(l,r:integer);
var i,j,x:integer;
begin
  i:=l;
  j:=r;
  x:=q[random(j-i+1)+i].x;
  while i<=j do begin
    while (q[i].x<x) do inc(i);
    while (q[j].x>x) do dec(j);
    if i<=j then begin
      swap(q[i].x,q[j].x);
      swap(q[i].id,q[j].id);
      inc(i);
      dec(j);
    end;
  end;
  if i<r then qsort(i,r);
  if l<j then qsort(l,j);
end;
procedure sort(l,r:integer);
var i,j,a,b,x:integer;
begin
  i:=l;
  j:=r;
  x:=random(j-i+1)+i;
  a:=sw[x].a;
  b:=sw[x].b;
  while i<=j do begin
    while (sw[i].a<a) or ((sw[i].a=a) and (sw[i].b<b)) do inc(i);
    while (sw[j].a>a) or ((sw[j].a=a) and (sw[j].b>b)) do dec(j);
    if i<=j then begin
      swap(sw[i].a,sw[j].a);
      swap(sw[i].b,sw[j].b);
      inc(i);
      dec(j);
    end;
  end;
  if i<r then sort(i,r);
  if l<j then sort(l,j);


end;

procedure solve();
var    i,j,kk,k:integer;
begin
  readln(n);
  c:=0;
  u:=0;
  fillchar(mark,sizeof(mark),0);
  fillchar(pos,sizeof(pos),0);
  for i:=1 to n do begin
    read(q[i].x);
    q[i].id:=i;
  end;
  qq:=q;
  qsort(1,n);
  for i:=1 to n do begin
    w[q[i].id].i:=i;
    w[q[i].id].x:=q[i].x;
  end;
  for i:=1 to n do begin
    if not mark[i] then begin
      k:=i;
      j:=w[i].i;
      mark[k]:=true;
      if not mark[j] then begin
        inc(c);

        pos[c]:=pos[c-1];
        inc(pos[c]);
        sp[pos[c]]:=k;
        inc(pos[c]);
        sp[pos[c]]:=j;
        mark[j]:=true;
        k:=w[k].i;
        j:=w[k].i;
        while not mark[j] do begin
          mark[j]:=true;
          inc(pos[c]);
          sp[pos[c]]:=j;
          k:=w[k].i;
          j:=w[k].i;
        end;
      end;
    end;
 end;
 for j:=1 to n do
  update(j,inf,0);
 for i:=1 to c do
 begin
   for j:=pos[i-1]+1 to pos[i] do
   update(sp[j],w[sp[j]].i,sp[j]);
   for j:=pos[i-1]+1 to pos[i] do begin
     if rmq[1].i=rmq[1].x then begin
       update(rmq[1].i,inf,rmq[1].i);
     end
     else begin
       kk:=rmq[1].i;
       k:=q[rmq[1].i].id;
       inc(u);
       sw[u].a:=q[rmq[1].x].x;
       sw[u].b:=qq[k].x;
       update(k,rmq[1].
       x,k);
       update(kk,inf,kk);
     end;
   end;
 end;
 sort(1,u);
 writeln(u);
 for i:=1 to u do
 writeln(sw[i].a,' ',sw[i].b);
end;
var i,t:integer;
begin
  assign(input,'sort.in');
  assign(output,'sort.out');
  rewrite(output);
  reset(input);
  readln(t);
  for i:=1 to t do begin
    solve();
  end;
  close(input);
  close(output);
end.