program apas;

const maxn = 100001;
      inf  = 1500000;

type integer = longint;
     tcyc = record
        x, l : integer;
     end;

var a, srt, d : array [1..maxn] of integer;
    hs, n, i, j, nc, nt, t, sh, minp, tv1, tv2 : integer;
    c : array [1..maxn] of tcyc;
    u : array [1..maxn] of boolean;
    h : array [0..maxn] of tcyc;
    p : array [1..3*maxn] of integer;
    curc, c1 : tcyc;

function less(c1, c2 : tcyc) : boolean;
begin
   less := d[c1.x] < d[c2.x];
end;

procedure Sort(l, r : integer);
var i, j, x, y : integer;
begin
   i := l; j := r; x := a[srt[l+random(r-l+1)]];
   repeat
      while a[srt[i]] < x do inc(i);
      while a[srt[j]] > x do dec(j);
      if i <= j then begin
         y := srt[i]; srt[i] := srt[j]; srt[j] := y;
         inc(i); dec(j);
      end;
   until i > j;
   if i < r then Sort(i, r);
   if j > l then Sort(l, j);
end;

procedure push(c : tcyc);
var i : integer;
begin
//   writeln('push( ', d[c.x], ' )');
   inc(hs); i := hs;
   h[i] := c;
   while (i > 1) and less(h[i], h[i div 2]) do begin
      h[0] := h[i]; h[i] := h[i div 2]; h[i div 2] := h[0];
      i := i div 2;
   end;
end;

function pop : tcyc;
var i, pr : integer;
begin
   pop := h[1];
//   writeln('pop -> ( ', d[h[1].x], ' )'); 
   h[1] := h[hs];
   dec(hs);
   i := 1; pr := 0;
   while (i <> pr) do begin
      pr := i;
      if 2*i <= hs then
         if less(h[2*i], h[pr]) then pr := 2*i;
      if 2*i < hs then
         if less(h[2*i+1], h[pr]) then pr := 2*i+1;
      if i <> pr then begin
         h[0] := h[i]; h[i] := h[pr]; h[pr] := h[0];
         i := pr; pr := 0;
      end;
   end;
end;

procedure setv(x, y : integer);
begin
   d[x] := y;
   x := x+sh;
   while (x > 1) do begin
      x := x div 2;
      if d[p[2*i]] < d[p[2*i+1]] then p[i] := p[2*i] else p[i] := p[2*i+1];
   end;
end;

function getv(l, r : integer) : integer;
var minl, minr : integer;
begin
   l := l+sh; minl := p[l];
   r := r+sh; minr := p[r];
   while l < r-1 do begin
      if l mod 2 = 0 then
         if d[p[l+1]] < d[minl] then minl := p[l+1];
      if r mod 2 = 1 then
         if d[p[r-1]] < d[minr] then minr := p[r-1];
      l := l div 2; r := r div 2;
   end;
   if d[minl] < d[minr] then getv := minl else getv := minr;
end;

begin
   randseed := 3751;
   assign(Input, 'sort.in');
   reset(Input);
   assign(Output, 'sort.out');
   rewrite(Output);
   read(nt);
   while (nt > 0) do begin
      read(n);
      for i := 1 to n do begin
         read(a[i]);
         srt[i] := i;
      end;
      Sort(1, n);
      for i := 1 to n do
         u[i] := false;
      t := 0; nc := 0;

      sh := 1;
      while sh < n-1 do sh := 2*sh+1;
      d[n+1] := inf;
      for i := sh+n+1 to 2*sh+1 do p[i] := n+1;

      for i := 1 to n do
         if not u[i] then begin
            inc(nc); c[nc].x := t+1; c[nc].l := 0;
            j := i;
            while not u[j] do begin
               u[j] := true;
               inc(t); d[t] := j;
               inc(c[nc].l);
               p[sh+t] := t;
               j := srt[j];
            end;
         end;
      for i := sh downto 1 do
         if d[p[2*i]] < d[p[2*i+1]] then
            p[i] := p[2*i]
         else
            p[i] := p[2*i+1];
      writeln(n-nc);
      hs := 0;
      for i := 1 to nc do
         if c[i].l > 1 then push(c[i]);
      while (hs > 0) do begin
         curc := pop;
         minp := getv(curc.x+1, curc.x+curc.l-1);
         writeln(a[srt[d[curc.x]]], ' ', a[srt[d[minp]]]);
         tv1 := d[minp]; tv2 := d[curc.x];
         setv(minp, -1);
         setv(curc.x, tv1);
         setv(minp, tv2);
         c1.x := minp;
         c1.l := curc.l-minp+curc.x;
         curc.l := curc.l-c1.l;
         if curc.l > 1 then push(curc);
         if c1.l > 1 then push(c1);
//         for i := 1 to hs do write(d[h[i].x], ' '); writeln;
      end;
      dec(nt);
   end;
   close(Input);
   close(Output);
end.