{$I-,Q-,R-,S-}
const
  EPS=1e-4;
  BIGEPS=1e-2;
  INF=1e30;
type
	integer=longint;
  real=single;
var
	k:array[1..100000] of integer;
  x:array[1..100000] of real;
  merge:array[1..100000] of real;
  n:integer;

procedure qsort(l,r:integer);
var
  i,j:integer;
  key:real;
	buf:integer;
  bufx:real;
begin
  i:=l;
  j:=r;
  key:=x[(l+r) DIV 2];
  repeat
    while x[i]<key do inc(i);
    while key < x[j] do dec(j);
    if i<=j then
    begin
      buf:=k[i];
      k[i]:=k[j];
      k[j]:=buf;
      bufx:=x[i];
      x[i]:=x[j];
      x[j]:=bufx;
      inc(i);
      dec(j);
    end;
  until i>j;
  if l<j then qsort(l,j);
  if i<r then qsort(i,r);
end;



procedure update(pos:integer);
begin
 if pos<>1 then begin
    merge[pos-1]:=(x[pos]-x[pos-1])/((100/k[pos])-(100/k[pos-1]));
    if merge[pos-1]+EPS<0 then
      merge[pos-1]:=INF;
  end;
  merge[pos]:=(x[pos+1]-x[pos])/((100/k[pos+1])-(100/k[pos]));
  if merge[pos]+EPS<0 then
    merge[pos]:=INF;
end;


procedure killgroup(pos:integer);
var
	i:integer;
begin
	k[pos]:=k[pos]+k[pos+1];
	for i:=pos+1 to n-1 do begin
  	k[i]:=k[i+1];
    x[i]:=x[i+1];
    merge[i]:=merge[i+1];
  end;
  dec(n);
//  update(pos);
end;




var
	i:integer;
  vv,dt,maxmerge:real;
  canmerge:integer;
begin
	randseed:=31337;
	assign(input,'longpath.in');
  reset(input);
  assign(output,'longpath.out');
  rewrite(output);
  readln(n);
  for i:=1 to n do begin
  	readln(k[i],x[i]);
  end;
  qsort(1,n);
 	canmerge:=-1;
  maxmerge:=INF/10;
 	for i:=1 to n-1 do begin
 	 	vv:=((100/k[i])-(100/k[i+1]));
    if vv>EPS then
    	merge[i]:=(x[i+1]-x[i])/vv
    else
    	merge[i]:=INF;

    if merge[i]+BIGEPS<0 then
    	merge[i]:=INF;

    if merge[i]<maxmerge then begin
			maxmerge:=merge[i];
      canmerge:=i;
    end;
  end;

  while canmerge<>-1 do begin
  	dt:=maxmerge;
    killgroup(canmerge);
    canmerge:=-1;
	  maxmerge:=INF;
    for i:=1 to n do begin
    	x[i]:=x[i]+(100/k[i])*dt;
      if i<>n then begin
      	vv:=((100/k[i])-(100/k[i+1]));
        if vv>EPS then
        	merge[i]:=(x[i+1]-x[i])/vv
        else
        	merge[i]:=INF;

        if merge[i]+BIGEPS<0 then
        	merge[i]:=INF;

        if merge[i]<maxmerge then begin
    			maxmerge:=merge[i];
          canmerge:=i;
        end;

    	end;
    end;
  end;

	writeln(n);
  for i:=1 to n do begin
  	write(k[i]);
    if i<>n then write(' ');
  end;

  close(input);

  close(output);
end.
