{$I-,Q-,R-,S-}
//{$I+,Q+,R+,S+}
{$M 5000000}
program Temp;

const
 in_f='sort.in';
 out_f='sort.out';
type
  int=longint;
  real=extended;
  bool=boolean;
  TElem=record
      x,num:int;
    end;
const
  maxN=100000;
var
  N:int;
  a:array[1..maxN] of TElem;
  V:array[1..maxN] of bool;
  ish,place,link:array[1..maxN] of int;

procedure Sort(l, r: Int);
var
  i, j: int;
  x,y:TElem;
begin
  i := l; j := r; x := a[(l+r) DIV 2];
  repeat
    while a[i].x< x.x do i := i + 1;
    while x.x < a[j].x do j := j - 1;
    if i <= j then
    begin
      y := a[i]; a[i] := a[j]; a[j] := y;
      i := i + 1; j := j - 1;
    end;
  until i > j;
  if l < j then Sort(l, j);
  if i < r then Sort(i, r);
end;

procedure TechSwap(var a,b:int);
var c:int;
begin
  c:=a;a:=b;b:=c;
end;

procedure Swap(ia,ib:int);
 begin
   Writeln(ish[ia],' ',ish[ib]);
   TechSwap(ish[ia],ish[ib]);
   TechSwap(place[ia],place[ib]);
   TechSwap(a[place[ia]].num,a[place[ib]].num);
   link[ia]:=ia;
   link[ib]:=ib;
 end;


procedure Dfs(u:int);
begin
  v[u]:=true;
  if not v[place[u]] then
    dfs(place[u]);
end;

procedure Solve;
 var
  i,cur:int;
  ans:int;

procedure DoLink(u:int);
 begin
   if u=cur then
     link[u]:=u
   else
     begin
       DoLink(place[u]);
       link[u]:=place[u];
       while ish[link[u]] > ish[u] do
         link[u]:=link[link[u]];
     end;
 end;

procedure DoSwap(u:int);
 begin
   if u<>cur then
     begin
       DoSwap(link[u]);
       Swap(cur, u);
     end;
   cur:=u;
 end;

 begin
   Sort(1,N);
   for i := 1 to N do
     place[a[i].num]:=i;
   for i := 1 to n Do
     v[i]:=false;
   ans:=N;
   for i := 1 to n Do
     if not v[i] then
       begin
         dfs(i);
         dec(ans);
       end;
   Writeln(ans);

   for i := 1 to N do
     link[i]:=0;

   for i := 1 to N do
     begin
       cur:=a[i].num;
       if link[cur]=0 then
         DoLink(place[cur]);
       DoSwap(place[cur]);
     end;
 end;

procedure Run;
 var
   M,i,j:int;
 begin
   Read(M);
   for j:= 1 to M do
     begin
       Read(N);
       for i := 1 to N do
         begin
           Read(ish[i]);
           a[i].x:=ish[i];
           a[i].num:=i;
         end;
       Solve;
     end;
 end;

procedure OpenFiles;
 begin
  Assign(input,in_f);
  Reset(input);
  Assign(output,out_f);
  Rewrite(output);
 end;

procedure CloseFiles;
 begin
  Close(input);
  Close(output);
 end;

Begin
OpenFiles;
Run;
CloseFiles;
End.
