#include <stdio.h>
#include <string.h>

#define MAX 103
#define MAXV 210
#define MAXE 41010

int Sum = 0, N, K, A[MAX][MAX];
int E = 0, St, En, He[MAXV], Ne[MAXE], Y[MAXE], F[MAXE], C[MAXE];
int U[MAXV], PN, P[MAXV];

void AddE( int a, int b, int c )
{
  Ne[E] = He[a], Y[E] = b, F[E] = 0, C[E] = c, He[a] = E++;
  Ne[E] = He[b], Y[E] = a, F[E] = 0, C[E] = 0, He[b] = E++;
}

int dfs( int v )
{
  int e;

  U[v] = 1;
  for (e = He[v]; e != -1; e = Ne[e])
    if (F[e] < C[e] && (Y[e] == En || (!U[Y[e]] && dfs(Y[e]))))
    {
      F[e]++, F[e ^ 1]--;
      return 1;
    }
  return 0;
}

int dfs2( int v )
{
  int e;

  U[v] = 1;
  for (e = He[v]; e != -1; e = Ne[e])
    if (F[e] > 0 && (Y[e] == En || (!U[Y[e]] && dfs2(Y[e]))))
    {
      P[PN++] = v;
      F[e]--, F[e ^ 1]++;
      return 1;
    }
  return 0;
}

int main( void )
{
  int i, j;

  freopen("coins.in", "rt", stdin);
  freopen("coins.out", "wt", stdout);
  scanf("%d%d", &N, &K);
  for (i = 1; i <= N; i++)
    for (j = 1; j <= K; j++)
      scanf("%d", &A[i][j]);
  St = 0, En = N + K + 1;
  memset(He, -1, sizeof(He));
  for (i = 1; i <= K; i++)
    AddE(St, i, A[1][i]);
  for (i = 1; i <= K; i++)
    AddE(i, En, 1);
  for (i = 2; i <= N; i++)
    for (j = 1; j <= K; j++)
      if (!A[i][j])
        AddE(j, K + i, 1);
      else
        AddE(K + i, j, A[i][j] - 1);
  memset(U, 0, sizeof(U));
  while (dfs(St))
    memset(U, 0, sizeof(U)), Sum++;
  printf("%d\n", Sum);
  memset(U, 0, sizeof(U)), PN = 0;
  while (dfs2(St))
  {
    for (i = PN - 2; i > 0; i -= 2)
      printf("%d %d %d\n", P[i - 1] - K, P[i - 2], P[i]);
    memset(U, 0, sizeof(U)), PN = 0;
  }
  return 0;
}
