program bpas;

type integer = longint;

var c, f : array [1..201, 1..201] of integer;
    u    : array [1..201] of boolean;
    a    : array [1..100, 1..3] of integer;
    sum, x, n, m, i, j, la : integer;

function dfs(v : integer) : boolean;
var i : integer;
begin
   u[v] := true;
   if v = n+m+1 then begin
      dfs := true;
      inc(sum);
      exit;
   end;
   for i := 1 to m+n+1 do
      if (not u[i]) and (c[v][i]-f[v][i] > 0) then
         if dfs(i) then begin
            inc(f[v][i]);
            dec(f[i][v]);
            dfs := true;
            exit;
         end;
   dfs := false;
end; 

function print(v, pr : integer) : boolean;
var i : integer;
begin
   u[v] := true;
   if v = n+m+1 then begin
      print := true;
      dec(sum);
      exit;
   end;
   for i := 1 to n+m+1 do
      if (not u[i]) and (f[v][i] > 0) then
         if print(i, v) then begin
            dec(f[v][i]);
            print := true;
            if (v > 1) and (v <= n) then begin
               inc(la); a[la][1] := v; a[la][2] := i-n; a[la][3] := pr-n;
            end;
            exit;
         end;
   print := false;
end;

begin
   assign(Input, 'coins.in');
   reset(Input);
   assign(Output, 'coins.out');
   rewrite(Output);
   fillchar(c, sizeof(c), 0);
   read(n, m);
   for i := 1 to m do begin
      read(c[1][n+i]);
      c[n+i][n+m+1] := 1;
   end;
   for i := 2 to n do
      for j := 1 to m do begin
         read(x);
         if x = 0 then
            c[n+j][i] := 1
         else
            c[i][n+j] := x-1;
      end;
   fillchar(f, sizeof(f), 0);
   fillchar(u, sizeof(u), 0);
   while dfs(1) do
      fillchar(u, sizeof(u), 0);
   writeln(sum);
   while (sum > 0) do begin
      la := 0;
      fillchar(u, sizeof(u), 0);
      print(1, 0);
      for i := la downto 1 do writeln(a[i][1], ' ', a[i][2], ' ', a[i][3]);
   end;
   close(Input);
   close(Output);
end.