const
        MaxN = 100;
var
        sm, f : Array[-MaxN .. MaxN, -MaxN .. MaxN] of Integer;
        vas : Array[1 .. MaxN] of LongInt;
        n, m, flow : LongInt;
        used : Array[-MaxN .. MaxN] of Boolean;

Procedure Init;
var
        i, j, k : LongInt;
begin
  ReadLn(n, m);
  flow := 0;
  for i := 1 to m do
    Read(vas[i]);
  Dec(n);
  for i := 1 to n do
    for j := 1 to m do
    begin
      Read(k);
      if k > 1 then
        sm[-i][j] := 1;
      if k = 0 then
        sm[j][-i] := 1;
    end;
  for i := 1 to m do
    sm[i][0] := 1;
end;

Function DFS(const a : Integer) : Boolean;
var
        b : Integer;
begin
  if a = 0 then
  begin
    Inc(flow);
    DFS := True;
    Exit;
  end;
  DFS := False;
  if used[a] then
    Exit;
  used[a] := True;
  for b := -n to m do
    if sm[a][b] > f[a][b] then
      if DFS(b) then
      begin
        DFS := True;
        Inc(f[a][b]);
        Dec(f[b][a]);
        Exit;
      end;
end;

Function DFS2(const u : Integer) : Boolean;
var
        v, t : Integer;
begin
  if u = 0 then
    Exit;
  DFS2 := False;
  if used[u] then
    Exit;
  used[u] := True;
  for v := -n to -1 do
    if f[u][v] > 0 then
      for t := 1 to m do
        if f[v][t] > 0 then
        begin
          WriteLn(-v + 1, ' ', t, ' ', u);
          Dec(f[v][t]);
          Inc(f[t][v]);
          Dec(f[u][v]);
          Inc(f[v][u]);
          DFS2(t);
          DFS2 := True;
          Exit;
        end;
end;

Procedure Solve;
var
        i, j : LongInt;
begin
  for i := 1 to n do
    for j := 1 to vas[i] do
    begin
      FillChar(used, SizeOf(used), False);
      if not DFS(i) then
        Break;
    end;
  WriteLn(flow);
  for i := 1 to n do
    for j := 1 to vas[i] do
    begin
      FillChar(used, SizeOf(used), False);
      if not DFS2(i) then
        Break;
    end;
end;

Procedure Print;
begin
end;

Procedure GenTest;
begin
  Assign(output, 'coins.in');
  Rewrite(output);
  Close(output);
end;

begin
  Assign(input, 'coins.in');
  Reset(input);
  Assign(output, 'coins.out');
  Rewrite(output);
  Init;
  Solve;
  Print;
  Close(input);
  Close(output);
end.
