type integer=longint;
const inf=1e100;
const maxn=100000;
var q:Array[1..maxn] of record
                          m:integer;
                          x:extended;
                          t:extended;
                        end;
    rmq:array[1..maxn*2-1] of record
                                i:integer;
                                x:extended;
                              end;
    pr,nx,ans:array[1..maxn]  of integer;
    del:Array[1..maxn] of boolean;
    res,i,j,n:integer;
var time:extended;

procedure update(i:integer;x:extended);
begin
  rmq[i+n-1].i:=i;
  i:=i+n-1;
  rmq[i].x:=x;
  i:=i shr 1;
  while i>0 do begin
   if rmq[i*2].x>rmq[i*2+1].x then
   rmq[i]:=rmq[i*2+1]
   else rmq[i]:=rmq[i*2];
   i:=i shr 1;
 end;
end;

procedure swape(var a,b:extended);
var c:extended;
begin
  c:=a;
  a:=b;
  b:=c;
end;

procedure swap(var a,b:integer);
var c:integer;
begin
  c:=a;
  a:=b;
  b:=c;
end;

procedure recalc(x:integer);
begin
  q[x].x:=q[x].x+(time-q[x].t)*(100.0/q[i].m);
  q[i].t:=time;
end;
function gettime(i,j:integer):extended;
begin
  if j>n then begin
    gettime:=inf;
    exit;
  end;
  if i<1 then begin
    gettime:=inf;
    exit;
  end;
  recalc(i);
  recalc(j);
  if (q[i].m<q[j].m) then gettime:=time+(q[j].x-q[i].x)/(100.0/q[i].m-100.0/q[j].m)
  else gettime:=inf;
end;
procedure qsort(l,r:integer);
var i,j:integer;
    x:extended;
begin
  i:=l;
  j:=r;
  x:=q[random(j-i+1)+i].x;
  while i<=j do begin
    while q[i].x<x do inc(i);
    while q[j].x>x do dec(j);
    if i<=j then begin
      swape(q[i].x,q[j].x);
      swap(q[i].m,q[j].m);
      inc(i);
      dec(j);
    end;
   end;
   if i<r then qsort(i,r);
   if l<j then qsort(l,j);
end;

procedure union(x,y:integer);
begin
  time:=time+rmq[1].x;
  del[y]:=true;
  update(y,inf);
  recalc(x);
  q[x].m:=q[x].m+q[y].m;
  nx[x]:=nx[y];
  if nx[x]<=n then begin
  pr[nx[x]]:=x;
  end;
  update(x,gettime(x,nx[x]));
  if pr[x]<>0 then
  update(pr[x],gettime(pr[x],x));
end;

begin
  assign(input,'longpath.in');
  assign(output,'longpath.out');
  rewrite(output);
  reset(input);
  readln(n);
  for i:=1 to n do begin
    read(q[i].m,q[i].x);
    q[i].t:=0;
    pr[i]:=i-1;
    nx[i]:=i+1;
  end;
  qsort(1,n);
  time:=0;
  for i:=1 to n do
  update(i,gettime(i,i+1));
  while rmq[1].x<>inf do
  union(rmq[1].i,nx[rmq[1].i]);
  for i:=1 to n do
  if not del[i] then begin
    inc(res);
    ans[res]:=i;
  end;
  writeln(res);
  for i:=1 to res do
  write(q[ans[i]].m,' ');
  close(input);
  close(output);
end.
