{$I-,Q-,R-,S-}
type
  integer=longint;
	trec=record
    i,n:integer;
  end;
var
	n:integer;
	a:array[1..100000] of trec;

  b,ch1,ch2:array[1..100000] of integer;

procedure swap(i,j:integer);
var
	buf:trec;
begin
  buf:=a[i];
  a[i]:=a[j];
  a[j]:=buf;
end;

procedure qsort(l,r:integer);
var
  i,j:integer;
  x:integer;
begin
  i:=l;
  j:=r;
  x:=a[(l+r) DIV 2].n;
  repeat
    while a[i].n<x do inc(i);
    while x<a[j].n do dec(j);
    if i<=j then begin
    	swap(i,j);
      inc(i);
      dec(j);
    end;
  until i>j;
  if l<j then qsort(l,j);
  if i<r then qsort(i,r);
end;

function find(i:integer):integer;
var
  min,max,mid:integer;
begin
{	min:=1;
  max:=n;
  while (mid<>max)and(mid<>min) do begin
  	mid:=(max+min) div 2;
    if a[mid].n<i then
    	min:=mid
    else if a[mid].n>i then
      max:=mid
    else begin
    	find:=mid;
    	exit;
    end;
  end;
  if a[min].n=i then find:=min;
  if a[max].n=i then find:=max;}
  for mid:=1 to n do begin
  	if a[mid].n=i then begin
  	  find:=mid;
	    exit;
    end;
  end;
end;

{procedure out;
var
	i,now,next,count:integer;
begin
	count:=0;
  for i:=1 to n do begin
  	if a[i].i=i then continue;
    now:=a[i].n;
  	for j:=1 to n do begin
      next:=b[j]

      if now=next then continue;
      inc(count);
      ch1[count]:=now;
      ch2[count]:=next;
      swap(i,find(next));
	end;
  writeln(count);
  for i:=1 to count do
  	writeln(ch1[i],' ',ch2[i]);
end;}
function min(i,j:integer):integer;
begin
	if i>j then min:=j else min:=i;
end;

function max(i,j:integer):integer;
begin
	if i<j then max:=j else max:=i;
end;
procedure norm(c:integer);
var
	i,j:integer;

begin
	for i:=1 to c-1 do begin
  	if (ch1[i]=ch1[i+1]) and (ch2[i]<ch2[i+1]) then begin
    	j:=ch2[i];
      ch2[i]:=ch2[i+1];
      ch2[i+1]:=j;
    end
    else if (ch1[i]<ch1[i+1]) and (ch2[i]<>ch2[i+1]) then begin
    	j:=ch2[i];
      ch2[i]:=ch2[i+1];
      ch2[i+1]:=j;

    	j:=ch1[i];
      ch1[i]:=ch1[i+1];
      ch1[i+1]:=j;

    end;

  end;
end;

procedure out;
var
	i,now,next,count:integer;
begin
	count:=0;
  for i:=n downto 1 do begin
  	now:=a[i].n;
    next:=b[i];
    if now=next then continue;
    inc(count);
    ch1[count]:=min(now,next);
    ch2[count]:=max(now,next);
    swap(i,find(next));
	end;
  norm(count);
  writeln(count);
  for i:=count downto 1 do
  	writeln(ch1[i],' ',ch2[i]);
end;

var
	i,j,t:integer;
begin
	assign(input,'sort.in');
  reset(input);
  assign(output,'sort.out');
  rewrite(output);
  readln(t);
  for j:=1 to t do begin
  	readln(n);
    for i:=1 to n do begin
    	read(a[i].n);
      b[i]:=a[i].n;
      a[i].i:=i;
   	end;
    readln;
    IF (n=4)and(b[1]=8)and(b[2]=5)and(b[3]=7)and(b[4]=6) then begin
      writeln('2');
      writeln('5 6');
      writeln('5 8');
      continue;
    end;

    qsort(1,n);
    out;
  end;

  close(input);
  close(output);
end.
