{$o+,Q-,R-}
uses Sysutils;
const
 MT=1000000000000000000;
 eps=0.01;
var
 D   :array[0..100000] of longint;
 X   :array[0..100000] of extended;
 T   :array[0..100000] of extended;
 TP  :array[0..100000] of extended;
 H   :array[0..300000] of longint; //Heap
 U   :array[0..100000] of boolean;
 Next:array[0..100000] of longint;
 Prev:array[0..100000] of longint;
 Ind :array[0..100000] of longint;
 d1,d2:int64;
 ff:longint;
 dist:extended;
 tx,time:extended;
 i,j,l,n:longint;
procedure SiftUp(index:longint);
 var
  tmp,i:longint;
 begin
  i:=index;
  while (i>1)and(T[H[i]]<T[H[i div 2]]) do begin
   ind[H[i]]:=i div 2;
   ind[H[i div 2]]:=i;
   tmp:=H[i];
   H[i]:=H[i div 2];
   H[i div 2]:=tmp;
   i:=i div 2;
  end;
 end;
procedure SiftDown(index:longint);
 var
  i,j,tmp:longint;
 begin
  i:=index;
  while ((2*i)<=l) do begin
   j:=i;
   if T[H[j]]>T[H[2*i]] then
    j:=2*i;
   if ((2*i+1)<=l)and(T[H[j]]>T[H[2*i+1]]) then
    j:=2*i+1;
   if i=j then break;
   ind[H[i]]:=j;
   ind[H[j]]:=i;
   tmp:=H[i];
   H[i]:=H[j];
   H[j]:=tmp;
   i:=j;
  end;
 end;
procedure Push(i:longint);
 begin
  inc(l);
  H[l]:=i;
  Ind[i]:=l;
  SiftUp(l);
 end;
function POP:longint;
 begin
  pop:=H[1];
  H[1]:=H[l];
  ind[H[1]]:=1;
  dec(l);
  SiftDown(1);
 end;
procedure Del(index:longint);
 begin
  H[index]:=H[l];
  ind[H[l]]:=index;
  dec(l);
  SiftDown(index);
  SiftUP(index);
 end;

procedure Qsort(l,r:longint);
 var
  i,j,tt:longint;
  m,t:extended;
 begin
  i:=l;
  j:=r;
  tt:=l+random(r-l+1);
  m:=X[tt];
  while i<=j do begin
   while X[i]<m do inc(i);
   while X[j]>m do dec(j);
   if i<=j then begin
    t:=X[i];
    X[i]:=X[j];
    X[j]:=t;
    tt:=D[i];
    D[i]:=D[j];
    D[j]:=tt;
    inc(i);
    dec(j);
   end;
  end;
  if l<j then Qsort(l,j);
  if r>i then Qsort(i,r);
 end;
begin
 fillchar(ind,sizeof(ind),0);
 fillchar(next,sizeof(next),0);
 fillchar(prev,sizeof(prev),0);
 randomize;
 assign(input,'longpath.in');
 reset(input);
 assign(output,'longpath.out');
 rewrite(output);
 read(n);
 for i:=1 to n do begin
  TP[i]:=0;
  T[i]:=0;
  prev[i]:=i-1;
  Next[i]:=i+1;
  U[i]:=true;
  read(D[i],X[i]);
 end;
 Next[n]:=0;
 l:=0;
 time:=0;
 Qsort(1,n);
 for i:=1 to n-1 do begin
  d1:=D[i];
  d2:=D[i+1];
  if d2<=d1 then begin
   T[i]:=MT;
   ind[i]:=0;
   continue;
  end;
  Dist:=X[i+1]-X[i];
  T[i]:=(Dist*d1*d2)/(d2-d1);
  Push(i);
 end;
 ff:=0;
 while (l>0) do begin
  i:=POP;
  U[next[i]]:=false;
  time:=T[i];
  X[i]:=X[i]+(time-TP[i])/D[i];
  TP[i]:=time;
  if ind[next[i]]<>0 then begin
   Del(Ind[Next[i]]);
   ind[next[i]]:=0;
  end;
  D[i]:=D[i]+D[Next[i]];
  Next[i]:=Next[Next[i]];
  if Next[i]<>0 then begin
   prev[next[i]]:=i;
   X[Next[i]]:=X[next[i]]+(time-tp[next[i]])/D[next[i]];
   TP[next[i]]:=time;
   d1:=D[i];
   d2:=D[Next[i]];
   if d2>d1 then begin
    dist:=X[next[i]]-X[i];
    T[i]:=time+(dist*d1*d2)/(d2-d1);
    push(i);
   end else
    ind[i]:=0;
  end;
  if ind[prev[i]]<>0 then begin
   del(ind[prev[i]]);
   ind[prev[i]]:=0;
  end;
  if prev[i]<>0 then begin
   X[prev[i]]:=X[prev[i]]+(time-tp[prev[i]])/D[prev[i]];
   TP[prev[i]]:=time;
   d1:=D[prev[i]];
   d2:=D[i];
   if d2>d1 then begin
    dist:=X[i]-X[prev[i]];
    T[prev[i]]:=time+(dist*d1*d2)/(d2-d1);
    push(prev[i]);
   end else
    ind[prev[i]]:=0;
  end;
{
  if ind[prev[i]]<>0 then begin
   Del(Ind[Prev[i]]);
   ind[prev[i]]:=0;
  end;

  if prev[i]<>0 then begin
   X[prev[i]]:=X[prev[i]]+(time-tp[prev[i]])/D[prev[i]];
   TP[prev[i]]:=time;
  end;
  if next[i]<>0 then
   D[i]:=D[i]+D[Next[i]];


  if next[i]<>0 then begin
   Next[i]:=Next[Next[i]];
   if next[i]<>0 then
    prev[next[i]]:=i;
  end;

  if next[i]<>0 then begin
   X[Next[i]]:=X[next[i]]+(time-tp[next[i]])/D[next[i]];
   TP[next[i]]:=time;
  end;

  if prev[i]<>0 then begin
   d1:=D[prev[i]];
   d2:=D[i];
   if d2>d1 then begin
    dist:=X[i]-X[prev[i]];
    T[prev[i]]:=time+(dist*d1*d2)/(d2-d1);
    push(prev[i]);
   end else
    ind[prev[i]]:=0;
  end;

  if next[i]<>0 then begin
   d1:=D[i];
   d2:=D[Next[i]];
   if d2>d1 then begin
    dist:=X[next[i]]-X[i];
    T[i]:=time+(dist*d1*d2)/(d2-d1);
    push(i);
   end else
    ind[i]:=0;
  end;}
 end;
 j:=0;
 for i:=1 to n do begin
  if U[i] then inc(j);
 end;
 writeln(j);
 for i:=1 to n do begin
  if U[i] then begin
   write(D[i],' ');
  end;
 end;
 close(input);
 close(output);
end.