Program prg;

function max(a, b: integer): integer;
  begin
    if a>b then max:=a else max:=b;
  end;

var
  n: integer;
  m1, m2: integer;
  st1, st2: array[0..31] of integer;
  t: array[0..1001] of integer;
  used: array[0..31, 0..31] of integer;

  i, j, k, last: integer;
  bo, bo2: boolean;

  time: integer;
  inuse: array[0..31] of integer;
  tt: array[0..31] of integer;


procedure swap(var a, b: integer);
  var
    t: integer;

  begin
    t:=a;
    a:=b;
    b:=t;
  end;

procedure qsort(l, r: integer);
  var
    lh, rh: integer;

  begin
    lh:=l;
    rh:=r;
    while (lh<rh) do begin
      while (lh<rh)and(st1[lh]<=st1[rh]) do inc(lh);
      swap(st1[lh], st1[rh]);
      while (lh<rh)and(st1[lh]<=st1[rh]) do dec(rh);
      swap(st1[lh], st1[rh]);
    end;
    if (lh-l)>1 then qsort(l, lh-1);
    if (r-rh)>1 then qsort(rh+1, r);
  end;


procedure qsortt(l, r: integer);
  var
    lh, rh: integer;

  begin
    lh:=l;
    rh:=r;
    while (lh<rh) do begin
      while (lh<rh)and(t[lh]<=t[rh]) do inc(lh);
      swap(t[lh], t[rh]);
      while (lh<rh)and(t[lh]<=t[rh]) do dec(rh);
      swap(t[lh], t[rh]);
    end;
    if (lh-l)>1 then qsortt(l, lh-1);
    if (r-rh)>1 then qsortt(rh+1, r);
  end;

begin
  assign(input, 'details.in');
  assign(output, 'details.out');
  reset(input);
  rewrite(output);

  read(n);

  read(m1);
  for i:=1 to m1 do begin
    read(st1[i]);
  end;
  for i:=1 to m2 do 
    read(st2[i]);

  qsort(1, m1);

  t[1]:=st1[1]*n;
  fillchar(used, sizeof(used), 0);
  used[1][1]:=n;

  
  for i:=2 to m1 do begin
   for j:=1 to i do 
     used[i][j]:=used[i-1][j];
   bo2:=true;
   while bo2 do begin
    bo2:=false;
    last:=1;
    for j:=2 to i-1 do begin
      if (used[i][j]*st1[j]) > (used[i][last]*st1[last]) then begin
        last:=j;
        bo:=false;
      end else
      if (used[i][j]*st1[j]) = (used[i][last]*st1[last]) then 
        bo:=true;
    end;
    if bo then begin
      if (used[i][i]*st1[i]+st1[i]) < (used[i][last]*st1[last]) then begin
        bo2:=true;
        dec(used[i][last]);
        inc(used[i][i]);
      end;
    end else begin
      if (used[i][i]*st1[i] + st1[i]) < ((used[i][last] - 1) * st1[last]) then begin
        bo2:=true;
        dec(used[i][last]);
        inc(used[i][i]);
      end;
    end;

   end;  // while bo2

  end;

  last:=-1;
  for i:=1 to m1 do begin
    k:=0;
    for j:=1 to used[m1][i] do begin
      k:=k+st1[i];
      inc(t[0]);
      t[t[0]]:=k;
    end;
    if (used[m1][i]*st1[i]) > last then
      last:=used[m1][i]*st1[i];
  end;

  writeln(last);

  //------------------

  read(m2);
  for i:=1 to m2 do read(st2[i]);

  qsortt(1, t[0]);

  for i:=1 to n do begin
    time:=high(integer);
    last:=-1;
    for j:=1 to m2 do begin
      k:=max(tt[j], t[i])+st2[j];
      if time > k then begin
        time:=k;
        last:=j;
      end;
    end;
    tt[last]:=max(tt[last], t[i])+st2[last];
  end;

  time:=-1;
  for i:=1 to m2 do 
    if time < tt[i] then time:=tt[i];



  writeln(time);

  close(input);
  close(output);
end.
