#include <stdio.h>
#include <string.h>

#define MIN(A, B) (((A) <= (B)) ? (A) : (B))
#define MAX(A, B) (((A) >= (B)) ? (A) : (B))
#define SWAP(A, B, C) ((C) = (A), (A) = (B), (B) = (C))
#define ABS(X) (((X) >= 0) ? (X) : -(X))

#define eps 1e-9
#define inf (int)1e9

#define MAXN 1500010

int N, A[MAXN], R[MAXN];
int C[MAXN], TN, TA[MAXN], TB[MAXN], TM[MAXN];

int main( void )
{
  int i, t, j, k;

  freopen("empodio.in", "rt", stdin);
  freopen("empodio.out", "wt", stdout);

  scanf("%d", &N);
  for (i = 0; i < N; i++)
    scanf("%d", &A[i]);

  for (i = 0; i < N; i++)
    R[A[i]] = i;

  memset(C, 0, sizeof(C));
  TN = 0;
  for (i = 0; i < N; i++)
  {
    C[i] = 1, t = i, j = i, k = 0;
    while (1)
    {
      if (A[t] == N - 1 || t < i)
        break;
      t = R[A[t] + 1];
      k++;
      C[t] = 1;
      while (j < N - 1 && C[j + 1])
        j++;
      if (j == t && t - i == k)
      {
        TA[TN] = i;
        TB[TN++] = j;
        break;
      }
    }
    t = i;
    C[i] = 0;
    while (1)
    {
      if (A[t] == N - 1 || t < i)
        break;
      t = R[A[t] + 1];
      if (C[t] == 0)
        break;
      C[t] = 0;
    }
  }
  for (i = 0; i < TN; i++)
    C[i] = 1;
  TM[TN - 1] = TB[TN - 1];
  for (i = TN - 2; i >= 0; i--)
    TM[i] = MIN(TM[i + 1], TB[i]);
  for (i = 0; i < TN - 1; i++)
    if (TB[i] >= TM[i + 1])
      C[i] = 0;
  N = 0;
  for (i = 0; i < TN; i++)
    N += C[i];
  printf("%d\n", N);
  for (i = 0; i < TN; i++)
    if (C[i])
      printf("%d %d\n", TA[i] + 1, TB[i] + 1);

  return 0;
}
