type integer = longint;
const MNOGO = $7F7F7F7F;
const MAXN = 800;
var n, s : integer;
	t, f : array[1..10000] of integer;
	cst, csf : array[0..10000] of integer;

procedure Load;
var i : integer;
begin
	read(n, s);
	cst[0] := 0;
	csf[0] := 0;
	for i := 1 to n do begin
		read(t[i], f[i]);
		cst[i] := cst[i - 1] + t[i];
		csf[i] := csf[i - 1] + f[i];
	end;
end;

var res : array[0..MAXN, 0..MAXN] of integer;
	ss : array[1..MAXN] of integer;

procedure Solve;
var min, i, j, k, cres : integer;
begin
	fillchar(res, sizeof(res), $7F);
	res[0, 0] := 0;
	for i := 1 to n do ss[i] := s * i;
	for i := 1 to n do begin
		for j := 1 to i + 1 do begin
			for k := i downto 1 do begin
				if res[k - 1, j - 1] = MNOGO then continue;
				cres := res[k - 1, j - 1] + (ss[j] + cst[i]) * (csf[i] - csf[k - 1]);
				if res[i, j] > cres then res[i, j] := cres;
			end;
		end;
	end;
	min := MNOGO;
	for i := 1 to n do begin
		if res[n, i] < min then begin
			min := res[n, i];
		end;
	end;
	write(min);
end;

begin
	assign(input, 'batch.in');
	assign(output, 'batch.out');
	reset(input);
	rewrite(output);
	Load;
	Solve;
	close(input);
	close(output);
end.