#include <cstdio>

#define maxn 100
#define INF 2147483647

int d[maxn+1][maxn+1];
int S, t[maxn+1], f[maxn+1], sum[maxn+1];
int n, ans, i, j, k;

int T(int i, int j){
  return t[j]-t[i-1];
}

int F(int i, int j){
  return f[j]-f[i-1];
}

int main(){
  freopen("batch.in", "rt", stdin);
  freopen("batch.out", "wt", stdout);
  scanf("%d%d", &n, &S);
  for (i=1; i<=n; i++){
    scanf("%d%d", &t[i], &f[i]);
    if (i>0) t[i]+=t[i-1];
    if (i>0) f[i]+=f[i-1];
  }
  for (i=0; i<=n; i++)
    for (j=0; j<=n; j++) d[i][j]=INF;
  d[0][0]=0;
  for (i=1; i<=n; i++){
    for (j=1; j<i; j++)
      sum[j]+=F(j, i-1)*T(i, i);
    for (j=1; j<=i; j++){
      for (k=0; k<i; k++)
        if (d[k][j-1]!=INF&&d[k][j-1]+sum[k]+j*(i-k)<d[i][j])
          d[i][j]=d[k][j-1]+sum[k+1]+j*S*F(k+1, i);
    }
  }
  ans=INF;
  for (i=1; i<=n; i++)
    if (d[n][i]<ans) ans=d[n][i];
  for (i=1; i<=n; i++) ans+=F(i, i)*T(1, i);
  printf("%d", ans);
  return 0;
}
