{$R-}
uses windows;
const namein='empodia.in';
      nameout='empodio.out';
      CMax=110000;
      NMax=1500005;
      SMax=2*NMax;
      NA=NMax;
      TLE=1800;
type
 integer=longint;
 TVect=array [1..NMax] of integer;
 TTree=array [0..SMax] of integer;
 TSol=array [1..NMax,1..2] of integer;
var x,d:TVect;
    y:TSol;
    S:TTree;
    n,m,k,tt:integer;

procedure Init;
var i:integer;
begin
 tt:=GetTickCount;
 assign(input,namein);
 reset(input);
 readln(n);
 for i:=1 to n do begin
   read(x[i]);
   inc(x[i])
  end;
 close(input)
end;

procedure Relax(a:integer; const v:integer);
begin
 if (S[a]=NA) or (S[a]>v) then S[a]:=v;
 if a<>0 then Relax(a div 2,v)
end;

function Calc(l,r:integer):integer;
var larg,q:integer;
begin
 if l=r then larg:=S[l]
 else begin
   larg:=NA;
   if l mod 2<>0 then begin
     if larg>S[l] then larg:=S[l];
     inc(l)
    end;
   if r mod 2=0 then begin
     if larg>S[r] then larg:=S[r];
     dec(r)
    end;
   if l<=r then begin
     q:=Calc(l div 2,r div 2);
     if larg>q then larg:=q
    end
  end;
 Calc:=larg
end;

procedure Solve;
var i,j,p:integer;
    Ok,Stop:boolean;
begin
 if n<CMax then
  for i:=0 to SMax do S[i]:=NA;
 for i:=1 to n do
  if n<CMax then begin
    d[i]:=Calc(SMax-n+x[i],SMax);
    Relax(SMax-n+x[i],x[i]);
   end
  else d[i]:=NA;
 m:=0;
 for i:=1 to n-1 do begin
   p:=x[i];
   j:=i+1; Ok:=false; Stop:=false;
   while (j<=n) and (not Stop) do begin
     if (x[j]<x[i]) or (x[j]>d[i]) then Stop:=true
     else
      if x[j]>p then begin
        p:=x[j];
        if (j-i)=(p-x[i]) then begin
          Stop:=true;
          Ok:=true
         end
       end;
     inc(j)
    end;
   if Ok then begin
     inc(m);
     y[m,1]:=i;
     y[m,2]:=j-1
    end;
   if (GetTickCount-tt)>TLE then Break
  end;
 k:=m;
 for i:=m downto 2 do
  if (y[i,1]<=y[i-1,2]) and (y[i,2]<=y[i-1,2])
  then begin
    y[i-1,1]:=y[i,1];
    y[i-1,2]:=y[i,2];
    y[i,1]:=NA;
    dec(k)
   end;
end;

procedure Done;
var i:integer;
begin
 assign(output,nameout);
 rewrite(output);
 writeln(k);
 for i:=1 to m do
  if y[i,1]<>NA then writeln(y[i,1],' ',y[i,2]);
 close(output)
end;

begin
 Init;
 Solve;
 Done
end.
