#include <stdio.h>
#include <string.h>
#include <time.h>

#define m 10010

int r1[m], r2[m], t[m], f[m], n, s, sf[m], st[m];

int main( void )
{
  int i, j, k, rr, be, stc = clock();

  freopen("batch.in", "rt", stdin);
  freopen("batch.out", "wt", stdout);
  scanf("%d%d", &n, &s);
  for (i = 0; i < n; i++)
    scanf("%d%d", &t[i], &f[i]);
  for (st[0] = t[0], i = 1; i < n; i++)
    st[i] = st[i - 1] + t[i];
  for (sf[0] = 0, i = 1; i <= n; i++)
    sf[i] = sf[i - 1] + f[i - 1];
  if (s == 0)
  {
    for (be = 0, i = 0; i < n; i++)
      be += st[i] * f[i];
    printf("%d", be);
    return 0;
  }
  memset(r1, -1, sizeof(r1));
  r1[0] = 0;
  be = -1;
  for (j = 0; j < n; j++)
  {
    if (clock() - stc > 1.8 * CLOCKS_PER_SEC)
      break;
    memset(r2, -1, sizeof(r2));
    for (i = j; i < n; i++)
      if (r1[i] != -1)
        for (k = i; k < n; k++)
        {
          rr = r1[i] + (st[k] + (j + 1) * s) * (sf[k + 1] - sf[i]);
          if (r2[k + 1] == -1 || r2[k + 1] > rr)
            r2[k + 1] = rr;
        }
    if (be == -1 || be > r2[n])
      be = r2[n];
    memcpy(r1, r2, sizeof(r2));
  }
  printf("%d", be);
  return 0;
}
