#include <stdio.h>

#define MAXN 10002

#define MIN(a, b) ((a) > (b) ? (b) : (a))

int N, S, T[MAXN], F[MAXN], D[MAXN];

int main() {
   int i, j;

   freopen("batch.in", "rt", stdin);
   freopen("batch.out", "wt", stdout);
   
   scanf("%d%d", &N, &S);
   T[0] = 0; F[0] = 0;
   for (i = 1; i <= N; i++)
      scanf("%d%d", &T[i], &F[i]), T[i] += T[i-1], F[i] += F[i-1];
   for (i = N; i > 0; i--) {
      D[i] = (S + T[N] - T[i-1]) * (F[N] - F[i-1]);
      for (j = N - 1; j >= i; j--)
         D[i] = MIN(D[i], (S + T[j] - T[i-1])*(F[N] - F[i-1]) + D[j+1]);
   }

   printf("%d", D[1]);

   fclose(stdin);
   fclose(stdout);

   return 0;
}