#include <stdio.h>
#include <string.h>

#define MAX 1010

#define NUM 20010

char S[MAX];
int N, F[26];

int GoRight( void )
{
  int i, k = 0;
  for (i = 0; i < N; i++)
    if (F[S[i] - 'a'])
      k++;
    else if (k)
      k--;
    else
    {
      F[S[i] - 'a'] = 1;
      return 1;
    }
  return 0;
}

int GoLeft( void )
{
  int i, k = 0;
  for (i = N - 1; i >= 0; i--)
    if (!F[S[i] - 'a'])
      k++;
    else if (k)
      k--;
    else
    {
      F[S[i] - 'a'] = 0;
      return 1;
    }
  return 0;
}

int main( void )
{
  int i, f = 1;

  freopen("brackets2.in", "rt", stdin);
  freopen("brackets2.out", "wt", stdout);
  scanf("%s", S), N = strlen(S);
  memset(F, 0, sizeof(F));
  for (i = 0; i < NUM && f; i++)
  {
    f = 0;
    while (GoRight())
      i++, f = 1;
    while (GoLeft())
      i++, f = 1;
  }
  if (f)
    puts("IMPOSSIBLE");
  else
    for (i = 0; i < N; i++)
      putc(F[S[i] - 'a'] ? '(' : ')', stdout);
  return 0;
}
