{$R-,H+}
uses SysUtils, Math;
const namein='brackets2.in';
      nameout='brackets2.out';
      NMax=1100;
      Inf=NMax;
type
 TChr=array ['a'..'z'] of integer;
 TSvv=array [1..NMax] of char;
var s,Sol:string;
    v,w,x:TChr;
    q:TSvv;
    n,m,i,k,w1,w2:integer;
    Ok:boolean;

procedure Init;
begin
 assign(input,namein);
 reset(input);
 readln(s);
 close(input)
end;

procedure Done;
begin
 assign(output,nameout);
 rewrite(output);
 if Ok then begin
   Sol:='';
   for i:=1 to m do
    if x[s[i]]=1 then Sol:=Sol+'('
    else Sol:=Sol+')';
   writeln(Sol)
  end
 else writeln('IMPOSSIBLE');
 close(output);
 halt(0)
end;

procedure Calc(a:integer);
begin
 if a>n then begin
   i:=1; k:=0;
   Ok:=true;
   while (i<=m) and Ok do begin
     inc(k,x[s[i]]);
     Ok:=Ok and (k>=0);
     inc(i)
    end;
   if Ok then Done
  end
 else begin
   if (w1+w[q[a]])<=(m div 2)
   then begin
     inc(w1,w[q[a]]);
     x[q[a]]:=1;
     Calc(a+1);
     dec(w1,w[q[a]])
    end;
   if (w2+w[q[a]])<=(m div 2)
   then begin
     inc(w2,w[q[a]]);
     x[q[a]]:=-1;
     Calc(a+1);
     dec(w2,w[q[a]])
    end
  end
end;

procedure Solve;
var i,j:integer;
    c:char;
begin
 for c:='a' to 'z' do begin
   v[c]:=Inf;
   w[c]:=0
  end;
 m:=length(s);
 for i:=1 to m do begin
   v[s[i]]:=min(v[s[i]],i);
   inc(w[s[i]])
  end;
 n:=0;
 for c:='a' to 'z' do
  if v[c]<>Inf then begin
    inc(n);
    q[n]:=c
   end;
 for i:=1 to n-1 do
  for j:=i+1 to n do
   if v[q[i]]>v[q[j]] then begin
     c:=q[i];
     q[i]:=q[j];
     q[j]:=c
    end;
 Ok:=((m mod 2)=0) and (w[q[1]]<=(m div 2));
 if Ok then begin
   Ok:=false;
   x[q[1]]:=1;
   w1:=w[q[1]]; w2:=0;
   Calc(2)
  end
end;

begin
 Init;
 Solve;
 Done
end.

