{$R-}
uses
  SysUtils;

const namein='brackets3.in';
      nameout='brackets3.out';
      NMax=61;
      Cnv:array ['a'..'z'] of char=('A','B','C','D','E','F','G','H','I',
                                    'J','K','L','M','N','O','P','Q','R',
                                    'S','T','U','V','W','X','Y','Z');
      CRes:array [false..true] of string=('NO','YES');
type
 TStt=array [0..NMax] of char;
 TVect=array [0..NMax] of integer;
var a,b,s:string;
    St:TStt;
    x:TVect;
    u,n,m,TNum:integer;
    Find:boolean;

procedure Init;
begin
 assign(input,namein);
 reset(input);
 assign(output,nameout);
 rewrite(output);
 readln(TNum)
end;

function Check(const s:string; const l,r:integer):boolean;
var Ok:boolean;
    i:integer;
begin
 u:=0;
 Ok:=true;
 for i:=l to r do
  if s[i] in ['A'..'Z']
  then begin
    inc(u);
    St[u]:=s[i]
   end
  else
   if (u=0) or (St[u]<>Cnv[s[i]])
   then begin
     Ok:=false;
     Break
    end
   else dec(u);
 Ok:=Ok and (u=0);
 Check:=Ok
end;

procedure Calc(v1,v2:integer);
var k1,k2,j:integer;
begin
 if v1>m then begin
   k1:=1; k2:=1; s:='';
   for j:=1 to n+m do
    if (k2<=n) and (x[k2]<k1) then begin
      s:=s+a[k2];
      inc(k2)
     end
    else begin
      s:=s+b[k1];
      inc(k1)
     end;
   if Check(s,1,n+m) then Find:=true
  end
 else
  for j:=v2 to n do begin
    x[v1]:=j;
    Calc(v1+1,j);
    if Find then Exit
   end
end;

procedure Solve;
var i:integer;
begin
 for i:=1 to TNum do begin
   readln(a);
   readln(b);
   n:=length(a);
   m:=length(b);
   Find:=false;
   Calc(0,0);
   writeln(CRes[Find])
  end
end;

procedure Done;
begin
 close(input);
 close(output)
end;

begin
 Init;
 Solve;
 Done
end.
