{$H+}
type integer = longint;
var s : string;

procedure Load;
begin
	readln(s);
end;

var stk : array[1..21000] of char;
	top : integer;

procedure Solve;
var i : integer;
begin
	top := 0;
	for i := 1 to length(s) do begin
		{can close}
		if (top > 0) and (stk[top] = s[i]) then begin
			dec(top);
		end
		else begin
			inc(top);
			stk[top] := s[i];
			s[i] := UpCase(s[i]);
		end;
	end;
	if top <> 0 then begin
		write('IMPOSSIBLE');
	end
	else begin
		write(s);
	end;
end;

var res : array[1..200, 1..200] of integer;
	pth : array[1..200, 1..200] of integer;

function Count(be, en : integer) : integer;
var i : integer;
begin
	if res[be, en] <> - 1 then begin
		Count := res[be, en];
		exit;
	end;
	if be = en then begin
		res[be, en] := 0;
		Count := 0;
		exit;
	end;
	if be = en + 1 then begin
		res[be, en] := 1;
		Count := 1;
		exit;
	end;
    res[be, en] := 0;
	if s[be] = s[en] then begin
		if Count(be + 1, en - 1) = 1 then begin
			res[be, en] := 1;
			pth[be, en] := -1;
		end;
	end;
	for i := be to en - 1 do begin
		if Count(be, i) + Count(i + 1, en) = 2 then begin
			res[be, en] := 1;
			pth[be, en] := i;
		end;
	end;
	Count := res[be, en];
end;

procedure Rans(be, en : integer);
begin
	if be = en + 1 then begin
		exit;
	end;
	if pth[be, en] = -1 then begin
		write(UpCase(s[be]));
		Rans(be + 1, en - 1);
		write(s[en]);
	end
	else begin
		Rans(be, pth[be, en]);
		Rans(pth[be, en] + 1, en);
	end;
end;

procedure SolveCubic;
begin
	fillchar(res, sizeof(res), $FF);
	Count(1, length(s));
	if res[1, length(s)] = 0 then begin
		write('IMPOSSIBLE');
	end
	else begin
		Rans(1, length(s));
	end;
end;


begin
	assign(input, 'brackets1.in');
	assign(output, 'brackets1.out');
	reset(input);
	rewrite(output);
	Load;
	if length(s) <= 200 then SolveCubic
	else Solve;
	close(input);
	close(output);
end.