#include <stdio.h>
#include <string.h>
#include <time.h>

#define WORK_TIME 1800

int stime;
int n;
char expr[1020];
int cnt['z'-'a'+1];
int mean['z'-'a'+1];
int an;
int adr['z'-'a'+1];
int sum, deg1, deg2;
bool barr['z'-'a'+1];
int tbcnt['z'-'a'+1];

int readString(char *arr) {
	fgets(arr, 1010, stdin);
	int len = strlen(arr);
	while ((arr[len-1]==' ') || (arr[len-1]=='\n'))
		len--;
	arr[len] = 0;
	return len;
}

bool next() {
	int i;
	for (i = 0; i<an; i++) {
		barr[i] = !barr[i];
		if (barr[i]) {
			sum -= (tbcnt[i]<<1);
			return true;
		}
		sum += (tbcnt[i]<<1);
	}
	return false;
}

int main(int argc, char **argv) {
	freopen("brackets2.in", "r", stdin);
	freopen("brackets2.out", "w", stdout);
	stime = clock();
	int i, j;
	n = readString(expr);
	for (i = 0; i<n; i++)
		cnt[expr[i]-'a']++;
	for (i = 0; i<='z'-'a'; i++)
		if (cnt[i]>0) {
			adr[an] = i;
			sum += cnt[i];
			tbcnt[an] = cnt[i];
			mean[i] = 1;
			an++;
		}
	do {
		if (sum != 0) continue;
		j = 0;
		for (i = 0; i<='z'-'a'; i++)
			if (cnt[i] > 0) {
				mean[i] = (barr[j] ? -1 : 1);
				j++;
			}
		deg1 = 0;
		deg2 = 0;
		bool ok = true;
		for (i = 0; i < (n+1)>>1; i++) {
			deg1 += mean[expr[i]-'a'];
			deg2 -= mean[expr[n-i-1]-'a'];
			if ((deg1<0) || (deg2<0)) {
				ok = false;
				break;
			}
		}
		if (ok) {
			for (i = 0; i<n; i++)
				printf("%c", (mean[expr[i]-'a']<0 ? ')' : '('));
			return 0;
		}
		if ((stime-clock())*1000 > WORK_TIME*CLOCKS_PER_SEC)
			break;
	} while (next());
	printf("IMPOSSIBLE");
	return 0;
}
