#include <stdio.h>
#include <string.h>

#define MIN(A, B) (((A) <= (B)) ? (A) : (B))
#define MAX(A, B) (((A) >= (B)) ? (A) : (B))
#define SWAP(A, B, C) ((C) = (A), (A) = (B), (B) = (C))
#define ABS(X) (((X) >= 0) ? (X) : -(X))

#define eps 1e-9
#define inf (int)2e9

#define MAXL 66

int T;
char S1[MAXL], S2[MAXL], D[MAXL][MAXL][MAXL][MAXL];

int F(int L1, int R1, int L2, int R2)
{
  int i, j;
  if (D[L1][R1][L2][R2] + 1)
    return D[L1][R1][L2][R2];
  if (L1 > R1 && L2 > R2)
    return D[L1][R1][L2][R2] = 1;
  if (L1 - R1 >= 1 && S1[L1] - 'A' + 'a' == S1[R1] && F(L1 + 1, R1 - 1, L2, R2))
    return D[L1][R1][L2][R2] = 1;
  if (L2 - R2 >= 1 && S2[L2] - 'A' + 'a' == S2[R2] && F(L1, R1, L2 + 1, R2 - 1))
    return D[L1][R1][L2][R2] = 1;
  if (L1 > R1 || L2 > R2)
    return D[L1][R1][L2][R2] = 0;
  if (S1[L1] - 'A' + 'a' == S2[R2] && F(L1 + 1, R1, L2, R2 - 1))
    return D[L1][R1][L2][R2] = 1;
  if (S2[L2] - 'A' + 'a' == S1[R1] && F(L1, R1 - 1, L2 + 1, R2))
    return D[L1][R1][L2][R2] = 1;
  for (i = L1; i < R1; i += 2)
    for (j = L2; j < R2; j += 2)
      if (F(L1, i, L2, j) && F(i + 1, R1, j + 1, R2))
        return D[L1][R1][L2][R2] = 1;
  return D[L1][R1][L2][R2] = 0;
}

int main( void )
{
  int i;

  freopen("brackets3.in", "rt", stdin);
  freopen("brackets3.out", "wt", stdout);

  scanf("%d", &T);
  while (T--)
  {
    scanf("%s", S1);
    scanf("%s", S2);
    memset(D, -1, sizeof(D));
    if (F(0, strlen(S1) - 1, 0, strlen(S2) - 1))
      printf("YES\n");
    else
      printf("NO\n");
  }

  return 0;
}
