#include <stdio.h>
#include <memory.h>
#include <string.h>

#define NUM 60

int k;
int m, n;
char e1[NUM+10], e2[NUM+10];
int nxt1[NUM+10]['z'-'a'+1], nxt2[NUM+10]['z'-'a'+1];
int ns1[NUM+10]['z'-'a'+1], ns2[NUM+10]['z'-'a'+1];
int sum['z'-'a'+1];
bool res[NUM+10][NUM+10][NUM+10][NUM+10];
bool done[NUM+10][NUM+10][NUM+10][NUM+10];

inline bool up(char a) {
	return ((a>='A') && (a<='Z'));
}

int readString(char *arr) {
	fgets(arr, NUM+5, stdin);
	int len = strlen(arr);
	while ((arr[len-1]==' ') || (arr[len-1]=='\n'))
		len--;
	arr[len] = 0;
	return len;
}

bool Solve(int i, int a, int j, int b) {
	if (done[i][a][j][b])
		return res[i][a][j][b];
	done[i][a][j][b] = true;
	if ((i==j) && (a==b))
		return (res[i][a][j][b] = true);
	int u, v;
	if (j-i>=2)
		if (up(e1[i])) {
			char co = e1[i]-'A';
			for (u = ns1[i][co]; u<j; u = nxt1[u][co])
				for (v = a; v<=b; v++)
					if (Solve(i+1, a, u, v) && Solve(u+1, v, j, b))
						return (res[i][a][j][b] = true);
		}
	if (b-a>=2)
		if (up(e2[a])) {
			char co = e2[a]-'A';
			for (u = ns2[a][co]; u<b; u = nxt2[u][co])
				for (v = i; v<=j; v++)
					if (Solve(i, a+1, v, u) && Solve(v, u+1, j, b))
						return (res[i][a][j][b] = true);
		}
	if ((j-i>=1) && (b-a>=1))
		if (up(e1[i])) {
			char co = e1[i]-'A';
			for (u = ns2[a][co]; u<b; u = nxt2[u][co])
				for (v = i+1; v<=j; v++)
					if (Solve(i+1, a, v, u) && Solve(v, u+1, j, b))
						return (res[i][a][j][b] = true);
		}
	if ((j-i>=1) && (b-a>=1))
		if (up(e2[a])) {
			char co = e2[a]-'A';
			for (u = ns1[i][co]; u<j; u = nxt1[u][co])
				for (v = a; v<=b; v++)
					if (Solve(i, a+1, u, v) && Solve(u+1, v, j, b))
						return (res[i][a][j][b] = true);
		}
	return (res[i][a][j][b] = false);
}

int main(int argc, char **argv) {
	freopen("brackets3.in", "r", stdin);
	freopen("brackets3.out", "w", stdout);
	int i, j, c;
	scanf("%d\n", &k);
	for (int cnt = 0; cnt<k; cnt++) {
		m = readString(e1);
		n = readString(e2);
		memset(sum, 0, sizeof(sum));
		for (i = 0; i<m; i++) {
			if (up(e1[i]))
				sum[e1[i]-'A']++;
			else
				sum[e1[i]-'a']--;
		}
		for (i = 0; i<n; i++) {
			if (up(e2[i]))
				sum[e2[i]-'A']++;
			else
				sum[e2[i]-'a']--;
		}
		bool badsum = false;
		for (i = 0; i<='z'-'a'; i++)
			if (sum[i] != 0) {
				printf("NO\n");
				badsum = true;
				break;
			}
		if (badsum) continue;
		for (c = 0; c<='z'-'a'; c++) {
			for (i = 0; i<m; i++) {
				nxt1[i][c] = m;
				for (j = i+1; j<m; j++)
					if (e1[j] == c+'a') {
						nxt1[i][c] = j;
						break;
					}
				ns1[i][c] = nxt1[i][c];
				if (e1[i] == c+'a')
					ns1[i][c] = i;
			}
			for (i = 0; i<n; i++) {
				nxt2[i][c] = n;
				for (j = i+1; j<n; j++)
					if (e2[j] == c+'a') {
						nxt2[i][c] = j;
						break;
					}
				ns2[i][c] = nxt2[i][c];
				if (e2[i] == c+'a')
					ns2[i][c] = i;
			}
		}
		memset(done, 0, sizeof(done));
		memset(res, 0, sizeof(res));
		Solve(0, 0, m, n);
		if (res[0][0][m][n])
			printf("YES\n");
		else
			printf("NO\n");
	}
	return 0;
}
