{$I-,Q-,R-,S-}
//{$I+,Q+,R+,S+}
program Temp;
uses
  SysUtils;
const
 in_f='brackets1.in';
 out_f='brackets1.out';
type
  int=longint;
  real=extended;
  bool=boolean;
  TPair=record
     num,zn : int;
    end;
const
  maxN=20000;
  magic=5000;
  imp='IMPOSSIBLE';
  let=26;
  tl=1.8/24/60/60;
var
  N:int;
  a:array[1..maxN] of int;
  open:array[1..maxN] of bool;
  s:array[0..maxN] of int;
  srt:array[0..maxN] of TPair;
  mst:array[0..maxN] of int;

  link:array[1..magic,1..magic] of smallint;

  begtime:real;

function Less(const a,b:TPair):bool;
begin
  if a.zn<>b.zn then
    Less:=a.zn<b.zn
  else
    Less:=a.num<b.num
end;

procedure QSort(l, r: Int);
var
  i, j: int;
  x,y:TPair;
begin
  i := l; j := r; x := srt[l+random(r-l+1)];
  repeat
    while Less(srt[i],x) do i := i + 1;
    while Less(x, srt[j]) do j := j - 1;
    if i <= j then
    begin
      y := srt[i]; srt[i] := srt[j]; srt[j] := y;
      i := i + 1; j := j - 1;
    end;
  until i > j;
  if l < j then QSort(l, j);
  if i < r then QSort(i, r);
end;


function Can(L,R:int):boolean;
 var
   i:int;
 begin
   if link[L,R]<>-1 then
     begin
       can:=link[L,r]>=0;
       exit;
     end;

   can:=false;
   link[l,r]:=-2;

   if L=R+1 then
     begin
       Can:=true;
       link[L,R]:=0;
     end
   else
     if s[R] xor s[L-1] = 0 then
       begin
         if a[L]=a[R] then
           if can(L+1,R-1) then
             begin
               open[L]:=true;
               open[R]:=false;
               Can:=true;
               link[l,r]:=0;
               exit;
             end;

         i:=mst[L-1]+1;
         while (i<=N) and (srt[i].zn=s[L-1]) and (srt[i].num<R) do
           begin
             if Can(srt[i].num+1,R) and Can(L,srt[i].num) then
               begin
                 Can:=true;
                 link[l,r]:=srt[i].num;
                 exit;
               end;
             inc(i);
           end;
       end;
 end;

procedure FillIt(L,R:int);
 begin
   if L=R+1 then exit;
   if link[l,r]=0 then
     begin
       open[L]:=true;
       open[R]:=false;
       FillIt(L+1,R-1);
     end
   else
     begin
       FillIt(L,link[l,r]);
       FillIt(link[l,r]+1,r);
     end;
 end;

function DoAll(L,R:int):boolean;
 var
   i:int;
 begin
   DoAll:=false;
   if now>begtime+tl then
     exit;

   if L=R+1 then
     DoAll:=true
   else
     if s[R] xor s[L-1] = 0 then
       begin
         if a[L]=a[R] then
           if DoAll(L+1,R-1) then
             begin
               open[L]:=true;
               open[R]:=false;
               DoAll:=true;
               exit;
             end;

         i:=mst[L-1]+1;
         while (i<=N) and (srt[i].zn=s[L-1]) and (srt[i].num<R) do
           begin
             if DoAll(srt[i].num+1,R) and DoAll(L,srt[i].num) then
               begin
                 DoAll:=true;
                 exit;
               end;
             inc(i);
           end;
       end;
 end;

procedure Solve;
 var
   i:int;
 begin
   if N=0 then
     exit;
   s[0]:=0;
   for i := 1 to N do
     s[i]:=s[i-1] xor (1 shl a[i]);

   for i := 0 to N do
     begin
       srt[i].num:=i;
       srt[i].zn:=s[i];
     end;
   QSort(0,N);
   for i := 0 to N do
     mst[srt[i].num]:=i;
   fillchar(link,sizeof(link),255);
   if N>magic then
     if DoAll(1,n) then
       for i := 1 to N do
         if open[i] then
           Write(chr(a[i]+ord('A')-1))
         else
           Write(chr(a[i]+ord('a')-1))
     else
       Write(imp)
   else
     if Can(1,n) then
       begin
         FillIt(1,n);
         for i := 1 to N do
           if open[i] then
             Write(chr(a[i]+ord('A')-1))
           else
             Write(chr(a[i]+ord('a')-1))
       end
     else
       Write(imp);
 end;

procedure Init;
 var
   ch:char;
 begin
   N:=0;
   while not seekeoln do
     begin
       Inc(N);
       Read(ch);
       a[n]:=ord(ch)-ord('a')+1;
     end;
 end;

procedure OpenFiles;
 begin
  Assign(input,in_f);
  Reset(input);
  Assign(output,out_f);
  Rewrite(output);
 end;

procedure CloseFiles;
 begin
  Close(input);
  Close(output);
 end;

Begin
begtime:=now;
OpenFiles;
Init;
Solve;
CloseFiles;
End.
