type
  TDet = array[1..1000] of integer;
  TSt = array[1..30] of record
    t:integer;
    cur:integer;
    nd:integer;
    free :boolean;
  end;
var
  D:TDet;
  n,m1,m2:integer;
  npa,npb:integer;
  a,b:Tst;
  T:Longint;

procedure Sort(var a:Tst;m:integer);
var
  i,j,t,max,jm:integer;
begin
  for i:=1 to m do begin
    max:=0;
    for j:=i to m do
      if a[j].t>max then begin
        max:=a[j].t;
        jm:=j;
      end;
    t:=a[i].t;
    a[i].t:=a[jm].t;
    a[jm].t:=t;
  end;
end;

procedure Init;
var
  i,j,k:integer;
begin
  FillChar(D,sizeof(D),0);
  assign(input,'details.in');
  reset(input);
  readln(n);
  readln(m1);
  for i:=1 to m1 do begin
    read(a[i].t);
    a[i].free:=true;
    a[i].cur:=0;
  end;
  readln;
  readln(m2);
  for i:=1 to m2 do begin
    read(b[i].t);
    b[i].free:=true;
    b[i].cur:=0;
  end;
  close(input);
  Sort(a,m1);
  Sort(b,m2);
end;

procedure Solve;
var
  i,k:integer;
begin
  npa:=1;
  npb:=1;
  T:=0;
  while true do begin
    for i:=1 to n do begin
      if (D[i]=0)and(npa<>0) then begin
        D[i]:=1;
        a[npa].free:=false;
        a[npa].cur:=0;
        a[npa].nd:=i;
        inc(npa);
        if npa>m1 then npa:=0;
      end;
      if (D[i]=2)and(npb<>0) then begin
        D[i]:=3;
        b[npb].free:=false;
        b[npb].cur:=0;
        b[npb].nd:=i;
        inc(npb);
        if npb>m2 then npb:=0;
      end;
    end;
    for i:=1 to m1 do begin
      a[i].cur:=a[i].cur+1;
      if a[i].cur=a[i].t then begin
        inc(D[a[i].nd]);
        a[i].free:=true;
      end;
    end;
    for i:=1 to m2 do begin
      b[i].cur:=b[i].cur+1;
      if b[i].cur=b[i].t then begin
        inc(D[b[i].nd]);
        b[i].free:=true;
      end;
    end;
    inc(T);
    for i:=1 to n do
      if D[i]=4 then inc(k);
    if k=n then break;
    for i:=m1 downto 1 do
      if a[i].free then begin
        npa:=i;
        break;
      end;
    for i:=m2 downto 1 do
      if b[i].free then begin
        npb:=i;
        break;
      end;
  end;
end;

procedure Print;
var
  i:integer;
begin
  assign(output,'details.out');
  rewrite(output);
  for i:=1 to m1 do write(a[i].t,' ');
  writeln;
  for i:=1 to m2 do write(b[i].t,' ');
  writeln(T);
  close(output);
end;

begin
  init;
  Print;
end.
