{$H+,B-,I-,Q-,R-,S-}
{H+,B-,I+,Q+,R+,S+}
const
 maxN=60;
type
 int=longint;
var
 s,t,st : array[0..2*maxN+1]of char;
 Ntests,test:int;
 n,m,size,ps,pt,i:int;
 ch:char;
 ok:boolean;

function up(ch:char):boolean;
begin
 up:=(ord(ch)>=ord('A'))and(ord(ch)<=ord('Z'));
end;
function invert(ch:char):char;
begin
 if up(ch)
  then invert:=chr(ord(ch)-ord('A')+ord('a'))
  else invert:=chr(ord(ch)-ord('a')+ord('A'));
end;

procedure poptop();
begin
 if (size>0) then dec(size);
end;
procedure push(ch:char);
begin
 if (size>0)and(up(st[size]))and(st[size]=invert(ch)) then poptop()
 else begin
  inc(size);
  st[size]:=ch;
 end;
end;
procedure stdpush;
begin
 if up(s[ps]) then
 begin push(s[ps]); inc(ps); end else
 if up(t[pt]) then
 begin push(t[pt]); inc(pt); end else ok:=false;
end;

function heuristics():boolean;
var
 i,min:int;
 r:boolean;
begin
 r:=false;
 size:=0;
 for i:=1 to n do
  push(s[i]);
 for i:=1 to m do
  push(t[i]);
 r:=r or (size=0);
 size:=0;
 for i:=1 to m do push(t[i]);
 for i:=1 to n do push(s[i]);
 r:=r or (size=0);
 if (n<m) then min:=n else min:=m;
 size:=0;
 for i:=1 to min do begin
  push(s[i]);
  push(t[i]);
 end;
 for i:=min+1 to n do push(s[i]);
 for i:=min+1 to m do push(t[i]);
 r:=r or (size=0);
 //
 heuristics:=r;
end;

Begin
 assign(input,'brackets3.in');
 reset(input);
 assign(output,'brackets3.out');
 rewrite(output);
 readln(Ntests);
 for test:=1 to Ntests do begin
  n:=0;
  while (not eoln()) do begin
   inc(n);
   read(s[n]);
  end;
  readln;
  m:=0;
  while (not eoln) do begin
   inc(m);
   read(t[m]);
  end;
  readln;
  ok:=true;
  size:=0; ps:=1; pt:=1;
  while (ps<=n)and(pt<=m) do begin
   if (not ok) then break;
   if (size=0) then stdpush() else
   begin
    if (st[size]=invert(s[ps])) then begin
     poptop(); inc(ps);
    end else
    if (st[size]=invert(t[pt])) then begin
     poptop(); inc(pt);
    end else stdpush();
   end;
  end;
  for i:=ps to n do push(s[i]);
  for i:=pt to m do push(t[i]);
  ok:=ok and (size=0);
  ok:=ok or (heuristics());
  if ok
   then writeln('YES')
   else writeln('NO');
 end;
 close(input);
 close(output);
End.
