#include <stdio.h>
#include <stdlib.h>
#include <time.h>

#define EXIT { fprintf(stderr, "time=%d\n", clock() - start); exit(0); }

int St[26], N, start, Cnt2[26], Cnt[1002];
char In[1002];

void dfs( int l, int r, int bal, int free, int dbal )
{
  int i;
  if (bal < 0 || N - l < bal)
    return;
  if (l == N)
  {
    if (bal == 0)
    {
      for (i = 0; i < N; i++)
      {
        if (St[In[i]] == -1)
          printf(")");
        else
          printf("(");
      }
      EXIT
    }
  }  
  if (St[In[l]] != 0)    
  {
    dfs(l + 1, bal + St[In[l]], free, dbal - St[In[l]]);
    return;
  }

  St[In[l]] = -1;
  free -= Cnt[l];
  if (bal - Cnt[l] + dbal <= free && bal - Cnt[l] + dbal >= -free)
    dfs(l + 1, bal - 1, free, dbal + 1 - Cnt[l]);

  St[In[l]] = 1;
  if (bal + Cnt[l] + dbal <= free && bal + Cnt[l] + dbal >= -free)
    dfs(l + 1, bal + 1, free, dbal - 1 + Cnt[l]);
  St[In[l]] = 0;
}
int main( void )
{
  int i, j, k;
  char c;

  start = clock();
  freopen("brackets2.in", "rt", stdin);
  freopen("brackets2.out", "wt", stdout);
  while ((c = getc(stdin)) >= 'a' && c <= 'z')
    In[N++] = c - 'a', Cnt2[c - 'a']++;
  for (i = 0; i < N; i++)
    Cnt[i] = Cnt2[In[i]];
  if (N & 1)
  {
    printf("IMPOSSIBLE");
    EXIT
  }
    
  dfs(0, N - 1, N, 0);
  printf("IMPOSSIBLE");
  EXIT

}
