const
  FName = 'threecolors2';
type
  Rect=array[1..2,1..1000] of integer;
  Rect_2=array[1..1000] of boolean;
var
  R:Rect;
  n:integer;
  Res:array[1..1000000] of integer;
  nr:longint;
  RF : Rect_2;

procedure Init;
var
  i,j:integer;
  ch:Char;
begin
  assign(input,FName+'.in');
  reset(input);
  readln(n);
  for i:=1 to 2 do begin
    for j:=1 to n do begin
      read(ch);
      if ch='R' then R[i,j]:=1;
      if ch='G' then R[i,j]:=2;
      if ch='B' then R[i,j]:=3;
    end;
    readln;
  end;
  close(input);
  FillChar(Rf,sizeof(Rf),true);
end;

function MaxColor(h,m:integer):integer;
var
  i,j:integer;
  k1,k2,k3:integer;
begin
  k1:=0;
  k2:=0;
  k3:=0;
  for i:=1 to 2 do
    for j:=h to m do begin
      if R[i,j]=1 then inc(k1);
      if R[i,j]=2 then inc(k2);
      if R[i,j]=3 then inc(k3);
    end;
  if m-h=1 then begin
    if k1=k2 then MaxColor:=3;
    if k2=k3 then MaxColor:=1;
    if k3=k1 then MaxColor:=2;
    if (k1>k2)and(k1>k3) then MaxColor:=1;
    if (k3>k2)and(k3>k1) then MaxColor:=3;
    if (k2>k1)and(k2>k3) then MaxColor:=2;
  end else begin
    if (k1>=k2)and(k1>=k3) then MaxColor:=1;
    if (k3>=k2)and(k3>=k1) then MaxColor:=3;
    if (k2>=k1)and(k2>=k3) then MaxColor:=2;
  end;
end;

function QColor(h,m,c:integer):integer;
var
  i,j:integer;
  k:integer;
begin
  k:=0;
  for i:=1 to 2 do
    for j:=h to m do
      if R[i,j]=c then inc(k);
  QColor:=k;
end;

procedure ReCol(i,c:integer;var R:Rect);
begin
  inc(nr);
  Res[nr]:=i;
  R[1,i]:=c;
  R[2,i]:=c;
  R[1,i+1]:=c;
  R[2,i+1]:=c;
end;

procedure Print(f:boolean);
var
  i:integer;
  j:integer;
begin
  assign(output,FName+'.out');
  rewrite(output);
  if f then
    for i:=1 to nr do writeln(Res[i])
  else
    writeln('IMPOSSIBLE');
  close(output);
end;

procedure Solve;
var
  i,j:integer;
  Mc,c : integer;
  p:integer;
  f:boolean;
begin
  Mc:=MaxColor(1,n);
  p:=2*n-QColor(1,n,Mc);
  nr:=0;
  while p<>0 do begin
    f:=false;
    for i:=1 to n-1 do begin
      if Rf[i] then begin
        c:=QColor(i,i+1,mc);
        if (c=2)and(maxColor(i,i+1)=mc) then begin
          ReCol(i,mc,R);
          p:=p-(2);
          f:=true;
          Rf[i]:=false;
          if p=0 then begin
            Print(true);
            exit;
          end;
        end else begin
          if (c=3)and(maxColor(i,i+1)=mc) then begin
            ReCol(i,mc,R);
            p:=p-(1);
            f:=true;
            Rf[i]:=false;
            if p=0 then begin
              Print(true);
              exit;
            end;
          end;
        end;
        if nr>1000*n then begin
          print(false);
          exit;
        end;
      end;
    end;
    if not f then begin
      Print(false);
      exit;
    end;
  end;
  Print(true);
end;

begin
  Init;
  Solve;
end.




