const
  eps=1e-5;
  r=0.3535533905932738;
  l=0.6123724356957945;
function isTria(a,b,c:extended):boolean;
begin
  isTria:=true;
  if a+b<=c then isTria:=false;
  if a+c<=b then isTria:=false;
  if b+c<=a then isTria:=false;
end;
var
  ab,ac,ad,bc,bd,cd:extended;

function isGood:boolean;
begin
  isGood:= isTria(ab,ac,bc) and isTria(ac,ad,cd) and isTria(ab,ad,bd) and isTria(bc,bd,cd);
end;

begin
  assign(input,'tetrahedron.in');
  reset(input);
  assign(output,'tetrahedron.out');
  rewrite(output);
  readln(ab,ac,ad,bc,bd,cd);
  if not isGood then begin
    writeln('IMPOSSIBLE');
  end
  else if (abs(ab-ac)<eps) and (abs(ac-ad)<eps) and (abs(ad-bc)<eps) and (abs(bc-bd)<eps) and (abs(bd-cd)<eps) then begin
    writeln('YES');
    writeln(r*ab);
    writeln(l*ab);
    writeln(l*ab);
    writeln(l*ab);
    writeln(l*ab);
  end
  else begin
    writeln('NO');
  end;

  close(input);
  close(output);
end.
