type integer = longint;
const eps = 1e-9;
	  td = 0.6123724356957945;
      tr = 0.3535533905932738;
var d : array[1..4, 1..4] of integer;

procedure Load;
var i, j : integer;
begin
	for i := 1 to 4 do begin
		for j := i + 1 to 4 do begin
			read(d[i, j]);
			d[j, i] := d[i, j];
		end;
	end;
end;

function RightT(a, b, c : integer) : boolean;
begin
	RightT := (a + b > c) and (b + c > a) and (a + c > b);
end;

function TriSqr(a, b, c : extended) : extended;
var p : extended;
begin
	p := (a + b + c) / 2;
	TriSqr := sqrt(p * (p - a) * (p - b) * (p - c));
end;

procedure Solve;
var i, j, tt, k : integer;
begin
	tt := 1;
	for i := 1 to 4 do begin
		for j := i + 1 to 4 do begin
			if d[i, j] <> d[1, 2] then tt := 0;
		end;
	end;
	if tt = 1 then begin
		writeln('YES');
		writeln(tr * d[1, 2] : 0 : 10);
		writeln(td * d[1, 2] : 0 : 10);
		writeln(td * d[1, 2] : 0 : 10);
		writeln(td * d[1, 2] : 0 : 10);
		write(td * d[1, 2] : 0 : 10);
		exit;
	end;
	for i := 1 to 4 do begin
		for j := i + 1 to 4 do begin
			for k := j + 1 to 4 do begin
				if not RightT(d[i, j], d[i, k], d[k, j]) then begin
					write('IMPOSSIBLE');
					exit;
				end;
				if abs(TriSqr(d[i, j], d[i, k], d[k, j])) < eps then begin
					write('IMPOSSIBLE');
					exit;
				end;
			end;
		end;
	end;
	write('NO');
end;

begin
	assign(input, 'tetrahedron.in');
	assign(output, 'tetrahedron.out');
	reset(input);
	rewrite(output);
	Load;
	Solve;
	close(input);
	close(output);
end.