#include <stdio.h>
#include <string.h>

#define MIN(A, B) (((A) <= (B)) ? (A) : (B))
#define MAX(A, B) (((A) >= (B)) ? (A) : (B))
#define SWAP(A, B, C) ((C) = (A), (A) = (B), (B) = (C))
#define ABS(X) (((X) >= 0) ? (X) : -(X))

#define eps 1e-9
#define inf (int)2e9

#define MAXN 1010

int N, TN, CN[264];
char A[2][MAXN], F[2][MAXN], TA[MAXN * 1000];
int GoTo( char C )
{
  int f, i;
  char G, B;
  if (C == 'R')
    G = 'G', B = 'B';
  else if (C == 'G')
    G = 'R', B = 'B';
  else
    G = 'R', B = 'G';
  TN = 0;
  for (i = 0; i < N; i++)
    A[0][i] = F[0][i], A[1][i] = F[1][i];
  while (1)
  {
    for (f = 1, i = 0; i < N && f; i++)
      if (A[0][i] != C || A[1][i] != C)
        f = 0;
    if (f)
    {
      for (i = 0; i < TN; i++)
        printf("%d\n", TA[i]);
      return 1;
    }
    for (f = i = 0; i < N - 1; i++)
    {
      CN[C] = CN[G] = CN[B] = 0;
      CN[A[0][i]]++, CN[A[0][i + 1]]++;
      CN[A[1][i]]++, CN[A[1][i + 1]]++;
      if (((CN[C] > CN[G] && CN[C] > CN[B]) || CN[G] == CN[B]) && (CN[C] != 4))
      {
        A[0][i] = A[0][i + 1] = C;
        A[1][i] = A[1][i + 1] = C;
        TA[TN++] = i + 1;
        f = 1;
      }
    }
    if (!f)
      break;
  }
  return 0;
}

int main( void )
{
  int i;

  freopen("threecolors2.in", "rt", stdin);
  freopen("threecolors2.out", "wt", stdout);

  scanf("%d", &N);
  scanf("%s", A[0]);
  scanf("%s", A[1]);
  for (i = 0; i < N; i++)
    F[0][i] = A[0][i], F[1][i] = A[1][i];

  if(!(GoTo('R') || GoTo('G') || GoTo('B')))
    printf("IMPOSSIBLE\n");

  return 0;
}
