const taskname='tetrahedron';c1=0.3535533905932738;c2=0.6123724356957945;
var
  t:text;
  i,j,i1,i2,i3:longint;
  a:array[1..6,1..6] of longint;
  op,opp:boolean;
begin
  assign(t,taskname+'.in');
  reset(t);
  for i:=1 to 6 do
  begin
    for j:=1 to 6 do
    begin
      a[i,j]:=-1;
    end;
  end;
  read(t,a[1,2],a[1,3],a[1,4],a[2,3],a[2,4],a[3,4]);
  close(t);
  op:=true;
  opp:=true;
  for i1:=1 to 6 do
  begin
    for i2:=1 to 6 do
    begin
      for i3:=1 to 6 do
      begin
        if (a[i1,i2]>-1)and(a[i2,i3]>-1)and(a[i1,i3]>-1) then
        begin
          if (a[i1,i2])<>a[i2,i3] then opp:=false;
          if ((a[i1,i2]+a[i2,i3])<=a[i1,i3])or((a[i1,i3]+a[i2,i3])<=a[i1,i2])or((a[i1,i2]+a[i1,i3])<=a[i2,i3]) then op:=false;
        end;
      end;
    end;
  end;
  assign(t,taskname+'.out');
  rewrite(t);
  if opp then
  begin
    writeln(t,'YES');
    writeln(t,c1*a[1,2]:16:16);
    for i:=1 to 4 do
    writeln(t,c2*a[1,2]:16:16);
  end else
  if op then writeln(t,'NO') else writeln(t,'IMPOSSIBLE');
  close(t);
end.
