{$Define NODEBUG}
const
        MaxN = 1000;

var
        n : LongInt;
        m, mas : Array[1 .. MaxN, 1 .. 2] of Char;

Procedure Init;
var
        i, j : LongInt;
begin
  ReadLn(n);
  for j := 1 to 2 do
  begin
    for i := 1 to n do
      Read(m[i][j]);
    ReadLn;
  end;
  mas := m;
end;

Function Get(const i : LongInt; const c : Char) : Char;
begin
  if (mas[i][1] = mas[i][2]) then
    Get := mas[i][1]
  else
    Get := c;
end;

Function Prim(const i : LongInt) : Char;
var
        r, g, b : LongInt;
begin
  r := 0;
  g := 0;
  b := 0;
  Case mas[i][1] of
    'R' : Inc(r);
    'G' : Inc(g);
    'B' : Inc(b);
  end;
  Case mas[i + 1][1] of
    'R' : Inc(r);
    'G' : Inc(g);
    'B' : Inc(b);
  end;
  Case mas[i + 1][2] of
    'R' : Inc(r);
    'G' : Inc(g);
    'B' : Inc(b);
  end;
  Case mas[i][2] of
    'R' : Inc(r);
    'G' : Inc(g);
    'B' : Inc(b);
  end;
  if (r > 2) or (g = b) then
    Prim := 'R';
  if (g > 2) or (r = b) then
    Prim := 'G';
  if (b > 2) or (r = g) then
    Prim := 'B';
end;

Function Can(const c : Char) : Boolean;
var
        i : LongInt;
begin
  Rewrite(output);
  for i := 1 to n - 1 do
    if Get(i, c) <> c then
    begin
      if Prim(i) = c then
      begin
        mas[i][1] := c;
        mas[i][2] := c;
        mas[i + 1][1] := c;
        mas[i + 1][2] := c;
        WriteLn(i);
      end
      else
      begin
        Can := False;
        Exit;
      end;
    end;
  if Get(n, c) <> c then
  begin
    Can := False;
    Exit;
  end;
  for i := 1 to n - 1 do
    if Prim(i) = c then
    begin
      Can := True;
      Exit;
    end;
  Can := False;
end;

Procedure Color(const c : Char);
var
        i : LongInt;
begin
  for i := 1 to n - 1 do
    if Prim(i) = c then
    begin
      WriteLn(i);
      mas[i][1] := c;
      mas[i][2] := c;
      mas[i + 1][1] := c;
      mas[i + 1][2] := c;
    end;
  for i := n - 1 downto 1 do
    if Prim(i) = c then
    begin
      WriteLn(i);
      mas[i][1] := c;
      mas[i][2] := c;
      mas[i + 1][1] := c;
      mas[i + 1][2] := c;
    end;
end;

Procedure Solve;
begin
  if Can('R') then
    Color('R')
  else
  begin
    mas := m;
    if Can('G') then
      Color('G')
    else
    begin
      mas := m;
      if Can('B') then
        Color('B')
      else
      begin
        Rewrite(output);
        Write('IMPOSSIBLE');
      end;
    end;
  end;
end;

Procedure Print;
var
        i : LongInt;
begin
  for i := 1 to n do
    if (mas[i][1] <> mas[1][1]) or (mas[i][2] <> mas[1][1]) then
    begin
      Rewrite(output);
      Write('IMPOSSIBLE');
    end;
end;

begin
  Assign(input, 'threecolors2.in');
  Reset(input);
  Assign(output, 'threecolors2.out');
  Rewrite(output);
  {$IfDef DEBUG}
  WriteLn('DEBUG: ');
  {$EndIf}
  Init;
  Solve;
  Print;
  Close(input);
  Close(output);
end.
