{$apptype console}
uses Math;
const
 eps=1e-9;

var
 tb:array[0..3,0..3]of extended;
 cosin:array[0..3,0..3,0..3]of extended;
 sin:array[0..3,0..3,0..3]of extended;
 i,j,k:longint;
 Rad:extended;
procedure Impossible;
 begin
  writeln('IMPOSSIBLE');
  close(input);
  close(output);
  Halt(0);
 end;
procedure NO;
 begin
  writeln('NO');
  close(input);
  close(output);
  Halt(0);
 end;

procedure CheckImpossible;
 var
  i,j,k,l:longint;
  l1,l2:extended;
 begin
  for i:=0 to 2 do
   for j:=i+1 to 3 do begin
    k:=0;
    while (k=i)or(k=j) do inc(k);
    l:=k+1;
    while (l=i)or(l=j) do inc(l);
    l1:=tb[k,l]*tb[k,l];
    l2:=(tb[i,k]*sin[k,i,j]+tb[i,l]*sin[j,i,l])*(tb[i,k]*sin[k,i,j]+tb[i,l]*sin[j,i,l])
       +(tb[i,k]*cosin[k,i,j]-tb[i,l]*cosin[j,i,l])*(tb[i,k]*cosin[k,i,j]-tb[i,l]*cosin[j,i,l]);
    if (l1-l2)>eps then Impossible;
   end;
 end;
procedure CheckNo;
 var
  r,p,a,r2,p2,a2:extended;
 begin
  p:=(tb[0,1]+tb[1,2]+tb[2,0])/2;
  r:=sqrt(((p-tb[0,1]) * (p-tb[1,2]) * (p-tb[2,0]))/p);
  a:=r*cotan(0.5*arccos(cosin[1,0,2]));

  p2:=(tb[0,1]+tb[1,3]+tb[3,0])/2;
  r2:=sqrt(((p2-tb[0,1]) * (p2-tb[1,3]) * (p2-tb[3,0]))/p2);
  a2:=r2*cotan(0.5*arccos(cosin[1,0,3]));
  if abs(a2-a)>eps then NO;

  p2:=(tb[0,2]+tb[2,3]+tb[3,0])/2;
  r2:=sqrt(((p2-tb[0,2]) * (p2-tb[2,3]) * (p2-tb[3,0]))/p2);
  a2:=r2*cotan(0.5*arccos(cosin[2,0,3]));
  if abs(a2-a)>eps then NO;

  p:=(tb[0,1]+tb[1,2]+tb[2,0])/2;
  r:=sqrt(((p-tb[0,1]) * (p-tb[1,2]) * (p-tb[2,0]))/p);
  a:=r*cotan(0.5*arccos(cosin[0,1,2]));

  p2:=(tb[1,2]+tb[2,3]+tb[3,1])/2;
  r2:=sqrt(((p2-tb[1,2]) * (p2-tb[2,3]) * (p2-tb[3,1]))/p2);
  a2:=r2*cotan(0.5*arccos(cosin[3,1,2]));
  if abs(a2-a)>eps then NO;

  p:=(tb[0,1]+tb[1,2]+tb[2,0])/2;
  r:=sqrt(((p-tb[0,1]) * (p-tb[1,2]) * (p-tb[2,0]))/p);
  a:=r*cOTAN(0.5*arccos(cosin[0,2,1]));

  p2:=(tb[1,2]+tb[2,3]+tb[3,1])/2;
  r2:=sqrt(((p2-tb[1,2]) * (p2-tb[2,3]) * (p2-tb[3,1]))/p2);
  a2:=r2*cotan(0.5*arccos(cosin[3,2,1]));
  if abs(a2-a)>eps then NO;

 end;
procedure Solve;
 var
  p,r1,r2,cosga,singa:extended;
 begin
  p:=(tb[0,1]+tb[1,2]+tb[2,0])/2;
  r1:=sqrt(((p-tb[0,1]) * (p-tb[1,2]) * (p-tb[2,0]))/p);
  p:=(tb[0,1]+tb[1,3]+tb[3,0])/2;
  r2:=sqrt(((p-tb[0,1]) * (p-tb[1,3]) * (p-tb[3,0]))/p);
  cosga:=-(cosin[3,0,1]*cosin[2,0,1]-cosin[3,0,2])/(sin[3,0,1]*sin[2,0,1]);
  if cosga>1 then cosga:=1;
  if cosga<-1 then cosga:=-1;
  singa:=sqrt(1-cosga*cosga);
  Rad:=(sqrt(r1*r1+r2*r2-2*r1*r2*cosga))/singa;
 end;
 
procedure PutOut;
 var
  p,r,a:extended;
 begin
  p:=(tb[0,1]+tb[1,2]+tb[2,0])/2;
  r:=sqrt(((p-tb[0,1]) * (p-tb[1,2]) * (p-tb[2,0]))/p);
  a:=r*cotan(0.5*arccos(cosin[1,0,2]));
  writeln(sqrt(a*a+rad*rad):0:18);

  p:=(tb[0,1]+tb[1,2]+tb[2,0])/2;
  r:=sqrt(((p-tb[0,1]) * (p-tb[1,2]) * (p-tb[2,0]))/p);
  a:=r*cotan(0.5*arccos(cosin[2,1,0]));
  writeln(sqrt(a*a+rad*rad):0:18);

  p:=(tb[0,1]+tb[1,2]+tb[2,0])/2;
  r:=sqrt(((p-tb[0,1]) * (p-tb[1,2]) * (p-tb[2,0]))/p);
  a:=r*cotan(0.5*arccos(cosin[1,2,0]));
  writeln(sqrt(a*a+rad*rad):0:18);

  p:=(tb[0,1]+tb[1,3]+tb[3,0])/2;
  r:=sqrt(((p-tb[0,1]) * (p-tb[1,3]) * (p-tb[3,0]))/p);
  a:=r*cotan(0.5*arccos(cosin[1,3,0]));
  writeln(sqrt(a*a+rad*rad):0:18);
 end;
begin
 assign(input,'tetrahedron.in');
 reset(input);
 assign(output,'tetrahedron.out');
 rewrite(output);
 for i:=0 to 2 do begin
  for j:=i+1 to 3 do begin
   read(tb[i,j]);
   tb[j,i]:=tb[i,j];
   if tb[i,j]<(1e-10) then Impossible;
  end;
 end;
 for i:=0 to 3 do begin
  for j:=0 to 3 do begin
   if (j=i) then continue;
   for k:=0 to 3 do begin
    if (k=i)or(k=j) then continue;
    if (tb[i,j]+tb[j,k]<=tb[i,k])or(tb[k,i]+tb[i,j]<=tb[j,k])or(tb[j,k]+tb[k,i]<=tb[i,j]) then impossible;
   end;
  end;
 end;
 for i:=0 to 3 do begin
  for j:=0 to 3 do begin
   if (j=i) then continue;
   for k:=0 to 3 do begin
    if (k=i)or(k=j) then continue;
    cosin[i,j,k]:=(tb[i,j]*tb[i,j]+tb[j,k]*tb[j,k]-tb[i,k]*tb[i,k])/(2*tb[i,j]*tb[j,k]);
    if abs(cosin[i,j,k])>1 then
     sin[i,j,k]:=0
    else
     sin[i,j,k]:=sqrt(1-cosin[i,j,k]*cosin[i,j,k]);
   end;
  end;
 end;
 CheckImpossible;
 CheckNO;
 Solve;
 writeln('YES');
 writeln(Rad:0:17);
 PutOut;
 close(input);
 close(output);
end.