{$UNDEF DEBUG}
{$H+}
type integer = longint;
const MNOGO = $7F7F7F7F;
var s : string;
	n : integer;

procedure Load;
begin
	readln(s);
	n := length(s);
end;

var res : array[1..300, 1..300] of integer;
	rs : array[1..300, 1..300] of string;
	ts : string;
	mx : array[1..300, 1..300] of char;
	mn : array[1..300, 1..300] of char;

procedure CountMax;
var i, j : integer;
	cm : char;
begin
	for i := 1 to length(s) do begin
		cm := #0;
		for j := i to length(s) do begin
			if s[j] > cm then cm := s[j];
			mx[i, j] := cm;
			mx[j, i] := cm;
		end;
	end;
end;

procedure CountMin;
var i, j : integer;
	cm : char;
begin
	for i := 1 to length(s) do begin
		cm := #255;
		for j := i to length(s) do begin
			if s[j] < cm then cm := s[j];
			mn[i, j] := cm;
			mn[j, i] := cm;
		end;
	end;
end;

function Count(be, en : integer) : integer;
var i, cres : integer;
begin
	if res[be, en] <> -1 then begin
		Count := res[be, en];
		exit;
	end;
	if be = en then begin
		res[be, en] := 1;
		rs[be, en] := s[be];
		Count := 1;
		exit;
	end;
	{}
	res[be, en] := MNOGO;
	rs[be, en] := '';
	if be <= en then begin
		if s[be] = mn[be, en] then begin
			 cres := Count(be + 1, en) + 1;
			 if (res[be, en] > cres) or ((res[be, en] = cres) and (rs[be, en] > s[be] + rs[be + 1, en])) then begin
			 	res[be, en] := cres;
			 	rs[be, en] := s[be] + rs[be + 1, en];
			 end;
		end;
		cres := Count(en, be) + 2;
		ts := '[' + rs[en, be] + ']';
		if (res[be, en] > cres) or ((res[be, en] = cres) and (rs[be, en] > ts)) then begin
			res[be, en] := cres;
			rs[be, en] := ts;
		end;
		for i := en - 1 downto be do begin
			if mx[i, be] <= mn[i + 1, en] then begin
            	Count(i, be);
                Count(i + 1, en);
                if (res[i, be] = MNOGO) or (res[i + 1, en] = MNOGO) then continue;
				cres := res[i, be] + res[i + 1, en] + 2;
				ts := '[' + rs[i, be] + ']' + rs[i + 1, en];
				if (res[be, en] > cres) or ((res[be, en] = cres) and (rs[be, en] > ts)) then begin
					res[be, en] := cres;
					rs[be, en] := ts;
				end;
			end;
		end;
   	end
   	else begin
   		{reverse}
   		if s[be] = mn[be, en] then begin
   			cres := Count(be - 1, en) + 1;
   			if (res[be, en] > cres) or ((res[be, en] = cres) and (rs[be, en] > s[be] + rs[be - 1, en])) then begin
   				res[be, en] := cres;
   				rs[be, en] := s[be] + rs[be - 1, en];
   			end;
   		end;
   		cres := Count(en, be) + 2;
   		ts := '[' + rs[en, be] + ']';
		if (res[be, en] > cres) or ((res[be, en] = cres) and (rs[be, en] > ts)) then begin
			res[be, en] := cres;
			rs[be, en] := ts;
		end;
		for i := en + 1 to be do begin
			if mx[i, be] <= mn[i - 1, en] then begin
            	Count(i, be);
                Count(i - 1, en);
                if (res[i, be] = MNOGO) or (res[i - 1, en] = MNOGO) then continue;
				cres := res[i, be] + res[i - 1, en] + 2;
				ts := '[' + rs[i, be] + ']' + rs[i - 1, en];
				if (res[be, en] > cres) or ((res[be, en] = cres) and (rs[be, en] > ts)) then begin
					res[be, en] := cres;
					rs[be, en] := ts;
				end;
			end;
		end;
   	end;
   	Count := res[be, en];
end;

procedure Solve;
begin
	fillchar(res, sizeof(res), $FF);
	CountMax;
	CountMin;
	if Count(1, n) = MNOGO then begin
		write('NO SOLUTION');
	end
	else begin
		write(rs[1, n]);
	end;
end;

begin
	assign(input, 'cipher.in');
	assign(output, 'cipher.out');
	reset(input);
	rewrite(output);
	Load;
	Solve;
	close(input);
	close(output);
end.
