{$apptype console}

const
 MAXL = 310;

var
 Impossible: boolean;
 S: array[0..MAXL] of char;
 A: array[-1..MAXL] of longint;
 c: char;
 N, i, j: longint;

procedure GetAns(L, R: integer);
 var
  max, min, t: char;
  i: longint;
 begin
{
   write('GetAns( S = "');
   for i := 0 to L - 1 do
     write('>');
   for i := L to R do
     write(S[i]);
   for i := R + 1 to N - 1  do
     write('<');
   writeln('", L = ', L, ', R = ', R, ');');
}
   max := #0;
   min := #255;
   if L >= R then
     exit;
   for i := L to R do begin
     if max < S[i] then
       max := S[i];
     if min > S[i] then
       min := S[i];
   end;
   if S[L] = min then
     GetAns(L + 1, R)
   else if S[R] = max then
     GetAns(L, R - 1)
   else if (S[L] = min) or (S[R] = min) or (S[L] = max) or (S[R] = max) then begin
     for i := L to R do
       inc(A[i]);
     for i := L to (R + L) div 2 do begin
       t := S[i];
       S[i] := S[R + L - i];
       S[R + L - i] := t;
     end;
     GetAns(L, R);
   end else
     Impossible := true;
 end;

begin
  assign(input, 'cipher.in');
  assign(output, 'cipher.out');
  reset(input);
  rewrite(output);

  N := 0;
  read(c);
  while c <= ' ' do
    read(c);
  while not(c <= ' ') do begin
    S[N] := c;
    inc(N);
    read(c);
  end;
  Impossible := false;
  fillchar(A, sizeof(A), 0);
  GetAns(0, N - 1);
  if Impossible then
    writeln('NO SOLUTION')
  else begin
    for i := 0 to N - 1 do begin
      for j := 0 to A[i] - A[i - 1] - 1 do
        write('[');
      write(S[i]);
      for j := 0 to A[i] - A[i + 1] - 1 do
        write(']');
    end;
    writeln;
  end;

  close(input);
  close(output);
end.
