#include <stdio.h>
#include <string.h>

#define MINI(A, B) ((A) < (B) ? (A) : (B))
#define MAXI(A, B) ((A) > (B) ? (A) : (B))

#define INF (int)1e9
#define MAX 303
#define MAXA 20100100

char S[MAX];
int L, Min[MAX][MAX], Max[MAX][MAX], MinT[MAX][MAX], MaxT[MAX][MAX];
int F[MAX][MAX][2], FT[MAX][MAX][2], St[MAX][MAX][2], StT[MAX][MAX][2];
int Pos = 0;
char Ans[MAXA], Tmp[MAX * 5];

void Out( int i, int j, int k )
{
  while (F[i][j][k]--)
    putc(Ans[St[i][j][k]++], stdout);
  puts("");
}

int StrCmp( char *S1, char *S2, int l )
{
  while (l-- && *S1 == *S2)
    S1++, S2++;
  return *S1 - *S2;
}

int count = 0;

void CalcS( int i, int j, int k )
{
  int st, l, f;

  count++;
  f = F[i][j][k];
  st = St[i][j][k] = Pos, Pos += f;
  StT[j][i][k] = St[i][j][k];
  if (j - i <= 1)
  {
    while (i < j)
      Ans[st++] = S[i++];
    return;
  }
  memset(Ans + st, 'z', f);
  if (F[i][j][1 - k] == f - 2)
  {
    if (St[i][j][1 - k] == -1) CalcS(i, j, 1 - k);
    memcpy(Ans + st + 1, Ans + St[i][j][1 - k], f - 2);
    Ans[st] = '[', Ans[st + f - 1] = ']';
  }
  if (!k)
  {
    for (l = i + 1; l < j; l++)
      if (Max[i][l] <= MinT[j][l] && F[i][l][0] + FT[j][l][0] == f)
      {
        if (St[i][l][0] == -1) CalcS(i, l, 0);
        if (StT[j][l][0] == -1) CalcS(l, j, 0);
        memcpy(Tmp, Ans + St[i][l][0], F[i][l][0]);
        memcpy(Tmp + F[i][l][0], Ans + StT[j][l][0], FT[j][l][0]);
        if (StrCmp(Tmp, Ans + st, f) < 0)
          memcpy(Ans + st, Tmp, f);
      }
  }
  else
  {
    for (l = i + 1; l < j; l++)
      if (Min[i][l] >= MaxT[j][l] && F[i][l][1] + FT[j][l][1] == f)
      {
        if (St[i][l][1] == -1) CalcS(i, l, 1);
        if (StT[j][l][1] == -1) CalcS(l, j, 1);
        memcpy(Tmp, Ans + StT[j][l][1], FT[j][l][1]);
        memcpy(Tmp + F[l][j][1], Ans + St[i][l][1], F[i][l][1]);
        if (StrCmp(Tmp, Ans + st, f) < 0)
          memcpy(Ans + st, Tmp, f);
      }
  }
}

int main( void )
{
  int ij, i, j, k, l, mf, f;

  freopen("cipher.in", "rt", stdin);
  freopen("cipher.out", "wt", stdout);
  gets(S), L = strlen(S);
  for (i = 0; i <= L; i++)
    Min[i][i] = INF, Max[i][i] = -1;
  for (i = 0; i <= L; i++)
    for (j = i + 1; j <= L; j++)
    {
      Min[i][j] = MINI(Min[i][j - 1], S[j - 1]);
      Max[i][j] = MAXI(Max[i][j - 1], S[j - 1]);
    }
  for (i = 0; i <= L; i++)
    for (j = 0; j <= L; j++)
      MinT[i][j] = Min[j][i], MaxT[i][j] = Max[j][i];
  memset(F, -1, sizeof(F));
  for (ij = 0; ij <= L; ij++)
    for (i = 0; i + ij <= L; i++)
    {
      j = i + ij;
      if (ij <= 1)
      {
        F[i][j][0] = F[i][j][1] = ij;
        continue;
      }
      mf = INF;
      for (l = i + 1; l < j; l++)
        if (Max[i][l] <= MinT[j][l])
          if ((f = F[i][l][0] + F[l][j][0]) < mf)
            mf = f;
      F[i][j][0] = mf;
      mf = INF;
      for (l = i + 1; l < j; l++)
        if (Min[i][l] >= MaxT[j][l])
          if ((f = F[i][l][1] + F[l][j][1]) < mf)
            mf = f;
      F[i][j][1] = mf;
      for (k = 0; k < 2; k++)
        if (F[i][j][1 - k] + 2 < F[i][j][k])
          F[i][j][k] = F[i][j][1 - k] + 2;
    }
  for (i = 0; i <= L; i++)
    for (j = 0; j <= L; j++)
      for (k = 0; k <= 2; k++)
        FT[i][j][k] = F[j][i][k];
  fprintf(stderr, "F is calculated\n");
  if (F[0][L][0] == INF)
  {
    puts("NO SOLUTION");
    return 0;
  }
  memset(St, -1, sizeof(St));
  memset(StT, -1, sizeof(StT));
  CalcS(0, L, 0);
  fprintf(stderr, "Ans is calculated (Pos=%d count=%d)\n", Pos, count);
  Out(0, L, 0);
  return 0;
}
