  {$I-,Q-,R-,S-}
uses sysutils;
const taskname='substring';maxnum=1594323;inf=1e40;
type pqwe=^tqwe;tqwe=array[1..13] of longint;extended=double;
var
  t:text;
  tm:extended;
  cnt,x,j,m,n,i:longint;
  s,ps:string;
  a,b:tqwe;
  pow,q:array[0..13] of longint;
  d:array[0..maxnum]of extended;
function getnum(a:pqwe):longint;
var i:longint;ans:longint;
begin
  ans:=a^[1];
  for i:=2 to n do
  begin
    ans:=ans*3+a^[i];
  end;
  getnum:=ans;
end;
procedure getmas(num:longint;a:pqwe);
var numm:longint;
begin
  numm:=num;
  for i:=n downto 1 do
  begin
    a^[i]:=numm mod 3;
    numm:=numm div 3;
  end;
end;
function _kmp:boolean;
var i,j:longint;op:boolean;
begin
  _kmp:=false;
  for i:=1to n-m+1 do
  begin
    op:=true;
    for j:=1 to m do
    begin
      if a[i+j-1]<>b[j] then
      begin
        op:=false;
        break;
      end;
    end;
    if op then
    begin
      _kmp:=true;
      exit;
    end;
  end;
end;
function _kmp1:boolean;
var i,j:longint;op:boolean;
begin
  _kmp1:=false;
  for i:=1to n-m+1 do
  begin
    op:=true;
    for j:=1 to m do
    begin
      if (a[i+j-1]<>b[j])and(a[i+j-1]<>2) then
      begin
        op:=false;
        break;
      end;
    end;
    if op then
    begin
      _kmp1:=true;
      exit;
    end;
  end;
end;
function kmp:boolean;
begin
  kmp:=false;
  j:=0;
  for i:=1 to n do
  begin
    while (j>0)and(b[j+1]<>a[i]) do j:=q[j];
    if b[j+1]=a[i] then inc(j);
    if j=m then
    begin
{      if not _kmp then
        writeln('figna');}
      kmp:=true;
      exit;
    end;
  end;
//  if _kmp then writeln('figna');
end;
function kmp1:boolean;
begin
  kmp1:=false;
  j:=0;
  for i:=1 to n do
  begin
    while (j>0)and((b[j+1]<>a[i])and(a[i]<2)) do j:=q[j];
    if (b[j+1]=a[i])or(a[i]=2) then inc(j);
    if j=m then
    begin
      if not _kmp1 then
        writeln('figna');
      kmp1:=true;
      exit;
    end;
  end;
  if _kmp1 then
    writeln('figna');
end;
function solve(qwe:longint):extended;
var i:longint;min,r:extended;op:boolean;
begin
//  x:=getnum(@a);
  if d[x]=-1 then
  begin
    inc(cnt);
    if kmp or (not _kmp1) then
    begin
      d[x]:=0;
    end else
    begin
      min:=inf;
      op:=false;
      for i:=1 to n do
      begin
        if a[i]=2 then
        begin
          a[i]:=0;
          dec(x,pow[i]*2);
          r:=1+solve(1)/2;
          a[i]:=1;
          inc(x,pow[i]);
          r:=r+solve(1)/2;
          if r<min then min:=r;
          a[i]:=2;
          inc(x,pow[i]);
          op:=true;
        end;
      end;
      if not op then d[x]:=0 else d[x]:=min;
    end;
  end;
  solve:=d[x];
end;
begin
tm:=now;
cnt:=0;
  assign(t,taskname+'.in');
  reset(t);
  readln(t,s);
  readln(t,ps);
  n:=length(s);
  m:=length(ps);
  q[0]:=0;
  q[1]:=0;
  for i:=2 to m do
  begin
    while (j>0)and(ps[j+1]<>ps[i]) do j:=q[j];
    if ps[j+1]=ps[i] then inc(j);
    q[i]:=j;
  end;

  j:=1;
  for i:=n downto 1 do
  begin
    pow[i]:=j;
    j:=j*3;
  end;

  for i:=1 to length(s) do
  begin
    case s[i] of
    '0':a[i]:=0;
    '1':a[i]:=1;
    '?':a[i]:=2;
    end;
  end;
  for i:=1 to length(ps) do
  begin
    case ps[i] of
    '0':b[i]:=0;
    '1':b[i]:=1;
    '?':b[i]:=2;
    end;
  end;
  close(t);
  for i:=0 to maxnum do d[i]:=-1;
  x:=getnum(@a);
  assign(t,taskname+'.out');
  rewrite(t);
  writeln(t,solve(1));
  close(t);
writeln(cnt);
writeln((now-tm)*24*60*60:3:3);
end.