#include <cstdio>
#include <algorithm>

using namespace std;

#include "stack.h"

#define MAX 5000010

char S[MAX];

int main( void )
{
  int C1, C2, N;
  int nop, fc, sc, ave, n[2] = {0, 0};

  init(&C1, &C2, &N);
  nop = nextOp();
  while (1)
  {
    fc = fastCount(), sc = slowCount();
    if (C2 > C1)
      ave = 1;
    else
      ave = (N + 1) >> 1;
    if (n[nop] > N * 1.5)
      ave = N;
    if (!fc && nop == POP)
      load(min(ave, sc));
    if (fc == N && nop == PUSH)
      save(ave);
    n[nop]++, n[1 - nop] = 0;
    nop = nextOp();
  }
  return 0;
}
