type integer = longint;
const MNOGO = $7F7F7F7F;
const DEPTH = 5;
var ma : array[1..26, 1..26] of integer;
	bver : integer;

procedure Load;
var i, j : integer;
	c : char;
begin
	for i := 1 to 26 do begin
		for j := 1 to 26 do begin
			read(ma[i, j]);
		end;
		readln;
	end;
	read(c);
	bver := ord(c) - ord('a') + 1;
end;

function Value(ver : integer) : integer;
var i, cur, max, j : integer;
begin
	max := -MNOGO;
	for i := 1 to 26 do begin
		if ma[ver, i] = 0 then continue;
		cur := 0;
		for j := 1 to 26 do inc(cur, ma[j, i]);
		for j := 1 to 26 do dec(cur, ma[i, j]);
		if cur > max then max := cur;
	end;
	Value := max;
end;

function GetMax(ver : integer; var mv : integer; dpt : integer) : integer; forward;

function GetMin(ver : integer; var mv : integer; dpt : integer) : integer;
var min, i, mmv, t : integer;
begin
	if dpt >= DEPTH then begin
		GetMin := Value(ver);
		mv := 0;
		exit;
	end;
	min := MNOGO;
	for i := 1 to 26 do begin
		if ma[ver, i] = 0 then continue;
		dec(ma[ver, i]);
		t := GetMax(i, mmv, dpt + 1);
		if t <= min then begin
			min := t;
			mv := i;
		end;
		inc(ma[ver, i]);
	end;
	GetMin := min;
end;

function GetMax(ver : integer; var mv : integer; dpt : integer) : integer;
var max, i, mmv, t : integer;
begin
	if dpt >= DEPTH then begin
		GetMax := Value(ver);
		mv := 0;
		exit;
	end;
	max := -MNOGO;
	for i := 1 to 26 do begin
		if ma[ver, i] = 0 then continue;
		dec(ma[ver, i]);
		t := GetMin(i, mmv, dpt + 1);
		if t >= max then begin
			max := t;
			mv := i;
		end;
		inc(ma[ver, i]);
	end;
	GetMax := max;
end;

procedure Solve;
var mv : integer;
begin
	GetMax(bver, mv, 1);
	write(chr(mv + ord('a') - 1));
end;

begin
	assign(input, 'towns.in');
	assign(output, 'towns.out');
	reset(input);
	rewrite(output);
	Load;
	Solve;
	close(input);
	close(output);
end.
