#include <cstdio>
#include "stack.h"

#define min(x,y) (x)<(y) ? (x):(y)

using namespace std;

int c1,c2,t,s1=0,s0=0;
long m1=0,m0=0,d=1,now=0;
int op;

inline long abs(long x)
{
	return (x>0) ? x:(-x);
}

inline long work(long x)
{
	if((abs(s1-s0)*50)/(s1+s0)==0) return t/2;
	long y=x;
	x/=(m1+m0);
	if(y%(m1+m0)>=(m1+m0)/2) x++;
	x=min(x,t);
	return (x<1) ? 1:x;
}

int main()
{
	init(&c1,&c2,&t);
	while(1){
		now++;
		op=nextOp();
		if(op==PUSH){
			s1++,m1+=(now/d);
		} else{
			s0++,m0+=(now/d);
		}
		if((m1>1000000)||(m0>1000000)) m1/=2,m0/=2,d*=2;
		if(op==PUSH){
			if(fastCount()>=t){
/*				printf("m1=%d, m0=%d, saving %d\n",m1,m0,work(t*m1));*/
				save(work(t*m1));
			}
		} else{
			if(fastCount()<=0){
				load(min(slowCount(),work(t*m0)));
			}
		}
	}
	return 0;
}
