Program prg;

{$O-}

uses
  Stack, Math;

var
  c1, c2, t: longint;
  State: integer;
  FCount, SCount: longint;
  PrevState: integer;

  // Temps

  i, j, k: integer;

  // Calculating

  O: int64;
  Sumt: int64;
  t1, t2: integer;
  turn: integer;
  d2, nd2: int64;

  //-----------------------------------------

function CanPush: boolean;
  begin
    CanPush:=(FCount < t);
  end;

function CanPop: boolean;
  begin
    CanPop:=(FCount > 0);
  end;

procedure give(k: integer);
  begin
    save(min(k, FCount));
    inc(SCount, min(k, FCount));
    dec(FCount, min(k, FCount));
  end;

procedure get(k: integer);
  var
    a: integer;

  begin
    a:=min(min(k, SCount), t-FCount);
    load(a);
    inc(FCount, a);
    dec(SCount, a);
  end;

begin
  init(c1, c2, t);
  FCount:=0;
  SCount:=0;
  O:=0;
  Sumt:=0;

  State:=nextOp;
  inc(FCount);
  O:=1;
  turn:=0;  // 0 - Pushing, 1 - Popping


  while (true) do begin
    PrevState:=State;
    State:=nextOp;
    inc(O);
    if PrevState <> State then begin
      turn:=1-turn;
    end;

    if State=PUSH then begin  // PUSH : T = PQuantity + Starthighness - FinishHighness;

      if not CanPush then begin
        k:=trunc(-t2+t1+(O/2));
        t2:=t2+k;
        give(t - k);
      end;
      inc(FCount);

    end else begin      // POP : T = PQuantity - Starthighness + FinishHighness;

      if not CanPop then begin
        k:=trunc(t2-t1+(O/2));
        t1:=t1+k;
        get(k);
      end;
      dec(FCount);

    end;
  end;

end.
