#include <ctime>
#include <cstdio>
#include <cstdlib>

#define maxsize 1000000

int d[26][26];
char c[26], cur;
int i, j, vcount;
long long int count;
int ex[20], ey[20], ec[20], ecmax[20], e, curv;
int ind[26], din[26];
bool se[maxsize];
bool dp[maxsize];

bool dfs(int x){
  int y;
  c[x]=1;
  ind[x]=vcount++;
  for (y=0; y<26; y++){
    count*=(d[x][y]+1);
    if (count*vcount>=maxsize) return true;
    if (d[x][y]){
      ex[e]=x;
      ey[e]=y;
      ec[e]=ecmax[e]=d[x][y];
      e++;
    }
  }
  for (y=0; y<26; y++)
    if (d[x][y]&&c[y]==0&&dfs(y)) return true;
  return false;
}

int encrypt(){
  int ans=0, i;
  for (i=0; i<e; i++){
    ans*=ecmax[i]+1;
    ans+=ec[i];
  }
  ans*=vcount;
  ans+=ind[curv];
  return ans;
}

void calc(){
  int x=encrypt(), cur=curv, i;
  if (se[x]) return;
  se[x]=1;
  dp[x]=0;
  for (i=0; i<e; i++){
    if (ec[i]==0) continue;
    if (ex[i]==cur){
      curv=ey[i];
      ec[i]--;
      calc();
      if (dp[encrypt()]==0){
        dp[x]=1;
        ec[i]++;
        return;
      }
      ec[i]++;
    }
  }
  return;
}

void update(int x){
  int j, t=((din[x]>>1)&1)+((din[x]<<1)&2);
  for (j=0; j<26; j++)
    if (d[j][x]&&(din[j]|t)!=din[j]){
      din[j]|=t;
      update(j);
    }
}

bool findbest(int cur){
  if (count*vcount>=maxsize) return false;
  curv=cur;
  int x=encrypt(), i;
  calc();
  /*if (dp[x]){
    for (i=0; i<e; i++){
      if (ex[i]==cur){
        curv=ey[i];
        ec[i]--;
        if (dp[encrypt()]==0){
          printf("%c", ey[i]+'a');
          return true;
        }
        ec[i]++;
      }
    }
  }*/
  return dp[x];
}

int main(){
  srand(clock());
  freopen("towns.in", "rt", stdin);
  freopen("towns.out", "wt", stdout);
  for (i=0; i<26; i++)
    for (j=0; j<26; j++)
      scanf("%d", &d[i][j]);
  scanf(" %c", &cur);
  cur-='a';
  for (i=0; i<26; i++){
    if (i==cur||d[cur][i]==0) continue;
    d[cur][i]--;
    for (j=0; j<26; j++) c[j]=0;
    vcount=0;
    count=1;
    e=0;
    if (!dfs(i)&&!findbest(i)){
      printf("%c", i+'a');
      return 0;
    }
    d[cur][i]++;
  }
  bool good;
  dfs(cur);
  for (i=0; i<26; i++){
    good=c[i];
    for (j=0; j<26; j++) good=good&&(i==j||d[i][j]==0);
    if (good==false) continue;
    for (j=0; j<26; j++) din[j]=0;
    din[i]=1;
    update(i);
    for (j=0; j<26; j++){
      if (d[cur][j]&&din[j]==2&&(d[i][i]&1)){
        printf("%c", j+'a');
        return 0;
      }
      if (d[cur][j]&&din[j]==1&&(d[i][i]&1)==0){
        printf("%c", j+'a');
        return 0;
      }
    }
  }
  /*if (dfs(cur)||!findbest()){*/
    for (i=rand()%26; d[cur][i]==0; i=rand()%26);
    printf("%c", i+'a');
  /*}*/
  return 0;
}
