#include <cmath>
#include <cstdlib>
#include "stack.h"

#define Pi 3.1415926535897932384626433832795

#define MAX(a, b) ((a)>(b)?(a):(b))
#define MIN(a, b) ((a)<(b)?(a):(b))

int c1, c2, T, ver[101], i, j, x, sum, a, b;
char t;

int main(){
  srand(77);
  init(&c1, &c2, &T);
  for (i=0; i<T+1; i++)
    sum+=ver[i]=i*(T+1-i)*100;
  for (j=0; 1; j++){
    t=nextOp();
    if (j==19596){
      a=fastCount();
      b=slowCount();
    }
    if (t==PUSH&&fastCount()==T){
      x=rand()%sum;
      for (i=0; ver[i]<=x; i++) x-=ver[i];
      save(i);
    }
    if (t==POP&&fastCount()==0){
      x=rand()%sum;
      for (i=0; ver[i]<=x; i++) x-=ver[i];
      load(MIN(i, slowCount()));
    }
  }
  return 0;
}
