#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define INF (int)1e9

int Mov, a[26][26], sumc[26], sums[26];

int dfs1( int k, int dep, int pr );
int dfs2( int k, int dep, int pr );

#define MAX 3500000

int dfs1( int k, int dep, int pr )
{
  int pr1, i, movs[26], movn = 0, f = 0, df;

  if (sums[k] == 0)
    return 0;
  pr1 = pr * sums[k];
  if (pr1 >= MAX)
  {
    for (i = 0; i < 26; i++)
      if (a[k][i])
        if (sums[i] == 0)
          return INF;
        else if (27 - sums[i] > f)
          f = 27 - sums[i];
    return f;
  }
  sums[k]--;
  for (i = 0; i < 26; i++)
    if (a[k][i])
    {
      a[k][i]--, sumc[i]--;
      if ((df = dfs2(i, dep + 1, pr1)) > f)
        f = df, movn = 1, movs[0] = i;
      else if (df == f)
        movs[movn++] = i;
      a[k][i]++, sumc[i]++;
    }
  sums[k]++;
  if (movn)
    Mov = movs[rand() % movn];
  else
    Mov = 0;
  return f;
}

int dfs2( int k, int dep, int pr )
{
  int pr1, i, f = INF, df;

  if (sums[k] == 0)
    return INF;
  pr1 = pr * sums[k];
  if (pr1 >= MAX)
  {
    for (i = 0; i < 26; i++)
      if (a[k][i])
        if (sums[i] == 0)
          return 0;
        else
          f = 1;
    return f;
  }
  sums[k]--;
  for (i = 0; i < 26; i++)
    if (a[k][i])
    {
      a[k][i]--, sumc[i]--;
      if ((df = dfs1(i, dep + 1, pr1)) < f)
        f = df;
      a[k][i]++, sumc[i]++;
    }
  sums[k]++;
  return f;
}

int main( void )
{
  int i, j, who;
  char s[9];

  srand(301703);
  freopen("towns.in", "rt", stdin);
  freopen("towns.out", "wt", stdout);
  memset(sums, 0, sizeof(sums));
  memset(sumc, 0, sizeof(sumc));
  for (i = 0; i < 26; i++)
    for (j = 0; j < 26; j++)
      scanf("%d", &a[i][j]), sums[i] += a[i][j], sumc[j] += a[i][j];
  scanf("%s", s);
  who = s[0] - 'a';
  dfs1(who, 0, 1);
  while (!a[who][Mov])
    Mov++;
  putc(Mov + 'a', stdout);
  return 0;
}
