#include <cstdio>
#include <algorithm>

using namespace std;

#include "stack.h"

#define MAX 5000010

char S[MAX];

int main( void )
{
  int C1, C2, N, K = 0;
  int Sum[2] = {0, 0}, Num[2] = {0, 0}, Cur[2] = {0, 0};
  int nop, fc, sc, old, ave;

  init(&C1, &C2, &N);
  nop = nextOp();
  while (1)
  {
    fc = fastCount(), sc = slowCount();
    if (!fc && nop == POP)
    {
      if (Num[POP] == 0)
        ave = (N + 1) >> 1;
      else
        ave = Sum[POP] / Num[POP];
      if (!ave)
        ave++;
      if (ave > N)
        ave = N;
      load(min(ave, sc));
    }
    if (fc == N && nop == PUSH)
    {
      if (Num[PUSH] == 0)
        ave = (N + 1) >> 1;
      else
        ave = Sum[PUSH] / Num[PUSH];
      if (!ave)
        ave++;
      if (ave > N)
        ave = N;
      save(ave);
    }
    Cur[nop]++;
    if (K && S[K - 1] != nop)
    {
      Num[1 - nop]++;
      Sum[1 - nop] += Cur[1 - nop];
      Cur[1 - nop] = 0;
    }
    S[K++] = nop;
    nop = nextOp();
  }
  return 0;
}
