#pragma comment (linker, "/STACK:30000000")

#include <string>
#include <vector>
#include <algorithm>
#include <iostream>
#include <cstdio>
#include <cassert>

using namespace std;

#define IN_FILE "palin.in"
#define OUT_FILE "palin.out"

#define forn(i, n) for (int i = 0; i < (int)(n); ++i)
#define forv(i, v) for (int i = 0; i < (int)(v.size()); ++i)
#define fors(i, s) for (int i = 0; i < (int)(s.length()); ++i)
#define pb push_back
#define VI vector<int>
#define all(x) x.begin(), x.end()

#define NMAX 333333
#define LMAX 20

string gen, text, s;

VI p;

VI g[NMAX];

int t_in[NMAX], t_out[NMAX], h[NMAX];

int tme = 0;

long long ans = 0;

void outdata() 
{
	cout << ans << endl;
}

int lca(int a, int b)
{
	while (a != b)
		if (a > b) a = p[a]; else b = p[b];
	return a;
}

void makeTree()
{
	int n = (int)s.length();
	p = VI(n, 0);
	for (int i = 2; i < n; ++i)
	{
		int ptr = p[i - 1];
		while (ptr > 0 && s[ptr + 1] != s[i]) ptr = p[ptr];
		if (s[ptr + 1] == s[i]) p[i] = ptr + 1;
	}
	for (int i = 1; i < n; ++i) g[p[i]].pb(i);
	forn (i, NMAX) h[i] = 0;
	for (int i = 1; i < n; ++i) h[i] = h[p[i]] + 1;
}

void solve() 
{
	makeTree();
	for (int i = 1; i <= (int)text.length(); ++i)
	{
		int cur = lca((int)gen.length() + 1 + i, (int)s.length() - i - 1);
		ans += h[cur];
		cur = lca((int)gen.length() + 1 + i, (int)s.length() - i);
		ans += h[cur];
	}
}

string readString()
{
	int c = getchar();
	while (c <= ' ') c = getchar();
	string res = "";
	while (isalpha(c)) 
	{
		res += c;
		c = getchar();
	}
	return res;
}

void readdata() 
{
	gen = readString();
	text = readString();
	string t = text;
	reverse(all(t));
	s = '!' + gen + '$' + text + '@' + t;
}

int main() 
{
	freopen(IN_FILE, "rt", stdin);
	freopen(OUT_FILE, "wt", stdout);
	readdata();
	solve();
	outdata();
	return 0;
}

