#define _CRT_SECURE_NO_DEPRECATE
#pragma comment (linker, "/STACK:30000000")
#include <string>
#include <vector>
#include <cmath>
#include <queue>
#include <set>
#include <map>
#include <algorithm>
#include <iostream>
#include <cstdio>
#include <cassert>
#include <utility>

#define IN_FILE "cloakroom.in"
#define OUT_FILE "cloakroom.out"

using namespace std;

#define INF (int)1E+9
#define forn(i, n) for (int i = 0; i < (int)(n); ++i)
#define forv(i, v) for (int i = 0; i < (int)(v.size()); ++i)
#define fors(i, s) for (int i = 0; i < (int)(s.length()); ++i)
#define all(a) a.begin(), a.end()
#define pb push_back
#define PII pair<int, int>
#define mp make_pair
#define VI vector<int>
#define VS vector<string>

struct segm {
    int l, r, no;
    bool operator < (const segm & a) {
        return this->l < a.l;
    }
};

int n;
vector< segm > a;

VI res;

void outdata() {
	forv(i, res) printf("%d ", res[i]);
}

void solve() {
	int pos = 0;
	vector<bool> used(n, false);
	forn(i, n) {
		int mn = INF, num = -1;
		forn(j, n) {
			if (!used[j] && mn > abs(pos - a[j].l)) {
				mn = abs(pos - a[j].l);
				num = j;
			}
		}
		pos	= a[num].r;
		used[num] = true;
		res.pb(a[num].no);
	}
}

void readdata() {
    scanf("%d", &n);
    assert(1 <= n && n <= 200000);
    a.resize(n);
    forn(i, n) {
        scanf("%d%d", &a[i].l, &a[i].r);
        assert(1 <= a[i].l && a[i].l < a[i].r && a[i].r <= (int)1E+9);
    }
    forn(i, n) a[i].no = i + 1;
}

int main() {
        freopen(IN_FILE, "rt", stdin);
        freopen(OUT_FILE, "wt", stdout);
        readdata();
        solve();
        outdata();
        return 0;
}
