program vylet;
const MAXN=10000;
var l: array[1..MAXN] of word;  { vzdialenosti kempov }
    c: array[1..MAXN] of word;  { ceny za nocah }
    delka: word;                { celkov dka vletu }
    K: word;                    { maximlna vzdlenostos denne }
    N: word;                    { poet kempov }
    f: text;


function ma_reseni:boolean;
var i: word;
begin
  if (delka<=K) then
    ma_reseni:=true
  else
    begin
      ma_reseni:=false;
      if (l[1]>K) then exit;
      for i:=1 to N-1 do if (l[i+1]-l[i]>K) then exit;
      if (delka-l[N]>K) then exit;
      ma_reseni:=true;  
    end
end;

procedure vyres_a;
var opt: array[1..MAXN] of word;  { optimlne rieenie }
    optpocet: word;               { poet kempov v poli opt }
    optcena: word;                { cena za prespanie v kempoch poda poa opt }
    vzdalenost: word;             { vzdialenos poslednho kempu v poli opt }
    i: word;
begin
  vzdalenost:=0;
  optpocet:=0;
  optcena:=0;
  i:=1;
  while (i<N) do
    begin
      if (l[i+1]-vzdalenost>K) then
        begin
          inc(optpocet);
          opt[optpocet]:=i;
          inc(optcena,c[i]);
          vzdalenost:=l[i];
        end;
      inc(i)
    end;
  if (delka-vzdalenost>K) then
    begin
      inc(optpocet);
      opt[optpocet]:=i;
      inc(optcena,c[i]);
    end;
  assign(f,'VYLET-A.OUT');
  rewrite(f);
  writeln(f,optpocet,' ',optcena);
  for i:=1 to optpocet do writeln(f,opt[i]);
  close(f)  
end;

procedure vyres_b;
var halda: array[0..MAXN] of word;        { pomocn halda }
    vhalde: word;                         { vekos pomocnej haldy }
    optcena: array[0..MAXN] of word;      { minimlna cena cesty
                                            z danho kempu do konca trasy }
    nasledujici: array[0..MAXN] of word;  { nasledujc kemp na opt. trase }
 { Oznaenie: 1 a N - kempy, 0 - konec trasy }
 function cena(p:word):word; { vracia opt. cenu cesty z kempu p do konce trasy }
 begin
   if p=0 then
     cena:=0
   else
     cena:=optcena[p]
 end;
 function vzdalenost(p:word):word; { vracia vzdialenos kempu p }
 begin
   if p=0 then
     vzdalenost:=delka
   else
     vzdalenost:=l[p]
 end;
 procedure vyjmi; { vyberie najmen prvok z haldy }
 var i, j, k: word;
 begin
   dec(vhalde);
   halda[0]:=halda[vhalde];
   i:=0;
   while (((i shl 1)+1<vhalde) and (cena(halda[i])>cena(halda[(i shl 1)+1]))) or
         (((i shl 1)+2<vhalde) and (cena(halda[i])>cena(halda[(i shl 1)+2]))) do
    begin
      j:=i; { vybereme vtev, do kter pjdeme }
      if (((i shl 1)+1<vhalde) and (cena(halda[j])>cena(halda[(i shl 1)+1]))) then
        j:=(i shl 1)+1;
      if (((i shl 1)+2<vhalde) and (cena(halda[j])>cena(halda[(i shl 1)+2]))) then
        j:=(i shl 1)+2;
      { ... a vymenme prvky }
      k:=halda[i]; halda[i]:=halda[j]; halda[j]:=k
    end
 end;
 procedure pridej(p:word); { prid kemp p do haldy }
 var i, j, k: word;
 begin
   i:=vhalde; halda[i]:=p; inc(vhalde);
   while (i>0) and (cena(halda[i])<cena(halda[(i-1) shr 1])) do
     begin
       j:=(i-1) shr 1;
       k:=halda[j]; halda[j]:=halda[i]; halda[i]:=k;
       i:=j
     end
 end;
var i,j: word;
begin
  vhalde:=1;
  halda[0]:=0;
  for i:=n downto 1 do
    begin
      while (vzdalenost(halda[0])-l[i]>K) do vyjmi;
      optcena[i]:=c[i]+cena(halda[0]);
      nasledujici[i]:=halda[0];
      pridej(i);
    end;
  while (vzdalenost(halda[0])>K) do vyjmi;
  optcena[0]:=cena(halda[0]);
  nasledujici[0]:=halda[0];
  { spotame poet kempov na ceste }
  i:=0; j:=0;
  while (nasledujici[i]<>0) do
    begin
      inc(j);
      i:=nasledujici[i];
    end;  
  { vypeme rieenie }
  assign(f,'VYLET-B.OUT');
  rewrite(f);
  writeln(f,j,' ',optcena[0]);
  i:=0;
  while (nasledujici[i]<>0) do
    begin
      i:=nasledujici[i];
      writeln(f,i);
    end;
  close(f)
end;

var i: word;
begin
  assign(f,'VYLET.IN');
  reset(f);
  readln(f,delka,K,N);
  for i:=1 to N do readln(f,l[i],c[i]);
  close(f);
  if not ma_reseni then
     begin
      assign(f,'VYLET-A.OUT');
      rewrite(f);
      writeln(f,'Trasu nemozno prejst.');
      close(f);
      assign(f,'VYLET-B.OUT');
      rewrite(f);
      writeln(f,'Trasu nemozno prejst.');
      close(f);
    end
   else  
    begin
      vyres_a;
      vyres_b;
    end  
end.
