program Pepik;  { P-II-3 }
const
  MAXK = 100;
type
  Cut = record
          a, b : Integer;
        end;
  CutA = Array[1..MAXK] of cut;
var
  n, k : Integer;       {Poet vrchol; Poet stih}
  c : CutA;             {Popis jednotlivch stih}

{Nate vstup}
procedure ReadInp;
var
  i, tmp : Integer;
begin
  Write('Zadejte pocet vrcholu a pocet strihu: ');
  Read(n, k);
  Write('Zadejte jednotlive strihy: ');
  {Nate popis stihu}
  for i := 1 to k do begin
    Read(c[i].a, c[i].b);
    {Prvn slo bude men}
    if c[i].a > c[i].b then begin
      tmp := c[i].a;
      c[i].a := c[i].b;
      c[i].b := tmp;
    end;
  end;
  {Pidme pomocnou ttivu}
  Inc(k);
  c[k].a := 1;
  c[k].b := n;
end;

{Porovn dva stihy}
function CmpCut(a, b : cut) : ShortInt;
begin
  if (a.a < b.a) or ((a.a = b.a) and (a.b > b.b)) then
    CmpCut := -1
  else if (a.a = b.a) and (a.b = b.b) then
    CmpCut := 0
  else
    CmpCut := 1;
end;

{Setd pole se stihy QuickSortem}
procedure SortCut(d, u : Integer);
var
  m, tmp : cut;         {Pivot}
  i, j : Integer;
begin
  m := c[(d+u) div 2];  {Vybereme pivota}
  i := d; j := u;
  while i <= j do begin
    {Nalezneme prvky ve patnch stech}
    while CmpCut(c[i], m) = -1 do
      Inc(i);
    while CmpCut(c[j], m) = 1 do
      Dec(j);
    if i <= j then begin
      {Zamnme prvky ve patnch stech}
      tmp := c[i];
      c[i] := c[j];
      c[j] := tmp;
      Inc(i);
      Dec(j);
    end;
  end;
  if i < u then  {Je co tdit v prav sti?}
    SortCut(i, u);
  if d < j then  {Je co tdit v lev sti?}
    SortCut(d, j);
end;

{Nalezne nejvt mnohohelnk}
function FindMax(n, d, u : Integer) : Integer;
var
  StackC : Array[1..MAXK] of Integer;
  StackN : Array[1..MAXK] of Integer;
  AV, SP, AChord, Max : Integer;
begin
  SP := 0;
  AV := c[1].a;
  AChord := 1;
  Max := 0;
  while True do begin
    {Kon tu njak mnohohelnk?}
    while (SP > 0) and (c[StackC[SP]].b = AV) do begin
      if StackN[SP] > Max then {Je nejvt?}
        Max := StackN[SP];
      Dec(SP);
      if SP > 0 then
        Inc(StackN[SP]);  {Pidme vrchol za prv ukonenou ttivu}
    end;
    if AV = n then      {U jsme proli cel mnohohelnk?}
      break;
    {Zan zde njak mnohohelnk?}
    while (AChord <= k) and (AV = c[AChord].a) do begin
      Inc(SP);
      StackC[SP] := AChord;
      StackN[SP] := 1;
      Inc(AChord);
    end;
    {Zan dve njak ttiva, ne kon jin?}
    if (AChord <= k) and (c[AChord].a < c[StackC[SP]].b) then begin
      Inc(StackN[SP], c[AChord].a - AV);
      AV := c[AChord].a;
    end
    else begin  {Njak ttiva nejdve kon}
      Inc(StackN[SP], c[StackC[SP]].b - AV);
      AV := c[StackC[SP]].b;
    end;
  end;
  FindMax := Max;
end;

begin
  ReadInp;       {Nate vstup}
  SortCut(1, k); {Setdme pole se stihy}
  {Nalezne nejvt st a vype ji}
  WriteLn('Nejvetsi cast ma ', FindMax(n, 1, k), ' vrcholu.');
end.

