program P_III_2;
const MAX_N =  100;
var N : integer;  { poet bodov }
    x,y	: array[1..MAX_N] of real; { sradnice bodov }
    pocet : array[1..MAX_N,1..MAX_N] of integer;
           { poet iastonch trs s danou poslednou hranou }
    ind : array[1..MAX_N] of integer;
           { indexov pole na triedenie poda uhla }
    uhol_ind : array[1..MAX_N] of real;
           { uhol zodpovedajci bodu v ind[i] }

function uhol(x, y :  real) : real;
var vysl : real;
begin  { implementcia funkcie "uhol" definovanej v zadan }
   if x = 0 then begin          { pecilny prpad x=0 }
      if y > 0 then uhol := 90
      else uhol := 270;
   end
   else begin                   { x<>0, meme pouit arctan }
      vysl := arctan(y/x) / pi * 180;
      if x < 0 then vysl := vysl - 180;  { zme vsledok poda kvadrantu }
      if vysl < 0 then vysl := vysl + 360;
      uhol := vysl;
   end;
end; { uhol }

procedure tried(stred : integer);
var pom_r : real;
var i, j, min, pom_i : integer;
begin { utriedi body okolo bodu "stred", ich indexy ulo
        do pola "ind" a uhly do pola "uhol_ind". }
   { inicializuj ind a spotaj uhly }
   j := 1;  
   for i := 1 to N do begin  
      if i<>stred then begin { bod "stred" vynechaj }
	 ind[j] := i;
	 uhol_ind[j] := uhol(x[i] - x[stred], y[i] - y[stred]);
	 j := j+1;
      end;
   end;
   { tried ind podla uhol_ind }
   for i := 1 to N-1 do begin
      min := i;    { njdi minimum v neutriedenej asti pola }
      for j := i+1 to N-1 do begin
         if uhol_ind[j] < uhol_ind[min] then min := j;
      end;
      { ulo minimum do ind[i] }
      pom_i := ind[i]; ind[i] := ind[min]; ind[min] := pom_i;
      pom_r := uhol_ind[i]; uhol_ind[i] := uhol_ind[min];
      uhol_ind[min] := pom_r;
   end;
end; { tried }   

procedure spocitaj_z_bodu(stred : integer);
var zac, kon, sucet, i : integer;		
   uhol_zac, uhol_kon	   :  real;
begin  { spotaj pocet[stred,i] pre vetky i>stred }
   tried(stred);
   zac := 1;   { prv bod, ktor je aspo na zaiatku vseku }
   kon := 1;   { prv bod, ktor je za koncom vseku }
   sucet := 0; { set bodov vo vseku }
   for i := stred to N-1 do begin
      uhol_zac := uhol_ind[i] - 180 - 45;    { spotaj vsek } 
      uhol_kon := uhol_ind[i] - 180 + 45;
      if uhol_kon > 180 then uhol_kon := 180;

      { posu indexy "zac" a "kon", udruj "sucet" }
      while uhol_ind[zac] < uhol_zac do begin
	 sucet := sucet - pocet[ind[zac], stred];
	 zac := zac+1;
      end;
      while uhol_ind[kon] <= uhol_kon do begin
	 sucet := sucet + pocet[ind[kon], stred];
	 kon := kon+1;
      end;

      pocet[stred, ind[i]] := sucet;  {ulo vsledok}
   end;
end; { spocitaj_z_bodu }

procedure inicializuj;
var i, j  : integer;
   pom : real;
begin { nataj vstup a strie poda y zhora nadol }
   read(N);
   for i := 1 to N do begin
      read(x[i], y[i]);
      j := i;   { vlo nov bod na sprvne miesto }
      while (j > 1) and (y[j] >= y[j-1]) do begin
	 pom := x[j-1]; x[j-1] := x[j]; x[j]:=pom;
	 pom := y[j-1]; y[j-1] := y[j]; y[j]:=pom;
	 j := j-1;
      end;
   end;
end; { inicializuj }

var i, sucet : integer;
begin { hlavn program }
   inicializuj; { natanie a utriedenie poda y }
   for i := 2 to N do pocet[1, i] := 1;  

   for i := 2 to N-1 do spocitaj_z_bodu(i);

   sucet := 0;  { staj hodnoty pocet[i,N] }
   for i := 1 to N-1 do sucet := sucet + pocet[i, N];
   writeln(sucet);  { vyp vsledok }
end.