{ Mugurel Ionut Andreica - Bucuresti, ROMANIA }

{$S-,I-,R-,Q-,N+}
{$M 65000,0,655360}
Program CENTRU;

const filein='CENTRU.IN';
      fileout='CENTRU.OUT';
      MAXN=16000;

type intarray=array[1..MAXN] of integer;
     pintarray=^intarray;
     plist=^list;
     list=record
            v:integer;
            urm:plist;
          end;

var fin,fout:text;
    muc:array[1..MAXN] of plist;
    deg,dist:pintarray;
    i,j,k,m,n,max:integer;
    aux,cst,cfin:plist;

begin
assign(fin,filein);
reset(fin);
readln(fin,n);

fillchar(muc,sizeof(muc),0);
new(deg);
fillchar(deg^,sizeof(intarray),0);

for k:=1 to n-1 do
  begin
    readln(fin,i,j);

    new(aux);
    aux^.v:=j;
    aux^.urm:=muc[i];
    muc[i]:=aux;

    new(aux);
    aux^.v:=i;
    aux^.urm:=muc[j];
    muc[j]:=aux;

    inc(deg^[i]);
    inc(deg^[j]);
  end;
close(fin);

new(dist);
fillchar(dist^,sizeof(intarray),0);

cst:=nil;
for i:=1 to n do
  if (deg^[i]=1) then
    begin
      dist^[i]:=1;

      if (cst=nil) then
        begin
          new(cst);
          cst^.v:=i;
          cst^.urm:=nil;
          cfin:=cst;
        end
      else
        begin
          new(aux);
          aux^.v:=i;
          aux^.urm:=nil;
          cfin^.urm:=aux;
          cfin:=aux;
        end;
    end;

while (cst<>nil) do
  begin
    i:=cst^.v;

    aux:=muc[i];
    while (aux<>nil) do
      begin
        j:=aux^.v;
        dec(deg^[j]);
        dec(deg^[i]);

        if (deg^[j]=1) then
          begin
            dist^[j]:=dist^[i]+1;
            new(aux);
            aux^.v:=j;
            aux^.urm:=nil;
            cfin^.urm:=aux;
            cfin:=aux;
          end;

        aux:=aux^.urm;
      end;

    aux:=cst;
    cst:=cst^.urm;
    dispose(aux);
  end;

max:=0; m:=0;
for i:=1 to n do
  if (dist^[i]>max) then
    begin
      max:=dist^[i];
      m:=1;
    end
  else
  if (dist^[i]=max) then
    begin
      m:=m+1;
    end;

assign(fout,fileout);
rewrite(fout);
writeln(fout,m);
for i:=1 to n do
  if (dist^[i]=max) then
    write(fout,i,' ');
writeln(fout);
close(fout);
end.