#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#include <vector>
using namespace std;

#define BIGINT long long
#define fmt "%lld"
#define LSUP 10000000000000
#define INF 1111111111
#define NMAX 100100

int w[NMAX], dmax[NMAX], dsup[NMAX], dist[NMAX];
char viz[NMAX];
vector<pair<int, int> > v[NMAX];
int i, j, l, k, N, K, nviz, cnt, cntok;
BIGINT li, ls, mid, x, cok;

void df(int n, int t, int lt)
{
	int i, x;

	dsup[n] = dmax[n];
	dist[n] = INF;

	viz[n] = 1;
	nviz++;

	for (i = 0; i < v[n].size(); i++)
	{
		x = v[n][i].first;

		if (!viz[x])
		{
			df(x, n, v[n][i].second);

			if (dsup[x] - v[n][i].second < dsup[n])
				dsup[n] = dsup[x] - v[n][i].second;

			if (dist[x] + v[n][i].second < dist[n])
				dist[n] = dist[x] + v[n][i].second;
		}
	}

	if (dsup[n] >= dist[n])
		dsup[n] = INF;
	else
	if (t == 0)
	{
		cnt++;
		dsup[n] = INF;
		dist[n] = 0;
	}
	else
	if (dsup[n] < lt)
	{
		cnt++;
		dsup[n] = INF;
		dist[n] = 0;
	}
}

int main()
{
	int te, T;

	//freopen("b.in", "r", stdin);
	//freopen("b.ok", "w", stdout);

	scanf("%d", &T);
	//T = 15;

	for (te = 1; te <= T; te++)
	{
		scanf("%d %d", &N, &K);

		fprintf(stderr, "### N=%d, K=%d\n", N, K);

		// read the demands

		for (i = 1; i <= N; i++)
		{
			scanf("%d", &w[i]);
			v[i].clear();
		}

		// read the edges

		for (k = 1; k < N; k++)
		{
			scanf("%d %d %d", &i, &j, &l);
			v[i].push_back(make_pair(j, l));
			v[j].push_back(make_pair(i, l));
		}

		// binary search

		li = 0; ls = cok = LSUP;
		cntok = 0;

		while (li <= ls)
		{
			mid = (li + ls) / 2;

			for (i = 1; i <= N; i++)
			{
				x = mid / w[i];

				if (x > INF)
					dmax[i] = INF;
				else
					dmax[i] = (int) x;

				viz[i] = 0;
			}

			cnt = 0;
			df(1, 0, 0);

			if (cnt <= K)
				ls = mid - 1,
				cok = mid,
				cntok = cnt;
			else
				li = mid + 1;
		}

		printf(fmt, cok);
		printf("\n");

		//fprintf(stderr, fmt, cok);
		//fprintf(stderr, " [%d/%d]\n", cntok, K);
	}

	return 0;
}