#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#define LMAX 5001
#define NMAX 2001

char s[2][LMAX];
int up[2][NMAX], left[NMAX], board[2][NMAX];
int i, j, k, N, lmax, cnt, c, a;

int readint(void)
{
	int x;
	fgets(s[0], LMAX - 1, stdin);
	sscanf(s[0], "%d", &x);
	return x;
}

int main()
{
	int T;

	//freopen("c.in", "r", stdin);
	//freopen("c.ok", "w", stdout);

	T = readint();

	while (T--)
	{
		N = readint();

		fprintf(stderr, "N=%d\n", N);

		lmax = cnt = 0;

		for (i = 1; i <= N; i++)
			up[0][i] = up[1][i] = board[0][i] = board[1][i] = 0;

		c = a = 0;

		for (k = 1; k <= N; k++)
		{
			a = c;
			c = 1 - c;

			fgets(s[c] + 1, LMAX - 2, stdin);

			if (k == 1)
			{
				for (i = 1; i <= N; i++)
					s[a][i] = s[c][i];
			}

			left[0] = 0;
			s[c][0] = s[c][1];

			for (i = 1; i <= N; i++)
			{
				left[i] = 1;
			
				if (s[c][i - 1] != s[c][i])
					left[i] += left[i - 1];

				if (s[a][i] != s[c][i])
					up[c][i] = up[a][i] + 1;
				else
					up[c][i] = 1;

				if (s[c][i] == '1')
				{
					board[c][i] = 1;

					if (i > 1 && s[a][i - 1] == s[c][i])
					{
						board[c][i] = left[i];

						if (up[c][i] < board[c][i])
							board[c][i] = up[c][i];

						if (board[a][i - 1] + 1 < board[c][i])
							board[c][i] = board[a][i - 1] + 1;
					}

					if (board[c][i] > lmax)
						lmax = board[c][i],
						cnt = 1;
					else
					if (board[c][i] == lmax)
						cnt++;
				}
				else
					board[c][i] = 0;
			}
		}

		printf("%d %d\n", lmax, cnt);
		//fprintf(stderr, "%d %d\n", lmax, cnt);
	}

	return 0;
}