#include <stdio.h>
#include <math.h>

#define step 0.0001
#define eps 0.0001
#define INF 30000000
#define NMAX 50100

int i, N;
double u, v, vx, vy, ti, hi, vmin, d, g, pip2;
double x[NMAX], h[NMAX];

int main()
{
	int te, T;
	
	pip2 = acos(0);

	freopen("g.in", "r", stdin);

	scanf("%d", &T);

	for (te = 1; te <= T; te++)
	{
		scanf("%lf %lf %d", &d, &g, &N);

		for (i = 1; i <= N; i++)
			scanf("%lf %lf", &x[i], &h[i]);

		vmin = INF;

		for (u = pip2 - step; u > 0; u -= step)
		{
			v = sqrt(0.5 * g * d / (sin(u) * cos(u)));

			if (v > vmin || fabs(v - vmin) < eps)
				continue;

			vx = v * cos(u);
			vy = v * sin(u);

			for (i = 1; i <= N; i++)
			{
				ti = x[i] / vx;
				hi = vy * ti - 0.5 * g * ti * ti;
				
				if (hi < h[i])
					break;
			}

			if (i > N)
				vmin = v;
		}

		printf("%.3lf\n", vmin);
	}

	return 0;
}
